CREATE TABLE geometries(id serial, geom geometry);

--1 closed, simple => ring
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('POINT(10 20)'));
--2 simple
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('LINESTRING(10 20, 30 40, 50 60)'));
--3 closed, simple, ring
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('LINESTRING(10 20, 30 40, 50 60, 80 60, 60 40, 10 20)'));
--4
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('LINESTRING(10 10, 50 50, 30 80, 25 5)'));
--5 closed, simple
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('POLYGON((10 10, 10 20, 20 20, 20 10, 10 10))'));
--6 closed, simple
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('MULTIPOINT(10 20, 30 40)'));
--7 simple
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('MULTILINESTRING((30 40, 40 50), (50 60, 60 70))'));
--8
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('MULTILINESTRING((30 40, 40 50, 30 40), (50 60, 60 70))'));
--9 closed
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('MULTILINESTRING((30 40, 40 50, 30 40), (50 60, 40 50, 20 30, 50 60))'));
--10 simple
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('MULTIPOLYGON(((10 10, 10 20, 20 20, 20 10, 10 10),(30 30, 30 40, 40 40, 40 30, 30 30)))'));
--11 simple
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('MULTIPOLYGON EMPTY'));
--12
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('GEOMETRYCOLLECTION(POINT(10 20),LINESTRING(10 20, 30 40),POLYGON((10 10, 10 20, 20 20, 20 10, 10 10)))'));
--13 closed
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('GEOMETRYCOLLECTION(POINT(10 20),LINESTRING(10 20, 30 40, 10 20),POLYGON((10 10, 10 20, 20 20, 20 10, 10 10)))'));

--3D

--14 closed, simple => ring
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('POINT(10 20 30)'));
--15 simple
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('LINESTRING(10 20 10, 30 40 10, 50 60 10)'));
--16 closed, simple, ring
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('LINESTRING(10 20 10, 30 40 10, 50 60 10, 80 60 10, 60 40 10, 10 20 10)'));
--17
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('LINESTRING(10 10 20, 50 50 30, 30 80 40, 25 5 50)'));
--18 closed, simple
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('POLYGON((10 10 5, 10 20 10, 20 20 15, 20 10 20, 10 10 25))'));
--19 closed, simple
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('MULTIPOINT(10 20 10, 30 40 30)'));
--20 simple
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('MULTILINESTRING((30 40 10, 40 50 20), (50 60 30, 60 70 40))'));
--21
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('MULTILINESTRING((30 40 10, 40 50 20, 30 40 30), (50 60 40, 60 70 50))'));
--22 closed
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('MULTILINESTRING((30 40 100, 40 50 90, 30 40 80), (50 60 70, 40 50 60, 20 30 50, 50 60 40))'));
--23 simple
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('MULTIPOLYGON(((10 10 5, 10 20 5, 20 20 5, 20 10 5, 10 10 5),(30 30 10, 30 40 10, 40 40 10, 40 30 10, 30 30 10)))'));
--24
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('GEOMETRYCOLLECTION(POINT(10 20 30),LINESTRING(10 20 10, 30 40 20),POLYGON((10 10 30, 10 20 30, 20 20 30, 20 10 30, 10 10 30)))'));
--25 closed
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('GEOMETRYCOLLECTION(POINT(10 20 30),LINESTRING(10 20 10, 30 40 20, 10 20 10),POLYGON((10 10 30, 10 20 30, 20 20 30, 20 10 30, 10 10 30)))'));

--polygons with holes

--26
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('POLYGON((100 100, 100 200, 200 200, 200 100, 100 100),(10 10, 10 20, 20 20, 20 10, 10 10))'));
--27
INSERT INTO geometries(geom) VALUES(ST_WKTToSQL('MULTIPOLYGON(((100 100, 100 200, 200 200, 200 100, 100 100),(10 10, 10 20, 20 20, 20 10, 10 10),(1 1, 1 2, 2 2, 2 1, 1 1)), ((100 100, 100 200, 200 200, 200 100, 100 100),(10 10, 10 20, 20 20, 20 10, 10 10)))'));

