START TRANSACTION;

CREATE TABLE "voyages" (
	"number"            integer	NOT NULL,
	"number_sup"        char(1)	NOT NULL,
	"trip"              integer,
	"trip_sup"          char(1),
	"boatname"          varchar(50),
	"master"            varchar(50),
	"tonnage"           integer,
	"type_of_boat"      varchar(30),
	"built"             varchar(15),
	"bought"            varchar(15),
	"hired"             varchar(15),
	"yard"              char(1),
	"chamber"           char(1),
	"departure_date"    date,
	"departure_harbour" varchar(30),
	"cape_arrival"      date,
	"cape_departure"    date,
	"cape_call"         boolean,
	"arrival_date"      date,
	"arrival_harbour"   varchar(30),
	"next_voyage"       integer,
	"particulars"       varchar(530)
);

INSERT INTO "voyages" VALUES (1, '', 1, '', 'AMSTERDAM', 'Jan Jakobsz. Schellinger', 260, NULL, '1594', NULL, NULL, 'A', NULL, '1595-04-02', 'Texel', NULL, NULL, true, '1596-06-06', 'Engano', NULL, 'from 04-08 till 11-08 in the Mosselbaai; from 13-09 till 07-10 in the Ampalazabaai; from 09-10 till 13-12 in S. Augustins Bay, where before departure 127 of the 249 men were still alive; 11-01 till 21-01 at Ste. Marie I.; from 23-01 till 12-02 in the Bay of Antongil. The AMSTERDAM was set on fire near Bawean, 11-01-1597.');
INSERT INTO "voyages" VALUES (2, '', 1, '', 'DUIFJE', 'Simon Lambrechtsz. Mau', 50, 'pinas', '1594', NULL, NULL, 'A', NULL, '1595-04-02', 'Texel', NULL, NULL, true, '1596-06-06', 'Engano', 5001, 'HOLLANDIA on 26-10-1595; he was succeeded by Hendrik Jansz.');
INSERT INTO "voyages" VALUES (3, '', 1, '', 'HOLLANDIA', 'Jan Dignumsz. van Kwadijk+', 460, NULL, '1594', NULL, NULL, 'A', NULL, '1595-04-02', 'Texel', NULL, NULL, true, '1596-06-06', 'Engano', 5002, 'Jan Dignumsz. died on 29-05-1595 and Mau was his successor.');
INSERT INTO "voyages" VALUES (4, '', 1, '', 'MAURITIUS', 'Jan Jansz. Molenaar', 460, NULL, '1594', NULL, NULL, 'A', NULL, '1595-04-02', 'Texel', NULL, NULL, true, '1596-06-06', 'Engano', 5003, 'Jan Jansz. died on 25-12-1596 and Hendrik Jansz. was his successor.');
INSERT INTO "voyages" VALUES (5, '', 1, '', 'LANGEBARK', 'Hans Huibrechtsz. Tonneman', 300, NULL, NULL, NULL, NULL, NULL, NULL, '1598-03-25', 'Zeeland', NULL, NULL, true, '1599-03-01', 'Bantam', 5010, 'other.');
INSERT INTO "voyages" VALUES (6, '', 1, '', 'MAAN', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1598-03-25', 'Zeeland', NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (7, '', 1, '', 'ZON', NULL, 140, NULL, NULL, NULL, NULL, NULL, NULL, '1598-03-25', 'Zeeland', NULL, NULL, true, '1599-02-01', 'Bantam', 5011, NULL);
INSERT INTO "voyages" VALUES (8, '', 1, '', 'LEEUW', 'Stokmans', 400, NULL, NULL, NULL, NULL, NULL, NULL, '1598-03-28', 'Veere', NULL, NULL, true, '1599-06-30', 'Atjeh', 5012, '01-04 till 17-04 at Torbay; from 11-05 till 19-05 at S. Nicolas; from 21-06 till 05-09 before Fernando de Noronha; from 17-11 till 18-11 in St. Helena Bay; from 21-11 till 07-12 in the Saldanha Bay; from 13-02 till 24-03 in S. Augustins Bay; from 10-04 till 27-04 at Mayotte; from 29-04 till 08-05 at Anjouan.');
INSERT INTO "voyages" VALUES (9, '', 1, '', 'LEEUWIN', 'Frederik de Houtman', 250, NULL, NULL, NULL, NULL, NULL, NULL, '1598-03-28', 'Veere', NULL, NULL, true, '1599-06-30', 'Atjeh', 5013, NULL);
INSERT INTO "voyages" VALUES (26, '', 1, '', 'HOOP', 'Jakob Jansz. Huidekoper', 50, 'jacht', NULL, NULL, NULL, NULL, NULL, '1598-09-13', 'Zeeland', NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (27, '', 1, '', 'MAURITIUS', 'Huigen Jansz. van Troyen', 250, NULL, NULL, NULL, NULL, NULL, NULL, '1598-09-13', 'Zeeland', NULL, NULL, true, '1601-01-29', 'Djaratan', 5022, 'A');
INSERT INTO "voyages" VALUES (28, '', 1, '', 'WASSENDE MAAN', 'Kornelis Heinsz.', 500, NULL, NULL, NULL, NULL, NULL, NULL, '1599-04-06', 'Texel', NULL, NULL, true, '1600-03-13', 'Bantam', 5017, 'till 16-05 at Maio I.; from 02-07 till 17-07 before Corsico; from 27-10 till 10-11 Sonnebaai (Madagascar) and from 17-11 till 21-12 in the Bay of Antongil.');
INSERT INTO "voyages" VALUES (29, '', 1, '', 'MORGENSTER', 'Kornelis Jansz. Melknap', 400, NULL, NULL, NULL, NULL, NULL, NULL, '1599-04-06', 'Texel', NULL, NULL, true, '1600-03-13', 'Bantam', 5019, NULL);
INSERT INTO "voyages" VALUES (30, '', 1, '', 'ZON', 'Kornelis Jansz. Schouten', 580, NULL, NULL, NULL, NULL, NULL, NULL, '1599-04-06', 'Texel', NULL, NULL, true, '1600-03-13', 'Bantam', 5022, NULL);
INSERT INTO "voyages" VALUES (31, '', 2, '', 'FRIESLAND', 'Jakob Pietersz.', 180, 'jacht', NULL, NULL, NULL, NULL, NULL, '1599-12-21', 'Texel', NULL, NULL, true, '1600-09-01', 'Bantam', 5016, 'Squadron (0031-0034) of the fleet of Van Neck which sailed later under command of vice-admiraal Jakob Willekens aboard the MAURITIUS.');
INSERT INTO "voyages" VALUES (32, '', 3, '', 'HOLLANDIA', 'Pieter Klaasz. Nek', 460, NULL, '1594', NULL, NULL, 'A', NULL, '1599-12-21', 'Texel', NULL, NULL, true, '1600-09-01', 'Bantam', 5026, NULL);
INSERT INTO "voyages" VALUES (33, '', 3, '', 'OVERIJSSEL', 'Thijmen Michielsz.', 50, 'jacht', '1594', NULL, NULL, 'A', NULL, '1599-12-21', 'Texel', NULL, NULL, true, '1600-09-01', 'Bantam', 5028, NULL);
INSERT INTO "voyages" VALUES (34, '', 3, '', 'MAURITIUS', 'Govert Jansz.', 460, NULL, '1594', NULL, NULL, 'A', NULL, '1599-12-21', 'Texel', NULL, NULL, true, '1600-09-01', 'Bantam', 5018, NULL);
INSERT INTO "voyages" VALUES (35, '', 1, '', 'HOF VAN HOLLAND', 'Jakob Dirksz.', 360, NULL, NULL, NULL, NULL, NULL, NULL, '1599-12-21', 'Texel', NULL, NULL, true, '1600-08-06', 'Bantam', 5024, 'Fleet (0035-0038) under command of admiraal Pieter Both aboard the NEDERLAND and vice-admiraal Paulus van Caerden aboard the VERENIGDE LANDEN, equipped by the Nieuwe Brabantsche Compagnie.');
INSERT INTO "voyages" VALUES (36, '', 1, '', 'VERENIGDE LANDEN', 'Klaas Gerritsz.', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1599-12-21', 'Texel', NULL, NULL, true, '1600-08-06', 'Bantam', 5025, NULL);
INSERT INTO "voyages" VALUES (37, '', 1, '', 'NASSAU', 'Frederik Kornelisz.', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1599-12-21', 'Texel', NULL, NULL, true, '1600-08-06', 'Bantam', 5020, NULL);
INSERT INTO "voyages" VALUES (38, '', 1, '', 'NEDERLAND', 'Ernst van Ommeren', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1599-12-21', 'Texel', NULL, NULL, true, '1600-08-06', 'Bantam', 5021, NULL);
INSERT INTO "voyages" VALUES (39, '', 1, '', 'ZWARTE AREND', NULL, 600, NULL, NULL, NULL, NULL, NULL, NULL, '1600-06-28', 'Texel', NULL, NULL, true, '1601-10-01', 'Bantam', 5032, 'Fleet (0039-0040) under command of admiraal Guilleaume Seneschel aboard the ZWARTE AREND, equipped by the Nieuwe Brabantsche Compagnie. From 01-07 till 06-07 at the Downs; from 12-07 till 14-07 at Portland; from 29-09 till 31-09 at Annabon.');
INSERT INTO "voyages" VALUES (40, '', 1, '', 'WITTE AREND', NULL, 600, NULL, NULL, NULL, NULL, NULL, NULL, '1600-06-28', 'Texel', NULL, NULL, true, '1601-10-01', 'Bantam', 5031, NULL);
INSERT INTO "voyages" VALUES (41, '', 1, '', 'AMSTERDAM', 'Simon Lambrechtsz. Mau', 900, NULL, '1600', NULL, NULL, NULL, NULL, '1600-06-28', 'Texel', NULL, NULL, true, '1601-03-30', 'Bantam', 5042, 'Fleet (0041-0046) under command of Van Neck aboard the AM-STERDAM and Foreest aboard the DORDRECHT, equipped by the Oude Oostindische Compagnie. From 01-10 till 10-10 at Annabon whereafter the fleet was divided into 2 squadrons: 1 squadron under command of Van Neck, consisted of the AMSTERDAM, the GOUDA, the DELFT and the other under command of Foreest, consisted of the LEIDEN, the DOR-DRECHT and the HAARLEM.');
INSERT INTO "voyages" VALUES (42, '', 1, '', 'DELFT', 'Simon Jansz. Hoen', 300, 'jacht', NULL, NULL, NULL, NULL, NULL, '1600-06-28', 'Texel', NULL, NULL, true, '1601-03-30', 'Bantam', 5023, NULL);
INSERT INTO "voyages" VALUES (43, '', 1, '', 'DORDRECHT', 'Dirk Mol', 900, NULL, '1600', NULL, NULL, NULL, NULL, '1600-06-28', 'Texel', NULL, NULL, true, '1601-08-09', 'Bantam', 5033, NULL);
INSERT INTO "voyages" VALUES (44, '', 1, '', 'GOUDA', 'Klaas Kornelisz.', 280, 'jacht', '1600', NULL, NULL, NULL, NULL, '1600-06-28', 'Texel', NULL, NULL, true, '1601-03-30', 'Bantam', 5043, NULL);
INSERT INTO "voyages" VALUES (45, '', 1, '', 'HAARLEM', 'Kornelis Klaasz.', 350, NULL, '1600', NULL, NULL, NULL, NULL, '1600-06-28', 'Texel', NULL, NULL, true, '1601-08-09', 'Bantam', NULL, 'Left behind at Patani in September 1603 as unseaworthy.');
INSERT INTO "voyages" VALUES (46, '', 1, '', 'LEIDEN', 'Hendrik Jansz.', 280, NULL, NULL, NULL, NULL, NULL, NULL, '1600-06-28', 'Texel', NULL, NULL, true, '1601-08-09', 'Bantam', 5056, NULL);
INSERT INTO "voyages" VALUES (47, '', 2, '', 'LANGEBARK', 'Nikolaas Anthonisz.', 300, NULL, NULL, NULL, NULL, NULL, NULL, '1601-01-28', 'Zeeland', NULL, NULL, true, '1601-08-23', 'Atjeh', 5029, 'number of deaths 5.');
INSERT INTO "voyages" VALUES (48, '', 1, '', 'MIDDELBURG', 'Hans Huibrechtsz. Tonneman', 400, NULL, NULL, NULL, NULL, NULL, NULL, '1601-01-28', 'Zeeland', NULL, NULL, true, '1601-08-23', 'Atjeh', 5044, 'The master died at Patani in 1602.');
INSERT INTO "voyages" VALUES (49, '', 1, '', 'ZEELANDIA', 'Kornelis Bastiaansz.', 600, NULL, NULL, NULL, NULL, NULL, NULL, '1601-01-28', 'Zeeland', NULL, NULL, true, '1601-08-23', 'Atjeh', 5030, NULL);
INSERT INTO "voyages" VALUES (50, '', 2, '', 'ZON', 'Kornelis Adriaansz. Valk', 140, NULL, NULL, NULL, NULL, NULL, NULL, '1601-01-28', 'Zeeland', NULL, NULL, true, '1601-08-23', 'Atjeh', 5045, NULL);
INSERT INTO "voyages" VALUES (51, '', 2, '', 'GELDERLAND', 'Jan Bruin', 360, NULL, NULL, NULL, NULL, NULL, NULL, '1601-04-23', 'Texel', NULL, NULL, true, '1601-12-26', 'Bantam', 5040, 'Bouwer, equipped by the Oude Oostindische Compagnie. From 27-09 till 20-10 at Mauritius.');
INSERT INTO "voyages" VALUES (52, '', 1, '', 'DUIFJE', 'Willem Kornelisz. Schouten', 60, 'jacht', NULL, NULL, NULL, NULL, NULL, '1611-04-23', 'Texel', NULL, NULL, true, '1601-12-26', 'Bantam', 5039, NULL);
INSERT INTO "voyages" VALUES (53, '', 2, '', 'UTRECHT', 'Jan Martensz.', 240, NULL, NULL, NULL, NULL, NULL, NULL, '1601-04-23', 'Texel', NULL, NULL, true, '1601-12-26', 'Bantam', NULL, NULL);
INSERT INTO "voyages" VALUES (54, '', 1, '', 'WACHTER', 'Gerrit Hendriksz. Roobol', 130, 'jacht', NULL, NULL, NULL, NULL, NULL, '1601-04-23', 'Texel', NULL, NULL, true, '1601-12-26', 'Bantam', NULL, NULL);
INSERT INTO "voyages" VALUES (55, '', 2, '', 'ZEELANDIA', 'Jan Kornelisz.', 360, NULL, NULL, NULL, NULL, NULL, NULL, '1601-04-23', 'Texel', NULL, NULL, true, '1601-12-26', 'Bantam', 5041, NULL);
INSERT INTO "voyages" VALUES (56, '', 1, '', 'ALKMAAR', 'Pieter Stokmans', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1601-04-23', 'Texel', NULL, NULL, true, '1602-02-22', 'Bantam', 5050, 'Fleet (0056-0063) under command of admiraal Jakob van Heemskerk aboard the AMSTERDAM, equipped by the Eerste Verenigde Compagnie op Oost-Indie. From 24-06 till 01-07 at Fernando Noronha; from 10-11 till 08-12 at Mayotte.');
INSERT INTO "voyages" VALUES (57, '', 2, '', 'AMSTERDAM', NULL, 500, NULL, NULL, NULL, NULL, NULL, NULL, '1601-04-23', 'Texel', NULL, NULL, true, '1602-02-22', 'Bantam', 5034, NULL);
INSERT INTO "voyages" VALUES (58, '', 1, '', 'ENKHUIZEN', 'Willem van Westzanen', NULL, 'jacht', NULL, NULL, NULL, NULL, NULL, '1601-04-23', 'Texel', NULL, NULL, true, '1602-02-22', 'Bantam', 5035, NULL);
INSERT INTO "voyages" VALUES (59, '', 1, '', 'HOORN', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1601-04-23', 'Texel', NULL, NULL, true, '1602-02-22', 'Bantam', 5036, NULL);
INSERT INTO "voyages" VALUES (60, '', 1, '', 'GROENE LEEUW', NULL, NULL, 'jacht', NULL, NULL, NULL, NULL, NULL, '1601-04-23', 'Texel', NULL, NULL, true, '1602-02-22', 'Bantam', 5037, NULL);
INSERT INTO "voyages" VALUES (61, '', 1, '', 'RODE LEEUW', 'Pieter Klaasz.', NULL, 'jacht', NULL, NULL, NULL, NULL, NULL, '1601-04-23', 'Texel', NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (62, '', 1, '', 'WITTE LEEUW', NULL, 540, 'jacht', NULL, NULL, NULL, 'A', NULL, '1601-04-23', 'Texel', NULL, NULL, true, '1602-02-22', 'Bantam', 5051, NULL);
INSERT INTO "voyages" VALUES (63, '', 1, '', 'ZWARTE LEEUW', 'Adriaan Blok', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1601-04-22', 'Wielingen', NULL, NULL, true, '1602-04-04', 'Bantam', 5038, NULL);
INSERT INTO "voyages" VALUES (64, '', 1, '', 'LAM', 'Willem Jansz.', NULL, 'jacht or pinas', NULL, NULL, NULL, NULL, NULL, '1601-05-05', 'Veere', NULL, NULL, true, NULL, 'Atjeh', 5048, 'Compagnie de Moucheron. T otal number of those on board 225. From 10-05 till 15-05 at Dartmouth; from 14-06 till 20-06 at Portugal; from 02-08 till 11-08 at Corisco; from 17-08 till 30-08 at Cape Lopez; from 15-11 till 20-11 at St. Helena Bay. The SCHAAP took on provisions from 21-02 till 04-04 at the Comoro and May 31th at Ceylon. The RAM with vice-admiraal Guyon Le Fort on board via the Bay of Augustin and Ceylon.');
INSERT INTO "voyages" VALUES (65, '', 1, '', 'RAM', 'Guyon Le Fort', 110, NULL, NULL, NULL, NULL, NULL, NULL, '1601-05-05', 'Veere', NULL, NULL, true, '1602-09-16', 'Atjeh', NULL, 'With the death of Le Fort (26-06) the RAM was sold to the V.O.C. and put under the command of Sebald de Weert (see 0067-69).');
INSERT INTO "voyages" VALUES (66, '', 1, '', 'SCHAAP', 'Pieter Kornelisz.', 110, NULL, NULL, NULL, NULL, NULL, NULL, '1601-05-05', 'Veere', NULL, NULL, true, '1602-09-16', 'Atjeh', 5049, NULL);
INSERT INTO "voyages" VALUES (67, '', 1, '', 'TER GOES', 'Marten Jelisz. Spanjaard', 240, NULL, NULL, NULL, NULL, NULL, 'Z', '1602-03-31', 'Wielingen', NULL, NULL, true, '1602-11-28', 'Ceylon', 5059, 'fleet of Van Warwyck. The three ships of Zeeland preceded the rest of the fleet. Took on provisions in the Bay of Antongil.');
INSERT INTO "voyages" VALUES (68, '', 1, '', 'VLISSINGEN', 'Laurens Fransz. van Vlissingen', 400, NULL, NULL, NULL, NULL, NULL, 'Z', '1602-03-31', 'Wielingen', NULL, NULL, true, '1602-11-28', 'Ceylon', 5070, NULL);
INSERT INTO "voyages" VALUES (69, '', 1, '', 'ZIERIKZEE', 'Govert Jansz.', 760, NULL, NULL, NULL, NULL, NULL, 'Z', '1602-03-31', 'Wielingen', NULL, NULL, true, '1602-11-28', 'Ceylon', 5061, NULL);
INSERT INTO "voyages" VALUES (70, '', 1, '', 'MAAGD VAN ENKHUIZEN', 'Kornelis Pietersz.', 320, NULL, NULL, NULL, NULL, NULL, 'E', '1602-06-17', 'Texel', NULL, NULL, true, '1603-04-29', 'Bantam', 5047, 'The equipment (0070-0081) of the `Fourteen ships'' (without the jacht PAPEGAAITJE) under admiraal Wybrand van Warwyck on the MAURITIUS.From June 24th till July 10th the fleet lay off Plymouth; from October 11th till 21th off Annabon; and was on December 12th near the Cape. December 14th the HOLLAND, the HOLLANDSE TUIN and the STER left the main fleet, and set sail for Atjeh, the remainder sailed for Bantam.');
INSERT INTO "voyages" VALUES (71, '', 1, '', 'HOLLANDIA', 'Dirk Gerritsz. van Hoorn', 600, NULL, NULL, NULL, NULL, 'A', 'A', '1602-06-17', 'Texel', NULL, NULL, true, '1603-03-10', 'Atjeh', 5069, NULL);
INSERT INTO "voyages" VALUES (72, '', 1, '', 'MAAN', 'Jan Kornelisz. Melknap', 500, NULL, NULL, NULL, NULL, NULL, 'A', '1602-06-17', 'Texel', NULL, NULL, true, '1603-04-29', 'Bantam', NULL, NULL);
INSERT INTO "voyages" VALUES (73, '', 1, '', 'MAURITIUS', 'Pieter Kornelisz. van Petten', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1602-06-17', 'Texel', NULL, NULL, true, '1603-04-29', 'Bantam', 5052, NULL);
INSERT INTO "voyages" VALUES (74, '', 1, '', 'NASSAU', 'Kornelis van de Venne', 320, NULL, NULL, NULL, NULL, NULL, 'A', '1602-06-17', 'Texel', NULL, NULL, true, '1603-04-29', 'Bantam', 5057, NULL);
INSERT INTO "voyages" VALUES (75, '', 1, '', 'PAPEGAAITJE', NULL, 50, 'jacht', NULL, NULL, NULL, NULL, 'E', '1602-06-17', 'Texel', NULL, NULL, true, '1603-04-29', 'Bantam', NULL, NULL);
INSERT INTO "voyages" VALUES (76, '', 1, '', 'STER', 'Abraham Mathijsz.', 360, NULL, NULL, NULL, NULL, NULL, 'A', '1602-06-17', 'Texel', NULL, NULL, true, '1603-03-10', 'Atjeh', 5058, NULL);
INSERT INTO "voyages" VALUES (77, '', 1, '', 'HOLLANDSE TUIN', 'Hendrik Haak', 360, NULL, NULL, NULL, NULL, NULL, 'E', '1602-06-17', 'Texel', NULL, NULL, true, '1603-03-10', 'Atjeh', 5060, NULL);
INSERT INTO "voyages" VALUES (78, '', 2, '', 'ZON', '(GROTE) Kornelis Jansz. Schouten', 580, NULL, NULL, NULL, NULL, NULL, 'A', '1602-06-17', 'Texel', NULL, NULL, true, '1603-04-29', 'Bantam', NULL, NULL);
INSERT INTO "voyages" VALUES (79, '', 1, '', 'EENDRACHT', 'Adriaan Kornelisz. Haai', 240, NULL, NULL, NULL, NULL, NULL, 'D', '1602-06-18', 'Maas', NULL, NULL, true, '1603-04-29', 'Bantam', 5046, NULL);
INSERT INTO "voyages" VALUES (80, '', 1, '', 'ERASMUS', 'Klaas Jansz. van Dijk', 540, NULL, NULL, NULL, NULL, NULL, 'R', '1602-06-18', 'Maas', NULL, NULL, true, '1603-04-29', 'Bantam', 5055, NULL);
INSERT INTO "voyages" VALUES (81, '', 1, '', 'ROTTERDAM', 'Pieter Klaasz. Rochussen', 800, NULL, NULL, NULL, NULL, NULL, 'R', '1602-06-18', 'Maas', NULL, NULL, true, '1603-04-29', 'Bantam', 5053, NULL);
INSERT INTO "voyages" VALUES (82, '', 1, '', 'AMSTERDAM', 'Arend Klaasz. Kalkbuis', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1603-12-18', 'Texel', NULL, NULL, true, '1604-12-31', 'Bantam', 5067, NULL);
INSERT INTO "voyages" VALUES (83, '', 2, '', 'DELFT', 'Willem Kornelisz. Schouten', 300, 'jacht', NULL, NULL, NULL, NULL, 'A', '1603-12-18', 'Texel', NULL, NULL, true, '1605-01-01', 'Atjeh', NULL, 'According to Commelin the master was Willem Lok. The ship stayed in the Indies.');
INSERT INTO "voyages" VALUES (84, '', 1, '', 'DORDRECHT', 'Hans Riemland', 900, NULL, NULL, NULL, NULL, NULL, 'Z', '1603-12-18', 'Wielingen', NULL, NULL, true, '1604-12-31', 'Bantam', 5068, NULL);
INSERT INTO "voyages" VALUES (85, '', 1, '', 'DUIFJE', 'Willem Jansz.', 60, 'jacht', NULL, NULL, NULL, 'A', 'A', '1603-12-18', 'Texel', NULL, NULL, true, '1604-12-11', 'Bantam', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (86, '', 1, '', 'ENKHUIZEN', 'Klaas Thijsz. Collet', 300, 'jacht', NULL, NULL, NULL, NULL, 'E', '1603-12-18', 'Texel', NULL, NULL, true, '1605-08-21', 'Bantam', NULL, 'Ran aground off Halmaheira, 1607.');
INSERT INTO "voyages" VALUES (87, '', 1, '', 'GELDERLAND', 'Jan Jansz. Mol', 500, NULL, NULL, NULL, NULL, NULL, 'A', '1603-12-18', 'Texel', NULL, NULL, true, '1604-12-31', 'Bantam', 5062, NULL);
INSERT INTO "voyages" VALUES (88, '', 1, '', 'HOF VAN HOLLAND', 'Willem Lok', 360, NULL, NULL, NULL, NULL, NULL, 'A', '1603-12-18', 'Texel', NULL, NULL, true, NULL, 'Madagascar', 5054, 'Commelin the master was Willem Kornelisz. Schouten.');
INSERT INTO "voyages" VALUES (89, '', 1, '', 'HOORN', 'Dirk Klaasz. Mooilieven', 700, NULL, NULL, NULL, NULL, 'H', 'H', '1603-12-18', 'Texel', NULL, NULL, true, '1604-12-31', 'Bantam', 5066, 'Took on provisions for about one month at Mauritius. Mooilieven was succeeded by Jan Konnelisz. van Avenhorn.');
INSERT INTO "voyages" VALUES (90, '', 1, '', 'MEDEMBLIK', 'Dirk Klaasz. Mooilieven', 250, 'jacht', NULL, NULL, NULL, NULL, 'H', '1603-12-18', 'Texel', NULL, NULL, true, '1604-07-01', 'Bantam', 5074, NULL);
INSERT INTO "voyages" VALUES (91, '', 1, '', 'GEUNIEERDE PROVINCIEN', 'Simon Jansz. Hoen', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1603-12-18', 'Texel', NULL, NULL, true, '1604-12-31', 'Bantam', 5065, 'took over the cargo and sailed back home, the ME-DEMBLIK proceeded to Bantam.');
INSERT INTO "voyages" VALUES (92, '', 1, '', 'WESTFRIESLAND', 'Jakob Jakobsz. Klunt', 700, NULL, NULL, NULL, NULL, 'E', 'E', '1603-12-18', 'Texel', NULL, NULL, true, '1604-12-31', 'Bantam', 5064, NULL);
INSERT INTO "voyages" VALUES (93, '', 1, '', 'ZEELANDIA', 'Krijn Pietersz.', 500, NULL, NULL, NULL, NULL, 'Z', 'Z', '1603-12-18', 'Wielingen', NULL, NULL, true, '1604-07-01', 'Cambodia', 5071, NULL);
INSERT INTO "voyages" VALUES (94, '', 1, '', 'GOUDA', 'Kornelis Heinsz. Pronk', 260, NULL, NULL, NULL, NULL, 'A', 'A', '1604-07-02', 'Texel', NULL, NULL, true, NULL, NULL, 5063, NULL);
INSERT INTO "voyages" VALUES (95, '', 1, '', 'EENDRACHT', 'Adriaan Kornelisz. Haai', 240, NULL, NULL, NULL, NULL, NULL, 'D', '1605-05-12', NULL, NULL, NULL, true, '1606-07-13', 'Bantam', NULL, 'Sent to Mauritius to collect ebony. According to Commelin departure 20-05-1605. At Mauritius 22-05-1606 (see 5068 and 5069). Destroyed by fire on the coast of Coromandel (1610).');
INSERT INTO "voyages" VALUES (96, '', 2, '', 'WITTE LEEUW', 'Wouter Jakobsz.', 540, 'jacht', NULL, NULL, NULL, 'A', 'A', '1605-05-12', 'Texel', NULL, NULL, true, '1606-05-01', 'Johore', 5073, 'was Gerrit Hendriksz. Roobol; according to Mac Leod Klaas Jansz. Melknap.');
INSERT INTO "voyages" VALUES (97, '', 1, '', 'ZWARTE LEEUW', 'Gerrit Hendriksz. Roobol', 600, NULL, NULL, NULL, NULL, 'A', 'A', '1605-05-12', 'Texel', NULL, NULL, true, '1606-05-01', 'Johore', 5075, 'According to Mac Leod the master was Abraham Mathijsz.');
INSERT INTO "voyages" VALUES (98, '', 2, '', 'MAURITIUS', 'Gerrit Klaasz.', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1605-05-12', 'Texel', NULL, NULL, true, '1606-05-01', 'Johore', 5077, 'According to Mac Leod the master was Klaas Gerritsz.');
INSERT INTO "voyages" VALUES (99, '', 1, '', 'MIDDELBURG', 'Simon Lambrechtsz. Mau.', 600, NULL, NULL, NULL, NULL, NULL, 'A', '1605-05-12', 'Texel', NULL, NULL, true, '1606-05-01', 'Johore', 18, '-08-1606 burnt in action before Malacca.');
INSERT INTO "voyages" VALUES (100, '', 2, '', 'NASSAU', 'Abraham Mathijsz.', 320, NULL, NULL, NULL, NULL, NULL, 'A', '1605-05-12', 'Texel', NULL, NULL, true, '1606-05-01', 'Johore', 22, '-08-1606 burnt in action before Malacca. According to Commelin the master was Wouter Jakobsz.; according to Mac Leod Walter Karelsz. There were also 15 blacks on board.');
INSERT INTO "voyages" VALUES (101, '', 1, '', 'ORANJE', 'Dirk Klaasz. Mol', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1605-05-12', 'Texel', NULL, NULL, true, '1606-05-01', 'Johore', 5078, 'fleet was before Johore where it started operations against the Portuguese. The ERASMUS, the PRO-VINCIEN and probably the EENDRACHT departed not before 30-05 from the Maas. The first 2 ships joined Matelieff on 14-07-1607 off Malacca, the EENDRACHT was sent for Mauritius to collect ebony. In August 1610 this ship was destroyed by fire on the coast of Coromandel. The ship probably never formed part of the fleet of Matelieff. The GROTE ZON and the KLEINE ZON stayed in the Indies and were broken up at Banda.');
INSERT INTO "voyages" VALUES (102, '', 1, '', 'GROTE ZON', 'Klaas Jansz. Melknap', 540, NULL, NULL, NULL, NULL, NULL, 'A', '1605-05-12', 'Texel', NULL, NULL, true, '1606-05-01', 'Johore', 5083, 'Purchased from the Admirality of Amsterdam, 1604.');
INSERT INTO "voyages" VALUES (103, '', 1, '', 'AMSTERDAM', 'Reinier Lambrechtsz.', 700, NULL, NULL, NULL, NULL, 'A', 'Z', '1605-05-24', 'Wielingen', NULL, NULL, true, '1606-05-01', 'Johore', 5072, NULL);
INSERT INTO "voyages" VALUES (104, '', 1, '', 'KLEINE ZON', 'Kornelis Jorisz.', 220, NULL, NULL, NULL, NULL, 'Z', 'Z', '1605-05-24', 'Wielingen', NULL, NULL, true, '1606-05-01', 'Johore', NULL, NULL);
INSERT INTO "voyages" VALUES (105, '', 2, '', 'ERASMUS', 'Olivier Kornelisz.', 540, NULL, NULL, NULL, NULL, NULL, 'R', '1605-05-30', 'Goeree', NULL, NULL, true, '1606-07-14', 'Johore', 5081, NULL);
INSERT INTO "voyages" VALUES (106, '', 1, '', 'GEUNIEERDE PROVINCIEN', 'Anthonis Anthonisz. (Zwarte Teun)', 400, NULL, NULL, NULL, NULL, 'D', 'D', '1605-05-30', 'Goeree', NULL, NULL, true, '1606-07-14', 'Johore', 5076, NULL);
INSERT INTO "voyages" VALUES (107, '', 1, '', 'BANDA', 'Jan Bruin', 600, NULL, NULL, NULL, NULL, NULL, 'A', '1606-04-20', 'Texel', NULL, NULL, true, '1607-10-02', 'Goa', 5088, 'number of those on board was 1060. From 23-05 till 03-06 on the roadstead of the isle of Wight, the 3 ships from Zeeland arrived here 25-05; 29-03 at Mozambique, where they started operations against the Portuguese. When leaving, 26-05, the ZIERIKZEE ran aground and was lost; the mainfleet was therefore unable to sail before June, 29th; from 08-06 till 17-07 at the Comoro I; from 04-08 till 26-08 again at Mozambique and 02-10 at Goa.');
INSERT INTO "voyages" VALUES (108, '', 1, '', 'BANTAM', 'Pieter Kornelisz. van Petten', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1606-04-20', 'Texel', NULL, NULL, true, '1607-10-02', 'Goa', 5079, NULL);
INSERT INTO "voyages" VALUES (109, '', 1, '', 'CEYLON', 'Willem Dirksz.', 340, NULL, NULL, NULL, NULL, 'A', 'A', '1606-04-20', 'Texel', NULL, NULL, true, '1607-10-02', 'Goa', 5080, NULL);
INSERT INTO "voyages" VALUES (110, '', 1, '', 'CHINA', 'Kornelis Maartensz.', 420, NULL, NULL, NULL, NULL, 'H', 'H', '1606-04-20', 'Texel', NULL, NULL, true, '1607-10-02', 'Goa', NULL, 'Riding at anchor off Ternate in 1608, the ship was lost due to bad weather (July 1608).');
INSERT INTO "voyages" VALUES (111, '', 1, '', 'PATANIA', 'Dirk Albertsz. de Vries', 340, NULL, NULL, NULL, NULL, 'E', 'E', '1606-04-20', 'Texel', NULL, NULL, true, '1607-10-02', 'Goa', 5087, NULL);
INSERT INTO "voyages" VALUES (112, '', 1, '', 'TER VEERE', 'Adriaan Looy', 700, NULL, NULL, NULL, NULL, 'Z', 'Z', '1606-05-14', 'Wielingen', NULL, NULL, true, '1607-10-02', 'Goa', 5082, NULL);
INSERT INTO "voyages" VALUES (113, '', 1, '', 'WALCHEREN', 'Arend Maartensz.', 700, NULL, NULL, NULL, NULL, 'Z', 'Z', '1606-05-14', 'Wielingen', NULL, NULL, true, '1607-10-02', 'Goa', NULL, 'Riding at anchor off Ternate in 1608, the ship was lost due to bad weather.');
INSERT INTO "voyages" VALUES (114, '', 2, '', 'ZIERIKZEE', 'Adriaan Kornelisz.', 760, NULL, NULL, NULL, NULL, 'Z', 'Z', '1606-05-14', 'Wielingen', NULL, NULL, true, NULL, NULL, NULL, 'Foundered 1607 Cabacella (Moz.).');
INSERT INTO "voyages" VALUES (115, '', 2, '', 'GELDERLAND', NULL, 500, NULL, NULL, NULL, NULL, NULL, 'A', '1606-12-13', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ship was forced by bad weather to take refuge in the harbour of Vlissingen, July 19th and was lost, making its way out July 20th.');
INSERT INTO "voyages" VALUES (116, '', 2, '', 'GOUDA', 'Jakob Gerritsz.', 260, NULL, NULL, NULL, NULL, 'A', 'A', '1606-12-13', 'Texel', NULL, NULL, true, '1608-01-01', 'Atjeh', 5084, NULL);
INSERT INTO "voyages" VALUES (117, '', 1, '', 'GELDERLAND', 'Jan Jansz. Mol', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1607-04-26', 'Zeeland', NULL, NULL, true, '1607-10-26', 'Malabar', 5085, NULL);
INSERT INTO "voyages" VALUES (118, '', 1, '', 'MIDDELBURG', 'Kornelis Leendertsz. Krakeel', 800, NULL, NULL, NULL, NULL, NULL, 'Z', '1607-12-21', 'Wielingen', NULL, NULL, true, '1608-09-18', 'Goa', 5096, NULL);
INSERT INTO "voyages" VALUES (119, '', 1, '', 'VALK', 'Kornelis Adriaansz. Hooiwagen', 140, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1607-12-21', 'Wielingen', NULL, NULL, true, '1608-09-18', 'Goa', NULL, 'Captured by the Spaniards off Manila, 25-04-1610.');
INSERT INTO "voyages" VALUES (120, '', 2, '', 'ZEELANDIA', 'Willem Jakobsz. van Arnemuiden', 500, NULL, NULL, NULL, NULL, 'Z', 'Z', '1607-12-21', 'Wielingen', NULL, NULL, true, '1608-09-18', 'Goa', 5086, NULL);
INSERT INTO "voyages" VALUES (121, '', 2, '', 'AMSTERDAM', 'Pieter Gerritsz.', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1607-12-22', 'Texel', NULL, NULL, true, '1608-09-18', 'Goa', NULL, 'Captured by the Spaniards off Manilla, 25-04-1610.');
INSERT INTO "voyages" VALUES (122, '', 1, '', 'AREND', 'Rutger Thomasz.', 140, 'jacht', NULL, NULL, NULL, 'A', 'A', '1607-12-22', 'Texel', NULL, NULL, true, '1608-09-18', 'Goa', NULL, 'Captured and burnt by the Spaniards off Manilla 25-04-1610.');
INSERT INTO "voyages" VALUES (123, '', 1, '', 'DELFT', 'Simon Maartensz. (Zwarte Simon)', 800, NULL, NULL, NULL, NULL, 'D', 'D', '1607-12-22', 'Goeree', NULL, NULL, true, '1608-09-18', 'Goa', 5094, NULL);
INSERT INTO "voyages" VALUES (124, '', 1, '', 'GRIFFIOEN', 'Kornelis Kornelisz. ''t Hert', 140, 'jacht', NULL, NULL, NULL, 'R', 'R', '1607-12-22', 'Goeree', NULL, NULL, true, '1608-09-18', 'Goa', NULL, 'The ship stayed in the Indies.');
INSERT INTO "voyages" VALUES (125, '', 2, '', 'HOLLANDIA', 'Simon Jansz. Hoen', 800, NULL, NULL, NULL, NULL, 'A', 'A', '1607-12-22', 'Texel', NULL, NULL, true, '1608-09-18', 'Goa', 5097, 'illemsz. Verhoeff aboard the GEUNIEERDE PROVINCIEN and vice-adm. Frans Hendriksz. Wittert aboard the MIDDELBURG. The 3 Zeeland ships and the mainfleet met at Maio I. February 1608; from 15-05 till 02-06 at St. Helena; 28-06 somewhere in the regions off the Cape; from 28-06 till 23-08 the fleet started operations against the Portuguese at Mozambique; from 18-09 till 02-10 off Goa.');
INSERT INTO "voyages" VALUES (126, '', 2, '', 'HOORN', 'Maarten Jansz. Kloot', 700, NULL, NULL, NULL, NULL, 'H', 'H', '1607-12-22', 'Texel', NULL, NULL, true, '1608-09-18', 'Goa', 5091, NULL);
INSERT INTO "voyages" VALUES (127, '', 1, '', 'RODE LEEUW MET PIJLEN', 'Jan Walijchsz.', 400, NULL, NULL, NULL, NULL, 'A', 'A', '1607-12-22', 'Texel', NULL, NULL, true, '1608-09-18', 'Goa', 5089, NULL);
INSERT INTO "voyages" VALUES (128, '', 1, '', 'PAUW', 'Meeuwis Gijsbertsz.', 140, 'jacht', NULL, NULL, NULL, 'A', 'A', '1607-12-22', 'Texel', NULL, NULL, true, '1608-09-18', 'Goa', NULL, 'The ship stayed in the Indies.');
INSERT INTO "voyages" VALUES (129, '', 2, '', 'GEUNIEERDE PROVINCIEN', 'Frans Jakobsz. de Vries', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1607-12-22', 'Texel', NULL, NULL, true, '1608-09-19', 'Goa', 5092, 'May 22th 1609 Frans 
Jakobsz. de Vries was murdered by the inhabitants of Banda.');
INSERT INTO "voyages" VALUES (130, '', 2, '', 'ROTTERDAM', 'Jan Kornelisz. de Wit', 800, NULL, NULL, NULL, NULL, 'R', 'R', '1607-12-22', 'Goeree', NULL, NULL, true, '1608-09-19', 'Goa', 5090, NULL);
INSERT INTO "voyages" VALUES (131, '', 2, '', 'MEDEMBLIK', 'Jacques l''Hermite', 250, 'jacht', NULL, NULL, NULL, NULL, 'A', '1608-01-01', 'Texel', NULL, NULL, true, NULL, 'Bantam', NULL, 'The ship was despatched to bring news of the forthcoming Twelve Years'' Truce; stayed in the Indies and was wrecked near the Maledive Islands.');
INSERT INTO "voyages" VALUES (132, '', 1, '', 'HOOP', 'Pieter Heeresz.', 80, 'jacht', NULL, NULL, NULL, 'A', 'A', '1608-04-15', 'Texel', NULL, NULL, true, '1608-12-26', 'Bantam', NULL, 'Captured by the Spaniards near Manila, 15-07-1610.');
INSERT INTO "voyages" VALUES (133, '', 1, '', 'HALVE MAAN', 'Henry Hudson', 80, 'jacht', NULL, NULL, NULL, 'A', 'A', '1609-04-06', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Destined to explore the North-East passage to the Indies; discovered Hudson Bay and returned 07-12 in Dartmouth. Further information see I''Honore Naber.');
INSERT INTO "voyages" VALUES (134, '', 1, '', 'HAZEWIND', 'Wemmer van Berchem', 120, 'jacht', NULL, NULL, NULL, 'E', 'E', '1609-08-01', 'Texel', NULL, NULL, true, '1610-10-01', 'Bantam', NULL, 'left Lissabon 05-02-1610, rounded the Cape 04-05, took on provisions from 25-06 till 06-07 at Madagascar. It stayed in the Indies.');
INSERT INTO "voyages" VALUES (135, '', 1, '', 'WAPEN VAN AMSTERDAM', 'Dirk Pietersz. Kalf', 800, NULL, NULL, NULL, NULL, 'A', 'A', '1610-01-30', 'Texel', '1610-06-28', '1610-08-10', true, '1610-12-19', 'Bantam', 5099, 'scattered the fleet; from 19-09 till 16-10 the WAPEN VAN AMSTERDAM took on provisions at Mauritius.');
INSERT INTO "voyages" VALUES (136, '', 1, '', 'BRAK', 'Jakob IJsbrandsz.', 100, 'jacht', NULL, NULL, NULL, NULL, 'E', '1610-01-30', 'Texel', NULL, NULL, true, NULL, 'Bantam', NULL, 'The BRAK lost sight of the fleet at 23-06; 03-08 at Mauritius. At 07-08-1613 the ship sailed aground near Macassar and was lost.');
INSERT INTO "voyages" VALUES (137, '', 2, '', 'CEYLON', 'Dirk Gerritsz. Smient', 340, NULL, NULL, NULL, NULL, 'A', 'A', '1610-01-30', 'Texel', NULL, NULL, true, '1610-08-08', 'Mauritius', 5093, 'The CEYLON lost sight of the fleet 03-07.');
INSERT INTO "voyages" VALUES (138, '', 2, '', 'TER GOES', 'Kornelis Reiniersz.', 240, NULL, NULL, NULL, NULL, 'Z', 'Z', '1610-01-30', 'Wielingen', NULL, NULL, true, '1610-12-10', 'Bantam', NULL, 'Lost sight of the fleet; from 30-07 till 02-08 at the Bay of Antipara; 02-08 in the St. Lucia Bay, where it took over the remaining cargo of the MAURITIUS (5077); 21-08 departure from Madagascar via the Bay of Antongil; from 27-10 till 08-12 at Mauritius.');
INSERT INTO "voyages" VALUES (139, '', 3, '', 'WITTE LEEUW', 'Klaas Rutgersz. Smit', 540, 'jacht', NULL, NULL, NULL, 'A', 'A', '1610-01-30', 'Texel', NULL, NULL, true, '1610-11-16', 'Bantam', 5100, 'Lost sight of the fleet; from 24-07 till 03-08 in the `Verhagensbaai''; from 29-08 till 27-09 at Mayotte.');
INSERT INTO "voyages" VALUES (140, '', 2, '', 'ZWARTE LEEUW', 'Kornelis Dirksz. Worst', 600, NULL, NULL, NULL, NULL, 'A', 'A', '1610-01-30', 'Texel', NULL, NULL, true, '1610-11-16', 'Bantam', 5102, 'See 0139.');
INSERT INTO "voyages" VALUES (141, '', 2, '', 'ORANJE', 'Kornelis Riemland', 700, NULL, NULL, NULL, NULL, 'A', 'Z', '1610-01-30', 'Wielingen', NULL, NULL, true, '1610-11-16', 'Bantam', 5095, 'See 0139.');
INSERT INTO "voyages" VALUES (142, '', 1, '', 'VLISSINGEN', 'Jan Kornelisz. ''t Hert', 600, NULL, NULL, NULL, NULL, 'Z', 'Z', '1610-01-30', 'Wielingen', NULL, NULL, true, '1610-11-16', 'Bantam', 5101, 'See 0139.');
INSERT INTO "voyages" VALUES (143, '', 3, '', 'GOUDA', 'Albert Hermansz.', 260, NULL, NULL, NULL, NULL, 'A', 'A', '1610-12-28', 'Texel', '1611-06-04', NULL, true, '1611-08-24', 'Bantam', NULL, 'Fleet (0143-0144) under the command of Hendrik Brouwer aboard the RODE LEEUW MET PIJLEN sailed the southern passage for the first time (latitude ca. 36'' south), which was made obligatory in 1616. The GOUDA was captured by the Spaniards near Tidore, 04-05-1612.');
INSERT INTO "voyages" VALUES (144, '', 2, '', 'RODE LEEUW MET PULEN', 'Kornelis Maartensz. ''t Kind', 400, NULL, NULL, NULL, NULL, 'A', 'A', '1610-12-28', 'Texel', '1611-06-04', NULL, true, '1611-08-18', 'Bantam', NULL, 'unseaworthiness, abandoned by its crew and set on fire, August 1615.');
INSERT INTO "voyages" VALUES (145, '', 2, '', 'TER VEERE', 'Willem Jakobsz. van Arnemuiden', 700, NULL, NULL, NULL, NULL, 'Z', 'Z', '1610-12-28', 'Wielingen', NULL, NULL, true, '1611-09-05', 'Bantam', 5103, NULL);
INSERT INTO "voyages" VALUES (146, '', 2, '', 'BANDA', 'Roelof Thijsz.', 800, NULL, NULL, NULL, NULL, NULL, 'A', '1611-03-16', 'Texel', NULL, NULL, true, '1612-02-02', 'Bantam', 5105, 'in St. Lucia Bay; from 15-12 till 23-12 at Mauritius. According to Commelin the master of the BANDA was Roelof Harmensz.');
INSERT INTO "voyages" VALUES (147, '', 2, '', 'BANTAM', 'Kornelis Arendse', 900, NULL, NULL, NULL, NULL, NULL, 'E', '1611-05-02', 'Texel', NULL, NULL, true, '1612-03-02', 'Bantam', 5098, NULL);
INSERT INTO "voyages" VALUES (148, '', 2, '', 'HALVE MAAN', 'Melis Andriesz.', 80, 'jacht', NULL, NULL, NULL, 'A', 'A', '1611-05-02', 'Texel', NULL, NULL, true, '1612-02-02', 'Bantam', NULL, NULL);
INSERT INTO "voyages" VALUES (149, '', 1, '', 'GROTE AEOLUS', 'Bouwe Bouwesz.', 300, NULL, NULL, NULL, NULL, 'A', 'A', '1611-12-29', 'Texel', NULL, NULL, true, '1612-11-28', 'Bantam', NULL, 'Capsized near Makian 31-01-1613; 15 survivors.');
INSERT INTO "voyages" VALUES (150, '', 3, '', 'CEYLON', 'Klaas Jansz.', 340, NULL, NULL, NULL, NULL, 'A', 'A', '1611-12-29', 'Texel', NULL, NULL, true, '1612-11-28', 'Bantam', NULL, NULL);
INSERT INTO "voyages" VALUES (151, '', 1, '', 'DUIFJE', 'Serpent', 50, 'jacht', NULL, NULL, NULL, 'A', 'A', '1611-12-29', 'Texel', NULL, NULL, true, '1612-10-24', 'Bantam', NULL, 'Ran aground near Surat and lost, 17-07-1617.');
INSERT INTO "voyages" VALUES (152, '', 2, '', 'GELDERLAND', 'Simon Lambrechtsz. Mau', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1611-12-29', 'Texel', NULL, NULL, true, '1612-11-28', 'Bantam', 5107, 'command of Adriaan Martensz. Blok aboard the GELDERLAND. The total number of those on board was ca. 2000. From 17-01 till 09-02 at Maio I.; from 21-03 till 31-03 at Cape Lopez; from 19-04 till 01-05 at Annabon; 25-06 somewhere off the Cape; from 06-08 till 23-08 at Reunion; 03-05 the GROENE LEEUW and the STER were sent to Coromandel; 15-07 the DUIFJE was sent ahead of the fleet to Bantam.');
INSERT INTO "voyages" VALUES (153, '', 1, '', 'GROENE LEEUW', 'Klaas Warebouts', 140, 'jacht', NULL, NULL, NULL, 'A', 'A', '1611-12-29', 'Texel', NULL, NULL, true, '1612-09-08', 'Pulicat', 5110, NULL);
INSERT INTO "voyages" VALUES (154, '', 1, '', 'RODE ZEEUW', 'Volkert Thijsz.', 400, NULL, NULL, '1610', NULL, 'A', 'A', '1611-12-29', 'Texel', NULL, NULL, true, '1612-11-28', 'Bantam', NULL, 'Coming from Manila lost near Japan, 31-01-1613.');
INSERT INTO "voyages" VALUES (155, '', 1, '', 'GROTE MAAN', 'Jan Gerritsz.', 500, NULL, NULL, NULL, NULL, 'A', 'A', '1611-12-29', 'Texel', NULL, NULL, true, '1612-11-28', 'Bantam', NULL, 'Lost sight of the mainfleet after a heavy storm 05-07 but joined the fleet again at 22-10; in the meanwhile took on provisions in the Bay of Antongil.');
INSERT INTO "voyages" VALUES (156, '', 2, '', 'PATANIA', 'Sandersz.', 340, NULL, NULL, NULL, NULL, 'E', 'E', '1611-12-29', 'Texel', NULL, NULL, true, '1612-11-28', 'Bantam', NULL, 'Broken up in the Moluccas, June 1615.');
INSERT INTO "voyages" VALUES (157, '', 1, '', 'STER', 'Wouter Klaasz.', 160, NULL, NULL, NULL, NULL, 'A', 'A', '1611-12-29', 'Texel', NULL, NULL, true, '1612-09-08', 'Pulicat', NULL, NULL);
INSERT INTO "voyages" VALUES (158, '', 1, '', 'ZON', 'Pieter Kornelisz.', 500, NULL, NULL, NULL, NULL, 'A', 'A', '1611-12-29', 'Texel', NULL, NULL, true, '1612-11-28', 'Bantam', NULL, 'Broken up,10-1-1621.');
INSERT INTO "voyages" VALUES (159, '', 3, '', 'ORANJE', 'Willem Jansz.', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1612-01-02', 'Wielingen', NULL, NULL, true, '1612-11-28', 'Bantam', NULL, 'Lost in the Indies 02-10-1614.');
INSERT INTO "voyages" VALUES (160, '', 3, '', 'ROTTERDAM', 'Elias Volkertsz.', 800, NULL, NULL, NULL, NULL, 'R', 'R', '1612-01-02', 'Goeree', NULL, NULL, true, '1612-10-19', 'Bantam', 5112, 'Sailed alone.');
INSERT INTO "voyages" VALUES (161, '', 3, '', 'ZEELANDIA', 'Abraham Klaasz.', 500, NULL, NULL, NULL, NULL, 'Z', 'Z', '1612-01-02', 'Wielingen', NULL, NULL, true, '1612-11-23', 'Bantam', NULL, 'Also mentioned as ZEELAND or OUD-ZEELAND.');
INSERT INTO "voyages" VALUES (162, '', 1, '', 'HOOP', 'Usbrand Jakobsz. de Gooier', 500, 'jacht', NULL, NULL, NULL, 'A', 'A', '1612-05-12', 'Texel', NULL, NULL, true, '1613-02-09', 'Bantam', NULL, 'at Brava I., where 13 man died in action. June 9th at the Gold Coast; September 8th somewhere off the Cape. From 04-11 till 24-11 at Mauritius.');
INSERT INTO "voyages" VALUES (163, '', 3, '', 'GEUNIEERDE PROVINCIEN', 'Rutger Antonisz.', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1612-05-12', 'Texel', NULL, NULL, true, '1613-02-09', 'Bantam', 5108, NULL);
INSERT INTO "voyages" VALUES (164, '', 1, '', 'AREND', 'Gerard Albertsz. Lous', 300, NULL, NULL, NULL, NULL, NULL, 'A', '1613-01-31', 'Texel', NULL, NULL, true, '1614-01-04', 'Bantam', NULL, '23th at Brava I.; June 13th somewhere off the Cape; from 20-06 till 08-07 at Fermosa Bay; from 22-08 till 16-09 at Mauritius.');
INSERT INTO "voyages" VALUES (165, '', 1, '', 'HOORN', 'Olf Jansz.', 700, NULL, NULL, NULL, NULL, 'H', 'H', '1613-01-31', 'Texel', NULL, NULL, true, '1614-01-04', 'Bantam', NULL, NULL);
INSERT INTO "voyages" VALUES (166, '', 1, '', 'WITTE VALK', NULL, 360, NULL, NULL, NULL, NULL, NULL, 'A', '1613-01-31', 'Texel', NULL, NULL, true, '1614-01-04', 'Bantam', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (167, '', 1, '', 'NEPTUNUS', 'Barend Pot', NULL, 'jacht', NULL, NULL, NULL, NULL, 'A', '1613-04-01', NULL, NULL, NULL, true, '1614-08-16', 'Bantam', NULL, 'Reprovisioned in St. Lucia Bay. The ship stayed in the Indies and was laid up ca. 1620-1621.');
INSERT INTO "voyages" VALUES (168, '', 1, '', 'KLEINE AEOLUS', 'Pieter Kornelisz.', 240, 'jacht', NULL, NULL, NULL, NULL, 'R', '1613-04-04', 'Maas', NULL, NULL, true, '1614-10-31', 'Bantam', NULL, 'Stayed in the Indies and was, coming from Coromandel, foundered on the rocks of Engano I. 25-08-1616.');
INSERT INTO "voyages" VALUES (169, '', 2, '', 'MIDDELBURG', 'Maarten Reiniersz.', 800, NULL, NULL, NULL, NULL, NULL, 'Z', '1613-04-04', 'Wielingen', NULL, NULL, true, '1614-05-02', 'Bantam', NULL, 'Fleet (0169-0170) under the command of Jasper van Surk aboard the MIDDELBURG. May 4th at Maio I.; August 10th the ZEELANDIA disappeared from sight and the MIDDELBURG reprovisioned in St. Lucia Bay. Later the MIDDELBURG was lost near Surat, 19-07-1617.');
INSERT INTO "voyages" VALUES (170, '', 1, '', 'ZEELANDIA', 'Kornelis Riemland', 800, NULL, NULL, NULL, NULL, 'Z', 'Z', '1613-04-04', 'Wielingen', '1613-08-21', '1613-09-03', true, '1613-12-12', 'Bantam', 5118, NULL);
INSERT INTO "voyages" VALUES (171, '', 2, '', 'DELFT', 'Jan Hillebrandsz.', 800, NULL, NULL, NULL, NULL, 'D', 'D', '1613-06-05', 'Goeree', NULL, NULL, true, '1614-05-05', 'Bantam', 5106, NULL);
INSERT INTO "voyages" VALUES (172, '', 1, '', 'WAPEN VAN AMSTERDAM', 'Jan Kornelisz. May', 1000, NULL, NULL, NULL, NULL, NULL, 'A', '1613-07-02', 'Texel', NULL, NULL, true, '1614-11-04', 'Bantam', 5117, NULL);
INSERT INTO "voyages" VALUES (173, '', 3, '', 'HOLLANDIA', 'Kornelis Hansz.', 800, NULL, NULL, NULL, NULL, 'A', 'A', '1613-07-02', 'Texel', NULL, NULL, true, '1614-11-05', 'Bantam', NULL, 'Gerard Reynst and admiraal Steven van der Hagen aboard the WAPEN VAN AMSTERDAM. From 29-09 till 05-10 at S. Vincente; January 
10th. at Cape Lopez; from 21-02 till 02-03 at Annabon; May 31th. somewhere off the Cape; from 13-06 till 21-07 at the Comoro Islands.');
INSERT INTO "voyages" VALUES (174, '', 1, '', 'MAURITIUS', 'Leendert Jakobsz.', 800, NULL, '1612', NULL, NULL, 'A', 'A', '1613-07-02', 'Texel', NULL, NULL, true, '1614-11-04', 'Bantam', 5113, NULL);
INSERT INTO "voyages" VALUES (175, '', 1, '', 'NASSAU', 'Jan Pietersz.', 300, 'jacht', NULL, NULL, NULL, NULL, 'A', '1613-07-02', 'Texel', NULL, NULL, true, '1614-12-30', 'Bantam', NULL, 'According to Coolhaas the ship arrived at Bantam 16-01-1615. The ship stayed in the Indies and ran aground in the river Andragiri 19-09-1615.');
INSERT INTO "voyages" VALUES (176, '', 1, '', 'HERT', 'Kornelis Kornelisz.', 280, 'jacht', NULL, NULL, NULL, 'R', 'R', '1614-02-14', 'Maas', NULL, NULL, true, '1614-08-07', 'Bantam', 5104, 'Reprovisioned at the Cape and sailed, before arriving at Bantam, by mistake to Bali.');
INSERT INTO "voyages" VALUES (177, '', 2, '', 'VLISSINGEN', 'Joost Engels', 600, NULL, NULL, NULL, NULL, 'Z', 'Z', '1614-04-24', 'Wielingen', NULL, NULL, true, '1615-12-02', 'Bantam', NULL, 'Fleet (0177-0182) under command of Adriaan Woutersz. Stoop (+ 26-11-1615) aboard the VLISSINGEN. The VLISSINGEN had a difficult voyage; 19-12 rounding the Cape the ship sailed north too early; 18-11-1615 (!) it encountered the WALCHE-REN, the ENGEL and the AMSTERDAM.');
INSERT INTO "voyages" VALUES (178, '', 1, '', 'WALCHEREN', 'Hugo Pietersz.', 500, NULL, '1612', NULL, NULL, 'Z', 'Z', '1614-04-24', 'Wielingen', NULL, NULL, true, '1615-12-02', 'Bantam', 5124, '1615 till 01-05-1615 at Mauritius.');
INSERT INTO "voyages" VALUES (179, '', 1, '', 'ORANJEBOOM', 'Pieter Barendsz. van Hoorn', 360, 'jacht', NULL, NULL, NULL, 'H', 'H', '1614-04-26', 'Texel', '1614-11-01', NULL, true, '1615-04-01', 'Mauritius', 5109, 'From April 1615 till May 1615 at Mauritius to collect the cargo of the wrecked GELDERLAND (6007).');
INSERT INTO "voyages" VALUES (180, '', 2, '', 'WAPEN VAN AMSTERDAM', 'IJsbrand Kornelisz.', 800, NULL, NULL, NULL, NULL, 'A', 'A', '1614-05-11', 'Texel', NULL, NULL, true, '1615-12-02', 'Bantam', NULL, 'From 04-08 till 15-08 off Principe L; from 16-08 till 24-08 off Corisco; from 02-03 till 28-03 at St. Lucia Bay; from 15-04 till 01-05 at Mauritius.');
INSERT INTO "voyages" VALUES (181, '', 1, '', 'ENGEL', 'Jakob Kornelisz. Goedheid', 600, NULL, '1613', NULL, NULL, 'D', 'D', '1614-05-15', 'Maas', NULL, NULL, true, '1615-12-02', 'Bantam', NULL, 'Left Madagascar 15-02-1615; from April 1615 till 01-05-1615 at Mauritius.');
INSERT INTO "voyages" VALUES (182, '', 1, '', 'ENKHUIZEN', 'Dirk Albertsz. de Vries', 500, NULL, NULL, NULL, NULL, NULL, 'E', '1614-05-15', 'Texel', NULL, NULL, true, '1615-03-13', 'Bantam', 5123, NULL);
INSERT INTO "voyages" VALUES (183, '', 1, '', 'GROTE AEOLUS', 'Job Kornelisz.', 320, NULL, NULL, NULL, NULL, NULL, 'Z', '1614-08-08', 'Wielingen', NULL, NULL, true, '1616-03-30', 'Ternate', NULL, 'Burst in the battle of Manila, 16-04-1617.');
INSERT INTO "voyages" VALUES (184, '', 1, '', 'JAGER', 'Gerrit Jansz.', 140, 'jacht', NULL, NULL, NULL, 'A', NULL, '1614-08-08', 'Texel', NULL, NULL, true, '1616-03-30', 'Ternate', NULL, 'near the reef of Armigon.');
INSERT INTO "voyages" VALUES (185, '', 1, '', 'GROTE MAAN', 'Reinier Lambrechtsz.', 600, NULL, NULL, NULL, NULL, NULL, 'A', '1614-08-08', 'Texel', NULL, NULL, true, '1616-03-30', 'Ternate', NULL, NULL);
INSERT INTO "voyages" VALUES (186, '', 1, '', 'MEEUWTJE', 'Jan de Wit', 60, 'jacht', '1613', NULL, NULL, 'A', 'A', '1614-08-08', 'Texel', NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (187, '', 1, '', 'MORGENSTER', 'Maarten Pietersz. Kruik', 300, NULL, '1613', NULL, NULL, 'R', 'R', '1614-08-08', 'Goeree', NULL, NULL, true, '1616-03-30', 'Ternate', NULL, NULL);
INSERT INTO "voyages" VALUES (188, '', 1, '', 'GROTE ZON', 'Reinier Jansz.', 600, NULL, NULL, NULL, NULL, NULL, 'A', '1614-08-08', 'Texel', NULL, NULL, true, '1616-03-30', 'Ternate', NULL, 'Maria; July 17th, sea battle of Canate against 8 Spanish ships (2 Spanish ships were sunk); from 08-08 till 21-08, capture of Payta; 11-10 till 18-10 at Acapulco; 24-01 till 27-01-1616 at the Ladrones; 28-02 till 10-03 at Manila Bay. The GROTE ZON was lost in the battle of Manila, 16-04-1617.');
INSERT INTO "voyages" VALUES (189, '', 1, '', 'WITTE BEER', 'Pieter Pietersz.', 300, 'jacht', '1614', NULL, NULL, 'A', 'A', '1614-12-17', 'Texel', '1615-04-14', '1615-04-29', true, '1615-12-02', 'Bantam', 5111, 'From 08-01 till 22-01-1615 at Maio Island.');
INSERT INTO "voyages" VALUES (190, '', 1, '', 'ZWARTE BEER', 'Adriaan Jansz. Pater', 320, 'jacht', NULL, NULL, NULL, 'A', 'A', '1614-12-17', 'Texel', '1615-04-14', '1615-04-29', true, '1615-08-17', 'Pulicat', 5115, 'From 08-01 till 22-01-1615 at Maio Island.');
INSERT INTO "voyages" VALUES (191, '', 1, '', 'DOLFIJN', 'David Willemsz. van Vlissingen', 280, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1615-04-05', 'Wielingen', NULL, NULL, true, '1616-03-01', 'Bantam', 5114, 'in the Bay of Antongil.');
INSERT INTO "voyages" VALUES (192, '', 3, '', 'TER VEERE', 'Willem Jakobsz. van Arnemuiden', 700, NULL, NULL, NULL, NULL, 'Z', 'Z', '1615-04-05', 'Wielingen', NULL, NULL, true, '1616-01-05', 'Bantam', NULL, 'Burnt in the battle of Manila 16-04-1617.');
INSERT INTO "voyages" VALUES (193, '', 1, '', 'BERGERBOOT', 'Floris Heeresz.', 280, 'jacht', NULL, NULL, NULL, NULL, 'A', '1615-05-18', 'Texel', NULL, NULL, true, '1616-04-30', 'Bantam', NULL, 'Reprovisioned at Cabo de Lopez Gonsalvez 20-09-1615; laid up in Batavia, 1621.');
INSERT INTO "voyages" VALUES (194, '', 1, '', 'GALIASSE', 'Theunis Florisz.', 280, NULL, NULL, NULL, NULL, 'H', 'H', '1615-05-18', 'Texel', NULL, NULL, true, '1616-04-30', 'Bantam', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (195, '', 3, '', 'ZWARTE LEEUW', 'Kornelis Klaasz.', 600, NULL, NULL, NULL, NULL, NULL, 'A', '1615-05-18', 'Texel', NULL, NULL, true, '1616-04-30', 'Bantam', NULL, 'Captured by the English near Bantam, 15-12-1618.');
INSERT INTO "voyages" VALUES (196, '', 1, '', 'EENDRACHT', 'Willem Kornelisz. Schouten', 360, NULL, NULL, NULL, NULL, NULL, NULL, '1615-06-14', 'Texel', NULL, NULL, true, '1616-09-17', 'Ternate', NULL, 'was confiscated by the V.O.C.');
INSERT INTO "voyages" VALUES (197, '', 1, '', 'HOORN', 'Jan Kornelisz. Schouten', 110, 'jacht', NULL, NULL, NULL, NULL, NULL, '1615-06-14', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Renamed ZUIDER EENDRACHT; capsized off Bantam, May 1620. The HOORN was destroyed by fire in Port Desire, 19-12-1615. Further information see Engelbrecht and Van Herwerden.');
INSERT INTO "voyages" VALUES (198, '', 1, '', 'GOUDEN LEEUW', 'Gheen Huigen Schapenham', 550, NULL, NULL, NULL, NULL, 'R', 'R', '1616-01-21', 'Maas', '1616-09-09', '1616-09-18', true, '1616-11-14', 'Bantam', 5134, 'Maio Island; 28-03 departure from Cabo de Lopez Gonsalvez; from 19-06 till 09-07 at Annabon.');
INSERT INTO "voyages" VALUES (199, '', 1, '', 'WESTFRIESLAND', 'Kornelis Fransz. van der Beets', 800, NULL, '1615', NULL, NULL, 'H', 'H', '1616-01-22', 'Texel', '1616-09-09', '1616-09-18', true, '1616-11-14', 'Bantam', 5119, 'From 21-02 till 04-03 Maio Island; 28-03-1616 departure from Cabo de Lopez Gonsalvez; from 19-06 till 09-07 at Annabon.');
INSERT INTO "voyages" VALUES (200, '', 1, '', 'BANTAM', 'Douwe Anthonisz.', 800, NULL, NULL, NULL, NULL, NULL, 'E', '1616-01-23', 'Texel', NULL, NULL, true, '1616-10-24', 'Bantam', NULL, 'Island; from 27-03 till 11-06 at Cabo de Lopez Gonsalvez; from 18-06 till 29-06 at Annabon. Burnt at Batavia 24-03-1627.');
INSERT INTO "voyages" VALUES (201, '', 1, '', 'EENDRACHT', 'Dirk Hartogs van Amsterdam', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1616-01-23', 'Texel', '1616-08-05', '1616-08-27', true, '1616-12-14', 'Macassar', 5122, 'From 21-02 till 04-03 at Maio Island; from 27-03 till 11-05 at Cape Lopez; landed on the West Coast of Australia (27'' South), October 25th.');
INSERT INTO "voyages" VALUES (202, '', 1, '', 'TROUW', 'Gerrit Douwesz. van Medemblik', 500, NULL, NULL, NULL, NULL, 'A', 'A', '1616-01-23', 'Texel', NULL, NULL, true, '1616-10-19', 'Bantam', NULL, 'Like EENDRACHT at Maio Island and Cape Lopez; from 18-05 till 29-05 at Annabon; August 14th somewhere off the Cape, took Southern passage. The ship stayed in the Indies and was thrown on the beach near Kalongan, 31-12-1624.');
INSERT INTO "voyages" VALUES (203, '', 1, '', 'WAPEN VAN ZEELAND', 'Jakob Pankras van Vlissingen', 700, NULL, NULL, NULL, NULL, 'Z', 'Z', '1616-02-07', 'Wielingen', NULL, NULL, true, '1617-04-09', 'Bantam', 5126, 'Reprovisioned at Annabon; via `Verhagensbaai'' to the Primeira Islands, and back to the `Verhagensbaai.''');
INSERT INTO "voyages" VALUES (204, '', 2, '', 'HERT', 'Jan Kornelisz. Kunst', 280, 'jacht', NULL, NULL, NULL, 'R', 'D', '1616-03-19', 'Goeree', '1616-06-10', '1616-07-03', true, '1616-08-27', 'Bantam', 5116, 'Reprovisioned at the Cape.');
INSERT INTO "voyages" VALUES (205, '', 2, '', 'ORANJEBOOM', 'Pieter Barendsz. van Hoorn', 360, 'jacht', NULL, NULL, NULL, 'H', 'H', '1616-04-23', 'Texel', '1616-10-20', '1616-11-01', true, '1617-04-09', 'Bantam', 5120, 'Mauritius.');
INSERT INTO "voyages" VALUES (206, '', 1, '', 'EENHOORN', NULL, 300, 'jacht', NULL, NULL, NULL, 'A', 'A', '1617-02-26', 'Texel', '1617-07-05', '1617-07-18', true, '1617-10-23', 'Bantam', 5125, NULL);
INSERT INTO "voyages" VALUES (207, '', 1, '', 'GOEDE FORTUIN', 'Albert Kornelisz. Schagen +', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1617-02-26', 'Texel', NULL, NULL, true, '1618-01-07', 'Bantam', 5127, 'Reprovisioned in the St. Lucia Bay.');
INSERT INTO "voyages" VALUES (208, '', 2, '', 'GROENE LEEUW', NULL, 140, 'jacht', NULL, NULL, NULL, 'A', 'A', '1617-02-26', 'Texel', NULL, NULL, true, '1617-10-26', 'Bantam', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (209, '', 1, '', 'POSTPAARD', 'Enkhuizen', 300, 'jacht', NULL, NULL, NULL, 'E', 'E', '1617-02-26', 'Texel', '1617-07-09', NULL, true, '1617-10-07', 'Bantam', 5121, NULL);
INSERT INTO "voyages" VALUES (210, '', 1, '', 'VOSJE', NULL, 80, 'jacht', NULL, NULL, NULL, 'A', 'A', '1617-02-26', 'Texel', '1617-07-11', NULL, true, '1617-10-23', 'Bantam', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (211, '', 1, '', 'ZIERIKZEE', 'Laurens Simonsz.', 800, NULL, NULL, NULL, NULL, 'Z', 'Z', '1617-02-26', 'Wielingen', NULL, NULL, true, '1618-01-07', 'Bantam', 5130, 'in the St. Lucia Bay.');
INSERT INTO "voyages" VALUES (212, '', 2, '', 'WITTE BEER', 'Aris Jansz. Landsman', 300, 'jacht', '1614', NULL, NULL, 'A', 'A', '1617-04-22', 'Texel', '1617-08-10', '1617-08-25', true, '1617-10-22', 'Bantam', 5128, NULL);
INSERT INTO "voyages" VALUES (213, '', 1, '', 'TIJGER', 'Dirk Gerritsz. Krul', 140, 'jacht', NULL, NULL, NULL, 'A', 'A', '1617-04-22', 'Texel', '1617-08-10', '1617-08-25', true, '1617-10-22', 'Bantam', NULL, 'Stayed in the Indies and was wrecked on the shore of China, September 1622.');
INSERT INTO "voyages" VALUES (214, '', 2, '', 'ZWARTE BEER', 'Sijmen Joosten', 320, 'jacht', NULL, NULL, NULL, 'A', 'A', '1617-10-31', 'Texel', '1618-03-14', '1618-03-01', true, '1618-06-22', 'Pondicherry', 5135, NULL);
INSERT INTO "voyages" VALUES (215, '', 2, '', 'DOLFIJN', 'Bruin Anthonisz.', 260, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1617-11-07', 'Wielingen', NULL, NULL, true, '1618-09-20', 'Masulipatna', NULL, 'Stayed in the Indies and, laid up between 1620-1621.');
INSERT INTO "voyages" VALUES (216, '', 1, '', 'TER THOLEN', 'Adriaan de Walle', 400, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1617-11-07', 'Wielingen', NULL, NULL, true, '1618-04-30', 'Bantam', 5129, 'Amsterdam Isl. sighted by the Dutch for the first time.');
INSERT INTO "voyages" VALUES (217, '', 1, '', 'ZEEWOLF', 'Havik Klaasz. van Hillegom', 360, 'jacht', NULL, NULL, NULL, 'A', 'A', '1617-12-02', 'Texel', '1618-03-08', '1618-03-24', true, '1618-07-01', 'Jacatra', NULL, 'April 19th St. Paul sighted by the Dutch for the first time. May 11th on the west coast of Australia. The ship stayed in the Indies.');
INSERT INTO "voyages" VALUES (218, '', 2, '', 'MAURITIUS', 'Leendert Jakobsz.', 800, NULL, '1612', NULL, NULL, 'A', 'A', '1618-01-04', 'Texel', NULL, NULL, true, '1618-08-22', 'Bantam', 5131, 'July 1618 on the west coast of Australia (Eendrachtsland, 22'' South).');
INSERT INTO "voyages" VALUES (219, '', 3, '', 'DELFT', 'Jan Kornelisz. Kunst', 800, NULL, NULL, NULL, NULL, 'D', 'D', '1618-04-01', 'Goeree', NULL, NULL, true, '1618-10-13', 'Bantam', 5132, NULL);
INSERT INTO "voyages" VALUES (220, '', 1, '', 'WAPEN VAN HAARLEM', 'Willem Jansz. van Amersfoort', 360, 'jacht', NULL, NULL, NULL, NULL, 'A', '1618-05-04', 'Texel', NULL, NULL, true, NULL, 'Bantam', NULL, 'the KLEIN AMSTER-DAM. The ship stayed in the Indies and was laid up between 31-10-1627 and 31-10-1628.');
INSERT INTO "voyages" VALUES (221, '', 3, '', 'HERT', 'Quinten Pietersz. Wiltvank', 280, 'jacht', NULL, NULL, NULL, 'R', 'R', '1618-06-01', 'Goeree', NULL, NULL, true, '1619-01-16', 'Bantam', NULL, 'Stayed in the Indies; wrecked on the African coast 21-06-1622.');
INSERT INTO "voyages" VALUES (222, '', 2, '', 'WESTFRIESLAND', 'Abbe Willemsz.', 800, NULL, '1615', NULL, NULL, 'H', 'Z', '1618-12-05', 'Wielingen', NULL, NULL, true, '1619-09-13', 'Jacatra', 5138, 'it NASSAU.');
INSERT INTO "voyages" VALUES (223, '', 1, '', 'DORDRECHT', 'Reinier Jansz.', 800, NULL, NULL, NULL, NULL, NULL, 'A', '1618-12-28', 'Texel', '1619-05-17', '1619-06-08', true, '1619-09-03', 'Bantam', 5136, 'Fleet (0223-0232) under command of Frederik de Houtman aboard the DORDRECHT and Jakob Dedel. T otal number of those on board: seamen 1725; soldiers 675.');
INSERT INTO "voyages" VALUES (224, '', 2, '', 'EENHOORN', 'Klaas Egbertsz.', 300, 'jacht', NULL, NULL, NULL, 'A', 'A', '1618-12-28', 'Texel', '1619-04-01', '1619-04-30', true, '1619-07-06', 'Bantam', 5133, '19th, the DORDRECHT struck upon the west coast of Australia (32''20'' South).');
INSERT INTO "voyages" VALUES (225, '', 2, '', 'ENKHUIZEN', NULL, 500, NULL, NULL, NULL, NULL, NULL, 'E', '1618-12-28', 'Texel', NULL, NULL, false, NULL, 'Coromandel', NULL, 'From 25-02 till 02-03 at Brava Island. The ship stayed in the Indies.');
INSERT INTO "voyages" VALUES (226, '', 1, '', 'HOORN', 'Willem Usbrand Bontekoe', 700, NULL, NULL, NULL, NULL, 'H', 'H', '1618-12-28', 'Texel', NULL, NULL, false, NULL, NULL, NULL, 'west of Sumatra the ship caught fire and was blown up; on 14-12-1619 the sloop of the HOORN arrived with the survivors at Bantam.');
INSERT INTO "voyages" VALUES (227, '', 1, '', 'GOEDE HOOP', 'Jan van der Venne', 600, 'jacht', NULL, NULL, NULL, 'A', 'A', '1618-12-28', 'Texel', '1619-11-19', '1619-11-26', true, '1620-02-09', 'Jacatra', NULL, 'Forced by heavy weather in the Bay of Biscay the GOEDE HOOP returned to Zeeland and departed again 13-05-1619; from 14-08 till 21-08 at Cape Lopez.');
INSERT INTO "voyages" VALUES (228, '', 2, '', 'POSTPAARD', 'Jan Jansz. Rood', 300, 'jacht', NULL, NULL, NULL, 'E', 'A', '1618-12-28', 'Texel', NULL, NULL, true, '1619-09-19', 'Jacatra', NULL, 'Stayed in the Indies and laid up in 1623.');
INSERT INTO "voyages" VALUES (229, '', 2, '', 'ZEELANDIA', 'Jan van Meldert', 800, NULL, NULL, NULL, NULL, 'Z', 'A', '1618-12-28', 'Wielingen', NULL, NULL, false, '1619-09-16', 'Jacatra', NULL, 'From 07-01 till 26-01 at Plymouth, where 3 man deserted; from 25-02 till 02-03 at Bravo Island; from 03-07 till 17-07 near St. Maria (Madagascar). The ship stayed in the Indies and was wrecked on the Westcoast of Sumatra. Also mentioned as NIEUW ZEELAND.');
INSERT INTO "voyages" VALUES (230, '', 3, '', 'ORANJEBOOM', NULL, 360, 'jacht', NULL, NULL, NULL, 'H', 'R', '1619-01-25', 'Goeree', '1619-04-01', '1619-04-30', true, '1619-08-07', 'Jacatra', 5137, NULL);
INSERT INTO "voyages" VALUES (231, '', 1, '', 'AMSTERDAM', 'Maarten Kornelisz.', 800, NULL, NULL, NULL, NULL, 'A', 'A', '1619-01-27', 'Texel', '1619-05-20', '1619-06-08', true, '1619-09-03', 'Bantam', NULL, 'June 19th on the west coast of Australia (37''20'' South); the ship stayed in the Indies.');
INSERT INTO "voyages" VALUES (232, '', 2, '', 'WAPEN VAN ZEELAND', 'Pieter Barendsz.', 700, NULL, NULL, NULL, NULL, 'Z', 'Z', '1619-01-27', 'Wielingen', NULL, NULL, true, '1619-08-07', 'Bantam', NULL, 'Stayed in the Indies and laid up in Surat 1626/1627.');
INSERT INTO "voyages" VALUES (233, '', 3, '', 'WITTE BEER', 'Klaas Warebouts', 300, 'jacht', '1614', NULL, NULL, 'A', 'A', '1619-05-13', 'Texel', NULL, NULL, true, '1620-01-28', 'Bantam', 5139, 'From 20-08 till 01-09 at Cape Lopez; from 08-02 till 11-02 at Annabon.');
INSERT INTO "voyages" VALUES (234, '', 2, '', 'EENDRACHT', NULL, 700, NULL, NULL, NULL, NULL, 'A', 'A', '1619-05-13', 'Texel', '1619-11-19', '1619-11-26', true, '1620-03-22', 'Jacatra', NULL, 'From 14-08 till 21-08 at Cape Lopez. The ship stayed in the Indies and was wrecked on the west coast of Ambon, 13-05-1622.');
INSERT INTO "voyages" VALUES (235, '', 2, '', 'GOEDE FORTUIN', 'Jan Gijsbertsz. Booneter', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1619-05-13', 'Texel', '1620-01-05', '1620-02-25', true, '1620-07-27', 'Jacatra', NULL, 'From 02-10 till 11-10 at Cape Lopez; February 5th with the GOUDEN LEEUW to the `Dasseneiland'' and St. Helena; from 15-02 till 25-02 at St. Helena. The ship stayed in the Indies and was lost near Sucatara; crew and cargo were saved.');
INSERT INTO "voyages" VALUES (236, '', 2, '', 'TER THOLEN', 'Adriaan de Walle', 400, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1619-05-16', 'Wielingen', NULL, NULL, true, '1619-11-20', 'Bantam', 5166, NULL);
INSERT INTO "voyages" VALUES (237, '', 2, '', 'WALCHEREN', 'Adriaan Boei', 500, NULL, '1612', NULL, NULL, 'Z', 'Z', '1619-05-16', 'Wielingen', NULL, NULL, true, '1619-12-01', 'Bantam', 5141, 'Forced to return to Zeeland, 11 -06-1619, but sailed again shortly afterwards.');
INSERT INTO "voyages" VALUES (238, '', 1, '', 'VREDE', NULL, 340, 'jacht', NULL, NULL, NULL, 'A', 'A', '1619-09-14', 'Texel', NULL, NULL, true, '1620-06-03', 'Bantam', 5140, NULL);
INSERT INTO "voyages" VALUES (239, '', 1, '', 'WAPEN VAN ENKHUIZEN', 'Jan Jansz.', 700, NULL, '1619', NULL, NULL, 'E', 'E', '1619-12-26', 'Texel', '1620-06-05', '1620-07-05', true, '1620-09-16', 'Jacatra', 5146, NULL);
INSERT INTO "voyages" VALUES (240, '', 1, '', 'HOLLANDIA', 'IJsbrand Kornelisz.', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1619-12-26', 'Texel', '1620-05-06', '1620-07-05', true, '1620-12-08', 'Jacatra', 5147, 'Fleet (0237-0250) under command of Nikolaas van Baecum aboard the HOLLANDIA and vice-admiraal Kornelis Reiniersz. aboard the ZIERIKZEE.');
INSERT INTO "voyages" VALUES (241, '', 1, '', 'LEIDEN', 'Willem Kornelisz. Schouten', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1619-12-26', 'Texel', '1620-06-01', '1620-07-05', true, '1620-12-15', 'Jacatra', 5144, NULL);
INSERT INTO "voyages" VALUES (242, '', 1, '', 'MEDEMBLIK', NULL, 300, 'jacht', NULL, NULL, NULL, NULL, 'H', '1619-12-26', 'Texel', '1620-06-01', '1620-07-05', true, '1620-09-11', 'Jacatra', 5145, NULL);
INSERT INTO "voyages" VALUES (243, '', 1, '', 'WAPEN VAN HOORN', 'Roelof Pietersz.', 400, 'fluit', '1619', NULL, NULL, 'H', 'H', '1619-12-27', 'Texel', '1620-06-01', '1620-07-05', true, '1620-12-08', 'Jacatra', 5142, NULL);
INSERT INTO "voyages" VALUES (244, '', 1, '', 'SCHOONHOVEN', 'Simon Jansz.', 400, 'jacht', NULL, NULL, NULL, 'A', 'A', '1619-12-27', 'Texel', '1620-06-01', '1620-07-05', true, '1620-12-14', 'Negapatnam', 5153, NULL);
INSERT INTO "voyages" VALUES (245, '', 3, '', 'MAURITIUS', 'Leendert Thomasz.', 800, NULL, '1612', NULL, NULL, 'A', 'A', '1619-12-28', 'Texel', '1620-06-01', '1620-07-05', true, '1620-12-08', 'Jacatra', 5143, NULL);
INSERT INTO "voyages" VALUES (246, '', 2, '', 'ZIERIKZEE', 'Mathijs Albertsz. Balk', 800, NULL, NULL, NULL, NULL, 'Z', 'Z', '1619-12-28', 'Wielingen', '1620-05-01', '1620-07-05', true, '1620-12-16', 'Jacatra', NULL, 'Stayed in the Indies. According to Coolhaas only good enough for the island waterways.');
INSERT INTO "voyages" VALUES (247, '', 1, '', 'GRONINGEN', 'Tobias Adriaansz.', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1620-01-01', 'Texel', '1620-06-01', '1620-07-05', true, '1620-11-25', 'Jacatra', NULL, 'Lost on a return voyage from Siam or Japan, 1627.');
INSERT INTO "voyages" VALUES (248, '', 1, '', 'WIDEN', NULL, 160, 'jacht', NULL, NULL, NULL, 'A', 'A', '1620-02-27', 'Texel', '1620-12-01', '1620-12-31', true, '1621-02-26', 'Jacatra', NULL, 'of China, 1623.');
INSERT INTO "voyages" VALUES (249, '', 1, '', 'SCHIEDAM', 'Jan Kornelisz. Kunst', 360, NULL, NULL, NULL, NULL, 'D', 'D', '1620-04-08', 'Goeree', NULL, NULL, true, '1620-10-11', 'Jacatra', 5161, NULL);
INSERT INTO "voyages" VALUES (250, '', 1, '', 'WEESP', NULL, 160, NULL, NULL, NULL, NULL, 'A', 'A', '1620-04-10', 'Texel', '1620-12-01', '1620-12-31', true, '1621-02-26', 'Jacatra', 5172, 'Reprovisioned at Annabon.');
INSERT INTO "voyages" VALUES (251, '', 4, '', 'DELFT', NULL, 800, NULL, NULL, NULL, NULL, 'D', 'R', '1620-04-23', 'Goeree', '1620-08-01', '1620-08-31', true, '1620-12-26', 'Jacatra', NULL, NULL);
INSERT INTO "voyages" VALUES (252, '', 1, '', 'ORANJE', NULL, 360, NULL, NULL, NULL, NULL, 'R', 'R', '1620-04-23', 'Goeree', '1620-08-01', '1620-08-31', true, '1620-12-26', 'Jacatra', NULL, NULL);
INSERT INTO "voyages" VALUES (253, '', 1, '', 'NOORD-HOLLAND', NULL, 600, NULL, NULL, NULL, NULL, 'A', 'A', '1620-05-10', 'Texel', '1620-12-01', NULL, true, '1621-05-27', 'Jacatra', NULL, 'Reprovisioned at Annabon. The ship stayed in the Indies and was laid up in Surat, between 31-10-1627 and 31-10-1628.');
INSERT INTO "voyages" VALUES (254, '', 1, '', 'ZUID-HOLLAND', 'Meeuwis Sandersz.', 600, NULL, NULL, NULL, NULL, 'A', 'A', '1620-05-10', 'Texel', NULL, NULL, true, '1621-05-27', 'Jacatra', NULL, 'Stayed in the Indies and laid up after 1627.');
INSERT INTO "voyages" VALUES (255, '', 1, '', 'BRUINVIS', NULL, 50, 'jacht', NULL, NULL, NULL, 'A', 'A', '1620-05-24', 'Texel', '1620-12-01', NULL, true, NULL, 'Batavia', NULL, 'Stayed in the Indies and wrecked in the river Andragiry, September 1622.');
INSERT INTO "voyages" VALUES (256, '', 3, '', 'EENHOORN', NULL, 300, 'jacht', NULL, NULL, NULL, 'A', 'A', '1620-05-24', 'Texel', '1620-12-01', NULL, true, '1621-02-22', 'Amboina', NULL, 'Stayed in the Indies and probably laid up.');
INSERT INTO "voyages" VALUES (257, '', 1, '', 'HEILBOT', NULL, 100, 'jacht', NULL, NULL, NULL, 'A', 'A', '1620-05-24', 'Texel', '1620-12-01', NULL, true, '1621-03-22', 'Amboina', NULL, 'Stayed in the Indies and lost between Amboina and Batavia, 1621.');
INSERT INTO "voyages" VALUES (258, '', 1, '', 'MIDDELBURG', 'Willem Jakobsz. van Arnemuiden', 700, NULL, '1619', NULL, NULL, 'Z', 'Z', '1620-05-25', 'Wielingen', NULL, NULL, true, '1621-02-11', 'Jacatra', 5148, NULL);
INSERT INTO "voyages" VALUES (259, '', 1, '', 'PURMEREND', NULL, 200, 'jacht', NULL, NULL, NULL, 'H', 'H', '1620-05-25', 'Texel', NULL, NULL, true, '1621-06-07', 'Jacatra', NULL, 'Stayed in the Indies and probably laid up.');
INSERT INTO "voyages" VALUES (260, '', 1, '', 'ALKMAAR', NULL, 600, NULL, '1619', NULL, NULL, 'E', 'E', '1620-06-02', 'Texel', NULL, NULL, true, '1621-06-24', 'Jacatra', 5156, NULL);
INSERT INTO "voyages" VALUES (261, '', 1, '', 'HARING', NULL, 180, NULL, NULL, NULL, NULL, 'E', 'E', '1620-12-27', 'Texel', '1621-05-20', NULL, true, '1621-08-31', 'Jacatra', NULL, 'Departure from S. Vincente 31-01-1621. The ship stayed in the Indies and ran ashore near Arakan, 1628.');
INSERT INTO "voyages" VALUES (262, '', 3, '', 'ZWARTE BEER', NULL, 320, 'jacht', NULL, NULL, NULL, 'A', 'A', '1620-12-28', 'Texel', '1621-05-21', NULL, true, '1621-08-20', 'Jacatra', NULL, 'Departure from Plymouth 31-01-1621; from 05-03 till 20-03 at S. Vincente. The ship stayed in the Indies.');
INSERT INTO "voyages" VALUES (263, '', 1, '', 'WAPEN VAN DELFT', 'Jan Klaasebol van Delfshaven', 700, NULL, '1620', NULL, NULL, 'D', 'D', '1620-12-28', 'Goeree', NULL, NULL, true, '1621-08-03', 'Jacatra', 5164, NULL);
INSERT INTO "voyages" VALUES (264, '', 1, '', 'GOUDA', 'Gerard Douwesz.', 800, NULL, NULL, NULL, NULL, 'A', 'A', '1620-12-28', 'Texel', '1621-05-20', NULL, true, '1621-08-31', 'Jacatra', 5150, 'Vincente 31-01-1621.');
INSERT INTO "voyages" VALUES (265, '', 1, '', 'HAZEWIND', NULL, 120, 'jacht', NULL, NULL, NULL, 'E', 'H', '1620-12-28', 'Texel', '1621-06-04', NULL, true, '1621-09-17', 'Jacatra', NULL, 'Via Plymouth; from 10-03 till 24-03 at S. Vincente. The ship stayed in the Indies and was broken up in Batavia between 31-10-1627 and 31-10-1628.');
INSERT INTO "voyages" VALUES (266, '', 1, '', 'NAARDEN', NULL, 180, 'jacht', NULL, NULL, NULL, 'A', 'A', '1620-12-28', 'Texel', NULL, NULL, true, '1621-06-24', 'Pulicat', 5149, NULL);
INSERT INTO "voyages" VALUES (267, '', 2, '', 'DORDRECHT', NULL, 600, NULL, NULL, NULL, NULL, NULL, 'A', '1620-12-29', 'Texel', NULL, NULL, true, '1621-06-24', 'Pulicat', 5155, NULL);
INSERT INTO "voyages" VALUES (268, '', 1, '', 'HAAN', NULL, 150, 'jacht', NULL, NULL, NULL, 'A', 'A', '1620-12-31', 'Texel', '1621-06-04', NULL, true, '1621-08-23', 'Jacatra', NULL, 'Departure from Plymouth 31-01-1621; from 10-03 till 24-03 at S. Vincente. The ship stayed in the Indies and was lost, according to Mac Leod, near China according to K.A. 1007 near Batavia, 20-05-1628.');
INSERT INTO "voyages" VALUES (269, '', 1, '', 'VALK', NULL, 120, 'jacht', NULL, NULL, NULL, 'A', 'A', '1620-12-31', 'Texel', '1621-06-04', NULL, true, '1621-08-23', 'Jacatra', NULL, '24-03 at S. Vincente. The ship stayed in the Indies and was wrecked near Formosa, 19-07-1623.');
INSERT INTO "voyages" VALUES (270, '', 3, '', 'WESTFRIESLAND', 'Jakob Pankras', 800, NULL, '1615', NULL, NULL, 'H', 'Z', '1621-02-11', 'Wielingen', NULL, NULL, true, '1621-10-13', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (271, '', 1, '', 'ARNEMUIDEN', 'Jan Dirksz.', 180, NULL, '1620', NULL, NULL, 'Z', 'Z', '1621-03-19', 'Wielingen', NULL, NULL, true, '1621-09-29', 'Batavia', NULL, 'Stayed in the Indies and broken up, 1629.');
INSERT INTO "voyages" VALUES (272, '', 4, '', 'ORANJEBOOM', 'Adriaan Huigensz.', 360, 'jacht', NULL, NULL, NULL, 'H', 'Z', '1621-03-19', 'Wielingen', NULL, NULL, true, '1621-09-16', 'Batavia', 5152, NULL);
INSERT INTO "voyages" VALUES (273, '', 1, '', 'WESTKAPELLE', 'Reinier Jansz.', 60, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1621-03-19', 'Wielingen', NULL, NULL, true, '1621-09-05', 'Batavia', NULL, 'Stayed in the Indies; captured by the Chinese I Kwan in 1627, but returned in 1628 and laid up in 1629.');
INSERT INTO "voyages" VALUES (274, '', 2, '', 'GOUDEN LEEUW', 'Pieter Kornelisz. van Rotterdam', 550, NULL, NULL, NULL, NULL, 'R', 'R', '1621-04-19', 'Goeree', NULL, NULL, true, '1621-08-23', 'Batavia', 5160, NULL);
INSERT INTO "voyages" VALUES (275, '', 1, '', 'LEEUWIN', NULL, 400, NULL, NULL, NULL, NULL, NULL, 'A', '1621-04-20', 'Texel', NULL, NULL, true, '1622-05-15', 'Batavia', 5154, 'the Gulf of Guinea and the west coast of Australia.');
INSERT INTO "voyages" VALUES (276, '', 4, '', 'BEER', NULL, 300, 'jacht', '1614', NULL, NULL, 'A', 'A', '1621-10-01', 'Texel', NULL, NULL, true, '1622-05-26', 'Pulicat', NULL, 'Stayed in the Indies and broken up in Batavia between 31-10-1627 and 31-10-1628.');
INSERT INTO "voyages" VALUES (277, '', 2, '', 'VREDE', NULL, 340, 'jacht', NULL, NULL, NULL, 'A', 'A', '1621-10-01', 'Texel', '1622-01-24', NULL, true, '1622-05-26', 'Pulicat', NULL, 'aboard the SCHOONHOVEN. The VREDE stayed in the Indies and was wrecked near Hirado, September 1631.');
INSERT INTO "voyages" VALUES (278, '', 1, '', 'WAPEN VAN ROTTERDAM', NULL, 700, NULL, '1621', NULL, NULL, 'R', 'R', '1621-11-09', 'Goeree', '1622-06-13', NULL, true, NULL, 'Batavia', 5180, 'Driven out of course when hunting a Portuguese carrack.');
INSERT INTO "voyages" VALUES (279, '', 1, '', 'DELFSHAVEN', 'Jakob Jansz. van Delfshaven', 400, 'jacht', '1621', NULL, NULL, 'D', 'D', '1621-12-16', 'Goeree', NULL, NULL, true, '1622-06-06', 'Batavia', 5179, NULL);
INSERT INTO "voyages" VALUES (280, '', 1, '', 'GORKUM', NULL, 300, 'fluit', NULL, NULL, NULL, 'A', 'A', '1621-12-22', 'Texel', NULL, NULL, true, '1622-06-03', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (281, '', 1, '', 'HEUSDEN', NULL, 250, 'jacht', NULL, NULL, NULL, 'A', 'A', '1621-12-22', 'Texel', '1622-03-30', NULL, true, '1622-06-14', 'Batavia', 5163, NULL);
INSERT INTO "voyages" VALUES (282, '', 4, '', 'MAURITIUS', NULL, 800, NULL, '1612', NULL, NULL, 'A', 'A', '1621-12-22', 'Texel', '1622-06-13', NULL, true, '1622-10-01', 'Batavia', 5158, 'course while pursuing a Portuguese carrack.');
INSERT INTO "voyages" VALUES (283, '', 3, '', 'WALCHEREN', 'Abraham Boei', 500, NULL, '1612', NULL, NULL, 'Z', 'Z', '1621-12-22', 'Wielingen', NULL, NULL, true, '1622-05-27', 'Batavia', 5159, NULL);
INSERT INTO "voyages" VALUES (284, '', 1, '', 'WOERDEN', NULL, 250, NULL, NULL, NULL, NULL, 'A', 'A', '1621-12-22', 'Texel', NULL, NULL, true, '1622-06-16', 'Batavia', NULL, 'Stayed in the Indies and lost north of Formosa, 1630.');
INSERT INTO "voyages" VALUES (285, '', 1, '', 'EDAM', NULL, 300, 'fluit', NULL, NULL, NULL, 'H', 'H', '1621-12-26', 'Texel', NULL, NULL, true, '1622-08-14', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (286, '', 2, '', 'WAPEN VAN HOORN', NULL, 400, 'fluit', '1619', NULL, NULL, 'H', 'H', '1621-12-26', 'Texel', NULL, NULL, true, '1622-07-22', 'Batavia', 5175, NULL);
INSERT INTO "voyages" VALUES (287, '', 1, '', 'MONNIKENDAM', NULL, 300, 'fluit', NULL, NULL, NULL, 'E', 'E', '1621-12-26', 'Texel', NULL, NULL, true, '1622-07-11', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (288, '', 1, '', 'KLEINE ERASMUS', NULL, 240, NULL, NULL, NULL, NULL, NULL, 'R', '1622-04-22', 'Goeree', '1622-11-01', NULL, true, '1623-01-20', 'Batavia', NULL, 'Stayed in the Indies and lost in Japan, 1634.');
INSERT INTO "voyages" VALUES (289, '', 1, '', 'MAKREEL', NULL, 300, 'fluit', NULL, NULL, NULL, 'E', 'E', '1622-12-17', 'Texel', NULL, NULL, true, '1623-06-20', 'Batavia', NULL, 'Batavia between 31-10-1627 and 31-10 1628.');
INSERT INTO "voyages" VALUES (290, '', 2, '', 'MIDDELBURG', 'Jan Willemsz. Dik', 700, NULL, '1619', NULL, NULL, 'Z', 'Z', '1622-12-17', 'Wielingen', NULL, NULL, true, '1623-08-16', 'Batavia', 5170, NULL);
INSERT INTO "voyages" VALUES (291, '', 2, '', 'WAPEN VAN ENKHUIZEN', NULL, 700, NULL, '1619', NULL, NULL, 'E', 'E', '1623-01-20', 'Texel', '1623-05-04', NULL, true, '1623-08-16', 'Batavia', 5181, '21-07 on the west coast of Australia (27'').');
INSERT INTO "voyages" VALUES (292, '', 2, '', 'LEIDEN', 'Klaas Hermansz.', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1623-01-20', 'Texel', '1623-04-27', '1623-05-21', true, '1623-08-25', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (293, '', 2, '', 'MEDEMBLIK', NULL, 300, 'jacht', NULL, NULL, NULL, NULL, 'H', '1623-01-20', 'Texel', '1623-04-28', NULL, true, '1623-09-19', 'Coromandel', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (294, '', 2, '', 'NAARDEN', NULL, 180, 'jacht', NULL, NULL, NULL, 'A', NULL, '1623-01-20', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked near Boa Vista, 1623. Its destination was Surat.');
INSERT INTO "voyages" VALUES (295, '', 2, '', 'SCHOONHOVEN', 'Dirk Evertsz.', 400, 'jacht', NULL, NULL, NULL, 'A', 'A', '1623-01-20', 'Texel', '1623-05-04', NULL, true, '1623-10-02', 'Surat', 5167, NULL);
INSERT INTO "voyages" VALUES (296, '', 1, '', 'ORANJE', 'Laurens Jansz. Crijne', 700, NULL, NULL, NULL, NULL, 'R', 'Z', '1623-04-19', 'Wielingen', NULL, NULL, true, '1625-09-04', 'Batavia', 5185, 'Strait Le Maire. Further information, see Voorbeijtel Cannenburg. According to this author the master of the ORANJE was called Laurens Jansz. Quirijnen.');
INSERT INTO "voyages" VALUES (297, '', 1, '', 'HAAS', NULL, 120, 'jacht', NULL, NULL, NULL, 'A', 'A', '1623-04-27', 'Texel', NULL, NULL, true, '1623-09-07', 'Batavia', 5162, NULL);
INSERT INTO "voyages" VALUES (298, '', 1, '', 'AMSTERDAM', 'Leendert Jakobsz. Stolk', 800, NULL, NULL, NULL, NULL, NULL, 'A', '1623-04-29', 'Goeree', NULL, NULL, true, '1625-08-29', 'Batavia', 5177, 'WAPEN VAN AMSTERDAM.');
INSERT INTO "voyages" VALUES (299, '', 1, '', 'AREND', 'Meindert Egbertsz. +', 400, 'jacht', NULL, '1622', NULL, 'A', 'A', '1623-04-29', 'Goeree', NULL, NULL, true, '1625-08-29', 'Batavia', NULL, 'Pieter Kornelsz. Hartloop succeeded, on September 9th 1624, Meindert Egbertsz., who died 28-08-1624, as master of the AREND. The AREND was sold to the V.O.C. and lost near Cape Mauritius.');
INSERT INTO "voyages" VALUES (300, '', 1, '', 'KONING DAVID', 'Jan Thomasz.', 360, 'jacht', NULL, NULL, NULL, 'H', 'H', '1623-04-29', 'Goeree', NULL, NULL, true, '1625-08-29', 'Batavia', 5176, NULL);
INSERT INTO "voyages" VALUES (301, '', 1, '', 'DELFT', 'Witte Kornelisz. de With', 800, NULL, NULL, NULL, NULL, 'D', 'A', '1623-04-29', 'Goeree', NULL, NULL, true, '1625-08-29', 'Batavia', 5178, NULL);
INSERT INTO "voyages" VALUES (302, '', 1, '', 'EENDRACHT', 'Jan IJsbrandsz.', 600, NULL, NULL, NULL, NULL, 'A', 'E', '1623-04-29', 'Goeree', NULL, NULL, true, '1625-09-13', 'Batavia', 5174, NULL);
INSERT INTO "voyages" VALUES (303, '', 1, '', 'GRIFFIOEN', 'Pieter Kornelisz. Hartloop', 320, 'jacht', NULL, NULL, NULL, 'H', 'H', '1623-04-29', 'Goeree', NULL, NULL, true, '1625-08-29', 'Batavia', NULL, 'the V.O.C. and was lost near the Moluccas.');
INSERT INTO "voyages" VALUES (304, '', 1, '', 'HAZEWIND', 'Salomon Willemsz.', 60, 'jacht', NULL, NULL, NULL, 'E', 'A', '1623-04-29', 'Goeree', NULL, NULL, true, NULL, NULL, NULL, 'Also mentioned as WINDHOND, according to Voorbeijtel Cannenburg. Salomon Willemsz. became master of the Hoop, 01-09 1623. June 1623 the ship was sent back to Holland, escorting 25 captured Spanish ships.');
INSERT INTO "voyages" VALUES (305, '', 1, '', 'HOLLANDIA', 'Adriaan Tol', 600, NULL, NULL, NULL, NULL, 'A', 'R', '1623-04-29', 'Goeree', NULL, NULL, true, '1625-08-29', 'Batavia', 5191, NULL);
INSERT INTO "voyages" VALUES (306, '', 1, '', 'HOOP', 'Pieter Harmensz. Slobbe', 260, 'jacht', NULL, '1623', NULL, 'A', 'R', '1623-04-29', 'Goeree', NULL, NULL, true, '1625-08-29', 'Batavia', NULL, 'Pieter Harmensz. Slobbe who became master of the MAURI-TIUS, September 1th 1623, was succeeded by Salomon Willemsz. The ship was sold to the V.O.C. and stayed in the Indies.');
INSERT INTO "voyages" VALUES (307, '', 1, '', 'MAURITIUS', 'Jakob Adriaansz. van Duin', 560, NULL, NULL, '1623', NULL, NULL, 'R', '1623-04-29', 'Goeree', NULL, NULL, true, '1625-09-04', 'Batavia', NULL, 'Jakob Adriaansz. van Duin, who died 28-08-1623 in Sierra Leone, was succeeded by Pieter Harmensz. Slobbe, 01-09-1623. The ship was sold to the V.O.C.');
INSERT INTO "voyages" VALUES (308, '', 1, '', 'TORTELDUIF', NULL, 80, 'jacht', NULL, NULL, NULL, 'A', 'A', '1623-11-16', 'Texel', NULL, NULL, true, '1624-06-21', 'Batavia', NULL, 'Indies and was laid up in Batavia between 31-10-1627 and 31-10-1628.');
INSERT INTO "voyages" VALUES (309, '', 3, '', 'DORDRECHT', NULL, 600, NULL, NULL, NULL, NULL, NULL, 'A', '1624-01-08', 'Texel', '1624-05-11', NULL, true, '1624-09-15', 'Surat', 5171, NULL);
INSERT INTO "voyages" VALUES (310, '', 2, '', 'GOUDA', NULL, 800, NULL, NULL, NULL, NULL, 'A', 'A', '1624-01-08', 'Texel', '1624-04-01', NULL, true, '1624-07-17', 'Batavia', 5168, NULL);
INSERT INTO "voyages" VALUES (311, '', 2, '', 'HOLLANDIA', NULL, 700, NULL, NULL, NULL, NULL, 'A', 'A', '1624-01-08', 'Texel', '1624-04-01', NULL, true, '1624-07-16', 'Batavia', 5169, NULL);
INSERT INTO "voyages" VALUES (312, '', 2, '', 'LEEUWIN', NULL, 500, NULL, NULL, NULL, NULL, NULL, 'A', '1624-01-08', 'Texel', '1624-05-11', NULL, true, '1624-08-04', 'Pulicat', 5173, NULL);
INSERT INTO "voyages" VALUES (313, '', 2, '', 'HAAS', NULL, 120, 'jacht', NULL, NULL, NULL, 'A', 'A', '1624-12-10', 'Texel', NULL, NULL, true, '1625-06-06', 'Batavia', NULL, 'The ship stayed in the Indies. According to Daghregister departure from the Maas, 31-12-1624.');
INSERT INTO "voyages" VALUES (314, '', 2, '', 'DELFSHAVEN', 'Jakob Pietersz. Hein', 400, 'jacht', '1621', NULL, NULL, 'D', 'D', '1625-01-04', 'Goeree', '1625-07-05', NULL, true, '1625-09-09', 'Pulicat', 5179, 'From 05-01 till 17-03-1625 in Vlissingen. T otal number of deaths: 3.');
INSERT INTO "voyages" VALUES (315, '', 2, '', 'HEUSDEN', NULL, 250, 'jacht', NULL, NULL, NULL, 'A', 'A', '1625-01-04', 'Texel', NULL, NULL, true, '1625-10-02', 'Surat', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (316, '', 1, '', 'KAMEEL', 'Reinier Saecq', 500, NULL, NULL, NULL, NULL, 'A', 'A', '1625-01-04', 'Texel', '1625-06-01', '1625-07-10', true, '1625-09-19', 'Batavia', NULL, 'Stayed in the Indies and was lost on `Boompjes-eiland'', 17-02-1630.');
INSERT INTO "voyages" VALUES (317, '', 3, '', 'GOUDEN LEEUW', NULL, 550, NULL, NULL, NULL, NULL, 'R', 'A', '1625-01-04', 'Texel', NULL, NULL, true, '1625-10-02', 'Surat', 5184, NULL);
INSERT INTO "voyages" VALUES (318, '', 5, '', 'MAURITIUS', 'Reinier Pels', 800, NULL, '1612', NULL, NULL, 'A', 'Z', '1625-01-04', 'Wielingen', '1625-06-01', '1625-07-10', true, '1625-10-03', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (319, '', 4, '', 'WALCHEREN', 'Pankras Anthonisz.', 500, NULL, '1612', NULL, NULL, 'Z', 'Z', '1625-01-04', 'Wielingen', NULL, NULL, true, '1625-10-03', 'Surat', 5186, NULL);
INSERT INTO "voyages" VALUES (320, '', 3, '', 'LEIDEN', 'Jansz. de Kok', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1625-05-17', 'Zeeland', '1626-01-31', '1626-02-13', true, '1626-05-30', 'Batavia', 5182, 'Tome.');
INSERT INTO "voyages" VALUES (321, '', 2, '', 'SCHIEDAM', 'Hendrik Spiering', 360, NULL, NULL, NULL, NULL, 'D', 'A', '1625-05-17', 'Texel', NULL, NULL, true, '1626-02-13', 'Batavia', 5187, 'Because of a storm, the SCHIEDAM missed the Cape, and took on provisions for several weeks at St. Mary Island.');
INSERT INTO "voyages" VALUES (322, '', 3, '', 'TER THOLEN', 'Mathijs Bale', 400, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1625-05-17', 'Wielingen', '1625-10-01', NULL, true, '1625-12-27', 'Batavia', 5183, NULL);
INSERT INTO "voyages" VALUES (323, '', 2, '', 'ALKMAAR', NULL, 600, NULL, '1619', NULL, NULL, 'E', 'E', '1625-07-05', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked on the roadstead of Texel, 05-07-1625.');
INSERT INTO "voyages" VALUES (324, '', 3, '', 'SCHOONHOVEN', 'Kornelis Hartman', 400, 'jacht', NULL, NULL, NULL, 'A', 'A', '1625-12-20', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked on the coast of Portugal, 22-01-1626, 198 men were taken prisoner in Lisbon.');
INSERT INTO "voyages" VALUES (325, '', 1, '', 'AMSTELVEEN', NULL, 300, 'fluit', NULL, NULL, NULL, NULL, 'A', '1626-01-16', 'Texel', '1626-05-18', NULL, true, '1626-10-04', 'Batavia', NULL, 'Forced by a storm to take refuge in Falmouth, leaving Falmouth 21-02-1626, leaving behind 35 deserters. During the voyage 1 man was taken on board.');
INSERT INTO "voyages" VALUES (326, '', 2, '', 'WAPEN VAN DELFT', 'Jakob Jansz. Koonekraai', 700, NULL, '1620', NULL, NULL, 'D', 'D', '1626-01-17', 'Goeree', NULL, NULL, true, '1627-01-28', 'Batavia', 5188, 'Kinsale, leaving Kinsale 24-05-1626.');
INSERT INTO "voyages" VALUES (327, '', 1, '', 'BEVERWIJK', 'Marten Hendriksz.', 160, 'jacht', NULL, NULL, NULL, NULL, 'A', '1626-05-03', 'Texel', '1626-09-29', '1626-11-03', true, '1627-01-27', 'Batavia', NULL, 'Stayed in the Indies and wrecked on the coast of China, 22-09-1631.');
INSERT INTO "voyages" VALUES (328, '', 1, '', 'DEN BRIEL', 'Willem Jakobsz. Koster', 400, 'jacht', NULL, NULL, NULL, NULL, 'A', '1626-05-03', 'Texel', '1626-09-29', '1626-11-03', true, '1627-01-27', 'Batavia', NULL, 'Stayed in the Indies and broken up.');
INSERT INTO "voyages" VALUES (329, '', 1, '', 'DIEMEN', 'Thijs Reiniersz.', 100, 'jacht', NULL, NULL, NULL, 'A', 'A', '1626-05-03', 'Texel', '1626-09-29', '1626-11-03', true, '1627-01-27', 'Batavia', NULL, 'Stayed in the Indies and broken up.');
INSERT INTO "voyages" VALUES (330, '', 1, '', 'OUDERKERK', 'Jouke Piersz.', 100, 'jacht', NULL, NULL, NULL, 'A', 'A', '1626-05-03', 'Texel', NULL, NULL, true, '1627-04-18', 'Batavia', NULL, 'Stayed in the Indies and lost near Amoy, 12-10-1627, fighting the Portuguese.');
INSERT INTO "voyages" VALUES (331, '', 1, '', 'SLOTEN', 'Dirk Gerritsz. Krul', 100, 'jacht', NULL, NULL, NULL, 'A', 'A', '1626-05-03', 'Texel', '1626-09-29', '1626-11-03', true, '1627-01-27', 'Batavia', NULL, 'coast of China, 07-10-1633; according to Mac Leod lost near Amoy, 05-02-1629.');
INSERT INTO "voyages" VALUES (332, '', 1, '', 'GROTEBROEK', NULL, 240, 'jacht', NULL, NULL, NULL, 'E', 'E', '1626-05-21', 'Texel', '1627-01-08', NULL, true, '1627-05-02', 'Batavia', 5201, 'Accompanied the HOLLANDIA to Sierra Leone; July 5th a fight with Klaas Kompaan; from 09-07 till 19-07 in Sierra Leone, July 22th wandered from the HOLLANDIA.');
INSERT INTO "voyages" VALUES (333, '', 1, '', 'DOMBURG', 'Jasper Klaas', 100, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1626-05-22', 'Wielingen', NULL, NULL, true, '1627-03-13', 'Batavia', NULL, 'Reprovisioned in Sierra Leone, June 17th. The ship stayed in the Indies and was burnt in the river Chincheu.');
INSERT INTO "voyages" VALUES (334, '', 3, '', 'HOLLANDIA', 'Willem Jansz. van Amersfoort', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1626-05-22', 'Zeeland', NULL, NULL, true, '1626-12-14', 'Batavia', 5191, '(0332).');
INSERT INTO "voyages" VALUES (335, '', 1, '', 'GULDEN ZEEPAARD', 'Frans Thijsz.', 400, NULL, NULL, NULL, NULL, 'Z', 'Z', '1626-05-22', 'Wielingen', NULL, NULL, true, '1627-04-10', 'Batavia', 5210, 'Reprovisioned in Sierra Leone, June.');
INSERT INTO "voyages" VALUES (336, '', 4, '', 'DORDRECHT', 'Adriaan Jakobsz. Durgerdam', 600, NULL, NULL, NULL, NULL, NULL, 'A', '1626-10-01', 'Texel', '1627-03-18', NULL, true, '1627-06-25', 'Batavia', 5193, 'Sailed again from Terschelling 11-11-1626; according to Dagh-register also MAAGD VAN DORDRECHT.');
INSERT INTO "voyages" VALUES (337, '', 2, '', 'WEESP', NULL, 160, 'jacht', NULL, NULL, NULL, 'A', 'A', '1626-10-01', 'Texel', '1627-03-01', NULL, true, '1627-06-25', 'Batavia', NULL, 'Sailed again from Goeree, 11-11-1626.');
INSERT INTO "voyages" VALUES (338, '', 1, '', 'BOMMEL', NULL, 200, NULL, NULL, NULL, NULL, NULL, 'A', '1626-11-11', 'Zeeland', '1627-03-01', NULL, true, '1627-06-19', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (339, '', 1, '', 'BROUWERSHAVEN', 'Willem Jakobsz.', 200, NULL, NULL, NULL, NULL, 'Z', 'Z', '1627-01-16', 'Wielingen', NULL, NULL, true, '1627-06-20', 'Batavia', NULL, 'Stayed in the Indies; ran aground and was destroyed by fire on the coast of Formosa, 28-06-1633. According to Mac Leod 08-11-1633.');
INSERT INTO "voyages" VALUES (340, '', 1, '', 'FREDERIK HENDRIK', 'Hildebrand Jansz.', 1100, NULL, '1626', NULL, NULL, 'Z', 'Z', '1627-01-16', 'Wielingen', NULL, NULL, true, '1627-06-20', 'Batavia', 5189, NULL);
INSERT INTO "voyages" VALUES (341, '', 1, '', 'GALIASSE', 'Reinier Jansz. Palsrok', 300, NULL, NULL, NULL, NULL, 'H', 'H', '1627-03-19', 'Texel', '1627-07-06', '1627-07-22', true, '1627-09-27', 'Batavia', 5190, 'In July Jan Jansz. became master of the ship. From 12-04 till 16-04 at Maio Island.');
INSERT INTO "voyages" VALUES (342, '', 3, '', 'WAPEN VAN HOORN', 'David Pietersz. de Vries', 400, 'fluit', '1619', NULL, NULL, 'H', 'H', '1627-03-19', 'Texel', '1627-07-16', '1627-08-07', true, '1627-10-13', 'Batavia', NULL, 'stayed in the Indies.');
INSERT INTO "voyages" VALUES (343, '', 1, '', 'KEMPHAAN', 'Kornelis Hendriksz. Denijs', 100, 'jacht', NULL, NULL, NULL, 'A', 'A', '1627-03-19', 'Texel', '1627-06-07', '1627-07-15', true, '1628-01-04', 'Pulicat', NULL, 'From 12-04 till 16-04 at Maio Island; from 22-09 till 07-10 at Anjouan; 17-12 from Gale; ran ashore at Cochin China, 22-10-1633.');
INSERT INTO "voyages" VALUES (344, '', 3, '', 'LEEUWIN', 'Jan Willemsz.', 400, NULL, NULL, NULL, NULL, NULL, 'A', '1627-03-19', 'Texel', '1627-06-07', '1627-07-15', true, '1628-01-04', 'Pulicat', 5200, 'till 07-10 at Anjouan; from 27-11 till 17-12 at Gale.');
INSERT INTO "voyages" VALUES (345, '', 1, '', 'TEXEL', 'Spreeuw', 200, 'jacht', NULL, NULL, NULL, 'A', 'A', '1627-03-19', 'Texel', '1627-07-06', '1627-07-22', true, '1627-09-27', 'Batavia', NULL, 'From 12-04 till 16-04 at Maio Island; the ship stayed in the Indies.');
INSERT INTO "voyages" VALUES (346, '', 1, '', 'UTRECHT', NULL, 400, NULL, NULL, NULL, NULL, 'A', 'A', '1627-03-19', 'Texel', '1627-07-06', '1627-07-22', true, '1627-09-25', 'Batavia', 5209, 'From 12-04 till 16-04 at Maio Island.');
INSERT INTO "voyages" VALUES (347, '', 1, '', 'VIANEN', 'Gerrit Thomasz. Pool', 400, NULL, NULL, NULL, NULL, 'A', 'A', '1627-03-19', 'Texel', '1627-07-16', '1627-08-07', true, '1627-10-08', 'Batavia', 5194, 'From 12-04 till 16-04 at Maio Island,');
INSERT INTO "voyages" VALUES (348, '', 1, '', 'DUBBELE AREND', NULL, 360, NULL, NULL, NULL, NULL, 'A', 'A', '1627-04-10', 'Texel', '1627-08-04', NULL, true, '1627-10-18', 'Batavia', NULL, 'Achterom and via Maio Isl. Stayed in the Indies and was lost near Mauritius, 1630,');
INSERT INTO "voyages" VALUES (349, '', 1, '', 'VELSEN', NULL, 360, 'fluit', NULL, NULL, NULL, 'A', 'A', '1627-04-10', 'Texel', '1627-08-04', NULL, true, '1627-10-29', 'Batavia', NULL, 'Achterom and via Maio Isl. Stayed in the Indies and was broken up, 1631; according to Mac Leod lost, 1635. .');
INSERT INTO "voyages" VALUES (350, '', 1, '', 'VLIEGENDE DRAAK', NULL, 320, 'jacht', NULL, NULL, NULL, 'E', 'E', '1627-10-12', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked on the Needles of Wight, 23-10-1627.');
INSERT INTO "voyages" VALUES (351, '', 1, '', 'KAMPEN', NULL, 300, 'jacht', NULL, NULL, NULL, 'A', 'A', '1627-10-12', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Wreck discovered.');
INSERT INTO "voyages" VALUES (352, '', 1, '', 'NASSAU', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1627-10-12', 'Texel', '1628-03-27', '1628-04-07', true, '1628-06-22', 'Batavia', 5196, 'From November 1627 till 07-01-1628 at Maio Island.');
INSERT INTO "voyages" VALUES (353, '', 1, '', 'TERSCHELLING', NULL, 80, 'jacht', NULL, NULL, NULL, 'A', 'A', '1627-10-12', 'Texel', '1628-03-27', '1628-04-07', true, '1628-07-14', 'Pulicat', NULL, 'From November 1627 till 07-01-1628 at Maio Island; blown up near Negapatnam fighting the enemy, 14-04-1630.');
INSERT INTO "voyages" VALUES (354, '', 1, '', 'VLIELAND', NULL, 80, 'jacht', NULL, NULL, NULL, 'A', 'A', '1627-10-12', 'Texel', '1628-02-01', NULL, true, '1628-06-09', 'Pulicat', NULL, 'November 1627 at Maio Island; the ship stayed in the Indies and was probably laid up,');
INSERT INTO "voyages" VALUES (355, '', 1, '', 'WIERINGEN', NULL, 120, 'jacht', NULL, NULL, NULL, 'A', 'A', '1627-10-12', 'Texel', '1628-03-27', '1628-04-07', true, '1628-07-14', 'Pulicat', NULL, 'From November 1627 till 07-01-1628 at Maio Island; blown up, fighting the Portuguese near Malacca, 02-06-1636,');
INSERT INTO "voyages" VALUES (356, '', 1, '', 'PRINS WILLEM', NULL, 500, NULL, NULL, NULL, NULL, 'A', 'A', '1627-10-12', 'Texel', '1628-03-27', '1628-04-07', true, '1628-06-22', 'Batavia', 5199, 'From November 1627 till 07-01-1628 at Maio Island.');
INSERT INTO "voyages" VALUES (357, '', 3, '', 'DELFSHAVEN', NULL, 400, 'jacht', '1621', NULL, NULL, 'D', 'R', '1627-11-18', 'Goeree', '1628-05-15', NULL, true, '1628-08-01', 'Batavia', 5195, NULL);
INSERT INTO "voyages" VALUES (358, '', 1, '', 'TER VEERE', 'Denijs Anthonisz.', 350, NULL, NULL, NULL, NULL, 'Z', 'Z', '1627-11-18', 'Wielingen', '1628-03-01', '1628-06-01', true, '1628-07-28', 'Batavia', 5197, 'Reprovisioned at St. Lucia Bay.');
INSERT INTO "voyages" VALUES (359, '', 1, '', 'VLISSINGEN', 'Jakob Jansz. de Gans', 350, NULL, NULL, NULL, NULL, 'Z', 'Z', '1627-11-18', 'Wielingen', '1628-04-01', '1628-05-15', true, '1628-08-01', 'Batavia', 5198, NULL);
INSERT INTO "voyages" VALUES (360, '', 1, '', 'ZEEBURG', 'Hendrik de Ruiter', 120, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1627-11-18', 'Wielingen', '1628-03-01', '1628-04-01', true, '1628-08-04', 'Batavia', NULL, 'Via Australia; stayed in the Indies and probably laid up,');
INSERT INTO "voyages" VALUES (361, '', 3, '', 'SCHIEDAM', NULL, 360, NULL, NULL, NULL, NULL, 'D', 'A', '1628-01-24', 'Texel', '1628-05-24', '1628-06-07', true, '1628-08-30', 'Coromandel', NULL, 'Stayed in the Indies and lost on `Boompjes-eiland'', February 1633.');
INSERT INTO "voyages" VALUES (362, '', 4, '', 'TER THOLEN', 'Mathijs Jansz. van Vlissingen', 400, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1628-05-01', 'Wielingen', NULL, NULL, true, '1629-02-06', 'Batavia', NULL, 'Indies.');
INSERT INTO "voyages" VALUES (363, '', 3, '', 'WAPEN VAN ENKHUIZEN', NULL, 700, NULL, '1619', NULL, NULL, 'E', 'E', '1628-05-12', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Blown up off Sierra Leone, 18-10-1628.');
INSERT INTO "voyages" VALUES (364, '', 4, '', 'LEIDEN', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'A', '1628-05-12', 'Texel', '1629-02-04', '1629-02-20', true, '1629-07-17', 'Batavia', 5207, 'Departure from Sierra Leone, 07-10-1628.');
INSERT INTO "voyages" VALUES (365, '', 2, '', 'WAPEN VAN ROTTERDAM', NULL, 700, NULL, '1621', NULL, NULL, 'R', 'R', '1628-05-12', 'Goeree', NULL, NULL, true, '1629-02-18', 'Batavia', 5208, NULL);
INSERT INTO "voyages" VALUES (366, '', 1, '', 'ASSENDELFT', NULL, 500, 'fluit', '1628', NULL, NULL, 'A', 'A', '1628-10-28', 'Texel', NULL, NULL, true, '1629-07-02', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (367, '', 1, '', 'BUREN', NULL, 200, NULL, NULL, NULL, NULL, 'E', 'E', '1628-10-28', 'Texel', NULL, NULL, true, '1629-07-10', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (368, '', 1, '', 'KLEINE DAVID', 'Kornelis Fransz.', 100, 'jacht', NULL, NULL, NULL, 'H', 'H', '1628-10-28', 'Texel', NULL, NULL, true, '1629-07-13', 'Pulicat', NULL, 'Destroyed by fire on the coast of the Coromandel, 11-02-1630.');
INSERT INTO "voyages" VALUES (369, '', 5, '', 'DORDRECHT', NULL, 500, NULL, NULL, NULL, NULL, NULL, 'A', '1628-10-28', 'Texel', NULL, NULL, true, '1629-07-10', 'Batavia', 5203, NULL);
INSERT INTO "voyages" VALUES (370, '', 1, '', '''S GRAVENHAGE', NULL, 300, NULL, NULL, NULL, NULL, 'A', 'A', '1628-10-28', 'Texel', '1629-09-12', NULL, true, '1629-11-19', 'Batavia', 5223, 'From 03-11-1628 till 04-05-1629 in Zeeland.');
INSERT INTO "voyages" VALUES (371, '', 1, '', 'ZAANDAM', NULL, 500, 'fluit', NULL, NULL, NULL, 'A', 'A', '1628-10-28', 'Texel', NULL, NULL, true, '1629-07-07', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (372, '', 1, '', 'BATAVIA', 'Adriaan Jakobsz.', 600, NULL, NULL, NULL, NULL, NULL, 'A', '1628-10-29', 'Texel', '1629-04-14', '1629-04-22', true, NULL, NULL, NULL, 'Wrecked on the Wallabi Group, 04-06-1629. Wreck has been discovered (see H. Edwards).');
INSERT INTO "voyages" VALUES (373, '', 2, '', 'GALIASSE', NULL, 300, NULL, NULL, NULL, NULL, 'H', 'H', '1628-12-28', 'Texel', NULL, NULL, true, '1629-07-13', 'Pulicat', 5204, NULL);
INSERT INTO "voyages" VALUES (374, '', 3, '', 'WAPEN VAN DELFT', 'Jakob Jansz. Koonekraai', 700, NULL, '1620', NULL, NULL, 'D', 'D', '1629-01-23', 'Goeree', NULL, NULL, true, '1629-07-23', 'Batavia', 5202, NULL);
INSERT INTO "voyages" VALUES (375, '', 1, '', 'ZALM', NULL, 100, 'jacht', NULL, NULL, NULL, 'R', 'R', '1629-01-23', 'Goeree', NULL, NULL, true, '1629-07-14', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (376, '', 2, '', 'FREDERIK HENDRIK', 'Kornelis Willemsz.', 1100, NULL, '1626', NULL, NULL, 'Z', 'Z', '1629-01-24', 'Wielingen', NULL, NULL, true, '1629-07-07', 'Batavia', 5205, 'From 28-01 till 17-02-1629 in the Downs; March 23th till 24th at St. Antao.');
INSERT INTO "voyages" VALUES (377, '', 1, '', 'TER GOES', 'Laurens Jansz. Crijne', 200, NULL, NULL, NULL, NULL, 'Z', 'Z', '1629-01-24', 'Wielingen', '1629-06-23', '1629-07-05', true, '1629-09-21', 'Batavia', NULL, 'From 28-01 till 17-02-1629 in the Downs; from 22-03 till 09-04 at St. Antao.');
INSERT INTO "voyages" VALUES (378, '', 1, '', 'ZOUTELANDE', 'Albert Jansz.', 100, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1629-01-24', 'Wielingen', NULL, NULL, true, NULL, NULL, NULL, 'From 28-01 till 17-02-1629 in the Downs, wrecked at St. Antao, 24-03-1629.');
INSERT INTO "voyages" VALUES (379, '', 1, '', 'BEETS', 'Kornelis Fransz.', 300, 'jacht', NULL, NULL, NULL, NULL, 'H', '1629-01-25', 'Texel', NULL, NULL, true, '1629-07-18', 'Batavia', NULL, 'Stayed in the Indies. From 28-01 till 17-02 in the Downs; March 23th till March 24th at St. Antao.');
INSERT INTO "voyages" VALUES (380, '', 1, '', 'BROEKERHAVEN', 'Marten Jansz. Proost', 100, 'jacht', NULL, NULL, NULL, 'E', 'E', '1629-01-25', 'Texel', '1629-07-27', '1629-08-19', true, '1629-10-22', 'Batavia', NULL, '22-10-1633.');
INSERT INTO "voyages" VALUES (381, '', 4, '', 'HOLLANDIA', 'Adriaan Kornelisz. Smal +', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1629-01-25', 'Texel', '1629-06-23', '1629-07-05', true, '1629-09-21', 'Batavia', 5206, 'From 28-01 till 17-02-1629 in the Downs; from 22-03 till 09-04 on the Cape Verde I. After the death of Smal, Jan Reyersz. Klok became master.');
INSERT INTO "voyages" VALUES (382, '', 1, '', 'OOSTZANEN', NULL, 100, 'jacht', NULL, NULL, NULL, 'A', 'A', '1629-01-25', 'Texel', '1629-06-23', '1629-07-05', true, '1629-09-21', 'Batavia', NULL, 'Portuguese, 05-04-1630. From 28-01 till 17-02 in the Downs; from 22-03 till 17-02 on the Cape Verde I.');
INSERT INTO "voyages" VALUES (383, '', 1, '', 'WESTZANEN', NULL, 100, 'jacht', NULL, NULL, NULL, 'A', 'A', '1629-01-25', 'Texel', '1629-06-23', '1629-07-05', true, '1629-09-21', 'Batavia', NULL, 'From 28-01 till 17-02 in the Downs; from 24-03 till 09-04 on the Cape Verde I. The ship stayed in the Indies. Together with the OOSTZANEN 139 men on board.');
INSERT INTO "voyages" VALUES (384, '', 5, '', 'WALCHEREN', NULL, 500, NULL, '1612', NULL, NULL, 'Z', 'Z', '1629-05-01', 'Wielingen', NULL, NULL, true, '1630-03-17', 'Batavia', NULL, 'Blown up near Djambi, fighting the Portuguese, 06-05-1630. According to Mac Leod 07-05-1629.');
INSERT INTO "voyages" VALUES (385, '', 4, '', 'GOUDEN LEEUW', NULL, 550, NULL, NULL, NULL, NULL, 'R', 'A', '1629-05-07', 'Texel', '1629-08-27', '1629-09-12', true, '1629-11-19', 'Batavia', NULL, 'Stayed in the Indies and wrecked on an unknown reef near Borneo, 1634.');
INSERT INTO "voyages" VALUES (386, '', 2, '', 'VIANEN', 'Albert Dirksz.', 400, NULL, NULL, NULL, NULL, 'A', 'H', '1629-05-07', 'Texel', '1629-08-27', '1629-09-12', true, NULL, NULL, NULL, 'Destroyed by fire in Strait Sunda, 14-11-1629.');
INSERT INTO "voyages" VALUES (387, '', 1, '', 'AMBOINA', NULL, 400, NULL, '1629', NULL, NULL, 'A', 'A', '1629-12-27', 'Texel', '1630-09-20', NULL, true, '1630-12-18', 'Batavia', 5231, 'From the Isle of Wight, 05-05-1630.');
INSERT INTO "voyages" VALUES (388, '', 1, '', 'BRAK', NULL, 100, NULL, NULL, NULL, NULL, NULL, 'A', '1629-12-27', 'Texel', NULL, NULL, true, '1630-08-23', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (389, '', 1, '', 'LEEUWARDEN', NULL, 550, NULL, '1629', NULL, NULL, 'E', 'E', '1629-12-27', 'Texel', '1630-07-29', '1630-08-19', true, '1630-11-06', 'Batavia', 5214, NULL);
INSERT INTO "voyages" VALUES (390, '', 1, '', 'DEVENTER', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1629-12-28', 'Texel', '1630-08-16', '1630-09-16', true, '1630-12-12', 'Batavia', 5212, 'From the Downs 25-03 back to Zeeland; from Zeeland 26-06-1630; from 04-07 till 10-07 at Cape Frio.');
INSERT INTO "voyages" VALUES (391, '', 1, '', 'NIJMEGEN', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1629-12-28', 'Texel', '1631-02-01', NULL, true, '1631-04-28', 'Batavia', 5221, 'Guinea.');
INSERT INTO "voyages" VALUES (392, '', 4, '', 'LEEUWIN', NULL, 400, NULL, NULL, NULL, NULL, NULL, 'A', '1630-02-18', 'Texel', '1630-07-06', '1630-07-15', true, '1630-09-23', 'Batavia', 5215, NULL);
INSERT INTO "voyages" VALUES (393, '', 1, '', 'WARMOND', NULL, 300, 'fluit', NULL, NULL, NULL, 'A', 'A', '1630-02-18', 'Texel', '1630-07-06', '1630-07-15', true, '1630-09-09', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (394, '', 1, '', 'WASSENAAR', NULL, 240, 'jacht', NULL, NULL, NULL, 'A', 'A', '1630-02-18', 'Texel', '1630-07-20', '1630-07-31', true, '1630-11-03', 'Batavia', 5217, NULL);
INSERT INTO "voyages" VALUES (395, '', 1, '', 'KOUDEKERKE', 'Joost Salters', 100, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1630-02-21', 'Texel', NULL, NULL, true, '1630-09-15', 'Batavia', NULL, 'Stayed in the Indies and laid up, 08-10-1640.');
INSERT INTO "voyages" VALUES (396, '', 1, '', 'MIDDELBURG', 'Kornelis Kornelisz. Oole', 550, NULL, NULL, NULL, NULL, NULL, 'Z', '1630-02-21', 'Texel', '1630-08-16', '1630-09-16', true, '1630-12-12', 'Batavia', 5216, 'March 25th. from the Downs; from 04-07 till 10-04 in Brazil.');
INSERT INTO "voyages" VALUES (397, '', 1, '', 'HOF VAN HOLLAND', NULL, 500, NULL, NULL, NULL, NULL, NULL, 'D', '1630-02-22', 'Goeree', '1630-08-16', '1630-09-16', true, '1630-12-25', 'Batavia', 5232, 'March 25 th. from the Downs; from 04-07 till 10-07 in Brazil.');
INSERT INTO "voyages" VALUES (398, '', 1, '', 'RIJSWIJK', NULL, 100, 'jacht', NULL, NULL, NULL, 'D', 'D', '1630-02-22', 'Goeree', NULL, NULL, true, NULL, NULL, NULL, 'Sailed to the equator but returned because of bad trimming and was captured by a Dunkirk privateer.');
INSERT INTO "voyages" VALUES (399, '', 4, '', 'DELFSHAVEN', NULL, 400, 'jacht', '1621', NULL, NULL, 'D', 'R', '1630-04-21', 'Goeree', '1630-09-20', NULL, true, '1630-12-18', 'Batavia', 5211, 'May 5th from Wight.');
INSERT INTO "voyages" VALUES (400, '', 1, '', 'EGMOND', NULL, 240, 'jacht', NULL, NULL, NULL, NULL, 'A', '1630-04-16', 'Texel', '1630-07-24', '1630-08-06', true, '1630-10-05', 'Batavia', 5213, NULL);
INSERT INTO "voyages" VALUES (401, '', 2, '', 'TER VEERE', 'Kornelis Kornelisz. Tand', 350, NULL, NULL, NULL, NULL, 'Z', 'Z', '1630-06-30', 'Wielingen', '1630-11-01', '1630-11-27', true, '1631-02-18', 'Batavia', 5224, 'Via Sierra Leone.');
INSERT INTO "voyages" VALUES (402, '', 2, '', 'VLISSINGEN', 'Krijn Pietersz.', 350, NULL, NULL, NULL, NULL, 'Z', 'Z', '1630-06-30', 'Wielingen', '1630-11-01', '1630-11-27', true, '1631-02-14', 'Batavia', 5239, 'Via Sierra Leone.');
INSERT INTO "voyages" VALUES (403, '', 1, '', 'KATWIJK', NULL, 100, NULL, NULL, NULL, NULL, 'A', 'A', '1630-11-06', 'Texel', '1630-03-11', NULL, true, '1631-05-22', 'Batavia', NULL, 'Stayed in the Indies and was wrecked in the Bay of Tarpia, 07-10-1633.');
INSERT INTO "voyages" VALUES (404, '', 2, '', 'GROOTEBROEK', NULL, 240, 'jacht', NULL, NULL, NULL, NULL, 'E', '1630-11-06', 'Texel', NULL, NULL, true, '1631-04-28', 'Batavia', NULL, 'during the voyage; wrecked on the coast of Cochin China, 1635.');
INSERT INTO "voyages" VALUES (405, '', 2, '', 'NASSAU', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1630-11-06', 'Texel', '1631-03-11', '1631-03-17', true, '1631-06-02', 'Batavia', 5220, NULL);
INSERT INTO "voyages" VALUES (406, '', 2, '', 'PRINS WILLEM', NULL, 500, NULL, NULL, NULL, NULL, 'A', 'A', '1630-11-06', 'Texel', '1631-03-11', '1631-03-17', true, '1631-06-02', 'Batavia', 5229, NULL);
INSERT INTO "voyages" VALUES (407, '', 1, '', 'WEZEL', NULL, 550, NULL, '1629', NULL, NULL, 'A', 'A', '1630-11-06', 'Texel', '1631-03-11', '1631-03-17', true, '1631-06-02', 'Batavia', 5222, NULL);
INSERT INTO "voyages" VALUES (408, '', 3, '', 'GALIASSE', NULL, 300, NULL, NULL, NULL, NULL, 'H', 'H', '1630-12-11', 'Texel', '1631-03-06', NULL, true, '1631-05-19', 'Batavia', 5219, NULL);
INSERT INTO "voyages" VALUES (409, '', 4, '', 'WAPEN VAN DELFT', 'Pieter Klaasz. Hardloop', 700, NULL, '1620', NULL, NULL, 'D', 'D', '1630-12-16', 'Goeree', NULL, NULL, true, '1631-06-06', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (410, '', 1, '', 'NOORDWIJK', NULL, 300, 'jacht', NULL, NULL, NULL, 'A', 'A', '1630-12-18', 'Texel', NULL, NULL, true, '1631-09-20', 'Batavia', NULL, 'Stayed in the Indies and was wrecked near the river Patrapa, 19-02-1637.');
INSERT INTO "voyages" VALUES (411, '', 1, '', 'HUISDUINEN', NULL, 150, 'fluit', NULL, NULL, NULL, 'A', 'A', '1631-03-03', 'Texel', NULL, NULL, true, '1631-11-04', 'Batavia', NULL, 'Sailed `achterom''; stayed in the Indies.');
INSERT INTO "voyages" VALUES (412, '', 3, '', 'FREDERIK HENDRIK', 'Pieter Jansz.', 1100, NULL, '1626', NULL, NULL, 'Z', 'Z', '1631-03-25', 'Wielingen', NULL, NULL, true, '1631-09-15', 'Batavia', 5218, 'No ports of call.');
INSERT INTO "voyages" VALUES (413, '', 2, '', 'GULDEN ZEEPAARD', 'Denijs Anthonisz.', 400, NULL, NULL, NULL, NULL, 'Z', 'Z', '1631-03-25', 'Wielingen', NULL, NULL, true, '1631-09-29', 'Batavia', NULL, 'Indies.');
INSERT INTO "voyages" VALUES (414, '', 3, '', 'WAPEN VAN ROTTERDAM', NULL, 700, NULL, '1621', NULL, NULL, 'R', 'R', '1631-03-25', 'Goeree', NULL, NULL, true, '1631-12-03', 'Batavia', 5228, NULL);
INSERT INTO "voyages" VALUES (415, '', 5, '', 'HOLLANDIA', NULL, 700, NULL, NULL, NULL, NULL, 'A', 'A', '1631-03-29', 'Texel', NULL, NULL, true, '1631-09-29', 'Batavia', 5226, NULL);
INSERT INTO "voyages" VALUES (416, '', 1, '', 'GROL', 'Theunis Liefhebber', 200, 'jacht', NULL, NULL, NULL, 'A', 'A', '1631-12-11', 'Texel', NULL, NULL, true, '1632-06-30', 'Batavia', NULL, 'From 30-01 till 06-02 at S. Vincente, stayed in the Indies.');
INSERT INTO "voyages" VALUES (417, '', 5, '', 'LEIDEN', 'Klaas Hendriksz. Houthaas+', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1631-12-11', 'Texel', NULL, NULL, true, '1632-07-16', 'Batavia', NULL, 'Houthaas died 14-07-1632; stayed in the Indies.');
INSERT INTO "voyages" VALUES (418, '', 1, '', 'UTRECHT', 'Kornelis Simonsz. van der Veer', 350, NULL, NULL, NULL, NULL, 'A', 'A', '1631-12-11', 'Texel', NULL, NULL, true, '1632-07-15', 'Batavia', NULL, 'Stayed in the Indies; ran ashore in Strait Doeriam, May 1641 and was burnt.');
INSERT INTO "voyages" VALUES (419, '', 1, '', 'BLEISWIJK', NULL, 100, 'jacht', NULL, NULL, NULL, 'R', 'R', '1632-01-01', 'Maas', '1632-12-01', NULL, true, '1633-06-19', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (420, '', 1, '', 'HOORN', NULL, 550, NULL, NULL, NULL, NULL, 'H', 'H', '1632-01-11', 'Texel', NULL, NULL, true, '1632-08-03', 'Batavia', 5227, NULL);
INSERT INTO "voyages" VALUES (421, '', 1, '', '''S HERTOGENBOSCH', 'Jakob Jansz. Koonekraai', 600, NULL, '1631', NULL, NULL, 'D', 'D', '1632-01-18', 'Goeree', NULL, NULL, true, '1632-07-27', 'Batavia', 5244, 'Vincente.');
INSERT INTO "voyages" VALUES (422, '', 1, '', 'AEMILIA', 'Gerrit van Hattem', 600, NULL, NULL, NULL, NULL, 'Z', 'Z', '1632-03-03', 'Wielingen', NULL, NULL, true, '1632-08-01', 'Batavia', 5225, 'No ports of call at all. 03-03 is the date of the second departure.');
INSERT INTO "voyages" VALUES (423, '', 5, '', 'DELFSHAVEN', NULL, 400, 'jacht', '1621', NULL, NULL, 'D', 'A', '1632-04-18', 'Texel', NULL, NULL, true, '1632-09-08', 'Batavia', NULL, 'Bursted because of carelessness in Batavia, 12-11-1633.');
INSERT INTO "voyages" VALUES (424, '', 5, '', 'LEEUWIN', NULL, 400, NULL, NULL, NULL, NULL, NULL, 'A', '1632-04-18', 'Texel', NULL, NULL, true, '1632-09-16', 'Batavia', NULL, 'No ports of call at all; stayed in the Indies and was laid up 1640.');
INSERT INTO "voyages" VALUES (425, '', 1, '', 'ZEELANDIA', 'Kornelis Kornelisz. Oole', 600, NULL, '1631', NULL, NULL, 'Z', 'Z', '1632-04-18', 'Wielingen', NULL, NULL, true, '1632-09-04', 'Batavia', 5242, 'No ports of call.');
INSERT INTO "voyages" VALUES (426, '', 1, '', 'ZUTPHEN', 'Nikolaas Bruin', 550, NULL, NULL, NULL, NULL, 'A', 'A', '1632-04-18', 'Texel', NULL, NULL, true, '1632-09-05', 'Batavia', 5230, 'May 3rd at Maio I.');
INSERT INTO "voyages" VALUES (427, '', 2, '', 'LEEUWARDEN', NULL, 550, NULL, '1629', NULL, NULL, 'E', 'E', '1632-05-10', 'Texel', NULL, NULL, true, '1632-11-10', 'Batavia', 5233, NULL);
INSERT INTO "voyages" VALUES (428, '', 1, '', 'OUDEWATER', NULL, 80, 'jacht', NULL, NULL, NULL, 'A', 'A', '1632-11-23', 'Texel', NULL, NULL, true, '1633-07-21', 'Batavia', NULL, 'Back to Vlissingen, sailed again January 28th; from 30-01 till 22-02 off the Isle of Wight; from 20-03 till 25-03 at S. Vincente; stayed in the Indies.');
INSERT INTO "voyages" VALUES (429, '', 1, '', 'VEENHUIZEN', NULL, 100, 'jacht', NULL, NULL, NULL, 'E', 'E', '1632-11-23', 'Texel', NULL, NULL, true, '1633-07-21', 'Batavia', NULL, 'See 0428.');
INSERT INTO "voyages" VALUES (430, '', 1, '', 'IJSSELSTEIN', NULL, 80, 'jacht', NULL, NULL, NULL, 'A', 'A', '1632-11-23', NULL, NULL, NULL, true, NULL, NULL, NULL, 'Captured by a Dunkirk privateer.');
INSERT INTO "voyages" VALUES (431, '', 1, '', 'AMSTERDAM', 'Theunis Willemsz. Harnay', 550, NULL, '1632', NULL, NULL, 'A', 'A', '1632-12-10', 'Texel', NULL, NULL, true, '1633-07-21', 'Batavia', 5237, 'See 0428; the AMSTERDAM did not stay in the Indies.');
INSERT INTO "voyages" VALUES (432, '', 1, '', 'BREEDAM', 'Michiel Vis', 200, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1632-12-10', 'Wielingen', NULL, NULL, true, '1633-05-24', 'Batavia', NULL, 'No ports of call; stayed in the Indies and was wrecked near the `Duizend eilanden''.');
INSERT INTO "voyages" VALUES (433, '', 2, '', 'MIDDELBURG', 'Willem van Domburg', 550, NULL, NULL, NULL, NULL, NULL, 'Z', '1632-12-10', 'Wielingen', NULL, NULL, true, '1633-05-12', 'Batavia', 5236, 'No ports of call. According to `Memoriael'' the master was Kornelis Kornelisz. Domb.');
INSERT INTO "voyages" VALUES (434, '', 1, '', 'VENLO', 'Anthonie Jansz.', 120, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1632-12-10', 'Wielingen', NULL, NULL, true, '1633-06-03', 'Batavia', NULL, 'No ports of call; stayed in the Indies and was laid up, 1646.');
INSERT INTO "voyages" VALUES (435, '', 3, '', 'NASSAU', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1633-03-23', 'Texel', NULL, NULL, true, '1633-08-11', 'Batavia', 5234, NULL);
INSERT INTO "voyages" VALUES (436, '', 1, '', 'SCHAGEN', NULL, 200, 'fluit', NULL, NULL, NULL, 'A', 'A', '1633-03-23', 'Texel', NULL, NULL, true, '1633-09-11', 'Batavia', NULL, 'Stayed in the Indies and was laid up in Batavia, 1644.');
INSERT INTO "voyages" VALUES (437, '', 2, '', 'WEZEL', NULL, 550, NULL, '1629', NULL, NULL, 'A', 'A', '1633-03-23', 'Texel', NULL, NULL, true, '1633-09-02', 'Batavia', 5235, NULL);
INSERT INTO "voyages" VALUES (438, '', 1, '', 'BANDA', NULL, 550, NULL, '1633', NULL, NULL, 'A', 'A', '1633-12-07', 'Texel', '1634-04-07', '1634-04-11', true, '1634-07-20', 'Persia', 5243, NULL);
INSERT INTO "voyages" VALUES (439, '', 2, '', 'EGMOND', NULL, 240, 'jacht', NULL, NULL, NULL, NULL, 'A', '1633-12-07', 'Texel', '1634-04-07', '1634-04-11', true, '1634-07-20', 'Persia', 5239, NULL);
INSERT INTO "voyages" VALUES (440, '', 2, '', 'HOORN', NULL, 550, NULL, NULL, NULL, NULL, 'H', 'H', '1633-12-07', 'Texel', '1634-04-07', NULL, true, '1634-06-09', 'Batavia', 5247, 'Via the Saldanha Bay.');
INSERT INTO "voyages" VALUES (441, '', 2, '', 'WASSENAAR', NULL, 240, NULL, NULL, NULL, NULL, 'A', 'A', '1633-12-07', 'Texel', '1634-04-07', '1634-04-11', true, '1634-06-17', 'Batavia', NULL, 'laid up in Malacca, 1643.');
INSERT INTO "voyages" VALUES (442, '', 4, '', 'FREDERIK HENDRIK', 'Pieter Jansz.', 1100, NULL, '1626', NULL, NULL, 'Z', 'Z', '1633-12-10', 'Wielingen', NULL, NULL, true, '1634-06-09', 'Batavia', 5251, 'Vincente.');
INSERT INTO "voyages" VALUES (443, '', 1, '', 'ZWAAN', 'Adriaan Waaghals', 200, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1633-12-10', 'Texel', NULL, NULL, true, '1634-06-10', 'Batavia', NULL, 'Reprovisioned at S. Vincente and stayed in the Indies; wrecked near the Pescadores 26-02-1637; according to Mac Leod surprised by the sultan of Martapoera and burnt, 1637.');
INSERT INTO "voyages" VALUES (444, '', 3, '', 'TER VEERE', 'Jakob Jansz. Gauw', 350, NULL, NULL, NULL, NULL, 'Z', 'Z', '1633-12-10', 'Wielingen', NULL, NULL, true, '1634-06-10', 'Batavia', NULL, 'Reprovisioned in Sierra Leone; stayed in the Indies.');
INSERT INTO "voyages" VALUES (445, '', 1, '', 'PETTEN', NULL, 200, 'fluit', NULL, NULL, NULL, 'A', 'A', '1634-04-18', 'Texel', NULL, NULL, true, NULL, 'Mauritius', 5285, NULL);
INSERT INTO "voyages" VALUES (446, '', 4, '', 'WAPEN VAN ROTTERDAM', NULL, 700, NULL, '1621', NULL, NULL, 'R', 'R', '1634-04-19', 'Goeree', NULL, NULL, true, '1634-09-23', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (447, '', 1, '', 'ZANDVOORT', NULL, 80, 'jacht', NULL, NULL, NULL, 'A', 'A', '1634-04-19', 'Texel', NULL, NULL, true, '1634-09-21', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (448, '', 2, '', 'ZUTPHEN', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1634-04-19', 'Texel', NULL, NULL, true, '1634-09-30', 'Batavia', 5240, NULL);
INSERT INTO "voyages" VALUES (449, '', 3, '', 'PRINS WILLEM', NULL, 500, NULL, NULL, NULL, NULL, 'A', 'A', '1634-04-19', 'Texel', NULL, NULL, true, '1634-09-20', 'Batavia', 5241, NULL);
INSERT INTO "voyages" VALUES (450, '', 2, '', 'AMBOINA', NULL, 400, NULL, '1629', NULL, NULL, 'A', 'A', '1634-12-26', 'Texel', NULL, NULL, true, '1635-07-17', 'Batavia', 5252, NULL);
INSERT INTO "voyages" VALUES (451, '', 2, '', 'AMSTERDAM', 'Pieter Dirksz.', 550, NULL, '1632', NULL, NULL, 'A', 'A', '1634-12-26', 'Texel', '1635-04-08', NULL, true, '1635-06-14', 'Batavia', 5245, NULL);
INSERT INTO "voyages" VALUES (452, '', 4, '', 'GALIASSE', NULL, 300, NULL, NULL, NULL, NULL, 'H', 'H', '1634-12-26', 'Texel', NULL, NULL, true, '1635-07-14', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (453, '', 2, '', '''S GRAVENHAGE', NULL, 300, NULL, NULL, NULL, NULL, 'A', 'A', '1634-12-26', 'Texel', '1635-05-01', NULL, true, '1635-07-06', 'Batavia', NULL, 'Stayed in the Indies and was burnt by the Portuguese off Goa, 04-01-1638.');
INSERT INTO "voyages" VALUES (454, '', 3, '', 'LEEUWARDEN', NULL, 550, NULL, '1629', NULL, NULL, 'E', 'E', '1634-12-26', 'Texel', NULL, NULL, true, '1635-08-22', 'Batavia', 5255, NULL);
INSERT INTO "voyages" VALUES (455, '', 1, '', 'MAASTRICHT', NULL, 600, NULL, NULL, NULL, NULL, 'R', 'R', '1634-12-26', 'Goeree', '1635-05-01', NULL, true, '1635-07-15', 'Batavia', 5248, NULL);
INSERT INTO "voyages" VALUES (456, '', 1, '', 'RAROP', NULL, 200, 'fluit', NULL, NULL, NULL, 'A', 'A', '1634-12-26', 'Texel', '1635-04-29', '1635-05-01', true, '1635-07-14', 'Batavia', NULL, 'Stayed in the Indies and wrecked on a reef between Colombo and Negombo, 01-01-1640.');
INSERT INTO "voyages" VALUES (457, '', 2, '', 'AEMILIA', 'Joost Salters', 600, NULL, NULL, NULL, NULL, 'Z', 'Z', '1634-12-27', 'Wielingen', NULL, NULL, true, '1635-07-20', 'Batavia', 5260, NULL);
INSERT INTO "voyages" VALUES (458, '', 2, '', 'HOF VAN HOLLAND', 'Jan Bouwesz.', 500, NULL, NULL, NULL, NULL, 'D', 'D', '1634-12-27', 'Goeree', NULL, NULL, true, '1635-08-16', 'Batavia', 5263, NULL);
INSERT INTO "voyages" VALUES (459, '', 1, '', 'RITHEM', 'Gerrit Hugo', 200, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1634-12-27', 'Wielingen', NULL, NULL, true, '1635-07-26', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (460, '', 3, '', 'VLISSINGEN', 'Huibrecht Huibrechtsz.', 350, NULL, NULL, NULL, NULL, 'Z', 'Z', '1634-12-27', 'Wielingen', NULL, NULL, true, '1635-07-16', 'Batavia', NULL, 'Stayed in the Indies and was set on fire by the Portuguese off Goa, 04-01-1638.');
INSERT INTO "voyages" VALUES (461, '', 6, '', 'HOLLANDIA', NULL, 700, NULL, NULL, NULL, NULL, 'A', 'A', '1635-05-02', 'Texel', NULL, NULL, true, '1635-09-21', 'Batavia', 5246, 'Via Cape Verde, departure June 1st.');
INSERT INTO "voyages" VALUES (462, '', 4, '', 'NASSAU', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1635-05-02', 'Texel', NULL, NULL, true, '1635-09-21', 'Batavia', 5249, 'Via Cape Verde, departure June 1st.');
INSERT INTO "voyages" VALUES (463, '', 3, '', 'WEZEL', NULL, 550, NULL, '1629', NULL, NULL, 'A', 'A', '1635-05-02', 'Texel', NULL, NULL, true, '1635-09-21', 'Batavia', 5250, 'Via Cape Verde, departure June 1st.');
INSERT INTO "voyages" VALUES (464, '', 2, '', 'BANDA', 'Anthonie Caan', 550, NULL, '1633', NULL, NULL, 'A', 'A', '1636-01-18', 'Texel', '1636-05-19', '1636-06-02', true, '1636-07-25', 'Batavia', 5253, '0464-0479 departed with 2557 men; death-toll 123 (Coolhaas I, 556). From 22-01-1636 till 16-02-1636 in the Wielingen. July 5th on the west coast of Australia, 25''S.');
INSERT INTO "voyages" VALUES (465, '', 3, '', 'EGMOND', NULL, 240, 'jacht', NULL, NULL, NULL, NULL, 'A', '1636-01-18', 'Texel', '1636-05-19', '1636-06-02', true, '1636-07-25', 'Batavia', NULL, '16-02-1636 in the Wielingen; the ship stayed in the Indies; laid up 1645.');
INSERT INTO "voyages" VALUES (466, '', 1, '', 'HARDERWIJK', NULL, 400, NULL, NULL, NULL, NULL, 'A', 'A', '1636-01-18', 'Texel', '1636-05-19', '1636-06-02', true, '1636-07-25', 'Batavia', 5278, 'From 22-01 till 16-02-1636 in the Wielingen.');
INSERT INTO "voyages" VALUES (467, '', 1, '', 'KEIZERIN', NULL, 200, 'fluit', NULL, NULL, NULL, NULL, 'A', '1636-01-18', 'Texel', '1636-05-19', '1636-06-02', true, '1636-07-25', 'Batavia', NULL, 'From 22-01 till 16-02-1636 in the Wielingen; the ship stayed in the Indies and ran ashore, coming from Taiwan on the coast of `Champa'', 1637; according to Mac Leod in the Bay of Padaran, 29-10-1636.');
INSERT INTO "voyages" VALUES (468, '', 1, '', 'OTTER', NULL, 200, 'fluit', NULL, NULL, NULL, NULL, 'A', '1636-01-18', 'Texel', '1636-05-19', '1636-06-02', true, '1636-07-25', 'Batavia', NULL, 'OTTER was wrecked upon a reef south of Buton, 1643; according to Coolhaas the crew was murdered 07-09-1643.');
INSERT INTO "voyages" VALUES (469, '', 1, '', 'ZWOLLE', 'Jan Thijssen', 360, NULL, NULL, NULL, NULL, 'A', 'A', '1636-01-18', 'Texel', '1636-05-19', '1636-06-02', true, '1636-07-21', 'Batavia', 5260, 'From 22-01 till 16-02-1636 in the Wielingen.');
INSERT INTO "voyages" VALUES (470, '', 1, '', 'VOS', NULL, NULL, 'jacht', NULL, NULL, NULL, NULL, 'A', '1636-01-18', 'Texel', NULL, NULL, true, '1636-07-17', 'Batavia', NULL, 'From 22-01 till 16-02-1636 in the Wielingen; the ship stayed in the Indies and was laid up in Batavia, 1644.');
INSERT INTO "voyages" VALUES (471, '', 3, '', 'MIDDELBURG', 'Kornelis Kornelisz. Oole', 550, NULL, NULL, NULL, NULL, NULL, 'Z', '1636-02-01', 'Wielingen', '1636-05-19', '1636-06-02', true, '1636-07-25', 'Batavia', 5266, 'departure 16-02-1636.');
INSERT INTO "voyages" VALUES (472, '', 1, '', 'OOSTKAPELLE', 'Enoch Marinusz.', 200, 'fluit', NULL, NULL, NULL, NULL, 'Z', '1636-02-01', 'Wielingen', NULL, NULL, true, '1636-07-07', 'Batavia', NULL, 'Stayed in the Indies and was broken up at Banda, 1645; according to Daghregister 1636, 153, departure 16-02-1636.');
INSERT INTO "voyages" VALUES (473, '', 1, '', 'DUIF', NULL, NULL, 'fluit', NULL, NULL, NULL, NULL, 'A', '1636-05-02', 'Texel', NULL, NULL, true, '1636-10-08', 'Batavia', NULL, 'the Indies and was wrecked, 1650.');
INSERT INTO "voyages" VALUES (474, '', 1, '', 'ENKHUIZEN', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'E', '1636-05-02', 'Texel', NULL, NULL, true, '1636-10-08', 'Batavia', 5258, 'No ports of call.');
INSERT INTO "voyages" VALUES (475, '', 4, '', 'PRINS WILLEM', NULL, 500, NULL, NULL, NULL, NULL, 'A', 'A', '1636-05-02', 'Texel', NULL, NULL, true, '1636-09-26', 'Batavia', 5255, 'No ports of call.');
INSERT INTO "voyages" VALUES (476, '', 3, '', 'ZUTPHEN', 'Willem Jakobsz. Koster', 550, NULL, NULL, NULL, NULL, 'A', 'A', '1636-05-02', 'Texel', '1636-08-14', '1636-08-25', true, '1636-10-30', 'Batavia', 5257, NULL);
INSERT INTO "voyages" VALUES (477, '', 1, '', 'ROEMERSWAAL', 'Thomas Jansz.', 80, 'jacht', NULL, NULL, NULL, NULL, 'Z', '1636-05-04', 'Wielingen', NULL, NULL, true, '1636-11-15', 'Batavia', NULL, 'Stayed in the Indies and was laid up 1649.');
INSERT INTO "voyages" VALUES (478, '', 1, '', 'VALK', 'Frans Thijsz.', 120, 'jacht', NULL, NULL, NULL, NULL, 'Z', '1636-05-04', 'Wielingen', NULL, NULL, true, '1636-11-06', 'Batavia', NULL, 'Via Sierra Leone, reprovisioning there for 8 days, leaving 19-07-1636; stayed in the Indies and was wrecked near Pulicat, 13-10-1638.');
INSERT INTO "voyages" VALUES (479, '', 2, '', 'ZEELANDIA', 'Denijs Anthonisz.', 600, NULL, '1631', NULL, NULL, 'Z', 'Z', '1636-05-04', 'Wielingen', NULL, NULL, true, '1636-11-06', 'Batavia', 5256, '8 days, leaving 19-07-1636.');
INSERT INTO "voyages" VALUES (480, '', 1, '', 'HAARLEM', NULL, 500, NULL, NULL, NULL, NULL, 'A', 'A', '1636-08-13', 'Texel', '1637-02-01', NULL, true, '1637-10-20', 'Batavia', 5261, '0480-0493 (except 0486) departed with 2669 men, arrived with 2511, amongst whom 637 soldiers; death-toll 158 (Coolhaas, I, 598).');
INSERT INTO "voyages" VALUES (481, '', 7, '', 'HOLLANDIA', NULL, 700, NULL, NULL, NULL, NULL, 'A', 'A', '1636-08-13', 'Texel', NULL, NULL, true, '1637-10-02', 'Batavia', 5263, NULL);
INSERT INTO "voyages" VALUES (482, '', 5, '', 'NASSAU', 'Jan Springer', 550, NULL, NULL, NULL, NULL, 'A', 'A', '1636-08-13', 'Texel', NULL, NULL, true, '1637-10-05', 'Batavia', 5264, NULL);
INSERT INTO "voyages" VALUES (483, '', 4, '', 'WEZEL', NULL, 550, NULL, '1629', NULL, NULL, 'A', 'A', '1636-08-13', 'Texel', NULL, NULL, true, '1637-10-05', 'Batavia', 5265, NULL);
INSERT INTO "voyages" VALUES (484, '', 1, '', 'AKERSLOOT', NULL, 360, 'jacht', '1636', NULL, NULL, 'A', 'A', '1636-12-03', 'Texel', NULL, NULL, true, '1637-04-28', 'Batavia', 5273, NULL);
INSERT INTO "voyages" VALUES (485, '', 3, '', 'AMSTERDAM', NULL, 550, NULL, '1632', NULL, NULL, 'A', 'A', '1636-12-03', 'Texel', NULL, NULL, true, '1637-04-26', 'Batavia', 5267, NULL);
INSERT INTO "voyages" VALUES (486, '', 3, '', 'HOORN', NULL, 550, NULL, NULL, NULL, NULL, 'H', 'H', '1637-01-06', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Sailed on the shallows off Brouwershaven and was wrecked; crew and cargo were saved.');
INSERT INTO "voyages" VALUES (487, '', 2, '', '''S HERTOGENBOSCH', 'Kornelis Leendertsz. Blauw', 600, NULL, '1631', NULL, NULL, 'D', 'D', '1637-01-08', 'Goeree', NULL, NULL, true, '1637-07-20', 'Batavia', 5283, NULL);
INSERT INTO "voyages" VALUES (488, '', 2, '', 'MAASTRICHT', NULL, 600, NULL, NULL, NULL, NULL, 'R', 'R', '1637-01-08', 'Goeree', NULL, NULL, true, '1637-07-25', 'Batavia', 5272, NULL);
INSERT INTO "voyages" VALUES (489, '', 1, '', 'GRAFT', NULL, 200, 'fluit', NULL, NULL, NULL, NULL, 'A', '1637-02-15', 'Texel', NULL, NULL, true, '1637-07-24', 'Batavia', NULL, 'Stayed in the Indies and was laid up, probably 1646.');
INSERT INTO "voyages" VALUES (490, '', 1, '', 'RIJP', NULL, 200, 'fluit', NULL, NULL, NULL, NULL, 'A', '1637-02-15', 'Texel', NULL, NULL, true, '1637-07-18', 'Batavia', NULL, 'Stayed in the Indies and was laid up in 1648.');
INSERT INTO "voyages" VALUES (491, '', 1, '', 'BROEKOORD', NULL, 200, 'fluit', NULL, NULL, NULL, 'E', 'E', '1637-02-20', 'Goeree', '1637-04-01', NULL, true, '1637-07-26', 'Batavia', NULL, 'Stayed in the Indies and was laid up in 1648.');
INSERT INTO "voyages" VALUES (492, '', 5, '', 'FREDERIK HENDRIK', 'Pieter Jansz.', 1100, NULL, '1626', NULL, NULL, 'Z', 'Z', '1637-02-22', 'Wielingen', NULL, NULL, true, '1637-09-05', 'Batavia', 5268, NULL);
INSERT INTO "voyages" VALUES (493, '', 1, '', 'HENRIETTE LOUISE', 'Willlem van Domburg', 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1637-02-22', 'Wielingen', NULL, NULL, true, '1637-09-05', 'Batavia', 5279, NULL);
INSERT INTO "voyages" VALUES (494, '', 1, '', 'RIJNSBURG', NULL, 200, 'jacht', NULL, NULL, NULL, 'A', 'A', '1637-10-11', 'Texel', NULL, NULL, false, '1638-04-28', 'Batavia', 494, 'Philippines.');
INSERT INTO "voyages" VALUES (495, '', 1, '', 'VALKENBURG', NULL, 200, 'jacht', NULL, NULL, NULL, 'A', 'A', '1637-10-11', 'Texel', NULL, NULL, false, '1638-04-20', 'Batavia', NULL, 'Stayed in the Indies and was foundered on the rocks, east of Banka, June 1647.');
INSERT INTO "voyages" VALUES (496, '', 1, '', 'MAAN', NULL, 200, 'fluit', NULL, NULL, NULL, 'A', 'A', '1637-12-31', 'Texel', NULL, NULL, false, '1638-09-19', 'Batavia', NULL, 'stayed in the Indies and ran ashore at Solor, 10-04-1642.');
INSERT INTO "voyages" VALUES (497, '', 1, '', 'ZON', NULL, 200, 'fluit', NULL, NULL, NULL, 'A', 'A', '1637-12-31', 'Texel', '1638-03-01', NULL, true, '1638-07-09', 'Batavia', 14, 'men killed at the Cape; the ship stayed in the Indies and was lost in the Pescadores, 31-12-1639.');
INSERT INTO "voyages" VALUES (498, '', 2, '', 'ZWOLLE', NULL, 360, NULL, NULL, NULL, NULL, 'A', 'A', '1637-12-31', 'Texel', NULL, NULL, false, '1638-06-23', 'Batavia', 5275, NULL);
INSERT INTO "voyages" VALUES (499, '', 1, '', 'WIJDENES', NULL, 160, 'jacht', NULL, NULL, NULL, 'E', 'E', '1637-12-31', 'Texel', NULL, NULL, false, '1638-06-02', 'Batavia', NULL, 'Stayed in the Indies. Attacked by natives and blown to pieces, 07-07-1643.');
INSERT INTO "voyages" VALUES (500, '', 1, '', 'ARNEMUIDEN', 'Laurens Laurensz.', 200, 'jacht', '1620', NULL, NULL, 'Z', 'Z', '1638-01-14', 'Wielingen', NULL, NULL, false, '1638-07-04', 'Batavia', NULL, 'Stayed in the Indies and was laid up in Batavia, 1652.');
INSERT INTO "voyages" VALUES (501, '', 1, '', 'GRIJPSKERKE', 'Kornelis Gerpers', 120, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1638-01-14', 'Wielingen', NULL, NULL, false, '1638-06-30', 'Batavia', NULL, 'Stayed in the Indies and was laid up in Malacca, 1653.');
INSERT INTO "voyages" VALUES (502, '', 3, '', 'ZEELANDIA', 'Jan de Laat', 600, NULL, '1631', NULL, NULL, 'Z', 'Z', '1638-01-14', 'Wielingen', NULL, NULL, false, '1638-07-03', 'Batavia', 5274, NULL);
INSERT INTO "voyages" VALUES (503, '', 3, '', 'AEMILIA', 'Joost Salters', 600, NULL, NULL, NULL, NULL, 'Z', 'A', '1638-04-12', 'Wielingen', '1638-07-01', NULL, true, '1638-10-24', 'Batavia', NULL, 'Ran ashore at Taiwan, 21-06-1639.');
INSERT INTO "voyages" VALUES (504, '', 1, '', 'NOORDSTER', 'Kornelis Jaspersz.', 200, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1638-04-12', 'Wielingen', NULL, NULL, false, '1638-12-05', 'Batavia', 5269, NULL);
INSERT INTO "voyages" VALUES (505, '', 1, '', 'WELSINGEN', 'Kornelis Roeleman', 80, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1638-04-12', 'Wielingen', NULL, NULL, false, '1638-10-24', 'Batavia', NULL, 'Stayed in the Indies and was laid up, 1649.');
INSERT INTO "voyages" VALUES (506, '', 3, '', 'AMBOINA', NULL, 550, NULL, '1629', NULL, NULL, 'A', 'A', '1638-04-15', 'Texel', NULL, NULL, false, '1638-12-07', 'Batavia', 5271, 'From 25-05 till 31-05 at S. Vicente.');
INSERT INTO "voyages" VALUES (507, '', 1, '', 'ENGEL', 'Abel Tasman', 360, 'fluit', NULL, NULL, NULL, NULL, 'A', '1638-04-15', 'Texel', NULL, NULL, false, '1638-10-11', 'Batavia', NULL, 'From 25-05 till 31-05 at S. Vicente, via Mauritius; the ship stayed in the Indies and was laid up in Batavia, 1648.');
INSERT INTO "voyages" VALUES (508, '', 1, '', 'ROEK', NULL, 200, 'fluit', NULL, NULL, NULL, NULL, 'A', '1638-04-15', 'Texel', NULL, NULL, true, '1639-04-25', 'Batavia', NULL, 'From 25-05 till 31-05 at S. Vicente, via Mauritius; the ship stayed in the Indies and was lost off Amboina, 15-02-1645.');
INSERT INTO "voyages" VALUES (509, '', 4, '', 'ZUTPHEN', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1638-04-27', 'Zeeland', NULL, NULL, false, '1638-10-11', 'Batavia', 5270, NULL);
INSERT INTO "voyages" VALUES (510, '', 1, '', 'BREDA', NULL, 1050, NULL, '1637', NULL, NULL, 'H', 'H', '1638-05-05', 'Texel', '1638-12-09', NULL, true, '1639-03-18', 'Batavia', 5280, 'From 16-06 till 20-06 at S. Vicente.');
INSERT INTO "voyages" VALUES (511, '', 2, '', 'ENKHUIZEN', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'E', '1638-05-05', 'Texel', NULL, NULL, true, '1639-04-25', 'Batavia', 5277, 'arrival December 20th., departure 5 weeks later.');
INSERT INTO "voyages" VALUES (512, '', 3, '', 'BANDA', 'Aris Kornelisz. Groes', 550, NULL, '1633', NULL, NULL, 'A', 'A', '1638-11-24', 'Texel', '1639-05-03', '1639-05-15', true, '1639-05-19', 'Batavia', 5285, NULL);
INSERT INTO "voyages" VALUES (513, '', 4, '', 'AMSTERDAM', NULL, 550, NULL, '1632', NULL, NULL, 'A', 'A', '1639-01-12', 'Texel', NULL, NULL, true, '1639-05-05', 'Batavia', 5276, 'Via Mauritius.');
INSERT INTO "voyages" VALUES (514, '', 1, '', 'CASTRICUM', NULL, 200, 'fluit', NULL, NULL, NULL, NULL, 'A', '1639-01-12', 'Texel', NULL, NULL, true, '1639-06-17', 'Batavia', NULL, 'Stayed in the Indies and was laid up in Amboina, December 1651.');
INSERT INTO "voyages" VALUES (515, '', 1, '', 'FRANEKER', NULL, 120, 'jacht', NULL, NULL, NULL, 'E', 'E', '1639-01-12', 'Texel', NULL, NULL, true, '1639-06-18', 'Batavia', NULL, 'off Malacca, 18-01-1642.');
INSERT INTO "voyages" VALUES (516, '', 2, '', 'HAARLEM', NULL, 500, NULL, NULL, NULL, NULL, 'A', 'A', '1639-01-12', 'Texel', NULL, NULL, true, '1639-06-17', 'Batavia', 5293, NULL);
INSERT INTO "voyages" VALUES (517, '', 1, '', 'HERT', NULL, 200, 'fluit', NULL, NULL, NULL, NULL, 'E', '1639-01-12', 'Texel', NULL, NULL, true, '1639-06-17', 'Batavia', NULL, 'Also mentioned as VLIEGENDE HERT; stayed in the Indies and was wrecked in the Pescadores, 1643.');
INSERT INTO "voyages" VALUES (518, '', 4, '', 'LEEUWARDEN', NULL, 550, NULL, '1629', NULL, NULL, 'E', 'E', '1639-01-12', 'Texel', NULL, NULL, true, '1639-06-18', 'Batavia', 5287, NULL);
INSERT INTO "voyages" VALUES (519, '', 1, '', 'LISSE', NULL, 120, 'jacht', '1637', NULL, NULL, 'A', 'A', '1639-01-12', 'Texel', NULL, NULL, true, '1639-05-21', 'Batavia', NULL, 'Stayed in the Indies and was laid up in Batavia, February 1650.');
INSERT INTO "voyages" VALUES (520, '', 1, '', 'MEERMAN', NULL, 200, 'fluit', NULL, NULL, NULL, 'A', 'A', '1639-01-12', 'Texel', NULL, NULL, true, '1639-08-20', 'Batavia', NULL, 'stayed in the Indies and was laid up in Batavia, 1652.');
INSERT INTO "voyages" VALUES (521, '', 4, '', 'MIDDELBURG', 'Dominicus Bouwens', 550, NULL, NULL, NULL, NULL, NULL, 'Z', '1639-01-14', 'Wielingen', NULL, NULL, true, '1639-06-29', 'Batavia', 5289, NULL);
INSERT INTO "voyages" VALUES (522, '', 1, '', 'ZIERIKZEE', 'Anthonis Jansz.', 400, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1639-01-14', 'Wielingen', NULL, NULL, true, '1639-06-30', 'Batavia', NULL, 'fighting the Portuguese and was lost, 06-12-1639.');
INSERT INTO "voyages" VALUES (523, '', 1, '', 'CAPELLE', NULL, 200, 'fluit', NULL, NULL, NULL, 'R', 'R', '1639-03-12', 'Goeree', NULL, NULL, true, '1639-09-20', 'Batavia', NULL, 'Stayed in the Indies and was laid up, 1647.');
INSERT INTO "voyages" VALUES (524, '', 1, '', 'KONING DAVID', 'Jan Taaikaas', 200, 'fluit', NULL, NULL, NULL, NULL, 'Z', '1639-03-12', 'Wielingen', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked on the S.E. coast of Madagascar, 29-08-1639.');
INSERT INTO "voyages" VALUES (525, '', 1, '', 'PAUW', 'Dirk Hermansz.', 200, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1639-03-12', 'Wielingen', NULL, NULL, true, '1639-11-12', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (526, '', 3, '', 'HOF VAN HOLLAND', 'Jan Bouwensz.van Delft', 500, NULL, NULL, NULL, NULL, 'D', 'D', '1639-04-19', 'Goeree', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked off Sierra Leone, June or July 14th; crew and cargo were saved.');
INSERT INTO "voyages" VALUES (527, '', 1, '', 'HEEMSKERK', NULL, 120, 'jacht', NULL, NULL, NULL, NULL, 'A', '1639-04-29', 'Texel', '1639-09-11', NULL, true, '1639-11-22', 'Batavia', NULL, 'and was laid up, 1649.');
INSERT INTO "voyages" VALUES (528, '', 8, '', 'HOLLANDIA', NULL, 700, NULL, NULL, NULL, NULL, 'A', 'A', '1639-04-29', 'Texel', '1639-09-05', '1639-10-09', true, '1639-12-25', 'Batavia', NULL, 'Stayed in the Indies and ran ashore on Lombok, 27-12-1642.');
INSERT INTO "voyages" VALUES (529, '', 1, '', 'MARIA DE MEDICI', NULL, 700, NULL, NULL, NULL, NULL, 'A', 'A', '1639-04-29', 'Texel', '1639-09-05', '1639-10-09', true, '1639-12-18', 'Batavia', 5281, NULL);
INSERT INTO "voyages" VALUES (530, '', 6, '', 'NASSAU', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'H', '1639-04-29', 'Texel', NULL, NULL, true, '1640-01-13', 'Batavia', 5284, '0530, 0532-42 and 0544-7 arrived with 1708 sailors and 697 soldiers at Batavia; death-toll 112 (Coolhaas II, 124).');
INSERT INTO "voyages" VALUES (531, '', 5, '', 'WEZEL', NULL, 550, NULL, '1629', NULL, NULL, 'A', 'A', '1639-04-29', 'Texel', '1639-09-12', '1639-10-09', true, '1639-12-18', 'Batavia', 5282, NULL);
INSERT INTO "voyages" VALUES (532, '', 1, '', 'LIMMEN', NULL, 120, 'jacht', NULL, NULL, NULL, 'A', 'A', '1639-09-01', 'Texel', NULL, NULL, true, '1640-04-29', 'Batavia', NULL, 'Stayed in the Indies and was laid up in Malacca, 1652.');
INSERT INTO "voyages" VALUES (533, '', 1, '', 'WITTE OLIFANT', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1639-09-01', 'Texel', NULL, NULL, true, '1640-03-16', 'Batavia', 5297, NULL);
INSERT INTO "voyages" VALUES (534, '', 1, '', 'ROB', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'A', '1640-01-01', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked in a storm when ready to leave Texel, 05-01-1640.');
INSERT INTO "voyages" VALUES (535, '', 2, '', 'AKERSLOOT', NULL, 360, 'jacht', '1636', NULL, NULL, 'A', 'A', '1640-01-17', 'Texel', NULL, NULL, true, '1640-07-27', 'Batavia', NULL, 'Stayed in the Indies and was laid up in Batavia, 1652.');
INSERT INTO "voyages" VALUES (536, '', 1, '', 'BERKHOUT', NULL, 400, 'fluit', '1639', NULL, NULL, 'H', 'H', '1640-01-17', 'Texel', NULL, NULL, true, '1640-09-30', 'Batavia', 5292, NULL);
INSERT INTO "voyages" VALUES (537, '', 1, '', 'BRAK', NULL, NULL, 'galjoot', NULL, NULL, NULL, 'E', 'E', '1640-01-17', 'Texel', NULL, NULL, true, '1640-07-30', 'Batavia', NULL, 'Stayed in the Indies and was wrecked in the river Ganges, 10-08-1648.');
INSERT INTO "voyages" VALUES (538, '', 1, '', 'ORANJEBOOM', NULL, 200, 'fluit', NULL, NULL, NULL, 'A', 'A', '1640-01-17', 'Texel', NULL, NULL, true, '1640-08-05', 'Batavia', NULL, 'Stayed in the Indies, captured by Japanese and Cambodians in 1643, restored by them to the Dutch and broken up in Batavia, 1647.');
INSERT INTO "voyages" VALUES (539, '', 1, '', 'SNOEK', NULL, 560, 'jacht', NULL, NULL, NULL, 'A', 'A', '1640-01-17', 'Texel', NULL, NULL, true, '1640-07-29', 'Batavia', 5301, NULL);
INSERT INTO "voyages" VALUES (540, '', 1, '', 'ZAAIER', NULL, 400, 'fluit', NULL, NULL, NULL, 'A', 'A', '1640-01-17', 'Texel', NULL, NULL, true, '1640-08-27', 'Batavia', NULL, 'Stayed in the Indies and was laid up, 1650.');
INSERT INTO "voyages" VALUES (541, '', 4, '', 'AMBOINA', NULL, 550, NULL, '1629', NULL, NULL, 'A', 'A', '1640-01-19', 'Texel', NULL, NULL, true, '1640-08-06', 'Batavia', NULL, 'Stayed in the Indies and scuttled in bad condition in the Philippines, 09-11-1647.');
INSERT INTO "voyages" VALUES (542, '', 1, '', 'NEPTUNUS', NULL, NULL, NULL, NULL, NULL, NULL, 'A', 'A', '1640-01-19', 'Texel', '1640-06-13', '1640-06-20', true, '1640-08-29', 'Batavia', NULL, 'in the Indies; ran ashore on the coast of Coromandel, 03-10-1643.');
INSERT INTO "voyages" VALUES (543, '', 1, '', 'ZEEHAAN', NULL, NULL, 'fluit', NULL, NULL, NULL, 'A', 'A', '1640-01-19', 'Texel', NULL, NULL, true, '1640-09-29', 'Cambodia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (544, '', 5, '', 'ZUTPHEN', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1640-01-19', 'Texel', NULL, NULL, true, '1640-07-29', 'Batavia', 5291, 'Via Surat.');
INSERT INTO "voyages" VALUES (545, '', 4, '', 'ZEELANDIA', 'Huibrecht Huibrechtsz.', 600, NULL, '1631', NULL, NULL, 'Z', 'Z', '1640-01-20', 'Wielingen', NULL, NULL, true, '1640-07-28', 'Batavia', 5300, NULL);
INSERT INTO "voyages" VALUES (546, '', 6, '', 'FREDERIK HENDRIK', 'Aris Arisz.', 1100, NULL, '1626', NULL, NULL, 'Z', 'Z', '1640-02-19', 'Wielingen', NULL, NULL, true, '1640-08-26', 'Batavia', 5287, NULL);
INSERT INTO "voyages" VALUES (547, '', 1, '', 'LIEFDE', 'Hans Arendsz.', 500, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1640-02-17', 'Wielingen', NULL, NULL, true, '1640-08-26', 'Batavia', NULL, 'Stayed in the Indies and was laid up in Batavia, 1658.');
INSERT INTO "voyages" VALUES (548, '', 3, '', 'MAASTRICHT', NULL, 600, NULL, NULL, NULL, NULL, 'R', 'R', '1640-04-30', 'Goeree', NULL, NULL, true, '1640-10-30', 'Batavia', 5294, 'No ports of call.');
INSERT INTO "voyages" VALUES (549, '', 1, '', 'DOLFIJN', 'Markus Jansz.', 200, 'fluit', NULL, NULL, NULL, NULL, 'Z', '1640-05-02', 'Wielingen', NULL, NULL, true, '1641-01-02', 'Batavia', NULL, 'Stayed in the Indies and was laid up in Batavia, 1648.');
INSERT INTO "voyages" VALUES (550, '', 1, '', 'GULDEN BUIS', 'Gerrit Vinkenburg', NULL, 'fluit', NULL, NULL, NULL, 'A', 'A', '1640-05-03', 'Texel', NULL, NULL, true, '1641-04-29', 'Batavia', NULL, 'in the Indies and was lost south of the Isle of Champello.');
INSERT INTO "voyages" VALUES (551, '', 1, '', 'HEEMSTEDE', NULL, 400, 'fluit', NULL, NULL, NULL, 'A', 'A', '1640-05-03', 'Texel', NULL, NULL, true, '1640-12-17', 'Batavia', 5295, 'According to Daghregister the HEEMSTEDE was a jacht.');
INSERT INTO "voyages" VALUES (552, '', 1, '', 'KIEVIT', NULL, 100, 'jacht', NULL, NULL, NULL, 'A', 'A', '1640-05-03', 'Texel', NULL, NULL, true, '1640-11-26', 'Batavia', NULL, 'Stayed in the Indies, laid up in Batavia and sold, 15-02-1659.');
INSERT INTO "voyages" VALUES (553, '', 1, '', 'SALAMANDER', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1640-05-03', 'Texel', NULL, NULL, true, '1640-10-27', 'Batavia', 5290, 'Via Maio Island.');
INSERT INTO "voyages" VALUES (554, '', 1, '', 'WALVIS', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1640-05-03', 'Texel', NULL, NULL, true, '1640-10-30', 'Batavia', 5302, 'Via Maio Island and Mauritius.');
INSERT INTO "voyages" VALUES (555, '', 1, '', 'EENDRACHT', 'Adriaan Blok', 200, 'fluit', NULL, NULL, NULL, NULL, 'Z', '1640-05-17', 'Wielingen', NULL, NULL, true, '1641-01-03', 'Batavia', NULL, 'Stayed in the Indies and was laid up, 1649.');
INSERT INTO "voyages" VALUES (556, '', 2, '', 'NOORDSTER', 'Jonathan de Nekker', 200, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1640-05-17', 'Wielingen', NULL, NULL, true, '1641-01-02', 'Batavia', NULL, 'Stayed in the Indies and was laid up, 1649.');
INSERT INTO "voyages" VALUES (557, '', 1, '', 'SPAANS GALJOEN', 'Samuel de Butter', 600, NULL, NULL, NULL, NULL, NULL, 'Z', '1640-05-18', 'Wielingen', '1640-12-01', NULL, true, '1641-02-22', 'Batavia', NULL, 'Stayed in the Indies.');
INSERT INTO "voyages" VALUES (558, '', 2, '', 'MARIA DE MEDICI', NULL, 700, NULL, NULL, NULL, NULL, 'A', 'A', '1640-09-20', 'Texel', '1640-12-01', NULL, true, '1641-03-13', 'Batavia', NULL, 'Stayed in the Indies and was lost south of the Isle of Champello, 26-11-1641.');
INSERT INTO "voyages" VALUES (559, '', 1, '', 'WATERHOND', NULL, NULL, 'jacht', NULL, NULL, NULL, 'A', 'A', '1640-09-20', 'Texel', NULL, NULL, true, '1641-03-27', 'Batavia', NULL, 'Stayed in the Indies and was laid up, 1648.');
INSERT INTO "voyages" VALUES (560, '', 5, '', 'AMSTERDAM', NULL, 550, NULL, '1632', NULL, NULL, 'A', 'A', '1640-12-13', 'Texel', '1641-04-01', NULL, true, '1641-06-07', 'Batavia', 5303, NULL);
INSERT INTO "voyages" VALUES (561, '', 2, '', 'HARDERWIJK', NULL, 400, NULL, NULL, NULL, NULL, 'A', 'A', '1640-12-13', 'Texel', '1641-03-01', NULL, true, '1641-06-11', 'Batavia', NULL, 'in the Moluccas, 1652. According to Schoute 234 men were on board.');
INSERT INTO "voyages" VALUES (562, '', 2, '', 'PETTEN', 'Andries Adriaansz.', 200, 'fluit', NULL, NULL, NULL, 'A', 'A', '1640-12-13', 'Texel', NULL, NULL, true, '1641-09-14', 'Batavia', NULL, 'Via Mauritius, where 12 men stayed behind; from 19-06 till 16-07-1641. In June the master Adriaansz. was placed on board of the HAARLEM. The ship stayed in the Indies and was laid up in Batavia, 1649.');
INSERT INTO "voyages" VALUES (563, '', 1, '', 'UITGEEST', NULL, 600, 'fluit', NULL, NULL, NULL, 'A', 'A', '1640-12-13', 'Texel', NULL, NULL, true, '1641-05-20', 'Batavia', NULL, 'Stayed in the Indies and was used at Onrust, 1653.');
INSERT INTO "voyages" VALUES (564, '', 2, '', 'BREDA', NULL, 1050, NULL, '1637', NULL, NULL, 'H', 'H', '1640-12-25', 'Texel', NULL, NULL, true, '1641-06-12', 'Batavia', 5296, NULL);
INSERT INTO "voyages" VALUES (565, '', 3, '', 'ENKHUIZEN', NULL, 550, NULL, NULL, NULL, NULL, NULL, 'E', '1640-12-25', 'Texel', '1641-02-01', NULL, true, '1641-05-19', 'Batavia', 5305, NULL);
INSERT INTO "voyages" VALUES (566, '', 3, '', '''S HERTOGENBOSCH', 'Kornelis Leendertsz. Blauw', 600, NULL, '1631', NULL, NULL, 'D', 'D', '1640-12-29', 'Goeree', NULL, NULL, true, '1641-05-12', 'Batavia', 5307, 'No ports of call.');
INSERT INTO "voyages" VALUES (567, '', 1, '', 'BERGEN OP ZOOM', 'David Dingemans', 300, 'jacht', '1640', NULL, NULL, 'Z', 'Z', '1641-03-07', 'Wielingen', NULL, NULL, true, '1641-08-17', 'Batavia', NULL, 'Stayed in the Indies; was wrecked on a reef south of Celebes, 04-03-1650.');
INSERT INTO "voyages" VALUES (568, '', 2, '', 'HENRIETTE LOUISE', 'Willem van Domburg', 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1641-03-07', 'Wielingen', NULL, NULL, true, '1641-07-31', 'Batavia', 5306, NULL);
INSERT INTO "voyages" VALUES (569, '', 1, '', 'VERENIGDE PROVINCIEN', 'Pieter Jansz.', 1100, NULL, '1640', NULL, NULL, 'Z', 'Z', '1641-03-07', 'Zeeland', NULL, NULL, true, '1641-09-04', 'Batavia', 5298, NULL);
INSERT INTO "voyages" VALUES (570, '', 1, '', 'VOGELSTRUIS', NULL, 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1641-04-27', 'Texel', '1641-08-09', NULL, true, '1641-11-08', 'Batavia', 5299, NULL);
INSERT INTO "voyages" VALUES (571, '', 6, '', 'WEZEL', NULL, 550, NULL, '1629', NULL, NULL, 'A', 'A', '1641-04-27', 'Texel', NULL, NULL, true, '1641-12-01', 'Batavia', 5304, 'already.');
INSERT INTO "voyages" VALUES (572, '', 1, '', 'ROTTERDAM', NULL, 1100, NULL, NULL, NULL, NULL, 'R', 'R', '1641-04-28', 'Goeree', NULL, NULL, true, '1642-06-16', 'Batavia', 5314, 'From 21-07 till 31-10-1641 back in Goeree.');
INSERT INTO "voyages" VALUES (573, '', 1, '', 'WAKENDE BOEI', 'Kornelis Koole', 50, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1641-05-03', 'Wielingen', NULL, NULL, true, '1642-02-14', 'Batavia', NULL, 'Via Pernambuco; the ship stayed in the Indies.');
INSERT INTO "voyages" VALUES (574, '', 1, '', 'LILLO', 'Jean Lalphart', 240, 'jacht', '1640', NULL, NULL, 'Z', 'Z', '1641-05-03', 'Wielingen', NULL, NULL, true, '1642-02-14', 'Batavia', NULL, 'Via Pernambuco; the ship stayed in the Indies, was wrecked on the roadstead of Batavia and broken up, January 1657.');
INSERT INTO "voyages" VALUES (575, '', 7, '', 'NASSAU', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1641-09-16', 'Texel', '1642-01-13', '1642-01-25', true, '1642-04-03', 'Batavia', 5312, 'Crew of the NASSAU and the TIJGER together at arrival: seafarers, 310; soldiers, 208; deaths during the voyage, 23.');
INSERT INTO "voyages" VALUES (576, '', 1, '', 'TIJGER', 'Pieter Dirksz.', 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1641-09-16', 'Texel', '1642-01-25', NULL, true, '1642-04-02', 'Batavia', 5309, 'See number 0575.');
INSERT INTO "voyages" VALUES (577, '', 4, '', 'BANDA', NULL, 550, NULL, '1633', NULL, NULL, 'A', 'A', '1642-01-14', 'Texel', '1642-02-02', NULL, true, '1642-09-19', 'Batavia', 5327, NULL);
INSERT INTO "voyages" VALUES (578, '', 1, '', 'HAAN', NULL, 480, NULL, NULL, NULL, NULL, NULL, 'A', '1642-01-14', 'Texel', NULL, NULL, true, '1643-03-05', 'Batavia', NULL, 'in the Indies and was lost off Negombo, 1651.');
INSERT INTO "voyages" VALUES (579, '', 2, '', 'HEEMSTEDE', NULL, 400, 'fluit', NULL, NULL, NULL, 'A', 'A', '1642-01-14', 'Texel', NULL, NULL, true, '1643-05-19', 'Batavia', NULL, 'According to Aanw. 1891/19e departure 07-03-1642; returned to Texel and sailed again 30-09-1642. Then, having lost its masts back to Texel in October, sailing again 02-11-1642. The ship stayed in the Indies and was burnt in Bengal, 09-10-1650.');
INSERT INTO "voyages" VALUES (580, '', 1, '', 'LUIPAARD', NULL, 320, 'jacht', NULL, NULL, NULL, 'A', 'A', '1642-01-14', 'Texel', NULL, NULL, true, '1642-08-30', 'Batavia', NULL, 'Stayed in the Indies; on a reef south of Celebes, 04-03-1650.');
INSERT INTO "voyages" VALUES (581, '', 1, '', 'VREDE', NULL, 800, NULL, '1641', NULL, NULL, 'A', 'A', '1642-01-14', 'Texel', NULL, NULL, true, '1642-08-01', 'Batavia', 5310, 'The crew of the VREDE and the MAASTRICHT together at arrival: seafarers, 359; soldiers, 155; deaths during the voyage, 7.');
INSERT INTO "voyages" VALUES (582, '', 1, '', 'WESTFRIESLAND', NULL, 1100, NULL, '1641', NULL, NULL, 'H', 'H', '1642-01-14', 'Texel', NULL, NULL, true, '1642-09-08', 'Batavia', 5311, NULL);
INSERT INTO "voyages" VALUES (583, '', 4, '', 'MAASTRICHT', NULL, 600, NULL, NULL, NULL, NULL, 'R', 'R', '1642-03-02', 'Goeree', NULL, NULL, true, '1642-08-01', 'Batavia', NULL, 'See number 0581 for the crew. T he MAASTRICHT stayed in the Indies and was lost, sailing from Malabar to Batavia.');
INSERT INTO "voyages" VALUES (584, '', 1, '', 'DELFT', 'Jakob Theunisz. Buis', 670, NULL, '1641', NULL, NULL, 'D', 'D', '1642-03-03', 'Goeree', NULL, NULL, true, '1642-10-28', 'Batavia', 5322, NULL);
INSERT INTO "voyages" VALUES (585, '', 1, '', 'HAZEWIND', NULL, 60, 'galjoot', NULL, NULL, NULL, 'E', 'E', '1642-03-07', 'Texel', NULL, NULL, true, '1642-08-19', 'Batavia', 1654, 'Stayed in the Indies and was laid up.');
INSERT INTO "voyages" VALUES (586, '', 5, '', 'LEEUWARDEN', NULL, 550, NULL, '1629', NULL, NULL, 'E', 'E', '1642-03-07', 'Texel', NULL, NULL, true, '1642-08-30', 'Batavia', 5321, NULL);
INSERT INTO "voyages" VALUES (587, '', 5, '', 'MIDDELBURG', 'Jan van Stapelen', 550, NULL, NULL, NULL, NULL, NULL, 'Z', '1642-03-11', 'Wielingen', NULL, NULL, true, '1642-09-26', 'Batavia', 5308, NULL);
INSERT INTO "voyages" VALUES (588, '', 1, '', 'BRESKENS', 'Lieven van Couwenburg', NULL, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1642-03-26', 'Wielingen', NULL, NULL, true, '1642-12-21', 'Batavia', NULL, 'Stayed in the Indies and was lost in a sea battle in the Bay of Tigaol, 01-08-1646.');
INSERT INTO "voyages" VALUES (589, '', 7, '', 'FREDERIK HENDRIK', 'Michiel Vis', 1100, NULL, '1626', NULL, NULL, 'Z', 'Z', '1642-03-26', 'Wielingen', NULL, NULL, true, '1643-01-08', 'Batavia', NULL, 'Stayed in the Indies and was broken up in Ternate, 1646. According to Uitloopboek, 4389, wrecked on a reef in Strait Banka. According to Schoute 35 men had died at arrival.');
INSERT INTO "voyages" VALUES (590, '', 1, '', 'AREND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'A', '1642-04-23', 'Texel', NULL, NULL, true, '1642-12-10', 'Batavia', NULL, 'Via Mauritius September 6th, 1642; stayed in the Indies and was broken up in Surat, 1649.');
INSERT INTO "voyages" VALUES (591, '', 1, '', 'DELFSHAVEN', 'Kornelis Kornelisz. van Houten', 300, 'jacht', NULL, NULL, NULL, 'D', 'D', '1642-04-23', 'Goeree', NULL, NULL, true, '1642-10-03', 'Batavia', NULL, 'Wrecked near Majoe, 1653.');
INSERT INTO "voyages" VALUES (592, '', 1, '', 'LEEUWERIK', NULL, 80, 'jacht', NULL, NULL, NULL, 'A', 'A', '1642-04-23', 'Texel', NULL, NULL, true, '1642-09-21', 'Batavia', NULL, 'Stayed in the Indies and was broken up in Batavia, 1657.');
INSERT INTO "voyages" VALUES (593, '', 2, '', 'SALAMANDER', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1642-04-23', 'Texel', NULL, NULL, true, '1642-10-02', 'Batavia', 5320, NULL);
INSERT INTO "voyages" VALUES (594, '', 1, '', 'VISSER', NULL, NULL, 'galjoot', NULL, NULL, NULL, 'A', 'A', '1642-04-23', 'Texel', NULL, NULL, true, '1642-10-29', 'Batavia', NULL, 'lost in a sea battle in the Bay of Tigaol, 01-08-1646.');
INSERT INTO "voyages" VALUES (595, '', 6, '', 'ZUTPHEN', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1642-04-23', 'Texel', NULL, NULL, true, '1642-11-01', 'Batavia', 5313, 'Via Mauritius.');
INSERT INTO "voyages" VALUES (596, '', 2, '', 'VOGELSTRUIS', NULL, 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1642-09-29', 'Texel', NULL, NULL, true, '1643-06-25', 'Batavia', 5317, NULL);
INSERT INTO "voyages" VALUES (597, '', 2, '', 'ZWAAN', NULL, NULL, 'fluit', NULL, NULL, NULL, NULL, 'A', '1642-09-29', 'Texel', NULL, NULL, true, '1643-04-17', 'Batavia', NULL, 'Wrecked on a reef in the Pescadores 27-10-1644; crew, except 1 man, and cargo saved.');
INSERT INTO "voyages" VALUES (598, '', 6, '', 'AMSTERDAM', NULL, 550, NULL, '1632', NULL, NULL, 'A', 'A', '1643-01-25', 'Texel', NULL, NULL, true, '1643-07-29', 'Batavia', NULL, 'Via the Isle of Wight, departure 21-02-1643; stayed in the Indies and was laid up in Batavia, 1648.');
INSERT INTO "voyages" VALUES (599, '', 2, '', 'BERKHOUT', NULL, 400, 'fluit', '1639', NULL, NULL, 'H', 'H', '1643-01-25', 'Texel', NULL, NULL, true, '1643-09-26', 'Batavia', NULL, 'Stayed in the Indies and was laid up in Banda, 1655.');
INSERT INTO "voyages" VALUES (600, '', 3, '', 'BREDA', NULL, 1050, NULL, '1637', NULL, NULL, 'H', 'H', '1643-01-25', 'Texel', NULL, NULL, true, '1643-07-19', 'Batavia', 5315, 'Via the Isle of Wight, departure 21-02-1643.');
INSERT INTO "voyages" VALUES (601, '', 2, '', 'WITTE OLIFANT', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1643-01-25', 'Texel', NULL, NULL, true, '1643-07-29', 'Batavia', 5324, 'Via the Isle of Wight, departure 21-02-1643.');
INSERT INTO "voyages" VALUES (602, '', 2, '', 'SNOEK', NULL, 560, 'jacht', NULL, NULL, NULL, 'A', 'A', '1643-01-25', 'Texel', NULL, NULL, true, '1643-07-29', 'Batavia', NULL, 'Via the Isle of Wight, departure 21-02-1643; the ship stayed in the Indies and was laid u p in Ternate, 1654.');
INSERT INTO "voyages" VALUES (603, '', 7, '', 'WEZEL', NULL, 550, NULL, '1629', NULL, NULL, 'A', 'A', '1643-01-25', 'Texel', NULL, NULL, true, '1643-08-02', 'Batavia', NULL, 'in the Indies and was broken up, 1653.');
INSERT INTO "voyages" VALUES (604, '', 2, '', 'VERENIGDE PROVINCIEN', 'Balten Baltensz.', 1100, NULL, '1640', NULL, NULL, 'Z', 'Z', '1643-02-21', 'Wielingen', NULL, NULL, true, '1643-08-07', 'Batavia', 5316, NULL);
INSERT INTO "voyages" VALUES (605, '', 1, '', 'HOF VAN ZEELAND', 'Dirk Jansz. Vongel', 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1643-02-21', 'Wielingen', NULL, NULL, true, '1643-07-31', 'Batavia', 5319, NULL);
INSERT INTO "voyages" VALUES (606, '', 3, '', 'HAARLEM', NULL, 500, NULL, NULL, NULL, NULL, 'A', 'A', '1643-05-03', 'Texel', NULL, NULL, true, '1643-11-03', 'Batavia', 5328, NULL);
INSERT INTO "voyages" VALUES (607, '', 1, '', 'MALAKKA', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1643-05-03', 'Texel', NULL, NULL, true, '1643-11-03', 'Batavia', 5323, NULL);
INSERT INTO "voyages" VALUES (608, '', 2, '', 'WALVIS', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1643-05-03', 'Texel', NULL, NULL, true, '1643-11-04', 'Batavia', 5318, NULL);
INSERT INTO "voyages" VALUES (609, '', 5, '', 'ZEELANDIA', 'Pieter Rutheunisz.', 600, NULL, '1631', NULL, NULL, 'Z', 'Z', '1643-05-22', 'Wielingen', NULL, NULL, true, '1643-11-04', 'Batavia', 5326, NULL);
INSERT INTO "voyages" VALUES (610, '', 1, '', 'ZEEMEEUW', 'Alexander Hendriksz.', 100, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1643-05-22', 'Wielingen', NULL, NULL, true, '1643-12-12', 'Batavia', NULL, 'Lost east of Batavia, 1653.');
INSERT INTO "voyages" VALUES (611, '', 1, '', 'HARING', NULL, 100, 'jacht', NULL, NULL, NULL, 'A', 'A', '1643-10-04', 'Texel', NULL, NULL, true, '1644-05-03', 'Batavia', NULL, 'Broke up on a reef near Amboina, May 1656.');
INSERT INTO "voyages" VALUES (612, '', 1, '', 'EILAND MAURITIUS', 'Pieter Theunisz.', NULL, NULL, NULL, NULL, NULL, 'A', 'A', '1643-10-04', 'Texel', NULL, NULL, true, NULL, NULL, NULL, '07-02-1644. The crew sailed to Batavia on board of the TIJGER and the VREDE.');
INSERT INTO "voyages" VALUES (613, '', 2, '', 'TIJGER', NULL, 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1643-10-04', 'Texel', '1644-02-07', NULL, true, '1644-04-04', 'Batavia', 5333, '25 Seafarers and 70 soldiers of the EILAND MAURITIUS.');
INSERT INTO "voyages" VALUES (614, '', 2, '', 'VREDE', 'Douwe Aukes', 800, NULL, '1641', NULL, NULL, 'A', 'A', '1643-10-04', 'Texel', '1644-02-09', NULL, true, '1644-05-21', 'Batavia', 5334, 'According to Coolhaas 73 deaths; the 69 men came from the EILAND MAURITIUS (0612).');
INSERT INTO "voyages" VALUES (615, '', 1, '', 'ZWARTE BEER', NULL, 380, 'fluit', NULL, NULL, NULL, 'A', 'A', '1644-01-17', 'Texel', NULL, NULL, true, '1644-05-27', 'Batavia', NULL, 'According to Coolhaas 1 death; the ship stayed in the Indies and was sold in 1655.');
INSERT INTO "voyages" VALUES (616, '', 4, '', 'ENKHUIZEN', 'Dirksz. Kien', 700, NULL, NULL, NULL, NULL, NULL, 'E', '1644-01-17', 'Texel', '1644-04-12', NULL, true, '1644-07-12', 'Batavia', 5330, NULL);
INSERT INTO "voyages" VALUES (617, '', 8, '', 'NASSAU', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1644-01-17', 'Texel', NULL, NULL, true, '1644-06-11', 'Batavia', NULL, 'No ports of call. The ship stayed in the Indies and was laid up in Amboina, 1652.');
INSERT INTO "voyages" VALUES (618, '', 2, '', 'WESTFRIESLAND', NULL, 1100, NULL, '1641', NULL, NULL, 'H', 'H', '1644-01-17', 'Texel', NULL, NULL, true, '1644-06-06', 'Batavia', 5336, '330 men on board when leaving Texel.');
INSERT INTO "voyages" VALUES (619, '', 1, '', 'ZEEWOLF', NULL, 340, 'fluit', NULL, NULL, NULL, 'A', 'A', '1644-01-17', 'Texel', NULL, NULL, true, '1644-06-06', 'Batavia', NULL, 'Stayed in the Indies and was laid up in Batavia, 1653.');
INSERT INTO "voyages" VALUES (620, '', 1, '', 'OVERSCHIE', NULL, 360, 'fluit', '1643', NULL, NULL, 'D', 'D', '1644-01-20', 'Maas', NULL, NULL, true, '1644-05-27', 'Batavia', NULL, 'Wrecked on the coast of Coromandel, 21-12-1653.');
INSERT INTO "voyages" VALUES (621, '', 2, '', 'ROTTERDAM', NULL, 1100, NULL, NULL, NULL, NULL, 'R', 'R', '1644-01-20', 'Goeree', NULL, NULL, true, '1644-06-06', 'Batavia', 5332, NULL);
INSERT INTO "voyages" VALUES (622, '', 3, '', 'HENRIETTE LOUISE', NULL, 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1644-01-21', 'Wielingen', NULL, NULL, true, '1644-06-06', 'Batavia', 5331, 'deaths 17.');
INSERT INTO "voyages" VALUES (623, '', 1, '', 'ORANJE', 'Jan Jansen', 700, NULL, '1643', NULL, NULL, 'Z', 'Z', '1644-01-21', 'Wielingen', NULL, NULL, true, '1644-06-06', 'Batavia', 5325, 'See HENRIETTE LOUISE (0622).');
INSERT INTO "voyages" VALUES (624, '', 1, '', 'MAKREEL', NULL, 100, 'jacht', NULL, NULL, NULL, 'A', 'A', '1644-04-14', 'Texel', NULL, NULL, true, '1644-09-17', 'Batavia', NULL, 'Via S. Tiago. Stayed in the Indies and sank in Sunda Strait, 1656.');
INSERT INTO "voyages" VALUES (625, '', 1, '', 'SCHELVIS', NULL, NULL, 'jacht', NULL, NULL, NULL, 'A', 'A', '1644-04-14', 'Texel', NULL, NULL, true, '1644-09-18', 'Batavia', NULL, 'Via S. Tiago. Stayed in the Indies and was burnt off Bassaora, 05-01-1646.');
INSERT INTO "voyages" VALUES (626, '', 1, '', 'SCHIEDAM', NULL, 800, NULL, NULL, NULL, NULL, 'D', 'D', '1644-04-14', 'Goeree', NULL, NULL, true, '1644-09-25', 'Batavia', 5348, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (627, '', 7, '', 'ZUTPHEN', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1644-04-14', 'Texel', NULL, NULL, true, '1644-09-19', 'Batavia', 5338, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (628, '', 1, '', 'AAGTEKERKE', NULL, 100, 'jacht', '1643', NULL, NULL, 'Z', 'Z', '1644-05-08', 'Wielingen', NULL, NULL, true, '1644-11-04', 'Batavia', NULL, 'Wrecked on a reef near Celebes, 04-03-1650.');
INSERT INTO "voyages" VALUES (629, '', 1, '', 'GOUDEN GANS', NULL, 340, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1644-05-08', 'Wielingen', NULL, NULL, true, '1644-11-02', 'Batavia', NULL, 'Stayed in the Indies and was sold in Batavia, 1655.');
INSERT INTO "voyages" VALUES (630, '', 1, '', 'GAPINGE', NULL, 120, 'jacht', '1644', NULL, NULL, 'Z', 'Z', '1644-05-08', 'Wielingen', NULL, NULL, true, '1644-11-04', 'Batavia', NULL, 'Stayed in the Indies, was used till 1654.');
INSERT INTO "voyages" VALUES (631, '', 1, '', 'POST', NULL, 100, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1644-05-08', 'Wielingen', NULL, NULL, true, '1644-12-01', 'Batavia', 5329, 'November 25th at Mauritius.');
INSERT INTO "voyages" VALUES (632, '', 1, '', 'HILLEGERSBERG', NULL, 360, 'fluit', NULL, NULL, NULL, 'R', 'R', '1644-12-30', 'Goeree', NULL, NULL, true, '1645-05-15', 'Batavia', NULL, 'No ports of call; the ship was used as a barrier in the mouth of the Anke. The hull was sold in 1659.');
INSERT INTO "voyages" VALUES (633, '', 1, '', 'MAASLAND', NULL, 340, 'fluit', NULL, NULL, NULL, 'D', 'D', '1644-12-30', 'Goeree', NULL, NULL, true, '1645-05-11', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (634, '', 1, '', 'ZALM', 'Jelten Pietersz.', 360, 'fluit', NULL, NULL, NULL, 'A', 'A', '1644-12-30', 'Texel', NULL, NULL, true, '1645-05-31', 'Batavia', NULL, 'No ports of call; the ship stayed in the Indies and was laid up, 21-09-1657, in Batavia.');
INSERT INTO "voyages" VALUES (635, '', 3, '', 'WALVIS', 'Pieter Dirksz.', 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1645-01-01', 'Texel', NULL, NULL, true, '1645-05-24', 'Batavia', 5335, 'No ports of call; fleet (0632-0635,0637-0638) with 835 seafarers and 320 soldiers, arriving in Batavia; 31 men died during the voyage.');
INSERT INTO "voyages" VALUES (636, '', 1, '', 'JUFFER', NULL, 480, 'fluit', NULL, NULL, NULL, 'A', 'A', '1645-01-04', 'Texel', NULL, NULL, true, '1645-07-09', 'Batavia', NULL, 'Tiago; wrecked on a reef south of Celebes, 04-03-1659.');
INSERT INTO "voyages" VALUES (637, '', 1, '', 'KONING VAN POLEN', NULL, 520, 'fluit', NULL, NULL, NULL, 'A', 'A', '1645-01-04', 'Texel', NULL, NULL, true, '1645-06-06', 'Batavia', 5354, 'No ports of call.');
INSERT INTO "voyages" VALUES (638, '', 3, '', 'VOGELSTRUIS', NULL, 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1645-01-04', 'Texel', NULL, NULL, true, '1645-06-08', 'Batavia', 5344, 'No ports of call.');
INSERT INTO "voyages" VALUES (639, '', 6, '', 'MIDDELBURG', NULL, 550, NULL, NULL, NULL, NULL, NULL, 'Z', '1645-01-08', 'Wielingen', '1645-04-26', NULL, true, '1645-07-18', 'Batavia', NULL, 'Total number of those on board together with the HOF VAN ZEELAND at the arrival: seafarers, 411; soldiers, 236; deaths 52. T he MIDDELBURG stayed in the Indies and was used at Onrust in 1649.');
INSERT INTO "voyages" VALUES (640, '', 2, '', 'HOF VAN ZEELAND', NULL, 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1645-01-08', 'Wielingen', '1645-04-26', NULL, true, '1645-07-18', 'Batavia', 5336, 'See 0639.');
INSERT INTO "voyages" VALUES (641, '', 1, '', 'BRUINVIS', NULL, 120, 'jacht', NULL, NULL, NULL, NULL, 'A', '1645-04-24', 'Texel', NULL, NULL, true, '1645-10-17', 'Batavia', NULL, 'Stayed in the Indies and  was blown up, January 20th, 1658, on Maginado by the Spaniards or by the crew.');
INSERT INTO "voyages" VALUES (642, '', 1, '', 'JONKER', NULL, NULL, 'fluit', NULL, NULL, NULL, 'A', 'A', '1645-04-24', 'Texel', NULL, NULL, true, '1645-12-06', 'Batavia', NULL, 'Stayed in the Indies and was wrecked off Wangkang, 21-10-1647.');
INSERT INTO "voyages" VALUES (643, '', 3, '', 'SALAMANDER', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1645-05-24', 'Texel', '1645-08-01', NULL, true, '1645-12-03', 'Batavia', 5343, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (644, '', 1, '', 'TONIJN', NULL, 300, 'jacht', NULL, NULL, NULL, 'A', 'A', '1645-05-24', 'Texel', NULL, NULL, true, '1645-12-04', 'Batavia', NULL, 'Stayed in the Indies; ran ashore on the Isle of Sapudi and was set on fire by the crew, 12-09-1646.');
INSERT INTO "voyages" VALUES (645, '', 6, '', 'LEEUWARDEN', NULL, 550, NULL, '1629', NULL, NULL, 'E', 'E', '1645-05-11', 'Texel', NULL, NULL, true, '1645-11-02', 'Batavia', 5340, NULL);
INSERT INTO "voyages" VALUES (646, '', 4, '', 'BREDA', NULL, 1050, NULL, '1637', NULL, NULL, 'H', 'H', '1645-05-13', 'Texel', NULL, NULL, true, '1645-11-02', 'Batavia', 5339, NULL);
INSERT INTO "voyages" VALUES (647, '', 1, '', 'SAS VAN GENT', NULL, 50, 'jacht', '1645', NULL, NULL, 'Z', 'Z', '1645-05-17', 'Wielingen', NULL, NULL, true, '1646-01-10', 'Batavia', NULL, 'Pernambuco; the ship stayed in the Indies and was laid up in Batavia, 1656.');
INSERT INTO "voyages" VALUES (648, '', 1, '', 'SLUIS', NULL, 240, 'jacht', '1644', NULL, NULL, 'Z', 'Z', '1645-05-17', 'Wielingen', NULL, NULL, true, '1645-11-27', 'Batavia', NULL, 'Stayed in the Indies and was sold, 1663.');
INSERT INTO "voyages" VALUES (649, '', 1, '', 'WITTE VALK', NULL, 320, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1645-05-17', 'Wielingen', NULL, NULL, true, '1645-11-10', 'Batavia', NULL, 'Stayed in the Indies and was laid up in Ambon, 1658.');
INSERT INTO "voyages" VALUES (650, '', 1, '', 'ROB', NULL, 240, 'jacht', NULL, NULL, NULL, 'A', 'A', '1645-10-09', 'Texel', '1646-01-01', NULL, true, '1646-05-06', 'Batavia', NULL, 'Via S. Tiago and Sierra Leone; the ship stayed in the Indies.');
INSERT INTO "voyages" VALUES (651, '', 2, '', 'MALAKKA', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1645-10-09', 'Texel', '1646-01-01', NULL, true, '1646-04-27', 'Batavia', 5341, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (652, '', 5, '', 'BANDA', NULL, 550, NULL, '1633', NULL, NULL, 'A', 'A', '1646-04-06', 'Texel', NULL, NULL, true, '1646-10-10', 'Batavia', NULL, 'Arrival in the Downs, April 17th.; via S. Tiago; the ship stayed in the Indies. The hull was sold in Batavia, 15-02-1659, after having been used at Onrust since 1654.');
INSERT INTO "voyages" VALUES (653, '', 1, '', 'KONING DAVID', 'Reinier Egbertsz.', 600, 'fluit', NULL, NULL, NULL, 'A', 'A', '1646-04-06', 'Texel', '1646-09-19', '1646-10-06', true, '1646-12-10', 'Batavia', 5397, 'Total number of those on board of the KONING DAVID, the WITTE OLIFANT and the WITTE PAARD arriving in Batavia: seafarers, 420; soldiers, 156; deaths, 22.');
INSERT INTO "voyages" VALUES (654, '', 3, '', 'WITTE OLIFANT', 'Klaas Bot', 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1646-04-06', 'Texel', '1646-09-19', '1646-10-06', true, '1646-12-05', 'Batavia', 5347, 'arrival at Tristan da Cunha, September 5th.');
INSERT INTO "voyages" VALUES (655, '', 1, '', 'PATIENTIE', NULL, 540, 'fluit', NULL, NULL, NULL, 'A', 'A', '1646-04-06', 'Texel', NULL, NULL, true, '1646-11-12', 'Batavia', NULL, 'See 0653; the ship stayed in the Indies, was laid up 20-12-1661 and sold 1662.');
INSERT INTO "voyages" VALUES (656, '', 1, '', 'DROMEDARIS', NULL, 560, 'jacht', NULL, NULL, NULL, 'A', 'A', '1646-04-23', 'Texel', NULL, NULL, true, '1647-01-23', 'Batavia', 5361, 'For the total number of the crew see the JONGE PRINS. Via S. Tiago; from 31-08 till 03-10 at Pernambuco.');
INSERT INTO "voyages" VALUES (657, '', 1, '', 'KAMPEN', NULL, 360, 'fluit', NULL, NULL, NULL, 'A', 'A', '1646-04-23', 'Texel', NULL, NULL, true, '1647-01-30', 'Batavia', NULL, 'For the total number of those on board see the JONGE PRINS (0668). Via S. Tiago; from 31-08 till 03-10 at Pernambuco. The ship stayed in the Indies. The hull was sold in Batavia, 1659.');
INSERT INTO "voyages" VALUES (658, '', 2, '', 'DELFT', NULL, 670, NULL, '1641', NULL, NULL, 'D', 'D', '1646-05-09', 'Goeree', NULL, NULL, true, '1647-07-12', 'Batavia', 5349, 'Mozambique.');
INSERT INTO "voyages" VALUES (659, '', 3, '', 'VERENIGDE PROVINCIEN', NULL, 1100, NULL, '1640', NULL, NULL, 'A', 'Z', '1646-05-09', 'Wielingen', '1646-07-01', NULL, true, '1646-10-14', 'Batavia', 5342, 'Via S.Tiago, departure June 10th.');
INSERT INTO "voyages" VALUES (660, '', 6, '', 'ZEELANDIA', NULL, 600, NULL, '1631', NULL, NULL, 'Z', 'Z', '1646-05-09', 'Wielingen', '1646-08-01', NULL, true, '1646-11-13', 'Batavia', 5345, 'Via S. Tiago, departure June 10th.');
INSERT INTO "voyages" VALUES (661, '', 4, '', 'HAARLEM', NULL, 500, NULL, NULL, NULL, NULL, 'A', 'A', '1646-05-15', 'Texel', NULL, NULL, true, '1646-11-02', 'Batavia', 5346, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (662, '', 1, '', 'WITTE PAARD', NULL, 360, 'fluit', NULL, NULL, NULL, 'A', 'A', '1646-05-15', 'Texel', NULL, NULL, true, '1646-12-26', 'Batavia', NULL, 'For the total number of those on board at the arrival in Batavia see the WITTE OLIFANT (0654). The ship stayed in the Indies and was laid up in 1657.');
INSERT INTO "voyages" VALUES (663, '', 2, '', 'LIEFDE', NULL, 500, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1646-07-01', 'Wielingen', NULL, NULL, true, '1647-03-20', 'Batavia', NULL, 'For the total number of those on board at the arrival in Batavia see the JONGE PRINS (0668). The ship stayed in the Indies and was laid up in Batavia in 1658.');
INSERT INTO "voyages" VALUES (664, '', 2, '', 'POST', NULL, 220, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1646-07-01', 'Wielingen', NULL, NULL, true, '1647-04-18', 'Batavia', NULL, 'For the total number of those on board at the arrival in Batavia see the JONGE PRINS (0668). The ship sailed via Mauritius, stayed in the Indies and was laid up in Batavia in 1657.');
INSERT INTO "voyages" VALUES (665, '', 1, '', 'HULST', NULL, 400, 'fluit', NULL, NULL, NULL, 'A', 'A', '1646-09-23', 'Texel', NULL, NULL, true, '1647-03-09', 'Batavia', NULL, 'For the total number of those on board at the arrival in Batavia see the JONGE PRINS (0668). The ship was lost near Nusa Untelue, coming from Solor, 19-07-1656.');
INSERT INTO "voyages" VALUES (666, '', 3, '', 'VREDE', NULL, 800, NULL, '1641', NULL, NULL, 'A', 'A', '1646-09-23', 'Texel', NULL, NULL, true, '1647-05-26', 'Batavia', 5357, 'For the total number of those on board at the arrival in Batavia see the JONGE PRINS (0668).');
INSERT INTO "voyages" VALUES (667, '', 4, '', 'WALVIS', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1646-09-24', 'Texel', NULL, NULL, true, '1647-04-13', 'Batavia', 5358, 'For the total number of those on board at the arrival in Batavia see the JONGE PRINS (0668).');
INSERT INTO "voyages" VALUES (668, '', 1, '', 'JONGE PRINS', NULL, 240, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1646-10-01', 'Wielingen', NULL, NULL, true, '1647-04-18', 'Batavia', NULL, 'Total number of those on board of the fleet arriving in Batavia April 1646 (0656-0682 except 0659-0662): seafarers, 3210; soldiers, 1140; deaths 407, mostly soldiers. T he ship stayed in the Indies and ran ashore near the Isle Pandy 23-05-1655. Crew and cargo were saved.');
INSERT INTO "voyages" VALUES (669, '', 1, '', 'ZAANDIJK', NULL, 300, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1646-10-01', 'Wielingen', NULL, NULL, true, '1647-04-19', 'Batavia', NULL, 'hull was sold in Batavia, 1654.');
INSERT INTO "voyages" VALUES (670, '', 1, '', 'KOE', NULL, 360, 'fluit', NULL, NULL, NULL, 'A', 'A', '1646-12-21', 'Texel', NULL, NULL, true, '1647-06-06', 'Batavia', NULL, 'For the total number of those on board at the arrival in Batavia see the JONGE PRINS (0668). The ship was lost on the coast of China, 20-07-1652.');
INSERT INTO "voyages" VALUES (671, '', 1, '', 'OS', NULL, 400, 'fluit', '1646', NULL, NULL, 'A', 'A', '1646-12-21', 'Texel', NULL, NULL, true, '1647-05-28', 'Batavia', NULL, 'in the Indies and was laid up in Batavia 21-09-1657.');
INSERT INTO "voyages" VALUES (672, '', 5, '', 'ENKHUIZEN', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'E', '1647-01-09', 'Texel', NULL, NULL, true, '1647-07-16', 'Batavia', 5350, 'For the total number of those on board at the arrival in Batavia see the JONGE PRINS (0668).');
INSERT INTO "voyages" VALUES (673, '', 3, '', 'WESTFRIESLAND', NULL, 1100, NULL, '1641', NULL, NULL, 'H', 'H', '1647-01-24', 'Texel', NULL, NULL, true, '1647-06-20', 'Batavia', 5359, 'board at the arrival in Batavia see the JONGE PRINS (0668).');
INSERT INTO "voyages" VALUES (674, '', 2, '', 'ORANJE', NULL, 700, NULL, '1643', NULL, NULL, 'Z', 'Z', '1647-01-25', 'Wielingen', NULL, NULL, true, '1647-06-30', 'Batavia', 5353, 'For the total number of those on board at the arrival in Batavia see the JONGE PRINS (0668).');
INSERT INTO "voyages" VALUES (675, '', 1, '', 'POPKENSBURG', NULL, 260, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1647-01-27', 'Wielingen', NULL, NULL, true, '1647-07-06', 'Batavia', NULL, 'between Coromandel and Ceylon. The crew was saved.');
INSERT INTO "voyages" VALUES (676, '', 4, '', 'HENRIETTE LOUISE', 'Thomas Jansz. Mendonk', 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1647-04-14', 'Wielingen', '1647-08-24', '1647-09-05', true, '1647-11-08', 'Batavia', 5351, 'For the total number of those on board at the arrival in Batavia see the JONGE PRINS (0668).');
INSERT INTO "voyages" VALUES (677, '', 1, '', 'NOORDMUNSTER', NULL, NULL, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1647-04-14', 'Wielingen', '1647-08-24', '1647-09-06', true, '1647-11-12', 'Batavia', 5352, 'number of those on board at the arrival in Batavia see the JONGE PRINS (0668).');
INSERT INTO "voyages" VALUES (678, '', 3, '', 'ROTTERDAM', NULL, 1100, NULL, NULL, NULL, NULL, 'R', 'R', '1647-04-29', 'Goeree', NULL, NULL, true, '1647-11-08', 'Batavia', 5355, 'For the total number of those on board at the arrival in Batavia see the JONGE PRINS (0668).');
INSERT INTO "voyages" VALUES (679, '', 1, '', 'GRIFFIOEN', NULL, 560, 'jacht', NULL, NULL, NULL, 'A', 'A', '1647-05-07', 'Texel', NULL, NULL, true, '1647-10-28', 'Batavia', NULL, 'use at Onrust; sunk 16-11-1663.');
INSERT INTO "voyages" VALUES (680, '', 3, '', 'TIJGER', NULL, 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1647-05-07', 'Texel', '1647-08-24', '1647-09-05', true, '1647-10-24', 'Batavia', 5356, 'For the total number of those on board at the arrival in Batavia see the JONGE PRINS (0668).');
INSERT INTO "voyages" VALUES (681, '', 8, '', 'ZUTPHEN', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1647-06-01', 'Texel', NULL, NULL, true, '1647-12-06', 'Batavia', 5360, NULL);
INSERT INTO "voyages" VALUES (682, '', 1, '', 'DUIF', NULL, 380, 'fluit', NULL, NULL, NULL, 'A', 'A', '1647-09-16', 'Texel', '1648-01-03', '1648-01-15', true, '1648-03-08', 'Batavia', 682, '-0693 arrived with 2273 men, amongst whom 701 soldiers; deathtoll 352 (Coolhaas II, 332). The ship stayed in the Indies and was wrecked on the coast of China in 1650.');
INSERT INTO "voyages" VALUES (683, '', 1, '', 'PRINSES ROYAAL', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1647-09-16', 'Texel', '1648-01-14', '1648-01-28', true, '1648-04-15', 'Batavia', 5364, NULL);
INSERT INTO "voyages" VALUES (684, '', 4, '', 'WITTE OLIFANT', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1648-01-17', 'Texel', NULL, NULL, true, '1648-08-14', 'Batavia', 5363, 'No ports of call.');
INSERT INTO "voyages" VALUES (685, '', 4, '', 'VOGELSTRUIS', NULL, 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1648-01-17', 'Texel', NULL, NULL, true, '1648-07-20', 'Batavia', 5367, 'Via the Downs and S. Vincente.');
INSERT INTO "voyages" VALUES (686, '', 3, '', 'HOF VAN ZEELAND', NULL, 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1648-01-17', 'Wielingen', NULL, NULL, true, '1648-08-02', 'Batavia', 5368, 'No ports of call.');
INSERT INTO "voyages" VALUES (687, '', 2, '', 'SCHIEDAM', NULL, 800, NULL, NULL, NULL, NULL, 'D', 'D', '1648-01-18', 'Goeree', NULL, NULL, true, '1648-08-24', 'Batavia', 5366, '13-03-1648 second departure from Goeree.');
INSERT INTO "voyages" VALUES (688, '', 1, '', 'CONCORDIA', NULL, 240, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1648-03-13', 'Wielingen', NULL, NULL, true, '1648-11-02', 'Batavia', NULL, 'Via S. Tiago and Mauritius where 4 soldiers deserted. The ship stayed in the Indies and was laid up in Malacca, 1660.');
INSERT INTO "voyages" VALUES (689, '', 4, '', 'VERENIGDE PROVINCIEN', NULL, 1100, NULL, '1640', NULL, NULL, 'Z', 'Z', '1648-03-13', 'Wielingen', NULL, NULL, true, '1648-08-20', 'Batavia', 5365, 'Via St. Tiago.');
INSERT INTO "voyages" VALUES (690, '', 7, '', 'ZEELANDIA', NULL, 600, NULL, '1631', NULL, NULL, 'Z', 'R', '1648-03-13', 'Goeree', NULL, NULL, true, '1648-08-14', 'Batavia', 5369, 'No ports of call.');
INSERT INTO "voyages" VALUES (691, '', 1, '', 'VERGULDE PELIKAAN', NULL, 300, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1648-04-13', 'Wielingen', NULL, NULL, true, '1648-11-22', 'Batavia', NULL, 'deserted, Cape Lopez, and S. Tome. The ship stayed in the Indies and was laid up and sold in Ternate, 1660.');
INSERT INTO "voyages" VALUES (692, '', 3, '', 'MALAKKA', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1648-04-26', 'Texel', NULL, NULL, true, '1648-12-04', 'Batavia', 5362, NULL);
INSERT INTO "voyages" VALUES (693, '', 1, '', 'REIGER', NULL, 560, 'fluit', NULL, NULL, NULL, 'A', 'A', '1648-04-26', 'Texel', NULL, NULL, true, '1648-11-01', 'Batavia', 5391, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (694, '', 1, '', 'SPERWER', NULL, 540, 'jacht', NULL, NULL, NULL, 'A', 'A', '1648-04-26', 'Texel', '1648-08-01', NULL, true, '1648-12-28', 'Batavia', NULL, 'Via Sierra Leone. The ship stayed in the Indies and was lost sailing from Taiwan to Japan, 16-08-1653.');
INSERT INTO "voyages" VALUES (695, '', 1, '', 'DIAMANT', NULL, 1100, NULL, '1648', NULL, NULL, 'A', 'A', '1648-10-08', 'Texel', NULL, NULL, true, '1649-05-17', 'Batavia', 5371, 'Via S. Tiago. 0695-0708 arrived with 2729 men, amongst whom 911 soldiers; death-toll 288 (Coolhaas II, 370).');
INSERT INTO "voyages" VALUES (696, '', 4, '', 'SALAMANDER', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1648-10-08', 'Texel', NULL, NULL, true, '1649-04-15', 'Batavia', 5377, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (697, '', 2, '', 'NOORDMUNSTER', NULL, NULL, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1648-11-01', 'Wielingen', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked in the `Sluise Gat'', when leaving the Wielingen.');
INSERT INTO "voyages" VALUES (698, '', 4, '', 'ROTTERDAM', NULL, 1100, NULL, NULL, NULL, NULL, 'R', 'R', '1649-01-15', 'Goeree', NULL, NULL, true, '1649-07-18', 'Batavia', 5376, 'See the BREDA (0703) for the total number of those on board.');
INSERT INTO "voyages" VALUES (699, '', 7, '', 'LEEUWARDEN', NULL, 550, NULL, '1629', NULL, NULL, 'E', 'E', '1649-01-15', 'Texel', NULL, NULL, true, '1649-07-31', 'Batavia', 5374, 'See the BREDA (0703) for the total number of those on board.');
INSERT INTO "voyages" VALUES (700, '', 1, '', 'LASTDRAGER', NULL, 640, 'fluit', NULL, '1648', NULL, 'A', 'A', '1649-01-17', 'Texel', NULL, NULL, true, '1649-08-21', 'Batavia', 5373, NULL);
INSERT INTO "voyages" VALUES (701, '', 1, '', 'ROBIJN', NULL, 480, 'jacht', NULL, NULL, NULL, 'A', 'A', '1649-01-17', 'Texel', NULL, NULL, true, '1649-07-10', 'Batavia', NULL, 'Via S. Tiago. The ship stayed in the Indies and was lost near the Arabian coast, 11-10-1653.');
INSERT INTO "voyages" VALUES (702, '', 3, '', 'ORANJE', NULL, 700, NULL, '1643', NULL, NULL, 'Z', 'Z', '1649-01-30', 'Wielingen', NULL, NULL, true, '1649-06-28', 'Batavia', 5375, 'See the BREDA (0703) for the total number of those on board.');
INSERT INTO "voyages" VALUES (703, '', 5, '', 'BREDA', NULL, 1050, NULL, '1637', NULL, NULL, 'H', 'H', '1659-01-31', 'Texel', NULL, NULL, true, '1649-06-25', 'Batavia', 5370, 'Total number of those on board of the BREDA, the HEN-RIETTE LOUISE, the ORANJE, the ROTTERDAM, the LEEUWARDEN, the TROUW and the POTVIS: arriving in Batavia: seafarers, 962; soldiers, 498; deaths, 138.');
INSERT INTO "voyages" VALUES (704, '', 5, '', 'HENRIETTE LOUISE', NULL, 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1649-02-03', 'Wielingen', NULL, NULL, true, '1649-06-26', 'Batavia', 5372, 'See the BREDA (0703) for the total number of those on board.');
INSERT INTO "voyages" VALUES (705, '', 1, '', 'TROUW', NULL, 500, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1649-04-03', 'Wielingen', NULL, NULL, true, '1649-09-20', 'Batavia', NULL, 'See the BREDA (0703) for the total number of those on board. T he TROUW stayed in the Indies and was wrecked in a storm on the coast of Hitoe, 1659.');
INSERT INTO "voyages" VALUES (706, '', 2, '', 'KONING VAN POLEN', NULL, 520, 'fluit', NULL, NULL, NULL, 'A', 'A', '1649-04-26', 'Texel', NULL, NULL, true, '1649-11-08', 'Batavia', 5427, NULL);
INSERT INTO "voyages" VALUES (707, '', 9, '', 'ZUTPHEN', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1649-04-26', 'Texel', '1649-07-01', NULL, true, '1649-10-16', 'Batavia', 5378, NULL);
INSERT INTO "voyages" VALUES (708, '', 1, '', 'POTVIS', NULL, 300, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1649-05-14', 'Wielingen', NULL, NULL, true, '1649-10-31', 'Batavia', NULL, 'See the BREDA (0703) for the total number of those on board. T he POTVIS stayed in the Indies and was wrecked on the coast of China, 1650.');
INSERT INTO "voyages" VALUES (709, '', 4, '', 'TIJGER', NULL, 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1649-05-22', 'Texel', NULL, NULL, true, '1650-01-04', 'Batavia', NULL, 'Via Sierca Leone: the ship stayed in the Indies and was wrecked on a reef south of Celebes, 04-03-1650.');
INSERT INTO "voyages" VALUES (710, '', 4, '', 'VREDE', NULL, 800, NULL, '1641', NULL, NULL, 'A', 'A', '1649-10-21', 'Texel', NULL, NULL, true, '1650-04-30', 'Batavia', 5394, 'Via Cape Verde. T he total number of those on board of the VREDE, the WALVIS, the MALAKKA, the PRINSES RO-YAAL, the SMIENT and the OLIFANT arriving in Batavia: seafarers, 1404.');
INSERT INTO "voyages" VALUES (711, '', 5, '', 'WALVIS', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1649-10-22', 'Texel', '1650-02-01', NULL, true, '1650-06-04', 'Batavia', 5383, 'For the total number of those on board see the VREDE (0710)');
INSERT INTO "voyages" VALUES (712, '', 3, '', 'DELFT', 'Simon Dirksz. Danser', 670, NULL, '1641', NULL, NULL, 'D', 'D', '1649-12-20', 'Maas', NULL, NULL, true, '1650-07-24', 'Batavia', 5386, NULL);
INSERT INTO "voyages" VALUES (713, '', 6, '', 'ENKHUIZEN', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'E', '1649-12-20', 'Texel', NULL, NULL, true, '1650-07-12', 'Batavia', 5387, NULL);
INSERT INTO "voyages" VALUES (714, '', 4, '', 'MALAKKA', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1649-12-20', 'Texel', NULL, NULL, true, '1650-06-11', 'Batavia', 5379, 'Leone.');
INSERT INTO "voyages" VALUES (715, '', 2, '', 'PRINSES ROYAAL', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1649-12-20', 'Texel', NULL, NULL, true, '1650-06-14', 'Batavia', 5381, 'For the total number of those on board see the VREDE (0710).Via Cape Verde.');
INSERT INTO "voyages" VALUES (716, '', 5, '', 'VERENIGDE PROVINCIEN', NULL, 1100, NULL, '1640', NULL, NULL, 'Z', 'Z', '1650-01-17', 'Wielingen', NULL, NULL, true, '1650-08-14', 'Batavia', 5382, 'Back to the Wielingen; sailed again 11-03-1650.');
INSERT INTO "voyages" VALUES (717, '', 4, '', 'HOF VAN ZEELAND', NULL, 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1650-01-17', 'Wielingen', NULL, NULL, true, '1650-09-01', 'Batavia', 5384, 'Back to the Wielingen; sailed again 11-03-1650.');
INSERT INTO "voyages" VALUES (718, '', 8, '', 'ZEELANDIA', NULL, 600, NULL, '1631', NULL, NULL, 'Z', 'R', '1650-04-02', 'Maas', NULL, NULL, true, '1650-09-06', 'Batavia', 5385, NULL);
INSERT INTO "voyages" VALUES (719, '', 5, '', 'WITTE OLIFANT', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1650-05-12', 'Texel', NULL, NULL, true, '1650-11-15', 'Batavia', 5380, 'Via Tenerife. For the total number of those on board see the VREDE (0710).');
INSERT INTO "voyages" VALUES (720, '', 1, '', 'SMIENT', 'Thijs Krab', 400, 'fluit', NULL, NULL, NULL, 'A', 'A', '1650-05-12', 'Texel', NULL, NULL, true, '1650-09-19', 'Batavia', NULL, 'Via Tenerife. For the total number of those on board see the VREDE (0710). The ship was wrecked sailing from Batavia to Taiwan, June 1653.');
INSERT INTO "voyages" VALUES (721, '', 4, '', 'WESTFRIESLAND', NULL, 1100, NULL, '1641', NULL, NULL, 'H', 'H', '1650-05-12', 'Texel', NULL, NULL, true, '1650-10-17', 'Batavia', 5388, NULL);
INSERT INTO "voyages" VALUES (722, '', 1, '', 'MORGENSTER', NULL, 360, 'fluit', NULL, NULL, NULL, NULL, 'Z', '1650-05-21', 'Wielingen', NULL, NULL, true, '1650-11-22', 'Batavia', NULL, 'Wrecked in a gale outside the Persian Gulf, 08-10-1653. No survivors, cargo (fl 284,824) was lost.');
INSERT INTO "voyages" VALUES (723, '', 1, '', 'SAFIER', NULL, 240, 'jacht', NULL, NULL, NULL, 'A', 'A', '1650-11-17', 'Texel', NULL, NULL, false, '1651-07-02', 'Batavia', NULL, 'Via S. Vincente. The ship stayed in the Indies and was broken up and sold in Batavia 20-01-1665.');
INSERT INTO "voyages" VALUES (724, '', 5, '', 'VOGELSTRUIS', NULL, 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1650-11-17', 'Texel', NULL, NULL, false, '1651-07-04', 'Batavia', 5393, 'Via Tenerife.');
INSERT INTO "voyages" VALUES (725, '', 1, '', 'TAIWAN', NULL, 300, 'jacht', '1650', NULL, NULL, 'Z', 'Z', '1650-12-06', 'Wielingen', '1651-02-01', NULL, true, '1651-05-11', 'Batavia', NULL, 'Wrecked near Taiwan, 09-08-1654. Crew and cargo were saved. Mentioned by the Uitloopboek 4389 as TAGORAS and by Coolhaas as TAYONAN.');
INSERT INTO "voyages" VALUES (726, '', 3, '', 'SCHIEDAM', 'Adriaan Kornelis Kalf', 800, NULL, NULL, NULL, NULL, 'D', 'D', '1650-12-29', 'Goeree', NULL, NULL, false, '1651-07-03', 'Batavia', NULL, 'Via S. Vincente. The ship stayed in the Indies and was lost off Arsapour, 19-10-1654; 51 deaths.');
INSERT INTO "voyages" VALUES (727, '', 6, '', 'HENRIETTE LOUISE', NULL, 750, NULL, '1635', NULL, NULL, 'Z', 'A', '1651-01-02', 'Wielingen', NULL, NULL, false, '1651-06-20', 'Batavia', 5390, NULL);
INSERT INTO "voyages" VALUES (728, '', 4, '', 'ORANJE', NULL, 700, NULL, '1643', NULL, NULL, 'Z', 'Z', '1651-01-29', 'Wielingen', NULL, NULL, false, '1651-07-04', 'Batavia', 5399, NULL);
INSERT INTO "voyages" VALUES (729, '', 6, '', 'BREDA', NULL, 1050, NULL, '1637', NULL, NULL, 'H', 'H', '1651-03-02', 'Texel', NULL, NULL, false, '1651-08-31', 'Batavia', 5396, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (730, '', 2, '', 'DIAMANT', NULL, 1100, NULL, '1648', NULL, NULL, 'A', 'A', '1651-03-02', 'Texel', NULL, NULL, false, '1651-08-29', 'Batavia', 5389, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (731, '', 2, '', 'LASTDRAGER', NULL, 640, 'fluit', NULL, '1648', NULL, 'A', 'A', '1651-03-02', 'Texel', '1651-04-01', NULL, true, '1651-08-29', 'Batavia', 5398, NULL);
INSERT INTO "voyages" VALUES (732, '', 8, '', 'LEEUWARDEN', NULL, 550, NULL, '1629', NULL, NULL, 'E', 'E', '1651-03-02', 'Texel', NULL, NULL, false, '1651-08-27', 'Batavia', NULL, 'Via Cape Verde. The ship was sold in 1655.');
INSERT INTO "voyages" VALUES (733, '', 5, '', 'ROTTERDAM', NULL, 1100, NULL, NULL, NULL, NULL, 'R', 'R', '1651-04-20', 'Goeree', NULL, NULL, false, '1651-10-12', 'Batavia', 5392, NULL);
INSERT INTO "voyages" VALUES (734, '', 5, '', 'SALAMANDER', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1651-05-04', 'Texel', '1651-08-01', NULL, true, '1651-11-17', 'Batavia', 5400, 'Via S. Vincente,leaving 15-06-1651.');
INSERT INTO "voyages" VALUES (735, '', 1, '', 'PRINS WILLEM', NULL, 700, NULL, '1650', NULL, NULL, 'Z', 'Z', '1651-05-04', 'Wielingen', NULL, NULL, false, '1651-10-30', 'Batavia', 5395, 'Via S. Vincente, 21-06-1651.');
INSERT INTO "voyages" VALUES (736, '', 10, '', 'ZUTPHEN', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1651-05-04', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked on the Vlaamse banken, 06-05-1651.');
INSERT INTO "voyages" VALUES (737, '', 1, '', 'PAREL', NULL, 1100, NULL, '1651', NULL, NULL, 'A', 'A', '1651-10-26', 'Texel', '1652-01-01', NULL, true, '1652-04-25', 'Batavia', 5402, 'Via Cape Verde.');
INSERT INTO "voyages" VALUES (738, '', 2, '', 'DROMEDARIS', 'David Koning', 560, 'jacht', NULL, NULL, NULL, 'A', 'A', '1651-12-24', 'Texel', '1652-04-06', '1652-05-25', true, '1652-07-22', 'Batavia', NULL, 'With van Riebeek on board. The ship was laid up in 1661.');
INSERT INTO "voyages" VALUES (739, '', 1, '', 'GOEDE HOOP', 'Simon Turver', NULL, 'jacht', NULL, NULL, NULL, 'A', 'A', '1651-12-24', 'Texel', '1652-04-06', '1653-01-23', true, '1653-05-16', 'Batavia', NULL, 'Lost near Amboina (Novo Tello) 13-07-1654.');
INSERT INTO "voyages" VALUES (740, '', 2, '', 'REIGER', 'Jan Hoogzaad', 560, 'fluit', NULL, NULL, NULL, 'A', 'A', '1651-12-24', 'Texel', '1652-04-06', '1652-05-17', true, '1652-07-22', 'Batavia', NULL, 'Blown up by its own powder off Pulicat, 19-10-1654.');
INSERT INTO "voyages" VALUES (741, '', 4, '', 'DELFT', 'Kornelis Pietersz. Roggeveen', 670, NULL, '1641', NULL, NULL, 'D', 'D', '1651-12-25', 'Goeree', NULL, NULL, false, '1652-05-27', 'Batavia', NULL, 'No ports of call. The ship was lost near Taiwan with all hands, October 3rd, 1652.');
INSERT INTO "voyages" VALUES (742, '', 6, '', 'WITTE OLIFANT', 'Klaas Jansz. Both', 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1652-01-03', 'Texel', '1652-05-07', '1652-05-17', true, '1652-07-22', 'Batavia', 5407, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (743, '', 6, '', 'WALVIS', 'Reinier Egbertsz.', 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1652-01-03', 'Texel', '1652-05-07', '1652-05-16', true, '1652-07-23', 'Batavia', 5404, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (744, '', 6, '', 'VERENIGDE PROVINCIEN', NULL, 1100, NULL, '1643', NULL, NULL, 'Z', 'Z', '1652-01-20', 'Wielingen', NULL, NULL, false, '1652-07-21', 'Batavia', 5408, 'Via the Canary Islands to get rid of some women, who had been surprised by the sudden departure, and via Sierre Leone.');
INSERT INTO "voyages" VALUES (745, '', 5, '', 'HOF VAN ZEELAND', 'Jan Overstraten', 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1652-01-31', 'Wielingen', '1652-05-25', '1652-06-01', true, '1652-08-03', 'Batavia', 5405, NULL);
INSERT INTO "voyages" VALUES (746, '', 1, '', 'WAPEN VAN BATAVIA', NULL, 340, 'jacht', '1651', NULL, NULL, 'Z', 'Z', '1652-04-03', 'Wielingen', NULL, NULL, false, '1652-09-16', 'Batavia', NULL, 'Via Cape Verde. Attacked by 8 Malabar pirates, the master blew up the ship, 1653; 5 survivors.');
INSERT INTO "voyages" VALUES (747, '', 1, '', 'LEEUW', '(RODE)', 240, 'jacht', '1651', NULL, NULL, 'Z', 'Z', '1652-04-03', 'Wielingen', NULL, NULL, false, '1652-08-27', 'Batavia', NULL, 'No ports of call. The ship was laid up at Cochin, 1665.');
INSERT INTO "voyages" VALUES (748, '', 1, '', 'CHARLOIS', NULL, NULL, 'galjoot', NULL, NULL, NULL, 'R', 'R', '1652-04-23', 'Goeree', NULL, NULL, false, '1652-10-14', 'Batavia', NULL, 'Via S. Vincente. The ship was laid up, 1664.');
INSERT INTO "voyages" VALUES (749, '', 5, '', 'MALAKKA', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1652-04-23', 'Texel', NULL, NULL, false, '1652-10-03', 'Batavia', 5401, 'No ports of call.');
INSERT INTO "voyages" VALUES (750, '', 3, '', 'PRINSES ROYAAL', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1652-04-23', 'Texel', NULL, NULL, false, '1652-10-04', 'Batavia', 5403, 'Via Cape Verde.');
INSERT INTO "voyages" VALUES (751, '', 1, '', 'TORTELDUIF', NULL, NULL, 'jacht', NULL, NULL, NULL, 'A', 'A', '1652-04-23', 'Texel', NULL, NULL, false, '1652-10-04', 'Batavia', NULL, 'Via Cape Verde. The ship stayed in the Indies and was probably laid up.');
INSERT INTO "voyages" VALUES (752, '', 9, '', 'ZEELANDIA', NULL, 600, NULL, '1631', NULL, NULL, 'Z', 'R', '1652-04-23', 'Goeree', NULL, NULL, false, '1652-10-18', 'Batavia', NULL, 'No ports of call. Decision to sell the ship, 10-04-1657. According to Uitloopboek laid up in 1659.');
INSERT INTO "voyages" VALUES (753, '', 7, '', 'ENKHUIZEN', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'E', '1652-05-04', 'Texel', NULL, NULL, true, '1652-12-01', 'Batavia', 5406, NULL);
INSERT INTO "voyages" VALUES (754, '', 1, '', 'VLEERMUIS (GULDEN)', NULL, 150, 'galjoot', NULL, NULL, NULL, 'E', 'E', '1652-05-04', 'Texel', NULL, NULL, true, '1652-11-24', 'Batavia', NULL, 'Wrecked on the reefs of the Vuile Eiland in the Pescadores, 26-09-1655.');
INSERT INTO "voyages" VALUES (755, '', 5, '', 'WESTFRIESLAND', 'Pieter Konstant +', 1100, NULL, '1641', NULL, NULL, 'H', 'Z', '1652-05-20', 'Wielingen', NULL, NULL, true, NULL, NULL, NULL, 'From 15-06 till 25-06 at S. Vincente; from 09-11 till 15-11 in Sierra Leone with 82 deaths and 15 healthy men. December 29th. back in Sierra Leone; near Pernambuco an attempt to mutiny by the first mate Jakob Arentsz., 15-08. Hendrik Jansz. replaced Pieter Konstant (+). Returned to Wielingen 17-07-1654.');
INSERT INTO "voyages" VALUES (756, '', 1, '', 'ZWARTE VOS', 'Theunis Eissen', 60, 'galjoot', NULL, NULL, NULL, 'A', 'A', '1652-09-04', 'Texel', '1653-01-18', '1653-06-09', true, NULL, 'Gamron', NULL, 'under of Gerrit Abelsen went first to Gamron, then to Surat. Departure from Surat 11-11-1653. The ship was wrecked on the river of Cambodia (1-1-1657).');
INSERT INTO "voyages" VALUES (757, '', 1, '', 'RODE VOS', 'Joris Meindertsz + Elbert Kornelisz. Kes', 60, 'galjoot', NULL, NULL, NULL, 'H', 'H', '1652-09-19', 'Texel', NULL, NULL, true, '1653-06-02', 'The Cape', NULL, 'From 26-10 till 01-11-1652 at S. Tiago. The ship was tossed about for 3 1/2 month off the Cape. The ship stayed at the Cape for some time. Was sold 08-09-1664 at Batavia.');
INSERT INTO "voyages" VALUES (758, '', 1, '', 'HAAS', 'Joris Jansz. Zomer', 200, 'jacht', NULL, NULL, NULL, 'A', 'A', '1652-09-28', 'Texel', '1653-03-26', '1653-04-17', true, '1653-06-20', 'Batavia', NULL, 'Via Sierra Leone (01-01-1653). On 22-04-1661 wrecked on the reefs of the island Roti near Timor.');
INSERT INTO "voyages" VALUES (759, '', 3, '', 'DIAMANT', NULL, 1100, NULL, '1648', NULL, NULL, 'A', 'A', '1652-11-01', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'After departure from Texel the ship went to Goeree. Departure from there 09-12-1652. The ship was wrecked on the island Schouwen, crew and cargo were saved and the ship was left 21-12.');
INSERT INTO "voyages" VALUES (760, '', 3, '', 'LASTDRAGER', NULL, 640, 'fluit', NULL, '1648', NULL, 'A', 'A', '1652-11-01', NULL, NULL, NULL, true, NULL, NULL, NULL, 'After departure from Texel to Goeree. From there 09-12 back to Texel because of a lost rudder. Departure from Texel 09-02-1653. The ship was wrecked near the Shetland Islands on 02-03 (reefs of Bluemull Sound; 26 survivors; wreck recently discovered).');
INSERT INTO "voyages" VALUES (761, '', 1, '', 'WINDHOND', '(WITTE)', 360, 'jacht', NULL, NULL, NULL, 'A', 'A', '1652-11-01', 'Texel', '1653-04-14', '1653-04-17', true, '1653-06-14', 'Batavia', NULL, 'First call at Goeree till 01-12-1653 and from 08-12-1652 till 15-12-1652 again at Goeree because of adverse winds. Ship was wrecked near Batavia 30-05-1658 (Boompjes Islands).');
INSERT INTO "voyages" VALUES (762, '', 1, '', 'MUIDEN', 'Evert Theunisz. Harnay', 400, 'jacht', NULL, NULL, NULL, 'A', 'A', '1652-12-26', 'Texel', '1653-04-18', '1653-04-26', true, '1653-07-01', 'Batavia', 5418, NULL);
INSERT INTO "voyages" VALUES (763, '', 1, '', 'WEESP', NULL, 560, 'jacht', NULL, NULL, NULL, 'A', 'A', '1652-12-26', 'Texel', NULL, NULL, true, '1653-06-15', 'Batavia', 5420, NULL);
INSERT INTO "voyages" VALUES (764, '', 6, '', 'VOGELSTRUIS', NULL, 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1653-04-03', NULL, NULL, NULL, true, NULL, NULL, NULL, '01-03-1653.');
INSERT INTO "voyages" VALUES (765, '', 1, '', 'AVENHORN', NULL, 240, 'jacht', '1652', NULL, NULL, 'H', 'H', '1653-02-09', 'Texel', NULL, NULL, false, '1653-07-26', 'Batavia', NULL, 'At Pipely (Balasore) wrecked in a heavy storm 22-10-1662; crew saved.');
INSERT INTO "voyages" VALUES (766, '', 1, '', 'ARNEMUIDEN', NULL, 320, 'jacht', NULL, NULL, NULL, NULL, 'Z', '1653-04-03', 'Wielingen', NULL, NULL, true, '1653-09-26', 'Batavia', NULL, 'refreshings at Boa Vista Island; the numbers of the crew at the arrival at Batavia are those of ARNEMUIDEN (0766) and VEERE (0768) together. T he hull was sold at Batavia 08-08-1667.');
INSERT INTO "voyages" VALUES (767, '', 1, '', 'LEEUWIN', NULL, 400, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1653-04-03', 'Wielingen', NULL, NULL, false, '1653-11-08', 'Batavia', 5411, 'and ZIERIK-ZEE (0769) together.');
INSERT INTO "voyages" VALUES (768, '', 1, '', 'VEERE', NULL, 520, 'jacht', NULL, NULL, NULL, NULL, 'Z', '1653-04-03', 'Wielingen', NULL, NULL, true, '1653-09-26', 'Batavia', NULL, 'Took on refreshings at Boa Vista Island; for further specification of the numbers of the crew see ARNEMUIDEN (0766)Ship was broken up at Ponnepilly 16-11-1664.');
INSERT INTO "voyages" VALUES (769, '', 1, '', 'ZIERIKZEE', NULL, 400, 'jacht', '1652', NULL, NULL, 'Z', 'Z', '1653-04-03', NULL, NULL, NULL, false, '1653-11-03', 'Batavia', 5468, 'For the numbers of the crew see LEEUWIN (0767)
Acc. to
Aanw. 1891/19e: departure 12-04-1653.');
INSERT INTO "voyages" VALUES (770, '', 2, '', 'KONING DAVID', 'Pieter Jansz. de Vries', 600, 'fluit', NULL, NULL, NULL, 'A', 'A', '1653-04-10', 'Texel', '1653-08-29', '1653-09-06', true, '1653-12-02', 'Batavia', 5410, NULL);
INSERT INTO "voyages" VALUES (771, '', 1, '', 'PHOENIX', 'Douwe Aukes', 900, NULL, NULL, NULL, NULL, NULL, 'A', '1653-04-10', 'Texel', '1653-08-16', '1653-08-25', true, '1653-10-22', 'Batavia', 5413, NULL);
INSERT INTO "voyages" VALUES (772, '', 6, '', 'SALAMANDER', NULL, 1100, NULL, '1639', NULL, NULL, 'A', 'A', '1653-04-10', 'Texel', '1653-08-05', '1653-08-14', true, '1653-10-07', 'Batavia', 5414, NULL);
INSERT INTO "voyages" VALUES (773, '', 1, '', 'DORDRECHT', NULL, 920, 'fregat', '1652', NULL, NULL, 'D', 'D', '1653-05-10', 'Goeree', NULL, NULL, true, '1654-02-18', 'Batavia', 5423, 'Via Maio Island and Annabon.');
INSERT INTO "voyages" VALUES (774, '', 1, '', 'ERASMUS', NULL, 400, 'jacht', '1652', NULL, NULL, 'R', 'R', '1653-05-10', 'Goeree', NULL, NULL, true, '1654-01-27', 'Batavia', 5469, 'Via Sierra Leone.');
INSERT INTO "voyages" VALUES (775, '', 6, '', 'ROTTERDAM', NULL, 1100, NULL, NULL, NULL, NULL, 'R', 'R', '1653-05-10', 'Goeree', NULL, NULL, true, '1654-01-02', 'Batavia', 5415, NULL);
INSERT INTO "voyages" VALUES (776, '', 5, '', 'ORANJE', 'Adriaan van Leene', 700, NULL, '1643', NULL, NULL, 'Z', 'Z', '1653-05-11', 'Wielingen', NULL, NULL, true, '1653-12-15', 'Batavia', 5412, 'Via St. Cruz.');
INSERT INTO "voyages" VALUES (777, '', 2, '', 'PRINS WILLEM', NULL, 700, NULL, '1650', NULL, NULL, 'Z', 'Z', '1653-05-11', 'Wielingen', NULL, NULL, false, '1653-12-31', 'Batavia', 5416, NULL);
INSERT INTO "voyages" VALUES (778, '', 7, '', 'HENRIETTE LOUISE', 'Hendrik van der Putte', 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1653-08-05', 'Wielingen', '1654-08-16', '1654-09-01', true, '1654-11-26', 'Batavia', 5425, '10-08-1653 in Goeree. The ship left the Wielingen 12-04-1654 for the second time. From 27-05-1654 till 03-06-1654 at S. Vincente.');
INSERT INTO "voyages" VALUES (779, '', 1, '', 'VERGULDE DRAAK', 'Aris Jansz. Dul', NULL, 'jacht', '1653', NULL, NULL, 'A', 'A', '1653-08-23', 'Texel', '1654-02-15', '1554-03-12', true, '1654-05-24', 'Batavia', 5417, 'After departure from the Cape the ship struck on a reef but without serious damage (14-03-1654).');
INSERT INTO "voyages" VALUES (780, '', 1, '', 'KALF', '(WITTE) Kornelis Ewoutsz. Juist', 320, 'pinas', NULL, NULL, NULL, 'A', 'A', '1653-08-23', 'Texel', '1654-02-09', '1654-03-12', true, '1654-05-30', 'Batavia', 5489, 'Via St. Antao, S. Tiago and S. Vincente.');
INSERT INTO "voyages" VALUES (781, '', 1, '', 'LAM', '(WITTE)', NULL, 'fluit', NULL, NULL, NULL, 'A', 'A', '1653-08-23', 'Texel', '1653-12-22', '1653-12-31', true, '1654-03-22', 'Batavia', NULL, 'On 28-10-1654 wrecked on a reef at Taiwan''s north coast');
INSERT INTO "voyages" VALUES (782, '', 1, '', 'NAARDEN', NULL, 400, 'jacht', NULL, NULL, NULL, 'A', 'A', '1653-08-23', 'Texel', '1653-12-22', '1653-12-31', true, '1654-03-14', 'Batavia', 5470, NULL);
INSERT INTO "voyages" VALUES (783, '', 5, '', 'VREDE', 'Kornelis Noordstrand', 800, NULL, '1641', NULL, NULL, 'A', 'A', '1653-08-23', 'Texel', '1654-01-06', '1654-01-24', true, '1654-05-18', 'Batavia', NULL, 'After the Cape Elbert Kornelisz. Kes became master. On 28-10-1654 wrecked on a reef at Taiwan''s north coast.');
INSERT INTO "voyages" VALUES (784, '', 7, '', 'BREDA', NULL, 1050, NULL, '1637', NULL, NULL, 'H', 'H', '1653-09-09', 'Texel', '1653-12-22', '1653-12-31', true, '1654-03-22', 'Batavia', 5421, NULL);
INSERT INTO "voyages" VALUES (785, '', 1, '', 'TULP', 'Samuel Volkertsz.', NULL, 'galjoot', NULL, NULL, NULL, 'A', 'A', '1653-12-23', 'Texel', NULL, NULL, true, '1654-04-18', 'The Cape', NULL, 'Stayed at the Cape for service; lost off Madagascar 02-12-1656.');
INSERT INTO "voyages" VALUES (786, '', 1, '', 'LELIE', NULL, NULL, 'galjoot', NULL, NULL, NULL, 'A', 'A', '1654-01-12', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Riding at anchor off Texel it was wrecked during a storm, but the cargo was saved.');
INSERT INTO "voyages" VALUES (787, '', 1, '', 'ROOS', NULL, NULL, 'galjoot', NULL, NULL, NULL, 'A', 'A', '1654-01-12', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Bank.');
INSERT INTO "voyages" VALUES (788, '', 1, '', 'GOUDSBLOEM', 'Simon Simonsz.', 540, 'jacht', NULL, NULL, NULL, 'A', 'A', '1654-01-28', 'Texel', '1654-07-09', '1654-08-17', true, '1654-10-11', 'Batavia', NULL, 'On 15-04-1654 it captured a small English ship named MER-CHANT at S. Vincente. The GOUDSBLOEM left S. Vincente 20-04. Broken up in 1665 in Bengal.');
INSERT INTO "voyages" VALUES (789, '', 1, '', 'BOTERBLOEM', 'Pieter Berkhout', 80, 'galjoot', NULL, NULL, NULL, 'A', 'A', '1654-01-29', 'Texel', '1654-07-23', '1654-08-17', true, '1654-10-21', 'Batavia', NULL, 'Tanete (north of Macassar), March 1660.');
INSERT INTO "voyages" VALUES (790, '', 1, '', 'THOLEN', NULL, 360, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1654-02-08', 'Wielingen', NULL, NULL, true, '1654-10-25', 'Batavia', 5429, 'Via Madagascar.');
INSERT INTO "voyages" VALUES (791, '', 1, '', 'VLISSINGEN', NULL, 400, 'jacht', '1653', NULL, NULL, 'Z', 'Z', '1654-02-08', 'Wielingen', NULL, NULL, true, '1654-08-28', 'Batavia', 5466, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (792, '', 1, '', 'ZWARTE BUL', 'Abraham Adriaansz.', 400, 'jacht', NULL, NULL, NULL, 'A', 'Z', '1654-03-30', 'Texel', '1654-10-24', '1654-11-12', true, '1655-01-19', 'Batavia', NULL, 'Via Torbay. Wrecked with all hands lost during a voyage from Batavia to Japan in 1659/1660.');
INSERT INTO "voyages" VALUES (793, '', 1, '', 'MARS', 'Dirk Ogel', 400, 'jacht', '1653', NULL, NULL, 'A', 'A', '1654-04-12', 'Wielingen', NULL, NULL, true, '1655-01-09', 'Batavia', 5485, 'Via Sierra Leone.');
INSERT INTO "voyages" VALUES (794, '', 1, '', 'ZOUTELANDE', NULL, 220, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1654-04-22', 'Wielingen', NULL, NULL, true, '1654-09-29', 'Batavia', NULL, 'Via S. Vincente. Sold in 1660 in the East Indies.');
INSERT INTO "voyages" VALUES (795, '', 1, '', 'ANJELIER', 'Klaas Jansz. Reeps', 440, 'jacht', '1653', NULL, NULL, 'H', 'H', '1654-04-26', 'Vlie', '1654-08-14', '1654-08-26', true, '1654-10-21', 'Batavia', 5498, NULL);
INSERT INTO "voyages" VALUES (796, '', 2, '', 'PAREL', NULL, 1100, NULL, '1651', NULL, NULL, 'A', 'A', '1654-04-26', 'Vlie', '1654-08-16', '1654-08-29', true, '1654-10-21', 'Batavia', 5426, NULL);
INSERT INTO "voyages" VALUES (797, '', 4, '', 'PRINSES ROYAAL', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1654-04-26', 'Vlie', NULL, NULL, false, '1654-10-11', 'Batavia', 5428, NULL);
INSERT INTO "voyages" VALUES (798, '', 1, '', 'TERSCHELLING', NULL, 520, 'jacht', NULL, NULL, NULL, 'A', 'A', '1654-04-26', 'Vlie', NULL, NULL, false, '1654-10-01', 'Batavia', 5419, NULL);
INSERT INTO "voyages" VALUES (799, '', 1, '', 'VLIELAND', NULL, 360, 'jacht', NULL, NULL, NULL, 'A', 'A', '1654-05-19', 'Vlie', '1654-08-15', '1654-08-20', true, '1654-10-11', 'Batavia', NULL, 'Laid up at Batavia 1668.');
INSERT INTO "voyages" VALUES (800, '', 1, '', 'DOLFIJN', 'Kornelis van Groet', 520, 'jacht', NULL, NULL, NULL, 'A', 'A', '1654-05-26', 'Vlie', '1654-08-31', '1654-09-07', true, '1654-11-01', 'Batavia', 5422, NULL);
INSERT INTO "voyages" VALUES (801, '', 1, '', 'GIDEON', NULL, NULL, 'jacht', NULL, NULL, NULL, NULL, 'A', '1654-05-26', 'Vlie', '1654-09-21', '1654-09-27', true, '1654-12-23', 'Batavia', 5424, 'According to KA 1093 117 seafarers and 57 soldiers arrived at Batavia.');
INSERT INTO "voyages" VALUES (802, '', 1, '', 'JONGE PRINS TE PAARD', NULL, NULL, 'jacht', NULL, NULL, NULL, NULL, 'A', '1654-05-30', 'Vlie', NULL, NULL, true, '1655-03-18', 'Batavia', 5430, 'Via Guinea and Annabon.');
INSERT INTO "voyages" VALUES (803, '', 7, '', 'WALVIS', 'Jan van Kampen', 1000, NULL, '1639', NULL, NULL, 'A', NULL, '1654-05-30', 'Vlie', '1654-10-29', '1654-11-12', true, '1655-01-10', 'Batavia', 5435, NULL);
INSERT INTO "voyages" VALUES (804, '', 1, 'A', 'BROUWERSHAVEN', NULL, 400, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1654-06-21', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'From 22-06 till 22-11-1654 in the Wielingen. Suffering from a high death-toll and danger of mutiny it returned at thirty degrees southern latitude. Arrival on 22-06-1655 (see also 0838).');
INSERT INTO "voyages" VALUES (805, '', 8, '', 'ENKHUIZEN', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'E', '1654-07-08', 'Vlie', NULL, NULL, false, '1655-03-24', 'Batavia', 5437, 'Because of leakage to Goeree. Final departure 03-09-1654.');
INSERT INTO "voyages" VALUES (806, '', 1, '', 'GEKROONDE LEEUW', NULL, 1200, NULL, NULL, NULL, NULL, 'E', 'E', '1654-07-08', 'Vlie', NULL, NULL, true, '1655-05-12', 'Batavia', 5431, 'Because of leakage to Goeree. Final departure 03-09-1654.');
INSERT INTO "voyages" VALUES (807, '', 7, '', 'WITTE OLIFANT', 'Arend Dirksz. de Rober', 100, NULL, '1639', NULL, NULL, 'A', 'A', '1654-08-06', 'Vlie', '1655-02-21', '1655-03-11', true, '1655-05-17', 'Batavia', 5438, 'Via Brittany and Sierra Leone. Number of deaths on the whole voyage and number of the crew at the arrival at Batavia also include those of the HOF VAN ZEELAND (0808).');
INSERT INTO "voyages" VALUES (808, '', 6, '', 'HOF VAN ZEELAND', 'Dirk Knebber', 1200, NULL, '1642', NULL, NULL, 'Z', 'A', '1654-08-06', 'Vlie', '1654-12-01', '1654-12-13', true, '1655-02-04', 'Batavia', 5436, 'See 0807.');
INSERT INTO "voyages" VALUES (809, '', 1, '', 'WAPEN VAN AMSTERDAM', 'Pieter Jansz. Mundt', 920, NULL, '1653', NULL, NULL, 'A', 'A', '1654-10-20', 'Vlie', '1655-03-18', '1655-04-02', true, '1655-06-21', 'Batavia', 5442, 'Via Maio Island.');
INSERT INTO "voyages" VALUES (810, '', 1, '', 'WAPEN VAN HOLLAND', 'Pieter de Bitter', 920, NULL, '1653', NULL, NULL, 'A', 'A', '1654-10-20', 'Vlie', '1655-02-22', '1655-03-11', true, '1655-05-16', 'Batavia', 5444, NULL);
INSERT INTO "voyages" VALUES (811, '', 6, '', 'MALAKKA', 'Jakob Kornelisz. de Zwart', 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1654-10-20', 'Vlie', '1655-02-19', NULL, true, '1655-05-17', 'Batavia', 5432, 'Via Maio Island.');
INSERT INTO "voyages" VALUES (812, '', 7, '', 'VERENIGDE PROVINCIEN', 'Pieter Mattheusz. Padt', 1100, NULL, '1643', NULL, NULL, 'Z', 'Z', '1654-11-17', 'Wielingen', '1655-04-03', '1655-04-15', true, '1655-06-19', 'Batavia', 5434, 'Before departure 3 men died and 40 deserted. 23-11 at Dover. 15-01 till 22-01-1655 at Cape Verde Islands.');
INSERT INTO "voyages" VALUES (813, '', 1, '', 'DOMBURG', NULL, 320, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1654-11-18', 'Wielingen', '1655-03-18', '1655-03-31', true, '1655-07-28', 'Batavia', NULL, '15-11-1669 laid up at Batavia and sold; 0813, 0817, 0823 and 0825 arrived with 1108 men, amongst whom 448 soldiers; death-toll 21 (Coolhaas, III 14).');
INSERT INTO "voyages" VALUES (814, '', 1, '', 'BLOEMENDAAL', 'Jan Kornelisz. Jol', 220, 'jacht', NULL, NULL, NULL, 'A', 'A', '1654-12-04', 'Texel', '1655-04-03', '1655-04-15', true, '1655-06-11', 'Batavia', NULL, 'In 1666 laid up at Batavia and sold.');
INSERT INTO "voyages" VALUES (815, '', 3, '', 'KONING DAVID', 'Kornelis Rob', 600, 'fluit', NULL, NULL, NULL, 'A', 'A', '1654-12-07', 'Texel', '1655-04-03', '1655-04-15', true, '1655-06-19', 'Batavia', NULL, 'In April 1661 sunk at Pegu, 10 men were drowned.');
INSERT INTO "voyages" VALUES (816, '', 1, '', 'MAAGD VAN ENKHUIZEN', 'Poppe Binkes', 200, 'galjoot', NULL, NULL, NULL, 'A', 'A', '1654-12-07', 'Texel', '1655-04-03', '1655-04-15', true, '1655-06-19', 'Batavia', NULL, 'On 12-11-1665 taken by the Portuguese in the Bay of Colombo.');
INSERT INTO "voyages" VALUES (817, '', 2, '', 'LEEUWIN', NULL, 400, 'jacht', NULL, NULL, NULL, 'Z', 'D', '1654-12-10', 'Goeree', '1655-07-22', '1655-07-31', true, '1655-09-27', 'Batavia', NULL, 'From 21-12-1654 till 21-03-1655 back in Goeree. On 24-12-1664 wrecked near Macassar.');
INSERT INTO "voyages" VALUES (818, '', 2, '', 'PHOENIX', 'Adriaan Roothaas', 900, NULL, NULL, NULL, NULL, NULL, 'A', '1654-12-10', 'Texel', '1655-04-03', '1655-04-14', true, '1655-06-19', 'Batavia', 5433, NULL);
INSERT INTO "voyages" VALUES (819, '', 1, '', 'KOUDEKERKE', NULL, 200, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1654-12-11', 'Wielingen', '1655-04-02', '1655-04-15', true, '1655-06-17', 'Batavia', NULL, 'On 16-09-1661 blown up in a battle against the Chinese off Formosa.');
INSERT INTO "voyages" VALUES (820, '', 3, '', 'PRINS WILLEM', NULL, 700, NULL, '1650', NULL, NULL, 'Z', 'Z', '1655-01-01', 'Wielingen', '1655-04-12', '1655-05-10', true, '1655-07-14', 'Batavia', 5446, NULL);
INSERT INTO "voyages" VALUES (821, '', 1, '', 'GOES', NULL, 460, 'jacht', NULL, NULL, NULL, NULL, 'Z', '1655-01-10', 'Wielingen', '1655-04-11', '1655-04-21', true, '1655-07-01', 'Batavia', NULL, 'On 07-03-1661 run ashore at the coast of Quinam.');
INSERT INTO "voyages" VALUES (822, '', 1, '', 'APPELBOOM', NULL, 80, 'galjoot', '1654', NULL, NULL, 'A', 'A', '1655-02-02', 'Texel', NULL, NULL, false, '1656-03-25', 'Batavia', NULL, 'In 1662 laid up in Asia.');
INSERT INTO "voyages" VALUES (823, '', 1, '', 'AVONDSTER', 'Jakob Klaasz. Bruining', 360, 'jacht', NULL, NULL, NULL, NULL, 'H', '1655-03-13', 'Texel', '1655-07-18', '1655-07-26', true, '1655-10-01', 'Batavia', 5448, NULL);
INSERT INTO "voyages" VALUES (824, '', 6, '', 'ORANJE', 'Thomas Jansz. Mendonk', 700, NULL, '1643', NULL, NULL, 'Z', 'Z', '1655-05-10', NULL, NULL, NULL, false, '1655-11-04', 'Batavia', 5439, NULL);
INSERT INTO "voyages" VALUES (825, '', 7, '', 'ROTTERDAM', 'Pieter Gerritsz.', 1100, NULL, NULL, NULL, NULL, 'R', 'R', '1655-05-16', 'Goeree', '1655-08-24', '1655-09-03', true, '1655-12-08', 'Batavia', 5440, NULL);
INSERT INTO "voyages" VALUES (826, '', 1, '', 'AMERSFOORT', 'Hendrik Grotenhuis', 1000, NULL, '1655', NULL, NULL, 'A', 'A', '1655-06-10', 'Vlie', '1655-11-07', '1655-11-21', true, '1656-02-13', 'Batavia', 5441, NULL);
INSERT INTO "voyages" VALUES (827, '', 1, '', 'ARNHEM', 'Magnus Hendriksz.', 1000, NULL, '1654', NULL, NULL, 'A', 'A', '1655-06-10', 'Vlie', '1655-10-21', '1655-11-06', true, '1656-02-08', 'Batavia', 5447, NULL);
INSERT INTO "voyages" VALUES (828, '', 1, '', 'NACHTGLAS', 'Jan Jakobsz. van Amsterdam', 100, 'galjoot', NULL, NULL, NULL, 'A', 'A', '1655-06-10', 'Vlie', NULL, NULL, true, '1655-10-20', 'The Cape', NULL, 'From 20-10-1655 till 18-07-1656 for service at the Cape. Left for Batavia with 26 men via Gamron and Surat. In 1664 laid up at Bengal.');
INSERT INTO "voyages" VALUES (829, '', 7, '', 'SALAMANDER', 'Klaas Jansz. Waling van Delftshaven', 1000, NULL, '1639', NULL, NULL, 'A', 'D', '1655-06-10', 'Vlie', '1655-11-04', '1655-11-08', true, '1656-02-06', 'Batavia', NULL, '1661 laid up and sold (22-11-1661).');
INSERT INTO "voyages" VALUES (830, '', 6, '', 'WESTFRIESLAND', 'Pieter Kornelisz. Puit', 1100, NULL, '1641', NULL, NULL, 'H', 'H', '1655-06-11', 'Vlie', '1655-11-16', '1655-11-25', true, '1656-02-12', 'Batavia', 5445, NULL);
INSERT INTO "voyages" VALUES (831, '', 1, '', 'SLOT VAN HONINGEN', 'Daam Pietersz. Lely', 1124, NULL, '1654', NULL, NULL, 'R', 'R', '1655-07-20', 'Goeree', '1655-11-10', '1655-11-18', true, '1656-02-15', 'Batavia', 5450, NULL);
INSERT INTO "voyages" VALUES (832, '', 1, '', 'BREUKELEN', NULL, 178, 'fluit', NULL, NULL, NULL, 'A', 'A', '1655-10-04', 'Texel', '1656-03-06', '1656-03-12', true, '1656-05-01', 'Batavia', NULL, 'Because of adverse winds for 4 weeks at Wight. On 18-03-1670 sold at Batavia.');
INSERT INTO "voyages" VALUES (833, '', 2, '', 'VERGULDE DRAAK', 'Pieter Albertsz.', NULL, 'jacht', '1653', NULL, NULL, 'A', 'A', '1655-10-04', 'Texel', '1656-03-09', '1656-03-12', true, NULL, NULL, NULL, 'On 28-04-1656 wrecked at the west coast of Australia. Value of the cargo: fl. 185,000.');
INSERT INTO "voyages" VALUES (834, '', 1, '', 'MAARSSEN', NULL, NULL, 'jacht', NULL, NULL, NULL, 'A', 'A', '1655-10-04', 'Texel', '1656-03-13', '1656-03-21', true, '1656-06-01', 'Batavia', NULL, 'On 11-09-1656 wrecked at the roads of Taiwan in a hurricane.');
INSERT INTO "voyages" VALUES (835, '', 2, '', 'MUIDEN', NULL, 400, 'jacht', NULL, NULL, NULL, 'A', 'A', '1655-10-04', 'Texel', '1656-03-01', '1656-03-10', true, '1656-05-09', 'Batavia', NULL, 'Because of adverse winds for 4 weeks at Wight. In 1675 laid up and sold at Batavia.');
INSERT INTO "voyages" VALUES (836, '', 2, '', 'WEESP', NULL, 560, 'jacht', NULL, NULL, NULL, 'A', 'A', '1655-10-04', 'Texel', '1656-03-05', '1656-03-11', true, '1656-05-24', 'Batavia', NULL, '4 weeks at Wight. On 28/29-09-1661 run aground and wrecked on the south shore of the Andaman Islands.');
INSERT INTO "voyages" VALUES (837, '', 2, '', 'DOLFIJN', NULL, 520, 'jacht', NULL, NULL, NULL, 'A', 'A', '1655-11-21', 'Texel', '1656-03-10', '1656-03-21', true, '1656-05-15', 'Batavia', NULL, 'Via England. Wrecked in the Bay of Gale, 15-05-1663.');
INSERT INTO "voyages" VALUES (838, '', 1, 'B', 'BROUWERSHAVEN', NULL, 400, NULL, NULL, NULL, NULL, 'Z', 'Z', '1655-11-22', 'Wielingen', '1656-03-11', '1656-03-21', true, '1656-05-30', 'Batavia', NULL, 'Via Wight. In 1668 sold at Batavia, see also 0804.1A.');
INSERT INTO "voyages" VALUES (839, '', 1, '', 'ZEEHOND', NULL, 180, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1655-11-22', 'Wielingen', '1656-03-16', '1656-03-28', true, '1656-06-08', 'Batavia', NULL, 'On 25-12-1668 sold at Batavia.');
INSERT INTO "voyages" VALUES (840, '', 1, '', 'ZEEPAARD', NULL, 400, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1655-11-22', 'Wielingen', '1656-03-10', '1656-03-15', true, '1656-05-24', 'Batavia', 5479, 'Via England.');
INSERT INTO "voyages" VALUES (841, '', 1, '', 'HECTOR', NULL, 600, 'jacht', NULL, NULL, NULL, 'A', 'A', '1655-12-05', 'Texel', '1656-03-30', '1656-04-07', true, '1656-06-12', 'Batavia', 5452, NULL);
INSERT INTO "voyages" VALUES (842, '', 1, '', 'ACHILLES', NULL, 500, 'jacht', '1655', NULL, NULL, 'A', 'A', '1655-12-10', 'Texel', '1656-03-12', '1656-03-21', true, '1656-06-06', 'Batavia', 5451, 'An earlier departure was from Zeeland on 24-03-1655; but it was forced to sail to Texel.');
INSERT INTO "voyages" VALUES (843, '', 1, '', 'HERCULES', NULL, 540, 'jacht', NULL, NULL, NULL, 'A', 'A', '1655-12-10', 'Texel', '1656-03-11', '1656-03-21', true, '1656-05-30', 'Batavia', NULL, 'On 21-05-1661 wrecked in the Bay of Gale.');
INSERT INTO "voyages" VALUES (844, '', 2, '', 'TERSCHELLING', NULL, 520, 'jacht', NULL, NULL, NULL, 'A', 'Z', '1655-12-11', 'Wielingen', '1656-03-19', '1656-03-28', true, '1656-06-08', 'Batavia', NULL, 'Bay of Bengal.');
INSERT INTO "voyages" VALUES (845, '', 2, '', 'THOLEN', 'Adriaan Roothaas', 360, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1656-01-06', 'Wielingen', '1656-04-15', '1656-04-25', true, '1656-06-19', 'Batavia', NULL, 'On 29-07-1672 laid up and sold.');
INSERT INTO "voyages" VALUES (846, '', 2, '', 'DORDRECHT', 'Michael Michaelsz. van Maasijk', 920, 'fregat', '1652', NULL, NULL, 'D', 'D', '1656-03-11', 'Goeree', NULL, NULL, false, '1656-08-21', 'Batavia', 5443, NULL);
INSERT INTO "voyages" VALUES (847, '', 3, '', 'KONING VAN POLEN', 'Robbert Karelsz.', 520, 'fluit', NULL, NULL, NULL, 'A', 'Z', '1656-03-11', 'Wielingen', NULL, NULL, false, '1656-08-12', 'Batavia', NULL, 'Three English soldiers were taken from board by an English ship in the Channel. 1661/1662 broken up at Onrust.');
INSERT INTO "voyages" VALUES (848, '', 8, '', 'HENRIETTE LOUISE', 'Cent Amers', 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1656-04-08', 'Wielingen', '1656-08-03', '1656-08-19', true, '1656-10-28', 'Batavia', 5449, NULL);
INSERT INTO "voyages" VALUES (849, '', 1, '', 'WAKENDE BOEI', NULL, 178, 'fluit', '1656', NULL, NULL, 'A', 'A', '1656-04-11', 'Vlie', '1656-09-11', '1656-09-22', true, '1656-12-05', 'Batavia', NULL, 'Via Plymouth (2x) and Falmouth. Two boys from Dunkirk came on board in England, one of them was drowned later. On 20-02-1666 laid up and sold.');
INSERT INTO "voyages" VALUES (850, '', 3, '', 'PAREL', 'Pieter Jansz. de Vries', 1100, NULL, '1651', NULL, NULL, 'A', 'A', '1656-04-11', 'Vlie', '1656-08-06', '1656-08-21', true, '1656-11-03', 'Batavia', 5456, NULL);
INSERT INTO "voyages" VALUES (851, '', 1, '', 'WACHTER', 'Evert ....', NULL, 'fluit', NULL, NULL, NULL, 'A', 'A', '1656-04-11', 'Vlie', '1656-11-26', '1656-12-03', true, '1657-02-09', 'Batavia', NULL, 'From 18-04 till 17-05-1656 at Wight. On 11-11-1659 wrecked at Palembang.');
INSERT INTO "voyages" VALUES (852, '', 1, '', 'EMMELOORD', 'Frans Hendriksz. van Stralen', NULL, 'galjoot? bootje?', '1655', NULL, NULL, 'E', 'E', '1656-05-01', 'Vlie', '1656-09-16', '1656-10-01', true, '1656-12-04', 'Batavia', NULL, 'For 10 days at the Shetland I. In 1663 wrecked at the island Damman(?).');
INSERT INTO "voyages" VALUES (853, '', 1, '', 'ENS', NULL, NULL, 'galjoot', '1655', NULL, NULL, 'E', 'E', '1656-05-01', 'Vlie', NULL, NULL, true, '1656-12-02', 'Batavia', NULL, 'Via S. Vincente, one man deserted. In 1662 broken up at Onrust.');
INSERT INTO "voyages" VALUES (854, '', 1, '', 'ZEERIDDER', 'Jan Leendertsz. Roskam', 160, 'fluit? jacht?', NULL, NULL, NULL, 'Z', 'Z', '1656-05-15', 'Wielingen', '1656-09-14', '1656-10-01', true, '1656-12-06', 'Batavia', NULL, 'On 13-08-1669 laid up and sold at Batavia.');
INSERT INTO "voyages" VALUES (855, '', 5, '', 'PRINSES ROYAAL', 'Reinoud Engelbrechtsz.', 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1656-05-31', 'Vlie', '1656-09-21', '1656-10-07', true, '1656-12-07', 'Batavia', 5458, 'Via S. Vincente and Sto. Antao. Three men were drowned at the Cape.');
INSERT INTO "voyages" VALUES (856, '', 1, '', 'ULYSSES', 'Jan Timonsz.', 400, 'fluit', NULL, NULL, NULL, 'A', 'A', '1656-05-31', 'Vlie', '1656-10-31', '1656-11-02', true, '1657-01-26', 'Batavia', 5459, NULL);
INSERT INTO "voyages" VALUES (857, '', 1, '', 'URK', NULL, NULL, 'galjoot', NULL, NULL, NULL, NULL, 'E', '1656-05-31', 'Vlie', NULL, NULL, false, '1657-01-10', 'Batavia', NULL, 'On 17-08-1661 wrecked in a battle against the Chinese.');
INSERT INTO "voyages" VALUES (858, '', 8, '', 'BREDA', 'Albert Jansz. Konijn', 1050, NULL, '1637', NULL, NULL, 'H', 'H', '1656-06-01', 'Vlie', '1656-10-17', '1656-11-01', true, '1657-01-20', 'Batavia', NULL, 'According to Daghregister 1656/7 it departed on 01-07-1656.');
INSERT INTO "voyages" VALUES (859, '', 1, '', 'MOLEN', 'Jakob Stevensz. Molenwerf', NULL, 'fluit', NULL, NULL, NULL, 'H', 'H', '1656-06-01', 'Vlie', '1656-11-09', '1656-11-21', true, '1657-02-11', 'Batavia', NULL, 'Via St. Helena. In March 1658 wrecked on a reef at Ceylon, crew and cargo were mainly saved.');
INSERT INTO "voyages" VALUES (860, '', 1, '', 'VOGELZANG', 'Robert Ram', 680, 'fluit', NULL, NULL, NULL, 'A', 'A', '1656-06-27', 'Texel', '1656-12-03', '1656-12-15', true, '1657-02-22', 'Batavia', 5481, NULL);
INSERT INTO "voyages" VALUES (861, '', 1, '', 'HILVERSUM', 'Jakob Jansz.', 202, 'fluit', '1656', NULL, NULL, 'A', 'A', '1656-10-19', 'Texel', '1657-02-05', '1657-02-12', true, '1657-05-11', 'Batavia', 5480, NULL);
INSERT INTO "voyages" VALUES (862, '', 7, '', 'MALAKKA', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1656-11-22', 'Vlie', '1657-03-18', '1657-03-28', true, '1657-05-23', 'Batavia', 5454, 'The 27 soldiers who came on board at the Cape were from the ORANJE. Via S. Vincente, 23 till 28-12.');
INSERT INTO "voyages" VALUES (863, '', 7, '', 'ORANJE', NULL, 700, NULL, '1643', NULL, NULL, 'Z', NULL, '1656-11-22', NULL, '1657-03-17', '1657-04-19', true, '1657-07-01', 'Batavia', 5455, 'At the Cape 27 soldiers went from the ORANJE to the MAL-ACCA.');
INSERT INTO "voyages" VALUES (864, '', 2, '', 'GEKROONDE LEEUW', NULL, 1200, NULL, NULL, NULL, NULL, 'E', 'A', '1656-12-24', 'Vlie', '1657-05-05', '1657-05-29', true, '1657-08-10', 'Batavia', 5453, NULL);
INSERT INTO "voyages" VALUES (865, '', 1, '', 'OOIEVAAR', 'Jakob Doorn', 627, 'fluit', '1656', NULL, NULL, 'Z', 'Z', '1656-12-24', 'Wielingen', '1657-05-02', '1657-05-22', true, '1657-08-07', 'Batavia', 5499, '225, the ship departed with 227 men.');
INSERT INTO "voyages" VALUES (866, '', 1, '', 'VENENBURG', 'Hendrik Juriaansz.', 703, 'fluit', '1656', NULL, NULL, 'A', 'A', '1656-12-24', 'Vlie', '1657-04-22', '1657-05-02', true, '1657-06-29', 'Batavia', 5490, NULL);
INSERT INTO "voyages" VALUES (867, '', 1, '', 'VINK', 'Jan Bartelsz. +', 202, 'fluit', '1656', NULL, NULL, 'Z', 'Z', '1656-12-24', 'Wielingen', '1657-04-19', '1657-04-27', true, '1657-07-08', 'Batavia', NULL, 'Via the west coast of Australia (Suytlandt) for an inquiry concerning the VERGULDE DRAAK. In 1668/69 sold to a Portuguese citizen of Batavia. Master became Joost Jansz. van Serooskerke.');
INSERT INTO "voyages" VALUES (868, '', 3, '', 'PHOENIX', 'Kornelis Stamper', 900, NULL, NULL, NULL, NULL, 'A', 'D', '1656-12-25', 'Goeree', '1657-04-04', '1657-04-13', true, '1657-06-12', 'Batavia', 5464, NULL);
INSERT INTO "voyages" VALUES (869, '', 7, '', 'HOF VAN ZEELAND', 'Dirk Jansz. Knibbel', 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1657-01-22', 'Wielingen', NULL, NULL, false, '1657-10-17', 'Batavia', 5460, 'back at the Wielingen. Missed the Cape because of a storm. Via Mauritius, departure: 20-08-1657.');
INSERT INTO "voyages" VALUES (870, '', 1, '', 'HASSELT', 'Jakob Hendriksz. Moker', 365, 'pinas', '1656', NULL, NULL, 'A', 'A', '1657-04-10', 'Vlie', '1657-08-16', NULL, true, NULL, NULL, NULL, 'Remained for service at the Cape, and probably sailed to Batavia later on. Sailing to Arakan in 1665/66 it was wrecked.');
INSERT INTO "voyages" VALUES (871, '', 1, '', 'MARIA', 'Klaas Fransz. Bording', 120, 'jacht', NULL, NULL, NULL, 'A', 'A', '1657-04-10', 'Vlie', '1657-07-13', '1658-07-18', true, NULL, NULL, NULL, 'departed from the Cape to Batavia with 35 men. It was laid up and sold at Batavia, 13-08-1669.');
INSERT INTO "voyages" VALUES (872, '', 8, '', 'WITTE OLIFANT', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1657-04-12', 'Vlie', NULL, NULL, false, '1658-01-19', 'Batavia', 5463, 'Via England, where 23 men deserted.');
INSERT INTO "voyages" VALUES (873, '', 8, '', 'VERENIGDE PROVINCIEN', 'Cape: Pieter van Dalen', 1100, NULL, '1643', NULL, NULL, 'Z', 'Z', '1657-04-13', 'Wielingen', '1657-08-07', '1657-08-27', true, '1657-10-25', 'Batavia', 5465, 'The men who embarked at the Cape came from the HASSELT and the MARIA. The master, Andries van Nesse, was dismissed because of adultery with the wife of the onderkoopman. According to Van Riebeek, 11, 153, the ship departed from the Wielingen with 263 men.');
INSERT INTO "voyages" VALUES (874, '', 8, '', 'ROTTERDAM', 'Jochem Klaasz.?', 1100, NULL, NULL, NULL, NULL, 'R', 'R', '1657-04-19', 'Goeree', '1657-08-25', '1657-09-30', true, '1657-12-13', 'Batavia', NULL, 'Laid up in 1661. At the Cape 31 seafarers and 45 soldiers were taken over by the ENKHUIZEN.');
INSERT INTO "voyages" VALUES (875, '', 9, '', 'ENKHUIZEN', 'Jan Kornelis Zwart', 700, NULL, NULL, NULL, NULL, NULL, 'E', '1657-04-30', 'Vlie', '1657-08-25', '1657-09-10', true, '1657-11-23', 'Batavia', 5457, 'See the ROTTERDAM (0874).');
INSERT INTO "voyages" VALUES (876, '', 8, '', 'WALVIS', 'Barend Barendsz. Lam van Bunschoten', 1000, NULL, '1639', NULL, NULL, 'A', 'D', '1657-06-27', 'Goeree', '1657-11-02', '1657-11-11', true, '1658-02-01', 'Batavia', 5467, NULL);
INSERT INTO "voyages" VALUES (877, '', 1, '', 'MEES', 'Maarten Bastink', 202, 'fluit', '1657', NULL, NULL, 'Z', 'Z', '1657-10-12', 'Wielingen', '1658-04-14', '1658-04-23', true, '1658-07-05', 'Batavia', NULL, 'one man deserted there. Until the Cape the voyage was severely delayed by calm and adverse winds. The ship was sold in 1673.');
INSERT INTO "voyages" VALUES (878, '', 1, '', 'SPREEUW', NULL, 374, 'fluit', '1657', NULL, NULL, 'Z', 'Z', '1657-10-12', 'Wielingen', '1658-03-27', '1658-04-08', true, NULL, NULL, 5500, 'there by the English. The seven `passengers'' who embarked at the Cape were slaves.');
INSERT INTO "voyages" VALUES (879, '', 2, '', 'VAN AMSTERDAM', 'Andries Wolf +', 920, NULL, '1653', NULL, NULL, 'A', 'A', '1657-10-13', 'Vlie', '1658-03-26', '1658-04-09', true, '1658-07-04', 'Batavia', 5462, 'succeeded him as master. The 16 `passengers'' who embarked at the Cape were slaves, 12 of them arrived at Batavia.');
INSERT INTO "voyages" VALUES (880, '', 2, '', 'WAPEN VAN HOLLAND', NULL, 920, NULL, '1653', NULL, NULL, 'A', 'A', '1657-10-13', 'Vlie', '1658-03-04', '1658-03-19', true, '1658-06-22', 'Batavia', 5473, NULL);
INSERT INTO "voyages" VALUES (881, '', 2, '', 'AMERSFOORT', 'Frederik Eldense', 1000, NULL, '1655', NULL, NULL, 'A', 'A', '1657-10-14', 'Vlie', '1658-03-28', '1658-04-09', true, '1658-07-01', 'Batavia', 5461, 'A Portuguese slave ship carrying 250 slaves was captured off Brazil. At the arrival at the Cape about 80 of them had died and many were ill; some 100 slaves arrived at Batavia.');
INSERT INTO "voyages" VALUES (882, '', 1, '', 'ELBURG', 'Jakob Pietersz. Pereboom', 360, 'fluit', '1657', NULL, NULL, 'A', 'A', '1657-12-14', 'Texel', '1658-04-13', '1658-04-23', true, '1658-07-16', 'Batavia', 5539, 'For four weeks at Tristan da Cunha because of calm. Via Cape Leewin.');
INSERT INTO "voyages" VALUES (883, '', 1, '', 'GEELMUIDEN', NULL, 202, 'fluit', '1657', NULL, NULL, 'A', 'A', '1657-12-14', 'Texel', '1658-05-31', '1658-06-14', true, '1658-08-20', 'Batavia', NULL, 'Sailing to Canton in 1659, the GEELMUIDEN was wrecked.');
INSERT INTO "voyages" VALUES (884, '', 3, '', 'DORDRECHT', 'Jakob Gerrit de Groot', 920, 'fregat', '1652', NULL, NULL, 'D', 'D', '1657-12-17', 'Goeree', '1658-04-28', '1658-05-13', true, '1658-07-14', 'Batavia', 5472, 'Via S. Vincente: 2 seafarers and 4 soldiers deserted there. The 30 ''passengers'' who embarked at the Cape were slaves; 28 of them arrived at Batavia.');
INSERT INTO "voyages" VALUES (885, '', 4, '', 'PRINS WILLEM', NULL, 700, NULL, '1650', NULL, NULL, 'Z', 'Z', '1658-01-25', 'Wielingen', '1658-06-17', '1658-07-05', true, '1658-09-12', 'Batavia', 5478, 'Via S. Vincente: one man deserted there.');
INSERT INTO "voyages" VALUES (886, '', 1, '', 'LEERDAM', NULL, 400, 'fluit', NULL, NULL, NULL, 'A', 'A', '1658-04-16', 'Texel', '1658-08-07', '1658-08-21', true, '1658-12-02', 'Batavia', NULL, 'In 1671 sold for breaking up.');
INSERT INTO "voyages" VALUES (887, '', 1, '', 'NIEUWPOORT', NULL, 400, 'fluit', NULL, NULL, NULL, NULL, 'A', '1658-04-16', 'Texel', '1658-07-25', '1658-08-01', true, '1658-10-15', 'Batavia', 5511, NULL);
INSERT INTO "voyages" VALUES (888, '', 9, '', 'HENRIETTE LOUISE', 'Gerrit Jansz.', 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1658-05-05', 'Wielingen', '1658-08-22', '1658-09-01', true, '1658-11-02', 'Batavia', NULL, 'Sold in the Indies, 08-09-1664.');
INSERT INTO "voyages" VALUES (889, '', 7, '', 'WESTFRIESLAND', 'Jakob Jansz. Houtschip', 1100, NULL, '1641', NULL, NULL, 'H', 'H', '1658-05-18', 'Vlie', '1658-10-28', '1658-11-08', true, '1659-02-07', 'Batavia', 5477, 'According to Daghregister, 1659, the ship departed on 08-05-1658, according to K4 1119: 31-05-1658. The ship did not call at the Cape but at Saldanha Bay: 150 men were ill.');
INSERT INTO "voyages" VALUES (890, '', 1, '', 'GOEREE', 'Kornelis Vonk', NULL, 'fluit', NULL, NULL, NULL, NULL, 'R', '1658-05-27', 'Goeree', '1658-09-11', '1658-09-18', true, '1658-11-27', 'Batavia', NULL, 'Laid up and sold at Batavia, 01-10-1669.');
INSERT INTO "voyages" VALUES (891, '', 1, '', 'RODE HERT', 'Herman Ruiter', 340, 'fluit', NULL, NULL, NULL, 'A', 'R', '1658-05-27', 'Goeree', '1658-09-09', '1658-09-18', true, '1658-11-19', 'Batavia', 5510, NULL);
INSERT INTO "voyages" VALUES (892, '', 1, '', 'HARP', 'Konwalles', NULL, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1658-05-31', 'Wielingen', '1658-11-17', '1658-12-03', true, '1659-02-24', 'Batavia', NULL, 'Batavia with 81 seafarers, 39 soldiers, and 5 passengers. It was wrecked on 25-06-1660 (off Taiwan?)');
INSERT INTO "voyages" VALUES (893, '', 1, '', 'IMMENHORN', 'Dirk Dirksz. Jonas', NULL, 'galjoot', NULL, NULL, NULL, 'E', 'E', '1658-08-22', 'Vlie', '1659-02-02', '1659-02-17', true, '1659-06-02', 'Batavia', NULL, 'was wrecked, probably in 1661.');
INSERT INTO "voyages" VALUES (894, '', 2, '', 'ARNHEM', 'Jan Timonsz.', 1000, NULL, '1654', NULL, NULL, 'A', 'A', '1658-10-22', 'Vlie', '1659-03-16', '1659-03-30', true, '1659-07-08', 'Batavia', 5471, 'Almonde.');
INSERT INTO "voyages" VALUES (895, '', 1, '', 'KORTENHOEF', 'Luit Pieters', 216, 'fluit', '1657', NULL, NULL, 'A', 'A', '1658-10-22', 'Vlie', '1659-03-22', '1659-04-01', true, '1659-06-20', 'Batavia', NULL, 'Via Canary Islands. Via Mauritius to accompany the PAREL which made water (see 0897). Attempting to relieve Fort Zeelandia at Formosa the KORTENHOEF was wrecked, 16-09-1661.');
INSERT INTO "voyages" VALUES (896, '', 1, '', 'LOENEN', 'Jan Jansz. Schroel', 216, 'fluit', '1656', NULL, NULL, 'A', 'A', '1658-10-22', 'Vlie', '1659-03-21', '1659-03-30', true, '1659-06-11', 'Batavia', NULL, 'Sold at Batavia 20-05-1670.');
INSERT INTO "voyages" VALUES (897, '', 4, '', 'PAREL', 'Douwe Aukes', 1100, NULL, '1651', NULL, NULL, 'A', 'A', '1658-10-22', 'Vlie', '1659-03-22', '1659-04-01', true, '1659-06-21', 'Batavia', 5475, 'Via Trinidad (29-01-1659). Via Mauritius and St. Paul because of leakage (see 0895).');
INSERT INTO "voyages" VALUES (898, '', 6, '', 'PRINSES ROYAAL', 'Maarten Doedesz.', 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1658-10-22', 'Vlie', '1659-03-08', '1659-03-20', true, '1659-06-02', 'Batavia', 5476, 'Via Trinidad (29-01-1659).');
INSERT INTO "voyages" VALUES (899, '', 1, '', 'ZUILEN', 'Steven Foram', 100, 'galjoot', '1657', NULL, NULL, 'A', 'A', '1658-10-22', 'Vlie', '1659-03-22', '1659-06-11', true, '1659-08-11', 'Batavia', NULL, 'From 31-03 till 26-05 at St. Helena. In 1671 sold for breaking up.');
INSERT INTO "voyages" VALUES (900, '', 1, '', 'HOOGLAND', 'Pieter Pouwels Andriesz. Steenhouwer', 270, 'pinas? jacht?', NULL, NULL, NULL, 'Z', 'Z', '1658-11-06', 'Wielingen', '1659-03-28', '1659-04-06', true, '1659-07-06', 'Batavia', NULL, 'Via the Wielingen; on 06-12 for the second time out. Via Sierra Leone. Laid up and sold at Batavia in 1673.');
INSERT INTO "voyages" VALUES (901, '', 1, '', 'MELISKERKE', NULL, 270, 'pinas? jacht?', '1658', NULL, NULL, 'Z', 'Z', '1658-11-11', 'Wielingen', '1659-03-10', '1659-03-19', true, '1659-06-02', 'Batavia', NULL, 'in 1674.');
INSERT INTO "voyages" VALUES (902, '', 2, '', 'ULYSSES', 'Kornelis Reiertsz. Steenhuizen', 400, 'fluit', NULL, NULL, NULL, 'A', 'A', '1658-12-03', 'Texel', '1659-03-21', '1659-03-30', true, '1659-06-20', 'Batavia', NULL, 'Via S. Tiago. Laid up at Batavia 16-10-1665.');
INSERT INTO "voyages" VALUES (903, '', 2, '', 'HECTOR', 'Lukas Bouwersz. van der Lek van Delfshaven', 600, 'jacht', NULL, NULL, NULL, 'A', 'D', '1658-12-06', 'Goeree', '1659-03-22', '1659-04-01', true, '1659-06-21', 'Batavia', NULL, 'Via Mauritius to accompany the PAREL which made water (see 0897). Wrecked in a battle against the Chinese in 1661.');
INSERT INTO "voyages" VALUES (904, '', 1, '', 'TERBOEDE', 'Kornelis Isaaksz. van der Vere', 182, 'galjoot', '1658', NULL, NULL, 'Z', 'Z', '1659-02-12', 'Wielingen', '1659-05-09', '1659-05-18', true, '1659-07-23', 'Batavia', NULL, 'Sold at Batavia in 1670.');
INSERT INTO "voyages" VALUES (905, '', 2, '', 'SLOT VAN HONINGEN', 'Sander Gerritsz. van Os', 1124, NULL, '1654', NULL, NULL, 'R', 'R', '1659-02-12', 'Wielingen', '1659-07-07', '1659-07-21', true, '1659-09-26', 'Batavia', 5474, NULL);
INSERT INTO "voyages" VALUES (906, '', 8, '', 'ORANJE', 'Hendrik van der Putte', 700, NULL, '1643', NULL, NULL, 'Z', 'Z', '1659-02-12', 'Wielingen', '1659-06-28', '1659-07-09', true, '1659-09-20', 'Batavia', 5487, NULL);
INSERT INTO "voyages" VALUES (907, '', 2, '', 'ACHILLES', 'Kornelis Reiersz.', 500, 'jacht', '1655', NULL, NULL, 'A', 'R', '1659-04-02', 'Goeree', '1659-07-15', '1659-07-29', true, '1659-09-26', 'Batavia', 5512, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (908, '', 8, '', 'HOF VAN ZEELAND', 'Jakob Bartelsz.', 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1659-04-03', 'Wielingen', '1659-07-14', '1659-07-29', true, '1659-09-27', 'Batavia', 5488, 'two children were born.');
INSERT INTO "voyages" VALUES (909, '', 8, '', 'MALAKKA', 'Jan van de Werf', 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1659-05-29', 'Vlie', '1659-10-05', '1659-10-22', true, '1659-12-29', 'Batavia', 5484, NULL);
INSERT INTO "voyages" VALUES (910, '', 3, '', 'GEKROONDE LEEUW', 'Frederik Pool', 1200, NULL, NULL, NULL, NULL, 'E', 'E', '1659-06-25', 'Vlie', '1659-12-16', '1659-12-31', true, '1660-04-21', 'Batavia', 5493, 'For two months the ship was delayed by calm at the equator. Via Annabon (departure 26-10).');
INSERT INTO "voyages" VALUES (911, '', 10, '', 'ENKHUIZEN', 'Hendrik Sieuwertsz.', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1659-09-09', 'Vlie', '1660-01-13', '1660-01-25', true, '1660-04-21', 'Batavia', NULL, 'For one month the ship was delayed by calm south of the equator. Laid up and sold 20-11-1665.');
INSERT INTO "voyages" VALUES (912, '', 1, '', '''S GRAVELAND', 'Andries Pietersz.', NULL, 'jacht', NULL, NULL, NULL, 'A', 'A', '1659-09-09', 'Vlie', '1660-01-10', '1660-01-22', true, '1660-05-01', 'Batavia', NULL, 'Returning from Nagasaki to Batavia in 1663, the ship was wrecked.');
INSERT INTO "voyages" VALUES (913, '', 3, '', 'AMERSFOORT', 'Jan Munt', 1000, NULL, '1655', NULL, NULL, 'A', 'A', '1659-12-17', 'Vlie', '1660-04-02', '1660-04-16', true, '1660-10-18', 'Batavia', 5482, 'Two of the men who embarked at the Cape were prisoners.');
INSERT INTO "voyages" VALUES (914, '', 3, '', 'WAPEN VAN AMSTERDAM', 'Michiel Engelken', 920, NULL, '1653', NULL, NULL, 'A', 'A', '1659-12-17', 'Vlie', '1660-03-29', '1660-04-09', true, '1660-06-04', 'Batavia', 5483, NULL);
INSERT INTO "voyages" VALUES (915, '', 2, '', 'ZIERIKZEE', 'Jut Jakobsz. Buis', 400, 'jacht', '1652', NULL, NULL, 'Z', 'R', '1659-12-17', 'Goeree', '1660-04-03', '1660-04-16', true, '1660-07-02', 'Batavia', NULL, 'Via Maio Island. Sunk off Macassar in 1668.');
INSERT INTO "voyages" VALUES (916, '', 1, '', 'DIEMERMEER', 'Karel Alteras', 505, 'fluit', '1659', NULL, NULL, 'A', 'Z', '1659-12-18', 'Wielingen', '1660-04-10', '1660-04-27', true, '1660-07-08', 'Batavia', 5525, NULL);
INSERT INTO "voyages" VALUES (917, '', 2, '', 'VLISSINGEN', 'Reinier Reiniersz.', 400, 'jacht', '1653', NULL, NULL, 'Z', 'Z', '1659-12-18', 'Wielingen', '1660-04-03', '1660-04-16', true, '1660-07-06', 'Batavia', NULL, 'Via Boa Vista Island. Broken up in the Bay of Gale (Ceylon), 1665/1666.');
INSERT INTO "voyages" VALUES (918, '', 2, '', 'NAARDEN', 'Pieter Egbertsz. Groot', 400, 'jacht', NULL, NULL, NULL, 'A', 'E', '1659-12-24', 'Texel', '1660-04-03', '1660-04-14', true, '1660-07-08', 'Batavia', NULL, 'Run ashore off Goa in 1665, and sold to a Portuguese for breaking up in 1666.');
INSERT INTO "voyages" VALUES (919, '', 9, '', 'WALVIS', 'Albert Bruinvis', 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1659-12-24', 'Vlie', '1660-04-04', '1660-04-16', true, '1660-07-12', 'Batavia', NULL, 'The two `passengers'' who embarked at the Cape were prisoners; one of them died. Wrecked on a reef at Salayar, 07-01-1663.');
INSERT INTO "voyages" VALUES (920, '', 1, '', 'MUSKAATBOOM or NOTENBOOM', 'Hermansz.', 600, NULL, NULL, '1659', NULL, NULL, 'A', '1660-03-08', 'Vlie', '1660-07-14', '1660-07-30', true, '1660-12-13', 'Batavia', 5528, NULL);
INSERT INTO "voyages" VALUES (921, '', 1, '', 'PARKIET', 'Usbrant van Banke', 80, 'galjoot', '1659', NULL, NULL, 'A', 'A', '1660-03-08', 'Vlie', '1660-07-27', '1661-06-17', true, '1661-08-19', 'Colombo', NULL, '09-11-1665.');
INSERT INTO "voyages" VALUES (922, '', 1, '', 'NAGELBOOM', 'Dirk Kornelis de Beer', 600, NULL, NULL, '1659', NULL, 'H', 'H', '1660-03-10', 'Texel', '1660-06-14', '1660-06-23', true, '1660-10-20', 'Batavia', 5486, 'At the Cape 58 French survivors of the wrecked MARECHAL embarked; three of them died.');
INSERT INTO "voyages" VALUES (923, '', 4, '', 'PHOENIX', 'Jan Lukas van Meeuwen', 900, NULL, NULL, NULL, NULL, 'A', 'D', '1660-03-13', 'Goeree', '1660-06-09', '1660-06-19', true, '1660-08-18', 'Batavia', 5495, 'At the Cape 58 French survivors of the wrecked MARECHAL embarked.');
INSERT INTO "voyages" VALUES (924, '', 9, '', 'VERENIGDE PROVINCIEN', NULL, 1100, NULL, '1643', NULL, NULL, 'Z', 'Z', '1660-03-13', 'Wielingen', NULL, NULL, false, '1660-08-10', 'Batavia', NULL, 'Via S. Vincente. Laid up at Batavia, 16-11-1663.');
INSERT INTO "voyages" VALUES (925, '', 1, '', 'BUIENSKERKE', NULL, 510, 'fluit', '1659', NULL, NULL, 'Z', 'Z', '1660-04-14', 'Wielingen', NULL, NULL, false, '1660-10-26', 'Batavia', 5538, 'Via Sierra Leone.');
INSERT INTO "voyages" VALUES (926, '', 1, '', 'LOOSDUINEN', 'Karsten Krijnsz. Rechter', 340, 'fluit', NULL, NULL, NULL, 'A', 'A', '1660-05-22', 'Texel', '1660-11-17', '1660-12-03', true, '1661-02-14', 'Batavia', 5522, 'Via Cape Mount, where two men deserted, 17-08 till 27-08-1660.');
INSERT INTO "voyages" VALUES (927, '', 1, '', 'VOLLENHOVEN', 'Nieuwendam', NULL, 'fluit', NULL, NULL, NULL, NULL, 'A', '1660-05-22', 'Texel', '1660-10-15', '1660-10-28', true, '1661-01-17', 'Batavia', NULL, 'Via Torbay where one seaman deserted. One child was born during the voyage. The ship was wrecked off Mishima Islands, 26-08-1663.');
INSERT INTO "voyages" VALUES (928, '', 9, '', 'WITTE OLIFANT', 'Filips de Bakker', 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1660-06-27', 'Vlie', '1660-11-15', '1660-12-03', true, '1661-02-13', 'Batavia', NULL, 'Laid up at Batavia, 04-03-1665.');
INSERT INTO "voyages" VALUES (929, '', 2, '', 'HILVERSUM', 'Jakob Bakker', 202, 'fluit', '1656', NULL, NULL, 'A', 'A', '1660-11-17', 'Texel', '1661-03-27', '1661-06-23', true, '1661-09-04', 'Coromandel', NULL, 'Via Brouwershaven where 3 man deserted. The ship was driven out of its course and sailed via Atjeh to Pulicat. The ship was sold in 1673.');
INSERT INTO "voyages" VALUES (930, '', 1, '', 'ANKEVEEN', 'Barend Joachimsz.', 283, 'jacht', '1660', NULL, NULL, 'A', 'A', '1660-11-24', 'Texel', '1661-03-24', '1661-04-02', true, '1661-05-30', 'Batavia', NULL, 'At the arrival at Batavia the crew included 10 stowaways from the return fleet (see 5482), who had come on board at the Cape. On 22-02-1663 wrecked off the coast of China; crew was saved.');
INSERT INTO "voyages" VALUES (931, '', 1, '', 'MAARSSEVEEN', 'Pieter Berkhout +', 1210, NULL, '1660', NULL, NULL, 'A', 'A', '1660-11-24', 'Texel', '1661-05-03', '1661-05-21', true, '1661-07-31', 'Batavia', 5494, 'The ship was delayed by a calm of 54 days south of the equator.');
INSERT INTO "voyages" VALUES (932, '', 2, '', 'VOGELZANG', 'Thomas Michielsz.', 680, 'fluit', NULL, NULL, NULL, 'A', 'A', '1660-11-24', 'Texel', '1661-04-25', '1661-05-05', true, '1661-07-13', 'Batavia', 5542, 'Via Cape Verde, 14 till 20-01-1661. The two `passengers'' who embarked at the Cape were stowaways.');
INSERT INTO "voyages" VALUES (933, '', 4, '', 'DORDRECHT', 'Adriaan de Gilde van Schiedam', 920, 'fregat', '1652', NULL, NULL, 'D', 'D', '1660-12-06', 'Goeree', '1661-04-26', '1661-05-05', true, '1661-07-18', 'Batavia', 5513, 'Acc. to Daghregister 1661 the ship departed 16-06-1660 from Texel.');
INSERT INTO "voyages" VALUES (934, '', 2, '', 'ERASMUS', 'Dirk van Duinen', 400, 'jacht', '1652', NULL, NULL, 'R', 'R', '1661-01-07', 'Goeree', '1661-04-25', '1661-05-05', true, '1661-07-14', 'Batavia', NULL, 'Laid up at Batavia, 21-02-1669.');
INSERT INTO "voyages" VALUES (935, '', 1, '', 'MEIBOOM', 'Gijsbert Jansz. Strandwijk', 312, 'jacht', '1660', NULL, NULL, 'R', 'R', '1661-01-07', 'Goeree', '1661-07-28', '1661-08-09', true, '1661-10-07', 'Batavia', 5509, 'On 11-04-1661 for the second time from Goeree.');
INSERT INTO "voyages" VALUES (936, '', 3, '', 'SLOT VAN HONINGEN', 'Willem Volkertsz.', 1124, NULL, '1654', NULL, NULL, 'R', 'Z', '1661-01-10', 'Wielingen', '1661-06-13', '1661-06-26', true, '1661-09-10', 'Batavia', 5503, 'On 07-02-1661 for the second time from Wielingen. Via Cape Verde.');
INSERT INTO "voyages" VALUES (937, '', 1, '', 'NIEUWENHOVE', 'Frederik Jansz.', 438, 'jacht', '1660', NULL, NULL, 'Z', 'Z', '1661-01-10', 'Wielingen', '1661-06-13', '1661-06-21', true, '1661-08-10', 'Batavia', 5535, 'On 07-02-1661 for the second time from the Wielingen.');
INSERT INTO "voyages" VALUES (938, '', 5, '', 'PRINS WILLEM', NULL, 700, NULL, '1650', NULL, NULL, 'Z', 'Z', '1661-01-10', 'Wielingen', '1661-06-09', '1661-06-29', true, '1661-09-10', 'Batavia', 5497, 'On 07-02-1661 for the second time from the Wielingen. One child was born during the voyage.');
INSERT INTO "voyages" VALUES (939, '', 3, '', 'ARNHEM', 'Rens Jansz. + Dirk Gerritsz. van Norden', 1000, NULL, '1654', NULL, NULL, 'A', 'A', '1661-02-07', 'Texel', '1661-06-16', '1661-07-06', true, '1661-09-12', 'Batavia', 5491, NULL);
INSERT INTO "voyages" VALUES (940, '', 3, '', 'WAPEN VAN HOLLAND', 'David de Koning', 920, NULL, '1653', NULL, NULL, 'A', 'A', '1661-02-07', 'Texel', '1661-06-18', '1661-07-06', true, '1661-09-12', 'Batavia', 5492, 'Gerrit van Harn, who was to succeed Jan van Riebeek as commandeur at the Cape, died and was buried at S. Vincente, March 1661.');
INSERT INTO "voyages" VALUES (941, '', 1, '', 'OVERVEEN', 'Hendrik Franken', 448, 'jacht', '1660', NULL, NULL, 'A', 'A', '1661-02-07', 'Texel', '1661-06-18', '1661-07-06', true, '1661-09-25', 'Batavia', NULL, 'One child was born during the voyage.');
INSERT INTO "voyages" VALUES (942, '', 2, '', 'ZEEPAARD', 'Hendrik Lucifer', 400, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1661-03-01', 'Wielingen', '1661-06-16', '1661-06-23', true, '1661-08-28', 'Batavia', 5519, 'Ship''s destination was Ceylon; arrival at Batavia by mistake of the master.');
INSERT INTO "voyages" VALUES (943, '', 1, '', 'BEURS VAN AMSTERDAM', 'Reier Mauntsz.', 472, 'jacht', NULL, '1660/1', NULL, 'A', 'A', '1661-04-11', 'Texel', '1661-07-25', '1661-08-03', true, '1661-11-01', 'Ceylon', 5521, NULL);
INSERT INTO "voyages" VALUES (944, '', 1, '', 'WASSENDE MAAN', 'Hendrik Springer', 400, 'jacht', NULL, '1660/1', NULL, 'A', 'A', '1661-04-11', 'Texel', '1661-08-23', '1661-09-24', true, '1662-06-04', 'Ceylon', 5504, 'Via S. Vincente (16 till 23-05). For five weeks at the equator. At the Cape 23 soldiers from the JONGE PRINS came on board. Searched for the return fleet (see 5491).');
INSERT INTO "voyages" VALUES (945, '', 1, '', 'RAADHUIS', NULL, 360, 'jacht', NULL, '1660/1', NULL, 'A', 'A', '1661-04-11', 'Texel', '1661-07-26', '1661-08-03', true, '1661-11-01', 'Ceylon', NULL, 'Laid up and sold, 24-11-1671.');
INSERT INTO "voyages" VALUES (946, '', 1, '', 'RIJZENDE ZON', NULL, 600, 'jacht', NULL, '1660/1', NULL, 'A', 'A', '1661-04-11', 'Texel', '1661-08-16', '1661-08-25', true, '1661-11-19', 'Ceylon', 5533, 'Via Sierra Leone; one man went missing and one man deserted. At the Cape 4 soldiers and a carpenter from the JONGE PRINS came on board.');
INSERT INTO "voyages" VALUES (947, '', 1, '', 'HUIS TE ZWIETEN', 'Gerrit Pietersz. van Vlaardingen', NULL, NULL, NULL, '1660/l', NULL, 'A', 'A', '1661-04-11', 'Texel', '1661-08-05', '1661-08-18', true, '1661-11-19', 'Ceylon', 5520, 'At the Cape 48 soldiers and a carpenter from the JONGE PRINS, 14 men from the MEIBOOM, and 20 men from the Cape came on board.');
INSERT INTO "voyages" VALUES (948, '', 1, '', 'JONGE PRINS', 'Kornelis Veldmuis +', 840, 'jacht', '1661', NULL, NULL, 'H', 'H', '1661-04-13', 'Texel', '1661-08-16', '1661-08-30', true, '1661-11-07', 'Batavia', 5506, 'At the Cape 23 soldiers went to the W ASSENDE MAAN, 4 soldiers and a carpenter to the RIJZENDE ZON, 48 soldiers and a carpenter to the HUTS TE ZWIETEN.');
INSERT INTO "voyages" VALUES (949, '', 1, '', 'NACHTEGAAL', 'Fijaart Meindertsz. Bakker', 80, 'galjoot', '1660', NULL, NULL, 'A', 'A', '1661-04-23', 'Vlie', '1662-01-17', '1662-01-31', true, '1662-06-02', 'Pulicat', NULL, 'On 15-06-1661 for the second time from the Vlie. Via Cape Verde (12 till 22-08) and Saldanha Bay (06-12-1661 till 10-01-1662). Wrecked off Ceram, 09-02-1665.');
INSERT INTO "voyages" VALUES (950, '', 5, '', 'PAREL', 'Robert Ram', 1100, NULL, '1651', NULL, NULL, 'A', 'A', '1661-04-23', 'Vlie', '1661-09-02', '1661-09-17', true, '1661-11-24', 'Batavia', 5505, 'During the voyage one child was born.');
INSERT INTO "voyages" VALUES (951, '', 7, '', 'PRINSES ROYAAL', 'Maarten Doedesz.', 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1661-04-23', 'Vlie', '1661-09-06', '1661-09-17', true, '1661-11-11', 'Batavia', 5496, 'One child was born during the voyage.');
INSERT INTO "voyages" VALUES (952, '', 1, '', 'KLEVERSKERKE', NULL, 368, 'fluit', '1660', NULL, NULL, 'Z', 'Z', '1661-05-13', 'Wielingen', '1661-09-26', '1661-10-05', true, '1661-12-12', 'Batavia', NULL, 'One child was born during the voyage. In 1675 laid up and sold at Batavia.');
INSERT INTO "voyages" VALUES (953, '', 8, '', 'WESTFRIESLAND', NULL, 1100, NULL, '1641', NULL, NULL, 'H', 'E', '1661-07-18', 'Vlie', '1662-01-18', '1662-02-02', true, '1662-05-24', 'Batavia', NULL, 'At Saldanha Bay (06-12-1661 till 10-01-1662). Laid up ar ;old at Batavia, 23-11-1667.');
INSERT INTO "voyages" VALUES (954, '', 4, '', 'WAPEN VAN AMSTERDAM', 'Jan Idese de Vink', 920, NULL, '1653', NULL, NULL, 'A', 'A', '1661-09-27', 'Vlie', '1661-01-30', '1661-02-09', true, '1662-04-28', 'Batavia', 5502, NULL);
INSERT INTO "voyages" VALUES (955, '', 9, '', 'MALAKKA', 'Pieter Jansz. Veldmuis', 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1661-10-03', 'Vlie', '1662-02-04', '1662-02-14', true, '1662-05-29', 'Batavia', NULL, 'Laid up and sold at Batavia, 19-10-1666.');
INSERT INTO "voyages" VALUES (956, '', 4, '', 'AMERSFOORT', 'Adriaan Joosten Zwaan', 1000, NULL, '1655', NULL, NULL, 'A', 'A', '1661-10-13', 'Wielingen', '1662-02-13', '1662-02-21', true, '1662-05-21', 'Batavia', 5501, NULL);
INSERT INTO "voyages" VALUES (957, '', 1, '', 'AMSTELLAND', 'Hermansz.', 700, 'fluit', '1660', NULL, NULL, 'A', 'A', '1662-01-09', 'Texel', '1662-04-27', '1662-05-08', true, '1662-07-10', 'Batavia', 5523, 'Via the Wielingen, departure on 26-01-1662.');
INSERT INTO "voyages" VALUES (958, '', 1, '', 'BUNSCHOTEN', 'Albert Krol', 219, 'fluit', '1660', NULL, NULL, 'E', 'E', '1662-01-09', 'Texel', '1662-04-22', '1662-04-27', true, '1662-07-07', 'Batavia', NULL, 'Laid up and sold at Batavia on 31-10-1676.');
INSERT INTO "voyages" VALUES (959, '', 2, '', 'KALF', NULL, 320, 'jacht? pinas?', NULL, NULL, NULL, 'A', 'A', '1662-01-09', 'Texel', '1662-04-21', '1662-04-27', true, '1662-06-05', 'Batavia', 5536, 'Via the Wielingen, departure on 26-01-1662.');
INSERT INTO "voyages" VALUES (960, '', 2, '', 'NAGELBOOM', NULL, 600, NULL, NULL, NULL, NULL, 'H', 'H', '1662-01-09', 'Texel', '1662-04-28', '1662-05-09', true, '1662-08-01', 'Batavia', 5516, 'Via the Wielingen, departure on 26-01-1662');
INSERT INTO "voyages" VALUES (961, '', 1, '', 'VELDHOEN', NULL, 180, 'fluit? galjoot?', '1661', NULL, NULL, 'A', 'A', '1662-01-09', 'Texel', '1662-08-01', '1662-09-26', true, NULL, NULL, NULL, 'Via the Wielingen. The ship stayed for some time for service at the Cape (Mozambique, St. Helena); see KENNEMERLAND (0968). Laid up and sold at Batavia in 1669.');
INSERT INTO "voyages" VALUES (962, '', 2, '', 'VENENBURG', NULL, 703, 'fluit', '1656', NULL, NULL, 'A', 'A', '1662-01-09', 'Texel', '1662-04-22', '1662-05-05', true, '1662-07-07', 'Batavia', 5537, 'Via the Wielingen, departure on 21-03-1662.');
INSERT INTO "voyages" VALUES (963, '', 2, '', 'MARS', NULL, 400, 'jacht', '1653', NULL, NULL, 'A', 'R', '1662-01-25', 'Goeree', '1662-04-22', '1662-05-08', true, '1662-07-06', 'Batavia', NULL, 'Laid up at Ceylon in 1669.');
INSERT INTO "voyages" VALUES (964, '', 1, '', 'PEPERBAAL', 'Vincent Dirksz. de Lange', 510, 'fluit', '1661', NULL, NULL, 'Z', 'D', '1662-01-25', 'Goeree', '1662-04-28', '1662-05-08', true, '1662-06-07', 'Batavia', NULL, 'The ship was wrecked near Japan (Mishima Islands) on 26-08-1663.');
INSERT INTO "voyages" VALUES (965, '', 1, '', 'WALCHEREN', NULL, 840, NULL, '1661', NULL, NULL, 'Z', 'Z', '1662-01-26', 'Wielingen', '1662-06-16', '1662-07-03', true, '1662-09-03', 'Batavia', 5507, NULL);
INSERT INTO "voyages" VALUES (966, '', 9, '', 'HOF VAN ZEELAND', NULL, 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1662-01-27', 'Wielingen', '1662-07-25', '1662-08-11', true, '1662-10-04', 'Batavia', 5508, 'Back in the Wielingen; new departure on 20-03-1662.');
INSERT INTO "voyages" VALUES (967, '', 1, '', 'VLAARDINGEN', 'Bartholomeus Verwey van Rotterdam', 400, 'jacht? pinas?', '1661?', NULL, NULL, 'D', 'D', '1662-04-14', 'Goeree', '1662-08-28', '1662-09-26', true, '1663-03-30', 'Batavia', 5570, 'departure on 23-05-1662. See KENNE-MERLAND (0968).');
INSERT INTO "voyages" VALUES (968, '', 1, '', 'KENNERMERLAND', NULL, 950, NULL, NULL, '1661/2', NULL, 'A', 'A', '1662-04-17', 'Texel', '1662-09-03', '1662-09-26', true, '1663-03-30', 'Batavia', 5514, 'KENNEMERLAND, WAPEN VAN ZEELAND (0973), VLAARDINGEN (0967), RIJNLAND (0969), KOGGE (0971), VELDHOEN (0961), and ZEERIDDER (0854), and on 16-10-1662 the ORANJE (0972) departed from the Cape under command of Huibert de Laresse to attack Mozambique and to look for the missing ships of the return fleet under command of Arnold de Vlaming. The mission failed; the fleet sailed on for Batavia.');
INSERT INTO "voyages" VALUES (969, '', 1, '', 'RIJNLAND', NULL, 795, NULL, '1662', NULL, NULL, 'A', 'A', '1662-04-17', 'Texel', '1662-09-02', '1662-09-26', true, '1663-03-30', 'Batavia', 5518, 'See KENNEMERLAND (0968).');
INSERT INTO "voyages" VALUES (970, '', 1, '', 'WATERHOEN', 'Pieter Willemsz.', 193, 'galjoot? fluit?', '1661', NULL, NULL, 'A', 'A', '1662-04-17', 'Texel', '1662-10-22', '1664-12-11', true, '1665-02-14', 'Batavia', NULL, 'attack on Mozambique, but fell behind and left the fleet on 29-06-1662 at 5''N. Stayed at the Cape. Wrecked at Amboina in 1672.');
INSERT INTO "voyages" VALUES (971, '', 1, '', 'KOGGE', NULL, 400, 'jacht', NULL, '1662', NULL, 'H', 'H', '1662-04-23', 'Texel', '1662-08-29', '1662-09-26', true, '1663-03-30', 'Batavia', 5534, 'The ship lost its bowsprit, foremast and several topmasts. See also KENNEMERLAND (0968).');
INSERT INTO "voyages" VALUES (972, '', 9, '', 'ORANJE', 'Pieter Kaub', 700, NULL, '1643', NULL, NULL, 'Z', 'Z', '1662-04-23', 'Wielingen', '1662-10-03', '1662-10-16', true, '1663-03-30', 'Batavia', 5517, 'See also KENNEMERLAND (0968).');
INSERT INTO "voyages" VALUES (973, '', 1, '', 'WAPEN VAN ZEELAND', NULL, NULL, NULL, NULL, '1661', NULL, 'Z', 'Z', '1662-04-23', 'Wielingen', '1662-09-07', '1662-09-26', true, '1663-03-30', 'Batavia', NULL, 'KENNEMERLAND (0968). On board: Vice-admiraal Willem Volgers. The ship was wrecked on a voyage to China on 16-09-1663.');
INSERT INTO "voyages" VALUES (974, '', 1, '', 'SLOTERDIJK', NULL, NULL, 'fluit', NULL, '1661/2', NULL, 'A', 'A', '1662-05-14', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked at Cape Verde in June 1662.');
INSERT INTO "voyages" VALUES (975, '', 1, '', 'BUIKSLOOT', NULL, 304, 'jacht', '1662', NULL, NULL, 'A', 'A', '1662-09-23', 'Texel', '1663-02-18', '1663-02-23', true, '1663-05-21', 'Batavia', NULL, 'on 09-10-1662. Laid up in 1674 and sold at Batavia.');
INSERT INTO "voyages" VALUES (976, '', 1, '', 'NIEUWENDAM', NULL, 210, 'jacht', '1662', NULL, NULL, 'A', 'A', '1662-09-23', 'Texel', '1663-03-12', '1663-03-27', true, '1663-06-18', 'Batavia', NULL, 'Via Goeree, departure on 09-10-1662. The ship was wrecked between Bima and Macassar on 1/2-10-1670.');
INSERT INTO "voyages" VALUES (977, '', 2, '', 'MAARSSEVEEN', 'Barend Barendsz. Lam', 1210, NULL, '1660', NULL, NULL, 'A', 'A', '1662-10-09', 'Texel', '1663-02-04', '1663-02-19', true, '1663-05-11', 'Batavia', 5515, 'The ship discovered two islands S. E. off the Cape which were called Dina and Maarsseveen. (later: Marion I. and Prince Edward I.).');
INSERT INTO "voyages" VALUES (978, '', 1, '', 'VLIEG', NULL, 120, 'galjoot? fluit?', NULL, '1661/2', NULL, 'A', 'A', '1662-10-09', 'Texel', '1663-01-07', '1663-02-14', true, '1663-05-21', 'Batavia', NULL, 'Laid up and sold at Batavia on 05-04-1675.');
INSERT INTO "voyages" VALUES (979, '', 1, '', 'KANEELBOOM', NULL, 300, 'jacht', '1662', NULL, NULL, 'Z', 'Z', '1662-11-28', 'Wielingen', '1663-04-03', '1663-04-17', true, '1663-07-06', 'Batavia', NULL, 'The ''passengers'' who embarked at the Cape, were Portuguese prisoners. The ship was wrecked on a voyage between Bengal and Batavia on 18-11-1670.');
INSERT INTO "voyages" VALUES (980, '', 1, '', 'RAMMEKENS', NULL, 438, 'jacht', '1662', NULL, NULL, 'Z', 'Z', '1662-11-28', 'Wielingen', '1663-03-29', '1663-04-10', true, '1663-06-18', 'Batavia', NULL, 'On the return voyage the ship carried French prisoners-of-war. Departure from Ceylon on 24-09-1674; arrival in Holland on 21-04-1676, when it was restored to the Company, see 1327.');
INSERT INTO "voyages" VALUES (981, '', 1, '', 'DURGERDAM', NULL, 452, 'jacht', '1662', NULL, NULL, 'A', 'A', '1662-11-29', 'Texel', '1663-04-06', '1663-04-17', true, '1663-09-21', 'Batavia', NULL, 'The ''passengers'' who embarked at the Cape, were 6 Portuguese prisoners and one slave. Laid up at Batavia in 1674.');
INSERT INTO "voyages" VALUES (982, '', 1, '', 'ELZENBURG', 'Theunis Schuit', 212, 'fluit', '1662', NULL, NULL, 'E', 'E', '1662-11-29', 'Texel', '1663-04-05', '1663-04-17', true, '1663-07-06', 'Batavia', NULL, 'The ''passengers'' who embarked at the Cape, were 4 Portuguese prisoners. The ship was wrecked on 09-11-1665 off Bimelepatnam.');
INSERT INTO "voyages" VALUES (983, '', 1, '', 'HOOGKARSPEL', 'Meindert Roelofsz.', 212, 'fluit', '1662', NULL, NULL, 'E', 'E', '1662-11-29', 'Texel', '1663-04-10', '1663-04-23', true, '1663-07-05', 'Batavia', NULL, 'embarked at the Cape were Portuguese prisoners. The ship was wrecked between Tonkin and Japan in 1670.');
INSERT INTO "voyages" VALUES (984, '', 2, '', 'OOIEVAAR', NULL, 627, 'fluit', '1656', NULL, NULL, 'Z', 'A', '1662-11-29', 'Texel', '1663-04-10', '1663-04-17', true, '1663-06-21', 'Batavia', 5529, 'The ''passengers'' who embarked at the Cape, were 6 Portuguese prisoners, 1 female slave and 2 children.');
INSERT INTO "voyages" VALUES (985, '', 1, '', 'BLEISWIJK', NULL, 240, 'jacht', '1662', NULL, NULL, 'R', 'R', '1662-12-01', 'Maas', '1663-03-19', '1663-04-08', true, '1663-07-19', 'Batavia', NULL, '1674.');
INSERT INTO "voyages" VALUES (986, '', 8, '', 'PRINSES ROYAAL', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'Z', '1662-12-28', 'Wielingen', '1663-05-09', '1663-05-23', true, '1663-08-02', 'Batavia', NULL, 'One child was born during the voyage. Laid up and sold in August 1666.');
INSERT INTO "voyages" VALUES (987, '', 1, '', 'JONKER', NULL, 200, 'fregat', NULL, '1662', NULL, 'Z', 'Z', '1663-01-22', 'Wielingen', NULL, NULL, false, '1663-06-14', 'Batavia', NULL, 'Wrecked on the rocks of the ''Hytanse'' Islands on 17-12-1667; 33 men were drowned; there were about 13 survivors.');
INSERT INTO "voyages" VALUES (988, '', 5, '', 'PHOENIX', 'Kornelis Stamper', 900, NULL, NULL, NULL, NULL, 'A', 'D', '1663-04-01', 'Goeree', '1663-07-15', '1663-08-03', true, '1663-10-08', 'Batavia', 5530, 'On board commandeur Johan van der Laan.');
INSERT INTO "voyages" VALUES (989, '', 2, '', 'SPREEUW', NULL, 347, 'fluit', '1657', NULL, NULL, 'Z', 'A', '1663-04-01', 'Goeree', '1663-07-16', '1663-07-25', true, '1663-09-16', 'Batavia', 5567, NULL);
INSERT INTO "voyages" VALUES (990, '', 1, '', 'ALPHEN', NULL, 700, 'fluit', '1662', NULL, NULL, 'A', 'A', '1663-04-16', 'Texel', '1663-08-26', '1663-09-09', true, '1663-11-14', 'Batavia', 5555, 'On board P. van Hoorn, extraordinaris Raad van Indie.');
INSERT INTO "voyages" VALUES (991, '', 1, '', 'AMERONGEN', NULL, 452, 'jacht', '1662', NULL, NULL, 'A', 'A', '1663-04-16', 'Texel', '1663-08-28', '1663-09-09', true, '1663-11-16', 'Batavia', 5564, NULL);
INSERT INTO "voyages" VALUES (992, '', 1, '', 'SPARENDAM', NULL, 700, 'fluit', '1662', NULL, NULL, 'A', 'A', '1663-04-16', 'Texel', '1663-08-26', '1663-09-09', true, '1663-11-13', 'Batavia', 5545, 'On board Pieter Anthonis Overwater, extraordinaris Raad van Indie.');
INSERT INTO "voyages" VALUES (993, '', 1, '', 'PURMERLAND', NULL, 218, 'jacht', '1663', NULL, NULL, 'A', 'A', '1663-04-19', 'Texel', '1663-08-28', '1663-09-06', true, '1663-11-13', 'Batavia', NULL, 'Wrecked at Macassar because of an explosion in the gunpowderroom, on 09-08-1668.');
INSERT INTO "voyages" VALUES (994, '', 1, '', 'ILPENDAM', 'Pieter Pietersz. van Ilpendam', 212, 'jacht', '1663', NULL, NULL, 'A', 'A', '1663-04-20', 'Texel', '1663-08-26', '1663-09-06', true, '1663-11-13', 'Batavia', NULL, 'At the Cape 2 soldiers came on board from the ALPHEN. Sold in 1671.');
INSERT INTO "voyages" VALUES (995, '', 1, '', 'LANDSMEER', 'Reinier Brinkmans', 212, 'jacht', '1663', NULL, NULL, 'A', 'A', '1663-04-26', 'Texel', '1663-08-27', '1663-09-05', true, '1664-02-12', 'Batavia', NULL, 'crew of the ARNHEM (05491). Laid up at Ceylon in 1675.');
INSERT INTO "voyages" VALUES (996, '', 1, '', 'HAZENBURG', NULL, 636, 'fluit', '1663', NULL, NULL, 'Z', 'Z', '1663-05-05', 'Wielingen', '1663-09-15', '1663-09-25', true, '1663-12-24', 'Batavia', 5550, 'during the voyage.');
INSERT INTO "voyages" VALUES (997, '', 1, '', 'MEERMAN', 'Laurens Maartensz. Luiken', 440, 'jacht', '1663', NULL, NULL, 'D', 'D', '1663-05-07', 'Maas', '1663-08-28', '1663-09-09', true, '1663-10-31', 'Batavia', 5541, 'as Klaas Barends.');
INSERT INTO "voyages" VALUES (998, '', 1, '', 'WESTWOUD', NULL, 212, 'fluit', '1663', NULL, NULL, 'E', 'E', '1663-05-11', 'Texel', '1663-10-12', '1663-10-23', true, '1663-12-21', 'Batavia', NULL, 'Wrecked at Bengal, 16-04-1673.');
INSERT INTO "voyages" VALUES (999, '', 1, '', 'WILGENBURG', NULL, 248, 'fluit? jacht?', '1663', NULL, NULL, 'E', 'E', '1663-05-11', 'Texel', '1663-10-12', '1663-10-23', true, '1663-12-25', 'Batavia', NULL, 'Sold at Batavia in 1674.');
INSERT INTO "voyages" VALUES (1000, '', 1, '', 'WAPEN VAN HOORN', 'Michiel Roelofsz. de jonge', 756, 'fluit? jacht?', '1662', NULL, NULL, 'H', 'H', '1663-05-19', 'Texel', '1663-12-29', '1664-01-29', true, '1664-05-22', 'Batavia', 5527, 'The master was dismissed at the Cape because of bad command, and was succeeded by Pieter Willemsz.van Weesp. Via Annabon.');
INSERT INTO "voyages" VALUES (1001, '', 1, '', 'PAUW', NULL, 550, 'jacht', '1663', NULL, NULL, 'R', 'R', '1663-05-24', 'Goeree', '1663-10-07', '1663-10-17', true, '1663-12-28', 'Batavia', NULL, 'Laid up and sold at Batavia on 07-05-1677.');
INSERT INTO "voyages" VALUES (1002, '', 1, '', 'BREDERODE', NULL, 666, 'fluit? jacht?', '1663', NULL, NULL, 'A', 'A', '1663-09-30', 'Vlie', '1664-04-10', '1664-04-21', true, '1664-07-17', 'Batavia', 5524, 'Via the Wielingen, departure on 27-11-1663.');
INSERT INTO "voyages" VALUES (1003, '', 1, '', 'KATTENBURG', NULL, 637, 'fluit', '1663', NULL, NULL, 'A', 'A', '1663-09-30', 'Vlie', '1664-03-11', '1664-03-20', true, '1664-06-21', 'Batavia', 5559, 'Via the Wielingen, departure on 27-11-1663.');
INSERT INTO "voyages" VALUES (1004, '', 6, '', 'PAREL', NULL, 1100, NULL, '1651', NULL, NULL, 'A', 'A', '1663-10-01', 'Vlie', '1664-04-10', '1664-04-20', true, '1664-06-14', 'Batavia', NULL, 'Via the Wielingen because of adverse winds, departure on 27-12-1663. Laid up and sold at Batavia on 15-11-1669.');
INSERT INTO "voyages" VALUES (1005, '', 10, '', 'HOF VAN ZEELAND', NULL, 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1663-11-27', 'Wielingen', '1664-03-30', '1664-04-11', true, '1664-06-21', 'Batavia', NULL, 'Laid up on 30-09-1670.');
INSERT INTO "voyages" VALUES (1006, '', 2, '', 'WASSENDE MAAN', NULL, 400, 'jacht', NULL, '1660/1', NULL, 'A', 'A', '1663-12-08', 'Texel', '1664-04-29', '1664-05-08', true, '1664-06-17', 'Batavia', 5540, NULL);
INSERT INTO "voyages" VALUES (1007, '', 2, '', 'MEIBOOM', NULL, 312, 'jacht', '1660', NULL, NULL, 'R', 'E', '1663-12-08', 'Texel', '1664-04-09', '1664-04-21', true, '1664-08-24', 'Batavia', NULL, 'Taken by 4 English privateers near Wingurla on 02-11-1672.');
INSERT INTO "voyages" VALUES (1008, '', 2, '', 'NIEUWPOORT', NULL, 400, 'fluit', NULL, NULL, NULL, NULL, 'A', '1663-12-08', 'Texel', '1664-04-13', '1664-04-21', true, '1664-07-06', 'Batavia', NULL, 'Laid up and sold on 30-10-1674.');
INSERT INTO "voyages" VALUES (1009, '', 2, '', 'JONGE PRINS', NULL, 840, 'jacht', '1661', NULL, NULL, 'H', 'H', '1663-12-08', 'Texel', '1664-04-09', '1664-04-25', true, '1664-07-06', 'Batavia', 5531, NULL);
INSERT INTO "voyages" VALUES (1010, '', 1, '', 'OUDSHOORN', NULL, 666, 'pinas? jacht?', '1663', NULL, NULL, 'A', 'A', '1663-12-10', 'Texel', '1664-03-15', '1664-03-26', true, '1664-06-08', 'Batavia', 5561, NULL);
INSERT INTO "voyages" VALUES (1011, '', 4, '', 'SLOT VAN HONINGEN', 'Herman de Ruiter', 1124, NULL, '1654', NULL, NULL, 'R', 'R', '1664-02-02', 'Goeree', '1664-05-09', '1664-05-27', true, '1664-07-22', 'Batavia', 5526, NULL);
INSERT INTO "voyages" VALUES (1012, '', 2, '', 'WALCHEREN', NULL, 840, NULL, '1661', NULL, NULL, 'Z', 'Z', '1664-03-30', 'Wielingen', '1664-06-29', '1664-07-14', true, '1664-09-22', 'Batavia', 5532, NULL);
INSERT INTO "voyages" VALUES (1013, '', 1, '', 'EENDRACHT', 'Gerrit den Kok van Delfshaven', 670, NULL, '1663', NULL, NULL, 'D', 'D', '1664-05-13', 'Goeree', '1664-11-12', '1664-11-28', true, '1665-03-03', 'Batavia', 5548, 'ship departed on 03-05-1664; via Sierra Leone. Two men were put ashore before arrival at the Cape.');
INSERT INTO "voyages" VALUES (1014, '', 2, '', 'RODE HERT', NULL, 340, 'fluit', NULL, NULL, NULL, 'A', 'A', '1664-05-15', 'Vlie', '1664-09-18', '1664-09-28', true, '1664-12-14', 'Batavia', NULL, 'Burnt in Japan, off Decima on 07-07-1665.');
INSERT INTO "voyages" VALUES (1015, '', 5, '', 'WAPEN VAN AMSTERDAM', NULL, 920, NULL, '1653', NULL, NULL, 'A', 'A', '1664-05-21', 'Vlie', '1664-10-11', '1664-10-21', true, '1665-01-24', 'Batavia', 5547, NULL);
INSERT INTO "voyages" VALUES (1016, '', 1, '', 'ZANDLOPER', NULL, 120, 'fluit? galjoot?', NULL, '1663/4', NULL, 'A', 'A', '1664-08-19', 'Texel', NULL, NULL, false, '1665-02-23', 'Batavia', NULL, 'According to Uitloopboek the ship departed on 26-08-1664. Laid up in 1674 and sold in 1675.');
INSERT INTO "voyages" VALUES (1017, '', 1, '', 'KEMPHAAN', 'Matthijs Kornelisz. Mijnochs van Delfshaven', 80, 'hoeker', NULL, '1664', NULL, 'D', 'D', '1664-08-20', 'Maas', '1665-01-02', '1665-01-16', true, '1665-03-12', 'Masulipatna', NULL, '1671.');
INSERT INTO "voyages" VALUES (1018, '', 1, '', 'KWIKSTAART', 'Gilles Kornelisz. Duin Meier van Delfshaven', 80, 'hoeker? bootje?', NULL, '1664', NULL, 'D', 'D', '1664-08-20', 'Maas', '1665-01-10', '1665-06-18', true, '1665-08-16', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1019, '', 1, '', 'PIMPEL', 'Jochem Jakobsz. Hogenhoek', 80, 'hoeker', NULL, '1664', NULL, 'D', 'D', '1664-08-26', 'Maas', '1665-01-04', '1666-07-27', true, '1666-10-17', 'Batavia', NULL, 'Stayed for some time for service at the Cape. Sold at Batavia in 1672.');
INSERT INTO "voyages" VALUES (1020, '', 1, '', 'POELSNIP', 'Jan Kornelisz. Kleinebout van Vlaardingen', 80, 'hoeker', NULL, '1664', NULL, 'D', 'D', '1664-08-26', 'Maas', '1665-01-29', '1665-02-08', true, '1665-04-23', 'Batavia', NULL, 'According to Uitloopboek the ship departed on 19-08-1664; laid up at Ceylon in 1675.');
INSERT INTO "voyages" VALUES (1021, '', 5, '', 'AMERSFOORT', NULL, 1000, NULL, '1655', NULL, NULL, 'A', 'A', '1664-11-22', 'Vlie', '1665-04-23', '1665-05-08', true, '1665-07-22', 'Batavia', 5546, 'According to Daghregister 1665 the ship arrived on 28-07-1665.');
INSERT INTO "voyages" VALUES (1022, '', 1, '', 'ZUIDPOLSBROEK', NULL, 960, NULL, '1664', NULL, NULL, 'A', 'A', '1664-11-22', 'Vlie', '1665-04-10', '1665-04-26', true, '1665-07-12', 'Batavia', 5554, NULL);
INSERT INTO "voyages" VALUES (1023, '', 1, '', 'DOFFER', NULL, 95, 'hoeker', NULL, NULL, '1664', 'R', 'R', '1664-12-05', 'Maas', NULL, NULL, true, NULL, NULL, NULL, 'Taken by the English.');
INSERT INTO "voyages" VALUES (1024, '', 1, '', 'KASTEEL VAN MEDEMBLIK', NULL, 696, NULL, '1664', NULL, NULL, 'E', 'E', '1664-12-09', 'Texel', '1665-05-01', '1665-05-12', true, '1665-07-26', 'Batavia', 5551, NULL);
INSERT INTO "voyages" VALUES (1025, '', 1, '', 'EEKHOORN', NULL, NULL, 'hoeker', NULL, NULL, '1664', 'R', 'R', '1664-12-14', 'Maas', '1665-06-09', '1665-06-24', true, '1665-08-27', 'Pulicat', NULL, 'Via La Rochelle, departure on 26-02-1665. The destination was Ceylon, but the ship passed it. Laid up at Banda in 1673.');
INSERT INTO "voyages" VALUES (1026, '', 2, '', 'RUNLAND', 'Wilke Wybertsz.?', 795, NULL, '1662', NULL, NULL, 'A', 'A', '1664-12-14', 'Texel', '1665-09-18', '1665-12-03', true, '1666-03-24', 'Batavia', NULL, 'From 06-01 till 01-07-1665 at Goeree. The ship was burned at Batavia after an explosion in the gunpowderroom on 05-05-1666.');
INSERT INTO "voyages" VALUES (1027, '', 2, '', 'KENNERMERLAND', NULL, 950, NULL, NULL, '1661', NULL, NULL, 'A', '1664-12-14', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked on Stour a Stack in the Outer Skerries, Shetland 1. on 20-12-1664. All hands lost, also the cargo of fl.120,000.');
INSERT INTO "voyages" VALUES (1028, '', 3, '', 'ACHILLES', NULL, 550, 'jacht', '1655', NULL, NULL, 'A', 'A', '1664-12-20', 'Wielingen', '1665-12-22', '1666-01-04', true, '1666-05-04', 'Batavia', NULL, 'New departure from the Wielingen: 24-03-1665. Via Annabon and Cape Lopez, where 7 seafarers and 9 soldiers deserted. Wrecked on a voyage to Japan in 1669.');
INSERT INTO "voyages" VALUES (1029, '', 1, '', 'MIDDELBURG', 'Pieter Pietersz.', 846, NULL, '1664', NULL, NULL, 'Z', 'Z', '1664-12-21', 'Wielingen', '1665-08-18', '1665-09-01', true, '1665-11-09', 'Batavia', 5552, 'Via the Wielingen: 08-01 till 24-03-1665, S. Vincente: 19 till 20-05-1665, Bravo 1.: 22-05-1665 and Ascension: 14-07-1665. On board: commandeur Usbrand Godske.');
INSERT INTO "voyages" VALUES (1030, '', 1, '', 'GEKROONDE HARING', NULL, 80, 'hoeker', NULL, NULL, '1664', 'Z', 'Z', '1665-02-12', 'Wielingen', '1665-07-01', '1665-09-13', true, '1666-12-18', 'Batavia', NULL, 'service at the Cape. Destination Ceylon; because of adverse winds the ship sailed to Batavia.');
INSERT INTO "voyages" VALUES (1031, '', 1, '', 'AAP', 'Tenneke Frederiksz.', NULL, 'hoeker', NULL, '1664/5', NULL, 'A', 'A', '1665-02-16', 'Maas', '1665-06-09', '1665-06-26', true, '1665-09-06', 'Surat', NULL, NULL);
INSERT INTO "voyages" VALUES (1032, '', 1, '', 'MEERKAT', NULL, 80, 'hoeker', NULL, '1664/5', NULL, 'A', 'A', '1665-02-17', 'Texel', '1665-06-11', '1665-07-11', true, '1665-09-24', 'Bengal', NULL, NULL);
INSERT INTO "voyages" VALUES (1033, '', 2, '', 'LOOSDUINEN', 'Daniel de Bak', 340, 'fluit', NULL, NULL, NULL, 'A', 'R', '1665-04-18', 'Goeree', '1665-09-17', '1665-10-02', true, '1665-12-25', 'Batavia', 5568, 'According to Uitloopboek the ship departed on 14-04-1665. At the Cape 11 English prisoners of the ROYAL CHARLES embarked.');
INSERT INTO "voyages" VALUES (1034, '', 1, '', 'VERGULDE TIJGER', NULL, 520, 'fluit? jacht?', NULL, NULL, '1664/5', 'A', 'A', '1665-08-15', 'Texel', '1666-01-30', '1666-02-12', true, '1666-05-07', 'Batavia', 5563, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1035, '', 1, '', 'CECILIA', NULL, NULL, 'fluit', NULL, NULL, '1665', 'H', 'H', '1665-08-16', 'Texel', '1666-01-30', '1666-02-12', true, '1666-05-24', 'Batavia', 5543, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1036, '', 1, '', 'ESPERANCE', NULL, NULL, 'fluit', NULL, NULL, '1665', 'H', 'H', '1665-08-21', 'Texel', '1666-01-26', '1666-02-04', true, '1666-05-06', 'Batavia', 5549, '.');
INSERT INTO "voyages" VALUES (1037, '', 1, '', 'OPPERDOES', NULL, NULL, 'fluit', NULL, NULL, '1664/5', 'A', 'A', '1665-10-05', 'Texel', '1666-03-19', '1666-04-01', true, '1666-07-14', 'Batavia', 5544, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (1038, '', 1, '', 'CONSTANTIA', NULL, NULL, 'pinas? jacht?', NULL, NULL, '1664/5', 'A', 'A', '1665-10-08', 'Texel', '1666-02-26', '1666-03-11', true, '1666-05-25', 'Batavia', 5557, NULL);
INSERT INTO "voyages" VALUES (1039, '', 1, '', 'GOUDEN LEEUW', NULL, 330, 'fluit', NULL, '1665', NULL, 'Z', 'Z', '1665-10-28', 'Wielingen', '1666-03-14', '1666-03-25', true, '1666-06-18', 'Batavia', NULL, 'Wrecked at one of the Tiger Islands in 1674.');
INSERT INTO "voyages" VALUES (1040, '', 1, '', 'WITTE LEEUW', NULL, 360, 'fluit', NULL, '1665', NULL, 'Z', 'Z', '1665-10-28', 'Wielingen', '1666-04-02', '1666-04-13', true, '1666-06-26', 'Batavia', NULL, 'The ship was wrecked at the Orissa coast on 03-11-1670.');
INSERT INTO "voyages" VALUES (1041, '', 1, '', 'ZWARTE LEEUW', NULL, 300, 'fluit', NULL, '1665', NULL, 'Z', 'Z', '1665-10-28', 'Wielingen', '1666-03-27', '1666-04-04', true, '1666-06-20', 'Batavia', NULL, 'Via S. Tiago. One soldier was drowned. According to Daghreg. 1675 and K.A. 1196 laid up and sold at Batavia in 1675; according to Coolhaas III the ship was wrecked coming from Bengal in 1671.');
INSERT INTO "voyages" VALUES (1042, '', 3, '', 'ZEEPAARD', NULL, 400, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1665-10-28', 'Wielingen', NULL, NULL, true, NULL, NULL, NULL, 'The ship was wrecked west of the Shetland Islands.');
INSERT INTO "voyages" VALUES (1043, '', 2, '', 'BREDERODE', NULL, 666, 'fluit? jacht?', '1663', NULL, NULL, 'A', 'A', '1665-12-17', 'Texel', '1666-04-06', '1666-04-13', true, '1666-06-26', 'Batavia', 5584, NULL);
INSERT INTO "voyages" VALUES (1044, '', 1, '', 'NUISSENBURG', NULL, 486, 'pinas? jacht?', NULL, '1664/5', NULL, 'A', 'A', '1665-12-17', 'Texel', '1666-04-01', '1666-04-15', true, '1666-06-18', 'Batavia', 5587, NULL);
INSERT INTO "voyages" VALUES (1045, '', 5, '', 'DORDRECHT', 'Jan Lukas van Meeuwen van Delfshaven', 920, 'fregat', '1652', NULL, NULL, 'D', 'D', '1665-12-19', 'Goeree', '1666-08-25', '1666-10-01', true, '1666-12-30', 'Batavia', 5558, 'Via Faeroe Islands. The ship stayed there for two months; ten seafarers enlisted. The ship brought commandeur Van Kwaalberge to the Cape.');
INSERT INTO "voyages" VALUES (1046, '', 2, '', 'NIEUWENHOVE', NULL, 438, 'jacht', '1660', NULL, NULL, 'Z', 'A', '1666-04-09', 'Texel', '1666-07-31', '1666-08-15', true, '1666-10-17', 'Batavia', NULL, 'The ship was laid up and sold at Batavia in 1675.');
INSERT INTO "voyages" VALUES (1047, '', 2, '', 'RIJZENDE ZON', NULL, 600, 'jacht', NULL, '1660/1', NULL, 'A', 'A', '1666-04-09', 'Texel', '1666-07-31', '1666-08-15', true, '1666-10-11', 'Batavia', 5577, NULL);
INSERT INTO "voyages" VALUES (1048, '', 1, '', 'HOLLANDSE TUIN', NULL, 1210, NULL, '1665', NULL, NULL, 'A', 'A', '1666-04-10', 'Texel', '1666-08-23', '1666-09-09', true, '1666-11-19', 'Batavia', 5562, 'Via Maio I. Pieter de Bitter died aboard.');
INSERT INTO "voyages" VALUES (1049, '', 1, '', 'KAUW', 'Kornelis Roobol', 80, 'galjoot? hoeker?', NULL, '1665', NULL, 'Z', 'Z', '1666-04-27', 'Texel', '1666-09-29', '1666-11-07', true, '1667-01-17', 'Batavia', NULL, 'ship was laid up at Ambon in 1669.');
INSERT INTO "voyages" VALUES (1050, '', 3, '', 'OOIEVAAR', 'Adriaan Huibertsz.', 627, 'fluit', '1656', NULL, NULL, 'Z', 'Z', '1666-04-29', 'Texel', '1666-11-03', '1666-12-08', true, '1667-04-27', 'Batavia', NULL, 'Via Maio I. (25-06-1666). The ship stayed near Lombok from 26-02 till 10-03-1667. The OOIEVAAR was wrecked in the Ganges in Bengal, 30-07-1668.');
INSERT INTO "voyages" VALUES (1051, '', 3, '', 'WALCHEREN', 'Frans van Heist', 840, NULL, '1661', NULL, NULL, 'Z', 'Z', '1666-05-02', 'Texel', '1666-09-21', '1666-10-17', true, '1666-12-15', 'Batavia', 5553, NULL);
INSERT INTO "voyages" VALUES (1052, '', 2, '', 'BEURS VAN AMSTERDAM', 'Pieter Koker', 472, 'jacht', NULL, '1660/1', NULL, 'A', 'A', '1666-05-29', 'Texel', '1666-09-29', '1666-11-19', true, '1667-01-22', 'Batavia', NULL, 'Via S. Vincente. The ship was laid up and sold at Batavia in 1675.');
INSERT INTO "voyages" VALUES (1053, '', 1, '', 'GERECHTIGHEID', NULL, 652, 'jacht', '1666', NULL, NULL, 'A', 'A', '1666-07-05', 'Texel', '1666-11-17', '1666-12-07', true, '1667-02-08', 'Batavia', 5610, NULL);
INSERT INTO "voyages" VALUES (1054, '', 2, '', 'DIEMERMEER', 'Engel Jansz.', 505, 'fluit', '1660', NULL, NULL, 'A', 'Z', '1666-07-29', 'Wielingen', '1666-12-31', '1667-01-12', true, '1667-05-03', 'Batavia', NULL, 'Acc. to K.A. 3979 the ship left the Wielingen on 31-06-1666.
The ship returned to the Maas on 30-07 and set out again on 01-08. Via S. Vincente: two seafarers deserted. The ship was wrecked near Banda, 28-06-1670.');
INSERT INTO "voyages" VALUES (1055, '', 1, '', 'BATAVIA', 'Dirk Hermansz.', 756, 'pinas? jacht?', NULL, '1666', NULL, 'R', 'R', '1666-08-01', 'Maas', '1666-12-27', '1667-01-11', true, '1667-03-31', 'Batavia', 5571, 'Via S. Tiago (13-09-1666).');
INSERT INTO "voyages" VALUES (1056, '', 2, '', 'WAPEN VAN HOORN', 'Jan Koertsz. van Steenwijk', 756, 'fluit? jacht?', '1662', NULL, NULL, 'H', 'A', '1666-09-12', 'Texel', '1667-02-16', '1667-03-01', true, '1667-05-25', 'Batavia', 5556, NULL);
INSERT INTO "voyages" VALUES (1057, '', 1, '', 'VRIJHEID', 'Douwe Aukes', 1210, NULL, '1666', NULL, NULL, 'A', 'A', '1666-09-12', 'Texel', '1667-01-27', '1667-02-12', true, '1667-05-07', 'Batavia', 5566, 'Via S. Vincente, arrival on 14-10-1666.');
INSERT INTO "voyages" VALUES (1058, '', 2, '', 'KOGGE', 'Jan Hendriksz. Boon', 400, 'jacht', NULL, '1662', NULL, 'H', 'A', '1666-09-25', 'Texel', '1667-02-20', '1667-03-10', true, '1667-06-05', 'Batavia', 5586, NULL);
INSERT INTO "voyages" VALUES (1059, '', 1, '', 'VICTORIA', 'Jakob Kleinzorg', 666, 'fluit', '1666', NULL, NULL, 'H', 'H', '1666-10-19', 'Texel', '1667-01-27', '1667-02-12', true, '1667-05-04', 'Batavia', NULL, 'when sailing from the Bay of Swally; the cargo was partly saved.');
INSERT INTO "voyages" VALUES (1060, '', 1, '', 'LIEFDE', 'Joost Goes', 400, 'jacht', NULL, '1664/5', NULL, 'A', 'Z', '1666-11-07', 'Wielingen', '1667-04-15', '1667-05-01', true, '1667-08-04', 'Batavia', 3, 'Boudewijnse was master. At S. Vincente on 28-12-1666 till 25-01-1667. Coming from Persia the ship was wrecked at Baios de Padua on 05-07-1668, with 27 men drowned.');
INSERT INTO "voyages" VALUES (1061, '', 1, '', 'BLAUWE VISSER', 'Arnt Kornelisz.+', 250, 'jacht? pinas?', NULL, '1666', NULL, 'Z', 'Z', '1666-11-07', 'Wielingen', '1667-04-02', '1667-05-01', true, '1667-07-29', 'Batavia', NULL, 'Batavia in 1674.');
INSERT INTO "voyages" VALUES (1062, '', 1, '', 'HANDELAAR', 'Pieter Harkes', 600, 'fluit', NULL, '1665/6', NULL, 'A', 'A', '1666-12-26', 'Texel', '1667-05-10', '1667-06-09', true, '1667-08-30', 'Batavia', 5579, NULL);
INSERT INTO "voyages" VALUES (1063, '', 3, '', 'JONGE PRINS', 'Kornelis Schuit', 840, 'jacht', '1661', NULL, NULL, 'H', 'E', '1666-12-27', 'Texel', '1667-07-07', '1667-07-23', true, '1667-09-29', 'Batavia', 5565, 'Via Sierra Leone and S. Vincente. According to Daghregister 1666/7 the ship departed on 17-12-1666.');
INSERT INTO "voyages" VALUES (1064, '', 1, '', 'WAPEN VAN MIDDELBURG', 'Krijn Jansz. Kant', 676, NULL, '1666', NULL, NULL, 'Z', 'Z', '1667-01-17', 'Wielingen', '1667-06-07', '1667-06-18', true, '1667-08-15', 'Batavia', 5560, 'Via Annabon. At Annabon and the Cape 8 seafarers and 1 soldier deserted.');
INSERT INTO "voyages" VALUES (1065, '', 3, '', 'WASSENDE MAAN', 'Pieter Douwesz.', 480, 'jacht', NULL, '1660/1', NULL, 'A', 'A', '1667-04-19', 'Texel', '1667-08-29', '1667-09-11', true, '1667-12-01', 'Colombo', 5569, 'According to K.A. 3870 the ship departed on 29-04-1667.');
INSERT INTO "voyages" VALUES (1066, '', 1, '', 'WAPEN VAN GOUDA', 'Gale Galisz.', 708, NULL, NULL, '1666/7', NULL, 'A', 'A', '1667-05-20', 'Texel', '1667-09-08', '1667-09-16', true, '1667-12-07', 'Colombo', 5572, NULL);
INSERT INTO "voyages" VALUES (1067, '', 3, '', 'VENENBURG', NULL, 703, 'fluit', '1656', NULL, NULL, 'A', 'A', '1667-05-20', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Taken by the English near Ireland in June 1667.');
INSERT INTO "voyages" VALUES (1068, '', 2, '', 'MEERMAN', 'Laurens Maartensz. Luiken', 440, 'jacht', '1663', NULL, NULL, 'D', 'D', '1667-05-23', 'Maas', '1667-11-28', '1667-12-05', true, '1668-02-11', 'Batavia', NULL, 'Via Texel, departure on 06-06-1667. Via Sierra Leone, 24-08 till 02-09-1667. At the Cape one seaman and five soldiers came on board as prisoners (counted as passengers). They were probably released at Batavia. The ship was sold in 1673.');
INSERT INTO "voyages" VALUES (1069, '', 2, '', 'BUIENSKERKE', 'Adriaan Schenkels+', 510, 'fluit', '1659', NULL, NULL, 'Z', 'Z', '1667-06-21', 'Wielingen', '1667-11-28', '1667-12-10', true, '1668-02-12', 'Batavia', NULL, 'some soldiers. Four soldiers were thrown overboard, one seaman and five soldiers went to the MEERMAN (1068). One child was born. The ship was wrecked near the isle of Galle (Bengal) on 08-08-1671.');
INSERT INTO "voyages" VALUES (1070, '', 1, '', 'DAMIATE', 'Kornelis Muts', 750, 'jacht', '1667', NULL, NULL, 'A', 'A', '1667-10-02', 'Texel', '1668-02-11', '1668-04-10', true, '1668-06-13', 'Batavia', 5600, 'Via Torbay, where 5 seafarers deserted.');
INSERT INTO "voyages" VALUES (1071, '', 1, '', 'DUINVLIET', 'Douwe Harkes', 500, 'fluit', '1667', NULL, NULL, 'A', 'A', '1667-10-02', 'Texel', '1668-02-05', '1668-02-29', true, '1668-05-14', 'Batavia', NULL, 'Via Maio I. Among the men who came on board at the Cape 2 seafarers and 25 soldiers were from the DAMIATE (1070).');
INSERT INTO "voyages" VALUES (1072, '', 2, 'a', 'ELBURG', 'Kornelis Kraker', 360, 'fluit', '1657', NULL, NULL, 'A', 'E', '1667-10-02', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ship was driven out of its course and landed in the West Indies. Via Fayal (Madeira). It returned in May 1668. See also 1102.');
INSERT INTO "voyages" VALUES (1073, '', 1, '', 'OOSTENBURG', 'Pieter Jonassen', 840, 'pinas? fluit?', '1667', NULL, NULL, 'A', 'A', '1667-10-02', 'Texel', '1668-03-22', '1668-04-10', true, '1668-06-13', 'Batavia', 5580, 'Via England, S. Vincente and Maio I.');
INSERT INTO "voyages" VALUES (1074, '', 1, '', 'WAPEN VAN ROTTERDAM', 'Gert Lambert Bastiaansz.', 1124, NULL, '1666', NULL, NULL, 'R', 'R', '1667-10-05', 'Goeree', '1668-02-09', '1668-04-10', true, '1668-06-09', 'Batavia', 5573, 'One soldier was sent home.');
INSERT INTO "voyages" VALUES (1075, '', 1, '', 'HUIS TE VELSEN', 'Pieter Jansz. Postmuis', 750, NULL, '1667', NULL, NULL, 'A', 'A', '1667-10-23', 'Texel', '1668-03-18', '1668-04-19', true, '1668-07-26', 'Batavia', 5575, 'A conspiracy was discovered aboard and the instigators were punished at the Cape.');
INSERT INTO "voyages" VALUES (1076, '', 1, '', 'KOKMEEUW', NULL, 90, 'hoeker', '1667', NULL, NULL, 'R', 'R', '1667-11-16', 'Maas', '1668-02-22', '1668-04-27', true, '1668-07-14', 'Colombo', 5648, NULL);
INSERT INTO "voyages" VALUES (1077, '', 1, '', 'VLIEGENDE ZWAAN', 'Boudewijn Lukasz. van de Lek', 100, 'bootje? fluit?', NULL, '1667', NULL, 'D', 'D', '1667-11-17', 'Maas', '1668-02-22', '1668-04-25', true, '1668-07-02', 'Batavia', NULL, 'The ship was laid up at Batavia on 03-09-1680.');
INSERT INTO "voyages" VALUES (1078, '', 1, '', 'WILTENBURG', 'Jan Jaspersz.', 120, 'jachtje', '1667', NULL, NULL, 'A', 'A', '1667-11-21', 'Texel', '1668-03-01', '1668-04-25', true, '1668-07-14', 'Batavia', NULL, 'The ship was laid up on 30-04-1677, and sold at Batavia on 07-05-1677.');
INSERT INTO "voyages" VALUES (1079, '', 1, '', 'ROTGANS', NULL, 90, 'hoeker', '1667', NULL, NULL, 'R', 'R', '1667-12-03', 'Maas', '1668-04-10', '1668-04-27', true, '1668-07-12', 'Colombo', NULL, 'Second departure from the Maas on 16-12-1667.');
INSERT INTO "voyages" VALUES (1080, '', 1, '', 'VREDENBURG', NULL, 160, 'fluit', NULL, '1666/7', NULL, 'A', 'A', '1667-12-13', 'Texel', '1668-04-06', '1668-04-27', true, '1668-07-09', 'Colombo', NULL, 'The ship was burnt and wrecked at Poulo Timaon on 07-06-1670.');
INSERT INTO "voyages" VALUES (1081, '', 1, '', 'VRIJE ZEE', 'Bartholomeus Jakobsz. van der Zwaan van Delft', 846, 'pinas', '1667', NULL, NULL, 'D', 'D', '1667-12-13', 'Goeree', '1668-04-07', '1668-04-19', true, '1668-07-18', 'Batavia', 5576, NULL);
INSERT INTO "voyages" VALUES (1082, '', 1, '', 'GEIT', NULL, 160, 'jachtje', '1667', NULL, NULL, 'A', 'A', '1667-12-19', 'Texel', '1668-04-14', '1668-04-25', true, '1668-07-14', 'Batavia', NULL, 'The ship was wrecked near Macassar on 04-08-1668.');
INSERT INTO "voyages" VALUES (1083, '', 1, '', 'PAPENBURG', NULL, 500, 'fluit', '1667', NULL, NULL, 'A', 'A', '1667-12-19', 'Texel', '1668-04-07', '1668-04-19', true, '1668-07-04', 'Batavia', 5589, NULL);
INSERT INTO "voyages" VALUES (1084, '', 1, '', 'VOORZICHTIGHEID', 'Kris Jansz. Eikenboom', 636, 'fluit', '1667', NULL, NULL, 'H', 'H', '1667-12-20', 'Texel', '1668-04-17', '1668-04-29', true, '1668-07-16', 'Batavia', 5583, '06-12-1667.');
INSERT INTO "voyages" VALUES (1085, '', 1, '', 'BOK', 'Klaas Harmanse', 160, 'jachtje', '1667', NULL, NULL, 'A', 'A', '1667-12-22', 'Texel', '1668-04-11', '1668-04-23', true, '1668-07-04', 'Batavia', NULL, 'Laid up at Batavia on 16-06-1676.');
INSERT INTO "voyages" VALUES (1086, '', 1, '', 'SCHOLLEVAAR', NULL, 90, 'hoeker', '1667', NULL, NULL, 'R', 'R', '1667-12-24', 'Maas', NULL, NULL, true, NULL, NULL, NULL, 'the coast of Africa about 9 miles north of the Cape on 31-05-1668. Two men were drowned; one of them was the master.');
INSERT INTO "voyages" VALUES (1087, '', 1, '', 'WAPEN VAN VLISSINGEN', 'Jakob Dirksen', 725, 'jacht', '1667', NULL, NULL, 'Z', 'Z', '1667-12-26', 'Wielingen', '1668-03-25', '1668-04-19', true, '1668-07-04', 'Batavia', 5603, NULL);
INSERT INTO "voyages" VALUES (1088, '', 1, '', 'HOF VAN BREDA', 'Jakob Jansz. Jongegeus', 670, 'jacht', '1667', NULL, NULL, 'A', 'A', '1667-12-27', 'Texel', '1668-06-16', '1668-07-02', true, '1668-09-15', 'Batavia', 5618, 'Via Portland, Wight (7 seafarers and 1 soldier deserted) and Cape Verde (15 till 27-03-1668). The ship brought commandeur Jakob Borghorst to the Cape.');
INSERT INTO "voyages" VALUES (1089, '', 1, '', 'DELFLAND', NULL, 905, NULL, NULL, '1666', NULL, 'Z', 'Z', '1668-01-29', NULL, NULL, NULL, true, NULL, NULL, NULL, 'Ran ashore at Boulogne on 14-02-1668.');
INSERT INTO "voyages" VALUES (1090, '', 1, '', 'LEPELAAR', 'Kornelis Kornelisz. Blankeroot', 90, 'hoeker', '1667', NULL, NULL, 'R', 'R', '1668-03-21', 'Maas', '1668-07-16', '1668-07-24', true, '1668-10-12', 'Batavia', NULL, 'Captured at the Cape by part of its own crew, 23-06-1669; the ship sailed to Pernambuco and was taken by the Portuguese.');
INSERT INTO "voyages" VALUES (1091, '', 1, '', 'PAPEGAAI', 'Eduard Roelofsz. Goudsmit', 160, 'jachtje', '1667', NULL, NULL, 'D', 'D', '1668-03-21', 'Maas', '1668-07-22', '1668-08-30', true, '1668-10-12', 'Batavia', NULL, 'Sold at Batavia on 06-08-1676.');
INSERT INTO "voyages" VALUES (1092, '', 1, '', 'IJSVOGEL', 'Theunisz. van der Burg van Delfshaven', 90, 'hoeker', '1667', NULL, NULL, 'D', 'D', '1668-03-21', 'Maas', '1668-07-21', '1668-08-21', true, '1669-01-20', 'Colombo', NULL, 'Via Madagascar. Laid up at Ceylon in 1679.');
INSERT INTO "voyages" VALUES (1093, '', 1, '', 'WAPEN VAN VEERE', 'Jan Bartelsz.', 627, 'fluit', '1667', NULL, NULL, 'Z', 'Z', '1668-03-27', 'Wielingen', '1668-07-17', '1668-07-24', true, '1668-10-07', 'Batavia', 5574, NULL);
INSERT INTO "voyages" VALUES (1094, '', 1, '', 'STICHT VAN UTRECHT', 'Jakob Fransz. Hinlopen', 990, NULL, '1667', NULL, NULL, 'A', 'A', '1668-04-08', 'Texel', '1668-08-24', '1668-09-03', true, '1668-11-27', 'Batavia', 5582, NULL);
INSERT INTO "voyages" VALUES (1095, '', 2, '', 'SPARENDAM', 'Dominicus Greie', 700, 'fluit', '1662', NULL, NULL, 'A', 'A', '1668-04-11', 'Texel', '1668-08-24', '1668-09-02', true, '1668-12-26', 'Colombo', 5585, NULL);
INSERT INTO "voyages" VALUES (1096, '', 2, '', 'ZUIDPOLSBROEK', 'Jan Zwart', 960, NULL, '1664', NULL, NULL, 'A', 'A', '1668-04-12', 'Texel', '1668-07-27', '1668-08-08', true, '1668-10-07', 'Batavia', 5578, 'According to Raven Hart, vol. 1 the ship arrived at the Cape on 23-07-1668 and left on 11-08-1668.');
INSERT INTO "voyages" VALUES (1097, '', 2, '', 'MIDDELBURG', 'Martinus Caesar', 846, NULL, '1664', NULL, NULL, 'Z', 'Z', '1668-04-28', 'Wielingen', '1668-08-29', '1668-09-12', true, '1668-11-30', 'Batavia', 5581, NULL);
INSERT INTO "voyages" VALUES (1098, '', 1, '', 'GEKROONDE VREDE', NULL, 730, NULL, '1667', NULL, NULL, 'E', 'E', '1668-05-02', 'Texel', '1668-09-28', '1668-10-07', true, '1669-01-05', 'Batavia', 5604, NULL);
INSERT INTO "voyages" VALUES (1099, '', 1, '', 'BEEMSTER', 'Jan Barendsz.', 514, 'fluit', '1667', NULL, NULL, 'A', 'A', '1668-05-09', 'Texel', '1668-09-12', '1668-09-18', true, '1668-12-29', 'Colombo', 5605, NULL);
INSERT INTO "voyages" VALUES (1100, '', 2, '', 'HAZENBURG', NULL, 636, 'fluit', '1663', NULL, NULL, 'Z', 'H', '1668-05-17', 'Texel', '1668-09-14', '1668-09-27', true, '1668-12-07', 'Batavia', 5588, NULL);
INSERT INTO "voyages" VALUES (1101, '', 6, '', 'AMERSFOORT', NULL, 1000, NULL, '1655', NULL, NULL, 'A', 'A', '1668-06-01', 'Texel', '1668-10-26', '1668-11-05', true, '1669-01-31', 'Batavia', 5590, NULL);
INSERT INTO "voyages" VALUES (1102, '', 2, 'b', 'ELBURG', 'Kornelis Kraker', 360, 'fluit', '1657', NULL, NULL, 'A', 'E', '1668-06-20', 'Texel', '1668-11-29', '1668-12-08', true, '1669-02-26', 'Batavia', NULL, 'See also 1072. Acc to K.A. 3981 the ship left the Cape on 13-08-1668. Laid up and sold at Batavia in 1675.');
INSERT INTO "voyages" VALUES (1103, '', 1, '', 'PUTTOOR', NULL, 90, 'hoeker', '1667', NULL, NULL, 'R', 'R', '1668-06-26', 'Maas', '1668-11-24', '1668-11-29', true, '1669-02-13', 'Batavia', NULL, 'One man was thrown overboard. The ship was laid up at Ceylon in 1675.');
INSERT INTO "voyages" VALUES (1104, '', 2, '', 'EENDRACHT', 'Jan Pietersz. de Vrije', 670, NULL, '1663', NULL, NULL, 'D', 'R', '1668-07-29', 'Goeree', '1668-12-03', '1668-12-08', true, '1669-02-17', 'Batavia', 5601, 'Via S. Tiago (Aug. 1668). 
Acc. to K.A. 3981 the ship left the Cape on 13-08-1668.');
INSERT INTO "voyages" VALUES (1105, '', 1, '', 'BURCHT VAN LEIDEN', 'Simon Kornelisz. van der Meer', 1040, NULL, '1667', NULL, NULL, 'A', 'A', '1668-07-29', 'Texel', '1668-11-28', '1668-12-08', true, '1669-02-18', 'Batavia', 5593, 'Acc. to K.A. 3981 the ship left the Cape on 13-08-1668.');
INSERT INTO "voyages" VALUES (1106, '', 2, '', 'KASTEEL VAN MEDEMBLIK', 'Gerbrand den Bok', 696, NULL, '1664', NULL, NULL, 'E', 'E', '1668-07-29', 'Texel', '1668-12-07', '1668-12-14', true, '1669-04-02', 'Batavia', 5594, 'The ship lost its masts in a storm at 17''C. and 107''E.');
INSERT INTO "voyages" VALUES (1107, '', 1, '', 'GOOILAND', 'Kornelis de Vos', 468, 'fluit', '1668', NULL, NULL, 'A', 'A', '1668-08-02', 'Texel', '1669-01-19', '1669-01-22', true, '1669-04-11', 'Batavia', 5640, 'Via Annabon.');
INSERT INTO "voyages" VALUES (1108, '', 1, '', 'DOLFIJN', 'Jan Theunisz. Krats+', 90, 'hoeker? bootje?', '1668', NULL, NULL, 'R', 'R', '1668-09-02', 'Maas', '1669-01-18', '1669-01-22', true, '1669-05-18', 'Batavia', 5637, 'Acc. to K.A. 3981 the ship departed on 02-10-1668. Via S. Vincente. Klaas Dirksz. van Kopperhoorn became master on 01-12-1668, after the Cape Jan Jansz. Oosterwijk succeeded him.');
INSERT INTO "voyages" VALUES (1109, '', 1, '', 'TULPENBURG', 'Pieter Jansz. de Vlieg', 750, 'jacht', '1668', NULL, NULL, 'A', 'A', '1668-09-15', 'Texel', '1669-01-16', '1669-01-22', true, '1669-04-11', 'Batavia', 5602, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1110, '', 1, '', 'WAPEN VAN ARNEMUIDEN', NULL, 100, 'jacht', '1668', NULL, NULL, 'Z', 'Z', '1668-09-23', 'Wielingen', '1669-01-14', '1669-01-22', true, '1669-04-28', 'Batavia', NULL, 'Via S. Vincente. The hull of this ship was used at Onrust in 1675.');
INSERT INTO "voyages" VALUES (1111, '', 2, '', 'WAPEN VAN MIDDELBURG', NULL, 676, NULL, '1666', NULL, NULL, 'Z', 'Z', '1668-09-23', 'Wielingen', '1669-01-24', '1669-02-03', true, '1669-04-12', 'Batavia', 5595, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1112, '', 1, '', 'WAPEN VAN ZIERIKZEE', 'Lieven Kakelaar', 1094, NULL, '1667', NULL, NULL, 'Z', 'Z', '1668-09-23', 'Wielingen', '1669-02-06', '1669-02-18', true, '1669-05-21', 'Batavia', 5599, 'Via `Salt Islands'' (= Cape Verde Islands).');
INSERT INTO "voyages" VALUES (1113, '', 2, '', 'KATTENBURG', 'Ouwel Jansen', 637, 'fluit', '1663', NULL, NULL, 'A', 'A', '1668-11-13', 'Texel', '1669-04-11', '1669-04-27', true, '1669-07-05', 'Batavia', 5622, 'Acc. to Daghregister 1668/9 the ship departed from Texel on 13-12-1668. Via Duins, 19-12 till 04-01-1669.');
INSERT INTO "voyages" VALUES (1114, '', 2, '', 'HOLLANDSE TUIN', 'Jakob Jansz. Poort', 1210, NULL, '1665', NULL, NULL, 'A', 'A', '1668-11-13', 'Texel', '1669-03-06', '1669-03-24', true, '1669-06-18', 'Batavia', 5598, 'Via Wight.');
INSERT INTO "voyages" VALUES (1115, '', 3, '', 'WAPEN VAN HOORN', NULL, 756, 'fluit? jacht?', '1662', NULL, NULL, 'H', 'A', '1668-11-16', 'Texel', '1669-03-06', '1669-03-15', true, '1669-05-28', 'Gale', 5612, NULL);
INSERT INTO "voyages" VALUES (1116, '', 4, '', 'WASSENDE MAAN', NULL, 480, 'jacht', NULL, '1660/1', NULL, 'A', 'A', '1668-11-16', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Second departure from Goeree on 07-03-1669, but the ship returned because of serious leakage and was laid up.');
INSERT INTO "voyages" VALUES (1117, '', 1, '', 'DELFSHAVEN', 'Michiel Jansz. Nieuwenhuize+', 654, 'fluit', '1668', NULL, NULL, 'D', 'D', '1668-12-03', 'Goeree', '1669-04-18', '1669-04-27', true, '1669-07-01', 'Batavia', 5591, 'The ship was attacked by a Turkish ship at 36''N.; 8 men were killed and 31 wounded. The master was among the deaths. He was succeeded by Kornelis de Jonge.');
INSERT INTO "voyages" VALUES (1118, '', 1, '', 'GRUNDEL', 'Gerrit Gerrritsz. Riddermuis', 90, 'hoeker', '1668', NULL, NULL, 'D', 'D', '1668-12-03', 'Maas', '1669-04-25', '1669-05-23', true, '1669-08-04', 'Batavia', NULL, 'The ship was wrecked east of Cape `Hangklip'', at the East African coast on 20-02-1673.');
INSERT INTO "voyages" VALUES (1119, '', 2, '', 'OUDSHOORN', NULL, 666, 'jacht? pinas?', '1663', NULL, NULL, 'A', 'Z', '1668-12-03', 'Wielingen', '1669-05-15', '1669-05-30', true, '1669-08-25', 'Colombo', 5606, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (1120, '', 1, '', 'BARM', 'Walter Koulster', 90, 'hoeker', '1668', NULL, NULL, 'R', 'R', '1668-12-04', 'Maas', '1669-04-03', '1669-04-15', true, '1669-06-30', 'Batavia', NULL, 'Laid up at Ceylon in 1679.');
INSERT INTO "voyages" VALUES (1121, '', 1, '', 'WIJTING', 'Simon Kroon', 90, 'hoeker', '1668', NULL, NULL, 'D', 'D', '1668-12-07', 'Maas', '1669-04-02', '1669-04-15', true, '1669-06-19', 'Batavia', NULL, 'Via Duins, 19-12 till 04-01-1669. Laid up at Ceylon in 1679.');
INSERT INTO "voyages" VALUES (1122, '', 2, '', 'AMERONGEN', 'Hendrik Pietersz. Mol', 452, 'jacht', '1662', NULL, NULL, 'A', 'A', '1668-12-13', 'Texel', '1669-04-13', '1669-04-27', true, '1669-07-02', 'Batavia', NULL, 'Laid up and sold in 1675.');
INSERT INTO "voyages" VALUES (1123, '', 3, '', 'SPREEUW', 'Dirk van Duinen', 374, 'fluit', '1657', NULL, NULL, 'Z', 'R', '1668-12-13', 'Maas', '1669-07-31', '1669-08-12', true, '1669-10-18', 'Batavia', NULL, 'sold in 1675.');
INSERT INTO "voyages" VALUES (1124, '', 1, '', 'TERNATE', NULL, 1014, 'pinas', '1668', NULL, NULL, 'A', 'A', '1668-12-13', 'Texel', '1669-04-11', '1669-04-27', true, '1669-07-05', 'Batavia', 5597, 'till 26-01-1669.');
INSERT INTO "voyages" VALUES (1125, '', 2, '', 'ALPHEN', 'Abraham Huibrechtsen', 700, 'fluit', '1662', NULL, NULL, 'A', 'Z', '1668-12-14', 'Wielingen', '1669-05-18', '1669-06-02', true, '1669-08-10', 'Batavia', 5642, 'Vincente.');
INSERT INTO "voyages" VALUES (1126, '', 3, '', 'LOOSDUINEN', NULL, 340, 'fluit', NULL, NULL, NULL, 'A', 'Z', '1668-12-14', 'Wielingen', '1669-04-26', '1669-05-12', true, '1669-07-17', 'Batavia', NULL, 'fl. 204,000 was mainly lost.');
INSERT INTO "voyages" VALUES (1127, '', 4, '', 'JONGE PRINS', 'J. Haan', 840, 'jacht', '1661', NULL, NULL, 'H', 'H', '1668-12-14', 'Texel', '1669-04-03', '1669-04-15', true, '1669-06-28', 'Batavia', 5596, 'Via Duins, till 04-01-1669.');
INSERT INTO "voyages" VALUES (1128, '', 2, '', 'VLAARDINGEN', NULL, 400, 'jacht? pinas?', '1661?', NULL, NULL, 'D', 'E', '1669-01-05', 'Texel', '1669-04-02', '1669-04-15', true, '1669-06-26', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1129, '', 1, '', 'BAARS', NULL, 90, 'hoeker', '1668', NULL, NULL, 'R', 'R', '1669-01-11', 'Texel', '1669-04-25', '1669-05-11', true, '1669-07-09', 'Batavia', 5650, NULL);
INSERT INTO "voyages" VALUES (1130, '', 1, '', 'ZEELT', 'Theunis Gijsbertsz.', 90, 'hoeker', '1668', NULL, NULL, 'R', 'R', '1669-01-11', 'Maas', '1669-05-15', '1669-05-23', true, '1669-08-09', 'Batavia', NULL, 'missing after departure from the Cape in 1672.');
INSERT INTO "voyages" VALUES (1131, '', 1, '', 'WAPEN VAN GOES', 'Leendert Leendertsz.', 671, NULL, '1668', NULL, NULL, 'Z', 'Z', '1669-01-16', 'Wielingen', '1669-04-25', '1669-05-11', true, '1669-07-13', 'Batavia', 5592, '20-02-1669. After departure from the Cape Kornelis Kornelisz. Blankeroot became master.');
INSERT INTO "voyages" VALUES (1132, '', 1, '', 'POLANEN', NULL, 670, NULL, '1668', NULL, NULL, 'A', 'A', '1669-04-21', 'Texel', '1669-09-19', '1669-09-30', true, '1669-12-28', 'Ceylon', NULL, 'Wrecked at Tuticorin on 29-04-1670.');
INSERT INTO "voyages" VALUES (1133, '', 1, '', 'OSDORP', NULL, 448, 'fluit', '1668', NULL, NULL, 'A', 'A', '1669-04-30', 'Texel', '1669-09-02', '1669-09-14', true, '1669-11-28', 'Batavia', 5607, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1134, '', 1, '', 'UITDAM', NULL, 448, 'fluit', '1668', NULL, NULL, 'A', 'A', '1669-04-30', 'Texel', '1669-09-19', '1669-09-30', true, '1669-12-14', 'Batavia', 5608, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1135, '', 2, '', 'VRIJHEID', NULL, 1210, NULL, '1666', NULL, NULL, 'A', 'A', '1669-04-30', 'Texel', '1669-08-25', '1669-09-07', true, '1669-11-15', 'Batavia', 5620, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1136, '', 6, '', 'DORDRECHT', 'Willem Jaspersz. van Teilinge van Delfshaven', 920, 'fregat', '1652', NULL, NULL, 'D', 'D', '1669-05-04', 'Goeree', '1669-08-12', '1669-08-23', true, '1669-10-11', 'Batavia', 5609, NULL);
INSERT INTO "voyages" VALUES (1137, '', 1, '', 'VOORN', NULL, 90, 'hoeker', '1668', NULL, NULL, 'R', 'R', '1669-05-18', 'Maas', '1669-09-16', '1669-10-18', true, '1670-01-19', 'Batavia', NULL, 'Via S. Vincente. One man fell overboard. The ship was broken up at Bengal in 1675.');
INSERT INTO "voyages" VALUES (1138, '', 1, '', 'KOREA', NULL, 182, 'jachtje', '1668', NULL, NULL, 'Z', 'Z', '1669-05-20', 'Wielingen', '1669-12-10', '1670-01-06', true, '1670-04-02', 'Batavia', NULL, 'Via Cape Lopez and Annabon. Laid up at Batavia on 15-11-1679.');
INSERT INTO "voyages" VALUES (1139, '', 1, '', 'HENGELAAR', 'IJsbrand Harkesz.', 90, 'hoeker', '1668', NULL, NULL, 'E', 'E', '1669-06-25', 'Texel', '1669-11-10', '1669-11-20', true, '1670-02-22', 'Batavia', NULL, 'The ship was laid up and sold at Batavia on 07-05-1677.');
INSERT INTO "voyages" VALUES (1140, '', 1, '', 'HUIS TE NOORDWIJK', 'Kornelis Jansz. de Zeeuw', 506, 'jacht', '1668', NULL, NULL, 'E', 'E', '1669-06-25', 'Texel', '1669-11-05', '1669-11-20', true, '1670-02-28', 'Batavia', NULL, 'The ship was wrecked at the Damar Islands on 24-01-1683.');
INSERT INTO "voyages" VALUES (1141, '', 1, '', 'PRINS WILLEM HENDRIK', NULL, 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1669-07-08', 'Wielingen', '1669-11-06', '1669-11-20', true, '1670-02-03', 'Batavia', 5615, NULL);
INSERT INTO "voyages" VALUES (1142, '', 1, '', 'SCHERMER', 'Hans Zwart', 636, 'fluit', '1668', NULL, NULL, 'H', 'A', '1669-07-30', 'Texel', '1669-11-20', '1669-12-03', true, '1670-03-14', 'Batavia', NULL, 'The ship was wrecked in Banka Strait on 04-06-1671.');
INSERT INTO "voyages" VALUES (1143, '', 1, '', 'POULERON', NULL, 638, 'jacht', '1669', NULL, NULL, 'Z', 'Z', '1669-08-11', 'Wielingen', '1669-12-17', '1670-01-06', true, '1670-03-28', 'Batavia', 5717, NULL);
INSERT INTO "voyages" VALUES (1144, '', 1, '', 'BONTEKRAAI', 'Lambert Colet', 90, 'hoeker', '1669', NULL, NULL, 'R', 'R', '1669-09-04', 'Maas', '1670-01-18', '1670-01-27', true, '1670-05-07', 'Batavia', NULL, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1145, '', 1, '', 'MOLENAAR', 'Kornelis de Gilde van Schiedam', 90, 'hoeker', '1669', NULL, NULL, 'D', 'D', '1669-09-06', 'Maas', '1670-01-25', '1670-02-03', true, '1670-06-13', 'Batavia', NULL, 'The ship was met in the Channel by two Turkish privateers, but escaped. Via S. Tiago. The ship was wrecked at Tuticorin on 22-02-1682.');
INSERT INTO "voyages" VALUES (1146, '', 2, '', 'WAPEN VAN VEERE', 'Jan Bartelsz.', 627, 'fluit', '1667', NULL, NULL, 'Z', 'Z', '1669-09-21', 'Wielingen', '1670-01-10', '1670-01-18', true, '1670-04-24', 'Batavia', 5619, 'According to Daghregister 1670 the ship departed from the Wielingen on 02-09-1669.');
INSERT INTO "voyages" VALUES (1147, '', 1, '', 'SPANBROEK', NULL, 448, 'fluit', '1669', NULL, NULL, 'A', 'A', '1669-10-13', 'Texel', '1670-03-11', '1670-03-26', true, '1670-06-15', 'Tuticorin', 5624, 'The ship stayed from 28-10 till 03-11-1669 in Texel. At Colombo: 13-07-1670.');
INSERT INTO "voyages" VALUES (1148, '', 1, '', 'WIMMENUM', NULL, 448, 'fluit', '1669', NULL, NULL, 'A', 'A', '1669-10-13', 'Texel', '1670-03-15', '1670-03-25', true, '1670-06-21', 'Batavia', 5626, NULL);
INSERT INTO "voyages" VALUES (1149, '', 1, '', 'ZWAARDVIS', 'Jakob van Ganswijk', 90, 'hoeker', '1669', NULL, NULL, 'R', 'R', '1669-11-03', 'Maas', '1670-04-22', '1670-05-03', true, '1670-07-19', 'Batavia', NULL, '12-09-1680.');
INSERT INTO "voyages" VALUES (1150, '', 2, '', 'BATAVIA', NULL, 756, 'pinas? jacht?', NULL, '1666', NULL, NULL, 'E', '1669-12-07', 'Texel', '1670-03-30', '1670-04-11', true, '1670-06-21', 'Batavia', NULL, 'The ship was laid up and sold at Batavia on 31-08-1678.');
INSERT INTO "voyages" VALUES (1151, '', 2, '', 'WAPEN VAN GOUDA', 'Harmen Gerritsz. van Haren', 708, NULL, NULL, '1666/7', NULL, 'A', 'A', '1669-12-07', 'Texel', '1670-04-01', '1670-04-11', true, '1670-06-21', 'Batavia', 5611, 'According to Daghregister 1670 the ship departed from Texel on 17-12-1669. Via the Cape Verde Islands.');
INSERT INTO "voyages" VALUES (1152, '', 3, '', 'KOGGE', 'Daniel Kok', 400, 'jacht', NULL, '1662', NULL, 'H', 'A', '1669-12-07', 'Texel', '1670-03-08', '1670-03-25', true, '1670-06-14', 'Batavia', NULL, 'The ship was laid up and sold at Batavia in 1675.');
INSERT INTO "voyages" VALUES (1153, '', 2, '', 'STICHT VAN UTRECHT', NULL, 990, NULL, '1667', NULL, NULL, 'A', 'A', '1669-12-07', 'Texel', '1670-03-18', '1670-04-01', true, '1670-06-20', 'Batavia', 5614, 'The ship brought commandeur Pieter Hakius to the Cape.');
INSERT INTO "voyages" VALUES (1154, '', 2, '', 'HUIS TE VELSEN', NULL, 750, NULL, '1667', NULL, NULL, 'A', 'A', '1669-12-07', 'Texel', '1670-03-21', '1670-04-01', true, '1670-06-22', 'Ceylon', 5617, NULL);
INSERT INTO "voyages" VALUES (1155, '', 1, '', 'VLIEGER', 'Jan Sandersz. Zorg', 90, 'hoeker', '1669', NULL, NULL, 'D', 'D', '1669-12-07', 'Maas', '1670-04-22', '1670-04-30', true, '1670-07-12', 'Batavia', NULL, 'The ship was laid up at Ceylon in 1679.');
INSERT INTO "voyages" VALUES (1156, '', 1, '', 'ZWEMMER', 'Jan Andriesz. Koning van Delfshaven', 90, 'hoeker', '1669', NULL, NULL, 'D', 'D', '1669-12-07', 'Maas', '1670-03-20', '1670-03-25', true, '1670-06-12', 'Batavia', 5659, NULL);
INSERT INTO "voyages" VALUES (1157, '', 3, '', 'MIDDELBURG', 'Pieter Koker', 846, NULL, '1664', NULL, NULL, 'Z', 'Z', '1669-12-08', 'Wielingen', '1670-03-31', '1670-04-21', true, '1670-06-20', 'Batavia', 5613, NULL);
INSERT INTO "voyages" VALUES (1158, '', 1, '', 'ZOETENDAAL', 'Jan van der Putten', 448, 'fluit', '1669', NULL, NULL, 'Z', 'Z', '1669-12-08', 'Wielingen', '1670-03-21', '1670-04-01', true, '1670-06-22', 'Tuticorin', 5623, NULL);
INSERT INTO "voyages" VALUES (1159, '', 2, '', 'VOORZICHTIGHEID', 'Pieter Otsen', 636, 'fluit', '1667', NULL, NULL, 'H', 'H', '1669-12-22', 'Texel', '1670-04-20', '1670-05-03', true, '1670-07-17', 'Batavia', 5634, NULL);
INSERT INTO "voyages" VALUES (1160, '', 2, '', 'VRIJE ZEE', 'IJsbrant Michielsz. Taaienhals van Delfshaven', 846, 'pinas', '1667', NULL, NULL, 'D', 'D', '1669-12-22', 'Goeree', '1670-04-04', '1670-04-21', true, '1670-06-30', 'Batavia', 5616, NULL);
INSERT INTO "voyages" VALUES (1161, '', 2, '', 'OOSTENBURG', 'Klaas de Rood', 840, 'pinas? fluit?', '1667', NULL, NULL, 'A', 'A', '1670-04-26', 'Texel', '1670-08-15', '1670-08-28', true, '1670-10-27', 'Batavia', 5630, NULL);
INSERT INTO "voyages" VALUES (1162, '', 1, '', 'SAKSENBURG', NULL, 450, 'fluit', '1669', NULL, NULL, 'A', 'A', '1670-04-26', 'Texel', '1670-09-14', '1670-09-25', true, '1670-12-09', 'Batavia', 5625, 'Second departure from Texel on 17-05-1670.');
INSERT INTO "voyages" VALUES (1163, '', 3, '', 'ZUIDPOLSBROEK', 'Hendrik Bonmeyer', 960, NULL, '1664', NULL, NULL, 'A', 'A', '1670-04-26', 'Texel', NULL, NULL, false, '1670-11-02', 'Batavia', 5621, 'No call at the Cape because of a storm.');
INSERT INTO "voyages" VALUES (1164, '', 2, '', 'WAPEN VAN ROTTERDAM', 'Jan Thomas van der Pot', 1124, NULL, '1666', NULL, NULL, 'R', 'R', '1670-04-30', 'Goeree', '1670-08-15', '1670-08-28', true, '1670-10-27', 'Batavia', 5631, NULL);
INSERT INTO "voyages" VALUES (1165, '', 3, '', 'RIJZENDE ZON', 'Krijn Kant', 600, 'jacht', NULL, '1660/1', NULL, 'Z', 'A', '1670-05-03', 'Wielingen', '1670-08-15', '1670-08-28', true, '1670-10-27', 'Batavia', NULL, 'sold at Batavia in 1675.');
INSERT INTO "voyages" VALUES (1166, '', 3, '', 'HAZENBURG', NULL, 636, 'fluit', '1663', NULL, NULL, 'Z', 'Z', '1670-06-13', 'Wielingen', '1670-10-18', '1670-10-29', true, '1670-12-31', 'Batavia', NULL, 'The ship was sold at Batavia in December 1680.');
INSERT INTO "voyages" VALUES (1167, '', 2, '', 'PAPENBURG', NULL, 500, 'fluit', '1667', NULL, NULL, 'A', 'A', '1670-07-06', 'Texel', '1670-10-22', '1670-10-30', true, '1670-12-28', 'Batavia', 5644, NULL);
INSERT INTO "voyages" VALUES (1168, '', 3, '', 'BREDERODE', NULL, 666, 'fluit? jacht?', '1663', NULL, NULL, 'A', 'A', '1670-10-13', 'Texel', '1671-01-13', '1671-01-28', true, '1671-05-12', 'Tuticorin', NULL, 'Fleet (1168-1173) under command of Rijklof van Goens junior aboard the BREDERODE (1168). Via S. Vincente (4 or 5 days). 
Acc. to Daghregister 16716 died before the Cape. The ship was laid up at Batavia on 30-09-1678.');
INSERT INTO "voyages" VALUES (1169, '', 1, '', 'BUREN', 'Abraham Lems', 468, 'fluit', '1670', NULL, NULL, 'A', 'A', '1670-10-13', 'Texel', '1671-01-10', '1671-01-20', true, '1671-04-19', 'Batavia', 5653, 'Acc. to Uitloopboek 4389 the ship departed on 31-10-1670. Via S. Vincente 03 till 08-11-1670.');
INSERT INTO "voyages" VALUES (1170, '', 2, '', 'DAMIATE', 'Arend Simonsz. Vader', 750, 'jacht', '1667', NULL, NULL, 'A', 'A', '1670-10-13', 'Texel', '1671-03-02', '1671-03-18', true, '1671-06-10', 'Batavia', NULL, 'Acc. to Uitloopboek 4389 the ship departed on 31-10-1670. The ship ran ashore east of Madura Island on 31-08-1677; 18 men were drowned.');
INSERT INTO "voyages" VALUES (1171, '', 2, '', 'NUISSENBURG', 'Kornelis Temmink', 486, 'pinas? jacht?', NULL, '1664/5', NULL, 'A', 'A', '1670-10-13', 'Texel', '1671-01-10', '1671-01-20', true, '1671-03-23', 'Batavia', NULL, 'Acc. to Uitloopboek 4389 the ship departed on 31-10-1670. Via S. Vincente (03 till 08-11-1670). The ship was laid up and sold at Batavia on 31-01-1678.');
INSERT INTO "voyages" VALUES (1172, '', 3, '', 'SPARENDAM', 'Jan Frederiksz.', 700, 'fluit', '1662', NULL, NULL, 'A', 'A', '1670-10-13', 'Texel', '1671-03-04', '1671-03-14', true, '1671-06-05', 'Tuticorin', 5638, 'At Colombo on 04-07-1671.');
INSERT INTO "voyages" VALUES (1173, '', 2, '', 'TULPENBURG', 'Dirk van Rijn+', 750, 'jacht', '1668', NULL, NULL, 'A', 'A', '1670-10-13', 'Texel', '1671-01-10', '1671-01-20', true, '1671-03-23', 'Batavia', NULL, 'master died on 30-10-1670 and was succeeded by Klaas Pietersz. Sluiter. The ship was laid up and sold at Batavia, 01-03-1680.');
INSERT INTO "voyages" VALUES (1174, '', 1, '', 'STERMEER', 'Jakob Verhogen', 502, 'fluit', '1669', NULL, NULL, 'H', 'H', '1670-11-23', 'Texel', '1671-04-01', '1671-04-11', true, '1671-07-24', 'Batavia', 5646, 'Acc. to K.A. 3984 the ship departed on 23-12-1670. Via Duins. 
Acc. to Daghregister 1671 the ship arrived at the Cape on 05-03-1671.');
INSERT INTO "voyages" VALUES (1175, '', 2, '', 'WAPEN VAN VLISSINGEN', NULL, 725, 'jacht', '1667', NULL, NULL, 'Z', 'Z', '1670-11-23', 'Wielingen', NULL, NULL, true, NULL, NULL, NULL, 'The ship was wrecked on the Goodwin Sands on 26-11-1670.');
INSERT INTO "voyages" VALUES (1176, '', 2, '', 'GEKROONDE VREDE', 'Gerrit Klaas Posthoorn', 730, NULL, '1667', NULL, NULL, 'E', 'H', '1670-11-23', 'Texel', '1671-03-05', '1671-03-18', true, '1671-06-05', 'Batavia', 5635, 'One child was born during the voyage.');
INSERT INTO "voyages" VALUES (1177, '', 1, '', 'ZWANENBURG', NULL, 508, 'fluit', '1670', NULL, NULL, 'Z', 'Z', '1670-11-23', 'Wielingen', NULL, NULL, false, '1671-06-05', 'Tuticorin', 5639, NULL);
INSERT INTO "voyages" VALUES (1178, '', 2, '', 'DELFSHAVEN', 'Jan Hendriksz. Binder van Rotterdam', 654, 'fluit', '1668', NULL, NULL, 'D', 'D', '1670-12-09', 'Goeree', '1671-04-04', '1671-04-11', true, '1671-07-01', 'Batavia', 5627, NULL);
INSERT INTO "voyages" VALUES (1179, '', 1, '', 'PUNACKER', 'Jan Lambertsz. Radder van Rotterdam', 472, 'fluit', '1670', NULL, NULL, 'D', 'D', '1670-12-09', 'Maas', '1671-03-26', '1671-04-11', true, '1671-06-21', 'Batavia', 5645, NULL);
INSERT INTO "voyages" VALUES (1180, '', 1, '', 'GROOTEBROEK', 'Jurriaan Danielsz. Glasius', 464, 'fluit', '1670', NULL, NULL, 'E', 'E', '1671-01-08', 'Texel', '1671-05-19', '1671-06-02', true, '1671-08-08', 'Batavia', 5641, 'Via Falmouth, where 4 seafarers and 2 soldiers deserted and 1 seaman signed 
on. Acc. to Daghregister 1671 the ship left the Cape on 16-06-1671.');
INSERT INTO "voyages" VALUES (1181, '', 1, '', 'IJSSELSTEIN', 'Albert Kool', 468, 'fluit', '1670', NULL, NULL, 'A', 'A', '1671-01-08', 'Texel', '1671-05-25', NULL, true, '1671-07-28', 'Batavia', NULL, 'Via Falmouth, where 3 seafarers deserted, and via False Bay (arrival on 25-05-1671), where 1 seaman and 2 soldiers were left behind. The ship was laid up and gallows were erected on the deck. (1680).');
INSERT INTO "voyages" VALUES (1182, '', 3, '', 'KASTEEL VAN MEDEMBLIK', NULL, 696, NULL, '1664', NULL, NULL, 'E', 'E', '1671-01-08', 'Texel', '1671-05-07', '1671-05-17', true, '1671-07-24', 'Batavia', 5629, NULL);
INSERT INTO "voyages" VALUES (1183, '', 2, '', 'OSDORP', 'Pieter Dirksz. Haan', 448, 'fluit', '1668', NULL, NULL, 'A', 'A', '1671-01-08', 'Texel', '1671-04-23', '1671-05-01', true, '1671-07-01', 'Batavia', NULL, 'The ship was wrecked in the river Ganges on 05-12-1674');
INSERT INTO "voyages" VALUES (1184, '', 2, '', 'TERNATE', NULL, 1014, 'pinas', '1668', NULL, NULL, 'A', 'A', '1671-01-08', 'Texel', '1671-05-20', '1671-06-02', true, '1671-07-24', 'Batavia', 5632, 'Via Falmouth. From the men who went ashore at the Cape, 7 ran away.');
INSERT INTO "voyages" VALUES (1185, '', 2, '', 'UITDAM', 'Michiel Kornelisz.', 448, 'fluit', '1668', NULL, NULL, 'A', 'A', '1671-01-08', 'Texel', '1671-05-26', '1671-06-02', true, '1671-08-08', 'Batavia', NULL, 'Via Falmouth. The ship was wrecked at the island Fortuin near Sumatra in November 1677.');
INSERT INTO "voyages" VALUES (1186, '', 1, '', 'TIDORE', 'Adriaan Sleutel', 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1671-01-10', 'Wielingen', '1671-05-20', '1671-06-02', true, '1671-07-24', 'Batavia', 5633, 'Because of adverse winds via Duins (14-01 till 11-02-1671). Two children were born during the voyage.At the Cape 6 men ran away; 
acc. to Daghregister 1671 the ship left the Cape on 06-06-1671.');
INSERT INTO "voyages" VALUES (1187, '', 2, '', 'WAPEN VAN ZIERIKZEE', 'Engel Jansz.', 1094, NULL, '1667', NULL, NULL, 'Z', 'Z', '1671-01-10', 'Wielingen', '1671-05-24', '1671-06-02', true, '1671-07-26', 'Batavia', 5636, 'Via Duins, 15-01 till 11-02-1671.');
INSERT INTO "voyages" VALUES (1188, '', 1, '', 'GOUDVINK', 'Jan Kornelisz. Egmond', 90, 'hoeker', '1670', NULL, NULL, 'D', 'D', '1671-03-18', 'Maas', '1671-08-07', '1671-08-14', true, '1671-10-25', 'Batavia', NULL, 'Via Las Palmas, where one seaman stayed behind. The ship was sold at Batavia in 1687.');
INSERT INTO "voyages" VALUES (1189, '', 3, '', 'OUDSHOORN', 'Marinus Looisen', 666, 'jacht? pinas?', '1663', NULL, NULL, 'A', 'Z', '1671-03-30', 'Wielingen', '1671-07-07', '1671-07-19', true, '1671-09-22', 'Batavia', NULL, 'The ship was laid up and sold at Batavia on 01-02-1680.');
INSERT INTO "voyages" VALUES (1190, '', 3, '', 'EENDRACHT', 'Simon van der Meer', 670, NULL, '1663', NULL, NULL, 'D', 'R', '1671-04-18', 'Goeree', NULL, NULL, false, '1671-10-03', 'Batavia', 5660, NULL);
INSERT INTO "voyages" VALUES (1191, '', 1, '', 'LUSTER', NULL, 90, 'hoeker', '1670', NULL, NULL, 'R', 'R', '1671-04-18', 'Goeree', '1671-08-23', '1672-08-16', true, '1672-10-29', 'Batavia', NULL, 'The ship stayed almost a year at the Cape waiting for news about the possible outbreak of war with France. Finally the LUSTER brought the expected message to Batavia. Laid up at Batavia in 1690.');
INSERT INTO "voyages" VALUES (1192, '', 1, '', 'CULEMBORG', NULL, 468, 'fluit', '1670', NULL, NULL, 'A', 'A', '1671-04-22', 'Texel', '1671-08-05', '1671-08-14', true, '1671-10-25', 'Batavia', NULL, 'The ship was wrecked in a storm off Formosa on 02-08-1672.');
INSERT INTO "voyages" VALUES (1193, '', 2, '', 'WAPEN VAN GOES', NULL, 671, NULL, '1668', NULL, NULL, 'Z', 'Z', '1671-05-09', 'Wielingen', '1671-09-05', '1671-09-17', true, '1671-11-21', 'Batavia', 5628, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1194, '', 2, '', 'BURCHT VAN LEIDEN', NULL, 1040, NULL, '1667', NULL, NULL, 'A', 'A', '1671-05-09', 'Texel', '1671-09-16', '1671-10-01', true, '1671-12-14', 'Batavia', 5654, 'Acc. to K.A. 3984 the ship departed from Texel on 31-05-1671. Via S. Tiago.');
INSERT INTO "voyages" VALUES (1195, '', 3, '', 'WAPEN VAN MIDDELBURG', NULL, 676, NULL, '1666', NULL, NULL, 'Z', 'Z', '1671-05-09', 'Wielingen', '1671-09-16', '1671-10-01', true, '1671-12-25', 'Batavia', NULL, 'Via S. Tiago. Sold at Batavia on 06-01-1685.');
INSERT INTO "voyages" VALUES (1196, '', 1, '', 'PAGADET', NULL, 90, 'hoeker', '1670', NULL, NULL, 'R', 'R', '1671-05-17', 'Maas', '1671-10-01', '1671-10-07', true, '1671-12-19', 'Batavia', NULL, 'The ship ran ashore east of Madura Island on 31-08-1677');
INSERT INTO "voyages" VALUES (1197, '', 2, '', 'BEEMSTER', NULL, 514, 'fluit', '1667', NULL, NULL, 'A', 'A', '1671-06-21', 'Texel', '1671-10-28', '1671-11-09', true, '1672-01-17', 'Batavia', 5651, 'Via Gomera, where one seaman deserted and via S. Tiago.');
INSERT INTO "voyages" VALUES (1198, '', 7, '', 'AMERSFOORT', NULL, 1000, NULL, '1655', NULL, NULL, 'A', 'A', '1671-08-25', 'Texel', '1672-02-11', '1672-03-01', true, '1672-05-31', 'Gale', NULL, 'Acc. T o K.A. 1182 the numbers 1198, 1199, 1204, 1212, 1213 and 1218 brought together 553 seafarers and 254 soldiers to Ceylon. The ship was sold at Batavia on 25-10-1677.');
INSERT INTO "voyages" VALUES (1199, '', 3, '', 'WAPEN VAN GOUDA', NULL, 708, NULL, NULL, '1666/7', NULL, 'A', 'A', '1671-09-11', 'Texel', '1672-02-12', '1672-02-23', true, '1672-05-22', 'Tuticorin', NULL, 'Via Wight (29-09) and S. Tiago. See also 1198. The ship was laid up in 1679 and the hull was sold on 18-01-1680.');
INSERT INTO "voyages" VALUES (1200, '', 3, '', 'HOLLANDSE TUIN', 'Jakob Poort', 1210, NULL, '1665', NULL, NULL, 'A', 'A', '1671-10-11', 'Texel', '1672-02-14', '1672-02-23', true, '1672-05-20', 'Batavia', 5657, 'Three children were born during the voyage; acc. to Daghregister 1672 the ship left the Cape on 27-02-1672.');
INSERT INTO "voyages" VALUES (1201, '', 3, '', 'HUIS TE VELSEN', 'Sieuwert Roos', 750, NULL, '1667', NULL, NULL, 'A', 'A', '1671-10-11', 'Texel', '1672-02-14', '1672-03-02', true, '1672-05-23', 'Batavia', NULL, 'Via S. Tiago. On the return voyage in 1674 the ship carried French prisoners of war. The ship was restored to the Company on 21-04-1676.');
INSERT INTO "voyages" VALUES (1202, '', 1, '', 'MARKEN', NULL, 230, 'fluit', '1671', NULL, NULL, 'A', 'A', '1671-10-17', 'Texel', '1672-05-25', '1672-06-14', true, '1672-08-11', 'Batavia', NULL, 'Ascension and Corisco. The ship was laid up and sold at Batavia on 16-06-1685.');
INSERT INTO "voyages" VALUES (1203, '', 2, '', 'SPANBROEK', 'Vis', 448, 'fluit', '1669', NULL, NULL, 'A', 'A', '1671-10-17', 'Texel', '1672-02-11', '1672-02-23', true, '1672-05-26', 'Batavia', 5656, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1204, '', 3, '', 'WAPEN VAN VEERE', NULL, 627, 'fluit', '1667', NULL, NULL, 'Z', 'Z', '1671-10-17', 'Wielingen', '1672-02-12', '1672-02-23', true, '1672-06-03', 'Ceylon', 5647, 'See also 1198.');
INSERT INTO "voyages" VALUES (1205, '', 3, '', 'STICHT VAN UTRECHT', 'Leendert Haringman', 990, NULL, '1667', NULL, NULL, 'A', 'A', '1671-10-26', 'Texel', '1672-03-18', '1672-04-16', true, '1672-06-22', 'Batavia', 5664, NULL);
INSERT INTO "voyages" VALUES (1206, '', 7, '', 'DORDRECHT', NULL, 920, 'fregat', '1652', NULL, NULL, 'D', 'R', '1671-10-28', 'Goeree', '1672-02-11', '1672-02-23', true, '1672-05-26', 'Batavia', NULL, 'Batavia on 12-05-1681.');
INSERT INTO "voyages" VALUES (1207, '', 2, '', 'HOF VAN BREDA', 'Jan Kornelisz. Waterhaler', 670, 'jacht', '1667', NULL, NULL, 'A', 'E', '1671-11-11', 'Texel', '1672-03-07', '1672-03-30', true, '1672-06-23', 'Batavia', 5652, NULL);
INSERT INTO "voyages" VALUES (1208, '', 1, '', 'KRANESTEIN', 'Adam van Breen', 676, 'pinas', '1671', NULL, NULL, 'Z', 'Z', '1671-11-14', 'Wielingen', '1672-02-12', '1672-02-23', true, '1672-05-18', 'Batavia', NULL, 'Ace. to Daghregister 1672 the ship left the Cape on 29-02-1672. In 1674 the ship was wrecked off S.Tome.');
INSERT INTO "voyages" VALUES (1209, '', 1, '', 'VOORHOUT', NULL, 250, 'hoeker? jacht?', '1671', NULL, NULL, 'Z', 'Z', '1671-11-14', 'Wielingen', '1672-02-12', '1672-02-23', true, '1672-05-25', 'Batavia', NULL, 'The ship was laid up and sold at Batavia on 16-06-1685.');
INSERT INTO "voyages" VALUES (1210, '', 1, '', 'MAKASSAR', 'Pieter Koker', 1014, 'pinas', '1671', NULL, NULL, 'A', 'A', '1671-12-10', 'Texel', '1672-03-23', '1672-04-17', true, '1672-06-21', 'Batavia', 5661, NULL);
INSERT INTO "voyages" VALUES (1211, '', 2, '', 'GERECHTIGHEID', NULL, 652, 'jacht', '1665', NULL, NULL, 'A', 'E', '1671-12-11', 'Texel', '1672-04-09', '1672-04-29', true, '1672-07-14', 'Batavia', NULL, 'One soldier who embarked at the Cape, turned out to be a woman. The ship was laid up and sold at Batavia on 23-03-1677.');
INSERT INTO "voyages" VALUES (1212, '', 1, '', 'IJPESTEIN', NULL, 310, 'fluit', '1671', NULL, NULL, 'H', 'H', '1671-12-11', 'Texel', '1672-04-19', '1672-05-02', true, '1672-07-28', 'Tuticorin', NULL, 'Steven Donker became master.');
INSERT INTO "voyages" VALUES (1213, '', 1, '', 'OPMEER', NULL, 202, 'fluit? kat?', '1671', NULL, NULL, 'H', 'E', '1671-12-11', 'Texel', '1672-04-28', '1672-06-02', true, '1672-07-28', 'Tuticorin', NULL, 'See also 1198. The ship was laid up and sold at Batavia on 22-05-1688.');
INSERT INTO "voyages" VALUES (1214, '', 5, '', 'JONGE PRINS', NULL, 840, 'jacht', '1661', NULL, NULL, 'H', 'H', '1671-12-11', 'Texel', '1672-04-20', '1672-05-18', true, '1672-07-28', 'Batavia', 5662, 'Ace. to Daghregister 1672 the ship left the Cape on 30-05-1672.');
INSERT INTO "voyages" VALUES (1215, '', 3, '', 'VRIJE ZEE', 'Kornelis Gerritsz. Kriek van Delfshaven', 846, 'pinas', '1667', NULL, NULL, 'D', 'D', '1671-12-11', 'Goeree', '1672-04-13', '1672-04-29', true, '1672-07-26', 'Batavia', 5666, NULL);
INSERT INTO "voyages" VALUES (1216, '', 2, '', 'WIMMENUM', NULL, 448, 'fluit', '1669', NULL, NULL, 'A', 'A', '1671-12-14', 'Texel', '1672-04-15', '1672-04-29', true, '1672-07-15', 'Batavia', NULL, 'The ship was laid up and sold at Batavia on 22-03-1681.');
INSERT INTO "voyages" VALUES (1217, '', 1, '', 'LAREN', 'Dominikus van Geine', 268, 'jacht', '1671', NULL, NULL, 'A', 'A', '1671-12-15', 'Texel', '1672-04-22', '1672-05-23', true, '1672-07-24', 'Batavia', NULL, 'The ship was laid up at Malacca, in April 1682.');
INSERT INTO "voyages" VALUES (1218, '', 1, '', 'NEDERHORST', NULL, 240, 'kat? fluit?', '1671', NULL, NULL, 'A', 'A', '1671-12-15', 'Texel', '1672-04-30', '1672-06-02', true, '1672-08-16', 'Tuticorin', NULL, 'Via S. Tiago. See also 1198. The ship was laid up and sold at Batavia on 24-07-1688.');
INSERT INTO "voyages" VALUES (1219, '', 1, '', 'PIJL', 'Reinier Klaasz.', 400, 'jacht', '1671', NULL, NULL, 'A', 'A', '1671-12-15', 'Texel', '1672-04-12', '1672-12-30', true, '1673-06-14', 'Batavia', NULL, 'deserted at Mozambique. Via Mauritius from 15-01 till April/May 1673. The ship was laid up and sold at Batavia on 29-08-1684. The crew figures at III,IV and V refer to the Cape and Mauritius.');
INSERT INTO "voyages" VALUES (1220, '', 4, '', 'MIDDELBURG', 'Pieter Kool+', 846, NULL, '1664', NULL, NULL, 'Z', 'Z', '1671-12-27', 'Wielingen', '1672-04-14', '1672-05-03', true, '1672-07-05', 'Batavia', 5655, 'The master died on 04-07-1672; he was succeeded by Marten Binkershoek.');
INSERT INTO "voyages" VALUES (1221, '', 2, '', 'PRINS WILLEM HENDRIK', NULL, 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1671-12-27', 'Wielingen', '1672-04-14', '1672-05-03', true, '1672-07-07', 'Batavia', 5658, NULL);
INSERT INTO "voyages" VALUES (1222, '', 1, '', 'POSTHOORN', NULL, 60, 'bootje', NULL, '1671', NULL, 'Z', 'Z', '1672-04-06', 'Wielingen', '1673-01-05', NULL, true, NULL, NULL, 5649, 'Via Sierra Leone and Annabon. The ship stayed at the Cape and sailed on 30-01-1673 to St. Helena because of war with England.');
INSERT INTO "voyages" VALUES (1223, '', 1, '', 'BULKESTEIN', NULL, 90, 'hoeker', '1671', NULL, NULL, 'R', 'R', '1672-04-16', 'Maas', NULL, NULL, true, NULL, NULL, NULL, 'The ship was taken by the English.');
INSERT INTO "voyages" VALUES (1224, '', 1, '', 'LOERI', NULL, 90, 'hoeker', '1671', NULL, NULL, 'A', 'A', '1672-04-16', 'Texel', '1672-09-06', '1672-09-11', true, '1672-12-25', 'Ceylon', NULL, 'The ship was wrecked off Colombo on 15-12-1677.');
INSERT INTO "voyages" VALUES (1225, '', 2, '', 'SAKSENBURG', 'Willem Albertsz. Graaf', 450, 'fluit', '1669', NULL, NULL, 'A', 'A', '1672-04-16', 'Texel', '1672-07-30', '1672-10-29', true, '1673-01-09', 'Batavia', NULL, 'The ship brought the news of the war with England and France to the Cape and also the Heren XVII''s order to do as much damage to the French and English as possible; the LUSTER (1191) went to Batavia with the same message.');
INSERT INTO "voyages" VALUES (1226, '', 4, '', 'ZUIDPOLSBROEK', 'Jakob Albertsz. Been', 960, NULL, '1664', NULL, NULL, 'A', 'A', '1672-04-30', 'Texel', '1672-10-07', '1673-05-19', true, '1673-08-14', 'Batavia', NULL, '12-01-1673. They left a garrison (+-100 men) and departed on 11-03-1673. The ZUIDPOLSBROEK arrived at the Cape with one soldier, taken prisoner at St. Helena. The ship was laid up at Batavia. The seafarers figures for III and IV refer to the Cape and St. Helena.');
INSERT INTO "voyages" VALUES (1227, '', 3, '', 'KATTENBURG', 'Jan Bartelsz. Tand', 637, 'fluit', '1663', NULL, NULL, 'A', 'Z', '1672-05-23', 'Veere', '1672-10-23', '1672-12-10', true, '1673-06-19', 'Batavia', NULL, 'See 1226. After departure from St. Helena no call at the Cape. The ship was laid up and sold at Batavia. on 16-07-1677. The seafarers figures for III and IV refer to the Cape and St. Helena.');
INSERT INTO "voyages" VALUES (1228, '', 1, '', 'EGEL', NULL, 90, 'hoeker', '1672', NULL, NULL, 'E', 'E', '1672-06-06', 'Texel', '1672-10-22', '1672-11-05', true, '1673-01-01', 'Ceylon', NULL, NULL);
INSERT INTO "voyages" VALUES (1229, '', 3, '', 'VRIJHEID', 'Jakob de Geus', 1210, NULL, '1666', NULL, NULL, 'A', 'A', '1672-06-06', 'Texel', '1672-10-18', '1672-12-10', true, '1673-06-18', 'Batavia', 5665, 'Helena.');
INSERT INTO "voyages" VALUES (1230, '', 1, '', 'HELLEVOETSLUIS', 'Laurens Martensz. Suiker', 714, 'pinas', '1671', NULL, NULL, 'R', 'R', '1672-07-04', 'Goeree', '1673-01-08', '1673-02-09', true, '1673-05-17', 'Batavia', 5695, 'The ship met the return fleet under command of Arnoud van Overbeke (5627-5641) near the Shetland Islands on 25-07-1672. Via Sierra Leone.');
INSERT INTO "voyages" VALUES (1231, '', 1, '', 'DEN BRIEL', 'Anthonie van Noord van Rotterdam', 766, NULL, '1671', NULL, NULL, 'D', 'D', '1672-09-29', 'Goeree', '1673-04-08', '1673-04-14', true, '1673-06-27', 'Batavia', 5672, 'soldiers deserted. Via S. Tiago, where 7 soldiers enlisted. 2 children were born during the 
voyage. Acc. to Daghregister 1673 the ship left the Cape on 21-04-1673.');
INSERT INTO "voyages" VALUES (1232, '', 1, '', 'KANARIEVOGEL', 'Kornelis Muts van Delfshaven', 90, 'hoeker', '1672', NULL, NULL, 'D', 'D', '1672-10-08', 'Goeree', NULL, NULL, true, NULL, NULL, NULL, 'Taken by the English on 10-10-1672.');
INSERT INTO "voyages" VALUES (1233, '', 1, '', 'WAPEN VAN ALKMAAR', 'Jan Boon', 892, 'pinas', '1671', NULL, NULL, 'A', 'A', '1672-10-21', 'Texel', '1673-03-27', '1673-04-14', true, '1673-06-27', 'Batavia', 5670, 'Via S. Vincente. One child was born during the voyage. Acc. to Daghregister 1673 the ship left the Cape on 21-04-1673; acc. to Van Dam l, 491 built by Enkhuizen.');
INSERT INTO "voyages" VALUES (1234, '', 1, '', 'RHENEN', NULL, 580, 'pinas', '1672', NULL, NULL, 'A', 'A', '1672-10-21', 'Texel', '1673-03-28', '1673-04-13', true, '1673-06-24', 'Ceylon', NULL, 'The ship was wrecked off S. Tome in 1674.');
INSERT INTO "voyages" VALUES (1235, '', 2, '', 'ZOETENDAAL', 'Simon Kerseboom+', 448, 'fluit', '1669', NULL, NULL, 'Z', 'E', '1672-10-21', 'Texel', '1673-03-28', '1673-04-14', true, '1673-06-27', 'Batavia', NULL, 'by Willem van der Hop. The ship left the Cape on 21-04-1673, acc. to Daghregister 1673. It was wrecked 50 miles east of the Cape on 23-08-1673.');
INSERT INTO "voyages" VALUES (1236, '', 1, '', 'AZIE', 'Jan Sijbrandsz. Doen', 1140, NULL, '1671', NULL, NULL, 'A', 'A', '1672-12-18', 'Texel', '1673-04-15', '1673-05-19', true, '1673-08-14', 'Batavia', 5671, 'On 29-12-1672 there was a fight with an English frigate (I dead and 8 wounded), but the ship escaped on the third day. During this voyage the master and nearly all the officers died. Acc. to Daghregister 1673 the ship left the Cape on 26-05-1673.');
INSERT INTO "voyages" VALUES (1237, '', 1, '', 'BERGEEND', NULL, 90, 'hoeker', '1672', NULL, NULL, 'H', 'H', '1672-12-18', 'Texel', '1673-10-02', '1673-10-14', true, '1673-01-01', 'Ceylon', NULL, 'English, retaken by a Zeeland privateer, and restored in Zeeland. It finally left the Wielingen on 26-05-1673. Laid up at Ceylon in 1690.');
INSERT INTO "voyages" VALUES (1238, '', 3, '', 'WAPEN VAN GOES', NULL, 671, NULL, '1668', NULL, NULL, 'Z', 'Z', '1672-12-18', 'Texel', '1673-04-27', '1673-05-19', true, '1673-09-01', 'Ceylon', 5668, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (1239, '', 2, '', 'GOOILAND', 'Balthus Groen', 468, 'fluit', '1668', NULL, NULL, 'A', 'A', '1672-12-18', 'Texel', '1673-04-05', '1673-04-14', true, '1673-06-26', 'Batavia', NULL, 'Acc. to Daghregister 1673 the ship left the Cape on 21-04-1673. The ship sank at Palembang on 28-09-1682.');
INSERT INTO "voyages" VALUES (1240, '', 1, '', 'EUROPA', NULL, 1140, NULL, '1671', NULL, NULL, 'A', 'A', '1672-12-20', 'Texel', '1673-07-01', '1673-07-18', true, '1673-10-10', 'Colombo', 5694, 'Via Goeree, departure on 04-02-1673, and via S. Tiago.');
INSERT INTO "voyages" VALUES (1241, '', 4, '', 'WAPEN VAN HOORN', NULL, 756, 'fluit? jacht?', '1662', NULL, NULL, 'H', 'H', '1672-12-20', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Lost near England in February 1673.');
INSERT INTO "voyages" VALUES (1242, '', 2, '', 'GROOTEBROEK', 'Leendert Rus van Delfshaven', 464, 'fluit', '1670', NULL, NULL, 'E', 'A', '1673-05-09', 'Texel', '1673-10-20', '1673-11-09', true, '1674-01-21', 'Batavia', NULL, 'Via S. Tiago. The ship was sold at Surat in 1680.');
INSERT INTO "voyages" VALUES (1243, '', 1, '', 'MUIDERBERG', NULL, 400, 'jacht', '1672', NULL, NULL, 'A', 'A', '1673-05-09', 'Texel', '1673-10-20', '1673-11-09', true, '1674-01-21', 'Batavia', 5675, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1244, '', 3, '', 'OOSTENBURG', NULL, 840, 'pinas? fluit?', '1667', NULL, NULL, 'A', 'A', '1673-05-09', 'Texel', '1673-10-10', '1673-10-31', true, '1674-01-10', 'Batavia', 5683, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1245, '', 4, '', 'SPARENDAM', NULL, 700, 'fluit', '1662', NULL, NULL, 'A', 'A', '1673-05-09', 'Texel', '1673-09-29', '1673-10-20', true, '1674-01-12', 'Batavia', NULL, 'Via S. Tiago. The ship was laid up at Batavia on 03-09-1680.');
INSERT INTO "voyages" VALUES (1246, '', 2, '', 'ZWANENBURG', NULL, 508, 'fluit', '1670', NULL, NULL, 'Z', 'E', '1673-05-09', 'Texel', '1673-10-14', '1673-10-31', true, '1674-01-16', 'Batavia', NULL, 'Batavia on 29-09-1685.');
INSERT INTO "voyages" VALUES (1247, '', 3, '', 'TERNATE', 'Evert Kaspersz.', 1014, 'pinas', '1668', NULL, NULL, 'A', 'A', '1673-06-11', 'Texel', '1673-10-15', '1673-11-09', true, '1674-01-21', 'Batavia', 5686, 'Via Saldanha Bay.');
INSERT INTO "voyages" VALUES (1248, '', 1, '', 'KWARTEL', NULL, 96, 'hoeker', '1672', NULL, NULL, 'A', 'A', '1673-06-24', 'Texel', '1673-10-14', NULL, true, '1673-10-14', 'The Cape', 5667, 'The ship stayed at the Cape.');
INSERT INTO "voyages" VALUES (1249, '', 3, '', 'GEKROONDE VREDE', NULL, 730, NULL, '1667', NULL, NULL, 'E', 'H', '1673-09-11', 'Texel', '1674-01-24', '1674-02-18', true, '1674-05-12', 'Batavia', 5699, 'Via S. Vincente, where 4 seafarers and 1 soldier stayed behind.');
INSERT INTO "voyages" VALUES (1250, '', 1, '', 'ZIJPE', 'Jan Modderman', 488, 'jacht', '1672', NULL, NULL, 'E', 'E', '1673-09-11', 'Texel', '1674-01-30', '1674-02-18', true, '1674-05-12', 'Batavia', NULL, 'The ship was blown up at the roadstead of Batavia in 1690.');
INSERT INTO "voyages" VALUES (1251, '', 1, '', 'BODE', 'Adriaan Roelofsz. van Asperen', 96, 'hoeker', '1673', NULL, NULL, 'D', 'D', '1673-11-08', 'Texel', '1674-11-18', NULL, true, NULL, NULL, NULL, 'Second departure on 22-06-1674. The ship was wrecked on a reef near the `Thousand Islands'', on 13-09-1684.');
INSERT INTO "voyages" VALUES (1252, '', 1, '', 'BRANDGANS', 'Huibert Bastiaansz. Gruit', 90, 'hoeker', '1673', NULL, NULL, 'D', 'D', '1673-11-08', 'Texel', '1674-05-03', '1674-07-20', true, NULL, 'Ceylon', NULL, 'Via 
S. Tiago. Acc. to Daghregister 1674 the ship arrived at the Cape on 10-04-1674. The ship was laid up and sold at Batavia in July 1687.');
INSERT INTO "voyages" VALUES (1253, '', 3, '', 'DELFSHAVEN', 'Anthonie Klaasz. van Engele van Delfshaven', 654, 'fluit', '1668', NULL, NULL, 'D', 'D', '1673-11-08', 'Texel', '1674-05-30', '1674-07-03', true, '1674-09-04', 'Batavia', 5693, 'Via 
S. Tiago. Acc. to Daghregister 1674 one passenger disembarked at the Cape instead of embarked.');
INSERT INTO "voyages" VALUES (1254, '', 2, '', 'TIDORE', NULL, 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1673-11-08', 'Texel', '1674-04-10', '1674-06-03', true, '1674-07-27', 'Batavia', 5663, 'Via S. Tiago, where 2 seafarers deserted.');
INSERT INTO "voyages" VALUES (1255, '', 1, '', 'WAPEN VAN THOLEN', 'Thomas Danielsz.', 698, 'pinas', '1672', NULL, NULL, 'Z', 'Z', '1673-12-04', 'Wielingen', '1674-05-12', '1674-06-03', true, '1674-08-01', 'Batavia', 5739, 'Via S. Tiago. One soldier turned out to be a woman.');
INSERT INTO "voyages" VALUES (1256, '', 3, '', 'WAPEN VAN ZIERIKZEE', 'Laurens de Potter', 1094, NULL, '1667', NULL, NULL, 'Z', 'Z', '1673-12-04', 'Texel', '1674-04-25', '1674-06-03', true, '1674-07-30', 'Batavia', 5673, 'Via Tenerife, where 4 seafarers deserted, and via S. Tiago.');
INSERT INTO "voyages" VALUES (1257, '', 3, '', 'WAPEN VAN ROTTERDAM', NULL, 1124, NULL, '1666', NULL, NULL, 'R', 'A', '1673-12-16', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'the English in February 1674.');
INSERT INTO "voyages" VALUES (1258, '', 3, '', 'VOORZICHTIGHEID', NULL, 636, 'fluit', '1667', NULL, NULL, 'H', 'A', '1673-12-16', 'Texel', '1674-05-13', '1674-06-03', true, '1674-08-01', 'Tuticorin', 5691, 'Via Cape Verde.');
INSERT INTO "voyages" VALUES (1259, '', 2, '', 'PUNACKER', NULL, 472, 'fluit', '1670', NULL, NULL, 'D', 'A', '1674-01-13', 'Texel', '1674-05-07', '1674-06-03', true, '1674-08-03', 'Tuticorin', NULL, 'The ship was laid up and sold at Batavia on 13-04-1684.');
INSERT INTO "voyages" VALUES (1260, '', 1, '', 'BLAUWE HULK', 'Jakob Willemsz. Schouten', 744, 'pinas', '1673', NULL, NULL, 'E', 'E', '1674-01-17', 'Texel', '1674-05-05', '1674-06-03', true, '1674-09-29', 'Batavia', 5680, 'One soldier stayed behind on the west coast of Sumatra.');
INSERT INTO "voyages" VALUES (1261, '', 1, '', 'KOEWERVE', 'Kornelis de Keizer', 698, 'pinas', '1672', NULL, NULL, 'Z', 'Z', '1674-03-16', 'Wielingen', '1674-07-13', '1674-08-04', true, '1674-10-05', 'Batavia', 5681, 'Original departure on 10-02-1673, but returned two months later. Via S. Tiago. The ship brought the news of peace with England.');
INSERT INTO "voyages" VALUES (1262, '', 2, '', 'KOKMEEUW', NULL, 90, 'hoeker', '1667', NULL, NULL, 'R', 'Z', '1674-03-16', 'Wielingen', '1674-07-20', '1674-08-04', true, '1674-12-15', 'Surat', NULL, 'Acc. to K.A. 1187 the ship departed on 10-08-1674 from the
Cape.');
INSERT INTO "voyages" VALUES (1263, '', 1, '', 'SNOEPER', 'Barend Fokkesz.', NULL, 'galjoot', NULL, NULL, '1673/4', 'A', 'A', '1674-04-20', 'Vlie', '1674-08-01', '1674-08-10', true, NULL, 'Ceylon', NULL, 'Via S. Tiago. In 1674 the ship capsized near the Maldive Islands. The master and the crew arrived safely at Cochin.');
INSERT INTO "voyages" VALUES (1264, '', 2, '', 'STERMEER', NULL, 502, 'fluit', '1669', NULL, NULL, 'H', 'A', '1674-04-30', 'Texel', NULL, NULL, true, NULL, 'Ceylon', NULL, NULL);
INSERT INTO "voyages" VALUES (1265, '', 1, '', 'KROONVOGEL', NULL, 108, 'hoeker', '1673', NULL, NULL, 'A', 'A', '1674-05-16', 'Texel', '1674-09-11', NULL, true, '1674-09-11', 'The Cape', 5674, NULL);
INSERT INTO "voyages" VALUES (1266, '', 2, '', 'POSTHOORN', NULL, 60, 'bootje', NULL, '1671', NULL, 'Z', 'A', '1674-05-16', 'Texel', '1674-09-27', '1675-01-08', true, '1675-04-27', 'Batavia', 5684, NULL);
INSERT INTO "voyages" VALUES (1267, '', 1, '', 'BETUWE', 'Pieter Harkesz.', 704, 'pinas', '1672', NULL, NULL, 'A', 'A', '1674-05-17', 'Texel', '1674-09-26', '1674-10-20', true, '1675-01-05', 'Batavia', NULL, 'The ship was laid up at Batavia on 03-01-1688.');
INSERT INTO "voyages" VALUES (1268, '', 1, '', 'VELUWE', 'Justinus Wijns', 740, NULL, '1672', NULL, NULL, 'A', 'A', '1674-06-09', 'Texel', '1674-09-26', '1674-10-20', true, '1674-12-21', 'Batavia', NULL, 'Acc. to Daghregister 1674 the ship departed from Texel on 29-06-1674. It was laid up and sold at Batavia on 29-08-1684.');
INSERT INTO "voyages" VALUES (1269, '', 1, '', 'AFRIKA', 'Kornelis Blankeroot', 1100, NULL, '1673', NULL, NULL, 'R', 'R', '1674-06-22', 'Goeree', '1675-01-15', '1675-02-05', true, '1675-05-11', 'Batavia', 5676, 'Daghreg. 1675 the ship departed on 10-02-1675 from the Cape.');
INSERT INTO "voyages" VALUES (1270, '', 1, '', 'HENDRIK MAURITS', 'David Kool', 1194, NULL, '1673', NULL, NULL, 'Z', 'Z', '1674-08-22', 'Wielingen', '1675-02-28', '1675-04-05', true, '1675-07-23', 'Batavia', 5678, 'The passenger who embarked at the Cape was a prisoner; he died during the voyage.');
INSERT INTO "voyages" VALUES (1271, '', 1, '', 'AMERIKA', 'Jakob Livius', 1002, 'pinas', '1674', NULL, NULL, 'H', 'H', '1674-09-02', 'Texel', '1675-03-11', '1675-04-05', true, '1675-07-23', 'Batavia', 5677, 'A conspiracy of seven men to sail the ship to Brazil was discovered; four of them were hanged at the Cape, the other three got a sentence of 20 years penal servitude.');
INSERT INTO "voyages" VALUES (1272, '', 1, '', 'HUIS TE BERGEN', NULL, 358, 'fluit? kat?', '1674', NULL, NULL, 'H', 'H', '1674-09-02', 'Texel', '1675-02-26', '1675-04-02', true, '1676-02-03', 'Colombo', NULL, 'Via Pegu, 29-07-1675. The ship was laid u p in Bengal in 1686.');
INSERT INTO "voyages" VALUES (1273, '', 1, '', 'KORHOEN', 'Reinier Guldensteen', 100, 'hoeker', '1674', NULL, NULL, 'E', 'E', '1674-09-02', 'Texel', '1675-01-26', '1675-02-05', true, '1675-05-15', 'Batavia', NULL, 'The ship was laid up at Ceylon in 1687.');
INSERT INTO "voyages" VALUES (1274, '', 1, '', 'EILAND MAURITIUS', 'Jakob Hanel van Rotterdam', 756, 'pinas', '1672', NULL, NULL, 'D', 'D', '1674-09-02', 'Goeree', '1675-02-09', '1675-02-24', true, '1675-06-06', 'Batavia', 5682, 'One child was born during the voyage and one soldier turned out to be a woman.');
INSERT INTO "voyages" VALUES (1275, '', 1, '', 'HOVELING', NULL, NULL, 'fluit', NULL, NULL, '1673/4', 'A', 'A', '1674-09-20', 'Texel', '1675-01-10', '1675-02-24', true, '1675-06-04', 'Batavia', 5679, 'The number of the shipowner''s men is unknown.');
INSERT INTO "voyages" VALUES (1276, '', 1, '', 'NIEUWE VISSER', NULL, 368, NULL, NULL, NULL, '1673/4', 'A', 'E', '1674-09-20', 'Texel', '1675-01-10', NULL, true, '1675-01-10', 'The Cape', NULL, NULL);
INSERT INTO "voyages" VALUES (1277, '', 1, '', 'SUMATRA', 'Willem Toledo', 738, 'pinas', '1673', NULL, NULL, 'A', 'A', '1674-11-16', 'Texel', '1675-03-22', '1675-04-09', true, '1675-07-21', 'Batavia', 5685, NULL);
INSERT INTO "voyages" VALUES (1278, '', 1, '', 'ROEMERSWAAL', NULL, 524, 'pinas? fluit?', '1674', NULL, NULL, 'Z', 'Z', '1674-11-21', 'Wielingen', '1675-05-22', '1675-06-09', true, '1675-08-17', 'Ceylon', 5702, 'Via England (2 months) and Saldanha Bay.');
INSERT INTO "voyages" VALUES (1279, '', 2, '', 'BUREN', 'Kornelis Thijsz. van Rooien van Delfshaven', 468, 'fluit', '1670', NULL, NULL, 'A', 'D', '1675-01-22', 'Goeree', '1675-05-30', '1675-06-15', true, '1675-08-16', 'Batavia', NULL, 'Via S. Tiago. The ship was laid up and sold at Batavia on 08-01-1683.');
INSERT INTO "voyages" VALUES (1280, '', 2, '', 'BAARS', NULL, 90, 'hoeker', '1668', NULL, NULL, 'R', 'A', '1675-01-24', 'Texel', '1675-06-20', '1676-10-05', true, '1677-01-12', 'Batavia', NULL, 'Via Plymouth (15 days). The ship was laid up and sold on 22-06-1680.');
INSERT INTO "voyages" VALUES (1281, '', 3, '', 'BEEMSTER', NULL, 514, 'fluit', '1667', NULL, NULL, 'A', 'A', '1675-01-24', 'Texel', '1675-05-21', '1675-06-09', true, '1675-08-17', 'Colombo', 5687, 'Via Plymouth (15 days) and 
S. Tiago. Acc. to Coolhaas 1V the
ship arrived at Ceylon on 13-08-1675.');
INSERT INTO "voyages" VALUES (1282, '', 1, '', 'BLEKER', NULL, 316, NULL, NULL, NULL, '1674/5', 'A', 'A', '1675-01-24', 'Texel', NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (1283, '', 1, '', 'CATHARINA', NULL, 345, NULL, NULL, NULL, '1674/5', 'A', 'A', '1675-01-24', 'Texel', NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (1284, '', 1, '', 'CEYLON', NULL, 776, NULL, '1673', NULL, NULL, 'A', 'A', '1675-01-24', 'Texel', '1675-06-22', '1675-07-08', true, '1675-09-12', 'Batavia', 5690, 'Via Plymouth (15 days), where 6 seafarers and 1 soldier deserted, 1 soldier was enlisted.');
INSERT INTO "voyages" VALUES (1285, '', 1, '', 'JAPAN', 'Jakob Zwart', 762, 'jacht', '1674', NULL, NULL, 'E', 'A', '1675-01-24', 'Texel', '1675-05-21', '1675-07-07', true, '1675-08-12', 'Batavia', NULL, 'Via Plymouth (15 days) and S. Tiago. The ship was laid up and sold at Batavia on 30-10-1685.');
INSERT INTO "voyages" VALUES (1286, '', 1, '', 'HUIS TE KLEEF', 'Gerrit Albertsz. Schellinger', 564, 'pinas? jacht?', '1674', NULL, NULL, 'A', 'A', '1675-01-24', 'Texel', '1675-06-09', '1675-07-07', true, '1675-08-16', 'Batavia', NULL, 'Via Plymouth (15 days), where 10 seafarers and 5 soldiers deserted. Via 
S. Tiago. Acc. to K.A. 1202 the ship arrived at the Cape on 12-05-1675. The ship was wrecked near the `Thousand Islands'' during a voyage to Palembang (01-09-1684).');
INSERT INTO "voyages" VALUES (1287, '', 3, '', 'SPANBROEK', NULL, 448, 'fluit', '1669', NULL, NULL, 'A', 'H', '1675-01-24', 'Texel', '1675-05-20', '1675-07-07', true, '1675-08-13', 'Batavia', 5688, 'Via Plymouth (15 days) and 
S. Tiago. Acc. to K.A. 3989 the passenger did arrive at Batavia.');
INSERT INTO "voyages" VALUES (1288, '', 1, '', 'ZWARTSLUIS', 'Klaas Pietersz.+', 500, 'fluit', NULL, '1674/5', NULL, 'A', 'A', '1675-01-24', 'Texel', '1675-06-26', '1675-07-07', true, '1675-10-30', 'Batavia', NULL, 'Via Plymouth where 7 seafarers deserted on 13-02-1675. The master died during the voyage and was buried at S. Tiago. He was succeeded by Laurens Verbeek. The ship was wrecked at Coromandel in January 1680.');
INSERT INTO "voyages" VALUES (1289, '', 1, '', 'ALEXANDER', 'Jan Gravius', 524, 'pinas? jacht?', '1674', NULL, NULL, 'Z', 'Z', '1675-02-22', 'Wielingen', '1675-06-27', '1675-07-08', true, '1675-09-08', 'Batavia', 5689, 'Via S. Tiago, where one seaman deserted.');
INSERT INTO "voyages" VALUES (1290, '', 1, '', 'ODIJK', 'Jan Witboom', 551, 'jacht', '1674', NULL, NULL, 'Z', 'Z', '1675-02-22', 'Wielingen', '1675-05-31', '1675-06-15', true, '1675-08-16', 'Batavia', NULL, 'The ship was laid up at Batavia in April 1690.');
INSERT INTO "voyages" VALUES (1291, '', 3, '', 'PRINS WILLEM HENDRIK', 'David Bessevin', 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1675-04-13', 'Wielingen', '1676-01-12', '1676-02-14', true, '1676-05-10', 'Batavia', 5700, 'new seafarers and 3 soldiers were enlisted.');
INSERT INTO "voyages" VALUES (1292, '', 3, '', 'BURCHT VAN LEIDEN', NULL, 1040, NULL, '1667', NULL, NULL, 'A', 'R', '1675-04-25', 'Goeree', '1675-08-30', NULL, true, '1675-11-16', 'Batavia', 5696, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (1293, '', 1, '', 'HUIS TE MERWEDE', NULL, 882, 'pinas', '1674', NULL, NULL, 'R', 'R', '1675-04-25', 'Goeree', '1675-08-31', NULL, true, '1675-11-20', 'Batavia', 5740, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (1294, '', 1, '', 'SCHIELAND', 'Lambertus de Radder', 710, NULL, '1674', NULL, NULL, 'D', 'D', '1675-04-25', 'Goeree', '1675-08-30', NULL, true, '1675-12-07', 'Batavia', 5735, 'Via S. Vincente, where one seaman was put ashore.');
INSERT INTO "voyages" VALUES (1295, '', 4, '', 'HOLLANDSE TUIN', NULL, 1210, NULL, '1665', NULL, NULL, 'A', 'A', '1675-04-25', 'Goeree', '1675-08-31', NULL, true, '1675-11-16', 'Batavia', 5698, 'Via S. Vincente. During the voyage one seaman was enlisted.');
INSERT INTO "voyages" VALUES (1296, '', 2, '', 'ZWEMMER', NULL, 90, 'hoeker', '1669', NULL, NULL, 'D', 'A', '1675-04-25', 'Goeree', '1675-09-12', '1675-10-05', true, '1676-01-30', 'Batavia', NULL, 'Via S. Vincente. The ship ran ashore and was wrecked at Colombo on 05-01-1680.');
INSERT INTO "voyages" VALUES (1297, '', 1, '', 'SINT JANSKERKE', NULL, 440, 'fluit', NULL, '1674', NULL, 'Z', 'Z', '1675-05-15', 'Texel', '1675-10-17', '1675-11-15', true, '1676-02-01', 'Batavia', NULL, 'Via Vlissingen (departure 18-05-1675). The ship was laid up and sold in 1682.');
INSERT INTO "voyages" VALUES (1298, '', 1, '', 'OOSTERBLOKKER', 'Jan van Haren', 472, 'fluit', NULL, '1675', NULL, 'H', 'H', '1675-05-18', 'Texel', '1676-03-28', NULL, true, '1676-07-23', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1299, '', 1, '', 'WESTERVELD', NULL, 500, 'fluit', NULL, '1674/5', NULL, 'A', 'A', '1675-05-18', 'Texel', '1675-10-30', '1675-11-15', true, '1676-01-19', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1300, '', 3, '', 'HOF VAN BREDA', NULL, 670, 'jacht', '1667', NULL, NULL, 'A', 'E', '1675-05-22', 'Texel', NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (1301, '', 1, '', 'COEVORDEN', 'Kornelis Zwart', 820, NULL, '1674', NULL, NULL, 'A', 'A', '1675-08-02', 'Texel', '1675-12-29', '1676-01-24', true, '1676-05-03', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1302, '', 1, '', 'HUIS TE SPIJK', 'Hendrik Geus', 700, 'fluit', '1674', NULL, NULL, 'A', 'A', '1675-08-02', 'Texel', '1676-01-13', '1676-02-14', true, '1676-05-09', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1303, '', 1, '', 'AARDENBURG', NULL, 482, 'fluit', NULL, '1672', NULL, 'Z', 'Z', '1675-08-15', 'Wielingen', '1676-01-23', '1676-02-14', true, '1676-05-17', 'Tuticorin', NULL, NULL);
INSERT INTO "voyages" VALUES (1304, '', 1, '', 'HUIS TE KRONENBURG', NULL, 700, 'fluit', '1674', NULL, NULL, 'A', 'A', '1675-09-15', 'Texel', '1676-02-19', '1676-03-10', true, '1676-06-02', 'Tuticorin', NULL, NULL);
INSERT INTO "voyages" VALUES (1305, '', 1, '', 'HUIS TE ZILVERSTEIN', 'Albert Schrik', 1017, NULL, '1674', NULL, NULL, 'A', 'A', '1675-09-15', 'Texel', '1676-02-24', '1676-03-24', true, '1676-05-29', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1306, '', 1, '', 'STAD GRAVE', 'Jan Adriaansz. Koning van Delfshaven', 474, 'fluit', '1675', NULL, NULL, 'D', 'D', '1675-11-08', 'Maas', '1676-05-03', '1676-05-22', true, '1676-07-20', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1307, '', 1, '', 'KORTGENE', 'Adriaan Sleutel', 1139, NULL, '1675', NULL, NULL, 'Z', 'Z', '1675-12-01', 'Wielingen', '1676-04-18', '1676-04-29', true, '1676-06-24', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1308, '', 2, '', 'MUIDERBERG', NULL, 400, 'jacht', '1672', NULL, NULL, 'A', 'Z', '1675-12-01', 'Wielingen', '1676-05-05', '1676-05-22', true, '1676-07-23', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1309, '', 3, '', 'TIDORE', NULL, 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1675-12-01', 'Wielingen', '1676-04-18', '1676-04-29', true, '1676-06-24', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1310, '', 2, '', 'AZIE', NULL, 1140, NULL, '1671', NULL, NULL, 'A', 'A', '1676-01-13', 'Texel', '1676-04-18', '1676-04-29', true, '1676-06-24', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1311, '', 2, '', 'DEN BRIEL', 'Jan Jansz. Boorne', 766, NULL, '1671', NULL, NULL, 'D', 'H', '1676-01-13', 'Texel', '1676-05-05', '1676-05-22', true, '1676-07-29', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1312, '', 2, '', 'KROONVOGEL', 'Lukas Genzenwinner', 108, 'hoeker', '1673', NULL, NULL, 'A', 'A', '1676-01-13', 'Texel', '1676-04-18', '1676-04-29', true, '1676-07-04', 'Batavia', NULL, 'Via Duins (16 till 17-01-1676). The ship ran ashore and was wrecked at Alkmaar Island near Batavia on 11-02-1686.');
INSERT INTO "voyages" VALUES (1313, '', 1, '', 'SINT LAURENS', NULL, NULL, 'fluit', NULL, NULL, '1675/6', 'A', 'A', '1676-01-13', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ship was wrecked at the Cape Verde Islands.');
INSERT INTO "voyages" VALUES (1314, '', 2, '', 'MAKASSAR', 'van Bruggen', 1014, 'pinas', '1671', NULL, NULL, 'A', 'A', '1676-01-13', 'Texel', '1676-05-01', '1676-05-22', true, '1676-07-23', 'Batavia', 5726, 'Via Duins (16 till 17-01-1676).');
INSERT INTO "voyages" VALUES (1315, '', 4, '', 'STICHT VAN UTRECHT', 'Karsten Pietersz.', 990, NULL, '1667', NULL, NULL, 'A', 'A', '1676-01-13', 'Texel', '1676-05-03', '1676-05-22', true, '1676-07-23', 'Batavia', 5701, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1316, '', 4, '', 'WAPEN VAN GOES', NULL, 671, NULL, '1668', NULL, NULL, 'Z', 'Z', '1676-03-11', 'Wielingen', '1676-07-10', '1676-07-27', true, '1676-09-25', 'Batiavia', 5701, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1317, '', 4, '', 'WAPEN VAN ZIERIKZEE', 'Jakob Valk', 1094, NULL, '1667', NULL, NULL, 'Z', 'Z', '1676-03-11', 'Wielingen', '1676-07-10', '1676-07-27', true, '1676-09-25', 'Batavia', 5712, 'Via S. Tiago. The ZIERIKZEE carried part of the cargo of the SINT LAURENS (1313) to Batavia.');
INSERT INTO "voyages" VALUES (1318, '', 4, '', 'EENDRACHT', NULL, 670, NULL, '1663', NULL, NULL, 'D', 'R', '1676-04-22', 'Maas', '1676-10-28', '1676-11-09', true, '1677-01-24', 'Batavia', NULL, 'voyage the ship was unsuccesfully attacked by four French ships. Laid up on 31-01-1681 and sold in February 1683.');
INSERT INTO "voyages" VALUES (1319, '', 4, '', 'VRIJE ZEE', 'Jakob Ganswijk', 846, 'pinas', '1667', NULL, NULL, 'D', 'D', '1676-04-22', 'Maas', '1676-08-25', '1676-09-07', true, '1676-11-21', 'Batavia', 5711, NULL);
INSERT INTO "voyages" VALUES (1320, '', 2, '', 'WAPEN VAN ALKMAAR', 'Willem Hagedoorn', 892, 'pinas', '1671', NULL, NULL, 'E', 'A', '1676-05-25', 'Texel', '1676-09-26', '1676-10-05', true, '1677-01-02', 'Batavia', 5703, 'the voyage.');
INSERT INTO "voyages" VALUES (1321, '', 1, '', 'GELE BEER', 'Reinier Klaasz. de Groot', 412, 'fluit', NULL, '1675/6', NULL, 'A', 'A', '1676-05-25', 'Texel', '1676-09-29', '1676-10-05', true, '1676-12-27', 'Batavia', 5704, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1322, '', 1, '', 'GEKROONDE EENDRACHT', 'Kornelis Loefhouwer', NULL, 'fluit', NULL, NULL, '1676', 'E', 'E', '1676-05-25', 'Texel', '1676-09-30', '1676-10-05', true, '1677-01-11', 'Batavia', 5705, NULL);
INSERT INTO "voyages" VALUES (1323, '', 2, '', 'KWARTEL', 'Kornelis Kornelisz.', 96, 'hoeker', '1672', NULL, NULL, 'A', 'A', '1676-05-25', 'Texel', '1676-09-29', '1678-09-03', true, '1678-11-07', 'Batavia', 5728, 'The ship stayed for about two years at the Cape.');
INSERT INTO "voyages" VALUES (1324, '', 1, '', 'JUFFROUW MARIA', 'Marten Binkershoek', 440, 'fluit', NULL, NULL, '1675/6', 'A', 'A', '1676-05-25', 'Texel', '1676-09-29', '1676-10-05', true, '1677-01-11', 'Batavia', 5706, 'Via S. Tiago, where one soldier was enlisted.');
INSERT INTO "voyages" VALUES (1325, '', 1, '', 'MIDDELBURG', NULL, 950, NULL, '1675', NULL, NULL, 'Z', 'Z', '1676-06-19', 'Wielingen', '1676-11-17', '1676-12-01', true, '1677-01-31', 'Batavia', 5709, 'During the voyage the ship was unsuccesfully attacked by four French ships. Via Cape Verde.');
INSERT INTO "voyages" VALUES (1326, '', 4, '', 'VRIJHEID', NULL, 1210, NULL, '1666', NULL, NULL, 'A', 'E', '1676-07-18', 'Texel', '1676-11-17', '1676-12-08', true, '1677-02-16', 'Batavia', 5710, NULL);
INSERT INTO "voyages" VALUES (1327, '', 2, '', 'RAMMEKENS', NULL, 438, 'jacht', '1662', NULL, NULL, 'Z', 'A', '1676-09-14', 'Texel', '1677-02-12', '1677-03-09', true, '1677-06-03', 'Tuticorin', NULL, 'Via S. Vincente. Laid up and sold on 22-03-1683.');
INSERT INTO "voyages" VALUES (1328, '', 1, '', 'SOESTDIJK', 'Jan Boon', 480, 'fluit', '1676', NULL, NULL, 'A', 'A', '1676-09-14', 'Texel', '1677-03-02', '1677-03-21', true, '1677-06-15', 'Batavia', NULL, 'Via S. Vincente. Laid up and sold on 30-09-1684.');
INSERT INTO "voyages" VALUES (1329, '', 4, '', 'HUIS TE VELSEN', 'Hendrik Bommer', 750, NULL, '1667', NULL, NULL, 'A', 'A', '1676-09-14', 'Texel', '1677-02-18', '1677-03-09', true, '1677-06-10', 'Tuticorin', 5714, 'Via S. Vincente. At Colombo on 19-06-1677.');
INSERT INTO "voyages" VALUES (1330, '', 1, '', 'WESTERAMSTEL', 'Jakob Harkesz.+', 480, 'fluit', '1676', NULL, NULL, 'A', 'A', '1676-09-14', 'Texel', '1677-03-02', '1677-03-21', true, '1677-07-01', 'Batavia', 5762, 'by Herman van Doeyenburg.');
INSERT INTO "voyages" VALUES (1331, '', 2, '', 'SUMATRA', 'Leendert Maas', 738, 'pinas', '1673', NULL, NULL, 'A', 'A', '1676-09-29', 'Texel', '1677-02-11', '1677-03-01', true, '1677-05-12', 'Batavia', 5738, NULL);
INSERT INTO "voyages" VALUES (1332, '', 2, '', 'AMERIKA', 'Jan Sybrandsz. Doen +', 1002, 'pinas', '1674', NULL, NULL, 'H', 'H', '1676-12-14', 'Texel', '1677-07-05', '1677-07-26', true, '1677-09-19', 'Batavia', 5722, 'Daghreg. 1677 on 30-06-1677 at the Cape and on 29-09-1677 at Batavia. The new master was Nanning Klaasz. Sanderus.');
INSERT INTO "voyages" VALUES (1333, '', 4, '', 'BEEMSTER', 'Jakob Breen', 514, 'fluit', '1667', NULL, NULL, 'A', 'A', '1676-12-14', 'Texel', '1677-06-30', '1677-07-13', true, '1677-09-15', 'Batavia', NULL, '1677 in the Veerse Gat); second departure on 11-03-1677. Via S. Tiago. Laid up and sold at Batavia on 13-05-1684.');
INSERT INTO "voyages" VALUES (1334, '', 1, '', 'BERKMEER', NULL, 454, 'fluit', '1676', NULL, NULL, 'E', 'A', '1676-12-14', 'Texel', '1677-09-20', '1677-10-02', true, '1677-12-29', 'Batavia', NULL, 'Second departure from Texel on 03-05-1677. Laid up at Malacca in 1690.');
INSERT INTO "voyages" VALUES (1335, '', 2, '', 'CEYLON', NULL, 776, NULL, '1673', NULL, NULL, 'A', 'A', '1676-12-14', 'Texel', '1677-06-30', '1677-07-14', true, '1677-10-13', 'Colombo', 5720, 'Second departure from the Wielingen on 11-03-1677.');
INSERT INTO "voyages" VALUES (1336, '', 2, '', 'BLAUWE HULK', 'Klaas Korf', 744, 'pinas', '1673', NULL, NULL, 'E', 'E', '1676-12-14', 'Texel', '1677-03-09', '1677-03-30', true, '1677-06-15', 'Batavia', 5746, NULL);
INSERT INTO "voyages" VALUES (1337, '', 1, '', 'LANDMAN', NULL, 474, 'fluit', '1676', NULL, NULL, 'A', 'A', '1676-12-14', 'Texel', '1677-07-03', '1677-07-16', true, '1677-10-04', 'Batavia', NULL, 'Because of icing the ship took refuge in the Wielingen; second departure on 11-03-1677. Via 
S. Tiago. Acc. to Daghreg. 1677 at the Cape on 30-06-1677. Burned in the Bay of Gale on 19-12-1679 (6 to 8 casualties).');
INSERT INTO "voyages" VALUES (1338, '', 3, '', 'POSTHOORN', 'Kornelis Wobbema', 60, 'bootje', NULL, '1671', NULL, 'A', 'Z', '1676-12-14', 'Texel', '1677-07-11', '1678-01-04', true, '1678-06-06', 'Batavia', 5756, 'Because of icing the ship found refuge in the Wielingen. Second departure on 
11-03-1677. Acc. to Daghreg. 1677 at the Cape on 30-06-1677. Via S. Tiago and Mauritius.');
INSERT INTO "voyages" VALUES (1339, '', 1, '', 'SPAARNWOUDE', NULL, 480, 'fluit', '1676', NULL, NULL, 'A', 'A', '1676-12-14', 'Texel', '1677-06-30', '1677-07-09', true, '1677-09-09', 'Batavia', 5754, 'Wielingen. Second departure on 11-03-1677. Via S. Tiago. The original destination was Ceylon.');
INSERT INTO "voyages" VALUES (1340, '', 2, '', 'KOEWERVE', NULL, 698, 'pinas', '1672', NULL, NULL, 'Z', 'Z', '1677-01-05', 'Wielingen', NULL, NULL, false, '1677-07-24', 'Negombo', 5713, 'Via S. Tiago, where 22 men deserted. No call at the Cape because of danger of war. At Colombo on 29-07-1677.');
INSERT INTO "voyages" VALUES (1341, '', 2, '', 'HENDRIK MAURITS', 'Adam van Breen+', 1194, NULL, '1673', NULL, NULL, 'Z', 'Z', '1677-01-05', 'Wielingen', NULL, NULL, false, '1677-07-19', 'Batavia', 5724, 'Via England, where 8 seafarers and 1 soldier deserted. 9 seafarers and 2 soldiers were pressed. The master was succeeded by Leendert Laurensz. No call at the Cape because of danger of war. One seaman turned out to be a woman.');
INSERT INTO "voyages" VALUES (1342, '', 4, '', 'SPANBROEK', 'Abraham Marlodt', 448, 'fluit', '1669', NULL, NULL, 'A', 'Z', '1677-01-05', 'Wielingen', NULL, NULL, false, '1677-09-06', 'Batavia', NULL, 'Via Falmouth, where 2 seafarers deserted and 5 seafares and 4 soldiers were pressed. No call at the Cape because of danger of war. Laid up and sold on 10-06-1683.');
INSERT INTO "voyages" VALUES (1343, '', 2, '', 'ALEXANDER', 'Abraham Fransen', 524, 'pinas? jacht?', '1674', NULL, NULL, 'Z', 'Z', '1677-03-11', 'Wielingen', '1677-06-30', '1677-07-26', true, '1677-09-25', 'Batavia', NULL, 'Via S. Tiago. Laid up at Malacca in 1690.');
INSERT INTO "voyages" VALUES (1344, '', 1, '', 'HELM', 'Jan Witboom', NULL, NULL, NULL, '1677', NULL, 'Z', 'Z', '1677-03-11', 'Wielingen', '1677-07-05', NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (1345, '', 2, '', 'AFRIKA', 'Jakob van der Kamme', 1100, NULL, '1673', NULL, NULL, 'R', 'A', '1677-04-12', 'Texel', '1677-07-16', '1677-07-31', true, '1677-09-23', 'Batavia', 5721, 'Acc. to Daghreg. 1677 the ship departed from Goeree. Via S. Tiago (16 till 20-05-1677).');
INSERT INTO "voyages" VALUES (1346, '', 2, '', 'EILAND MAURITIUS', 'Kornelis Adriaansz. de Gilde van Schiedam', 756, 'pinas', '1672', NULL, NULL, 'D', 'D', '1677-04-12', 'Goeree', '1677-07-18', '1677-07-31', true, '1677-09-16', 'Batavia', 5747, 'Via S. Tiago. (16 till 20-05-1677).');
INSERT INTO "voyages" VALUES (1347, '', 1, '', 'STRIJEN', NULL, 634, 'fluit', '1676', NULL, NULL, 'R', 'R', '1677-04-12', 'Goeree', '1678-06-27', '1678-07-09', true, '1678-09-10', 'Batavia', 5767, 'Acc. to Daghreg. 1678 the ship departed on 07-12-1677; 
acc. to
K.A. 3991 on 23-02-1678. Via Wight. One soldier deserted at the Cape.');
INSERT INTO "voyages" VALUES (1348, '', 1, '', 'SINT ANDRIES', 'Siewert Klaasz.', 604, 'fluit? jacht?', NULL, NULL, '1677', 'A', 'A', '1677-05-26', 'Texel', '1678-01-02', '1678-02-10', true, '1678-05-15', 'Batavia', 5732, 'The number of shipowner''s men is unknown. Via Cape Verde and S. Paulo de Luanda. One soldier 
deserted. Acc. to 1678 departure Daghreg. from the Cape on 07-02-1678. The master was succeeded by Hendrik Plechtman.');
INSERT INTO "voyages" VALUES (1349, '', 1, '', 'BLOEMENDAAL', 'Heije Arendsz. de Wilde', 588, NULL, NULL, NULL, '1677', 'A', 'A', '1677-05-26', 'Texel', '1677-09-21', '1677-09-30', true, '1677-12-26', 'Batavia', 5715, 'The number of shipowner''s men is unknown.');
INSERT INTO "voyages" VALUES (1350, '', 1, '', 'KRIJGSMAN', 'Gijsbert Willemsz.', 356, 'fluit', NULL, NULL, '1677', 'A', 'A', '1677-05-26', 'Texel', '1677-09-20', '1677-09-30', true, '1677-12-04', 'Batavia', 5716, 'About 30 seafarers were the shipowner''s men. Via S. Tiago.');
INSERT INTO "voyages" VALUES (1351, '', 4, '', 'OOSTENBURG', 'Jurriaan Goversblom', 840, 'pinas? fluit?', '1667', NULL, NULL, 'A', 'A', '1677-05-26', 'Texel', '1677-09-19', '1677-10-02', true, '1677-12-26', 'Colombo', 5750, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1352, '', 4, '', 'TERNATE', 'Michiel van der Buis', 1014, 'pinas', '1668', NULL, NULL, 'A', 'A', '1677-05-26', 'Texel', '1677-09-19', '1677-10-02', true, '1677-12-28', 'Batavia', 5741, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1353, '', 4, '', 'VOORZICHTIGHEID', 'Jansz.', 636, 'fluit', '1667', NULL, NULL, 'H', 'A', '1677-05-26', 'Texel', '1677-09-20', '1677-10-02', true, '1677-12-26', 'Batavia', NULL, 'Laid up and sold on 30-12-1683.');
INSERT INTO "voyages" VALUES (1354, '', 1, '', 'CHINA', 'Meindert Pruis', 1124, NULL, '1676', NULL, NULL, 'A', 'A', '1677-09-16', 'Texel', '1678-02-20', '1678-03-17', true, '1678-06-06', 'Batavia', 5743, NULL);
INSERT INTO "voyages" VALUES (1355, '', 1, '', 'LAND VAN SCHOUWEN', 'Reinier Reiniersz.', 1140, NULL, '1676', NULL, NULL, 'Z', 'Z', '1677-09-17', 'Texel', '1678-02-20', '1678-03-17', true, '1678-06-06', 'Batavia', 5736, NULL);
INSERT INTO "voyages" VALUES (1356, '', 2, '', 'SNOEPER', 'Barend Fokkesz.', NULL, 'galjoot', NULL, NULL, '1677', 'A', 'A', '1677-11-03', 'Texel', '1678-01-21', '1678-01-30', true, '1678-04-10', 'Batavia', 5718, NULL);
INSERT INTO "voyages" VALUES (1357, '', 2, '', 'EUROPA', NULL, 1140, NULL, '1671', NULL, NULL, 'A', 'A', '1678-02-06', 'Texel', '1678-05-16', '1678-06-05', true, '1678-08-02', 'Batavia', 5734, 'departure from Texel: 07-12-1677. At the Cape 6 seafarers and 4 soldiers were sent home.');
INSERT INTO "voyages" VALUES (1358, '', 1, '', 'JONAS', NULL, NULL, 'fluit', NULL, NULL, '1677/8', 'A', 'A', '1678-02-06', 'Texel', '1678-05-12', '1678-05-16', true, '1678-07-10', 'Batavia', 5725, 'Original departure from Texel: 07-12-1677. One soldier was lost during the voyage.');
INSERT INTO "voyages" VALUES (1359, '', 2, '', 'ROEMERSWAAL', 'Jan Wittebol', 524, 'pinas? fluit?', '1674', NULL, NULL, 'Z', 'A', '1677-12-07', 'Texel', '1678-04-10', '1678-04-25', true, '1678-07-02', 'Batavia', NULL, 'The ship was laid up and sold at Batavia. 28-06-1685.');
INSERT INTO "voyages" VALUES (1360, '', 2, '', 'GELE BEER', NULL, 412, 'fluit', NULL, '1677/8', NULL, 'A', 'A', '1678-02-05', 'Texel', '1678-05-22', '1678-07-03', true, '1678-09-11', 'Batavia', 5753, '37 seafarers were the shipowner''s men. Via Saldanha Bay.');
INSERT INTO "voyages" VALUES (1361, '', 3, '', 'DEN BRIEL', NULL, 766, NULL, '1671', NULL, NULL, 'D', 'H', '1678-02-05', 'Texel', '1678-05-22', '1678-06-06', true, '1678-08-22', 'Batavia', 5719, 'Via Saldanha Bay.');
INSERT INTO "voyages" VALUES (1362, '', 1, '', 'ELISABETH', NULL, 260, 'galjoot? pinas?', NULL, '1677/8', NULL, 'A', 'A', '1678-02-05', 'Texel', '1678-07-15', '1678-10-15', true, '1679-07-14', 'Batavia', NULL, 'Via Fernando de Noronha (02-06-1678), Madagascar (114 slaves bought for the west coast of Sumatra; 51 died), Mauritius, Magalage and the west coast of Sumatra. The ship was laid up or wrecked in 1685.');
INSERT INTO "voyages" VALUES (1363, '', 2, '', 'JUFFROUW MARIA', NULL, 440, 'fluit', NULL, NULL, '16778', 'A', 'A', '1678-02-05', 'Texel', '1678-05-14', '1678-06-05', true, '1678-07-28', 'Batavia', 5727, 'The number of shipowner''s men is unknown.');
INSERT INTO "voyages" VALUES (1364, '', 4, '', 'TIDORE', NULL, 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1678-02-07', 'Texel', '1678-05-21', '1678-06-09', true, '1678-08-20', 'Batavia', 5737, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (1365, '', 4, '', 'PRINS WILLEM HENDRIK', 'Manuel van Keulen', 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1678-02-07', 'Texel', '1678-05-21', '1678-06-09', true, '1678-11-17', 'Batavia', 5745, 'Via S. Vincente. The ship sailed to Ceylon because of leakage and the loss of topmasts (28-08 till 26-10-1678), where 8 seafarers and 63 soldiers left the ship and 37 seafarers, 11 soldiers and 5 passengers came on board.');
INSERT INTO "voyages" VALUES (1366, '', 4, '', 'DELFSHAVEN', 'Simon van den Berg van Schiedam', 654, 'fluit', '1668', NULL, NULL, 'D', 'D', '1678-04-07', 'Texel', NULL, NULL, false, '1678-08-27', 'Batavia', NULL, 'No call at the Cape because of storm.');
INSERT INTO "voyages" VALUES (1367, '', 2, '', 'HELLEVOETSLUIS', NULL, 714, 'pinas', '1671', NULL, NULL, 'R', 'R', '1678-04-07', 'Texel', '1678-06-21', '1678-07-03', true, '1678-09-10', 'Batavia', 5723, 'Acc. to Daghreg. 1678 the ship left Texel on 28-04-1678.');
INSERT INTO "voyages" VALUES (1368, '', 3, '', 'WAPEN VAN ALKMAAR', NULL, 892, 'pinas', '1671', NULL, NULL, 'E', 'A', '1678-05-21', 'Texel', '1678-10-17', '1678-11-03', true, '1679-01-13', 'Batavia', 5742, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1369, '', 1, '', 'HORSTERMEER', NULL, 310, 'fluit? kat?', '1677', NULL, NULL, 'A', 'A', '1678-05-21', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ship was wrecked in the South Atlantic.');
INSERT INTO "voyages" VALUES (1370, '', 4, '', 'BURCHT VAN LEIDEN', NULL, 1040, NULL, '1667', NULL, NULL, 'A', 'A', '1678-05-21', 'Texel', '1678-10-05', '1678-10-23', true, '1679-01-06', 'Batavia', 5744, 'Via S. T iago. During the voyage 4 seafarers were lost. Unknown number of passengers on board.');
INSERT INTO "voyages" VALUES (1371, '', 1, '', 'NAARDERMEER', NULL, 314, 'kat', '1677', NULL, NULL, 'A', 'A', '1678-05-21', 'Texel', '1678-10-16', '1678-11-03', true, NULL, 'Ceylon', NULL, '1690. Laid up at Batavia in 1690.');
INSERT INTO "voyages" VALUES (1372, '', 4, '', 'GEKROONDE VREDE', NULL, 730, NULL, '1667', NULL, NULL, 'E', 'E', '1678-05-21', 'Texel', '1678-10-01', '1678-10-14', true, '1678-12-14', 'Batavia', NULL, 'Via S. Tiago. Laid up and sold at Batavia on 19/29-08-1684.');
INSERT INTO "voyages" VALUES (1373, '', 1, '', 'JUFFROUW KORNELIA', NULL, 316, 'fluit', NULL, NULL, '16778', 'A', 'A', '1678-09-17', 'Texel', '1679-03-15', '1679-03-24', true, '1679-07-25', 'Ceylon', 5731, 'Via Cape Verde and Tuticorin (08-07-1679).');
INSERT INTO "voyages" VALUES (1374, '', 1, '', 'ROMEIN', 'Jan Molenaar', 450, 'fluit? hekboot?', NULL, NULL, '16778', 'A', 'A', '1678-09-17', 'Texel', '1679-02-10', '1679-02-20', true, '1679-06-02', 'Batavia', 5730, 'The seafarers were shipowner''s men.');
INSERT INTO "voyages" VALUES (1375, '', 2, '', 'KORTGENE', NULL, 1139, NULL, '1675', NULL, NULL, 'Z', 'Z', '1678-12-11', 'Wielingen', '1679-05-25', '1679-06-15', true, '1679-08-21', 'Batavia', 5761, 'Via S. Vincente. One seaman deserted. One stowawav became a soldier.');
INSERT INTO "voyages" VALUES (1376, '', 3, '', 'AZIE', NULL, 1140, NULL, '1671', NULL, NULL, 'A', 'A', '1678-12-19', 'Texel', '1679-04-20', '1679-05-22', true, '1679-07-25', 'Batavia', 5733, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1377, '', 2, '', 'MIDDELBURG', NULL, 950, NULL, '1675', NULL, NULL, 'Z', 'Z', '1678-12-19', 'Wielingen', '1679-04-12', '1679-05-31', true, '1679-08-01', 'Ceylon', NULL, 'Via Sierra Leone.');
INSERT INTO "voyages" VALUES (1378, '', 5, '', 'HOLLANDSE TUIN', NULL, 1210, NULL, '1665', NULL, NULL, 'A', 'A', '1678-12-19', 'Texel', '1679-04-28', '1679-05-22', true, '1679-07-27', 'Batavia', 5758, 'Via S. Tiago (2 seafarers deserted). At the Cape one seaman went over to the AZIE (1376).');
INSERT INTO "voyages" VALUES (1379, '', 5, '', 'WAPEN VAN GOES', NULL, 671, NULL, '1668', NULL, NULL, 'Z', 'Z', '1679-03-05', 'Wielingen', '1679-06-14', '1679-06-26', true, '1679-08-21', 'Batavia', NULL, 'Via S. Tiago, September 1686. Laid up and sold at Bantam in September 1686.');
INSERT INTO "voyages" VALUES (1380, '', 3, '', 'KOEWERVE', NULL, 698, 'pinas', '1672', NULL, NULL, 'Z', 'A', '1679-05-21', 'Texel', '1679-08-30', '1679-09-16', true, '1679-11-19', 'Batavia', NULL, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1381, '', 5, '', 'VRIJE ZEE', NULL, 846, 'pinas', '1667', NULL, NULL, 'D', 'A', '1679-05-21', 'Texel', '1679-10-12', '1679-10-29', true, '1680-01-15', 'Batavia', 5752, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1382, '', 2, '', 'POULERON', 'Adriaan Kornelisz. Muts van Delfshaven', 638, 'jacht', '1669', NULL, NULL, 'Z', 'D', '1679-06-01', 'Goeree', '1679-10-15', '1679-10-28', true, '1680-01-15', 'Batavia', NULL, 'Via Saldanha Bay. Laid up at Batavia on 03-01-1688.');
INSERT INTO "voyages" VALUES (1383, '', 5, '', 'WAPEN VAN ZIERIKZEE', NULL, 1094, NULL, '1667', NULL, NULL, 'Z', 'Z', '1679-06-01', 'Wielingen', '1679-09-23', '1679-10-07', true, '1679-12-02', 'Batavia', NULL, 'One seaman was lost during the voyage. Laid up and sold at Batavia in April 1687.');
INSERT INTO "voyages" VALUES (1384, '', 5, '', 'HUIS TE VELSEN', NULL, 750, NULL, '1667', NULL, NULL, 'A', 'E', '1679-06-07', 'Texel', '1679-09-22', NULL, true, '1679-12-14', 'Batavia', NULL, 'Via S. Tiago, where 4 seafarers deserted. Wrecked on a reef (off Ternate?) on 22-05-1682.');
INSERT INTO "voyages" VALUES (1385, '', 5, '', 'VRIJHEID', NULL, 1210, NULL, '1666', NULL, NULL, 'A', 'A', '1679-08-02', 'Texel', '1679-12-02', '1679-12-17', true, '1680-03-21', 'Batavia', 5759, 'Acc. to K.A. 1231 only one passenger on board. The passenger for I and VI was either 3 or 4.');
INSERT INTO "voyages" VALUES (1386, '', 3, '', 'HENDRIK MAURITS', 'Stoffel de Vos', 1194, NULL, '1673', NULL, NULL, 'Z', 'Z', '1680-02-15', 'Goeree', NULL, NULL, false, '1680-09-02', 'Batavia', 5749, 'Acc. to Daghreg. 1680 the ship departed from Veere on 25/26-02-1680. Via S. Tiago, where 2 soldiers deserted. No call at the Cape because of a storm.');
INSERT INTO "voyages" VALUES (1387, '', 4, '', 'DEN BRIEL', 'Theunis Andriesz.', 766, NULL, '1671', NULL, NULL, 'D', 'Z', '1680-02-24', 'Wielingen', '1680-06-27', '1680-07-19', true, '1680-09-14', 'Batavia', NULL, 'Acc. to Daghreg. 1680 the ship departed from Veere. Via Plymouth (21 till 31-03-1680) and S. Tiago (27-04-1680), where respectively one and two soldiers deserted. Wrecked at Arrakan on 20-10-1681.');
INSERT INTO "voyages" VALUES (1388, '', 3, '', 'KWARTEL', NULL, 96, 'hoeker', '1672', NULL, NULL, 'A', 'Z', '1680-02-24', 'Wielingen', '1680-06-30', '1681-08-12', true, '1681-10-20', 'Batavia', NULL, 'Via S. Tiago. Stayed at the Cape for service. Laid up at the west coast of Sumatra in 1687.');
INSERT INTO "voyages" VALUES (1389, '', 3, '', 'CEYLON', NULL, 776, NULL, '1673', NULL, NULL, 'A', 'A', '1680-02-26', 'Texel', '1680-07-12', '1680-07-21', true, NULL, NULL, NULL, 'Wrecked between the Cape and India on 36''S. in August 1680. All hands lost.');
INSERT INTO "voyages" VALUES (1390, '', 1, '', 'JAMBY', 'Leendert Maas', 336, 'pinas? jacht?', '1679', NULL, NULL, 'A', 'A', '1680-02-26', 'Texel', '1680-07-09', '1680-07-21', true, '1680-09-22', 'Batavia', 5802, 'Via Wight (departure on 30-03-1680), where 6 soldiers and 2 seafarers were enlisted.');
INSERT INTO "voyages" VALUES (1391, '', 1, '', 'NEGOMBO', 'Andries Tertholen', 320, 'pinas? jacht?', '1679', NULL, NULL, 'A', 'A', '1680-02-26', 'Texel', '1680-07-03', '1680-07-21', true, '1680-09-23', 'Batavia', NULL, 'Via Wight (departure on 29-03-1680), one seafarer deserted. laid up at Tuticorin, 1690.');
INSERT INTO "voyages" VALUES (1392, '', 1, '', 'GULDEN WAGEN', 'Kornelis Blankevoort', 300, 'fluit', NULL, '1678/9', NULL, 'A', 'A', '1680-02-26', 'Texel', '1681-03-27', '1681-04-26', true, '1681-07-18', 'Ceylon', 5827, 'Stayed in Lisbon for 6 months. Via Madeira Island and Tuticorin.');
INSERT INTO "voyages" VALUES (1393, '', 2, '', 'HUIS TE ZILVERSTEIN', 'Karsten de Gilde', 1017, NULL, '1674', NULL, NULL, 'A', 'A', '1680-02-26', 'Texel', '1680-06-27', '1680-07-21', true, '1680-09-13', 'Batavia', 5748, 'Via Portland (06 till 29-03-1680) and S. Tiago (02 till 06-05-1680). At the Cape 2 prisoners came on board.');
INSERT INTO "voyages" VALUES (1394, '', 3, '', 'HELLEVOETSLUIS', 'Jan van Velzen', 714, 'pinas', '1671', NULL, NULL, 'R', 'R', '1680-05-03', 'Goeree', '1680-08-28', '1680-09-16', true, '1680-11-27', 'Batavia', NULL, 'Via S. Tiago. Laid up at Ceylon in 1686.');
INSERT INTO "voyages" VALUES (1395, '', 1, '', 'HONSELAARSDIJK', 'Nouters', 722, 'pinas', '1679', NULL, NULL, 'Z', 'Z', '1680-05-04', 'Vlissingen', '1680-09-23', '1680-10-01', true, '1680-12-01', 'Batavia', 5792, 'Via S. Tiago, where 1 seafarer deserted. Via Saldanha Bay. Acc. to Daghreg. 1680 the ship arrived on 30-09-1680 at the Cape.');
INSERT INTO "voyages" VALUES (1396, '', 1, '', 'JAVA', 'Klaas Jansz. Knot', 762, 'pinas', '1678', NULL, NULL, 'A', 'E', '1680-05-11', 'Texel', '1680-09-20', '1680-10-01', true, '1680-12-01', 'Batavia', 5751, 'Acc. to Daghreg. 1680 the ship arrived at the Cape on 30-09-1680.');
INSERT INTO "voyages" VALUES (1397, '', 3, '', 'AFRIKA', 'Maarten Wildvank', 1100, NULL, '1673', NULL, NULL, 'R', 'A', '1680-05-26', 'Goeree', '1680-09-18', '1680-10-01', true, '1680-11-18', 'Batavia', 5755, 'Acc. to Daghreg. 1680 the ship arrived at the Cape on 30-09-1680.');
INSERT INTO "voyages" VALUES (1398, '', 3, '', 'AMERIKA', 'Pieter Hasius+', 1002, 'pinas', '1674', NULL, NULL, 'H', 'H', '1680-06-01', 'Texel', '1681-01-25', '1681-02-22', true, '1681-06-02', 'Batavia', NULL, 'Via Saldanha Bay (09-12 till 24-01-1681); 
acc. to Daghreg. 1681 24 men died before the Cape.');
INSERT INTO "voyages" VALUES (1399, '', 1, '', 'KRAANVOGEL', 'Ommeken Jansz.', 180, 'pinas? jacht?', '1680', NULL, NULL, 'A', 'A', '1680-06-01', 'Texel', '1680-12-01', '1680-12-19', true, '1681-03-31', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1400, '', 1, '', 'MEREL', NULL, 160, 'fluit', '1679', NULL, NULL, 'A', 'A', '1680-06-01', 'Texel', '1680-12-30', '1681-02-22', true, '1681-06-02', 'Batavia', NULL, 'Via Cape Lopez Gonsalvez. The ship was laid up at Batavia in 1693.');
INSERT INTO "voyages" VALUES (1401, '', 1, '', 'NAALDWIJK', 'Jan Zeeman', 332, 'pinas? jacht?', '1680', NULL, NULL, 'A', 'A', '1680-06-01', 'Texel', '1680-12-07', '1680-12-19', true, '1681-03-20', 'Batavia', NULL, 'Via Cape Lopez Gonsalvez. The ship was wrecked on the Ganges in Bengal in 1688.');
INSERT INTO "voyages" VALUES (1402, '', 1, '', 'ZEIST', 'Jan Pietersz. Rood', 338, 'pinas? jacht?', '1680', NULL, NULL, 'Z', 'Z', '1680-06-30', 'Wielingen', '1680-11-30', '1680-12-10', true, '1681-02-21', 'Batavia', NULL, 'Via S. Tiago and Saldanha Bay. The ship was laid up at Ceylon in 1694.');
INSERT INTO "voyages" VALUES (1403, '', 3, '', 'SUMATRA', 'Jakob Karstensz.+', 738, 'pinas', '1673', NULL, NULL, 'A', 'A', '1680-11-09', 'Texel', '1681-03-19', '1681-04-07', true, '1681-06-10', 'Batavia', NULL, 'Via Torbay (24 till 30-11-1680). Dirk Pijl succeeded Jakob Karstensz. (16-11-1680).');
INSERT INTO "voyages" VALUES (1404, '', 2, '', 'LAND VAN SCHOUWEN', 'Adriaan Pietersz.', 1140, NULL, '1676', NULL, NULL, 'Z', 'Z', '1680-11-17', 'Wielingen', '1681-03-17', '1681-04-07', true, '1681-06-21', 'Batavia', 5757, NULL);
INSERT INTO "voyages" VALUES (1405, '', 1, '', 'BAARN', NULL, 206, 'fluit', '1680', NULL, NULL, 'A', 'A', '1680-12-19', 'Texel', '1681-05-23', '1681-08-03', true, NULL, 'Ceylon?', NULL, 'up at Bengal in 1694.');
INSERT INTO "voyages" VALUES (1406, '', 1, '', 'CIVETKAT', NULL, 290, 'kat', '1679', NULL, NULL, 'A', 'A', '1680-12-19', 'Texel', '1681-05-24', '1681-06-13', true, '1681-09-12', 'Ceylon', NULL, 'Via S. Tiago and Tuticorin (12-08-1681). Laid up at Batavia in December 1696.');
INSERT INTO "voyages" VALUES (1407, '', 1, '', 'SILLIDA', NULL, 324, 'pinas? jacht?', '1680', NULL, NULL, 'A', 'A', '1680-12-22', 'Texel', '1681-05-10', '1681-07-03', true, '1682-08-23', 'Batavia', 5819, 'Via S.Tiago. Orders were received for a slave trade to Madagascar and to bring the slaves to the west coast of Sumatra. Via Ceylon (24-11 till 05-12-1681) and Sumatra. Acc to Daghreg. 1682 the ship arrived at Batavia on 02-09-1682.');
INSERT INTO "voyages" VALUES (1408, '', 3, '', 'MAKASSAR', 'Hendrik Bontekraai', 1014, 'pinas', '1671', NULL, NULL, 'A', 'A', '1681-02-01', 'Texel', '1681-05-15', '1681-06-12', true, '1681-09-12', 'Batavia', NULL, '(1407) embarked. Laid up and sold at Batavia on 20-11-1688.');
INSERT INTO "voyages" VALUES (1409, '', 2, '', 'HUIS TE MERWEDE', 'Kornelis Starrenburg', 882, 'pinas', '1674', NULL, NULL, 'R', 'A', '1681-02-01', 'Wielingen', '1681-05-10', '1681-05-22', true, '1681-07-17', 'Batavia', NULL, 'Laid up in 1687.');
INSERT INTO "voyages" VALUES (1410, '', 1, '', 'WOUD', 'Jan Thomasz. Pot', 90, 'hoeker', '1680', NULL, NULL, 'R', 'R', '1681-03-19', 'Maas', '1681-08-19', '1681-09-04', true, '1681-11-19', 'Batavia', NULL, 'Via Duins, Plymouth (7 days) and Saldanha Bay (7 days).');
INSERT INTO "voyages" VALUES (1411, '', 1, '', 'ENGELENBURG', 'Sijbrand Theunisz.', 364, 'kat', '1680', NULL, NULL, 'H', 'H', '1681-03-28', 'Texel', '1681-07-22', '1681-08-12', true, '1681-10-14', 'Batavia', NULL, 'Laid up at Batavia, January 1694.');
INSERT INTO "voyages" VALUES (1412, '', 5, '', 'TIDORE', 'Evert van Gelder', 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1681-03-28', 'Vlissingen', '1681-07-20', '1681-08-12', true, '1681-10-21', 'Batavia', 5774, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1413, '', 2, '', 'SCHIELAND', 'Gijsbert Willemsz. Boele van Delfshaven', 710, NULL, '1674', NULL, NULL, 'D', 'D', '1681-05-09', 'Goeree', '1681-09-27', '1681-10-15', true, '1682-01-03', 'Batavia', 5772, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1414, '', 2, '', 'WAPEN VAN THOLEN', 'Jan Witboom', 698, 'pinas', '1672', NULL, NULL, 'Z', 'Z', '1681-05-27', 'Wielingen', '1681-10-09', '1681-11-01', true, '1682-01-24', 'Batavia', NULL, 'Via S. Vincente; laid up at Batavia in 1690.');
INSERT INTO "voyages" VALUES (1415, '', 3, '', 'EUROPA', 'Jan Kadul', 1140, NULL, '1671', NULL, NULL, 'A', 'A', '1681-05-31', 'Texel', '1681-09-28', '1681-10-15', true, '1681-12-13', 'Batavia', 5769, NULL);
INSERT INTO "voyages" VALUES (1416, '', 5, '', 'TERNATE', 'Jan Gerritsz.', 1014, 'pinas', '1668', NULL, NULL, 'A', 'A', '1681-05-31', 'Texel', '1681-09-27', '1681-10-16', true, '1681-12-30', 'Batavia', NULL, 'The ship struck on the rocks of Tristan da Cunha, but without damage; because of leakage near Sunda Strait the ship called at the Wijnkoopsbergen. Laid up and sold at Batavia on 04-07-1684.');
INSERT INTO "voyages" VALUES (1417, '', 1, '', 'ZUID BEVELAND', 'Kornelis de Jonge', 518, 'pinas? jacht?', '1680', NULL, NULL, 'Z', 'Z', '1681-07-01', 'Wielingen', '1681-12-07', '1681-12-26', true, '1682-03-04', 'Batavia', 5834, 'Acc. to Daghreg. 1682 the ship departed from the Wielingen on 01-06-1681. Via S. Tiago, where 4 seafarers and 2 soldiers deserted.');
INSERT INTO "voyages" VALUES (1418, '', 1, '', 'GOUDESTEIN', 'Jan Hendriksz. Boon', 843, 'pinas', '1679', NULL, NULL, 'A', 'A', '1681-07-16', 'Texel', '1681-12-24', '1682-01-09', true, '1682-05-04', 'Batavia', 5770, 'Via 
S. Tiago.Acc. to Daghreg. 1682 the ship arrived at Tanara on 04-04-1682. 30 soldiers were taken on board.');
INSERT INTO "voyages" VALUES (1419, '', 1, '', 'WAVEREN', 'Reinier de Groot', 488, 'fluit', '1680', NULL, NULL, 'A', 'A', '1681-07-16', 'Texel', '1681-11-28', '1681-12-09', true, '1682-03-16', 'Batavia', NULL, 'Via S. Tiago. At Bantam 70 soldiers embarked. A fire in the galley during a voyage from Bengal to Batavia destroyed the ship on 20-12-1689.');
INSERT INTO "voyages" VALUES (1420, '', 4, '', 'AZIE', 'Kornelis Meppel', 1140, NULL, '1671', NULL, NULL, 'A', 'E', '1681-08-18', 'Texel', '1682-01-14', '1682-02-08', true, '1682-05-23', 'Batavia', 5768, 'Via S. Tiago, where 4 seafarers deserted. The master Kornelis Meppel was disrated; 2 seafarers became soldiers. One child was born during the voyage.');
INSERT INTO "voyages" VALUES (1421, '', 5, '', 'BURCHT VAN LEIDEN', NULL, 1040, NULL, '1667', NULL, NULL, 'A', NULL, '1681-11-16', NULL, '1682-03-04', NULL, true, NULL, NULL, 5763, 'transferred to this ship, which returned to patria. Rijklof van Goens was succeeded by Jakob Barendsz. Sonbeek.');
INSERT INTO "voyages" VALUES (1422, '', 1, '', 'ADRICHEM', 'Adriaan Vos', 486, 'fluit', '1680', NULL, NULL, 'A', 'A', '1682-02-09', 'Texel', '1682-06-21', '1682-07-10', true, '1682-09-17', 'Batavia', 5776, NULL);
INSERT INTO "voyages" VALUES (1423, '', 2, '', 'CHINA', 'Doede Star', 1124, NULL, '1676', NULL, NULL, 'A', 'A', '1682-02-09', 'Texel', '1682-06-18', '1682-07-10', true, '1682-09-15', 'Batavia', 5764, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1424, '', 1, '', 'DRAKESTEIN', 'Kornelis Poort', 256, 'fluit? kat?', '1680', NULL, NULL, 'A', 'A', '1682-02-09', 'Texel', '1682-06-18', '1682-06-27', true, '1682-08-31', 'Batavia', NULL, 'at Batavia in 1697.');
INSERT INTO "voyages" VALUES (1425, '', 1, '', 'EEMLAND', 'Kornelis Jansz. Grolts', 398, 'pinas? jacht?', '1680', NULL, NULL, 'A', 'A', '1682-02-09', 'Texel', '1682-06-11', '1682-07-10', true, '1683-03-23', 'Batavia', 5817, '(16-07 till 27 -09-1682) where 241 slaves were taken aboard. Via Cochin (23 till 31-11-1682): 30 seaf. and 1 sold. disembarked, 5 seaf. and 2 sold. embarked. Via Padang (arrival: 24-01-1683): 6 seaf. disembarked, and via Padang on the west coast of Sumatra (05-03-1683).');
INSERT INTO "voyages" VALUES (1426, '', 3, '', 'BLAUWE HULK', 'Klaas Wijnberg', 744, 'pinas', '1673', NULL, NULL, 'E', 'H', '1682-02-09', 'Texel', '1682-06-08', '1682-06-27', true, '1682-09-09', 'Batavia', NULL, 'Via S. Tiago because of leakage (23 till 28-03-1682). Serious damage after a heavy storm from 22 till 25-07-1682.');
INSERT INTO "voyages" VALUES (1427, '', 2, '', 'JAVA', 'Hendrik Pronk', 762, 'pinas', '1678', NULL, NULL, 'A', 'A', '1682-02-09', 'Texel', '1682-06-17', '1682-07-10', true, '1682-09-11', 'Batavia', 5770, 'Via S. Tiago (24 till 29-03-1682). The passengers who embarked at the Cape were survivors of the English ship JOANNA. One soldier deserted.');
INSERT INTO "voyages" VALUES (1428, '', 1, '', 'RAAP', NULL, 60, 'hoeker? jachtje?', '1681', NULL, NULL, 'H', 'H', '1682-02-09', 'Texel', '1682-11-20', '1682-12-26', true, '1683-04-18', 'Ceylon', NULL, 'Via S. Tiago, Trinidad (departure 10-07-1682) and the Bahia de Todos os Santos (20-07 till 19-08-1682). Laid up at Ternate in 1694.');
INSERT INTO "voyages" VALUES (1429, '', 1, '', 'WESTBROEK', 'Jan Gelein', 253, 'fluit? kat?', '1681', NULL, NULL, 'A', 'A', '1682-02-09', 'Texel', '1682-06-30', '1682-07-16', true, '1682-09-17', 'Batavia', 5779, 'Via Maio Island. The passengers who embarked at the Cape were survivors of the English ship JOANNA.');
INSERT INTO "voyages" VALUES (1430, '', 3, '', 'HUIS TE ZILVERSTEIN', 'Karsten de Gilde', 1017, NULL, '1674', NULL, NULL, 'A', 'A', '1682-02-09', 'Texel', '1682-06-07', '1682-06-27', true, '1682-09-10', 'Batavia', 5799, 'Via S. Tiago because of leakage (24 till 29-03-1682). 2 seafarers went missing during the voyage.');
INSERT INTO "voyages" VALUES (1431, '', 4, '', 'HENDRIK MAURITS', 'Willem Faats', 1194, NULL, '1673', NULL, NULL, 'Z', 'Z', '1682-03-13', 'Wielingen', NULL, NULL, false, '1682-07-31', 'Batavia', 5765, 'Via Duins and S. Tiago. (3 days).');
INSERT INTO "voyages" VALUES (1432, '', 1, '', 'SCHIEBROEK', 'Kornelis Valkenburg', 250, 'jachtje', '1681', NULL, NULL, 'Z', 'Z', '1682-03-13', 'Wielingen', '1682-06-28', '1682-07-16', true, '1682-09-15', 'Batavia', 5771, 'the English ship JOANNA.');
INSERT INTO "voyages" VALUES (1433, '', 3, '', 'GELE BEER', 'Herman Beets', 412, 'fluit', NULL, '1677/8', NULL, 'Z', 'A', '1682-03-27', 'Wielingen', '1682-08-16', '1682-09-07', true, '1682-12-07', 'Batavia', NULL, 'arrived at the Cape on 06-08-1682. The ship was wrecked west of Sumatra in 1684.');
INSERT INTO "voyages" VALUES (1434, '', 4, '', 'WAPEN VAN ALKMAAR', NULL, 892, 'pinas', '1671', NULL, NULL, 'E', 'A', '1682-05-03', 'Texel', '1682-10-10', '1682-11-25', true, '1683-02-13', 'Batavia', 5783, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (1435, '', 2, '', 'SPAARNWOUDE', 'Evert Hendriksz. de Beuken', 480, 'fluit', '1676', NULL, NULL, 'A', 'A', '1682-05-03', 'Texel', '1683-01-09', '1683-01-29', true, '1683-05-05', 'Batavia', NULL, 'Via S. Tiago. It took 3 months to pass the Equator. Called at the Gulf of Guinea. Via Loanga, S. Paulo and Cape Lopez Gonsalvez.');
INSERT INTO "voyages" VALUES (1436, '', 5, '', 'OOSTENBURG', NULL, 840, 'pinas? fluit?', '1667', NULL, NULL, 'A', 'A', '1682-05-07', 'Texel', '1682-10-10', '1682-11-14', true, '1683-01-27', 'Batavia', 5786, 'Acc. to K.A. 3995 the ship departed from Texel on 03-05-1682.
Via S. Tiago.');
INSERT INTO "voyages" VALUES (1437, '', 6, '', 'VRIJE ZEE', NULL, 846, 'pinas', '1667', NULL, NULL, 'D', 'A', '1682-05-07', 'Texel', '1682-10-12', '1682-11-14', true, '1683-01-27', 'Batavia', 5788, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (1438, '', 1, '', 'PRINSELAND', 'Gerrit Kornelisz. Kriek van Delfshaven', 710, 'fluit', '1681', NULL, NULL, 'D', 'D', '1682-05-18', 'Goeree', '1682-10-21', '1682-11-14', true, '1683-01-27', 'Batavia', 5795, 'Acc. to K.A. 1261 the ship departed from Goeree on 07-05-1682.
Via S. Tiago.');
INSERT INTO "voyages" VALUES (1439, '', 1, '', 'SINT MAARTENSDIJK', NULL, 352, 'pinas? jacht?', '1681', NULL, NULL, 'Z', 'Z', '1682-05-21', 'Wielingen', '1682-10-21', '1682-11-25', true, '1683-02-21', 'Batavia', 5803, 'Via S. Tiago. 3 seafarers deserted.');
INSERT INTO "voyages" VALUES (1440, '', 1, '', 'STAVENISSE', 'Jan Kouwenburg', 544, 'fluit', '1681', NULL, NULL, 'Z', 'Z', '1682-05-21', 'Wielingen', '1682-10-21', '1682-11-14', true, '1683-01-23', 'Batavia', 5778, 'Via S. Tiago, where 2 soldiers deserted.');
INSERT INTO "voyages" VALUES (1441, '', 3, '', 'EILAND MAURITIUS', NULL, 756, 'pinas', '1672', NULL, NULL, 'D', 'R', '1682-07-16', 'Goeree', '1682-11-17', '1682-11-25', true, '1683-02-09', 'Batavia', 5785, NULL);
INSERT INTO "voyages" VALUES (1442, '', 1, '', 'PURMER', 'Willem Hagedoorn', 582, 'fregat', '1681', NULL, NULL, 'A', 'A', '1682-10-14', 'Texel', '1683-02-25', '1683-03-08', true, '1683-05-29', 'Ceylon', 5789, 'According to K.A. 3995 departure from Texel 21-10-1682; via S. Tiago and Tuticorin (25-05-1683).');
INSERT INTO "voyages" VALUES (1443, '', 5, '', 'PRINS WILLEM HENDRIK', NULL, 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1682-11-06', 'Texel', '1683-03-01', '1683-03-24', true, '1683-06-12', 'Batavia', 5781, 'Via S. Tiago (12-12 till 18-12-1682 where 2 seafarers deserted. According to K.A. 1171 the ship departed on 06-11-1682 from Goeree and on 15-03-1683 from the Cape.');
INSERT INTO "voyages" VALUES (1444, '', 6, '', 'BURCHT VAN LEIDEN', 'Joost Klarebout', 1040, NULL, '1667', NULL, NULL, 'A', 'Z', '1682-12-14', 'Wielingen', '1683-05-13', '1683-05-21', true, '1683-07-28', 'Batavia', 5784, 'Via Duins. Via S. Tiago (arrival on 04-03-1683) where 2 seafarers deserted.');
INSERT INTO "voyages" VALUES (1445, '', 1, '', 'GAASPERDAM', 'Jan Beste Bitter', 312, 'pinas? jacht?', '1681', NULL, NULL, 'A', 'A', '1682-12-18', 'Texel', '1683-05-20', '1683-05-26', true, '1683-08-13', 'Batavia', NULL, 'Via England.');
INSERT INTO "voyages" VALUES (1446, '', 1, '', 'HOGERGEEST', NULL, 222, 'pinas? jacht?', '1681', NULL, NULL, 'A', 'A', '1682-12-18', 'Texel', '1683-05-11', '1683-07-06', true, '1686-04-13', 'Batavia', 5880, 'west coast of Sumatra where the ship brought slaves (108 out of 274 died). The ship stayed there from 27-06-1684 till 28-06-1685.');
INSERT INTO "voyages" VALUES (1447, '', 3, '', 'LAND VAN SCHOUWEN', '...... Barkens', 1140, NULL, '1676', NULL, NULL, 'Z', 'A', '1682-12-18', 'Texel', '1683-04-04', '1683-04-24', true, '1683-07-10', 'Batavia', 5780, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1448, '', 2, '', 'WESTERAMSTEL', NULL, 480, 'fluit', '1676', NULL, NULL, 'A', 'A', '1682-12-18', 'Texel', '1683-05-19', NULL, true, NULL, NULL, 5775, 'Via England. Stayed at the Cape.');
INSERT INTO "voyages" VALUES (1449, '', 6, '', 'HOLLANDSE TUIN', 'David Abrahamsz.', 1210, NULL, '1665', NULL, NULL, 'A', 'Z', '1683-01-18', 'Wielingen', NULL, NULL, false, '1683-10-31', 'Batavia', NULL, 'Sumatra (Padang: arrival on 06-09-1683) where 27 seafarers disembarked.');
INSERT INTO "voyages" VALUES (1450, '', 4, '', 'AFRIKA', 'Klaas de Voogd', 1100, NULL, '1673', NULL, NULL, 'R', 'A', '1683-01-30', 'Goeree', '1683-04-17', '1683-05-16', true, '1683-07-30', 'Batavia', 5782, 'S. Tiago.');
INSERT INTO "voyages" VALUES (1451, '', 1, '', 'PRINSES MARIA', 'Karel de Marville', 1140, NULL, '1682', NULL, NULL, 'Z', 'Z', '1683-04-17', 'Wielingen', '1683-09-08', '1683-09-30', true, '1683-11-30', 'Batavia', 5794, NULL);
INSERT INTO "voyages" VALUES (1452, '', 1, '', 'LANGEWIJK', NULL, 544, 'fluit', '1682', NULL, NULL, 'E', 'E', '1683-04-27', 'Texel', '1684-05-08', '1684-06-08', true, '1684-08-25', 'Batavia', 5800, 'The ship was delayed by much adverse winds and calm. Via Sierra Leone, Cabo Negro in Angola (where 1 soldier deserted) and S. Paulo. The master died.');
INSERT INTO "voyages" VALUES (1453, '', 1, '', 'CASTRICUM', 'Sieuwert de Jong', 623, 'jacht', NULL, '1681/2', NULL, 'A', 'A', '1683-05-09', 'Texel', '1683-09-08', '1683-09-30', true, '1683-11-27', 'Batavia', 5823, 'Via S. Tiago (23-06 till 28-06-1683).');
INSERT INTO "voyages" VALUES (1454, '', 2, '', 'KOEVORDEN', 'Willem Kuit', 820, NULL, '1674', NULL, NULL, 'A', 'A', '1683-05-09', 'Texel', '1683-09-20', '1683-09-30', true, '1683-11-27', 'Batavia', 5798, 'Via S. Tiago (24-06 till 28-06-1683). According to K.A. 1271 the ship arrived on 03-12-1683 at Batavia.');
INSERT INTO "voyages" VALUES (1455, '', 3, '', 'KORTGENE', 'Jansz.', 1139, NULL, '1675', NULL, NULL, 'Z', 'A', '1683-05-09', 'Texel', '1683-09-08', '1683-09-30', true, '1683-11-28', 'Batavia', 5793, NULL);
INSERT INTO "voyages" VALUES (1456, '', 1, '', 'RIDDERSCHAP VAN HOLLAND', 'Jakob Pietersz. Kool', 1138, NULL, '1681', NULL, NULL, 'A', 'A', '1683-05-09', 'Texel', '1683-09-14', '1683-09-30', true, '1683-11-27', 'Batavia', 5787, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1457, '', 1, '', 'HUIS TE NEK', NULL, 690, 'fluit', '1682', NULL, NULL, 'H', 'H', '1683-05-10', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ship was wrecked.');
INSERT INTO "voyages" VALUES (1458, '', 6, '', 'VRIJHEID', 'Jan Jansz. Poot', 1210, NULL, '1666', NULL, NULL, 'A', 'Z', '1683-08-05', 'Wielingen', '1683-11-27', '1683-12-21', true, '1684-03-03', 'Batavia', 5796, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1459, '', 1, '', 'BOVENKARSPEL', 'Jakob Andriesz.', 490, 'fluit', NULL, '1683', NULL, 'E', 'E', '1683-09-01', 'Texel', '1684-02-11', '1684-03-04', true, '1684-06-05', 'Batavia', NULL, 'Batavia in 1696.');
INSERT INTO "voyages" VALUES (1460, '', 1, '', 'DUIFJE', NULL, 90, 'hoeker? bootje?', '1682', NULL, NULL, 'A', 'A', '1683-10-15', 'Texel', '1684-09-19', '1684-10-17', true, '1685-01-17', 'Batavia', 5804, 'deserted).');
INSERT INTO "voyages" VALUES (1461, '', 1, '', 'EMMENES', NULL, 297, 'fluit? kat?', '1682', NULL, NULL, 'A', 'A', '1683-10-15', 'Texel', '1684-04-02', NULL, true, '1684-04-02', 'The Cape', 5790, 'According to Coolhaas VI this ship was called EEMNES (1461, 5790, 1493, 5863, 1608, 5911, 1686). Stayed at the Cape.');
INSERT INTO "voyages" VALUES (1462, '', 1, '', 'GIDEON', 'Pieter Andriesz. Goedland van Delft', 404, 'fluit', NULL, '1683', NULL, 'D', 'D', '1683-11-27', 'Goeree', '1684-03-31', '1684-04-23', true, '1684-06-24', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1463, '', 1, '', 'FAAM', NULL, 477, 'pinas? jacht?', '1682', NULL, NULL, 'A', 'A', '1683-11-28', 'Texel', '1684-05-04', '1684-05-25', true, '1684-08-06', 'Batavia', 5885, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (1464, '', 1, '', 'POST', NULL, 577, 'fluit? hekboot?', NULL, '1682/3', NULL, 'A', 'A', '1683-11-28', 'Texel', '1684-05-04', '1684-05-25', true, '1684-08-05', 'Batavia', 5833, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (1465, '', 2, '', 'ROMEIN', NULL, 450, 'fluit? hekboot?', NULL, NULL, '1682/3', 'A', 'A', '1683-11-28', 'Texel', '1684-04-04', '1684-04-23', true, '1684-07-23', 'Batavia', 5797, '58 to 60 seafarers were the shipowners men. According to K.A. 1283 the ship arrived on 09-04-1684 at the Cape.');
INSERT INTO "voyages" VALUES (1466, '', 1, '', 'JUFFROUW ANNA', 'Jan Molenaar', 457, NULL, NULL, NULL, '1682/3', 'A', 'A', '1683-12-19', 'Texel', '1684-04-04', '1684-04-24', true, '1684-06-21', 'Batavia', 5791, '53 seafarers were the shipowner''s men.');
INSERT INTO "voyages" VALUES (1467, '', 1, '', 'AMSTERDAM', NULL, 479, 'pinas? jacht?', NULL, '1682/3', NULL, 'A', 'A', '1683-12-19', 'Texel', '1684-04-05', '1684-04-23', true, '1684-06-21', 'Batavia', 5801, NULL);
INSERT INTO "voyages" VALUES (1468, '', 2, '', 'KRIJGSMAN', NULL, 356, 'fluit', NULL, '1683', NULL, 'Z', 'Z', '1683-12-20', 'Wielingen', '1684-05-07', '1684-06-08', true, '1684-08-21', 'Batavia', 5818, 'ship arrived on 04-04-1684 at the Cape and departed 23-04. According to K.A. 1293 the ship departed on 23-05-1684 from the Cape.');
INSERT INTO "voyages" VALUES (1469, '', 1, '', 'SCHELDE', NULL, 733, 'jacht', '1682', NULL, NULL, 'Z', 'Z', '1683-12-20', 'Wielingen', '1684-05-01', '1684-05-25', true, '1684-07-27', 'Batavia', 5825, NULL);
INSERT INTO "voyages" VALUES (1470, '', 1, '', 'DEN BRIEL', NULL, 140, 'fluit? hoeker?', '1683', NULL, NULL, 'R', 'R', '1684-01-21', 'Goeree', '1684-06-08', '1684-06-28', true, '1684-09-21', 'Batavia', NULL, 'According to K.A. 1183 the ship arrived on 16-06-1684 at the Cape and departed on 26-06-1684.');
INSERT INTO "voyages" VALUES (1471, '', 2, '', 'SCHIEBROEK', NULL, 250, 'jacht', '1681', NULL, NULL, 'Z', 'Z', '1684-03-09', 'Wielingen', '1684-07-15', '1684-07-22', true, '1684-09-27', 'Colombo', 5815, NULL);
INSERT INTO "voyages" VALUES (1472, '', 1, '', 'SPAARPOT', NULL, 90, 'hoeker? bootje?', '1683', NULL, NULL, 'Z', 'Z', '1684-03-09', 'Wielingen', '1684-06-26', '1684-07-14', true, '1684-12-16', 'Ceylon', NULL, 'Via S. Tiago and Mauritius. The ship was laid up at Ceylon in 1704.');
INSERT INTO "voyages" VALUES (1473, '', 1, '', 'WAAKHOND', 'Pieter Visjager', 90, 'fluit? hoeker?', '1682', NULL, NULL, 'A', 'A', '1684-04-11', 'Texel', '1684-12-03', '1685-01-05', true, '1685-04-15', 'Batavia', NULL, 'Via Cape Lopez, Sao Tome and the west coast of Sumatra. Laid up at Ceylon in 1694.');
INSERT INTO "voyages" VALUES (1474, '', 1, '', 'WATERLAND', 'Meindert Pruis', 1138, NULL, '1683', NULL, NULL, 'A', 'A', '1684-05-06', 'Texel', '1684-10-10', '1685-01-05', true, '1685-04-07', 'Batavia', 5816, 'According to K.A. 1294 the ship departed from Texel on 16-05-1684 and left the Cape on 16-01-1685. Via S. Tiago (arrival on 10-07-1684) where 1 seafarer deserted. Via Saldanha Bay (arrival on 06-10-1684).');
INSERT INTO "voyages" VALUES (1475, '', 3, '', 'WESTERAMSTEL', NULL, 480, 'fluit', '1676', NULL, NULL, 'A', 'A', '1684-05-06', 'Texel', '1684-10-11', '1684-11-03', true, '1685-02-15', 'Ceylon', NULL, 'Via S. Tiago. According to K.A. 1283 the ship departed from the Cape on 30-10-1684.');
INSERT INTO "voyages" VALUES (1476, '', 3, '', 'JAVA', 'Kornelis Sek', 762, 'pinas', '1678', NULL, NULL, 'A', 'H', '1684-05-14', 'Texel', '1684-11-26', '1685-01-05', true, '1685-04-16', 'Batavia', 5805, 'According to K.A. 1297 the ship departed from Texel on 19-05-1684. Via Sao Tome (04-08 till 16-08-1684).');
INSERT INTO "voyages" VALUES (1477, '', 1, '', 'GROTE VISSERIJ', NULL, 638, 'jacht', NULL, '1683', NULL, 'E', 'E', '1684-05-14', 'Texel', '1684-09-23', '1684-10-17', true, '1685-01-05', 'Batavia', 5813, NULL);
INSERT INTO "voyages" VALUES (1478, '', 5, '', 'HENDRIK MAURITS', NULL, 1194, NULL, '1673', NULL, NULL, 'Z', 'Z', '1684-05-17', 'Wielingen', '1684-10-10', '1684-11-03', true, '1685-01-20', 'Batavia', 5808, 'Via S. Tiago (arrival on 19-07-1684) where 3 seafarers deserted. Via Saldanha Bay (arrival on 06-10-1684).');
INSERT INTO "voyages" VALUES (1479, '', 3, '', 'CHINA', NULL, 1124, NULL, '1676', NULL, NULL, 'A', 'A', '1684-05-19', 'Texel', '1684-10-10', '1684-11-03', true, '1685-01-17', 'Batavia', 5807, NULL);
INSERT INTO "voyages" VALUES (1480, '', 2, '', 'GOUDESTEIN', NULL, 843, 'pinas', '1679', NULL, NULL, 'A', 'A', '1684-05-19', 'Texel', '1684-10-11', '1684-11-03', true, '1685-01-17', 'Batavia', 5811, NULL);
INSERT INTO "voyages" VALUES (1481, '', 1, '', 'MAAS', NULL, 790, NULL, '1683', NULL, NULL, 'R', 'R', '1684-06-21', 'Goeree', '1684-10-11', '1684-11-03', true, '1685-01-10', 'Batavia', 5856, 'Via S. Tiago (19-07 till 23-07-1684).');
INSERT INTO "voyages" VALUES (1482, '', 2, '', 'HUIS TE KRONENBURG', 'Pieter Maatsuiker', 700, 'fluit', '1674', NULL, NULL, 'A', 'A', '1684-07-03', 'Texel', '1684-11-29', '1684-12-26', true, '1685-03-30', 'Batavia', 5821, 'Via S. Tiago (23-08 till 28-08-1684).');
INSERT INTO "voyages" VALUES (1483, '', 1, '', 'MONTFOORT', 'Jan Gerlofsz.', 540, 'fluit', NULL, '1682/3', NULL, 'A', 'A', '1684-07-03', 'Texel', '1685-02-06', '1685-02-28', true, '1685-05-12', 'Batavia', NULL, 'Via S. Tiago (arrival on 22-08 and Annabon, arrival on 20-10-1684). According to K.A. 1297 the ship departed from the Cape on 20-02-1685. The ship was taken by the French at Ceylon in 1690.');
INSERT INTO "voyages" VALUES (1484, '', 2, '', 'STRIJEN', NULL, 634, 'fluit', '1676', NULL, NULL, 'R', 'A', '1684-07-03', 'Texel', '1684-10-30', '1684-12-26', true, '1685-03-25', 'Batavia', NULL, 'Via S. Tiago (23-08 till 28-08-1684). According to K.A. 1297 the ship arrived on 20-10-1684 at the Cape and departed on 10-12-1684. Wrecked in the mouth of the Ganges in January 1686.');
INSERT INTO "voyages" VALUES (1485, '', 3, '', 'SCHIELAND', 'Dirk van der Gaag', 710, NULL, '1674', NULL, NULL, 'D', 'D', '1684-08-02', 'Goeree', NULL, NULL, false, '1685-01-23', 'Batavia', 5810, 'Via S. Tiago (arrival on 02-09-1684) where 2 soldiers deserted.');
INSERT INTO "voyages" VALUES (1486, '', 1, '', 'WALENBURG', 'Alexander Simons', 413, 'kat', '1683', NULL, NULL, 'A', 'A', '1684-08-08', 'Texel', '1684-12-16', '1684-12-26', true, '1685-03-30', 'Batavia', NULL, 'till 14-09-1684). Laid up and sold at Batavia in 1699.');
INSERT INTO "voyages" VALUES (1487, '', 1, '', 'EENHOORN', 'Daniel Barendsz.', 749, NULL, '1683', NULL, NULL, 'Z', 'Z', '1684-10-07', 'Wielingen', '1685-04-19', '1685-05-02', true, '1685-07-18', 'Batavia', 5814, 'Via Duins where 11 seafarers and 2 soldiers deserted and 12 seafarers were enlisted, via S. Tiago (11-01 till 20-01-1685) where 3 seafarers and 1 soldier deserted and the Cape where 1 seafarer deserted. According to K.A. 1297 the ship arrived on 10-04-1685 at the Cape.');
INSERT INTO "voyages" VALUES (1488, '', 2, '', 'RIDDERSCHAP VAN HOLLAND', 'Jan Gagenaar', 1138, NULL, '1681', NULL, NULL, 'A', 'A', '1684-12-21', 'Wielingen', '1685-04-07', '1685-05-10', true, '1685-07-17', 'Batavia', 5809, 'At the Cape 1 seafarer deserted. According to K.A. 1297 the ship departed on 19-05-1685 from the Cape.');
INSERT INTO "voyages" VALUES (1489, '', 1, '', 'VOORSCHOTEN', 'Bouwen Huigen van Delfshaven or Jan Stoormans', 558, 'fluit', '1684', NULL, NULL, 'D', 'D', '1684-12-21', 'Goeree', '1685-05-16', '1685-06-17', true, '1685-08-24', 'Batavia', 5832, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1490, '', 2, '', 'WESTBROEK', 'Dirk Zalm', 253, 'fluit? kat?', '1681', NULL, NULL, 'A', 'R', '1684-12-21', 'Maas', NULL, NULL, false, '1685-08-22', 'Batavia', NULL, 'in 1697; according to Daghregister 1697 laid up at Batavia in 1697.');
INSERT INTO "voyages" VALUES (1491, '', 2, '', 'ADRICHEM', NULL, 486, 'fluit', '1680', NULL, NULL, 'A', 'A', '1684-12-24', 'Texel', '1685-04-19', '1685-07-17', true, '1685-10-13', 'Colombo', NULL, 'The ship was laid up at Batavia and sold in 1967.');
INSERT INTO "voyages" VALUES (1492, '', 1, '', 'BANTAM', 'Pieter van Dordrecht', 1138, 'pinas? jacht?', '1683', NULL, NULL, 'A', 'A', '1684-12-24', 'Texel', '1685-04-19', '1685-06-17', true, '1685-08-27', 'Batavia', 5806, 'At the Cape 1 seafarer and 1 soldier deserted.');
INSERT INTO "voyages" VALUES (1493, '', 2, '', 'EMMENES', 'Kornelis Adriaansz.', 297, 'fluit? kat?', '1682', NULL, NULL, 'A', 'A', '1684-12-24', 'Texel', '1685-04-18', '1685-05-02', true, '1685-07-10', 'Batavia', 5863, 'Via S. Tiago (26-01 till 27-01-1685).');
INSERT INTO "voyages" VALUES (1494, '', 2, '', 'PURMER', NULL, 582, 'fregat', '1681', NULL, NULL, 'A', 'A', '1684-12-24', 'Texel', '1685-04-18', '1685-07-16', true, '1685-10-13', 'Colombo', 5868, 'According to K.A. 3999 the ship departed from Texel on 23-11-1684. Via Duins and S. Tiago. On board was Hendrik Adriaan van Reede tot Drakestein, commissaris-generaal.');
INSERT INTO "voyages" VALUES (1495, '', 2, '', 'STAVENISSE', 'Gerrit van Leeuwen', 544, 'fluit', '1681', NULL, NULL, 'Z', 'Z', '1684-12-24', 'Wielingen', '1685-04-19', '1685-05-05', true, '1685-07-26', 'Batavia', 5812, NULL);
INSERT INTO "voyages" VALUES (1496, '', 1, '', 'BOSWIJK', 'Jeroen Rijkwaart', 370, 'pinas? jacht?', '1684', NULL, NULL, 'Z', 'Z', '1685-05-13', 'Wielingen', '1685-10-19', '1685-11-09', true, '1686-02-04', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1497, '', 1, '', 'DEN HELDER', 'Gijsbert van Kraaienstein', 578, 'fluit', '1683', NULL, NULL, 'A', 'A', '1685-05-13', 'Texel', '1685-10-08', '1685-10-28', true, '1686-01-26', 'Batavia', 5828, 'At the Cape 1 seafarer deserted.');
INSERT INTO "voyages" VALUES (1498, '', 1, '', 'MOERKAPELLE', 'Jan van Velzen', 685, 'pinas? jacht?', '1684', NULL, NULL, 'R', 'R', '1685-05-13', 'Goeree', '1685-09-17', '1685-10-13', true, '1685-12-30', 'Batavia', 5847, 'Via S. Tiago (13-06 till 17-06-1685).');
INSERT INTO "voyages" VALUES (1499, '', 4, '', 'LAND VAN SCHOUWEN', 'Kornelis Klaasz.', 1140, NULL, '1676', NULL, NULL, 'Z', 'A', '1685-05-13', 'Texel', '1685-09-17', '1685-10-13', true, '1685-12-24', 'Batavia', 5831, 'Via Cape Lopez (25-07 till 29-07-1685).');
INSERT INTO "voyages" VALUES (1500, '', 1, '', 'WAALSTROOM', 'Jakob Kool', 648, 'pinas', '1684', NULL, NULL, 'A', 'A', '1685-05-13', 'Texel', '1685-09-17', '1685-10-13', true, '1686-01-01', 'Batavia', 5838, 'Via S. Tiago (13-06 till 17-06-1685).');
INSERT INTO "voyages" VALUES (1501, '', 1, '', 'WESTERWIJK', 'Michiel 
Jansz. de Vries
van Flensburg', 434, 'pinas? jacht?', '1683', NULL, NULL, 'A', 'A', '1685-05-13', 'Texel', '1685-09-05', '1685-11-04', true, NULL, NULL, NULL, 'Madagascar for slave trade (arr. on 16-02-1686) but was taken in the same month by an English pirate in the river of Mamegare on Madagascar.');
INSERT INTO "voyages" VALUES (1502, '', 6, '', 'PRINS WILLEM HENDRIK', 'Adriaan van Kreuningen', 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1685-05-13', 'Wielingen', '1685-09-06', '1685-10-03', true, '1685-12-24', 'Batavia', NULL, 'The ship was wrecked in Banka street on a voyage to Siam on 18-09-1686.');
INSERT INTO "voyages" VALUES (1503, '', 1, '', 'NIEROP', 'Dirk Gijsz. Slob', 494, 'fluit', '1684', NULL, NULL, 'E', 'E', '1685-05-26', 'Texel', '1685-10-11', '1685-10-28', true, '1686-01-24', 'Batavia', 5858, 'At the Cape 2 soldiers deserted.');
INSERT INTO "voyages" VALUES (1504, '', 1, '', 'PIJLSWAART', 'Hendrik Plechtman', 600, 'pinas? jacht?', '1684', NULL, NULL, 'H', 'H', '1685-05-26', 'Texel', '1685-10-11', '1685-10-28', true, '1686-01-23', 'Batavia', 5867, NULL);
INSERT INTO "voyages" VALUES (1505, '', 5, '', 'WAPEN VAN ALKMAAR', 'Marten Wildvang', 892, 'pinas', '1671', NULL, NULL, 'E', 'A', '1685-07-05', 'Texel', '1685-11-11', '1685-12-03', true, '1686-03-11', 'Batavia', 5820, NULL);
INSERT INTO "voyages" VALUES (1506, '', 2, '', 'LANGEWIJK', NULL, 544, 'fluit', '1682', NULL, NULL, 'E', 'A', '1685-10-30', 'Texel', '1686-03-09', '1686-04-21', true, '1686-07-15', 'Ceylon', 5829, 'Via England.');
INSERT INTO "voyages" VALUES (1507, '', 2, '', 'HUIS TE SPIJK', 'Jan Speelman', 700, 'fluit', '1674', NULL, NULL, 'A', 'A', '1685-10-30', 'Texel', '1686-03-26', '1686-04-24', true, '1685-07-05', 'Batavia', NULL, 'The ship was sold at Batavia in October 1697.');
INSERT INTO "voyages" VALUES (1508, '', 2, '', 'PRINSELAND', 'Gerrit Kornelisz. Kriek van Delfshaven', 710, 'fluit', '1681', NULL, NULL, 'D', 'D', '1685-11-23', 'Goeree', NULL, NULL, false, '1686-06-06', 'Batavia', 5830, 'Via Cape Verde (13-01 till 19-01-1686).');
INSERT INTO "voyages" VALUES (1509, '', 1, '', 'OOSTERLAND', NULL, 1123, NULL, '1685', NULL, NULL, 'Z', 'Z', '1685-11-25', 'Wielingen', '1686-05-17', '1686-06-08', true, '1686-07-31', 'Batavia', 5824, 'became seafarers.');
INSERT INTO "voyages" VALUES (1510, '', 1, '', 'HOEFIJZER', NULL, 90, 'hoeker', '1685', NULL, NULL, 'R', 'R', '1686-01-04', 'Maas', '1686-06-06', '1686-06-22', true, '1686-09-27', 'Ceylon', NULL, 'The ship was laid up India.');
INSERT INTO "voyages" VALUES (1511, '', 2, '', 'HONSELAARSDIJK', 'Pieter Kornelisz. Puit', 722, 'pinas', '1679', NULL, NULL, 'Z', 'H', '1686-01-04', 'Texel', '1686-05-04', '1686-05-25', true, '1686-07-29', 'Batavia', 5822, 'Via Duins where 1 soldier deserted.');
INSERT INTO "voyages" VALUES (1512, '', 1, '', 'KLAVERBLAD', 'Dirk Maartensz. Verdoes van Delfshaven', 100, 'hoeker? bootje?', '1685', NULL, NULL, 'D', 'D', '1686-01-04', 'Maas', '1686-06-06', '1686-06-22', true, '1686-09-15', 'Batavia', NULL, 'The ship was laid up at Batavia in May 1698.');
INSERT INTO "voyages" VALUES (1513, '', 2, '', 'PRINSES MARIA', NULL, 1140, NULL, '1682', NULL, NULL, 'Z', 'A', '1686-01-04', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ship was wrecked on the Sorlings. All hands were lost.');
INSERT INTO "voyages" VALUES (1514, '', 1, '', 'SPIERDIJK', 'Jan Gerritsz. van Bordeaux', 606, 'fluit? hekboot?', '1685', NULL, NULL, 'A', 'A', '1686-01-04', 'Texel', '1686-06-16', '1686-07-04', true, '1686-09-13', 'Batavia', 5826, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1515, '', 2, '', 'BEURS VAN AMSTERDAM', 'Jan de Visser', 479, 'pinas? jacht?', NULL, '1682/3', NULL, 'A', 'R', '1686-01-05', 'Maas', '1686-05-21', '1686-06-21', true, '1686-08-30', 'Batavia', NULL, 'Laid up at Batavia in December 1696.');
INSERT INTO "voyages" VALUES (1516, '', 1, '', 'BRONSTEDE', 'Jakob Barendsz. Sonbeek', 253, 'fluit? kat?', '1685', NULL, NULL, 'A', 'E', '1686-01-05', 'Texel', '1686-06-23', '1686-07-10', true, '1686-10-10', 'Batavia', NULL, 'Via England where 2 seafarers deserted. Wrecked on the roads of Semarang because of leakage on 21-08-1697.');
INSERT INTO "voyages" VALUES (1517, '', 2, '', 'JAMBY', NULL, 336, 'pinas? jacht?', '1679', NULL, NULL, 'A', 'A', '1686-01-21', 'Texel', '1686-05-17', '1687-03-01', true, '1688-02-25', 'Batavia', NULL, 'On 06-06-1686 departure from the Cape to Madagascar for slave trade. On 13-11-1686 back at the Cape with 212 slaves. Via Ceylon and the west coast of Sumatra (arrival on 02-09-1687). Laid up at Batavia in December 1696.');
INSERT INTO "voyages" VALUES (1518, '', 3, '', 'COEVORDEN', NULL, 820, NULL, '1674', NULL, NULL, 'A', 'Z', '1686-02-04', 'Vlissingen', '1686-06-05', '1686-06-22', true, '1686-09-27', 'Ceylon', NULL, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1519, '', 7, '', 'VRIJHEID', NULL, 1210, NULL, '1666', NULL, NULL, 'A', 'Z', '1686-03-09', 'Wielingen', '1686-06-23', '1686-07-03', true, '1686-09-07', 'Batavia', NULL, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1520, '', 2, '', 'DUIFJE', NULL, 90, 'hoeker? bootje?', '1682', NULL, NULL, 'A', 'A', '1686-04-10', 'Texel', '1686-09-21', '1686-10-14', true, '1687-02-07', 'Batavia', NULL, 'Via England; according to K.A. 1307 arrival at on the Cape on 12-09-1686. Laid up at Batavia in December 1696.');
INSERT INTO "voyages" VALUES (1521, '', 2, '', 'SINT MAARTENSDIJK', 'Adriaan Kempe van der Veer', 352, 'pinas? jacht?', '1681', NULL, NULL, 'Z', 'Z', '1686-04-11', 'Wielingen', '1686-08-20', '1686-09-09', true, '1686-12-19', 'Batavia', NULL, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1522, '', 1, '', 'NIEUWLAND', 'Francois Pies van Vlissingen', 544, 'fluit', '1685', NULL, NULL, 'Z', 'Z', '1686-05-04', 'Wielingen', NULL, NULL, false, '1686-12-06', 'Batavia', 5846, 'During the voyage 2 English seafarers were enlisted. Via S. Tiago (30-06 till 02-07-1686).');
INSERT INTO "voyages" VALUES (1523, '', 4, '', 'KORTGENE', 'Jan Gelein', 1139, NULL, '1675', NULL, NULL, 'Z', 'A', '1686-05-24', 'Texel', '1686-10-01', '1686-10-16', true, '1686-12-28', 'Batavia', 5843, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1524, '', 1, '', 'NETELENBURG', NULL, 100, 'fluit? hoeker?', '1686', NULL, NULL, 'A', 'A', '1686-05-24', 'Texel', '1687-01-05', '1687-01-16', true, '1687-06-04', 'Tuticorin', NULL, 'Via Saldanha Bay (arrival on 23-11-1686).');
INSERT INTO "voyages" VALUES (1525, '', 1, '', 'LANDS WELVAREN', 'Klaas de Voogd', 1145, 'pinas', '1685', NULL, NULL, 'A', 'A', '1686-05-24', 'Texel', '1686-10-01', '1686-10-15', true, '1687-02-08', 'Batavia', NULL, 'Via S. Tiago. At the Cape 2 soldiers went over to the KORT-GENE (1523).');
INSERT INTO "voyages" VALUES (1526, '', 4, '', 'HUIS TE ZILVERSTEIN', 'Karsten de Gilde', 1017, NULL, '1674', NULL, NULL, 'A', 'A', '1686-05-24', 'Texel', '1686-09-26', '1686-10-07', true, '1686-12-30', 'Batavia', 5845, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1527, '', 1, '', 'HOBRE', NULL, 524, 'fluit', '1685', NULL, NULL, 'E', 'E', '1686-07-06', 'Texel', NULL, NULL, false, '1687-04-12', 'Batavia', 5842, 'Via Saldanha Bay (arrival on 26-11-1686).');
INSERT INTO "voyages" VALUES (1528, '', 1, '', 'MASTBOS', NULL, 438, 'fluit', NULL, '1685/6', NULL, 'A', 'A', '1686-07-06', 'Texel', '1686-11-20', '1686-12-08', true, '1687-03-05', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1529, '', 1, '', 'SALLAND', NULL, 760, 'pinas', '1686', NULL, NULL, 'A', 'A', '1686-11-01', 'Texel', '1687-03-13', '1687-03-31', true, '1687-06-05', 'Batavia', 5835, 'Via S. Vincente.');
INSERT INTO "voyages" VALUES (1530, '', 2, '', 'BANTAM', NULL, 1138, 'pinas? jacht?', '1683', NULL, NULL, 'A', 'A', '1687-01-03', 'Texel', '1687-04-25', '1687-05-13', true, '1687-08-10', 'Batavia', 5841, NULL);
INSERT INTO "voyages" VALUES (1531, '', 2, '', 'EENHOORN', NULL, 749, NULL, '1683', NULL, NULL, 'Z', 'Z', '1687-01-03', 'Wielingen', '1687-04-25', '1687-05-15', true, '1687-08-24', 'Negombo', 5840, 'Via Tuticorin (arrival on 11-08-1687).');
INSERT INTO "voyages" VALUES (1532, '', 1, '', 'LEEUWENBURG', NULL, 90, 'hoeker', '1686', NULL, NULL, 'Z', 'Z', '1687-01-03', NULL, '1687-05-31', '1687-07-22', true, NULL, 'Ceylon', NULL, 'Via Saldanha Bay (25-04 till 29-05-1687).');
INSERT INTO "voyages" VALUES (1533, '', 3, '', 'RIDDERSCHAP VAN HOLLAND', NULL, 1138, NULL, '1681', NULL, NULL, 'A', 'A', '1687-01-03', 'Texel', '1687-04-20', '1687-05-03', true, '1687-07-26', 'Batavia', 5844, NULL);
INSERT INTO "voyages" VALUES (1534, '', 3, '', 'SCHIEBROEK', NULL, 250, 'jacht', '1681', NULL, NULL, 'Z', 'A', '1687-01-03', 'Texel', '1687-04-25', '1687-05-15', true, '1687-08-17', 'Negombo', 5921, 'Via Tuticorin (arrival on 10-08-1687).');
INSERT INTO "voyages" VALUES (1535, '', 3, '', 'GOUDESTEIN', NULL, 843, 'pinas', '1679', NULL, NULL, 'A', 'H', '1687-01-03', 'Texel', '1687-04-25', '1687-05-13', true, '1687-08-17', 'Batavia', 5837, NULL);
INSERT INTO "voyages" VALUES (1536, '', 1, '', 'KAPELLE', NULL, 647, 'jacht', '1686', NULL, NULL, 'R', 'R', '1687-01-04', 'Goeree', '1687-04-04', '1687-04-24', true, '1687-07-14', 'Batavia', 5865, NULL);
INSERT INTO "voyages" VALUES (1537, '', 1, '', 'SION', 'van den Berg', 740, NULL, '1686', NULL, NULL, 'D', 'D', '1687-01-18', 'Goeree', NULL, NULL, true, '1687-08-02', 'Batavia', 5836, 'Via Saldanha Bay (25-04 till 29-05-1687).');
INSERT INTO "voyages" VALUES (1538, '', 6, '', 'HENDRIK MAURITS', NULL, 1194, NULL, '1673', NULL, NULL, 'Z', 'Z', '1687-03-10', 'Wielingen', '1687-08-22', '1687-09-06', true, '1687-11-21', 'Batavia', NULL, 'Daghregister 1696 sold at Batavia, July 1696.');
INSERT INTO "voyages" VALUES (1539, '', 1, '', 'OOSTSOUBURG', NULL, 759, NULL, '1686', NULL, NULL, 'Z', 'Z', '1687-03-10', 'Wielingen', '1687-08-15', '1687-09-06', true, '1687-12-08', 'Batavia', 5861, NULL);
INSERT INTO "voyages" VALUES (1540, '', 1, '', 'LEK', NULL, 762, 'pinas', '1686', NULL, NULL, 'A', 'A', '1687-04-22', 'Texel', '1687-09-15', '1687-10-07', true, '1687-12-09', 'Batavia', 5875, NULL);
INSERT INTO "voyages" VALUES (1541, '', 1, '', 'NOORD(STER)', 'Pieter Timmerman', 90, 'galjoot', '1686', NULL, NULL, 'A', 'A', '1687-04-22', 'Texel', '1687-09-04', NULL, true, '1687-09-04', 'The Cape', NULL, 'Via S. Tiago. The ship stayed at the Cape. On 16-01-1690 wrecked at Klippenpunt about 15 miles west of Cape St. Francis.');
INSERT INTO "voyages" VALUES (1542, '', 2, '', 'GROTE VISSERIJ', NULL, 638, 'jacht', NULL, '1683', NULL, 'E', 'E', '1687-04-22', 'Texel', '1687-09-15', '1687-10-07', true, '1687-12-26', 'Batavia', NULL, 'Via S. Tiago. Laid up at Macassar in 1694.');
INSERT INTO "voyages" VALUES (1543, '', 2, '', 'WATERLAND', NULL, 1138, NULL, '1683', NULL, NULL, 'A', 'A', '1687-04-22', 'Texel', '1687-09-18', '1687-10-07', true, '1687-12-29', 'Batavia', 5857, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1544, '', 1, '', 'RAD VAN AVONTUUR', NULL, 484, 'fluit', NULL, NULL, '1686/7', 'A', 'A', '1687-05-06', 'Texel', '1687-09-18', '1687-10-07', true, '1688-01-17', 'Batavia', 5848, NULL);
INSERT INTO "voyages" VALUES (1545, '', 2, '', 'EEMLAND', NULL, 398, 'pinas? jacht?', '1680', NULL, NULL, 'A', 'Z', '1687-05-10', 'Wielingen', '1687-10-13', '1687-11-02', true, '1688-02-28', 'Batavia', 3, 'up at Batavia in 1702, according to Daghregister 1700 laid up at Batavia in May 1700.');
INSERT INTO "voyages" VALUES (1546, '', 1, '', 'ZAAMSLAG', NULL, 585, 'pinas? jacht?', '1687', NULL, NULL, 'Z', 'Z', '1687-11-29', 'Wielingen', '1688-04-11', '1688-05-04', true, '1688-07-31', 'Batavia', 5860, NULL);
INSERT INTO "voyages" VALUES (1547, '', 4, '', 'JAVA', NULL, 762, 'pinas', '1678', NULL, NULL, 'A', 'A', '1687-12-30', 'Texel', '1688-04-11', '1688-05-07', true, '1688-07-26', 'Batavia', 5849, NULL);
INSERT INTO "voyages" VALUES (1548, '', 3, '', 'LANGEWIJK', 'Theodorus Geelkerken', 544, 'fluit', '1682', NULL, NULL, 'E', 'A', '1687-12-30', 'Texel', '1688-04-19', '1688-05-14', true, '1688-08-08', 'Batavia', 5850, NULL);
INSERT INTO "voyages" VALUES (1549, '', 1, '', 'PAMPUS', NULL, 604, NULL, '1686', NULL, NULL, 'A', 'A', '1687-12-30', 'Texel', '1688-04-13', '1688-05-28', true, '1688-09-29', 'Ceylon', 5878, NULL);
INSERT INTO "voyages" VALUES (1550, '', 2, '', 'SILLIDA', NULL, 324, 'pinas? jacht?', '1680', NULL, NULL, 'A', 'A', '1687-12-30', 'Texel', '1688-04-26', '1688-05-11', true, '1688-07-22', 'Batavia', NULL, 'Laid up at Batavia in 1697.');
INSERT INTO "voyages" VALUES (1551, '', 2, '', 'SPIERDIJK', NULL, 606, 'fluit? hekboot?', '1685', NULL, NULL, 'A', 'A', '1687-12-30', 'Texel', '1688-04-23', '1688-05-09', true, '1688-07-30', 'Batavia', 5859, NULL);
INSERT INTO "voyages" VALUES (1552, '', 1, '', 'TAMEN', NULL, 416, 'fluit? kat?', '1687', NULL, NULL, 'A', 'A', '1687-12-30', 'Texel', '1688-05-18', '1688-06-03', true, '1688-08-14', 'Batavia', NULL, 'Wrecked at Ponte Pedro in 1691.');
INSERT INTO "voyages" VALUES (1553, '', 2, '', 'VOORSCHOTEN', 'Frans Valeriens', 558, 'fluit', '1684', NULL, NULL, 'D', 'D', '1687-12-31', 'Goeree', '1688-05-08', NULL, true, '1688-07-04', 'Batavia', 5854, 'Via Saldanha Bay (April 1688).');
INSERT INTO "voyages" VALUES (1554, '', 1, '', 'BORSENBURG', NULL, 320, 'fluit? kat?', '1686', NULL, NULL, 'A', 'A', '1688-01-06', 'Texel', '1688-05-12', '1688-06-03', true, '1688-08-10', 'Batavia', 5879, NULL);
INSERT INTO "voyages" VALUES (1555, '', 1, '', 'OOSTHUIZEN', 'Wessel Jansz. Koeze', 500, 'fluit', '1687', NULL, NULL, 'E', 'E', '1688-01-06', 'Texel', '1688-04-28', '1688-05-21', true, '1688-08-08', 'Batavia', 5852, 'Via S. Tiago (22-01 till 24-01-1688).');
INSERT INTO "voyages" VALUES (1556, '', 3, '', 'HONSELAARSDIJK', NULL, 722, 'pinas', '1679', NULL, NULL, 'Z', 'H', '1688-01-07', 'Texel', '1688-04-11', NULL, true, '1688-07-08', 'Batavia', 5855, 'At the Cape 1 seafarer deserted.');
INSERT INTO "voyages" VALUES (1557, '', 2, '', 'OOSTERLAND', NULL, 1123, NULL, '1685', NULL, NULL, 'Z', 'Z', '1688-01-29', 'Wielingen', '1688-04-25', '1688-05-15', true, '1688-07-19', 'Batavia', 5851, NULL);
INSERT INTO "voyages" VALUES (1558, '', 2, '', 'SCHELDE', 'Aarnoud Scheiteruit', 733, 'jacht', '1682', NULL, NULL, 'Z', 'Z', '1688-02-19', 'Wielingen', '1688-06-05', '1688-07-01', true, '1688-09-16', 'Batavia', 5853, 'Via S. Tiago.');
INSERT INTO "voyages" VALUES (1559, '', 2, '', 'DEN HELDER', NULL, 578, 'fluit', '1683', NULL, NULL, 'A', 'A', '1688-02-25', 'Texel', '1688-06-07', '1688-06-30', true, '1688-08-17', 'Ceylon', NULL, 'Wrecked at the river Ganges in 1690.');
INSERT INTO "voyages" VALUES (1560, '', 4, '', 'CHINA', NULL, 1124, NULL, '1676', NULL, NULL, 'A', 'R', '1688-03-20', 'Goeree', '1688-08-04', '1688-08-24', true, '1688-11-13', 'Batavia', 5874, NULL);
INSERT INTO "voyages" VALUES (1561, '', 2, '', 'ZUID BEVELAND', NULL, 518, 'pinas? jacht?', '1680', NULL, NULL, 'Z', 'Z', '1688-04-22', 'Wielingen', '1688-08-19', '1688-09-07', true, '1688-11-19', 'Batavia', 5862, NULL);
INSERT INTO "voyages" VALUES (1562, '', 2, '', 'CASTRICUM', NULL, 623, 'jacht', NULL, '168112', NULL, 'A', 'A', '1688-05-13', 'Texel', '1688-10-29', '1688-11-21', true, '1689-02-18', 'Batavia', NULL, 'deserted. Laid up at Batavia in October 1696.');
INSERT INTO "voyages" VALUES (1563, '', 3, '', 'PRINSELAND', NULL, 710, 'fluit', '1681', NULL, NULL, 'D', 'A', '1688-05-22', 'Texel', '1688-10-21', '1688-11-07', true, '1689-02-08', 'Batavia', 5882, 'seafarers and 1 soldier deserted.');
INSERT INTO "voyages" VALUES (1564, '', 6, '', 'WAPEN VAN ALKMAAR', 'Karel Godske', 892, 'pinas', '1671', NULL, NULL, 'A', 'A', '1688-07-27', 'Texel', '1689-01-27', '1689-02-27', true, '1689-05-20', 'Batavia', 5873, 'At the Cape 1 seafarer deserted.');
INSERT INTO "voyages" VALUES (1565, '', 1, '', 'HAANTJE', 'Govert van Leeuwen', 90, 'fluitje', '1688', NULL, NULL, 'R', 'R', '1688-10-26', 'Goeree', NULL, NULL, true, NULL, NULL, NULL, 'Taken by the French in the English Channel on 28-10-1688, but the ship was returned and then renamed HENNETJE (1722).');
INSERT INTO "voyages" VALUES (1566, '', 1, '', 'TUIMELAAR', 'Anthonie Vernier', 60, 'hoeker', '1688', NULL, NULL, 'A', 'Z', '1688-10-26', 'Wielingen', '1689-02-23', '1689-02-27', true, NULL, 'Ceylon', NULL, 'The ship was laid up at Tuticorin in 1692.');
INSERT INTO "voyages" VALUES (1567, '', 3, '', 'KRIJGSMAN', 'Jan Meier', 356, 'fluit', NULL, '1683', NULL, 'Z', 'Z', '1688-10-27', 'Wielingen', NULL, NULL, true, NULL, NULL, NULL, 'Taken by the French in the English Channel.');
INSERT INTO "voyages" VALUES (1568, '', 3, '', 'SNOEPER', 'Albert Barendsz. Fokkes', NULL, 'galjoot', NULL, NULL, '1677', NULL, 'A', '1688-11-17', 'Texel', '1689-03-15', '1689-03-24', true, '1689-06-03', 'Batavia', 5872, NULL);
INSERT INTO "voyages" VALUES (1569, '', 1, '', 'ELISABETH', NULL, NULL, 'galjoot', NULL, NULL, '1688', 'A', 'A', '1688-11-26', 'Texel', '1689-03-19', '1689-03-25', true, NULL, 'Ceylon', 5876, NULL);
INSERT INTO "voyages" VALUES (1570, '', 1, '', 'TOBIAS LEIDSMAN', NULL, NULL, 'buffs', '1688', NULL, NULL, 'A', 'A', '1688-11-26', 'Vlie', NULL, NULL, true, NULL, NULL, NULL, 'On 29-11-1688 the ship was wrecked at Hanglip (Shetland Islands).');
INSERT INTO "voyages" VALUES (1571, '', 1, '', 'VLAMING', 'Willem Hesselsz. de Vlaming', NULL, 'galjoot', NULL, NULL, '1688', 'A', 'A', '1688-11-26', 'Vlie', '1689-03-25', '1689-04-07', true, '1689-10-31', 'Batavia', 5864, NULL);
INSERT INTO "voyages" VALUES (1572, '', 1, '', 'HANDBOOG', 'Pieter Klein', 594, 'fluit', '1687', NULL, NULL, 'A', 'A', '1688-11-28', 'Texel', '1689-05-05', '1689-07-11', true, NULL, 'Ceylon', 5877, NULL);
INSERT INTO "voyages" VALUES (1573, '', 1, '', 'NEDERLAND', 'Marcelis Kock', 1173, 'pinas', '1687', NULL, NULL, 'A', 'A', '1688-11-28', 'Texel', '1689-03-22', '1689-05-19', true, '1689-08-01', 'Batavia', 5866, 'At the Cape 2 seafarers and 2 soldiers deserted. Among the passengers who embarked at the Cape were 20 French prisoners.');
INSERT INTO "voyages" VALUES (1574, '', 4, '', 'SCHIELAND', 'Anthonie Kornelisz. Pronk', 710, NULL, '1674', NULL, NULL, 'D', 'A', '1689-01-01', 'Texel', '1689-05-15', '1689-07-11', true, '1689-09-14', 'Batavia', 5869, 'At the Cape 1 seafarer deserted. The passengers who embarked at the Cape were French prisoners. The ship was sold on 19-06-1691.');
INSERT INTO "voyages" VALUES (1575, '', 1, '', 'VOETBOOG', 'Egbert Kalf', 595, 'fluit', '1687', NULL, NULL, 'A', 'A', '1689-01-01', 'Texel', '1689-07-12', '1689-07-31', true, '1689-10-05', 'Batavia', 5897, NULL);
INSERT INTO "voyages" VALUES (1576, '', 2, '', 'SION', 'Simon van den Berg', 740, NULL, '1686', NULL, NULL, 'D', 'D', '1689-01-04', 'Goeree', '1689-05-06', '1689-06-11', true, '1689-08-16', 'Batavia', 5871, 'At the Cape 1 seafarer deserted. The passengers who embarked at the Cape were French prisoners.');
INSERT INTO "voyages" VALUES (1577, '', 1, '', 'DRECHTERLAND', 'Freek Groot', 756, NULL, '1688', NULL, NULL, 'E', 'E', '1689-01-12', 'Texel', '1689-07-25', '1689-08-18', true, '1689-10-25', 'Batavia', 5906, 'Via S. Tiago where 1 seafarer and 1 soldier deserted.');
INSERT INTO "voyages" VALUES (1578, '', 2, '', 'SALLAND', 'Jakob de Jonge', 760, 'pinas', '1686', NULL, NULL, 'A', 'Z', '1689-03-26', 'Wielingen', '1689-08-22', '1689-09-06', true, NULL, 'Batavia', NULL, 'The ship was laid up on 25-09-1699 at Tuticorin.');
INSERT INTO "voyages" VALUES (1579, '', 5, '', 'SCHOUWEN', 'Kornelis Wisse', 1140, NULL, '1676', NULL, NULL, 'Z', 'Z', '1689-03-26', 'Wielingen', '1689-07-12', '1689-07-31', true, '1689-10-05', 'Batavia', 5870, 'According to K.A. 1346 the ship departed from the Wielingen on 22-03-1689.');
INSERT INTO "voyages" VALUES (1580, '', 3, '', 'BANTAM', 'Bruin Jansz. van Gorkum', 1138, 'pinas? jacht?', '1683', NULL, NULL, 'A', 'A', '1689-04-26', 'Texel', '1689-08-29', '1689-09-21', true, '1689-11-26', 'Batavia', 5887, 'Via S. Tiago (09-06 till 17-06-1689).');
INSERT INTO "voyages" VALUES (1581, '', 2, '', 'NIEUWLAND', 'Jan de Marre', 544, 'fluit', '1685', NULL, NULL, 'Z', 'A', '1689-04-26', 'Texel', '1689-08-29', '1689-09-21', true, '1689-12-29', 'Batavia', 5881, 'Via S. Tiago (09-06 till 16-06-1689).');
INSERT INTO "voyages" VALUES (1582, '', 2, '', 'WAALSTROOM', 'Harman Voet', 648, 'pinas', '1684', NULL, NULL, 'A', 'A', '1689-04-26', 'Texel', '1689-08-26', '1689-09-21', true, '1689-12-05', 'Batavia', 5898, 'Via S. Tiago (09-06-1689 till 26-06-1689).');
INSERT INTO "voyages" VALUES (1583, '', 3, '', 'HUTS TE KRONENBURG', 'Arie de Bruin', 700, 'fluit', '1674', NULL, NULL, 'A', 'R', '1689-05-08', 'Goeree', '1689-09-19', '1689-10-12', true, '1690-01-04', 'Batavia', NULL, 'Via S. Tiago (28-06 till 01-07-1689) where 2 seafarers deserted. The ship was laid up at Batavia in 1697.');
INSERT INTO "voyages" VALUES (1584, '', 1, '', 'KRAB', 'Baltus Doen', 644, 'fluit', '1688', NULL, NULL, 'H', 'H', '1689-06-01', 'Texel', '1690-02-08', '1690-02-28', true, '1690-05-25', 'Batavia', 5886, 'Via Portsmouth and Plymouth. At the Cape 3 seafarers deserted. During the voyage 1 soldier became seafarer.');
INSERT INTO "voyages" VALUES (1585, '', 1, '', 'SCHOONDUK', 'Krijn Koster', 759, NULL, '1688', NULL, NULL, 'Z', 'Z', '1689-06-11', 'Wielingen', '1689-11-03', '1689-11-27', true, '1690-01-28', 'Batavia', 5896, 'According to K.A. 4390a the ship departed on 31-05-1689. Via S. Tiago (01-08 till 07-08-1689).');
INSERT INTO "voyages" VALUES (1586, '', 2, '', 'MOERKAPELLE', 'Pieter de Gilde', 685, 'pinas? jacht?', '1684', NULL, NULL, 'R', 'A', '1689-09-26', 'Texel', '1690-03-02', '1690-03-31', true, '1690-06-10', 'Batavia', 5905, NULL);
INSERT INTO "voyages" VALUES (1587, '', 4, '', 'RIDDERSCHAP VAN HOLLAND', 'Alexander Simons', 1138, NULL, '1681', NULL, NULL, 'A', 'A', '1689-09-26', 'Texel', '1690-01-04', '1690-02-06', true, '1690-04-08', 'Batavia', 5895, 'At the Cape 1 seafarer deserted.');
INSERT INTO "voyages" VALUES (1588, '', 1, '', 'SCHOLTENBURG', 'Willebrord Jakobsz.', NULL, 'galjoot', NULL, NULL, '1689', 'A', 'A', '1689-12-13', 'Texel', '1690-05-28', NULL, true, '1690-05-28', 'The Cape', 5883, NULL);
INSERT INTO "voyages" VALUES (1589, '', 1, '', 'HAANTJE', 'Govert van Leeuwen', 100, 'hoeker', '1689', NULL, NULL, 'R', 'R', '1689-12-18', 'Maas', '1690-05-29', '1690-07-02', true, '1690-11-28', 'Batavia', NULL, 'Via Duins (21-12-1689 till 27-01-1690), Falmouth (01-02 till 13 02-1690) and Mauritius (03-08 till 16-09-1690). Sold at Batavia for 320 rials on 24-12-1697.');
INSERT INTO "voyages" VALUES (1590, '', 2, '', 'HOBRE', 'Jan Hendriksz. de Reus', 524, 'fluit', '1685', NULL, NULL, 'E', 'E', '1690-01-04', 'Texel', '1690-05-28', '1690-07-02', true, '1690-08-30', 'Batavia', NULL, 'The ship was laid up at Batavia in 1700.');
INSERT INTO "voyages" VALUES (1591, '', 1, '', 'GOEDE HOOP', 'Wessel Jansz. Koeze', 1177, 'pinas', '1688', NULL, NULL, 'A', 'A', '1690-01-04', 'Texel', '1690-05-13', '1690-10-05', true, '1690-12-10', 'Batavia', 5900, 'Via S. Tiago (19-02 till 11-03-1690). At the Cape 14 seafarers and 2 soldiers deserted.');
INSERT INTO "voyages" VALUES (1592, '', 4, '', 'LANGEWIJK', 'Jakob Terhuis', 544, 'fluit', '1682', NULL, NULL, 'E', 'H', '1690-01-04', 'Texel', '1690-09-15', '1690-10-28', true, '1691-01-10', 'Batavia', 5890, 'Via Bergen (Norway) (25-01 till 24-04-1690) where 29 seafarers and 19 soldiers deserted and 22 seafarers and 3 soldiers were enlisted.');
INSERT INTO "voyages" VALUES (1593, '', 1, '', 'MIJDRECHT', 'Klaas Voshol', 597, 'pinas? jacht?', '1688', NULL, NULL, 'A', 'A', '1690-01-04', 'Texel', '1690-05-14', '1690-09-20', true, NULL, 'Ceylon', 5901, NULL);
INSERT INTO "voyages" VALUES (1594, '', 4, '', 'GOUDESTEIN', 'Gilles Brouwer', 843, 'pinas', '1679', NULL, NULL, 'A', 'A', '1690-01-04', 'Texel', '1690-05-13', '1690-10-05', true, NULL, 'Ceylon', 5889, NULL);
INSERT INTO "voyages" VALUES (1595, '', 1, '', 'BELOIS', 'Gerrit Kornelisz. Kriek van Delfshaven', 506, 'fluit', '1687', NULL, NULL, 'D', 'D', '1690-01-28', 'Goeree', '1690-07-08', '1690-07-29', true, '1690-09-28', 'Batavia', 5888, NULL);
INSERT INTO "voyages" VALUES (1596, '', 3, '', 'EENHOORN', 'Albert Bichon', 749, NULL, '1683', NULL, NULL, 'Z', 'R', '1690-01-28', 'Goeree', '1690-09-03', '1690-10-28', true, '1691-01-06', 'Batavia', 5894, 'Via Bergen (Norway) (10-02 till 24-04-1690) where 7 seafarers and 2 soldiers were enlisted. At the Cape and Bergen 15 seafarers and 10 soldiers deserted.');
INSERT INTO "voyages" VALUES (1597, '', 5, '', 'KORTGENE', 'Jan Kakelaar', 1139, NULL, '1675', NULL, NULL, 'Z', 'Z', '1690-03-09', 'Wielingen', '1690-10-16', '1690-12-09', true, '1691-02-14', 'Batavia', NULL, 'The ship was laid up at Tuticorin in 1694.');
INSERT INTO "voyages" VALUES (1598, '', 2, '', 'LANDS WELVAREN', 'Abraham Arnoudsz.', 1145, 'pinas', '1685', NULL, NULL, 'A', 'Z', '1690-03-09', 'Wielingen', '1690-10-16', '1691-01-02', true, '1691-06-14', 'Batavia', 5903, NULL);
INSERT INTO "voyages" VALUES (1599, '', 2, '', 'MAAS', 'Willem Kemp', 790, NULL, '1683', NULL, NULL, 'R', 'A', '1690-05-20', 'Texel', '1690-10-02', '1690-10-28', true, '1691-01-05', 'Batavia', 5943, 'Via S. Tiago (16-07 till 21-07-1690). At the Cape 1 seafarer deserted.');
INSERT INTO "voyages" VALUES (1600, '', 2, '', 'NIEROP', 'Jan Speelman', 494, 'fluit', '1684', NULL, NULL, 'E', 'A', '1690-05-20', 'Texel', '1690-10-01', '1690-10-28', true, '1691-01-06', 'Batavia', 5891, 'Via S. Tiago (16-07 till 21-07-1690).');
INSERT INTO "voyages" VALUES (1601, '', 3, '', 'WATERLAND', 'Jan Konstantijn van den Markt', 1138, NULL, '1683', NULL, NULL, 'A', 'A', '1690-05-20', 'Texel', '1690-10-02', '1690-10-28', true, '1691-01-06', 'Batavia', 5899, 'Tiago (16-07 till 21-07-1690). At the Cape 1 seafarer and 1 soldier deserted.');
INSERT INTO "voyages" VALUES (1602, '', 1, '', 'ZWARTE LEEUW', 'Pieter Andriesz. Goedland', NULL, NULL, NULL, '1690', NULL, 'D', 'D', '1690-06-06', 'Goeree', '1690-09-19', NULL, true, '1690-09-19', 'The Cape', NULL, 'The ship was laid up at the Cape in 1696.');
INSERT INTO "voyages" VALUES (1603, '', 4, '', 'HONSELAARSDIJK', 'Kornelis Ole', 722, 'pinas', '1679', NULL, NULL, 'Z', 'Z', '1690-06-07', 'Wielingen', '1690-11-01', '1690-12-09', true, '1691-02-28', 'Batavia', NULL, 'The ship was wrecked at the roads of Batavia in 1698.');
INSERT INTO "voyages" VALUES (1604, '', 1, '', 'ALIDA', 'Jan Nobel', NULL, 'galjoot', NULL, NULL, '1690', 'A', 'A', '1690-11-05', 'Texel', '1691-05-06', NULL, true, '1691-05-06', 'The Cape', 5892, NULL);
INSERT INTO "voyages" VALUES (1605, '', 1, '', 'ENGEL MICHAEL', 'Jan Michielsz.', NULL, 'galjoot', NULL, NULL, '1690', 'A', 'A', '1690-11-14', 'Texel', '1691-04-10', NULL, true, '1691-04-10', 'The Cape', 5893, NULL);
INSERT INTO "voyages" VALUES (1606, '', 3, '', 'SPIERDIJK', 'Sieuwert de Jong', 606, 'fluit? hekboot?', '1685', NULL, NULL, 'A', 'A', '1690-11-15', 'Texel', '1691-04-05', '1691-04-20', true, '1691-06-27', 'Batavia', 5902, NULL);
INSERT INTO "voyages" VALUES (1607, '', 1, '', 'BRANDENBURG', 'Evert Verbrugge', 817, NULL, '1690', NULL, NULL, 'A', 'A', '1690-12-29', 'Texel', '1691-06-04', '1691-07-08', true, '1691-09-25', 'Ceylon', 5923, NULL);
INSERT INTO "voyages" VALUES (1608, '', 3, '', 'EMMENES', 'Sijbrand Visser', 297, 'fluit? kat?', '1682', NULL, NULL, 'A', 'E', '1690-12-29', 'Texel', '1691-06-08', '1691-07-20', true, '1691-09-29', 'Batavia', 5911, NULL);
INSERT INTO "voyages" VALUES (1609, '', 2, '', 'HANDBOOG', 'Kornelis Koleman', 594, 'fluit', '1687', NULL, NULL, 'A', 'A', '1690-12-29', 'Texel', '1691-05-12', '1691-05-26', true, '1691-07-26', 'Batavia', 5912, 'the Cape 3 seafarers deserted.');
INSERT INTO "voyages" VALUES (1610, '', 2, '', 'PAMPUS', 'Jan de Wit', 604, NULL, '1686', NULL, NULL, 'A', 'A', '1690-12-29', 'Texel', '1691-05-12', '1691-06-06', true, '1691-08-06', 'Ceylon', 5915, NULL);
INSERT INTO "voyages" VALUES (1611, '', 5, '', 'JAVA', 'Hendrik Pronk', 762, 'pinas', '1679', NULL, NULL, 'A', 'A', '1691-01-03', 'Texel', '1691-06-01', '1691-07-12', true, '1691-09-11', 'Batavia', NULL, 'The ship was laid up at Batavia in 1700.');
INSERT INTO "voyages" VALUES (1612, '', 3, '', 'OOSTERLAND', 'Aarnoud Scheiteruit', 1123, NULL, '1685', NULL, NULL, 'Z', 'Z', '1691-02-08', 'Wielingen', '1691-06-17', '1691-07-20', true, '1691-09-28', 'Batavia', 5918, NULL);
INSERT INTO "voyages" VALUES (1613, '', 3, '', 'SCHELDE', 'Thomas van Willigen', 733, 'jacht', '1682', NULL, NULL, 'Z', 'R', '1691-04-20', 'Goeree', '1691-09-02', '1691-09-30', true, '1691-12-23', 'Batavia', NULL, 'The ship was laid up at Batavia in January 1703.');
INSERT INTO "voyages" VALUES (1614, '', 1, '', 'BERKEL', 'Barend Boom', 280, 'fluit', '1689', NULL, NULL, 'D', 'D', '1691-05-17', 'Goeree', '1691-10-23', '1691-11-16', true, '1692-03-12', 'Batavia', 5913, 'Via S. Tiago (02-06 till 08-06-1691).');
INSERT INTO "voyages" VALUES (1615, '', 2, '', 'HOGERGEEST', 'Jasper de Leeuw', 222, 'pinas? jacht?', '1681', NULL, NULL, 'A', 'D', '1691-05-17', 'Goeree', '1691-10-01', '1691-10-31', true, '1692-01-19', 'Batavia', 5904, NULL);
INSERT INTO "voyages" VALUES (1616, '', 3, '', 'VOORSCHOTEN', 'Jan Sibbing', 558, 'fluit', '1684', NULL, NULL, 'D', 'A', '1691-05-17', 'Goeree', '1691-10-20', '1691-11-16', true, '1692-02-13', 'Batavia', 5920, 'Via S. Tiago (02-07-1691).');
INSERT INTO "voyages" VALUES (1617, '', 2, '', 'LEK', 'Teunis de Hoop', 762, 'pinas', '1686', NULL, NULL, 'A', 'A', '1691-06-01', 'Texel', '1691-10-01', '1691-10-31', true, '1692-04-20', 'Batavia', 5926, NULL);
INSERT INTO "voyages" VALUES (1618, '', 2, '', 'NEDERLAND', 'Otto van Tiel', 1173, 'pinas', '1687', NULL, NULL, 'A', 'A', '1691-06-01', 'Texel', '1691-10-01', '1691-10-31', true, '1692-01-14', 'Batavia', 5907, NULL);
INSERT INTO "voyages" VALUES (1619, '', 2, '', 'OOSTHUIZEN', 'Willem van Texel', 500, 'fluit', '1687', NULL, NULL, 'H', 'E', '1691-06-01', 'Texel', '1691-10-29', '1691-12-01', true, '1692-03-02', 'Batavia', 5914, NULL);
INSERT INTO "voyages" VALUES (1620, '', 3, '', 'PURMER', 'Willem Willemsz. Vermey', 582, 'pinas? jacht?', '1681', NULL, NULL, 'A', 'A', '1691-06-01', 'Texel', '1691-10-28', '1691-11-16', true, '1692-02-12', 'Batavia', 5919, NULL);
INSERT INTO "voyages" VALUES (1621, '', 3, '', 'SION', 'Jakob Klaasz. Mouthaan', 740, NULL, '1686', NULL, NULL, 'D', 'H', '1691-06-01', 'Texel', '1691-10-26', '1691-12-01', true, '1692-03-19', 'Batavia', 5910, 'One child was born during the voyage.');
INSERT INTO "voyages" VALUES (1622, '', 5, '', 'HUIS TE ZILVERSTEIN', 'Hans Beurens', 1017, NULL, '1674', NULL, NULL, 'A', 'A', '1691-06-01', 'Texel', '1691-10-09', '1691-12-01', true, '1692-02-12', 'Batavia', NULL, 'Via S. Tiago (16-07 till 23-07-1691). The ship was wrecked at Macassar on 29-03-1697.');
INSERT INTO "voyages" VALUES (1623, '', 1, '', 'DOMBURG', 'Willem Burggraaf', 759, NULL, '1690', NULL, NULL, 'Z', 'Z', '1691-06-02', 'Wielingen', '1691-10-27', '1691-12-11', true, '1692-02-15', 'Batavia', 5982, NULL);
INSERT INTO "voyages" VALUES (1624, '', 2, '', 'OOSTSOUBURG', 'Leendert Adriaansz.', 759, NULL, '1686', NULL, NULL, 'Z', 'Z', '1691-06-02', 'Wielingen', '1691-10-27', '1691-11-30', true, '1692-02-17', 'Batavia', 5980, 'A');
INSERT INTO "voyages" VALUES (1625, '', 2, '', 'ZAAMSLAG', 'Jakob Landsheer', 585, 'pinas? jacht?', '1687', NULL, NULL, 'Z', 'Z', '1691-06-02', 'Wielingen', '1691-10-27', '1691-12-11', true, '1692-04-20', 'Batavia', NULL, 'the ZAAMSLAG left the Cape on 08-12-1691. Laid up at Batavia in 1705.');
INSERT INTO "voyages" VALUES (1626, '', 2, '', 'BORSENBURG', 'Joost van der Tocht', 320, 'fluit? kat?', '1686', NULL, NULL, 'A', 'R', '1691-11-03', 'Goeree', '1692-04-20', '1692-05-07', true, '1692-08-15', 'Batavia', NULL, 'The ship was wrecked on the roads of Surat on 07-05-1697.');
INSERT INTO "voyages" VALUES (1627, '', 4, '', 'PRINSELAND', 'Jakob Swaaf', 710, 'fluit', '1681', NULL, NULL, 'D', 'D', '1691-12-24', 'Goeree', '1692-06-11', '1692-07-08', true, '1692-09-18', 'Batavia', 5908, 'Via Faeroe Islands (11-01 till 27-01-1692) and S. Tiago (27-02 till 03-03-1692).');
INSERT INTO "voyages" VALUES (1628, '', 1, '', 'HOEN', 'Usbrand Heemskerk', 70, 'galjoot', '1691', NULL, NULL, 'A', 'A', '1691-12-26', 'Texel', '1692-05-28', NULL, true, '1692-05-28', 'The Cape', NULL, 'The ship was taken on its way from Surat by an Arabian pirate on 11-10-1704.');
INSERT INTO "voyages" VALUES (1629, '', 1, '', 'HOF VAN ILPENDAM', 'Michiel de Vries', 700, 'pinas', '1691', NULL, NULL, 'A', 'A', '1691-12-26', 'Texel', '1692-06-01', '1692-07-08', true, '1692-09-19', 'Ceylon', 5917, 'Via Plymouth (03-05-1692).');
INSERT INTO "voyages" VALUES (1630, '', 1, '', 'ISSELT', 'Jan Kleinrens', 785, 'fluit', '1691', NULL, NULL, 'A', 'A', '1691-12-26', 'Texel', '1692-06-03', '1692-07-08', true, '1692-09-18', 'Batavia', 5955, 'Via Plymouth (03-01 till 22-01-1692).');
INSERT INTO "voyages" VALUES (1631, '', 1, '', 'REIGERSDAAL', 'Jan Gerlofsz.', 818, 'pinas', '1691', NULL, NULL, 'A', 'A', '1691-12-26', 'Texel', '1692-05-30', '1692-07-08', true, '1692-09-18', 'Batavia', 5909, 'Plymouth where 3 seafarers deserted.');
INSERT INTO "voyages" VALUES (1632, '', 1, '', 'TROMPETTER', 'Sieuwert Karstensz.', 158, NULL, '1691', NULL, NULL, 'A', 'A', '1691-12-26', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ship was taken by the French off the Scottish coast and was burned.');
INSERT INTO "voyages" VALUES (1633, '', 1, '', 'BIJ', 'Dirk Starreman', 100, 'jacht', '1691', NULL, NULL, 'Z', 'Z', '1692-04-06', 'Wielingen', '1692-09-07', '1692-10-14', true, NULL, NULL, NULL, 'The ship was laid up at Batavia on 22-02-1706.');
INSERT INTO "voyages" VALUES (1634, '', 1, '', 'KAUW', 'Matthijs Brasser', 125, 'jacht', '1691', NULL, NULL, 'Z', 'Z', '1692-04-06', 'Wielingen', '1692-08-31', '1692-09-28', true, '1692-12-18', 'Ceylon', NULL, 'The ship was laid up at Batavia in 1705.');
INSERT INTO "voyages" VALUES (1635, '', 1, '', 'SIRJANSLAND', 'Jeroen Rijkwaart', 759, NULL, '1691', NULL, NULL, 'Z', 'Z', '1692-04-06', 'Wielingen', '1692-09-07', '1692-10-05', true, '1692-12-19', 'Batavia', 5916, 'Via S. Tiago (05-06 till 10-06-1692) where 1 seafarer deserted.');
INSERT INTO "voyages" VALUES (1636, '', 1, '', 'WIND', 'Kornelis de Graver', 246, 'jacht', '1691', NULL, NULL, 'Z', 'Z', '1692-04-06', 'Wielingen', '1692-08-12', '1692-09-05', true, '1692-10-28', 'Ceylon', 5960, NULL);
INSERT INTO "voyages" VALUES (1637, '', 1, '', 'ITERSHEM', 'Pieter Klaasz. Snel', 579, 'fluit', '1691', NULL, NULL, 'H', 'H', '1692-05-25', 'Texel', '1692-10-21', '1692-12-08', true, '1693-02-25', 'Batavia', 5931, 'Via S. Tiago (09-07 till 15-07-1692).');
INSERT INTO "voyages" VALUES (1638, '', 2, '', 'KRAB', 'Dirk Lovelt', 644, 'fluit', '1688', NULL, NULL, 'H', 'A', '1692-05-25', 'Texel', '1692-10-20', '1692-11-10', true, '1693-02-18', 'Ceylon', 5934, NULL);
INSERT INTO "voyages" VALUES (1639, '', 3, '', 'NIEUWLAND', 'Jakob Kuiper', 544, 'fluit', '1685', NULL, NULL, 'Z', 'E', '1692-05-25', 'Texel', '1692-10-20', '1692-12-08', true, '1693-03-16', 'Ceylon', 5933, NULL);
INSERT INTO "voyages" VALUES (1640, '', 1, '', 'PRUIJEN', 'Laurens Teunisz. Zeeman', NULL, 'loodsboot', '1691', NULL, NULL, 'E', 'E', '1692-05-25', 'Texel', '1692-10-21', '1692-12-08', true, NULL, NULL, NULL, 'The ship was laid up at Batavia in 1702.');
INSERT INTO "voyages" VALUES (1641, '', 1, '', 'TAMBOER', 'Sieuwert Karstensz.', 124, NULL, '1691', NULL, NULL, 'A', 'A', '1692-05-25', 'Texel', '1692-10-20', NULL, true, '1692-10-20', 'The Cape', NULL, 'Batavia in 1705.');
INSERT INTO "voyages" VALUES (1642, '', 2, '', 'BELOIS', 'Jan Barendsz.', 506, 'fluit', '1687', NULL, NULL, 'D', 'D', '1692-06-28', 'Goeree', '1692-11-08', '1692-12-08', true, '1693-02-16', 'Batavia', 5950, NULL);
INSERT INTO "voyages" VALUES (1643, '', 4, '', 'BANTAM', 'Barend Visser', 1138, 'pinas? jacht?', '1683', NULL, NULL, 'A', 'A', '1692-07-27', 'Texel', '1693-02-19', '1693-03-29', true, '1693-06-14', 'Batavia', 5922, 'One child was born during the voyage.');
INSERT INTO "voyages" VALUES (1644, '', 1, '', 'HUIS TE DIEREN', 'Jakob Kool', 603, 'fluit', '1691', NULL, NULL, 'A', 'A', '1692-07-27', 'Texel', '1692-12-21', '1693-01-18', true, '1693-04-06', 'Batavia', 5951, 'Via S. Tiago (27-09 till 02-10-1692).');
INSERT INTO "voyages" VALUES (1645, '', 1, '', 'HUIS TE LOO', 'Paulus Huntum', 875, 'pinas', '1691', NULL, NULL, 'A', 'A', '1692-07-27', 'Texel', '1692-12-21', '1693-01-18', true, '1693-03-23', 'Batavia', 5936, NULL);
INSERT INTO "voyages" VALUES (1646, '', 3, '', 'NIEROP', 'Leendert Klaasz. Braak', 494, 'fluit', '1684', NULL, NULL, 'A', 'H', '1692-07-27', 'Texel', '1692-12-21', '1693-01-18', true, '1693-05-04', 'Batavia', NULL, 'Laid up at Batavia in 1701.');
INSERT INTO "voyages" VALUES (1647, '', 1, '', 'PEER', 'Gerrit Fopsen', 70, 'galjoot? loodsboot?', '1691', NULL, NULL, 'A', 'A', '1692-07-27', 'Texel', '1692-12-25', '1693-01-14', true, '1693-05-03', 'Ceylon', NULL, 'The ship was laid up at Tjeribon in 1702.');
INSERT INTO "voyages" VALUES (1648, '', 1, '', 'WADDINXVEEN', 'Elbert Fransz.', 751, NULL, '1691', NULL, NULL, 'R', 'R', '1692-07-28', 'Goeree', '1692-10-30', '1692-12-08', true, '1693-02-14', 'Batavia', 5939, 'The master might have been called Albert instead of Eldert.');
INSERT INTO "voyages" VALUES (1649, '', 5, '', 'GOUDESTEIN', 'Wijnand Bouwman', 843, 'pinas', '1679', NULL, NULL, 'A', 'Z', '1692-08-13', 'Wielingen', '1693-02-05', '1693-03-01', true, '1693-05-31', 'Batavia', NULL, 'Shortly after departure the master Wijnand Bouwman changed place with Kornelis Mesdag, master on the VOSMAAR (1650). Via S. Tiago (16-10 till 28-10-1692) where 5 seafarers and 1 soldier deserted. January or February 1699 wrecked at Ligoor (Siam).');
INSERT INTO "voyages" VALUES (1650, '', 1, '', 'VOSMAAR', 'Kornelis Mesdag', 759, NULL, '1691', NULL, NULL, 'Z', 'Z', '1692-08-13', 'Wielingen', '1693-02-20', '1693-03-29', true, '1693-06-14', 'Batavia', 5938, 'Shortly after departure the master Kornelis Mesdag changed place with Wijnand Bouwman, master on the GOUDESTEIN (1649). Via S. Tiago (16-10 till 28-10-1692).');
INSERT INTO "voyages" VALUES (1651, '', 1, '', 'APPEL', 'Adriaan Klapmuts', 70, 'galjoot', '1691', NULL, NULL, 'A', 'A', '1692-09-29', 'Texel', '1693-03-04', '1693-03-21', true, '1693-06-14', 'Ceylon', NULL, 'The ship was laid up at Bengal in 1700.');
INSERT INTO "voyages" VALUES (1652, '', 5, '', 'LANGEWIJK', 'Meindert Hayes', 544, 'fluit', '1682', NULL, NULL, 'E', 'A', '1692-09-29', 'Texel', '1693-02-28', '1693-03-25', true, '1693-05-30', 'Batavia', NULL, 'Via S. Tiago (03-12 till 08-12-1692). Laid up at Batavia in 1701.');
INSERT INTO "voyages" VALUES (1653, '', 2, '', 'SCHAAPHERDER', 'Lukas Zwart', 90, 'jacht', 'Indies 1690', NULL, NULL, NULL, 'A', '1692-09-29', 'Texel', '1693-02-18', '1693-03-04', true, '1693-06-19', 'Batavia', NULL, 'Laid up at Batavia on 17-10-1706.');
INSERT INTO "voyages" VALUES (1654, '', 1, '', 'WATERMAN', 'Klaas Jansz. Neuselaar', 588, 'fluit', '1691', NULL, NULL, 'E', 'E', '1692-09-29', 'Texel', '1693-04-16', '1693-05-04', true, '1693-08-04', 'Batavia', 5927, 'Via S. Tiago (22-12 till 25-12-1692). At the Cape 1 seafarer and 1 soldier deserted.');
INSERT INTO "voyages" VALUES (1655, '', 1, '', 'AGATHA', 'Dirk Zijp', NULL, 'fluit', NULL, NULL, '1692', 'A', 'A', '1693-01-17', 'Texel', '1693-08-19', '1693-10-02', true, '1693-12-16', 'Batavia', 5930, 'Via Portsmouth (20-01 till 19-04-1693) where the master was shot and 12 seafarers and 1 soldier deserted.');
INSERT INTO "voyages" VALUES (1656, '', 2, '', 'FAAM', 'Steven Harteveld', 477, 'pinas? jacht?', '1682', NULL, NULL, 'A', 'A', '1693-01-17', 'Texel', '1693-08-20', '1693-09-08', true, '1693-12-11', 'Ceylon', 5928, 'Via England (departure 19-04-1693) and via Scotland.');
INSERT INTO "voyages" VALUES (1657, '', 1, '', 'NICHTEVECHT', 'Gerrit Voordewind', 825, 'pinas', '1692', NULL, NULL, 'A', 'A', '1693-01-17', 'Texel', '1693-08-19', '1693-09-08', true, '1693-11-20', 'Batavia', 5932, 'Via Portsmouth (20-01 till 19-04-1693) where 10 seafarers deserted.');
INSERT INTO "voyages" VALUES (1658, '', 1, '', 'DAGERAAD', 'Jan Tak', 140, NULL, '1692', NULL, NULL, 'Z', 'Z', '1693-01-18', 'Wielingen', '1693-12-15', NULL, true, NULL, NULL, NULL, 'Wrecked west of Robben Island in December 1693.');
INSERT INTO "voyages" VALUES (1659, '', 2, '', 'MIJDRECHT', 'Gerrit Koper', 597, 'pinas? jacht?', '1688', NULL, NULL, 'A', 'R', '1693-01-18', 'Goeree', '1693-08-06', '1693-08-27', true, '1693-11-02', 'Batavia', 5944, 'Via Portsmouth (21-01 till 19-04-1693) where 6 seafarers and 1 soldier deserted.');
INSERT INTO "voyages" VALUES (1660, '', 1, '', 'DRIEBERGEN', 'Klaas Koman', 616, 'fluit', '1692', NULL, NULL, 'A', 'A', '1693-01-23', 'Texel', '1693-08-12', '1693-08-27', true, '1693-10-20', 'Batavia', 5924, 'Via Portsmouth (31-01 till 19-04-1693) where 2 seafarers deserted.');
INSERT INTO "voyages" VALUES (1661, '', 4, '', 'EENHOORN', 'Frans Lievense', 749, NULL, '1683', NULL, NULL, 'Z', 'Z', '1693-03-05', 'Wielingen', '1693-06-28', '1693-07-13', true, '1693-10-08', 'Ceylon', 5952, NULL);
INSERT INTO "voyages" VALUES (1662, '', 1, '', 'KARTHAGO', 'Jan Speelman', 759, NULL, '1692', NULL, NULL, 'Z', 'Z', '1693-03-05', 'Wielingen', '1693-07-04', '1693-07-23', true, '1693-10-08', 'Batavia', 5925, NULL);
INSERT INTO "voyages" VALUES (1663, '', 2, '', 'VOETBOOG', 'Gilles Brouwer', 595, 'fluit', '1687', NULL, NULL, 'A', 'A', '1693-04-07', 'Texel', '1693-08-02', '1693-08-23', true, '1693-11-12', 'Ceylon', 5929, 'Via England (departure 19-04-1693).');
INSERT INTO "voyages" VALUES (1664, '', 1, '', 'WOGGENUM', 'Dirk Danielsz Bent', 538, 'jacht', '1692', NULL, NULL, 'H', 'H', '1693-04-07', 'Texel', '1693-10-11', '1693-11-11', true, '1694-03-06', 'Batavia', NULL, 'Via S. Tiago (21-05 till 23-05-1693). Laid up at Batavia in 1705.');
INSERT INTO "voyages" VALUES (1665, '', 1, '', 'GOUDEN BUIS', 'Teunis Kornelisz. Baanman', NULL, NULL, '1692', NULL, NULL, 'E', 'E', '1693-05-04', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ship was wrecked at St. Helena Bay in December 1693.');
INSERT INTO "voyages" VALUES (1666, '', 1, '', 'KERS', 'Willem Gerritsz. Blok', 70, 'galjoot? loodsboot?', '1691', NULL, NULL, 'A', 'A', '1693-05-04', 'Texel', '1693-09-27', '1693-10-06', true, '1694-01-04', 'Ceylon', NULL, 'due to the loss of the main mast.');
INSERT INTO "voyages" VALUES (1667, '', 1, '', 'KONING WILLIAM', 'Huibert Hossen', 1197, 'pinas', '1692', NULL, NULL, 'A', 'A', '1693-05-04', 'Texel', '1693-09-17', '1693-10-24', true, '1694-01-19', 'Batavia', 5941, NULL);
INSERT INTO "voyages" VALUES (1668, '', 1, '', 'BEIEREN', 'Gerrit Kornelisz. Kriek van Delfshaven', 832, NULL, '1692', NULL, NULL, 'D', 'D', '1693-05-17', 'Maas', '1693-11-25', '1694-01-01', true, '1694-04-01', 'Batavia', 5981, 'born during the voyage.');
INSERT INTO "voyages" VALUES (1669, '', 1, '', 'SPRINKHAAN', 'Job Stokke', 100, 'hoeker', '1693', NULL, NULL, 'D', 'D', '1693-05-17', 'Maas', '1693-09-16', '1693-10-04', true, '1693-12-05', 'Ceylon', NULL, 'The ship was laid up at Ceylon in 1700.');
INSERT INTO "voyages" VALUES (1670, '', 2, '', 'SCHOONDUK', 'Lambert Klein', 759, NULL, '1688', NULL, NULL, 'Z', 'A', '1693-06-10', 'Texel', '1693-11-25', NULL, true, '1694-05-01', 'Batavia', 5987, 'A');
INSERT INTO "voyages" VALUES (1671, '', 5, '', 'RIDDERSCHAP VAN HOLLAND', 'Dirk de Lange', 1138, NULL, '1681', NULL, NULL, 'A', 'Z', '1693-07-11', 'Wielingen', '1694-01-09', '1694-02-05', true, NULL, NULL, NULL, 'The ship disappeared after departure from the Cape.');
INSERT INTO "voyages" VALUES (1672, '', 3, '', 'LANDS WELVAREN', 'Reineus Ole', 1145, 'pinas', '1685', NULL, NULL, 'A', 'Z', '1693-07-11', 'Wielingen', '1694-01-20', '1694-02-13', true, '1694-06-09', 'Batavia', 5940, 'Via Annabon (29-10 till 11-11-1693).');
INSERT INTO "voyages" VALUES (1673, '', 4, '', 'SPIERDIJK', 'Sieuwert de Jong', 606, 'fluit? hekboot?', '1685', NULL, NULL, 'A', 'A', '1693-08-17', 'Texel', '1694-01-03', '1694-02-03', true, '1694-05-02', 'Batavia', 6014, NULL);
INSERT INTO "voyages" VALUES (1674, '', 3, '', 'MOERKAPELLE', 'Barend Andriesz. Lingeveld +', 685, 'pinas? jacht?', '1684', NULL, NULL, 'R', 'A', '1693-09-19', 'Texel', '1694-04-08', '1694-05-17', true, '1694-08-05', 'Batavia', 5945, 'The master died at the Cape, he was succeeded bij Hendrik Roos.');
INSERT INTO "voyages" VALUES (1675, '', 1, '', 'IJSSELMONDE', 'Adriaan Palestein', 832, NULL, '1693', NULL, NULL, 'R', 'R', '1693-10-24', 'Goeree', '1694-04-04', '1694-05-17', true, '1694-08-05', 'Batavia', 5946, NULL);
INSERT INTO "voyages" VALUES (1676, '', 3, '', 'HANDBOOG', 'Kornelis Koster', 594, 'fluit', '1687', NULL, NULL, 'A', 'H', '1694-01-07', 'Texel', '1695-01-22', '1695-03-31', true, '1695-07-01', 'Batavia', 5954, 'Via Bergen (Norway), 13-02 till 27-08-1694.');
INSERT INTO "voyages" VALUES (1677, '', 1, '', 'DRIE KRONEN', 'Alexander Simons', 1075, 'pinas', '1693', NULL, NULL, 'A', 'A', '1694-01-07', 'Texel', '1694-05-27', '1694-06-23', true, '1694-08-18', 'Batavia', 5935, NULL);
INSERT INTO "voyages" VALUES (1678, '', 1, '', 'MERESTEIN', 'Willem de Vlaming', 826, 'pinas', '1693', NULL, NULL, 'A', 'A', '1694-01-07', 'Texel', '1694-06-07', '1694-07-07', true, '1694-09-13', 'Batavia', 5937, NULL);
INSERT INTO "voyages" VALUES (1679, '', 1, '', 'ROSKAM', 'Pieter Harmensz. Vos', 90, 'hoeker', '1693', NULL, NULL, 'A', 'A', '1694-01-07', 'Texel', '1695-01-16', '1695-02-25', true, NULL, 'Ceylon', 5961, 'Via Bergen (Norway), 13-02 till 27-08-1694.');
INSERT INTO "voyages" VALUES (1680, '', 1, '', 'SCHULP', 'Jakob Broek', 411, 'kat', '1693', NULL, NULL, 'A', 'A', '1694-01-07', 'Texel', '1694-08-29', '1694-09-23', true, '1694-12-29', 'Ceylon', NULL, 'According to Coolhaas VI, 473, this ship was laid up at Batavia in 1707.');
INSERT INTO "voyages" VALUES (1681, '', 1, '', 'SPARE', 'Klaas Voshol', 603, 'pinas', '1692', NULL, NULL, 'A', 'A', '1694-01-07', 'Texel', '1694-10-19', '1694-12-07', true, '1695-03-05', 'Batavia', NULL, 'Here 4 seafarers and 1 soldier were left behind. 2 soldiers and 2 seafarers proved to be absent at departure. Lost on the 4th of November 1698 coming from Japan.');
INSERT INTO "voyages" VALUES (1682, '', 2, '', 'BERKEL', 'Bruin Jansz.', 280, 'fluit', '1689', NULL, NULL, 'D', 'A', '1694-01-22', 'Texel', '1694-07-29', '1694-08-22', true, '1694-11-06', 'Batavia', 5942, 'At Rio Sester, Guinea, from 03-05 till 10-05-1694.');
INSERT INTO "voyages" VALUES (1683, '', 1, '', 'HUIS TER DUINE', 'Thomas de Kok', 588, 'jacht', '1693', NULL, NULL, 'Z', 'Z', '1694-02-05', 'Zeeland', '1694-07-31', '1694-09-03', true, '1694-11-21', 'Batavia', 5947, NULL);
INSERT INTO "voyages" VALUES (1684, '', 2, '', 'REIGERSDAAL', 'Kornelis Jorissen', 818, 'pinas', '1691', NULL, NULL, 'A', 'Z', '1694-02-05', 'Zeeland', '1694-09-02', '1694-10-06', true, '1695-01-03', 'Batavia', 6004, 'At Vlieland from 05-03-1694 till 01-05-1694. One woman who signed on in manclothes was left behind. Three seafarers ran away.');
INSERT INTO "voyages" VALUES (1685, '', 4, '', 'SION', 'Melchert de Vos', 740, NULL, '1686', NULL, NULL, 'D', 'D', '1694-04-28', 'Goeree', '1694-08-27', '1694-09-13', true, '1694-11-06', 'Batavia', 597, ''',');
INSERT INTO "voyages" VALUES (1686, '', 4, '', 'EMMENES', 'Jakob Terhuis', 297, 'fluit?', '1682', NULL, NULL, 'A', 'H', '1694-05-17', 'Texel', '1694-10-21', '1695-01-22', true, '1695-05-18', 'Batavia', NULL, 'The ship was laid up at Batavia in 1701.');
INSERT INTO "voyages" VALUES (1687, '', 2, '', 'HOF VAN ILPENDAM', 'Jan Kornelisz. van Alkmaar', 700, 'pinas', '1691', NULL, NULL, 'A', 'A', '1694-05-17', 'Texel', '1694-09-25', '1694-10-27', true, '1695-01-23', 'Ceylon', 6002, NULL);
INSERT INTO "voyages" VALUES (1688, '', 3, '', 'NEDERLAND', 'Jan Ammansz.', 1173, 'pinas', '1687', NULL, NULL, 'A', 'A', '1694-05-17', 'Texel', '1694-09-09', '1694-10-14', true, '1694-12-12', 'Batavia', 5970, NULL);
INSERT INTO "voyages" VALUES (1689, '', 3, '', 'OOSTHUIZEN', 'Hendrik Harmensz. Spinger', 500, 'fluit', '1687', NULL, NULL, 'H', 'E', '1694-05-17', 'Texel', '1694-10-24', '1694-12-12', true, '1695-03-05', 'Batavia', NULL, 'The ship was laid up at Batavia in 1705.');
INSERT INTO "voyages" VALUES (1690, '', 5, '', 'PRINSELAND', 'Gerrit Remming', 710, 'fluit', '1681', NULL, NULL, 'D', 'A', '1694-05-17', 'Texel', '1694-10-01', '1694-10-27', true, '1695-01-25', 'Batavia', NULL, 'sold at Batavia on 23-08-1704.');
INSERT INTO "voyages" VALUES (1691, '', 1, '', 'SPIEGEL', 'Cornelis Koleman', 831, 'pinas', '1693', NULL, NULL, 'A', 'A', '1694-05-17', 'Texel', '1694-09-21', '1694-10-11', true, '1694-12-11', 'Batavia', 5948, NULL);
INSERT INTO "voyages" VALUES (1692, '', 3, '', 'PAMPUS', 'Bartel Bastein', 604, NULL, '1686', NULL, NULL, 'A', 'R', '1694-06-20', 'Goeree', '1694-12-23', '1695-03-05', true, '1695-07-25', 'Batavia', NULL, 'Sold at Batavia on 21-05-1704.');
INSERT INTO "voyages" VALUES (1693, '', 4, '', 'OOSTERLAND', 'Pieter van Ede', 1123, NULL, '1685', NULL, NULL, 'Z', 'Z', '1694-07-16', 'Zeeland', '1694-12-31', '1695-03-03', true, '1695-06-11', 'Batavia', 5975, 'The ship was wrecked at the Cape on 24-05-1697.');
INSERT INTO "voyages" VALUES (1694, '', 4, '', 'PURMER', 'Jan de Wersijn', 582, 'jacht? pinas?', '1681', NULL, NULL, 'A', 'Z', '1694-07-16', 'Zeeland', '1695-01-03', '1695-03-05', true, '1695-07-21', 'Batavia', NULL, 'Laid up at Batavia in 1701.');
INSERT INTO "voyages" VALUES (1695, '', 2, '', 'SIRJANSLAND', 'Anthonie Pronk', 759, NULL, '1691', NULL, NULL, 'Z', 'A', '1694-09-15', 'Texel', '1695-04-19', '1695-05-25', true, '1695-07-31', 'Batavia', 5957, NULL);
INSERT INTO "voyages" VALUES (1696, '', 1, '', 'BEKESTEIN', 'Egbert Kalf', 324, 'jacht? pinas?', '1694', NULL, NULL, 'A', 'A', '1694-10-15', 'Texel', '1695-04-15', '1695-04-28', true, '1695-07-03', 'Batavia', 6016, 'The ship was from 18-10-1694 till 05-12-1694 at Portsmouth.');
INSERT INTO "voyages" VALUES (1697, '', 1, '', 'GENT', 'Dirk Gijsz. Slob', 816, NULL, '1693', NULL, NULL, 'E', 'E', '1694-10-15', 'Texel', '1695-04-06', '1695-04-28', true, '1695-07-02', 'Batavia', 5953, 'From 28-10-1694 till 05-12-1694 at Portsmouth, 1 seafarer and 7 soldiers ran away.');
INSERT INTO "voyages" VALUES (1698, '', 4, '', 'VOORSCHOTEN', 'Jan Subbing', 558, 'fluit', '1684', NULL, NULL, 'D', 'A', '1694-10-15', 'Texel', '1695-04-16', '1695-05-10', true, '1695-07-24', 'Batavia', 6023, 'The ship stayed from 20-10-1694 till 05-12-1694 at Portsmouth.');
INSERT INTO "voyages" VALUES (1699, '', 3, '', 'WAALSTROOM', 'Klaas Koman', 648, 'pinas', '1684', NULL, NULL, 'A', 'A', '1694-10-15', 'Texel', '1695-04-26', '1695-05-20', true, '1695-07-31', 'Batavia', 5959, NULL);
INSERT INTO "voyages" VALUES (1700, '', 2, '', 'DRECHTERLAND', 'Harman Pelser', 756, NULL, '1688', NULL, NULL, 'E', 'A', '1694-12-31', 'Texel', '1695-05-27', '1695-06-26', true, '1695-09-03', 'Ceylon', 6001, NULL);
INSERT INTO "voyages" VALUES (1701, '', 1, '', 'STAD KEULEN', 'Harman Voet', 1089, 'pinas', '1693', NULL, NULL, 'A', 'A', '1694-12-31', 'Texel', '1695-04-26', '1695-05-10', true, '1695-07-02', 'Batavia', 5967, 'From 09-01-1695 till 27-01-1695 at Portsmouth.');
INSERT INTO "voyages" VALUES (1702, '', 1, '', 'VECHT', 'Steven Harteveld', 626, 'fluit', '1693', NULL, NULL, 'A', 'A', '1694-12-31', 'Texel', '1695-05-09', '1695-06-07', true, '1695-08-30', 'Batavia', 5958, 'From 09-01-1695 till 27-01-1695 at Portsmouth.');
INSERT INTO "voyages" VALUES (1703, '', 3, '', 'VOETBOOG', 'Kornelis Dekker', 595, 'fluit', '1687', NULL, NULL, 'A', 'A', '1694-12-31', 'Texel', '1695-04-16', '1695-05-10', true, '1695-07-20', 'Batavia', 6034, 'From 10-01-1695 till 27-01-1695 at Portsmouth.');
INSERT INTO "voyages" VALUES (1704, '', 1, '', 'VOSSENBOS', 'Klaas Schacht', 95, 'fluit', '1693', NULL, NULL, 'H', 'H', '1694-12-31', 'Texel', '1695-05-04', '1695-05-20', true, '1695-08-17', 'Batavia', NULL, 'The ship was laid up at Batavia on 17-10-1706.');
INSERT INTO "voyages" VALUES (1705, '', 1, '', 'SWAAG', 'Anthonie Chef', 396, 'fluit', '1692', NULL, NULL, 'E', 'E', '1694-12-31', 'Texel', '1695-05-11', '1695-06-07', true, '1695-08-31', 'Batavia', NULL, 'Wrecked west of the isle of Pinancro on 21-03-1704.');
INSERT INTO "voyages" VALUES (1706, '', 1, '', 'OOSTERSTEIN', 'Jan de Wit', 1139, NULL, '1693', NULL, NULL, 'Z', 'Z', '1695-01-29', 'Wielingen', '1695-05-05', '1695-05-25', true, '1695-08-15', 'Batavia', 5956, NULL);
INSERT INTO "voyages" VALUES (1707, '', 1, '', 'EIKELENBURG', 'Jakob Uithuizen', 320, 'pinas? jacht?', '1693', NULL, NULL, 'A', 'A', '1695-03-23', 'Texel', '1695-07-07', '1695-08-13', true, '1695-10-12', 'Batavia', 5949, 'According to Coolhaas V, 736, this ship was a fregat (1707, 5949, 1781, 6035, 1854).');
INSERT INTO "voyages" VALUES (1708, '', 1, '', 'MATROOS', 'Albert Barendsz. Fokkes', 288, 'fregat', '1692', NULL, NULL, 'A', 'A', '1695-03-23', 'Texel', '1695-06-19', '1695-07-06', true, '1695-08-31', 'Ceylon', 5980, NULL);
INSERT INTO "voyages" VALUES (1709, '', 4, '', 'SNOEPER', 'Simon Harmensz.', NULL, 'galjoot', NULL, NULL, '1677', 'A', 'A', '1695-03-23', 'Texel', '1695-07-10', '1695-07-29', true, NULL, NULL, NULL, 'Laid up at Batavia in 1701.');
INSERT INTO "voyages" VALUES (1710, '', 1, '', 'SCHOONDERLOO', 'Jakob Oversloot', 622, 'fluit', '1693', NULL, NULL, 'D', 'D', '1695-05-29', 'Goeree', '1695-11-29', '1696-01-07', true, '1696-04-12', 'Batavia', 6047, 'The SCHOONDERLOO was with a fleet of 10 ships (1711-1720) from 19-06-1695 till 05-07-1695 at Bresont in Hitland.');
INSERT INTO "voyages" VALUES (1711, '', 1, '', 'JERUSALEM', 'Kornelis Mesdag', 622, 'fluit', '1693', NULL, NULL, 'R', 'R', '1695-05-30', 'Goeree', '1695-11-29', '1696-01-07', true, '1696-04-14', 'Batavia', 5965, 'See no. 1710.');
INSERT INTO "voyages" VALUES (1712, '', 2, '', 'BRANDENBURG', 'Jan Stam', 817, NULL, '1690', NULL, NULL, 'A', 'A', '1695-06-02', 'Texel', '1695-11-29', '1696-01-07', true, '1696-04-10', 'Batavia', 6000, 'See no. 1710.');
INSERT INTO "voyages" VALUES (1713, '', 2, '', 'DRIEBERGEN', 'Jan Bogaard', 616, 'fluit', '1692', NULL, NULL, 'A', 'A', '1695-06-02', 'Texel', '1695-11-29', '1696-01-07', true, '1696-04-15', 'Batavia', 5964, 'See no. 1710.');
INSERT INTO "voyages" VALUES (1714, '', 3, '', 'LEK', 'Marten de Jeugd', 762, 'pinas', '1686', NULL, NULL, 'A', 'A', '1695-06-02', 'Texel', '1695-11-29', '1696-01-07', true, '1696-04-15', 'Batavia', 5998, 'See no. 1710.');
INSERT INTO "voyages" VALUES (1715, '', 2, '', 'NICHTEVECHT', 'Jasper de Leeuw', 825, 'pinas', '1692', NULL, NULL, 'A', 'A', '1695-06-02', 'Texel', '1695-11-29', '1696-01-07', true, '1696-04-08', 'Batavia', 5986, 'See no. 1710.');
INSERT INTO "voyages" VALUES (1716, '', 1, '', 'HUIS OVERRIJP', 'Pieter Gerritsz. Maatschoen', 436, 'fluit', '1693', NULL, NULL, 'H', 'H', '1695-06-02', 'Texel', '1695-11-29', '1696-01-07', true, '1696-04-16', 'Batavia', 5976, 'See no. 1710.');
INSERT INTO "voyages" VALUES (1717, '', 2, '', 'WATERMAN', 'Klaas Jansz. Neuselaar', 588, 'fluit', '1691', NULL, NULL, 'E', 'E', '1695-06-02', 'Texel', '1695-11-29', '1696-01-07', true, '1696-04-15', 'Batavia', 5978, 'See no. 1710.');
INSERT INTO "voyages" VALUES (1718, '', 2, '', 'KARTHAGO', 'Servaas Adriaansz. Goudswaard', 759, NULL, '1692', NULL, NULL, 'Z', 'Z', '1695-06-03', 'Wielingen', '1695-11-29', '1696-01-06', true, '1696-04-07', 'Batavia', 5994, 'See no. 1710.');
INSERT INTO "voyages" VALUES (1719, '', 4, '', 'NIEUWLAND', 'Jan Tak', 544, 'fluit', '1685', NULL, NULL, 'Z', 'Z', '1695-06-03', 'Wielingen', '1695-11-29', '1696-01-14', true, '1696-11-09', 'Ceylon', 6012, 'See no. 1710. Laid up at the Cape in 1700.');
INSERT INTO "voyages" VALUES (1720, '', 1, '', 'NOORDGOUW', 'Abraham van de Velde', 280, 'fregat', '1694', NULL, NULL, 'Z', 'Z', '1695-06-03', NULL, '1695-11-29', NULL, true, '1695-11-29', 'The Cape', 5990, 'See no. 1710. For service at the Cape.');
INSERT INTO "voyages" VALUES (1721, '', 1, '', 'ZANDLOPER', 'Welgevaren', 244, 'fluit', '1695', NULL, NULL, 'D', 'D', '1695-07-27', 'Maas', '1695-12-12', '1696-01-06', true, '1696-04-08', 'Batavia', 5999, NULL);
INSERT INTO "voyages" VALUES (1722, '', 2, '', 'HENNETJE', 'Pieter Wijmans', 90, 'fluit', '1688', NULL, NULL, 'R', 'R', '1695-09-26', 'Maas', '1696-03-08', '1696-03-26', true, '1696-06-03', 'Batavia', 5979, 'See no. 1565.');
INSERT INTO "voyages" VALUES (1723, '', 3, '', 'FAAM', 'Adolf Hage', 477, 'pinas? jacht?', '1682', NULL, NULL, 'A', 'A', '1695-10-03', 'Texel', '1696-04-16', '1696-05-12', true, '1696-08-11', 'Batavia', NULL, 'Laid up at Ceylon in 1702.');
INSERT INTO "voyages" VALUES (1724, '', 1, '', 'ASSENDELFT', 'Sijbrand Visser', 816, 'pinas', '1694', NULL, NULL, 'A', 'A', '1695-12-19', 'Texel', '1696-07-27', '1696-08-22', true, '1696-12-05', 'Ceylon', 5974, NULL);
INSERT INTO "voyages" VALUES (1725, '', 5, '', 'BANTAM', 'Jan Fransz. Prins', 1138, 'pinas? jacht?', '1683', NULL, NULL, 'A', 'A', '1695-12-19', 'Texel', '1696-07-27', '1696-08-22', true, '1696-11-06', 'Batavia', 5962, 'soldiers ran away.');
INSERT INTO "voyages" VALUES (1726, '', 1, '', 'BERKENRODE', 'Koenraad Warnarsz.', 635, 'fluit', '1694', NULL, NULL, 'A', 'A', '1695-12-19', 'Texel', '1696-07-27', '1696-08-22', true, '1696-10-27', 'Batavia', 5963, 'soldiers ran away.');
INSERT INTO "voyages" VALUES (1727, '', 1, '', 'BOOR', 'Jan Verbrugge', 192, 'fluit', '1695', NULL, NULL, 'A', 'A', '1695-12-19', 'Texel', '1696-07-27', '1696-08-29', true, '1696-10-29', 'Batavia', 5997, 'The ship stayed at Portsmouth from 22-12-1695 till 03-04-1696.');
INSERT INTO "voyages" VALUES (1728, '', 2, '', 'ITERSHEM', 'Pieter Doen', 579, 'fluit', '1691', NULL, NULL, 'H', 'H', '1695-12-19', 'Texel', '1696-07-27', '1696-08-21', true, '1696-10-31', 'Batavia', NULL, 'Stayed at Portsmouth from 22-12-1695 till 03-04-1696; 9 seafarers and 1 soldier ran away. Laid up at Batavia on 19-04-1706.');
INSERT INTO "voyages" VALUES (1729, '', 2, '', 'DRIE KRONEN', 'Hendrik Pronk', 1075, 'pinas', '1693', NULL, NULL, 'A', 'A', '1695-12-19', 'Texel', '1696-07-27', '1696-08-21', true, '1696-10-29', 'Batavia', 5968, 'At Portsmouth from 22-12-1695 till 03-04-1696; 4 seafarers ran away.');
INSERT INTO "voyages" VALUES (1730, '', 1, '', 'SOLDAAT', 'Kornelis Jansz.', 288, 'fregat', '1692', NULL, NULL, 'A', 'A', '1695-12-19', 'Texel', '1696-07-27', '1696-11-12', true, '1698-09-01', NULL, NULL, 'arrived on 01-09-1698 in Batavia with a letter dated 15 December 1697.');
INSERT INTO "voyages" VALUES (1731, '', 2, '', 'SPIEGEL', 'Kornelis Koleman', 831, 'pinas', '1693', NULL, NULL, 'A', 'A', '1695-12-19', 'Texel', '1696-07-27', '1696-08-16', true, '1696-10-27', 'Batavia', 5972, 'Also at Portsmouth from 22-12-1695 till 03-04-1696 where 7 seafarers ran away and 7 soldiers became seafarers.');
INSERT INTO "voyages" VALUES (1732, '', 2, '', 'HUIS TE LOO', 'Jakob Swaaf', 875, 'pinas', '1691', NULL, NULL, 'A', 'D', '1695-12-20', 'Goeree', '1696-07-27', '1696-08-22', true, '1696-10-27', 'Batavia', 5969, 'From 22-12-1695 till 03-04-1696 at Portsmouth; 7 seafarers ran away.');
INSERT INTO "voyages" VALUES (1733, '', 2, '', 'WADDINXVEEN', 'Thomas van Willigen', 751, NULL, '1691', NULL, NULL, 'R', 'R', '1695-12-20', 'Goeree', '1696-07-27', '1696-08-21', true, '1696-10-29', 'Batavia', 5973, '03-04-1696; 3 seafarers and 1 soldier deserted.');
INSERT INTO "voyages" VALUES (1734, '', 1, '', 'KATTENDUK', 'Jan Naalhout', 759, NULL, '1694', NULL, NULL, 'Z', 'Z', '1695-12-26', 'Wielingen', '1696-06-06', '1696-06-29', true, '1696-09-11', 'Batavia', 5966, 'From 05-10-1696 till 15-03-1696 at Duins; 7 seafarers ran away.');
INSERT INTO "voyages" VALUES (1735, '', 1, '', 'VRIJBURG', 'Marinus Verhulst', 784, NULL, '1695', NULL, NULL, 'Z', 'Z', '1695-12-26', 'Wielingen', '1696-06-14', '1696-06-30', true, '1696-09-11', 'Batavia', 5971, 'At Duins from 05-01-1696 till 15-03-1696; 2 soldiers were put ashore.');
INSERT INTO "voyages" VALUES (1736, '', 2, '', 'HUIS TER DUINE', 'Thomas Kok', 588, 'jacht', '1693', NULL, NULL, 'Z', 'Z', '1696-04-26', 'Wielingen', '1696-11-08', '1696-12-24', true, '1697-03-22', 'Batavia', 6070, NULL);
INSERT INTO "voyages" VALUES (1737, '', 1, '', 'VEENMOL', 'Matthijs Koole', 213, 'fluit', '1695', NULL, NULL, 'Z', 'Z', '1696-04-26', 'Wielingen', '1696-11-03', '1697-01-29', true, NULL, NULL, NULL, 'Between the Cape and Batavia taken by the French in February 1697,');
INSERT INTO "voyages" VALUES (1738, '', 2, '', 'VOSMAAR', 'Jakob Landsheer', 759, NULL, '1691', NULL, NULL, 'Z', 'Z', '1696-04-26', 'Wielingen', '1696-10-22', '1696-12-24', true, '1697-03-22', 'Batavia', 6006, NULL);
INSERT INTO "voyages" VALUES (1739, '', 3, '', 'BERKEL', 'Leendert van Dijk', 280, 'fluit', '1689', NULL, NULL, 'D', 'A', '1696-05-03', 'Texel', '1696-10-14', '1696-11-18', true, '1697-03-20', 'Ceylon', 5991, '03-07-1696 at S. Tiago.');
INSERT INTO "voyages" VALUES (1740, '', 1, '', 'GEELVINK', 'Willem de Vlaming', 380, 'fregat? jacht?', '1696', NULL, NULL, 'A', 'A', '1696-05-03', 'Texel', '1696-09-07', '1696-10-27', true, '1697-03-20', 'Batavia', 6031, 'WEZELTJE(1742) from 17-08 till 21-08-1696 at Tristan da Cunha; 29-11 till 05-12-1696 at the islands of Amsterdam and St. Paulo; 29-12-1696 till 21-02-1697 at the Zuidland (see Schilder).');
INSERT INTO "voyages" VALUES (1741, '', 1, '', 'NIJPTANG', 'Gerrit Kolaart', 100, 'hoeker', '1695', NULL, NULL, 'A', 'A', '1696-05-03', 'Texel', '1696-09-03', '1696-10-27', true, '1697-03-17', 'Batavia', NULL, 'See no. 1740. Laid up at Ceylon in 1703.');
INSERT INTO "voyages" VALUES (1742, '', 1, '', 'WEZELTJE', 'Laurens Zeeman', 70, 'galjoot', '1695', NULL, NULL, 'A', 'A', '1696-05-03', 'Texel', '1696-09-08', '1696-10-27', true, '1697-03-17', 'Batavia', NULL, 'See no. 1740. Laid up in 1707.');
INSERT INTO "voyages" VALUES (1743, '', 3, '', 'KRAB', 'Reinier Vink', 644, 'fluit', '1688', NULL, NULL, 'H', 'H', '1696-07-20', 'Texel', '1697-04-24', '1697-06-17', true, '1697-09-17', 'Batavia', NULL, 'The ship stayed from 07-08 till 14-11-1696 at Portsmouth; 7 seafarers deserted. The KRAB was sold at Batavia on 25-10-1704.');
INSERT INTO "voyages" VALUES (1744, '', 2, '', 'MERESTEIN', 'Willem van Texel', 826, 'pinas', '1693', NULL, NULL, 'A', 'E', '1696-07-20', 'Texel', '1697-04-23', '1697-06-17', true, '1697-09-17', 'Batavia', 5985, 'At Portsmouth from 07-08 till 14-11-1696; 9 seafarers ran away.');
INSERT INTO "voyages" VALUES (1745, '', 2, '', 'KONING WILLIAM', 'Jan Hendrik Thim', 1197, 'pinas', '1692', NULL, NULL, 'A', 'A', '1696-07-20', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ship was wrecked at the Flemish coast on 22 or 23-07-1696.');
INSERT INTO "voyages" VALUES (1746, '', 2, '', 'IJSSELMONDE', 'Adriaan Palestein', 832, NULL, '1693', NULL, NULL, 'R', 'A', '1696-07-20', 'Texel', '1697-04-19', '1697-05-14', true, '1697-07-19', 'Batavia', 5992, 'The ship stayed at Portsmouth from 07-08 till 14-11-1696; 3 seafarers deserted.');
INSERT INTO "voyages" VALUES (1747, '', 1, '', 'DONKERVLIET', 'Kornelis Wels', 794, NULL, '1696', NULL, NULL, 'Z', 'Z', '1696-12-10', 'Wielingen', '1697-04-24', '1697-05-14', true, '1697-07-21', 'Batavia', 5983, NULL);
INSERT INTO "voyages" VALUES (1748, '', 1, '', 'LOODSBOOT', 'Dirk Intjes', 80, 'hoeker', '1682', NULL, NULL, 'Z', '?', '1696-12-18', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Because of a storm at the Orcades in Jan. 1697; the ship returned to Texel and was sold at Amsterdam in March 1700.');
INSERT INTO "voyages" VALUES (1749, '', 1, '', 'GRIMMESTEIN', 'Abraham Zeeman', 759, NULL, '1696', NULL, NULL, 'A', 'A', '1696-12-24', 'Texel', '1697-04-25', '1697-05-17', true, '1697-07-19', 'Batavia', 5984, NULL);
INSERT INTO "voyages" VALUES (1750, '', 3, '', 'MIJDRECHT', 'Dirk Lovelt', 597, 'jacht? pinas?', '1688', NULL, NULL, 'A', 'A', '1696-12-24', 'Texel', '1697-05-14', '1697-06-17', true, '1697-08-28', 'Batavia', 6021, NULL);
INSERT INTO "voyages" VALUES (1751, '', 1, '', 'OVERNES', 'Jan Vlasblom', 616, 'fluit', '1696', NULL, NULL, 'A', 'A', '1696-12-24', 'Texel', '1697-04-24', '1697-06-30', true, '1697-08-28', 'Batavia', 5987, NULL);
INSERT INTO "voyages" VALUES (1752, '', 4, '', 'LANDS WELVAREN', 'Speelman', 1145, 'pinas', '1685', NULL, NULL, 'A', 'A', '1696-12-24', 'Texel', '1697-04-24', '1697-05-14', true, '1697-07-18', 'Batavia', 5988, NULL);
INSERT INTO "voyages" VALUES (1753, '', 3, '', 'BELOIS', 'Hendrik Roos', 506, 'fluit', '1687', NULL, NULL, 'D', 'A', '1697-05-01', 'Texel', '1697-08-26', '1697-09-14', true, '1698-01-05', 'Ceylon', 5996, NULL);
INSERT INTO "voyages" VALUES (1754, '', 2, '', 'GENT', 'Jan Gerlofsz.', 816, NULL, '1693', NULL, NULL, 'E', 'A', '1697-05-01', 'Texel', '1697-08-21', '1697-09-20', true, '1697-12-01', 'Batavia', 5993, 'One child was born during the voyage.');
INSERT INTO "voyages" VALUES (1755, '', 1, '', 'HAASJE', 'Abraham van Stormen', 80, NULL, '1696', NULL, NULL, 'H', 'H', '1697-05-01', 'Texel', '1697-08-28', '1697-09-17', true, '1697-12-28', 'Batavia', NULL, 'The ship was laid up at Batavia in 1707.');
INSERT INTO "voyages" VALUES (1756, '', 2, '', 'ISSELT', 'Elbert Fransz.', 785, 'fluit', '1691', NULL, NULL, 'A', 'A', '1697-05-01', 'Texel', '1697-08-16', '1697-09-04', true, '1697-10-29', 'Batavia', 5989, NULL);
INSERT INTO "voyages" VALUES (1757, '', 3, '', 'SIRJANSLAND', 'Anthonie Pronk', 759, NULL, '1691', NULL, NULL, 'Z', 'A', '1697-05-01', 'Texel', '1697-08-26', '1697-09-20', true, '1697-12-13', 'Batavia', 6013, 'A soldier became second-surgeon.');
INSERT INTO "voyages" VALUES (1758, '', 4, '', 'WAALSTROOM', 'Gerrit Koper', 648, 'pinas', '1684', NULL, NULL, 'A', 'A', '1697-05-01', 'Texel', '1697-08-18', '1697-09-04', true, '1697-10-29', 'Batavia', 6015, 'Laid up at the Cape on 27-02-1700.');
INSERT INTO "voyages" VALUES (1759, '', 4, '', 'HANDBOOG', 'Baltus Doen', 594, 'fluit', '1687', NULL, NULL, 'A', 'H', '1697-05-08', 'Texel', '1697-09-07', '1697-09-20', true, '1697-11-21', 'Batavia', 6025, NULL);
INSERT INTO "voyages" VALUES (1760, '', 2, '', 'VECHT', 'Hendrik Korvemaker', 626, 'fluit', '1693', NULL, NULL, 'A', 'E', '1697-05-08', 'Texel', '1697-10-05', '1697-11-01', true, '1698-04-08', 'Batavia', 6033, NULL);
INSERT INTO "voyages" VALUES (1761, '', 4, '', 'MOERKAPELLE', 'Willem de Haze +', 685, 'jacht? pinas?', '1684', NULL, NULL, 'R', 'Z', '1697-05-13', 'Wielingen', '1697-10-15', '1697-11-08', true, '1698-03-16', 'Batavia', NULL, 'the sands of the river Palembang in 1703.');
INSERT INTO "voyages" VALUES (1762, '', 2, '', 'OOSTERSTEIN', 'Michiel de Keizer', 1139, NULL, '1693', NULL, NULL, 'Z', 'Z', '1697-05-13', 'Wielingen', '1697-10-04', '1697-11-01', true, '1698-01-19', 'Batavia', 6003, NULL);
INSERT INTO "voyages" VALUES (1763, '', 1, '', 'SCHELLAG', 'Dirk Blauw', 290, 'jacht? fregat?', '1696', NULL, NULL, 'Z', 'Z', '1697-05-13', 'Wielingen', '1697-09-07', '1697-09-17', true, '1697-12-23', 'Ceylon', 5995, NULL);
INSERT INTO "voyages" VALUES (1764, '', 2, '', 'WIND', 'Theunis Danielsz.', 246, 'jacht', '1691', NULL, NULL, 'Z', 'Z', '1697-05-13', 'Wielingen', '1697-08-30', '1697-09-14', true, NULL, 'Batavia', NULL, 'The ship was laid up at Batavia in 1702.');
INSERT INTO "voyages" VALUES (1765, '', 1, '', 'CONCORDIA', 'Abraham Oudenhoorn', 900, NULL, '1696', NULL, NULL, 'D', 'D', '1697-06-10', 'Goeree', '1697-10-31', '1697-12-05', true, '1698-03-24', 'Batavia', 6018, NULL);
INSERT INTO "voyages" VALUES (1766, '', 2, '', 'HUIS TE DIEREN', 'Dirk van der Hof', 603, 'fluit', '1691', NULL, NULL, 'A', 'R', '1697-06-10', 'Goeree', '1697-10-28', '1697-11-25', true, '1698-01-31', 'Batavia', 6009, NULL);
INSERT INTO "voyages" VALUES (1767, '', 1, '', 'LEEUWERIK', 'Jakob Willemsz.', 70, 'galjoot', '1697', NULL, NULL, 'A', 'A', '1697-10-30', 'Texel', '1698-02-11', '1698-02-19', true, '1698-05-30', 'Batavia', NULL, 'Laid up at Batavia on 01-09-1706.');
INSERT INTO "voyages" VALUES (1768, '', 1, '', 'POOL', 'Gerrit de Beer', 276, 'fregat', '1696', NULL, NULL, 'A', 'A', '1697-11-10', 'Texel', '1698-02-03', '1698-02-21', true, '1698-05-22', 'Ceylon', NULL, 'The ship was laid up at Batavia on 11-05-1706.');
INSERT INTO "voyages" VALUES (1769, '', 1, '', 'BAMBEEK', 'Christiaan van Leeuwen', 845, 'pinas', '1696', NULL, NULL, 'A', 'A', '1697-11-19', 'Texel', '1698-04-23', '1698-05-16', true, '1698-07-28', 'Batavia', 6011, NULL);
INSERT INTO "voyages" VALUES (1770, '', 1, '', 'UNIE', 'Jan Hendrik Smit', 1080, 'pinas', '1696', NULL, NULL, 'A', 'A', '1697-12-17', 'Texel', '1698-04-11', '1698-05-04', true, '1698-08-04', 'Batavia', 6005, 'From 23-11 till 26-11-1697 at Duins; from 31-01 till 06-02-1698 at S. Tiago.');
INSERT INTO "voyages" VALUES (1771, '', 1, '', 'KRAAIESTEIN', 'Jan van de Vijver', 1154, NULL, '1697', NULL, NULL, 'Z', 'Z', '1698-02-01', 'Wielingen', NULL, NULL, true, NULL, NULL, NULL, 'The ship was wrecked three miles off the Cape on 27-05-1698.');
INSERT INTO "voyages" VALUES (1772, '', 1, '', 'HARDLOPER', 'Gerrit Koek', 272, 'fregat', '1695', NULL, NULL, 'A', 'A', '1698-04-06', 'Texel', '1698-07-03', '1698-08-02', true, '1698-10-03', 'Ceylon', NULL, 'Laid up at Batavia in 1707.');
INSERT INTO "voyages" VALUES (1773, '', 2, '', 'ASSENDELFT', 'Ameland Jansz.', 816, 'pinas', '1694', NULL, NULL, 'A', 'A', '1698-05-02', 'Texel', '1698-09-13', '1698-10-07', true, '1699-01-05', 'Ceylon', 6068, NULL);
INSERT INTO "voyages" VALUES (1774, '', 3, '', 'HUIS TE LOO', 'Diedlof Kroes', 875, 'pinas', '1691', NULL, NULL, 'A', 'A', '1698-05-02', 'Texel', '1698-08-23', '1698-09-08', true, '1698-11-06', 'Batavia', 6008, NULL);
INSERT INTO "voyages" VALUES (1775, '', 1, '', 'HUIS TE NIEUWBURG', 'Henk Schrik', 618, 'hekboot? fluit?', '1697', NULL, NULL, 'A', 'A', '1698-05-02', 'Texel', '1698-09-07', '1698-09-24', true, '1698-11-27', 'Batavia', 6010, NULL);
INSERT INTO "voyages" VALUES (1776, '', 5, '', 'EENHOORN', 'Matthijs Koole', 749, NULL, '1683', NULL, NULL, 'Z', 'Z', '1698-05-03', 'Wielingen', '1698-09-05', '1698-09-27', true, '1698-12-14', 'Batavia', NULL, 'The ship was laid up at Batavia in 1706.');
INSERT INTO "voyages" VALUES (1777, '', 3, '', 'DRIEBERGEN', 'Marten de Jeugd', 616, 'fluit', '1692', NULL, NULL, 'A', 'D', '1698-05-25', 'Goeree', '1698-09-03', '1698-09-24', true, '1698-11-22', 'Batavia', 6007, 'From 01-07 till 03-07-1698 at Conbay.');
INSERT INTO "voyages" VALUES (1778, '', 2, '', 'JERUSALEM', 'Abraham Boon', 622, 'fluit', '1693', NULL, NULL, 'R', 'R', '1698-05-25', 'Goeree', '1698-09-18', '1698-10-07', true, '1699-01-09', 'Batavia', 6042, NULL);
INSERT INTO "voyages" VALUES (1779, '', 2, '', 'VRIJBURG', 'Isaak Lambrechtsen', 784, NULL, '1695', NULL, NULL, 'Z', 'Z', '1698-06-19', 'Wielingen', '1698-10-15', '1698-11-03', true, '1699-04-25', 'Batavia', 6075, 'From 01-02- till 11-04-1699 in the Mauritius Bay.');
INSERT INTO "voyages" VALUES (1780, '', 2, '', 'BERKENRODE', 'Leendert Klaasz. Broek', 635, 'fluit', '1694', NULL, NULL, 'A', 'H', '1698-09-22', 'Texel', '1699-02-24', '1699-03-24', true, '1699-06-15', 'Batavia', 6030, 'From 10-11 till 16-11-1698 at S. Tiago.');
INSERT INTO "voyages" VALUES (1781, '', 2, '', 'EIKELENBURG', 'Herman Blokhuizen', 380, 'pinas?', '1693', NULL, NULL, 'A', 'A', '1698-09-22', 'Texel', '1699-01-30', '1699-02-08', true, '1699-04-25', 'Batavia', 6035, 'At S. Tiago from 10-11 till 16-11-1698.');
INSERT INTO "voyages" VALUES (1782, '', 2, '', 'STAD KEULEN', 'Alexander Simons', 1089, 'pinas', '1693', NULL, NULL, 'A', 'A', '1698-09-22', 'Texel', '1699-01-23', '1699-02-07', true, '1699-04-24', 'Batavia', 6046, 'From 10-11 till 16-11-1698 at S. Tiago.');
INSERT INTO "voyages" VALUES (1783, '', 3, '', 'DRIE KRONEN', 'Jan Speelman', 1075, 'pinas', '1693', NULL, NULL, 'A', 'A', '1698-09-22', 'Texel', '1699-01-23', '1699-02-07', true, '1699-04-25', 'Batavia', 6037, 'From 10-11 till 16-11-1698 at S. Tiago.');
INSERT INTO "voyages" VALUES (1784, '', 2, '', 'HUIS OVERRIJP', 'Jan Abrahamsz. van Oldenhove', 436, 'fluit', '1693', NULL, NULL, 'H', 'A', '1698-09-22', 'Texel', '1699-02-20', '1699-05-02', true, '1699-11-05', 'Batavia', 6027, NULL);
INSERT INTO "voyages" VALUES (1785, '', 1, '', 'VENHUIZEN', 'Klaas Kompas', 250, 'fluit', '1697', NULL, NULL, 'E', 'E', '1698-09-22', 'Texel', '1699-02-12', '1699-02-27', true, '1699-06-04', 'Batavia', 6039, 'One child was born during the voyage.');
INSERT INTO "voyages" VALUES (1786, '', 3, '', 'SPIEGEL', 'Jan Gerritsz. van Bordeaux', 831, 'pinas', '1693', NULL, NULL, 'A', 'A', '1698-09-22', 'Texel', '1699-02-24', '1699-03-20', true, '1699-06-25', 'Ceylon', 6029, NULL);
INSERT INTO "voyages" VALUES (1787, '', 1, '', 'PETER EN PAUL', 'Klaas Dekker', 278, 'fregat', '1697', NULL, NULL, 'A', 'A', '1698-10-24', 'Texel', '1699-03-08', '1699-07-03', true, NULL, 'Batavia', 6057, NULL);
INSERT INTO "voyages" VALUES (1788, '', 2, '', 'KATTENDIJK', 'Jan Naalhout', 759, NULL, '1694', NULL, NULL, 'Z', 'Z', '1698-12-10', 'Wielingen', '1699-04-05', '1699-05-01', true, '1699-07-01', 'Batavia', 6020, NULL);
INSERT INTO "voyages" VALUES (1789, '', 1, '', 'ABBEKERK', 'Jasper Huid', 242, 'fluit', '1698', NULL, NULL, 'H', 'H', '1699-02-01', 'Texel', '1699-05-19', '1699-06-12', true, '1699-08-30', 'Batavia', 6077, NULL);
INSERT INTO "voyages" VALUES (1790, '', 4, '', 'BERKEL', 'Jakob Kuil', 280, 'fluit', '1689', NULL, NULL, 'D', 'A', '1699-02-01', 'Texel', '1699-05-19', NULL, true, '1699-05-19', 'The Cape', 6017, 'in order to take over the cargo of the NIEUWLAND (6012).');
INSERT INTO "voyages" VALUES (1791, '', 3, '', 'GENT', 'Dirk Verdoes', 816, NULL, '1693', NULL, NULL, 'E', 'A', '1699-02-01', 'Texel', '1699-04-28', '1699-05-28', true, '1699-07-29', 'Batavia', 6019, 'One stowaway deserted at the Cape.');
INSERT INTO "voyages" VALUES (1792, '', 2, '', 'GRIMMESTEIN', 'Abraham Zeeman', 759, NULL, '1696', NULL, NULL, 'A', 'A', '1699-02-01', 'Texel', '1699-05-14', '1699-06-02', true, '1699-08-06', 'Ceylon', 6028, NULL);
INSERT INTO "voyages" VALUES (1793, '', 3, '', 'ISSELT', 'Simon Langendam', 785, 'fluit', '1691', NULL, NULL, 'A', 'A', '1699-02-01', 'Texel', '1699-05-02', '1699-05-28', true, '1699-07-19', 'Ceylon', NULL, 'The ship was laid up at Batavia in 1706.');
INSERT INTO "voyages" VALUES (1794, '', 3, '', 'NICHTEVECHT', 'Elbert Fransz.', 825, 'pinas', '1692', NULL, NULL, 'A', 'A', '1699-02-01', 'Texel', NULL, NULL, true, '1699-06-29', 'Batavia', 6022, 'The ship did not call at the Cape because of a storm.');
INSERT INTO "voyages" VALUES (1795, '', 2, '', 'OVERNES', 'Gerrit Kolaart', 616, 'fluit', '1696', NULL, NULL, 'A', 'A', '1699-02-01', 'Texel', '1699-05-14', '1699-06-02', true, '1699-08-25', 'Batavia', 6031, 'From 12-03 till 15-03-1699 at S. Tiago.');
INSERT INTO "voyages" VALUES (1796, '', 2, '', 'ROSKAM', 'Fokel Hendriksz.', 90, 'hoeker', '1693', NULL, NULL, 'A', 'A', '1699-02-01', 'Texel', '1699-05-14', '1699-06-02', true, '1699-07-24', 'Ceylon', NULL, 'The ship was laid up at Ceylon in 1705.');
INSERT INTO "voyages" VALUES (1797, '', 3, '', 'WATERMAN', 'Schon', 588, 'fluit', '1691', NULL, NULL, 'E', 'E', '1699-02-01', 'Texel', '1699-05-19', '1699-06-11', true, '1699-08-26', 'Batavia', NULL, 'The ship set out for Persia, in August 1702 but it never returned.');
INSERT INTO "voyages" VALUES (1798, '', 5, '', 'LANDS WELVAREN', 'Adriaan Palestein', 1145, 'pinas', '1685', NULL, NULL, 'A', 'A', '1699-02-01', 'Texel', '1699-05-11', '1699-06-02', true, '1699-08-02', 'Batavia', 6024, NULL);
INSERT INTO "voyages" VALUES (1799, '', 2, '', 'BEIEREN', 'Melchior de Vos', 832, NULL, '1692', NULL, NULL, 'D', 'D', '1699-02-02', 'Goeree', '1699-06-05', '1699-06-24', true, '1699-08-28', 'Batavia', 6050, 'From 14-02 till 11-03-1699 at Plymouth: 1 seafarer ran away.');
INSERT INTO "voyages" VALUES (1800, '', 2, '', 'DONKERVLIET', 'Steven Scheiteruit', 794, NULL, '1696', NULL, NULL, 'Z', 'Z', '1699-02-02', 'Wielingen', '1699-07-20', '1699-08-22', true, '1699-11-01', 'Batavia', 6054, 'From 12-02 till 12-03-1699 at Wight.');
INSERT INTO "voyages" VALUES (1801, '', 3, '', 'HENNETJE', 'Jasper Hageneveld', 90, 'fluit', '1688', NULL, NULL, 'R', 'Z', '1699-02-02', 'Wielingen', '1699-06-18', '1699-07-16', true, '1699-09-30', 'Ceylon', NULL, 'The ship laid up at Batavia in 1705.');
INSERT INTO "voyages" VALUES (1802, '', 1, '', 'WESTHOVEN', 'Kornelis Gillisz.', 776, NULL, '1698', NULL, NULL, 'Z', 'Z', '1699-02-02', 'Wielingen', '1699-06-16', '1699-07-06', true, '1699-09-08', 'Batavia', 6104, NULL);
INSERT INTO "voyages" VALUES (1803, '', 3, '', 'MERESTEIN', 'Thomas van Willigen', 826, 'pinas', '1693', NULL, NULL, 'A', 'R', '1699-04-15', 'Goeree', '1699-08-03', '1699-08-30', true, '1699-10-29', 'Batavia', 6026, NULL);
INSERT INTO "voyages" VALUES (1804, '', 4, '', 'BELOIS', 'Jan Verbrugge', 506, 'fluit', '1687', NULL, NULL, 'D', 'A', '1699-05-09', 'Texel', '1699-10-27', '1699-11-14', true, '1700-01-27', 'Batavia', 6058, NULL);
INSERT INTO "voyages" VALUES (1805, '', 1, '', 'HUIS TE BIJWEG', 'Kornelis de Vlaming', 392, 'fluit', NULL, '1699', NULL, 'A', 'A', '1699-05-09', 'Texel', '1699-10-21', '1699-11-11', true, '1700-01-28', 'Batavia', 6040, NULL);
INSERT INTO "voyages" VALUES (1806, '', 4, '', 'NEDERLAND', 'Leendert van Dijk', 1173, 'pinas', '1687', NULL, NULL, 'A', 'A', '1699-05-09', 'Texel', '1699-10-24', '1699-11-20', true, '1700-01-25', 'Batavia', NULL, 'The ship was laid up at Batavia on 09-09-1706.');
INSERT INTO "voyages" VALUES (1807, '', 1, '', 'PEPERBOOM', 'Bogaard', 553, 'fluit', NULL, '1699', NULL, 'A', 'A', '1699-05-09', 'Texel', '1699-10-24', '1699-11-11', true, '1700-01-28', 'Batavia', 6043, NULL);
INSERT INTO "voyages" VALUES (1808, '', 3, '', 'IJSSELMONDE', 'Pieter Bogaard', 832, NULL, '1693', NULL, NULL, 'R', 'Z', '1699-05-09', 'Wielingen', '1699-10-16', '1699-11-09', true, '1700-02-04', 'Batavia', 6052, 'The ship was on 19-06-1699 at Guinea.');
INSERT INTO "voyages" VALUES (1809, '', 5, '', 'SION', 'Hendrik Henderson', 740, NULL, '1686', NULL, NULL, 'D', 'Z', '1699-05-19', 'Wielingen', '1699-10-27', '1699-11-20', true, '1700-02-22', 'Ceylon', 6067, NULL);
INSERT INTO "voyages" VALUES (1810, '', 1, '', 'LIEFDE', 'Kornelis Koleman', 1009, 'pinas', '1698', NULL, NULL, 'A', 'A', '1699-05-21', 'Texel', '1699-08-28', '1699-09-15', true, '1699-11-13', 'Batavia', 6044, NULL);
INSERT INTO "voyages" VALUES (1811, '', 2, '', 'BOOR', 'Jan van Wijk', 192, 'fluit', '1695', NULL, NULL, 'A', 'A', '1699-07-17', 'Texel', '1699-11-23', '1699-12-10', true, '1700-02-12', 'Batavia', 6049, 'From 15-08 till 29-08-1699 at S. Tiago.');
INSERT INTO "voyages" VALUES (1812, '', 4, '', 'LEK', 'Jan Plak', 762, 'pinas', '1686', NULL, NULL, 'A', 'A', '1699-10-08', 'Texel', '1700-02-08', NULL, true, '1700-02-08', 'The Cape', 6036, 'condition.');
INSERT INTO "voyages" VALUES (1813, '', 1, '', 'OEGSTGEEST', 'Jan de Wit', 576, 'hekboot', '1699', NULL, NULL, 'A', 'A', '1699-10-08', 'Texel', '1700-02-08', '1700-03-24', true, '1700-06-10', 'Batavia', 6074, NULL);
INSERT INTO "voyages" VALUES (1814, '', 2, '', 'MATROOS', 'Jakob Willemsz.', 288, 'fregat', '1692', NULL, NULL, 'A', 'A', '1699-12-03', 'Texel', '1700-03-19', '1700-03-26', true, '1700-05-25', 'Batavia', 2, 'Seafarers ran away at Plymouth. The ship laid up at Batavia in 1705.');
INSERT INTO "voyages" VALUES (1815, '', 1, '', 'TAXISBOOMPJE', 'Kornelis Valk', 614, NULL, '1699', NULL, NULL, 'D', 'D', '1699-12-13', 'Maas', '1700-04-17', '1700-05-16', true, '1700-07-06', 'Ceylon', 6134, 'The ship stayed from 19-12-1699 till 26-12-1699 in the Maas.');
INSERT INTO "voyages" VALUES (1816, '', 1, '', 'FLORA', 'Pieter Lubkes', 554, 'fluit', '1699', NULL, NULL, 'A', 'A', '1699-12-26', 'Texel', '1700-04-07', '1700-06-07', true, '1700-08-14', 'Batavia', 6067, NULL);
INSERT INTO "voyages" VALUES (1817, '', 1, '', 'HORSTENDAAL', 'Marten van de Vijver', 688, 'pinas', '1699', NULL, NULL, 'A', 'A', '1699-12-26', 'Texel', '1700-05-11', '1700-05-28', true, '1700-07-17', 'Ceylon', 6051, NULL);
INSERT INTO "voyages" VALUES (1818, '', 2, '', 'HUIS TE NIEUWBURG', 'Jakob Onkruid', 618, 'fluit? hekboot?', '1697', NULL, NULL, 'A', 'A', '1699-12-26', 'Texel', '1700-04-17', '1700-04-28', true, '1700-07-12', 'Batavia', 6084, NULL);
INSERT INTO "voyages" VALUES (1819, '', 3, '', 'OOSTERSTEIN', 'Usbrand Douwesz.', 1139, NULL, '1693', NULL, NULL, 'Z', 'A', '1699-12-26', 'Texel', '1700-04-11', '1700-05-09', true, '1700-07-05', 'Batavia', 6038, 'One child was born during the voyage.');
INSERT INTO "voyages" VALUES (1820, '', 1, '', 'THEEBOOM', 'Gerrit Gerritsz.', 526, 'fluit', '1699', NULL, NULL, 'A', 'A', '1699-12-26', 'Texel', '1700-04-06', '1700-05-14', true, '1700-07-14', 'Batavia', 6056, NULL);
INSERT INTO "voyages" VALUES (1821, '', 2, '', 'UNIE', 'Jan Vrelant', 1080, 'pinas', '1696', NULL, NULL, 'A', 'A', '1699-12-26', 'Texel', '1700-04-07', '1700-04-27', true, '1700-07-05', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1822, '', 1, '', 'ZOELEN', 'Kornelis Boesem', 656, 'fluit', '1699', NULL, NULL, 'R', 'R', '1699-12-26', 'Goeree', '1700-04-07', '1700-04-21', true, '1700-07-05', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1823, '', 2, '', 'DOMBURG', 'Kornelis Jorissen', 759, NULL, '1690', NULL, NULL, 'Z', 'Z', '1700-02-22', 'Wielingen', '1700-06-11', '1700-06-24', true, '1700-08-27', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1824, '', 1, '', 'ELLEMEET', 'Dirk Blauw', 670, NULL, '1699', NULL, NULL, 'Z', 'Z', '1700-02-22', 'Wielingen', '1700-06-11', '1700-06-24', true, '1700-09-08', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1825, '', 3, '', 'KARTHAGO', 'Pieter Donker', 759, NULL, '1692', NULL, NULL, 'Z', 'Z', '1700-02-22', 'Wielingen', '1700-06-05', '1700-06-17', true, '1700-08-14', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1826, '', 2, '', 'SCHELLAG', 'Jakob de la Palma', 290, 'jacht', '1696', NULL, NULL, 'Z', 'Z', '1700-02-22', 'Wielingen', '1700-06-13', '1700-07-21', true, '1700-09-10', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1827, '', 3, '', 'SCHOONDIJK', 'Willem van Texel', 759, NULL, '1688', NULL, NULL, 'Z', 'E', '1700-02-22', 'Texel', '1700-06-05', '1700-06-24', true, '1700-08-28', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1828, '', 2, '', 'ZANDLOPER', 'Kornelis van de Kriek', 244, 'fluit', '1695', NULL, NULL, 'D', 'Z', '1700-02-22', 'Wielingen', '1700-06-17', '1700-07-21', true, '1700-09-20', 'Ceylon', NULL, NULL);
INSERT INTO "voyages" VALUES (1829, '', 2, '', 'BAMBEEK', 'Evert Doedes', 845, 'pinas', '1696', NULL, NULL, 'A', 'A', '1700-04-22', 'Texel', '1700-08-31', '1700-09-21', true, '1700-11-19', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1830, '', 3, '', 'HUIS TE DIEREN', 'Kornelis Kool', 603, 'fluit', '1691', NULL, NULL, 'A', 'A', '1700-04-22', 'Texel', '1700-08-31', '1700-09-21', true, '1700-11-27', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1831, '', 1, '', 'HAAK', 'Sijbrand Visser', 550, 'fluit', '1699', NULL, NULL, 'E', 'E', '1700-04-22', 'Texel', '1700-08-27', '1700-09-12', true, '1700-11-18', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1832, '', 3, '', 'HOF VAN ILPENDAM', 'Jan Wijnands', 700, 'pinas', '1691', NULL, NULL, 'A', 'H', '1700-04-22', 'Texel', '1700-12-27', '1701-01-14', true, '1701-03-24', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1833, '', 3, '', 'REIGERSDAAL', 'Marten de Jeugd', 818, 'pinas', '1691', NULL, NULL, 'A', 'D', '1700-05-02', 'Goeree', '1700-08-22', '1700-09-12', true, '1700-11-14', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1834, '', 1, '', 'GENERALE VREDE', 'Harman Voet', 1008, 'pinas', '1699', NULL, NULL, 'A', 'A', '1700-05-02', 'Texel', '1700-08-31', '1700-09-21', true, '1700-12-08', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1835, '', 4, '', 'HUIS TE LOO', 'Jan de Wersijn', 875, 'pinas', '1691', NULL, NULL, 'A', 'Z', '1700-05-05', 'Wielingen', '1700-08-31', '1700-09-21', true, '1700-11-29', 'Batavia', 6083, 'One child was born during the voyage.');
INSERT INTO "voyages" VALUES (1836, '', 3, '', 'VOSMAAR', 'Hendrik den Exter', 759, NULL, '1691', NULL, NULL, 'Z', 'Z', '1700-05-05', 'Wielingen', '1700-08-26', '1700-09-12', true, '1700-11-08', 'Batavia', 6048, NULL);
INSERT INTO "voyages" VALUES (1837, '', 1, '', 'ZUIDPOOL', 'Pieter Hendriksz. Klein', 130, 'gajoot', '1700', NULL, NULL, 'A', 'A', '1700-07-08', 'Texel', '1700-11-05', '1700-11-11', true, '1701-04-12', 'Gamron', NULL, 'ZUIDPOOL went to Batavia; in 1708 arrival at India. Laid up at Batavia in 1715.');
INSERT INTO "voyages" VALUES (1838, '', 3, '', 'BRANDENBURG', 'Christiaan van Leeuwen', 817, NULL, '1690', NULL, NULL, 'A', 'A', '1700-09-29', 'Texel', '1701-01-25', '1701-02-15', true, '1701-05-07', 'Batavia', 6073, NULL);
INSERT INTO "voyages" VALUES (1839, '', 1, '', 'DIEMEN', 'Hendrik Mondiger', 596, 'fluit', '1700', NULL, NULL, 'A', 'A', '1700-09-29', 'Texel', '1701-01-25', '1700-02-15', true, '1701-06-23', 'Batavia', 6097, 'One soldier became a seafarer.');
INSERT INTO "voyages" VALUES (1840, '', 4, '', 'NICHTEVECHT', 'Jakob Kuil', 825, 'pinas', '1692', NULL, NULL, 'A', 'A', '1700-09-29', 'Texel', '1701-01-26', '1701-02-15', true, '1701-05-14', 'Batavia', 6064, 'Tiago.');
INSERT INTO "voyages" VALUES (1841, '', 2, '', 'NOORDGOUW', 'Volkert Schouten', 280, 'fregat', '1694', NULL, NULL, 'Z', 'A', '1700-09-29', 'Texel', '1700-12-29', NULL, true, '1700-12-29', 'The Cape', 6117, NULL);
INSERT INTO "voyages" VALUES (1842, '', 1, '', 'POPKENSBURG', 'Servaas Goudswaard', 804, NULL, '1699', NULL, NULL, 'Z', 'Z', '1700-10-28', 'Wielingen', '1701-04-18', '1701-05-10', true, '1701-07-20', 'Batavia', 6162, 'From 31-10 till 14-11-1700 at Duins; 1 seafarer deserted. 2 Seafarers ran away at the Cape.');
INSERT INTO "voyages" VALUES (1843, '', 2, '', 'BEKESTEIN', 'de Klunder', 324, 'pinas', '1694', NULL, NULL, 'A', 'A', '1700-12-15', 'Texel', '1701-04-12', '1701-04-30', true, '1701-07-09', 'Batavia', NULL, 'According to Coolhaas VI, 473 this ship was laid up at Batavia in 1707.');
INSERT INTO "voyages" VALUES (1844, '', 1, '', 'BEVERWIJK', 'Adriaan Palestein', 836, NULL, '1700', NULL, NULL, 'A', 'A', '1700-12-15', 'Texel', '1701-05-06', '1701-05-31', true, '1701-08-04', 'Batavia', 6145, 'One soldier became a seafarer.');
INSERT INTO "voyages" VALUES (1845, '', 3, '', 'DRECHTERLAND', 'Meindert de Boer', 756, NULL, '1688', NULL, NULL, 'E', 'E', '1700-12-15', 'Texel', '1701-04-13', '1701-05-09', true, '1701-07-10', 'Batavia', 6059, NULL);
INSERT INTO "voyages" VALUES (1846, '', 3, '', 'KATTENDIJK', 'Jakob Broek', 759, NULL, '1694', NULL, NULL, 'Z', 'A', '1700-12-15', 'Texel', '1701-04-05', '1701-04-27', true, '1701-06-26', 'Batavia', 6062, NULL);
INSERT INTO "voyages" VALUES (1847, '', 5, '', 'LEK', 'Klaas Schacht', 762, 'pinas', '1686', NULL, NULL, 'A', 'A', '1700-12-15', 'Texel', '1701-04-04', '1701-04-20', true, '1701-06-24', 'Ceylon', 6071, NULL);
INSERT INTO "voyages" VALUES (1848, '', 1, '', 'MOLENWERF', 'Pieter Florisz. Blom +', 554, 'fluit', '1700', NULL, NULL, 'H', 'H', '1700-12-15', 'Texel', '1701-04-12', '1701-05-09', true, '1701-07-23', 'Batavia', 6063, 'The master died during the voyage.');
INSERT INTO "voyages" VALUES (1849, '', 3, '', 'OVERNES', 'Herman Blokhuizen', 616, 'fluit', '1696', NULL, NULL, 'A', 'A', '1700-12-15', 'Texel', '1701-04-13', '1701-04-30', true, '1701-07-06', 'Batavia', 6065, NULL);
INSERT INTO "voyages" VALUES (1850, '', 5, '', 'SPIERDIJK', 'Gerrit de Boer', 606, 'fluit? hekboot?', '1685', NULL, NULL, 'A', 'A', '1700-12-15', 'Texel', '1701-04-11', '1701-05-31', true, '1701-08-04', 'Batavia', NULL, 'The ship was laid up at Batavia in 1708.');
INSERT INTO "voyages" VALUES (1851, '', 4, '', 'DRIEBERGEN', 'Dirk Krijne', 616, 'fluit', '1692', NULL, NULL, 'A', 'R', '1700-12-20', 'Goeree', '1701-06-25', '1701-07-12', true, '1701-10-09', 'Batavia', 6060, 'Portsmouth; 3 soldiers became seafarers. One child was born during the voyage.');
INSERT INTO "voyages" VALUES (1852, '', 4, '', 'SIRJANSLAND', 'Gerrit Hendriksz.', 759, NULL, '1691', NULL, NULL, 'Z', 'Z', '1700-12-21', 'Wielingen', '1701-06-24', '1701-07-10', true, '1701-09-16', 'Batavia', 6102, 'Back at Goeree: from 30-12-1700 till 18-01-1701. From 21-01 till 08-03-1701 at Duins.');
INSERT INTO "voyages" VALUES (1853, '', 5, '', 'BERKEL', 'Jan Gideons', 280, 'fluit', '1689', NULL, NULL, 'D', 'Z', '1701-01-18', 'Wielingen', '1701-06-23', '1701-07-10', true, '1701-09-18', 'Ceylon', 6069, 'The ship stayed till 03-03-1701 in England.');
INSERT INTO "voyages" VALUES (1854, '', 3, '', 'EIKELENBURG', 'Gerrit Hittens', 320, 'pinas', '1693', NULL, NULL, 'A', 'Z', '1701-01-18', 'Wielingen', '1701-06-23', '1701-07-23', true, '1701-10-05', 'Batavia', NULL, 'From 23-01 till 07-03-1701 at Portsmouth and from 30-03 till 04-04-1701 at S. Tiago.');
INSERT INTO "voyages" VALUES (1855, '', 1, '', 'GOUDEN PHOENIX', 'Arie Taats', 770, NULL, '1700', NULL, NULL, 'Z', 'Z', '1701-01-18', 'Wielingen', '1701-06-23', '1701-07-10', true, '1701-09-16', 'Batavia', NULL, 'From 21-01 till 08-03-1701 at Wight; on 13-01-1705 at the coast of Coromandel taken by 4 French ships.');
INSERT INTO "voyages" VALUES (1856, '', 2, '', 'CONCORDIA', 'Jan Munkhoven', 900, NULL, '1696', NULL, NULL, 'D', 'Z', '1701-04-12', 'Wielingen', '1701-08-19', '1701-09-05', true, '1701-11-20', 'Batavia', 6107, 'One seafarer deserted at the Cape.');
INSERT INTO "voyages" VALUES (1857, '', 4, '', 'MIJDRECHT', 'Jan Jongerens', 597, 'pinas', '1688', NULL, NULL, 'A', 'R', '1701-04-13', 'Goeree', '1701-08-05', '1701-09-05', true, '1701-11-30', 'Batavia', NULL, 'On 17-04-1701 second departure. Laid up at Batavia in 1707.');
INSERT INTO "voyages" VALUES (1858, '', 5, '', 'VOORSCHOTEN', 'Gijsbert Martensz. Welgevaren', 558, 'fluit', '1684', NULL, NULL, 'D', 'D', '1701-04-13', 'Goeree', '1701-08-27', '1701-09-26', true, '1702-01-08', 'Batavia', NULL, 'The ship was laid up at Batavia on 09-11-1706.');
INSERT INTO "voyages" VALUES (1859, '', 3, '', 'BERKENRODE', 'Jan Abraham van Oldenhove', 635, 'fluit', '1694', NULL, NULL, 'A', 'A', '1701-04-25', 'Texel', '1701-12-13', '1702-01-06', true, '1702-05-04', 'Batavia', 6095, 'From 13-08 till 22-08-1701 at Cape Lopez; from 11-10 till 19-10-1701 at S. Paulo.');
INSERT INTO "voyages" VALUES (1860, '', 5, '', 'HANDBOOG', 'Klaas Goudenberg', 594, 'fluit', '1687', NULL, NULL, 'A', 'H', '1701-04-25', 'Texel', '1701-09-19', '1701-10-12', true, '1702-01-08', 'Batavia', NULL, 'From 23-07 till 31-07-1701 at Annabon. Laid up at Batavia in 1706.');
INSERT INTO "voyages" VALUES (1861, '', 3, '', 'HUIS OVERRIJP', 'Willem Knol', 436, 'fluit', '1693', NULL, NULL, 'H', 'E', '1701-04-25', 'Texel', '1701-12-13', '1702-01-06', true, '1702-05-24', 'Batavia', 6092, 'The ship stayed at S. Paulo from 11-10 till 19-10-1701.');
INSERT INTO "voyages" VALUES (1862, '', 4, '', 'SPIEGEL', 'Abraham Zeeman', 831, 'pinas', '1693', NULL, NULL, 'A', 'A', '1701-04-25', 'Texel', '1701-10-04', '1701-10-25', true, '1702-01-22', 'Batavia', 6087, 'From 23-07 till 31-07-1701 at Annabon.');
INSERT INTO "voyages" VALUES (1863, '', 6, '', 'LANDS WELVAREN', 'Adolf Hage', 1145, 'pinas', '1685', NULL, NULL, 'A', 'A', '1701-04-25', 'Texel', '1701-10-04', '1701-10-25', true, '1702-01-12', 'Batavia', 6089, 'The ship stayed at Annabon from 23-07 till 31-07-1701.');
INSERT INTO "voyages" VALUES (1864, '', 3, '', 'GRIMMESTEIN', 'Adriaan Tilburg', 759, NULL, '1696', NULL, NULL, 'A', 'Z', '1701-05-03', 'Wielingen', '1701-09-24', '1701-10-19', true, '1702-02-05', 'Batavia', 6081, 'From 05-05 till 14-05-1701 at Wight.');
INSERT INTO "voyages" VALUES (1865, '', 2, '', 'GEELVINK', 'Klaas Maas', 380, 'fregat? jacht?', '1696', NULL, NULL, 'A', 'A', '1701-06-05', 'Texel', '1701-09-10', '1701-10-25', true, '1701-12-22', 'Batavia', 6078, NULL);
INSERT INTO "voyages" VALUES (1866, '', 1, '', 'DEN BERG', 'Aldert Koops', 836, NULL, '1701', NULL, NULL, 'A', 'A', '1701-10-04', 'Texel', '1702-04-15', '1702-05-02', true, '1702-07-16', 'Batavia', 6123, 'On 01-04-1702 at Dasseneiland.');
INSERT INTO "voyages" VALUES (1867, '', 1, '', '''T GHIJN', 'Fokel Hendriksz.', 810, NULL, '1701', NULL, NULL, 'A', 'A', '1701-10-04', 'Texel', '1702-08-04', '1702-08-24', true, '1702-11-28', 'Batavia', 6146, 'The ship lost the main mast on 24-11-1701 and took refuge at Milfort till 23-04-1702. 35 Seafarers and 11 soldiers ran away; 31 seafarers and 17 soldiers signed on.');
INSERT INTO "voyages" VALUES (1868, '', 2, '', 'LIEFDE', 'Anthonie Pronk', 1009, 'pinas', '1698', NULL, NULL, 'A', 'A', '1701-10-04', 'Texel', '1702-02-26', '1702-03-30', true, '1702-06-25', 'Batavia', 6082, NULL);
INSERT INTO "voyages" VALUES (1869, '', 4, '', 'MERESTEIN', 'Jan Subbing', 826, 'pinas', '1693', NULL, NULL, 'A', 'A', '1701-10-04', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'there were 99 survivors; the cargo was lost.');
INSERT INTO "voyages" VALUES (1870, '', 2, '', 'THEEBOOM', 'David Kodde', 526, 'fluit', '1699', NULL, NULL, 'A', 'A', '1701-10-04', 'Texel', '1702-04-04', '1702-04-21', true, '1702-06-28', 'Batavia', 6093, NULL);
INSERT INTO "voyages" VALUES (1871, '', 4, '', 'GENT', 'Libertus Boon', 816, NULL, '1693', NULL, NULL, 'E', 'Z', '1701-11-04', 'Wielingen', '1702-03-24', '1702-04-08', true, '1702-06-21', 'Batavia', 6080, 'From 05-11 till 08-11-1701 back at the Wielingen.');
INSERT INTO "voyages" VALUES (1872, '', 1, '', 'BODE', 'Jan Larous', 172, NULL, '1701', NULL, NULL, 'A', 'A', '1701-12-21', 'Texel', '1702-05-14', '1702-08-24', true, '1702-10-29', 'Ceylon', NULL, 'The master might also have been called Leroux (6100). On 14-01-1707 taken by the pirate `Cangie Angrie''.');
INSERT INTO "voyages" VALUES (1873, '', 2, '', 'HUIS TE BIJWEG', 'Herman Stellingwerf', 392, 'fluit', '1699', NULL, NULL, 'A', 'A', '1701-12-21', 'Texel', '1702-05-16', '1702-06-24', true, '1702-09-05', 'Batavia', 6090, NULL);
INSERT INTO "voyages" VALUES (1874, '', 3, '', 'DONKERVLIET', 'Justinus van Zand', 794, NULL, '1696', NULL, NULL, 'Z', 'D', '1701-12-21', 'Goeree', '1702-06-01', '1702-06-24', true, '1702-09-05', 'Batavia', 6098, 'The ship stayed from 27-12-1701 till 15-01-1702 at Duins.');
INSERT INTO "voyages" VALUES (1875, '', 2, '', 'HAAK', 'Baltus Doen +', 550, 'fluit', '1699', NULL, NULL, 'E', 'H', '1701-12-21', 'Texel', '1702-05-16', '1702-06-02', true, '1702-08-06', 'Batavia', 6100, 'The master Baltus Doen died during the voyage.');
INSERT INTO "voyages" VALUES (1876, '', 1, '', 'HUIS TE HEMERT', 'Thomas du Bois', 612, 'fluit', '1701', NULL, NULL, 'A', 'A', '1701-12-21', 'Texel', '1702-04-22', '1702-05-15', true, '1702-08-24', 'Batavia', 6110, NULL);
INSERT INTO "voyages" VALUES (1877, '', 2, '', 'HORSTENDAAL', 'Jan de Rooy', 688, 'pinas', '1699', NULL, NULL, 'A', 'A', '1701-12-21', 'Texel', '1702-04-20', '1702-05-09', true, '1702-07-21', 'Ceylon', 6091, NULL);
INSERT INTO "voyages" VALUES (1878, '', 1, '', 'KIEFHOEK', 'Robbert de Groot', 832, NULL, '1701', NULL, NULL, 'R', 'R', '1701-12-21', 'Goeree', '1702-05-11', '1702-06-02', true, '1702-07-28', 'Batavia', 6126, 'From 01-01 till 15-01-1702 at Duins.');
INSERT INTO "voyages" VALUES (1879, '', 4, '', 'REIGERSDAAL', 'Jakob Zalm', 818, 'pinas', '1691', NULL, NULL, 'A', 'A', '1701-12-21', 'Texel', '1702-04-13', '1702-05-02', true, '1702-07-10', 'Batavia', 6086, '6 Seafarers ran away at the Cape.');
INSERT INTO "voyages" VALUES (1880, '', 2, '', 'VENHUIZEN', 'Dirk de Reus', 250, 'fluit', '1697', NULL, NULL, 'E', 'E', '1701-12-21', 'Texel', '1702-06-06', '1702-06-25', true, '1702-09-05', 'Batavia', 6122, 'One child was born during the voyage.');
INSERT INTO "voyages" VALUES (1881, '', 4, '', 'VOSMAAR', 'Pieter Muis', 759, NULL, '1691', NULL, NULL, 'Z', 'A', '1701-12-21', 'Texel', '1702-07-26', '1702-08-08', true, '1702-10-13', 'Batavia', 6088, 'From 11-01 till 26-04-1702 at Plymouth; 17 seafarers ran away.');
INSERT INTO "voyages" VALUES (1882, '', 3, '', 'DOMBURG', 'Matthijs de Geus', 759, NULL, '1690', NULL, NULL, 'Z', 'Z', '1701-01-15', 'Wielingen', '1702-06-17', '1702-07-07', true, '1702-09-08', 'Batavia', 6079, 'The ship stayed from 30-01 till 05-03-1702 at Wight.');
INSERT INTO "voyages" VALUES (1883, '', 4, '', 'OOSTERSTEIN', 'Jan Geens', 1139, NULL, '1693', NULL, NULL, 'Z', 'Z', '1702-01-15', 'Wielingen', '1702-06-12', '1702-07-07', true, '1702-09-09', 'Batavia', 6085, 'At Torbay from 26-01 till 05-03-1702.');
INSERT INTO "voyages" VALUES (1884, '', 1, '', 'ZUIDDORP', 'Kornelis Jorissen', 1152, NULL, '1701', NULL, NULL, 'Z', 'Z', '1702-01-15', 'Wielingen', '1702-06-12', '1702-07-07', true, '1702-10-06', 'Batavia', 6140, 'The ship stayed from 26-01 till 05-03-1702 at Torbay; 7 seafarers and 1 soldier ran away.');
INSERT INTO "voyages" VALUES (1885, '', 2, '', 'PEPERBOOM', 'Jan Leeuwe', 553, 'fluit', '1699', NULL, NULL, 'A', 'Z', '1702-03-19', 'Wielingen', '1702-06-29', '1702-07-20', true, '1702-10-06', 'Batavia', NULL, 'The ship was laid up at Batavia in 1709.');
INSERT INTO "voyages" VALUES (1886, '', 1, '', 'WATERINGEN', 'Jan Lookman', 626, 'jacht', '1701', NULL, NULL, 'D', 'D', '1702-04-15', 'Goeree', '1702-08-18', '1702-09-02', true, '1702-11-22', 'Batavia', 6158, NULL);
INSERT INTO "voyages" VALUES (1887, '', 4, '', 'IJSSELMONDE', 'Jakob Helma', 832, NULL, '1693', NULL, NULL, 'R', 'A', '1702-04-15', 'Texel', '1702-08-26', '1702-10-04', true, '1702-12-09', 'Batavia', 6106, '(1919) on 16-05-1702.');
INSERT INTO "voyages" VALUES (1888, '', 3, '', 'JERUSALEM', 'Hendrik Bichon', 622, 'fluit', '1693', NULL, NULL, 'R', 'R', '1702-04-25', 'Goeree', '1702-09-17', '1702-10-14', true, '1703-01-14', 'Batavia', 6115, NULL);
INSERT INTO "voyages" VALUES (1889, '', 3, '', 'STAD KEULEN', 'Dekker', 1089, 'pinas', '1693', NULL, NULL, 'A', 'A', '1702-04-25', 'Texel', '1702-08-30', '1702-10-04', true, '1702-12-09', 'Batavia', NULL, 'The ship was laid up at Batavia in 1707.');
INSERT INTO "voyages" VALUES (1890, '', 1, '', 'BUISJE', 'Paulus Visser', 160, NULL, NULL, NULL, '1701', 'A', 'A', '1702-04-27', 'Texel', '1702-09-18', '1702-10-04', true, '1702-12-16', 'Batavia', NULL, 'Departure from Plymouth on 30-05-1702. Laid up at Batavia in 1707.');
INSERT INTO "voyages" VALUES (1891, '', 4, '', 'SCHOONDIJK', 'Salig Sijbrands', 759, NULL, '1688', NULL, NULL, 'Z', 'H', '1702-05-06', 'Texel', '1702-08-27', '1702-09-14', true, '1702-11-13', 'Batavia', NULL, 'According to Coolhaas VI, 473 the SCHOONDIJK was laid up in 1707.');
INSERT INTO "voyages" VALUES (1892, '', 3, '', 'BEIEREN', 'Jan Heuld', 832, NULL, '1692', NULL, NULL, 'D', 'Z', '1702-05-07', 'Wielingen', '1702-09-30', '1702-11-02', true, '1703-02-26', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1893, '', 1, '', 'POSTLOPER', 'Kornelis Jongeboer', 130, NULL, '1701', NULL, NULL, 'A', 'A', '1702-05-07', NULL, '1702-09-30', NULL, true, '1702-09-30', 'The Cape', NULL, 'The ship was captured on 13-03-1703.');
INSERT INTO "voyages" VALUES (1894, '', 1, '', 'SUIKERMOLEN', 'Klaas van Convent', 720, 'fluit', '1701', NULL, NULL, 'Z', 'Z', '1702-05-07', 'Wielingen', '1702-09-21', '1702-10-14', true, '1703-01-15', 'Batavia', 6096, NULL);
INSERT INTO "voyages" VALUES (1895, '', 1, '', 'TER EEM', 'Haye Jansz.', 262, NULL, '1701', NULL, NULL, 'A', 'A', '1702-05-15', 'Texel', '1702-08-20', '1702-08-31', true, '1702-11-23', 'Ceylon', NULL, NULL);
INSERT INTO "voyages" VALUES (1896, '', 1, '', 'ZANDHORST', 'Jakob de Boer', 520, 'fluit', '1701', NULL, NULL, 'A', 'A', '1702-05-15', 'Texel', '1702-09-17', '1702-10-14', true, '1702-12-21', 'Batavia', 6094, NULL);
INSERT INTO "voyages" VALUES (1897, '', 1, '', 'ZEGEN', 'Krijn Bollaart', 180, NULL, NULL, '1702', NULL, 'A', 'A', '1702-05-15', 'Texel', '1702-09-17', '1702-10-04', true, NULL, NULL, NULL, 'The ship was captured on 13-03-1703.');
INSERT INTO "voyages" VALUES (1898, '', 1, '', 'MERCURIUS', 'Theodorus Tijd', 170, 'galjoot', '1700', NULL, NULL, 'A', 'A', '1702-07-03', 'Texel', '1703-01-13', '1703-01-31', true, '1703-05-30', 'Batavia', NULL, 'From 12-07 till 18-07-1702 at Hitland and from 28-10 till 29-10-1702 at Guinea.');
INSERT INTO "voyages" VALUES (1899, '', 4, '', 'BRANDENBURG', 'Jakob Willemsz.', 817, NULL, '1690', NULL, NULL, 'A', 'A', '1702-10-02', 'Texel', '1703-01-26', '1703-02-15', true, '1703-06-02', 'Batavia', 6114, NULL);
INSERT INTO "voyages" VALUES (1900, '', 1, '', 'BEVERWAART', 'Jakob Helma', 760, NULL, '1702', NULL, NULL, 'A', 'A', '1702-10-08', 'Texel', '1703-03-12', '1703-03-30', true, '1703-06-10', 'Batavia', 6124, NULL);
INSERT INTO "voyages" VALUES (1901, '', 1, '', 'GANSENHOF', 'Pieter Oostendorp', 640, 'fluit', '1702', NULL, NULL, 'A', 'A', '1702-10-08', 'Texel', '1703-01-29', '1703-02-15', true, '1703-06-03', 'Batavia', 6109, NULL);
INSERT INTO "voyages" VALUES (1902, '', 3, '', 'VECHT', 'Arnoldus van der Straten', 626, 'fluit', '1693', NULL, NULL, 'A', 'D', '1703-01-13', 'Goeree', '1703-05-04', '1703-05-20', true, '1703-08-05', 'Batavia', NULL, 'The ship stayed from 25-01 till 28-01-1703 at Portsmouth. Laid up and sold at Batavia in 1709.');
INSERT INTO "voyages" VALUES (1903, '', 4, '', 'DRECHTERLAND', 'Willem van Texel', 756, NULL, '1688', NULL, NULL, 'E', 'E', '1703-01-22', 'Texel', '1703-06-20', '1703-07-27', true, '1703-09-30', 'Batavia', NULL, 'The ship was laid up at Batavia on 10-06-1706.');
INSERT INTO "voyages" VALUES (1904, '', 5, '', 'DRIEBERGEN', 'Jakob Regenboog', 616, 'fluit', '1692', NULL, NULL, 'A', 'A', '1703-01-22', 'Texel', '1703-05-09', '1703-05-26', true, '1703-08-05', 'Batavia', 6108, NULL);
INSERT INTO "voyages" VALUES (1905, '', 2, '', 'FLORA', 'Jan Schaaf', 554, 'fluit', '1699', NULL, NULL, 'A', 'A', '1703-01-22', 'Texel', '1703-05-11', '1703-07-16', true, '1703-09-12', 'Batavia', 6099, NULL);
INSERT INTO "voyages" VALUES (1906, '', 2, '', 'MOLENWERF', 'Dirk Danielsz. Bent', 594, 'fluit', '1700', NULL, NULL, 'H', 'H', '1703-01-22', 'Texel', '1703-05-18', '1703-05-30', true, '1703-08-10', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1907, '', 4, '', 'OVERNES', 'Herman de Marre', 616, 'fluit', '1696', NULL, NULL, 'A', 'A', '1703-01-22', 'Texel', '1703-05-09', '1703-05-26', true, '1703-07-22', 'Batavia', 6127, NULL);
INSERT INTO "voyages" VALUES (1908, '', 1, '', 'HUIS TE ROZENBURG', 'Herman Jurriaansz. Doel', 576, 'fluit', '1702', NULL, NULL, 'A', 'A', '1703-01-22', 'Texel', '1703-05-20', '1703-06-08', true, '1703-08-10', 'Batavia', 6132, NULL);
INSERT INTO "voyages" VALUES (1909, '', 6, '', 'SION', 'Jan Meier', 740, NULL, '1686', NULL, NULL, 'D', 'A', '1703-01-22', 'Texel', '1703-10-15', '1703-11-08', true, '1704-01-28', 'Ceylon', NULL, 'The ship stayed at Lisbon till 30-06-1703. Laid up and sold at Batavia in 1709.');
INSERT INTO "voyages" VALUES (1910, '', 3, '', 'UNIE', 'Christiaan van Leeuwen', 1080, 'pinas', '1696', NULL, NULL, 'A', 'A', '1703-01-22', 'Texel', '1703-05-20', '1703-06-08', true, '1703-08-07', 'Batavia', 6103, NULL);
INSERT INTO "voyages" VALUES (1911, '', 2, '', 'GENERALE VREDE', 'Diedlof Kroes', 1008, 'pinas', '1699', NULL, NULL, 'A', 'A', '1703-01-22', 'Texel', '1703-05-09', '1703-05-26', true, '1703-08-05', 'Batavia', 6105, NULL);
INSERT INTO "voyages" VALUES (1912, '', 2, '', 'ABBEKERK', 'Adriaan Gelijnsz.', 242, 'fluit', '1698', NULL, NULL, 'H', 'Z', '1703-02-22', 'Wielingen', '1703-06-07', '1703-07-16', true, '1703-09-12', 'Batavia', 6112, NULL);
INSERT INTO "voyages" VALUES (1913, '', 4, '', 'KARTHAGO', 'Isaak Keuvel', 759, NULL, '1692', NULL, NULL, 'Z', 'Z', '1703-02-22', 'Wielingen', '1703-05-27', '1703-06-16', true, '1703-08-12', 'Batavia', 6147, NULL);
INSERT INTO "voyages" VALUES (1914, '', 3, '', 'VRIJBURG', 'Marten Engele', 784, NULL, '1695', NULL, NULL, 'Z', 'Z', '1703-02-22', 'Wielingen', '1703-06-03', '1703-07-16', true, '1703-09-11', 'Ceylon', 6111, NULL);
INSERT INTO "voyages" VALUES (1915, '', 1, '', 'WAARDE', 'Jakob de Jong', 830, NULL, '1702', NULL, NULL, 'Z', 'Z', '1703-02-22', 'Wielingen', '1703-06-17', '1703-07-27', true, '1703-09-22', 'Batavia', 6163, NULL);
INSERT INTO "voyages" VALUES (1916, '', 5, '', 'BELOIS', 'Jakob van Belle', 506, 'fluit', '1687', NULL, NULL, 'D', 'R', '1703-04-27', 'Goeree', '1703-09-12', '1703-10-08', true, '1703-12-13', 'Batavia', 6113, NULL);
INSERT INTO "voyages" VALUES (1917, '', 2, '', 'SCHOONDERLOO', 'Willem Elshoek', 622, 'fluit', '1693', NULL, NULL, 'D', 'D', '1703-04-27', 'Goeree', '1703-08-31', '1703-10-06', true, '1703-12-14', 'Batavia', 6116, NULL);
INSERT INTO "voyages" VALUES (1918, '', 6, '', 'BERKEL', 'Isaak Philipsz.', 280, 'fluit', '1689', NULL, NULL, 'D', 'A', '1703-04-28', 'Texel', '1703-10-01', '1703-11-04', true, '1704-01-20', 'Batavia', NULL, 'The ship was laid up at Batavia in 1710');
INSERT INTO "voyages" VALUES (1919, '', 4, '', 'DRIE KRONEN', 'Meindert de Boer', 1075, 'pinas', '1693', NULL, NULL, 'A', 'A', '1703-04-28', 'Texel', '1703-08-28', '1703-10-15', true, '1703-12-09', 'Batavia', 6176, '1708.');
INSERT INTO "voyages" VALUES (1920, '', 1, '', 'LOKHORST', 'Hendrik Som', 612, 'fluit', '1702', NULL, NULL, 'E', 'E', '1703-04-28', 'Texel', '1703-10-04', '1703-11-07', true, '1704-01-20', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1921, '', 5, '', 'NICHTEVECHT', 'Kornelis de Vlaming', 825, 'pinas', '1692', NULL, NULL, 'A', 'A', '1703-04-28', 'Texel', '1703-08-30', '1703-10-15', true, '1703-12-09', 'Batavia', NULL, 'Laid up at Batavia in 1711.');
INSERT INTO "voyages" VALUES (1922, '', 2, '', 'OEGSTGEEST', 'Martinus van Dijk', 576, 'hekboot', '1699', NULL, NULL, 'A', 'H', '1703-04-28', 'Texel', '1703-10-11', '1703-11-08', true, '1704-01-13', 'Batavia', 6131, NULL);
INSERT INTO "voyages" VALUES (1923, '', 6, '', 'LEK', 'Gerrit Koek', 762, 'pinas', '1686', NULL, NULL, 'A', 'A', '1703-05-27', 'Texel', '1703-10-14', '1703-11-12', true, '1704-01-20', 'Batavia', NULL, 'Laid up at Batavia in 1707.');
INSERT INTO "voyages" VALUES (1924, '', 1, '', 'HUIS TER BOEDE', 'Jan Hoebeek', 642, NULL, '1702', NULL, NULL, 'Z', 'Z', '1703-06-14', 'Wielingen', '1703-11-04', '1703-12-14', true, '1704-03-19', 'Batavia', 6178, NULL);
INSERT INTO "voyages" VALUES (1925, '', 4, '', 'KATTENDUK', 'Huibrecht Kakelaar', 759, NULL, '1694', NULL, NULL, 'Z', 'Z', '1703-06-14', 'Wielingen', '1703-10-30', '1703-12-14', true, '1704-02-29', 'Batavia', 6130, 'The master died during the voyage.');
INSERT INTO "voyages" VALUES (1926, '', 1, '', 'HAZELNOOT', 'Jan Haysen', 130, 'galjoot', '1698', NULL, NULL, 'A', 'A', '1703-11-17', 'Texel', '1704-04-26', '1704-05-12', true, '1704-07-20', 'Batavia', 6152, NULL);
INSERT INTO "voyages" VALUES (1927, '', 1, '', 'SINT JAN', 'Jan Sanderus', 130, 'galjoot', '1703', NULL, NULL, 'A', 'A', '1703-11-17', 'Texel', '1704-04-24', '1704-05-12', true, '1704-07-07', 'Batavia', NULL, 'The ship was laid up at Batavia in 1709');
INSERT INTO "voyages" VALUES (1928, '', 1, '', 'PRINS EUGENIUS', 'Klaas Nanningsz. Sanderus', 874, NULL, '1703', NULL, NULL, 'A', 'A', '1703-11-19', 'Texel', '1704-05-05', '1704-06-01', true, '1704-08-10', 'Batavia', 6188, 'From 03-01 till 17-01-1704 at Portsmouth.');
INSERT INTO "voyages" VALUES (1929, '', 1, '', 'HUIS TER HAAN', 'Albert Barendsz. Fokkes', 322, NULL, '1702', NULL, NULL, 'A', 'A', '1703-11-19', 'Texel', '1704-03-19', '1704-03-30', true, '1704-05-26', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1930, '', 3, '', 'HORSTENDAAL', 'Vis', 688, 'pinas', '1699', NULL, NULL, 'A', 'A', '1703-11-19', 'Texel', NULL, NULL, false, '1704-08-04', 'Batavia', 6121, 'From 03-01 till 06-01-1704 back at Texel due to a storm; 12-01 till 16-01 at Portsmouth; 30-01 till 02-02 at Torbay; 04-02 till 24-02 again at Portsmouth where 3 seafarers ran away.');
INSERT INTO "voyages" VALUES (1931, '', 1, '', 'RENSWOUDE', 'Leendert de Haan', 588, NULL, '1703', NULL, NULL, 'A', 'A', '1703-11-19', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ship was wrecked at Ameland on 13-12-1703.');
INSERT INTO "voyages" VALUES (1932, '', 3, '', 'THEEBOOM', 'Arie Schut', 526, 'fluit', '1699', NULL, NULL, 'A', 'A', '1703-11-19', 'Texel', '1704-05-05', '1704-05-19', true, '1704-07-20', 'Batavia', 6128, 'The ship was back at Texel 27-12 till 06-01-1704 forced by a storm; 12-01 from till 17-01-1704 at Portsmouth. The passenger was a stowaway');
INSERT INTO "voyages" VALUES (1933, '', 1, '', 'BOGAARD', 'Michiel Pietersz. van Parra', 200, 'fluit', '1703', NULL, NULL, 'D', 'D', '1704-01-03', 'Goeree', NULL, NULL, false, '1704-07-30', 'Batavia', NULL, 'From 06-01 till 17-01-1704 at Portsmouth. Again at Portsmouth 27-01 till 24-02-1704, due to a storm. 4 Seafarers ran away.');
INSERT INTO "voyages" VALUES (1934, '', 3, '', 'HUIS TER DUINE', 'Pieter Opterwilt', 588, NULL, '1693', NULL, NULL, 'Z', 'Z', '1704-01-03', 'Wielingen', '1704-04-27', '1704-05-17', true, '1704-08-01', 'Batavia', 6120, 'According to Coolhaas VI, 289, the HUIS TER DUINE arrived on 10-08-1704 at Batavia.');
INSERT INTO "voyages" VALUES (1935, '', 4, '', 'GRIMMESTEIN', 'Dirk Krijne', 759, NULL, '1696', NULL, NULL, 'A', 'R', '1704-01-03', 'Goeree', '1704-05-26', '1704-06-19', true, '1704-08-22', 'Batavia', 6125, 'With BOGAARD (1933) and REIGERSDAAL (1936) at Portsmouth, from 06-01 till 17-01-1704 and from 27-01 till 24-01-1704. Two seafarers ran away.');
INSERT INTO "voyages" VALUES (1936, '', 5, '', 'REIGERSDAAL', 'Jakob Joppe de Jong', 818, 'pinas', '1691', NULL, NULL, 'A', 'D', '1704-01-03', 'Goeree', '1704-05-22', '1704-06-01', true, '1704-08-01', 'Batavia', NULL, 'At Portsmouth from 06-01 till 17-01-1704 and from 27-01 till 24-02-1704. Two seafarers embarked. According to Coolhaas VI, 289, the REIGERSDAAL arrived on 10-08-1704 at Batavia. Laid up and sold at Batavia in 1709.');
INSERT INTO "voyages" VALUES (1937, '', 1, '', 'SCHONEWAL', 'Jakob de Bije', 632, 'jacht', '1703', NULL, NULL, 'Z', 'Z', '1704-01-03', 'Wielingen', '1704-05-12', '1704-06-02', true, '1704-08-04', 'Batavia', 6197, NULL);
INSERT INTO "voyages" VALUES (1938, '', 1, '', 'ZEEHAAN', NULL, 130, NULL, '1702', NULL, NULL, 'E', 'E', '1704-01-09', 'Texel', '1704-06-10', '1704-06-15', true, '1704-09-08', 'Ceylon', 6135, NULL);
INSERT INTO "voyages" VALUES (1939, '', 3, '', 'GEELVINK', 'Christiaan Zwart', 380, 'jacht', '1696', NULL, NULL, 'A', 'A', '1704-01-12', 'Texel', '1704-07-30', '1704-08-18', true, '1704-11-09', 'Batavia', NULL, 'From 05-02 till 04-03-1704 at Ireland due to a storm; from 14-04 till 18-04-1704 at S. Tiago. The 2 passengers were stowaways. The ship was laid up at Batavia in 1711.');
INSERT INTO "voyages" VALUES (1940, '', 1, '', 'HAMER', 'Kornelis Zeeman', 170, NULL, '1702', NULL, NULL, 'A', 'A', '1704-01-12', 'Texel', '1704-06-29', NULL, true, '1704-06-29', 'The Cape', NULL, NULL);
INSERT INTO "voyages" VALUES (1941, '', 3, '', 'ASSENDELFT', 'Pieter Jansz. Bot', 816, 'pinas', '1694', NULL, NULL, 'A', 'Z', '1704-02-27', 'Wielingen', '1704-06-17', '1704-07-08', true, '1704-09-24', 'Batavia', 6118, NULL);
INSERT INTO "voyages" VALUES (1942, '', 4, '', 'DOMBURG', 'Bartholomeus le Fain +', 759, NULL, '1690', NULL, NULL, 'Z', 'Z', '1704-02-27', 'Wielingen', '1704-06-02', '1704-06-28', true, '1704-08-28', 'Batavia', 6119, 'The master died and he was succeeded by Martinus Pattemier.');
INSERT INTO "voyages" VALUES (1943, '', 3, '', 'HUIS TE BIJWEG', 'Jakob Verzijde', 392, 'fluit', '1699', NULL, NULL, 'A', 'D', '1704-05-09', 'Goeree', '1704-10-10', '1704-12-19', true, '1705-04-04', 'Batavia', NULL, 'From 10-10 till 22-11-1704 at Saldanha Bay.');
INSERT INTO "voyages" VALUES (1944, '', 4, '', 'HUIS OVERRIJP', 'Wessel van Neerkassel', 436, 'fluit', '1693', NULL, NULL, 'H', 'R', '1704-05-09', 'Goeree', '1704-09-12', '1704-10-10', true, '1705-01-19', 'Batavia', NULL, 'The ship was laid up at the Cape in 1710. The two passengers were stowaways.');
INSERT INTO "voyages" VALUES (1945, '', 1, '', 'BREDENHOF', 'Jan Portier', 586, 'fluit', '1703', NULL, NULL, 'H', 'H', '1704-05-11', 'Texel', '1704-10-25', '1704-12-19', true, '1705-04-19', 'Batavia', 6187, 'From 13-10 till 14-10-1704 at Dasseneiland and from 15-10 till 22-10-1704 at Saldanha Bay.');
INSERT INTO "voyages" VALUES (1946, '', 3, '', 'LIEFDE', 'Jakob Broek', 1009, 'pinas', '1698', NULL, NULL, 'A', 'A', '1704-05-11', 'Texel', '1704-09-04', '1704-10-05', true, '1704-12-15', 'Batavia', 6157, NULL);
INSERT INTO "voyages" VALUES (1947, '', 5, '', 'HUIS TE LOO', 'Kornelis Kool', 875, 'pinas', '1691', NULL, NULL, 'A', 'A', '1704-05-11', 'Texel', '1704-09-04', '1704-10-05', true, '1704-12-18', 'Ceylon', 6142, NULL);
INSERT INTO "voyages" VALUES (1948, '', 3, '', 'HUIS TE NIEUWBURG', 'Leendert Klaasz. Broek', 618, 'hekboot fluit', '1697', NULL, NULL, 'A', 'H', '1704-05-11', 'Texel', '1704-10-02', '1704-11-06', true, '1705-01-28', 'Batavia', 6151, 'One passenger was a stowaway.');
INSERT INTO "voyages" VALUES (1949, '', 5, '', 'SPIEGEL', 'Jan Eekhout', 831, 'pinas', '1693', NULL, NULL, 'A', 'A', '1704-05-11', 'Texel', '1704-09-09', '1704-10-05', true, '1704-12-10', 'Batavia', 6133, 'One child was born during the voyage.');
INSERT INTO "voyages" VALUES (1950, '', 1, '', 'BON', 'Klaas Kompas', 600, 'fluit', '1703', NULL, NULL, 'A', 'A', '1704-06-16', 'Texel', '1704-12-16', '1705-01-18', true, '1705-05-14', 'Batavia', 6165, 'The ship was together with the KONING KAREL DE DERDE (1952) and the VOSMAAR (1953) (forced by a storm) at Annabon 14-10 till 19-10-1704 and at St. Helena from 12-11 till 19-11-1704.');
INSERT INTO "voyages" VALUES (1951, '', 5, '', 'GENT', 'Willem Knot', 816, NULL, '1693', NULL, NULL, 'E', 'E', '1704-06-16', 'Texel', '1704-12-15', '1705-01-13', true, '1705-05-14', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (1952, '', 1, '', 'KONING KAREL DE DERDE', 'Herman Stellingwerf', 830, NULL, '1704', NULL, NULL, 'A', 'A', '1704-06-16', 'Texel', '1704-12-16', '1705-01-05', true, '1705-04-06', 'Batavia', 6161, 'In a storm main mast was damaged and the ship ran aground at Annabon, from 14-10 till 19-10-1704. From 12-11 till 19-11-1704 at St-Helena.');
INSERT INTO "voyages" VALUES (1953, '', 5, '', 'VOSMAAR', 'Thomasz.', 759, NULL, '1691', NULL, NULL, 'Z', 'A', '1704-06-16', 'Texel', '1704-12-15', '1705-01-05', true, '1705-04-05', 'Batavia', NULL, 'In a storm the ship lost the bowsprit, and took refuge at Annabon from 14-09 till 29-09-1704. From 12-11 till 19-11-1704 at St. Helena.');
INSERT INTO "voyages" VALUES (1954, '', 1, '', 'HOEDEKENSKERKE', 'Paulus Visser', 830, NULL, '1704', NULL, NULL, 'Z', 'Z', '1704-10-13', 'Wielingen', '1705-03-07', '1705-04-14', true, '1705-06-29', 'Batavia', 6141, NULL);
INSERT INTO "voyages" VALUES (1955, '', 1, '', 'NEPTUNUS', 'Pieter Oostendorp', 858, NULL, '1704', NULL, NULL, 'A', 'A', '1704-10-13', 'Texel', '1705-03-09', '1705-03-28', true, '1705-06-25', 'Batavia', 6173, 'From 17-10 till 18-10-1704 at Plymouth. Four passengers were stowaways.');
INSERT INTO "voyages" VALUES (1956, '', 5, '', 'OOSTERSTEIN', 'Jan de Wersijn', 1139, NULL, '1693', NULL, NULL, 'Z', 'Z', '1704-10-13', 'Wielingen', '1705-03-07', '1705-04-14', true, '1705-07-08', 'Batavia', 6174, NULL);
INSERT INTO "voyages" VALUES (1957, '', 1, '', 'SLOTEN', 'Koert Gerrits', 610, 'fluit', '1704', NULL, NULL, 'A', 'A', '1704-10-13', 'Texel', '1705-03-08', '1705-03-27', true, '1705-07-08', 'Batavia', 6198, NULL);
INSERT INTO "voyages" VALUES (1958, '', 4, '', 'DONKERVLIET', 'Gerrit van der Zijde', 794, NULL, '1696', NULL, NULL, 'Z', 'D', '1704-12-24', 'Goeree', '1705-05-02', '1705-05-16', true, '1705-08-20', 'Batavia', 6136, NULL);
INSERT INTO "voyages" VALUES (1959, '', 1, '', 'MONSTER', 'Jan Walburg', 572, 'fluit', '1704', NULL, NULL, 'R', 'R', '1704-12-24', 'Goeree', '1705-05-30', '1705-06-18', true, '1705-09-10', 'Batavia', NULL, 'on 30-06-1708 and was lost.');
INSERT INTO "voyages" VALUES (1960, '', 1, '', 'TER AA', 'Pieter Sliedrecht', 210, NULL, '1704', NULL, NULL, 'A', 'E', '1705-01-08', 'Texel', '1705-04-29', NULL, true, '1705-04-29', 'The Cape', NULL, NULL);
INSERT INTO "voyages" VALUES (1961, '', 4, '', 'BERKENRODE', 'Jan Jansekin', 635, 'fluit', '1694', NULL, NULL, 'A', 'E', '1705-01-08', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ship was captured on 14-02-1705 by two pirates from St. Malo.');
INSERT INTO "voyages" VALUES (1962, '', 3, '', 'FLORA', 'Jakob Regenboog', 554, 'fluit', '1699', NULL, NULL, 'A', 'A', '1705-01-08', 'Texel', '1705-05-20', '1705-06-18', true, '1705-08-23', 'Ceylon', NULL, 'Laid up at Batavia on 31-01-1711.');
INSERT INTO "voyages" VALUES (1963, '', 1, '', 'HAM', 'Karel Lavia', 580, 'fluit', '1704', NULL, NULL, 'H', 'H', '1705-01-08', 'Texel', '1705-05-29', '1705-06-18', true, '1705-08-24', 'Batavia', 6160, 'stayed from 10-03 till 13-03-1705 at S. Tiago.');
INSERT INTO "voyages" VALUES (1964, '', 2, '', 'HUIS TE HEMERT', 'Jakob Willemsz.', 612, 'fluit', '1701', NULL, NULL, 'A', 'A', '1705-01-08', 'Texel', '1705-05-26', '1705-06-18', true, '1705-08-20', 'Batavia', 6148, 'passengers were stowaways.');
INSERT INTO "voyages" VALUES (1965, '', 3, '', 'SCHOONDERLOO', 'Paulus Kroon', 622, 'fluit', '1693', NULL, NULL, 'D', 'A', '1705-01-08', 'Texel', '1705-06-05', '1705-06-18', true, '1705-09-03', 'Batavia', 6138, 'The passengers was a stowaway.');
INSERT INTO "voyages" VALUES (1966, '', 4, '', 'UNIE', 'Adriaan Bogaard', 1080, 'pinas', '1696', NULL, NULL, 'A', 'A', '1705-01-08', 'Texel', '1705-06-11', '1705-06-29', true, '1705-09-08', 'Batavia', 6143, '19-03-1705 at S. Tiago; 4 French prisoners were taken aboard.');
INSERT INTO "voyages" VALUES (1967, '', 3, '', 'GENERALE VREDE', 'Egbert Kalf', 1008, 'pinas', '1699', NULL, NULL, 'A', 'A', '1705-01-08', 'Texel', '1705-05-05', '1705-05-29', true, '1705-07-26', 'Batavia', 6144, NULL);
INSERT INTO "voyages" VALUES (1968, '', 2, '', 'ZANDHORST', 'Jan de Rode', 520, 'fluit', '1701', NULL, NULL, 'A', 'A', '1705-01-08', 'Texel', '1705-06-11', '1705-08-06', true, '1705-10-22', 'Batavia', 6164, 'At S. Tiago from 14-03 till 19-03-1705. One seafarer and one soldier disembarked.');
INSERT INTO "voyages" VALUES (1969, '', 2, '', 'DIEMEN', 'Marten Engele', 596, 'fluit', '1700', NULL, NULL, 'A', 'Z', '1705-03-01', 'Wielingen', '1705-06-14', '1705-07-16', true, '1705-10-02', 'Batavia', 6149, NULL);
INSERT INTO "voyages" VALUES (1970, '', 2, '', 'GANSENHOEF', 'Joost de Vlieger', 640, 'fluit', '1702', NULL, NULL, 'A', 'Z', '1705-03-01', 'Wielingen', '1705-06-14', '1705-07-16', true, '1705-09-10', 'Batavia', 6137, NULL);
INSERT INTO "voyages" VALUES (1971, '', 5, '', 'SIRJANSLAND', 'Kornelis Balle', 759, NULL, '1691', NULL, NULL, 'Z', 'Z', '1705-03-01', 'Wielingen', '1705-06-12', '1705-07-16', true, '1705-09-16', 'Batavia', NULL, 'The ship stayed from 07-03 till 18-03-1705 at Falmouth. Laid up at Batavia in 1711.');
INSERT INTO "voyages" VALUES (1972, '', 2, '', 'WESTHOVEN', 'Jan Akkerman', 776, NULL, '1698', NULL, NULL, 'Z', 'Z', '1705-03-01', 'Wielingen', '1705-06-12', '1705-07-02', true, '1705-09-20', 'Batavia', 6139, NULL);
INSERT INTO "voyages" VALUES (1973, '', 3, '', 'ABBEKERK', 'Frans Sombeek', 242, 'fluit', '1698', NULL, NULL, 'H', 'H', '1705-05-10', 'Texel', '1705-09-29', '1705-11-01', true, '1706-01-03', 'Batavia', 6170, NULL);
INSERT INTO "voyages" VALUES (1974, '', 1, '', 'BELVLIET', 'Anthonie Chef', 586, 'fluit', '1704', NULL, NULL, 'E', 'E', '1705-05-10', 'Texel', '1705-10-25', '1705-11-30', true, '1706-02-24', 'Batavia', 6167, NULL);
INSERT INTO "voyages" VALUES (1975, '', 5, '', 'BRANDENBURG', 'Klaas Schacht', 817, NULL, '1690', NULL, NULL, 'A', 'A', '1705-05-10', 'Texel', '1705-09-12', '1705-10-09', true, '1705-12-28', 'Ceylon', NULL, 'Laid up at Batavia in 1711.');
INSERT INTO "voyages" VALUES (1976, '', 6, '', 'DRIEBERGEN', 'Jan Palestein', 616, 'fluit', '1692', NULL, NULL, 'A', 'A', '1705-05-10', 'Texel', '1705-11-11', '1705-12-10', true, '1706-02-16', 'Batavia', NULL, 'The passenger was a stowaway. Laid up at Batavia on 11-01-1714.');
INSERT INTO "voyages" VALUES (1977, '', 4, '', 'HOF VAN ILPENDAM', 'David Kodde', 700, 'pinas', '1691', NULL, NULL, 'A', 'A', '1705-05-10', 'Texel', '1705-09-29', '1705-11-07', true, '1706-01-18', 'Batavia', NULL, 'Among the passengers was the reverend Francois Valentijn. Laid up at Batavia in 1713.');
INSERT INTO "voyages" VALUES (1978, '', 1, '', 'RIJNENBURG', 'Jan de Klunder', 618, 'fluit', '1704', NULL, NULL, 'A', 'A', '1705-05-10', 'Texel', '1705-10-02', '1705-11-07', true, '1706-02-13', 'Batavia', 6203, NULL);
INSERT INTO "voyages" VALUES (1979, '', 4, '', 'VRIJBURG', 'Diedlof Kroes', 784, NULL, '1695', NULL, NULL, 'Z', 'A', '1705-05-10', 'Texel', '1705-09-12', '1705-10-02', true, '1705-12-18', 'Batavia', 6150, NULL);
INSERT INTO "voyages" VALUES (1980, '', 5, '', 'IJSSELMONDE', 'Kornelis van Overraad', 832, NULL, '1693', NULL, NULL, 'R', 'R', '1705-05-20', 'Goeree', '1705-09-28', '1705-10-31', true, '1706-01-02', 'Batavia', 6175, 'The passenger was a stowaway.');
INSERT INTO "voyages" VALUES (1981, '', 1, '', 'WASSENAAR', 'Melchior de Vos', 804, NULL, '1704', NULL, NULL, 'D', 'D', '1705-05-20', 'Goeree', '1705-09-11', '1705-10-02', true, '1705-12-23', 'Batavia', 6193, NULL);
INSERT INTO "voyages" VALUES (1982, '', 6, '', 'BELOIS', 'Cent van Dongen', 506, 'fluit', '1687', NULL, NULL, 'D', 'Z', '1705-10-02', 'Wielingen', '1706-02-06', '1706-03-01', true, '1706-08-28', 'Ceylon', NULL, '16-11-1716.');
INSERT INTO "voyages" VALUES (1983, '', 1, '', 'HERSTELDE LEEUW', 'Kornelis Gillisz.', 1138, NULL, '1704', NULL, NULL, 'Z', 'Z', '1705-10-02', 'Wielingen', '1706-02-25', '1706-03-23', true, '1706-06-17', 'Batavia', 6189, NULL);
INSERT INTO "voyages" VALUES (1984, '', 1, '', 'BAARZANDE', 'Ameland Jansz.', 786, NULL, '1705', NULL, NULL, 'A', 'A', '1705-11-16', 'Texel', '1706-05-09', '1706-05-30', true, '1706-08-19', 'Batavia', 6218, 'till 18-01-1706 at Portsmouth.');
INSERT INTO "voyages" VALUES (1985, '', 2, '', 'BEVERWAART', 'Hendrik Jurriaansz. Ben.', 760, NULL, '1702', NULL, NULL, 'A', 'A', '1705-11-16', 'Texel', '1706-05-04', '1706-05-30', true, '1706-08-16', 'Batavia', 6153, 'At Duins from 19-11-1705 till 02-01-1706; at Portsmouth from 04-01 till 18-01-1706.');
INSERT INTO "voyages" VALUES (1986, '', 1, '', 'LIMBURG', 'Klaas Maas', 810, NULL, '1704', NULL, NULL, 'A', 'A', '1705-11-16', 'Texel', '1706-05-04', '1706-05-25', true, '1706-07-28', 'Batavia', 6190, 'Three seafarers and one soldier deserted.');
INSERT INTO "voyages" VALUES (1987, '', 1, '', 'ZUIDERBURG', 'Joris Vis', 618, 'fluit', '1704', NULL, NULL, 'A', 'A', '1705-11-16', 'Texel', '1706-05-04', '1706-05-30', true, '1706-08-08', 'Batavia', 6184, 'At Duins from 19-11-1705 till 02-01-1706. At Portsmouth 07-01-1706 till 18-01-1706.');
INSERT INTO "voyages" VALUES (1988, '', 5, '', 'GRIMMESTEIN', 'Robbert de Groot', 759, NULL, '1696', NULL, NULL, 'A', 'D', '1706-01-04', 'Goeree', '1706-05-02', '1706-05-25', true, '1706-07-30', 'Batavia', 6155, NULL);
INSERT INTO "voyages" VALUES (1989, '', 2, '', 'SUIKERMOLEN', 'Jakob Bogaard', 720, 'fluit', '1701', NULL, NULL, 'Z', 'R', '1706-01-04', 'Hellevoetsluis', '1706-05-12', '1706-06-08', true, '1706-08-16', 'Batavia', NULL, 'Laid up at Batavia on 24-06-1716.');
INSERT INTO "voyages" VALUES (1990, '', 4, '', 'ASSENDELFT', 'Klaas Jansz. Neuselaar', 816, 'pinas', '1694', NULL, NULL, 'A', 'E', '1706-01-20', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Taken by three French ships on 13-04-1706.');
INSERT INTO "voyages" VALUES (1991, '', 2, '', 'DEN BERG', 'Adriaan Timmerman', 836, NULL, '1701', NULL, NULL, 'A', 'A', '1706-01-20', 'Texel', '1706-06-18', '1706-08-10', true, '1706-10-26', 'Batavia', 6159, 'The passenger at departure was a stowaway. From 31-01 till 03-02-1706 at Portsmouth, from 12-02 till 23-02-1706 at Torbay.');
INSERT INTO "voyages" VALUES (1992, '', 1, '', 'HOGESTELT', 'Jan de Rooy', 800, NULL, '1705', NULL, NULL, 'A', 'A', '1706-01-20', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Taken by three French ships and burnt on 13-04-1706.');
INSERT INTO "voyages" VALUES (1993, '', 4, '', 'HORSTENDAAL', 'Arie Schut', 688, 'pinas', '1699', NULL, NULL, 'A', 'A', '1706-01-20', 'Texel', '1706-06-26', '1706-07-31', true, '1706-10-07', 'Batavia', 6156, 'From 31-01 till 03-02-1706 at Portsmouth; at Torbay from 12-02 till 23-02-1706.');
INSERT INTO "voyages" VALUES (1994, '', 4, '', 'JERUSALEM', 'Willem Mina', 622, 'fluit', '1693', NULL, NULL, 'R', 'H', '1706-01-20', 'Texel', '1706-06-25', '1706-07-31', true, '1706-10-12', 'Batavia', NULL, 'The passenger was a stowaway. From 31-01 till 03-02-1706 at Portsmouth; at Torbay from 12-02 till 23-02-1706.');
INSERT INTO "voyages" VALUES (1995, '', 1, '', 'SCHELLENBERG', 'Dirk Korver', 630, 'fluit', '1705', NULL, NULL, 'A', 'A', '1706-01-20', 'Texel', '1706-06-26', '1706-07-31', true, '1706-10-06', 'Batavia', 6166, 'One of the passengers was a stowaway, another one was found at the Cape. From 30-01 till 03-02-1706 at Portsmouth; from 12-02 till 23-02-1706 at Torbay.');
INSERT INTO "voyages" VALUES (1996, '', 1, '', 'DONAU', 'Jakob Pikkereeuw', 794, NULL, '1705', NULL, NULL, 'Z', 'Z', '1706-02-20', 'Wielingen', '1706-07-26', '1706-08-18', true, '1706-10-29', 'Batavia', 6202, 'From 06-03 till 08-03-1706 at the Orcades.');
INSERT INTO "voyages" VALUES (1997, '', 4, '', 'THEEBOOM', 'Pieter Opterwilt', 526, 'fluit', '1699', NULL, NULL, 'A', 'Z', '1706-02-20', 'Wielingen', '1707-03-31', '1707-05-06', true, '1707-07-30', 'Batavia', 6177, 'From 04-04 till 18-09-1706 in Norway.');
INSERT INTO "voyages" VALUES (1998, '', 2, '', 'KIEFHOEK', 'Dirk Krijne', 832, NULL, '1701', NULL, NULL, 'R', 'R', '1706-05-04', 'Goeree', '1706-08-16', '1706-09-16', true, '1706-12-02', 'Batavia', 6179, NULL);
INSERT INTO "voyages" VALUES (1999, '', 1, '', 'NATERS', 'Leendert Haveluk', 210, 'jacht', '1705', NULL, NULL, 'D', 'D', '1706-05-04', 'Goeree', '1706-08-28', '1706-09-16', true, '1706-12-02', 'Batavia', NULL, 'The passenger at departure was a stowaway. The ship was laid up at Batavia on 18-10-1718.');
INSERT INTO "voyages" VALUES (2000, '', 1, '', 'HARINGTUIN', 'Huibert Vermeulen', 618, 'fluit', '1705', NULL, NULL, 'E', 'E', '1706-05-09', 'Texel', '1706-10-21', '1706-11-27', true, '1707-02-04', 'Batavia', 6253, 'From 17-05 till 07-06-1706 at Torbay.');
INSERT INTO "voyages" VALUES (2001, '', 6, '', 'SPIEGEL', 'Herman Jurriaansz. Daal', 831, 'pinas', '1693', NULL, NULL, 'A', 'A', '1706-05-09', 'Texel', '1706-10-19', '1706-11-19', true, '1707-01-30', 'Batavia', NULL, '07-06-1706. Laid up at Batavia in 1712.');
INSERT INTO "voyages" VALUES (2002, '', 3, '', 'OEGSTGEEST', 'Jan Eekhout', 576, 'hekboot', '1699', NULL, NULL, 'A', 'A', '1706-05-09', 'Texel', '1706-10-24', '1706-12-04', true, '1707-03-02', 'Batavia', 6181, '07-06-1706.');
INSERT INTO "voyages" VALUES (2003, '', 2, '', 'HUIS TE ROZENBURG', 'Herman de Marre', 576, 'fluit', '1702', NULL, NULL, 'A', 'A', '1706-05-09', 'Texel', '1706-12-11', '1707-01-19', true, '1707-04-27', 'Batavia', 6182, 'From 17-05 till 07-06-1706 at Torbay.');
INSERT INTO "voyages" VALUES (2004, '', 4, '', 'VENHUIZEN', 'Simon Stevenant', 250, 'fluit', '1697', NULL, NULL, 'E', 'H', '1706-05-09', 'Texel', '1706-10-21', '1706-11-27', true, '1707-02-16', 'Batavia', NULL, 'At Torbay from 17-05 till 07-06-1706. Laid up at Batavia in 1711.');
INSERT INTO "voyages" VALUES (2005, '', 2, '', 'ZOELEN', 'Christiaan Zwart', 656, 'fluit', '1699', NULL, NULL, 'R', 'A', '1706-05-09', 'Texel', '1706-12-25', '1707-01-19', true, '1707-05-03', 'Batavia', NULL, 'At Torbay from 17-05 till 07-06-1706. Laid up at Batavia on 11-01-1714.');
INSERT INTO "voyages" VALUES (2006, '', 5, '', 'DOMBURG', 'Jan van Munkhoven', 759, NULL, '1690', NULL, NULL, 'Z', 'Z', '1706-06-13', 'Vlissingen', NULL, NULL, true, NULL, NULL, NULL, '13-07-1706 taken by seven French ships.');
INSERT INTO "voyages" VALUES (2007, '', 3, '', 'CONCORDIA', 'Anthonie Kornelisz. Richtsnoert', 900, NULL, '1696', NULL, NULL, 'D', 'Z', '1706-07-29', 'Wielingen', '1706-12-12', '1707-01-08', true, '1707-04-06', 'Batavia', 6183, 'The master died between the Cape and Batavia.');
INSERT INTO "voyages" VALUES (2008, '', 2, '', 'PETER EN PAUL', 'Hendrik Matthijsz.', 278, 'fregat', '1697', NULL, NULL, 'A', 'A', '1706-11-02', 'Texel', '1707-02-20', '1707-03-08', true, '1707-05-20', 'Batavia', NULL, 'The passenger was a stowaway. Laid up on 30-11-1717 at Batavia.');
INSERT INTO "voyages" VALUES (2009, '', 1, '', 'DUIVENVOORDE', 'Jakob van den Akker', 620, NULL, '1705', NULL, NULL, 'R', 'R', '1706-12-21', 'Goeree', '1707-08-21', '1707-09-14', true, '1707-12-11', 'Batavia', 6185, 'Second departure on 08-01-1707 from Texel. From 09-02 till 21-04-1707 in England.');
INSERT INTO "voyages" VALUES (2010, '', 4, '', 'SCHOONDERLOO', 'Jakob Arendsz. Verduin', 622, 'fluit', '1693', NULL, NULL, 'D', 'D', '1706-12-21', 'Goeree', '1707-06-08', '1707-07-02', true, '1707-09-07', 'Batavia', NULL, 'The two passengers at departure were stowaways. From 05-01 till 07-02-1707 at Torbay.');
INSERT INTO "voyages" VALUES (2011, '', 1, '', 'BARNEVELD', 'Adolf Hage', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1706-12-25', 'Texel', '1707-05-06', '1707-06-10', true, '1707-08-10', 'Batavia', 6171, NULL);
INSERT INTO "voyages" VALUES (2012, '', 5, '', 'KATTENDIJK', 'Kornelis de Geus', 759, NULL, '1694', NULL, NULL, 'Z', 'A', '1706-12-25', 'Texel', '1707-04-16', '1707-05-06', true, '1707-07-10', 'Batavia', NULL, 'Two of the passengers were stowaways. The ship was wrecked in Sunda Strait in April 1709.');
INSERT INTO "voyages" VALUES (2013, '', 1, '', 'KORSSLOOT', 'Jurriaan Wormer', 630, 'fluit', '1705', NULL, NULL, 'H', 'H', '1706-12-25', 'Texel', '1707-05-06', '1707-06-15', true, '1707-08-12', 'Batavia', 6248, NULL);
INSERT INTO "voyages" VALUES (2014, '', 5, '', 'OVERNES', 'Pieter Kalis', 616, 'fluit', '1696', NULL, NULL, 'A', 'A', '1706-12-25', 'Texel', '1707-05-06', '1707-05-31', true, '1707-08-02', 'Batavia', NULL, 'The passengers were stowaways. Laid up at Batavia on 21-06-1718.');
INSERT INTO "voyages" VALUES (2015, '', 2, '', 'TAXISBOOM', 'Dionys van Vlierden', 614, 'fluit', '1699', NULL, NULL, 'D', 'A', '1706-12-25', 'Texel', '1707-05-06', '1707-05-23', true, '1707-07-19', 'Batavia', NULL, 'The two passengers at departure were stowaways. The ship taken by pirates at the Smalle Baai in 1707.');
INSERT INTO "voyages" VALUES (2016, '', 4, '', 'HUIS TER DUINE', 'Jan Tessing', 588, 'jacht', '1693', NULL, NULL, 'Z', 'Z', '1707-01-06', 'Vlissingen', '1707-05-06', '1707-06-10', true, '1707-08-11', 'Batavia', NULL, 'The ship was laid up at Batavia on 30-11-1717.');
INSERT INTO "voyages" VALUES (2017, '', 1, '', 'VADERLAND GETROUW', 'Frans Buscop', 848, NULL, '1705', NULL, NULL, 'Z', 'Z', '1707-01-06', 'Vlissingen', '1707-05-05', '1707-05-31', true, '1707-08-07', 'Batavia', 6214, 'One of the passengers was Jakob Roggeveen, later explorer of the Pacific (1721-1722).');
INSERT INTO "voyages" VALUES (2018, '', 1, '', 'ARION', 'Jan Zandvoort', 630, 'fluit', '1706', NULL, NULL, 'A', 'A', '1707-01-08', 'Texel', '1707-06-13', '1707-07-06', true, '1707-09-15', 'Batavia', 6231, 'Together with GAMRON (2019),''T GHIJN (2020), HUIS TE HEMERT (2021), HOEDEKENSKERKE (2022) and HUIS TE LOO (2023) 04-02 till 07-02-1707 at Duins and 07-02 till 27-02-1707 at Portsmouth. Among the passengers were four stow-aways.');
INSERT INTO "voyages" VALUES (2019, '', 1, '', 'GAMRON', 'Jakob Weiland', 848, NULL, '1706', NULL, NULL, 'A', 'A', '1707-01-08', 'Texel', '1707-06-11', '1707-07-03', true, '1707-09-08', 'Batavia', 6196, 'See no. 2018.');
INSERT INTO "voyages" VALUES (2020, '', 2, '', '''T GHIJN', 'Paulus Kroon', 810, NULL, '1701', NULL, NULL, 'A', 'A', '1707-01-08', 'Texel', '1707-06-11', '1707-07-10', true, '1707-09-11', 'Batavia', 6169, 'See no. 2018. Among the passengers were two stowaways; one disembarked at the Cape.');
INSERT INTO "voyages" VALUES (2021, '', 3, '', 'HUIS TE HEMERT', 'Lukas Koertsz. Wormer', 612, 'fluit', '1701', NULL, NULL, 'A', 'E', '1707-01-08', 'Texel', '1707-06-10', '1707-07-03', true, '1707-09-07', 'Batavia', 6194, 'See no. 2018');
INSERT INTO "voyages" VALUES (2022, '', 2, '', 'HOEDEKENSKERKE', 'Jakob Willemsz.', 830, NULL, '1704', NULL, NULL, 'Z', 'A', '1707-01-08', 'Texel', '1707-06-11', '1707-07-03', true, '1707-09-08', 'Batavia', 6172, 'See no. 2018. Among the passengers were five stowaways.');
INSERT INTO "voyages" VALUES (2023, '', 6, '', 'HUIS TE LOO', 'Haye Jansz.', 875, 'pinas', '1691', NULL, NULL, 'A', 'A', '1707-01-08', 'Texel', '1707-06-07', '1707-07-02', true, '1707-09-05', 'Ceylon', 6180, 'See no. 2018.');
INSERT INTO "voyages" VALUES (2024, '', 1, '', 'ZANDENBURG', 'Adriaan Tilburg', 1136, NULL, '1706', NULL, NULL, 'Z', 'Z', '1707-03-04', 'Wielingen', '1707-06-11', '1707-07-03', true, '1707-09-07', 'Batavia', 6215, NULL);
INSERT INTO "voyages" VALUES (2025, '', 5, '', 'DONKERVLIET', 'Hendrik Stokman', 794, NULL, '1696', NULL, NULL, 'Z', 'R', '1707-04-15', 'Goeree', '1707-08-17', '1707-09-14', true, '1707-11-21', 'Batavia', 6168, NULL);
INSERT INTO "voyages" VALUES (2026, '', 2, '', 'BEVERWIJK', 'Lukas Schrik', 836, NULL, '1700', NULL, NULL, 'A', 'A', '1707-05-19', 'Texel', '1708-01-23', '1708-03-14', true, '1708-06-06', 'Batavia', 6201, 'Formosa. Two seafarers ran away and two more went over to the GEN-ERALE VREDE (2031).');
INSERT INTO "voyages" VALUES (2027, '', 3, '', 'DIEMEN', 'Pieter Bol+', 596, 'fluit', '1700', NULL, NULL, 'A', 'H', '1707-05-19', 'Texel', '1708-01-23', '1708-03-14', true, '1708-06-06', 'Batavia', 6221, 'was succeeded by Jakob de Graaf.');
INSERT INTO "voyages" VALUES (2028, '', 3, '', 'GANSENHOEF', 'Daniel Engels', 640, 'fluit', '1702', NULL, NULL, 'A', 'A', '1707-05-19', 'Texel', '1708-01-23', '1708-03-14', true, '1708-06-09', 'Batavia', 6265, 'See no. 2026. 2 Seafarers and 1 soldier ran away.');
INSERT INTO "voyages" VALUES (2029, '', 3, '', 'HAAK', 'Kornelis Jongeboer', 550, 'fluit', '1699', NULL, NULL, 'E', 'E', '1707-05-19', 'Texel', '1708-01-23', '1708-02-29', true, '1708-05-26', 'Batavia', NULL, 'See no. 2026. 13 Men ran away. The ship was laid up at Batavia on 20-11-1715.');
INSERT INTO "voyages" VALUES (2030, '', 5, '', 'UNIE', 'Hidding Idesz. Nooy', 1080, 'pinas', '1696', NULL, NULL, 'A', 'A', '1707-05-19', 'Texel', '1708-01-23', '1708-03-14', true, '1708-06-06', 'Batavia', 6199, 'See no. 2026. Two seafarers and two soldiers deserted in Brazil; one passenger became a soldier.');
INSERT INTO "voyages" VALUES (2031, '', 4, '', 'GENERALE VREDE', 'Gerrit Gerritsz. Boom', 1008, 'pinas', '1699', NULL, NULL, 'A', 'A', '1707-05-19', 'Texel', '1708-01-24', '1708-03-14', true, '1708-06-05', 'Batavia', 6200, 'See no. 2026. Among the passengers was Louis van Assenburg, gouverneur of the Cape and a stowaway. In Brazil 3 men deserted.');
INSERT INTO "voyages" VALUES (2032, '', 3, '', 'WESTHOVEN', 'Krijn Andriesz.', 776, NULL, '1698', NULL, NULL, 'Z', 'Z', '1707-06-05', 'Vlissingen', '1707-11-07', '1707-12-08', true, '1708-03-09', 'Ceylon', 6195, NULL);
INSERT INTO "voyages" VALUES (2033, '', 2, '', 'ZUIDDORP', 'Jan Akkerman', 1152, NULL, '1701', NULL, NULL, 'Z', 'Z', '1707-06-05', 'Wielingen', '1707-11-07', '1707-12-09', true, '1708-02-29', 'Batavia', 6216, NULL);
INSERT INTO "voyages" VALUES (2034, '', 5, '', 'VRIJBURG', 'Willem Elshoek', 784, NULL, '1695', NULL, NULL, 'Z', 'D', '1707-10-24', 'Goeree', '1708-07-24', '1708-09-13', true, '1708-12-02', 'Batavia', 6219, 'From 26-10-1707 till 18-03-1708 at Portsmouth, where 18 men deserted. 11 Seafarers and 1 soldier were enlisted.');
INSERT INTO "voyages" VALUES (2035, '', 1, '', 'MEERVLIET', 'Volkert Koeman', 210, 'jacht? fregat?', '1706', NULL, NULL, 'A', 'A', '1707-11-14', 'Texel', '1708-06-13', NULL, true, '1708-06-13', 'The Cape', 6186, NULL);
INSERT INTO "voyages" VALUES (2036, '', 1, '', 'SCHAGERHAAN', 'Sasker Rijpen', 180, NULL, '1706', NULL, NULL, 'E', 'E', '1707-11-14', 'Texel', '1708-06-13', '1708-07-22', true, '1708-10-11', 'Ceylon', NULL, 'The ship was taken by the French at Ceylon in 1709.');
INSERT INTO "voyages" VALUES (2037, '', 1, '', 'NAGEL', 'Pieter Berkman', 130, NULL, '1702', NULL, NULL, 'A', 'A', '1707-12-28', 'Texel', '1708-05-10', NULL, true, '1708-05-10', 'The Cape', NULL, 'The ship was burnt in the Saldanha Bay on 28-05-1709.');
INSERT INTO "voyages" VALUES (2038, '', 1, '', 'KROMSTRIJEN', 'Dirk van der Meer', 678, 'fluit', '1706', NULL, NULL, 'R', 'R', '1707-12-29', 'Goeree', '1708-06-02', '1708-07-04', true, '1708-09-16', 'Batavia', NULL, 'Two of the passengers were stowaways. The ship was lost on a voyage to Bengal in 1709.');
INSERT INTO "voyages" VALUES (2039, '', 2, '', 'SCHELLENBERG', 'Leendert de Koning', 630, 'fluit', '1705', NULL, NULL, 'A', 'D', '1707-12-29', 'Goeree', '1708-05-11', '1708-06-17', true, '1708-08-21', 'Batavia', 6192, NULL);
INSERT INTO "voyages" VALUES (2040, '', 5, '', 'KARTHAGO', 'Joost de Vlieger', 759, NULL, '1692', NULL, NULL, 'Z', 'Z', '1707-12-30', 'Rammekens', '1708-07-19', '1708-09-08', true, '1709-01-16', 'Batavia', NULL, 'Till 18-03-1708 in England, where 23 men deserted. From 05-11 till 03-12-1708 at Mauritius. According to Coolhaas VI, 595,141 persons arrived at Batavia. Probably most of the passengers disembarked at Mauritius. Laid up at Batavia on 27-09-1720.');
INSERT INTO "voyages" VALUES (2041, '', 1, '', 'KIEVIT', 'Jakob Zalm', 794, NULL, '1706', NULL, NULL, 'A', 'A', '1707-12-30', 'Texel', '1708-08-20', '1708-10-07', true, '1708-12-18', 'Batavia', NULL, 'At Edinburgh from 29-01 till 25-03-1708 where 12 seafarers and 1 soldier deserted and 10 seafarers embarked. Taken by the French on a voyage to Surat on 18-09-1709.');
INSERT INTO "voyages" VALUES (2042, '', 1, '', 'OUWERKERK', 'Thomas du Bois', 658, 'fluit', '1706', NULL, NULL, 'A', 'A', '1707-12-30', 'Texel', '1708-05-12', '1708-06-20', true, '1708-09-02', 'Batavia', 6228, '2041.');
INSERT INTO "voyages" VALUES (2043, '', 1, '', 'OVERWINNAAR', 'Jakob Eles', 800, NULL, '1706', NULL, NULL, 'Z', 'Z', '1707-12-30', 'Rammekens', NULL, NULL, true, NULL, NULL, NULL, 'Taken by the French on 03-06-1708, between the equator and the Cape.');
INSERT INTO "voyages" VALUES (2044, '', 1, '', 'STANDVASTIGHEID', 'Jan Verbrugge', 888, NULL, '1706', NULL, NULL, 'A', 'A', '1707-12-30', 'Texel', '1708-08-20', '1708-10-09', true, '1709-01-24', 'Batavia', 6240, 'Second time out from Texel on 24-01-1708, at Edinburgh till 24-03-1708.');
INSERT INTO "voyages" VALUES (2045, '', 3, '', 'DEN BERG', 'Lambert van Kouwenhoven', 836, NULL, '1701', NULL, NULL, 'A', 'A', '1708-01-24', 'Texel', NULL, NULL, false, '1708-08-19', 'Ceylon', 6227, NULL);
INSERT INTO "voyages" VALUES (2046, '', 3, '', 'BEVERWAART', 'Dirk Danielsz. Bent+', 760, NULL, '1702', NULL, NULL, 'A', 'H', '1708-01-24', 'Texel', '1709-09-07', '1709-10-29', true, '1710-05-04', 'Batavia', 6301, 'at Mauritius. 73 Seafarers and 21 soldiers embarked, together with 67 passengers. 42 Seafarers and 9 soldiers came from the KIEVIT (2041). 4 Soldiers deserted.');
INSERT INTO "voyages" VALUES (2047, '', 2, '', 'BON', 'Jakob Onkruid', 600, 'fluit', '1703', NULL, NULL, 'A', 'E', '1708-01-24', 'Texel', '1709-12-15', '1710-01-15', true, '1710-04-05', 'Batavia', NULL, 'BEVERWAART (2046); out again 17-07-1709; at S. Tiago from 17-09 till 23-09-1709. Laid up at Batavia on 30-11-1717.');
INSERT INTO "voyages" VALUES (2048, '', 2, '', 'HAM', 'Pieter van Nas', 580, 'fluit', '1704', NULL, NULL, 'A', 'A', '1708-01-24', 'Texel', '1708-06-11', '1708-07-22', true, '1708-10-11', 'Ceylon', 6245, NULL);
INSERT INTO "voyages" VALUES (2049, '', 2, '', 'KONING KAREL DE DERDE', 'Dirk Korver', 830, NULL, '1704', NULL, NULL, 'A', 'A', '1708-01-24', 'Texel', '1708-05-07', '1708-06-17', true, '1708-08-19', 'Batavia', 6224, NULL);
INSERT INTO "voyages" VALUES (2050, '', 1, '', 'MOSSEL', 'Pieter Frederiks de Groot', 676, 'fluit', '1706', NULL, NULL, 'E', 'A', '1708-01-24', 'Texel', '1708-05-29', '1708-07-04', true, '1708-09-16', 'Batavia', 6229, NULL);
INSERT INTO "voyages" VALUES (2051, '', 4, '', 'HUIS TE NIEUWBURG', 'Kasper Laurentsz.', 618, 'fluit? hekboot?', '1697', NULL, NULL, 'A', 'A', '1708-01-24', 'Texel', '1708-06-11', '1708-07-04', true, '1708-09-19', 'Batavia', 6191, NULL);
INSERT INTO "voyages" VALUES (2052, '', 6, '', 'GRIMMESTEIN', 'Wessel van Neercassel', 759, NULL, '1696', NULL, NULL, 'A', 'R', '1708-04-20', 'Goeree', '1708-09-06', '1708-09-26', true, '1708-12-22', 'Batavia', 6210, 'The two passengers were stowaways.');
INSERT INTO "voyages" VALUES (2053, '', 2, '', 'WATERINGEN', 'Jakob Heerman', 626, 'jacht', '1701', NULL, NULL, 'D', 'D', '1708-04-20', 'Goeree', '1708-09-12', '1708-10-07', true, '1708-12-21', 'Batavia', 6204, 'At the Cape the passenger was enlisted as a seafarer.');
INSERT INTO "voyages" VALUES (2054, '', 2, '', 'WAARDE', 'Jakob Bitter', 830, NULL, '1702', NULL, NULL, 'Z', 'Z', '1708-06-02', 'Wielingen', '1708-12-24', '1709-01-28', true, '1709-06-11', 'Batavia', 6226, '29-07 till 02-08-1708 at Annabon; from 18-08 till 28-08-1708 at Luanda in Angola.');
INSERT INTO "voyages" VALUES (2055, '', 3, '', 'ZANDHORST', 'Willem Biskop', 520, 'fluit', '1701', NULL, NULL, 'A', 'Z', '1708-06-02', 'Wielingen', '1709-01-22', '1709-02-10', true, '1709-06-12', 'Batavia', 6247, 'From 08-11 till 17-11-1708 at S. Tome.');
INSERT INTO "voyages" VALUES (2056, '', 2, '', 'BELVLIET', 'Klaas de Vries', 586, 'fluit', '1704', NULL, NULL, 'E', 'A', '1708-06-03', 'Texel', '1708-11-21', '1708-12-30', true, '1709-04-01', 'Batavia', 6220, 'On 02-11-1708 at Dasseneiland.');
INSERT INTO "voyages" VALUES (2057, '', 1, '', 'ENGEWORMER', 'Barend Meikens', 560, 'fluit', '1707', NULL, NULL, 'H', 'H', '1708-06-03', 'Texel', '1708-11-21', '1708-12-30', true, '1709-04-10', 'Batavia', 6222, NULL);
INSERT INTO "voyages" VALUES (2058, '', 5, '', 'HORSTENDAAL', 'Jakob Visser', 688, 'pinas', '1699', NULL, NULL, 'A', 'E', '1708-06-03', 'Texel', '1708-11-05', '1708-12-09', true, '1709-02-13', 'Batavia', 6223, NULL);
INSERT INTO "voyages" VALUES (2059, '', 4, '', 'LIEFDE', 'Adriaan Timmerman', 1009, 'pinas', '1698', NULL, NULL, 'A', 'A', '1708-06-03', 'Texel', '1708-11-21', '1708-12-30', true, '1709-04-03', 'Batavia', 6212, 'Among the passengers were 4 stowaways.');
INSERT INTO "voyages" VALUES (2060, '', 2, '', 'POPKENSBURG', 'Karel Lavia', 804, NULL, '1699', NULL, NULL, 'Z', 'A', '1708-06-03', 'Texel', '1708-11-05', '1708-12-09', true, '1709-02-23', 'Batavia', 6225, NULL);
INSERT INTO "voyages" VALUES (2061, '', 1, '', 'MEERMAN', NULL, 180, NULL, '1706', NULL, NULL, 'D', 'D', '1708-10-18', 'Goeree', NULL, NULL, true, NULL, NULL, NULL, 'The ship was taken by the French on 20-10-1708.');
INSERT INTO "voyages" VALUES (2062, '', 1, '', 'ZEELANDIA', 'Matthijs Burger', 160, NULL, '1704', NULL, NULL, 'Z', 'Z', '1708-10-18', 'Goeree', '1709-02-04', NULL, true, '1705-02-04', 'The Cape', 6207, NULL);
INSERT INTO "voyages" VALUES (2063, '', 1, '', 'VOORPOORT', 'Pieter Hendriksz. Klein', 160, NULL, '1708', NULL, NULL, 'A', 'A', '1708-10-26', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'was taken by the French on 28-10-1708.');
INSERT INTO "voyages" VALUES (2064, '', 2, '', 'MEERVLIET', 'Hayman de Laver', 210, 'jacht? fregat?', '1706', NULL, NULL, 'A', 'A', '1708-11-04', 'Texel', '1709-03-25', '1709-05-22', true, '1709-07-25', 'Batavia', 6213, 'At Saldanha Bay from 02-03 till 24-03-1709.');
INSERT INTO "voyages" VALUES (2065, '', 1, '', 'AMAZONE', 'Jan Meerlaan', 590, 'fluit', '1707', NULL, NULL, 'A', 'A', '1708-11-06', 'Texel', '1710-02-10', '1710-03-23', true, '1710-07-04', 'Batavia', 6261, 'From 10-11 till 07-12-1708 back at Texel together with SAM-SON (2066). Stayed at Duins, St. Helena, S. Tome and Luanda. At Portsmouth 3 seafarers were entlisted.');
INSERT INTO "voyages" VALUES (2066, '', 1, '', 'SAMSON', 'Jan de Rode', 800, NULL, '1707', NULL, NULL, 'A', 'A', '1708-11-06', 'Texel', '1709-05-05', '1709-05-30', true, '1709-08-08', 'Batavia', 6257, 'At S. Tiago from 06-02 till 10-02-1709.');
INSERT INTO "voyages" VALUES (2067, '', 1, '', 'HARING', 'Dirk van Veen', 140, NULL, '1704', NULL, NULL, 'A', 'A', '1708-12-12', 'Texel', '1709-04-20', NULL, true, '1705-04-20', 'The Cape', 6206, NULL);
INSERT INTO "voyages" VALUES (2068, '', 1, '', 'AREND', 'Jan de Wit', 130, NULL, '1708', NULL, NULL, 'A', 'A', '1708-12-22', 'Texel', '1709-04-30', NULL, true, '1709-04-30', 'The Cape', 6208, NULL);
INSERT INTO "voyages" VALUES (2069, '', 3, '', 'HOEDEKENSKERKE', 'Jan de Hei', 830, NULL, '1704', NULL, NULL, 'Z', 'Z', '1709-01-07', 'Wielingen', '1709-05-22', '1709-06-28', true, '1709-09-16', 'Batavia', 6211, NULL);
INSERT INTO "voyages" VALUES (2070, '', 1, '', 'NOORDBEEK', 'Adriaan van Doom', 858, NULL, '1707', NULL, NULL, 'Z', 'Z', '1709-01-07', 'Wielingen', '1709-06-02', '1709-06-28', true, '1709-09-02', 'Batavia', 6238, 'On 29-05-1709 at Robbeneiland.');
INSERT INTO "voyages" VALUES (2071, '', 1, '', 'BRUG', 'Hero Dol', 600, NULL, '1708', NULL, NULL, 'E', 'E', '1709-01-08', 'Texel', '1709-06-04', '1709-06-28', true, '1709-09-17', 'Batavia', 6209, 'At S. Tiago on 16-03 till 18-03-1709. The passengers were stow-aways.');
INSERT INTO "voyages" VALUES (2072, '', 6, '', 'IJSSELMONDE', 'Jan de Hooft', 832, NULL, '1693', NULL, NULL, 'R', 'R', '1709-01-11', 'Goeree', '1709-06-03', '1709-06-28', true, '1709-09-11', 'Batavia', NULL, 'From 18-01 till 27-02-1709 at Portsmouth. One seafarer deserted. Laid up on 30-10-1716.');
INSERT INTO "voyages" VALUES (2073, '', 1, '', 'ARENDSDUIN', 'Jan Huigen van Breen', 580, 'jacht', '1708', NULL, NULL, 'D', 'D', '1709-04-30', 'Goeree', '1709-08-25', '1709-09-21', true, '1709-11-20', 'Batavia', 6230, NULL);
INSERT INTO "voyages" VALUES (2074, '', 6, '', 'DONKERVLIET', 'Arie Turfkloot', 794, NULL, '1696', NULL, NULL, 'Z', 'D', '1709-04-30', 'Goeree', '1709-08-13', '1709-09-08', true, '1709-11-15', 'Batavia', 6217, NULL);
INSERT INTO "voyages" VALUES (2075, '', 1, '', 'NEDERHOVEN', 'Jan Jongerens', 600, 'fluit', '1708', NULL, NULL, 'R', 'R', '1709-04-30', 'Goeree', '1709-09-10', '1709-10-30', true, '1710-01-23', 'Batavia', 6307, NULL);
INSERT INTO "voyages" VALUES (2076, '', 2, '', 'BARNEVELD', 'Palestein', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1709-05-07', 'Texel', '1709-09-07', '1709-10-30', true, '1710-01-14', 'Batavia', 6233, 'Among the passengers was one stowaway.');
INSERT INTO "voyages" VALUES (2077, '', 1, '', 'BENNEBROEK', 'Jan Hes', 800, NULL, '1708', NULL, NULL, 'A', 'A', '1709-05-07', 'Texel', '1709-09-06', '1709-10-29', true, '1710-02-01', 'Ceylon', 6243, NULL);
INSERT INTO "voyages" VALUES (2078, '', 1, '', 'BENTVELD', 'Abraham Kloot', 938, NULL, '1708', NULL, NULL, 'A', 'A', '1709-05-07', 'Texel', '1709-09-06', '1709-10-30', true, '1709-12-28', 'Batavia', 6242, 'Among the passengers was one stowaway. The master died. He was succeeded by Leendert de Koning at the Cape.');
INSERT INTO "voyages" VALUES (2079, '', 3, '', 'HUIS TE ROZENBURG', 'Theunis Gerbrands', 576, 'fluit', '1702', NULL, NULL, 'A', 'A', '1709-05-07', 'Texel', '1709-09-07', '1709-10-30', true, '1710-01-15', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (2080, '', 2, '', 'HUIS TER BOEDE', 'Jan Kole', 642, NULL, '1702', NULL, NULL, 'Z', 'Z', '1709-06-06', 'Wielingen', '1709-12-18', '1710-01-27', true, '1710-04-30', 'Ceylon', 6303, NULL);
INSERT INTO "voyages" VALUES (2081, '', 2, '', 'ELLEMEET', 'Michiel Landsheer', 670, NULL, '1699', NULL, NULL, 'Z', 'Z', '1709-06-06', 'Wielingen', '1709-10-28', '1709-12-11', true, '1710-02-19', 'Batavia', 6305, NULL);
INSERT INTO "voyages" VALUES (2082, '', 3, '', 'KIEFHOEK', 'Jakob Kole', 832, NULL, '1701', NULL, NULL, 'R', 'Z', '1709-06-06', 'Wielingen', '1709-11-02', '1709-12-10', true, '1710-03-07', 'Batavia', 6269, NULL);
INSERT INTO "voyages" VALUES (2083, '', 4, '', 'ABBEKERK', 'Jakob Hoek', 600, 'fluit', '1698', NULL, NULL, 'H', 'H', '1709-06-10', 'Texel', '1710-02-04', '1710-04-02', true, '1710-07-04', 'Batavia', 6290, 'From 28-09 till 16-10-1709 at S. Tome.');
INSERT INTO "voyages" VALUES (2084, '', 7, '', 'HUIS TE LOO', 'Broer Holman', 875, 'pinas', '1691', NULL, NULL, 'A', 'A', '1709-06-10', 'Texel', '1709-11-06', '1709-12-26', true, '1710-04-10', 'Batavia', NULL, 'Six passengers were stowaways. Laid up at Batavia on 30-11-1717.');
INSERT INTO "voyages" VALUES (2085, '', 2, '', 'NEPTUNUS', 'Willem Langerens', 858, NULL, '1704', NULL, NULL, 'A', 'A', '1709-06-10', 'Texel', '1710-01-11', '1710-02-27', true, '1710-06-02', 'Batavia', 6256, 'From 15-09 till 20-10-1709 at S. Tome.');
INSERT INTO "voyages" VALUES (2086, '', 4, '', 'OEGSTGEEST', 'Pieter Jansz. Bruin', 576, 'hekboot', '1699', NULL, NULL, 'A', 'A', '1709-06-10', 'Texel', '1709-12-20', '1710-02-03', true, '1710-05-21', 'Batavia', NULL, 'The two passengers were stowaways. Lost at Grisee in 1719.');
INSERT INTO "voyages" VALUES (2087, '', 2, '', 'LOKHORST', 'Klaas Zwaan', 612, 'fluit', '1702', NULL, NULL, 'E', 'E', '1709-07-17', 'Texel', '1709-12-18', '1710-01-15', true, '1710-05-10', 'Batavia', 6329, 'The three passengers were stowaways. At S. Tiago from 17-09 till 23-09-1709. Two seafarers ran away.');
INSERT INTO "voyages" VALUES (2088, '', 2, '', 'MEERMAN', 'Jan Koster', 180, NULL, '1706', NULL, NULL, 'D', 'D', '1709-10-11', 'Maas', '1710-03-11', '1710-04-23', true, '1710-06-26', 'Ceylon', NULL, 'Laid up at Batavia in 1719.');
INSERT INTO "voyages" VALUES (2089, '', 1, '', 'AVONTURIER', 'Koert Gerrits', 300, 'jacht? fregat?', '1707', NULL, NULL, 'A', 'A', '1709-10-12', 'Texel', '1710-02-27', '1710-04-10', true, '1710-06-17', 'Batavia', 6232, 'The five passengers were stowaways; they were enlisted at the Cape.');
INSERT INTO "voyages" VALUES (2090, '', 1, '', 'GELUKKIG UUR', 'Gilles Scharbotten', 300, 'fregat', '1707', NULL, NULL, 'A', 'A', '1709-10-12', 'Texel', '1710-01-24', '1710-02-11', true, '1710-05-12', 'Batavia', NULL, 'The two passengers were stowaways. At `Hitland'' from 18-10 till 23-10-1709. The ship was lost in Asia.');
INSERT INTO "voyages" VALUES (2091, '', 3, '', '''T GHIJN', 'Hendrik Kalf', 810, NULL, '1701', NULL, NULL, 'A', 'A', '1709-10-27', 'Texel', '1710-05-16', '1710-07-10', true, '1710-09-20', 'Batavia', 6385, 'Among the passengers were 14 stowaways. 11 Persons went missing, 54 persons died during the voyage.');
INSERT INTO "voyages" VALUES (2092, '', 1, '', 'MIJNDEN', 'Herman de Marre', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1709-10-27', 'Texel', '1710-03-25', '1710-05-02', true, '1710-08-16', 'Batavia', 6237, 'The passengers was a stowaway.');
INSERT INTO "voyages" VALUES (2093, '', 1, '', 'OUDENAARDE', 'Christiaan Emmerij', 858, NULL, '1708', NULL, NULL, 'A', 'A', '1709-10-27', 'Texel', '1710-04-07', '1710-06-05', true, '1710-08-09', 'Batavia', 6286, NULL);
INSERT INTO "voyages" VALUES (2094, '', 5, '', 'THEEBOOM', 'Tobias Uilenberg', 526, 'fluit', '1699', NULL, NULL, 'A', 'A', '1709-10-27', 'Texel', '1710-04-19', '1710-07-10', true, '1710-09-21', 'Batavia', NULL, 'The three passengers were stowaways. Lost at Banda in 1711.');
INSERT INTO "voyages" VALUES (2095, '', 3, '', 'BEVERWIJK', 'Gerrit Donker', 839, NULL, '1700', NULL, NULL, 'A', 'A', '1710-01-19', 'Texel', '1710-05-07', '1710-06-05', true, '1710-07-27', 'Ceylon', 6244, NULL);
INSERT INTO "voyages" VALUES (2096, '', 2, '', 'PRINS EUGENIUS', 'Jan Berger', 874, NULL, '1703', NULL, NULL, 'A', 'A', '1710-01-19', 'Texel', '1710-05-04', '1710-06-05', true, '1710-08-08', 'Batavia', 6264, 'The passengers were stowaways.');
INSERT INTO "voyages" VALUES (2097, '', 2, '', 'GAMRON', 'Marten van der Tocht', 848, NULL, '1706', NULL, NULL, 'A', 'A', '1710-01-19', 'Texel', '1710-05-14', '1710-07-10', true, '1710-09-06', 'Batavia', 6249, 'The passengers were stowaways.');
INSERT INTO "voyages" VALUES (2098, '', 2, '', 'LIMBURG', 'Jan Vorster', 810, NULL, '1704', NULL, NULL, 'A', 'A', '1710-01-19', 'Texel', '1710-05-13', '1710-06-17', true, '1710-09-06', 'Batavia', 6236, 'Among the passengers were four stowaways, at the Cape one stowaway embarked.');
INSERT INTO "voyages" VALUES (2099, '', 5, '', 'HUIS TE NIEUWBURG', 'Jan Klooster', 618, 'fluit? hekboot?', '1697', NULL, NULL, 'A', 'A', '1710-01-19', 'Texel', '1710-05-17', '1710-06-23', true, '1710-09-08', 'Batavia', NULL, 'Lost after departure from Ceylon in 1710.');
INSERT INTO "voyages" VALUES (2100, '', 2, '', 'SLOTEN', 'Theunis de Haan', 610, 'fluit', '1704', NULL, NULL, 'A', 'A', '1710-01-19', 'Texel', '1710-05-17', '1710-06-16', true, '1710-08-22', 'Ceylon', 6246, 'A');
INSERT INTO "voyages" VALUES (2101, '', 2, '', 'DUIVENVOORDE', 'Jan Sluis', 620, 'fluit', '1705', NULL, NULL, 'R', 'R', '1710-01-20', 'Goeree', '1710-05-24', '1710-06-23', true, '1710-09-08', 'Batavia', 6304, 'The passenger was a stowaway.');
INSERT INTO "voyages" VALUES (2102, '', 4, '', 'HUIS TE HEMERT', 'Pieter Daalder', 612, 'fluit', '1701', NULL, NULL, 'A', 'E', '1710-01-20', 'Texel', '1710-05-11', '1710-06-05', true, '1710-08-08', 'Batavia', 6234, 'The passenger was a stowaway.');
INSERT INTO "voyages" VALUES (2103, '', 2, '', 'HERSTELDE LEEUW', 'Adriaan Zomer', 1138, NULL, '1704', NULL, NULL, 'Z', 'Z', '1710-01-20', 'Wielingen', '1710-05-13', '1710-06-05', true, '1710-08-08', 'Batavia', 6235, 'The passenger was a stowaway.');
INSERT INTO "voyages" VALUES (2104, '', 1, '', 'RAADHUIS VAN MIDDELBURG', 'Frederik van der Plas', 890, NULL, '1708', NULL, NULL, 'Z', 'Z', '1710-01-20', 'Wielingen', '1710-05-07', '1710-06-05', true, '1710-08-08', 'Batavia', 6246, NULL);
INSERT INTO "voyages" VALUES (2105, '', 1, '', 'NOORDERKWARTIER', 'Hendrik Verwer', 550, 'fluit', '1709', NULL, NULL, 'H', 'H', '1710-01-20', 'Texel', '1710-05-18', '1710-06-23', true, '1710-09-12', 'Batavia', 6266, NULL);
INSERT INTO "voyages" VALUES (2106, '', 6, '', 'OOSTERSTEIN', 'Jakob Wijsvliet', 1139, NULL, '1693', NULL, NULL, 'Z', 'Z', '1710-01-20', 'Wielingen', '1710-05-06', '1710-06-05', true, '1710-08-08', 'Batavia', 6239, NULL);
INSERT INTO "voyages" VALUES (2107, '', 2, '', 'SCHONEWAL', 'Adriaan de Heere', 632, 'jacht', '1703', NULL, NULL, 'Z', 'Z', '1710-01-20', 'Wielingen', '1710-05-16', '1710-06-05', true, '1710-08-10', 'Batavia', 6258, 'The passenger was a stowaway.');
INSERT INTO "voyages" VALUES (2108, '', 2, '', 'WASSENAAR', 'Jan van Hessel', 804, 'jacht', '1704', NULL, NULL, 'D', 'D', '1710-01-20', 'Goeree', '1710-05-19', '1710-06-17', true, '1710-08-28', 'Batavia', 6241, 'The passenger was a stowaway.');
INSERT INTO "voyages" VALUES (2109, '', 3, '', 'SCHELLENBERG', 'Jakob van den Anker', 630, 'fluit', '1705', NULL, NULL, 'A', 'R', '1710-04-23', 'Goeree', '1710-09-26', '1710-10-24', true, '1711-01-17', 'Batavia', 6268, 'Among the passengers was a stowaway.');
INSERT INTO "voyages" VALUES (2110, '', 1, '', 'WIJNENDAAL', 'Jakob Hekman', 804, 'jacht', '1709', NULL, NULL, 'D', 'D', '1710-04-23', 'Goeree', '1710-09-27', '1710-10-18', true, '1711-01-17', 'Batavia', 6288, NULL);
INSERT INTO "voyages" VALUES (2111, '', 2, '', 'BREDENHOF', 'Hendrik Ben', 586, 'fluit', '1703', NULL, NULL, 'H', 'H', '1710-05-18', 'Texel', '1710-09-29', '1710-10-18', true, '1711-01-14', 'Batavia', NULL, 'At S. Tiago from 12-05 till 15-05-1710. Laid up at Batavia on 27-09-1720.');
INSERT INTO "voyages" VALUES (2112, '', 1, '', 'RAADHUIS VAN ENKHUIZEN', 'Simon Rijksen', 578, 'fluit', '1709', NULL, NULL, 'E', 'E', '1710-05-18', 'Texel', '1710-10-18', '1710-11-15', true, '1711-02-16', 'Batavia', 6283, 'At Porto Prayo from 12-07 till 15-07-1710.');
INSERT INTO "voyages" VALUES (2113, '', 1, '', 'HUIS TER LEEDE', 'Kornelis Dobbel', 300, NULL, '1710', NULL, NULL, 'A', 'A', '1710-05-18', 'Texel', '1710-11-12', NULL, true, '1710-11-12', 'The Cape', 6250, 'Destined for the Cape, to take over the goods of the HAM (6245).');
INSERT INTO "voyages" VALUES (2114, '', 2, '', 'RIJNENBURG', 'Jan de Koning', 618, 'fluit', '1704', NULL, NULL, 'A', 'A', '1710-05-18', 'Texel', '1710-10-25', '1710-11-19', true, '1711-02-21', 'Batavia', 6267, 'Among the passengers were 9 stowaways. Two of them disembarked at the Cape. From 12-07 till 15-07-1710 at S. Tiago.');
INSERT INTO "voyages" VALUES (2115, '', 1, '', 'RIJNESTEIN', 'Jakob Huibertsz. Kaan', 608, 'fluit', '1709', NULL, NULL, 'A', 'A', '1710-05-18', 'Texel', '1710-11-05', '1710-11-28', true, '1711-03-05', 'Batavia', 6284, 'At S. Tiago from 12-07 till 15-07-1710.');
INSERT INTO "voyages" VALUES (2116, '', 5, '', 'GENERALE VREDE', 'Herman Stellingwerf', 1008, 'pinas', '1699', NULL, NULL, 'A', 'A', '1710-05-18', 'Texel', '1710-09-28', '1710-10-23', true, '1711-01-15', 'Batavia', 6260, 'Among the passengers were 5 stowaways; four of them became seafarers. At S. Tiago from 12-07 till 15-07-1710.');
INSERT INTO "voyages" VALUES (2117, '', 3, '', 'WATERINGEN', 'Pieter de Jong', 626, 'jacht', '1701', NULL, NULL, 'D', 'A', '1710-05-18', 'Texel', '1710-10-20', '1710-11-15', true, '1711-02-22', 'Batavia', 6335, 'Among the passengers were 9 stowaways; one of them disembarked at the Cape. From 12-07 till 15-07-1710 at S. Tiago.');
INSERT INTO "voyages" VALUES (2118, '', 2, '', 'DONAU', 'Pieter Stoffelsz.', 794, NULL, '1705', NULL, NULL, 'Z', 'Z', '1710-06-08', 'Wielingen', '1710-11-06', '1711-01-12', true, '1711-03-24', 'Batavia', 6274, NULL);
INSERT INTO "voyages" VALUES (2119, '', 1, '', 'RIJSSEL', 'Frederik van Eik', 858, NULL, '1709', NULL, NULL, 'Z', 'Z', '1710-06-08', 'Wielingen', '1710-11-06', '1711-01-12', true, '1711-05-03', 'Batavia', 6299, 'The two passengers were stowaways.');
INSERT INTO "voyages" VALUES (2120, '', 4, '', 'WESTHOVEN', 'Pieter Buis', 776, NULL, '1698', NULL, NULL, 'Z', 'Z', '1710-06-08', 'Wielingen', '1710-11-06', '1710-12-31', true, '1711-03-24', 'Batavia', 6287, NULL);
INSERT INTO "voyages" VALUES (2121, '', 1, '', 'JORDAAN', 'Joost Nose', 380, NULL, '1709', NULL, NULL, 'Z', 'Z', '1710-10-08', 'Wielingen', '1711-01-23', '1711-02-28', true, '1711-06-25', 'Ceylon', NULL, NULL);
INSERT INTO "voyages" VALUES (2122, '', 2, '', 'BAARZANDE', 'Gijsbert Steen', 768, NULL, '1705', NULL, NULL, 'A', 'A', '1710-10-29', 'Texel', '1711-04-01', '1711-05-12', true, NULL, NULL, NULL, 'The ship was lost on the coast of Mozambique on 09-06-1711.');
INSERT INTO "voyages" VALUES (2123, '', 1, '', 'DOORNIK', 'Hidding Idesz. Nooy', 830, NULL, '1709', NULL, NULL, 'A', 'A', '1710-10-29', 'Texel', '1711-04-04', '1711-05-12', true, '1711-08-20', 'Ceylon', 6315, NULL);
INSERT INTO "voyages" VALUES (2124, '', 2, '', 'ENGEWORMER', 'Willem de Leus', 560, 'fluit', '1707', NULL, NULL, 'H', 'A', '1710-10-29', 'Texel', '1711-05-20', '1711-07-05', true, '1711-10-10', 'Coromandel', 6263, NULL);
INSERT INTO "voyages" VALUES (2125, '', 1, '', 'LEIDSMAN', 'Matthijs de Geus', 320, 'fregat', '1710', NULL, NULL, 'A', 'A', '1710-10-29', 'Texel', '1711-02-15', '1711-05-10', true, '1711-09-03', 'Batavia', 6278, 'The three passengers were stowaways. From 13-06 till 14-07-1711 at Mauritius; two seafarers embarked, who had been left behind by the MERCURIUS (1898).');
INSERT INTO "voyages" VALUES (2126, '', 3, '', 'MEERVLIET', 'Jakob van der Poel', 210, 'jacht', '1706', NULL, NULL, 'A', 'A', '1710-10-29', 'Texel', '1711-02-25', '1711-05-10', true, '1711-09-14', 'Batavia', 6255, 'The three passengers were stowaways. From 13-06 till 15-07-1711 at Mauritius; three seafarers and two passengers embarked.');
INSERT INTO "voyages" VALUES (2127, '', 1, '', 'CHARLOIS', 'Hendrik Lont', 632, 'fluit', '1709', NULL, NULL, 'R', 'R', '1711-01-08', 'Goeree', '1711-05-30', '1711-07-05', true, '1711-09-23', 'Batavia', 6341, 'Among the passengers were 3 stowaways. From 13-01 till 18-01-1711 at Portsmouth.');
INSERT INTO "voyages" VALUES (2128, '', 4, '', 'HOEDEKENSKERKE', 'Arie Turfkloot', 830, NULL, '1704', NULL, NULL, 'Z', 'D', '1711-01-08', 'Goeree', '1711-07-28', '1711-09-05', true, '1711-10-30', 'Batavia', 6295, 'Because of loss of masts at Lisbon in February 1711 till 22-04-1711. 6 Seafarers and 2 soldiers deserted and 2 seaf. embarked.');
INSERT INTO "voyages" VALUES (2129, '', 4, '', 'DEN BERG', 'Hendrik Matthijsz. de Wilde', 836, NULL, '1701', NULL, NULL, 'A', 'A', '1711-01-11', 'Texel', '1711-05-09', '1711-06-10', true, '1711-08-12', 'Ceylon', 6262, 'At Goeree from 16-01 till 31-01-1711.');
INSERT INTO "voyages" VALUES (2130, '', 2, '', 'BRUG', 'Frans Sombeek', 600, 'fluit', '1708', NULL, NULL, 'E', 'E', '1711-01-11', 'Texel', '1711-05-14', '1711-06-03', true, '1711-09-21', 'Batavia', 6292, 'At Goeree from 16-01 till 31-01-1711. At S. Tiago from 15-03 till 19-03-1711.');
INSERT INTO "voyages" VALUES (2131, '', 4, '', 'DIEMEN', 'Gerrit van Lantschot', 596, 'fluit', '1700', NULL, NULL, 'A', 'A', '1711-01-11', 'Texel', '1711-05-13', '1711-06-03', true, '1711-08-07', 'Batavia', 6252, 'At Goeree from 16-01 till 31-01-1711. The passengers were stowaways.');
INSERT INTO "voyages" VALUES (2132, '', 7, '', 'DONKERVLIET', 'Dionys van Vlierden', 794, NULL, '1696', NULL, NULL, 'Z', 'A', '1711-01-11', 'Texel', '1711-05-02', '1711-05-23', true, '1711-07-26', 'Batavia', NULL, 'Among the passengers were four stowaways. Lost after departure from Macassar in November 1718.');
INSERT INTO "voyages" VALUES (2133, '', 1, '', 'HUIGENWAARD', 'Muys Keizer', 600, NULL, '1710', NULL, NULL, 'H', 'H', '1711-01-11', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'At Goeree from 16-01 till 31-01-1711. Taken by the French man of war L''ARSELLE at Cape Finisterre on 21-02-1711.');
INSERT INTO "voyages" VALUES (2134, '', 3, '', 'KONING KAREL DE DERDE', 'David Brouwer', 830, NULL, '1704', NULL, NULL, 'A', 'A', '1711-01-11', 'Texel', '1711-05-09', '1711-06-03', true, '1711-08-12', 'Batavia', 6254, 'Among the passengers were 4 stowaways.');
INSERT INTO "voyages" VALUES (2135, '', 1, '', 'SCHONAUWEN', 'Pieter Kalis', 800, NULL, '1710', NULL, NULL, 'A', 'A', '1711-01-11', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ship was taken by two French ships on 30-04-1711.');
INSERT INTO "voyages" VALUES (2136, '', 3, '', 'WAARDE', 'Karel Lavia', 830, NULL, '1702', NULL, NULL, 'Z', 'A', '1711-01-11', 'Texel', '1711-05-09', '1711-06-03', true, '1711-08-07', 'Batavia', 6270, 'stowaways. From 16-01 till 31-01-1711 at Goeree. At S. Tiago from 15-03 till 19-03-1711.');
INSERT INTO "voyages" VALUES (2137, '', 1, '', 'BERBICES', 'Kornelis Uitenbroek', 1136, NULL, '1709', NULL, NULL, 'Z', 'Z', '1711-01-31', 'Wielingen', '1711-04-30', '1711-05-23', true, '1711-07-19', 'Batavia', 6251, 'Among the passengers were two stowaways.');
INSERT INTO "voyages" VALUES (2138, '', 6, '', 'UNIE', 'Hugo van der Slikke', 1080, 'pinas', '1696', NULL, NULL, 'A', 'Z', '1711-01-31', 'Wielingen', '1711-05-16', '1711-06-16', true, '1711-08-18', 'Batavia', 6259, NULL);
INSERT INTO "voyages" VALUES (2139, '', 2, '', 'VADERLAND GETROUW', 'Herman Grindet', 848, NULL, '1705', NULL, NULL, 'Z', 'Z', '1711-01-31', 'Wielingen', '1711-05-06', '1711-05-23', true, '1711-07-23', 'Batavia', 6285, NULL);
INSERT INTO "voyages" VALUES (2140, '', 2, '', 'OUWEKERK', 'Hero Dol', 658, 'fluit', '1706', NULL, NULL, 'A', 'E', '1711-04-19', 'Texel', '1711-08-09', '1711-09-05', true, '1711-11-18', 'Batavia', 6298, 'The passengers were stowaways.');
INSERT INTO "voyages" VALUES (2141, '', 7, '', 'GRIMMESTEIN', 'Wessel van Neercassel', 759, NULL, '1696', NULL, NULL, 'A', 'R', '1711-04-20', 'Goeree', '1711-09-26', '1711-10-29', true, '1712-01-17', 'Batavia', 6275, 'The four passengers who embarked at the Cape were prisoners.');
INSERT INTO "voyages" VALUES (2142, '', 1, '', 'VOORBURG', 'Kornelis Koekebakker', 600, NULL, '1710', NULL, NULL, 'D', 'D', '1711-04-20', 'Goeree', '1711-09-16', '1711-10-16', true, '1711-12-26', 'Batavia', 6271, NULL);
INSERT INTO "voyages" VALUES (2143, '', 6, '', 'HORSTENDAAL', 'Hendrik Thieling', 688, 'pinas', '1699', NULL, NULL, 'A', 'A', '1711-05-31', 'Texel', '1711-10-15', '1711-11-29', true, '1712-02-28', 'Batavia', 6320, 'The passengers who were on board at departure were stow-aways.');
INSERT INTO "voyages" VALUES (2144, '', 6, '', 'VRIJBURG', 'Dirk Brant', 784, NULL, '1695', NULL, NULL, 'Z', 'H', '1711-05-31', 'Texel', '1711-10-22', '1711-12-13', true, '1712-05-16', 'Batavia', 6308, 'The passengers were stowaways.');
INSERT INTO "voyages" VALUES (2145, '', 2, '', 'ZANDENBURG', 'Adriaan Timmerman', 1136, NULL, '1706', NULL, NULL, 'Z', 'A', '1711-05-31', 'Texel', '1711-10-15', '1711-11-28', true, '1712-02-20', 'Batavia', 6280, 'Among the passengers were 13 stowaways, one of them died. Two children were born during the voyage.');
INSERT INTO "voyages" VALUES (2146, '', 3, '', 'BELVLIET', 'Dirk Blauw +', 586, 'fluit', '1704', NULL, NULL, 'E', 'Z', '1711-08-01', 'Wielingen', '1712-03-27', '1712-05-09', true, '1712-07-18', 'Batavia', 6339, 'From 12-12-1711 till 05-01-1712 at S. Tome, from 10-01 till 16-01-1712 at Cape de Lopez Gonsalves. The master died before the Cape, he was succeeded by Jakob Seinsen.');
INSERT INTO "voyages" VALUES (2147, '', 3, '', 'ZUIDDORP', 'Marinus Wijsvliet', 1152, NULL, '1701', NULL, NULL, 'Z', 'Z', '1711-08-01', 'Wielingen', '1712-03-23', '1712-04-22', true, NULL, NULL, NULL, 'From 13-12-1711 till 04-01-1712 at S. Tome. Via Annabon. Wrecked 40 miles north of the Murchinson river at the west coast of Australia. The wreck was discovered in 1927.');
INSERT INTO "voyages" VALUES (2148, '', 1, '', 'HOOGWOUD', 'Evert van der Werf', 180, NULL, '1710', NULL, NULL, 'E', 'E', '1711-11-03', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'On 18-01-1712 the ship was taken by three French warships.');
INSERT INTO "voyages" VALUES (2149, '', 1, '', 'KIJKUIT', 'Gerrit Moring', 200, 'fregat', '1709', NULL, NULL, 'A', 'A', '1711-11-03', 'Texel', '1712-03-01', NULL, true, '1712-03-01', 'The Cape', 6272, NULL);
INSERT INTO "voyages" VALUES (2150, '', 1, '', 'KOCKENGEN', 'Hayman de Laver', 824, NULL, '1711', NULL, NULL, 'A', 'A', '1711-11-03', 'Texel', '1712-03-28', '1712-04-22', true, '1712-07-04', 'Batavia', 6276, NULL);
INSERT INTO "voyages" VALUES (2151, '', 5, '', 'LIEFDE', 'Barend Meikens', 1009, 'fregat', '1698', NULL, NULL, 'A', 'A', '1711-11-03', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'one man was saved.');
INSERT INTO "voyages" VALUES (2152, '', 2, '', 'MOSSEL', 'Pieter Mansvelt', 676, 'fluit', '1706', NULL, NULL, 'E', 'A', '1711-11-03', 'Texel', '1712-03-13', '1712-03-29', true, '1712-06-11', 'Batavia', 6296, 'of the passengers who came aboard at the Cape was a stowaway.');
INSERT INTO "voyages" VALUES (2153, '', 1, '', 'WEERESTEIN', 'Jan Krijnebak.', 240, NULL, '1710', NULL, NULL, 'E', 'A', '1711-11-03', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Lost at the Shetlands.');
INSERT INTO "voyages" VALUES (2154, '', 2, '', 'STANDVASTIGHEID', 'Kornelis Goudswaard', 888, NULL, '1706', NULL, NULL, 'A', 'R', '1712-01-10', 'Goeree', '1712-05-28', '1712-06-17', true, '1712-08-29', 'Batavia', 6279, 'Among the passengers were 5 stowaways.');
INSERT INTO "voyages" VALUES (2155, '', 2, '', 'KORSSLOOT', 'Stoffel Hansz. Boom', 630, 'fluit', '1705', NULL, NULL, 'H', 'E', '1712-01-19', 'Texel', '1712-05-01', '1712-05-20', true, '1712-07-28', 'Batavia', 6277, 'Among the passengers were 6 stowaways.');
INSERT INTO "voyages" VALUES (2156, '', 1, '', 'OUDE ZIJPE', 'Daniel Dirksz. Bent', 600, 'fluit', '1711', NULL, NULL, 'H', 'E', '1712-01-19', 'Texel', '1712-05-01', '1712-05-20', true, NULL, 'Batavia', 6281, NULL);
INSERT INTO "voyages" VALUES (2157, '', 3, '', 'BARNEVELD', 'Adriaan Bogaard', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1712-01-20', 'Texel', '1712-06-14', '1712-07-11', true, '1712-09-01', 'Batavia', 6273, NULL);
INSERT INTO "voyages" VALUES (2158, '', 2, '', 'BENTVELD', 'Kornelis Dobbel', 938, NULL, '1708', NULL, NULL, 'A', 'A', '1712-01-20', 'Texel', '1712-05-31', '1712-06-24', true, '1712-08-20', 'Ceylon', 6282, NULL);
INSERT INTO "voyages" VALUES (2159, '', 2, '', 'MUNDEN', 'Theunis de Haan', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1712-01-20', 'Texel', '1712-06-21', '1712-07-27', true, '1712-09-27', 'Batavia', 6306, 'From 27-03 till 02-04-1712 at S. Tiago. Among the passengers were 5 stowaways.');
INSERT INTO "voyages" VALUES (2160, '', 2, '', 'NOORDBEEK', 'Pieter de Groot', 858, NULL, '1707', NULL, NULL, 'Z', 'A', '1712-01-20', 'Texel', '1712-06-17', '1712-08-15', true, '1712-10-18', 'Batavia', 6330, 'From 27-03 till 02-04-1712 at S. Tiago. Among the passengers were 11 stowaways.');
INSERT INTO "voyages" VALUES (2161, '', 1, '', 'ZANDERHOEF', 'Geerlof Bontekoe', 608, 'fluit', '1711', NULL, NULL, 'A', 'A', '1712-01-20', 'Texel', '1712-06-25', '1712-07-27', true, '1712-10-21', 'Batavia', 6363, 'The passengers were stowaways.');
INSERT INTO "voyages" VALUES (2162, '', 7, '', 'OOSTERSTEIN', 'Jan de Hei', 1139, NULL, '1693', NULL, NULL, 'Z', 'Z', '1712-01-24', 'Wielingen', '1712-04-20', '1712-05-09', true, '1712-07-07', 'Batavia', NULL, 'During the voyage one child was born. Laid up at Ceylon in 1716.');
INSERT INTO "voyages" VALUES (2163, '', 3, '', 'POPKENSBURG', 'Kornelis Gillisz.', 804, NULL, '1699', NULL, NULL, 'Z', 'Z', '1712-01-24', 'Wielingen', '1712-04-20', '1712-05-09', true, '1712-07-22', 'Batavia', 6322, NULL);
INSERT INTO "voyages" VALUES (2164, '', 1, '', 'ZUIDERBEEK', 'Reinier Hijpe', 812, NULL, '1711', NULL, NULL, 'Z', 'Z', '1712-01-24', 'Wielingen', '1712-04-19', '1712-05-09', true, '1712-07-17', 'Batavia', 6333, NULL);
INSERT INTO "voyages" VALUES (2165, '', 2, '', 'ARENDSDUIN', 'Wessel Hoogwerf', 580, 'jacht', '1708', NULL, NULL, 'D', 'A', '1712-04-27', 'Texel', '1712-08-27', '1712-09-25', true, '1712-12-04', 'Batavia', 6289, 'Among the passengers were 4 stowaways.');
INSERT INTO "voyages" VALUES (2166, '', 2, '', 'ARION', 'Jan van der Merkt', 630, 'fluit', '1706', NULL, NULL, 'A', 'A', '1712-04-27', 'Texel', '1712-08-31', '1712-10-04', true, '1712-12-04', 'Batavia', NULL, 'Among the passengers were 2 stowaways. Lost in 1714 at the Paracelles on the way to Japan.');
INSERT INTO "voyages" VALUES (2167, '', 5, '', 'HUIS TE HEMERT', 'Kornelis de Ka', 612, 'fluit', '1701', NULL, NULL, 'A', 'E', '1712-04-27', 'Texel', '1712-08-29', '1712-09-25', true, '1712-12-05', 'Batavia', 6318, 'The passengers were stowaways.');
INSERT INTO "voyages" VALUES (2168, '', 2, '', 'HUIS TER LEEDE', 'Jan van Vliet', 300, NULL, '1710', NULL, NULL, 'A', 'A', '1712-04-27', 'Texel', '1712-09-02', '1712-09-25', true, '1713-01-12', 'Batavia', 6338, NULL);
INSERT INTO "voyages" VALUES (2169, '', 3, '', 'LIMBURG', 'Jan Wijnands', 810, NULL, '1704', NULL, NULL, 'A', 'H', '1712-04-27', 'Texel', '1712-08-31', '1712-09-25', true, '1712-12-09', 'Batavia', 6328, 'The passengers were stowaways.');
INSERT INTO "voyages" VALUES (2170, '', 2, '', 'RAADHUIS VAN MIDDELBURG', 'Anthonie van Doorn', 890, NULL, '1708', NULL, NULL, 'Z', 'Z', '1712-04-30', 'Wielingen', '1712-08-11', '1712-09-10', true, '1712-11-20', 'Batavia', 6359, 'Among the passengers was one stowaway.');
INSERT INTO "voyages" VALUES (2171, '', 1, '', 'HUIS TEN DONK', 'Jan van Diemen', 650, NULL, '1711', NULL, NULL, 'R', 'R', '1712-05-10', 'Goeree', '1713-02-17', '1713-04-03', true, '1713-07-04', 'Batavia', 6357, 'stowaway. From 26-08 till 17-09-1712 at Rio Grande, where 6 seafarers deserted.');
INSERT INTO "voyages" VALUES (2172, '', 3, '', 'WASSENAAR', 'Jakob Verduin', 804, NULL, '1704', NULL, NULL, 'D', 'D', '1712-05-10', 'Goeree', '1712-11-19', '1712-12-13', true, '1713-02-18', 'Batavia', 6332, 'The passenger was a stowaway. From 17-08 till 26-08-1712 at S. Tome.');
INSERT INTO "voyages" VALUES (2173, '', 4, '', 'BEVERWIJK', 'Hessel Pruis', 836, NULL, '1700', NULL, NULL, 'A', 'A', '1712-06-05', 'Texel', '1712-10-02', '1712-11-14', true, '1713-02-10', 'Batavia', 6314, 'Among the passengers were 3 stowaways.');
INSERT INTO "voyages" VALUES (2174, '', 2, '', 'AVONTURIER', 'Abraham Ram', 300, 'fregat', '1707', NULL, NULL, 'A', 'A', '1712-10-23', 'Texel', '1713-02-14', '1713-04-03', true, '1713-06-27', 'Batavia', NULL, 'was laid up at Batavia on 26-03-1720.');
INSERT INTO "voyages" VALUES (2175, '', 1, '', 'SCHOTEROOG', 'Boudewijn Overmeer', 360, 'fregat', '1712', NULL, NULL, 'A', 'A', '1712-10-23', 'Texel', '1713-02-08', '1713-02-26', true, '1713-05-15', 'Batavia', 6324, 'were stowaways.');
INSERT INTO "voyages" VALUES (2176, '', 2, '', 'AMAZONE', 'Pieter Prop', 590, 'fluit', '1707', NULL, NULL, 'A', 'A', '1712-10-27', 'Texel', '1713-03-27', '1713-04-20', true, '1713-07-11', 'Batavia', 6291, 'The passengers were stowaways.');
INSERT INTO "voyages" VALUES (2177, '', 2, '', 'NOORDERKWARTIER', 'Gerrit Moring', 550, 'fluit', '1709', NULL, NULL, 'H', 'A', '1712-10-27', 'Texel', '1713-03-13', '1713-04-03', true, '1713-07-08', 'Batavia', 6297, 'The passengers at departure were stowaways.');
INSERT INTO "voyages" VALUES (2178, '', 7, '', 'UNIE', 'Herman de Marre', 1080, 'pinas', '1696', NULL, NULL, 'A', 'A', '1712-10-27', 'Texel', '1713-03-15', '1713-04-20', true, '1713-07-14', 'Batavia', NULL, 'The passengers aboard at departure were stowaways. Laid up at Batavia on 30-11-1721.');
INSERT INTO "voyages" VALUES (2179, '', 5, '', 'DEN BERG', 'Kornelis de Geus', 836, NULL, '1701', NULL, NULL, 'A', 'A', '1713-01-01', 'Texel', '1713-04-29', '1713-05-27', true, '1713-08-10', 'Ceylon', 6301, NULL);
INSERT INTO "voyages" VALUES (2180, '', 3, '', 'GAMRON', 'Jakob Regenboog', 848, NULL, '1706', NULL, NULL, 'A', 'A', '1713-01-01', 'Texel', '1713-04-29', '1713-05-27', true, '1713-07-31', 'Batavia', 6294, NULL);
INSERT INTO "voyages" VALUES (2181, '', 2, '', 'SAMSON', 'Pieter Kornelisz. Koster', 800, NULL, '1707', NULL, NULL, 'A', 'H', '1713-01-01', 'Texel', '1713-05-09', '1713-05-27', true, '1713-07-31', 'Batavia', 6300, 'Among the passengers were 9 stowaways.');
INSERT INTO "voyages" VALUES (2182, '', 2, '', 'BERBICES', 'Daniel Keskes', 1136, NULL, '1709', NULL, NULL, 'Z', 'Z', '1713-03-07', 'Wielingen', '1713-07-05', '1713-08-13', true, '1713-10-23', 'Batavia', 6313, 'The passengers at departure were stowaways.');
INSERT INTO "voyages" VALUES (2183, '', 3, '', 'ENGEWORMER', 'Kornelis de Roos', 560, 'fluit', '1707', NULL, NULL, 'H', 'Z', '1713-03-07', 'Wielingen', '1713-07-05', '1713-07-28', true, '1713-10-09', 'Batavia', 6293, NULL);
INSERT INTO "voyages" VALUES (2184, '', 2, '', 'HERSTELDE LEEUW', 'Huibrecht Andriesz.', 1138, NULL, '1704', NULL, NULL, 'Z', 'Z', '1713-03-07', 'Wielingen', '1713-07-03', '1713-08-13', true, '1713-10-26', 'Batavia', 6321, NULL);
INSERT INTO "voyages" VALUES (2185, '', 4, '', 'SCHELLENBERG', 'Frans de Brooi', 630, 'fluit', '1705', NULL, NULL, 'A', 'Z', '1713-03-07', 'Wielingen', '1713-07-05', '1713-07-28', true, '1713-10-10', 'Batavia', 6331, NULL);
INSERT INTO "voyages" VALUES (2186, '', 3, '', 'RIJNENBURG', 'David Brouwer', 618, 'fluit', '1704', NULL, NULL, 'A', 'A', '1713-03-09', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ship was lost on a reef of the Shetlands on 15-03-1713.');
INSERT INTO "voyages" VALUES (2187, '', 4, '', 'KONING KAREL DE DERDE', 'Gerrit van der Zijde', 830, NULL, '1704', NULL, NULL, 'A', 'D', '1713-05-08', 'Goeree', '1713-09-14', '1713-10-07', true, '1713-12-12', 'Batavia', 6369, 'Among the passengers were 6 stowaways; 4 of them disembarked at the Cape.');
INSERT INTO "voyages" VALUES (2188, '', 3, '', 'NEPTUNUS', 'Hendrik Stokman', 858, NULL, '1704', NULL, NULL, 'A', 'R', '1713-05-18', 'Goeree', '1713-09-29', '1713-10-28', true, '1714-01-06', 'Batavia', 6352, 'From 23-05 till 05-06-1713 back at Goeree because of leakage. Here 3 seafarers and 3 soldiers deserted and 1 sold. disembarked because of illness.');
INSERT INTO "voyages" VALUES (2189, '', 2, '', 'HARINGTUIN', 'Freek Albertsz. Slott', 618, 'fluit', '1705', NULL, NULL, 'E', 'E', '1713-05-23', 'Texel', '1713-09-29', '1713-11-01', true, '1714-01-13', 'Batavia', 6334, 'Among the passengers were 2 stowaways. The master died during the voyage and was succeeded by Hendrik Jansz. Prins.');
INSERT INTO "voyages" VALUES (2190, '', 3, '', 'PRINS EUGENIUS', 'Christiaan Emmerij', 874, NULL, '1703', NULL, NULL, 'A', 'A', '1713-05-26', 'Texel', '1713-10-18', '1713-11-20', true, '1714-02-02', 'Batavia', 6351, '25-07-1713 at S. Tiago.');
INSERT INTO "voyages" VALUES (2191, '', 2, '', 'KIJKUIT', 'Wouter Thomas van Dijk', 200, 'fregat', '1709', NULL, NULL, 'A', 'A', '1713-05-26', 'Texel', NULL, NULL, false, '1713-10-24', 'Batavia', 6342, 'The passengers were stowaways.');
INSERT INTO "voyages" VALUES (2192, '', 4, '', 'MEERVLIET', 'Joost Morry', 200, 'jacht', '1706', NULL, NULL, 'A', 'A', '1713-05-26', 'Texel', '1713-10-01', '1713-10-06', true, '1714-01-01', 'Ceylon', NULL, 'With the message of the peace treaty of Utrecht.');
INSERT INTO "voyages" VALUES (2193, '', 1, '', 'NESSERAK', 'Francois Zegers', 804, NULL, '1712', NULL, NULL, 'A', 'A', '1713-05-26', 'Texel', '1713-11-08', '1713-12-23', true, '1714-05-07', 'Batavia', 6372, 'The 15 passengers on board at departure were stowaways. From 22-07 till 26-07-1713 at S. Tiago.');
INSERT INTO "voyages" VALUES (2194, '', 2, '', 'VOORBURG', 'Jan Lette', 600, NULL, '1710', NULL, NULL, 'D', 'A', '1713-05-26', 'Texel', '1713-09-29', '1713-10-28', true, '1714-01-25', 'Batavia', 6309, 'Among the passengers were 6 stowaways who disembarked at the Cape.');
INSERT INTO "voyages" VALUES (2195, '', 6, '', 'GENERALE VREDE', 'Willem de Leus', 1008, 'pinas', '1699', NULL, NULL, 'A', 'A', '1713-05-26', 'Texel', '1713-10-02', '1713-11-20', true, '1714-03-19', 'Batavia', 6312, 'Among the passengers were 19 stowaways who disembarked at the Cape.');
INSERT INTO "voyages" VALUES (2196, '', 3, '', 'SCHONEWAL', 'Adriaan Tessing', 632, 'jacht', '1703', NULL, NULL, 'Z', 'Z', '1713-06-05', 'Wielingen', '1713-09-29', '1713-10-28', true, '1714-01-21', 'Batavia', 6336, 'Among the passengers were 2 stowaways.');
INSERT INTO "voyages" VALUES (2197, '', 4, '', 'WAARDE', 'Jan Tessing', 830, NULL, '1702', NULL, NULL, 'Z', 'Z', '1713-06-05', 'Wielingen', '1713-10-01', '1713-10-28', true, '1714-01-23', 'Ceylon', 6361, NULL);
INSERT INTO "voyages" VALUES (2198, '', 1, '', 'STRIJKEBOLLE', 'Pieter Willemsz. Slijper', 540, 'fluit', '1712', NULL, NULL, 'E', 'E', '1713-06-15', 'Texel', '1713-10-14', '1713-11-01', true, '1714-01-13', 'Batavia', 6388, 'The passengers were stowaways.');
INSERT INTO "voyages" VALUES (2199, '', 5, '', 'DIEMEN', 'Jan Lindeboom', 596, 'fluit', '1700', NULL, NULL, 'A', 'A', '1713-06-22', 'Texel', '1713-10-16', '1713-11-20', true, '1714-01-23', 'Ceylon', 6362, NULL);
INSERT INTO "voyages" VALUES (2200, '', 1, '', 'MIDDELWOUD', 'Jan Akkerman', 804, NULL, '1713', NULL, NULL, 'Z', 'Z', '1713-10-14', 'Wielingen', '1714-01-29', '1714-02-22', true, '1714-05-01', 'Batavia', 6387, NULL);
INSERT INTO "voyages" VALUES (2201, '', 1, '', 'D''UNO', 'Jan Leendertsz.', 250, 'fregat', '1707', NULL, NULL, 'Z', 'Z', '1713-10-16', 'Wielingen', '1714-01-19', '1714-02-22', true, '1714-05-17', 'Batavia', 6374, NULL);
INSERT INTO "voyages" VALUES (2202, '', 4, '', 'GANSENHOEF', 'Rijkmanus ten Ben', 640, 'fluit', '1702', NULL, NULL, 'A', 'A', '1713-10-22', 'Texel', '1714-04-04', '1714-04-23', true, '1714-07-01', 'Batavia', 6337, 'From 3-11 till 05-12-1713 at S. Tiago.');
INSERT INTO "voyages" VALUES (2203, '', 2, '', 'KOCKENGEN', 'Reiniersz.', 824, NULL, '1711', NULL, NULL, 'A', 'A', '1713-11-30', 'Texel', '1714-03-24', '1714-04-05', true, '1714-06-16', 'Batavia', 6386, NULL);
INSERT INTO "voyages" VALUES (2204, '', 2, '', 'WIJNENDAAL', 'Jan Baai', 804, 'jacht', '1709', NULL, NULL, 'D', 'A', '1713-11-30', 'Texel', '1714-03-26', '1714-04-05', true, '1714-06-23', 'Batavia', 6364, NULL);
INSERT INTO "voyages" VALUES (2205, '', 1, '', 'TER HORST', 'Aarnoud van Kleef', 520, 'fluit', '1713', NULL, NULL, 'D', 'D', '1714-01-16', 'Goeree', '1714-05-09', '1714-06-12', true, '1714-08-28', 'Batavia', 6319, NULL);
INSERT INTO "voyages" VALUES (2206, '', 4, '', 'KIEFHOEK', 'Kornelis Goudswaard', 832, NULL, '1701', NULL, NULL, 'R', 'R', '1714-01-16', 'Goeree', '1714-05-09', '1714-06-05', true, '1714-08-13', 'Batavia', 6370, 'One child was born during the voyage.');
INSERT INTO "voyages" VALUES (2207, '', 3, '', 'KORSSLOOT', 'Pieter de Boer', 630, 'fluit', '1705', NULL, NULL, 'H', 'E', '1714-01-17', 'Texel', '1714-04-20', '1714-06-02', true, '1714-08-13', 'Batavia', 6311, NULL);
INSERT INTO "voyages" VALUES (2208, '', 3, '', 'BENTVELD', 'Lambert Rot', 538, NULL, '1708', NULL, NULL, 'A', 'A', '1714-01-18', 'Texel', '1714-04-17', '1714-06-01', true, '1714-08-19', 'Ceylon', 6327, NULL);
INSERT INTO "voyages" VALUES (2209, '', 1, '', 'RIJKSDORP', 'Lukas Schrik', 792, NULL, '1713', NULL, NULL, 'A', 'A', '1714-01-18', 'Texel', '1714-05-18', '1714-06-30', true, '1714-09-20', 'Batavia', 6400, NULL);
INSERT INTO "voyages" VALUES (2210, '', 2, '', 'RIJNESTEIN', 'Balten Leesten', 608, 'fluit', '1709', NULL, NULL, 'A', 'Z', '1714-01-18', 'Wielingen', '1714-05-13', '1714-06-12', true, '1714-09-09', 'Batavia', 6323, NULL);
INSERT INTO "voyages" VALUES (2211, '', 3, '', 'ZANDENBURG', 'Jakob Kole', 1136, NULL, '1706', NULL, NULL, 'Z', 'Z', '1714-01-18', 'Wielingen', '1714-05-07', '1714-06-05', true, '1714-08-13', 'Batavia', 6326, NULL);
INSERT INTO "voyages" VALUES (2212, '', 2, '', 'OUDE ZIJPE', 'Gerrit Verburg', 600, 'fluit', '1711', NULL, NULL, 'H', 'E', '1714-01-18', 'Texel', '1714-05-02', '1714-06-02', true, '1714-08-13', 'Batavia', 6389, NULL);
INSERT INTO "voyages" VALUES (2213, '', 4, '', 'BARNEVELD', 'Kornelis Dobbel', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1714-01-23', 'Texel', '1714-05-09', '1714-06-12', true, '1714-08-28', 'Batavia', 6310, 'Among the passengers was one stowaway, who disembarked at the Cape.');
INSERT INTO "voyages" VALUES (2214, '', 8, '', 'GRIMMESTEIN', 'Michiel Rozenkrans', 759, NULL, '1696', NULL, NULL, 'A', 'A', '1714-01-23', 'Texel', '1714-05-09', '1714-06-12', true, '1714-08-28', 'Batavia', 6317, NULL);
INSERT INTO "voyages" VALUES (2215, '', 5, '', 'WESTHOVEN', 'Pieter Buis', 776, NULL, '1698', NULL, NULL, 'Z', 'Z', '1714-01-29', 'Wielingen', '1714-05-09', '1714-06-12', true, '1714-08-28', 'Batavia', 6325, NULL);
INSERT INTO "voyages" VALUES (2216, '', 2, '', 'RAADHUIS VAN ENKHUIZEN', 'Douwe Bruin', 578, 'fluit', '1709', NULL, NULL, 'E', 'A', '1714-01-30', 'Texel', '1714-05-14', '1714-07-19', true, '1714-09-28', 'Batavia', 6316, NULL);
INSERT INTO "voyages" VALUES (2217, '', 1, '', 'HUIS DE VLOTTER', 'Jan Sanderus', 528, 'fluit', '1713', NULL, NULL, 'A', 'A', '1714-03-11', 'Texel', '1714-07-27', '1714-08-18', true, '1714-11-05', 'Batavia', 6391, NULL);
INSERT INTO "voyages" VALUES (2218, '', 3, '', 'VADERLAND GETROUW', 'Jakob de Laver', 848, NULL, '1705', NULL, NULL, 'Z', 'Z', '1714-04-08', 'Wielingen', '1714-07-18', '1714-08-13', true, '1714-10-18', 'Batavia', 6356, NULL);
INSERT INTO "voyages" VALUES (2219, '', 3, '', 'DONAU', 'Kornelis Koekebakker', 794, NULL, '1705', NULL, NULL, 'Z', 'D', '1714-04-24', 'Goeree', '1714-08-01', '1714-09-02', true, '1714-11-15', 'Batavia', 6411, NULL);
INSERT INTO "voyages" VALUES (2220, '', 3, '', 'STANDVASTIGHEID', 'Klaas de Vries', 888, NULL, '1706', NULL, NULL, 'A', 'A', '1714-04-24', 'Goeree', '1714-08-12', '1714-09-08', true, '1714-11-24', 'Batavia', 6355, 'Among the passengers was one stowaway.');
INSERT INTO "voyages" VALUES (2221, '', 1, '', 'SLEEWIJK', 'Gerrit Schot', 520, 'jacht', '1713', NULL, NULL, 'R', 'R', '1714-04-25', 'Goeree', '1714-08-22', '1714-09-17', true, '1714-11-22', 'Batavia', 6373, NULL);
INSERT INTO "voyages" VALUES (2222, '', 2, '', 'OUDENAARDE', 'Jan Jurriaansz. Ben', 858, NULL, '1708', NULL, NULL, 'A', 'H', '1714-05-09', 'Texel', '1714-12-23', '1715-01-20', true, '1715-05-08', 'Batavia', 6360, 'Guinea.');
INSERT INTO "voyages" VALUES (2223, '', 1, '', 'RISDAM', 'Pieter Daalder', 520, 'fluit', '1713', NULL, NULL, 'H', 'A', '1714-09-27', 'Texel', '1715-01-09', '1715-01-27', true, '1715-04-22', 'Batavia', 6390, 'At S. Tiago from 27-10 till 01-11-1725.');
INSERT INTO "voyages" VALUES (2224, '', 1, '', 'LINSCHOTEN', 'Arie van der Linde +', 804, NULL, '1714', NULL, NULL, 'A', 'A', '1714-10-22', 'Texel', '1715-03-19', '1715-04-19', true, '1715-06-23', 'Batavia', 6343, 'From 30-10 till 16-11-1714 at Duins.');
INSERT INTO "voyages" VALUES (2225, '', 1, '', 'WESTERDIJKSHORN', 'Jan Berger', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1714-10-22', 'Texel', '1715-03-04', '1715-04-21', true, '1715-06-24', 'Batavia', 6349, 'From 30-10 till 16-11-1714 at Duins.');
INSERT INTO "voyages" VALUES (2226, '', 3, '', 'AMAZONE', 'Lambert Kellaar', 590, 'fluit', '1707', NULL, NULL, 'A', 'A', '1714-11-16', 'Texel', '1715-03-30', '1715-04-21', true, '1715-07-03', 'Batavia', 6410, NULL);
INSERT INTO "voyages" VALUES (2227, '', 1, '', 'MEIJENBURG', 'Jan de Heere', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1714-12-10', 'Wielingen', '1715-03-27', '1715-05-24', true, '1715-07-22', 'Batavia', 6344, 'At Duins from 13-12 till 19-12-1714; 5 seafarers were left behind.');
INSERT INTO "voyages" VALUES (2228, '', 4, '', 'ENGEWORMER', 'Jakobus van der Kade', 560, 'fluit', '1707', NULL, NULL, 'H', 'R', '1714-12-23', 'Goeree', '1715-04-30', '1715-05-24', true, '1715-07-18', 'Batavia', 6350, NULL);
INSERT INTO "voyages" VALUES (2229, '', 2, '', 'LEIDSMAN', 'Pieter Knollendam', 320, 'fregat', '1710', NULL, NULL, 'A', 'H', '1714-12-23', 'Texel', '1715-03-27', NULL, true, '1716-04-13', 'Batavia', 6405, NULL);
INSERT INTO "voyages" VALUES (2230, '', 2, '', 'NEDERHOVEN', 'Jakob van der Poel', 600, 'fluit', '1708', NULL, NULL, 'R', 'D', '1714-12-23', 'Goeree', '1715-04-30', '1715-05-24', true, '1715-07-28', 'Batavia', 6399, NULL);
INSERT INTO "voyages" VALUES (2231, '', 3, '', 'ARENDSDUIN', 'Pieter Oversluis', 580, 'jacht', '1708', NULL, NULL, 'D', 'Z', '1715-01-09', 'Wielingen', '1715-04-27', '1715-06-14', true, '1715-08-20', 'Batavia', 6367, NULL);
INSERT INTO "voyages" VALUES (2232, '', 3, '', 'BRUG', 'Jakob Visser', 600, 'fluit', '1708', NULL, NULL, 'E', 'E', '1715-01-09', 'Texel', '1715-04-19', '1715-05-24', true, '1715-07-26', 'Batavia', 6340, NULL);
INSERT INTO "voyages" VALUES (2233, '', 1, '', 'LOOSDRECHT', 'Overmeer', 805, NULL, '1714', NULL, NULL, 'A', 'A', '1715-01-09', 'Texel', '1715-04-20', '1715-05-23', true, NULL, 'Ceylon', 6358, NULL);
INSERT INTO "voyages" VALUES (2234, '', 3, '', 'MIJNDEN', 'Wessel Hoogwerf', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1715-01-09', 'Texel', '1715-04-30', '1715-06-14', true, '1715-08-15', 'Batavia', 6345, NULL);
INSERT INTO "voyages" VALUES (2235, '', 3, '', 'NOORDERKWARTIER', 'Jochem Pijselman', 550, 'fluit', '1709', NULL, NULL, 'H', 'A', '1715-01-09', 'Texel', '1715-04-20', '1715-05-23', true, '1715-07-21', 'Batavia', 6346, 'Among the passengers was only one stowaway.');
INSERT INTO "voyages" VALUES (2236, '', 3, '', 'OUWERKERK', 'Gerrit Staal', 658, 'fluit', '1706', NULL, NULL, 'A', 'A', '1715-01-09', 'Texel', '1715-05-05', '1715-07-09', true, '1715-09-27', 'Batavia', 6353, NULL);
INSERT INTO "voyages" VALUES (2237, '', 3, '', 'SAMSON', 'Pieter Prop', 800, NULL, '1707', NULL, NULL, 'A', 'A', '1715-01-09', 'Texel', '1715-04-20', '1715-05-23', true, '1715-07-27', 'Batavia', 6354, NULL);
INSERT INTO "voyages" VALUES (2238, '', 3, '', 'VOORBURG', 'Jan Kopersluis', 600, NULL, '1710', NULL, NULL, 'D', 'A', '1715-01-09', 'Texel', '1715-05-04', '1715-06-14', true, '1715-08-16', 'Batavia', 6348, NULL);
INSERT INTO "voyages" VALUES (2239, '', 1, '', 'WITSBURG', 'Frank Versijde', 520, 'fluit', '1714', NULL, NULL, 'E', 'A', '1715-01-09', 'Texel', '1715-04-23', '1715-05-24', true, '1715-07-30', 'Batavia', 6393, NULL);
INSERT INTO "voyages" VALUES (2240, '', 2, '', 'RIJSSEL', 'Michiel Landsheer', 858, NULL, '1709', NULL, NULL, 'Z', 'Z', '1715-01-10', 'Wielingen', '1715-04-25', '1715-05-24', true, '1715-07-21', 'Batavia', 6347, NULL);
INSERT INTO "voyages" VALUES (2241, '', 3, '', 'DUIVENVOORDE', 'Frederik van Eik', 620, 'fluit', '1705', NULL, NULL, 'R', 'Z', '1715-01-17', 'Vlissingen', '1715-07-10', '1715-08-25', true, '1715-11-10', 'Batavia', 6379, 'The passenger on board at departure was a stowaway. From 24-01 till 16-02-1715 at Duins where the five seafarers who missed the MEIJENBURG (2227) were picked up. At Portsmouth from 17-02 till 26-02; at St. Helens from 27 till 28-02-1715 and again at Portsmouth from 04-03 till 12-03-1715; from 15-03 till 29-03-1715 at Plymouth where two seafarers and one soldier deserted.');
INSERT INTO "voyages" VALUES (2242, '', 3, '', 'ELLEMEET', 'Bartholomeus van de Kapello', 670, NULL, '1699', NULL, NULL, 'Z', 'Z', '1715-04-05', 'Rammekens', '1715-08-12', '1715-09-12', true, NULL, NULL, NULL, 'The ship was laid up at Batavia on 25-09-1722.');
INSERT INTO "voyages" VALUES (2243, '', 6, '', 'DEN BERG', 'Jakob Onkruid', 836, NULL, '1701', NULL, NULL, 'A', 'A', '1715-04-09', 'Texel', '1715-08-20', '1715-10-01', true, '1715-12-17', 'Batavia', 6378, 'From 19-05 till 26-05-1715 at S. Tiago.');
INSERT INTO "voyages" VALUES (2244, '', 7, '', 'VRIJBURG', 'Jan de Koning', 784, NULL, '1695', NULL, NULL, 'Z', 'A', '1715-04-09', 'Texel', '1715-08-21', '1715-10-01', true, '1716-02-29', 'Batavia', NULL, 'From 19-05 till 26-05-1715 at S. Tiago. Due to leakage back to the Cape and second departure from there on 21-01-1716. The master left the ship and was replaced by Bartold Bolleman. The VRIJBURG was laid up at Batavia on 25-09-1722.');
INSERT INTO "voyages" VALUES (2245, '', 4, '', 'GAMRON', 'Daniel van Krimpen', 848, NULL, '1706', NULL, NULL, 'A', 'R', '1715-04-21', 'Goeree', '1715-08-20', '1715-11-02', true, '1716-02-17', 'Batavia', NULL, 'Burnt off the coast of Ceylon on 15-11-1721.');
INSERT INTO "voyages" VALUES (2246, '', 1, '', 'SLOT ALDEGONDE', 'Jakob de Vries', 1160, 'jacht', '1714', NULL, NULL, 'Z', 'Z', '1715-04-25', 'Rammekens', '1715-10-07', '1715-11-29', true, '1716-02-25', 'Batavia', 6409, 'At Saldanha Bay from 20-08 till 06-10-1715, due to the loss of the steer.');
INSERT INTO "voyages" VALUES (2247, '', 4, '', 'BEVERWAART', 'Pieter Koster', 760, NULL, '1702', NULL, NULL, 'A', 'A', '1715-05-31', 'Texel', '1715-09-20', '1715-11-29', true, '1716-02-25', 'Batavia', NULL, 'At Dassen Island on 13-09-1715. Laid up at Batavia in 1723.');
INSERT INTO "voyages" VALUES (2248, '', 3, '', 'HUIS TER BOEDE', 'Pieter Berkman', 642, 'jacht', '1702', NULL, NULL, 'Z', 'A', '1715-05-31', 'Texel', '1715-12-16', NULL, true, '1716-04-08', 'Batavia', 6420, 'Among the passengers was a stowaway. At Sao Tome from 03-09 till 26-09-1715; 2 seafarers and 2 soldiers ran away and 2 stow-aways came aboard.');
INSERT INTO "voyages" VALUES (2249, '', 3, '', 'MOSSEL', 'Stoffel Hansz. Boom', 676, 'fluit', '1706', NULL, NULL, 'E', 'E', '1715-05-31', 'Texel', '1715-10-13', '1715-11-29', true, '1716-02-27', 'Batavia', 6371, 'According to K.A. 4390A departure on 23-12-1714.');
INSERT INTO "voyages" VALUES (2250, '', 5, '', 'HOEDEKENSKERKE', 'Jan Maljaard +', 830, NULL, '1704', NULL, NULL, 'Z', 'Z', '1715-06-04', 'Vlissingen', '1715-10-30', '1715-12-11', true, '1716-05-17', 'Batavia', 6436, 'The master died during the voyage.');
INSERT INTO "voyages" VALUES (2251, '', 5, '', 'ABBEKERK', 'Pieter Jakob Rus', 600, 'fluit', '1698', NULL, NULL, 'H', 'H', '1715-06-12', 'Texel', '1715-12-16', '1716-01-15', true, '1716-04-14', 'Batavia', 6366, 'Among the passengers was a woman who had signed on as a seafarer. At Sao Tome on 11-09-1715. 1 seafarer ran away.');
INSERT INTO "voyages" VALUES (2252, '', 1, '', 'SPIERING', 'Jan Huigen', 810, NULL, '1714', NULL, NULL, 'D', 'D', '1715-09-29', 'Goeree', '1716-03-14', '1716-04-12', true, '1716-06-21', 'Batavia', 6395, NULL);
INSERT INTO "voyages" VALUES (2253, '', 1, '', 'TER NISSE', 'Gerrit Stokke', 810, NULL, '1714', NULL, NULL, 'Z', 'Z', '1715-11-08', 'Wielingen', '1716-03-09', '1716-03-25', true, '1716-05-30', 'Batavia', 6444, NULL);
INSERT INTO "voyages" VALUES (2254, '', 4, '', 'BENTVELD', 'Matthijs Want', 938, NULL, '1708', NULL, NULL, 'A', 'A', '1715-11-24', 'Texel', '1716-03-07', '1716-03-25', true, '1716-06-21', 'Batavia', 6394, NULL);
INSERT INTO "voyages" VALUES (2255, '', 1, '', 'GROENSWAART', 'Jakob Bogaard', 600, 'fluit', '1714', NULL, NULL, 'R', 'R', '1715-11-24', 'Goeree', '1716-04-07', '1716-04-26', true, '1716-07-06', 'Batavia', 6365, NULL);
INSERT INTO "voyages" VALUES (2256, '', 2, '', 'ZUIDERBEEK', 'David Brouwer', 812, NULL, '1711', NULL, NULL, 'Z', 'A', '1715-11-24', 'Texel', '1716-03-09', '1716-03-25', true, '1716-05-30', 'Batavia', 6375, NULL);
INSERT INTO "voyages" VALUES (2257, '', 1, '', 'ELISABETH', 'Kornelis de Geus', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1715-12-02', 'Texel', '1716-03-19', '1716-04-14', true, '1716-06-24', 'Batavia', 6368, NULL);
INSERT INTO "voyages" VALUES (2258, '', 5, '', 'SCHELLENBERG', 'Jan Linthout', 630, 'fluit', '1705', NULL, NULL, 'A', 'Z', '1715-12-24', 'Rammekens', '1716-04-08', '1716-04-26', true, '1716-07-07', 'Batavia', 6426, NULL);
INSERT INTO "voyages" VALUES (2259, '', 2, '', 'SCHOTEROOG', 'Jan Koster', 360, 'fregat', '1712', NULL, NULL, 'A', 'D', '1716-03-22', 'Goeree', '1716-06-08', '1716-06-26', true, '1716-08-14', 'Batavia', 6446, NULL);
INSERT INTO "voyages" VALUES (2260, '', 3, '', 'BERBICES', 'Adriaan Bogaard', 1136, NULL, '1709', NULL, NULL, 'Z', 'A', '1716-03-25', 'Texel', '1716-07-16', '1716-08-05', true, '1716-10-02', 'Batavia', 6377, NULL);
INSERT INTO "voyages" VALUES (2261, '', 5, '', 'BEVERWIJK', 'Hendrik Jurriaansz. Ben', 836, NULL, '1700', NULL, NULL, 'A', 'H', '1716-03-25', 'Texel', '1716-07-30', '1716-08-20', true, '1716-10-21', 'Batavia', NULL, 'Laid up at Batavia in 1722.');
INSERT INTO "voyages" VALUES (2262, '', 3, '', 'RAADHUIS VAN ENKHUIZEN', 'Simon Rijksen', 578, 'fluit', '1709', NULL, NULL, 'E', 'E', '1716-03-25', 'Texel', '1716-08-03', '1716-08-27', true, '1716-10-26', 'Batavia', 6417, 'At S. Tiago from 15-05 till 18-05-1716.');
INSERT INTO "voyages" VALUES (2263, '', 2, '', 'TER HORST', 'Jakob Brouwer', 520, 'fluit', '1713', NULL, NULL, 'D', 'R', '1716-03-25', 'Goeree', '1716-07-03', '1716-08-02', true, '1716-10-10', 'Batavia', 6430, NULL);
INSERT INTO "voyages" VALUES (2264, '', 1, '', 'RAADHUIS VAN VLISSINGEN', 'Daniel Keskes', 600, 'fluit', '1714', NULL, NULL, 'Z', 'Z', '1716-03-25', 'Rammekens', '1716-07-31', '1716-09-07', true, '1716-11-12', 'Batavia', 6380, NULL);
INSERT INTO "voyages" VALUES (2265, '', 6, '', 'WESTHOVEN', 'Charles Duurkoop', 776, NULL, '1698', NULL, NULL, 'Z', 'Z', '1716-03-25', 'Rammekens', NULL, NULL, false, '1716-09-21', 'Batavia', 6382, NULL);
INSERT INTO "voyages" VALUES (2266, '', 4, '', 'ZANDENBURG', 'Jakob Wijdeman', 1136, NULL, '1706', NULL, NULL, 'Z', 'Z', '1716-04-05', 'Rammekens', '1716-07-05', '1716-08-05', true, '1716-10-26', 'Batavia', 6383, NULL);
INSERT INTO "voyages" VALUES (2267, '', 5, '', 'BARNEVELD', 'Hendrik Schalkenius', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1716-04-10', 'Texel', '1716-07-28', '1716-08-20', true, '1716-11-16', 'Batavia', 6376, NULL);
INSERT INTO "voyages" VALUES (2268, '', 1, '', 'BOEKENRODE', 'Lambert Both', 890, NULL, '1714', NULL, NULL, 'A', 'A', '1716-04-10', 'Texel', '1716-07-06', '1716-08-02', true, '1716-09-25', 'Ceylon', 6384, NULL);
INSERT INTO "voyages" VALUES (2269, '', 2, '', 'DOORNIK', 'Abraham Kracht', 830, NULL, '1709', NULL, NULL, 'A', 'A', '1716-04-10', 'Texel', '1716-08-01', '1716-08-27', true, '1716-10-23', 'Batavia', 6435, NULL);
INSERT INTO "voyages" VALUES (2270, '', 7, '', 'GENERALE VREDE', 'Willem de Leus', 1008, 'pinas', '1699', NULL, NULL, 'A', 'A', '1716-04-10', 'Texel', '1716-07-28', '1716-08-21', true, '1716-10-30', 'Batavia', 6381, NULL);
INSERT INTO "voyages" VALUES (2271, '', 7, '', 'HORSTENDAAL', 'Jan van Hessel', 688, 'pinas', '1699', NULL, NULL, 'A', 'D', '1716-05-04', 'Goeree', '1716-08-30', '1716-09-22', true, '1716-12-06', 'Batavia', NULL, 'The ship was laid up at Batavia in 1723.');
INSERT INTO "voyages" VALUES (2272, '', 3, '', 'RUNESTEIN', 'Nikolaas van der Hoeven', 608, 'fluit', '1709', NULL, NULL, 'A', 'R', '1716-05-07', 'Goeree', '1716-10-14', '1716-10-20', true, '1717-02-19', 'Batavia', 6439, 'Among the passengers was one stowaway. At Porto Prayo from 27-06 till 03-07-1716.');
INSERT INTO "voyages" VALUES (2273, '', 3, '', 'HERSTELDE LEEUW', 'Jakob Wijsvliet', 1138, NULL, '1704', NULL, NULL, 'Z', 'Z', '1716-05-16', 'Rammekens', '1716-09-12', '1716-10-11', true, '1717-01-10', 'Batavia', 6397, 'Among the passengers was one stowaway.');
INSERT INTO "voyages" VALUES (2274, '', 1, '', 'HOPVOGEL', 'Albert van Soest', 600, 'fluit', '1714', NULL, NULL, 'A', 'A', '1716-06-03', 'Texel', '1716-12-18', '1717-01-09', true, '1717-04-11', 'Batavia', 6458, 'The passenger was a stowaway. From 25-07 till 02-08-1716 at S. Tiago and from 11-09 till 18-09-1716 at Annabon.');
INSERT INTO "voyages" VALUES (2275, '', 1, '', 'LUCHTENBURG', 'Hidding Idesz. Nooy', 800, NULL, '1715', NULL, NULL, 'H', 'H', '1716-06-03', 'Texel', '1716-10-25', '1716-11-28', true, '1717-04-12', 'Batavia', 6415, 'From 25-07 till 02-08-1716 at S. Tiago.');
INSERT INTO "voyages" VALUES (2276, '', 1, '', 'MARGARETA', 'Siewert Pool', 600, 'fluit', '1715', NULL, NULL, 'E', 'E', '1716-06-03', 'Texel', '1716-10-25', '1716-11-28', true, '1717-03-07', 'Batavia', 6450, NULL);
INSERT INTO "voyages" VALUES (2277, '', 1, '', 'MEERHUIZEN', 'Wouter van Dijk', 600, 'fluit', '1714', NULL, NULL, 'A', 'A', '1716-06-03', 'Texel', '1716-11-04', '1716-11-28', true, '1717-02-06', 'Batavia', 6392, 'From 25-07 till 02-08-1716 at S. Tiago.');
INSERT INTO "voyages" VALUES (2278, '', 4, '', 'LIMBURG', 'Reinier Hijpe', 810, NULL, '1704', NULL, NULL, 'A', 'Z', '1716-06-27', 'Rammekens', '1716-11-04', '1716-11-28', true, '1717-04-12', 'Batavia', NULL, 'in 1725.');
INSERT INTO "voyages" VALUES (2279, '', 4, '', 'KORSSLOOT', 'Tijmen Potter', 630, 'fluit', '1705', NULL, NULL, 'E', 'E', '1716-07-01', 'Texel', '1716-12-23', '1717-01-24', true, '1717-04-20', 'Batavia', NULL, 'At the Shetlands from 14-07 till 29-07-1716. Laid up at Batavia on 31-03-1722.');
INSERT INTO "voyages" VALUES (2280, '', 3, '', 'NOORDBEEK', 'Jakob Verzijde', 858, NULL, '1707', NULL, NULL, 'Z', 'A', '1716-07-01', 'Texel', '1716-12-23', '1717-01-24', true, '1717-04-14', 'Batavia', 6416, 'At Annabon from 15-10 till 22-10-1716.');
INSERT INTO "voyages" VALUES (2281, '', 3, '', 'HARINGTUIN', 'Aarnoud van Kleef', 618, 'fluit', '1705', NULL, NULL, 'E', 'D', '1716-10-13', 'Goeree', '1717-03-17', '1717-04-23', true, '1717-07-12', 'Batavia', 6423, 'At Portsmouth from 23-10 till 09-11-1716.');
INSERT INTO "voyages" VALUES (2282, '', 1, '', 'GEEN RUST', 'Dirk Renvoort', 150, 'galjoot', '1716', NULL, NULL, 'A', 'A', '1716-10-16', 'Texel', '1717-05-08', NULL, true, NULL, NULL, NULL, 'On 03-10-1717 burnt at the Cape.');
INSERT INTO "voyages" VALUES (2283, '', 1, '', 'BORSSELE', 'Frans de Brooi', 800, NULL, '1715', NULL, NULL, 'Z', 'Z', '1716-10-27', 'Rammekens', '1717-04-22', '1717-05-18', true, '1717-07-17', 'Batavia', 6428, 'At Sao Tome from 18-02 till 26-02-1717. Three seafarers and soldiers ran away.');
INSERT INTO "voyages" VALUES (2284, '', 3, '', 'HUIS TER LEEDS', 'Jakob de Bie', 300, NULL, '1710', NULL, NULL, 'A', 'Z', '1716-10-27', 'Rammekens', '1717-06-08', '1717-06-30', true, '1717-09-09', 'Batavia', NULL, 'From 12-03 till 23-03-1717 at Sao Tome, where 2 seafarers ran away; from 04-06 till 05-06-1717 at Robben Island. Laid up at Batavia in 1724.');
INSERT INTO "voyages" VALUES (2285, '', 5, '', 'GANSENHOEF', 'Theunis de Haan', 640, 'fluit', '1702', NULL, NULL, 'A', 'A', '1716-11-08', 'Texel', '1717-03-29', '1717-05-22', true, '1717-08-14', 'Ceylon', 6412, NULL);
INSERT INTO "voyages" VALUES (2286, '', 2, '', 'LINSCHOTEN', 'Hayman de Laver', 804, NULL, '1714', NULL, NULL, 'A', 'A', '1716-11-08', 'Texel', '1717-03-14', '1717-04-23', true, '1717-07-08', 'Batavia', 6429, NULL);
INSERT INTO "voyages" VALUES (2287, '', 4, '', 'WASSENAAR', 'Andries Pijl', 804, NULL, '1704', NULL, NULL, 'D', 'A', '1716-11-08', 'Texel', '1717-03-21', '1717-04-23', true, '1717-07-03', 'Batavia', 6414, NULL);
INSERT INTO "voyages" VALUES (2288, '', 1, '', 'HOGERMEER', 'Jan Klooster', 470, 'fluit', NULL, '1716', NULL, 'A', 'A', '1716-11-18', 'Texel', '1717-05-09', '1717-08-06', true, '1717-10-25', 'Batavia', 6404, NULL);
INSERT INTO "voyages" VALUES (2289, '', 1, '', 'VELSERHOOFD', 'Thieleman Sterling', 650, 'fluit', '1716', NULL, NULL, 'A', 'A', '1716-11-18', 'Texel', '1717-05-13', '1717-08-07', true, '1717-10-22', 'Batavia', NULL, 'The ship was laid up at Batavia in 1730.');
INSERT INTO "voyages" VALUES (2290, '', 4, '', 'BRUG', 'Pieter de Boer', 600, 'fluit', '1708', NULL, NULL, 'E', 'E', '1716-12-20', 'Texel', '1717-03-31', '1717-04-23', true, '1717-07-14', 'Batavia', NULL, 'Wrecked on the river Ganges in 1718.');
INSERT INTO "voyages" VALUES (2291, '', 5, '', 'ENGEWORMER', 'Herman Branus', 560, 'fluit', '1707', NULL, NULL, 'A', 'H', '1716-12-20', 'Texel', '1717-04-01', '1717-04-23', true, '1717-07-06', 'Batavia', NULL, 'Laid up at Batavia in 1724.');
INSERT INTO "voyages" VALUES (2292, '', 1, '', 'ROTTERDAM', 'Hendrik Lont', 800, NULL, '1716', NULL, NULL, 'R', 'R', '1716-12-29', 'Goeree', '1717-05-15', '1717-06-06', true, '1717-09-14', 'Batavia', 6402, 'Duins from 02-01 till 10-01-1717.');
INSERT INTO "voyages" VALUES (2293, '', 4, '', 'VOORBURG', 'Gerrit Bokshoorn', 600, NULL, '1710', NULL, NULL, 'D', 'D', '1717-01-17', 'Goeree', '1717-06-29', '1717-08-11', true, '1717-10-14', 'Batavia', 6407, NULL);
INSERT INTO "voyages" VALUES (2294, '', 2, '', 'HUIS TEN DONK', 'Nikolaas Boom', 650, NULL, '1711', NULL, NULL, 'R', 'A', '1717-01-19', 'Texel', '1717-06-18', '1717-07-30', true, '1717-10-14', 'Batavia', 6403, NULL);
INSERT INTO "voyages" VALUES (2295, '', 2, '', 'LOOSDRECHT', 'Jochem Pijselman', 805, NULL, '1714', NULL, NULL, 'A', 'A', '1717-01-19', 'Texel', '1717-06-20', '1717-08-11', true, '1717-10-27', 'Ceylon', 6413, NULL);
INSERT INTO "voyages" VALUES (2296, '', 4, '', 'MIJNDEN', 'Wessel Hoogwerf', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1717-01-19', 'Texel', '1717-06-04', '1717-06-30', true, '1717-10-12', 'Batavia', 6406, 'At S. Tiago from 26-04 till 28-04-1717.');
INSERT INTO "voyages" VALUES (2297, '', 2, '', 'WESTERDIJKSHORN', 'Jan Baai', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1717-01-19', 'Texel', '1717-06-08', '1717-06-30', true, '1717-09-29', 'Batavia', 6408, 'Among the passengers was one stowaway. From 24-03 till 28-03-1717 at S. Tiago.');
INSERT INTO "voyages" VALUES (2298, '', 4, '', 'BELVLIET', 'Kornelis Centsen', 586, 'fluit', '1704', NULL, NULL, 'E', 'Z', '1717-01-28', 'Wielingen', '1717-05-15', '1717-06-06', true, '1717-09-24', 'Batavia', NULL, 'Laid up at Batavia in 1729.');
INSERT INTO "voyages" VALUES (2299, '', 2, '', 'MEIJENBURG', 'Pieter van Dalen', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1717-01-28', 'Wielingen', '1717-05-08', '1717-06-10', true, '1717-08-06', 'Batavia', 6398, NULL);
INSERT INTO "voyages" VALUES (2300, '', 3, '', 'RIJSSEL', 'Jakob Delincourt', 858, NULL, '1709', NULL, NULL, 'Z', 'Z', '1717-01-28', 'Wielingen', '1717-05-09', '1717-05-29', true, '1717-08-30', 'Batavia', 6401, NULL);
INSERT INTO "voyages" VALUES (2301, '', 1, '', 'CATS', 'Hugo van der Slikke', 580, NULL, '1716', NULL, NULL, 'Z', 'Z', '1717-02-19', 'Rammekens', '1717-06-20', '1717-07-30', true, '1717-10-09', 'Batavia', 6396, 'passenger was a woman who came aboard as a soldier.');
INSERT INTO "voyages" VALUES (2302, '', 3, '', 'RAADHUIS VAN MIDDELBURG', 'Pieter Buis', 890, NULL, '1708', NULL, NULL, 'Z', 'Z', '1717-03-09', 'Wielingen', '1717-06-17', '1717-07-30', true, '1717-09-30', 'Batavia', 6424, NULL);
INSERT INTO "voyages" VALUES (2303, '', 2, '', 'CHARLOIS', 'Arend Rectog', 632, 'fluit', '1709', NULL, NULL, 'R', 'A', '1717-04-25', 'Hellevoetsluis', '1717-08-24', '1717-09-18', true, '1717-12-31', 'Batavia', 6449, NULL);
INSERT INTO "voyages" VALUES (2304, '', 4, '', 'SAMSON', 'Jan Kopersluis', 800, NULL, '1707', NULL, NULL, 'A', 'D', '1717-04-25', 'Goeree', '1717-08-21', '1717-09-25', true, '1717-12-14', 'Batavia', 6451, NULL);
INSERT INTO "voyages" VALUES (2305, '', 4, '', 'VADERLAND GETROUW', 'Willem de Vries', 848, NULL, '1705', NULL, NULL, 'Z', 'Z', '1717-05-15', 'Wielingen', '1717-10-01', '1717-11-27', true, '1718-03-13', 'Ceylon', 6418, NULL);
INSERT INTO "voyages" VALUES (2306, '', 1, '', 'JOHANNA', 'Jan Melcherse', 550, 'fluit', '1714', NULL, NULL, 'A', 'A', '1717-05-18', 'Texel', '1717-11-10', '1718-01-03', true, '1718-04-22', 'Batavia', 6441, 'One seafarer came from the MEEROOG (2307).');
INSERT INTO "voyages" VALUES (2307, '', 1, '', 'MEEROOG', 'Pieter van Leent', 800, NULL, '1715', NULL, NULL, 'A', 'A', '1717-05-18', 'Texel', '1717-11-09', '1718-01-03', true, '1718-04-14', 'Batavia', NULL, 'The ship was wrecked on a voyage to Japan on 04-08-1719.');
INSERT INTO "voyages" VALUES (2308, '', 4, '', 'NOORDERKWARTIER', 'Arend Dirksz. Bent', 550, 'fluit', '1709', NULL, NULL, 'H', 'H', '1717-05-18', 'Texel', '1717-10-03', '1717-10-26', true, '1718-01-11', 'Batavia', 6445, NULL);
INSERT INTO "voyages" VALUES (2309, '', 4, '', 'OUWERKERK', 'Jakob Visser', 658, 'fluit', '1706', NULL, NULL, 'A', 'E', '1717-05-18', 'Texel', '1717-09-21', '1717-10-26', true, '1718-01-02', 'Batavia', 6438, NULL);
INSERT INTO "voyages" VALUES (2310, '', 1, '', 'PRATTENBURG', 'Kornelis Dobbel', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1717-05-18', 'Texel', '1717-08-24', '1717-09-12', true, '1717-12-29', 'Batavia', 6425, NULL);
INSERT INTO "voyages" VALUES (2311, '', 1, '', 'VIS', 'Tijmen Zwaag', 600, 'fluit', '1716', NULL, NULL, 'E', 'E', '1717-05-18', 'Texel', '1717-09-10', '1717-10-07', true, '1717-12-22', 'Batavia', 6473, NULL);
INSERT INTO "voyages" VALUES (2312, '', 1, '', 'VRIESWIJK', 'Jan Jurriaansz. Ben', 850, NULL, '1716', NULL, NULL, 'H', 'H', '1717-05-18', 'Texel', '1717-09-04', '1717-10-05', true, '1718-05-27', 'Batavia', 6453, 'From 19-02-1718 till 02-05-1718 at Timor.');
INSERT INTO "voyages" VALUES (2313, '', 4, '', 'PRINS EUGENIUS', 'Lukas Schrik', 874, NULL, '1703', NULL, NULL, 'A', 'A', '1717-05-21', 'Texel', '1717-09-04', '1717-10-05', true, '1717-12-31', 'Batavia', NULL, 'Laid up at Batavia in 1727.');
INSERT INTO "voyages" VALUES (2314, '', 4, '', 'NEPTUNUS', 'Jan Ringelenberg', 858, NULL, '1704', NULL, NULL, 'A', 'R', '1717-05-21', 'Goeree', '1717-10-30', '1717-12-13', true, '1718-03-08', 'Batavia', 6461, NULL);
INSERT INTO "voyages" VALUES (2315, '', 2, '', 'ZANDERHOEF', 'Gerrit Staal', 608, 'fluit', '1711', NULL, NULL, 'A', 'A', '1717-05-21', 'Texel', '1717-10-02', '1717-10-29', true, '1718-01-26', 'Batavia', NULL, 'Laid up at Batavia in 1724.');
INSERT INTO "voyages" VALUES (2316, '', 3, '', 'OUDENAARDE', 'Bontekoe', 858, NULL, '1708', NULL, NULL, 'A', 'A', '1717-06-22', 'Texel', '1717-11-07', '1717-12-02', true, '1718-02-09', 'Batavia', 6432, NULL);
INSERT INTO "voyages" VALUES (2317, '', 3, '', 'WIJNENDAAL', 'Jan Laurens de Hoge', 804, 'jacht', '1709', NULL, NULL, 'D', 'A', '1717-06-22', 'Texel', '1717-11-09', '1717-12-02', true, '1718-02-09', 'Batavia', 6447, NULL);
INSERT INTO "voyages" VALUES (2318, '', 1, '', 'AMSTERDAM', 'David Brouwer', 800, NULL, '1716', NULL, NULL, 'A', 'A', '1717-10-10', 'Texel', '1718-02-27', '1718-03-19', true, '1718-06-29', 'Batavia', 6448, NULL);
INSERT INTO "voyages" VALUES (2319, '', 3, '', 'KIJKUIT', 'Simon Jansen', 200, 'fregat', '1709', NULL, NULL, 'A', 'A', '1717-10-10', 'Texel', '1718-02-07', '1718-03-06', true, '1718-05-28', 'Batavia', NULL, '1724.');
INSERT INTO "voyages" VALUES (2320, '', 1, '', 'WENDELA', 'Arend Etman', 600, NULL, '1716', NULL, NULL, 'A', 'A', '1717-10-10', 'Texel', '1718-05-19', '1718-06-10', true, '1718-08-23', 'Batavia', 6464, 'Cape Lopez, and from 18-02 till 26-02-1718 at Sao Tome.');
INSERT INTO "voyages" VALUES (2321, '', 2, '', 'BOEKENRODE', 'Jan Vorster', 890, NULL, '1714', NULL, NULL, 'A', 'A', '1717-10-26', 'Texel', '1718-04-27', '1718-05-18', true, '1718-07-30', 'Batavia', 6421, '03-11 till 14-01-1718 at Portsmouth.');
INSERT INTO "voyages" VALUES (2322, '', 1, '', 'DEN DAM', 'Jan Verschouw', 600, 'fluit', '1716', NULL, NULL, 'D', 'D', '1717-10-26', 'Goeree', '1718-03-23', '1718-04-23', true, '1718-06-29', 'Batavia', 6467, 'child was born during the voyage.');
INSERT INTO "voyages" VALUES (2323, '', 2, '', 'NESSERAK', 'Jan Cats', 804, NULL, '1712', NULL, NULL, 'A', 'A', '1717-10-26', 'Texel', '1718-05-01', '1718-05-23', true, '1718-08-18', 'Batavia', 6494, 'at S. Tiago from 20-12 till 26-12-1717.');
INSERT INTO "voyages" VALUES (2324, '', 4, '', 'STANDVASTIGHEID', 'Gerrit Moring', 888, NULL, '1706', NULL, NULL, 'A', 'A', '1717-10-26', 'Texel', '1718-03-23', '1718-04-13', true, '1718-06-27', 'Batavia', 6427, 'Two soldiers were enlisted as seafarers.');
INSERT INTO "voyages" VALUES (2325, '', 1, '', 'VALKENISSE', 'Herman Grindet', 1150, NULL, '1716', NULL, NULL, 'Z', 'Z', '1717-11-07', 'Rammekens', '1718-04-24', '1718-05-18', true, '1718-07-28', 'Batavia', 6433, 'and Torbay.');
INSERT INTO "voyages" VALUES (2326, '', 2, '', 'RAADHUIS VAN VLISSINGEN', 'Pieter van Genechten', 600, 'fluit', '1714', NULL, NULL, 'Z', 'Z', '1717-11-07', 'Rammekens', '1718-04-27', '1718-05-18', true, '1718-07-23', 'Batavia', 6472, 'At the English coast from 11-11-1717 till 16-01-1718 (Portsmouth, Torbay and Falmouth).');
INSERT INTO "voyages" VALUES (2327, '', 2, '', 'GROENSWAART', 'Klaas van Eik', 600, 'fluit', '1714', NULL, NULL, 'R', 'A', '1718-01-02', 'Goeree', '1718-05-19', '1718-06-10', true, '1718-08-23', 'Batavia', 6440, 'Torbay.');
INSERT INTO "voyages" VALUES (2328, '', 2, '', 'SLEEWIJK', 'Gerrit Schot', 520, 'jacht', '1713', NULL, NULL, 'R', 'R', '1718-01-02', 'Goeree', '1718-09-04', '1718-10-17', true, '1718-12-29', 'Batavia', 6497, 'Due to a storm at Gluckstad on 16-01-1718.');
INSERT INTO "voyages" VALUES (2329, '', 7, '', 'WESTHOVEN', 'Arie ''t Hoff', 776, NULL, '1698', NULL, NULL, 'Z', 'D', '1718-01-02', 'Goeree', '1718-04-27', '1718-05-18', true, '1718-07-30', 'Batavia', NULL, 'Laid up at Batavia in 1724.');
INSERT INTO "voyages" VALUES (2330, '', 6, '', 'ABBEKERK', 'Abraham Ram', 600, 'fluit', '1698', NULL, NULL, 'H', 'H', '1718-01-23', 'Texel', '1718-05-19', '1718-08-21', true, '1718-11-13', 'Batavia', NULL, 'Laid up at Batavia in 1727.');
INSERT INTO "voyages" VALUES (2331, '', 2, '', 'ELISABETH', 'Jakob Onkruid', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1718-01-23', 'Texel', '1718-04-26', '1718-05-18', true, '1718-07-13', 'Batavia', 6422, NULL);
INSERT INTO "voyages" VALUES (2332, '', 2, '', 'MIDDELWOUD', 'Willem de Leus', 804, NULL, '1713', NULL, NULL, 'Z', 'A', '1718-01-23', 'Texel', '1718-04-29', '1718-05-29', true, '1718-08-15', 'Ceylon', 6437, NULL);
INSERT INTO "voyages" VALUES (2333, '', 4, '', 'MOSSEL', 'Michiel de Reus', 676, 'fluit', '1706', NULL, NULL, 'E', 'E', '1718-01-23', 'Texel', '1718-05-26', '1718-06-21', true, '1718-09-13', 'Batavia', NULL, 'Laid up at Batavia in 1724.');
INSERT INTO "voyages" VALUES (2334, '', 2, '', 'HUIS DE VLOTTER', 'Daniel van Staden', 528, 'fluit', '1713', NULL, NULL, 'A', 'H', '1718-01-23', 'Texel', '1718-05-20', '1718-07-07', true, '1718-09-18', 'Batavia', 6434, NULL);
INSERT INTO "voyages" VALUES (2335, '', 8, '', 'GENERALE VREDE', 'Jakob Regenboog', 1008, 'pinas', '1699', NULL, NULL, 'A', 'A', '1718-01-23', 'Texel', '1718-05-06', '1718-06-03', true, '1718-08-23', 'Batavia', NULL, 'Laid up at Batavia on 25-09-1722.');
INSERT INTO "voyages" VALUES (2336, '', 4, '', 'BERBICES', 'Reinier Hijpe', 1136, NULL, '1709', NULL, NULL, 'Z', 'Z', '1718-01-27', 'Rammekens', '1718-04-24', '1718-05-18', true, '1718-07-28', 'Batavia', 6419, NULL);
INSERT INTO "voyages" VALUES (2337, '', 1, '', 'HOGENES', 'Adriaan Tessing', 870, NULL, '1716', NULL, NULL, 'Z', 'Z', '1718-01-27', 'Rammekens', '1718-04-24', '1718-05-04', true, '1718-07-13', 'Batavia', 6468, NULL);
INSERT INTO "voyages" VALUES (2338, '', 3, '', 'KOCKENGEN', 'Matthijs Burger', 824, NULL, '1711', NULL, NULL, 'A', 'Z', '1718-01-27', 'Rammekens', '1718-04-30', '1718-05-18', true, '1718-07-30', 'Batavia', 6431, NULL);
INSERT INTO "voyages" VALUES (2339, '', 5, '', 'KIEFHOEK', 'Jakob Bogaard', 832, NULL, '1701', NULL, NULL, 'R', 'R', '1718-03-21', 'Goeree', '1718-07-07', '1718-08-04', true, '1718-10-01', 'Batavia', 6442, 'The ship departed for the first time on 16-01-1718, but returned to Goeree.');
INSERT INTO "voyages" VALUES (2340, '', 3, '', 'ZUIDERBEEK', 'Jan Linthout', 812, NULL, '1711', NULL, NULL, 'Z', 'Z', '1718-04-08', 'Rammekens', '1718-08-28', '1718-09-19', true, '1718-11-18', 'Batavia', NULL, 'Torbay. Laid up at Batavia in 1730.');
INSERT INTO "voyages" VALUES (2341, '', 1, '', 'ANNA MARIA', 'Kornelis Fret', 600, NULL, '1717', NULL, NULL, 'Z', 'Z', '1718-04-20', 'Rammekens', '1718-09-10', '1718-10-09', true, '1718-12-29', 'Batavia', 6540, NULL);
INSERT INTO "voyages" VALUES (2342, '', 2, '', 'WITSBURG', 'Jan Defen', 520, 'fluit', '1714', NULL, NULL, 'E', 'A', '1718-04-25', 'Texel', '1718-09-08', '1718-10-28', true, '1719-02-04', 'Batavia', 6574, NULL);
INSERT INTO "voyages" VALUES (2343, '', 4, '', 'ARENDSDUIN', 'Theunis van der Storm', 580, 'jacht', '1708', NULL, NULL, 'D', 'D', '1718-04-28', 'Goeree', '1718-08-15', '1718-09-09', true, '1718-10-10', 'Batavia', 6455, NULL);
INSERT INTO "voyages" VALUES (2344, '', 1, '', 'GEERTRUID', 'Pieter Siebens', 600, 'fluit', '1717', NULL, NULL, 'E', 'E', '1718-05-03', 'Texel', '1718-10-06', '1718-11-14', true, '1719-02-04', 'Batavia', 6526, NULL);
INSERT INTO "voyages" VALUES (2345, '', 1, '', 'HUIS TE FOREEST', 'Pieter Jakobsz. Rus', 600, 'fluit', '1717', NULL, NULL, 'H', 'H', '1718-05-03', 'Texel', '1718-09-10', '1718-10-09', true, '1718-12-30', 'Batavia', 6522, NULL);
INSERT INTO "voyages" VALUES (2346, '', 1, '', 'SLOT VAN KAPELLE', 'Pieter van Heel', 600, NULL, '1717', NULL, NULL, 'R', 'R', '1718-05-03', 'Goeree', '1718-08-31', '1718-09-19', true, '1718-11-24', 'Batavia', NULL, 'The ship was lost on a voyage to Japan in 1719.');
INSERT INTO "voyages" VALUES (2347, '', 2, '', 'STRUKEBOLLE', 'Jakob Blauw', 540, 'fluit', '1712', NULL, NULL, 'E', 'Z', '1718-05-03', 'Rammekens', '1718-08-24', '1718-09-19', true, '1718-11-26', 'Batavia', 6452, NULL);
INSERT INTO "voyages" VALUES (2348, '', 2, '', 'MEERHUIZEN', 'Frank Versijde', 600, 'fluit', '1714', NULL, NULL, 'A', 'A', '1718-05-04', 'Texel', '1718-08-30', '1718-09-19', true, '1718-11-20', 'Batavia', 6443, NULL);
INSERT INTO "voyages" VALUES (2349, '', 1, '', 'CATHARINA', 'Lambert Bot', 800, NULL, '1717', NULL, NULL, 'A', 'A', '1718-05-05', 'Texel', '1718-08-24', '1718-09-19', true, '1718-11-28', 'Batavia', NULL, 'The ship was lost on a voyage to Japan on 14-08-1719.');
INSERT INTO "voyages" VALUES (2350, '', 1, '', 'HAFTEN', NULL, 600, 'fluit', '1717', NULL, NULL, 'A', 'A', '1718-05-07', 'Texel', '1718-09-07', '1718-10-09', true, '1719-01-02', 'Batavia', 6554, NULL);
INSERT INTO "voyages" VALUES (2351, '', 5, '', 'KONING KAREL DE DERDE', 'Wouter van Dijk', 830, NULL, '1704', NULL, NULL, 'A', 'A', '1718-05-07', 'Texel', '1718-08-24', '1718-09-19', true, '1718-11-19', 'Batavia', 6459, NULL);
INSERT INTO "voyages" VALUES (2352, '', 2, '', 'D''UNO', 'Pieter de Vlaming', 250, 'fregat', '1707', NULL, NULL, 'Z', 'A', '1718-05-13', 'Texel', '1718-10-14', '1718-12-18', true, '1719-02-28', 'Batavia', 6462, 'The ship was taken by two pirates on 07-07-1718, but was apparently released.');
INSERT INTO "voyages" VALUES (2353, '', 5, '', 'ZANDENBURG', 'Charles Duurkoop', 1136, NULL, '1706', NULL, NULL, 'Z', 'Z', '1718-06-08', 'Rammekens', '1718-11-07', '1718-12-18', true, '1719-02-28', 'Batavia', 6466, NULL);
INSERT INTO "voyages" VALUES (2354, '', 1, '', 'DELFLAND', 'Philip van den Broek', 600, 'fluit', '1717', NULL, NULL, 'D', 'D', '1718-09-21', 'Goeree', '1719-01-17', '1719-02-18', true, '1719-05-15', 'Batavia', 6525, NULL);
INSERT INTO "voyages" VALUES (2355, '', 1, '', 'AMSTELVEEN', 'Theunis de Haan', 1150, NULL, '1717', NULL, NULL, 'A', 'A', '1718-11-16', 'Texel', '1719-04-29', '1719-06-01', true, '1719-07-31', 'Batavia', 6454, 'From 28-11 till 24-12-1718 at Torbay.');
INSERT INTO "voyages" VALUES (2356, '', 6, '', 'GANSENHOEF', 'Jakob van Luipen', 640, 'fluit', '1702', NULL, NULL, 'A', 'A', '1718-11-16', 'Texel', '1719-05-01', '1719-05-20', true, '1719-07-29', 'Batavia', 6457, 'From 25-11 till 24-12-1718 at Torbay.');
INSERT INTO "voyages" VALUES (2357, '', 2, '', 'RISDAM', 'Kornelis Dam', 520, 'fluit', '1713', NULL, NULL, 'H', 'A', '1718-11-16', 'Texel', '1719-04-29', '1719-06-16', true, '1719-08-31', 'Batavia', NULL, '25-11 till 24-12-1718 at Torbay. One child was born. The RISDAM sank on a voyage from Siam to Batavia in 1726. Wreck discovered.');
INSERT INTO "voyages" VALUES (2358, '', 2, '', 'LUCHTENBURG', 'Gillis de Graaf', 800, NULL, '1715', NULL, NULL, 'H', 'R', '1718-12-28', 'Goeree', '1719-05-12', '1719-06-16', true, '1719-08-14', 'Batavia', 6482, 'The master Gillis de Graaf fell ill at the Cape; he was succeeded by Pieter van Duren.');
INSERT INTO "voyages" VALUES (2359, '', 2, '', 'ROTTERDAM', 'Jakob van der Poel', 800, NULL, '1716', NULL, NULL, 'R', 'D', '1718-12-28', 'Goeree', '1719-05-12', '1719-06-16', true, '1719-08-16', 'Batavia', 6484, NULL);
INSERT INTO "voyages" VALUES (2360, '', 2, '', 'SLOT ALDEGONDE', 'Jan Havelaar', 1160, 'jacht', '1714', NULL, NULL, 'Z', 'Z', '1718-12-31', 'Rammekens', '1719-07-02', '1719-08-09', true, '1719-10-21', 'Batavia', 6486, 'from 07-01 till 24/26-02-1719 at Portsmouth.');
INSERT INTO "voyages" VALUES (2361, '', 1, '', 'BARBESTEIN', 'Michiel Landsheer', 1100, NULL, '1717', NULL, NULL, 'Z', 'Z', '1718-12-31', 'Rammekens', '1719-07-02', '1719-08-25', true, '1719-10-21', 'Batavia', 6456, 'See 2360. 3 Seafarers were pressed by the English at Portsmouth.');
INSERT INTO "voyages" VALUES (2362, '', 2, '', 'CATS', 'Kornelis de Giers', 580, NULL, '1716', NULL, NULL, 'Z', 'Z', '1718-12-31', 'Rammekens', '1719-07-03', '1719-08-09', true, '1719-11-05', 'Batavia', 6551, 'See 2360.');
INSERT INTO "voyages" VALUES (2363, '', 3, '', 'MEIJENBURG', 'Jan de Heere', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1718-12-31', 'Rammekens', '1719-06-18', '1719-08-11', true, '1719-10-11', 'Batavia', 6460, 'See 2360.');
INSERT INTO "voyages" VALUES (2364, '', 2, '', 'ZEELANDIA', 'Christiaan Mark', 160, NULL, '1704', NULL, NULL, 'Z', 'Z', '1718-12-31', 'Rammekens', '1719-06-22', NULL, true, '1719-06-22', 'The Cape', NULL, 'Laid up at the Cape on 31-03-1730.');
INSERT INTO "voyages" VALUES (2365, '', 6, '', 'BARNEVELD', 'Jan de Koning', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1719-01-01', 'Texel', '1720-02-07', '1720-03-08', true, '1720-06-09', 'Batavia', 6487, '02-02-1720.');
INSERT INTO "voyages" VALUES (2366, '', 2, '', 'HOGEMEER', 'Jan Reebok', 470, 'fluit', '1716', NULL, NULL, 'A', 'A', '1719-01-01', 'Texel', NULL, NULL, false, '1719-09-24', 'Batavia', NULL, 'At Duins from 07-01 till 26-01-1719. One seafarer from the BARNEVELD (2365). At Portsmouth from 04-02 till 26-02-1719. 2 Seafarers ran away. At S. Tiago from 09-04 till 16-04-1719. Laid up at Batavia in 1727.');
INSERT INTO "voyages" VALUES (2367, '', 2, '', 'RIJKSDORP', 'Daniel Dirksz. Bent +', 792, NULL, '1713', NULL, NULL, 'A', 'H', '1719-01-01', 'Texel', '1719-09-07', '1719-10-22', true, '1720-03-19', 'Batavia', 6496, 'Hired: 46 English seafarers. At Margate from 22-01 till 05-02-1719. At London from 07-02 till 04-05-1719 for repair. On board from Holland: 82 seafarers, 70 soldiers and 1 craftsmen. After the death of the master, Maarten Crijnsen succeeded him at the Cape.');
INSERT INTO "voyages" VALUES (2368, '', 4, '', 'RIJSSEL', 'Kornelis de Lange +', 858, NULL, '1709', NULL, NULL, 'Z', 'E', '1719-01-01', 'Texel', NULL, NULL, false, '1720-01-08', 'Batavia', 6483, 'Padang from 20-11 till 05-12-1719. Daniel Silemans succeeded Kornelis de Lange who died there. On 31-12-1719, 20 seafarers and 25 soldiers went to the HERSTELDE LEEUW (2377).');
INSERT INTO "voyages" VALUES (2369, '', 2, '', 'SPIERING', 'Dirk Haan', 810, NULL, '1714', NULL, NULL, 'D', 'A', '1719-01-01', 'Texel', '1719-07-19', '1719-08-25', true, '1719-11-11', 'Batavia', 6471, 'At Duins from 07-01 till 26-01-1719. At Portsmouth from 04-02 till 26-02-1719. At S. Tiago from 09-04 till 16-04-1719.');
INSERT INTO "voyages" VALUES (2370, '', 3, '', 'WESTERDIJKSHORN', 'Matthijs Want', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1719-01-01', 'Texel', '1719-05-31', '1719-07-04', true, '1719-09-16', 'Batavia', 6465, 'At Duins from 07-01 till 26-01-1719. At Portsmouth from 04-02 till 26-02-1719.');
INSERT INTO "voyages" VALUES (2371, '', 3, '', 'HUIS TEN DONK', 'Hendrik Schoon', 650, NULL, '1711', NULL, NULL, 'R', 'A', '1719-01-14', 'Texel', '1719-06-07', '1719-07-04', true, '1719-10-12', 'Batavia', 6480, 'From 19-01 till 25-01-1719 at Romney.');
INSERT INTO "voyages" VALUES (2372, '', 3, '', 'LOOSDRECHT', 'Willem Dekker', 805, NULL, '1714', NULL, NULL, 'A', 'A', '1719-01-14', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'On 21-01-1719 run around at the island of Wight.');
INSERT INTO "voyages" VALUES (2373, '', 4, '', 'NOORDBEEK', 'Andries Pijl', 858, NULL, '1707', NULL, NULL, 'Z', 'A', '1719-02-10', 'Texel', '1719-06-12', '1719-08-09', true, '1719-10-12', 'Batavia', 6469, 'From 06-02 till 22-02-1719 at Plymouth; 5 seafarers deserted.');
INSERT INTO "voyages" VALUES (2374, '', 1, '', 'SCHONENBERG', 'Jan van der Linden +', 800, NULL, '1717', NULL, NULL, 'A', 'A', '1719-02-10', 'Texel', '1719-06-07', '1719-08-10', true, '1720-09-16', 'Ceylon', 6485, 'After departure from the Cape out of its course by storms, took refuge in the Red Sea, arrived finally at Mocha at the end of June 1720; the master and a few others were killed in Oba Bay, Ethiopia.');
INSERT INTO "voyages" VALUES (2375, '', 5, '', 'WASSENAAR', 'Alexander Ad. du Pon', 804, NULL, '1704', NULL, NULL, 'D', 'Z', '1719-02-25', 'Rammekens', '1719-06-23', '1719-08-11', true, '1719-10-26', 'Batavia', 6463, 'From 03-03 till 01-04-1719 at Portsmouth; 3 seafarers and 1 soldier ran away.');
INSERT INTO "voyages" VALUES (2376, '', 1, '', 'STADHUIS VAN DELFT', 'Michiel van Pavie', 600, 'fluit', '1718', NULL, NULL, 'D', 'D', '1719-05-04', 'Goeree', '1719-09-01', '1719-09-26', true, '1719-11-30', 'Batavia', 6501, NULL);
INSERT INTO "voyages" VALUES (2377, '', 4, '', 'HERSTELDE LEEUW', 'Balten Leesten', 1138, NULL, '1704', NULL, NULL, 'Z', 'Z', '1719-05-04', 'Rammekens', '1719-09-01', '1719-10-16', true, '1720-01-08', 'Batavia', 6481, 'From the RIJSSEL (2368) 20 seafarers and 25 soldiers went over on 31-12-1719.');
INSERT INTO "voyages" VALUES (2378, '', 3, '', 'NEDERHOVEN', 'Andries Walburg', 600, 'fluit', '1708', NULL, NULL, 'R', 'R', '1719-05-04', 'Goeree', '1719-09-07', '1719-10-16', true, '1720-01-10', 'Batavia', 6518, NULL);
INSERT INTO "voyages" VALUES (2379, '', 1, '', 'NOORDWADDINXVEEN', 'Hendrik Lont', 850, NULL, '1718', NULL, NULL, 'R', 'R', '1719-05-04', 'Goeree', '1719-09-01', '1719-09-26', true, '1719-12-23', 'Batavia', 6506, NULL);
INSERT INTO "voyages" VALUES (2380, '', 1, '', 'HOF NIET ALTIJD ZOMER', 'Joris Vermouwe', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1719-05-04', 'Rammekens', '1719-09-01', '1719-09-26', true, '1720-01-04', 'Ceylon', 6535, NULL);
INSERT INTO "voyages" VALUES (2381, '', 1, '', 'HAAKSBURG', 'Pieter Visser', 600, NULL, '1718', NULL, NULL, 'E', 'E', '1719-05-05', 'Texel', '1719-08-28', '1719-09-24', true, '1719-12-02', 'Batavia', 6507, NULL);
INSERT INTO "voyages" VALUES (2382, '', 3, '', 'LEIDSMAN', 'Dirk van Veen+', 320, 'fregat', '1710', NULL, NULL, 'A', 'A', '1719-05-05', 'Texel', '1719-07-29', '1719-08-28', true, '1719-12-01', 'Batavia', NULL, 'The master died; at the Cape Barend van der Sprong succeeded him. Laid up at Batavia in 1724.');
INSERT INTO "voyages" VALUES (2383, '', 1, '', 'OPPERDOES', 'Jan Ravenek', 600, 'fluit', '1718', NULL, NULL, 'H', 'H', '1719-05-05', 'Texel', '1719-08-13', '1719-09-13', true, '1719-12-04', 'Batavia', 6470, NULL);
INSERT INTO "voyages" VALUES (2384, '', 5, '', 'VOORBURG', 'Hendrik Kloek', 600, NULL, '1710', NULL, NULL, 'D', 'A', '1719-05-05', 'Texel', '1719-09-06', '1719-10-16', true, '1720-01-17', 'Batavia', 6537, NULL);
INSERT INTO "voyages" VALUES (2385, '', 1, '', 'KOMMERRUST', 'Koenraad Mels', 810, NULL, '1718', NULL, NULL, 'A', 'A', '1719-05-16', 'Texel', '1719-09-06', '1719-10-16', true, '1720-01-11', 'Batavia', 6504, NULL);
INSERT INTO "voyages" VALUES (2386, '', 1, '', 'LOENDERVEEN', 'Jan van der Heiden', 650, 'fluit', '1718', NULL, NULL, 'A', 'A', '1719-05-16', 'Texel', '1719-10-11', '1719-11-21', true, '1720-03-06', 'Batavia', 6477, NULL);
INSERT INTO "voyages" VALUES (2387, '', 5, '', 'MUNDEN', 'Gerbrand Mamus', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1719-05-16', 'Texel', '1719-10-01', '1719-11-16', true, '1720-02-22', 'Batavia', 6493, 'From 22-09 till 27-09-1719 at Saldanha Bay.');
INSERT INTO "voyages" VALUES (2388, '', 1, '', 'LAKENMAN', 'Stoffel Hansz. Boom', 600, 'fluit', '1718', NULL, NULL, 'E', 'E', '1719-06-10', 'Texel', '1719-11-27', '1719-12-25', true, '1720-03-12', 'Batavia', 6476, NULL);
INSERT INTO "voyages" VALUES (2389, '', 1, '', 'STAD LEIDEN', 'Jakob Korijn', 1140, NULL, '1718', NULL, NULL, 'A', 'A', '1719-06-10', 'Texel', '1719-10-21', '1719-12-03', true, '1720-03-10', 'Batavia', 6491, NULL);
INSERT INTO "voyages" VALUES (2390, '', 1, '', 'ZOETIGHEID', 'Abraham van der Ceel', 600, 'fluit', '1718', NULL, NULL, 'D', 'D', '1719-10-18', 'Goeree', '1720-02-10', '1720-03-06', true, '1720-06-14', 'Batavia', 6479, 'From 22-10 till 04-11-1719 at Portsmouth.');
INSERT INTO "voyages" VALUES (2391, '', 4, '', 'AMAZONE', 'Albert van Petten', 590, 'fluit', '1707', NULL, NULL, 'A', 'A', '1719-11-04', 'Texel', '1720-03-03', '1720-03-21', true, '1720-06-14', 'Batavia', NULL, 'Laid up at Batavia in 1729.');
INSERT INTO "voyages" VALUES (2392, '', 1, '', 'HUIS TE ASSENBURG', 'Hendrik Thieling', 800, NULL, '1718', NULL, NULL, 'A', 'A', '1719-11-04', 'Texel', '1720-02-21', '1720-03-21', true, '1720-06-09', 'Batavia', 6514, 'Fought against pirates.');
INSERT INTO "voyages" VALUES (2393, '', 5, '', 'BENTVELD', 'Frans Bol', 938, NULL, '1708', NULL, NULL, 'A', 'A', '1719-11-04', 'Texel', '1720-02-09', '1720-03-06', true, '1720-06-14', 'Batavia', 6550, NULL);
INSERT INTO "voyages" VALUES (2394, '', 2, '', 'PRATTENBURG', 'Jakob Onkruid', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1719-11-04', 'Texel', '1720-06-03', '1720-07-15', true, '1720-09-13', 'Batavia', 6495, '27-12-1719 and again back to Texel; third departure on 05-02-1720; 15-02 till 09-03-1720 at Hellevoetsluis: 6 seafarers and 1 craftsmen ran away.');
INSERT INTO "voyages" VALUES (2395, '', 1, '', 'PURMERLUST', 'Jan Gerrits Bestebeen', 580, NULL, '1718', NULL, NULL, 'A', 'A', '1719-11-04', 'Texel', '1720-02-09', '1720-03-06', true, '1720-06-07', 'Batavia', 6511, NULL);
INSERT INTO "voyages" VALUES (2396, '', 1, '', 'SAMARITAAN', 'Hendrik van der Grippe', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1719-11-24', 'Rammekens', '1720-06-14', '1720-07-15', true, '1720-09-19', 'Batavia', 6478, 'From 11-01 till 26-02-1720 back at Rammekens.');
INSERT INTO "voyages" VALUES (2397, '', 1, '', 'STEENHOVEN', 'Jakob Lijnsen+', 850, NULL, '1718', NULL, NULL, 'Z', 'Z', '1719-11-24', 'Rammekens', '1720-06-13', '1720-07-15', true, '1720-09-18', 'Batavia', 6499, 'The master died, and was succeeded by Philip de Waal. From 10-12 till 26-12-1719 at Den Burg; 24-01 till 03-02-1720 at Duins: 1 soldier deserted. From 06-02 till 24-02-1720 at Portsmouth: 1 soldier deserted; 02-03 till 08-03-1720 again at Portsmouth.');
INSERT INTO "voyages" VALUES (2398, '', 4, '', 'RAADHUIS VAN ENKHUIZEN', 'Jakob Breed', 578, 'fluit', '1709', NULL, NULL, 'E', 'A', '1719-12-09', 'Goeree', '1720-04-12', '1720-05-12', true, '1720-08-04', 'Batavia', 6489, NULL);
INSERT INTO "voyages" VALUES (2399, '', 3, '', 'GROENSWAART', 'Jan Kroon', 600, 'fluit', '1714', NULL, NULL, 'R', 'R', '1719-12-15', 'Goeree', '1720-03-25', '1720-04-19', true, '1720-07-10', 'Batavia', 6474, NULL);
INSERT INTO "voyages" VALUES (2400, '', 6, '', 'KIEFHOEK', 'Hendrik Wijman', 832, NULL, '1707', NULL, NULL, 'R', 'R', '1719-12-15', 'Goeree', '1720-03-26', '1720-04-19', true, '1720-07-11', 'Batavia', NULL, 'The ship was laid up at Batavia in 1729.');
INSERT INTO "voyages" VALUES (2401, '', 2, '', 'BORSSELE', 'David Brouwer', 800, NULL, '1715', NULL, NULL, 'Z', 'A', '1719-12-18', 'Texel', '1720-03-20', '1720-04-19', true, '1720-07-18', 'Batavia', 6516, 'From 22-12 till 25-12-1719 at Duins.');
INSERT INTO "voyages" VALUES (2402, '', 2, '', 'JOHANNA', 'Abraham Uithof', 550, 'fluit', '1714', NULL, NULL, 'A', 'A', '1719-12-18', 'Texel', '1720-03-20', '1720-04-19', true, '1720-07-10', 'Batavia', 6475, 'From 22-12 till 25-12-1719 at Duins.');
INSERT INTO "voyages" VALUES (2403, '', 3, '', 'MEERHUIZEN', 'Gideon Kuiper', 600, 'fluit', '1714', NULL, NULL, 'A', 'A', '1719-12-18', 'Texel', '1720-05-04', '1720-05-29', true, '1720-07-28', 'Ceylon', 6502, NULL);
INSERT INTO "voyages" VALUES (2404, '', 5, '', 'STANDVASTIGHEID', 'Gerrit Moring', 888, NULL, '1706', NULL, NULL, 'A', 'A', '1719-12-18', 'Texel', '1720-03-16', '1720-04-19', true, '1720-07-11', 'Batavia', 6498, 'From 22-12 till 25-12-1719 at Duins.');
INSERT INTO "voyages" VALUES (2405, '', 3, '', 'HUIS DE VLOTTER', 'Jan Pietersz. Keizer', 528, 'fluit', '1713', NULL, NULL, 'A', 'E', '1719-12-18', 'Texel', '1720-05-05', '1720-06-08', true, '1720-08-15', 'Batavia', 6503, 'From 22-12 till 25-12-1719 at Duins.');
INSERT INTO "voyages" VALUES (2406, '', 3, '', 'TER HORST', 'Pieter van Dalen', 520, 'fluit', '1713', NULL, NULL, 'D', 'D', '1719-12-19', 'Goeree', '1720-04-12', '1720-05-01', true, '1720-07-19', 'Batavia', 6490, NULL);
INSERT INTO "voyages" VALUES (2407, '', 4, '', 'RIJNESTEIN', 'Pieter Bitter', 608, 'fluit', '1709', NULL, NULL, 'A', 'Z', '1719-12-25', 'Wielingen', '1720-05-09', '1720-06-08', true, '1720-08-17', 'Batavia', 6512, '.');
INSERT INTO "voyages" VALUES (2408, '', 2, '', 'VALKENISSE', 'Hugo van der Slikke+', 1150, NULL, '1716', NULL, NULL, 'Z', 'Z', '1719-12-25', 'Wielingen', '1720-05-05', '1720-06-08', true, '1720-08-14', 'Batavia', 6500, 'was succeeded by Matthijs Ruger.');
INSERT INTO "voyages" VALUES (2409, '', 3, '', 'BOEKENRODE', 'Abraham Ram', 890, NULL, '1714', NULL, NULL, 'A', 'A', '1719-12-27', 'Texel', '1720-05-27', '1720-07-15', true, '1720-10-01', 'Ceylon', 6544, NULL);
INSERT INTO "voyages" VALUES (2410, '', 3, '', 'ELISABETH', 'Jan Klooster', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1719-12-27', 'Texel', '1720-06-13', '1720-07-24', true, '1720-09-24', 'Batavia', 6488, 'From 31-01 till 03-02-1720 at Duins; 06-02 till 24-02-1720 at Portsmouth and again 02-03 till 08-03-1720.');
INSERT INTO "voyages" VALUES (2411, '', 2, '', 'TER NISSE', 'Thieleman Sterling', 810, NULL, '1714', NULL, NULL, 'Z', 'A', '1719-12-27', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked at the coast of Eijerland, on 04-01-1720.');
INSERT INTO "voyages" VALUES (2412, '', 5, '', 'NOORDERKWARTIER', 'Pieter Knollendam', 550, 'fluit', '1709', NULL, NULL, 'H', 'H', '1719-12-27', 'Texel', '1720-06-07', '1720-07-15', true, '1720-10-13', 'Batavia', 6528, NULL);
INSERT INTO "voyages" VALUES (2413, '', 1, '', 'GOUDA', 'Marten Kleinkens', 220, NULL, '1719', NULL, NULL, 'A', 'A', '1720-02-03', 'Texel', '1720-11-22', NULL, true, '1720-11-22', 'The Cape', NULL, 'On 09-02 back at Texel, second departure on 23-02-1720; after coming back again, third departure on 21-07-1720. Wrecked at the Cape on 15-06-1722.');
INSERT INTO "voyages" VALUES (2414, '', 1, '', 'METEREN', 'Koenraad in de Betouw', 190, 'hoeker', '1719', NULL, NULL, 'E', 'A', '1720-02-03', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The METEREN probably returned to patria shortly after departure, see 2425 and 2547.');
INSERT INTO "voyages" VALUES (2415, '', 4, '', 'HARINGTUIN', 'Pieter van Losen', 618, 'fluit', '1705', NULL, NULL, 'E', 'E', '1720-03-08', 'Texel', '1720-06-15', '1720-07-15', true, '1720-09-24', 'Batavia', NULL, 'Laid up at Batavia in 1724.');
INSERT INTO "voyages" VALUES (2416, '', 1, '', 'MAGDALENA', 'Isaak de Winter', 600, NULL, '1719', NULL, NULL, 'H', 'H', '1720-03-08', 'Texel', '1720-06-15', '1720-07-15', true, '1720-09-19', 'Batavia', 6509, '2 Soldiers became seafarers.');
INSERT INTO "voyages" VALUES (2417, '', 5, '', 'BERBICES', 'Frederik van Eik', 1136, NULL, '1709', NULL, NULL, 'Z', 'Z', '1720-04-16', 'Wielingen', '1720-08-28', '1720-11-03', true, '1721-01-21', 'Batavia', 6515, '8 Seafarers went to the OUDENAARDE (2427).');
INSERT INTO "voyages" VALUES (2418, '', 4, '', 'RAADHUIS VAN MIDDELBURG', 'Jakob Delincourt', 890, NULL, '1708', NULL, NULL, 'Z', 'Z', '1720-04-16', 'Wielingen', '1720-08-28', '1720-10-06', true, '1721-01-18', 'Batavia', 6510, NULL);
INSERT INTO "voyages" VALUES (2419, '', 1, '', 'GOUDRIAAN', 'Michiel Ruis', 630, 'fluit', '1719', NULL, NULL, 'D', 'D', '1720-04-17', 'Goeree', '1720-09-03', '1720-11-03', true, '1721-01-21', 'Batavia', 6534, 'From 20-04 till 25-04-1720 at Portsmouth.');
INSERT INTO "voyages" VALUES (2420, '', 3, '', 'LINSCHOTEN', 'Siewert Pool', 804, NULL, '1714', NULL, NULL, 'A', 'A', '1720-04-24', 'Texel', '1720-08-30', '1720-11-03', true, '1721-01-21', 'Batavia', 6572, 'From 03-06 till 07-06-1720 at S. Tiago. 8 Seafarers went to the OUDENAARDE (2427).');
INSERT INTO "voyages" VALUES (2421, '', 3, '', 'MIDDELWOUD', 'Klaas Zwaan', 804, NULL, '1713', NULL, NULL, 'Z', 'A', '1720-04-24', 'Texel', '1720-08-28', '1720-10-06', true, '1720-12-23', 'Batavia', 6505, '1 Soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2422, '', 1, '', 'VALKENBOS', 'Jakob Brouwer', 800, NULL, '1719', NULL, NULL, 'R', 'R', '1720-04-25', 'Goeree', '1720-08-28', '1720-10-06', true, '1721-01-21', 'Batavia', NULL, 'Between 14-08 and 18-08-1722 lost near Japan.');
INSERT INTO "voyages" VALUES (2423, '', 4, '', 'HUIS TER BOEDE', 'Daniel van Staden', 642, 'jacht', '1702', NULL, NULL, 'Z', 'H', '1720-05-11', 'Texel', '1720-09-07', '1720-11-08', true, '1721-01-23', 'Batavia', NULL, 'Laid up at Batavia in 1728.');
INSERT INTO "voyages" VALUES (2424, '', 4, '', 'WIJNENDAAL', 'Jan Rusteplukker', 804, 'jacht', '1709', NULL, NULL, 'D', 'E', '1720-05-11', 'Texel', '1720-09-08', '1720-11-08', true, '1721-01-23', 'Batavia', NULL, 'Laid up at Batavia in 1728.');
INSERT INTO "voyages" VALUES (2425, '', 3, '', 'SCHOTEROOG', 'Koenraad in de Betouw', 360, 'fregat', '1712', NULL, NULL, 'A', 'A', '1720-05-14', 'Texel', '1720-08-19', '1720-10-06', true, '1720-12-07', 'Batavia', 6529, NULL);
INSERT INTO "voyages" VALUES (2426, '', 6, '', 'HOEDEKENSKERKE', 'Hendrik Fret', 830, NULL, '1704', NULL, NULL, 'Z', 'Z', '1720-05-20', 'Rammekens', '1720-10-02', '1720-11-08', true, '1721-01-17', 'Batavia', 6517, NULL);
INSERT INTO "voyages" VALUES (2427, '', 4, '', 'OUDENAARDE', 'Gerrit Stokke', 858, NULL, '1708', NULL, NULL, 'A', 'Z', '1720-05-20', 'Rammekens', '1720-09-07', '1720-11-03', true, '1721-01-21', 'Batavia', 6633, 'See 2417 and 2420.');
INSERT INTO "voyages" VALUES (2428, '', 4, '', 'KOCKENGEN', 'Louis Schulerius', 824, NULL, '1711', NULL, NULL, 'A', 'A', '1720-06-01', 'Texel', '1720-10-04', '1720-11-08', true, '1721-01-23', 'Batavia', 6585, NULL);
INSERT INTO "voyages" VALUES (2429, '', 1, '', 'BLEIJENBURG', 'Jan Lindenboom', 1100, NULL, '1719', NULL, NULL, 'A', 'A', '1720-07-21', 'Texel', '1720-11-23', '1721-01-01', true, '1721-04-24', 'Batavia', 6508, NULL);
INSERT INTO "voyages" VALUES (2430, '', 1, '', 'KAAP', NULL, 220, NULL, '1720', NULL, NULL, 'A', 'A', '1720-07-21', 'Texel', '1720-11-22', NULL, true, '1720-11-22', 'The Cape', NULL, 'On 19-04-1722 taken by 3 pirates at the Rio Delagoa.');
INSERT INTO "voyages" VALUES (2431, '', 5, '', 'OUWERKERK', 'Jan Kluit', 658, 'fluit', '1706', NULL, NULL, 'A', 'A', '1720-07-21', 'Texel', '1720-12-03', '1721-01-01', true, '1721-03-17', 'Batavia', 6519, NULL);
INSERT INTO "voyages" VALUES (2432, '', 3, '', 'DOORNIK', 'Jakob van Luipen', 830, NULL, '1709', NULL, NULL, 'A', 'A', '1720-11-21', 'Texel', '1721-06-04', '1721-07-11', true, '1721-09-09', 'Batavia', 6542, 'At Duins 26-11 till 06-01-1721; at Torbay 09-01 till 06-02-1721; at Plymouth 12-02 till 20-02-1721.');
INSERT INTO "voyages" VALUES (2433, '', 2, '', 'HOPVOGEL', 'Dirk Renvoort', 600, 'fluit', '1714', NULL, NULL, 'A', 'A', '1720-11-21', 'Texel', '1721-06-09', '1721-07-11', true, '1721-09-08', 'Batavia', 6619, 'From 26-11 till 06-01-1721 at Duins; at Torbay from 09-01 till 08-02-1721; at Plymouth from 12-02 till 20-02-1721.');
INSERT INTO "voyages" VALUES (2434, '', 2, '', 'MARGARETA', 'Jan Theunis', 600, 'fluit', '1715', NULL, NULL, 'E', 'A', '1720-11-21', 'Texel', '1721-06-09', '1721-08-05', true, '1721-11-07', 'Batavia', 6536, 'From 26-11 till 06-01-1721 at Duins; at Torbay from 09-01 till 08-02-1721; at Plymouth from 12-02 till 20-02-1721.');
INSERT INTO "voyages" VALUES (2435, '', 1, '', 'MIDLOO', 'Hendrik de Vries', 800, NULL, '1719', NULL, NULL, 'A', 'A', '1720-11-21', 'Texel', '1721-06-01', '1721-06-28', true, '1721-09-02', 'Batavia', 6586, 'From 26-11 till 06-01-1721 at Duins; at Torbay from 09-01 till 08-02-1721; at Plymouth from 12-02 till 20-02-1721.');
INSERT INTO "voyages" VALUES (2436, '', 2, '', 'DEN DAM', 'Frederik Koper', 600, 'fluit', '1716', NULL, NULL, 'D', 'E', '1721-02-09', 'Rammekens', '1721-06-10', '1721-07-11', true, '1721-09-08', 'Batavia', 6524, NULL);
INSERT INTO "voyages" VALUES (2437, '', 4, '', 'MEIJENBURG', 'Pieter Buis', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1721-02-15', 'Rammekens', '1721-08-13', '1721-09-28', true, '1721-12-13', 'Batavia', 6560, 'From 26-03 till 12-05-1721 at Portsmouth; 16 seafarers and 17 soldiers ran away, 4 seafarers came aboard.');
INSERT INTO "voyages" VALUES (2438, '', 1, '', 'NIEUWVLIET', 'Jan Behagele', 650, NULL, '1719', NULL, NULL, 'Z', 'Z', '1721-02-15', 'Rammekens', '1721-06-12', '1721-07-11', true, '1721-09-15', 'Batavia', 6587, NULL);
INSERT INTO "voyages" VALUES (2439, '', 1, '', 'RAVESTEIN', 'Reinier Hijpe', 800, NULL, '1719', NULL, NULL, 'Z', 'Z', '1721-02-15', 'Rammekens', '1721-06-04', '1721-07-11', true, '1721-09-02', 'Batavia', 6588, NULL);
INSERT INTO "voyages" VALUES (2440, '', 5, '', 'SAMSON', 'Kornelis van Reet', 800, NULL, '1707', NULL, NULL, 'A', 'Z', '1721-02-15', 'Rammekens', '1721-07-09', '1721-08-05', true, '1721-10-14', 'Batavia', 6513, NULL);
INSERT INTO "voyages" VALUES (2441, '', 3, '', 'D''UNO', 'Abraham Bustijn', 250, 'fregat', '1707', NULL, NULL, 'Z', 'Z', '1721-02-15', 'Rammekens', '1721-06-04', '1721-06-28', true, '1722-01-26', 'Batavia', 6563, NULL);
INSERT INTO "voyages" VALUES (2442, '', 6, '', 'ZANDENBURG', 'Jan Kole', 1136, NULL, '1706', NULL, NULL, 'Z', 'Z', '1721-02-15', 'Rammekens', NULL, NULL, true, NULL, NULL, NULL, 'Officers and men left the ship on 16-03-1721 +- 80 miles west of the Sorlings.');
INSERT INTO "voyages" VALUES (2443, '', 2, '', 'AMSTELVEEN', 'Theunis de Haan', 1150, NULL, '1717', NULL, NULL, 'A', 'A', '1721-02-19', 'Texel', '1721-05-25', '1721-06-28', true, '1721-09-04', 'Batavia', 6521, NULL);
INSERT INTO "voyages" VALUES (2444, '', 2, '', 'AMSTERDAM', 'Arend Redog', 800, NULL, '1716', NULL, NULL, 'A', 'A', '1721-02-19', 'Texel', '1721-06-25', '1721-08-05', true, '1721-10-11', 'Batavia', 6523, NULL);
INSERT INTO "voyages" VALUES (2445, '', 2, '', 'HOGENES', 'Isaak de Vries', 870, NULL, '1716', NULL, NULL, 'Z', 'A', '1721-02-19', 'Texel', '1721-05-25', '1721-06-28', true, '1721-08-28', 'Batavia', 6543, NULL);
INSERT INTO "voyages" VALUES (2446, '', 6, '', 'KONING KAREL DE DERDE', 'Jakob de Marre', 830, NULL, '1704', NULL, NULL, 'A', 'A', '1721-02-19', 'Texel', '1721-06-09', '1721-07-11', true, '1721-09-10', 'Batavia', 6527, NULL);
INSERT INTO "voyages" VALUES (2447, '', 3, '', 'STRUKEBOLLE', 'Jan Geerse', 540, 'fluit', '1712', NULL, NULL, 'E', 'A', '1721-02-19', 'Texel', '1721-07-15', '1721-08-20', true, '1721-11-10', 'Batavia', 6530, NULL);
INSERT INTO "voyages" VALUES (2448, '', 2, '', 'VRIESWIJK', 'Nikolaas de Roy', 850, NULL, '1716', NULL, NULL, 'H', 'A', '1721-02-19', 'Texel', '1721-06-09', '1721-07-20', true, '1721-09-18', 'Ceylon', 6634, NULL);
INSERT INTO "voyages" VALUES (2449, '', 6, '', 'WASSENAAR', 'Daniel Jakobsz. Bent', 804, NULL, '1704', NULL, NULL, 'D', 'H', '1721-02-19', 'Texel', '1721-06-10', '1721-07-11', true, '1721-09-09', 'Batavia', 6532, NULL);
INSERT INTO "voyages" VALUES (2450, '', 2, '', 'WENDELA', 'Bastiaan Schul', 600, NULL, '1716', NULL, NULL, 'A', 'A', '1721-02-19', 'Texel', '1721-06-10', '1721-07-14', true, '1721-09-18', 'Ceylon', 6520, NULL);
INSERT INTO "voyages" VALUES (2451, '', 4, '', 'WESTERDIJKSHORN', 'Matthijs Want', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1721-02-19', 'Texel', '1721-06-10', '1721-08-05', true, '1721-10-11', 'Batavia', 6533, NULL);
INSERT INTO "voyages" VALUES (2452, '', 5, '', 'NEPTUNUS', 'Jakob Bogaard', 858, NULL, '1704', NULL, NULL, 'A', 'R', '1721-02-23', 'Goeree', '1721-07-09', '1721-08-05', true, '1721-10-24', 'Batavia', NULL, 'The ship was laid up at Batavia in 1730.');
INSERT INTO "voyages" VALUES (2453, '', 5, '', 'VADERLAND GETROUW', 'Jan de Vos', 848, NULL, '1705', NULL, NULL, 'Z', 'D', '1721-04-08', 'Goeree', '1721-07-22', '1721-08-22', true, '1721-10-24', 'Batavia', 6531, 'First departure on 12-10-1720, return to Texel on 15-11-1720.');
INSERT INTO "voyages" VALUES (2454, '', 1, '', 'KROOSWIJK', 'Adriaan van Dorp', 600, 'fluit', '1720', NULL, NULL, 'R', 'R', '1721-05-06', 'Goeree', '1721-10-02', '1721-11-11', true, '1722-02-26', 'Batavia', 6623, NULL);
INSERT INTO "voyages" VALUES (2455, '', 3, '', 'SPIERING', 'Jan Kuipers', 810, NULL, '1714', NULL, NULL, 'D', 'Z', '1721-05-12', 'Rammekens', '1721-11-23', '1721-12-29', true, '1722-05-08', 'Ceylon', 6593, NULL);
INSERT INTO "voyages" VALUES (2456, '', 3, '', 'RAADHUIS VAN VLISSINGEN', 'Anthonie Klink', 600, 'fluit', '1714', NULL, NULL, 'Z', 'Z', '1721-05-12', 'Rammekens', '1721-11-23', '1721-12-29', true, '1722-03-15', 'Batavia', 6538, 'From 23-07 till 05-08-1721 at Cape Lopez; from 14-08 till 08-09-1721 at S. Tome; 2 soldiers ran away.');
INSERT INTO "voyages" VALUES (2457, '', 1, '', 'BAANMAN', 'Engel Appelman', 650, NULL, '1720', NULL, NULL, 'E', 'E', '1721-05-14', 'Texel', '1721-09-07', '1721-10-21', true, '1722-01-21', 'Batavia', 6569, '1 Seafarer went to the OPPERDOES (2458).');
INSERT INTO "voyages" VALUES (2458, '', 2, '', 'OPPERDOES', 'Jan Ravenek', 600, 'fluit', '1718', NULL, NULL, 'H', 'H', '1721-05-14', 'Texel', '1721-09-07', '1721-10-21', true, '1722-01-25', 'Batavia', 6539, 'See 2457.');
INSERT INTO "voyages" VALUES (2459, '', 2, '', 'BARBESTEIN', 'Jan Kopersluis', 1100, NULL, '1717', NULL, NULL, 'Z', 'D', '1721-05-21', 'Goeree', '1721-09-07', '1721-10-21', true, '1722-01-24', 'Batavia', 6548, NULL);
INSERT INTO "voyages" VALUES (2460, '', 7, '', 'GANSENHOEF', 'Arend Dirksz. Bent', 640, 'fluit', '1702', NULL, NULL, 'A', 'H', '1721-06-02', 'Texel', '1721-10-08', '1721-11-11', true, '1722-02-08', 'Batavia', NULL, 'Laid up at Batavia in 1729.');
INSERT INTO "voyages" VALUES (2461, '', 1, '', 'HILLEGONDA', 'Jan Ringelenberg', 850, NULL, '1720', NULL, NULL, 'H', 'A', '1721-06-02', 'Texel', '1721-10-08', '1721-11-11', true, '1722-01-28', 'Batavia', 6545, NULL);
INSERT INTO "voyages" VALUES (2462, '', 1, '', 'HEINKENSZAND', 'Kornelis Centsen', 1150, NULL, '1720', NULL, NULL, 'Z', 'Z', '1721-06-26', 'Rammekens', '1721-12-21', '1722-01-25', true, '1722-04-19', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (2463, '', 5, '', 'ARENDSDUIN', 'Evert van der Werf', 580, 'jacht', '1708', NULL, NULL, 'D', 'E', '1721-07-08', 'Texel', '1721-11-02', '1721-12-07', true, '1722-02-26', 'Batavia', 1, 'Soldier became a seafarer. The ship was lost in 1725.');
INSERT INTO "voyages" VALUES (2464, '', 2, '', 'VIS', 'Kornelis Haringkarspel', 600, 'fluit', '1716', NULL, NULL, 'E', 'A', '1721-07-08', 'Texel', '1721-12-02', '1722-01-13', true, '1722-03-20', 'Batavia', 6591, NULL);
INSERT INTO "voyages" VALUES (2465, '', 1, '', 'HAARLEM', 'Jan Laurens de Hoge', 850, NULL, '1720', NULL, NULL, 'A', 'A', '1721-07-09', 'Texel', '1721-10-19', '1721-11-29', true, '1722-01-30', 'Batavia', 6615, NULL);
INSERT INTO "voyages" VALUES (2466, '', 1, '', 'HEESBURG', 'Dirk Haan', 850, NULL, '1720', NULL, NULL, 'A', 'A', '1721-07-09', 'Texel', '1721-10-19', '1721-11-29', true, '1722-01-30', 'Batavia', 6605, NULL);
INSERT INTO "voyages" VALUES (2467, '', 1, '', 'STADWIJK', 'Gerrit Staal', 1150, NULL, '1720', NULL, NULL, 'A', 'A', '1721-07-15', 'Texel', '1721-12-09', '1722-01-15', true, '1722-04-15', 'Batavia', 6547, NULL);
INSERT INTO "voyages" VALUES (2468, '', 1, '', 'THEODORA', 'Pieter Scherf', 600, 'fluit', '1720', NULL, NULL, 'A', 'A', '1721-07-15', 'Texel', '1722-01-01', '1722-01-25', true, '1722-05-21', 'Batavia', 6568, NULL);
INSERT INTO "voyages" VALUES (2469, '', 3, '', 'JOHANNA', 'Gerrit Loot', 550, 'fluit', '1714', NULL, NULL, 'A', 'A', '1721-10-16', 'Texel', '1722-04-24', '1722-05-22', true, '1722-07-20', 'Batavia', 6555, 'From 14-11 till 24-11-1721 at Torbay; on 04-12-1721 at Portsmouth.');
INSERT INTO "voyages" VALUES (2470, '', 2, '', 'LOENDERVEEN', 'Pieter Westrik', 650, 'fluit', '1718', NULL, NULL, 'A', 'A', '1721-10-16', 'Texel', '1722-04-27', '1722-05-22', true, '1722-08-06', 'Batavia', 6558, 'From 07-11 till 14-12-1721 at Hellevoetsluis.');
INSERT INTO "voyages" VALUES (2471, '', 5, '', 'NOORDBEEK', 'Klaas van Eik', 858, NULL, '1707', NULL, NULL, 'Z', 'A', '1721-10-16', 'Texel', '1722-04-27', '1722-05-22', true, '1727-07-30', 'Batavia', 6561, 'From 07-11 till 14-12-1721 at Hellevoetsluis.');
INSERT INTO "voyages" VALUES (2472, '', 1, '', 'ASTREA', 'Huibert van Spijk', 800, NULL, '1720', NULL, NULL, 'D', 'D', '1721-10-18', 'Goeree', '1722-03-05', '1722-04-20', true, '1722-06-30', 'Batavia', 6602, NULL);
INSERT INTO "voyages" VALUES (2473, '', 4, '', 'GROENSWAART', 'Bartholomeus Mastrigt', 600, 'fluit', '1714', NULL, NULL, 'R', 'R', '1721-12-15', 'Goeree', '1722-04-12', '1722-05-10', true, '1722-07-23', 'Batavia', 6577, '2 soldiers became seafarers.');
INSERT INTO "voyages" VALUES (2474, '', 2, '', 'KOMMERRUST', 'Andries Pijl', 810, NULL, '1718', NULL, NULL, 'A', 'A', '1721-12-15', 'Texel', '1722-04-13', '1722-05-10', true, '1722-07-21', 'Batavia', 6556, NULL);
INSERT INTO "voyages" VALUES (2475, '', 2, '', 'LAKENMAN', 'Herman Branus', 600, 'fluit', '1718', NULL, NULL, 'E', 'E', '1721-12-15', 'Texel', '1722-06-06', NULL, true, NULL, NULL, NULL, 'On 15-06-1722 wrecked at the Cape.');
INSERT INTO "voyages" VALUES (2476, '', 2, '', 'SCHONENBERG', 'Albert van Soest', 800, NULL, '1717', NULL, NULL, 'A', 'A', '1721-12-15', 'Texel', '1722-04-11', '1722-05-10', true, '1722-07-21', NULL, 6541, NULL);
INSERT INTO "voyages" VALUES (2477, '', 1, '', 'AAGTEKERKE', 'Nikolaas Rabodus', 800, NULL, '1720', NULL, NULL, 'Z', 'Z', '1721-12-17', 'Rammekens', NULL, NULL, true, NULL, NULL, NULL, 'The ship ran ashore near Plymouth in December 1721.');
INSERT INTO "voyages" VALUES (2478, '', 2, '', 'SAMARITAAN', 'Jan Credo', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1721-12-17', 'Rammekens', '1722-05-05', '1722-06-10', true, '1722-11-24', 'Batavia', 6567, 'From 24-12 till 14-01-1722 at Plymouth: 6 seafarers and 2 soldiers ran away; 27-09 till 28-10-1722 at Benkulen: 2 seafarers and 2 soldiers ran away, 2 English and 1 stowaway came aboard.');
INSERT INTO "voyages" VALUES (2479, '', 2, '', 'STEENHOVEN', 'Jakob Lijnsen', 850, NULL, '1718', NULL, NULL, 'Z', 'Z', '1721-12-17', 'Rammekens', '1722-04-19', '1722-05-10', true, '1722-07-02', 'Batavia', 6598, NULL);
INSERT INTO "voyages" VALUES (2480, '', 7, '', 'BARNEVELD', 'Gideon Kuiper', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1721-12-21', 'Texel', '1722-04-28', '1722-06-10', true, '1722-08-12', 'Batavia', 6549, 'At Torbay from 10-01 till 18-01-1722.');
INSERT INTO "voyages" VALUES (2481, '', 1, '', 'JACOBA', 'Jan Pietersz. Keizer', 805, NULL, '1721', NULL, NULL, 'A', 'A', '1721-12-21', 'Texel', '1722-08-26', '1722-09-22', true, '1722-11-26', 'Batavia', 6566, 'Back at Texel from 05-03-1722 till 29-04-1722.');
INSERT INTO "voyages" VALUES (2482, '', 3, '', 'PRATTENBURG', 'Jan van der Heiden', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1721-12-21', 'Texel', '1722-04-10', '1722-05-10', true, '1722-07-23', 'Batavia', 6562, 'From 05-01 till 13-01-1722 at Duins.');
INSERT INTO "voyages" VALUES (2483, '', 1, '', 'SUSANNA', 'Nikolaas van Leeuwen', 600, NULL, '1721', NULL, NULL, 'A', 'A', '1721-12-21', 'Texel', '1722-04-28', '1722-05-22', true, '1722-08-10', 'Ceylon', 6607, NULL);
INSERT INTO "voyages" VALUES (2484, '', 5, '', 'RAADHUIS VAN ENKHUIZEN', NULL, 578, 'fluit', '1709', NULL, NULL, 'E', 'E', '1721-12-22', NULL, NULL, NULL, true, NULL, NULL, NULL, 'Lost at departure on 22-12-1721.');
INSERT INTO "voyages" VALUES (2485, '', 2, '', 'ZOETIGHEID', 'Abraham van der Ceel', 600, 'fluit', '1718', NULL, NULL, 'D', 'D', '1721-12-23', 'Goeree', '1722-06-13', NULL, true, NULL, NULL, NULL, 'Wrecked at the Cape on 15-06-1722.');
INSERT INTO "voyages" VALUES (2486, '', 2, '', 'STADHUIS VAN DELFT', 'Hendrik Schalkenius', 600, 'fluit', '1718', NULL, NULL, 'D', 'H', '1722-01-13', 'Texel', '1722-04-29', '1722-05-22', true, '1722-08-09', 'Batavia', 6552, NULL);
INSERT INTO "voyages" VALUES (2487, '', 4, '', 'ELISABETH', 'Marten Harting', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1722-01-13', 'Texel', '1722-04-12', '1722-05-10', true, '1722-07-11', 'Batavia', 6553, NULL);
INSERT INTO "voyages" VALUES (2488, '', 2, '', 'STAD LEIDEN', 'Pieter Verley', 1140, NULL, '1718', NULL, NULL, 'A', 'A', '1722-01-13', 'Texel', '1722-04-12', '1722-05-10', true, '1722-07-11', 'Batavia', 6557, NULL);
INSERT INTO "voyages" VALUES (2489, '', 3, '', 'LUCHTENBURG', 'Elias Wargaren', 800, NULL, '1715', NULL, NULL, 'H', 'A', '1722-01-13', 'Texel', '1722-04-18', '1722-05-10', true, '1722-07-20', 'Batavia', 6559, NULL);
INSERT INTO "voyages" VALUES (2490, '', 4, '', 'MEERHUIZEN', 'Hendrik Schoon', 600, 'fluit', '1714', NULL, NULL, 'A', 'A', '1722-01-13', 'Texel', '1722-04-28', '1722-05-22', true, '1722-08-10', 'Ceylon', 6546, NULL);
INSERT INTO "voyages" VALUES (2491, '', 3, '', 'VALKENISSE', 'Hendrik van der Grippe', 1150, NULL, '1716', NULL, NULL, 'Z', 'Z', '1722-01-16', 'Rammekens', '1722-04-29', '1722-05-28', true, '1722-07-23', 'Batavia', 6564, '4390A Hugo van der Slikke was master, but Van der Slikke had died during an outward bound voyage in 1720. (See 2408). According to Mattheus the master was Hendrik van der Grippe.');
INSERT INTO "voyages" VALUES (2492, '', 1, '', 'SCHOTSE LORRENDRAAIER', 'Adriaan Hijpe', NULL, 'fregat', NULL, NULL, NULL, NULL, 'Z', '1722-03-03', 'Rammekens', '1722-06-13', NULL, true, NULL, NULL, NULL, 'Lost at the Cape on 15-06-1722.');
INSERT INTO "voyages" VALUES (2493, '', 2, '', 'NOORDWADDINXVEEN', 'Johan de Hamer', 850, NULL, '1718', NULL, NULL, 'R', 'R', '1722-03-03', 'Goeree', '1722-07-13', '1722-08-12', true, '1722-11-08', 'Batavia', 6627, 'At Portsmouth from 07-03 till 10-03-1722.');
INSERT INTO "voyages" VALUES (2494, '', 3, '', 'ROTTERDAM', 'Gerrit Fiers', 800, NULL, '1716', NULL, NULL, 'R', 'Z', '1722-03-03', 'Rammekens', '1722-06-13', NULL, true, NULL, NULL, NULL, 'at the Cape on 15-06-1722.');
INSERT INTO "voyages" VALUES (2495, '', 6, '', 'STANDVASTIGHEID', 'Jan Kole', 888, NULL, '1706', NULL, NULL, 'A', 'Z', '1722-03-03', 'Rammekens', '1722-06-13', NULL, true, NULL, NULL, NULL, 'Lost at the Cape on 15-06-1722.');
INSERT INTO "voyages" VALUES (2496, '', 1, '', 'HERSTELLING', 'Pieter van Dalen', 600, NULL, '1721', NULL, NULL, 'D', 'D', '1722-04-10', 'Goeree', '1722-07-14', '1722-08-12', true, '1722-11-03', 'Batavia', 6631, 'Four soldiers became seafarers.');
INSERT INTO "voyages" VALUES (2497, '', 5, '', 'HERSTELDE LEEUW', 'Balten Leesten', 1138, NULL, '1704', NULL, NULL, 'Z', 'Z', '1722-04-23', 'Rammekens', '1723-01-20', '1723-02-24', true, '1723-06-08', 'Batavia', NULL, '11-09 till 16-09-1722 at Cape Lopez; from 21-10 till 10-11-1722 at Benguela; from 26-12-1722 till 18-01-1723 at Saldanha Bay. The ship was laid up at Batavia in 1730.');
INSERT INTO "voyages" VALUES (2498, '', 4, '', 'MIDDELWOUD', 'Kornelis Braams', 804, NULL, '1712', NULL, NULL, 'Z', 'Z', '1722-04-23', 'Rammekens', '1723-01-20', '1723-02-24', true, '1723-06-09', 'Batavia', 6579, 'Benguela; from 26-12-1722 till 18-01-1722 at Saldanha Bay.');
INSERT INTO "voyages" VALUES (2499, '', 1, '', 'APPOLLONIA', 'Gerbrand Mamus', 800, NULL, '1721', NULL, NULL, 'A', 'A', '1722-04-29', 'Texel', '1722-08-30', '1722-10-03', true, '1722-12-21', 'Batavia', NULL, 'Japan in 1724.');
INSERT INTO "voyages" VALUES (2500, '', 1, '', 'CORNELIA', 'Jan Brouwer', 800, NULL, '1721', NULL, NULL, 'H', 'H', '1722-04-29', 'Texel', '1722-09-30', '1722-10-08', true, '1723-01-24', 'Batavia', 6614, NULL);
INSERT INTO "voyages" VALUES (2501, '', 2, '', 'HAAKSBURG', 'Koenraad Mels', 600, NULL, '1718', NULL, NULL, 'E', 'A', '1722-04-29', 'Texel', '1722-08-25', '1722-10-16', true, '1723-01-20', 'Batavia', 6640, NULL);
INSERT INTO "voyages" VALUES (2502, '', 1, '', 'OOSTRUST', 'Gerrit Moring', 1140, NULL, '1721', NULL, NULL, 'A', 'A', '1722-04-29', 'Texel', '1722-08-24', '1722-09-21', true, '1722-12-03', 'Batavia', 6594, NULL);
INSERT INTO "voyages" VALUES (2503, '', 1, '', 'KETEL', 'Samuel Jansz.', 810, NULL, '1721', NULL, NULL, 'R', 'R', '1722-05-07', 'Goeree', '1722-08-25', '1722-10-03', true, '1722-12-22', 'Batavia', 6632, NULL);
INSERT INTO "voyages" VALUES (2504, '', 4, '', 'TER HORST', 'Jan de Rode', 520, 'fluit', '1713', NULL, NULL, 'D', 'A', '1722-05-13', 'Hellevoetsluis', '1722-09-21', '1722-11-02', true, '1723-01-24', 'Batavia', 6620, 'From 15-05 till 17-05-1722 at Duins.');
INSERT INTO "voyages" VALUES (2505, '', 3, '', 'SLEEWIJK', 'Klaas Koster', 520, 'jacht', '1713', NULL, NULL, 'R', 'A', '1722-05-13', 'Hellevoetsluis', '1722-09-20', '1722-10-23', true, '1723-01-25', 'Batavia', 6727, 'From 15-05 till 17-05-1722 at Duins.');
INSERT INTO "voyages" VALUES (2506, '', 3, '', 'SLOT ALDEGONDE', 'Steven Boghoute', 1160, 'jacht', '1714', NULL, NULL, 'Z', 'Z', '1722-05-27', 'Rammekens', '1722-10-13', '1722-11-16', true, '1723-03-01', 'Batavia', 6570, NULL);
INSERT INTO "voyages" VALUES (2507, '', 1, '', 'KLARABEEK', 'Matthijs van Eps', 705, NULL, '1721', NULL, NULL, 'Z', 'Z', '1722-05-27', 'Rammekens', '1722-10-13', '1722-11-16', true, '1723-01-26', 'Batavia', 6600, NULL);
INSERT INTO "voyages" VALUES (2508, '', 1, '', 'AGATHA', 'Wouter Brand', 600, NULL, '1721', NULL, NULL, 'E', 'E', '1722-06-12', 'Texel', '1722-11-07', '1722-12-26', true, '1723-03-07', 'Batavia', 6644, 'from 19-07 till 22-07-1722.');
INSERT INTO "voyages" VALUES (2509, '', 4, '', 'HUIS DE VLOTTER', 'Klaas Slijper', 528, 'fluit', '1713', NULL, NULL, 'A', 'E', '1722-06-12', 'Texel', '1722-10-27', '1722-11-19', true, '1723-02-03', 'Batavia', 6582, 'At S. Tiago from 19-07 till 22-07-1722.');
INSERT INTO "voyages" VALUES (2510, '', 4, '', 'HUIS TEN DONK', 'Klaas Schouten', 650, NULL, '1711', NULL, NULL, 'R', 'A', '1722-10-17', 'Texel', '1723-02-15', '1723-03-11', true, '1723-06-08', 'Batavia', 6590, NULL);
INSERT INTO "voyages" VALUES (2511, '', 6, '', 'MIJNDEN', 'Balthus van Santen', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1722-10-17', 'Texel', '1723-03-04', '1723-03-31', true, '1723-06-19', 'Batavia', 6580, NULL);
INSERT INTO "voyages" VALUES (2512, '', 2, '', 'PURMERLUST', 'Jakob Kooimans', 580, NULL, '1718', NULL, NULL, 'A', 'A', '1722-10-17', 'Texel', '1723-03-21', '1723-04-11', true, '1723-07-01', 'Batavia', 6657, NULL);
INSERT INTO "voyages" VALUES (2513, '', 3, '', 'RIJKSDORP', 'Jakob Klotendraaier', 792, NULL, '1713', NULL, NULL, 'A', 'H', '1722-10-17', 'Texel', '1723-04-19', '1723-05-08', true, '1723-07-20', 'Batavia', 6581, 'From 01-04 till 16-04-1723 at Saldanha Bay.');
INSERT INTO "voyages" VALUES (2514, '', 2, '', 'DELFLAND', 'Jakob van der Poel', 600, 'fluit', '1717', NULL, NULL, 'D', 'D', '1723-01-07', 'Goeree', '1723-04-19', '1723-05-01', true, '1723-07-01', 'Batavia', 6576, NULL);
INSERT INTO "voyages" VALUES (2515, '', 7, '', 'WASSENAAR', 'Hendrik Wijman', 804, NULL, '1704', NULL, NULL, 'D', 'R', '1723-01-07', 'Goeree', '1723-04-28', '1723-05-29', true, '1723-08-26', 'Batavia', NULL, 'One soldier became a seafarer. Laid up at Batavia in 1731.');
INSERT INTO "voyages" VALUES (2516, '', 3, '', 'AMSTERDAM', 'Wessel Hoogwerf', 800, NULL, '1716', NULL, NULL, 'A', 'A', '1723-01-09', 'Texel', '1723-04-13', '1723-04-29', true, '1723-07-05', 'Batavia', 6589, NULL);
INSERT INTO "voyages" VALUES (2517, '', 2, '', 'HUIS TE ASSENBURG', 'Jakob Thoom', 800, NULL, '1718', NULL, NULL, 'A', 'A', '1723-01-09', 'Texel', '1723-04-12', '1723-05-01', true, '1723-07-01', 'Batavia', 6601, NULL);
INSERT INTO "voyages" VALUES (2518, '', 1, '', 'CASTRICUM', 'Michiel van Pavie', 1150, NULL, '1722', NULL, NULL, 'A', 'A', '1723-01-09', 'Texel', '1723-04-12', '1723-05-01', true, '1723-06-29', 'Batavia', 6575, NULL);
INSERT INTO "voyages" VALUES (2519, '', 2, '', 'GEERTRUID', 'IJpe Engelsman', 600, 'fluit', '1717', NULL, NULL, 'E', 'E', '1723-01-09', 'Texel', '1723-04-17', '1723-05-01', true, '1723-07-20', 'Batavia', 6571, 'One soldier became seafarer.');
INSERT INTO "voyages" VALUES (2520, '', 7, '', 'KONING KAREL DE DERDE', 'Arend Redog', 830, NULL, '1704', NULL, NULL, 'A', 'A', '1723-01-09', 'Texel', '1723-04-12', '1723-05-01', true, '1723-08-10', 'Ceylon', NULL, 'Laid up at Batavia in 1730.');
INSERT INTO "voyages" VALUES (2521, '', 6, '', 'OUWERKERK', 'Jan de Vos', 658, 'fluit', '1706', NULL, NULL, 'A', 'A', '1723-01-09', 'Texel', '1723-04-17', '1723-05-01', true, '1723-07-18', 'Batavia', NULL, 'Wrecked near Japara in 1728.');
INSERT INTO "voyages" VALUES (2522, '', 4, '', 'SCHOTEROOG', 'Jan Verschouw', 360, 'fregat', '1712', NULL, NULL, 'A', 'A', '1723-01-09', 'Texel', '1723-04-06', '1723-08-09', true, '1723-10-14', 'Batavia', NULL, 'First departure from the Cape on 09-05-1723; from 27-05 till 23-06-1723 at Rio Delagoa where 15 seafarers and 28 soldiers disembarked and two seafarers, two soldiers and three blacks came aboard. Back at the Cape on 11-07-1723 where two soldiers and the three blacks disembarked and four seafarers and seven soldiers came aboard. Laid up at Batavia in 1729.');
INSERT INTO "voyages" VALUES (2523, '', 1, '', 'STABROEK', 'Jakob de Marre', 900, NULL, '1722', NULL, NULL, 'A', 'A', '1723-01-09', 'Texel', '1723-04-18', '1723-05-01', true, '1723-07-11', 'Batavia', 6597, NULL);
INSERT INTO "voyages" VALUES (2524, '', 3, '', 'WENDELA', 'Jan van den Tempel', 600, NULL, '1716', NULL, NULL, 'A', 'A', '1723-01-09', 'Texel', '1723-04-11', '1723-05-01', true, '1723-06-29', 'Batavia', 6573, NULL);
INSERT INTO "voyages" VALUES (2525, '', 1, '', 'WESTERBEEK', 'Jan Kluit', 650, NULL, '1722', NULL, NULL, 'A', 'A', '1723-01-09', 'Texel', '1723-04-12', '1723-05-01', true, '1723-07-15', 'Batavia', 6681, NULL);
INSERT INTO "voyages" VALUES (2526, '', 5, '', 'WESTERDIJKSHORN', 'Bastiaan Schul', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1723-01-09', 'Texel', '1723-04-12', '1723-05-01', true, '1723-07-01', 'Batavia', 6583, NULL);
INSERT INTO "voyages" VALUES (2527, '', 1, '', 'WESTFRIESLAND', 'Klaas Zeeridder', 370, 'jacht', '1722', NULL, NULL, 'H', 'H', '1723-01-09', 'Texel', '1723-04-17', '1723-05-01', true, '1723-06-29', 'Batavia', 6584, NULL);
INSERT INTO "voyages" VALUES (2528, '', 1, '', 'CASTOR EN POLLUX', 'Jakob Jongerheld', 400, 'jacht', '1722', NULL, NULL, 'Z', 'Z', '1723-01-13', 'Rammekens', '1723-05-14', '1723-06-28', true, '1723-08-28', 'Batavia', 6692, NULL);
INSERT INTO "voyages" VALUES (2529, '', 2, '', 'MAGDALENA', 'Willem de Smit', 600, NULL, '1719', NULL, NULL, 'H', 'Z', '1723-01-13', 'Rammekens', '1723-05-15', '1723-06-28', true, '1723-08-26', 'Batavia', 6578, NULL);
INSERT INTO "voyages" VALUES (2530, '', 4, '', 'NEDERHOVEN', 'Matthijs Ruger', 600, 'fluit', '1708', NULL, NULL, 'R', 'Z', '1723-01-13', 'Rammekens', '1723-05-21', '1723-07-05', true, '1723-10-28', 'Batavia', NULL, 'Laid up at Batavia in 1733.');
INSERT INTO "voyages" VALUES (2531, '', 6, '', 'VADERLAND GETROUW', 'Jan Havelaar', 848, NULL, '1705', NULL, NULL, 'Z', 'Z', '1723-01-13', 'Rammekens', '1723-05-14', '1723-06-28', true, '1723-08-31', 'Batavia', NULL, 'One craftsmen became a seafarer. Laid up at Batavia in 1733.');
INSERT INTO "voyages" VALUES (2532, '', 1, '', 'ZOETELINGSKERKE', 'Leendert Ole', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1723-01-13', 'Rammekens', '1723-05-15', '1723-06-28', true, '1723-09-07', 'Batavia', 6592, NULL);
INSERT INTO "voyages" VALUES (2533, '', 7, '', 'HOEDEKENSKERKE', 'Nikolaas Rabodus', 830, NULL, '1704', NULL, NULL, 'Z', 'Z', '1723-03-28', 'Rammekens', '1723-07-20', '1723-08-11', true, '1723-10-24', 'Batavia', NULL, 'Laid up at Batavia in 1732.');
INSERT INTO "voyages" VALUES (2534, '', 1, '', 'ZEEPOST', 'Adriaan Buth', NULL, 'hoeker', NULL, NULL, NULL, NULL, 'Z', '1723-03-28', 'Rammekens', '1723-07-20', NULL, true, '1723-07-20', 'The Cape', NULL, 'Laid up at the Cape in 1733.');
INSERT INTO "voyages" VALUES (2535, '', 2, '', 'HOF NIET ALTIJD ZOMER', 'Pieter van de Roete', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1723-03-28', 'Rammekens', '1723-07-20', '1723-08-11', true, '1723-10-23', 'Batavia', 6595, NULL);
INSERT INTO "voyages" VALUES (2536, '', 1, '', 'KASTEEL VAN WOERDEN', 'Jakob Bernards', 850, NULL, '1722', NULL, NULL, 'D', 'D', '1723-03-29', 'Goeree', '1723-07-09', '1723-07-25', true, '1723-10-01', 'Batavia', 6669, NULL);
INSERT INTO "voyages" VALUES (2537, '', 1, '', 'PATMOS', 'Gelijp de Haas', 810, NULL, '1722', NULL, NULL, 'D', 'R', '1723-04-07', 'Hellevoetsluis', '1723-07-16', '1723-08-09', true, '1723-10-25', 'Batavia', 6596, NULL);
INSERT INTO "voyages" VALUES (2538, '', 3, '', 'MARGARETA', 'Jakob Onkruid', 600, 'fluit', '1715', NULL, NULL, 'E', 'A', '1723-04-25', 'Texel', '1723-09-03', '1723-10-18', true, '1724-01-02', 'Batavia', 6626, 'Two soldiers became seafarers.');
INSERT INTO "voyages" VALUES (2539, '', 3, '', 'OPPERDOES', 'Matthijs Zwaan', 600, 'fluit', '1718', NULL, NULL, 'H', 'A', '1723-04-25', 'Texel', '1723-09-07', '1723-10-28', true, '1724-01-10', 'Batavia', 6606, 'Two soldiers became seafarers. During the voyage one child was born.');
INSERT INTO "voyages" VALUES (2540, '', 4, '', 'RAADHUIS VAN VLISSINGEN', 'Gerrit Fiers', 600, 'fluit', '1714', NULL, NULL, 'Z', 'Z', '1723-04-29', 'Rammekens', '1723-11-05', '1723-11-19', true, '1724-02-13', 'Batavia', 6758, 'From 09-09 till 04-11-1723 at Saldanha Bay.');
INSERT INTO "voyages" VALUES (2541, '', 1, '', 'WOLPHAARTSDIJK', 'Matthijs Burger', 660, NULL, '1722', NULL, NULL, 'Z', 'Z', '1723-04-29', 'Rammekens', '1723-09-07', '1723-11-06', true, '1724-01-21', 'Batavia', 6683, NULL);
INSERT INTO "voyages" VALUES (2542, '', 4, '', 'STRUKEBOLLE', 'Jan Bloemendaal', 540, 'fluit', '1712', NULL, NULL, 'E', 'E', '1723-05-01', 'Texel', '1723-08-24', '1723-09-07', true, '1723-12-04', 'Batavia', 6599, NULL);
INSERT INTO "voyages" VALUES (2543, '', 6, '', 'NOORDERKWARTIER', 'Jan Meindertsz. Blok', 550, 'fluit', '1709', NULL, NULL, 'H', 'H', '1723-05-03', 'Texel', '1723-12-23', '1724-01-13', true, '1724-05-26', 'Batavia', 6637, NULL);
INSERT INTO "voyages" VALUES (2544, '', 2, '', 'GOUDRIAAN', 'Jan Reebok', 630, 'fluit', '1719', NULL, NULL, 'D', 'A', '1723-05-15', 'Goeree', '1723-09-16', '1723-11-06', true, '1724-02-19', 'Batavia', 6604, 'From 19-06 till 23-06-1723 at S. Tiago.');
INSERT INTO "voyages" VALUES (2545, '', 1, '', 'PETRONELLA ALIDA', 'Jan Rusteplukker', 550, NULL, '1722', NULL, NULL, 'E', 'E', '1723-05-20', 'Texel', '1723-11-17', '1723-12-20', true, '1724-04-14', 'Batavia', 6643, NULL);
INSERT INTO "voyages" VALUES (2546, '', 3, '', 'DEN DAM', 'Arie Jansz. Verduin', 600, 'fluit', '1716', NULL, NULL, 'D', 'D', '1723-05-24', 'Goeree', '1722-09-07', '1723-09-24', true, '1723-12-18', 'Batavia', 6639, NULL);
INSERT INTO "voyages" VALUES (2547, '', 2, '', 'METEREN', 'Willem van Turenhout', 190, 'hoeker', '1719', NULL, NULL, 'E', 'A', '1723-05-24', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'On 07-11-1723 wrecked on the coast of Africa, near the Olifantsriver (31'' 20'' S.). 9 Men were saved.');
INSERT INTO "voyages" VALUES (2548, '', 1, '', 'WINDHOND', 'Jan van de Vijver', 370, NULL, '1722', NULL, NULL, 'A', 'A', '1723-05-24', 'Texel', '1723-09-03', '1723-09-24', true, '1723-12-01', 'Batavia', 6630, NULL);
INSERT INTO "voyages" VALUES (2549, '', 6, '', 'VOORBURG', 'Isaak Hage', 600, NULL, '1710', NULL, NULL, 'D', 'A', '1723-05-25', 'Texel', '1723-11-03', '1723-11-25', true, '1724-01-31', 'Batavia', 6652, NULL);
INSERT INTO "voyages" VALUES (2550, '', 1, '', 'ADELAAR', 'Joris Vermouwe', 810, NULL, '1722', NULL, NULL, 'Z', 'Z', '1723-06-06', 'Rammekens', '1723-10-17', '1723-11-10', true, '1724-01-16', 'Batavia', 6608, 'During the voyage one child was born. At S. Tiago from 16-07 till 23-07-1723.');
INSERT INTO "voyages" VALUES (2551, '', 3, '', 'BORSSELE', 'Jonas Mierman', 800, NULL, '1715', NULL, NULL, 'Z', 'Z', '1723-06-06', 'Rammekens', '1723-10-17', '1723-11-06', true, '1724-02-01', 'Ceylon', 6603, NULL);
INSERT INTO "voyages" VALUES (2552, '', 6, '', 'BERBICES', 'Wouter van Dijk', 1136, NULL, '1709', NULL, NULL, 'Z', 'A', '1723-07-12', 'Texel', '1723-11-19', '1723-12-08', true, '1724-03-21', 'Batavia', 6613, NULL);
INSERT INTO "voyages" VALUES (2553, '', 2, '', 'ANNA MARIA', 'Leonard de Rijke', 600, NULL, '1717', NULL, NULL, 'Z', 'Z', '1723-09-27', 'Rammekens', '1724-01-04', '1724-01-18', true, '1724-04-01', 'Batavia', 6654, NULL);
INSERT INTO "voyages" VALUES (2554, '', 4, '', 'DOORNIK', 'Jan Kole', 830, NULL, '1709', NULL, NULL, 'A', 'Z', '1723-09-27', 'Rammekens', '1724-01-04', '1724-01-18', true, '1724-04-17', 'Batavia', 6609, NULL);
INSERT INTO "voyages" VALUES (2555, '', 1, '', 'FORTUIN', 'Pieter Westrik', 800, NULL, '1722', NULL, NULL, 'A', 'A', '1723-09-27', 'Texel', '1724-01-02', '1724-01-18', true, NULL, NULL, NULL, 'between the Cape and Batavia.');
INSERT INTO "voyages" VALUES (2556, '', 1, '', '''S GRAVELAND', 'Jan Diephout', 600, NULL, '1722', NULL, NULL, 'A', 'A', '1723-09-27', 'Texel', '1724-01-02', '1724-02-03', true, '1724-04-27', 'Batavia', 6636, NULL);
INSERT INTO "voyages" VALUES (2557, '', 3, '', 'HOGENES', 'Elias Wargaren', 870, NULL, '1716', NULL, NULL, 'Z', 'A', '1723-04-27', 'Texel', '1724-01-02', '1724-01-18', true, '1724-04-21', 'Batavia', 6618, NULL);
INSERT INTO "voyages" VALUES (2558, '', 2, '', 'STADWIJK', 'Marten Harting', 1150, NULL, '1720', NULL, NULL, 'A', 'A', '1723-11-02', 'Texel', '1724-03-08', '1724-03-23', true, '1724-06-07', 'Batavia', 6611, NULL);
INSERT INTO "voyages" VALUES (2559, '', 6, '', 'BENTVELD', 'Isaak de Vries', 938, NULL, '1708', NULL, NULL, 'A', 'A', '1723-11-29', 'Texel', '1724-06-07', '1724-07-01', true, '1724-08-29', 'Batavia', NULL, 'seafarer and 1 soldier ran away. The ship was laid up at Batavia in 1734.');
INSERT INTO "voyages" VALUES (2560, '', 3, '', 'KOMMERRUST', 'Pieter Verley', 810, NULL, '1718', NULL, NULL, 'A', 'A', '1723-11-29', 'Texel', '1724-06-08', '1724-07-01', true, '1724-09-02', 'Batavia', 6622, 'From 12-12-1723 till 09-02-1724 at Portsmouth; 4 seafarers ran away.');
INSERT INTO "voyages" VALUES (2561, '', 2, '', 'HEINKENSZAND', 'Jan Credo', 1150, NULL, '1720', NULL, NULL, 'Z', 'Z', '1723-11-30', 'Rammekens', '1724-06-22', '1724-07-13', true, '1724-09-29', 'Batavia', 6616, 'Back at the Vlie from 03-01 till 10-02-1724; from 15-02 till 18-02-1724 at Duins; from 20-02 till 24-02-1724 at Wight; from 02-03 till 08-03-1724 at Portsmouth.');
INSERT INTO "voyages" VALUES (2562, '', 4, '', 'VALKENISSE', 'Abraham Bustijn', 1150, NULL, '1716', NULL, NULL, 'Z', 'Z', '1723-11-30', 'Rammekens', '1724-07-20', '1724-08-20', true, '1724-10-21', 'Batavia', 6651, 'From 18-01 till 08-03-1724 at Edinburgh; from 14-03 till 02-04-1724 back at Vlissingen.');
INSERT INTO "voyages" VALUES (2563, '', 1, '', 'BLIJDORP', 'Krielaard', 900, NULL, '1723', NULL, NULL, 'R', 'R', '1724-01-08', 'Goeree', '1724-05-13', '1724-05-23', true, '1724-08-03', 'Batavia', 6646, NULL);
INSERT INTO "voyages" VALUES (2564, '', 1, '', 'LANGERODE', 'Jakob van der Swet', 600, NULL, '1723', NULL, NULL, 'D', 'D', '1724-01-08', 'Goeree', '1724-05-07', '1724-05-22', true, '1724-07-10', 'Batavia', 6624, NULL);
INSERT INTO "voyages" VALUES (2565, '', 3, '', 'BARBESTEIN', 'Kornelis Fret', 1100, NULL, '1717', NULL, NULL, 'Z', 'Z', '1724-02-10', 'Rammekens', '1724-06-18', '1724-07-01', true, '1724-09-01', 'Batavia', 6612, NULL);
INSERT INTO "voyages" VALUES (2566, '', 8, '', 'BARNEVELD', 'Gideon Kuiper', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1724-02-10', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'On 14-02-1724 wrecked on the sands between Grevelingen and Dunkirk.');
INSERT INTO "voyages" VALUES (2567, '', 1, '', 'BERKENRODE', 'Jan van der Heiden', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1724-02-10', 'Texel', '1724-06-05', '1724-07-01', true, '1724-08-30', 'Batavia', 6629, NULL);
INSERT INTO "voyages" VALUES (2568, '', 2, '', 'HILLEGONDA', 'Michiel de Reus', 850, NULL, '1720', NULL, NULL, 'H', 'H', '1724-02-10', 'Texel', '1724-07-16', '1724-08-20', true, '1724-11-08', 'Batavia', 6617, NULL);
INSERT INTO "voyages" VALUES (2569, '', 2, '', 'JACOBA', 'Tijmen Mol', 805, NULL, '1721', NULL, NULL, 'A', 'A', '1724-02-10', 'Texel', '1724-06-20', '1724-07-01', true, '1724-09-30', 'Ceylon', 6610, NULL);
INSERT INTO "voyages" VALUES (2570, '', 4, '', 'JOHANNA', 'Klaas Jonkers', 550, 'fluit', '1714', NULL, NULL, 'A', 'E', '1724-02-10', 'Texel', '1724-06-07', '1724-07-01', true, '1724-08-30', 'Batavia', 6621, NULL);
INSERT INTO "voyages" VALUES (2571, '', 3, '', 'STAD LEIDEN', 'Jakob Breed', 1140, NULL, '1718', NULL, NULL, 'A', 'A', '1724-02-10', 'Texel', '1724-06-07', '1724-07-01', true, '1724-08-29', 'Batavia', 6625, 'From 16-02 till 18-02-1724 at Portsmouth; 2 seafarers ran away.');
INSERT INTO "voyages" VALUES (2572, '', 4, '', 'PRATTENBURG', 'Pieter Scherf', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1724-02-10', 'Texel', '1724-06-07', '1724-07-01', true, '1724-09-02', 'Batavia', 6628, NULL);
INSERT INTO "voyages" VALUES (2573, '', 1, '', 'SAKSENBURG', 'Jakobus Upelaar', 610, NULL, '1723', NULL, NULL, 'A', 'A', '1724-02-10', 'Texel', '1724-06-06', '1724-06-19', true, '1724-08-30', 'Batavia', 6670, NULL);
INSERT INTO "voyages" VALUES (2574, '', 3, '', 'SAMARITAAN', 'Elias Moeninx', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1724-02-10', 'Rammekens', '1724-06-11', '1724-07-01', true, '1724-09-07', 'Batavia', 6661, NULL);
INSERT INTO "voyages" VALUES (2575, '', 2, '', 'THEODORA', 'Pieter Bellaart', 600, 'fluit', '1720', NULL, NULL, 'A', 'A', '1724-02-10', 'Texel', '1724-06-07', '1724-07-01', true, '1724-09-07', 'Ceylon', 6649, 'A');
INSERT INTO "voyages" VALUES (2576, '', 1, '', 'WICKENBURG', 'Adriaan Hijpe', 850, NULL, '1722', NULL, NULL, 'Z', 'Z', '1724-02-10', 'Rammekens', '1724-06-11', '1724-07-01', true, '1724-09-02', 'Batavia', 6635, NULL);
INSERT INTO "voyages" VALUES (2577, '', 6, '', 'NOORDBEEK', 'Joost Roset', 858, NULL, '1707', NULL, NULL, 'Z', 'D', '1724-04-01', 'Goeree', '1724-07-13', '1724-08-05', true, '1724-10-21', 'Batavia', 6642, NULL);
INSERT INTO "voyages" VALUES (2578, '', 3, '', 'CATS', 'Michiel van Market', 580, NULL, '1716', NULL, NULL, 'Z', 'R', '1724-05-02', 'Goeree', '1724-10-25', '1724-11-17', true, '1725-02-04', 'Batavia', 6710, 'From 09-05 till 13-05-1724 at Portsmouth.');
INSERT INTO "voyages" VALUES (2579, '', 3, '', 'STADHUIS VAN DELFT', 'Jan Kopersluis', 600, 'fluit', '1718', NULL, NULL, 'D', 'D', '1724-05-02', 'Goeree', '1724-10-25', '1724-11-17', true, '1725-02-23', 'Batavia', 6672, NULL);
INSERT INTO "voyages" VALUES (2580, '', 2, '', 'BAANMAN', 'Anthonie Biermans', 650, NULL, '1720', NULL, NULL, 'E', 'A', '1724-05-03', 'Texel', '1724-10-06', '1724-11-02', true, '1725-02-03', 'Batavia', 6671, NULL);
INSERT INTO "voyages" VALUES (2581, '', 1, '', 'WAPEN VAN HOORN', 'Hendrik Schoon', 850, NULL, '1723', NULL, NULL, 'H', 'A', '1724-05-03', 'Texel', '1724-10-13', '1724-11-09', true, '1725-02-03', 'Batavia', 6702, 'At S. Tiago from 02-07 till 14-07-1724; 4 seafarers and 5 soldiers ran away.');
INSERT INTO "voyages" VALUES (2582, '', 4, '', 'LUCHTENBURG', 'Dirk de Vet', 800, NULL, '1715', NULL, NULL, 'H', 'H', '1724-05-03', 'Texel', '1724-10-06', '1724-11-02', true, '1725-01-21', 'Batavia', 6641, NULL);
INSERT INTO "voyages" VALUES (2583, '', 5, '', 'MEERHUIZEN', 'Leendert Danverst', 600, 'fluit', '1714', NULL, NULL, 'A', 'A', '1724-05-03', 'Texel', '1724-10-21', '1724-11-26', true, '1725-03-21', 'Batavia', NULL, 'during the voyage and was succeeded by Daniel Overbeek. Wrecked between Coromandel and Batavia in 1730.');
INSERT INTO "voyages" VALUES (2584, '', 4, '', 'D''UNO', 'Nikolaas van Langeveld', 250, 'fregat', '1707', NULL, NULL, 'Z', 'A', '1724-05-03', 'Texel', '1724-11-01', '1724-11-26', true, '1725-03-21', 'Batavia', 6650, 'At S. Tiago from 02-07 till 14-07-1724.');
INSERT INTO "voyages" VALUES (2585, '', 2, '', 'HAFTEN', 'Pieter Siebens', 600, 'fluit', '1717', NULL, NULL, 'A', 'E', '1724-05-27', 'Texel', '1724-10-06', '1724-11-02', true, '1725-01-21', 'Batavia', 6666, NULL);
INSERT INTO "voyages" VALUES (2586, '', 5, '', 'MEIJENBURG', 'Christiaan Daniels', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1724-06-01', 'Rammekens', '1724-10-21', '1724-11-17', true, '1725-01-21', 'Batavia', 6660, NULL);
INSERT INTO "voyages" VALUES (2587, '', 1, '', 'HOF NIET ALTIJD WINTER', 'Abraham van den Busse', 650, NULL, '1723', NULL, NULL, 'Z', 'Z', '1724-06-01', 'Rammekens', '1724-10-30', '1724-11-26', true, '1725-03-27', 'Batavia', 6733, NULL);
INSERT INTO "voyages" VALUES (2588, '', 4, '', 'BOEKENRODE', 'Klaas van Eik', 890, NULL, '1714', NULL, NULL, 'A', 'A', '1724-06-11', 'Texel', '1724-10-12', '1724-11-09', true, '1725-02-04', 'Batavia', 6638, NULL);
INSERT INTO "voyages" VALUES (2589, '', 1, '', 'HOGERSMILDE', 'Gerbrand Mamus', 810, NULL, '1723', NULL, NULL, 'A', 'A', '1724-06-11', 'Texel', '1724-10-12', '1724-11-09', true, '1725-02-03', 'Batavia', 6664, NULL);
INSERT INTO "voyages" VALUES (2590, '', 1, '', 'KARSENHOF', 'Herman de Vrij', 800, NULL, '1723', NULL, NULL, 'A', 'A', '1724-06-11', 'Texel', '1724-10-09', '1724-11-02', true, '1725-01-11', 'Batavia', 6659, NULL);
INSERT INTO "voyages" VALUES (2591, '', 1, '', 'LAND VAN BELOFTEN', 'Pieter Groothuis', 520, NULL, '1723', NULL, NULL, 'E', 'E', '1724-06-15', 'Texel', '1724-10-21', '1724-11-09', true, '1725-02-03', 'Batavia', 6730, NULL);
INSERT INTO "voyages" VALUES (2592, '', 2, '', 'CASTRICUM', 'Andries Pijl', 1150, NULL, '1722', NULL, NULL, 'A', 'A', '1724-09-16', 'Texel', '1725-01-28', '1725-02-20', true, '1725-05-15', 'Batavia', 6658, NULL);
INSERT INTO "voyages" VALUES (2593, '', 3, '', 'GEERTRUID', 'Thomas Fletcher', 600, 'fluit', '1717', NULL, NULL, 'E', 'A', '1724-09-16', 'Texel', '1725-02-03', '1725-02-28', true, '1725-06-02', 'Batavia', 6665, NULL);
INSERT INTO "voyages" VALUES (2594, '', 3, '', 'LOENDERVEEN', 'Hendrik Schalkenius', 650, 'fluit', '1718', NULL, NULL, 'A', 'H', '1724-09-16', 'Texel', '1725-02-03', '1725-02-24', true, '1725-06-02', 'Batavia', 6732, NULL);
INSERT INTO "voyages" VALUES (2595, '', 7, '', 'MUNDEN', 'Herman Klumper', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1724-10-18', 'Texel', '1725-03-20', '1725-04-10', true, '1725-06-28', 'Batavia', 6647, NULL);
INSERT INTO "voyages" VALUES (2596, '', 2, '', 'OOSTRUST', 'Laurens IJsenhart', 1140, NULL, '1721', NULL, NULL, 'A', 'A', '1724-10-18', 'Texel', '1725-03-08', '1725-03-23', true, '1725-06-24', 'Batavia', 6648, 'At Duins from 27-10 till 31-10-1724.');
INSERT INTO "voyages" VALUES (2597, '', 1, '', 'PALLAS', 'Pieter Timmerman', 650, NULL, '1723', NULL, NULL, 'A', 'A', '1724-10-18', 'Texel', '1725-03-25', '1725-04-29', true, '1725-08-15', 'Ceylon', 6706, NULL);
INSERT INTO "voyages" VALUES (2598, '', 4, '', 'WENDELA', 'Pieter Visser', 600, NULL, '1716', NULL, NULL, 'A', 'A', '1724-10-18', 'Texel', '1725-04-13', '1725-05-14', true, '1725-07-31', 'Batavia', NULL, 'At Duins from 28-10 till 01-11-1724. The ship was wrecked on the west coast of Sumatra on 25-02-1735.');
INSERT INTO "voyages" VALUES (2599, '', 4, '', 'SLOT ALDEGONDE', 'Hendrik van der Grippe', 1160, 'jacht', '1714', NULL, NULL, 'Z', 'Z', '1724-10-31', 'Rammekens', '1725-04-15', '1725-05-14', true, '1725-08-01', 'Batavia', 6685, NULL);
INSERT INTO "voyages" VALUES (2600, '', 1, '', 'SLOT TER HOGE', 'Steven Boghoute', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1724-10-31', 'Rammekens', NULL, NULL, true, NULL, NULL, NULL, 'The ship was wrecked at the island of Porto Santo on 19-11-1724.');
INSERT INTO "voyages" VALUES (2601, '', 5, '', 'HUIS TEN DONK', 'Theunis Brouisze', 650, NULL, '1711', NULL, NULL, 'R', 'R', '1724-12-24', 'Goeree', '1725-06-01', '1725-06-21', true, '1725-08-23', 'Batavia', 6656, NULL);
INSERT INTO "voyages" VALUES (2602, '', 4, '', 'AMSTERDAM', 'Mijndert Schut', 800, NULL, '1716', NULL, NULL, 'A', 'A', '1724-12-25', 'Texel', '1725-04-29', '1725-05-14', true, '1725-07-13', 'Batavia', 6645, 'From 22-01 till 03-02-1724 at Portsmouth.');
INSERT INTO "voyages" VALUES (2603, '', 3, '', 'DELFLAND', 'Pieter van Pavie', 600, 'fluit', '1717', NULL, NULL, 'D', 'D', '1724-12-25', 'Goeree', '1725-07-16', '1725-08-08', true, '1725-10-30', 'Batavia', 6655, 'From 06-01 till 27-03-1725 at the Shetlands.');
INSERT INTO "voyages" VALUES (2604, '', 5, '', 'ELISABETH', 'Gerrit Moring+', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1724-12-25', 'Texel', '1725-06-13', '1725-07-03', true, '1725-09-16', 'Batavia', 6662, 'From 13-01 till 28-01-1725 at Aldeburgh; from 02-02 till 05-03-1725 on the Thames. Gerrit Moring died, he was succeeded by Jan Schul.');
INSERT INTO "voyages" VALUES (2605, '', 1, '', 'FIJENOORD', 'Jan van der Quade', 160, 'brigantijn', NULL, NULL, NULL, 'R', 'R', '1724-12-25', 'Goeree', '1725-05-20', NULL, true, NULL, NULL, NULL, 'ship was wrecked at the Saldanha Bay on 1/2-07-1736.');
INSERT INTO "voyages" VALUES (2606, '', 3, '', 'MAGDALENA', 'Herman Branus', 600, NULL, '1719', NULL, NULL, 'H', 'H', '1724-12-25', 'Texel', '1725-09-21', '1725-10-18', true, '1726-01-25', 'Batavia', 6676, 'At Duins on 05-02-1725.');
INSERT INTO "voyages" VALUES (2607, '', 2, '', 'MIDLOO', 'Jan Loots', 800, NULL, '1719', NULL, NULL, 'A', 'A', '1724-12-25', 'Texel', '1725-09-11', '1725-10-10', true, '1726-01-22', 'Ceylon', 6726, NULL);
INSERT INTO "voyages" VALUES (2608, '', 1, '', 'VICTORIA', 'Jakob Groot', 160, NULL, '1724', NULL, NULL, 'H', 'H', '1724-12-25', 'Texel', '1725-06-12', NULL, true, NULL, NULL, NULL, 'At Duins on 05-02-1725. Wrecked at the Cape on 21-05-1737.');
INSERT INTO "voyages" VALUES (2609, '', 1, '', 'AKERENDAM', 'Nikolaas de Roy', 850, NULL, '1724', NULL, NULL, 'A', 'A', '1725-01-19', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked at the island of Rondoe, at the coast of Norway on 08-03-1725.');
INSERT INTO "voyages" VALUES (2610, '', 1, '', 'GAASPERDAM', 'Bastiaan Schul', 1150, NULL, '1724', NULL, NULL, 'A', 'A', '1725-01-19', 'Texel', '1725-08-11', '1725-09-14', true, '1725-12-01', 'Batavia', 6693, 'At Portsmouth from 21-03 till 11-04-1725; 3 seafarers and 1 soldier ran away.');
INSERT INTO "voyages" VALUES (2611, '', 5, '', 'KOCKENGEN', 'Albert Bovet', 824, NULL, '1711', NULL, NULL, 'A', 'A', '1725-01-19', 'Texel', '1725-08-11', '1725-09-14', true, '1725-11-22', 'Batavia', 6667, NULL);
INSERT INTO "voyages" VALUES (2612, '', 3, '', 'WITSBURG', 'IJpe Engelsman', 520, 'fluit', '1714', NULL, NULL, 'E', 'E', '1725-01-19', 'Texel', '1725-09-21', '1725-10-18', true, '1726-01-25', 'Batavia', 6719, '18-05-1725.');
INSERT INTO "voyages" VALUES (2613, '', 1, '', 'EVERSWAART', 'Willem de Keizer', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1725-02-03', 'Rammekens', '1725-05-18', '1725-06-03', true, '1725-07-31', 'Batavia', 6663, 'At Portsmouth from 07-02 till 10-02-1725.');
INSERT INTO "voyages" VALUES (2614, '', 2, '', 'ZOETELINGSKERKE', 'Jakob de Vries', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1725-02-03', 'Rammekens', '1725-05-18', '1725-06-06', true, '1725-08-09', 'Batavia', 6653, NULL);
INSERT INTO "voyages" VALUES (2615, '', 2, '', 'NIEUWVLIET', 'Jan Boot', 650, NULL, '1719', NULL, NULL, 'Z', 'Z', '1725-03-19', 'Rammekens', '1725-07-24', '1725-09-14', true, '1725-11-22', 'Batavia', 6668, NULL);
INSERT INTO "voyages" VALUES (2616, '', 4, '', 'RIJKSDORP', 'Jan van Est', 792, NULL, '1713', NULL, NULL, 'A', 'Z', '1725-03-19', 'Rammekens', '1725-07-28', '1725-09-14', true, '1725-11-16', 'Batavia', 6677, NULL);
INSERT INTO "voyages" VALUES (2617, '', 2, '', 'PATMOS', 'Gerrit van Wezel', 810, NULL, '1722', NULL, NULL, 'R', 'R', '1725-04-11', 'Goeree', '1725-07-27', '1725-08-10', true, '1725-10-14', 'Batavia', 6649, NULL);
INSERT INTO "voyages" VALUES (2618, '', 4, '', 'SPIERING', 'Jakob van der Poel', 810, NULL, '1714', NULL, NULL, 'D', 'D', '1725-04-25', 'Goeree', '1725-08-22', '1725-09-14', true, '1725-12-15', 'Batavia', 6699, NULL);
INSERT INTO "voyages" VALUES (2619, '', 1, '', 'SPIERINGSHOEK', 'Abraham van Bodegem', 450, 'jacht', '1724', NULL, NULL, 'D', 'D', '1725-04-25', 'Goeree', '1725-08-17', '1725-09-14', true, '1725-12-15', 'Batavia', 6775, 'succeeded by Jan Simonsz. Afslager.');
INSERT INTO "voyages" VALUES (2620, '', 5, '', 'STRIJKEBOLLE', 'Jan Bloemendaal', 540, 'fluit', '1712', NULL, NULL, 'E', 'E', '1725-05-18', 'Texel', '1725-09-21', '1725-10-18', true, '1726-01-11', 'Batavia', 6718, NULL);
INSERT INTO "voyages" VALUES (2621, '', 5, '', 'HUIS DE VLOTTER', 'Klaas Zeeridder', 528, 'fluit', '1713', NULL, NULL, 'A', 'H', '1725-05-18', 'Texel', '1725-09-21', '1725-10-18', true, '1726-01-24', 'Batavia', 6705, NULL);
INSERT INTO "voyages" VALUES (2622, '', 1, '', 'AAGTEKERKE', 'Jan Witboom', 850, NULL, '1724', NULL, NULL, 'Z', 'Z', '1725-05-27', 'Rammekens', '1726-01-03', '1726-01-27', true, NULL, NULL, NULL, 'The ship was lost between the Cape and Batavia.');
INSERT INTO "voyages" VALUES (2623, '', 2, '', 'RAVESTEIN', 'Anthonie Klink', 800, NULL, '1719', NULL, NULL, 'Z', 'Z', '1725-05-27', 'Rammekens', '1725-12-09', '1726-01-08', true, NULL, NULL, NULL, 'The ship was lost at one of the Maldive Islands on 08-05-1726. The cargo was saved.');
INSERT INTO "voyages" VALUES (2624, '', 2, '', 'STABROEK', 'David Kleeman', 900, NULL, '1722', NULL, NULL, 'A', 'A', '1725-05-30', 'Texel', '1725-10-23', '1725-11-19', true, '1726-02-21', 'Ceylon', 6690, NULL);
INSERT INTO "voyages" VALUES (2625, '', 3, '', 'STEENHOVEN', 'Gelijn de Haas', 850, NULL, '1718', NULL, NULL, 'Z', 'A', '1725-05-30', 'Texel', '1726-02-18', '1726-03-27', true, '1726-06-30', 'Batavia', 6679, 'From 10-12-1725 till 07-02-1726 at the Saldanha Bay.');
INSERT INTO "voyages" VALUES (2626, '', 1, '', 'SCHUITWIJK', 'Jakob Visser', 650, NULL, '1724', NULL, NULL, 'E', 'E', '1725-06-05', 'Texel', '1725-12-12', '1726-01-08', true, '1726-04-24', 'Batavia', 6704, 'Islands.');
INSERT INTO "voyages" VALUES (2627, '', 1, '', 'BEEKVLIET', 'Jan de Koning', 850, NULL, '1724', NULL, NULL, 'A', 'A', '1725-06-30', 'Texel', '1726-02-18', '1726-03-27', true, '1726-06-30', 'Batavia', 6746, 'At the Saldanha Bay from 10-12-1725 till 04-02-1726. 1 Seafarer became a soldier.');
INSERT INTO "voyages" VALUES (2628, '', 2, '', 'KLARABEEK', 'Daniel van Staden', 705, NULL, '1721', NULL, NULL, 'Z', 'A', '1725-06-30', 'Texel', '1726-02-18', '1726-03-27', true, '1726-06-30', 'Batavia', 6751, 'At the Saldanha Bay from 10-12-1725 till 04-02-1726.');
INSERT INTO "voyages" VALUES (2629, '', 2, '', 'WESTFRIESLAND', 'Jan Simonsz. Afslager', 370, 'jacht', '1722', NULL, NULL, 'H', 'A', '1725-06-30', 'Texel', '1725-12-12', '1726-01-27', true, '1726-05-27', 'Batavia', 6729, 'At the Cape the master changed places with the master of the SPIERINGSHOEK (2619) Abraham van Bodegem.');
INSERT INTO "voyages" VALUES (2630, '', 2, '', 'ASTREA', 'Jakob Thoom', 800, NULL, '1720', NULL, NULL, 'D', 'A', '1725-09-30', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Plymouth on 09-10-1725.');
INSERT INTO "voyages" VALUES (2631, '', 2, '', 'HEESBURG', 'Tijmen Mol', 850, NULL, '1720', NULL, NULL, 'A', 'A', '1725-09-30', 'Texel', '1726-02-04', '1726-02-20', true, '1726-05-19', 'Batavia', 6688, 'One soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2632, '', 4, '', 'LINSCHOTEN', 'Adriaan van Leeuwen', 804, NULL, '1714', NULL, NULL, 'A', 'A', '1725-09-30', 'Texel', '1726-02-07', '1726-03-04', true, '1726-05-19', 'Batavia', 6689, 'From 10-10 till 21-10-1725 at Plymouth; 2 seafarers ran away.');
INSERT INTO "voyages" VALUES (2633, '', 2, '', 'SUSANNA', 'Adam van Ingen', 600, NULL, '1721', NULL, NULL, 'A', 'A', '1725-09-30', 'Texel', '1726-02-05', '1726-03-21', true, '1726-06-23', 'Batavia', 6707, 'From 09-10 till 21-10-1725 at Plymouth. 4 Seafarers boarded and 2 seafarers ran away.');
INSERT INTO "voyages" VALUES (2634, '', 1, '', 'VELSERBEEK', 'Kornelis Kerkhoven', 650, NULL, '1724', NULL, NULL, 'A', 'A', '1725-09-30', 'Texel', '1726-02-05', '1726-02-20', true, '1726-05-21', 'Batavia', NULL, 'At Plymouth from 09-10 till 21-10-1725. The ship was lost between Padang and Bengal in 1727.');
INSERT INTO "voyages" VALUES (2635, '', 6, '', 'WESTERDIJKSHORN', 'Willem de Leus', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1725-09-30', 'Texel', '1726-02-05', '1726-03-04', true, '1726-05-19', 'Batavia', 6682, 'At Plymouth from 09-10 till 21-10-1725.');
INSERT INTO "voyages" VALUES (2636, '', 2, '', 'ADELAAR', 'Jan Vrijdag', 810, NULL, '1722', NULL, NULL, 'Z', 'Z', '1725-10-01', 'Rammekens', '1726-01-31', '1726-02-15', true, '1726-04-24', 'Batavia', NULL, 'At Portsmouth from 10-10 till 21-10-1725. One seafarer ran away.');
INSERT INTO "voyages" VALUES (2637, '', 1, '', '''S HEER ARENDSKERKE', 'Gerrit Stokke', 600, NULL, '1724', NULL, NULL, 'Z', 'Z', '1725-10-01', 'Rammekens', '1726-01-31', '1726-02-15', true, '1726-04-26', 'Batavia', 6778, 'At Portsmouth from 10-10 till 21-10-1725.');
INSERT INTO "voyages" VALUES (2638, '', 4, '', 'BORSSELE', 'Pieter van den Berg', 800, NULL, '1715', NULL, NULL, 'Z', 'Z', '1725-10-01', 'Rammekens', '1726-01-31', '1726-02-15', true, '1726-05-21', 'Batavia', 6686, 'At Portsmouth from 10-10 till 21-10-1725.');
INSERT INTO "voyages" VALUES (2639, '', 4, '', 'OPPERDOES', 'Albert Orangie', 600, 'fluit', '1718', NULL, NULL, 'H', 'H', '1725-10-17', 'Texel', '1726-01-23', '1726-02-09', true, '1726-05-19', 'Batavia', 6822, 'Two soldiers became seafarers.');
INSERT INTO "voyages" VALUES (2640, '', 3, '', 'GOUDRIAAN', 'Willem Staalman', 630, 'fluit', '1719', NULL, NULL, 'D', 'D', '1725-10-18', 'Goeree', '1726-02-25', '1726-03-11', true, '1726-06-03', 'Batavia', 6673, NULL);
INSERT INTO "voyages" VALUES (2641, '', 5, '', 'GROENSWAART', 'Kornelis Rees', 600, 'fluit', '1714', NULL, NULL, 'R', 'R', '1725-10-18', 'Goeree', '1726-02-18', '1726-03-10', true, '1726-05-29', 'Batavia', 6674, NULL);
INSERT INTO "voyages" VALUES (2642, '', 3, '', 'VIS', 'Jan Schaap', 600, 'fluit', '1716', NULL, NULL, 'E', 'E', '1725-10-30', 'Texel', '1726-04-09', '1726-04-30', true, '1726-08-17', 'Batavia', 6680, NULL);
INSERT INTO "voyages" VALUES (2643, '', 2, '', 'LANGERODE', 'Jakob van der Swet', 600, NULL, '1723', NULL, NULL, 'D', 'D', '1726-01-12', 'Goeree', '1726-04-16', '1726-04-30', true, '1726-07-02', 'Batavia', 6703, NULL);
INSERT INTO "voyages" VALUES (2644, '', 2, '', 'BERKENRODE', 'David Brouwer', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1726-01-15', 'Texel', '1726-04-20', '1726-05-16', true, '1726-07-30', 'Batavia', 6691, NULL);
INSERT INTO "voyages" VALUES (2645, '', 5, '', 'DOORNIK', 'Willem Koy', 830, NULL, '1709', NULL, NULL, 'A', 'A', '1726-01-15', 'Texel', '1726-04-23', '1726-05-16', true, '1726-08-04', 'Ceylon', NULL, 'The ship was laid up at Batavia in 1735.');
INSERT INTO "voyages" VALUES (2646, '', 2, '', '''S GRAVELAND', 'Gideon Kuiper', 600, NULL, '1722', NULL, NULL, 'A', 'A', '1726-01-15', 'Texel', '1726-04-29', '1726-05-28', true, '1726-07-30', 'Batavia', 6755, NULL);
INSERT INTO "voyages" VALUES (2647, '', 2, '', 'HAARLEM', 'Jochem Thijssen', 850, NULL, '1720', NULL, NULL, 'A', 'A', '1726-01-15', 'Texel', '1726-04-16', '1726-04-30', true, '1725-06-22', 'Ceylon', 6687, NULL);
INSERT INTO "voyages" VALUES (2648, '', 1, '', 'LANDSKROON', 'Simon de Groot', 850, NULL, '1725', NULL, NULL, 'A', 'A', '1726-01-15', 'Texel', '1726-04-16', '1726-04-30', true, '1726-07-16', 'Batavia', 6675, NULL);
INSERT INTO "voyages" VALUES (2649, '', 4, '', 'STAD LEIDEN', 'Elias Wargaren', 1140, NULL, '1718', NULL, NULL, 'A', 'A', '1726-01-15', 'Texel', '1726-04-23', '1726-05-16', true, '1726-07-29', 'Batavia', 6694, NULL);
INSERT INTO "voyages" VALUES (2650, '', 4, '', 'MARGARETA', 'Jan Kous', 600, 'fluit', '1715', NULL, NULL, 'E', 'E', '1726-01-15', 'Texel', '1726-04-26', '1726-05-16', true, '1726-07-29', 'Batavia', NULL, 'The ship was wrecked in Asia in 1733.');
INSERT INTO "voyages" VALUES (2651, '', 3, '', 'STADWIJK', 'Marten Harting', 1150, NULL, '1720', NULL, NULL, 'A', 'A', '1726-01-15', 'Texel', '1726-04-07', '1726-04-26', true, '1726-06-23', 'Batavia', 6678, NULL);
INSERT INTO "voyages" VALUES (2652, '', 3, '', 'HEINKENSZAND', 'Hendrik Fret', 1150, NULL, '1720', NULL, NULL, 'Z', 'Z', '1726-01-17', 'Rammekens', '1726-04-28', '1726-05-16', true, '1726-07-30', 'Batavia', 6696, NULL);
INSERT INTO "voyages" VALUES (2653, '', 5, '', 'MIDDELWOUD', 'Joost Nose', 804, NULL, '1712', NULL, NULL, 'Z', 'Z', '1726-01-17', 'Rammekens', '1726-05-26', '1726-06-14', true, '1726-08-17', 'Batavia', 6725, 'From 29-01 till 24-02-1726 at Plymouth; one seafarer ran away.');
INSERT INTO "voyages" VALUES (2654, '', 3, '', 'HOF NIET ALTIJD ZOMER', 'Pieter van de Roete', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1726-01-17', 'Rammekens', '1726-04-30', '1726-05-16', true, '1726-07-30', 'Batavia', 6684, NULL);
INSERT INTO "voyages" VALUES (2655, '', 2, '', 'CORNELIA', 'Marinus Commerse', 800, NULL, '1721', NULL, NULL, 'H', 'Z', '1726-04-05', 'Rammekens', '1726-07-18', '1726-08-05', true, '1726-10-07', 'Batavia', 6695, NULL);
INSERT INTO "voyages" VALUES (2656, '', 2, '', 'WICKENBURG', 'Adriaan Hijpe', 850, NULL, '1722', NULL, NULL, 'Z', 'Z', '1726-04-05', 'Rammekens', '1726-07-18', '1726-08-05', true, '1726-10-09', 'Batavia', 6700, NULL);
INSERT INTO "voyages" VALUES (2657, '', 3, '', 'NOORDWADDINXVEEN', 'Arie Schutter', 850, NULL, '1718', NULL, NULL, 'R', 'R', '1726-04-21', 'Goeree', '1726-08-31', '1726-09-19', true, '1726-12-20', 'Batavia', 6740, NULL);
INSERT INTO "voyages" VALUES (2658, '', 2, '', 'HERSTELLING', 'Jan Moerman', 600, NULL, '1721', NULL, NULL, 'D', 'D', '1726-04-22', 'Goeree', '1726-08-13', '1726-08-28', true, '1726-10-21', 'Batavia', 6697, NULL);
INSERT INTO "voyages" VALUES (2659, '', 3, '', 'HILLEGONDA', 'Albert Visser', 850, NULL, '1720', NULL, NULL, 'H', 'H', '1726-04-22', 'Texel', '1726-08-12', '1726-08-28', true, '1726-10-25', 'Batavia', 6698, NULL);
INSERT INTO "voyages" VALUES (2660, '', 5, '', 'JOHANNA', 'Klaas Jonker', 550, 'fluit', '1714', NULL, NULL, 'A', 'E', '1726-05-06', 'Texel', '1726-08-31', '1726-09-19', true, '1726-12-22', 'Batavia', 6724, NULL);
INSERT INTO "voyages" VALUES (2661, '', 7, '', 'BERBICES', 'Jakob Onkruid', 1136, NULL, '1709', NULL, NULL, 'A', 'A', '1726-05-15', 'Texel', '1726-10-22', '1726-11-19', true, '1727-02-19', 'Batavia', NULL, 'From 18-06 till 24-06 at S. Tiago. Laid up in Asia in 1734.');
INSERT INTO "voyages" VALUES (2662, '', 3, '', 'JACOBA', 'Jan van der Heiden', 805, NULL, '1721', NULL, NULL, 'A', 'A', '1726-05-15', 'Texel', '1726-10-21', '1726-11-18', true, '1727-01-23', 'Batavia', 6731, 'At S. Tiago from 17-06 till 24-06-1726.');
INSERT INTO "voyages" VALUES (2663, '', 4, '', 'KOMMERRUST', 'Pieter Verley', 810, NULL, '1718', NULL, NULL, 'A', 'A', '1726-05-15', 'Texel', '1726-10-20', '1726-11-06', true, '1727-01-22', 'Batavia', 6720, 'from 18-06 till 24-06-1726.');
INSERT INTO "voyages" VALUES (2664, '', 1, '', 'MEERLUST', 'Pieter Scherf', 600, NULL, '1725', NULL, NULL, 'A', 'A', '1726-05-15', 'Texel', '1726-10-21', '1726-11-19', true, '1727-03-05', 'Batavia', 6734, '24-06-1726');
INSERT INTO "voyages" VALUES (2665, '', 2, '', 'WINDHOND', 'Kornelis Oterlijk', 370, NULL, '1722', NULL, NULL, 'A', 'A', '1726-05-15', 'Texel', '1726-10-30', '1726-11-18', true, '1727-01-23', 'Batavia', 6754, 'At S. Tiago from 18-06 till 24-06-1726.');
INSERT INTO "voyages" VALUES (2666, '', 2, '', 'BLIJDORP', 'Jan Krielaard', 900, NULL, '1723', NULL, NULL, 'R', 'R', '1726-11-06', 'Goeree', '1727-04-13', '1727-05-01', true, '1727-07-16', 'Batavia', 6735, NULL);
INSERT INTO "voyages" VALUES (2667, '', 5, '', 'TER HORST', 'Kornelis van der Kolster', 520, 'fluit', '1712', NULL, NULL, 'D', 'D', '1726-11-06', 'Goeree', '1727-04-08', '1727-05-01', true, '1727-07-29', 'Batavia', 6713, NULL);
INSERT INTO "voyages" VALUES (2668, '', 3, '', 'HUIS TE ASSENBURG', 'Laurens Usenhart', 800, NULL, '1718', NULL, NULL, 'A', 'A', '1726-11-07', 'Texel', '1727-03-16', '1727-04-03', true, '1727-06-22', 'Batavia', 6723, 'At Duins from 09-11 till 23-11-1726.');
INSERT INTO "voyages" VALUES (2669, '', 4, '', 'BARBESTEIN', 'Joris Vermouwe', 1100, NULL, '1717', NULL, NULL, 'Z', 'Z', '1726-11-07', 'Rammekens', '1727-03-18', '1727-04-19', true, '1727-07-11', 'Batavia', 6708, 'At Duins from 09-11 till 23-11-1726.');
INSERT INTO "voyages" VALUES (2670, '', 5, '', 'BOEKENRODE', 'Mijndert Schut', 890, NULL, '1714', NULL, NULL, 'A', 'A', '1726-11-07', 'Texel', '1727-06-27', '1727-08-09', true, '1727-10-18', 'Batavia', NULL, 'From 21-11 till 30-01-1727 at Goeree; from 10-03 till 27-03-1727 at S. Tiago. 8 Seafarers ran away. Laid up at Batavia in 1734.');
INSERT INTO "voyages" VALUES (2671, '', 2, '', 'EVERSWAART', 'Dirk de Visser', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1726-11-07', 'Rammekens', '1727-04-18', '1727-05-08', true, '1727-07-16', 'Batavia', 6748, 'From 09-01 till 17-01-1727 at S. Tiago. One seafarer ran away.');
INSERT INTO "voyages" VALUES (2672, '', 4, '', 'HOGENES', 'Bartholomeus Teerling', 870, NULL, '1716', NULL, NULL, 'Z', 'Z', '1726-11-07', 'Rammekens', '1727-04-13', '1727-05-16', true, '1727-07-16', 'Batavia', 6711, 'Back at Rammekens from 09-11 till 23-11-1726. At S. Tiago from 09-01 till 17-01-1727.');
INSERT INTO "voyages" VALUES (2673, '', 3, '', 'HOPVOGEL', 'Dirk de Vet', 600, 'fluit', '1714', NULL, NULL, 'A', 'H', '1726-11-07', 'Texel', '1727-04-27', '1727-05-16', true, '1727-08-03', 'Batavia', 6712, 'From 21-11 till 28-11-1726 back at Texel; at Portsmouth from 05-12 till 19-12-1726. One soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2674, '', 2, '', 'KARSENHOF', 'Jan Diephout', 800, NULL, '1723', NULL, NULL, 'A', 'A', '1726-11-07', 'Texel', '1727-04-17', '1727-05-16', true, '1727-07-24', 'Batavia', 6728, 'Back at Texel from 21-11 till 28-11-1726. At Portsmouth from 05-12 till 19-12-1726.');
INSERT INTO "voyages" VALUES (2675, '', 2, '', 'KETEL', 'Jakob Thoom', 810, NULL, '1721', NULL, NULL, 'R', 'A', '1726-11-07', 'Texel', '1727-04-16', '1727-05-16', true, '1727-07-24', 'Batavia', 6714, 'From 21-11 till 28-11-1726 back at Texel; 4 seafarers ran away and one soldier became a seafarer. At Portsmouth from 05-12 till 19-12-1726.');
INSERT INTO "voyages" VALUES (2676, '', 5, '', 'OUDENAARDE', 'Isaak Hage', 858, NULL, '1708', NULL, NULL, 'A', 'A', '1726-11-07', 'Texel', '1727-03-09', '1727-03-28', true, '1727-06-22', 'Batavia', NULL, 'Laid up at Batavia in 1734.');
INSERT INTO "voyages" VALUES (2677, '', 2, '', 'PETRONELLA ALIDA', 'Hendrik Cente', 550, NULL, '1722', NULL, NULL, 'E', 'A', '1726-11-07', 'Texel', '1727-04-09', '1727-05-16', true, '1727-07-29', 'Batavia', 6800, 'From 19-11 till 23-11-1726 at Duins.');
INSERT INTO "voyages" VALUES (2678, '', 1, '', 'LAGS POLDER', 'Hendrik Vegt', 580, NULL, '1725', NULL, NULL, 'E', 'E', '1726-11-07', 'Texel', '1727-04-17', '1727-05-16', true, '1727-08-03', 'Batavia', 6741, 'From 21-11 till 28-11-1726 back at Texel. At Portsmouth from 05-12 till 19-12-1726.');
INSERT INTO "voyages" VALUES (2679, '', 5, '', 'PRATTENBURG', 'Hendrik Thieling', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1726-11-07', 'Texel', '1727-04-16', '1727-05-16', true, '1727-07-24', 'Batavia', 6717, 'Back at Texel from 21-11 till 28-11-1726. From 05-12 till 19-12-1726 at Portsmouth.');
INSERT INTO "voyages" VALUES (2680, '', 1, '', 'ZEEWIJK', 'Jan Steins', 850, NULL, '1725', NULL, NULL, 'Z', 'Z', '1726-11-07', 'Rammekens', '1727-03-26', '1727-04-21', true, NULL, NULL, NULL, '30-04-1728 with the complete cargo. (See H. Edwards.)');
INSERT INTO "voyages" VALUES (2681, '', 3, '', 'ANNA MARIA', 'Dirk van Zanen', 600, NULL, '1717', NULL, NULL, 'Z', 'E', '1727-01-14', 'Texel', '1727-05-09', '1727-05-23', true, '1727-07-22', 'Batavia', NULL, 'till 30-01-1727. Laid up at Batavia in 1734.');
INSERT INTO "voyages" VALUES (2682, '', 3, '', 'PATMOS', 'Erasmus Schuit', 810, NULL, '1722', NULL, NULL, 'R', 'H', '1727-01-14', 'Texel', '1727-05-10', '1727-05-23', true, '1727-07-24', 'Batavia', 6716, NULL);
INSERT INTO "voyages" VALUES (2683, '', 5, '', 'D''UNO', 'Hendrik van den Berg', 250, 'fregat', '1707', NULL, NULL, 'Z', 'A', '1727-01-29', 'Texel', '1727-05-11', '1727-05-22', true, '1727-08-03', 'Batavia', NULL, 'Laid up at Batavia on 13-03-1723.');
INSERT INTO "voyages" VALUES (2684, '', 1, '', 'ADRICHEM', 'Huig Bredero', 850, NULL, '1726', NULL, NULL, 'A', 'A', '1727-01-30', 'Texel', '1727-05-15', '1727-06-02', true, '1727-11-02', 'Batavia', 6802, NULL);
INSERT INTO "voyages" VALUES (2685, '', 3, '', 'CASTRICUM', 'Jan Schul', 1150, NULL, '1722', NULL, NULL, 'A', 'A', '1727-01-30', 'Texel', '1727-04-21', '1727-05-16', true, '1727-07-16', 'Batavia', 6709, NULL);
INSERT INTO "voyages" VALUES (2686, '', 2, '', 'HOGERSMILDE', 'Daniel Overbeek', 810, NULL, '1723', NULL, NULL, 'A', 'A', '1727-01-30', 'Texel', '1727-05-19', '1727-06-05', true, '1727-08-24', 'Ceylon', 6750, NULL);
INSERT INTO "voyages" VALUES (2687, '', 2, '', 'KROOSWIJK', 'Gerrit van Wezel', 600, 'fluit', '1720', NULL, NULL, 'R', 'R', '1727-01-30', 'Goeree', '1727-07-04', '1727-07-21', true, '1727-11-12', 'Batavia', 6757, 'At S. Tiago from 10-03 till 27-03-1727.');
INSERT INTO "voyages" VALUES (2688, '', 8, '', 'MUNDEN', 'Jan Almees', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1727-01-30', 'Texel', '1727-05-12', '1727-06-12', true, '1727-08-11', 'Batavia', 6715, NULL);
INSERT INTO "voyages" VALUES (2689, '', 7, '', 'NOORDBEEK', 'Herman Brand', 858, NULL, '1707', NULL, NULL, 'Z', 'Z', '1727-01-30', 'Rammekens', '1727-05-03', '1727-05-22', true, '1727-08-08', 'Batavia', NULL, 'Lost between Ternate and Bima in 1730.');
INSERT INTO "voyages" VALUES (2690, '', 3, '', 'OOSTRUST', 'Thomas Fletcher', 1140, NULL, '1721', NULL, NULL, 'A', 'A', '1727-01-30', 'Texel', '1727-06-28', '1727-07-20', true, '1727-10-05', 'Batavia', 6721, 'At S. Tiago from 10-03 till 27-03-1727.');
INSERT INTO "voyages" VALUES (2691, '', 1, '', 'REIGERSBROEK', 'Kornelis Klaasz.', 600, NULL, '1726', NULL, NULL, 'A', 'A', '1727-01-30', 'Texel', '1727-05-13', '1727-05-22', true, '1727-08-03', 'Batavia', 6760, NULL);
INSERT INTO "voyages" VALUES (2692, '', 4, '', 'SAMARITAAN', 'Willem Sempel', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1727-01-30', 'Rammekens', '1727-05-15', '1727-06-05', true, '1727-09-01', 'Batavia', NULL, 'On 21-05-1729 wrecked at the coast of Malabar.');
INSERT INTO "voyages" VALUES (2693, '', 3, '', 'ZOETELINGSKERKE', 'Kornelis Fret', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1727-01-30', 'Rammekens', '1727-05-12', '1727-06-02', true, '1727-08-08', 'Batavia', 6722, NULL);
INSERT INTO "voyages" VALUES (2694, '', 1, '', 'ALBLASSERDAM', 'Arie Jansz. Verduin', 600, NULL, '1725', NULL, NULL, 'D', 'D', '1727-04-04', 'Goeree', '1727-08-05', '1727-08-22', true, '1727-10-25', 'Batavia', 6803, NULL);
INSERT INTO "voyages" VALUES (2695, '', 1, '', 'RIDDERKERK', 'Jan de Graaf', 500, NULL, '1726', NULL, NULL, 'R', 'R', '1727-04-04', 'Goeree', '1727-08-05', '1727-08-16', true, '1727-10-30', 'Batavia', 6761, NULL);
INSERT INTO "voyages" VALUES (2696, '', 1, '', 'BINNENWIJZEND', 'Jakob Klotendraaier', 500, NULL, '1726', NULL, NULL, 'H', 'H', '1727-05-01', 'Texel', '1727-09-05', '1727-09-17', true, '1721-11-15', 'Batavia', 6952, NULL);
INSERT INTO "voyages" VALUES (2697, '', 5, '', 'VALKENISSE', 'Jan Bogaard', 1150, NULL, '1716', NULL, NULL, 'Z', 'Z', '1727-05-01', 'Rammekens', '1727-09-23', '1727-10-20', true, '1728-01-22', 'Ceylon', 6742, NULL);
INSERT INTO "voyages" VALUES (2698, '', 2, '', 'KASTEEL VAN WOERDEN', 'Jonas Mierman', 850, NULL, '1722', NULL, NULL, 'D', 'Z', '1727-05-01', 'Rammekens', '1727-09-23', '1727-10-16', true, '1728-01-07', 'Batavia', 6788, 'At S. Tiago from 16-06 till 22-06-1727.');
INSERT INTO "voyages" VALUES (2699, '', 3, '', 'HAAKSBURG', 'Adriaan van den Berg', 600, NULL, '1718', NULL, NULL, 'E', 'E', '1727-05-23', 'Texel', '1727-10-31', '1727-11-19', true, '1728-01-25', 'Batavia', 6756, 'At Torbay from 05-06 till 15-06-1727.');
INSERT INTO "voyages" VALUES (2700, '', 5, '', 'AMSTERDAM', 'Jakob Kooimans', 800, NULL, '1716', NULL, NULL, 'A', 'A', '1727-05-26', 'Texel', '1727-09-23', '1727-10-15', true, '1728-01-11', 'Batavia', 6792, 'From 05-06 till 15-06-1727 at Torbay. 2 Soldiers became seafarers.');
INSERT INTO "voyages" VALUES (2701, '', 6, '', 'ELISABETH', 'Gerbrand Mamus', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1727-05-26', 'Texel', '1727-09-19', '1727-10-16', true, '1727-12-21', 'Batavia', 6747, 'From 04-06 till 14-06-1727 at Torbay. 1 Soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2702, '', 6, '', 'KOCKENGEN', 'Matthijs Pingstemakel', 824, NULL, '1711', NULL, NULL, 'A', 'A', '1727-05-26', 'Texel', '1727-09-24', '1727-10-15', true, '1728-01-06', 'Batavia', NULL, 'From 05-06 till 15-06-1727 at Torbay. Laip up at Batavia in 1733.');
INSERT INTO "voyages" VALUES (2703, '', 7, '', 'NOORDERKWARTIER', 'Klaas Valk', 550, NULL, '1709', NULL, NULL, 'H', 'A', '1727-05-29', 'Texel', '1727-11-09', '1727-12-09', true, '1728-03-18', 'Batavia', NULL, 'Laid up at Batavia in 1735.');
INSERT INTO "voyages" VALUES (2704, '', 4, '', 'DEN DAM', 'Jan Moerman', 600, 'fluit', '1716', NULL, NULL, 'D', 'D', '1727-11-02', 'Goeree', '1728-05-02', '1728-05-26', true, '1728-08-14', 'Batavia', 6737, 'At Duins from 05-12 till 09-12-1727. 10 Seafarers ran away.');
INSERT INTO "voyages" VALUES (2705, '', 6, '', 'HUIS TEN DONK', 'Arie Brouwer', 650, NULL, '1711', NULL, NULL, 'R', 'R', '1727-11-02', 'Goeree', '1728-04-28', '1728-05-17', true, '1728-08-11', 'Batavia', 6780, 'At Duins from 05-11 till 26-11-1727. 2 Soldiers became seafarers.');
INSERT INTO "voyages" VALUES (2706, '', 3, '', 'HAFTEN', 'Hendrik Smit', 600, 'fluit', '1717', NULL, NULL, 'A', 'A', '1727-11-02', 'Texel', '1728-04-19', '1728-05-26', true, '1728-08-13', 'Batavia', 6739, 'From 17-11 till 10-12-1727 at Portsmouth. One seafarer ran away.');
INSERT INTO "voyages" VALUES (2707, '', 1, '', 'SLOT TER HOGE', 'Jakob de Vries', 850, NULL, '1726', NULL, NULL, 'Z', 'Z', '1727-11-02', 'Rammekens', '1728-04-19', '1728-06-14', true, '1728-09-02', 'Batavia', 6809, 'At Duins from 05-11 till 26-11-1727.');
INSERT INTO "voyages" VALUES (2708, '', 2, '', 'LANDSKROON', 'Willem Verbeek', 850, NULL, '1725', NULL, NULL, 'A', 'A', '1727-11-02', 'Texel', '1728-04-19', '1728-05-17', true, '1728-07-26', 'Batavia', 6752, 'At Portsmouth from 21-11 till 11-12-1727. Two seafarers ran away.');
INSERT INTO "voyages" VALUES (2709, '', 5, '', 'LUCHTENBURG', 'Adriaan van Leeuwen', 800, NULL, '1715', NULL, NULL, 'H', 'A', '1727-11-02', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked at the Wielingen on 17-11-1727.');
INSERT INTO "voyages" VALUES (2710, '', 3, '', 'PURMERLUST', 'Michiel Reus', 580, NULL, '1718', NULL, NULL, 'A', 'H', '1727-11-02', 'Texel', '1728-02-22', '1728-03-19', true, '1728-07-10', 'Batavia', 6759, NULL);
INSERT INTO "voyages" VALUES (2711, '', 2, '', 'SAKSENBURG', 'Jan de Haan', 610, NULL, '1723', NULL, NULL, 'A', 'A', '1727-11-02', 'Texel', '1728-04-21', '1728-05-26', true, '1728-08-12', 'Batavia', NULL, 'From 17-11 till 23-11-1727 at Torbay. The was ship wrecked near Cape Agulhas on 08-01-1730.');
INSERT INTO "voyages" VALUES (2712, '', 2, '', 'WESTERBEEK', 'Herman de Vrij', 650, NULL, '1722', NULL, NULL, 'A', 'A', '1727-11-02', 'Texel', '1728-04-19', '1728-05-17', true, '1728-08-08', 'Batavia', 6743, 'At Duins from 09-11 till 24-11-1727. Two soldiers became seafarers.');
INSERT INTO "voyages" VALUES (2713, '', 7, '', 'WESTERDIJKSHORN', 'Willem de Leus+', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1727-11-02', 'Texel', '1728-04-19', '1728-05-17', true, '1728-07-22', 'Batavia', 6744, 'The master died; he was succeeded by Dirk Groengracht. From 28-11 till 10-12-1727 at Portsmouth.');
INSERT INTO "voyages" VALUES (2714, '', 3, '', 'WICKENBURG', 'Jan van Est', 850, NULL, '1722', NULL, NULL, 'Z', 'Z', '1727-11-02', 'Rammekens', '1728-04-28', '1728-06-14', true, '1728-08-26', 'Batavia', 6745, 'At Portsmouth from 21-11 till 10-12-1727.');
INSERT INTO "voyages" VALUES (2715, '', 4, '', 'GEERTRUID', 'Evert de Bruin', 600, 'fluit', '1717', NULL, NULL, 'E', 'E', '1727-12-10', 'Texel', '1728-03-28', '1728-04-20', true, '1728-07-22', 'Batavia', 6763, 'Two soldiers became seafarers.');
INSERT INTO "voyages" VALUES (2716, '', 3, '', 'NIEUWVLIET', 'Kornelis Lans', 650, NULL, '1719', NULL, NULL, 'Z', 'R', '1728-01-01', 'Goeree', '1728-06-22', '1728-07-20', true, '1728-09-30', 'Batavia', 6782, 'From 06-01 till 22-01-1728 at Duins.');
INSERT INTO "voyages" VALUES (2717, '', 3, '', 'BERKENRODE', 'Tijmen Mol', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1728-01-02', 'Texel', '1728-12-10', '1729-01-12', true, '1729-04-17', 'Batavia', 6779, 'S. Tome from 05-08 till 17-08-1728. One soldier ran away and one soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2718, '', 3, '', 'CORNELIA', 'Pieter Timmerman', 800, NULL, '1721', NULL, NULL, 'H', 'A', '1728-01-02', 'Texel', '1728-05-22', '1728-06-14', true, '1728-08-18', 'Batavia', 6736, 'From 31-01 till 10-02-1728 at Portsmouth.');
INSERT INTO "voyages" VALUES (2719, '', 4, '', 'HILLEGONDA', 'Albert Visser', 850, NULL, '1720', NULL, NULL, 'H', 'H', '1728-01-02', 'Texel', '1728-06-22', '1728-09-15', true, '1728-12-17', 'Batavia', 6765, 'Back at Texel from 20-01 till 23-01-1728; from 08-08 till 04-09-1728 at the Saldanha Bay.');
INSERT INTO "voyages" VALUES (2720, '', 2, '', 'CASTOR EN POLLUX', 'Hendrik Klooster', 400, 'jacht', '1722', NULL, NULL, 'Z', 'A', '1728-01-23', 'Texel', '1728-05-22', '1728-06-24', true, '1728-09-07', 'Batavia', 6795, NULL);
INSERT INTO "voyages" VALUES (2721, '', 3, '', 'GAASPERDAM', 'Willem van Ginkel', 1150, NULL, '1724', NULL, NULL, 'A', 'A', '1728-01-23', 'Texel', '1728-05-22', '1728-06-14', true, '1728-08-19', 'Batavia', 6738, 'Back at Hellevoetsluis from 29-01 till 01-02-1728.');
INSERT INTO "voyages" VALUES (2722, '', 5, '', 'LINSCHOTEN', 'Jan Kemp', 804, NULL, '1714', NULL, NULL, 'A', 'A', '1728-01-23', 'Texel', '1728-05-22', '1728-06-14', true, '1728-08-30', 'Ceylon', NULL, 'Back at Goeree from 29-01 till 01-02-1728. Laid up at Batavia in 1735.');
INSERT INTO "voyages" VALUES (2723, '', 6, '', 'MEIJENBURG', 'Hendrik van der Grippe', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1728-01-24', 'Rammekens', '1728-06-08', '1728-07-19', true, '1728-09-30', 'Batavia', 6753, NULL);
INSERT INTO "voyages" VALUES (2724, '', 3, '', 'STABROEK', 'Barend van der Zalm', 900, NULL, '1722', NULL, NULL, 'A', 'Z', '1728-01-24', 'Rammekens', '1728-06-09', NULL, true, NULL, NULL, NULL, 'Wrecked off the Cape on 03-07-1728.');
INSERT INTO "voyages" VALUES (2725, '', 4, '', 'STEENHOVEN', 'Willem Huigen', 850, NULL, '1718', NULL, NULL, 'Z', 'Z', '1728-01-24', 'Texel', '1729-02-07', '1729-02-26', true, '1729-05-18', 'Batavia', 6770, 'From 11-03 till 29-04-1728 at Plymouth: 4 seafarers and 2 soldiers ran away; from 15-08 till 23-11-1728 at the Brazilian coast: 5 seafarers and 1 craftsmen deserted. One soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2726, '', 3, '', 'HAARLEM', 'Anthonie Biermans', 850, NULL, '1720', NULL, NULL, 'A', 'A', '1728-02-07', 'Texel', '1728-06-07', NULL, true, NULL, NULL, NULL, 'On 03-07-1728 wrecked off the Cape.');
INSERT INTO "voyages" VALUES (2727, '', 1, '', 'KNAPENBURG', 'Pieter Tinnekens', 900, NULL, '1727', NULL, NULL, 'A', 'A', '1728-02-07', 'Texel', '1728-05-22', '1728-06-14', true, '1728-08-30', 'Ceylon', 6749, NULL);
INSERT INTO "voyages" VALUES (2728, '', 1, '', 'MIDDENRAK', 'Hendrik Jurriaan van Beek', 600, NULL, '1717', NULL, NULL, 'A', 'A', '1728-02-07', 'Texel', '1728-05-25', NULL, true, NULL, NULL, NULL, 'On 03-07-1728 wrecked off the Cape.');
INSERT INTO "voyages" VALUES (2729, '', 3, '', 'ADELAAR', 'Willem de Keizer', 810, NULL, '1722', NULL, NULL, 'Z', 'Z', '1728-03-21', 'Rammekens', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked on the reefs of Barra Island near Scotland in March 1728. Remains of the ship were located in March 1972.');
INSERT INTO "voyages" VALUES (2730, '', 4, '', 'HOF NIET ALTIJD ZOMER', 'Frederik Maurits Guitedt', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1728-03-25', 'Rammekens', '1728-08-08', '1728-09-10', true, '1728-12-10', 'Batavia', 6874, NULL);
INSERT INTO "voyages" VALUES (2731, '', 4, '', 'DELFLAND', 'Nikolaas Vis', 600, 'fluit', '1717', NULL, NULL, 'D', 'D', '1728-04-07', 'Goeree', '1728-08-04', '1728-08-30', true, '1728-11-07', 'Batavia', 6845, NULL);
INSERT INTO "voyages" VALUES (2732, '', 6, '', 'GROENSWAART', 'Kornelis Rees', 600, 'fluit', '1714', NULL, NULL, 'R', 'R', '1728-04-08', 'Goeree', '1728-12-07', '1729-01-12', true, '1729-06-19', 'Batavia', 6764, 'From 05-08 till 18-08-1728 at S. Tome.');
INSERT INTO "voyages" VALUES (2733, '', 5, '', 'SPIERING', 'Jakob van der Poel', 810, NULL, '1714', NULL, NULL, 'D', 'D', '1728-04-28', 'Goeree', '1728-09-03', '1728-10-03', true, '1728-12-23', 'Batavia', 6769, 'At Portsmouth from 16-05 till 21-05-1728.');
INSERT INTO "voyages" VALUES (2734, '', 2, '', 'WOLPHAARTSDIJK', 'Adriaan Centsent', 660, NULL, '1722', NULL, NULL, 'Z', 'Z', '1728-04-28', 'Rammekens', '1728-09-25', '1728-10-13', true, '1729-01-10', 'Batavia', 6771, 'At Portsmouth from 12-05 till 21-05-1728. The master died; he was succeeded by Blaquire.');
INSERT INTO "voyages" VALUES (2735, '', 3, '', 'HEESBURG', 'Jan de Marre', 850, NULL, '1720', NULL, NULL, 'A', 'A', '1728-05-10', 'Texel', '1728-09-27', '1728-10-23', true, '1728-12-21', 'Batavia', 6820, 'From 28-06 till 11-07-1728 at S. Tiago.');
INSERT INTO "voyages" VALUES (2736, '', 2, '', 'WAPEN VAN HOORN', 'Hendrik Schadee', 850, NULL, '1723', NULL, NULL, 'H', 'A', '1728-05-10', 'Texel', '1728-09-17', '1728-10-01', true, '1728-12-12', 'Batavia', 6785, NULL);
INSERT INTO "voyages" VALUES (2737, '', 5, '', 'RIJKSDORP', 'Jurriaan Popta', 792, NULL, '1713', NULL, NULL, 'A', 'A', '1728-05-10', 'Texel', '1728-10-24', '1728-11-18', true, '1729-02-18', 'Batavia', 6777, NULL);
INSERT INTO "voyages" VALUES (2738, '', 4, '', 'STADWIJK', 'Gelijn de Haas', 1150, NULL, '1720', NULL, NULL, 'A', 'A', '1728-05-10', 'Texel', '1728-09-05', '1728-10-05', true, '1728-11-29', 'Batavia', 6772, NULL);
INSERT INTO "voyages" VALUES (2739, '', 4, '', 'VIS', 'Lodewijk Verburg', 600, 'fluit', '1716', NULL, NULL, 'E', 'H', '1728-05-10', 'Texel', '1728-10-21', '1728-11-18', true, '1729-02-16', 'Batavia', 6824, 'At S. Tiago from 06-07 till 13-07-1728. One soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2740, '', 3, '', 'BAANMAN', 'Dirk Goudberg', 650, NULL, '1720', NULL, NULL, 'E', 'E', '1728-05-20', 'Texel', '1728-10-22', '1728-11-18', true, '1729-02-16', 'Batavia', NULL, 'One soldier became a seafarer. Laid up in Asia in 1733.');
INSERT INTO "voyages" VALUES (2741, '', 4, '', 'HEINKENSZAND', 'Nikolaas Anderson', 1150, NULL, '1720', NULL, NULL, 'Z', 'Z', '1728-05-20', 'Rammekens', '1728-09-24', '1728-10-13', true, '1728-12-29', 'Batavia', 6781, 'At Torbay from 23-05 till 03-06-1728.');
INSERT INTO "voyages" VALUES (2742, '', 1, '', 'BUIS', 'Dirk Dol', 600, NULL, '1727', NULL, NULL, 'E', 'E', '1728-06-22', 'Texel', '1729-01-08', '1729-02-28', true, '1729-05-16', 'Batavia', 6841, 'At S. Tome from 03-10 till 10-10-1728.');
INSERT INTO "voyages" VALUES (2743, '', 5, '', 'SLOT ALDEGONDE', 'Gillis Oudemans', 580, 'jacht', '1714', NULL, NULL, 'Z', 'A', '1728-06-23', 'Texel', '1728-11-04', '1728-12-09', true, '1729-04-15', 'Batavia', 6784, NULL);
INSERT INTO "voyages" VALUES (2744, '', 5, '', 'STAD LEIDEN', 'Wouter van Dijk', 1140, NULL, '1718', NULL, NULL, 'A', 'A', '1728-06-23', 'Texel', '1728-10-21', '1728-11-18', true, '1729-02-09', 'Batavia', 6767, NULL);
INSERT INTO "voyages" VALUES (2745, '', 4, '', 'CASTRICUM', 'Thomas Fletcher', 1150, NULL, '1722', NULL, NULL, 'A', 'A', '1728-10-28', 'Texel', '1729-02-23', '1729-03-19', true, '1729-06-13', 'Batavia', 6762, NULL);
INSERT INTO "voyages" VALUES (2746, '', 6, '', 'HUTS DE VLOTTER', 'Jan Molentijn', 528, 'fluit', '1713', NULL, NULL, 'A', 'A', '1728-10-28', 'Texel', '1729-03-29', '1729-04-20', true, '1729-07-12', 'Batavia', 6787, NULL);
INSERT INTO "voyages" VALUES (2747, '', 5, '', 'BORSSELE', 'Jakob Jongerheld', 800, NULL, '1715', NULL, NULL, 'Z', 'Z', '1728-10-29', 'Rammekens', '1729-02-23', '1729-03-19', true, '1129-05-19', 'Batavia', NULL, 'Wrecked between Persia and Batavia in 1731.');
INSERT INTO "voyages" VALUES (2748, '', 1, '', 'DUINBEEK', 'Marinus Commerse', 800, NULL, '1727', NULL, NULL, 'Z', 'Z', '1728-10-29', 'Rammekens', '1729-02-21', '1729-03-12', true, '1729-05-19', 'Batavia', 6829, NULL);
INSERT INTO "voyages" VALUES (2749, '', 3, '', 'HERSTELLING', 'Jan van der Quade', 600, NULL, '1721', NULL, NULL, 'D', 'R', '1728-10-29', 'Goeree', '1729-04-07', '1729-04-27', true, '1729-11-27', 'Batavia', 6791, 'passengers came aboard.');
INSERT INTO "voyages" VALUES (2750, '', 3, '', 'LANGERODE', 'Kornelis van der Kolster', 600, NULL, '1723', NULL, NULL, 'D', 'D', '1728-10-29', 'Goeree', '1729-02-23', '1729-03-19', true, '1729-06-11', 'Batavia', 6766, NULL);
INSERT INTO "voyages" VALUES (2751, '', 6, '', 'MIDDELWOUD', 'Hendrik de Keizer', 804, NULL, '1712', NULL, NULL, 'Z', 'Z', '1728-10-29', 'Rammekens', '1729-04-06', '1729-04-26', true, '1729-07-28', 'Batavia', NULL, 'Laid up at Batavia on 17-04-1737.');
INSERT INTO "voyages" VALUES (2752, '', 2, '', 'PALLAS', 'Isaak Rombouts', 650, NULL, '1723', NULL, NULL, 'A', 'A', '1728-10-29', 'Texel', '1729-03-26', '1729-05-10', true, '1729-07-29', 'Batavia', 6789, NULL);
INSERT INTO "voyages" VALUES (2753, '', 3, '', 'SUSANNA', 'Joris Davidson', 600, NULL, '1721', NULL, NULL, 'A', 'A', '1728-10-29', 'Texel', '1729-03-17', '1729-04-20', true, '1729-07-08', 'Batavia', 6807, NULL);
INSERT INTO "voyages" VALUES (2754, '', 4, '', 'MAGDALENA', 'Klaas Zeeridder', 600, NULL, '1719', NULL, NULL, 'H', 'H', '1728-11-15', 'Texel', '1729-04-07', '1729-04-27', true, '1729-07-07', 'Batavia', 6768, NULL);
INSERT INTO "voyages" VALUES (2755, '', 1, '', 'COXHOORN', 'Jan Schul', 450, NULL, '1728', NULL, NULL, 'A', 'A', '1728-12-05', 'Texel', '1729-03-28', '1729-04-21', true, '1729-08-12', 'China', 6783, NULL);
INSERT INTO "voyages" VALUES (2756, '', 3, '', 'KARSENHOF', 'Adam van Ingen', 800, NULL, '1723', NULL, NULL, 'A', 'A', '1728-12-06', 'Texel', '1729-04-07', '1729-04-27', true, '1729-07-10', 'Batavia', 6806, 'At Duins from 11-12 till 25-12-1728; 3 seafarers signed on there.');
INSERT INTO "voyages" VALUES (2757, '', 9, '', 'MUNDEN', 'Simon de Groot', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1728-12-06', 'Texel', '1729-04-07', '1729-04-27', true, '1729-07-05', 'Batavia', NULL, 'At Duins from 16-12 till 25-12-1728. Laid up at Batavia in 1735.');
INSERT INTO "voyages" VALUES (2758, '', 4, '', 'HOPVOGEL', 'Kornelis Zwaag', 600, 'fluit', '1714', NULL, NULL, 'A', 'E', '1728-12-15', 'Texel', '1729-04-13', '1729-05-03', true, '1729-08-05', 'Batavia', NULL, 'One soldier became a seafarer. Laid up at Batavia in 1739.');
INSERT INTO "voyages" VALUES (2759, '', 2, '', 'SCHUITWIJK', 'Dirk de Vet', 650, NULL, '1724', NULL, NULL, 'E', 'H', '1729-03-03', 'Texel', '1729-06-07', '1729-06-25', true, '1729-09-12', 'Batavia', 6790, NULL);
INSERT INTO "voyages" VALUES (2760, '', 4, '', 'HUIS TE ASSENBURG', 'Jan Almees', 800, NULL, '1718', NULL, NULL, 'A', 'A', '1729-03-19', 'Texel', '1729-07-17', '1729-08-13', true, '1729-11-05', 'Ceylon', NULL, 'Laid up at Batavia in 1735.');
INSERT INTO "voyages" VALUES (2761, '', 4, '', 'JACOBA', 'Hendrik van den Berg', 805, NULL, '1721', NULL, NULL, 'A', 'A', '1729-03-19', 'Texel', '1729-07-20', '1729-08-13', true, '1729-10-24', 'Batavia', 6786, NULL);
INSERT INTO "voyages" VALUES (2762, '', 4, '', 'OOSTRUST', 'Pieter Verley', 1140, NULL, '1721', NULL, NULL, 'A', 'A', '1729-03-19', 'Texel', '1729-07-11', '1729-08-05', true, '1729-10-05', 'Batavia', 6773, NULL);
INSERT INTO "voyages" VALUES (2763, '', 6, '', 'PRATTENBURG', 'Jan Verschouw', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1729-03-19', 'Texel', '1729-07-11', '1729-08-05', true, '1729-10-05', 'Batavia', 6774, NULL);
INSERT INTO "voyages" VALUES (2764, '', 5, '', 'HOGENES', 'Joris Vermouwe', 870, NULL, '1716', NULL, NULL, 'Z', 'Z', '1729-03-27', 'Rammekens', '1729-07-26', '1729-08-13', true, '1729-11-07', 'Batavia', NULL, 'From 26-04 till 03-05-1729 at S. Tiago. Laid up at Batavia in 1736.');
INSERT INTO "voyages" VALUES (2765, '', 2, '', 'HOF NIET ALTIJD ZOMER', 'Leonard de Rijke', 650, NULL, '1723', NULL, NULL, 'Z', 'Z', '1729-03-27', 'Rammekens', '1729-07-22', '1729-08-13', true, '1729-11-05', 'Ceylon', 6863, NULL);
INSERT INTO "voyages" VALUES (2766, '', 4, '', 'PATMOS', 'Markel', 810, NULL, '1722', NULL, NULL, 'R', 'R', '1729-04-09', 'Goeree', '1729-08-21', '1729-09-08', true, '1729-11-28', 'Batavia', 6896, NULL);
INSERT INTO "voyages" VALUES (2767, '', 4, '', 'ZOETELINGSKERKE', 'Gerrit Fiers', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1729-04-14', 'Rammekens', '1729-08-04', '1729-08-19', true, '1729-10-24', 'Batavia', 6776, NULL);
INSERT INTO "voyages" VALUES (2768, '', 4, '', 'GOUDRIAAN', 'Adriaan van Dorp', 630, 'fluit', '1719', NULL, NULL, 'D', 'D', '1729-04-26', 'Goeree', '1729-08-20', '1729-09-08', true, '1729-11-21', 'Batavia', 6798, NULL);
INSERT INTO "voyages" VALUES (2769, '', 6, '', 'JOHANNA', 'Hendrik van Beek', 550, 'fluit', '1714', NULL, NULL, 'A', 'A', '1729-05-08', 'Texel', '1729-10-05', '1729-10-30', true, '1730-02-14', 'Batavia', NULL, 'At Duins from 14-05 till 15-05-1729. Two soldiers became seafarers. Wrecked on the river Ganges in 1730.');
INSERT INTO "voyages" VALUES (2770, '', 5, '', 'KOMMERRUST', 'Marten Harting', 810, NULL, '1718', NULL, NULL, 'A', 'A', '1729-05-08', 'Texel', '1729-10-01', '1729-10-19', true, '1730-01-25', 'Batavia', 6810, 'At Duins from 13-05 till 15-05-1729. One seafarer became a soldier.');
INSERT INTO "voyages" VALUES (2771, '', 2, '', 'MEERLUST', 'Kornelis Oterlijk', 600, NULL, '1725', NULL, NULL, 'A', 'A', '1729-05-08', 'Texel', '1729-10-05', '1729-10-30', true, '1730-02-15', 'Batavia', 6852, 'At Duins from 14-04 till 15-05-1729.');
INSERT INTO "voyages" VALUES (2772, '', 5, '', 'BARBESTEIN', 'Anthonie Klink', 1100, NULL, '1717', NULL, NULL, 'Z', 'Z', '1729-05-28', 'Rammekens', '1729-10-05', '1729-11-02', true, '1730-02-14', 'Batavia', 6794, 'At S. Tiago from 07-07 till 18-07-1729.');
INSERT INTO "voyages" VALUES (2773, '', 3, '', 'WESTFRIESLAND', 'Frans van der Hoop', 370, 'jacht', '1722', NULL, NULL, 'H', 'Z', '1729-05-28', 'Rammekens', '1729-10-05', '1729-11-02', true, '1730-02-19', 'Batavia', 6855, 'At S. Tiago from 08-07 till 18-07-1729.');
INSERT INTO "voyages" VALUES (2774, '', 2, '', 'LAND VAN BELOFTEN', 'IJpe Engelman', 520, NULL, '1723', NULL, NULL, 'E', 'E', '1729-05-29', 'Texel', '1730-01-01', '1730-01-17', true, '1730-06-05', 'Batavia', 6876, 'From 06-11 till 27-12-1729 at Saldanha Bay. Three soldiers became seafarers.');
INSERT INTO "voyages" VALUES (2775, '', 6, '', 'STRUKEBOLLE', 'Jan Keizer', 540, 'fluit', '1712', NULL, NULL, 'E', 'H', '1729-05-29', 'Texel', '1729-10-26', '1729-11-17', true, '1730-02-25', 'Batavia', NULL, 'Laid up at Batavia on 19-04-1737.');
INSERT INTO "voyages" VALUES (2776, '', 3, '', 'MIDLOO', 'Jan Diephout', 800, NULL, '1719', NULL, NULL, 'A', 'A', '1729-05-31', 'Texel', '1729-10-05', '1729-10-30', true, '1730-02-19', 'Batavia', 6837, NULL);
INSERT INTO "voyages" VALUES (2777, '', 4, '', 'SLEEWIJK', 'Reijnder Lub', 520, 'jacht', '1713', NULL, NULL, 'R', 'E', '1729-09-19', 'Texel', '1730-01-13', '1730-02-05', true, '1730-05-22', 'Batavia', NULL, 'Laid up at Batavia on 22-04-1738.');
INSERT INTO "voyages" VALUES (2778, '', 1, '', 'ANNA CATHARINA', 'Adriaan Krijnsen', 600, NULL, '1728', NULL, NULL, 'Z', 'Z', '1729-11-04', 'Rammekens', '1730-04-19', '1730-05-05', true, '1730-08-06', 'Batavia', 6793, NULL);
INSERT INTO "voyages" VALUES (2779, '', 4, '', 'CATS', 'Jan van Malen', 580, NULL, '1716', NULL, NULL, 'Z', 'Z', '1729-11-04', 'Rammekens', '1730-02-25', '1730-03-11', true, '1730-06-05', 'Batavia', NULL, 'Laid up at Batavia in 1739.');
INSERT INTO "voyages" VALUES (2780, '', 4, '', 'STADHUIS VAN DELFT', 'Gijsbert Boelen', 600, 'fluit', '1718', NULL, NULL, 'D', 'D', '1729-11-05', 'Goeree', '1730-02-15', '1730-02-26', true, '1730-05-15', 'Batavia', NULL, 'One soldier became a seafarer. Wrecked in Sunda Strait in 1731.');
INSERT INTO "voyages" VALUES (2781, '', 3, '', 'KETEL', 'Jan Hokkeling', 810, NULL, '1721', NULL, NULL, 'R', 'R', '1729-11-05', 'Goeree', '1730-02-19', '1730-03-13', true, '1730-06-13', 'Batavia', 6799, NULL);
INSERT INTO "voyages" VALUES (2782, '', 1, '', 'BUREN', 'Hendrik Huizing', 450, NULL, '1728', NULL, NULL, 'A', 'A', '1729-11-11', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'destination was China.');
INSERT INTO "voyages" VALUES (2783, '', 1, '', 'DUIFJE', 'Huig Goedhart', 450, NULL, '1729', NULL, NULL, 'A', 'A', '1729-11-11', 'Texel', '1730-05-07', '1730-05-18', true, NULL, 'China', 6812, 'At Plymouth from 26-12 till 28-12-1729.');
INSERT INTO "voyages" VALUES (2784, '', 3, '', 'GAASPERDAM', 'Ginkel', 1150, NULL, '1724', NULL, NULL, 'A', 'A', '1729-11-11', 'Texel', '1730-04-22', '1730-05-13', true, '1730-07-17', 'Batavia', 6808, 'Back at Hellevoetsluis from 16-11 till 04-12-1729. One soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2785, '', 1, '', 'PAPENBURG', 'Kornelis Brouw', 800, NULL, '1729', NULL, NULL, 'A', 'A', '1729-11-11', 'Texel', '1730-04-22', '1730-05-05', true, '1730-06-30', 'Batavia', 6831, 'seafarer became a soldier.');
INSERT INTO "voyages" VALUES (2786, '', 1, '', 'SCHONAUWEN', 'Hendrik Smit', 600, NULL, '1729', NULL, NULL, 'A', 'A', '1729-11-11', 'Texel', '1730-05-16', '1730-06-06', true, '1730-08-26', 'Batavia', 6873, 'seafarer deserted. From 26-12-1729 till 15-01-1730 at Portsmouth: 4 seafarers ran away. From 01-05 till 12-05-1730 at Saldanha Bay.');
INSERT INTO "voyages" VALUES (2787, '', 3, '', 'WESTERBEEK', 'Pieter Bley', 650, NULL, '1722', NULL, NULL, 'A', 'A', '1729-11-11', 'Texel', '1730-04-27', '1730-06-06', true, '1730-08-10', 'Batavia', 6924, 'At Duins from 22-11 till 24-11-1729.');
INSERT INTO "voyages" VALUES (2788, '', 8, '', 'WESTERDIJKSHORN', 'Adriaan de Raad', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1729-11-11', 'Texel', '1730-04-22', '1730-05-18', true, '1730-07-20', 'Batavia', 6801, 'Back at Hellevoetsluis from 16-11 till 05-12-1729. From 15-12 till 27-12-1729 at Texel: 15 soldiers signed on. From 30-12-1729 till 15-01-1730 at Portsmouth.');
INSERT INTO "voyages" VALUES (2789, '', 4, '', 'CORNELIA', 'Jakob Nierop', 800, NULL, '1721', NULL, NULL, 'H', 'H', '1729-12-04', 'Texel', '1730-04-16', '1730-05-01', true, '1730-07-16', 'Batavia', 6796, 'According to K.A. 2036 Jan Pereboom was the master.');
INSERT INTO "voyages" VALUES (2790, '', 7, '', 'MEIJENBURG', 'Barend van der Zalm', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1730-01-15', 'Rammekens', '1730-04-21', '1730-04-30', true, '1730-07-02', 'Batavia', 6811, NULL);
INSERT INTO "voyages" VALUES (2791, '', 1, '', 'SNUFFELAAR', 'Dringer', 200, 'hoeker', '1723', NULL, NULL, 'Z', 'Z', '1730-01-15', 'Rammekens', '1730-05-11', NULL, true, '1730-05-11', 'The Cape', NULL, 'Was laid up at Batavia in 1743.');
INSERT INTO "voyages" VALUES (2792, '', 4, '', 'WICKENBURG', 'Pieter van der Roete', 850, NULL, '1722', NULL, NULL, 'Z', 'Z', '1730-01-15', 'Rammekens', '1730-05-11', '1730-06-06', true, '1730-08-18', 'Batavia', 6867, NULL);
INSERT INTO "voyages" VALUES (2793, '', 1, '', 'BEEKVLIET', 'Hendrik Klooster', 850, NULL, '1724', NULL, NULL, 'A', 'A', '1730-01-20', 'Texel', '1730-04-26', '1730-05-18', true, '1730-08-11', 'Batavia', 6804, NULL);
INSERT INTO "voyages" VALUES (2794, '', 7, '', 'ELISABETH', 'Herman de Vrij', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1730-01-20', 'Texel', '1730-04-20', '1730-05-05', true, '1730-07-03', 'Batavia', 6797, NULL);
INSERT INTO "voyages" VALUES (2795, '', 3, '', 'HOGERSMILDE', 'Pieter Timmerman', 810, NULL, '1723', NULL, NULL, 'A', 'A', '1730-01-20', 'Texel', '1730-04-02', '1730-05-05', true, '1730-07-07', 'Batavia', 6830, 'One soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2796, '', 2, '', 'KNAPENBURG', 'Pieter Tinnekens', 900, NULL, '1727', NULL, NULL, 'A', 'A', '1730-01-20', 'Texel', '1730-04-21', '1730-05-18', true, '1730-08-19', 'Ceylon', NULL, 'Lost on its way to Japan in 1731.');
INSERT INTO "voyages" VALUES (2797, '', 3, '', 'LANDSKROON', 'Jan van Thiel', 850, NULL, '1725', NULL, NULL, 'A', 'A', '1730-01-20', 'Texel', '1730-04-26', '1730-05-18', true, '1730-08-11', 'Ceylon', 6871, NULL);
INSERT INTO "voyages" VALUES (2798, '', 2, '', 'LAGS POLDER', 'Kasper Duits', 580, NULL, '1725', NULL, NULL, 'E', 'E', '1730-01-20', 'Texel', '1730-05-10', '1730-06-06', true, '1730-09-23', 'Batavia', 6839, NULL);
INSERT INTO "voyages" VALUES (2799, '', 4, '', 'HAFTEN', 'Jan de Graaf', 600, 'fluit', '1717', NULL, NULL, 'A', 'R', '1730-04-07', 'Texel', '1730-09-03', '1730-09-27', true, '1731-01-28', 'Batavia', 6842, 'One soldier became a seafarer. According to K.A. 2046 Huibert Haringvanger was the master.');
INSERT INTO "voyages" VALUES (2800, '', 4, '', 'LOENDERVEEN', 'Jakob van der Swet', 650, 'fluit', '1718', NULL, NULL, 'A', 'D', '1730-04-14', 'Goeree', '1730-08-13', '1730-08-28', true, '1730-10-28', 'Batavia', 6814, NULL);
INSERT INTO "voyages" VALUES (2801, '', 5, '', 'DEN DAM', 'Kornelis de Ruiter', 600, 'fluit', '1716', NULL, NULL, 'D', 'D', '1730-04-27', 'Goeree', '1730-08-16', '1730-08-28', true, '1730-10-28', 'Batavia', 6813, NULL);
INSERT INTO "voyages" VALUES (2802, '', 3, '', 'BLIJDORP', 'Jan de Haan', 900, NULL, '1723', NULL, NULL, 'R', 'A', '1730-05-02', 'Texel', '1730-08-08', '1730-08-28', true, '1730-10-28', 'Batavia', 6840, 'One soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2803, '', 3, '', 'EVERSWAART', 'Pieter Obry', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1730-05-02', 'Rammekens', '1730-08-10', '1730-08-28', true, '1730-10-28', 'Batavia', 6805, NULL);
INSERT INTO "voyages" VALUES (2804, '', 2, '', 'REIGERSBROEK', 'Hendrik Huizing', 600, NULL, '1726', NULL, NULL, 'A', 'A', '1730-05-02', 'Texel', '1730-09-10', '1730-10-04', true, '1731-01-25', 'Batavia', 6815, 'According to K.A. 2046 Jacob van der Beek was the master.');
INSERT INTO "voyages" VALUES (2805, '', 2, '', 'RIDDERKERK', 'Gerrit Klinkhamer', 500, NULL, '1726', NULL, NULL, 'R', 'A', '1730-05-02', 'Texel', '1730-08-16', '1730-08-28', true, '1730-10-27', 'Batavia', 6903, NULL);
INSERT INTO "voyages" VALUES (2806, '', 1, '', 'SIJBEKARSPEL', 'Meindertsz. Blok', 650, NULL, '1729', NULL, NULL, 'H', 'H', '1730-05-02', 'Texel', '1730-09-26', '1730-10-27', true, '1731-03-12', 'Batavia', 6930, NULL);
INSERT INTO "voyages" VALUES (2807, '', 6, '', 'VALKENISSE', 'Dirk de Visser', 1150, NULL, '1716', NULL, NULL, 'Z', 'Z', '1730-05-02', 'Rammekens', '1730-09-03', '1730-09-27', true, '1731-02-17', 'Batavia', 6832, 'According to K.A. 2046 the master was Adriaan van der Graaf.');
INSERT INTO "voyages" VALUES (2808, '', 3, '', 'KLAREBEEK', 'Christiaan Damme', 705, NULL, '1721', NULL, NULL, 'Z', 'Z', '1730-05-13', 'Rammekens', '1730-10-24', '1730-11-17', true, '1731-03-05', 'Batavia', 6881, 'From 21-06 till 27-06-1730 at S. Tiago. At the Cape 2 seafarers and one craftsmen went to the WINDHOND (2809).');
INSERT INTO "voyages" VALUES (2809, '', 3, '', 'WINDHOND', 'Zacharias Zachariasz.', 370, NULL, '1722', NULL, NULL, 'A', 'Z', '1730-05-13', 'Rammekens', '1730-10-24', '1730-11-17', true, '1731-03-05', 'Batavia', NULL, 'K.A. 2046 the master was Apolonius den Hollander. From 21-06 till 27-06-1730 at S. Tiago. The ship was laid up at Batavia in 1740.');
INSERT INTO "voyages" VALUES (2810, '', 4, '', 'HAAKSBURG', 'Reus', 600, NULL, '1718', NULL, NULL, 'E', 'H', '1730-06-30', 'Texel', '1731-01-19', '1731-02-21', true, '1731-06-04', 'Batavia', 6819, NULL);
INSERT INTO "voyages" VALUES (2811, '', 4, '', 'NOORDWADDINXVEEN', 'Hendrik Beene', 850, NULL, '1718', NULL, NULL, 'R', 'E', '1730-09-06', 'Texel', '1731-02-11', '1731-03-08', true, '1731-07-20', 'Batavia', 6838, NULL);
INSERT INTO "voyages" VALUES (2812, '', 1, '', 'HOFVLIET', 'Arie Brouwer', 1000, NULL, '1729', NULL, NULL, 'R', 'R', '1730-10-10', 'Goeree', '1731-03-16', '1731-04-07', true, '1731-07-04', 'Batavia', 6879, NULL);
INSERT INTO "voyages" VALUES (2813, '', 4, '', 'LANGERODE', 'Samuel Hoppestijn van Leeuwen', 600, NULL, '1723', NULL, NULL, 'D', 'D', '1730-10-11', 'Goeree', '1731-03-01', '1731-03-21', true, '1731-06-26', 'Batavia', NULL, 'Laid up at Batavia on 22-04-1738.');
INSERT INTO "voyages" VALUES (2814, '', 5, '', 'MAGDALENA', 'Gerrit Kuit', 600, NULL, '1719', NULL, NULL, 'H', 'H', '1730-10-21', 'Texel', '1731-04-21', '1731-05-13', true, '1731-07-28', 'Batavia', 6821, 'Back at Texel from 27-10 till 11-12-1730.');
INSERT INTO "voyages" VALUES (2815, '', 5, '', 'CASTRICUM', 'Isaak Hage', 1150, NULL, '1722', NULL, NULL, 'A', 'A', '1730-10-26', 'Texel', '1731-03-28', '1731-04-12', true, '1731-07-04', 'Batavia', 6817, 'Back at Texel from 27-10 till 11-12-1730.');
INSERT INTO "voyages" VALUES (2816, '', 2, '', 'SPIERINGSHOEK', 'Willem Haysen', 450, 'jacht', '1724', NULL, NULL, 'D', 'A', '1730-10-26', 'Texel', '1731-03-28', '1731-04-28', true, '1731-07-08', 'Batavia', NULL, 'Back at Texel from 27-10 till 11-12-1730. Laid up at Batavia on 04-07-1738.');
INSERT INTO "voyages" VALUES (2817, '', 1, '', 'ZORGWIJK', 'Hendrik Oterlijk', 650, NULL, '1730', NULL, NULL, 'A', 'A', '1730-10-26', 'Texel', '1731-03-29', '1731-04-12', true, '1731-07-12', 'Batavia', 6844, 'Back at Texel from 27-10 till 11-12-1730.');
INSERT INTO "voyages" VALUES (2818, '', 2, '', 'COXHOORN', 'Gerrit Pik', 450, NULL, '1728', NULL, NULL, 'A', 'A', '1730-12-11', 'Texel', '1731-03-29', '1731-04-01', true, NULL, 'China', 6834, NULL);
INSERT INTO "voyages" VALUES (2819, '', 1, '', 'FLORA', 'Daniel Overbeek', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1730-12-11', 'Texel', '1731-03-28', '1731-04-13', true, '1731-07-04', 'Batavia', 6818, NULL);
INSERT INTO "voyages" VALUES (2820, '', 1, '', '''T VLIEGENDE HART', 'Abraham van der Hart', 850, NULL, '1729', NULL, NULL, 'Z', 'Z', '1730-12-11', 'Rammekens', '1731-04-09', '1731-04-28', true, '1731-07-10', 'Batavia', 6890, NULL);
INSERT INTO "voyages" VALUES (2821, '', 6, '', 'TER HORST', 'Hendrik Schoon', 520, 'fluit', '1713', NULL, NULL, 'D', 'D', '1730-12-11', 'Texel', '1731-03-28', '1731-04-13', true, '1731-07-18', 'Batavia', NULL, 'First departure from Texel on 10-05-1730. The ship was taken by privateers and forced to stay at Algiers from 15-05 till 05-06-1730. Back at Texel on 13-08-1730. Laid up at Batavia on 22-04-1738.');
INSERT INTO "voyages" VALUES (2822, '', 1, '', 'LEIDUIN', 'Jan Reebok', 650, NULL, '1730', NULL, NULL, 'A', 'A', '1730-12-11', 'Texel', '1731-03-16', '1731-04-02', true, NULL, 'China', 6835, NULL);
INSERT INTO "voyages" VALUES (2823, '', 4, '', 'NIEUWVLIET', 'Gerrit Fiers', 650, NULL, '1719', NULL, NULL, 'Z', 'Z', '1730-12-11', 'Rammekens', '1731-03-22', '1731-04-08', true, NULL, 'China', 6833, NULL);
INSERT INTO "voyages" VALUES (2824, '', 4, '', 'PURMERLUST', 'Samuel Veldhuizen', 580, NULL, '1718', NULL, NULL, 'A', 'A', '1730-12-11', 'Texel', '1731-03-28', '1731-05-17', true, '1731-07-28', 'Batavia', 6853, 'First departure from Texel on 10-05-1730. The ship was taken by privateers and forced to stay at Algiers from 15-05 till 05-06-1730. Back at Texel on 13-08-1730.');
INSERT INTO "voyages" VALUES (2825, '', 3, '', 'WOLPHAARTSDIJK', 'Pieter van Hoorn', 660, NULL, '1722', NULL, NULL, 'Z', 'Z', '1730-12-11', 'Rammekens', '1731-04-07', '1731-04-28', true, '1731-07-06', 'Batavia', NULL, 'Laid up at Batavia on 22-04-1738.');
INSERT INTO "voyages" VALUES (2826, '', 5, '', 'ZOETELINGSKERKE', 'Paulus Udemans', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1730-12-13', 'Rammekens', '1731-04-13', '1731-05-13', true, '1731-07-13', 'Batavia', 6825, NULL);
INSERT INTO "voyages" VALUES (2827, '', 4, '', 'BERKENRODE', 'Jurriaan Popta', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1730-12-29', 'Texel', '1731-04-01', '1731-04-13', true, '1731-07-04', 'Batavia', 6816, NULL);
INSERT INTO "voyages" VALUES (2828, '', 7, '', 'HUIS TEN DONK', 'Laurens de Ruiter', 650, NULL, '1711', NULL, NULL, 'R', 'A', '1730-12-29', 'Texel', '1731-05-01', '1731-05-17', true, '1731-07-29', 'Batavia', NULL, 'Laid up at Batavia on 17-04-1739.');
INSERT INTO "voyages" VALUES (2829, '', 6, '', 'STAD LEIDEN', 'Lambert Zwaan', 1140, NULL, '1718', NULL, NULL, 'A', 'A', '1730-12-29', 'Texel', '1731-03-27', '1731-04-14', true, '1731-07-04', 'Batavia', 6827, NULL);
INSERT INTO "voyages" VALUES (2830, '', 1, '', 'MEERMOND', 'Jakob Gosen Hoogstad', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1730-12-29', 'Texel', '1731-04-01', '1731-05-14', true, '1731-08-12', 'Ceylon', 6864, NULL);
INSERT INTO "voyages" VALUES (2831, '', 7, '', 'PRATTENBURG', 'Hendrik Smit', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1730-12-29', 'Texel', '1731-03-27', '1731-04-11', true, '1731-07-02', 'Batavia', 6823, NULL);
INSERT INTO "voyages" VALUES (2832, '', 5, '', 'HILLEGONDA', 'Albert Visser', 850, NULL, '1720', NULL, NULL, 'H', 'H', '1731-01-01', 'Texel', '1731-05-11', '1731-05-20', true, '1731-07-28', 'Batavia', 6826, NULL);
INSERT INTO "voyages" VALUES (2833, '', 5, '', 'GEERTRUID', 'Kornelis van der Hoeve', 600, 'fluit', '1717', NULL, NULL, 'E', 'E', '1731-01-19', 'Texel', '1731-05-09', '1731-05-20', true, '1731-07-29', 'Batavia', 6858, NULL);
INSERT INTO "voyages" VALUES (2834, '', 7, '', 'GROENSWAART', 'Jan van der Quade', 600, 'fluit', '1714', NULL, NULL, 'R', 'R', '1731-04-08', 'Goeree', '1731-07-19', '1731-08-08', true, '1731-10-26', 'Batavia', 6836, NULL);
INSERT INTO "voyages" VALUES (2835, '', 3, '', 'KROOSWIJK', 'Pieter Kaas', 600, 'fluit', '1720', NULL, NULL, 'R', 'R', '1731-04-26', 'Goeree', '1731-08-30', '1731-09-22', true, '1731-12-15', 'Batavia', 6843, NULL);
INSERT INTO "voyages" VALUES (2836, '', 6, '', 'SPIERING', 'Kornelis van der Kolster', 810, NULL, '1714', NULL, NULL, 'D', 'D', '1731-04-26', 'Goeree', '1731-08-17', '1731-09-07', true, '1731-10-30', 'Batavia', 6828, NULL);
INSERT INTO "voyages" VALUES (2837, '', 2, '', '''S HEER ARENDSKERKE', 'Jan van den Berge', 600, NULL, '1724', NULL, NULL, 'Z', 'Z', '1731-05-11', 'Rammekens', '1731-10-16', '1731-11-09', true, '1732-02-18', 'Ceylon', 7039, NULL);
INSERT INTO "voyages" VALUES (2838, '', 1, '', 'MARIA ADRIANA', 'Jan de Heere', 650, NULL, '1730', NULL, NULL, 'Z', 'Z', '1731-05-11', 'Rammekens', '1731-10-16', '1731-11-09', true, '1732-02-14', 'Ceylon', 6859, NULL);
INSERT INTO "voyages" VALUES (2839, '', 3, '', 'WAPEN VAN HOORN', 'Klaas Zeeridder', 850, NULL, '1723', NULL, NULL, 'H', 'H', '1731-05-21', 'Texel', '1731-11-16', '1731-12-18', true, '1732-05-08', 'Batavia', 6984, '1 Soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2840, '', 5, '', 'JACOBA', 'Pieter van Hengelen', 805, NULL, '1721', NULL, NULL, 'A', 'A', '1731-05-21', 'Texel', '1731-10-16', '1731-11-14', true, '1732-03-01', 'Ceylon', NULL, 'Laid up at Batavia on 16-08-1737.');
INSERT INTO "voyages" VALUES (2841, '', 5, '', 'OOSTRUST', 'Hendrik van den Berg', 1140, NULL, '1721-01-01', NULL, NULL, 'A', 'A', '1731-05-21', 'Texel', '1731-10-09', '1731-11-01', true, '1732-01-16', 'Batavia', 6865, NULL);
INSERT INTO "voyages" VALUES (2842, '', 6, '', 'RIJKSDORP', 'Jan Molentijn', 792, NULL, '1713', NULL, NULL, 'A', 'A', '1731-05-21', 'Texel', '1732-02-15', '1732-03-07', true, '1732-06-11', 'Batavia', NULL, 'Acc. to K.A. 2100 the master was Klaas Meelhoop; he probably succeeded Jan Molentijn during the voyage. The ship was wrecked on 01-06-1734.');
INSERT INTO "voyages" VALUES (2843, '', 7, '', 'HUIS DE VLOTTER', 'Pieter Knollendam', 528, 'fluit', '1713', NULL, NULL, 'A', 'A', '1731-05-21', 'Texel', '1732-02-15', '1732-03-15', true, '1732-06-20', 'Batavia', NULL, 'The ship was from 12-12-1731 till 12-01-1732 at St. Helena and from 02-02 till 14-02-1732 at Saldanha 
Bay. Acc. to K.A. 2100 Willem de Wijs was the master: he probably succeeded Pieter Knollendam. Laid up at Batavia on 19-04-1737.');
INSERT INTO "voyages" VALUES (2844, '', 6, '', 'SLOT ALDEGONDE', 'Paulus Erasmus', 580, 'jacht', '1714', NULL, NULL, 'Z', 'Z', '1731-06-01', 'Rammekens', '1731-10-14', '1731-11-01', true, '1732-02-21', 'Batavia', NULL, 'From 07-07-1731 till 16-07-1731 at S. Tiago: 3 seafarers and 4 soldiers ran away. Laid up at Batavia on 22-04-1738.');
INSERT INTO "voyages" VALUES (2845, '', 5, '', 'HEINKENSZAND', 'Jan Govaarts', 1150, NULL, '1720', NULL, NULL, 'Z', 'Z', '1731-06-01', 'Rammekens', '1732-01-08', '1732-02-11', true, '1732-05-28', 'Batavia', NULL, 'From 08-07 till 16-07-1731 at S. Tiago; 1 soldier deserted; from 01-12-1731 till 15-12-1731 at S. Tome; 2 seafarers and 1 soldier ran away. Laid up at Batavia in 1736.');
INSERT INTO "voyages" VALUES (2846, '', 3, '', 'SCHUITWIJK', 'Michiel Keizer', 650, NULL, '1724', NULL, NULL, 'E', 'Z', '1731-06-01', 'Rammekens', '1732-01-13', '1732-02-23', true, '1732-05-28', 'Batavia', 6866, 'From 08-07 till 16-07-1731 at S. Tiago; from 01-09 till 14-09-1731 at S. Tome.');
INSERT INTO "voyages" VALUES (2847, '', 1, '', 'HUIS TE MARQUETTE', 'Gelijn de Haas +', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1731-06-24', 'Texel', '1731-11-20', '1731-12-24', true, '1732-04-11', 'Batavia', 6895, 'The master died and was succeeded by Pieter Jonges.');
INSERT INTO "voyages" VALUES (2848, '', 3, '', 'PALLAS', 'Evert Vlaming', 650, NULL, '1723', NULL, NULL, 'A', 'A', '1731-07-18', 'Texel', '1732-02-26', '1732-04-04', true, '1732-07-09', 'Batavia', 6916, 'At S. Tiago from 11-09 till 26-09-1731. Acc. to K.A. 2100 the master was Jurriaan Lijssen. He probably succeeded Evert Vlaming.');
INSERT INTO "voyages" VALUES (2849, '', 1, '', 'PROOSTWIJK', 'Evert de Bruin', 650, NULL, '1730', NULL, NULL, 'E', 'E', '1731-07-18', 'Texel', '1732-01-13', '1732-02-10', true, '1732-05-10', 'Batavia', 6894, 'At S. Tiago from 16-09 till 26-09-1731.');
INSERT INTO "voyages" VALUES (2850, '', 5, '', 'STADWIJK', 'Isaak Rombouts', 1150, NULL, '1720', NULL, NULL, 'A', 'A', '1731-07-18', 'Texel', '1731-11-15', '1731-12-05', true, '1732-02-29', 'Batavia', 6861, NULL);
INSERT INTO "voyages" VALUES (2851, '', 2, '', 'DUIFJE', 'Jan Brouwer', 450, NULL, '1729', NULL, NULL, 'A', 'A', '1731-10-23', 'Texel', NULL, NULL, false, '1732-05-28', 'Batavia', 6938, NULL);
INSERT INTO "voyages" VALUES (2852, '', 1, '', 'HAAMSTEDE', 'Boudewijn de Graaf', 650, NULL, '1730', NULL, NULL, 'D', 'D', '1731-10-29', 'Goeree', '1732-02-17', '1732-02-28', true, '1732-05-28', 'Batavia', 6877, NULL);
INSERT INTO "voyages" VALUES (2853, '', 3, '', 'KASTEEL VAN WOERDEN', 'Isaak Brandenburg', 850, NULL, '1722', NULL, NULL, 'D', 'E', '1731-10-30', 'Texel', '1732-04-22', '1732-05-18', true, '1732-08-01', 'Batavia', 6856, NULL);
INSERT INTO "voyages" VALUES (2854, '', 5, '', 'CORNELIA', 'Jan Pereboom', 800, NULL, '1721', NULL, NULL, 'H', 'H', '1731-11-21', 'Texel', '1732-04-21', '1732-05-04', true, '1732-07-25', 'Batavia', 6857, 'Portsmouth.');
INSERT INTO "voyages" VALUES (2855, '', 4, '', 'HERSTELLING', 'Willem Jakobsz. Smeer', 600, NULL, '1721', NULL, NULL, 'D', 'A', '1731-11-21', 'Texel', '1732-04-07', '1732-06-01', true, '1733-04-10', 'Batavia', NULL, '01-06-1732; 4 seafarers ran away there. Laid up at Batavia on 17-04-1733.');
INSERT INTO "voyages" VALUES (2856, '', 1, '', 'LOOSDRECHT', 'Huig Goedhart', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1731-11-21', 'Texel', '1732-04-24', '1732-05-18', true, '1732-08-06', 'Batavia', 6851, 'Back at Goeree from 29-11 till 11-12-1731. From 14-12-1731 till 01-01-1732 at Portsmouth.');
INSERT INTO "voyages" VALUES (2857, '', 3, '', 'CASTOR EN POLLUX', 'Jakob Koster', 400, 'jacht', '1722', NULL, NULL, 'Z', 'A', '1731-12-06', 'Texel', '1732-03-21', '1732-05-02', true, '1732-07-22', 'Batavia', NULL, 'Laid up at Batavia in 1740.');
INSERT INTO "voyages" VALUES (2858, '', 4, '', 'EVERSWAART', 'Pieter Bruis', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1731-12-11', 'Rammekens', '1732-04-15', '1732-05-02', true, '1732-07-18', 'Batavia', 6848, 'At Duins from 22-12 till 31-12-1731.');
INSERT INTO "voyages" VALUES (2859, '', 4, '', 'KETEL', 'Jakob van der Blok', 810, NULL, '1721', NULL, NULL, 'R', 'R', '1731-12-11', 'Goeree', '1732-04-30', '1732-05-18', true, '1732-07-24', 'Batavia', 6850, 'seafarer.');
INSERT INTO "voyages" VALUES (2860, '', 5, '', 'STEENHOVEN', 'Hendrik van der Grippe', 850, NULL, '1718', NULL, NULL, 'Z', 'Z', '1731-12-11', 'Rammekens', '1732-04-24', '1732-05-18', true, '1732-09-01', 'Batavia', 6854, 'At Duins from 22-12 till 31-12-1731.');
INSERT INTO "voyages" VALUES (2861, '', 1, '', 'WESTKAPELLE', 'Jakob Landheer', 850, NULL, '1730', NULL, NULL, 'Z', 'Z', '1731-12-11', 'Rammekens', '1732-04-24', '1732-05-18', true, '1732-08-14', 'Batavia', 6862, 'From 22-12 till 31-12-1731 at Duins.');
INSERT INTO "voyages" VALUES (2862, '', 1, '', 'IEPENRODE', 'Adriaan de Raad', 650, NULL, '1731', NULL, NULL, 'A', 'A', '1732-01-02', 'Texel', '1732-04-21', '1732-05-03', true, '1732-08-13', 'China', 6868, NULL);
INSERT INTO "voyages" VALUES (2863, '', 1, '', 'KNAPPENHOF', 'Pieter Verley', 650, NULL, '1731', NULL, NULL, 'A', 'A', '1732-01-02', 'Texel', '1732-04-21', '1732-05-03', true, '1732-08-13', 'China', 6869, NULL);
INSERT INTO "voyages" VALUES (2864, '', 2, '', 'ADRICHEM', 'Hendrik Perfekt', 850, NULL, '1726', NULL, NULL, 'A', 'A', '1732-01-04', 'Texel', '1732-04-24', '1732-05-18', true, '1732-07-25', 'Batavia', 6846, 'From 11-01 till 14-01-1732 at Duins: one seafarer went to the WESTERDIJKSHORN (2868).');
INSERT INTO "voyages" VALUES (2865, '', 2, '', 'CATHARINA', 'Herman Brand', 600, NULL, '1728', NULL, NULL, 'Z', 'Z', '1732-01-04', 'Rammekens', NULL, NULL, false, '1732-10-24', 'China', 6897, NULL);
INSERT INTO "voyages" VALUES (2866, '', 2, '', 'BEEKVLIET', 'Lukas Hardenbroek', 850, NULL, '1724', NULL, NULL, 'A', 'A', '1732-01-04', 'Texel', '1732-04-24', '1732-05-18', true, '1732-08-06', 'Batavia', 6847, 'till 14-01-1732.');
INSERT INTO "voyages" VALUES (2867, '', 4, '', 'GAASPERDAM', 'Joris Davidson', 1150, NULL, '1724', NULL, NULL, 'A', 'A', '1732-01-04', 'Texel', '1732-04-28', '1732-05-18', true, '1732-07-25', 'Batavia', 6849, 'At Duins from 11-01 till 14-01-1732.');
INSERT INTO "voyages" VALUES (2868, '', 9, '', 'WESTERDLKSHORN', 'Mijndert Schut', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1732-01-04', 'Texel', '1732-05-01', '1732-05-18', true, '1732-08-06', 'Batavia', NULL, 'At Duins from 11-01 till 14-01-1732;1 soldier and 1 seafarer died there. Laid up at Batavia on 07-07-1741.');
INSERT INTO "voyages" VALUES (2869, '', 6, '', 'DEN DAM', 'Kornelis Nannings', 600, 'fluit', '1716', NULL, NULL, 'D', 'Z', '1732-01-14', 'Rammekens', '1732-04-30', '1732-05-18', true, '1732-07-20', 'Batavia', 6870, NULL);
INSERT INTO "voyages" VALUES (2870, '', 6, '', 'KOMMERRUST', 'Pieter Sluis', 810, NULL, '1718', NULL, NULL, 'A', 'A', '1732-01-14', 'Texel', '1732-06-01', '1732-06-22', true, '1732-09-28', 'Batavia', NULL, 'Laid up at Batavia in 1736.');
INSERT INTO "voyages" VALUES (2871, '', 8, '', 'MEIJENBURG', 'Levinus de Heere', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1732-01-14', 'Rammekens', '1732-06-01', '1732-06-22', true, '1732-09-09', 'Batavia', 6860, 'From 29-02 till 07-03-1732 at S. Tiago: one soldier died and one soldier ran away.');
INSERT INTO "voyages" VALUES (2872, '', 3, '', 'PETRONELLA ALIDA', 'Hendrik Thiedesz.', 550, NULL, '1722', NULL, NULL, 'E', 'E', '1732-01-16', 'Texel', '1732-08-02', '1732-08-31', true, '1732-11-11', 'Batavia', 6872, 'At Plymouth from 29-01 till 15-03-1732: 3 seafarers deserted and two seafarers died there.');
INSERT INTO "voyages" VALUES (2873, '', 5, '', 'GOUDRIAAN', 'Kornelis de Ruiter', 630, 'fluit', '1719', NULL, NULL, 'D', 'D', '1732-04-22', 'Goeree', '1732-08-15', '1732-08-31', true, '1732-11-08', 'Batavia', 6936, NULL);
INSERT INTO "voyages" VALUES (2874, '', 2, '', 'ALBLASSERDAM', 'Joris van Kleef', 600, NULL, '1725', NULL, NULL, 'D', 'D', '1732-04-30', 'Goeree', '1732-08-22', '1732-09-06', true, '1732-12-07', 'Batavia', 6875, NULL);
INSERT INTO "voyages" VALUES (2875, '', 6, '', 'BARBESTEIN', 'Jan van Est', 1100, NULL, '1717', NULL, NULL, 'Z', 'Z', '1732-05-14', 'Rammekens', '1732-11-07', '1732-12-06', true, '1733-04-10', 'Batavia', NULL, 'TER HOGE (2877) came aboard. The ship was wrecked at Gale on 23-10-1735.');
INSERT INTO "voyages" VALUES (2876, '', 1, '', 'HOFWEGEN', 'Jan Krielaard', 650, NULL, '1731', NULL, NULL, 'R', 'R', '1732-05-14', 'Goeree', '1732-09-04', '1732-09-19', true, '1733-01-14', 'Batavia', 6953, NULL);
INSERT INTO "voyages" VALUES (2877, '', 3, '', 'SLOT TER HOGE', 'Willem de Smit', 850, NULL, '1726', NULL, NULL, 'Z', 'Z', '1732-05-14', 'Rammekens', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked at Ilha de Mayo on 19-06-1732. Wreck discovered.');
INSERT INTO "voyages" VALUES (2878, '', 1, '', 'HUIS DEN EULT', 'Theunis Goedhart', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1732-05-15', 'Texel', '1732-11-14', '1732-12-18', true, '1733-08-26', 'Ceylon', 6996, NULL);
INSERT INTO "voyages" VALUES (2879, '', 8, '', 'ELISABETH', 'Hendrik Klooster', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1732-05-15', 'Texel', '1732-11-14', '1732-12-07', true, '1733-03-20', 'Batavia', NULL, 'aboard. Laid up at Batavia on 04-07-1738.');
INSERT INTO "voyages" VALUES (2880, '', 1, '', 'HUIS TE FOREEST', 'Dirk de Vet', 850, NULL, '1731', NULL, NULL, 'H', 'H', '1732-05-15', 'Texel', '1732-11-16', '1732-12-15', true, '1733-05-10', 'Batavia', 6905, '25-05 till 30-05-1732. At S. Tiago from 05-07 till 14-07-1732. 4 Seafarers and 2 soldiers from the SLOT TER HOGE (2877) came aboard there.');
INSERT INTO "voyages" VALUES (2881, '', 4, '', 'KARSENHOF', 'Kornelis Loukens', 800, NULL, '1723', NULL, NULL, 'A', 'A', '1732-05-15', 'Texel', '1732-11-16', '1732-12-18', true, '1723-04-27', 'Ceylon', 6886, NULL);
INSERT INTO "voyages" VALUES (2882, '', 5, '', 'LOENDERVEEN', 'Pieter Goedhart', 650, 'fluit', '1718', NULL, NULL, 'A', 'A', '1732-05-15', 'Texel', '1732-12-27', '1733-01-25', true, '1733-09-11', 'Ceylon', NULL, NULL);
INSERT INTO "voyages" VALUES (2883, '', 3, '', 'REIGERSBROEK', 'Kornelis Roobol', 600, NULL, '1726', NULL, NULL, 'A', 'E', '1732-05-15', 'Texel', '1732-11-16', '1732-12-18', true, '1733-06-04', 'Batavia', 6908, '26-06-1732; from SLOT TER HOGE (2877) 26 seafarers and 16 soldiers came aboard.');
INSERT INTO "voyages" VALUES (2884, '', 1, '', 'JONGE WILLEM', 'Duncan Lauchlon', 650, NULL, '1731', NULL, NULL, 'Z', 'Z', '1732-05-15', 'Rammekens', '1732-11-08', '1732-12-07', true, '1733-04-10', 'Batavia', 6966, 'The ship was at first called WALCHEREN, but it was renamed. At S. Tiago from 20-06 till 26-06-1732. On 28-03-1733 28 men went over to the HERSTELLING (2855).');
INSERT INTO "voyages" VALUES (2885, '', 1, '', 'BETHLEHEM', 'Jakob van der Beek', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1732-06-15', 'Texel', '1732-11-08', '1732-12-07', true, '1733-02-26', 'Batavia', 6888, NULL);
INSERT INTO "voyages" VALUES (2886, '', 4, '', 'SUSANNA', 'Pieter Kronenburg', 600, NULL, '1721', NULL, NULL, 'A', 'A', '1732-07-04', 'Texel', '1732-11-13', '1732-12-07', true, '1733-02-21', 'Batavia', NULL, 'Wrecked at Rembang in 1737.');
INSERT INTO "voyages" VALUES (2887, '', 5, '', 'BERKENRODE', 'Daniel Overbeek', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1732-11-05', 'Texel', '1733-02-19', '1733-03-18', true, '1733-06-01', 'Batavia', 6887, 'Back at Texel from 10-11 till 13-11-1732.');
INSERT INTO "voyages" VALUES (2888, '', 3, '', 'COXHOORN', 'Jan Kranenburg', 450, NULL, '1728', NULL, NULL, 'A', 'A', '1732-11-05', 'Texel', '1733-02-19', '1733-03-27', true, '1733-06-05', 'Batavia', 6935, 'Back at Texel from 08-11 till 13-11-1732.');
INSERT INTO "voyages" VALUES (2889, '', 1, '', 'ELSBROEK', 'Hendrik Opmeer', 350, NULL, '1732', NULL, NULL, 'A', 'A', '1732-11-05', 'Texel', '1733-03-09', '1733-03-27', true, '1733-07-02', 'Batavia', 6950, 'Back at Texel from 08-11 till 13-11-1732.');
INSERT INTO "voyages" VALUES (2890, '', 2, '', 'FLORA', 'Adriaan van Leeuwen', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1732-11-05', 'Texel', '1733-03-25', '1733-04-12', true, '1733-07-03', 'Batavia', 6889, 'Back at Texel from 09-11 till 13-11-1732.');
INSERT INTO "voyages" VALUES (2891, '', 5, '', 'HAAKSBURG', 'Kornelis Lans', 600, NULL, '1718', NULL, NULL, 'E', 'R', '1732-11-05', 'Goeree', '1733-03-15', '1733-04-02', true, '1733-07-06', 'Batavia', NULL, 'Laid up at Batavia in 1740.');
INSERT INTO "voyages" VALUES (2892, '', 1, '', 'PADDENBURG', 'Dirk Prest', 850, NULL, '1732', NULL, NULL, 'A', 'A', '1732-11-05', 'Texel', '1733-03-13', '1733-04-01', true, '1733-07-01', 'Batavia', 6893, 'Back at Texel from 08-11 till 13-11-1732.');
INSERT INTO "voyages" VALUES (2893, '', 8, '', 'PRATTENBURG', 'Gerrit Pik', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1732-11-05', 'Texel', '1733-02-27', '1733-03-18', true, '1733-06-04', 'Batavia', NULL, 'Back at Texel from 08-11 till 13-11-1732. Laid up at Batavia on 12-09-1738.');
INSERT INTO "voyages" VALUES (2894, '', 1, '', 'HUIS TE SPIJK', 'Dignus de Vlaming', 650, NULL, '1732', NULL, NULL, 'D', 'D', '1732-11-05', 'Goeree', '1733-03-05', '1733-03-27', true, '1733-07-01', 'Batavia', 6883, NULL);
INSERT INTO "voyages" VALUES (2895, '', 2, '', 'LEIDUIN', 'Jan de Haan', 650, NULL, '1730', NULL, NULL, 'A', 'A', '1732-11-26', 'Texel', '1733-04-14', '1733-05-03', true, '1733-09-07', 'China', 6898, 'From 28-11 till 18-12-1732 at Rammekens.');
INSERT INTO "voyages" VALUES (2896, '', 1, '', 'VOORDUIN', 'Lambert Zwaan', 650, NULL, '1732', NULL, NULL, 'A', 'A', '1732-11-26', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'On 02-12-1732 at Rammekens; from now on the VOORDUIN was called ZORGWIJK (2920).');
INSERT INTO "voyages" VALUES (2897, '', 5, '', 'NIEUWVLIET', 'Gerrit Fiers', 650, NULL, '1719', NULL, NULL, 'Z', 'Z', '1732-12-18', 'Rammekens', '1733-04-12', '1733-04-26', true, NULL, 'China', 6899, NULL);
INSERT INTO "voyages" VALUES (2898, '', 5, '', 'VIS', 'Lukas Semeyns', 600, 'fluit', '1716', NULL, NULL, 'E', 'E', '1732-12-18', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'state the ship was sold at Lisbon on 01-02-1733. The EENDRACHT (now called NIEUWE VIS) (2925) took over the cargo on 08-09-1733. 37 Seafarers, 9 soldiers and 5 craftsmen deserted at Lisbon.');
INSERT INTO "voyages" VALUES (2899, '', 1, '', 'NIEUW WALCHEREN', 'Jan van den Elske', 850, NULL, '1731', NULL, NULL, 'Z', 'Z', '1732-12-18', 'Rammekens', '1733-05-15', '1733-05-30', true, '1733-08-08', 'Batavia', 6884, 'From 19-02 till 24-02-1733 at S. Tiago: 3 seafarers and 1 soldier ran away.');
INSERT INTO "voyages" VALUES (2900, '', 6, '', 'ZOETELINGSKERKE', 'Pieter Obrv', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1732-12-18', 'Rammekens', '1733-04-17', '1733-05-20', true, '1733-07-31', 'Batavia', 6885, NULL);
INSERT INTO "voyages" VALUES (2901, '', 6, '', 'HILLEGONDA', 'Kornelis Damme', 850, NULL, '1720', NULL, NULL, 'H', 'Z', '1733-01-29', 'Rammekens', '1733-05-18', '1733-05-30', true, '1733-08-10', 'Batavia', 6878, NULL);
INSERT INTO "voyages" VALUES (2902, '', 1, '', 'RITTHEM', 'Jan van den Broek', 350, NULL, '1732', NULL, NULL, 'Z', 'Z', '1733-01-29', 'Rammekens', '1733-07-23', '1733-09-05', true, '1733-12-26', 'Batavia', 6902, 'From 15-03 till 15-04-1733 at Plymouth.');
INSERT INTO "voyages" VALUES (2903, '', 2, '', 'VOORDUIN', 'Lambert Zwaan', 650, NULL, '1730', NULL, NULL, 'A', 'Z', '1733-01-29', 'Rammekens', NULL, NULL, true, NULL, 'China', 6900, 'was equipped by the chamber Zeeland for Amsterdam.');
INSERT INTO "voyages" VALUES (2904, '', 2, '', 'DUINBEEK', 'Pieter Visser', 800, NULL, '1727', NULL, NULL, 'Z', 'A', '1733-01-31', 'Texel', '1733-07-24', '1733-08-19', true, NULL, 'Ceylon', 6920, NULL);
INSERT INTO "voyages" VALUES (2905, '', 4, '', 'HOGERSMILDE', 'Dirk Mulder', 810, NULL, '1723', NULL, NULL, 'A', 'A', '1733-01-31', 'Texel', '1733-07-03', '1733-07-19', true, '1733-10-02', 'Batavia', 6880, 'From 05-02 till 21-03-1733 at Falmouth; 1 seafarer died there.');
INSERT INTO "voyages" VALUES (2906, '', 7, '', 'STAD LEIDEN', 'Isaak Hage', 1140, NULL, '1718', NULL, NULL, 'A', 'A', '1733-01-31', 'Texel', '1733-06-21', '1733-07-19', true, '1733-10-28', 'Batavia', NULL, 'From 05-02 till 21-03-1733 at Falmouth; 6 seafarers died there. On 12-09-1738 laid up at Batavia.');
INSERT INTO "voyages" VALUES (2907, '', 5, '', 'OPPERDOES', 'Jan de Roeper', 600, 'fluit', '1718', NULL, NULL, 'H', 'H', '1733-01-31', 'Texel', '1733-08-13', '1733-09-09', true, '1733-11-25', 'Batavia', 6892, 'From 05-02 till 21-03-1733 at Falmouth; 1 seafarer ran away there.');
INSERT INTO "voyages" VALUES (2908, '', 2, '', 'PAPENBURG', 'Dirk de Vet', 800, NULL, '1729', NULL, NULL, 'A', 'A', '1733-01-31', 'Texel', '1733-08-13', '1733-09-05', true, NULL, 'Ceylon', 6922, 'From 05-02 till 21-03-1733 at Falmouth.');
INSERT INTO "voyages" VALUES (2909, '', 7, '', 'SPIERING', 'Jan Meulman', 810, NULL, '1714', NULL, NULL, 'D', 'A', '1733-01-31', 'Texel', '1733-05-20', '1733-06-05', true, '1733-08-28', 'Batavia', 6882, NULL);
INSERT INTO "voyages" VALUES (2910, '', 1, '', 'G ROET', 'Reinier Brugman', 850, NULL, '1732', NULL, NULL, 'A', 'A', '1733-02-26', 'Texel', '1733-08-27', '1733-09-09', true, '1734-01-10', 'Batavia', 6901, 'From 21-04- till 01-05-1733 at S. Tiago: 2 seaferers from SLOT TER HOGE (2877) came aboard.');
INSERT INTO "voyages" VALUES (2911, '', 6, '', 'MAGDALENA', 'Kornelis van der Kolster', 600, NULL, '1719', NULL, NULL, 'H', 'D', '1733-04-15', 'Goeree', '1733-08-20', '1733-09-16', true, '1733-11-19', 'Batavia', 6891, 'One soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2912, '', 7, '', 'VALKENISSE', 'Elias Moeninx', 1150, NULL, '1716', NULL, NULL, 'Z', 'Z', '1733-04-17', 'Rammekens', '1733-10-31', '1733-11-08', true, '1734-01-21', 'Batavia', NULL, 'From 02-07 till 10-07-1733 at Guinea: 1 seafarer deserted. Wrecked at Bantam in September 1740.');
INSERT INTO "voyages" VALUES (2913, '', 4, '', 'KROOSWIJK', 'de Witt', 600, 'fluit', '1720', NULL, NULL, 'R', 'D', '1733-04-23', 'Goeree', '1733-09-18', '1733-10-14', true, '1734-01-21', 'Batavia', 6907, 'From 20-08 till 17-10-1733 at Saldanha Bay.');
INSERT INTO "voyages" VALUES (2914, '', 5, '', 'NOORDWADDINXVEEN', 'Jan van der Quade', 850, NULL, '1718', NULL, NULL, 'R', 'R', '1733-04-27', 'Goeree', '1733-09-03', '1733-10-14', true, '1734-01-24', 'Batavia', 6929, 'At Duins from 29-04 till 02-05-1733.');
INSERT INTO "voyages" VALUES (2915, '', 2, '', 'BUIS', 'Gerrit Kuit', 600, NULL, '1727', NULL, NULL, 'E', 'H', '1733-04-29', 'Texel', '1733-09-11', '1733-10-14', true, '1734-01-24', 'Batavia', 6904, NULL);
INSERT INTO "voyages" VALUES (2916, '', 5, '', 'DELFLAND', 'Klaas Molenaar', 600, 'fluit', '1717', NULL, NULL, 'D', 'A', '1733-05-13', 'Texel', '1733-10-08', '1733-11-06', true, '1734-02-06', 'Batavia', 7009, NULL);
INSERT INTO "voyages" VALUES (2917, '', 1, '', 'NOORDWIJKERHOUT', 'Jan Mijndertsz.', 350, NULL, '1732', NULL, NULL, 'A', 'A', '1733-05-13', 'Texel', '1733-12-27', '1734-02-12', true, '1734-07-26', 'Batavia', 6981, 'At the Cape the master went over to the VAN ALSEM (2921); he was succeeded by Dirk van Gunster.');
INSERT INTO "voyages" VALUES (2918, '', 8, '', 'GROENSWAART', 'Samuel Hendriksz.', 600, 'fluit', '1714', NULL, NULL, 'R', 'Z', '1733-05-20', 'Rammekens', '1733-11-04', '1734-01-01', true, '1734-04-23', 'Ceylon', NULL, 'Laid up a at Batavia in 1740.');
INSERT INTO "voyages" VALUES (2919, '', 1, '', 'POPKENSBURG', 'Jakob Jongerhelt', 850, NULL, '1732', NULL, NULL, 'Z', 'Z', '1733-05-20', 'Rammekens', '1733-10-25', '1733-12-06', true, '1734-03-13', 'Batavia', 6962, NULL);
INSERT INTO "voyages" VALUES (2920, '', 2, '', 'ZORGWIJK', 'Jan Bot', 650, NULL, '1732', NULL, NULL, 'A', 'Z', '1733-05-20', 'Rammekens', '1733-11-20', '1734-01-21', true, '1734-05-11', 'Ceylon', 6947, 'From now on the VOORDUIN (2896) was called the ZORG-WIJK.');
INSERT INTO "voyages" VALUES (2921, '', 1, '', 'ALSEM', 'Jan Hokkeling', 650, NULL, '1732', NULL, NULL, 'A', 'A', '1733-07-06', 'Texel', '1733-12-29', '1734-02-05', true, '1734-07-18', 'Batavia', NULL, 'Jan Hokkeling remained at the Cape and was succeeded by Jan Mijndertsz.');
INSERT INTO "voyages" VALUES (2922, '', 4, '', 'BLIJDORP', 'Haije Blauwhuis', 900, NULL, '1723', NULL, NULL, 'R', 'A', '1733-07-06', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'At Duins from 09-07 till 12-07-1733. On 05-08-1733 wrecked at the Cape Verde Islands.');
INSERT INTO "voyages" VALUES (2923, '', 5, '', 'HAFTEN', 'Adriaan van der Graaf', 600, 'fluit', '1717', NULL, NULL, 'A', 'A', '1733-07-06', 'Texel', '1733-12-14', '1734-02-12', true, '1734-06-06', 'Batavia', NULL, 'At the Cape Evert Kiekebos succeeded Van der Graaf. At Duins from 09-07 till 12-07-1733. Laid up at Batavia on 06-10-1741.');
INSERT INTO "voyages" VALUES (2924, '', 6, '', 'CASTRICUM', 'Hendrik Oterlijk', 1150, NULL, '1722', NULL, NULL, 'A', 'A', '1733-08-08', 'Texel', '1733-11-26', '1733-12-14', true, '1734-03-07', 'Batavia', 6933, NULL);
INSERT INTO "voyages" VALUES (2925, '', 1, '', 'NIEUWE VIS', 'Lukas Semeyns', 650, NULL, '1732', NULL, NULL, 'E', 'E', '1733-08-08', 'Texel', '1734-03-08', '1734-03-27', true, '1734-07-03', 'Batavia', 6931, 'This ship was at first called EENDRACHT. Took over the cargo of the VIS (2898) at Lisbon; left on 15-10-1733. Data of those on board concern departure from Lisbon.)');
INSERT INTO "voyages" VALUES (2926, '', 3, '', 'LAGE POLDER', 'Jakob Sombeek', 580, NULL, '1725', NULL, NULL, 'E', 'E', '1733-08-08', 'Texel', '1734-03-02', '1734-04-04', true, '1734-07-25', 'Batavia', 6917, 'At Lisbon from 08-09 till 15-10-1733; 16 seafarers and 16 soldiers went to the NIEUWE VIS (2925).');
INSERT INTO "voyages" VALUES (2927, '', 3, '', 'ADRICHEM', 'Samuel Hoppestijn van Leeuwen', 850, NULL, '1726', NULL, NULL, 'A', 'D', '1733-10-28', 'Goeree', '1734-04-06', '1734-04-21', true, '1734-06-20', 'Batavia', 6927, NULL);
INSERT INTO "voyages" VALUES (2928, '', 2, '', 'MARIA ADRIANA', 'Pieter Kaas', 650, NULL, '1730', NULL, NULL, 'R', 'R', '1733-10-28', 'Goeree', '1734-04-08', '1734-04-28', true, '1734-07-18', 'Batavia', 6941, NULL);
INSERT INTO "voyages" VALUES (2929, '', 3, '', 'BEEKVLIET', 'Elias Hogervorst', 850, NULL, '1724', NULL, NULL, 'A', 'A', '1734-01-17', 'Texel', '1734-04-27', '1734-05-19', true, '1734-07-14', 'Batavia', 6910, NULL);
INSERT INTO "voyages" VALUES (2930, '', 1, '', 'HILLEGOM', 'Jan Almees', 1150, NULL, '1733', NULL, NULL, 'A', 'A', '1734-01-17', 'Texel', '1734-05-01', '1734-05-25', true, '1734-07-25', 'Batavia', 6912, '1 Seafarer went to the KERKWIJK (2932).');
INSERT INTO "voyages" VALUES (2931, '', 2, '', 'IEPENRODE', 'Dirk Elsberg', 650, NULL, '1731', NULL, NULL, 'A', 'A', '1734-01-17', 'Texel', '1734-05-01', '1734-05-20', true, '1734-07-20', 'Batavia', 6991, NULL);
INSERT INTO "voyages" VALUES (2932, '', 1, '', 'KERKWIJK', 'Pieter Sluis', 850, NULL, '1733', NULL, NULL, 'A', 'A', '1734-01-17', 'Texel', '1734-05-01', '1734-05-25', true, '1734-07-31', 'Batavia', 6921, NULL);
INSERT INTO "voyages" VALUES (2933, '', 2, '', 'LOOSDRECHT', 'Bastiaan Mol', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1734-01-17', 'Texel', '1734-04-30', '1734-05-19', true, '1734-07-30', 'Batavia', 6913, NULL);
INSERT INTO "voyages" VALUES (2934, '', 1, '', 'NIEUWSTAD', 'Lodewijk Verburg', 650, NULL, '1733', NULL, NULL, 'H', 'H', '1734-01-17', 'Texel', '1734-05-03', '1734-05-27', true, '1734-07-31', 'Batavia', 6915, '1 Soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2935, '', 1, '', 'NOORDWOLFSBERGEN', 'Hendrik Perfekt', 650, NULL, '1733', NULL, NULL, 'A', 'A', '1734-01-17', 'Texel', '1734-04-29', '1734-05-16', true, NULL, 'China', 6934, NULL);
INSERT INTO "voyages" VALUES (2936, '', 5, '', 'EVERSWAART', 'Anthonie van Doorn', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1734-01-21', 'Rammekens', '1734-04-27', '1734-05-17', true, '1734-07-12', 'Batavia', 6939, 'One seafarer and one soldier went over to the WESTKAPELLE (2942), two seafarers from the WESTKAPELLE and the MEIJENBURG (2938) came on board.');
INSERT INTO "voyages" VALUES (2937, '', 2, '', 'MEERMOND', 'Willem Vroom', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1734-01-21', 'Texel', '1734-05-01', '1734-05-27', true, '1734-08-30', 'Ceylon', 6928, NULL);
INSERT INTO "voyages" VALUES (2938, '', 9, '', 'IMEIJENBURG', 'Kornelis Fret', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1734-01-21', 'Rammekens', '1734-04-27', '1734-05-17', true, '1734-07-14', 'Batavia', 6914, 'Three seafarers went over to the EVERSWAART (2936), the VLISSINGEN (2941) and the WESTKAPELLE (2942) respectively,');
INSERT INTO "voyages" VALUES (2939, '', 5, '', 'PURMERLUST', 'Hans Faggerdal', 580, NULL, '1718', NULL, NULL, 'A', 'A', '1734-01-21', 'Texel', '1734-04-29', '1734-06-25', true, '1734-08-22', 'Batavia', NULL, 'Laid up at Batavia on 17-04-1739.');
INSERT INTO "voyages" VALUES (2940, '', 6, '', 'STEENHOVEN', 'Leonard de Rijke', 850, NULL, '1718', NULL, NULL, 'Z', 'Z', '1734-01-21', 'Rammekens', '1734-04-27', '1734-05-17', true, '1734-07-15', 'Batavia', 6977, NULL);
INSERT INTO "voyages" VALUES (2941, '', 1, '', 'VLISSINGEN', 'Levinus de Heere', 650, NULL, '1732', NULL, NULL, 'Z', 'Z', '1734-01-21', 'Rammekens', '1734-04-30', '1734-05-21', true, '1734-07-25', 'Batavia', 6918, 'One seafarer went over to the STEENHOVEN (2940). One soldier became a seafarer. One soldier went over to the WESTKA-PELLE (2942) and from the WESTKAPELLE one seafarer came on board.');
INSERT INTO "voyages" VALUES (2942, '', 2, '', 'WESTKAPELLE', 'Pieter Bruis', 850, NULL, '1730', NULL, NULL, 'Z', 'Z', '1734-01-21', 'Rammekens', '1734-04-27', '1734-05-17', true, '1734-07-14', 'Batavia', 6919, 'One seafarer went over to the EVERSWAART (2936), five seafarers came on board from the VLISSINGEN (2941), the STEENHOVEN (2940), the MEIJENBURG (2938), and the EVERSWAART.');
INSERT INTO "voyages" VALUES (2943, '', 6, '', 'STADWIJK', 'Jan Bouritius', 1150, NULL, '1720', NULL, NULL, 'A', 'A', '1734-01-22', 'Texel', '1734-05-02', '1734-05-27', true, '1734-08-30', 'Ceylon', NULL, 'Laid up at Batavia on 05-09-1739.');
INSERT INTO "voyages" VALUES (2944, '', 4, '', 'KASTEEL VAN WOERDEN', 'Johannes Karsteman +', 850, NULL, '1722', NULL, NULL, 'D', 'E', '1734-01-22', 'Texel', '1734-05-04', '1734-05-25', true, '1734-08-27', 'Batavia', 6909, 'Johannes Karsteman died and was succeeded by Kornelis van der Hoeve.');
INSERT INTO "voyages" VALUES (2945, '', 5, '', 'GAASPERDAM', 'Joris Davidson', 1150, NULL, '1724', NULL, NULL, 'A', 'A', '1734-01-23', 'Texel', '1734-04-27', '1734-05-19', true, '1734-07-22', 'Batavia', 6911, NULL);
INSERT INTO "voyages" VALUES (2946, '', 2, '', 'KNAPPENHOF', 'Jakob Gosen Hoogstad', 650, NULL, '1731', NULL, NULL, 'A', 'A', '1734-01-23', 'Texel', '1734-05-01', '1734-05-25', true, '1734-09-22', 'Batavia', 6906, 'One soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2947, '', 1, '', 'SLOT KRONENBURG', 'Jan van Engelen', 350, NULL, '1733', NULL, NULL, 'A', 'A', '1734-01-23', 'Texel', '1734-05-03', '1734-05-19', true, '1734-07-25', 'Batavia', 6926, NULL);
INSERT INTO "voyages" VALUES (2948, '', 4, '', 'SCHUITWIIK', 'Gerrit Bijleveld', 650, NULL, '1724', NULL, NULL, 'E', 'Z', '1734-03-12', 'Rammekens', '1734-08-08', '1734-08-23', true, '1734-11-01', 'Batavia', 6923, '17-04-1734 at Duins.');
INSERT INTO "voyages" VALUES (2949, '', 5, '', 'WICKENBURG', 'Pieter Zwanendrecht', 850, NULL, '1722', NULL, NULL, 'Z', 'Z', '1734-03-12', 'Rammekens', '1734-09-03', '1734-09-17', true, '1734-12-12', 'Batavia', 6960, 'soldier became a seafarer; 1 seafarer came from DEN DAM (2952).');
INSERT INTO "voyages" VALUES (2950, '', 1, '', 'BOOT', 'Pieter Scherf', 650, NULL, '1733', NULL, NULL, 'R', 'R', '1734-03-24', 'Goeree', '1734-08-31', '1734-09-17', true, '1734-12-02', 'Batavia', 6932, 'seafarer went over to the SCHONAUWEN (2953); 1 soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2951, '', 3, '', 'ALBLASSERDAM', 'Michiel Vonk', 600, NULL, '1725', NULL, NULL, 'D', 'A', '1734-04-25', 'Texel', '1734-09-01', '1734-09-17', true, '1734-12-12', 'Batavia', NULL, 'Chinese coast on its outward bound voyage to China.');
INSERT INTO "voyages" VALUES (2952, '', 7, '', 'DEN DAM', 'Kornelis de Ruiter', 600, 'fluit', '1716', NULL, NULL, 'D', 'D', '1734-04-25', 'Goeree', '1734-09-01', '1734-09-17', true, '1734-12-11', 'Batavia', NULL, 'One soldier became a seafarer. One seafarer went to the IEPEN-BURG (2949). The ship was laid up at Batavia on 18-09-1742.');
INSERT INTO "voyages" VALUES (2953, '', 2, '', 'SCHONAUWEN', 'Christiaan Bakker', 600, NULL, '1729', NULL, NULL, 'A', 'A', '1734-04-25', 'Texel', '1734-09-02', '1734-10-15', true, '1735-01-30', 'Batavia', 6965, 'One soldier became a seafarer.');
INSERT INTO "voyages" VALUES (2954, '', 3, '', 'MEERLUST', 'Michiel de Reus', 600, NULL, '1725', NULL, NULL, 'A', 'H', '1734-05-28', 'Texel', '1735-01-01', '1735-02-07', true, '1735-05-29', 'Batavia', 6959, 'One soldier became a seafarer. The master Michiel de Reus was succeeded by Dirk Goudberg. From 21-06 till 30-06-1734 at S. Tiago: two soldiers deserted. On 25-12-1734 at Robben Island.');
INSERT INTO "voyages" VALUES (2955, '', 3, '', 'HOF NIET ALTIJD WINTER', 'Pieter Palm', 650, NULL, '1723', NULL, NULL, 'Z', 'A', '1734-05-28', 'Texel', '1734-10-31', '1734-11-28', true, '1735-02-28', 'Batavia', 7051, 'At S. Tiago from 21-07 till 31-07-1734.');
INSERT INTO "voyages" VALUES (2956, '', 5, '', 'KETEL', 'Adriaan Krielaard', 810, NULL, '1721', NULL, NULL, 'R', 'R', '1734-06-01', 'Goeree', '1734-12-18', '1735-01-13', true, '1735-05-19', 'Batavia', 6958, 'away.');
INSERT INTO "voyages" VALUES (2957, '', 5, '', 'HOF NIET ALTIJD ZOMER', 'Mauritius van der Star', 600, 'fluit', '1718', NULL, NULL, 'Z', 'E', '1734-06-01', 'Texel', '1734-11-01', '1734-11-28', true, '1735-02-28', 'Batavia', 6963, '31-10-1734.');
INSERT INTO "voyages" VALUES (2958, '', 1, '', 'HUIS TE RENSBURG', 'Kornelis Nannings', 850, NULL, '1733', NULL, NULL, 'Z', 'Z', '1734-06-08', 'Rammekens', '1734-10-31', '1734-11-28', true, '1735-01-29', 'Batavia', 6957, 'At S. Tiago from 02-08 till 07-08-1734. Two soldiers came on board from the MEERLUST (2954).');
INSERT INTO "voyages" VALUES (2959, '', 4, '', 'LANDSKROON', 'Marten Burgers', 850, NULL, '1725', NULL, NULL, 'A', 'A', '1734-06-15', 'Texel', '1734-12-07', '1735-01-05', true, '1735-04-26', 'Batavia', 6954, NULL);
INSERT INTO "voyages" VALUES (2960, '', 1, '', 'NIEUWLAND', 'Michiel Keizer', 850, NULL, '1733', NULL, NULL, 'Z', 'Z', '1734-06-30', 'Rammekens', '1734-11-22', '1734-12-10', true, '1735-02-26', 'Batavia', 6955, 'From 09-07 till 18-07-1734 at Portsmouth. from 15-08 till 21-08-1734 at S. Tiago; from 09-11 till 21-11-1734 at Saldanha Bay.');
INSERT INTO "voyages" VALUES (2961, '', 6, '', 'OOSTRUST', 'Lukas Hardenbroek', 1140, NULL, '1721', NULL, NULL, 'A', 'A', '1734-08-24', 'Texel', '1735-04-09', '1735-04-27', true, '1735-08-01', 'Batavia', 6942, 'From 13-09 till 02-11-1734 at Plymouth: 9 men deserted.');
INSERT INTO "voyages" VALUES (2962, '', 6, '', 'CORNELIA', 'Hendrik Hessing', 800, NULL, '1721', NULL, NULL, 'H', 'H', '1734-10-16', 'Texel', '1735-04-08', '1735-04-27', true, '1735-08-23', 'Batavia', 6937, 'From 12-12 till 21-12-1734 at S. Tiago.');
INSERT INTO "voyages" VALUES (2963, '', 4, '', 'PETRONELLA ALIDA', 'Nikolaas du Moulin', 550, NULL, '1722', NULL, NULL, 'E', 'E', '1734-10-16', 'Texel', '1735-03-16', '1735-04-01', true, '1735-07-08', 'Batavia', 6943, 'From 16-02 till 15-03-1735 at Saldanha Bay.');
INSERT INTO "voyages" VALUES (2964, '', 1, '', 'GOIDSCHALXOORD', 'Willem van der Tijd', 850, 'fluit', '1734', NULL, NULL, 'A', 'A', '1734-10-27', 'Texel', '1735-03-04', '1735-04-15', true, '1735-06-07', 'Batavia', 6940, NULL);
INSERT INTO "voyages" VALUES (2965, '', 2, '', 'HUIS TE SPIJK', 'Kornelis Oterlijk', 650, NULL, '1732', NULL, NULL, 'D', 'A', '1734-10-27', 'Texel', '1735-02-20', '1735-03-15', true, '1735-05-24', 'Batavia', 6987, NULL);
INSERT INTO "voyages" VALUES (2966, '', 1, '', 'VENENBURG', 'Jakob Popta', 650, NULL, '1734', NULL, NULL, 'A', 'A', '1734-10-27', 'Texel', '1735-03-05', '1735-04-21', true, '1735-07-22', 'Batavia', 6945, NULL);
INSERT INTO "voyages" VALUES (2967, '', 1, '', 'RUST EN WERK', 'Joris van Kleef', 650, NULL, '1734', NULL, NULL, 'D', 'D', '1734-11-13', 'Goeree', '1735-02-26', '1735-03-15', true, '1735-06-09', 'Batavia', 6944, NULL);
INSERT INTO "voyages" VALUES (2968, '', 1, '', 'HARTENLUST', 'Viktor van der Kaag', 650, NULL, '1734', NULL, NULL, 'A', 'A', '1734-11-19', 'Texel', '1735-02-25', '1735-03-15', true, '1735-05-19', 'Batavia', 6951, NULL);
INSERT INTO "voyages" VALUES (2969, '', 1, '', 'MIDDENRAK', 'Jan van Arras', 350, NULL, '1734', NULL, NULL, 'A', 'A', '1734-11-19', 'Texel', '1735-03-01', '1735-03-18', true, '1735-06-10', 'Batavia', 7026, NULL);
INSERT INTO "voyages" VALUES (2970, '', 8, '', 'SPIERING', 'Johannes Verklocken', 810, NULL, '1714', NULL, NULL, 'D', 'A', '1734-11-19', 'Texel', '1735-02-24', '1735-03-15', true, '1735-05-25', 'Batavia', NULL, 'At Robben Island 21-02-1735. Wrecked on 10-03-1740 at the island of Watubela near Banda.');
INSERT INTO "voyages" VALUES (2971, '', 2, '', 'HOFVLIET', 'Jakob van Banken', 1000, NULL, '1729', NULL, NULL, 'R', 'R', '1734-11-22', 'Goeree', '1735-03-03', '1735-03-18', true, '1735-06-09', 'Batavia', 6970, NULL);
INSERT INTO "voyages" VALUES (2972, '', 2, '', 'NIEUW WALCHEREN', '2 Kornelis Damme', 850, NULL, '1731', NULL, NULL, 'Z', 'Z', '1734-11-22', 'Rammekens', '1735-03-03', '1735-03-18', true, '1735-06-10', 'Batavia', 6979, NULL);
INSERT INTO "voyages" VALUES (2973, '', 7, '', 'ZOETELINGSKERKE', 'Huibrecht op den Dijk', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1734-11-22', 'Rammekens', '1735-03-06', '1735-03-25', true, '1735-06-09', 'Batavia', 6946, NULL);
INSERT INTO "voyages" VALUES (2974, '', 3, '', 'LEIDUIN', 'Pieter van der Leden', 650, NULL, '1730', NULL, NULL, 'A', 'A', '1735-02-01', 'Texel', '1735-07-17', '1735-08-02', true, '1735-10-05', 'Batavia', 6973, 'From 14-04 till 21-04 at S. Tiago where 1 seafarer deserted.');
INSERT INTO "voyages" VALUES (2975, '', 2, '', 'PADDENBURG', 'Arie van Veurden', 850, NULL, '1732', NULL, NULL, 'A', 'A', '1735-02-01', 'Texel', '1735-05-12', '1735-05-31', true, '1735-07-31', 'Ceylon', 6993, NULL);
INSERT INTO "voyages" VALUES (2976, '', 3, '', 'VOORDUIN', 'Adriaan de Ruiter', 650, NULL, '1730', NULL, NULL, 'A', 'A', '1735-02-01', 'Texel', '1735-07-08', '1735-08-02', true, '1735-10-07', 'Batavia', 6978, 'of the VOORDUIN, which during its first voyage (2817/6844) was called ZORGWIJK.');
INSERT INTO "voyages" VALUES (2977, '', 3, '', 'ANNA CATHARINA', 'Jakob de Prinse', 600, NULL, '1728', NULL, NULL, 'Z', 'Z', '1735-02-03', 'Rammekens', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked at departure on 03-02-1735.');
INSERT INTO "voyages" VALUES (2978, '', 2, '', '''T VLIEGEND HART', 'Kornelis van der Horst', 850, NULL, '1729', NULL, NULL, 'Z', 'Z', '1735-02-03', 'Rammekens', NULL, NULL, true, NULL, NULL, NULL, 'Wrecked at departure on 03-02-1735.');
INSERT INTO "voyages" VALUES (2979, '', 6, '', 'BERKENRODE', 'Gerrit Klinkhamer', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1735-02-25', 'Texel', '1735-06-02', '1735-06-25', true, '1735-09-13', 'Batavia', 6948, 'From 16 till 18-03-1735 at Duins.');
INSERT INTO "voyages" VALUES (2980, '', 2, '', 'BETHLEHEM', 'Jan Meulman', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1735-02-25', 'Texel', '1735-09-11', '1735-10-04', true, '1735-12-09', 'Batavia', 7023, 'seafarers and 5 soldiers deserted.');
INSERT INTO "voyages" VALUES (2981, '', 4, '', 'KLARABEEK', 'Jan Pereboom', 705, NULL, '1721', NULL, NULL, 'Z', 'H', '1735-02-25', 'Texel', '1735-06-29', '1735-07-17', true, '1735-09-24', 'Batavia', 6949, 'where 4 seafarers deserted.');
INSERT INTO "voyages" VALUES (2982, '', 2, '', 'PROOSTWIJK', 'Jakob Verleng', 650, NULL, '1730', NULL, NULL, 'E', 'A', '1735-02-25', 'Texel', '1735-06-17', '1735-06-28', true, '1735-09-14', 'Batavia', 6982, 'From 16 till 18-03-1735 at Duins.');
INSERT INTO "voyages" VALUES (2983, '', 2, '', 'RITTHEM', 'Jan Elswout', 350, NULL, '1732', NULL, NULL, 'Z', 'Z', '1735-03-19', 'Rammekens', '1735-06-10', '1735-06-28', true, '1735-09-07', 'Batavia', NULL, 'From 05 till 09-06-1735 at Saldanha Bay. Laid up in Bengal on 12-10-1737.');
INSERT INTO "voyages" VALUES (2984, '', 3, '', 'LAND VAN BELOFTEN', 'Hermanus Blom', 520, NULL, '1723', NULL, NULL, 'E', 'E', '1735-03-30', 'Texel', '1735-08-27', '1735-09-22', true, '1735-12-13', 'Batavia', NULL, 'From 02 till 25-08 at Saldanha Bay. Laid up in the Indies on 01-03-1743.');
INSERT INTO "voyages" VALUES (2985, '', 2, '', 'HAAMSTEDE', 'Jakob Bernards', 650, NULL, '1730', NULL, NULL, 'D', 'D', '1735-04-14', 'Goeree', '1735-07-14', '1735-08-02', true, '1735-10-04', 'Batavia', 6968, NULL);
INSERT INTO "voyages" VALUES (2986, '', 5, '', 'PATMOS', 'Willem de Wijs', 810, NULL, '1722', NULL, NULL, 'R', 'R', '1735-04-28', 'Goeree', '1735-08-25', '1735-09-22', true, '1735-11-26', 'Batavia', 6956, NULL);
INSERT INTO "voyages" VALUES (2987, '', 7, '', 'MAGDALENA', 'Willem Cagie', 600, NULL, '1719', NULL, NULL, 'H', 'H', '1735-05-06', 'Texel', '1735-09-27', '1735-10-17', true, '1736-02-17', 'Batavia', 7045, 'One of the soldiers became ondermeester.');
INSERT INTO "voyages" VALUES (2988, '', 6, '', 'OPPERDOES', 'Gerrit van der Tolle', 600, NULL, '1718', NULL, NULL, 'H', 'Z', '1735-05-12', 'Rammekens', '1735-09-19', '1735-10-04', true, '1735-12-20', 'Batavia', NULL, 'Laid up in the Indies on 03-12-1743.');
INSERT INTO "voyages" VALUES (2989, '', 3, '', 'FLORA', 'Arie de lager', 850, NULL, '1730', NULL, NULL, 'A', 'Z', '1735-05-30', 'Rammekens', '1735-10-23', '1735-11-15', true, '1736-02-28', 'Ceylon', 6992, NULL);
INSERT INTO "voyages" VALUES (2990, '', 7, '', 'HILLEGONDA', 'Willem Haysen', 850, NULL, '1720', NULL, NULL, 'H', 'A', '1735-06-01', 'Texel', '1735-09-19', '1735-10-10', true, '1736-01-03', 'Batavia', 7044, 'From 07 till 15-06 at S. Tiago. One of the corporals became third meester.');
INSERT INTO "voyages" VALUES (2991, '', 5, '', 'HOGERSMILDE', 'Gillis Oudemans', 810, NULL, '1723', NULL, NULL, 'A', 'A', '1735-06-01', 'Texel', '1735-09-19', '1735-10-09', true, '1735-12-12', 'Batavia', 6961, 'From 07 till 15-06 at S. Tiago.');
INSERT INTO "voyages" VALUES (2992, '', 1, '', 'LANGEWIJK', 'Matthijs Zwaan', 850, NULL, '1734', NULL, NULL, 'E', 'E', '1735-06-09', 'Texel', '1735-12-26', '1736-01-16', true, '1736-05-04', 'Batavia', 6980, 'From 24-06 till 18-07-1735 at Portsmouth; from 19 till 25-09-1735 at S. Tiago. One of the soldiers became a seafarer.');
INSERT INTO "voyages" VALUES (2993, '', 1, '', 'ABBEKERK', 'Kornelis den Breen', 850, NULL, '1734', NULL, NULL, 'H', 'A', '1735-06-15', 'Texel', '1735-11-12', '1735-12-16', true, '1736-02-27', 'Batavia', 7035, NULL);
INSERT INTO "voyages" VALUES (2994, '', 1, '', 'BEUKESTIJN', 'Klaas Meelhoop', 850, NULL, '1734', NULL, NULL, 'A', 'A', '1735-06-15', 'Texel', '1735-11-07', '1735-12-01', true, '1736-02-27', 'Batavia', 6995, 'One of the soldiers became cook''s wain.');
INSERT INTO "voyages" VALUES (2995, '', 5, '', 'KARSENHOF', 'Adriaan van Rensen', 800, NULL, '1723', NULL, NULL, 'A', 'A', '1735-06-23', 'Texel', '1735-11-19', '1735-12-30', true, '1736-04-19', 'Batavia', 6971, 'One of the soldiers became cook''s wain.');
INSERT INTO "voyages" VALUES (2996, '', 3, '', 'RIDDERKERK', 'Kornelis de Boer', 500, NULL, '1726', NULL, NULL, 'R', 'A', '1735-06-23', 'Texel', '1735-09-29', '1735-10-16', true, '1736-01-02', 'Batavia', 6964, NULL);
INSERT INTO "voyages" VALUES (2997, '', 1, '', 'WESTHOVEN', 'Kornelis Pietersz. Booms', 650, NULL, '1734', NULL, NULL, 'Z', 'Z', '1735-07-16', 'Rammekens', '1735-12-22', '1736-01-19', true, '1736-05-05', 'Batavia', 7016, 'From 19-07 till 01-08 at Duins. From 14 till 25-09 at S. Tiago where 4 seafarers and 1 soldier deserted.');
INSERT INTO "voyages" VALUES (2998, '', 1, '', 'SINT LAURENS', 'Abraham van der Hart', 850, NULL, '1734', NULL, NULL, 'Z', 'Z', '1735-08-09', 'Rammekens', '1735-12-23', '1736-01-29', true, '1736-05-09', 'Batavia', 7033, NULL);
INSERT INTO "voyages" VALUES (2999, '', 6, '', 'NIEUWVLIET', 'Jan de Jager +', 650, NULL, '1719', NULL, NULL, 'Z', 'Z', '1735-10-17', 'Rammekens', '1736-03-10', '1736-04-10', true, '1736-06-22', 'Batavia', 6975, 'till 24-10 at Duins. The NIEUWVLIET replaced the ANNA CATHARINA (2977), wrecked in February 1735.');
INSERT INTO "voyages" VALUES (3000, '', 3, '', 'WESTKAPELLE', 'Abraham Everhard', 850, NULL, '1730', NULL, NULL, 'Z', 'Z', '1735-10-17', 'Rammekens', '1736-03-11', '1736-03-28', true, '1736-06-10', 'Batavia', 6997, 'From 19 till 24-10 at Duins. The WESTKAPELLE replaced the ''T VLIEGEND HART (2978), wrecked in February 1735.');
INSERT INTO "voyages" VALUES (3001, '', 1, '', 'HILVERSBEEK', 'Lambert Zwaan', 850, NULL, '1735', NULL, NULL, 'A', 'A', '1735-10-24', 'Texel', '1736-03-23', '1736-04-14', true, '1736-07-02', 'Batavia', 6969, NULL);
INSERT INTO "voyages" VALUES (3002, '', 2, '', 'NOORDWOLFSBERGEN', 'Jurriaan Lijsen', 650, NULL, '1733', NULL, NULL, 'A', 'A', '1735-10-24', 'Texel', '1736-03-18', '1736-04-14', true, '1736-07-09', 'Batavia', 7078, 'From 11 till 17-03 at Robben Island. One of the soldiers became cook''s wain.');
INSERT INTO "voyages" VALUES (3003, '', 3, '', 'KNAPPENHOF', 'Arie van der Stolk', 650, NULL, '1731', NULL, NULL, 'A', 'R', '1735-10-25', 'Goeree', '1736-04-09', '1736-04-23', true, '1736-07-13', 'Batavia', 7022, 'Two soldiers became third meesters.');
INSERT INTO "voyages" VALUES (3004, '', 1, '', 'SCHEIJBEEK', 'Jan de Haan', 850, NULL, '1735', NULL, NULL, 'A', 'A', '1735-10-25', 'Texel', '1736-03-23', '1736-04-15', true, '1736-07-09', 'Batavia', 6976, 'three passengers included one female slave.');
INSERT INTO "voyages" VALUES (3005, '', 2, '', 'NIEUWSTAD', 'Lukas Rozeboom', 650, NULL, '1733', NULL, NULL, 'H', 'H', '1735-10-28', 'Texel', '1736-03-22', '1736-04-17', true, '1736-07-07', 'Batavia', 6974, NULL);
INSERT INTO "voyages" VALUES (3006, '', 5, '', 'KROOSWIJK', 'Adriaan de Witt', 600, NULL, '1720', NULL, NULL, 'R', 'D', '1735-12-22', 'Goeree', '1736-04-02', '1736-04-18', true, '1736-07-07', 'Batavia', 7054, NULL);
INSERT INTO "voyages" VALUES (3007, '', 4, '', 'LAGE POLDER', 'Lukas Semeyns', 580, NULL, '1725', NULL, NULL, 'E', 'E', '1735-12-25', 'Texel', '1736-05-24', '1736-06-08', true, '1736-08-21', 'Batavia', 7010, 'From 22 till 27-02 at S. Tiago.');
INSERT INTO "voyages" VALUES (3008, '', 2, '', 'BOOT', 'Jan Jorisz.', 650, NULL, '1733', NULL, NULL, 'R', 'Z', '1736-01-03', 'Rammekens', '1736-06-25', '1736-07-17', true, '1736-11-11', 'Ceylon', 7040, 'See 3009.');
INSERT INTO "voyages" VALUES (3009, '', 2, '', 'SLOT KRONENBURG', 'Abraham van Ranoy', 350, NULL, '1733', NULL, NULL, 'A', 'Z', '1736-01-03', 'Rammekens', '1736-06-15', '1736-07-27', true, '1736-08-29', 'Batavia', 7025, 'From 16 till 18-01-1736 at Duins; from 19 till 22-01 at Portsmouth. The BOOT (3008) took over one of the seafarers of the SLOT KRONENBURG. The five passengers included two female slaves.');
INSERT INTO "voyages" VALUES (3010, '', 10, '', 'MEDENBURG', 'Simon Muller', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1736-01-03', 'Rammekens', '1736-06-25', '1736-08-08', true, '1736-10-03', 'Batavia', 6986, 'From 18-01 till 18-02 at Duins: one seafarer was taken over by the VLISSINGEN (3011); from 19 till 25-02 at Portsmouth.');
INSERT INTO "voyages" VALUES (3011, '', 2, '', 'VLISSINGEN', 'Pieter Bruis', 650, NULL, '1732', NULL, NULL, 'Z', 'Z', '1736-01-03', 'Rammekens', '1736-06-25', '1736-07-14', true, '1736-09-11', 'Batavia', 7013, '19 till 22-02 at Portsmouth; 2 soldiers and 2 craftsmen deserted.');
INSERT INTO "voyages" VALUES (3012, '', 2, '', 'VAN ALSEM', 'Jurriaan van Wolbergen', 650, NULL, '1732', NULL, NULL, 'A', 'A', '1736-02-12', 'Texel', '1736-06-25', '1736-07-17', true, '1736-11-11', 'Ceylon', 6994, 'From 13 till 18-02-1736 the ship was back at Texel.');
INSERT INTO "voyages" VALUES (3013, '', 3, '', 'BUIS', 'Hendrik Orsel', 600, NULL, '1727', NULL, NULL, 'E', 'E', '1736-02-12', 'Texel', '1736-09-19', '1736-10-06', true, '1736-12-15', 'Batavia', 6998, '111 seafarers and 28 soldiers; on the fifth of May 1736 the ship departed from Duins in a damaged condition.');
INSERT INTO "voyages" VALUES (3014, '', 7, '', 'CASTRICUM', 'Joris Davidson', 1150, NULL, '1722', NULL, NULL, 'A', 'A', '1736-02-12', 'Texel', '1736-06-04', '1736-06-21', true, '1736-09-02', 'Batavia', NULL, 'One of the soldiers became cook''s wain. The CASTRICUM was laid up in the Indies on 19-03-1743.');
INSERT INTO "voyages" VALUES (3015, '', 2, '', 'HUIS TE FOREEST', 'Jan Mijndertsz.', 850, NULL, '1731', NULL, NULL, 'H', 'A', '1736-02-12', 'Texel', '1736-06-10', '1736-06-27', true, '1736-09-01', 'Batavia', 7043, 'From 13 till 18-02 the ship was back at Texel.');
INSERT INTO "voyages" VALUES (3016, '', 2, '', 'HILLEGOM', 'Jan Almees', 1150, NULL, '1733', NULL, NULL, 'A', 'A', '1736-02-12', NULL, NULL, NULL, true, NULL, NULL, NULL, 'to Texel, but was wrecked there, one day after its initial departure.');
INSERT INTO "voyages" VALUES (3017, '', 2, '', 'KERKWIJK', 'Daniel van Staden', 850, NULL, '1733', NULL, NULL, 'A', 'H', '1736-02-12', 'Texel', '1736-06-01', '1736-06-17', true, '1736-08-26', 'Batavia', 6972, NULL);
INSERT INTO "voyages" VALUES (3018, '', 1, '', 'KERKZICHT', 'Pieter Visser', 650, NULL, '1735', NULL, NULL, 'A', 'A', '1736-02-12', 'Texel', '1736-06-26', '1736-08-08', true, '1736-10-09', 'Batavia', 6985, NULL);
INSERT INTO "voyages" VALUES (3019, '', 3, '', 'LOOSDRECHT', 'Willem Vroom', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1736-02-12', NULL, NULL, NULL, true, NULL, NULL, NULL, 'From 13 till 18-02 the ship was back at Texel. As the BUIS (3013) the LOOSDRECHT ran ashore on Goodwin''s Sand, 19-02-1736.');
INSERT INTO "voyages" VALUES (3020, '', 2, '', 'HUIS TE MARQUETTE', 'Jakob van Duinen', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1736-02-12', 'Texel', '1736-07-25', NULL, true, '1736-10-17', 'Ceylon', 7020, NULL);
INSERT INTO "voyages" VALUES (3021, '', 3, '', 'MEERMOND', 'Jakob Gosen Hoogstad', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1736-02-12', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'From 13 till 18-02-1736 the ship was back at Texel. As the BUIS (3013) and the LOOSDRECHT (see 3019), the MEERMOND stranded on Goodwin''s Sand, 19-02-1736.');
INSERT INTO "voyages" VALUES (3022, '', 6, '', 'NOORDWADDINXVEEN', 'Kornelis Springenberg', 850, NULL, '1718', NULL, NULL, 'R', 'A', '1736-02-12', 'Texel', '1736-06-01', '1736-06-17', true, '1736-08-25', 'Batavia', 7012, 'One of the soldiers became cook''s wain.');
INSERT INTO "voyages" VALUES (3023, '', 2, '', 'VIS', 'Gerrit Pik', 650, NULL, '1732', NULL, NULL, 'E', 'A', '1736-02-12', 'Texel', '1736-07-01', '1736-07-17', true, '1736-11-08', 'Batavia', 6988, 'From 14 till 18-02-1736 the ship was back at Texel.');
INSERT INTO "voyages" VALUES (3024, '', 1, '', 'VREELAND', 'Jan van Engelen', 650, NULL, '1735', NULL, NULL, 'A', 'A', '1736-02-12', 'Texel', '1736-08-06', '1736-08-23', true, '1736-11-18', 'Batavia', 6989, 'From 13 till 19-02-1736 the ship was back at Texel; from 26-02 till 26-03 it was at Plymouth: 9 seafarers and 3 soldiers deserted. From 02 till 05-08 the VREELAND was at Saldanha Say. One of the soldiers became cook, another became seafarer.');
INSERT INTO "voyages" VALUES (3025, '', 4, '', 'ADRICHEM', 'Jan van den Broek', 850, NULL, '1726', NULL, NULL, 'A', 'Z', '1736-03-28', 'Rammekens', '1736-07-17', '1736-07-28', true, '1736-09-28', 'Batavia', 7032, NULL);
INSERT INTO "voyages" VALUES (3026, '', 4, '', 'COXHOORN', 'Gerrit Bijleveld', 450, NULL, '1728', NULL, NULL, 'A', 'Z', '1736-03-28', 'Rammekens', '1736-07-14', '1736-08-28', true, '1736-10-03', 'Batavia', 6983, NULL);
INSERT INTO "voyages" VALUES (3027, '', 2, '', 'SIJBEKARSPEL', 'Adriaan Cats', 650, NULL, '1729', NULL, NULL, 'H', 'Z', '1736-03-28', 'Rammekens', '1736-07-15', NULL, true, '1736-10-01', 'Ceylon', 7015, NULL);
INSERT INTO "voyages" VALUES (3028, '', 5, '', 'KASTEEL VAN WOERDEN', 'Marinus Dringer', 850, NULL, '1722', NULL, NULL, 'D', 'D', '1736-04-14', 'Goeree', '1736-07-11', '1736-07-25', true, '1736-11-03', 'Batavia', 6990, NULL);
INSERT INTO "voyages" VALUES (3029, '', 6, '', 'GOUDRIAAN', 'Frans van Nek', 630, 'fluit', '1719', NULL, NULL, 'D', 'A', '1736-04-25', 'Texel', '1736-08-30', '1736-10-10', true, '1736-12-06', 'Batavia', 7000, NULL);
INSERT INTO "voyages" VALUES (3030, '', 4, '', 'WESTERBEEK', 'Pieter van der Sprenkel', 650, NULL, '1722', NULL, NULL, 'A', 'D', '1736-04-25', 'Goeree', '1736-09-13', '1736-10-06', true, '1737-01-09', 'Batavia', 7004, NULL);
INSERT INTO "voyages" VALUES (3031, '', 3, '', 'PAPENBURG', 'Hans Nomsen', 800, NULL, '1729', NULL, NULL, 'A', 'R', '1736-05-06', 'Goeree', '1736-09-14', '1736-10-01', true, '1736-12-04', 'Batavia', 7001, 'Goeree, the crew was composed as is indicated in the first column, but before the final departure of the PAPENBURG on 06-05-1736 the crew was reduced to 144 seafarers, 83 soldiers and 10 craftsmen. From 27 till 29-05-1736 the ship was at Duins, from 05 till 13-09 at Saldanha Bay.');
INSERT INTO "voyages" VALUES (3032, '', 1, '', 'RODENRIJS', 'Jan van Heemstede', 650, NULL, '1735', NULL, NULL, 'R', 'R', '1736-05-06', 'Goeree', '1736-09-13', '1736-10-01', true, '1736-12-18', 'Batavia', 7002, 'From 27 till 29-05-1736 at Duins.');
INSERT INTO "voyages" VALUES (3033, '', 3, '', 'DUINBEEK', 'Jan van Thiel', 800, NULL, '1727', NULL, NULL, 'Z', 'A', '1736-05-20', 'Texel', '1736-09-11', '1736-10-01', true, '1736-12-06', 'Batavia', 6999, 'From 22 till 29-05-1736 at Duins.');
INSERT INTO "voyages" VALUES (3034, '', 1, '', 'WESTERWIJK', 'Wouter Bos', 850, NULL, '1735', NULL, NULL, 'A', 'A', '1736-05-20', 'Texel', '1736-09-12', '1736-10-06', true, '1736-12-05', 'Batavia', 7003, 'From 22 till 29-05-1736 at Duins.');
INSERT INTO "voyages" VALUES (3035, '', 5, '', 'SCHUITWIJK', 'Jan de Roeper', 650, NULL, '1724', NULL, NULL, 'E', 'H', '1736-05-30', 'Texel', '1736-10-24', '1736-11-11', true, '1737-02-01', 'Batavia', NULL, 'From 11 till 18-07-1736 at S. Tiago. Laid up in the Indies. 01-03-1743.');
INSERT INTO "voyages" VALUES (3036, '', 4, '', 'REIGERSBROEK', 'Jan van den Elske', 600, NULL, '1726', NULL, NULL, 'A', 'Z', '1736-06-07', 'Rammekens', '1736-10-25', '1736-11-11', true, '1737-01-31', 'Batavia', 7019, 'From 09 till 11-06-1736 at Duins; from 18 till 25-07 at S. Tiago: 2 soldiers deserted.');
INSERT INTO "voyages" VALUES (3037, '', 4, '', 'BEEKVLIET', 'Bastiaan Mol', 850, NULL, '1724', NULL, NULL, 'A', 'A', '1736-06-08', 'Texel', '1736-10-12', '1736-10-31', true, '1737-01-11', 'Batavia', 7021, 'females).');
INSERT INTO "voyages" VALUES (3038, '', 1, '', 'ENKHUIZEN', 'Adriaan Pool', 850, NULL, '1735', NULL, NULL, 'E', 'E', '1736-06-21', 'Texel', '1736-10-14', '1736-10-31', true, '1737-01-11', 'Batavia', 7069, 'From 19 till 25-07-1736 at S. Tiago.');
INSERT INTO "voyages" VALUES (3039, '', 1, '', 'DISHOEK', 'Jan van Riet', 665, NULL, '1735', NULL, NULL, 'Z', 'Z', '1736-07-08', 'Rammekens', '1737-03-12', '1737-04-20', true, '1737-07-17', 'Batavia', 7111, 'Jan van Riet remained at the Cape, Huibrecht Bout became master. From 17-07 till 28-07-1736 the DISHOEK was at Portsmouth, from 07-12 till 20-12-1736 at Soango Boanie in Angola.');
INSERT INTO "voyages" VALUES (3040, '', 1, '', 'NIEUWERKERK', 'Kornelis van de Woestijne', 1135, NULL, '1735', NULL, NULL, 'Z', 'Z', '1736-07-08', 'Rammekens', '1736-12-23', '1737-01-08', true, '1737-04-15', 'Batavia', 7034, 'From 21 till 25-08-1736 at S. Tiago: 7 seafarers and 2 soldiers deserted; one new seafarer was taken on board.');
INSERT INTO "voyages" VALUES (3041, '', 1, '', 'STRIJEN', 'Anthonie Guldeman', 650, NULL, '1735', NULL, NULL, 'D', 'D', '1736-10-27', 'Goeree', '1737-02-14', '1737-03-07', true, '1737-06-03', 'Batavia', 7018, NULL);
INSERT INTO "voyages" VALUES (3042, '', 2, '', 'BINNENWIJZEND', 'Jan Hendriksz. Bos', 500, NULL, '1726', NULL, NULL, 'H', 'H', '1737-03-10', 'Texel', '1737-06-17', '1737-06-29', true, '1737-09-14', 'Batavia', NULL, 'Laid up in the Indies, 31-12-1747.');
INSERT INTO "voyages" VALUES (3043, '', 7, '', 'CORNELIA', 'Dirk de Vet', 800, NULL, '1721', NULL, NULL, 'H', 'H', '1737-03-10', 'Texel', '1737-11-08', '1737-12-08', true, '1738-04-07', 'Batavia', 7042, 'till 28-05-1737 the CORNELIA was at S. Tiago: 6 seafarers and 3 soldiers deserted, one soldier became seafarer; from 21-10 till 06-11-1736 the ship was at Saldanha Bay. One of the passengers was a former slave.');
INSERT INTO "voyages" VALUES (3044, '', 1, '', 'DIEMERMEER', 'Jan Kolom', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1737-03-10', 'Texel', '1737-07-15', '1737-08-05', true, '1737-11-15', 'Batavia', 7005, 'One of the passengers who embarked at the Cape was a slave.');
INSERT INTO "voyages" VALUES (3045, '', 6, '', 'GAASPERDAM', 'Harke Zeres', 1150, NULL, '1724', NULL, NULL, 'A', 'A', '1737-03-10', 'Texel', '1737-07-19', '1737-08-06', true, '1737-10-16', 'Batavia', 7006, 'Three of the passengers were indicated as `blacks''.');
INSERT INTO "voyages" VALUES (3046, '', 2, '', 'GOIDSCHALXOORD', 'Willem van der Velden', 850, 'fluit', '1734', NULL, NULL, 'A', 'A', '1737-03-10', 'Texel', '1737-08-17', '1737-09-09', true, '1737-12-05', 'Batavia', 7024, NULL);
INSERT INTO "voyages" VALUES (3047, '', 1, '', 'GUNTERSTUN', 'Frans Gartelman', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1737-03-10', 'Texel', '1737-07-19', '1737-08-07', true, '1737-10-17', 'Batavia', 7017, 'From 02-06 till 09-06-1737 the ship was at S. Tiago : one seafarer deserted.');
INSERT INTO "voyages" VALUES (3048, '', 2, '', 'HARTENLUST', 'Jakob Popta', 650, NULL, '1734', NULL, NULL, 'A', 'A', '1737-03-10', 'Texel', '1737-08-11', '1737-09-17', true, '1738-01-03', 'Batavia', 7101, NULL);
INSERT INTO "voyages" VALUES (3049, '', 6, '', 'KETEL', 'Willem Miekman', 810, NULL, '1721', NULL, NULL, 'R', 'A', '1737-03-10', 'Texel', '1738-03-08', '1738-04-21', true, '1738-08-14', 'Ceylon', 7152, 'From 09-01 till 05-03-1738 the KETEL was at Saldanha Bay.');
INSERT INTO "voyages" VALUES (3050, '', 4, '', 'MEERLUST', 'Pieter Bekker', 600, NULL, '1725', NULL, NULL, 'A', 'A', '1737-03-10', 'Texel', '1737-06-21', '1737-06-30', true, '1737-09-17', 'Batavia', 7077, NULL);
INSERT INTO "voyages" VALUES (3051, '', 2, '', 'NIEUWLAND', 'Gijsbert Hageman', 850, NULL, '1733', NULL, NULL, 'Z', 'A', '1737-03-10', 'Texel', '1737-06-17', '1737-06-29', true, '1737-09-08', 'Batavia', 7011, 'During the voyage one soldier became a seafarer.');
INSERT INTO "voyages" VALUES (3052, '', 7, '', 'OOSTRUST', 'Willem van der Tijd', 1140, NULL, '1721', NULL, NULL, 'A', 'A', '1737-03-10', 'Texel', '1737-07-12', '1737-08-06', true, '1737-10-24', 'Batavia', 7027, 'The passengers included one female slave.');
INSERT INTO "voyages" VALUES (3053, '', 4, '', 'PALLAS', 'Johan Kornelis Warmenhoven', 650, NULL, '1723', NULL, NULL, 'A', 'A', '1737-03-10', 'Texel', '1737-09-05', '1737-10-10', true, '1738-01-21', 'Batavia', 7067, 'During the voyage one soldier became a seafarer. From 02-08 till 02-09-1737 the PALLAS was at Simon Bay, a part of False Bay.');
INSERT INTO "voyages" VALUES (3054, '', 5, '', 'PETRONELLA ALIDA', 'Pieter Lup', 550, NULL, '1722', NULL, NULL, 'E', 'E', '1737-03-10', 'Texel', '1737-11-04', NULL, true, '1737-11-04', 'The Cape', NULL, 'From 09-07 till 24-07-1737 the ship was at S. Tiago. The PETRONELLA ALIDA was broken up in 1738 in Saldanha Bay.');
INSERT INTO "voyages" VALUES (3055, '', 4, '', 'RIDDERKERK', 'Jan Licent', 500, NULL, '1726', NULL, NULL, 'R', 'A', '1737-03-10', 'Texel', '1737-06-16', '1737-07-06', true, '1737-09-15', 'Batavia', NULL, 'According to KA 2288, the RIDDERKERK was wrecked in 1743 at Conati in Persia.');
INSERT INTO "voyages" VALUES (3056, '', 1, '', 'STREEFKERK', 'Willem Houthuizen', 650, NULL, '1736', NULL, NULL, 'A', 'A', '1737-03-10', 'Texel', '1737-08-25', '1737-09-15', true, '1737-12-25', 'Batavia', 7038, 'During the voyage one craftsmen became a seafarer.');
INSERT INTO "voyages" VALUES (3057, '', 2, '', 'VENENBURG', 'Jan Tobias Toon', 650, NULL, '1734', NULL, NULL, 'A', 'A', '1737-03-10', 'Texel', '1737-06-19', '1737-07-03', true, '1737-09-17', 'Batavia', 7089, NULL);
INSERT INTO "voyages" VALUES (3058, '', 1, '', 'WATERVLIET', 'Pieter Korver', 650, NULL, '1736', NULL, NULL, 'A', 'A', '1737-03-10', 'Texel', '1737-07-19', '1737-08-06', true, '1737-11-26', 'Batavia', 7031, 'From 17-04 till 29-04-1737 the WATERVLIET was at S. Tiago. Two soldiers became seafarers.');
INSERT INTO "voyages" VALUES (3059, '', 3, '', 'ZORGWIJK', 'Kornelis van der Marie', 650, NULL, '1732', NULL, NULL, 'A', 'A', '1737-03-10', 'Texel', '1737-06-18', '1737-06-30', true, '1737-09-16', 'Batavia', 7014, '3059/7014 Is the third voyage of the ZORGWIJK, which during its first voyage (see 2896/-) was called VOORDUIN.');
INSERT INTO "voyages" VALUES (3060, '', 5, '', 'KLARABEEK', 'Jan Bijland', 705, NULL, '1721', NULL, NULL, 'Z', 'Z', '1737-03-11', 'Rammekens', '1737-07-15', '1737-08-06', true, '1737-10-19', 'Batavia', 7007, 'During the voyage one of the soldiers became a seafarer. The passengers included 11 slaves (6 males and 5 females).');
INSERT INTO "voyages" VALUES (3061, '', 2, '', 'HUIS TE RENSBURG', 'Jan de Bruin', 850, NULL, '1733', NULL, NULL, 'Z', 'Z', '1737-03-11', 'Rammekens', '1737-07-09', '1737-07-21', true, '1737-09-23', 'Batavia', 7094, '23-06 till 08-07-1737 the ship was at Saldanha Bay.');
INSERT INTO "voyages" VALUES (3062, '', 1, '', 'ARNESTUN', 'Willem Hendriksz. van Roffe', 575, NULL, '1736', NULL, NULL, 'Z', 'Z', '1737-03-12', 'Rammekens', '1737-06-20', '1737-07-06', true, '1937-09-17', 'Batavia', 7008, 'During the voyage one of the soldiers became a seafarer. The passengers who embarked at the Cape included eight slaves: two (married) couples with two children each.');
INSERT INTO "voyages" VALUES (3063, '', 3, '', 'MARIA ADRIANA', 'Willem de Wijs', 650, NULL, '1730', NULL, NULL, 'R', 'R', '1737-03-12', 'Goeree', '1737-06-17', '1737-07-02', true, '1737-09-07', 'Batavia', 7055, NULL);
INSERT INTO "voyages" VALUES (3064, '', 8, '', 'ZOETELINGSKERKE', 'Huibrecht op den Dijk', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1737-03-12', 'Rammekens', '1737-06-17', '1737-07-07', true, '1737-09-23', 'Batavia', NULL, 'Laid up at Ceylon, 12-01-1740. One of the passengers was a slave.');
INSERT INTO "voyages" VALUES (3065, '', 6, '', 'PATMOS', 'Samuel Hoppestijn van Leeuwen', 810, NULL, '1722', NULL, NULL, 'R', 'D', '1737-04-11', 'Goeree', '1737-08-06', '1737-08-21', true, '1737-11-26', 'Batavia', 7028, NULL);
INSERT INTO "voyages" VALUES (3066, '', 1, '', 'RIJNHUIZEN', 'Hendrik van Raa', 650, NULL, '1736', NULL, NULL, 'R', 'R', '1737-04-11', 'Goeree', '1737-09-02', '1737-09-17', true, '1737-12-06', 'Batavia', 7030, NULL);
INSERT INTO "voyages" VALUES (3067, '', 2, '', 'RUST EN WERK', 'Hendrik Westerbeek', 650, NULL, '1734', NULL, NULL, 'D', 'D', '1737-04-15', 'Goeree', '1737-08-08', '1737-08-24', true, '1738-01-06', 'Batavia', 7029, NULL);
INSERT INTO "voyages" VALUES (3068, '', 2, '', 'JONGE WILLEM', 'Jan Bot', 650, NULL, '1731', NULL, NULL, 'Z', 'Z', '1737-04-27', 'Rammekens', '1737-09-22', '1737-10-27', true, '1738-01-21', 'Batavia', 7074, NULL);
INSERT INTO "voyages" VALUES (3069, '', 1, '', 'RUITER', 'Isaak Brandenburg', 650, NULL, '1736', NULL, NULL, 'E', 'E', '1737-04-28', 'Texel', '1737-11-05', '1737-12-08', true, '1738-04-11', 'Batavia', 7083, 'From 04 till 11-05-1737 the ship was at Duins. One of the soldiers became bottler.');
INSERT INTO "voyages" VALUES (3070, '', 2, '', 'HOFWEGEN', 'Olof Kuit', 650, NULL, '1731', NULL, NULL, 'R', 'R', '1737-05-10', 'Goeree', '1737-09-18', '1737-10-01', true, '1737-12-19', 'Batavia', 7037, NULL);
INSERT INTO "voyages" VALUES (3071, '', 6, '', 'EVERSWAART', 'Michiel Keizer', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1737-05-11', 'Rammekens', '1737-09-24', '1737-12-04', true, '1738-03-03', 'Ceylon', 7065, NULL);
INSERT INTO "voyages" VALUES (3072, '', 1, '', 'DRECHTERLAND', 'Hendrik Hessing', 250, NULL, '1736', NULL, NULL, 'H', 'H', '1737-05-13', 'Texel', '1737-11-04', '1737-11-27', true, '1738-03-10', 'Batavia', 7068, 'From 09 till 24-07-1737 the ship was at St. Tiago: the crew was enlarged with 2 seafarers.');
INSERT INTO "voyages" VALUES (3073, '', 3, '', 'DUIFJE', 'Jan van Ingen', 450, NULL, '1729', NULL, NULL, 'A', 'A', '1737-05-21', 'Texel', '1737-09-15', '1737-10-10', true, '1737-12-25', 'Batavia', 7036, 'enlarged with one seafarer (see 3074).');
INSERT INTO "voyages" VALUES (3074, '', 3, '', 'SCHONAUEN', 'Christiaan Bakker+', 600, NULL, '1729', NULL, NULL, 'A', 'A', '1737-05-21', 'Texel', '1737-11-08', '1737-12-08', true, '1738-04-11', 'Batavia', 7161, 'Christiaan Bakker died during the voyage, Jakob Hendrik Inker succeeded him as master. From 23-06 till 02-07 the ship was at St. Tiago: the DUIFJE (3073) took over the second cooper. From 27-10 till 07-11-1737 the SCHONAUWEN was at Saldanha Bay.');
INSERT INTO "voyages" VALUES (3075, '', 1, '', 'SCHELLAG', 'Gerrit de Zomer', 850, NULL, '1736', NULL, NULL, 'Z', 'Z', '1737-06-01', 'Rammekens', '1737-11-04', '1737-11-26', true, '1738-02-15', 'Batavia', 7071, 'From 13 till 23-07-1737 the SCHELLAG was at S. Tiago: 1 seafarer and 2 soldiers died or deserted, the reduced crew was enlarged with one soldier.');
INSERT INTO "voyages" VALUES (3076, '', 2, '', 'POPKENSBURG', 'Kornelis van der Hoeve', 850, NULL, '1732', NULL, NULL, 'Z', 'E', '1737-06-19', 'Texel', '1737-10-31', '1737-11-15', true, '1738-02-14', 'Batavia', 7100, 'stowaway was found on the POPKENSBURG.');
INSERT INTO "voyages" VALUES (3077, '', 1, '', 'BUVEGNIES', 'Viktor van der Kaag', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1737-07-12', 'Texel', '1737-11-24', '1737-12-12', true, '1738-03-18', 'Batavia', 7057, 'From 23 till 26-08-1737 the ship was at S. Tiago. During the voyage one soldier became a seafarer.');
INSERT INTO "voyages" VALUES (3078, '', 6, '', 'HOGERSMILDE', 'Hendrik Opmeer', 810, NULL, '1723', NULL, NULL, 'A', 'A', '1737-07-12', 'Texel', '1737-11-24', '1737-12-12', true, '1738-03-31', 'Batavia', 7056, 'From 22 till 26-08-1737 the ship was at S. Tiago.');
INSERT INTO "voyages" VALUES (3079, '', 5, '', 'LANDSKROON', 'Lambert van Schagen', 850, NULL, '1725', NULL, NULL, 'A', 'A', '1737-07-12', 'Texel', '1737-11-24', '1737-12-12', true, '1738-03-31', 'Batavia', 7066, 'From 22 till 26-08-1737 the ship was at S. Tiago.');
INSERT INTO "voyages" VALUES (3080, '', 6, '', 'WICKENBURG', 'Salomon Reynders', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1737-09-16', 'Rammekens', '1738-02-08', '1738-03-16', true, '1738-06-06', 'Batavia', 7050, 'From 23-09 till 15-10-1737 the ship was at Falmouth.');
INSERT INTO "voyages" VALUES (3081, '', 6, '', 'HOF NIET ALTIJD ZOMER', 'Jan Leynsen', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1737-09-16', 'Rammekens', '1738-02-10', '1738-03-16', true, '1738-07-10', 'Batavia', NULL, 'From 23-09 till 15-10-1737 the ship was at Falmouth: 2 seafarers and 1 soldier deserted. The HOF NIET ALTUD ZOMER was laid up in the Indies, 11-06-1743.');
INSERT INTO "voyages" VALUES (3082, '', 2, '', 'BATAVIER', 'Pieter Kaayman', 525, NULL, '1735', NULL, NULL, 'B', 'A', '1737-10-17', 'Texel', '1738-02-11', '1738-02-20', true, '1738-06-06', 'Batavia', 7052, NULL);
INSERT INTO "voyages" VALUES (3083, '', 7, '', 'BERKENRODE', 'Hendrik van Beek', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1737-10-17', 'Texel', '1738-02-03', '1738-02-20', true, '1738-04-30', 'Batavia', 7064, 'One seafarer was taken over by the KASTEEL VAN TILBURG (3087); one of the soldiers became a seafarer. The two ''passengers'' were slaves.');
INSERT INTO "voyages" VALUES (3084, '', 3, '', 'HOFVLIET', 'Koenraad van der Poel', 1000, NULL, '1729', NULL, NULL, 'R', 'R', '1737-10-17', 'Goeree', '1738-02-05', '1738-02-27', true, '1738-06-12', 'Batavia', 7053, 'one seafarer deserted.');
INSERT INTO "voyages" VALUES (3085, '', 3, '', 'KERKWIJK', 'Marten Burgers', 850, NULL, '1733', NULL, NULL, 'A', 'A', '1737-10-17', 'Texel', '1738-02-04', '1738-02-18', true, '1738-06-18', 'Batavia', 7091, 'During the voyage one of the soldiers became a seafarer, another soldier became cook. The two `passengers'' were slaves.');
INSERT INTO "voyages" VALUES (3086, '', 1, '', 'RUYVEN', 'Joris van Kleef', 650, NULL, '1737', NULL, NULL, 'D', 'D', '1737-10-17', 'Goeree', '1738-02-08', '1738-02-27', true, '1738-06-17', 'Batavia', 7073, 'From 20 till 25-10-1737 the ship was at Portsmouth. During the voyage 1 craftsmen and 2 soldiers became seafarers.');
INSERT INTO "voyages" VALUES (3087, '', 1, '', 'KASTEEL VAN TILBURG', 'Pieter Kronenburg', 850, NULL, '1737', NULL, NULL, 'A', 'A', '1737-10-17', 'Texel', '1738-02-04', '1738-02-27', true, '1738-06-06', 'Batavia', 7088, 'At least two, and probably even three soldiers became seafarers. The ship took over one seafarer from the BERKENRODE (see 3083), the BERKENRODE took over one seafarer from the KASTEEL VAN TILBURG. One of the passengers was a slave.');
INSERT INTO "voyages" VALUES (3088, '', 2, '', 'LANGEWIJK', 'Adriaan Katersveld+', 850, NULL, '1734', NULL, NULL, 'A', 'A', '1737-10-24', 'Texel', '1738-04-11', '1738-05-18', true, '1738-08-05', 'Batavia', 7102, 'died during the voyage, Wijnand van Nullerus succeeded him as master. During the voyage one of the soldiers became seafarer.');
INSERT INTO "voyages" VALUES (3089, '', 1, '', 'ROOSWIJK', 'Adriaan van Rensen', 850, NULL, '1737', NULL, NULL, 'A', 'A', '1737-10-24', 'Texel', '1738-06-08', '1738-06-27', true, '1738-09-23', 'Batavia', 7059, 'From 14 till 30-03-1738 the ship was at S. Tiago: one seafarer deserted.');
INSERT INTO "voyages" VALUES (3090, '', 1, '', 'VELSEN', 'David van Elteren', 600, NULL, '1737', NULL, NULL, 'A', 'A', '1737-10-24', 'Texel', '1738-03-16', '1738-06-14', true, '1738-09-16', 'Batavia', 7162, 'From 30-11 till 05-12-1737 the ship was at S. Tiago: one seafarer deserted.');
INSERT INTO "voyages" VALUES (3091, '', 7, '', 'NIEUWVLIET', 'Pieter van Hoorn', 650, NULL, '1719', NULL, NULL, 'Z', 'Z', '1737-11-12', 'Rammekens', '1738-03-12', '1738-04-02', true, '1738-07-10', 'Batavia', 7093, 'During the voyage one seafarer deserted, one of the soldiers became seafarer.');
INSERT INTO "voyages" VALUES (3092, '', 3, '', 'NIEUW WALCHEREN', 'Pieter Zwanendrecht', 850, NULL, '1731', NULL, NULL, 'Z', 'Z', '1737-11-12', 'Rammekens', '1738-02-27', '1738-03-17', true, '1738-06-02', 'Batavia', 7049, 'During the voyage one of the soldiers became seafarer.');
INSERT INTO "voyages" VALUES (3093, '', 3, '', 'VAN ALSEM', 'Gerrit van der Veurt', 650, NULL, '1732', NULL, NULL, 'A', 'A', '1738-01-01', 'Texel', '1738-04-24', '1738-05-09', true, '1738-08-04', 'Ceylon', 7063, NULL);
INSERT INTO "voyages" VALUES (3094, '', 2, '', 'BEUKESTIJN', 'Klaas Meelhoop', 850, NULL, '1734', NULL, NULL, 'A', 'A', '1738-01-01', 'Texel', '1738-05-29', '1738-06-20', true, '1738-09-07', 'Batavia', 7041, 'From 21-01 till 20-02-1738 the ship was at Plymouth: one seafarer deserted.');
INSERT INTO "voyages" VALUES (3095, '', 6, '', 'KARSENHOF', 'Reinier Brugman', 800, NULL, '1723', NULL, NULL, 'A', 'A', '1738-01-01', 'Texel', '1738-05-29', '1738-06-25', true, '1738-09-15', 'Ceylon', NULL, 'From 20-02 till 03-03-1738 the ship was at S, Tiago. The KARSENHOF was laid up in the Indies in 1743.');
INSERT INTO "voyages" VALUES (3096, '', 2, '', 'SCHEUBEEK', 'Pieter Visser', 850, NULL, '1735', NULL, NULL, 'A', 'A', '1738-01-01', 'Texel', '1738-06-08', '1738-06-15', true, '1738-09-16', 'Batavia', 7046, 'One soldier and one craftsmen became seafarers.');
INSERT INTO "voyages" VALUES (3097, '', 3, '', 'VIS', 'Hermanus Blom+', 650, NULL, '1732', NULL, NULL, 'E', 'E', '1738-01-01', 'Texel', '1738-06-07', '1738-06-27', true, '1738-09-11', 'Batavia', 7047, 'During the voyage Herman Blom died; Pieter Elsvliet succeeded him as master, From 15-01 till 15-02-1738 the ship was at Plymouth: one seafarer deserted,');
INSERT INTO "voyages" VALUES (3098, '', 2, '', 'VREELAND', 'Jurriaan Zeeman', 650, NULL, '1735', NULL, NULL, 'A', 'A', '1738-01-01', 'Texel', '1738-04-22', '1738-06-16', true, '1738-08-22', 'Batavia', 7048, NULL);
INSERT INTO "voyages" VALUES (3099, '', 2, '', 'KERKZICHT', 'Hand Nomsen', 650, NULL, '1735', NULL, NULL, 'A', 'A', '1738-01-06', 'Texel', '1738-06-01', '1738-06-14', true, '1738-09-24', 'Batavia', 7085, 'From 13 till 28-01-1738 the ship was at Portsmouth.');
INSERT INTO "voyages" VALUES (3100, '', 1, '', 'POLANEN', 'Frans de Put', 650, NULL, '1737', NULL, NULL, 'A', 'A', '1738-01-06', 'Texel', '1738-06-01', '1738-06-17', true, '1738-09-06', 'Batavia', 7129, 'Initially the ship departed from Texel on 01-01-1738, but three days later it returned. From 13-01 till 20-02-1738 the POLA-NEN was at Plymouth. During the voyage two soldiers became seafarers.');
INSERT INTO "voyages" VALUES (3101, '', 11, '', 'MEIJENBURG', 'Abraham Everhard', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1738-01-07', 'Rammekens', '1738-05-22', '1738-06-03', true, '1738-08-21', 'Batavia', NULL, 'numbers of deserters.)');
INSERT INTO "voyages" VALUES (3102, '', 7, '', 'STEENHOVEN', 'Simon Muller', 850, NULL, '1718', NULL, NULL, 'Z', 'Z', '1738-01-07', 'Rammekens', '1738-06-01', '1738-06-17', true, '1738-09-06', 'Batavia', NULL, 'From 13-01 till 17-02-1738 the ship was at Portsmouth: 2 seafarers deserted, The passengers included 3 slaves (one male and two females). The STEENHOVEN was wrecked on a voyage to Banda in 1741,');
INSERT INTO "voyages" VALUES (3103, '', 2, '', 'HILVERBEEK', 'Jakob Verleng', 850, NULL, '1735', NULL, NULL, 'A', 'A', '1738-02-15', 'Texel', '1738-06-20', '1738-07-03', true, '1738-09-23', 'Batavia', 7115, 'The initial date of departure of the HILVERSBEEK was 01-01-1738, but 25 days later it returned to Texel, From 20 till 30-03-1738 the ship was at S, Tiago. During the voyage two soldiers became seafarers,');
INSERT INTO "voyages" VALUES (3104, '', 4, '', 'WESTKAPELLE', 'Gerrit van der Tolle', 850, NULL, '1730', NULL, NULL, 'Z', 'Z', '1738-02-21', 'Rammekens', '1738-06-01', '1738-06-17', true, '1738-09-06', 'Batavia', 7062, NULL);
INSERT INTO "voyages" VALUES (3105, '', 1, '', 'LOVERENDAAL', 'Samuel Hendriks', 650, NULL, '1737', NULL, NULL, 'Z', 'Z', '1738-03-22', 'Rammekens', '1738-07-13', '1738-07-27', true, '1738-10-03', 'Batavia', 7058, 'From 27-04 till 04-05 the ship was at S, Tiago: two seafarers and one soldier deserted,');
INSERT INTO "voyages" VALUES (3106, '', 2, '', 'NOORDWIJKERHOUT', 'Daniel Tuineman', 350, NULL, '1732', NULL, NULL, 'A', 'Z', '1738-03-22', 'Rammekens', '1738-07-19', '1738-07-29', true, '1738-10-24', 'Batavia', NULL, 'From 27-04 till 01-05-1738 the ship was at S. Tiago: one seafarer and one craftsmen deserted, The NOORDWIJKERHOUT was laid up in the Indies, 11-09-1744.');
INSERT INTO "voyages" VALUES (3107, '', 3, '', 'PROOSTWIJK', 'Jan van Engelen', 650, NULL, '1730', NULL, NULL, 'E', 'A', '1738-03-27', 'Texel', '1738-10-02', '1738-10-27', true, '1739-02-13', 'Batavia', NULL, 'also 3110.');
INSERT INTO "voyages" VALUES (3108, '', 3, '', 'HAAMSTEDE', 'Willem van Eyk', 650, NULL, '1730', NULL, NULL, 'D', 'D', '1738-04-20', 'Goeree', '1738-08-25', '1738-09-10', true, '1738-12-01', 'Batavia', 7082, NULL);
INSERT INTO "voyages" VALUES (3109, '', 4, '', 'WAPEN VAN HOORN', 'Daniel van Staden +', 850, NULL, '1723', NULL, NULL, 'H', 'H', '1738-04-20', 'Texel', '1738-08-14', '1738-09-01', true, '1738-11-29', 'Batavia', 7070, 'Daniel van Staden did not survive the voyage, Joost Salomonsz. Anker succeeded him as master,');
INSERT INTO "voyages" VALUES (3110, '', 3, '', 'NIEUWSTAD', 'Lukas Rozeboom', 650, NULL, '1733', NULL, NULL, 'H', 'H', '1738-04-20', 'Texel', '1738-10-01', '1738-10-27', true, '1739-02-13', 'Batavia', 7192, 'took place in 1737. During the last stay of the ship at Texel, 30-01 till 20-04, the crew was enlarged with 11 seafarers. From 03 till 14-06 the ship was at S. Tiago: 1 seafarer was taken over by the PROOSTWIJK (3107), one of the soldiers became a seafarer,');
INSERT INTO "voyages" VALUES (3111, '', 3, '', 'HUIS TE SPIJK', 'Jan Kelder', 650, NULL, '1732', NULL, NULL, 'D', 'A', '1738-04-20', 'Texel', '1738-08-13', '1738-09-07', true, '1738-11-10', 'Batavia', 7060, 'The HUIS TE SPIJK did not call at the Cape, but at False Bay (13-08 till 07-09): two seafarers left the ship, see the third column.');
INSERT INTO "voyages" VALUES (3112, '', 4, '', 'VOORDUIN', 'Jurriaan Wolbergen', 650, NULL, '1732', NULL, NULL, 'A', 'A', '1738-04-20', 'Texel', '1738-10-03', '1738-10-29', true, '1739-02-03', 'Batavia', 7095, '3112/7095 Is the fourth voyage of the VOORDUIN, which during its first voyage (2817/6844) was called ZORGWIJK. From 20-09 till 02-10-1738 the ship was at Saldanha Bay; one soldier became seafarer.');
INSERT INTO "voyages" VALUES (3113, '', 5, '', 'WESTERBEEK', 'Pieter Kouderk', 650, NULL, '1722', NULL, NULL, 'A', 'A', '1738-04-20', 'Texel', '1738-08-02', '1738-08-18', true, '1738-10-27', 'Batavia', 7061, 'One of the passengers was a female slave.');
INSERT INTO "voyages" VALUES (3114, '', 6, '', 'KASTEEL VAN WOERDEN', 'Jan van Heemstede', 850, NULL, '1722', NULL, NULL, 'D', 'R', '1738-04-20', 'Goeree', '1738-09-09', '1738-09-21', true, '1738-12-12', 'Batavia', 7072, 'During the voyage one soldier became seafarer.');
INSERT INTO "voyages" VALUES (3115, '', 4, '', 'LEIDUIN', 'Dirk Zwart', 650, NULL, '1730', NULL, NULL, 'E', 'E', '1738-05-04', 'Texel', '1738-09-13', '1738-10-06', true, '1739-01-24', 'Batavia', 7076, 'During the voyage two soldiers became seafarers,');
INSERT INTO "voyages" VALUES (3116, '', 2, '', 'HUIS DEN EULT', 'Jan van Schutterop', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1738-05-08', 'Texel', '1738-09-30', '1738-10-27', true, '1739-01-27', 'Batavia', 7090, 'From 21-06 till 01-07-1738 the ship was at S. Tiago. During the voyage one of the cooks became soldier.');
INSERT INTO "voyages" VALUES (3117, '', 4, '', 'PAPENBURG', 'Dominikus Wormhout', 800, NULL, '1729', NULL, NULL, 'A', 'A', '1738-05-08', 'Texel', '1738-10-25', '1738-11-28', true, '1739-02-02', 'Batavia', 7126, 'stow-aways disembarked at the Cape.');
INSERT INTO "voyages" VALUES (3118, '', 1, '', 'TER MEIJEN', 'Bastiaan Verdoes', 150, NULL, '1737', NULL, NULL, 'A', 'A', '1738-05-14', 'Texel', '1738-10-26', NULL, true, '1738-10-26', 'The Cape', NULL, 'The TER MEIJEN remained on service at the Cape,');
INSERT INTO "voyages" VALUES (3119, '', 5, '', 'COXHOORN', 'Mijsters', 450, NULL, '1728', NULL, NULL, 'A', 'Z', '1738-05-25', 'Rammekens', '1738-10-04', '1738-10-29', true, '1739-01-26', 'Batavia', 7081, 'On its way to the Cape the COXHOORN called at Duins (27-05 till 07-06-1738) and at S. Tiago (16 till 23-07-1738).');
INSERT INTO "voyages" VALUES (3120, '', 1, '', 'HECTOR', 'Gerrit van der Port', NULL, 'hoeker', '1738', NULL, NULL, 'Z', 'Z', '1738-06-02', 'Rammekens', '1738-12-15', NULL, true, '1738-12-15', 'The Cape', 7173, 'The outward voyage of the HECTOR ended at the Cape.');
INSERT INTO "voyages" VALUES (3121, '', 1, '', 'SARA JACOBA', 'Jan Govaarts', 1100, NULL, '1737', NULL, NULL, 'Z', 'Z', '1738-06-02', 'Rammekens', '1738-12-10', '1739-01-07', true, '1739-06-09', 'Batavia', 7109, 'From 11 -06 till 11-07-1738 the ship was at Duins. During a stay at S. Tiago, 23-08 till 04-09-1738, five soldiers deserted,');
INSERT INTO "voyages" VALUES (3122, '', 2, '', 'ARNESTIJN', 'Huibert Tiebout', 575, NULL, '1736', NULL, NULL, 'Z', 'Z', '1738-09-29', 'Rammekens', '1739-01-20', '1739-02-04', true, '1739-04-30', 'Batavia', 7128, 'During the voyage one soldier became seafarer,');
INSERT INTO "voyages" VALUES (3123, '', 3, '', 'VLISSINGEN', 'Anthonie Uiterschouw', 650, NULL, '1732', NULL, NULL, 'Z', 'Z', '1738-09-29', 'Rammekens', '1739-01-21', '1739-02-04', true, '1739-05-02', 'Batavia', 7084, NULL);
INSERT INTO "voyages" VALUES (3124, '', 3, '', 'RUST EN WERK', 'Anthonie Guldeman', 650, NULL, '1734', NULL, NULL, 'D', 'D', '1738-11-04', 'Goeree', '1739-02-21', '1739-03-09', true, '1739-06-14', 'Batavia', 7079, 'From 06 till 10-11-1738 the ship was at Duins.');
INSERT INTO "voyages" VALUES (3125, '', 2, '', 'RIJNHUIZEN', 'Hendrik van Raa', 650, NULL, '1736', NULL, NULL, 'R', 'R', '1738-11-04', 'Goeree', '1739-02-26', '1739-03-10', true, '1739-06-30', 'Batavia', 7108, NULL);
INSERT INTO "voyages" VALUES (3126, '', 1, '', 'ANANAS', 'Bos', 650, NULL, '1738', NULL, NULL, 'A', 'A', '1738-11-05', 'Texel', '1739-02-22', '1739-03-07', true, '1739-06-23', 'Batavia', 7134, NULL);
INSERT INTO "voyages" VALUES (3127, '', 2, '', 'DIEMERMEER', 'Pieter Korver', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1738-11-05', 'Texel', '1739-02-17', '1739-03-09', true, '1739-06-09', 'Batavia', 7092, NULL);
INSERT INTO "voyages" VALUES (3128, '', 1, '', 'LIS', 'Arie van Veurden', 600, NULL, '1738', NULL, NULL, 'A', 'A', '1738-11-05', 'Texel', '1739-04-17', '1739-06-02', true, '1739-08-20', 'Batavia', 7202, NULL);
INSERT INTO "voyages" VALUES (3129, '', 3, '', 'NIEUWLAND', 'Gerrit Pik', 850, NULL, '1733', NULL, NULL, 'Z', 'A', '1738-11-05', 'Texel', '1739-02-17', '1739-03-09', true, '1739-06-14', 'Batavia', 7156, 'The three passengers included two ''black passengers''. During the voyage two soldiers became seafarers.');
INSERT INTO "voyages" VALUES (3130, '', 1, '', 'PAREL', 'Jan van Thiel', 600, NULL, '1738', NULL, NULL, 'A', 'A', '1738-11-05', 'Texel', '1739-04-11', '1739-05-21', true, '1739-08-19', 'Batavia', NULL, 'The PAREL was laid up in the Indies. 31-12-1747.');
INSERT INTO "voyages" VALUES (3131, '', 1, '', 'REIGERSDAAL', 'Harke Zeres', 850, NULL, '1738', NULL, NULL, 'A', 'A', '1738-11-05', 'Texel', '1739-03-07', '1739-03-25', true, '1739-06-20', 'Batavia', 7166, NULL);
INSERT INTO "voyages" VALUES (3132, '', 2, '', 'STRIJEN', 'Willem van der Velden', 650, NULL, '1735', NULL, NULL, 'D', 'A', '1738-11-05', 'Texel', '1739-04-02', '1739-04-20', true, '1739-06-19', 'Batavia', 7137, NULL);
INSERT INTO "voyages" VALUES (3133, '', 3, '', 'SLOT KRONENBURG', 'Frederik Afslager', 350, NULL, '1733', NULL, NULL, 'A', 'E', '1738-12-26', 'Texel', '1739-04-03', '1739-04-20', true, '1739-07-24', 'Batavia', NULL, 'The SLOT KRONENBURG was laid up in the Indies. 11-09-1744.');
INSERT INTO "voyages" VALUES (3134, '', 3, '', 'GOIDSCHALXOORD', 'Jan Abels', 850, 'fluit', '1734', NULL, NULL, 'A', 'A', '1738-12-27', 'Texel', '1739-07-07', '1739-07-15', true, '1739-09-11', 'Ceylon', 7105, 'From 07-01 till 14-03-1739 the ship was at Portsmouth.');
INSERT INTO "voyages" VALUES (3135, '', 2, '', 'GUNTERSTUN', 'Kornelis Kroon', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1738-12-27', 'Texel', '1739-07-08', '1739-07-17', true, '1739-09-21', 'Batavia', 7075, 'soldiers and 1 craftsmen deserted.');
INSERT INTO "voyages" VALUES (3136, '', 3, '', 'MIDDENRAK', 'Pieter Monk', 350, NULL, '1734', NULL, NULL, 'A', 'A', '1738-12-27', 'Texel', '1739-07-02', '1739-07-24', true, '1739-09-25', 'Batavia', NULL, 'the Indies. 11-09-1744. See also 3139.');
INSERT INTO "voyages" VALUES (3137, '', 2, '', 'WATERVLIET', 'Willem Houthuizen', 650, NULL, '1736', NULL, NULL, 'A', 'A', '1738-12-27', 'Texel', '1739-07-05', '1739-07-15', true, '1739-09-26', 'Batavia', 7125, 'Portsmouth twice (10-01 till 10-03 and 16 till 27-03-1739); during the second stay at Portsmouth one seafarer was added to the crew; one of the soldiers became seafarer.');
INSERT INTO "voyages" VALUES (3138, '', 7, '', 'GAASPERDAM', 'Jurriaan Popta', 1150, NULL, '1724', NULL, NULL, 'A', 'A', '1739-02-17', 'Texel', '1739-07-27', '1739-08-15', true, NULL, 'Ceylon', NULL, 'was laid up in the Indies in 1745.');
INSERT INTO "voyages" VALUES (3139, '', 3, '', 'HOFWEGEN', 'Kornelis Pottebakker', 650, NULL, '1731', NULL, NULL, 'R', 'H', '1739-02-17', 'Texel', '1739-07-03', '1739-07-15', true, '1739-09-26', 'Batavia', 7106, '(3136).');
INSERT INTO "voyages" VALUES (3140, '', 2, '', 'NIEUWERKERK', 'Kornelis van der Marle', 1135, NULL, '1735', NULL, NULL, 'Z', 'A', '1739-02-17', 'Texel', '1739-07-26', '1739-08-10', true, '1739-10-25', 'Batavia', 7123, '`black boy'',');
INSERT INTO "voyages" VALUES (3141, '', 8, '', 'OOSTRUST', 'Willem Vroom', 1140, NULL, '1721', NULL, NULL, 'A', 'A', '1739-02-17', 'Texel', '1739-07-03', '1739-07-18', true, NULL, NULL, NULL, 'On 18-08-1739, one month after its departure from the Cape, the OOSTRUST got serious leakage and was forced to sail to the Mosselbaai. Finally it was laid up at the Cape in 1739.');
INSERT INTO "voyages" VALUES (3142, '', 2, '', 'WESTHOVEN', 'Usbrand Moens', 650, NULL, '1734', NULL, NULL, 'Z', 'A', '1739-02-17', 'Texel', '1739-07-06', '1739-07-17', true, '1739-09-25', 'Batavia', 7080, 'During the voyage one soldier became seafarer.');
INSERT INTO "voyages" VALUES (3143, '', 3, '', '''S HEER ARENDSKERKE', 'Mattheus Feris du Rietz', 600, NULL, '1724', NULL, NULL, 'Z', 'Z', '1739-04-02', 'Rammekens', '1739-07-28', '1739-08-15', true, '1739-12-04', 'Batavia', 7096, NULL);
INSERT INTO "voyages" VALUES (3144, '', 4, '', 'DUIFJE', 'Kornelis van de Woestijne+', 450, NULL, '1729', NULL, NULL, 'A', 'Z', '1739-04-02', 'Rammekens', '1739-08-06', '1739-08-26', true, '1739-12-04', 'Batavia', 7098, 'Kornelis van de Woestijne did not survive the voyage, Bastiaan Koleman succeeded him as master.');
INSERT INTO "voyages" VALUES (3145, '', 6, '', 'KLARABEEK', 'Adriaan Cats', 705, NULL, '1721', NULL, NULL, 'Z', 'Z', '1739-04-02', 'Rammekens', '1739-07-28', '1739-08-26', true, '1739-11-07', 'Batavia', 7086, NULL);
INSERT INTO "voyages" VALUES (3146, '', 1, '', 'KRABBENDIJKE', 'Pieter Bruis', 830, NULL, '1738', NULL, NULL, 'Z', 'Z', '1739-04-02', 'Rammekens', '1739-08-06', '1739-08-26', true, '1739-10-26', 'Batavia', 7164, 'One of the soldiers became seafarer.');
INSERT INTO "voyages" VALUES (3147, '', 2, '', 'SINT LAURENS', 'Hendrik Bossen', 850, NULL, '1734', NULL, NULL, 'Z', 'Z', '1739-04-02', 'Rammekens', '1739-07-28', '1739-08-15', true, '1739-11-01', 'Batavia', 7087, 'seafarer.');
INSERT INTO "voyages" VALUES (3148, '', 7, '', 'PATMOS', 'Jan de Jonge', 810, NULL, '1722', NULL, NULL, 'R', 'Z', '1739-04-02', 'Rammekens', '1739-07-28', '1739-08-26', true, '1739-11-07', 'Batavia', 7099, NULL);
INSERT INTO "voyages" VALUES (3149, '', 4, '', 'ZORGWIJK', 'Gozewijn de Vos', 650, NULL, '1732', NULL, NULL, 'A', 'R', '1739-04-06', 'Goeree', '1739-07-22', '1739-08-04', true, '1739-10-13', 'Batavia', 3149, 'the fourth voyage of the ZORGWIJK, which during its first voyage (see 2896/-) was called VOORDUIN. The ship was laid up in the Indies, 11-09-1744. One of the passengers was a female slave.');
INSERT INTO "voyages" VALUES (3150, '', 6, '', 'DELFLAND', 'Arie Verdoes', 600, NULL, '1717', NULL, NULL, 'D', 'Z', '1739-04-07', 'Goeree', '1739-08-18', '1739-09-07', true, '1739-11-26', 'Batavia', 7097, NULL);
INSERT INTO "voyages" VALUES (3151, '', 2, '', 'STREEFKERK', 'Hendrik Orsel', 650, NULL, '1736', NULL, NULL, 'A', 'E', '1739-05-19', 'Texel', '1739-12-09', '1740-01-01', true, '1740-04-28', 'Batavia', NULL, 'From 13 till 20-07-1739 the ship was at S. Tiago: one seafarer and three soldiers deserted. Since 22-09-1740 the STREEFKERK was missing at the island `Cureduvo at Calpetty''.');
INSERT INTO "voyages" VALUES (3152, '', 3, '', 'SIJBEKARSPEL', 'Gerrit Munt', 650, NULL, '1729', NULL, NULL, 'H', 'H', '1739-05-19', 'Texel', '1739-11-04', '1739-11-25', true, '1740-03-07', 'Batavia', 7114, 'From 13 till 21-07-1739 the ship was at S. Tiago. During the voyage one soldier became seafarer.');
INSERT INTO "voyages" VALUES (3153, '', 5, '', 'ADRICHEM', 'Bastiaan Mol', 850, NULL, '1726', NULL, NULL, 'A', 'A', '1739-05-21', 'Texel', '1739-10-25', '1739-11-15', true, '1740-02-23', 'Batavia', 7121, 'crew was enlarged with one soldier. The nine passengers included three female slaves and a slave-child.');
INSERT INTO "voyages" VALUES (3154, '', 3, '', 'BETHLEHEM', 'Jan van der Straten', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1739-05-21', 'Texel', '1739-10-17', '1739-11-11', true, '1740-01-24', 'Batavia', 7117, 'From 16 till 23-07-1739 the ship was at S, Tiago. One soldier became seafarer, The six passengers included three slaves (one male and two females),');
INSERT INTO "voyages" VALUES (3155, '', 3, '', 'HUTS TE MARQUETTE', 'Joris Davidson +', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1739-05-21', 'Texel', '1739-10-16', '1739-11-16', true, '1740-02-14', 'Batavia', 7119, 'Joris Davidson died on the way; Christiaan Duif succeeded him as master. One soldier became seafarer. One of the passengers was a female slave.');
INSERT INTO "voyages" VALUES (3156, '', 2, '', 'ABBEKERK', 'Dirk van der Poel', 850, NULL, '1734', NULL, NULL, 'Z', 'Z', '1739-05-25', 'Rammekens', '1739-09-22', '1739-10-11', true, '1739-12-22', 'Ceylon', 7139, NULL);
INSERT INTO "voyages" VALUES (3157, '', 5, '', 'LAGS POLDER', 'Jan Berkmans', 580, NULL, '1725', NULL, NULL, 'E', 'E', '1739-06-02', 'Texel', '1739-11-01', '1739-11-25', true, '1740-03-07', 'Batavia', NULL, 'The LAGEPOLDER was sold at Batavia, 28-03-1747.');
INSERT INTO "voyages" VALUES (3158, '', 1, '', 'HORSTENDAAL', 'Leendert Jongebroer', 850, NULL, '1739', NULL, NULL, 'A', 'A', '1739-10-02', 'Texel', '1740-03-07', '1740-03-25', true, '1740-06-16', 'Batavia', 7142, NULL);
INSERT INTO "voyages" VALUES (3159, '', 1, '', 'MAARSSEVEEN', 'Jan Almees', 850, NULL, '1739', NULL, NULL, 'A', 'A', '1739-10-02', 'Texel', '1740-03-07', '1740-03-25', true, '1740-06-15', 'Batavia', 7140, NULL);
INSERT INTO "voyages" VALUES (3160, '', 4, '', 'KNAPPENHOF', 'Kornelis de Zitter', 650, NULL, '1731', NULL, NULL, 'A', 'Z', '1739-10-07', 'Rammekens', '1740-02-11', '1740-02-27', true, '1740-06-05', 'Batavia', 7113, 'On its way to the Cape the ship called at Duins: from 09 till 11-10-1739.');
INSERT INTO "voyages" VALUES (3161, '', 2, '', 'LOVERENDAAL', 'Samuel Hendriksz.', 650, NULL, '1737', NULL, NULL, 'Z', 'Z', '1739-10-07', 'Rammekens', '1740-02-07', '1740-02-24', true, '1740-05-27', 'Batavia', 7118, '11-10-1739 the ship was at Duins.');
INSERT INTO "voyages" VALUES (3162, '', 1, '', 'OUWERKERK', 'Jan Bijland', 540, NULL, '1738', NULL, NULL, 'Z', 'Z', '1739-10-07', 'Rammekens', '1740-02-07', '1740-02-24', true, '1740-05-05', 'Batavia', 7107, 'The ship called at Duins from 09 till 10-10-1739,');
INSERT INTO "voyages" VALUES (3163, '', 5, '', 'BEEKVLIET', 'Pieter Kaayman', 850, NULL, '1724', NULL, NULL, 'A', 'A', '1739-10-09', 'Texel', '1740-03-03', '1740-03-27', true, '1740-06-16', 'Batavia', NULL, 'The BEEKVLIET was laid up in the Indies in 1744,');
INSERT INTO "voyages" VALUES (3164, '', 3, '', 'SCHEIJBEEK', 'Pieter Visser', 850, NULL, '1735', NULL, NULL, 'A', 'A', '1739-10-09', 'Texel', '1740-01-16', '1740-02-03', true, '1740-04-14', 'Batavia', 7120, 'On 14-01-1740 the SCHEIJBEEK arrived at Robben Island.');
INSERT INTO "voyages" VALUES (3165, '', 1, '', 'HORSSEN', 'Jan Luders', 650, NULL, '1739', NULL, NULL, 'A', 'A', '1739-10-12', 'Texel', '1740-02-10', '1740-02-27', true, '1740-06-06', 'Batavia', 7112, NULL);
INSERT INTO "voyages" VALUES (3166, '', 11, '', 'PHOENIX', 'Pieter Alkmaar', 650, NULL, '1739', NULL, NULL, 'A', 'A', '1739-10-12', 'Texel', '1740-01-15', '1740-02-03', true, '1740-04-27', 'Batavia', NULL, 'The PHOENIX was laid up at Batavia on 16-09-1746,');
INSERT INTO "voyages" VALUES (3167, '', 3, '', 'VREELAND', 'Jurriaan Zeeman', 650, NULL, '1735', NULL, NULL, 'A', 'A', '1739-10-12', 'Texel', '1740-01-20', '1740-02-08', true, '1740-04-09', 'Batavia', 7110, 'The VREELAND arrived at Robben Island on 17-01-1740.');
INSERT INTO "voyages" VALUES (3168, '', 8, '', 'MAGDALENA', 'Hendrik Westerbeek', 600, NULL, '1719', NULL, NULL, 'H', 'D', '1739-10-19', 'Goeree', '1740-02-23', '1740-03-16', true, '1740-06-15', 'Batavia', NULL, 'One soldier became seafarer; one of the seafarers was taken over by the WICKENBURG (see 3169). According to a letter from Bengal (31-12-1743) the MAG-DALENA was laid up there.');
INSERT INTO "voyages" VALUES (3169, '', 7, '', 'WICKENBURG', 'Gelijn Leynsen', 850, NULL, '1722', NULL, NULL, 'Z', 'Z', '1739-10-19', 'Rammekens', '1740-02-20', '1740-03-25', true, '1740-06-15', 'Batavia', 7127, 'During the voyage three seafarers deserted; the crew was enlarged by one seafarer, taken over from the MAGDALENA (see 3168), and a sailmaker.');
INSERT INTO "voyages" VALUES (3170, '', 4, '', 'HUIS TE SPIJK', 'Willem de Wijs', 650, NULL, '1732', NULL, NULL, 'D', 'R', '1739-10-31', 'Goeree', '1740-02-20', '1740-03-14', true, '1740-05-30', 'Batavia', 7133, 'During the voyage one soldier became seafarer.');
INSERT INTO "voyages" VALUES (3171, '', 8, '', 'BERKENRODE', 'Pieter Scherf', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1740-01-08', 'Texel', '1740-05-21', '1740-06-09', true, '1740-08-19', 'Ceylon', NULL, 'The BERKENRODE was laid up in the Indies in 1744.');
INSERT INTO "voyages" VALUES (3172, '', 3, '', 'BEUKESTIJN', 'Jan de Boer', 850, NULL, '1734', NULL, NULL, 'A', 'A', '1740-01-08', 'Texel', '1740-05-01', '1740-05-11', true, '1740-07-20', 'Batavia', 7103, NULL);
INSERT INTO "voyages" VALUES (3173, '', 2, '', 'ROOSWIJK', 'Daniel Ronzieres', 850, NULL, '1737', NULL, NULL, 'A', 'A', '1740-01-08', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'One day after its departure from Texel the ROOSWIJK was wrecked at Goodwin''s Sand on 09-01-1740.');
INSERT INTO "voyages" VALUES (3174, '', 4, '', 'VIS', 'Jan Sikkes', 650, NULL, '1732', NULL, NULL, 'E', 'A', '1740-01-08', 'Texel', '1740-05-06', NULL, true, NULL, NULL, NULL, 'wrecked `behind the Waterplaats'' at the Cape on 06-05-1740.');
INSERT INTO "voyages" VALUES (3175, '', 4, '', 'NIEUW WALCHEREN', 'Jan Reynders', 850, NULL, '1731', NULL, NULL, 'Z', 'Z', '1740-01-17', 'Rammekens', '1740-06-02', '1740-07-10', true, '1740-09-18', 'Batavia', 7116, NULL);
INSERT INTO "voyages" VALUES (3176, '', 7, '', 'EVERSWAART', 'Gerrit van der Tolle', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1740-01-25', 'Rammekens', '1740-05-27', '1740-06-21', true, '1740-08-18', 'Batavia', 7104, 'The EVERSWAART did not call at the Cape, but at False Bay (27-05 till 21-06-1740),');
INSERT INTO "voyages" VALUES (3177, '', 1, '', 'HOF VAN DELFT', 'Jean Belleveau', 850, NULL, '1739', NULL, NULL, 'D', 'D', '1740-04-20', 'Goeree', '1740-09-04', '1740-09-21', true, '1740-12-08', 'Batavia', 7122, 'The two passengers on the HOF VAN DELFT were slaves.');
INSERT INTO "voyages" VALUES (3178, '', 2, '', 'SCHELLAG', 'Kornelis Mol +', 850, NULL, '1736', NULL, NULL, 'Z', 'Z', '1740-04-20', 'Rammekens', '1740-07-21', '1740-09-11', true, '1740-11-19', 'Batavia', 7124, 'During the voyage Kornelis Mol died, Willem Hendriksz. van Roffe succeeded him as master, One of the soldiers became seafarer.');
INSERT INTO "voyages" VALUES (3179, '', 7, '', 'BUVEGNIES', 'Jan Boelhouwer', 850, NULL, '1722', NULL, NULL, 'D', 'A', '1740-05-08', 'Texel', '1740-10-12', '1740-11-04', true, '1741-04-28', 'Batavia', 3179, '/- Is the seventh voyage of this ship, which during its preceding six voyages was called KASTEEL VAN WOERDEN (3114/1072). From 23-06 till 06-07-1740 the ship was at S. Tiago, where 6 seafarers deserted and one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3180, '', 2, '', 'ENKHUIZEN', 'Dirk Zomerman', 850, NULL, '1735', NULL, NULL, 'E', 'A', '1740-05-08', 'Texel', '1740-10-12', '1740-11-15', true, '1741-02-16', 'Batavia', 7138, 'From 22-06 till 06-07-1740 the ship was at S, Tiago.');
INSERT INTO "voyages" VALUES (3181, '', 5, '', 'HOGERSMILDE', 'Willem Schul', 850, NULL, '1723', NULL, NULL, 'H', 'A', '1740-05-08', 'Texel', '1740-10-12', '1740-11-15', true, '1741-05-28', 'Batavia', 7143, 'The ship called at S, Tiago (23-06 till 06-07-1740), One soldier became seafarer. 3181/7143 Is the fifth voyage of this ship, which during its four preceding voyages was called WAPEN VAN HOORN (see 3109/7070).');
INSERT INTO "voyages" VALUES (3182, '', 4, '', 'HOF NIET ALTIJD WINTER', 'Koenraad van der Poel', 650, NULL, '1723', NULL, NULL, 'Z', 'R', '1740-05-15', 'Goeree', '1741-05-10', '1741-05-27', true, '1741-08-16', 'Batavia', NULL, '30-11-1740 till 02-01-1741 the ship was at Cape Lopez; it also called at Saldanha Bay (20-04 till 02-05-1741), The ship was sold at Batavia on 10-12-1747.');
INSERT INTO "voyages" VALUES (3183, '', 8, '', 'HILLEGONDA', 'Dirk de Vet', 850, NULL, '1720', NULL, NULL, 'H', 'H', '1740-05-18', 'Texel', '1740-11-02', '1740-12-10', true, '1741-05-27', 'Batavia', NULL, 'From 01 till 06-07-1740 the ship wat at S, Tiago. where one member of the crew deserted, probably a seafarer. In 1745 the HILLEGONDA was laid up at Batavia,');
INSERT INTO "voyages" VALUES (3184, '', 4, '', 'MARIA ADRIANA', 'Jan Elswout', 650, NULL, '1730', NULL, NULL, 'R', 'Z', '1740-05-23', 'Rammekens', '1740-11-03', '1740-11-21', true, '1741-03-03', 'Batavia', 7170, 'From 27-06 till 06-07-1740 the ship was at Porto Prayo and from 18-10 till 02-11 it called at Saldanha Bay.');
INSERT INTO "voyages" VALUES (3185, '', 6, '', 'WESTERBEEK', 'Dirk Pomp', 650, NULL, '1722', NULL, NULL, 'A', 'E', '1740-06-03', 'Texel', '1740-12-25', '1741-01-19', true, '1741-05-28', 'Batavia', 7145, 'Dirk Pomp died during the voyage; Christian Boelhouwer succeeded him as master. The ship called at S. Tiago from 29-08 till 03-09-1740.');
INSERT INTO "voyages" VALUES (3186, '', 3, '', 'BATAVIER', 'Jakob Verleng', 525, NULL, '1735', NULL, NULL, 'A', 'E', '1740-06-07', 'Texel', '1741-01-02', '1741-02-12', true, '1741-06-04', 'Batavia', 7131, 'On its way to the Cape the BATAVIER called at Ireland (08 till 20-07-1740) and at Saldanha Bay (19-12-1740 till 01-01-1741),');
INSERT INTO "voyages" VALUES (3187, '', 3, '', 'HUIS TE FOREEST', 'Christiaan Bakker', 850, NULL, '1731', NULL, NULL, 'H', 'A', '1740-06-29', 'Texel', '1741-01-02', '1741-01-19', true, '1741-04-25', 'Batavia', 7155, 'The 48 persons indicated in the fifth column include 12 seafarers and 8 soldiers who disembarked during a long stay at Pernambuco (13-09 till 13-11-1740); they all went to the hospital there. 2 Soldiers became seafarers.');
INSERT INTO "voyages" VALUES (3188, '', 2, '', 'KASTEEL VAN WOERDEN', 'Jan van Ingen', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1740-06-29', 'Texel', '1740-11-23', '1740-11-26', true, '1741-04-24', 'Batavia', 7146, '3188/7146 Is the second voyage of the KASTEEL VAN WOERDEN; during the preceding voyage (3077/7057) it was called BUVEGNIES. From 29-07 till 11-08-1740 the ship was at S. Tiago.');
INSERT INTO "voyages" VALUES (3189, '', 1, '', 'OUDE ZIJPE', 'Joost Anker', 650, NULL, '1730', NULL, NULL, 'H', 'H', '1740-06-29', 'Texel', '1740-12-16', '1741-01-19', true, '1741-05-28', 'Batavia', 7136, 'probably became seafarers.');
INSERT INTO "voyages" VALUES (3190, '', 8, '', 'CORNELIA', 'Gerrit Scheepbouwer', 800, NULL, '1721', NULL, NULL, 'H', 'E', '1740-09-26', 'Texel', '1741-05-19', '1741-06-14', true, '1741-08-28', 'Batavia', 26, 'date of departure of the CORNELIA-. on 05-01-1740 it sailed out for the first time, but on 19-03 it returned to Texel, During the voyage one soldier became seafarer. The ship was laid up in the Indies on 11-09-1744.');
INSERT INTO "voyages" VALUES (3191, '', 4, '', 'RUST EN WERK', 'Willem van Eyk', 650, NULL, '1734', NULL, NULL, 'D', 'D', '1740-10-13', 'Goeree', '1741-02-24', '1741-03-16', true, '1741-06-08', 'Batavia', 7149, 'From 15 till 26-10-1740 the ship called at Portsmouth. One of the soldiers became corporal, another soldier probably became seafarer,');
INSERT INTO "voyages" VALUES (3192, '', 5, '', 'WESTKAPELLE', 'Michiel Keizer', 850, NULL, '1730', NULL, NULL, 'Z', 'Z', '1740-10-26', 'Rammekens', '1741-02-07', '1741-02-28', true, '1741-06-25', 'Batavia', 7191, 'One of the 17 seafarers who embarked at the Cape was taken over from the AMSTERDAM (see 3194); one soldier probably became seafarer, The five passengers included one former slave.');
INSERT INTO "voyages" VALUES (3193, '', 1, '', 'WOITKENSDORP', 'Adriaan van Maarsseveen', 800, NULL, '1739', NULL, NULL, 'Z', 'Z', '1740-10-26', 'Rammekens', '1741-02-08', '1741-02-28', true, '1741-06-29', 'Batavia', 7168, 'During the voyage one soldier became cook''s wain.');
INSERT INTO "voyages" VALUES (3194, '', 1, '', 'AMSTERDAM', 'Jan van Heemstede', 850, NULL, '1740', NULL, NULL, 'A', 'A', '1740-10-27', 'Texel', '1741-01-25', '1741-02-25', true, '1741-05-22', 'Batavia', 7130, 'One of the 20 seafarers who disembarked at the Cape was taken over by the WESTKAPELLE (3192), During the voyage one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3195, '', 4, '', 'HOFVLIET', 'Kornelis van Velden', 1000, NULL, '1729', NULL, NULL, 'R', 'A', '1740-10-27', 'Texel', '1741-01-29', '1741-02-19', true, '1741-05-22', 'Batavia', 7132, NULL);
INSERT INTO "voyages" VALUES (3196, '', 7, '', 'WAPEN VAN HOORN', 'Jakob van Banken', 810, NULL, '1723', NULL, NULL, 'A', 'A', '1740-10-27', 'Texel', '1741-01-21', '1741-02-23', true, '1741-05-22', 'Batavia', 3196, '/- Is the seventh voyage of this ship, which during its six preceding voyages was called HOGERSMILDE (see 3078/7056), The ship was laid up in the Indies on 11-09-1744.');
INSERT INTO "voyages" VALUES (3197, '', 2, '', 'RUYVEN', 'Bernardus Heymans', 650, NULL, '1736', NULL, NULL, 'D', 'A', '1740-10-27', 'Texel', '1741-03-18', '1741-04-07', true, '1741-07-12', 'Batavia', 7141, NULL);
INSERT INTO "voyages" VALUES (3198, '', 1, '', 'THEEKOP', 'Jan Kelder', 600, NULL, '1740', NULL, NULL, 'A', 'A', '1740-10-27', 'Texel', '1741-03-10', '1741-05-04', true, '1741-07-29', 'Batavia', NULL, 'up and sold at Batavia on 1748,');
INSERT INTO "voyages" VALUES (3199, '', 1, '', 'WELTEVREDEN', 'Adolf van Westhoven', 850, NULL, '1740', NULL, NULL, 'A', 'A', '1740-10-27', 'Texel', '1741-01-31', '1741-02-19', true, '1741-05-22', 'Batavia', 7144, NULL);
INSERT INTO "voyages" VALUES (3200, '', 3, '', 'DIEMERMEER', 'Kornelis Kroon', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1740-11-05', 'Texel', '1741-03-24', '1741-04-18', true, '1741-06-08', 'Batavia', 7151, 'The DIEMERMEER called at Duins (09 till 16-11-1740), One soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3201, '', 4, '', 'HAAMSTEDE', 'Maarten Kist', 650, NULL, '1730', NULL, NULL, 'D', 'H', '1740-12-26', 'Texel', '1741-05-24', '1741-06-14', true, '1741-08-28', 'Batavia', 7159, 'Two soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3202, '', 1, '', 'HUIS TER DUINE', 'Mattheus Feris du Rietz', 550, NULL, '1739', NULL, NULL, 'Z', 'Z', '1740-12-31', 'Rammekens', '1741-05-21', '1741-06-14', true, '1741-08-16', 'Batavia', 7135, 'Adverse winds forced the ship to call at Duins (06 till 26-01-1741). One soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3203, '', 3, '', 'JONGE WILLEM', 'Daniel Udemans', 650, NULL, '1731', NULL, NULL, 'Z', 'Z', '1740-12-31', 'Rammekens', '1741-05-14', '1741-06-14', true, '1741-08-20', 'Batavia', 7150, 'From 02 till 26-01-1741 the ship was at Duins.');
INSERT INTO "voyages" VALUES (3204, '', 3, '', 'GUNTERSTUN', 'Pieter Korver', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1741-01-20', 'Texel', '1741-05-18', '1741-06-14', true, '1741-09-08', 'Batavia', 7198, NULL);
INSERT INTO "voyages" VALUES (3205, '', 1, '', 'HEUVEL', 'Witto', 650, NULL, '1740', NULL, NULL, 'A', 'A', '1741-01-20', 'Texel', '1741-06-06', '1741-06-20', true, '1741-09-10', 'Batavia', 7147, 'One soldier became bottler'' s mate.');
INSERT INTO "voyages" VALUES (3206, '', 5, '', 'LEIDUIN', 'Dirk Quast', 650, NULL, '1730', NULL, NULL, 'A', 'E', '1741-01-20', 'Texel', '1741-06-12', '1741-06-27', true, '1741-09-02', 'Batavia', NULL, 'The LEIDUIN called at S. Tiago where one seafarer and one soldier deserted (05 till 30-03-1741). Some of the four seafarers who embarked at the Cape were taken over from the PATMOS (3207); at the Cape three soldiers became seafarers, The ship was laid up in the Indies on 11-09-1744.');
INSERT INTO "voyages" VALUES (3207, '', 8, '', 'PATMOS', 'David van Elteren', 810, NULL, '1722', NULL, NULL, 'R', 'A', '1741-01-20', 'Texel', '1741-06-12', '1741-06-27', true, '1741-09-09', 'Ceylon', 7200, NULL);
INSERT INTO "voyages" VALUES (3208, '', 5, '', 'VOORDUIN', 'Fredrik Schouten', 650, NULL, '1730', NULL, NULL, 'A', 'A', '1741-01-20', 'Texel', '1741-06-12', '1741-06-27', true, '1741-08-28', 'Batavia', NULL, 'Hs the fifth voyage of the VOORDUIN, which during its first voyage (2817/6844) was called ZORGWIJK. The ship was laid up in the Indies on 26-01-1745.');
INSERT INTO "voyages" VALUES (3209, '', 2, '', 'RUITER', 'Paulus Pieman', 650, NULL, '1736', NULL, NULL, 'E', 'A', '1741-01-23', 'Texel', '1741-11-10', '1741-12-06', true, '1742-02-13', 'Batavia', 7160, '08-03-1741 the RUITER was at Mountsbav where 4 seafarers and 1 soldier deserted. From 10 till 22-05-1741 the ship called at Plymouth where 17 seafarers and 3 soldiers died and 11 seafarers and 7 soldiers deserted, The diminished crew was enlarged by 37 seafarers from Amsterdam. The ship also called at S. Tiago (04 till 17-07-1741) where 1 seafarer and 1 soldier deserted and 2 soldiers became seafarers.');
INSERT INTO "voyages" VALUES (3210, '', 7, '', 'DELFLAND', 'Egbert Verduin', 600, NULL, '1717', NULL, NULL, 'D', 'D', '1741-03-29', 'Goeree', '1741-06-24', '1741-07-18', true, '1741-09-11', 'Batavia', NULL, 'After an accident on a voyage to Ambon the DELFLAND was laid up on 12-07-1746.');
INSERT INTO "voyages" VALUES (3211, '', 1, '', 'VRIJHEID', 'Jakob Pols', 650, NULL, '1740', NULL, NULL, 'R', 'R', '1741-05-06', 'Goeree', '1741-09-15', '1741-10-08', true, '1742-01-09', 'Batavia', 7163, 'One soldier probably became seafarer,');
INSERT INTO "voyages" VALUES (3212, '', 5, '', 'DUIFJE', 'Jakob van Duinen', 450, NULL, '1729', NULL, NULL, 'A', 'A', '1741-05-07', 'Texel', '1741-09-15', '1741-10-08', true, '1742-01-05', 'Batavia', NULL, 'The DUIFJE was sold at Batavia on 28-03-1747,');
INSERT INTO "voyages" VALUES (3213, '', 1, '', 'OOSTERHOUT', 'Willem Meyer', 600, NULL, '1740', NULL, NULL, 'A', 'A', '1741-05-07', 'Texel', '1742-02-09', '1742-03-11', true, '1742-06-14', 'Batavia', NULL, 'The OOSTERHOUT called at S. Tiago (16 till 26-06-1741) and at Saldanha Bay (.13-12-1741 till 08-02-1742). See also 3214. The ship was laid up at Batavia on 16-04-1748.');
INSERT INTO "voyages" VALUES (3214, '', 3, '', 'HUIS DEN EULT', 'Christiaan Boord', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1741-05-18', 'Texel', '1741-11-04', '1741-12-03', true, '1742-02-25', 'Batavia', NULL, 'From 04 till 17-07-1741 the ship called at S. Tiago where one seafarer, deserted from the OOSTERHOUT (3213), embarked, One soldier probably became seafarer. The ship was laid up in the Indies on 25-02-1746,');
INSERT INTO "voyages" VALUES (3215, '', 3, '', 'HUIS TE RENSBURG', 'Jan Mijsters', 850, NULL, '1733', NULL, NULL, 'Z', 'Z', '1741-05-22', 'Rammekens', '1741-11-04', '1741-12-03', true, '1742-04-18', 'Ceylon', 7187, 'From 04 till 17-07-1741 the ship was at S. Tiago.');
INSERT INTO "voyages" VALUES (3216, '', 4, '', 'VLISSINGEN', 'Huibert Tiebout', 650, NULL, '1732', NULL, NULL, 'Z', 'Z', '1741-05-22', 'Rammekens', '1741-10-31', '1742-02-28', true, '1742-06-12', 'Batavia', 7222, 'till 30-10-1741),');
INSERT INTO "voyages" VALUES (3217, '', 3, '', 'WESTHOVEN', 'Jan de Jong', 650, NULL, '1734', NULL, NULL, 'Z', 'Z', '1741-05-22', 'Rammekens', '1741-11-03', '1741-12-13', true, '1742-03-17', 'Batavia', 7193, 'From 06 till 17-07-1741 the WESTHOVEN was at S. Tiago and from 27-10 till 02-11-1741 it was at Dassen Island.');
INSERT INTO "voyages" VALUES (3218, '', 5, '', 'MEERLUST', 'Gerrit Blauwpot', 600, NULL, '1725', NULL, NULL, 'A', 'H', '1741-05-24', 'Texel', '1741-12-08', '1741-12-22', true, '1742-04-07', 'Batavia', 7165, 'From 05-11 till 07-12-1741 the MEERLUST called at Saldanha Bay. One soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3219, '', 1, '', 'IDA', 'Roelof Blok', 650, NULL, '1740', NULL, NULL, 'E', 'E', '1741-06-01', 'Texel', '1741-11-15', '1741-12-06', true, '1742-02-26', 'Batavia', 7183, 'The IDA called at Robben Island (05 till 16-11-1741).');
INSERT INTO "voyages" VALUES (3220, '', 1, '', 'ROZENBEEK', 'Nanning Broeder', 200, 'galjoot', '1731', NULL, NULL, 'A', 'A', '1741-10-19', 'Texel', '1742-02-20', NULL, true, '1742-02-20', 'The Cape', 7148, 'orders''.');
INSERT INTO "voyages" VALUES (3221, '', 1, '', 'BOSBEEK', 'Jan Tobias Toon', 650, NULL, '1741', NULL, NULL, 'A', 'A', '1741-10-23', 'Texel', '1742-02-26', '1742-03-11', true, '1742-05-24', 'Batavia', 7158, 'During the voyage two soldiers probably became seafarers,');
INSERT INTO "voyages" VALUES (3222, '', 2, '', 'DRECHTERLAND', 'Pieter Krook', 650, NULL, '1736', NULL, NULL, 'H', 'A', '1741-10-23', 'Texel', '1742-02-22', '1742-03-23', true, '1742-06-12', 'Batavia', 7178, NULL);
INSERT INTO "voyages" VALUES (3223, '', 4, '', 'KERKWIJK', 'Pieter Sluis', 850, NULL, '1733', NULL, NULL, 'A', 'A', '1741-10-23', 'Texel', '1742-03-13', '1742-04-07', true, '1742-06-20', 'Batavia', 7216, NULL);
INSERT INTO "voyages" VALUES (3224, '', 3, '', 'NOORDWOLFSBERGEN', 'Wijnand Meurs', 650, NULL, '1733', NULL, NULL, 'A', 'A', '1741-10-23', 'Texel', '1742-03-14', '1742-04-07', true, '1742-06-12', 'Batavia', NULL, 'seafarer probably became soldier, The NOORDWOLFSBERGEN was sold at Batavia on 10-11-1747.');
INSERT INTO "voyages" VALUES (3225, '', 3, '', 'POPKENSBURG', 'Jan van Schutterop', 850, NULL, '1732', NULL, NULL, 'Z', 'A', '1741-10-23', 'Texel', '1742-02-20', '1742-03-13', true, '1742-06-12', 'Batavia', 7207, NULL);
INSERT INTO "voyages" VALUES (3226, '', 1, '', 'TOLSDUIN', 'Pieter Kouderk', 850, NULL, '1741', NULL, NULL, 'A', 'A', '1741-10-23', 'Texel', '1742-03-18', '1742-04-27', true, '1742-07-17', 'Batavia', 7157, 'The TOLSDUIN called at S. Tiago (14 till 26-12-1741).');
INSERT INTO "voyages" VALUES (3227, '', 4, '', 'SIJBEKARSPEL', 'Barend de Bruin', 650, NULL, '1729', NULL, NULL, 'H', 'A', '1741-10-23', 'Texel', '1742-03-14', '1742-04-07', true, '1742-06-20', 'Batavia', 7167, 'During the voyage one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3228, '', 4, '', '''S HEER ARENDSKERKE', 'Kornelis Ariensz. Keet', 600, NULL, '1724', NULL, NULL, 'Z', 'R', '1741-10-24', 'Goeree', '1742-03-22', '1742-04-17', true, '1742-07-17', 'Batavia', NULL, 'Batavia on 01-11-1752,');
INSERT INTO "voyages" VALUES (3229, '', 1, '', 'DOMBURG', 'Dirk Tromp', 850, NULL, '1740', NULL, NULL, 'Z', 'Z', '1741-10-27', 'Rammekens', '1742-03-14', '1742-04-17', true, '1742-07-17', 'Batavia', 7177, 'During the voyage two soldiers probably became seafarers, One source mentions Hammen Noordrecht as master.');
INSERT INTO "voyages" VALUES (3230, '', 5, '', 'PALLAS', 'Bastiaan Koolmans', 650, NULL, '1723', NULL, NULL, 'A', 'Z', '1741-10-27', 'Rammekens', '1742-03-14', '1742-04-07', true, '1742-06-20', 'Batavia', NULL, 'Batavia on 25-04-1747.');
INSERT INTO "voyages" VALUES (3231, '', 5, '', 'KNAPPENHOF', 'Gozewijn de Vos', 650, NULL, '1731', NULL, NULL, 'A', 'R', '1741-12-14', 'Goeree', '1742-04-30', '1742-05-20', true, '1742-10-13', 'Batavia', 7169, 'The KNAPPENHOF called at Duins (21-12-1741 till 02-01-1742).');
INSERT INTO "voyages" VALUES (3232, '', 4, '', 'VREELAND', 'Arie Verdoes', 650, NULL, '1735', NULL, NULL, 'A', 'D', '1741-12-14', 'Goeree', '1742-04-30', '1742-05-20', true, '1742-08-08', 'Batavia', 7172, 'The VREELAND called at Portsmouth (19 till 23-12-1741). Three soldiers became seafarers.');
INSERT INTO "voyages" VALUES (3233, '', 4, '', 'BETHLEHEM', 'Usbrand Moens', 850, NULL, '1731', NULL, NULL, 'A', 'Z', '1741-12-26', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The BETHLEHEM stranded at the Flemish sandbanks off Oostende on 29-12-1741. See also 3252. The ship was bound for Ceylon.');
INSERT INTO "voyages" VALUES (3234, '', 2, '', 'HORSSEN', 'Booy Kornelisz.', 650, NULL, '1739', NULL, NULL, 'A', 'A', '1741-12-26', 'Texel', '1742-04-12', '1742-05-04', true, '1742-06-22', 'Ceylon', NULL, 'The HORSSEN was laid up in the Indies on 15-08-1749. In one source Pieter Aas is mentioned as master.');
INSERT INTO "voyages" VALUES (3235, '', 1, '', 'LEEUWERIK', 'Dominikus Wormhout', 650, NULL, '1741', NULL, NULL, 'A', 'A', '1741-12-26', 'Texel', '1742-04-29', '1742-05-20', true, '1742-08-08', 'Batavia', 7175, NULL);
INSERT INTO "voyages" VALUES (3236, '', 4, '', 'HUIS TE MARQUETTE', 'Reinier Brugman', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1741-12-26', 'Texel', '1742-04-12', '1742-05-11', true, '1742-07-02', 'Batavia', 7153, NULL);
INSERT INTO "voyages" VALUES (3237, '', 2, '', 'OUWERKERK', 'Meindert de Beer', 540, NULL, '1738', NULL, NULL, 'Z', 'E', '1741-12-26', 'Texel', '1742-04-12', '1742-05-11', true, '1742-07-17', 'Batavia', 7154, NULL);
INSERT INTO "voyages" VALUES (3238, '', 3, '', 'RIJNHUIZEN', 'Gerrit Reyndertsz. Vos', 650, NULL, '1736', NULL, NULL, 'R', 'H', '1741-12-26', 'Texel', '1742-04-30', '1742-05-20', true, '1742-10-14', 'Batavia', 7171, NULL);
INSERT INTO "voyages" VALUES (3239, '', 1, '', 'DUINENBURG', 'Hendrik Jansen', 650, NULL, '1740', NULL, NULL, 'Z', 'Z', '1742-01-03', 'Rammekens', '1742-05-10', '1742-06-23', true, '1742-11-08', 'Batavia', 7179, 'The DUINENBURG did not call at the Cape, but at False Bay.');
INSERT INTO "voyages" VALUES (3240, '', 8, '', 'NIEUWVLIET', 'Pieter Koor', 650, NULL, '1719', NULL, NULL, 'Z', 'Z', '1742-01-03', 'Rammekens', '1742-04-16', '1742-05-11', true, '1742-07-17', 'Batavia', NULL, 'During the voyage one soldier probably became seafarer. The NIEUWVLIET was laid up at Batavia on 23-07-1750.');
INSERT INTO "voyages" VALUES (3241, '', 2, '', 'SARA JACOBA', 'Jan Revnders', 1100, NULL, '1737', NULL, NULL, 'Z', 'Z', '1742-03-08', 'Rammekens', '1742-08-02', '1742-08-12', true, '1742-11-05', 'Batavia', 7196, 'The SARA JACOBA called at Saldanha Bay (25-06 till 01-08-1742) where 9 seafarers and 4 soldiers died. The six passengers who embarked at the Cape included ex-Governor-General Adriaan Valkenier, arrested at the Cape after his return from Batavia in January 1742 (see also 7130); he was accused by the future Governor-General Van Imhoff of being reponsible for the notorious ''Chinese murders'' in Batavia in 1740.');
INSERT INTO "voyages" VALUES (3242, '', 2, '', 'HOF VAN DELFT', 'Pieter van der Linden', 850, NULL, '1739', NULL, NULL, 'D', 'D', '1742-04-08', 'Goeree', '1742-08-10', '1742-09-15', true, '1742-11-25', 'Batavia', 7174, 'but at False Bay.');
INSERT INTO "voyages" VALUES (3243, '', 4, '', 'HOFWEGEN', 'Jan de Wit', 650, NULL, '1731', NULL, NULL, 'R', 'R', '1742-04-10', 'Goeree', NULL, NULL, false, '1742-10-07', 'Batavia', NULL, 'On 01-09-1746 the ship exploded on the roads of Batavia.');
INSERT INTO "voyages" VALUES (3244, '', 4, '', 'BEUKESTIJN', 'Jan de Boer', 850, NULL, '1734', NULL, NULL, 'A', 'A', '1742-05-03', 'Texel', '1742-08-23', '1742-09-09', true, '1742-12-22', 'Batavia', 7215, NULL);
INSERT INTO "voyages" VALUES (3245, '', 4, '', 'GOIDSCHALXOORD', 'Douwe Jansz. Mout', 850, 'fluit', '1734', NULL, NULL, 'A', 'A', '1742-05-03', 'Texel', '1742-08-22', '1742-10-29', true, '1743-01-06', 'Batavia', 7195, 'One soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3246, '', 3, '', 'NIEUWERKERK', 'Willem Houthuizen', 1135, NULL, '1735', NULL, NULL, 'Z', 'A', '1742-05-03', 'Texel', '1742-09-06', '1742-09-26', true, '1742-12-11', 'Batavia', 7184, 'One soldier became seafarer.');
INSERT INTO "voyages" VALUES (3247, '', 5, '', 'NIEUW WALCHEREN', 'Nikolaas van Ewijk', 850, NULL, '1731', NULL, NULL, 'Z', 'A', '1742-05-03', 'Texel', '1742-08-22', '1742-09-09', true, '1742-12-20', 'Batavia', 7218, 'One seafarer became soldier.');
INSERT INTO "voyages" VALUES (3248, '', 3, '', 'WATERVLIET', 'Gerbrand Swaag', 650, NULL, '1736', NULL, NULL, 'A', 'E', '1742-05-03', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The WATERVLIET ran ashore off Calais on 05-05-1742. See also 3261.');
INSERT INTO "voyages" VALUES (3249, '', 2, '', 'POLANEN', 'Herman Quinje', 650, NULL, '1737', NULL, NULL, 'A', 'H', '1742-05-05', 'Texel', '1742-09-11', '1742-10-09', true, '1743-01-12', 'Batavia', 7194, 'at Robben Island. At the Cape two soldiers became cook and cook''s wain; another soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3250, '', 8, '', 'EVERSWAART', 'Kornelis de Zitter', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1742-05-15', 'Rammekens', '1742-09-11', '1742-10-03', true, '1743-01-08', 'Batavia', NULL, 'one soldier became cook, The ship was laid up at Batavia on 03-12-1748.');
INSERT INTO "voyages" VALUES (3251, '', 4, '', 'SCHEIJBEEK', 'Jan Bijland', 850, NULL, '1735', NULL, NULL, 'A', 'Z', '1742-05-15', 'Rammekens', '1742-08-25', '1742-09-18', true, '1743-11-22', 'Batavia', 7197, NULL);
INSERT INTO "voyages" VALUES (3252, '', 5, '', 'PAPENBURG', 'Pieter Elsvliet', 800, NULL, '1729', NULL, NULL, 'A', 'A', '1742-06-20', 'Texel', '1742-10-04', '1742-11-09', true, '1743-02-02', 'Ceylon', NULL, 'The PAPENBURG replaced the wrecked BETHLEHEM (see 3233). The ship was sold at Batavia on 05-05-1747.');
INSERT INTO "voyages" VALUES (3253, '', 1, '', 'ANNA', 'Christoffel Blom', 600, NULL, '1741', NULL, NULL, 'A', 'A', '1742-10-27', 'Texel', '1743-01-24', '1743-02-18', true, '1743-05-28', 'Batavia', 7176, 'The ANNA called at Madeira (12 till 14-11-1742) and at S. Tiago (25/6-11-1742). During the voyage, probably at the Cape, one seafarer was taken over by the EENDRACHT (3254); five soldiers became seafarers.');
INSERT INTO "voyages" VALUES (3254, '', 1, '', 'EENDRACHT', 'Jakob Verleng', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1742-10-27', 'Texel', '1743-02-02', '1743-02-28', true, '1743-05-28', 'Batavia', 7180, 'The EENDRACHT called at Madeira (12 till 14-11-1742) and at S. Tiago (25/6-11-1742). See also 3253.');
INSERT INTO "voyages" VALUES (3255, '', 1, '', 'FORTUIN', 'Kornelis Booys', 600, NULL, '1741', NULL, NULL, 'A', 'A', '1742-10-27', 'Texel', '1743-01-21', '1743-02-18', true, '1743-05-28', 'Batavia', 7201, 'The FORTUIN called at Madeira (12 till 14-11-1742) and at S. Tiago (25/6-11-1742), At the Cape 2 seafarers disembarked, another deserted; the 14 passengers who embarked at the Cape included 4 slaves.');
INSERT INTO "voyages" VALUES (3256, '', 1, '', 'HERSTELDER', 'Jean Belleveau', 1150, NULL, NULL, '1741', NULL, 'A', 'A', '1742-10-27', 'Texel', '1743-01-21', '1743-02-28', true, '1743-05-28', 'Batavia', 7181, 'previously called EDAM, had been bought by the VOC from the Admiralty of Amsterdam, The 9 passengers included Governor-General Van Imhoff and 7 servants. From 12 till 14-11-1742 the ship called at Madeira where 2 seafarers embarked. The ship also called at S. Tiago (25/6-11-1742) where 1 seafarer died, At the Cape 3 seafarers and 1 servant of the GG became soldiers.');
INSERT INTO "voyages" VALUES (3257, '', 8, '', 'WICKENBURG', 'Jan Licent', 850, NULL, '1722', NULL, NULL, 'Z', 'A', '1742-10-28', 'Texel', '1743-01-24', '1743-02-06', true, '1743-05-10', 'Ceylon', NULL, 'The WICKENBURG called at Madeira (12 till 14-11-1742) and at S. Tiago (25/6-11-1742). The ship was laid up in the Indies on 07-05-1748.');
INSERT INTO "voyages" VALUES (3258, '', 3, '', 'SCHELLAG', 'Anthonie Uiterschouw', 850, NULL, '1736', NULL, NULL, 'Z', 'Z', '1742-11-01', 'Rammekens', '1743-03-01', '1743-03-16', true, '1743-05-28', 'Batavia', 7185, 'From 05 till 21-11-1742 the SCHELLAG was at Portsmouth.');
INSERT INTO "voyages" VALUES (3259, '', 1, '', 'ZAAMSLAG', 'Nanning Broeder', 900, NULL, '1741', NULL, NULL, 'Z', 'Z', '1742-11-01', 'Rammekens', '1743-02-28', '1743-03-16', true, '1743-05-28', 'Batavia', 7186, 'The ZAAMSLAG called at Portsmouth (05 till 21-11-1742) and at S. Tiago (15 till 20-12-1742) where 11 persons died and 13 soldiers deserted.');
INSERT INTO "voyages" VALUES (3260, '', 6, '', 'ADRICHEM', 'Kornelis van Velden', 850, NULL, '1726', NULL, NULL, 'A', 'A', '1742-11-22', 'Texel', '1743-03-28', '1743-04-24', true, '1743-07-21', 'Batavia', NULL, 'as master.');
INSERT INTO "voyages" VALUES (3261, '', 5, '', 'HOFVLIET', 'Pieter Lakeman', 1000, NULL, '1729', NULL, NULL, 'R', 'E', '1742-11-22', 'Texel', '1743-03-22', '1743-04-11', true, '1743-10-15', 'Batavia', 7182, 'During the voyage one seafarer became soldier. The HOF-VLIET replaced the W ATERVLIET, wrecked in May 1742 (see 3248).');
INSERT INTO "voyages" VALUES (3262, '', 1, '', 'KLEVERSKERKE', 'Anthonie Marijnissen +', 850, NULL, '1742', NULL, NULL, 'Z', 'Z', '1742-12-12', 'Rammekens', '1743-03-19', '1743-04-09', true, '1743-10-15', 'Batavia', 7244, 'Two seafarers were taken over by an English man-of-war. Anthonie Marijnissen died during the voyage.');
INSERT INTO "voyages" VALUES (3263, '', 3, '', 'ARNESTUN', 'Bastiaan Verdoes', 575, NULL, '1736', NULL, NULL, 'Z', 'A', '1743-03-07', 'Texel', '1743-08-03', '1743-08-23', true, '1743-11-05', 'Batavia', 7188, 'From 30-04 till 13-05-1743 the ship was at S. Tiago. At the Cape one soldier became seafarer,');
INSERT INTO "voyages" VALUES (3264, '', 4, '', 'BATAVIER', 'Marten den Breems', 525, NULL, '1735', NULL, NULL, 'A', 'A', '1743-03-07', 'Texel', '1743-08-02', '1743-08-08', true, '1743-10-22', 'Batavia', 7219, 'the ship called at S. Tiago, where 2 soldiers died.');
INSERT INTO "voyages" VALUES (3265, '', 1, '', 'LEIDERDORP', 'Hendrik Weiland', 600, NULL, '1741', NULL, NULL, 'A', 'A', '1743-03-07', 'Texel', '1743-08-11', '1743-09-28', true, '1743-12-15', 'Batavia', NULL, 'On its way to the Cape the ship called at S. Tiago (30-04 till 13-05-1743). At the Cape 8 seafarers were taken over by the HOOP (see 3272) and 2 seafarers deserted. The LEIDERDORP was laid up in the Indies on 20-08-1748.');
INSERT INTO "voyages" VALUES (3266, '', 2, '', 'WELTEVREDEN', 'Harke Zeres', 850, NULL, '1740', NULL, NULL, 'A', 'A', '1743-03-07', 'Texel', '1743-08-06', '1743-08-23', true, '1743-11-12', 'Batavia', 7199, 'One source mentions Pieter Schildman as master.');
INSERT INTO "voyages" VALUES (3267, '', 3, '', 'KASTEEL VAN WOERDEN', 'Willem Vroom', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1743-03-19', 'Texel', '1743-07-23', '1743-08-18', true, '1743-11-13', 'Ceylon', 3267, 'its first voyage(3077/7057) was called BUVEGNIES. The KASTEEL VAN WOERDEN was laid up in the Indies on 08-10-1744.');
INSERT INTO "voyages" VALUES (3268, '', 3, '', 'HARTENLUST', 'Gijsbert Bonekamp', 650, NULL, '1734', NULL, NULL, 'A', 'R', '1743-03-29', 'Goeree', '1743-08-06', '1743-08-23', true, '1743-11-14', 'Batavia', 7190, NULL);
INSERT INTO "voyages" VALUES (3269, '', 3, '', 'LOVERENDAAL', 'Kornelis Mangelaar', 650, NULL, '1737', NULL, NULL, 'Z', 'Z', '1743-03-30', 'Rammekens', '1743-08-12', '1743-09-21', true, '1743-12-20', 'Batavia', NULL, 'The LOVERENDAAL called at Duins from 11 till 27-04-1743 where at Duins 10 seafarers deserted, one soldier died and the crew was enlarged by one seafarer; 2 soldiers became seafarers. The ship was laid up at Batavia on 13-12-1751.');
INSERT INTO "voyages" VALUES (3270, '', 2, '', 'HUIS TER DUINE', 'Pieter Adriaansz.', 550, NULL, '1739', NULL, NULL, 'Z', 'Z', '1743-04-25', 'Rammekens', '1743-08-06', '1743-09-05', true, '1743-11-12', 'Batavia', 7189, 'The 16 seafarers who disembarked at the Cape included 3 deserters.');
INSERT INTO "voyages" VALUES (3271, '', 3, '', 'STRIJEN', 'Gijsbert van der Blok', 650, NULL, '1735', NULL, NULL, 'D', 'D', '1743-04-25', 'Goeree', '1743-09-14', '1744-10-20', true, '1744-01-03', 'Batavia', 7203, NULL);
INSERT INTO "voyages" VALUES (3272, '', 1, '', 'HOOP', 'Pieter Zwanendrecht', 850, NULL, '1742', NULL, NULL, 'D', 'D', '1743-05-10', 'Goeree', '1743-09-21', '1743-10-12', true, '1744-02-12', 'Batavia', 7220, 'From 15 till 20-06-1743 the ship was at S. Tiago. See also 3265.');
INSERT INTO "voyages" VALUES (3273, '', 3, '', 'RUYVEN', 'Christiaan de Jong', 650, NULL, '1736', NULL, NULL, 'D', 'R', '1743-06-24', 'Goeree', '1743-12-10', '1744-01-11', true, '1744-05-14', 'Batavia', NULL, 'The RUYVEN called at Duins from 28-06 till 01-07-1743. On 11-09-1745 the ship was wrecked on the Ganges.');
INSERT INTO "voyages" VALUES (3274, '', 2, '', 'HEUVEL', 'Daniel ten Velde', 650, NULL, '1740', NULL, NULL, 'A', 'A', '1743-07-03', 'Texel', '1743-12-18', '1744-01-09', true, '1744-05-10', 'Batavia', 7225, 'From 20 till 29-08-1743 the HEUVEL was at S. Tiago. The ship replaced the ENKHUIZEN, lost in 1742 (see 7138).');
INSERT INTO "voyages" VALUES (3275, '', 1, '', 'HOLLANDIA', 'Jan Kelder', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1743-07-03', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'HOLLANDIA was wrecked at the Sorlings on 13-07-1743. The wreck was found in 1971; coins from the HOLLANDIA were put up for auction in 1972.');
INSERT INTO "voyages" VALUES (3276, '', 1, '', 'OVERNES', 'Hendrik de Ruyter', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1743-07-03', 'Texel', '1743-12-08', '1744-01-02', true, '1744-04-11', 'Batavia', 7224, 'From 19 till 29-08-1743 the ship was at S. Tiago where the crew was enlarged by 2 seafarers. During the voyage 2 soldiers became seafarers.');
INSERT INTO "voyages" VALUES (3277, '', 2, '', 'MAARSSEVEEN', 'Koenraad van der Poel', 850, NULL, '1739', NULL, NULL, 'A', 'Z', '1743-07-26', 'Rammekens', '1744-01-15', '1744-02-28', true, '1744-06-27', 'Batavia', 7206, NULL);
INSERT INTO "voyages" VALUES (3278, '', 6, '', 'HOGERSMILDE', 'Otto van Dam', 850, NULL, '1723', NULL, NULL, 'H', 'Z', '1743-08-29', 'Rammekens', '1744-01-18', '1744-02-28', true, '1745-02-25', 'Ceylon', 7228, '3278/7228 Is the sixth voyage of the HOGERSMILDE, which during its first four voyages was called WAPEN VAN HOORN.');
INSERT INTO "voyages" VALUES (3279, '', 1, '', 'VERWACHTING', 'Gerrit van der Tolle', 850, NULL, '1742', NULL, NULL, 'Z', 'Z', '1743-08-29', 'Rammekens', '1744-01-01', '1744-02-05', true, '1744-05-13', 'Batavia', NULL, 'to Surat.');
INSERT INTO "voyages" VALUES (3280, '', 1, '', 'HUIGENWAARD', 'Adam Roos', 850, NULL, '1742', NULL, NULL, 'H', 'H', '1743-09-25', 'Texel', '1744-01-29', '1744-02-12', true, '1744-08-22', 'Batavia', 7247, 'The HUIGENWAARD called at Saldanha Bay, where one craftsmen died.');
INSERT INTO "voyages" VALUES (3281, '', 1, '', 'AKERENDAM', 'Paulus Pieman', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1743-10-27', 'Texel', '1744-02-24', '1744-03-14', true, '1744-05-27', 'Batavia', 7213, 'and at S. Tiago (29-12-1743 till 05-01-1744). At S. Tiago one soldier deserted.');
INSERT INTO "voyages" VALUES (3282, '', 1, '', 'DUINHOF', 'Kornelis Bommer', 850, NULL, '1743', NULL, NULL, 'A', 'A', '1743-10-27', 'Texel', '1744-03-26', '1744-04-18', true, '1744-06-11', 'Batavia', 7233, 'From 18 till 19-11-1743 the DUINHOF was at Duins.');
INSERT INTO "voyages" VALUES (3283, '', 5, '', 'RUST EN WERK', 'Pieter Jellesz.', 650, NULL, '1734', NULL, NULL, 'D', 'A', '1743-10-27', 'Texel', '1744-04-05', '1744-04-23', true, NULL, 'Batavia', 7209, '22-01-1744).');
INSERT INTO "voyages" VALUES (3284, '', 2, '', 'BOSBEEK', 'Laurens Siewertsz.', 650, NULL, '1741', NULL, NULL, 'A', 'A', '1743-11-27', 'Texel', '1744-03-30', '1744-04-20', true, '1744-06-26', 'Batavia', 7223, '31-12-1743) where 8 seafarers deserted. During the voyage one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3285, '', 1, '', 'GERECHTIGHEID', 'Meindert de Beer', 850, NULL, '1742', NULL, NULL, 'E', 'E', '1743-11-27', 'Texel', '1744-04-01', '1744-04-18', true, '1744-07-07', 'Batavia', 7212, 'At the Cape 6 soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3286, '', 2, '', 'HECTOR', 'Jan Raay', NULL, 'hoeker', '1738', NULL, NULL, 'Z', 'A', '1743-11-27', 'Texel', '1744-05-26', NULL, true, '1744-05-26', 'The Cape', 7360, 'During the voyage Jan Bop succeeded Jan Raay as master, one source mentions Gerrit Bot. From 26-12-1743 till 06-02-1744 the ship was at Morlaix.');
INSERT INTO "voyages" VALUES (3287, '', 5, '', 'HUTS TE MARQUETTE', 'Paulus Lindenberg', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1743-11-27', 'Texel', '1744-03-27', '1744-04-18', true, '1744-08-06', 'Batavia', NULL, 'One week after its departure from Texel the ship returned (04-12-1743); on 27-12 it sailed out again. The HUTS TE MAR-QUETTE was sold at Batavia on 10-11-1747.');
INSERT INTO "voyages" VALUES (3288, '', 1, '', 'STANDVASTIGHEID', 'Willem de Wijs', 850, NULL, '1743', NULL, NULL, 'R', 'R', '1743-11-27', 'Goeree', '1744-03-17', '1744-04-06', true, '1744-06-22', 'Batavia', 7221, 'On its way to the Cape the ship called at Duins (08-till 13-12-1743) where 2 seafarers deserted, at Dassen Island (17-02 till 06-03-1744), and at Saldanha Bay. During the voyage one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3289, '', 2, '', 'TOLSDUIN', 'Maarten van der Meer', 850, NULL, '1741', NULL, NULL, 'A', 'D', '1743-11-27', 'Goeree', '1744-04-12', '1744-05-01', true, NULL, 'Batavia', 7208, '(17-12-1743 till 06-01-1744) where 11 seafarers and 4 soldiers were pressed by the English. During the voyage one soldier became seafarer.');
INSERT INTO "voyages" VALUES (3290, '', 2, '', 'WOITKENSDORP', 'Jurriaan Koperslager', 800, NULL, '1739', NULL, NULL, 'Z', 'A', '1743-11-27', 'Texel', '1744-03-02', '1744-03-21', true, '1744-06-11', 'Batavia', 7211, NULL);
INSERT INTO "voyages" VALUES (3291, '', 2, '', 'KRABBENDIJKE', 'Frans Gassels', 830, NULL, '1738', NULL, NULL, 'Z', 'A', '1743-12-27', 'Texel', '1744-04-15', '1744-05-08', true, '1744-08-07', 'Batavia', 7205, 'At the Cape one stowaway, not registered in the columns, disembarked; one soldier became third meester (counted as seafarer).');
INSERT INTO "voyages" VALUES (3292, '', 2, '', 'DISHOEK', 'Jan Hugo Captijn', 665, NULL, '1735', NULL, NULL, 'Z', 'Z', '1743-12-31', 'Rammekens', '1744-04-14', '1744-05-01', true, '1744-08-22', 'Batavia', 7204, 'From 02 till 04-02-1744 the DISHOEK called at S. Tiago where one seafarer died, another seafarer and one soldier deserted.');
INSERT INTO "voyages" VALUES (3293, '', 3, '', 'OUWERKERK', 'Kornelis Stevens', 540, NULL, '1738', NULL, NULL, 'Z', 'Z', '1743-12-31', 'Rammekens', '1744-05-13', '1744-06-02', true, '1744-09-07', 'Batavia', 7214, 'embarked, two of them died on the way to Batavia.');
INSERT INTO "voyages" VALUES (3294, '', 4, '', 'JONGE WILLEM', 'Jan Akkerveld', 650, NULL, '1731', NULL, NULL, 'Z', 'Z', '1743-12-31', 'Rammekens', '1744-05-04', '1744-05-15', true, '1744-08-17', 'Batavia', NULL, 'S. Tiago where two seafarers died and six soldiers deserted. The ship was laid up in the Indies on 03-06-1749.');
INSERT INTO "voyages" VALUES (3295, '', 5, '', 'SIJBEKARSPEL', 'Hendrik Volkers', 650, NULL, '1729', NULL, NULL, 'H', 'A', '1744-01-09', 'Texel', '1744-04-06', '1744-04-18', true, '1744-07-03', 'Batavia', 7210, '09-01-1744 Was the final date of departure of the SIJBEKAR-SPEL; on 01-01-1744 the ship set out for the first time. but four days later it returned to Texel.');
INSERT INTO "voyages" VALUES (3296, '', 3, '', 'RUITER', 'Bastiaan Mol', 650, NULL, '1736', NULL, NULL, 'E', 'E', '1744-01-09', 'Texel', '1744-06-02', '1744-07-06', true, '1744-09-20', 'Batavia', NULL, 'From 07 till 18-02-1744 the RUITER called at S. Tiago where one seafarer and five soldiers died; the crew was enlarged by one seafarer, taken over from the OUWERKERK (see 3293), and one soldier. At the Cape ten seafarers deserted. The ship was laid up in the Indies on 03-06-1749.');
INSERT INTO "voyages" VALUES (3297, '', 6, '', 'KNAPPENHOF', 'Herman Schutte', 650, NULL, '1731', NULL, NULL, 'A', 'A', '1744-01-11', 'Texel', '1744-05-22', '1744-07-06', true, '1744-09-22', 'Ceylon', 7217, 'The KNAPENHOF called at Duins (16-01 till 03-02-1744). It did not call at the Cape, but at False Bay.');
INSERT INTO "voyages" VALUES (3298, '', 2, '', 'VRIJHEID', 'Adriaan van Dorp+', 650, NULL, '1740', NULL, NULL, 'R', 'D', '1744-05-12', 'Goeree', '1744-11-01', '1744-11-30', true, '1745-04-12', 'Batavia', 7275, NULL);
INSERT INTO "voyages" VALUES (3299, '', 1, '', 'NIEUW VIJVERVREUGD', 'Hendrik Bossen', 1150, NULL, '1742', NULL, NULL, 'Z', 'Z', '1744-05-13', 'Rammekens', '1744-09-14', '1744-10-01', true, '1744-12-06', 'Batavia', NULL, 'During the voyage one soldier became seafarer. The seven passengers were criminals. The NIEUW VIJVERVREUGD exploded in 1746 on the roads of Batavia.');
INSERT INTO "voyages" VALUES (3300, '', 2, '', 'LEEUWERIK', 'Adriaan Laurens', 650, NULL, '1741', NULL, NULL, 'A', 'A', '1744-05-17', 'Texel', '1744-10-11', '1744-11-03', true, '1745-01-25', 'Ceylon', NULL, 'The LEEUWERIK called at S. Tiago (10 till 17-07-1744). In 1748 the ship was wrecked near Macassar.');
INSERT INTO "voyages" VALUES (3301, '', 4, '', 'HUIS TE FOREEST', 'Gerrit Blauwpot', 850, NULL, '1731', NULL, NULL, 'H', 'A', '1744-05-27', 'Texel', '1744-10-12', '1744-11-03', true, '1745-01-11', 'Batavia', NULL, 'Tiago. One of the soldiers became cook''s wain. The 2 seafarers who embarked at the Cape included a master, Kornelis Booys.');
INSERT INTO "voyages" VALUES (3302, '', 4, '', 'NIEUWLAND', 'Jan de Zee', 850, NULL, '1733', NULL, NULL, 'Z', 'H', '1744-06-06', 'Texel', '1744-12-16', '1744-12-28', true, '1745-04-28', 'Batavia', 7238, NULL);
INSERT INTO "voyages" VALUES (3303, '', 4, '', 'DIEMERMEER', 'Christiaan Boord', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1744-07-19', 'Texel', '1745-01-11', '1745-02-09', true, '1745-08-14', 'Ceylon', 7257, 'From 04 till 15-10-1744 the DIEMERMEER was at S. Tiago.');
INSERT INTO "voyages" VALUES (3304, '', 7, '', 'KETEL', 'Kornelis Quack', 810, NULL, '1721', NULL, NULL, 'R', 'R', '1744-07-31', 'Goeree', '1745-04-02', '1745-04-27', true, '1745-07-14', 'Batavia', NULL, 'The KETEL called at Portsmouth from 06-08 till 09-12-1744. See also 3313. According to a Resolution of Gouverneur-Generaal en Raden the ship was sold to Spanish merchants at Manila in 1748.');
INSERT INTO "voyages" VALUES (3305, '', 1, '', 'VOORZICHTIGHEID', 'der Schilde', 850, NULL, '1744', NULL, NULL, 'D', 'D', '1744-10-04', 'Goeree', '1745-05-05', '1745-06-29', true, '1745-09-11', 'Batavia', 7235, 'The VOORZICHTIGHEID did not call at the Cape but at Saldanha Bay.');
INSERT INTO "voyages" VALUES (3306, '', 1, '', 'HUTS TE PERSIJN', 'Jan Koning', 850, NULL, '1743', NULL, NULL, 'R', 'R', '1744-11-06', 'Goeree', '1745-05-25', '1745-06-11', true, '1745-08-17', 'Batavia', 7234, 'One day after its departure the ship returned to Goeree (07-11-1744); it finally set out on 08-12-1744. From 29-12-1744 till 26-01-1745 the ship called at Duins. The HUIS TE PERSIJN did not call at the Cape, but at False Bay (25-05 till 11-06-1745). During the voyage 4 soldiers became seafarers.');
INSERT INTO "voyages" VALUES (3307, '', 3, '', 'HOF VAN DELFT', 'Jan Bloem', 850, NULL, '1739', NULL, NULL, 'D', 'A', '1744-11-06', 'Texel', '1745-03-27', '1745-04-12', true, '1745-06-30', 'Batavia', NULL, 'after its departure the ship returned to Texel (10-11-1744); it finally sailed out on 09-12. The eight passengers included one female slave. The HOF VAN DELFT was sold in the Indies on 17-02-1750.');
INSERT INTO "voyages" VALUES (3308, '', 1, '', 'DIEMEN', 'Barend de Bruin', 850, NULL, '1743', NULL, NULL, 'A', 'A', '1744-11-06', 'Texel', '1745-03-29', '1745-04-16', true, '1745-07-02', 'Batavia', 7239, 'Four days after its departure the DIEMEN returned to Texel (10-11-1744); it finally set out on 09-12-1744. The ship carried f 250,000 in cash.');
INSERT INTO "voyages" VALUES (3309, '', 2, '', 'EENDRACHT', 'Nanning Broeder+', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1744-11-06', 'Texel', '1745-03-07', '1745-03-22', true, '1745-06-08', 'Batavia', 7251, '7208). Nanning Broeder died, his successor is unknown.');
INSERT INTO "voyages" VALUES (3310, '', 2, '', 'ZAAMSLAG', 'Johannes Band', 900, NULL, '1741', NULL, NULL, 'Z', 'A', '1744-11-06', 'Texel', '1745-03-26', '1745-04-12', true, '1745-06-13', 'Batavia', 7236, 'to Texel on 10-11 ; it finally departed on 09-12-1744. The ship carried f 200,000 in cash.');
INSERT INTO "voyages" VALUES (3311, '', 1, '', 'ZUIDERBURG', 'Christoffel Blom', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1744-11-06', 'Texel', '1745-03-21', '1745-04-19', true, '1745-07-02', 'Batavia', 7237, 'The ZUIDERBURG returned to Texel on 10-11, its final date of departure was 09-12-1744. The ship carried f 250,000 in cash.');
INSERT INTO "voyages" VALUES (3312, '', 2, '', 'ANNA', 'Hendrik Taal', 600, NULL, '1741', NULL, NULL, 'A', 'A', '1744-12-09', 'Texel', '1745-04-02', '1745-05-02', true, '1745-07-15', 'Batavia', 7294, NULL);
INSERT INTO "voyages" VALUES (3313, '', 1, '', 'BROUWER', 'Gerrit Revndertsz. Vos', 850, NULL, '1743', NULL, NULL, 'H', 'H', '1744-12-09', 'Texel', '1745-04-24', '1745-05-19', true, '1745-08-18', 'Batavia', 7232, 'Some of the 29 persons who disembarked at the Cape went to the KETEL (see 3304); the 16 embarking persons partially came from the KETEL and the LEIDEN (see 3321). One soldier became cook''s wain. The BROUWER replaced the ABBEKERK, wrecked on a return voyage in 1742 (see 7139).');
INSERT INTO "voyages" VALUES (3314, '', 2, '', 'DOMBURG', 'Jan Verhagen', 850, NULL, '1740', NULL, NULL, 'Z', 'A', '1744-12-09', 'Texel', '1745-04-09', '1745-04-27', true, '1745-07-05', 'Batavia', 7241, 'At the Cape one seafarer turned out to be a woman, she continued the voyage as passenger. One soldier became cook''s wain. The DOMBURG carried f 250,000 in cash.');
INSERT INTO "voyages" VALUES (3315, '', 2, '', 'REIGERSDAAL', 'Kornelis van Zwanenburg', 850, NULL, '1738', NULL, NULL, 'A', 'Z', '1744-12-09', 'Rammekens', '1745-04-07', '1745-05-02', true, '1745-07-07', 'Batavia', 7230, NULL);
INSERT INTO "voyages" VALUES (3316, '', 1, '', 'SPANDERSWOUD', 'Hendrik Gerritsz.', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1744-12-09', 'Texel', '1745-03-29', '1745-05-02', true, '1745-07-04', 'Batavia', 7231, 'the ship was at S. Tiago. One of the craftsmen became bottler''s mate. The SPANDERSWOUD carried f 100,000 in cash.');
INSERT INTO "voyages" VALUES (3317, '', 5, '', 'H UIS TE SPIJK', 'Kornelis Vis', 650, NULL, '1732', NULL, NULL, 'D', 'Z', '1744-12-09', 'Rammekens', '1745-04-20', '1745-05-10', true, '1745-07-20', 'Batavia', NULL, 'The HUIS TE SPIJK was laid up and sold at Batavia on 18-07-1752.');
INSERT INTO "voyages" VALUES (3318, '', 4, '', 'SCHELLAG', 'Willem ''t Hoen', 850, NULL, '1736', NULL, NULL, 'Z', 'A', '1745-01-14', 'Texel', '1745-06-01', '1745-06-18', true, '1745-08-17', 'Batavia', 7242, 'From 02 till 13-03-1745 the SCHELLAG was at S. Tiago: at Porto Prayo the crew was enlarged with 16 seafarers and 27 soldiers. These 43 persons came from the SCHONAUWEN (see 3320). The ship carried f 100,000 in cash. It did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3319, '', 5, '', 'VREELAND', 'Evert de Haas', 650, NULL, '1735', NULL, NULL, 'A', 'E', '1745-01-14', 'Texel', '1745-07-03', '1745-08-06', true, '1745-10-18', 'Batavia', 14, '-01-1745 Was the final date of departure of the VREELAND: on 06-12-1744 the ship sailed out for the first time, it returned to Texel the same day however. The ship called at Torbay (24 till 29-01-1745) and at Plymouth (05 till 26-02-1745). It did not call at the Cape but at False Bay: the two passengers who embarked there included one slave. The VREELAND was laid up at Batavia on 10-11-1750.');
INSERT INTO "voyages" VALUES (3320, '', 4, '', 'SCHONAUWEN', 'Evert Blinkebijle', 600, NULL, '1729', NULL, NULL, 'A', 'Z', '1745-01-20', 'Rammekens', '1745-06-15', '1745-07-08', true, NULL, 'Batavia', NULL, 'SCHELLAG (see 3318). The SCHONAUWEN did not call at the Cape but at False Bay. The ship was sold at Batavia on 29-01-1754.');
INSERT INTO "voyages" VALUES (3321, '', 1, '', 'LEIDEN', 'Jakob Verleng', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1745-01-21', 'Texel', '1745-05-11', '1745-05-19', true, '1745-07-24', 'Batavia', 7229, 'At the Cape one seafarer was taken over by the BROUWER (see 3313), another disembarked.');
INSERT INTO "voyages" VALUES (3322, '', 3, '', 'WELTEVREDEN', 'Willem Vrucht', 850, NULL, '1740', NULL, NULL, 'A', 'A', '1745-01-21', 'Texel', '1745-06-15', '1745-07-08', true, '1745-10-05', 'Ceylon', 7243, NULL);
INSERT INTO "voyages" VALUES (3323, '', 3, '', 'HUIS TER DUINE', 'Dirk Quast', 550, NULL, '1739', NULL, NULL, 'Z', 'E', '1745-01-23', 'Texel', '1745-05-03', '1745-05-19', true, '1745-07-21', 'Batavia', 7240, NULL);
INSERT INTO "voyages" VALUES (3324, '', 4, '', 'HARTENLUST', 'Bastiaan Verdoes', 650, NULL, '1734', NULL, NULL, 'A', 'A', '1745-02-26', 'Texel', '1745-06-15', '1745-07-08', true, '1745-09-13', 'Batavia', NULL, 'The HARTENLUST did not call at the Cape but at False Bay. The ship was laid up and sold at Batavia on 11-05-1753.');
INSERT INTO "voyages" VALUES (3325, '', 2, '', 'IDA', 'Simon de Boer', 650, NULL, '1740', NULL, NULL, 'E', 'D', '1745-04-21', 'Goeree', '1745-12-31', '1746-01-24', true, '1746-05-19', 'Batavia', NULL, 'before the IDA reached the Cape 20 seaferers and 11 soldiers were taken over from the DUINENBURG (see 3331). The ship was laid up in the Indies on 11-05-1751. Klaas van den Hoed and Jakob van der Meer are also mentioned in sources as master of the IDA.');
INSERT INTO "voyages" VALUES (3326, '', 4, '', 'NIEUWSTAD', 'Abraham Zwart', 650, NULL, '1733', NULL, NULL, 'H', 'A', '1745-04-21', 'Texel', '1745-09-16', '1745-10-03', true, '1745-12-13', 'Batavia', 7322, 'From 21-05 till 09-06-1745 the NIEUWSTAD called at S. Tiago where 4 seafarers and 1 soldier deserted. At the Cape one seafarer turned out to be a woman; she continued the voyage as a passenger.');
INSERT INTO "voyages" VALUES (3327, '', 3, '', 'POLANEN', 'Gijsbert Bonekamp', 650, NULL, '1737', NULL, NULL, 'A', 'R', '1745-04-21', 'Goeree', '1745-09-01', '1745-09-22', true, '1745-12-13', 'Batavia', 7266, NULL);
INSERT INTO "voyages" VALUES (3328, '', 5, '', 'GOIDSCHALXOORD', 'Gerrit Bot', 850, 'fluit', '1734', NULL, NULL, 'A', 'A', '1745-05-12', 'Texel', '1745-10-15', '1745-11-30', true, '1746-05-07', 'Batavia', NULL, 'soldiers became seafarers. The GOID-SCHALXOORD was laid up at Batavia in 1750.');
INSERT INTO "voyages" VALUES (3329, '', 4, '', 'RIJNHUIZEN', 'Adriaan de Graaf', 650, NULL, '1736', NULL, NULL, 'R', 'H', '1745-05-20', 'Texel', '1745-09-29', '1745-10-20', true, '1746-01-25', 'Batavia', NULL, 'RIJNHUIZEN was laid up at Batavia on 31-12-1751.');
INSERT INTO "voyages" VALUES (3330, '', 1, '', 'SPION', '. Jan Thorn', 150, NULL, '1745', NULL, NULL, 'A', 'A', '1745-06-11', 'Texel', '1745-12-19', '1745-12-29', true, '1746-03-23', 'Batavia', NULL, 'The SPION called at S. Tiago (25 till 30-07-1745), and at the island Annabon (19 till 22-09); from 29 till 31-10 the ship was off Angola.');
INSERT INTO "voyages" VALUES (3331, '', 2, '', 'DUINENBURG', 'Willem van Mensburg', 650, NULL, '1740', NULL, NULL, 'Z', 'E', '1745-06-30', 'Texel', '1745-12-28', '1746-01-15', true, '1746-06-07', 'Batavia', 7258, 'at Saldanha Bay. See also the IDA (3325).');
INSERT INTO "voyages" VALUES (3332, '', 2, '', 'HERSTELDER', 'Jan Mijsters', 1150, NULL, NULL, '1741', NULL, 'A', 'Z', '1745-07-03', 'Rammekens', '1745-11-25', '1745-12-14', true, '1746-03-05', 'Batavia', 7346, 'The HERSTELDER called at Saldanha Bay from 06 till 25-11-1745.');
INSERT INTO "voyages" VALUES (3333, '', 2, '', 'LIS', 'Kornelis Salomonsz.', 600, NULL, '1738', NULL, NULL, 'A', 'H', '1745-08-01', 'Texel', '1745-12-31', '1746-01-16', true, '1746-05-15', 'Batavia', 7263, '29-09-1745): at Porto Prayo 3 seafarers and 3 soldiers deserted. The ship also called at Robben Island (29 till 31-12-1745).');
INSERT INTO "voyages" VALUES (3334, '', 1, '', 'HOF D''UNO', 'Gilles Dabijn', 1150, NULL, '1743', NULL, NULL, 'Z', 'Z', '1745-08-12', 'Rammekens', '1745-12-25', '1746-01-14', true, '1746-05-18', 'Batavia', 7262, 'Tiago where one seafarer and four soldiers deserted.');
INSERT INTO "voyages" VALUES (3335, '', 1, '', 'HERCULES', 'Jan Bijland', 850, NULL, '1743', NULL, NULL, 'Z', 'Z', '1745-09-06', 'Rammekens', '1746-02-03', '1746-03-04', true, '1746-06-21', 'Batavia', 7264, NULL);
INSERT INTO "voyages" VALUES (3336, '', 4, '', 'WESTHOVEN', 'Jan de Jong', 650, NULL, '1734', NULL, NULL, 'Z', 'Z', '1745-09-11', 'Rammekens', '1746-01-19', '1746-02-11', true, '1746-05-15', 'Batavia', 7260, '14 till 22-09 the WESTHOVEN was at Portsmouth where 6 seafarers and 4 soldiers were pressed by the English. The ship also called at Dassen Island from 06 till 18-01-1746. The passenger who embarked at the Cape was a stowaway, found on the REIGERSDAAL (see 7230).');
INSERT INTO "voyages" VALUES (3337, '', 4, '', 'NIEUWERKERK', 'Jan Akkermans', 1135, NULL, '1735', NULL, NULL, 'Z', 'Z', '1745-10-09', 'Rammekens', '1746-03-20', '1746-04-10', true, '1746-07-01', 'Batavia', NULL, 'from Batavia to Banda. Francois Pennink and Reinier van der Luchten also are mentioned in sources as master of the NIEUWERKERK.');
INSERT INTO "voyages" VALUES (3338, '', 4, '', 'ARNESTIJN', 'Jan Hugo Captijn', 575, NULL, '1736', NULL, NULL, 'Z', 'R', '1745-11-11', 'Goeree', '1746-03-02', '1746-03-20', true, '1746-06-20', 'Batavia', 7265, NULL);
INSERT INTO "voyages" VALUES (3339, '', 1, '', 'PASGELD', 'Hendrik Westerbeek', 850, NULL, '1744', NULL, NULL, 'D', 'D', '1745-11-11', 'Goeree', '1746-02-28', '1746-03-25', true, '1746-06-11', 'Batavia', 7281, NULL);
INSERT INTO "voyages" VALUES (3340, '', 2, '', 'FORTUIN', 'Dirk Took', 600, NULL, '1741', NULL, NULL, 'A', 'A', '1745-11-14', 'Texel', '1746-03-14', '1746-04-20', true, '1746-07-01', 'Batavia', 7245, 'The FORTUIN carried f 150,000 in cash.');
INSERT INTO "voyages" VALUES (3341, '', 1, '', 'LEKKERLAND', 'Jan de Boer', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1745-11-14', 'Texel', '1746-02-04', '1746-02-26', true, '1746-05-15', 'Batavia', 7261, 'The LEKKERLAND carried f 250,000 in cash.');
INSERT INTO "voyages" VALUES (3342, '', 5, '', 'SCHEIJBEEK', 'Martin Grambergen', 850, NULL, '1735', NULL, NULL, 'A', 'A', '1745-11-14', 'Texel', '1746-02-19', '1746-04-03', true, '1746-06-20', 'Batavia', 7259, 'During the voyage, probably in November, 43 soldiers were taken over from the WILDRIJK (see 3343) and other ships. The SCHEIJBEEK carried f 200,000 in cash.');
INSERT INTO "voyages" VALUES (3343, '', 1, '', 'WILDRIJK', 'Kornelis de Nijs', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1745-11-14', 'Texel', '1746-02-14', '1746-04-20', true, NULL, NULL, 7292, 'November, many soldiers, presumably about 40, were taken over by the SCHEIJBEEK (see 3342). The WILDRIJK carried f 145,000 in cash.');
INSERT INTO "voyages" VALUES (3344, '', 3, '', 'SARA JACOBA', 'Jan Reynders', 1100, NULL, '1737', NULL, NULL, 'Z', 'Z', '1745-11-20', 'Rammekens', '1746-03-03', '1746-04-19', true, '1746-07-23', 'Ceylon', NULL, 'The SARA JACOBA was laid up and sold at Batavia on 02-02-1753.');
INSERT INTO "voyages" VALUES (3345, '', 1, '', 'WAAKZAAMHEID', 'Roelof Blok', 850, NULL, '1744', NULL, NULL, 'E', 'E', '1745-12-14', 'Texel', '1746-04-17', '1746-05-03', true, '1746-07-07', 'Batavia', 7332, 'The WAAKZAAAMHEID called at S. Tiago from 21 tilt 26-01-1746.');
INSERT INTO "voyages" VALUES (3346, '', 1, '', 'EINDHOEF', 'Willem Klump', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1745-12-15', 'Texel', '1746-04-01', '1746-05-07', true, '1746-08-19', 'Batavia', 7246, '15-12-1745 Was the final date of departure of the EINDHOEF; on 24-11-1745 the ship set out for the first time but four days later it returned: 20 soldiers disembarked and 30 seafarers were taken over from the HUIS TE RENSBURG (see 3353); the original crew consequently was altered into 83 seafarers and 21 soldiers.');
INSERT INTO "voyages" VALUES (3347, '', 1, '', 'ZEELANDIA', 'Boudewijn Immers', 1150, NULL, '1744', NULL, NULL, 'Z', 'Z', '1746-01-10', 'Rammekens', '1746-06-09', '1746-07-09', true, '1746-10-30', 'Batavia', 7252, 'turned out to be a woman; she continued the voyage as a passenger.');
INSERT INTO "voyages" VALUES (3348, '', 1, '', 'GETROUWIGHEID', 'Herman Zoet', 850, NULL, '1744', NULL, NULL, 'H', 'H', '1746-02-15', 'Texel', '1746-06-22', '1746-07-04', true, '1746-11-08', 'Batavia', 7254, 'Five days after its departure the ship returned to Texel (20-02-1746); it finally set out on 10-03-1746. From 05 till 09-04-1746 the GETROUWIGHEID called at S. Tiago. It did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3349, '', 9, '', 'PATMOS', 'Kornelis Arduin', 810, NULL, '1722', NULL, NULL, 'R', 'Z', '1746-03-22', 'Rammekens', '1746-08-31', '1746-10-15', true, '1747-01-09', 'Batavia', NULL, 'Smalle Baei''.');
INSERT INTO "voyages" VALUES (3350, '', 1, '', 'SPARENRIJK', 'Herman Schutte', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1746-03-23', 'Texel', '1746-07-18', '1746-08-08', true, '1746-09-26', 'Ceylon', 7284, '23-03-1746 Was the final date of departure of the SPAREN-RIJK; on 15-02-1746 the ship sailed out for the first time, but five days later it returned. The SPARENRIJK did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3351, '', 3, '', 'DISHOEK', 'Nikolaas van Eek', 665, NULL, '1735', NULL, NULL, 'Z', 'R', '1746-03-29', 'Goeree', '1746-07-12', '1746-08-28', true, '1746-11-22', 'Batavia', 7253, 'False Bay.');
INSERT INTO "voyages" VALUES (3352, '', 7, '', 'KNAPPENHOF', 'Jakob Kornelis Warmenhoven', 650, NULL, '1731', NULL, NULL, 'A', 'A', '1746-04-09', 'Texel', '1746-07-12', '1746-07-28', true, '1746-09-30', 'Batavia', NULL, '02-07-1754.');
INSERT INTO "voyages" VALUES (3353, '', 4, '', 'HUIS TE RENSBURG', 'Willem van Westrenen', 850, NULL, '1733', NULL, NULL, 'Z', 'A', '1746-04-09', 'Texel', '1746-07-18', '1746-08-11', true, '1746-11-10', 'Batavia', 7255, '09-04-1746 Was the final date of departure of the HUIS TE RENSBURG; on 24-11-1745 it set out for the first time, but on 27-01-1746 it returned. Thirty seafarers had been taken over by the EINDHOEF (see 3346); the first column indicates the final composition of the crew. The ship did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3354, '', 6, '', 'RUST EN WERK', 'Dirk Verduin', 650, NULL, '1734', NULL, NULL, 'D', 'D', '1746-04-09', 'Goeree', '1746-07-24', '1746-08-08', true, '1746-10-11', 'Batavia', 7248, 'The RUST EN W ERK did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3355, '', 2, '', 'STANDVASTIGHEID', 'Floris Smit', 850, NULL, '1743', NULL, NULL, 'R', 'A', '1746-04-09', 'Texel', '1746-08-05', '1746-08-28', true, '1746-10-10', 'Batavia', 7256, 'Pieter Schildman was master and that he died before reaching the Cape. From 08 till 15-05-1746 the STANDVASTIGHEID was at Porto Prayo (S. Tiago). The ship did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3356, '', 3, '', 'TOLSDUIN', 'Kornelis Booys', 850, NULL, '1741', NULL, NULL, 'A', 'A', '1746-04-09', 'Texel', '1746-07-16', '1746-07-27', true, '1746-10-10', 'Batavia', 7250, 'The four passengers included one slave. The TOLSDUIN called at S. Tiago (03 till 06-05-1746) and at False Bay.');
INSERT INTO "voyages" VALUES (3357, '', 1, '', 'SLOT VAN KAPELLE', 'Pieter Jellesz.', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1746-04-22', 'Texel', '1746-07-26', '1746-08-08', true, '1746-10-05', 'Batavia', 7249, 'The SLOT VAN KAPELLE did not call at the Cape but at False Bay. The ship carried f 225,000 in cash.');
INSERT INTO "voyages" VALUES (3358, '', 2, '', 'AKERENDAM', 'Hendrik Volkers', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1746-05-07', 'Texel', '1746-08-31', '1746-09-22', true, '1746-11-13', 'Batavia', 7279, 'was at Duins.');
INSERT INTO "voyages" VALUES (3359, '', 5, '', 'BATAVIER', 'Arnold de la Forcade', 525, NULL, '1735', NULL, NULL, 'A', 'A', '1746-05-07', 'Texel', '1746-10-24', '1746-11-16', true, '1747-01-30', 'Batavia', 7293, '23-05-1746 the BATAVIER was at Duins.');
INSERT INTO "voyages" VALUES (3360, '', 3, '', 'MAARSSEVEEN', 'Herman Quinje', 850, NULL, '1739', NULL, NULL, 'A', 'A', '1746-05-07', 'Texel', '1746-10-20', '1746-11-16', true, '1747-01-30', 'Batavia', NULL, 'The MAARSSEVEEN called at Duins (09 till 23-05-1746) and at S. Tiago (10-06 till 12-07-1746). where the crew was enlarged by 9 French seafarers. In 1748 the ship exploded on a voyage from Banda to Batavia.');
INSERT INTO "voyages" VALUES (3361, '', 6, '', 'WESTKAPELLE', 'Herman van Hoest', 850, NULL, '1730', NULL, NULL, 'Z', 'Z', '1746-05-26', 'Rammekens', '1746-10-26', '1746-11-22', true, '1747-03-02', 'Batavia', NULL, 'See also 3364. In 1751 the WESTKAPELLE was laid up at Bengal.');
INSERT INTO "voyages" VALUES (3362, '', 3, '', 'BOSBEEK', 'Leendert de Bruin', 650, NULL, '1741', NULL, NULL, 'A', 'D', '1746-05-29', 'Goeree', '1746-10-20', '1746-11-17', true, '1747-03-02', 'Batavia', 7267, 'From 07 till 22-07-1746 the BOSBEEK called at S. Tiago, where four soldiers `disembarked'' (they probably died); the crew was enlarged by five French seafarers.');
INSERT INTO "voyages" VALUES (3363, '', 4, '', 'OUWERKERK', 'Bernard Heymans', 540, NULL, '1738', NULL, NULL, 'Z', 'A', '1746-06-01', 'Texel', '1746-10-26', '1746-11-22', true, '1747-03-05', 'Batavia', 7335, 'See also 3364.');
INSERT INTO "voyages" VALUES (3364, '', 1, '', 'DONK', 'Govert van Welle', 875, NULL, '1745', NULL, NULL, 'R', 'R', '1746-06-24', 'Goeree', '1746-11-08', '1746-11-23', true, '1747-02-14', 'Batavia', 7333, '21-08-1746). Some of the 17 persons who disembarked at the Cape were taken over by the WESTKA-PELLE (3361) and the OUWERKERK (3363).');
INSERT INTO "voyages" VALUES (3365, '', 2, '', 'GERECHTIGHEID', 'Kornelis Trappel', 850, NULL, '1742', NULL, NULL, 'E', 'E', '1746-06-25', 'Texel', '1746-12-12', '1747-01-17', true, '1747-05-21', 'Batavia', 7286, 'From 28-06 till 06-07-1746 the ship was at Duins.');
INSERT INTO "voyages" VALUES (3366, '', 6, '', 'SUBEKARSPEL', 'Erasmus Mulder', 650, NULL, '1729', NULL, NULL, 'H', 'H', '1746-07-05', 'Texel', '1746-12-12', '1747-01-17', true, '1747-05-19', 'Batavia', NULL, 'The SIJBEKARSPEL called at S. Tiago from 27-08 till 03-09-1746 where 3 French seafarers embarked. The ship was laid up and sold at Batavia on 11-05-1753.');
INSERT INTO "voyages" VALUES (3367, '', 3, '', 'WOITKENSDORP', 'Kornelis Stevens', 800, NULL, '1739', NULL, NULL, 'Z', 'Z', '1746-07-05', 'Rammekens', '1746-12-24', '1747-02-03', true, '1747-06-02', 'Batavia', 7285, NULL);
INSERT INTO "voyages" VALUES (3368, '', 3, '', 'KRABBENDIJKE', 'Jan Tuman', 830, NULL, '1738', NULL, NULL, 'Z', 'A', '1746-07-24', 'Texel', '1746-12-12', '1747-01-18', true, '1747-08-17', 'Ceylon', 7282, 'The KRABBENDUKE called at Portsmouth from 05 till 21-08-1746.');
INSERT INTO "voyages" VALUES (3369, '', 2, '', 'OVERNES', 'Nikolaas de Beer', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1746-07-24', 'Texel', '1746-12-12', '1747-01-17', true, '1747-05-07', 'Batavia', 7291, 'The OVERNES called at Portsmouth (05-08 till 21-08-1746 (?)) and at S. Tiago (08 till 14-09-1746).');
INSERT INTO "voyages" VALUES (3370, '', 1, '', 'GUSTAAF WILLEM', 'Huibert Tiebout', 1150, NULL, '1744', NULL, NULL, 'Z', 'Z', '1746-07-31', 'Rammekens', '1747-01-09', '1747-02-03', true, '1747-04-30', 'Batavia', 7280, 'From 13 till 26-10-1746 the GUSTAAF WILLEM called at S. Tiago. After the departure from the Cape two stowaways were found.');
INSERT INTO "voyages" VALUES (3371, '', 5, '', 'BEUKESTIJN', 'Frederik Schouten', 850, NULL, '1734', NULL, NULL, 'A', 'A', '1746-10-19', 'Texel', '1747-02-17', '1747-03-23', true, '1747-06-15', 'Batavia', NULL, 'The BEUKESTIJN carried_f 150,000 in cash. The ship was laid up and sold at Batavia on 11-05-1753.');
INSERT INTO "voyages" VALUES (3372, '', 1, '', 'HAARLEM', 'Hendrik de Ruyter', 1150, NULL, '1745', NULL, NULL, 'A', 'A', '1746-10-19', 'Texel', '1746-11-18', '1747-02-12', true, '1747-04-30', 'Batavia', 7270, 'During the voyage two soldiers became seafarers. The HAAR-LEM carried _/''300,000 in cash.');
INSERT INTO "voyages" VALUES (3373, '', 5, '', 'HUIS TE RENSBURG', 'Jakob Wiebe', 850, NULL, '1733', NULL, NULL, 'A', 'A', '1746-10-19', 'Texel', '1747-01-18', '1747-02-16', true, '1747-08-17', 'Ceylon', 7283, '3373/7283 Is the fifth voyage of this ship, which during its four preceding voyages was called KERKWIJK (3223/7216). The HUTS TE RENSBURG carried f 200,000 in cash.');
INSERT INTO "voyages" VALUES (3374, '', 1, '', 'HUIS TE MANPAD', 'Willem ''t Hoen', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1746-10-19', 'Texel', '1747-02-26', '1747-03-31', true, '1747-06-15', 'Batavia', 7287, 'From 20 till 26-02-1747 the HUIS TE MANPAD called at Robben Island. The ship carried f 250,000 in cash.');
INSERT INTO "voyages" VALUES (3375, '', 1, '', 'OOSTKAPELLE', 'Jan Kakelaar', 850, NULL, '1745', NULL, NULL, 'Z', 'Z', '1746-10-20', 'Rammekens', '1747-02-13', '1747-03-10', true, '1747-05-27', 'Batavia', 7310, 'The OOSTKAPELLE called Robben Island from 03 till 13-02-1747.');
INSERT INTO "voyages" VALUES (3376, '', 6, '', 'NIEUW WALCHEREN', 'Jakob Hogermolen', 850, NULL, '1731', NULL, NULL, 'Z', 'Z', '1746-10-20', 'Rammekens', '1747-02-13', '1747-03-10', true, '1747-05-27', 'Batavia', NULL, 'From 03 till 13-02-1747 the NIEUW WALCHEREN called at Robben Island. The ship was wrecked on the roads of Surat on 24-05-1748.');
INSERT INTO "voyages" VALUES (3377, '', 2, '', 'HOOP', 'Gerrit Reyndertsz. Vos', 850, NULL, '1742', NULL, NULL, 'D', 'H', '1746-11-10', 'Texel', '1747-03-05', '1747-03-31', true, '1747-07-18', 'Batavia', 7271, 'Some of the 16 persons who disembarked at the Cape were taken over by the LEIDEN (see 3382).');
INSERT INTO "voyages" VALUES (3378, '', 1, '', 'ROOSWIJK', 'Jan van Ingen', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1746-11-10', 'Texel', '1747-02-17', '1747-03-23', true, '1747-08-28', 'Batavia', 7277, NULL);
INSERT INTO "voyages" VALUES (3379, '', 1, '', 'OVERSCHIE', 'Maarten van der Meer', 850, NULL, '1745', NULL, NULL, 'D', 'D', '1746-11-11', 'Goeree', '1747-03-08', '1747-03-31', true, '1747-06-28', 'Batavia', 7272, 'out to be a woman, she continued the voyage as a passenger.');
INSERT INTO "voyages" VALUES (3380, '', 1, '', 'LANGEWIJK', 'Meindert de Beer', 850, NULL, '1745', NULL, NULL, 'E', 'E', '1746-11-15', 'Texel', '1747-03-11', '1747-03-31', true, '1747-06-21', 'Batavia', 7309, NULL);
INSERT INTO "voyages" VALUES (3381, '', 2, '', 'DIEMEN', 'Michiel van Son', 850, NULL, '1743', NULL, NULL, 'A', 'A', '1746-11-22', 'Texel', '1747-03-08', '1747-04-15', true, '1747-07-07', 'Batavia', 7268, 'The four passengers included two female slaves. The DIEMEN carried f 130,000 in cash.');
INSERT INTO "voyages" VALUES (3382, '', 2, '', 'LEIDEN', 'Dirk Wolter van Nimwegen', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1746-11-22', 'Texel', '1747-03-08', '1747-03-31', true, '1747-06-27', 'Batavia', 7301, 'Sea''. From 30-12-1746 till 05-01-1747 the LEIDEN was at S. Tiago. The ship carried f 150,000 in cash.');
INSERT INTO "voyages" VALUES (3383, '', 2, '', 'ZUIDERBURG', 'Martin den Breems+', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1746-11-22', 'Texel', '1747-03-19', '1747-04-17', true, '1747-06-27', 'Batavia', 7289, 'Martin den Breems 
died. at the Cape he was succeeded by Pieter
Pietersz. The 5 passengers included one slave. The ZUIDER-BURG called at S. Tiago (31-12-1746 till 09-01-1747) and at Robben Island (17 till 19-03-1747). The ship carried f 150,000 in cash');
INSERT INTO "voyages" VALUES (3384, '', 2, '', 'SPANDERSWOUD', 'Jan du Riets', 850, NULL, '1744', NULL, NULL, 'A', 'Z', '1746-11-25', 'Rammekens', '1747-03-24', '1747-04-19', true, '1747-06-15', 'Batavia', 7288, NULL);
INSERT INTO "voyages" VALUES (3385, '', 1, '', 'OUD BERKENRODE', 'Jan van Thiel', 850, NULL, '1746', NULL, NULL, 'A', 'A', '1747-01-07', 'Texel', '1747-05-21', '1747-06-23', true, '1747-09-21', 'Batavia', NULL, 'The OUD BERKENRODE did not call at the Cape but at False Bay. On 04-12-1747 the ship was wrecked ''in the Bight of Anjer''; most of the cargo and crew was saved.');
INSERT INTO "voyages" VALUES (3386, '', 7, '', 'HOGERSMILDE', 'Herman Laurier', 850, NULL, '1723', NULL, NULL, 'H', 'A', '1747-01-07', 'Texel', '1747-06-18', '1747-07-21', true, '1747-11-02', 'Ceylon', 3386, '/- Is the seventh voyage of this ship, which during its first four voyages was called WAPEN VAN HOORN. The ship was wrecked on a return voyage from Surat to Batavia on 08-06-1751.');
INSERT INTO "voyages" VALUES (3387, '', 2, '', 'VOORZICHTIGHEID', 'Willem de Wijs', 850, NULL, '1743', NULL, NULL, 'D', 'R', '1747-01-07', 'Goeree', '1747-05-10', '1747-06-01', true, '1747-08-03', 'Batavia', 7273, NULL);
INSERT INTO "voyages" VALUES (3388, '', 4, '', 'WELTEVREDEN', 'Jochem Outjes', 850, NULL, '1740', NULL, NULL, 'A', 'A', '1747-01-07', 'Texel', '1747-06-21', '1747-07-21', true, '1747-10-12', 'Batavia', 7276, 'The WELTEVREDEN did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3389, '', 5, '', 'VLISSINGEN', 'Adriaan Kakelaar', 650, NULL, '1732', NULL, NULL, 'Z', 'Z', '1747-01-09', 'Rammekens', NULL, NULL, true, NULL, NULL, NULL, 'The VLISSINGEN was lost between patria and the Cape.');
INSERT INTO "voyages" VALUES (3390, '', 3, '', 'DOMBURG', 'Leendert Bonekamp', 850, NULL, '1740', NULL, NULL, 'Z', 'A', '1747-03-03', 'Texel', '1747-06-10', '1747-07-04', true, '1747-09-17', 'Batavia', 7274, 'The DOMBURG did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3391, '', 2, '', 'DUINHOF', 'Hendrik Taal', 850, NULL, '1743', NULL, NULL, 'A', 'A', '1747-03-03', 'Texel', '1747-06-17', '1747-07-04', true, '1747-10-14', 'Batavia', 7269, 'the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3392, '', 1, '', 'HAGEDIS', 'Gerrit de Leeuw', 600, NULL, '1746', NULL, NULL, 'A', 'A', '1747-03-03', 'Texel', '1747-06-17', '1747-07-04', true, '1747-09-13', 'Batavia', NULL, 'did not call at the Cape but at False Bay and Simon''s Bay (17-06 till 04-07-1747). The ship was sold at Batavia on 19-03-1748.');
INSERT INTO "voyages" VALUES (3393, '', 1, '', 'BAARZANDE', 'Martin Haringman', 850, NULL, '1745', NULL, NULL, 'Z', 'Z', '1747-03-22', 'Rammekens', '1747-07-18', '1747-08-08', true, '1747-10-30', 'Batavia', 7278, 'but at False Bay.');
INSERT INTO "voyages" VALUES (3394, '', 4, '', 'HUIS TER DUINE', 'Pieter van Onkhuizen', 550, NULL, '1739', NULL, NULL, 'Z', 'D', '1747-03-23', 'Goeree', '1747-07-09', '1747-07-29', true, '1747-11-09', 'Batavia', 7290, 'The HUIS TER DUINE did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3395, '', 1, '', 'JAGER', 'Pieter Tijm', 850, NULL, '1745', NULL, NULL, 'H', 'H', '1747-04-02', 'Texel', '1747-09-19', '1747-10-11', true, '1748-05-17', 'Batavia', 7343, '25-01-1748), and at Lombok (28/9-01-1748).');
INSERT INTO "voyages" VALUES (3396, '', 1, '', 'KASTEEL VAN TILBURG', 'Abraham Zwart', 850, NULL, '1746', NULL, NULL, 'A', 'A', '1747-05-02', 'Texel', '1747-08-22', '1747-09-12', true, '1747-12-02', 'Batavia', 7295, NULL);
INSERT INTO "voyages" VALUES (3397, '', 2, '', 'HUIS TE PERSUN', 'Dirk Bolk', 850, NULL, '1743', NULL, NULL, 'R', 'E', '1747-05-14', 'Texel', '1747-09-23', '1747-11-07', true, '1748-03-06', 'Batavia', NULL, 'In 1748 the HUIS TE PERSIJN was wrecked on a return voyage from Japan.');
INSERT INTO "voyages" VALUES (3398, '', 1, '', 'SCHAKENBOS', 'Jan Joel', 850, NULL, '1746', NULL, NULL, 'R', 'R', '1747-05-19', 'Goeree', '1747-10-16', '1747-11-05', true, '1748-03-07', 'Batavia', 7324, 'From 28-06 till 03-07-1747 the SCHAKENBOS was at S. Tiago.');
INSERT INTO "voyages" VALUES (3399, '', 3, '', 'REIGERSDAAL', 'Johannes Band', 850, NULL, '1738', NULL, NULL, 'A', 'A', '1747-05-31', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'On 25-10-1747 the REIGERSDAAL was wrecked off the Cape. Wreck discovered.');
INSERT INTO "voyages" VALUES (3400, '', 2, '', 'KLEVERSKERKE', 'Simon de Groot', 850, NULL, '1742', NULL, NULL, 'Z', 'A', '1747-06-17', 'Texel', '1747-11-20', '1747-12-11', true, '1748-03-06', 'Batavia', 7308, 'The KLEVERSKERKE called at S. Tiago, where one seafarer disembarked, another one and one soldier deserted.');
INSERT INTO "voyages" VALUES (3401, '', 2, '', 'BROUWER', 'Jan Tuinman', 850, NULL, '1743', NULL, NULL, 'H', 'H', '1747-06-26', 'Texel', '1747-12-15', '1748-02-07', true, '1748-05-15', 'Batavia', 7307, 'From 17-11 till 07-12-1747 the BROUWER called at Saldanha Bay.');
INSERT INTO "voyages" VALUES (3402, '', 3, '', 'ZAAMSLAG', 'Kornelis Zwanenburg', 900, NULL, '1741', NULL, NULL, 'Z', 'Z', '1747-07-25', 'Rammekens', '1747-12-15', '1748-01-25', true, '1748-06-01', 'Batavia', 7306, 'From 05 till 13-09-1747 the ZAAMSLAG was at `Goeree near Cape Verde''.');
INSERT INTO "voyages" VALUES (3403, '', 1, '', 'NAARSTIGHEID', 'Dirk van der Schilde', 850, NULL, '1746', NULL, NULL, 'D', 'D', '1747-07-28', 'Goeree', '1747-11-14', '1747-12-02', true, '1748-02-29', 'Batavia', 7305, NULL);
INSERT INTO "voyages" VALUES (3404, '', 1, '', 'IMMAGONDA', 'Lambert Toussaint', 850, NULL, '1746', NULL, NULL, 'E', 'E', '1747-08-18', 'Texel', '1748-01-10', '1748-02-07', true, '1748-06-04', 'Batavia', 7304, 'From 27-09 till 01-10-1747 the IMMAGONDA called at S. Tiago where 2 seafarers and 2 soldiers deserted.');
INSERT INTO "voyages" VALUES (3405, '', 5, '', 'SCHELLAG', 'Adriaan Laurens', 850, NULL, '1736', NULL, NULL, 'Z', 'Z', '1747-08-20', 'Rammekens', '1747-12-18', '1748-01-16', true, '1748-05-18', 'Batavia', NULL, 'The SCHELLAG called at S. Tiago from 22-09 till 01-10-1747 where one sailmaker was taken over by the IMMAGONDA (see 3404), another seafarer and 16 soldiers deserted. In 1748, during a return voyage from Japan, the ship was captured by the French.');
INSERT INTO "voyages" VALUES (3406, '', 1, '', 'AMISTELVEEN', 'Molen', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1747-10-27', 'Texel', '1748-05-09', '1748-05-30', true, '1748-09-18', 'Batavia', 7302, 'From 25-12-1747 till 05-01-1748 the AMSTELVEEN called at S. Tiago. The ship carried f 150,000 in cash.');
INSERT INTO "voyages" VALUES (3407, '', 2, '', 'SLOT VAN KAPELLE', 'Jakob Buis', 1150, NULL, '1745', NULL, NULL, 'A', 'A', '1747-10-27', 'Texel', '1748-05-06', '1748-05-30', true, '1748-10-15', 'Batavia', 7311, 'deserted. The ship carried f 150,000 in cash.');
INSERT INTO "voyages" VALUES (3408, '', 2, '', 'EINDHOEF', 'Jan Otto', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1747-10-27', 'Texel', '1748-04-12', '1748-05-19', true, '1748-09-08', 'Batavia', NULL, 'carried f 100,000 in cash. The EINDHOEF was laid up and sold at Batavia on 31-12-1755.');
INSERT INTO "voyages" VALUES (3409, '', 3, '', 'FORTUIN', 'Jochem Beek', 600, NULL, '1741', NULL, NULL, 'A', 'A', '1747-10-27', 'Texel', '1748-04-06', '1748-05-02', true, '1748-07-07', 'Batavia', 7303, 'and one seafarer embarked. The ship carried f 100.000 in cash.');
INSERT INTO "voyages" VALUES (3410, '', 1, '', 'OSDORP', 'Willem Vrucht', 850, NULL, '1746', NULL, NULL, 'A', 'A', '1747-10-27', 'Texel', '1748-04-27', '1748-05-30', true, '1748-10-12', 'Batavia', 7300, 'OSDORP called at S. Tiago from 23-12-1747 till 03-01-1748 where 5 seafarers and 13 soldiers died or deserted. The ship carried f 100,000 in cash.');
INSERT INTO "voyages" VALUES (3411, '', 1, '', 'VOSMAAR', 'Willem van der Heyden', 850, NULL, '1746', NULL, NULL, 'Z', 'Z', '1748-10-29', 'Rammekens', '1748-04-25', '1748-05-19', true, '1748-10-15', 'Batavia', 7299, 'From 23 till 28-12-1747 the VOSMAAR called at S. Tiago where one seafarer died and two soldiers embarked.');
INSERT INTO "voyages" VALUES (3412, '', 1, '', 'BEVALLIGHEID', 'Arie van der Meer', 850, NULL, '1746', NULL, NULL, 'R', 'R', '1748-01-05', 'Goeree', '1748-04-12', '1748-05-19', true, '1748-09-08', 'Batavia', 7297, 'The BEVALLIGHEID called at Portsmouth (08 till 15-01-1748) where 11 seafarers and 4 soldiers deserted or were pressed by the English.');
INSERT INTO "voyages" VALUES (3413, '', 1, '', 'SLOTEN', 'Arneus Lodewijk Berting', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1748-01-05', 'Texel', '1748-04-07', '1748-05-19', true, '1748-09-17', 'Batavia', 7329, 'The SLOTEN carried f 150,000 in cash.');
INSERT INTO "voyages" VALUES (3414, '', 1, '', 'SLOTERDIJK', 'David van Elteren', 1150, NULL, '1747', NULL, NULL, 'A', 'A', '1748-01-05', 'Texel', '1748-04-12', '1748-05-19', true, '1748-10-12', 'Batavia', 7298, 'The SLOTERDIJK carried f 150,000 in cash.');
INSERT INTO "voyages" VALUES (3415, '', 4, '', 'TOLSDUIN', 'Bastiaan Verdoes', 850, NULL, '1741', NULL, NULL, 'A', 'A', '1748-01-05', 'Texel', '1748-03-31', '1748-05-19', true, '1748-09-05', 'Batavia', 7296, '130,000 in cash.');
INSERT INTO "voyages" VALUES (3416, '', 3, '', 'EENDRACHT', 'Abraham Haring', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1748-05-06', 'Texel', '1748-09-06', '1748-10-08', true, '1749-01-22', 'Ceylon', 7330, NULL);
INSERT INTO "voyages" VALUES (3417, '', 2, '', 'HUIGENWAARD', 'Huibert van der Linde', 850, NULL, '1742', NULL, NULL, 'H', 'A', '1748-05-06', 'Texel', '1748-09-06', '1748-09-28', true, '1748-12-26', 'Batavia', 7334, NULL);
INSERT INTO "voyages" VALUES (3418, '', 2, '', 'LEKKERLAND', 'Willem van Westrenen', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1748-05-06', 'Texel', '1748-09-06', '1748-10-02', true, '1748-12-26', 'Batavia', 7312, 'On the way four seafarers and nine soldiers deserted.');
INSERT INTO "voyages" VALUES (3419, '', 1, '', 'BREDENHOF', 'Frederik Jansz. van Winsum', 850, NULL, '1746', NULL, NULL, 'H', 'H', '1748-05-26', 'Texel', '1748-09-30', '1748-10-20', true, '1749-02-24', 'Batavia', 7313, 'to Texel on 10-05. The two passengers were stowaways found after the departure from the Cape; one of them was the wife of a sergeant.');
INSERT INTO "voyages" VALUES (3420, '', 3, '', 'LIS', 'Willem Hoogland', 600, NULL, '1738', NULL, NULL, 'A', 'A', '1748-05-26', 'Texel', '1748-11-22', '1748-12-28', true, '1749-04-14', 'Batavia', NULL, 'out on 06-05-1748; four days later it returned to Texel after having run aground ''at the Haaks''. The ship was laid up and sold at Batavia on 01-05-1752.');
INSERT INTO "voyages" VALUES (3421, '', 2, '', 'ZEELANDIA', 'Otto van Dam', 1150, NULL, '1744', NULL, NULL, 'Z', 'Z', '1748-05-27', 'Rammekens', '1748-10-15', '1748-11-30', true, '1749-03-26', 'Ceylon', NULL, 'One source mentions Thomas Hardy as master. The ZEELANDIA was wrecked in the Indies.');
INSERT INTO "voyages" VALUES (3422, '', 4, '', 'DISHOEK', 'Leendert van Dijk', 665, NULL, '1735', NULL, NULL, 'Z', 'E', '1748-06-10', 'Texel', '1748-11-20', '1749-01-01', true, '1749-05-30', 'Batavia', NULL, 'The DISHOEK was laid up in the Indies on 31-12-1756.');
INSERT INTO "voyages" VALUES (3423, '', 2, '', 'HERCULES', 'Thijl Jansz. Thijling', 850, NULL, '1743', NULL, NULL, 'Z', 'A', '1748-06-10', 'Texel', '1748-01-16', '1749-01-10', true, '1749-05-01', 'Ceylon', 7327, 'As the BREDENHOF and the LIS (see 3419 and 3420) the HERCULES initially set out on 06-05-1748; four days later the ship returned to Texel after having run aground ''at the Haaks''.');
INSERT INTO "voyages" VALUES (3424, '', 6, '', 'DUINENBURG', 'Jan Frederik Woesthof', 850, NULL, '1733', NULL, NULL, 'A', 'A', '1748-07-04', 'Texel', '1748-11-20', '1748-12-16', true, '1749-04-06', 'Batavia', 3424, '/- Is the sixth voyage of this ship, which during its first four voyages was called KERKWIJK (3223/7216) and during its fifth voyage HUIS TE RENSBURG (3373/7283). The ship was sold at Batavia on 29-01-1754.');
INSERT INTO "voyages" VALUES (3425, '', 1, '', 'WITSBURG', 'Willem van Mensburg', 850, NULL, '1746', NULL, NULL, 'E', 'E', '1748-07-29', 'Texel', '1748-12-23', '1749-02-01', true, '1749-05-18', 'Batavia', 7361, NULL);
INSERT INTO "voyages" VALUES (3426, '', 3, '', 'STANDVASTIGHEID', 'Pieter Lichthart', 850, NULL, '1742', NULL, NULL, 'R', 'R', '1748-08-10', 'Goeree', '1748-11-20', '1748-12-13', true, '1749-03-28', 'Batavia', 7314, NULL);
INSERT INTO "voyages" VALUES (3427, '', 1, '', 'GELDERMALSEN', 'Willem Marreeuw', 1150, NULL, '1746', NULL, NULL, 'Z', 'Z', '1748-08-16', 'Rammekens', '1748-12-18', '1749-01-10', true, '1749-03-31', 'Batavia', 7371, 'The GELDERMALSEN called at S. Tiago from 15 till 30-09-1748.');
INSERT INTO "voyages" VALUES (3428, '', 5, '', 'WESTHOVEN', 'Dirk Verduin', 650, NULL, '1734', NULL, NULL, 'Z', 'D', '1748-08-18', 'Goeree', '1748-12-23', '1749-02-01', true, '1749-06-09', 'Batavia', NULL, 'From 08 till 18-12-1748 the WESTHOVEN was at Robben Island. The ship was sold at Malacca.');
INSERT INTO "voyages" VALUES (3429, '', 2, '', 'GETROUWIGHEID', 'Huibert Vijs', 850, NULL, '1744', NULL, NULL, 'H', 'Z', '1748-09-20', 'Rammekens', '1749-03-05', '1749-04-07', true, '1749-06-27', 'Batavia', 7363, NULL);
INSERT INTO "voyages" VALUES (3430, '', 1, '', 'PRINSES VAN ORANJE', 'Pieter Tornboom', 250, NULL, NULL, '1747', NULL, 'E', 'A', '1748-10-17', 'Texel', '1749-02-18', '1749-03-07', true, '1749-06-17', 'Batavia', 7315, 'The PRINSES VAN ORANJE was bought in England where it had been built by Wells and Stanton, a shipyard on the Thames; the ship arrived at Texel in January 1748.');
INSERT INTO "voyages" VALUES (3431, '', 1, '', 'OUDKARSPEL', 'Ficco Eybo van Rheede', 1150, NULL, '1747', NULL, NULL, 'A', 'A', '1748-11-04', 'Texel', '1749-03-01', '1749-03-20', true, '1749-05-24', 'Batavia', 7392, 'The OUDKARSPEL called at Duins from 10 till 15-11-1748.');
INSERT INTO "voyages" VALUES (3432, '', 3, '', 'HUIS TE RENSBURG', 'Jacob van Wieler', 650, NULL, '1740', NULL, NULL, 'Z', 'A', '1748-11-04', 'Texel', '1749-03-11', NULL, true, '1749-06-13', NULL, 7336, 'was called DUINENBURG (3331/7258). 04-11-1748 Was the final date of departure of the HUIS TE RENS-BURG; the ship initially sailed out on 06-05-1748, but it returned four days later after having run aground `at the Haaks'' (at that moment its name still was DUINENBURG). On 15-11-1748 the ship was at Duins.');
INSERT INTO "voyages" VALUES (3433, '', 1, '', 'SCHUILENBURG', 'Jan Tobias Toon', 300, NULL, '1747', NULL, NULL, 'A', 'A', '1748-11-04', 'Texel', '1749-03-18', NULL, true, '1749-03-18', 'The Cape', NULL, '15-11-1748. For seven years the ship was on service at the Cape: in 1756 it was wrecked on a voyage from the Cape to False Bay.');
INSERT INTO "voyages" VALUES (3434, '', 4, '', 'POLANEN', 'Adriaan Waag +', 650, NULL, '1737', NULL, NULL, 'A', 'A', '1748-11-21', 'Texel', '1749-06-29', '1749-07-26', true, '1749-09-25', 'Batavia', 7325, 'Initially the POLANEN departed on 15-11, but four days later it returned to Texel. The ship called at Duins twice: 11-12-1748 till 09-01-1749 and 22-01 till 22-02-1749. Adriaan Waag did not survive the voyage, Hilde Hendriksz. Hoek succeeded him as master. The ship did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3435, '', 2, '', 'OVERSCHIE', 'Leendert de Bruin', 850, NULL, '1745', NULL, NULL, 'D', 'D', '1749-01-07', 'Goeree', '1749-08-18', '1749-09-07', true, '1749-11-22', 'Batavia', 7352, 'of its course by a heavy storm, the ship stranded near Portsmouth; before it got afloat 137 seafarers, 83 soldiers and 12 craftsmen deserted. From 17-02, the day the ship got afloat, till 10-05-1749 the OVER-SCHIE remained at Portsmouth; the diminished crew was enlarged by 113 seafarers, 74 soldiers, 3 craftsmen and 12 passengers, all sent from Delft. During the voyage at least 5 soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3436, '', 2, '', 'PASGELD', 'Hendrik van Oudheusden', 850, NULL, '1745', NULL, NULL, 'D', 'R', '1749-01-07', 'Goeree', '1749-07-16', '1749-08-04', true, '1749-09-29', 'Batavia', 7319, 'stranded near Portsmouth; after getting afloat it sailed to Spithead. The PASGELD remained there till 09-02 and, after a vain attempt to depart, from 12-02 till 10-04-1749. The ship did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3437, '', 1, '', 'AMSTERDAM', 'Willem Klump', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1749-01-08', 'Texel', NULL, NULL, true, NULL, NULL, NULL, '15-11-1748 (return to Texel: 19-11) and 21-11 (return: 06-12). On 26-01-1749 the ship ran ashore between Hastings and Beachy Head. The value of silver in coins and bars was f 300,104; most of it was recovered within a few days after the loss.');
INSERT INTO "voyages" VALUES (3438, '', 1, '', 'ELSWOUD', 'Dirk Took', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1749-01-08', 'Texel', '1649-06-02', '1749-07-03', true, '1749-09-12', 'Batavia', 7317, 'The ELSWOUD called at Duins. 24-01 till 22-02-1749. It did not call at the Cape but at False Bay, 02-06 till 03-07-1749 During the voyage 2 soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3439, '', 2, '', 'HAARLEM', 'Herman Schutte', 1150, NULL, '1745', NULL, NULL, 'A', 'A', '1749-01-08', 'Texel', '1749-06-02', '1749-07-03', true, '1749-09-19', 'Ceylon', 7373, 'From 20-01 till 22-02-1749 the HAARLEM called at Duins.');
INSERT INTO "voyages" VALUES (3440, '', 1, '', 'HARTEKAMP', 'Jan Diederik Morel', 650, NULL, '1748', NULL, NULL, 'A', 'A', '1749-01-08', 'Texel', '1749-06-15', '1749-07-03', true, '1749-09-20', 'Batavia', 7318, 'The HARTEKAMP did not call at the Cape but at False Bay; the 8 seafarers who disembarked there included one drummer, 2 seafarers went over to the HUIS TE MANPAD (see 3441).');
INSERT INTO "voyages" VALUES (3441, '', 2, '', 'HUIS TE MANPAD', 'Hendrik de Ruyter', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1749-01-08', 'Texel', '1749-06-02', '1749-07-03', true, '1749-09-05', 'Batavia', 7366, 'From 23-01 till 22-02 the HUIS TE MANPAD was at Duins. It did not call at the Cape but at False Bay; the 2 seafarers who embarked there came from the HARTEKAMP (see 3440).');
INSERT INTO "voyages" VALUES (3442, '', 2, '', 'SPARENDIJK', 'Jan Willemsz. van den Briel', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1749-01-08', 'Texel', '1749-06-16', '1749-07-08', true, '1749-09-09', 'Batavia', 7316, 'The SPARENRIJK called at Spithead twice: 20-01 till 09-02 and 12 till 22-02-1749. The ship did not call at the Cape but at False Bay, 16-06 till 08-07-1749.');
INSERT INTO "voyages" VALUES (3443, '', 2, '', 'HOF D''UNO', 'Gerrit Reyndertsz. Vos', 1150, NULL, '1743', NULL, NULL, 'Z', 'H', '1749-01-08', 'Texel', '1749-07-12', '1749-08-25', true, '1749-11-14', 'Batavia', 7331, 'From 23-01 till 22-02-1749 the HOF D''UNO was at Duins. The ship did not call at the Cape but at False Bay, 12-07 till 25-08-1749.');
INSERT INTO "voyages" VALUES (3444, '', 3, '', 'DIEMEN', 'Jakob Wiebe', 850, NULL, '1743', NULL, NULL, 'A', 'A', '1749-02-07', 'Texel', '1749-06-08', '1749-07-03', true, '1749-09-12', 'Batavia', 7326, 'From 13 till 22-02 the DIEMEN was at Duins. The ship did not call at the Cape but at False Bay from 08-06 till 03-07-1749.');
INSERT INTO "voyages" VALUES (3445, '', 3, '', 'SPANDERSWOUD', 'Jean de la Voie', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1749-02-07', 'Texel', '1749-06-02', '1749-07-03', true, '1749-09-09', 'Batavia', 7328, 'The SPANDERSWOUD called at Duins, 13 till 22-02-1749. It did not call at the Cape but at False Bay from 02-06 till 03-07-1749.');
INSERT INTO "voyages" VALUES (3446, '', 5, '', 'ARNESTUN', 'Jochem Aldertsz. Tarnike', 575, NULL, '1736', NULL, NULL, 'Z', 'E', '1749-02-23', 'Texel', '1749-07-13', '1749-07-26', true, '1749-10-01', 'Batavia', 7321, '26-07-1749. During the voyage one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3447, '', 4, '', 'BOSBEEK', 'Jan Sluiskens', 650, NULL, '1741', NULL, NULL, 'A', 'Z', '1749-03-02', 'Rammekens', '1749-07-26', '1749-09-18', true, '1749-11-23', 'Batavia', NULL, 'the BOSBEEK was at S. Tiago. It did not call at the Cape but at Saldanha Bay, 26-07 till 18-09-1749. The ship was laid up and sold at Batavia, 05-01-1754.');
INSERT INTO "voyages" VALUES (3448, '', 6, '', 'SCHEIJBEEK', 'Pieter Perduin', 850, NULL, '1735', NULL, NULL, 'A', 'Z', '1749-03-02', 'Rammekens', '1749-07-15', '1749-08-04', true, '1749-10-05', 'Batavia', NULL, 'The SCHEIJBEEK made two earlier attempts to depart: 21-11-1748 and 10-01-1749 (return to Rammekens: 31-01). From 18-04 till 01-05-1749 the ship was at S. Tiago: 9 soldiers deserted. The SCHEIJBEEK was laid up in India, 09-08-1755.');
INSERT INTO "voyages" VALUES (3449, '', 1, '', 'VREDE', 'Gillis Dabijn', 850, NULL, '1746', NULL, NULL, 'Z', 'Z', '1749-03-02', 'Rammekens', '1749-07-14', '1749-08-04', true, '1749-10-05', 'Batavia', 7365, 'The VREDE made one earlier attempt to depart: 10-01; three weeks later it returned to Rammekens (31-01-1749). From 18-04 till 01-05-1749 the ship called at S. Tiago.');
INSERT INTO "voyages" VALUES (3450, '', 2, '', 'GUSTAAF WILLEM', 'Kornelis Jurriaansz.', 1150, NULL, '1744', NULL, NULL, 'Z', 'Z', '1749-03-11', 'Rammekens', '1749-06-25', '1749-07-26', true, '1749-09-24', 'Batavia', 7320, 'The GUSTAAF WILLEM called at S. Tiago. 23-04 till 01-05-1749. The two passengers were slaves.');
INSERT INTO "voyages" VALUES (3451, '', 2, '', 'WILDRIJK', 'Jan Pakmor', 850, NULL, '1744', NULL, NULL, 'A', 'D', '1749-03-25', 'Goeree', '1749-08-20', '1749-09-19', true, '1749-11-22', 'Batavia', 7393, 'From 07 till 15-05-1749 the WILDRIJK called at S. Tiago. The ship did not call at the Cape but at False Bay from 20-08 till 19-09-1749.');
INSERT INTO "voyages" VALUES (3452, '', 3, '', 'VOORZICHTIGHEID', 'Kornelis Quack', 850, NULL, '1743', NULL, NULL, 'D', 'R', '1749-04-21', 'Goeree', '1749-08-18', '1749-09-02', true, '1749-11-22', 'Batavia', 7372, 'The VOORZICHTIGHEID called at Portsmouth from 24-04 till 07-05-1749.');
INSERT INTO "voyages" VALUES (3453, '', 2, '', 'BAARZANDE', 'Maarten Haringman', 850, NULL, '1745', NULL, NULL, 'Z', 'Z', '1749-02-01', 'Rammekens', '1749-09-18', '1749-09-21', true, '1749-12-11', 'Batavia', 7323, 'Duins (24-04 till 07-05-1749) and at S. Tiago (02 till 07-06-1749).');
INSERT INTO "voyages" VALUES (3454, '', 1, '', 'PRINSES CAROLINA', 'Josias Ruts', 300, NULL, '1748', NULL, NULL, 'Z', 'Z', '1749-05-07', 'Rammekens', '1749-08-30', '1749-09-18', true, '1749-12-11', 'Batavia', 7383, 'From 03 till 07-06-1749 the PRINSES CAROLINA called at S. Tiago.');
INSERT INTO "voyages" VALUES (3455, '', 3, '', 'HOOP', 'Gerrit Munt', 850, NULL, '1742', NULL, NULL, 'D', 'H', '1749-05-07', 'Texel', '1749-10-08', '1749-10-31', true, '1750-01-22', 'Batavia', 7337, 'called at S. Tiago from 05 till 11-06-1749.');
INSERT INTO "voyages" VALUES (3456, '', 4, '', 'KRABBENDIJKE', 'Otto Freudenfeld', 830, NULL, '1738', NULL, NULL, 'Z', 'A', '1749-06-19', 'Texel', '1749-11-10', '1749-12-03', true, '1750-03-07', 'Batavia', 7351, 'KRABBENDIJKE called at S. Tiago. The ship replaced the DIEMERMEER, wrecked in 1747 (see 7257).');
INSERT INTO "voyages" VALUES (3457, '', 1, '', 'WAPEN VAN HOORN', 'Jakob Greef', 850, NULL, '1747', NULL, NULL, 'H', 'H', '1749-06-20', 'Texel', '1749-11-28', '1749-12-15', true, '1750-03-22', 'Batavia', 7350, 'On its way to the Cape the WAPEN VAN HOORN called at Duins (24-06 till 08-07-1749) and at S. Tiago (17 till 24-08-1749).');
INSERT INTO "voyages" VALUES (3458, '', 1, '', 'DEUNISVELD', 'Marten van der Meer', 850, NULL, '1747', NULL, NULL, 'D', 'D', '1749-07-09', 'Goeree', '1749-12-02', '1749-12-15', true, '1750-04-28', 'Batavia', 7411, 'The DEUNISVELD called at S. Tiago from 25-08 till 09-09-1749.');
INSERT INTO "voyages" VALUES (3459, '', 5, '', 'HUIS TER DUINE', 'Arnoldus de Ruyter', 550, NULL, '1739', NULL, NULL, 'Z', 'E', '1749-07-09', 'Texel', '1749-11-01', '1749-11-25', true, '1750-01-24', 'Batavia', 7347, 'From 11 till 17-07-1749 the HUIS TER DUINE was at S. Tiago.');
INSERT INTO "voyages" VALUES (3460, '', 4, '', 'WOITKENSDORP', 'Pieter de Waayer de la Rue', 800, NULL, '1739', NULL, NULL, 'Z', 'Z', '1749-07-09', 'Rammekens', '1749-12-02', '1750-01-25', true, '1750-05-11', 'Batavia', 7357, '11-09-1749.');
INSERT INTO "voyages" VALUES (3461, '', 3, '', 'AKERENDAM', 'Klaas Andersen', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1749-07-12', 'Texel', '1749-11-29', '1749-12-15', true, '1750-03-13', 'Batavia', 7342, 'probably became soldiers.');
INSERT INTO "voyages" VALUES (3462, '', 5, '', 'HUIS TE RENSBURG', 'Kornelis Leempoel', 850, NULL, '1733', NULL, NULL, 'Z', 'A', '1749-07-12', 'Texel', '1749-12-11', '1750-01-02', true, '1750-04-26', 'Batavia', NULL, 'The HUIS TE RENSBURG called at Duins (15 till 20-07-1749) and at Portsmouth (02 till 25-08-1749). The ship was sold in the Indies, 29-06-1753.');
INSERT INTO "voyages" VALUES (3463, '', 3, '', 'OVERNES', 'Michiel van Son', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1749-07-12', 'Texel', '1749-12-01', '1749-12-17', true, '1750-03-14', 'Batavia', 7348, 'OVERNES called at Duins (15 till 20-07-1749) and at S. Tiago (01-09 till 13-09-1749).');
INSERT INTO "voyages" VALUES (3464, '', 3, '', 'ZUIDERBURG', 'Gerrit Kadoele', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1749-07-12', 'Texel', '1749-12-02', '1749-12-17', true, '1750-04-25', 'Batavia', 7368, 'The ZUIDERBURG called at Duins (15 till 20-07-1749) and at S. Tiago (01 till 13-09-1749). During the voyage one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3465, '', 3, '', 'ANNA', 'Jakob Regnault', 600, NULL, '1741', NULL, NULL, 'A', 'Z', '1749-08-31', 'Rammekens', '1750-01-12', '1750-01-17', true, '1750-04-23', 'Batavia', NULL, 'From 10 till 17-10-1749 the ANNA was at Porto Prayo on S. Tiago. The ship was sold at Batavia, 30-12-1758.');
INSERT INTO "voyages" VALUES (3466, '', 1, '', 'NIEUWVIJVERVREUGD', 'Jan du Riets', 1150, NULL, '1748', NULL, NULL, 'Z', 'Z', '1749-08-31', 'Rammekens', '1750-01-11', '1750-02-13', true, '1750-05-25', 'Batavia', 7349, 'The NIEUWVIJVERVREUGD called at S. Tiago from 10 till 18-10-1749.');
INSERT INTO "voyages" VALUES (3467, '', 6, '', 'BATAVIER', 'Pieter Pietersz.', 525, NULL, '1735', NULL, NULL, 'A', 'A', '1749-09-08', 'Texel', '1750-01-13', '1750-02-16', true, '1750-05-07', 'Batavia', 7362, 'voyage two soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3468, '', 2, '', 'KASTEEL VAN TILBURG', 'Kornelis de Nijs', 850, NULL, '1746', NULL, NULL, 'A', 'A', '1749-09-08', 'Texel', '1750-01-13', '1750-02-07', true, '1750-05-05', 'Batavia', 7366, 'probably became soldier.');
INSERT INTO "voyages" VALUES (3469, '', 1, '', 'BLOEMENDAAL', 'Hendrik Taal', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1749-09-30', 'Texel', '1750-01-13', '1750-02-07', true, '1750-05-02', 'Batavia', 7374, '08-11-1749. During the voyage one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3470, '', 1, '', 'LIEFDE', 'Jochem Outjes', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1749-09-30', 'Texel', '1750-01-04', '1750-01-21', true, '1750-04-03', 'Batavia', 7341, 'From 02 till 08-11-1749 the LIEFDE was at S. Tiago.');
INSERT INTO "voyages" VALUES (3471, '', 7, '', 'RUST EN WERK', 'Paulus Verschur', 650, NULL, '1734', NULL, NULL, 'D', 'D', '1749-09-30', 'Goeree', '1750-01-11', '1750-01-25', true, '1750-05-05', 'Batavia', NULL, 'Strait Buton, retaken and laid up there. Taken by a ''Maccassaersen vrijman'' called Frans Fransz.');
INSERT INTO "voyages" VALUES (3472, '', 2, '', 'SLOTERDIJK', 'Herman Zoet', 1150, NULL, '1747', NULL, NULL, 'A', 'A', '1749-09-30', 'Texel', '1750-01-14', '1750-02-07', true, '1750-05-04', 'Batavia', 7345, 'During the voyage one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3473, '', 1, '', 'SPREEUW', 'Jan de Wit', 150, NULL, '1749', NULL, NULL, 'A', 'A', '1749-10-03', 'Texel', '1750-01-13', '1750-01-28', true, '1750-05-02', 'Batavia', NULL, 'From 01 till 08-11-1749 the SPREEUW called at S. Tiago. The ship was destined to remain on service between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (3474, '', 5, '', 'TOLSDUIN', 'Gerrit de Leeuw', 850, NULL, '1741', NULL, NULL, 'A', 'A', '1749-10-07', 'Texel', '1750-01-04', '1750-01-21', true, '1750-04-22', 'Batavia', NULL, 'The TOLSDUIN was laid up at the Cape, 15-06-1752.');
INSERT INTO "voyages" VALUES (3475, '', 3, '', 'GERECHTIGHEID', 'Martin Lop', 850, NULL, '1742', NULL, NULL, 'E', 'Z', '1749-10-09', 'Rammekens', '1750-02-08', '1750-03-06', true, '1750-07-09', 'Ceylon', 7356, 'The GERECHTIGHEID called at Duins from 15 till 21-10-1749.');
INSERT INTO "voyages" VALUES (3476, '', 1, '', 'ROTTERDAM', 'Jan Martens', 850, NULL, '1748', NULL, NULL, 'R', 'R', '1749-10-13', 'Goeree', '1750-02-05', '1750-02-18', true, '1750-05-12', 'Batavia', 7377, 'The ROTTERDAM called at Duins from 14 till 21-10-1749. and at S. Tiago from 13 till 16-11-1749.');
INSERT INTO "voyages" VALUES (3477, '', 2, '', 'BEVALLIGHEID', 'Maarten de Vos', 850, NULL, '1746', NULL, NULL, 'R', 'D', '1749-11-23', 'Goeree', '1750-03-31', '1750-04-16', true, '1750-06-20', 'Batavia', 7338, 'Some of the 20 persons who disembarked at the Cape went over to the STRALEN (see 3484). During the voyage 3 soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3478, '', 2, '', 'VOSMAAR', 'Willem van der Heyden', 850, NULL, '1746', NULL, NULL, 'Z', 'Z', '1749-11-23', 'Rammekens', '1750-04-01', '1750-04-16', true, '1750-06-25', 'Batavia', 7339, NULL);
INSERT INTO "voyages" VALUES (3479, '', 2, '', 'AMSTELVEEN', 'Herman Laurier', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1749-12-31', 'Texel', '1750-04-16', '1750-05-02', true, '1750-07-03', 'Ceylon', 7370, NULL);
INSERT INTO "voyages" VALUES (3480, '', 4, '', 'FORTUIN', 'Marten Wout', 600, NULL, '1741', NULL, NULL, 'A', 'A', '1749-12-31', 'Texel', '1750-05-06', '1750-06-09', true, '1750-08-18', 'Batavia', NULL, 'The FORTUIN called at S. Tiago from 01 till 08-02-1750. The ship was laid up and sold at Batavia, 31-12-1755.');
INSERT INTO "voyages" VALUES (3481, '', 2, '', 'IMMAGONDA', 'Hendrik Visser', 850, NULL, '1746', NULL, NULL, 'E', 'A', '1749-12-31', 'Texel', '1750-04-22', '1750-05-02', true, '1750-07-18', 'Batavia', 7340, 'The IMMAGONDA called at S. Tiago from 01 till 07-02-1750.');
INSERT INTO "voyages" VALUES (3482, '', 1, '', 'KIEVITSHEUVEL', 'Jochem Beek', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1749-12-31', 'Texel', '1750-04-01', '1750-04-16', true, '1750-06-21', 'Batavia', 7344, 'The 6 passengers included one female slave. The KIEVIETS-HEUVEL called at S. Tiago from 01 till 07-02-1750.');
INSERT INTO "voyages" VALUES (3483, '', 1, '', 'ADMIRAAL DE RUYTER', 'Bastiaan Verdoes', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1749-12-31', 'Texel', '1750-04-22', '1750-05-02', true, '1750-07-06', 'Batavia', 7355, NULL);
INSERT INTO "voyages" VALUES (3484, '', 1, '', 'STRALEN', 'Kornelis Trappel', 850, NULL, '1748', NULL, NULL, 'E', 'E', '1749-12-31', 'Texel', '1750-04-01', '1750-04-16', true, '1750-07-06', 'Batavia', 7359, 'During the voyage one soldier probably became seafarer. See also 3477.');
INSERT INTO "voyages" VALUES (3485, '', 1, '', 'HAZE', 'Kornelis de Jonge', 150, NULL, '1749', NULL, NULL, 'A', 'Z', '1750-01-02', 'Rammekens', NULL, NULL, false, '1750-10-29', 'Batavia', NULL, 'Storm and thunder drove the HAZE beyond the Cape; it called at Delagoa from 11-07 till 08-08-1750. The ship was laid up in the Indies on 31-12-1756.');
INSERT INTO "voyages" VALUES (3486, '', 2, '', 'NAARSTIGHEID', 'Kornelis Vis', 850, NULL, '1746', NULL, NULL, 'D', 'Z', '1750-03-26', 'Rammekens', '1750-09-17', '1750-10-12', true, '1750-12-24', 'Batavia', 7387, 'The NAARSTIGHEID called at Duins (twice: from 10 till 21-04 and 26 till 28-04-1750) and at Portsmouth (03 till 17-05-1750).');
INSERT INTO "voyages" VALUES (3487, '', 1, '', 'GOUVERNEUR-GENERAAL', 'Dirk van der Schilde', 850, NULL, '1749', NULL, NULL, 'D', 'D', '1750-04-18', 'Goeree', '1750-08-07', '1750-08-24', true, '1750-11-28', 'Batavia', 7354, 'Prayo on S. Tiago (19 till 23-05-1750). It did not call at the Cape but at False Bay from 07 till 24-08-1750.');
INSERT INTO "voyages" VALUES (3488, '', 2, '', 'OOSTKAPELLE', 'Gijsbert Bonekamp', 850, NULL, '1745', NULL, NULL, 'Z', 'R', '1750-04-18', 'Goeree', '1750-08-10', '1750-08-25', true, '1750-12-20', 'Batavia', 7358, 'The OOSTKAPELLE called at S. Tiago from 16 till 21-05-1750. During the voyage one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3489, '', 3, '', 'BROUWER', 'Adriaan de Graaf', 850, NULL, '1743', NULL, NULL, 'H', 'H', '1750-04-19', 'Texel', NULL, NULL, false, '1750-10-10', 'Batavia', 7353, 'From 19 till 27-05-1750 the BROUWER was at S. Tiago.');
INSERT INTO "voyages" VALUES (3490, '', 3, '', 'KLEVERSKERKE', 'Willem ''t Hoen', 850, NULL, '1742', NULL, NULL, 'Z', 'A', '1750-04-21', 'Texel', '1750-07-31', '1750-08-24', true, '1750-11-08', 'Batavia', NULL, 'disembarked at Batavia. As appears from a resolution of gouverneur-generaal en raden the KLEVERSKERKE was wrecked during a voyage to Macassar in 1761.');
INSERT INTO "voyages" VALUES (3491, '', 2, '', 'LANGEWIJK', 'Wouter Abraham Brake', 850, NULL, '1745', NULL, NULL, 'E', 'A', '1750-04-21', 'Texel', '1750-08-03', '1750-09-04', true, '1750-12-23', 'Batavia', 7395, 'The LANGEWIJK called at Duins (26 till 29-04) and at S. Tiago (25 till 28-05-1750). It did not call at the Cape but at False Bay The 52 soldiers who disembarked at Batavia included 7 gunners');
INSERT INTO "voyages" VALUES (3492, '', 3, '', 'LEIDEN', 'Frederik Schouten', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1750-04-21', 'Texel', '1750-08-03', '1750-08-24', true, '1750-10-31', 'Batavia', 738, '28-04-1750) and at S. Tiago (22 till 27-05-1750). It did no call at the Cape but at False Bay. During the voyage one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3493, '', 1, '', 'MEERVLIET', 'Pieter Frederik van Heyne', 850, 'fluit', '1749', NULL, NULL, 'A', 'A', '1750-04-21', 'Texel', '1750-08-05', '1750-09-12', true, '1751-01-08', 'Batavia', 737, 'called at Duins from 26 till 29-04-1750.');
INSERT INTO "voyages" VALUES (3494, '', 1, '', 'ADMIRAAL TROMP', 'Jakob Klaasz.', 250, NULL, '1749', NULL, NULL, 'R', 'R', '1750-04-21', 'Goeree', '1750-07-31', '1750-08-09', true, '1750-10-19', 'Batavia', NULL, 'From 18 till 20-05-1750 the ADMIRAAL TROMP was at S. Tia go. It did not call at the Cape but at False Bay, 31-07 till 09-08 1750. The ship was sold in the Indies on 25-08-1763.');
INSERT INTO "voyages" VALUES (3495, '', 4, '', 'ZAAMSLAG', 'Ilogermoien +', 900, NULL, '1741', NULL, NULL, 'Z', 'Z', '1750-04-21', 'Rammekens', '1751-01-05', '1751-02-03', true, '1751-05-24', 'Batavia', 7375, 'The 92 soldiers who embarked at the Rammekens included 10 gunners; they disembarked at Batavia. The ZAAMSLAG called at S. Tiago (from 22 till 27-05-1750) and, after a vain attempt to round Cape Augustin, at S. Angra on Terceira (from 26-08 till 24-09-1750). Jakob Hogermolen died before reaching the Cape: Leendert Fruit van Hertog succeeded him as master. The ship also called at Bantam, where 64 soldiers disembarked.');
INSERT INTO "voyages" VALUES (3496, '', 2, '', 'OSDORP', 'Joost Meeuwsz.', 850, NULL, '1746', NULL, NULL, 'A', 'E', '1750-05-09', 'Texel', '1750-12-09', '1751-01-12', true, '1751-05-18', 'Batavia', 7419, 'After having lost its rudder on the Flemish Banks, 10-05. the OS-DORP called at Duins (from 13-05 till 21-07-1750). This delay was due to a mutiny. 19 Mutineers were taken over by a man-of-war. The OSDORP also called at Bantam, where 52 soldiers disembarked.');
INSERT INTO "voyages" VALUES (3497, '', 1, '', 'VRIJBURG', 'Huibert Tiebout', 1150, NULL, '1748', NULL, NULL, 'Z', 'Z', '1750-05-18', 'Rammekens', '1750-09-19', '1750-10-26', true, '1751-01-03', 'Batavia', 7422, 'The 119 soldiers who embarked at Rammekens included 11 gunners; they all disembarked at Batavia.');
INSERT INTO "voyages" VALUES (3498, '', 1, '', 'OOSTHUIZEN', 'Jan Tuinman', 850, NULL, '1749', NULL, NULL, 'H', 'H', '1750-05-22', 'Texel', '1751-11-18', '1751-12-11', true, '1752-03-03', 'Batavia', 7400, 'till 04-12-1750): 21 seafarers, 3 soldiers and 2 craftsmen disembarked or deserted. The ship also called at Surinam (from 21-02 till 10-05-1751): 28 seafarers and 13 soldiers deserted, one chief mate and 4 soldiers embarked. From 18-07 till 13-08-1751 the OOSTHUIZEN was at S. Tiago: 2 seafarers and 3 soldiers went ashore, 4 seafarers were taken over from the LUCHTENBURG (see 3525) and the TULPENBURG (see 3526). Some of the 4 seafarers who disembarked at the Cape went to the LUCHTENBURG.');
INSERT INTO "voyages" VALUES (3499, '', 4, '', 'STANDVASTIGHEID', 'Jakob Buis', 850, NULL, '1742', NULL, NULL, 'R', 'D', '1750-09-02', 'Goeree', '1750-12-29', '1751-01-24', true, '1751-05-18', 'Batavia', 7401, 'The 6 passengers who embarked at the Cape were bandits. The STANDVASTIGHEID called at Bantam, where 62 soldiers went ashore.');
INSERT INTO "voyages" VALUES (3500, '', 3, '', 'LEKKERLAND', 'Jan Kakelaar', 1150, NULL, '1744', NULL, NULL, 'A', 'Z', '1750-09-10', 'Rammekens', '1751-01-08', '1751-02-03', true, '1751-05-18', 'Batavia', 7426, 'From 24-10 till 4-11-1750 the LEKKERLAND called at S. Tiago. At Bantam 71 soldiers disembarked.');
INSERT INTO "voyages" VALUES (3501, '', 2, '', 'HARTEKAMP', 'Pieter Tijm', 650, NULL, '1748', NULL, NULL, 'A', 'H', '1750-09-21', 'Texel', '1751-02-08', '1751-02-22', true, '1751-06-20', 'Batavia', 7429, 'The HARTEKAMP called at Duins (25-09 till 04-10), and at S. Tiago (11 till 18-11-1750).');
INSERT INTO "voyages" VALUES (3502, '', 2, '', 'BREDENHOF', 'Simon Rood', 850, NULL, '1746', NULL, NULL, 'H', 'E', '1750-10-06', 'Texel', '1751-01-31', '1751-02-16', true, '1751-06-26', 'Batavia', 7363, 'In two sources Frederik 
Jansz. is mentioned as master of the
BREDENHOF. At the Cape one soldier became a seafarer.');
INSERT INTO "voyages" VALUES (3503, '', 2, '', 'ELSWOUD', 'Jan Willemsz, van den Briel', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1750-10-06', 'Texel', '1751-01-29', '1751-02-16', true, '1751-05-18', 'Batavia', 7398, 'Bantam.');
INSERT INTO "voyages" VALUES (3504, '', 2, '', 'SLOTEN', 'Jan Diederik Morel', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1750-10-06', 'Texel', '1751-01-21', '1751-02-09', true, '1751-05-18', 'Batavia', 7386, 'SLOTEN called at Bantam, where 93 soldiers went ashore.');
INSERT INTO "voyages" VALUES (3505, '', 3, '', 'SPARENRIJK', 'Jan Tobias Toon', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1750-10-06', 'Texel', '1751-01-28', '1751-02-09', true, '1751-05-25', 'Batavia', 7417, 'From 11 till 17-11-1750 the SPARENRIJK called at S. Tiago.');
INSERT INTO "voyages" VALUES (3506, '', 3, '', 'SLOT VAN KAPELLE', 'Jakob van Wieler', 1150, NULL, '1745', NULL, NULL, 'A', 'A', '1750-10-18', 'Texel', '1751-01-23', '1751-02-09', true, '1751-06-04', 'Batavia', 7428, NULL);
INSERT INTO "voyages" VALUES (3507, '', 1, '', 'MIDDELBURG', 'Kornelis van Zwanenburg', 1150, NULL, '1749', NULL, NULL, 'Z', 'Z', '1750-10-18', 'Rammekens', '1751-02-10', '1751-03-23', true, '1751-07-10', 'Batavia', 7414, 'The MIDDELBURG called at S. Tiago from 28-11 till 08-12-1750.');
INSERT INTO "voyages" VALUES (3508, '', 1, '', 'ROZENBURG', 'Molen', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1750-10-18', 'Texel', '1751-01-23', '1751-02-09', true, '1751-07-10', 'Batavia', 7420, NULL);
INSERT INTO "voyages" VALUES (3509, '', 1, '', 'GIESSENBURG', 'David van Elteren', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1750-11-18', 'Texel', '1751-03-21', '1751-04-13', true, '1751-07-10', 'Batavia', 7394, 'The 6 passengers included 3 female slaves. The GIESSEN-BURG called at Duins (20 till 28-11-1750) and at S. Tiago (25-12-1750 till 02-01-1751).');
INSERT INTO "voyages" VALUES (3510, '', 3, '', 'GUSTAAF WILLEM', 'Abraham Zwart', 1150, NULL, '1744', NULL, NULL, 'Z', 'A', '1750-11-18', 'Texel', '1751-04-01', '1751-04-21', true, '1751-07-26', 'Batavia', 7424, 'The GUSTAAF WILLEM called at Duins (20 till 28-11-1750) and at S. Tiago (25-12-1750 till 02-01-1751). At Bantam 122 seafarers and 85 soldiers disembarked. During the voyage one soldier probably became a seafarer.');
INSERT INTO "voyages" VALUES (3511, '', 3, '', 'PASGELD', 'Klaas van den Hoed', 850, NULL, '1745', NULL, NULL, 'D', 'D', '1750-11-18', 'Goeree', '1751-01-28', '1751-02-09', true, '1751-05-18', 'Batavia', 7382, '75 soldiers went ashore.');
INSERT INTO "voyages" VALUES (3512, '', 1, '', 'NOORD NIEUWLAND', 'Hendrik van Oudheusden', 880, NULL, '1749', NULL, NULL, 'R', 'R', '1750-11-19', 'Goeree', '1751-01-29', '1751-02-15', true, '1751-05-26', 'Batavia', 7381, 'seafarer.');
INSERT INTO "voyages" VALUES (3513, '', 4, '', 'DIEMEN', 'Simon de Groot', 850, NULL, '1743', NULL, NULL, 'A', 'A', '1750-12-04', 'Texel', '1751-04-27', '1751-05-08', true, '1751-09-12', 'Bengal', 7368, 'transported to Bengal.');
INSERT INTO "voyages" VALUES (3514, '', 1, '', 'RUYSKESTEIN', 'Willem Klump', 850, NULL, '1749', NULL, NULL, 'A', 'A', '1750-12-04', 'Texel', '1751-04-30', '1751-05-13', true, '1751-08-12', 'Batavia', 7444, 'From 10 till 26-12-1750 the RUYSKESTEIN called at Duins.');
INSERT INTO "voyages" VALUES (3515, '', 1, '', 'LUXEMBURG', 'Jakob Wiebe', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1750-12-26', 'Texel', '1751-04-27', '1751-05-08', true, '1751-07-08', 'Ceylon', 7390, 'The LUXEMBURG carried 20 cases tilled with silver, destined for Bengal (see also 3513).');
INSERT INTO "voyages" VALUES (3516, '', 1, '', 'LYCOCHTON', 'Jochem Albertsz. Tarnike', 880, NULL, '1749', NULL, NULL, 'E', 'E', '1750-12-26', 'Texel', '1751-04-27', '1751-05-13', true, '1751-07-20', 'Batavia', 7408, 'The LYCOCHTON called at Duins (06 till 14-02-1751) and at Bantam, where 58 soldiers disembarked.');
INSERT INTO "voyages" VALUES (3517, '', 5, '', 'NIEUWSTAD', 'Jan Dekker', 650, NULL, '1733', NULL, NULL, 'H', 'H', '1750-12-26', 'Texel', '1751-05-02', '1751-05-14', true, '1751-07-26', 'Batavia', NULL, 'During the voyage two soldiers probably became seafarers. The NIEUWSTAD was sold in the Indies on 28-06-1754.');
INSERT INTO "voyages" VALUES (3518, '', 4, '', 'SPANDERSWOUD', 'Pieter Tornboom', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1750-12-26', 'Texel', '1751-04-19', '1751-05-05', true, '1751-07-12', 'Ceylon', NULL, 'The SPANDERSWOUD carried 20 cases filled with silver, destined for Bengal (see also 3513).');
INSERT INTO "voyages" VALUES (3519, '', 6, '', 'ARNESTUN', 'Adriaan van den Boer', 650, NULL, '1736', NULL, NULL, 'Z', 'Z', '1751-01-03', 'Rammekens', '1751-04-25', '1751-05-08', true, '1751-07-14', 'Ceylon', NULL, 'In 1757 the ARNESTIJN was laid up and sold at Batavia.');
INSERT INTO "voyages" VALUES (3520, '', 3, '', 'HOF D''UNO', 'Samuel Wanjon', 1150, NULL, '1743', NULL, NULL, 'H', 'Z', '1751-02-01', 'Rammekens', '1751-05-24', '1751-06-18', true, '1751-10-08', 'Batavia', 7409, 'From 09 till 17-03-1751 the HOF D''UNO was at S. Tiago. The ship did not call at the Cape but at False Bay');
INSERT INTO "voyages" VALUES (3521, '', 2, '', 'SCHAKENBOS', 'Dirk Klein', 850, NULL, '1746', NULL, NULL, 'R', 'R', '1751-04-12', 'Goeree', '1751-07-31', '1751-08-14', true, '1751-10-18', 'Batavia', NULL, 'The SCHAKENBOS did not call at the Cape, but at False Bay. During the voyage one soldier probably became a seafarer. On 17-02-1752 the SCHAKENBOS was wrecked in Manipa Strait.');
INSERT INTO "voyages" VALUES (3522, '', 3, '', 'BAARZANDE', 'Gerrit Bot', 850, NULL, '1745', NULL, NULL, 'Z', 'A', '1751-04-28', 'Texel', '1751-08-16', '1751-09-06', true, '1751-11-11', 'Batavia', 7379, 'The BAARZANDE called at S. Tiago from 05 till 08-07-1751.');
INSERT INTO "voyages" VALUES (3523, '', 4, '', 'EENDRACHT', 'Willem Kramer', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1751-04-28', 'Texel', '1751-07-29', '1751-08-14', true, '1751-10-14', 'Batavia', 7397, 'From 21 till 26-07-1751 the EENDRACHT called at S. Tiago.');
INSERT INTO "voyages" VALUES (3524, '', 1, '', 'ERFPRINS', 'Pieter Schoneman', 850, NULL, '1750', NULL, NULL, 'D', 'D', '1751-05-01', 'Goeree', '1751-08-19', '1751-09-06', true, '1751-11-15', 'Batavia', 7403, 'During the voyage 2 soldiers and 1 craftsmen possibly became seafarers.');
INSERT INTO "voyages" VALUES (3525, '', 1, '', 'LUCHTENBURG', 'Gerrit Reyndertsz. Vos', 880, NULL, '1750', NULL, NULL, 'H', 'H', '1751-05-11', 'Texel', '1751-11-12', '1751-12-17', true, '1752-07-02', 'Batavia', 7412, 'The LUCHTENBURG called at S. Tiago from 20-07 till 12-08-1751.');
INSERT INTO "voyages" VALUES (3526, '', 1, '', 'TULPENBURG', 'Jean de la Voie', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1751-06-09', 'Texel', '1751-10-29', '1751-11-20', true, '1752-01-26', 'Batavia', 7438, 'From 02 till 13-08-1751 the TULPENBURG called at S. Tiago.');
INSERT INTO "voyages" VALUES (3527, '', 3, '', 'HERCULES', 'Hendrik Booms', 850, NULL, '1743', NULL, NULL, 'Z', 'Z', '1751-07-04', 'Rammekens', '1751-12-14', '1752-01-09', true, '1752-05-01', 'Batavia', 7384, 'The HERCULES called at S. Tiago from 30-08 till 09-09-1751');
INSERT INTO "voyages" VALUES (3528, '', 1, '', 'NIEUW NIEUWERKERK', 'Jan de Wever', 1150, NULL, '1749', NULL, NULL, 'Z', 'Z', '1751-07-04', 'Rammekens', '1751-12-16', '1752-01-26', true, '1752-05-01', 'Batavia', 7391, 'From 30-08 till 09-09-1751 the ship called at S. Tiago.');
INSERT INTO "voyages" VALUES (3529, '', 2, '', 'WAAKZAAMHEID', 'Christoffel Alwel', 850, NULL, '1744', NULL, NULL, 'E', 'E', '1751-08-27', 'Texel', '1752-01-09', '1752-01-26', true, '1752-04-15', 'Batavia', 7395, 'The WAAKZAAMHEID called at S. Tiago from 07 till 14-10-1751.');
INSERT INTO "voyages" VALUES (3530, '', 1, '', 'AMSTELLAND', 'Hilde Hendriksz. Hoek', 850, NULL, '1750', NULL, NULL, 'A', 'A', '1751-09-07', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'AMSTELLAND ran ashore at the island Sylt.');
INSERT INTO "voyages" VALUES (3531, '', 3, '', 'VOSMAAR', 'Klaas Droogsteen', 850, NULL, '1746', NULL, NULL, 'Z', 'R', '1751-09-27', 'Goeree', '1752-02-08', '1752-02-20', true, '1752-06-07', 'Batavia', 7402, 'Before reaching Batavia the VOSMAAR called at Bantam. where 66 soldiers disembarked.');
INSERT INTO "voyages" VALUES (3532, '', 3, '', 'HUIGENWAARD', 'Kornelis Eike', 850, NULL, '1742', NULL, NULL, 'H', 'A', '1751-10-05', 'Texel', '1752-02-08', '1752-03-01', true, '1752-06-16', 'Batavia', 7385, 'On 07-09 the HUIGENWAARD set out for the first time, but three days later it returned to Texel. The ship called at S. Tiago from 29-11 till 04-12-1751.');
INSERT INTO "voyages" VALUES (3533, '', 2, '', 'KIEVIETSHEUVEL', 'Beek', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1751-10-05', 'Texel', '1752-02-11', '1752-03-04', true, '1752-08-12', 'Ceylon', 7405, NULL);
INSERT INTO "voyages" VALUES (3534, '', 2, '', 'LIEFDE', 'Jochem Outjes', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1751-10-05', 'Texel', '1752-01-23', '1752-02-12', true, '1752-05-22', 'Batavia', 7476, 'seafarer.');
INSERT INTO "voyages" VALUES (3535, '', 4, '', 'HUIS TE RENSBURG', 'Jan Hover', 650, NULL, '1740', NULL, NULL, 'Z', 'A', '1751-10-05', 'Texel', '1752-02-11', '1752-03-04', true, '1752-07-01', 'Batavia', NULL, 'Texel. It called at Duins (19-10 till 21-10) and at S. Tiago (27 till 30-11-1751). At Bantam 54 soldiers disembarked. During the voyage one soldier probably became a seafarer. 3535/- Is the fourth voyage of this ship. which during its first two voyages was called DUINENBURG (see 3331/7258); it was laid up and sold at Batavia on 11-05-1753.');
INSERT INTO "voyages" VALUES (3536, '', 3, '', 'BEVALLIGHEID', 'Gabriel Keizer', 850, NULL, '1746', NULL, NULL, 'R', 'D', '1751-10-21', 'Goeree', '1752-01-22', '1752-02-16', true, '1752-05-25', 'Batavia', 7396, NULL);
INSERT INTO "voyages" VALUES (3537, '', 1, '', 'BOSSCHENHOVE', 'Dirk Took', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1751-10-23', 'Texel', '1752-01-25', '1752-02-24', true, '1752-06-06', 'Batavia', 7427, 'soldiers disembarked.');
INSERT INTO "voyages" VALUES (3538, '', 2, '', 'JAGER', 'Jakob Leertouwer', 850, NULL, '1745', NULL, NULL, 'H', 'H', '1751-10-23', 'Texel', '1752-01-22', '1752-02-12', true, '1752-05-05', 'Batavia', 7388, 'were handed over to the law.');
INSERT INTO "voyages" VALUES (3539, '', 1, '', 'SNOEK', 'Kornelis Jurriaansz.', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1751-10-23', 'Rammekens', '1752-01-26', '1752-03-14', true, '1752-05-29', 'Batavia', 7446, 'The 5 passengers who embarked at Rammekens included 2 slaves. During the voyage one soldier probably became a seafarer.');
INSERT INTO "voyages" VALUES (3540, '', 1, '', 'SPAARZAAMHEID', 'Willem Vrucht', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1751-10-23', 'Texel', '1752-01-24', '1752-02-18', true, '1752-06-07', 'Batavia', 7462, 'The SPAARZAAMHEID called at Bantam, where 75 soldiers went ashore.');
INSERT INTO "voyages" VALUES (3541, '', 1, '', 'VOORLAND', 'Herman Zoet', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1751-10-23', 'Texel', '1752-01-22', '1752-02-16', true, '1752-05-22', 'Batavia', 7407, 'During the voyage 17 soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3542, '', 2, '', 'NIEUWVIJVERVREUGD', 'Martin Haringman', 1150, NULL, '1748', NULL, NULL, 'Z', 'Z', '1751-10-23', 'Rammekens', '1752-02-03', '1752-04-03', true, '1752-07-13', 'Batavia', 7389, NULL);
INSERT INTO "voyages" VALUES (3543, '', 4, '', 'AKERENDAM', 'Klaas Andersen', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1751-11-07', 'Texel', '1752-03-29', '1752-04-22', true, '1752-07-25', 'Batavia', 7416, 'The AKERENDAM called at S. Tiago from 31-12-1751 till 06-01-1752.');
INSERT INTO "voyages" VALUES (3544, '', 4, '', 'BROUWER', 'Jurriaan Bartels', 850, NULL, '1743', NULL, NULL, 'H', 'E', '1751-12-19', 'Texel', '1752-04-11', '1752-04-29', true, '1752-07-22', 'Batavia', 7418, 'they are registered in the third column as passengers (they disembarked at the Cape).');
INSERT INTO "voyages" VALUES (3545, '', 3, '', 'IMMAGONDA', 'Hendrik Visser', 850, NULL, '1746', NULL, NULL, 'E', 'A', '1751-12-19', 'Texel', '1752-04-01', '1752-04-29', true, NULL, 'Bengal', 7425, NULL);
INSERT INTO "voyages" VALUES (3546, '', 3, '', 'SLOTERDIJK', 'Gillis Dabijn', 1150, NULL, '1747', NULL, NULL, 'A', 'Z', '1751-12-19', 'Rammekens', '1752-04-15', '1752-05-21', true, '1752-07-26', 'Batavia', 7437, NULL);
INSERT INTO "voyages" VALUES (3547, '', 6, '', 'HUIS TER DUINE', 'Jan Statema', 650, NULL, '1739', NULL, NULL, 'Z', 'A', '1752-01-12', 'Texel', '1752-05-05', '1752-06-04', true, '1752-08-06', 'Batavia', NULL, 'On 30-12-1751 the HUIS TER DUINE set out for the first time, but three days later it returned to Texel. In 1757 the ship was laid up in the Indies.');
INSERT INTO "voyages" VALUES (3548, '', 4, '', 'HOOP', 'Godfried Wargijn', 850, NULL, '1742', NULL, NULL, 'D', 'A', '1752-01-12', 'Texel', '1752-04-24', '1752-05-22', true, '1752-07-17', 'Batavia', 7432, 'the law.');
INSERT INTO "voyages" VALUES (3549, '', 5, '', 'KRABBENDIJKE', 'Christiaan Hansen', 830, NULL, '1738', NULL, NULL, 'Z', 'A', '1752-01-12', 'Texel', '1752-04-25', '1752-05-17', true, '1752-08-14', 'Ceylon', 7406, NULL);
INSERT INTO "voyages" VALUES (3550, '', 2, '', 'ADMIRAAL DE RUYTER', 'Christiaan Boelhouwer', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1752-01-12', 'Texel', '1752-04-25', '1752-05-17', true, '1752-07-23', 'Batavia', 7445, 'On 30-12-1751 the ADMIRAAL DE RUYTER set out for the first time, but three days later the ship returned to Texel. From 17 till 22-02-1752 the ship called at S. Tiago.');
INSERT INTO "voyages" VALUES (3551, '', 2, '', 'HUIS TEN DONK', 'Huibert Vijs', 875, NULL, '1745', NULL, NULL, 'R', 'Z', '1752-01-29', 'Rammekens', '1752-05-07', '1752-05-21', true, '1752-07-26', 'Batavia', 7410, 'The HUIS TEN DONK called at S. Tiago from 25-02 till 01-03-1752.');
INSERT INTO "voyages" VALUES (3552, '', 3, '', 'HERSTELDER', 'Jan van Tuil', 1150, NULL, NULL, '1741', NULL, 'A', 'A', '1752-01-31', 'Texel', '1752-04-27', '1752-05-17', true, '1752-08-12', 'Ceylon', 7404, NULL);
INSERT INTO "voyages" VALUES (3553, '', 4, '', 'OVERNES', 'Michiel van Son', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1752-01-31', 'Texel', '1752-06-10', '1752-07-03', true, '1752-09-08', 'Batavia', 7415, 'till 07-03-1752). It did not call at the Cape but at False Bay. During the voyage a number of soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3554, '', 4, '', 'GERECHTIGHEID', 'Martin Lop', 850, NULL, '1742', NULL, NULL, 'E', 'Z', '1752-02-15', 'Rammekens', '1752-05-30', '1752-06-20', true, '1752-08-21', 'Batavia', 7423, 'The GERECHTIGHEID did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3555, '', 3, '', 'OOSTKAPELLE', 'Boudewijn Immers', 850, NULL, '1745', NULL, NULL, 'Z', 'Z', '1752-04-08', 'Rammekens', '1752-07-20', '1752-08-06', true, '1752-10-28', 'Batavia', 7413, NULL);
INSERT INTO "voyages" VALUES (3556, '', 3, '', 'OVERSCHIE', 'Maarten de Vos', 850, NULL, '1745', NULL, NULL, 'D', 'D', '1752-04-09', 'Goeree', '1752-07-21', '1752-08-15', true, '1752-11-01', 'Batavia', 7443, 'The OVERSCHIE did not call at the Cape but at False Bay from 21-07 till 15-08-1752.');
INSERT INTO "voyages" VALUES (3557, '', 3, '', 'HECTOR', 'Kornelis de Leeuw', NULL, 'hoeker', '1738', NULL, NULL, 'Z', 'A', '1752-05-15', 'Texel', '1752-10-11', NULL, true, '1752-10-11', 'The Cape', NULL, 'See also the SCHOLTENBURG (3743) and the NAARSTIGHEID (7502). Laid up at the Cape in 1762.');
INSERT INTO "voyages" VALUES (3558, '', 2, '', 'STRALEN', 'Adriaan de Graaf', 850, NULL, '1748', NULL, NULL, 'E', 'H', '1752-05-17', 'Texel', '1752-09-16', '1752-10-04', true, '1752-12-10', 'Batavia', 7431, 'The STRALEN called at S. Tiago from 28-06 till 06-07-1752.');
INSERT INTO "voyages" VALUES (3559, '', 1, '', 'VREDESTEIN', 'Pieter Lichthart', 880, NULL, '1750', NULL, NULL, 'R', 'R', '1752-05-22', 'Goeree', '1752-09-17', '1752-10-04', true, '1752-12-13', 'Batavia', 7421, 'From 02 till 06-07-1752 the VREDESTEIN called at S. Tiago. The ''passenger'' who embarked at the Cape was a bandit.');
INSERT INTO "voyages" VALUES (3560, '', 5, '', 'WOITKENSDORP', 'Martin van den Hoed', 800, NULL, '1739', NULL, NULL, 'Z', 'A', '1752-05-22', 'Texel', '1752-10-11', '1752-11-05', true, '1753-01-30', 'Batavia', NULL, 'WOITKENSDORP called at S. Tiago from 06 till 13-07-1752. The ship was sold in the Indies on 31-12-1758.');
INSERT INTO "voyages" VALUES (3561, '', 1, '', 'ORANJEZAAL', 'Willem van Mensburg', 880, NULL, '1750', NULL, NULL, 'E', 'E', '1752-06-05', 'Texel', '1752-10-15', '1752-11-05', true, '1753-01-23', 'Batavia', 7448, NULL);
INSERT INTO "voyages" VALUES (3562, '', 2, '', 'GOUVERNEUR-GENERAAL', 'Kornelis Leempoel', 850, NULL, '1749', NULL, NULL, 'D', 'A', '1752-06-10', 'Goeree', '1752-10-18', '1752-11-09', true, '1753-01-17', 'Batavia', 7473, 'GOUVERNEUR-GENERAAL called at S. Tiago.');
INSERT INTO "voyages" VALUES (3563, '', 1, '', 'TORENVLIET', 'Jakob la Mote', 1150, NULL, '1750', NULL, NULL, 'Z', 'Z', '1752-06-24', 'Rammekens', '1752-11-14', '1752-12-06', true, '1753-03-31', 'Batavia', 7459, 'The TORENVLIET called at S. Tiago (10 till 16-08-1752), where 11 seafarers, 8 soldiers and 2 craftsmen deserted. During the voyage one soldier probably became a seafarer.');
INSERT INTO "voyages" VALUES (3564, '', 2, '', 'WITSBURG', 'Arie van der Pot', 850, NULL, '1746', NULL, NULL, 'E', 'R', '1752-07-24', 'Goeree', '1752-12-05', '1753-01-01', true, '1753-04-07', 'Batavia', 7430, 'From 26 till 31-08-1752 the WITSBURG called at S. Tiago, where 2 seafarers deserted.');
INSERT INTO "voyages" VALUES (3565, '', 7, '', 'BATAVIER', 'Jakob Regnault', 525, NULL, '1735', NULL, NULL, 'A', 'Z', '1752-08-04', 'Rammekens', '1752-12-10', '1753-01-01', true, '1753-03-11', 'Batavia', 7478, 'Tiago from 21 till 26-09-1752. where 5 seafarers and 8 soldiers deserted.');
INSERT INTO "voyages" VALUES (3566, '', 1, '', 'HAGEVELD', 'Pieter Jongedijk', 600, NULL, '1752', NULL, NULL, 'A', 'A', '1752-10-03', 'Texel', '1753-03-21', '1753-05-08', true, '1753-09-20', 'Batavia', NULL, 'The cargo of the HAGEVELD consisted among other things of f 179.972 in cash. From 09 till 21-10-1752 the ship called at Portsmouth. The HAGEVELD was laid up in the Indies on 31-12-1756.');
INSERT INTO "voyages" VALUES (3567, '', 1, '', 'DE DRIE HEUVELEN', 'Gotlieb Silo', 850, 'fluit', '1752', NULL, NULL, 'A', 'A', '1752-10-03', 'Texel', '1753-03-07', '1754-02-04', true, '1754-05-20', 'Batavia', NULL, 'In 1758 the DRIE HEUVELEN, sailing from Banda, was wrecked on a reef.');
INSERT INTO "voyages" VALUES (3568, '', 5, '', 'OUWERKERK', 'Marinus de Jong', 540, NULL, '1738', NULL, NULL, 'Z', 'Z', '1752-10-03', 'Rammekens', '1753-03-06', '1753-04-01', true, '1753-07-08', 'Batavia', NULL, 'The OUWERKERK called at Plymouth from 09 till 21-10-1752, where 4 seafarers and 1 soldier deserted. In 1758 the ship was wrecked in the Indies.');
INSERT INTO "voyages" VALUES (3569, '', 1, '', 'DE DRIE PAPEGAAIEN', 'Bastiaan Verdoes', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1752-10-03', 'Texel', '1753-03-06', '1753-03-25', true, '1753-06-14', 'Batavia', 7496, 'The DRIE PAPEGAAIEN called at Portsmouth (08 till 20-10-1752) and at S. Tiago (16 till 27-11-1752), where one soldier deserted, and one craftsmen died.');
INSERT INTO "voyages" VALUES (3570, '', 1, '', 'VLIETLUST', 'Otto Freudenfeld', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1752-10-03', 'Texel', '1753-02-22', '1753-03-15', true, '1753-06-07', 'Batavia', 7484, 'ship carried among other things f 299,290 in cash.');
INSERT INTO "voyages" VALUES (3571, '', 1, '', 'WIMMENUM', 'Johan Louis Philippi', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1752-10-03', 'Texel', '1753-03-06', '1753-03-27', true, '1753-07-18', 'Batavia', NULL, 'One of the passengers was a female slave. From 09 till 21-10 the WIMMENUM called at Portsmouth. from 16 till 27-11-1752 at S. Tiago, where 3 soldiers deserted. The cargo consisted of among other things f 299,698 in cash. In January 1754 the ship was attacked by `Angrians'' of the Malabar Coast, it caught fire and exploded, see also the VREDE (3575).');
INSERT INTO "voyages" VALUES (3572, '', 1, '', 'DELFT', 'Jan van Heemskerk', 850, NULL, '1752', NULL, NULL, 'D', 'D', '1752-10-05', 'Goeree', '1753-03-16', '1753-03-27', true, '1753-06-16', 'Batavia', 7455, '249,851 in cash.');
INSERT INTO "voyages" VALUES (3573, '', 1, '', 'PIJLSWAART', 'Reinier Jongemaas', 880, NULL, '1752', NULL, NULL, 'H', 'H', '1752-10-21', 'Texel', '1753-03-07', '1753-03-27', true, '1753-07-20', 'Batavia', 7435, 'On 06-10-1752 the PIJLSWAART set out for the first time, but on 12-10 it returned to Texel. The ship called at S. Tiago (08 till 15-12-1752), where one seafarer deserted. During the voyage one soldier probably became a seafarer. The cargo consisted among other things of f 250,004 in cash.');
INSERT INTO "voyages" VALUES (3574, '', 1, '', 'KATTENDIJKE', 'Willem van der Heyden', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1752-10-24', 'Rammekens', '1753-03-21', '1753-04-14', true, '1753-07-08', 'Batavia', 7433, 'During the voyage one soldier probably became a seafarer.');
INSERT INTO "voyages" VALUES (3575, '', 2, '', 'VREDE', 'Simon Rood', 850, NULL, '1746', NULL, NULL, 'Z', 'E', '1752-11-17', 'Texel', '1753-03-11', '1753-04-01', true, '1753-07-02', 'Batavia', NULL, 'During the voyage one soldier probably became seafarer. The VREDE carried among other things f 98,109 in cash. See the WIMMENUM (3571).');
INSERT INTO "voyages" VALUES (3576, '', 2, '', 'BLOEMENDAAL', 'Hilde Hendriksz. Hoek', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1752-12-28', 'Texel', '1753-03-17', '1753-04-01', true, '1753-06-14', 'Batavia', NULL, 'The cargo of the BLOEMENDAAL consisted among other things of f 215,629 in cash. In 1756 the ship was wrecked off Surat.');
INSERT INTO "voyages" VALUES (3577, '', 3, '', 'DIEMEN', 'Tobias Sielkens', 850, NULL, '1746', NULL, NULL, 'A', 'A', '1752-12-28', 'Texel', '1753-03-17', '1753-04-14', true, '1753-07-06', 'Batavia', NULL, 'The DIEMEN carried among other things f 103,542 in cash. 3577/- Is the third voyage of this ship, which during its previous two voyages was called KASTEEL VAN TILBURG (see 3468/7366). In 1756 it was wrecked in the Indies.');
INSERT INTO "voyages" VALUES (3578, '', 3, '', 'GETROUWIGHEID', 'Petrus Engelaar', 850, NULL, '1744', NULL, NULL, 'H', 'A', '1752-12-28', 'Texel', '1753-03-16', '1753-04-01', true, '1753-06-21', 'Batavia', 7465, 'One of the passengers was a female slave. The cargo of the GE-TROUWIGHEID consisted among other things of f 115,342 in cash.');
INSERT INTO "voyages" VALUES (3579, '', 3, '', 'HUIS TE MANPAD', 'Jan Roelofsz.', 850, NULL, '1745', NULL, NULL, 'A', 'H', '1752-12-28', 'Texel', '1753-03-23', '1753-04-14', true, '1753-07-06', 'Batavia', 7457, 'The cargo of the HUIS TE MANPAD consisted among other things of f 62,772 in cash.');
INSERT INTO "voyages" VALUES (3580, '', 5, '', 'KASTEEL VAN TILBURG', 'Willem ''t Hoen', 850, NULL, '1743', NULL, NULL, 'A', 'A', '1752-12-28', 'Texel', '1753-03-16', '1753-04-17', true, NULL, 'Bengal', 7475, '3513/7369).');
INSERT INTO "voyages" VALUES (3581, '', 4, '', 'ZUIDERBURG', 'Christiaan Hagerop', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1752-12-28', 'Texel', '1753-03-17', '1753-04-05', true, NULL, 'Ceylon', 7452, 'The cargo of the ZUIDERBURG consisted of f 375,270 in cash.');
INSERT INTO "voyages" VALUES (3582, '', 3, '', 'BREDENHOF', 'Jan Nielson', 850, NULL, '1746', NULL, NULL, 'H', 'Z', '1752-12-31', 'Rammekens', '1753-04-11', '1753-04-26', true, NULL, NULL, NULL, 'the ship ran aground on a small island and was wrecked. Foundered 06-0601753 on a reef off the coast of Mozambique; wreck discovered.');
INSERT INTO "voyages" VALUES (3583, '', 2, '', 'ROTTERDAM', 'Govert van Welle', 850, NULL, '1748', NULL, NULL, 'R', 'R', '1753-01-01', 'Goeree', '1753-03-27', '1753-04-14', true, '1753-07-06', 'Batavia', 7436, 'On 19-11-1752 the ROTTERDAM set out for the first time, but it was forced by adverse wind to return to Goeree three days later. The ship carried among other things f 250,006 in cash.');
INSERT INTO "voyages" VALUES (3584, '', 5, '', 'ZAAMSLAG', 'Jakob Kolom', 900, NULL, '1741', NULL, NULL, 'Z', 'Z', '1753-02-28', 'Rammekens', '1753-07-03', '1753-07-25', true, '1753-09-25', 'Batavia', NULL, 'ZAAMSLAG was laid up at Batavia.');
INSERT INTO "voyages" VALUES (3585, '', 3, '', 'AMSTELVEEN', 'Jan Willemsz. van den Briel', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1753-03-09', 'Texel', '1753-06-30', '1753-07-18', true, '1753-12-15', 'Batavia', 7442, 'Bay.');
INSERT INTO "voyages" VALUES (3586, '', 3, '', 'HAARLEM', 'Markus Tetting', 1150, NULL, '1745', NULL, NULL, 'A', 'A', '1763-03-09', 'Texel', '1753-06-29', '1753-07-18', true, '1753-11-14', 'Batavia', 7463, 'From 12-03 till 05-04-1753 the HAARLEM called at Duins, where 2 seafarers died. The ship did not call at the Cape but at False Bay. At Bantam 51 soldiers went ashore. During the voyage 2 soldiers probably became seafarers. The ship carried among other things f 27,580 in cash.');
INSERT INTO "voyages" VALUES (3587, '', 2, '', 'NOORD NIEUWLAND', 'Eduard Koning', 880, NULL, '1749', NULL, NULL, 'R', 'A', '1753-03-09', 'Texel', '1753-06-30', '1753-07-18', true, '1753-09-18', 'Batavia', 7449, 'The cargo consisted among other things of f 104,950 in cash.');
INSERT INTO "voyages" VALUES (3588, '', 1, '', 'RHOON', 'Kornelis de Jonge', 1150, NULL, '1752', NULL, NULL, 'Z', 'Z', '1753-04-09', 'Rammekens', '1753-08-31', '1753-09-19', true, '1753-11-12', 'Batavia', 7440, 'The 8 passengers included 4 female slaves. The RHOON called at Duins twice: from 14 till 15-04 and from 16-04 till 03-05-1753, where one seafarer died. It did not call at the Cape but at False Bay. The ship carried among other things f 171,894 in cash. During the voyage one soldier probably became a seafarer.');
INSERT INTO "voyages" VALUES (3589, '', 4, '', 'BAARZANDE', 'Hans Coenraads', 850, NULL, '1745', NULL, NULL, 'Z', 'D', '1753-04-20', 'Goeree', '1753-08-22', '1753-09-08', true, '1753-11-12', 'Batavia', 7439, 'The BAARZANDE carried among other things f 149,721 in cash.');
INSERT INTO "voyages" VALUES (3590, '', 1, '', 'PERSIJNENBURG', 'Pieter Arendse', 880, NULL, '1752', NULL, NULL, 'E', 'E', '1753-05-05', 'Texel', '1753-08-29', '1753-09-27', true, '1753-12-05', 'Batavia', 7472, 'in cash.');
INSERT INTO "voyages" VALUES (3591, '', 5, '', 'SPANDERSWOUD', 'Nikolaas Pietersz.', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1753-05-05', 'Texel', '1753-09-06', '1753-09-27', true, '1754-04-26', 'Batavia', 7447, 'Louis, the delay there cost 1100 French pounds, the equivalent of 550 Dutch guilders. The ship carried among other things f 354,027 in cash.');
INSERT INTO "voyages" VALUES (3592, '', 2, '', 'MEERVLIET', 'Dirk Dirksz. Klein', 850, NULL, '1749', NULL, NULL, 'A', 'H', '1753-05-30', 'Texel', '1754-03-30', '1754-04-23', true, '1754-07-25', 'Batavia', NULL, 'The MEERVLIET called at Bahia de Todos os Santos (All Saints'' Bay) from 03-12-1753 till 20-01-1754, where 20 seafarers deserted or died. The 6 seafarers who disembarked at the Cape included one condemned person, he was sent back to patria on the OSDORP (see 7419). The ship carried among other things f 74,550 in cash. It was laid up at Malacca on 31-12-1758.');
INSERT INTO "voyages" VALUES (3593, '', 4, '', 'VOORZICHTIGHEID', 'Arend van der Deuren', 850, NULL, '1743', NULL, NULL, 'D', 'E', '1753-05-30', 'Texel', '1753-08-28', '1753-09-27', true, '1753-12-05', 'Batavia', NULL, 'The cargo of the VOORZICHTIGHEID consisted among other things of f 60,005 in cash. On 08-06-1757 the VOORZICHTIGHEID, loaded with rice, ran aground at the Cape and was wrecked.');
INSERT INTO "voyages" VALUES (3594, '', 4, '', 'LEIDEN', 'Jan Sluiskens', 1150, NULL, '1744', NULL, NULL, 'A', 'Z', '1753-06-12', 'Rammekens', '1753-10-16', '1753-11-03', true, '1754-01-19', 'Batavia', 7481, 'seafarers, one soldier and 2 craftsmen deserted. The ship carried among other things .f 82,117 in cash.');
INSERT INTO "voyages" VALUES (3595, '', 1, '', 'JERUSALEM', 'Jan van der Vlucht', 880, NULL, '1752', NULL, NULL, 'R', 'R', '1753-07-07', 'Goeree', '1753-11-08', '1753-11-28', true, '1754-01-26', 'Batavia', 7469, 'From 19 till 25-08-1753 the JERUSALEM called at S. Tiago.');
INSERT INTO "voyages" VALUES (3596, '', 1, '', 'VISVLIET', 'Hertog', 880, NULL, '1752', NULL, NULL, 'Z', 'Z', '1753-07-25', 'Rammekens', '1754-01-14', '1754-02-07', true, '1754-05-20', 'Batavia', 7499, 'The VISVLIET called at Portsmouth (07-08 till 06-09) and at S. Tiago (13 till 18-10-1753), where 8 seafarers and one soldier deserted. The ship carried among other things f 325,000 in cash.');
INSERT INTO "voyages" VALUES (3597, '', 4, '', 'PASGELD', 'Josias Ruts+', 850, NULL, '1745', NULL, NULL, 'D', 'Z', '1753-09-14', 'Rammekens', '1754-01-10', '1754-02-03', true, '1754-05-15', 'Batavia', NULL, 'died; Jakob van Dam succeeded him as master. At Bantam 41 soldiers went ashore. The PASGELD carried among other things f 112,927 in cash. The ship was sold in the Indies on 06-08-1762.');
INSERT INTO "voyages" VALUES (3598, '', 1, '', 'VOORBURG', 'Klaas van den Hoed', 880, NULL, '1753', NULL, NULL, 'D', 'D', '1753-09-19', 'Goeree', '1754-01-22', '1754-02-10', true, '1754-05-18', 'Batavia', NULL, 'From 16 till 17-09-1753 the VOORBURG called at Duins, where one seaferer disembarked. In 1756 the ship was wrecked off Bengal.');
INSERT INTO "voyages" VALUES (3599, '', 4, '', 'HERCULES', 'Johannes Nicolaij', 850, NULL, '1743', NULL, NULL, 'Z', 'Z', '1753-10-22', 'Rammekens', '1754-01-18', '1754-02-10', true, '1754-05-04', 'Batavia', 7474, NULL);
INSERT INTO "voyages" VALUES (3600, '', 1, '', 'BUITENZORG', 'Abraham Zwart', 880, NULL, '1753', NULL, NULL, 'A', 'A', '1753-10-23', 'Texel', '1754-01-22', '1754-02-21', true, '1754-06-08', 'Batavia', 7500, 'On 08-10 the BUITENZORG set out for the first time, but three days later it returned to Texel.');
INSERT INTO "voyages" VALUES (3601, '', 2, '', 'PRINSES CAROLINA', 'Willem Kramer', 300, NULL, '1748', NULL, NULL, 'Z', 'A', '1753-10-23', 'Texel', '1754-02-07', '1754-03-12', true, '1754-08-12', 'Batavia', NULL, 'return to Texel. The ship called at S. Tiago from 19 till 24-11-1753. It carried f 42,700 in cash. The PRINSES CAROLINA replaced the AMSTELLAND, wrecked in September 1751 at the island Sylt (see 3530).');
INSERT INTO "voyages" VALUES (3602, '', 2, '', 'GIESSENBURG', 'Willem Hoogland', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1753-10-23', 'Texel', '1754-01-18', '1754-02-10', true, '1754-04-21', 'Batavia', NULL, 'An earlier attempt to depart from Texel took place on 08-10, but three days later the ship had to return. The PRINSES VAN ORANJE called at S. Tiago from 10 till 24-11-1753. The ship was sold in the Indies on 21-02-1764.');
INSERT INTO "voyages" VALUES (3603, '', 1, '', 'KEUKENHOF', 'Bot+', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1753-10-23', 'Texel', '1754-01-24', '1754-02-21', true, '1754-06-14', 'Batavia', 7434, 'On 08-10 the KEUKENHOF sailed out for the first time, but three days later it had to return to Texel. Gerrit Bot died before reaching the Cape, Isaak Grindet succeeded him as master.');
INSERT INTO "voyages" VALUES (3604, '', 2, '', 'LUXEMBURG', 'Pieter Tornboom', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1753-10-23', 'Texel', '1754-01-22', '1754-03-04', true, '1754-06-14', 'Batavia', 7491, 'On 08-10 the LUXEMBURG set out for the first time, but three days later it returned to Texel.');
INSERT INTO "voyages" VALUES (3605, '', 1, '', 'MARIENBOS', 'Kornelis de Nijs', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1753-10-23', 'Texel', '1754-01-20', '1754-02-21', true, '1754-05-20', 'Batavia', 7508, NULL);
INSERT INTO "voyages" VALUES (3606, '', 2, '', 'PRINSES VAN ORANJE', 'Michiel Kruger', 250, NULL, NULL, '1747', NULL, 'E', 'A', '1753-10-23', 'Texel', '1754-02-07', '1754-02-10', true, '1754-05-17', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (3607, '', 1, '', 'RUITEVELD', 'Hendrik Taal', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1753-10-23', 'Texel', '1754-01-20', '1754-02-21', true, '1754-05-20', 'Batavia', 7450, 'The RUITEVELD set out for the first time on 08-10, but three days later it returned. The ship carried among other things f 344,896 in cash.');
INSERT INTO "voyages" VALUES (3608, '', 2, '', 'ERFPRINS', 'Bartholomeus Schut', 850, NULL, '1750', NULL, NULL, 'D', 'D', '1753-10-26', 'Goeree', '1754-01-22', '1754-02-10', true, '1754-05-20', 'Batavia', 7480, NULL);
INSERT INTO "voyages" VALUES (3609, '', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1753-10-26', NULL, NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (3610, '', 4, '', 'HUIGENWAARD', 'Jochem Hendrik Dodendorp', 850, NULL, '1742', NULL, NULL, 'H', 'H', '1753-11-09', 'Texel', '1754-04-05', '1754-04-23', true, '1754-06-13', 'Batavia', NULL, 'The HUIGENWAARD called at Portsmouth from 11 till 13-11-1753, where one seafarer deserted. In 1758 the ship was sold at Batavia.');
INSERT INTO "voyages" VALUES (3611, '', 4, '', 'BEVALLIGHIEID', 'Willem Klump', 850, NULL, '1746', NULL, NULL, 'R', 'A', '1753-11-30', 'Texel', '1754-03-02', '1754-04-13', true, '1754-08-13', 'Bengal', NULL, NULL);
INSERT INTO "voyages" VALUES (3612, '', 3, '', 'JAGER', 'Daniel Blok', 850, NULL, '1745', NULL, NULL, 'H', 'E', '1753-11-30', 'Texel', '1754-03-22', '1754-04-17', true, '1754-07-10', 'Batavia', 7453, 'The JAGER called at S. Tiago from 06 till 12-01-1754, where one seafarer deserted. The two passengers who embarked at the Cape were a condemned seafarer and an ex-exile who for ten years had been banished from Batavia. During the voyage one soldier possibly became a seafarer. Since March 1755 the JAGER was called BAARZANDE (see 7453 etc.).');
INSERT INTO "voyages" VALUES (3613, '', 2, '', 'NIEUWERKERK', 'Hendrik Booms', 1150, NULL, '1749', NULL, NULL, 'Z', 'Z', '1753-11-30', 'Rammekens', '1754-03-27', '1754-04-18', true, '1754-07-10', 'Batavia', 7464, 'During the voyage one soldier probably became a seafarer.');
INSERT INTO "voyages" VALUES (3614, '', 2, '', 'OUDKARSPEL', 'Marten Wout', 1150, NULL, '1747', NULL, NULL, 'A', 'A', '1753-12-31', 'Texel', '1754-04-29', '1754-05-16', true, '1754-08-01', 'Ceylon', 7451, 'The OUDKARSPEL called at Duins three times: from 04 till 09-01, from 11 till 22-01, and from 24 till 28-01-1754.');
INSERT INTO "voyages" VALUES (3615, '', 3, '', 'NIEUWVIJVERVREUGD', 'Adriaan van den Boer', 1150, NULL, '1748', NULL, NULL, 'Z', 'Z', '1754-02-05', 'Rammekens', '1754-05-20', '1754-06-14', true, '1754-09-10', 'Batavia', 7471, 'The NIEUWVIJVERVREUGD did not call at the Cape but at False Bay from 20-05 till 14-06-1754.');
INSERT INTO "voyages" VALUES (3616, '', 3, '', 'WILDRIJK', 'Kornelis Quack', 850, NULL, '1744', NULL, NULL, 'A', 'R', '1754-03-06', 'Goeree', NULL, NULL, false, '1754-08-29', 'Batavia', 7460, NULL);
INSERT INTO "voyages" VALUES (3617, '', 1, '', 'RADERMACHER', 'Samuel Wanjon', 1150, NULL, '1753', NULL, NULL, 'Z', 'Z', '1754-03-11', 'Rammekens', '1754-07-20', '1754-08-13', true, '1754-10-28', 'Batavia', 7520, 'The RADERMACHER did not call at the Cape but at False Bay from 20-07 till 13-08-1754.');
INSERT INTO "voyages" VALUES (3618, '', 3, '', 'NAARSTIGHEID', NULL, 850, NULL, '1746', NULL, NULL, 'D', 'D', '1754-04-06', 'Goeree', '1754-07-22', '1754-08-13', true, '1754-10-17', 'Batavia', 7502, 'During the voyage one soldier turned out to be a woman; she disembarked at the Cape (see the ''passenger'' indicated in the third column). The 9 passengers who went ashore at Batavia included one female slave.');
INSERT INTO "voyages" VALUES (3619, '', 3, '', 'EENDRACHT', 'Steven Lodewijk de Lill', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1754-05-20', 'Texel', '1754-09-25', '1754-10-19', true, '1755-01-14', 'Batavia', 7487, 'included one female slave. The EENDRACHT called at Duins (27-05 till 04-06) and at S. Tiago (27-06 till 04-07-1754). 3619/7487 Is the third voyage of this ship, which during its two preceding voyages was called ELSWOUD (see 3503/7398).');
INSERT INTO "voyages" VALUES (3620, '', 5, '', 'ELSWOUD', 'Dirk Stijve', 850, NULL, '1742', NULL, NULL, 'A', 'A', '1754-05-20', 'Texel', '1754-09-29', '1754-11-07', true, '1755-01-14', 'Ceylon', 3620, 'Ceylon.');
INSERT INTO "voyages" VALUES (3621, '', 3, '', 'KIEVITSHEUVEL', 'Kornelis Eike', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1754-05-20', 'Texel', '1754-10-06', '1754-10-30', true, '1755-03-04', 'Ceylon', 7534, NULL);
INSERT INTO "voyages" VALUES (3622, '', 3, '', 'SLOTEN', 'Willem Houthuizen', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1754-05-20', 'Texel', '1754-09-04', '1754-09-24', true, '1754-12-06', 'Batavia', 7466, 'On 31-12-1753 the SLOTEN set out for the first time, but it had to return to Texel. The 9 passengers who went aboard at Texel included one female slave; she disembarked at the Cape. The SLOTEN called at Duins from 24 till 27-05-1754.');
INSERT INTO "voyages" VALUES (3623, '', 5, '', 'STANDVASTIGHEID', 'Jan Martens', 850, NULL, '1742', NULL, NULL, 'R', 'R', '1754-06-01', 'Goeree', '1754-09-27', '1754-10-19', true, '1755-01-04', 'Batavia', 7454, 'at S. Tiago, where one seafarer and two soldiers deserted. two seafarers and one soldier were taken aboard. During the voyage one seafarer probably became a soldier.');
INSERT INTO "voyages" VALUES (3624, '', 4, '', 'VOSMAAR', 'Laurens Helmstrom', 850, NULL, '1746', NULL, NULL, 'Z', 'Z', '1754-06-15', 'Rammekens', '1754-10-28', '1754-11-15', true, '1755-02-15', 'Batavia', 7538, 'The VOSMAAR called at S. Tiago from 01 till 09-08-1754, where one seafarer and three soldiers deserted, another soldier died.');
INSERT INTO "voyages" VALUES (3625, '', 3, '', 'LANGEWIJK', 'Jan Wessel', 850, NULL, '1745', NULL, NULL, 'E', 'E', '1754-07-09', 'Texel', '1754-12-15', '1755-01-22', true, '1755-04-30', 'Batavia', 7456, 'In some sources Ring 
Barendsz. de Vries and Jan Eggers are
mentioned as well as masters of the LANGEWIJK; they possibly succeeded each other.');
INSERT INTO "voyages" VALUES (3626, '', 1, '', 'SCHAGEN', 'Jakob Leertouwer', 880, NULL, '1753', NULL, NULL, 'H', 'H', '1754-08-18', 'Texel', '1754-12-03', '1754-12-20', true, '1755-02-28', 'Batavia', 7493, 'The SCHAGEN called at S. Tiago from 19 till 23-09-1754.');
INSERT INTO "voyages" VALUES (3627, '', 6, '', 'KRABBENDUKE', 'Paulus van der Giessen', 850, NULL, '1738', NULL, NULL, 'Z', 'Z', '1754-08-19', 'Rammekens', '1754-12-17', '1755-01-06', true, '1755-03-26', 'Batavia', NULL, 'From 19 till 24-09-1754 the KRABBENDUKE called at S. Tiago, where 2 seafarers deserted, and 3 soldiers were taken aboard. In 1759 the ship was laid up at Batavia.');
INSERT INTO "voyages" VALUES (3628, '', 3, '', 'HUIS TEN DONK', 'Klaas Droogsteen', 875, NULL, '1745', NULL, NULL, 'R', 'R', '1754-09-16', 'Goeree', '1754-12-19', '1755-01-06', true, '1755-04-21', 'Batavia', 7501, 'where 2 soldiers deserted.');
INSERT INTO "voyages" VALUES (3629, '', 3, '', 'WAAKZAAMHEID', 'Simon de Graaf', 850, NULL, '1744', NULL, NULL, 'E', 'Z', '1754-09-17', 'Rammekens', '1754-12-23', '1755-01-06', true, '1755-04-12', 'Batavia', 7494, 'where 3 seafarers and 14 soldiers deserted or died.');
INSERT INTO "voyages" VALUES (3630, '', 2, '', 'DEUNISVELD', 'Dirk van der Schilde', 850, NULL, '1747', NULL, NULL, 'D', 'D', '1754-09-23', 'Goeree', '1755-01-27', '1755-02-22', true, '1755-05-31', 'Batavia', 7506, 'During the voyage one soldier probably became a seafarer.');
INSERT INTO "voyages" VALUES (3631, '', 1, '', 'AMELISWEERT', 'Jakob Wiebe', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1754-11-02', 'Texel', '1755-02-16', '1755-03-09', true, '1755-05-31', 'Batavia', 7467, 'died.');
INSERT INTO "voyages" VALUES (3632, '', 4, '', 'HERSTELDER', 'Jan Hover', 1150, NULL, NULL, '1741', NULL, 'A', 'A', '1754-11-02', 'Texel', '1755-02-01', '1755-02-20', true, '1755-04-30', 'Batavia', NULL, 'The HERSTELDER called at Portsmouth from 07 till 17-11-1754, where one seafarer deserted, another seafarer died. Two of the 17 seafarers who disembarked at the Cape deserted. The HERSTELDER was sold in the Indies on 06-08-1762.');
INSERT INTO "voyages" VALUES (3633, '', 1, '', 'LAPIENENBURG', 'Tobias Sielkens', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1754-11-02', 'Texel', '1755-02-14', '1755-03-09', true, '1755-05-30', 'Batavia', 7543, 'The LAPIENENBURG called at Portsmouth from 07 till 17-11-1754, where one seafarer deserted. At Bantam 95 soldiers went ashore. During the voyage 7 soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3634, '', 2, '', 'LYCOCHTON', 'Jochem Aldertsz. Tarnike', 880, NULL, '1749', NULL, NULL, 'E', 'E', '1754-11-02', 'Texel', '1755-02-14', '1755-03-04', true, '1755-05-30', 'Batavia', 7482, 'The LYCOCHTON called at Duins from 07 till 18-11-1754.');
INSERT INTO "voyages" VALUES (3635, '', 2, '', 'OOSTHUIZEN', 'Jakob de Roeper', 850, NULL, '1749', NULL, NULL, 'H', 'H', '1754-11-02', 'Texel', '1755-03-24', '1755-04-11', true, '1755-06-27', 'Batavia', 7509, 'From 08 till 18-11-1754 the OOSTHUIZEN called at Duins.');
INSERT INTO "voyages" VALUES (3636, '', 1, '', 'STADWIJK', 'Willem Vrucht', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1754-11-02', 'Texel', '1755-03-08', '1755-04-02', true, '1755-07-14', 'Batavia', 7458, 'The STADWIJK called at Portsmouth from 06 till 17-11-1754, where two seafarers and one soldier were pressed by the English. At Bantam 103 soldiers disembarked.');
INSERT INTO "voyages" VALUES (3637, '', 2, '', 'VOORLAND', 'Paulus Rauwenhof', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1754-11-02', 'Texel', '1755-04-05', '1755-04-29', true, '1755-07-14', 'Batavia', 7552, 'The 9 passengers included 3 slaves (one male and two females). The VOORLAND called at Duins (08 till 19-11) and at Portsmouth (20-11 till 19-12-1754); at Portsmouth 3 seafarers and one soldier were pressed by the English, one seafarer deserted, one craftsmen died. During the voyage one soldier probably became a seafarer.');
INSERT INTO "voyages" VALUES (3638, '', 2, '', 'VREDESTEIN', 'Laurens Kok', 880, NULL, '1750', NULL, NULL, 'R', 'R', '1754-11-02', 'Goeree', '1755-02-06', '1755-02-20', true, '1755-05-20', 'Batavia', 7479, 'voyage 3 soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3639, '', 1, '', 'HUIS TE BOEDE', 'Martin Haringman', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1754-11-19', 'Rammekens', '1755-03-20', '1755-04-29', true, '1755-07-13', 'Batavia', 7489, 'The 20 persons who disembarked at the Cape included some deserters.');
INSERT INTO "voyages" VALUES (3640, '', 4, '', 'OOSTKAPELLE', 'Adriaan Bertrand', 850, NULL, '1745', NULL, NULL, 'Z', 'Z', '1754-11-19', 'Goeree', '1755-03-20', '1755-05-03', true, '1755-07-20', 'Batavia', NULL, 'In 1758 the OOSTKAPELLE was wrecked off the Coromandel Coast.');
INSERT INTO "voyages" VALUES (3641, '', 2, '', 'LUCHTENBURG', 'Hans Sierks', 880, NULL, '1750', NULL, NULL, 'H', 'H', '1754-12-22', 'Texel', '1755-03-26', '1755-04-11', true, '1755-07-26', 'Batavia', 7470, NULL);
INSERT INTO "voyages" VALUES (3642, '', 2, '', 'ROZENBURG', 'Pieter Broman', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1754-12-30', 'Texel', '1755-03-27', '1755-04-29', true, '1755-07-07', 'Ceylon', 7477, NULL);
INSERT INTO "voyages" VALUES (3643, '', 1, '', 'SCHOLTENBURG', 'Hendrik Visser', 880, NULL, '1753', NULL, NULL, 'A', 'A', '1754-12-30', 'Texel', '1755-03-29', '1755-04-29', true, '1755-08-17', 'Bengal', 7498, NULL);
INSERT INTO "voyages" VALUES (3644, '', 5, '', 'AKERENDAM', 'Kornelis van der Stam', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1754-12-31', 'Texel', '1755-03-26', '1755-04-16', true, '1755-06-23', 'Batavia', 7505, 'During the voyage 6 soldiers possibly became seafarers.');
INSERT INTO "voyages" VALUES (3645, '', 2, '', 'MIDDELBURG', 'Kornelis van Zwanenburg', 1150, NULL, '1749', NULL, NULL, 'Z', 'Z', '1754-12-31', 'Rammekens', '1755-04-03', '1755-05-19', true, '1755-07-21', 'Batavia', 7483, 'During the voyage 7 soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3646, '', 5, '', 'OVERNES', 'Arie van der Aart', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1754-12-31', 'Texel', '1755-03-26', '1755-04-16', true, '1755-06-24', 'Batavia', 7461, 'slave.');
INSERT INTO "voyages" VALUES (3647, '', 1, '', '''S GRAVENZANDE', 'Hendrik Altman', 880, NULL, '1754', NULL, NULL, 'D', 'D', '1755-05-09', 'Texel', '1755-09-08', '1755-09-29', true, '1755-12-12', 'Batavia', 7507, 'The 3 passengers who embarked at the Cape were condemned persons; they disembarked at Batavia.');
INSERT INTO "voyages" VALUES (3648, '', 2, '', 'VRIJBURG', 'Boudewijn Immers', 1150, NULL, '1748', NULL, NULL, 'Z', 'Z', '1755-05-24', 'Rammekens', '1755-09-16', '1755-10-06', true, '1756-03-15', 'Ceylon', 7516, NULL);
INSERT INTO "voyages" VALUES (3649, '', 2, '', 'BOSSCHENHOVE', 'Klaas Andersen', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1755-06-02', 'Texel', '1755-09-25', '1755-10-26', true, '1756-01-04', 'Batavia', 7486, 'The BOSSCHENHOVE called at S. Tiago from 11 till 19-07-1755. The two passengers included one slave.');
INSERT INTO "voyages" VALUES (3650, '', 4, '', 'SLOT VAN KAPELLE', 'Paulus Engelaar', 1150, NULL, '1745', NULL, NULL, 'A', 'A', '1755-06-02', 'Texel', '1755-09-28', '1755-10-26', true, '1756-01-13', 'Batavia', 7495, 'From 11 till 19-07-1755 the SLOT VAN KAPELLE called at S. Tiago, where 7 soldiers deserted or died. During the voyage one soldier probably became a seafarer.');
INSERT INTO "voyages" VALUES (3651, '', 3, '', 'OSDORP', 'Anthonie Henemans', 850, NULL, '1746', NULL, NULL, 'A', 'A', '1755-06-02', 'Texel', '1755-09-29', '1755-10-23', true, '1756-01-18', 'Batavia', 7492, NULL);
INSERT INTO "voyages" VALUES (3652, '', 4, '', 'SPARENRUK', 'Christiaan Prehn', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1755-06-02', 'Texel', '1755-10-08', '1755-10-23', true, '1756-01-17', 'Batavia', 7523, 'The SPARENDIJK called at S. Tiago (dates of arrival and departure unknown). After the departure from S. Tiago a stowaway was found; he disembarked at Batavia (registered as passenger in the sixth column).');
INSERT INTO "voyages" VALUES (3653, '', 1, '', 'WELGELEGEN', 'Hans Stoft', 880, NULL, '1753', NULL, NULL, 'E', 'E', '1755-06-02', 'Texel', '1755-09-21', '1755-10-05', true, '1756-01-14', 'Batavia', 7488, 'During the voyage two soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3654, '', 1, '', 'BARBARA THEODORA', 'Jakob Reysik', 1150, NULL, '1753', NULL, NULL, 'Z', 'Z', '1755-08-13', 'Rammekens', '1756-01-19', '1756-02-23', true, '1756-05-29', 'Batavia', 7529, 'seafarers died, during the second call three seafarers and one craftsman died, two seafarers and two soldiers deserted. Some of the 89 persons who went ashore at the Cape were handed over to the law. At Bantam 58 soldiers disembarked.');
INSERT INTO "voyages" VALUES (3655, '', 4, '', 'LEKKERLAND', 'Dirk van Maastricht', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1755-08-13', 'Texel', '1756-01-02', '1756-01-27', true, '1756-05-07', 'Batavia', 7525, 'The two passengers who went aboard at the Cape were condemned persons; they disembarked at Batavia. At Bantam 81 soldiers went ashore.');
INSERT INTO "voyages" VALUES (3656, '', 4, '', 'HOF D''UNO', 'Laurens Houtepen', 1150, NULL, '1743', NULL, NULL, 'H', 'Z', '1755-08-13', 'Rammekens', '1756-01-02', '1756-02-23', true, '1756-06-18', 'Batavia', 7497, 'The HOF D''UNO called at Duins twice: 17 till 27-08 and 10-09 till 17-09-1755; during the first call one seafarer died, during the second call one seafarer deserted.');
INSERT INTO "voyages" VALUES (3657, '', 5, '', 'BROUWER', 'Jakob Ketel', 850, NULL, '1743', NULL, NULL, 'H', 'H', '1755-10-13', 'Texel', '1756-01-24', '1756-02-13', true, '1756-05-12', 'Batavia', 7522, 'From 17 till 18-10-1755 the BROUWER called at Duins, where one seafarer died.');
INSERT INTO "voyages" VALUES (3658, '', 2, '', 'KEUKENHOF', 'Nikolaas Oman', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1755-10-13', 'Texel', '1756-01-24', '1756-02-13', true, '1756-05-13', 'Batavia', 7524, 'The KEUKENHOF called at Duins from 17 till 18-10-1755, where two soldiers died.');
INSERT INTO "voyages" VALUES (3659, '', 2, '', 'RUITEVELD', 'Sjouke Jakobsz.', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1755-10-13', 'Texel', '1756-01-25', '1756-02-13', true, '1756-05-11', 'Batavia', 7517, 'The RUITEVELD called at Duins from 17 till 18-10-1755. Some of the 35 seafarers and soldiers who went ashore at the Cape deserted.');
INSERT INTO "voyages" VALUES (3660, '', 1, '', 'BLIJDORP', 'Jan van der Vlucht', 880, NULL, '1753', NULL, NULL, 'R', 'R', '1755-10-18', 'Goeree', '1756-01-10', '1756-01-26', true, '1756-04-12', 'Batavia', 7504, NULL);
INSERT INTO "voyages" VALUES (3661, '', 5, '', 'GERECHTIGHEID', 'Hans Coenraads', 850, NULL, '1742', NULL, NULL, 'E', 'D', '1755-10-18', 'Goeree', '1756-01-18', '1756-01-26', true, '1756-04-13', 'Batavia', 7490, NULL);
INSERT INTO "voyages" VALUES (3662, '', 2, '', 'KATTENDIJKE', 'Lieve Timmermans', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1755-10-19', 'Rammekens', '1756-03-08', '1756-04-19', true, '1756-07-01', 'Batavia', 7515, 'The KATTENDIJKE called at Duins from 25 till 27-10-1755, where two seafarers were pressed by the English. The passenger who embarked at the Cape was a criminal; he did not survive the voyage to Batavia.');
INSERT INTO "voyages" VALUES (3663, '', 1, '', 'VLISSINGEN', 'Kornelis de Jonge', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1755-10-19', 'Rammekens', '1756-03-11', '1756-04-19', true, '1756-06-26', 'Batavia', 7511, 'died. Between Duins and the Cape one seafarer turned out to be a woman; she disembarked at the Cape (indicated as passenger in the third column). Two of the 50 seafarers who went ashore at the Cape were handed over to the law.');
INSERT INTO "voyages" VALUES (3664, '', 1, '', 'AMERONGEN', 'Christiaan Hansen', 1150, NULL, '1754', NULL, NULL, 'A', 'A', '1756-02-02', 'Texel', '1756-06-11', '1756-07-05', true, '1756-09-07', 'Batavia', 7555, 'The AMERONGEN called at Duins (04 till 24-02) and at S. Tiago (05 till 12-04-1756), at Duins one soldier deserted, two soldiers died. During the voyage 11 soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3665, '', 5, '', 'BEVALLIGHEID', 'Dirk Took', 850, NULL, '1746', NULL, NULL, 'R', 'A', '1756-02-02', 'Texel', '1756-06-05', '1756-06-28', true, '1756-10-08', 'Bengal', 7530, 'From 04 till 24-01-1756 the BEVALLIGHEID called at Duins.');
INSERT INTO "voyages" VALUES (3666, '', 4, '', 'IMMAGONDA', 'Jan de Zee', 850, NULL, '1746', NULL, NULL, 'E', 'E', '1756-02-02', 'Texel', '1756-06-05', '1756-06-28', true, '1756-08-15', 'Batavia', 7519, 'The IMMAGONDA called at Duins from 04 till 24-02-1756, where three seafarers deserted, another seafarer died.');
INSERT INTO "voyages" VALUES (3667, '', 2, '', 'PIJLSWAART', 'Christiaan Boomgaard', 880, NULL, '1752', NULL, NULL, 'H', 'H', '1756-02-02', 'Texel', '1756-06-13', '1756-07-07', true, '1756-09-18', 'Batavia', 7528, 'From 04 till 24-02-1756 the PIJLSWAART called at Duins, where one seafarer was pressed by the English, one soldier went missing; the crew was enforced by one seafarer. The ship did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3668, '', 1, '', 'VROUWE REBECCA JACOBA', 'Jan van Ingen', 1150, NULL, '1754', NULL, NULL, 'A', 'A', '1756-02-02', 'Texel', '1756-06-16', '1756-07-18', true, '1756-10-23', 'Batavia', 7568, 'S. Tiago two soldiers deserted, one seafarer was taken over by another ship. The VROUWE REBECCA JACOBA did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3669, '', 2, '', 'RHOON', 'Hendrik Smit', 1150, NULL, '1752', NULL, NULL, 'Z', 'Z', '1756-02-02', 'Rammekens', '1756-06-11', '1756-07-07', true, '1756-09-19', 'Batavia', 7562, 'The RHOON called at Duins (04 till 18-02) and at Spithead (22 till 25-02-1756); at Duins one seafarer deserted. At the Cape Hendrik Smit went to the SNOEK (see 3672) as a passenger; Jurriaan Molensteen, coming from the VROUWE REBECCA JA-COBA (see 3668), succeeded him as master.');
INSERT INTO "voyages" VALUES (3670, '', 3, '', 'ADMIRAAL DE RUYTER', 'Pietersz.', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1756-02-02', 'Texel', '1756-06-13', '1756-07-01', true, '1756-09-12', 'Ceylon', 7563, 'From 04 till 24-02-1756 the ADMIRAAL DE RUYTER called at Duins.');
INSERT INTO "voyages" VALUES (3671, '', 4, '', 'SLOTERDIJK', 'Hans Heide', 1150, NULL, '1747', NULL, NULL, 'A', 'A', '1756-02-02', 'Texel', '1756-06-05', '1756-07-07', true, '1756-09-14', 'Ceylon', 7536, 'The SLOTERDIJK called at Duins from 04 till 24-02-1756.');
INSERT INTO "voyages" VALUES (3672, '', 2, '', 'SNOEK', 'Jan Sluiskens', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1756-02-02', 'Rammekens', '1756-06-11', '1756-07-07', true, '1756-09-06', 'Batavia', 7540, 'at the Cape but at False Bay, where, besides 4 seafarers, Hendrik Smit, former master of the RHOON (see 3669), embarked.');
INSERT INTO "voyages" VALUES (3673, '', 3, '', 'STRALEN', 'Daniel Nieman', 850, NULL, '1748', NULL, NULL, 'E', 'E', '1756-02-02', 'Texel', '1756-06-20', '1756-07-15', true, '1756-09-26', 'Batavia', 7537, 'The STRALEN called at Duins (04 till 24-02) and at S. Tiago (06 till 12-04-1756); at Duins 4 seafarers were pressed by the English, 2 soldiers died; 2 seafarers were taken over from other ships. During the voyage one soldier probably became a seafarer.');
INSERT INTO "voyages" VALUES (3674, '', 5, '', 'HOOP', 'Thomas Hakens', 850, NULL, '1742', NULL, NULL, 'D', 'D', '1756-05-14', 'Goeree', '1756-08-20', '1756-09-11', true, '1756-11-18', 'Batavia', 7514, NULL);
INSERT INTO "voyages" VALUES (3675, '', 3, '', 'NOORD NIEUWLAND', 'Frederik Wielard', 880, NULL, '1749', NULL, NULL, 'R', 'R', '1756-05-14', 'Goeree', '1756-08-20', '1756-09-11', true, '1756-11-17', 'Batavia', 7513, 'During the voyage one soldier probably became a seafarer.');
INSERT INTO "voyages" VALUES (3676, '', 4, '', 'AMSTELVEEN', 'Willem Everdingen van de Nieuwpoort', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1756-05-20', 'Texel', '1756-08-26', '1756-09-14', true, '1756-11-28', 'Batavia', 7565, 'From 13 till 15-06-1756 the AMSTELVEEN called at S. Tiago.');
INSERT INTO "voyages" VALUES (3677, '', 2, '', 'ORANJEZAAL', 'Albert Verzaat', 880, NULL, '1750', NULL, NULL, 'E', 'A', '1756-05-20', 'Texel', '1756-08-28', '1757-02-01', true, '1757-05-21', 'Batavia', 7598, 'The two passengers who embarked at the Cape were condemned persons.');
INSERT INTO "voyages" VALUES (3678, '', 6, '', 'SPANDERSWOUD', 'Nikolaas Pietersz.', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1756-05-20', 'Texel', '1756-08-28', '1756-09-14', true, '1756-11-19', 'Batavia', 7503, NULL);
INSERT INTO "voyages" VALUES (3679, '', 2, '', 'TULPENBURG', 'Kornelis Stuurman', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1756-05-20', 'Texel', '1756-08-28', '1756-09-14', true, '1757-01-09', 'Ceylon', 7569, NULL);
INSERT INTO "voyages" VALUES (3680, '', 5, '', 'ZUIDERBURG', 'Christiaan Hagerop', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1756-05-20', 'Texel', '1756-08-19', '1756-09-11', true, '1756-11-26', 'Batavia', 7526, 'The 20 soldiers who went ashore at the Cape included one person who had turned out to be a woman. The two passengers who embarked at the Cape were condemned criminals.');
INSERT INTO "voyages" VALUES (3681, '', 4, '', 'OVERSCHIE', 'Pieter Kronenburg', 850, NULL, '1745', NULL, NULL, 'D', 'D', '1756-10-23', 'Goeree', '1757-02-13', '1757-03-01', true, '1757-06-01', 'Batavia', 7535, 'The 5 passengers who embarked at the Cape included 4 slaves. During the voyage one soldier probably became a seafarer.');
INSERT INTO "voyages" VALUES (3682, '', 3, '', 'ROTTERDAM', 'Laurens Koek', 850, NULL, '1748', NULL, NULL, 'R', 'R', '1756-10-23', 'Goeree', '1757-02-09', '1757-03-01', true, '1757-05-19', 'Batavia', 7539, 'person.');
INSERT INTO "voyages" VALUES (3683, '', 4, '', 'GUSTAAF WILLEM', 'Jan Leinders', 1150, NULL, '1744', NULL, NULL, 'Z', 'Z', '1756-10-24', 'Rammekens', '1757-02-12', '1757-03-07', true, '1757-06-10', 'Batavia', 7551, 'During the voyage 3 soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3684, '', 3, '', 'OUDKARSPEL', 'Jakob Baars', 1150, NULL, '1747', NULL, NULL, 'A', 'Z', '1756-10-24', 'Rammekens', '1757-02-12', '1757-03-26', true, '1757-06-10', 'Batavia', 7561, 'The 61 persons who went ashore at the Cape included some deserters.');
INSERT INTO "voyages" VALUES (3685, '', 1, '', 'WALCHEREN', 'Leendert Fruit van Hertog', 1150, NULL, '1754', NULL, NULL, 'Z', 'Z', '1756-10-24', 'Rammekens', '1757-02-24', '1757-03-19', true, '1757-06-10', 'Batavia', 7512, NULL);
INSERT INTO "voyages" VALUES (3686, '', 2, '', 'AMELISWEERT', 'Pieter Huisman', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1756-12-07', 'Texel', '1757-04-05', '1757-04-28', true, '1757-07-16', 'Batavia', 7572, 'The AMELISWEERT called at Bantam on 12-07-1757, where two soldiers disembarked. During the voyage two seafarers probably became soldiers.');
INSERT INTO "voyages" VALUES (3687, '', 1, '', 'BRONSTEE', 'Willem Klump', 600, NULL, '1755', NULL, NULL, 'A', 'A', '1756-12-07', 'Texel', '1757-04-24', '1757-05-16', true, '1757-08-28', 'Bengal', 7648, NULL);
INSERT INTO "voyages" VALUES (3688, '', 1, '', 'LEKKERLUST', 'Klaas Stuiver', 880, NULL, '1755', NULL, NULL, 'H', 'H', '1756-12-07', 'Texel', '1757-04-24', '1757-05-15', true, '1757-08-03', 'Batavia', 7589, NULL);
INSERT INTO "voyages" VALUES (3689, '', 1, '', 'LEIMUIDEN', 'Hendrik Winkelman', 1150, NULL, '1755', NULL, NULL, 'A', 'A', '1756-12-07', 'Texel', '1757-05-16', '1757-06-04', true, '1757-08-13', 'Batavia', 7602, 'The 6 passengers who embarked at Texel included one female slave. The LEIMUIDEN called at S. Tiago from 12 till 19-01-1757, where 12 seafarers and one soldier died.');
INSERT INTO "voyages" VALUES (3690, '', 1, '', 'VROUWE PETRONELLA MARIA', 'Jean de la Voie', 1150, NULL, '1755', NULL, NULL, 'A', 'A', '1756-12-07', 'Texel', '1757-04-05', '1757-04-28', true, '1757-07-21', 'Batavia', 7510, NULL);
INSERT INTO "voyages" VALUES (3691, '', 2, '', 'RUYSKENSTEIN', 'Jan Frederik Schrijver', 850, NULL, '1749', NULL, NULL, 'A', 'E', '1756-12-07', 'Texel', '1757-04-24', '1757-05-15', true, '1757-08-03', 'Batavia', NULL, 'The RUYSKENSTEIN was sold at Batavia in 1761.');
INSERT INTO "voyages" VALUES (3692, '', 2, '', 'STADWIJK', 'Pieter de Rode', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1756-12-07', 'Texel', '1757-04-04', '1757-04-28', true, '1757-07-07', 'Batavia', NULL, 'The STADWIJK called at Bantam on 04-07-1757, where 6 seafarers went ashore. During the voyage 10 soldiers probably became seafarers. In 1759 the ship got lost during a voyage to Japan.');
INSERT INTO "voyages" VALUES (3693, '', 4, '', 'SLOTEN', 'Godfried Wargijn', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1756-12-08', 'Texel', '1757-03-12', '1757-03-23', true, '1757-07-31', 'China', 7521, NULL);
INSERT INTO "voyages" VALUES (3694, '', 4, '', 'BAARZANDE', 'Pieter Ruis', 850, NULL, '1745', NULL, NULL, 'H', 'Z', '1757-03-08', 'Rammekens', '1757-07-18', '1757-08-15', true, '1757-10-12', 'Batavia', 7566, 'seafarers and one soldier were pressed by the English. The ship did not call at the Cape but at Simon''s Bay, a part of False Bay. During the voyage one soldier probably became a seafarer. 3694/7566 Is the fourth voyage of this ship, which during its first two voyages and the outward part of its third voyage was called JAGER (see 3612/7453).');
INSERT INTO "voyages" VALUES (3695, '', 2, '', 'TORENVLIET', 'Johannes Nicolaij', 1150, NULL, '1750', NULL, NULL, 'Z', 'Z', '1757-03-08', 'Rammekens', '1757-07-25', '1757-08-25', true, '1757-10-26', 'Ceylon', 7549, NULL);
INSERT INTO "voyages" VALUES (3696, '', 2, '', 'DELFT', 'Pieter Hogendorp', 850, NULL, '1752', NULL, NULL, 'D', 'D', '1757-04-19', 'Goeree', '1757-08-03', '1757-08-26', true, '1757-10-24', 'Batavia', 7518, 'The DELFT did not call at the Cape but at Simon''s Bay. During the voyage two soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3697, '', 1, '', 'VROUWE ELISABETH', 'Pieter Matthijs Joele', 850, NULL, '1755', NULL, NULL, 'R', 'R', '1757-04-19', 'Goeree', '1757-08-03', '1757-08-18', true, '1757-10-26', 'Batavia', 7556, 'From 30-05 till 04-06-1757 the VROUWE ELISABETH called at S. Tiago. The ship did not call at the Cape but at Simon''s Bay. The 3 passengers who went ashore at Simon''s Bay included one ex-soldier who had turned out to be a woman.');
INSERT INTO "voyages" VALUES (3698, '', 4, '', 'GETROUWIGHEID', 'Augustinus Heynenberg', 850, NULL, '1744', NULL, NULL, 'H', 'H', '1757-05-26', 'Texel', '1757-09-06', '1757-09-24', true, '1757-12-27', 'Batavia', 7532, 'During the voyage one soldier probably became a seafarer.');
INSERT INTO "voyages" VALUES (3699, '', 4, '', 'HUIS TE MANPAD', 'Andries Lint', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1757-05-26', 'Texel', '1757-10-16', '1757-11-11', true, '1758-01-29', 'Batavia', 7527, 'The HUTS TE MANPAD called at S. Tiago from 27-06 till 09-07-1757, where 3 seafarers and 3 soldiers died. The 3 passengers who disembarked there included 2 stowaways. discovered on the ship. Between the Cape and Batavia another stowaway was found; he did not survive the voyage (registered as passenger in the fifth column). During the voyage 2 soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3700, '', 3, '', 'OVERNES', 'Marten Wout', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1757-05-26', 'Texel', '1757-10-02', '1757-11-01', true, '1758-01-29', 'Batavia', 7544, 'The OVERNES called at S. Tiago from 27-06 till 09-07-1757, where two seafarers and one soldier died; two seafarers went to the SPAARZAAMHEID (see 3703), two soldiers deserted. The passenger who embarked at the Cape was a condemned person. 3700/7544 Is the third voyage of this ship, which during preceding voyages was called ROZENBURG (see 3642/7477); it was to make two other voyages, both under a third name: AMERONGEN (see 3796/7638 and 3901/-).');
INSERT INTO "voyages" VALUES (3701, '', 1, '', 'VROUWE PETRONELLA', 'Reinder Dijkveld', 880, NULL, '1755', NULL, NULL, 'E', 'E', '1757-05-26', 'Texel', '1757-09-19', '1757-10-10', true, '1758-01-08', 'Batavia', 7541, 'included two female slaves and a former prisoner. During the voyage two soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3702, '', 6, '', 'ROZENBURG', 'Simon Smit', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1757-05-26', 'Texel', '1757-10-07', '1757-11-01', true, '1758-03-24', 'Ceylon', 3702, '/- Is the sixth voyage of the ROZENBURG, which during its five preceding voyages was called OVERNES (see 3646/7461). The ship was sold in the Indies on 06-08-1762.');
INSERT INTO "voyages" VALUES (3703, '', 2, '', 'SPAARZAAMHEID', 'Jan Schellinger', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1757-05-26', 'Texel', '1757-09-29', '1757-10-24', true, '1758-01-15', 'Batavia', NULL, 'seafarers and 14 soldiers died; 2 seafarers were taken over from the OVERNES (see 3700). The 4 passengers who embarked at the Cape were bandits. During the voyage two soldiers probably became seafarers. On 18-10-1763 the ship was laid up in the Indies.');
INSERT INTO "voyages" VALUES (3704, '', 4, '', 'WILDRIJK', 'Jan Spek', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1757-05-26', 'Texel', '1757-10-04', '1757-11-30', true, '1758-03-18', 'Batavia', 7542, 'The WILDRIJK called at S. Tiago 27-06 till 09-07-1757, where 5 seafarers and 2 soldiers deserted or died.');
INSERT INTO "voyages" VALUES (3705, '', 4, '', 'HAARLEM', 'Isaak van den Berg', 1150, NULL, '1745', NULL, NULL, 'A', 'A', '1757-06-24', 'Texel', '1757-10-31', '1757-12-15', true, '1758-03-18', 'Batavia', NULL, 'On 08-08-1758 the HAARLEM was seized by the French off Pondichery in India; later on the ship was wrecked.');
INSERT INTO "voyages" VALUES (3706, '', 6, '', 'KASTEEL VAN TILBURG', 'George Christiaan Honsdorp', 850, NULL, '1743', NULL, NULL, 'A', 'A', '1757-06-24', 'Texel', '1757-10-31', '1757-12-29', true, '1758-04-06', 'Batavia', 3706, 'sixth voyage of this ship, which during its first four voyages was called DIEMEN (see 3513/7369). On 20-10-1764 the ship was laid up in the Indies.');
INSERT INTO "voyages" VALUES (3707, '', 5, '', 'JAGER', 'Paterson', 850, NULL, '1745', NULL, NULL, 'Z', 'Z', '1757-07-08', 'Rammekens', '1757-12-09', '1758-01-13', true, '1758-05-03', 'Batavia', NULL, 'voyage was called BAARZANDE (see 3589/7439 and 7468). In 1765 the ship was sold in the Indies.');
INSERT INTO "voyages" VALUES (3708, '', 3, '', 'NIEUW NIEUWERKERK', 'Pieter de Visser', 1150, NULL, '1749', NULL, NULL, 'Z', 'Z', '1757-07-08', 'Rammekens', '1757-12-01', '1757-12-29', true, '1758-03-18', 'Batavia', 7560, 'from 16 till 20-08-1757, where 3 soldiers deserted.');
INSERT INTO "voyages" VALUES (3709, '', 3, '', 'GOUVERNEUR-GENERAAL', 'Bartholomeus Schut', 850, NULL, '1749', NULL, NULL, 'D', 'D', '1757-10-07', 'Goeree', '1758-01-03', '1758-01-22', true, '1758-04-06', 'Batavia', 7533, 'During the voyage one soldier and one craftsmen possibly became seafarers.');
INSERT INTO "voyages" VALUES (3710, '', 2, '', 'JERUSALEM', 'Pieter Rozenburg', 880, NULL, '1753', NULL, NULL, 'R', 'R', '1757-10-07', 'Goeree', '1758-01-04', '1758-01-22', true, '1758-04-14', 'Batavia', 7546, 'The passenger was a slave.');
INSERT INTO "voyages" VALUES (3711, '', 5, '', 'HERCULES', 'Leendert Kouw', 850, NULL, '1743', NULL, NULL, 'Z', 'Z', '1757-10-18', 'Rammekens', '1758-01-19', '1758-02-23', true, '1758-05-26', 'Batavia', NULL, 'The passenger who went ashore at the Cape was an ex-soldier who had turned out to be a woman. In 1763 the HERCULES was wrecked on a voyage to Timor.');
INSERT INTO "voyages" VALUES (3712, '', 1, '', 'ZUID-BEVELAND', 'Hendrik Booms', 1100, NULL, '1755', NULL, NULL, 'Z', 'Z', '1757-10-18', 'Rammekens', '1758-01-05', '1758-02-05', true, '1758-05-05', 'Batavia', 7617, 'During the voyage one seafarer probably became a soldier.');
INSERT INTO "voyages" VALUES (3713, '', 7, '', 'BATAVIER', 'Kornelis Kuiper', 525, NULL, '1735', NULL, NULL, 'A', 'A', '1757-12-19', 'Texel', '1758-05-19', '1758-10-03', true, '1758-12-16', 'Batavia', NULL, 'The BATAVIER called at Portsmouth (from 30 till 31-12-1757) and at S. Tiago (from 08 till 15-02-1758), where one soldier deserted. During the voyage two soldiers probably became seafarers. The BATAVIER did not call at the Cape but at Simon''s Bay.');
INSERT INTO "voyages" VALUES (3714, '', 4, '', 'LANGEWIJK', 'Jakob de Vries', 850, NULL, '1745', NULL, NULL, 'E', 'E', '1757-12-19', 'Texel', '1758-05-05', '1758-05-24', true, '1758-07-18', 'Batavia', 7557, 'seafarers and 39 soldiers went ashore.');
INSERT INTO "voyages" VALUES (3715, '', 3, '', 'LYCOCHTON', 'Pieter A. Lindholm', 880, NULL, '1749', NULL, NULL, 'E', 'H', '1757-12-19', 'Texel', '1758-05-07', '1758-05-24', true, '1758-07-27', 'Batavia', 7558, 'from 01 till 07-02-1758, where one seafarer and 4 soldiers deserted or died, and one soldier came aboard. At Bantam 51 soldiers went ashore. During the voyage two soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3716, '', 1, '', 'VELSEN', 'Markus Tetting', 1100, NULL, '1756', NULL, NULL, 'A', 'A', '1757-12-19', 'Texel', NULL, NULL, false, '1758-07-25', 'Batavia', 7545, 'The VELSEN called at S. Tiago, probably from 10 till 16-02-1758. On 25-05-1758 the ship rounded the Cape. After arrival at Batavia the VELSEN sailed on to China.');
INSERT INTO "voyages" VALUES (3717, '', 2, '', 'VLIETLUST', 'Jakob Zwart', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1757-12-19', 'Texel', '1758-05-07', '1758-05-17', true, '1758-07-23', 'Ceylon', 7547, NULL);
INSERT INTO "voyages" VALUES (3718, '', 3, '', 'BOSSCHENHOVE', 'Jan Hoyer', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1757-12-30', 'Texel', '1758-05-22', '1758-06-13', true, '1758-08-20', 'Batavia', 7531, 'seafarers, 15 soldiers and one craftsmen deserted or died. and 10 seafarers were taken aboard. The ship did not call at the Cape but at Simon''s Bay. During the voyage 7 soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3719, '', 3, '', 'GIESSENBURG', 'Jan Willem Munts', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1757-12-30', 'Texel', '1758-05-13', '1758-05-24', true, '1758-08-16', 'Ceylon', 7590, NULL);
INSERT INTO "voyages" VALUES (3720, '', 3, '', 'MIDDELBURG', 'Adriaan van den Boer', 1150, NULL, '1749', NULL, NULL, 'Z', 'Z', '1757-12-30', 'Rammekens', '1758-04-09', '1758-05-09', true, '1758-07-16', 'Batavia', NULL, 'During the voyage two soldiers and one craftsmen possibly became seafarers. The MIDDELBURG was sold in the Indies on 20-09-1763.');
INSERT INTO "voyages" VALUES (3721, '', 4, '', 'OSDORP', 'Willem Vrucht', 850, NULL, '1746', NULL, NULL, 'A', 'A', '1757-12-30', 'Texel', '1758-04-20', '1758-05-16', true, '1758-08-30', 'Bengal', NULL, 'The OSDORP was sold in the Indies on 21-10-1766.');
INSERT INTO "voyages" VALUES (3722, '', 1, '', 'RENSWOUDE', 'Jan-Zacharias Nauwman', 1150, NULL, '1756', NULL, NULL, 'A', 'A', '1757-12-30', 'Texel', '1758-05-07', '1758-05-17', true, '1758-08-03', 'Batavia', 7550, 'During the voyage one soldier probably became seafarer. After arrival at Batavia the RENSWOUDE sailed on to China.');
INSERT INTO "voyages" VALUES (3723, '', 1, '', 'ZEELELIE', 'Jakob la Mote', 600, NULL, '1755', NULL, NULL, 'Z', 'Z', '1757-12-30', 'Rammekens', '1758-05-29', '1758-07-02', true, '1758-09-19', 'Batavia', NULL, 'The ZEELELIE did not call at the Cape but at Simon''s Bay. In 1764 the ship was wrecked during a voyage to Banda.');
INSERT INTO "voyages" VALUES (3724, '', 5, '', 'SLOT VAN KAPELLE', 'Anthonie Henemans +', 1150, NULL, '1745', NULL, NULL, 'A', 'A', '1758-01-15', 'Texel', '1758-05-19', '1758-06-13', true, '1758-08-22', 'Batavia', NULL, 'female slave. The SLOT VAN KAPELLE did not call at the Cape but at Simon''s Bay. Between Simon''s Bay and Batavia Anthonie Henemans died; Michiel Hamelo succeeded him as master. On 13-08-1758 18 soldiers went ashore at Bantam. During the voyage 3 soldiers probably became seafarers. The ship was sold in the Indies on 20-09-1763.');
INSERT INTO "voyages" VALUES (3725, '', 2, '', 'HUIS TE BOEDE', 'Huibrecht van der Kneu', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1758-01-21', 'Rammekens', '1758-05-12', '1758-05-24', true, '1758-07-28', 'Batavia', 7573, 'During the voyage one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3726, '', 1, '', 'BLEISWIJK', 'Hans Coenraads', 880, NULL, '1756', NULL, NULL, 'D', 'D', '1758-04-09', 'Goeree', '1758-07-19', '1758-08-12', true, '1758-10-13', 'Batavia', 7597, 'The BLEISWIJK did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3727, '', 6, '', 'STANDVASTIGHEID', 'Herman de Kool', 850, NULL, '1743', NULL, NULL, 'R', 'R', '1758-04-20', 'Goeree', '1758-07-29', '1758-08-24', true, '1758-10-31', 'Batavia', 7554, 'The STANDVASTIGHEID did not call at the Cape but at Simon''s Bay.');
INSERT INTO "voyages" VALUES (3728, '', 5, '', 'HOF D''UNO', 'Louis de Jonge', 1150, NULL, '1743', NULL, NULL, 'H', 'Z', '1758-04-24', 'Rammekens', '1758-08-19', '1758-10-02', true, '1758-12-16', 'Batavia', NULL, 'Indies on 28-12-1762.');
INSERT INTO "voyages" VALUES (3729, '', 2, '', 'BUITENZORG', 'Jurriaan Molensteen', 880, NULL, '1753', NULL, NULL, 'A', 'A', '1758-05-07', 'Texel', '1758-08-27', '1758-09-20', true, '1758-12-11', 'Batavia', 7553, NULL);
INSERT INTO "voyages" VALUES (3730, '', 5, '', 'LEIDEN', 'Thomas Middelmeer', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1758-05-07', 'Texel', '1758-09-04', '1758-10-03', true, '1758-12-11', 'Batavia', NULL, 'Indies on 24-07-1764.');
INSERT INTO "voyages" VALUES (3731, '', 3, '', 'LUXEMBURG', 'Dirk Pietersz.', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1758-05-07', 'Texel', '1758-08-25', '1758-09-20', true, '1758-12-08', 'Batavia', 7548, NULL);
INSERT INTO "voyages" VALUES (3732, '', 2, '', 'WELGELEGEN', 'Jochem Aldertsz. Tarnike', 880, NULL, '1753', NULL, NULL, 'E', 'E', '1758-05-14', 'Texel', '1758-10-13', '1758-12-02', true, '1759-03-09', 'Batavia', 7580, 'soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3733, '', 2, '', 'VISVLIET', 'Justus Baak', 880, NULL, '1752', NULL, NULL, 'Z', 'Z', '1758-05-15', 'Rammekens', '1758-09-14', '1758-10-15', true, '1758-12-26', 'Batavia', 7571, NULL);
INSERT INTO "voyages" VALUES (3734, '', 6, '', 'GERECHTIGHEID', 'Jan Mulder', 850, NULL, '1742', NULL, NULL, 'E', 'H', '1758-05-16', 'Texel', '1758-09-15', '1758-10-15', true, '1758-12-26', 'Batavia', NULL, '19 till 23-06-1758, where one soldier died, and another one deserted. The ship was sold in the Indies on 05-07-1763.');
INSERT INTO "voyages" VALUES (3735, '', 4, '', 'EENDRACHT', 'Hendrik Hartsing', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1758-07-02', 'Texel', '1758-11-04', '1758-12-22', true, '1759-04-16', 'Batavia', 7593, 'On 12-07-1758 the EENDRACHT called at Torbay, where two seafarers died. 3735/7593 Is the fourth voyage of this ship, which during its first two voyages was called ELSWOUD (see 3503/7398).');
INSERT INTO "voyages" VALUES (3736, '', 2, '', 'DE DRIE PAPEGAAIEN', 'Coenraad Dirk Wolk', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1758-07-02', 'Texel', '1758-11-14', '1758-12-03', true, '1759-02-13', 'Batavia', 7603, 'seafarer and 3 soldiers deserted, one seafarer and one soldier were taken aboard. The 2 passengers who embarked at the Cape were condemned ex-soldiers; they were transported to the small island Edam off Batavia.');
INSERT INTO "voyages" VALUES (3737, '', 3, '', 'VRIJBURG', 'Laurens Houtepen', 1150, NULL, '1748', NULL, NULL, 'Z', 'Z', '1758-07-20', 'Rammekens', '1758-11-04', '1758-12-31', true, '1759-05-01', 'Batavia', 7576, 'The 2 passengers who went aboard the VRIJBURG at the Cape were criminals; they had been banished to Edam off Batavia for two years.');
INSERT INTO "voyages" VALUES (3738, '', 4, '', 'HUIS TEN DONK', 'Arend van der Deuren', 875, NULL, '1745', NULL, NULL, 'R', 'R', '1758-10-04', 'Goeree', '1759-01-17', '1759-02-07', true, '1759-04-29', 'Batavia', 7570, 'At the Cape one soldier became seafarer.');
INSERT INTO "voyages" VALUES (3739, '', 3, '', 'ERFPRINS', 'Jakob Welgevaren', 850, NULL, '1750', NULL, NULL, 'D', 'D', '1758-10-04', 'Goeree', NULL, NULL, true, NULL, NULL, NULL, 'It was replaced by another ERFPRINS, previously called DELFT; in April 1759 the new ERFPRINS departed from Goeree (see 3757).');
INSERT INTO "voyages" VALUES (3740, '', 3, '', 'LIEFDE', 'Simon de Graaf', 1150, NULL, '1748', NULL, NULL, 'A', 'Z', '1758-10-04', 'Rammekens', '1759-01-29', '1759-03-07', true, '1759-06-20', 'Batavia', 7575, 'The 6 passengers included one slave; he disembarked at the Cape. Before the LIEFDE arrived at Batavia 55 soldiers were taken over by the LEIDEN, which since January 1759 was on service in the inter-Asiatic trade (see 3730).');
INSERT INTO "voyages" VALUES (3741, '', 1, '', 'NOORD-BEVELAND', 'Jakob Reysik', 1150, NULL, '1756', NULL, NULL, 'Z', 'Z', '1758-10-04', 'Rammekens', '1759-02-19', '1759-03-05', true, '1759-06-20', 'Batavia', 7560, 'The passenger was a slave. One day after the departure from Rammekens the NOORD-BEVELAND returned. on 14-10 it finally set out. From 04 till 19-02-1759 the ship was at Robben Island, where one seafarer and 4 soldiers died. Before it arrived at Batavia 24 soldiers were taken over by the LEIDEN, which since January 1759 was on service in the inter-Asiatic trade (see 3730).');
INSERT INTO "voyages" VALUES (3742, '', 2, '', 'SCHAGEN', 'Klaas Ariensz.', 880, NULL, '1753', NULL, NULL, 'H', 'H', '1758-10-07', 'Texel', '1759-01-29', '1759-03-02', true, '1759-06-17', 'Batavia', 7564, NULL);
INSERT INTO "voyages" VALUES (3743, '', 2, '', 'SCHOLTENBURG', 'Steven Lodewijk de Lill', 880, NULL, '1753', NULL, NULL, 'A', 'A', '1758-10-22', 'Texel', '1759-03-11', NULL, true, '1759-03-11', 'The Cape', 7581, 'members of the crews were accused of having smuggled with goods from the NAARSTIGHEID. After a protracted judicial inquiry the SCHOLTENBURG sailed for patria again in February 1760 (see 7581).');
INSERT INTO "voyages" VALUES (3744, '', 1, '', 'VROUWE ELISABETH DOROTHEA', 'Klaas Andersen', 600, NULL, '1757', NULL, NULL, 'A', 'A', '1758-11-27', 'Texel', '1759-03-13', '1759-04-16', true, '1760-01-01', 'Bengal', 7667, NULL);
INSERT INTO "voyages" VALUES (3745, '', 2, '', 'VLISSINGEN', 'Laurens Helmstrom', 880, NULL, '1754', NULL, NULL, 'Z', 'Z', '1758-11-27', 'Rammekens', '1759-03-05', '1759-04-16', true, '1759-06-29', 'Batavia', 7592, 'The 4 passengers who embarked at the Cape included one condemned person, banished to Edam off Batavia.');
INSERT INTO "voyages" VALUES (3746, '', 4, '', 'WAAKZAAMHEID', 'Jan de Zee', 850, NULL, '1744', NULL, NULL, 'E', 'E', '1758-11-27', 'Texel', '1759-03-13', '1759-03-31', true, '1759-06-17', 'Batavia', NULL, 'WAAKZAAMHEID was sold in the Indies on 19-10-1762.');
INSERT INTO "voyages" VALUES (3747, '', 2, '', 'WALCHEREN', 'Hans Kornelisz.', 1150, NULL, '1754', NULL, NULL, 'Z', 'Z', '1758-11-27', 'Rammekens', '1759-03-05', '1759-04-16', true, '1759-06-21', 'Ceylon', 7591, NULL);
INSERT INTO "voyages" VALUES (3748, '', 1, '', 'VROUWE GEERTRUIDA', 'Christiaan Hagerop', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1758-12-01', 'Texel', '1759-03-29', '1759-04-09', true, '1759-07-06', 'Batavia', 7577, 'The VROUWE GEERTRUIDA called at S. Tiago from 07 till 14-01-1759, where one seafarer and 6 soldiers died. After arrival at Batavia the ship sailed on to China.');
INSERT INTO "voyages" VALUES (3749, '', 1, '', 'KRONENBURG', 'Willem Hoogland', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1758-12-01', 'Texel', '1759-03-28', '1759-04-04', true, '1759-06-20', 'Batavia', 7578, 'After arrival at Batavia the KRONENBURG sailed on to China.');
INSERT INTO "voyages" VALUES (3750, '', 2, '', 'VROUWE PETRONELLA MARIA', 'Reinier Jan Elsevier+', 1100, NULL, '1755', NULL, NULL, 'A', 'A', '1758-12-01', 'Texel', '1759-03-30', '1759-04-12', true, '1759-06-29', 'Batavia', 7579, 'Between the Cape and Batavia Reinier Jan Elsevier died; Simon Bot succeeded him as master. During the voyage two soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3751, '', 6, '', 'HOOP', 'Pieter Broman', 850, NULL, '1742', NULL, NULL, 'D', 'A', '1759-02-19', 'Texel', '1759-07-12', '1759-08-12', true, '1759-10-03', 'Batavia', 7567, 'An earlier departure took place on 22-01-1759, but adverse wind forced the HOOP to return to Texel on 28-01. From 04 till 19-04-1759 the ship was at S. Tiago. where one seafarer and one soldier deserted. It did not call at the Cape but at False Bay. During the voyage 3 soldiers probably became seafarers.');
INSERT INTO "voyages" VALUES (3752, '', 3, '', 'KATTENDUKE', 'Dirk Wagtels', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1759-02-19', 'Rammekens', '1759-05-31', '1759-07-01', true, '1759-09-06', 'Batavia', 7622, 'The KATTENDIJKE did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3753, '', 1, '', 'NEPTUNUS', 'B. van Pantegem', 180, 'hoeker', '1757', NULL, NULL, 'Z', 'Z', '1759-02-19', 'Rammekens', '1759-08-27', NULL, true, '1759-08-27', 'Cape', NULL, 'The NEPTUNUS remained on service at the Cape; in 1775 the ship was laid up (01-03) and broken up.');
INSERT INTO "voyages" VALUES (3754, '', 3, '', 'RUITEVELD', 'Paulus Engelaar', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1759-02-19', 'Texel', '1759-05-30', '1759-07-21', true, '1759-09-06', 'Ceylon', 7626, '19-02-1759 Was the final date of departure of the RUITEVELD; on 22-01 the ship sailed out for the first time, but 6 days later it had to return to Texel.');
INSERT INTO "voyages" VALUES (3755, '', 2, '', 'LEKKERLAND', 'Johan Sigismund Hoeve', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1759-03-05', 'Texel', '1759-07-11', '1759-07-30', true, '1759-10-04', 'Batavia', 7611, 'MARIENBOS (see 3605/7508).');
INSERT INTO "voyages" VALUES (3756, '', 2, '', 'RADERMACHER', 'Pieter Ruis +', 1150, NULL, '1753', NULL, NULL, 'Z', 'Z', '1759-04-02', 'Rammekens', '1759-07-19', '1759-08-26', true, '1759-11-01', 'Batavia', 7587, 'False Bay. After the departure from False Bay Pieter Ruis died; Gerard Rijnder succeeded him as master.');
INSERT INTO "voyages" VALUES (3757, '', 3, '', 'ERFPRINS', 'Simon van Dalen', 850, NULL, '1752', NULL, NULL, 'D', 'D', '1759-04-09', 'Goeree', '1759-08-03', '1759-08-26', true, '1759-10-30', 'Batavia', 7607, 'The ERFPRINS did not call at the Cape but at False Bay. 3757/7606 Is the third voyage of this ship, which during both preceding voyages was called DELFT (see 3696/7518); the new ERFPRINS replaced the previous ERFPRINS, wrecked in October 1758 near Calais (see 3739).');
INSERT INTO "voyages" VALUES (3758, '', 3, '', 'VREDESTEIN', 'Jakob Claeys', 880, NULL, '1750', NULL, NULL, 'R', 'R', '1759-04-09', 'Goeree', '1759-07-08', '1759-07-28', true, '1759-09-26', 'Batavia', 7604, 'From 07 till 09-05-1759 the VREDESTEIN was at S. Tiago. The ship did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3759, '', 1, '', 'NIJENBORG', 'Klaas Stuiver', 880, NULL, '1757', NULL, NULL, 'H', 'H', '1759-04-10', 'Texel', '1759-08-03', '1759-08-19', true, '1759-10-12', 'Batavia', 7612, '03 till 19-08-1759.');
INSERT INTO "voyages" VALUES (3760, '', 5, '', 'IMMAGONDA', 'Jan Frederik Schrijver', 850, NULL, '1746', NULL, NULL, 'E', 'E', '1759-04-30', 'Texel', '1759-08-20', '1759-09-08', true, '1759-11-13', 'Batavia', 7574, 'The 2 passengers who embarked at the Cape were condemned persons.');
INSERT INTO "voyages" VALUES (3761, '', 2, '', 'BLIJDORP', 'Kornelis Nannings', 880, NULL, '1754', NULL, NULL, 'R', 'A', '1759-05-03', 'Goeree', '1759-08-28', '1759-09-15', true, '1759-10-21', 'Batavia', 7582, 'Adverse wind forced the BLIJDORP to call at Duins (05 till 17-05-1759) where two soldiers were pressed by the English.');
INSERT INTO "voyages" VALUES (3762, '', 6, '', 'BROUWER', 'Barend Rust', 850, NULL, '1743', NULL, NULL, 'H', 'A', '1759-05-19', 'Texel', '1759-10-21', '1759-11-15', true, '1760-02-09', 'Batavia', NULL, 'The BROUWER called at S. Tiago from 24-06 till 05-07-1759, where 4 soldiers disembarked. During the voyage 3 soldiers probably became seafarers. The ship was sold in the Indies on 24-07-1764.');
INSERT INTO "voyages" VALUES (3763, '', 5, '', 'SLOTEN', 'Dirk van Maastricht', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1759-05-19', 'Texel', '1759-08-28', '1759-09-15', true, '1759-12-27', 'Batavia', 7588, NULL);
INSERT INTO "voyages" VALUES (3764, '', 6, '', 'ZUIDERBURG', 'Jan van Dalen', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1759-05-19', 'Texel', '1759-10-19', '1759-11-15', true, '1760-02-16', 'Batavia', NULL, 'who came aboard at the Cape included 5 condemned persons. During the voyage one soldier possibly became seafarer. The ZUID-ERBURG was laid up in the Indies on 20-10-1764.');
INSERT INTO "voyages" VALUES (3765, '', 2, '', '''S GRAVENZANDE', 'Pieter Hogendorp', 880, NULL, '1754', NULL, NULL, 'D', 'D', '1759-06-21', 'Goeree', '1759-10-27', '1759-11-15', true, '1760-02-10', 'Batavia', 7621, 'During the voyage one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3766, '', 3, '', 'KEUKENHOF', 'Anthonie Leertouwer', 1150, NULL, '1753', NULL, NULL, 'A', 'Z', '1759-07-28', 'Rammekens', '1759-12-10', '1760-01-06', true, '1760-04-29', 'Batavia', 7618, 'On 19-09-1759 the KEUKENHOF called at S. Tiago for a few hours.');
INSERT INTO "voyages" VALUES (3767, '', 1, '', 'DUINENBURG', 'Christiaan de Jong', 1100, NULL, '1757', NULL, NULL, 'Z', 'Z', '1759-09-21', 'Rammekens', '1760-01-17', '1760-02-28', true, '1760-06-01', 'Batavia', 7628, 'The passenger who embarked at the Cape was a condemned seafarer, banished for one year to Edam off Batavia.');
INSERT INTO "voyages" VALUES (3768, '', 4, '', 'NIEUWLAND', 'Pieter Matthijs Joele', 880, NULL, '1749', NULL, NULL, 'R', 'R', '1759-10-02', 'Goeree', '1760-01-22', '1760-02-05', true, '1760-05-17', 'Batavia', 7583, 'probably became seafarers.');
INSERT INTO "voyages" VALUES (3769, '', 5, '', '- MARIENBOS', 'Nikolaas Pietersz.', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1759-10-29', 'Texel', '1760-03-10', '1760-04-08', true, '1760-06-16', 'Batavia', NULL, 'the ship was wrecked in a heavy storm near Ceylon.');
INSERT INTO "voyages" VALUES (3770, '', 1, '', 'OOSTERBEEK', 'Jan Schellinger', 1100, NULL, '1758', NULL, NULL, 'A', 'A', '1759-10-29', 'Texel', '1760-03-18', '1760-03-29', true, '1760-06-05', 'Batavia', 7594, 'After arrival at Batavia the OOSTER-BEEK sailed on to China.');
INSERT INTO "voyages" VALUES (3771, '', 3, '', 'OOSTHUIZEN', 'Adriaan de Graaf', 850, NULL, '1749', NULL, NULL, 'H', 'H', '1759-10-29', 'Texel', '1760-03-09', '1760-03-29', true, '1760-06-15', 'Batavia', 7600, 'The OOSTHUIZEN called at S. Tiago (19 till 26-12-1759) where 2 seafarers and one craftsmen died and 11 seafarers and 5 soldiers deserted. On 13-01-1760 the ship spoke the MARIENBOS (see 3769) and took over 2 seafarers. The 7 passengers who embarked at the Cape were 2 Chinese families, released from exile by the authorities.');
INSERT INTO "voyages" VALUES (3772, '', 1, '', 'OUDERAMSTEL', 'Jakob Wiebe', 1100, NULL, '1758', NULL, NULL, 'A', 'A', '1759-10-29', 'Texel', '1760-03-22', '1760-04-07', true, '1760-06-20', 'Batavia', 7595, 'and 2 soldiers were pressed by the English. After arrival at Batavia the ship sailed on to China.');
INSERT INTO "voyages" VALUES (3773, '', 2, '', 'VROUWE PETRONELLA', 'Pieter de Leur', 880, NULL, '1755', NULL, NULL, 'E', 'E', '1759-10-29', 'Texel', '1760-02-28', '1760-03-16', true, '1760-06-17', 'Batavia', 7586, NULL);
INSERT INTO "voyages" VALUES (3774, '', 2, '', 'LAPIENENBURG', 'Jean de la Voie', 11, NULL, '1753', NULL, NULL, 'A', 'A', '1759-11-16', 'Texel', '1760-03-18', '1760-04-08', true, '1760-07-01', 'Batavia', 7610, NULL);
INSERT INTO "voyages" VALUES (3775, '', 5, '', 'OVERSCHIE', 'P. van Kronenburg', 850, NULL, '1745', NULL, NULL, 'D', 'D', '1759-11-19', 'Goeree', '1760-03-17', '1760-04-08', true, '1760-06-17', 'Batavia', 7585, NULL);
INSERT INTO "voyages" VALUES (3776, '', 5, '', 'HUIS TE MANPAD', 'Willem Klump', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1759-12-05', 'Texel', '1760-03-18', '1760-04-15', true, '1761-01-09', 'Bengal', NULL, 'In 1766 the HUIS TE MANPAD was sold in the Indies.');
INSERT INTO "voyages" VALUES (3777, '', 2, '', 'VELSEN', 'Hendrik Winkelman', 1100, NULL, '1756', NULL, NULL, 'A', 'A', '1759-12-05', 'Texel', '1760-03-05', '1760-03-16', true, '1760-06-05', 'Batavia', 7596, 'After arrival at Batavia the VELSEN sailed on to China.');
INSERT INTO "voyages" VALUES (3778, '', 5, '', 'SPARENRIJK', 'Andries Lint', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1759-12-06', 'Texel', '1760-03-18', '1760-05-10', true, '1760-07-19', 'Batavia', NULL, 'On 27-03-1762 the SPARENDIJK was wrecked in a heavy storm near Ceylon.');
INSERT INTO "voyages" VALUES (3779, '', 2, '', 'BARBARA THEODORA', 'Pieter Visser', 1150, NULL, '1753', NULL, NULL, 'Z', 'Z', '1760-01-06', 'Rammekens', '1760-03-28', '1760-04-15', true, '1760-06-29', 'Batavia', 7584, NULL);
INSERT INTO "voyages" VALUES (3780, '', 3, '', 'SNOEK', 'Leendert Kouw', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1760-01-06', 'Rammekens', '1760-03-28', '1760-04-23', true, '1760-06-25', 'Batavia', 7614, 'During the voyage one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3781, '', 4, '', 'BOSSCHENHOVE', 'Kornelis van der Stam', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1760-03-26', 'Texel', '1760-07-05', '1760-07-22', true, '1760-10-07', 'Ceylon', 7624, NULL);
INSERT INTO "voyages" VALUES (3782, '', 2, '', 'RENSWOUDE', 'Isaak van den Berg', 1150, NULL, '1756', NULL, NULL, 'A', 'A', '1760-03-26', 'Texel', '1760-07-05', '1760-08-09', true, '1761-01-01', 'Ceylon', 7725, NULL);
INSERT INTO "voyages" VALUES (3783, '', 3, '', 'TORENVLIET', 'Huibrecht van der Kneu', 1150, NULL, '1750', NULL, NULL, 'Z', 'Z', '1760-03-30', 'Rammekens', '1760-06-28', '1760-07-22', true, '1760-09-26', 'Batavia', 7616, 'The TORENVLIET called at Bantam, where 95 soldiers went ashore (23-09-1760).');
INSERT INTO "voyages" VALUES (3784, '', 4, '', 'GOUVERNEUR-GENERAAL', 'Bartholomeus Schut', 850, NULL, '1749', NULL, NULL, 'D', 'D', '1760-04-24', 'Goeree', '1760-07-14', '1760-08-23', true, '1760-10-19', 'Batavia', 7608, NULL);
INSERT INTO "voyages" VALUES (3785, '', 3, '', 'JERUSALEM', 'Godfried Wargijn', 880, NULL, '1753', NULL, NULL, 'R', 'A', '1760-04-24', 'Texel', '1760-07-28', '1760-08-23', true, '1760-11-03', 'Batavia', 7599, NULL);
INSERT INTO "voyages" VALUES (3786, '', 3, '', 'PIJLSWAART', 'Jakob Ketel', 880, NULL, '1752', NULL, NULL, 'H', 'H', '1760-04-27', 'Texel', '1760-07-24', '1760-08-23', true, '1760-10-13', 'Batavia', 7601, 'During the voyage one soldier probably became a seafarer.');
INSERT INTO "voyages" VALUES (3787, '', 3, '', 'DEUNISVELD', 'Leendert Diikveld', 850, NULL, '1747', NULL, NULL, 'D', 'E', '1760-05-13', 'Texel', '1760-09-02', '1760-10-14', true, '1760-12-28', 'Batavia', NULL, 'DEUNISVELD called at S. Tiago (29-06 till 03-07-1760), where 2 seafarers and one soldier died and 3 seafarers and 3 soldiers went missing; 6 soldiers were taken aboard. The passengers who embarked at the Cape were criminals, banished to Edam off Batavia. In 1766 the DEUNISVELD was sold in the Indies.');
INSERT INTO "voyages" VALUES (3788, '', 4, '', 'LUXEMBURG', 'Dirk Pietersz.', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1760-05-13', 'Texel', '1760-09-25', '1760-10-14', true, '1760-12-24', 'Batavia', 7625, 'At the Cape Christiaan Kornelis Testrop succeeded Dirk 
Pietersz. as master of the LUXEMBURG.');
INSERT INTO "voyages" VALUES (3789, '', 1, '', 'SCHOONZICHT', 'Jochem Hendrik Dodendorp', 880, NULL, '1758', NULL, NULL, 'R', 'R', '1760-05-24', 'Goeree', '1760-09-24', '1760-10-14', true, '1760-12-24', 'Batavia', 7629, 'seafarer and 5 soldiers deserted and 2 seafarers were taken aboard. Before arrival at S. Tiago one soldier had been pressed by an English warship.');
INSERT INTO "voyages" VALUES (3790, '', 5, '', 'WILDRIJK', 'Jan Moorland', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1760-06-06', 'Texel', '1760-09-30', '1760-10-15', true, '1761-01-10', 'Batavia', 7623, '(03 till 09-07-1760), where one soldier died, another one deserted and 2 soldiers were taken aboard. During the voyage one soldier probably became seafarer.');
INSERT INTO "voyages" VALUES (3791, '', 3, '', 'VLIETLUST', 'Jakob Boekhout', 1150, NULL, '1752', NULL, NULL, 'A', 'Z', '1760-07-02', 'Rammekens', '1760-11-08', '1760-12-06', true, '1761-02-15', 'Batavia', 7627, NULL);
INSERT INTO "voyages" VALUES (3792, '', 5, '', 'GUSTAAF WILLEM', 'Michiel Godfried Lehman', 1150, NULL, '1744', NULL, NULL, 'Z', 'Z', '1760-09-05', 'Rammekens', '1761-01-23', '1761-03-16', true, '1761-06-09', 'Batavia', NULL, 'Ten of the 33 seafarers who went ashore at the Cape were handed over to the law. In 1764 the GUSTAAF WILLEM was laid up in the Indies.');
INSERT INTO "voyages" VALUES (3793, '', 1, '', 'BORSSELE', 'Abraham in `t Anker', 1150, NULL, '1758', NULL, NULL, 'Z', 'Z', '1761-01-09', 'Rammekens', '1761-04-20', '1761-05-07', true, '1761-07-07', 'Batavia', 7669, 'The 5 passengers included 2 female slaves. The 47 persons who disembarked at the Cape included 3 deserters.');
INSERT INTO "voyages" VALUES (3794, '', 2, '', 'NOORD-BEVELAND', 'Jakob Reysik', 1150, NULL, '1756', NULL, NULL, 'Z', 'Z', '1761-01-09', 'Rammekens', '1761-04-20', '1761-05-07', true, '1761-07-18', 'Batavia', 7647, 'The 4 passengers who embarked at Rammekens included one female slave. The passenger who came aboard at the Cape was a Chinese, released from exile.');
INSERT INTO "voyages" VALUES (3795, '', 4, '', 'ROTTERDAM', 'Frederik Wielard', 850, NULL, '1748', NULL, NULL, 'R', 'R', '1761-01-09', 'Goeree', '1761-04-20', '1761-05-04', true, '1761-07-06', 'Batavia', 7605, 'From 19 till 23-01-1761 the ROTTERDAM was at Duins where 5 seafarers and one soldier were pressed by the English.');
INSERT INTO "voyages" VALUES (3796, '', 4, '', 'AMERONGEN', 'Jan Spek', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1761-01-27', 'Texel', '1761-06-26', '1761-07-25', true, '1762-05-04', 'Ceylon', 7638, '3796/7638 Is the fourth voyage of this ship, which during its first two voyages was called ROZENBURG (see 3642/7477), and during its third voyage OVERNES (see 3700/7544); after return to patria in 1763 it was to make one other voyage, sailing again as AMERONGEN (see 3901/4');
INSERT INTO "voyages" VALUES (3797, '', 1, '', 'DAMZICHT', 'Kornelis Stuurman', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1761-01-27', 'Texel', '1761-04-24', '1761-05-04', true, '1761-07-07', 'Batavia', 7619, 'Eight of the 37 persons who disembarked at the Cape were deserters. After arrival at Batavia the DAMZICHT sailed on to China.');
INSERT INTO "voyages" VALUES (3798, '', 5, '', 'HUIS TEN DONK', 'Pieter Albertsz. +', 875, NULL, '1745', NULL, NULL, 'R', 'A', '1761-01-27', 'Texel', '1761-06-25', '1761-07-19', true, '1761-09-14', 'Batavia', 7, 'between patria and the Cape, Jan Beys succeeded him as master. The HUIS TEN DONK called at Torbay (01 till 03-02-1761). When it set out again 3 seafarers and 6 soldiers had deserted, 9 seafarers, 14 soldiers and the passenger had died.');
INSERT INTO "voyages" VALUES (3799, '', 5, '', 'GETROUWIGHEID', 'August Heynenberg', 850, NULL, '1744', NULL, NULL, 'H', 'H', '1761-01-27', 'Texel', '1761-04-23', '1761-05-04', true, '1761-07-03', 'Batavia', NULL, 'In 1762 the GETROUWIGHEID ran aground in the Bay of Goa and was wrecked.');
INSERT INTO "voyages" VALUES (3800, '', 4, '', 'KIEVITSHEUVEL', 'Markus Tetting', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1761-01-27', 'Texel', '1761-06-11', '1761-06-29', true, '1761-09-02', 'Batavia', 7609, 'did so: on 02-11-1761, two months after its arrival, the KIEVITSHEUVEL started the return voyage to patria, departing from Batavia.');
INSERT INTO "voyages" VALUES (3801, '', 1, '', 'JONGE LIEVE', 'Kornelis Kuiper', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1761-01-27', 'Texel', '1761-05-13', '1761-05-28', true, '1761-07-25', 'Batavia', 7620, 'After arrival at Batavia the JONGE LIEVE sailed on to China.');
INSERT INTO "voyages" VALUES (3802, '', 1, '', 'MEERMIN', 'Hendrik Worms', 450, 'hoeker', '1759', NULL, NULL, 'A', 'A', '1761-01-27', 'Texel', '1761-06-15', NULL, true, '1761-06-15', 'The Cape', NULL, 'The MEERMIN remained on service of the authorities at the Cape until 09-04-1766, when it ran aground and was wrecked.');
INSERT INTO "voyages" VALUES (3803, '', 5, '', 'VROUWE REBECCA JACOBA', 'Anthonie Vogelzang', 1150, NULL, '1747', NULL, NULL, 'A', 'A', '1761-01-27', 'Texel', '1761-05-12', '1761-06-01', true, '1761-07-16', 'Bengal', 3803, '/- Is the fifth voyage of this ship, which during its preceding four voyages was called SLOTERDIJK (number of the fourth voyage: 3761/7536); in 1768 the VROUWE REBECCA JACOBA was laid up in the Indies ?#?');
INSERT INTO "voyages" VALUES (3804, '', 4, '', 'STRALEN', 'Arie Arkebout', 850, NULL, '1748', NULL, NULL, 'E', 'E', '1761-01-27', 'Texel', '1761-06-07', '1761-06-28', true, '1761-09-13', 'Batavia', 7615, 'stowaways were discovered on the ship: they became seafarers.');
INSERT INTO "voyages" VALUES (3805, '', 7, '', 'HOOP', 'Herman de Kool', 850, NULL, '1742', NULL, NULL, 'D', 'D', '1761-01-29', 'Goeree', '1761-07-21', '1761-08-13', true, '1761-11-02', 'Batavia', 7632, '11-03-1761 the HOOP was at Duins: one seafarer and 9 soldiers went to English ships.');
INSERT INTO "voyages" VALUES (3806, '', 3, '', 'RHOON', 'Jan Bernard Schaper', 1150, NULL, '1752', NULL, NULL, 'Z', 'Z', '1761-03-09', 'Rammekens', '1761-07-02', '1761-07-25', true, '1761-09-23', 'Ceylon', NULL, 'On 27-03-1762 the RHOON was wrecked in a heavy storm near Ceylon.');
INSERT INTO "voyages" VALUES (3807, '', 5, '', 'VOSMAAR', 'Laurens Houtepen', 850, NULL, '1746', NULL, NULL, 'Z', 'Z', '1761-03-29', 'Rammekens', '1761-06-25', '1761-07-13', true, '1761-09-25', 'Batavia', 7636, 'Four of the 26 seafarers who went ashore at the Cape were deserters.');
INSERT INTO "voyages" VALUES (3808, '', 3, '', 'SCHOLTENBURG', 'Leendert van der Linden', 880, NULL, '1753', NULL, NULL, 'A', 'D', '1761-04-06', 'Goeree', '1761-07-17', '1761-08-02', true, '1761-09-29', 'Batavia', 7642, 'The SCHOLTENBURG did not call at the Cape but at False Bay. During the voyage 2 soldiers possibly became seafarers.');
INSERT INTO "voyages" VALUES (3809, '', 3, '', 'SCHAGEN', 'Klaas Ariensz.', 880, NULL, '1753', NULL, NULL, 'H', 'H', '1761-04-19', 'Texel', NULL, NULL, false, '1761-09-24', 'Batavia', 7613, NULL);
INSERT INTO "voyages" VALUES (3810, '', 2, '', 'OVERNES', 'Christoffel Blom', 1150, NULL, '1754', NULL, NULL, 'A', 'A', '1761-05-09', 'Texel', '1761-09-13', '1761-10-03', true, '1761-12-19', 'Batavia', 7658, 'AMERONGEN (see 3664/7555).');
INSERT INTO "voyages" VALUES (3811, '', 2, '', 'SLOTERDIJK', 'Jan Siewersz.', 1150, NULL, '1754', NULL, NULL, 'A', 'A', '1761-05-09', 'Texel', '1761-09-14', '1761-10-03', true, '1761-12-21', 'Batavia', 7664, 'was at Duins: 4 seafarers and 6 soldiers were pressed by an English warship. It also called at S. Tiago, 23 till 28-06-1761: 4 seafarers and 2 soldiers deserted. The 14 soldiers who went ashore at the Cape included 6 deserters. 3811/7664 Is the second voyage of this ship, which during its first voyage was called VROUWE REBECCA JACOBA (see 3668/1568).');
INSERT INTO "voyages" VALUES (3812, '', 2, '', 'VROUWE ELIZABETH', 'Arend van der Deuren', 850, NULL, '1755', NULL, NULL, 'R', 'R', '1761-05-27', 'Goeree', '1761-09-01', '1761-09-18', true, '1761-11-27', 'Batavia', 7631, 'called at Bantam: 4 seafarers and 71 soldiers disembarked.');
INSERT INTO "voyages" VALUES (3813, '', 5, '', 'LANGEWIJK', 'Daniel Nieman', 850, NULL, '1745', NULL, NULL, 'E', 'E', '1761-05-27', 'Texel', '1761-09-12', '1761-10-03', true, '1761-12-18', 'Batavia', NULL, 'The LANGEWIJK was laid up and sold at Batavia, 14-01-1768.');
INSERT INTO "voyages" VALUES (3814, '', 3, '', 'VOORLAND', 'Paulus Hansen', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1761-06-15', 'Texel', '1761-12-30', '1762-01-16', true, '1762-03-23', 'Batavia', 7646, 'at Portsmouth 3 seafarers were pressed, 11 seafarers and 6 soldiers deserted, one seafarer and 3 soldiers died, and one seafarer went to an other ship; at S. Tiago one seafarer deserted.');
INSERT INTO "voyages" VALUES (3815, '', 4, '', 'NIEUW NIEUWERKERK', 'Adriaan van den Boer', 1150, NULL, '1749', NULL, NULL, 'Z', 'Z', '1761-08-05', 'Rammekens', '1761-12-25', '1762-01-16', true, '1762-05-18', 'Batavia', 7644, 'discovered as a stowaway on the NIJENBORG, which was returning to patria in 1761/2 (see 7612).');
INSERT INTO "voyages" VALUES (3816, '', 3, '', 'VISVLIET', 'Louis de Jonge', 880, NULL, '1752', NULL, NULL, 'Z', 'Z', '1761-08-05', 'Rammekens', '1761-12-25', '1762-01-26', true, '1762-05-08', 'Batavia', 7643, 'The VISVLIET called at Duins, 09 till 10-08-1761: one seafarer died. Between the Cape and Batavia 2 soldiers were taken over by an English ship.');
INSERT INTO "voyages" VALUES (3817, '', 3, '', 'HUIS TE BOEDE', 'Simon de Graaf', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1761-09-25', 'Rammekens', '1762-02-04', '1762-03-04', true, '1762-05-24', 'Batavia', 7678, 'The 56 persons who went ashore at the Cape included 5 seafarers and one soldier who deserted.');
INSERT INTO "voyages" VALUES (3818, '', 1, '', 'VROUWE KORNELIA HILLEGONDA', 'Simon van Dalen', 850, NULL, '1760', NULL, NULL, 'D', 'D', '1761-09-28', 'Goeree', '1762-01-17', '1762-01-30', true, '1762-04-30', 'Batavia', 7685, 'The 17 persons who went ashore at the Cape included 4 seafarers and 2 soldiers who deserted.');
INSERT INTO "voyages" VALUES (3819, '', 7, '', 'STANDVASTIGHEID', 'Klaas Vermeulen', 850, NULL, '1750', NULL, NULL, 'R', 'R', '1761-09-28', 'Goeree', '1762-01-10', '1762-01-26', true, '1762-05-20', 'Batavia', NULL, 'Between the Cape and Batavia 4 seafarers, 6 soldiers and one craftsmen were pressed by an English warship. In 1768 the STANDVASTIGHEID was sold in the Indies.');
INSERT INTO "voyages" VALUES (3820, '', 1, '', 'BURCH', 'Dirk Wagtels', 1150, NULL, '1760', NULL, NULL, 'Z', 'Z', '1761-10-02', 'Rammekens', '1762-01-21', '1762-02-16', true, '1762-05-19', 'Batavia', 7654, 'two female slaves. Between patria and the Cape one seafarer and one craftsmen went missing. The 48 persons who went ashore at the Cape included 5 seafarers, one soldier and 2 craftsmen who deserted.');
INSERT INTO "voyages" VALUES (3821, '', 2, '', 'VROUWE GEERTRUIDA W', 'illem Everdingen vim der Nieuwpoort', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1761-10-06', 'Texel', '1762-02-13', '1762-03-02', true, '1762-05-23', 'Batavia', 7651, 'one soldier deserted, one seafarer died; at S. Tiago 3 seafarers and one soldier deserted.');
INSERT INTO "voyages" VALUES (3822, '', 2, '', 'OUDERAMSTEL', 'Simon Bot', 1100, NULL, '1758', NULL, NULL, 'A', 'A', '1761-10-11', 'Texel', '1762-02-14', '1762-04-04', true, '1762-06-05', 'Ceylon', 7653, 'From 14 till 21-10-1761 the OUDERAMSTEL was at Duins.');
INSERT INTO "voyages" VALUES (3823, '', 4, '', 'OUDKARSPEL', 'Willem van Braam', 1150, NULL, '1747', NULL, NULL, 'A', 'A', '1761-10-21', 'Texel', '1762-02-12', '1762-03-25', true, '1762-06-16', 'Batavia', 7635, NULL);
INSERT INTO "voyages" VALUES (3824, '', 3, '', 'AMELISWEERT', 'Honsdorp', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1761-12-12', 'Texel', '1762-03-28', '1762-04-18', true, '1762-06-23', 'Ceylon', NULL, 'voyage to Surat');
INSERT INTO "voyages" VALUES (3825, '', 1, '', 'ASCHAT', 'Kornelis Nannings', 1150, NULL, '1760', NULL, NULL, 'A', 'A', '1761-12-12', 'Texel', NULL, NULL, false, '1762-07-21', 'Batavia', 7639, 'Spithead 23 seafarers were taken over by the OOSTERBEEK (see 3831). On 12-07-1762 the ship took over 25 seafarers from the IMMAGONDA (see 3827). After having arrived at Batavia it sailed on to China.');
INSERT INTO "voyages" VALUES (3826, '', 3, '', 'BLIJDORP', 'Pieter Broman', 880, NULL, '1754', NULL, NULL, 'R', 'A', '1761-12-12', 'Texel', '1762-03-18', '1762-04-16', true, '1762-10-10', 'Batavia', 7655, '132 Of the 151 seafarers who disembarked at the Cape went to other ships; many of the 172 embarking soldiers carne from other ships. The BLIJDORP called at Tuticorin in India (23-06 till 21-08-1762): 11 seafarers were admitted to the hospital, one seafarer died, 172 soldiers and one passenger went ashore. During the voyage at least 9 soldiers possibly became seafarers.');
INSERT INTO "voyages" VALUES (3827, '', 6, '', 'IMMAGONDA', 'Jan Frederik Schrijver', 850, NULL, '1746', NULL, NULL, 'E', 'E', '1761-12-12', 'Texel', '1762-04-12', '1762-04-26', true, '1762-07-21', 'Batavia', 7630, 'seafarers were taken over by the ASCHAT (see 3825).');
INSERT INTO "voyages" VALUES (3828, '', 2, '', 'KRONENBURG', 'Johannes van Boom', 1100, NULL, '1757', NULL, NULL, 'A', 'Z', '1761-12-12', 'Rammekens', '1762-04-05', '1762-05-12', true, '1762-07-22', 'Batavia', 7717, 'The 94 disembarking seafarers and soldiers at the Cape included 10 seafarers and 65 soldiers who went to other ships.');
INSERT INTO "voyages" VALUES (3829, '', 4, '', 'LIEFDE', 'Hendrik Andries Tieding', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1761-12-12', 'Texel', '1762-04-15', '1762-05-13', true, '1762-07-21', 'Batavia', 7633, 'Between patria and the Cape one seafarer and two soldiers were pressed by the English. The 22 seafarers who went ashore at the Cape included two deserters.');
INSERT INTO "voyages" VALUES (3830, '', 4, '', 'LYCOCHTON', 'Klaas Stuiver', 880, NULL, '1749', NULL, NULL, 'E', 'H', '1761-12-12', 'Texel', '1762-03-23', '1762-04-08', true, '1762-07-03', 'Batavia', 7634, NULL);
INSERT INTO "voyages" VALUES (3831, '', 2, '', 'OOSTERBEEK', 'Jan Zacharias Nauwman', 1100, NULL, '1758', NULL, NULL, 'A', 'A', '1761-12-12', 'Texel', '1762-05-24', '1762-06-19', true, '1762-10-11', 'Bengal', NULL, 'The OOSTERBEEK called at Duins (17 till 22-12) and at Spithead (29-12-1761 till 23-01-1762); at Spithead the ship took over 23 seafarers from the ASCHAT (see 3825). Before sailing to Bengal it first called at Ceylon. See also 3834. In 1765 the OOSTER-BEEK ran aground at East Java and was wrecked.');
INSERT INTO "voyages" VALUES (3832, '', 3, '', 'VROUWE PETRONELLA MARIA', 'Jan van Eysden', 1100, NULL, '1755', NULL, NULL, 'A', 'A', '1761-12-12', 'Texel', '1762-03-28', '1762-04-08', true, '1762-07-03', 'Batavia', 7640, 'who went ashore at the Cape included one deserter. At Sunda Straits 3 seafarers were taken over by a Dutch jacht. After having arrived at Batavia the VROUWE PETRONELLA MARIA sailed on the China.');
INSERT INTO "voyages" VALUES (3833, '', 4, '', 'ADMIRAAL DE RUYTER', 'Hendrik Hilverduin', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1761-12-12', 'Texel', '1762-04-05', '1762-04-24', true, '1762-07-21', 'Batavia', NULL, 'English; between. the Cape and Batavia two seafarers went missing. After having arrived at Batavia the ADMIRAAL DE RUYTER sailed on to China.');
INSERT INTO "voyages" VALUES (3834, '', 3, '', 'WALCHEREN', 'Hans Kornelisz.', 1150, NULL, '1754', NULL, NULL, 'Z', 'Z', '1762-03-01', 'Rammekens', '1762-06-06', '1762-06-25', true, '1762-08-29', 'Batavia', 7637, '01-03-1762 Is the final date of departure of the WALCHEREN; on 25-01-1762 the ship vainly tried to sail out for the first time. The 133 persons who disembarked at the Cape included 12 seafarers and 98 soldiers who went to the OOSTERBEEK (see 3831).');
INSERT INTO "voyages" VALUES (3835, '', 2, '', 'BLEISWIJK', 'Bartholomeus Bigom', 880, NULL, '1756', NULL, NULL, 'D', 'D', '1762-04-05', 'Goeree', '1762-07-12', '1762-07-29', true, '1762-09-26', 'Batavia', 7650, NULL);
INSERT INTO "voyages" VALUES (3836, '', 3, '', 'VELSEN', 'Laurens Helmstrom', 1100, NULL, '1756', NULL, NULL, 'A', 'Z', '1762-04-14', 'Rammekens', '1762-08-21', '1762-09-12', true, '1762-11-29', 'Batavia', 7645, 'soldiers were pressed by the English.');
INSERT INTO "voyages" VALUES (3837, '', 3, '', 'WELGELEGEN', 'Jurriaan Molensteen', 880, NULL, '1753', NULL, NULL, 'E', 'A', '1762-04-15', 'Texel', '1762-08-21', '1762-09-06', true, '1762-11-07', 'Batavia', 7657, 'The WELGELEGEN called at Duins, 20 till 21-04-1762: 3 seafarers and 2 soldiers were pressed by the English. The 17 seafarers who went ashore there included one deserter.');
INSERT INTO "voyages" VALUES (3838, '', 5, '', 'AMSTELVEEN', 'Nikolaas Pietersz.', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1762-05-05', 'Texel', '1762-09-04', '1762-09-21', true, '1762-11-28', 'Batavia', NULL, 'deserted. On 05-08-1763 the AMSTELVEEN was wrecked off the Arabian Coast.');
INSERT INTO "voyages" VALUES (3839, '', 2, '', 'LEIMUIDEN', 'Barend de Rust', 1150, NULL, '1755', NULL, NULL, 'A', 'A', '1762-05-05', 'Texel', '1762-09-17', '1762-10-14', true, '1762-12-23', 'Batavia', 7714, 'From 07 till 15-06 the LEIMUIDEN was at S. Vincente: 7 soldiers deserted. On 16-06 one seafarer and one craftsmen were pressed by an English ship. The ship also called at S. Tiago, 17 till 25-06-1762: two soldiers were taken aboard.');
INSERT INTO "voyages" VALUES (3840, '', 5, '', 'NOORD NIEUWLAND', 'Joost van den Berg', 880, NULL, '1749', NULL, NULL, 'R', 'R', '1762-05-05', 'Goeree', '1762-08-21', '1762-09-06', true, '1762-11-10', 'Batavia', 7652, NULL);
INSERT INTO "voyages" VALUES (3841, '', 4, '', 'OOSTHUIZEN', 'Jan Mulder', 850, NULL, '1749', NULL, NULL, 'H', 'H', '1762-05-19', 'Texel', '1762-09-09', '1762-10-06', true, '1762-12-17', 'Batavia', 7656, NULL);
INSERT INTO "voyages" VALUES (3842, '', 1, '', 'ENKHUIZEN', 'Jakob de Vries', 880, NULL, '1760', NULL, NULL, 'E', 'E', '1762-06-14', 'Texel', '1762-11-26', '1762-12-08', true, '1763-03-02', 'Batavia', 7716, NULL);
INSERT INTO "voyages" VALUES (3843, '', 3, '', 'VLISSINGEN', 'Pieter Visser', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1762-08-12', 'Rammekens', '1763-01-03', '1763-02-15', true, '1763-05-16', 'Batavia', 7662, 'The VLISSINGEN called at Portsmouth (23 till 27-08) and at S. Vincente (26-09 till 04-10-1762); at Portsmouth 3 seafarers were pressed by the English, one seafarer died; at S. Vincente one seafarer and 6 soldiers deserted; one Frenchman was taken aboard as seafarer.');
INSERT INTO "voyages" VALUES (3844, '', 1, '', 'HUTS TE BIJWEG', 'Dirk van Maastricht', 1100, NULL, '1760', NULL, NULL, 'A', 'A', '1762-09-14', 'Texel', '1763-01-16', '1763-02-09', true, '1763-05-15', 'Batavia', 7659, 'From 24-09 till 02-10-1762 the HUIS TE BIJWEG was at Duins. The ship sailed on to China.');
INSERT INTO "voyages" VALUES (3845, '', 6, '', 'SLOTEN', 'Hagerop', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1762-09-14', 'Texel', '1763-01-11', '1763-01-26', true, '1763-05-15', 'Batavia', 7660, 'The SLOTEN called at Spithead, 24-09 till 02-10-1762. The ship sailed on to China.');
INSERT INTO "voyages" VALUES (3846, '', 5, '', 'KIEVITSHEUVEL', 'Frederik Kelger', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1762-10-07', 'Texel', '1763-01-11', '1763-02-26', true, '1763-06-13', 'Batavia', 7680, NULL);
INSERT INTO "voyages" VALUES (3847, '', 6, '', 'OVERSCHIE', 'Jan Hendriksz. Vogelaar', 850, NULL, '1745', NULL, NULL, 'D', 'D', '1762-10-08', 'Goeree', '1763-01-05', '1763-01-16', true, '1763-04-17', 'Batavia', NULL, 'The 16 soldiers who went ashore at the Cape included one deserter. The OVERSCHIE was laid up in the Indies, 20-10-1764.');
INSERT INTO "voyages" VALUES (3848, '', 3, '', 'TULPENBURG', 'Gerrit Reyndertsz. Vos', 1150, NULL, '1750', NULL, NULL, 'A', 'Z', '1762-10-09', 'Rammekens', '1763-01-12', '1763-02-15', true, '1763-05-16', 'Batavia', 7699, '24 seafarers who went ashore at the Cape included 5 deserters.');
INSERT INTO "voyages" VALUES (3849, '', 4, '', 'VRIJBURG', 'Jakob Wiebe', 1150, NULL, '1748', NULL, NULL, 'Z', 'A', '1762-10-31', 'Texel', '1763-03-13', '1763-04-22', true, '1763-07-08', 'Batavia', 7666, 'persons who went ashore at the Cape included 7 seafarers and 6 soldiers who deserted.');
INSERT INTO "voyages" VALUES (3850, '', 1, '', 'WESTERVELD', 'Hans Bruns', 1100, NULL, '1761', NULL, NULL, 'A', 'A', '1762-10-31', 'Texel', '1763-03-08', '1763-03-22', true, '1763-06-09', 'Batavia', 7661, 'After having arrived at Batavia the WESTERVELD sailed on to China.');
INSERT INTO "voyages" VALUES (3851, '', 5, '', 'BAARZANDE', 'Pieter de Leur', 850, NULL, '1745', NULL, NULL, 'H', 'E', '1762-12-09', 'Texel', '1763-03-15', '1763-03-31', true, '1763-06-20', 'Batavia', 7649, 'The BAARZANDE called at S. Tiago, 04 till 14-01-1763. 3851/7649 Is the fifth voyage of this ship, which during its first two voyages and its third outward-voyage was called JAGER (numbers of the third voyage: 3612/7453).');
INSERT INTO "voyages" VALUES (3852, '', 4, '', 'JERUSALEM', 'Johan Sigismund Hoeve', 880, NULL, '1753', NULL, NULL, 'R', 'A', '1762-12-09', 'Texel', '1763-03-16', '1763-04-29', true, '1763-08-11', 'Bengal', 7688, NULL);
INSERT INTO "voyages" VALUES (3853, '', 2, '', 'LEKKERLUST', 'Adriaan de Graaf', 880, NULL, '1755', NULL, NULL, 'H', 'H', '1762-12-09', 'Texel', '1763-03-15', '1763-03-31', true, '1763-06-19', 'Batavia', 7677, 'The LEKKERLUST called at S. Tiago (04 till 14-01-1763): 3 seafarers and one soldier disembarked.');
INSERT INTO "voyages" VALUES (3854, '', 3, '', 'DE DRIE PAPEGAAIEN', 'Volkert Groeneweg van Oudshoom', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1762-12-09', 'Texel', '1763-03-15', '1763-04-25', true, '1763-07-05', 'Batavia', 7665, 'From 04 till 14-01-1763 the DRIE PAPEGAAIEN was at S. Tiago: one seafarer and two soldiers went missing, one seafarer died. The ship also called at Bantam (23-06-1763): 4 seafarers went to another ship.');
INSERT INTO "voyages" VALUES (3855, '', 4, '', 'VREDESTEIN', 'Jochem Hendrik Dodendorp', 880, NULL, '1750', NULL, NULL, 'R', 'R', '1762-12-10', 'Goeree', '1763-03-15', '1763-03-31', true, '1763-05-01', 'Batavia', 7676, NULL);
INSERT INTO "voyages" VALUES (3856, '', 3, '', 'RADERMACHER', 'Jan Doensen', 1150, NULL, '1753', NULL, NULL, 'Z', 'Z', '1762-12-15', 'Rammekens', '1763-05-09', '1763-05-29', true, '1763-11-05', 'Batavia', 7663, 'The 22 seafarers who went ashore at the Cape included one deserter.');
INSERT INTO "voyages" VALUES (3857, '', 2, '', 'LIEVE', 'Karsten Zunksen', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1762-12-27', 'Texel', '1763-05-04', '1763-05-19', true, '1763-08-25', 'Ceylon', 7673, NULL);
INSERT INTO "voyages" VALUES (3858, '', 2, '', 'DAMZICHT', 'Lodewijk Thomasz.', 1150, NULL, '1759', NULL, NULL, 'A', 'Z', '1763-03-13', 'Rammekens', '1763-07-09', '1763-08-12', true, '1763-10-19', 'Ceylon', 7713, NULL);
INSERT INTO "voyages" VALUES (3859, '', 4, '', 'ERFPRINS', 'Pieter Schoneman', 850, NULL, '1752', NULL, NULL, 'D', 'D', '1763-04-10', 'Goeree', '1763-07-14', '1763-08-02', true, '1763-10-08', 'Batavia', 7675, 'The ERFPRINS did not call at the Cape but at False Bay; the 31 soldiers who went ashore there included one deserter. 3859/7675 is the fourth voyage of this ship, which during its first two voyages was called DELFT (numbers of the second voyage: 3696/7518).');
INSERT INTO "voyages" VALUES (3860, '', 5, '', 'ROTTERDAM', 'Pieter Matthijs Joele', 850, NULL, '1748', NULL, NULL, 'R', 'R', '1763-04-26', 'Goeree', '1763-08-15', '1763-09-07', true, '1763-11-01', 'Batavia', NULL, 'Tiago, 31-05 till 04-06-1763: two soldiers and one craftsmen disembarked, 8 passengers came aboard. The ship was sold in the Indies, 31-12-1768.');
INSERT INTO "voyages" VALUES (3861, '', 5, '', 'EENDRACHT', 'Jan Schellinger', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1763-05-06', 'Texel', '1763-09-13', '1763-10-29', true, '1764-02-05', 'Batavia', 7689, 'The EENDRACHT did not call at the Cape but at False Bay; the 58 persons who went ashore there included 2 seafarers and 2 soldiers who deserted. 3861/7689 Is the fifth voyage of this ship, which during its first two voyages was called ELSWOUD (numbers of the second voyage: 3503/7398).');
INSERT INTO "voyages" VALUES (3862, '', 3, '', 'ORANJEZAAL', 'Hendrik Worms', 880, NULL, '1750', NULL, NULL, 'E', 'A', '1763-05-06', 'Texel', '1763-09-18', '1763-10-07', true, '1763-12-13', 'Batavia', 7679, NULL);
INSERT INTO "voyages" VALUES (3863, '', 4, '', 'BARBARA THEODORA', 'Gillis Verte', 1150, NULL, '1750', NULL, NULL, 'Z', 'Z', '1763-05-08', 'Rammekens', '1763-08-26', '1763-09-24', true, '1763-11-13', 'Batavia', 7704, 'third voyage: 3783/7616).');
INSERT INTO "voyages" VALUES (3864, '', 2, '', 'NIJENBORG', 'Jakob Ketel+', 880, NULL, '1757', NULL, NULL, 'H', 'H', '1763-05-08', 'Texel', '1765-05-03', '1765-06-24', true, '1765-08-30', 'Batavia', 7715, 'supplemented crew. Jakob Ketel died and was succeeded by George Christiaansz. Hartsz. All mutineers were caught and sent to Holland by the Portuguese. The French sent some of them to Surinam. During the trials at Den Helder and Paramaribo 24 men were sentenced to death.');
INSERT INTO "voyages" VALUES (3865, '', 3, '', 'VROUWE PETRONELLA', 'Arie Arkebout', 880, NULL, '1755', NULL, NULL, 'E', 'E', '1763-05-19', 'Texel', '1763-09-15', '1763-10-07', true, '1763-12-12', 'Batavia', 7668, NULL);
INSERT INTO "voyages" VALUES (3866, '', 4, '', 'GIESSENBURG', 'Thijs Fierman', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1763-06-03', 'Texel', '1763-09-21', '1763-10-19', true, '1764-01-04', 'Ceylon', NULL, 'In 1766 the GIESSENBURG, sailing to Banda. was wrecked.');
INSERT INTO "voyages" VALUES (3867, '', 3, '', 'LEKKERLAND', 'Christiaan Blom', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1763-06-03', 'Texel', '1763-09-23', '1763-10-31', true, '1764-02-03', 'Ceylon', 3867, '/- Is the third voyage of this ship, which during its first voyage was called MARIENBOS (see 3605/7508). The ship was sold in the Indies, 12-01-1770.');
INSERT INTO "voyages" VALUES (3868, '', 6, '', 'HUIS TEN DONK', 'Frederik Wielard', 875, NULL, '1745', NULL, NULL, 'R', 'R', '1763-06-15', 'Goeree', '1763-09-19', '1763-10-12', true, '1763-12-11', 'Batavia', 7670, 'One of the two seafarers who went ashore at the Cape was a deserter, 110 of the 119 disembarking soldiers were destined for Ceylon,');
INSERT INTO "voyages" VALUES (3869, '', 3, '', '''S GRAVENZANDE', 'Jan Moorland', 880, NULL, '1754', NULL, NULL, 'D', 'A', '1763-06-15', 'Texel', '1763-10-20', '1763-11-12', true, '1764-02-19', 'Batavia', 7695, NULL);
INSERT INTO "voyages" VALUES (3870, '', 3, '', 'LAPIENENBURG', 'Markus Tetting', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1763-06-15', 'Texel', '1763-10-07', '1763-11-04', true, '1764-02-05', 'Batavia', NULL, 'At the Cape two seafarers deserted.');
INSERT INTO "voyages" VALUES (3871, '', 2, '', 'DUINENBURG', 'Michiel Godfried Lehman', 1100, NULL, '1757', NULL, NULL, 'Z', 'Z', '1763-06-20', 'Rammekens', '1763-11-18', '1763-12-13', true, '1764-04-09', 'Ceylon', 7671, NULL);
INSERT INTO "voyages" VALUES (3872, '', 5, '', 'GOUVERNEUR-GENERAAL', 'Gerrit Harmeyer', 850, NULL, '1749', NULL, NULL, 'D', 'D', '1763-07-23', 'Goeree', '1763-12-25', '1764-01-16', true, '1764-09-11', 'Batavia', 7672, 'The GOUVERNEUR-GENERAAL called at S. Tiago (15 till 22-09-1763) and at Tuticorin (08-05 till 24-07-1764); at S. Tiago 3 seafarers and one soldier died, 3 soldiers deserted, one seafarer and one soldier were taken aboard. At Tuticorin 24 seafarers, 148 soldiers and 9 passengers went ashore, 11 seafarers and 11 soldiers died; 2 seafarers came aboard.');
INSERT INTO "voyages" VALUES (3873, '', 2, '', 'ZUID-BEVELAND', 'Huibrecht van der Kneu', 1100, NULL, '1755', NULL, NULL, 'Z', 'Z', '1763-08-17', 'Rammekens', '1763-12-27', '1764-02-14', true, '1764-05-15', 'Batavia', 7700, 'and 05 till 23-09-1763 respectively): at Ponsmouth one seafarer deserted; at Falmouth 7 seafarers, one soldier and one craftsmen were pressed by the English, one seafarer died.');
INSERT INTO "voyages" VALUES (3874, '', 4, '', 'SCHAGEN', 'Klaas Ariensz.', 880, NULL, '1753', NULL, NULL, 'H', 'H', '1763-09-01', 'Texel', '1763-12-30', '1764-01-23', true, '1764-09-22', 'Batavia', 7712, 'The 51 persons who went ashore at the Cape included 5 seafarers and 5 soldiers who deserted. From 22-05 till 07-08-1764 the SCHAGEN was at Tuticorin in India: 15 seafarers and 102 soldiers disembarked, 8 seafarers and 27 soldiers died.');
INSERT INTO "voyages" VALUES (3875, '', 5, '', 'STRALEN', 'Thomas van Wagtendonk', 850, NULL, '1748', NULL, NULL, 'E', 'E', '1763-09-06', 'Texel', '1764-01-12', '1764-02-10', true, '1764-05-20', 'Batavia', 7686, 'The 60 persons who went ashore at the Cape included 6 seafarers and 3 soldiers who deserted.');
INSERT INTO "voyages" VALUES (3876, '', 2, '', 'ASCHAT', 'Kornelis Kuiper', 1150, NULL, '1760', NULL, NULL, 'A', 'A', '1763-09-27', 'Texel', '1764-01-11', '1764-02-08', true, '1764-05-16', 'Batavia', 7681, 'From 05 till 15-10-1763 the ASCHAT was at Duins: 7 seafarers and one soldier were pressed by the English, After having arrived at Batavia the ship sailed on to China.');
INSERT INTO "voyages" VALUES (3877, '', 3, '', 'VROUWE ELIZABETH', 'Pieter Breugel', 850, NULL, '1755', NULL, NULL, 'R', 'R', '1763-09-27', 'Goeree', '1763-12-31', '1764-01-16', true, '1764-03-28', 'Batavia', 7694, NULL);
INSERT INTO "voyages" VALUES (3878, '', 1, '', 'HUIS OM', 'Kornelis Pietersen', 1150, NULL, '1761', NULL, NULL, 'Z', 'Z', '1763-09-27', 'Rammekens', '1764-01-01', '1764-02-14', true, '1764-05-17', 'Batavia', 7682, 'The 6 passengers included 2 female slaves. After having arrived at Batavia the HUIS OM sailed on to China.');
INSERT INTO "voyages" VALUES (3879, '', 1, '', '''S LANDS WELVAREN', 'Pieter Fruit', 880, NULL, '1762', NULL, NULL, 'A', 'A', '1763-09-27', 'Texel', '1764-01-12', '1764-02-07', true, '1764-05-16', 'Batavia', 7684, '''S LANDS WELVAREN called at Duins, 05 till 15-10-1763. After having arrived at Batavia the ship sailed on to China.');
INSERT INTO "voyages" VALUES (3880, '', 8, '', 'HOOP', 'Herman de Kool', 850, NULL, '1742', NULL, NULL, 'D', 'D', '1763-10-10', 'Goeree', '1764-01-13', '1764-02-02', true, '1764-05-18', 'Batavia', NULL, 'ashore at the Cape included 7 seafarers and 3 soldiers who deserted. The HOOP was sold in the Indies, 31-03-1767.');
INSERT INTO "voyages" VALUES (3881, '', 4, '', 'KEUKENHOF', 'Jan van Dalen', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1763-10-15', 'Texel', '1764-01-11', '1764-02-22', true, '1764-05-17', 'Batavia', 7696, NULL);
INSERT INTO "voyages" VALUES (3882, '', 4, '', 'RUITEVELD', 'Isaak van den Berg', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1763-10-16', 'Texel', '1764-02-09', '1764-03-03', true, '1764-05-16', 'Batavia', 7683, '16-10-1763 Is the final date of departure of the RUITEVELD; on 28-09-1763 the ship set out for the first time, but 16 days later it returned to Texel (14-10); adverse wind caused this delay. After having arrived at Batavia the ship sailed on to China.');
INSERT INTO "voyages" VALUES (3883, '', 6, '', 'WILDRIJK', 'Pieter Clement', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1763-10-28', 'Texel', '1764-02-08', '1764-03-19', true, '1764-05-31', 'Batavia', NULL, 'From 07 till 10-11-1763 the WILDRIJK was at Duins. In 1766 the ship was sold in the Indies.');
INSERT INTO "voyages" VALUES (3884, '', 7, '', 'IMMAGONDA', 'Pieter Boot', 850, NULL, '1746', NULL, NULL, 'E', 'E', '1763-11-07', 'Texel', '1764-02-09', '1764-03-03', true, '1764-05-13', 'Batavia', NULL, 'In 1766 the IMMAGONDA was laid up in the Indies.');
INSERT INTO "voyages" VALUES (3885, '', 5, '', 'LUXEMBURG', 'Jan Beys', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1763-11-14', 'Texel', '1764-03-06', '1764-03-27', true, '1764-05-30', 'Batavia', 7690, 'deserted.');
INSERT INTO "voyages" VALUES (3886, '', 5, '', 'BOSSCHENHOVE', 'Pieter Sijbrandz. Flout', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1763-12-14', 'Texel', '1764-04-09', '1764-04-25', true, '1764-07-11', 'Batavia', NULL, 'From 29-01 till 03-02-1764 the ship was at S. Tiago: one seafarer deserted. On 12-01-1770 the BOSSCHENHOVE was laid up and sold in the Indies.');
INSERT INTO "voyages" VALUES (3887, '', 3, '', 'SCHOONZICHT', 'Kornelis van der Stam', 880, NULL, '1758', NULL, NULL, 'R', 'A', '1763-12-14', 'Texel', '1764-05-15', '1764-06-08', true, '1764-08-23', 'Bengal', 7706, NULL);
INSERT INTO "voyages" VALUES (3888, '', 4, '', 'VELSEN', 'Hendrik Andries Tieding', 1100, NULL, '1756', NULL, NULL, 'A', 'A', '1763-12-14', 'Texel', '1764-05-15', '1764-06-26', true, '1764-09-05', 'Batavia', 7720, 'The VELSEN called at S. Tiago (02 till 14-02-1764): 23 seafarers and 9 soldiers deserted or died.');
INSERT INTO "voyages" VALUES (3889, '', 1, '', 'WESTFRIESLAND', 'Bernard Hulleman', 880, NULL, '1761', NULL, NULL, 'H', 'H', '1763-12-14', 'Texel', '1764-05-15', '1764-06-26', true, '1764-08-29', 'Batavia', 7691, 'The WESTFRIESLAND called at S. Tiago (probably from 29-01 till 03-02-1764): 2 seafarers and 6 soldiers deserted, one soldier died. The 2 passengers who embarked at the Cape were condemned persons.');
INSERT INTO "voyages" VALUES (3890, '', 5, '', 'LIEFDE', 'Gerrit de Mul', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1763-12-17', 'Texel', '1764-05-24', '1764-06-12', true, '1764-08-05', 'Ceylon', NULL, 'The LIEFDE called at Torbay (30-12-1763 till 16-01-1764) and at Portsmouth (20 till 29-01-1764). In 1768 the ship was laid up in the Indies.');
INSERT INTO "voyages" VALUES (3891, '', 4, '', 'SNOEK', 'J. H. Westkapelle', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1764-02-21', 'Rammekens', '1764-06-01', '1764-07-06', true, '1764-09-13', 'Batavia', 7674, 'The 27 seafarers who went ashore at the Cape included one deserter.');
INSERT INTO "voyages" VALUES (3892, '', 3, '', 'TORENVLIET', 'Christiaan Adriaanse', 1150, NULL, '1753', NULL, NULL, 'Z', 'Z', '1764-02-21', 'Rammekens', '1764-06-01', '1764-07-06', true, '1764-09-05', 'Batavia', NULL, 'The passenger was a female slave. 3892/- Is the third voyage of this ship, which during its two preceding voyages was called BARBARA THEODORA (numbers of the second voyage: 3779/7584).');
INSERT INTO "voyages" VALUES (3893, '', 4, '', 'WALCHEREN', 'Hans Kornelisz.', 1150, NULL, '1754', NULL, NULL, 'Z', 'Z', '1764-02-21', 'Rammekens', '1764-05-24', '1764-06-26', true, '1764-08-28', 'Batavia', 7722, NULL);
INSERT INTO "voyages" VALUES (3894, '', 5, '', 'OUDKARSPEL', 'Aldert Aalders', 1150, NULL, '1747', NULL, NULL, 'A', 'A', '1764-02-25', 'Texel', '1764-05-24', '1764-07-06', true, '1764-09-01', 'Batavia', NULL, 'On 11-01-1764 the OUDKARSPEL tried to sail out for the first time, but it returned to Texel the following day. In 1768 the ship was sold in the Indies.');
INSERT INTO "voyages" VALUES (3895, '', 6, '', 'VOSMAAR', 'Anthonie Leertouwer', 850, NULL, '1746', NULL, NULL, 'Z', 'Z', '1764-03-01', 'Rammekens', '1764-06-06', '1764-07-13', true, '1764-10-04', 'Batavia', 7687, 'From 23 till 28-03-1764 the VOSMAAR was at S. Tiago.');
INSERT INTO "voyages" VALUES (3896, '', 4, '', 'KATTENDIJKE', 'Leendert van der Linden', 880, NULL, '1750', NULL, NULL, 'Z', 'D', '1764-05-08', 'Goeree', '1764-09-23', '1764-10-17', true, '1764-12-31', 'Batavia', 7701, NULL);
INSERT INTO "voyages" VALUES (3897, '', 1, '', 'USSELMONDE', 'Arend van der Deuren', 880, NULL, '1762', NULL, NULL, 'R', 'R', '1764-05-08', 'Goeree', '1764-09-28', '1764-10-17', true, '1764-12-31', 'Batavia', 7787, NULL);
INSERT INTO "voyages" VALUES (3898, '', 5, '', 'ADMIRAAL DE RUYTER', 'Johan Nikolaas Herault', 1150, NULL, '1749', NULL, NULL, 'A', 'Z', '1764-05-10', 'Rammekens', '1764-10-10', '1764-11-22', true, '1765-02-20', 'Batavia', 7698, NULL);
INSERT INTO "voyages" VALUES (3899, '', 3, '', 'SCHOLTENBURG', 'George Jakob Meyer', 880, NULL, '1753', NULL, NULL, 'A', 'A', '1764-05-10', 'Texel', '1764-11-29', '1765-01-06', true, '1765-03-26', 'Batavia', 7702, 'called at the northern coast of Brazil, 05 till 19-08-1764.');
INSERT INTO "voyages" VALUES (3900, '', 4, '', 'VROUWE PETRONELLA MARIA', 'Jan van Eysden', 1100, NULL, '1755', NULL, NULL, 'A', 'A', '1764-05-17', 'Texel', '1764-10-04', '1764-11-04', true, '1765-01-16', 'Batavia', 7760, 'The VROUWE PETRONELLA MARIA called at Duins, 21 till 26-05-1764; one soldier was pressed by the English.');
INSERT INTO "voyages" VALUES (3901, '', 5, '', 'AMERONGEN', 'Jakob Pieter van Braam', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1764-05-18', 'Texel', '1764-09-25', '1764-10-23', true, '1764-12-29', 'Batavia', 3901, '/- Is the fifth voyage of this ship, which during its first two voyages was called ROZENBURG (numbers of the second voyage: 3642/7477), during its third voyage OVERNES (see 3700/7544), and during its last two voyages AMERONGEN (numbers of the fourth voyage: 3796/7638). In 1768 the ship was laid up in the Indies.');
INSERT INTO "voyages" VALUES (3902, '', 4, '', 'VOORLAND', 'Josua Hartman', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1764-05-26', 'Texel', '1764-12-29', '1765-02-22', true, '1765-06-06', 'Batavia', NULL, 'VOORLAND was laid up and sold in the Indies, 12-01-1770.');
INSERT INTO "voyages" VALUES (3903, '', 5, '', 'LYCOCHTON', 'Klaas Stuiver', 880, NULL, '1749', NULL, NULL, 'E', 'H', '1764-06-19', 'Texel', '1764-10-08', '1764-11-04', true, '1765-01-16', 'Batavia', 7692, 'LYCOCHTON took over one seafarer from the PIJLSWAART (see 3904).');
INSERT INTO "voyages" VALUES (3904, '', 4, '', 'PIJLSWAART', 'Hans Eggers', 880, NULL, '1752', NULL, NULL, 'H', 'E', '1764-06-19', 'Texel', '1764-10-15', '1764-11-28', true, NULL, NULL, NULL, 'On 24-02-1765 the PIJLSWAART, sailing near Batavia, caught fire in a thunderstorm and exploded. See also 3903.');
INSERT INTO "voyages" VALUES (3905, '', 1, '', 'DE JONGE SAMUEL', 'Johannes van Boom', 880, NULL, '1761', NULL, NULL, 'Z', 'Z', '1764-06-19', 'Rammekens', '1764-11-04', '1764-12-19', true, '1765-04-06', 'Batavia', 7726, 'Some of the persons who went ashore at the Cape were handed over to the law.');
INSERT INTO "voyages" VALUES (3906, '', 2, '', 'BURCH', 'Anthonie de Jong', 1150, NULL, '1760', NULL, NULL, 'Z', 'Z', '1764-08-10', 'Rammekens', '1764-12-22', '1765-01-27', true, '1765-04-06', 'Batavia', 7758, 'at Duins, 18 till 22-08-1764; one seafarer deserted.');
INSERT INTO "voyages" VALUES (3907, '', 1, '', 'SNELHEID', 'Elkel Juel', 120, 'hoeker', '1763', NULL, NULL, 'A', 'A', '1764-09-12', 'Texel', '1764-12-27', NULL, true, '1764-12-27', 'The Cape', NULL, 'The SNELHEID remained on service at the Cape.');
INSERT INTO "voyages" VALUES (3908, '', 3, '', 'BLEISWIJK', 'Bartholomeus Bigom', 880, NULL, '1756', NULL, NULL, 'D', 'D', '1764-10-07', 'Goeree', '1765-01-13', '1765-01-29', true, '1765-04-02', 'Batavia', 7711, NULL);
INSERT INTO "voyages" VALUES (3909, '', 3, '', 'NOORD-BEVELAND', 'Simon Rot', 1150, NULL, '1756', NULL, NULL, 'Z', 'A', '1764-10-08', 'Texel', '1765-01-15', '1765-01-29', true, '1765-05-02', 'Batavia', 7707, 'After having arrived at Batavia the NOORD-BEVELAND sailed on to China.');
INSERT INTO "voyages" VALUES (3910, '', 6, '', 'BAARZANDE', 'Gerrit Bartels', 850, NULL, '1745', NULL, NULL, 'H', 'E', '1764-11-15', 'Texel', '1765-02-12', '1765-02-28', true, '1765-05-23', 'Batavia', 7693, 'voyage was called JAGER (numbers of the third voyage: 3612/7453).');
INSERT INTO "voyages" VALUES (3911, '', 3, '', 'VROUWE GEERTRUIDA', 'Michiel Hendrik Kerke', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1764-11-15', 'Texel', '1765-02-24', '1765-04-14', true, '1765-06-19', 'Batavia', 7749, '08-10-1764 the VROUWE GEERTRUIDA sailed out for the first time, but it was forced by adverse wind to return to Texel two days later. One soldier died before the final date of departure.');
INSERT INTO "voyages" VALUES (3912, '', 3, '', 'OUDERAMSTEL', 'Jan Stuiver', 1100, NULL, '1758', NULL, NULL, 'A', 'A', '1764-11-15', 'Texel', '1765-02-19', '1765-03-25', true, '1765-06-16', 'Batavia', 7756, 'After the arrival of the ship at Batavia, its name was altered into AZIE (see 7756).');
INSERT INTO "voyages" VALUES (3913, '', 1, '', 'VREDENHOF', 'Willem van Braam', 1150, NULL, '1763', NULL, NULL, 'A', 'A', '1764-11-15', 'Texel', '1765-02-20', '1765-03-07', true, '1765-06-16', 'Batavia', 7708, '15-11-1764 Is the final date of departure of the VREDENHOF; on 08-10-1764 it sailed out for the first time, but it was forced by adverse wind to return to Texel two days later. After having arrived at Batavia the ship sailed on the China.');
INSERT INTO "voyages" VALUES (3914, '', 4, '', 'WELGELEGEN', 'Jurriaan Molensteen', 880, NULL, '1753', NULL, NULL, 'E', 'A', '1764-11-15', 'Texel', '1765-02-12', '1765-04-14', true, '1765-07-28', 'Bengal', 7745, NULL);
INSERT INTO "voyages" VALUES (3915, '', 1, '', 'COMPAGNIES WELVAREN', 'Arend Willemse', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1764-11-15', 'Texel', '1765-02-12', '1765-02-28', true, '1765-05-28', 'Batavia', 7746, NULL);
INSERT INTO "voyages" VALUES (3916, '', 1, '', 'WALENBURG', 'Erasmus de Vries', 880, NULL, '1764', NULL, NULL, 'R', 'R', '1764-11-16', 'Goeree', '1765-02-21', '1765-03-07', true, '1765-06-23', 'Batavia', 7710, 'After having arrived at Batavia the WALENBURG sailed on to China (arrival there in October).');
INSERT INTO "voyages" VALUES (3917, '', 1, '', 'PALLAS', 'Jakob Boekhout', 1150, NULL, '1762', NULL, NULL, 'Z', 'Z', '1764-11-20', 'Rammekens', '1765-03-02', '1765-03-19', true, '1765-06-24', 'Batavia', 7709, 'arrived at Batavia the ship sailed on to China (arrival there in October).');
INSERT INTO "voyages" VALUES (3918, '', 2, '', 'WESTERVELD', 'Lieve van Rentergem', 1100, NULL, '1761', NULL, NULL, 'A', 'Z', '1764-11-20', 'Rammekens', '1765-03-01', '1765-04-14', true, '1765-06-19', 'Ceylon', 7737, NULL);
INSERT INTO "voyages" VALUES (3919, '', 5, '', 'OOSTHUIZEN', 'Pieter Klinkert', 850, NULL, '1749', NULL, NULL, 'H', 'H', '1764-11-23', 'Texel', '1765-04-13', '1765-04-27', true, '1765-07-17', 'Batavia', NULL, 'The OOSTHUIZEN called at S. Tiago, 02 till 09-01-1765: 3 seafarers deserted, one seafarer, 3 soldiers and 2 craftsmen died. The ship was laid up in the Indies, 09-01-1772.');
INSERT INTO "voyages" VALUES (3920, '', 4, '', 'DE DRIE PAPEGAAIEN', 'Frederik Visser', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1764-12-17', 'Texel', '1765-04-13', '1765-04-27', true, '1765-07-02', 'Ceylon', NULL, 'The DRIE PAPEGAAIEN was laid up in the Indies, 27-12-1768.');
INSERT INTO "voyages" VALUES (3921, '', 1, '', 'LANDSKROON', 'Volkert Groeneweg van Oudshoom', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1764-12-18', 'Texel', '1765-05-05', '1765-05-17', true, '1765-08-13', 'Batavia', 7770, 'From 26-01 till 05-02-1765 the LANDSKROON was at S. Tiago: 2 seafarers and 5 soldiers went missing, one seafarer was taken over from another ship. At Bantam 26 soldiers went ashore (30-07).');
INSERT INTO "voyages" VALUES (3922, '', 3, '', 'OVERNES', 'Pietersen', 1150, NULL, '1754', NULL, NULL, 'A', 'A', '1764-12-18', 'Texel', '1765-05-03', '1765-05-17', true, '1765-07-04', 'Ceylon', 7703, '3922/7703 Is the third voyage of this ship, which during its first voyage was called AMERONGEN (see 3664/7555).');
INSERT INTO "voyages" VALUES (3923, '', 4, '', 'VLIETLUST', 'Laurens Houtepen', 1150, NULL, '1752', NULL, NULL, 'A', 'Z', '1765-02-01', 'Rammekens', '1765-05-08', '1765-05-17', true, '1765-07-04', 'Ceylon', 7736, 'soldiers,');
INSERT INTO "voyages" VALUES (3924, '', 1, '', 'VREEBURG', 'Frans van Ewijk', 850, NULL, '1764', NULL, NULL, 'D', 'D', '1765-04-17', 'Goeree', '1765-08-17', '1765-09-08', true, '1765-11-16', 'Batavia', 7721, 'The VREEBURG called at Duins, 18 till 20-04-1765.');
INSERT INTO "voyages" VALUES (3925, '', 6, '', 'NOORD NIEUWLAND', 'Jakob Hart', 880, NULL, '1749', NULL, NULL, 'R', 'Z', '1765-04-20', 'Rammekens', '1765-08-12', '1765-09-02', true, '1765-11-16', 'Batavia', 7719, 'The NOORDNIEUWLAND did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3926, '', 2, '', 'HUIS TE BIJWEG', 'Johan Sigismund Hoeve', 1100, NULL, '1760', NULL, NULL, 'A', 'A', '1765-05-01', 'Texel', '1765-08-25', '1765-09-23', true, '1765-12-21', 'Batavia', 7740, 'S, Tiago: one seafarer and one soldier died, 9 seafarers and 2 soldiers deserted, At the Cape one seafarer and one soldier died.');
INSERT INTO "voyages" VALUES (3927, '', 7, '', 'SLOTEN', 'Andries Lint', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1765-05-01', 'Texel', '1765-08-26', '1765-09-23', true, '1765-12-18', 'Batavia', NULL, 'The SLOTEN called at S. Tiago, 28-05 till 10-06-1765; 2 seafarers and 2 soldiers died, one soldier deserted. At the Cape 2 seafarers and 2 soldiers died, one soldier deserted, The SLOTEN was laid up in the Indies, 31-12-1768.');
INSERT INTO "voyages" VALUES (3928, '', 5, '', 'BLIJDORP', 'Marten Hakker', 880, NULL, '1753', NULL, NULL, 'R', 'R', '1765-05-02', 'Goeree', '1765-08-04', '1765-08-19', true, '1765-10-18', 'Batavia', 7705, 'The 3 passengers were former (female) slaves, The BLIJDORP did not call at the Cape but at False Bay. The ship also called at Bantam (14-10-1765), where 24 soldiers disembarked.');
INSERT INTO "voyages" VALUES (3929, '', 1, '', 'LINDENHOF', 'Hans Bruns', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1765-06-18', 'Texel', '1765-11-03', '1765-12-05', true, '1766-02-26', 'Batavia', NULL, 'the Cape Pieter Anthonie van der Burg succeeded Hans Bruns as master of the LINDENHOF. At the Cape 2 seafarers and 3 soldiers died. After having arrived at Batavia the ship sailed on to China, Sailing to China the LINDENHOF was struck by lightning and exploded, 1766.');
INSERT INTO "voyages" VALUES (3930, '', 5, '', 'NIEUW NIEUWERKERK', 'Dirk Klinkert', 1150, NULL, '1749', NULL, NULL, 'Z', 'A', '1765-06-18', 'Texel', '1765-10-13', '1765-11-04', true, '1766-01-31', 'Batavia', NULL, 'The 22 seafarers who went ashore at the Cape included one deserter; one soldier died at the Cape. The NIEUW NIEUWERKERK was laid up and sold in the Indies, 14-04-1772.');
INSERT INTO "voyages" VALUES (3931, '', 1, '', 'JONKVROUWE KORNELIA JAKOBA', 'Pieter de Leur', 880, NULL, '1763', NULL, NULL, 'H', 'E', '1765-07-14', 'Texel', '1765-11-22', '1765-12-12', true, '1766-03-27', 'Batavia', 7732, 'KORNELIA JAKOBA called at S. Tiago, 19 till 26-08-1765; 4 seafarers and 4 soldiers deserted; one passenger embarked (he went ashore at the Cape), At the Cape one soldier died.');
INSERT INTO "voyages" VALUES (3932, '', 5, '', 'VRIJBURG', 'Karel Sluiter', 1150, NULL, '1748', NULL, NULL, 'Z', 'Z', '1765-08-04', 'Rammekens', '1765-12-25', '1766-02-04', true, '1766-05-10', 'Batavia', NULL, 'The VRIJBURG called at Duins, 06 till 16-08-1765, At the Cape 6 seafarers, 10 soldiers and 3 craftsmen died. The VRIJBURG was laid up in the Indies, 16-10-1771.');
INSERT INTO "voyages" VALUES (3933, '', 1, '', 'BARTHA PETRONELLA', 'Leendert van Koopstad', 880, NULL, '1764', NULL, NULL, 'H', 'H', '1765-08-19', 'Texel', '1766-01-13', '1766-02-03', true, '1766-05-10', 'Batavia', 7729, 'English seafarers came aboard. After having arrived at Batavia the BARTHA PETRONELLA sailed on to China.');
INSERT INTO "voyages" VALUES (3934, '', 1, '', 'POPKENSBURG', 'Jakob Reysik', 880, NULL, '1763', NULL, NULL, 'Z', 'Z', '1765-09-10', 'Rammekens', '1766-02-24', '1766-04-07', true, '1766-07-03', 'Batavia', 7794, 'At the Cape Jakob Reysik went ashore; his successor as master of the POPKENSBURG, Jan Canvas, embarked there, During the call at the Cape 8 seafarers, 10 soldiers and one craftsmen died, one seafarer and one craftsmen deserted.');
INSERT INTO "voyages" VALUES (3935, '', 1, '', 'JONGE THOMAS', 'Jakob Wiebe', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1765-10-25', 'Texel', '1766-03-12', '1766-03-28', true, '1766-06-25', 'Batavia', 7728, 'soldier died at the Cape. After having arrived at Batavia the JONGE THOMAS sailed on to China,');
INSERT INTO "voyages" VALUES (3936, '', 3, '', 'VROUWE ELISABETH DOROTHEA', 'Willem Groeve', 600, NULL, '1757', NULL, NULL, 'A', 'A', '1765-11-15', 'Texel', '1766-03-04', '1766-03-20', true, '1766-06-24', 'Batavia', 7738, 'was back at Texel (12-10); on 25-10 the ship sailed out for the second time, adverse wind, however, again forced it to return to Texel (31-10); 15-11 is the third and final date of departure. The VROUWE ELISABETH DOROTHEA replaced the BRONSTEE, missing in 1763 between Batavia and the Cape, see 7648,');
INSERT INTO "voyages" VALUES (3937, '', 6, '', 'KIEVITSHEUVEL', 'Frans Overzee', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1765-11-15', 'Texel', '1766-03-03', '1766-04-11', true, '1766-06-24', 'Batavia', NULL, 'KIEVITSHEUVEL was laid up in the Indies, 22-12-1768.');
INSERT INTO "voyages" VALUES (3938, '', 1, '', 'ZILVEREN LEEUW', 'Gerrit Harmeyer', 880, NULL, '1765', NULL, NULL, 'D', 'D', '1765-11-15', 'Goeree', '1766-02-22', '1766-03-14', true, '1766-06-07', 'Batavia', 7718, NULL);
INSERT INTO "voyages" VALUES (3939, '', 3, '', 'JONGE LIEVE', 'Hendrik de Haard', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1765-11-15', 'Texel', '1766-03-14', '1766-04-22', true, '1766-07-02', 'Batavia', 7730, 'From 03 till 12-01-1766 the JONGE LIEVE was at S. Tiago: 3 seafarers and one passenger died, 3 seafarers and 2 soldiers deserted. At the Cape one soldier died,');
INSERT INTO "voyages" VALUES (3940, '', 1, '', 'NIEUW RHOON', 'Abraham in ''t Anker', 1150, NULL, '1764', NULL, NULL, 'Z', 'Z', '1765-11-15', 'Rammekens', '1766-03-19', '1766-04-03', true, '1766-06-12', 'Batavia', 7727, 'At the Cape 5 seafarers and 3 soldiers died. After having arrived at Batavia the NIEUW RHOON sailed on to China,');
INSERT INTO "voyages" VALUES (3941, '', 5, '', 'SNOEK', 'Johan Hendriksz.', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1765-11-15', 'Rammekens', '1766-03-26', '1766-04-07', true, '1766-06-26', 'Batavia', 7735, NULL);
INSERT INTO "voyages" VALUES (3942, '', 1, '', 'VREDELUST', 'Martin Meytens', 1150, NULL, '1765', NULL, NULL, 'A', 'A', '1765-11-15', 'Texel', '1766-03-26', '1766-04-16', true, '1766-07-07', 'Batavia', 7809, 'seafarer, 2 soldiers and one craftsmen died.');
INSERT INTO "voyages" VALUES (3943, '', 5, '', 'VREDESTEIN', 'Jochem Hendrik Dodendorp', 880, NULL, '1750', NULL, NULL, 'R', 'R', '1765-11-15', 'Goeree', '1766-03-13', '1766-03-28', true, '1766-06-24', 'Batavia', 7733, 'The ''passenger'' was a slave. At the Cape one soldier died.');
INSERT INTO "voyages" VALUES (3944, '', 4, '', 'ORANJEZAAL', 'Frederik Kelger', 880, NULL, '1750', NULL, NULL, 'E', 'A', '1765-12-01', 'Texel', '1766-03-05', '1766-04-16', true, '1766-08-04', 'Bengal', 7724, NULL);
INSERT INTO "voyages" VALUES (3945, '', 4, '', 'VROUWE PETRONELLA', 'Steven Booms', 880, NULL, '1755', NULL, NULL, 'E', 'E', '1765-12-01', 'Texel', '1766-03-15', '1766-04-03', true, '1766-06-21', 'Batavia', NULL, 'Ganges, 11-01-1768.');
INSERT INTO "voyages" VALUES (3946, '', 2, '', 'BORSSELE', 'Pieter Fruit', 1150, NULL, '1758', NULL, NULL, 'Z', 'A', '1765-12-29', 'Texel', '1766-04-08', '1766-04-27', true, '1766-07-03', 'Batavia', 7766, NULL);
INSERT INTO "voyages" VALUES (3947, '', 6, '', 'GOUVERNEUR-GENERAAL', 'Pieter Andriesz.', 850, NULL, '1749', NULL, NULL, 'D', 'A', '1765-12-29', 'Texel', '1766-04-07', '1766-04-22', true, '1766-06-20', 'Ceylon', 7734, NULL);
INSERT INTO "voyages" VALUES (3948, '', 2, '', 'HUIS OM', 'Elkel Juel', 1150, NULL, '1761', NULL, NULL, 'Z', 'A', '1765-12-29', 'Texel', '1766-04-15', '1766-05-04', true, '1766-06-24', 'Ceylon', 7723, NULL);
INSERT INTO "voyages" VALUES (3949, '', 1, '', 'ZONNESTEIN', 'Jakob Barendsz.', 1150, NULL, '1765', NULL, NULL, 'A', 'A', '1765-12-29', 'Texel', '1766-04-21', '1766-05-04', true, '1766-07-12', 'Batavia', NULL, 'remained on service in the interasiatic trade, carrying rice between Batavia and the Cape. During one of such voyages, sailing from the Cape to Batavia, the transport-ship was wrecked, January 1768.');
INSERT INTO "voyages" VALUES (3950, '', 3, '', 'DUINENBURG', 'Helmstrom', 1100, NULL, '1757', NULL, NULL, 'Z', 'Z', '1766-02-08', 'Rammekens', '1766-05-14', '1766-07-15', true, '1766-09-20', 'Batavia', 7741, 'The DUINENBURG did not call at the Cape but at False Bay. Between patria and False Bay a mutiny broke out, which was suppressed. The 74 persons who disembarked at False Bay included a number of mutineers; they were handed over to the law.');
INSERT INTO "voyages" VALUES (3951, '', 4, '', 'VLISSINGEN', 'Dirk Wagtels', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1766-03-12', 'Rammekens', '1766-06-28', '1766-07-21', true, '1766-09-23', 'Batavia', 7778, 'The VLISSINGEN did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (3952, '', 5, '', 'ERFPRINS', 'Simon van Dalen', 850, NULL, '1752', NULL, NULL, 'D', 'D', '1766-04-06', 'Goeree', NULL, NULL, true, NULL, NULL, NULL, 'voyage: 3696/7518). See also 3985.');
INSERT INTO "voyages" VALUES (3953, '', 3, '', 'ASCHAT', 'Willem Silvester', 1150, NULL, '1760', NULL, NULL, 'A', 'A', '1766-04-25', 'Texel', '1766-11-01', '1766-11-26', true, '1767-01-30', 'Batavia', 7792, 'craftsmen went ashore at the Cape; 41 seafarers, 38 soldiers, and 7 craftsmen died during the voyage.');
INSERT INTO "voyages" VALUES (3954, '', 2, '', 'VROUWE KORNELIA HILLEGONDA', 'Christiaan Wijsbaard', 850, NULL, '1760', NULL, NULL, 'D', 'A', '1766-04-25', 'Goeree', '1766-08-15', '1766-09-17', true, '1766-12-03', 'Batavia', 7748, 'According to a Resolution of 15-10-1765 the VROUWE KORNELIA HILLEGONDA transported many soldiers to the Cape.');
INSERT INTO "voyages" VALUES (3955, '', 1, '', 'BLEIJENBURG', 'Frederik Wielard', 880, NULL, '1765', NULL, NULL, 'R', 'R', '1766-04-30', 'Goeree', '1766-08-20', '1766-09-17', true, '1766-12-03', 'Batavia', 7785, NULL);
INSERT INTO "voyages" VALUES (3956, '', 2, '', '''S LANDS WELVAREN', 'Michiel Hamelo', 880, NULL, '1762', NULL, NULL, 'A', 'A', '1766-04-30', 'Goeree', '1766-08-20', '1766-09-11', true, '1766-11-25', 'Batavia', 7731, NULL);
INSERT INTO "voyages" VALUES (3957, '', 1, '', 'VELDHOEN', 'Mulder', 1150, NULL, '1765', NULL, NULL, 'A', 'A', '1766-05-17', 'Texel', '1766-09-16', '1766-09-30', true, '1766-12-18', 'Batavia', 7773, 'During the voyage of the VELDHOEN one soldier became seafarer.');
INSERT INTO "voyages" VALUES (3958, '', 7, '', 'VOSMAAR', 'Kornelis Pietersen', 850, NULL, '1746', NULL, NULL, 'Z', 'Z', '1766-05-17', 'Rammekens', '1766-09-07', '1766-09-25', true, '1766-12-18', 'Batavia', NULL, 'The VOSMAAR was laid up in the Indies, 25-02-1772.');
INSERT INTO "voyages" VALUES (3959, '', 6, '', 'LUXEMBURG', 'Klaas Roem', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1766-06-25', 'Texel', '1766-12-08', '1767-01-01', true, '1767-06-24', 'Batavia', NULL, 'died; 3 seafarers and one soldier died at Duins; at S. Tiago 6 seafarers, 8 soldiers, and one craftsmen died, 14 seafarers, 10 soldiers, and one craftsmen deserted; at the Cape 458 seafarers, 352 soldiers, 19 craftsmen, and 5 passengers went ashore; during the voyage 388 seafarers, 450 soldiers, 41 craftsmen, and 4 passengers died; 2884 seafarers, 1045 soldiers, 105 craftsmen, and 28 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (3960, '', 6, '', 'STRALEN', 'Marten Pietersz. Mooy', 850, NULL, '1748', NULL, NULL, 'E', 'H', '1766-06-25', 'Texel', '1766-12-08', '1767-01-01', true, '1767-04-14', 'Batavia', 7811, 'See the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3961, '', 1, '', 'VAILLANT', 'Thomas van Wagtendonk', 880, NULL, '1764', NULL, NULL, 'E', 'E', '1766-07-11', 'Texel', '1767-01-27', '1767-03-31', true, '1767-06-26', 'Batavia', NULL, 'ASCHAT (3953).');
INSERT INTO "voyages" VALUES (3962, '', 5, '', 'JERUSALEM', 'Jan Karel Schacht', 880, NULL, '1752', NULL, NULL, 'R', 'A', '1766-08-02', 'Texel', '1766-11-23', '1766-12-09', true, '1767-03-04', 'Batavia', 7763, 'See the ASCHAT (3953).');
INSERT INTO "voyages" VALUES (3963, '', 5, '', 'RUITEVELD', 'Karsten Vink', 1150, NULL, '1752', NULL, NULL, 'A', 'Z', '1766-08-22', 'Rammekens', '1767-01-08', '1767-01-26', true, '1767-05-04', 'Batavia', 7750, 'After having called at Batavia, the RUITEVELD sailed on to Ceylon. See the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3964, '', 3, '', 'LEKKERLUST', 'Bernard Hulleman', 880, NULL, '1755', NULL, NULL, 'H', 'H', '1766-09-22', 'Texel', '1767-01-19', '1767-03-10', true, '1767-06-15', 'Batavia', 7742, 'See the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3965, '', 7, '', 'HUIS TEN DONK', 'Jan Moorland', 875, NULL, '1745', NULL, NULL, 'R', 'A', '1766-09-24', 'Texel', '1766-12-30', '1767-01-17', true, '1767-04-16', 'Batavia', NULL, 'See the ASCHAT (3953). The HUIS TEN DONK was laid up and sold in the Indies, 12-01-1770.');
INSERT INTO "voyages" VALUES (3966, '', 1, '', 'GEINWENS', 'Kornelis Kuiper', 1100, NULL, '1765', NULL, NULL, 'A', 'A', '1766-09-24', 'Texel', '1767-01-11', '1767-02-04', true, '1767-05-07', 'Batavia', 7753, 'After having called at Batavia, the GEINWENS sailed on to China. See the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3967, '', 1, '', 'RITTHEM', 'Jakob de Frein', 880, NULL, '1764', NULL, NULL, 'Z', 'Z', '1766-09-25', 'Rammekens', '1767-01-05', '1767-01-20', true, '1767-05-21', 'Batavia', 7744, 'See the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3968, '', 1, '', 'VROUWE ANTHOINETTA KOENRARDINA', 'Abraham van Leeuwen', 880, NULL, '1765', NULL, NULL, 'D', 'D', '1766-10-01', 'Goeree', '1766-12-30', '1767-01-10', true, '1767-04-15', 'Batavia', 7755, 'Specified data concerning the crew of the VROUWE ANTHOINETTA KOENRARDINA: 196 seafarers, 88 soldiers, and 17 craftsmen departed from Goeree or embarked at the Cape. See the ASCHAT (3953).');
INSERT INTO "voyages" VALUES (3969, '', 1, '', 'GANZENHOEF', 'Thijs Fierman', 880, NULL, '1765', NULL, NULL, 'A', 'A', '1766-10-01', 'Texel', '1766-12-31', '1767-01-10', true, '1767-03-21', 'Batavia', 7751, 'After having called at Batavia, the GANZENHOEF sailed on to China. See the ASCHAT (3953).');
INSERT INTO "voyages" VALUES (3970, '', 2, '', 'VREDENHOF', 'Aldert Aldertsz.', 1150, NULL, '1763', NULL, NULL, 'A', 'A', '1766-10-01', 'Texel', '1766-12-29', '1767-01-10', true, '1767-05-07', 'Batavia', NULL, 'See the LUXEMBURG (3959). In 1768 the VREDENHOF, sailing to Japan, was wrecked.');
INSERT INTO "voyages" VALUES (3971, '', 3, '', 'VROUWE ELISABETH', 'Anthonie Leertouwer', 850, NULL, '1755', NULL, NULL, 'R', 'R', '1766-10-08', 'Goeree', '1767-01-12', '1767-01-23', true, '1767-04-14', 'Batavia', 7757, 'Specified data concerning the crew of the VROUWE ELISABETH: 196 seafarers, 89 soldiers, and 17 craftsmen departed from Goeree or embarked at the Cape. See the ASCHAT (3953).');
INSERT INTO "voyages" VALUES (3972, '', 1, '', 'HERTOG VAN BRUNSWIJK', 'Jan Schellinger', 1150, NULL, '1765', NULL, NULL, 'A', 'A', '1766-10-10', 'Texel', '1767-03-05', '1767-03-22', true, '1767-06-18', 'Batavia', NULL, 'See the LUXEMBURG (3959). On 31-08-1769 the HERTOG VAN BRUNSWIJK ran ashore between Navekarre and Kalpitiya.');
INSERT INTO "voyages" VALUES (3973, '', 2, '', 'WESTFRIESLAND', 'Kornelis Pietersen', 880, NULL, '1761', NULL, NULL, 'H', 'A', '1766-10-16', 'Texel', '1767-03-14', '1767-04-09', true, '1767-06-26', 'Batavia', 7739, 'See the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3974, '', 1, '', 'VROUWE MARGARETHA MARIA', 'Arie Arkebout', 880, NULL, '1765', NULL, NULL, 'E', 'E', '1766-11-07', 'Texel', '1767-03-15', '1767-03-24', true, '1767-06-18', 'Batavia', 7754, 'After having arrived at Batavia, the VROUWE MARGARETHA MARIA sailed on to China. See the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3975, '', 2, '', 'PALLAS', 'Jakob Boekhout', 1150, NULL, '1762', NULL, NULL, 'Z', 'Z', '1766-11-07', 'Rammekens', '1767-04-02', '1767-04-09', true, '1767-06-28', 'Batavia', 7752, 'After having arrived at Batavia, the PALLAS sailed on to China. See the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3976, '', 5, '', 'KEUKENHOF', 'George Jakob Meyer', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1766-12-01', 'Texel', '1767-03-05', '1767-03-22', true, '1767-05-28', 'Batavia', NULL, 'On 21-11-1766 the KEUKENHOF initially put to sea; the next day, however, the ship returned to Texel; 01-12-1766 is its final date of departure. The KEUKENHOF was laid up in the Indies, 31-12-1770. See the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3977, '', 6, '', 'LYCOCHTON', 'Jan Balthus Meyer', 880, NULL, '1749', NULL, NULL, 'E', 'H', '1766-12-08', 'Texel', '1767-04-02', '1767-04-19', true, '1767-06-29', 'Batavia', 7743, 'See the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3978, '', 4, '', 'NOORD-BEVELAND', 'Michiel Hendrik Wunder', 1150, NULL, '1756', NULL, NULL, 'Z', 'A', '1766-12-25', 'Texel', '1767-03-23', '1767-04-09', true, '1767-06-28', 'Ceylon', 7759, NULL);
INSERT INTO "voyages" VALUES (3979, '', 4, '', 'SCHOLTENBURG', 'Pieter Clement', 880, NULL, '1753', NULL, NULL, 'A', 'A', '1766-12-25', 'Texel', '1767-03-15', '1767-04-09', true, '1767-08-01', 'Bengal', 7777, NULL);
INSERT INTO "voyages" VALUES (3980, '', 4, '', 'SCHOONZICHT', 'Albert Kikkert', 880, NULL, '1758', NULL, NULL, 'R', 'A', '1766-12-25', 'Texel', '1767-03-27', '1767-04-19', true, '1767-06-27', 'Ceylon', 7761, NULL);
INSERT INTO "voyages" VALUES (3981, '', 1, '', 'AZIE', 'Michiel Godfried Lehman', 1100, NULL, '1765', NULL, NULL, 'Z', 'Z', '1766-12-29', 'Rammekens', '1767-04-08', '1767-04-26', true, '1767-07-01', 'Batavia', 7747, 'After the arrival of the ship at Batavia, its name was altered into OUDERAMSTEL (see 7747, etc.). See the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3982, '', 7, '', 'BAARZANDE', 'Jan Rondekrans', 850, NULL, '1745', NULL, NULL, 'H', 'E', '1767-01-06', 'Texel', '1767-06-03', '1767-06-21', true, '1767-08-16', 'Batavia', 3982, '/- Is the seventh voyage of this ship, which during its first two voyages and the outward part of its third voyage was called JAGER (numbers of the third voyage: 3612/7453). The BAARZANDE was laid up and sold in the Indies, 12-01-1770. See the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3983, '', 4, '', 'TULPENBURG', 'Jan Beys', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1767-01-06', 'Texel', '1767-05-19', '1767-06-21', true, '1767-08-21', 'Batavia', NULL, 'was laid up in the Indies, 31-12-1773. See the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3984, '', 6, '', 'ADMIRAAL DE RUYTER', 'Kornelis van der Putte+', 1150, NULL, '1749', NULL, NULL, 'A', 'Z', '1767-01-17', 'Rammekens', '1767-07-31', '1767-09-10', true, '1767-12-12', 'Ceylon', NULL, 'In November 1767 Kornelis van der Putte was drowned. The ADMIRAAL DE RUYTER was laid up and sold in the Indies, 06-01-1773.');
INSERT INTO "voyages" VALUES (3985, '', 4, '', 'ERFPRINS', 'Thomas de Beukelaar', 880, NULL, '1754', NULL, NULL, 'D', 'D', '1767-03-26', 'Goeree', '1767-07-14', '1767-08-09', true, '1767-10-17', 'Batavia', 7769, '3985/7769 Is the fourth voyage of this ship, which during its first three voyages was called ''S GRAVENZANDE (numbers of the third voyage: 3869/7695). The ERFPRINS replaced the former ERFPRINS (see 3952). See also the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3986, '', 6, '', 'BLIJDORP', 'Lodewijk Thomasz.', 880, NULL, '1753', NULL, NULL, 'R', 'Z', '1767-04-05', 'Rammekens', '1767-07-16', '1767-08-01', true, '1767-10-03', 'Batavia', 7765, 'See the LUXEMBURG (3959).');
INSERT INTO "voyages" VALUES (3987, '', 3, '', 'DAMZICHT', 'Volkert Groeneweg van Oudshoorn', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1767-05-16', 'Texel', '1767-12-17', '1768-02-20', true, '1768-06-16', 'Batavia', 7788, 'seafarer and one soldier died, one seafarer and 8 soldiers deserted; at the Cape 561 seafarers, 377 soldiers, 25 craftsmen, and one passenger went ashore; during the voyage 424 seafarers, 267 soldiers, and 41 craftsmen died.');
INSERT INTO "voyages" VALUES (3988, '', 4, '', 'LAPIENENBURG', 'Hendrik Jakob Beeld', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1767-05-16', 'Texel', '1767-09-08', '1767-09-27', true, '1767-11-26', 'Batavia', NULL, '3989) and the NIJENBORG (3993): 535 seafarers, 283 soldiers, 29 craftsmen, and 3 passengers departed from the Republic or embarked at the Cape; 465 seafarers, 233 soldiers, 22 craftsmen, and 3 passengers arrived at Batavia. Data concerning both the aforesaid three ships and the WALENBURG (3990) and the BLEISWIJK (3991): 5 seafarers ans 2 soldiers deserted at S. Tiago; at the Cape 95 seafarers, 65 soldiers, and 12 craftsmen disembarked; during the voyage 46 seafarers, 36 soldiers, and 7 craftsmen died.');
INSERT INTO "voyages" VALUES (3989, '', 4, '', 'OVERNES', 'Willem van Braam', 1150, NULL, '1754', NULL, NULL, 'A', 'A', '1767-05-16', 'Texel', '1767-08-24', '1767-09-08', true, '1767-11-24', 'Batavia', NULL, 'See the LAPIENENBURG (3988). 3989/- Is the fourth voyage of this ship, which during its first voyage (3664/7556) was called AMERONGEN. The ship was laid up in the Indies, 09-01-1772.');
INSERT INTO "voyages" VALUES (3990, '', 2, '', 'WALENBURG', 'Erasmus de Vries', 880, NULL, '1764', NULL, NULL, 'R', 'R', '1767-05-16', 'Goeree', '1767-10-02', '1767-10-22', true, '1767-12-26', 'Batavia', 7774, 'Specified data concerning the crew of the WALENBURG: 143 seafarers, 57 soldiers, and 15 craftsmen departed from Goeroe or embarked at the Cape. See the LAPIENENBURG (3988).');
INSERT INTO "voyages" VALUES (3991, '', 4, '', 'BLEISWIJK', 'Kornelis van Brattem', 880, NULL, '1756', NULL, NULL, 'D', 'D', '1767-06-10', 'Goeree', '1767-09-07', '1767-10-21', true, '1767-12-26', 'Batavia', 7762, 'Specified data concerning the crew of the BLEISWIJK: 190 seafarers, 96 soldiers, 21 craftsmen, and 4 passengers departed from Goeree or embarked at the Cape. See the LAPIENENBURG (3988).');
INSERT INTO "voyages" VALUES (3992, '', 3, '', 'LEIMUIDEN', 'Thomas Brunel', 1150, NULL, '1755', NULL, NULL, 'A', 'A', '1767-06-10', 'Texel', '1767-10-04', '1767-11-19', true, '1768-03-07', 'Batavia', 7789, NULL);
INSERT INTO "voyages" VALUES (3993, '', 3, '', 'NIJENBORG', 'J. Arkerklauw', 880, NULL, '1757', NULL, NULL, 'H', 'A', '1767-06-10', 'Texel', '1767-10-08', '1767-10-24', true, '1768-01-05', 'Batavia', 7784, 'See the LAPIENENBURG (3988).');
INSERT INTO "voyages" VALUES (3994, '', 4, '', 'HUIS TE BOEDE', 'Johan Nikolaas Herault', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1767-07-17', 'Rammekens', '1767-12-07', '1768-01-05', true, '1768-05-07', 'Batavia', NULL, 'seafarers, 271 soldiers, 26 craftsmen, and 6 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (3995, '', 5, '', 'KATTENDUKE', 'Abel Barber', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1767-07-17', 'Rammekens', '1767-11-30', '1767-12-19', true, '1768-03-04', 'Batavia', NULL, 'The KATTENDIJKE was laid up and sold in the Indies, 06-01-1773.');
INSERT INTO "voyages" VALUES (3996, '', 1, '', 'VROUWE MARIA JAKOBA', 'Klaas Ariensz.', 880, NULL, '1765', NULL, NULL, 'H', 'H', '1767-07-18', 'Texel', '1767-12-16', '1768-02-08', true, '1768-05-31', 'Batavia', 7807, '278 seafarers, 46 soldiers, and 13 craftsmen arrived at Batavia.');
INSERT INTO "voyages" VALUES (3997, '', 1, '', 'WILLEM DE VIJFDE', 'Jan Canvas', 1150, NULL, '1765', NULL, NULL, 'Z', 'Z', '1767-09-20', 'Rammekens', '1768-01-18', '1768-02-02', true, '1768-05-07', 'Batavia', 7782, 'sailed on to China. See the DAMZICHT (3987) and the HUIS TE BOEDE (3994).');
INSERT INTO "voyages" VALUES (3998, '', 5, '', 'SCHAGEN', 'Laurens Sprengler', 880, NULL, '1753', NULL, NULL, 'H', 'A', '1767-09-21', 'Texel', '1767-12-25', '1768-01-27', true, '1768-05-06', 'Batavia', 7799, 'See the DAMZICHT (3987).');
INSERT INTO "voyages" VALUES (3999, '', 2, '', 'JONGE THOMAS', 'Wopke Popta', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1767-09-21', 'Texel', '1767-12-24', '1768-01-09', true, '1768-03-27', 'Batavia', 7779, 'After having called at Batavia, the JONGE THOMAS sailed on to China,');
INSERT INTO "voyages" VALUES (4000, '', 1, '', 'WOESTDUIN', 'Jan Och', 1150, NULL, '1767', NULL, NULL, 'A', 'A', '1767-09-21', 'Texel', '1768-01-05', '1768-01-19', true, '1768-04-23', 'Batavia', 7780, 'After having called at Batavia, the WOESTDUIN sailed on to China.');
INSERT INTO "voyages" VALUES (4001, '', 3, '', 'HUIS OM', 'Jan van Dalen', 1150, NULL, '1761', NULL, NULL, 'Z', 'A', '1767-09-23', 'Texel', '1768-02-03', '1768-03-15', true, '1768-06-06', 'Batavia', 7793, 'See the DAMZICHT (3987).');
INSERT INTO "voyages" VALUES (4002, '', 1, '', 'HUIS TER MEIJEN', 'Jurriaan Molensteen', 1150, NULL, '1767', NULL, NULL, 'A', 'A', '1767-09-25', 'Texel', '1768-02-09', '1768-03-05', true, '1768-06-09', 'Batavia', 7821, 'See the DAMZICHT (3987).');
INSERT INTO "voyages" VALUES (4003, '', 1, '', 'PAUW', 'Gerrit Harmeyer', 850, NULL, '1767', NULL, NULL, 'D', 'D', '1767-10-12', 'Goeree', '1768-03-08', '1768-03-22', true, '1768-06-08', 'Batavia', 7781, 'concerning the crew of the PAUW: 190 seafarers, 78 soldiers, and 12 craftsmen departed from Goeree or embarked at the Cape. After having called at Batavia the ship sailed on to China. See the DAMZICHT (3987).');
INSERT INTO "voyages" VALUES (4004, '', 1, '', 'RIDDERKERK', 'Marten Hakker', 850, NULL, '1766', NULL, NULL, 'R', 'R', '1767-10-14', 'Goeree', '1768-03-08', '1768-03-22', true, '1768-06-12', 'Batavia', 7771, 'Specified data concerning the crew of the RIDDERKERK: 207 seafarers, 87 soldiers, 24 craftsmen, and one passenger departed from Goeree or embarked at the Cape. The ship called at Falmouth, 03 till 29-11-1767: 5 soldiers died. See the DAMZICHT (3987).');
INSERT INTO "voyages" VALUES (4005, '', 1, '', 'BOVENKERKER POLDER', 'Frederik Kelger', 850, NULL, '1765', NULL, NULL, 'A', 'A', '1767-11-24', 'Texel', '1768-04-02', '1768-04-29', true, '1768-07-15', 'Batavia', 7767, 'See the DAMZICHT (3987).');
INSERT INTO "voyages" VALUES (4006, '', 1, '', 'DUIVENBRUG', 'Jakob de Vries', 850, NULL, '1766', NULL, NULL, 'E', 'E', '1767-11-24', 'Texel', '1768-03-08', '1768-03-22', true, '1768-06-08', 'Batavia', 7768, 'Specified data concerning the crew of the DUIVENBRUG: 248 seafarers, 17 soldiers, 11 craftsmen, and one passenger departed from Texel or embarked at the Cape. See the DAMZICHT (3987).');
INSERT INTO "voyages" VALUES (4007, '', 3, '', 'KRONENBURG', 'Pieter Andriesz.', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1767-11-24', 'Texel', '1768-02-23', '1768-03-29', true, '1768-06-14', 'Batavia', NULL, 'See the DAMZICHT (3987).');
INSERT INTO "voyages" VALUES (4008, '', 4, '', 'JONGE LIEVE', 'Hendrik de Haard', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1767-11-24', 'Texel', '1768-03-19', '1768-04-05', true, '1768-06-08', 'Batavia', 7820, 'From 30-11 till 02-12-1767 the JONGE LIEVE was at Duins. See the DAMZICHT (3987).');
INSERT INTO "voyages" VALUES (4009, '', 3, '', '''S LANDS WELVAREN', 'Simon Bot', 880, NULL, '1762', NULL, NULL, 'A', 'A', '1767-12-02', 'Texel', '1768-03-27', '1768-04-23', true, '1768-08-01', 'Bengal', 7812, 'The ''S LANDS WELVAREN called at Duins, 15 till 21-12-1767.');
INSERT INTO "voyages" VALUES (4010, '', 2, '', 'BARTHA PETRONELLA', 'Kotnelis Brouwer', 880, NULL, '1764', NULL, NULL, 'H', 'H', '1767-12-20', 'Texel', '1768-04-06', '1768-04-23', true, '1768-07-07', 'Batavia', 7764, 'See the DAMZICHT (3987) and the VROUWE MARIA JAKOBA (3996).');
INSERT INTO "voyages" VALUES (4011, '', 5, '', 'VELSEN', 'Kornelis Bos', 1100, NULL, '1756', NULL, NULL, 'A', 'A', '1767-12-20', 'Texel', '1768-03-27', '1768-04-29', true, '1768-06-14', 'Ceylon', 7813, NULL);
INSERT INTO "voyages" VALUES (4012, '', 5, '', 'VLIETLUST', 'Frederik Sankwaart', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1767-12-20', 'Texel', '1768-04-02', '1768-04-29', true, '1768-12-07', 'Ceylon', NULL, 'The VLIETLUST was laid up in the Indies, 21-10-1774.');
INSERT INTO "voyages" VALUES (4013, '', 2, '', 'NIEUW RHOON', 'Jan Hendriks', 1150, NULL, '1764', NULL, NULL, 'Z', 'Z', '1767-12-21', 'Rammekens', '1768-04-06', '1768-05-03', true, '1768-06-15', 'Batavia', 7776, 'See the DAMZICHT (3987) and the HUIS TE BOEDE (3994).');
INSERT INTO "voyages" VALUES (4014, '', 3, '', 'ZUID-BEVELAND', 'Anthonie de Jong', 1100, NULL, '1755', NULL, NULL, 'Z', 'Z', '1767-12-21', 'Rammekens', '1768-04-12', '1768-05-13', true, '1768-07-16', 'Batavia', 7814, 'See the DAMZICHT (3987) and the HUIS TE BOEDE (3994).');
INSERT INTO "voyages" VALUES (4015, '', 2, '', 'JONGE SAMUEL', 'Jakob Hart', 880, NULL, '1761', NULL, NULL, 'Z', 'Z', '1768-03-06', 'Rammekens', '1768-06-14', '1768-07-02', true, '1768-09-09', 'Batavia', 7772, 'See the DAMZICHT (3987) and the HUIS TE BOEDE (3994).');
INSERT INTO "voyages" VALUES (4016, '', 2, '', 'ZILVEREN LEEUW', 'Willem Koelbier', 880, NULL, '1765', NULL, NULL, 'D', 'R', '1768-05-05', 'Goeree', '1768-08-08', '1768-08-31', true, '1768-10-22', 'Batavia', 7783, 'of the ORANJEZAAL (see 4017), the RENSWOUDE (4018), the VREDENSTEIN (4019), and the WESTERVELD (4021):94 seafarers, 69 soldiers, and 2 craftsmen went ashore at the Cape; during the voyage 34 seafarers, 22 soldiers, and one craftsmen died.');
INSERT INTO "voyages" VALUES (4017, '', 5, '', 'ORANJEZAAL', 'S. L. Klink', 880, NULL, '1750', NULL, NULL, 'E', 'A', '1768-05-07', 'Texel', '1768-08-14', '1768-09-19', true, '1768-12-18', 'Batavia', NULL, 'crew of the ORANJEZAAL as well as to the crews of the REN-SWOUDE (see 4018) and the VREDESTEIN (4019): 508 seafarers, 255 soldiers, 33 craftsmen, and 5 passengers departed from the Republic or embarked at the Cape; 450 seafarers, 219 soldiers, 32 craftsmen, and 5 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4018, '', 3, '', 'RENSWOUDE', 'Michiel Hamelo', 1150, NULL, '1756', NULL, NULL, 'A', 'A', '1768-05-07', 'Texel', '1768-08-10', '1768-08-31', true, '1768-11-06', 'Batavia', 7785, 'ORANJEZAAL (4017).');
INSERT INTO "voyages" VALUES (4019, '', 6, '', 'VREDESTEIN', 'Jan Abel', 880, NULL, '1750', NULL, NULL, 'R', 'A', '1768-05-13', 'Texel', '1768-09-12', '1768-10-08', true, '1768-12-27', 'Batavia', 7800, 'See the ZILVEREN LEEUW (4016) and the ORANJEZAAL (4017).');
INSERT INTO "voyages" VALUES (4020, '', 2, '', 'ENKHUIZEN', 'I. F. Hout', 880, NULL, '1760', NULL, NULL, 'E', 'A', '1768-05-15', 'Texel', '1768-10-28', '1768-11-15', true, '1769-01-27', 'Batavia', 7810, 'soldiers, and 18 craftsmen died.');
INSERT INTO "voyages" VALUES (4021, '', 3, '', 'WESTERVELD', 'Abraham in ''t Anker', 1100, NULL, '1761', NULL, NULL, 'A', 'Z', '1768-06-04', 'Rammekens', '1768-09-23', '1768-10-13', true, '1768-12-14', 'Batavia', 7839, 'See the ZILVER-EN LEEUW (4016).');
INSERT INTO "voyages" VALUES (4022, '', 6, '', 'SNOEK', 'Johan Splinter Stavorinus', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1768-06-24', 'Rammekens', '1768-11-18', '1768-12-12', true, '1769-03-19', 'Batavia', NULL, 'soldiers, and 14 craftsmen arrived at Batavia,');
INSERT INTO "voyages" VALUES (4023, '', 1, '', 'RIJNSBURG', 'Huibrecht van der Kneu', 850, NULL, '1765', NULL, NULL, 'Z', 'Z', '1768-07-25', 'Rammekens', '1768-12-21', '1769-01-14', true, '1769-04-27', 'Batavia', 7790, 'See the ENKHUIZEN (4020) and the SNOEK (4022).');
INSERT INTO "voyages" VALUES (4024, '', 2, '', 'KORNELIA JAKOBA', 'Gerrit Bruin', 880, NULL, '1763', NULL, NULL, 'E', 'E', '1768-08-31', 'Texel', '1769-01-09', '1769-02-13', true, '1769-06-10', 'Batavia', NULL, 'WELVAREN (4036), the BARBARA THEODORA (4041), and the GOUVERNEUR-GENERAAL (4044): one seafarer deserted at Duins; at Portsmouth 2 seaf. and 5 soldiers died, one seafarer deserted; at S. Tiago 12 seafarers, 5 soldiers, and one craftsmen died, 16 seafarers, 15 soldiers, and one craftsmen deserted; at the Cape 182 seafarers, 191 soldiers, 7 craftsmen, and 7 passengers went ashore; during the voyage 222 seafarers, 205 soldiers, and 21 craftsmen died.');
INSERT INTO "voyages" VALUES (4025, '', 1, '', 'OOSTKAPELLE', 'Frederik Papegaai', 1150, NULL, '1767', NULL, NULL, 'Z', 'Z', '1768-09-12', 'Rammekens', '1769-01-02', '1769-01-24', true, '1769-04-27', 'Batavia', 7804, 'After having called at Batavia the OOSTKAPELLE sailed on to China. See the ENKHUIZEN (4020) and the SNOEK (4022).');
INSERT INTO "voyages" VALUES (4026, '', 1, '', 'TEMPEL', 'Wouter Macquelin', 850, NULL, '1767', NULL, NULL, 'R', 'R', '1768-09-20', 'Goeree', '1769-01-09', '1769-01-24', true, '1769-05-06', 'Batavia', 7805, 'ship sailed on to China. See also the ENKHUIZEN (4020).');
INSERT INTO "voyages" VALUES (4027, '', 1, '', 'OUD HAARLEM', 'Pieter Sijbrandsz. Flout', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1768-10-01', 'Texel', '1769-02-02', '1769-02-15', true, '1769-05-05', 'Batavia', 7802, 'After having called at Batavia the OUD HAARLEM sailed on to China. See the ENKHUIZEN (4020).');
INSERT INTO "voyages" VALUES (4028, '', 1, '', '''T LOO', 'Kornelis Pietersen', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1768-10-01', 'Texel', '1769-01-22', '1769-02-07', true, '1769-04-30', 'Batavia', 7803, 'After having called at Batavia the ''T LOO sailed on to China. See the ENKHUIZEN (4020).');
INSERT INTO "voyages" VALUES (4029, '', 7, '', 'NOORD NIEUWLAND', 'Leendert van Koopstad', 880, NULL, '1749', NULL, NULL, 'R', 'H', '1768-10-01', 'Texel', '1769-03-03', '1769-03-21', true, '1769-06-14', 'Batavia', NULL, 'embarked at the Cape. See the JONKVROUWE KORNELIA JAKOBA (4024). The NOORD NIEUWLAND was laid up and sold in the Indies, 14-04-1772.');
INSERT INTO "voyages" VALUES (4030, '', 2, '', 'VREEBURG', 'Jan Houtwijk', 850, NULL, '1764', NULL, NULL, 'D', 'A', '1768-10-01', 'Texel', '1769-03-27', '1769-04-14', true, '1769-07-19', 'Batavia', 7791, 'refer to the crew of the VREEBURG as well as to the crews of the GAN-ZENHOEF (see 4031), the OUDERAMSTEL (4032), the HUIS TE BIJWEG (4034), the PALLAS (4035), and the COMPAGN-IES WELVAREN (4036):1318 seafarers, 706 soldiers, 76 craftsmen, and 6 passengers departed from the Republic or embarked at the Cape; 1077 seafarers, 437 soldiers, 60 craftsmen, and 4 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4031, '', 2, '', 'GANZENHOEF', 'Gerrit de Waal', 880, NULL, '1765', NULL, NULL, 'A', 'A', '1768-10-02', 'Texel', '1769-02-18', '1769-03-05', true, '1769-06-04', 'Batavia', NULL, 'See the JONKVROUW E KORNELIA JAKOBA (4024) and the VREEBURG (4030). In 1770 the GANZENHOEF was wrecked during a voyage from Japan to Batavia.');
INSERT INTO "voyages" VALUES (4032, '', 2, '', 'OUDERAMSTEL', 'Christiaan Blom', 1100, NULL, '1765', NULL, NULL, 'Z', 'A', '1768-10-02', 'Texel', '1769-01-23', '1769-02-15', true, '1769-06-04', 'Batavia', 7847, 'voyage was called AZIE (numbers of the first voyage: 3981/7747); after the arrival of the ship at Batavia, 04-06-1769, its name was altered into AZIE again (see 7847).');
INSERT INTO "voyages" VALUES (4033, '', 2, '', 'RITTHEM', 'der Weide', 880, NULL, '1764', NULL, NULL, 'Z', 'D', '1768-10-02', 'Goeree', '1769-01-22', '1769-02-15', true, '1769-06-04', 'Batavia', 7837, 'crew of the RITTHEM: 198 seafarers, 74 soldiers, 23 craftsmen, and 6 passengers departed from Goeree or embarked at the Cape. See the JONKVROUWE KORNELIA JAKOBA (4024).');
INSERT INTO "voyages" VALUES (4034, '', 3, '', 'HUIS TE BIJWEG', 'Michiel Hendrik Kerke', 1100, NULL, '1760', NULL, NULL, 'A', 'A', '1768-11-13', 'Texel', '1769-04-11', '1769-05-08', true, '1769-08-07', 'Batavia', 7797, 'See the JONKVROUWE KORNELIA JAKOBA (4024) and the VREEBURG (4030).');
INSERT INTO "voyages" VALUES (4035, '', 3, '', 'PALLAS', 'Frans Overzee', 1150, NULL, '1762', NULL, NULL, 'Z', 'A', '1768-11-13', 'Texel', '1769-04-21', '1769-05-20', true, '1769-08-07', 'Batavia', 7796, 'See the JONKVROUWE KORNELIA JAKOBA (4024) and the VREEBURG (4030).');
INSERT INTO "voyages" VALUES (4036, '', 2, '', 'COMPAGNIES WELVAREN', 'Jan Berghuis', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1768-12-10', 'Texel', '1769-03-19', '1769-04-28', true, '1769-07-21', 'Batavia', 7795, 'The COMPAGNIES WELVAREN initially set out on 13-11-1768; on 29-11, however, the ship had to return to Texel; 10-12-1768 is its final date of departure, See the JONKVROUWE KORNELIA JAKOBA (4024) and the VREEBURG (4030).');
INSERT INTO "voyages" VALUES (4037, '', 1, '', 'ZON', 'Jan Daniel van de Bogaard', 450, 'hoeker', '1768', NULL, NULL, 'A', 'A', '1768-12-10', 'Texel', '1769-04-13', NULL, true, '1769-04-13', 'The Cape', 7841, '13-11-1768 the ZON initially put to sea; 16 days later, however, the ship returned to Texel; 10-12-1768 is its final date of departure.');
INSERT INTO "voyages" VALUES (4038, '', 4, '', 'VROUWE GEERTRUIDA', 'Josua Hartman', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1768-12-13', 'Texel', '1769-04-25', '1769-05-17', true, '1769-08-07', 'Ceylon', 7801, NULL);
INSERT INTO "voyages" VALUES (4039, '', 3, '', 'VROUWE KORNELIA HILLEGONDA', 'Johan Sigismund Hoeve', 850, NULL, '1760', NULL, NULL, 'D', 'A', '1768-12-13', 'Texel', '1769-04-29', '1769-05-15', true, '1769-09-01', 'Bengal', 7816, NULL);
INSERT INTO "voyages" VALUES (4040, '', 6, '', 'RUITEVELD', 'Albert Kikkert', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1768-12-13', 'Texel', '1769-04-29', '1769-05-17', true, '1769-08-04', 'Ceylon', NULL, 'The RUITEVELD was sold in the Indies, 13-04-1773.');
INSERT INTO "voyages" VALUES (4041, '', 5, '', 'BARBARA THEODORA', 'Pieter ten Droge', 1150, NULL, '1750', NULL, NULL, 'Z', 'Z', '1768-12-14', 'Rammekens', '1769-04-01', '1769-04-18', true, '1769-07-19', 'Batavia', 7798, 'arrived at Batavia,');
INSERT INTO "voyages" VALUES (4042, '', 2, '', 'GEINWENS', 'Jakob de Frein', 1100, NULL, '1765', NULL, NULL, 'A', 'Z', '1768-12-14', 'Rammekens', '1769-04-01', '1769-05-08', true, '1769-12-07', 'Ceylon', 7827, NULL);
INSERT INTO "voyages" VALUES (4043, '', 2, '', 'VROUWE MARGARETHA MARIA', 'Jakob de Bruin', 880, NULL, '1765', NULL, NULL, 'E', 'E', '1768-12-17', 'Texel', '1769-08-06', '1769-09-13', true, '1769-11-19', 'Batavia', 7806, 'and 5 craftsmen went ashore at the Cape; during the voyage 18 seafarers, 21 soldiers, and 2 craftsmen died.');
INSERT INTO "voyages" VALUES (4044, '', 7, '', 'GOUVERNEUR-GENERAAL', 'Christiaan Rebel', 850, NULL, '1749', NULL, NULL, 'D', 'Z', '1769-01-20', 'Rammekens', '1769-05-06', '1769-06-08', true, '1769-08-14', 'Batavia', NULL, 'See the JONKVROUWE KORNELIA JAKOBA (4024) and the BARBARA THEODORA (4041), The GOUVERNEUR-GENERAAL was laid up in the Indies, 31-12-1773.');
INSERT INTO "voyages" VALUES (4045, '', 4, '', 'DUINENBURG', 'Jan Verheke', 1100, NULL, '1757', NULL, NULL, 'Z', 'Z', '1769-03-30', 'Rammekens', '1769-07-19', '1769-08-04', true, '1769-10-12', 'Batavia', 7823, 'soldier went ashore, 6 seafarers embarked.');
INSERT INTO "voyages" VALUES (4046, '', 4, '', 'LEKKERLUST', 'Abraham van Leeuwen', 880, NULL, '1755', NULL, NULL, 'H', 'D', '1769-04-08', 'Goeree', '1769-11-22', '1770-01-14', true, '1770-04-28', 'Batavia', NULL, 'seafarers, 10 soldiers, and 7 craftsmen deserted; at the Cape 158 seafarers, 123 soldiers, and 20 craftsmen disembarked; during the voyage 66 seafarers, 45 soldiers, 11 craftsmen, and one passenger died.');
INSERT INTO "voyages" VALUES (4047, '', 7, '', 'LYCOCHTON', 'George Heendekker', 880, NULL, '1749', NULL, NULL, 'E', 'A', '1769-05-13', 'Texel', '1769-10-01', '1769-10-19', true, '1770-01-09', 'Batavia', NULL, 'to the crews of the WELGELEGEN (see 4049) and the BLEISWIJK (4051): 476 seafarers, 210 soldiers, 29 craftsmen, and 4 passengers departed from the Republic or embarked at the Cape; 413 seafarers, 172 soldiers, 20 craftsmen, and 4 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4048, '', 5, '', 'VROUWE PETRONELLA MARIA', 'Thijs Fierman', 1150, NULL, '1755', NULL, NULL, 'A', 'A', '1769-05-13', 'Texel', '1769-08-31', '1769-09-09', true, '1769-11-28', 'Batavia', 7808, 'Specified data concerning the crew of the VROUWE PETRONELLA MARIA: 196 seafarers, 98 soldiers, and 11 craftsmen departed from Texel or embarked at the Cape. See the VROUWE MARGARETHA MARIA (4043).');
INSERT INTO "voyages" VALUES (4049, '', 5, '', 'WELGELEGEN', 'Gerrit ten Sunder', 880, NULL, '1753', NULL, NULL, 'E', 'A', '1769-05-13', 'Texel', '1769-10-08', '1769-10-24', true, '1770-01-20', 'Batavia', 7863, 'See the LEKKERLUST (4046) and the LYCOCHTON (4047).');
INSERT INTO "voyages" VALUES (4050, '', 3, '', 'WESTFRIESLAND', 'Marten Pietersz. Mooy', 880, NULL, '1761', NULL, NULL, 'H', 'H', '1769-05-13', 'Texel', '1769-10-31', '1769-11-23', true, '1770-03-08', 'Batavia', 7815, 'Specified data concerning the crew of the WESTFRIESLAND: 203 seafarers, 92 soldiers, 25 craftsmen, and one passenger departed from Texel or embarked at the Cape. See the LEKKERLUST (4046).');
INSERT INTO "voyages" VALUES (4051, '', 5, '', 'BLEISWIJK', 'Jan Moorland', 880, NULL, '1756', NULL, NULL, 'D', 'A', '1769-06-05', 'Texel', '1769-10-07', '1769-10-24', true, '1770-01-09', 'Batavia', 7836, 'See the LEKKERLUST (4046) and the LYCOCHTON (4047).');
INSERT INTO "voyages" VALUES (4052, '', 3, '', 'BURCH', 'Frans van Ewijk', 1150, NULL, '1760', NULL, NULL, 'Z', 'Z', '1769-07-05', 'Rammekens', '1769-11-15', '1770-01-01', true, '1770-03-30', 'Batavia', NULL, '4053): 390 seafarers, 205 soldiers, 31 craftsmen, and 7 passengers departed from the Republic or embarked at the Cape; 302 seafarers, 139 soldiers, 19 craftsmen, and 6 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4053, '', 5, '', 'NOORD-BEVELAND', 'Arie Fransz.', 1150, NULL, '1756', NULL, NULL, 'Z', 'Z', '1769-09-04', 'Rammekens', '1770-01-15', '1770-02-04', true, '1770-05-01', 'Batavia', 7874, 'See the LEKKERLUST (4046) and the BURCH (4052).');
INSERT INTO "voyages" VALUES (4054, '', 2, '', 'VROUWE ANTHOINETTA KOENRARDINA', 'Hendrik Hilverduin', 880, NULL, '1765', NULL, NULL, 'D', 'E', '1769-09-05', 'Texel', '1770-01-15', '1770-02-15', true, '1770-05-27', 'Batavia', 7819, 'concerning both the aforesaid seventeen ships and the JONGE HELLINGMAN (4063): at S. Tiago 11 seafarers, 19 soldiers, and one craftsmen died, 12 seafarers, 17 soldiers, and 3 craftsmen deserted; during the voyage 212 seafarers, 195 soldiers, 18 craftsmen, and one passenger died.');
INSERT INTO "voyages" VALUES (4055, '', 1, '', 'BOT', 'H. C. Bremer', 1150, NULL, '1768', NULL, NULL, 'Z', 'Z', '1769-10-01', 'Rammekens', '1770-02-07', '1770-03-05', true, '1770-05-27', 'Batavia', 7829, 'Batavia the BOT sailed on to China. See the VROUWE ANTHOINETTA KOENRARDINA (4054). The following data refer to the crew of the BOT as well as to the crews of the NIEUW RHOON (see 4066), the VLISSIN-GEN (4073), and the WOESTDUIN (4074): 1106 seafarers, 348 soldiers, 31 craftsmen, and 8 passengers departed from the Republic or embarked at the Cape; 887 seafarers, 202 soldiers, 20 craftsmen, and 8 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4056, '', 1, '', 'ALKEMADE', 'Jan van Eysden', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1769-10-02', 'Texel', '1770-02-15', '1770-03-05', true, '1770-05-27', 'Batavia', 7866, 'the Republic or embarked at the Cape; 1503 seafarers, 745 soldiers, 107 craftsmen, and 14 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4057, '', 4, '', 'VROUWE ELISABETH', 'Anthonie Leertouwer', 850, NULL, '1755', NULL, NULL, 'R', 'R', '1769-10-02', 'Goeree', '1770-02-11', '1770-03-05', true, '1770-05-27', 'Batavia', 7849, '100 soldiers, 23 craftsmen, and 2 passengers departed from Goeree or embarked at the Cape. See also the VROUWE ANTHOINETTA KOENRARDINA (4054). (4054).');
INSERT INTO "voyages" VALUES (4058, '', 5, '', 'ERFPRINS', 'Kornelis van Brattem', 880, NULL, '1754', NULL, NULL, 'D', 'D', '1769-10-02', 'Goeree', '1770-02-09', '1770-03-10', true, '1770-05-27', 'Batavia', 4058, 'or embarked at the Cape; 300 seafarers, 157 soldiers, 35 craftsmen, and one passenger arrived at Batavia.');
INSERT INTO "voyages" VALUES (4059, '', 1, '', 'PRINSES VAN ORANJE', 'Kornelis Kuiper', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1769-10-02', 'Texel', '1770-02-11', '1770-03-05', true, '1770-05-27', 'Batavia', 7831, 'After having arrived at Batavia the PRINSES VAN ORANJE sailed on to China. See the VROUWE ANTHOINETTA KOENRARDINA (4054) and the ALKEMADE (4056).');
INSERT INTO "voyages" VALUES (4060, '', 2, '', 'RIDDERKERK', 'Pieter van Prooien', 850, NULL, '1766', NULL, NULL, 'R', 'A', '1769-10-02', 'Texel', '1770-02-16', '1770-03-05', true, '1770-05-20', 'Batavia', 7824, 'See the VROUWE ANTHOINETTA KOENRARDINA (4054) and the ALKEMADE (4056),');
INSERT INTO "voyages" VALUES (4061, '', 3, '', 'JONGE SAMUEL', 'Angelvorst', 880, NULL, '1761', NULL, NULL, 'Z', 'A', '1769-10-02', 'Texel', '1770-02-16', '1770-03-18', true, '1770-05-27', 'Batavia', 7822, 'See the VROUWE ANTHOINETTA KOENRARDINA (4054) and the ALKEMADE (4056).');
INSERT INTO "voyages" VALUES (4062, '', 2, '', 'WILLEM DE VIJFDE', 'Frederik Visser', 1150, NULL, '1765', NULL, NULL, 'Z', 'A', '1769-10-02', 'Texel', '1770-02-13', '1770-03-05', true, '1770-05-23', 'Batavia', 7832, 'After having arrived at Batavia the WILLEM DE VIJFDE sailed on to China, See the VROUWE ANTHOINETTA KOENRARDINA (4054) and the ALKEMADE (4056).');
INSERT INTO "voyages" VALUES (4063, '', 1, '', 'JONGE HELLINGMAN', 'Jan Balthus Meyer', 850, NULL, '1767', NULL, NULL, 'H', 'H', '1769-10-06', 'Texel', '1770-02-15', '1770-03-05', true, '1770-05-23', 'Batavia', 7830, 'Specified data concerning the crew of the JONGE HELLING-MAN: 204 seafarers, 83 soldiers, 22 craftsmen, and 4 passengers departed from Texel or embarked at the Cape. After having called at Batavia the ship sailed on to China. See the VROUWE ANTHOINETTA KOENRARDINA (4054).');
INSERT INTO "voyages" VALUES (4064, '', 5, '', 'SCHOLTENBURG', 'Jan Ide', 880, NULL, '1753', NULL, NULL, 'A', 'A', '1769-10-12', 'Texel', '1770-02-10', '1770-03-19', true, '1770-05-27', 'Batavia', NULL, '09-01-1772 the SCHOLTENBURG, sailing to Ceylon, was wrecked. See the VROUWE ANTHOINETTA KOENRARDINA (4054) and the ALKEMADE (4056).');
INSERT INTO "voyages" VALUES (4065, '', 2, '', 'VELDHOEN', 'Karel Philip Kassel', 1150, NULL, '1765', NULL, NULL, 'A', 'A', '1769-10-12', 'Texel', '1770-02-10', '1770-03-14', true, '1770-05-27', 'Batavia', 7881, 'See the VROUWE ANTHOINETTA KOENRARDINA (4054) and the ALKEMADE (4056).');
INSERT INTO "voyages" VALUES (4066, '', 3, '', 'NIEUW RHOON', 'Jan Hendriksz.', 1150, NULL, '1764', NULL, NULL, 'Z', 'Z', '1769-11-12', 'Rammekens', '1770-03-09', '1770-04-01', true, '1770-06-02', 'Batavia', 7818, 'See the VROUWE ANTHOINETTA KOENRARDINA (4054) and the BOT (4055).');
INSERT INTO "voyages" VALUES (4067, '', 2, '', 'BOVENKERKER POLDER', 'Pieter Andriesz.', 850, NULL, '1765', NULL, NULL, 'A', 'A', '1769-12-29', 'Texel', '1770-04-05', '1770-04-24', true, '1770-08-12', 'Bengal', 7828, NULL);
INSERT INTO "voyages" VALUES (4068, '', 4, '', 'KRONENBURG', 'Frederik Kelger', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1769-12-29', 'Texel', '1770-04-05', '1770-05-03', true, '1770-07-16', 'Batavia', 7817, 'KOENRARDINA (4054) and the ALKEMADE (4056).');
INSERT INTO "voyages" VALUES (4069, '', 4, '', 'LEIMUIDEN', 'J. H. Kinsbergen', 1150, NULL, '1755', NULL, NULL, 'A', 'A', '1769-12-29', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'On 27-01-1770 the LEIMUIDEN ran aground off the island Boavista, one of the Cape Verde Islands, and was wrecked,');
INSERT INTO "voyages" VALUES (4070, '', 4, '', 'RENSWOUDE', 'Hendrik Willemse', 1150, NULL, '1756', NULL, NULL, 'A', 'A', '1769-12-29', 'Texel', '1770-04-25', '1770-05-13', true, '1770-07-29', 'Ceylon', 7838, NULL);
INSERT INTO "voyages" VALUES (4071, '', 3, '', 'JONGE THOMAS', 'Laurens Molkenboer', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1769-12-29', 'Texel', '1770-03-27', '1770-04-16', true, '1770-07-01', 'Batavia', 7854, 'See the VROUWE ANTHOINETTA KOENRARDINA (4054) and the ALKEMADE (4056).');
INSERT INTO "voyages" VALUES (4072, '', 3, '', 'WALENBURG', 'Andries Brusse', 880, NULL, '1764', NULL, NULL, 'R', 'A', '1769-12-29', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'On 12/13-01-1770 the WALENBURG ran ashore off Portsal at the coast of Bretagne (Brittany) and was wrecked, See 4090,');
INSERT INTO "voyages" VALUES (4073, '', 5, '', 'VLISSINGEN', 'Jakob Hart', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1770-02-23', 'Rammekens', '1770-06-01', '1770-06-21', true, '1770-09-05', 'Batavia', 7825, 'See the VROUWE ANTHOINETTA KOENRARDINA (4054) and the BOT (4055).');
INSERT INTO "voyages" VALUES (4074, '', 2, '', 'WOESTDUIN', 'Michiel Godfried Lehman', 1150, NULL, '1767', NULL, NULL, 'A', 'Z', '1770-02-23', 'Rammekens', '1770-06-25', '1770-07-16', true, '1770-09-12', 'Batavia', 7826, 'Se the VROUWE ANTHOINETTA KOENRARDINA (4054) and the BOT (4055),');
INSERT INTO "voyages" VALUES (4075, '', 3, '', 'ZILVEREN LEEUW', 'Christiaan Andries Spin', 880, NULL, '1765', NULL, NULL, 'D', 'D', '1770-04-10', 'Goeree', '1770-08-01', '1770-08-19', true, '1770-10-22', 'Batavia', 7833, 'See the VROUWE ANTHOINETTA KOENRARDINA (4054) and the ERFPRINS (4058),');
INSERT INTO "voyages" VALUES (4076, '', 5, '', 'SCHOONZICHT', 'Marten Hakker', 880, NULL, '1758', NULL, NULL, 'R', 'R', '1770-04-10', 'Goeree', '1770-09-02', '1770-09-14', true, '1770-11-26', 'Batavia', 7834, 'data concerning the crew of the SCHOONZICHT: 162 seafarers, 103 soldiers, and 20 craftsmen departed from Goeree or embarked at the Cape. The following data refer to the crew of the SCHOONZICHT as well as to the crews of the WALCHEREN (see 4077), the DAMZICHT (4079), and the LANDSKROON (4080): 100 seafarers, 89 soldiers, 5 craftsmen, and 19 passengers went ashore at the Cape; during the voyage 61 seafarers, 36 soldiers, 5 craftsmen, and 4 passengers died.');
INSERT INTO "voyages" VALUES (4077, '', 5, '', 'WALCHEREN', 'Lodewijk Thomasz.', 1150, NULL, '1754', NULL, NULL, 'Z', 'Z', '1770-05-07', 'Rammekens', '1770-09-16', '1770-10-10', true, '1770-12-26', 'Batavia', NULL, 'Surat.');
INSERT INTO "voyages" VALUES (4078, '', 3, '', 'BARTHA PETRONELLA', 'Kornelis Brouwer', 880, NULL, '1764', NULL, NULL, 'H', 'H', '1770-05-12', 'Texel', '1770-09-09', '1770-10-28', true, '1771-02-10', 'Batavia', 7843, '(see 4082): 56 seafarers, 22 soldiers, and 3 craftsmen embarked at the Cape. Data concerning both the two aforesaid ships and the DUIVEN-BRUG (4081): at S. Tiago one soldier and one craftsmen died, 8 seafarers, 2 soldiers, and one craftsmen deserted (no deserters from the BARTHA PETRONELLA); 109 seafarers and 68 soldiers went ashore at the Cape; during the voyage 20 seafarers, 21 soldiers, and 4 craftsmen died.');
INSERT INTO "voyages" VALUES (4079, '', 4, '', 'DAMZICHT', 'Arend Willemse', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1770-05-20', 'Texel', '1770-09-02', '1770-09-14', true, '1770-11-24', 'Batavia', 7835, 'the LANDSKROON (see 4080): 456 seafarers, 236 soldiers, 25 craftsmen, and 26 passengers departed from the Republic or embarked at the Cape, 357 seafarers, 155 soldiers, 20 craftsmen, and 3 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4080, '', 2, '', 'LANDSKROON', 'Andries Lint', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1770-05-20', 'Texel', '1770-09-23', '1770-10-20', true, '1771-01-07', 'Batavia', 7851, 'At Porto Prayo, S. Tiago, one soldier deserted. See the SCHOONZICHT (4076) and the DAMZICHT (4079).');
INSERT INTO "voyages" VALUES (4081, '', 2, '', 'DUIVENBRUG', 'Steven Booms', 850, NULL, '1766', NULL, NULL, 'E', 'E', '1770-05-25', 'Texel', '1770-10-01', '1770-10-20', true, '1771-01-12', 'Batavia', 7840, 'At S. Tiago 3 members of the crew deserted. See the BARTHA PETRONELLA (4078).');
INSERT INTO "voyages" VALUES (4082, '', 7, '', 'BLUDORP', 'Abel Barber', 880, NULL, '1753', NULL, NULL, 'R', 'Z', '1770-08-01', 'Rammekens', '1770-11-27', '1770-12-19', true, '1771-03-14', 'Batavia', NULL, 'departed from Rammekens or embarked at the Cape. At S. Tiago 8 members of the crew deserted. See the BARTHA PETRONELLA (4078). The BLIJ-DORP was laid up in the Indies, 31-12-1773.');
INSERT INTO "voyages" VALUES (4083, '', 6, '', 'BARBARA THEODORA', 'Jan Canvas', 1150, NULL, '1750', NULL, NULL, 'Z', 'Z', '1770-09-02', 'Rammekens', '1771-02-04', '1771-02-28', true, '1771-06-11', 'Batavia', 4083, '/- Is the sixth voyage of this ship, which during its first three voyages was called TORENVLIET (3783/7616). The BARBARA THEODORA was laid up in the Indies. The following data refer to the crew of the BARBARA THEODORA as well as to the crews of the OOSTKAPELLE (4089) and the OU-WERKERK (4095): 69 seafarers, 31 soldiers, and 4 craftsmen embarked at the Cape.');
INSERT INTO "voyages" VALUES (4084, '', 4, '', 'HUIS OM', 'Hamelo', 1150, NULL, '1761', NULL, NULL, 'Z', 'A', '1770-10-01', 'Texel', '1771-05-19', '1771-07-23', true, '1771-09-29', 'Batavia', 7852, 'HAARLEM (4092), the''T LOO (4094), and the ASCHAT (4096): 121 seafarers, 48 soldiers, and 8 craftsmen embarked at the Cape.');
INSERT INTO "voyages" VALUES (4085, '', 4, '', 'PALLAS', 'Klaas Roem', 1150, NULL, '1762', NULL, NULL, 'Z', 'A', '1770-10-01', 'Texel', '1771-02-16', '1771-04-07', true, '1771-06-12', 'Batavia', 7844, 'crew deserted, See the HUIS OM (4084).');
INSERT INTO "voyages" VALUES (4086, '', 2, '', 'RIJNSBURG', 'Roelof Schot', 850, NULL, '1765', NULL, NULL, 'Z', 'A', '1770-10-01', 'Texel', '1771-02-05', '1771-02-24', true, '1771-05-29', 'Batavia', 7842, '(4084).');
INSERT INTO "voyages" VALUES (4087, '', 1, '', 'LAM', 'Gerrit Harmeyer', 850, NULL, '1769', NULL, NULL, 'D', 'D', '1770-10-02', 'Goeree', '1771-02-18', '1771-03-10', true, '1771-06-10', 'Batavia', 7857, 'During the voyage 5 members of the crew deserted.');
INSERT INTO "voyages" VALUES (4088, '', 2, '', 'USSELMONDE', 'Arend van der Deuren', 880, NULL, '1762', NULL, NULL, 'R', 'R', '1770-10-02', 'Goeree', '1771-03-01', '1771-03-17', true, '1771-06-10', 'Batavia', 7861, 'During the voyage one member of the crew deserted.');
INSERT INTO "voyages" VALUES (4089, '', 2, '', 'OOSTKAPELLE', 'Frederik Papegaai', 1150, NULL, '1767', NULL, NULL, 'Z', 'Z', '1770-10-03', 'Rammekens', '1771-02-19', '1771-03-10', true, '1771-06-19', 'Batavia', 7860, 'During the voyage 4 members of the crew deserted. After having arrived at Batavia the OOSTKAPELLE sailed on to China. See the BARBARA THEODORA (4083).');
INSERT INTO "voyages" VALUES (4090, '', 5, '', 'VROUWE GEERTRUIDA', 'Overstraten', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1770-11-02', 'Texel', '1771-04-20', '1771-05-06', true, '1771-08-07', 'Batavia', 7850, 'During the voyage 2 members of the crew deserted. The VROUWE GEERTRUIDA replaced the WALENBURG, which, during a voyage to the Indies, was wrecked at the coast of Bretagne (Brittany), January 1770 (4072). See the HUIS OM (4084).');
INSERT INTO "voyages" VALUES (4091, '', 3, '', 'COMPAGNIES WELVAREN', 'Hendrik Jakob Beeld', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1770-11-02', 'Texel', '1771-02-19', '1771-04-07', true, '1771-06-11', 'Batavia', 7924, 'During the voyage 2 members of the crew deserted. See the HUIS OM (4084).');
INSERT INTO "voyages" VALUES (4092, '', 2, '', 'OUD HAARLEM', 'Jan Och', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1770-11-17', 'Texel', '1771-03-01', '1771-03-13', true, '1771-06-10', 'Batavia', 7859, 'During the voyage one member of the crew deserted. After having arrived at Batavia the OUD HAARLEM sailed on to China. See the HUIS OM (4084).');
INSERT INTO "voyages" VALUES (4093, '', 1, '', 'HOOLWERF', 'Gerrit van der Gracht', 850, NULL, '1769', NULL, NULL, 'H', 'H', '1770-11-18', 'Texel', '1771-04-24', '1771-05-06', true, '1771-07-28', 'Batavia', 7845, 'PETRONELLA (4078).');
INSERT INTO "voyages" VALUES (4094, '', 2, '', '''T LOO', 'Wopke Popta', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1770-11-18', 'Texel', '1771-02-24', '1771-03-13', true, '1771-06-09', 'Batavia', 7858, 'sailed on to China. See the HUIS OM (4084).');
INSERT INTO "voyages" VALUES (4095, '', 1, '', 'OUWERKERK', 'Jakob de Frein', 1150, NULL, '1768', NULL, NULL, 'Z', 'Z', '1770-11-19', 'Rammekens', '1771-04-19', '1771-06-16', true, '1771-09-21', 'Batavia', 7853, 'THEODORA (4083).');
INSERT INTO "voyages" VALUES (4096, '', 4, '', 'ASCHAT', 'Jan Abel', 1150, NULL, '1760', NULL, NULL, 'A', 'A', '1771-01-11', 'Texel', '1771-04-26', '1771-05-24', true, '1771-09-10', 'Batavia', 7846, 'See the HUIS OM (4084).');
INSERT INTO "voyages" VALUES (4097, '', 4, '', 'HUIS TE BIJWEG', 'Hendrik Sterrenberg', 1100, NULL, '1760', NULL, NULL, 'A', 'A', '1771-01-11', 'Texel', '1771-05-01', '1771-06-01', true, '1771-08-07', 'Batavia', 7848, 'During the voyage 4 members of the crew deserted.');
INSERT INTO "voyages" VALUES (4098, '', 6, '', 'VELSEN', 'Christiaan Schreuder', 1100, NULL, '1756', NULL, NULL, 'A', 'A', '1771-01-11', 'Texel', '1771-04-15', '1771-05-01', true, '1771-06-26', 'Ceylon', NULL, 'When the VELSEN departed from the Cape, 01-05-1771, 152 seafarers and 102 soldiers were aboard. The ship was laid up in the Indies, 01-01-1780.');
INSERT INTO "voyages" VALUES (4099, '', 4, '', '''S LANDS WELVAREN', 'Pieter Clement', 880, NULL, '1762', NULL, NULL, 'A', 'A', '1771-01-11', 'Texel', '1771-04-12', '1771-05-01', true, '1771-08-08', 'Bengal', 7856, NULL);
INSERT INTO "voyages" VALUES (4100, '', 1, '', 'VREDEJAAR', 'Arie Arkebout', 850, NULL, '1769', NULL, NULL, 'E', 'E', '1771-01-12', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The VREDEJAAR got missing between patria and the Cape; the ship was destined for China.');
INSERT INTO "voyages" VALUES (4101, '', 3, '', 'BORSSELE', 'Jan Siereveld', 1150, NULL, '1758', NULL, NULL, 'Z', 'Z', '1771-01-13', 'Rammekens', '1771-04-24', '1771-05-24', true, '1771-07-14', 'Ceylon', 7862, 'When the BORSSELE departed from the Cape, 146 seafarers and 36 soldiers were aboard.');
INSERT INTO "voyages" VALUES (4102, '', 3, '', 'VREEBURG', 'Jan Kaatman', 850, NULL, '1764', NULL, NULL, 'D', 'D', '1771-04-02', 'Goeree', '1771-07-01', '1771-08-04', true, '1771-10-26', 'Batavia', 7855, NULL);
INSERT INTO "voyages" VALUES (4103, '', 2, '', 'TEMPEL', 'Willem Koelbier', 850, NULL, '1767', NULL, NULL, 'R', 'R', '1771-05-14', 'Goeree', '1771-10-03', '1771-11-16', true, '1772-02-14', 'Batavia', 7914, NULL);
INSERT INTO "voyages" VALUES (4104, '', 1, '', 'BEEKVLIET', 'Thomas Brunei', 850, NULL, '1770', NULL, NULL, 'A', 'A', '1771-06-08', 'Texel', '1773-08-31', '1773-09-10', true, '1773-11-28', 'Batavia', 7908, 'ELISABETH (4171): 607 seafarers, 282 soldiers, 40 craftsmen, and one passenger arrived at Batavia. Data concerning both the above-mentioned four ships and the IJSSELMONDE (4172): 1102 seafarers, 530 soldiers, 89 craftsmen, and one passenger departed from the Republic or embarked at the Cape; at S. Tiago 4 seafarers and 3 soldiers died, one soldier deserted; 198 seafarers, 119 soldiers, and 23 craftsmen died during the voyage.');
INSERT INTO "voyages" VALUES (4105, '', 2, '', 'BLEIJENBURG', 'Kornelis Bos', 880, NULL, '1765', NULL, NULL, 'R', 'A', '1771-06-08', 'Texel', '1771-09-24', '1771-10-30', true, '1772-02-04', 'Batavia', 7864, NULL);
INSERT INTO "voyages" VALUES (4106, '', 2, '', 'VREDELUST', 'Willem Silvester', 1150, NULL, '1765', NULL, NULL, 'A', 'A', '1771-06-08', 'Texel', '1771-10-13', '1772-02-05', true, '1772-05-16', 'Batavia', NULL, 'The VREDELUST was laid up in the Indies, 01-01-1780.');
INSERT INTO "voyages" VALUES (4107, '', 4, '', 'ZUID-BEVELAND', 'Lambert Arnout Halfman', 1100, NULL, '1755', NULL, NULL, 'Z', 'Z', '1771-06-09', 'Rammekens', '1771-12-22', '1772-03-14', true, '1772-06-19', 'Batavia', 7875, NULL);
INSERT INTO "voyages" VALUES (4108, '', 3, '', 'VROUWE MARGARETHA MARIA', 'Jakob de Vries', 880, NULL, '1765', NULL, NULL, 'E', 'E', '1771-06-25', 'Texel', '1771-11-14', '1772-01-30', true, '1772-05-17', 'Batavia', 7889, NULL);
INSERT INTO "voyages" VALUES (4109, '', 6, '', 'SCHAGEN', 'Leendert van Koopstad', 880, NULL, '1753', NULL, NULL, 'H', 'H', '1771-06-25', 'Texel', '1771-11-16', '1772-01-30', true, '1772-05-16', 'Batavia', NULL, 'The SCHAGEN was laid up in the Indies, 31-12-1775.');
INSERT INTO "voyages" VALUES (4110, '', 2, '', 'POPKENSBURG', 'Pidter ten Droge', 880, NULL, '1763', NULL, NULL, 'Z', 'Z', '1771-06-27', 'Rammekens', '1771-11-11', '1772-01-15', true, '1772-05-07', 'Batavia', 7903, NULL);
INSERT INTO "voyages" VALUES (4111, '', 1, '', 'BOTLAND', 'Johan van Voorst', 1150, NULL, '1769', NULL, NULL, 'Z', 'Z', '1771-08-24', 'Rammekens', '1771-12-12', '1772-01-15', true, '1772-04-14', 'Batavia', 7872, NULL);
INSERT INTO "voyages" VALUES (4112, '', 7, '', 'VREDESTEIN', 'Adriaan de Keizer', 880, NULL, '1750', NULL, NULL, 'R', 'Z', '1771-09-02', 'Rammekens', '1772-01-07', '1772-02-25', true, '1772-05-16', 'Batavia', NULL, 'The VREDESTEIN was sold in the Indies, 01-01-1780.');
INSERT INTO "voyages" VALUES (4113, '', 2, '', 'PRINSES VAN ORANJE', 'Karsten Eggers', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1771-09-25', 'Texel', '1772-01-08', '1772-03-14', true, '1772-05-16', 'Batavia', 7880, NULL);
INSERT INTO "voyages" VALUES (4114, '', 4, '', 'WESTFRIESLAND', 'Gerrit Springer', 880, NULL, '1761', NULL, NULL, 'H', 'A', '1771-09-25', 'Texel', '1772-01-08', '1772-01-30', true, '1772-05-16', 'Batavia', 7885, NULL);
INSERT INTO "voyages" VALUES (4115, '', 2, '', 'BOT', 'Damiaan Hugo Staring', 1150, NULL, '1768', NULL, NULL, 'Z', 'A', '1771-09-26', 'Texel', '1772-01-08', '1772-02-19', true, '1772-05-10', 'Batavia', 7876, 'The BOT called at S. Tiago, 30-10 till 06-11-1771: 3 seafarers and 8 soldiers deserted or died.');
INSERT INTO "voyages" VALUES (4116, '', 4, '', 'VROUWE KORNELIA HILLEGONDA', 'J. Zonavond', 850, NULL, '1760', NULL, NULL, 'D', 'E', '1771-12-07', 'Texel', '1772-09-27', '1772-10-27', true, '1773-01-28', 'Batavia', 7893, 'JONGE LIEVE (4136), the RIDDERKERK(4137), the VLISSINGEN (4141), and the RENSWOUDE (4142): at S. Tiago 5 seafarers and one soldier died, 2 seafarers and one soldier deserted; 122 seafarers, 83 soldiers, and 9 craftsmen went ashore at the Cape; during the voyage 200 seafarers, 105 soldiers and 14 craftsmen died,');
INSERT INTO "voyages" VALUES (4117, '', 3, '', 'BOVENKERKER POLDER', 'Jan Moorland', 850, NULL, '1765', NULL, NULL, 'A', 'A', '1771-12-30', 'Texel', '1772-04-24', '1772-05-12', true, '1772-08-15', 'Bengal', 7882, NULL);
INSERT INTO "voyages" VALUES (4118, '', 3, '', 'GEINWENS', 'Michiel Hendrik Kerke', 1100, NULL, '1765', NULL, NULL, 'A', 'A', '1771-12-30', 'Texel', '1772-05-21', '1772-07-01', true, '1772-09-12', 'Ceylon', NULL, 'According to a letter sent from the Cape the GEINWENS departed from Texel with 350 persons aboard. At the departure from the Cape the crew consisted of 211 men. In 1776 GEINWENS was wrecked off Punto Gale.');
INSERT INTO "voyages" VALUES (4119, '', 1, '', 'LEIDERDORP', 'Albert Kikkert', 600, NULL, '1770', NULL, NULL, 'A', 'A', '1771-12-30', 'Texel', '1772-05-12', '1772-06-09', true, '1772-08-17', 'Batavia', NULL, 'On 18-11-1771 the LEIDERDORP set out for the first time; it had to return to Texel the next day. A second attempt to depart, 07-12-1771, also failed; back at Texel: 22-12. The third and final date of departure was 30-12-1771. In 1776 the LEIDERDORP was sold in the Indies.');
INSERT INTO "voyages" VALUES (4120, '', 4, '', 'NIEUW RHOON', 'Pieter van Prooien', 1150, NULL, '1764', NULL, NULL, 'Z', 'A', '1771-12-30', 'Texel', '1772-05-10', '1772-06-09', true, '1772-08-15', 'Batavia', 7878, NULL);
INSERT INTO "voyages" VALUES (4121, '', 6, '', 'SCHOONZICHT', 'Jan Rondekrans', 880, NULL, '1758', NULL, NULL, 'R', 'A', '1771-12-30', 'Texel', '1772-04-16', '1772-06-25', true, '1772-08-29', 'Batavia', NULL, 'The SCHOONZICHT was laid up in the Indies, 01-01-1780.');
INSERT INTO "voyages" VALUES (4122, '', 3, '', 'WOESTDUIN', 'Pieter Angelvorst', 1150, NULL, '1767', NULL, NULL, 'A', 'A', '1771-12-30', 'Texel', '1772-04-22', '1772-05-12', true, '1772-07-30', 'Ceylon', 7886, NULL);
INSERT INTO "voyages" VALUES (4123, '', 2, '', 'ZON', 'Andries Hansen', 450, 'hoeker', '1768', NULL, NULL, 'A', 'A', '1771-12-30', 'Texel', '1772-05-10', NULL, true, '1772-05-10', 'The Cape', 7865, 'The ZON was bound for the Cape.');
INSERT INTO "voyages" VALUES (4124, '', 1, '', 'GROENENDAAL', 'Kornelis Pietersen', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1771-12-31', 'Texel', '1772-04-16', '1772-05-01', true, '1772-07-12', 'Batavia', 7868, 'The GROENENDAAL made two earlier attempts to put out: 18-11-1771 (return to Texel the next day) and 07-12 1771 (back at Texel: 12-12); 31-12-1771 was the final date of departure. According to data recorded at the Cape the ship left from Texel with 249 persons aboard.');
INSERT INTO "voyages" VALUES (4125, '', 1, '', 'HONKOOP', 'Pieter Sijbrandsz. Flout', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1771-12-31', 'Texel', '1772-04-09', '1772-04-22', true, '1772-06-26', 'Batavia', 7870, 'The HONKOOP made two earlier attempts to put out: 18-11-1771(back at Texel the next day) and 07-12-1771 (return 19-12); 31-12-1771 was the final date of departure. According to data recorded at the Cape the ship departed from Texel with a crew consisting of 282 persons.');
INSERT INTO "voyages" VALUES (4126, '', 5, '', 'KRONENBURG', 'Jurriaan Verburg', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1771-12-31', 'Texel', '1772-04-16', '1772-05-01', true, '1772-08-25', 'Batavia', NULL, 'made two earlier attempts to set out: 18-11-1771 (return at Texel the next day) and 07-12-1771 (back at Texel: 19-12); 31-12-1771 was the final date of departure. According to data recorded at the Cape the ship left from Texel with 304 persons aboard, The KRONENBURG was laid up in the Indies, 31-12-1780.');
INSERT INTO "voyages" VALUES (4127, '', 2, '', 'HUIS TER MEIJEN', 'Simon Bot', 1150, NULL, '1767', NULL, NULL, 'A', 'A', '1771-12-31', 'Texel', '1772-05-01', '1772-07-03', true, '1772-09-05', 'Batavia', 7899, 'The HUIS TER MEIJEN made two earlier attempts to put out: 18-11-1771 (back at Texel the next day) and 07-12-1771 (return: 19-12); 31-12-1771 was the final date of departure. According to data recorded at the Cape the HUIS TER MEIJEN departed from Texel with a crew consisting of 248 persons.');
INSERT INTO "voyages" VALUES (4128, '', 2, '', 'PAUW', 'Abraham van der Weide', 850, NULL, '1767', NULL, NULL, 'D', 'D', '1771-12-31', 'Goeree', '1772-04-24', '1772-05-11', true, '1772-07-12', 'Batavia', 7869, 'attempted to set out for the first time; fifteen days later it had to return to TexeL');
INSERT INTO "voyages" VALUES (4129, '', 2, '', 'VROUWE MARIA JAKOBA', 'Marten Pietersz. Mooy', 880, NULL, '1765', NULL, NULL, 'H', 'H', '1772-01-17', 'Texel', '1772-05-11', '1772-06-09', true, '1772-08-18', 'Batavia', 7873, 'Texel with a crew consisting of 208 men.');
INSERT INTO "voyages" VALUES (4130, '', 3, '', 'RITTHEM', 'J. F. Lindeman', 880, NULL, '1764', NULL, NULL, 'Z', 'Z', '1772-01-21', 'Rammekens', '1772-05-13', '1772-06-22', true, '1772-08-29', 'Batavia', 7867, NULL);
INSERT INTO "voyages" VALUES (4131, '', 4, '', 'JONGE SAMUEL', 'Gerrit Evertsz. Popta', 880, NULL, '1761', NULL, NULL, 'Z', 'Z', '1772-01-21', 'Rammekens', '1772-05-11', '1772-06-20', true, '1772-08-25', 'Batavia', 7879, 'first time; sixteen days later it had to return to Rammekens. One source mentions G. L. Popken as master of the JONGE SAM-UEL.');
INSERT INTO "voyages" VALUES (4132, '', 3, '', 'WILLEM DE VIJFDE', 'Kornelis Klingweel', 1150, NULL, '1765', NULL, NULL, 'Z', 'Z', '1772-01-21', 'Rammekens', '1772-05-13', '1772-05-24', true, '1772-07-31', 'Batavia', 7871, 'On 05-12-1771 the WILLEM DE VIJFDE attempted to put out for the first time; sixteen days later the ship had to return to Rammekens. According to KA 3230 it finally departed from Rammekens with a crew consisting of 309 men.');
INSERT INTO "voyages" VALUES (4133, '', 1, '', 'HUIS TE KROOSWIJK', 'Frederik Wielard', 850, NULL, '1770', NULL, NULL, 'R', 'R', '1772-02-17', 'Goeree', '1772-06-03', '1772-06-26', true, '1772-08-26', 'Batavia', 7894, 'On 05-12-1771 the HUIS TE KROOSWIJK attempted to put out for the first time, two weeks later it had to return to Goeree. The ship called at Spithead, 24-02-1772.');
INSERT INTO "voyages" VALUES (4134, '', 1, '', 'MERCUUR', 'Christiaan Andries Spin', 850, NULL, '1770', NULL, NULL, 'D', 'D', '1772-04-01', 'Goeree', '1772-07-08', '1772-07-30', true, '1772-10-03', 'Batavia', 7884, NULL);
INSERT INTO "voyages" VALUES (4135, '', 5, '', 'DUINENBURG', 'Pieter Thomasz.', 1100, NULL, '1757', NULL, NULL, 'Z', 'Z', '1772-04-27', 'Rammekens', '1772-08-23', '1772-09-19', true, '1772-11-26', 'Batavia', 7883, NULL);
INSERT INTO "voyages" VALUES (4136, '', 5, '', 'JONGE LIEVE', 'Jan Frederik Raatjes', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1772-05-12', 'Texel', '1772-09-17', '1772-10-27', true, '1773-01-28', 'Batavia', 7891, 'See the VROUWE KORNELIA HILLEGONDA (4116). The following data refer to the crew of the JONGE LIEVE as well as to the crew of the RIDDERKERK (4137): 355 seafarers, 174 soldiers, and 25 craftsmen departed from the Republic or embarked at the Cape; 266 seafarers, 120 soldiers, and 18 craftsmen arrived at Batavia,');
INSERT INTO "voyages" VALUES (4137, '', 3, '', 'RIDDERKERK', 'Michiel Hendrik Wunder', 850, NULL, '1766', NULL, NULL, 'R', 'A', '1772-05-12', 'Texel', '1772-09-18', '1772-10-25', true, '1773-01-27', 'Batavia', 7888, 'See the VROUWE KORNELIA HILLEGONDA (4116) and the JONGE LIEVE (4136).');
INSERT INTO "voyages" VALUES (4138, '', 4, '', 'WESTERVELD', 'Andries Bruin', 1100, NULL, '1761', NULL, NULL, 'A', 'A', '1772-05-12', 'Texel', '1772-09-04', '1772-10-09', true, '1773-01-22', 'Batavia', 7917, NULL);
INSERT INTO "voyages" VALUES (4139, '', 2, '', 'JONGE HELLINGMAN', 'Jan Balthus Meyer', 850, NULL, '1767', NULL, NULL, 'H', 'H', '1772-05-19', 'Texel', '1772-09-19', '1772-10-25', true, '1773-01-25', 'Batavia', 7905, NULL);
INSERT INTO "voyages" VALUES (4140, '', 4, '', 'ZILVEREN LEEUW', 'Marten Hakker', 880, NULL, '1765', NULL, NULL, 'D', 'R', '1772-05-19', 'Goeree', '1772-09-11', '1772-10-25', true, '1773-01-22', 'Batavia', 7910, 'departed from Goeree with a crew consisting of 244 persons.');
INSERT INTO "voyages" VALUES (4141, '', 6, '', 'VLISSINGEN', 'J. de Fik', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1772-05-23', 'Rammekens', '1772-11-02', '1772-12-04', true, '1773-03-09', 'Batavia', NULL, 'Cape; 282 seafarers, 122 soldiers, and 23 craftsmen arrived at Batavia,');
INSERT INTO "voyages" VALUES (4142, '', 5, '', 'RENSWOUDE', 'Stoffel Kok', 1150, NULL, '1756', NULL, NULL, 'A', 'Z', '1772-07-05', 'Rammekens', '1772-11-02', '1772-12-21', true, '1773-04-11', 'Batavia', NULL, 'The RENSWOUDE was laid up in the Indies, 01-01-1780. See the VROUWE KORNELIA HILLEGONDA (4116) and the VLISSINGEN (4141),');
INSERT INTO "voyages" VALUES (4143, '', 2, '', 'OUWERKERK', 'Josua de Wolf van Ieperen', 1150, NULL, '1768', NULL, NULL, 'Z', 'Z', '1772-08-26', 'Rammekens', '1773-01-26', NULL, true, '1773-01-26', 'The Cape', 7887, 'The OUWERKERK was bound for the Cape. The crew consisted for the greater part of soldiers, placed at the disposal of the Dutch authorities at the Cape.');
INSERT INTO "voyages" VALUES (4144, '', 1, '', 'BEEMSTER WELVAREN', 'Marten Schoning', 850, NULL, '1770', NULL, NULL, 'E', 'E', '1772-09-11', 'Texel', '1773-02-18', '1773-03-07', true, '1773-06-07', 'Batavia', 7928, 'ANTHOINETTA KOENRARDINA (4145), the JUNO (4146), and the FOREEST (4150): 19 seafarers, 13 soldiers, and 2 craftsmen died at Porto Prayo, S. Tiago; 25 men deserted; at the Cape 554 seafarers, 357 soldiers, 30 craftsmen, and 15 passengers disembarked; during the voyage 496 seafarers, 410 soldiers, 61 craftsmen, and 6 passengers died.');
INSERT INTO "voyages" VALUES (4145, '', 3, '', 'VROUWE ANTHOINETTA KOENRARDINA', 'Jan Kaatman', 880, NULL, '1765', NULL, NULL, 'D', 'D', '1772-09-29', 'Goeree', '1773-02-13', '1773-03-07', true, '1773-06-09', 'Batavia', 7918, 'Specified data concerning the crew of the VROUWE ANTHOINETTA KOENRARDINA: 203 seafarers, 73 soldiers, 22 craftsmen, and 11 passengers departed from the Republic or embarked at the Cape. See also the BEEMSTER WELVAREN (4144).');
INSERT INTO "voyages" VALUES (4146, '', 1, '', 'JUNO', 'Pieter Verkerk', 850, NULL, '1771', NULL, NULL, 'R', 'R', '1772-10-19', 'Goeree', '1773-04-11', '1773-04-24', true, '1773-07-22', 'Batavia', 7892, 'BEEMSTER WELVAREN (4144). The following data refer to the crew of the JUNO as well as to the crews of the ASCHAT (4147), the AZIE (4148), and the HOLLAND (4157): at Portsmouth 3 seafarers, 9 soldiers, and 2 craftsmen died. Data concerning both the aforesaid four ships and the FOREEST (4150), the OVERHOUT (4151), the VOORBERG (4153), and the EUROPA (4155): at Duins and Portsmouth 24 men were pressed by the English.');
INSERT INTO "voyages" VALUES (4147, '', 5, '', 'ASC H AT', 'Reindert den Uil', 1150, NULL, '1760', NULL, NULL, 'A', 'A', '1772-10-20', 'Texel', '1773-04-15', '1773-06-14', true, '1773-09-08', 'Batavia', 7902, '13 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4148, '', 3, '', 'AZIE', 'Christiaan Blom', 1100, NULL, '1765', NULL, NULL, 'Z', 'A', '1772-10-20', 'Texel', '1773-04-11', '1773-05-26', true, '1773-08-25', 'Batavia', 7896, 'was altered into AZIE again (7847).');
INSERT INTO "voyages" VALUES (4149, '', 4, '', 'BARTHA PETRONELLA', 'Jakob Hendrik Johansen', 880, NULL, '1764', NULL, NULL, 'H', 'A', '1772-10-20', 'Texel', '1773-05-19', NULL, true, '1773-05-19', 'The Cape', 7890, 'The BARTHA PETRONELLA called at Portsmouth (25-10 till 19-11-1772) and at Plymouth (19-11-1772 till 03-02-1773), The ship was bound for the Cape.');
INSERT INTO "voyages" VALUES (4150, '', 1, '', 'FOREEST', 'Kornelis Brouwer', 850, NULL, '1770', NULL, NULL, 'H', 'H', '1772-10-20', 'Texel', '1773-04-15', '1773-05-05', true, '1773-08-05', 'Batavia', 7897, 'VOORBERG (4153), and the EUROPA (4155)t at Duins 12 seafarers, 17 soldiers, and 2 craftsmen died.');
INSERT INTO "voyages" VALUES (4151, '', 1, '', 'OVERHOUT', 'Hendrik Willemse', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1772-10-20', 'Texel', '1773-04-14', '1773-06-14', true, '1773-09-08', 'Batavia', 7901, 'From 22-10 till 15-11-1772 the OVERHOUT called at Duins (see the FOREEST, 4150; see also the JUNO, 4146). See the BEEMSTER WELVAREN (4144) and the ASCHAT (4147).');
INSERT INTO "voyages" VALUES (4152, '', 4, '', 'JONGE THOMAS', 'Barend de la Main', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1772-10-20', 'Texel', '1773-03-29', NULL, true, NULL, NULL, NULL, 'From 22-10 till 15-11-1772 the JONGE THOMAS called at Duins. In the Table Bay at the Cape the ship was wrecked, 01-06-1773.');
INSERT INTO "voyages" VALUES (4153, '', 1, '', 'VOORBERG', 'Frederik Visser', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1772-10-20', 'Texel', '1773-04-17', '1773-04-24', true, '1773-07-07', 'Batavia', 7907, 'see the JUNO, 4146). After having called at Batavia, the ship sailed on to China. See the BEEMSTER WELVAREN (4144) and the ASCHAT (4147).');
INSERT INTO "voyages" VALUES (4154, '', 3, '', 'DUIVENBRUG', 'Willem Hartsz.', 850, NULL, '1766', NULL, NULL, 'E', 'A', '1772-10-21', 'Texel', '1773-04-11', '1773-07-01', true, '1773-10-02', 'Batavia', 7977, 'See the BEEMSTER WELVAREN (4144).');
INSERT INTO "voyages" VALUES (4155, '', 1, '', 'EUROPA', 'Jakob de Frein', 1200, NULL, '1770', NULL, NULL, 'Z', 'Z', '1772-10-23', 'Rammekens', '1773-04-09', '1773-04-24', true, '1773-07-07', 'Batavia', 7906, 'From 27-10 till 19-11-1772 the EUROPA was at Duins (see the FOREEST, 4150; see the JUNO, 4146). After having called at Batavia, the EUROPA sailed on to China. See the BEEMSTER WELVAREN (4144).');
INSERT INTO "voyages" VALUES (4156, '', 6, '', 'BLEISWIJK', 'C. de Roo', 880, NULL, '1756', NULL, NULL, 'D', 'Z', '1772-11-15', 'Rammekens', '1773-09-26', '1773-10-28', true, '1774-02-01', 'Batavia', NULL, 'The BLEISWIJK called at Rochefort, 14-12-1772 till 14-01-1773. During the voyage 46 members of the crew deserted. In 1777 the BLEISWIJK was wrecked in the Indies.');
INSERT INTO "voyages" VALUES (4157, '', 1, '', 'HOLLAND', 'Hans Hansen', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1772-11-15', 'Texel', '1773-04-09', '1773-04-24', true, '1773-07-03', 'Batavia', 7905, 'at Portsmouth (see the JUNO, 4146). After having called at Batavia, the ship sailed on to China. See the BEEMSTER WELVAREN (4144) and the ASCHAT (4147).');
INSERT INTO "voyages" VALUES (4158, '', 3, '', 'ZON', 'Andries Hansen', 450, 'hoeker', '1768', NULL, NULL, 'A', 'A', '1772-12-24', 'Texel', '1773-06-27', NULL, true, '1773-06-27', 'The Cape', NULL, 'The ZON called at St. Paulo de Luanda: departure: 03-05-1773 (see also the BEEKVLIET, 4104). The ship was bound for the Cape; it was laid up in 1782.');
INSERT INTO "voyages" VALUES (4159, '', 5, '', 'HUIS TE BIJWEG', 'Jan Paardekoper', 1100, NULL, '1760', NULL, NULL, 'A', 'A', '1772-12-25', 'Texel', '1773-04-15', '1773-05-05', true, '1773-07-07', 'Batavia', 7900, 'See the BEEMSTER WELVAREN (4144) and the ASCHAT (4147).');
INSERT INTO "voyages" VALUES (4160, '', 3, '', 'LANDSKROON', 'Michiel Hamelo', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1772-12-25', 'Texel', '1773-04-09', '1773-05-15', true, '1773-07-08', 'Ceylon', 7913, NULL);
INSERT INTO "voyages" VALUES (4161, '', 3, '', '''T LOO', 'Klaas Roem', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1772-12-25', 'Texel', '1773-04-06', '1773-05-26', true, '1773-08-05', 'Batavia', 7898, 'See the BEEMSTER WELVAREN (4144) and the ASCHAT (4147).');
INSERT INTO "voyages" VALUES (4162, '', 3, '', 'OOSTKAPELLE', 'Jan Abel', 1150, NULL, '1767', NULL, NULL, 'Z', 'A', '1772-12-25', 'Texel', '1773-04-15', '1773-05-05', true, '1773-07-17', 'Batavia', 7930, 'See the BEEMSTER WELVAREN (4144) and the ASCHAT (4147).');
INSERT INTO "voyages" VALUES (4163, '', 4, '', 'VREEBURG', 'Hendrik Hilverduin', 850, NULL, '1764', NULL, NULL, 'D', 'E', '1772-12-25', 'Texel', '1773-04-07', '1773-05-04', true, '1773-06-16', 'Batavia', 7895, 'See the BEEMSTER WELVAREN (4144) and the ASCHAT (4147).');
INSERT INTO "voyages" VALUES (4164, '', 5, '', '''S LANDS WELVAREN', 'Frederik Kelger', 880, NULL, '1762', NULL, NULL, 'A', 'A', '1772-12-25', 'Texel', '1773-04-07', '1773-05-26', true, '1773-08-28', 'Bengal', NULL, 'Sailing on the Ganges the ''S LANDS WELVAREN ran aground, 28-08-1773. The ship was laid up in Bengal, 12-01-1774.');
INSERT INTO "voyages" VALUES (4165, '', 3, '', 'OUD HAARLEM', 'Jan Siereveld', 1150, NULL, '1768', NULL, NULL, 'A', 'Z', '1772-12-26', 'Rammekens', '1773-04-11', '1773-05-15', true, '1773-07-16', 'Ceylon', 7912, NULL);
INSERT INTO "voyages" VALUES (4166, '', 1, '', 'ZEEDUIN', 'Kornelis Pietersen', 1150, NULL, '1771', NULL, NULL, 'Z', 'Z', '1773-02-08', 'Rammekens', '1773-05-26', '1773-07-07', true, '1773-09-10', 'Batavia', 8023, 'See the BEEMSTER WELVAREN (4144).');
INSERT INTO "voyages" VALUES (4167, '', 2, '', 'HOOLWERF', 'Willem Dona', 850, NULL, '1769', NULL, NULL, 'H', 'D', '1773-04-09', 'Goeree', '1773-08-31', '1773-09-28', true, '1773-11-28', 'Batavia', 7909, 'See the BEEKVLIET (4104). The following data refer to the crew of the HOOLWERF as well as to the crews of the VROUWE GEERTRUIDA (4169), the VROUWE ELISA-BETH (4171), and the IJSSELMONDE (4172): at the Cape 142 seafarers, 71 soldiers and 11 craftsmen disembarked.');
INSERT INTO "voyages" VALUES (4168, '', 3, '', 'BLEIJENBURG', 'Barend de Rust', 880, NULL, '1765', NULL, NULL, 'R', 'A', '1773-05-05', 'Texel', '1773-11-07', '1773-12-08', true, '1774-03-10', 'Batavia', 7968, 'During the voyage 5 members of the crew deserted.');
INSERT INTO "voyages" VALUES (4169, '', 6, '', 'VROUWE GEERTRUIDA', 'Willem Bruelle', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1773-05-05', 'Texel', '1773-08-01', '1773-08-24', true, '1773-11-28', 'Batavia', NULL, 'See the BEEKVLIET (4104) and the HOOLWERF (4167). The VROUWE GEERTRUIDA was laid up in the Indies, 01-01-1779.');
INSERT INTO "voyages" VALUES (4170, '', 5, '', 'PALLAS', 'Asmus Hendrik Sterrenberg', 1150, NULL, '1762', NULL, NULL, 'Z', 'A', '1773-05-05', 'Texel', '1773-09-05', '1773-11-02', true, '1774-02-04', 'Batavia', 7916, 'During the voyage one member of the crew deserted.');
INSERT INTO "voyages" VALUES (4171, '', 5, '', 'VROUWE ELISABETH', 'Jurriaan Willemsz. Greveling', 850, NULL, '1755', NULL, NULL, 'R', 'R', '1773-05-14', 'Goeree', '1773-08-31', '1773-09-28', true, '1773-12-02', 'Batavia', NULL, 'BEEKVLIET (4104) and the HOOLWERF (4167). The VROUWE ELISABETH was laid up in the Indies, 01-01-1777.');
INSERT INTO "voyages" VALUES (4172, '', 3, '', 'IJSSELMONDE', 'Gerrit van der Gracht', 880, NULL, '1762', NULL, NULL, 'R', 'H', '1773-06-10', 'Texel', '1773-10-03', '1773-10-28', true, '1774-01-04', 'Batavia', NULL, 'the Indies, 01-01-1778.');
INSERT INTO "voyages" VALUES (4173, '', 5, '', 'HUIS OM', 'Christiaan Rebel', 1150, NULL, '1761', NULL, NULL, 'Z', 'Z', '1773-06-30', 'Rammekens', '1774-03-15', '1774-04-25', true, '1774-07-19', 'Batavia', 7946, 'soldiers, 43 craftsmen, and 2 passengers died.');
INSERT INTO "voyages" VALUES (4174, '', 2, '', 'LAM', 'Olke Hendrik Andringa', 850, NULL, '1769', NULL, NULL, 'D', 'E', '1773-07-02', 'Texel', '1773-11-16', '1773-12-20', true, '1774-03-28', 'Batavia', 7933, NULL);
INSERT INTO "voyages" VALUES (4175, '', 4, '', 'BORSSELE', 'Johan Frederik Schuts', 1150, NULL, '1758', NULL, NULL, 'Z', 'Z', '1773-07-14', 'Rammekens', '1773-10-16', '1773-12-02', true, '1774-02-01', 'Batavia', 7919, 'During the voyage 6 members of the crew deserted.');
INSERT INTO "voyages" VALUES (4176, '', 1, '', 'HOOP', 'Michiel Kooplijn', 800, 'fluit', NULL, NULL, NULL, 'A', 'A', '1773-07-31', 'Texel', '1773-12-14', NULL, true, '1773-12-14', 'The Cape', 7911, 'The HOOP was bound for the Cape.');
INSERT INTO "voyages" VALUES (4177, '', 1, '', 'EENDRACHT', 'Thomas de Beukelaar', 850, NULL, '1771', NULL, NULL, 'D', 'D', '1773-10-07', 'Goeree', '1774-03-19', '1774-04-13', true, '1774-06-18', 'Batavia', 8015, 'one passenger departed from Goeree or embarked at the Cape. See the HUIS OM (4173).');
INSERT INTO "voyages" VALUES (4178, '', 1, '', 'BREDENHOF', 'Marten Pietersz. Mooy', 850, NULL, '1771', NULL, NULL, 'H', 'H', '1773-12-07', 'Texel', '1774-04-28', '1774-05-11', true, '1774-07-21', 'Batavia', 7920, 'from Texel or embarked at the Cape. See the HUIS OM (4173).');
INSERT INTO "voyages" VALUES (4179, '', 1, '', 'HOOGKARSPEL', 'Pieter Helmers', 850, NULL, '1771', NULL, NULL, 'E', 'E', '1773-12-07', 'Texel', '1774-05-14', '1774-06-13', true, '1774-09-08', 'Batavia', 7927, 'the crew of the HOOGKARSPEL: 221 seafarers and 27 soldiers departed from Texel or embarked at the Cape, During the voyage 3 members of the crew deserted. See the HUTS OM (4173).');
INSERT INTO "voyages" VALUES (4180, '', 2, '', 'ALKEMADE', 'Daniel Deune', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1773-12-08', 'Texel', '1774-05-01', '1774-07-12', true, '1774-09-09', 'Batavia', 7926, 'During the voyage 3 members of the crew deserted. See the HUIS OM (4173). The following data refer to the crew of the ALKEMADE as well as to the crews of the HONKOOP (see 4182), the VENUS (4184), the AMSTERDAM (4185), the GROENENDAAL (4186), the VRIJHEID (4187), the BOTLAND (4191), and the PRINSES VAN ORANJE (4193): 131 seafarers, 66 soldiers, and 6 craftsmen embarked at the Cape.');
INSERT INTO "voyages" VALUES (4181, '', 1, '', 'CERES', 'Wopke Popta', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1773-12-08', 'Texel', '1774-04-27', '1774-05-11', true, '1774-07-19', 'Batavia', 7929, 'After having called at Batavia the CERES sailed on to China. See the HUIS OM (4173).');
INSERT INTO "voyages" VALUES (4182, '', 2, '', 'HONKOOP', 'Pieter Haverkamp', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1773-12-08', 'Texel', '1774-04-25', '1774-06-08', true, '1774-09-06', 'Batavia', 7934, 'During the voyage 8 members of the crew deserted. See the HUIS OM (4173) and the ALKEMADE (4180).');
INSERT INTO "voyages" VALUES (4183, '', 1, '', 'NOORDBEEK', 'J. Wellegaart', 850, 'fluit', NULL, '1773', NULL, 'Z', 'Z', '1773-12-08', 'Rammekens', '1774-04-28', NULL, true, '1774-04-28', 'The Cape', 7915, 'The NOORDBEEK was bound for the Cape.');
INSERT INTO "voyages" VALUES (4184, '', 1, '', 'VENUS', 'Gerrit ten Sunder', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1773-12-08', 'Texel', '1774-05-03', '1774-05-16', true, '1774-08-30', 'Batavia', 8014, 'See the HUIS OM (4173) and the ALKEMADE (4180).');
INSERT INTO "voyages" VALUES (4185, '', 1, '', 'AMSTERDAM', 'Koenraad Louwe', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1773-12-09', 'Texel', '1774-04-25', '1774-05-31', true, '1774-08-09', 'Batavia', 7976, 'HUIS OM (4173) and the ALKEMADE (4180).');
INSERT INTO "voyages" VALUES (4186, '', 2, '', 'GROENENDAAL', 'Jan Stil', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1773-12-09', 'Texel', '1774-04-24', '1774-05-23', true, '1774-07-26', 'Batavia', 7922, 'During the voyage 3 members of the crew deserted. See the HUIS OM (4173) and the ALKEMADE (4180).');
INSERT INTO "voyages" VALUES (4187, '', 1, '', 'VRIJHEID', 'Jan Och', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1773-12-09', 'Texel', '1774-04-10', '1774-04-21', true, '1774-07-07', 'Batavia', 7931, 'After having called at Batavia the VRIJHEID sailed on to China. See also the HUIS OM (4173) and the ALKEMADE (4180).');
INSERT INTO "voyages" VALUES (4188, '', 1, '', 'DANKBAARHEID', 'Joachim Ernst Wend', 850, NULL, '1772', NULL, NULL, 'R', 'R', '1773-12-13', 'Goeree', '1774-04-25', '1774-05-11', true, '1774-07-26', 'Batavia', 7921, 'Specified data concerning the crew of the DANKBAARHEID: 169 seafarers, 70 soldiers, and 12 craftsmen departed from Goeree or embarked at the Cape. See also the HUIS OM (4173).');
INSERT INTO "voyages" VALUES (4189, '', 1, '', 'MARS', 'Johan van Voorst', 1150, NULL, '1771', NULL, NULL, 'Z', 'Z', '1773-12-13', 'Rammekens', '1774-04-30', '1774-05-11', true, '1774-07-21', 'Batavia', 7923, 'During the voyage 5 members of the crew deserted. See also the HUIS OM (4173).');
INSERT INTO "voyages" VALUES (4190, '', 4, '', 'WILLEM DE VIJFDE', 'Josua de Wolf van leperen', 1150, NULL, '1766', NULL, NULL, 'Z', 'Z', '1773-12-13', 'Rammekens', '1774-04-30', '1774-05-16', true, '1774-07-28', 'Batavia', 7935, 'See the HUIS OM (4173).');
INSERT INTO "voyages" VALUES (4191, '', 2, '', 'BOTLAND', 'Joost Koen', 1150, NULL, '1769', NULL, NULL, 'Z', 'A', '1773-12-14', 'Texel', '1774-04-24', '1774-05-23', true, '1774-07-21', 'Batavia', 7925, 'During the voyage one member of the crew deserted. See the HUIS OM (4173) and the ALKEMADE (4180).');
INSERT INTO "voyages" VALUES (4192, '', 4, '', 'BOVENKERKER POLDER', 'Kornelis Bos', 850, NULL, '1765', NULL, NULL, 'A', 'A', '1773-12-15', 'Texel', '1774-04-30', '1774-05-16', true, '1774-09-23', 'Bengal', 7932, NULL);
INSERT INTO "voyages" VALUES (4193, '', 3, '', 'PRINSES VAN ORANJE', 'Karsten Eggers', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1773-12-15', 'Texel', '1774-05-14', '1774-06-25', true, '1774-09-22', 'Batavia', 7967, 'During the voyage 7 members of the crew deserted. See the HUIS OM (4173) and the ALKEMADE (4180).');
INSERT INTO "voyages" VALUES (4194, '', 5, '', 'ZUID-BEVELAND', 'Hendrik Nieuwboer', 1100, NULL, '1755', NULL, NULL, 'Z', 'A', '1773-12-15', 'Texel', '1774-04-25', '1774-05-12', true, '1774-07-13', 'Ceylon', 7937, NULL);
INSERT INTO "voyages" VALUES (4195, '', 3, '', 'VELDHOEN', 'Justus Hendrik Pfeil', 1150, NULL, '1765', NULL, NULL, 'A', 'A', '1773-12-29', 'Texel', '1774-04-30', '1774-05-15', true, '1774-07-11', 'Ceylon', 7936, NULL);
INSERT INTO "voyages" VALUES (4196, '', 3, '', 'OUWERKERK', 'Johan Splinter Stavorinus', 1150, NULL, '1768', NULL, NULL, 'Z', 'Z', '1774-03-10', 'Rammekens', '1774-07-12', '1774-08-03', true, '1774-10-28', 'Batavia', 8002, 'soldiers, 29 craftsmen, and 3 passengers departed from the Republic or embarked at the Cape; 294 seafarers, 143 soldiers, 17 craftsmen, and 3 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4197, '', 3, '', 'BOT', 'Lambert Arnout Halfman', 1150, NULL, '1768', NULL, NULL, 'Z', 'Z', '1774-04-28', 'Rammekens', '1774-09-10', '1774-10-09', true, '1774-12-19', 'Batavia', 7941, '(4202): 994 seafarers, 387 soldiers, 64 craftsmen, and 20 passengers departed from the Republic or embarked at the Cape; one seafarer and one soldier deserted at S. Tiago; at the Cape 125 seafarers, 78 soldiers, 14 craftsmen, and 7 passengers went ashore, during the voyage 74 seafarers, 32 soldiers, and 4 craftsmen died; 794 seafarers, 276 soldiers, 46 craftsmen, and 13 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4198, '', 2, '', 'MERCUUR', 'Hendrik Mulder', 850, NULL, '1770', NULL, NULL, 'D', 'R', '1774-05-01', 'Goeree', '1774-09-09', '1774-10-01', true, '1774-12-13', 'Batavia', 7939, 'See the BOT (4197).');
INSERT INTO "voyages" VALUES (4199, '', 4, '', 'WOESTDUIN', 'Pieter Thijssen jr.', 1150, NULL, '1767', NULL, NULL, 'A', 'A', '1774-05-01', 'Texel', '1774-09-06', '1774-09-27', true, '1774-11-18', 'Batavia', 7947, 'See the BOT (4197).');
INSERT INTO "voyages" VALUES (4200, '', 1, '', 'MORGENSTER', 'Gerrit Springer', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1774-05-04', 'Texel', '1774-09-10', '1774-09-27', true, '1774-12-13', 'Batavia', 7957, 'See the BOT (4197).');
INSERT INTO "voyages" VALUES (4201, '', 3, '', 'PAUW', 'Johan Snijders', 850, NULL, '1767', NULL, NULL, 'D', 'D', '1774-05-11', 'Goeree', '1774-07-31', '1774-08-30', true, '1774-10-25', 'Batavia', 7959, 'See the OUWERKERK (4196).');
INSERT INTO "voyages" VALUES (4202, '', 1, '', 'WAKKERHEID', 'Jakob Hendrik Johansen', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1774-05-20', 'Texel', '1774-09-11', '1774-10-09', true, '1774-12-26', 'Batavia', 7992, 'See the BOT (4197).');
INSERT INTO "voyages" VALUES (4203, '', 3, '', 'VROUWE MARIA JAKOBA', 'Pieter Dekker', 880, NULL, '1765', NULL, NULL, 'H', 'H', '1774-06-12', 'Texel', '1774-12-15', '1775-01-10', true, '1775-04-27', 'Batavia', NULL, 'The VROUWE MARIA JAKOBA called at Duins, where 3 seafarers deserted. During the voyage 4 other members of the crew deserted. The ship was laid up in the Indies, 31-12-1780.');
INSERT INTO "voyages" VALUES (4204, '', 4, '', 'RITTHEM', 'Jan Everwijk Drillinger', 880, NULL, '1764', NULL, NULL, 'Z', 'E', '1774-06-17', 'Texel', '1774-12-22', '1775-01-10', true, '1775-05-05', 'Batavia', 7953, NULL);
INSERT INTO "voyages" VALUES (4205, '', 5, '', 'JONGE SAMUEL', 'Jakob de Vos', 880, NULL, '1761', NULL, NULL, 'Z', 'R', '1774-07-25', 'Goeree', '1774-12-16', '1774-12-31', true, '1775-03-04', 'Batavia', 7949, 'During the voyage 2 members of the crew deserted.');
INSERT INTO "voyages" VALUES (4206, '', 5, '', 'BARTHA PETRONELLA', 'Justinus van Gennep', 880, NULL, '1764', NULL, NULL, 'H', 'Z', '1774-07-26', 'Rammekens', '1774-11-20', '1774-12-18', true, '1775-03-01', 'Batavia', 7944, 'During the voyage one member of the crew deserted.');
INSERT INTO "voyages" VALUES (4207, '', 2, '', 'HERSTELDER', 'Jan Petri', 600, 'fregat', NULL, '1772', NULL, 'C', 'D', '1774-07-26', 'Goeree', '1774-12-10', '1775-01-21', true, '1775-11-04', 'Batavia', 7965, 'After having called at the Cape the HERSTELDER sailed to Ceylon; on 05-05-1775 it departed from Ceylon, destination: Batavia.');
INSERT INTO "voyages" VALUES (4208, '', 1, '', 'STAVENISSE', 'Gerrit Evertsz. Popta', 1150, NULL, '1772', NULL, NULL, 'Z', 'Z', '1774-07-26', 'Rammekens', '1774-11-13', '1774-12-13', true, '1775-02-22', 'Batavia', 8046, 'During the voyage 7 members of the crew deserted.');
INSERT INTO "voyages" VALUES (4209, '', 2, '', 'HOOP', 'Swerus Vrolijk', 800, 'fluit', NULL, NULL, NULL, 'A', 'A', '1774-08-04', 'Texel', '1774-12-31', NULL, true, '1774-12-31', 'The Cape', 7938, NULL);
INSERT INTO "voyages" VALUES (4210, '', 1, '', 'INDIAAN', 'Frederik Raatjes', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1774-09-15', 'Texel', '1775-01-24', '1775-02-08', true, '1775-06-17', 'Batavia', 7943, 'PATRIOT (4219), the EUROPA (4221), the ABBEKERK (4222), and the HOF TER LINDEN (4223): at the Cape 226 seafarers, 75 soldiers, 12 craftsmen, and 2 passengers went ashore, 77 seafarers, 49 soldiers, 4 craftsmen, and I 1 passengers embarked; during the voyage 155 seafarers, 63 soldiers, and 13 craftsmen died.');
INSERT INTO "voyages" VALUES (4211, '', 6, '', 'JONGE LIEVE', 'Willem Ferret', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1774-09-15', 'Texel', '1775-02-17', '1775-03-28', true, '1775-07-08', 'Batavia', 7954, 'The JONGE LIEVE called at Portsmouth: one seafarer died, one craftsmen deserted. During the voyage one other member of the crew deserted. See the INDIAAN (4210).');
INSERT INTO "voyages" VALUES (4212, '', 4, '', 'RIDDERKERK', 'Christiaan van Veerden', 850, NULL, '1766', NULL, NULL, 'R', 'A', '1774-09-15', 'Texel', '1775-02-06', '1775-03-16', true, '1775-06-19', 'Batavia', 7951, 'The RIDDERKERK called at Dartmouth: 8 seafarers and one soldier deserted. See the INDIAAN (4210).');
INSERT INTO "voyages" VALUES (4213, '', 5, '', 'NIEUW RHOON', 'Jakob Koelders', 1150, NULL, '1764', NULL, NULL, 'Z', 'Z', '1774-09-18', 'Rammekens', '1774-12-30', '1775-01-24', true, '1775-04-25', 'Batavia', 7955, 'During the voyage 2 members of the crew deserted.');
INSERT INTO "voyages" VALUES (4214, '', 4, '', '''T LOO', 'Gerrit Berg', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1774-09-26', 'Texel', '1775-01-24', '1775-03-02', true, '1775-06-18', 'Batavia', 7945, 'During the voyage 2 members of the crew deserted. See also the INDIAAN (4210).');
INSERT INTO "voyages" VALUES (4215, '', 1, '', 'DELFSHAVEN', 'Christiaan Andries Spin', 850, NULL, '1772', NULL, NULL, 'D', 'D', '1774-09-27', 'Goeree', '1775-01-15', '1775-02-02', true, '1775-04-28', 'Batavia', 799, 'The DELFSHAVEN called at Duins, where 6 seafarers were pressed by the English,');
INSERT INTO "voyages" VALUES (4216, '', 6, '', 'ASCHAT', 'Jan Paardekoper', 1150, NULL, '1760', NULL, NULL, 'A', 'A', '1774-10-27', 'Texel', '1775-03-17', '1775-05-02', true, '1775-08-01', 'Batavia', NULL, 'The ASCHAT sailed via Bantam, where 6 seafarers went ashore. During the voyage 3 members of the crew deserted. See also the INDIAAN (4210). In 1776 the ASCHAT was wrecked in the Indies.');
INSERT INTO "voyages" VALUES (4217, '', 1, '', 'JONGE HUGO', 'Hendrik Hilverduin', 850, NULL, '1772', NULL, NULL, 'E', 'E', '1774-10-27', 'Texel', '1775-02-25', '1775-03-16', true, '1775-06-11', 'Batavia', 7942, 'After having called at Batavia the JONGE HUGO sailed on to China. See the INDIAAN (4210),');
INSERT INTO "voyages" VALUES (4218, '', 2, '', 'OVERHOUT', 'Pieter Angelvorst', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1774-10-27', 'Texel', '1775-02-15', '1775-03-21', true, '1775-06-19', 'Batavia', 7989, 'The OVERHOUT called at S. Tiago: one seafarer died, 2 seafarers and 2 soldiers deserted. During the voyage one other member of the crew deserted. See also the INDIAAN (4210).');
INSERT INTO "voyages" VALUES (4219, '', 1, '', 'PATRIOT', 'Jan Ide', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1774-10-27', 'Texel', '1775-03-06', '1775-04-08', true, '1775-07-18', 'Batavia', 7948, 'See the INDIAAN (4210).');
INSERT INTO "voyages" VALUES (4220, '', 1, '', 'RODENRIJS', 'Arend van der Deuren', 850, NULL, '1773', NULL, NULL, 'R', 'R', '1774-10-31', 'Goeree', '1775-09-27', '1775-10-27', true, '1776-01-02', 'Batavia', NULL, 'The RODENRUS called at Lisbon, 18-04 till 20-05-1775: 2 seafarers, 2 soldiers, and one craftsmen went ashore. The ship was laid up in the Indies, 31-12-1785.');
INSERT INTO "voyages" VALUES (4221, '', 2, '', 'EUROPA', 'Jakob de Frein', 1200, NULL, '1770', NULL, NULL, 'Z', 'Z', '1774-11-05', 'Rammekens', '1775-02-21', '1775-03-28', true, '1775-07-02', 'Batavia', 7956, 'During the voyage one member of the crew deserted. After having called at Batavia the EUROPA sailed on to China. See the INDIAAN (4210).');
INSERT INTO "voyages" VALUES (4222, '', 1, '', 'ABBEKERK', 'Gerrit Bruin', 850, NULL, '1772', NULL, NULL, 'H', 'H', '1774-12-05', 'Texel', '1775-04-17', '1775-05-02', true, '1775-07-24', 'Batavia', 7950, 'The ABBEKERK called at Bantam: 19 seafarers and 25 soldiers went ashore. During the voyage one member of the crew deserted, See the INDIAAN (4210).');
INSERT INTO "voyages" VALUES (4223, '', 1, '', 'HOF TER LINDEN', 'Jan Kornelis Roos', 1150, NULL, '1772', NULL, NULL, 'Z', 'Z', '1774-12-06', 'Rammekens', '1775-04-19', '1775-05-25', true, '1775-08-08', 'Batavia', 7952, 'During the voyage one member of the crew deserted. See also the INDIAAN (4210).');
INSERT INTO "voyages" VALUES (4224, '', 1, '', 'KATWIJK AAN DEN RIJN', 'Isaak Louis de Bellon', 750, NULL, NULL, '1774', NULL, 'A', 'A', '1775-01-16', 'Texel', '1775-04-29', NULL, true, '1775-04-29', 'The Cape', 7940, NULL);
INSERT INTO "voyages" VALUES (4225, '', 1, '', 'HUIS TE SPIJK', 'Michiel Kooplijn', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1775-01-17', 'Texel', '1775-06-04', '1775-06-29', true, '1775-10-31', 'Batavia', 7960, 'Specified data concerning the crew of the HUIS TE SPIJK: 305 seafarers, 43 soldiers, 17 craftsmen, and 3 passengers departed from Texel or embarked at the Cape. From 08-02 till 13-03-1775 the ship was at Torbay: 3 seafarers deserted.');
INSERT INTO "voyages" VALUES (4226, '', 2, '', 'VOORBERG', 'Reindert den Uil', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1775-01-17', 'Texel', NULL, NULL, false, '1775-10-01', 'Batavia', 7961, 'From 03-02 till 13-03-1775 the VOORBERG was at Duins.');
INSERT INTO "voyages" VALUES (4227, '', 3, '', 'HUIS TER MEIJEN', 'Klaas Roem', 1150, NULL, '1767', NULL, NULL, 'A', 'A', '1775-01-22', 'Texel', '1775-07-05', '1775-08-04', true, '1775-11-06', 'Ceylon', 7963, 'The HUIS TER MEIJEN called at Spithead, 07-02 till 18-03-1775.');
INSERT INTO "voyages" VALUES (4228, '', 3, '', 'JONGE HELLINGMAN', 'Pieter Verkerk', 850, NULL, '1767', NULL, NULL, 'H', 'R', '1775-04-06', 'Goeree', '1775-07-16', '1775-08-06', true, '1775-10-17', 'Batavia', 7996, NULL);
INSERT INTO "voyages" VALUES (4229, '', 2, '', 'FOREEST', 'Christiaan Blom', 850, NULL, '1770', NULL, NULL, 'H', 'A', '1775-04-07', 'Texel', '1775-07-14', '1775-08-04', true, '1775-11-10', 'Bengal', 7958, NULL);
INSERT INTO "voyages" VALUES (4230, '', 4, '', 'OUD HAARLEM', 'Jan Siereveld', 1150, NULL, '1768', NULL, NULL, 'A', 'Z', '1775-04-07', 'Rammekens', '1775-07-08', '1775-07-27', true, '1775-11-06', 'Ceylon', 7962, NULL);
INSERT INTO "voyages" VALUES (4231, '', 2, '', 'HOLLAND', 'Hendrik Willemse', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1775-04-27', 'Texel', '1775-08-17', '1775-09-09', true, '1775-12-04', 'Batavia', 7987, NULL);
INSERT INTO "voyages" VALUES (4232, '', 2, '', 'BEEKVLIET', 'Benjamin van der Spek', 850, NULL, '1770', NULL, NULL, 'A', 'A', '1775-04-29', 'Texel', '1775-09-08', '1775-10-06', true, '1776-01-23', 'Batavia', 7984, 'JUNO (4234), the VROUWE KORNELIA HILLEGONDA (4235), the TRITON (4237), the HOOLWERF (4241), and the GROENENDAAL (4243): 1333 seafarers, 625 soldiers, 84 craftsmen, and 7 passengers departed from the Republic or embarked at the Cape; 110 seafarers, 87 soldiers, and 5 craftsmen went ashore at the Cape; at Bantam 26 soldiers disembarked; during the voyage 46 seafarers, 31 soldiers, and 4 craftsmen died; 1173 seafarers, 481 soldiers, 75 craftsmen, and 6 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4233, '', 5, '', 'WESTFRIESLAND', 'J. F. Lindeman', 880, NULL, '1761', NULL, NULL, 'H', 'Z', '1775-06-02', 'Rammekens', '1775-11-09', '1775-12-02', true, '1776-02-15', 'Batavia', NULL, 'In Sunda Strait one passenger jumped overboard and swam to the shore. See the BEEKVLIET (4232). The WEST-FRIESLAND was laid up in the Indies, 31-12-1783.');
INSERT INTO "voyages" VALUES (4234, '', 2, '', 'JUNO', 'Willem Dona', 850, NULL, '1771', NULL, NULL, 'R', 'D', '1775-06-14', 'Goeree', '1775-10-16', '1775-11-11', true, '1776-01-29', 'Batavia', 8003, 'See the BEEKVLIET (4232).');
INSERT INTO "voyages" VALUES (4235, '', 5, '', 'VROUWE KORNELIA HILLEGONDA', 'Charles Smits', 850, NULL, '1760', NULL, NULL, 'D', 'H', '1775-06-16', 'Texel', '1775-10-16', '1775-11-11', true, '1776-01-29', 'Batavia', 7971, 'See the BEEKVLIET (4232).');
INSERT INTO "voyages" VALUES (4236, '', 4, '', 'LANDSKROON', 'Pieter Hofham', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1775-06-16', 'Texel', '1776-06-17', '1776-07-10', true, '1776-09-18', 'Batavia', NULL, 'passengers disembarked; 46 soldiers went ashore at Bantam; during the voyage 136 seafarers, 104 soldiers, 13 craftsmen, and one passenger died.');
INSERT INTO "voyages" VALUES (4237, '', 1, '', 'TRITON', 'Pieter van Prooien', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1775-06-27', 'Texel', '1775-12-29', '1776-01-23', true, '1776-04-19', 'Batavia', 7981, 'The TRITON called at Duins: one seafarer died, one seafarer deserted, another seafarer was pressed by the English. After having called at Batavia, the TRITON sailed on to China. See the BEEKVLIET (4232).');
INSERT INTO "voyages" VALUES (4238, '', 3, '', 'POPKENSBURG', 'Jakob de Meyer', 880, NULL, '1763', NULL, NULL, 'Z', 'Z', '1775-07-22', 'Rammekens', '1776-01-12', '1776-02-07', true, '1776-05-10', 'Batavia', 7973, 'the Cape: during the voyage 2 soldiers were sent back to Middelburg; 722 seafarers, 303 soldiers, 45 craftsmen, and 7 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4239, '', 2, '', 'HUIS TE KROOSWIJK', 'Schreuder', 850, NULL, '1770', NULL, NULL, 'R', 'R', '1775-08-25', 'Goeree', '1775-12-27', NULL, true, '1775-12-27', 'The Cape', 7964, NULL);
INSERT INTO "voyages" VALUES (4240, '', 2, '', 'NOORDBEEK', 'Jan Karel Wetterijk', 850, 'fluit', NULL, '1773', NULL, 'Z', 'Z', '1775-08-25', 'Rammekens', '1776-03-13', NULL, true, '1776-03-13', 'The Cape', 7966, NULL);
INSERT INTO "voyages" VALUES (4241, '', 3, '', 'HOOLWERF', 'C.Jaring', 850, NULL, '1769', NULL, NULL, 'H', 'E', '1775-08-26', 'Texel', '1775-12-26', '1776-01-17', true, '1776-04-20', 'Batavia', 8001, 'The HOOLWERF called at S. Tiago, where one seafarer deserted. See the BEEKVLIET (4232).');
INSERT INTO "voyages" VALUES (4242, '', 3, '', 'BOTLAND', 'Jurriaan Verburg', 1150, NULL, '1769', NULL, NULL, 'Z', 'A', '1775-09-15', 'Texel', '1776-01-16', '1776-03-09', true, '1776-05-31', 'Batavia', 7969, 'See the LANDSKROON (4236).');
INSERT INTO "voyages" VALUES (4243, '', 3, '', 'GROENENDAAL', 'Koen', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1775-09-15', 'Texel', '1775-12-25', '1776-02-04', true, '1776-04-19', 'Batavia', 8025, 'See the BEEKVLIET (4232).');
INSERT INTO "voyages" VALUES (4244, '', 3, '', 'HOOP', 'Johan Alexander van Schkoppf', 800, 'fluit', NULL, NULL, NULL, 'A', 'A', '1775-09-15', 'Texel', '1776-06-19', NULL, true, '1776-06-19', 'The Cape', 8016, 'From 11-02 till 17-03-1776 the HOOP was at Lisbon. On 01-09-1776 the HOOP departed from the Cape and sailed to Ceylon, arrival at Punto Gale: 25-11 ; four months later, 23-03-1777, the ship returned at the Cape. On 22-02-1778 it set out from the Cape again, destination: Batavia.');
INSERT INTO "voyages" VALUES (4245, '', 5, '', 'ZILVEREN LEEUW', 'Josua de Wolf van Ieperen', 880, NULL, '1765', NULL, NULL, 'D', 'Z', '1775-09-23', 'Rammekens', '1776-01-18', '1776-03-10', true, '1776-06-02', 'Batavia', 8021, 'See the LANDSKROON (4236) and the POPKENSBURG (4238).');
INSERT INTO "voyages" VALUES (4246, '', 5, '', 'VREEBURG', 'Willem Bax', 850, NULL, '1764', NULL, NULL, 'D', 'Z', '1775-09-23', 'Rammekens', '1776-03-05', '1776-04-06', true, '1776-06-30', 'Batavia', 7975, 'See the LANDSKROON (4236) and the POPKENSBURG (4238).');
INSERT INTO "voyages" VALUES (4247, '', 1, '', 'HELD WOLTEMADE', 'Jan Stil', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1775-09-24', 'Texel', '1776-02-22', '1776-04-06', true, '1776-06-17', 'Batavia', 7974, 'See the LANDSKROON (4236).');
INSERT INTO "voyages" VALUES (4248, '', 1, '', 'BUITENLEVEN', 'Jan Kaatman', 850, NULL, '1773', NULL, NULL, 'D', 'D', '1775-11-03', 'Goeree', '1776-02-14', '1776-03-03', true, '1776-05-27', 'Batavia', 7980, 'After having called at Batavia the ship sailed on to China. See the LANDSKROON (4236).');
INSERT INTO "voyages" VALUES (4249, '', 2, '', 'CERES', 'Johan van Voorst', 1150, NULL, '1771', NULL, NULL, 'A', 'Z', '1775-11-03', 'Rammekens', '1776-02-22', '1776-03-10', true, '1776-05-27', 'Batavia', 7982, 'After having called at Batavia the CERES sailed on to China. See the LANDSKROON (4236) and the POPKENSBURG (4238).');
INSERT INTO "voyages" VALUES (4250, '', 1, '', 'DIANA', 'Willemsz. Greveling', 850, NULL, '1774', NULL, NULL, 'R', 'R', '1775-11-03', 'Goeree', '1776-03-05', '1776-03-22', true, '1776-06-25', 'Batavia', 7995, 'Specified data concerning the crew of the DIANA: 189 seafarers, 84 soldiers, and 16 craftsmen departed from Goeree or embarked at the Cape. See the LANDSKROON (4236) and the BUITENLEVEN (4248).');
INSERT INTO "voyages" VALUES (4251, '', 3, '', 'ALKEMADE', 'Isaak de Vries', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1775-11-04', 'Texel', '1776-02-17', '1776-04-06', true, '1776-06-29', 'Batavia', 8037, 'See the LANDSKROON (4236).');
INSERT INTO "voyages" VALUES (4252, '', 1, '', 'MENTOR', 'Hans Hansen', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1775-11-04', 'Texel', '1776-02-17', '1776-03-10', true, '1776-06-02', 'Batavia', 7972, 'See the LANDSKROON (4236).');
INSERT INTO "voyages" VALUES (4253, '', 2, '', 'VRIJHEID', 'Jan Abel', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1775-11-04', 'Texel', '1776-02-21', '1776-03-10', true, '1776-06-03', 'Batavia', 7997, 'See the LANDSKROON (4236).');
INSERT INTO "voyages" VALUES (4254, '', 1, '', 'BLOK', 'Jakob de Lange', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1775-11-08', 'Batavia', '1776-03-16', '1776-06-23', true, NULL, NULL, 7983, 'After having called at Batavia the BLOK sailed on to China. See the LANDSKROON (4236).');
INSERT INTO "voyages" VALUES (4255, '', 3, '', 'HONKOOP', 'Daniel Deune', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1775-12-16', 'Ceylon', '1776-05-21', '1776-07-30', true, NULL, NULL, 7990, NULL);
INSERT INTO "voyages" VALUES (4256, '', 5, '', 'WESTERVELD', 'Swerus Vrolijk', 1100, NULL, '1761', NULL, NULL, 'A', 'A', '1775-11-01', 'Ceylon', '1776-04-16', '1776-07-04', true, NULL, NULL, 7978, NULL);
INSERT INTO "voyages" VALUES (4257, '', 5, '', 'BOVENKERKER POLDER', 'Hendrik Elders', 850, NULL, '1765', NULL, NULL, 'A', 'A', '1776-01-02', 'Batavia', '1776-04-13', '1776-07-04', true, NULL, NULL, 7970, 'In Sunda Strait 2 seafarers went missing. See the LANDSKROON (4236).');
INSERT INTO "voyages" VALUES (4258, '', 1, '', 'MERENBERG', 'Jan Balthus Meyer', 850, NULL, '1773', NULL, NULL, 'H', 'H', '1776-01-02', 'Batavia', '1776-04-03', '1776-06-29', true, NULL, NULL, 7988, 'Specified data concerning the crew of the MERENBERG: 181 seafarers, 51 soldiers, 10 craftsmen, and 6 passengers departed from Texel or embarked at the Cape. See the LANDSKROON (4236).');
INSERT INTO "voyages" VALUES (4259, '', 3, '', 'TEMPEL', 'Asmus Hendrik Sterrenberg', 850, NULL, '1767', NULL, NULL, 'R', 'A', '1776-01-02', 'Bengal', '1776-07-10', '1776-10-25', true, NULL, NULL, 7985, 'The TEMPEL called at lie de Rhe, 27-02 till 12-04-1776.');
INSERT INTO "voyages" VALUES (4260, '', 1, '', 'BATAVIA', 'Willem Helmers', 850, NULL, '1773', NULL, NULL, 'E', 'E', '1776-01-06', 'Batavia', '1776-04-16', '1776-07-18', true, NULL, NULL, 7986, 'the Cape. See the LANDSKROON (4236).');
INSERT INTO "voyages" VALUES (4261, '', 1, '', 'WILLEM FREDERIK', 'Frederik Papegaai', 1150, NULL, '1773', NULL, NULL, 'Z', 'Z', '1776-01-16', 'Batavia', '1776-04-16', '1776-07-13', true, NULL, NULL, 7999, 'See the LANDSKROON (4236) and the POPKENSBURG (4238).');
INSERT INTO "voyages" VALUES (4262, '', 4, '', 'OOSTKAPELLE', 'Pieter Haverkamp', 1150, NULL, '1767', NULL, NULL, 'Z', 'A', '1776-05-11', 'Batavia', '1776-08-07', '1776-10-22', true, NULL, NULL, NULL, 'The OOSTKAPELLE did not call at the Cape but at False Bay. The ship was laid up in the Indies, 31-12-1783.');
INSERT INTO "voyages" VALUES (4263, '', 4, '', 'VELDHOEN', 'Arend de Zeeuw', 1150, NULL, '1765', NULL, NULL, 'A', 'A', '1776-05-11', 'Batavia', '1776-08-16', '1776-11-17', true, NULL, NULL, NULL, 'disembarked. The ship was laid up in the Indies, 01-01-1780.');
INSERT INTO "voyages" VALUES (4264, '', 2, '', 'MARS', 'Samuel Willegaards', 1150, NULL, '1771', NULL, NULL, 'Z', 'Z', '1776-05-17', 'Batavia', '1776-09-16', '1777-01-03', true, NULL, NULL, 8004, NULL);
INSERT INTO "voyages" VALUES (4265, '', 2, '', 'DANKBAARHEID', 'Joachim Ernst Wend', 850, NULL, '1772', NULL, NULL, 'R', 'R', '1776-05-18', 'Batavia', '1776-08-16', '1776-11-27', true, NULL, NULL, 8075, NULL);
INSERT INTO "voyages" VALUES (4266, '', 2, '', 'BEEMSTER WELVAREN', 'Michiel Hamelo', 850, NULL, '1770', NULL, NULL, 'E', 'A', '1776-06-27', 'Texel', '1776-11-28', '1776-12-31', true, '1777-04-10', 'Batavia', NULL, 'passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4267, '', 4, '', 'COMPAGNIES WELVAREN', 'Dirk Schoon', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1776-06-27', 'Texel', '1776-11-13', '1776-12-08', true, '1777-02-20', 'Batavia', 7998, 'See the BEEMSTER WELVAREN (4266).');
INSERT INTO "voyages" VALUES (4268, '', 4, '', 'VROUWE ANTHOINETTA KOENRARDINA', 'Gerrit Harmeyer', 880, NULL, '1765', NULL, NULL, 'D', 'D', '1776-07-05', 'Goeree', '1776-12-03', '1776-12-31', true, '1777-04-09', 'Batavia', 7993, 'See the BEEMSTER WELVAREN (4266).');
INSERT INTO "voyages" VALUES (4269, '', 1, '', 'CONCORDIA', 'Evert Wesseling', 1150, NULL, '1773', NULL, NULL, 'Z', 'Z', '1776-08-01', 'Rammekens', '1776-12-07', '1776-12-31', true, '1777-03-20', 'Batavia', 8064, 'See the BEEMSTER WELVAREN (4266).');
INSERT INTO "voyages" VALUES (4270, '', 2, '', 'BREDENHOF', 'Leendert van Koopstad', 850, NULL, '1771', NULL, NULL, 'H', 'H', '1776-08-23', 'Texel', '1777-01-14', '1777-02-03', true, '1777-05-21', 'Batavia', 8000, 'the ZEEPAARD (4273): at Duins 3 seafarers died, 3 seafarers were pressed by the English.');
INSERT INTO "voyages" VALUES (4271, '', 2, '', 'HOOGKARSPEL', 'Hendrik Andringa', 850, NULL, '1771', NULL, NULL, 'E', 'E', '1776-08-23', 'Texel', '1776-12-20', '1777-01-18', true, '1777-04-07', 'Batavia', 8009, 'The HOOGKARSPEL called at Duins, 04 till 09-09-1776. See the BEEMSTER WELVAREN (4266).');
INSERT INTO "voyages" VALUES (4272, '', 2, '', 'KATWIJK AAN DEN RIJN', 'Kasper Meyer', 750, NULL, NULL, '1774', NULL, 'A', 'A', '1776-08-23', 'Texel', '1777-01-13', NULL, true, '1777-01-13', 'The Cape', 7991, 'The KATWIJK AAN DEN RIJN called at Weymouth, 03 till 10-09-1776.');
INSERT INTO "voyages" VALUES (4273, '', 1, '', 'ZEEPAARD', 'Jan Och', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1776-09-08', 'Texel', '1776-12-21', '1777-01-18', true, '1777-04-07', 'Batavia', 8008, 'The ZEEPAARD called at Duins, 14 till 19-09-1776. After having called at Batavia the ship sailed on to China. See the BEEM-STER WELVAREN (4266).');
INSERT INTO "voyages" VALUES (4274, '', 4, '', 'AZIE', 'Adriaan de Keizer', 1100, NULL, '1765', NULL, NULL, 'Z', 'Z', '1776-09-19', 'Rammekens', '1776-12-20', '1777-01-18', true, '1777-04-21', 'Batavia', NULL, 'the Indies, 31-12-1785.');
INSERT INTO "voyages" VALUES (4275, '', 1, '', 'BEHEMOTH', 'Hendrik Nieuwboer', 1150, NULL, '1775', NULL, NULL, 'A', 'A', '1776-09-19', 'Texel', '1776-12-20', '1777-01-18', true, '1777-03-21', 'Batavia', 8018, 'See the BEEMSTER WELVAREN (4266).');
INSERT INTO "voyages" VALUES (4276, '', 1, '', 'JACHTRUST', 'Joost Keller', 450, 'fregat', '1775', NULL, NULL, 'A', 'A', '1776-09-19', 'Texel', '1777-01-21', NULL, true, '1777-01-21', 'The Cape', 8142, 'years; in 1785 it returned to Texel.');
INSERT INTO "voyages" VALUES (4277, '', 1, '', 'VRIENDSCHAP', 'Jakob van den Berg', 850, NULL, '1774', NULL, NULL, 'D', 'D', '1776-09-20', 'Goeree', '1776-12-31', '1777-02-03', true, '1777-05-02', 'Batavia', 8024, 'See the BEEMSTER WELVAREN (4266).');
INSERT INTO "voyages" VALUES (4278, '', 1, '', 'KANAAN', 'Willem Koelbier', 850, NULL, '1775', NULL, NULL, 'R', 'R', '1776-09-30', 'Goeree', '1777-01-22', '1777-02-10', true, '1777-05-29', 'Batavia', 8010, '(4266).');
INSERT INTO "voyages" VALUES (4279, '', 4, '', 'BOT', 'Christiaan van Veerden', 1150, NULL, '1768', NULL, NULL, 'Z', 'A', '1776-10-24', 'Texel', '1777-02-05', '1777-03-12', true, '1777-06-03', 'Batavia', 7994, 'See the BEEMSTER WELVAREN (4266).');
INSERT INTO "voyages" VALUES (4280, '', 2, '', 'INDIAAN', 'Christoffel Beem', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1776-10-25', 'Texel', '1777-02-03', '1777-03-12', true, '1777-06-02', 'Batavia', 8020, 'See the BEEMSTER WELVAREN (4266).');
INSERT INTO "voyages" VALUES (4281, '', 1, '', 'OVERDUIN', 'Johan Kornelis Roos', 1150, NULL, '1774', NULL, NULL, 'Z', 'Z', '1776-10-31', 'Rammekens', '1777-04-03', '1777-04-14', true, '1777-07-02', 'Batavia', 8012, 'The OVERDUIN called at Portsmouth, 05 till 07-11-1776: 3 seafarers died, one seafarer went missing, another seafarer went ashore. After having called at Batavia the ship sailed on to China. See the BEEMSTER WELVAREN (4266).');
INSERT INTO "voyages" VALUES (4282, '', 1, '', 'GANGES', 'Wopke Popta', 1150, NULL, '1775', NULL, NULL, 'A', 'A', '1776-11-25', 'Texel', '1777-03-20', '1777-04-01', true, '1777-06-06', 'Batavia', 8007, 'Batavia the GANGES sailed on to China. See the BEEMSTER WELVAREN (4266).');
INSERT INTO "voyages" VALUES (4283, '', 1, '', 'HOORN', 'Gerrit Bruin', 850, NULL, '1774', NULL, NULL, 'H', 'H', '1776-12-28', 'Texel', '1777-04-14', '1777-04-30', true, '1777-07-28', 'Batavia', 8131, 'See the BEEMSTER WELVAREN (4266).');
INSERT INTO "voyages" VALUES (4284, '', 1, '', 'VROUWE JOHANNA MARGARETHA', 'Jan Meindertsz. Swaal', 850, NULL, '1774', NULL, NULL, 'E', 'E', '1776-12-28', 'Texel', '1777-04-05', '1777-04-22', true, '1777-07-09', 'Batavia', 8006, 'See the BEEMSTER WELVAREN (4266).');
INSERT INTO "voyages" VALUES (4285, '', 7, '', 'JONGE LIEVE', 'Adriaan Frederik van de Graaf', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1776-12-28', 'Texel', '1777-03-30', '1777-04-14', true, '1777-06-19', 'Batavia', NULL, 'See the BEEMSTER WELVAREN (4266). The JONGE LIEVE was laid up in the Indies, 31-12-1781.');
INSERT INTO "voyages" VALUES (4286, '', 2, '', 'PATRIOT', 'Hendrik Mulder', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1776-12-28', 'Texel', '1777-04-15', '1777-05-04', true, '1777-08-14', 'Batavia', 8017, 'See the BEEMSTER WELVAREN (4266).');
INSERT INTO "voyages" VALUES (4287, '', 3, '', 'MERCUUR', 'Kornelis Bos', 850, NULL, '1770', NULL, NULL, 'D', 'A', '1777-01-21', 'Texel', '1777-06-04', '1777-06-22', true, '1772-09-08', 'Bengal', 8005, 'The MERCUUR called at Portsmouth, 24-01 till 08-02-1777');
INSERT INTO "voyages" VALUES (4288, '', 5, '', '''T LOO', 'Stoffel Kok', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1777-01-22', 'Texel', '1777-06-16', '1777-07-06', true, '1777-09-02', 'Ceylon', 8011, '08-02-1777.');
INSERT INTO "voyages" VALUES (4289, '', 5, '', 'WILLEM DE VIJFDE', 'Justinus van Gennep', 1150, NULL, '1766', NULL, NULL, 'Z', 'Z', '1777-01-25', 'Rammekens', '1777-06-01', '1777-06-22', true, '1777-08-20', 'Ceylon', 8013, 'The WILLEM DE VIJFDE called at Portsmouth, 01 till 08-02-1777-');
INSERT INTO "voyages" VALUES (4290, '', 4, '', 'HUIS TER MEIJEN', 'Joachim Edets', 1150, NULL, '1767', NULL, NULL, 'A', 'A', '1777-05-28', 'Texel', '1777-09-19', '1777-10-09', true, '1778-01-06', 'Batavia', NULL, 'In 1785 the HUIS TER MEIJEN sank in the Indies.');
INSERT INTO "voyages" VALUES (4291, '', 2, '', 'MORGENSTER', 'Gerrit Springer', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1777-07-22', 'Texel', '1777-12-03', '1777-12-24', true, '1778-04-03', 'Batavia', 8040, 'JONGE HUGO (4308), the TRITON (4311), and the VROUWE EVERHARDINA (4313): 5400 persons departed from the Republic or embarked at the Cape, at Porto Prayo, S. Tiago. 14 seafarers, 2 soldiers, and one craftsmen deserted, at the Cape 418 seafarers, 331 soldiers, 29 craftsmen, and 5 passengers went ashore, one passenger died; during the voyage 116 seafarers, 46 soldiers and 7 craftsmen died; 4421 persons arrived at Batavia.');
INSERT INTO "voyages" VALUES (4292, '', 2, '', 'HUIS TE SPIJK', 'Thijssen jr.', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1777-07-22', 'Texel', '1777-11-24', '1777-12-18', true, '1778-03-02', 'Batavia', 8081, 'See the MORGENSTER (4291).');
INSERT INTO "voyages" VALUES (4293, '', 5, '', 'WOESTDUIN', 'Gerrit Berg', 1150, NULL, '1767', NULL, NULL, 'A', 'A', '1777-07-22', 'Texel', '1777-11-12', '1777-12-02', true, '1778-02-11', 'Batavia', 8026, 'See the MORGENSTER (4291).');
INSERT INTO "voyages" VALUES (4294, '', 3, '', 'HUIS TE KROOSWIJK', 'Hendrik Schreuder', 850, NULL, '1770', NULL, NULL, 'R', 'R', '1777-08-08', 'Goeree', '1777-12-07', '1778-01-03', true, '1778-04-23', 'Batavia', 8029, '(4291).');
INSERT INTO "voyages" VALUES (4295, '', 5, '', 'BORSSELE', 'Andries Matthijssen', 1150, NULL, '1758', NULL, NULL, 'Z', 'Z', '1777-08-27', 'Rammekens', '1777-12-27', '1778-01-22', true, '1778-04-04', 'Batavia', NULL, 'Rammekens as criminals.');
INSERT INTO "voyages" VALUES (4296, '', 6, '', 'ZUID-BEVELAND', 'Johan Hendrik Pauwelsen', 1100, NULL, '1755', NULL, NULL, 'Z', 'Z', '1777-08-27', 'Rammekens', '1777-12-10', '1778-01-03', true, '1778-04-01', 'Batavia', NULL, 'The ZUID-BEVELAND called at Duins, 29-08-1777. In 1781 the ship was laid up in the Indies. See the MORGENSTER (4291).');
INSERT INTO "voyages" VALUES (4297, '', 5, '', 'RIDDERKERK', 'Johan Snijders', 850, NULL, '1766', NULL, NULL, 'D', 'D', '1777-08-28', 'Goeree', '1777-12-21', '1778-01-12', true, '1778-04-04', 'Batavia', 8032, 'See the MORGENSTER (4291).');
INSERT INTO "voyages" VALUES (4298, '', 1, '', 'DOLFIJN', 'Jan Frederik Raatjes', 1150, NULL, '1776', NULL, NULL, 'A', 'A', '1777-09-13', 'Texel', '1777-12-26', '1778-01-12', true, '1778-05-06', 'Batavia', 8030, 'After having called at Batavia the DOLFIJN sailed on to China. See the MORGENSTER (4291).');
INSERT INTO "voyages" VALUES (4299, '', 3, '', 'FOREEST', 'Johan Smit', 850, NULL, '1770', NULL, NULL, 'H', 'A', '1777-09-13', 'Texel', '1777-12-26', '1778-01-22', true, '1778-05-03', 'Batavia', NULL, 'See the MORGENSTER (4291). In 1783 the FOREEST was burnt in the Indies.');
INSERT INTO "voyages" VALUES (4300, '', 5, '', 'RITTHEM', 'Kornelis Kornelissen', 880, NULL, '1764', NULL, NULL, 'Z', 'A', '1777-09-28', 'Texel', '1778-03-02', '1778-04-02', true, '1778-07-05', 'Batavia', 8022, 'The RITTHEM called at Portsmouth (19 till 23-10-1777) and at Spithead (25-10-1777). See the MORGENSTER (4291). The following data refer to the crew of the RITTHEM as well as to the crew of the HELD WOLTEMADE (4301): at Portsmouth one passenger died, 2 seafarers deserted.');
INSERT INTO "voyages" VALUES (4301, '', 2, '', 'HELD WOLTEMADE', 'Hendrik Elders jr.', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1777-09-28', 'Texel', '1778-03-08', '1778-04-18', true, '1778-07-05', 'Batavia', 8041, 'The HELD WOLTEMADE called at Portsmouth (19 till 23-10-1777) and at Spithead (25-10-1777). See the MORGENSTER (4291).');
INSERT INTO "voyages" VALUES (4302, '', 2, '', 'DELFSHAVEN', 'Arie Jansz. den Hertog', 850, NULL, '1772', NULL, NULL, 'D', 'A', '1777-10-13', 'Texel', '1777-12-31', '1778-01-22', true, '1778-03-29', 'Batavia', NULL, 'See the MORGENSTER (4291). In 1780 the DELFSHAVEN was wrecked in the Indies.');
INSERT INTO "voyages" VALUES (4303, '', 2, '', 'MENTOR', 'Johan de Korte', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1777-10-13', 'Texel', '1778-01-13', '1778-02-13', true, '1778-06-01', 'Batavia', 8045, 'See the MORGENSTER (4291).');
INSERT INTO "voyages" VALUES (4304, '', 1, '', 'ZEEUW', 'Jan Siereveld', 1150, NULL, '1774', NULL, NULL, 'Z', 'Z', '1777-10-19', 'Rammekens', '1778-02-15', '1778-03-12', true, '1778-05-18', 'Batavia', 8031, 'After having called at Batavia the ZEEUW sailed on to China. See the MORGENSTER (4291).');
INSERT INTO "voyages" VALUES (4305, '', 2, '', 'ABBEKERK', 'Kasper Burger', 850, NULL, '1772', NULL, NULL, 'H', 'H', '1777-10-22', 'Texel', '1778-03-15', '1778-04-02', true, '1778-07-07', 'Batavia', 8033, 'After having called at Batavia the ABBEKERK sailed on to China. See the MORGENSTER (4291).');
INSERT INTO "voyages" VALUES (4306, '', 6, '', 'JONGE SAMUEL', 'Kornelis de Klerk', 880, NULL, '1761', NULL, NULL, 'Z', 'R', '1777-11-15', 'Goeree', '1778-03-15', '1778-04-02', true, '1778-06-27', 'Batavia', NULL, 'See the MORGENSTER (4291). The JONGE SAMUEL was laid up in the Indies, 08-12-1784.');
INSERT INTO "voyages" VALUES (4307, '', 1, '', 'VREDENHOF', 'Reindert den Uil', 1150, NULL, '1776', NULL, NULL, 'A', 'A', '1777-12-09', 'Texel', '1778-03-19', '1778-04-02', true, '1778-07-05', 'Batavia', 8034, 'After having called at Batavia the VREDENHOF sailed on to China. See the MORGENSTER (4291).');
INSERT INTO "voyages" VALUES (4308, '', 2, '', 'JONGE HUGO', 'Klein', 850, NULL, '1772', NULL, NULL, 'E', 'E', '1777-12-25', 'Texel', '1778-04-09', '1778-05-02', true, '1778-07-07', 'Batavia', 8019, 'See the MORGENSTER (4291).');
INSERT INTO "voyages" VALUES (4309, '', 6, '', 'BOVENKERKER POLDER', 'Klaas Roem', 850, NULL, '1765', NULL, NULL, 'A', 'A', '1777-12-29', 'Texel', '1778-04-10', '1778-05-02', true, '1778-08-20', 'Bengal', 8028, NULL);
INSERT INTO "voyages" VALUES (4310, '', 3, '', 'CERES', 'Johan Alexander van Schkoppf', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1777-12-29', 'Texel', '1778-04-13', '1778-05-02', true, '1778-06-27', 'Ceylon', 8039, NULL);
INSERT INTO "voyages" VALUES (4311, '', 2, '', 'TRITON', 'Gottlieb Mulder', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1777-12-29', 'Texel', '1778-03-22', '1778-04-02', true, '1778-06-08', 'Batavia', 8061, 'See the MORGENSTER (4291).');
INSERT INTO "voyages" VALUES (4312, '', 2, '', 'AMSTERDAM', 'Swerus Vrolijk', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1778-01-05', 'Texel', '1778-04-16', '1778-05-02', true, '1778-06-27', 'Ceylon', 8027, NULL);
INSERT INTO "voyages" VALUES (4313, '', 1, '', 'VROUWE EVERHARDINA', 'Magnus Gustaaf Beerstaal', 850, NULL, '1776', NULL, NULL, 'D', 'D', '1778-01-27', 'Goeree', '1778-05-17', '1778-06-18', true, '1778-08-19', 'Batavia', 8055, 'See the MORGENSTER (4291).');
INSERT INTO "voyages" VALUES (4314, '', 3, '', 'KATWIJK AAN DEN RIJN', 'Laurens de Sille', 750, NULL, NULL, '1774', NULL, 'A', 'A', '1778-03-09', 'Texel', '1778-08-25', NULL, true, '1778-08-25', 'The Cape', 8036, 'The KATWIJK AAN DEN RIJN was bound for the Cape.');
INSERT INTO "voyages" VALUES (4315, '', 2, '', 'HOF TER LINDEN', 'Lambert Arnout Halfman', 1150, NULL, '1772', NULL, NULL, 'Z', 'Z', '1778-03-13', 'Rammekens', '1778-07-04', '1778-08-07', true, '1778-10-16', 'Batavia', 8038, 'but at Simon''s Bay.');
INSERT INTO "voyages" VALUES (4316, '', 3, '', 'HOLLAND', 'Benjamin van der Spek', 1150, NULL, '1771', NULL, NULL, 'A', NULL, '1778-05-23', 'Texel', '1778-09-28', '1778-10-25', true, '1779-01-23', 'Batavia', 8043, 'one passenger went ashore; during the voyage 20 seafarers, 3 soldiers. and one craftsmen died; 338 seafarers, 87 soldiers, 25 craftsmen, and 9 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4317, '', 4, '', 'PRINSES VAN ORANJE', 'Jan Frederik Volmer', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1778-05-23', 'Texel', '1778-09-21', '1778-10-14', true, '1778-12-27', 'Batavia', 8051, 'See the HOLLAND (4316).');
INSERT INTO "voyages" VALUES (4318, '', 6, '', 'PALLAS', 'Isaak Segon', 1150, NULL, '1762', NULL, NULL, 'Z', 'A', '1778-07-15', 'Texel', '1778-11-29', '1779-01-02', true, '1779-04-04', 'Batavia', NULL, 'Batavia.');
INSERT INTO "voyages" VALUES (4319, '', 6, '', 'VREEBURG', 'Adriaan van Katersveld', 850, NULL, '1764', NULL, NULL, 'D', 'D', '1778-07-15', 'Goeree', '1778-11-30', '1779-01-03', true, '1779-04-10', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (4320, '', 3, '', 'EUROPA', 'Pieter Kardon', 1200, NULL, '1770', NULL, NULL, 'Z', 'Z', '1778-07-19', 'Rammekens', '1778-11-29', '1778-12-22', true, '1779-02-28', 'Batavia', NULL, 'The EUROPA called at Portsmouth: 10 seafarers, 3 soldiers, and one craftsmen died, one soldier was pressed by the English. See the PALLAS (4318). On 23-07-1784 the EUROPA, sailing off Indramajoe, was wrecked on a rock.');
INSERT INTO "voyages" VALUES (4321, '', 4, '', 'HONKOOP', 'Nikolaas Sevie', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1778-07-19', 'Texel', '1779-01-03', '1779-01-25', true, '1779-05-01', 'Batavia', 8071, 'See the PALLAS (4318).');
INSERT INTO "voyages" VALUES (4322, '', 3, '', 'NOORDBEEK', 'Wouter de Gelder', 850, 'fluit', NULL, '1773', NULL, 'Z', 'Z', '1778-07-19', 'Rammekens', '1779-01-16', NULL, true, '1779-01-16', 'The Cape', 8079, 'The NOORDBEEK was bound for the Cape.');
INSERT INTO "voyages" VALUES (4323, '', 3, '', 'HERSTELDER', 'Axel Land', 600, 'fregat', NULL, '1772', NULL, 'A', 'A', '1778-07-31', 'Texel', '1778-11-20', NULL, true, '1778-11-20', 'The Cape', 8035, 'The HERSTELDER was bound for the Cape.');
INSERT INTO "voyages" VALUES (4324, '', 1, '', 'HINDELOOPEN', 'Jan Tromp', 850, NULL, '1776', NULL, NULL, 'H', 'H', '1778-08-17', 'Texel', '1779-01-03', '1779-04-04', true, '1779-07-03', 'Batavia', 8042, 'See the PALLAS (4318).');
INSERT INTO "voyages" VALUES (4325, '', 3, '', 'LAM', 'Jan Everwijk Drillinger', 850, NULL, '1769', NULL, NULL, 'D', 'E', '1778-08-17', 'Texel', '1779-01-08', '1779-02-03', true, '1779-05-23', 'Batavia', 8054, 'See the PALLAS (4318).');
INSERT INTO "voyages" VALUES (4326, '', 4, '', 'BLEIJENBURG', 'Pieter van Prooien', 850, NULL, '1765', NULL, NULL, 'R', 'R', '1778-08-18', 'Goeree', '1778-12-04', '1779-01-03', true, '1779-03-12', 'Batavia', 8047, 'See the PALLAS (4318).');
INSERT INTO "voyages" VALUES (4327, '', 2, '', 'BLOK', 'Jakob de Lange', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1778-08-21', 'Texel', '1778-11-30', '1778-12-21', true, '1779-02-17', 'Batavia', 8049, 'After having called at Batavia the BLOK sailed on to China. See the PALLAS (4318).');
INSERT INTO "voyages" VALUES (4328, '', 4, '', 'PAUW', 'Jakob de Meyer', 850, NULL, '1767', NULL, NULL, 'D', 'Z', '1778-09-11', 'Rammekens', '1779-01-26', '1779-02-23', true, '1779-06-18', 'Batavia', NULL, 'See the PALLAS (4318). The PAUW was laid up in the Indies, 08-12-1784.');
INSERT INTO "voyages" VALUES (4329, '', 2, '', 'BUITENLEVEN', 'Karel Magnus Poulin', 850, NULL, '1773', NULL, NULL, 'D', 'D', '1778-10-19', 'Goeree', '1779-07-01', '1779-07-26', true, '1779-09-25', 'Batavia', NULL, 'were pressed by the English. See the PALLAS (4318). The BUITENLEVEN was laid up in the Indies, 31-12-1787.');
INSERT INTO "voyages" VALUES (4330, '', 3, '', 'VRIJHEID', 'Hendrik Willemse', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1778-10-20', 'Texel', '1779-05-07', '1779-06-03', true, '1779-08-30', 'Batavia', NULL, 'See the PALLAS (4318). Early in 1783 the VRIJHEID was sold to the French at Ceylon.');
INSERT INTO "voyages" VALUES (4331, '', 5, '', 'COMPAGNIES WELVAREN', 'Frederik Godert Wever', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1778-10-20', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'till 30-11-1778) and at Plymouth (02-12-1778 till 21-04-1779); there-upon it sailed back to Texel. After the return of the ship at Texel, 24-04-1779, its name was altered into WAKKERHEID (see the sixth voyage: 4356/-).');
INSERT INTO "voyages" VALUES (4332, '', 1, '', 'JAYA', 'Jan Meindertsz. Swaal', 850, NULL, '1775', NULL, NULL, 'E', 'E', '1779-01-06', 'Texel', '1779-04-13', '1779-04-27', true, '1779-07-05', 'Batavia', 8052, 'After having called at Batavia the JAVA sailed On to China. See the PALLAS (4318).');
INSERT INTO "voyages" VALUES (4333, '', 2, '', 'VROUWE JOHANNA MARGARETHA', 'Dirk Schoon', 850, NULL, '1774', NULL, NULL, 'E', 'A', '1779-01-06', 'Texel', '1779-04-13', '1779-05-06', true, '1779-07-01', 'Batavia', NULL, 'See the PALLAS (4318). In 1783 the VROUWE JOHANNA MARGARETHA was wrecked in the Indies.');
INSERT INTO "voyages" VALUES (4334, '', 3, '', 'MARS', 'Christiaan van Veerden', 1150, NULL, '1771', NULL, NULL, 'Z', 'A', '1779-01-06', 'Texel', '1779-04-13', '1779-05-15', true, '1779-07-23', 'Batavia', NULL, 'See the PALLAS (4318). The MARS was laid up in the Indies. 31-12-1787.');
INSERT INTO "voyages" VALUES (4335, '', 4, '', 'MERCUUR', 'Daniel Deune', 850, NULL, '1770', NULL, NULL, 'D', 'A', '1779-01-06', 'Texel', '1779-04-05', '1779-04-27', true, '1779-07-20', 'Bengal', 8048, NULL);
INSERT INTO "voyages" VALUES (4336, '', 3, '', 'VOORBERG', 'Johan van Voorst', 1150, NULL, '1770', NULL, NULL, 'A', 'Z', '1779-01-06', 'Rammekens', '1779-04-06', '1779-04-19', true, '1779-06-21', 'Batavia', 8053, 'After having called at Batavia the VOORBERG sailed on to China. See the PALLAS (4318).');
INSERT INTO "voyages" VALUES (4337, '', 2, '', 'ZEEPAARD', 'Jan Willem Nieder', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1779-01-06', 'Texel', '1779-04-13', '1779-05-06', true, '1779-07-03', 'Batavia', 8056, 'See the PALLAS (4318).');
INSERT INTO "voyages" VALUES (4338, '', 1, '', 'ZEEPLOEG', 'Jan Stil', 1150, NULL, '1777', NULL, NULL, 'A', 'A', '1779-01-06', 'Texel', '1779-04-24', '1779-05-06', true, '1779-06-30', 'Batavia', 8050, 'After having called at Batavia the ZEEPLOEG sailed on to China. See the PALLAS (4318).');
INSERT INTO "voyages" VALUES (4339, '', 2, '', 'MERENBERG', 'Herman Jakob Hulleman', 850, NULL, '1773', NULL, NULL, 'H', 'H', '1779-01-07', 'Texel', '1779-04-13', '1779-05-06', true, '1779-07-05', 'Batavia', 8044, 'See the PALLAS (4318).');
INSERT INTO "voyages" VALUES (4340, '', 4, '', 'TEMPEL', 'Isaak Thierens', 850, NULL, '1767', NULL, NULL, 'R', 'R', '1779-01-08', 'Goeree', '1779-04-13', '1779-05-06', true, '1779-07-11', 'Batavia', NULL, 'See the PALLAS (4318). The TEMPEL was laid up in the Indies, 31-12-1788.');
INSERT INTO "voyages" VALUES (4341, '', 2, '', 'GANGES', 'Hillert Volkers', 1150, NULL, '1775', NULL, NULL, 'A', 'A', '1779-01-10', 'Texel', '1779-04-04', '1779-04-27', true, '1779-07-10', 'Ceylon', 8058, NULL);
INSERT INTO "voyages" VALUES (4342, '', 6, '', 'HUIS OM', 'Willem Udemans jr.', 1150, NULL, '1761', NULL, NULL, 'Z', 'Z', '1779-03-07', 'Rammekens', '1779-07-04', '1779-07-26', true, '1779-11-13', 'Ceylon', 8057, NULL);
INSERT INTO "voyages" VALUES (4343, '', 2, '', 'DIANA', 'Pierre Frederik Riebe', 850, NULL, '1774', NULL, NULL, 'R', 'A', '1779-04-17', 'Goeree', '1779-12-25', '1780-04-24', true, '1780-07-14', 'Batavia', 8069, 'The DIANA called at Duins (21 till 30-04) and at Rio de Janeiro (16-10 till 15-11-1779).');
INSERT INTO "voyages" VALUES (4344, '', 2, '', 'OVE RDUIN', 'Hans Hansen', 1150, NULL, '1774', NULL, NULL, 'Z', 'A', '1779-05-13', 'Texel', '1779-08-28', '1779-10-06', true, '1780-01-11', 'Batavia', 8127, 'at Bantam 25 soldiers disembarked; during the voyage 195 seafarers, 110 soldiers, 17 craftsmen, and one passenger died, one seafarer went missing; 2927 seafarers, 822 soldiers, 134 craftsmen, and 29 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4345, '', 2, '', 'COMPAGNIES WELVAREN', 'Christiaan Frederik Winterheim', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1779-06-03', 'Texel', '1779-10-24', '1779-12-01', true, '1780-02-20', 'Batavia', NULL, 'WAKKERHEID. In 1783 or early in 1784 the COMPAGNIES WELVAREN, sailing from Batavia to Ceylon, was wrecked.');
INSERT INTO "voyages" VALUES (4346, '', 2, '', 'WILLEM FREDERIK', 'Hendrik Steitsch', 1150, NULL, '1773', NULL, NULL, 'Z', 'A', '1779-07-07', 'Texel', '1779-10-27', '1779-11-17', true, '1780-02-14', 'Batavia', NULL, 'See the OVERDUIN (4344). The WILLEM FREDERIK was laid up in the Indies, 31-12-1786.');
INSERT INTO "voyages" VALUES (4347, '', 4, '', 'JONGE HELLINGMAN', 'Lukas Aams', 850, NULL, '1767', NULL, NULL, 'H', 'A', '1779-07-14', 'Texel', '1779-11-17', '1779-12-06', true, '1780-02-23', 'Batavia', NULL, 'the OVERDUIN (4344). On 12-09-1780 the JONGE HEL-LINGMAN ran aground at sandbanks off Bengal and was wrecked.');
INSERT INTO "voyages" VALUES (4348, '', 5, '', 'VROUWE ANTHOINETTA KOENRARDINA', 'Kornelis Philippus Hoek', 880, NULL, '1765', NULL, NULL, 'D', 'D', '1779-07-19', 'Goeree', '1779-12-13', '1780-01-11', true, '1780-04-26', 'Batavia', 8062, 'See the OVERDUIN (4344).');
INSERT INTO "voyages" VALUES (4349, '', 2, '', 'KANAAN', 'Pieter van der Weert', 850, NULL, '1775', NULL, NULL, 'R', 'R', '1779-08-13', 'Goeree', '1779-12-21', '1780-01-17', true, '1780-04-11', 'Batavia', NULL, 'See the OVERDUIN (4344).');
INSERT INTO "voyages" VALUES (4350, '', 4, '', 'BOTLAND', 'Jakob Johnson', 1150, NULL, '1769', NULL, NULL, 'Z', 'Z', '1779-08-19', 'Rammekens', '1779-12-13', '1780-01-11', true, '1780-04-11', 'Batavia', NULL, 'See the OVERDUIN (4344). On 04-1-1783 the BOTLAND was wrecked in the roads of Colombo.');
INSERT INTO "voyages" VALUES (4351, '', 5, '', 'OUD HAARLEM', 'Bartholomeus Veau', 1150, NULL, '1768', NULL, NULL, 'A', 'Z', '1779-08-19', 'Rammekens', '1779-12-24', '1780-01-17', true, '1780-04-26', 'Batavia', 8065, 'See also the OVERDUIN (4344).');
INSERT INTO "voyages" VALUES (4352, '', 3, '', 'HOOGKARSPEL', 'Olke Hendrik Andringa', 850, NULL, '1771', NULL, NULL, 'E', 'E', '1779-08-24', 'Texel', '1780-01-06', '1780-02-17', true, '1780-05-03', 'Batavia', 8072, 'See also the OVERDUIN (4344).');
INSERT INTO "voyages" VALUES (4353, '', 6, '', '''T LOO', 'Ian van der Sloot', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1779-08-24', 'Texel', '1779-12-17', '1780-01-11', true, '1780-03-21', 'Batavia', 8068, 'See the OVERDUIN (4344).');
INSERT INTO "voyages" VALUES (4354, '', 4, '', 'HERSTELDER', 'Abraham Tim', 600, 'fregat', NULL, '1772', NULL, 'C', 'A', '1779-10-05', 'Texel', '1780-01-17', NULL, true, '1780-01-17', 'The Cape', 8059, 'The HERSTELDER called at Duins, 07 till 21-10-1779.');
INSERT INTO "voyages" VALUES (4355, '', 4, '', 'KATWIJK AAN DEN RIJN', 'Jan Jansz. Laurits', 750, 'hoeker', NULL, '1774', NULL, 'A', 'A', '1779-10-05', 'Texel', '1780-02-09', NULL, true, '1780-02-09', 'The Cape', 8060, 'called at Duins, 07 till 21-10-1779.');
INSERT INTO "voyages" VALUES (4356, '', 6, '', 'WAKKERHEID', 'Benjamin der Kinderen', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1779-10-05', 'Texel', '1780-01-17', '1780-02-17', true, '1780-04-30', 'Batavia', NULL, 'WAKKERHEID as well as to the crews of the BEHEMOTH (4357) and at the PAREL (4359): one seafarer died at Duins.');
INSERT INTO "voyages" VALUES (4357, '', 2, '', 'BEHEMOTH', 'Kornelis Kornelissen', 1150, NULL, '1775', NULL, NULL, 'A', 'A', '1779-11-18', 'Texel', '1780-04-21', '1780-05-24', true, '1780-09-12', 'Batavia', 8063, 'The BEHEMOTH called at Duins, 09 till 28-12-1779. See the OVERDUIN (4344).');
INSERT INTO "voyages" VALUES (4358, '', 3, '', 'INDIAAN', 'Arie Kikkert', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1779-11-18', 'Texel', '1780-05-12', '1780-07-10', true, '1780-09-13', 'Batavia', 8078, 'The INDIAAN called at Portsmouth (30-12-1779 till 11-02-1780): 4 seafarers and 4 soldiers died. See the OVERDUIN (4344).');
INSERT INTO "voyages" VALUES (4359, '', 1, '', 'PAREL', 'Dirk Kornelisz. Plokker', 1150, NULL, '1778', NULL, NULL, 'A', 'A', '1779-11-18', 'Texel', '1780-04-14', '1780-04-30', true, '1780-07-05', 'Batavia', 8074, 'The PAREL called at Duins, 24-11 till 28-12-1779. After having called at Batavia the ship sailed on to China. See the OVERDUIN (4344).');
INSERT INTO "voyages" VALUES (4360, '', 1, '', 'MIDDELBURG', 'Justinus van Gennep', 1150, NULL, '1775', NULL, NULL, 'Z', 'Z', '1779-12-28', 'Rammekens', '1780-04-12', '1780-04-24', true, '1780-07-04', 'Batavia', 8073, 'After having called at Batavia the MIDDELBURG sailed on to China. See the OVERDUIN (4344).');
INSERT INTO "voyages" VALUES (4361, '', 4, '', 'POPKENSBURG', 'Jochem Bank', 880, NULL, '1763', NULL, NULL, 'Z', 'Z', '1779-12-28', 'Rammekens', '1780-04-12', '1780-04-30', true, '1780-07-28', 'Bengal', 8070, NULL);
INSERT INTO "voyages" VALUES (4362, '', 3, '', 'BEEKVLIET', 'N. Ketel Jakobsz.', 850, NULL, '1770', NULL, NULL, 'A', 'H', '1779-12-29', 'Texel', '1780-04-12', '1780-05-15', true, '1780-07-28', 'Batavia', 8067, 'See the OVERDUIN (4344).');
INSERT INTO "voyages" VALUES (4363, '', 3, '', 'BREDENHOF', 'Leendert van Koopstad', 850, NULL, '1771', NULL, NULL, 'H', 'H', '1779-12-29', 'Texel', '1780-04-21', '1780-05-16', true, '1780-08-07', 'Batavia', 8132, 'On 31-08-1779 the BREDENHOF originally departed, about a month later, however, the ship had to return to Texel (arrival there: 29-09-1779). Second and final date of departure: 29-12-1779. See the OVERDUIN (4344).');
INSERT INTO "voyages" VALUES (4364, '', 3, '', 'JONGE HUGO', 'Johan Herman Kornel', 850, NULL, '1772', NULL, NULL, 'E', 'E', '1779-12-29', 'Texel', '1780-04-12', '1780-05-18', true, '1780-08-08', 'Batavia', NULL, 'See the OVERDUIN (4344). The JONGE HUGO was laid up in the Indies, 31-12-1786.');
INSERT INTO "voyages" VALUES (4365, '', 2, '', 'DOLFIJN', 'Axel Land', 1150, NULL, '1776', NULL, NULL, 'A', 'A', '1779-12-30', 'Texel', '1780-04-09', '1780-04-24', true, '1780-07-03', 'Batavia', NULL, 'See the OVERDUIN (4344). On 27-06-1784 the DOLFIJN exploded in the roads of Malacca.');
INSERT INTO "voyages" VALUES (4366, '', 3, '', 'AMSTERDAM', 'Laurens de Sille', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1780-01-04', 'Texel', '1780-05-01', '1780-05-18', true, '1780-07-11', 'Ceylon', 8076, NULL);
INSERT INTO "voyages" VALUES (4367, '', 3, '', 'PATRIOT', 'Adriaan Frederik van de Graaf', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1780-01-04', 'Texel', '1780-04-16', '1780-05-15', true, '1780-07-22', 'Batavia', NULL, 'In 1786 the PATRIOT was wrecked off Madurai in Southern India. See the OVERDUIN (4344).');
INSERT INTO "voyages" VALUES (4368, '', 2, '', 'BATAVIA', 'Gerrit Harmeyer', 850, NULL, '1773', NULL, NULL, 'E', 'D', '1780-01-07', 'Goeree', '1780-05-13', '1780-06-01', true, '1780-08-11', 'Batavia', 8077, 'The BATAVIA originally departed on 23-10-1779; on 09-11-1779, however, it returned to Goeree. See the OVERDUIN (4344).');
INSERT INTO "voyages" VALUES (4369, '', 6, '', 'RITTHEM', 'Gerrit Opdal', 880, NULL, '1764', NULL, NULL, 'Z', 'R', '1780-01-08', 'Goeree', '1780-06-24', '1780-07-31', true, '1780-10-23', 'Batavia', NULL, 'RITTHEM called at Lisbon. The ship was laid up in the Indies, 31-12-1785.');
INSERT INTO "voyages" VALUES (4370, '', 7, '', 'BOVENKERKER POLDER', 'Jurriaan Verburg', 850, NULL, '1765', NULL, NULL, 'A', 'A', '1780-04-01', 'Texel', '1780-07-08', '1780-08-01', true, '1780-11-16', 'Bengal', NULL, 'The BOVENKERKER POLDER was laid up in the Indies, 31-12-1786.');
INSERT INTO "voyages" VALUES (4371, '', 3, '', 'MORGENSTER', 'Gerrit Berg', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1780-05-01', 'Texel', '1780-08-31', '1780-10-01', true, '1780-12-22', 'Ceylon', 8108, NULL);
INSERT INTO "voyages" VALUES (4372, '', 4, '', 'GROENENDAAL', 'Christoffel Beem', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1780-06-05', 'Texel', '1780-10-14', '1780-11-16', true, '1781-02-20', 'Batavia', 8080, 'During the voyage four men deserted.');
INSERT INTO "voyages" VALUES (4373, '', 3, '', 'JUNO', 'Hubert Hendrik Hendriksz.', 850, NULL, '1771', NULL, NULL, 'R', 'Z', '1780-06-05', 'Rammekens', NULL, NULL, true, NULL, NULL, NULL, 'Sailing to the Cape the JUNO was wrecked.');
INSERT INTO "voyages" VALUES (4374, '', 6, '', 'BARTHA PETRONELLA', 'Andries Jurriaansz. Klein', 880, NULL, '1764', NULL, NULL, 'H', 'E', '1780-07-23', 'Texel', '1780-11-17', '1780-12-15', true, '1781-04-24', 'Batavia', NULL, 'was sold in the Indies in 1782.');
INSERT INTO "voyages" VALUES (4375, '', 4, '', 'CERES', 'Jakob Schubert', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1780-07-23', 'Texel', '1780-11-05', '1780-11-29', true, '1781-04-18', 'Batavia', NULL, 'In 1786 the CERES was laid up in the Indies.');
INSERT INTO "voyages" VALUES (4376, '', 6, '', 'VROUWE KORNELIA HILLEGONDA', 'Sijbrand Dometius', 850, NULL, '1760', NULL, NULL, 'D', 'H', '1780-07-30', 'Texel', '1780-11-18', '1780-12-15', true, '1781-05-07', 'Batavia', NULL, 'According to K.A. 4390a the crew consisted of 264 men, when the ship departed from Texel. In 1784 the VROUWE KORNELIA HILLEGONDA was laid up in the Indies.');
INSERT INTO "voyages" VALUES (4377, '', 6, '', 'ZILVEREN LEEUW', 'Johan Snijders', 880, NULL, '1765', NULL, NULL, 'D', 'D', '1780-08-05', 'Goeree', '1780-12-16', '1781-01-12', true, '1781-05-13', 'Batavia', NULL, 'The ZILVEREN LEEUW was laid up in the Indies, 31-12-1786.');
INSERT INTO "voyages" VALUES (4378, '', 4, '', 'HUIS TE KROOSWIJK', 'Herman Volkers', 850, NULL, '1770', NULL, NULL, 'R', 'R', '1780-08-07', 'Goeree', '1780-11-22', '1780-12-15', true, '1781-04-19', 'Batavia', NULL, 'In 1787 the HUIS TE KROOSWIJK was laid up in the Indies.');
INSERT INTO "voyages" VALUES (4379, '', 4, '', 'HOOP', 'Theunis Hans Borch', 800, NULL, NULL, NULL, NULL, 'A', 'A', '1780-08-23', 'Texel', '1781-01-21', '1781-02-17', true, '1781-05-15', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (4380, '', 1, '', 'TROMPENBURG', 'Hendrik Elders jr.', 1150, NULL, '1778', NULL, NULL, 'A', 'A', '1780-08-23', 'Texel', '1780-12-21', '1781-01-12', true, '1781-05-12', 'Batavia', NULL, 'In 1788 the ship was wrecked in the Indies.');
INSERT INTO "voyages" VALUES (4381, '', 1, '', 'SLOT TER HOGE', 'Lambert Arnout Halfman', 1150, NULL, NULL, NULL, NULL, 'Z', 'Z', '1780-08-27', 'Rammekens', '1780-12-31', '1781-01-30', true, '1781-04-19', 'Batavia', 8091, NULL);
INSERT INTO "voyages" VALUES (4382, '', 3, '', 'HOF TER LINDEN', 'Thoger Abo', 1150, NULL, '1772', NULL, NULL, 'Z', 'A', '1780-10-28', 'Texel', '1781-02-15', NULL, true, '1781-05-31', 'Batavia', 8191, 'During the voyage two members of the crew deserted. The date of departure from the Cape is unknown.');
INSERT INTO "voyages" VALUES (4383, '', 5, '', 'HERSTELDER', 'Frederik Godert Wever', 600, 'fregat', NULL, '1772', NULL, 'C', 'A', '1780-11-01', 'Texel', '1781-01-29', '1781-04-01', true, '1781-06-12', 'Batavia', NULL, 'In 1783 the HERSTELDER was wrecked in the Indies.');
INSERT INTO "voyages" VALUES (4384, '', 3, '', 'MERENBERG', 'Jan Montagne', 850, NULL, '1773', NULL, NULL, 'H', 'E', '1780-11-30', 'Texel', '1781-05-01', '1781-05-16', true, '1781-07-30', 'Batavia', 8120, 'During the voyage one man deserted.');
INSERT INTO "voyages" VALUES (4385, '', 1, '', 'DIAMANT', 'Jakob Frederiks', 1150, NULL, '1779', NULL, NULL, 'A', 'A', '1780-12-18', 'Texel', '1781-04-02', '1781-04-17', true, '1781-07-09', 'Batavia', 8179, NULL);
INSERT INTO "voyages" VALUES (4386, '', 5, '', 'KATWIJK AAN DEN RIJN', 'Isaak Louis Bellon', 750, 'hoeker', NULL, '1774', NULL, 'A', 'A', '1780-12-18', 'Texel', '1781-05-24', NULL, true, '1781-05-24', 'The Cape', NULL, 'Company''s authorities at the Cape then decided to have it broken up.');
INSERT INTO "voyages" VALUES (4387, '', 5, '', 'MERCLUR', 'Klaas Roem', 850, NULL, '1770', NULL, NULL, 'D', 'A', '1780-12-19', 'Texel', '1781-04-14', '1781-05-08', true, '1781-07-20', 'Batavia', NULL, 'In 1782 the ship sank in the Indies.');
INSERT INTO "voyages" VALUES (4388, '', 2, '', 'VRIENDSCHAP', 'Paulus Bast', 850, NULL, '1774', NULL, NULL, 'D', 'H', '1780-12-19', 'Texel', '1781-04-14', '1781-05-08', true, '1781-07-20', 'Batavia', NULL, 'During the voyage one man deserted. The VRIENDSCHAP was laid up in the Indies, 31-12-1787.');
INSERT INTO "voyages" VALUES (4389, '', 3, '', 'HELD WOLTEMADE', 'Swerus Vrolijk', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1780-12-19', 'Texel', '1781-04-14', '1781-06-28', true, NULL, NULL, NULL, '01-07-1781, however, the ship was taken by two English frigates, which forced it to sail to Plymouth (arrival: 03-02-1782).');
INSERT INTO "voyages" VALUES (4390, '', 1, '', 'VROUWE KATHARINA WILHELMINA', 'Pieter van Prooien', 880, NULL, '1778', NULL, NULL, 'R', 'R', '1780-12-25', 'Goeree', NULL, NULL, true, NULL, NULL, NULL, 'January, 1781, the ship arrived at Duins.');
INSERT INTO "voyages" VALUES (4391, '', 1, '', 'ZWALUW', 'Jan Jansz. Laurits', NULL, 'logger', NULL, NULL, NULL, NULL, NULL, '1782-01-03', 'Lorient', '1782-03-23', NULL, true, '1782-03-23', 'The Cape', 8082, 'The ZWALUW was bound for the Cape.');
INSERT INTO "voyages" VALUES (4392, '', 5, '', 'BOT', 'Johan Frederik Schuts', 1150, NULL, '1768', NULL, NULL, 'Z', 'Z', '1782-07-07', 'Texel', '1782-12-02', '1783-04-11', true, '1783-07-19', 'Batavia', NULL, '(4393), the HOLLAND (4394), the JAVA (4395), the SCHOONDERLOO (4396), the VOORBERG (4397), the ZEEPAARD (4398), and the ZEEUW (4399) were accompanied by two Dutch men-of-war. Commandeur of this fleet was Jan Paardekoper aboard the GANGES.');
INSERT INTO "voyages" VALUES (4393, '', 3, '', 'GANGES', 'Jan Paardekoper', 1150, NULL, '1775', NULL, NULL, 'A', 'A', '1782-07-07', 'Texel', '1782-12-02', '1783-02-10', true, '1783-08-03', 'Ceylon', 8106, 'departed om 11-09-1781; five days later the ship returned to Texel. The GANGES sailed via Mauritius. After having arrived at Ceylon the ship continued its voyage to Batavia, where it cast anchor on 15-11-1783. The high death-rate among the crew was due to scurvy. See also the BOT (4392).');
INSERT INTO "voyages" VALUES (4394, '', 4, '', 'HOLLAND', 'Isaak de Vries', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1782-07-07', 'Texel', '1782-12-02', '1783-02-10', true, '1783-08-03', 'Ceylon', 8105, 'out on 11-09-1781; five days later, however, it returned to Texel. The ship sailed via Mauritius. After having arrived at Ceylon the HOLLAND continued its voyage to Batavia; arrival: 16-11-1783. The high death-rate among the crew was due to scurvy. See also the BOT (4392).');
INSERT INTO "voyages" VALUES (4395, '', 2, '', 'JAVA', 'Jan Tromp', 850, NULL, '1775', NULL, NULL, 'E', 'H', '1782-07-07', 'Texel', '1782-12-02', '1783-05-06', true, '1783-07-30', 'Batavia', 8096, 'Originally the JAVA departed on 11-09-1781; five days later, however, the ship returned to Texel. The high death-rate among the crew was due to scurvy. See also the BOT (4392).');
INSERT INTO "voyages" VALUES (4396, '', 1, '', 'SCHOONDERLOO', 'Jakob van den Berg', 880, NULL, '1779', NULL, NULL, 'D', 'D', '1782-07-07', 'Texel', '1782-12-02', '1783-04-11', true, '1783-07-18', 'Batavia', 8092, 'On 10-09-1781 the SCHOONDERLOO departed from Goeree; six days later it arrived at Texel. During the voyage five members of the crew deserted. The high death-rate was due to scurvy. See also the BOT (4392).');
INSERT INTO "voyages" VALUES (4397, '', 4, '', 'VOORBERG', 'Abraham Tim', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1782-07-07', 'Texel', '1782-12-02', '1783-02-10', true, '1783-08-03', 'Ceylon', 8104, 'Originally the VOORBERG departed on 11-09-1781; five days later, however, it returned to Texel. The ship sailed via Mauritius. After having arrived at Ceylon the VOORBERG continued its voyage to Batavia, where it arrived on 16-11-1783. The high death-rate among the crew was due to scurvy. See also the BOT (4392).');
INSERT INTO "voyages" VALUES (4398, '', 3, '', 'ZEEPAARD', 'Pieter Thijssen jr.', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1782-07-07', 'Texel', '1782-12-02', '1783-04-11', true, '1783-07-18', 'Batavia', 8093, 'death rate was due to scurvy. See also the BOT (4392).');
INSERT INTO "voyages" VALUES (4399, '', 2, '', 'ZEEUW', 'Willem Udemans jr.', 1150, NULL, '1774', NULL, NULL, 'Z', 'Z', '1782-07-07', 'Texel', '1782-12-02', '1783-02-10', true, '1783-08-03', 'Ceylon', NULL, 'also the BOT (4392).');
INSERT INTO "voyages" VALUES (4400, '', 1, '', 'BERLIN', 'Arie van der Giessen', 898, 'fluit', NULL, NULL, NULL, 'D', NULL, '1782-08-28', 'Riga', '1783-01-06', '1793-02-15', true, '1783-05-24', 'Batavia', 8087, 'The BERLIN flew the Prussian flag. During the voyage the ship called at Helsingor; departure: 14-09-1782.');
INSERT INTO "voyages" VALUES (4401, '', 1, '', 'L''ANGELIQUE BENECH', 'De Strale', 250, NULL, NULL, NULL, NULL, NULL, NULL, '1782-09-02', 'La Rochelle', '1783-01-22', NULL, true, '1783-01-22', 'The Cape', 8085, 'The ANGELIQUE BENECH flew the Imperial (i.e.: Austrian) flag. The ship was bound for the Cape.');
INSERT INTO "voyages" VALUES (4402, '', 1, '', 'LOUIS FRANCOIS', 'Scipion', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1782-09-02', 'La Rochelle', '1783-01-22', '1783-05-26', true, NULL, 'Ceylon', NULL, 'The LOUIS FRANCOIS flew the Imperial (i.e.: Austrian) flag. The date of arrival at Ceylon is unknown.');
INSERT INTO "voyages" VALUES (4403, '', 1, '', 'FRIEDRICH DER GROSSE', 'Simon Koter', 678, NULL, NULL, NULL, NULL, NULL, NULL, '1782-09-07', 'Texel', '2-01-01', '1783-01-28', true, '1783-05-25', 'Batavia', 8088, 'The FRIEDRICH DER GROSSE flew the Prussian flag.');
INSERT INTO "voyages" VALUES (4404, '', 1, '', 'KROONPRINS VAN PRUISEN', 'Dirk Huizing', 760, NULL, NULL, NULL, NULL, NULL, NULL, '1782-09-07', 'Texel', '1783-01-13', NULL, true, '1783-01-13', 'The Cape', 8086, 'The KROONPRINS VAN PRUISEN flew the Prussian flag. It was bound for the Cape.');
INSERT INTO "voyages" VALUES (4405, '', 1, '', 'DOLFIJN', 'Ilonore Roux', 397, NULL, NULL, NULL, NULL, NULL, 'Z', '1782-12-04', 'Texel', '1783-04-28', '1783-05-26', true, '1783-09-01', 'Ceylon', 8094, 'The DOLFIJN flew the Imperial (i.e.: Austrian) flag.');
INSERT INTO "voyages" VALUES (4406, '', 2, '', 'OOSTEREEM', 'Axel Land', 1150, NULL, NULL, NULL, '1771', 'A', 'A', '1783-01-17', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The OOSTEREEM flew the Prussian flag. The ship was bound for China; on 21-01-1783, however, it ran aground at Goodwin''s Sand and was wrecked. 4406/- Is the second voyage of this ship, which during the preceding voyage (4184/8014) was called VENUS.');
INSERT INTO "voyages" VALUES (4407, '', 6, '', 'AURICH', 'Jan Meindertsz. Swaal', 850, NULL, NULL, NULL, '1766', 'R', 'E', '1783-02-15', 'Texel', '1783-05-26', '1783-06-17', true, '1783-09-01', 'Batavia', 8095, 'Pieter Modderman was master, when the ship arrived at the Cape. After having called at Batavia the AURICH possibly sailed on to China. 4407/8095 Is the sixth voyage of this ship, which during the preceding voyages was called RIDDERKERK (numbers of the fifth voyage: 4297/8032).');
INSERT INTO "voyages" VALUES (4408, '', 3, '', 'BRESLAU', 'Jan Kornelis Roos', 1150, NULL, NULL, NULL, '1774', 'A', 'Z', '1783-02-15', 'Rammekens', '1783-05-27', '1783-06-12', true, '1783-08-06', 'Batavia', 8101, 'having arrived at Batavia the ship sailed on to China, where it cast anchor on 11-10-1783. 4408/8101 Is the third voyage of this ship, which during its preceding voyages was called BLOK (numbers of the second voyage: 4327/8049).');
INSERT INTO "voyages" VALUES (4409, '', 1, '', 'LES DEUX SOEURS', 'Blankman', 582, NULL, NULL, '1781', NULL, 'B', 'Z', '1783-02-15', 'Lorient', '1783-06-14', NULL, true, '1783-06-14', 'The Cape', 8098, 'LES DEUX SOEURS was bound for the Cape.');
INSERT INTO "voyages" VALUES (4410, '', 1, '', 'POTSDAM', 'Bernard Christiaan Muller', 1150, NULL, NULL, NULL, '1780', 'A', 'A', '1783-02-25', 'Texel', '1783-05-27', '1783-06-12', true, '1783-08-09', 'Batavia', 8099, 'The POTSDAM flew the Prussian flag. The original date of departure was 17-01-1783, nine days later, however, the ship returned to Texel. After having arrived at Batavia the POTSDAM sailed on to China, where it cast anchor on 11-10-1783.');
INSERT INTO "voyages" VALUES (4411, '', 1, '', 'GERECHTIGHEID', 'Isaak Segon', 1150, NULL, '1779', NULL, NULL, 'A', 'A', '1783-03-04', 'Rammekens', '1783-07-19', '1783-08-22', true, '1783-11-08', 'Batavia', 8103, 'On 24-11-1782 the GERECHTIGHEID departed from Texel for Rammekens. At Texel a mutiny broke out, but was suppressed.');
INSERT INTO "voyages" VALUES (4412, '', 1, '', 'MAGDEBURG', 'Asuerus Brinkman', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1783-03-17', 'Texel', '1783-06-18', '1783-06-29', true, '1783-09-05', 'Batavia', 8089, 'Prussian flag. According to K.A. 3526 Jan Nieuwenhuis was master.');
INSERT INTO "voyages" VALUES (4413, '', 6, '', 'WILLEM DE VIJFDE', 'Pieter Kardon', 1150, NULL, '1765', NULL, NULL, 'Z', 'Z', '1783-04-04', 'Rammekens', '1783-07-19', '1783-08-10', true, '1783-11-02', 'Ceylon', 8102, NULL);
INSERT INTO "voyages" VALUES (4414, '', 1, '', 'PRINZ HEINRICH', 'Laurens Smit', 846, 'fluit', NULL, NULL, NULL, NULL, NULL, '1783-04-05', 'Texel', '1783-07-31', '1783-09-06', true, '1783-11-27', 'Batavia', 8107, 'ship was probably accompanied by a Dutch man-of-war.');
INSERT INTO "voyages" VALUES (4415, '', 1, '', 'ROTTERDAMS WELVAREN', 'Kornelis de Wit', 880, NULL, '1780', NULL, NULL, 'R', 'R', '1783-04-19', 'Goeree', '1783-08-08', '1783-09-10', true, '1783-11-17', 'Batavia', 8110, NULL);
INSERT INTO "voyages" VALUES (4416, '', 1, '', 'FACTOR', 'Jan Jochem Milfaart', 320, NULL, NULL, NULL, NULL, NULL, 'Z', '1783-05-20', 'Rammekens', '1783-08-29', NULL, true, '1783-08-29', 'The Cape', 8090, NULL);
INSERT INTO "voyages" VALUES (4417, '', 4, '', 'OUWERKERK', 'Pieter Six', 1150, NULL, '1768', NULL, NULL, 'Z', 'Z', '1783-06-01', 'Rammekens', '1783-11-14', '1784-01-14', true, '1784-04-26', 'Batavia', NULL, 'From 06 till 24-06-1783 the OUWERKERK called at Duins. The ship was laid up in the Indies, 31-12-1789.');
INSERT INTO "voyages" VALUES (4418, '', 1, '', 'L''HARMONIE', 'Joseph Bexto', 650, NULL, NULL, NULL, NULL, NULL, 'D', '1783-06-20', 'Rochefort', '1783-11-21', NULL, true, '1783-11-21', 'The Cape', 8100, 'L''HARMONIE flew the French flag. The ship was bound for the Cape.');
INSERT INTO "voyages" VALUES (4419, '', 4, '', 'HOOLWERF', 'Benjamin van der Spek', 850, NULL, '1769', NULL, NULL, 'H', 'A', '1783-06-24', 'Texel', '1783-11-14', '1783-12-17', true, '1784-04-13', 'Batavia', NULL, 'to the HOOLWERF as well as to the PRINSES VAN ORANJE (4423), the BREDERODE (4424), the DRAAK (4426), the ZEEDUIN (4428), the TRITON (4431), the DAPPERHEID (4434), and the''T LOO (4437): 1881 seafarers, 421 soldiers, 38 craftsmen, and 14 passengers departed from Texel; 1538 seafarers, 267 soldiers, 27 craftsmen, and 32 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4420, '', 2, '', 'HINDELOOPEN', 'Kornelis Loreim', 850, NULL, '1776', NULL, NULL, 'D', 'D', '1783-06-27', 'Goeree', '1783-11-22', '1783-12-17', true, '1784-03-13', 'Batavia', 8164, 'The following data refer to both the HINDELOOPEN and the ROZENBURG (4425): 451 seafarers, 91 soldiers, 14 craftsmen, and 6 passengers departed from Goeree; 366 seafarers, 70 soldiers, 17 craftsmen, and 4 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4421, '', 1, '', 'L''ESPERANCE DE LA PRIX', NULL, 600, NULL, NULL, NULL, NULL, NULL, 'A', '1783-06-01', 'La Rochelle', '1783-11-16', NULL, true, '1783-11-16', 'The Cape', 8109, 'it probably sailed via the Guinea Coast.');
INSERT INTO "voyages" VALUES (4422, '', 2, '', 'VROUWE EVERHARDINA', 'Wouter de Gelder', 850, NULL, '1776', NULL, NULL, 'D', 'Z', '1783-07-08', 'Rammekens', '1783-10-29', '1783-12-23', true, '1784-04-24', 'Batavia', NULL, 'soldiers, and 9 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4423, '', 5, '', 'PRINSES VAN ORANJE', 'Jan Frederik Volmer', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1783-07-24', 'Texel', '1783-10-29', '1783-12-20', true, '1784-03-11', 'Batavia', NULL, 'In 1789 the PRINSES VAN ORANJE was laid up in the Indies. See the HOOLWERF (4419).');
INSERT INTO "voyages" VALUES (4424, '', 1, '', 'BREDERODE', 'Gottlieb Mulder', 1150, NULL, '1780', NULL, NULL, 'A', 'A', '1783-07-26', 'Texel', '1783-11-30', '1784-01-09', true, '1784-04-13', 'Batavia', 8136, 'BREDERODE departed from Batavia and sailed to China, where it arrived on 24-09-1784. See the HOOLWERF (4419).');
INSERT INTO "voyages" VALUES (4425, '', 1, '', 'ROZENBURG', 'Gerrit Harmeyer', 880, NULL, '1780', NULL, NULL, 'D', 'D', '1783-09-17', 'Goeree', '1784-01-15', '1784-02-14', true, '1784-05-18', 'Batavia', 8122, 'See the HINDELOOPEN (4420).');
INSERT INTO "voyages" VALUES (4426, '', 1, '', 'DRAAK', 'Arie Kikkert', 1150, NULL, '1780', NULL, NULL, 'A', 'A', '1783-09-27', 'Texel', '1784-01-01', '1784-01-21', true, '1784-04-13', 'Batavia', 8134, 'On 15-08-1784 the DRAAK departed from Batavia and sailed to China, where it cast anchor on 30-09-1784. See the HOOLWERF (4419).');
INSERT INTO "voyages" VALUES (4427, '', 1, '', 'STRALEN', 'Willem de Wijn', 880, NULL, '1778', NULL, NULL, 'E', 'E', '1783-09-28', 'Texel', '1784-01-15', '1784-02-14', true, '1784-05-10', 'Batavia', 8135, NULL);
INSERT INTO "voyages" VALUES (4428, '', 2, '', 'ZEEDUIN', 'Jan Frederik Zegert', 1150, NULL, '1771', NULL, NULL, 'Z', 'A', '1783-09-28', 'Texel', '1784-01-01', '1784-04-16', true, '1784-07-20', 'Batavia', NULL, 'The ZEEDUIN sailed via Mauritius. In 1785, when sailing from Batavia to the Cape, the ship was wrecked. See the HOOLWERF (4419).');
INSERT INTO "voyages" VALUES (4429, '', 5, '', 'BLEIJENBURG', 'Willem Jakob Andriessen', 880, NULL, '1765', NULL, NULL, 'R', 'R', '1783-10-12', 'Goeree', '1784-01-20', '1784-04-16', true, '1784-08-18', 'Batavia', NULL, 'The BLEIJENBURG sailed via Mauritius. In 1789 the ship was laid up in the Indies.');
INSERT INTO "voyages" VALUES (4430, '', 1, '', 'GOUVERNEUR-GENERAAL DE CLERCK', 'Jochem Bank', 1150, NULL, '1779', NULL, NULL, 'Z', 'Z', '1783-10-12', 'Rammekens', '1784-01-22', '1784-02-14', true, '1784-05-06', 'Batavia', 8133, 'On 15-07-1784 the GOUVERNEUR-GENERAAL DE CLERCK depated from Batavia and sailed to China. See the VROUWE EVERHARDINA (4422).');
INSERT INTO "voyages" VALUES (4431, '', 3, '', 'TRITON', 'Hendrik Steedsel', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1783-10-26', 'Texel', '1784-03-18', '1784-04-12', true, '1784-06-29', 'Batavia', 8140, 'See the HOOLWERF (4419).');
INSERT INTO "voyages" VALUES (4432, '', 1, '', 'HARMONIE', 'Kornelis Philippus Hoek', 1150, NULL, '1778', NULL, NULL, 'Z', 'Z', '1783-11-07', 'Rammekens', '1784-03-09', '1784-04-12', true, '1784-07-02', 'Batavia', 8124, 'The 20 passengers, who embarked at the Cape, included 14 Chinese.');
INSERT INTO "voyages" VALUES (4433, '', 1, '', 'BERKHOUT', 'Herman Jakob Hulleman', 1150, NULL, '1779', NULL, NULL, 'H', 'H', '1783-12-12', 'Texel', '1784-03-30', '1784-04-26', true, '1784-08-18', 'Batavia', 8138, 'On 25-08-1784 the BERKHOUT departed from Batavia and sailed to China.');
INSERT INTO "voyages" VALUES (4434, '', 1, '', 'DAPPERHEID', 'Kornelis de Boer', 472, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1783-12-23', 'Texel', '1784-04-12', '1784-05-14', true, '1784-07-19', 'Batavia', 8119, 'According to K.A. 4189 the departing crew consisted of 262 men. See the HOOLWERF (4419).');
INSERT INTO "voyages" VALUES (4435, '', 1, '', 'DOGGERSBANK', 'Swerus Vrolijk', 1150, NULL, '1782', NULL, NULL, 'A', 'A', '1783-12-23', 'Texel', '1784-04-15', '1784-05-07', true, '1784-08-21', 'Ceylon', 8139, NULL);
INSERT INTO "voyages" VALUES (4436, '', 1, '', 'JONGE FRANK', 'Jakob Veer', 592, NULL, NULL, NULL, NULL, NULL, 'A', '1783-12-23', 'Texel', '1784-04-29', '1784-05-16', true, '1784-08-01', 'Batavia', 8126, NULL);
INSERT INTO "voyages" VALUES (4437, '', 7, '', '''T LOO', 'Dirk Hulsebos', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1783-12-23', 'Texel', '1784-04-13', '1784-05-07', true, '1784-07-04', 'Batavia', 8121, 'See the HOOLWERF (4419).');
INSERT INTO "voyages" VALUES (4438, '', 1, '', 'MEERMIN', 'Francois Duminy', 500, 'fregat', '1782', NULL, NULL, 'A', 'A', '1783-12-23', 'Texel', '1784-04-03', NULL, true, '1784-04-03', 'The Cape', 8252, 'The MEERMIN was bound for the Cape.');
INSERT INTO "voyages" VALUES (4439, '', 2, '', 'ZWALUW', 'Harme Karel Visser', NULL, 'logger', NULL, NULL, NULL, NULL, NULL, '1783-12-23', 'Lorient', '1784-04-06', NULL, true, '1784-04-06', 'The Cape', NULL, NULL);
INSERT INTO "voyages" VALUES (4440, '', 1, '', 'LES QUATRES FRERES', 'Samuel Nusker', 620, 'fregat', NULL, NULL, NULL, NULL, 'A', '1783-12-27', 'Texel', '1784-08-14', '1784-09-15', true, '1784-12-16', 'Batavia', 8145, 'LES QUATRES FRERES flew the Prussian flag. During the voyage the ship called at Lorient (departure: 23-05-1784).');
INSERT INTO "voyages" VALUES (4441, '', 2, '', 'VREDE EN VRIJHEID', 'Dirk Huizing', 760, NULL, NULL, NULL, NULL, NULL, 'A', '1783-12-27', 'Texel', '1784-04-25', '1784-08-10', true, '1784-10-07', 'Batavia', 8128, 'This is the second voyage of this ship, which during its preceding voyage (4404/8086) was called KROONPRINS VAN PRUISEN.');
INSERT INTO "voyages" VALUES (4442, '', 1, '', 'VREDE', 'John Wilton', 650, NULL, NULL, '1783', NULL, 'Z', 'Z', '1784-01-06', 'Rammekens', '1784-04-25', '1784-06-02', true, '1784-08-13', 'Batavia', NULL, 'According to K.A. 4289 the departing crew consisted of 137 men. The VREDE called at Duins, 08 till 29-01-1784. See the VROUWE EVERHARDINA (4422).');
INSERT INTO "voyages" VALUES (4443, '', 1, '', 'ONZEKERE', 'Jakob Johan Staalkop', 348, NULL, NULL, NULL, NULL, NULL, 'Z', '1784-04-08', 'Rammekens', '1784-07-25', '1784-08-11', true, '1784-10-15', 'Batavia', 8130, 'The ONZEKERE called at Duins, 12 till 29-04-1784.');
INSERT INTO "voyages" VALUES (4444, '', 2, '', 'STAVENISSE', 'Kornelis van Vlaanderen', 1150, NULL, '1772', NULL, NULL, 'Z', 'Z', '1784-04-08', 'Rammekens', '1784-08-20', '1784-09-17', true, '1784-12-27', 'Ceylon', 8166, 'False Bay.');
INSERT INTO "voyages" VALUES (4445, '', 1, '', 'VROUWE WIJNANDA LUBERTA', 'Sijbrand Berk', 508, 'fregat', NULL, NULL, NULL, NULL, 'A', '1784-05-17', 'Texel', '1784-08-16', '1784-09-15', true, '1784-11-13', 'Batavia', 8137, 'According to K.A. 4390a the departing crew consisted of 245 men. On 15-09-1784 the VROUWE WIJNANDA LUBERTA set out from False Bay.');
INSERT INTO "voyages" VALUES (4446, '', 1, '', 'VRIJHEID', 'Andries Allan', 790, 'fluit', NULL, NULL, NULL, NULL, 'R', '1784-05-24', 'Goeree', '1784-09-10', '1784-09-22', true, '1784-12-15', 'Batavia', 8144, NULL);
INSERT INTO "voyages" VALUES (4447, '', 1, '', 'BATAVIER', 'Jan Jansz. Laurits', 1150, NULL, '1782', NULL, NULL, 'A', 'A', '1784-06-01', 'Texel', '1784-09-21', '1784-10-15', true, '1784-12-27', 'Batavia', 8240, NULL);
INSERT INTO "voyages" VALUES (4448, '', 1, '', 'SCHELDE', 'Pieter Harmsz.', 1150, NULL, '1780', NULL, NULL, 'Z', 'Z', '1784-07-07', 'Rammekens', '1781-11-26', '1785-01-08', true, '1785-03-19', 'Batavia', 8176, 'The SCHELDE called at Duins; departure: 02-08-1784.');
INSERT INTO "voyages" VALUES (4449, '', 1, '', 'VREDE', 'Thijs Ketel', 854, 'fluit', NULL, NULL, NULL, NULL, 'A', '1784-07-07', 'Texel', '1785-01-17', NULL, true, '1785-01-17', 'The Cape', 8143, 'The VREDE was bound for the Cape.');
INSERT INTO "voyages" VALUES (4450, '', 1, '', 'EENSGEZINDHEID', 'Peter Jansen', 884, 'fluit', NULL, NULL, NULL, NULL, 'A', '1784-07-29', 'Texel', '1784-11-29', '1785-01-22', true, '1785-03-18', 'Batavia', 8147, 'According to K.A. 4390a the departing crew consisted of 305 men.');
INSERT INTO "voyages" VALUES (4451, '', 1, '', 'EIK EN LINDE', 'Dirk Carlberg', 574, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1784-08-02', 'Texel', '1784-12-18', '1785-01-16', true, '1785-05-01', 'Batavia', 8149, 'At the departure from Texel the EIK EN LINDE and the EIKENWOUD (4452) were escorted by a man-of-war.');
INSERT INTO "voyages" VALUES (4452, '', 1, '', 'EIKENWOUD', 'Klaas Ent', 892, 'fluit', NULL, NULL, NULL, NULL, 'A', '1784-08-02', 'Texel', '1784-12-26', '1785-02-07', true, '1785-06-29', 'Batavia', 8159, 'According to K.A. 4390a the departing crew consisted of 22 men. See the EIK EN LINDE (4451).');
INSERT INTO "voyages" VALUES (4453, '', 1, '', 'SPAARNE', 'Johan Otto', 656, 'hoeker', NULL, '1784', NULL, 'A', 'A', '1784-08-14', 'Texel', '1784-12-21', '1785-01-29', true, '1785-05-25', 'Batavia', 8213, NULL);
INSERT INTO "voyages" VALUES (4454, '', 1, '', 'EENPARIGHEID', 'Pieter Johan Muller', 600, NULL, NULL, '1784', NULL, 'H', 'H', '1784-08-21', 'Texel', '1784-12-21', '1785-01-16', true, '1785-05-30', 'Batavia', 8177, NULL);
INSERT INTO "voyages" VALUES (4455, '', 1, '', 'MENTOR', 'Jan Jochem Milfaart', 560, NULL, NULL, NULL, NULL, NULL, 'Z', '1784-08-21', 'Rammekens', '1784-12-04', '1785-02-05', true, '1785-05-12', 'Batavia', 8150, NULL);
INSERT INTO "voyages" VALUES (4456, '', 4, '', 'LAM', 'Bartholomeus Veau', 850, NULL, '1769', NULL, NULL, 'D', 'Z', '1784-09-04', 'Rammekens', '1785-01-16', '1785-02-23', true, '1785-06-22', 'Batavia', NULL, 'In 1789 the LAM was wrecked in the Indies.');
INSERT INTO "voyages" VALUES (4457, '', 1, '', 'CONSTANTIA', 'Adriaan van Katersveld', 880, NULL, '1782', NULL, NULL, 'D', 'D', '1784-09-14', 'Goeree', '1784-12-23', '1785-01-16', true, '1785-04-21', 'Batavia', 8163, NULL);
INSERT INTO "voyages" VALUES (4458, '', 2, '', 'DORDRECHT', 'Ane van der Giessen', 898, 'fluit', NULL, NULL, NULL, 'D', 'A', '1784-09-19', 'Texel', '1784-12-18', '1785-01-05', true, '1785-04-15', 'Batavia', 8148, '(4400/8087) was called BERLIN.');
INSERT INTO "voyages" VALUES (4459, '', 1, '', 'VROUWE JOHANNA JAKOBA', 'Jan Hendrik van der Linden', 444, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1784-09-19', 'Texel', '1785-01-13', '1785-02-13', true, '1785-06-20', 'Batavia', 8156, NULL);
INSERT INTO "voyages" VALUES (4460, '', 1, '', 'VLUGGE TREKVOGEL', 'Barend Jansz. Uffen', 484, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1784-09-19', 'Texel', '1785-02-12', '1785-03-28', true, '1785-07-13', 'Batavia', 8160, NULL);
INSERT INTO "voyages" VALUES (4461, '', 1, '', 'WILLEM EN JAN', 'Tijmen de Zweed', 356, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1784-09-19', 'Texel', '1785-02-20', '1785-03-12', true, '1785-06-25', 'Batavia', 8154, NULL);
INSERT INTO "voyages" VALUES (4462, '', 1, '', 'JONGE JAKOB', 'Asmus Pieter Asmus', 648, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1784-09-25', 'Texel', '1784-12-23', '1785-03-23', true, NULL, 'Batavia', 8155, 'Date of arrival at Batavia unknown.');
INSERT INTO "voyages" VALUES (4463, '', 1, '', 'RESOLUTIE', 'Justinus Philippus Man', 530, NULL, NULL, '1784', NULL, 'E', 'E', '1784-09-25', 'Texel', '1785-01-13', '1785-02-13', true, '1785-05-27', 'Batavia', 8268, NULL);
INSERT INTO "voyages" VALUES (4464, '', 1, '', 'CASTOR', 'Matthijs Lodewijk Heikoop', 650, NULL, NULL, '1784', NULL, 'Z', 'Z', '1784-09-29', 'Rammekens', '1784-12-28', '1785-01-29', true, '1785-05-14', 'Batavia', 8263, NULL);
INSERT INTO "voyages" VALUES (4465, '', 1, '', 'VOORSCHOTEN', 'Kornelis Kornelissen', 1150, NULL, '1783', NULL, NULL, 'A', 'A', '1784-09-29', 'Texel', '1785-01-23', '1785-02-23', true, '1785-06-20', 'Batavia', 8158, 'According to K.A. 4390a the departing crew consisted of 290 men. After having arrived at Batavia the VOORSCHOTEN sailed on to China.');
INSERT INTO "voyages" VALUES (4466, '', 1, '', 'MIDDELWIJK', 'Kornelis de Klerk', 880, NULL, '1783', NULL, NULL, 'R', 'R', '1784-09-30', 'Goeree', '1785-01-05', '1785-01-29', true, '1785-05-25', 'Batavia', NULL, 'In 1788 the MIDDELWIJK, sailing from Batavia to China, was wrecked.');
INSERT INTO "voyages" VALUES (4467, '', 1, '', 'HOOP', 'Jan Kraai', 175, NULL, NULL, '1782', NULL, 'A', 'A', '1784-10-10', 'Texel', '1784-12-27', '1785-01-16', true, '1785-04-24', 'Batavia', 8151, NULL);
INSERT INTO "voyages" VALUES (4468, '', 1, '', 'OUDENAARDE', 'Hans Klaassen', 380, NULL, NULL, NULL, NULL, NULL, 'Z', '1784-10-11', 'Rammekens', '1785-01-26', '1785-04-10', true, '1785-06-25', 'Batavia', 8172, NULL);
INSERT INTO "voyages" VALUES (4469, '', 1, '', 'POLLUX', 'Lodewijk Kappelhof', 550, NULL, NULL, '1784', NULL, 'Z', 'Z', '1784-10-30', 'Rammekens', '1785-03-03', '1785-03-30', true, '1785-06-20', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (4470, '', 1, '', 'BARBESTEIN', 'Dirk Kornelis Plokker', 1150, NULL, '1783', NULL, NULL, 'A', 'A', '1784-12-12', 'Texel', '1785-03-30', '1785-04-29', true, '1785-07-10', 'Batavia', 8161, '(4471), the JAVA (4472), the SPARENRIJK (4474), and the ZEEPAARD (4475) were accompanied by a Dutch man-of-war.');
INSERT INTO "voyages" VALUES (4471, '', 1, '', 'HUISDUINEN', 'Laurens Kornelissen', 723, NULL, NULL, '1784', NULL, 'A', 'A', '1784-12-12', 'Texel', '1785-03-27', '1785-05-08', true, '1785-07-01', 'Ceylon', 8157, 'See the BARBESTEIN (4470).');
INSERT INTO "voyages" VALUES (4472, '', 3, '', 'JAVA', 'Harme Karel Visser', 850, NULL, '1775', NULL, NULL, 'E', 'A', '1784-12-12', 'Texel', '1785-04-25', '1785-05-28', true, '1785-08-11', 'Batavia', 8216, 'See the BARBESTEIN (4470).');
INSERT INTO "voyages" VALUES (4473, '', 2, '', 'PAREL', 'Kornelis in ''t Anker', 1150, NULL, '1778', NULL, NULL, 'A', 'Z', '1784-12-12', 'Rammekens', '1785-05-27', '1785-07-25', true, '1785-09-24', 'Batavia', 8193, 'During a heavy storm the PAREL lost its foremast and bowsprit. For that reason the ship was forced to call at S. Tiago, 30-01 till 30-03-1785. Two spars were supplied by the PHOENIX, a Dutch man-of-war, which called at the island from 03 till 07-02-1785.');
INSERT INTO "voyages" VALUES (4474, '', 2, '', 'SPARENRIJK', 'Christoffel Beem', 1150, NULL, '1780', NULL, NULL, 'A', 'A', '1784-12-12', 'Texel', '1785-04-04', '1785-05-28', true, '1785-09-22', 'Ceylon', 8262, 'See the BARBESTEIN (4470). 4474/8262 Is the second voyage of this ship, which during the preceding voyage (4410/8099) was called POTSDAM.');
INSERT INTO "voyages" VALUES (4475, '', 4, '', 'ZEEPAARD', 'Hendrik Zwart', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1784-12-12', 'Texel', '1785-05-23', '1785-07-28', true, '1785-09-26', 'Batavia', 8180, 'the ZEEPAARD arrived at False Bay. See the BARBESTEIN (4470).');
INSERT INTO "voyages" VALUES (4476, '', 1, '', 'NEERLANDS VRIJHEID', 'Frederik Floor', 566, NULL, NULL, NULL, NULL, NULL, 'A', '1784-12-13', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'One day after its departure from Texel the NEERLANDS VRIJHEID ran aground off the coast of England and was wrecked.');
INSERT INTO "voyages" VALUES (4477, '', 1, '', 'MEEUWTJE', 'Huibert den Breem', 400, NULL, '1783', NULL, NULL, 'A', 'E', '1784-12-22', 'Texel', '1785-04-17', '1786-01-05', true, '1786-05-02', 'Batavia', 8285, 'the NEGOTIE (4497), the TEXELSTROOM (4498), the ZAANSTROOM (4499), the ZOUTMAN (4501), the DUIFJE (4508), and the VREDENBURG (4511): 1704 seafarers, 461 soldiers. 80 craftsmen, and 51 passengers including 24 Chinese departed from Texel; 1545 seafarers, 345 soldiers, 71 craftsmen, and 39 passengers (incl. 21 Chinese) arrived at Batavia.');
INSERT INTO "voyages" VALUES (4478, '', 1, '', 'AFRIKAAN', 'Pieter Modderman', 880, NULL, '1780', NULL, NULL, 'E', 'E', '1784-12-26', 'Texel', '1785-04-21', '1785-05-11', true, '1785-07-13', 'Batavia', 8165, 'On 23-08-1785 the AFRIKAAN departed from Batavia and sailed to China.');
INSERT INTO "voyages" VALUES (4479, '', 1, '', 'AVENHORN', 'A. Arend Thobiasz.', 880, NULL, '1780', NULL, NULL, 'H', 'H', '1784-12-26', 'Texel', '1785-04-20', '1785-05-16', true, '1785-08-11', 'Batavia', 8201, 'According to K.A. 4295 the departing crew consisted of 258 men.');
INSERT INTO "voyages" VALUES (4480, '', 2, '', 'SLOT TER HOGE', 'Jan Siereveld', 1150, NULL, '1776', NULL, NULL, 'Z', 'Z', '1784-12-28', 'Rammekens', '1785-04-17', '1785-05-11', true, '1785-07-10', 'Batavia', 8167, 'Jan Siereveld became ill and disembarked at the Cape; as master he probably was succeeded by Lodewijk Elgenhuizen.');
INSERT INTO "voyages" VALUES (4481, '', 1, '', 'NOSTRA SENHORA DE L''AMPRADOZA', 'Josua Felix de Zouza', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1785-03-02', 'Lisbon', '1735-07-10', '1785-07-18', true, '1785-10-03', 'Batavia', NULL, 'The NOSTRA SENHORA DE L''AMPRADOZA flew the Portuguese flag. According to 
K.A. 
3577. fol. 2482 the ship
carried goods for the V.O.C.; 
acc. to fol. 2476 it remained at
Batavia.');
INSERT INTO "voyages" VALUES (4482, '', 2, '', 'GERECHTIGHEID', 'Hans Christiaan Christiaanse', 1150, NULL, '1779', NULL, NULL, 'A', 'A', '1785-05-23', 'Texel', '1785-10-19', '1785-11-14', true, '1786-02-21', 'Batavia', 8231, 'According to K.A. 4293 the departing crew consisted of 338 men. See the MEEUWTJE (4477).');
INSERT INTO "voyages" VALUES (4483, '', 1, '', 'ALBLASSERDAM', 'Aris van Valkenburg', 1150, NULL, '1782', NULL, NULL, 'Z', 'Z', '1785-06-13', 'Rammekens', '1785-10-18', '1785-11-25', true, '1786-02-21', 'Batavia', 8230, NULL);
INSERT INTO "voyages" VALUES (4484, '', 1, '', 'JAN EN KORNELIS', 'Klaas Duif', 560, NULL, NULL, NULL, NULL, NULL, 'A', '1785-06-13', 'Texel', '1785-10-29', '1785-11-25', true, '1786-03-01', 'Batavia', 8169, NULL);
INSERT INTO "voyages" VALUES (4485, '', 1, '', 'RIJNOORD', 'Laurens Smit', 846, 'fluit', NULL, NULL, NULL, NULL, 'A', '1785-06-13', 'Texel', '1785-11-04', '1785-12-27', true, '1786-06-25', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (4486, '', 1, '', 'IJSTROOM', 'Dirk Roem', 898, NULL, NULL, '1785', NULL, 'A', 'A', '1785-06-13', 'Texel', '1785-10-29', '1785-11-25', true, '1786-02-21', 'Batavia', 8236, 'crew consisted of 309 men. See the MEEUWTJE (4477).');
INSERT INTO "voyages" VALUES (4487, '', 2, '', 'FACTOR', 'Jan Jochem Milfaart', 320, NULL, NULL, NULL, NULL, NULL, 'Z', '1785-06-24', 'Rammekens', '1785-10-29', '1785-11-25', true, '1786-03-08', 'Ceylon', 8168, NULL);
INSERT INTO "voyages" VALUES (4488, '', 1, '', 'GEERTRUIDA', 'Daniel Kunneman', 660, 'fluit', NULL, NULL, NULL, NULL, 'A', '1785-06-28', 'Texel', '1785-10-29', '1785-11-19', true, '1786-02-13', 'Batavia', 8170, NULL);
INSERT INTO "voyages" VALUES (4489, '', 1, '', 'JOSEPHUS DE TWEEDE', 'Christiaan Zummack', 460, NULL, NULL, NULL, NULL, NULL, 'Z', '1785-07-13', 'Rammekens', '1785-10-27', '1785-11-25', true, '1786-02-09', 'Batavia', 8171, NULL);
INSERT INTO "voyages" VALUES (4490, '', 2, '', 'ROTTERDAMS WELVAREN', 'Gijshert Matthias Weitzel', 880, NULL, '1780', NULL, NULL, 'R', 'R', '1785-07-26', 'Goeree', '1785-11-16', '1785-12-05', true, '1786-03-01', 'Batavia', 8269, 'The following data refer to both the ROTTERDAMS WELVAREN and the STANDVASTIGHEID (4504): 362 seafarers. 49 soldiers, 9 craftsmen, and 3 passengers departed from Goeree; 291 seafarers, 51 soldiers, 6 craftsmen, and 8 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4491, '', 1, '', 'BEVERWIJK', 'Hendrik Eduard Lodewijk van Baggen', 1150, NULL, '1784', NULL, NULL, 'A', 'A', '1785-09-15', 'Texel', '1786-02-09', '1786-03-02', true, '1786-05-26', 'Batavia', 8187, 'According to K.A. 4293 the departing crew consisted of 325 men. The BEVERWIJK called at Portsmouth, 16 till 18-10-1785. On 17-08-1786 the ship departed from Batavia and sailed to China. See the MEEUWTJE (4477).');
INSERT INTO "voyages" VALUES (4492, '', 1, '', 'MARIA LUCIA THERESIA', 'Dirk Peek', 429, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1785-09-15', 'Texel', '1786-01-19', '1786-02-23', true, '1786-05-27', 'Batavia', 8173, NULL);
INSERT INTO "voyages" VALUES (4493, '', 7, '', 'RIDDERKERK', 'Imel Edan de Vries', 850, NULL, '1766', NULL, NULL, 'R', 'E', '1785-09-15', 'Texel', '1786-02-04', '1786-02-27', true, '1786-05-27', 'Batavia', NULL, '21 of them had embarked at Texel. 4493/- Is the seventh voyage of this ship, which during its sixth voyage (4407/8095) was called AURICH.');
INSERT INTO "voyages" VALUES (4494, '', 2, '', 'SCHOONDERLOO', 'Gouke Dekker van der Mieden', 880, NULL, '1779', NULL, NULL, 'D', 'D', '1785-09-15', 'Goeree', '1786-02-07', '1786-02-27', true, '1786-05-30', 'Batavia', 8183, '(4503): 408 seafarers, 93 soldiers, 16 craftsmen, and 26 passengers including 24 Chinese departed from Goeree; 339 seafarers, 59 soldiers, 10 craftsmen, and 37 passengers (incl. the 24 Chinese) arrived at Batavia.');
INSERT INTO "voyages" VALUES (4495, '', 6, '', 'OUD HAARLEM', 'Johan Bakker', 1150, NULL, '1768', NULL, NULL, 'A', 'Z', '1785-10-19', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'was taken over by the outward-bound TRITON (4517), which left the island on 04-08-1786. At Santa Cruz Johan Bakker probably changed ships, for in K.A. 4298, a source from the Cape, he is mentioned as master of the TRITON. The OUD HAARLEM sailed back to Rammekens.');
INSERT INTO "voyages" VALUES (4496, '', 1, '', 'VROUWE KATHARINA JOHANNA', 'Pieter Stokbroo', 900, NULL, NULL, '1785', NULL, 'H', 'H', '1785-10-19', 'Texel', '1786-02-11', '1786-03-06', true, '1786-05-30', 'Batavia', 8181, '185 men. Originally the VROUWE KATHARINA JOHANNA put to sea on 15-09-1785; nine days later, however, the ship returned to Texel. The following data refer to both the VROUWE KATHARINA JOHANNA and the HOLLAND (4514): 438 seafarers, 70 soldiers, 11 craftsmen, and 23 passengers including 20 Chinese departed from Texel; 353 seafarers, 63 soldiers, 17 craftsmen, and 21 passengers (incl. the 20 Chinese) arrived at Batavia.');
INSERT INTO "voyages" VALUES (4497, '', 1, '', 'NEGOTIE', 'Jonas Arend', 440, NULL, NULL, '1785', NULL, 'A', 'A', '1785-10-19', 'Texel', '1786-02-07', '1786-04-07', true, '1786-06-23', 'Batavia', 8264, 'See the MEEUWTJE (4477).');
INSERT INTO "voyages" VALUES (4498, '', 1, '', 'TEXELSTROOM', 'Paulus Kroon', 708, NULL, NULL, '1785', NULL, 'A', 'A', '1785-10-19', 'Texel', '1786-02-21', '1786-03-11', true, '1786-06-03', 'Batavia', 8182, 'See the MEEUWTJE (4477).');
INSERT INTO "voyages" VALUES (4499, '', 1, '', 'ZAANSTROOM', 'Roelof Pietersz. Hoberg', 564, NULL, NULL, '1785', NULL, 'A', 'A', '1785-10-19', 'Texel', '1786-04-27', '1786-05-19', true, '1786-07-21', 'Batavia', 8267, 'See the MEEUWTJE (4477).');
INSERT INTO "voyages" VALUES (4500, '', 1, '', 'ZEENIMF', 'Johan Noordhoek', 450, NULL, '1782', NULL, NULL, 'Z', 'Z', '1785-10-19', 'Texel', '1786-02-03', '1786-03-23', true, '1786-07-11', 'Batavia', 8286, 'On 03-10-1785 the ZEENIMF departed from Rammekens and sailed to Texel, where it cast anchor on 11-10. The ship called at S. Tiago, 26-11 till 04-12-1785.');
INSERT INTO "voyages" VALUES (4501, '', 1, '', 'ZOUTMAN', 'Bernard Christiaan Muller', 1150, NULL, '1784', NULL, NULL, 'A', 'A', '1785-10-19', 'Texel', '1786-02-09', '1786-02-27', true, '1786-05-27', 'Batavia', 8184, 'On 10-07-1786 the ZOUTMAN departed from Batavia and sailed to China. See the MEEUWTJE (4477).');
INSERT INTO "voyages" VALUES (4502, '', 2, '', 'TWEE GEZUSTERS', 'Wouter Jakobsen', 582, NULL, NULL, '1781', NULL, 'Z', 'Z', '1785-11-09', 'Rammekens', '1786-02-21', '1786-05-06', true, '1786-07-22', 'Batavia', 8175, '4502/8175 Is the second voyage of this ship, which during its preceding voyage (4409/8098) was called LES DEUX SOEURS.');
INSERT INTO "voyages" VALUES (4503, '', 1, '', 'HORSSEN', 'Jakob van den Berg', 880, NULL, '1784', NULL, NULL, 'D', 'D', '1785-11-14', 'Goeree', '1786-02-13', '1786-03-02', true, '1786-05-30', 'Batavia', 8185, 'On 10-07-1786 the HORSSEN departed from Batavia and sailed to China. See the SCHOONDERLOO (4494).');
INSERT INTO "voyages" VALUES (4504, '', 1, '', 'STANDVASTIGHEID', 'Willem Sterk', 780, 'hoeker', NULL, '1785', NULL, 'R', 'R', '1785-11-14', 'Goeree', '1786-04-04', '1786-05-06', true, '1786-07-19', 'Batavia', 8235, '(4490).');
INSERT INTO "voyages" VALUES (4505, '', 2, '', 'VREDE EN VRIJHEID', 'Dirk Huizing', 760, NULL, NULL, NULL, NULL, NULL, 'Z', '1785-12-10', 'Rammekens', '1786-05-01', '1786-06-07', true, '1786-08-28', 'Batavia', 8178, NULL);
INSERT INTO "voyages" VALUES (4506, '', 2, '', 'GOUVERNEUR-GENERAAL DE CLERCK', 'Jan Arendsz.', 1150, NULL, '1779', NULL, NULL, 'Z', 'Z', '1785-12-17', 'Rammekens', '1786-04-14', '1786-05-06', true, '1786-07-09', 'Batavia', 8188, 'China.');
INSERT INTO "voyages" VALUES (4507, '', 2, '', 'DRAAK', 'Pieter Frederik Riebe', 1150, NULL, '1780', NULL, NULL, 'A', 'A', '1785-12-18', 'Texel', NULL, NULL, false, '1786-08-22', 'Ceylon', 8192, 'At the departure from Texel the DRAAK, the DUIFJE (4508), the NEPTUNUS (4509), the STRALEN (4510), and the VREDENBURG (4511) were accompanied by a Dutch man-of-war.');
INSERT INTO "voyages" VALUES (4508, '', 1, '', 'DUIFJE', 'Gerrit Jan van der Kerkhof', 400, NULL, '1 784', NULL, NULL, 'A', 'A', '1785-12-18', 'Texel', '1786-03-24', '1786-05-06', true, '1786-07-08', 'Batavia', 8190, 'See the MEEUWTJE (4477) and the DRAAK (4507).');
INSERT INTO "voyages" VALUES (4509, '', 1, '', 'NEPTUNUS', 'Clement Bijndorp', 748, NULL, NULL, '1785', NULL, 'A', 'A', '1785-12-18', 'Texel', '1786-05-13', '1786-09-07', true, '1786-12-13', 'Batavia', NULL, 'seafarers, 33 soldiers, 12 craftsmen, and 4 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4510, '', 2, '', 'STRALEN', 'Jan Paardekoper', 880, NULL, '1778', NULL, NULL, 'E', 'A', '1785-12-18', 'Texel', '1786-04-30', '1786-05-19', true, '1786-09-05', 'Bengal', 8186, 'The STRALEN called at S. Tiago, 27-01 till 02-02-1786. See the DRAAK (4507).');
INSERT INTO "voyages" VALUES (4511, '', 1, '', 'VREDENBURG', 'Herman Kikken', 1150, NULL, '1784', NULL, NULL, 'A', 'A', '1785-12-18', 'Texel', '1786-04-30', '1786-05-19', true, '1786-07-23', 'Batavia', 8189, 'On 21-08-1786 the VREDENBURG departed from Batavia and sailed to China. See the MEEUWTJE (4477) and the DRAAK (4507).');
INSERT INTO "voyages" VALUES (4512, '', 5, '', 'VOORBERG', 'Thobias Post', 1150, NULL, '1770', NULL, NULL, 'A', 'E', '1785-12-25', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The VOORBERG called at Dartmouth, 12-01-1786. On 29-06 the ship returned to Texel. Almost three months later, on 20-09, the VOORBERG put to see for the second time; on 14-10-1786, however, it sailed back to Texel again.');
INSERT INTO "voyages" VALUES (4513, '', 4, '', 'GANGES', 'Jan Frederik Schuts', 1150, NULL, '1775', NULL, NULL, 'A', 'Z', '1685-12-28', 'Rammekens', NULL, NULL, true, NULL, NULL, NULL, 'The GANGES was bound for China. On 02-02-1786 the ship ran aground at Padstow in Cornwall and was wrecked.');
INSERT INTO "voyages" VALUES (4514, '', 5, '', 'HOLLAND', 'Lars Jansen', 1150, NULL, '1771', NULL, NULL, 'A', 'H', '1786-02-24', 'Texel', '1786-05-30', '1786-07-18', true, '1786-09-21', 'Batavia', NULL, 'See the VROUWE KATHARINA JOHANNA (4496).');
INSERT INTO "voyages" VALUES (4515, '', 1, '', 'ZEELAND', 'Bank', 1150, NULL, '1783', NULL, NULL, 'Z', 'Z', '1786-04-30', 'Rammekens', '1786-08-12', '1786-09-16', true, '1786-11-20', 'Ceylon', 8270, NULL);
INSERT INTO "voyages" VALUES (4516, '', 2, '', 'JACHTRUST', 'Jan Anthonie Lubben', 450, 'fregat', NULL, '1775', NULL, 'A', 'A', '1786-05-27', 'Texel', '1786-09-10', '1786-10-10', true, '1787-01-06', 'Batavia', NULL, 'See the NEPTUNUS (4509).');
INSERT INTO "voyages" VALUES (4517, '', 4, '', 'TRITON M', 'J.m Jochem ilfaart', 1150, NULL, '1773', NULL, NULL, 'A', 'Z', '1786-05-29', 'Rammekens', '1786-10-24', '1786-11-19', true, '1787-02-06', 'Batavia', NULL, 'At the departure from the Cape the TRITON was accompanied by a Dutch man-of-war. In 1792 the ship was wrecked in the Indies. The following data refer to the TRITON as well as to the JONGE FRANK (4521), the JUF-FROUW JOHANNA (4540), the BARBESTEIN (4544), and the SURSEANCE (4557): 494 seafarers, 432 soldiers, 30 craftsmen, and 1 passenger departed from Rammekens; 495 seafarers, 248 soldiers. 19 craftsmen, and 5 passengers arrived at Batavia. and 5 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4518, '', 1, '', 'VEERS', 'Jan Malek', 758, 'pink', NULL, '1786', NULL, 'Z', 'Z', '1786-05-29', 'Rammekens', '1786-11-23', '1786-12-24', true, NULL, 'Ceylon', 8265, 'The VEERE called at Santa Cruz on Tenerife; departure: 04-08-1786. The date of arrival at Ceylon is unknown.');
INSERT INTO "voyages" VALUES (4519, '', 2, '', 'ROZENBURG', 'Hendrik de Lange', 880, NULL, '1780', NULL, NULL, 'D', 'D', '1786-06-03', 'Goeree', '1786-09-18', '1786-10-24', true, '1787-01-24', 'Batavia', 8261, 'According to K.A. 4298 Thomas van Tried was master. The following data refer to both the ROZENBURG and the HOUTLUST (4539): 352 seafarers, 160 soldiers, and 30 craftsmen departed from Goeree.');
INSERT INTO "voyages" VALUES (4520, '', 2, '', 'ONZEKERE', 'Klaas Zwart', 348, NULL, NULL, NULL, NULL, NULL, 'Z', '1786-06-01', 'Rammekens', '1786-11-08', '1786-12-10', true, '1787-03-01', 'Batavia', 8198, NULL);
INSERT INTO "voyages" VALUES (4521, '', 2, '', 'JONGE FRANK', 'Jakob Veer', 592, NULL, NULL, NULL, NULL, NULL, 'Z', '1786-06-12', 'Rammekens', '1786-10-23', '1786-12-02', true, '1787-02-14', 'Batavia', 8194, 'See the TRITON (4517). When arriving at the Cape. both the JONGE FRANK and the LOO (4523) were accompanied by three Dutch men-of-war. Two of them, as well as an other warship, escorted the JONGE FRANK when it departed from the Cape.');
INSERT INTO "voyages" VALUES (4522, '', 2, '', 'DOGGERSBANK', 'Abraham Tim', 1150, NULL, '1782', NULL, NULL, 'A', 'A', '1786-07-10', 'Texel', '1786-10-24', '1786-11-16', true, '1787-02-12', 'Batavia', 8205, 'The following data refer to the DOGGERSBANK as well as to the ''T LOO (4523), the VALK (4525), the AREND (4527), the HUISDUINEN (4534), the NEERLANDS WELVAREN (4536), the EENSGEZINDHEID (4537), the ADMIRAAL DE SUFFREN (4543), and the VOORSCHOTEN (4547): 1789 seafarers, 797 soldiers, 113 craftsmen, and 20 passengers departed from Texel; 1445 seafarers, 510 soldiers, 89 craftsmen, and 23 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4523, '', 8, '', '''T LOO', 'Johan Pleen', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1786-07-10', 'Texel', '1786-10-23', '1786-11-16', true, '1787-02-02', 'Batavia', NULL, 'In 1790 the''T LOO sank in the Indies. See the JONGE FRANK (4521).');
INSERT INTO "voyages" VALUES (4524, '', 1, '', 'MARIA', 'Pieter Siskes', 908, 'fluit', NULL, NULL, NULL, NULL, 'A', '1786-07-13', 'Texel', '1781-01-02', '1787-01-29', true, '1787-05-12', 'Batavia', 8207, 'According to K.A. 4298 the departing crew consisted of 383 men. The MARIA called at S. Tiago. 31-08 till 08-09-l`86.');
INSERT INTO "voyages" VALUES (4525, '', 1, '', 'VALK', 'Matthijs Laurens Koster', 600, NULL, NULL, '1785', NULL, 'A', 'A', '1786-07-13', 'Texel', '1786-11-20', '1786-12-10', true, '1787-02-15', 'Batavia', 8259, NULL);
INSERT INTO "voyages" VALUES (4526, '', 2, '', 'DAPPERHEID W', 'Evert ittenberg', 472, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1786-07-14', 'Texel', '1786-11-22', '1786-12-12', true, '1787-03-01', 'Batavia', 8196, NULL);
INSERT INTO "voyages" VALUES (4527, '', 1, '', 'AREND', 'Nikolaas Klopper', 690, NULL, NULL, '1786', NULL, 'A', 'A', '1786-07-17', 'Texel', '1786-12-08', '1746-12-13', true, '1787-05-12', 'Batavia', 8266, NULL);
INSERT INTO "voyages" VALUES (4528, '', 2, '', 'VROUWE WUNANDA LUBERTA', 'Sijbrand Berk', 508, 'fregar', NULL, NULL, NULL, NULL, 'A', '1786-07-17', 'Texel', '1786-11-16', '1786-12-12', true, '1787-02-24', 'Batavia', 8197, NULL);
INSERT INTO "voyages" VALUES (4529, '', 1, '', 'BERKSHOVEN', 'Pieter Hans Matthijssen', 651, 'pink', NULL, NULL, NULL, NULL, 'A', '1786-08-09', 'Texel', '1786-11-23', '1786-12-10', true, '1781-02-21', 'Batavia', 8195, 'According to K.A. 4298 the departing crew consisted of 335 men.');
INSERT INTO "voyages" VALUES (4530, '', 1, '', 'OOSTZAANDAM', 'Pieter Stippel', 650, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1786-08-26', 'Texel', '1787-02-26', '1787-03-28', true, '1787-07-09', 'Batavia', 8204, 'The OOSTZAANDAM called at Portsmouth, 30-09 till 17-10-1786. According to K.A. 4298 Jakob de Vries was master.');
INSERT INTO "voyages" VALUES (4531, '', 2, '', 'BERKHOUT', 'Fedde Hansen', 1150, NULL, '1779', NULL, NULL, 'H', 'H', '1786-09-20', 'Texel', '1787-01-27', '1787-02-27', true, '1787-06-10', 'Batavia', 8308, 'The following data refer to both the BERKHOUT and the HOORN (4549): 444 seafarers, 182 soldiers, 12 craftsmen, and 5 passengers departed from Texel; 356 seafarers, 127 soldiers, 10 craftsmen. and 7 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4532, '', 1, '', 'GOUDA', 'Klaas Voet', 400, NULL, '1784', NULL, NULL, 'A', 'A', '1786-09-20', 'Texel', '1786-12-28', '1787-01-29', true, '1787-05-19', 'Malabar', 8292, NULL);
INSERT INTO "voyages" VALUES (4533, '', 3, '', 'DORDRECHT', 'Pleun van der Giessen', 898, NULL, NULL, NULL, NULL, 'D', 'A', '1786-10-17', 'Texel', '1787-02-03', '1787-03-19', true, '1787-06-07', 'Batavia', 8209, '4533/8209 Is the third voyage of this ship, which during its first voyage (4400/8087) was called BERLIN.');
INSERT INTO "voyages" VALUES (4534, '', 2, '', 'HUISDUINEN', 'Arie Simonsz. Koek', 723, NULL, NULL, '1784', NULL, 'A', 'A', '1786-10-17', 'Texel', '1787-02-24', '1787-03-25', true, '1787-06-16', 'Batavia', 8280, NULL);
INSERT INTO "voyages" VALUES (4535, '', 4, '', 'MERENBERG', 'Willem de Wijn+', 850, NULL, '1773', NULL, NULL, 'H', 'E', '1786-10-17', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'On 02-11-1786 the MERENBERG ran aground off Crookhaven in Ireland. Its cargo was taken over by the outward-bound MERENBERG (4556), previously called EIKENWOUD, which departed from Texel in March, 1787. The stranded MERENBERG was broken up in 1787.');
INSERT INTO "voyages" VALUES (4536, '', 1, '', 'NEDERLANDS WELVAREN', 'Arie Kikkert', 1150, NULL, '1785', NULL, NULL, 'A', 'A', '1786-10-17', 'Texel', '1787-02-03', '1787-02-27', true, '1787-05-12', 'Batavia', 8212, 'According to K.A. 4298 the departing crew consisted of 345 men. After having arrived at Batavia the NEDERLANDS WELVAREN sailed on to China.');
INSERT INTO "voyages" VALUES (4537, '', 2, '', 'EENSGEZINDHEID', 'Peter Jansen', 884, 'fluit', NULL, NULL, NULL, NULL, 'A', '1786-10-19', 'Texel', '1787-02-24', '1787-03-16', true, '1787-06-16', 'Batavia', 8202, 'according to K.A. 4298 the departing crew consisted of 331 men.');
INSERT INTO "voyages" VALUES (4538, '', 2, '', 'JONGE JAKOB', 'Asmus Pieter Asmus', 648, 'hooker', NULL, NULL, NULL, NULL, 'A', '1796-10-19', 'Texel', '1787-01-29', '1787-02-13', true, NULL, 'Batavia', 8199, 'Date of arrival at Batavia unknown.');
INSERT INTO "voyages" VALUES (4539, '', 1, '', 'HOUTLUST', 'Pieter Hol', 880, NULL, '1785', NULL, NULL, 'D', 'D', '1786-10-24', 'Goeree', '1787-02-06', '1787-02-27', true, '1787-05-12', 'Batavia', 8260, 'See the ROZENBURG (4519).');
INSERT INTO "voyages" VALUES (4540, '', 2, '', 'JUFFROUW JOHANNA', 'Simon Koter', 678, NULL, NULL, NULL, NULL, NULL, 'Z', '1786-10-24', 'Rammekens', '1787-02-22', '1787-03-19', true, '1787-06-09', 'Batavia', 8200, 'According to K.A. 4198 the departing crew consisted of 196 men. See the TRITON (4517). This is the second voyage of this ship, which during its preceding voyage (4404/8086) was called FRIEDRICH DER GROSSE.');
INSERT INTO "voyages" VALUES (4541, '', 2, '', 'VREDE', 'Thijs Ketel', 854, 'fluit', NULL, NULL, NULL, NULL, 'Z', '1786-10-24', 'Rammekens', '1787-09-09', NULL, true, '1787-09-09', 'The Cape', 8214, 'The VREDE called at Tenerife, 04-04 till 06-05-1787.');
INSERT INTO "voyages" VALUES (4542, '', 1, '', 'CANTON', 'Kornelis de Wit', 1150, NULL, '1785', NULL, NULL, 'R', 'R', '1786-10-25', 'Goeree', '1787-02-06', '1787-02-27', true, '1787-05-12', 'Batavia', 8211, 'sailed on to China.');
INSERT INTO "voyages" VALUES (4543, '', 1, '', 'ADMIRAAL DE SUFFREN', 'Gottlieb Mulder', 1300, NULL, '1785', NULL, NULL, 'A', 'A', '1786-11-17', 'Texel', '1787-04-04', '1787-04-23', true, '1787-07-05', 'Batavia', 8218, 'The ADMIRAAL DE SUFFREN called at Spithead. 23-11 till 20-12-1786. After having arrived at Batavia the ship sailed on to China.');
INSERT INTO "voyages" VALUES (4544, '', 2, '', 'BARBESTEIN', 'Kornelis van Vlaanderen', 1150, NULL, '1783', NULL, NULL, 'A', 'Z', '1786-11-25', 'Rammekens', '1787-04-21', '1787-05-19', true, '1787-08-08', 'Batavia', 8217, 'According to K.A. 4304 the departing crew consisted of 262 men. The BARBESTEIN called at Duins, 28-11-1786 till 07-01-1787 where a mutiny was discovered. The BARBESTEIN went on to China. See the TRITON (4517).');
INSERT INTO "voyages" VALUES (4545, '', 2, '', 'MENTOR', 'Jochem Hendrik Milfaart', 560, NULL, NULL, NULL, NULL, NULL, 'Z', '1786-12-19', 'Rammekens', '1787-03-20', '1787-04-19', true, '1787-06-20', 'Batavia', 8203, NULL);
INSERT INTO "voyages" VALUES (4546, '', 2, '', 'POLLUX', 'Johan van Stralen', 490, NULL, NULL, '1784', NULL, 'Z', 'A', '1786-12-25', 'Texel', '1787-04-29', '1787-05-19', true, '1787-07-11', 'Ceylon', 8281, NULL);
INSERT INTO "voyages" VALUES (4547, '', 2, '', 'VOORSCHOTEN', 'Willem van Groningen', 1150, NULL, '1783', NULL, NULL, 'A', 'A', '1786-12-25', 'Texel', '1787-04-27', '1787-05-01', true, '1787-07-27', 'Batavia', 8219, 'According to K.A. 4304 the departing crew consisted of 319 men. The VOORSCHOTEN called at Duins, 05 till 07-01-1787. After having arrived at Batavia the ship sailed on to China.');
INSERT INTO "voyages" VALUES (4548, '', 1, '', 'LEVIATHAN', 'Harme Karel Visser', 1150, NULL, '1785', NULL, NULL, 'A', 'A', '1787-01-09', 'Texel', '1787-04-26', '1787-05-19', true, '1787-07-11', 'Ceylon', 8039, NULL);
INSERT INTO "voyages" VALUES (4549, '', 2, '', 'HOORN', 'Hendrik Holder', 850, NULL, '1774', NULL, NULL, 'H', 'H', '1787-01-10', 'Texel', '1787-04-20', '1787-05-19', true, '1787-07-20', 'Batavia', NULL, 'According to K.A. 4198 the departing crew consisted of 273 men. See the BERKHOUT (4531).');
INSERT INTO "voyages" VALUES (4550, '', 1, '', 'VLISSINGEN', 'Willem Fredenks', 380, NULL, NULL, NULL, NULL, NULL, 'Z', '1787-01-11', 'Rammekens', '1787-04-28', '1787-05-21', true, '1787-08-08', 'Batavia', 8206, NULL);
INSERT INTO "voyages" VALUES (4551, '', 1, '', 'BROEDERSLUST', 'Simon Vaartjes', 686, 'hoeker', NULL, NULL, NULL, NULL, 'E', '1781-01-12', 'Texel', '1787-05-19', '1787-07-01', true, '1787-09-06', 'Batavia', 8208, 'departed from Texel; 187 seafarers and 60 soldiers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4552, '', 1, '', 'GOEDE INTENTIE', 'Thobias Post', 500, 'hoeker', NULL, NULL, NULL, NULL, 'E', '1787-01-12', 'Texel', '1787-05-21', '1787-07-01', true, '1787-09-07', 'Batavia', 8210, 'According to K.A. 4304 Pieter Kornelissen was master of the GOEDE INTENTIE. See the BROEDERSLUST (4551).');
INSERT INTO "voyages" VALUES (4553, '', 1, '', 'SINT LAURENS', 'Lodewijk Kappelhof', 1150, NULL, '1784', NULL, NULL, 'Z', 'Z', '1787-01-24', 'Rammekens', '1787-07-31', '1787-09-24', true, '1787-12-18', 'Batavia', 8298, 'following data refer to both the ST. LAURENS and the OUD HAARLEM (4571): 413 seafarers, 263 soldiers, 9 craftsmen, and 6 passengers departed from Rammekens; 270 seafarers, 110 soldiers, 9 craftsmen, and 5 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4554, '', 2, '', 'VLUGGE TREKVOGEL', 'Barend Jansz. Uffen', 484, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1787-02-23', 'Texel', '1787-07-13', '1787-08-26', true, '1787-11-28', 'Ceylon', 8229, NULL);
INSERT INTO "voyages" VALUES (4555, '', 3, '', 'HINDELOOPEN', 'Isaak de Vries', 850, NULL, '1776', NULL, NULL, 'H', 'A', '1787-03-05', 'Texel', '1787-07-03', '1787-07-29', true, '1787-11-13', 'Bengal', NULL, 'At the departure from the Cape the HINDELOOPEN was accompanied by two Dutch men-of-war.');
INSERT INTO "voyages" VALUES (4556, '', 2, '', 'MERENBERG', 'Klaas Ent', 892, 'fluit', NULL, NULL, NULL, NULL, 'E', '1787-03-09', 'Texel', '1787-10-15', '1787-11-24', true, '1788-02-14', 'Batavia', 8223, 'voyage of this ship, which during its preceding voyage (4452/8159) was called EIKENWOUD. The following data refer to both the MERENBERG and the BEL-VLIET (4563): 269 seafarers, 135 soldiers, 16 craftsmen, and 3 passengers departed from Texel; 226 seafarers, 94 soldiers, 8 craftsmen, and 1 passenger arrived at Batavia.');
INSERT INTO "voyages" VALUES (4557, '', 1, '', 'SURSEANCE', 'Andries Maankop', 768, NULL, NULL, '1786', NULL, 'Z', 'Z', '1787-04-01', 'Rammekens', '1787-07-19', '1787-08-14', true, '1787-10-25', 'Batavia', 8313, 'See the TRITON (4517).');
INSERT INTO "voyages" VALUES (4558, '', 1, '', 'GOEDE VERWACHTING', 'Tijmen de Zweed', 560, NULL, NULL, NULL, NULL, NULL, 'A', '1787-05-07', 'Texel', '1787-09-05', '1187-11-27', true, '1788-02-08', 'Batavia', 8222, NULL);
INSERT INTO "voyages" VALUES (4559, '', 1, '', 'SLOT CAPELLE', 'Willem Jakob Andriessen', 880, NULL, '1786', NULL, NULL, 'R', 'R', '1787-05-16', 'Goeree', '1787-08-23', '1787-09-21', true, '1787-01-21', 'Batavia', 8284, NULL);
INSERT INTO "voyages" VALUES (4560, '', 2, '', 'CONSTANTIA', 'Jan Hendrik van der Linden', 880, NULL, '1782', NULL, NULL, 'D', 'D', '1787-05-06', 'Goeree', '1787-08-29', '1787-10-12', true, '1787-12-18', 'Batavia', 8293, NULL);
INSERT INTO "voyages" VALUES (4561, '', 1, '', 'VROUWE SARA HENDRINA', 'Hillebrand van Uijen', 656, 'fluit', NULL, NULL, NULL, NULL, 'A', '1787-05-20', 'Texel', '1787-10-02', '1787-10-27', true, '1788-02-04', 'Batavia', 8220, NULL);
INSERT INTO "voyages" VALUES (4562, '', 1, '', 'ZEEVAART', '(HOLLAND) Simon Jakob Forster', 846, NULL, NULL, NULL, NULL, NULL, 'A', '1787-06-02', 'Texel', '1787-09-10', '1787-11-24', true, '1788-02-13', 'Batavia', 8228, NULL);
INSERT INTO "voyages" VALUES (4563, '', 1, '', 'BELVLIET', 'Jan Montagne', 880, NULL, '1783', NULL, NULL, 'H', 'E', '1787-06-10', 'Texel', '1787-10-07', '1787-11-16', true, '1788-02-08', 'Batavia', NULL, 'According to K.A. 4304 the departing crew consisted of 229 men. In 1789 the BELVLIET was wrecked in the Indies. See the MERENBERG (4556).');
INSERT INTO "voyages" VALUES (4564, '', 1, '', 'PHOENICIER', 'Laurens Kornelissen', 1150, NULL, '1786', NULL, NULL, 'A', 'A', '1787-06-29', 'Texel', '1787-11-27', '1788-01-09', true, '1788-04-30', 'Batavia', 8314, 'STAVENISSE (4565), the EIK EN LINDE (4573), the SCHELDE (4578), the GOUVERNEUR-GENERAAL MAATSUIJKER (4589), the WIRTZLUST (4590), and the BEVERWIJK (4594): 1434 seafarers, 541 soldiers, 94 craftsmen, and 35 passengers departed from Texel; 1112 seafarers, 332 soldiers, 70 craftsmen, and 29 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4565, '', 3, '', 'STAVENISSE', 'Karel Mulder', 1150, NULL, '1772', NULL, NULL, 'Z', 'A', '1787-06-29', 'Texel', '1787-11-24', '1788-01-09', true, '1788-05-07', 'Batavia', NULL, '4304 the departing crew consisted of 299 men. In 1792 the STAVENISSE was sold and broken up at Batavia. See the PHOENICIER (4564).');
INSERT INTO "voyages" VALUES (4566, '', 1, '', 'FORTUIN (VAN', 'DORDRECHT) Jan Daale', NULL, 'fluit', NULL, NULL, NULL, NULL, 'Z', '1787-07-01', 'Rammekens', '1787-12-20', '1788-02-10', true, NULL, 'Ceylon', 8224, 'The FORTUIN VAN DORDRECHT called at S. Tiago, 22 till 26-08-1787. The date of arrival at Ceylon is unknown.');
INSERT INTO "voyages" VALUES (4567, '', 1, '', 'DRIE GEBROEDERS', 'Roelofsz. de Groot', 828, 'fluit', NULL, NULL, NULL, NULL, 'Z', '1787-07-01', 'Rammekens', '1787-12-03', '1788-02-09', true, NULL, 'Ceylon', 8225, 'Date of arrival at Ceylon unknown.');
INSERT INTO "voyages" VALUES (4568, '', 2, '', 'JOSEPHUS DE TWEEDE', 'Johan de Wolf', 460, NULL, NULL, NULL, NULL, NULL, 'Z', '1787-07-01', 'Rammekens', '1787-10-25', '1788-02-10', true, NULL, 'Ceylon', 8233, NULL);
INSERT INTO "voyages" VALUES (4569, '', 1, '', 'DRIETAL HANDELAARS', 'Kornelis de Vries', 502, NULL, NULL, NULL, NULL, NULL, 'A', '1787-07-14', 'Texel', '1787-09-07', '1787-12-16', true, '1788-03-13', 'Batavia', 8246, NULL);
INSERT INTO "voyages" VALUES (4570, '', 1, '', 'VERWACHTING', 'Dirk Sem', 600, 'hoeker', NULL, '1787', NULL, 'H', 'H', '1787-07-14', 'Texel', '1787-12-08', '1788-01-09', true, '1788-04-09', 'Batavia', 8282, 'The following data refer to both the VERWACHTING and the DRECHTERLAND (4588): 337 seafarers, 119 soldiers, 7 craftsmen, and 2 passengers departed from Texel; 275 seafarers, 62 soldiers, 5 craftsmen, and 3 passengers arrived at Batavia.');
INSERT INTO "voyages" VALUES (4571, '', 7, '', 'OUD HAARLEM', 'Kornelis Haringman', 1150, NULL, '1768', NULL, NULL, 'A', 'Z', '1787-08-05', 'Rammekens', '1787-12-02', '1788-01-09', true, '1788-03-13', 'Batavia', NULL, 'See the ST. LAURENS (4553).');
INSERT INTO "voyages" VALUES (4572, '', 3, '', 'JUFFROUW JOHANNA', 'Michiel Poest', 678, NULL, NULL, NULL, NULL, NULL, 'Z', '1787-08-05', 'Rammekens', '1787-12-04', '1788-02-10', true, NULL, NULL, 8226, 'Destination (probably Ceylon) and date of arrival in the Indies unknown.');
INSERT INTO "voyages" VALUES (4573, '', 2, '', 'EIK EN LINDE', 'Jan Bringman', 574, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1787-08-08', 'Texel', '1788-01-13', '1788-02-17', true, '1788-05-12', 'Batavia', 8271, 'According to K.A. 4304 the departing crew consisted of 222 men. The EIK EN LINDE called at S. Tiago, 30-09 till 04-10-1787. See the PHOENICIER (4564).');
INSERT INTO "voyages" VALUES (4574, '', 2, '', 'GEERTRUIDA', 'Daniel Kunneman', 660, NULL, NULL, NULL, NULL, NULL, 'A', '1787-08-08', 'Texel', '1788-01-13', '1788-02-17', true, '1788-06-28', 'Batavia', 8234, NULL);
INSERT INTO "voyages" VALUES (4575, '', 1, '', 'LEIDEN', 'Johan Hendrik Gevels', 1150, NULL, '1786', NULL, NULL, 'A', 'A', '1787-08-09', 'Texel', '1787-12-07', '1788-01-09', true, '1788-03-13', 'Batavia', 8241, 'crew consisted of 352 men. On 19-06-1788 the LEIDEN departed from Batavia to sail to China.');
INSERT INTO "voyages" VALUES (4576, '', 1, '', 'DORDWIJK', 'Kornelis van Deventer', 800, 'hoeker', NULL, '1787', NULL, 'R', 'R', '1787-09-01', 'Goeree', '1788-01-04', '1788-02-22', true, '1788-05-13', 'Batavia', 8279, NULL);
INSERT INTO "voyages" VALUES (4577, '', 2, '', 'HOOP', 'Laurens Smit', 175, NULL, NULL, '1782', NULL, 'A', 'A', '1787-09-01', 'Texel', '1788-02-20', '1788-03-21', true, '1788-06-17', 'Ceylon', NULL, NULL);
INSERT INTO "voyages" VALUES (4578, '', 2, '', 'SCHELDE', 'Matthijs Bosman', 1150, NULL, '1780', NULL, NULL, 'Z', 'A', '1787-09-11', 'Texel', '1788-01-06', '1788-02-22', true, '1788-06-02', 'Batavia', 8295, 'See the PHOENICIER (4564).');
INSERT INTO "voyages" VALUES (4579, '', 1, '', 'SUSANNA', 'Klaas Zwart', NULL, NULL, NULL, NULL, NULL, NULL, 'Z', '1787-09-29', 'Rammekens', '1788-01-20', '1788-02-27', true, NULL, 'Ceylon', 8227, 'The SUSANNA called at S. Tiago, 12 till 16-11-1787.');
INSERT INTO "voyages" VALUES (4580, '', 1, '', 'GOEDE HOOP', 'Laurens Jansen', 400, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1787-10-28', 'Texel', '1788-04-27', '1788-05-14', true, '1788-08-14', 'Batavia', 8239, NULL);
INSERT INTO "voyages" VALUES (4581, '', 2, '', 'VROUWE JOHANNA JAKOBA', 'Simon Krijgsman', 444, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1787-10-28', 'Texel', '1788-05-04', '1788-06-23', true, '1788-10-14', 'Batavia', 8251, 'The VROUWE JOHANNA JAKOBA called at Portsmouth, 15-11 till 21-12-1787.');
INSERT INTO "voyages" VALUES (4582, '', 2, '', 'RIJNOORD', 'Kornelis Reindertsz. Tromp', 846, 'fluit', NULL, NULL, NULL, NULL, NULL, '1787-10-29', 'Texel', '1788-07-07', '1788-10-01', true, NULL, 'Batavia', 8256, 'From 17-12-1787 till 30-01-1788 the RIJNOORD called at an English port.');
INSERT INTO "voyages" VALUES (4583, '', 2, '', 'JAN EN KORNELIS', 'Klaas Duif', 560, 'fluit', NULL, NULL, NULL, NULL, 'A', '1787-11-14', 'Texel', '1788-05-13', '1788-06-11', true, '1788-10-08', 'Batavia', 8250, NULL);
INSERT INTO "voyages" VALUES (4584, '', 1, '', 'GEERTRUIDA PETRONELLA', 'Jan Gerrit Scholten', 1090, 'hoeker', NULL, NULL, NULL, NULL, 'Z', '1787-11-15', 'Rammekens', '1788-03-29', '1788-05-14', true, '1788-07-19', 'Batavia', 8249, NULL);
INSERT INTO "voyages" VALUES (4585, '', 2, '', 'VROUWE JAKOBA MARIA LUCIA THERESIA', 'Dirk Peek', 429, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1787-11-20', 'Texel', '1788-03-06', '1788-04-20', true, '1788-06-22', 'Batavia', 8232, NULL);
INSERT INTO "voyages" VALUES (4586, '', 1, '', 'RECHT DOOR ZEE', 'Dirk Dirksz. Varkevisser', 880, NULL, '1,86', NULL, NULL, 'D', 'D', '1787-11-27', 'Goeree', '1788-04-04', '1788-04-30', true, '1788-08-20', 'Batavia', 8294, NULL);
INSERT INTO "voyages" VALUES (4587, '', 2, '', 'AFRIKAAN', 'Frederik Drillinger', 880, NULL, '1780', NULL, NULL, 'E', 'E', '1787-12-19', 'Texel', '1788-03-30', '1788-04-30', true, '1788-07-17', 'Batavia', 8303, NULL);
INSERT INTO "voyages" VALUES (4588, '', 1, '', 'DRECHTERLAND', 'Pieter Johan Muller', 1150, NULL, '1784', NULL, NULL, 'H', 'H', '1787-12-19', 'Texel', '1788-04-02', '1788-04-30', true, '1788-08-13', 'Batavia', 8395, 'According to K.A. 4304 the departing crew consisted of 329 men. See the VERWACHTING (4570).');
INSERT INTO "voyages" VALUES (4589, '', 1, '', 'GOUVERNEUR-GENERAAL MAATSUIJKER', 'Gerrit Esman', 1150, NULL, '1786', NULL, NULL, 'A', 'A', '1787-12-19', 'Texel', '1788-03-30', '1788-04-30', true, '1788-07-04', 'Batavia', 8244, 'China. See the PHOENICIER (4564).');
INSERT INTO "voyages" VALUES (4590, '', 1, '', 'WIRTZLUST', 'Karel Volkman', 590, NULL, NULL, NULL, NULL, NULL, 'A', '1787-12-19', 'Texel', '1788-03-30', '1788-04-30', true, '1788-07-16', 'Batavia', 8237, 'See the PHOENICIER (4564).');
INSERT INTO "voyages" VALUES (4591, '', 1, '', 'VROUWE AGATHA', 'Albert Kornelisz.', 900, 'fluit', NULL, NULL, NULL, NULL, 'Z', '1787-12-22', 'Rammekens', '1788-04-29', NULL, true, '11788-04-29', 'The Cape', 8221, '(4593).');
INSERT INTO "voyages" VALUES (4592, '', 1, '', 'BLITTERSWIJK', 'Lodewijk Elgenhuizen', 1150, NULL, '1785', NULL, NULL, 'Z', 'Z', '1787-12-22', 'Rammekens', '1788-04-06', '8-05-17', true, '1788-07-18', 'Batavia', 8245, 'Batavia.');
INSERT INTO "voyages" VALUES (4593, '', 1, '', 'GATENISSE', 'Hans Klaassen', 660, NULL, NULL, NULL, NULL, NULL, 'Z', '1787-12-22', 'Rammekens', '1788-03-28', '1788-05-05', true, '1788-07-17', 'Batavia', 8248, 'When sailing from Rammekens the GATENISSE, the VROUWE AGATHA (4591), and the BLITTERSWIJK (4592) were accompanied by a Dutch man-of-war.');
INSERT INTO "voyages" VALUES (4594, '', 2, '', 'BEVERWIJK', 'Axel Land', 1150, NULL, '1784', NULL, NULL, 'A', 'A', '1788-01-31', 'Texel', '1788-05-26', '1788-06-23', true, '1788-08-31', 'Batavia', 8307, 'The BEVERWIJK called at Duins, 03 till 08-02-1788. See the PHOENICIER (4564).');
INSERT INTO "voyages" VALUES (4595, '', 1, '', 'GOUVERNEUR FALCK', 'Paulus Kroon', 1150, NULL, '1786', NULL, NULL, 'A', 'A', '1788-01-31', 'Texel', '1788-05-23', '1788-06-23', true, '1788-09-01', 'Ceylon', 8243, 'The GOUVERNEUR FALCK called at Duins, 03 till 08-02-1788.');
INSERT INTO "voyages" VALUES (4596, '', 1, '', 'HANDELLUST', 'Eldert Evertsz.', 458, NULL, NULL, NULL, NULL, NULL, 'A', '1788-01-31', 'Texel', '1788-05-26', '1788-07-04', true, '1788-09-14', 'Batavia', 8238, NULL);
INSERT INTO "voyages" VALUES (4597, '', 3, '', 'STRALEN', 'Gerard Masson', 880, NULL, '1778', NULL, NULL, 'E', 'A', '1788-01-31', 'Texel', '1788-07-06', '1788-07-22', true, NULL, 'Bengal', 8334, 'From 23 till 29-03-1788 the STRALEN was at S. Tiago.');
INSERT INTO "voyages" VALUES (4598, '', 2, '', 'ZOUTMAN', 'Nikolaas Akker', 150, NULL, '1784', NULL, NULL, 'A', 'A', '1788-01-31', 'Texel', '1788-07-03', '1788-09-03', true, '1788-11-13', 'Batavia', NULL, 'The ZOUTMAN called at Duins, 02 till 08-02-1788. In 1793 or 1794 the ship was sold at Batavia.');
INSERT INTO "voyages" VALUES (4599, '', 1, '', 'GOEDE TROUW', 'Jan Arendsz.', 1150, NULL, '1786', NULL, NULL, 'Z', 'Z', '1788-02-08', 'Rammekens', NULL, NULL, false, '1788-07-18', 'Batavia', 8242, 'On 20-08-1788 the ship departed from Batavia to sail to China. See the BLITTERSWIJK (4592).');
INSERT INTO "voyages" VALUES (4600, '', 3, '', 'GOUVERNEUR-GENERAAL DE CLERCK', 'Wouter Jakobsen.', 1150, NULL, '1779', NULL, NULL, 'Z', 'Z', '1788-05-01', 'Rammekens', '1788-08-18', '1788-09-13', true, '1788-12-05', 'Ceylon', 8296, NULL);
INSERT INTO "voyages" VALUES (4601, '', 3, '', 'SLOT TER HOGE', 'Johan Moster', 1150, NULL, '1776', NULL, NULL, 'Z', 'Z', '1788-05-01', 'Rammekens', '1788-08-11', '1788-09-13', true, '1788-12-05', 'Batavia', 8287, 'According to K.A. 4310 the departing crew consisted of 536 men.');
INSERT INTO "voyages" VALUES (4602, '', 2, '', 'TEXELSTROOM', 'Barend Sterk', 708, NULL, NULL, '1785', NULL, 'A', 'R', '1788-05-08', 'Goeree', '1788-08-19', '1788-09-13', true, '1788-12-03', 'Batavia', 8328, 'STANDVASTIGHEID (8328).');
INSERT INTO "voyages" VALUES (4603, '', 3, '', 'DAPPERHEID', 'Evert Wittenberg', 472, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1788-05-12', 'Texel', '1788-09-05', '1788-09-22', true, '1788-12-01', 'Batavia', 8254, NULL);
INSERT INTO "voyages" VALUES (4604, '', 2, '', 'DUIFJE', 'Laurens Steenboom', 400, NULL, '1784', NULL, NULL, 'A', 'A', '1788-05-14', 'Texel', '1788-09-15', NULL, true, '1788-09-15', 'The Cape', 8312, 'The DUIFJE was bound for the Cape.');
INSERT INTO "voyages" VALUES (4605, '', NULL, '', NULL, 'Not used', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1788-05-14', NULL, NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (4606, '', 2, '', 'VREDENBURG', 'Jakob Zock', 1150, NULL, '1784', NULL, NULL, 'A', 'A', '1788-05-14', 'Texel', '1789-02-11', '1789-03-11', true, '1789-05-29', 'Batavia', 8329, 'The VREDENBURG got off its course and arrived at Rio de Janeiro, where it remained from 19-10 till 17-12-1788.');
INSERT INTO "voyages" VALUES (4607, '', 5, '', 'ZEEPAARD', 'Dirk Muller', 1150, NULL, '1774', NULL, NULL, 'A', 'Z', '1788-05-14', 'Texel', '1789-01-04', '1789-02-03', true, '1789-05-07', 'Batavia', NULL, 'In 1792 the ZEEPAARD was sold and broken up at Batavia.');
INSERT INTO "voyages" VALUES (4608, '', 2, '', 'BERKSHOVEN', 'Herman Ruurdsz.', 651, 'pink', NULL, NULL, NULL, NULL, 'Z', '1788-05-27', 'Rammekens', '1788-10-10', NULL, true, NULL, 'Batavia', 8255, NULL);
INSERT INTO "voyages" VALUES (4609, '', 2, '', 'HORSSEN', 'George Philip Gas', 880, NULL, '1784', NULL, NULL, 'D', 'D', '1788-05-28', 'Goeree', '1788-10-12', '1788-10-17', true, '1789-01-01', 'Batavia', 8327, NULL);
INSERT INTO "voyages" VALUES (4610, '', 1, '', 'JONGE JAKOB EN ALBERTUS', 'Hendrik Joosten', 516, 'fregat', NULL, NULL, NULL, NULL, 'A', '1788-06-02', 'Texel', '1788-08-24', '1788-09-15', true, '1788-11-18', 'Batavia', 8253, NULL);
INSERT INTO "voyages" VALUES (4611, '', 2, '', 'VROUWE KATHARINA JOHANNA', 'Jakob Meyer', 900, NULL, NULL, '1785', NULL, 'H', 'H', '1788-06-09', 'Texel', '1788-12-11', '1789-01-10', true, '1789-07-19', 'Batavia', 8341, NULL);
INSERT INTO "voyages" VALUES (4612, '', 2, '', 'TWEE GEZUSTERS', 'Jochem Westvaal', 582, NULL, NULL, '1781', NULL, 'B', 'Z', '1788-06-19', 'Rammekens', '1788-11-13', '1788-12-22', true, '1789-03-30', 'Batavia', NULL, 'According to K.A. 4390a the departing crew consisted of 169 men. The TWEE GEZUSTERS called at S Tiago. 31-07 till 08-08-1788. 4612/- Is the third voyage of this ship. which during its irst voyage (4409/8098) was called LES DEUX SOEURS.');
INSERT INTO "voyages" VALUES (4613, '', 1, '', 'NOORD-HOLLAND', 'Adriaan Kneppel', 894, NULL, NULL, NULL, NULL, NULL, 'A', '1788-08-07', 'Texel', '1788-12-19', '1789-01-14', true, '1789-04-07', 'Batavia', 8290, 'From 21 till 24-09-1788 the NOORD-HOLLAND was at S. Tiago.');
INSERT INTO "voyages" VALUES (4614, '', 6, '', 'VOORBERG', 'Kornelis Dirksz.', 1150, NULL, '1770', NULL, NULL, 'A', 'E', '1788-08-07', 'Texel', '1788-11-14', '1788-12-01', true, '1789-02-10', 'Batavia', NULL, 'In 1792 the VOORBERG was sold and broken up at Batavia.');
INSERT INTO "voyages" VALUES (4615, '', 1, '', 'MARIA LOUISA', 'Anthonie Franciscus Steffers', 136, 'paketboot', '1788', NULL, NULL, 'A', NULL, '1788-09-01', 'Texel', '1788-11-27', '1788-12-11', true, '1789-02-11', 'Batavia', 8247, NULL);
INSERT INTO "voyages" VALUES (4616, '', 1, '', 'DEMERARY', 'Jan Paardekoper', 1150, NULL, '1787', NULL, NULL, 'A', 'A', '1788-09-12', 'Texel', '1789-02-19', '1789-04-08', true, '1789-07-07', 'Batavia', 8363, NULL);
INSERT INTO "voyages" VALUES (4617, '', 2, '', 'DIAMANT', 'Willem Jakob Kuddee', 1150, NULL, '1779', NULL, NULL, 'A', 'Z', '1788-09-15', 'Rammekens', '1789-02-19', '1789-03-24', true, '1789-06-19', 'Batavia', NULL, 'According to K.A. 4390a the departing crew consisted of 299 men. The DIAMANT called at Duins, 18-09 till 09-10-1788.');
INSERT INTO "voyages" VALUES (4618, '', 1, '', 'TEILINGEN', 'Karel Frederik Schaak', 1150, NULL, '1786', NULL, NULL, 'R', 'R', '1788-09-16', 'Goeree', '1789-02-10', '1789-03-01', true, '1789-05-12', 'Batavia', 8301, NULL);
INSERT INTO "voyages" VALUES (4619, '', 3, '', 'JONGE JAKOB', 'Asmus Pieter Asmus', 648, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1788-09-21', 'Texel', '1789-12-22', '1789-03-16', true, '1789-06-02', 'Batavia', 8291, NULL);
INSERT INTO "voyages" VALUES (4620, '', 1, '', 'MEERWIJK', 'Bernard Christiaan Muller', 1150, NULL, '1787', NULL, NULL, 'A', 'A', '1788-10-08', 'Texel', '1789-02-11', '1789-03-01', true, '1789-05-25', 'Batavia', 8275, 'On 04-07-1789 the MEERWIJK departed from Batavia and sailed to China, where it arrived on 03-08-1789.');
INSERT INTO "voyages" VALUES (4621, '', 3, '', 'JONGE FRANK', 'Jakob Veer', 592, NULL, NULL, '1788', NULL, 'Z', 'Z', '1788-11-08', 'Rammekens', '1789-03-24', '1789-10-04', true, '1789-12-24', 'Batavia', 5910, 'One child was born during the voyage.');
INSERT INTO "voyages" VALUES (4622, '', 1, '', 'DELFT', 'Jakob Swetman', 880, NULL, '1786', NULL, NULL, 'D', 'D', '1788-11-24', 'Goeree', '1789-03-25', '1789-04-14', true, '1789-06-26', 'Batavia', 8274, 'After having arrived at Batavia the DELFT sailed on to China, where it cast anchor on 04-09-1789.');
INSERT INTO "voyages" VALUES (4623, '', 1, '', 'CHRISTOFFEL COLUMBUS', 'Jurriaan Pietersen', 1150, NULL, '1787', NULL, NULL, 'A', 'A', '1788-11-25', 'Texel', '1789-04-06', '1789-04-24', true, '1789-07-25', 'Batavia', 8273, 'After having arrived at Batavia the CHRISTOFFEL COLUMBUS sailed on to China, arrival: 16-10-1789.');
INSERT INTO "voyages" VALUES (4624, '', 3, '', 'SCHOONDERLOO', 'Augustinus Heyenberg', 880, NULL, '1779', NULL, NULL, 'D', 'H', '1788-11-25', 'Texel', '1789-03-24', '1789-04-14', true, '1789-06-19', 'Batavia', 8315, NULL);
INSERT INTO "voyages" VALUES (4625, '', 2, '', 'NEDERLANDS WELVAREN', 'Jakob Smit', 1150, NULL, '1785', NULL, NULL, 'A', 'A', '1788-11-25', 'Texel', '1789-03-24', '1789-04-24', true, '1789-07-07', 'Batavia', NULL, 'According to K.A. 4390a the departing crew consisted of 355 men.');
INSERT INTO "voyages" VALUES (4626, '', 3, '', 'EENSGEZINDHEID', 'Simon Koter', 884, 'fluit', NULL, NULL, NULL, NULL, 'A', '1788-11-30', 'Texel', '1789-06-30', '1789-08-25', true, '1789-10-31', 'Batavia', 8304, NULL);
INSERT INTO "voyages" VALUES (4627, '', 1, '', 'FAAM', 'Luur Runken', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1788-12-22', 'Texel', '1789-03-19', '1789-03-30', true, '1789-06-02', 'Batavia', 8257, NULL);
INSERT INTO "voyages" VALUES (4628, '', 1, '', 'ZUIDERBURG', 'Gouke Dekker van der Mieden', 1150, NULL, '1786', NULL, NULL, 'Z', 'Z', '1788-12-28', 'Rammekens', '1789-06-05', '1789-06-25', true, '1789-09-01', 'Batavia', 8378, 'Rammekens the ZUIDERBURG lost its rudder, for that reason the ship had to call at Plymouth, 12-01 till 02-03-1789.');
INSERT INTO "voyages" VALUES (4629, '', 3, '', 'DOGGERSBANK', 'Christiaan de Cerf', 1150, NULL, '1782', NULL, NULL, 'A', 'A', '1789-02-12', 'Texel', '1789-05-27', '1789-06-10', true, '1790-01-02', 'Batavia', NULL, 'continued its voyage to Malacca (arrival: 17-10-1789). In 1795 the ship was sold at Batavia.');
INSERT INTO "voyages" VALUES (4630, '', 2, '', 'BROEDERSLUST', 'Gottlieb Jager', 686, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1789-02-27', 'Texel', '1789-05-23', '1789-06-07', true, '1789-08-07', 'Batavia', 8306, 'According to K.A. 4317 the BROEDERSLUST did not sail for the Chamber Amsterdam, but for Enkhuizen.');
INSERT INTO "voyages" VALUES (4631, '', 1, '', 'VROUWE MARIA KORNELIA', 'Pieter Modderman', 1150, NULL, '1785', NULL, NULL, 'E', 'E', '1789-02-28', 'Texel', '1789-05-22', '1789-06-07', true, '1789-08-11', 'Batavia', 8277, 'At the departure from Texel both the VROUWE MARIA KORNELIA and the TRINCONOMALE (4632) were escorted by two Dutch men-of-war. After having arrived at Batavia the VROUWE MARIA KORNELIA sailed on to China, where it cast anchor on 26-10-1789.');
INSERT INTO "voyages" VALUES (4632, '', 1, '', 'TRINCONOMALE', 'Herman Driesman', 1150, NULL, '1787', NULL, NULL, 'A', 'A', '1789-02-28', 'Texel', '1789-05-24', '1789-06-15', true, '1789-09-09', 'Ceylon', 8283, 'See the VROUWE MARIA KORNELIA (4631).');
INSERT INTO "voyages" VALUES (4633, '', 4, '', 'JUFFROUW JOHANNA', 'Thobias Tak Couperus', 678, NULL, NULL, '1788', NULL, 'Z', 'Z', '1789-03-01', 'Rammekens', '1789-07-10', '1789-08-25', true, '1789-11-16', 'Batavia', NULL, 'S. Tiago, 25-03 till 03-04-1789. In 1793 or 1794 the ship was sold at Batavia.');
INSERT INTO "voyages" VALUES (4634, '', 1, '', 'SCHAGEN', 'Pieter Stokbroo', 880, NULL, '1785', NULL, NULL, 'H', 'H', '1789-03-03', 'Texel', '1789-05-27', '1789-06-10', true, '1789-08-03', 'Batavia', 8278, 'it arrived on 07-10-1789.');
INSERT INTO "voyages" VALUES (4635, '', 2, '', 'SPAARNE', 'Stoete', 656, 'hoeker', NULL, '1784', NULL, 'A', 'A', '1789-03-05', 'Texel', '1789-06-14', '1789-06-28', true, '1789-08-31', 'Bengal', NULL, NULL);
INSERT INTO "voyages" VALUES (4636, '', 1, '', 'VLIJT', 'Pieter Couvret', 136, 'paketboot', '1788', NULL, NULL, 'Z', 'Z', '1789-04-04', 'Rammekens', '1789-07-11', '1789-07-20', true, NULL, 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (4637, '', 2, '', 'OOSTZAANDAM', 'Jakob de Vries', 650, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1789-05-21', 'Texel', '1789-12-10', '1790-01-21', true, '1790-06-01', 'Batavia', 8317, 'July the OOSTZAANDAM, sailing to the Cape, lost its foremast.');
INSERT INTO "voyages" VALUES (4638, '', 1, '', 'LUCHTBOL', 'Nils Lundstrom', 136, 'paketboot', '1788', NULL, NULL, 'R', 'R', '1789-06-01', 'Goeree', '1789-09-09', '1789-09-21', true, '1789-11-18', 'Batavia', 8272, NULL);
INSERT INTO "voyages" VALUES (4639, '', 3, '', 'DRAAK', 'Wietse de Boer', 1150, NULL, '1780', NULL, NULL, 'A', 'A', '1789-06-11', 'Texel', '1789-09-18', '1789-10-12', true, '1789-12-24', 'Batavia', 8323, NULL);
INSERT INTO "voyages" VALUES (4640, '', 4, '', 'DORDRECHT', 'Pleun van der Giessen', 898, 'fluit', NULL, NULL, NULL, 'D', 'A', '1789-07-03', 'Texel', '1789-11-27', '1789-12-17', true, '1790-02-23', 'Batavia', 8322, 'was at Duins. During the voyage the master died. 4640/8322 Is the fourth voyage of this ship, which during its first voyage (4400/8087) was called BERLIN.');
INSERT INTO "voyages" VALUES (4641, '', 2, '', 'VROUWE SARA HENDRINA', 'Hillebrand van Uijen', 656, 'fluit', NULL, NULL, NULL, NULL, 'A', '1789-07-03', 'Texel', '1789-11-26', NULL, true, '1789-11-26', 'The Cape', 8276, 'The VROUWE SARA HENDRINA was bound for the Cape.');
INSERT INTO "voyages" VALUES (4642, '', 2, '', 'EENPARIGHEID', 'de Groot', 600, NULL, NULL, '1784', NULL, 'H', 'D', '1789-07-04', 'Goeree', '1789-11-25', '1789-12-17', true, '1790-02-25', 'Batavia', 8320, 'Soon after having departed from Goeree the EEN-PARIGHEID''s masts were severely damaged. For that reason the ship had to call at Duins, 09 till 23-07-1789.');
INSERT INTO "voyages" VALUES (4643, '', 3, '', 'MENTOR', 'Jan Jochem Milfaart', 560, NULL, NULL, '1789', NULL, 'Z', 'Z', '1789-07-20', 'Rammekens', '1789-11-19', '1789-12-17', true, '1790-03-07', 'Batavia', 8325, 'According to K.A. 4390a the departing crew consisted of 200 men. The MENTOR called at Duins, 24 till 27-07-1789.');
INSERT INTO "voyages" VALUES (4644, '', 4, '', 'HOF TER LINDEN', 'Jakob de Groot', 1150, NULL, '1772', NULL, NULL, 'Z', 'Z', '1789-08-03', 'Rammekens', '1789-11-27', '1789-12-20', true, NULL, 'Batavia', NULL, 'According to K.A. 4317 the departing crew consisted of 293 men.');
INSERT INTO "voyages" VALUES (4645, '', 1, '', 'ZEEBOUWER', 'Jan Mulder', 880, NULL, '1787', NULL, NULL, 'R', 'R', '1789-08-03', 'Goeree', '1789-11-23', '1789-12-17', true, '1790-03-01', 'Batavia', NULL, 'called at Duins, 04 till 08-08-1789. In 1793 the ship was sold in Bengal.');
INSERT INTO "voyages" VALUES (4646, '', 2, '', 'VROUWE AGATHA', 'Albert Kornelisz.', 900, 'fluit', NULL, NULL, NULL, NULL, 'A', '1789-08-09', 'Texel', '1789-12-17', '1790-01-07', true, '1790-04-25', 'Batavia', 8332, NULL);
INSERT INTO "voyages" VALUES (4647, '', 1, '', 'STERRESCHANS', 'Klaas Keuken', 850, 'hoeker', NULL, '1789', NULL, 'A', 'A', '1789-08-09', 'Texel', '1789-12-20', NULL, true, '1789-12-20', 'The Cape', NULL, 'The STERRESCHANS was bound for the Cape. On 20-05-1793 the ship ran aground at the Cape and was wrecked.');
INSERT INTO "voyages" VALUES (4648, '', 1, '', 'EXPEDITIE', 'Jakob Zoeteman', 136, 'paketboot', '1788', NULL, NULL, 'D', 'D', '1789-09-01', 'Goeree', '1789-12-31', '1790-01-14', true, '1790-04-26', 'Batavia', 8299, NULL);
INSERT INTO "voyages" VALUES (4649, '', 2, '', 'MARIA LOUISA', 'Anthonie Franciscus Steffers', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1789-10-09', 'Texel', '1790-01-02', '1790-01-16', true, NULL, 'Ceylon', 8305, NULL);
INSERT INTO "voyages" VALUES (4650, '', 1, '', 'HOUGLY', 'Christiaan Stratenburg', 1150, NULL, '1788', NULL, NULL, 'A', 'A', '1789-10-23', 'Texel', '1790-02-05', '1790-02-25', true, '1790-06-02', 'Batavia', 8383, NULL);
INSERT INTO "voyages" VALUES (4651, '', 1, '', 'VASCO DA GAMA', 'Hans Barendse', 1150, NULL, '1788', NULL, NULL, 'A', 'A', '1789-10-23', 'Texel', '1790-02-24', '1790-03-17', true, '1790-06-17', 'Batavia', 8302, 'After having arrived at Batavia the VASCO DA GAMA sailed on to China.');
INSERT INTO "voyages" VALUES (4652, '', 3, '', 'VOORSCHOTEN', 'Abraham Christoffel Hofman', 1150, NULL, '1783', NULL, NULL, 'A', 'A', '1789-10-23', 'Texel', '1790-02-02', '1789-03-13', true, '1790-06-01', 'Batavia', NULL, 'In 1793 or 1794 the VOORSCHOTEN was sold at Batavia.');
INSERT INTO "voyages" VALUES (4653, '', 2, '', 'ALBLASSERDAM', 'Pieter Mallet jr.', 1150, NULL, '1782', NULL, NULL, 'Z', 'Z', '1789-10-24', 'Rammekens', '1790-02-03', '1790-02-25', true, '1790-05-18', 'Batavia', 8330, 'According to K.A. 4390a the departing crew consisted of 355 men. The ship went on to China.');
INSERT INTO "voyages" VALUES (4654, '', 1, '', 'HAASJE', 'Jan Andries Rugee', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1789-11-18', 'Texel', '1790-02-06', '1790-02-17', true, '1790-04-22', 'Batavia', 8288, NULL);
INSERT INTO "voyages" VALUES (4655, '', 2, '', 'LEIDEN', 'Dirk Roem', 1150, NULL, '1786', NULL, NULL, 'A', 'A', '1789-11-22', 'Texel', '1790-03-06', '1790-04-07', true, NULL, 'Batavia', 8354, NULL);
INSERT INTO "voyages" VALUES (4656, '', 2, '', 'GOEVERNEUR-GENERAAL MAATSUIJKER', 'Jan Kraai', 1150, NULL, '1786', NULL, NULL, 'A', 'A', '1789-11-23', 'Texel', '1790-04-02', '1790-05-04', true, '1790-07-23', 'Batavia', NULL, 'the GOUVERNEUR-GENERAAL MAATSUIJKER was sold at Batavia.');
INSERT INTO "voyages" VALUES (4657, '', 1, '', 'SNELHEID', 'Jan Koenraad Haverkamp', 136, 'paketboot', '1788', NULL, NULL, 'H', 'H', '1790-01-06', 'Texel', '1790-04-13', '1790-04-26', true, '1790-07-11', 'Batavia', 8289, NULL);
INSERT INTO "voyages" VALUES (4658, '', 2, '', 'CANTON', 'Dirk Peek', 1150, NULL, '1785', NULL, NULL, 'R', 'R', '1790-01-18', 'Texel', '1790-04-29', '1790-05-13', true, '1790-07-16', 'Batavia', NULL, 'On 01-12-1789 the CANTON departed from Goeree; five days later it arrived at Texel. Continuing its voyage from Batavia to China the CANTON was wrecked in the South China Sea.');
INSERT INTO "voyages" VALUES (4659, '', 1, '', 'HOORNWEG', 'Simon Vaartjes', 880, NULL, '1787', NULL, NULL, 'D', 'D', '1790-01-18', 'Texel', '1790-04-29', '1790-05-13', true, '1790-07-26', 'Batavia', 8326, 'On 01-12-1789 the HOORNWEG departed from Goeree; nine days later the ship arrived at Texel.');
INSERT INTO "voyages" VALUES (4660, '', 1, '', 'MAKASSAR', 'Laurens Jansen', 1150, NULL, '1787', NULL, NULL, 'E', 'E', '1790-01-18', 'Texel', '1790-04-29', '1790-05-13', true, '1790-07-30', 'Batavia', 8342, NULL);
INSERT INTO "voyages" VALUES (4661, '', 1, '', 'GOUVERNEUR-GENERAAL MOSSEL', 'Hans Christiaan Christiaanse', 1150, NULL, '1788', NULL, NULL, 'A', 'A', '1790-01-18', 'Texel', '1790-04-30', '1790-05-29', true, '1790-07-21', 'Ceylon', 8346, NULL);
INSERT INTO "voyages" VALUES (4662, '', 1, '', 'NIEUWSTAD', 'Jan Olhof', 880, NULL, '1787', NULL, NULL, 'H', 'H', '1790-01-18', 'Texel', '1790-04-29', '1790-05-13', true, '1790-07-26', 'Batavia', 8345, 'The NIEUWSTAD called at Portsmouth, 21 till 28-02-1790.');
INSERT INTO "voyages" VALUES (4663, '', 2, '', 'GOEDE TROUW', 'Arie Stijne', 1150, NULL, '1786', NULL, NULL, 'Z', 'Z', '1790-01-18', 'Rammekens', '1790-04-22', '1790-05-21', true, '1790-08-09', 'Batavia', NULL, 'According to K.A. 4390a the departing crew consisted of 331 men.');
INSERT INTO "voyages" VALUES (4664, '', 1, '', 'UNIE', 'Simon Laurentius', 1150, NULL, '1787', NULL, NULL, 'Z', 'Z', '1790-01-18', 'Rammekens', '1790-04-30', '1790-05-29', true, '1790-07-22', 'Ceylon', 8297, NULL);
INSERT INTO "voyages" VALUES (4665, '', 1, '', 'STAR', 'Christiaan Zummack', 136, 'paketboot', '1788', NULL, NULL, 'Z', 'Z', '1790-02-19', 'Rammekens', '1790-05-19', NULL, true, NULL, 'Ceylon', 8340, 'On 19-05-1790 the STAR arrived at False Bay.');
INSERT INTO "voyages" VALUES (4666, '', 2, '', 'FAAM', 'Luur Runken', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1790-03-05', 'Texel', '1790-06-01', '1790-06-19', true, '1790-08-10', 'Batavia', 8300, NULL);
INSERT INTO "voyages" VALUES (4667, '', 1, '', 'ZEEMEEUW', 'Pierre Muntz', 136, 'paketboot', '1788', NULL, NULL, 'E', 'E', '1790-04-02', 'Texel', '1790-06-26', NULL, true, '1790-09-14', 'Ceylon', 8319, NULL);
INSERT INTO "voyages" VALUES (4668, '', 1, '', 'VOORLAND', 'Daniel Correch', 1150, NULL, '1788', NULL, NULL, 'A', 'A', '1790-04-13', 'Texel', '1790-08-21', '1790-09-15', true, '1790-12-07', 'Batavia', 8358, NULL);
INSERT INTO "voyages" VALUES (4669, '', 3, '', 'BARBESTEIN', 'Johan Koenraad Knot', 1150, NULL, '1783', NULL, NULL, 'A', 'Z', '1790-05-12', 'Rammekens', '1790-09-01', '1790-09-20', true, '1790-12-07', 'Batavia', 8339, NULL);
INSERT INTO "voyages" VALUES (4670, '', 2, '', 'GOUVERNEUR FALCK', 'Jan Anthonie Lubben', 1150, NULL, '1786', NULL, NULL, 'A', 'A', '1790-05-25', 'Texel', '1790-09-22', '1790-10-17', true, '1790-12-27', 'Batavia', 8337, NULL);
INSERT INTO "voyages" VALUES (4671, '', 2, '', 'VLIJT', 'Pieter Couvret', 136, 'paketboot', '1788', NULL, NULL, 'Z', 'Z', '1790-06-02', 'Rammekens', '1790-09-05', '1790-09-15', true, NULL, 'Batavia', 8310, NULL);
INSERT INTO "voyages" VALUES (4672, '', 2, '', 'BATAVIER', 'Pieter Volkwart jr.', 1150, NULL, '1782', NULL, NULL, 'A', 'A', '1790-06-13', 'Texel', '1790-09-23', '1790-11-02', true, '1791-02-08', 'Batavia', NULL, 'In 1793 the BATAVIER ran aground and was wrecked in the Indies');
INSERT INTO "voyages" VALUES (4673, '', 3, '', 'GERECHTIGIIEID', 'Wiggert Molenaar', 1150, NULL, '1779', NULL, NULL, 'A', 'R', '1790-06-16', 'Goeree', '1790-10-12', '1790-11-02', true, '1791-02-01', 'Batavia', 8364, 'The 27 passengers included 26 Chinese, 11 of them arrived at Batavia.');
INSERT INTO "voyages" VALUES (4674, '', 2, '', 'MEERMIN', 'Lodewijk Willem van Rossum', 500, 'fregat', '1782', NULL, NULL, 'A', 'A', '1790-06-27', 'Texel', '1790-10-16', NULL, true, '1790-10-16', 'The Cape', 8398, 'till 06-07-1790.');
INSERT INTO "voyages" VALUES (4675, '', 2, '', 'STANDVASTIGHEID', 'Evert Wittenberg', 780, 'hoeker', NULL, '1785', NULL, 'R', 'D', '1790-08-13', 'Goeree', '1791-01-23', '1791-02-18', true, '1791-05-22', 'Batavia', 8318, 'At Batavia, before sailing back to Texel in 1791/2, the ship''s name was altered into TEXELSTROOM (see 8318).');
INSERT INTO "voyages" VALUES (4676, '', 2, '', 'LUCHTBOL', 'Jakob Soetemans', 136, 'paketboot', '1788', NULL, NULL, 'R', 'R', '1790-09-06', 'Goeree', '1791-01-11', '1791-01-28', true, '1791-05-03', 'Batavia', 8316, '08-09 till 12-10-1790.');
INSERT INTO "voyages" VALUES (4677, '', 1, '', 'INDUS', 'Matthijs Laurens Koster', 1150, NULL, '1789', NULL, NULL, 'A', 'A', '1790-09-07', 'Texel', '1791-01-05', '1791-02-01', true, '1791-05-20', 'Batavia', NULL, 'Originally the INDUS departed on 27-08-1790; it had to return to Texel, however. From 10 till 24-09-1790 the ship was at Duins. In 1794 the INDUS was burnt down in the roads of Batavia.');
INSERT INTO "voyages" VALUES (4678, '', 1, '', 'ZWAAN', 'Marinus van Vlaanderen', 1150, NULL, '1787', NULL, NULL, 'Z', 'Z', '1790-09-08', 'Rammekens', '1791-01-26', '1791-03-09', true, '1791-05-28', 'Batavia', 8321, 'According to K.A. 4328 the departing crew consisted of 286 men.');
INSERT INTO "voyages" VALUES (4679, '', 2, '', 'USTROOM', 'Ulke Barendsz.', 898, NULL, NULL, '1785', NULL, 'A', 'Z', '1790-10-01', 'Rammekens', '1791-03-03', '1791-04-18', true, '1791-07-24', 'Batavia', NULL, 'In 1793 or 1794 the IJSTROOM was sold at Batavia.');
INSERT INTO "voyages" VALUES (4680, '', 2, '', 'BLITTERSWIJK', 'Jakob Thomsen', 1150, NULL, '1785', NULL, NULL, 'Z', 'H', '1790-10-02', 'Texel', '1791-01-25', '1791-03-09', true, '1791-06-07', 'Batavia', 8331, 'According to K.A. 4328 three passengers were aboard the BLITTERSWIJK, when it departed from Texel. The ship called at Duins, 06 till 09-10-1790, and went from Batavia to China.');
INSERT INTO "voyages" VALUES (4681, '', 1, '', 'WILLEM DE VIERDE', 'Gerrit Esman', 1150, NULL, '1789', NULL, NULL, 'A', 'A', '1790-10-02', 'Texel', '1791-02-06', '1791-03-08', true, '1791-06-19', 'Batavia', NULL, 'In 1793 the WILLEM DE VIERDE was taken by the French in Sunda Strait.');
INSERT INTO "voyages" VALUES (4682, '', 2, '', 'VALK', 'George Gottlieb Hebner', 600, NULL, NULL, '1785', NULL, 'A', 'A', '1790-10-11', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'From 17-10-1790 till 21-02-1791 the VALK was at Gluckstadt. On 27-02-1791 the ship was wrecked at the banks off Yarmouth.');
INSERT INTO "voyages" VALUES (4683, '', 1, '', 'CANDIA', 'Dirksz. Varkevisser', 1150, NULL, '1788', NULL, NULL, 'R', 'R', '1790-10-26', 'Goeree', '1791-02-13', '1791-03-23', true, '1791-06-15', 'Batavia', NULL, 'In 1796 the CANDIA was sold and broken up at Batavia.');
INSERT INTO "voyages" VALUES (4684, '', 3, '', 'SPARENRIJK', 'Johan Pleen', 1150, NULL, '1780', NULL, NULL, 'A', 'A', '1790-10-27', 'Texel', '1791-02-09', '1791-03-17', true, '1791-06-17', 'Batavia', NULL, 'According to K.A. 4328 nine passengers were aboard the SPA-RENRIJK, when it departed from Texel. In 1794 the ship was sold at Batavia. 4684.1- Is the third voyage of this ship, which during its first voyage (4410/8099) was called POTSDAM.');
INSERT INTO "voyages" VALUES (4685, '', 1, '', 'RUSTHOF', 'Simon Jakob Forster', 880, NULL, '1788', NULL, NULL, 'D', 'D', '1790-11-09', 'Goeree', '1791-02-14', '1791-03-28', true, '1791-06-19', 'Batavia', 8347, NULL);
INSERT INTO "voyages" VALUES (4686, '', 2, '', 'NEGOTIE', 'Herman Driesman', 440, NULL, NULL, '1785', NULL, 'A', 'A', '1790-11-23', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The NEGOTIE was bound for Ceylon. On 26 and 27-11-1790, however, the ship was wrecked and went to pieces off Texel.');
INSERT INTO "voyages" VALUES (4687, '', 2, '', 'MEERWiJK', 'Willem van Groningen', 1150, NULL, '1787', NULL, NULL, 'A', 'A', '1790-11-29', 'Texel', '1791-05-28', '1791-06-20', true, '1791-09-14', 'Batavia', NULL, 'Torbay (14 till 27-02-1791). In 1795 the MEERWIJK was sold at Batavia.');
INSERT INTO "voyages" VALUES (4688, '', 2, '', 'CHRISTOFFEL COLUMBUS', 'Laurits', 1150, NULL, '1787', NULL, NULL, 'A', 'A', '1791-02-20', 'Texel', '1791-06-17', '1791-07-21', true, '1791-12-02', 'Ceylon', 8335, 'At the departure from Texel the CHRISTOFFEL COLUMBUS, the CONSTITUTIE (4689), the KRAAI (4690), the SCHAGEN (4691), and the ZAANSTROOM (4692) were accompanied by a Dutch man-of-war.');
INSERT INTO "voyages" VALUES (4689, '', 1, '', 'CONSTITUTIE', 'Zacharias van Hek', 880, NULL, '1788', NULL, NULL, 'H', 'H', '1791-02-20', 'Texel', '1791-06-01', '1791-07-05', true, '1791-09-05', 'Batavia', 8343, 'During the voyage the CONSTITUTIE lost all its topmasts. See the CHRISTOFFEL COLUMBUS (4688).');
INSERT INTO "voyages" VALUES (4690, '', 1, '', 'K R A A I', 'Swerus Magnus Cederborg', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1791-02-20', 'Texel', '1791-05-29', NULL, true, '1791-08-30', 'Batavia', 8324, 'Date of departure from the Cape unknown. See the CHRISTOF-FEL COLUMBUS (4688).');
INSERT INTO "voyages" VALUES (4691, '', 2, '', 'SCHAGEN', 'Justinus Philippus Man', 880, NULL, '1785', NULL, NULL, 'H', 'E', '1791-02-20', 'Texel', '1791-05-29', '1791-06-24', true, '1791-09-12', 'Batavia', NULL, 'See the CHRISTOFFEL COLUMBUS (4688).');
INSERT INTO "voyages" VALUES (4692, '', 2, '', 'ZAANSTROOM', 'Jan Jobst Droop', 564, NULL, '1785', NULL, NULL, 'A', 'A', '1791-02-20', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ZAANSTROOM was bound for the Cape. On 28-02-1791, however, the ship ran aground off Barfleur in France. See the CHRISTOFFEL COLUMBUS (4688).');
INSERT INTO "voyages" VALUES (4693, '', 1, '', 'ERFPRINS', 'Jan Arendsz.', 1150, NULL, '1788', NULL, NULL, 'Z', 'Z', '1791-03-31', 'Rammekens', '1791-08-03', '1791-10-08', true, '1792-01-30', 'Batavia', NULL, 'According to K.A. 4328 the departing crew consisted of 301 men. At the Cape many soldiers embarked. Eventually the ship was sold at Batavia.');
INSERT INTO "voyages" VALUES (4694, '', 2, '', 'ZEELAND', 'Albert Tjerksz.', 1150, NULL, '1783', NULL, NULL, 'Z', 'Z', '1791-03-31', 'Rammekens', '1791-07-24', '1791-10-08', true, '1792-03-20', 'Batavia', 8353, 'The ZEELAND carried many soldiers to Batavia and went on to China.');
INSERT INTO "voyages" VALUES (4695, '', 2, '', 'DRIE GEBROEDERS', 'Jan Roelofsz. de Groot', 828, 'fluit', NULL, NULL, NULL, NULL, 'A', '1791-04-27', 'Texel', '1791-08-25', '1791-09-24', true, '1791-12-14', 'Batavia', 8338, 'According to K.A. 4328 the departing crew consisted of 372 men.');
INSERT INTO "voyages" VALUES (4696, '', 2, '', 'SNELHEID', 'Roelof Jurgen Frdrop', 136, 'paketboot', '1788', NULL, NULL, 'H', 'H', '1791-05-02', 'Texel', '1791-07-09', '1791-07-27', true, '1791-09-14', 'Batavia', 8336, NULL);
INSERT INTO "voyages" VALUES (4697, '', 4, '', 'JAVA', 'Jakob van Citters de Rijke', 850, NULL, '1775', NULL, NULL, 'E', 'Z', '1791-05-25', 'Rammekens', '1791-10-22', '1791-11-17', true, '1792-02-11', 'Batavia', NULL, 'According to K.A. 4390a the departing crew consisted of 207 men. The JAVA carried many soldiers to Batavia. In 1796 the ship was laid up at Batavia.');
INSERT INTO "voyages" VALUES (4698, '', 2, '', 'VROUWE MARIA KORNELIA', 'Michiel Jurgens', 1150, NULL, '1785', NULL, NULL, 'E', 'Z', '1791-05-25', 'Rammekens', '1791-09-04', '1791-10-23', true, '1792-04-13', 'Batavia', 8351, 'VROUWE MARIA KORNELIA, when it departed from Rammekens.');
INSERT INTO "voyages" VALUES (4699, '', 2, '', 'AREND', 'Klaas Keuken', 690, NULL, NULL, '1786', NULL, 'A', 'A', '1791-06-03', 'Texel', '1791-10-19', '1791-11-09', true, '1792-01-23', 'Batavia', NULL, 'In 1795 the AREND was sold at Batavia.');
INSERT INTO "voyages" VALUES (4700, '', 2, '', 'MEEUWTJE', 'Wietse de Boer', 400, NULL, '1783', NULL, NULL, 'A', 'A', '1791-06-05', 'Texel', '1791-08-29', '1791-10-03', true, '1791-12-07', 'Ceylon', NULL, 'In 1795 the MEEUWTJE was sold at Batavia.');
INSERT INTO "voyages" VALUES (4701, '', 2, '', 'HOUTLUST', 'Kornelis van Deventer', 880, NULL, '1785', NULL, NULL, 'D', 'R', '1791-06-17', 'Goeree', '1791-10-19', '1791-11-09', true, '1792-02-10', 'Batavia', NULL, 'Chinese, 11 of them arrived at Batavia. In 1796 the HOUTLUST was sold and broken up at Batavia.');
INSERT INTO "voyages" VALUES (4702, '', 2, '', 'HAASJE', 'Jakob Zoeteman', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1791-07-09', 'Texel', '1791-09-16', '1791-10-30', true, '1791-12-15', 'Batavia', 8333, NULL);
INSERT INTO "voyages" VALUES (4703, '', 3, '', 'HUISDUINEN', 'Jan Kornelis Baane', 723, NULL, NULL, '1784', NULL, 'A', 'Z', '1791-08-08', 'Rammekens', '1791-11-30', '1791-12-30', true, '1792-04-01', 'Batavia', NULL, 'According to K.A. 4390a the departing crew consisted of 269 men. The 22 passengers indicated in the first and sixth column were Chinese. Eventually the HUISDUINEN was sold at Batavia.');
INSERT INTO "voyages" VALUES (4704, '', 2, '', 'TRINCONOMALE', 'Roelof Pietersz. Hoberg', 1150, NULL, '1787', NULL, NULL, 'A', 'A', '1791-08-09', 'Texel', '1792-01-15', '1792-02-16', true, '1792-06-07', 'Batavia', NULL, 'In 1796 the TRINCONOMALE was sold at Batavia.');
INSERT INTO "voyages" VALUES (4705, '', 1, '', 'JONKVROUWE SIBILLA ANTHOINETTA', 'Nikolaas Klopper', 1150, NULL, '1789', NULL, NULL, 'A', 'A', '1791-08-15', 'Texel', '1791-11-22', '1791-12-16', true, '1792-03-12', 'Batavia', 8356, 'The 34 passengers indicated in the first column included 25 Chinese, 24 of them arrived at Batavia.');
INSERT INTO "voyages" VALUES (4706, '', 2, '', 'CASTOR', 'Jan Jobst Droop', 650, NULL, NULL, '1784', NULL, 'Z', 'A', '1791-09-08', 'Texel', '1792-01-09', NULL, true, '1792-01-09', 'The Cape', 8360, NULL);
INSERT INTO "voyages" VALUES (4707, '', 2, '', 'VERWACHTING', 'Pieter van Aarson', 600, 'hoeker', NULL, '1787', NULL, 'H', 'Z', '1791-09-09', 'Rammekens', '1792-01-17', '1792-02-13', true, '1792-06-21', 'Batavia', 8357, NULL);
INSERT INTO "voyages" VALUES (4708, '', 3, '', 'ROZENBURG', 'Roelof Bengtson', 880, NULL, '1780', NULL, NULL, 'D', 'D', '1791-09-12', 'Goeree', '1791-12-22', '1792-01-05', true, '1792-04-01', 'Batavia', 8355, 'The 20 passengers indicated in the first column included 18 Chinese, they all arrived at Batavia. The ship went on to China.');
INSERT INTO "voyages" VALUES (4709, '', 1, '', 'GEERTRUIDA EN PETRONELLA', 'Lodewijk Willem van Rossum', 964, 'pink', NULL, NULL, NULL, NULL, 'A', '1791-09-14', 'Texel', '1792-01-12', '1792-02-10', true, '1792-04-24', 'Batavia', 8344, NULL);
INSERT INTO "voyages" VALUES (4710, '', 3, '', 'POLLUX', 'Petrus Stephanus Buissine', 490, NULL, NULL, '1784', NULL, 'Z', 'Z', '1791-10-27', 'Rammekens', '1792-02-29', '1792-03-20', true, '1792-06-14', 'Batavia', NULL, 'In 1795 the POLLUX was sold at Batavia.');
INSERT INTO "voyages" VALUES (4711, '', 3, '', 'FAAM', 'Hidde Bok', 136, 'paketboot', NULL, NULL, NULL, 'A', 'A', '1791-12-16', 'Texel', '1792-03-13', '1792-03-25', true, '1792-05-29', 'Batavia', 8365, NULL);
INSERT INTO "voyages" VALUES (4712, '', 1, '', 'BUITENVERWACHTING', 'Arie Simonsz. Koek', 1150, NULL, '1789', NULL, NULL, 'A', 'A', '1791-12-17', 'Texel', '1792-05-31', '1792-06-21', true, '1792-08-30', 'Batavia', 8350, '(4713), the OOSTHUIZEN (4714), the UNIE (4715), and the VASCO DA GAMA (4716) were escorted by a Dutch man-of-war.');
INSERT INTO "voyages" VALUES (4713, '', 2, '', 'SLOT CAPELLE', 'Nicolaus Fischerstrom', 880, NULL, '1786', NULL, NULL, 'R', 'E', '1791-12-17', 'Texel', '1792-07-04', '1792-07-24', true, '1792-09-12', 'Batavia', NULL, 'The SLOT CAPELLE called at S. Tiago, 03 till 10-03-1792. After 1795 the ship was sold at Batavia. See the BUI-TENVERWACHTING (4712).');
INSERT INTO "voyages" VALUES (4714, '', 1, '', 'OOSTHUIZEN', 'Gerrit Scheler', 880, NULL, '1789', NULL, NULL, 'H', 'H', '1791-12-17', 'Texel', '1792-04-03', NULL, true, '1792-07-09', 'Batavia', 8352, 'Date of departure from the Cape unknown. After having arrived at Batavia the OOSTHUIZEN sailed on to China. See also BUITENVERWACHTING (4712).');
INSERT INTO "voyages" VALUES (4715, '', 2, '', 'UNIE', 'Jurriaan Pietersen', 1150, NULL, '1787', NULL, NULL, 'Z', 'A', '1791-12-17', 'Texel', '1792-05-31', '1792-06-21', true, '1792-08-30', 'Batavia', 8348, 'The 25 passengers indicated in the first column included 22 Chinese; 16 of them arrived at Batavia. See the BUITENVERWACHTING (4712).');
INSERT INTO "voyages" VALUES (4716, '', 2, '', 'VASCO DA GAMA', 'Jan van Stralen', 1150, NULL, '1788', NULL, NULL, 'A', 'A', '1791-12-17', 'Texel', '1792-06-17', '1792-07-10', true, '1792-09-21', 'Ceylon', NULL, 'The VASCO DA GAMA called at Portsmouth, 03-01 till 16-02-1792. After 1795 the ship was broken up at Batavia. See the BUITENVERWACHTING (4712).');
INSERT INTO "voyages" VALUES (4717, '', 1, '', 'WESTKAPELLE', 'Simon Laurentius', 1150, NULL, '1788', NULL, NULL, 'Z', 'Z', '1791-12-22', 'Rammekens', '1192-05-31', '1792-06-14', true, '1792-09-12', 'Batavia', 8349, 'From 25-02 till 30-03-1792 the WESTKAPELLE was at S. Tiago.');
INSERT INTO "voyages" VALUES (4718, '', 2, '', 'GOUDA', 'Anthonie Franciscus Steffers', 400, NULL, '1784', NULL, NULL, 'A', 'A', '1792-01-20', 'Texel', '1792-05-27', NULL, true, '1792-05-27', 'The Cape', 8362, 'Originally the GOUDA sailed from Texel on 21-12-1791; five days later, however, the ship returned.');
INSERT INTO "voyages" VALUES (4719, '', 2, '', 'HELENA LOUISA', 'Jan Driwes', 180, 'brik', NULL, '1787', NULL, 'B', 'A', '1792-01-20', 'Texel', '1792-05-31', NULL, true, '1792-05-31', 'The Cape', NULL, 'AFRIKAAN.');
INSERT INTO "voyages" VALUES (4720, '', 2, '', 'DORDWIJK', 'Arnold Rogge', 800, 'hoeker', NULL, '1787', NULL, 'R', 'R', '1792-01-22', 'Goeree', '1792-06-30', '1792-07-21', true, '1792-09-23', 'Batavia', 8381, 'The DORDWIJK called at Duins (arrival: 27-01-1792).');
INSERT INTO "voyages" VALUES (4721, '', 3, '', 'SCHELDE', 'Kornelis van Eps', 1150, NULL, '1780', NULL, NULL, 'Z', 'Z', '1792-02-20', 'Rammekens', '1792-06-30', '1792-07-16', true, '1792-09-16', 'Ceylon', 8377, NULL);
INSERT INTO "voyages" VALUES (4722, '', 3, '', 'VLIJT', 'Francois Moser', 136, 'paketboot', '1788', NULL, NULL, 'Z', 'Z', '1792-03-20', 'Rammekens', '1792-07-17', '1793-05-31', true, '1793-09-17', 'Batavia', 8391, 'From 25-03 till 06-04-1792 the VLIJT was at Duins.');
INSERT INTO "voyages" VALUES (4723, '', 1, '', 'HILVERSBEEK', 'Klaas Voet', 1150, NULL, '1790', NULL, NULL, 'A', 'A', '1792-05-24', 'Texel', '1792-09-06', '1792-09-27', true, '1792-12-08', 'Ceylon', NULL, 'The HILVERSBEEK called at Duins (departure: 02-06-1792). At (or before) the Cape Jan Jobst Droop succeeded Klaas Voet as master. The ship carried many soldiers to Ceylon.');
INSERT INTO "voyages" VALUES (4724, '', 3, '', 'BERKHOUT', 'Martens', 1150, NULL, '1779', NULL, NULL, 'H', 'A', '1792-06-02', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'One day after its departure from Texel the BERKHOUT had to be towed into Dover; there the ship was laid up.');
INSERT INTO "voyages" VALUES (4725, '', 3, '', 'MARIA LOUISA', 'Pieter Mosterd', 136, 'paketboot', '1788', NULL, NULL, 'A', 'D', '1792-06-16', 'Goeree', '1792-09-18', '1792-10-01', true, '1792-11-25', 'Batavia', 8367, NULL);
INSERT INTO "voyages" VALUES (4726, '', 2, '', 'TEILINGEN', 'Simon Vaartjes', 1150, NULL, '1786', NULL, NULL, 'R', 'R', '1792-07-10', 'Goeree', '1792-10-15', '1792-11-03', true, '1793-01-05', 'Batavia', NULL, 'In 1796 the TEILINGEN was sold and broken up at Batavia.');
INSERT INTO "voyages" VALUES (4727, '', 3, '', 'DUIFJE', 'Jan Olhof', 400, NULL, '1784', NULL, NULL, 'A', 'A', '1792-07-11', 'Texel', '1792-11-21', NULL, true, '1792-11-21', 'The Cape', 8361, 'at Duins (departure: 20-07-1792) and at S. Tiago (27 till 29-08-1792).');
INSERT INTO "voyages" VALUES (4728, '', 2, '', 'RECHT DOOR ZEE', 'Luur Runken', 880, NULL, '1786', NULL, NULL, 'D', 'A', '1792-07-11', 'Texel', '1792-11-23', '1792-12-09', true, '1793-02-20', 'Batavia', NULL, 'From 17 till 20-07-1792 the RECHT DOOR ZEE was at Duins. In 1795 or 1796 the ship was sold at Batavia.');
INSERT INTO "voyages" VALUES (4729, '', 2, '', 'SINT LAURENS', 'Jan David Sluiters', 1150, NULL, '1784', NULL, NULL, 'Z', 'Z', '1792-07-12', 'Rammekens', '1792-12-03', '1792-12-19', true, '1793-02-24', 'Batavia', NULL, 'The ST. LAURENS called at Duins (17 till 20-07-1792) and at S. Tiago (01 till 10-09-1792). In 1795 or 1796 the ship was broken up at Batavia.');
INSERT INTO "voyages" VALUES (4730, '', 2, '', 'RESOLUTIE', 'Daniel Hendriks', 530, NULL, NULL, '1784', NULL, 'H', 'A', '1792-07-24', 'Texel', '1793-01-17', NULL, true, '1793-01-17', 'The Cape', 8366, NULL);
INSERT INTO "voyages" VALUES (4731, '', 2, '', 'KRAAL', 'Jakob Sem', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1792-09-30', 'Texel', '1793-01-01', '1793-01-10', true, '1793-03-27', 'Batavia', 8369, NULL);
INSERT INTO "voyages" VALUES (4732, '', 3, '', 'AFRIKAAN', 'Thijs Ketel', 880, NULL, '1780', NULL, NULL, 'E', 'E', '1792-10-01', 'Texel', '1793-01-17', '1793-02-04', true, '1793-05-07', 'Batavia', 8371, NULL);
INSERT INTO "voyages" VALUES (4733, '', 2, '', 'DELFT', 'Johan van der Plas', 880, NULL, '1786', NULL, NULL, 'D', 'Z', '1792-10-01', 'Rammekens', '1793-01-18', '1793-03-06', true, '1793-06-13', 'Batavia', 8373, 'According to K.A. 4390a the departing crew consisted of 296 men.');
INSERT INTO "voyages" VALUES (4734, '', 2, '', 'PHOENICIER', 'Lodewijk Haak', 1150, NULL, '1786', NULL, NULL, 'A', 'A', '1792-10-01', 'Texel', '1793-01-18', '1793-02-04', true, '1793-05-08', 'Batavia', 8376, NULL);
INSERT INTO "voyages" VALUES (4735, '', 3, '', 'TEXELSTROOM', 'Jurriaan Kornelis Koertse', 780, 'hneker', NULL, '1785', NULL, 'R', 'A', '1792-10-07', 'Texel', '1793-03-31', NULL, true, '1793-03-31', 'The Cape', 8368, 'voyage was called STANDVASTIGHEID (numbers of the second voyage:4675/8318).');
INSERT INTO "voyages" VALUES (4736, '', 1, '', 'NAGELBOOM', 'Hans Barendse', 1150, NULL, '1790', NULL, NULL, 'A', 'A', '1792-10-09', 'Texel', '1793-03-25', '1793-04-11', true, '1793-07-03', 'Batavia', 8375, 'From 15 till 24-10-1792 the NAGELBOOM was at Duins. After having arrived at Batavia the ship sailed on to China.');
INSERT INTO "voyages" VALUES (4737, '', 2, '', 'ZWAAN', 'Andries Maankop', 1150, NULL, '1787', NULL, NULL, 'Z', 'Z', '1792-10-25', 'Rammekens', '1793-03-24', '1793-05-03', true, '1793-07-13', 'Batavia', 8395, 'According to K..4. 4336 the departing crew consisted of 360 men. The ZWAAN called at Duins, 28-10 till 25-11-1792.');
INSERT INTO "voyages" VALUES (4738, '', 3, '', 'BERKHOUT', 'Swerus Magnus Cederborg', 1150, NULL, '1784', NULL, NULL, 'A', 'A', '1792-11-24', 'Texel', '1793-03-21', '1793-04-10', true, '1793-07-13', 'Batavia', NULL, 'during the preceding voyages was called BEVERWIJK (numbers of the second voyage: 4594/8307).');
INSERT INTO "voyages" VALUES (4739, '', 3, '', 'BLITTERSWIJK', 'Nlarinus van Vlaanderen', 1150, NULL, '1785', NULL, NULL, 'Z', 'Z', '1792-11-25', 'Rammekens', '1793-04-04', '1793-04-21', true, '1793-06-22', 'Batavia', 8372, 'According to K.A. 4336 the departing crew consisted of 357 men.');
INSERT INTO "voyages" VALUES (4740, '', 1, '', 'IJSSELMONDE', 'Barend Sterk', 1150, NULL, '1789', NULL, NULL, 'R', 'R', '1792-11-29', 'Goeree', '1793-04-11', '1793-05-03', true, '1793-08-06', 'Batavia', NULL, 'In 1796 the IJSSELMONDE was sold and broken up at Batavia.');
INSERT INTO "voyages" VALUES (4741, '', 2, '', 'EXPEDITIE', 'Ditmar Smit', 136, 'paketboot', '1788', NULL, NULL, 'D', 'A', '1792-12-28', 'Texel', '1793-04-07', '1793-04-16', true, '1793-06-13', 'Batavia', 8370, NULL);
INSERT INTO "voyages" VALUES (4742, '', 1, '', 'CEYLON', 'Pierce Muntz', 900, 'pink', '1791', NULL, NULL, 'A', 'A', '1793-01-15', 'Texel', '1793-04-11', '1793-05-06', true, '1793-07-09', 'Ceylon', 8387, '196 men.');
INSERT INTO "voyages" VALUES (4743, '', 3, '', 'COLUMBUS', 'Daniel Kikkert', 1150, NULL, '1787', NULL, NULL, 'A', 'A', '1793-01-15', 'Texel', '1793-04-29', '1793-05-31', true, '1793-08-16', 'Batavia', NULL, 'In 1795 or 1796 the ship was broken up at Batavia.');
INSERT INTO "voyages" VALUES (4744, '', 4, '', 'DRAAK', 'Anthonie van Rijn', 1150, NULL, '1780', NULL, NULL, 'A', 'A', '1793-01-15', 'Texel', '1793-04-11', '1793-05-03', true, '1793-07-13', 'Batavia', NULL, 'Batavia, was struck by lightning and burnt down.');
INSERT INTO "voyages" VALUES (4745, '', 1, '', 'ENKHUIZER MAAGD', 'Jan Everwijn Drillinger', 1150, NULL, '1788', NULL, NULL, 'E', 'E', '1793-01-15', 'Texel', '1793-04-18', '1793-05-09', true, '1793-08-07', 'Batavia', 8374, NULL);
INSERT INTO "voyages" VALUES (4746, '', 4, '', 'MENTOR', 'Ulke Barendsz.', 560, NULL, NULL, '1789', NULL, 'Z', 'Z', '1793-04-06', 'Rammekens', '1793-07-13', '1793-07-30', true, '1793-10-04', 'Batavia', 8385, NULL);
INSERT INTO "voyages" VALUES (4747, '', 2, '', 'SURSEANCE', 'Christiaan Zummack', 768, NULL, NULL, '1786', NULL, 'Z', 'Z', '1793-04-06', 'Rammekens', '1793-07-13', '1793-07-30', true, '1793-09-25', 'Batavia', 8386, NULL);
INSERT INTO "voyages" VALUES (4748, '', 2, '', 'STAR', 'Karel Jakob Brugman', 136, 'paketboot', '1788', NULL, NULL, 'Z', 'Z', '1793-04-09', 'Rammekens', '1793-07-07', NULL, true, '1793-07-07', 'The Cape', NULL, 'On 04-08-1793 the Company''s authorities sent the ship to the Delagoa River in order to look for the homeward-bound DEMERARY (8363), which had departed from Batavia in February, 1793, and was missing since. Eventually the STAR was taken by the English.');
INSERT INTO "voyages" VALUES (4749, '', 3, '', 'LUCHTBOL', 'Willem Smal', 136, 'paketboot', '1788', NULL, NULL, 'R', 'R', '1793-07-01', 'Goeree', '1793-10-15', '1793-10-28', true, '1793-12-20', 'Batavia', NULL, 'On 15-07-1795 the LUCHTBOL was sold to the Danes at Bengal.');
INSERT INTO "voyages" VALUES (4750, '', 3, '', 'CONSTANTIA', 'Andries Laurens Kanters', 880, NULL, '1782', NULL, NULL, 'D', 'D', '1793-07-08', 'Goeree', '1793-11-12', '1793-12-08', true, '1794-02-18', 'Batavia', NULL, 'there it was taken by the English, when they captured the city.');
INSERT INTO "voyages" VALUES (4751, '', 1, '', 'KROMHOUT', 'Hendrik Holder', 880, NULL, '1790', NULL, NULL, 'H', 'H', '1793-07-08', 'Texel', '1793-11-11', '1793-12-08', true, '1794-02-16', 'Batavia', 8384, 'The 23 passengers indicated in the first column were Chinese; 20 of them arrived at Batavia.');
INSERT INTO "voyages" VALUES (4752, '', 3, '', 'HAASJE', 'Arie Smitskamp', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1793-09-20', 'Texel', '1794-03-06', '1794-03-16', true, '1794-06-15', 'Batavia', NULL, 'From 28-09 till 24-11-1793 the HAASJE was at Plymouth. Early in May, 1797, the HAASJE, which had been severely damaged during a storm, cast anchor off the mouth of the Delagoa River; on 27-05-1797 it was taken there by an English fishing-boat, assisted by a Portuguese ship.');
INSERT INTO "voyages" VALUES (4753, '', 3, '', 'VREDENBURG', 'Meindert Bode', 1150, NULL, '1784', NULL, NULL, 'A', 'A', '1793-09-20', 'Texel', '1794-03-29', NULL, true, '1794-07-06', 'Batavia', NULL, 'The VREDENBURG called at Plymouth, 28-09 till 24-11-1793. The date of departure from the Cape is unknown. In 1795 or 1796 the ship was sold at Batavia.');
INSERT INTO "voyages" VALUES (4754, '', 3, '', 'VROUWE AGATHA', 'Puter Murk', 900, 'fluit', NULL, NULL, NULL, NULL, 'A', '1793-11-07', 'Texel', '1794-04-11', '1794-04-20', true, '1794-07-09', 'Batavia', 8379, NULL);
INSERT INTO "voyages" VALUES (4755, '', 1, '', 'HERTOG VAN BRUNSWIJK', 'Jan Olhof', 1150, NULL, '1792', NULL, NULL, 'A', 'A', '1793-11-07', 'Texel', '1794-03-08', '1794-04-17', true, '1794-07-09', 'Batavia', NULL, 'The 44 passengers indicated in the first column included 39 Chinese; 37 of them arrived at Batavia. After having called at Batavia the HERTOG VAN BRUNSWIJK possibly sailed on to China. In 1795 or 1796 the ship was wrecked off Batavia.');
INSERT INTO "voyages" VALUES (4756, '', 5, '', 'DORDRECHT', 'Gottlieb Jager', 898, 'fluit', NULL, NULL, NULL, 'D', 'A', '1793-11-07', 'Texel', '1794-03-14', NULL, true, '1794-07-09', 'Batavia', 8380, 'According to K.A. 43936 the DORDRECHT had taken in its cargo at Riga. 4756/8380 Is the fifth voyage of this ship, which during its first voyage (4400/8087) was called BERLIN.');
INSERT INTO "voyages" VALUES (4757, '', 2, '', 'GEERTRUIDA EN PETRONELLA', 'Matthijs Hansen', 964, 'pink', NULL, NULL, NULL, NULL, 'A', '1793-11-07', 'Texel', '1794-03-14', '1794-04-20', true, '1794-07-09', 'Batavia', 8382, NULL);
INSERT INTO "voyages" VALUES (4758, '', 2, '', 'NOORD-HOLLAND', 'Hendrik Sluis', 894, 'fluit', NULL, NULL, NULL, NULL, 'A', '1793-11-07', 'Texel', '1794-09-05', NULL, true, '1794-11-05', 'Batavia', 8389, NULL);
INSERT INTO "voyages" VALUES (4759, '', 1, '', 'WASHINGTON', 'Gerard Adriaan van Velsen', 1150, NULL, '1791', NULL, NULL, 'A', 'A', '1793-11-07', 'Texel', '1794-03-08', '1794-04-17', true, '1794-07-09', 'Batavia', 8393, 'they all arrived at Batavia. After having called at Batavia the WASHINGTON sailed on to China.');
INSERT INTO "voyages" VALUES (4760, '', 1, '', 'SIAM', 'George Philip Gas', 880, NULL, '1789', NULL, NULL, 'D', 'D', '1793-11-16', 'Goeree', '1794-03-14', '1794-04-20', true, '1794-07-09', 'Batavia', 8392, 'to China.');
INSERT INTO "voyages" VALUES (4761, '', 3, '', 'STANDVASTIGHEID', 'Anton Christian von Fleischer', 708, NULL, NULL, '1785', NULL, 'A', 'R', '1793-11-16', 'Goeree', '1794-09-05', NULL, true, '1794-11-28', 'Batavia', 8390, 'Date of arrival at the Cape unknown. 4761/8390 Is the third voyage of this ship, which during its first voyage and the outward-bound part of the second voyage was called TEXELSTROOM(numbers of the second voyage: 4602/8328).');
INSERT INTO "voyages" VALUES (4762, '', 1, '', 'ZEELELIE', 'Jan Jochem Milfaart', 1150, NULL, '1789', NULL, NULL, 'Z', 'Z', '1793-11-16', 'Rammekens', '1794-03-30', '1794-04-20', true, '1794-07-09', 'Batavia', 8394, 'The 26 passengers indicated in the first column included 23 Chinese; they all arrived at Batavia. After having called at Batavia the ZEELELIE sailed on to China.');
INSERT INTO "voyages" VALUES (4763, '', 2, '', 'ZEEMEEUW', 'Albert Hillebrandsz.', 136, 'paketboot', '1788', NULL, NULL, 'E', 'A', '1793-12-26', 'Texel', NULL, NULL, false, '1794-07-15', 'Batavia', NULL, 'From Texel the ZEEMEEUW sailed to Rammekens; there it finally put to sea on 02-02-1794.');
INSERT INTO "voyages" VALUES (4764, '', 3, '', 'ALBLASSERDAM', 'Klaas Keuken', 1150, NULL, '1782', NULL, NULL, 'Z', 'A', '1793-12-27', 'Texel', '1794-08-11', '1794-09-05', true, '1795-01-01', 'Ceylon', NULL, NULL);
INSERT INTO "voyages" VALUES (4765, '', 1, '', 'EENDRACHT', 'Roelof Jurgen Erdrop', 880, NULL, '1791', NULL, NULL, 'H', 'H', '1793-12-27', 'Texel', '1794-08-08', '1194-09-05', true, '1794-11-05', 'Batavia', NULL, 'Batavia.');
INSERT INTO "voyages" VALUES (4766, '', 2, '', 'MAKASSAR', 'Frederik Markt', 1150, NULL, '1787', NULL, NULL, 'E', 'E', '1793-12-27', 'Texel', '1794-08-11', '1794-09-05', true, '1794-12-01', 'Batavia', 8388, NULL);
INSERT INTO "voyages" VALUES (4767, '', 2, '', 'WESTKAPELLE', 'Pieter .Mallet jr.', 1150, NULL, '1788', NULL, NULL, 'Z', 'Z', '1793-12-29', 'Rammekens', '1794-08-11', '1794-09-23', true, '1795-01-31', 'Batavia', NULL, 'In 1795 or 1796 the WESTKAPELLE was sold at Batavia.');
INSERT INTO "voyages" VALUES (4768, '', 4, '', 'FARM', 'Luitje Frederiksz.', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1794-03-21', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'On 25-03-1794 the FAAM was taken by the French and brought to Brest.');
INSERT INTO "voyages" VALUES (4769, '', 2, '', 'BUITENVERWACHTING', 'Hendrik Anthonie Stoete', 1150, NULL, '1789', NULL, NULL, 'A', 'A', '1794-05-05', 'Texel', '1794-09-20', '1194-10-12', true, '1795-01-29', 'Batavia', NULL, 'According to K.A. 4390a the departing crew consisted of 231 men. After 1795 the BUITENVERWACHTING was sold at Batavia.');
INSERT INTO "voyages" VALUES (4770, '', 1, '', 'VROUWE MARIA GEERTRUIDA', 'Roelof Tiernan', 320, NULL, NULL, NULL, NULL, NULL, 'Z', '1794-05-05', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'On 23-04-1794 the VROUWE MARIA GEERTRUIDA sailed from Rammekens to Texel. Twenty days after its final departure from Texel the ship was seized by the French; later that year it was recaptured by the English and taken to Plymouth, where it arrived on 09-06-1794.');
INSERT INTO "voyages" VALUES (4771, '', 1, '', 'ONDERNEMING', 'Karel Jakob Brugman', 570, NULL, NULL, '1793', NULL, 'Z', 'Z', '1794-05-05', 'Texel', '1794-09-01', '1794-10-12', true, '1794-12-01', 'Batavia', NULL, 'On 23-04-1794 the ONDERNEMING sailed from Rammekens to Texel.');
INSERT INTO "voyages" VALUES (4772, '', 1, '', 'ZUIDPOOL', 'J. A. van der Putten', 900, 'pink', '1791', NULL, NULL, 'Z', 'Z', '1794-05-05', 'Texel', '1794-08-22', '1794-09-05', true, '1795-01-01', 'Ceylon', 8397, 'On 23-04-1794 the ZUIDPOOL sailed from Rammekens to Texel.');
INSERT INTO "voyages" VALUES (4773, '', 1, '', 'BERLICUM', 'Frans Bremer', 846, NULL, NULL, NULL, NULL, NULL, 'Z', '1794-06-24', 'Texel', '1794-12-29', '1795-02-03', true, '1795-05-15', 'Batavia', NULL, 'On 23-06-1794 the BERLICUM sailed from Rammekens to Texel. On 15-02-1796 the ship was confiscated by the English at Ceylon.');
INSERT INTO "voyages" VALUES (4774, '', 1, '', 'JONGE BONIFACIUS', 'J. N. Kroese', 488, 'hoeker', NULL, NULL, NULL, NULL, 'Z', '1794-06-24', 'Texel', '1794-11-28', '1794-12-21', true, '1795-02-26', 'Batavia', 8399, 'On 23-06-1794 the JONGE BONIFACIUS sailed from Rammekens to Texel.');
INSERT INTO "voyages" VALUES (4775, '', 3, '', 'CASTOR', 'Gerard Ewoud Overbeek', 650, 'pink', NULL, '1784', NULL, 'Z', 'A', '1794-06-24', 'Texel', '1794-11-28', NULL, true, '1794-11-28', 'The Cape', NULL, 'The CASTOR was bound for the Cape. Eventually the ship was taken by the English.');
INSERT INTO "voyages" VALUES (4776, '', 4, '', 'EENSGEZINDHEID', 'Kornelis Michielsen', 884, 'fluit', NULL, NULL, NULL, NULL, 'Z', '1794-06-24', 'Texel', '1794-12-14', '1794-12-31', true, '1795-05-15', 'Batavia', NULL, 'On 23-06-1794 the EENSGEZINDHEID sailed from Rammekens to Texel. On 15-02-1796 the ship was seized by the English at Ceylon.');
INSERT INTO "voyages" VALUES (4777, '', 1, '', 'LOUISA ANTHONY', 'Kersje Hillebrandsz.', 640, 'fluit', NULL, NULL, NULL, NULL, 'A', '1794-06-24', 'Texel', NULL, NULL, true, '1795-04-03', 'Batavia', 8400, NULL);
INSERT INTO "voyages" VALUES (4778, '', 1, '', 'VERTROUWEN', 'Hillebrand van Uijen', 890, 'fluit', NULL, NULL, NULL, NULL, 'A', '1794-06-24', 'Texel', NULL, NULL, true, NULL, 'Batavia', 8401, NULL);
INSERT INTO "voyages" VALUES (4779, '', 4, '', 'MARIA LOUISA', 'L. Heikoop', 136, 'paketboot', '1788', NULL, NULL, 'A', 'D', '1794-07-10', 'Texel', NULL, NULL, true, '1795-01-24', 'Batavia', NULL, 'On 22-05-1794 the MARIA LOUISA sailed from Goeree to Texel. On 21-10-1795 the ship was captured by the English off the Cape and taken to the Cape.');
INSERT INTO "voyages" VALUES (4780, '', 3, '', 'KRAAL', 'J. C. Clemens', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1794-09-06', 'Texel', NULL, NULL, true, '1795-02-14', 'Batavia', NULL, 'wrecked.');
INSERT INTO "voyages" VALUES (4781, '', 3, '', 'RESOLUTIE', 'Daniel Hendriks', 530, NULL, NULL, '1784', NULL, 'E', 'A', '1794-09-06', 'Texel', '1795-01-15', '1795-02-18', true, '1795-05-15', 'Batavia', NULL, 'The RESOLUTIE called at Portsmouth, 09 till 11-09-1794. One source indicates, that in 1797 the ship still was in active service in the Indies.');
INSERT INTO "voyages" VALUES (4782, '', 1, '', 'NIEUWLAND', 'Johan Arkebout', 1150, NULL, '1790', NULL, NULL, 'R', 'R', '1794-12-19', 'Goeree', NULL, NULL, true, NULL, NULL, NULL, 'The NIEUWLAND was bound for China. The ship called at Duins; arrival: 19-12-1794. On 10-01-1795 the NIEUWLAND cast anchor at Plymouth; there the English put an embargo on the ship and finally confiscated it.');
INSERT INTO "voyages" VALUES (4783, '', 3, '', 'GEERTRUIDA', 'Marten de Vries', 660, 'fluit', NULL, NULL, NULL, NULL, 'A', '1794-12-22', 'Texel', '1795-05-09', NULL, true, NULL, NULL, NULL, 'In August 1795, the GEERTRUIDA was captured by the English at the Cape.');
INSERT INTO "voyages" VALUES (4784, '', 2, '', 'OOSTHUIZEN', 'Gerrit Scheler', 880, NULL, '1789', NULL, NULL, 'H', 'A', '1794-12-22', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The OOSTHUIZEN was bound for China Six days after its departure from Texel the ship called at the Scilly Islands In December 1795, the OOSTIIUIZEN was confiscated by the English.');
INSERT INTO "voyages" VALUES (4785, '', 2, '', 'VOORLAND', 'Jan Arendsz.', 1150, NULL, '1788', NULL, NULL, 'A', 'Z', '1794-12-22', 'Texel', '1795-04-12', '1795-04-28', true, '1795-07-13', 'Batavia', NULL, NULL);
INSERT INTO "voyages" VALUES (4786, '', 1, '', 'WESTERMEER', 'Kornelis Jakobsz. Schots', 656, 'fluit', NULL, NULL, NULL, NULL, 'A', '1794-12-22', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The WESTERMEER was bound for Batavia. Four days after the departure from Texel, however, the ship was seized by the French.');
INSERT INTO "voyages" VALUES (4787, '', 1, '', 'WILLEMSTAD EN BOETSELAAR', 'Simon Koter', 978, 'pink', NULL, NULL, NULL, NULL, 'A', '1794-12-22', 'Texel', '1795-05-10', NULL, true, NULL, NULL, NULL, 'The WILLEMSTAD EN BOETSELAAR was bound for Batavia. In August 1795, the ship was captured by the English at the Cape.');
INSERT INTO "voyages" VALUES (4788, '', 1, '', 'ZORG', 'Gerard Olthof', 900, 'pink', '1792', NULL, NULL, 'Z', 'Z', '1794-12-22', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'The ZORG called at Plymouth, 26-12-1794 till 04-11-1795. Three days after the departure from Plymouth the ship ran aground off Boulogne and was wrecked.');
INSERT INTO "voyages" VALUES (4789, '', 1, '', 'PRINS FREDERIK', 'Daniel Correch', 1150, NULL, '1793', NULL, NULL, 'A', 'A', '1794-12-26', 'Texel', NULL, NULL, true, NULL, NULL, NULL, 'English.');
INSERT INTO "voyages" VALUES (5014, '', 1, '', 'AMSTERDAM', 'Klaas Jansz. Melknap', 500, NULL, NULL, NULL, NULL, NULL, NULL, '1600-01-21', 'Bantam', NULL, NULL, true, '1600-09-01', 'Texel', 10, 'stayed behind under command of admiral van Warwijck and vice-admiral van Heemskerk, the AMSTERDAM and the UTRECHT under command of van Warwijck were the last to leave the Indies, From 17-05 till 21-05 off St, Helena where they could not reprovision because of the Portuguese. From 3005 till 31-05 at Ascension.');
INSERT INTO "voyages" VALUES (5015, '', 1, '', 'UTRECHT', 'Jan Martensz.', 240, NULL, NULL, NULL, NULL, NULL, NULL, '1600-01-21', 'Bantam', NULL, NULL, true, '1600-09-01', 'Texel', 16, NULL);
INSERT INTO "voyages" VALUES (5016, '', 2, '', 'FRIESLAND', 'Jakob Pietersz.', 180, 'jacht', NULL, NULL, NULL, NULL, NULL, '1601-01-14', 'Bantam', NULL, NULL, true, '1601-09-01', NULL, 31, 'Return fleet (5018 and 5016) under command of vice-admiral Jakob Willekens, which left together with the fleet of Steven van der Haghen and the fleet of Pieter Both,');
INSERT INTO "voyages" VALUES (5017, '', 1, '', 'WASSENDE MAAN', 'Kornelis Heinsz.', 500, NULL, NULL, NULL, NULL, NULL, NULL, '1601-01-14', 'Bantam', NULL, NULL, true, '1601-10-01', NULL, 28, NULL);
INSERT INTO "voyages" VALUES (5018, '', 3, '', 'MAURITIUS', 'Govert Jansz.', 460, NULL, '1594', NULL, NULL, 'A', NULL, '1601-01-14', 'Bantam', NULL, NULL, true, '1601-09-01', NULL, 34, NULL);
INSERT INTO "voyages" VALUES (5019, '', 1, '', 'MORGENSTER', 'Kornelis Jansz. Melknap', 400, NULL, NULL, NULL, NULL, NULL, NULL, '1601-01-14', NULL, NULL, NULL, true, '1601-10-01', NULL, 29, NULL);
INSERT INTO "voyages" VALUES (5020, '', 1, '', 'NASSAU', 'Frederik Kornelisz.', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1601-01-14', 'Bantam', NULL, NULL, true, NULL, NULL, 37, NULL);
INSERT INTO "voyages" VALUES (5021, '', 1, '', 'NEDERLAND', 'Ernst van Ommeren', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1601-01-14', 'Bantam', NULL, NULL, true, NULL, NULL, 38, 'Willekens.');
INSERT INTO "voyages" VALUES (5022, '', 1, '', 'ZON', 'Kornelis Jansz. Schouten', 580, NULL, NULL, NULL, NULL, NULL, NULL, '1601-01-14', 'Bantam', NULL, NULL, true, '1601-10-01', NULL, 30, 'Return fleet (5017, 5019, 5022) under command of admiral Steven van der Haghen aboard the ZON sailed together with the fleet of Pieter Both and the fleet of Jakob W illekens. From 06-07 till 12-07 at St, Helena,');
INSERT INTO "voyages" VALUES (5022, 'A', 1, '', 'MAURITIUS', NULL, 250, NULL, NULL, NULL, NULL, NULL, NULL, '1601-02-04', 'Djaratan', NULL, NULL, true, '1601-06-25', 'Maas', 27, 'the MAURITIUS was admiral Olivier van Noort, the first Dutchman who sailed around the world, On 01-05-1601 the ship passed the Cape of Good Hope; from 26 till 30-05-1601 it took on provisions at St. Helena.');
INSERT INTO "voyages" VALUES (5023, '', 1, '', 'DELFT', 'Simon Jansz. Hoen', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1601-04-01', 'Bantam', NULL, NULL, true, '1601-11-01', NULL, 42, NULL);
INSERT INTO "voyages" VALUES (5024, '', 1, '', 'HOF VAN HOLLAND', 'Jakob Dirksz.', 360, NULL, NULL, NULL, NULL, NULL, NULL, '1601-04-13', 'Bantam', NULL, NULL, true, '1601-10-11', NULL, 35, 'vice-admiral Paulus van Caerden. From 08-07 till 14-07 in the Mosselbaai; from 16-07 till 21-07 in the Vleesbaai; from 17-09 till 18-09 at St. Helena.');
INSERT INTO "voyages" VALUES (5025, '', 1, '', 'VERENIGDE LANDEN', 'Klaas Gerritsz.', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1601-04-13', 'Bantam', NULL, NULL, true, '1601-10-11', NULL, 36, NULL);
INSERT INTO "voyages" VALUES (5026, '', 3, '', 'HOLLANDIA', 'Pieter Klaasz. Nek', 460, NULL, '1594', NULL, NULL, 'A', NULL, '1601-09-09', 'Bantam', NULL, NULL, true, '1602-06-01', NULL, 32, NULL);
INSERT INTO "voyages" VALUES (5027, '', NULL, '', NULL, 'Not used', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1601-09-09', NULL, NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (5028, '', 3, '', 'OVERIJSSEL', 'Thijmen Michielz.', 50, 'jacht', '1594', NULL, NULL, 'A', NULL, '1601-09-09', 'Bantam', NULL, NULL, true, '1602-06-01', NULL, 33, NULL);
INSERT INTO "voyages" VALUES (5029, '', 2, '', 'LANGEBARK', 'Nikolaas Anthonisz.', 300, NULL, NULL, NULL, NULL, NULL, NULL, '1601-11-29', 'Atjeh', NULL, NULL, true, '1602-07-06', 'Zeeland', 47, 'Return fleet (5029-5030) under command of admiral Kornelis Bastiaansz. From 06-03 till +/- 20-03 at St. Helena where hey took the Portuguese carrack SAN JAGO, which sailed to Zeeland under command of Laurens Bicker. From 08-04 till 3-05 at Fernado Noronha.');
INSERT INTO "voyages" VALUES (5030, '', 1, '', 'ZEELANDIA', 'Kornelis Bastiaansz.', 600, NULL, NULL, NULL, NULL, NULL, NULL, '1601-11-29', 'Atjeh', NULL, NULL, true, '1602-07-06', 'Zeeland', 49, NULL);
INSERT INTO "voyages" VALUES (5031, '', 1, '', 'WITTE AREND', NULL, 600, NULL, NULL, NULL, NULL, NULL, NULL, '1601-11-29', NULL, NULL, NULL, true, NULL, NULL, 40, NULL);
INSERT INTO "voyages" VALUES (5032, '', 1, '', 'ZWARTE AREND', NULL, 600, NULL, NULL, NULL, NULL, NULL, NULL, '1601-11-29', NULL, NULL, NULL, true, NULL, NULL, 39, NULL);
INSERT INTO "voyages" VALUES (5033, '', 1, '', 'DORDRECHT', 'Dirk Mol', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1601-12-31', 'Bantam', NULL, NULL, true, '1602-11-01', NULL, 43, 'Sailed with the WITTE AREND and the ZWARTE AREND.');
INSERT INTO "voyages" VALUES (5034, '', 2, '', 'AMSTERDAM', NULL, 500, NULL, NULL, NULL, NULL, NULL, NULL, '1602-05-11', 'Bantam', NULL, NULL, true, '1603-04-01', 'Texel', 57, 'Return fleet (5034-5039) under command of Hans Schuurmans aboard the AMSTERDAM. From 22-06 till 08-09 at Mauritius; from 16-11 till 23-12 at St, Helena; from 09-01 till 22-01 at Fernando Noronha; from 27-03 till 14-04 at Falmouth.');
INSERT INTO "voyages" VALUES (5035, '', 1, '', 'ENKHUIZEN', 'Willem van Westzanen', NULL, 'jacht', NULL, NULL, NULL, NULL, NULL, '1602-05-11', 'Bantam', NULL, NULL, true, '1603-04-01', 'Texel', 58, NULL);
INSERT INTO "voyages" VALUES (5036, '', 1, '', 'HOORN', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1602-05-11', 'Bantam', NULL, NULL, true, '1603-04-01', 'Texel', 59, NULL);
INSERT INTO "voyages" VALUES (5037, '', 1, '', 'GROENE LEEUW', NULL, NULL, 'jacht', NULL, NULL, NULL, NULL, NULL, '1602-05-11', 'Bantam', NULL, NULL, true, '1603-04-01', 'Texel', 60, NULL);
INSERT INTO "voyages" VALUES (5038, '', 1, '', 'ZWARTE LEEUW', 'Adriaan Blok', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1602-05-11', 'Bantam', NULL, NULL, true, '1603-04-01', 'Texel', 63, NULL);
INSERT INTO "voyages" VALUES (5039, '', 1, '', 'DUIFJE', 'Willem Kornelisz. Schouten', 60, 'jacht', NULL, NULL, NULL, NULL, NULL, '1602-08-25', 'Bantam', NULL, NULL, true, '1603-02-17', 'Vlissingen', 52, '(5039-5041), under command of admiral W, Harmensz. and vice-admiral H. Brouwer which lost sight of the DUIFJE off Cape Agulhas. The DUIFJE sailed separately to Zeeland.');
INSERT INTO "voyages" VALUES (5040, '', 2, '', 'GELDERLAND', 'Jan Bruin', 360, NULL, NULL, NULL, NULL, NULL, NULL, '1602-08-25', 'Bantam', NULL, NULL, true, '1603-04-01', NULL, 51, 'From 23-11 till 23-12 at St, Helena; from 09-01 till 22-01 at Fernando Lorentio.');
INSERT INTO "voyages" VALUES (5041, '', 2, '', 'ZEELANDIA', 'Jan Kornelisz.', 360, NULL, NULL, NULL, NULL, NULL, NULL, '1602-08-25', 'Bantam', NULL, NULL, true, '1603-04-01', NULL, 55, 'From 25-11 till 23-12 at St, Helena; from 09-01 till 22-01 at Fernando Lorentio.');
INSERT INTO "voyages" VALUES (5042, '', 1, '', 'AMSTERDAM', 'Simon Lambrechtsz. Mau', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1602-11-01', 'Bantam', NULL, NULL, true, '1603-07-15', 'Wielingen', 41, 'Return fleet (5042-5043) under command of admiral Jakob van Neck aboard the AMSTERDAM, From 03-03 till 24-03 at St. Helena.');
INSERT INTO "voyages" VALUES (5043, '', 1, '', 'GOUDA', 'Klaas Kornelisz.', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1602-11-01', 'Bantam', NULL, NULL, true, '1603-07-15', 'Wielingen', 44, 'Gerard Le Roy. The fleet left St, Helena February 20th,');
INSERT INTO "voyages" VALUES (5044, '', 1, '', 'MIDDELBURG', 'Hans Huibrechtsz. Tonneman', 400, NULL, NULL, NULL, NULL, NULL, NULL, '1602-11-01', 'Bantam', NULL, NULL, true, '1603-05-31', 'Zeeland', 48, NULL);
INSERT INTO "voyages" VALUES (5045, '', 2, '', 'ZON', 'Kornelis Adriaansz. Valk', 140, NULL, NULL, NULL, NULL, NULL, NULL, '1602-11-01', 'Bantam', NULL, NULL, true, '1603-05-31', 'Zeeland', 50, NULL);
INSERT INTO "voyages" VALUES (5046, '', 1, '', 'EENDRACHT', 'Jan Meerman', 240, NULL, NULL, NULL, NULL, NULL, 'D', '1603-08-29', 'Bantam', NULL, NULL, true, '1604-03-24', 'Vlissingen', 79, 'From 26-11 till 29-12 at St, Helena,');
INSERT INTO "voyages" VALUES (5047, '', 1, '', 'MAAGD VAN ENKHUIZEN', 'Arnout de Valee', 320, NULL, NULL, NULL, NULL, NULL, 'E', '1603-08-30', 'Bantam', NULL, NULL, true, '1604-03-24', 'Vlissingen', 70, 'From 26-11 till 29-12 at St. Helena,');
INSERT INTO "voyages" VALUES (5048, '', 1, '', 'LAM', 'Mathias Smit', NULL, 'jacht or pinas', NULL, NULL, NULL, NULL, NULL, '1603-08-30', 'Bantam', NULL, NULL, true, '1604-03-24', 'Vlissingen', 64, 'Ship of the Compagnie van De Moucheron, at the Cape 08-11-1603; from 26-11 till 29-12 at St. Helena,');
INSERT INTO "voyages" VALUES (5049, '', 1, '', 'SCHAAP', 'Pieter Kornelisz.', 110, NULL, NULL, NULL, NULL, NULL, NULL, '1603-08-30', 'Bantam', NULL, NULL, true, '1604-03-24', 'Vlissingen', 66, 'the Compagnie van De Moucheron; at the Cape 08-11-1603; from 26-11 till 29-12 at St, Helena.');
INSERT INTO "voyages" VALUES (5050, '', 1, '', 'ALKMAAR', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1603-10-18', 'Bantam', NULL, NULL, true, NULL, NULL, 56, 'Ship of the Verenigde Compagnie; affected by shipworm and left behind in the Bay of Antongil; the cargo was taken over by the HOF VAN HOLLAND (5054)');
INSERT INTO "voyages" VALUES (5051, '', 1, '', 'WITTE LEEUW', NULL, 540, 'jacht', NULL, NULL, NULL, 'A', NULL, '1603-10-18', 'Bantam', NULL, NULL, true, '1604-07-01', NULL, 62, 'the Verenigde Compagnie.');
INSERT INTO "voyages" VALUES (5052, '', 1, '', 'MAURITIUS', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'A', '1603-10-18', 'Bantam', NULL, NULL, true, '1604-07-01', NULL, 73, NULL);
INSERT INTO "voyages" VALUES (5053, '', 1, '', 'ROTTERDAM', NULL, 800, NULL, NULL, NULL, NULL, NULL, 'R', '1603-10-18', 'Bantam', NULL, NULL, true, '1604-07-01', NULL, 81, NULL);
INSERT INTO "voyages" VALUES (5054, '', 1, '', 'HOF VAN HOLLAND', 'Willem Kornelisz. Schouten', 360, NULL, NULL, NULL, NULL, NULL, 'A', '1604-01-01', 'Madagascar', NULL, NULL, true, '1605-04-08', 'Texel', 88, 'cargo of the ALKMAAR (5050).');
INSERT INTO "voyages" VALUES (5055, '', 1, '', 'ERASMUS', NULL, 540, NULL, NULL, NULL, NULL, NULL, 'R', '1604-01-27', 'Bantam', NULL, NULL, true, '1604-08-30', NULL, 80, NULL);
INSERT INTO "voyages" VALUES (5056, '', 1, '', 'LEIDEN', 'Hendrik Jansz.', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1604-01-27', 'Bantam', NULL, NULL, true, '1604-08-30', 'Texel', 46, 'Ship of the Oude Oostindische Compagnie.');
INSERT INTO "voyages" VALUES (5057, '', 1, '', 'NASSAU', NULL, 320, NULL, NULL, NULL, NULL, NULL, 'A', '1604-01-27', 'Bantam', NULL, NULL, true, '1604-08-30', NULL, 74, NULL);
INSERT INTO "voyages" VALUES (5058, '', 1, '', 'STER', NULL, 360, NULL, NULL, NULL, NULL, NULL, 'A', '1604-01-27', 'Bantam', NULL, NULL, true, '1604-08-30', NULL, 76, NULL);
INSERT INTO "voyages" VALUES (5059, '', 1, '', 'TER GOES', NULL, 240, NULL, NULL, NULL, NULL, NULL, 'Z', '1604-04-21', 'Bantam', NULL, NULL, true, '1605-04-01', 'Zeeland', 67, 'Somewhere off the Cape from 24-08 till 07-09; from 08-11 till 14-01 at St, Helena,');
INSERT INTO "voyages" VALUES (5060, '', 1, '', 'HOLLANDSE TUIN', NULL, 360, NULL, NULL, NULL, NULL, NULL, 'A', '1604-04-21', 'Bantam', NULL, NULL, true, '1605-04-08', 'Texel', 77, 'St, Helena.');
INSERT INTO "voyages" VALUES (5061, '', 1, '', 'ZIERIKZEE', NULL, 760, NULL, NULL, NULL, NULL, NULL, 'Z', '1604-04-21', 'Bantam', NULL, NULL, true, '1605-04-01', 'Zeeland', 69, 'Reprovisioned somewhere near the Cape from 24-08 till 07-09; from 08-11 till 04-01 at St. Helena,');
INSERT INTO "voyages" VALUES (5062, '', 1, '', 'GELDERLAND', NULL, 500, NULL, NULL, NULL, NULL, NULL, 'A', '1605-08-25', 'Bantam', NULL, NULL, true, '1606-04-29', 'Texel', 87, NULL);
INSERT INTO "voyages" VALUES (5063, '', 1, '', 'GOUDA', NULL, 260, NULL, NULL, NULL, NULL, NULL, 'A', '1605-08-25', 'Bantam', NULL, NULL, true, '1606-04-28', 'Texel', 94, NULL);
INSERT INTO "voyages" VALUES (5064, '', 1, '', 'WESTFRIESLAND', 'Willem Jansz. van Amsterdam', 700, NULL, NULL, NULL, NULL, NULL, 'E', '1605-08-25', 'Bantam', NULL, NULL, true, NULL, NULL, 92, 'Ran ashore on the coast of Madagascar, 1606; the crew returned to Bantam.');
INSERT INTO "voyages" VALUES (5065, '', 1, '', 'PROVINCIEN', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'A', '1605-10-07', 'Bantam', NULL, NULL, true, '1606-07-23', 'Texel', 91, 'Reprovisioned for one month at Mauritius.');
INSERT INTO "voyages" VALUES (5066, '', 1, '', 'HOORN', NULL, 700, NULL, NULL, NULL, NULL, 'H', 'H', '1605-11-05', 'Bantam', NULL, NULL, true, '1606-07-23', 'Texel', 89, 'Reprovisioned for one month at Mauritius.');
INSERT INTO "voyages" VALUES (5067, '', 1, '', 'AMSTERDAM', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'A', '1606-02-06', 'Bantam', NULL, NULL, true, '1606-10-13', 'Goeree', 82, 'The return fleet (5067-5071) under admiraal Wybrand van Warwijck. Because of leakage the HOLLANDIA and the DOR-DRECHT were forced to stay at Mauritius from 06-04 till 04-11-1606; 28-01 till 28-02-1607 at St. Helena, The remainder of the fleet stayed from 06-04 till 21-04 at Mauritius and left under command of Daniel van der Leck: from 30-06 till 08-07 at St. Helena.');
INSERT INTO "voyages" VALUES (5068, '', 1, '', 'DORDRECHT', NULL, 900, NULL, NULL, NULL, NULL, NULL, 'Z', '1606-02-06', 'Bantam', NULL, NULL, true, '1607-06-01', 'Goeree', 84, NULL);
INSERT INTO "voyages" VALUES (5069, '', 1, '', 'HOLLANDIA', NULL, 600, NULL, NULL, NULL, NULL, 'A', 'A', '1606-02-06', 'Bantam', NULL, NULL, true, '1607-06-01', 'Texel', 71, NULL);
INSERT INTO "voyages" VALUES (5070, '', 1, '', 'VLISSINGEN', NULL, 400, NULL, NULL, NULL, NULL, NULL, 'Z', '1606-02-06', 'Bantam', NULL, NULL, true, '1606-10-13', 'Goeree', 68, NULL);
INSERT INTO "voyages" VALUES (5071, '', 1, '', 'ZEELANDIA', NULL, 500, NULL, NULL, NULL, NULL, NULL, 'A', '1606-02-06', 'Bantam', NULL, NULL, true, '1606-10-13', 'Goeree', 93, NULL);
INSERT INTO "voyages" VALUES (5072, '', 1, '', 'AMSTERDAM', 'Reinier Lambrechtsz.', 700, NULL, NULL, NULL, NULL, NULL, 'Z', '1607-06-19', 'Bantam', NULL, NULL, true, '1608-05-01', 'Texel', 103, 'Reinier Lambrechtsz. died shortly after sailing through the Sunda Strait; Olivier deVivere, the vice-admimral. died at Mauritius; departure from Mauritius October 13th.; from 19-12 till 06-01 at St. Helena,');
INSERT INTO "voyages" VALUES (5073, '', 2, '', 'WITTE LEEUW', NULL, 540, 'jacht', NULL, NULL, NULL, NULL, 'A', '1607-06-19', 'Bantam', NULL, NULL, true, '1608-05-04', 'Texel', 96, 'Departure from Mauritius October 13th.; from 15-12 till 06-01 at St. Helena.');
INSERT INTO "voyages" VALUES (5074, '', 1, '', 'MEDEMBLIK', NULL, 250, 'jacht', NULL, NULL, NULL, NULL, 'H', '1607-07-18', 'Bantam', NULL, NULL, true, '1608-05-01', NULL, 90, 'Until December 26th. at Mauritius (+- 40 days) from 21-02 till 03-03 at St. Helena,');
INSERT INTO "voyages" VALUES (5075, '', 1, '', 'ZWARTE LEEUW', NULL, 600, NULL, NULL, NULL, NULL, NULL, 'A', '1607-10-15', 'Bantam', NULL, NULL, true, '1608-08-08', 'Texel', 97, 'From 26-11 till 26-12 at Mauritius; from 21-02 till 03-03 at St. Helena; according to Muller the date of arrival in Holland is 18-03-1608.');
INSERT INTO "voyages" VALUES (5076, '', 1, '', 'GEUNIEERDE PROVINCIEN', NULL, 400, NULL, NULL, NULL, NULL, NULL, 'D', '1607-10-15', 'Bantam', NULL, NULL, true, '1608-05-01', NULL, 106, 'From 26-11 till 26-12 at Mauritius; from 21-02 till 03-03 at St. Helena.');
INSERT INTO "voyages" VALUES (5077, '', 2, '', 'MAURITIUS', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'A', '1607-12-27', 'Bantam', NULL, NULL, true, NULL, NULL, 98, 'From Bantam to Patani to take over the cargo of a Portuguese prize-ship, and lost on the coast of Guinea.');
INSERT INTO "voyages" VALUES (5078, '', 1, '', 'ORANJE', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'A', '1608-01-28', 'Bantam', '1608-04-12', '1608-04-22', true, '1608-09-02', 'Wielingen', 101, 'From 12-04 till 22-04 at Portland,');
INSERT INTO "voyages" VALUES (5079, '', 1, '', 'BANTAM', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'A', '1608-11-16', 'Bantam', NULL, NULL, true, '1609-08-07', 'Wielingen', 108, NULL);
INSERT INTO "voyages" VALUES (5080, '', 1, '', 'CEYLON', NULL, 340, NULL, NULL, NULL, NULL, 'A', 'A', '1608-11-16', 'Bantam', NULL, NULL, true, '1609-08-09', 'Texel', 109, NULL);
INSERT INTO "voyages" VALUES (5081, '', 2, '', 'ERASMUS', NULL, 540, NULL, NULL, NULL, NULL, NULL, 'R', '1608-11-16', 'Bantam', NULL, NULL, true, NULL, NULL, 105, 'Because of leakage the ERASMUS was forced to stay at Mauritius.');
INSERT INTO "voyages" VALUES (5082, '', 1, '', 'TER VEERS', 'Adriaan Maartensz.', 700, NULL, NULL, NULL, NULL, NULL, 'Z', '1608-11-16', 'Bantam', NULL, NULL, true, '1609-08-07', 'Wielingen', 112, NULL);
INSERT INTO "voyages" VALUES (5083, '', 1, '', 'GROTE ZON', NULL, 540, NULL, NULL, NULL, NULL, NULL, 'A', '1608-11-16', 'Bantam', NULL, NULL, true, NULL, NULL, 102, 'Because of leakage the GROTE ZON was forced to return to Bantam; stayed in the Indies and was broken up,');
INSERT INTO "voyages" VALUES (5084, '', 2, '', 'GOUDA', 'Jakob Gerritsz.', 260, NULL, NULL, NULL, NULL, NULL, 'A', '1608-11-20', 'Bantam', NULL, NULL, true, '1609-08-09', 'Texel', 116, 'Took over the cargo of the GROTE ZON.');
INSERT INTO "voyages" VALUES (5085, '', 1, '', 'GELDERLAND', 'Jan Jansz. Mol', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1609-05-24', 'Bantam', NULL, NULL, true, '1610-06-18', 'Texel', 1, ''' Instructed to search for the ERASMUS (5081) at Mauritius: from 02-07 till 12-11 at Mauritius; left with 48 men of the ERASMUS.');
INSERT INTO "voyages" VALUES (5086, '', 2, '', 'ZEELANDIA', 'Willem Jakobsz. van Arnemuiden', 500, NULL, NULL, NULL, NULL, NULL, 'Z', '1609-05-24', 'Bantam', NULL, NULL, true, '1610-06-01', 'Wielingen', 120, 'Via Mauritius to search for the ERASMUS (5081).');
INSERT INTO "voyages" VALUES (5087, '', 1, '', 'PATANIA', NULL, 340, NULL, NULL, NULL, NULL, 'E', 'E', '1609-10-01', 'Bantam', NULL, NULL, true, '1610-07-01', 'Enkhuizer', 111, NULL);
INSERT INTO "voyages" VALUES (5088, '', 1, '', 'BANDA', 'Kornelis Maartensz.', 600, NULL, NULL, NULL, NULL, NULL, 'A', '1610-01-10', 'Bantam', '1610-02-21', NULL, true, '1610-07-25', 'Texel', 107, 'In Saldanha Bay 14-03-1610; from 20-04 till 24-04 at St. Helena.');
INSERT INTO "voyages" VALUES (5089, '', 1, '', 'RODE LEEUW MET PIJLEN', 'Jan Walijchsz.', 400, NULL, NULL, NULL, NULL, NULL, 'A', '1610-01-10', 'Bantam', '1610-03-14', NULL, true, '1610-07-21', 'Texel', 127, 'From 20-04 till 24-04 at St. Helena.');
INSERT INTO "voyages" VALUES (5090, '', 2, '', 'ROTTERDAM', 'Jan Kornelisz. de Wit', 800, NULL, NULL, NULL, NULL, NULL, 'R', '1610-09-02', 'Bantam', NULL, NULL, true, '1611-06-30', 'Rotterdam', 130, 'Via Mauritius and St. Helena; departure from St. Helena 19-03-1611.');
INSERT INTO "voyages" VALUES (5091, '', 2, '', 'HOORN', NULL, 700, NULL, NULL, NULL, NULL, 'H', 'H', '1610-09-04', 'Bantam', NULL, NULL, true, '1611-06-28', 'Texel', 126, 'Via Mauritius and St. Helena; departure from St. Helena 19-03-1611.');
INSERT INTO "voyages" VALUES (5092, '', 2, '', 'GEUNIEERDE PROVINCIEN', 'Arend Maartensz.', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1610-11-14', 'Bantam', '1611-02-06', NULL, true, '1611-06-30', 'Texel', 129, 'From 22-02 till 19-03 at St. Helena,');
INSERT INTO "voyages" VALUES (5093, '', 2, '', 'CEYLON', 'Dirk Gerritsz.', 340, NULL, NULL, NULL, NULL, 'A', 'A', '1610-12-01', 'Mauritius', NULL, NULL, true, '1611-06-28', 'Texel', 137, 'With crew and cargo of the ERASMUS (5081); departure from St. Helena 19-03-1611.');
INSERT INTO "voyages" VALUES (5094, '', 1, '', 'DELFT', NULL, 800, NULL, NULL, NULL, NULL, 'D', 'D', '1611-02-01', 'Bantam', NULL, NULL, true, '1611-08-01', 'Goeree', 123, NULL);
INSERT INTO "voyages" VALUES (5095, '', 2, '', 'ORANJE', NULL, 700, NULL, NULL, NULL, NULL, 'Z', 'Z', '1611-02-01', 'Bantam', NULL, NULL, true, '1611-08-01', 'Zeeland', 141, NULL);
INSERT INTO "voyages" VALUES (5096, '', 1, '', 'MIDDELBURG', 'Maarten Reiniersz.', 800, NULL, NULL, NULL, NULL, 'Z', 'Z', '1611-09-24', 'Bantam', NULL, NULL, true, '1612-07-18', 'Wielingen', 118, 'From 07-11 till 24-12 at Mauritius; from 05-01 till 12-0f at St. Lucia Bay; from 03-03 till 10-03 at St. Helena.');
INSERT INTO "voyages" VALUES (5097, '', 2, '', 'HOLLANDIA', 'Pieter Pietersz. Hein.', 800, NULL, NULL, NULL, NULL, 'A', 'A', '1611-10-13', 'Bantam', NULL, NULL, true, '1612-07-19', 'Texel', 125, 'From 07-11 till 24-12 at Mauritius; from 05-01 till 12-01 at St, Lucia Bay; from 03-03 till 10-03 in St. Helena,');
INSERT INTO "voyages" VALUES (5098, '', 2, '', 'BANTAM', NULL, 700, NULL, NULL, NULL, NULL, 'E', 'E', '1612-10-15', 'Bantam', NULL, NULL, true, '1613-09-30', 'Amelander Gat', 147, 'Ran ashore, sailing through the Amelander Gat and was lost.');
INSERT INTO "voyages" VALUES (5099, '', 1, '', 'WAPEN VAN AMSTERDAM', NULL, 800, NULL, NULL, NULL, NULL, 'A', 'A', '1612-12-05', 'Bantam', NULL, NULL, true, '1613-10-01', 'Amelander Gat', 135, NULL);
INSERT INTO "voyages" VALUES (5100, '', 3, '', 'WITTE LEEUW', 'Roelof Simonsz. de Bloem', 540, 'jacht', NULL, NULL, NULL, 'A', 'A', '1612-12-05', 'Bantam', NULL, NULL, true, NULL, NULL, 139, 'Burnt in a fight with a Portuguese carrack off St. Helena, 13-06-1613; a part of the crew sailed back to Holland aboard the VLISSINGEN and the BANTAM (5098).');
INSERT INTO "voyages" VALUES (5101, '', 2, '', 'VLISSINGEN', 'Jan Kornelisz. ''t Hert', 600, NULL, NULL, NULL, NULL, 'Z', 'Z', '1612-12-05', 'Bantam', NULL, NULL, true, '1613-09-28', 'Zeeland', 142, NULL);
INSERT INTO "voyages" VALUES (5102, '', 2, '', 'ZWARTE LEEUW', NULL, 600, NULL, NULL, NULL, NULL, 'A', 'A', '1614-01-01', 'Bantam', NULL, NULL, true, '1614-08-06', 'Texel', 140, 'According to Valentijn departure on 30-12-1613,');
INSERT INTO "voyages" VALUES (5103, '', 2, '', 'TER VEERS', 'Willem Jakobsz. van Arnemuiden', 700, NULL, NULL, NULL, NULL, 'Z', 'Z', '1614-01-01', 'Bantam', NULL, NULL, true, '1614-08-03', 'Zeeland', 145, 'According to Valentijn departure on 30-12-1613.');
INSERT INTO "voyages" VALUES (5104, '', 1, '', 'HERT', 'Kornelis Kornelisz.', 280, 'jacht', NULL, NULL, NULL, 'R', 'R', '1614-11-10', 'Bantam', '1615-01-01', NULL, true, '1615-04-24', 'Rotterdam', 176, 'According to Valentijn departure on 17-10-1614.');
INSERT INTO "voyages" VALUES (5105, '', 2, '', 'BANDA', NULL, 600, NULL, NULL, NULL, NULL, NULL, 'A', '1614-12-27', 'Bantam', NULL, NULL, true, NULL, NULL, 146, 'Return fleet (5105-5108) with Pieter Both aboard the BANDA; this ship foundered on a reef in a hurricane near Mauritius; 30 deaths, including Pieter Both, 06-03-1615, wreck discovered.');
INSERT INTO "voyages" VALUES (5106, '', 2, '', 'DELFT', NULL, 800, NULL, NULL, NULL, NULL, 'D', 'D', '1614-12-27', 'Bantam', NULL, NULL, true, '1615-07-01', 'Maas', 171, 'Via Mauritius; took over the cargo of the GELDERLAND (5107) and left Mauritius 12-04-1615');
INSERT INTO "voyages" VALUES (5107, '', 2, '', 'GELDERLAND', 'Simon Lambrechtsz. Mau', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1614-12-27', 'Bantam', NULL, NULL, true, NULL, NULL, 152, 'Ran ashore in a hurricane near Mauritius and was lost, 06-03-1615.');
INSERT INTO "voyages" VALUES (5108, '', 3, '', 'GEUNIEERDE PROVINCIEN', NULL, 700, NULL, NULL, NULL, NULL, 'A', 'A', '1614-12-27', 'Bantam', NULL, NULL, true, NULL, NULL, 163, 'Foundered on a reef near Mauritius during a hurricane, 06-03-1615; 30 deaths.');
INSERT INTO "voyages" VALUES (5109, '', 1, '', 'ORANJEBOOM', 'Klaas Jansz. Ketel', 360, 'jacht', NULL, NULL, NULL, 'H', 'H', '1615-05-01', 'Mauritius', NULL, NULL, true, '1615-12-13', 'Texel', 179, 'Took over the remaining cargo of the GELDERLAND (5107).');
INSERT INTO "voyages" VALUES (5110, '', 1, '', 'GROENE ZEEUW', 'Klaas Warebouts', 140, 'jacht', NULL, NULL, NULL, 'A', 'A', '1615-10-27', 'Bantam', NULL, NULL, true, '1616-06-04', 'Texel', 153, NULL);
INSERT INTO "voyages" VALUES (5111, '', 1, '', 'WITTE BEER', NULL, 300, 'jacht', '1614', NULL, NULL, 'A', NULL, '1615-12-26', 'Bantam', NULL, NULL, true, '1616-08-30', 'Texel', 189, 'Took over the remaining cargo of the GELDERLAND (5107), BANDA (5105) and PROVINCIEN (5108) and the survivors of the GELDERLAND; from 08-02 till 08-03 at Mauritius.');
INSERT INTO "voyages" VALUES (5112, '', 3, '', 'ROTTERDAM', 'Volkert Thijsz.', 800, NULL, NULL, NULL, NULL, 'R', 'R', '1616-01-01', 'Bantam', '1616-04-20', '1616-05-12', true, '1616-09-28', 'Goeree', 160, 'Via St. Helena.');
INSERT INTO "voyages" VALUES (5113, '', 1, '', 'MAURITIUS', 'Leendert Jakobsz.', 800, NULL, '1612', NULL, NULL, 'A', 'A', '1616-01-15', 'Bantam', '1616-05-02', '1616-05-12', true, '1616-09-27', 'Zeeland', 174, 'Via St. Helena,');
INSERT INTO "voyages" VALUES (5114, '', 1, '', 'DOLFIJN', 'David Willemsz.', 280, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1616-03-31', 'Bantam', NULL, NULL, true, '1616-09-10', 'Zeeland', 191, NULL);
INSERT INTO "voyages" VALUES (5115, '', 1, '', 'ZWARTE BEER', 'Adriaan Jansz. Pater', 320, 'jacht', NULL, NULL, NULL, 'A', 'A', '1616-05-12', 'Masulipatnam', '1616-10-26', '1616-12-07', true, '1617-03-27', 'Goeree', 190, 'From 26-12 till 03-01 at St, Helena.');
INSERT INTO "voyages" VALUES (5116, '', 2, '', 'HERT', 'Jan Kornelisz. Kunst', 280, 'jacht', NULL, NULL, NULL, 'R', 'D', '1616-10-12', 'Bantam', '1616-11-29', '1616-12-07', true, '1617-03-27', 'Goeree', 204, 'From 26-12 till 03-01 at St. Helena,');
INSERT INTO "voyages" VALUES (5117, '', 1, '', 'WAPEN VAN AMSTERDAM', 'Jan Kornelisz. May', 1000, NULL, NULL, NULL, NULL, NULL, 'A', '1616-12-13', 'Bantam', NULL, NULL, true, '1617-07-02', 'Zeeland', 172, 'From 24-01 till 30-01 at Mauritius; from 02-04 till 07-04 at St. Helena.');
INSERT INTO "voyages" VALUES (5118, '', 1, '', 'ZEELANDIA', 'Kornelis Riemland', 800, NULL, NULL, NULL, NULL, 'Z', 'Z', '1616-12-13', 'Bantam', NULL, NULL, true, '1617-06-30', 'Zeeland', 170, 'According to Valentijn also called NIEUW-ZEELAND; departure from St. Helena 07-04-1617.');
INSERT INTO "voyages" VALUES (5119, '', 1, '', 'WESTFRIESLAND', NULL, 800, NULL, '1615', NULL, NULL, 'H', 'H', '1617-03-31', 'Bantam', NULL, NULL, true, '1617-10-05', 'Vlissingen', 199, NULL);
INSERT INTO "voyages" VALUES (5120, '', 2, '', 'ORANJEBOOM', NULL, 360, 'jacht', NULL, NULL, NULL, 'H', 'H', '1617-11-02', 'Bantam', NULL, NULL, true, '1618-04-13', 'Texel', 205, NULL);
INSERT INTO "voyages" VALUES (5121, '', 1, '', 'POSTPAARD', NULL, 300, 'jacht', NULL, NULL, NULL, 'E', 'E', '1617-11-06', 'Bantam', NULL, NULL, true, '1618-06-02', 'Texel', 209, NULL);
INSERT INTO "voyages" VALUES (5122, '', 1, '', 'EENDRACHT', 'Dirk Hartogs', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1617-12-17', 'Bantam', NULL, NULL, true, '1618-10-16', 'Zeeland', 201, NULL);
INSERT INTO "voyages" VALUES (5123, '', 1, '', 'ENKHUIZEN', 'Marten Geertsz.', 500, NULL, NULL, NULL, NULL, NULL, 'E', '1617-12-17', 'Bantam', '1618-03-16', '1618-03-24', true, '1618-07-24', 'Texel', 182, NULL);
INSERT INTO "voyages" VALUES (5124, '', 1, '', 'WALCHEREN', 'Pieter Klaasz.', 500, NULL, '1612', NULL, NULL, 'Z', 'Z', '1617-12-17', 'Bantam', NULL, NULL, true, '1618-10-16', 'Zeeland', 178, NULL);
INSERT INTO "voyages" VALUES (5125, '', 1, '', 'EENHOORN', 'Pieter Kornelisz.', 300, 'jacht', NULL, NULL, NULL, 'A', 'A', '1618-01-18', 'Bantam', '1618-03-17', '1618-03-24', true, '1618-07-21', 'Texel', 206, 'According to Valentijn the ship sailed from Bantam 31-12-1617.');
INSERT INTO "voyages" VALUES (5126, '', 1, '', 'WAPEN VAN ZEELAND', 'Pieter Barentsz. van Hoorn', 700, NULL, NULL, NULL, NULL, 'Z', 'Z', '1618-01-18', 'Bantam', '1618-03-17', '1618-03-24', true, '1618-07-23', 'Zeeland', 203, 'According to Valentijn this ship departed 31-12-1617.');
INSERT INTO "voyages" VALUES (5127, '', 1, '', 'GOEDE FORTUIN', 'Reinier Lambrechtsz.', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1618-03-11', 'Jacatra', NULL, NULL, true, '1618-11-15', 'Zeeland', 207, NULL);
INSERT INTO "voyages" VALUES (5128, '', 2, '', 'WITTE BEER', NULL, 300, 'jacht', '1614', NULL, NULL, 'A', 'A', '1618-06-25', 'Bantam', NULL, NULL, true, '1619-01-04', 'Zeeland', 212, NULL);
INSERT INTO "voyages" VALUES (5129, '', 1, '', 'TER THOLEN', 'Adriaan de Walle', 400, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1618-07-25', 'Bantam', NULL, NULL, true, '1619-01-22', 'Zeeland', 216, NULL);
INSERT INTO "voyages" VALUES (5130, '', 1, '', 'ZIERIKZEE', NULL, 800, NULL, NULL, NULL, NULL, 'Z', 'Z', '1618-07-25', 'Bantam', NULL, NULL, true, '1619-05-31', 'Zeeland', 211, NULL);
INSERT INTO "voyages" VALUES (5131, '', 2, '', 'MAURITIUS', 'Usbrand Kornelisz.', 800, NULL, '1612', NULL, NULL, 'A', 'A', '1618-11-12', 'Bantam', NULL, NULL, true, '1619-05-31', 'Zeeland', 218, NULL);
INSERT INTO "voyages" VALUES (5132, '', 3, '', 'DELFT', NULL, 800, NULL, NULL, NULL, NULL, 'D', 'D', '1619-01-11', 'Bantam', NULL, NULL, true, '1619-08-20', 'Goeree', 219, 'through Strait Bali to Holland via St. Helena.');
INSERT INTO "voyages" VALUES (5133, '', 2, '', 'EENHOORN', 'Gerrit Douwesz.', 300, 'jacht', NULL, NULL, NULL, 'A', 'A', '1619-08-06', 'Jacatra', '1619-10-05', '1619-10-12', true, '1620-01-20', 'Texel', 224, NULL);
INSERT INTO "voyages" VALUES (5134, '', 1, '', 'GOUDEN LEEUW', 'Gijsbrecht van Zuilen', 550, NULL, NULL, NULL, NULL, 'R', 'R', '1619-10-07', 'Jacatra', '1620-01-14', '1620-02-05', true, '1620-05-23', 'Goeree', 198, 'Helena.');
INSERT INTO "voyages" VALUES (5135, '', 2, '', 'ZWARTE BEER', 'Adriaan Jansz. Pater', 320, 'jacht', NULL, NULL, NULL, 'A', 'A', '1619-10-15', 'Coromandel', NULL, NULL, true, '1620-03-13', 'Texel', 214, NULL);
INSERT INTO "voyages" VALUES (5136, '', 1, '', 'DORDRECHT', 'Floris Heeresz.', 800, NULL, NULL, NULL, NULL, NULL, 'A', '1620-01-28', 'Jacatra', NULL, NULL, true, '1620-08-13', 'Zeeland', 223, NULL);
INSERT INTO "voyages" VALUES (5137, '', 3, '', 'ORANJEBOOM', NULL, 360, 'jacht', NULL, NULL, NULL, 'H', 'R', '1620-01-22', 'Jacatra', NULL, NULL, true, '1620-07-26', 'Goeree', 230, NULL);
INSERT INTO "voyages" VALUES (5138, '', 2, '', 'WESTFRIESLAND', 'Theunis Florisz.', 800, NULL, '1615', NULL, NULL, 'H', 'H', '1620-01-22', 'Jacatra', NULL, NULL, true, '1620-08-16', 'Zeeland', 222, NULL);
INSERT INTO "voyages" VALUES (5139, '', 3, '', 'WITTE BEER', 'Havik Klaasz. van Hillegom', 300, 'jacht', '1614', NULL, NULL, 'A', 'A', '1620-05-11', 'Jacatra', '1620-08-15', '1620-09-16', true, '1621-03-04', 'Zeeland', 233, 'Arrived at Plymouth 22-12-1620 where the English laid embargo on the ship. but it was soon released,');
INSERT INTO "voyages" VALUES (5140, '', 1, '', 'VREDE', 'Jan Willemsz.', 340, 'jacht', NULL, NULL, NULL, 'A', 'A', '1620-07-31', 'Jacatra', NULL, NULL, true, '1621-02-04', 'Zeeland', 238, 'Via Masulipatnam, 03-10-1620.');
INSERT INTO "voyages" VALUES (5141, '', 2, '', 'WALCHEREN', NULL, 500, NULL, '1612', NULL, NULL, 'Z', 'Z', '1620-10-26', 'Jacatra', NULL, NULL, true, '1621-06-11', 'Zeeland', 237, NULL);
INSERT INTO "voyages" VALUES (5142, '', 1, '', 'WAPEN VAN HOORN', NULL, 400, 'fluit', '1619', NULL, NULL, 'H', 'H', '1621-01-07', 'Jacatra', NULL, NULL, true, '1621-07-17', 'Texel', 243, NULL);
INSERT INTO "voyages" VALUES (5143, '', 3, '', 'MAURITIUS', 'Klaas Hermansz.', 800, NULL, '1612', NULL, NULL, 'A', 'A', '1621-01-07', 'Jacatra', NULL, NULL, true, '1621-09-01', NULL, 245, NULL);
INSERT INTO "voyages" VALUES (5144, '', 1, '', 'LEIDEN', 'Leendert Thomasz.', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1621-04-08', 'Jacatra', NULL, NULL, true, '1622-02-24', 'Zeeland', 241, NULL);
INSERT INTO "voyages" VALUES (5145, '', 1, '', 'MEDEMBLIK', 'Koert Geurtsz. Visser', 300, 'jacht', NULL, NULL, NULL, NULL, 'H', '1621-05-20', 'Masulipatnam', NULL, NULL, true, '1622-04-27', 'Texel', 242, 'According to Mac Leod the ship departed 27-05-1621,');
INSERT INTO "voyages" VALUES (5146, '', 1, '', 'WAPEN VAN ENKHUIZEN', NULL, 700, NULL, '1619', NULL, NULL, 'E', 'E', '1621-07-09', 'Batavia', NULL, NULL, true, '1622-02-27', 'Zeeland', 239, NULL);
INSERT INTO "voyages" VALUES (5147, '', 1, '', 'HOLLANDIA', 'Usbrand Kornelisz.', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1621-11-16', 'Batavia', NULL, NULL, true, '1622-06-24', 'Texel', 240, NULL);
INSERT INTO "voyages" VALUES (5148, '', 1, '', 'MIDDELBURG', 'Willem Jakobsz. van Amemuiden', 700, NULL, '1619', NULL, NULL, 'Z', 'Z', '1621-11-16', 'Batavia', NULL, NULL, true, '1622-06-21', 'Zeeland', 258, NULL);
INSERT INTO "voyages" VALUES (5149, '', 1, '', 'NAARDEN', 'Iwan Spluiters', 180, 'jacht', NULL, NULL, NULL, 'A', 'A', '1621-11-25', 'Batavia', '1622-01-01', NULL, true, '1622-09-01', 'Texel', 266, 'According to Mac Leod the ship departed from the Coromandel. 25-11-1621,');
INSERT INTO "voyages" VALUES (5150, '', 1, '', 'GOUDA', 'Gerard Douwesz.', 800, NULL, NULL, NULL, NULL, 'A', 'A', '1622-01-21', 'Batavia', NULL, NULL, true, '1622-09-24', 'Texel', 264, NULL);
INSERT INTO "voyages" VALUES (5151, '', 3, '', 'WESTFRIESLAND', 'Amersfoort', 800, NULL, '1615', NULL, NULL, 'H', 'Z', '1622-01-21', 'Batavia', NULL, NULL, true, '1622-08-16', 'Zeeland', 270, NULL);
INSERT INTO "voyages" VALUES (5152, '', 4, '', 'ORANJEBOOM', NULL, 360, 'jacht', NULL, NULL, NULL, 'H', 'Z', '1622-03-30', 'Batavia', NULL, NULL, true, '1622-11-01', NULL, 272, NULL);
INSERT INTO "voyages" VALUES (5153, '', 1, '', 'SCHOONHOVEN', NULL, 400, 'jacht', NULL, NULL, NULL, 'A', 'A', '1622-03-30', 'Batavia', NULL, NULL, true, '1622-12-01', 'Texel', 244, NULL);
INSERT INTO "voyages" VALUES (5154, '', 1, '', 'LEEUWIN', 'Dirk Gerritsz. Krul', 400, NULL, NULL, NULL, NULL, NULL, 'A', '1622-09-06', 'Batavia', '1623-02-06', NULL, true, '1623-05-19', 'Texel', 275, 'Via St. Helena.');
INSERT INTO "voyages" VALUES (5155, '', 2, '', 'DORDRECHT', 'Adriaan Jansz. Pater', 600, NULL, NULL, NULL, NULL, NULL, 'A', '1622-11-06', 'Masulipatnam', '1623-02-06', NULL, true, '1623-11-01', NULL, 267, 'Via St. Helena; according to Valentijn the DORDRECHT sailed from Batavia, 06-11-1622.');
INSERT INTO "voyages" VALUES (5156, '', 1, '', 'ALKMAAR', 'Mathijs Bale', 600, NULL, '1619', NULL, NULL, 'E', 'E', '1623-02-01', 'Batavia', '1623-05-12', '1623-05-18', true, '1623-09-01', 'Zeeland', 260, 'From 12-06 till 20-06 at St, Helena,');
INSERT INTO "voyages" VALUES (5157, '', 1, '', 'DELFSHAVEN', 'M. Gerritsz. Root', 400, 'jacht', '1621', NULL, NULL, 'D', 'D', '1623-02-01', 'Batavia', NULL, NULL, false, '1623-09-01', 'Zeeland', 279, 'Departure from St, Helena 20-06-1623,');
INSERT INTO "voyages" VALUES (5158, '', 4, '', 'MAURITIUS', 'Klaas Pietersz.', 800, NULL, '1612', NULL, NULL, 'A', 'A', '1623-02-01', 'Batavia', '1623-05-11', '1623-05-18', true, '1623-09-09', 'Zeeland', 282, 'From 12-06 till 20-06 at St, Helena,');
INSERT INTO "voyages" VALUES (5159, '', 3, '', 'WALCHEREN', 'Kornelis Kornelisz. ''t Hert', 500, NULL, '1612', NULL, NULL, 'Z', 'Z', '1623-02-01', 'Batavia', '1623-05-11', '1623-05-18', true, '1623-09-09', 'Zeeland', 283, 'From 12-06 till 20-06 at St, Helena,');
INSERT INTO "voyages" VALUES (5160, '', 2, '', 'GOUDEN LEEUW', 'Daniel Jansz. de Kook', 550, NULL, NULL, NULL, NULL, 'R', 'R', '1623-02-24', 'Batavia', NULL, NULL, false, '1623-10-25', 'Goeree', 274, 'DELFSHAVEN (5157) to offer help, but due to a change of wind the LEEUW was forced to leave St. Helena, without its sloop and crew.');
INSERT INTO "voyages" VALUES (5161, '', 1, '', 'SCHIEDAM', NULL, 360, NULL, NULL, NULL, NULL, 'D', 'D', '1623-04-20', 'Tegenapatnam', '1623-05-24', '1623-06-07', true, '1623-11-01', NULL, 249, 'According to Mac Leod the ship departed 25-04-1623.');
INSERT INTO "voyages" VALUES (5162, '', 1, '', 'HAAS', 'Theunis Jakobsz. Engels', 120, 'jacht', NULL, NULL, NULL, 'A', 'A', '1624-01-03', 'Batavia', NULL, NULL, true, '1624-05-31', 'Texel', 297, NULL);
INSERT INTO "voyages" VALUES (5163, '', 1, '', 'HEUSDEN', 'Jan Gijsbertsz. Booneter', 250, NULL, NULL, NULL, NULL, 'A', 'A', '1624-01-08', 'Surat', '1624-04-01', NULL, true, '1624-08-24', 'Texel', 281, 'Via Persia.');
INSERT INTO "voyages" VALUES (5164, '', 1, '', 'WAPEN VAN DELFT', 'Meeuwis Sandersz.', 700, NULL, '1620', NULL, NULL, 'D', 'D', '1624-01-31', 'Batavia', NULL, NULL, true, '1624-09-17', 'Goeree', 263, NULL);
INSERT INTO "voyages" VALUES (5165, '', 2, '', 'LEIDEN', 'Klaas Egbertsz.', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1624-01-30', 'Batavia', NULL, NULL, true, '1624-11-16', 'Zeeland', 292, NULL);
INSERT INTO "voyages" VALUES (5166, '', 2, '', 'TER THOLEN', 'Adriaan Huigensz.', 400, 'jacht', NULL, NULL, NULL, 'Z', 'A', '1624-01-30', 'Batavia', NULL, NULL, true, '1624-09-16', 'Zeeland', 236, NULL);
INSERT INTO "voyages" VALUES (5167, '', 2, '', 'SCHOONHOVEN', NULL, 400, 'jacht', NULL, NULL, NULL, 'A', 'A', '1624-08-24', 'Coromandel', NULL, NULL, true, '1625-05-29', 'Zeeland', 295, 'Via Pulicat for gunpowder: departure 12-10-1624,');
INSERT INTO "voyages" VALUES (5168, '', 2, '', 'GOUDA', 'Jan Willemsz. Dijk', 800, NULL, NULL, NULL, NULL, 'A', 'A', '1625-01-27', 'Batavia', NULL, NULL, true, NULL, NULL, 310, 'Lost in a storm near Madagascar, 18-03-1625,');
INSERT INTO "voyages" VALUES (5169, '', 2, '', 'HOLLANDIA', 'Willem IJsbrandsz. Bontekoe', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1625-01-27', 'Batavia', NULL, NULL, false, '1625-11-25', 'Vlissingen', 311, 'Return fleet (5168-5170) under command of Kornelis Reiniersz; the total number of those on board was 360, According to K.A. 994 the HOLLANDIA was in S. Lucia Bay from 27-03 till 25-04,');
INSERT INTO "voyages" VALUES (5170, '', 2, '', 'MIDDELBURG', 'Schouten', 700, NULL, '1619', NULL, NULL, 'Z', 'Z', '1625-01-27', 'Batavia', '1625-12-18', NULL, true, NULL, NULL, 290, 'via Mascarenes, arrival 01-04-1625 and from 10-04 till 25-10 in the Bay of Antongil; fougth 2 Portuguese carracks near St. Helena, afterwards lost,');
INSERT INTO "voyages" VALUES (5171, '', 3, '', 'DORDRECHT', 'Willem Jakobsz. Koster', 600, NULL, NULL, NULL, NULL, NULL, 'A', '1625-04-23', 'Surat', '1626-10-01', NULL, true, '1626-02-11', 'Texel', 309, 'Stayed for 3 months at Mauritius; according to Dunlop f 451,043,');
INSERT INTO "voyages" VALUES (5172, '', 1, '', 'WEESP', 'Dirk Klaasz.', 160, NULL, NULL, NULL, NULL, 'A', 'A', '1625-04-23', 'Surat', '1625-09-01', NULL, true, '1626-03-19', 'Texel', 250, 'Stayed for 3 months at Mauritius; forced by a heavy storm to sail to Plymouth, January 1626,');
INSERT INTO "voyages" VALUES (5173, '', 2, '', 'LEEUWIN', 'Jan Willemsz. van Oostzaner Overtoom', 400, NULL, NULL, NULL, NULL, NULL, 'A', '1625-05-25', 'Masulipatnam', '1625-09-01', '1625-11-04', true, '1626-03-21', 'Texel', 312, 'Departure from Pulicat 31-05-1625; via Mauritius, and Plymouth. because of leakage and a broken rudder after a storm, January 1626,');
INSERT INTO "voyages" VALUES (5174, '', 1, '', 'EENDRACHT', 'Jan Usbrandsz. de Jong', 600, NULL, NULL, NULL, NULL, 'A', 'E', '1625-10-25', 'Batavia', '1626-01-22', '1626-02-09', true, '1626-07-09', 'Texel', 302, 'From 24-02 till 11-03 at St. Helena; 16-06 at Plymouth. According to Daghregister the EENDRACHT left Batavia 28-10-1625,');
INSERT INTO "voyages" VALUES (5175, '', 2, '', 'WAPEN VAN HOORN', 'Pieter Gerritsz. Bierenbroodspot', 400, 'fluit', '1619', NULL, NULL, 'H', 'H', '1625-10-25', 'Batavia', '1626-01-22', '1626-02-09', true, '1626-07-09', 'Texel', 286, 'From 24-02 till 11-03 at St, Helena; 16-06 at Plymouth, According to Daghregister the HOORN left Batavia 28-10-1625.');
INSERT INTO "voyages" VALUES (5176, '', 1, '', 'KONING DAVID', 'Koert Geurtsz. Visser', 360, 'jacht', NULL, NULL, NULL, 'H', 'H', '1626-03-08', 'Masulipatnam', '1626-07-01', NULL, true, '1626-12-15', 'Maas', 300, NULL);
INSERT INTO "voyages" VALUES (5177, '', 1, '', 'AMSTERDAM', 'Leendert Jakobsz. Stolk', 800, NULL, NULL, NULL, NULL, NULL, 'A', '1626-02-02', 'Batavia', '1626-05-01', NULL, true, '1626-09-21', 'Zeeland', 298, 'according to the Daghregisrer: the departure was 05-02-1626. The AMSTERDAM was, according to the Daghregister, also called the WAPEN VAN AM-STERDAM.');
INSERT INTO "voyages" VALUES (5178, '', 1, '', 'DELFT', 'Witte Kornelisz. de With', 800, NULL, NULL, NULL, NULL, 'D', 'A', '1626-02-02', 'Batavia', '1626-05-08', NULL, true, '1626-09-01', NULL, 301, 'According to the Daghregister the DELFT was also called WAPEN VAN DELFT,');
INSERT INTO "voyages" VALUES (5179, '', 2, '', 'DELFSHAVEN', 'Jakob Pankras van Vlissingen', 400, 'jacht', '1621', NULL, NULL, 'D', 'D', '1626-02-02', 'Batavia', '1626-05-01', NULL, true, '1626-09-01', 'Maas', 314, 'Sailed separately,');
INSERT INTO "voyages" VALUES (5180, '', 1, '', 'WAPEN VAN ROTTERDAM', 'Kornelis Stuivezand', 700, NULL, '1621', NULL, NULL, 'R', 'R', '1626-02-02', 'Batavia', '1626-12-31', '1627-01-01', true, '1627-05-26', 'Goeree', 278, 'From 25-06 till 10-11-1626 in the Bay of Antongil and wandered for about 5 months between Madagascar and the Cape.');
INSERT INTO "voyages" VALUES (5181, '', 2, '', 'WAPEN VAN ENKHUIZEN', 'Gerrit Hendriksz.', 700, NULL, '1619', NULL, NULL, 'E', 'E', '1626-12-12', 'Batavia', NULL, NULL, true, '1627-07-25', 'Texel', 291, NULL);
INSERT INTO "voyages" VALUES (5182, '', 3, '', 'LEIDEN', 'Daniel Jansz. de Kook', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1626-12-12', 'Batavia', NULL, NULL, true, '1627-07-25', 'Texel', 320, NULL);
INSERT INTO "voyages" VALUES (5183, '', 3, '', 'TER THOLEN', 'Jakob Jansz. van Delftshaven', 400, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1626-12-12', 'Batavia', NULL, NULL, true, '1627-07-25', 'Texel', 322, NULL);
INSERT INTO "voyages" VALUES (5184, '', 3, '', 'GOUDEN LEEUW', NULL, 550, NULL, NULL, NULL, NULL, 'R', 'A', '1626-12-25', 'Surat', NULL, NULL, true, '1628-10-01', 'Texel', 317, 'Isle of Wight.');
INSERT INTO "voyages" VALUES (5185, '', 1, '', 'ORANJE', NULL, 700, NULL, NULL, NULL, NULL, 'R', 'Z', '1626-12-25', 'Surat', NULL, NULL, true, '1628-09-30', 'Texel', 296, 'Ship of the Nassause vloot; chained up for about one year at the Isle of Wight.');
INSERT INTO "voyages" VALUES (5186, '', 4, '', 'WALCHEREN', NULL, 500, NULL, '1612', NULL, NULL, 'Z', 'Z', '1626-12-25', 'Surat', NULL, NULL, true, '1628-10-01', 'Texel', 319, 'Chained up for 12 months and 10 days at the Isle of Wight,');
INSERT INTO "voyages" VALUES (5187, '', 2, '', 'SCHIEDAM', NULL, 360, NULL, NULL, NULL, NULL, 'D', 'A', '1626-12-27', 'Batavia', NULL, NULL, true, '1627-07-25', 'Texel', 321, NULL);
INSERT INTO "voyages" VALUES (5188, '', 2, '', 'WAPEN VAN DELFT', NULL, 700, NULL, '1620', NULL, NULL, 'D', 'D', '1627-11-06', 'Batavia', '1628-01-19', '1628-01-31', true, '1628-06-02', 'Goeree', 326, 'Via St. Helena.');
INSERT INTO "voyages" VALUES (5189, '', 1, '', 'FREDERIK HENDRIK', NULL, 1100, NULL, '1626', NULL, NULL, 'Z', 'Z', '1627-11-06', 'Batavia', '1628-01-19', '1628-01-31', true, '1628-06-02', 'Zeeland', 340, 'Via St. Helena.');
INSERT INTO "voyages" VALUES (5190, '', 1, '', 'GALIASSE', NULL, 300, NULL, NULL, NULL, NULL, 'H', 'H', '1627-11-06', 'Batavia', '1628-01-19', '1628-01-31', true, '1628-06-02', 'Texel', 341, 'Via St. Helena.');
INSERT INTO "voyages" VALUES (5191, '', 1, '', 'HOLLANDIA', NULL, 600, NULL, NULL, NULL, NULL, 'A', 'R', '1627-11-06', 'Batavia', '1628-01-19', '1628-01-31', true, '1628-06-28', 'Texel', 305, 'Helena; ship of the Nassause vloot.');
INSERT INTO "voyages" VALUES (5192, '', 3, '', 'HOLLANDIA', NULL, 700, NULL, NULL, NULL, NULL, 'A', 'A', '1627-11-06', 'Batavia', '1628-01-19', '1628-01-31', true, '1628-06-28', 'Texel', 334, 'Via St. Helena, in Valentijn mentioned as the GROOT HOLLANDIA.');
INSERT INTO "voyages" VALUES (5193, '', 4, '', 'DORDRECHT', NULL, 600, NULL, NULL, NULL, NULL, NULL, 'A', '1627-12-20', 'Surat', NULL, NULL, true, '1628-06-22', 'Texel', 336, 'cargo was f 339,674,');
INSERT INTO "voyages" VALUES (5194, '', 1, '', 'VIANEN', 'Gerrit de Wit', 400, NULL, NULL, NULL, NULL, 'A', 'A', '1628-01-06', 'Batavia', '1628-05-24', '1628-06-01', true, '1628-11-08', 'Goeree', 347, 'Because of bad trimming (rankheid) of the ship, the VIANEN returned to Batavia and sailed again 14-01 1628 via Strait Bali; via the west coast of Australia where it struck on a reef (21''S) without serious damage.');
INSERT INTO "voyages" VALUES (5195, '', 3, '', 'DELFSHAVEN', NULL, 400, 'jacht', '1621', NULL, NULL, 'D', 'R', '1628-11-03', 'Batavia', NULL, NULL, true, '1629-07-18', 'Goeree', 357, 'From 24-12 till 16-01 at Mauritius; from 19-03 till 14-04 at St, Helena,');
INSERT INTO "voyages" VALUES (5196, '', 1, '', 'NASSAU', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1628-11-03', 'Batavia', '1629-03-03', '1629-03-16', true, '1629-07-11', 'Texel', 352, 'From 24-12 till 16-01 at Mauritius; from 06-04 till 14-04 at St, Helena.');
INSERT INTO "voyages" VALUES (5197, '', 1, '', 'TER VEERE', NULL, 350, NULL, NULL, NULL, NULL, 'Z', 'Z', '1628-11-03', 'Batavia', NULL, NULL, true, '1629-07-10', 'Zeeland', 358, 'From 24-12 till 16-01 at Mauritius; from 19-03 till 14-04 at St. Helena.');
INSERT INTO "voyages" VALUES (5198, '', 1, '', 'VLISSINGEN', NULL, 350, NULL, NULL, NULL, NULL, 'Z', 'Z', '1628-11-03', 'Batavia', '1629-03-10', '1629-03-16', true, '1629-07-10', 'Zeeland', 359, 'From 26-12 till 30-01 at Mauritius; from 06-04 till 14-04 at St. Helena.');
INSERT INTO "voyages" VALUES (5199, '', 1, '', 'PRINS WILLEM', NULL, 500, NULL, NULL, NULL, NULL, 'A', 'A', '1628-11-03', 'Batavia', '1629-03-10', '1629-03-16', true, '1629-07-11', 'Texel', 356, 'From 26-12 till 30-01 at Mauritius; from 06-04 till 14-04 at St, Helena.');
INSERT INTO "voyages" VALUES (5200, '', 3, '', 'LEEUWIN', NULL, 400, NULL, NULL, NULL, NULL, NULL, 'A', '1628-11-17', 'Batavia', '1628-03-10', '1629-03-16', true, '1629-07-11', 'Texel', 344, 'From 26-12 till 30-01 at Mauritius; from 06-04 till 14-04 at St., Helena.');
INSERT INTO "voyages" VALUES (5201, '', 1, '', 'GROOTEBROEK', 'Hendrik Klaasz. van Amsterdam', 240, 'jacht', NULL, NULL, NULL, 'E', 'E', '1629-03-18', 'Batavia', NULL, NULL, true, '1629-10-12', 'Texel', 332, NULL);
INSERT INTO "voyages" VALUES (5202, '', 3, '', 'WAPEN VAN DELFT', 'Jakob Jansz. Koonekraay', 700, NULL, '1620', NULL, NULL, 'D', 'D', '1629-12-18', 'Batavia', '1630-02-17', '1630-02-27', true, '1630-07-06', 'Goeree', 374, NULL);
INSERT INTO "voyages" VALUES (5203, '', 5, '', 'DORDRECHT', 'Pauwel Kornelisz.', 600, NULL, NULL, NULL, NULL, NULL, 'A', '1629-12-18', 'Batavia', '1630-02-17', '1630-02-26', true, NULL, NULL, 369, 'Burnt on 20-04 or 30-04 at 4''33'' North.');
INSERT INTO "voyages" VALUES (5204, '', 2, '', 'GALIASSE', 'Koert Geurtsz. Visser', 300, NULL, NULL, NULL, NULL, 'H', 'H', '1629-12-18', 'Batavia', '1630-02-17', '1630-02-26', true, '1630-07-01', 'Texel', 373, 'from 17-03 till 23-03 at St. Helena. The GAL-IASSE strayed off the fleet and sailed via the Irish Sea to Holland.');
INSERT INTO "voyages" VALUES (5205, '', 2, '', 'FREDERIK HENDRIK', 'Theunis Jakobsz. Engels', 1100, NULL, '1626', NULL, NULL, 'Z', 'Z', '1629-12-18', 'Batavia', '1630-02-17', '1630-02-26', true, '1630-06-06', 'Zeeland', 376, NULL);
INSERT INTO "voyages" VALUES (5206, '', 4, '', 'HOLLANDIA', 'Klaas Hendriksz.', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1629-12-18', 'Batavia', '1630-02-17', '1630-02-26', true, '1630-06-07', 'Texel', 381, NULL);
INSERT INTO "voyages" VALUES (5207, '', 4, '', 'LEIDEN', 'Daniel Aartsz.', 700, NULL, NULL, NULL, NULL, NULL, 'A', '1629-12-18', 'Batavia', '1630-02-17', '1630-02-26', true, '1630-07-07', 'Texel', 364, NULL);
INSERT INTO "voyages" VALUES (5208, '', 2, '', 'WAPEN VAN ROTTERDAM', 'Pieter Kornelisz.', 700, NULL, '1621', NULL, NULL, 'R', 'R', '1629-12-18', 'Batavia', '1630-02-17', '1630-02-26', true, '1630-07-06', 'Goeree', 365, NULL);
INSERT INTO "voyages" VALUES (5209, '', 1, '', 'UTRECHT', 'Kornelis Jansz.', 400, NULL, NULL, NULL, NULL, 'A', 'A', '1629-12-18', 'Batavia', '1630-02-17', '1630-02-26', true, '1630-06-06', 'Texel', 346, NULL);
INSERT INTO "voyages" VALUES (5210, '', 1, '', 'VERGULDE ZEEPAARD', 'Frans Thijsz.', 400, NULL, NULL, NULL, NULL, 'Z', 'Z', '1629-12-18', 'Batavia', '1630-02-17', '1630-02-26', true, '1630-07-06', 'Zeeland', 335, NULL);
INSERT INTO "voyages" VALUES (5211, '', 4, '', 'DELFSHAVEN', 'Adriaan Tonneman', 400, 'jacht', '1621', NULL, NULL, 'D', 'A', '1631-03-08', 'Batavia', '1631-06-10', '1631-06-22', true, '1631-10-09', 'Texel', 399, 'Return fleet (5211-5217) under command of Anthonie van Diemen aboard the DEVENTER 13-07-1631 off St. Helena.');
INSERT INTO "voyages" VALUES (5212, '', 1, '', 'DEVENTER', 'Klaas Jansz. Bruin', 550, NULL, NULL, NULL, NULL, 'A', 'A', '1631-03-08', 'Batavia', '1631-06-10', '1631-06-22', true, '1631-10-01', 'Texel', 390, 'Lost off Texel.');
INSERT INTO "voyages" VALUES (5213, '', 1, '', 'EGMOND', NULL, 240, 'jacht', NULL, NULL, NULL, NULL, 'A', '1631-03-08', 'Batavia', '1631-06-10', '1631-06-22', true, '1631-10-10', 'Texel', 400, NULL);
INSERT INTO "voyages" VALUES (5214, '', 1, '', 'LEEUWARDEN', NULL, 550, NULL, '1629', NULL, NULL, 'E', 'E', '1631-03-08', 'Batavia', '1631-06-10', '1631-06-23', true, '1631-10-09', 'Amelander Gat', 389, NULL);
INSERT INTO "voyages" VALUES (5215, '', 4, '', 'LEEUWIN', NULL, 400, NULL, NULL, NULL, NULL, NULL, 'A', '1631-03-08', 'Batavia', '1631-06-10', '1631-06-22', true, '1631-10-09', 'Amelander Gat', 392, NULL);
INSERT INTO "voyages" VALUES (5216, '', 1, '', 'MIDDELBURG', 'Kornelis Kornelisz. Oole', 550, NULL, NULL, NULL, NULL, NULL, 'Z', '1631-03-08', 'Batavia', '1631-06-10', '1631-06-22', true, '1631-10-07', 'Wielingen', 396, NULL);
INSERT INTO "voyages" VALUES (5217, '', 1, '', 'WASSENAAR', '[*] Klaas Pietersz.', 240, NULL, NULL, NULL, NULL, NULL, 'A', '1631-03-08', 'Batavia', '1631-06-10', '1631-06-22', true, '1631-10-09', 'Texel', 394, NULL);
INSERT INTO "voyages" VALUES (5218, '', 3, '', 'FREDERIK HENDRIK', 'Pieter Jansz.', 1100, NULL, '1626', NULL, NULL, 'Z', 'Z', '1632-01-06', 'Batavia', '1632-04-03', '1632-04-20', true, '1632-08-06', 'Zeeland', 412, 'Return fleet (5218-5222) under command of Dirk van der Lee aboard the NASSAU.');
INSERT INTO "voyages" VALUES (5219, '', 3, '', 'GALIASSE', 'Theunis Jakobsz. Engels', 300, NULL, NULL, NULL, NULL, NULL, 'H', '1632-01-06', 'Batavia', '1632-04-03', '1632-04-20', true, '1632-08-06', 'Texel', 408, NULL);
INSERT INTO "voyages" VALUES (5220, '', 2, '', 'NASSAU', 'Daniel Aartsz.', 550, NULL, NULL, NULL, NULL, NULL, 'A', '1632-01-06', 'Batavia', '1632-04-03', '1632-04-20', true, '1632-08-06', 'Amelander Gat', 405, NULL);
INSERT INTO "voyages" VALUES (5221, '', 1, '', 'NIJMWEGEN', 'Dirk Adamsz.', 550, NULL, NULL, NULL, NULL, NULL, 'A', '1632-01-06', 'Batavia', '1632-04-03', '1632-04-20', true, '1632-08-01', NULL, 391, 'Lost near the Borkumer Rif, August 1632.');
INSERT INTO "voyages" VALUES (5222, '', 1, '', 'WEZEL', 'Laurens Gerritsz.', 550, NULL, '1629', NULL, NULL, 'A', 'A', '1632-01-06', 'Batavia', '1632-04-03', '1632-04-20', true, '1632-08-06', 'Amelander Gat', 407, NULL);
INSERT INTO "voyages" VALUES (5223, '', 1, '', '''S GRAVENHAGE', 'Jan Kornelisz.', 300, NULL, NULL, NULL, NULL, NULL, 'A', '1632-02-28', 'Surat', '1632-11-01', '1632-12-02', true, '1633-05-02', 'Texel', 370, 'Together with the TER VEERE; from Mauritius 19-05-1632 via S. Augustin where they stayed from 15-07 till 17-09. They had to wait for the return fleet at St. Helena.');
INSERT INTO "voyages" VALUES (5224, '', 2, '', 'TER VEERS', 'Jan Usbrandsz. de Jong', 350, NULL, NULL, NULL, NULL, NULL, 'Z', '1632-03-02', 'Surat', '1632-11-01', '1632-12-02', true, '1633-05-01', 'Zeeland', 401, NULL);
INSERT INTO "voyages" VALUES (5225, '', 1, '', 'AEMILIA', NULL, 600, NULL, NULL, NULL, NULL, 'Z', 'Z', '1632-12-04', 'Batavia', '1633-03-03', '1633-03-25', true, '1633-07-12', 'Zeeland', 422, 'Return fleet (5225-5229) under command of Jakob Speckx aboard the PRINS WILLEM. Via St. Helena, from 15-04 till 26-04.');
INSERT INTO "voyages" VALUES (5226, '', 5, '', 'HOLLANDIA', NULL, 700, NULL, NULL, NULL, NULL, 'A', 'A', '1632-12-04', 'Batavia', '1633-03-05', '1633-03-25', true, '1633-07-16', 'Texel', 415, NULL);
INSERT INTO "voyages" VALUES (5227, '', 1, '', 'HOORN', NULL, 550, NULL, NULL, NULL, NULL, 'H', 'H', '1632-12-04', 'Batavia', '1633-03-03', '1633-03-25', true, '1633-07-12', 'Texel', 420, NULL);
INSERT INTO "voyages" VALUES (5228, '', 3, '', 'WAPEN VAN ROTTERDAM', NULL, 700, NULL, '1621', NULL, NULL, 'R', 'R', '1632-12-04', 'Batavia', '1633-03-03', '1633-03-25', true, '1633-07-12', 'Goeree', 414, NULL);
INSERT INTO "voyages" VALUES (5229, '', 2, '', 'PRINS WILLEM', NULL, 500, NULL, NULL, NULL, NULL, 'A', 'A', '1632-12-04', 'Batavia', '1633-03-03', '1633-03-25', true, '1633-07-17', 'Texel', 406, NULL);
INSERT INTO "voyages" VALUES (5230, '', 1, '', 'ZUTPHEN', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1632-12-14', 'Batavia', '1633-03-06', '1633-03-25', true, '1633-07-16', 'Texel', 426, 'the Cape');
INSERT INTO "voyages" VALUES (5231, '', 1, '', 'AMBOINA', 'Kornelis Anthonisz.', 400, NULL, '1629', NULL, NULL, 'A', 'A', '1633-01-17', 'Surat', '1633-03-29', '1633-04-01', true, '1633-07-15', 'Texel', 3, '87 Joined the return fleet of Speckx at St. Helena.');
INSERT INTO "voyages" VALUES (5232, '', 1, '', 'HOF VAN HOLLAND', 'Aris Kornelisz. Groes', 500, NULL, NULL, NULL, NULL, NULL, NULL, '1633-11-13', 'Surat', '1634-03-16', '1634-03-20', true, '1634-07-01', 'Goeree', 397, 'Together with the LEEUWARDEN-, from 17-12 till 29-12 at Gamron; via St. Helena.');
INSERT INTO "voyages" VALUES (5233, '', 2, '', 'LEEUWARDEN', 'Rijks', 550, NULL, '1629', NULL, NULL, 'E', 'E', '1633-11-13', 'Surat', '1634-03-16', '1634-03-20', true, '1634-06-27', 'Texel', 427, NULL);
INSERT INTO "voyages" VALUES (5234, '', 3, '', 'NASSAU', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1633-12-18', 'Batavia', '1634-02-24', '1634-03-03', true, '1634-06-27', 'Texel', 435, 'Return fleet (5234-5235) under command of Willem Jansz. van Amersfoort aboard the WEZEL, sailed via St Helena.');
INSERT INTO "voyages" VALUES (5235, '', 2, '', 'WEZEL', NULL, 550, NULL, '1629', NULL, NULL, 'A', 'A', '1633-12-18', 'Batavia', '1634-02-24', '1634-03-03', true, '1634-06-27', 'Texel', 437, NULL);
INSERT INTO "voyages" VALUES (5236, '', 2, '', 'MIDDELBURG', NULL, 550, NULL, NULL, NULL, NULL, NULL, 'Z', '1633-12-21', 'Batavia', '1634-02-24', '1634-03-03', true, '1634-06-29', 'Wielingen', 433, 'Via St. Helena.');
INSERT INTO "voyages" VALUES (5237, '', 1, '', 'AMSTERDAM', 'Theunis Willemsz. Hamay', 550, NULL, '1632', NULL, NULL, 'A', 'A', '1633-12-30', 'Surat', '1634-03-08', '1634-03-09', true, '1634-06-27', 'Texel', 431, 'of Lukasz.: sailed via St. Helena.');
INSERT INTO "voyages" VALUES (5238, '', 2, '', 'VLISSINGEN', 'Jan Crijnsz.', 350, NULL, NULL, NULL, NULL, 'Z', 'Z', '1633-12-30', 'Surat', '1634-03-08', '1634-03-09', true, '1634-07-01', 'Zeeland', 402, NULL);
INSERT INTO "voyages" VALUES (5239, '', 2, '', 'EGMOND', 'Laurens Kornelisz. Verbeek', 240, 'jacht', NULL, NULL, NULL, NULL, 'A', '1634-12-25', 'Gamron', '1635-03-21', '1635-03-28', true, '1635-07-17', 'Texel', 439, 'Departure from Surat with a crew of 100 men 27-11-1634: joined at the Cape the return fleet of Pieter Vlak.');
INSERT INTO "voyages" VALUES (5240, '', 2, '', 'ZUTPHEN', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1634-12-30', 'Batavia', '1635-03-14', '1635-03-28', true, '1635-07-17', 'Texel', 448, 'Joined at the Cape the return fleet of Pieter Vlak.');
INSERT INTO "voyages" VALUES (5241, '', 3, '', 'PRINS WILLEM', NULL, 500, NULL, NULL, NULL, NULL, 'A', 'A', '1634-12-30', 'Batavia', '1635-03-16', '1635-03-28', true, '1635-07-17', 'Texel', 449, 'of Pieter Vlak.');
INSERT INTO "voyages" VALUES (5242, '', 1, '', 'ZEELANDIA', 'Denijs Anthonisz. van Drien', 600, NULL, '1631', NULL, NULL, 'Z', 'Z', '1634-12-30', 'Batavia', '1635-03-16', '1635-03-28', true, '1635-07-17', 'Wielingen', 425, NULL);
INSERT INTO "voyages" VALUES (5243, '', 1, '', 'BANDA', NULL, 550, NULL, '1633', NULL, NULL, 'A', 'A', '1635-01-05', 'Surat', '1635-03-10', '1635-03-28', true, '1635-07-17', 'Texel', 438, 'Return fleet (5243-5244) under command of Pieter Vlak aboard the BANDA; joined the fleet of Koster at the Cape. Vlak became commandeur of both fleets; from 13-04 till 20-04 at St. Helena.');
INSERT INTO "voyages" VALUES (5244, '', 1, '', '''S HERTOGENBOSCH', NULL, 600, NULL, '1631', NULL, NULL, 'D', 'D', '1635-01-05', 'Surat', '1635-03-10', '1635-03-28', true, '1635-07-17', 'Goeree', 421, NULL);
INSERT INTO "voyages" VALUES (5245, '', 2, '', 'AMSTERDAM', 'Pieter Dirksz.van Wieringen', 550, NULL, '1632', NULL, NULL, 'A', 'A', '1636-01-05', 'Batavia', '1636-03-09', '1636-04-02', true, '1636-07-31', 'Texel', 451, 'Return fleet (5245-5250), under command of Hendrik Brouwer, at the Cape joining the FREDERIK HENDRIK (5251) and at St. Helena probably the AMBOINA (5252); at St. Helena from 16-04 till 30-04.');
INSERT INTO "voyages" VALUES (5246, '', 6, '', 'HOLLANDIA', 'Willem Kornelisz. van Domburg', 700, NULL, NULL, NULL, NULL, 'A', 'A', '1636-01-05', 'Batavia', '1636-03-09', '1636-04-02', true, '1636-07-31', 'Texel', 461, NULL);
INSERT INTO "voyages" VALUES (5247, '', 2, '', 'HOORN', 'Lornelis Simonsz. van der Veer', 550, NULL, NULL, NULL, NULL, 'H', 'H', '1636-01-05', 'Batavia', '1636-03-09', '1636-04-02', true, '1636-07-31', 'Texel', 440, NULL);
INSERT INTO "voyages" VALUES (5248, '', 1, '', 'MAASTRICHT', 'Kornelis Frederiksz. Stuivesant', 600, NULL, NULL, NULL, NULL, 'R', 'R', '1636-01-05', 'Batavia', '1636-03-09', '1636-04-02', true, '1636-07-31', 'Goeree', 455, NULL);
INSERT INTO "voyages" VALUES (5249, '', 4, '', 'NASSAU', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1636-01-05', 'Batavia', '1636-03-09', '1636-04-02', true, '1636-07-31', 'Texel', 462, NULL);
INSERT INTO "voyages" VALUES (5250, '', 3, '', 'WEZEL', 'Jakob Jansz. van Enkhuizen', 550, NULL, '1629', NULL, NULL, 'A', 'A', '1636-01-05', 'Batavia', '1636-03-09', '1636-04-02', true, '1636-07-31', 'Texel', 463, NULL);
INSERT INTO "voyages" VALUES (5251, '', 4, '', 'FREDERIK HENDRIK', NULL, 1100, NULL, '1626', NULL, NULL, 'Z', 'Z', '1636-01-10', 'Surat', '1636-03-17', '1636-04-02', true, '1636-08-04', 'Wielingen', 442, NULL);
INSERT INTO "voyages" VALUES (5252, '', 2, '', 'AMBOINA', 'Klaas Jansz. Bruin', 400, NULL, '1629', NULL, NULL, 'A', 'A', '1636-02-09', 'Surat', '1636-05-06', '1636-05-11', true, '1636-10-16', 'Texel', 450, 'return fleet probably off St. Helena; master died 27-08 at Shetland Isl.');
INSERT INTO "voyages" VALUES (5253, '', 2, '', 'BANDA', 'Mathijs Hendriksz. Kwast', 550, NULL, '1633', NULL, NULL, 'A', 'A', '1636-12-29', 'Batavia', '1637-03-30', '1637-04-05', true, '1637-08-01', 'Texel', 464, 'Return fleet (5253-5257) under command of Hans Puntmans aboard the BANDA; from 21-04 till 15-05 at St. Helena');
INSERT INTO "voyages" VALUES (5254, '', 3, '', 'LEEUWARDEN', NULL, 550, NULL, '1629', NULL, NULL, 'E', 'E', '1636-12-29', 'Batavia', '1637-05-04', NULL, true, '1637-10-31', 'Texel', 454, 'According to the Daghregister the cargo was f 268,960.');
INSERT INTO "voyages" VALUES (5255, '', 4, '', 'PRINS WILLEM', 'Laurens Kornelisz. Verbeek', 500, NULL, NULL, NULL, NULL, 'A', 'A', '1636-12-29', 'Batavia', NULL, NULL, true, NULL, NULL, 475, 'Ran ashore in the Sunda Strait, off Varkenseiland, 02-01-1637, Part of the cargo was lost, crew saved and ship broken up.');
INSERT INTO "voyages" VALUES (5256, '', 2, '', 'ZEELANDIA', NULL, 600, NULL, '1631', NULL, NULL, 'Z', 'Z', '1636-12-29', 'Batavia', '1637-03-30', '1637-04-05', true, '1637-08-02', 'Wielingen', 479, 'Also called NIEUW-ZEELAND.');
INSERT INTO "voyages" VALUES (5257, '', 3, '', 'ZUTPHEN', 'Theunis Jansz.', 550, NULL, NULL, NULL, NULL, 'A', 'A', '1636-12-29', 'Batavia', '1637-05-03', '1637-05-15', true, '1638-01-02', 'Zeeland', 476, NULL);
INSERT INTO "voyages" VALUES (5258, '', 1, '', 'ENKHUIZEN', 'Jan Eversz.', 700, NULL, NULL, NULL, NULL, NULL, 'E', '1637-01-10', 'Batavia', '1637-05-13', '1637-05-20', true, '1637-10-30', 'Texel', 474, 'Sailed together with the return fleet of Puntmans.');
INSERT INTO "voyages" VALUES (5259, '', 2, '', 'AEMILIA', 'Aris Kornelisz. Groes', 600, NULL, NULL, NULL, NULL, 'Z', 'Z', '1637-01-20', 'Gamron', '1637-04-21', '1637-04-25', true, '1637-08-17', 'Wielingen', 457, 'Sailed together with the ZWOLLE.');
INSERT INTO "voyages" VALUES (5260, '', 1, '', 'ZWOLLE', NULL, 360, NULL, NULL, NULL, NULL, 'A', 'A', '1637-01-20', 'Gamron', '1637-04-19', '1637-04-25', true, '1637-08-16', 'Texel', 469, 'Sailed together with the AEMILIA.');
INSERT INTO "voyages" VALUES (5261, '', 1, '', 'HAARLEM', NULL, 500, NULL, NULL, NULL, NULL, 'A', 'A', '1637-12-10', 'Batavia', '1638-02-20', '1638-03-16', true, '1638-07-17', 'Texel', 480, 'Return fleet (5261-5266) under command of Artus Gijsels aboard the WEZEL; from 01-04 till 25-04 at St. Heiena.');
INSERT INTO "voyages" VALUES (5262, '', 2, '', 'HOF VAN HOLLAND', NULL, 500, NULL, NULL, NULL, NULL, 'D', 'D', '1637-12-10', 'Batavia', '1638-02-20', '1638-03-16', true, '1638-07-18', 'Goeree', 458, NULL);
INSERT INTO "voyages" VALUES (5263, '', 7, '', 'HOLLANDIA', NULL, 700, NULL, NULL, NULL, NULL, 'A', 'H', '1637-12-10', 'Batavia', '1638-02-20', '1638-03-16', true, '1638-07-17', 'Texel', 481, NULL);
INSERT INTO "voyages" VALUES (5264, '', 5, '', 'NASSAU', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1637-12-10', 'Batavia', '1638-02-20', '1638-03-16', true, '1638-07-17', 'Texel', 482, NULL);
INSERT INTO "voyages" VALUES (5265, '', 4, '', 'WEZEL', NULL, 550, NULL, '1629', NULL, NULL, 'A', 'A', '1637-12-10', 'Batavia', '1638-02-20', '1638-03-16', true, '1638-07-17', 'Texel', 483, NULL);
INSERT INTO "voyages" VALUES (5266, '', 3, '', 'MIDDELBURG', NULL, 550, NULL, NULL, NULL, NULL, NULL, 'Z', '1637-12-18', 'Batavia', '1638-03-26', '1638-04-01', true, '1638-07-18', 'Wielingen', 471, 'Joined the return fleet of Gijsels at St. Helena on 16-04.');
INSERT INTO "voyages" VALUES (5267, '', 3, '', 'AMSTERDAM', 'Hendrik Hagenaar', 550, NULL, '1632', NULL, NULL, 'A', 'A', '1638-01-04', 'Batavia', '1638-03-17', '1638-03-21', true, '1638-07-17', 'Texel', 485, 'Joined the return fleet of Gijsels at St. Helena and stayed there from 06-04 till 25-04.');
INSERT INTO "voyages" VALUES (5268, '', 5, '', 'FREDERIK HENDRIK', NULL, 1100, NULL, '1626', NULL, NULL, 'Z', 'Z', '1638-12-23', 'Batavia', '1639-02-19', NULL, true, '1639-07-21', 'Wielingen', 492, 'Return fleet (5268-5272) under command of Jochem Roelofsz. van Deutekom aboard the ZUTPHEN. The fleet sailed via St. Helena.');
INSERT INTO "voyages" VALUES (5269, '', 1, '', 'NOORDSTER', NULL, 200, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1638-12-23', 'Batavia', '1639-02-19', '1639-03-01', true, '1639-07-20', 'Texel', 504, NULL);
INSERT INTO "voyages" VALUES (5270, '', 4, '', 'ZUTPHEN', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1638-12-23', 'Batavia', '1639-02-19', '1639-03-01', true, '1639-07-20', 'Texel', 509, NULL);
INSERT INTO "voyages" VALUES (5271, '', 3, '', 'AMBOINA', NULL, 550, NULL, '1629', NULL, NULL, 'A', 'A', '1638-12-31', 'Batavia', '1639-03-08', '1639-03-14', true, '1639-07-20', 'Texel', 506, NULL);
INSERT INTO "voyages" VALUES (5272, '', 2, '', 'MAASTRICHT', 'Valk', 600, NULL, NULL, NULL, NULL, 'R', 'R', '1638-12-31', 'Batavia', NULL, NULL, true, '1639-07-21', 'Goeree', 488, NULL);
INSERT INTO "voyages" VALUES (5273, '', 1, '', 'AKERSLOOT', NULL, 360, 'jacht', '1636', NULL, NULL, 'A', 'A', '1639-01-13', 'Batavia', '1639-03-29', '1639-04-06', true, '1639-08-01', 'Texel', 484, 'Return fleet (5273-5274) under command of Karel Reiniers aboard the ZW OLLE, sailed via St. Helena.');
INSERT INTO "voyages" VALUES (5274, '', 3, '', 'ZEELANDIA', NULL, 600, NULL, '1631', NULL, NULL, 'Z', 'Z', '1639-01-13', 'Batavia', '1639-03-29', '1639-04-06', true, '1639-08-01', NULL, 502, NULL);
INSERT INTO "voyages" VALUES (5275, '', 2, '', 'ZWOLLE', NULL, 360, NULL, NULL, NULL, NULL, 'A', 'A', '1639-01-13', 'Batavia', '1639-03-29', '1639-04-06', true, '1639-08-01', 'Texel', 498, 'Wrecked off Texel.');
INSERT INTO "voyages" VALUES (5276, '', 4, '', 'AMSTERDAM', NULL, 550, NULL, '1632', NULL, NULL, 'A', 'A', '1639-12-12', 'Batavia', '1640-03-22', '1640-03-25', true, '1640-07-22', 'Texel', 513, 'under command of Koekebakker aboard the AMSTERDAM; from 12-04 till 25-04 at St. Helena, where they joined the return fleet of Schouten. The fleet was under command of Koekebakker.');
INSERT INTO "voyages" VALUES (5277, '', 2, '', 'ENKHUIZEN', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'E', '1639-12-18', 'Batavia', '1640-03-22', '1640-03-25', true, '1640-07-22', 'Texel', 511, NULL);
INSERT INTO "voyages" VALUES (5278, '', 1, '', 'HARDERWIJK', NULL, 400, NULL, NULL, NULL, NULL, 'A', 'A', '1639-12-18', 'Batavia', '1640-03-22', '1640-03-25', true, '1640-07-22', 'Texel', 466, NULL);
INSERT INTO "voyages" VALUES (5279, '', 1, '', 'HENRIETTE LOUISE', NULL, 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1639-12-18', 'Batavia', '1640-03-22', '1640-05-25', true, '1640-07-24', 'Wielingen', 493, NULL);
INSERT INTO "voyages" VALUES (5280, '', 1, '', 'BREDA', NULL, 400, NULL, '1637', NULL, NULL, 'H', 'H', '1640-01-08', 'Batavia', '1640-03-13', '1640-03-16', true, '1640-07-22', 'Texel', 510, 'Return fleet (5280-5282) under command of Kornelis Schouten aboard the MARIA DE MEDICI joined the return fleet of Koekebakker at St. Helena; Schouten became vice-commandeur.');
INSERT INTO "voyages" VALUES (5281, '', 1, '', 'MARIA DE MEDICI', NULL, 700, NULL, NULL, NULL, NULL, 'A', 'A', '1640-01-08', 'Batavia', '1640-03-13', '1640-03-16', true, '1640-07-22', 'Texel', 529, 'From 05-04 till 25-04 at St. Helena. At the Cape 33 survivors of the KONING DAVID (0524) were taken on board of the fleet.');
INSERT INTO "voyages" VALUES (5282, '', 5, '', 'WEZEL', NULL, 550, NULL, '1629', NULL, NULL, 'A', 'A', '1640-01-08', 'Batavia', '1640-03-13', '1640-03-16', true, '1640-07-22', 'Texel', 531, NULL);
INSERT INTO "voyages" VALUES (5283, '', 2, '', '''S HERTOGENBOSCH', NULL, 600, NULL, '1631', NULL, NULL, 'D', 'D', '1640-01-11', 'Negombo', '1640-03-21', '1640-03-25', true, '1640-07-22', 'Goeree', 487, 'Joined the return fleet of Koekebakker at the Cape.');
INSERT INTO "voyages" VALUES (5284, '', 6, '', 'NASSAU', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'Z', '1640-01-31', 'Batavia', '1640-04-15', '1640-04-20', true, '1640-08-15', 'Zeeland', 530, 'Sailed together with the PETTEN.');
INSERT INTO "voyages" VALUES (5285, '', 1, '', 'PETTEN', NULL, 200, 'fluit', NULL, NULL, NULL, 'A', 'A', '1640-01-31', 'Batavia', '1640-04-14', '1640-04-20', true, '1640-08-12', 'Texel', 445, NULL);
INSERT INTO "voyages" VALUES (5286, '', 3, '', 'BANDA', NULL, 550, NULL, '1633', NULL, NULL, 'A', 'A', '1640-12-01', 'Batavia', '1641-02-02', NULL, true, '1641-04-01', NULL, 512, 'Portuguese prisoners on board.');
INSERT INTO "voyages" VALUES (5287, '', 6, '', 'FREDERIK HENDRIK', NULL, 1100, NULL, '1626', NULL, NULL, 'Z', 'Z', '1640-12-01', 'Batavia', '1641-02-02', NULL, true, '1641-06-17', 'Wielingen', 546, 'With 17 Portuguese prisoners on board.');
INSERT INTO "voyages" VALUES (5288, '', 4, '', 'LEEUWARDEN', NULL, 700, NULL, '1629', NULL, NULL, 'E', 'E', '1640-12-01', 'Batavia', '1641-02-02', NULL, true, '1641-06-29', 'Texel', 518, 'With 13 Portuguese prisoners on board.');
INSERT INTO "voyages" VALUES (5289, '', 4, '', 'MIDDELBURG', NULL, 550, NULL, NULL, NULL, NULL, NULL, 'Z', '1640-12-01', 'Batavia', '1641-02-02', NULL, true, '1641-06-17', 'Wielingen', 521, 'With 14 Portuguese prisoners on board.');
INSERT INTO "voyages" VALUES (5290, '', 1, '', 'SALAMANDER', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1640-12-01', 'Batavia', '1641-02-02', NULL, true, '1641-06-29', 'Texel', 553, ', With 11 Portuguese prisoners on board.');
INSERT INTO "voyages" VALUES (5291, '', 5, '', 'ZUTPHEN', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1640-12-01', 'Batavia', '1641-02-02', NULL, true, '1641-06-29', 'Texel', 544, 'With 12 Portuguese prisoners on board.');
INSERT INTO "voyages" VALUES (5292, '', 1, '', 'BERKHOUT', 'Wopke Sipkes', 400, 'fluit', '1639', NULL, NULL, 'H', 'H', '1641-01-09', 'Batavia', '1641-06-25', '1641-06-28', true, '1642-04-08', 'Texel', 536, 'Return fleet (5292-5294) under command of Kornelis Jansz. Silvius aboard the HAARLEM. The BERKHOUT was also called BERKEL. Because of a gale from 23-03 till 08-05 at Mauritius; via St. Helena.');
INSERT INTO "voyages" VALUES (5293, '', 2, '', 'HAARLEM', NULL, 500, NULL, NULL, NULL, NULL, 'A', 'A', '1641-01-09', 'Batavia', '1641-12-01', '1642-01-06', true, '1642-07-31', 'Texel', 516, 'The master Adriaan Tonneman died 09-06 and was succeeded by Andries Adriaansz. Because of a gale from 22-03 till 28-10 at Mauritius; from 24-01-1642 till 23-03 at St. Helena.');
INSERT INTO "voyages" VALUES (5294, '', 3, '', 'MAASTRICHT', NULL, 600, NULL, NULL, NULL, NULL, 'R', 'R', '1641-01-09', 'Batavia', NULL, NULL, true, '1641-09-01', NULL, 548, NULL);
INSERT INTO "voyages" VALUES (5295, '', 1, '', 'HEEMSTEDE', NULL, 400, 'fluit', NULL, NULL, NULL, 'A', 'A', '1641-02-01', 'Batavia', '1641-04-22', NULL, true, '1641-07-01', NULL, 551, 'Sailed alone.');
INSERT INTO "voyages" VALUES (5296, '', 2, '', 'BREDA', NULL, 1050, NULL, '1637', NULL, NULL, 'H', 'H', '1641-12-13', 'Batavia', '1642-02-20', '1642-03-23', true, '1642-07-31', 'Texel', 564, 'Return fleet (5296-5300) under command of Francois Caron aboard the VOGELSTRUIS. From 11-04 till 24-04 at St. Helena.');
INSERT INTO "voyages" VALUES (5297, '', 1, '', 'WITTE OLIFANT', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1641-12-13', 'Batavia', '1642-02-20', '1643-03-23', true, '1642-07-31', 'Texel', 533, NULL);
INSERT INTO "voyages" VALUES (5298, '', 1, '', 'VERENIGDE PROV INCIEN', NULL, 1100, NULL, '1640', NULL, NULL, 'Z', 'Z', '1641-12-13', 'Batavia', '1642-02-20', '1642-03-23', true, '1642-08-02', 'Wielingen', 569, NULL);
INSERT INTO "voyages" VALUES (5299, '', 1, '', 'VOGELSTRIUIS', NULL, 1000, NULL, '1640', NULL, NULL, NULL, 'A', '1641-12-13', 'Batavia', '1642-02-20', '1642-03-23', true, '1642-07-31', 'Texel', 570, NULL);
INSERT INTO "voyages" VALUES (5300, '', 4, '', 'ZEELANDIA', NULL, 600, NULL, '1631', NULL, NULL, 'Z', 'Z', '1641-12-13', 'Batavia', '1642-02-20', '1642-03-23', true, '1642-08-02', 'Wielingen', 545, NULL);
INSERT INTO "voyages" VALUES (5301, '', 1, '', 'SNOEK', NULL, 560, 'jacht', NULL, NULL, NULL, 'A', 'A', '1641-12-29', 'Batavia', '1642-03-08', '1642-03-23', true, '1642-08-01', 'Texel', 539, 'Joined, together with the WALVIS. the return fleet of Caron at the Cape.');
INSERT INTO "voyages" VALUES (5302, '', 1, '', 'WALVIS', NULL, 1000, NULL, '1639', NULL, NULL, NULL, 'A', '1641-12-29', 'Batavia', '1642-03-15', '1642-03-23', true, '1642-07-31', 'Texel', 554, 'Joined, together with the SNOEK, the return fleet of Caron at the Cape.');
INSERT INTO "voyages" VALUES (5303, '', 5, '', 'AMSTERDAM', NULL, 550, NULL, '1632', NULL, NULL, 'A', 'A', '1642-01-11', 'Batavia', '1642-03-30', NULL, true, '1642-07-31', 'Texel', 560, 'Joined, together with the WEZEL, the return fleet of Caron at St. Helena; from 17-04 till 24-04 at St. Helena.');
INSERT INTO "voyages" VALUES (5304, '', 6, '', 'WEZEL', NULL, 550, NULL, '1629', NULL, NULL, 'A', 'A', '1642-01-11', 'Batavia', '1642-03-30', NULL, true, '1642-07-31', 'Texel', 571, 'Joined, together with the AMSTERDAM the return fleet of Caron at St. Helena; from 18-04 till 24-04 at St. Helena.');
INSERT INTO "voyages" VALUES (5305, '', 3, '', 'ENKHUIZEN', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'E', '1642-12-13', 'Batavia', '1643-02-24', '1643-03-11', true, '1643-07-10', 'Texel', 565, 'Return fleet (5305-5313, except 5307, with 1050 men on board at departure) under command of Karel Hartsing aboard the VREDE. From 30-03 till 12-04 at St. Helena.');
INSERT INTO "voyages" VALUES (5306, '', 2, '', 'HENRIETTE LOUISE', NULL, 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1642-12-13', 'Batavia', NULL, NULL, true, '1643-07-17', 'Wielingen', 568, NULL);
INSERT INTO "voyages" VALUES (5307, '', 3, '', '''S HERTOGENBOSCH', NULL, 600, NULL, '1631', NULL, NULL, 'D', 'D', '1642-12-13', 'Batavia', NULL, NULL, true, '1643-07-15', 'Texel', 566, 'Joined the return fleet of Hartsing at St. Helena. Broken up in 1643.');
INSERT INTO "voyages" VALUES (5308, '', 5, '', 'MIDDELBURG', NULL, 550, NULL, NULL, NULL, NULL, NULL, 'Z', '1642-12-13', 'Batavia', '1643-03-11', NULL, true, '1643-07-17', 'Wielingen', 587, NULL);
INSERT INTO "voyages" VALUES (5309, '', 1, '', 'TIJGER', NULL, 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1642-12-13', 'Batavia', '1643-03-11', NULL, true, '1643-07-09', 'Texel', 576, NULL);
INSERT INTO "voyages" VALUES (5310, '', 1, '', 'VREDE', NULL, 800, NULL, '1641', NULL, NULL, 'A', 'A', '1642-12-13', 'Batavia', '1643-03-11', NULL, true, '1643-07-09', 'Texel', 581, NULL);
INSERT INTO "voyages" VALUES (5311, '', 1, '', 'WESTFRIESLAND', NULL, 1100, NULL, '1641', NULL, NULL, 'H', 'H', '1642-12-13', 'Batavia', '1643-03-02', '1643-03-11', true, '1643-07-09', 'Texel', 582, NULL);
INSERT INTO "voyages" VALUES (5312, '', 7, '', 'NASSAU', NULL, 550, NULL, NULL, NULL, NULL, 'A', 'A', '1642-12-24', 'Batavia', '1643-02-22', '1643-03-11', true, '1643-07-09', 'Texel', 575, NULL);
INSERT INTO "voyages" VALUES (5313, '', 6, '', 'ZUTPHEN', 'Karel Hartsing', 550, NULL, NULL, NULL, NULL, 'A', 'A', '1642-12-24', 'Batavia', '1643-03-11', NULL, true, '1643-07-09', 'Texel', 595, NULL);
INSERT INTO "voyages" VALUES (5314, '', 1, '', 'ROTTERDAM', NULL, 1100, NULL, NULL, NULL, NULL, 'R', 'R', '1643-01-14', 'Batavia', NULL, NULL, true, '1643-07-21', 'Goeree', 572, 'Joined the return fleet of Hartsing at St. Helena where the ship arrived April 5th.');
INSERT INTO "voyages" VALUES (5315, '', 3, '', 'BREDA', NULL, 1050, NULL, '1637', NULL, NULL, 'H', 'H', '1643-12-23', 'Batavia', '1644-03-22', '1644-03-27', true, '1644-08-19', 'Texel', 600, 'Return fleet (5315-5319 with 711 men on board at departure) under command of Anthonie Caan aboard the W ALVIS and Jan Dirksz. Gale aboard the HOF VAN ZEELAND. Via St. Helena.');
INSERT INTO "voyages" VALUES (5316, '', 2, '', 'VERENIGDE PROVINCIEN', NULL, 1100, NULL, '1640', NULL, NULL, 'Z', 'Z', '1643-12-23', 'Batavia', NULL, NULL, true, '1644-08-19', 'Texel', 604, NULL);
INSERT INTO "voyages" VALUES (5317, '', 2, '', 'VOGELSTRUIS', NULL, 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1643-12-23', 'Batavia', '1644-03-22', '1644-03-27', true, '1644-08-19', 'Texel', 596, NULL);
INSERT INTO "voyages" VALUES (5318, '', 2, '', 'WALVIS', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1643-12-23', 'Batavia', '1644-02-21', '1644-03-02', true, '1644-08-19', 'Texel', 608, NULL);
INSERT INTO "voyages" VALUES (5319, '', 1, '', 'HOF VAN ZEELAND', NULL, 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1643-12-23', 'Batavia', '1644-02-21', '1644-03-02', true, '1644-08-19', 'Wielingen', 605, NULL);
INSERT INTO "voyages" VALUES (5320, '', 2, '', 'SALAMANDER', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1644-01-05', 'Batavia', NULL, NULL, true, '1644-09-01', NULL, 593, 'Sailed alone.');
INSERT INTO "voyages" VALUES (5321, '', 5, '', 'LEEUWARDEN', NULL, 550, NULL, '1629', NULL, NULL, 'E', 'E', '1644-01-10', 'Batavia', '1644-04-11', '1644-04-13', true, '1644-06-01', 'Texel', 586, 'Sailed alone.');
INSERT INTO "voyages" VALUES (5322, '', 1, '', 'DELFT', 'Hendrik Dirksz. Platvoet', 670, NULL, '1641', NULL, NULL, 'D', 'D', '1644-12-24', 'Batavia', NULL, NULL, true, '1645-08-01', 'Goeree', 584, 'Total number of those on board 658.');
INSERT INTO "voyages" VALUES (5323, '', 1, '', 'MALAKKA', 'Simon Douwesz.', 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1644-12-24', 'Batavia', NULL, NULL, true, '1645-07-24', 'Texel', 607, NULL);
INSERT INTO "voyages" VALUES (5324, '', 2, '', 'WITTE OLIFANT', 'Jan IJsbrandsz.', 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1644-12-24', 'Batavia', NULL, NULL, true, '1645-07-24', 'Texel', 601, NULL);
INSERT INTO "voyages" VALUES (5325, '', 1, '', 'ORANJE', 'Willem Kornelisz. van Domburg', 700, NULL, '1643', NULL, NULL, 'Z', 'Z', '1644-12-24', 'Batavia', NULL, NULL, true, '1645-07-26', 'Wielingen', 623, NULL);
INSERT INTO "voyages" VALUES (5326, '', 5, '', 'ZEELANDIA', 'Pieter Anthonisz.', 600, NULL, '1631', NULL, NULL, 'Z', 'Z', '1644-12-24', 'Batavia', NULL, NULL, true, '1645-07-26', 'Wielingen', 609, NULL);
INSERT INTO "voyages" VALUES (5327, '', 4, '', 'BANDA', 'Huig Adriaansz.', 550, NULL, '1633', NULL, NULL, 'A', 'A', '1645-01-19', 'Batavia', '1645-03-30', '1645-04-03', true, '1645-07-24', 'Texel', 577, 'Together with HAARLEM under command of Jan van Elserak; met the fleet of Krook at St. Helena. Elserak became vice-commandeur aboard the ZEELANDIA. The fleet left 26-04.');
INSERT INTO "voyages" VALUES (5328, '', 3, '', 'HAARLEM', 'Klaas Vis', 500, NULL, NULL, NULL, NULL, 'A', 'A', '1645-01-19', 'Batavia', '1645-03-30', '1645-04-03', true, '1645-07-24', 'Texel', 606, NULL);
INSERT INTO "voyages" VALUES (5329, '', 1, '', 'POST', 'Dirk Gerritsz. Jongeveld', 220, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1645-07-12', 'Batavia', NULL, NULL, true, '1645-12-01', NULL, 631, '''Adviesschip'' sailed via La Rochelle, where it waited for a convoy to Holland.');
INSERT INTO "voyages" VALUES (5330, '', 4, '', 'ENKHUIZEN', 'Jack Harkesz.', 700, NULL, NULL, NULL, NULL, NULL, 'E', '1645-12-18', 'Batavia', NULL, NULL, true, '1646-06-30', 'Texel', 616, 'of those on board (HEN-RIETTE LOUISE not included) 1062.');
INSERT INTO "voyages" VALUES (5331, '', 3, '', 'HENRIETTE LOUISE', 'Jonathan van Nelkern', 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1645-12-18', 'Batavia', NULL, NULL, true, '1646-07-03', 'Wielingen', 622, NULL);
INSERT INTO "voyages" VALUES (5332, '', 2, '', 'ROTTERDAM', 'Samuel Jansz.', 1100, NULL, NULL, NULL, NULL, 'R', 'R', '1645-12-18', 'Batavia', NULL, NULL, true, '1646-07-02', 'Goeree', 621, NULL);
INSERT INTO "voyages" VALUES (5333, '', 2, '', 'TIJGER', 'Pieter Dirksz.', 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1645-12-18', 'Batavia', NULL, NULL, true, '1646-06-30', 'Texel', 613, 'According to Coolhaas the invoice value of the return cargo was 338,219.');
INSERT INTO "voyages" VALUES (5334, '', 2, '', 'VREDE', 'Kornelis Jansz. Geesbuur', 800, NULL, '1641', NULL, NULL, 'A', 'A', '1645-12-18', 'Batavia', NULL, NULL, true, '1646-06-30', 'Texel', 614, NULL);
INSERT INTO "voyages" VALUES (5335, '', 3, '', 'WALVIS', 'Lucas Albertsz.', 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1645-12-18', 'Batavia', NULL, NULL, true, '1646-06-30', 'Texel', 635, NULL);
INSERT INTO "voyages" VALUES (5336, '', 2, '', 'WESTFRIESLAND', 'Klaas Kornelisz.', 1100, NULL, '1641', NULL, NULL, 'H', 'H', '1645-12-18', 'Batavia', NULL, NULL, true, '1646-06-30', 'Texel', 618, NULL);
INSERT INTO "voyages" VALUES (5337, '', 2, '', 'HOF VAN ZEELAND', 'Jan van Stapelen', 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1645-12-18', 'Batavia', NULL, NULL, true, '1646-07-03', 'Wielingen', 640, NULL);
INSERT INTO "voyages" VALUES (5338, '', 7, '', 'ZUTPHEN', 'Paul Egbertsz.', 550, NULL, NULL, NULL, NULL, 'A', 'A', '1645-12-18', 'Batavia', NULL, NULL, true, '1646-06-30', 'Texel', 627, NULL);
INSERT INTO "voyages" VALUES (5339, '', 4, '', 'BREDA', 'Jan Roelofsz.', 1050, NULL, '1637', NULL, NULL, 'H', 'H', '1646-12-22', 'Batavia', NULL, NULL, true, '1647-08-09', 'Texel', 646, 'Return fleet (5339-5345) under command of Jeremias van Wet aboard the VOGELSTRUIS. T otal number of those on board 939.');
INSERT INTO "voyages" VALUES (5340, '', 6, '', 'LEEUWARDEN', 'Hendrik Sieuwertsz. Spanhems', 550, NULL, '1629', NULL, NULL, 'E', 'E', '1646-12-22', 'Batavia', NULL, NULL, true, '1647-08-09', 'Texel', 645, NULL);
INSERT INTO "voyages" VALUES (5341, '', 2, '', 'MALAKKA', 'Bastiaan Bardoel', 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1646-12-22', 'Batavia', NULL, NULL, true, '1647-08-09', 'Texel', 651, NULL);
INSERT INTO "voyages" VALUES (5342, '', 3, '', 'VERENIGDE PROVINCIEN', 'Jan Hermansz.', 1100, NULL, '1640', NULL, NULL, 'A', 'Z', '1646-12-22', 'Batavia', NULL, NULL, true, '1647-08-10', 'Wielingen', 659, NULL);
INSERT INTO "voyages" VALUES (5343, '', 3, '', 'SALAMANDER', 'Jan Rijksz.', 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1646-12-22', 'Batavia', NULL, NULL, true, '1647-08-09', 'Texel', 643, NULL);
INSERT INTO "voyages" VALUES (5344, '', 3, '', 'VOGELSTRUIS', NULL, 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1646-12-22', 'Batavia', NULL, NULL, true, '1647-08-09', 'Texel', 638, NULL);
INSERT INTO "voyages" VALUES (5345, '', 6, '', 'ZEELANDIA', 'Kornelis Jansz. van Hoorn', 600, NULL, '1631', NULL, NULL, 'Z', 'Z', '1646-12-22', 'Batavia', NULL, NULL, true, '1647-08-10', 'Wielingen', 660, NULL);
INSERT INTO "voyages" VALUES (5346, '', 4, '', 'HAARLEM', 'Pieter Pietersz.', 500, NULL, NULL, NULL, NULL, 'A', 'A', '1647-01-16', 'Batavia', '1647-03-25', NULL, true, NULL, NULL, 661, 'Robben Island and the mainland. The fleet sailed via St. Helena.');
INSERT INTO "voyages" VALUES (5347, '', 3, '', 'WITTE OLIFANT', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1647-01-16', 'Batavia', '1647-03-25', '1647-04-12', true, '1647-08-09', 'Texel', 654, NULL);
INSERT INTO "voyages" VALUES (5348, '', 1, '', 'SCHIEDAM', NULL, 800, NULL, NULL, NULL, NULL, 'D', 'D', '1647-01-16', 'Batavia', '1647-03-30', '1647-04-12', true, '1647-08-10', 'Goeree', 626, NULL);
INSERT INTO "voyages" VALUES (5349, '', 2, '', 'DELFT', NULL, 670, NULL, '1641', NULL, NULL, 'D', 'D', '1648-01-04', 'Batavia', '1648-03-17', '1648-04-03', true, '1648-08-15', 'Goeree', 658, 'Return fleet (5349-5360 with 1600 men on board at departure) under command of Wollebrant Geleijnsen de Jong sailed via St. Helena.');
INSERT INTO "voyages" VALUES (5350, '', 5, '', 'ENKHUIZEN', NULL, 550, NULL, NULL, NULL, NULL, NULL, 'E', '1648-01-04', 'Batavia', '1648-03-17', '1648-04-03', true, '1648-08-09', 'Texel', 672, NULL);
INSERT INTO "voyages" VALUES (5351, '', 4, '', 'HENRIETTE LOUISE', NULL, 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1648-01-04', 'Batavia', '1648-03-17', '1648-04-03', true, '1648-08-01', 'Wielingen', 676, NULL);
INSERT INTO "voyages" VALUES (5352, '', 1, '', 'NOORDMUNSTER', NULL, NULL, 'fluit', NULL, NULL, NULL, 'Z', 'Z', '1648-04-01', 'Batavia', '1648-03-17', '1648-04-03', true, '1648-08-01', 'Wielingen', 677, NULL);
INSERT INTO "voyages" VALUES (5353, '', 2, '', 'ORANJE', NULL, 700, NULL, '1643', NULL, NULL, 'Z', 'Z', '1648-01-04', 'Batavia', '1648-03-17', '1648-04-03', true, '1648-08-01', 'Wielingen', 674, NULL);
INSERT INTO "voyages" VALUES (5382, '', 5, '', 'VERENIGDE PROVINCIEN', NULL, 1100, NULL, '1640', NULL, NULL, 'Z', 'Z', '1650-12-11', 'Batavia', NULL, NULL, true, '1651-06-01', 'Wielingen', 716, NULL);
INSERT INTO "voyages" VALUES (5383, '', 5, '', 'WALVIS', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1650-12-11', 'Batavia', NULL, NULL, true, '1651-06-24', 'Texel', 711, NULL);
INSERT INTO "voyages" VALUES (5384, '', 4, '', 'HOF VAN ZEELAND', NULL, 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1650-12-11', 'Batavia', NULL, NULL, true, '1651-06-01', 'Wielingen', 717, NULL);
INSERT INTO "voyages" VALUES (5385, '', 8, '', 'ZEELANDIA', NULL, 600, NULL, '1631', NULL, NULL, 'Z', 'R', '1650-12-11', 'Batavia', NULL, NULL, true, '1651-06-24', 'Goeree', 718, NULL);
INSERT INTO "voyages" VALUES (5386, '', 3, '', 'DELFT', NULL, 670, NULL, '1641', NULL, NULL, 'D', 'D', '1651-01-21', 'Batavia', NULL, NULL, true, '1651-09-01', NULL, 712, 'Second return fleet (5386, 5387, 5391) under command of Van der Lijn.');
INSERT INTO "voyages" VALUES (5387, '', 6, '', 'ENKHUIZEN', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'E', '1651-01-21', 'Batavia', NULL, NULL, true, '1651-08-25', 'Texel', 713, NULL);
INSERT INTO "voyages" VALUES (5388, '', 4, '', 'WESTFRIESLAND', NULL, 1100, NULL, '1641', NULL, NULL, 'H', 'H', '1651-01-21', 'Batavia', NULL, NULL, true, '1651-09-01', NULL, 721, NULL);
INSERT INTO "voyages" VALUES (5389, '', 2, '', 'DIAMANT', NULL, 1100, NULL, '1648', NULL, NULL, 'A', 'A', '1651-12-01', 'Batavia', '1652-02-15', '1652-02-26', true, '1652-09-01', NULL, 730, 'Return fleet (5389-5395 except 5391) under command of Joan van Teylingen aboard the DIAMANT. T otal number of those on board 762, amongst whom 28 passengers.');
INSERT INTO "voyages" VALUES (5390, '', 6, '', 'HENRIETTE LOUISE', NULL, 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1651-12-01', 'Batavia', '1652-02-13', '1652-02-26', true, '1652-10-01', NULL, 727, NULL);
INSERT INTO "voyages" VALUES (5391, '', 1, '', 'REIGER', NULL, 560, 'fluit', NULL, NULL, NULL, 'A', 'A', '1651-01-22', 'Batavia', NULL, NULL, true, '1651-09-01', NULL, 693, NULL);
INSERT INTO "voyages" VALUES (5392, '', 5, '', 'ROTTERDAM', NULL, 1100, NULL, NULL, NULL, NULL, 'R', 'R', '1651-12-19', 'Batavia', '1652-02-13', '1652-02-26', true, '1652-10-01', NULL, 733, NULL);
INSERT INTO "voyages" VALUES (5393, '', 5, '', 'VOGELSTRUIS', NULL, 1000, NULL, '1640', NULL, NULL, 'A', 'A', '1651-12-19', 'Batavia', NULL, NULL, false, '1652-08-01', NULL, 724, '141 men including 11 passengers.');
INSERT INTO "voyages" VALUES (5394, '', 4, '', 'VREDE', NULL, 800, NULL, '1641', NULL, NULL, 'A', 'A', '1651-12-19', 'Batavia', NULL, NULL, false, '1652-08-01', NULL, 710, '109 men including 2 passengers.');
INSERT INTO "voyages" VALUES (5395, '', 1, '', 'PRINS WILLEM', NULL, 700, NULL, '1650', NULL, NULL, 'Z', 'Z', '1651-12-19', 'Batavia', NULL, NULL, false, '1652-08-01', NULL, 735, NULL);
INSERT INTO "voyages" VALUES (5396, '', 6, '', 'BREDA', NULL, 1050, NULL, '1637', NULL, NULL, 'H', 'H', '1652-01-25', 'Batavia', NULL, NULL, true, '1652-09-01', NULL, 729, 'Return fleet (5396-5400) under command of Dirk Ogel aboard the SALAMANDER(?).');
INSERT INTO "voyages" VALUES (5397, '', 1, '', 'KONING DAVID', NULL, 600, 'fluit', NULL, NULL, NULL, 'A', 'A', '1652-01-25', 'Batavia', NULL, NULL, true, '1652-08-15', 'Texel', 653, NULL);
INSERT INTO "voyages" VALUES (5398, '', 2, '', 'LASTDRAGER', NULL, 640, 'fluit', NULL, '1648', NULL, 'A', 'A', '1652-01-25', 'Batavia', NULL, NULL, true, '1652-09-01', NULL, 731, NULL);
INSERT INTO "voyages" VALUES (5399, '', 4, '', 'ORANJE', NULL, 1200, NULL, '1643', NULL, NULL, 'Z', 'Z', '1652-01-25', 'Batavia', NULL, NULL, true, '1652-09-01', NULL, 728, NULL);
INSERT INTO "voyages" VALUES (5400, '', 5, '', 'SALAMANDER', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1652-01-25', 'Batavia', '1652-04-15', '1652-04-19', true, '1652-08-01', NULL, 734, NULL);
INSERT INTO "voyages" VALUES (5401, '', 5, '', 'MALAKKA', 'Johan Knecht', 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1652-12-24', 'Batavia', '1653-03-06', '1653-04-17', true, '1653-11-16', 'Texel', 749, 'Return fleet (5401-5405) under command of Gerard Demmer aboard the PAREL, after the Cape Andries Frisius became commandeur. T otal number of those on board 765. The MALAKKA was unloaded at Bergen, October 1653.');
INSERT INTO "voyages" VALUES (5402, '', 1, '', 'PAREL', 'Klaas Vis', 1100, NULL, '1651', NULL, NULL, 'A', 'A', '1652-12-24', 'Batavia', '1653-03-06', '1653-04-17', true, '1653-11-06', 'Texel', 737, NULL);
INSERT INTO "voyages" VALUES (5403, '', 3, '', 'PRINSES ROYAAL', 'Groet', 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1652-12-24', 'Batavia', '1653-03-06', '1653-04-17', true, '1653-11-06', 'Texel', 750, NULL);
INSERT INTO "voyages" VALUES (5404, '', 6, '', 'WALVIS', 'Johan Teyssen', 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1652-12-24', 'Batavia', '1653-03-02', '1653-04-17', true, '1653-11-06', 'Texel', 743, NULL);
INSERT INTO "voyages" VALUES (5405, '', 5, '', 'HOF VAN ZEELAND', NULL, 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1652-12-24', 'Batavia', '1653-03-02', '1653-04-17', true, '1653-11-05', 'Texel', 745, NULL);
INSERT INTO "voyages" VALUES (5406, '', 7, '', 'ENKHUIZEN', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'E', '1653-02-02', 'Batavia', '1653-05-01', '1653-05-06', true, '1653-11-06', NULL, 753, 'Second return fleet (5406-5408) under command of Andries Frisius, who became commandeur of the joined fleets.');
INSERT INTO "voyages" VALUES (5407, '', 6, '', 'WITTE OLIFANT', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1653-02-02', 'Batavia', '1653-04-19', '1653-05-06', true, '1653-11-16', 'Texel', 742, NULL);
INSERT INTO "voyages" VALUES (5408, '', 6, '', 'VERENIGDE PROVINCIEN', NULL, 1100, NULL, '1643', NULL, NULL, 'Z', 'Z', '1653-02-02', 'Batavia', '1653-04-22', '1653-05-06', true, '1654-01-11', 'Texel', 744, NULL);
INSERT INTO "voyages" VALUES (5409, '', 1, '', 'AVONDSTER', NULL, 360, 'jacht', NULL, NULL, NULL, NULL, 'H', '1654-01-19', 'Batavia', NULL, NULL, false, '1654-09-01', NULL, NULL, 'Captured from the English.');
INSERT INTO "voyages" VALUES (5410, '', 2, '', 'KONING DAVID', NULL, 600, 'fluit', NULL, NULL, NULL, 'A', 'A', '1654-01-19', 'Batavia', NULL, NULL, false, '1654-08-30', 'Texel', 770, 'Return fleet (5409-5414) under command of Pieter Kemp. At St. Helena they waited for the ROTTERDAM and the PRINS WILLEM. Arrival at St. Helena 18-04-1654.');
INSERT INTO "voyages" VALUES (5411, '', 1, '', 'LEEUWIN', NULL, 400, 'jacht', NULL, NULL, NULL, 'Z', 'D', '1654-01-19', 'Batavia', NULL, NULL, false, '1654-08-30', NULL, 767, NULL);
INSERT INTO "voyages" VALUES (5412, '', 5, '', 'ORANJE', NULL, 700, NULL, '1643', NULL, NULL, 'Z', 'Z', '1654-01-19', 'Batavia', NULL, NULL, false, '1654-08-31', 'Wielingen', 776, NULL);
INSERT INTO "voyages" VALUES (5413, '', 1, '', 'PHOENIX', NULL, 900, NULL, NULL, NULL, NULL, NULL, 'A', '1654-01-19', 'Batavia', NULL, NULL, false, '1654-08-30', 'Texel', 771, NULL);
INSERT INTO "voyages" VALUES (5414, '', 6, '', 'SALAMANDER', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1654-01-19', 'Batavia', NULL, NULL, false, '1654-08-30', 'Texel', 772, NULL);
INSERT INTO "voyages" VALUES (5415, '', 6, '', 'ROTTERDAM', NULL, 1100, NULL, NULL, NULL, NULL, 'R', 'R', '1654-02-06', 'Batavia', NULL, NULL, true, '1654-08-31', NULL, 775, NULL);
INSERT INTO "voyages" VALUES (5416, '', 2, '', 'PRINS WILLEM', NULL, 700, NULL, '1650', NULL, NULL, 'Z', 'Z', '1654-02-06', 'Batavia', NULL, NULL, true, '1654-08-31', 'Wielingen', 777, NULL);
INSERT INTO "voyages" VALUES (5417, '', 1, '', 'VERGULDE DRAAK', 'Pieter Albertsz.', NULL, 'jacht', '1653', NULL, NULL, 'A', 'A', '1654-11-07', 'Batavia', '1655-01-19', '1655-01-28', true, '1655-06-11', 'Texel', 779, 'Return fleet (5417-5420) under command of Huibert de Laresse. Vice-commandeur was Hubert Hugo aboard the TERSCHEL-LING. Total number of those aboard 327 including 14 women and children. Via St. Helena, departure 06-03-1655.');
INSERT INTO "voyages" VALUES (5418, '', 1, '', 'MUIDEN', NULL, 400, 'jacht', NULL, NULL, NULL, 'A', 'A', '1654-11-07', 'Batavia', '1655-01-29', NULL, true, '1655-06-19', 'Texel', 762, NULL);
INSERT INTO "voyages" VALUES (5419, '', 1, '', 'TERSCHELLING', NULL, NULL, 'jacht', NULL, NULL, NULL, NULL, 'A', '1654-11-07', 'Batavia', '1655-01-24', '1655-01-28', true, '1655-06-16', 'Wielingen', 798, NULL);
INSERT INTO "voyages" VALUES (5420, '', 1, '', 'WEESP', NULL, NULL, 'jacht', NULL, NULL, NULL, 'A', 'A', '1654-11-07', 'Batavia', '1655-02-01', NULL, true, '1655-06-19', 'Texel', 763, NULL);
INSERT INTO "voyages" VALUES (5421, '', 7, '', 'BREDA', NULL, 1050, NULL, '1637', NULL, NULL, 'H', 'H', '1655-02-01', 'Batavia', NULL, NULL, true, '1655-09-06', 'Vlie', 784, 'Return fleet (5421-5429) under command of Rijklof van Goens aboard the PAREL(?). Total number of those aboard 839.');
INSERT INTO "voyages" VALUES (5422, '', 1, '', 'DOLFUN', NULL, 520, 'jacht', NULL, NULL, NULL, 'A', 'A', '1655-02-01', 'Batavia', '1655-04-21', '1655-05-09', true, '1655-09-06', 'Vlie', 800, 'Via St. Helena.');
INSERT INTO "voyages" VALUES (5423, '', 1, '', 'DORDRECHT', NULL, 920, NULL, '1652', NULL, NULL, 'D', 'D', '1655-02-01', 'Batavia', '1655-04-21', '1655-05-09', true, '1655-09-01', 'Goeree', 773, 'Via St. Helena.');
INSERT INTO "voyages" VALUES (5424, '', 1, '', 'GIDEON', NULL, NULL, 'jacht', NULL, NULL, NULL, NULL, 'A', '1655-02-01', 'Batavia', '1655-04-21', '1655-05-09', true, '1655-09-05', 'Vlie', 801, 'Via St. Helena.');
INSERT INTO "voyages" VALUES (5425, '', 7, '', 'HENRIETTE LOUISE', NULL, 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1655-02-01', 'Batavia', '1655-04-21', '1655-05-09', true, '1655-09-08', 'Wielingen', 778, 'Via St. Helena.');
INSERT INTO "voyages" VALUES (5426, '', 2, '', 'PAREL', NULL, 1100, NULL, '1651', NULL, NULL, 'A', 'A', '1655-02-01', 'Batavia', '1655-04-21', '1655-05-09', true, '1655-09-06', 'Vlie', 796, 'Via St. Helena.');
INSERT INTO "voyages" VALUES (5427, '', 2, '', 'KONING VAN POLEN', NULL, 520, 'fluit', NULL, NULL, NULL, 'A', 'Z', '1655-02-13', 'Batavia', NULL, NULL, true, '1655-09-08', 'Wielingen', 706, NULL);
INSERT INTO "voyages" VALUES (5428, '', 4, '', 'PRINSES ROYAAL', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1655-02-01', 'Batavia', '1655-04-21', '1655-05-09', true, '1655-09-06', 'Vlie', 797, 'Via St. Helena.');
INSERT INTO "voyages" VALUES (5429, '', 1, '', 'THOLEN', NULL, 360, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1655-02-01', 'Batavia', '1655-04-21', '1655-05-09', true, '1655-09-06', 'Wielingen', 7941, 'Via St. Helena.');
INSERT INTO "voyages" VALUES (5430, '', 1, '', 'JONGE PRINS TE PAARD', NULL, NULL, 'jacht', NULL, NULL, NULL, NULL, 'A', '1655-04-01', 'Batavia', '1655-06-24', '1655-07-05', true, '1655-09-26', 'Texel', 802, NULL);
INSERT INTO "voyages" VALUES (5431, '', 1, '', 'GEKROONDE LEEUW', NULL, 1200, NULL, NULL, NULL, NULL, 'E', 'E', '1655-12-24', 'Batavia', '1656-03-15', '1656-03-27', true, '1656-07-25', 'Vlie', 806, 'First return fleet (5431-5436) under command of Kasper van den Bogaard aboard the VERENIGDE PROVINCIEN(?) Via St. Helena? Total number of those aboard 832.');
INSERT INTO "voyages" VALUES (5432, '', 6, '', 'MALAKKA', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1655-12-24', 'Batavia', '1656-03-15', '1656-03-27', true, '1656-07-25', 'Vlie', 811, NULL);
INSERT INTO "voyages" VALUES (5433, '', 2, '', 'PHOENIX', NULL, 900, NULL, NULL, NULL, NULL, NULL, 'D', '1655-12-24', 'Batavia', '1656-03-15', '1656-03-27', true, '1656-07-28', 'Goeree', 818, NULL);
INSERT INTO "voyages" VALUES (5434, '', 7, '', 'VERENIGDE PROVINCIEN', NULL, 1100, NULL, '1643', NULL, NULL, 'Z', 'Z', '1655-12-24', 'Batavia', '1656-03-15', '1656-03-27', true, '1656-07-31', 'Wielingen', 812, NULL);
INSERT INTO "voyages" VALUES (5435, '', 7, '', 'WALVIS', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1655-12-24', 'Batavia', '1656-03-15', '1656-03-27', true, '1656-07-25', 'Vlie', 803, NULL);
INSERT INTO "voyages" VALUES (5436, '', 6, '', 'HOF VAN ZEELAND', NULL, 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1655-12-24', 'Batavia', '1656-03-15', '1656-03-27', true, '1656-07-30', 'Wielingen', 808, NULL);
INSERT INTO "voyages" VALUES (5437, '', 8, '', 'ENKHUIZEN', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'A', '1656-02-03', 'Batavia', '1656-04-11', '1656-04-27', true, '1656-09-08', 'Vlie', 805, 'command of Dirk Sarcerius. Arrival at St. Helena 17-05-1656 and stayed there for at least 10 days.');
INSERT INTO "voyages" VALUES (5438, '', 7, '', 'OLIFANT', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'A', '1656-02-03', 'Batavia', '1656-04-11', '1656-04-27', true, '1656-09-08', 'Vlie', 807, NULL);
INSERT INTO "voyages" VALUES (5439, '', 6, '', 'ORANJE', NULL, 700, NULL, '1643', NULL, NULL, 'Z', 'A', '1656-02-03', 'Batavia', '1656-04-11', '1656-04-27', true, '1656-09-08', 'Vlie', 824, NULL);
INSERT INTO "voyages" VALUES (5440, '', 7, '', 'ROTTERDAM', NULL, 1100, NULL, NULL, NULL, NULL, 'R', 'R', '1656-02-03', 'Batavia', '1656-04-11', '1656-04-27', true, '1656-09-10', 'Goeree', 825, NULL);
INSERT INTO "voyages" VALUES (5441, '', 1, '', 'AMERSFOORT', NULL, 1000, NULL, '1655', NULL, NULL, 'A', 'A', '1656-12-04', 'Batavia', '1657-02-21', '1657-03-08', true, '1657-07-16', NULL, 826, 'First return fleet (5441-5446) under command of Thijs Krab aboard the PRINS WILLEM. T otal number of those on board 528 seamen, 235 soldiers and 108 passengers (Portuguese).');
INSERT INTO "voyages" VALUES (5442, '', 1, '', 'WAPEN VAN AMSTERDAM', NULL, 920, NULL, '1653', NULL, NULL, 'A', 'A', '1656-12-04', 'Batavia', '1657-02-21', '1657-03-08', true, '1657-07-16', 'Vlie', 809, NULL);
INSERT INTO "voyages" VALUES (5443, '', 2, '', 'DORDRECHT', NULL, 920, 'fregat', '1652', NULL, NULL, 'D', 'D', '1656-12-04', 'Batavia', '1657-02-21', '1657-03-08', true, '1657-07-16', 'Goeree', 846, NULL);
INSERT INTO "voyages" VALUES (5444, '', 1, '', 'WAPEN VAN HOLLAND', NULL, 920, NULL, '1653', NULL, NULL, 'A', 'A', '1656-12-04', 'Batavia', '1657-02-21', '1657-03-08', true, '1657-07-16', 'Vlie', 810, NULL);
INSERT INTO "voyages" VALUES (5445, '', 6, '', 'WESTFRIESLAND', NULL, 1100, NULL, '1641', NULL, NULL, 'H', 'H', '1656-12-04', 'Batavia', '1657-02-21', '1657-03-08', true, '1657-07-16', 'Vlie', 830, NULL);
INSERT INTO "voyages" VALUES (5446, '', 3, '', 'PRINS WILLEM', NULL, 700, NULL, '1650', NULL, NULL, 'Z', 'Z', '1656-12-04', 'Batavia', '1657-02-21', '1657-03-08', true, '1657-07-18', 'Wielingen', 820, NULL);
INSERT INTO "voyages" VALUES (5447, '', 1, '', 'ARNHEM', 'Michiel Jakobsz. van Bergen', 1000, NULL, '1654', NULL, NULL, 'A', 'A', '1657-02-03', 'Batavia', '1657-12-21', NULL, true, '1658-07-29', 'Vlie', 827, '02-07-1657) and Madagascar because of damage. Overtaken at St. Helena by the return fleet of 18-12-1657. Before the ARNHEM had left the Sunda Strait, two masters had died: Jan Rotgans and Pieter 
Jansz. de Vries; the third one, Van Bergen, was dismissed at the Cape for being unable to maintain order. His successor was Jan Simonsz. Klos.');
INSERT INTO "voyages" VALUES (5448, '', 2, '', 'AVONDSTER', 'Sander Gerritsz. van Os', 360, 'jacht', NULL, NULL, NULL, NULL, 'Z', '1657-02-03', 'Batavia', NULL, NULL, true, NULL, NULL, 823, 'AVONDSTER returned to Batavia because of leakage (28-02-1657). Part of the cargo was taken over by the PAREL. It stayed in the Indies and was wrecked in the Bay of Gale (Ceylon) (02-07-1659).');
INSERT INTO "voyages" VALUES (5449, '', 8, '', 'HENRIETTE LOUISE', NULL, 750, NULL, '1635', NULL, NULL, 'Z', 'Z', '1657-02-03', 'Batavia', '1657-05-23', '1657-06-07', true, '1657-10-16', 'Wielingen', 848, 'Departure from Cape with 157 men.');
INSERT INTO "voyages" VALUES (5450, '', 1, '', 'SLOT VAN HONINGEN', 'Klaas Speelman', 1124, NULL, '1654', NULL, NULL, 'R', 'R', '1657-02-03', 'Batavia', '1657-12-20', NULL, true, '1658-07-05', 'Vlie', 831, 'Via Mauritius (arrival 27-06 or 02-07) in order to wait for the return fleet of 18-12-1657.');
INSERT INTO "voyages" VALUES (5451, '', 1, '', 'ACHILLES', NULL, 550, NULL, '1655', NULL, NULL, 'A', 'R', '1657-12-18', 'Batavia', '1658-03-03', '1658-03-08', true, '1658-07-21', 'Goeree', 842, 'VAN HONINGEN to wait for the fleet.');
INSERT INTO "voyages" VALUES (5452, '', 1, '', 'HECTOR', NULL, 600, NULL, NULL, NULL, NULL, 'A', 'D', '1657-12-18', 'Batavia', '1658-03-05', '1658-03-16', true, '1658-07-23', 'Goeree', 841, NULL);
INSERT INTO "voyages" VALUES (5453, '', 2, '', 'GEKROONDE LEEUW', NULL, 1200, NULL, NULL, NULL, NULL, 'E', 'E', '1657-12-18', 'Batavia', '1658-03-06', '1658-03-19', true, '1658-07-21', 'Vlie', 864, NULL);
INSERT INTO "voyages" VALUES (5454, '', 7, '', 'MALAKKA', 'Jan Munt', 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1657-12-18', 'Batavia', '1658-03-06', '1658-03-19', true, '1658-07-24', 'Wielingen', 862, NULL);
INSERT INTO "voyages" VALUES (5455, '', 7, '', 'ORANJE', NULL, 700, NULL, '1643', NULL, NULL, 'Z', 'Z', '1657-12-18', 'Batavia', '1658-03-05', '1658-03-19', true, '1658-07-24', 'Wielingen', 863, NULL);
INSERT INTO "voyages" VALUES (5456, '', 3, '', 'PAREL', NULL, 1100, NULL, '1651', NULL, NULL, 'A', 'A', '1657-12-18', 'Batavia', '1658-03-06', '1658-03-19', true, '1658-07-24', 'Wielingen', 850, 'See also 5448.');
INSERT INTO "voyages" VALUES (5457, '', 9, '', 'ENKHUIZEN', NULL, 700, NULL, NULL, NULL, NULL, NULL, 'H', '1658-01-17', 'Batavia', '1658-04-01', '1658-04-12', true, '1658-07-25', 'Vlie', 875, 'Second return fleet (5457-5460) under command of Kornelis Kwaalberge. The ENKHUIZEN arrived at the Cape with 150 men.');
INSERT INTO "voyages" VALUES (5458, '', 5, '', 'PRINSES ROYAAL', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1658-01-17', 'Batavia', '1658-04-01', '1658-04-12', true, '1658-07-24', 'Vlie', 855, 'The PRINSES ROYAAL arrived at the Cape with 160 men.');
INSERT INTO "voyages" VALUES (5459, '', 1, '', 'ULYSSES', NULL, 400, 'fluit', NULL, NULL, NULL, 'A', 'A', '1658-01-17', 'Batavia', '1658-03-30', '1658-04-01', true, '1658-07-21', 'Vlie', 856, NULL);
INSERT INTO "voyages" VALUES (5460, '', 7, '', 'HOF VAN ZEELAND', NULL, 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1658-01-17', 'Batavia', '1658-03-31', '1658-04-12', true, '1658-07-26', 'Wielingen', 869, NULL);
INSERT INTO "voyages" VALUES (5461, '', 2, '', 'AMERSFOORT', NULL, 1000, NULL, '1655', NULL, NULL, 'A', 'A', '1658-12-14', 'Batavia', NULL, NULL, false, '1659-07-01', 'Vlie', 881, 'board. The AMERSFOORT called at St. Helena (10-03 till 08-04).');
INSERT INTO "voyages" VALUES (5462, '', 2, '', 'WAPEN VAN AMSTERDAM', NULL, 920, NULL, '1653', NULL, NULL, 'A', 'A', '1658-12-14', 'Batavia', '1659-02-23', '1659-03-07', true, '1659-06-30', 'Vlie', 879, 'From 25/28-03 till 08-04-1659 at St. Helena.');
INSERT INTO "voyages" VALUES (5463, '', 8, '', 'OLIFANT', NULL, 1000, NULL, '1639', NULL, NULL, 'Z', 'E', '1658-12-14', 'Batavia', '1659-02-23', '1659-03-07', true, '1659-07-01', 'Vlie', 872, 'From 25/28-03 till 08-04-1659 at St. Helena.');
INSERT INTO "voyages" VALUES (5464, '', 3, '', 'PHOENIX', NULL, 900, NULL, NULL, NULL, NULL, 'A', 'D', '1658-12-14', 'Batavia', NULL, NULL, false, '1659-07-03', 'Goeree', 868, 'From 9/10-03 till 08-04-1659 at St. Helena.');
INSERT INTO "voyages" VALUES (5465, '', 8, '', 'VERENIGDE PROVINCIEN', NULL, 1100, NULL, '1643', NULL, NULL, 'Z', 'Z', '1658-12-14', 'Batavia', '1659-02-24', '1659-03-07', true, '1659-07-02', 'Wielingen', 873, 'From 25/28-03 till 08-04-1659 at St. Helena.');
INSERT INTO "voyages" VALUES (5466, '', 1, '', 'VLISSINGEN', NULL, 400, NULL, '1653', NULL, NULL, 'Z', 'Z', '1658-12-14', 'Batavia', '1659-02-23', '1659-03-07', true, '1659-07-02', 'Wielingen', 791, 'From 25/28-03 till 08-04-1659 at St. He ena.');
INSERT INTO "voyages" VALUES (5467, '', 8, '', 'WALVIS', NULL, 1000, NULL, '1639', NULL, NULL, 'A', 'H', '1658-12-14', 'Batavia', NULL, NULL, false, '1659-07-01', 'Vlie', 876, 'From 9/10-03 till 08-04-1659 at St. Helena.');
INSERT INTO "voyages" VALUES (5468, '', 1, '', 'ZIERIKZEE', NULL, 400, NULL, '1652', NULL, NULL, 'Z', 'R', '1658-12-14', 'Batavia', NULL, NULL, false, '1659-06-29', 'Vlie', 769, 'From 9/10-03 till 08-04-1659 at St. Helena.');
INSERT INTO "voyages" VALUES (5469, '', 1, '', 'ERASMUS', 'Daam Pietersz. Lely +', 400, NULL, '1652', NULL, NULL, 'R', 'A', '1659-01-15', 'Batavia', '1659-09-25', '1660-03-20', true, '1660-07-18', 'Vlie', 774, 'Both ships lost each other out of sight, 29/30-03-1659. The ERASMUS sailed via the Comoro Istands and Madagascar because of damage. At the Cape it waited for the return fleet of 18-12-1659. The ship called at St Helena. The crew included 16 Portuguese prisoners.');
INSERT INTO "voyages" VALUES (5470, '', 1, '', 'NAARDEN', 'Kornelis Rob', 400, NULL, NULL, NULL, NULL, 'A', 'A', '1659-01-15', 'Batavia', '1659-04-11', '1659-05-03', true, '1659-07-01', 'Texel', 782, 'DOLPHIN, an English ship.');
INSERT INTO "voyages" VALUES (5471, '', 2, '', 'ARNHEM', 'Rens Jansz.', 1000, NULL, '1654', NULL, NULL, 'A', 'E', '1659-12-18', 'Batavia', '1660-03-02', '1660-03-20', true, '1660-07-18', 'Vlie', 894, 'First return fleet (5471-5479) under command of Pieter Sterthenius aboard the WAPEN VAN HOLLAND. At the Cape the ERASMUS joined the fleet.');
INSERT INTO "voyages" VALUES (5472, '', 3, '', 'DORDRECHT', 'Adriaan de Gilde', 920, 'fregat', '1652', NULL, NULL, 'D', 'D', '1659-12-18', 'Batavia', '1660-03-02', '1660-03-20', true, '1660-07-10', 'Maas', 884, NULL);
INSERT INTO "voyages" VALUES (5473, '', 2, '', 'WAPEN VAN HOLLAND', 'Pieter Berkhout', 920, NULL, '1653', NULL, NULL, 'A', 'A', '1659-12-18', 'Batavia', '1660-03-02', '1660-03-20', true, '1660-07-18', 'Vlie', 880, NULL);
INSERT INTO "voyages" VALUES (5474, '', 2, '', 'SLOT VAN HONINGEN', 'Pieter Pietersz.', 1124, NULL, '1654', NULL, NULL, 'R', 'R', '1659-12-18', 'Batavia', '1660-03-02', '1660-03-20', true, '1660-07-10', 'Maas', 905, NULL);
INSERT INTO "voyages" VALUES (5475, '', 4, '', 'PAREL', 'Douwe Aukesz.', 1100, NULL, '1651', NULL, NULL, 'A', 'A', '1659-12-18', 'Batavia', '1660-03-02', '1660-03-20', true, '1660-07-18', 'Vlie', 897, 'The crew included 3 passengers.');
INSERT INTO "voyages" VALUES (5476, '', 6, '', 'PRINSES ROYAAL', 'Maarten Deene', 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1659-12-18', 'Batavia', '1660-03-02', '1660-03-20', true, '1660-07-18', 'Vlie', 898, 'The crew included 2 passengers.');
INSERT INTO "voyages" VALUES (5477, '', 7, '', 'WESTFRIESLAND', 'Jakob Brune', 1100, NULL, '1641', NULL, NULL, 'H', 'H', '1659-12-18', 'Batavia', '1660-03-02', '1660-03-20', true, '1660-07-18', 'Vlie', 889, NULL);
INSERT INTO "voyages" VALUES (5478, '', 4, '', 'PRINS WILLEM', 'Daniel de Loper', 700, NULL, '1650', NULL, NULL, 'Z', 'Z', '1659-12-18', 'Batavia', '1660-03-02', '1660-03-20', true, '1660-07-10', 'Wielingen', 885, NULL);
INSERT INTO "voyages" VALUES (5479, '', 1, '', 'ZEEPAARD', 'Arien Zwart', 400, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1659-12-18', 'Batavia', '1660-03-02', '1660-03-20', true, '1660-07-10', NULL, 840, NULL);
INSERT INTO "voyages" VALUES (5480, '', 1, '', 'HILVERSUM', NULL, 202, 'fluit', '1656', NULL, NULL, 'A', 'A', '1660-01-16', 'Batavia', '1660-04-21', '1660-05-04', true, '1660-08-10', 'Vlie', 861, 'Second return fleet (5480-5481).');
INSERT INTO "voyages" VALUES (5481, '', 1, '', 'VOGELZANG', NULL, 680, 'fluit', NULL, NULL, NULL, 'A', 'A', '1660-01-16', 'Batavia', '1660-04-21', '1660-05-04', true, '1660-08-10', 'Vlie', 860, NULL);
INSERT INTO "voyages" VALUES (5482, '', 3, '', 'AMERSFOORT', 'Jan Munt', 1000, NULL, '1655', NULL, NULL, 'A', 'A', '1660-12-17', 'Batavia', '1661-02-24', '1661-03-13', true, '1661-06-30', 'Vlie', 913, 'stow-aways were put aboard the ANKEVEEN at the Cape (see 0930). Via St. Helena.');
INSERT INTO "voyages" VALUES (5483, '', 3, '', 'WAPEN VAN AMSTERDAM', NULL, 920, NULL, '1653', NULL, NULL, 'A', 'A', '1660-12-17', 'Batavia', '1661-02-24', '1661-03-13', true, '1661-06-30', 'Vlie', 914, NULL);
INSERT INTO "voyages" VALUES (5484, '', 8, '', 'MALAKKA', NULL, 1100, NULL, NULL, NULL, NULL, 'A', 'A', '1660-12-17', 'Batavia', '1661-02-24', '1661-03-13', true, '1661-06-30', 'Vlie', 909, NULL);
INSERT INTO "voyages" VALUES (5485, '', 1, '', 'MARS', NULL, 400, 'jacht', '1653', NULL, NULL, 'A', 'R', '1660-12-17', 'Batavia', '1661-02-24', '1661-03-13', true, '1661-07-01', 'Goeree', 793, NULL);
INSERT INTO "voyages" VALUES (5486, '', 1, '', 'NAGELBOOM', NULL, 600, NULL, NULL, NULL, NULL, 'H', 'H', '1660-12-17', 'Batavia', '1661-02-24', '1661-03-13', true, '1661-06-30', 'Vlie', 922, NULL);
INSERT INTO "voyages" VALUES (5487, '', 8, '', 'ORANJE', NULL, 700, NULL, '1643', NULL, NULL, 'Z', 'Z', '1660-12-17', 'Batavia', '1661-02-24', '1661-03-13', true, '1661-07-01', 'Wielingen', 906, NULL);
INSERT INTO "voyages" VALUES (5488, '', 8, '', 'HOF VAN ZEELAND', NULL, 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1660-12-17', 'Batavia', '1661-02-24', '1661-03-13', true, '1661-07-01', 'Wielingen', 908, NULL);
INSERT INTO "voyages" VALUES (5489, '', 1, '', 'KALF', NULL, 320, 'jacht? pinas?', NULL, NULL, NULL, 'A', 'A', '1661-01-27', 'Batavia', '1661-04-18', '1661-05-05', true, '1661-09-03', 'Vlie', 780, 'Second return fleet (5489-5490) under command of Johan Bouchellon. The crew included 7 passengers.');
INSERT INTO "voyages" VALUES (5490, '', 1, '', 'VENENBURG', 'Hendrik Juriaansz.', 703, 'fluit', '1656', NULL, NULL, 'A', 'A', '1661-01-27', 'Batavia', '1661-04-18', '1661-05-05', true, '1661-09-03', 'Vlie', 866, NULL);
INSERT INTO "voyages" VALUES (5491, '', 3, '', 'ARNHEM', 'Pieter Anthonisz.', 1000, NULL, '1654', NULL, NULL, 'A', 'A', '1661-12-23', 'Batavia', NULL, NULL, true, NULL, NULL, 939, 'First return fleet (5491-5497) under command of Arnold de Vlaming van Oudshoorn(+) aboard the WAPEN VAN HOLLAND and Jakob Willemsz. (vice-comm. +). At the Cape the fleet waited for the return fleet of 30-01-1662. Johan van der Laan became the new commander. The ARNHEM was wrecked at Brandao, an island east of Madagascar (12-02-1662); about 80 survivors reached Mauritius and were picked up later.');
INSERT INTO "voyages" VALUES (5492, '', 3, '', 'WAPEN VAN HOLLAND', 'Maarten Doedesz.', 920, NULL, '1653', NULL, NULL, 'A', 'A', '1661-12-23', 'Batavia', NULL, NULL, true, NULL, NULL, 940, 'Was wrecked in the Indian Ocean during a storm at 25/26''S. (10-02-1662).');
INSERT INTO "voyages" VALUES (5493, '', 3, '', 'GEKROONDE LEEUW', 'Frederik Pool', 1200, NULL, NULL, NULL, NULL, 'E', 'E', '1661-12-23', 'Batavia', NULL, NULL, true, NULL, NULL, 910, 'Was wrecked in the Indian Ocean during a storm at 25/26''S (10/11-02-1662).');
INSERT INTO "voyages" VALUES (5494, '', 1, '', 'MAARSSEVEEN', 'Haan', 1210, NULL, '1660', NULL, NULL, 'A', 'A', '1661-12-23', 'Batavia', '1662-03-15', '1662-04-10', true, '1662-07-28', 'Vlie', 931, 'The crew included 15 passengers.');
INSERT INTO "voyages" VALUES (5495, '', 4, '', 'PHOENIX', 'Kornelis Stamper', 900, NULL, NULL, NULL, NULL, NULL, 'D', '1661-12-23', 'Batavia', '1662-03-15', '1662-04-10', true, '1662-08-01', 'Goeree', 923, NULL);
INSERT INTO "voyages" VALUES (5496, '', 7, '', 'PRINSES ROYAAL', 'Cent Amers', 1100, NULL, NULL, NULL, NULL, 'A', 'Z', '1661-12-23', 'Batavia', '1662-03-15', '1662-04-10', true, '1662-08-03', 'Wielingen', 951, NULL);
INSERT INTO "voyages" VALUES (5497, '', 5, '', 'PRINS WILLEM', 'Adriaan van Leene', 700, NULL, '1650', NULL, NULL, 'Z', 'Z', '1661-12-23', 'Batavia', NULL, NULL, true, NULL, NULL, 938, 'Was wrecked in the Indian Ocean during a storm at 25/26''S. (10/11-02-1662).');
INSERT INTO "voyages" VALUES (5498, '', 1, '', 'ANJELIER', 'Barend Barendsz. Hans', 440, 'jacht', '1653', NULL, NULL, 'H', 'A', '1662-01-30', 'Batavia', '1662-04-02', '1662-04-10', true, '1662-07-28', 'Vlie', 795, 'Terschelling(?).');
INSERT INTO "voyages" VALUES (5499, '', 1, '', 'OOIEVAAR', 'Kollum', 627, 'fluit', '1656', NULL, NULL, 'Z', 'A', '1662-01-30', 'Batavia', '1662-04-02', '1662-04-10', true, '1662-07-28', 'Vlie', 865, 'The crew included 5 passengers.');
INSERT INTO "voyages" VALUES (5500, '', 1, '', 'SPREEUW', 'Pieter Pietersz.', 374, 'fluit', '1657', NULL, NULL, 'Z', 'Z', '1662-04-22', 'Batavia', '1662-08-01', NULL, true, '1662-11-25', 'Goeree', 878, 'The SPREEUW sailed on its own with message of the loss of Taiwan.');
INSERT INTO "voyages" VALUES (5501, '', 4, '', 'AMERSFOORT', NULL, 1000, NULL, '1655', NULL, NULL, 'A', 'A', '1662-12-26', 'Batavia', '1663-03-17', '1663-04-08', true, '1663-07-18', 'Vlie', 956, 'First return fleet (5501-5508) under command of Herman Klenke van Odessen aboard the WAPEN VAN AMSTER-DAM. At the Cape the MEIBOOM joined the fleet. Unsuccessful voyage of discovery to the non-existent island New Helena.');
INSERT INTO "voyages" VALUES (5502, '', 4, '', 'WAPEN VAN AMSTERDAM', NULL, 920, NULL, '1653', NULL, NULL, 'A', 'A', '1662-12-26', 'Batavia', '1663-03-17', '1663-04-08', true, '1663-07-18', 'Vlie', 954, NULL);
INSERT INTO "voyages" VALUES (5503, '', 3, '', 'SLOT VAN HONINGEN', NULL, 1124, NULL, '1654', NULL, NULL, 'R', 'R', '1662-12-26', 'Batavia', '1663-03-17', '1663-04-08', true, '1663-07-19', 'Goeree', 936, NULL);
INSERT INTO "voyages" VALUES (5504, '', 1, '', 'WASSENDE MAAN', NULL, 400, 'jacht', NULL, '1660/1', NULL, 'A', 'A', '1662-12-26', 'Batavia', '1663-03-17', '1663-04-08', true, '1663-07-18', 'Vlie', 944, NULL);
INSERT INTO "voyages" VALUES (5505, '', 5, '', 'PAREL', NULL, 1100, NULL, '1651', NULL, NULL, 'A', 'A', '1662-12-26', 'Batavia', '1663-03-17', '1663-04-08', true, '1663-07-18', 'Vlie', 950, NULL);
INSERT INTO "voyages" VALUES (5506, '', 1, '', 'JONGE PRINS', NULL, 840, 'jacht', '1661', NULL, NULL, 'H', 'H', '1662-12-26', 'Batavia', '1663-03-17', '1663-04-08', true, '1663-07-18', 'Vlie', 948, NULL);
INSERT INTO "voyages" VALUES (5507, '', 1, '', 'WALCHEREN', NULL, 840, NULL, '1661', NULL, NULL, 'Z', 'Z', '1662-12-26', 'Batavia', '1663-03-17', '1663-04-08', true, '1663-07-20', 'Wielingen', 965, NULL);
INSERT INTO "voyages" VALUES (5508, '', 9, '', 'HOF VAN HOLLAND', NULL, 1200, NULL, '1642', NULL, NULL, 'Z', 'Z', '1662-12-26', 'Batavia', '1663-03-17', '1663-04-08', true, '1663-07-20', 'Wielingen', 966, NULL);
INSERT INTO "voyages" VALUES (5509, '', 1, '', 'MEIBOOM', 'Karel Alteras', 312, 'jacht', '1660', NULL, NULL, 'R', 'A', '1663-01-23', 'Cochin', '1663-03-20', '1663-04-08', true, '1663-07-18', 'Vlie', 935, 'Joined the fleet of 26-12-1662 at the Cape. This adviesjacht brought the message of the Dutch conquest of Cochin');
INSERT INTO "voyages" VALUES (5510, '', 1, '', 'RODE HERT', 'Kornelis Vonk', 340, 'fluit', NULL, NULL, NULL, 'A', 'A', '1663-01-26', 'Batavia', NULL, NULL, true, '1663-08-31', 'Vlie', 891, 'Second return fleet (5510-5511) under command of Kornelis Vonk.');
INSERT INTO "voyages" VALUES (5511, '', 1, '', 'NIEUWPOORT', NULL, 400, 'fluit', NULL, NULL, NULL, 'A', 'A', '1663-01-26', 'Batavia', '1663-05-05', '1663-05-17', true, '1663-08-31', 'Vlie', 887, NULL);
INSERT INTO "voyages" VALUES (5512, '', 2, '', 'ACHILLES', 'Gerrit lsewijn', 550, 'jacht', '1655', NULL, NULL, 'A', 'Z', '1663-12-21', 'Batavia', '1664-03-31', '1664-04-16', true, '1664-08-30', 'Wielingen', 907, 'and the LOOSDUINEN (5522) joined the fleet.');
INSERT INTO "voyages" VALUES (5513, '', 4, '', 'DORDRECHT', 'Jan Simonsz.', 920, 'fregat', '1652', NULL, NULL, 'D', 'D', '1663-12-21', 'Batavia', '1664-03-31', '1664-04-16', true, '1664-08-29', 'Goeree', 933, NULL);
INSERT INTO "voyages" VALUES (5514, '', 1, '', 'KENNEMERLAND', 'Idese de Vink', 950, NULL, NULL, '1662', NULL, 'A', 'A', '1663-12-21', 'Batavia', '1664-03-13', '1664-04-16', true, '1664-08-25', 'Vlie', 968, NULL);
INSERT INTO "voyages" VALUES (5515, '', 2, '', 'MAARSSEVEEN', 'Jan Hermansz.', 1210, NULL, '1660', NULL, NULL, 'A', 'A', '1663-12-21', 'Batavia', '1664-03-13', '1664-04-16', true, '1664-08-25', 'Vlie', 977, 'Aboard the MAARSSEVEEN was Adriaan van der Meide, vice-commandeur of the return fleet. The ship was wrecked in the battle of Lowestoft against the English, 13-06-1665.');
INSERT INTO "voyages" VALUES (5516, '', 2, '', 'NAGELBOOM', 'Jan Andriesz.', 600, NULL, NULL, NULL, NULL, 'H', 'E', '1663-12-21', 'Batavia', '1664-03-31', '1664-04-16', true, '1664-08-25', 'Vlie', 960, 'The NAGELBOOM was hired by the Admiralties to fight the English; it was taken by the English on 13-06-1665.');
INSERT INTO "voyages" VALUES (5517, '', 9, '', 'ORANJE', 'Reinier Reiniersz.', 700, NULL, '1643', NULL, NULL, 'Z', 'Z', '1663-12-21', 'Batavia', '1664-03-31', '1664-04-16', true, '1664-08-30', 'Wielingen', 972, 'Aboard the ORANJE was Dirk Steur, commandeur of the return fleet. The ship was hired by the Admiralties to fight the English; it was burnt in the battle of Lowestoft, 13-06-1665.');
INSERT INTO "voyages" VALUES (5518, '', 1, '', 'RIJNLAND', NULL, 795, NULL, '1662', NULL, NULL, 'A', 'A', '1663-12-21', 'Batavia', '1664-03-31', '1664-04-16', true, '1664-08-28', 'Vlie', 969, NULL);
INSERT INTO "voyages" VALUES (5519, '', 2, '', 'ZEEPAARD', 'Thomas Koen or Pietersz.?', 400, 'jacht', NULL, NULL, NULL, 'Z', 'Z', '1663-12-21', 'Batavia', '1664-03-13', '1664-04-16', true, '1664-08-29', 'Wielingen', 942, 'Four stowaways discovered.');
INSERT INTO "voyages" VALUES (5520, '', 1, '', 'HUIS TE ZWIETEN', NULL, NULL, NULL, NULL, '1660/1', NULL, 'A', 'A', '1663-12-21', 'Batavia', '1664-03-31', '1664-04-16', true, '1664-08-06', 'Vlie', 947, 'Was hired by the Admiralties to fight the English; taken by the English on 19-09-1665.');
INSERT INTO "voyages" VALUES (5521, '', 1, '', 'BEURS VAN AMSTERDAM', NULL, 472, 'jacht', NULL, '1660/1', NULL, 'A', 'A', '1664-01-27', 'Batavia', '1664-03-31', '1664-04-16', true, '1664-08-25', 'Vlie', 943, 'Cape.');
INSERT INTO "voyages" VALUES (5522, '', 1, '', 'LOOSDUINEN', 'Karsten Krijnsz. Rechter', 340, NULL, NULL, NULL, NULL, NULL, 'A', '1664-01-27', 'Batavia', '1664-04-09', '1664-04-16', true, '1664-08-25', 'Vlie', 926, NULL);
INSERT INTO "voyages" VALUES (5523, '', 1, '', 'AMSTELLAND', 'Theunis Gijsbertsz.', 700, 'fluit', '1660', NULL, NULL, 'A', 'A', '1664-12-23', 'Batavia', '1665-03-11', '1665-04-22', true, NULL, NULL, 957, 'KOGGE and the NIEU-WENHOVE (5534 and 5535) joined the fleet. The combined fleet sailed via Bergen (Norway) because of the war; 12-08-1665: battle in the Bay of Bergen against an English fleet (25 men killed and 70 wounded). After the departure from Bergen two ships were taken by the English (see below). The AMSTELLAND returned to Bergen on 16-09-1665; departure: in October. On 25-10-1665 the ship was wrecked east of Terschelling; its cargo was mainly saved.');
INSERT INTO "voyages" VALUES (5524, '', 1, '', 'BREDERODE', 'Pieter Veldmuis de Voogd', 666, 'fluit? jacht?', '1663', NULL, NULL, 'A', 'A', '1664-12-23', 'Batavia', '1665-03-11', '1665-04-22', true, '1665-09-17', 'Vlie', 1002, 'Via Bergen (08-08 till 02-09-1665).');
INSERT INTO "voyages" VALUES (5525, '', 1, '', 'DIEMERMEER', NULL, 505, 'fluit', '1659', NULL, NULL, 'A', 'Z', '1664-12-23', 'Batavia', '1665-03-11', '1665-04-22', true, '1665-11-28', 'Wielingen', 916, 'Via Bergen, departure on 02-09-1665.');
INSERT INTO "voyages" VALUES (5526, '', 4, '', 'SLOT VAN HONINGEN', 'Herman de Ruiter', 1124, NULL, '1654', NULL, NULL, 'R', 'R', '1664-12-23', 'Batavia', '1665-03-11', '1665-04-22', true, NULL, NULL, 1011, 'Via Bergen (08-08 till 02-09-1665). Taken on 13-09-1665 by the English at Dogger Bank.');
INSERT INTO "voyages" VALUES (5527, '', 1, '', 'WAPEN VAN HOORN', NULL, 756, 'fluit? jacht?', '1662', NULL, NULL, 'H', 'A', '1664-12-23', 'Batavia', '1665-03-12', '1665-04-22', true, '1666-05-13', 'Vlie', 1000, 'Via Bergen (08-08 till 02-09-1665) and Gluckstadt on the Elbe.');
INSERT INTO "voyages" VALUES (5528, '', 1, '', 'MUSKAATBOOM or NOTENBOOM', NULL, 600, NULL, NULL, '1659', NULL, NULL, 'A', '1664-12-23', 'Batavia', NULL, NULL, true, NULL, NULL, 920, 'storm near the Cape (Febr. 1665).');
INSERT INTO "voyages" VALUES (5529, '', 2, '', 'OOIEVAAR', 'Frederik Jansz.', 627, 'fluit', '1656', NULL, NULL, 'Z', 'Z', '1664-12-23', 'Batavia', '1665-03-11', '1665-04-22', true, '1665-09-20', 'Eems', 984, 'Via Trondheim, not via Bergen.');
INSERT INTO "voyages" VALUES (5530, '', 5, '', 'PHOENIX', 'Kornelis Stamper', 900, NULL, NULL, NULL, NULL, NULL, 'A', '1664-12-23', 'Batavia', '1665-03-11', '1665-04-22', true, NULL, NULL, 988, '02-09-1665); on 13-09-1665 it was taken by the English at Dogger Bank.');
INSERT INTO "voyages" VALUES (5531, '', 2, '', 'JONGE PRINS', 'Jakob Jochemsz.', 840, 'jacht', '1661', NULL, NULL, 'H', 'H', '1664-12-23', 'Batavia', '1665-03-11', '1665-04-22', true, '1666-03-25', 'Texel', 1009, 'Via Bergen, departure on 02-09-1665; returned to Norway (Flecker O and Kristiansand).');
INSERT INTO "voyages" VALUES (5532, '', 2, '', 'WALCHEREN', 'Frans van Heist', 840, NULL, '1661', NULL, NULL, 'Z', 'Z', '1664-12-23', 'Batavia', '1665-03-11', '1665-04-22', true, '1665-09-17', 'Vlie', 1012, 'till 02-09-16651.');
INSERT INTO "voyages" VALUES (5533, '', 1, '', 'RIJZENDE ZON', NULL, 600, 'jacht', NULL, '1660/1', NULL, 'A', 'A', '1664-12-23', 'Batavia', '1665-03-11', '1665-04-22', true, '1665-10-08', 'Vlie', 946, 'Via Bergen (08-08 till 02-09-1665) and Denmark (Kronborg). Returned under convoy in the fleet of schout-bij-nacht Stachouwer of the Admiralty of Friesland.');
INSERT INTO "voyages" VALUES (5534, '', 1, '', 'KOGGE', 'Luit Pietersz.', 400, 'jacht', NULL, '1662', NULL, 'H', 'A', '1665-01-31', 'Batavia', '1665-04-14', '1665-04-22', true, '1666-03-21', 'Vlie', 971, 'Second return fleet (5534-5535), joined the first return fleet (see 5523) at the Cape. According to Daghregister 1665 the KOGGE carried a cargo of 88,576. The ship called at Bergen; departure: 02-09-1665. Later on it returned to Norway (Flecker O and Kristiansand).');
INSERT INTO "voyages" VALUES (5535, '', 1, '', 'NIEUWENHOVE', 'Pieter Koker', 438, 'jacht', '1660', NULL, NULL, 'Z', 'A', '1665-01-31', 'Batavia', '1665-04-16', '1665-04-22', true, '1665-10-31', 'Vlie', 937, 'The crew included 2 passengers.');
INSERT INTO "voyages" VALUES (5536, '', 2, '', 'KALF', 'Pieter Korf', 320, 'jacht? pinas?', NULL, NULL, NULL, 'A', 'Z', '1665-11-18', 'Bengal', '1666-03-06', '1666-05-24', true, '1666-07-01', NULL, 959, 'Separate fleet (5536-5537) from Bengal via Ceylon (departure on 29-12-1665) and Malabar; joined the fleet of 30-01-1666 at the Cape. The original cargo of the KALF From Bengal had an invoice value of 190,754. The ship sailed v ia Bergen. It was wrecked in the Vlie, 22 men were saved.');
INSERT INTO "voyages" VALUES (5537, '', 2, '', 'VENENBURG', 'Adriaan Bastiaansz.', 703, 'fluit', '1656', NULL, NULL, 'A', 'A', '1665-11-18', 'Bengal', '1666-03-06', '1666-05-24', true, '1666-07-01', NULL, 962, 'Original cargo from Bengal: 364,044. The VENENBURG was taken by the English.');
INSERT INTO "voyages" VALUES (5538, '', 1, '', 'BUIENSKERKE', 'Daniel de Loper', 510, 'fluit', '1659', NULL, NULL, 'Z', 'Z', '1666-01-30', 'Batavia', '1666-04-23', '1666-05-24', true, '1666-10-05', 'Vlie', 925, 'with 356 men and 11 passengers. At the Cape the KALF and the VENENBURG (5536 and 5537) joined the fleet.');
INSERT INTO "voyages" VALUES (5539, '', 1, '', 'ELBURG', 'Jakob le Bleu', 360, 'fluit', '1657', NULL, NULL, 'A', 'E', '1666-01-30', 'Batavia', '1666-04-23', '1666-05-24', true, '1666-11-16', 'Vlie', 882, NULL);
INSERT INTO "voyages" VALUES (5540, '', 2, '', 'WASSENDE MAAN', 'Barend Lam van Bunschoten', 400, 'jacht', NULL, '1660', NULL, 'A', 'A', '1666-01-30', 'Batavia', '1666-04-23', '1666-05-24', true, '1666-10-05', 'Vlie', 1006, 'Jakob Kauw, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5541, '', 1, '', 'MEERMAN', 'Laurens Martensz. Suiker', 440, 'jacht', '1663', NULL, NULL, 'D', 'D', '1666-01-30', 'Batavia', '1666-04-23', '1666-05-24', true, '1666-10-05', 'Vlie', 997, NULL);
INSERT INTO "voyages" VALUES (5542, '', 2, '', 'VOGELZANG', 'Thomas Melchiorsz.', 680, 'fluit', NULL, NULL, NULL, 'A', 'A', '1666-01-30', 'Batavia', '1666-05-10', '1666-05-24', true, '1666-07-01', NULL, 932, 'was repaired at Panjon. It sailed via Saldanha Bay (arrival: 25-04-1666). At the Cape the problem of leakage occurred again.');
INSERT INTO "voyages" VALUES (5543, '', 1, '', 'CECILIA', NULL, NULL, 'fluit', NULL, NULL, '1665', 'H', 'H', '1666-12-07', 'Bengal', '1667-03-26', '1667-06-08', true, '1667-10-25', 'Texel', 1035, 'Separate fleet (5543-5545) from Bengal via Ceylon (19-01-1667) and Malabar, joined the return fleet of 26-01-1667 at the Cape. Original cargo of the CECILIA from Batavia: 17,415.');
INSERT INTO "voyages" VALUES (5544, '', 1, '', 'OPPERDOES', 'Jan Blauwmeulen', NULL, 'fluit', NULL, NULL, '1664/5', 'A', 'Z', '1666-12-07', 'Bengal', '1667-03-26', '1667-06-08', true, '1667-10-09', 'Vlie', 1037, 'Batavia: 17,730.');
INSERT INTO "voyages" VALUES (5545, '', 1, '', 'SPARENDAM', 'Pieter Pietersz.', 700, 'fluit', '1662', NULL, NULL, 'A', 'A', '1666-12-07', 'Bengal', '1667-03-26', '1667-06-08', true, '1667-10-22', 'Eems', 992, 'Original cargo from Batavia: 18,317.');
INSERT INTO "voyages" VALUES (5546, '', 5, '', 'AMERSFOORT', 'Pieter Sakke', 1000, NULL, '1655', NULL, NULL, 'A', 'A', '1667-01-26', 'Batavia', '1667-05-13', '1667-06-08', true, '1667-10-25', 'Texel', 1021, '(5554). At he Cape the CECI-LIA, the OPPERDOES, and the SPARENDAM (5543-5545) joined the fleet. The crew of the AMERSFOORT included one passenger.');
INSERT INTO "voyages" VALUES (5547, '', 5, '', 'WAPEN VAN AMSTERDAM', 'Reinier Brinkmans', 920, NULL, '1653', NULL, NULL, 'A', 'A', '1667-01-26', 'Batavia', '1667-06-08', NULL, true, NULL, NULL, 1015, 'On 19-09-1667 the WAPEN VAN AMSTERDAM was wrecked south of Iceland; 14 men were saved.');
INSERT INTO "voyages" VALUES (5548, '', 1, '', 'EENDRACHT', 'Jakob Gommers Bak', 670, NULL, '1663', NULL, NULL, 'D', 'R', '1667-01-26', 'Batavia', '1667-06-08', NULL, true, '1667-10-09', 'Texel', 1013, NULL);
INSERT INTO "voyages" VALUES (5549, '', 1, '', 'ESPERANCE', 'Hans Zwart', NULL, 'fluit', NULL, NULL, '1665', 'H', 'A', '1667-01-26', 'Batavia', '1667-05-08', '1667-06-08', true, '1667-10-21', 'Vlie', 1036, NULL);
INSERT INTO "voyages" VALUES (5550, '', 1, '', 'HAZENBURG', NULL, 636, 'fluit', '1663', NULL, NULL, 'Z', 'D', '1667-01-26', 'Batavia', '1667-05-13', '1667-06-08', true, '1667-10-10', 'Texel', 996, NULL);
INSERT INTO "voyages" VALUES (5551, '', 1, '', 'KASTEEL VAN MEDEMBLIK', 'Gerbrand de Bok', 696, NULL, '1664', NULL, NULL, 'E', 'E', '1667-01-26', 'Batavia', '1667-05-09', '1667-06-08', true, '1667-10-25', 'Texel', 1024, NULL);
INSERT INTO "voyages" VALUES (5552, '', 1, '', 'MIDDELBURG', 'Dirk Knebber', 846, NULL, '1664', NULL, NULL, 'Z', 'Z', '1667-01-26', 'Batavia', '1667-05-13', '1667-06-08', true, '1667-10-25', 'Wielingen', 1029, NULL);
INSERT INTO "voyages" VALUES (5553, '', 3, '', 'WALCHEREN', NULL, 840, NULL, '1661', NULL, NULL, 'Z', 'Z', '1667-01-26', 'Batavia', '1667-05-09', '1667-06-08', true, NULL, NULL, 1051, 'Was wrecked near the Faeroe 
Is. in September 1667. Many men
were drowned.');
INSERT INTO "voyages" VALUES (5554, '', 1, '', 'ZUIDPOLSBROEK', 'Simon Pietersz.', 960, NULL, '1664', NULL, NULL, 'A', 'A', '1667-01-26', 'Batavia', '1667-05-13', '1667-06-08', true, '1667-10-09', 'Texel', 1022, 'The crew included 2 passengers. Aboard the ZUIDPOLS-BROEK was Johan van Dam, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5555, '', 1, '', 'ALPHEN', 'Simon Kornelis van der Meer', 700, 'fluit', '1662', NULL, NULL, 'A', 'A', '1667-10-06', 'Batavia', '1667-12-24', '1668-01-24', true, '1668-05-18', 'Vlie', 990, 'First return fleet (5555-5557) under command of Jan van de Werf, master of the WAPEN VAN HOORN (5556).');
INSERT INTO "voyages" VALUES (5556, '', 2, '', 'WAPEN VAN HOORN', 'Jan van de Werf', 756, 'fluit? jacht?', '1662', NULL, NULL, 'H', 'A', '1667-10-06', 'Batavia', '1667-12-24', '1668-01-24', true, '1668-05-18', 'Vlie', 1056, 'Jan van de Werve was commandeur of the return fleet. According to K.A. 1156 the cargo was destined for the chamber of Hoorn.');
INSERT INTO "voyages" VALUES (5557, '', 1, '', 'CONSTANTIA', NULL, NULL, 'pinas? jacht?', NULL, NULL, '1664/5', 'A', 'E', '1667-10-06', 'Batavia', '1667-12-24', '1668-01-24', true, '1668-05-18', 'Vlie', 1038, NULL);
INSERT INTO "voyages" VALUES (5558, '', 5, '', 'DORDRECHT', NULL, 920, 'fregat', '1652', NULL, NULL, 'D', 'D', '1667-12-07', 'Batavia', '1668-02-23', '1668-03-23', true, '1668-07-15', 'Goeree', 1045, 'Second return fleet (5558-5563) under command of Van der Laan aboard the HOLLANDSE TUIN (5562) and Wagenaar aboard the WAPEN VAN MIDDELBURG (5560). At the Cape the AMERONGEN, the JONGE PRINS. the VRIJHEID, and the SPREEUW (5564-5567) joined the fleet.');
INSERT INTO "voyages" VALUES (5559, '', 1, '', 'KATTENBURG', 'Ouwel Jansz.', 637, 'fluit', '1663', NULL, NULL, 'A', 'A', '1667-12-07', 'Batavia', '1668-02-23', '1668-03-23', true, '1668-07-13', 'Texel', 1003, NULL);
INSERT INTO "voyages" VALUES (5560, '', 1, '', 'WAPEN VAN MIDDELBURG', NULL, 676, NULL, '1666', NULL, NULL, 'Z', 'Z', '1667-12-07', 'Batavia', '1668-02-23', '1668-03-23', true, '1668-07-15', 'Wielingen', 1064, 'Aboard the WAPEN VAN MIDDELBURG was Wagenaar, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5561, '', 1, '', 'OUDSHOORN', 'Jan Flodorp', 666, 'pinas? jacht?', '1663', NULL, NULL, 'A', 'Z', '1667-12-07', 'Batavia', '1668-02-23', '1668-03-23', true, '1668-07-15', 'Wielingen', 1057, NULL);
INSERT INTO "voyages" VALUES (5562, '', 1, '', 'HOLLANDSE TUIN', NULL, 1210, NULL, '1665', NULL, NULL, 'A', 'A', '1667-12-07', 'Batavia', '1668-02-23', '1668-03-23', true, '1668-07-13', 'Texel', 1048, 'Laan. commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5563, '', 1, '', 'VERGULDE TIJGER', '... Zwart', 520, 'fluit? jacht?', NULL, NULL, '1664/5', 'A', 'Z', '1667-12-07', 'Batavia', '1668-02-23', '1668-03-23', true, '1668-07-23', 'Wielingen', NULL, NULL);
INSERT INTO "voyages" VALUES (5564, '', 1, '', 'AMERONGEN', 'Jakob Jansz. Poort', 460, 'jacht', '1662', NULL, NULL, 'A', 'A', '1667-12-24', 'Batavia', '1668-03-10', '1668-03-23', true, '1668-07-20', 'Texel', 991, 'Third return fleet (5564-5566). Joined the fleet of 07-12-1667 at the Cape. The crew of the AMERONGEN included 3 passengers.');
INSERT INTO "voyages" VALUES (5565, '', 3, '', 'JONGE PRINS', NULL, 840, 'jacht', '1661', NULL, NULL, 'H', 'H', '1667-12-24', 'Batavia', '1668-03-10', '1668-03-23', true, '1668-07-13', 'Texel', 1063, NULL);
INSERT INTO "voyages" VALUES (5566, '', 1, '', 'VRIJHEID', 'Douwe Aukesz.', 1210, NULL, '1666', NULL, NULL, 'A', 'A', '1667-12-24', 'Batavia', '1668-03-23', NULL, true, '1668-07-13', 'Texel', 1057, NULL);
INSERT INTO "voyages" VALUES (5567, '', 2, '', 'SPREEUW', NULL, 374, 'fluit', '1657', NULL, NULL, 'Z', 'R', '1667-12-31', 'Batavia', '1668-03-10', '1668-03-23', true, '1668-07-15', 'Maas', 989, 'carried a cargo of 170,212. The ship joined the fleet of 07-12 and that of 24-12-1667 at the Cape.');
INSERT INTO "voyages" VALUES (5568, '', 2, '', 'LOOSDUINEN', 'Daniel de Bak', 340, 'fluit', NULL, NULL, NULL, 'A', 'A', '1668-01-25', 'Ceylon', '1668-04-05', '1668-04-15', true, '1668-07-25', 'Vlie', 1033, NULL);
INSERT INTO "voyages" VALUES (5569, '', 3, '', 'WASSENDE MAAN', NULL, 400, 'jacht', NULL, '1660/1', NULL, 'A', 'A', '1668-01-25', 'Ceylon', '1668-04-05', '1668-04-15', true, '1668-07-23', 'Vlie', 1065, NULL);
INSERT INTO "voyages" VALUES (5570, '', 1, '', 'VLAARDINGEN', NULL, 400, 'jacht? pinas?', '1661', NULL, NULL, 'D', 'A', '1668-01-25', 'Ceylon', '1668-04-05', '1668-04-15', true, '1668-06-01', NULL, 967, NULL);
INSERT INTO "voyages" VALUES (5571, '', 1, '', 'BATAVIA', NULL, 756, 'pinas? jacht?', NULL, '1666', NULL, 'R', 'E', '1668-12-01', 'Batavia', '1669-03-09', '1669-03-24', true, '1669-06-26', NULL, 1055, 'First return fleet (5571-5578) under command of Johan Thijssen aboard the ZUIDPOLSBROEK (5578). Seven heavy storms harassed the fleet before it reached the Cape. The fleet of 14-12 and that of 20-12-1668 joined the command of Johan Thijssen. According to Daghregister 1668/9 the BATAVIA arrived at the Cape on 01-03-1669. The crew included one passenger.');
INSERT INTO "voyages" VALUES (5572, '', 1, '', 'WAPEN VAN GOUDA', NULL, 708, NULL, NULL, '1666/7', NULL, 'A', 'A', '1668-12-01', 'Batavia', '1669-02-25', '1669-03-24', true, '1669-06-30', 'Texel', 1066, 'The crew included 7 passengers.');
INSERT INTO "voyages" VALUES (5573, '', 1, '', 'WAPEN VAN ROTTERDAM', NULL, 1124, NULL, '1666', NULL, NULL, 'R', 'R', '1668-12-01', 'Batavia', '1669-03-01', '1669-03-24', true, '1669-06-29', 'Goeree', 10, '-4 The crew included 10 passengers.');
INSERT INTO "voyages" VALUES (5574, '', 1, '', 'WAPEN VAN VEERE', NULL, 627, 'fluit', '1667', NULL, NULL, 'Z', 'Z', '1668-12-01', 'Batavia', '1669-02-27', '1669-03-24', true, '1669-06-29', 'Wielingen', 1093, NULL);
INSERT INTO "voyages" VALUES (5575, '', 1, '', 'HUIS TE VELSEN', 'Jan Hendriksz. Kim', 750, NULL, '1667', NULL, NULL, 'A', 'A', '1668-12-01', 'Batavia', '1669-02-25', '1669-03-24', true, '1669-06-30', 'Texel', NULL, '-; The crew included 4 passengers.');
INSERT INTO "voyages" VALUES (5576, '', 1, '', 'VRIJE ZEE', NULL, 846, 'pinas', '1667', NULL, NULL, 'D', 'D', '1668-12-01', 'Batavia', '1669-03-01', '1669-03-24', true, '1669-06-29', 'Goeree', 1081, 'The crew included 10 passengers.');
INSERT INTO "voyages" VALUES (5577, '', 2, '', 'RIJZENDE ZON', NULL, 600, NULL, NULL, '1660/1', NULL, 'A', 'Z', '1668-12-01', 'Batavia', '1669-02-25', '1669-03-24', true, '1669-06-29', 'Wielingen', 1047, 'The crew included 5 passengers.');
INSERT INTO "voyages" VALUES (5578, '', 2, '', 'ZUIDPOLSBROEK', 'Johan Zwart', 960, NULL, '1664', NULL, NULL, 'A', 'A', '1668-12-01', 'Batavia', '1669-03-09', '1669-03-24', true, '1669-06-30', 'Texel', 1096, 'on 01-03-1669. Aboard the ZUIDPOLSBROEK was Johan Thijssen, commandeer of the return fleet.');
INSERT INTO "voyages" VALUES (5579, '', 1, '', 'HANDELAAR', NULL, 600, 'fluit', NULL, '1665/6', NULL, 'A', 'A', '1668-12-14', 'Batavia', '1669-03-09', '1669-03-24', true, '1669-06-26', 'Texel', 1062, 'Second return fleet (5579-5580) under command of Enoch Poolvoet aboard the OOSTENBURG; joined the fleet of 01-12-1668 at the Cape.');
INSERT INTO "voyages" VALUES (5580, '', 1, '', 'OOSTENBURG', 'Pieter Jonassen', 840, 'pinas? fluit?', '1667', NULL, NULL, 'A', 'A', '1668-12-14', 'Batavia', '1669-03-09', '1669-03-24', true, '1669-06-29', 'Texel', 1073, 'The crew included one passenger. Aboard the OOSTENBURG was Enoch Poolvoet, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5581, '', 2, '', 'MIDDELBURG', NULL, 846, NULL, '1664', NULL, NULL, 'Z', 'Z', '1668-12-20', 'Batavia', '1669-02-25', '1669-03-24', true, '1669-05-01', NULL, 1097, 'Third return fleet (5581-5583). Joined the fleet of 01-12-1668 at the Cape.');
INSERT INTO "voyages" VALUES (5582, '', 1, '', 'STICHT VAN UTRECHT', 'Paulus Adriaansz. van de ....', 990, NULL, '1667', NULL, NULL, 'A', 'A', '1668-12-20', 'Batavia', '1669-02-25', '1669-03-24', true, '1669-06-26', 'Texel', 1094, 'The crew included 10 passengers.');
INSERT INTO "voyages" VALUES (5583, '', 1, '', 'VOORZICHTIGHEID', NULL, 636, 'fluit', '1667', NULL, NULL, 'H', 'H', '1668-12-20', 'Batavia', '1669-02-28', '1669-03-24', true, '1669-06-30', 'Texel', 1084, 'According to Daghregister 1668/9; cargo 160,990.');
INSERT INTO "voyages" VALUES (5584, '', 2, '', 'BREDERODE', 'Krijn Jansz. Kant?', 666, 'fluit? jacht?', '1663', NULL, NULL, 'A', 'A', '1668-12-30', 'Ceylon', '1669-04-02', '1669-04-13', true, '1669-08-04', 'Texel', 1043, 'Fleet from Ceylon (5584-5587) under command of Rijklof van Goens (Junior) aboard the KOGGE.');
INSERT INTO "voyages" VALUES (5585, '', 2, '', 'SPARENDAM', 'Pieter Pietersz.?', 700, 'fluit', '1662', NULL, NULL, 'A', 'A', '1668-12-30', 'Ceylon', '1669-04-02', '1669-04-13', true, '1669-08-11', 'Texel', 1095, NULL);
INSERT INTO "voyages" VALUES (5586, '', 2, '', 'KOGGE', NULL, 400, 'jacht', NULL, '1662', NULL, 'H', 'A', '1669-01-22', 'Ceylon', '1669-03-24', '1669-04-13', true, '1669-08-10', 'Texel', 1058, 'Aboard the KOGGE was Rijklof van Goens (Junior), commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5587, '', 1, '', 'NUISSENBURG', NULL, 486, 'pinas? jacht?', NULL, '1664/5', NULL, 'A', 'A', '1669-01-22', 'Ceylon', '1669-03-24', '1669-04-13', true, '1669-08-06', 'Texel', 1044, NULL);
INSERT INTO "voyages" VALUES (5588, '', 2, '', 'HAZENBURG', NULL, 636, 'fluit', '1663', NULL, NULL, 'Z', 'Z', '1669-02-01', 'Batavia', '1669-04-16', '1669-04-27', true, '1669-08-04', 'Wielingen', 1100, 'Fourth return fleet (5588-5589).');
INSERT INTO "voyages" VALUES (5589, '', 1, '', 'PAPENBURG', NULL, 500, 'fluit', '1667', NULL, NULL, 'A', 'A', '1669-02-01', 'Batavia', '1669-04-18', '1669-04-27', true, '1669-08-08', 'Texel', 1083, 'According to Coolhaas 111: cargo 237,020.');
INSERT INTO "voyages" VALUES (5590, '', 6, '', 'AMERSFOORT', NULL, 1000, NULL, '1655', NULL, NULL, 'A', 'A', '1669-11-18', 'Batavia', '1670-02-09', '1670-03-17', true, '1670-07-01', 'Texel', 1101, '29 passengers. At the Cape the fleet of 17-12-1668 joined this fleet.');
INSERT INTO "voyages" VALUES (5591, '', 1, '', 'DELFSHAVEN', NULL, 654, 'fluit', '1668', NULL, NULL, 'D', 'D', '1669-11-18', 'Batavia', '1670-02-09', '1670-03-17', true, '1670-07-01', 'Goeree', 1117, NULL);
INSERT INTO "voyages" VALUES (5592, '', 1, '', 'WAPEN VAN GOES', NULL, 671, NULL, '1668', NULL, NULL, 'Z', 'Z', '1669-11-18', 'Batavia', '1670-02-09', '1670-03-17', true, '1670-07-01', 'Wielingen', 1131, NULL);
INSERT INTO "voyages" VALUES (5593, '', 1, '', 'BURCHT VAN LEIDEN', 'Simon Kornelis van der Meer', 1040, NULL, '1667', NULL, NULL, 'A', 'A', '1669-11-18', 'Batavia', '1670-02-09', '1670-03-17', true, '1670-07-01', 'Texel', 1105, 'The crew included 6 passengers.');
INSERT INTO "voyages" VALUES (5594, '', 2, '', 'KASTEEL VAN MEDEMBLIK', NULL, 696, NULL, '1664', NULL, NULL, 'E', 'E', '1669-11-18', 'Batavia', '1670-02-09', '1670-03-17', true, '1670-07-01', 'Texel', 1106, NULL);
INSERT INTO "voyages" VALUES (5595, '', 2, '', 'WAPEN VAN MIDDELBURG', NULL, 676, NULL, '1666', NULL, NULL, 'Z', 'Z', '1669-11-18', 'Batavia', '1670-02-09', '1670-03-17', true, '1670-07-01', 'Wielingen', 1111, NULL);
INSERT INTO "voyages" VALUES (5596, '', 4, '', 'JONGE PRINS', NULL, 840, 'jacht', '1661', NULL, NULL, 'H', 'H', '1669-11-18', 'Batavia', '1670-02-09', '1670-03-17', true, '1670-07-01', 'Texel', 1127, 'According to Daghregister 1668/9: cargo 285,732.');
INSERT INTO "voyages" VALUES (5597, '', 1, '', 'TERNATE', NULL, 1014, 'pinas', '1668', NULL, NULL, 'A', 'A', '1669-11-18', 'Batavia', '1670-02-09', '1670-03-17', true, '1670-07-01', 'Texel', 1124, NULL);
INSERT INTO "voyages" VALUES (5598, '', 2, '', 'HOLLANDSE TUIN', 'Jakob Jansz. Poort', 1210, NULL, '1665', NULL, NULL, 'A', 'A', '1669-11-18', 'Batavia', '1670-02-09', '1670-03-17', true, '1670-07-01', 'Texel', 1114, 'The crew included 4 passengers. Aboard the HOLLANDSE TUIN was Mattheus van den Broek, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5599, '', 1, '', 'WAPEN VAN ZIERIKZEE', NULL, 1094, NULL, '1667', NULL, NULL, 'Z', 'Z', '1669-11-18', 'Batavia', '1670-02-09', '1670-03-17', true, '1670-07-01', 'Wielingen', 1112, NULL);
INSERT INTO "voyages" VALUES (5600, '', 1, '', 'DAMIATE', 'Pieter van Ekeren', 750, 'jacht', '1667', NULL, NULL, 'A', 'A', '1669-12-17', 'Batavia', '1670-02-21', '1670-03-17', true, '1670-07-01', 'Texel', 1070, 'Second return fleet (5600-5604) under command of Johannes Massis aboard the DAMIATE. Joined the fleet of 18-11-1669 at the Cape. The crew of the DAMIATE included 5 passengers.');
INSERT INTO "voyages" VALUES (5601, '', 2, '', 'EENDRACHT', NULL, 670, NULL, '1663', NULL, NULL, 'D', 'R', '1669-12-17', 'Batavia', '1670-02-21', '1670-03-17', true, '1670-07-01', 'Goeree', 1104, NULL);
INSERT INTO "voyages" VALUES (5602, '', 1, '', 'TULPENBURG', 'Dirk van Rijn', 750, 'jacht', '1668', NULL, NULL, 'A', 'A', '1669-12-17', 'Batavia', '1670-02-21', '1670-03-17', true, '1670-07-01', 'Texel', 1109, 'The crew included 5 passengers.');
INSERT INTO "voyages" VALUES (5603, '', 1, '', 'WAPEN VAN VLISSINGEN', NULL, 725, 'jacht', '1667', NULL, NULL, 'Z', 'Z', '1669-12-17', 'Batavia', '1670-02-22', '1670-03-17', true, '1670-07-01', 'Wielingen', 1087, NULL);
INSERT INTO "voyages" VALUES (5604, '', 1, '', 'GEKROONDE VREDE', NULL, 730, NULL, '1667', NULL, NULL, 'E', 'E', '1669-12-17', 'Batavia', '1670-02-21', '1670-03-17', true, '1670-07-01', 'Texel', 1098, NULL);
INSERT INTO "voyages" VALUES (5605, '', 1, '', 'BEEMSTER', 'Pieter Maartensz. Wildvang', 514, 'fluit', '1667', NULL, NULL, 'A', 'A', '1670-01-15', 'Ceylon', '1670-03-29', '1670-04-21', true, '1670-07-29', 'Texel', 1099, 'The fleet (5605-5606) from Ceylon joined the fleet of 01-02-1670 at the Cape.');
INSERT INTO "voyages" VALUES (5606, '', 2, '', 'OUDSHOORN', 'Jan Aartsz.', 666, 'jacht? pinas?', '1663', NULL, NULL, 'A', 'Z', '1670-01-15', 'Ceylon', '1670-04-01', '1670-04-21', true, '1670-08-01', 'Wielingen', 1119, NULL);
INSERT INTO "voyages" VALUES (5607, '', 1, '', 'OSDORP', NULL, 448, 'fluit', '1668', NULL, NULL, 'A', 'A', '1670-02-01', 'Batavia', '1670-04-10', '1670-04-21', true, '1670-07-29', 'Texel', 1133, 'Third return fleet (5607-5608). The fleet from Ceylon joined this fleet at the Cape.');
INSERT INTO "voyages" VALUES (5608, '', 1, '', 'UITDAM', NULL, 448, 'fluit', '1668', NULL, NULL, 'A', 'A', '1670-02-01', 'Batavia', NULL, NULL, true, '1670-08-02', 'Texel', 1134, NULL);
INSERT INTO "voyages" VALUES (5609, '', 6, '', 'DORDRECHT', NULL, 920, 'fregat', '1652', NULL, NULL, 'D', 'R', '1670-11-19', 'Batavia', '1671-02-01', '1671-02-26', true, '1671-06-14', 'Goeree', 1136, 'First return fleet (5609-5616) under command of IJsbrand Goske aboard the STICHT VAN UTRECHT (5614). At the Cape the HUIS TE VELSEN (5617) and the fleet of 19-12-1670 from Ceylon joined this fleet. According to Daghregister 1671 the fleet left the Cape on 16-03-1671.');
INSERT INTO "voyages" VALUES (5610, '', 1, '', 'GERECHTIGHEID', NULL, 652, NULL, '1665', NULL, NULL, 'A', 'E', '1670-11-19', 'Batavia', '1671-02-01', '1671-02-26', true, '1671-06-14', 'Texel', 1053, NULL);
INSERT INTO "voyages" VALUES (5611, '', 2, '', 'WAPEN VAN GOUDA', NULL, 708, NULL, NULL, '1666/7', NULL, 'A', 'A', '1670-11-19', 'Batavia', '1671-02-01', '1671-02-26', true, '1671-06-14', 'Texel', 1151, NULL);
INSERT INTO "voyages" VALUES (5612, '', 3, '', 'WAPEN VAN HOORN', NULL, 756, 'fluit? jacht?', '1662', NULL, NULL, 'H', 'H', '1670-11-19', 'Batavia', '1671-02-01', '1671-02-26', true, '1671-06-14', 'Texel', 1115, NULL);
INSERT INTO "voyages" VALUES (5613, '', 3, '', 'MIDDELBURG', NULL, 846, NULL, '1664', NULL, NULL, 'Z', 'Z', '1670-11-19', 'Batavia', '1671-02-01', '1671-02-26', true, '1671-06-14', 'Wielingen', 1157, NULL);
INSERT INTO "voyages" VALUES (5614, '', 2, '', 'STICHT VAN UTRECHT', NULL, 990, NULL, '1667', NULL, NULL, 'A', 'A', '1670-11-19', 'Batavia', '1671-02-01', '1671-02-26', true, '1671-06-14', 'Texel', 1153, 'STICHT VAN UTRECHT was IJsbrand Goske. commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5615, '', 1, '', 'PRINS WILLEM HENDRIK', NULL, 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1670-11-19', 'Batavia', '1671-02-01', '1671-02-26', true, '1671-06-14', 'Wielingen', 1141, NULL);
INSERT INTO "voyages" VALUES (5616, '', 2, '', 'VRIJE ZEE', NULL, 846, 'pinas', '1667', NULL, NULL, 'D', 'D', '1670-11-19', 'Batavia', '1671-02-01', '1671-02-26', true, '1671-06-14', 'Goeree', 1160, NULL);
INSERT INTO "voyages" VALUES (5617, '', 2, '', 'HUIS TE VELSEN', 'Sieuwert Roos', 750, NULL, '1667', NULL, NULL, 'A', 'A', '1670-12-07', 'Ceylon', '1671-02-11', '1671-02-26', true, '1671-06-15', 'Texel', 1154, 'Joined the fleet of 19-11-1670 at the Cape.');
INSERT INTO "voyages" VALUES (5618, '', 1, '', 'HOF VAN BREDA', NULL, 670, 'jacht', '1667', NULL, NULL, 'A', 'E', '1670-12-16', 'Batavia', '1671-03-06', '1671-03-22', true, '1671-07-08', 'Texel', 1088, 'Second return fleet (5618-5621) under command of Pieter Koopman aboard the VRIJHEID (5620). At the Cape the SPANBROEK (5624) joined the fleet. According to K.A. 3984 the fleet left the Cape on 20-03-1671.');
INSERT INTO "voyages" VALUES (5619, '', 2, '', 'WAPEN VAN VEERE', NULL, 627, 'fluit', '1667', NULL, NULL, 'Z', 'Z', '1670-12-16', 'Batavia', '1671-03-06', '1671-03-22', true, '1671-07-10', 'Wielingen', 1146, NULL);
INSERT INTO "voyages" VALUES (5620, '', 2, '', 'VRIJHEID', NULL, 1210, NULL, '1666', NULL, NULL, 'A', 'A', '1670-12-16', 'Batavia', '1671-03-06', '1671-03-22', true, '1671-07-08', 'Texel', 1135, 'The crew included 2 passengers. Aboard the VRIJHEID was Pieter Koopman, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5621, '', 3, '', 'ZUIDPOLSBROEK', 'Jakob Albertsz. Been', 960, NULL, '1664', NULL, NULL, 'A', 'A', '1670-12-16', 'Batavia', '1671-03-06', '1671-03-22', true, '1671-07-08', 'Texel', 1163, 'The crew included 6 passengers.');
INSERT INTO "voyages" VALUES (5622, '', 2, '', 'KATTENBURG', NULL, 637, 'fluit', '1663', NULL, NULL, 'A', 'Z', '1670-12-19', 'Ceylon', '1671-02-14', '1671-02-26', true, '1671-06-15', 'Wielingen', 1113, 'The fleet (5622-5623) from Ceylon joined the fleet of 19-11-1670 at the Cape. According to K.A.3984 the fleet left Ceylon on 25-12-1670.');
INSERT INTO "voyages" VALUES (5623, '', 1, '', 'ZOETENDAAL', 'Jan van der Putte', 448, 'fluit', '1669', NULL, NULL, 'Z', 'A', '1670-12-19', 'Ceylon', '1671-02-14', '1671-02-26', true, '1671-06-14', 'Texel', 1158, NULL);
INSERT INTO "voyages" VALUES (5624, '', 1, '', 'SPANBROEK', NULL, 448, 'fluit', '1669', NULL, NULL, 'A', 'A', '1671-01-14', 'Ceylon', '1671-03-09', '1671-03-20', true, '1671-07-08', 'Texel', 1147, 'Joined the fleet of 16-12-1670 at the Cape.');
INSERT INTO "voyages" VALUES (5625, '', 1, '', 'SAKSENBURG', NULL, 450, 'fluit', '1669', NULL, NULL, 'A', 'A', '1671-02-01', 'Batavia', NULL, NULL, true, '1671-09-02', 'Texel', 1162, 'Third return fleet (5625-5626).');
INSERT INTO "voyages" VALUES (5626, '', 1, '', 'WIMMENUM', 'Adriaan Dromt', 448, 'fluit', '1669', NULL, NULL, 'A', 'A', '1671-02-01', 'Batavia', '1671-04-10', '1671-04-23', true, '1671-08-24', 'Vlie', 1148, 'After a dinner at the Cape the master was stabbed in a quarrel and died. His successor was Isaak Fontein.');
INSERT INTO "voyages" VALUES (5627, '', 2, '', 'DELFSHAVEN', NULL, 654, 'fluit', '1668', NULL, NULL, 'D', 'D', '1671-12-20', 'Batavia', '1672-04-05', '1672-04-24', true, '1672-08-03', 'Eems', 1178, 'aboard the TERNATE (5632), and schout-bij-nacht Sanderus aboard the DELFSHAVEN. At the Cape the fleet of 20-01-1672 from Ceylon and the fleet of 04-02-1672 joined this fleet. According to K.A. 3984 the combined fleet left the Cape on 19-04-1672.');
INSERT INTO "voyages" VALUES (5628, '', 2, '', 'WAPEN VAN GOES', NULL, 671, NULL, '1668', NULL, NULL, 'Z', 'Z', '1671-12-20', 'Batavia', '1672-03-26', '1672-04-24', true, '1672-08-03', 'Eems', 1193, NULL);
INSERT INTO "voyages" VALUES (5629, '', 3, '', 'KASTEEL VAN MEDEMBLIK', NULL, 696, NULL, '1664', NULL, NULL, 'E', 'E', '1671-12-20', 'Batavia', '1672-04-05', '1672-04-24', true, '1672-08-03', 'Eems', 1182, 'Via St. Helena.');
INSERT INTO "voyages" VALUES (5630, '', 2, '', 'OOSTENBURG', NULL, 840, 'pinas? fluit?', '1667', NULL, NULL, 'A', 'A', '1671-12-20', 'Batavia', '1672-04-05', '1672-04-24', true, '1672-08-03', 'Eems', 1161, NULL);
INSERT INTO "voyages" VALUES (5631, '', 2, '', 'WAPEN VAN ROTTERDAM', NULL, 1124, NULL, '1666', NULL, NULL, 'R', 'R', '1671-12-20', 'Batavia', '1672-03-30', '1672-04-24', true, '1672-08-03', 'Eems', 1164, NULL);
INSERT INTO "voyages" VALUES (5632, '', 2, '', 'TERNATE', NULL, 1014, 'pinas', '1668', NULL, NULL, 'A', 'A', '1671-12-20', 'Batavia', '1672-03-25', '1672-04-24', true, '1672-08-03', 'Eems', 1184, 'Aboard the TERNATE was Schimmelpennink, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5633, '', 1, '', 'TIDORE', NULL, 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1671-12-20', 'Batavia', '1672-03-25', '1672-04-24', true, '1672-08-03', 'Eems', 1186, 'Aboard the TIDORE was Arnoud van Overbeke, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5634, '', 2, '', 'VOORZICHTIGHEID', NULL, 636, 'fluit', '1667', NULL, NULL, 'H', 'A', '1671-12-20', 'Batavia', '1672-03-26', '1672-04-24', true, '1672-08-03', 'Eems', 1159, NULL);
INSERT INTO "voyages" VALUES (5635, '', 2, '', 'GEKROONDE VREDE', NULL, 750, NULL, '1667', NULL, NULL, 'E', 'H', '1671-12-20', 'Batavia', '1672-03-25', '1672-04-24', true, '1672-08-03', 'Eems', 1176, NULL);
INSERT INTO "voyages" VALUES (5636, '', 2, '', 'WAPEN VAN ZIERIKZEE', NULL, 1094, NULL, '1667', NULL, NULL, 'Z', 'Z', '1671-12-20', 'Batavia', '1672-03-26', '1672-04-24', true, '1672-08-03', 'Eems', 1187, NULL);
INSERT INTO "voyages" VALUES (5637, '', 1, '', 'DOLFUN', NULL, 90, 'hoeker? bootje?', '1668', NULL, NULL, 'R', 'Z', '1672-01-20', 'Ceylon', NULL, NULL, true, '1672-09-01', NULL, 1108, 'undercommand of Johan de Barra joined the fleet of 20-12-1671 at the Cape. According to K.A. 3984 the combined fleet left the Cape on 19-04-1672.');
INSERT INTO "voyages" VALUES (5638, '', 3, '', 'SPARENDAM', NULL, 700, 'fluit', '1662', NULL, NULL, 'A', 'A', '1672-01-20', 'Ceylon', '1672-03-23', '1672-04-24', true, '1672-08-03', 'Eems', 1172, NULL);
INSERT INTO "voyages" VALUES (5639, '', 1, '', 'ZWANENBURG', NULL, 508, 'fluit', '1670', NULL, NULL, 'Z', 'Z', '1672-01-20', 'Ceylon', '1672-03-21', '1672-04-24', true, '1672-08-03', 'Eems', 1177, NULL);
INSERT INTO "voyages" VALUES (5640, '', 1, '', 'GOOILAND', NULL, 468, 'fluit', '1668', NULL, NULL, 'A', 'A', '1672-02-04', 'Batavia', '1672-04-09', '1672-04-24', true, '1672-08-03', 'Eems', 1107, 'Second return fleet (5640-5641); joined the fleet of 20-12-1671 at the Cape. According to K.A. 3984 the combined fleet left the Cape on 19-04-1672.');
INSERT INTO "voyages" VALUES (5641, '', 1, '', 'GROOTEBROEK', NULL, 464, 'fluit', '1670', NULL, NULL, 'E', 'A', '1672-02-04', 'Batavia', '1672-04-09', '1672-04-24', true, '1672-08-03', 'Eems', 1180, NULL);
INSERT INTO "voyages" VALUES (5642, '', 2, '', 'ALPHEN', 'Jan Kop', 700, 'fluit', '1662', NULL, NULL, 'A', 'A', '1673-02-04', 'Batavia', '1673-04-20', '1673-05-11', true, NULL, NULL, 1125, 'Return fleet (5642-5647) under command of Abraham Huibrechtsen aboard the WAPEN VAN VEERE (5647) and Eduard Goudsmit aboard the PIJNACKER (5645). The ALPHEN was taken by the English at St. Helena, May 1673.');
INSERT INTO "voyages" VALUES (5643, '', 1, '', '''FRANSE'' EUROPA', 'Pieter Koker', NULL, 'fluit', 'taken 1672', NULL, NULL, NULL, 'H', '1673-02-04', 'Batavia', '1673-04-15', '1673-04-29', true, NULL, NULL, NULL, 'The EUROPA originally was a French ship, captured in the Indies (October 1672). According to Daghregister 167314 the ship left the Cape on 10-05-1673. At St. Helena it was taken by the English, May 1673.');
INSERT INTO "voyages" VALUES (5644, '', 2, '', 'PAPENBURG', 'Simon Kroon? Jan Koning?', 500, 'fluit', '1667', NULL, NULL, 'A', 'E', '1673-02-04', 'Batavia', '1673-04-20', '1673-05-11', true, NULL, NULL, 1167, 'Due to wrong instructions the PAPENBURG was taken by the English off Texel, August 1673.');
INSERT INTO "voyages" VALUES (5645, '', 1, '', 'PIJNACKER', NULL, 472, 'fluit', '1670', NULL, NULL, 'D', 'D', '1673-02-04', 'Batavia', '1673-04-20', '1673-05-11', true, '1673-09-25', 'Texel', 1179, 'Aboard the PIJNACKER was Eduard Goudsmit, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5646, '', 1, '', 'STERMEER', 'Jan van Dorre', 502, 'fluit', '1669', NULL, NULL, 'H', 'R', '1673-02-04', 'Batavia', '1673-04-20', '1673-05-11', true, '1673-09-25', 'Texel', 1174, NULL);
INSERT INTO "voyages" VALUES (5647, '', 3, '', 'WAPEN VAN VEERS', NULL, 627, 'fluit', '1667', NULL, NULL, 'Z', 'Z', '1673-02-04', 'Batavia', '1673-04-20', '1673-05-11', true, NULL, NULL, 1204, 'Aboard the WAPEN VAN VEERE was Abraham Huibrechtsen, commandeur of the return fleet. The ship was taken by the English at St. Helena, May 1673.');
INSERT INTO "voyages" VALUES (5648, '', 1, '', 'KOKMEEUW', NULL, 90, 'hoeker', '1667', NULL, NULL, 'R', 'A', '1673-02-06', 'Ceylon', '1673-04-09', '1673-05-10', true, '1673-10-05', 'Texel', 1076, 'Sailed via Bergen (Norway).');
INSERT INTO "voyages" VALUES (5649, '', 1, '', 'POSTHOORN', NULL, 60, 'bootje', NULL, '1671', NULL, 'Z', 'Z', '1673-09-17', 'The Cape', '1673-09-17', NULL, true, '1673-12-29', 'Texel', 1222, NULL);
INSERT INTO "voyages" VALUES (5650, '', 1, '', 'BAARS', NULL, 90, 'hoeker', '1668', NULL, NULL, 'R', 'R', '1674-02-04', 'Batavia', '1674-05-02', '1674-06-03', true, '1674-09-25', 'Texel', 1129, 'Return fleet (5650-5658) under command of Nikolaas de Rooi aboard the BURCHT VAN LEIDEN (5654), Jan Blauwmeulen aboard the MIDDELBURG (5655), and Jan Lambertsz. Radder aboard the BUREN (5653). At the Cape the ZWEMMER (5659) joined the fleet. The BAARS carried rice to the Cape and sailed on to patria.');
INSERT INTO "voyages" VALUES (5651, '', 2, '', 'BEEMSTER', 'Adriaan Bastiaansz. Schepers', 514, 'fluit', '1667', NULL, NULL, 'A', 'R', '1674-02-04', 'Batavia', '1674-04-25', '1674-06-03', true, '1674-10-01', NULL, 1197, 'Acc. to Daghregister 1674 the ship arrived at the Cape on 02 or 04-05-1674.');
INSERT INTO "voyages" VALUES (5652, '', 2, '', 'HOF VAN BREDA', 'Jakob Klok', 670, 'jacht', '1667', NULL, NULL, 'A', 'E', '1674-02-04', 'Batavia', '1674-05-02', '1674-06-03', true, '1674-08-01', NULL, 1207, NULL);
INSERT INTO "voyages" VALUES (5653, '', 1, '', 'BUREN', 'Kornelis de Gilde', 468, 'fluit', '1670', NULL, NULL, 'A', 'D', '1674-02-04', 'Batavia', '1674-05-02', '1674-06-03', true, '1674-08-01', NULL, 1169, 'Aboard the BUREN was Jan Lambertsz. Radder, schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (5654, '', 2, '', 'BURCHT VAN LEIDEN', 'Kornelis Zwart', 1040, NULL, '1667', NULL, NULL, 'A', 'A', '1674-02-04', 'Batavia', '1674-05-02', '1674-06-03', true, '1674-10-01', 'Goeree', 1194, 'Aboard the BURCHT VAN LEIDEN was Nikolaas de Rooi, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5655, '', 4, '', 'MIDDELBURG', NULL, 846, NULL, '1664', NULL, NULL, 'Z', 'Z', '1674-02-04', 'Batavia', '1674-11-13', '1675-02-12', true, '1675-04-01', NULL, 1220, 'The MIDDELBURG sailed via Anjouan (09-06-1674) and the Mayotte Islands (12-08 till 03-10-1674), meeting with many difficulties and loosing about 60 men, The ship joined the fleet of 18-11-1674 at the Cape. Aboard the MIDDELBURG was Jan Blauwmeulen, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5656, '', 2, '', 'SPANBROEK', 'Jan Hendriksz. Boon', 448, 'fluit', '1669', NULL, NULL, 'A', 'H', '1674-02-04', 'Batavia', '1674-05-02', '1674-06-03', true, '1674-10-05', NULL, 1203, NULL);
INSERT INTO "voyages" VALUES (5657, '', 3, '', 'HOLLANDSE TUIN', 'Jan Zwart', 1210, NULL, '1665', NULL, NULL, 'A', 'A', '1674-02-04', 'Batavia', '1674-05-05', '1674-06-03', true, '1674-10-01', 'Goeree', 1200, NULL);
INSERT INTO "voyages" VALUES (5658, '', 2, '', 'PRINS WILLEM HENDRIK', 'Adriaan Sleutel', 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1674-02-04', 'Batavia', '1674-05-02', '1674-06-03', true, '1674-09-25', 'Wielingen', 1221, NULL);
INSERT INTO "voyages" VALUES (5659, '', 1, '', 'ZWEMMER', NULL, 90, 'hoeker', '1669', NULL, NULL, 'D', 'A', '1674-02-12', 'Ceylon', '1674-05-04', '1674-06-03', true, '1674-09-25', 'Texel', 1156, 'Joined the fleet of 04-02-1674 at the Cape.');
INSERT INTO "voyages" VALUES (5660, '', 3, '', 'EENDRACHT', 'Simon Kornelisz. van der Meer', 670, NULL, '1663', NULL, NULL, 'D', 'R', '1674-11-18', 'Batavia', '1675-01-19', '1675-02-12', true, '1675-06-07', NULL, 1190, '(5663), and Jakob Ganswijk aboard the VRIJE ZEE (5666). At the Cape the MIDDELBURG (5655) and the KROONVOGEL (5674) joined the fleet.');
INSERT INTO "voyages" VALUES (5661, '', 1, '', 'MAKASSAR', NULL, 1014, 'pinas', '1671', NULL, NULL, 'A', 'A', '1674-11-18', 'Batavia', '1675-01-19', '1675-02-12', true, '1675-06-07', NULL, 1210, 'Aboard the MAKASSAR was Kornelis Valkenier, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5662, '', 5, '', 'JONGE PRINS', 'Kornelis Bakker', 840, 'jacht', '1661', NULL, NULL, 'H', 'H', '1674-11-18', 'Batavia', '1675-01-19', '1675-02-12', true, '1675-04-01', NULL, 1214, NULL);
INSERT INTO "voyages" VALUES (5663, '', 2, '', 'TIDORE', NULL, 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1674-11-18', 'Batavia', '1675-01-19', '1675-02-12', true, '1675-04-01', NULL, 1254, 'According to Valentijn: cargo 337,695. Aboard the TIDORE was Adam van Breen, vice-commandeur of the return fleet,');
INSERT INTO "voyages" VALUES (5664, '', 3, '', 'STICHT VAN UTRECHT', 'Jan Kraan', 990, NULL, '1667', NULL, NULL, 'A', 'A', '1674-11-18', 'Batavia', '1675-01-19', '1675-02-12', true, '1675-04-01', NULL, 1205, NULL);
INSERT INTO "voyages" VALUES (5665, '', 3, '', 'VRIJHEID', 'Klaas de Rood', 1210, NULL, '1666', NULL, NULL, 'A', 'E', '1674-11-18', 'Batavia', '1675-01-19', '1675-02-12', true, '1675-04-01', NULL, 1229, NULL);
INSERT INTO "voyages" VALUES (5666, '', 3, '', 'VRIJE ZEE', NULL, 846, 'pinas', '1667', NULL, NULL, 'D', 'D', '1674-11-18', 'Batavia', NULL, NULL, false, '1675-06-07', 'Goeree', 1215, 'through Sunda Strait the ship lost sight of the fleet. Due to a French attack it did not call at the Cape, and sailed via Pernambuco (Brazil). Aboard the VRIJE ZEE was Jakob Ganswijk, schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (5667, '', 1, '', 'KWARTEL', NULL, 96, 'hoeker', '1672', NULL, NULL, 'A', 'A', '1675-01-07', 'Ceylon', NULL, NULL, true, '1675-05-12', 'Texel', 1248, NULL);
INSERT INTO "voyages" VALUES (5668, '', 3, '', 'WAPEN VAN GOES', NULL, 671, NULL, '1668', NULL, NULL, 'Z', 'Z', '1675-01-12', 'Ceylon', '1675-03-24', '1675-05-01', true, '1675-07-01', NULL, 1238, 'joined the fleet of 28-01-1675 at the Cape. According to Valentijn the Ceylon-fleet departed on 07-01-1675.');
INSERT INTO "voyages" VALUES (5669, '', 1, '', 'PRESIDENT', NULL, NULL, 'jacht', NULL, NULL, NULL, NULL, 'A', '1675-01-12', 'Ceylon', '1675-03-24', '1675-05-01', true, '1675-07-01', NULL, NULL, 'Captured from the English.');
INSERT INTO "voyages" VALUES (5670, '', 1, '', 'WAPEN VAN ALKMAAR', 'Hendrik Bommer', 892, 'pinas', '1671', NULL, NULL, 'A', 'A', '1675-01-28', 'Batavia', '1675-04-18', '1675-05-01', true, '1675-07-01', NULL, 1233, 'Second return fleet (5670-5673) under command of Ludder Brummer aboard the AZIE (5671) and Jakob Valk, master of the WAPEN VAN ZIERIKZEE (5673). At the Cape the Ceylon-fleet of 12-01-1675 joined this fleet.');
INSERT INTO "voyages" VALUES (5671, '', 1, '', 'AZIE', 'Willem Hagedoorn', 1140, NULL, '1671', NULL, NULL, 'A', 'A', '1675-01-28', 'Batavia', '1675-04-18', '1675-05-01', true, '1675-07-01', NULL, 1236, 'Aboard the AZIE was Ludder Brummer, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5672, '', 1, '', 'DEN BRIEL', 'Adriaan van der Werf', 766, NULL, '1671', NULL, NULL, 'D', 'E', '1675-01-28', 'Ceylon', '1675-04-18', '1675-05-01', true, '1675-07-01', NULL, 1231, 'The DEN BRIEL sailed from Ceylon and waited in Sunda Strait for the fleet of 28-01-1675.');
INSERT INTO "voyages" VALUES (5673, '', 3, '', 'ZIERIKZEE', 'Jakob Valk', 1094, NULL, '1667', NULL, NULL, 'Z', 'Z', '1675-01-28', 'Batavia', '1675-04-18', '1675-05-01', true, '1675-07-01', NULL, 1256, 'return fleet.');
INSERT INTO "voyages" VALUES (5674, '', 1, '', 'KROONVOGEL', NULL, 108, 'hoeker', '1673', NULL, NULL, 'A', 'A', '1675-02-12', 'The Cape', '1675-02-12', NULL, true, '1675-05-01', NULL, 1265, 'The ship sailed from the Cape together with the return fleet of 18-11-1674.');
INSERT INTO "voyages" VALUES (5675, '', 1, '', 'MUIDERBERG', NULL, 400, 'jacht', '1672', NULL, NULL, 'A', 'Z', '1675-03-07', 'Batavia', NULL, NULL, false, '1675-07-01', NULL, 1243, 'to the Indies (see 1308),');
INSERT INTO "voyages" VALUES (5676, '', 1, '', 'AFRIKA', 'Adriaan Jakobsz. Zwart', 1100, NULL, '1673', NULL, NULL, 'R', 'R', '1675-11-21', 'Batavia', '1676-02-04', '1676-03-18', true, '1676-07-16', NULL, 1269, '02-01-1676 joined this fleet.');
INSERT INTO "voyages" VALUES (5677, '', 1, '', 'AMERIKA', 'Jan Sijbrandsz. Doen', 1002, 'pinas', '1674', NULL, NULL, 'H', 'H', '1675-11-21', 'Batavia', '1676-02-04', '1676-03-18', true, '1676-07-16', NULL, 1271, NULL);
INSERT INTO "voyages" VALUES (5678, '', 1, '', 'HENDRIK MAURITS', 'Reinier Reiniersz.', 1194, NULL, '1673', NULL, NULL, 'Z', 'Z', '1675-11-21', 'Batavia', '1676-02-04', '1676-03-18', true, '1676-07-16', NULL, 1270, NULL);
INSERT INTO "voyages" VALUES (5679, '', 1, '', 'HOVELING', 'Bruin Jansz.', NULL, 'fluit', NULL, NULL, '1673/4', 'A', 'A', '1675-11-21', 'Batavia', '1676-02-04', '1676-03-18', true, '1676-07-16', 'Texel', 1275, 'According to Daghreg. 1675 49 men on board had been privately recruited by the master of the ship, and 16 men by the Company. Acc. to K.A. 1198 the ship arrived on 11-07-1676 at Texel.');
INSERT INTO "voyages" VALUES (5680, '', 1, '', 'BLAUWE HULK', 'Jakob van der Kamme', 744, 'pinas', '1673', NULL, NULL, 'E', 'E', '1675-11-21', 'Batavia', '1676-02-04', '1676-03-18', true, '1676-07-16', NULL, 1260, NULL);
INSERT INTO "voyages" VALUES (5681, '', 1, '', 'KOEWERVE', 'Kornelis Mathall', 698, 'pinas', '1672', NULL, NULL, 'Z', 'Z', '1675-11-21', 'Batavia', '1676-02-04', '1676-03-18', true, '1676-07-16', NULL, 1261, NULL);
INSERT INTO "voyages" VALUES (5682, '', 1, '', 'EILAND MAURITIUS', 'Kornelis Kriek', 756, 'pinas', '1672', NULL, NULL, 'D', 'D', '1675-11-21', 'Batavia', '1676-02-04', '1676-03-18', true, '1676-07-16', NULL, 1274, NULL);
INSERT INTO "voyages" VALUES (5683, '', 3, '', 'OOSTENBURG', 'Klaas Pietersz. Sluiter', 840, 'pinas? fluit?', '1667', NULL, NULL, 'A', 'A', '1675-11-21', 'Batavia', '1676-02-04', '1676-03-18', true, '1676-07-16', 'Texel', 1244, 'Acc. to K.A. 1198 the ship arrived at Texel on 11-07-1676.');
INSERT INTO "voyages" VALUES (5684, '', 2, '', 'POSTHOORN', 'Barend Fokkesz.', 60, 'bootje', NULL, '1671', NULL, 'Z', 'A', '1675-11-21', 'Batavia', '1676-02-04', '1676-03-18', true, '1676-07-16', 'Texel', 1266, 'Acc. to K.A. 1198 the ship arrived at Texel on 11-07-1676.');
INSERT INTO "voyages" VALUES (5685, '', 1, '', 'SUMATRA', 'Jakob Albertsz. Been', 738, 'pinas', '1673', NULL, NULL, 'A', 'A', '1675-11-21', 'Batavia', '1676-02-04', '1676-03-18', true, '1676-07-16', 'Texel', 1277, 'Acc. to K.A. 1198 the ship arrived at Texel on 11-07-1676.');
INSERT INTO "voyages" VALUES (5686, '', 3, '', 'TERNATE', 'Hendrik Span', 1014, 'pinas', '1668', NULL, NULL, 'A', 'A', '1675-11-21', 'Batavia', '1676-02-04', '1676-03-18', true, '1676-07-16', 'Texel', 1247, 'Aboard the TERNATE was Nikolaas Verburg, commandeur of the return fleet. Acc. to K.A. 1198 the ship arrived at Texel on 11-07-1676.');
INSERT INTO "voyages" VALUES (5687, '', 3, '', 'BEEMSTER', NULL, 514, 'fluit', '1667', NULL, NULL, 'A', 'A', '1676-01-02', 'Ceylon', '1676-03-01', '1676-03-18', true, '1676-07-16', NULL, 1281, 'The fleet (5687-5688) from Ceylon joined the fleet of 21-11-1675 at the Cape. According to Daghregister 1676 the BEEMSTER departed on 17-11-1675 from Ceylon, and arrived on 13-03-1676 at the Cape.');
INSERT INTO "voyages" VALUES (5688, '', 3, '', 'SPANBROEK', NULL, 448, 'fluit', '1669', NULL, NULL, 'A', 'Z', '1676-01-02', 'Ceylon', '1676-03-02', '1676-03-18', true, '1676-07-16', NULL, 1287, 'the Cape.');
INSERT INTO "voyages" VALUES (5689, '', 1, '', 'ALEXANDER', 'Joost Goest', 524, 'pinas? jacht?', '1674', NULL, NULL, 'Z', 'Z', '1676-02-08', 'Batavia', '1676-04-26', '1676-05-22', true, '1676-09-15', NULL, 1289, 'Second return fleet (5689-5691) under command of Klaas Voogd, master of the CEYLON (5690). The crew of the ALEXANDER included 72 seafarers.');
INSERT INTO "voyages" VALUES (5690, '', 1, '', 'CEYLON', 'Klaas Voogd', 776, NULL, '1673', NULL, NULL, 'A', 'A', '1676-02-08', 'Batavia', '1676-04-26', '1676-05-22', true, '1676-09-15', 'Vlie', 1284, 'Klaas Voogd was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5691, '', 3, '', 'VOORZICHTIGHEID', 'Ouwel Jansz.', 636, 'fluit', '1667', NULL, NULL, 'H', 'A', '1676-02-08', 'Batavia', '1676-04-26', '1676-05-22', true, '1676-09-15', 'Vlie', 1258, 'Acc. to Daghregister 1676: cargo 163,760. Amongst the crew were 81 seafarers.');
INSERT INTO "voyages" VALUES (5692, '', 2, '', 'DEN BRIEL', 'Jan Bornee', 766, NULL, '1671', NULL, NULL, 'D', 'H', '1676-11-25', 'Batavia', '1677-02-22', '1677-03-18', true, '1677-05-01', NULL, 1311, 'First return fleet (5692-5700) under command of Gijsbert David Strandwijk aboard the BURCHT VAN LEIDEN (5696), Jan Bartelsz. Tand aboard the PRINS WILLEM HENDRIK (5700), and Laurens Martensz. Suiker aboard the DELFSHAVEN (5693). According to Valentijn the fleet departed on 2111-1676 from Batavia.');
INSERT INTO "voyages" VALUES (5693, '', 3, '', 'DELFSHAVEN', NULL, 654, 'fluit', '1668', NULL, NULL, 'D', 'D', '1676-11-25', 'Batavia', '1677-02-23', '1677-03-18', true, '1677-05-01', NULL, 1253, 'Aboard the DELFSHAVEN was Laurens Martensz. Suiker, schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (5694, '', 1, '', 'EUROPA', 'Sieuwert Roos', 1140, NULL, '1671', NULL, NULL, 'A', 'A', '1676-11-25', 'Batavia', '1677-02-26', '1677-03-18', true, '1677-07-08', 'Texel', 1240, NULL);
INSERT INTO "voyages" VALUES (5695, '', 1, '', 'HELLEVOETSLUIS', 'Jan Voorman', 714, 'pinas', '1671', NULL, NULL, 'R', 'R', '1676-11-25', 'Batavia', '1677-02-27', '1677-03-18', true, '1677-05-01', NULL, 1230, NULL);
INSERT INTO "voyages" VALUES (5696, '', 3, '', 'BURCHT VAN LEIDEN', 'Balthus Groen', 1040, NULL, '1667', NULL, NULL, 'A', 'A', '1676-11-25', 'Batavia', '1677-02-22', '1677-03-18', true, '1677-07-08', 'Texel', 1292, 'Aboard the BURCHT VAN LEIDEN was Gijsbert David Strandwijk, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5697, '', 3, '', 'TIDORE', 'David Kool', 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1676-11-25', 'Batavia', '1677-02-23', '1677-03-18', true, '1677-05-01', NULL, 1309, NULL);
INSERT INTO "voyages" VALUES (5698, '', 4, '', 'HOLLANDSE TUIN', 'Daniel den Bak', 1210, NULL, '1665', NULL, NULL, 'A', 'A', '1676-11-25', 'Batavia', '1677-02-22', '1677-03-18', true, '1677-07-08', 'Texel', 1295, NULL);
INSERT INTO "voyages" VALUES (5699, '', 3, '', 'GEKROONDE VREDE', 'Jan Blok', 730, NULL, '1667', NULL, NULL, 'E', 'E', '1676-11-25', 'Batavia', '1677-02-22', '1677-03-18', true, '1677-05-01', NULL, 1249, NULL);
INSERT INTO "voyages" VALUES (5700, '', 3, '', 'PRINS WILLEM HENDRIK', NULL, 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1676-11-25', 'Batavia', '1677-02-22', '1677-03-18', true, '1677-05-01', NULL, 1291, 'Aboard the PRINS WILLEM HENDRIK was Jan Bartelsz. Tand, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5701, '', 4, '', 'WAPEN VAN GOES', NULL, 671, NULL, '1668', NULL, NULL, 'D', 'Z', '1677-01-26', 'Ceylon', '1677-03-27', '1677-05-25', true, '1677-09-06', NULL, 1316, 'The fleet (5701-5702) from Ceylon joined perhaps the return fleet of 12-02-1677 at the Cape. 
Acc. to K.A. 1204 the Ceylon-fleet arrived at the Cape on 31-03-1677.');
INSERT INTO "voyages" VALUES (5702, '', 1, '', 'ROEMERSWAAL', NULL, 524, 'pinas/fluit', '1674', NULL, NULL, 'Z', 'A', '1677-01-26', 'Ceylon', '1677-03-27', '1677-05-25', true, '1677-09-06', NULL, 1278, NULL);
INSERT INTO "voyages" VALUES (5703, '', 2, '', 'WAPEN VAN ALKMAAR', 'Willem Hagedoom', 892, 'pinas', '1671', NULL, NULL, 'E', 'A', '1677-02-12', 'Batavia', '1677-05-12', '1677-05-25', true, '1677-09-11', 'Texel', 1320, 'Willem Hagedoorn was commandeur of the second return fleet (5703-5706); it joined perhaps the fleet of 26-01-1677 from CeyIon at the Cape. According to Hudde 20 the WAPEN VAN ALKMAAR arrived on 04-11-1677 in patria.');
INSERT INTO "voyages" VALUES (5704, '', 1, '', 'GELE BEER', 'Reinier Klaasz. de Groot', 412, 'fluit', NULL, '1675/6', NULL, 'A', 'A', '1677-02-12', 'Batavia', '1677-05-12', '1677-05-25', true, '1677-09-11', 'Texel', 1321, 'According to Hudde 20 the GELE BEER arrived on 04-11-1677 in patria.');
INSERT INTO "voyages" VALUES (5705, '', 1, '', 'GEKROONDE EENDRACHT', 'Kornelis Loefhouwer', NULL, 'fluit', NULL, NULL, '1676', 'E', 'E', '1677-02-12', 'Batavia', '1677-05-12', '1677-05-25', true, '1677-09-11', NULL, 1322, NULL);
INSERT INTO "voyages" VALUES (5706, '', 1, '', 'JUFFROUW MARIA', 'Marten Binkershoek', 440, 'fluit', NULL, NULL, '1675/6', 'A', 'H', '1677-02-12', 'Batavia', '1677-05-12', '1677-05-25', true, '1677-07-01', NULL, 1324, NULL);
INSERT INTO "voyages" VALUES (5707, '', 2, '', 'AZIE', 'Jakob Been', 1140, NULL, '1671', NULL, NULL, 'A', 'A', '1677-11-24', 'Batavia', NULL, NULL, false, '1678-06-30', 'Texel', 1310, 'First return fleet (5707-5712) under command of Konstantijn Raust aboard the AZIE, Hendrik van Rede aboard the KORT-GENE (5708) and Jan van Oosterwijk aboard the VRIJE ZEE (5711). The fleet revictuated at Pernambuco(Brazil).');
INSERT INTO "voyages" VALUES (5708, '', 1, '', 'KORTGENE', 'Thomas Danielsz.', 1139, NULL, '1675', NULL, NULL, 'Z', 'Z', '1677-11-24', 'Batavia', NULL, NULL, false, '1678-06-30', NULL, 1307, 'Aboard the KORTGENE was Hendrik van Rede, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5709, '', 1, '', 'MIDDELBURG', 'Jakob Zwart', 950, NULL, '1675', NULL, NULL, 'Z', 'A', '1677-11-24', 'Batavia', NULL, NULL, false, '1678-06-30', 'Texel', 1325, NULL);
INSERT INTO "voyages" VALUES (5710, '', 4, '', 'VRIJHEID', 'Jan Sloper', 1210, NULL, '1666', NULL, NULL, 'A', 'A', '1677-11-24', 'Batavia', NULL, NULL, false, '1678-06-30', 'Texel', 1326, NULL);
INSERT INTO "voyages" VALUES (5711, '', 4, '', 'VRIJE ZEE', 'Kornelis Blankevoort', 846, 'pinas', '1667', NULL, NULL, 'D', 'A', '1677-11-24', 'Batavia', NULL, NULL, false, '1678-06-30', 'Texel', 1319, 'Aboard the VRIJE ZEE was Jan van Oosterwijk, schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (5712, '', 4, '', 'WAPEN VAN ZIERIKZEE', 'Laurens de Potter', 1094, NULL, '1667', NULL, NULL, 'Z', 'Z', '1677-11-24', 'Batavia', NULL, NULL, false, '1678-04-01', NULL, 1317, NULL);
INSERT INTO "voyages" VALUES (5713, '', 2, '', 'KOEWERVE', 'Johan Goudsmit', 698, 'pinas', '1672', NULL, NULL, 'Z', 'Z', '1677-12-31', 'Ceylon', NULL, NULL, false, '1678-09-22', NULL, 1340, 'The fleet (5713-5714) from Ceylon did not call at the Cape, but called at Fernando Noronha (27-04 till 02-06-1678).');
INSERT INTO "voyages" VALUES (5714, '', 4, '', 'HUTS TE VELSEN', NULL, 750, NULL, '1667', NULL, NULL, 'A', 'A', '1677-12-31', 'Ceylon', NULL, NULL, false, '1678-09-22', 'Texel', 1329, NULL);
INSERT INTO "voyages" VALUES (5715, '', 1, '', 'BLOEMENDAAL', 'Heye Arendsz. de Wilde', 588, NULL, NULL, NULL, '1677', 'A', 'E', '1678-02-15', 'Batavia', '1678-05-01', '1678-05-16', true, '1678-09-06', 'Texel', 1349, 'Second return fleet (5715-5717) under command of Jan Hendriksz. Boon, master of the POULERON (5717). Aboard the BLOEMENDAAL there were probably also seafarers privately recruited by the master.');
INSERT INTO "voyages" VALUES (5716, '', 1, '', 'KRIJGSMAN', 'Gijsbert Willemsz.', 356, 'fluit', NULL, NULL, '1677', 'A', 'D', '1678-02-15', 'Batavia', '1678-05-01', '1678-05-16', true, '1678-07-01', NULL, 1350, 'Aboard the KRIJGSMAN there were probably also seafarers privately recruited by the master.');
INSERT INTO "voyages" VALUES (5717, '', 1, '', 'POULERON', 'Jan Hendriksz. Boon', 638, 'jacht', '1669', NULL, NULL, 'Z', 'Z', '1678-02-15', 'Batavia', '1678-05-01', '1678-05-16', true, '1678-07-01', NULL, 1143, 'Jan Hendriksz. Boon was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5718, '', 2, '', 'SNOEPER', 'Barend Fokkesz.', NULL, 'galjoot', NULL, NULL, '1677', 'A', 'A', '1678-12-21', 'Batavia', '1679-02-15', '1679-02-21', true, '1679-05-10', 'Amsterdam', 1356, 'Acc. to Valentijn: cargo 4,157.');
INSERT INTO "voyages" VALUES (5719, '', 3, '', 'DEN BRIEL', 'Andries Tertholen', 766, NULL, '1671', NULL, NULL, 'D', 'Z', '1679-01-10', 'Ceylon', '1679-03-05', '1679-04-19', true, '1679-08-10', 'Zeeland', 1361, NULL);
INSERT INTO "voyages" VALUES (5720, '', 2, '', 'CEYLON', '... Verdonk', 776, NULL, '1673', NULL, NULL, 'A', 'A', '1679-01-10', 'Ceylon', '1679-03-03', '1679-04-19', true, '1679-08-08', 'Texel', 1335, NULL);
INSERT INTO "voyages" VALUES (5721, '', 2, '', 'AFRIKA', NULL, 1100, NULL, '1673', NULL, NULL, 'R', 'A', '1679-02-04', 'Batavia', '1679-05-14', '1679-06-01', true, '1679-10-17', 'Texel', 1345, '(5721-5729) under command of Jakob van der Waayen aboard the AFRIKA, Bartholomeus Nouters aboard the HENDRIK MAURITS (5724), and Johannes Brakes aboard the HUIS TE ZILVERSTEIN (5729).  Acc. to K.A. 3992 the first seven ships departed on 15-03-1679, and acc. to Coolhaas IV on 13-03-1679.');
INSERT INTO "voyages" VALUES (5722, '', 2, '', 'AMERIKA', NULL, 1002, 'pinas', '1674', NULL, NULL, 'H', 'A', '1679-02-04', 'Batavia', '1679-05-16', '1679-06-01', true, '1679-10-17', 'Texel', 1332, 'Acc. to Hudde 20 132 seafarers and 40 soldiers on board.');
INSERT INTO "voyages" VALUES (5723, '', 2, '', 'HELLEVOETSLUIS', NULL, 714, 'pinas', '1671', NULL, NULL, 'R', 'R', '1679-02-04', 'Batavia', '1679-05-23', '1679-06-01', true, '1679-10-17', NULL, 1367, NULL);
INSERT INTO "voyages" VALUES (5724, '', 2, '', 'HENDRIK MAURITS', NULL, 1194, NULL, '1673', NULL, NULL, 'Z', 'Z', '1679-02-04', 'Batavia', '1679-05-14', '1679-06-01', true, '1679-10-17', NULL, 1341, 'Aboard the HENDRIK MAURITS was Bartholomeus Nouters, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5725, '', 1, '', 'JONAS', NULL, NULL, 'fluit', NULL, NULL, '1677', 'A', 'A', '1679-02-04', 'Batavia', '1679-05-14', '1679-06-01', true, '1679-10-17', 'Texel', 1358, NULL);
INSERT INTO "voyages" VALUES (5726, '', 2, '', 'MAKASSAR', NULL, 1014, 'pinas', '1671', NULL, NULL, 'A', 'Z', '1679-02-04', 'Batavia', '1679-05-15', '1679-06-01', true, '1679-08-01', NULL, 1314, NULL);
INSERT INTO "voyages" VALUES (5727, '', 2, '', 'JUFFROUW MARIA', NULL, 440, 'fluit', NULL, NULL, '1677', 'A', 'H', '1679-02-04', 'Batavia', '1679-05-14', '1679-06-01', true, '1679-10-17', NULL, 1363, '36 Seafarers had been privately recruited by the master of the ship.');
INSERT INTO "voyages" VALUES (5728, '', 2, '', 'KWARTEL', NULL, 96, 'hoeker', '1672', NULL, NULL, 'A', 'A', '1679-02-13', 'Batavia', '1679-04-28', '1679-06-01', true, '1679-08-01', NULL, 1323, 'Sailed ahead of the fleet and joined it at the Cape.');
INSERT INTO "voyages" VALUES (5729, '', 1, '', 'HUIS TE ZILVERSTEIN', 'Jan Verschuur?', 1017, NULL, '1674', NULL, NULL, 'A', 'D', '1679-02-15', 'Batavia', '1679-05-14', '1679-06-01', true, '1679-10-17', NULL, 1305, 'Joined the return fleet during the voyage; according to Hudde 20, 135 seafarers on board. Aboard the HUIS TE ZILVER-STEIN was Johannes Brakel, schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (5730, '', 1, '', 'ROMEIN', NULL, 450, 'fluit? hekboot?', NULL, NULL, '1677', 'A', 'A', '1679-10-13', 'Batavia', '1679-12-13', '1679-12-25', true, '1680-04-18', 'Texel', 1374, 'Sailed alone.');
INSERT INTO "voyages" VALUES (5731, '', 1, '', 'JUFFROUW KORNELIA', NULL, 316, 'fluit', NULL, NULL, '1677', NULL, 'A', '1679-11-06', 'Ceylon', '1680-02-02', '1680-02-13', true, '1680-06-20', NULL, 1373, 'Sailed alone. According to K.A.1231, fol. 1618. cargo 54,065.');
INSERT INTO "voyages" VALUES (5732, '', 1, '', 'SINT ANDRIES', NULL, 604, 'fluit? jacht?', NULL, NULL, '1677', 'A', 'A', '1679-11-24', 'Batavia', '1680-02-20', '1680-03-28', true, '1680-07-12', 'Texel', 1348, 'First return fleet (5732-5737) under command of Sybrand Abbema aboard the LAND VAN SCHOUWEN (5736), Andries Bogaard aboard the EUROPA (5734), and Dirk Timonsz. de Jonge aboard the SCHIELAND (5735). At the Cape the fleet of 09-01-1680 from Ceylon joined this fleet. In addition to the crew, 36 sick seafarers were aboard the fleet. The 60 seafarers aboard the SINT ANDRIES had been privately recruited by the master. According to Hudde 20 departure from Batavia on 11-12-1679.');
INSERT INTO "voyages" VALUES (5733, '', 3, '', 'AZIE', NULL, 1140, NULL, '1671', NULL, NULL, 'A', 'H', '1679-11-24', 'Batavia', '1680-02-20', '1680-03-28', true, '1680-07-11', NULL, 1376, 'The 18 impotenten were soldiers.');
INSERT INTO "voyages" VALUES (5734, '', 2, '', 'EUROPA', NULL, 1140, NULL, '1671', NULL, NULL, 'A', 'A', '1679-11-24', 'Batavia', '1680-02-20', '1680-03-28', true, '1680-07-11', 'Texel', 1357, 'The 19 impotenten were soldiers. Aboard the EUROPA was Andries Bogaard, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5735, '', 1, '', 'SCHIELAND', NULL, 710, NULL, '1674', NULL, NULL, 'D', 'R', '1679-11-24', 'Batavia', '1680-02-20', '1680-03-28', true, '1680-05-01', NULL, 1299, 'The 18 impotenten were soldiers.');
INSERT INTO "voyages" VALUES (5736, '', 1, '', 'LAND VAN SCHOUWEN', NULL, 1140, NULL, '1676', NULL, NULL, 'Z', 'Z', '1679-11-24', 'Batavia', '1680-02-20', '1680-03-28', true, '1680-04-01', NULL, 1355, 'The 20 impotenten were soldiers. Aboard the LAND VAN SCHOUWEN was Sybrand Abbema, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5737, '', 4, '', 'TIDORE', NULL, 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1679-11-24', 'Batavia', '1680-02-20', '1680-03-28', true, '1680-07-11', NULL, 1364, 'The 20 impotenten were soldiers.');
INSERT INTO "voyages" VALUES (5738, '', 2, '', 'SUMATRA', NULL, 738, 'pinas', '1673', NULL, NULL, 'A', 'A', '1680-01-09', 'Ceylon', '1680-03-08', '1680-03-28', true, '1680-07-11', NULL, 1331, 'The fleet (5738-5739) from Ceylon joined the return fleet of 24-11-1679 at the Cape.');
INSERT INTO "voyages" VALUES (5739, '', 1, '', 'WAPEN VAN THOLEN', NULL, 698, 'pinas', '1672', NULL, NULL, 'Z', 'Z', '1680-01-09', 'Ceylon', '1680-03-08', '1680-03-28', true, '1680-07-11', NULL, 1255, NULL);
INSERT INTO "voyages" VALUES (5740, '', 1, '', 'HUIS TE MERWEDE', NULL, 882, 'pinas', '1674', NULL, NULL, 'R', 'Z', '1680-03-15', 'Batavia', NULL, NULL, false, '1680-08-01', NULL, 1293, 'van Goens aboard the HUIS TE MERWEDE. The Cape was passed by on 23-05-1680.');
INSERT INTO "voyages" VALUES (5741, '', 4, '', 'TERNATE', 'Willem Kemp', 1014, 'pinas', '1668', NULL, NULL, 'A', 'A', '1680-03-15', 'Batavia', NULL, NULL, false, '1680-09-23', 'Texel', 1352, NULL);
INSERT INTO "voyages" VALUES (5742, '', 3, '', 'WAPEN VAN ALKMAAR', 'Marten Pit?', 892, 'pinas', '1671', NULL, NULL, 'E', 'A', '1680-11-29', 'Batavia', '1681-02-14', '1681-03-28', true, '1681-07-24', 'Texel', 1368, 'First return fleet (5742-5745) under command of Rijklof van Goens Junior aboard the BURCHT VAN LEIDEN (5744) and Jakob Geus aboard the CHINA (5743). They were ordered to wait at the Cape until 30-03-1681 for the second return fleet (see below); only the HUIS TE ZILVERSTEIN (5748) succeeded in joining the fleet in time.');
INSERT INTO "voyages" VALUES (5743, '', 1, '', 'CHINA', NULL, 1124, NULL, '1676', NULL, NULL, 'A', 'A', '1680-11-29', 'Batavia', '1681-02-14', '1681-03-28', true, '1681-07-24', 'Texel', 1345, 'Aboard the CHINA was Jakob Geus, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5744, '', 4, '', 'BURCHT VAN LEIDEN', NULL, 1040, NULL, '1667', NULL, NULL, 'A', 'Z', '1680-11-29', 'Batavia', '1681-02-14', '1681-03-28', true, '1681-07-24', NULL, 1370, 'Aboard the BURCHT VAN LEIDEN was Rijklof van Goens Junior, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5745, '', 4, '', 'PRINS WILLEM HENDRIK', 'Kornelis de Keizer or Kornelis Mol', 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1680-11-29', 'Batavia', '1681-02-14', '1681-03-28', true, '1681-05-01', NULL, 1365, NULL);
INSERT INTO "voyages" VALUES (5746, '', 2, '', 'BLAUWE HULK', 'Jan Jansz. Laman', 744, 'pinas', '1673', NULL, NULL, 'E', 'H', '1680-12-23', 'Batavia', '1681-04-04', '1681-04-30', true, '1681-06-01', NULL, 1336, 'Second return fleet (5746-5748) under command of Huibert Barendsz. Gruit aboard the EILAND MAURITIUS (5747). The 15 passengers aboard the BLAUWE HULK included 11 imprisoned criminals.');
INSERT INTO "voyages" VALUES (5747, '', 2, '', 'EILAND MAURITIUS', 'Huibert Barendsz. Gruit', 756, 'pinas', '1672', NULL, NULL, 'D', 'R', '1680-12-23', 'Batavia', '1681-04-04', '1681-04-30', true, '1681-06-01', NULL, 1346, 'The 12 passengers included 8 imprisoned criminals. Aboard the EILAND MAURITIUS was Huibert Barendsz. Gruit, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5748, '', 2, '', 'HUIS TE ZILVERSTEIN', 'Karsten de Gilde', 1017, NULL, '1674', NULL, NULL, 'A', 'A', '1680-12-23', 'Batavia', '1681-03-21', '1681-03-28', true, '1681-07-24', 'Texel', 1393, 'The 12 passengers included 11 imprisoned criminals. The HUIS TE ZILVERSTEIN joined the return fleet of 29-11-1680 at the Cape.');
INSERT INTO "voyages" VALUES (5749, '', 3, '', 'HENDRIK MAURITS', NULL, 1194, NULL, '1673', NULL, NULL, 'Z', 'Z', '1681-01-15', 'Ceylon', '1681-03-29', '1681-04-30', true, '1681-08-25', NULL, 1386, NULL);
INSERT INTO "voyages" VALUES (5750, '', 4, '', 'OOSTENBURG', 'Kornelis van Rooien', 840, 'pinas? fluit?', '1667', NULL, NULL, 'A', 'A', '1681-01-15', 'Ceylon', '1681-04-05', '1681-04-30', true, '1681-08-25', 'Texel', 1351, NULL);
INSERT INTO "voyages" VALUES (5751, '', 1, '', 'JAVA', 'Jan Wagemant', 762, 'pinas', '1678', NULL, NULL, 'A', 'A', '1681-02-13', 'Batavia', '1681-05-15', '1681-05-28', true, '1681-09-27', NULL, 1396, 'Third return fleet (5751-5752). The master died at the Cape.');
INSERT INTO "voyages" VALUES (5752, '', 5, '', 'VRIJE ZEE', 'Kornelis Klaasz. Sman', 846, 'pinas', '1667', NULL, NULL, 'D', 'A', '1681-02-13', 'Batavia', '1681-05-08', '1681-05-28', true, '1681-09-27', 'Texel', 1381, 'Acc. to Daghregister 168011: cargo of 605,705.');
INSERT INTO "voyages" VALUES (5753, '', 2, '', 'GELE BEER', 'Gerrit van Leeuwen', 412, 'fluit', NULL, '1677', NULL, 'A', 'Z', '1681-04-30', 'Batavia', NULL, NULL, true, '1681-11-07', NULL, 1360, 'Fourth return fleet (5753-5754). 
Acc. to Valentijn the fleet departed on 21-03-1681 from Batavia.');
INSERT INTO "voyages" VALUES (5754, '', 1, '', 'SPAARNWOUDE', 'Bruin Jansz.', 480, 'fluit', '1676', NULL, NULL, 'A', 'A', '1681-04-30', 'Batavia', NULL, NULL, true, '1681-11-07', 'Texel', 1339, 'Jan Wittebol is also mentioned as master.');
INSERT INTO "voyages" VALUES (5755, '', 3, '', 'AFRIKA', 'Maurits Jakobsz. van Eik', 1100, NULL, '1673', NULL, NULL, 'R', 'A', '1681-11-26', 'Batavia', '1682-02-16', '1682-04-28', true, '1682-08-30', 'Goeree', 1397, 'First return fleet (5755-5757) under command of Rijklof van Goens Senior aboard the LAND VAN SCHOUWEN(5757). At the Cape the second return fleet of 20-12-1681, the ships of 20-01-1682 from Ceylon, and the BURCHT VAN LEIDEN (5763) joined this fleet; Leendert Maas, master of the LAND VAN SCHOUWEN, became vice-commandeur and embarked on the HOLLANDSE TUIN (5758).');
INSERT INTO "voyages" VALUES (5756, '', 3, '', 'POSTHOORN', 'Dominikus van Geine', 60, 'bootje', NULL, '1671', NULL, 'Z', 'A', '1681-11-26', 'Batavia', '1682-02-15', '1682-04-28', true, '1682-08-29', NULL, 1338, NULL);
INSERT INTO "voyages" VALUES (5757, '', 2, '', 'LAND VAN SCHOUWEN', 'Leendert Maas', 1140, NULL, '1676', NULL, NULL, 'Z', 'A', '1681-11-26', 'Batavia', '1682-02-16', '1682-04-28', true, '1682-08-29', 'Texel', 1404, 'aboard the HOLLANDSE TUIN.');
INSERT INTO "voyages" VALUES (5758, '', 5, '', 'HOLLANDSE TUIN', 'Adriaan Sleutel', 1210, NULL, '1665', NULL, NULL, 'A', 'Z', '1681-12-20', 'Batavia', '1682-04-04', '1682-04-28', true, '1682-06-01', NULL, 1378, 'storm off Cape Agulhas. It joined the return fleet of 26-11-1681 at the Cape. At the Cape vice-commandeur Leendert Maas embarked on the HOLLANDSE TUIN (See also 5757).');
INSERT INTO "voyages" VALUES (5759, '', 5, '', 'VRIJHEID', 'Jakob Valk', 1210, NULL, '1666', NULL, NULL, 'A', 'Z', '1681-12-20', 'Batavia', '1682-03-25', '1682-04-28', true, '1682-08-30', NULL, 1385, NULL);
INSERT INTO "voyages" VALUES (5760, '', 1, '', 'COEVORDEN', NULL, 820, NULL, '1674', NULL, NULL, 'A', 'A', '1682-01-20', 'Ceylon', '1682-04-02', '1682-04-28', true, '1682-08-29', NULL, 1301, 'Via Malabar.');
INSERT INTO "voyages" VALUES (5761, '', 2, '', 'KORTGENE', NULL, 1139, NULL, '1675', NULL, NULL, 'Z', 'A', '1682-01-20', 'Ceylon', '1682-04-05', '1682-04-28', true, '1682-08-31', NULL, 1375, NULL);
INSERT INTO "voyages" VALUES (5762, '', 1, '', 'WESTERAMSTEL', NULL, 480, 'fluit', '1676', NULL, NULL, 'A', 'A', '1682-01-20', 'Ceylon', '1682-04-05', '1682-04-28', true, '1682-08-30', NULL, 1330, 'The ship from Ceylon (5760-5762) joined the return fleet of 26-11-1681 at the Cape.Acc. to Daghregister 1681 the WESTERAMSTEL arrived on 15-04-1682 at the Cape.');
INSERT INTO "voyages" VALUES (5763, '', 5, '', 'BURCHT VAN LEIDEN', NULL, 1040, NULL, '1667', NULL, NULL, 'A', NULL, '1682-04-28', 'The Cape', '1682-04-28', NULL, true, '1682-06-01', NULL, 1421, 'Departed from the Cape with the return fleet of 26-11-1681. According to K.A. 1143, fol. 808 the ship left the Cape on 28-08-1682 with a cargo of 425,315.');
INSERT INTO "voyages" VALUES (5764, '', 2, '', 'CHINA', 'Pieter van den Berg', 1124, NULL, '1676', NULL, NULL, 'A', 'A', '1683-01-22', 'Ceylon', '1683-04-13', '1683-06-01', true, '1683-09-26', 'Texel', 1423, 'According to Hudde 10 the crew of the CHINA consisted of 110 seafarers and 37 soldiers. 
Acc. to Valentijn the ships from Ceylon (5764-5766) departed on 30-01-1683.');
INSERT INTO "voyages" VALUES (5765, '', 4, '', 'HENDRIK MAURITS', 'Evert van Bruggen', 1194, NULL, '1673', NULL, NULL, 'Z', 'Z', '1683-01-22', 'Ceylon', '1683-04-08', '1683-06-01', true, '1683-08-01', NULL, 1431, NULL);
INSERT INTO "voyages" VALUES (5766, '', 1, '', 'HUIS TE KRONENBURG', 'Leendert Laurensz.', 700, 'fluit', '1674', NULL, NULL, 'A', 'A', '1683-01-22', 'Ceylon', '1683-04-08', '1683-06-01', true, '1683-09-25', 'Texel', 1304, 'According to Coolhaas IV the ship departed on 06-06-1683 from the Cape. Acc. to Hudde 10 the crew consisted of 86 seafarers and 18 soldiers.');
INSERT INTO "voyages" VALUES (5767, '', 1, '', 'STRIJEN', 'Adriaan van der Werf', 634, 'fluit', '1676', NULL, NULL, 'R', 'E', '1683-02-25', 'Batavia', '1683-06-11', '1683-07-06', true, '1683-09-01', NULL, 1347, 'Return fleet (5767-5774) under command of Hendrik van Oudshoom aboard the TIDORE (5774). The STRIJEN waited for the fleet of 27-02-1683 in Sunda Strait. Originally the WEST-BROEK (5779) and the HUIS TE SPIJK (5777) also belonged to this fleet, but they had to return to Batavia because of leakage.');
INSERT INTO "voyages" VALUES (5768, '', 4, '', 'AZIE', 'Jakob Dirksz. Jaarsma', 1140, NULL, '1671', NULL, NULL, 'A', 'A', '1683-02-27', 'Batavia', '1683-06-11', '1683-07-06', true, NULL, NULL, 1420, 'The AZIE was wrecked on 17''N.');
INSERT INTO "voyages" VALUES (5769, '', 3, '', 'EUROPA', 'Michiel van der Buis or Gijsbert Kraaienstein', 1140, NULL, '1671', NULL, NULL, 'A', 'A', '1683-02-27', 'Batavia', '1683-11-25', '1684-05-01', true, '1684-08-24', NULL, 1415, 'damaged by storms the EUROPA had to call at Mauritius (08-05 till 29-09-1683) and for more than five months at the Cape, where it was repaired. It waited for the return fleet of 26-12-1683.');
INSERT INTO "voyages" VALUES (5770, '', 1, '', 'GOUDESTEIN V', 'Beier is', 843, 'pinas', '1679', NULL, NULL, 'A', 'A', '1683-02-27', 'Batavia', '1683-06-07', '1683-07-06', true, '1683-10-26', 'Texel', 1418, NULL);
INSERT INTO "voyages" VALUES (5771, '', 2, '', 'JAVA', 'Sieuwert Roos', 762, 'pinas', '1678', NULL, NULL, 'A', 'H', '1683-02-27', 'Batavia', NULL, NULL, false, '1683-10-01', NULL, 1427, NULL);
INSERT INTO "voyages" VALUES (5772, '', 1, '', 'SCHIEBROEK', 'Kornelis Valkens', 250, 'jachtje', '1681', NULL, NULL, 'Z', 'Z', '1683-02-27', 'Batavia', '1683-06-13', '1683-07-06', true, '1683-10-26', NULL, 1432, NULL);
INSERT INTO "voyages" VALUES (5773, '', 2, '', 'SCHIELAND', 'Pieter Lakens', 710, NULL, '1674', NULL, NULL, 'D', 'Z', '1683-02-27', 'Batavia', '1683-06-07', '1683-07-06', true, '1683-10-26', NULL, 1413, NULL);
INSERT INTO "voyages" VALUES (5774, '', 5, '', 'TIDORE', 'Jakob Been', 1094, NULL, '1668', NULL, NULL, 'Z', 'Z', '1683-02-27', 'Batavia', NULL, NULL, false, NULL, NULL, 1412, 'Ameland.');
INSERT INTO "voyages" VALUES (5775, '', 2, '', 'WESTERAMSTEL', NULL, 480, 'fluit', '1676', NULL, NULL, 'A', NULL, '1683-07-06', 'The Cape', '1683-07-06', NULL, true, NULL, NULL, 1448, 'Departed from the Cape with the return fleet of 27-02-1683. Date of arrival in the Republic unknown.');
INSERT INTO "voyages" VALUES (5776, '', 1, '', 'ADRICHEM', 'Reinier Schouten', 486, 'fluit', '1680', NULL, NULL, 'A', 'A', '1683-12-26', 'Batavia', '1684-04-02', '1684-05-01', true, '1684-08-24', 'Texel', 1422, 'command of Steven Schorer aboard the ADRICHEM. Via Algoa Bay (17 till +/- 20-03) and Saldanha Bay (24-03 till 01-04-1684). At the Cape the EUROPA of the return fleet of 27-02-1683, the PURMER (5789), the EM-MENES (5790), and the ships of 16-01-1684 from Ceylon joined this fleet.');
INSERT INTO "voyages" VALUES (5777, '', 1, '', 'HUIS TE SPIJK', 'Jan van Dordrecht', 700, 'fluit', '1674', NULL, NULL, 'A', 'A', '1683-12-26', 'Batavia', '1684-04-02', '1684-05-01', true, '1684-08-23', 'Texel', 1302, 'The master was also called Jan van Dorre. Original departure of the HUIS TE SPIJK and the WESTBROEK (5779) on 25-02-1683. Both ships had to return to Batavia because of leakage, 3004-1683 (see also 5767).');
INSERT INTO "voyages" VALUES (5778, '', 1, '', 'STAVENISSE', 'Marinus Willemsz. Stoop', 544, 'fluit', '1681', NULL, NULL, 'Z', 'Z', '1683-12-26', 'Batavia', '1684-04-02', '1684-05-01', true, '1684-08-24', NULL, 1440, NULL);
INSERT INTO "voyages" VALUES (5779, '', 1, '', 'WESTBROEK', 'Jan Gelein', 253, 'fluit? kat?', '1681', NULL, NULL, 'A', 'R', '1683-12-26', 'Batavia', '1684-04-02', '1684-05-01', true, '1684-08-24', NULL, 1429, 'See 5767 and 5777.');
INSERT INTO "voyages" VALUES (5780, '', 3, '', 'LAND VAN SCHOUWEN', 'Jan van Velzen', 1140, NULL, '1676', NULL, NULL, 'Z', 'A', '1684-01-16', 'Ceylon', '1684-03-15', '1684-05-01', true, '1684-08-23', NULL, 1447, 'toK.A. 1271 the crew consisted of 134 men.');
INSERT INTO "voyages" VALUES (5781, '', 5, '', 'PRINS WILLEM HENDRIK', NULL, 1094, NULL, '1668', NULL, NULL, 'Z', 'A', '1684-01-16', 'Ceylon', '1684-03-15', '1684-05-01', true, '1684-08-23', NULL, 1443, NULL);
INSERT INTO "voyages" VALUES (5782, '', 4, '', 'AFRIKA', 'Christoffel de Vos', 1100, NULL, '1673', NULL, NULL, 'R', 'Z', '1684-02-08', 'Batavia', NULL, NULL, true, NULL, NULL, 1450, '1022 men, among whom 133 soldiers and 53 impotenten. During a heavy storm in the Indian Ocean the AFRIKA was wrecked, 23-04-1684.');
INSERT INTO "voyages" VALUES (5783, '', 4, '', 'WAPEN VAN ALKMAAR', 'Kornelis Kaashouwer', 892, 'pinas', '1671', NULL, NULL, 'E', 'A', '1684-02-08', 'Batavia', '1684-05-21', '1684-06-20', true, '1684-10-13', 'Texel', 1434, 'Acc. to Coolhaas IV the ship had a cargo of 476,419. Via Anjouan, one of the Comoro Islands (14-05-1684).');
INSERT INTO "voyages" VALUES (5784, '', 6, '', 'BURCHT VAN LEIDEN', 'Bartholomeus Nouters', 1040, NULL, '1667', NULL, NULL, 'A', 'Z', '1684-02-08', 'Batavia', '1684-11-14', '1685-02-06', true, '1685-05-14', NULL, 1444, 'After a heavy storm to the Mayotte Islands to be repaired; in 1685 laid up in patria.');
INSERT INTO "voyages" VALUES (5785, '', 3, '', 'EILAND MAURITIUS', 'Simon van den Berg', 756, 'pinas', '1672', NULL, NULL, 'D', 'R', '1684-02-08', 'Batavia', '1684-05-21', '1684-06-20', true, '1684-10-13', NULL, 1441, 'Via Anjouan one of the Comoro Islands (14-05-1684); in 1685 laid up in patria.');
INSERT INTO "voyages" VALUES (5786, '', 5, '', 'OOSTENBURG', 'Jan Jansz. Speelman', 840, 'pinas? fluit?', '1667', NULL, NULL, 'A', 'E', '1684-02-08', 'Batavia', '1684-05-21', '1684-06-20', true, '1684-10-13', NULL, 1436, 'Via Anjouan, one of the Comoro Islands (14-05-1684); in 1685 laid up in patria.');
INSERT INTO "voyages" VALUES (5787, '', 1, '', 'RIDDERSCHAP VAN HOLLAND', 'Jakob Pietersz. Kool', 1138, NULL, '1681', NULL, NULL, 'A', 'A', '1684-02-08', 'Batavia', '1684-05-21', '1684-06-20', true, '1684-10-13', 'Wielingen', 1456, 'Acc. to Coolhaas IV cargo of 575,813. Via Anjouan, one of the Comoro Islands (14-05-1684). Aboard the RIDDERSCHAP VAN HOLLAND was Jorephas Vos, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5788, '', 6, '', 'VRIJE ZEE', 'Kornelis Sman', 846, 'pinas', '1667', NULL, NULL, 'D', 'A', '1684-02-08', 'Batavia', '1684-05-19', '1684-06-20', true, '1684-10-13', 'Texel', 1437, 'Acc. to Coolhaas IV cargo of 457,535.');
INSERT INTO "voyages" VALUES (5789, '', 1, '', 'PURMER', 'Willem Hagedoom', 582, 'fregat', '1681', NULL, NULL, 'A', 'A', '1684-02-12', 'Coromandel', '1684-04-19', '1684-05-01', true, '1684-08-20', 'Texel', 1442, 'Via 
Ceylon. Acc. to K.A.191, 625-7: cargo of 466,497.');
INSERT INTO "voyages" VALUES (5790, '', 1, '', 'EMMENES', NULL, 297, 'fluit? kat?', '1682', NULL, NULL, 'A', NULL, '1684-05-01', 'The Cape', '1684-05-01', NULL, true, NULL, NULL, 1461, 'fleet of 26-12-1683. Date of arrival in the Republic unknown.');
INSERT INTO "voyages" VALUES (5791, '', 1, '', 'JUFFROUW ANNA', 'Gerritsz.', 457, NULL, NULL, NULL, '1682/3', 'A', 'A', '1684-10-09', 'Coromandel', NULL, NULL, true, '1685-05-14', NULL, 1466, NULL);
INSERT INTO "voyages" VALUES (5792, '', 1, '', 'HONSELAARSDIJK', 'Barend Visser', 722, 'pinas', '1679', NULL, NULL, 'Z', 'H', '1684-11-28', 'Batavia', '1685-03-17', '1685-03-29', true, '1685-06-27', 'Texel', 1395, 'PRINSES MARIA (5794) was the admiraal''s ship and the VRIJ-HEID (5796) the vice-admiraal''s.');
INSERT INTO "voyages" VALUES (5793, '', 3, '', 'KORTGENE', 'Adriaan Kornelisz. Muts', 1139, NULL, '1675', NULL, NULL, 'Z', 'E', '1684-11-28', 'Batavia', '1685-03-17', '1685-03-29', true, '1685-06-27', 'Texel', 1455, 'The KORTGENE was the vice-commandeur''s ship.');
INSERT INTO "voyages" VALUES (5794, '', 1, '', 'PRINSES MARIA', 'Marville', 1140, NULL, '1682', NULL, NULL, 'Z', 'A', '1684-11-28', 'Batavia', '1685-03-17', '1685-03-29', true, '1685-06-27', 'Texel', 1451, 'Probably the same master as mentioned under voyage no. 1451. See also 5792.');
INSERT INTO "voyages" VALUES (5795, '', 1, '', 'PRINSELAND', 'Gerrit Kornelisz. Kriek van Delfshaven', 710, 'fluit', '1681', NULL, NULL, 'D', 'D', '1684-11-28', 'Batavia', '1685-03-17', '1685-03-29', true, '1685-06-27', 'Texel', 1438, 'Aboard the PRINSELAND was Matthias Luchtenburg, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5796, '', 6, '', 'VRIJHEID', 'Krijn de Rande', 1210, NULL, '1666', NULL, NULL, 'A', 'Z', '1684-11-28', 'Batavia', '1685-03-17', '1685-03-29', true, '1685-06-27', 'Texel', 1458, 'See also 5792.');
INSERT INTO "voyages" VALUES (5797, '', 2, '', 'ROMEIN', 'Jan Molenaar', 450, 'fluit? hekboot?', NULL, NULL, '1682/3', 'A', 'A', '1684-12-20', 'Bengal', '1685-03-23', '1685-03-29', true, '1685-06-27', NULL, 1465, 'Acc. to K.A. 1284 the ship departed on 31-12-1684 from Bengal; it joined the return fleet of 28-11-1684 at the Cape.');
INSERT INTO "voyages" VALUES (5798, '', 2, '', 'COEVORDEN', 'Pieter Kornelisz. Puit', 820, NULL, '1674', NULL, NULL, 'A', 'Z', '1685-01-10', 'Ceylon', '1685-03-11', '1685-03-29', true, '1685-06-28', NULL, 1454, 'At the Cape the ships from Ceylon (5789-5800) under command of Salomon Lesage aboard the HUTS TE ZILVERSTEIN (5799) joined the return fleet of 28-11-1684 from Batavia.');
INSERT INTO "voyages" VALUES (5799, '', 3, '', 'HUIS TE ZILVERSTEIN', 'Karsten de Gilde', 1017, NULL, '1674', NULL, NULL, 'A', 'A', '1685-01-10', 'Ceylon', '1685-03-11', '1685-03-29', true, '1685-06-28', NULL, 1430, 'the return fleet.');
INSERT INTO "voyages" VALUES (5800, '', 1, '', 'LANGEWIJK', 'Jan Ammansz.', 544, 'fluit', '1682', NULL, NULL, 'E', 'A', '1685-01-17', 'Ceylon', '1685-03-13', '1685-03-29', true, '1685-06-28', NULL, 1452, 'Acc. to Hudde 20 the ship departed on 10-01-1685 from Ceylon.');
INSERT INTO "voyages" VALUES (5801, '', 1, '', 'VAN AMSTERDAM', 'Jan Barendsz.', 479, 'pinas? jacht?', NULL, '1682/3', NULL, 'A', 'R', '1685-02-07', 'Batavia', '1685-04-27', '1685-05-14', true, '1685-08-30', NULL, 1467, '(5801-5802). At the Cape the SINT MAAR-TENSDIJK (5803) joined this fleet. At S. Nicolas Bay one seafarer, 6 soldiers, and 3 craftsmen left the JAMBY for the BEURS VAN AMSTERDAM.');
INSERT INTO "voyages" VALUES (5802, '', 1, '', 'JAMBY', 'Jan Gerritsz.', 336, 'pinas? jacht?', '1679', NULL, NULL, 'A', 'A', '1685-02-07', 'Batavia', '1685-04-27', '1685-05-14', true, '1685-08-30', 'Texel', 1390, 'See also 5801.');
INSERT INTO "voyages" VALUES (5803, '', 1, '', 'SINT MAARTENSDIJK', 'Abraham Pierman', 352, 'pinas? jacht?', '1681', NULL, NULL, 'Z', 'Z', '1685-02-21', 'Batavia', '1685-05-04', '1685-05-14', true, '1685-08-30', NULL, 1439, 'Acc. to Valentijn the ship departed on 07-02-1685 from Batavia.');
INSERT INTO "voyages" VALUES (5804, '', 1, '', 'DUIFJE', NULL, 90, 'hoeker/bootje', '1682', NULL, NULL, 'A', 'A', '1685-03-18', 'Batavia', '1685-08-05', '1685-08-27', true, '1686-01-02', 'Texel', 1460, NULL);
INSERT INTO "voyages" VALUES (5805, '', 3, '', 'JAVA', NULL, 762, 'pinas', '1678', NULL, NULL, 'A', 'A', '1685-10-08', 'Coromandel', '1686-01-01', '1686-04-12', true, '1686-07-26', NULL, 1467, '1319 the ship arrived on 01-03-1686 at the Cape.
The JAVA joined the return fleet of 04-12-1685 at the Cape.');
INSERT INTO "voyages" VALUES (5806, '', 1, '', 'BANTAM', 'Adriaan de Vos van Amsterdam', 1138, 'pinas? jacht?', '1683', NULL, NULL, 'A', 'A', '1685-12-04', 'Batavia', '1686-03-09', '1686-04-12', true, '1686-07-26', 'Vlie', 1492, 'At the Cape the JAVA (5805), the GROTE V ISSERIJ (5813), and the ships from Ceylon (5814-5816) joined this fleet.');
INSERT INTO "voyages" VALUES (5807, '', 3, '', 'CHINA', 'Jan Jakobsz. Zeeman', 1124, NULL, '1676', NULL, NULL, 'A', 'R', '1685-12-04', 'Batavia', '1686-03-13', '1686-04-12', true, '1686-06-27', NULL, 1479, NULL);
INSERT INTO "voyages" VALUES (5808, '', 5, '', 'HENDRIK MAURITS', 'Kornelis Valkenburg van der Veer', 1194, NULL, '1673', NULL, NULL, 'Z', 'Z', '1685-12-04', 'Batavia', '1686-03-09', '1686-04-12', true, '1686-06-27', NULL, 1478, NULL);
INSERT INTO "voyages" VALUES (5809, '', 2, '', 'RIDDERSCHAP VAN HOLLAND', 'Hendrik Pronk', 1138, NULL, '1681', NULL, NULL, 'A', 'A', '1685-12-04', 'Batavia', '1686-03-09', '1686-04-12', true, '1686-07-20', 'Texel', 1488, 'Hudde 20 the ship arrived on 29-07-1686 at Texel.');
INSERT INTO "voyages" VALUES (5810, '', 3, '', 'SCHIELAND', 'Dirk van der Gaag', 710, NULL, '1674', NULL, NULL, 'D', 'D', '1685-12-04', 'Batavia', '1686-03-09', '1686-04-12', true, '1686-06-27', NULL, 1485, NULL);
INSERT INTO "voyages" VALUES (5811, '', 2, '', 'GOUDESTEIN', 'Beier Vis', 843, 'pinas', '1679', NULL, NULL, 'A', 'H', '1685-12-04', 'Batavia', '1686-03-09', '1686-04-12', true, '1686-06-27', NULL, 1480, NULL);
INSERT INTO "voyages" VALUES (5812, '', 2, '', 'STAVENISSE', 'Willem Kuif', 544, 'fluit', '1681', NULL, NULL, 'Z', 'A', '1685-12-18', 'Bengal', NULL, NULL, true, NULL, NULL, 1495, 'Acc. to Valentijn the ship departed on 06-12-1685 from Bengal.
On 16-02-1686 it was wrecked at Terra de Natal.');
INSERT INTO "voyages" VALUES (5813, '', 1, '', 'GROTE VISSERIJ', 'Jakob Hendriksz. ten Engeltje', 638, 'jacht', NULL, '1683', NULL, 'E', 'E', '1686-01-09', 'Batavia', '1686-04-03', '1686-04-12', true, '1686-07-26', NULL, 1477, 'The ship joined the return fleet of 04-12-1685 at the Cape.');
INSERT INTO "voyages" VALUES (5814, '', 1, '', 'EENHOORN', NULL, 749, NULL, '1683', NULL, NULL, 'Z', 'Z', '1686-01-22', 'Ceylon', '1686-04-02', '1686-04-12', true, '1686-06-01', NULL, 1487, 'of 04-12-1685 at the Cape.');
INSERT INTO "voyages" VALUES (5815, '', 2, '', 'SCHIEBROEK', NULL, 250, 'jachtje', '1681', NULL, NULL, 'Z', 'A', '1686-01-22', 'Ceylon', '1686-03-29', '1686-04-12', true, '1686-07-26', NULL, 1471, NULL);
INSERT INTO "voyages" VALUES (5816, '', 1, '', 'WATERLAND', NULL, 1138, NULL, '1683', NULL, NULL, 'A', 'A', '1686-01-22', 'Ceylon', '1686-03-29', '1686-04-12', true, '1686-07-26', NULL, 1474, NULL);
INSERT INTO "voyages" VALUES (5817, '', 1, '', 'EEMLAND', NULL, 398, 'pinas? jacht?', '1680', NULL, NULL, 'A', 'Z', '1686-02-22', 'Pulicat', '1686-05-25', '1686-06-17', true, '1686-08-01', NULL, 1425, NULL);
INSERT INTO "voyages" VALUES (5818, '', 2, '', 'KRIJGSMAN', NULL, 356, 'fluit', NULL, '1683', NULL, 'Z', 'Z', '1686-03-09', 'Batavia', '1686-06-14', '1686-06-25', true, '1686-10-10', 'Goeree', 1468, 'departed on 24-02-1686 from 
Batavia. Acc. to K.A. 1307 the fleet
departed on 17-06-1686 from the Cape.');
INSERT INTO "voyages" VALUES (5819, '', 1, '', 'SILLIDA', NULL, 324, 'pinas? jacht?', '1680', NULL, NULL, 'A', 'A', '1686-03-09', 'Batavia', '1686-06-12', '1686-06-25', true, '1686-10-10', 'Goeree', 1407, NULL);
INSERT INTO "voyages" VALUES (5820, '', 5, '', 'WAPEN VAN ALKMAAR', 'Marten Wildvang', 892, 'pinas', '1671', NULL, NULL, 'E', 'A', '1686-10-08', 'Masulipatnam', '1686-12-31', '1687-04-20', true, '1687-06-01', NULL, 1505, 'The 109 men aboard the WAPEN VAN ALKMAAR included 3 craftsmen and 4 impotenten. According to Valentijn the ships from Coromandel (5820-5821) departed on 13-10-1686. They joined the return fleet of 13-12-1686 at the Cape.');
INSERT INTO "voyages" VALUES (5821, '', 2, '', 'HUIS TE KRONENBURG', 'Abraham Aarnoutsz.', 700, 'fluit', '1674', NULL, NULL, 'A', 'R', '1686-10-08', 'Masulipatnam', '1686-12-29', '1687-04-20', true, '1687-06-01', NULL, 1482, NULL);
INSERT INTO "voyages" VALUES (5822, '', 2, '', 'HONSELAARSDIJK', 'Pieter Puit', 722, 'pinas', '1679', NULL, NULL, 'Z', 'H', '1686-12-13', 'Batavia', '1687-03-20', '1687-04-20', true, '1687-08-01', NULL, 1511, 'Masulipatnam (5820-5821) and from Ceylon (5829-5832) and the DEN HELDER (5828) from Bengal joined this fleet.');
INSERT INTO "voyages" VALUES (5823, '', 1, '', 'CASTRICUM', 'Jan Gerritsz. van Bordeaux', 623, 'jacht', NULL, '1681', NULL, 'A', 'A', '1686-12-13', 'Batavia', '1687-03-21', '1687-04-20', true, '1687-08-15', 'Texel', 1453, 'Aboard the CASTRICUM was Daniel Braams, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5824, '', 1, '', 'OOSTERLAND', 'Karel de Marville', 1123, NULL, '1685', NULL, NULL, 'Z', 'Z', '1686-12-13', 'Batavia', '1687-03-20', '1687-04-20', true, '1687-08-01', NULL, 1509, NULL);
INSERT INTO "voyages" VALUES (5825, '', 1, '', 'SCHELDE', 'Krijn Koster', 733, 'jacht', '1682', NULL, NULL, 'Z', 'Z', '1686-12-13', 'Batavia', '1687-03-20', '1687-04-20', true, '1687-08-01', NULL, 1469, NULL);
INSERT INTO "voyages" VALUES (5826, '', 1, '', 'SPIERDIJK', 'Ruiter', 606, 'fluit? hekboot?', '1685', NULL, NULL, 'A', 'A', '1686-12-13', 'Batavia', '1687-03-20', '1687-04-20', true, '1687-08-13', 'Texel', 1514, NULL);
INSERT INTO "voyages" VALUES (5827, '', 1, '', 'GULDEN WAGEN', 'Karel Godske', 300, 'fluit', NULL, '167819', NULL, 'A', 'E', '1686-12-13', 'Batavia', '1687-03-21', '1687-04-20', true, '1687-08-15', NULL, 1392, NULL);
INSERT INTO "voyages" VALUES (5828, '', 1, '', 'DEN HELDER', 'Gijsbert van Kraaienstein', 578, 'fluit', '1683', NULL, NULL, 'A', 'A', '1686-12-16', 'Bengal', '1687-03-25', '1687-04-20', true, '1687-08-01', NULL, 1497, 'Acc. to Valentijn the ship departed on 31-12-1686 from Bengal.
It joined the return fleet of 13-12-1686 at the Cape.');
INSERT INTO "voyages" VALUES (5829, '', 2, '', 'LANGEWIJK', 'Jakob Jakobsz. de Jonge', 544, 'fluit', '1682', NULL, NULL, 'E', 'A', '1687-01-22', 'Ceylon', '1687-03-21', '1687-04-20', true, '1687-08-01', NULL, 1506, 'The ships from Ceylon (5829-5832) joined the return fleet of 13-12-1686 at the Cape.');
INSERT INTO "voyages" VALUES (5830, '', 2, '', 'PRINSELAND', 'Meindert van Enkhuizen or Kornelis van Hoom', 710, 'fluit', '1681', NULL, NULL, 'D', 'A', '1687-01-22', 'Ceylon', '1687-03-20', '1687-04-20', true, '1687-08-01', NULL, 1508, NULL);
INSERT INTO "voyages" VALUES (5831, '', 4, '', 'LAND VAN SCHOUWEN', 'Willem Burggraaf', 1140, NULL, '1676', NULL, NULL, 'Z', 'Z', '1687-01-22', 'Ceylon', '1687-03-19', '1687-04-20', true, '1687-08-01', NULL, 1499, NULL);
INSERT INTO "voyages" VALUES (5832, '', 1, '', 'VOORSCHOTEN', 'Pieter Andriesz. Goedland', 558, 'fluit', '1684', NULL, NULL, 'D', 'D', '1687-01-22', 'Ceylon', '1687-03-19', '1687-04-20', true, '1687-08-27', NULL, 1489, NULL);
INSERT INTO "voyages" VALUES (5833, '', 1, '', 'POST', 'Willem Kemp', 577, 'fluit? hekboot?', NULL, '1682/3', NULL, 'A', 'A', '1687-03-06', 'Batavia', '1687-05-10', '1687-05-20', true, '1687-09-14', 'Goeree', 1464, 'Second return fleet (5833-5834).');
INSERT INTO "voyages" VALUES (5834, '', 1, '', 'ZUID-BEVELAND', 'Kornelis de Jonge', 518, 'pinas', '1680', NULL, NULL, 'Z', 'A', '1687-03-06', 'Batavia', '1687-05-10', '1687-05-20', true, '1687-08-27', NULL, 1417, NULL);
INSERT INTO "voyages" VALUES (5835, '', 1, '', 'SALLAND', 'Kornelis Wisse', 760, 'pinas? jacht?', '1686', NULL, NULL, 'A', 'Z', '1687-12-01', 'Batavia', '1688-03-30', '1688-04-30', true, '1688-08-10', 'Texel', 1529, 'First return fleet (5835-5839) under command of Jakob Kouper aboard the LANDS WELVAREN (5839). At the Cape the EENHOORN (5840) and the ships from Ceylon (5841-5845) joined the fleet.');
INSERT INTO "voyages" VALUES (5836, '', 1, '', 'SION', 'Simon van den Berg', 740, NULL, '1686', NULL, NULL, 'D', 'D', '1687-12-01', 'Batavia', '1688-03-31', '1688-04-30', true, '1688-08-10', NULL, 1537, NULL);
INSERT INTO "voyages" VALUES (5837, '', 3, '', 'GOUDESTEIN', 'Doede Star?', 843, 'pinas', '1679', NULL, NULL, 'A', 'A', '1687-12-01', 'Batavia', '1688-04-21', '1688-04-30', true, '1688-08-21', 'Texel', 1535, 'Because of a storm the GOUDESTEIN had to return to Batavia, 31-12-1687; second departure from Batavia: 11-01-1688. The second amount indicated under ''Inv. value'' was destined for the other five Chambers of the Company.');
INSERT INTO "voyages" VALUES (5838, '', 1, '', 'WAALSTROOM', 'Pieter Visjager', 648, 'pinas', '1684', NULL, NULL, 'A', 'A', '1687-12-01', 'Batavia', '1688-03-30', '1688-04-30', true, '1688-08-21', 'Texel', 1500, NULL);
INSERT INTO "voyages" VALUES (5839, '', 1, '', 'LANDS WELVAREN', 'Bruin Jansz.', 1145, 'pinas', '1685', NULL, NULL, 'A', 'Z', '1687-12-01', 'Batavia', '1688-03-30', '1688-04-30', true, '1688-08-10', 'Texel', 1525, 'WELVAREN was Jakob Kouper, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5840, '', 2, '', 'EENHOORN', 'Meindert Prins', 749, NULL, '1683', NULL, NULL, 'Z', 'R', '1687-12-14', 'Batavia', '1688-03-31', '1688-04-30', true, '1688-08-10', 'Maas', 1531, 'Acc. to Valentijn the ship departed on 10-12-1687.');
INSERT INTO "voyages" VALUES (5841, '', 2, '', 'BANTAM', 'Evert van Brugge', 1138, 'pinas? jacht?', '1683', NULL, NULL, 'A', 'A', '1688-01-18', 'Ceylon', '1688-04-10', '1688-04-30', true, '1688-06-01', NULL, 1530, 'According to Valentijn the fleet from Ceylon (5841-5845) departed on 22-01-1688, 
acc. to K.A. 4002 on 23-01-1688. It joined the return fleet of 01-12-1687 at the Cape.');
INSERT INTO "voyages" VALUES (5842, '', 1, '', 'HOBRE', 'Jakob Andriesz. Rat', 524, 'fluit', '1685', NULL, NULL, 'E', 'E', '1688-01-18', 'Ceylon', '1688-04-10', '1688-04-30', true, '1688-08-10', 'Texel', 1527, NULL);
INSERT INTO "voyages" VALUES (5843, '', 4, '', 'KORTGENE', 'de Bitter', 1139, NULL, '1675', NULL, NULL, 'Z', 'Z', '1688-01-18', 'Ceylon', '1688-04-10', '1688-04-30', true, '1688-06-01', NULL, 1523, NULL);
INSERT INTO "voyages" VALUES (5844, '', 3, '', 'RIDDERSCHAP VAN HOLLAND', 'Hendrik Pronk', 1138, NULL, '1681', NULL, NULL, 'A', 'A', '1688-01-18', 'Ceylon', '1688-04-10', '1688-04-30', true, '1688-06-01', NULL, 1533, NULL);
INSERT INTO "voyages" VALUES (5845, '', 4, '', 'HUIS TE ZILVERSTEIN', 'Karsten de Gilde', 1017, NULL, '1674', NULL, NULL, 'A', 'H', '1688-01-18', 'Ceylon', '1688-04-10', '1688-04-30', true, '1688-08-10', 'Texel', 1526, NULL);
INSERT INTO "voyages" VALUES (5846, '', 1, '', 'NIEUWLAND', 'Herman Voet', 544, 'fluit', '1685', NULL, NULL, 'Z', 'A', '1688-01-22', 'Bengal', '1688-05-04', '1688-06-21', true, '1688-09-27', 'Texel', 1522, 'The ship joined the second return fleet of 16-03-1688 at the Cape.');
INSERT INTO "voyages" VALUES (5847, '', 1, '', 'MOERKAPEL', 'Jan van Velzen', 685, 'pinas? jacht?', '1684', NULL, NULL, 'R', 'A', '1688-03-16', 'Batavia', '1688-05-31', '1688-06-21', true, '1688-09-27', 'Texel', 1498, 'According to Valentijn the second return fleet (5847-5848) departed on 28-02-1688 from Batavia. At the Cape the NIEUWLAND (5846) joined this fleet.');
INSERT INTO "voyages" VALUES (5848, '', 1, '', 'RAD VAN AVONTUUR', 'Dominikus Barendsz.', 484, 'fluit', NULL, NULL, '1686/1', 'A', 'A', '1688-03-16', 'Batavia', '1688-05-31', '1688-06-21', true, '1688-09-27', 'Texel', 1544, NULL);
INSERT INTO "voyages" VALUES (5849, '', 4, '', 'JAVA', 'Sieuwert de Jong', 762, 'pinas', '1678', NULL, NULL, 'A', 'A', '1688-12-25', 'Batavia', '1689-03-17', '1689-04-17', true, '1689-08-08', 'Texel', 1547, 'Batavia.
At the Cape the ships from Ceylon (5855-5857) joined this fleet.');
INSERT INTO "voyages" VALUES (5850, '', 3, '', 'LANGEWIJK', 'Hendrik Pop', 544, 'fluit', '1682', NULL, NULL, 'E', 'H', '1688-12-25', 'Batavia', '1689-03-17', '1689-04-17', true, '1689-08-09', 'Texel', 1548, NULL);
INSERT INTO "voyages" VALUES (5851, '', 2, '', 'OOSTERLAND', 'Aarnoud Scheiteruit', 1123, NULL, '1685', NULL, NULL, 'Z', 'Z', '1688-12-25', 'Batavia', '1689-03-17', '1689-04-17', true, '1689-08-09', NULL, 1557, 'Aboard the OOSTERLAND was Robertus Padbrugge, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5852, '', 1, '', 'OOSTHUIZEN', 'Wessel Jansz. Koeze', 500, 'fluit', '1687', NULL, NULL, 'E', 'E', '1688-12-25', 'Batavia', '1689-03-17', '1689-04-17', true, '1689-08-09', 'Texel', 1555, NULL);
INSERT INTO "voyages" VALUES (5853, '', 2, '', 'SCHELDE', 'Jan Speelman', 733, 'jacht', '1682', NULL, NULL, 'Z', 'R', '1688-12-25', 'Batavia', '1689-03-17', '1689-04-17', true, '1689-08-09', NULL, 1558, NULL);
INSERT INTO "voyages" VALUES (5854, '', 2, '', 'VOORSCHOTEN', 'Gerrit Comelisz. Kriek', 558, 'fluit', '1684', NULL, NULL, 'D', 'D', '1688-12-25', 'Batavia', '1689-03-17', '1689-04-17', true, '1689-08-09', NULL, 1553, NULL);
INSERT INTO "voyages" VALUES (5855, '', 3, '', 'HONSELAARSDIJK', 'Nikolaas Kolen', 722, 'pinas', '1679', NULL, NULL, 'Z', 'Z', '1689-01-25', 'Ceylon', '1689-04-05', '1689-04-17', true, '1689-08-09', NULL, 1556, 'The first fleet from Ceylon (5855-5857) joined the return fleet of 25-12-1688 at the Cape.');
INSERT INTO "voyages" VALUES (5856, '', 1, '', 'MAAS', 'Leendert Lourens', 790, NULL, '1683', NULL, NULL, 'R', 'A', '1689-01-25', 'Ceylon', '1689-04-05', '1689-04-17', true, '1689-08-08', 'Texel', 1481, NULL);
INSERT INTO "voyages" VALUES (5857, '', 2, '', 'WATERLAND', 'Jakob Gagenaar', 1138, NULL, '1683', NULL, NULL, 'A', 'A', '1689-01-25', 'Ceylon', '1689-04-07', '1689-04-17', true, '1689-08-08', 'Texel', 1543, NULL);
INSERT INTO "voyages" VALUES (5858, '', 1, '', 'NIEROP', NULL, 494, 'fluit', '1684', NULL, NULL, 'E', 'A', '1689-02-27', 'Ceylon', '1689-04-29', '1689-06-30', true, '1689-10-29', 'Veere', 1503, 'return fleet of 02-03-1689 at the Cape.');
INSERT INTO "voyages" VALUES (5859, '', 2, '', 'SPIERDIJK', 'Jan Konstantijn van den Mast', 606, 'fluit? hekboot?', '1685', NULL, NULL, 'A', 'A', '1689-02-27', 'Ceylon', '1689-04-30', '1689-06-30', true, '1689-09-03', 'Veere', 1551, NULL);
INSERT INTO "voyages" VALUES (5860, '', 1, '', 'ZAAMSLAG', 'Pieter van Eek', 585, 'pinas? jacht?', '1687', NULL, NULL, 'Z', 'Z', '1689-02-27', 'Ceylon', '1689-04-24', '1689-06-30', true, '1689-10-29', 'Veere', 1546, NULL);
INSERT INTO "voyages" VALUES (5861, '', 1, '', 'OOSTSOUBURG', NULL, 759, NULL, '1686', NULL, NULL, 'Z', 'Z', '1689-03-02', 'Batavia', '1689-05-24', '1689-06-30', true, '1689-10-29', 'Veere', 1539, 'Second return fleet (5861-5862). 
Acc. to Valentijn the feet departed on 07-03-1689 from Batavia. At the Cape the fleet of 27-02-1689 from Ceylon joined this fleet.');
INSERT INTO "voyages" VALUES (5862, '', 2, '', 'ZUID-BEVELAND', NULL, 518, 'pinas? jacht?', '1680', NULL, NULL, 'Z', 'A', '1689-03-02', 'Batavia', '1689-05-24', '1689-06-30', true, '1689-10-29', 'Veere', 1561, 'In 1690 burned down at Amsterdam.');
INSERT INTO "voyages" VALUES (5863, '', 2, '', 'EMMENES', NULL, 297, 'fluit? kat?', '1682', NULL, NULL, 'A', 'E', '1689-03-31', 'Batavia', '1689-07-18', '1689-08-05', true, '1689-11-30', 'Eems', 1493, 'Acc. to K.A. 4004 the ship departed on 06-04-1689 from Batavia.');
INSERT INTO "voyages" VALUES (5864, '', 1, '', 'VLAMING', 'Willem Hesselsz. de Vlaming', NULL, 'galjoot', NULL, NULL, '1688', 'A', 'A', '1689-12-04', 'Bengal', NULL, NULL, true, '1690-05-28', 'Goeree', 1571, NULL);
INSERT INTO "voyages" VALUES (5865, '', 1, '', 'KAPELLE', NULL, 647, 'jacht', '1686', NULL, NULL, 'R', 'R', '1689-12-29', 'Batavia', '1690-04-05', '1690-06-01', true, NULL, NULL, 1536, 'KAPELLE was wrecked near the Shetland Islands.');
INSERT INTO "voyages" VALUES (5866, '', 1, '', 'NEDERLAND', NULL, 1173, 'pinas', '1687', NULL, NULL, 'A', 'A', '1689-12-29', 'Batavia', '1690-04-05', '1690-06-01', true, '1690-10-08', 'Texel', 1573, 'Aboard the NEDERLAND was Johan Parve, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5867, '', 1, '', 'PIJLSWAART', NULL, 600, 'pinas? jacht?', '1684', NULL, NULL, 'H', 'H', '1689-12-29', 'Batavia', '1690-04-05', '1690-06-01', true, NULL, NULL, 1504, 'the Shetland Islands.');
INSERT INTO "voyages" VALUES (5868, '', 2, '', 'PURMER', NULL, 582, 'fregat', '1681', NULL, NULL, 'A', 'A', '1689-12-29', 'Batavia', '1690-04-12', '1690-06-01', true, '1690-10-08', 'Texel', 1494, NULL);
INSERT INTO "voyages" VALUES (5869, '', 4, '', 'SCHIELAND', NULL, 710, NULL, '1674', NULL, NULL, 'D', 'E', '1689-12-29', 'Batavia', '1690-04-05', '1690-06-01', true, '1690-10-01', 'Veere', 1574, 'Sold after arrival at Veere.');
INSERT INTO "voyages" VALUES (5870, '', 5, '', 'LAND VAN SCHOUWEN', NULL, 1140, NULL, '1676', NULL, NULL, 'Z', 'Z', '1689-12-29', 'Batavia', '1690-04-06', '1690-06-01', true, NULL, NULL, 1579, 'Aboard the LAND VAN SCHOUWEN was Abraham Post, vice-commandeur of the return fleet. The ship went astray from the fleet at 62''N. and was wrecked near the Shetland Islands.');
INSERT INTO "voyages" VALUES (5871, '', 2, '', 'SION', NULL, 740, NULL, '1686', NULL, NULL, 'D', 'D', '1689-12-29', 'Batavia', '1690-04-05', '1690-06-01', true, '1690-10-08', 'Texel', 1576, NULL);
INSERT INTO "voyages" VALUES (5872, '', 3, '', 'SNOEPER', NULL, NULL, 'gajoot', NULL, NULL, '1677', NULL, 'A', '1689-12-29', 'Batavia', '1690-03-16', '1690-06-01', true, '1690-11-01', 'Texel', 1568, NULL);
INSERT INTO "voyages" VALUES (5873, '', 6, '', 'WAPEN VAN ALKMAAR', NULL, 892, 'pinas', '1671', NULL, NULL, 'E', 'Z', '1690-02-07', 'Ceylon', '1690-05-15', '1690-06-01', true, NULL, NULL, 1564, 'The first ships from Ceylon (5873-5875) joined the first return fleet of 29-12-1689 at the Cape. The WAPEN VAN ALKMAAR was wrecked near the Shetland Islands.');
INSERT INTO "voyages" VALUES (5874, '', 4, '', 'CHINA', 'Sibert Stoffelsz.', 1124, NULL, '1676', NULL, NULL, 'A', 'A', '1690-02-07', 'Ceylon', '1690-12-09', '1691-07-04', true, '1691-12-01', NULL, 1560, 'Badly damaged by storm the CHINA had to wait at Mauritius for materials from the Cape. It left the island on 08-11-1690.');
INSERT INTO "voyages" VALUES (5875, '', 1, '', 'LEK', NULL, 762, 'pinas', '1686', NULL, NULL, 'A', 'A', '1690-02-07', 'Ceylon', '1690-05-09', '1690-06-01', true, '1690-10-08', 'Texel', 1540, NULL);
INSERT INTO "voyages" VALUES (5876, '', 1, '', 'ELISABETH', NULL, NULL, 'gajoot', NULL, NULL, '1688', NULL, 'A', '1690-03-12', 'Ceylon', '1690-05-15', '1690-06-01', true, NULL, NULL, 1569, 'second fleet from Ceylon (5876-5878) joined the first return fleet of 29-12-1689 at the Cape.');
INSERT INTO "voyages" VALUES (5877, '', 1, '', 'HANDBOOG', NULL, 594, 'fluit', '1687', NULL, NULL, 'A', 'A', '1690-03-12', 'Ceylon', '1690-05-19', '1690-06-01', true, '1690-10-08', 'Texel', 1572, NULL);
INSERT INTO "voyages" VALUES (5878, '', 1, '', 'PAMPUS', NULL, 604, NULL, '1686', NULL, NULL, 'A', 'A', '1690-03-12', 'Ceylon', '1690-05-19', '1690-06-01', true, '1690-10-08', 'Texel', 1549, NULL);
INSERT INTO "voyages" VALUES (5879, '', 1, '', 'BORSENBURG', 'Michiel de Vries', 320, 'fluit? kat?', '1686', NULL, NULL, 'A', 'R', '1690-03-16', 'Batavia', '1690-05-31', '1690-06-14', true, '1690-10-08', 'Goeree', 1554, 'Second return fleet (5879-5882). It left the Cape under command of Paulus Huntum, master aboard the PRINSELAND (5882).');
INSERT INTO "voyages" VALUES (5880, '', 1, '', 'HOGERGEEST', 'Willem Vermei', 222, 'pinas? jacht?', '1681', NULL, NULL, 'A', 'H', '1690-03-16', 'Batavia', '1690-05-31', '1690-06-14', true, '1690-10-08', 'Goeree', 1446, NULL);
INSERT INTO "voyages" VALUES (5881, '', 2, '', 'NIEUWLAND', 'Jan de Marre', 544, 'fluit', '1685', NULL, NULL, 'Z', 'E', '1690-03-16', 'Batavia', '1690-05-31', '1690-06-14', true, '1690-10-08', 'Goeree', 1581, NULL);
INSERT INTO "voyages" VALUES (5882, '', 3, '', 'PRINSELAND', 'Paulus Huntum', 710, 'fluit', '1681', NULL, NULL, 'D', 'D', '1690-03-16', 'Batavia', '1690-05-31', '1690-06-14', true, '1690-10-08', 'Goeree', 1563, 'At the Cape Paulus Huntum became commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5883, '', 1, '', 'SCHOLTENBURG', NULL, NULL, 'galjoot', NULL, NULL, '1689', 'A', 'A', '1690-07-15', 'The Cape', '1690-07-15', NULL, true, NULL, NULL, 1588, NULL);
INSERT INTO "voyages" VALUES (5884, '', 1, '', 'SCHAAPHERDER', 'Gerrit Loeling', 90, 'jacht', 'Indies 1690', NULL, NULL, NULL, 'A', '1690-12-15', 'Batavia', '1691-02-27', '1691-03-11', true, NULL, NULL, NULL, 'Probably the first ship built in the Indies and used for a homeward-bound voyage. Date of arrival in the Republic unknown.');
INSERT INTO "voyages" VALUES (5885, '', 1, '', 'FARM', 'Kornelis Simon', 477, 'pinas? jacht?', '1682', NULL, NULL, 'A', 'A', '1691-02-15', 'Bengal', '1691-04-26', '1691-07-04', true, '1691-12-04', 'Goeree', 1463, 'from the Cape together with the CHINA (5874), the fleet of 02-03-1691 from Ceylon, the ALIDA (5892), and the ENGEL MICHAEL (5893).');
INSERT INTO "voyages" VALUES (5886, '', 1, '', 'KRAB', 'Baltus Doen', 644, 'fluit', '1688', NULL, NULL, 'H', 'A', '1691-02-15', 'Bengal', '1691-04-26', '1691-07-04', true, '1691-12-05', 'Texel', 1584, NULL);
INSERT INTO "voyages" VALUES (5887, '', 3, '', 'BANTAM', 'Bruin Jansz.', 1138, 'pinas? jacht?', '1683', NULL, NULL, 'A', 'A', '1691-03-02', 'Ceylon', '1691-05-22', '1691-07-04', true, '1691-12-05', 'Texel', 1580, 'Fleet from Ceylon (5887-5889). See also 5885.');
INSERT INTO "voyages" VALUES (5888, '', 1, '', 'BELOIS', NULL, 506, 'fluit', '1687', NULL, NULL, 'D', 'A', '1691-03-02', 'Ceylon', '1691-05-22', '1691-07-04', true, '1691-12-04', 'Goeree', 1595, NULL);
INSERT INTO "voyages" VALUES (5889, '', 4, '', 'GOUDESTEIN', 'Gilbert Brans', 843, 'pinas', '1679', NULL, NULL, 'A', 'Z', '1691-03-02', 'Ceylon', '1691-05-21', '1691-07-04', true, '1691-12-04', 'Rammekens', 1594, NULL);
INSERT INTO "voyages" VALUES (5890, '', 4, '', 'LANGEWIJK', 'Jan Barendsz.', 544, 'fluit', '1682', NULL, NULL, 'E', 'D', '1691-03-28', 'Batavia', '1691-07-05', '1691-07-04', true, '1691-11-06', 'Goeree', 1592, '(5890-5891).');
INSERT INTO "voyages" VALUES (5891, '', 2, '', 'NIEROP', 'Alexander Simons van Amsterdam', 494, 'fluit', '1684', NULL, NULL, 'E', 'R', '1691-03-28', 'Batavia', '1691-07-11', '1691-07-04', true, '1691-11-07', 'Goeree', 1600, NULL);
INSERT INTO "voyages" VALUES (5892, '', 1, '', 'ALIDA', NULL, NULL, 'galjoot', NULL, NULL, '1690', 'A', 'A', '1691-07-04', 'The Cape', '1691-07-04', NULL, true, '1691-12-05', 'Texel', 1604, 'See 5885.');
INSERT INTO "voyages" VALUES (5893, '', 1, '', 'ENGEL MICHAEL', 'Gerrit Michielsz.', NULL, 'galjoot', NULL, NULL, '1690', 'A', 'A', '1691-07-04', 'The Cape', '1691-07-04', NULL, true, '1691-12-05', 'Texel', 1605, 'See 5885.');
INSERT INTO "voyages" VALUES (5894, '', 3, '', 'EENHOORN', 'Pieter van Ede', 749, NULL, '1683', NULL, NULL, 'Z', 'Z', '1692-01-30', 'Batavia', '1692-05-27', '1692-06-26', true, '1692-10-30', 'Rammekens', 1596, 'WATERLAND (5899). At the Cape the fleet of 28-02-1692 from Ceylon and the MOERKAPEL (5905) joined this fleet. The EENHOORN sailed via Saldanha Bay (21 till 27-05-1692). According to K.A. 4007 its crew consisted of 146 men.');
INSERT INTO "voyages" VALUES (5895, '', 4, '', 'RIDDERSCHAP VAN HOLLAND', 'Jan Ammansz.', 1138, NULL, '1681', NULL, NULL, 'A', 'E', '1692-01-30', 'Batavia', '1692-05-27', '1692-06-26', true, '1692-10-14', 'Vlissingen', 1587, 'Acc. to K.A. 4007 the crew consisted of 184 men. Via Saldanha Bay (01 till 27-05-1692).');
INSERT INTO "voyages" VALUES (5896, '', 1, '', 'SCHOONDIJK', 'Lambert Klein', 759, NULL, '1688', NULL, NULL, 'Z', 'D', '1692-01-30', 'Batavia', '1692-05-27', '1692-06-26', true, '1692-10-15', 'Veere', 1585, 'Acc. to K.A. 4007 the crew consisted of 146 men. Via Saldanha Bay (21 till 27-05-1692).');
INSERT INTO "voyages" VALUES (5897, '', 1, '', 'VOETBOOG', 'Egbert Kalf', 595, 'fluit', '1687', NULL, NULL, 'A', 'R', '1692-01-30', 'Batavia', '1692-05-27', '1692-06-26', true, '1692-10-14', 'Vlissingen', 1575, 'Acc. to K.A. 4007 the crew consisted of 125 men. Via Saldanha Bay (01 till 27-05-1692).');
INSERT INTO "voyages" VALUES (5898, '', 2, '', 'WAALSTROOM', 'Klaas Koman', 648, 'pinas', '1684', NULL, NULL, 'A', 'H', '1692-01-30', 'Batavia', NULL, NULL, true, '1692-10-01', 'Texel', 1582, 'Acc. to K.A. 4390a the master was Pieter Pietersz. The ship probably did not call at the Cape.');
INSERT INTO "voyages" VALUES (5899, '', 3, '', 'WATERLAND', 'Willem Kemp', 1138, NULL, '1683', NULL, NULL, 'A', 'A', '1692-01-30', 'Batavia', '1692-05-27', '1692-06-26', true, NULL, NULL, 1601, 'consisted of 184 men. The WATERLAND sailed via Saldanha Bay (01 till 21-05-1692). On 12-09-1692 the ship was attacked by the French and sunk with all hands at 45''N.');
INSERT INTO "voyages" VALUES (5900, '', 1, '', 'GOEDE HOOP', 'Anthonie Pronk', 1177, 'pinas', '1688', NULL, NULL, 'A', 'A', '1692-02-28', 'Ceylon', '1692-05-07', NULL, true, NULL, NULL, 1591, 'fleet of 30-01-1692 at the Cape. The GOEDE HOOP was wrecked at the Cape, 05-06-1692; from the cargo 562,488 was saved and carried to patria aboard the EMMENES (5911).');
INSERT INTO "voyages" VALUES (5901, '', 1, '', 'MIJDRECHT', NULL, 597, 'pinas? jacht?', '1688', NULL, NULL, 'A', 'R', '1692-02-28', 'Ceylon', '1692-06-01', '1692-06-26', true, '1692-10-14', 'Goeree', 1593, NULL);
INSERT INTO "voyages" VALUES (5902, '', 3, '', 'SPIERDIJK', 'Sieuwert de Jong', 606, 'fluit? hekboot?', '1685', NULL, NULL, 'A', 'A', '1692-02-28', 'Ceylon', '1692-05-03', '1692-06-26', true, '1692-10-10', 'Veere', 1606, 'Acc. to K.A. 4390a the ship arrived on 10-12-1692 at Veere.');
INSERT INTO "voyages" VALUES (5903, '', 2, '', 'LANDS WELVAREN', 'Jan Speelman', 1145, 'pinas', '1685', NULL, NULL, 'A', 'Z', '1692-02-28', 'Ceylon', '1692-05-07', '1692-06-26', true, '1692-10-16', 'Rammekens', 1598, NULL);
INSERT INTO "voyages" VALUES (5904, '', 2, '', 'HOGERGEEST', 'Jakob ter Huisen', 222, 'pinas? jacht?', '1681', NULL, NULL, 'A', NULL, '1692-03-06', 'Batavia', '1692-05-23', NULL, true, NULL, NULL, 1615, 'On 10-06-1692 the HOGERGEEST was wrecked at the Cape.');
INSERT INTO "voyages" VALUES (5905, '', 2, '', 'MOERKAPEL', 'Jasper de Leeuw', 685, 'pinas? jacht?', '1684', NULL, NULL, 'R', 'R', '1692-03-29', 'Batavia', '1692-05-26', '1692-06-26', true, '1692-10-15', 'Veere', 1586, 'Joined the return fleet of 30-01-1692 at the Cape.');
INSERT INTO "voyages" VALUES (5906, '', 1, '', 'DRECHTERLAND', 'Gillis van Markel', 756, NULL, '1688', NULL, NULL, 'E', 'E', '1692-12-11', 'Batavia', '1693-03-20', '1693-04-17', true, '1693-08-07', 'Texel', 1577, 'First return fleet (5906-5910) under command of Jan van den Berg; he died before arrival at the Cape. Abraham Zeeman, master of the NEDERLAND (5907), succeeded him. At the Cape the HANDBOOG (5912) joined the fleet. 
Acc. to K.A. 4007 the crew of the DRECHTERLAND consisted of 125 men.');
INSERT INTO "voyages" VALUES (5907, '', 2, '', 'NEDERLAND', 'Abraham Jakobsz. Zeeman', 1173, 'pinas?', '1687', NULL, NULL, 'A', 'A', '1692-12-11', 'Batavia', '1693-03-20', '1693-04-17', true, '1693-08-07', 'Texel', 1618, 'succeeded Jan van den Berg as commandeur of the return fleet (see 5906).');
INSERT INTO "voyages" VALUES (5908, '', 4, '', 'PRINSELAND', 'Adriaan Palestein', 710, 'fluit', '1681', NULL, NULL, 'D', 'R', '1692-12-11', 'Batavia', '1693-03-16', '1693-04-17', true, '1693-08-07', 'Texel', 1627, 'Acc. to K.A. 4007 the crew consisted of 120 men. At least one passenger was on board.');
INSERT INTO "voyages" VALUES (5909, '', 1, '', 'REIGERSDAAL', 'Adriaansz.', 818, 'pinas', '1691', NULL, NULL, 'A', 'Z', '1692-12-11', 'Batavia', '1693-03-20', '1693-04-17', true, '1693-08-07', 'Rammekens', 1631, 'Acc. to K.A. 4007 the crew consisted of 120 men.');
INSERT INTO "voyages" VALUES (5910, '', 3, '', 'SION', 'Jakob Swaaf', 740, NULL, '1686', NULL, NULL, 'D', 'D', '1692-12-11', 'Batavia', '1693-03-20', '1693-04-17', true, '1693-08-07', 'Goeree', 1621, 'Acc. to K.A. 4007 the crew consisted of 128 
men. Acc. to K.A. 4390a the name of the master was Jakob Klaasz. Mouthaan.');
INSERT INTO "voyages" VALUES (5911, '', 3, '', 'EMMENES', NULL, 297, 'fluit? kat?', '1682', NULL, NULL, 'A', 'A', '1693-01-07', 'Batavia', '1693-03-31', '1693-06-12', true, '1693-10-02', 'Veere', 1608, 'was only bound for the Cape, but it had to carry the cargo saved from the GOEDE HOOP (5900) to patria. At the Cape the ship joined the second return fleet of 0802-1693.');
INSERT INTO "voyages" VALUES (5912, '', 2, '', 'HANDBOOG', 'Kornelis Koleman', 594, 'fluit', '1687', NULL, NULL, 'A', 'H', '1693-01-07', 'Batavia', '1693-03-18', '1693-04-17', true, '1693-08-07', 'Texel', 1609, 'The ship joined the first return fleet of 11-12-1692 at the Cape.');
INSERT INTO "voyages" VALUES (5913, '', 1, '', 'BERKEL', 'Herman Voet', 280, 'fluit', '1689', NULL, NULL, 'D', 'D', '1693-02-08', 'Batavia', '1693-05-15', '1693-06-12', true, '1693-10-04', 'Rammekens', 1614, '(5913-5916); at the Cape the fleet of 28-02-1693 from Ceylon, the EMMENES (5911), and the SCHIE-BROEK (5921) joined this fleet. Herman Voet, master of the BERKEL, was in command of the combined fleet. Acc to K.A. 4009 the BERKEL''s crew consisted of 97 men.');
INSERT INTO "voyages" VALUES (5914, '', 2, '', 'OOSTHUIZEN', 'Willem van Texel', 500, 'fluit', '1687', NULL, NULL, 'E', 'E', '1693-02-08', 'Batavia', '1693-05-15', '1693-06-12', true, '1693-10-04', 'Veere', 1619, 'Acc. to K.A. 4009 the crew consisted of 92 men.');
INSERT INTO "voyages" VALUES (5915, '', 2, '', 'PAMPUS', 'Jan de Wit', 604, NULL, '1686', NULL, NULL, 'A', 'R', '1693-02-08', 'Batavia', '1693-05-15', '1693-06-12', true, '1693-10-04', 'Rammekens', 1610, 'Acc. to K.A. 4009 the crew consisted of 120 men.');
INSERT INTO "voyages" VALUES (5916, '', 1, '', 'SIRJANSLAND', 'Jan Gerritsz.', 759, NULL, '1691', NULL, NULL, 'Z', 'H', '1693-02-08', 'Batavia', '1693-05-15', '1693-06-12', true, '1693-10-04', 'Veere', 1635, 'Acc. to K.A. 4009 the crew consisted of 133 men.');
INSERT INTO "voyages" VALUES (5917, '', 1, '', 'HOF VAN ILPENDAM', 'Michiel de Vries', 700, 'pinas', '1691', NULL, NULL, 'A', 'A', '1693-02-28', 'Ceylon', '1693-05-20', '1693-06-12', true, '1693-10-04', 'Veere', 1629, 'The ships from Ceylon (5917-5920) joined the return fleet of 0802-1693 at the Cape.');
INSERT INTO "voyages" VALUES (5918, '', 3, '', NULL, 'OOSTERLAND. Aarnoud Scheiteruit', 1123, NULL, '1685', NULL, NULL, 'Z', 'Z', '1693-02-28', 'Ceylon', '1693-05-20', '1693-06-12', true, '1693-10-04', 'Rammekens', 1612, 'Acc. to K.A. 4009 the crew consisted of 140 men.');
INSERT INTO "voyages" VALUES (5919, '', 3, '', 'PURMER', NULL, 582, 'fregat', '1681', NULL, NULL, 'A', 'A', '1693-02-28', 'Ceylon', '1693-05-20', '1693-06-12', true, '1693-10-04', 'Veere', 1620, 'Acc. to K.A. 4009 the crew consisted of 90 men.');
INSERT INTO "voyages" VALUES (5920, '', 3, '', 'VOORSCHOTEN', NULL, 558, 'fluit', '1684', NULL, NULL, 'D', 'A', '1693-02-28', 'Ceylon', '1693-05-20', '1693-06-12', true, '1693-10-04', 'Veere', 1616, NULL);
INSERT INTO "voyages" VALUES (5921, '', 3, '', 'SCHIEBROEK', 'Jakob Dirksz.', 250, 'jachtje', '1681', NULL, NULL, 'Z', 'A', '1693-03-10', 'Batavia', '1693-05-27', '1693-06-12', true, '1693-10-09', NULL, 1534, 'Acc. to K.A. 4009 the ship departed on 16-03-1693 from Batavia and had a crew of 45 men. It joined the return fleet of 08-02-1693 at the Cape. In 1694 sold in patria.');
INSERT INTO "voyages" VALUES (5922, '', 4, '', 'BANTAM', NULL, 1138, 'pinas? jacht?', '1683', NULL, NULL, 'A', 'A', '1693-12-07', 'Batavia', '1694-03-03', '1694-04-16', true, '1694-07-27', 'Texel', 1643, 'First return fleet (5922-5927). At the Cape the ships of 23-01-1694 joined this fleet. The combined fleet was under command of Hendrik Pronk and Adriaan van Laren. The 10 ''passengers'' aboard the BANTAM were French prisoners.');
INSERT INTO "voyages" VALUES (5923, '', 1, '', 'BRANDENBURG', NULL, 817, NULL, '1690', NULL, NULL, 'A', 'R', '1693-12-07', 'Batavia', '1694-03-11', '1694-04-16', true, '1694-06-27', 'Texel', 1607, 'The 8 ''passengers'' were French prisoners. Acc. to K.A. 4009 the crew consisted of 138 men.');
INSERT INTO "voyages" VALUES (5924, '', 1, '', 'DRIEBERGEN', NULL, 616, 'fluit', '1692', NULL, NULL, 'A', 'H', '1693-12-07', 'Batavia', '1694-03-03', '1694-04-16', true, '1694-07-26', 'Texel', 1660, 'Acc. to K.A. 4009 the crew consisted of 110 men. The ''passengers'' were French prisoners.');
INSERT INTO "voyages" VALUES (5925, '', 1, '', 'KARTHAGO', NULL, 759, NULL, '1692', NULL, NULL, 'Z', 'Z', '1693-12-07', 'Batavia', '1694-03-03', '1694-04-16', true, '1694-07-27', 'Texel', 1662, 'Acc. to K.A. 4009 the crew consisted of 151 men. The ''passengers'' were French prisoners.');
INSERT INTO "voyages" VALUES (5926, '', 2, '', 'LEK', NULL, 762, 'pinas', '1686', NULL, NULL, 'A', 'D', '1693-12-07', 'Batavia', '1694-03-11', '1694-04-16', true, '1694-06-27', 'Texel', 1617, 'Acc. to K.A. 4009 the crew consisted of 125 men. The ''passengers'' were French prisoners.');
INSERT INTO "voyages" VALUES (5927, '', 1, '', 'WATERMAN', NULL, 588, 'fluit', '1691', NULL, NULL, 'E', 'E', '1693-12-07', 'Batavia', '1694-03-12', '1694-04-16', true, '1694-07-27', 'Texel', 1654, 'Acc. to K.A. 4009 the crew consisted of 101 men. The ''passengers'' were French prisoners.');
INSERT INTO "voyages" VALUES (5928, '', 2, '', 'FAAM', 'Steven Harteveld', 477, 'pinas? jacht?', '1682', NULL, NULL, 'A', 'Z', '1694-01-23', 'Ceylon', '1694-03-31', '1694-04-16', true, '1694-07-27', 'Texel', 1656, 'The ships from Ceylon (5928-5929) joined the return fleet of 07-12-1693 at the Cape.');
INSERT INTO "voyages" VALUES (5929, '', 2, '', 'VOETBOOG', 'Marten de Jeugd', 595, 'fluit', '1687', NULL, NULL, 'A', 'A', '1694-01-23', 'Ceylon', '1694-04-03', '1694-04-16', true, '1694-07-27', 'Texel', 1663, NULL);
INSERT INTO "voyages" VALUES (5930, '', 1, '', 'AGATHA', 'Jan Stam', NULL, 'fluit', NULL, NULL, '1692', 'A', 'A', '1694-02-07', 'Batavia', '1694-05-05', '1694-06-12', true, '1694-10-08', 'Texel', 1655, 'Second return fleet (5930-5933) under command of Jan Speelman, master of the NIGTEVECHT (5932).');
INSERT INTO "voyages" VALUES (5931, '', 1, '', 'ITERSHEM', 'Klaas Neuselaar', 579, 'fluit', '1691', NULL, NULL, 'H', 'H', '1694-02-07', 'Batavia', '1694-05-05', '1694-06-12', true, '1694-10-04', 'Texel', 1637, NULL);
INSERT INTO "voyages" VALUES (5932, '', 1, '', 'NIGTEVECHT', 'Jan Speelman', 825, 'pinas', '1692', NULL, NULL, 'A', 'A', '1694-02-07', 'Batavia', '1694-05-05', '1694-06-12', true, '1694-10-04', 'Texel', 1657, 'Jan Speelman was commandeer of the return fleet.');
INSERT INTO "voyages" VALUES (5933, '', 3, '', 'NIEUWLAND', 'Jakob Kuiper', 544, 'fluit', '1685', NULL, NULL, 'Z', 'Z', '1694-02-07', 'Batavia', '1694-05-05', '1694-06-12', true, '1694-10-15', 'Texel', 1639, NULL);
INSERT INTO "voyages" VALUES (5934, '', 2, '', 'KRAB', 'Jan Vlasblom', 644, 'fluit', '1688', NULL, NULL, 'H', 'H', '1694-12-02', 'Batavia', '1695-02-27', '1695-04-18', true, '1695-08-23', 'Goeree', 1638, 'Vos aboard the KONING WILLIAM (5941). At the Cape the BER-KEL (5942), the fleet of 26-01-1695 from Ceylon, and the second return fleet of 04-02-1695 joined this fleet. 
Acc. to K.A. 4012 the crew of the KRAB consisted of 104 men. The 11 passengers included 8 French prisoners.');
INSERT INTO "voyages" VALUES (5935, '', 1, '', 'DRIE KRONEN', 'Alexander Simons', 1075, 'pinas', '1693', NULL, NULL, 'A', 'A', '1694-12-02', 'Batavia', '1695-03-02', '1695-04-18', true, '1695-08-24', 'Goeree', 1677, 'Acc. to K.A. 4011 the crew consisted of 150 men. The 10 ''passengers'' were French prisoners.');
INSERT INTO "voyages" VALUES (5936, '', 1, '', 'HUIS TE LOO', 'Thomas van Willigen', 875, 'pinas', '1691', NULL, NULL, 'A', 'D', '1694-12-02', 'Batavia', '1695-03-02', '1695-04-18', true, '1695-08-23', 'Goeree', 1645, 'Acc. to K.A. 4012 the crew consisted of 140 men. Amongst the passengers were 10 French prisoners.');
INSERT INTO "voyages" VALUES (5937, '', 1, '', 'MERESTEIN', 'Willem Hesselsz. de Vlaming', 826, 'pinas', '1693', NULL, NULL, 'A', 'E', '1694-12-02', 'Batavia', '1695-02-27', '1695-04-18', true, '1695-08-23', 'Texel', 1678, 'Acc. to K.A. 4011 the crew consisted of 124 men. The 9 ''passengers'' were French prisoners.');
INSERT INTO "voyages" VALUES (5938, '', 1, '', 'VOSMAAR', 'Jakob Landsheer', 759, NULL, '1691', NULL, NULL, 'Z', 'Z', '1694-12-02', 'Batavia', '1695-02-27', '1695-04-18', true, '1695-08-23', 'Goeree', 1650, 'Acc. to K.A. 4012 the crew consisted of 148 men. Amongst the passengers were 10 French prisoners.');
INSERT INTO "voyages" VALUES (5939, '', 1, '', 'WADDINXVEEN', 'Elbert Fransz.', 751, NULL, '1691', NULL, NULL, 'R', 'R', '1694-12-02', 'Batavia', '1695-02-26', '1695-04-18', true, '1695-08-23', 'Goeree', 1648, '10 French prisoners.');
INSERT INTO "voyages" VALUES (5940, '', 3, '', 'LANDS WELVAREN', 'Reineus Ole', 1145, 'pinas', '1685', NULL, NULL, 'A', 'Z', '1694-12-02', 'Batavia', '1695-03-03', '1695-04-18', true, '1695-08-23', 'Goeree', 1672, 'prisoners.');
INSERT INTO "voyages" VALUES (5941, '', 1, '', 'KONING WILLIAM', 'Huibert Hossen', 1197, 'pinas', '1692', NULL, NULL, 'A', 'A', '1694-12-02', 'Batavia', '1695-03-03', '1695-04-18', true, '1695-08-24', 'Goeree', 1667, 'the KONING WILLIAM was Reinier de Vos, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5942, '', 2, '', 'BERKEL', 'Leendert van Dijk', 280, 'fluit', '1689', NULL, NULL, 'D', 'A', '1694-12-29', 'Batavia', '1695-03-12', '1695-04-18', true, '1695-08-24', 'Goeree', 1682, 'of 104 men.');
INSERT INTO "voyages" VALUES (5943, '', 2, '', 'MAAS', 'Usbrant Hooglaat', 790, NULL, '1683', NULL, NULL, 'R', 'A', '1695-01-26', 'Ceylon', '1695-04-07', '1695-04-18', true, '1695-08-23', 'Goeree', 1599, 'According to K.A. 4013 R. de Vos was commandeur of the return fleet (5943-5946). The MAAS was sold in Zeeland in 1696.');
INSERT INTO "voyages" VALUES (5944, '', 2, '', 'MIJDRECHT', 'Gerrit Koper', 597, 'pinas? jacht?', '1688', NULL, NULL, 'A', 'A', '1695-01-26', 'Ceylon', '1695-04-07', '1695-04-18', true, '1695-08-23', 'Texel', 1659, NULL);
INSERT INTO "voyages" VALUES (5945, '', 3, '', 'MOERKAPEL', 'Jan de Ruis', 685, 'pinas? jacht?', '1684', NULL, NULL, 'R', 'Z', '1695-01-26', 'Ceylon', '1695-04-07', '1695-04-18', true, '1695-08-23', 'Goeree', 1674, NULL);
INSERT INTO "voyages" VALUES (5946, '', 1, '', 'USSELMONDE', 'Adriaan Palestein', 832, NULL, '1693', NULL, NULL, 'R', 'A', '1695-01-26', 'Ceylon', '1695-04-07', '1695-04-18', true, '1695-08-24', 'Goeree', 1675, NULL);
INSERT INTO "voyages" VALUES (5947, '', 1, '', 'HUIS TER DUINE', 'Thomas de Kok', 588, 'jacht', '1693', NULL, NULL, 'Z', 'Z', '1695-02-04', 'Batavia', '1695-04-25', '1695-05-12', true, '1695-08-29', 'Goeree', 1683, NULL);
INSERT INTO "voyages" VALUES (5948, '', 1, '', 'SPIEGEL', 'Kornelis Koleman', 831, 'pinas', '1693', NULL, NULL, 'A', 'A', '1695-02-04', 'Batavia', '1695-04-23', '1695-05-12', true, '1695-08-29', 'Texel', 1691, NULL);
INSERT INTO "voyages" VALUES (5949, '', 1, '', 'EIKELENBURG', 'Jakob Dirksz. Uithuizen', 320, 'pinas? jacht?', '1693', NULL, NULL, 'A', 'A', '1695-11-03', 'Batavia', NULL, NULL, false, '1696-10-20', 'Texel', 1707, NULL);
INSERT INTO "voyages" VALUES (5950, '', 2, '', 'BELOIS', 'Jan Barendsz.', 506, 'fluit', '1687', NULL, NULL, 'D', 'D', '1696-02-08', 'Batavia', NULL, NULL, false, '1696-11-27', 'Texel', 1642, 'Commandeur of the return fleet (5950-5960) was Jan de Wit, master of the OOSTERSTEIN (5956); schout-bij-nacht was Dirk Thomasz. aboard the BELOIS. The fleet did not call at the Cape but at St. Helena.');
INSERT INTO "voyages" VALUES (5951, '', 1, '', 'HUIS TE DIEREN', 'Pieter de Leeuw', 603, 'fluit', '1691', NULL, NULL, 'A', 'R', '1696-02-08', 'Batavia', NULL, NULL, false, '1696-11-27', 'Texel', 1644, NULL);
INSERT INTO "voyages" VALUES (5952, '', 4, '', 'EENHOORN', 'Matthijs Laurentsz. Brasser', 749, NULL, '1683', NULL, NULL, 'Z', 'Z', '1696-02-08', 'Batavia', NULL, NULL, false, '1696-11-27', 'Texel', 1661, NULL);
INSERT INTO "voyages" VALUES (5953, '', 1, '', 'GENT', 'Klaas Nanningsz. Sanderus', 816, NULL, '1693', NULL, NULL, 'E', 'A', '1696-02-08', 'Batavia', NULL, NULL, false, '1696-11-27', 'Texel', 1697, NULL);
INSERT INTO "voyages" VALUES (5954, '', 3, '', 'HANDBOOG', 'Jan Gelein', 594, 'fluit', '1687', NULL, NULL, 'A', 'H', '1696-02-08', 'Batavia', NULL, NULL, false, '1696-11-27', 'Texel', 1676, NULL);
INSERT INTO "voyages" VALUES (5955, '', 1, '', 'ISSELT', 'Jan Kleinkens', 785, 'fluit', '1691', NULL, NULL, 'A', 'A', '1696-02-08', 'Batavia', NULL, NULL, false, '1696-11-27', 'Texel', 1630, NULL);
INSERT INTO "voyages" VALUES (5956, '', 2, '', 'OOSTERSTEIN', 'Jan de Wit', 1139, NULL, '1693', NULL, NULL, 'Z', 'Z', '1696-02-08', 'Batavia', NULL, NULL, false, '1696-11-27', 'Texel', 1706, 'Jan de Wit was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5957, '', 2, '', 'SIRJANSLAND', 'Anthonie Pronk', 759, NULL, '1691', NULL, NULL, 'Z', 'A', '1696-02-08', 'Batavia', NULL, NULL, false, '1696-11-27', 'Texel', 1695, 'The master was vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5958, '', 1, '', 'VECHT', 'Hendrik Roos', 626, 'fluit', '1693', NULL, NULL, 'A', 'E', '1696-02-08', 'Batavia', NULL, NULL, false, '1696-11-27', 'Texel', 1702, NULL);
INSERT INTO "voyages" VALUES (5959, '', 2, '', 'WAALSTROOM', 'Klaas Koman', 648, 'pinas', '1684', NULL, NULL, 'A', 'A', '1696-02-08', 'Batavia', NULL, NULL, false, '1696-11-27', 'Texel', 1699, NULL);
INSERT INTO "voyages" VALUES (5960, '', 1, '', 'WIND', 'Kornelis de Gaver', 246, 'jacht', '1691', NULL, NULL, 'Z', 'Z', '1696-02-08', 'Batavia', NULL, NULL, false, '1696-11-27', 'Texel', 1636, 'During the Voyage Isaak Lambrechtsen succeeded Kornelis de Gaver as master.');
INSERT INTO "voyages" VALUES (5961, '', 1, '', 'ROSKAM', NULL, 90, 'hoeker', '1693', NULL, NULL, 'A', 'A', '1696-04-18', 'Ceylon', '1696-07-21', '1696-08-13', true, NULL, NULL, 1679, 'According to K.A. 1475 the ROSKAM was taken by the French, successively by the English, and finally restored to the Company.');
INSERT INTO "voyages" VALUES (5962, '', 5, '', 'BANTAM', 'Pieter de Rande', 1138, 'pinas? jacht?', '1683', NULL, NULL, 'A', 'A', '1697-01-15', 'Batavia', '1697-05-20', '1697-07-17', true, NULL, NULL, 1725, 'replaced him. Hendrik van Buitenhem was vice-commandeur aboard the STAD KEULEN (5967).');
INSERT INTO "voyages" VALUES (5963, '', 1, '', 'BERKENRODE', 'Laurens Witboon', 635, 'fluit', '1694', NULL, NULL, 'A', 'H', '1697-01-15', 'Batavia', '1697-05-20', '1697-07-17', true, '1697-12-03', 'Veere', 1726, 'been the master.');
INSERT INTO "voyages" VALUES (5964, '', 2, '', 'DRIEBERGEN', 'Gerrit Kriek', 616, 'fluit', '1692', NULL, NULL, 'A', 'D', '1697-01-15', 'Batavia', '1697-05-20', '1697-07-17', true, '1697-12-05', 'Goeree', 1713, 'Aboard the DRIEBERGEN was Hendrik Gravia, schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (5965, '', 1, '', 'JERUSALEM', 'Marten de Jonge', 622, 'fluit', '1693', NULL, NULL, 'R', 'R', '1697-01-15', 'Batavia', '1697-05-20', '1697-07-17', true, '1697-12-05', 'Greveling', 1711, NULL);
INSERT INTO "voyages" VALUES (5966, '', 1, '', 'KATTENDIJK', 'Jan Naalhout', 759, NULL, '1694', NULL, NULL, 'Z', 'Z', '1697-01-15', 'Batavia', '1697-05-20', '1697-07-17', true, '1697-12-23', 'Wielingen', 1734, NULL);
INSERT INTO "voyages" VALUES (5967, '', 1, '', 'STAD KEULEN', 'Klaas Ole', 1089, 'pinas', '1693', NULL, NULL, 'A', 'A', '1697-01-15', 'Batavia', '1697-05-20', '1697-07-17', true, '1697-12-04', 'Veere', 1701, 'was Hendrik van Buitenhem, vice-commandeur of the return fleet. Full cargo list printed in Glamann, p. 23/14.');
INSERT INTO "voyages" VALUES (5968, '', 2, '', 'DRIE KRONEN', 'Jan Abrahamsz. Oldenhove', 1075, 'pinas', '1693', NULL, NULL, 'A', 'A', '1697-01-15', 'Batavia', '1697-05-20', '1697-07-17', true, '1697-12-03', 'Veere', 1729, 'the departure from Batavia Jan Abrahamsz. Oldenhove might not yet have been aboard. (see also 5976).');
INSERT INTO "voyages" VALUES (5969, '', 2, '', 'HUIS TE LOO', 'Jakob Swaaf', 875, 'pinas', '1691', NULL, NULL, 'A', 'A', '1697-01-15', 'Batavia', '1697-05-20', '1697-07-17', true, '1697-11-15', 'Texel', 1732, NULL);
INSERT INTO "voyages" VALUES (5970, '', 3, '', 'NEDERLAND', 'Dirk Verdoes', 1173, 'pinas', '1687', NULL, NULL, 'A', 'A', '1697-01-15', 'Batavia', '1697-05-20', '1697-07-17', true, '1697-11-11', 'Goeree', 1688, NULL);
INSERT INTO "voyages" VALUES (5971, '', 1, '', 'VRIJBURG', 'Marinus Verhulst', 784, NULL, '1695', NULL, NULL, 'Z', 'Z', '1697-01-15', 'Batavia', '1697-05-20', '1697-07-17', true, '1697-12-05', 'Wielingen', 1735, NULL);
INSERT INTO "voyages" VALUES (5972, '', 2, '', 'SPIEGEL', 'Kornelis Koleman', 831, 'pinas', '1693', NULL, NULL, 'A', 'A', '1697-01-15', 'Batavia', '1697-05-20', '1697-07-17', true, '1697-12-03', 'Veere', 1731, NULL);
INSERT INTO "voyages" VALUES (5973, '', 2, '', 'WADDINXVEEN', 'Thomas van Willigen', 751, NULL, '1691', NULL, NULL, 'R', 'E', '1697-01-15', 'Batavia', '1697-05-20', NULL, true, NULL, NULL, 1733, 'The WADDINXVEEN was wrecked at the Cape, 24-05-1697, 4 men were saved.');
INSERT INTO "voyages" VALUES (5974, '', 1, '', 'ASSENDELFT', 'Sijbrant Visser', 816, 'pinas', '1694', NULL, NULL, 'A', 'A', '1697-02-17', 'Ceylon', '1697-05-06', '1697-07-17', true, '1697-11-14', 'Texel', 1724, NULL);
INSERT INTO "voyages" VALUES (5975, '', 4, '', 'OOSTERLAND', NULL, 1123, NULL, '1685', NULL, NULL, 'Z', 'A', '1697-02-17', 'Ceylon', NULL, NULL, true, NULL, NULL, 1693, 'The OOSTERLAND was wrecked in the Table Bay, 24-05-1697.');
INSERT INTO "voyages" VALUES (5976, '', 1, '', 'HUIS OVERRIJP', 'Pieter van Doen', 436, 'fluit', '1693', NULL, NULL, 'H', 'Z', '1697-02-17', 'Ceylon', '1697-05-06', '1697-07-17', true, '1697-12-05', 'Wielingen', 1716, 'At the departure from Ceylon Jan Abrahamsz. Oldenhove might have been the master, see also 5968.');
INSERT INTO "voyages" VALUES (5977, '', 4, '', 'SION', 'Ameland Jansz.', 740, NULL, '1686', NULL, NULL, 'D', 'Z', '1697-02-17', 'Ceylon', '1697-05-06', '1697-07-17', true, '1697-12-05', 'Wielingen', 1685, NULL);
INSERT INTO "voyages" VALUES (5978, '', 2, '', 'WATERMAN', 'Klaas Jansz. Neuselaar', 588, 'fluit', '1691', NULL, NULL, 'E', 'A', '1697-02-17', 'Ceylon', '1697-05-06', '1697-07-17', true, '1697-12-03', 'Veere', 1717, NULL);
INSERT INTO "voyages" VALUES (5979, '', 3, '', 'HENNETJE', 'Broek van Hoorn', 90, 'fluit', '1688', NULL, NULL, 'R', 'Z', '1697-02-19', 'Batavia', '1697-04-27', '1697-07-17', true, '1697-12-05', 'Wielingen', 1722, NULL);
INSERT INTO "voyages" VALUES (5980, '', 1, '', 'MATROOS', 'Albert Fokkes', 288, 'fregat', '1692', NULL, NULL, 'A', 'A', '1697-02-19', 'Batavia', '1697-04-27', '1697-07-17', true, '1697-11-01', 'Texel', 1708, NULL);
INSERT INTO "voyages" VALUES (5980, 'A', 2, '', 'OOSTSOUBURG', NULL, 759, NULL, '1686', NULL, NULL, 'Z', 'Z', '1697-07-13', 'Batavia', NULL, NULL, false, '1698-06-21', 'Vlissingen', 1624, 'Sailed via Persia.');
INSERT INTO "voyages" VALUES (5981, '', 1, '', 'BEIEREN', 'Melchior de Vos', 832, NULL, '1692', NULL, NULL, 'D', 'D', '1697-11-30', 'Batavia', '1698-02-17', '1698-03-13', true, '1698-06-28', 'Goeree', 1668, 'Commandeur of the return fleet (5981-5988) was Klaas Bichon aboard the LANDS WELVAREN (5988); at the Cape he embarked on the ISSELT (5989). Vice-commandeur was Paulus Huntum aboard the DOMBURG (5982).');
INSERT INTO "voyages" VALUES (5982, '', 1, '', 'DOMBURG', 'Frans Lievens', 759, NULL, '1690', NULL, NULL, 'Z', 'Z', '1697-11-30', 'Batavia', NULL, NULL, false, '1698-06-21', 'Vlissingen', 1623, 'Aboard the DOMBURG was Paulus Huntum, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (5983, '', 1, '', 'DONKERVLIET', 'Andries Pietersz. de Loper', 794, NULL, '1696', NULL, NULL, 'Z', 'Z', '1697-11-30', 'Batavia', '1698-02-17', '1698-03-13', true, '1698-06-29', 'Wielingen', 1747, NULL);
INSERT INTO "voyages" VALUES (5984, '', 1, '', 'GRIMMESTEIN', 'Abraham Zeeman', 759, NULL, '1696', NULL, NULL, 'A', 'A', '1697-11-30', 'Batavia', '1698-02-20', '1698-03-13', true, '1698-06-26', 'Texel', 1749, NULL);
INSERT INTO "voyages" VALUES (5985, '', 2, '', 'MERESTEIN', 'Albert Bichon', 826, 'pinas', '1693', NULL, NULL, 'A', 'R', '1697-11-30', 'Batavia', '1698-02-17', '1698-03-13', true, '1698-06-28', 'Goeree', 1744, NULL);
INSERT INTO "voyages" VALUES (5986, '', 2, '', 'NIGTEVECHT', 'Jasper de Leeuw', 825, 'pinas', '1692', NULL, NULL, 'A', 'A', '1697-11-30', 'Batavia', '1698-02-17', '1698-03-13', true, '1698-06-26', 'Texel', 1715, NULL);
INSERT INTO "voyages" VALUES (5987, '', 1, '', 'OVERNES', 'Klaas Dekker', 616, 'fluit', '1696', NULL, NULL, 'A', 'H', '1697-11-30', 'Batavia', '1698-02-17', '1698-03-13', true, '1698-06-27', 'Texel', 1751, NULL);
INSERT INTO "voyages" VALUES (5987, 'A', 2, '', 'SCHOONDIJK', 'Lambert Klein', 759, NULL, '1688', NULL, NULL, 'Z', 'E', '1697-11-30', 'Batavia', '1698-02-17', '1698-03-13', true, '1698-06-27', 'Texel', 1670, NULL);
INSERT INTO "voyages" VALUES (5988, '', 4, '', 'LANDS WELVAREN', 'Jan Speelman', 1145, 'pinas', '1685', NULL, NULL, 'A', 'A', '1697-11-30', 'Batavia', '1698-02-17', '1698-03-13', true, '1698-06-26', 'Texel', 1752, 'Aboard the LANDS WELVAREN was Klaas Bichon, commandeur of the return fleet; at the Cape he embarked on the ISSELT (5989).');
INSERT INTO "voyages" VALUES (5989, '', 2, '', 'ISSELT', 'Albert Fransz.', 785, 'fluit', '1691', NULL, NULL, 'A', 'A', '1697-12-10', 'Batavia', '1698-03-06', '1698-04-03', true, '1698-07-04', 'Texel', 1756, 'See also 5981 and 5988.');
INSERT INTO "voyages" VALUES (5990, '', 1, '', 'NOORDGOUW', 'Kornelis van de Voet', 280, 'fregat', '1694', NULL, NULL, 'Z', 'A', '1697-12-10', 'Batavia', '1698-04-03', NULL, true, '1698-07-08', 'Texel', 1720, 'The NOORDGOUW carried the cargoes of the WADDINX-VEEN and the OOSTERLAND, both wrecked at the Cape (see 5973 and 5975).');
INSERT INTO "voyages" VALUES (5991, '', 3, '', 'BERKEL', 'Kornelis Boesem', 280, 'fluit', '1689', NULL, NULL, 'D', 'A', '1698-02-01', 'Ceylon', '1698-04-07', '1698-05-03', true, '1698-08-15', 'Texel', 1739, 'The crew included 6 impotenten.');
INSERT INTO "voyages" VALUES (5992, '', 2, '', 'USSELMONDE', 'Kornelis Jorissen van de Sluis', 832, NULL, '1693', NULL, NULL, 'R', 'Z', '1698-02-01', 'Ceylon', '1698-04-07', '1698-05-03', true, '1698-08-17', 'Wielingen', 1746, 'The crew included 6 impotenten.');
INSERT INTO "voyages" VALUES (5993, '', 2, '', 'GENT', 'Willem de Vlaming', 816, NULL, '1693', NULL, NULL, 'E', 'A', '1698-02-11', 'Batavia', '1698-04-17', '1698-05-08', true, '1698-08-16', 'Texel', 1754, 'W illem de Vlaming was commandeur of the return fleet (5993-5997 and 5999).');
INSERT INTO "voyages" VALUES (5994, '', 2, '', 'KARTHAGO', 'Servaas Adriaansz. Goudzwaard', 759, NULL, '1692', NULL, NULL, 'Z', 'Z', '1698-02-11', 'Batavia', '1698-04-17', '1698-05-08', true, '1698-08-17', 'Wielingen', 1718, NULL);
INSERT INTO "voyages" VALUES (5995, '', 1, '', 'SCHELLAG', 'Dirk Blauw', 290, 'jacht? fregat?', '1696', NULL, NULL, 'Z', 'Z', '1698-02-14', 'Ceylon', '1698-04-29', '1698-05-08', true, '1698-08-17', 'Wielingen', 1763, 'The crew included 3 impotenten.');
INSERT INTO "voyages" VALUES (5996, '', 3, '', 'BELOIS', 'Leendert van Dijk', 506, 'fluit', '1687', NULL, NULL, 'D', 'D', '1698-02-16', 'Ceylon', '1698-04-29', '1698-05-08', true, '1698-08-16', 'Texel', 1753, NULL);
INSERT INTO "voyages" VALUES (5997, '', 1, '', 'BOOR', 'Jan Verbrugge', 192, 'fluit', '1695', NULL, NULL, 'A', 'A', '1698-02-23', 'Batavia', '1698-04-25', '1698-05-08', true, '1698-08-16', 'Texel', 1727, 'According to K.A. 4017 the crew consisted of 48 men.');
INSERT INTO "voyages" VALUES (5998, '', 3, '', 'LEK', 'Adriaan Palestein', 762, 'pinas', '1686', NULL, NULL, 'A', 'A', '1698-02-23', 'Ceylon', '1698-04-07', '1698-05-08', true, '1698-08-15', 'Texel', 1714, 'The crew included 7 impotenten.');
INSERT INTO "voyages" VALUES (5999, '', 1, '', 'ZANDLOPER', 'Gijsbert Martensz. Welgevaren', 244, 'fluit', '1695', NULL, NULL, 'D', 'D', '1698-02-23', 'Batavia', '1698-04-25', '1698-05-08', true, '1698-08-17', 'Wielingen', 1721, NULL);
INSERT INTO "voyages" VALUES (6000, '', 2, '', 'BRANDENBURG', 'Voet', 817, NULL, '1690', NULL, NULL, 'A', 'A', '1698-12-20', 'Batavia', '1699-02-13', '1699-03-20', true, '1699-06-30', 'Texel', 1712, 'REIGERSDAAL (6004).');
INSERT INTO "voyages" VALUES (6001, '', 2, '', 'DRECHTERLAND', 'Herman Goelser', 756, NULL, '1688', NULL, NULL, 'E', 'A', '1698-12-20', 'Batavia', '1699-02-13', '1699-03-20', true, '1699-07-11', 'Texel', 1700, NULL);
INSERT INTO "voyages" VALUES (6002, '', 2, '', 'HOF VAN ILPENDAM', 'Jan Smit', 700, 'pinas', '1691', NULL, NULL, 'A', 'A', '1698-12-20', 'Batavia', '1699-02-13', '1699-03-20', true, '1699-06-29', 'Texel', 1687, NULL);
INSERT INTO "voyages" VALUES (6003, '', 2, '', 'OOSTERSTEIN', 'Jan de Wersijn', 1139, NULL, '1693', NULL, NULL, 'Z', 'A', '1698-12-20', 'Batavia', '1699-02-13', '1699-03-20', true, '1699-06-29', 'Texel', 1762, 'Aboard the OOSTERSTEIN was Daniel Henens, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6004, '', 2, '', 'REIGERSDAAL', 'Gerrit Donker', 818, 'pinas', '1691', NULL, NULL, 'A', 'D', '1698-12-20', 'Batavia', '1699-02-13', '1699-03-20', true, '1699-07-01', 'Goeree', 1684, 'Aboard the REIGERSDAAL was Govert van W ierden, schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6005, '', 1, '', 'UNIE', 'Evert Doedes', 1080, 'pinas', '1696', NULL, NULL, 'A', 'A', '1698-12-20', 'Batavia', '1699-02-13', '1699-03-20', true, '1699-06-29', 'Texel', 1770, NULL);
INSERT INTO "voyages" VALUES (6006, '', 2, '', 'VOSMAAR', 'Joost Klaarbont', 759, NULL, '1691', NULL, NULL, 'Z', 'Z', '1698-12-20', 'Batavia', '1699-02-14', '1699-03-20', true, '1699-07-11', 'Rammekens', 1738, 'was Albert Buis, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6007, '', 3, '', 'DRIEBERGEN', 'Marten de Jonge', 616, 'fluit', '1692', NULL, NULL, 'A', 'R', '1698-12-26', 'Batavia', '1699-02-19', '1699-03-20', true, '1699-06-30', 'Goeree', 1777, NULL);
INSERT INTO "voyages" VALUES (6008, '', 3, '', 'HUTS TE LOO', 'Kornelis Weis', 875, 'pinas', '1691', NULL, NULL, 'A', 'Z', '1698-12-26', 'Batavia', '1699-02-19', '1699-03-20', true, '1699-07-01', 'Wielingen', 1774, NULL);
INSERT INTO "voyages" VALUES (6009, '', 2, '', 'HUTS TE DIEREN', 'Hendrik Vermei', 603, 'fluit', '1691', NULL, NULL, 'A', 'E', '1699-01-22', 'Batavia', '1699-05-05', '1699-06-08', true, '1699-09-25', 'Texel', 1766, NULL);
INSERT INTO "voyages" VALUES (6010, '', 1, '', 'HUTS TE NIEUWBURG', 'Egbert Kalf', 618, 'hekboot? fluit?', '1697', NULL, NULL, 'A', 'A', '1699-01-22', 'Batavia', '1699-05-05', '1699-06-08', true, '1699-09-25', 'Texel', 1775, NULL);
INSERT INTO "voyages" VALUES (6011, '', 1, '', 'BAMBEEK', 'Christiaan van Leeuwen', 845, 'pinas', '1696', NULL, NULL, 'A', 'A', '1699-02-06', 'Ceylon', '1699-05-14', '1699-06-08', true, '1699-09-25', 'Texel', 1769, NULL);
INSERT INTO "voyages" VALUES (6012, '', 4, '', 'NIEUWLAND', NULL, 544, 'fluit', '1685', NULL, NULL, 'Z', 'Z', '1699-02-09', 'Ceylon', '1699-05-14', NULL, true, NULL, NULL, 1719, 'Laid up at the Cape, 1700.');
INSERT INTO "voyages" VALUES (6013, '', 3, '', 'SIRJANSLAND', 'Anthonie Pronk', 759, NULL, '1691', NULL, NULL, 'Z', 'Z', '1699-02-09', 'Ceylon', '1699-05-19', '1699-07-13', true, '1699-11-23', 'Wielingen', 1757, NULL);
INSERT INTO "voyages" VALUES (6014, '', 4, '', 'SPIERDIJK', 'Anthonie Chef', 606, 'fluit? hekboot?', '1685', NULL, NULL, 'A', 'A', '1699-02-09', 'Ceylon', '1699-05-14', '1699-06-08', true, '1699-09-27', 'Texel', 1673, NULL);
INSERT INTO "voyages" VALUES (6015, '', 4, '', 'WAALSTROOM', NULL, 648, 'pinas', '1684', NULL, NULL, 'A', 'A', '1699-02-09', 'Ceylon', '1699-01-01', NULL, true, NULL, NULL, 1758, 'Laid up at the Cape, 27-02-1700.');
INSERT INTO "voyages" VALUES (6016, '', 1, '', 'BEKESTEIN', 'Hendrik Schrik', 324, 'jacht? pinas?', '1694', NULL, NULL, 'A', 'A', '1699-02-12', 'Batavia', '1699-04-19', '1699-06-08', true, '1699-11-06', 'Texel', 1696, NULL);
INSERT INTO "voyages" VALUES (6017, '', 4, '', 'BERKEL', 'Jakob Kuil', 280, 'fluit', '1689', NULL, NULL, 'D', 'A', '1699-07-13', 'Cape', '1699-07-13', NULL, true, '1699-11-15', 'Wielingen', 1790, 'Carried the cargo of the NIEUWLAND (6012), which had been laid up at the Cape in 1700.');
INSERT INTO "voyages" VALUES (6018, '', 1, '', 'CONCORDIA', 'Adriaan Palestein', 900, NULL, '1696', NULL, NULL, 'D', 'Z', '1699-11-25', 'Batavia', '1700-01-27', '1700-03-03', true, '1700-07-02', 'Rammekens', 1765, 'Wouter Valkenier aboard the KATTENDIJK (6020); vice-commandeur was Wijbrand Lycochton aboard the CONCORDIA.');
INSERT INTO "voyages" VALUES (6019, '', 3, '', 'GENT', 'Francois Peis', 816, NULL, '1693', NULL, NULL, 'E', 'Z', '1699-11-25', 'Batavia', '1700-01-27', '1700-03-03', true, '1700-07-02', 'Rammekens', 1791, NULL);
INSERT INTO "voyages" VALUES (6020, '', 2, '', 'KATTENDIJK', 'Jakob Broek', 759, NULL, '1694', NULL, NULL, 'Z', 'A', '1699-11-25', 'Batavia', '1700-01-27', '1700-03-03', true, '1700-06-29', 'Texel', 1788, 'Aboard the KATTENDIJK was Wouter Valkenier, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6021, '', 3, '', 'MIJDRECHT', 'Jan Stam', 579, 'jacht? pinas?', '1688', NULL, NULL, 'A', 'R', '1699-11-25', 'Batavia', '1700-01-27', '1700-03-03', true, '1700-06-29', 'Goeree', 1750, 'At the arrival at Goeree, Meindert de Boer probably was master.');
INSERT INTO "voyages" VALUES (6022, '', 3, '', 'NIGTEVECHT', 'Hendrik Springer', 825, 'pinas', '1692', NULL, NULL, 'A', 'A', '1699-11-25', 'Batavia', '1700-01-27', '1700-03-03', true, '1700-06-29', 'Texel', 1794, NULL);
INSERT INTO "voyages" VALUES (6023, '', 4, '', 'VOORSCHOTEN', 'Jan Subbing', 558, 'fluit', '1684', NULL, NULL, 'D', 'D', '1699-11-25', 'Batavia', '1700-01-28', '1700-03-03', true, '1700-06-25', 'Veere', 1698, NULL);
INSERT INTO "voyages" VALUES (6024, '', 5, '', 'LANDS WELVAREN', 'Adolf Hage', 1145, 'pinas', '1685', NULL, NULL, 'A', 'A', '1699-11-25', 'Batavia', '1700-01-27', '1700-03-03', true, '1700-06-29', 'Texel', 1798, NULL);
INSERT INTO "voyages" VALUES (6025, '', 4, '', 'HANDBOOG', 'Baltus Doen', 594, 'fluit', '1687', NULL, NULL, 'A', 'H', '1699-11-29', 'Batavia', '1700-01-27', '1700-03-03', true, '1700-06-29', 'Texel', 1759, NULL);
INSERT INTO "voyages" VALUES (6026, '', 3, '', 'MERESTEIN', 'Dirk Bent', 826, 'pinas', '1693', NULL, NULL, 'A', 'A', '1699-12-17', 'Batavia', '1700-03-31', '1700-04-29', true, '1700-08-04', 'Texel', 1803, NULL);
INSERT INTO "voyages" VALUES (6027, '', 2, '', 'HUIS OVERRIJP', 'Jan Abrahamsz. van Oldenhove', 436, 'fluit', '1693', NULL, NULL, 'H', 'E', '1699-12-17', 'Batavia', '1700-04-10', '1700-04-29', true, '1700-08-04', 'Texel', 1784, NULL);
INSERT INTO "voyages" VALUES (6028, '', 2, '', 'GRIMMESTEIN', 'Abraham Simon', 759, NULL, '1696', NULL, NULL, 'A', 'Z', '1699-12-20', 'Ceylon', '1700-03-06', '1700-03-31', true, '1700-07-21', 'Rammekens', 1792, 'Commandeur of the return fleet from Ceylon (6028-6031) was Jan Gerritsz. van Bordeaux, master of the SPIEGEL (6029).');
INSERT INTO "voyages" VALUES (6029, '', 3, '', 'SPIEGEL', 'Jan Gerritsz. van Bordeaux', 831, 'pinas', '1693', NULL, NULL, 'A', 'A', '1699-12-20', 'Ceylon', '1700-03-06', '1700-03-31', true, '1700-07-18', 'Texel', 1786, 'Jan Gerritsz. van Bordeaux was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6030, '', 2, '', 'BERKENRODE', 'Klaas Maas', 635, 'fluit', '1694', NULL, NULL, 'A', 'A', '1699-12-23', 'Ceylon', '1700-03-06', '1700-03-31', true, '1700-07-29', 'Texel', 1780, NULL);
INSERT INTO "voyages" VALUES (6031, '', 2, '', 'OVERNES', 'Jan Lookman', 616, 'fluit', '1696', NULL, NULL, 'A', 'A', '1699-12-23', 'Ceylon', '1700-03-06', '1700-03-31', true, '1700-07-18', 'Texel', 1795, NULL);
INSERT INTO "voyages" VALUES (6032, '', 1, '', 'GEELVINK', 'Aldert Koops', 380, 'jacht?', '1696', NULL, NULL, 'A', 'A', '1700-01-21', 'Batavia', '1700-04-25', '1700-04-29', true, '1700-08-04', 'Texel', 1740, NULL);
INSERT INTO "voyages" VALUES (6033, '', 2, '', 'VECHT', 'Jakob Landsheer', 626, 'fluit', '1693', NULL, NULL, 'A', 'E', '1700-01-21', 'Batavia', '1700-04-27', '1700-06-07', true, '1700-10-04', 'Goeree', 1760, NULL);
INSERT INTO "voyages" VALUES (6034, '', 3, '', 'VOETBOOG', 'Adriaan de Ruiter', 595, 'fluit', '1687', NULL, NULL, 'A', 'H', '1700-01-21', 'Batavia', NULL, NULL, false, NULL, NULL, 1703, 'Wrecked on 29-05-1700 off Pernambuco.');
INSERT INTO "voyages" VALUES (6035, '', 2, '', 'EIKELENBURG', 'Herman Blokhuizen', 320, 'jacht? pinas?', '1693', NULL, NULL, 'A', 'Z', '1700-02-20', 'Batavia', NULL, NULL, false, '1700-08-06', 'Rammekens', 1781, NULL);
INSERT INTO "voyages" VALUES (6036, '', 4, '', 'LEK', 'Gerrit Koper', 762, 'pinas', '1686', NULL, NULL, 'A', 'A', '1700-03-31', 'The Cape', '1700-03-31', NULL, true, '1700-07-19', 'Texel', 1812, 'Carried the cargo of the WAALSTROOM (6015), which had been laid up at the Cape in 1700.');
INSERT INTO "voyages" VALUES (6037, '', 3, '', 'DRIE KRONEN', 'Jakob Onkruid', 1075, 'pinas', '1693', NULL, NULL, 'A', 'A', '1700-10-26', 'Batavia', '1701-01-11', '1701-01-31', true, '1701-05-21', 'Texel', 1783, 'Jakob Onkruid was commandeur of the return fleet (6037-6039).');
INSERT INTO "voyages" VALUES (6038, '', 3, '', 'OOSTERSTEIN', 'Kornelis van de Mast', 1139, NULL, '1693', NULL, NULL, 'Z', 'Z', '1700-10-26', 'Batavia', '1701-01-11', '1701-01-31', true, '1701-05-22', 'Rammekens', 1819, NULL);
INSERT INTO "voyages" VALUES (6039, '', 1, '', 'VENHUIZEN', 'Klaas Kompas', 250, 'fluit', '1697', NULL, NULL, 'E', 'E', '1700-10-26', 'Batavia', '1701-01-11', '1701-01-31', true, '1701-05-21', 'Texel', 1785, NULL);
INSERT INTO "voyages" VALUES (6040, '', 1, '', 'HUIS TE BIJWEG', 'Jakob Zalm', 392, 'fluit', '1699', NULL, NULL, 'A', 'A', '1700-11-10', 'Batavia', '1701-02-26', '1701-03-16', true, '1701-07-18', 'Texel', 1805, 'Commandeur of the return fleet (6040-6047) was Kornelis Koleman, master of the LIEFDE (6044); Kornelis Jorisz. Oversluis, master of the DOMBURG (6041), was vice-commandeur; schout-bij-nacht was Abraham Oudenhoorn, master of the SCHOON-DERLOO (6047).');
INSERT INTO "voyages" VALUES (6041, '', 2, '', 'DOMBURG', 'Kornelis Jorissen Oversluis', 759, NULL, '1690', NULL, NULL, 'Z', 'Z', '1700-11-10', 'Batavia', '1701-02-20', '1701-03-16', true, '1701-07-18', 'Rammekens', 1823, 'Kornelis Jorisz. Oversluis was vice-commandeur  of the return fleet.');
INSERT INTO "voyages" VALUES (6042, '', 2, '', 'JERUSALEM', 'Abraham Toon', 622, 'fluit', '1693', NULL, NULL, 'R', 'R', '1700-11-10', 'Batavia', '1701-02-20', '1701-03-16', true, '1701-07-18', 'Goeree', 1778, NULL);
INSERT INTO "voyages" VALUES (6043, '', 1, '', 'PEPERBOOM', 'Dirk Fokkes', 533, 'fluit', '1699', NULL, NULL, 'A', 'Z', '1700-11-10', 'Batavia', '1701-02-20', '1701-03-16', true, '1701-07-18', 'Rammekens', 1807, NULL);
INSERT INTO "voyages" VALUES (6044, '', 1, '', 'LIEFDE', 'Kornelis Koleman', 1009, 'pinas', '1698', NULL, NULL, 'A', 'A', '1700-12-01', 'Batavia', '1701-02-26', '1701-03-16', true, '1701-07-18', 'Texel', 1810, 'Kornelis Koleman was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6045, '', 3, '', 'SCHOONDUK', 'Willem van Texel', 759, NULL, '1688', NULL, NULL, 'Z', 'H', '1700-12-01', 'Batavia', '1701-02-26', '1701-03-16', true, '1701-07-18', 'Texel', 1827, NULL);
INSERT INTO "voyages" VALUES (6046, '', 2, '', 'STAD KEULEN', 'Kornelis de Vlaming', 1089, 'pinas', '1693', NULL, NULL, 'A', 'A', '1700-12-02', 'Batavia', '1701-02-26', '1701-03-16', true, '1701-07-18', 'Texel', 1782, NULL);
INSERT INTO "voyages" VALUES (6047, '', 1, '', 'SCHOONDERLOO', 'Abraham Oudenhoom', 622, 'fluit', '1693', NULL, NULL, 'D', 'D', '1700-12-02', 'Batavia', '1701-03-01', '1701-03-16', true, '1701-07-18', 'Goeree', 1710, 'was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6048, '', 3, '', 'VOSMAAR', 'Gerrit Gerritsz.', 759, NULL, '1691', NULL, NULL, 'Z', 'A', '1700-12-18', 'Batavia', '1701-03-19', '1701-03-31', true, '1701-07-18', 'Texel', 1836, NULL);
INSERT INTO "voyages" VALUES (6049, '', 2, '', 'BOOR', NULL, 192, 'fluit', '1695', NULL, NULL, 'A', 'A', '1700-12-19', 'Batavia', NULL, NULL, true, NULL, NULL, 1811, 'between Batavia and the Cape');
INSERT INTO "voyages" VALUES (6050, '', 2, '', 'BEIEREN', 'Melchior de Vos', 832, NULL, '1692', NULL, NULL, 'D', 'Z', '1700-12-20', 'Ceylon', '1701-02-26', '1701-03-16', true, '1701-07-18', 'Rammekens', 1799, NULL);
INSERT INTO "voyages" VALUES (6051, '', 1, '', 'HORSTENDAAL', 'Reinier Vink', 688, 'pinas', '1699', NULL, NULL, 'A', 'A', '1700-12-20', 'Ceylon', '1701-02-26', '1701-03-16', true, '1701-07-18', 'Texel', 1817, NULL);
INSERT INTO "voyages" VALUES (6052, '', 3, '', 'USSELMONDE', 'Hendrik Roos', 832, NULL, '1693', NULL, NULL, 'R', 'A', '1700-12-20', 'Ceylon', '1701-02-26', '1701-03-16', true, '1701-07-18', 'Texel', 1808, NULL);
INSERT INTO "voyages" VALUES (6053, '', 3, '', 'REIGERSDAAL', 'Marten de Jeugd', 818, 'pinas', '1691', NULL, NULL, 'A', 'A', '1700-12-23', 'Batavia', '1701-03-08', '1701-03-31', true, '1701-07-18', 'Texel', 1833, NULL);
INSERT INTO "voyages" VALUES (6054, '', 2, '', 'DONKERVLIET', 'Marinus Stokke', 794, NULL, '1696', NULL, NULL, 'Z', 'D', '1701-01-28', 'Batavia', '1701-03-30', '1701-04-12', true, '1701-07-18', 'Goeree', 1800, 'fleet (6054-6056) was Alexander Simons, master of the THEEBOOM (6056).');
INSERT INTO "voyages" VALUES (6055, '', 1, '', 'HAAK', 'Sijbrand Visser', 550, 'fluit', '1699', NULL, NULL, 'E', 'H', '1701-01-31', 'Batavia', '1701-03-30', '1701-04-12', true, '1701-07-18', 'Texel', 1831, NULL);
INSERT INTO "voyages" VALUES (6056, '', 1, '', 'THEEBOOM', 'Alexander Simons', 526, 'fluit', '1699', NULL, NULL, 'A', 'A', '1701-01-31', 'Batavia', '1701-03-30', '1701-04-12', true, '1701-07-18', 'Texel', 1820, 'Alexander Simons was Commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6057, '', 1, '', 'PETER EN PAUL', 'Klaas Dekker', 278, 'fregat', '1697', NULL, NULL, 'A', 'Z', '1701-02-13', 'Batavia', '1701-05-12', '1701-05-24', true, '1701-09-10', 'Rammekens', 1787, NULL);
INSERT INTO "voyages" VALUES (6058, '', 4, '', 'BELOIS', 'Jan Verbrugge', 506, 'fluit', '1687', NULL, NULL, 'D', 'R', '1701-11-28', 'Batavia', '1702-02-13', '1702-03-15', true, '1702-07-22', 'Texel', 1804, 'Kollaart, master of the SION (6067).');
INSERT INTO "voyages" VALUES (6059, '', 3, '', 'DRECHTERLAND', 'Meindert de Boer', 756, NULL, '1688', NULL, NULL, 'E', 'E', '1701-11-28', 'Batavia', '1702-02-13', '1702-03-15', true, '1702-07-22', 'Texel', 1845, NULL);
INSERT INTO "voyages" VALUES (6060, '', 4, '', 'DRIEBERGEN', 'Dirk Krijne', 616, 'fluit', '1692', NULL, NULL, 'A', 'A', '1701-11-28', 'Batavia', '1702-02-13', '1702-03-15', true, '1702-07-22', 'Texel', 1851, NULL);
INSERT INTO "voyages" VALUES (6061, '', 3, '', 'KARTHAGO', 'Pieter Donker', 759, NULL, '1692', NULL, NULL, 'Z', 'Z', '1701-11-28', 'Batavia', '1702-02-13', '1702-03-15', true, '1702-07-22', 'Texel', 1825, 'During the voyage Isaak Philipsz. succeeded Pieter Donker as master.');
INSERT INTO "voyages" VALUES (6062, '', 3, '', 'KATTENDIJK', 'Jakob de Jong', 759, NULL, '1694', NULL, NULL, 'Z', 'Z', '1701-11-28', 'Batavia', '1702-02-13', '1702-03-15', true, '1702-07-22', 'Texel', 1846, NULL);
INSERT INTO "voyages" VALUES (6063, '', 1, '', 'MOLENWERF', 'Evert Doedes', 554, 'fluit', '1700', NULL, NULL, 'H', 'H', '1701-11-28', 'Batavia', '1702-02-13', '1702-03-15', true, '1702-07-22', 'Texel', 1848, NULL);
INSERT INTO "voyages" VALUES (6064, '', 4, '', 'NIGTEVECHT', 'Jan van Wijk', 825, 'pinas', '1692', NULL, NULL, 'A', 'A', '1701-11-28', 'Batavia', '1702-02-13', '1702-03-15', true, '1702-07-22', 'Texel', 1840, NULL);
INSERT INTO "voyages" VALUES (6065, '', 3, '', 'OVERNES', 'Gerrit de Boer', 616, 'fluit', '1696', NULL, NULL, 'A', 'A', '1701-11-28', 'Batavia', '1702-02-13', '1702-03-15', true, '1702-07-22', 'Texel', 1849, NULL);
INSERT INTO "voyages" VALUES (6066, '', 1, '', 'GENERALE VREDE', 'Willem Elshoek', 1008, 'pinas', '1669', NULL, NULL, 'A', 'A', '1701-11-28', 'Batavia', '1702-02-13', '1702-03-15', true, '1702-07-22', 'Texel', 1834, 'Aboard the GENERALE VREDE was Harman Voet, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6067, '', 5, '', 'SION', 'Gerrit Kollaart', 740, NULL, '1686', NULL, NULL, 'D', 'D', '1701-11-28', 'Ceylon', '1702-02-13', '1702-03-15', true, '1702-07-22', 'Texel', NULL, 'Gerrit 1809 Collaart was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6068, '', 2, '', 'ASSENDELFT', 'Amelaand Jansz.', 816, 'pinas', '1694', NULL, NULL, 'A', 'Z', '1701-12-20', 'Ceylon', '1702-02-28', '1702-03-15', true, '1702-07-22', 'Texel', 1773, NULL);
INSERT INTO "voyages" VALUES (6069, '', 5, '', 'BERKEL', 'Jan Gideons', 280, 'fluit', '1689', NULL, NULL, 'D', 'A', '1701-12-20', 'Ceylon', '1702-02-21', '1702-03-15', true, '1702-07-22', 'Texel', 1853, NULL);
INSERT INTO "voyages" VALUES (6070, '', 2, '', 'HUIS TER DUINE', 'Diedlof Kroes', 588, 'jacht', '1693', NULL, NULL, 'Z', 'Z', '1701-12-21', 'Ceylon', '1702-02-21', '1702-03-15', true, '1702-07-22', 'Texel', 1736, NULL);
INSERT INTO "voyages" VALUES (6071, '', 5, '', 'LEK', 'Klaas Schacht', 762, 'pinas', '1686', NULL, NULL, 'A', 'A', '1701-12-23', 'Ceylon', '1702-02-21', '1702-03-15', true, '1702-07-22', 'Texel', 1847, NULL);
INSERT INTO "voyages" VALUES (6072, '', 2, '', 'UNIE', 'Jan Vrelant', 1080, 'pinas', '1696', NULL, NULL, 'A', 'A', '1701-12-23', 'Ceylon', '1702-02-26', '1702-03-15', true, '1702-07-22', 'Texel', 1821, NULL);
INSERT INTO "voyages" VALUES (6073, '', 3, '', 'BRANDENBURG', 'Christiaan van Leeuwen', 817, NULL, '1690', NULL, NULL, 'A', 'A', '1701-12-31', 'Batavia', '1702-02-25', '1702-03-15', true, '1702-07-22', 'Texel', 1838, NULL);
INSERT INTO "voyages" VALUES (6074, '', 1, '', 'OEGSTGEEST', 'Jakob Regenboog', 576, 'hekboot', '1699', NULL, NULL, 'A', 'H', '1701-12-31', 'Batavia', '1702-02-25', '1702-03-15', true, '1702-07-22', 'Texel', 1813, NULL);
INSERT INTO "voyages" VALUES (6075, '', 2, '', 'VRIJBURG', 'Marten Engele', 784, NULL, '1695', NULL, NULL, 'Z', 'Z', '1701-12-31', 'Batavia', '1702-02-24', '1702-03-15', true, '1702-07-22', 'Texel', 1779, NULL);
INSERT INTO "voyages" VALUES (6076, '', 1, '', 'FLORA', 'Jakob Willemsz.', 554, 'fluit', '1699', NULL, NULL, 'A', 'A', '1702-01-03', 'Batavia', '1702-04-30', '1702-05-18', true, '1702-07-22', 'Texel', 1816, NULL);
INSERT INTO "voyages" VALUES (6077, '', 1, '', 'ABBEKERK', 'Jan Naalhout', 242, 'fluit', '1698', NULL, NULL, 'H', 'Z', '1702-01-21', 'Batavia', '1702-04-30', '1702-05-18', true, '1702-08-29', 'Texel', 1789, NULL);
INSERT INTO "voyages" VALUES (6078, '', 2, '', 'GEELVINK', 'Gerrit Koek', 380, 'fregat? jacht?', '1696', NULL, NULL, 'A', 'A', '1702-01-31', 'Batavia', '1702-04-30', '1702-05-18', true, '1702-08-29', 'Texel', 1865, NULL);
INSERT INTO "voyages" VALUES (6079, '', 3, '', 'DOMBURG', 'Matthijs de Geus', 759, NULL, '1690', NULL, NULL, 'Z', 'Z', '1702-11-29', 'Batavia', '1703-03-15', '1703-04-10', true, '1703-08-08', 'Rammekens', 1882, '(6086).');
INSERT INTO "voyages" VALUES (6080, '', 4, '', 'GENT', 'Jakob Verzijde', 816, NULL, '1693', NULL, NULL, 'E', 'E', '1702-11-29', 'Batavia', '1703-03-21', '1703-04-10', true, '1703-08-06', 'Texel', 1871, NULL);
INSERT INTO "voyages" VALUES (6081, '', 3, '', 'GRIMMESTEIN', 'Robbert de Groot', 759, NULL, '1696', NULL, NULL, 'A', 'R', '1702-11-29', 'Batavia', '1703-03-15', '1703-04-10', true, '1703-08-07', 'Goeree', 1864, NULL);
INSERT INTO "voyages" VALUES (6082, '', 2, '', 'LIEFDE', 'Anthonie Pronk', 1009, 'pinas', '1698', NULL, NULL, 'A', 'A', '1702-11-29', 'Batavia', '1703-03-15', '1703-04-10', true, '1703-08-06', 'Texel', 1868, NULL);
INSERT INTO "voyages" VALUES (6083, '', 4, '', 'HUIS TE LOO', 'Jan Portier', 875, 'pinas', '1691', NULL, NULL, 'A', 'A', '1702-11-29', 'Batavia', '1703-03-21', '1703-04-10', true, '1703-08-06', 'Texel', 1835, NULL);
INSERT INTO "voyages" VALUES (6084, '', 2, '', 'HUIS TE NIEUWBURG', 'Oldenhove', 618, 'fluit? hekboot?', '1697', NULL, NULL, 'A', 'H', '1702-11-29', 'Batavia', '1703-03-20', '1703-04-10', true, '1703-08-06', 'Texel', 1818, NULL);
INSERT INTO "voyages" VALUES (6085, '', 4, '', 'OOSTERSTEIN', 'Jan de Wersijn', 1139, NULL, '1693', NULL, NULL, 'Z', 'Z', '1702-11-29', 'Batavia', '1703-03-15', '1703-04-10', true, '1703-08-08', 'Rammekens', 1883, 'Jan de Wersijn was vice-commandeur of the combined return fleet.');
INSERT INTO "voyages" VALUES (6086, '', 4, '', 'REIGERSDAAL', 'Jakob Joppe de Jong', 818, 'pinas', '1691', NULL, NULL, 'A', 'D', '1702-11-29', 'Batavia', '1703-03-06', '1703-04-10', true, '1703-08-07', 'Goeree', 1879, 'Jakob Joppe de Jong was schout-bij-nacht of the combined return fleet.');
INSERT INTO "voyages" VALUES (6087, '', 4, '', 'SPIEGEL', 'Jakob Broek', 831, 'pinas', '1693', NULL, NULL, 'A', 'A', '1702-11-29', 'Batavia', '1703-03-21', '1703-04-10', true, '1703-08-06', 'Texel', 1862, 'Broek was commandeur of the combined fleet.');
INSERT INTO "voyages" VALUES (6088, '', 4, '', 'VOSMAAR', 'Thomas van Willigen', 759, NULL, '1691', NULL, NULL, 'Z', 'A', '1702-11-29', 'Batavia', '1703-03-14', '1703-04-10', true, '1703-08-06', 'Texel', 1881, NULL);
INSERT INTO "voyages" VALUES (6089, '', 6, '', 'LANDS WELVAREN', 'Kornelis Kool', 1145, 'pinas', '1685', NULL, NULL, 'A', 'A', '1702-11-29', 'Batavia', '1703-03-15', '1703-04-10', true, '1703-08-07', 'Texel', 1863, 'After this voyage the ship was sold.');
INSERT INTO "voyages" VALUES (6090, '', 2, '', 'HUIS TE BIJWEG', 'Herman Stellingwerf', 392, 'fluit', '1699', NULL, NULL, 'A', 'Z', '1702-12-29', 'Ceylon', '1703-03-16', '1703-04-10', true, '1703-08-07', 'Wielingen', 1873, NULL);
INSERT INTO "voyages" VALUES (6091, '', 2, '', 'HORSTENDAAL', 'Jan de Rooy', 688, 'pinas', '1699', NULL, NULL, 'A', 'A', '1702-12-29', 'Ceylon', '1703-03-15', '1703-04-10', true, '1703-08-06', 'Texel', 1877, NULL);
INSERT INTO "voyages" VALUES (6092, '', 3, '', 'HUIS OVERRUP', 'Willem Knol', 436, 'fluit', '1693', NULL, NULL, 'H', 'Z', '1702-12-29', 'Ceylon', '1703-04-04', '1703-04-10', true, '1703-08-08', 'Rammekens', 1861, NULL);
INSERT INTO "voyages" VALUES (6093, '', 2, '', 'THEEBOOM', 'Francois Zegers', 526, 'fluit', '1699', NULL, NULL, 'A', 'A', '1702-12-29', 'Ceylon', '1703-03-14', '1703-04-10', true, '1703-08-06', 'Texel', 1870, NULL);
INSERT INTO "voyages" VALUES (6094, '', 1, '', 'ZANDHORST', 'Jan Lookman', 520, 'fluit', '1701', NULL, NULL, 'A', 'H', '1703-02-28', 'Batavia', '1703-06-03', '1703-07-16', true, '1704-04-26', 'Texel', 1896, 'Norway, where a temporary embargo was laid on ship and cargo.');
INSERT INTO "voyages" VALUES (6095, '', 3, '', 'BERKENRODE', 'Klaas Maas', 635, 'fluit', '1694', NULL, NULL, 'A', 'E', '1703-02-28', 'Batavia', '1703-06-03', '1703-07-16', true, '1704-04-26', 'Texel', 1859, 'Since 13-11-1703 in Norway, where a temporary embargo was laid on ship and cargo.');
INSERT INTO "voyages" VALUES (6096, '', 1, '', 'SUIKERMOLEN', 'Pieter Jansz. Voute', 720, 'fluit', '1701', NULL, NULL, 'Z', 'R', '1703-02-28', 'Batavia', '1703-06-02', '1703-07-16', true, '1704-03-03', 'Goeree', 1894, 'Since 13-11-1703 in Norway, where a temporary embargo was laid on ship and cargo.');
INSERT INTO "voyages" VALUES (6097, '', 1, '', 'DIEMEN', 'Jakob Pikkereeuw', 596, 'fluit', '1700', NULL, NULL, 'A', 'Z', '1703-11-30', 'Batavia', '1704-03-07', '1704-03-30', true, '1704-08-11', 'Rammekens', 1839, 'Commandeur of the combined return fleet (6097-6112) was Adolf Winkler aboard the WESTHOVEN (6104); vice-commandeur was Diedlof Kroes, master of the GENERALE VREDE (6105); schout-bij-nacht was Kornelis Valk, master of the DON-KERVLIET (6098).');
INSERT INTO "voyages" VALUES (6098, '', 3, '', 'DONKERVLIET', 'Kornelis Valk', 794, NULL, '1696', NULL, NULL, 'Z', 'D', '1703-11-30', 'Batavia', '1704-03-03', '1704-03-30', true, '1704-08-11', 'Goeree', 1874, 'Kornelis Valk was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6099, '', 2, '', 'FLORA', 'J5 de Klunder', 554, 'fluit', '1699', NULL, NULL, 'A', 'A', '1703-11-30', 'Batavia', '1704-03-03', '1704-03-30', true, '1704-08-09', 'Texel', 1905, NULL);
INSERT INTO "voyages" VALUES (6100, '', 2, '', 'HAAK', 'Jan Leroux', 550, 'fluit', '1699', NULL, NULL, 'E', 'E', '1703-11-30', 'Batavia', '1704-03-03', '1704-03-30', true, '1704-08-09', 'Texel', 1875, NULL);
INSERT INTO "voyages" VALUES (6101, '', 3, '', 'HOF VAN ILPENDAM', 'Joris van der Wijn', 700, 'pinas', '1691', NULL, NULL, 'A', 'A', '1703-11-30', 'Batavia', '1704-03-03', '1704-03-30', true, '1704-08-09', 'Texel', 1832, NULL);
INSERT INTO "voyages" VALUES (6102, '', 4, '', 'SIRJANSLAND', 'Dirk Dirksz. Ballast', 759, NULL, '1691', NULL, NULL, 'Z', 'Z', '1703-11-30', 'Batavia', '1704-03-03', '1704-03-30', true, '1704-08-10', 'Rammekens', 1852, NULL);
INSERT INTO "voyages" VALUES (6103, '', 3, '', 'UNIE', 'Adriaan Bogaard', 1080, 'pinas', '1696', NULL, NULL, 'A', 'A', '1703-11-30', 'Batavia', '1704-03-07', '1704-03-30', true, '1704-08-09', 'Texel', 1910, NULL);
INSERT INTO "voyages" VALUES (6104, '', 1, '', 'WESTHOVEN', 'Kornelis Gillisz. van Middelburg', 776, NULL, '1698', NULL, NULL, 'Z', 'Z', '1703-11-30', 'Batavia', '1704-03-09', '1704-03-30', true, '1704-08-11', 'Rammekens', 1802, 'Aboard the WESTHOVEN were Adolf Winkler, commandeur of the return fleet, and his family.');
INSERT INTO "voyages" VALUES (6105, '', 2, '', 'GENERALE VREDE', 'Diedlof Kroes', 1008, 'pinas', '1699', NULL, NULL, 'A', 'A', '1703-11-30', 'Batavia', '1704-03-03', '1704-03-30', true, '1704-08-09', 'Texel', 1911, 'Diedlof Kroes was vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6106, '', 4, '', 'USSELMONDE', 'van de Vijver', 832, NULL, '1693', NULL, NULL, 'R', 'R', '1703-11-30', 'Batavia', '1704-03-03', '1704-03-30', true, '1704-08-11', 'Goeree', 1887, NULL);
INSERT INTO "voyages" VALUES (6107, '', 2, '', 'CONCORDIA', 'Jan Munkhoven', 900, NULL, '1696', NULL, NULL, 'D', 'Z', '1703-12-25', 'Ceylon', '1704-03-03', '1704-03-30', true, '1704-08-11', 'Rammekens', 1856, NULL);
INSERT INTO "voyages" VALUES (6108, '', 5, '', 'DRIEBERGEN', 'Jakob Regenboog', 616, 'fluit', '1692', NULL, NULL, 'A', 'A', '1703-12-25', 'Ceylon', '1704-03-03', '1704-03-30', true, '1704-08-09', 'Texel', 1904, NULL);
INSERT INTO "voyages" VALUES (6109, '', 1, '', 'GANSENHOEF', 'Marten Engele', 640, 'fluit', '1702', NULL, NULL, 'A', 'Z', '1703-12-25', 'Ceylon', '1704-03-03', '1704-03-30', true, '1704-08-11', 'Rammekens', 1901, NULL);
INSERT INTO "voyages" VALUES (6110, '', 1, '', 'HUIS TE HEMERT', 'Thomas de Bois', 612, 'fluit', '1701', NULL, NULL, 'A', 'A', '1703-12-25', 'Ceylon', '1704-03-09', '1704-03-30', true, '1704-08-09', 'Texel', 1876, NULL);
INSERT INTO "voyages" VALUES (6111, '', 3, '', 'VRIJBURG', 'Pieter Oostendorp', 784, NULL, '1695', NULL, NULL, 'Z', 'A', '1703-12-25', 'Ceylon', '1704-03-09', '1704-03-30', true, '1704-08-09', 'Texel', 1914, NULL);
INSERT INTO "voyages" VALUES (6112, '', 2, '', 'ABBEKERK', 'Pieter Wijmans', 242, 'fluit', '1698', NULL, NULL, 'H', 'H', '1703-12-30', 'Batavia', '1704-03-03', '1704-03-30', true, '1704-08-09', 'Texel', 1912, NULL);
INSERT INTO "voyages" VALUES (6113, '', 5, '', 'BELOIS', 'Hendrik den Exter', 506, 'fluit', '1687', NULL, NULL, 'D', 'Z', '1704-02-05', 'Batavia', '1704-04-28', '1704-05-10', true, '1704-09-05', 'Goeree', 1916, 'Commandeur of the return fleet (6113-6116) was C. H. Rollenburg.');
INSERT INTO "voyages" VALUES (6114, '', 4, '', 'BRANDENBURG', 'Volkert Schouten', 817, NULL, '1690', NULL, NULL, 'A', 'A', '1704-02-05', 'Batavia', '1704-04-17', '1704-05-10', true, '1704-09-08', 'Elbe', 1899, NULL);
INSERT INTO "voyages" VALUES (6115, '', 3, '', 'JERUSALEM', 'David Kodde', 622, 'fluit', '1693', NULL, NULL, 'R', 'H', '1704-02-05', 'Batavia', '1704-04-17', '1704-05-10', true, '1704-09-06', 'Ooster Eems', 1888, NULL);
INSERT INTO "voyages" VALUES (6116, '', 2, '', 'SCHOONDERLOO', 'Paulus Kroon', 622, 'fluit', '1693', NULL, NULL, 'D', 'A', '1704-02-05', 'Batavia', '1704-04-17', '1704-05-10', true, '1704-09-05', 'Goeree', 1917, NULL);
INSERT INTO "voyages" VALUES (6117, '', 2, '', 'NOORDGOUW', 'Jakob Willemsz.', 280, 'fregat', '1694', NULL, NULL, 'Z', 'Z', '1704-02-28', 'Batavia', NULL, NULL, false, '1704-08-01', 'Texel', 1841, 'According to K.A. 1563, fol. 1579 a call at the Cape was not allowed.');
INSERT INTO "voyages" VALUES (6118, '', 3, '', 'ASSENDELFT', 'Huibert Vermeulen', 816, 'pinas', '1694', NULL, NULL, 'A', 'E', '1704-12-01', 'Batavia', '1705-02-18', '1705-03-28', true, '1705-07-23', 'Texel', 1941, 'master of the DOMBURG (6119); vice-commandeur was Adolf Hage, master of the DEN BERG (6123); Dirk Krijne, master of the GRIMMESTEIN (6125), was schout-bij-nacht');
INSERT INTO "voyages" VALUES (6119, '', 4, '', 'DOMBURG', 'Gerrit Hendriksz. van Fenween', 759, NULL, '1690', NULL, NULL, 'Z', 'Z', '1704-12-01', 'Batavia', '1705-02-25', '1705-03-28', true, '1705-07-23', 'Wielingen', 1942, 'The master was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6120, '', 3, '', 'TER DUINE', 'Jan Geerts', 588, NULL, '1693', NULL, NULL, 'Z', 'Z', '1704-12-01', 'Batavia', '1705-02-18', '1705-03-28', true, '1705-07-23', 'Wielingen', 1934, NULL);
INSERT INTO "voyages" VALUES (6121, '', 3, '', 'HORSTENDAAL', 'Joris Vis', 688, 'pinas', '1699', NULL, NULL, 'A', 'A', '1704-12-01', 'Batavia', '1705-02-17', '1705-03-28', true, '1705-07-23', 'Texel', 1925, NULL);
INSERT INTO "voyages" VALUES (6122, '', 2, '', 'VENHUIZEN', 'Kornelis de Geus', 250, 'fluit', '1697', NULL, NULL, 'E', 'H', '1704-12-01', 'Batavia', '1705-02-18', '1705-03-28', true, '1705-07-23', 'Texel', 1880, NULL);
INSERT INTO "voyages" VALUES (6123, '', 1, '', 'DEN BERG', 'Adolf Hage', 836, NULL, '1701', NULL, NULL, 'A', 'A', '1704-12-18', 'Batavia', '1705-03-06', '1705-03-28', true, '1705-07-23', 'Texel', 1866, 'Adolf Hage was vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6124, '', 1, '', 'BEVERWAART', 'Pieter Jansz. Kalis', 760, NULL, '1702', NULL, NULL, 'A', 'A', '1704-12-18', 'Batavia', '1705-03-06', '1705-03-28', true, '1705-07-23', 'Texel', 1900, NULL);
INSERT INTO "voyages" VALUES (6125, '', 4, '', 'GRIMMESTEIN', 'Dirk Krijne', 759, NULL, '1696', NULL, NULL, 'A', 'D', '1704-12-18', 'Batavia', '1705-03-06', '1705-03-28', true, '1705-07-23', 'Goeree', 1935, 'Dirk Krijne was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6126, '', 1, '', 'KIEFHOEK', 'Kornelis Boesem', 832, NULL, '1701', NULL, NULL, 'R', 'R', '1704-12-18', 'Batavia', '1705-03-06', '1705-03-28', true, '1705-07-23', 'Goeree', 1878, NULL);
INSERT INTO "voyages" VALUES (6127, '', 4, '', 'OVERNES', 'Herman de Marre', 616, 'fluit', '1696', NULL, NULL, 'A', 'A', '1704-12-26', 'Ceylon', '1705-02-27', '1705-03-28', true, '1705-07-23', 'Texel', 1907, NULL);
INSERT INTO "voyages" VALUES (6128, '', 3, '', 'THEEBOOM', 'Pieter Opterwilt', 526, 'fluit', '1699', NULL, NULL, 'A', 'Z', '1704-12-26', 'Ceylon', '1705-02-28', '1705-03-28', true, '1705-07-23', 'Wielingen', 1932, NULL);
INSERT INTO "voyages" VALUES (6129, '', 1, '', 'ZOELEN', 'Schut', 656, 'fluit', '1699', NULL, NULL, 'R', 'A', '1704-12-26', 'Ceylon', '1705-02-27', '1705-03-28', true, '1705-07-23', 'Texel', 1822, NULL);
INSERT INTO "voyages" VALUES (6130, '', 4, '', 'KATTENDIJK', 'Arie Tilburg', 759, NULL, '1694', NULL, NULL, 'Z', 'Z', '1705-02-09', 'Batavia', '1705-05-11', '1705-06-02', true, '1705-10-02', 'Texel', 1926, NULL);
INSERT INTO "voyages" VALUES (6131, '', 2, '', 'OEGSTGEEST', 'Dirk Korver', 576, 'hekboot', '1699', NULL, NULL, 'A', 'A', '1705-02-09', 'Batavia', '1705-05-11', '1705-06-02', true, '1705-10-02', 'Texel', 1922, NULL);
INSERT INTO "voyages" VALUES (6132, '', 1, '', 'HUIS TE ROZENBURG', 'Herman, Jurriaansz. Daal', 576, 'fluit', '1702', NULL, NULL, 'A', 'A', '1705-02-09', 'Batavia', '1705-05-11', '1705-06-02', true, '1705-10-02', 'Texel', 1908, NULL);
INSERT INTO "voyages" VALUES (6133, '', 5, '', 'SPIEGEL', 'Jan Eekhout', 831, 'pinas', '1693', NULL, NULL, 'A', 'A', '1705-02-09', 'Batavia', '1705-05-09', '1705-06-02', true, '1705-10-01', 'Texel', 1949, NULL);
INSERT INTO "voyages" VALUES (6134, '', 1, '', 'TAXISBOOMPJE', 'Christiaan Zwart', 614, NULL, '1699', NULL, NULL, 'D', 'A', '1705-02-09', 'Batavia', '1705-05-20', '1705-06-02', true, '1705-10-02', 'Texel', 1815, NULL);
INSERT INTO "voyages" VALUES (6135, '', 1, '', 'ZEEHAAN', NULL, 130, 'galjoot', '1702', NULL, NULL, 'E', 'A', '1705-02-26', 'Ceylon', '1705-05-11', NULL, true, NULL, NULL, 1938, 'The ZEEHAAN was bound for the chamber Amsterdam, according to K.A. 4030, fol. 115, however, it returned from the Cape to Ceylon.');
INSERT INTO "voyages" VALUES (6136, '', 4, '', 'DONKERVLIET', 'Paulus Kroon', 794, NULL, '1696', NULL, NULL, 'Z', 'R', '1705-12-01', 'Batavia', '1706-02-03', '1706-04-04', true, '1706-07-26', 'Texel', 1958, 'SCHOONDERLOO (6138), was schout-bij-nacht.');
INSERT INTO "voyages" VALUES (6137, '', 2, '', 'GANSENHOEF', 'Joost de Vlieger', 640, 'fluit', '1702', NULL, NULL, 'A', 'H', '1705-12-01', 'Batavia', '1706-02-04', '1706-04-04', true, '1706-07-26', 'Texel', 1970, NULL);
INSERT INTO "voyages" VALUES (6138, '', 3, '', 'SCHOONDERLOO', 'Willem Elshoek', 622, 'fluit', '1693', NULL, NULL, 'D', 'D', '1705-12-01', 'Batavia', '1706-02-04', '1706-04-04', true, '1706-07-26', 'Texel', 1965, 'Willem Elshoek was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6139, '', 2, '', 'WESTHOVEN', 'Jan Akkerman', 776, NULL, '1698', NULL, NULL, 'Z', 'Z', '1705-12-01', 'Batavia', '1706-02-03', '1706-04-04', true, '1706-07-26', 'Texel', 1972, NULL);
INSERT INTO "voyages" VALUES (6140, '', 1, '', 'ZUIDDORP', 'Arie Taats', 1152, NULL, '1701', NULL, NULL, 'Z', 'Z', '1705-12-01', 'Batavia', '1706-02-03', '1706-04-04', true, '1706-07-26', 'Rammekens', 1884, 'Aboard the ZUIDDORP was Pieter Bogaard, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6141, '', 1, '', 'HOEDEKENSKERKE', 'Jakob Weiland', 830, NULL, '1704', NULL, NULL, 'Z', 'A', '1705-12-18', 'Batavia', '1706-02-04', '1706-04-04', true, '1706-07-20', 'Texel', 1954, 'Aboard the HOEDEKENSKERKE was Jan de Wit, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6142, '', 5, '', 'HUIS TE LOO', 'Jakob Zalm', 875, 'pinas', '1691', NULL, NULL, 'A', 'A', '1705-12-18', 'Batavia', '1706-02-04', '1706-04-04', true, '1706-07-26', 'Texel', 1947, NULL);
INSERT INTO "voyages" VALUES (6143, '', 4, '', 'UNIE', 'Lukas Wormer', 1080, 'pinas', '1696', NULL, NULL, 'A', 'A', '1705-12-18', 'Batavia', '1706-02-03', '1706-04-04', true, '1706-07-26', 'Texel', 1966, NULL);
INSERT INTO "voyages" VALUES (6144, '', 3, '', 'GENERALE VREDE', 'Egbert Kalf', 1008, 'pinas', '1699', NULL, NULL, 'A', 'A', '1705-12-18', 'Batavia', '1706-02-04', '1706-04-04', true, '1706-07-20', 'Texel', 2031, NULL);
INSERT INTO "voyages" VALUES (6145, '', 1, '', 'BEVERWIJK', 'Gerrit Gerritsz.', 836, NULL, '1700', NULL, NULL, 'A', 'A', '1705-12-21', 'Ceylon', '1706-03-05', '1706-04-04', true, '1706-07-26', 'Texel', 1844, 'also 6136.');
INSERT INTO "voyages" VALUES (6146, '', 1, '', '''T GHIJN', 'Haye Jansz.', 810, NULL, '1701', NULL, NULL, 'A', 'A', '1705-12-21', 'Ceylon', '1706-03-06', '1706-04-04', true, '1706-07-26', 'Texel', 1867, NULL);
INSERT INTO "voyages" VALUES (6147, '', 4, '', 'KARTHAGO', 'Isaak Keuvel', 759, NULL, '1692', NULL, NULL, 'Z', 'Z', '1705-12-24', 'Ceylon', '1706-03-05', '1706-04-04', true, '1706-07-26', 'Texel', 1913, NULL);
INSERT INTO "voyages" VALUES (6148, '', 2, '', 'HUIS TE HEMERT', ', Huibert de Vries', 612, 'fluit', '1701', NULL, NULL, 'A', 'E', '1706-01-01', 'Batavia', '1706-04-04', NULL, true, '1706-07-26', 'Texel', 1964, 'According to K.A. 4390 a, Jakob Willemsz. was master.');
INSERT INTO "voyages" VALUES (6149, '', 2, '', 'DIEMEN', 'Wormer', 596, 'fluit', '1700', NULL, NULL, 'A', 'H', '1706-01-29', 'Batavia', '1706-03-25', '1706-04-24', true, '1706-07-26', 'Texel', 1969, NULL);
INSERT INTO "voyages" VALUES (6150, '', 4, '', 'VRIJBURG', 'Klaas Kompas', 784, NULL, '1695', NULL, NULL, 'Z', 'D', '1706-01-29', 'Batavia', '1706-03-24', '1706-04-24', true, '1706-07-26', 'Texel', 1979, NULL);
INSERT INTO "voyages" VALUES (6151, '', 3, '', 'HUIS TE NIEUWBURG', 'Jakob de Boer', 618, 'fluit? hekboot?', '1697', NULL, NULL, 'A', 'H', '1706-02-13', 'Batavia', '1706-06-07', '1706-07-05', true, '1706-11-15', 'Terschelling', 1848, 'According to K.A. 4390 a, Joost van de Vogel was master.');
INSERT INTO "voyages" VALUES (6152, '', 1, '', 'HAZELNOOT', NULL, 130, 'galjoot', '1698', NULL, NULL, 'A', 'A', '1706-04-02', 'Batavia', '1706-06-06', '1706-07-05', true, NULL, NULL, 1927, 'The HAZELNOOT sunk in the Spanish Sea.');
INSERT INTO "voyages" VALUES (6153, '', 2, '', 'BEVERWAART', 'Hendrik Jurriaansz. Ben', 760, NULL, '1702', NULL, NULL, 'A', 'H', '1706-12-01', 'Batavia', '1707-04-07', '1707-04-29', true, '1707-09-19', 'Texel', 1958, 'Commandeur of the return fleet (6153-6166) was Meindert de Boer aboard the LIEFDE (6157); Dirk Blauw, master of the ELLEMEET (6154), was vice-commandeur; schout-bij-nacht was Jan Koenraad de Lamer aboard the WATERINGEN (6158).');
INSERT INTO "voyages" VALUES (6154, '', 1, '', 'ELLEMEET', 'Dirk Blauw', 670, NULL, '1699', NULL, NULL, 'Z', 'A', '1706-12-01', 'Batavia', '1707-04-02', '1707-04-29', true, '1707-09-19', 'Texel', 1824, 'Dirk Blauw was vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6155, '', 5, '', 'GRIMMESTEIN', 'Klaas Schacht', 759, NULL, '1696', NULL, NULL, 'A', 'R', '1706-12-01', 'Batavia', '1707-03-31', '1707-04-29', true, '1707-09-19', 'Texel', 1988, NULL);
INSERT INTO "voyages" VALUES (6156, '', 4, '', 'HORSTENDAAL', 'Jan Wijnands', 688, 'pinas', '1699', NULL, NULL, 'A', 'E', '1706-12-01', 'Batavia', '1707-03-30', '1707-04-29', true, '1707-09-19', 'Texel', 1993, NULL);
INSERT INTO "voyages" VALUES (6157, '', 3, '', 'LIEFDE', 'Pieter Woordman', 1009, 'pinas', '1698', NULL, NULL, 'A', 'A', '1706-12-01', 'Batavia', '1707-03-31', '1707-04-29', true, '1707-09-15', 'Texel', 1946, 'Aboard the LIEFDE was Meindert de Boer, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6158, '', 1, '', 'WATERINGEN', 'Arnoldus van der Straten', 626, 'jacht', '1701', NULL, NULL, 'D', 'D', '1706-12-01', 'Batavia', '1707-04-05', '1707-04-29', true, '1707-09-19', 'Texel', 1886, 'Aboard the WATERINGEN was Jan Koenraad de Lamer, schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6159, '', 2, '', 'DEN BERG', 'Adriaan Timmerman', 836, NULL, '1701', NULL, NULL, 'A', 'A', '1706-12-18', 'Batavia', '1707-03-31', '1707-04-29', true, '1707-09-15', 'Texel', 1991, NULL);
INSERT INTO "voyages" VALUES (6160, '', 1, '', 'HAM', 'Karel Lavia', 580, 'fluit', '1704', NULL, NULL, 'H', 'A', '1706-12-26', 'Ceylon', '1707-03-08', '1707-04-29', true, '1707-09-19', 'Texel', 1963, NULL);
INSERT INTO "voyages" VALUES (6161, '', 1, '', 'KONING KAREL DE DERDE', 'Herman Stellingwerf', 830, NULL, '1704', NULL, NULL, 'A', 'A', '1706-12-26', 'Ceylon', '1707-03-04', '1707-04-29', true, '1707-09-19', 'Texel', 1952, NULL);
INSERT INTO "voyages" VALUES (6162, '', 1, '', 'POPKENSBURG', 'Wessel van Neercassel', 804, NULL, '1699', NULL, NULL, 'Z', 'A', '1706-12-26', 'Ceylon', '1707-03-08', '1707-04-29', true, '1707-09-15', 'Texel', 1842, NULL);
INSERT INTO "voyages" VALUES (6163, '', 1, '', 'WAARDE', 'Arie Gelijns van der Does', 830, NULL, '1702', NULL, NULL, 'Z', 'A', '1706-12-26', 'Ceylon', '1707-03-04', '1707-04-29', true, '1707-09-19', 'Texel', 1915, NULL);
INSERT INTO "voyages" VALUES (6164, '', 2, '', 'ZANDHORST', 'Jan de Rode', 520, 'fluit', '1701', NULL, NULL, 'A', 'A', '1706-12-26', 'Ceylon', '1707-03-04', '1707-04-29', true, '1707-09-19', 'Texel', 1968, NULL);
INSERT INTO "voyages" VALUES (6165, '', 1, '', 'BON', 'Adriaan Palestein', 600, 'fluit', '1703', NULL, NULL, 'A', 'E', '1707-01-17', 'Batavia', '1707-04-19', '1707-04-29', true, '1707-09-15', 'Texel', 1950, NULL);
INSERT INTO "voyages" VALUES (6166, '', 1, '', 'SCHELLENBERG', 'Dirk Korver', 630, 'fluit', '1705', NULL, NULL, 'A', 'R', '1707-01-17', 'Batavia', '1707-04-19', '1707-04-29', true, '1707-09-19', 'Texel', 1995, NULL);
INSERT INTO "voyages" VALUES (6167, '', 1, '', 'BELVLIET', 'Diedlof Kroes', 586, 'fluit', '1704', NULL, NULL, 'E', 'Z', '1707-02-28', 'Batavia', '1707-05-11', '1707-05-23', true, '1707-09-28', 'Terschelling', 1974, NULL);
INSERT INTO "voyages" VALUES (6168, '', 5, '', 'DONKERVLIET', 'Willem Langerens', 794, NULL, '1696', NULL, NULL, 'Z', 'D', '1707-11-02', 'Batavia', '1708-02-15', '1708-04-23', true, '1708-09-14', 'Goeree', 2025, 'Commandeur of the return fleet (6168-6182) was Kornelis Jan Simons aboard the HUIS TE LOO (6180); vice-commandeur was Hendrik Louis Gerlag aboard the OOSTERSTEIN (6174); Simon Langendam was schout-bij-nacht aboard the DONKER-VLIET.');
INSERT INTO "voyages" VALUES (6169, '', 2, '', '''T GHIJN', 'Jakob Kroes', 810, NULL, '1701', NULL, NULL, 'A', 'A', '1707-11-02', 'Batavia', '1708-02-13', '1708-04-23', true, '1708-09-14', 'Texel', 2020, NULL);
INSERT INTO "voyages" VALUES (6170, '', 3, '', 'ABBEKERK', 'Hendrik Som', 242, 'fluit', '1698', NULL, NULL, 'H', 'H', '1707-11-10', 'Batavia', '1708-01-24', '1708-04-23', true, '1708-09-14', 'Texel', 1973, NULL);
INSERT INTO "voyages" VALUES (6171, '', 1, '', 'BARNEVELD', 'Adolf Hage', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1707-11-10', 'Batavia', '1708-01-30', '1708-04-23', true, '1708-09-14', 'Texel', 2011, NULL);
INSERT INTO "voyages" VALUES (6172, '', 2, '', 'HOEDEKENSKERKE', 'Paulus Visser', 830, NULL, '1704', NULL, NULL, 'Z', 'Z', '1707-11-10', 'Batavia', '1708-02-12', '1708-04-23', true, '1708-09-13', 'Wielingen', 2022, NULL);
INSERT INTO "voyages" VALUES (6173, '', 1, '', 'NEPTUNUS', 'Melchior de Vos', 858, NULL, '1704', NULL, NULL, 'A', 'A', '1707-11-10', 'Batavia', '1708-01-30', '1708-04-23', true, '1708-09-14', 'Texel', 1955, NULL);
INSERT INTO "voyages" VALUES (6174, '', 5, '', 'OOSTERSTEIN', 'Jan de Wersijn', 1139, NULL, '1693', NULL, NULL, 'Z', 'Z', '1707-11-10', 'Batavia', '1708-01-30', '1708-04-23', true, '1708-09-13', 'Wielingen', 1956, 'Aboard the OOSTERSTEIN was Hendrik Louis Gerlag, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6175, '', 5, '', 'USSELMONDE', 'Jan Jongerens', 832, NULL, '1693', NULL, NULL, 'R', 'R', '1707-11-10', 'Batavia', '1708-01-30', '1708-04-23', true, '1708-09-18', 'Goeree', 1980, NULL);
INSERT INTO "voyages" VALUES (6176, '', 1, '', 'LOKHORST', 'Gerrit Koops', 612, 'fluit', '1702', NULL, NULL, 'E', 'E', '1707-11-29', 'Batavia', '1708-02-13', '1708-04-23', true, '1708-09-14', 'Texel', 1920, NULL);
INSERT INTO "voyages" VALUES (6177, '', 4, '', 'THEEBOOM', 'Willem van Texel', 526, 'fluit', '1699', NULL, NULL, 'A', 'A', '1707-11-29', 'Batavia', '1708-02-27', '1708-04-23', true, '1708-09-14', 'Texel', 1997, NULL);
INSERT INTO "voyages" VALUES (6178, '', 1, '', 'HUIS TER BOEDE', 'Marten Engele', 642, NULL, '1702', NULL, NULL, 'Z', 'Z', '1707-12-23', 'Ceylon', '1708-02-26', '1708-04-23', true, '1708-09-13', 'Wielingen', 1924, NULL);
INSERT INTO "voyages" VALUES (6179, '', 2, '', 'KIEFHOEK', 'Dirk Krijne', 832, NULL, '1701', NULL, NULL, 'R', 'Z', '1707-12-23', 'Ceylon', '1708-02-26', '1708-04-23', true, '1708-09-13', 'Wielingen', 1998, NULL);
INSERT INTO "voyages" VALUES (6180, '', 6, '', 'HUIS TE LOO', 'Klaas Maas', 875, 'pinas', '1691', NULL, NULL, 'A', 'A', '1707-12-23', 'Ceylon', '1708-02-23', '1708-04-23', true, '1708-09-14', 'Texel', 2023, 'Simons, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6181, '', 3, '', 'OEGSTGEEST', 'Jan Eekhout', 576, 'hekboot', '1699', NULL, NULL, 'A', 'A', '1707-12-23', 'Ceylon', '1708-02-23', '1708-04-23', true, '1708-09-14', 'Texel', 2002, NULL);
INSERT INTO "voyages" VALUES (6182, '', 2, '', 'ROZENBURG', 'Herman de Marre', 576, 'fluit', '1702', NULL, NULL, 'A', 'A', '1707-12-23', 'Ceylon', '1708-02-26', '1708-04-23', true, '1708-09-14', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (6183, '', 3, '', 'CONCORDIA', 'Joris Vis', 900, NULL, '1696', NULL, NULL, 'D', 'Z', '1708-01-15', 'Batavia', NULL, NULL, true, NULL, NULL, 2007, 'Lost near Mauritius.');
INSERT INTO "voyages" VALUES (6184, '', 1, '', 'ZUIDERBURG', 'Jan Likkert', 618, 'fluit', '1704', NULL, NULL, 'A', 'A', '1708-01-15', 'Batavia', NULL, NULL, true, NULL, NULL, 1987, 'Lost near Mauritius.');
INSERT INTO "voyages" VALUES (6185, '', 1, '', 'DUIVENVOORDE', 'Jakob van den Anker', 620, NULL, '1705', NULL, NULL, 'R', 'R', '1708-02-12', 'Batavia', '1708-07-07', '1708-08-22', true, '1709-04-06', 'Maas', 2009, 'The DUIVENVOORDE called at Falmouth (arrival 15-12-1708).');
INSERT INTO "voyages" VALUES (6186, '', 1, '', 'MEERVLIET', NULL, 210, 'fregat?', '1706', NULL, NULL, 'A', 'A', '1708-06-01', 'The Cape', NULL, NULL, true, '1708-10-02', 'Vlie', 2035, NULL);
INSERT INTO "voyages" VALUES (6187, '', 1, '', 'BREDENHOF', 'Jakob Huibertsz.', 586, 'fluit', '1703', NULL, NULL, 'H', 'H', '1708-11-25', 'Batavia', '1709-02-21', '1709-04-21', true, '1709-08-10', 'Texel', 1945, 'Commandeur of the combined return fleet (6187-6201) was Rijklof Michiel van Goens aboard the LIMBURG (6190); vice-commandeur was Abraham Quevellerius aboard the HERSTEL-LENDE LEEUW (6189); schout-bij-nacht was Willem van der Lely na aboard of the WASSENAAR (6193).');
INSERT INTO "voyages" VALUES (6188, '', 1, '', 'PRINS EUGENIUS', 'Pieter Oosterdorp', 874, NULL, '1703', NULL, NULL, 'A', 'A', '1708-11-25', 'Batavia', '1709-02-21', '1709-04-21', true, '1709-08-10', 'Texel', 1929, NULL);
INSERT INTO "voyages" VALUES (6189, '', 1, '', 'HERSTELDE LEEUW', 'Kornelis Gillisz.', 1138, NULL, '1704', NULL, NULL, 'Z', 'R', '1708-11-25', 'Batavia', '1709-02-20', '1709-04-21', true, '1709-08-30', 'Goeree', 1983, 'Aboard the HERSTELDE LEEUW was Abraham Quevellerius, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6190, '', 1, '', 'LIMBURG', 'Klaas Dekker', 810, NULL, '1704', NULL, NULL, 'A', 'A', '1708-11-25', 'Batavia', '1709-02-21', '1709-04-21', true, '1709-08-10', 'Texel', 1986, 'Aboard the LIMBURG was Rijklof Michiel van Goens, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6191, '', 4, '', 'HUIS TE NIEUWBURG', 'Jakob Regenboog', 618, 'fluit? hekboot?', '1697', NULL, NULL, 'A', 'A', '1708-11-25', 'Batavia', '1709-02-21', '1709-04-21', true, '1709-08-10', 'Texel', 2051, NULL);
INSERT INTO "voyages" VALUES (6192, '', 2, '', 'SCHELLENBERG', 'Kornelis Kool', 630, 'fluit', '1705', NULL, NULL, 'A', 'R', '1708-11-25', 'Batavia', '1709-02-21', '1709-04-21', true, '1709-08-12', 'Goeree', 2039, NULL);
INSERT INTO "voyages" VALUES (6193, '', 1, '', 'WASSENAAR', 'Kornelis van Overraad', 804, NULL, '1704', NULL, NULL, 'D', 'D', '1708-11-25', 'Batavia', '1709-02-21', '1709-04-21', true, '1709-08-13', 'Goeree', 1981, 'the return fleet.');
INSERT INTO "voyages" VALUES (6194, '', 3, '', 'HUIS TE HEMERT', 'Jan Portier', 612, 'fluit', '1701', NULL, NULL, 'A', 'E', '1708-11-28', 'Batavia', '1709-03-11', '1709-04-21', true, '1709-08-10', 'Texel', 2021, NULL);
INSERT INTO "voyages" VALUES (6195, '', 3, '', 'WESTHOVEN', 'Krijn Andriesz.', 776, NULL, '1698', NULL, NULL, 'Z', 'Z', '1708-11-30', 'Batavia', '1709-03-12', '1709-04-21', true, '1709-08-13', 'Goeree', 2032, NULL);
INSERT INTO "voyages" VALUES (6196, '', 1, '', 'GAMRON', 'Marten van der Tocht', 848, NULL, '1706', NULL, NULL, 'A', 'A', '1708-12-23', 'Ceylon', '1709-03-08', '1709-04-21', true, '1709-08-10', 'Texel', 2019, NULL);
INSERT INTO "voyages" VALUES (6197, '', 1, '', 'SCHONEWAL', 'Jakob de Bie', 632, 'jacht', '1703', NULL, NULL, 'Z', 'Z', '1708-12-23', 'Ceylon', '1709-03-08', '1709-04-21', true, '1709-08-13', 'Goeree', 1937, NULL);
INSERT INTO "voyages" VALUES (6198, '', 1, '', 'SLOTEN', 'Koert Gerritsz.', 610, 'fluit', '1704', NULL, NULL, 'A', 'A', '1708-12-23', 'Ceylon', '1709-03-08', '1709-04-21', true, '1709-08-10', 'Texel', 1957, NULL);
INSERT INTO "voyages" VALUES (6199, '', 5, '', 'UNIE', 'Hidding Idesz. Nooy', 1080, 'pinas', '1696', NULL, NULL, 'A', 'Z', '1708-12-23', 'Ceylon', '1709-02-20', '1709-04-21', true, '1709-08-13', 'Goeree', 2030, NULL);
INSERT INTO "voyages" VALUES (6200, '', 4, '', 'GENERALE VREDE', 'Gerrit Gerritsz. Boom', 1008, 'pinas', '1699', NULL, NULL, 'A', 'A', '1708-12-23', 'Ceylon', '1709-03-04', '1709-04-21', true, '1709-08-10', 'Texel', 2031, NULL);
INSERT INTO "voyages" VALUES (6201, '', 2, '', 'BEVERWIJK', 'Adriaan Bogaard', 836, NULL, '1700', NULL, NULL, 'A', 'A', '1709-01-01', 'Batavia', '1709-03-19', '1709-04-21', true, '1709-08-10', 'Texel', 2026, NULL);
INSERT INTO "voyages" VALUES (6202, '', 1, '', 'DONAU', 'Jakob Pikkereeuw', 794, NULL, '1705', NULL, NULL, 'Z', 'Z', '1709-01-21', 'Batavia', '1709-04-30', '1709-06-11', true, '1709-10-22', 'Goeree', 1996, NULL);
INSERT INTO "voyages" VALUES (6203, '', 1, '', 'RIJNENBURG', 'Jakob Verzijde', 618, 'fluit', '1704', NULL, NULL, 'A', 'H', '1709-01-21', 'Batavia', '1709-05-01', '1709-06-11', true, '1709-10-27', 'Texel', 1978, NULL);
INSERT INTO "voyages" VALUES (6204, '', 2, '', 'WATERINGEN', 'Jakob Heerman', 626, 'jacht', '1701', NULL, NULL, 'D', 'A', '1709-02-20', 'Batavia', '1709-05-21', '1709-06-11', true, '1709-10-20', 'Texel', 2053, NULL);
INSERT INTO "voyages" VALUES (6205, '', 2, '', 'ZEEHAAN', NULL, 130, 'galjoot', '1702', NULL, NULL, 'E', 'A', '1709-02-20', 'Batavia', '1709-06-11', NULL, true, '1709-10-20', 'Texel', NULL, 'For an earlier voyage see 6135.');
INSERT INTO "voyages" VALUES (6206, '', 1, '', 'HARING', 'Dirk van Veen', 140, NULL, '1704', NULL, NULL, 'A', 'A', '1709-04-21', 'Cape', '1709-04-21', NULL, true, '1709-08-10', 'Texel', 2067, NULL);
INSERT INTO "voyages" VALUES (6207, '', 1, '', 'ZEELANDIA', 'Matthijs Burger', 160, NULL, '1704', NULL, NULL, 'Z', 'Z', '1709-04-21', 'The Cape', '1709-04-21', NULL, true, '1709-08-13', 'Goeree', 2062, NULL);
INSERT INTO "voyages" VALUES (6208, '', 1, '', 'AREND', 'Jan de Wit', 130, NULL, '1708', NULL, NULL, 'A', 'A', '1709-06-11', 'The Cape', '1709-06-11', NULL, true, '1709-10-09', 'Texel', 2068, NULL);
INSERT INTO "voyages" VALUES (6209, '', 1, '', 'BRUG', 'Dionys van Vlierden', 600, NULL, '1708', NULL, NULL, 'E', 'E', '1709-10-31', 'Batavia', '1710-01-11', '1710-04-02', true, '1710-07-16', 'Texel', 2071, 'the ZANDEN-BURG (6215); vice-commandeur was Adam van Rijn aboard the  VADERLAND GETROUW (6214); schout-bij-nacht was Govert Knol aboard the HOEDEKENSKERKE (6211).');
INSERT INTO "voyages" VALUES (6210, '', 6, '', 'GRIMMESTEIN', 'Wessel van Neercassel', 759, NULL, '1696', NULL, NULL, 'A', 'R', '1709-10-31', 'Batavia', '1710-01-10', '1710-04-02', true, '1710-07-17', 'Goeree', 2052, NULL);
INSERT INTO "voyages" VALUES (6211, '', 3, '', 'HOEDEKENSKERKE', 'Hayman de Laver', 830, NULL, '1704', NULL, NULL, 'Z', 'D', '1709-10-31', 'Batavia', '1710-01-10', '1710-04-02', true, '1710-07-16', 'Texel', 2069, 'Aboard the HOEDEKENSKERKE was Govert Knol schout-bij-nacht of the return fleet. According to K.A. 1657, Adriaan van Oosten was master.');
INSERT INTO "voyages" VALUES (6212, '', 4, '', 'LIEFDE', 'Adriaan Timmerman', 1009, 'pinas', '1698', NULL, NULL, 'A', 'A', '1709-10-31', 'Batavia', '1710-01-10', '1710-04-02', true, '1710-07-16', 'Texel', 2059, NULL);
INSERT INTO "voyages" VALUES (6213, '', 2, '', 'MEERVLIET', 'Pieter Kalis', 210, 'jacht? fregat?', '1706', NULL, NULL, 'A', 'A', '1709-10-31', 'Batavia', '1710-01-10', '1710-04-02', true, '1710-07-16', 'Texel', 2064, NULL);
INSERT INTO "voyages" VALUES (6214, '', 1, '', 'VADERLAND GETROUW', 'Pieter Mansveld', 848, NULL, '1705', NULL, NULL, 'Z', 'Z', '1709-10-31', 'Batavia', '1710-01-10', '1710-04-02', true, '1710-07-17', 'Rammekens', 2017, 'Aboard the VADERLAND GETROUW was Adam van Rijn, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6215, '', 1, '', 'ZANDENBURG', 'Gerrit van der Zijde', 1136, NULL, '1706', NULL, NULL, 'Z', 'A', '1709-10-31', 'Batavia', '1710-01-10', '1710-04-02', true, '1710-07-16', 'Texel', 2024, 'Aboard  the ZANDENBURG was the former gouverneur-generaal   Joan van Hoorn, admiraal of the return fleet.');
INSERT INTO "voyages" VALUES (6216, '', 2, '', 'ZUIDDORP', 'Jan Akkerman', 1152, NULL, '1701', NULL, NULL, 'Z', 'Z', '1709-11-13', 'Batavia', '1710-01-31', '1710-04-02', true, '1710-07-16', 'Rammekens', 2033, NULL);
INSERT INTO "voyages" VALUES (6217, '', 6, '', 'DONKERVLIET', 'Arie Turfkloot', 794, NULL, '1696', NULL, NULL, 'Z', 'A', '1709-12-04', 'Batavia', '1710-03-01', '1710-04-02', true, '1710-07-16', 'Texel', 2074, NULL);
INSERT INTO "voyages" VALUES (6218, '', 1, '', 'BAARZANDE', 'Hendrik Stokman', 768, NULL, '1705', NULL, NULL, 'A', 'A', '1709-12-05', 'Batavia', '1710-03-01', '1710-04-02', true, '1710-07-16', 'Texel', 1984, NULL);
INSERT INTO "voyages" VALUES (6219, '', 5, '', 'VRIJBURG', 'Hendrik Thieling', 784, NULL, '1695', NULL, NULL, 'Z', 'H', '1709-12-05', 'Batavia', '1710-03-01', '1710-04-02', true, '1710-07-16', 'Texel', 2034, NULL);
INSERT INTO "voyages" VALUES (6220, '', 2, '', 'BELVLIET', 'Jakob Bogaard', 586, 'fluit', '1704', NULL, NULL, 'E', 'Z', '1709-12-25', 'Ceylon', '1710-03-02', '1710-04-02', true, '1710-07-17', 'Rammekens', 2056, NULL);
INSERT INTO "voyages" VALUES (6221, '', 3, '', 'DIEMEN', 'Pieter Gelinde', 596, 'fluit', '1700', NULL, NULL, 'A', 'A', '1709-12-25', 'Ceylon', '1710-03-17', '1710-04-02', true, '1710-07-16', 'Texel', 2027, NULL);
INSERT INTO "voyages" VALUES (6222, '', 1, '', 'ENGEWORMER', 'Barend Meikens', 560, 'fluit', '1707', NULL, NULL, 'H', 'A', '1709-12-25', 'Ceylon', '1710-03-17', '1710-04-02', true, '1710-07-16', 'Texel', 2057, NULL);
INSERT INTO "voyages" VALUES (6223, '', 5, '', 'HORSTENDAAL', 'Jakob Helma', 688, 'pinas', '1699', NULL, NULL, 'A', 'A', '1709-12-25', 'Ceylon', '1710-03-17', '1710-04-02', true, '1710-07-16', 'Texel', 2058, NULL);
INSERT INTO "voyages" VALUES (6224, '', 2, '', 'KONING KAREL DE DERDE', 'Hendrik Matthijsz. de Wilde', 830, NULL, '1704', NULL, NULL, 'A', 'A', '1709-12-25', 'Ceylon', '1710-03-17', '1710-04-02', true, '1710-07-16', 'Texel', 2049, NULL);
INSERT INTO "voyages" VALUES (6225, '', 2, '', 'POPKENSBURG', 'Herman Grindet', 804, NULL, '1699', NULL, NULL, 'Z', 'Z', '1709-12-25', 'Ceylon', '1710-03-17', '1710-04-02', true, '1710-07-17', 'Rammekens', 2060, NULL);
INSERT INTO "voyages" VALUES (6226, '', 2, '', 'WAARDE', 'Karel Lavia', 830, NULL, '1702', NULL, NULL, 'Z', 'A', '1709-12-25', 'Ceylon', '1710-03-17', '1710-04-02', true, '1710-07-16', 'Texel', 2054, NULL);
INSERT INTO "voyages" VALUES (6227, '', 3, '', 'DEN BERG', 'Jan de Hei', 836, NULL, '1701', NULL, NULL, 'A', 'A', '1710-01-17', 'Batavia', '1710-03-29', '1710-04-02', true, '1710-07-16', 'Texel', 2045, NULL);
INSERT INTO "voyages" VALUES (6228, '', 1, '', 'OUWERKERK', 'Hero Dol', 658, 'fluit', '1706', NULL, NULL, 'A', 'E', '1710-01-17', 'Batavia', '1710-03-28', '1710-04-02', true, '1710-07-16', 'Texel', 2042, NULL);
INSERT INTO "voyages" VALUES (6229, '', 1, '', 'MOSSEL', 'Pieter Frederiksz. de Groot', 676, 'fluit', '1706', NULL, NULL, 'E', 'A', '1710-02-28', 'Batavia', '1710-06-16', '1710-07-24', true, '1711-04-11', 'Texel', 2050, 'The MOSSEL called at Bergen, Norway, 27-12-1710.');
INSERT INTO "voyages" VALUES (6230, '', 1, '', 'ARENDSDUIN', 'Jakob Onkruid', 580, 'jacht', '1708', NULL, NULL, 'D', 'A', '1710-11-30', 'Batavia', '1711-03-06', '1711-06-18', true, '1711-10-07', 'Texel', 2073, 'Admiraal of the combined return fleet (6230-6249) was Pieter de Vos aboard the NOORDBEEK (6238); Adriaan van Tilburg, master of the HERSTELDE LEEUW (6235), was vice-commandeur; schout-bij-nacht was Johannes Focanus aboard the WAS-SENAAR (6241).');
INSERT INTO "voyages" VALUES (6231, '', 1, '', 'ARION', 'Jakob Wijsvliet', 630, 'fluit', '1706', NULL, NULL, 'A', 'A', '1710-11-30', 'Batavia', '1711-03-06', '1711-04-15', true, '1711-08-03', 'Texel', 2018, NULL);
INSERT INTO "voyages" VALUES (6232, '', 1, '', 'AVONTURIER', 'Jan Tessing', 300, 'jacht? fregat?', '1707', NULL, NULL, 'A', 'E', '1710-11-30', 'Batavia', '1711-03-06', '1711-04-15', true, '1711-08-03', 'Texel', 2089, NULL);
INSERT INTO "voyages" VALUES (6233, '', 2, '', 'BARNEVELD', 'Adriaan Palestein', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1710-11-30', 'Batavia', '1711-03-06', '1711-04-15', true, '1711-08-03', 'Texel', 2076, NULL);
INSERT INTO "voyages" VALUES (6234, '', 4, '', 'HUTS TE HEMERT', 'Pieter Daalder', 612, 'fluit', '1701', NULL, NULL, 'A', 'E', '1710-11-30', 'Batavia', '1711-03-06', '1711-04-15', true, '1711-08-03', 'Texel', 2102, NULL);
INSERT INTO "voyages" VALUES (6235, '', 2, '', 'HERSTELDE LEEUW', 'Adriaan van Tilburg', 1138, NULL, '1704', NULL, NULL, 'Z', 'Z', '1710-11-30', 'Batavia', '1711-03-06', '1711-04-15', true, '1711-08-07', 'Rammekens', 2103, 'The master was vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6236, '', 2, '', 'LIMBURG', 'Jurriaan Wormer', 810, NULL, '1704', NULL, NULL, 'A', 'H', '1710-11-30', 'Batavia', '1711-03-06', '1711-04-15', true, '1711-08-03', 'Texel', 2098, NULL);
INSERT INTO "voyages" VALUES (6237, '', 1, '', 'MUNDEN', 'Herman de Marre', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1710-11-30', 'Batavia', '1711-03-06', '1711-04-15', true, '1711-08-03', 'Texel', 2092, NULL);
INSERT INTO "voyages" VALUES (6238, '', 1, '', 'NOORDBEEK', 'Steven Scheiteruit', 858, NULL, '1707', NULL, NULL, 'Z', 'A', '1710-11-30', 'Batavia', '1711-03-06', '1711-04-15', true, '1711-08-03', 'Texel', 2070, 'Aboard the NOORDBEEK was Pieter de Vos, admiraal of the return fleet.');
INSERT INTO "voyages" VALUES (6239, '', 6, '', 'OOSTERSTEIN', 'Daniel Keskes', 1139, NULL, '1693', NULL, NULL, 'Z', 'Z', '1710-11-30', 'Batavia', '1711-03-06', '1711-04-15', true, '1711-08-07', 'Texel', 2106, NULL);
INSERT INTO "voyages" VALUES (6240, '', 1, '', 'STANDVASTIGHEID', 'Jan Verbruggen', 888, NULL, '1706', NULL, NULL, 'A', 'R', '1710-11-30', 'Batavia', '1711-03-06', '1711-04-15', true, '1711-08-05', 'Texel', 2044, NULL);
INSERT INTO "voyages" VALUES (6241, '', 2, '', 'WASSENAAR', 'Jakob Verduin', 804, 'jacht', '1704', NULL, NULL, 'D', 'D', '1710-11-30', 'Batavia', '1711-03-06', '1711-04-15', true, '1711-08-06', 'Goeree', 2108, 'Aboard the WASSENAAR was Johannes Focanus, schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6242, '', 1, '', 'BENTVELD', 'Theunis de Haan', 938, NULL, '1708', NULL, NULL, 'A', 'A', '1710-12-20', 'Ceylon', '1711-03-06', '1711-04-15', true, '1711-08-03', 'Texel', 2078, NULL);
INSERT INTO "voyages" VALUES (6243, '', 1, '', 'BENNEBROEK', NULL, 800, NULL, '1708', NULL, NULL, 'A', 'A', '1710-12-20', 'Ceylon', NULL, NULL, true, NULL, NULL, 2077, 'The BENNEBROEK was wrecked in Struys Baai, east of Cape Agulhas.');
INSERT INTO "voyages" VALUES (6244, '', 3, '', 'BEVERWIJK', 'Wessel Hoogwerf', 839, NULL, '1700', NULL, NULL, 'A', 'A', '1710-12-20', 'Ceylon', '1711-03-18', '1711-04-15', true, '1711-08-03', 'Texel', 2095, NULL);
INSERT INTO "voyages" VALUES (6245, '', 2, '', 'HAM', NULL, 580, 'fluit', '1704', NULL, NULL, 'H', 'A', '1710-12-20', 'Ceylon', '1711-03-23', NULL, true, NULL, NULL, 2048, 'The HAM sailed as far as the Cape; it was laid up there in 1711. See also 6250 and 6272.');
INSERT INTO "voyages" VALUES (6246, '', 1, '', 'RAADHUIS VAN MIDDELBURG', 'Frederik van der Plas', 890, NULL, '1708', NULL, NULL, 'Z', 'Z', '1710-12-20', 'Ceylon', '1711-03-18', '1711-04-15', true, '1711-08-07', 'Rammekens', 2104, NULL);
INSERT INTO "voyages" VALUES (6246, 'A', 2, '', 'SLOTEN', 'Jan de Rode', 610, 'fluit', '1704', NULL, NULL, 'A', NULL, '1710-12-20', 'Ceylon', NULL, NULL, true, NULL, NULL, 2100, 'Lost after departure.');
INSERT INTO "voyages" VALUES (6247, '', 3, '', 'ZANDHORST', NULL, 520, 'fluit', '1701', NULL, NULL, 'A', NULL, '1710-12-20', 'Ceylon', NULL, NULL, true, NULL, NULL, 2055, 'Lost after departure.');
INSERT INTO "voyages" VALUES (6248, '', 1, '', 'KORSSLOOT', 'Jakob Visser', 630, 'fluit', '1705', NULL, NULL, 'H', 'E', '1711-01-16', 'Batavia', '1711-03-28', '1711-04-15', true, '1711-08-03', 'Texel', 2013, NULL);
INSERT INTO "voyages" VALUES (6249, '', 2, '', 'GAMRON', 'Jan van Diemen', 848, NULL, '1706', NULL, NULL, 'A', 'D', '1711-01-17', 'Ceylon', '1711-03-28', '1711-04-15', true, '1711-08-06', 'Goeree', 2097, NULL);
INSERT INTO "voyages" VALUES (6250, '', 1, '', 'HUIS TER LEEDS', 'Kornelis Dobbel', 300, NULL, '1710', NULL, NULL, 'A', 'A', '1711-06-18', 'The Cape', '1711-06-18', NULL, true, '1711-10-09', 'Texel', 2120, 'Carried part of the cargo of the HAM (6245).');
INSERT INTO "voyages" VALUES (6251, '', 1, '', 'BERBICES', 'Kornelis Uitenbroek', 1136, NULL, '1709', NULL, NULL, 'Z', 'Z', '1711-12-01', 'Batavia', '1712-02-13', '1712-03-29', true, '1712-08-18', 'Rammekens', 2137, 'Aboard the BERBICES was Pieter van Hoorn, commandeur of the return fleet; Herman Stellingwerf, master of the GENE-RALE VREDE (6260), was vice-commandeur; schout-bij-nacht was Andries Leenders aboard the KONING KAREL DE DERDE (6254).');
INSERT INTO "voyages" VALUES (6252, '', 4, '', 'DIEMEN', 'Christiaan Emmerij', 596, 'fluit', '1700', NULL, NULL, 'A', 'A', '1711-12-01', 'Batavia', '1712-02-13', '1712-03-29', true, '1712-08-14', 'Texel', 2131, NULL);
INSERT INTO "voyages" VALUES (6253, '', 1, '', 'HARINGTUIN', 'Leendert de Koning', 618, 'fluit', '1705', NULL, NULL, 'E', 'E', '1711-12-01', 'Batavia', '1712-02-13', '1712-03-29', true, '1712-08-19', 'Texel', 2000, NULL);
INSERT INTO "voyages" VALUES (6254, '', 3, '', 'KAREL DE DERDE', 'David Brouwer', 830, NULL, '1704', NULL, NULL, 'A', 'D', '1711-12-01', 'Batavia', '1712-02-13', '1712-03-29', true, '1712-08-18', 'Goeree', 2134, 'Aboard the KONING KAREL DE DERDE was Andries Leenders, schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6255, '', 3, '', 'MEERVLIET', 'Jakob van der Poel', 210, 'fregat/jacht', '1706', NULL, NULL, 'A', 'E', '1711-12-01', 'Batavia', '1712-02-13', '1712-03-29', true, '1712-08-14', 'Texel', 2126, NULL);
INSERT INTO "voyages" VALUES (6256, '', 2, '', 'NEPTUNUS', 'Willem Langerens', 858, NULL, '1704', NULL, NULL, 'A', 'R', '1711-12-01', 'Batavia', '1712-02-13', '1712-03-29', true, '1712-08-18', 'Goeree', 2085, NULL);
INSERT INTO "voyages" VALUES (6257, '', 1, '', 'SAMSON', 'Kornelis de Geus', 800, NULL, '1707', NULL, NULL, 'A', 'H', '1711-12-01', 'Batavia', '1712-02-13', '1712-03-29', true, '1712-08-19', 'Texel', 2066, NULL);
INSERT INTO "voyages" VALUES (6258, '', 2, '', 'SCHONEWAL', 'Lukas Schrik', 632, 'jacht', '1703', NULL, NULL, 'Z', 'Z', '1711-12-01', 'Batavia', '1712-02-13', '1712-03-29', true, '1712-08-18', 'Rammekens', 2107, NULL);
INSERT INTO "voyages" VALUES (6259, '', 6, '', 'UNIE', 'Paulus Kroon', 1080, 'pinas', '1706', NULL, NULL, 'A', 'A', '1711-12-01', 'Batavia', '1712-02-13', '1712-03-29', true, '1712-08-14', 'Texel', 2138, NULL);
INSERT INTO "voyages" VALUES (6260, '', 5, '', 'GENERALS VREDE', 'Herman Stellingwerf', 1008, 'pinas', '1699', NULL, NULL, 'A', 'A', '1711-12-01', 'Batavia', '1712-02-13', '1712-03-29', true, '1712-08-14', 'Texel', 2115, 'The master was vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6261, '', 1, '', 'AMAZONS', 'Jan Meerlaan', 590, 'fluit', '1707', NULL, NULL, 'A', 'A', '1711-12-24', 'Ceylon', '1712-02-13', '1712-03-29', true, '1712-08-14', 'Texel', 2065, NULL);
INSERT INTO "voyages" VALUES (6262, '', 4, '', 'DEN BERG', 'Hendrik Matthijsz. de Wilde', 836, NULL, '1701', NULL, NULL, 'A', 'A', '1711-12-24', 'Ceylon', '1712-03-01', '1712-03-29', true, '1712-08-14', 'Texel', 2129, NULL);
INSERT INTO "voyages" VALUES (6263, '', 2, '', 'ENGEWORMER', 'Willem de Leus', 560, 'fluit', '1707', NULL, NULL, 'H', 'Z', '1711-12-24', 'Ceylon', '1712-03-01', '1712-03-29', true, '1712-08-18', 'Rammekens', 2124, NULL);
INSERT INTO "voyages" VALUES (6264, '', 2, '', 'PRINS EUGENIUS', 'Wouter Thomas van Dijk', 874, NULL, '1703', NULL, NULL, 'A', 'A', '1711-12-24', 'Ceylon', '1712-03-01', '1712-03-29', true, '1712-08-14', 'Texel', 2096, NULL);
INSERT INTO "voyages" VALUES (6265, '', 3, '', 'GANSENHOEF', 'Pieter van Delen', 640, 'fluit', '1702', NULL, NULL, 'A', 'Z', '1711-12-24', 'Ceylon', '1712-03-01', '1712-03-29', true, '1712-08-18', 'Rammekens', 2028, 'According to N.A. 1902, XXVI 94 Klaas van Dalen was master.');
INSERT INTO "voyages" VALUES (6266, '', 1, '', 'NOORDERKWARTIER', 'Hendrik Verwer', 550, 'fluit', '1709', NULL, NULL, 'H', 'A', '1711-12-24', 'Ceylon', '1712-03-01', '1712-03-29', true, '1712-08-14', 'Texel', 2105, NULL);
INSERT INTO "voyages" VALUES (6267, '', 2, '', 'RIJNENBURG', 'Jan de Koning', 618, 'fluit', '1704', NULL, NULL, 'A', 'A', '1711-12-24', 'Ceylon', '1712-03-01', '1712-03-29', true, '1712-08-14', 'Texel', 2114, NULL);
INSERT INTO "voyages" VALUES (6268, '', 3, '', 'SCHELLENBERG', 'Jakob van den Anker', 630, 'fluit', '1705', NULL, NULL, 'A', 'Z', '1711-12-24', 'Ceylon', '1712-03-01', '1712-03-29', true, '1712-08-18', 'Rammekens', 2109, NULL);
INSERT INTO "voyages" VALUES (6269, '', 3, '', 'KIEFHOEK', 'Pieter Kornelisz. Koster', 832, NULL, '1701', NULL, NULL, 'R', 'R', '1712-01-17', 'Batavia', '1712-03-21', '1712-03-29', true, '1712-08-14', 'Goeree', 2081, 'According to K.A. 1693 Karel Lavia was master.');
INSERT INTO "voyages" VALUES (6270, '', 3, '', 'WAARDE', 'Jakob Koole', 830, NULL, '1702', NULL, NULL, 'Z', 'Z', '1712-01-17', 'Batavia', '1712-03-21', '1712-03-29', true, '1712-08-18', 'Rammekens', 2136, '''');
INSERT INTO "voyages" VALUES (6271, '', 1, '', 'VOORBURG', 'Wouter Reiniersz.', 600, NULL, '1710', NULL, NULL, 'D', 'A', '1712-02-15', 'Batavia', '1712-05-26', '1712-06-07', true, '1712-12-09', 'Vlie', 2142, NULL);
INSERT INTO "voyages" VALUES (6272, '', 1, '', 'KIJKUIT', 'Gerrit Moring', 200, 'fregat', '1709', NULL, NULL, 'A', 'A', '1712-03-29', 'The Cape', '1712-03-29', NULL, true, '1712-08-14', 'Texel', 2149, 'Carried part of the cargo of the HAM (6245).');
INSERT INTO "voyages" VALUES (6273, '', 3, '', 'BARNEVELD', 'Adriaan Bogaard', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1712-11-26', 'Batavia', '1713-02-12', '1713-04-10', true, '1713-08-19', 'Texel', 2157, 'Commandeur of the return fleet was Johannes van Steeland aboard the ZANDENBURG (6280); Arie Bogaard, master of the BARNEVELD, was vice-commandeur; schout-bij-nacht was Jan Huigen van Breen. master of the DONAU (6274).');
INSERT INTO "voyages" VALUES (6274, '', 2, '', 'DONAU', 'Jan Huigen van Breen', 794, NULL, '1705', NULL, NULL, 'Z', 'D', '1712-11-26', 'Batavia', '1713-02-12', '1713-04-10', true, '1713-08-22', 'Goeree', 2117, 'The master was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6275, '', 7, '', 'GRIMMESTEIN', 'Jan Berger', 759, NULL, '1696', NULL, NULL, 'A', 'A', '1712-11-26', 'Batavia', '1713-02-12', '1713-04-10', true, '1713-08-19', 'Texel', 2141, NULL);
INSERT INTO "voyages" VALUES (6276, '', 1, '', 'KOCKENGEN', 'Hayman de Laver', 824, NULL, '1711', NULL, NULL, 'A', 'A', '1712-11-26', 'Batavia', '1713-02-12', '1713-04-10', true, '1713-08-19', 'Texel', 2150, NULL);
INSERT INTO "voyages" VALUES (6277, '', 2, '', 'KORSSLOOT', 'Stoffel Hansz. Boom', 630, 'fluit', '1705', NULL, NULL, 'H', 'E', '1712-11-26', 'Batavia', '1713-02-12', '1713-04-10', true, '1713-08-18', 'Texel', 2155, NULL);
INSERT INTO "voyages" VALUES (6278, '', 1, '', 'LEIDSMAN', 'Arie van der Linden', 320, 'fregat', '1710', NULL, NULL, 'A', 'E', '1712-11-26', 'Batavia', '1713-02-12', '1713-04-10', true, '1713-08-09', 'Texel', 2125, NULL);
INSERT INTO "voyages" VALUES (6279, '', 2, '', 'STANDVASTIGHEID', 'Kornelis Goudswaard', 888, NULL, '1706', NULL, NULL, 'A', 'R', '1712-11-26', 'Batavia', '1713-02-12', '1713-04-10', true, '1713-08-22', 'Goeree', 2154, NULL);
INSERT INTO "voyages" VALUES (6280, '', 2, '', 'ZANDENBURG', 'Adriaan Timmerman', 1136, NULL, '1706', NULL, NULL, 'Z', 'Z', '1712-11-26', 'Batavia', '1713-02-12', '1713-04-10', true, '1713-08-22', 'Rammekens', 2145, 'Aboard the ZANDENBURG was Johannes van Steeland, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6281, '', 1, '', 'OUDE ZIJPE', 'Klaas de Vries', 600, 'fluit', '1711', NULL, NULL, 'H', 'H', '1712-11-26', 'Batavia', '1713-02-12', '1713-04-10', true, '1713-08-19', 'Texel', 2156, NULL);
INSERT INTO "voyages" VALUES (6282, '', 2, '', 'BENTVELD', 'Kornelis Dobbel', 938, NULL, '1708', NULL, NULL, 'A', 'A', '1712-12-22', 'Ceylon', '1713-02-28', '1713-04-10', true, '1713-08-22', 'Texel', 2158, NULL);
INSERT INTO "voyages" VALUES (6283, '', 1, '', 'RAADHUIS VAN ENKHUIZEN', 'Simon Rijksen', 578, 'fluit', '1709', NULL, NULL, 'E', 'A', '1712-12-22', 'Ceylon', '1713-03-25', '1713-04-10', true, '1713-08-18', 'Texel', 2112, NULL);
INSERT INTO "voyages" VALUES (6284, '', 1, '', 'RIJNESTEIN', 'Lambert Bot', 608, 'fluit', '1709', NULL, NULL, 'A', 'Z', '1712-12-22', 'Ceylon', '1713-02-17', '1713-04-10', true, '1713-08-22', NULL, 2113, NULL);
INSERT INTO "voyages" VALUES (6285, '', 2, '', 'VADERLAND GETROUW', 'Adriaan de Jager', 848, NULL, '1705', NULL, NULL, 'Z', 'Z', '1712-12-22', 'Ceylon', '1713-02-28', '1713-04-10', true, '1713-08-22', NULL, 2139, NULL);
INSERT INTO "voyages" VALUES (6286, '', 1, '', 'OUDENAARDE', 'Daniel van Krijnen', 858, NULL, '1708', NULL, NULL, 'A', 'H', '1713-01-16', 'Batavia', '1713-04-06', '1713-04-10', true, '1713-08-19', 'Texel', 2093, NULL);
INSERT INTO "voyages" VALUES (6287, '', 4, '', 'WESTHOVEN', 'Kornelis Hoek', 776, NULL, '1698', NULL, NULL, 'Z', 'Z', '1713-01-16', 'Batavia', '1713-04-06', '1713-04-10', true, '1713-08-22', 'Rammekens', 2119, NULL);
INSERT INTO "voyages" VALUES (6288, '', 1, '', 'WIJNENDAAL', 'Jan Kole', 804, 'jacht', '1709', NULL, NULL, 'D', 'A', '1713-02-14', 'Batavia', '1713-04-19', '1713-04-29', true, '1713-08-14', 'Texel', 2110, NULL);
INSERT INTO "voyages" VALUES (6289, '', 2, '', 'ARENDSDUIN', 'Arie Zomer', 580, 'jacht', '1708', NULL, NULL, 'D', 'Z', '1713-11-25', 'Ceylon', '1714-03-15', '1714-04-10', true, '1714-08-01', 'Rammekens', 216, NULL);
INSERT INTO "voyages" VALUES (6290, '', 4, '', 'ABBEKERK', 'Jakob Hoek', 242, 'fluit', '1698', NULL, NULL, 'H', 'H', '1713-11-28', 'Batavia', '1714-03-05', '1714-04-10', true, '1714-07-30', 'Texel', 2082, 'Commandeur of the return fleet was Anthonie Valkenier aboard the SAMSON (6300); Arie Turfkloot, master of the HOEDE-KENSKERKE (6295), was vice-commandeur; schout-bij-nacht was Klaas van Noort aboard the GAMRON (6294).');
INSERT INTO "voyages" VALUES (6291, '', 2, '', 'AMAZONS', 'Pieter Prop', 590, 'fluit', '1707', NULL, NULL, 'A', 'A', '1713-11-28', 'Batavia', '1714-02-05', '1714-04-10', true, '1714-07-30', 'Texel', 2176, NULL);
INSERT INTO "voyages" VALUES (6292, '', 2, '', 'BRUG', 'Klaas Zwaan', 600, 'fluit', '1708', NULL, NULL, 'E', 'E', '1713-11-28', 'Batavia', '1714-02-05', '1714-04-10', true, '1714-07-30', 'Texel', 2130, NULL);
INSERT INTO "voyages" VALUES (6293, '', 3, '', 'ENGEWORMER', 'Jakob Regenboog', 560, 'fluit', '1707', NULL, NULL, 'H', 'R', '1713-11-28', 'Batavia', '1714-02-01', '1714-04-10', true, '1714-08-01', 'Goeree', 2183, NULL);
INSERT INTO "voyages" VALUES (6294, '', 3, '', 'GAMRON', 'Wessel Hoogwerf', 848, NULL, '1706', NULL, NULL, 'A', 'D', '1713-11-28', 'Batavia', '1714-02-05', '1714-04-10', true, '1714-07-31', 'Goeree', 2180, 'Aboard the GAMRON was schout-bij-nacht Klaas van Noort.');
INSERT INTO "voyages" VALUES (6295, '', 4, '', 'HOEDEKENSKERKE', 'Arie Turfkloot', 830, NULL, '1704', NULL, NULL, 'Z', 'Z', '1713-11-28', 'Batavia', '1714-02-05', '1714-04-10', true, '1714-08-18', 'Rammekens', 2128, 'The master was vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6296, '', 2, '', 'MOSSEL', 'Jan Wijnands', 676, 'fluit', '1706', NULL, NULL, 'E', 'E', '1713-11-28', 'Batavia', '1714-02-02', '1714-04-10', true, '1714-07-30', 'Texel', 2152, NULL);
INSERT INTO "voyages" VALUES (6297, '', 2, '', 'NOORDERKWARTIER', 'Boudewijn Overmeer', 550, 'fluit', '1709', NULL, NULL, 'H', 'A', '1713-11-28', 'Batavia', '1714-01-31', '1714-04-10', true, '1714-07-30', 'Texel', 2177, NULL);
INSERT INTO "voyages" VALUES (6298, '', 2, '', 'OUWERKERK', 'Pieter Jansz. Bruin', 658, 'fluit', '1706', NULL, NULL, 'A', 'A', '1713-11-28', 'Batavia', '1714-02-05', '1714-04-10', true, '1714-07-30', 'Texel', 2140, NULL);
INSERT INTO "voyages" VALUES (6299, '', 1, '', 'RIJSSEL', 'Frederik van Eik', 858, NULL, '1709', NULL, NULL, 'Z', 'Z', '1713-11-28', 'Batavia', '1714-02-05', '1714-04-10', true, '1714-08-01', 'Rammekens', 2118, NULL);
INSERT INTO "voyages" VALUES (6300, '', 2, '', 'SAMSON', 'Pieter Kornelisz. Koster', 800, NULL, '1707', NULL, NULL, 'A', 'A', '1713-11-28', 'Batavia', '1714-03-05', '1714-04-10', true, '1714-07-30', 'Texel', 2181, 'SAMSON was Anthonie Valkenier, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6301, '', 5, '', 'DEN BERG', 'Jan Kopersluis', 836, NULL, '1701', NULL, NULL, 'A', 'A', '1713-12-25', 'Ceylon', '1714-03-20', '1714-04-10', true, '1714-07-30', 'Texel', 2179, NULL);
INSERT INTO "voyages" VALUES (6302, '', 3, '', 'BEVERWAART', 'Pieter Ruts', 760, NULL, '1702', NULL, NULL, 'A', 'A', '1713-12-25', 'Ceylon', '1714-03-16', '1714-04-10', true, '1714-07-30', 'Texel', 2046, NULL);
INSERT INTO "voyages" VALUES (6303, '', 2, '', 'HUIS TER BOEDE', 'Vlierden', 642, NULL, '1702', NULL, NULL, 'Z', 'A', '1713-12-25', 'Ceylon', '1714-03-16', '1714-04-10', true, '1714-07-30', 'Texel', 2080, NULL);
INSERT INTO "voyages" VALUES (6304, '', 2, '', 'DUIVENVOORDE', 'Jan Sluis', 620, 'fluit', '1705', NULL, NULL, 'R', 'Z', '1713-12-25', 'Ceylon', '1714-03-16', '1714-04-10', true, '1714-08-01', 'Rammekens', 2101, NULL);
INSERT INTO "voyages" VALUES (6305, '', 2, '', 'ELLEMEET', 'Michiel Landsheer', 670, NULL, '1699', NULL, NULL, 'Z', 'Z', '1713-12-25', 'Ceylon', '1714-03-17', '1714-04-10', true, '1714-08-01', 'Rammekens', 2083, NULL);
INSERT INTO "voyages" VALUES (6306, '', 2, '', 'MUNDEN', 'Tobias Uilenberg', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1713-12-25', 'Batavia', '1714-04-03', '1714-04-23', true, '1714-08-28', 'Texel', 2159, NULL);
INSERT INTO "voyages" VALUES (6307, '', 1, '', 'NEDERHOVEN', 'Jakob Stokvis', 600, 'fluit', '1708', NULL, NULL, 'R', 'D', '1714-01-13', 'Batavia', '1714-03-23', '1714-04-10', true, '1714-08-01', 'Goeree', 2075, NULL);
INSERT INTO "voyages" VALUES (6308, '', 6, '', 'VRIJBURG', 'Kornelis de Geus', 784, NULL, '1695', NULL, NULL, 'Z', 'A', '1714-01-13', 'Batavia', '1714-03-24', '1714-04-10', true, '1714-07-30', 'Texel', 2144, NULL);
INSERT INTO "voyages" VALUES (6309, '', 2, '', 'VOORBURG', 'Jan Lette', 600, NULL, '1710', NULL, NULL, 'D', 'A', '1714-03-01', 'Batavia', '1714-05-13', '1714-06-10', true, '1714-09-13', 'Texel', 2194, NULL);
INSERT INTO "voyages" VALUES (6310, '', 4, '', 'BARNEVELD', 'Simon van Hoom', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1714-11-16', 'Batavia', '1715-02-26', '1715-04-05', true, '1715-08-06', 'Texel', 2213, 'Commandeur of the return fleet was Kornelis de Vlaming, master of the BERBICES (6313); Daniel Keskes, master of the HERSTELDE LEEUW (6321), was vice-commandeer; schout-bij-nacht was Kornelis Goudswaard, master of the HOR-STENDAAL (6320).');
INSERT INTO "voyages" VALUES (6311, '', 3, '', 'KORSSLOOT', 'Kornelis Dobbel', 630, 'fluit', '1705', NULL, NULL, 'H', 'E', '1714-11-16', 'Batavia', '1715-02-11', '1715-04-05', true, '1715-08-06', 'Texel', 2207, NULL);
INSERT INTO "voyages" VALUES (6312, '', 6, '', 'GENERALE VREDE', 'Willem de Leus', 1008, 'pinas', '1699', NULL, NULL, 'A', 'A', '1714-11-16', 'Batavia', '1715-02-26', '1715-04-05', true, '1715-08-06', 'Texel', 2195, NULL);
INSERT INTO "voyages" VALUES (6313, '', 2, '', 'BERBICES', 'Kornelis de Vlarning', 1136, NULL, '1709', NULL, NULL, 'Z', 'A', '1714-11-26', 'Batavia', '1715-02-26', '1715-04-05', true, '1715-08-06', 'Texel', 2182, 'The master was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6314, '', 4, '', 'BEVERWIJK', 'Jan van Hessel', 836, NULL, '1700', NULL, NULL, 'A', 'H', '1714-11-26', 'Batavia', '1715-02-26', '1715-04-05', true, '1715-08-06', 'Vlie', 2173, NULL);
INSERT INTO "voyages" VALUES (6315, '', 1, '', 'DOORNIK', 'Hidding Idesz. Nooy', 830, NULL, '1709', NULL, NULL, 'A', 'A', '1714-11-26', 'Batavia', '1715-02-26', '1715-04-05', true, '1715-08-06', 'Texel', 2123, NULL);
INSERT INTO "voyages" VALUES (6316, '', 2, '', 'RAADHUIS VAN ENKHUIZEN', 'Jan Gerritsz. Moes', 578, 'fluit', '1709', NULL, NULL, 'E', 'E', '1714-11-26', 'Batavia', '1715-02-26', '1715-04-05', true, '1715-08-06', 'Texel', 2216, NULL);
INSERT INTO "voyages" VALUES (6317, '', 8, '', 'GRIMMESTEIN', 'Michiel Rozenkrans', 759, NULL, '1696', NULL, NULL, 'A', 'A', '1714-11-26', 'Batavia', '1715-02-26', '1715-04-05', true, '1715-08-06', 'Texel', 2214, NULL);
INSERT INTO "voyages" VALUES (6318, '', 5, '', 'HUIS TE HEMERT', 'Herman Grinder', 612, 'fluit', '1701', NULL, NULL, 'A', 'H', '1714-11-26', 'Batavia', '1715-02-26', '1715-04-05', true, '1715-08-06', 'Texel', 2167, NULL);
INSERT INTO "voyages" VALUES (6319, '', 1, '', 'TER HORST', 'Aarnoud van Kleef', 520, 'fluit', '1712', NULL, NULL, 'D', 'R', '1714-11-26', 'Batavia', '1715-02-26', '1715-04-05', true, '1715-08-06', 'Goeree', 2205, NULL);
INSERT INTO "voyages" VALUES (6320, '', 6, '', 'HORSTENDAAL', 'Kornelis Goudswaard', 688, 'pinas', '1699', NULL, NULL, 'A', 'D', '1714-11-26', 'Batavia', '1715-02-25', '1715-04-05', true, '1715-08-06', 'Goeree', 2143, 'The master was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6321, '', 2, '', 'HERSTELDE LEEUW', 'Daniel Keskes', 1138, NULL, '1704', NULL, NULL, 'Z', 'Z', '1714-11-26', 'Batavia', '1715-02-26', '1715-04-05', true, '1715-08-06', 'Rammekens', 2184, 'The master was vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6322, '', 3, '', 'POPKENSBURG', 'Wouter Thomasz. van Dijk', 804, NULL, '1699', NULL, NULL, 'Z', 'A', '1714-11-26', 'Batavia', '1715-02-26', '1715-04-05', true, '1715-08-06', 'Texel', 2163, NULL);
INSERT INTO "voyages" VALUES (6323, '', 2, '', 'RIJNESTEIN', 'Batten Leesten', 608, 'fluit', '1709', NULL, NULL, 'A', 'R', '1714-11-26', 'Batavia', '1715-02-26', '1715-04-05', true, '1715-08-06', 'Goeree', 2210, NULL);
INSERT INTO "voyages" VALUES (6324, '', 1, '', 'SCHOTEROOG', 'Jan Koster', 360, 'fregat', '1712', NULL, NULL, 'A', 'D', '1714-11-26', 'Batavia', '1715-02-26', '1715-04-05', true, '1715-08-06', 'Goeree', 2175, NULL);
INSERT INTO "voyages" VALUES (6325, '', 5, '', 'WESTHOVEN', 'Pieter Buis', 776, NULL, '1698', NULL, NULL, 'Z', 'Z', '1714-11-26', 'Batavia', '1715-02-26', '1715-04-05', true, '1715-08-06', 'Rammekens', 2215, NULL);
INSERT INTO "voyages" VALUES (6326, '', 3, '', 'ZANDENBURG', 'Jakob Koole', 1136, NULL, '1706', NULL, NULL, 'Z', 'Z', '1714-11-26', 'Batavia', '1715-02-25', '1715-04-05', true, '1715-08-06', 'Rammekens', 2211, NULL);
INSERT INTO "voyages" VALUES (6327, '', 3, '', 'BENTVELD', 'Lambert Bot', 938, NULL, 'I708', NULL, NULL, 'A', 'A', '1714-12-21', 'Ceylon', '1715-03-06', '1715-04-05', true, '1715-08-06', 'Texel', 2208, NULL);
INSERT INTO "voyages" VALUES (6328, '', 3, '', 'LIMBURG', 'Mattheus Burger', 810, NULL, 'I704', NULL, NULL, 'A', 'Z', '1714-12-21', 'Ceylon', '1715-03-08', '1715-04-05', true, '1715-08-06', 'Rammekens', 2169, NULL);
INSERT INTO "voyages" VALUES (6329, '', 2, '', 'LOKHORST', 'Jan Vorster', 6, 'fluit', '1702', NULL, NULL, 'E', 'Z', '1714-12-21', 'Ceylon', '1715-03-05', '1715-04-05', true, '1715-08-09', 'Rammekens', 2087, NULL);
INSERT INTO "voyages" VALUES (6330, '', 2, '', 'NOORBEEK', 'Jan Melcherse', 858, NULL, 'I707', NULL, NULL, 'Z', 'A', '1714-12-21', 'Ceylon', '1715-03-08', '1715-04-05', true, '1715-08-06', 'Texel', 2160, 'According to N.A. 1902, XXVI, 94 the value of the cargo was 295,773.');
INSERT INTO "voyages" VALUES (6331, '', 4, '', 'SCHELLENBERG', 'Frans de Brooi', 630, 'fluit', '1705', NULL, NULL, 'A', 'Z', '1714-12-21', 'Ceylon', '1715-03-06', '1715-04-05', true, '1715-08-06', 'Rammekens', 2185, NULL);
INSERT INTO "voyages" VALUES (6332, '', 3, '', 'WASSENAAR', 'Jakob Verduin', 804, NULL, '1704', NULL, NULL, 'D', 'A', '1714-12-21', 'Ceylon', '1715-03-08', '1715-04-05', true, '1715-08-06', 'Texel', 2172, NULL);
INSERT INTO "voyages" VALUES (6333, '', 1, '', 'ZUIDERBEEK', 'Reinier Hijpe', 8, NULL, '1711', NULL, NULL, 'Z', 'A', '1714-12-21', 'Ceylon', '1715-03-05', '1715-04-05', true, '1715-08-06', 'Texel', 2164, NULL);
INSERT INTO "voyages" VALUES (6334, '', 2, '', 'HARINGTUIN', 'Hero Dol', 6, 'fluit', '1705', NULL, NULL, 'E', 'E', '1715-01-16', 'Batavia', '1715-04-12', '1715-05-24', true, '1715-10-19', NULL, 2189, NULL);
INSERT INTO "voyages" VALUES (6335, '', 3, '', 'WATERINGEN', 'Hugo van der Slikke', 626, 'jacht', '1701', NULL, NULL, 'D', 'A', '1715-01-16', 'Batavia', '1715-04-14', '1715-05-24', true, '1715-09-07', 'Texel', 2116, NULL);
INSERT INTO "voyages" VALUES (6336, '', 3, '', 'SCHONEWAL', 'Adriaan Tessing', 632, 'jacht', 'I703', NULL, NULL, 'Z', 'A', '1715-02-20', 'Batavia', '1715-04-30', '1715-05-24', true, '1715-09-07', NULL, 2196, NULL);
INSERT INTO "voyages" VALUES (6337, '', 4, '', 'GANSENHOEF', 'Rijkmanus ten Bem', 640, 'fluit', 'I702', NULL, NULL, 'A', 'A', '1715-09-15', 'Batavia', '1715-11-22', '1716-01-05', true, '1716-05-11', 'Texel', 2202, NULL);
INSERT INTO "voyages" VALUES (6338, '', 2, '', 'HUIS TER LEEDE', 'Jan de Hei', 300, NULL, '1710', NULL, NULL, 'A', 'Z', '1715-09-15', 'Batavia', '1715-11-21', '1717-01-05', true, '1716-05-15', 'Rammekens', 2168, NULL);
INSERT INTO "voyages" VALUES (6339, '', 3, '', 'BELVLIET', 'Jakob Lijnsen', 586, 'fluit', '1704', NULL, NULL, 'E', 'Z', '1715-09-18', 'Ceylon', '1716-03-02', '1716-04-01', true, '1716-07-11', 'Rammekens', 2146, 'Commandeur of the return fleet was Abraham Douglas; vice-commandeur Marinus Duvelaar; schout-bij-nacht Aarnoud Bitter.');
INSERT INTO "voyages" VALUES (6340, '', 3, '', 'BRUG', 'Jan Visser', 600, 'fluit', '1708', NULL, NULL, 'E', 'E', '1715-10-30', 'Batavia', '1716-01-11', '1716-04-01', true, '1716-07-08', 'Texel', 2232, NULL);
INSERT INTO "voyages" VALUES (6341, '', 1, '', 'CHARLOIS', 'Hendrik Lont', 632, 'fluit', '1709', NULL, NULL, 'R', 'R', '1715-10-30', 'Batavia', '1716-01-24', '1716-04-01', true, '1716-07-08', 'Goeree', 2127, NULL);
INSERT INTO "voyages" VALUES (6342, '', 2, '', 'KIJKUIT', 'Pieter de Boer', 200, 'fregat', '1706', NULL, NULL, 'A', 'A', '1715-10-30', 'Batavia', '1716-01-10', '1716-04-01', true, '1716-07-08', 'Texel', 2191, NULL);
INSERT INTO "voyages" VALUES (6343, '', 1, '', 'LINSCHOTEN', 'Pieter Prop', 804, NULL, '1714', NULL, NULL, 'A', 'A', '1715-10-30', 'Batavia', '1716-01-11', '1716-04-01', true, '1716-07-08', 'Texel', 2224, NULL);
INSERT INTO "voyages" VALUES (6344, '', 1, '', 'MEIJENBURG', 'Jan Akkerman', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1715-10-30', 'Batavia', '1716-01-10', '1717-04-01', true, '1716-07-11', 'Rammekens', 2227, NULL);
INSERT INTO "voyages" VALUES (6345, '', 3, '', 'MUNDEN', 'Wessel Hoogwerf', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1715-10-30', 'Batavia', '1716-01-11', '1716-04-01', true, '1716-07-08', 'Texel', 2234, NULL);
INSERT INTO "voyages" VALUES (6346, '', 3, '', 'NOORDERKWARTIER', 'Jochem Pijselman', 550, 'fluit', '1709', NULL, NULL, 'H', 'H', '1715-10-30', 'Batavia', '1716-01-11', '1716-04-01', true, '1716-07-08', 'Texel', 2235, NULL);
INSERT INTO "voyages" VALUES (6347, '', 2, '', 'RIJSSEL', 'Michiel Landsheer', 858, NULL, '1709', NULL, NULL, 'Z', 'Z', '1715-10-30', 'Batavia', '1716-01-11', '1716-04-01', true, '1716-07-12', 'Rammekens', 2240, NULL);
INSERT INTO "voyages" VALUES (6348, '', 3, '', 'VOORBURG', 'Jan Kopersluis', 600, NULL, '1710', NULL, NULL, 'D', 'D', '1715-10-30', 'Batavia', '1716-01-11', '1716-04-01', true, '1716-07-08', 'Goeree', 2238, NULL);
INSERT INTO "voyages" VALUES (6349, '', 1, '', 'WESTERDIJKSHORN', 'Jan Berger', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1715-10-30', 'Batavia', '1716-01-11', '1716-04-01', true, '1716-07-08', 'Texel', 2225, NULL);
INSERT INTO "voyages" VALUES (6350, '', 4, '', 'ENGEWORMER', 'Gerrit Moring', 560, 'fluit', '1707', NULL, NULL, 'H', 'H', '1715-11-28', 'Batavia', '1716-03-11', '1716-04-01', true, '1716-07-08', 'Texel', 2228, NULL);
INSERT INTO "voyages" VALUES (6351, '', 3, '', 'PRINS EUGENIUS', 'Christiaan Emmerij', 874, NULL, '1703', NULL, NULL, 'A', 'A', '1715-11-28', 'Batavia', '1716-03-14', '1716-04-01', true, '1716-07-08', 'Texel', 2190, NULL);
INSERT INTO "voyages" VALUES (6352, '', 3, '', 'NEPTUNUS', 'Andries Pijl', 858, NULL, '1704', NULL, NULL, 'A', 'R', '1715-11-28', 'Batavia', '1716-03-19', '1716-04-01', true, '1716-07-08', 'Goeree', 2188, NULL);
INSERT INTO "voyages" VALUES (6353, '', 3, '', 'OUWERKERK', 'Gerrit Staal', 658, 'fluit', '1706', NULL, NULL, 'A', 'E', '1715-11-28', 'Batavia', '1716-03-16', '1716-04-01', true, '1716-07-08', 'Texel', 2236, NULL);
INSERT INTO "voyages" VALUES (6354, '', 3, '', 'SAMSON', 'Francois de Roos', 800, NULL, '1707', NULL, NULL, 'A', 'D', '1715-11-28', 'Batavia', '1716-03-19', '1716-04-01', true, '1716-07-08', 'Texel', 2237, NULL);
INSERT INTO "voyages" VALUES (6355, '', 3, '', 'STANDVASTIGHEID', 'Lukas Schrik', 888, NULL, '1706', NULL, NULL, 'A', 'A', '1715-11-28', 'Batavia', '1716-03-19', '1716-04-01', true, '1716-07-08', 'Texel', 2220, NULL);
INSERT INTO "voyages" VALUES (6356, '', 3, '', 'VADERLAND GETROUW', 'Jakob de Laver', 848, NULL, '1705', NULL, NULL, 'Z', 'Z', '1715-11-28', 'Batavia', '1716-03-15', '1716-04-01', true, '1716-07-11', 'Rammekens', 2218, NULL);
INSERT INTO "voyages" VALUES (6357, '', 1, '', 'HUIS TEN DONK', 'Jan van Diemen', 650, NULL, '1711', NULL, NULL, 'R', 'A', '1715-12-18', 'Ceylon', '1716-03-02', '1716-04-01', true, '1716-07-08', 'Texel', 2171, NULL);
INSERT INTO "voyages" VALUES (6358, '', 1, '', 'LOOSDRECHT', 'Boudewijn Overmeer', 805, NULL, '1714', NULL, NULL, 'A', 'A', '1715-12-18', 'Ceylon', '1716-03-02', '1716-04-01', true, '1716-07-08', 'Texel', 2233, NULL);
INSERT INTO "voyages" VALUES (6359, '', 2, '', 'RAADHUIS VAN MIDDELBURG', 'Nikolaas Boom', 890, NULL, '1708', NULL, NULL, 'Z', 'A', '1715-12-18', 'Ceylon', '1716-03-02', '1716-04-01', true, '1716-07-11', 'Rammekens', 2170, NULL);
INSERT INTO "voyages" VALUES (6360, '', 2, '', 'OUDENAARDE', 'Jan Jurriaansz. Ben', 858, NULL, '1708', NULL, NULL, 'A', 'A', '1715-12-18', 'Ceylon', '1716-03-02', '1716-04-01', true, '1716-07-08', 'Texel', 2222, NULL);
INSERT INTO "voyages" VALUES (6361, '', 4, '', 'WAARDE', 'Jan Tessing', 830, NULL, '1702', NULL, NULL, 'Z', 'A', '1715-12-18', 'Ceylon', '1716-03-02', '1716-04-01', true, '1716-07-11', 'Texel', 2197, NULL);
INSERT INTO "voyages" VALUES (6362, '', 5, '', 'DIEMEN', 'Anthonie van Doom', 596, 'fluit', '1700', NULL, NULL, 'A', 'Z', '1716-01-28', 'Batavia', '1716-03-27', '1716-04-01', true, '1716-07-11', 'Rammekens', 2199, NULL);
INSERT INTO "voyages" VALUES (6363, '', 1, '', 'ZANDERHOEF', 'Geerlof Bontekoe', 608, 'fluit', '1711', NULL, NULL, 'A', 'A', '1716-01-30', 'Batavia', '1716-03-26', '1716-04-01', true, '1716-07-11', 'Texel', 2161, NULL);
INSERT INTO "voyages" VALUES (6364, '', 2, '', 'WIJNENDAAL', 'Jan Baai', 804, 'jacht', '1709', NULL, NULL, 'D', 'A', '1716-02-20', 'Batavia', '1716-05-14', '1716-05-26', true, '1716-09-14', 'Vlie', 2204, NULL);
INSERT INTO "voyages" VALUES (6365, '', 1, '', 'GROENSWAART', 'Jakob Bogaard', 600, 'fluit', '1714', NULL, NULL, 'R', 'R', '1716-09-20', 'Batavia', '1716-11-26', '1716-12-25', true, '1712-04-05', 'Goeree', 2255, NULL);
INSERT INTO "voyages" VALUES (6366, '', 5, '', 'ABBEKERK', 'Pieter Jakob Rus', 600, 'fluit', '1698', NULL, NULL, 'H', 'H', '1716-11-01', 'Batavia', '1717-03-14', '1717-04-13', true, '1717-07-31', 'Texel', 2251, 'Hoom (6375), schout-bij-nacht Charles Duurkoop (6382).');
INSERT INTO "voyages" VALUES (6367, '', 3, '', 'ARENDSDUIN', 'Philip van den Broek', 580, 'jacht', '1708', NULL, NULL, 'D', 'D', '1716-11-01', 'Batavia', '1717-03-09', '1717-04-13', true, '1717-07-30', 'Goeree', 2231, NULL);
INSERT INTO "voyages" VALUES (6368, '', 1, '', 'ELISABETH', 'Geus', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1716-11-01', 'Batavia', '1717-03-09', '1717-04-13', true, '1717-08-01', 'Texel', 2257, NULL);
INSERT INTO "voyages" VALUES (6369, '', 4, '', 'KONING KAREL DE DERDE', 'David Brouwer', 830, NULL, '1704', NULL, NULL, 'A', 'A', '1716-11-01', 'Batavia', '1717-03-09', '1717-04-13', true, '1717-07-31', 'Texel', 2187, NULL);
INSERT INTO "voyages" VALUES (6370, '', 4, '', 'KIEFHOEK', 'Stokman', 832, NULL, '1701', NULL, NULL, 'R', 'R', '1716-11-01', 'Batavia', '1717-03-09', '1717-04-13', true, '1717-07-30', 'Goeree', 2206, NULL);
INSERT INTO "voyages" VALUES (6371, '', 3, '', 'MOSSEL', 'Hendrik Jansz. Prins', 676, 'fluit', '1706', NULL, NULL, 'E', 'E', '1716-11-01', 'Batavia', '1717-03-03', '1717-04-13', true, '1717-07-30', 'Texel', 2249, NULL);
INSERT INTO "voyages" VALUES (6372, '', 1, '', 'NESSERAK', 'Francois Zegers', 804, NULL, '1712', NULL, NULL, 'A', 'A', '1716-11-01', 'Batavia', '1717-03-09', '1717-04-13', true, '1717-07-31', 'Texel', 2193, NULL);
INSERT INTO "voyages" VALUES (6373, '', 1, '', 'SLEEWIJK', 'Gerrit Schot', 520, 'jacht', '1713', NULL, NULL, 'R', 'R', '1716-11-01', 'Batavia', '1717-03-09', '1717-04-13', true, '1717-07-30', 'Goeree', 2221, NULL);
INSERT INTO "voyages" VALUES (6374, '', 1, '', 'D''UNO', 'Willem Dekker', 250, 'fregat', '1707', NULL, NULL, 'Z', 'A', '1716-11-01', 'Batavia', '1717-03-07', '1717-04-13', true, '1717-07-30', 'Texel', 2201, NULL);
INSERT INTO "voyages" VALUES (6375, '', 2, '', 'ZUIDERBEEK', 'Jan Linthout', 812, NULL, '1711', NULL, NULL, 'Z', 'Z', '1716-11-01', 'Batavia', '1717-03-09', '1717-04-13', true, '1717-07-31', 'Rammekens', 2256, NULL);
INSERT INTO "voyages" VALUES (6376, '', 5, '', 'BARNEVELD', 'Hendrik Schalkenius', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1716-12-01', 'Batavia', '1717-03-09', '1717-04-13', true, '1717-08-01', 'Texel', 2267, NULL);
INSERT INTO "voyages" VALUES (6377, '', 3, '', 'BERBICUS', 'Herman Schut', 1136, NULL, '1709', NULL, NULL, 'Z', 'Z', '1716-12-01', 'Batavia', '1717-03-09', '1717-04-13', true, '1717-07-31', 'Rammekens', 2260, NULL);
INSERT INTO "voyages" VALUES (6378, '', 6, '', 'DEN BERG', 'Jakob Onkruid', 836, NULL, '1701', NULL, NULL, 'A', 'H', '1716-12-01', 'Batavia', '1717-03-09', '1717-04-13', true, '1717-07-31', 'Texel', 2243, NULL);
INSERT INTO "voyages" VALUES (6379, '', 3, '', 'DUIVENVOORDE', 'Frederik van Eik', 620, 'fluit', '1705', NULL, NULL, 'R', 'E', '1716-12-01', 'Batavia', '1717-03-21', '1717-04-13', true, '1717-07-30', 'Texel', 2241, NULL);
INSERT INTO "voyages" VALUES (6380, '', 1, '', 'RAADHUIS VAN VLISSINGEN', 'Hendrik Fret', 600, 'fluit', '1714', NULL, NULL, 'Z', 'Z', '1716-12-01', 'Batavia', '1717-03-09', '1717-04-13', true, '1717-07-31', 'Rammekens', 2264, NULL);
INSERT INTO "voyages" VALUES (6381, '', 7, '', 'GENERALE VREDE', 'Willem de Leus', 1008, 'pinas', '1699', NULL, NULL, 'A', 'A', '1716-12-01', 'Batavia', '1717-03-09', '1717-04-13', true, '1717-08-01', 'Texel', 2270, NULL);
INSERT INTO "voyages" VALUES (6382, '', 6, '', 'WESTHOVEN', 'Charles Duurkoop', 776, NULL, '1698', NULL, NULL, 'Z', 'D', '1716-12-01', 'Batavia', '1717-03-09', '1717-04-13', true, '1717-07-30', 'Goeree', 2265, NULL);
INSERT INTO "voyages" VALUES (6383, '', 4, '', 'ZANDENBURG', 'Jan Wijdeman', 1136, NULL, '1706', NULL, NULL, 'Z', 'Z', '1716-12-01', 'Batavia', '1717-03-05', '1717-04-13', true, '1717-07-31', 'Rammekens', 2266, NULL);
INSERT INTO "voyages" VALUES (6384, '', 1, '', 'BOEKENRODE', 'Lambert Bot', 890, NULL, '1714', NULL, NULL, 'A', 'A', '1716-12-12', 'Ceylon', '1717-02-15', '1717-04-13', true, '1717-07-31', 'Texel', 2268, NULL);
INSERT INTO "voyages" VALUES (6385, '', 3, '', '''T GHIJN', 'Pieter de Vlaming', 810, NULL, '1701', NULL, NULL, 'A', 'A', '1716-12-12', 'Ceylon', '1717-03-13', '1717-04-13', true, '1717-08-01', 'Texel', 2091, NULL);
INSERT INTO "voyages" VALUES (6386, '', 2, '', 'KOCKENGEN', 'Wouter Reiniersz.', 824, NULL, '1711', NULL, NULL, 'A', 'Z', '1716-12-12', 'Ceylon', '1717-03-22', '1717-04-13', true, '1717-07-31', 'Rammekens', 2203, NULL);
INSERT INTO "voyages" VALUES (6387, '', 1, '', 'MIDDELWOUD', 'Jan de Heere', 804, NULL, '1713', NULL, NULL, 'Z', 'A', '1716-12-12', 'Ceylon', '1717-03-13', '1717-04-13', true, '1717-07-31', 'Texel', 2200, NULL);
INSERT INTO "voyages" VALUES (6388, '', 1, '', 'STRIJKEBOLLE', 'Abraham Ram', 540, 'fluit', '1712', NULL, NULL, 'E', 'Z', '1716-12-12', 'Ceylon', '1717-03-09', '1717-04-13', true, '1717-07-31', 'Rammekens', 2198, NULL);
INSERT INTO "voyages" VALUES (6389, '', 2, '', 'OUDE ZIJPE', 'Gerrit Verburg', 600, 'fluit', '1711', NULL, NULL, 'H', 'A', '1716-12-12', 'Ceylon', NULL, NULL, true, NULL, NULL, 2212, 'Wrecked at Mauritius');
INSERT INTO "voyages" VALUES (6390, '', 1, '', 'RISDAM', 'Jakobus Verkade', 520, 'fluit', '1713', NULL, NULL, 'H', 'E', '1717-01-16', 'Batavia', '1717-03-28', '1717-04-13', true, '1717-07-30', 'Texel', 2223, NULL);
INSERT INTO "voyages" VALUES (6391, '', 1, '', 'HUIS DE VLOTTER', 'Daniel Dirksz. Bent', 528, 'fluit', '1713', NULL, NULL, 'A', 'H', '1717-01-16', 'Batavia', '1717-03-30', '1717-04-13', true, '1717-07-31', 'Texel', 2217, NULL);
INSERT INTO "voyages" VALUES (6392, '', 1, '', 'MEERHUIZEN', 'Wouter van Dijk', 600, 'fluit', '1714', NULL, NULL, 'A', 'A', '1717-03-24', 'Batavia', '1717-06-17', '1717-07-12', true, '1717-11-10', 'Texel', 2277, NULL);
INSERT INTO "voyages" VALUES (6393, '', 1, '', 'WITSBURG', 'Frank Versijde', 520, 'fluit', '1714', NULL, NULL, 'E', 'A', '1717-03-24', 'Batavia', '1717-06-17', '1717-07-12', true, '1717-11-09', 'Texel', 2239, NULL);
INSERT INTO "voyages" VALUES (6394, '', 4, '', 'BENTVELD', 'Matthijs Want', 938, NULL, '1708', NULL, NULL, 'A', 'A', '1717-11-15', 'Ceylon', '1718-02-14', '1718-04-07', true, '1718-07-17', 'Texel', 2254, NULL);
INSERT INTO "voyages" VALUES (6395, '', 1, '', 'SPIERING', 'Jan Huigen van Breen', 810, NULL, '1714', NULL, NULL, 'D', 'A', '1717-11-15', 'Ceylon', '1718-02-06', '1718-04-07', true, '1718-07-17', 'Texel', 2252, 'Commandeur of this return fleet was Hayman de Laver on the WESTERDIJKSHORN (6408).');
INSERT INTO "voyages" VALUES (6396, '', 1, '', 'CATS', 'Hugo van der Slikke', 580, NULL, '1716', NULL, NULL, 'Z', 'Z', '1717-12-01', 'Batavia', '1718-02-22', '1718-04-07', true, '1718-07-18', 'Rammekens', 2301, NULL);
INSERT INTO "voyages" VALUES (6397, '', 3, '', 'HERSTELDE LEEUW', 'Jakob Delincourt', 1138, NULL, '1704', NULL, NULL, 'Z', 'Z', '1717-12-01', 'Batavia', '1718-02-22', '1718-04-07', true, '1718-07-18', 'Rammekens', 2273, NULL);
INSERT INTO "voyages" VALUES (6398, '', 2, '', 'MEIJENBURG', 'Pieter van Dalen', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1717-12-01', 'Batavia', '1718-02-22', '1718-04-07', true, '1718-07-19', 'Rammekens', 2299, NULL);
INSERT INTO "voyages" VALUES (6399, '', 2, '', 'NEDERHOVEN', 'Jakob van der Poel', 600, 'fluit', '1708', NULL, NULL, 'R', 'R', '1717-12-01', 'Batavia', '1718-02-23', '1718-04-07', true, '1718-07-17', 'Goeree', 2230, NULL);
INSERT INTO "voyages" VALUES (6400, '', 1, '', 'RIJKSDORP', 'Jan Klaasz. Kluit', 792, NULL, '1713', NULL, NULL, 'A', 'H', '1717-12-01', 'Batavia', '1718-02-22', '1718-04-07', true, '1718-07-17', 'Texel', 2209, NULL);
INSERT INTO "voyages" VALUES (6401, '', 3, '', 'RIJSSEL', 'Jan Baai', 858, NULL, '1709', NULL, NULL, 'Z', 'E', '1717-12-01', 'Batavia', '1718-02-22', '1718-04-07', true, '1718-07-17', 'Texel', 2300, NULL);
INSERT INTO "voyages" VALUES (6402, '', 1, '', 'ROTTERDAM', 'Hendrik Lont', 800, NULL, '1716', NULL, NULL, 'R', 'D', '1717-12-01', 'Batavia', '1718-02-22', '1718-04-07', true, '1718-07-17', 'Goeree', 2292, NULL);
INSERT INTO "voyages" VALUES (6403, '', 2, '', 'HUIS TEN DONK', 'Nikolaas Boom', 650, NULL, '1711', NULL, NULL, 'R', 'A', '1717-12-11', 'Batavia', '1718-02-22', '1718-04-07', true, '1718-07-17', 'Texel', 2294, NULL);
INSERT INTO "voyages" VALUES (6404, '', 1, '', 'HOGERMEER', 'Jan Klooster', 470, 'fluit', '1716', NULL, NULL, 'A', 'A', '1717-12-11', 'Batavia', '1718-02-22', '1718-04-07', true, '1718-07-17', 'Texel', 2288, NULL);
INSERT INTO "voyages" VALUES (6405, '', 2, '', 'LEIDSMAN', 'Frans de Brooi', 320, 'fregat', '1710', NULL, NULL, 'A', 'A', '1717-12-11', 'Batavia', '1718-02-22', '1718-04-07', true, '1718-07-17', 'Texel', 2229, NULL);
INSERT INTO "voyages" VALUES (6406, '', 4, '', 'MUNDEN', 'Wessel Hoogwerf', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1717-12-11', 'Batavia', '1718-02-22', '1718-04-07', true, '1718-07-17', 'Texel', 2296, NULL);
INSERT INTO "voyages" VALUES (6407, '', 4, '', 'VOORBURG', 'Gerrit Bokshoorn', 600, NULL, '1710', NULL, NULL, 'D', 'A', '1717-12-11', 'Batavia', '1718-02-22', '1718-04-07', true, '1718-07-17', 'Texel', 2293, NULL);
INSERT INTO "voyages" VALUES (6408, '', 2, '', 'WESTERDUKSHORN', 'Hayman de Laver', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1717-12-11', 'Batavia', '1718-02-22', '1718-04-07', true, '1718-07-17', 'Texel', 2297, NULL);
INSERT INTO "voyages" VALUES (6409, '', 1, '', 'SLOT ALDEGONDE', 'Jakob de Vries', 1160, 'jacht', '1714', NULL, NULL, 'Z', 'Z', '1717-12-21', 'Ceylon', '1718-03-07', '1718-04-07', true, '1718-07-18', 'Rammekens', 2246, NULL);
INSERT INTO "voyages" VALUES (6410, '', 3, '', 'AMAZONE', 'van Hessel', 590, 'fluit', '1707', NULL, NULL, 'A', 'A', '1717-12-21', 'Ceylon', '1718-03-07', '1718-04-07', true, '1718-07-17', 'Texel', 2226, NULL);
INSERT INTO "voyages" VALUES (6411, '', 3, '', 'DONAU', 'Pieter Slijper', 794, NULL, '1705', NULL, NULL, 'Z', 'A', '1717-12-21', 'Ceylon', '1718-03-07', '1718-04-07', true, '1718-07-17', 'Texel', 2219, NULL);
INSERT INTO "voyages" VALUES (6412, '', 5, '', 'GANSENHOEF', 'Theunis de Haan', 640, 'fluit', '1702', NULL, NULL, 'A', 'A', '1717-12-21', 'Ceylon', '1718-03-07', '1718-04-07', true, '1718-07-17', 'Texel', 2285, NULL);
INSERT INTO "voyages" VALUES (6413, '', 2, '', 'LOOSDRECHT', 'Gillis de Graaf', 805, NULL, '1714', NULL, NULL, 'A', 'A', '1717-12-21', 'Ceylon', '1718-03-05', '1718-04-07', true, '1718-07-17', 'Texel', 2295, NULL);
INSERT INTO "voyages" VALUES (6414, '', 4, '', 'WASSENAAR', 'Andries Pijl', 804, NULL, '1704', NULL, NULL, 'D', 'Z', '1717-12-21', 'Ceylon', '1718-03-07', '1718-04-07', true, '1718-07-18', 'Rammekens', 2287, NULL);
INSERT INTO "voyages" VALUES (6415, '', 1, '', 'LUCHTENBURG', 'Gerbrand Mamus', 800, NULL, '1715', NULL, NULL, 'H', 'R', '1718-01-16', 'Batavia', '1718-04-13', NULL, true, '1718-08-09', 'Goeree', 2275, NULL);
INSERT INTO "voyages" VALUES (6416, '', 3, '', 'NOORDBEEK', 'Jan Koster', 858, NULL, '1707', NULL, NULL, 'Z', 'A', '1718-01-16', 'Batavia', '1718-04-09', NULL, true, '1718-08-06', 'Vlie', 2280, NULL);
INSERT INTO "voyages" VALUES (6417, '', 3, '', 'RAADHUIS VAN ENKHUIZEN', 'Simon Rijksen', 578, 'fluit', '1709', NULL, NULL, 'E', 'A', '1718-03-20', 'Batavia', '1718-06-09', NULL, true, '1718-11-10', 'Goeree', 2262, NULL);
INSERT INTO "voyages" VALUES (6418, '', 4, '', 'VADERLAND GETROUW', 'Aarnoud van Kleef', 848, NULL, '1705', NULL, NULL, 'Z', 'D', '1718-11-25', 'Batavia', '1719-03-16', '1719-04-02', true, '1719-08-08', 'Goeree', 2305, 'Commandeur of this return fleet was Gerrit van der Zijde (6421); Aarnoud van Kleef was schout-bij-nacht.');
INSERT INTO "voyages" VALUES (6419, '', 4, '', 'BERBICUS', 'Hijpe', 1136, NULL, '1709', NULL, NULL, 'Z', 'Z', '1718-11-28', 'Batavia', '1719-02-09', '1719-04-02', true, '1719-08-10', 'Rammekens', 2336, NULL);
INSERT INTO "voyages" VALUES (6420, '', 3, '', 'HUIS TER BOEDE', 'Isaak de Winter', 642, 'jacht', '1702', NULL, NULL, 'Z', 'H', '1718-11-28', 'Batavia', '1719-02-09', '1719-04-02', true, '1719-08-07', 'Texel', 2248, NULL);
INSERT INTO "voyages" VALUES (6421, '', 2, '', 'BOEKENRODE', 'Jan Vorster', 890, NULL, '1714', NULL, NULL, 'A', 'A', '1718-11-28', 'Batavia', '1719-02-09', '1719-04-02', true, '1719-08-07', 'Texel', 2321, NULL);
INSERT INTO "voyages" VALUES (6422, '', 2, '', 'ELISABETH', 'Jakob Onkruid', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1718-11-28', 'Batavia', '1719-02-09', '1719-04-02', true, '1719-08-07', 'Texel', 2331, NULL);
INSERT INTO "voyages" VALUES (6423, '', 3, '', 'HARINGTUIN', 'David Brouwer', 618, 'fluit', '1705', NULL, NULL, 'E', 'E', '1718-11-28', 'Batavia', '1719-02-09', '1719-04-02', true, '1719-08-07', 'Texel', 2281, NULL);
INSERT INTO "voyages" VALUES (6424, '', 3, '', 'RAADHUIS VAN MIDDELBURG', 'Pieter Buis', 890, NULL, '1708', NULL, NULL, 'Z', 'Z', '1718-11-28', 'Batavia', '1719-02-09', '1719-04-02', true, '1719-08-10', 'Rammekens', 2302, NULL);
INSERT INTO "voyages" VALUES (6425, '', 1, '', 'PRATTENBURG', 'Kornelis Dobbel', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1718-11-28', 'Batavia', '1719-02-14', '1719-04-02', true, '1719-08-07', 'Texel', 2310, NULL);
INSERT INTO "voyages" VALUES (6426, '', 5, '', 'SCHELLENBERG', 'Bartholomeus van de Kapelle', 630, 'fluit', '1705', NULL, NULL, 'A', 'A', '1718-11-28', 'Batavia', '1719-02-09', '1719-04-02', true, '1719-08-07', 'Texel', 2258, NULL);
INSERT INTO "voyages" VALUES (6427, '', 4, '', 'STANDVASTIGHEID', 'Gerrit Moring', 888, NULL, '1706', NULL, NULL, 'A', 'A', '1718-11-28', 'Batavia', '1719-02-09', '1719-04-02', true, '1719-08-07', 'Texel', 2324, NULL);
INSERT INTO "voyages" VALUES (6428, '', 1, '', 'BORSSELE', 'Louis Schulerius', 800, NULL, '1715', NULL, NULL, 'Z', 'A', '1718-12-02', 'Ceylon', '1719-02-18', '1719-04-02', true, '1719-08-07', 'Texel', 2283, NULL);
INSERT INTO "voyages" VALUES (6429, '', 2, '', 'LINSCHOTEN', 'Pieter Knollendam', 804, NULL, '1714', NULL, NULL, 'A', 'A', '1718-12-02', 'Ceylon', '1719-02-18', '1719-04-02', true, '1719-08-07', 'Texel', 2286, NULL);
INSERT INTO "voyages" VALUES (6430, '', 2, '', 'TER HORST', 'Jakob Brouwer', 520, 'fluit', '1713', NULL, NULL, 'D', 'D', '1718-12-07', 'Batavia', '1719-02-14', '1719-04-02', true, '1719-08-08', 'Goeree', 2263, NULL);
INSERT INTO "voyages" VALUES (6431, '', 3, '', 'KOCKENGEN', 'Albert van Petten', 824, NULL, '1711', NULL, NULL, 'A', 'A', '1718-12-07', 'Batavia', '1719-02-13', '1719-04-02', true, '1719-08-07', 'Texel', 2338, NULL);
INSERT INTO "voyages" VALUES (6432, '', 3, '', 'OUDENAARDE', 'Geerlof Bontekoe', 858, NULL, '1708', NULL, NULL, 'A', 'R', '1718-12-07', 'Batavia', '1719-02-14', '1719-04-02', true, '1719-08-07', 'Goeree', 2316, NULL);
INSERT INTO "voyages" VALUES (6433, '', 1, '', 'VALKENISSE', 'Herman Grindet', 1150, NULL, '1716', NULL, NULL, 'Z', 'Z', '1718-12-07', 'Batavia', '1719-02-16', '1719-04-02', true, '1719-08-10', 'Rammekens', 2325, NULL);
INSERT INTO "voyages" VALUES (6434, '', 2, '', 'HUIS DE VLOTTER', 'Daniel van Staden', 528, 'fluit', '1713', NULL, NULL, 'A', 'E', '1718-12-07', 'Batavia', '1719-02-16', '1719-04-02', true, '1719-08-07', 'Texel', 2334, NULL);
INSERT INTO "voyages" VALUES (6435, '', 2, '', 'DOORNIK', 'Siewert Pool', 830, NULL, '1709', NULL, NULL, 'A', 'A', '1718-12-25', 'Ceylon', '1719-02-16', '1719-04-02', true, '1719-08-07', 'Texel', 2269, NULL);
INSERT INTO "voyages" VALUES (6436, '', 5, '', 'HOEDEKENSKERK', 'Michiel Ruis', 830, NULL, '1704', NULL, NULL, 'Z', 'Z', '1718-12-25', 'Ceylon', '1719-03-16', '1719-04-02', true, '1719-08-10', 'Rammekens', 2250, NULL);
INSERT INTO "voyages" VALUES (6437, '', 2, '', 'MIDDELWOUD', 'Willem de Leus', 804, NULL, '1713', NULL, NULL, 'Z', 'A', '1718-12-25', 'Ceylon', '1719-03-16', '1719-04-02', true, '1719-08-07', 'Texel', 2332, NULL);
INSERT INTO "voyages" VALUES (6438, '', 4, '', 'OUWERKERK', 'Jakob Visser', 658, 'fluit', '1706', NULL, NULL, 'A', 'A', '1718-12-25', 'Ceylon', '1719-03-16', '1719-04-02', true, '1719-08-07', 'Texel', 2309, NULL);
INSERT INTO "voyages" VALUES (6439, '', 3, '', 'RIJNESTEIN', 'Hendrik de Vries', 608, 'fluit', '1709', NULL, NULL, 'A', 'Z', '1718-12-25', 'Ceylon', '1719-03-16', '1719-04-02', true, '1719-08-10', 'Rammekens', 2272, NULL);
INSERT INTO "voyages" VALUES (6440, '', 2, '', 'GROENSWAART', 'Klaas van Eik', 600, 'fluit', '1714', NULL, NULL, 'R', 'R', '1719-01-15', 'Batavia', '1719-03-24', '1719-04-02', true, '1719-08-08', 'Goeree', 2327, NULL);
INSERT INTO "voyages" VALUES (6441, '', 1, '', 'JOHANNA', 'Abraham Ram', 550, 'fluit', '1714', NULL, NULL, 'A', 'A', '1719-01-15', 'Batavia', '1719-03-24', '1719-04-02', true, '1719-08-07', 'Texel', 2306, NULL);
INSERT INTO "voyages" VALUES (6442, '', 5, '', 'KIEFHOEK', 'Jakob Bogaard', 832, NULL, '1701', NULL, NULL, 'R', 'R', '1719-01-15', 'Batavia', '1719-03-24', '1719-04-02', true, '1719-08-08', 'Goeree', 2339, NULL);
INSERT INTO "voyages" VALUES (6443, '', 2, '', 'MEERHUIZEN', 'Thieleman Sterling', 600, 'fluit', '1714', NULL, NULL, 'A', 'A', '1719-01-15', 'Batavia', '1719-03-24', '1719-04-02', true, '1719-08-07', 'Texel', 2348, NULL);
INSERT INTO "voyages" VALUES (6444, '', 1, '', 'TER NISSE', 'Gerrit Stokke', 810, NULL, '1714', NULL, NULL, 'Z', 'A', '1719-01-15', 'Batavia', '1719-03-24', '1719-04-02', true, '1719-08-07', 'Texel', 2253, NULL);
INSERT INTO "voyages" VALUES (6445, '', 4, '', 'NOORDERKWARTIER', 'Arend Dirksz. Bent', 550, 'fluit', '1709', NULL, NULL, 'H', 'H', '1719-01-15', 'Batavia', '1719-03-24', '1719-04-02', true, '1719-08-07', 'Texel', 2308, NULL);
INSERT INTO "voyages" VALUES (6446, '', 2, '', 'SCHOTEROOG', 'Abraham van der Ceel', 360, 'fregat', '1712', NULL, NULL, 'A', 'A', '1719-01-15', 'Batavia', '1719-03-24', '1719-04-02', true, '1719-08-07', 'Texel', 2259, NULL);
INSERT INTO "voyages" VALUES (6447, '', 3, '', 'WIJNENDAAL', 'Jan Laurens de Hoge', 804, 'jacht', '1709', NULL, NULL, 'D', 'A', '1719-03-29', 'Batavia', '1719-07-08', '1719-08-09', true, '1719-11-02', 'Texel', 2317, NULL);
INSERT INTO "voyages" VALUES (6448, '', 1, '', 'AMSTERDAM', 'Dirk Renvoort', 800, NULL, '1716', NULL, NULL, 'A', 'A', '1719-11-21', 'Ceylon', '1720-02-20', '1720-04-19', true, '1720-08-06', 'Texel', 2318, NULL);
INSERT INTO "voyages" VALUES (6449, '', 2, '', 'CHARLOIS', 'Arend Redog', 632, 'fluit', '1709', NULL, NULL, 'R', 'A', '1719-11-21', 'Ceylon', '1720-02-18', '1720-04-19', true, '1720-08-08', 'Texel', 2303, NULL);
INSERT INTO "voyages" VALUES (6450, '', 1, '', 'MARGARETA', 'Pieter Scherf', 600, 'fluit', '1715', NULL, NULL, 'E', 'A', '1719-11-21', 'Ceylon', '1720-02-17', '1720-04-19', true, '1720-08-05', 'Texel', 2276, NULL);
INSERT INTO "voyages" VALUES (6451, '', 4, '', 'SAMSON', 'Jan Kopersluis', 800, NULL, '1707', NULL, NULL, 'A', 'Z', '1719-11-21', 'Ceylon', '1720-02-17', '1720-04-19', true, '1720-08-06', 'Rammekens', 2304, NULL);
INSERT INTO "voyages" VALUES (6452, '', 2, '', 'STRUKEBOLLE', 'Jakob Blauw', 540, 'fluit', '1712', NULL, NULL, 'E', 'A', '1719-11-21', 'Ceylon', '1720-02-18', '1720-04-19', true, '1720-08-05', 'Texel', 2347, NULL);
INSERT INTO "voyages" VALUES (6453, '', 1, '', 'VRIESWIJK', 'Jan Baaiken', 850, NULL, '1716', NULL, NULL, 'H', 'A', '1719-11-21', 'Ceylon', '1720-02-18', '1720-04-19', true, '1720-08-06', 'Texel', 2312, NULL);
INSERT INTO "voyages" VALUES (6454, '', 1, '', 'AMSTELVEEN', 'Theunis de Haan', 1150, NULL, '1717', NULL, NULL, 'A', 'A', '1719-12-01', 'Batavia', '1720-02-25', '1720-04-19', true, '1720-08-06', 'Texel', 2355, NULL);
INSERT INTO "voyages" VALUES (6455, '', 4, '', 'ARENDSDUIN', 'Theunis van der Storm', 580, 'jacht', '1708', NULL, NULL, 'D', 'E', '1719-12-01', 'Batavia', '1720-02-25', '1720-04-19', true, '1720-08-05', 'Texel', 2343, NULL);
INSERT INTO "voyages" VALUES (6456, '', 1, '', 'BARBESTEIN', 'Andries Pijl', 1100, NULL, '1717', NULL, NULL, 'Z', 'D', '1719-12-01', 'Batavia', '1720-02-18', '1720-04-19', true, '1720-08-06', 'Goeree', 2361, NULL);
INSERT INTO "voyages" VALUES (6457, '', 6, '', 'GANSENHOEF', 'Jakob van Luipen', 640, 'fluit', '1702', NULL, NULL, 'A', 'H', '1719-12-01', 'Batavia', '1720-02-18', '1720-04-19', true, '1720-08-05', 'Texel', 2356, NULL);
INSERT INTO "voyages" VALUES (6458, '', 1, '', 'HOPVOGEL', 'Albert van Soest', 600, 'fluit', '1714', NULL, NULL, 'A', 'A', '1719-12-01', 'Batavia', '1720-03-05', '1720-04-19', true, '1720-08-05', 'Texel', 2274, NULL);
INSERT INTO "voyages" VALUES (6459, '', 5, '', 'KONING KAREL DE DERDE', 'Wouter van Dijk', 830, NULL, '1704', NULL, NULL, 'A', 'A', '1719-12-01', 'Batavia', '1720-03-19', '1720-04-19', true, '1720-08-02', 'Texel', 2351, NULL);
INSERT INTO "voyages" VALUES (6460, '', 3, '', 'MEIJENBURG', 'Michiel Landsheer', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1719-12-01', 'Batavia', '1720-02-18', '1720-04-19', true, '1720-08-06', 'Rammekens', 2363, 'The master was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6461, '', 4, '', 'NEPTUNUS', 'Jan Ringelenberg', 858, NULL, '1704', NULL, NULL, 'A', 'D', '1719-12-01', 'Batavia', '1720-02-25', '1720-04-19', true, '1720-08-06', 'Goeree', 2314, NULL);
INSERT INTO "voyages" VALUES (6462, '', 2, '', 'D''UNO', 'Kornelis Haringkarspel', 250, 'fregat', '1707', NULL, NULL, 'Z', 'Z', '1719-12-01', 'Batavia', '1720-03-01', '1720-04-19', true, '1720-08-06', 'Rammekens', 2352, NULL);
INSERT INTO "voyages" VALUES (6463, '', 5, '', 'WASSENAAR', 'Jakob Kooimans', 804, NULL, '1704', NULL, NULL, 'D', 'H', '1719-12-01', 'Batavia', '1720-03-01', '1720-04-19', true, '1720-08-05', 'Texel', 2375, NULL);
INSERT INTO "voyages" VALUES (6464, '', 1, '', 'WENDELA', 'Herman Branus', 600, NULL, '1716', NULL, NULL, 'A', 'E', '1719-12-01', 'Batavia', '1720-03-01', '1720-04-19', true, '1720-08-05', 'Texel', 2320, NULL);
INSERT INTO "voyages" VALUES (6465, '', 3, '', 'WESTERDIJKSHORN', 'Matthijs Want', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1719-12-01', 'Batavia', '1720-02-25', '1720-04-19', true, '1720-08-06', 'Texel', 2370, NULL);
INSERT INTO "voyages" VALUES (6466, '', 5, '', 'ZANDENBURG', 'Gerrit Staal', 1136, NULL, '1706', NULL, NULL, 'Z', 'Z', '1719-12-01', 'Batavia', '1720-02-18', '1720-04-19', true, '1720-08-06', 'Rammekens', 2353, NULL);
INSERT INTO "voyages" VALUES (6467, '', 1, '', 'DEN DAM', 'Jan Verschouw', 600, 'fluit', '1716', NULL, NULL, 'D', 'E', '1720-01-17', 'Batavia', '1720-04-04', '1720-04-19', true, '1720-08-05', 'Texel', 2322, NULL);
INSERT INTO "voyages" VALUES (6468, '', 1, '', 'HOGENES', 'Jakob de Marre', 870, NULL, '1716', NULL, NULL, 'Z', 'A', '1720-01-17', 'Batavia', '1720-04-26', '1720-05-29', true, '1720-09-27', 'Texel', 2337, NULL);
INSERT INTO "voyages" VALUES (6469, '', 4, '', 'NOORDBEEK', 'Adriaan van Dorp', 858, NULL, '1707', NULL, NULL, 'Z', 'A', '1720-01-17', 'Batavia', '1720-05-06', '1720-05-29', true, '1720-09-27', 'Texel', 2373, NULL);
INSERT INTO "voyages" VALUES (6470, '', 1, '', 'OPPERDOES', 'Jan Ravenek', 600, 'fluit', '1718', NULL, NULL, 'H', 'H', '1720-01-17', 'Batavia', '1720-05-14', '1720-05-29', true, '1720-09-27', 'Texel', 2383, NULL);
INSERT INTO "voyages" VALUES (6471, '', 2, '', 'SPIERING', 'Dirk Haan', 810, NULL, '1714', NULL, NULL, 'D', 'D', '1720-01-17', 'Batavia', '1720-04-26', '1720-05-29', true, '1720-09-23', 'Goeree', 2369, NULL);
INSERT INTO "voyages" VALUES (6472, '', 2, '', 'RAADHUIS VAN VLISSINGEN', 'Kornelis Centsen', 600, 'fluit', '1714', NULL, NULL, 'Z', 'Z', '1720-01-17', 'Batavia', '1720-05-06', '1720-05-29', true, '1720-09-24', 'Rammekens', 2326, NULL);
INSERT INTO "voyages" VALUES (6473, '', 1, '', 'VIS', 'Tijmen Zwaag', 600, 'fluit', '1716', NULL, NULL, 'E', 'A', '1720-03-26', 'Batavia', '1720-06-15', '1720-07-06', true, '1720-10-12', 'Texel', 2311, NULL);
INSERT INTO "voyages" VALUES (6474, '', 3, '', 'GROENSWAART', 'Jan Kroon', 600, 'fluit', '1714', NULL, NULL, 'R', 'R', '1720-10-30', 'Batavia', '1721-01-11', '1721-02-05', true, '1721-06-03', 'Texel', 2399, 'Loten (6500), vice-commandeur Adriaan Bogaard (6487), and schout-bij-nacht Pieter van Dalen (6494).');
INSERT INTO "voyages" VALUES (6475, '', 2, '', 'JOHANNA', 'Abraham Uithof', 550, 'fluit', '1714', NULL, NULL, 'A', 'A', '1720-10-30', 'Batavia', '1721-01-10', '1721-02-05', true, '1721-06-04', 'Texel', 2402, NULL);
INSERT INTO "voyages" VALUES (6476, '', 1, '', 'LAKENMAN', 'Stoffel Hansz. Boom', 600, 'fluit', '1718', NULL, NULL, 'E', 'E', '1720-10-30', 'Batavia', '1721-01-11', '1721-02-05', true, '1721-06-04', 'Texel', 2388, NULL);
INSERT INTO "voyages" VALUES (6477, '', 1, '', 'LOENDERVEEN', 'Jan van der Heiden', 650, 'fluit', '1718', NULL, NULL, 'A', 'A', '1720-10-30', 'Batavia', '1721-01-11', '1721-02-05', true, '1721-06-03', 'Texel', 2386, NULL);
INSERT INTO "voyages" VALUES (6478, '', 1, '', 'SAMARITAAN', 'Hendrik van der Grippe', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1720-10-30', 'Batavia', '1721-01-11', '1721-02-05', true, '1721-06-04', 'Rammekens', 2396, NULL);
INSERT INTO "voyages" VALUES (6479, '', 1, '', 'ZOETIGHEID', 'Abraham van der Ceel', 600, 'fluit', '1718', NULL, NULL, 'D', 'D', '1720-10-30', 'Batavia', '1721-01-11', '1721-02-05', true, '1721-06-03', 'Texel', 2390, NULL);
INSERT INTO "voyages" VALUES (6480, '', 3, '', 'HUIS TEN DONK', 'Hendrik Schoon', 650, NULL, '1711', NULL, NULL, 'R', 'A', '1720-11-22', 'Ceylon', '1721-02-08', '1721-04-23', true, '1721-08-21', 'Texel', 2371, NULL);
INSERT INTO "voyages" VALUES (6481, '', 4, '', 'HERSTELDE LEEUW', 'Jan de Heere', 1138, NULL, '1704', NULL, NULL, 'Z', 'Z', '1720-11-22', 'Ceylon', '1721-02-15', '1721-04-23', true, '1721-08-22', 'Rammekens', 2377, NULL);
INSERT INTO "voyages" VALUES (6482, '', 2, '', 'LUCHTENBURG', 'Bartholomeus Mastrigt', 800, NULL, '1715', NULL, NULL, 'H', 'A', '1720-11-22', 'Ceylon', '1721-02-08', '1721-04-23', true, '1721-08-21', 'Texel', 2358, NULL);
INSERT INTO "voyages" VALUES (6483, '', 4, '', 'RIJSSEL', 'Jan de Rode', 858, NULL, '1709', NULL, NULL, 'Z', 'A', '1720-11-22', 'Ceylon', '1721-02-08', '1721-04-23', true, '1721-08-21', 'Texel', 2368, NULL);
INSERT INTO "voyages" VALUES (6484, '', 2, '', 'ROTTERDAM', 'Jakob van der Poel', 800, NULL, '1716', NULL, NULL, 'R', 'Z', '1720-11-22', 'Ceylon', '1721-02-09', '1721-04-23', true, '1721-08-22', 'Rammekens', 2359, NULL);
INSERT INTO "voyages" VALUES (6485, '', 1, '', 'SCHONENBERG', 'Jakob Thoorn', 800, NULL, '1717', NULL, NULL, 'A', 'A', '1720-11-22', 'Ceylon', '1721-02-08', '1721-04-23', true, '1721-08-21', 'Texel', 2374, NULL);
INSERT INTO "voyages" VALUES (6486, '', 2, '', 'SLOT ALDEGONDE', 'Jan Havelaar', 1160, 'jacht', '1714', NULL, NULL, 'Z', 'Z', '1720-12-01', 'Ceylon', '1721-02-08', '1721-04-23', true, '1721-08-22', 'Rammekens', 2360, NULL);
INSERT INTO "voyages" VALUES (6487, '', 6, '', 'BARNEVELD', 'Adriaan Bogaard', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1720-12-01', 'Batavia', '1721-02-08', '1721-04-23', true, '1721-08-21', 'Texel', 2365, NULL);
INSERT INTO "voyages" VALUES (6488, '', 3, '', 'ELISABETH', 'Gerrit Moring', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1720-12-01', 'Batavia', '1721-02-21', '1721-04-23', true, '1721-08-21', 'Texel', 2410, NULL);
INSERT INTO "voyages" VALUES (6489, '', 4, '', 'RAADHUIS VAN ENKHUIZEN', 'Tijmen Potter', 578, 'fluit', '1709', NULL, NULL, 'E', 'E', '1720-12-01', 'Batavia', '1721-02-21', '1721-04-23', true, '1721-08-19', 'Texel', 2398, NULL);
INSERT INTO "voyages" VALUES (6490, '', 3, '', 'TER HORST', 'Jan van den Tempel', 520, 'fluit', '1713', NULL, NULL, 'D', 'R', '1720-12-01', 'Batavia', '1721-02-21', '1721-04-23', true, '1721-08-21', 'Goeree', 2406, NULL);
INSERT INTO "voyages" VALUES (6491, '', 1, '', 'STAD LEIDEN', 'Jakob Korijn', 1140, NULL, '1718', NULL, NULL, 'A', 'A', '1720-12-01', 'Batavia', '1721-02-23', '1721-04-23', true, '1721-08-21', 'Texel', 2389, NULL);
INSERT INTO "voyages" VALUES (6492, '', 1, '', 'SCHOTSE LORRENDRAAIER', 'Nikolaas van Leeuwen', NULL, 'fregat', NULL, NULL, NULL, NULL, 'Z', '1720-12-01', 'Batavia', '1721-02-22', '1721-04-23', true, '1721-08-21', 'Rammekens', NULL, 'According to K.A. 1823 this ship was the English frigate BRIT-TANIA GALLEY, taken in Asia.');
INSERT INTO "voyages" VALUES (6493, '', 5, '', 'MUNDEN', 'Gerbrand Mamus', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1720-12-01', 'Batavia', '1721-02-21', '1721-04-23', true, '1721-08-21', 'Texel', 2387, NULL);
INSERT INTO "voyages" VALUES (6494, '', 2, '', 'NESSERAK', 'Pieter van Dalen', 804, NULL, '1712', NULL, NULL, 'A', 'D', '1720-12-01', 'Batavia', '1721-02-22', '1721-04-23', true, '1721-08-21', 'Goeree', 2323, NULL);
INSERT INTO "voyages" VALUES (6495, '', 2, '', 'PRATTENBURG', 'Balthus van Santen', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1720-12-01', 'Batavia', '1721-02-21', '1721-04-23', true, '1721-08-21', 'Texel', 2394, NULL);
INSERT INTO "voyages" VALUES (6496, '', 2, '', 'RIJKSDORP', 'Krijnsen', 792, NULL, '1713', NULL, NULL, 'A', 'H', '1720-12-01', 'Batavia', '1721-02-27', '1721-04-23', true, '1721-08-19', 'Texel', 2367, NULL);
INSERT INTO "voyages" VALUES (6497, '', 2, '', 'SLEEWIJK', 'Gerrit Schot', 520, 'jacht', '1713', NULL, NULL, 'R', 'R', '1720-12-01', 'Batavia', '1721-02-27', '1721-04-23', true, '1721-08-21', 'Goeree', 2328, NULL);
INSERT INTO "voyages" VALUES (6498, '', 5, '', 'STANDVASTIGHEID', 'Matthijs Ruger', 888, NULL, '1706', NULL, NULL, 'A', 'Z', '1720-12-01', 'Batavia', '1721-02-27', '1721-04-23', true, '1721-08-22', 'Rammekens', 2404, NULL);
INSERT INTO "voyages" VALUES (6499, '', 1, '', 'STEENHOVEN', 'Jan Linthout', 850, NULL, '1718', NULL, NULL, 'Z', 'Z', '1720-12-01', 'Batavia', '1721-02-23', '1721-04-23', true, '1721-08-22', 'Rammekens', 2397, NULL);
INSERT INTO "voyages" VALUES (6500, '', 2, '', 'VALKENISSE', 'Lukas Schrik', 1150, NULL, '1716', NULL, NULL, 'Z', 'Z', '1720-12-01', 'Batavia', '1721-02-27', '1721-04-23', true, '1721-08-22', 'Rammekens', 2408, NULL);
INSERT INTO "voyages" VALUES (6501, '', 1, '', 'STADHUIS VAN DELFT', 'Michiel van Pavie', 600, NULL, '1718', NULL, NULL, 'D', 'H', '1721-01-16', 'Batavia', '1721-04-19', '1721-05-03', true, '1721-09-14', 'Texel', 2376, NULL);
INSERT INTO "voyages" VALUES (6502, '', 3, '', 'MEERHUIZEN', 'Gideon Kuiper', 600, 'fluit', '1714', NULL, NULL, 'A', 'A', '1721-01-16', 'Batavia', '1721-04-17', '1721-05-23', true, '1721-09-15', 'Texel', 2403, NULL);
INSERT INTO "voyages" VALUES (6503, '', 3, '', 'HUIS DE VLOTTER', 'Jan Pietersz. Keizer', 528, 'fluit', '1713', NULL, NULL, 'A', 'E', '1721-01-16', 'Batavia', '1721-04-19', '1721-05-03', true, '1721-09-14', 'Texel', 2405, NULL);
INSERT INTO "voyages" VALUES (6504, '', 1, '', 'KOMMERRUST', 'Koenraad Mels', 810, NULL, '1718', NULL, NULL, 'A', 'A', '1721-02-08', 'Batavia', '1721-04-12', '1721-04-23', true, '1721-08-21', 'Texel', 2385, NULL);
INSERT INTO "voyages" VALUES (6505, '', 3, '', 'MIDDELWOUD', 'Klaas Zwaan', 804, NULL, '1713', NULL, NULL, 'Z', 'Z', '1721-02-08', 'Batavia', '1721-04-19', '1721-05-03', true, '1721-09-17', 'Goeree', 2421, NULL);
INSERT INTO "voyages" VALUES (6506, '', 1, '', 'NOORDWADDINXVEEN', 'Hendrik Lont', 850, NULL, '1718', NULL, NULL, 'R', 'R', '1721-02-08', 'Batavia', '1721-04-19', '1721-05-03', true, '1721-09-21', 'Goeree', 2379, NULL);
INSERT INTO "voyages" VALUES (6507, '', 1, '', 'HAAKSBURG', 'Pieter Visser', 600, NULL, '1718', NULL, NULL, 'E', 'A', '1721-04-01', 'Batavia', '1721-07-22', '1721-08-01', true, '1721-10-28', 'Texel', 2381, NULL);
INSERT INTO "voyages" VALUES (6508, '', 1, '', 'BLEIJENBURG', 'Jan Lindeboom', 1100, NULL, '1719', NULL, NULL, 'A', 'A', '1721-09-22', 'Batavia', NULL, NULL, true, NULL, NULL, 2429, 'Wrecked in 1722 between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (6509, '', 1, '', 'MAGDALENA', 'Isaak de Winter', 600, NULL, '1719', NULL, NULL, 'H', 'Z', '1721-09-22', 'Batavia', '1721-11-21', '1722-01-13', true, '1722-04-29', 'Rammekens', 2416, NULL);
INSERT INTO "voyages" VALUES (6510, '', 4, '', 'RAADHUIS VAN MIDDELBURG', 'Jakob Delincourt', 890, NULL, '1708', NULL, NULL, 'Z', 'Z', '1721-09-22', 'Batavia', NULL, NULL, true, NULL, NULL, 2418, 'According to N.A. 1901 XXVI. 94 the cargo was 357,691. Wrecked in 1722 near Mauritius.');
INSERT INTO "voyages" VALUES (6511, '', 1, '', 'PURMERLUST', 'Kornelis Dam', 580, NULL, '1718', NULL, NULL, 'A', 'A', '1721-09-22', 'Batavia', '1721-11-21', '1722-01-13', true, '1722-04-29', 'Texel', 2395, NULL);
INSERT INTO "voyages" VALUES (6512, '', 4, '', 'RIJNESTEIN', 'Pieter Bitter', 608, 'fluit', '1709', NULL, NULL, 'A', 'A', '1721-09-22', 'Batavia', NULL, NULL, true, NULL, NULL, 2407, 'near Mauritius.');
INSERT INTO "voyages" VALUES (6513, '', 5, '', 'SAMSON', 'Kornelis van Reet', 800, NULL, '1707', NULL, NULL, 'A', 'Z', '1721-11-30', 'Batavia', NULL, NULL, true, NULL, NULL, 2440, 'Wrecked on 08-01-1722 at 26''15''S.');
INSERT INTO "voyages" VALUES (6514, '', 1, '', 'HUIS TE ASSENBURG', 'Jan Reebok', 800, NULL, '1718', NULL, NULL, 'A', 'A', '1721-11-22', 'Ceylon', '1722-02-14', '1722-04-10', true, '1722-08-05', 'Texel', 2392, NULL);
INSERT INTO "voyages" VALUES (6515, '', 5, '', 'BERRICUS', 'Frank Versijde', 1136, NULL, '1709', NULL, NULL, 'Z', 'A', '1721-11-22', 'Ceylon', '1722-02-14', '1722-04-10', true, '1722-08-05', 'Texel', 2417, NULL);
INSERT INTO "voyages" VALUES (6516, '', 2, '', 'BORSSELE', 'Leendert Ole', 800, NULL, '1715', NULL, NULL, 'Z', 'Z', '1721-11-22', 'Ceylon', '1722-02-14', '1722-04-10', true, '1722-08-08', 'Rammekens', 2401, NULL);
INSERT INTO "voyages" VALUES (6517, '', 6, '', 'HOEDEKENSKERKE', 'Hendrik Fret', 830, NULL, '1704', NULL, NULL, 'Z', 'Z', '1721-11-22', 'Ceylon', '1722-02-14', '1722-04-10', true, '1722-08-04', 'Rammekens', 2426, NULL);
INSERT INTO "voyages" VALUES (6518, '', 3, '', 'NEDERHOVEN', 'Jakob Wijman', 600, 'fluit', '1708', NULL, NULL, 'R', 'Z', '1721-11-22', 'Ceylon', '1722-02-14', '1722-04-10', true, '1722-08-07', 'Rammekens', 2378, NULL);
INSERT INTO "voyages" VALUES (6519, '', 5, '', 'OUWERKERK', 'Jan Kluit', 658, 'fluit', '1706', NULL, NULL, 'A', 'A', '1721-11-22', 'Ceylon', '1722-02-14', '1722-04-10', true, '1722-08-05', 'Texel', 2431, NULL);
INSERT INTO "voyages" VALUES (6520, '', 2, '', 'WENDELA', 'Bastiaan Schul', 600, NULL, '1716', NULL, NULL, 'A', 'A', '1721-11-22', 'Ceylon', '1722-02-14', '1722-04-10', true, '1722-08-04', 'Texel', 2450, NULL);
INSERT INTO "voyages" VALUES (6521, '', 2, '', 'AMSTELVEEN', 'Theunis de Haan', 1150, NULL, '1717', NULL, NULL, 'A', 'A', '1721-11-30', 'Batavia', NULL, NULL, true, NULL, NULL, 2443, 'Wrecked on 08-01-1722 at 26''15''S.');
INSERT INTO "voyages" VALUES (6522, '', 1, '', 'HUIS TE FOREEST', 'Pieter Rus', 600, 'fluit', '1717', NULL, NULL, 'H', 'H', '1721-11-30', 'Batavia', NULL, NULL, true, NULL, NULL, 2345, 'Wrecked in 1722 near Mauritius.');
INSERT INTO "voyages" VALUES (6523, '', 2, '', 'AMSTERDAM', 'Arend Redog', 800, NULL, '1716', NULL, NULL, 'A', 'A', '1721-12-17', 'Batavia', '1722-04-06', '1722-04-10', true, '1722-07-26', 'Texel', 2444, NULL);
INSERT INTO "voyages" VALUES (6524, '', 2, '', 'DEN DAM', 'Frederik Koper', 600, 'fluit', '1716', NULL, NULL, 'D', 'D', '1721-12-17', 'Batavia', '1722-03-08', '1722-04-10', true, '1722-08-05', 'Goeree', 2436, NULL);
INSERT INTO "voyages" VALUES (6525, '', 1, '', 'DELFLAND', 'Philip van den Broek', 600, 'fluit', '1717', NULL, NULL, 'D', 'D', '1721-12-17', 'Batavia', '1722-03-05', '1722-04-10', true, '1722-08-05', 'Goeree', 2354, 'The master was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6526, '', 1, '', 'GEERTRUID', 'Jan Simonsz.', 600, 'fluit', '1717', NULL, NULL, 'E', 'E', '1721-12-17', 'Batavia', '1722-03-06', '1722-04-10', true, '1722-08-05', 'Texel', 2344, NULL);
INSERT INTO "voyages" VALUES (6527, '', 6, '', 'KONING KAREL DE DERDE', 'Jakob de Marre', 830, NULL, '1704', NULL, NULL, 'A', 'A', '1721-12-17', 'Batavia', '1722-03-19', '1722-04-10', true, '1722-08-05', 'Texel', 2446, NULL);
INSERT INTO "voyages" VALUES (6528, '', 5, '', 'NOORDERKWARTIER', 'Jan Klooster', 550, 'fluit', '1709', NULL, NULL, 'H', 'H', '1721-12-17', 'Batavia', '1722-02-28', '1722-04-10', true, '1722-07-27', 'Texel', 2412, NULL);
INSERT INTO "voyages" VALUES (6529, '', 3, '', 'SCHOTEROOG', 'Jakob Brouwer', 360, 'fregat', '1712', NULL, NULL, 'A', 'A', '1721-12-17', 'Batavia', '1722-03-19', '1722-04-10', true, '1722-08-05', 'Texel', 2425, NULL);
INSERT INTO "voyages" VALUES (6530, '', 3, '', 'STRIJKEBOLLE', 'Michiel de Reus', 540, 'fluit', '1712', NULL, NULL, 'E', 'E', '1721-12-17', 'Batavia', '1722-03-01', '1722-04-10', true, '1722-08-06', 'Vlie', 2447, NULL);
INSERT INTO "voyages" VALUES (6531, '', 5, '', 'VADERLAND GETROUW', 'Matthijs Burger', 848, NULL, '1705', NULL, NULL, 'Z', 'Z', '1721-12-17', 'Batavia', '1722-02-24', '1722-04-10', true, '1722-08-08', 'Rammekens', 2453, 'The master was vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6532, '', 6, '', 'WASSENAAR', 'Daniel Bent', 804, NULL, '1704', NULL, NULL, 'D', 'R', '1721-12-17', 'Batavia', '1722-02-24', '1722-04-10', true, '1722-08-05', 'Goeree', 2449, NULL);
INSERT INTO "voyages" VALUES (6533, '', 4, '', 'WESTERDIJKSHORN', 'Jan de Vos', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1721-12-17', 'Batavia', '1722-02-24', '1722-04-10', true, '1722-08-03', 'Texel', 2451, NULL);
INSERT INTO "voyages" VALUES (6534, '', 1, '', 'GOUDRIAAN', 'Jan Bloemendaal', 630, 'fluit', '1719', NULL, NULL, 'D', 'D', '1722-01-22', 'Batavia', '1722-05-09', '1722-06-10', true, '1722-09-23', 'Goeree', 2419, NULL);
INSERT INTO "voyages" VALUES (6535, '', 1, '', 'HOF NIET ALTIJD ZOMER', 'Joris Vermouwe', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1722-01-22', 'Batavia', '1722-05-09', '1722-06-10', true, '1722-10-06', 'Rammekens', 2380, NULL);
INSERT INTO "voyages" VALUES (6536, '', 2, '', 'MARGARETA', 'Jan Rusteplukker', 600, 'fluit', '1715', NULL, NULL, 'E', 'E', '1722-01-22', 'Batavia', '1722-05-09', '1722-06-10', true, '1722-09-25', 'Texel', 2434, NULL);
INSERT INTO "voyages" VALUES (6537, '', 5, '', 'VOORBURG', 'Jakob Bogaard', 600, NULL, '1710', NULL, NULL, 'D', 'A', '1722-01-22', 'Batavia', '1722-05-09', '1722-06-10', true, '1722-10-24', 'Texel', 2384, NULL);
INSERT INTO "voyages" VALUES (6538, '', 3, '', 'RAADHUIS VAN VLISSINGEN', 'Jakob Onkruid', 600, 'fluit', '1714', NULL, NULL, 'Z', 'Z', '1722-03-31', 'Batavia', '1722-07-01', '1722-07-29', true, '1722-11-17', 'Rammekens', 2456, NULL);
INSERT INTO "voyages" VALUES (6539, '', 2, '', 'OPPERDOES', 'Jakob Breed', 600, 'fluit', '1718', NULL, NULL, 'H', 'A', '1722-03-31', 'Batavia', '1722-06-26', '1722-07-29', true, '1722-11-10', 'Goeree', 2458, NULL);
INSERT INTO "voyages" VALUES (6540, '', 1, '', 'ANNA MARIA', 'Kornelis Fret', 600, NULL, '1717', NULL, NULL, 'Z', 'Z', '1722-09-26', 'Batavia', '1722-11-24', '1723-04-25', true, '1723-04-25', 'Rammekens', 2341, NULL);
INSERT INTO "voyages" VALUES (6541, '', 2, '', 'SCHONENBERG', 'Albert van Soest', 800, NULL, '1717', NULL, NULL, 'A', 'A', '1722-09-26', 'Batavia', NULL, NULL, true, NULL, NULL, 2476, 'Wrecked near Angola.');
INSERT INTO "voyages" VALUES (6542, '', 3, '', 'DOORNIK', 'Herman de Vrij', 830, NULL, '1709', NULL, NULL, 'A', 'Z', '1722-10-19', 'Ceylon', '1723-01-08', '1723-02-06', true, '1723-05-25', 'Rammekens', 2432, NULL);
INSERT INTO "voyages" VALUES (6543, '', 2, '', 'HOGENES', 'Isaak de Vries', 870, NULL, '1716', NULL, NULL, 'Z', 'A', '1722-10-19', 'Ceylon', '1723-01-08', '1723-02-06', true, '1723-05-24', 'Texel', 2445, NULL);
INSERT INTO "voyages" VALUES (6544, '', 3, '', 'BOEKENRODE', 'Abraham Ram', 890, NULL, '1714', NULL, NULL, 'A', 'A', '1722-11-27', 'Ceylon', '1723-02-17', '1723-03-25', true, '1723-07-24', 'Texel', 2409, 'Commandeur of this return fleet was Jan van Strijen, vice-commandeur Hendrik van der Grippe (6564) and schout-bij-nacht Klaas van Eik (6561).');
INSERT INTO "voyages" VALUES (6545, '', 1, '', 'HEINEKENSZAND', 'Hendrik Keizer', 1150, NULL, '1720', NULL, NULL, 'Z', 'Z', '1722-11-27', 'Ceylon', '1723-02-15', '1723-03-25', true, '1723-07-06', 'Rammekens', 2462, NULL);
INSERT INTO "voyages" VALUES (6546, '', 4, '', 'MEERHUIZEN', 'Hendrik Schoon', 600, 'fluit', '1714', NULL, NULL, 'A', 'A', '1722-11-27', 'Ceylon', '1723-02-14', '1723-03-25', true, '1723-07-24', 'Texel', 2490, NULL);
INSERT INTO "voyages" VALUES (6547, '', 1, '', 'STADWIJK', 'Gerrit Staal', 1150, NULL, '1720', NULL, NULL, 'A', 'A', '1722-11-27', 'Ceylon', '1723-02-17', '1723-03-25', true, '1723-07-04', 'Texel', 2467, NULL);
INSERT INTO "voyages" VALUES (6548, '', 2, '', 'BARBESTEIN', 'Jan Kopersluis', 1100, NULL, '1717', NULL, NULL, 'Z', 'Z', '1722-12-02', 'Batavia', '1723-03-04', '1723-03-25', true, '1723-07-06', 'Rammekens', 2459, NULL);
INSERT INTO "voyages" VALUES (6549, '', 7, '', 'BARNEVELD', 'Gideon Kuiper', 1008, NULL, '1706', NULL, NULL, 'A', 'A', '1722-12-02', 'Batavia', '1723-02-16', '1723-03-25', true, '1723-07-04', 'Texel', 2480, NULL);
INSERT INTO "voyages" VALUES (6550, '', 5, '', 'BENTVELD', 'Laurens Usenhart', 938, NULL, '1708', NULL, NULL, 'A', 'A', '1722-12-02', 'Batavia', '1723-02-16', '1723-03-25', true, '1723-07-05', 'Texel', 2393, NULL);
INSERT INTO "voyages" VALUES (6551, '', 2, '', 'CATS', 'Michiel van Markel', 580, NULL, '1716', NULL, NULL, 'Z', 'R', '1722-12-02', 'Batavia', '1723-03-03', '1723-03-25', true, '1723-07-05', 'Goeree', 2362, NULL);
INSERT INTO "voyages" VALUES (6552, '', 2, '', 'STADHUIS VAN DELFT', 'Hendrik Schalkenius', 600, 'fluit', '1718', NULL, NULL, 'D', 'R', '1722-12-02', 'Batavia', '1723-03-16', '1723-03-25', true, '1723-07-05', 'Goeree', 2486, NULL);
INSERT INTO "voyages" VALUES (6553, '', 4, '', 'ELISABETH', 'Marten Harting', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1722-12-02', 'Batavia', '1723-02-16', '1723-03-25', true, '1723-07-04', 'Texel', 2487, NULL);
INSERT INTO "voyages" VALUES (6554, '', 1, '', 'HAFTEN', 'Jakob Wijdeman', 600, 'fluit', '1717', NULL, NULL, 'A', 'E', '1722-12-02', 'Batavia', '1723-03-04', '1723-03-25', true, '1723-07-04', 'Texel', 2350, NULL);
INSERT INTO "voyages" VALUES (6555, '', 3, '', 'JOHANNA', 'Gerrit Loot', 550, 'fluit', '1714', NULL, NULL, 'A', 'E', '1722-12-02', 'Batavia', '1723-02-28', '1723-03-25', true, '1723-07-04', 'Texel', 2469, NULL);
INSERT INTO "voyages" VALUES (6556, '', 2, '', 'KOMMERRUST', 'Andries Pijl', 810, NULL, '1718', NULL, NULL, 'A', 'A', '1722-12-02', 'Batavia', '1723-02-16', '1723-03-25', true, '1723-07-04', 'Texel', 2474, NULL);
INSERT INTO "voyages" VALUES (6557, '', 2, '', 'STAD LEIDEN', 'Pieter Verley', 1140, NULL, '1718', NULL, NULL, 'A', 'A', '1722-12-02', 'Batavia', '1723-02-17', '1723-03-25', true, '1723-07-04', 'Texel', 2488, NULL);
INSERT INTO "voyages" VALUES (6558, '', 2, '', 'LOENDERVEEN', 'Pieter Westrik', 650, 'fluit', '1718', NULL, NULL, 'A', 'H', '1722-12-02', 'Batavia', '1723-02-16', '1723-03-25', true, '1723-07-04', 'Texel', 2470, NULL);
INSERT INTO "voyages" VALUES (6559, '', 3, '', 'LUCHTENBURG', 'Elias Wargaren', 800, NULL, '1715', NULL, NULL, 'H', 'H', '1722-12-02', 'Batavia', '1723-02-16', '1723-03-25', true, '1723-07-04', 'Texel', 2489, NULL);
INSERT INTO "voyages" VALUES (6560, '', 4, '', 'MEUENBURG', 'Kornelis de Giers', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1722-12-02', 'Batavia', '1723-02-16', '1723-03-25', true, '1723-07-06', 'Rammekens', 2437, NULL);
INSERT INTO "voyages" VALUES (6561, '', 5, '', 'NOORDBEEK', 'Klaas van Eik', 858, NULL, '1707', NULL, NULL, 'Z', 'D', '1722-12-02', 'Batavia', '1723-02-16', '1723-03-25', true, '1723-07-05', 'Goeree', 2471, NULL);
INSERT INTO "voyages" VALUES (6562, '', 3, '', 'PRATTENBURG', 'Jan van der Heiden', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1722-12-02', 'Batavia', '1723-02-17', '1723-03-25', true, '1723-07-04', 'Texel', 2482, NULL);
INSERT INTO "voyages" VALUES (6563, '', 3, '', 'D''UNO', 'Abraham Bustijn', 250, 'fregat', '1707', NULL, NULL, 'Z', 'A', '1722-12-02', 'Batavia', '1723-02-16', '1723-03-25', true, '1723-07-24', 'Texel', 2441, NULL);
INSERT INTO "voyages" VALUES (6564, '', 3, '', 'VALKENISSE', 'Hendrik van der Grippe', 1150, NULL, '1716', NULL, NULL, 'Z', 'Z', '1722-12-02', 'Batavia', '1723-02-16', '1723-03-25', true, '1723-07-06', 'Rammekens', 2491, NULL);
INSERT INTO "voyages" VALUES (6565, '', 1, '', 'HILLEGONDA', 'Jan Ringelenberg', 850, NULL, '1720', NULL, NULL, 'H', 'H', '1723-01-21', 'Batavia', '1723-04-04', '1723-05-01', true, '1723-08-22', 'Texel', 2461, NULL);
INSERT INTO "voyages" VALUES (6566, '', 1, '', 'JACOBA', 'Gerbrand Mamus', 805, NULL, '1721', NULL, NULL, 'A', 'A', '1723-01-21', 'Batavia', '1723-04-04', '1723-05-01', true, '1723-08-22', 'Texel', 2481, NULL);
INSERT INTO "voyages" VALUES (6567, '', 2, '', 'SAMARITAAN', 'Jan Credo', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1723-01-21', 'Batavia', '1723-04-04', '1723-05-01', true, '1723-08-23', 'Rammekens', 2478, NULL);
INSERT INTO "voyages" VALUES (6568, '', 1, '', 'THEODORA', 'Pieter Scherf', 600, 'fluit', '1720', NULL, NULL, 'A', 'A', '1723-01-21', 'Batavia', '1723-04-04', '1723-05-01', true, '1723-08-22', 'Texel', 2468, NULL);
INSERT INTO "voyages" VALUES (6569, '', 1, '', 'BAANMAN', 'Engel Appelman', 650, NULL, '1720', NULL, NULL, 'E', 'A', '1723-03-21', 'Batavia', '1723-06-27', '1723-07-24', true, '1723-11-20', 'Texel', 2457, NULL);
INSERT INTO "voyages" VALUES (6570, '', 3, '', 'SLOT ALDEGONDE', 'Steven Boghoute', 1160, 'jacht', '1714', NULL, NULL, 'Z', 'Z', '1723-09-23', 'Batavia', '1723-11-30', '1724-01-28', true, '1724-04-30', 'Rammekens', 2506, NULL);
INSERT INTO "voyages" VALUES (6571, '', 2, '', 'GEERTRUID', 'IJpe Engelsman', 600, 'fluit', '1717', NULL, NULL, 'E', 'A', '1723-09-23', 'Batavia', '1723-12-21', '1724-01-28', true, '1724-05-07', 'Texel', 2519, NULL);
INSERT INTO "voyages" VALUES (6572, '', 3, '', 'LINSCHOTEN', 'Siewert Pool', 804, NULL, '1714', NULL, NULL, 'A', 'A', '1723-09-23', 'Batavia', '1723-11-30', '1724-01-28', true, '1724-05-07', 'Texel', 2420, NULL);
INSERT INTO "voyages" VALUES (6573, '', 3, '', 'WENDELA', 'David Brouwer', 600, NULL, '1716', NULL, NULL, 'A', 'A', '1723-09-23', 'Batavia', '1723-11-30', '1724-01-28', true, '1724-05-23', 'Texel', 2524, NULL);
INSERT INTO "voyages" VALUES (6574, '', 2, '', 'WITSBURG', 'Arend Etman', 520, 'fluit', '1714', NULL, NULL, 'E', 'E', '1723-11-15', 'Batavia', '1724-03-18', '1724-04-02', true, '1724-07-06', 'Texel', 2342, 'Commandeur of this return fleet was Hans Frederik Berkman, vice-commandeur Gerrit Stokke (6592), and schout-bij-nacht Jakob van der Poel (6576).');
INSERT INTO "voyages" VALUES (6575, '', 1, '', 'CASTRICUM', 'Hendrik Thieling', 1150, NULL, '1722', NULL, NULL, 'A', 'A', '1723-11-25', 'Batavia', '1724-03-11', '1724-04-02', true, '1724-07-05', 'Texel', 2518, NULL);
INSERT INTO "voyages" VALUES (6576, '', 2, '', 'DELFLAND', 'Jakob van der Poel', 600, 'fluit', '1717', NULL, NULL, 'D', 'D', '1723-11-25', 'Batavia', '1724-03-10', '1724-04-02', true, '1724-07-05', 'Goeree', 2514, NULL);
INSERT INTO "voyages" VALUES (6577, '', 4, '', 'GROENSWAART', 'Bartholomeus Mastrigt', 600, 'fluit', '1714', NULL, NULL, 'R', 'R', '1723-11-25', 'Batavia', '1724-03-03', '1724-04-02', true, '1724-07-05', 'Goeree', 2473, NULL);
INSERT INTO "voyages" VALUES (6578, '', 2, '', 'MAGDALENA', 'Michiel van Pavie', 600, NULL, '1719', NULL, NULL, 'H', 'H', '1723-11-25', 'Batavia', '1724-03-11', '1724-04-02', true, '1724-07-05', 'Texel', 2529, NULL);
INSERT INTO "voyages" VALUES (6579, '', 4, '', 'MIDDELWOUD', 'Kornelis Braams', 804, NULL, '1712', NULL, NULL, 'Z', 'Z', '1723-11-25', 'Batavia', '1724-03-08', '1724-04-02', true, '1724-07-05', 'Rammekens', 2498, NULL);
INSERT INTO "voyages" VALUES (6580, '', 6, '', 'MUNDEN', 'Jan de Koning', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1723-11-25', 'Batavia', '1724-03-11', '1724-04-02', true, '1724-07-05', 'Texel', 2511, NULL);
INSERT INTO "voyages" VALUES (6581, '', 3, '', 'RIJKSDORP', 'Anthonie Klink', 792, NULL, '1713', NULL, NULL, 'A', 'Z', '1723-11-25', 'Batavia', '1724-03-08', '1724-04-02', true, '1724-07-05', 'Rammekens', 2513, NULL);
INSERT INTO "voyages" VALUES (6582, '', 4, '', 'HUIS DE VLOTTER', 'Klaas Slijper', 528, 'fluit', '1713', NULL, NULL, 'A', 'H', '1723-11-25', 'Batavia', '1724-03-11', '1724-04-02', true, '1724-07-05', 'Texel', 2509, NULL);
INSERT INTO "voyages" VALUES (6583, '', 5, '', 'WESTERDIJKSHORN', 'Bastiaan Schul', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1723-11-25', 'Batavia', '1724-03-08', '1724-04-02', true, '1724-07-05', 'Texel', 2526, NULL);
INSERT INTO "voyages" VALUES (6584, '', 1, '', 'WESTFRIESLAND', 'Klaas Zeeridder', 370, 'jacht', '1722', NULL, NULL, 'H', 'A', '1723-11-25', 'Batavia', '1724-03-08', '1724-04-02', true, '1724-07-04', 'Texel', 2527, NULL);
INSERT INTO "voyages" VALUES (6585, '', 4, '', 'KOCKENGEN', 'Louis Schulerius', 824, NULL, '1711', NULL, NULL, 'A', 'A', '1723-11-28', 'Ceylon', '1724-02-07', '1724-04-02', true, '1724-07-05', 'Texel', 2428, NULL);
INSERT INTO "voyages" VALUES (6586, '', 1, '', 'MIDLOO', 'Abraham van Bodegem', 800, NULL, '1719', NULL, NULL, 'A', 'A', '1723-11-28', 'Ceylon', '1724-02-07', '1724-04-02', true, '1724-07-04', 'Texel', 2435, NULL);
INSERT INTO "voyages" VALUES (6587, '', 1, '', 'NIEUWVLIET', 'Pieter van den Berg', 650, NULL, '1719', NULL, NULL, 'Z', 'Z', '1723-11-28', 'Ceylon', '1724-02-07', '1724-04-02', true, '1724-07-05', 'Rammekens', 2438, NULL);
INSERT INTO "voyages" VALUES (6588, '', 1, '', 'RAVESTEIN', 'Albert Bovet', 800, NULL, '1707', NULL, NULL, 'A', 'Z', '1723-11-28', 'Ceylon', '1724-01-28', '1724-04-02', true, '1724-07-05', 'Rammekens', 2439, NULL);
INSERT INTO "voyages" VALUES (6589, '', 3, '', 'AMSTERDAM', 'Wessel Hoogwerf', 800, NULL, '1716', NULL, NULL, 'A', 'A', '1723-12-04', 'Batavia', '1724-02-25', '1724-04-02', true, '1724-07-05', 'Texel', 2516, NULL);
INSERT INTO "voyages" VALUES (6590, '', 4, '', 'HUIS TEN DONK', 'Jan Kluit', 650, NULL, '1711', NULL, NULL, 'R', 'R', '1723-12-04', 'Batavia', '1724-02-25', '1724-04-02', true, '1724-07-05', 'Goeree', 2510, NULL);
INSERT INTO "voyages" VALUES (6591, '', 2, '', 'VIS', 'Pieter van Losen', 600, 'fluit', '1716', NULL, NULL, 'E', 'E', '1723-12-04', 'Batavia', '1724-02-25', '1724-04-02', true, '1724-07-04', 'Texel', 2464, NULL);
INSERT INTO "voyages" VALUES (6592, '', 1, '', 'ZOETELINGSKERKE', 'Gerrit Stokke', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1723-12-04', 'Batavia', '1724-02-25', '1724-04-02', true, '1724-07-05', 'Rammekens', 2532, NULL);
INSERT INTO "voyages" VALUES (6593, '', 3, '', 'SPIERING', 'Erasmus Schuit', 810, NULL, '1714', NULL, NULL, 'D', 'D', '1723-12-17', 'Batavia', '1724-03-07', '1724-04-02', true, '1724-07-05', 'Goeree', 2455, 'At the departure Jan Kuipers was probably the master.');
INSERT INTO "voyages" VALUES (6594, '', 1, '', 'OOSTRUST', 'Gerrit Moring', 1140, NULL, '1721', NULL, NULL, 'A', 'A', '1723-12-24', 'Batavia', '1724-03-02', '1724-04-02', true, '1724-07-05', 'Texel', 2502, NULL);
INSERT INTO "voyages" VALUES (6595, '', 2, '', 'HOF NIET ALTIJD ZOMER', 'Pieter van de Roete', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1724-01-22', 'Batavia', '1724-04-25', '1724-05-12', true, '1724-09-18', 'Rammekens', 2535, NULL);
INSERT INTO "voyages" VALUES (6596, '', 1, '', 'PATMOS', 'Gelijn de Haas', 810, NULL, '1722', NULL, NULL, 'D', 'R', '1724-01-22', 'Batavia', '1724-04-25', '1724-05-22', true, '1724-09-08', 'Goeree', 2537, NULL);
INSERT INTO "voyages" VALUES (6597, '', 1, '', 'STABROEK', 'Jakob de Marre', 900, NULL, '1722', NULL, NULL, 'A', 'A', '1724-01-22', 'Batavia', '1724-04-25', '1724-05-12', true, '1724-09-08', 'Texel', 2523, NULL);
INSERT INTO "voyages" VALUES (6598, '', 2, '', 'STEENHOVEN', 'Nikolaas de Roy', 850, NULL, '1718', NULL, NULL, 'Z', 'A', '1724-01-22', 'Colombo', '1724-04-26', '1724-05-12', true, '1724-09-04', 'Texel', 2479, 'The STEENHOVEN left Mocha on 03-09-1723 and sailed via Cochin to Colombo.');
INSERT INTO "voyages" VALUES (6599, '', 4, '', 'STRIJKEBOLLE', 'Bloemendaal', 540, 'fluit', '1712', NULL, NULL, 'E', 'E', '1724-01-22', 'Batavia', '1724-04-23', '1724-05-22', true, '1724-09-07', 'Texel', 2542, NULL);
INSERT INTO "voyages" VALUES (6600, '', 1, '', 'KLARABEEK', 'Jan Moerman', 705, NULL, '1721', NULL, NULL, 'Z', 'A', '1724-03-30', 'Batavia', '1724-08-04', '1724-08-27', true, '1724-12-29', 'Texel', 2507, NULL);
INSERT INTO "voyages" VALUES (6601, '', 2, '', 'HUIS TE ASSENBURG', 'Jakob Thoorn', 800, NULL, '1718', NULL, NULL, 'A', 'A', '1724-10-11', 'Ceylon', '1725-01-11', '1725-01-19', true, '1725-05-23', 'Texel', 2517, 'ASSENBURG was a ''coffee ship'', it left Mocha on 14-08-1724.');
INSERT INTO "voyages" VALUES (6602, '', 1, '', 'ASTREA', 'Jan Reebok', 800, NULL, '1720', NULL, NULL, 'D', 'A', '1724-09-26', 'Batavia', '1724-11-22', '1725-01-19', true, '1725-05-21', 'Texel', 2472, NULL);
INSERT INTO "voyages" VALUES (6603, '', 3, '', 'BORSSELE', 'Jonas Mierman', 800, NULL, '1715', NULL, NULL, 'Z', 'Z', '1724-09-26', 'Batavia', '1724-11-22', '1725-01-19', true, '1725-05-16', 'Rammekens', 2551, NULL);
INSERT INTO "voyages" VALUES (6604, '', 2, '', 'GOUDRIAAN', 'Huibert van Spijk', 630, 'fluit', '1719', NULL, NULL, 'D', 'D', '1724-09-26', 'Batavia', '1724-11-22', '1725-01-19', true, '1725-05-16', 'Goeree', 2544, NULL);
INSERT INTO "voyages" VALUES (6605, '', 1, '', 'HEESBURG', 'Reinier Hijpe', 850, NULL, '1720', NULL, NULL, 'A', 'A', '1724-09-26', 'Batavia', '1724-11-22', '1725-01-19', true, '1725-05-21', 'Texel', 2466, NULL);
INSERT INTO "voyages" VALUES (6606, '', 3, '', 'OPPERDOES', 'Jan Ravenek', 600, 'fluit', '1718', NULL, NULL, 'H', 'H', '1724-09-26', 'Batavia', '1724-11-22', '1725-01-19', true, '1725-05-20', 'Texel', 2539, NULL);
INSERT INTO "voyages" VALUES (6607, '', 1, '', 'SUSANNA', 'Isaak Hage', 600, NULL, '1721', NULL, NULL, 'A', 'A', '1724-09-26', 'Batavia', '1724-11-22', '1725-01-19', true, '1725-05-21', 'Texel', 2483, NULL);
INSERT INTO "voyages" VALUES (6608, '', 1, '', 'ADELAAR', 'Joris Vermouwe', 810, NULL, '1722', NULL, NULL, 'Z', 'Z', '1724-11-27', 'Ceylon', '1725-02-24', '1725-04-11', true, '1725-07-06', 'Rammekens', 2550, 'Admiraal of this return fleet was Pieter Scherf (6629), commandeur was Ewout van Dieshoek, vice-commandeur was Kornelis Fret (6612), and schout-bij-nacht was Jakob van der Swet (6624).');
INSERT INTO "voyages" VALUES (6609, '', 4, '', 'DOORNIK', 'Gerrit Pekstok', 830, NULL, '1709', NULL, NULL, 'A', 'A', '1724-11-27', 'Ceylon', '1725-02-23', '1725-04-11', true, '1725-07-24', 'Texel', 2554, NULL);
INSERT INTO "voyages" VALUES (6610, '', 2, '', 'JACOBA', 'Tijmen Mol', 805, NULL, '1721', NULL, NULL, 'A', 'A', '1724-11-27', 'Ceylon', '1725-02-23', '1725-04-11', true, '1725-07-24', 'Texel', 2569, NULL);
INSERT INTO "voyages" VALUES (6611, '', 2, '', 'STADWIJK', 'Marten Harting', 1150, NULL, '1720', NULL, NULL, 'A', 'A', '1724-11-27', 'Ceylon', '1725-02-24', '1725-04-11', true, '1725-07-05', 'Texel', 2558, NULL);
INSERT INTO "voyages" VALUES (6612, '', 3, '', 'BARBESTEIN', 'Kornelis Fret', 1100, NULL, '1717', NULL, NULL, 'Z', 'Z', '1724-12-01', 'Batavia', '1725-02-21', '1725-04-11', true, '1725-07-27', 'Rammekens', 2565, 'vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6613, '', 6, '', 'BERBICES', 'Wouter van Dijk', 1136, NULL, '1709', NULL, NULL, 'Z', 'A', '1724-12-01', 'Batavia', '1725-03-20', '1725-04-11', true, '1725-07-24', 'Texel', 2552, NULL);
INSERT INTO "voyages" VALUES (6614, '', 1, '', 'CORNELIA', 'Nikolaas Anderson', 800, NULL, '1721', NULL, NULL, 'H', 'Z', '1724-12-01', 'Ceylon', '1725-03-21', '1725-04-11', true, '1725-07-27', 'Rammekens', 2500, NULL);
INSERT INTO "voyages" VALUES (6615, '', 1, '', 'HAARLEM', 'Jan Laurens de Hoge', 850, NULL, '1720', NULL, NULL, 'A', 'A', '1724-12-01', 'Batavia', '1725-03-19', '1725-04-11', true, '1725-07-24', 'Texel', 2465, NULL);
INSERT INTO "voyages" VALUES (6616, '', 2, '', 'HEINKENSZAND', 'Jan Credo', 1150, NULL, '1720', NULL, NULL, 'Z', 'Z', '1724-12-01', 'Batavia', '1725-03-18', '1725-04-11', true, '1725-07-27', 'Rammekens', 2561, NULL);
INSERT INTO "voyages" VALUES (6617, '', 2, '', 'HILLEGONDA', 'Arend Dirksz. Bent', 850, NULL, '1720', NULL, NULL, 'H', 'H', '1724-12-01', 'Batavia', '1725-03-21', '1725-04-11', true, '1725-07-26', 'Texel', 2568, NULL);
INSERT INTO "voyages" VALUES (6618, '', 3, '', 'HOGENES', 'Elias Wargaren', 870, NULL, '1716', NULL, NULL, 'Z', 'Z', '1724-12-01', 'Batavia', '1725-03-18', '1725-04-11', true, '1725-07-27', 'Rammekens', 2557, NULL);
INSERT INTO "voyages" VALUES (6619, '', 2, '', 'HOPVOGEL', 'Dirk Renvoort', 600, 'fluit', '1714', NULL, NULL, 'A', 'H', '1724-12-01', 'Batavia', '1725-03-21', '1725-04-11', true, '1725-07-24', 'Texel', 2433, NULL);
INSERT INTO "voyages" VALUES (6620, '', 4, '', 'TER HORST', 'Jakob Upelaar', 520, 'fluit', '1713', NULL, NULL, 'Z', 'D', '1724-12-01', 'Batavia', '1725-03-19', '1725-04-11', true, '1725-07-26', 'Goeree', 2504, NULL);
INSERT INTO "voyages" VALUES (6621, '', 4, '', 'JOHANNA', 'Klaas Jonker', 550, 'fluit', '1714', NULL, NULL, 'A', 'E', '1724-12-01', 'Batavia', '1725-03-18', '1725-04-11', true, '1725-07-24', 'Texel', 2570, NULL);
INSERT INTO "voyages" VALUES (6622, '', 3, '', 'KOMMERRUST', 'Pieter Verley', 810, NULL, '1718', NULL, NULL, 'A', 'A', '1724-12-01', 'Batavia', '1725-03-19', '1725-04-11', true, '1725-07-23', 'Terschelling', 2560, NULL);
INSERT INTO "voyages" VALUES (6623, '', 1, '', 'KROOSWUK', 'Adriaan van Dorp', 600, 'fluit', '1720', NULL, NULL, 'R', 'R', '1724-12-01', 'Batavia', '1725-03-19', '1725-04-11', true, '1725-07-26', 'Goeree', 2454, NULL);
INSERT INTO "voyages" VALUES (6624, '', 1, '', 'LANGERODE', 'Jakob van der Swet', 600, NULL, '1723', NULL, NULL, 'D', 'D', '1724-12-01', 'Batavia', '1725-03-19', '1725-04-11', true, '1725-07-26', 'Goeree', 2564, 'The master was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6625, '', 3, '', 'STAD LEIDEN', 'Jakob Breed', 1, NULL, '1718', NULL, NULL, 'A', 'A', '1724-12-01', 'Batavia', '1725-03-21', '1725-04-11', true, '1725-07-23', 'Texel', 2571, NULL);
INSERT INTO "voyages" VALUES (6626, '', 3, '', 'MARGARETA', 'Karel de Laver', 600, 'fluit', '1715', NULL, NULL, 'E', 'E', '1724-12-01', 'Batavia', '1725-03-15', '1725-04-11', true, '1725-07-24', 'Texel', 2538, NULL);
INSERT INTO "voyages" VALUES (6627, '', 2, '', 'NOORDWADDINXVEEN', 'Hendrik Lont', 850, NULL, '1718', NULL, NULL, 'R', 'R', '1724-12-01', 'Batavia', '1725-03-20', '1725-04-11', true, '1725-07-07', 'Vlie', 2493, NULL);
INSERT INTO "voyages" VALUES (6628, '', 4, '', 'PRATTENBURG', 'Jan van der Heiden', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1724-12-01', 'Batavia', '1725-03-19', '1725-04-11', true, '1725-07-23', 'Texel', 2572, NULL);
INSERT INTO "voyages" VALUES (6629, '', 1, '', 'BERKENRODE', 'Pieter Scherf', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1724-12-04', 'Batavia', '1725-03-18', '1725-04-11', true, '1725-07-24', 'Texel', 2567, 'The master was admiraal of the return fleet.');
INSERT INTO "voyages" VALUES (6630, '', 1, '', 'WINDHOND', 'de Vijver', 370, NULL, '1722', NULL, NULL, 'A', 'A', '1724-12-04', 'Batavia', '1725-03-18', '1725-04-11', true, '1725-07-24', 'Texel', 2548, NULL);
INSERT INTO "voyages" VALUES (6631, '', 1, '', 'HERSTELLING', 'Pieter van Dalen', 600, NULL, '1721', NULL, NULL, 'D', 'D', '1725-02-01', 'Batavia', '1725-05-15', '1725-06-03', true, '1725-11-13', 'Goeree', 2496, NULL);
INSERT INTO "voyages" VALUES (6632, '', 1, '', 'KETEL', 'Jakob Onkruid', 810, NULL, '1721', NULL, NULL, 'R', 'A', '1725-02-01', 'Batavia', '1725-05-12', '1725-06-03', true, '1725-12-12', 'Texel', 2503, NULL);
INSERT INTO "voyages" VALUES (6633, '', 4, '', 'OUDENAARDE', 'Jan van den Broek', 858, NULL, '1708', NULL, NULL, 'A', 'A', '1725-02-01', 'Batavia', '1725-05-12', '1725-06-03', true, '1725-12-12', 'Texel', 2427, NULL);
INSERT INTO "voyages" VALUES (6634, '', 2, '', 'VRIESWUK', 'Michiel de Reus', 850, NULL, '1716', NULL, NULL, 'H', 'H', '1725-02-01', 'Batavia', '1725-05-12', '1725-06-03', true, '1725-12-11', 'Texel', 2448, 'Laid up in patria in 1726.');
INSERT INTO "voyages" VALUES (6635, '', 1, '', 'WICKENBURG', 'Adriaan Hijpe', 850, NULL, '1722', NULL, NULL, 'Z', 'Z', '1725-02-01', 'Batavia', '1725-05-15', '1725-06-03', true, '1725-11-14', 'Rammekens', 2576, NULL);
INSERT INTO "voyages" VALUES (6636, '', 1, '', '''S GRAVELAND', 'Jan Diephout', 600, NULL, '1722', NULL, NULL, 'A', 'A', '1725-03-27', 'Batavia', '1725-06-09', '1725-06-20', true, '1725-09-19', 'Texel', 2556, NULL);
INSERT INTO "voyages" VALUES (6637, '', 6, '', 'NOORDERKWARTIER', 'Jakob Meindertsz. Blok', 550, 'fluit', '1709', NULL, NULL, 'H', 'A', '1725-10-29', 'Ceylon', '1726-02-07', '1726-02-28', true, '1726-06-30', 'Texel', 2543, 'The NOORDERKWARTIER was a ''coffee ship'', it left Mocha on 25-08-1725.');
INSERT INTO "voyages" VALUES (6638, '', 4, '', 'BOEKENRODE', 'Klaas van Eik', 890, NULL, '1714', NULL, NULL, 'A', 'A', '1725-10-24', 'Batavia', '1726-01-22', '1726-02-28', true, '1726-06-19', 'Texel', 2588, NULL);
INSERT INTO "voyages" VALUES (6639, '', 3, '', 'DEN DAM', 'Arie Jansz. Verduin', 600, 'fluit', '1716', NULL, NULL, 'D', 'D', '1725-10-24', 'Batavia', '1726-01-22', '1726-02-28', true, '1726-06-18', 'Goeree', 2546, NULL);
INSERT INTO "voyages" VALUES (6640, '', 2, '', 'HAAKSBURG', 'Joost Roset', 600, NULL, '1718', NULL, NULL, 'E', 'E', '1725-10-24', 'Batavia', '1726-01-22', '1726-02-28', true, '1726-06-19', 'Texel', 2501, NULL);
INSERT INTO "voyages" VALUES (6641, '', 4, '', 'LUCHTENBURG', 'Dirk de Vet', 800, NULL, '1715', NULL, NULL, 'H', 'A', '1725-10-24', 'Batavia', '1726-01-23', '1726-02-28', true, '1726-06-19', 'Texel', 2582, NULL);
INSERT INTO "voyages" VALUES (6642, '', 6, '', 'NOORDBEEK', 'Jan Hijpe', 858, NULL, '1707', NULL, NULL, 'Z', 'Z', '1725-10-24', 'Batavia', '1726-01-22', '1726-02-28', true, '1726-06-07', 'Rammekens', 2577, NULL);
INSERT INTO "voyages" VALUES (6643, '', 1, '', 'PETRONELLA ALIDA', 'Jan Rusteplukker', 550, NULL, '1722', NULL, NULL, 'E', 'A', '1725-10-24', 'Batavia', '1726-01-24', '1726-02-28', true, '1726-06-19', 'Texel', 2545, NULL);
INSERT INTO "voyages" VALUES (6644, '', 1, '', 'AGATHA', 'Wouter Brand', 600, NULL, '1721', NULL, NULL, 'E', 'E', '1725-11-20', 'Batavia', NULL, NULL, true, NULL, NULL, 2508, 'Lost at 31''S.');
INSERT INTO "voyages" VALUES (6645, '', 4, '', 'AMSTERDAM', 'Mijndert Schut', 800, NULL, '1716', NULL, NULL, 'A', 'A', '1725-11-20', 'Batavia', '1726-01-22', '1726-03-21', true, '1726-07-04', 'Texel', 2602, NULL);
INSERT INTO "voyages" VALUES (6646, '', 1, '', 'BLIJDORP', 'Jan Krielaard', 900, NULL, '1723', NULL, NULL, 'R', 'R', '1725-11-20', 'Batavia', '1726-01-27', '1726-03-21', true, '1726-07-05', 'Goeree', 2563, NULL);
INSERT INTO "voyages" VALUES (6647, '', 7, '', 'MUNDEN', 'Pieter Visser', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1725-11-20', 'Batavia', '1726-01-22', '1726-03-21', true, '1726-07-04', 'Texel', 2595, NULL);
INSERT INTO "voyages" VALUES (6648, '', 2, '', 'OOSTRUST', 'Laurens IJsenhart', 1140, NULL, '1721', NULL, NULL, 'A', 'A', '1725-11-20', 'Batavia', '1726-01-22', '1726-03-21', true, '1726-07-04', 'Texel', 2596, NULL);
INSERT INTO "voyages" VALUES (6649, '', 2, '', 'PATMOS', 'Gerrit van Wezel', 810, NULL, '1722', NULL, NULL, 'D', 'H', '1725-11-20', 'Batavia', '1726-01-27', '1726-03-21', true, '1726-07-04', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (6649, 'A', 2, '', 'THEODORA', 'Pieter Bellaart', 600, 'fluit', '1720', NULL, NULL, 'A', 'A', '1725-11-20', 'Batavia', NULL, NULL, true, NULL, NULL, 2575, '31''S. According to N.A. 1902 XXVI, 94 the THEODO-RA departed on 11-12-1725 from Batavia.');
INSERT INTO "voyages" VALUES (6650, '', 4, '', 'D''UNO', 'Daniel Overbeek', 250, 'fregat', '1707', NULL, NULL, 'Z', 'A', '1725-11-20', 'Batavia', '1726-01-27', '1726-03-21', true, '1726-07-04', 'Texel', 2534, NULL);
INSERT INTO "voyages" VALUES (6651, '', 4, '', 'VALKENISSE', 'Abraham Bustijn', 1150, NULL, '1716', NULL, NULL, 'Z', 'Z', '1725-11-20', 'Batavia', '1726-01-27', '1726-03-21', true, '1726-07-06', 'Rammekens', 2562, NULL);
INSERT INTO "voyages" VALUES (6652, '', 6, '', 'VOORBURG', 'Nikolaas van Langeveld', 600, NULL, '1710', NULL, NULL, 'D', 'D', '1725-11-20', 'Batavia', NULL, NULL, true, NULL, NULL, 2549, 'Lost at 31''S.');
INSERT INTO "voyages" VALUES (6653, '', 2, '', 'ZOETELINGSKERKE', 'Jakob de Vries', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1725-11-20', 'Batavia', '1726-01-27', '1726-03-21', true, '1726-07-06', 'Rammekens', 2614, NULL);
INSERT INTO "voyages" VALUES (6654, '', 2, '', 'ANNA MARIA', 'Hendrik van der Grippe', 600, NULL, '1717', NULL, NULL, 'Z', 'E', '1725-12-01', 'Batavia', '1726-01-29', '1726-03-21', true, '1726-07-04', 'Texel', 2553, NULL);
INSERT INTO "voyages" VALUES (6655, '', 3, '', 'DELFLAND', 'Pieter van Pavie', 600, 'fluit', '1717', NULL, NULL, 'D', 'D', '1725-12-01', 'Batavia', '1726-01-29', '1726-03-21', true, '1726-07-05', 'Goeree', 2603, NULL);
INSERT INTO "voyages" VALUES (6656, '', 5, '', 'HUIS TEN DONK', 'Theunis Brouisze', 650, NULL, '1711', NULL, NULL, 'R', 'R', '1725-12-01', 'Batavia', '1726-01-29', '1726-03-21', true, '1726-07-05', 'Goeree', 2601, NULL);
INSERT INTO "voyages" VALUES (6657, '', 2, '', 'PURMERLUST', 'Jakob Kooimans', 580, NULL, '1718', NULL, NULL, 'A', 'H', '1725-12-01', 'Batavia', '1726-01-29', '1726-03-21', true, '1726-07-04', 'Texel', 2512, NULL);
INSERT INTO "voyages" VALUES (6658, '', 2, '', 'CASTRICUM', 'Andries Pijl', 1150, NULL, '1722', NULL, NULL, 'A', 'A', '1725-12-04', 'Ceylon', '1726-02-18', '1726-03-21', true, '1726-07-04', 'Texel', 2592, NULL);
INSERT INTO "voyages" VALUES (6659, '', 1, '', 'KARSENHOF', 'Herman de Vrij', 800, NULL, '1723', NULL, NULL, 'A', 'A', '1725-12-04', 'Ceylon', '1726-02-18', '1726-03-21', true, '1726-07-04', 'Texel', 2590, NULL);
INSERT INTO "voyages" VALUES (6660, '', 5, '', 'MEIJENBURG', 'Christiaan Daniels', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1725-12-04', 'Ceylon', '1726-02-18', '1726-03-21', true, '1726-07-06', 'Rammekens', 2586, NULL);
INSERT INTO "voyages" VALUES (6661, '', 3, '', 'SAMARITAAN', 'Elias Moeninx', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1725-12-04', 'Ceylon', '1726-02-18', '1726-03-21', true, '1726-07-06', 'Rammekens', 2574, NULL);
INSERT INTO "voyages" VALUES (6662, '', 5, '', 'ELISABETH', 'Jan Schul', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1725-12-11', 'Batavia', '1726-01-29', '1726-03-21', true, '1726-07-04', 'Texel', 2604, NULL);
INSERT INTO "voyages" VALUES (6663, '', 1, '', 'EVERSWAART', 'Willem de Keizer', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1725-12-11', 'Batavia', '1726-01-29', '1726-03-21', true, '1726-07-06', 'Rammekens', 2613, NULL);
INSERT INTO "voyages" VALUES (6664, '', 1, '', 'HOGERSMILDE', 'Gerbrand Mamus', 810, NULL, '1723', NULL, NULL, 'A', 'A', '1725-12-11', 'Batavia', '1726-01-29', '1726-03-21', true, '1726-07-04', 'Texel', 2589, 'The master was commandeer of the return fleet.');
INSERT INTO "voyages" VALUES (6665, '', 3, '', 'GEERTRUID', 'Thomas Fletcher', 600, 'fluit', '1717', NULL, NULL, 'E', 'E', '1726-01-26', 'Batavia', '1726-05-22', '1726-06-21', true, '1726-09-29', 'Texel', 2593, NULL);
INSERT INTO "voyages" VALUES (6666, '', 2, '', 'HAFTEN', 'Hendrik van den Berg', 600, 'fluit', '1717', NULL, NULL, 'A', 'A', '1726-01-26', 'Batavia', '1726-05-22', '1726-06-21', true, '1726-10-20', 'Texel', 2585, NULL);
INSERT INTO "voyages" VALUES (6667, '', 5, '', 'KOCKENGEN', 'Matthijs Pingsternakel', 824, NULL, '1711', NULL, NULL, 'A', 'A', '1726-01-26', 'Batavia', '1726-05-22', '1726-06-21', true, '1726-09-29', 'Texel', 2611, NULL);
INSERT INTO "voyages" VALUES (6668, '', 2, '', 'NIEUWVLIET', 'Jan Boot', 650, NULL, '1719', NULL, NULL, 'Z', 'D', '1726-01-26', 'Batavia', '1726-05-22', '1726-06-21', true, '1726-09-29', 'Goeree', 2615, NULL);
INSERT INTO "voyages" VALUES (6669, '', 1, '', 'KASTEEL VAN WOERDEN', 'Jakob Bernards', 850, NULL, '1722', NULL, NULL, 'D', 'Z', '1726-01-26', 'Batavia', '1726-05-19', '1726-06-21', true, '1726-09-30', 'Veere', 2536, NULL);
INSERT INTO "voyages" VALUES (6670, '', 1, '', 'SAKSENBURG', 'Jan Bloemendaal', 610, NULL, '1723', NULL, NULL, 'A', 'A', '1726-03-26', 'Batavia', '1726-05-22', '1726-06-21', true, '1726-10-19', 'Texel', 2573, NULL);
INSERT INTO "voyages" VALUES (6671, '', 2, '', 'BAANMAN', 'Anthonie Biermans', 650, NULL, '1720', NULL, NULL, 'E', 'E', '1726-10-21', 'Batavia', '1727-01-04', '1727-02-01', true, '1726-06-24', 'Texel', 2580, NULL);
INSERT INTO "voyages" VALUES (6672, '', 3, '', 'STADHUIS VAN DELFT', 'Hendrik Zilde', 600, 'fluit', '1718', NULL, NULL, 'D', 'D', '1726-10-21', 'Batavia', '1727-01-16', '1727-02-01', true, '1727-06-25', 'Goeree', 2579, NULL);
INSERT INTO "voyages" VALUES (6673, '', 4, '', 'GOUDRIAAN', 'Willem Staalman', 600, 'fluit', '1719', NULL, NULL, 'D', 'D', '1726-10-21', 'Batavia', '1727-01-09', '1727-02-01', true, '1727-06-21', 'Goeree', 2640, NULL);
INSERT INTO "voyages" VALUES (6674, '', 5, '', 'GROENSWAART', 'Kornelis Rees', 600, 'fluit', '1714', NULL, NULL, 'R', 'R', '1726-10-21', 'Batavia', '1727-01-09', '1727-02-01', true, '1727-06-25', 'Goeree', 2641, NULL);
INSERT INTO "voyages" VALUES (6675, '', 1, '', 'LANDSKROON', 'Simon de Groot', 850, NULL, '1725', NULL, NULL, 'A', 'A', '1726-10-21', 'Batavia', '1727-01-04', '1727-02-01', true, '1727-06-24', 'Texel', 2648, NULL);
INSERT INTO "voyages" VALUES (6676, '', 3, '', 'MAGDALENA', 'Willem Verbeek', 600, NULL, '1719', NULL, NULL, 'H', 'H', '1726-10-21', 'Batavia', '1727-01-04', '1727-02-01', true, '1727-06-20', 'Texel', 2606, NULL);
INSERT INTO "voyages" VALUES (6677, '', 4, '', 'RIJKSDORP', 'Jan van Est', 792, NULL, '1713', NULL, NULL, 'A', 'A', '1726-10-21', 'Batavia', '1727-01-04', '1727-02-01', true, '1727-06-24', 'Texel', 2616, NULL);
INSERT INTO "voyages" VALUES (6678, '', 3, '', 'STADWIJK', 'Marten Hartin', 1150, NULL, '1720', NULL, NULL, 'A', 'A', '1726-10-21', 'Batavia', '1727-01-04', '1727-02-01', true, '1727-06-20', 'Texel', 2651, NULL);
INSERT INTO "voyages" VALUES (6679, '', 3, '', 'STEENHOVEN', 'Gelijn de Haas', 850, NULL, '1718', NULL, NULL, 'Z', 'Z', '1726-10-21', 'Batavia', '1727-01-04', '1727-02-01', true, '1727-06-25', 'Rammekens', 2625, NULL);
INSERT INTO "voyages" VALUES (6680, '', 3, '', 'VIS', 'Jan Schaap', 600, 'fluit', '1716', NULL, NULL, 'E', 'H', '1726-10-21', 'Batavia', '1727-01-04', '1727-02-01', true, '1727-06-20', 'Texel', 2642, NULL);
INSERT INTO "voyages" VALUES (6681, '', 1, '', 'WESTERBEEK', 'Kornelis Haringkarspel', 650, NULL, '1722', NULL, NULL, 'A', 'A', '1726-10-21', 'Batavia', '1727-01-04', '1727-02-01', true, '1727-06-25', 'Texel', 2525, NULL);
INSERT INTO "voyages" VALUES (6682, '', 6, '', 'WESTERDIJKSHORN', 'Willem de Leus', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1726-10-21', 'Batavia', '1727-01-04', '1727-02-01', true, '1727-06-25', 'Texel', 2635, NULL);
INSERT INTO "voyages" VALUES (6683, '', 1, '', 'WOLPHAARTSDIJK', 'Matthijs Burger', 660, 'fluit', '1722', NULL, NULL, 'Z', 'Z', '1726-10-21', 'Batavia', '1727-01-04', '1727-02-01', true, '1727-06-25', 'Rammekens', 2541, NULL);
INSERT INTO "voyages" VALUES (6684, '', 3, '', 'HOF NIET ALTIJD ZOMER', 'Pieter van de Roete', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1726-10-21', 'Batavia', '1727-01-04', '1727-02-01', true, '1727-06-25', 'Rammekens', 2654, NULL);
INSERT INTO "voyages" VALUES (6685, '', 4, '', 'SLOT ALDEGONDE', 'Leonard de Rijke', 1160, 'jacht', '1714', NULL, NULL, 'Z', 'A', '1726-10-23', 'Ceylon', '1727-02-05', '1727-02-26', true, '1727-06-20', 'Texel', 2599, NULL);
INSERT INTO "voyages" VALUES (6686, '', 4, '', 'BORSSELE', 'Pieter van den Berg', 800, NULL, '1715', NULL, NULL, 'Z', 'Z', '1726-11-29', 'Ceylon', '1727-02-15', '1727-03-28', true, '1727-07-14', 'Rammekens', 2638, NULL);
INSERT INTO "voyages" VALUES (6687, '', 2, '', 'HAARLEM', 'Jochem Thijssen', 850, NULL, '1720', NULL, NULL, 'A', 'A', '1726-11-29', 'Ceylon', '1727-02-15', '1727-03-28', true, '1727-07-12', 'Texel', 2647, NULL);
INSERT INTO "voyages" VALUES (6688, '', 2, '', 'HEESBURG', 'Tijmen Mol', 850, NULL, '1720', NULL, NULL, 'A', 'A', '1726-11-29', 'Ceylon', '1727-02-15', '1727-03-28', true, '1727-07-10', 'Texel', 2631, NULL);
INSERT INTO "voyages" VALUES (6689, '', 4, '', 'LINSCHOTEN', 'Adriaan van Leeuwen', 804, NULL, '1714', NULL, NULL, 'A', 'A', '1726-11-29', 'Ceylon', '1727-02-15', '1727-03-28', true, '1727-07-12', 'Texel', 2632, NULL);
INSERT INTO "voyages" VALUES (6690, '', 2, '', 'STABROEK', 'David Kleeman', 900, NULL, '1722', NULL, NULL, 'A', 'Z', '1726-11-29', 'Ceylon', '1727-02-15', '1727-03-28', true, '1727-07-14', 'Rammekens', 2624, NULL);
INSERT INTO "voyages" VALUES (6691, '', 2, '', 'BERKENRODE', 'Isaak de Haan', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1726-12-06', 'Batavia', '1727-02-12', '1727-03-28', true, '1727-07-12', 'Texel', 2644, NULL);
INSERT INTO "voyages" VALUES (6692, '', 1, '', 'CASTOR EN POLLUX', 'Jan Verschouw', 400, NULL, '1722', NULL, NULL, 'Z', 'A', '1726-12-06', 'Batavia', '1727-02-12', '1727-03-28', true, '1727-07-11', 'Texel', 2528, NULL);
INSERT INTO "voyages" VALUES (6693, '', 1, '', 'GAASPERDAM', 'Bastiaan Schul', 1150, NULL, '1724', NULL, NULL, 'A', 'A', '1726-12-06', 'Batavia', '1727-02-13', '1727-03-28', true, '1727-07-12', 'Texel', 2610, NULL);
INSERT INTO "voyages" VALUES (6694, '', 4, '', 'STAD LEIDEN', 'Hendrik Beene', 1140, NULL, '1718', NULL, NULL, 'A', 'A', '1726-12-06', 'Batavia', '1727-02-12', '1727-03-28', true, '1721-07-12', 'Texel', 2649, NULL);
INSERT INTO "voyages" VALUES (6695, '', 2, '', 'CORNELIA', 'Marinus Commerse', 800, NULL, '1721', NULL, NULL, 'H', 'A', '1726-12-16', 'Batavia', '1727-02-12', '1727-03-28', true, '1727-07-11', 'Texel', 2655, NULL);
INSERT INTO "voyages" VALUES (6696, '', 3, '', 'HEINKENSZAND', 'Jakob Jongerheld', 1150, NULL, '1720', NULL, NULL, 'Z', 'Z', '1726-12-16', 'Batavia', '1727-02-16', '1727-03-28', true, '1727-07-14', 'Rammekens', 2652, NULL);
INSERT INTO "voyages" VALUES (6697, '', 2, '', 'HERSTELLING', 'Jan Moerman', 600, NULL, '1721', NULL, NULL, 'D', 'R', '1726-12-16', 'Batavia', '1727-02-12', '1727-03-28', true, '1727-07-13', 'Goeree', 2658, NULL);
INSERT INTO "voyages" VALUES (6698, '', 3, '', 'HILLEGONDA', 'Albert Visser', 850, NULL, '1720', NULL, NULL, 'H', 'H', '1726-12-16', 'Batavia', '1727-02-12', '1727-03-28', true, '1727-07-12', 'Texel', 2659, NULL);
INSERT INTO "voyages" VALUES (6699, '', 4, '', 'SPIERING', 'Jakob van der Poel', 810, NULL, '1714', NULL, NULL, 'D', 'D', '1726-12-16', 'Batavia', '1727-02-12', '1727-03-28', true, '1727-07-13', 'Goeree', 2618, NULL);
INSERT INTO "voyages" VALUES (6700, '', 2, '', 'WICKENBURG', 'Adriaan Hijpe', 850, NULL, '1722', NULL, NULL, 'Z', 'Z', '1726-12-16', 'Batavia', '1727-02-12', '1727-03-28', true, '1727-07-14', 'Rammekens', 2656, NULL);
INSERT INTO "voyages" VALUES (6701, '', 2, '', 'ADELAAR', 'Gerrit Fiers', 810, NULL, '1722', NULL, NULL, 'Z', 'Z', '1727-02-02', 'Batavia', '1727-04-13', '1727-05-01', true, '1727-08-25', 'Rammekens', 2636, NULL);
INSERT INTO "voyages" VALUES (6702, '', 1, '', 'WAPEN VAN HOORN', 'Hendrik Jurriaansz. van Beek', 850, NULL, '1723', NULL, NULL, 'H', 'A', '1727-02-02', 'Batavia', '1727-04-13', '1727-05-01', true, '1727-08-25', 'Texel', 2581, NULL);
INSERT INTO "voyages" VALUES (6703, '', 2, '', 'LANGERODE', 'Jakob van der Swet', 600, NULL, '1723', NULL, NULL, 'D', 'D', '1727-02-02', 'Batavia', '1727-04-13', '1727-05-01', true, '1727-08-23', 'Goeree', 2643, NULL);
INSERT INTO "voyages" VALUES (6704, '', 1, '', 'SCHUITWIJK', 'Jakob Visser', 650, NULL, '1724', NULL, NULL, 'E', 'H', '1727-02-02', 'Batavia', '1727-04-13', '1727-05-01', true, '1727-08-25', 'Texel', 2626, NULL);
INSERT INTO "voyages" VALUES (6705, '', 5, '', 'HUIS DE VLOTTER', 'Klaas Zeeridder', 528, 'fluit', '1713', NULL, NULL, 'A', 'A', '1727-02-02', 'Batavia', '1727-04-13', '1727-04-28', true, '1727-08-25', 'Texel', 2621, NULL);
INSERT INTO "voyages" VALUES (6706, '', 1, '', 'PALLAS', 'Pieter Timmerman', 650, NULL, '1723', NULL, NULL, 'A', 'A', '1727-03-03', 'Batavia', '1727-06-08', '1727-06-18', true, '1727-09-29', 'Texel', 2597, NULL);
INSERT INTO "voyages" VALUES (6707, '', 2, '', 'SUSANNA', 'Adam van Ingen', 600, NULL, '1721', NULL, NULL, 'A', 'A', '1727-10-13', 'Ceylon', '1728-01-13', '1728-02-09', true, '1728-05-24', 'Texel', 2633, 'Departure from Bengal on 16-08-1727.');
INSERT INTO "voyages" VALUES (6708, '', 4, '', 'BARBESTEIN', 'Joris Vermouwe', 1100, NULL, '1717', NULL, NULL, 'Z', 'Z', '1727-10-26', 'Batavia', '1728-01-26', '1728-02-09', true, '1728-06-17', 'Rammekens', 2669, 'Commandeur of this return fleet was Everhard Kraaievanger (6708), vice-commandeur was Hendrik Thieling (6717), and schout-bij-nacht was Jan de Vos (6713).');
INSERT INTO "voyages" VALUES (6709, '', 3, '', 'CASTRICUM', 'Jan Schul', 1150, NULL, '1722', NULL, NULL, 'A', 'A', '1727-10-26', 'Batavia', '1728-01-21', '1728-02-09', true, '1728-06-10', 'Texel', 2685, NULL);
INSERT INTO "voyages" VALUES (6710, '', 3, '', 'CATS', 'Michiel van Markel', 580, NULL, '1716', NULL, NULL, 'Z', 'Z', '1727-10-26', 'Batavia', '1728-01-26', '1728-02-09', true, '1728-06-17', 'Rammekens', 2578, NULL);
INSERT INTO "voyages" VALUES (6711, '', 4, '', 'HOGENES', 'Bartholomeus Teerling', 870, NULL, '1716', NULL, NULL, 'Z', 'Z', '1727-10-26', 'Batavia', '1728-01-26', '1728-02-09', true, '1728-06-17', 'Rammekens', 2672, NULL);
INSERT INTO "voyages" VALUES (6712, '', 3, '', 'HOPVOGEL', 'Dirk de Vet', 600, 'fluit', '1714', NULL, NULL, 'A', 'E', '1727-10-26', 'Batavia', '1728-01-26', '1728-02-28', true, '1728-06-14', 'Texel', 2673, 'According to N.A. 1902, XXVI. 94 the invoice-value was 84,115.');
INSERT INTO "voyages" VALUES (6713, '', 5, '', 'TER HORST', 'Jan de Vos', 520, 'fluit', '1713', NULL, NULL, 'D', 'D', '1727-10-26', 'Batavia', '1728-01-21', '1728-02-09', true, '1728-06-14', 'Goeree', 2667, 'The master was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6714, '', 2, '', 'KETEL', 'Jakob Thoorn', 810, NULL, '1721', NULL, NULL, 'R', 'R', '1727-10-26', 'Batavia', '1728-01-26', '1728-02-09', true, '1728-06-14', 'Goeree', 2675, NULL);
INSERT INTO "voyages" VALUES (6715, '', 8, '', 'MUNDEN', 'Balthus van Santen', 1008, NULL, '1709', NULL, NULL, 'A', 'A', '1727-10-26', 'Batavia', '1728-01-26', '1728-02-09', true, '1728-06-10', 'Texel', 2688, NULL);
INSERT INTO "voyages" VALUES (6716, '', 3, '', 'PATMOS', 'Kornelis van der Kolster', 810, NULL, '1722', NULL, NULL, 'R', 'R', '1727-10-26', 'Batavia', '1728-01-21', '1728-02-09', true, '1728-06-14', 'Goeree', 2682, NULL);
INSERT INTO "voyages" VALUES (6717, '', 5, '', 'PRATTENBURG', 'Hendrik Thieling', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1727-10-26', 'Batavia', '1728-01-26', '1728-02-09', true, '1728-06-10', 'Texel', 2679, 'The master was vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6718, '', 5, '', 'STRIJKEBOLLE', 'Hendrik Schoon', 540, 'fluit', '1712', NULL, NULL, 'E', 'H', '1727-10-26', 'Batavia', '1728-01-26', '1728-02-09', true, '1728-06-10', 'Texel', 2620, NULL);
INSERT INTO "voyages" VALUES (6719, '', 3, '', 'WITSBURG', 'IJpe Engelsman', 520, 'fluit', '1714', NULL, NULL, 'E', 'E', '1727-10-26', 'Batavia', '1728-01-26', '1728-02-09', true, '1728-06-20', 'Texel', 2612, NULL);
INSERT INTO "voyages" VALUES (6720, '', 4, '', 'KOMMERRUST', 'Pieter Verley', 810, NULL, '1718', NULL, NULL, 'A', 'A', '1727-11-30', 'Batavia', '1728-03-06', '1728-04-07', true, '1728-07-24', 'Texel', 2663, NULL);
INSERT INTO "voyages" VALUES (6721, '', 3, '', 'OOSTRUST', 'Thomas Fletcher', 1140, NULL, '1721', NULL, NULL, 'A', 'A', '1727-11-30', 'Batavia', '1728-02-07', '1728-04-07', true, '1728-07-24', 'Texel', 2690, NULL);
INSERT INTO "voyages" VALUES (6722, '', 3, '', 'ZOETELINGSKERKE', 'Kornelis Fret', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1727-11-30', 'Batavia', '1728-02-14', '1728-04-07', true, '1728-07-28', 'Rammekens', 2693, NULL);
INSERT INTO "voyages" VALUES (6723, '', 3, '', 'HUIS TE ASSENBURG', 'Jan van den Broek', 800, NULL, '1718', NULL, NULL, 'A', 'A', '1727-12-07', 'Ceylon', '1728-02-14', '1728-04-07', true, '1728-07-24', 'Texel', 2668, NULL);
INSERT INTO "voyages" VALUES (6724, '', 5, '', 'JOHANNA', 'Klaas Jonker', 550, 'fluit', '1714', NULL, NULL, 'A', 'A', '1727-12-07', 'Ceylon', '1728-03-08', '1728-04-07', true, '1728-07-24', 'Texel', 2660, NULL);
INSERT INTO "voyages" VALUES (6725, '', 5, '', 'MIDDELWOUD', 'Joost Nose', 804, NULL, '1712', NULL, NULL, 'Z', 'Z', '1727-12-07', 'Ceylon', '1728-02-14', '1728-04-07', true, '1728-07-28', 'Rammekens', 2653, NULL);
INSERT INTO "voyages" VALUES (6726, '', 2, '', 'MIDLOO', 'Kornelis Oterlijk', 800, NULL, '1719', NULL, NULL, 'A', 'A', '1727-12-07', 'Ceylon', '1728-03-08', '1728-04-07', true, '1728-07-24', 'Texel', 2607, NULL);
INSERT INTO "voyages" VALUES (6727, '', 3, '', 'SLEEWIJK', 'Anthonie Klink', 520, 'jacht', '1713', NULL, NULL, 'R', 'Z', '1727-12-07', 'Ceylon', '1728-03-08', '1728-04-07', true, '1728-07-30', 'Vlie', 2505, 'der Fles was probably the master.');
INSERT INTO "voyages" VALUES (6728, '', 2, '', 'KARSENHOF', 'Jan Diephout', 800, NULL, '1723', NULL, NULL, 'A', 'A', '1727-12-16', 'Batavia', '1728-03-06', '1728-04-07', true, '1728-07-24', 'Texel', 2674, NULL);
INSERT INTO "voyages" VALUES (6729, '', 2, '', 'WESTFRIESLAND', 'Jan Almees', 370, 'jacht', '1722', NULL, NULL, 'H', 'Z', '1727-12-16', 'Batavia', '1728-02-14', '1728-04-07', true, '1728-07-28', 'Rammekens', 2629, NULL);
INSERT INTO "voyages" VALUES (6730, '', 1, '', 'LAND VAN BELOFTEN', 'Hendrik van den Berg', 520, NULL, '1723', NULL, NULL, 'E', 'E', '1728-02-03', 'Batavia', '1728-04-28', '1728-05-17', true, '1728-08-22', 'Texel', 2591, NULL);
INSERT INTO "voyages" VALUES (6731, '', 3, '', 'JACOBA', 'Jan van der Heiden', 805, NULL, '1721', NULL, NULL, 'A', 'A', '1728-02-03', 'Batavia', '1728-04-21', '1728-05-17', true, '1728-08-21', 'Texel', 2662, NULL);
INSERT INTO "voyages" VALUES (6732, '', 3, '', 'LOENDERVEEN', 'Matthijs Zwaan', 650, 'fluit', '1718', NULL, NULL, 'A', 'D', '1728-02-03', 'Batavia', '1728-04-25', '1728-05-17', true, '1728-08-22', 'Goeree', 2594, NULL);
INSERT INTO "voyages" VALUES (6733, '', 1, '', 'HOF NIET ALTIJD WINTER', 'Abraham van den Busse', 650, NULL, '1723', NULL, NULL, 'Z', 'Z', '1728-02-03', 'Batavia', '1728-04-30', '1728-05-17', true, '1728-08-21', 'Rammekens', 2587, NULL);
INSERT INTO "voyages" VALUES (6734, '', 1, '', 'MEERLUST', 'Pieter Scherf', 600, NULL, '1725', NULL, NULL, 'A', 'A', '1728-04-02', 'Batavia', '1728-06-22', '1728-07-15', true, '1728-11-19', 'Texel', 2664, NULL);
INSERT INTO "voyages" VALUES (6735, '', 2, '', 'BLUDORP', 'Isaak Hage', 900, NULL, '1723', NULL, NULL, 'R', 'R', '1728-11-01', 'Batavia', '1729-01-14', '1729-02-04', true, '1729-06-28', 'Goeree', 2666, 'schout-bij-nacht was Kornelis de Ruiter (6737).');
INSERT INTO "voyages" VALUES (6736, '', 3, '', 'CORNELIA', 'Pieter Timmerman', 800, NULL, '1721', NULL, NULL, 'H', 'H', '1728-11-01', 'Batavia', '1729-01-14', '1729-02-04', true, '1729-06-26', 'Texel', 2718, NULL);
INSERT INTO "voyages" VALUES (6737, '', 4, '', 'DEN DAM', 'Kornelis de Ruiter', 600, 'fluit', '1716', NULL, NULL, 'D', 'D', '1728-11-01', 'Batavia', '1729-01-14', '1729-02-04', true, '1729-06-26', 'Goeree', 2704, NULL);
INSERT INTO "voyages" VALUES (6738, '', 2, '', 'GAASPERDAM', 'Willem van Ginkel', 1150, NULL, '1724', NULL, NULL, 'A', 'A', '1728-11-01', 'Batavia', '1729-01-14', '1729-02-04', true, '1729-06-26', 'Texel', 2721, NULL);
INSERT INTO "voyages" VALUES (6739, '', 3, '', 'HAFTEN', 'Hendrik Smit', 600, 'fluit', '1717', NULL, NULL, 'A', 'A', '1728-11-01', 'Batavia', '1729-01-14', '1729-02-04', true, '1729-06-26', 'Goeree', 2706, NULL);
INSERT INTO "voyages" VALUES (6740, '', 3, '', 'NOORDWADDINXVEEN', 'Jan Krielaard', 850, NULL, '1718', NULL, NULL, 'R', 'E', '1728-11-01', 'Batavia', '1729-01-14', '1729-02-04', true, '1729-06-26', 'Texel', 2657, NULL);
INSERT INTO "voyages" VALUES (6741, '', 1, '', 'LAGE POLDER', 'Hendrik Vegt', 580, NULL, '1725', NULL, NULL, 'E', 'E', '1728-11-01', 'Batavia', '1729-01-14', '1729-02-04', true, '1729-06-26', 'Texel', 2678, NULL);
INSERT INTO "voyages" VALUES (6742, '', 5, '', 'VALKENISSE', 'Gerrit Stokke', 1150, NULL, '1716', NULL, NULL, 'Z', 'Z', '1728-11-01', 'Batavia', '1729-01-14', '1729-02-04', true, '1729-06-26', 'Rammekens', 2697, NULL);
INSERT INTO "voyages" VALUES (6743, '', 2, '', 'WESTERBEEK', 'Herman de Vrij', 650, NULL, '1722', NULL, NULL, 'A', 'A', '1728-11-01', 'Batavia', '1729-01-14', '1729-02-04', true, '1729-06-26', 'Texel', 2712, NULL);
INSERT INTO "voyages" VALUES (6744, '', 7, '', 'WESTERDIJKSHORN', 'Jan de Haan', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1728-11-01', 'Batavia', '1729-01-14', '1729-02-04', true, '1729-06-26', 'Texel', 2713, NULL);
INSERT INTO "voyages" VALUES (6745, '', 3, '', 'WICKENBURG', 'Jakob de Vries', 850, NULL, '1722', NULL, NULL, 'Z', 'Z', '1728-11-01', 'Batavia', '1729-01-14', '1729-02-04', true, '1729-06-26', 'Rammekens', 2714, NULL);
INSERT INTO "voyages" VALUES (6746, '', 1, '', 'BEEKVLIET', 'Pieter Knollendam', 850, NULL, '1719', NULL, NULL, 'A', 'A', '1728-12-05', 'Ceylon', '1729-02-16', '1729-03-22', true, '1729-07-29', 'Texel', 2627, NULL);
INSERT INTO "voyages" VALUES (6747, '', 6, '', 'ELISABETH', 'Jakob Kooimans', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1728-12-05', 'Ceylon', '1729-02-18', '1729-03-22', true, '1729-07-29', 'Texel', 2701, NULL);
INSERT INTO "voyages" VALUES (6748, '', 2, '', 'EVERSWAART', 'Dirk de Visser', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1728-12-05', 'Ceylon', '1729-02-19', '1729-03-22', true, '1729-07-30', 'Rammekens', 2671, NULL);
INSERT INTO "voyages" VALUES (6749, '', 1, '', 'KNAPENBURG', 'Pieter Tinnekes', 900, NULL, '1727', NULL, NULL, 'A', 'A', '1728-12-05', 'Ceylon', '1729-02-17', '1729-03-22', true, '1729-07-26', 'Texel', 2727, NULL);
INSERT INTO "voyages" VALUES (6750, '', 2, '', 'HOGERSMILDE', 'Daniel Overbeek', 810, NULL, '1723', NULL, NULL, 'A', 'A', '1728-12-09', 'Batavia', '1729-02-24', '1729-03-22', true, '1729-07-30', 'Texel', 2686, NULL);
INSERT INTO "voyages" VALUES (6751, '', 2, '', 'KLARABEEK', 'Pieter Kronenburg', 705, NULL, '1721', NULL, NULL, 'Z', 'Z', '1728-12-09', 'Ceylon', '1729-02-19', '1729-03-22', true, '1729-07-30', 'Rammekens', 2628, NULL);
INSERT INTO "voyages" VALUES (6752, '', 2, '', 'LANDSKROON', 'Willem Verbeek', 850, NULL, '1725', NULL, NULL, 'A', 'A', '1728-12-09', 'Batavia', '1729-02-19', '1729-03-22', true, '1729-07-30', 'Texel', 2708, NULL);
INSERT INTO "voyages" VALUES (6753, '', 6, '', 'MEIJENBURG', 'Hendrik van der Grippe', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1728-12-09', 'Batavia', '1729-02-24', '1729-03-22', true, '1729-07-30', 'Rammekens', 2723, NULL);
INSERT INTO "voyages" VALUES (6754, '', 2, '', 'WINDHOND', 'Hendrik Klooster', 370, NULL, '1722', NULL, NULL, 'A', 'Z', '1728-12-09', 'Batavia', '1729-02-24', '1729-03-22', true, '1729-07-30', 'Rammekens', 2665, NULL);
INSERT INTO "voyages" VALUES (6755, '', 2, '', '''S GRAVELAND', 'Gideon Kuiper', 600, NULL, '1722', NULL, NULL, 'A', 'A', '1729-02-03', 'Batavia', '1729-05-11', '1729-06-18', true, NULL, NULL, 2646, 'Wrecked on its way to patria.');
INSERT INTO "voyages" VALUES (6756, '', 3, '', 'HAAKSBURG', 'Klaas Goethoen', 600, NULL, '1718', NULL, NULL, 'E', 'E', '1729-02-03', 'Batavia', '1729-06-03', '1729-06-18', true, '1729-10-13', 'Texel', 2699, NULL);
INSERT INTO "voyages" VALUES (6757, '', 2, '', 'KROOSWIJK', 'Paulus Tideman', 600, 'fluit', '1720', NULL, NULL, 'R', 'D', '1729-02-03', 'Batavia', '1729-06-03', '1729-06-18', true, '1729-10-13', 'Goeree', 2687, NULL);
INSERT INTO "voyages" VALUES (6758, '', 4, '', 'VLISSINGEN', 'Jonas Mierman', 600, 'fluit', '1714', NULL, NULL, 'Z', 'Z', '1729-02-03', 'Batavia', '1729-06-03', '1729-06-18', true, '1729-10-09', 'Rammekens', 2540, NULL);
INSERT INTO "voyages" VALUES (6759, '', 3, '', 'PURMERLUST', 'Michiel de Reus', 580, NULL, '1718', NULL, NULL, 'A', 'A', '1729-02-28', 'Batavia', '1729-06-01', '1729-06-18', true, '1729-10-09', 'Texel', 2710, NULL);
INSERT INTO "voyages" VALUES (6760, '', 1, '', 'REIGERSBROEK', 'Hendrik Smit', 600, NULL, '1726', NULL, NULL, 'A', 'A', '1729-03-31', 'Batavia', '1729-07-01', '1729-07-10', true, '1729-10-25', 'Texel', 2691, NULL);
INSERT INTO "voyages" VALUES (6761, '', 1, '', 'RIDDERKERK', 'Jan de Graaf', 500, NULL, '1726', NULL, NULL, 'R', 'A', '1729-07-19', 'Batavia', '1729-10-02', '1729-10-12', true, '1730-01-04', 'Texel', 2695, NULL);
INSERT INTO "voyages" VALUES (6762, '', 4, '', 'CASTRICUM', 'Willem de Smit', 1150, NULL, '1722', NULL, NULL, 'A', 'A', '1729-10-02', 'Batavia', '1729-12-06', '1730-02-05', true, '1730-05-20', 'Texel', 2745, NULL);
INSERT INTO "voyages" VALUES (6763, '', 4, '', 'GEERTRUID', 'Evert de Bruin', 600, 'fluit', '1717', NULL, NULL, 'E', 'E', '1729-10-02', 'Batavia', '1730-01-27', '1730-02-05', true, '1730-05-20', 'Texel', 2715, 'Commandeur on the return fleet was Willem de Smit (6762).');
INSERT INTO "voyages" VALUES (6764, '', 6, '', 'GROENSWAART', 'Kornelis Rees', 600, 'fluit', '1714', NULL, NULL, 'R', 'R', '1729-10-02', 'Batavia', '1729-12-06', '1730-02-05', true, '1730-05-20', 'Goeree', 2732, NULL);
INSERT INTO "voyages" VALUES (6765, '', 4, '', 'HILLEGONDA', 'Albert Visser', 850, NULL, '1720', NULL, NULL, 'H', 'H', '1729-10-02', 'Batavia', '1729-12-05', '1730-02-05', true, '1730-05-20', 'Goeree', 2719, NULL);
INSERT INTO "voyages" VALUES (6766, '', 3, '', 'LANGERODE', 'Kornelis van der Kolster', 600, NULL, '1723', NULL, NULL, 'D', 'D', '1729-10-02', 'Batavia', '1729-12-06', '1730-02-05', true, '1730-05-20', 'Goeree', 2750, NULL);
INSERT INTO "voyages" VALUES (6767, '', 5, '', 'STAD LEIDEN', 'Pieter Thomas van Dijk', 1140, NULL, '1718', NULL, NULL, 'A', 'A', '1729-10-02', 'Batavia', '1729-12-06', '1730-02-05', true, '1730-05-30', 'Texel', 2744, NULL);
INSERT INTO "voyages" VALUES (6768, '', 4, '', 'MAGDALENA', 'Klaas Zeeridder', 600, NULL, '1719', NULL, NULL, 'H', 'H', '1729-10-02', 'Batavia', '1729-12-06', '1730-02-05', true, '1730-05-20', 'Texel', 2754, NULL);
INSERT INTO "voyages" VALUES (6769, '', 5, '', 'SPIERING', 'Samuel Hoppestijn', 810, NULL, '1714', NULL, NULL, 'D', 'D', '1729-10-02', 'Batavia', '1729-12-06', '1730-02-05', true, '1730-05-20', 'Goeree', 2733, NULL);
INSERT INTO "voyages" VALUES (6770, '', 4, '', 'STEENHOVEN', 'Willem Huigen', 850, NULL, '1718', NULL, NULL, 'Z', 'Z', '1729-10-02', 'Batavia', '1729-12-06', '1730-02-05', true, '1730-05-20', 'Rammekens', 2725, NULL);
INSERT INTO "voyages" VALUES (6771, '', 2, '', 'WOLPHAARTSDIJK', 'Jakob Jongerheld', 660, NULL, '1722', NULL, NULL, 'Z', 'Z', '1729-10-02', 'Batavia', '1729-12-06', '1730-02-05', true, '1730-05-20', 'Rammekens', 2734, NULL);
INSERT INTO "voyages" VALUES (6772, '', 4, '', 'STADWIJK', 'Gelijn de Haas', 1150, NULL, '1720', NULL, NULL, 'A', 'A', '1729-11-07', 'Batavia', '1730-01-27', '1730-02-05', true, '1730-05-20', 'Texel', 2738, NULL);
INSERT INTO "voyages" VALUES (6773, '', 1, '', 'OOSTRUST', 'Pieter Verley', 1140, NULL, '1721', NULL, NULL, 'A', 'A', '1729-12-01', 'Batavia', '1730-03-13', '1730-04-03', true, '1730-07-25', 'Texel', 2762, NULL);
INSERT INTO "voyages" VALUES (6774, '', 6, '', 'PRATTENBURG', 'Jan Verschouw', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1729-12-01', 'Batavia', '1730-03-13', '1730-04-03', true, '1730-07-25', 'Texel', 2763, NULL);
INSERT INTO "voyages" VALUES (6775, '', 1, '', 'SPIERINGSHOEK', 'Paulus Erasmus', 450, 'jacht', '1724', NULL, NULL, 'D', 'A', '1729-12-01', 'Batavia', '1730-03-17', '1730-04-03', true, '1730-07-25', 'Texel', 2619, NULL);
INSERT INTO "voyages" VALUES (6776, '', 4, '', 'ZOETELINGSKERKE', 'Gerrit Fiers', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1729-12-01', 'Batavia', '1730-03-15', '1730-04-03', true, '1730-07-27', 'Rammekens', 2767, NULL);
INSERT INTO "voyages" VALUES (6777, '', 5, '', 'RIJKSDORP', 'Jurriaan Popta', 792, NULL, '1713', NULL, NULL, 'A', 'A', '1729-12-16', 'Ceylon', '1730-03-18', '1730-04-03', true, '1730-07-21', 'Texel', 2737, NULL);
INSERT INTO "voyages" VALUES (6778, '', 1, '', '''S HEER ARENDSKERKE', 'Pieter Groothuis', 600, NULL, '1724', NULL, NULL, 'Z', 'Z', '1729-12-18', 'Batavia', '1730-03-18', '1730-04-03', true, '1730-07-27', 'Rammekens', 2637, NULL);
INSERT INTO "voyages" VALUES (6779, '', 3, '', 'BERKENRODE', 'Lodewijk Verburg', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1729-12-19', 'Ceylon', '1730-03-18', '1730-04-03', true, '1730-07-21', 'Texel', 2717, NULL);
INSERT INTO "voyages" VALUES (6780, '', 6, '', 'HUIS TEN DONK', 'Arie Brouwer', 650, NULL, '1711', NULL, NULL, 'R', 'A', '1729-12-19', 'Ceylon', '1730-03-18', '1730-04-03', true, '1730-07-27', 'Texel', 2705, NULL);
INSERT INTO "voyages" VALUES (6781, '', 4, '', 'HEINKENSZAND', 'Nikolaas Anderson', 1150, NULL, '1720', NULL, NULL, 'Z', 'Z', '1729-12-19', 'Ceylon', '1730-03-18', '1730-04-03', true, '1730-07-21', 'Rammekens', 2741, NULL);
INSERT INTO "voyages" VALUES (6782, '', 3, '', 'NIEUWVLIET', 'Kornelis Lans', 650, NULL, '1719', NULL, NULL, 'Z', 'Z', '1729-12-19', 'Ceylon', '1730-03-18', '1730-04-03', true, '1730-07-21', 'Rammekens', 2716, NULL);
INSERT INTO "voyages" VALUES (6783, '', 1, '', 'COXHOORN', 'Jan Schul', 450, NULL, '1728', NULL, NULL, 'A', 'A', '1730-01-07', 'China', '1730-03-29', '1730-04-23', true, '1730-07-13', 'Texel', 2755, NULL);
INSERT INTO "voyages" VALUES (6784, '', 5, '', 'SLOT ALDEGONDE', 'Pieter van Genechten', 580, 'jacht', '1714', NULL, NULL, 'Z', 'Z', '1730-01-31', 'Batavia', '1730-06-11', '1730-07-04', true, '1730-10-31', 'Rammekens', 2743, NULL);
INSERT INTO "voyages" VALUES (6785, '', 2, '', 'WAPEN VAN HOORN', 'Hendrik Schadee', 850, NULL, '1723', NULL, NULL, 'H', 'H', '1730-01-31', 'Batavia', '1730-05-29', '1730-07-04', true, '1730-10-31', 'Texel', 2736, NULL);
INSERT INTO "voyages" VALUES (6786, '', 4, '', 'JACOBA', 'Hendrik van den Berg', 805, NULL, '1721', NULL, NULL, 'A', 'A', '1730-01-31', 'Batavia', '1730-06-03', '1730-07-04', true, '1730-10-31', 'Texel', 2761, NULL);
INSERT INTO "voyages" VALUES (6787, '', 6, '', 'HUIS DE VLOTTER', 'Jan Molentijn', 528, 'fluit', '1713', NULL, NULL, 'A', 'A', '1730-01-31', 'Batavia', '1730-05-28', '1730-07-04', true, '1730-10-31', 'Texel', 2746, NULL);
INSERT INTO "voyages" VALUES (6788, '', 2, '', 'KASTEEL VAN WOERDEN', 'den Berg', 850, NULL, '1722', NULL, NULL, 'D', 'D', '1730-01-31', 'Batavia', '1730-06-16', '1730-07-04', true, '1730-10-31', 'Goeree', 2698, NULL);
INSERT INTO "voyages" VALUES (6789, '', 2, '', 'PALLAS', 'Isaak Rombouts', 650, NULL, '1723', NULL, NULL, 'A', 'A', '1730-02-14', 'Batavia', '1730-06-12', '1730-07-04', true, '1730-10-31', 'Texel', 2752, NULL);
INSERT INTO "voyages" VALUES (6790, '', 2, '', 'SCHUITWIJK', 'Dirk de Vet', 650, NULL, '1724', NULL, NULL, 'E', 'Z', '1730-03-01', 'Batavia', '1730-06-12', '1730-07-04', true, '1730-10-31', 'Rammekens', 2759, NULL);
INSERT INTO "voyages" VALUES (6791, '', 3, '', 'HERSTELLING', 'Jan van der Quade', 600, NULL, '1721', NULL, NULL, 'D', 'R', '1730-03-23', 'Batavia', '1730-06-01', '1730-07-04', true, '1730-10-31', 'Texel', 2749, NULL);
INSERT INTO "voyages" VALUES (6792, '', 5, '', 'AMSTERDAM', 'Frans van der Hoop', 800, NULL, '1716', NULL, NULL, 'A', 'A', '1730-10-17', 'Batavia', '1731-01-19', '1731-02-21', true, '1731-07-13', 'Texel', 2700, 'Commandeur of the return fleet was W illem ter Smitten (6801).');
INSERT INTO "voyages" VALUES (6793, '', 1, '', 'ANNA CATHARINA', 'Adriaan Krijnsen', 600, NULL, '1728', NULL, NULL, 'Z', 'Z', '1730-10-17', 'Batavia', '1731-01-18', '1731-02-21', true, '1731-07-13', 'Rammekens', 2778, NULL);
INSERT INTO "voyages" VALUES (6794, '', 5, '', 'BARBESTEIN', 'Anthonie Klink', 1100, NULL, '1717', NULL, NULL, 'Z', 'Z', '1730-10-17', 'Batavia', '1731-01-18', '1731-02-21', true, '1731-07-13', 'Rammekens', 2772, NULL);
INSERT INTO "voyages" VALUES (6795, '', 2, '', 'CASTOR EN POLLUX', 'Pieter Sluis', 400, 'jacht', '1722', NULL, NULL, 'Z', 'A', '1730-10-17', 'Batavia', '1731-01-19', '1731-02-21', true, '1731-07-13', 'Texel', 2720, NULL);
INSERT INTO "voyages" VALUES (6796, '', 4, '', 'CORNELIA', 'Jan Pereboom', 800, NULL, '1721', NULL, NULL, 'H', 'H', '1730-10-17', 'Batavia', '1731-01-14', '1731-02-21', true, '1731-07-13', 'Texel', 2789, NULL);
INSERT INTO "voyages" VALUES (6797, '', 7, '', 'ELISABETH', 'Mijndert Schut', 1140, NULL, '1714', NULL, NULL, 'A', 'A', '1730-10-17', 'Batavia', '1731-01-19', '1731-02-21', true, '1731-07-13', 'Texel', 2794, NULL);
INSERT INTO "voyages" VALUES (6798, '', 4, '', 'GOUDRIAAN', 'Adriaan van Dorp', 630, 'fluit', '1719', NULL, NULL, 'D', 'D', '1730-10-17', 'Batavia', '1731-01-18', '1731-02-21', true, '1731-07-13', 'Goeree', 2768, NULL);
INSERT INTO "voyages" VALUES (6799, '', 3, '', 'KETEL', 'Jan Hokkeling', 810, NULL, '1721', NULL, NULL, 'R', 'R', '1730-10-17', 'Batavia', '1731-01-18', '1731-02-21', true, '1731-07-13', 'Goeree', 2781, NULL);
INSERT INTO "voyages" VALUES (6800, '', 2, '', 'PETRONELLA ALIDA', 'Kornelis Klaasz.', 550, NULL, '1722', NULL, NULL, 'E', 'E', '1730-10-17', 'Batavia', '1731-01-19', '1731-02-21', true, '1731-07-13', 'Texel', 2677, NULL);
INSERT INTO "voyages" VALUES (6801, '', 8, '', 'WESTERDIJKSHORN', 'Adriaan de Raad', 1150, NULL, '1713', NULL, NULL, 'A', 'A', '1730-10-17', 'Batavia', '1731-01-18', '1731-02-21', true, '1731-07-13', 'Texel', 2788, NULL);
INSERT INTO "voyages" VALUES (6802, '', 1, '', 'ADRICHEM', 'Groot', 850, NULL, '1726', NULL, NULL, 'A', 'A', '1730-12-01', 'Batavia', '1731-03-13', '1731-04-11', true, '1731-07-30', 'Texel', 2684, 'Commandeur of this return fleet was Pieter Reinierse Thoren (6804).');
INSERT INTO "voyages" VALUES (6803, '', 1, '', 'ALBLASSERDAM', 'Herman Brand', 600, NULL, '1725', NULL, NULL, 'D', 'Z', '1730-12-01', 'Batavia', '1731-03-22', '1731-04-11', true, '1731-07-30', 'Rammekens', 2694, NULL);
INSERT INTO "voyages" VALUES (6804, '', 1, '', 'BEEKVLIET', 'Hendrik Klooster', 850, NULL, '1724', NULL, NULL, 'A', 'A', '1730-12-01', 'Batavia', '1731-03-22', '1731-04-11', true, '1731-07-30', 'Texel', 2793, NULL);
INSERT INTO "voyages" VALUES (6805, '', 3, '', 'EVERSWAART', 'Pieter Obry', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1730-12-01', 'Batavia', '1731-03-22', '1731-04-11', true, '1731-07-30', 'Rammekens', 2803, NULL);
INSERT INTO "voyages" VALUES (6806, '', 3, '', 'KARSENHOF', 'Adam van Ingen', 800, NULL, '1723', NULL, NULL, 'A', 'A', '1730-12-01', 'Batavia', '1731-02-27', '1731-04-11', true, '1731-07-30', 'Texel', 2756, NULL);
INSERT INTO "voyages" VALUES (6807, '', 3, '', 'SUSANNA', 'Joris Davidson', 600, NULL, '1721', NULL, NULL, 'A', 'A', '1730-12-01', 'Batavia', '1731-03-21', '1731-04-11', true, '1731-07-30', 'Texel', 2753, NULL);
INSERT INTO "voyages" VALUES (6808, '', 3, '', 'GAASPERDAM', 'Joris van Kleef', 1150, NULL, '1724', NULL, NULL, 'A', 'A', '1730-12-09', 'Ceylon', '1731-03-21', '1731-04-11', true, '1731-07-30', 'Texel', 2784, NULL);
INSERT INTO "voyages" VALUES (6809, '', 1, '', 'SLOT TER HOGE', 'Jan van Est', 850, NULL, '1726', NULL, NULL, 'Z', 'Z', '1730-12-09', 'Ceylon', '1731-03-02', '1731-04-11', true, '1731-07-30', 'Rammekens', 2707, NULL);
INSERT INTO "voyages" VALUES (6810, '', 5, '', 'KOMMERRUST', 'Levinus de Heere', 810, NULL, '1718', NULL, NULL, 'A', 'A', '1730-12-09', 'Ceylon', '1731-03-21', '1731-04-11', true, '1731-07-30', 'Texel', 2770, NULL);
INSERT INTO "voyages" VALUES (6811, '', 7, '', 'MEIJENBURG', 'Barend van der Zalm', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1730-12-09', 'Ceylon', '1731-02-27', '1731-04-11', true, '1731-07-30', 'Rammekens', 2790, NULL);
INSERT INTO "voyages" VALUES (6812, '', 1, '', 'DUIFJE', 'Huig Goedhart', 450, NULL, '1729', NULL, NULL, 'A', 'A', '1731-01-03', 'China', '1731-04-06', '1731-04-15', true, '1731-07-27', 'Texel', 2783, NULL);
INSERT INTO "voyages" VALUES (6813, '', 5, '', 'DEN DAM', 'Kornelis de Ruiter', 600, NULL, '1716', NULL, NULL, 'D', 'Z', '1731-02-02', 'Batavia', '1731-04-26', '1731-05-14', true, '1731-08-27', 'Rammekens', 2801, NULL);
INSERT INTO "voyages" VALUES (6814, '', 4, '', 'LOENDERVEEN', 'Jakob van der Swet', 650, 'fluit', '1718', NULL, NULL, 'A', 'A', '1731-02-02', 'Batavia', '1731-04-26', '1731-05-14', true, '1731-08-27', 'Texel', 2800, NULL);
INSERT INTO "voyages" VALUES (6815, '', 2, '', 'REIGERSBROEK', 'Jakob van der Beek', 600, NULL, '1726', NULL, NULL, 'A', 'A', '1731-03-02', 'Batavia', '1731-07-24', '1731-08-08', true, '1731-11-16', 'Texel', 2804, NULL);
INSERT INTO "voyages" VALUES (6816, '', 4, '', 'BERKENRODE', 'Jurriaan Popta', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1731-10-13', 'Batavia', '1731-12-28', '1732-02-02', true, '1732-06-18', 'Texel', 2827, 'Commandeur of this return fleet was Isaak Hage (6817).');
INSERT INTO "voyages" VALUES (6817, '', 5, '', 'CASTRICUM', 'Isaak Hage', 1150, NULL, '1722', NULL, NULL, 'A', 'A', '1731-10-13', 'Batavia', '1731-12-28', '1732-02-02', true, '1732-06-18', 'Texel', 2815, NULL);
INSERT INTO "voyages" VALUES (6818, '', 1, '', 'FLORA', 'Daniel Overbeek', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1731-10-13', 'Batavia', '1731-12-28', '1732-02-02', true, '1732-06-18', 'Texel', 2819, NULL);
INSERT INTO "voyages" VALUES (6819, '', 4, '', 'HAAKSBURG', 'Michiel de Reus', 600, NULL, '1718', NULL, NULL, 'E', 'R', '1731-10-13', 'Batavia', '1731-12-28', '1732-02-02', true, '1732-06-30', 'Goeree', 2810, NULL);
INSERT INTO "voyages" VALUES (6820, '', 3, '', 'HEESBURG', 'Jan de Marre', 850, NULL, '1720', NULL, NULL, 'A', 'Z', '1731-10-13', 'Batavia', '1731-12-28', '1732-02-02', true, '1732-06-18', 'Rammekens', 2735, NULL);
INSERT INTO "voyages" VALUES (6821, '', 5, '', 'MAGDALENA', 'Gerrit Kuit', 600, NULL, '1719', NULL, NULL, 'H', 'D', '1731-10-13', 'Batavia', '1731-12-28', '1732-02-02', true, '1732-06-18', 'Goeree', 2814, NULL);
INSERT INTO "voyages" VALUES (6822, '', 4, '', 'OPPERDOES', 'Jan de Haan', 600, 'fluit', '1718', NULL, NULL, 'H', 'H', '1731-10-13', 'Batavia', '1731-12-28', '1732-02-02', true, '1732-06-27', 'Texel', 2639, 'Invoice value according to KA 2697 3-3-1733.');
INSERT INTO "voyages" VALUES (6823, '', 7, '', 'PRATTENBURG', 'Hendrik Smit', 1150, NULL, '1715', NULL, NULL, 'A', 'A', '1731-10-13', 'Batavia', '1731-12-28', '1732-02-02', true, '1732-05-23', 'Texel', 2831, NULL);
INSERT INTO "voyages" VALUES (6824, '', 4, '', 'VIS', 'Jan Almees', 600, 'fluit', '1716', NULL, NULL, 'E', 'E', '1731-10-13', 'Batavia', '1731-12-28', '1732-02-02', true, '1732-06-18', 'Texel', 2739, NULL);
INSERT INTO "voyages" VALUES (6825, '', 5, '', 'ZOETELINGSKERKE', 'Gerrit van Wezel', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1731-10-13', 'Batavia', '1731-12-28', '1732-02-02', true, '1732-06-18', 'Rammekens', 2826, NULL);
INSERT INTO "voyages" VALUES (6826, '', 5, '', 'HILLEGONDA', 'Albert Visser', 850, NULL, '1720', NULL, NULL, 'H', 'Z', '1731-11-30', 'Batavia', '1732-02-06', '1732-04-02', true, '1732-07-15', 'Rammekens', 2832, NULL);
INSERT INTO "voyages" VALUES (6827, '', 6, '', 'STAD LEIDEN', 'Lambert Zwaan', 1140, NULL, '1718', NULL, NULL, 'A', 'A', '1731-11-30', 'Batavia', '1732-02-06', '1732-04-02', true, '1732-07-15', 'Texel', 2829, NULL);
INSERT INTO "voyages" VALUES (6828, '', 6, '', 'SPIERING', 'Kornelis van der Kolster', 810, NULL, '1714', NULL, NULL, 'D', 'A', '1731-11-30', 'Batavia', '1732-02-06', '1732-04-02', true, '1732-07-15', 'Texel', 2836, NULL);
INSERT INTO "voyages" VALUES (6829, '', 1, '', 'DUINBEEK', 'Marinus Commerse', 800, NULL, '1727', NULL, NULL, 'Z', 'A', '1731-12-05', 'Ceylon', '1732-02-29', '1732-04-02', true, '1732-07-15', 'Texel', 2748, 'The invoice value from the chamber of Zeeland according to K.A 269, 3-3-1733.');
INSERT INTO "voyages" VALUES (6830, '', 3, '', 'HOGERSMILDE', 'Pieter Timmerman', 810, NULL, '1723', NULL, NULL, 'A', 'A', '1731-12-05', 'Ceylon', '1732-03-02', '1732-04-02', true, '1732-07-15', 'Texel', 2795, NULL);
INSERT INTO "voyages" VALUES (6831, '', 1, '', 'PAPENBURG', 'Kornelis Brouw', 800, NULL, '1729', NULL, NULL, 'A', 'A', '1731-12-05', 'Ceylon', '1732-03-02', '1732-04-02', true, '1732-07-15', 'Texel', 2785, 'Invoice value according to K.A. 269, 3-3-1733.');
INSERT INTO "voyages" VALUES (6832, '', 6, '', 'VALKENISSE', 'Adriaan van der Graaf', 1150, NULL, '1716', NULL, NULL, 'Z', 'Z', '1731-12-05', 'Ceylon', '1732-03-02', '1732-04-02', true, '1732-07-15', 'Rammekens', 2807, NULL);
INSERT INTO "voyages" VALUES (6833, '', 4, '', 'NIEUWVLIET', 'Gerrit Fiers', 650, NULL, '1719', NULL, NULL, 'Z', 'Z', '1731-12-13', 'China', '1732-03-12', '1732-03-26', true, '1732-06-24', 'Rammekens', 2823, 'See 6831.');
INSERT INTO "voyages" VALUES (6834, '', 2, '', 'COXHOORN', 'Gerrit Pik', 450, NULL, '1728', NULL, NULL, 'A', 'A', '1731-12-26', 'China', '1732-04-11', '1732-05-02', true, '1732-08-03', 'Texel', 2818, 'See 6831.');
INSERT INTO "voyages" VALUES (6835, '', 1, '', 'LEIDUIN', 'Jan Reebok', 650, NULL, '1730', NULL, NULL, 'A', 'A', '1731-12-26', 'China', '1732-04-11', '1732-05-02', true, '1732-08-03', 'Texel', 2822, 'See 6831.');
INSERT INTO "voyages" VALUES (6836, '', 7, '', 'GROENSWAART', 'Jan van der Quade', 600, 'fluit', '1714', NULL, NULL, 'R', 'Z', '1732-01-01', 'Batavia', '1732-04-22', '1732-05-24', true, '1732-10-02', 'Texel', 2834, NULL);
INSERT INTO "voyages" VALUES (6837, '', 3, '', 'MIDLOO', 'Pieter Tinnekens', 800, NULL, '1719', NULL, NULL, 'A', 'A', '1732-01-01', 'Batavia', '1732-05-08', '1732-05-24', true, NULL, NULL, 2776, 'Wrecked at Terschelling on 28-09-1732');
INSERT INTO "voyages" VALUES (6838, '', 4, '', 'NOORDWADDINXVEEN', 'Hendrik Beene', 850, NULL, '1718', NULL, NULL, 'R', 'R', '1732-01-01', 'Batavia', '1732-04-27', '1732-05-24', true, '1732-09-07', 'Goeree', 2811, NULL);
INSERT INTO "voyages" VALUES (6839, '', 2, '', 'LAGE POLDER', 'Dirk Dol', 580, NULL, '1725', NULL, NULL, 'E', 'E', '1732-01-01', 'Batavia', '1732-05-01', '1732-05-24', true, '1732-09-25', 'Texel', 2798, NULL);
INSERT INTO "voyages" VALUES (6840, '', 3, '', 'BLIJDORP', 'Huibert Haringvanger', 900, 'fluit', '1723', NULL, NULL, 'R', 'A', '1732-02-14', 'Batavia', '1732-06-29', '1732-07-14', true, '1732-10-22', 'Texel', 2802, 'According to N.A. XXVI, 1902, 94 the master was Huig Haverkamp');
INSERT INTO "voyages" VALUES (6841, '', 1, '', 'BUIS', 'Klaas Molenaar', 600, NULL, '1727', NULL, NULL, 'E', 'H', '1732-02-14', 'Batavia', '1732-06-04', '1732-06-24', true, '1732-10-15', 'Texel', 2742, NULL);
INSERT INTO "voyages" VALUES (6842, '', 4, '', 'HAFTEN', 'Dirk Goudberg', 600, 'fluit', '1717', NULL, NULL, 'A', 'A', '1732-02-14', 'Batavia', '1732-05-27', '1732-06-24', true, '1732-10-06', 'Texel', 2799, NULL);
INSERT INTO "voyages" VALUES (6843, '', 3, '', 'KROOSWIJK', 'Pieter Kaas', 600, 'fluit', '1720', NULL, NULL, 'R', 'D', '1732-02-14', 'Batavia', '1732-06-01', '1732-06-24', true, '1732-10-02', 'Texel', 2835, NULL);
INSERT INTO "voyages" VALUES (6844, '', 1, '', 'ZORGWIJK', 'Hendrik Oterlijk', 650, NULL, '1730', NULL, NULL, 'A', 'Z', '1732-02-14', 'Batavia', '1732-05-12', '1732-06-24', true, '1732-10-02', 'Texel', 2817, 'The ZORGWIJK made four other voyages, but from now on the ship was called VOORDUIN (see 2903/6900 etc.)');
INSERT INTO "voyages" VALUES (6845, '', 4, '', 'DELFLAND', 'Nikolaas du Moulin', 600, 'fluit', '1717', NULL, NULL, 'D', 'A', '1732-03-22', 'Batavia', NULL, NULL, false, '1732-09-26', 'Texel', 2731, 'Called at St. Helena from 21-06 till 06-07-1732.');
INSERT INTO "voyages" VALUES (6846, '', 2, '', 'ADRICHEM', 'Samuel Hoppestijn', 850, NULL, '1726', NULL, NULL, 'A', 'D', '1732-10-26', 'Batavia', '1733-01-28', '1733-03-07', true, '1733-07-06', 'Goeree', 2864, 'Commandeur of this return fleet was Kornelis Oterlijk (6851); vice-commandeur was Leonard de Rijke (6848), and schout-bij-nacht was Samuel Hoppestijn (6846).');
INSERT INTO "voyages" VALUES (6847, '', 2, '', 'BEEKVLIET', 'Huig Goedhart', 850, NULL, '1724', NULL, NULL, 'A', 'A', '1732-10-26', 'Batavia', '1733-01-29', '1733-03-07', true, '1732-06-28', 'Texel', 2866, NULL);
INSERT INTO "voyages" VALUES (6848, '', 4, '', 'EVERSWAART', 'Leonard de Rijke', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1732-10-26', 'Batavia', '1733-01-28', '1733-03-07', true, '1733-06-28', 'Rammekens', 2858, NULL);
INSERT INTO "voyages" VALUES (6849, '', 4, '', 'GAASPERDAM', 'Willem van Ginkel', 1150, NULL, '1724', NULL, NULL, 'A', 'A', '1732-10-26', 'Batavia', '1733-01-28', '1733-03-07', true, '1733-06-28', 'Texel', 2867, NULL);
INSERT INTO "voyages" VALUES (6850, '', 4, '', 'KETEL', 'Michiel van Markel', 810, NULL, '1721', NULL, NULL, 'R', 'R', '1732-10-26', 'Batavia', '1733-01-28', '1733-03-07', true, '1733-06-28', 'Goeree', 2859, NULL);
INSERT INTO "voyages" VALUES (6851, '', 1, '', 'LOOSDRECHT', 'Kornelis Oterlijk', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1732-10-26', 'Batavia', '1733-02-09', '1733-03-07', true, '1733-06-28', 'Texel', 2856, NULL);
INSERT INTO "voyages" VALUES (6852, '', 2, '', 'MEERLUST', 'Joachim Galouw', 600, NULL, '1725', NULL, NULL, 'A', 'H', '1732-10-26', 'Batavia', '1733-01-28', '1733-03-07', true, '1733-06-28', 'Texel', 2771, NULL);
INSERT INTO "voyages" VALUES (6853, '', 4, '', 'PURMERLUST', 'Bastiaan Mol', 580, NULL, '1718', NULL, NULL, 'A', 'A', '1732-10-26', 'Batavia', '1733-02-05', '1733-03-07', true, '1733-06-26', 'Texel', 2824, NULL);
INSERT INTO "voyages" VALUES (6854, '', 5, '', 'STEENHOVEN', 'Hendrik Perfekt', 850, NULL, '1718', NULL, NULL, 'Z', 'Z', '1732-10-26', 'Batavia', '1733-01-28', '1733-03-07', true, '1733-06-28', 'Rammekens', 2860, NULL);
INSERT INTO "voyages" VALUES (6855, '', 3, '', 'WESTFRIESLAND', 'Willem Vroom', 370, NULL, '1722', NULL, NULL, 'H', 'A', '1732-10-26', 'Batavia', '1733-02-06', '1733-03-07', true, '1733-06-28', 'Texel', 2773, NULL);
INSERT INTO "voyages" VALUES (6856, '', 3, '', 'KASTEEL VAN WOERDEN', 'Isaak Brandenburg', 850, NULL, '1722', NULL, NULL, 'E', 'E', '1732-10-26', 'Batavia', '1733-01-28', '1733-03-07', true, '1733-06-28', 'Texel', 2853, NULL);
INSERT INTO "voyages" VALUES (6857, '', 5, '', 'CORNELIA', 'Jan Pereboom', 800, NULL, '1721', NULL, NULL, 'H', 'H', '1732-11-30', 'Batavia', '1733-03-01', '1733-03-28', true, '1733-07-27', 'Texel', 2854, NULL);
INSERT INTO "voyages" VALUES (6858, '', 5, '', 'GEERTRUID', 'Kornelis van der Hoeve', 600, 'fluit', '1717', NULL, NULL, 'E', 'A', '1732-11-30', 'Batavia', '1733-03-01', '1733-03-28', true, '1733-07-27', 'Texel', 2833, NULL);
INSERT INTO "voyages" VALUES (6859, '', 1, '', 'MARIA ADRIANA', 'Pieter Sluis', 650, NULL, '1730', NULL, NULL, 'Z', 'R', '1732-11-30', 'Batavia', '1733-03-08', '1733-04-28', true, '1733-07-27', 'Goeree', 2838, NULL);
INSERT INTO "voyages" VALUES (6860, '', 8, '', 'MEUENBURG', 'Levinus de Heere', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1732-11-30', 'Batavia', '1733-03-01', '1733-03-28', true, '1733-07-27', 'Rammekens', 2871, NULL);
INSERT INTO "voyages" VALUES (6861, '', 5, '', 'STADWIJK', 'Joris Davidson', 1150, NULL, '1720', NULL, NULL, 'A', 'A', '1732-11-30', 'Batavia', '1733-03-01', '1733-03-28', true, '1733-07-27', 'Texel', 2850, NULL);
INSERT INTO "voyages" VALUES (6862, '', 1, '', 'WESTKAPELLE', 'Jakob Landsheer', 850, NULL, '1730', NULL, NULL, 'Z', 'Z', '1732-11-30', 'Batavia', '1733-03-04', '1733-03-28', true, '1733-07-27', 'Rammekens', 2861, NULL);
INSERT INTO "voyages" VALUES (6863, '', 2, '', 'WINTER', 'Pieter Bruis', 650, NULL, '1723', NULL, NULL, 'Z', 'A', '1732-11-30', 'Batavia', '1733-03-01', '1733-03-28', true, '1733-07-27', 'Texel', 2765, NULL);
INSERT INTO "voyages" VALUES (6864, '', 1, '', 'MEERMOND', 'Jakob Gosen Hoogstad', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1732-12-30', 'Ceylon', '1733-03-06', '1733-03-28', true, '1733-07-22', 'Texel', 2830, NULL);
INSERT INTO "voyages" VALUES (6865, '', 5, '', 'OOSTRUST', 'Hendrik van den Berg', 1140, NULL, '1721', NULL, NULL, 'A', 'A', '1732-12-30', 'Ceylon', '1733-03-09', '1733-03-28', true, '1733-07-22', 'Texel', 2841, NULL);
INSERT INTO "voyages" VALUES (6866, '', 3, '', 'SCHUITWIJK', 'Michiel Keizer', 650, NULL, '1724', NULL, NULL, 'E', 'Z', '1732-12-30', 'Ceylon', '1733-03-07', '1733-03-28', true, '1733-07-22', 'Rammekens', 2846, NULL);
INSERT INTO "voyages" VALUES (6867, '', 4, '', 'WICKENBURG', 'Pieter van de Roete', 850, NULL, '1722', NULL, NULL, 'Z', 'Z', '1732-12-30', 'Ceylon', '1733-03-09', '1733-03-28', true, '1733-07-22', 'Rammekens', 2792, NULL);
INSERT INTO "voyages" VALUES (6868, '', 1, '', 'IEPENRODE', 'Adriaan de Raad+', 650, NULL, '1731', NULL, NULL, 'A', 'A', '1733-01-25', 'China', '1733-05-24', '1733-06-13', true, '1733-09-11', 'Texel', 2862, 'The master died and was succeeded by Jan Schuring.');
INSERT INTO "voyages" VALUES (6869, '', 1, '', 'KNAPPENHOF', 'Pieter Verley', 650, NULL, '1731', NULL, NULL, 'A', 'A', '1733-01-25', 'China', '1733-05-21', '1733-06-13', true, '1733-09-11', 'Texel', 2863, NULL);
INSERT INTO "voyages" VALUES (6870, '', 6, '', 'DEN DAM', 'Kornelis Nannings', 600, 'fluit', '1716', NULL, NULL, 'D', 'D', '1733-02-13', 'Batavia', '1733-05-23', '1733-06-25', true, '1733-10-11', 'Goeree', 2869, NULL);
INSERT INTO "voyages" VALUES (6871, '', 3, '', 'LANDSKROON', 'Jan van Thiel', 850, NULL, '1725', NULL, NULL, 'A', 'A', '1733-02-13', 'Batavia', '1733-06-04', '1733-06-25', true, '1733-10-11', 'Texel', 2797, NULL);
INSERT INTO "voyages" VALUES (6872, '', 3, '', 'PETRONELLA ALIDA', 'Kornelis de Ruiter', 550, NULL, '1722', NULL, NULL, 'E', 'E', '1733-02-13', 'Batavia', '1733-06-02', '1733-06-25', true, '1733-11-12', 'Texel', 2872, NULL);
INSERT INTO "voyages" VALUES (6873, '', 1, '', 'SCHONAUWEN', 'Lukas Hardenbroek', 600, NULL, '1729', NULL, NULL, 'A', 'A', '1733-02-13', 'Batavia', '1733-06-10', '1733-06-25', true, '1733-10-30', 'Texel', 2786, NULL);
INSERT INTO "voyages" VALUES (6874, '', 4, '', 'HOF NIET ALTIJD ZOMER', 'Huibrecht op den Dijk', 600, 'fluit', '1718', NULL, NULL, 'Z', 'Z', '1733-02-13', 'Batavia', '1733-05-28', '1733-06-25', true, '1733-11-06', 'Rammekens', 2730, NULL);
INSERT INTO "voyages" VALUES (6875, '', 2, '', 'ALBLASSERDAM', 'Joris van Kleef', 600, NULL, '1725', NULL, NULL, 'D', 'A', '1733-03-31', 'Batavia', '1733-06-19', '1733-07-02', true, '1733-10-08', 'Texel', 2874, NULL);
INSERT INTO "voyages" VALUES (6876, '', 2, '', 'LAND VAN BELOFTEN', 'Gillis Oudemans', 520, NULL, '1723', NULL, NULL, 'E', 'E', '1733-10-30', 'Batavia', '1734-01-13', '1734-03-03', true, '1734-06-15', 'Texel', 2772, 'Pieter Obry (6885), schout-bij-nacht was Boudewijn de Graaf (6877). The LAND VAN BELOFTEN returned via the Channel.');
INSERT INTO "voyages" VALUES (6877, '', 1, '', 'HAAMSTEDE', 'Boudewijn de Graaf', 650, NULL, '1730', NULL, NULL, 'D', 'D', '1733-10-30', 'Batavia', '1734-01-13', '1734-03-03', true, '1734-07-30', 'Goeree', 2852, NULL);
INSERT INTO "voyages" VALUES (6878, '', 6, '', 'HILLEGONDA', 'Kornelis Damme', 850, NULL, '1720', NULL, NULL, 'H', 'A', '1733-10-30', 'Batavia', '1734-01-13', '1734-03-03', true, '1734-07-29', 'Texel', 2901, NULL);
INSERT INTO "voyages" VALUES (6879, '', 1, '', 'HOFVLIET', 'Willem Cagie', 1000, NULL, '1729', NULL, NULL, 'R', 'R', '1733-10-30', 'Batavia', '1734-01-13', '1734-03-03', true, '1734-07-31', 'Goeree', 2812, NULL);
INSERT INTO "voyages" VALUES (6880, '', 4, '', 'HOGERSMILDE', 'Gerrit Pik', 810, NULL, '1723', NULL, NULL, 'A', 'A', '1733-10-30', 'Batavia', '1734-01-13', '1734-03-03', true, '1734-07-29', 'Texel', 2905, NULL);
INSERT INTO "voyages" VALUES (6881, '', 3, '', 'KLARABEEK', 'Christiaan Damme', 705, NULL, '1721', NULL, NULL, 'Z', 'H', '1733-10-30', 'Batavia', '1734-01-13', '1734-03-03', true, '1734-07-31', 'Texel', 2808, NULL);
INSERT INTO "voyages" VALUES (6882, '', 7, '', 'SPIERING', 'Jan Meulman', 810, NULL, '1714', NULL, NULL, 'D', 'A', '1733-10-30', 'Batavia', '1734-01-13', '1734-03-03', true, '1734-07-29', 'Texel', 2909, NULL);
INSERT INTO "voyages" VALUES (6883, '', 1, '', 'HUIS TE SPIJK', 'Jakob van Banken', 650, NULL, '1732', NULL, NULL, 'D', 'A', '1733-10-30', 'Batavia', '1734-01-13', '1734-03-03', true, '1734-07-29', 'Texel', 2894, NULL);
INSERT INTO "voyages" VALUES (6884, '', 1, '', 'NIEUW WALCHEREN', 'Jan van den Elske', 850, NULL, '1731', NULL, NULL, 'Z', 'Z', '1733-10-30', 'Batavia', '1734-01-13', '1734-03-03', true, '1734-07-31', 'Rammekens', 2899, NULL);
INSERT INTO "voyages" VALUES (6885, '', 6, '', 'ZOETELINGSKERKE', 'Pieter Obry', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1733-10-30', 'Batavia', '1734-01-13', '1734-03-03', true, '1734-07-31', 'Rammekens', 2900, NULL);
INSERT INTO "voyages" VALUES (6886, '', 4, '', 'KARSENHOF', 'Kornelis Jonker+', 800, NULL, '1723', NULL, NULL, 'A', 'A', '1733-12-05', 'Batavia', '1734-02-23', '1734-03-03', true, '1734-07-30', 'Texel', 2881, 'The master died and was succeeded by J. C. Herman.');
INSERT INTO "voyages" VALUES (6887, '', 5, '', 'BERKENRODE', 'Gerrit Klinkhamer', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1733-12-22', 'Ceylon', '1734-03-07', '1734-04-22', true, '1734-08-14', 'Texel', 2887, NULL);
INSERT INTO "voyages" VALUES (6888, '', 1, '', 'BETHLEHEM', 'Klaas Meelhoop', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1733-12-22', 'Batavia', '1734-05-28', '1734-06-12', true, '1734-10-05', 'Texel', 2885, NULL);
INSERT INTO "voyages" VALUES (6889, '', 2, '', 'FLORA', 'Adriaan van Leeuwen', 850, NULL, '1730', NULL, NULL, 'A', 'Z', '1733-12-22', 'Ceylon', '1734-03-07', '1734-04-22', true, '1734-08-15', 'Rammekens', 2890, NULL);
INSERT INTO "voyages" VALUES (6890, '', 1, '', '''T VLIEGEND HART', 'Abraham van der Hart', 850, NULL, '1729', NULL, NULL, 'Z', 'Z', '1733-12-22', 'Ceylon', '1734-03-07', '1734-04-22', true, '1734-08-15', 'Rammekens', 2820, NULL);
INSERT INTO "voyages" VALUES (6891, '', 6, '', 'MAGDALENA', 'Simon Muller', 600, NULL, '1719', NULL, NULL, 'H', 'H', '1733-12-22', 'Batavia', '1734-05-22', '1734-06-12', true, '1734-09-30', 'Texel', 2911, NULL);
INSERT INTO "voyages" VALUES (6892, '', 5, '', 'OPPERDOES', 'Jakob van der Blok +', 600, 'fluit', '1718', NULL, NULL, 'H', 'Z', '1733-12-22', 'Batavia', '1734-05-22', '1734-06-12', true, '1734-10-04', 'Rammekens', 2907, 'The master died and was succeeded by Abraham Everhard.');
INSERT INTO "voyages" VALUES (6893, '', 1, '', 'PADDENBURG', 'Willem de Wijs', 850, NULL, '1732', NULL, NULL, 'A', 'A', '1733-12-22', 'Ceylon', '1734-03-07', '1734-04-22', true, '1734-08-14', 'Texel', 2892, NULL);
INSERT INTO "voyages" VALUES (6894, '', 1, '', 'PROOSTWIJK', 'Evert de Bruin', 650, NULL, '1730', NULL, NULL, 'E', 'A', '1733-12-22', 'Ceylon', '1734-03-07', '1734-04-22', true, '1734-08-14', 'Texel', 2849, NULL);
INSERT INTO "voyages" VALUES (6895, '', 1, '', 'HUIS TE MARQUETTE', 'Abraham van Rijnoy', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1734-01-02', 'Ceylon', '1734-10-21', '1735-03-03', true, '1735-06-25', 'Texel', 2847, 'Stayed in Mosselbaai.');
INSERT INTO "voyages" VALUES (6896, '', 4, '', 'PATMOS', 'Kornelis den Breen', 810, NULL, '1722', NULL, NULL, 'R', 'R', '1734-01-17', 'Batavia', NULL, NULL, false, '1734-10-04', 'Goeree', 2766, NULL);
INSERT INTO "voyages" VALUES (6897, '', 2, '', 'ANNA CATHARINA', 'Herman Brand +', 600, NULL, '1728', NULL, NULL, 'Z', 'Z', '1734-01-18', 'China', '1734-04-22', '1734-05-19', true, '1734-08-27', 'Rammekens', 2865, 'The master died and was succeeded by Nikolaas Blom.');
INSERT INTO "voyages" VALUES (6898, '', 2, '', 'LEIDUIN', 'Jan de Haan', 650, NULL, '1730', NULL, NULL, 'A', 'A', '1734-01-18', 'China', '1734-04-23', '1734-05-19', true, '1734-08-27', 'Texel', 2895, NULL);
INSERT INTO "voyages" VALUES (6899, '', 5, '', 'NIEUWVLIET', 'Gerrit Fiers', 650, NULL, '1719', NULL, NULL, 'Z', 'Z', '1734-01-18', 'China', '1734-04-22', '1734-05-19', true, '1734-08-27', 'Rammekens', 2897, NULL);
INSERT INTO "voyages" VALUES (6900, '', 2, '', 'VOORDUIN', 'Lambert Zwaan', 650, NULL, '1730', NULL, NULL, 'A', 'A', '1734-01-18', 'China', '1734-04-23', '1734-05-19', true, '1734-08-27', 'Texel', 2903, 'See 6844.');
INSERT INTO "voyages" VALUES (6901, '', 1, '', 'GROET', 'Dirk Mulder', 850, NULL, '1732', NULL, NULL, 'A', 'A', '1734-02-28', 'Batavia', NULL, NULL, true, NULL, NULL, 2910, 'Batavia and the Cape.');
INSERT INTO "voyages" VALUES (6902, '', 1, '', 'RITTHEM', 'Klaas Melop', 350, NULL, '1732', NULL, NULL, 'Z', 'Z', '1734-02-28', 'Batavia', '1734-05-28', '1734-06-12', true, '1734-09-30', 'Rammekens', 2902, NULL);
INSERT INTO "voyages" VALUES (6903, '', 2, '', 'RIDDERKERK', 'Willem Haysen', 500, NULL, '1726', NULL, NULL, 'R', 'A', '1734-04-02', 'Batavia', '1734-12-18', '1735-03-03', true, '1735-10-12', 'Texel', 2805, 'Commandeur of this return fleet was L.F. de Witte van Schoten (6912).');
INSERT INTO "voyages" VALUES (6904, '', 2, '', 'BUIS', 'Gerrit Kuit', 600, NULL, '1727', NULL, NULL, 'E', 'E', '1734-09-12', 'Batavia', '1734-12-18', '1735-03-03', true, '1735-07-06', 'Texel', 2915, NULL);
INSERT INTO "voyages" VALUES (6905, '', 1, '', 'HUIS TE FOREEST', 'Dirk de Vet', 850, NULL, '1731', NULL, NULL, 'H', 'A', '1734-09-12', 'Ceylon', '1734-12-18', '1735-03-03', true, '1735-07-06', 'Texel', 2880, NULL);
INSERT INTO "voyages" VALUES (6906, '', 2, '', 'KNAPPENHOF', 'Wouter Bois', 650, NULL, '1731', NULL, NULL, 'A', 'R', '1734-09-12', 'Batavia', '1735-01-16', '1735-03-03', true, '1735-07-11', 'Goeree', 2946, NULL);
INSERT INTO "voyages" VALUES (6907, '', 4, '', 'KROOSWIJK', 'Adriaan de Wit', 600, 'fluit', '1720', NULL, NULL, 'R', 'D', '1734-09-12', 'Batavia', '1734-12-14', '1735-03-03', true, '1735-07-11', 'Goeree', 2913, NULL);
INSERT INTO "voyages" VALUES (6908, '', 3, '', 'REIGERSBROEK', 'Kornelis Roobol', 600, NULL, '1726', NULL, NULL, 'A', 'Z', '1734-09-12', 'Batavia', '1734-12-16', '1735-03-03', true, '1735-07-17', 'Rammekens', 2883, NULL);
INSERT INTO "voyages" VALUES (6909, '', 4, '', 'KASTEEL VAN WOERDEN', 'Hendrik Jansz.van Beek', 850, NULL, '1722', NULL, NULL, 'D', 'D', '1734-09-12', 'Batavia', '1735-01-16', '1735-03-03', true, '1735-07-11', 'Goeree', 2944, NULL);
INSERT INTO "voyages" VALUES (6910, '', 3, '', 'BEEKVLIET', 'Gartelman', 850, NULL, '1724', NULL, NULL, 'A', 'A', '1734-10-07', 'Batavia', '1734-12-30', '1735-03-03', true, '1735-07-05', 'Texel', 2929, NULL);
INSERT INTO "voyages" VALUES (6911, '', 5, '', 'GAASPERDAM', 'Joris Davidson', 1150, NULL, '1724', NULL, NULL, 'A', 'A', '1734-10-07', 'Batavia', '1735-01-13', '1735-03-03', true, '1735-06-25', 'Texel', 2945, NULL);
INSERT INTO "voyages" VALUES (6912, '', 1, '', 'HILLEGOM', 'Jan Almees', 1150, NULL, '1733', NULL, NULL, 'A', 'A', '1734-10-07', 'Ceylon', '1735-01-01', '1735-03-03', true, '1735-07-06', 'Texel', 2930, NULL);
INSERT INTO "voyages" VALUES (6913, '', 2, '', 'LOOSDRECHT', 'Bastiaan Mol', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1734-10-07', 'Ceylon', '1735-01-07', '1735-03-03', true, '1735-07-06', 'Texel', 2933, NULL);
INSERT INTO "voyages" VALUES (6914, '', 9, '', 'MEIJENBURG', 'Kornelis Fret', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1734-10-07', 'Batavia', '1735-01-01', '1735-03-03', true, '1735-07-28', 'Rammekens', 2938, NULL);
INSERT INTO "voyages" VALUES (6915, '', 1, '', 'NIEUWSTAD', 'Jan Licent', 650, NULL, '1733', NULL, NULL, 'H', 'H', '1734-10-07', 'Batavia', '1735-01-07', '1735-03-03', true, '1735-07-06', 'Texel', 2934, NULL);
INSERT INTO "voyages" VALUES (6916, '', 3, '', 'PALLAS', 'Jurriaan Lijssen', 650, NULL, '1723', NULL, NULL, 'A', 'A', '1734-10-07', 'Batavia', '1735-01-07', '1735-03-03', true, '1735-06-25', 'Texel', 2848, NULL);
INSERT INTO "voyages" VALUES (6917, '', 3, '', 'LAGE POLDER', 'Jan van Malen', 580, NULL, '1725', NULL, NULL, 'E', 'E', '1734-10-07', 'Batavia', '1735-01-01', '1735-03-03', true, '1735-07-06', 'Texel', 2926, NULL);
INSERT INTO "voyages" VALUES (6918, '', 1, '', 'VLISSINGEN', 'Jan de Roeper', 650, NULL, '1732', NULL, NULL, 'Z', 'Z', '1734-10-07', 'Batavia', '1735-01-07', '1735-03-03', true, '1735-07-17', 'Rammekens', 2941, NULL);
INSERT INTO "voyages" VALUES (6919, '', 2, '', 'WESTKAPELLE', 'Pieter Bruis', 850, NULL, '1730', NULL, NULL, 'Z', 'Z', '1734-10-07', 'Batavia', '1734-12-31', '1735-03-03', true, '1735-06-26', 'Rammekens', 2942, NULL);
INSERT INTO "voyages" VALUES (6920, '', 2, '', 'DUINBEEK', 'Jakob Gosen Hoogstad', 800, NULL, '1727', NULL, NULL, 'Z', 'A', '1734-12-06', 'Batavia', '1735-03-12', '1735-04-01', true, '1735-07-31', 'Texel', 2904, 'Commandeur of this return fleet was Jakob Pielat (6920).');
INSERT INTO "voyages" VALUES (6921, '', 1, '', 'KERKWIJK', 'Pieter Visser', 850, NULL, '1733', NULL, NULL, 'A', 'H', '1734-12-06', 'Batavia', '1735-03-12', '1735-04-01', true, '1735-07-21', 'Texel', 2932, NULL);
INSERT INTO "voyages" VALUES (6922, '', 2, '', 'PAPENBURG', 'Hendrik Orsel', 800, NULL, '1729', NULL, NULL, 'A', 'R', '1734-12-06', 'Batavia', '1735-03-16', '1735-04-01', true, '1735-08-03', 'Goeree', 2908, NULL);
INSERT INTO "voyages" VALUES (6923, '', 4, '', 'SCHUITWIJK', 'Gerrit Bijleveld', 650, NULL, '1724', NULL, NULL, 'E', 'E', '1734-12-06', 'Batavia', '1735-03-12', '1735-04-01', true, '1735-07-31', 'Texel', 2948, NULL);
INSERT INTO "voyages" VALUES (6924, '', 3, '', 'WESTERBEEK', 'Marinus Dringer', 650, NULL, '1722', NULL, NULL, 'A', 'D', '1734-12-06', 'Batavia', '1735-03-12', '1735-04-01', true, '1735-08-03', 'Goeree', 2787, NULL);
INSERT INTO "voyages" VALUES (6925, '', 1, '', 'VAN ALSEM', 'Jan Mijndertsz.', 650, NULL, '1732', NULL, NULL, 'A', 'A', '1734-12-07', 'Bengal', '1735-02-24', '1735-03-03', true, '1735-07-06', 'Texel', 2921, NULL);
INSERT INTO "voyages" VALUES (6926, '', 1, '', 'SLOT KRONENBURG', 'Jan van Engelen', 350, NULL, '1733', NULL, NULL, 'A', 'A', '1734-12-07', 'Bengal', '1735-02-25', '1735-03-03', true, '1735-07-12', 'Rammekens', 2947, NULL);
INSERT INTO "voyages" VALUES (6927, '', 3, '', 'ADRICHEM', 'Jan Boelhouwer', 850, NULL, '1726', NULL, NULL, 'A', 'Z', '1734-12-18', 'Ceylon', '1735-02-22', '1735-03-03', true, '1735-07-19', 'Rammekens', 2927, NULL);
INSERT INTO "voyages" VALUES (6928, '', 2, '', 'MEERMOND', 'Willem Vroom', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1734-12-18', 'Ceylon', '1735-02-18', '1735-03-03', true, '1735-07-06', 'Texel', 2937, NULL);
INSERT INTO "voyages" VALUES (6929, '', 5, '', 'NOORDWADDINXVEEN', '1. Muisenhoofd', 850, NULL, '1718', NULL, NULL, 'R', 'A', '1734-12-18', 'Ceylon', '1735-02-22', '1735-03-03', true, '1735-07-06', 'Texel', 2914, NULL);
INSERT INTO "voyages" VALUES (6930, '', 1, '', 'SIJBEKARSPEL', 'Willem Braakman', 650, NULL, '1729', NULL, NULL, 'H', 'Z', '1734-12-18', 'Ceylon', '1735-02-18', '1735-03-03', true, '1735-07-11', 'Texel', 2806, NULL);
INSERT INTO "voyages" VALUES (6931, '', 1, '', 'VIS', '(NIEUWE) Lukas Semeyns', 650, NULL, '1732', NULL, NULL, 'E', 'A', '1734-12-18', 'Ceylon', '1735-02-18', '1735-03-03', true, '1735-06-26', 'Texel', 2925, NULL);
INSERT INTO "voyages" VALUES (6932, '', 1, '', 'BOOT', 'Arie Brouwer', 650, NULL, '1733', NULL, NULL, 'R', 'Z', '1734-12-25', 'Batavia', '1735-03-10', '1735-04-01', true, '1735-08-03', 'Rammekens', 2950, NULL);
INSERT INTO "voyages" VALUES (6933, '', 6, '', 'CASTRICUM', 'Jakob van Duinen', 1150, NULL, '1722', NULL, NULL, 'A', 'A', '1734-12-25', 'Batavia', '1735-03-11', '1735-04-01', true, '1735-07-31', 'Texel', 2924, NULL);
INSERT INTO "voyages" VALUES (6934, '', 1, '', 'NOORDWOLFSBERGEN', 'Hendrik Perfekt', 650, NULL, '1733', NULL, NULL, 'A', 'A', '1735-01-02', 'China', '1735-04-05', '1735-04-21', true, '1735-07-20', 'Texel', 2935, NULL);
INSERT INTO "voyages" VALUES (6935, '', 3, '', 'COXHOORN', 'Frans van Nek', 450, NULL, '1728', NULL, NULL, 'A', 'Z', '1735-04-06', 'Batavia', '1735-06-06', '1735-06-25', true, '1735-09-21', 'Rammekens', 2888, NULL);
INSERT INTO "voyages" VALUES (6936, '', 5, '', 'GOUDRIAAN', 'Willem Hendriksz. van Roffe', 630, 'fluit', '1719', NULL, NULL, 'D', 'A', '1735-04-06', 'Batavia', NULL, NULL, false, '1735-09-25', 'Texel', 2873, 'Called at St. Helena.');
INSERT INTO "voyages" VALUES (6937, '', 6, '', 'CORNELIA', 'Hendrik Hessing', 800, NULL, '1721', NULL, NULL, 'H', 'H', '1735-10-14', 'Batavia', '1735-12-21', '1736-03-01', true, '1736-07-21', 'Texel', 2962, 'Commandeur of this return fleet was Jan Elsevier (6939), vice-commandeur was Hendrik Opmeer (6940), schout-bij-nacht was Diederik van den Zandheuvel (6944).');
INSERT INTO "voyages" VALUES (6938, '', 2, '', 'DUIFJE', 'Jan Krielaard', 450, NULL, '1729', NULL, NULL, 'A', 'A', '1735-10-14', 'Batavia', '1735-12-23', '1736-03-01', true, '1736-07-21', 'Texel', 2851, NULL);
INSERT INTO "voyages" VALUES (6939, '', 5, '', 'EVERSWAART', 'Hoppestijn', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1735-10-14', 'Batavia', '1735-12-22', '1736-03-01', true, '1736-07-26', 'Rammekens', 2936, NULL);
INSERT INTO "voyages" VALUES (6940, '', 1, '', 'GOIDSCHALKXOORD', 'Frederik Hendrik Meerme', 850, 'fluit', '1734', NULL, NULL, 'A', 'A', '1735-10-14', 'Batavia', '1735-12-22', '1736-03-01', true, '1736-07-21', 'Texel', 2964, NULL);
INSERT INTO "voyages" VALUES (6941, '', 3, '', 'MARIA ADRIANA', 'Pieter Kaas', 650, NULL, '1730', NULL, NULL, 'R', 'R', '1735-10-14', 'Batavia', '1735-12-22', '1736-03-01', true, '1736-07-22', 'Goeree', 2928, NULL);
INSERT INTO "voyages" VALUES (6942, '', 6, '', 'OOSTRUST', 'Pieter Lup', 1140, NULL, '1721', NULL, NULL, 'A', 'A', '1735-10-14', 'Batavia', '1735-12-21', '1736-03-01', true, '1736-07-21', 'Texel', 2961, NULL);
INSERT INTO "voyages" VALUES (6943, '', 4, '', 'PETRONELLA ALIDA', 'Nikolaas du Moulin', 550, NULL, '1722', NULL, NULL, 'E', 'E', '1735-10-14', 'Batavia', '1735-12-26', '1736-03-01', true, '1736-07-21', 'Texel', 2963, NULL);
INSERT INTO "voyages" VALUES (6944, '', 1, '', 'RUST EN WERK', 'Diederik van den Zandheuvel', 650, NULL, '1734', NULL, NULL, 'D', 'D', '1735-10-14', 'Batavia', '1735-12-22', '1736-03-01', true, '1736-07-22', 'Goeree', 2967, NULL);
INSERT INTO "voyages" VALUES (6945, '', 1, '', 'VENENBURG', 'Jakob Popta', 650, NULL, '1734', NULL, NULL, 'A', 'A', '1735-10-14', 'Batavia', '1735-12-22', '1736-03-01', true, '1736-07-21', 'Texel', 2966, NULL);
INSERT INTO "voyages" VALUES (6946, '', 7, '', 'ZOETELINGSKERKE', 'Huibrecht op den Dijk', 1100, NULL, '1721', NULL, NULL, 'Z', 'Z', '1735-10-14', 'Batavia', '1735-12-24', '1736-03-01', true, '1736-07-26', 'Rammekens', 2974, NULL);
INSERT INTO "voyages" VALUES (6947, '', 2, '', 'ZORGWIJK', 'Jan Bot', 650, NULL, '1732', NULL, NULL, 'A', 'A', '1735-10-14', 'Batavia', '1735-12-22', '1736-03-01', true, '1736-07-21', 'Texel', 2920, 'This is the ''second'' voyage of the ZORGWIJK, which during its ''first'' voyage (2896/-) was called VOORDUIN. See 6844.');
INSERT INTO "voyages" VALUES (6948, '', 6, '', 'BERKENRODE', 'Anthonie Guldeman', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1735-10-28', 'Batavia', '1736-01-08', '1736-03-01', true, '1736-07-21', 'Texel', 2979, NULL);
INSERT INTO "voyages" VALUES (6949, '', 4, '', 'KLARABEEK', 'Jan Pereboom', 705, NULL, '1721', NULL, NULL, 'Z', 'Z', '1735-10-28', 'Batavia', '1736-01-05', '1736-03-01', true, '1736-07-26', 'Rammekens', 2981, NULL);
INSERT INTO "voyages" VALUES (6950, '', 1, '', 'ELSBROEK', 'Barend Lont', 350, NULL, '1732', NULL, NULL, 'A', 'Z', '1735-11-20', 'Bengal', '1736-02-05', '1736-03-01', true, '1736-08-06', 'Rammekens', 2889, NULL);
INSERT INTO "voyages" VALUES (6951, '', 1, '', 'HARTENLUST', 'Viktor van der Kaag', 650, NULL, '1734', NULL, NULL, 'A', 'A', '1735-11-20', 'Bengal', '1736-02-05', '1736-03-01', true, '1736-07-25', 'Texel', 2968, NULL);
INSERT INTO "voyages" VALUES (6952, '', 1, '', 'BINNENWIJZEND', NULL, 500, NULL, '1726', NULL, NULL, 'H', 'H', '1735-12-20', 'Batavia', '1736-02-27', '1736-04-05', true, '1736-07-26', 'Texel', 2696, NULL);
INSERT INTO "voyages" VALUES (6953, '', 1, '', 'HOFWEGEN', 'Gijsbert Hageman', 650, NULL, '1731', NULL, NULL, 'R', 'R', '1735-12-20', 'Batavia', '1736-02-27', '1736-04-05', true, '1736-08-09', 'Goeree', 2876, NULL);
INSERT INTO "voyages" VALUES (6954, '', 4, '', 'LANDSKROON', 'Hendrik Schoon', 850, NULL, '1725', NULL, NULL, 'A', 'A', '1735-12-20', 'Batavia', '1736-02-27', '1736-04-05', true, '1736-08-08', 'Texel', 2959, NULL);
INSERT INTO "voyages" VALUES (6955, '', 1, '', 'NIEUWLAND', 'Michiel Keizer', 850, NULL, '1733', NULL, NULL, 'Z', 'A', '1735-12-20', 'Batavia', '1736-02-27', '1736-04-05', true, '1736-08-08', 'Texel', 2960, NULL);
INSERT INTO "voyages" VALUES (6956, '', 5, '', 'PATMOS', 'Willem de Wijs', 810, NULL, '1722', NULL, NULL, 'R', 'D', '1735-12-20', 'Batavia', '1736-02-27', '1736-04-05', true, '1736-08-08', 'Goeree', 2986, NULL);
INSERT INTO "voyages" VALUES (6957, '', 1, '', 'HUIS TE RENSBURG', 'Kornelis Nannings', 850, NULL, '1733', NULL, NULL, 'Z', 'Z', '1735-12-20', 'Batavia', '1736-02-27', '1736-04-05', true, '1736-08-09', 'Rammekens', 2958, NULL);
INSERT INTO "voyages" VALUES (6958, '', 5, '', 'KETEL', 'Adriaan Krielaard', 810, NULL, '1721', NULL, NULL, 'R', 'A', '1736-01-16', 'Ceylon', '1736-04-09', '1736-04-27', true, '1736-08-27', 'Texel', 2956, 'Adriaan Krielaard died, Dirk Prest succeeded him as master.');
INSERT INTO "voyages" VALUES (6959, '', 3, '', 'MEERLUST', 'Kornelis van der Hoeve', 600, NULL, '1725', NULL, NULL, 'A', 'A', '1736-01-16', 'Ceylon', '1736-04-09', '1736-04-27', true, '1736-08-28', 'Texel', 2954, NULL);
INSERT INTO "voyages" VALUES (6960, '', 5, '', 'WICKENBURG', 'Pieter Zwanendrecht', 850, NULL, '1722', NULL, NULL, 'Z', 'Z', '1736-01-16', 'Ceylon', '1736-04-09', '1736-04-27', true, '1736-08-29', 'Rammekens', 2949, NULL);
INSERT INTO "voyages" VALUES (6961, '', 5, '', 'HOGERSMILDE', 'Herman Blom', 810, NULL, '1723', NULL, NULL, 'A', 'A', '1736-01-18', 'Batavia', '1736-05-31', '1736-07-05', true, '1736-10-14', 'Texel', 2991, NULL);
INSERT INTO "voyages" VALUES (6962, '', 1, '', 'POPKENSBURG', 'Samuel Hendriksz.', 850, NULL, '1732', NULL, NULL, 'Z', 'E', '1736-01-18', 'Batavia', '1736-06-10', '1736-07-05', true, '1736-10-15', 'Texel', 2919, NULL);
INSERT INTO "voyages" VALUES (6963, '', 5, '', 'HOF NIET ALTIJD ZOMER', 'Mauritius van der Star', 600, NULL, '1718', NULL, NULL, 'Z', 'Z', '1736-01-18', 'Batavia', '1736-06-20', '1736-07-05', true, '1736-11-10', 'Texel', 2957, 'Arrived on 16-03-1737 at Rammekens.');
INSERT INTO "voyages" VALUES (6964, '', 3, '', 'RIDDERKERK', 'Gerrit Klinkhamer', 500, NULL, '1726', NULL, NULL, 'R', 'A', '1736-04-07', 'Batavia', '1736-06-11', '1736-07-25', true, '1736-10-08', 'Texel', 2996, 'Cargo: tea.');
INSERT INTO "voyages" VALUES (6965, '', 2, '', 'SCHONAUWEN', 'Christiaan Bakker', 600, NULL, '1729', NULL, NULL, 'A', 'A', '1736-04-07', 'Batavia', '1736-06-16', '1736-07-28', true, '1736-11-06', 'Texel', 2953, 'Cargo: tea.');
INSERT INTO "voyages" VALUES (6966, '', 1, '', 'JONGE WILLEM', 'Pieter van Hoom', 650, NULL, '1731', NULL, NULL, 'Z', 'Z', '1736-04-07', 'Batavia', NULL, NULL, false, '1736-11-16', 'Rammekens', 2884, 'Cargo: tea.');
INSERT INTO "voyages" VALUES (6967, '', 1, '', 'BATAVIER', 'Arie van der Stolk', 525, NULL, '1735', NULL, NULL, 'A', 'A', '1736-10-26', 'Batavia', '1737-01-16', '1737-03-03', true, '1737-06-26', 'Texel', NULL, 'Bernards (6968), was schout-bij-nacht.');
INSERT INTO "voyages" VALUES (6968, '', 2, '', 'HAAMSTEDE', 'Jakob Bernards', 650, NULL, '1730', NULL, NULL, 'D', 'D', '1736-10-26', 'Batavia', '1737-01-11', '1737-03-03', true, '1737-06-27', 'Goeree', 2985, 'Jakob Bernards was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (6969, '', 1, '', 'HILVERSBEEK', 'Lambert Zwaan', 850, NULL, '1735', NULL, NULL, 'A', 'A', '1736-10-26', 'Batavia', '1737-01-18', '1737-03-03', true, '1737-06-26', 'Texel', 3001, NULL);
INSERT INTO "voyages" VALUES (6970, '', 2, '', 'HOFVLIET', 'Jakob van Banken', 1000, NULL, '1729', NULL, NULL, 'R', 'R', '1736-10-26', 'Batavia', '1737-01-18', '1737-03-03', true, '1737-06-27', 'Goeree', 2971, NULL);
INSERT INTO "voyages" VALUES (6971, '', 5, '', 'KARSENHOF', 'Adriaan van Rensen', 800, NULL, '1723', NULL, NULL, 'A', 'A', '1736-10-26', 'Batavia', '1737-01-18', '1737-03-03', true, '1737-06-26', 'Texel', 2995, NULL);
INSERT INTO "voyages" VALUES (6972, '', 2, '', 'KERKWIJK', 'Daniel van Staden', 850, NULL, '1733', NULL, NULL, 'A', 'A', '1736-10-26', 'Batavia', '1737-01-13', '1737-03-03', true, '1737-06-26', 'Texel', 3017, NULL);
INSERT INTO "voyages" VALUES (6973, '', 3, '', 'LEIDUIN', 'Pieter Kronenburg', 650, NULL, '1730', NULL, NULL, 'A', 'E', '1736-10-26', 'Batavia', '1737-01-18', '1737-03-03', true, '1737-06-26', 'Texel', 2974, NULL);
INSERT INTO "voyages" VALUES (6974, '', 2, '', 'NIEUWSTAD', 'Lukas Rozeboom', 650, NULL, '1733', NULL, NULL, 'H', 'H', '1736-10-26', 'Batavia', '1737-01-20', '1737-03-03', true, '1737-06-26', 'Texel', 3005, NULL);
INSERT INTO "voyages" VALUES (6975, '', 6, '', 'NIEUWVLIET', 'Jan Govaarts', 650, NULL, '1719', NULL, NULL, 'Z', 'Z', '1736-10-26', 'Batavia', '1737-01-19', '1737-03-03', true, '1737-06-30', 'Rammekens', 2999, NULL);
INSERT INTO "voyages" VALUES (6976, '', 1, '', 'SCHEUBEEK', 'Jan de Haan', 850, NULL, '1735', NULL, NULL, 'A', 'A', '1736-10-26', 'Batavia', '1737-01-13', '1737-03-03', true, '1737-06-26', 'Texel', 3004, 'fleet.');
INSERT INTO "voyages" VALUES (6977, '', 6, '', 'STEENHOVEN', 'Leonard de Rijke', 850, NULL, '1718', NULL, NULL, 'Z', 'Z', '1736-10-26', 'Batavia', '1737-01-13', '1737-03-03', true, '1737-07-08', 'Rammekens', 2940, NULL);
INSERT INTO "voyages" VALUES (6978, '', 3, '', 'VOORDUIN', 'Pieter Scherf', 650, NULL, '1730', NULL, NULL, 'A', 'A', '1736-10-26', 'Batavia', '1737-01-18', '1737-03-03', true, '1737-06-26', 'Texel', 2976, 'See 6844.');
INSERT INTO "voyages" VALUES (6979, '', 2, '', 'NIEUW-WALCHEREN', 'Reinier Brugman', 850, NULL, '1731', NULL, NULL, 'Z', 'Z', '1736-10-26', 'Batavia', '1737-01-19', '1737-03-03', true, '1737-06-30', 'Rammekens', 2972, 'return fleet.');
INSERT INTO "voyages" VALUES (6980, '', 1, '', 'LANGEWIJK', 'Frans de Put', 850, NULL, '1734', NULL, NULL, 'E', 'A', '1736-11-23', 'Bengal', '1737-02-16', '1737-03-03', true, '1737-06-26', 'Texel', 2992, NULL);
INSERT INTO "voyages" VALUES (6981, '', 1, '', 'NOORDWIJKERHOUT', 'Marten Burgers', 350, NULL, '1732', NULL, NULL, 'A', 'Z', '1736-11-23', 'Bengal', '1737-02-17', '1737-03-03', true, '1737-07-08', 'Rammekens', 2917, NULL);
INSERT INTO "voyages" VALUES (6982, '', 2, '', 'PROOSTWIJK', 'Jakob Verleng', 650, NULL, '1730', NULL, NULL, 'E', 'A', '1736-12-01', 'Ceylon', '1737-02-20', '1737-03-03', true, '1737-07-10', 'Texel', 2982, 'Departure from Mocha on 22-08-1736.');
INSERT INTO "voyages" VALUES (6983, '', 4, '', 'COXHOORN', 'Simon Mulder', 450, NULL, '1728', NULL, NULL, 'A', 'Z', '1736-12-31', 'Batavia', '1737-04-01', '1737-04-22', true, '1737-09-05', 'Rammekens', 3026, 'Commandeur of the return fleet was Herman de Vrij (6986).');
INSERT INTO "voyages" VALUES (6984, '', 3, '', 'WAPEN VAN HOORN', 'Joris Davidson', 850, NULL, '1723', NULL, NULL, 'H', 'H', '1736-12-31', 'Batavia', '1737-04-05', '1737-04-23', true, '1737-08-17', 'Texel', 2839, NULL);
INSERT INTO "voyages" VALUES (6985, '', 1, '', 'KERKZICHT', 'Pieter Visser', 650, NULL, '1735', NULL, NULL, 'A', 'A', '1736-12-31', 'Batavia', '1737-04-03', '1737-04-22', true, '1737-09-01', 'Texel', 3018, NULL);
INSERT INTO "voyages" VALUES (6986, '', 10, '', 'MEIJENBURG', 'Herman de Vrij', 1180, NULL, '1713', NULL, NULL, 'Z', 'Z', '1736-12-31', 'Batavia', '1737-03-29', '1737-04-22', true, '1737-09-05', 'Rammekens', 3010, 'Herman de Vrij was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (6987, '', 2, '', 'HUIS TE SPIJK', 'Kornelis de Ruiter', 650, NULL, '1732', NULL, NULL, 'D', 'A', '1736-12-31', 'China', '1737-03-28', '1737-04-22', true, '1737-09-03', 'Texel', 2965, NULL);
INSERT INTO "voyages" VALUES (6988, '', 2, '', 'VIS', 'Lukas Krootjes', 650, NULL, '1732', NULL, NULL, 'E', 'E', '1736-12-31', 'Batavia', '1737-04-04', '1737-04-22', true, '1737-08-17', 'Texel', 3023, NULL);
INSERT INTO "voyages" VALUES (6989, '', 1, '', 'VREELAND', 'Jan van Engelen', 650, NULL, '1735', NULL, NULL, 'A', 'A', '1736-12-31', 'Batavia', '1737-03-29', '1737-04-22', true, '1737-09-01', 'Texel', 3024, NULL);
INSERT INTO "voyages" VALUES (6990, '', 5, '', 'KASTEEL VAN WOERDEN', 'Marinus Dringer', 850, NULL, '1722', NULL, NULL, 'D', 'D', '1736-12-31', 'Batavia', '1737-04-07', '1737-04-22', true, '1737-09-07', 'Goeree', 3028, NULL);
INSERT INTO "voyages" VALUES (6991, '', 2, '', 'IEPENRODE', 'Dirk Elsberg', 650, NULL, '1731', NULL, NULL, 'A', 'A', '1737-01-01', 'Batavia', '1737-05-20', NULL, true, NULL, NULL, 2931, 'Wrecked at the Cape on 21-05-1737. The total loss of those on board the ships, wrecked on 21-05-1737, was 208; the loss of cargo amounted up to f 1,921,532 (see also: 6992,7002, 6993, 6998-7000, and 7003.)');
INSERT INTO "voyages" VALUES (6992, '', 3, '', 'FLORA', 'Gerrit Pik', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1737-01-02', 'Batavia', '1737-04-29', NULL, true, NULL, NULL, 2989, 'Wrecked at the Cape on 21-05-1737.');
INSERT INTO "voyages" VALUES (6993, '', 2, '', 'PADDENBURG', 'Arie van Veurden', 850, NULL, '1732', NULL, NULL, 'A', 'A', '1737-01-02', 'Batavia', '1737-04-27', NULL, true, NULL, NULL, 2975, 'Wrecked at the Cape on 21-05-1737.');
INSERT INTO "voyages" VALUES (6994, '', 2, '', 'VAN ALSEM', 'Jurriaan Wolbergen', 650, NULL, '1732', NULL, NULL, 'A', 'A', '1737-01-22', 'Ceylon', '1737-03-29', '1737-04-22', true, '1737-08-05', 'Texel', 3012, 'The 90 men aboard the VAN ALSEM included 7 impotenten.');
INSERT INTO "voyages" VALUES (6995, '', 1, '', 'BEUKESTIJN', 'Klaas Meelhoop', 850, NULL, '1734', NULL, NULL, 'A', 'A', '1737-01-22', 'Ceylon', '1737-04-04', '1737-04-22', true, '1737-09-01', 'Texel', 2994, 'The 114 men aboard the BEUKESTIJN included 8 passengers.');
INSERT INTO "voyages" VALUES (6996, '', 1, '', 'HUIS DEN EULT', 'Gerrit van der Jolle', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1737-01-22', 'Ceylon', '1737-03-29', '1737-04-22', true, '1737-09-01', 'Texel', 2879, 'The 117 men aboard the HUIS DEN EULT included 9 passengers.');
INSERT INTO "voyages" VALUES (6997, '', 3, '', 'WESTKAPELLE', 'Abraham Everhard', 850, NULL, '1730', NULL, NULL, 'Z', 'Z', '1737-01-22', 'Ceylon', '1737-03-29', '1737-04-22', true, '1737-09-05', 'Rammekens', 3000, NULL);
INSERT INTO "voyages" VALUES (6998, '', 3, '', 'BUIS', 'Hendrik Orsel', 600, NULL, '1727', NULL, NULL, 'E', 'H', '1737-02-06', 'Batavia', '1737-05-11', NULL, true, NULL, NULL, 3013, 'Wrecked at the Cape on 21-05-1737.');
INSERT INTO "voyages" VALUES (6999, '', 3, '', 'DUINBEEK', 'Jan van Thiel', 800, NULL, '1727', NULL, NULL, 'Z', 'Z', '1737-02-06', 'Batavia', '1737-05-16', NULL, true, NULL, NULL, 3033, 'Wrecked at the Cape on 21-05-1737.');
INSERT INTO "voyages" VALUES (7000, '', 6, '', 'GOUDRIAAN', 'Jurriaan Zeeman', 630, 'fluit', '1719', NULL, NULL, 'D', 'D', '1737-02-06', 'Batavia', '1737-05-06', NULL, true, NULL, NULL, 3029, 'Wrecked at the Cape on 21-05-1737.');
INSERT INTO "voyages" VALUES (7001, '', 3, '', 'PAPENBURG', 'Hans Nomsen', 800, NULL, '1729', NULL, NULL, 'A', 'A', '1737-02-06', 'Batavia', '1737-05-10', '1737-05-30', true, '1737-08-23', 'Texel', 3031, NULL);
INSERT INTO "voyages" VALUES (7002, '', 1, '', 'RODENRUS', 'Jan van Heemstede', 650, NULL, '1735', NULL, NULL, 'R', 'R', '1737-02-06', 'Batavia', '1737-05-07', NULL, true, NULL, NULL, 3032, 'Wrecked at the Cape on 21-05-1737.');
INSERT INTO "voyages" VALUES (7003, '', 1, '', 'WESTERWIJK', 'Wouter Bos', 850, NULL, '1735', NULL, NULL, 'A', 'A', '1737-02-06', 'Batavia', '1737-05-07', NULL, true, NULL, NULL, 3034, 'Wrecked at the Cape on 21-05-1737');
INSERT INTO "voyages" VALUES (7004, '', 4, '', 'WESTERBEEK', 'Pieter van der Sprenkel', 650, NULL, '1722', NULL, NULL, 'A', 'A', '1737-04-04', 'Batavia', '1737-06-19', '1737-06-28', true, '1737-09-26', 'Texel', 3030, NULL);
INSERT INTO "voyages" VALUES (7005, '', 1, '', 'DIEMERMEER', 'Jan Kolom', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1737-10-31', 'Batavia', '1738-02-13', '1738-03-06', true, '1738-06-12', 'Texel', 3044, 'was schout-bij-nacht.');
INSERT INTO "voyages" VALUES (7006, '', 6, '', 'GAASPERDAM', 'Harke Zeres', 1150, NULL, '1724', NULL, NULL, 'A', 'A', '1737-10-31', 'Batavia', '1738-02-13', '1738-03-06', true, '1738-06-12', 'Texel', 3045, 'Aboard the GAASPERDAM was Jan de la Fontaine, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7007, '', 4, '', 'KLARABEEK', 'Jan Bijland', 705, NULL, '1721', NULL, NULL, 'Z', 'Z', '1737-10-31', 'Batavia', '1738-02-13', '1738-03-06', true, '1738-06-10', 'Rammekens', 3060, NULL);
INSERT INTO "voyages" VALUES (7008, '', 1, '', 'ARNESTUN', 'Willem Hendriksz. van Roffe', 575, NULL, '1736', NULL, NULL, 'Z', 'Z', '1737-11-02', 'Batavia', '1738-01-16', '1738-02-18', true, '1738-06-07', 'Rammekens', 3062, NULL);
INSERT INTO "voyages" VALUES (7009, '', 5, '', 'DELFLAND', 'Kornelis van Marle', 600, NULL, '1717', NULL, NULL, 'D', 'D', '1737-11-02', 'Batavia', '1738-01-18', '1738-02-18', true, '1738-06-07', 'Goeree', 2916, 'Kornelis van Marie was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (7010, '', 4, '', 'LAGE POLDER', 'Dirk Zomerman', 580, NULL, '1725', NULL, NULL, 'E', 'E', '1737-11-02', 'Batavia', '1738-01-17', '1738-02-18', true, '1738-06-07', 'Texel', 3007, NULL);
INSERT INTO "voyages" VALUES (7011, '', 2, '', 'NIEUWLAND', 'Anthonie Guldeman', 850, NULL, '1733', NULL, NULL, 'Z', 'A', '1737-11-02', 'Batavia', '1738-01-16', '1738-02-18', true, '1738-06-07', 'Texel', 3051, NULL);
INSERT INTO "voyages" VALUES (7012, '', 6, '', 'NOORDWADDINXVEEN', 'Jan Tobias Toon', 850, NULL, '1718', NULL, NULL, 'R', 'A', '1737-11-02', 'Batavia', '1738-01-02', '1738-02-18', true, '1738-06-07', 'Texel', 3022, NULL);
INSERT INTO "voyages" VALUES (7013, '', 2, '', 'VLISSINGEN', 'Pieter Bruis', 650, NULL, '1732', NULL, NULL, 'Z', 'Z', '1737-11-02', 'Batavia', '1738-01-02', '1738-02-18', true, '1738-06-06', 'Rammekens', 3011, NULL);
INSERT INTO "voyages" VALUES (7014, '', 3, '', 'ZORGWIJK', 'Gozewijn de Vos', 650, NULL, '1732', NULL, NULL, 'A', 'R', '1737-11-08', 'Batavia', '1738-01-17', '1738-02-18', true, '1738-06-10', 'Goeree', 3059, 'See 6947.');
INSERT INTO "voyages" VALUES (7015, '', 2, '', 'SIJBEKARSPEL', 'Adriaan Cats', 650, NULL, '1729', NULL, NULL, 'H', 'H', '1737-11-14', 'Batavia', '1738-01-24', '1738-02-18', true, '1738-06-09', 'Texel', 3027, NULL);
INSERT INTO "voyages" VALUES (7016, '', 1, '', 'WESTHOVEN', 'Dirk Pomp', 650, NULL, '1734', NULL, NULL, 'Z', 'A', '1737-11-28', 'Ceylon', '1738-03-06', '1738-03-26', true, '1738-06-28', 'Texel', 2997, 'Departure from Mocha on 25-11-1737.');
INSERT INTO "voyages" VALUES (7017, '', 1, '', 'GUNTERSTUN', 'Pieter Sluis', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1737-11-30', 'Batavia', '1738-02-13', '1738-03-06', true, '1738-06-12', 'Texel', 3047, NULL);
INSERT INTO "voyages" VALUES (7018, '', 1, '', 'STRIJEN', 'Jan Boelhouwer', 650, NULL, '1735', NULL, NULL, 'D', 'A', '1737-12-03', 'Bengal', '1738-02-13', '1738-03-06', true, '1738-06-11', 'Texel', 3041, 'The 92 men aboard the STRIJEN included 80 seafarers.');
INSERT INTO "voyages" VALUES (7019, '', 4, '', 'REIGERSBROEK', 'Elias Moeninx', 600, NULL, '1726', NULL, NULL, 'A', 'Z', '1737-12-17', 'Ceylon', '1738-03-06', '1738-03-26', true, NULL, NULL, 3036, 'The 91 men aboard the REIGERSBROEK included 71 seafarers. The ship was wrecked off Zeeland and smashed against the Westkapelsedijk.');
INSERT INTO "voyages" VALUES (7020, '', 2, '', 'HUIS TE MARQUETTE', 'Pieter Geel', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1737-12-19', 'Ceylon', '1738-03-06', '1738-03-26', true, '1738-06-28', 'Texel', 3020, 'The 116 men aboard the HUIS TE MARQUETTE included 93 seafarers.');
INSERT INTO "voyages" VALUES (7021, '', 4, '', 'BEEKVLIET', 'Bastiaan Mol', 850, NULL, '1724', NULL, NULL, 'A', 'A', '1737-12-23', 'China', '1738-06-11', '1738-06-25', true, '1738-09-28', 'Texel', 3037, NULL);
INSERT INTO "voyages" VALUES (7022, '', 3, '', 'KNAPPENHOF', 'Willem Cagie', 650, NULL, '1731', NULL, NULL, 'A', 'Z', '1737-12-23', 'China', '1738-05-02', '1738-06-03', true, '1738-09-12', 'Rammekens', 3003, NULL);
INSERT INTO "voyages" VALUES (7023, '', 2, '', 'BETHLEHEM', 'Jan Licent', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1738-01-15', 'Batavia', '1738-03-22', '1738-04-09', true, '1738-07-07', 'Texel', 2980, 'Vice-commandeur of the return fleet was Jakob Roman, sailing on the PATMOS (7028).');
INSERT INTO "voyages" VALUES (7024, '', 2, '', 'GOIDSCHALXOORD', 'Willem van der Velden', 850, 'fluit', '1734', NULL, NULL, 'A', 'A', '1738-01-15', 'Batavia', '1738-03-22', '1738-04-09', true, '1738-07-21', 'Texel', 3046, NULL);
INSERT INTO "voyages" VALUES (7025, '', 2, '', 'SLOT KRONENBURG', 'Jan Hugo Captijn', 350, NULL, '1733', NULL, NULL, 'A', 'E', '1738-01-15', 'Batavia', '1738-03-22', '1738-04-09', true, '1738-07-21', 'Texel', 7025, NULL);
INSERT INTO "voyages" VALUES (7026, '', 1, '', 'MIDDENRAK', 'Anthonie Uiterschouw', 350, NULL, '1734', NULL, NULL, 'A', 'A', '1738-01-15', 'Batavia', '1738-03-23', '1738-04-09', true, '1738-07-07', 'Texel', 2969, NULL);
INSERT INTO "voyages" VALUES (7027, '', 7, '', 'OOSTRUST', 'Huibert Tiebout', 1140, NULL, '1721', NULL, NULL, 'A', 'A', '1738-01-15', 'Batavia', '1738-04-02', '1738-04-09', true, '1738-07-07', 'Texel', 3052, 'The master was also mentioned as Hendrik Tiebout.');
INSERT INTO "voyages" VALUES (7028, '', 5, '', 'PATMOS', 'Arie Verdoes', 810, NULL, '1722', NULL, NULL, 'R', 'Z', '1738-01-15', 'Batavia', '1738-03-22', '1738-04-09', true, '1738-07-07', 'Rammekens', 3065, 'Aboard the PATMOS was Jakob Roman, vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7029, '', 2, '', 'RUST EN WERK', 'Hendrik Westerbeek', 650, NULL, '1734', NULL, NULL, 'D', 'D', '1738-01-15', 'Batavia', NULL, NULL, false, '1738-06-17', 'Goeree', 3067, 'at St. Helena''.');
INSERT INTO "voyages" VALUES (7030, '', 1, '', 'RIJNHUIZEN', 'Hendrik van Raa', 650, NULL, '1736', NULL, NULL, 'R', 'R', '1738-01-15', 'Batavia', '1738-03-23', '1738-04-09', true, '1738-07-06', 'Goeree', 3066, NULL);
INSERT INTO "voyages" VALUES (7031, '', 1, '', 'WATERVLIET', 'Pieter Korver', 650, NULL, '1736', NULL, NULL, 'A', 'A', '1738-01-15', 'Batavia', '1738-03-22', '1738-04-09', true, '1738-07-21', 'Texel', 3058, NULL);
INSERT INTO "voyages" VALUES (7032, '', 4, '', 'ADRICHEM', 'Kornelis Kroon', 850, NULL, '1726', NULL, NULL, 'A', 'A', '1738-02-11', 'Ceylon', '1738-04-29', '1738-06-03', true, '1738-09-12', 'Texel', 3025, 'The 118 men aboard the ADRICHEM included 93 seafarers and 7 impotenten. On 03-06-1738 the ship departed from Robben Island.');
INSERT INTO "voyages" VALUES (7033, '', 1, '', 'SINT LAURENS', 'Hendrik Bossen', 850, NULL, '1734', NULL, NULL, 'Z', 'Z', '1738-02-11', 'Ceylon', '1738-05-05', '1738-06-03', true, '1738-09-12', 'Rammekens', 2998, 'The 117 men aboard the SINT LAURENS included 93 seafarers.');
INSERT INTO "voyages" VALUES (7034, '', 1, '', 'NIEUWERKERK', 'Kornelis van de Woestijne', 1135, NULL, '1735', NULL, NULL, 'Z', 'A', '1738-02-11', 'Ceylon', '1738-05-05', '1738-06-03', true, '1738-09-12', 'Texel', 3040, NULL);
INSERT INTO "voyages" VALUES (7035, '', 1, '', 'ABBEKERK', 'Huibrecht op den Dijk', 850, NULL, '1734', NULL, NULL, 'H', 'Z', '1738-02-14', 'Batavia', NULL, NULL, false, '1738-10-27', 'Rammekens', 2993, 'The ABBEKERK became separated from the other ships of the return fleet.');
INSERT INTO "voyages" VALUES (7036, '', 3, '', 'DUIFJE', 'Jan de Jong', 450, NULL, '1729', NULL, NULL, 'A', 'Z', '1738-02-14', 'Batavia', NULL, NULL, false, '1738-08-25', 'Rammekens', 3073, NULL);
INSERT INTO "voyages" VALUES (7037, '', 2, '', 'HOFWEGEN', 'Olof Kuit +', 650, NULL, '1731', NULL, NULL, 'R', 'H', '1738-02-14', 'Batavia', '1738-05-13', '1738-06-03', true, '1738-09-12', 'Texel', 3070, 'him as master.');
INSERT INTO "voyages" VALUES (7038, '', 1, '', 'STREEFKERK', 'Willem Houthuizen', 650, NULL, '1736', NULL, NULL, 'A', 'A', '1738-02-14', 'Batavia', '1738-05-12', '1738-06-16', true, '1738-09-18', 'Texel', 3056, NULL);
INSERT INTO "voyages" VALUES (7039, '', 2, '', '''S HEER ARENDSKERKE', 'Leendert Jongebroer', 600, NULL, '1724', NULL, NULL, 'Z', 'Z', '1738-04-02', 'Batavia', '1738-07-21', '1738-07-29', true, '1738-10-26', 'Rammekens', 2837, NULL);
INSERT INTO "voyages" VALUES (7040, '', 2, '', 'BOOT', 'Jakob van Duinen', 650, NULL, '1733', NULL, NULL, 'R', 'A', '1738-04-02', 'Batavia', '1738-07-31', '1738-08-12', true, NULL, NULL, 3008, 'Wrecked in the Channel between Goudstaart and Dartmouth on 08-11-1738.');
INSERT INTO "voyages" VALUES (7041, '', 2, '', 'BEUKESTIJN', 'Samuel Hoppestijn van Leeuwen', 850, NULL, '1734', NULL, NULL, 'A', 'A', '1738-11-12', 'Batavia', '1739-02-12', '1739-03-02', true, '1739-06-22', 'Texel', 3094, 'vice-commandeur; Christiaan Bakker, master of the MAGDALENA (7045), was schout-bij-nacht.');
INSERT INTO "voyages" VALUES (7042, '', 7, '', 'CORNELIA', 'Dirk de Vet', 800, NULL, '1721', NULL, NULL, 'H', 'E', '1738-11-12', 'Batavia', '1739-02-12', '1739-03-09', true, '1739-06-18', 'Texel', 3043, NULL);
INSERT INTO "voyages" VALUES (7043, '', 2, '', 'HUIS TE FOREEST', 'Pieter Alkmaar', 850, NULL, '1731', NULL, NULL, 'H', 'A', '1738-11-12', 'Batavia', '1739-02-14', '1739-03-02', true, '1739-06-22', 'Texel', 3015, NULL);
INSERT INTO "voyages" VALUES (7044, '', 7, '', 'HILLEGONDA', 'Willem Meyer', 850, NULL, '1720', NULL, NULL, 'H', 'H', '1738-11-12', 'Batavia', '1739-02-12', '1739-03-09', true, '1739-06-18', 'Texel', 2990, NULL);
INSERT INTO "voyages" VALUES (7045, '', 7, '', 'MAGDALENA', 'Christiaan Bakker', 600, NULL, '1719', NULL, NULL, 'H', 'D', '1738-11-12', 'Batavia', '1739-02-12', '1739-03-02', true, '1739-06-25', 'Goeree', 2987, 'Christiaan Bakker was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (7046, '', 2, '', 'SCHEIJBEEK', 'Pieter Visser', 850, NULL, '1735', NULL, NULL, 'A', 'A', '1738-11-12', 'Batavia', '1739-02-12', '1739-03-09', true, '1739-06-18', 'Texel', 3096, NULL);
INSERT INTO "voyages" VALUES (7047, '', 3, '', 'VIS', 'Pieter Elsvliet', 650, NULL, '1732', NULL, NULL, 'E', 'A', '1738-11-12', 'Batavia', '1739-02-12', '1739-03-09', true, '1739-06-17', 'Texel', 3097, NULL);
INSERT INTO "voyages" VALUES (7048, '', 2, '', 'VREELAND', 'Jurriaan Zeeman', 650, NULL, '1735', NULL, NULL, 'A', 'A', '1738-11-12', 'Batavia', '1739-02-12', '1739-03-02', true, '1739-06-22', 'Texel', 3098, NULL);
INSERT INTO "voyages" VALUES (7049, '', 3, '', 'NIEUW-WALCHEREN', 'Pieter Zwanendrecht', 850, NULL, '1731', NULL, NULL, 'Z', 'Z', '1738-11-12', 'Batavia', '1739-02-14', '1739-03-02', true, '1739-06-29', 'Rammekens', 3092, 'The master was vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7050, '', 6, '', 'WICKENBURG', 'Salomon Reynders', 850, NULL, '1722', NULL, NULL, 'Z', 'Z', '1738-11-12', 'Batavia', '1739-02-16', '1739-03-02', true, '1739-06-26', 'Rammekens', 3080, NULL);
INSERT INTO "voyages" VALUES (7051, '', 3, '', 'HOF NIET ALTIJD WINTER', 'Arie de Ruyter', 650, NULL, '1723', NULL, NULL, 'Z', 'R', '1738-11-12', 'Batavia', '1739-02-14', '1739-03-09', true, '1739-06-14', 'Goeree', 2955, NULL);
INSERT INTO "voyages" VALUES (7052, '', 2, '', 'BATAVIER', 'Pieter Kaayman', 525, NULL, '1735', NULL, NULL, 'A', 'A', '1738-12-14', 'Bengal', '1739-03-13', '1739-04-01', true, '1739-07-03', 'Texel', 3082, NULL);
INSERT INTO "voyages" VALUES (7053, '', 3, '', 'HOFVLIET', 'van der Poel', 1000, NULL, '1729', NULL, NULL, 'R', 'A', '1738-12-14', 'Bengal', '1739-03-14', '1739-04-01', true, '1739-07-03', 'Texel', 3084, 'The 81 men aboard the HOFVLIET included 71 seafarers.');
INSERT INTO "voyages" VALUES (7054, '', 5, '', 'KROOSWIJK', NULL, 600, NULL, '1720', NULL, NULL, 'R', 'R', '1738-12-14', 'Bengal', NULL, NULL, true, NULL, NULL, 3006, 'Wrecked between Bengal and the Cape. Lost sight of by the accompanying ships since 17-02-1739.');
INSERT INTO "voyages" VALUES (7055, '', 3, '', 'MARIA ADRIANA', 'Willem de Wijs', 650, NULL, '1730', NULL, NULL, 'R', 'Z', '1738-12-14', 'Bengal', '1739-03-04', '1739-04-01', true, '1739-06-30', 'Rammekens', 3063, 'The 81 men aboard the MARIA ADRIANA included 70 seafarers.');
INSERT INTO "voyages" VALUES (7056, '', 6, '', 'HOGERSMILDE', 'Jan van Ingen', 810, NULL, '1723', NULL, NULL, 'A', 'A', '1738-12-21', 'China', '1739-04-11', '1739-05-15', true, '1739-08-24', 'Texel', 3078, 'After the return of the ship at Texel, its name was changed into WAPEN VAN HOORN (see 3196).');
INSERT INTO "voyages" VALUES (7057, '', 1, '', 'BUVEGNIES', 'Vegter van de Koog', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1738-12-25', 'Batavia', '1739-03-21', '1739-04-20', true, '1739-07-14', 'Texel', 3077, 'After the return of the ship at Texel, its name was changed into KASTEEL VAN WOERDEN (see 3188/7146, etc.).');
INSERT INTO "voyages" VALUES (7058, '', 1, '', 'LOVERENDAAL', 'Samuel Hendriksz.', 650, NULL, '1737', NULL, NULL, 'Z', 'Z', '1738-12-25', 'Batavia', '1739-03-21', '1739-04-09', true, '1739-07-08', 'Rammekens', 3105, NULL);
INSERT INTO "voyages" VALUES (7059, '', 1, '', 'ROOSWIJK', 'Jakob Verleng', 850, NULL, '1737', NULL, NULL, 'A', 'A', '1738-12-25', 'Batavia', '1739-03-21', '1739-04-09', true, '1739-07-11', 'Texel', 3089, NULL);
INSERT INTO "voyages" VALUES (7060, '', 3, '', 'HUIS TE SPIJK', 'Jan Kelder', 650, NULL, '1732', NULL, NULL, 'D', 'R', '1738-12-25', 'Batavia', '1739-03-20', '1739-04-09', true, '1739-07-09', 'Goeree', 3111, NULL);
INSERT INTO "voyages" VALUES (7061, '', 5, '', 'WESTERBEEK', 'Kornelis Damme', 650, NULL, '1722', NULL, NULL, 'A', 'E', '1738-12-25', 'Batavia', '1739-03-21', '1739-04-09', true, '1739-07-14', 'Texel', 3113, NULL);
INSERT INTO "voyages" VALUES (7062, '', 4, '', 'WESTKAPELLE', 'Gerrit van der Tolle', 850, NULL, '1730', NULL, NULL, 'Z', 'Z', '1738-12-25', 'Batavia', '1739-03-21', '1739-04-09', true, '1739-07-08', 'Rammekens', 3104, NULL);
INSERT INTO "voyages" VALUES (7063, '', 3, '', 'VAN ALSEM', NULL, 650, NULL, '1732', NULL, NULL, 'A', 'A', '1739-01-05', 'Ceylon', NULL, NULL, true, NULL, NULL, 3093, 'Lost between Ceylon and the Cape.');
INSERT INTO "voyages" VALUES (7064, '', 6, '', 'BERKENRODE', 'Joris van Kleef', 1150, NULL, '1723', NULL, NULL, 'A', 'A', '1739-01-05', 'Ceylon', '1739-03-14', '1739-04-20', true, '1740-07-08', 'Texel', 3083, 'The 124 men aboard the BERKENRODE included 110 seafarers.');
INSERT INTO "voyages" VALUES (7065, '', 6, '', 'EVERSWAART', 'Michiel Keizer', 850, NULL, '1723', NULL, NULL, NULL, 'Z', '1739-01-05', 'Ceylon', '1739-03-25', '1739-05-12', true, '1739-08-14', 'Rammekens', 3071, 'The 109 men aboard the EVERSWAART included 90 seafarers.');
INSERT INTO "voyages" VALUES (7066, '', 5, '', 'LANDSKROON', NULL, 850, NULL, '1725', NULL, NULL, 'A', 'A', '1739-01-05', 'Ceylon', NULL, NULL, true, NULL, NULL, 3079, 'Lost between Ceylon and the Cape.');
INSERT INTO "voyages" VALUES (7067, '', 4, '', 'PALLAS', 'Willem Schul', 650, NULL, '1723', NULL, NULL, 'A', 'Z', '1739-01-05', 'Ceylon', '1739-03-27', '1739-05-15', true, '1739-09-03', 'Rammekens', 3053, 'The 89 men aboard the PALLAS included 70 seafarers.');
INSERT INTO "voyages" VALUES (7068, '', 1, '', 'DRECHTERLAND', 'Hendrik Hessing', 250, NULL, '1736', NULL, NULL, 'H', 'A', '1739-02-02', 'Batavia', NULL, NULL, false, '1740-05-07', 'Texel', 3072, 'Stayed in England for some time.');
INSERT INTO "voyages" VALUES (7069, '', 1, '', 'ENKHUIZEN', 'Adriaan Pool', 850, NULL, '1735', NULL, NULL, 'E', 'A', '1739-02-02', 'Batavia', '1739-05-15', '1739-05-22', true, '1739-09-11', 'Texel', 3038, NULL);
INSERT INTO "voyages" VALUES (7070, '', 4, '', 'WAPEN VAN HOORN', 'Joost Anker', 850, NULL, '1723', NULL, NULL, 'H', 'A', '1739-02-02', 'Batavia', '1739-05-06', '1739-05-15', true, '1739-08-14', 'Texel', 3109, 'After the ship''s return at Texel its name was changed into HO-GERSMILDE (see 3181/7143, etc.).');
INSERT INTO "voyages" VALUES (7071, '', 1, '', 'SCHELLAG', 'Jan Elswout', 850, NULL, '1736', NULL, NULL, 'Z', 'Z', '1739-02-02', 'Batavia', '1739-05-17', '1739-06-01', true, '1739-09-08', 'Rammekens', 3075, NULL);
INSERT INTO "voyages" VALUES (7072, '', 6, '', 'KASTEEL VAN WOERDEN', 'Jan van Heemstede', 850, NULL, '1722', NULL, NULL, 'D', 'A', '1739-02-02', 'Batavia', NULL, NULL, false, '1739-08-14', 'Texel', 3114, 'After the arrival of the ship at Texel its name was changed into BUVEGNIES (see 3179).');
INSERT INTO "voyages" VALUES (7073, '', 1, '', 'RUYVEN', 'Adriaan Katersveld', 650, NULL, '1737', NULL, NULL, 'D', 'A', '1739-04-07', 'Batavia', '1739-07-07', '1739-07-15', true, '1739-11-08', 'Texel', 3086, NULL);
INSERT INTO "voyages" VALUES (7074, '', 2, '', 'JONGE WILLEM', 'Adriaan Maarseveen', 650, NULL, '1731', NULL, NULL, 'Z', 'Z', '1739-04-07', 'Batavia', NULL, NULL, false, '1739-09-15', 'Rammekens', 3068, 'According to K.A. 4119, fol. 819, the JONGE WILLEM was to call at St. Helena.');
INSERT INTO "voyages" VALUES (7075, '', 2, '', 'GUNTERSTUN', 'Kornelis Kroon', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1739-11-08', 'Batavia', '1740-01-28', '1740-03-09', true, '1740-07-08', 'Texel', 3135, 'Commandeur of the return fleet was Adriaan Bergsma aboard the GUNTERSTIJN; IJsbrand Moens, master of the WEST-HOVEN (7080), was vice-commandeur; schout-bij-nacht  was Daniel Udemans, master of the RUST EN WERK (7079).');
INSERT INTO "voyages" VALUES (7076, '', 4, '', 'LEIDUIN', 'Dirk Quast', 650, NULL, '1730', NULL, NULL, 'A', 'E', '1739-11-08', 'Batavia', '1740-01-28', '1740-03-09', true, '1749-07-08', 'Texel', 3115, NULL);
INSERT INTO "voyages" VALUES (7077, '', 4, '', 'MEERLUST', 'Hendrik van Beek', 600, NULL, '1725', NULL, NULL, 'A', 'H', '1739-11-08', 'Batavia', '1740-01-28', '1740-03-09', true, '1740-07-08', 'Texel', 3050, NULL);
INSERT INTO "voyages" VALUES (7078, '', 2, '', 'NOORDWOLFSBERGEN', 'David van Elteren', 650, NULL, '1733', NULL, NULL, 'A', 'A', '1739-11-08', 'Batavia', '1740-01-28', '1740-03-09', true, '1740-07-08', 'Texel', 3002, NULL);
INSERT INTO "voyages" VALUES (7079, '', 3, '', 'RUST EN WERK', 'Daniel Udemans', 650, NULL, '1734', NULL, NULL, 'D', 'D', '1739-11-08', 'Batavia', '1740-01-28', '1740-03-09', true, '1740-07-09', 'Goeree', 3124, 'Daniel Udemans was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (7080, '', 2, '', 'WESTHOVEN', 'Usbrand Moens', 650, NULL, '1734', NULL, NULL, 'Z', 'Z', '1739-11-08', 'Batavia', '1740-01-28', '1740-03-09', true, '1740-07-10', 'Rammekens', 3142, 'Usbrand Moens was vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7081, '', 5, '', 'COXHOORN', 'Jan Mijsters', 450, NULL, '1728', NULL, NULL, 'A', 'A', '1739-11-25', 'Bengal', '1740-02-15', '1740-03-09', true, '1740-07-08', 'Texel', 3119, 'Laid up on 28-11-1741.');
INSERT INTO "voyages" VALUES (7082, '', 3, '', 'HAAMSTEDE', 'Willem van Eyk', 650, NULL, '1730', NULL, NULL, 'D', 'H', '1739-11-25', 'Bengal', '1740-02-11', '1740-03-09', true, '1740-07-08', 'Texel', 3108, NULL);
INSERT INTO "voyages" VALUES (7083, '', 1, '', 'RUITER', 'Jakob Pols', 650, NULL, '1736', NULL, NULL, 'E', 'A', '1739-11-25', 'Bengal', '1740-03-06', '1740-04-03', true, '1740-07-10', 'Texel', 3069, 'The 83 men aboard the RUITER included 70 seafarers.');
INSERT INTO "voyages" VALUES (7084, '', 3, '', 'VLISSINGEN', 'Anthonie Uiterschouw', 650, NULL, '1732', NULL, NULL, 'Z', 'Z', '1739-11-25', 'Bengal', '1740-02-17', '1740-03-09', true, '1740-07-10', 'Rammekens', 3123, 'The 85 men aboard the VLISSINGEN included 75 seafarers.');
INSERT INTO "voyages" VALUES (7085, '', 2, '', 'KERKZICHT', 'Huyg Kuyper', 650, NULL, '1735', NULL, NULL, 'A', 'D', '1739-12-10', 'Batavia', NULL, NULL, true, NULL, NULL, 3099, 'Wrecked between Batavia and the Cape. Commandeur of the return fleet was Jurriaan Wolbergen, master of the KASTEEL VAN TILBURG (7088).');
INSERT INTO "voyages" VALUES (7086, '', 6, '', 'KLARABEEK', 'Adriaan Cats', 705, NULL, '1721', NULL, NULL, 'Z', 'R', '1739-12-10', 'Batavia', NULL, NULL, true, NULL, NULL, 3145, 'Wrecked between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7087, '', 2, '', 'SINT LAURENS', 'Pieter van Hoorn', 850, NULL, '1734', NULL, NULL, 'Z', 'Z', '1739-12-10', 'Batavia', NULL, NULL, true, NULL, NULL, 3147, 'between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7088, '', 1, '', 'KASTEEL VAN TILBURG', 'Jurriaan Wolbergen', 850, NULL, '1737', NULL, NULL, 'A', 'A', '1739-12-10', 'Batavia', NULL, NULL, true, NULL, NULL, 3087, 'Jurriaan Wolbergen was commandeur of the return fleet. The KASTEEL VAN TILBURG was wrecked between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7089, '', 2, '', 'VENENBURG', NULL, 650, NULL, '1734', NULL, NULL, 'A', 'H', '1739-12-10', 'Batavia', NULL, NULL, true, NULL, NULL, 3057, 'Wrecked between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7090, '', 2, '', 'HUIS DEN EULT', 'Jan van Schutterop', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1739-12-15', 'China', '1740-05-02', '1740-05-31', true, '1740-09-21', 'Texel', 3116, NULL);
INSERT INTO "voyages" VALUES (7091, '', 3, '', 'KERKWIJK', 'Gerrit Leenderts+', 850, NULL, '1733', NULL, NULL, 'A', 'A', '1739-12-16', 'Batavia', '1740-03-06', '1740-04-03', true, '1740-07-10', 'Texel', 3085, 'Gerrit Leenderts died, Klaas Nierop succeeded him as master.');
INSERT INTO "voyages" VALUES (7092, '', 1, '', 'DIEMERMEER', 'Pieter Korver', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1739-12-21', 'Ceylon', '1740-03-18', '1740-04-03', true, '1740-07-10', 'Texel', 3127, NULL);
INSERT INTO "voyages" VALUES (7093, '', 7, '', 'NIEUWVLIET', 'Huibert Tiebout', 650, NULL, '1719', NULL, NULL, 'Z', 'Z', '1739-12-21', 'Ceylon', '1740-03-14', '1740-04-03', true, '1740-07-13', 'Rammekens', 3091, 'The master was also mentioned as Hendrik Tiebout.');
INSERT INTO "voyages" VALUES (7094, '', 2, '', 'HUIS TE RENSBURG', 'Wijnand Meurs', 850, NULL, '1733', NULL, NULL, 'Z', 'Z', '1739-12-21', 'Ceylon', '1740-03-27', '1740-04-03', true, '1740-07-13', 'Rammekens', 3061, 'The 3 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7095, '', 4, '', 'VOORDUIN', 'Pieter Kouderk', 650, NULL, '1730', NULL, NULL, 'A', 'A', '1739-12-21', 'Ceylon', '1740-03-15', '1740-04-03', true, '1740-07-10', 'Texel', 3112, 'See 6844.');
INSERT INTO "voyages" VALUES (7096, '', 3, '', '''S HEER ARENDSKERKE', 'Mattheus Feris du Rietz', 600, NULL, '1724', NULL, NULL, 'Z', 'Z', '1740-01-10', 'Batavia', '1740-04-30', '1740-05-31', true, '1740-09-19', 'Rammekens', 3143, NULL);
INSERT INTO "voyages" VALUES (7097, '', 6, '', 'DELFLAND', 'Arie Verdoes', 600, NULL, '1717', NULL, NULL, 'D', 'Z', '1740-01-10', 'Batavia', '1740-05-09', '1740-05-31', true, '1740-09-19', 'Rammekens', 3150, NULL);
INSERT INTO "voyages" VALUES (7098, '', 4, '', 'DUIFJE', 'Frederik Hendrik Schouten', 450, NULL, '1729', NULL, NULL, 'A', 'A', '1740-01-10', 'Batavia', '1740-03-14', '1740-05-31', true, '1740-09-20', 'Texel', 3144, NULL);
INSERT INTO "voyages" VALUES (7099, '', 7, '', 'PATMOS', 'Jan. de Jong', 810, NULL, '1722', NULL, NULL, 'R', 'A', '1740-01-10', 'Batavia', NULL, NULL, false, '1740-08-10', 'Texel', 3148, NULL);
INSERT INTO "voyages" VALUES (7100, '', 2, '', 'POPKENSBURG', 'N. Muller', 850, NULL, '1732', NULL, NULL, 'Z', 'A', '1740-01-10', 'Batavia', '1740-04-27', '1740-05-31', true, '1740-09-20', 'Texel', 3076, NULL);
INSERT INTO "voyages" VALUES (7101, '', 2, '', 'HARTENLUST', 'Bastiaan Koolmans', 650, NULL, '1734', NULL, NULL, 'A', 'Z', '1740-04-02', 'Batavia', '1740-10-06', '1741-01-08', true, '1740-04-28', 'Rammekens', 3048, NULL);
INSERT INTO "voyages" VALUES (7102, '', 2, '', 'LANGEWIJK', 'Daniel Tuineman', 850, NULL, '1734', NULL, NULL, 'E', 'A', '1740-04-02', 'Batavia', NULL, NULL, true, NULL, NULL, 3088, 'Lost between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7103, '', 3, '', 'BEUKESTIJN', 'Jan de Boer', 850, NULL, '1734', NULL, NULL, 'A', 'A', '1740-11-03', 'Batavia', '1741-01-25', '1741-03-16', true, '1741-07-27', 'Texel', 3172, 'Commandeur of the return fleet was Gerardus Bernardus Visser aboard the BEUKESTIJN; Jan Govaarts, master of the SARA JACOBA (7109), was vice-commandeur; schout-bij-nacht was Reinier Brugman, master of the VREELAND (7110).');
INSERT INTO "voyages" VALUES (7104, '', 7, '', 'EVERSWAART', 'Jan Bijland', 850, NULL, '1723', NULL, NULL, 'Z', 'Z', '1740-11-03', 'Batavia', '1741-01-25', '1741-03-16', true, '1741-08-05', 'Rammekens', 3176, NULL);
INSERT INTO "voyages" VALUES (7105, '', 3, '', 'GOIDSCHALXOORD', 'Frans van Nek', 850, 'fluit', '1734', NULL, NULL, 'A', 'A', '1740-11-03', 'Batavia', '1741-01-29', '1741-03-16', true, '1741-07-29', 'Texel', 3134, NULL);
INSERT INTO "voyages" VALUES (7106, '', 3, '', 'HOFWEGEN', 'Jan de Wit', 650, NULL, '1731', NULL, NULL, 'R', 'R', '1740-11-03', 'Batavia', '1741-01-29', '1741-03-16', true, '1741-07-20', 'Goeree', 3139, NULL);
INSERT INTO "voyages" VALUES (7107, '', 1, '', 'OUWERKERK', 'Jan van Thiel', 540, NULL, '1738', NULL, NULL, 'Z', 'E', '1740-11-03', 'Batavia', '1741-01-26', '1741-03-16', true, '1741-07-27', 'Texel', 3162, NULL);
INSERT INTO "voyages" VALUES (7108, '', 2, '', 'RIJNHUIZEN', 'Hendrik van Raa', 650, NULL, '1736', NULL, NULL, 'R', 'H', '1740-11-03', 'Batavia', '1741-02-05', '1741-03-16', true, '1741-07-10', 'Texel', 3125, NULL);
INSERT INTO "voyages" VALUES (7109, '', 1, '', 'SARA JACOBA', 'Jan Govaarts', 1100, NULL, '1737', NULL, NULL, 'Z', 'Z', '1740-11-03', 'Batavia', '1741-01-29', '1741-03-16', true, '1741-08-01', 'Rammekens', 3121, 'Jan Govaarts was vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7110, '', 3, '', 'VREELAND', 'Reinier Brugman', 650, NULL, '1735', NULL, NULL, 'A', 'D', '1740-11-03', 'Batavia', '1741-01-25', '1741-03-16', true, '1741-07-30', 'Goeree', 3167, 'Reinier Brugman was schout-bij-nacht of the return fleet.');
INSERT INTO "voyages" VALUES (7111, '', 1, '', 'DISHOEK', 'Gerrit Reyndertsz. Vos', 665, NULL, '1735', NULL, NULL, 'Z', 'Z', '1740-11-30', 'Bengal', '1741-03-10', '1741-04-03', true, '1741-07-30', 'Rammekens', 3039, NULL);
INSERT INTO "voyages" VALUES (7112, '', 1, '', 'HORSSEN', 'Jan Luders', 650, NULL, '1739', NULL, NULL, 'A', 'A', '1740-11-30', 'Bengal', '1741-02-25', '1741-03-16', true, '1741-07-29', 'Texel', 3165, NULL);
INSERT INTO "voyages" VALUES (7113, '', 4, '', 'KNAPPENHOF', 'Douwe Jansz. Mout', 650, NULL, '1731', NULL, NULL, 'A', 'D', '1740-11-30', 'Bengal', '1741-03-02', '1741-03-16', true, '1741-07-20', 'Goeree', 3160, NULL);
INSERT INTO "voyages" VALUES (7114, '', 3, '', 'SIJBEKARSPEL', 'Gerrit Munt', 650, NULL, '1729', NULL, NULL, 'H', 'A', '1740-11-30', 'Bengal', '1741-02-27', '1741-03-16', true, '1741-07-23', 'Texel', 3152, NULL);
INSERT INTO "voyages" VALUES (7115, '', 2, '', 'HILVERSBEEK', 'Frans de Put', 850, NULL, '1735', NULL, NULL, 'A', 'A', '1740-12-03', 'Batavia', '1741-01-30', '1741-03-16', true, NULL, NULL, 3103, '28-06-1741.');
INSERT INTO "voyages" VALUES (7116, '', 4, '', 'NIEUW WALCHEREN', 'Jan Reynders', 850, NULL, '1731', NULL, NULL, 'Z', 'A', '1740-12-03', 'Batavia', '1741-01-29', '1741-03-16', true, '1741-07-27', 'Texel', 3175, NULL);
INSERT INTO "voyages" VALUES (7117, '', 3, '', 'BETHLEHEM', 'Gozewijn de Vos', 850, NULL, '1731', NULL, NULL, 'A', 'A', '1740-12-10', 'China', '1741-03-11', '1741-04-03', true, '1741-07-29', 'Texel', 3154, NULL);
INSERT INTO "voyages" VALUES (7118, '', 2, '', 'LOVERENDAAL', 'Samuel Hendriksz.', 650, NULL, '1737', NULL, NULL, 'Z', 'Z', '1740-12-18', 'Ceylon', '1741-02-24', '1741-03-16', true, '1741-07-30', 'Rammekens', 3161, NULL);
INSERT INTO "voyages" VALUES (7119, '', 3, '', 'HUIS TE MARQUETTE', 'Hendrik Bossen', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1740-12-18', 'Ceylon', '1741-02-25', '1741-03-16', true, '1741-07-10', 'Texel', 3155, NULL);
INSERT INTO "voyages" VALUES (7120, '', 3, '', 'SCHEIJBEEK', 'Jan Berkmans', 850, NULL, '1735', NULL, NULL, 'A', 'Z', '1740-12-21', 'China', '1741-03-12', '1741-04-03', true, '1741-07-30', 'Rammekens', 3164, NULL);
INSERT INTO "voyages" VALUES (7121, '', 5, '', 'ADRICHEM', 'Bastiaan Mol', 850, NULL, '1726', NULL, NULL, 'A', 'A', '1741-01-14', 'Batavia', '1741-04-23', '1741-05-10', true, '1741-09-19', 'Texel', 3153, 'Commandeur of the return fleet was Kornelis van Marle, master of the NIEUWERKERK (7123).');
INSERT INTO "voyages" VALUES (7122, '', 1, '', 'HOF VAN DELFT', 'Jean Belleveau', 850, NULL, '1739', NULL, NULL, 'D', 'R', '1741-01-14', 'Batavia', '1741-04-16', '1741-05-10', true, '1741-09-20', 'Goeree', 3177, NULL);
INSERT INTO "voyages" VALUES (7123, '', 2, '', 'NIEUWERKERK', 'Kornelis van Marie', 1135, NULL, '1135', NULL, NULL, 'Z', 'A', '1741-01-14', 'Batavia', '1741-04-13', '1741-05-10', true, '1741-09-09', 'Texel', 3140, 'Kornelis van Marle was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7124, '', 2, '', 'SCHELLAG', 'Willem Hendriksz. van Roffe', 850, NULL, '1736', NULL, NULL, 'Z', 'Z', '1741-01-14', 'Batavia', '1741-04-14', '1741-05-10', true, '1741-09-27', 'Rammekens', 3178, NULL);
INSERT INTO "voyages" VALUES (7125, '', 2, '', 'WATERVLIET', 'Willem Houthuizen', 650, NULL, '1736', NULL, NULL, 'A', 'H', '1741-01-14', 'Batavia', '1741-04-30', '1741-05-10', true, '1741-09-26', 'Texel', 3137, NULL);
INSERT INTO "voyages" VALUES (7126, '', 4, '', 'PAPENBURG', 'Dominikus Wormhout', 800, NULL, '1729', NULL, NULL, 'A', 'A', '1741-02-04', 'Ceylon', '1741-05-02', '1741-05-10', true, '1741-09-19', 'Texel', 3117, 'The 8 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7127, '', 7, '', 'WICKENBURG', 'Walle', 850, NULL, '1722', NULL, NULL, 'Z', 'A', '1741-02-04', 'Ceylon', '1741-05-01', '1741-05-10', true, '1741-09-09', 'Texel', 3169, 'One of the passengers was a condemned person.');
INSERT INTO "voyages" VALUES (7128, '', 2, '', 'ARNESTUN', 'Johan Splinter Stavorinus', 575, NULL, '1736', NULL, NULL, 'Z', 'A', '1741-03-28', 'Batavia', '1741-08-10', '1741-08-24', true, '1741-12-10', 'Texel', 3122, NULL);
INSERT INTO "voyages" VALUES (7129, '', 1, '', 'POLANEN', 'Nikolaas van Ewijk', 650, NULL, '1737', NULL, NULL, 'A', 'A', '1741-03-28', 'Batavia', '1741-07-02', '1741-07-19', true, '1741-11-02', 'Texel', 3100, NULL);
INSERT INTO "voyages" VALUES (7130, '', 1, '', 'AMSTERDAM', 'Pieter Visser', 850, NULL, '1740', NULL, NULL, 'A', 'A', '1741-11-07', 'Batavia', '1742-01-25', '1742-03-15', true, NULL, NULL, 3194, 'Valkenier was transported back to Batavia (see 3241). The AMSTERDAM was wrecked off the Shetland Islands.');
INSERT INTO "voyages" VALUES (7131, '', 3, '', 'BATAVIER', 'Jakob Verleng', 525, NULL, '1735', NULL, NULL, 'A', 'A', '1741-12-04', 'Bengal', '1742-02-20', '1742-03-05', true, '1742-06-20', 'Texel', 3186, 'The 84 men aboard the BATAVIER included 60 seafarers.');
INSERT INTO "voyages" VALUES (7132, '', 4, '', 'HOFVLIET', 'Kornelis van Velden', 1000, NULL, '1729', NULL, NULL, 'R', 'E', '1741-12-04', 'Bengal', '1742-02-19', '1742-03-05', true, '1742-07-20', 'Texel', 3195, 'The 86 men aboard the HOFVLIET included 75 seafarers.');
INSERT INTO "voyages" VALUES (7133, '', 4, '', 'HUIS TE SPIJK', 'Willem de Wijs', 650, NULL, '1732', NULL, NULL, 'D', 'Z', '1741-12-04', 'Bengal', '1742-02-24', '1742-03-15', true, '1742-06-25', 'Rammekens', 3170, NULL);
INSERT INTO "voyages" VALUES (7134, '', 1, '', 'ANANAS', 'Jakob Popta', 650, NULL, '1738', NULL, NULL, 'A', 'A', '1741-12-15', 'Batavia', '1742-05-27', '1742-06-23', true, NULL, NULL, 3126, 'The ANANAS called at False Bay. On 17-10-1742 it ran ashore off Calais. Schout-bij-nacht of the return fleet was Jan van Heemstede, master of the STRIJEN (7137).');
INSERT INTO "voyages" VALUES (7135, '', 1, '', 'HUIS TER DUINE', 'Jan Jorisz.', 550, NULL, '1739', NULL, NULL, 'Z', 'Z', '1741-12-15', 'Batavia', NULL, NULL, false, '1742-07-20', 'Rammekens', 3202, NULL);
INSERT INTO "voyages" VALUES (7136, '', 1, '', 'DUDE ZIJPE', 'Joost Anker', 650, NULL, '1730', NULL, NULL, 'H', 'E', '1741-12-15', 'Batavia', '1742-04-22', '1742-05-11', true, NULL, NULL, 3189, 'The 99 men aboard the OUDE ZIJPE included 12 impotenten and 14 passengers. The ship ran ashore off Zandvoort, 19/20-09-1742. Wreck discovered.');
INSERT INTO "voyages" VALUES (7137, '', 2, '', 'STRUEN', 'Jan van Heemstede', 650, NULL, '1735', NULL, NULL, 'D', 'D', '1741-12-19', 'Batavia', '1742-04-15', '1742-05-11', true, '1742-09-15', 'Goeree', 3132, 'Jan van Heemstede was schout-bij-nacht of the return fleet. The 90 men aboard the STRIJEN included 14 impotenten.');
INSERT INTO "voyages" VALUES (7138, '', 2, '', 'ENKHUIZEN', 'Dirk Zomerman', 850, NULL, '1735', NULL, NULL, 'E', 'A', '1741-12-31', 'China', '1742-05-28', '1742-06-12', true, NULL, NULL, 3180, 'On 27-05-1742 the ENKHUIZEN arrived at Robben Island. Lost between the Cape and Patria. See also 3274.');
INSERT INTO "voyages" VALUES (7139, '', 2, '', 'ABBEKERK', 'Dirk van der Poel', 850, NULL, '1734', NULL, NULL, 'H', 'H', '1742-01-02', 'Batavia', '1742-05-31', '1742-06-12', true, NULL, NULL, 3156, 'The 116 man aboard the ABBEKERK included 16 impotenten and 6 passengers. The ship was wrecked between the Cape and Patria. See also 3313.');
INSERT INTO "voyages" VALUES (7140, '', 1, '', 'MAARSSEVEEN', 'Gerrit van der Tolle', 850, NULL, '1739', NULL, NULL, 'A', 'A', '1742-01-07', 'Batavia', '1742-04-25', '1742-05-11', true, '1742-09-18', 'Rammekens', 3159, 'from the Cape on 11-05-1742; commandeur was Jan Paul Schagen aboard the WELTEVRE-DEN (7144).');
INSERT INTO "voyages" VALUES (7141, '', 2, '', 'RUYVEN', 'Koenraad van der Poet', 650, NULL, '1737', NULL, NULL, 'D', 'R', '1742-01-07', 'Batavia', '1742-05-30', '1742-06-12', true, '1742-09-30', 'Goeree', 3197, 'The 93 men aboard the RUYVEN included 14 impotenten and 2 passengers.');
INSERT INTO "voyages" VALUES (7142, '', 1, '', 'HORSTENDAAL', 'Jan Kelder', 850, NULL, '1739', NULL, NULL, 'A', 'A', '1742-01-19', 'Batavia', '1742-04-22', '1742-05-11', true, '1742-09-19', 'Texel', 3158, 'The 115 men aboard the HORSTENDAAL included 11 impotenten and 5 passengers. On 18-09-1742 the ship ran ashore between Callantsoog and Huisduinen in the Buizegat.');
INSERT INTO "voyages" VALUES (7143, '', 5, '', 'HOGERSMILDE', 'Arie van Veurden', 850, NULL, '1723', NULL, NULL, 'H', 'Z', '1742-01-27', 'Ceylon', '1742-04-22', '1742-05-11', true, '1742-09-19', 'Texel', 3181, 'of this ship, which during its four preceding voyages was called WAPEN VAN HOORN (numbers of the fourth voyage: 3109/7070).');
INSERT INTO "voyages" VALUES (7144, '', 1, '', 'WELTEVREDEN', 'Willem Vroom', 850, NULL, '1740', NULL, NULL, 'A', 'A', '1742-01-27', 'Ceylon', '1742-04-21', '1742-05-11', true, '1742-09-01', 'Texel', 3199, 'Aboard the WELTEVREDEN was Jan Paul Schagen, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7145, '', 6, '', 'WESTERBEEK', 'Herman Schutte', 650, NULL, '1722', NULL, NULL, 'A', 'Z', '1742-01-27', 'Ceylon', '1742-04-22', '1742-05-11', true, NULL, NULL, 3185, 'The WESTERBEEK ran ashore off Fero on 02-09-1742.');
INSERT INTO "voyages" VALUES (7146, '', 2, '', 'KASTEEL VAN WOERDEN', 'Harke Zeres', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1742-01-27', 'Ceylon', '1742-04-22', '1742-05-11', true, '1742-09-11', 'Texel', 3188, 'was called BUVEGN-IES.');
INSERT INTO "voyages" VALUES (7147, '', 1, '', 'HEUVEL', 'Hendrik Detering', 650, NULL, '1740', NULL, NULL, 'A', 'A', '1742-02-13', 'Batavia', '1742-06-14', '1742-07-16', true, '1743-01-02', 'Texel', 3205, 'According to K.A. 4390a George Witto was master of the HEU-VEL (upon arrival at Texel?). The ship did not call at the Cape but at Saldanha Bay.');
INSERT INTO "voyages" VALUES (7148, '', 1, '', 'ROZENBEEK', 'Nanning Broeder', 200, 'galjoot', '1731', NULL, NULL, 'A', 'A', '1742-02-27', 'The Cape', '1742-02-27', NULL, true, '1742-06-01', 'Texel', 3220, 'The ROZENBEEK was laid up at Amsterdam, 26-03-1753.');
INSERT INTO "voyages" VALUES (7149, '', 4, '', 'EN WERK', 'Willem van Eyk', 650, NULL, '1734', NULL, NULL, 'D', 'A', '1742-04-07', 'Batavia', '1742-07-14', '1742-08-20', true, '1743-02-10', 'Texel', 3191, 'The 82 men aboard the RUST EN WERK included 2 passengers. The ship did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7150, '', 3, '', 'JONGE WILLEM', 'Daniel Udemans', 650, NULL, '1731', NULL, NULL, 'Z', 'Z', '1742-04-07', 'Batavia', '1742-08-17', '1742-10-05', true, '1743-02-08', 'Rammekens', 3203, 'The JONGE WILLEM did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7151, '', 3, '', 'DIEMERMEER', 'Jan Tobias Toon', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1742-12-07', 'Batavia', '1743-02-12', '1743-03-21', true, '1743-07-19', 'Texel', 3200, 'Commandeur of the ships that departed from the Cape on 19 and 21-03-1743 was Hendrik Westerbeek, master of the HUIS TE MARQUETTE (7153), Meindert de Beer, master of the OU-WERKERK (7154), was vice-commandeur; Pieter Jellesz., master of the TOLSDUIN (7157), was schout-bij-nacht.');
INSERT INTO "voyages" VALUES (7152, '', 6, '', 'KETEL', 'Christiaan Boord', 810, NULL, '1721', NULL, NULL, 'R', 'R', '1742-12-07', 'Batavia', '1743-02-12', '1743-03-19', true, '1743-07-19', 'Goeree', 3049, NULL);
INSERT INTO "voyages" VALUES (7153, '', 4, '', 'HUIS TE MARQUETTE', 'Hendrik Westerbeek', 850, NULL, '1730', NULL, NULL, 'A', 'A', '1742-12-07', 'Batavia', '1743-02-12', '1743-03-21', true, '1743-07-19', 'Texel', 3236, 'Hendrik Westerbeek was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7154, '', 2, '', 'OUWERKERK', 'Meindert de Beer', 540, NULL, '1738', NULL, NULL, 'Z', 'Z', '1742-12-07', 'Batavia', '1743-02-12', '1743-03-19', true, '1743-07-20', 'Rammekens', 3237, 'Meindert de Beer was vice-commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7155, '', 3, '', 'HUIS TE FOREEST', 'Jan Albertsz.', 850, NULL, '1731', NULL, NULL, 'H', 'A', '1742-12-18', 'China', '1743-03-15', '1743-03-21', true, '1743-07-19', 'Texel', 3187, 'The 110 men aboard the HUIS TE FOREEST included 100 seafarers.');
INSERT INTO "voyages" VALUES (7156, '', 3, '', 'NIEUWLAND', 'Leendert Jongebroer', 850, NULL, '1733', NULL, NULL, 'Z', 'H', '1742-12-19', 'Batavia', '1743-03-15', '1743-04-24', true, '1743-08-13', 'Texel', 3129, 'The 108 men aboard the NIEUWLAND included 90 seafarers and 3 passengers. From 13 till 15-03-1743 the ship was at anchor at Robben Island.');
INSERT INTO "voyages" VALUES (7157, '', 1, '', 'TOLSDUIN', 'Pieter Jellesz.', 850, NULL, '1741', NULL, NULL, 'A', 'D', '1742-12-20', 'Batavia', '1743-03-17', '1743-03-21', true, '1743-07-20', 'Goeree', 3226, 'Pieter Jellesz. was schout-bij-nacht of the return fleet. The 117 men aboard the TOLSDUIN included 90 seafarers.');
INSERT INTO "voyages" VALUES (7158, '', 1, '', 'BOSBEEK', 'Maarten van der Meer', 650, NULL, '1741', NULL, NULL, 'A', 'A', '1742-12-26', 'Bengal', '1743-03-11', '1743-03-21', true, '1743-07-19', 'Texel', 3221, 'The 83 men aboard the BOSBEEK included 80 seafarers.');
INSERT INTO "voyages" VALUES (7159, '', 4, '', 'HAAMSTEDE', NULL, 650, NULL, '1730', NULL, NULL, 'D', NULL, '1742-12-26', 'Bengal', NULL, NULL, true, NULL, NULL, 3201, 'According to K.A. 2448 the HAAMSTEDE departed from Bengal together with the BOSBEEK (7158).');
INSERT INTO "voyages" VALUES (7160, '', 2, '', 'RUITER', 'Paulus Pieman', 650, NULL, '1736', NULL, NULL, 'E', 'A', '1742-12-26', 'Bengal', '1743-03-11', '1743-03-21', true, '1743-07-19', 'Texel', 3209, NULL);
INSERT INTO "voyages" VALUES (7161, '', 3, '', 'SCHONAUWEN', 'Kornelis Kroon', 600, NULL, '1729', NULL, NULL, 'A', 'Z', '1742-12-26', 'Bengal', '1743-03-10', '1743-04-21', true, '1743-07-19', 'Rammekens', 3074, 'The 86 men aboard the SCHONAUWEN included 70 seafarers.');
INSERT INTO "voyages" VALUES (7162, '', 1, '', 'VELSEN', NULL, 600, NULL, '1737', NULL, NULL, 'A', NULL, '1742-12-26', 'Bengal', NULL, NULL, true, NULL, NULL, 3090, '2442 the VELSEN departed from Bengal together with the VRIJHEID (7163) and the SCHONAUWEN (7161).');
INSERT INTO "voyages" VALUES (7163, '', 1, '', 'VRIJHEID', 'Jakob Pols', 650, NULL, '1740', NULL, NULL, 'R', 'D', '1742-12-26', 'Bengal', '1743-03-11', '1743-04-21', true, '1743-07-19', 'Goeree', 3211, 'The 87 men aboard the VRIJHEID included 70 seafarers.');
INSERT INTO "voyages" VALUES (7164, '', 1, '', 'KRABBENDUKE', 'David van Elteren', 830, NULL, '1738', NULL, NULL, 'Z', 'Z', '1743-01-04', 'China', '1743-04-13', '1743-04-24', true, '1743-08-18', 'Rammekens', 3146, 'The 108 men aboard the KRABBENDIJKE included 100 seafarers.');
INSERT INTO "voyages" VALUES (7165, '', 5, '', 'MEERLUST', 'Gerrit Blauwpot', 600, NULL, '1725', NULL, NULL, 'A', 'A', '1743-01-09', 'Ceylon', '1743-03-22', '1743-04-11', true, '1743-07-22', 'Texel', 3218, 'The 83 men aboard the MEERLUST included 70 seafarers and 3 impotenten.');
INSERT INTO "voyages" VALUES (7166, '', 1, '', 'REIGERSDAAL', 'Jakob van Banken', 850, NULL, '1738', NULL, NULL, 'A', 'Z', '1743-01-09', 'Ceylon', '1743-03-23', '1743-04-11', true, '1743-07-21', 'Rammekens', 3131, NULL);
INSERT INTO "voyages" VALUES (7167, '', 4, '', 'SIJBEKARSPEL', 'Barend de Bruin', 650, NULL, '1729', NULL, NULL, 'H', 'A', '1743-01-09', 'Ceylon', '1743-03-23', '1743-04-11', true, '1743-07-22', 'Goeree', 3227, 'The 85 men aboard the SIJBEKARSPEL included 70 seafarers and 2 impotenten.');
INSERT INTO "voyages" VALUES (7168, '', 1, '', 'WOITENSDORP', 'Kornelis Bommer', 800, NULL, '1739', NULL, NULL, 'Z', 'A', '1743-01-09', 'Ceylon', '1743-03-23', '1743-04-11', true, '1743-07-22', 'Texel', 3193, NULL);
INSERT INTO "voyages" VALUES (7169, '', 5, '', 'KNAPPENHOF', 'Gozewijn de Vos', 650, NULL, '1731', NULL, NULL, 'A', 'A', '1743-01-14', 'Batavia', NULL, NULL, false, '1743-10-19', 'Texel', 3231, NULL);
INSERT INTO "voyages" VALUES (7170, '', 4, '', 'MARIA ADRIANA', 'Jan Elswout', 650, NULL, '1730', NULL, NULL, 'R', 'Z', '1743-01-14', 'Batavia', '1743-08-01', '1743-09-14', true, NULL, NULL, 3184, 'Missing between the Cape and Patria.');
INSERT INTO "voyages" VALUES (7171, '', 3, '', 'RIJNHUIZEN', 'Gerrit Reyndertsz. Vos', 650, NULL, '1736', NULL, NULL, 'R', 'D', '1743-01-14', 'Batavia', '1743-07-22', '1743-09-12', true, '1734-12-31', 'Rammekens', 3238, 'The RIJNHUIZEN did not call at the Cape but at False Bay. Arrival at Texel: 05-04-1744.');
INSERT INTO "voyages" VALUES (7172, '', 4, '', 'VREELAND', 'Arie Verdoes', 650, NULL, '1735', NULL, NULL, 'A', 'E', '1743-01-14', 'Batavia', '1743-05-28', '1743-06-12', true, '1743-10-30', 'Texel', 3232, NULL);
INSERT INTO "voyages" VALUES (7173, '', 1, '', 'HECTOR', 'Jan Raay', NULL, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1743-02-03', 'The Cape', '1743-02-03', NULL, true, '1743-06-10', 'Texel', 3120, NULL);
INSERT INTO "voyages" VALUES (7174, '', 2, '', 'HOF VAN DELFT', 'Jakob van Duinen', 850, NULL, '1739', NULL, NULL, 'D', 'A', '1743-04-05', 'Batavia', '1743-06-22', '1743-08-11', true, '1743-11-19', 'Rammekens', 3242, 'The HOF VAN DELFT was laid up in Zeeland; on 05-04-1744, it arrived at Texel.');
INSERT INTO "voyages" VALUES (7175, '', 1, '', 'LEEUWERIK', 'Hendrik Gerritsz.', 650, NULL, '1741', NULL, NULL, 'A', 'A', '1743-04-05', 'Batavia', '1743-06-21', '1743-08-04', true, '1743-11-16', 'Texel', 3235, NULL);
INSERT INTO "voyages" VALUES (7176, '', 1, '', 'ANNA', 'Christoffel Blom', 600, NULL, '1741', NULL, NULL, 'A', 'A', '1743-07-05', 'Batavia', '1743-10-10', '1743-10-28', true, '1744-04-06', 'Texel', 3253, 'On 05-02-1744 the ANNA called at Plymouth.');
INSERT INTO "voyages" VALUES (7177, '', 1, '', 'DOMBURG', 'Jan van Arras', 850, NULL, '1740', NULL, NULL, 'Z', 'A', '1743-10-17', 'Batavia', '1744-01-12', '1744-03-12', true, '1744-07-04', 'Texel', 3229, 'Commandeur of the return fleet was Dirk Wolter van Nimwegen, master of the HERSTELDER (7181).');
INSERT INTO "voyages" VALUES (7178, '', 2, '', 'DRECHTERLAND', 'Pieter Krook', 250, NULL, '1736', NULL, NULL, 'H', 'H', '1743-10-17', 'Batavia', '1744-01-17', '1744-03-05', true, NULL, NULL, 3222, 'Wrecked between the Cape and Patria, 19-05-1744.');
INSERT INTO "voyages" VALUES (7179, '', 1, '', 'DUINENBURG', 'Jan de Jong', 650, NULL, '1740', NULL, NULL, 'Z', 'E', '1743-10-17', 'Batavia', '1744-01-24', '1744-03-05', true, '1744-06-28', 'Texel', 3239, NULL);
INSERT INTO "voyages" VALUES (7180, '', 1, '', 'EENDRACHT', 'Jakob Verleng', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1743-10-17', 'Batavia', '1744-01-09', '1744-03-05', true, '1744-06-17', 'Texel', 3254, NULL);
INSERT INTO "voyages" VALUES (7181, '', 1, '', 'HERSTELDER', 'Dirk Wolter van Nimwegen', 1150, NULL, NULL, '1741', NULL, 'A', 'Z', '1743-10-17', 'Batavia', '1744-01-09', '1744-03-05', true, '1744-06-17', 'Rammekens', 3256, 'The HERSTELDER was a man-of-war. Dirk Wolter van Nimwegen was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7182, '', 5, '', 'HOFVLIET', 'Pieter Lakeman', 1000, NULL, '1729', NULL, NULL, 'R', 'R', '1743-10-17', 'Batavia', '1744-01-12', '1744-03-05', true, NULL, NULL, 3261, 'Wrecked between the Cape and Patria, 19-05-1744.');
INSERT INTO "voyages" VALUES (7183, '', 1, '', 'IDA', 'Roelof Blok', 650, NULL, '1740', NULL, NULL, 'E', 'D', '1743-10-17', 'Batavia', '1744-01-12', '1744-03-05', true, '1744-06-24', 'Goeree', 3219, NULL);
INSERT INTO "voyages" VALUES (7184, '', 3, '', 'NIEUWERKERK', 'Willem Houthuizen', 1135, NULL, '1735', NULL, NULL, 'Z', 'Z', '1743-10-17', 'Batavia', '1744-01-12', '1744-03-05', true, '1744-06-17', 'Rammekens', 3246, NULL);
INSERT INTO "voyages" VALUES (7185, '', 3, '', 'SCHELLAG', 'Anthonie Uiterschouw', 850, NULL, '1736', NULL, NULL, 'Z', 'A', '1743-10-17', 'Batavia', '1744-01-12', '1744-03-05', true, '1744-06-17', 'Texel', 3258, NULL);
INSERT INTO "voyages" VALUES (7186, '', 1, '', 'ZAAMSLAG', 'Nanning Broeder', 900, NULL, '1741', NULL, NULL, 'Z', 'A', '1743-11-02', 'Batavia', '1744-01-12', '1744-01-21', true, '1744-05-06', 'Texel', 3259, NULL);
INSERT INTO "voyages" VALUES (7187, '', 3, '', 'HUIS TE RENSBURG', 'Barend de Bruin', 850, NULL, '1733', NULL, NULL, 'Z', 'A', '1743-12-29', 'Batavia', '1744-05-04', '1744-05-14', true, '1744-08-29', 'Texel', 3215, NULL);
INSERT INTO "voyages" VALUES (7188, '', 3, '', 'ARNESTUN', 'Bastiaan Verdoes', 575, NULL, '1736', NULL, NULL, 'Z', 'D', '1743-12-30', 'Batavia', '1744-04-10', '1744-04-18', true, '1744-08-05', 'Goeree', 3263, NULL);
INSERT INTO "voyages" VALUES (7189, '', 2, '', 'HUIS TER DUINE', 'Jan Mijsters', 550, NULL, '1739', NULL, NULL, 'Z', 'E', '1743-12-30', 'Batavia', '1744-03-31', '1744-04-14', true, '1744-08-04', 'Texel', 3270, NULL);
INSERT INTO "voyages" VALUES (7190, '', 3, '', 'HARTENLUST', 'Gijsbert Bonekamp', 650, NULL, '1734', NULL, NULL, 'A', 'A', '1743-12-30', 'Batavia', '1744-04-12', '1744-04-18', true, '1744-08-04', 'Texel', 3268, NULL);
INSERT INTO "voyages" VALUES (7191, '', 5, '', 'WESTKAPELLE', 'Jan van Ingen', 850, NULL, '1730', NULL, NULL, 'Z', 'Z', '1743-12-30', 'Batavia', '1744-03-30', '1744-04-18', true, '1744-08-06', 'Rammekens', 3192, NULL);
INSERT INTO "voyages" VALUES (7192, '', 3, '', 'NIEUWSTAD', 'Dirk Quast', 650, NULL, '1733', NULL, NULL, 'H', 'A', '1744-01-10', 'Bengal', '1744-03-26', '1744-04-18', true, '1744-08-04', 'Texel', 3110, NULL);
INSERT INTO "voyages" VALUES (7193, '', 3, '', 'WESTHOVEN', 'Herman Quinje', 650, NULL, '1734', NULL, NULL, 'Z', 'Z', '1744-01-10', 'Bengal', '1744-04-04', '1744-04-18', true, '1744-08-11', 'Rammekens', 3217, NULL);
INSERT INTO "voyages" VALUES (7194, '', 2, '', 'POLANEN', 'Christiaan Andriesz.', 650, NULL, '1737', NULL, NULL, 'A', 'R', '1744-01-14', 'Batavia', '1744-05-01', '1744-05-14', true, '1744-09-04', 'Goeree', 3249, NULL);
INSERT INTO "voyages" VALUES (7195, '', 4, '', 'GOIDSCHALXOORD', 'Douwe Jansz. Mout', 850, 'fluit', '1734', NULL, NULL, 'A', 'A', '1744-01-15', 'Ceylon', '1744-01-31', '1744-04-14', true, '1744-08-05', 'Texel', 3245, 'The 122 men aboard the GOIDSCHALXOORD included 4 impotenten.');
INSERT INTO "voyages" VALUES (7196, '', 2, '', 'SARA JACOBA', 'Jan Reynders', 1100, NULL, '1737', NULL, NULL, 'Z', 'Z', '1744-01-15', 'Ceylon', '1744-03-14', '1744-04-18', true, '1744-08-06', 'Rammekens', 3241, NULL);
INSERT INTO "voyages" VALUES (7197, '', 4, '', 'SCHEUBEEK', 'Jan Bijland', 850, NULL, '1735', NULL, NULL, 'A', 'A', '1744-01-15', 'Ceylon', '1744-03-30', '1744-04-18', true, '1744-08-05', 'Texel', 3251, 'The 118 men aboard the SCHEIJBEEK included 4 impotenten.');
INSERT INTO "voyages" VALUES (7198, '', 3, '', 'GUNTERSTUN', 'Jan de Boer', 850, NULL, '1736', NULL, NULL, 'A', 'A', '1744-01-17', 'China', '1744-05-18', NULL, true, NULL, NULL, 3204, 'According to a letter from the Cape (29-06-1744) the GUN-TERSTIJN was laid up and broken up in the Table Bay; its cargo had been transhipped into the FORTUIN (7201).');
INSERT INTO "voyages" VALUES (7199, '', 2, '', 'WELTEVREDEN', 'Abraham Haring', 850, NULL, '1740', NULL, NULL, 'A', 'A', '1744-01-19', 'Batavia', '1744-06-05', '1744-06-09', true, '1744-10-02', 'Texel', 3266, 'According to K.A. 4390a Gerrit Bot was master; according to K.A. 2483: Andries van den Bos. The WELTEVREDEN did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7200, '', 8, '', 'PATMOS', 'Michiel Keizer', 810, NULL, '1722', NULL, NULL, 'R', 'Z', '1744-01-21', 'China', '1744-04-30', '1744-05-14', true, '1744-08-05', 'Rammekens', 3207, 'the PATMOS arrived at the Rammekens on 29-08-1744.');
INSERT INTO "voyages" VALUES (7201, '', 1, '', 'FORTUIN', 'Kornelis Booys', 600, NULL, '1741', NULL, NULL, 'A', 'A', '1744-01-24', 'Batavia', '1744-04-26', '1744-06-30', true, '1744-09-23', 'Texel', 3255, 'The FORTUIN was a storeship. At the Cape it took over the cargo of the GUNTERSTIJN (see 7198). According to K.A. 4390a Jan de Boer, former master of the GUNTERSTIJN, was master of the FORTUIN when it arrived at Texel; if so, he probably embarked at the Cape.');
INSERT INTO "voyages" VALUES (7202, '', 1, '', 'LIS', 'Boudewijn Immers', 600, NULL, '1738', NULL, NULL, 'A', 'H', '1744-02-18', 'Bengal', '1744-06-11', '1744-08-07', true, '1744-11-12', 'Texel', 3128, 'The LIS did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7203, '', 3, '', 'STRIJEN', NULL, 650, NULL, '1735', NULL, NULL, 'D', 'A', '1744-03-01', 'Batavia', NULL, NULL, true, NULL, NULL, 3271, 'Missing between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7204, '', 2, '', 'DISHOEK', 'Jan Hugo Captijn', 665, NULL, '1735', NULL, NULL, 'Z', 'R', '1744-10-10', 'Batavia', '1745-01-01', '1745-04-16', true, '1745-08-27', 'Goeree', 3292, 'AI-bert Sichterman, sailing aboard the WOITKENSDORP (7211); commandeur was Pieter Zwanendrecht, master of the POP-KENSBURG (7207).');
INSERT INTO "voyages" VALUES (7205, '', 2, '', 'KRABBENDIJKE', 'Frans Gassels', 830, NULL, '1738', NULL, NULL, 'Z', 'A', '1744-10-10', 'Batavia', '1745-01-01', '1745-04-16', true, '1745-08-24', 'Texel', 3291, 'From 30-12-1744 till 01-01-1745 the KRABBENDIJKE was at anchor off Robben Island.');
INSERT INTO "voyages" VALUES (7206, '', 2, '', 'MAARSSEVEEN', 'Jurriaan Koperslager', 850, NULL, '1739', NULL, NULL, 'A', 'A', '1744-10-10', 'Batavia', '1744-12-27', '1745-04-16', true, '1745-08-26', 'Texel', 3277, NULL);
INSERT INTO "voyages" VALUES (7207, '', 3, '', 'POPKENSBURG', 'Pieter Zwanendrecht', 850, NULL, '1732', NULL, NULL, 'Z', 'A', '1744-10-10', 'Batavia', '1745-01-01', '1745-04-16', true, '1745-08-24', 'Texel', 3225, 'Pieter Zwanendrecht was commandeur of the return fleet. From 30-12-1744 till 01-01-1745 the POPKENSBURG was at anchor off Robben Island.');
INSERT INTO "voyages" VALUES (7208, '', 2, '', 'TOLSDUIN', 'Maarten van der Meer', 850, NULL, '1741', NULL, NULL, 'A', 'A', '1744-10-10', 'Batavia', '1745-01-03', '1745-04-16', true, '1745-08-24', 'Texel', 3289, 'At the Cape a stowaway, found on the TOLSDUIN, embarked on the EENDRACHT, which set out to Batavia on 22-03-1745 (3309).');
INSERT INTO "voyages" VALUES (7209, '', 5, '', 'RUST EN WERK', 'Pieter Jellesz.', 650, NULL, '1734', NULL, NULL, 'D', 'D', '1744-10-24', 'Batavia', '1745-02-15', '1745-04-16', true, '1745-08-27', 'Goeree', 3283, 'From 09 till 15-02-1745 the RUST EN WERK was at anchor off Robben Island.');
INSERT INTO "voyages" VALUES (7210, '', 5, '', 'SIJBEKARSPEL', 'Hendrik Volkers', 650, NULL, '1729', NULL, NULL, 'H', 'H', '1744-10-24', 'Batavia', '1745-01-28', '1745-04-16', true, '1745-08-25', 'Texel', 3295, NULL);
INSERT INTO "voyages" VALUES (7211, '', 2, '', 'WOITKENSDORP', 'Pieter Sluis', 800, NULL, '1739', NULL, NULL, 'Z', 'Z', '1744-10-24', 'Batavia', '1745-02-01', '1745-04-16', true, '1745-09-02', 'Rammekens', 3290, 'Aboard the WOITKENSDORP was Johan Albert Sichterman, admiraal of the return fleet. From 27-01 till 01-02-1745 the ship was at anchor off Robben Island.');
INSERT INTO "voyages" VALUES (7212, '', 1, '', 'GERECHTIGHEID', 'Meindert de Beer', 850, NULL, '1742', NULL, NULL, 'E', 'E', '1744-10-25', 'Batavia', '1745-02-01', '1745-04-16', true, '1745-08-08', 'Texel', 3285, 'From 27-01 till 01-02-1745 the GERECHTIGHEID was at anchor off Robben Island.');
INSERT INTO "voyages" VALUES (7213, '', 1, '', 'AKERENDAM', 'Paulus Pieman', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1744-11-05', 'Batavia', '1745-02-01', '1745-04-16', true, '1745-08-26', 'Texel', 3281, 'From 30-01 till 01-02-1745 the AKERENDAM was at anchor off Robben Island.');
INSERT INTO "voyages" VALUES (7214, '', 3, '', 'OUWERKERK', 'Kornelis Stevens', 540, NULL, '1738', NULL, NULL, 'Z', 'A', '1744-11-05', 'Batavia', '1745-02-06', '1745-04-16', true, '1745-08-24', 'Texel', 3293, 'From 03 till 06-02-1745 the OUWERKERK was at anchor off Robben Island.');
INSERT INTO "voyages" VALUES (7215, '', 3, '', 'BEUKESTIJN', 'Nikolaas Jongma', 850, NULL, '1734', NULL, NULL, 'A', 'A', '1744-11-29', 'Ceylon', '1745-02-06', '1745-04-16', true, '1745-08-24', 'Texel', 3244, NULL);
INSERT INTO "voyages" VALUES (7216, '', 4, '', 'KERKWUK', 'Michiel van Son', 850, NULL, '1733', NULL, NULL, 'A', 'A', '1745-01-15', 'Ceylon', '1745-04-02', '1745-04-16', true, '1745-08-26', 'Texel', 3223, 'The 110 men aboard the KERKWIJK included 5 impotenten. The KERKWIJK was to make two other voyages; during its fifth voyage the ship was called HUIS TE RENSBURG (see 3373/7283), during the last voyage (3424) its name was DUINENBURG.');
INSERT INTO "voyages" VALUES (7217, '', 6, '', 'KNAPPENHOF', 'Herman Schutte', 650, NULL, '1731', NULL, NULL, 'A', 'A', '1745-01-15', 'Ceylon', '1745-03-29', '1745-04-16', true, '1745-08-26', 'Texel', 3297, 'The 86 men aboard the KNAPPENHOF included 5 impotenten.');
INSERT INTO "voyages" VALUES (7218, '', 5, '', 'NIEUW WALCHEREN', 'Nikolaas van Ewijk', 850, NULL, '1731', NULL, NULL, 'Z', 'Z', '1745-01-15', 'Ceylon', '1745-03-19', '1745-04-16', true, '1745-08-25', 'Goeree', 3247, 'Arrival of the NIEUW WALCHEREN at the Rammekens: 14-09-1745.');
INSERT INTO "voyages" VALUES (7219, '', 3, '', 'BATAVIER', 'Marten den Breems', 525, NULL, '1735', NULL, NULL, 'A', 'E', '1745-01-17', 'Batavia', '1745-06-02', '1745-06-24', true, '1745-10-20', 'Texel', 3264, 'The 58 persons aboard the BATAVIER included 7 passengers. The ship did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7220, '', 1, '', 'HOOP', 'Jan van Schutterop', 850, NULL, '1742', NULL, NULL, 'D', 'A', '1745-01-17', 'Batavia', '1745-06-15', '1745-06-24', true, '1745-10-18', 'Texel', 3272, 'During the voyage Jan van Schutterop died; Leendert de Bruin succeeded him as master. The HOOP did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7221, '', 1, '', 'STANDVASTIGHEID', 'Willem de Wijs', 850, NULL, '1743', NULL, NULL, 'R', 'A', '1745-02-01', 'Bengal', '1745-05-08', '1745-05-19', true, '1745-09-11', 'Texel', 3288, NULL);
INSERT INTO "voyages" VALUES (7222, '', 4, '', 'VLISSINGEN', 'Huibert Tiebout', 650, NULL, '1732', NULL, NULL, 'Z', 'Z', '1745-02-01', 'Bengal', '1745-05-11', '1745-06-23', true, '1745-10-22', 'Rammekens', 3216, 'The VLISSINGEN did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7223, '', 2, '', 'BOSBEEK', 'Laurens Siewertsz.', 650, NULL, '1741', NULL, NULL, 'A', 'D', '1745-02-02', 'China', NULL, NULL, false, '1745-09-09', 'Goeree', 3284, NULL);
INSERT INTO "voyages" VALUES (7224, '', 1, '', 'OVERNES', 'Hendrik de Ruyter', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1745-02-02', 'China', '1745-06-02', '1745-06-23', true, '1745-10-20', 'Texel', 3276, 'The OVERNES did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7225, '', 2, '', 'HEUVEL', NULL, 650, NULL, '1740', NULL, NULL, 'A', 'Z', '1745-03-02', 'Batavia', NULL, NULL, true, NULL, NULL, 3274, 'Missing between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7226, '', 1, '', 'OPLETTENDHEID', 'Hendrik Bommer', 850, NULL, NULL, NULL, NULL, NULL, 'A', '1745-03-12', 'Batavia', '1745-06-15', '1745-07-24', true, '1745-10-21', 'Texel', NULL, 'The OPLETTENDHEID did not call at the Cape but at False Bay. Originally the OPLETTENDHEID was a French ship, called JASON; it was captured by the English (05-02-1745), brought to Batavia (13-02), and sold to the Dutch (16-02).');
INSERT INTO "voyages" VALUES (7227, '', 1, '', 'TOEVALLIGHEID', NULL, 850, NULL, NULL, NULL, NULL, NULL, 'A', '1745-03-12', 'Batavia', NULL, NULL, false, '1745-10-11', 'Texel', NULL, 'As the OPLETTENDHEID (7226) the TOEVALLIGHEID originally was a French ship, called HERCULES; it was captured by the English (05-02-1745), brought to Batavia (13-02), and sold to the Dutch (16-02).');
INSERT INTO "voyages" VALUES (7228, '', 6, '', 'HOGERSMILDE', 'Otto van Dam', 850, NULL, '1723', NULL, NULL, 'H', 'A', '1745-10-25', 'Batavia', '1746-01-21', '1746-03-25', true, '1746-07-23', 'Texel', 3278, 'This was the sixth voyage (3278/7228) of this which during ship, its first four voyages was called WAPEN VAN HOORN (numbers of the fourth voyage: 3109/7070).  Commandeur of the return fleet was Jan de Wit, master of the LEIDEN (7229).');
INSERT INTO "voyages" VALUES (7229, '', 1, '', 'LEIDEN', 'Jan de Wit', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1745-10-25', 'Batavia', '1746-01-01', '1746-03-25', true, '1746-07-23', 'Texel', 3321, 'Jan de Wit was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7230, '', 2, '', 'REIGERSDAAL', 'Willem ''t Hoen', 850, NULL, '1738', NULL, NULL, 'A', 'A', '1745-10-25', 'Batavia', '1745-12-31', '1746-03-25', true, '1746-07-19', 'Texel', 3315, 'On 30-12-1745 the REIGERSDAAL arrived at Robben Island. See also 3334 and 3336.');
INSERT INTO "voyages" VALUES (7231, '', 1, '', 'SPANDERSWOUD', 'Wijnand Meurs', 850, NULL, '1744', NULL, NULL, 'A', 'Z', '1745-10-25', 'Batavia', '1746-01-04', '1746-03-25', true, '1746-07-25', 'Rammekens', 3316, NULL);
INSERT INTO "voyages" VALUES (7232, '', 1, '', 'BROUWER', 'Gerrit Reyndertsz. Vos', 850, NULL, '1743', NULL, NULL, 'H', 'H', '1745-11-11', 'Batavia', '1746-01-31', '1746-03-25', true, '1746-07-15', 'Texel', 3313, 'From 26 till 31-01-1746 the BROUWER was at anchor off Robben Island.');
INSERT INTO "voyages" VALUES (7233, '', 1, '', 'DUINHOF', 'Jakob Laurens', 850, NULL, '1743', NULL, NULL, 'A', 'A', '1745-11-13', 'Batavia', '1746-01-17', '1746-03-25', true, '1746-07-25', 'Texel', 3282, NULL);
INSERT INTO "voyages" VALUES (7234, '', 1, '', 'HUIS TE PERSIJN', 'Frederik Schouten', 850, NULL, '1743', NULL, NULL, 'R', 'E', '1745-11-13', 'Batavia', '1746-01-21', '1746-03-25', true, '1746-07-19', 'Texel', 3306, NULL);
INSERT INTO "voyages" VALUES (7235, '', 1, '', 'VOORZICHTIGHEID', 'Dirk van der Schilde', 850, NULL, '1744', NULL, NULL, 'D', 'D', '1745-12-29', 'Batavia', '1746-05-07', '1746-05-15', true, '1746-08-21', 'Goeree', 3305, NULL);
INSERT INTO "voyages" VALUES (7236, '', 2, '', 'ZAAMSLAG', 'Johannes Brand', 900, NULL, '1741', NULL, NULL, 'Z', 'Z', '1746-01-07', 'China', '1746-05-02', '1746-05-15', true, '1746-08-21', 'Rammekens', 3310, NULL);
INSERT INTO "voyages" VALUES (7237, '', 1, '', 'ZUIDERBURG', 'Hendrik Taal', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1746-01-07', 'China', '1746-05-02', '1746-05-15', true, '1746-08-19', 'Texel', 3311, NULL);
INSERT INTO "voyages" VALUES (7238, '', 4, '', 'NIEUWLAND', 'Jan de Zee', 850, NULL, '1733', NULL, NULL, 'Z', 'Z', '1746-01-10', 'Batavia', NULL, NULL, true, NULL, NULL, 3302, 'Missing between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7239, '', 1, '', 'DIEMEN', 'Willem van der Heyden', 850, NULL, '1743', NULL, NULL, 'A', 'A', '1746-01-13', 'Bengal', '1746-03-27', '1746-04-19', true, '1746-08-15', 'Texel', 3308, NULL);
INSERT INTO "voyages" VALUES (7240, '', 3, '', 'HUIS TER DUINE', 'Dirk Quast', 550, NULL, '1739', NULL, NULL, 'Z', 'R', '1746-01-13', 'Bengal', '1746-03-27', '1746-04-19', true, '1746-07-19', 'Goeree', 3323, NULL);
INSERT INTO "voyages" VALUES (7241, '', 2, '', 'DOMBURG', 'Jan Verhagen', 850, NULL, '1740', NULL, NULL, 'Z', 'A', '1746-01-19', 'Ceylon', '1746-03-24', '1746-04-19', true, '1746-08-15', 'Texel', 3314, 'The 13 passengers were condemned persons.');
INSERT INTO "voyages" VALUES (7242, '', 4, '', 'SCHELLAG', 'Kornelis van Zwanenburg', 850, NULL, '1736', NULL, NULL, 'Z', 'Z', '1746-01-19', 'Ceylon', '1746-03-26', '1746-04-19', true, '1746-08-12', 'Rammekens', 3318, 'The 13 passengers included 11 condemned persons.');
INSERT INTO "voyages" VALUES (7243, '', 3, '', 'WELTEVREDEN', 'Willem Vrucht', 850, NULL, '1740', NULL, NULL, 'A', 'A', '1746-01-19', 'Ceylon', '1746-03-24', '1746-04-19', true, '1746-08-15', 'Texel', 3322, 'The 10 passengers were condemned persons.');
INSERT INTO "voyages" VALUES (7244, '', 1, '', 'KLEVERSKERKE', 'Abraham Zwart', 850, NULL, '1742', NULL, NULL, 'Z', 'A', '1746-03-12', 'Batavia', '1746-06-28', '1746-07-15', true, '1746-11-05', 'Texel', 3262, 'included 20 passengers. The ship did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7245, '', 2, '', 'FORTUIN', 'Dirk Took', 600, NULL, '1741', NULL, NULL, 'A', 'A', '1746-10-08', 'Batavia', '1746-12-28', '1747-01-17', true, '1747-06-17', 'Texel', 3340, NULL);
INSERT INTO "voyages" VALUES (7246, '', 1, '', 'EINDHOEF', 'Willem Klump', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1746-10-23', 'Batavia', '1747-01-08', '1747-03-15', true, '1747-07-18', 'Texel', 3346, 'From 06 till 08-01-1747 the EINDHOEF was at anchor off Robben Island.');
INSERT INTO "voyages" VALUES (7247, '', 1, '', 'HUIGENWAARD', 'Bastiaan Verdoes', 850, NULL, '1742', NULL, NULL, 'H', 'A', '1746-10-28', 'Batavia', '1747-01-08', '1747-03-15', true, '1747-07-18', 'Texel', 3280, NULL);
INSERT INTO "voyages" VALUES (7248, '', 6, '', 'RUST EN WERK', 'Dirk Verduin', 650, NULL, '1734', NULL, NULL, 'D', 'D', '1746-11-21', 'Batavia', '1747-02-13', '1747-03-20', true, '1747-07-07', 'Goeree', 3354, 'From 06 till 13-02-1747 the RUST EN WERK was at anchor off Robben Island.');
INSERT INTO "voyages" VALUES (7249, '', 1, '', 'SLOT VAN KAPELLE', 'Pieter Jellesz.', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1746-11-25', 'Batavia', '1747-02-28', '1747-03-15', true, '1747-07-18', 'Texel', 3357, NULL);
INSERT INTO "voyages" VALUES (7250, '', 3, '', 'TOLSDUIN', 'Jan de Jong', 850, NULL, '1741', NULL, NULL, 'A', 'A', '1746-11-25', 'Batavia', '1747-02-13', '1747-03-15', true, '1711-07-18', 'Texel', 3356, 'From 05 till 13-02-1747 the TOLSDUIN was at anchor off Robben Island.');
INSERT INTO "voyages" VALUES (7251, '', 2, '', 'EENDRACHT', 'Jan Christoffel Tiede', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1746-12-02', 'Mocha', '1747-02-13', '1747-03-15', true, '1747-07-18', 'Texel', 3309, 'Probably the ship sailed via Ceylon to the Cape and Patria. The 5 passengers were condemned persons.');
INSERT INTO "voyages" VALUES (7252, '', 1, '', 'ZEELANDIA', 'Willem Marreeuw', 1150, NULL, '1744', NULL, NULL, 'Z', 'Z', '1746-12-19', 'Batavia', '1747-02-04', '1747-03-15', true, '1747-07-19', 'Rammekens', 3347, NULL);
INSERT INTO "voyages" VALUES (7253, '', 3, '', 'DISHOEK', 'Willem van Westrenen', 665, NULL, '1735', NULL, NULL, 'Z', 'E', '1747-01-05', 'Batavia', '1747-04-20', '1747-05-02', true, '1747-09-11', 'Texel', 3351, 'Commandeur of the return fleet was Ficco Eybo van Rheede, master of the HUIS TE RENSBURG (7255).');
INSERT INTO "voyages" VALUES (7254, '', 1, '', 'GETROUWIGHEID', 'Herman Zoet', 850, NULL, '1744', NULL, NULL, 'H', 'Z', '1747-01-05', 'Batavia', '1747-04-20', '1747-05-02', true, '1747-08-22', 'Rammekens', 3348, NULL);
INSERT INTO "voyages" VALUES (7255, '', 4, '', 'HUIS TE RENSBURG', 'Ficco Eybo van Rheede', 850, NULL, '1733', NULL, NULL, 'Z', 'A', '1747-01-05', 'Batavia', '1747-04-07', '1747-05-02', true, '1747-09-11', 'Texel', 3353, 'Ficco Eybo van Rheede was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7256, '', 2, '', 'STANDVASTIGHEID', 'Floris Smit', 850, NULL, '1743', NULL, NULL, 'R', 'R', '1747-01-05', 'Batavia', '1747-04-09', '1747-05-02', true, '1747-09-11', 'Goeree', 3355, NULL);
INSERT INTO "voyages" VALUES (7257, '', 4, '', 'DIEMERMEER', NULL, 850, NULL, '1736', NULL, NULL, 'A', 'Z', '1747-01-15', 'Ceylon', NULL, NULL, false, NULL, NULL, 3303, 'The ship was wrecked off Guinea.');
INSERT INTO "voyages" VALUES (7258, '', 2, '', 'DUINENBURG', 'Willem van Mensburg', 650, NULL, '1740', NULL, NULL, 'Z', 'A', '1747-01-15', 'Ceylon', '1747-04-22', '1747-05-02', true, '1747-09-11', 'Texel', 3331, 'After the return of the ship at Texel its name was changed into HUIS TE RENSBURG (3432/7336).');
INSERT INTO "voyages" VALUES (7259, '', 5, '', 'SCHEIJBEEK', 'Klaas van den Hoed', 850, NULL, '1735', NULL, NULL, 'A', 'Z', '1747-01-15', 'Ceylon', '1747-04-14', '1747-05-02', true, '1747-09-12', 'Rammekens', 3342, NULL);
INSERT INTO "voyages" VALUES (7260, '', 4, '', 'WESTHOVEN', 'Huibert Vijs', 650, NULL, '1734', NULL, NULL, 'Z', 'E', '1747-01-17', 'Batavia', '1747-06-06', '1747-07-15', true, '1747-11-01', 'Goeree', 3336, NULL);
INSERT INTO "voyages" VALUES (7261, '', 1, '', 'LEKKERLAND', NULL, 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1747-01-01', 'China', NULL, NULL, false, '1747-11-09', 'Texel', 3341, 'Departure from China probably was at the end of January 1747.');
INSERT INTO "voyages" VALUES (7262, '', 1, '', 'HOF D''UNO', NULL, 1150, NULL, '1743', NULL, NULL, 'Z', 'H', '1747-01-01', 'China', NULL, NULL, false, '1747-11-09', 'Texel', 3334, 'Departure from China probably was at the end of January 1747.');
INSERT INTO "voyages" VALUES (7263, '', 2, '', 'LIS', 'Jakob Greef', 600, NULL, '1738', NULL, NULL, 'A', 'A', '1747-02-02', 'Ceylon', '1747-04-21', '1747-05-02', true, '1747-09-11', 'Texel', 3333, NULL);
INSERT INTO "voyages" VALUES (7264, '', 1, '', 'HERCULES', 'Jan Mijsters', 850, NULL, '1743', NULL, NULL, 'Z', 'A', '1747-03-02', 'Bengal', '1747-04-14', '1747-05-02', true, '1747-09-11', 'Texel', 3335, NULL);
INSERT INTO "voyages" VALUES (7265, '', 4, '', 'ARNESTIJN', 'Jan Hugo Captijn', 575, NULL, '1736', NULL, NULL, 'Z', 'E', '1747-03-07', 'Bengal', '1747-07-02', '1747-11-05', true, '1748-04-22', 'Texel', 3338, NULL);
INSERT INTO "voyages" VALUES (7266, '', 3, '', 'POLANEN', 'Bastiaan Mol', 650, NULL, '1737', NULL, NULL, 'A', 'A', '1747-03-30', 'Batavia', '1747-07-26', '1747-08-12', true, '1748-06-07', 'Texel', 3327, 'Bastiaan Mol was master till the Cape; Kornelis Broeders succeeded him.');
INSERT INTO "voyages" VALUES (7267, '', 3, '', 'BOSBEEK', 'Bruyn', 650, NULL, '1741', NULL, NULL, 'A', 'Z', '1747-04-08', 'Batavia', NULL, NULL, false, '1747-12-10', 'Rammekens', 3362, NULL);
INSERT INTO "voyages" VALUES (7268, '', 2, '', 'DIEMEN', 'Michiel van Son', 850, NULL, '1743', NULL, NULL, 'A', 'A', '1747-10-03', 'Batavia', '1747-12-07', '1748-04-24', true, '1748-08-31', 'Texel', 3381, 'the HAARLEM (7270).');
INSERT INTO "voyages" VALUES (7269, '', 2, '', 'DUINHOF', 'Hendrik Taal', 850, NULL, '1743', NULL, NULL, 'A', 'H', '1747-10-14', 'Batavia', '1748-05-18', NULL, true, NULL, NULL, 3391, 'The DUINHOF was broken up at the Cape; its cargo was taken over by the KASTEEL VAN TILBURG (7295).');
INSERT INTO "voyages" VALUES (7270, '', 1, '', 'HAARLEM', 'Hendrik de Ruyter', 1150, NULL, '1745', NULL, NULL, 'A', 'A', '1747-10-24', 'Batavia', '1748-01-07', '1748-04-24', true, '1748-08-31', 'Texel', 3372, 'Aboard the HAARLEM was Daniel Nolthenius, admiraal of the return fleet.');
INSERT INTO "voyages" VALUES (7271, '', 2, '', 'HOOP', 'Gerrit Reyndertsz. Vos', 850, NULL, '1742', NULL, NULL, 'D', 'H', '1747-10-24', 'Batavia', '1748-01-14', '1748-04-24', true, '1748-08-31', 'Texel', 3377, NULL);
INSERT INTO "voyages" VALUES (7272, '', 1, '', 'OVERSCHIE', 'Maarten van der Meer', 850, NULL, '1745', NULL, NULL, 'D', 'D', '1747-10-24', 'Batavia', '1748-01-09', '1748-04-24', true, '1748-08-30', 'Goeree', 3379, NULL);
INSERT INTO "voyages" VALUES (7273, '', 2, '', 'VOORZICHTIGHEID', 'Kornelis Quack', 850, NULL, '1744', NULL, NULL, 'D', 'R', '1747-10-24', 'Batavia', '1748-01-14', '1748-04-24', true, '1748-08-30', 'Goeree', 3387, NULL);
INSERT INTO "voyages" VALUES (7274, '', 3, '', 'DOMBURG', 'Bonekamp', 850, NULL, '1740', NULL, NULL, 'Z', 'Z', '1747-11-12', 'Batavia', NULL, NULL, true, NULL, NULL, 3390, 'Missing between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7275, '', 2, '', 'VRIJHEID', 'Kornelis Mangelaar', 650, NULL, '1740', NULL, NULL, 'R', 'E', '1747-11-12', 'Batavia', NULL, NULL, true, NULL, NULL, 3298, 'Missing between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7276, '', 4, '', 'WELTEVREDEN', 'Jochem Outjes', 850, NULL, '1740', NULL, NULL, 'A', 'A', '1747-11-12', 'Batavia', '1748-04-22', NULL, true, NULL, NULL, 3388, 'Ran ashore on a reef near Cape Agullas (April 1748) and was towed to the Cape. According to a resolution of 24-11-1748 the WELTEVREDEN was broken up at the Cape.');
INSERT INTO "voyages" VALUES (7277, '', 1, '', 'ROOSWIJK', 'Paulus Lindenberg', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1747-11-24', 'Batavia', NULL, NULL, true, NULL, NULL, 3378, 'Missing between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7278, '', 1, '', 'BAARZANDE', 'Martin Haringman', 850, NULL, '1745', NULL, NULL, 'Z', 'Z', '1748-01-13', 'Batavia', '1748-04-02', '1748-04-24', true, '1748-09-06', 'Rammekens', 3393, NULL);
INSERT INTO "voyages" VALUES (7279, '', 2, '', 'AKERENDAM', 'Hendrik Volkers', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1748-01-16', 'China', '1748-03-26', '1748-04-24', true, '1748-08-31', 'Texel', 3358, 'Part of the cargo (227,120) consisted of tea. According to K.A. 8403 it was 227,200.');
INSERT INTO "voyages" VALUES (7280, '', 1, '', 'GUSTAAF WILLEM', 'Huibert Tiebout', 1150, NULL, '1744', NULL, NULL, 'Z', 'Z', '1748-01-16', 'China', '1748-03-31', '1748-04-24', true, '1748-09-06', 'Rammekens', 3370, 'Part of the cargo (230,330) consisted of tea.');
INSERT INTO "voyages" VALUES (7281, '', 1, '', 'PASGELD', 'Kornelis Jurriaansz.', 850, NULL, '1744', NULL, NULL, 'D', 'R', '1748-01-16', 'China', '1748-04-04', '1748-04-24', true, '1748-08-30', 'Goeree', 3339, 'Part of the cargo (152,945) consisted of tea.');
INSERT INTO "voyages" VALUES (7282, '', 3, '', 'KRABBENDUKE', 'Kornelis Vis', 830, NULL, '1738', NULL, NULL, 'Z', 'A', '1748-01-18', 'Ceylon', '1748-04-18', '1748-04-24', true, '1748-09-02', 'Texel', 3368, 'The 125 men aboard the KRABBENDIJKE included 6 impotenten.');
INSERT INTO "voyages" VALUES (7283, '', 5, '', 'HUTS TE RENSBURG', 'Jakob Wiebe', 850, NULL, '1733', NULL, NULL, 'A', 'A', '1748-01-18', 'Ceylon', '1748-03-30', '1748-04-24', true, '1748-09-02', 'Texel', 3373, 'This was the fifth voyage (3373/7283) of this ship, which during its four preceding voyages was called KERKWIJK (numbers of the fourth voyage: 3223/7216). In 1748/9 the ship was to make its sixth and last voyage to the Indies, then called DUINENBURG (3424).');
INSERT INTO "voyages" VALUES (7284, '', 1, '', 'SPARENRIJK', 'Herman Schutte', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1748-01-18', 'Ceylon', '1748-04-05', '1748-04-24', true, '1748-09-02', 'Texel', 3350, 'The 108 men aboard the SPARENDIJK included 7 passengers. From 21-03 till 05-04-1748 the ship was at anchor off Robben Island.');
INSERT INTO "voyages" VALUES (7285, '', 3, '', 'WOITKENSDORP', 'Jan Willemsz. van den Briel', 800, NULL, '1739', NULL, NULL, 'Z', 'Z', '1748-01-18', 'Ceylon', '1748-04-05', '1748-04-24', true, '1748-09-06', 'Rammekens', 3367, '05-04-1748 the WOITKENSDORP was at anchor off Dassen Island.');
INSERT INTO "voyages" VALUES (7286, '', 2, '', 'GERECHTIGHEID', 'Kornelis Trappel', 850, NULL, '1742', NULL, NULL, 'E', 'Z', '1748-01-22', 'Bengal', '1748-04-05', '1748-04-24', true, '1748-09-06', 'Rammekens', 3365, 'From 31-03 till 05-04-1748 the GERECHTIGHEID was at anchor off Robben Island.');
INSERT INTO "voyages" VALUES (7287, '', 1, '', 'HUIS TE MANPAD', 'Willem ''t Hoen', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1748-01-22', 'Bengal', '1748-03-31', '1748-04-24', true, '1748-08-31', 'Texel', 3374, NULL);
INSERT INTO "voyages" VALUES (7288, '', 2, '', 'SPANDERSWOUD', 'Jan du Riets', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1748-01-22', 'Bengal', '1748-04-05', '1748-04-24', true, '1748-08-31', 'Texel', 3384, NULL);
INSERT INTO "voyages" VALUES (7289, '', 2, '', 'ZUIDERBURG', 'Jean Belleveau', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1748-01-23', 'China', '1748-04-12', '1748-04-24', true, '1748-09-02', 'Texel', 3383, NULL);
INSERT INTO "voyages" VALUES (7290, '', 4, '', 'HUTS TER DUINE', 'Pieter van Onkhuizen', 550, NULL, '1739', NULL, NULL, 'Z', 'Z', '1748-01-25', 'Batavia', '1748-07-15', '1748-08-21', true, '1748-12-13', 'Texel', 3394, 'The 80 men aboard the HUIS TER DUINE included one passenger.');
INSERT INTO "voyages" VALUES (7291, '', 2, '', 'OVERNES', 'Adriaan de Graaf', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1748-02-03', 'China', '1748-04-18', '1748-04-24', true, '1748-08-31', 'Texel', 3369, 'Part of the cargo (225,622) consisted of tea.');
INSERT INTO "voyages" VALUES (7292, '', 1, '', 'WILDRIJK', 'Kornelis de Nijs', 850, NULL, '1744', NULL, NULL, 'A', 'D', '1748-02-21', 'Bengal', '1748-05-20', '1748-06-22', true, '1748-09-28', 'Goeree', 3343, NULL);
INSERT INTO "voyages" VALUES (7293, '', 5, '', 'BATAVIER', 'Gerrit de Leeuw', 525, NULL, '1735', NULL, NULL, 'A', 'A', '1748-04-01', 'Batavia', '1748-07-01', '1748-08-21', true, '1749-04-04', 'Texel', 3359, 'included 2 passengers. Part of the cargo consisted of tea.');
INSERT INTO "voyages" VALUES (7294, '', 2, '', 'ANNA', 'Martin Lop', 600, NULL, '1741', NULL, NULL, 'A', 'Z', '1748-05-15', 'Batavia', '1748-08-23', '1748-08-31', true, '1748-12-06', 'Rammekens', 3312, 'The 76 men aboard the ANNA included 2 passengers.');
INSERT INTO "voyages" VALUES (7295, '', 1, '', 'KASTEEL VAN TILBURG', 'Abraham Zwart', 850, NULL, '1746', NULL, NULL, 'A', 'H', '1748-08-14', 'Batavia', '1748-11-03', '1749-01-24', true, '1749-05-04', 'Texel', 3396, 'This ship carried the cargo of the DUINHOF, which had sailed from Batavia to the Cape and had been broken up there (7269).');
INSERT INTO "voyages" VALUES (7296, '', 4, '', 'TOLSDUIN', 'Bastiaan Verdoes', 850, NULL, '1741', NULL, NULL, 'A', 'A', '1748-10-31', 'Batavia', '1749-01-03', '1749-01-09', true, '1749-06-11', 'Texel', 3415, 'The 7 passengers included 6 condemned persons. The TOLS-DUIN called at Plymouth, 23-04-1749.');
INSERT INTO "voyages" VALUES (7297, '', 1, '', 'BEVALLIGHEID', 'Arie van der Meer', 850, NULL, '1746', NULL, NULL, 'R', 'D', '1748-11-09', 'Batavia', '1749-03-19', '1749-04-09', true, '1749-07-04', 'Goeree', 3412, 'The 9 passengers included 7 condemned persons.');
INSERT INTO "voyages" VALUES (7298, '', 1, '', 'SLOTERDIJK', 'David van Elteren', 1150, NULL, '1747', NULL, NULL, 'A', 'A', '1748-12-09', 'Batavia', '1749-03-18', '1749-04-09', true, '1749-07-04', 'Texel', 3414, 'The 7 passengers included 4 condemned persons.');
INSERT INTO "voyages" VALUES (7299, '', 1, '', 'VOSMAAR', 'Willem van der Heyden', 850, NULL, '1746', NULL, NULL, 'Z', 'Z', '1748-12-22', 'Batavia', '1749-03-28', '1749-04-09', true, '1749-07-15', 'Rammekens', 3411, NULL);
INSERT INTO "voyages" VALUES (7300, '', 1, '', 'OSDORP', 'Willem Vrucht', 850, NULL, '1746', NULL, NULL, 'A', 'E', '1749-01-24', 'Batavia', '1749-05-01', '1749-05-18', true, '1749-09-17', 'Texel', 3410, 'Commandeur of the ships that departed from the Cape on 18-05-1749 was Boudewijn Molen, master of the AMSTELVEEN (7302).');
INSERT INTO "voyages" VALUES (7301, '', 2, '', 'LEIDEN', 'Jan de Wever', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1749-02-02', 'China', '1749-05-01', '1749-05-18', true, '1749-09-18', 'Texel', 3382, NULL);
INSERT INTO "voyages" VALUES (7302, '', 1, '', 'AMSTELVEEN', 'Gijsbert Bonekamp', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1749-02-05', 'Batavia', '1749-05-01', '1749-05-18', true, '1749-09-18', 'Texel', 3406, 'Boudewijn Molen was commandeur of the return fleet. The 6 passengers included 5 condemned persons.');
INSERT INTO "voyages" VALUES (7303, '', 3, '', 'FORTUIN', 'Jochem Beek', 600, NULL, '1741', NULL, NULL, 'A', 'A', '1749-02-05', 'Ceylon', '1749-04-20', '1749-04-29', true, '1749-08-24', 'Texel', 3409, NULL);
INSERT INTO "voyages" VALUES (7304, '', 1, '', 'IMMAGONDA', 'Herman Laurier', 850, NULL, '1746', NULL, NULL, 'E', 'A', '1749-02-05', 'Ceylon', '1749-05-01', '1749-05-18', true, '1749-09-18', 'Texel', 3404, 'From 26-04 till 01-05-1749 the IMMAGONDA was at anchor off Robben Island.');
INSERT INTO "voyages" VALUES (7305, '', 1, '', 'NAARSTIGHEID', 'Dirk van der Schilde', 850, NULL, '1746', NULL, NULL, 'D', 'Z', '1749-02-05', 'Ceylon', '1749-05-01', '1749-05-18', true, '1749-09-12', 'Rammekens', 3403, NULL);
INSERT INTO "voyages" VALUES (7306, '', 3, '', 'ZAAMSLAG', 'Kornelis Zwanenburg', 900, NULL, '1741', NULL, NULL, 'Z', 'Z', '1749-02-12', 'China', '1749-04-25', '1749-05-08', true, '1749-08-21', 'Rammekens', 3402, NULL);
INSERT INTO "voyages" VALUES (7307, '', 2, '', 'BROUWER', 'Jan Tuinman', 850, NULL, '1743', NULL, NULL, 'H', 'H', '1749-02-15', 'Bengal', '1749-05-01', '1749-05-18', true, '1749-09-11', 'Texel', 3401, NULL);
INSERT INTO "voyages" VALUES (7308, '', 2, '', 'KLEVERSKERKE', 'Simon de Groot', 850, NULL, '1742', NULL, NULL, 'Z', 'A', '1749-02-15', 'Bengal', NULL, NULL, false, '1749-09-08', 'Texel', 3400, NULL);
INSERT INTO "voyages" VALUES (7309, '', 1, '', 'LANGEWIJK', 'Frederik Schouten', 850, NULL, '1745', NULL, NULL, 'E', 'A', '1749-02-22', 'Bengal', '1749-05-17', '1749-06-27', true, '1749-10-13', 'Texel', 3380, NULL);
INSERT INTO "voyages" VALUES (7310, '', 1, '', 'OOSTKAPELLE', 'Jan Kakelaar', 850, NULL, '1745', NULL, NULL, 'Z', 'R', '1749-03-01', 'Bengal', '1749-05-16', '1749-06-09', true, '1749-10-10', 'Goeree', 3375, 'The OOSTKAPELLE did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7311, '', 2, '', 'SLOT VAN KAPELLE', 'Jakob Buis', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1749-03-20', 'Batavia', '1749-09-29', '1749-10-17', true, '1750-04-25', 'Texel', 3407, 'The 104 men aboard the SLOT VAN KAPELLE included 10 passengers.');
INSERT INTO "voyages" VALUES (7312, '', 2, '', 'LEKKERLAND', 'Pieter Schoneman', 1150, NULL, '1744', NULL, NULL, 'A', 'Z', '1749-04-04', 'Batavia', '1749-07-07', '1749-07-14', true, '1750-03-30', 'Rammekens', 3418, 'The 106 men aboard the LEKKERLAND included 9 passengers.');
INSERT INTO "voyages" VALUES (7313, '', 1, '', 'BREDENHOF', 'Winsum', 850, NULL, '1746', NULL, NULL, 'H', 'E', '1749-04-23', 'Batavia', '1749-08-16', NULL, true, '1750-04-01', 'Texel', 4419, NULL);
INSERT INTO "voyages" VALUES (7314, '', 3, '', 'STANDVASTIGHEID', 'Willem Marreeuw', 850, NULL, '1743', NULL, NULL, 'R', 'R', '1749-05-12', 'Batavia', '1749-09-11', '1749-10-17', true, '1750-03-06', 'Goeree', 3426, NULL);
INSERT INTO "voyages" VALUES (7315, '', 1, '', 'PRINSES VAN ORANJE', 'Pieter Tomboom', 250, NULL, NULL, '1747', NULL, 'E', 'A', '1749-09-24', 'Batavia', '1749-12-08', '1749-12-19', true, '1750-04-01', 'Texel', 3430, NULL);
INSERT INTO "voyages" VALUES (7316, '', 2, '', 'SPARENRIJK', 'Jan Willemsz. van den Briel', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1749-10-20', 'Batavia', '1749-12-29', '1750-01-21', true, '1750-05-01', 'Texel', 3442, NULL);
INSERT INTO "voyages" VALUES (7317, '', 1, '', 'ELSWOUD', 'Dirk Took', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1749-10-28', 'Batavia', '1750-01-25', '1750-02-17', true, '1750-06-10', 'Texel', 3438, 'Admiraal of the ships that departed from the Cape on 17-02-1750 was Jakob van den Bos aboard the ELSWOUD; commandeur was Jakob Verleng aboard the GUSTAAF WILLEM (7320).');
INSERT INTO "voyages" VALUES (7318, '', 1, '', 'HARTEKAMP', 'Jan Diederik Morel', 650, NULL, '1748', NULL, NULL, 'A', 'H', '1749-10-29', 'Batavia', '1749-12-29', '1750-01-21', true, '1750-04-22', 'Texel', 3440, NULL);
INSERT INTO "voyages" VALUES (7319, '', 2, '', 'PASGELD', 'Hendrik van Oudheusden', 850, NULL, '1744', NULL, NULL, 'D', 'D', '1749-10-31', 'Batavia', '1750-01-25', '1750-02-17', true, '1750-06-07', 'Goeree', 3436, NULL);
INSERT INTO "voyages" VALUES (7320, '', 2, '', 'GUSTAAF WILLEM', 'Kornelis Jurriaansz.', 1150, NULL, '1744', NULL, NULL, 'Z', 'A', '1749-11-05', 'Batavia', '1750-01-25', '1750-02-17', true, '1750-06-10', 'Texel', 3450, 'Aboard the GUSTAAF WILLEM was Jakob Verleng, commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7321, '', 5, '', 'ARNESTUN', 'Jochem Aldertsz. Tamike', 575, NULL, '1736', NULL, NULL, 'Z', 'Z', '1749-11-12', 'Batavia', '1750-01-25', '1750-02-17', true, '1750-06-07', 'Rammekens', 3446, NULL);
INSERT INTO "voyages" VALUES (7322, '', 4, '', 'NIEUWSTAD', 'Gerrit Bot', 650, NULL, '1733', NULL, NULL, 'H', 'H', '1749-11-13', 'Batavia', '1750-02-07', '1750-03-12', true, '1750-06-22', 'Texel', 3326, NULL);
INSERT INTO "voyages" VALUES (7323, '', 2, '', 'BAARZANDE', 'Martin Haringman', 850, NULL, '1745', NULL, NULL, 'Z', 'E', '1749-11-16', 'Batavia', NULL, NULL, false, '1750-09-26', 'Texel', 3453, NULL);
INSERT INTO "voyages" VALUES (7324, '', 1, '', 'SCHAKENBOS', 'Gillis Dabijn', 850, NULL, '1746', NULL, NULL, 'R', 'R', '1749-11-16', 'Batavia', '1750-02-07', '1750-03-12', true, '1750-06-22', 'Goeree', 3398, NULL);
INSERT INTO "voyages" VALUES (7325, '', NULL, '', 'NOT USED', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1749-11-16', NULL, NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (7326, '', 3, '', 'DIEMEN', 'Jakob Wiebe', 850, NULL, '1743', NULL, NULL, 'A', 'A', '1749-12-04', 'Ceylon', '1750-04-08', '1750-04-21', true, '1750-07-20', 'Texel', 3444, NULL);
INSERT INTO "voyages" VALUES (7327, '', 2, '', 'HERCULES', 'Thijl Jansz. Thijling', 850, NULL, '1743', NULL, NULL, 'Z', 'Z', '1749-12-04', 'Ceylon', '1750-04-09', '1750-05-24', true, '1750-11-20', 'Rammekens', 3423, 'The 6 passengers were condemned persons. On 10-07-1750 the HERCULES was back at False Bay.');
INSERT INTO "voyages" VALUES (7328, '', 3, '', 'SPANDERSWOUD', 'Jean de la Voie', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1749-12-04', 'Ceylon', '1750-04-20', '1750-05-02', true, '1750-08-04', 'Texel', 3445, 'The 3 passengers included 2 condemned persons.');
INSERT INTO "voyages" VALUES (7329, '', 1, '', 'SLOTEN', 'Arneus Lodewijk Berting', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1749-12-23', 'China', '1750-04-10', '1750-04-23', true, '1750-07-20', 'Texel', 3413, NULL);
INSERT INTO "voyages" VALUES (7330, '', 3, '', 'EENDRACHT', 'Abraham Haring', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1750-01-20', 'Batavia', '1750-04-30', '1750-05-12', true, '1750-09-05', 'Texel', 3416, NULL);
INSERT INTO "voyages" VALUES (7331, '', 2, '', 'HOF D''UNO', 'Gerrit Reyndertsz. Vos', 1150, NULL, '1743', NULL, NULL, 'Z', 'Z', '1750-01-20', 'Batavia', '1750-04-26', '1750-05-12', true, '1750-08-19', 'Rammekens', 3443, NULL);
INSERT INTO "voyages" VALUES (7332, '', 1, '', 'WAAKZAAMHEID', 'Frederik Jan Paul Honsdorp', 850, NULL, '1744', NULL, NULL, 'E', 'E', '1750-01-20', 'Batavia', '1750-04-28', '1750-05-12', true, '1750-09-11', 'Texel', 3345, NULL);
INSERT INTO "voyages" VALUES (7333, '', 1, '', 'HUIS TEN DONK', 'Govert van Welle', 875, NULL, '1745', NULL, NULL, 'R', 'Z', '1750-02-22', 'Ceylon', '1750-09-04', '1750-09-19', true, '1751-06-11', 'Rammekens', 3364, 'the reef off Cape Agulhas, was spoken by the HUIS TE RENSBURG (7336). From 14-08 till 19-08-1750 the HUIS TEN DONK was at anchor at the Vlees Bay.');
INSERT INTO "voyages" VALUES (7334, '', 2, '', 'HUIGENWAARD', 'Hubertus van der Linde', 850, NULL, '1742', NULL, NULL, 'H', 'A', '1750-02-25', 'Bengal', '1750-06-16', '1750-07-07', true, '1750-11-20', 'Texel', 3417, 'The HUIGENWAARD did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7335, '', 4, '', 'OUWERKERK', 'Pieter Lund', 540, NULL, '1738', NULL, NULL, 'Z', 'Z', '1750-02-25', 'Bengal', '1750-07-19', '1750-09-18', true, '1751-02-23', 'Rammekens', 3363, 'The OUWERKERK did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7336, '', 3, '', 'HUIS TE RENSBURG', 'Willem de Wijs', 650, NULL, '1740', NULL, NULL, 'Z', 'A', '1750-02-26', 'Ceylon', '1750-07-20', '1750-09-18', true, '1751-03-27', 'Texel', 3432, '(3432/7336) of this ship, which during its two preceding voyages was called DUINENBURG (numbers of the second voyage: 3331/7258).');
INSERT INTO "voyages" VALUES (7337, '', 3, '', 'HOOP', 'Pieter Lichthart', 850, NULL, '1742', NULL, NULL, 'D', 'H', '1750-04-15', 'Batavia', '1750-08-08', '1750-09-18', true, '1751-04-01', 'Texel', 3455, 'The HOOP did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7338, '', 2, '', 'BEVALLIGHEID', 'Maarten de Vos', 850, NULL, '1746', NULL, NULL, 'R', 'D', '1750-09-07', 'Batavia', '1750-12-13', '1751-03-05', true, '1751-06-09', 'Goeree', 3477, NULL);
INSERT INTO "voyages" VALUES (7339, '', 2, '', 'VOSMAAR', 'Willem van der Heyden', 850, NULL, '1746', NULL, NULL, 'Z', 'R', '1750-09-07', 'Batavia', '1750-12-01', '1751-02-02', true, '1751-05-10', 'Goeree', 3478, NULL);
INSERT INTO "voyages" VALUES (7340, '', 2, '', 'IMMAGONDA', 'Hendrik Visser', 850, NULL, '1746', NULL, NULL, 'E', 'E', '1750-09-10', 'Batavia', '1750-11-23', '1751-02-02', true, '1751-05-15', 'Texel', 3481, NULL);
INSERT INTO "voyages" VALUES (7341, '', 1, '', 'LIEFDE', 'Jochem Outjes', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1750-09-18', 'Batavia', '1750-11-27', '1751-03-05', true, '1751-06-10', 'Texel', 3470, NULL);
INSERT INTO "voyages" VALUES (7342, '', 3, '', 'AKERENDAM', 'Klaas Andersen', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1750-09-24', 'Batavia', '1750-11-28', '1751-02-02', true, '1751-05-13', 'Texel', 3461, NULL);
INSERT INTO "voyages" VALUES (7343, '', 1, '', 'JAGER', 'Willem van Mensburg', 850, NULL, '1745', NULL, NULL, 'H', 'H', '1750-09-27', 'Batavia', '1750-12-14', '1751-02-02', true, '1751-05-23', 'Texel', 3395, NULL);
INSERT INTO "voyages" VALUES (7344, '', 1, '', 'KIEVITSHEUVEL', 'Jochem Beek', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1750-10-01', 'Batavia', '1750-12-10', '1751-02-02', true, '1751-05-09', 'Texel', 3482, NULL);
INSERT INTO "voyages" VALUES (7345, '', 2, '', 'SLOTERDIJK', 'Herman Zoet', 1150, NULL, '1747', NULL, NULL, 'A', 'Z', '1750-10-01', 'Batavia', '1750-12-19', '1751-02-02', true, '1751-05-13', 'Rammekens', 3472, NULL);
INSERT INTO "voyages" VALUES (7346, '', 2, '', 'HERSTELDER', 'Kornelis Eike', 1150, NULL, NULL, '1741', NULL, 'A', 'A', '1750-10-29', 'Batavia', '1750-12-26', '1751-03-05', true, '1751-06-10', 'Texel', 3332, NULL);
INSERT INTO "voyages" VALUES (7347, '', 5, '', 'HUIS TER DUINE', 'Leendert van Dijk', 550, NULL, '1739', NULL, NULL, 'Z', 'A', '1750-11-14', 'Bengal', '1751-02-11', '1751-02-27', true, '1751-06-12', 'Texel', 3459, NULL);
INSERT INTO "voyages" VALUES (7348, '', 3, '', 'OVERNES', 'Michiel van Son', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1750-11-14', 'China', '1751-03-07', '1751-04-01', true, '1751-06-26', 'Texel', 3463, 'See also the WAPEN VAN HOORN (7350).');
INSERT INTO "voyages" VALUES (7349, '', 1, '', 'NIEUWVIJVERVREUGD', 'Jan du Riets', 1150, NULL, '1748', NULL, NULL, 'Z', 'Z', '1750-11-22', 'China', '1751-03-14', '1751-03-31', true, '1751-06-26', 'Rammekens', 3466, NULL);
INSERT INTO "voyages" VALUES (7350, '', 1, '', 'WAPEN VAN HOORN', 'Jakob Greef', 850, NULL, '1747', NULL, NULL, 'H', 'Z', '1750-11-30', 'Ceylon', NULL, NULL, false, NULL, NULL, 3457, 'the island Ascension, 10-05-1751. On 28-01-1752 the ship sank off Cape Finisterre; Jakob Greef and 32 other members of the crew were saved.');
INSERT INTO "voyages" VALUES (7351, '', 4, '', 'KRABBENDIJKE', 'Otto Freudenfeld', 830, NULL, '1738', NULL, NULL, 'Z', 'A', '1750-11-30', 'Ceylon', '1751-02-11', '1751-03-05', true, '1751-06-10', 'Texel', 3456, 'The 6 passengers included 5 condemned persons.');
INSERT INTO "voyages" VALUES (7352, '', 2, '', 'OVERSCHIE', 'Leendert de Bruin', 850, NULL, '1745', NULL, NULL, 'D', 'D', '1751-01-06', 'Bengal', '1751-03-31', '1751-04-21', true, '1751-07-22', 'Goeree', 3435, NULL);
INSERT INTO "voyages" VALUES (7353, '', 3, '', 'BROUWER', 'Adriaan de Graaf', 850, NULL, '1743', NULL, NULL, 'H', 'E', '1751-01-21', 'Batavia', '1751-04-30', '1751-05-16', true, '1751-08-21', 'Texel', 3489, NULL);
INSERT INTO "voyages" VALUES (7354, '', 1, '', 'GOUVERNEUR-GENERAAL', 'Kornelis Vis', 850, NULL, '1749', NULL, NULL, 'D', 'D', '1751-01-24', 'Batavia', '1751-05-27', '1751-06-22', true, '1751-10-06', 'Goeree', 3487, NULL);
INSERT INTO "voyages" VALUES (7355, '', 1, '', 'ADMIRAAL DE RUYTER', 'Bastiaan Verdoes', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1751-01-27', 'Batavia', '1751-05-09', '1751-05-27', true, '1751-09-15', 'Texel', 3483, 'The 10 passengers were condemned persons. Aboard the ADMIRAAL DE RUYTER was commandeer Jan Huygens.');
INSERT INTO "voyages" VALUES (7356, '', 3, '', 'GERECHTIGHEID', 'Martin Lop', 850, NULL, '1742', NULL, NULL, 'E', 'Z', '1751-02-01', 'Ceylon', '1751-04-13', '1751-04-28', true, '1751-08-05', 'Rammekens', 3475, NULL);
INSERT INTO "voyages" VALUES (7357, '', 4, '', 'WOITKENSDORP', 'Kornelis Leempoel', 800, NULL, '1739', NULL, NULL, 'Z', 'A', '1751-02-01', 'Ceylon', '1751-04-30', '1751-05-18', true, '1751-09-15', 'Texel', 3460, NULL);
INSERT INTO "voyages" VALUES (7358, '', 2, '', 'OOSTKAPELLE', 'Gijsbert Bonekamp', 850, NULL, '1745', NULL, NULL, 'Z', 'Z', '1751-02-06', 'Batavia', '1751-05-25', '1751-06-21', true, '1751-10-03', 'Rammekens', 3488, 'False Bay');
INSERT INTO "voyages" VALUES (7359, '', 1, '', 'STRALEN', 'Kornelis Trappel', 850, NULL, '1748', NULL, NULL, 'E', 'H', '1751-02-09', 'Bengal', '1751-05-14', '1751-06-02', true, '1751-09-09', 'Rammekens', 3484, 'Arrival of the STRALEN at Texel: 04-11-1751.');
INSERT INTO "voyages" VALUES (7360, '', 2, '', 'HECTOR', 'Mulder', NULL, 'hoeker', '1738', NULL, NULL, 'Z', 'A', '1751-03-01', 'The Cape', '1751-03-01', NULL, true, '1751-06-01', 'Texel', 3286, NULL);
INSERT INTO "voyages" VALUES (7361, '', 1, '', 'WITSBURG', 'Jurriaan Hinst', 850, NULL, '1746', NULL, NULL, 'E', 'R', '1751-03-10', 'Bengal', '1751-06-20', '1751-07-08', true, '1751-10-09', 'Goeree', 3425, NULL);
INSERT INTO "voyages" VALUES (7362, '', 6, '', 'BATAVIER', 'Paulus Engelaar', 525, NULL, '1735', NULL, NULL, 'A', 'Z', '1751-04-13', 'Batavia', '1751-09-11', '1751-10-22', true, '1752-02-25', 'Rammekens', 3467, 'The 81 men aboard the BATAVIER included one passenger.');
INSERT INTO "voyages" VALUES (7363, '', 2, '', 'GETROUWIGHEID', 'Hendrik Westermeer', 850, NULL, '1744', NULL, NULL, 'H', 'A', '1751-09-29', 'Batavia', '1751-12-25', '1752-01-12', true, '1752-05-05', 'Texel', NULL, 'Crew at the Cape: 107.');
INSERT INTO "voyages" VALUES (7364, '', 2, '', 'BREDENHOF', 'Jakob van Wies', 850, NULL, '1746', NULL, NULL, 'H', 'Z', '1751-10-11', 'Batavia', '1752-01-15', '1752-04-22', true, '1752-07-23', 'Rammekens', 3502, 'reaching the Cape the BREDENHOF called at Robben Island, 05 till 15-01-1752. Crew at the Cape: 86.');
INSERT INTO "voyages" VALUES (7365, '', 1, '', 'VREDE', 'Abraham Zwart', 850, NULL, '1746', NULL, NULL, 'Z', 'E', '1751-10-25', 'Batavia', '1752-01-27', '1752-02-18', true, '1752-05-27', 'Texel', 3449, 'Crew at the Cape: 123.');
INSERT INTO "voyages" VALUES (7366, '', 2, '', 'KASTEEL VAN TILBURG', 'Kornelis de Nijs', 850, NULL, '1746', NULL, NULL, 'A', 'A', '1751-11-04', 'Batavia', '1752-01-19', '1752-02-12', true, '1752-05-15', 'Texel', 3468, 'Crew at the Cape: 130. After the arrival of the ship at patria its name was altered into DIEMEN (see 3577/-).');
INSERT INTO "voyages" VALUES (7367, '', 2, '', 'HUIS TE MANPAD', 'Jan Sluiskens', 850, NULL, '1745', NULL, NULL, 'A', 'H', '1751-11-19', 'Batavia', '1752-02-03', '1752-02-23', true, '1752-05-30', 'Texel', 3441, 'Crew at the Cape: 118.');
INSERT INTO "voyages" VALUES (7368, '', 3, '', 'ZUIDERBURG', 'Jan Willemsz. van den Briel', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1751-11-21', 'Ceylon', '1752-02-03', '1752-02-23', true, '1752-05-30', 'Texel', 3464, NULL);
INSERT INTO "voyages" VALUES (7369, '', 4, '', 'DIEMEN', 'Pieter Jongedijk', 850, NULL, '1743', NULL, NULL, 'A', 'A', '1751-11-25', 'Bengal', '1752-02-03', '1752-02-23', true, '1752-06-01', 'Texel', 3513, 'Crew at the Cape: 92. On 22-05-1752 the DIEMEN was spoken by the STRALEN (sailing to Batavia, see 3558), in the Channel: the ship appeared to have lost its mainmast. After the arrival of the ship at patria its name was altered into KASTEEL VAN TILBURG (see its last two voyages, 3580/7475 and 3706/-).');
INSERT INTO "voyages" VALUES (7370, '', 2, '', 'AMSTELVEEN', 'Herman Laurier', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1751-11-30', 'China', '1752-03-24', '1752-04-16', true, '1752-07-07', 'Texel', 3479, 'Crew at the Cape: 105.');
INSERT INTO "voyages" VALUES (7371, '', 1, '', 'GELDERMALSEN', NULL, 1150, NULL, '1746', NULL, NULL, 'Z', 'Z', '1751-12-18', 'China', NULL, NULL, true, NULL, NULL, 3427, 'On 18-01-1752 the GELDERMALSEN was wrecked on 10-01-1752 on Geldria''s Droogte; wreck discovered. 32 members of the crew were saved.');
INSERT INTO "voyages" VALUES (7372, '', 3, '', 'VOORZICHTIGHEID', 'Kornelis de Jonge', 850, NULL, '1743', NULL, NULL, 'D', 'E', '1751-12-15', 'Bengal', '1752-03-22', '1752-04-04', true, '1752-07-02', 'Texel', 3452, 'From 27-12-1751 till 02-01-1752 the VOORZICHTIGHEID called at Gale on Ceylon. Crew at the Cape: 90.');
INSERT INTO "voyages" VALUES (7373, '', 2, '', 'HAARLEM', 'Willem Klump', 1150, NULL, '1745', NULL, NULL, 'A', 'A', '1752-01-12', 'Batavia', '1752-03-26', '1752-04-16', true, '1752-07-07', 'Texel', 3439, 'persons.');
INSERT INTO "voyages" VALUES (7374, '', 1, '', 'BLOEMENDAAL', 'Hendrik Taal', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1752-01-16', 'Ceylon', '1752-03-22', '1752-04-04', true, '1752-07-02', 'Texel', 3469, 'The five passengers included three students and one condemned person.');
INSERT INTO "voyages" VALUES (7375, '', 4, '', 'ZAAMSLAG', 'Jakob Kolom', 900, NULL, '1741', NULL, NULL, 'Z', 'Z', '1752-01-16', 'Ceylon', '1752-03-28', '1752-04-16', true, '1752-08-06', 'Rammekens', 3495, 'The passenger was a condemned person.');
INSERT INTO "voyages" VALUES (7376, '', 1, '', 'MEERVLIET', 'Adriaan Roos', 850, 'fluit', '1749', NULL, NULL, 'A', 'A', '1752-01-25', 'Batavia', '1752-06-07', '1752-06-23', true, '1752-11-08', 'Texel', 3493, 'five passengers included two condemned persons. According to Uitloopboek the cargo was consigned to Amsterdam.');
INSERT INTO "voyages" VALUES (7377, '', 1, '', 'ROTTERDAM', 'Jan Martens', 850, NULL, '1748', NULL, NULL, 'R', 'R', '1752-01-27', 'Batavia', '1752-03-27', '1752-04-16', true, '1752-07-07', 'Goeree', 3476, 'Crew at the Cape: 95.');
INSERT INTO "voyages" VALUES (7378, '', 4, '', 'SPANDERSWOUD', 'Pieter Tornboom', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1752-01-27', 'Ceylon', '1752-04-16', '1752-05-12', true, '1752-08-27', 'Texel', 3518, NULL);
INSERT INTO "voyages" VALUES (7379, '', 3, '', 'BAARZANDE', 'Gerrit Bot', 850, NULL, '1745', NULL, NULL, 'Z', 'D', '1752-02-02', 'Batavia', '1752-05-27', '1752-06-23', true, '1752-09-23', 'Goeree', 3522, 'Crew at the Cape: 101.');
INSERT INTO "voyages" VALUES (7380, '', 3, '', 'LEIDEN', 'Willem ''t Hoen', 1150, NULL, '1744', NULL, NULL, 'A', 'Z', '1752-02-06', 'Batavia', '1752-06-03', '1752-06-23', true, '1752-09-24', 'Rammekens', 3492, 'Crew at the Cape: 130.');
INSERT INTO "voyages" VALUES (7381, '', 1, '', 'NOORD NIEUWLAND', 'Kornelis Quack', 880, NULL, '1749', NULL, NULL, 'R', 'A', '1752-02-14', 'Bengal', '1752-05-27', '1752-06-23', true, '1752-09-24', 'Texel', 3512, 'Crew at the Cape: 97.');
INSERT INTO "voyages" VALUES (7382, '', 3, '', 'PASGELD', 'Pieter de Wayer de la Rue', 850, NULL, '1745', NULL, NULL, 'D', 'Z', '1752-04-01', 'Batavia', '1752-06-14', '1752-07-09', true, '1753-03-24', 'Rammekens', 3511, 'Crew at the Cape: 89.');
INSERT INTO "voyages" VALUES (7383, '', 1, '', 'PRINSES CAROLINA', 'Josias Ruts', 300, NULL, '1748', NULL, NULL, 'Z', 'A', '1752-06-06', 'Batavia', '1752-08-16', '1752-09-12', true, '1753-03-25', 'Texel', 3454, 'Crew at the Cape: 82. The eight passengers included seven condemned persons.');
INSERT INTO "voyages" VALUES (7384, '', 3, '', 'HERCULES', 'Hendrik Booms', 850, NULL, '1743', NULL, NULL, 'Z', 'Z', '1752-10-05', 'Batavia', '1752-12-11', '1753-01-01', true, '1753-04-24', 'Rammekens', 3527, 'Crew at the Cape: 104.');
INSERT INTO "voyages" VALUES (7385, '', 3, '', 'HUIGENWAARD', 'Maarten Wout', 850, NULL, '1742', NULL, NULL, 'H', 'H', '1752-10-22', 'Batavia', '1752-12-18', '1753-02-02', true, '1753-05-03', 'Texel', 3532, 'Crew at the Cape: 117. The 11 passengers included six condemned persons.');
INSERT INTO "voyages" VALUES (7386, '', 2, '', 'SLOTEN', 'Willem Vrucht', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1752-10-22', 'Batavia', '1752-12-19', '1753-02-02', true, '1753-05-03', 'Texel', 3504, 'The nine passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7387, '', 2, '', 'NAARSTIGHEID', 'Dirk van der Schilde', 850, NULL, '1746', NULL, NULL, 'D', 'D', '1752-10-29', 'Batavia', '1753-01-25', '1753-03-17', true, '1753-06-22', 'Goeree', 3486, 'Crew at the Cape: 119.');
INSERT INTO "voyages" VALUES (7388, '', 2, '', 'JAGER', 'Jakob Leertouwer', 850, NULL, '1745', NULL, NULL, 'H', 'E', '1752-11-04', 'China', '1753-02-05', '1753-04-18', true, '1753-07-11', 'Texel', 3538, NULL);
INSERT INTO "voyages" VALUES (7389, '', 2, '', 'NIEUWVIJVERVREUGD', 'Martin Haringman', 1150, NULL, '1748', NULL, NULL, 'Z', 'Z', '1752-11-07', 'Batavia', '1753-02-02', '1753-03-06', true, '1753-06-21', 'Rammekens', 3542, 'NIEUWVIJVER-VREUGD, Martin Haringman, was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7390, '', 1, '', 'LUXEMBURG', 'Jakob Wiebe', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1752-11-09', 'China', '1753-02-20', '1753-03-06', true, '1753-06-22', 'Texel', 3515, 'Crew at the Cape: 98.');
INSERT INTO "voyages" VALUES (7391, '', 1, '', 'NIEUW NIEUWERKERK', 'Jan de Wever', 1150, NULL, '1749', NULL, NULL, 'Z', 'Z', '1752-11-09', 'China', '1753-02-16', '1753-03-06', true, '1753-06-21', 'Rammekens', 3528, 'Crew at the Cape: 103.');
INSERT INTO "voyages" VALUES (7392, '', 1, '', 'OUDKARSPEL', 'Samuel Wanjon', 1150, NULL, '1747', NULL, NULL, 'A', 'A', '1752-11-10', 'Batavia', '1753-02-02', '1753-03-17', true, '1753-06-19', 'Texel', 3431, NULL);
INSERT INTO "voyages" VALUES (7393, '', 2, '', 'WILDRUK', 'Frans Lodder', 850, NULL, '1744', NULL, NULL, 'A', 'R', '1752-11-13', 'Batavia', '1753-02-22', '1753-03-17', true, '1753-06-22', 'Goeree', 3451, NULL);
INSERT INTO "voyages" VALUES (7394, '', 1, '', 'GIESSENBURG', 'Kornelis Eike', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1752-11-15', 'Ceylon', '1753-01-25', '1753-03-06', true, '1753-05-22', 'Texel', 3509, NULL);
INSERT INTO "voyages" VALUES (7395, '', 2, '', 'WAAKZAAMHEID', 'Hendrik Visser', 850, NULL, '1744', NULL, NULL, 'E', 'Z', '1752-12-02', 'Bengal', '1753-02-15', '1753-03-06', true, '1753-06-21', 'Rammekens', 3529, 'Crew at the Cape; 103.');
INSERT INTO "voyages" VALUES (7396, '', 3, '', 'BEVALLIGHEID', 'Marten van der Meer', 850, NULL, '1746', NULL, NULL, 'R', 'A', '1752-12-29', 'Bengal', '1753-03-12', '1753-04-05', true, '1753-07-05', 'Texel', NULL, 'Crew at the Cape: 116.');
INSERT INTO "voyages" VALUES (7397, '', 4, '', 'EENDRACHT', 'Willem Kramer', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1753-01-04', 'China', '1753-04-20', '1753-05-19', true, '1753-08-30', 'Texel', 3523, 'Crew at the Cape: 89. After the return to Texel this ship was renamed ELSWOUD (see 3620/-).');
INSERT INTO "voyages" VALUES (7398, '', 2, '', 'ELSWOUD', 'Dirk Took', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1753-01-05', 'Batavia', '1753-04-23', '1753-05-19', true, '1753-11-22', 'Texel', 3503, 'The five passengers included two condemned persons. After the return to Texel this ship was renamed EENDRACHT (see 3619/7487 etc.).');
INSERT INTO "voyages" VALUES (7399, '', 2, '', 'LANGEWIJK', 'Adriaan van den Boer', 850, NULL, '1745', NULL, NULL, 'E', 'E', '1753-01-05', 'Batavia', '1753-04-22', '1753-05-19', true, '1753-09-26', 'Texel', 3491, 'Crew at the Cape: 111. The four passengers included two condemned persons.');
INSERT INTO "voyages" VALUES (7400, '', 1, '', 'OOSTHUIZEN', 'Kornelis van Zwanenburg', 850, NULL, '1749', NULL, NULL, 'H', 'H', '1753-01-05', 'Batavia', '1753-04-30', '1753-06-28', true, '1754-01-01', 'Texel', 3498, 'Cape: 100. The three passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7401, '', 4, '', 'STANDVASTIGHEID', 'Maarten de Vos', 850, NULL, '1742', NULL, NULL, 'R', 'R', '1753-01-05', 'Batavia', '1753-04-28', '1753-06-17', true, '1753-10-02', 'Goeree', 3499, 'The STANDVASTIGHEID did not call at the Cape but at False Bay. Crew at False Bay: 97. The passenger was a condemned person.');
INSERT INTO "voyages" VALUES (7402, '', 3, '', 'VOSMAAR', 'Klaas Droogsteen', 850, NULL, '1746', NULL, NULL, 'Z', 'Z', '1753-01-05', 'Batavia', '1753-04-23', '1753-05-08', true, '1753-08-17', 'Rammekens', 3531, NULL);
INSERT INTO "voyages" VALUES (7403, '', 1, '', 'ERFPRINS', 'Pieter Schoneman', 850, NULL, '1750', NULL, NULL, 'D', 'D', '1753-01-14', 'Bengal', '1753-03-26', '1753-04-05', true, '1753-07-05', 'Goeree', 3524, 'Crew at the Cape: 116.');
INSERT INTO "voyages" VALUES (7404, '', 3, '', 'HERSTELDER', 'Jan de Wit', 1150, NULL, NULL, '1741', NULL, 'A', 'A', '1753-01-30', 'Ceylon', '1753-04-23', '1753-05-08', true, '1753-07-11', 'Texel', 3552, NULL);
INSERT INTO "voyages" VALUES (7405, '', 2, '', 'KIEVITSHEUVEL', 'Pieter Broman', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1753-01-30', 'Ceylon', '1753-04-23', '1753-05-08', true, '1753-08-30', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7406, '', 5, '', 'KRABBENDIJKE', 'Hendrik Altman', 830, NULL, '1738', NULL, NULL, 'Z', 'Z', '1753-01-30', 'Ceylon', '1753-04-11', '1753-04-27', true, '1753-08-09', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7407, '', 1, '', 'VOORLAND', 'Herman Zoet', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1753-10-04', 'Batavia', '1753-12-13', '1754-01-08', true, '1754-04-23', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7408, '', 1, '', 'LYCOCHTON', 'Jochem Aldertsz. Tarnike', 880, NULL, '1749', NULL, NULL, 'E', 'E', '1753-10-25', 'Batavia', '1753-12-21', '1754-02-03', true, '1754-05-13', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7409, '', 3, '', 'HOF D''UNO', 'Tobias Sielkens', 1150, NULL, '1743', NULL, NULL, 'H', 'Z', '1753-10-29', 'Batavia', '1754-01-09', '1754-02-03', true, '1754-05-16', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7410, '', 2, '', 'HUTS TEN DONK', 'Huibert Vijs', 875, NULL, '1745', NULL, NULL, 'R', 'R', '1753-11-05', 'Batavia', '1754-01-08', '1754-02-03', true, '1754-05-18', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7411, '', 1, '', 'DEUNISVELD', 'Arie van der Pot', 850, NULL, '1747', NULL, NULL, 'D', 'D', '1753-11-10', 'Batavia', '1754-01-30', '1754-02-20', true, '1754-06-04', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7412, '', 1, '', 'LUCHTENBURG', 'Paulus Engelaar', 880, NULL, '1750', NULL, NULL, 'H', 'H', '1753-11-10', 'Batavia', '1754-02-02', '1754-02-20', true, '1754-05-14', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7413, '', 3, '', 'OOSTKAPELLE', 'Jan Hoyer', 850, NULL, '1745', NULL, NULL, 'Z', 'Z', '1753-11-10', 'Bengal', '1754-02-01', '1754-02-20', true, '1754-05-14', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7414, '', 1, '', 'MIDDELBURG', 'Willem van Mensburg', 1150, NULL, '1749', NULL, NULL, 'Z', 'Z', '1753-11-13', 'China', '1754-02-25', '1754-03-24', true, '1754-06-11', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7415, '', 4, '', 'OVERNES', 'Michiel van Son+', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1753-11-13', 'China', '1754-02-27', '1754-03-24', true, '1754-06-12', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7416, '', 4, '', 'AKERENDAM', 'Klaas Andersen', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1753-11-15', 'Ceylon', '1754-01-14', '1754-02-03', true, '1754-05-14', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7417, '', 3, '', 'SPARENRIJK', 'Kornelis Leempoel', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1753-11-22', 'Bengal', '1754-02-27', '1754-03-24', true, '1754-06-25', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7418, '', 4, '', 'BROUWER', 'Adriaan Bartels', 850, NULL, '1743', NULL, NULL, 'H', 'H', '1754-01-01', 'Bengal', '1754-04-05', '1754-04-23', true, '1754-07-19', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7419, '', 2, '', 'OSDORP', 'Willem ''t Hoen', 850, NULL, '1746', NULL, NULL, 'A', 'A', '1754-01-01', 'Bengal', '1754-04-04', '1754-04-23', true, '1754-07-16', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7420, '', 1, '', 'ROZENBURG', 'Martin van den Hoed', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1754-01-01', 'China', '1754-04-04', '1754-04-18', true, '1754-07-10', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7421, '', 1, '', 'VREDESTEIN', 'Pieter Lichthart', 880, NULL, '1750', NULL, NULL, 'R', 'R', '1754-01-01', 'China', '1754-03-30', '1754-04-18', true, '1754-07-10', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7422, '', 1, '', 'VRIJBURG', 'Boudewijn Immers', 1150, NULL, '1748', NULL, NULL, 'Z', 'Z', '1754-01-01', 'Ceylon', '1754-04-05', '1754-04-23', true, '1754-08-10', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7423, '', 4, '', 'GERECHTIGHEID', 'Martin Lop+', 850, NULL, '1742', NULL, NULL, 'E', 'D', '1754-01-16', 'Batavia', '1754-07-09', '1754-08-13', true, '1754-11-30', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7424, '', 3, '', 'GUSTAAF WILLEM', 'Jan van Ingen', 1150, NULL, '1744', NULL, NULL, 'Z', 'Z', '1754-01-16', 'Batavia', '1754-05-13', '1754-06-23', true, '1754-10-17', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7425, '', 3, '', 'IMMAGONDA', 'Reinier Jongmaats', 850, NULL, '1746', NULL, NULL, 'E', 'E', '1754-01-16', 'Batavia', '1754-05-22', '1754-06-23', true, '1754-10-14', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7426, '', 3, '', 'LEKKERLAND', 'Nikolaas de Beer', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1754-01-16', 'Batavia', '1754-04-27', '1754-05-20', true, '1754-08-30', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7427, '', 1, '', 'BOSSCHENHOVE', 'Huibert Tiebout', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1754-01-17', 'Batavia', '1754-04-27', '1754-05-17', true, '1754-08-30', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7428, '', 3, '', 'SLOT VAN KAPELLE', 'Hendrik Smit', 1150, NULL, '1745', NULL, NULL, 'A', 'A', '1754-01-31', 'Ceylon', '1754-04-13', '1754-05-07', true, '1754-09-06', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7429, '', 2, '', 'HARTEKAMP', NULL, 650, NULL, '1748', NULL, NULL, 'A', NULL, '1754-10-12', 'Bengal', NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (7430, '', 2, '', 'WITSBURG', NULL, 850, NULL, '1746', NULL, NULL, 'E', NULL, '1754-10-12', 'Bengal', NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (7431, '', 2, '', 'STRALEN', 'Pieter Eikels', 850, NULL, '1748', NULL, NULL, 'E', 'E', '1754-10-16', 'Batavia', '1754-12-30', '1755-01-13', true, '1755-04-13', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7432, '', 4, '', 'HOOP', 'Jan van der Vlucht', 850, NULL, '1742', NULL, NULL, 'D', 'D', '1754-10-30', 'Batavia', '1755-01-19', '1755-02-10', true, '1755-06-01', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7433, '', 1, '', 'KATTENDUKE', 'Jakob la Mote', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1754-10-30', 'Batavia', '1755-01-25', '1755-02-10', true, '1755-05-29', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7434, '', 1, '', 'KEUKENHOF', 'Jochem Outjes', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1754-10-30', 'Batavia', '1755-01-12', '1755-02-10', true, '1755-05-31', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7435, '', 1, '', 'PULSWEERT', 'Jan Philip Glissenberg', 880, NULL, '1752', NULL, NULL, 'H', 'H', '1754-10-30', 'Batavia', '1755-01-23', '1755-02-10', true, '1755-05-31', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7436, '', 2, '', 'ROTTERDAM', 'Klaas van den Hoed', 850, NULL, '1748', NULL, NULL, 'R', 'R', '1754-10-30', 'Batavia', '1755-01-12', '1755-02-10', true, '1755-06-01', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7437, '', 3, '', 'SLOTERDIJK', 'Jakob Boekhout', 1150, NULL, '1747', NULL, NULL, 'A', 'A', '1754-11-17', 'Ceylon', '1755-01-31', '1755-02-17', true, '1755-05-31', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7438, '', 1, '', 'TULPENBURG', 'Jean de la Voie', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1754-11-19', 'China', '1755-03-26', '1755-04-11', true, '1755-07-09', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7439, '', 4, '', 'BAARZANDE', 'Gotlieb Silo', 850, NULL, '1745', NULL, NULL, 'Z', 'Z', '1754-11-21', 'China', NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (7440, '', 1, '', 'RHOON', 'Jan Sluiskens', 1150, NULL, '1752', NULL, NULL, 'Z', 'Z', '1754-11-21', 'China', '1755-02-15', '1755-03-04', true, '1755-06-10', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7441, '', 4, '', 'BEVALLIGHEID', 'Willem Klump', 850, NULL, '1746', NULL, NULL, 'R', 'A', '1754-11-23', 'Bengal', '1755-01-25', '1755-02-17', true, '1755-05-31', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7442, '', 3, '', 'AMSTELVEEN', 'Jan Willemsz. van den Briel', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1755-01-01', 'China', '1755-03-27', '1755-04-11', true, '1755-07-10', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7443, '', 3, '', 'OVERSCHIE', 'Hans Coenraads', 850, NULL, '1745', NULL, NULL, 'D', 'D', '1755-01-01', 'China', '1755-03-20', '1755-04-06', true, '1755-06-28', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7444, '', 1, '', 'RUYSKENSTEIN', 'Willem Everdingen van der Nieuwpoort', 850, NULL, '1749', NULL, NULL, 'A', 'E', '1755-01-01', 'Bengal', '1755-04-24', '1755-05-06', true, '1755-07-30', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7445, '', 2, '', 'ADMIRAAL DE RUYTER', 'Hansen', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1755-01-01', 'China', '1755-03-20', '1755-04-06', true, '1755-06-29', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7446, '', 1, '', 'SNOEK', 'Kornelis Jurriaansz.', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1755-01-16', 'Bengal', '1755-04-07', '1755-04-18', true, '1755-07-18', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7447, '', 5, '', 'SPANDERSWOUD', 'Nikolaas Pietersz.', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1755-01-16', 'Bengal', '1755-04-05', '1755-04-18', true, '1755-07-19', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7448, '', 1, '', 'ORANJEZAAL', 'Leendert Fruit van Hertog', 880, NULL, '1750', NULL, NULL, 'E', 'H', '1755-01-17', 'Batavia', '1755-04-03', '1755-04-18', true, '1755-07-19', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7449, '', 2, '', 'NOORD NIEUWLAND', 'Thomas Hakens', 880, NULL, '1749', NULL, NULL, 'R', 'R', '1755-01-18', 'Batavia', '1755-03-25', '1755-04-11', true, '1755-07-14', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7450, '', 1, '', 'RUITEVELD', 'Kornelis Quack', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1755-01-18', 'Batavia', '1755-03-20', '1755-04-06', true, '1755-06-29', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7451, '', 2, '', 'OUDKARSPEL', 'Marten Wout', 1150, NULL, '1747', NULL, NULL, 'A', 'Z', '1755-02-01', 'Ceylon', '1755-04-05', '1755-04-18', true, '1755-07-18', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7452, '', 4, '', 'ZUIDERBURG', 'Christiaan Hagerop', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1755-02-01', 'Ceylon', '1755-04-19', '1755-05-02', true, '1755-08-24', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7453, '', 3, '', 'BAARZANDE', 'Gotlieb Silo', 850, NULL, '1745', NULL, NULL, 'H', 'Z', '1755-03-06', 'Bantam', '1755-05-07', '1755-05-20', true, '1755-08-30', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7454, '', 5, '', 'STANDVASTIGHEID', 'Jan Martens', 850, NULL, '1742', NULL, NULL, 'R', 'R', '1755-10-17', 'Batavia', '1755-12-20', '1756-03-03', true, '1756-07-29', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7455, '', 1, '', 'DELFT', 'Jan van Heemskerk', 850, NULL, '1752', NULL, NULL, 'D', 'D', '1755-10-30', 'Batavia', '1755-12-28', '1756-03-03', true, '1756-07-23', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7456, '', 3, '', 'LANGEWIJK', 'Reindert Dijkveld', 850, NULL, '1745', NULL, NULL, 'E', 'E', '1755-10-30', 'Batavia', '1755-12-28', '1756-03-03', true, '1756-07-26', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7457, '', 3, '', 'HUIS TE MANPAD', 'Matthijs de Wit', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1755-10-30', 'Batavia', '1755-12-20', '1756-03-03', true, '1756-07-26', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7458, '', 1, '', 'STADWIJK', 'Willem Vrucht', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1755-10-30', 'Batavia', '1755-12-28', '1756-03-03', true, '1756-07-26', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7459, '', 1, '', 'TORENVLIET', 'Martin Haringman', 1150, NULL, '1750', NULL, NULL, 'Z', 'Z', '1755-10-30', 'Batavia', '1755-12-28', '1756-03-03', true, '1756-07-28', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7460, '', 3, '', 'WILDRIJK', 'Pieter A. Lindholm', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1755-11-15', 'Bengal', '1756-02-04', '1756-03-03', true, '1756-07-26', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7461, '', 5, '', 'OVERNES', 'Arie van der Aart', 1150, NULL, '1742', NULL, NULL, 'A', 'A', '1755-11-20', 'Ceylon', '1756-02-04', '1756-03-03', true, '1756-07-26', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7462, '', 1, '', 'SPAARZAAMHEID', 'Jakob Wiebe', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1755-11-20', 'Ceylon', '1756-02-04', '1756-03-03', true, '1756-07-26', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7463, '', 3, '', 'HAARLEM', 'Markus Tetting', 1150, NULL, '1745', NULL, NULL, 'A', 'A', '1755-11-25', 'China', '1756-03-25', '1756-04-13', true, '1756-07-28', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7464, '', 2, '', 'NIEUW NIEUWERKERK', 'Hendrik Booms', 1150, NULL, '1749', NULL, NULL, 'Z', 'Z', '1755-11-28', 'China', '1756-03-25', '1756-04-13', true, '1756-07-29', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7465, '', 3, '', 'GETROUWIGHEID', 'Jakob Leertouwer', 850, NULL, '1744', NULL, NULL, 'H', 'H', '1756-01-02', 'China', '1756-03-25', '1756-04-13', true, '1756-07-28', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7466, '', 3, '', 'SLOTEN', 'Laurens Kok', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1756-01-02', 'China', '1756-03-24', '1756-04-13', true, '1756-07-28', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7467, '', 1, '', 'AMELISWEERT', 'Paulus Rauwenhof', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1756-01-14', 'Batavia', '1756-03-24', '1756-04-13', true, '1756-07-28', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7468, '', 4, '', 'JAGER', 'Adriaan van den Boer', 850, NULL, '1745', NULL, NULL, 'Z', 'Z', '1756-01-14', 'Batavia', '1756-04-30', '1756-06-06', true, '1756-09-19', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7469, '', 1, '', 'JERUSALEM', 'Godfried Wargijn', 880, NULL, '1752', NULL, NULL, 'R', 'R', '1756-01-14', 'Batavia', '1756-04-23', '1756-05-09', true, '1756-08-30', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7470, '', 2, '', 'LUCHTENBURG', 'Hans Lieragh', 880, NULL, '1750', NULL, NULL, 'H', 'H', '1756-01-14', 'Batavia', NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (7471, '', 3, '', 'NIEUWVIJVERVREUGD', 'Marinus de Jonge', 1150, NULL, '1748', NULL, NULL, 'Z', 'Z', '1756-01-14', 'Batavia', '1756-04-17', '1756-05-09', true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (7472, '', 1, '', 'PERSIJNENBURG', 'Pieter Arendse', 880, NULL, '1752', NULL, NULL, 'E', 'E', '1756-01-14', 'Batavia', NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (7473, '', 2, '', 'GOUVERNEUR-GENERAAL', 'Dirk van der Schilde', 850, NULL, '1749', NULL, NULL, 'D', 'D', '1756-01-17', 'Bengal', '1756-04-23', '1756-05-09', true, '1756-08-30', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7474, '', 4, '', 'HERCULES', 'Johannes Nicolaij', 850, NULL, '1743', NULL, NULL, 'Z', 'Z', '1756-01-17', 'Bengal', '1756-03-22', '1756-04-13', true, '1756-07-29', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7475, '', 5, '', 'KASTEEL VAN TILBURG', 'Gillis Paterson', 850, NULL, '1743', NULL, NULL, 'A', 'A', '1756-01-17', 'Bengal', '1756-04-23', '1756-05-09', true, '1756-08-28', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7476, '', 2, '', 'LIEFDE', 'Jan Hoyer', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1756-02-01', 'Ceylon', '1756-04-26', '1756-05-14', true, '1756-09-15', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7477, '', 2, '', 'ROZENBURG', 'Pieter Broman', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1756-02-01', 'Ceylon', '1756-05-04', '1756-05-14', true, '1756-08-30', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7478, '', 6, '', 'BATAVIER', 'Jakob Regnault', 525, NULL, '1735', NULL, NULL, 'A', 'A', '1756-04-06', 'Batavia', '1756-07-21', '1756-08-19', true, '1757-04-25', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7479, '', 2, '', 'VREDESTEIN', 'Kornelis de Jonge', 880, NULL, '1750', NULL, NULL, 'R', 'R', '1756-10-18', 'Batavia', '1756-12-31', '1757-02-27', true, '1757-06-29', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7480, '', 2, '', 'ERFPRINS', 'Bartholomeus Schut', 850, NULL, '1740', NULL, NULL, 'D', 'D', '1756-10-30', 'Batavia', '1757-01-17', '1757-02-27', true, '1757-06-29', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7481, '', 4, '', 'LEIDEN', 'Otto Freudenfeld', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1756-10-30', 'Batavia', '1757-01-17', '1757-02-27', true, '1757-06-23', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7482, '', 2, '', 'LYCOCHTON', 'Jochem Aldertsz. Tarnike', 880, NULL, '1749', NULL, NULL, 'E', 'H', '1756-10-30', 'Batavia', '1757-01-17', '1757-02-27', true, '1757-06-28', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7483, '', 2, '', 'MIDDELBURG', 'Kornelis van Zwanenburg', 1150, NULL, '1749', NULL, NULL, 'Z', 'Z', '1756-10-30', 'Batavia', '1757-01-17', '1757-02-27', true, '1757-06-23', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7484, '', 1, '', 'VLIETLUST', 'Jan van der Zee', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1756-10-30', 'Batavia', '1757-01-17', '1757-02-27', true, '1757-06-28', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7485, '', 2, '', 'GIESSENBURG', 'Willem Hoogland', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1756-11-16', 'Ceylon', '1757-01-25', '1757-02-27', true, '1757-06-28', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7486, '', 2, '', 'BOSSCHENHOVE', 'Klaas Andersen', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1756-12-12', 'China', '1757-03-23', '1757-04-26', true, '1757-08-14', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7487, '', 3, '', 'EENDRACHT', 'Steven Lodewijk de Lill', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1757-01-10', 'China', '1757-04-21', '1757-05-13', true, '1757-08-23', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7488, '', 1, '', 'WELGELEGEN', 'Hendrik Hartsing', 880, NULL, '1753', NULL, NULL, 'E', 'E', '1757-01-10', 'China', '1757-04-14', '1757-04-26', true, '1757-07-13', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7489, '', 1, '', 'HUIS TE BOEDE', 'Molensteen', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1757-01-19', 'Batavia', '1757-04-04', '1757-04-26', true, '1757-08-13', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7490, '', 5, '', 'GERECHTIGHEID', 'Hans Coenraads', 850, NULL, '1742', NULL, NULL, 'E', 'H', '1757-01-19', 'Batavia', '1757-04-05', '1757-04-26', true, '1757-08-14', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7491, '', 2, '', 'LUXEMBURG', 'Christiaan Hagerop', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1757-01-19', 'Batavia', '1757-04-05', '1757-04-26', true, '1757-08-14', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7492, '', 3, '', 'OSDORP', 'Anthony Henemans', 850, NULL, '1746', NULL, NULL, 'A', 'A', '1757-01-19', 'Batavia', '1757-04-04', '1757-04-26', true, '1757-08-14', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7493, '', 1, '', 'SCHAGEN', 'Klaas Ariensz.', 880, NULL, '1743', NULL, NULL, 'H', 'H', '1757-01-19', 'Batavia', '1757-04-11', '1757-04-26', true, '1757-07-20', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7494, '', 3, '', 'WAAKZAAMHEID', 'Simon de Graaf', 850, NULL, '1744', NULL, NULL, 'E', 'E', '1757-01-19', 'Batavia', '1757-04-05', '1757-04-26', true, '1757-08-14', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7495, '', 4, '', 'SLOT VAN KAPELLE', 'Paulus Engelaar', 1150, NULL, '1745', NULL, NULL, 'A', 'A', '1757-02-01', 'Ceylon', '1757-04-21', '1757-05-13', true, '1757-08-26', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7496, '', 1, '', 'DE DRIE PAPEGAAIEN', 'Justus Baak', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1757-02-01', 'Ceylon', '1757-04-20', '1757-05-13', true, '1757-08-23', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7497, '', 4, '', 'HOF D''UNO', 'Laurens Houtepen', 1150, NULL, '1743', NULL, NULL, 'H', 'Z', '1757-02-01', 'Ceylon', '1757-04-12', '1757-04-26', true, '1757-08-13', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7498, '', 1, '', 'SCHOLTENBURG', 'Dirk Took', 880, NULL, '1753', NULL, NULL, 'A', 'A', '1757-02-02', 'Bengal', '1757-05-12', '1757-06-10', true, NULL, 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7499, '', 1, '', 'VISVLIET', 'Frederik Schouten', 880, NULL, '1752', NULL, NULL, 'Z', 'Z', '1757-02-02', 'Bengal', '1757-05-30', '1757-06-19', true, '1757-10-16', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7500, '', 1, '', 'BUITENZORG', 'Hendrik Altman', 880, NULL, '1753', NULL, NULL, 'A', 'A', '1757-02-14', 'Bengal', '1757-05-04', '1757-07-01', true, '1757-10-14', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7501, '', 3, '', 'HUIS TEN DONK', 'Arend van der Deuren', 875, NULL, '1745', NULL, NULL, 'R', 'R', '1757-02-14', 'Bengal', '1757-05-03', '1757-05-29', true, '1757-10-31', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7502, '', 3, '', 'NAARSTIGHEID', NULL, 850, NULL, '1746', NULL, NULL, 'D', 'D', '1757-02-14', 'Bengal', NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (7503, '', 6, '', 'SPANDERSWOUD', 'Nikolaas Pietersz.', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1757-04-28', 'Batavia', '1757-07-03', '1757-07-19', true, '1757-12-11', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7504, '', 1, '', 'BLIJDORP', 'Jakob Klaasz.', 880, NULL, '1753', NULL, NULL, 'R', 'R', '1757-10-18', 'Batavia', '1757-12-08', '1758-02-26', true, '1758-06-14', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7505, '', 5, '', 'AKERENDAM', 'Adriaan de Graaf', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1757-10-29', 'Batavia', '1758-01-06', '1758-02-26', true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (7506, '', 2, '', 'DEUNISVELD', 'Jan Frederik Schrijver', 850, NULL, '1747', NULL, NULL, 'D', 'E', '1757-10-29', 'Batavia', '1758-01-10', '1758-02-26', true, '1758-07-15', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7507, '', 1, '', '''S GRAVENZANDE', 'Nikolaas Stuiver', 880, NULL, '1754', NULL, NULL, 'D', 'D', '1757-10-29', 'Batavia', '1758-01-11', '1758-02-26', true, '1758-06-14', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7508, '', 1, '', 'MARIENBOS', 'Kornelis de Nijs', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1757-10-29', 'Batavia', '1758-01-11', '1758-02-26', true, '1758-06-15', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7509, '', 2, '', 'OOSTHUIZEN', 'Jan Liebens', 850, NULL, '1749', NULL, NULL, 'H', 'H', '1757-10-29', 'Batavia', '1758-01-10', '1758-02-26', true, '1758-06-15', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7510, '', 1, '', 'VROUWE PETRONELLA MARIA', 'Jean de la Voie', 1150, NULL, '1755', NULL, NULL, 'A', 'A', '1757-10-29', 'Batavia', '1758-01-06', '1758-02-26', true, '1758-06-15', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7511, '', 1, '', 'VLISSINGEN', 'Laurens Helmstrom', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1757-10-29', 'Batavia', '1758-01-10', '1758-02-26', true, '1758-06-14', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7512, '', 1, '', 'WALCHEREN', 'Leendert Fruit van Hertog', 1150, NULL, '1754', NULL, NULL, 'Z', 'Z', '1757-10-29', 'Batavia', '1758-01-10', '1758-02-26', true, '1758-06-14', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7513, '', 3, '', 'NOORD NIEUWLAND', 'Govert van Welle', 880, NULL, '1749', NULL, NULL, 'R', 'R', '1757-11-16', 'Batavia', '1758-01-28', '1758-02-26', true, '1758-06-14', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7514, '', 5, '', 'HOOP', 'Thomas Hakens', 850, NULL, '1742', NULL, NULL, 'D', 'A', '1757-11-22', 'Bengal', '1758-02-01', '1758-02-26', true, '1758-06-15', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7515, '', 2, '', 'KATTENDIJKE', 'Lieve Timmerman', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1757-11-22', 'Bengal', '1758-02-06', '1758-02-26', true, '1758-06-14', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7516, '', 2, '', 'VRIJBURG', 'Jakob Reysik', 1150, NULL, '1748', NULL, NULL, 'Z', 'Z', '1757-12-12', 'China', '1758-04-05', '1758-04-26', true, '1758-09-08', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7517, '', 2, '', 'RUITEVELD', 'Anthony Heideman', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1757-12-16', 'Ceylon', '1758-02-18', '1758-02-26', true, '1758-06-15', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7518, '', 2, '', 'DELFT', 'Pieter Hogendorp', 850, NULL, '1752', NULL, NULL, 'D', 'D', '1758-01-18', 'Batavia', '1758-03-26', '1758-04-22', true, '1758-07-30', 'Goeree', NULL, NULL);
INSERT INTO "voyages" VALUES (7519, '', 4, '', 'IMMAGONDA', 'Leendert van der Linden', 850, NULL, '1746', NULL, NULL, 'E', 'E', '1758-01-18', 'Batavia', '1758-04-16', '1758-04-28', true, '1758-09-02', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7520, '', 1, '', 'RADERMACHER', 'Pieter Ruis', 1150, NULL, '1753', NULL, NULL, 'Z', 'Z', '1758-01-18', 'Batavia', '1758-04-16', '1758-04-28', true, '1758-09-02', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7521, '', 4, '', 'SLOTEN', 'Godfried Wargijn', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1758-01-22', 'China', '1758-04-16', '1758-04-28', true, '1758-09-03', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7522, '', 5, '', 'BROUWER', 'Jakob Ketel', 850, NULL, '1743', NULL, NULL, 'H', 'H', '1758-01-23', 'Bengal', '1758-04-18', '1758-04-28', true, '1758-09-01', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7523, '', 4, '', 'SPARENRIJK', 'Jan van Dalen', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1758-01-23', 'Bengal', '1758-04-14', '1758-04-22', true, '1758-08-20', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (7524, '', 2, '', 'KEUKENHOF', 'Kornelis Stuurman', 1150, NULL, '1753', NULL, NULL, 'A', 'Z', '1758-02-01', 'Ceylon', '1758-04-17', '1758-04-28', true, '1758-09-02', 'Rammekens', NULL, NULL);
INSERT INTO "voyages" VALUES (7525, '', 4, '', 'LEKKERLAND', 'Dirk van Maastricht', 1150, NULL, '1744', NULL, NULL, 'A', 'A', '1758-02-01', 'Ceylon', '1758-04-09', '1758-04-22', true, '1758-08-02', 'Texel', 3655, 'After the arrival of the ship at patria its name was altered into MARIENBOS (see 3769/-).');
INSERT INTO "voyages" VALUES (7526, '', 5, '', 'ZUIDERBURG', 'Kornelis Boomgaard', 1150, NULL, '1743', NULL, NULL, 'A', 'A', '1758-02-01', 'Ceylon', '1758-04-17', '1758-04-28', true, '1758-09-02', 'Texel', 3680, 'Crew at the Cape: 134.');
INSERT INTO "voyages" VALUES (7527, '', 4, '', 'HUIS TE MANPAD', 'Andries Lint', 850, NULL, '1745', NULL, NULL, 'A', 'A', '1758-04-28', 'Batavia', '1758-08-10', '1758-08-23', true, '1758-12-16', 'Texel', 3699, 'Crew at the Cape: 101.');
INSERT INTO "voyages" VALUES (7528, '', 2, '', 'PIJLSWAART', 'Pieter Matthijs Joele', 880, NULL, '1752', NULL, NULL, 'H', 'H', '1758-10-28', 'Batavia', '1758-12-30', '1759-02-28', true, '1759-06-24', 'Texel', 3667, '(see 7534).');
INSERT INTO "voyages" VALUES (7529, '', 1, '', 'BARBARA THEODORA', 'Visser', 1150, NULL, '1753', NULL, NULL, 'Z', 'Z', '1758-10-31', 'Batavia', '1759-01-10', '1759-02-26', true, '1759-06-24', 'Rammekens', 3654, 'The six passengers included two condemned persons.');
INSERT INTO "voyages" VALUES (7530, '', 5, '', 'BEVALLIGHEID', 'Albert Verzaat', 850, NULL, '1746', NULL, NULL, 'R', 'R', '1758-10-31', 'Batavia', '1759-01-13', '1759-02-26', true, NULL, NULL, NULL, '366 The BEVALLIGHEID got missing between the Cape and patria.');
INSERT INTO "voyages" VALUES (7531, '', 3, '', 'BOSSCHENHOVE', 'Jan Hoyer', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1758-10-31', 'Batavia', '1759-01-04', '1759-02-26', true, '1759-06-24', 'Texel', 3718, 'The three passengers included two condemned persons.');
INSERT INTO "voyages" VALUES (7532, '', 4, '', 'GETROUWIGHEID', 'Augustinus Heynenberg', 850, NULL, '1744', NULL, NULL, 'H', 'H', '1758-10-31', 'Batavia', '1759-01-07', '1759-02-26', true, '1759-06-24', 'Texel', 3698, 'Crew at the Cape: 110.');
INSERT INTO "voyages" VALUES (7533, '', 3, '', 'GOUVERNEUR-GENERAAL', 'Bartholomeus Schut', 850, NULL, '1749', NULL, NULL, 'D', 'D', '1758-10-31', 'Batavia', '1759-01-04', '1759-02-26', true, '1759-06-24', 'Goeree', 3709, NULL);
INSERT INTO "voyages" VALUES (7534, '', 3, '', 'KIEVITSHEUVEL', 'Leendert Marinus Kouw', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1758-10-31', 'Batavia', '1759-01-04', '1759-02-26', true, '1759-06-24', 'Texel', 3621, 'The master of the KIEVITSHEUVEL, Leendert Marinus Kouw, was commandeer of the return fleet.');
INSERT INTO "voyages" VALUES (7535, '', 4, '', 'OVERSCHIE', 'Pieter van Kronenburg', 850, NULL, '1745', NULL, NULL, 'D', 'D', '1758-10-31', 'Batavia', '1759-01-08', '1759-02-26', true, '1759-06-24', 'Goeree', 3681, NULL);
INSERT INTO "voyages" VALUES (7536, '', 4, '', 'SLOTERDIJK', 'Kornelis van der Stam', 1150, NULL, '1747', NULL, NULL, 'A', 'A', '1758-10-31', 'Batavia', '1759-01-06', '1759-02-26', true, '1759-06-29', 'Texel', 3671, 'The nine passengers included one condemned person. After the arrival of the ship at patria its name was altered into VROUWE REBECCA JACOBA (see 3803/-).');
INSERT INTO "voyages" VALUES (7537, '', 3, '', 'STRALEN', 'Daniel Nieman', 850, NULL, '1748', NULL, NULL, 'E', 'E', '1758-10-31', 'Batavia', '1759-01-04', '1759-02-26', true, '1759-06-24', 'Texel', 3673, 'The five passengers included three condemned persons.');
INSERT INTO "voyages" VALUES (7538, '', 4, '', 'VOSMAAR', 'Huibrecht van der Kneu', 850, NULL, '1746', NULL, NULL, 'Z', 'Z', '1758-10-31', 'Batavia', '1759-01-04', '1759-02-26', true, '1759-06-24', 'Rammekens', 3624, 'The three passengers included two condemned persons.');
INSERT INTO "voyages" VALUES (7539, '', 3, '', 'ROTTERDAM', 'Simon Smit', 850, NULL, '1748', NULL, NULL, 'R', 'R', '1758-11-04', 'Batavia', '1759-01-13', '1759-02-26', true, '1759-07-05', 'Goeree', 3682, NULL);
INSERT INTO "voyages" VALUES (7540, '', 2, '', 'SNOEK', 'Jan Sluiskens', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1758-11-04', 'Batavia', '1759-01-04', '1759-02-26', true, '1759-06-24', 'Rammekens', 3672, 'The three passengers included two condemned persons.');
INSERT INTO "voyages" VALUES (7541, '', 1, '', 'VROUWE PETRONELLA', 'Reindert Dijkveld', 880, NULL, '1755', NULL, NULL, 'E', 'E', '1758-11-13', 'Bengal', '1759-01-29', '1759-02-26', true, '1759-06-24', 'Texel', 3701, '104.');
INSERT INTO "voyages" VALUES (7542, '', 4, '', 'WILDRIJK', 'Jan Spek', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1758-11-13', 'Bengal', '1759-02-19', '1759-02-26', true, '1759-08-05', 'Texel', 3704, 'Crew at the Cape: 97.');
INSERT INTO "voyages" VALUES (7543, '', 1, '', 'LAPIENENBURG', 'Hendrik Winkelman .', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1758-01-16', 'Ceylon', '1759-01-29', '1759-02-26', true, '1759-06-24', 'Texel', 3633, 'Crew at the Cape: 144.');
INSERT INTO "voyages" VALUES (7544, '', 3, '', 'OVERNES', 'Jan Schellinger', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1758-01-16', 'Ceylon', '1759-01-22', '1759-02-26', true, '1759-06-25', 'Texel', 3700, 'for the second time, now into AMERONGEN (see 3796/7638 and 3901/-');
INSERT INTO "voyages" VALUES (7545, '', 1, '', 'VELSEN', 'Markus Tetting', 1100, NULL, '1756', NULL, NULL, 'A', 'A', '1758-12-22', 'China', '1759-03-25', '1759-04-21', true, '1759-09-07', 'Texel', 3716, 'Crew at the Cape: 110.');
INSERT INTO "voyages" VALUES (7546, '', 2, '', 'JERUSALEM', 'Hieronymus Jongenberg', 880, NULL, '1753', NULL, NULL, 'R', 'A', '1759-01-15', 'Bengal', '1759-04-02', '1759-04-21', true, '1759-08-04', 'Texel', 3710, 'Cape: 97.');
INSERT INTO "voyages" VALUES (7547, '', 2, '', 'VLIETLUST', 'Adriaan Bertrand', 1150, NULL, '1752', NULL, NULL, 'A', 'Z', '1759-01-15', 'Bengal', '1759-04-02', '1759-04-21', true, '1759-08-07', 'Rammekens', 3717, 'At the Cape Jakob Zwart succeeded Adriaan Bertrand as master of the VLIETLUST. Crew at the Cape: 110.');
INSERT INTO "voyages" VALUES (7548, '', 3, '', 'LUXEMBURG', 'Dirk Pietersz.', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1759-01-20', 'Batavia', '1759-04-07', '1759-04-21', true, '1759-08-04', 'Texel', 3731, 'The seven passengers included six condemned persons.');
INSERT INTO "voyages" VALUES (7549, '', 2, '', 'TORENVLIET', 'Jakob Boekhout', 1150, NULL, '1750', NULL, NULL, 'Z', 'Z', '1759-01-20', 'Batavia', '1759-04-04', '1759-04-21', true, '1759-08-07', 'Texel', 3695, 'The eight passengers included seven condemned persons.');
INSERT INTO "voyages" VALUES (7550, '', 1, '', 'RENSWOUDE', 'Jan Zacharias Nauwman', 1150, NULL, '1756', NULL, NULL, 'A', 'A', '1759-01-30', 'China', '1759-05-12', '1759-05-27', true, '1759-10-03', 'Texel', 3722, 'Crew at the Cape: 116.');
INSERT INTO "voyages" VALUES (7551, '', 4, '', 'GUSTAAF WILLEM', 'Jochem Hendrik Dodendorp', 1150, NULL, '1744', NULL, NULL, 'Z', 'Z', '1759-02-02', 'Ceylon', '1759-04-03', '1759-04-21', true, '1759-08-08', 'Rammekens', 3683, 'Crew at the Cape: 125.');
INSERT INTO "voyages" VALUES (7552, '', 2, '', 'VOORLAND', 'Isaak van den Berg', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1759-02-02', 'Ceylon', '1759-04-07', '1759-04-21', true, '1759-09-07', 'Texel', 3637, 'Crew at the Cape: 125.');
INSERT INTO "voyages" VALUES (7553, '', 2, '', 'BUITENZORG', 'Coenraad Dirk Wolk', 880, NULL, '1753', NULL, NULL, 'A', 'A', '1759-05-02', 'Batavia', '1759-07-20', '1759-08-13', true, '1759-11-24', 'Texel', 3729, 'The three passengers included one condemned person. After having been unloaded the BUITENZORG was wrecked off Texel.');
INSERT INTO "voyages" VALUES (7554, '', 6, '', 'STANDVASTIGHEID', 'Herman de Kool', 850, NULL, '1743', NULL, NULL, 'R', 'R', '1759-10-17', 'Batavia', '1759-12-10', '1759-12-15', true, '1760-06-13', 'Goeree', 3727, NULL);
INSERT INTO "voyages" VALUES (7555, '', 1, '', 'AMERONGEN', 'Christiaan Hansen', 1150, NULL, '1754', NULL, NULL, 'A', 'A', '1759-11-01', 'Batavia', '1760-01-08', '1760-02-19', true, '1760-06-12', 'Texel', 3664, 'altered into OVERNES (see 3810/7658 etc.). The commandeur of the return fleet, Koert Rozeboom, was aboard the NOORD-BEVELAND (see 7561).');
INSERT INTO "voyages" VALUES (7556, '', 1, '', 'VROUWE ELIZABETH', 'Frederik Wielard', 850, NULL, '1755', NULL, NULL, 'R', 'R', '1759-11-01', 'Batavia', '1760-01-14', '1760-02-19', true, '1760-06-13', 'Goeree', 3697, NULL);
INSERT INTO "voyages" VALUES (7557, '', 4, '', 'LANGEWIJK', 'Jakob de Vries', 850, NULL, '1745', NULL, NULL, 'E', 'E', '1759-11-01', 'Batavia', '1760-01-12', '1760-02-19', true, '1760-06-12', 'Texel', 3714, NULL);
INSERT INTO "voyages" VALUES (7558, '', 3, '', 'LYCOCHTON', 'Kornelis Kuiper', 880, NULL, '1749', NULL, NULL, 'E', 'H', '1759-01-01', 'Batavia', '1760-01-20', '1760-02-19', true, '1760-06-12', 'Texel', 3715, NULL);
INSERT INTO "voyages" VALUES (7559, '', 3, '', 'NIEUW NIEUWERKERK', 'Dirk Wagtels', 1150, NULL, '1749', NULL, NULL, 'Z', 'Z', '1759-11-01', 'Batavia', '1760-01-26', '1760-02-19', true, '1760-06-13', 'Rammekens', 3708, NULL);
INSERT INTO "voyages" VALUES (7560, '', 1, '', 'NOORD-BEVELAND', 'Jakob Reysik', 1150, NULL, '1756', NULL, NULL, 'Z', 'Z', '1759-11-01', 'Batavia', '1760-01-08', '1760-02-19', true, '1760-06-13', 'Rammekens', 3741, 'in aboard the NOORD-BEVELAND.');
INSERT INTO "voyages" VALUES (7561, '', 3, '', 'OUDKARSPEL', 'Michiel Hamelo', 1150, NULL, '1747', NULL, NULL, 'A', 'A', '1759-11-01', 'Batavia', '1760-01-11', '1760-02-19', true, '1760-06-12', 'Texel', 3684, 'The five passengers included two condemned persons; they disembarked at the Cape.');
INSERT INTO "voyages" VALUES (7562, '', 2, '', 'RHOON', 'Adriaan van den Boer', 1150, NULL, '1752', NULL, NULL, 'Z', 'Z', '1759-11-01', 'Batavia', '1760-01-12', '1760-02-19', true, '1760-06-20', 'Rammekens', 3669, 'The four passengers included one condemned person; he was transported to the Cape to serve his sentence: a fifty years banishment in chains.');
INSERT INTO "voyages" VALUES (7563, '', 3, '', 'ADMIRAAL DE RUYTER', 'Christiaan Honsdorp', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1759-11-01', 'Batavia', '1760-01-27', '1760-02-19', true, '1760-06-12', 'Texel', 3670, 'The seven passengers included one slave and one condemned person.');
INSERT INTO "voyages" VALUES (7564, '', 2, '', 'SCHAGEN', 'Klaas Ariensz.', 880, NULL, '1753', NULL, NULL, 'H', 'H', '1759-11-01', 'Batavia', '1760-01-12', '1760-02-19', true, '1760-06-12', 'Texel', 3742, NULL);
INSERT INTO "voyages" VALUES (7565, '', 4, '', 'AMSTELVEEN', 'Willem Everdingen van der Nieuwpoort', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1759-11-10', 'Batavia', '1760-01-13', '1760-02-19', true, '1760-06-12', 'Texel', 3676, 'condemned person.');
INSERT INTO "voyages" VALUES (7566, '', 4, '', 'BAARZANDE', 'Jan Willem Munts', 850, NULL, '1745', NULL, NULL, 'H', 'E', '1759-11-10', 'Batavia', '1760-01-26', '1760-02-19', true, '1760-06-13', 'Texel', 3694, 'The seven passengers included one slave. 3694/7567 was the fourth voyage of this ship, which during its first two voyages and the outward part of its third voyage was called JAGER (3612/7453).');
INSERT INTO "voyages" VALUES (7567, '', 6, '', 'HOOP', 'Pieter Broman', 850, NULL, '1742', NULL, NULL, 'D', 'A', '1759-11-10', 'Batavia', '1760-01-21', '1760-02-19', true, '1760-06-13', 'Goeree', 3751, 'The passenger was a condemned person; he disembarked at the Cape.');
INSERT INTO "voyages" VALUES (7568, '', 1, '', 'VROUWE REBECCA JACOBA', 'Jan Bernard Schaper', 1150, NULL, '1754', NULL, NULL, 'A', 'A', '1759-11-16', 'Ceylon', '1760-01-21', '1760-02-19', true, '1760-06-12', 'Texel', 3668, 'Crew at the Cape: 123. After the arrival of the ship at patria its name was altered into SLOTERDIJK (see 3811/7664).');
INSERT INTO "voyages" VALUES (7569, '', 2, '', 'TULPENBURG', 'Louis de Jonge', 1150, NULL, '1750', NULL, NULL, 'A', 'Z', '1759-11-16', 'Ceylon', '1760-01-26', '1760-02-19', true, '1760-06-13', 'Rammekens', 3679, 'Crew at the Cape: 123.');
INSERT INTO "voyages" VALUES (7570, '', 4, '', 'TEN DONK', 'Arend van der Deuren', 875, NULL, '1745', NULL, NULL, 'R', 'A', '1759-11-19', 'Bengal', '1760-01-31', '1760-02-19', true, '1760-06-12', 'Texel', 3738, 'Crew at the Cape: 105.');
INSERT INTO "voyages" VALUES (7571, '', 2, '', 'VISVLIET', 'Justus Baak', 880, NULL, '1752', NULL, NULL, 'Z', 'Z', '1759-11-19', 'Bengal', '1760-01-31', '1760-02-19', true, '1760-06-13', 'Rammekens', 3733, 'Crew at the Cape: 101.');
INSERT INTO "voyages" VALUES (7572, '', 2, '', 'AMELISWEERT', 'Klaas Stuiver', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1760-01-17', 'Batavia', '1760-03-19', '1760-04-27', true, '1760-08-18', 'Texel', 3686, 'The five passengers included two condemned persons.');
INSERT INTO "voyages" VALUES (7573, '', 2, '', 'HUIS TE BOEDE', 'Gillis Paterson', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1760-01-17', 'Batavia', '1760-04-14', '1760-04-27', true, '1760-08-27', 'Rammekens', 3725, 'included two condemned persons.');
INSERT INTO "voyages" VALUES (7574, '', 5, '', 'IMMAGONDA', 'Jan Frederik Schrijver', 850, NULL, '1746', NULL, NULL, 'E', 'E', '1760-01-17', 'Batavia', '1760-04-12', '1760-04-27', true, '1760-08-18', 'Texel', 3760, 'The five passengers included two condemned persons.');
INSERT INTO "voyages" VALUES (7575, '', 3, '', 'LIEFDE', 'Simon de Graaf', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1760-02-01', 'Ceylon', '1760-04-09', '1760-04-27', true, '1760-08-18', 'Texel', 3740, NULL);
INSERT INTO "voyages" VALUES (7576, '', 3, '', 'VRIJBURG', 'Laurens Houtepen', 1150, NULL, '1748', NULL, NULL, 'Z', 'A', '1760-02-01', 'Ceylon', '1760-04-09', '1760-04-27', true, '1760-08-18', 'Texel', 3737, 'Crew at the Cape: 129.');
INSERT INTO "voyages" VALUES (7577, '', 1, '', 'VROUWE GEERTRUIDA', 'Christiaan Hagerop', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1760-02-03', 'China', '1760-05-21', '1760-06-24', true, '1760-10-10', 'Texel', 3748, 'Crew at the Cape: 112.');
INSERT INTO "voyages" VALUES (7578, '', 1, '', 'KRONENBURG', 'Willem Hoogland', 1100, NULL, '1757', NULL, NULL, 'A', 'Z', '1760-02-03', 'China', '1760-06-04', '1761-03-03', true, '1761-06-09', 'Texel', 3749, 'the Cape. In patria the ship first called at Texel, 09-06-1761; arrival at the Rammekens: 01-07-1761.');
INSERT INTO "voyages" VALUES (7579, '', 2, '', 'VROUWE PETRONELLA MARIA', 'Steven Lodewijk de Lill', 1100, NULL, '1755', NULL, NULL, 'A', 'A', '1760-02-03', 'China', '1760-05-29', '1760-06-24', true, '1760-10-15', 'Texel', 3750, 'Crew at the Cape: 118.');
INSERT INTO "voyages" VALUES (7580, '', 2, '', 'WELGELEGEN', 'Jan Mulder', 880, NULL, '1753', NULL, NULL, 'E', 'A', '1760-02-12', 'Bengal', '1760-05-30', '1760-06-24', true, '1760-10-16', 'Texel', 3732, 'Crew at the Cape: 105.');
INSERT INTO "voyages" VALUES (7581, '', 2, '', 'SCHOLTENBURG', 'Pieter Schoneman', 880, NULL, '1753', NULL, NULL, 'A', 'D', '1760-02-19', 'The Cape', '1760-02-19', NULL, true, '1760-06-13', 'Goeree', 3743, 'The SCHOLTENBURG carried the cargo of the NAARSTIGHEID, given up and set on fire in Delagao Bay, July 1757 (see 7502). See also the outward voyage of the SCHOLTENBURG, 3743.');
INSERT INTO "voyages" VALUES (7582, '', 2, '', 'BLIJDORP', 'Kornelis Nannings', 880, NULL, '1754', NULL, NULL, 'R', 'A', '1760-04-28', 'Batavia', '1760-07-19', '1760-08-09', true, '1760-11-06', 'Texel', 3761, 'Crew at the Cape: 97.');
INSERT INTO "voyages" VALUES (7583, '', 4, '', 'NOORD NIEUWLAND', 'Karel Koster', 880, NULL, '1749', NULL, NULL, 'R', 'R', '1760-10-10', 'Batavia', '1761-01-14', '1761-03-03', true, '1761-06-14', 'Goeree', 3768, 'Kornelis de Jonge, master of the RADERMACHER (see 7587).');
INSERT INTO "voyages" VALUES (7584, '', 2, '', 'BARBARA THEODORA', 'Pieter Visser', 1150, NULL, '1753', NULL, NULL, 'Z', 'Z', '1760-10-29', 'Batavia', '1761-01-16', '1761-03-03', true, '1761-06-19', 'Rammekens', 3779, 'The seven passengers included three condemned persons; they disembarked at the Cape. After the arrival of the ship at patria its name was altered into TORENVLIET (see 3892/-).');
INSERT INTO "voyages" VALUES (7585, '', 5, '', 'OVERSCHIE', 'Leendert Kouw', 850, NULL, '1745', NULL, NULL, 'D', 'D', '1760-10-29', 'Batavia', '1761-01-21', '1761-03-03', true, '1761-06-14', 'Goeree', 3775, NULL);
INSERT INTO "voyages" VALUES (7586, '', 2, '', 'VROUWE PETRONELLA', 'Pieter de Leur', 880, NULL, '1755', NULL, NULL, 'E', 'E', '1760-10-29', 'Batavia', '1761-01-19', '1761-03-03', true, '1761-06-09', 'Texel', 3773, NULL);
INSERT INTO "voyages" VALUES (7587, '', 2, '', 'RADERMACHER', 'Kornelis de Jonge', 1150, NULL, '1753', NULL, NULL, 'Z', 'Z', '1760-10-29', 'Batavia', '1761-01-19', '1761-03-03', true, '1761-06-19', 'Rammekens', 3756, 'criminal disembarked at the Cape.');
INSERT INTO "voyages" VALUES (7588, '', 5, '', 'SLOTEN', 'Dirk van Maastricht', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1760-10-29', 'Batavia', '1761-01-17', '1761-03-03', true, '1761-06-19', 'Texel', 3763, 'The 11 passengers included one female slave and one condemned person.');
INSERT INTO "voyages" VALUES (7589, '', 1, '', 'LEKKERLUST', 'Jan Doensen', 880, NULL, '1755', NULL, NULL, 'H', 'H', '1760-11-07', 'Batavia', '1761-01-22', '1761-03-03', true, '1761-06-09', 'Texel', 3688, 'The 12 passengers included some slaves.');
INSERT INTO "voyages" VALUES (7590, '', 3, '', 'GIESSENBURG', 'Simon van Dalen', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1760-11-17', 'Ceylon', '1761-01-20', '1761-03-30', true, '1761-06-09', 'Texel', 3719, 'Crew at the Cape: 126.');
INSERT INTO "voyages" VALUES (7591, '', 2, '', 'WALCHEREN', 'Hans Kornelisz.', 1150, NULL, '1754', NULL, NULL, 'Z', 'Z', '1760-11-17', 'Ceylon', '1761-01-26', '1761-03-30', true, '1761-07-13', 'Rammekens', 3747, 'Crew at the Cape: 127.');
INSERT INTO "voyages" VALUES (7592, '', 2, '', 'VLISSINGEN', 'Laurens Helmstrom', 880, NULL, '1754', NULL, NULL, 'Z', 'Z', '1760-11-19', 'Bengal', '1761-02-05', '1761-03-30', true, '1761-06-13', 'Rammekens', 3745, 'Crew at the Cape: 109');
INSERT INTO "voyages" VALUES (7593, '', 4, '', 'EENDRACHT', 'Jan Bloem', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1760-11-29', 'Batavia', '1761-01-19', '1761-03-03', true, '1761-06-09', 'Texel', 3735, 'was the fourth voyage of this ship, which during its first two voyages was called ELSWOUD (3503/7398).');
INSERT INTO "voyages" VALUES (7594, '', 1, '', 'OOSTERBEEK', 'Jan Schellinger', 1100, NULL, '1758', NULL, NULL, 'A', 'A', '1761-01-04', 'China', '1761-04-27', '1761-05-07', true, '1761-08-17', 'Texel', 3770, 'Crew at the Cape: 106.');
INSERT INTO "voyages" VALUES (7595, '', 1, '', 'OUDERAMSTEL', 'Jakob Wiebe', 1100, NULL, '1758', NULL, NULL, 'A', 'A', '1761-01-04', 'China', '1761-04-13', '1761-04-22', true, '1761-08-01', 'Texel', 3772, 'Crew at the Cape: 113.');
INSERT INTO "voyages" VALUES (7596, '', 2, '', 'VELSEN', 'Hendrik Winkelman', 1100, NULL, '1756', NULL, NULL, 'A', 'A', '1761-01-09', 'China', '1761-04-15', '1761-04-22', true, '1761-08-06', 'Rammekens', 3777, 'Crew at the Cape: 106.');
INSERT INTO "voyages" VALUES (7597, '', 1, '', 'BLEISWIJK', 'Hans Coenraads', 880, NULL, '1756', NULL, NULL, 'D', 'D', '1761-01-17', 'Bengal', '1761-03-24', '1761-04-22', true, '1761-08-03', 'Goeree', 3726, 'Crew at the Cape: 100.');
INSERT INTO "voyages" VALUES (7598, '', 2, '', 'ORANJEZAAL', 'Molensteen', 880, NULL, '1750', NULL, NULL, 'E', 'A', '1761-01-17', 'Bengal', '1761-03-27', '1761-04-22', true, '1761-08-01', 'Texel', 3677, 'Crew at the Cape: 106.');
INSERT INTO "voyages" VALUES (7599, '', 3, '', 'JERUSALEM', 'Thomas Middelmeer', 880, NULL, '1753', NULL, NULL, 'R', 'A', '1761-01-19', 'Batavia', '1761-05-21', '1761-06-09', true, '1761-09-24', 'Texel', 3785, NULL);
INSERT INTO "voyages" VALUES (7600, '', 3, '', 'OOSTHUIZEN', 'Adriaan de Graaf', 850, NULL, '1749', NULL, NULL, 'H', 'H', '1761-01-19', 'Batavia', '1761-04-13', '1761-04-22', true, '1761-08-01', 'Texel', 3771, NULL);
INSERT INTO "voyages" VALUES (7601, '', 3, '', 'PIJLSWAART', 'Jakob Ketel', 880, NULL, '1752', NULL, NULL, 'H', 'E', '1761-01-19', 'Batavia', '1761-04-09', '1761-04-22', true, '1761-08-01', 'Texel', 3786, NULL);
INSERT INTO "voyages" VALUES (7602, '', 1, '', 'LEIMUIDEN', 'Barend Rust', 1150, NULL, '1755', NULL, NULL, 'A', 'A', '1761-02-01', 'Ceylon', '1761-04-12', '1761-04-22', true, '1761-08-01', 'Texel', 3689, 'One passenger was a condemned person.');
INSERT INTO "voyages" VALUES (7603, '', 2, '', 'DE DRIE PAPEGAAIEN', 'Gillis P. Verlee', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1761-02-01', 'Ceylon', '1761-04-30', '1761-06-09', true, '1761-09-24', 'Texel', 3736, 'The three passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7604, '', 3, '', 'VREDESTEIN', 'Nikolaas Pietersz.', 880, NULL, '1750', NULL, NULL, 'R', 'R', '1761-04-29', 'Batavia', NULL, NULL, false, '1761-10-17', 'Goeree', 3758, NULL);
INSERT INTO "voyages" VALUES (7605, '', 4, '', 'ROTTERDAM', 'Frederik Wielard', 850, NULL, '1748', NULL, NULL, 'R', 'R', '1761-10-20', 'Batavia', '1761-12-30', '1762-01-12', true, '1762-04-02', 'Goeree', 3795, 'Crew at the Cape: 110.');
INSERT INTO "voyages" VALUES (7606, '', 5, '', 'HUIS TEN DONK', 'Kornelis van der Stam', 875, NULL, '1745', NULL, NULL, 'R', 'R', '1761-11-02', 'Batavia', '1761-12-27', '1762-03-02', true, '1762-06-25', 'Goeree', 3798, 'The admiraal of the return fleet, Roelof Blok, was aboard the LEKKERLAND (see 7611).');
INSERT INTO "voyages" VALUES (7607, '', 3, '', 'ERFPRINS', 'Jochem Hendrik Dodendorp', 850, NULL, '1752', NULL, NULL, 'D', 'D', '1761-11-02', 'Batavia', '1762-01-04', '1762-02-01', true, '1762-06-02', 'Goeree', 3757, 'Crew at the Cape: 109.3757/7607 was the third voyage of this ship, which during its two preceding voyages was called DELFT (3696/7518). The ERFPRINS replaced the previous ERFPRINS, wrecked off Calais, October 1758 (3739).');
INSERT INTO "voyages" VALUES (7608, '', 4, '', 'GOUVERNEUR-GENERAAL', 'Willem Vrucht', 850, NULL, '1749', NULL, NULL, 'D', 'D', '1761-11-02', 'Batavia', '1761-12-27', '1762-03-02', true, '1762-06-20', 'Goeree', 3784, 'Crew at the Cape:101.');
INSERT INTO "voyages" VALUES (7609, '', 4, '', 'KIEVITSHEUVEL', 'Markus Tetting', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1761-11-02', 'Batavia', '1761-12-19', '1762-02-01', true, '1762-06-02', 'Texel', 3800, 'Crew at the Cape: 120.');
INSERT INTO "voyages" VALUES (7610, '', 2, '', 'LAPIENENBURG', 'Holland', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1761-11-02', 'Batavia', '1761-12-27', '1762-03-02', true, '1762-06-26', 'Texel', 3774, 'Crew at the Cape: 112.');
INSERT INTO "voyages" VALUES (7611, '', 2, '', 'LEKKERLAND', 'Johan Sigismund Hoeve', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1761-11-02', 'Batavia', '1761-12-27', '1762-02-01', true, '1762-06-02', 'Texel', 3755, 'of this ship, which during its preceding voyage was called MARIENBOS (3605/7508).');
INSERT INTO "voyages" VALUES (7612, '', 1, '', 'NIJENBORG', 'Isaak van den Berg', 880, NULL, '1757', NULL, NULL, 'H', 'H', '1761-11-02', 'Batavia', '1762-01-07', '1762-03-02', true, '21762-06-26', 'Texel', 3759, 'to the NIEUW NIEUWERKERK, sailing to Batavia in 1761/2 (3815).');
INSERT INTO "voyages" VALUES (7613, '', 3, '', 'SCHAGEN', 'Klaas Ariensz.', 880, NULL, '1753', NULL, NULL, 'H', 'H', '1761-11-02', 'Batavia', '1762-01-07', '1762-02-01', true, '1762-06-02', 'Texel', 3809, 'Crew at the Cape: 105.');
INSERT INTO "voyages" VALUES (7614, '', 3, '', 'SNOEK', 'Willem Klump', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1761-11-02', 'Batavia', '1762-01-07', '1762-03-02', true, '1762-06-24', 'Rammekens', 3780, 'Crew at the Cape: 106.');
INSERT INTO "voyages" VALUES (7615, '', 4, '', 'STRALEN', 'Adriaan Arkebout', 850, NULL, '1748', NULL, NULL, 'E', 'E', '1761-11-02', 'Batavia', '1762-01-07', '1762-02-01', true, '1762-06-02', 'Texel', 3804, 'Cape: 97');
INSERT INTO "voyages" VALUES (7616, '', 3, '', 'TORENVLIET', 'Huibert van der Kneu', 1150, NULL, '1750', NULL, NULL, 'Z', 'Z', '1761-11-02', 'Batavia', '1762-01-06', '1762-02-01', true, '1762-07-01', 'Rammekens', 3783, 'Crew at the Cape: 117. After the arrival of the ship at patria its name was altered into BARBARA THEODORA (3863/7704, etc.).');
INSERT INTO "voyages" VALUES (7617, '', 1, '', 'ZUID-BEVELAND', 'Pieter Matthijs Joele', 1100, NULL, '1755', NULL, NULL, 'Z', 'Z', '1761-11-02', 'Batavia', '1762-01-07', '1762-03-02', true, '1762-06-24', 'Rammekens', 3712, 'Crew at the Cape: 113.');
INSERT INTO "voyages" VALUES (7618, '', 3, '', 'KEUKENHOF', 'Jan van Dalen', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1761-11-16', 'Ceylon', '1762-02-26', '1762-04-01', true, '1762-07-18', 'Texel', 3766, 'Crew at the Cape:121.');
INSERT INTO "voyages" VALUES (7619, '', 1, '', 'DAMZICHT', 'Kornelis Stuurmans', 1150, NULL, '1759', NULL, NULL, 'A', 'Z', '1762-01-07', 'China', '1762-04-08', '1762-04-26', true, '1762-07-20', 'Rammekens', 3797, 'Crew at the Cape: 128.');
INSERT INTO "voyages" VALUES (7620, '', 1, '', 'JONGE LIEVE', 'Kornelis Kuiper', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1762-01-07', 'China', '1762-04-05', '1762-04-24', true, '1762-07-26', 'Texel', 3801, 'Crew at the Cape: 121.');
INSERT INTO "voyages" VALUES (7621, '', 2, '', '''S GRAVENZANDE', 'Bartholomeus Schut', 880, NULL, '1754', NULL, NULL, 'D', 'A', '1762-01-19', 'Bengal', '1762-04-02', '1762-04-16', true, '1762-07-16', 'Texel', NULL, 'Crew at the Cape: 100.');
INSERT INTO "voyages" VALUES (7622, '', 3, '', 'KATTENDIJKE', 'Simon Rood', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1762-01-19', 'Bengal', '1762-04-05', '1762-04-26', true, '1762-07-20', 'Rammekens', 3752, 'Crew at the Cape: 112.');
INSERT INTO "voyages" VALUES (7623, '', 5, '', 'WILDRIJK', 'Jan Moorland', 850, NULL, '1744', NULL, NULL, 'A', 'A', '1762-01-19', 'Bengal', '1762-04-05', '1762-05-16', true, '1762-07-16', 'Texel', 3790, 'Crew at the Cape: 115.');
INSERT INTO "voyages" VALUES (7624, '', 4, '', 'BOSSCHENHOVE', 'Jan van der Zee', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1762-02-01', 'Batavia', '1762-05-17', '1762-06-16', true, '1762-09-29', 'Texel', 3781, 'The six passengers included one condemned person. The BOSSCHENHOVE did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7625, '', 4, '', 'LUXEMBURG', 'Christiaan Blom', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1762-02-01', 'Batavia', '1762-05-12', '1762-06-01', true, '1762-09-13', 'Texel', 3788, 'The four passengers included one condemned person. The LUXEMBURG did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7626, '', 3, '', 'RUITEVELD', 'Pieter Boot', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1762-02-02', 'Ceylon', '1762-04-06', '1762-04-24', true, '1762-07-25', 'Texel', 3754, 'Crew at the Cape: 132.');
INSERT INTO "voyages" VALUES (7627, '', 3, '', 'VLIETLUST', 'Jakob Boekhout', 1150, NULL, '1752', NULL, NULL, 'A', 'Z', '1762-02-02', 'Ceylon', '1762-04-10', '1762-04-24', true, '1762-07-24', 'Rammekens', 3791, 'Crew at the Cape: 136.');
INSERT INTO "voyages" VALUES (7628, '', 1, '', 'DUINENBURG', 'Michiel Godfried Lehman', 1100, NULL, '1757', NULL, NULL, 'Z', 'Z', '1762-02-06', 'Batavia', '1762-05-03', '1762-05-13', true, '1762-08-27', 'Rammekens', 3767, NULL);
INSERT INTO "voyages" VALUES (7629, '', 1, '', 'SCHOONZICHT', 'Kornelis Pietersen', 880, NULL, '1758', NULL, NULL, 'R', 'A', '1762-05-05', 'Batavia', NULL, NULL, false, '1762-11-04', 'Texel', 3789, NULL);
INSERT INTO "voyages" VALUES (7630, '', 6, '', 'IMMAGONDA', 'Johannes van Boom', 850, NULL, '1746', NULL, NULL, 'E', 'E', '1762-10-20', 'Batavia', '1762-12-31', '1763-01-14', true, '1763-04-18', 'Texel', 3827, NULL);
INSERT INTO "voyages" VALUES (7631, '', 2, '', 'VROUWE ELIZABETH', 'Arend van der Deuren', 850, NULL, '1755', NULL, NULL, 'R', 'R', '1762-11-05', 'Batavia', '1763-01-21', '1763-02-02', true, '1763-05-13', 'Goeree', 3812, 'Commandeur of the return fleet was Willem van Braam, master of the OUDKARSPEL (see 7635).');
INSERT INTO "voyages" VALUES (7632, '', 7, '', 'HOOP', 'Anthonie Leertouwer', 850, NULL, '1742', NULL, NULL, 'D', 'D', '1762-11-05', 'Batavia', '1763-01-21', '1763-02-02', true, '1763-05-13', 'Goeree', 3805, 'Crew at the Cape: 117.');
INSERT INTO "voyages" VALUES (7633, '', 4, '', 'LIEFDE', 'Hendrik Andries Tieding', 1150, NULL, '1748', NULL, NULL, 'A', 'A', '1762-11-05', 'Batavia', '1763-01-16', '1763-02-02', true, '1763-05-16', 'Texel', 3829, 'The ten passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7634, '', 4, '', 'LYCOCHTON', 'Klaas Stuiver', 880, NULL, '1749', NULL, NULL, 'E', 'H', '1762-11-05', 'Batavia', '1763-01-15', '1763-02-02', true, '1763-05-16', 'Texel', 3830, 'passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7635, '', 4, '', 'OUDKARSPEL', 'Willem van Braam', 1150, NULL, '1747', NULL, NULL, 'A', 'A', '1762-11-05', 'Batavia', '1763-01-15', '1763-02-02', true, '1763-05-16', 'Texel', 3823, 'The master of the OUDKARSPEL, Willem van Braam, was commandeur of the return fleet. The nine passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7636, '', 5, '', 'VOSMAAR', 'Laurens Houtepen', 850, NULL, '1746', NULL, NULL, 'Z', 'Z', '1762-11-05', 'Batavia', '1763-01-25', '1763-03-05', true, '1763-06-27', 'Rammekens', 3807, 'The seven passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7637, '', 3, '', 'WALCHEREN', 'Hans Kornelisz.', 1150, NULL, '1754', NULL, NULL, 'Z', 'Z', '1762-11-05', 'Batavia', '1763-01-16', '1763-02-02', true, '1763-05-13', 'Rammekens', 3834, 'The nine passengers included two condemned persons.');
INSERT INTO "voyages" VALUES (7638, '', 4, '', 'AMERONGEN', 'Jan Spek', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1762-11-22', 'Ceylon', '1763-02-19', '1763-03-05', true, '1763-06-27', 'Texel', 3796, 'which during its first two voyages was called ROZENBURG (3642/7477) and during its third voyage OVERNES (3700/7544). See also 3901/-.');
INSERT INTO "voyages" VALUES (7639, '', 1, '', 'ASCHAT', 'Kornelis Nannings', 1150, NULL, '1760', NULL, NULL, 'A', 'A', '1763-01-04', 'China', '1763-03-27', '1763-04-07', true, '1763-07-03', 'Texel', 3825, 'Crew at the Cape: 107.');
INSERT INTO "voyages" VALUES (7640, '', 3, '', 'VROUWE PETRONELLA MARIA', 'Jan van Eysden', 1100, NULL, '1755', NULL, NULL, 'A', 'A', '1763-01-04', 'China', '1763-03-27', '1763-04-07', true, '1763-07-03', 'Texel', 3832, 'Crew at the Cape: 107.');
INSERT INTO "voyages" VALUES (7641, '', 3, '', 'ADMIRAAL DE RUYTER', 'Hendrik Hilverduin', 1150, NULL, '1749', NULL, NULL, 'A', 'Z', '1763-01-04', 'China', '1763-05-24', '1763-06-16', true, '1763-09-18', 'Rammekens', 3833, 'The ADMIRAAL DE RUYTER did not call at the Cape but at False Bay. Crew at False Bay: 110.');
INSERT INTO "voyages" VALUES (7642, '', 3, '', 'SCHOLTENBURG', 'Leendert van der Linden', 880, NULL, '1753', NULL, NULL, 'A', 'A', '1763-01-19', 'Bengal', '1763-04-24', '1763-05-10', true, '1763-07-31', 'Texel', 3808, 'The SCHOLTENBURG did not succeed in obtaining a cargo at Bengal. Crew at the Cape: 103.');
INSERT INTO "voyages" VALUES (7643, '', 3, '', 'VISVLIET', NULL, 880, NULL, '1752', NULL, NULL, 'Z', 'Z', '1763-01-19', 'Bengal', NULL, NULL, true, NULL, NULL, 3816, 'The VISVLIET was lost between Bengal and the Cape.');
INSERT INTO "voyages" VALUES (7644, '', 4, '', 'NIEUW NIEUWERKERK', 'Adriaan van den Boer', 1150, NULL, '1749', NULL, NULL, 'Z', 'Z', '1763-01-20', 'Batavia', '1763-06-08', '1763-07-05', true, '1763-10-14', 'Rammekens', 3815, 'Crew at the Cape: 122.');
INSERT INTO "voyages" VALUES (7645, '', 3, '', 'VELSEN', 'Laurens Helmstrom', 1100, NULL, '1756', NULL, NULL, 'A', 'A', '1763-01-20', 'Batavia', '1763-05-04', '1763-05-19', true, '1763-08-22', 'Texel', 3836, 'Crew at the Cape: 126.');
INSERT INTO "voyages" VALUES (7646, '', 3, '', 'VOORLAND', 'Josua Hartman', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1763-02-02', 'Ceylon', '1763-04-20', '1763-05-10', true, '1763-08-17', 'Texel', 3814, 'Crew at the Cape: 122.');
INSERT INTO "voyages" VALUES (7647, '', 2, '', 'NOORD-BEVELAND', 'Jakob Reysik', 1150, NULL, '1756', NULL, NULL, 'Z', 'Z', '1763-02-22', 'Ceylon', '1763-05-19', '1763-07-05', true, '1763-10-13', 'Rammekens', 3794, 'The NOORD-BEVELAND did not call at the Cape but at False Bay. Crew at False Bay: 106.');
INSERT INTO "voyages" VALUES (7648, '', 1, '', 'BRONSTEE', NULL, 600, NULL, '1755', NULL, NULL, 'A', 'E', '1763-05-10', 'Batavia', NULL, NULL, true, NULL, NULL, 3687, 'Lost between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7649, '', 5, '', 'BAARZANDE', 'Pieter de Leur', 850, NULL, '1745', NULL, NULL, 'H', 'E', '1763-10-21', 'Batavia', '1763-12-25', '1764-01-11', true, '1764-04-15', 'Texel', 3851, 'Crew at the Cape: 112. 3851/7649 was the fifth voyage of this ship, which during its first two voyages and the outward part of the third voyage was called JAGER (3612/7453).');
INSERT INTO "voyages" VALUES (7650, '', 2, '', 'BLEISWIJK', 'Bartholomeus Bigom', 880, NULL, '1756', NULL, NULL, 'D', 'D', '1763-10-31', 'Batavia', '1764-01-10', '1764-02-02', true, '1764-05-11', 'Goeree', 3835, 'The five passengers included two condemned persons. Commandeur of the return fleet is Willem Everdingen van der Nieuwpoort, master of the VROUWE GEERTRUIDA (7651).');
INSERT INTO "voyages" VALUES (7651, '', 2, '', 'VROUWE GEERTRUIDA', 'Willem Everdingen van der Nieuwpoort', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1763-11-02', 'Batavia', '1764-01-04', '1764-02-02', true, '1764-05-11', 'Texel', 3821, 'The master of the VROUWE GEERTRUIDA, Willem Everdingen van der Nieuwpoort, was Commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7652, '', 5, '', 'NOORD NIEUWLAND', 'Kornelis Pietersen', 880, NULL, '1749', NULL, NULL, 'R', 'Z', '1763-11-02', 'Batavia', '1764-01-11', '1764-03-03', true, '1764-06-10', 'Rammekens', 3840, 'One source mentions Gerrit Reynders as master of the NOORD NIEUWLAND.');
INSERT INTO "voyages" VALUES (7653, '', 2, '', 'OUDERAMSTEL', 'Simon Bot', 1100, NULL, '1758', NULL, NULL, 'A', 'A', '1763-11-02', 'Batavia', '1764-01-11', '1764-02-02', true, '1764-05-11', 'Texel', 3822, NULL);
INSERT INTO "voyages" VALUES (7654, '', 1, '', 'BURCH', 'Dirk Wagtels', 1150, NULL, '1760', NULL, NULL, 'Z', 'Z', '1763-01-04', 'Batavia', '1764-01-11', '1764-02-02', true, '1764-05-11', 'Rammekens', 3820, NULL);
INSERT INTO "voyages" VALUES (7655, '', 3, '', 'BLIJDORP', 'Pieter Broman', 880, NULL, '1754', NULL, NULL, 'R', 'R', '1763-11-06', 'Batavia', '1764-01-12', '1764-02-02', true, '1764-05-11', 'Goeree', 3826, 'Crew at the Cape: 117.');
INSERT INTO "voyages" VALUES (7656, '', 4, '', 'OOSTHUIZEN', 'Johan Muller', 850, NULL, '1749', NULL, NULL, 'H', 'H', '1763-11-06', 'Batavia', '1764-01-11', '1764-02-02', true, '1764-05-11', 'Texel', 3841, 'The seven passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7657, '', 3, '', 'WELGELEGEN', 'Jurriaan Molensteen', 880, NULL, '1753', NULL, NULL, 'E', 'A', '1763-11-12', 'Bengal', '1764-02-14', '1764-03-03', true, '1764-06-10', 'Texel', 3837, 'Crew at the Cape: 101');
INSERT INTO "voyages" VALUES (7658, '', 2, '', 'OVERNES', 'Jan Holst', 1150, NULL, '1754', NULL, NULL, 'A', 'A', '1763-11-21', 'Ceylon', '1764-02-03', '1764-03-03', true, '1764-06-10', 'Texel', 3810, 'Crew at the Cape: 135. 3810/7658 was the second voyage of this ship, which during its preceding voyage was called AMERONGEN (3664/7556).');
INSERT INTO "voyages" VALUES (7659, '', 1, '', 'HUIS TE BIJWEG', 'Dirk van Maastricht', 1100, NULL, '1760', NULL, NULL, 'A', 'A', '1763-12-31', 'China', '1764-04-25', '1764-07-06', true, '1764-10-15', 'Texel', 3844, 'The HUIS TE BIJWEG did not call at the Cape but at False Bay.');
INSERT INTO "voyages" VALUES (7660, '', 6, '', 'SLOTEN', 'Christiaan Hagerop', 1150, NULL, '1746', NULL, NULL, 'A', 'A', '1763-12-31', 'China', '1764-04-17', '1764-04-29', true, '1764-07-27', 'Texel', 3845, 'Crew at the Cape: 116.');
INSERT INTO "voyages" VALUES (7661, '', 1, '', 'WESTERVELD', 'Hans Bruns', 1100, NULL, '1761', NULL, NULL, 'A', 'Z', '1763-12-31', 'China', '1764-04-17', '1764-04-29', true, '1764-07-27', 'Rammekens', 3850, 'at the Cape: 116.');
INSERT INTO "voyages" VALUES (7662, '', 3, '', 'VLISSINGEN', 'Johan Sigismund Hoeve', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1764-01-18', 'Bengal', '1764-04-16', '1764-04-29', true, '1764-07-27', 'Rammekens', 3843, 'One source mentions Pieter Visser as master of the VLISSINGEN. Crew at the Cape: 112');
INSERT INTO "voyages" VALUES (7663, '', 3, '', 'RADERMACHER', 'Jan de la Nooye', 1150, NULL, '1753', NULL, NULL, 'Z', 'Z', '1764-01-25', 'Batavia', NULL, NULL, true, NULL, NULL, 3856, 'Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7664, '', 2, '', 'SLOTERKIJK', 'Jan Stewer', 1150, NULL, '1754', NULL, NULL, 'A', 'A', '1764-01-25', 'Batavia', NULL, NULL, true, NULL, NULL, 3811, 'Lost between Batavia and the Cape. 3811/7664 was the second voyage of this ship, which during its preceding voyage was called VROUWE REBECCA JACOBA (3668/7568).');
INSERT INTO "voyages" VALUES (7665, '', 3, '', 'DE DRIE PAPEGAAIEN', 'Volkert Groeneweg van Oudshoorn', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1764-02-07', 'Ceylon', '1764-04-16', '1764-04-29', true, '1764-07-27', 'Texel', 3854, 'Crew at the Cape: 123.');
INSERT INTO "voyages" VALUES (7666, '', 4, '', 'VRIJBURG', 'Jakob Wiebe', 1150, NULL, '1748', NULL, NULL, 'Z', 'Z', '1764-02-07', 'Ceylon', '1764-04-16', '1764-04-29', true, '1764-07-27', 'Rammekens', 3849, 'Crew at the Cape: 121.');
INSERT INTO "voyages" VALUES (7667, '', 1, '', 'DOROTHEA', 'Marten Pietersz. Mooy', 600, NULL, '1745', NULL, NULL, 'A', 'H', '1764-05-10', 'Batavia', NULL, NULL, false, '1764-10-18', 'Texel', 3744, NULL);
INSERT INTO "voyages" VALUES (7668, '', 3, '', 'VROUWE PETRONELLA', 'Arie Arkebout', 880, NULL, '1755', NULL, NULL, 'E', 'E', '1764-10-22', 'Batavia', '1764-12-24', '1765-01-11', true, '1765-04-11', 'Texel', 3865, NULL);
INSERT INTO "voyages" VALUES (7669, '', 1, '', 'BORSSELE', 'Abraham in ''t Anker', 1150, NULL, '1758', NULL, NULL, 'Z', 'A', '1764-11-02', 'Batavia', '1765-01-08', '1765-02-11', true, '1765-06-03', 'Texel', 3793, 'Aboard the BORSSELE was Liebrecht Horeman, admiraal of the return fleet; the commandeur, Hendrik Booms, aboard the DUINENBURG (7671).');
INSERT INTO "voyages" VALUES (7670, '', 6, '', 'HUIS TEN DONK', 'Frederik Wielard', 875, NULL, '1745', NULL, NULL, 'R', 'D', '1764-11-02', 'Batavia', '1765-01-21', '1765-02-11', true, '1765-06-12', 'Goeree', NULL, ';868 Crew at the Cape: 112');
INSERT INTO "voyages" VALUES (7671, '', 2, '', 'DUINENBURG', 'Michiel Godfried Lehman', 1100, NULL, '1757', NULL, NULL, 'Z', 'Z', '1764-11-02', 'Batavia', '1765-01-21', '1765-02-11', true, '1765-06-12', 'Rammekens', 3871, 'Aboard the DUINENBURG was Hendrik Booms, commandeur of the return fleet. The 12 passengers included six slaves (of whom one female).');
INSERT INTO "voyages" VALUES (7672, '', 5, '', 'GOUVERNEUR-GENERAAL', 'Gerrit Harmeyer', 850, NULL, '1749', NULL, NULL, 'D', 'A', '1764-11-02', 'Batavia', '1765-02-04', '1765-03-02', true, '1765-06-15', 'Texel', 3872, 'The passenger was a condemned person.');
INSERT INTO "voyages" VALUES (7673, '', 2, '', 'JONGE LIEVE', 'Edmond Collier', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1764-11-02', 'Batavia', '1765-02-04', '1765-03-02', true, '1765-06-15', 'Texel', 3857, 'The seven passengers included one slave.');
INSERT INTO "voyages" VALUES (7674, '', 4, '', 'SNOEK', 'Jonas Hendriksz.', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1764-11-02', 'Batavia', '1765-01-24', '1765-02-11', true, '1765-06-12', 'Rammekens', 3891, NULL);
INSERT INTO "voyages" VALUES (7675, '', 4, '', 'ERFPRINS', 'Pieter Schoneman', 850, NULL, '1752', NULL, NULL, 'D', 'D', '1764-01-03', 'Batavia', '1765-01-27', '1765-03-02', true, '1765-06-15', 'Goeree', 3859, '3859/7675 was the fourth voyage of this ship, which during its first two voyages was called DELFT (3696/7518).');
INSERT INTO "voyages" VALUES (7676, '', 4, '', 'VREDESTEIN', 'Jochem Hendrik Dodendorp', 880, NULL, '1750', NULL, NULL, 'R', 'R', '1764-11-10', 'Batavia', '1765-01-21', '1765-02-11', true, '1765-06-12', 'Goeree', 3855, 'The six passengers included one slave.');
INSERT INTO "voyages" VALUES (7677, '', 2, '', 'LEKKERLUST', 'Adriaan de Graaff', 880, NULL, '1755', NULL, NULL, 'H', 'H', '1764-11-11', 'Batavia', '1765-01-21', '1765-03-02', true, '1765-06-15', 'Texel', 3853, 'Crew at the Cape: 110.');
INSERT INTO "voyages" VALUES (7678, '', 3, '', 'HUIS TE BOEDE', 'Simon de Graaf', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1764-01-16', 'Bengal', '1765-02-04', '1765-03-02', true, '1765-06-13', 'Rammekens', 3817, 'Crew at the Cape: 101.');
INSERT INTO "voyages" VALUES (7679, '', 3, '', 'ORANJEZAAL', 'Hendrik Worms', 880, NULL, '1750', NULL, NULL, 'E', 'A', '1764-11-16', 'Bengal', '1765-02-01', '1765-03-02', true, '1765-06-15', 'Texel', 3862, 'Crew at the Cape: 100.');
INSERT INTO "voyages" VALUES (7680, '', 5, '', 'KIEVITSHEUVEL', 'Frederik Kelger', 1150, NULL, '1749', NULL, NULL, 'A', 'A', '1764-11-19', 'Ceylon', '1765-01-15', '1765-02-11', true, '1765-06-03', 'Texel', 3846, 'Crew at the Cape: 128.');
INSERT INTO "voyages" VALUES (7681, '', 2, '', 'ASCHAT', 'Kornelis Kuiper', 1150, NULL, '1760', NULL, NULL, 'A', 'A', '1765-01-09', 'China', '1765-04-18', '1765-04-27', true, '1765-08-06', 'Texel', 3876, 'Crew at the Cape: 107.');
INSERT INTO "voyages" VALUES (7682, '', 1, '', 'HUIS OM', 'Kornelis Pietersen', 1150, NULL, '1761', NULL, NULL, 'Z', 'A', '1765-01-09', 'China', '1765-05-01', '1765-05-23', true, '1765-09-15', 'Texel', 3878, 'The HUIS OM did not call at the Cape but at False Bay. Crew at False Bay: 106.');
INSERT INTO "voyages" VALUES (7683, '', 4, '', 'RUITEVELD', 'Isaak van den Berg', 1150, NULL, '1752', NULL, NULL, 'A', 'Z', '1765-01-09', 'China', '1765-04-22', '1765-05-09', true, '1765-08-14', 'Rammekens', 3882, 'Crew at the Cape: 107');
INSERT INTO "voyages" VALUES (7684, '', 1, '', '''S LANDS WELVAREN', 'Pieter Fruit', 880, NULL, '1762', NULL, NULL, 'A', 'D', '1765-01-09', 'China', '1765-04-09', '1765-04-21', true, '1765-07-25', 'Goeree', 3879, 'Crew at the Cape: 108.');
INSERT INTO "voyages" VALUES (7685, '', 1, '', 'VROUWE CORNELIA HILLEGONDA', 'Simon van Dalen', 850, NULL, '1760', NULL, NULL, 'D', 'R', '1765-01-17', 'Bengal', '1765-03-30', '1765-04-14', true, '1765-07-23', 'Goeree', 3818, 'Crew at the Cape: 105');
INSERT INTO "voyages" VALUES (7686, '', 5, '', 'STRALEN', 'Thomas van Wagtendonk', 850, NULL, '1748', NULL, NULL, 'E', 'H', '1765-01-17', 'Bengal', '1765-03-30', '1765-04-14', true, '1765-07-23', 'Texel', 3875, 'Crew at the Cape: 100.');
INSERT INTO "voyages" VALUES (7687, '', 6, '', 'VOSMAAR', 'Anthonie Leertouwer', 850, NULL, '1746', NULL, NULL, 'Z', 'Z', '1765-01-29', 'Batavia', '1765-04-25', '1765-05-10', true, '1765-08-27', 'Rammekens', 3895, 'Crew at the Cape: 113.');
INSERT INTO "voyages" VALUES (7688, '', 4, '', 'JERUSALEM', 'Thijs Fierman', 880, NULL, '1753', NULL, NULL, 'R', 'A', '1765-01-30', 'Batavia', '1765-04-30', '1765-05-17', true, '1765-08-31', 'Texel', 3852, 'The six passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7689, '', 5, '', 'EENDRACHT', 'Jan Schellinger', 1150, NULL, '1748', NULL, NULL, 'A', 'Z', '1765-02-01', 'Ceylon', '1765-04-25', '1765-05-10', true, '1765-08-30', 'Rammekens', 3861, 'Crew at the Cape: 143. 3861/7689 was the fifth. voyage of this ship, which during its first two voyages was called ELSWOUD (3503/7398).');
INSERT INTO "voyages" VALUES (7690, '', 5, '', 'LUXEMBURG', 'Jan Beys', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1765-02-01', 'Ceylon', '1765-04-06', '1765-04-21', true, '1765-07-07', 'Texel', 3885, 'Crew at the Cape: 142.');
INSERT INTO "voyages" VALUES (7691, '', 1, '', 'WESTFRIESLAND', 'Bernard Hulleman', 880, NULL, '1761', NULL, NULL, 'H', 'R', '1765-05-10', 'Batavia', NULL, NULL, false, '1765-12-08', 'Goeree', 3889, 'The four passengers included three condemned persons.');
INSERT INTO "voyages" VALUES (7692, '', 5, '', 'LYCOCHTON', 'Daniel Nieman', 880, NULL, '1749', NULL, NULL, 'E', 'H', '1765-10-22', 'Batavia', '1765-12-20', '1766-01-08', true, '1766-04-18', 'Texel', 3903, 'The four passengers included one condemned person. Crew at the Cape: 112.');
INSERT INTO "voyages" VALUES (7693, '', 6, '', 'BAARZANDE', 'Gerrit Bartels', 850, NULL, '1745', NULL, NULL, 'H', 'E', '1765-10-30', 'Batavia', '1765-12-29', '1766-02-03', true, '1766-05-18', 'Texel', 3910, 'JAGER (3612/7453).');
INSERT INTO "voyages" VALUES (7694, '', 3, '', 'VROUWE ELIZABETH', 'Pieter Breugel', 850, NULL, '1755', NULL, NULL, 'R', 'R', '1765-10-30', 'Batavia', '1766-01-07', '1766-02-03', true, '1766-05-19', 'Goeree', 3877, NULL);
INSERT INTO "voyages" VALUES (7695, '', 3, '', '''S GRAVENZANDE', 'Jan Moorland', 880, NULL, '1754', NULL, NULL, 'D', 'D', '1765-10-30', 'Batavia', '1765-12-29', '1766-02-03', true, '1766-05-17', 'Goeree', 3869, 'After the arrival of the ship at Goeree its name was altered into ERFPRINS (3985/7769, etc.).');
INSERT INTO "voyages" VALUES (7696, '', 4, '', 'KEUKENHOF', 'Jan van Dalen', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1765-10-30', 'Batavia', '1765-12-29', '1766-02-03', true, '1766-05-18', 'Texel', 3881, NULL);
INSERT INTO "voyages" VALUES (7697, '', 3, '', 'LAPIENENBURG', 'Markus Tetting', 1150, NULL, '1753', NULL, NULL, 'A', 'A', '1765-10-30', 'Batavia', '1765-12-30', '1766-02-03', true, '1766-05-18', 'Texel', 3870, 'The LAPIENENBURG was the commandeer-ship of the return fleet: master Markus Tetting was commandeer.');
INSERT INTO "voyages" VALUES (7698, '', 4, '', 'ADMIRAAL DE RUYTER', 'Nikolaas Herault', 1150, NULL, '1749', NULL, NULL, 'A', 'Z', '1765-10-30', 'Batavia', '1766-01-06', '1766-03-01', true, '1766-06-14', 'Rammekens', 3898, NULL);
INSERT INTO "voyages" VALUES (7699, '', 3, '', 'TULPENBURG', 'Pieter Clement', 1150, NULL, '1750', NULL, NULL, 'A', 'A', '1765-10-30', 'Batavia', '1765-12-27', '1766-03-01', true, '1766-06-15', 'Texel', 3848, NULL);
INSERT INTO "voyages" VALUES (7700, '', 2, '', 'ZUID-BEVELAND', 'Huibert van der Kneu', 1100, NULL, '1755', NULL, NULL, 'Z', 'Z', '1765-10-30', 'Batavia', '1766-01-06', '1766-02-03', true, '1766-05-18', 'Rammekens', 3873, NULL);
INSERT INTO "voyages" VALUES (7701, '', 4, '', 'KATTENDUKE', 'Jurriaan Molensteen', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1765-11-16', 'Bengal', '1766-02-06', '1766-03-01', true, '1766-06-14', 'Rammekens', 3896, 'Crew at the Cape: 99.');
INSERT INTO "voyages" VALUES (7702, '', 4, '', 'SCHOLTENBURG', 'George Jakob Meyer', 880, NULL, '1753', NULL, NULL, 'A', 'A', '1765-11-16', 'Bengal', '1766-02-06', '1766-03-01', true, '1766-06-15', 'Texel', 3899, 'Crew at the Cape: 104.');
INSERT INTO "voyages" VALUES (7703, '', 3, '', 'OVERNES', 'Kornelis Pietersen', 1150, NULL, '1754', NULL, NULL, 'A', 'A', '1765-11-18', 'Ceylon', '1766-02-10', '1766-03-01', true, '1766-06-15', 'Texel', 3922, 'Crew at the Cape: 143. 3922/7703 was the third voyage of this ship, which during its first voyage was called AMERONGEN (3664/7555).');
INSERT INTO "voyages" VALUES (7704, '', 4, '', 'BARBARA THEODORA', 'Aldert Aldertsz.', 1150, NULL, '1750', NULL, NULL, 'Z', 'Z', '1765-11-20', 'Ceylon', '1766-02-06', '1766-03-01', true, '1766-06-14', 'Rammekens', 3863, 'Crew at the Cape: 126. 3863/7704 was the fourth voyage of this ship, which during its three preceding voyages was called TORENVLIET (3783/7616).');
INSERT INTO "voyages" VALUES (7705, '', 4, '', 'BLUDORP', 'Marten Hakker', 880, NULL, '1754', NULL, NULL, 'R', 'Z', '1765-12-31', 'Batavia', '1766-03-26', '1766-04-16', true, '1766-07-15', 'Rammekens', 3928, 'slaves, (one male and one female).');
INSERT INTO "voyages" VALUES (7706, '', 2, '', 'SCHOONZICHT', 'Volkert Groeneweg van Oudshoom', 880, NULL, '1758', NULL, NULL, 'R', 'A', '1765-12-31', 'Batavia', '1766-03-27', '1766-04-16', true, '1766-07-15', 'Texel', 3887, 'The three passengers were condemned persons.');
INSERT INTO "voyages" VALUES (7707, '', 3, '', 'NOORD-BEVELAND', 'Simon Bot', 1150, NULL, '1756', NULL, NULL, 'Z', 'A', '1766-01-05', 'China', '1766-04-09', '1766-04-21', true, '1766-07-15', 'Texel', 3909, NULL);
INSERT INTO "voyages" VALUES (7708, '', 1, '', 'VREDENHOF', 'Willem van Braam', 1150, NULL, '1763', NULL, NULL, 'A', 'A', '1766-01-05', 'China', '1766-04-11', '1766-04-21', true, '1766-07-15', 'Texel', 3913, NULL);
INSERT INTO "voyages" VALUES (7709, '', 1, '', 'PALLAS', 'Jakob Boekhout', 1150, NULL, '1762', NULL, NULL, 'Z', 'Z', '1766-01-09', 'China', '1766-04-12', '1766-04-28', true, '1766-07-26', 'Rammekens', 3917, NULL);
INSERT INTO "voyages" VALUES (7710, '', 1, '', 'WALENBURG', 'Erasmus de Vries', 880, NULL, '1764', NULL, NULL, 'R', 'R', '1766-01-09', 'China', '1766-04-17', '1766-04-28', true, '1766-06-26', 'Goeree', 3916, NULL);
INSERT INTO "voyages" VALUES (7711, '', 3, '', 'BLEISWIJK', 'Klaas Stuiver', 880, NULL, '1756', NULL, NULL, 'D', 'D', '1766-01-17', 'Bengal', '1766-04-05', '1766-04-19', true, '1766-07-14', 'Texel', 3908, NULL);
INSERT INTO "voyages" VALUES (7712, '', 4, '', 'SCHAGEN', 'Klaas Ariensz.', 880, NULL, '1753', NULL, NULL, 'H', 'H', '1766-01-17', 'Bengal', '1766-04-19', '1766-05-04', true, '1766-08-04', 'Texel', 3874, NULL);
INSERT INTO "voyages" VALUES (7713, '', 2, '', 'DAMZICHT', 'Lodewijk Thomassen', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1766-02-02', 'Ceylon', '1766-04-12', '1766-04-28', true, '1766-07-27', 'Texel', 3858, NULL);
INSERT INTO "voyages" VALUES (7714, '', 2, '', 'LEIMUIDEN', 'Anthonie de long', 1150, NULL, '1755', NULL, NULL, 'A', 'A', '1766-02-02', 'Ceylon', '1766-04-19', '1766-05-04', true, '1766-08-04', 'Texel', 3839, NULL);
INSERT INTO "voyages" VALUES (7715, '', 2, '', 'NIJENBORG', 'Teunis van Brattem', 880, NULL, '1757', NULL, NULL, 'H', 'A', '1766-04-09', 'Batavia', NULL, NULL, false, '1766-10-20', 'Texel', 3864, NULL);
INSERT INTO "voyages" VALUES (7716, '', 1, '', 'ENKHUIZEN', 'Jakob de Vries', 880, NULL, '1760', NULL, NULL, 'E', 'E', '1766-10-26', 'Batavia', '1766-12-14', '1767-01-07', true, '1767-05-08', 'Texel', 3842, 'The ENKHUIZEN carried, among other things. tea with a value of f 277,778.');
INSERT INTO "voyages" VALUES (7717, '', 2, '', 'KRONENBURG', 'Jan Hendrik Vogelaar', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1766-11-07', 'Batavia', '1767-01-18', '1767-02-11', true, '1767-05-26', 'Texel', 3828, 'Aboard the KRONENBURG was Christiaan Blom, commandeer of the return fleet.');
INSERT INTO "voyages" VALUES (7718, '', 1, '', 'ZILVEREN LEEUW', 'Gerrit Harmeyer', 880, NULL, '1765', NULL, NULL, 'D', 'R', '1766-11-07', 'Batavia', '1767-01-18', '1767-02-11', true, '1767-05-24', 'Goeree', 3938, 'The 8 passengers included one female slave.');
INSERT INTO "voyages" VALUES (7719, '', 6, '', 'NOORD NIEUWLAND', 'Jakob ''t Hart', 880, NULL, '1749', NULL, NULL, 'R', 'H', '1766-11-07', 'Batavia', '1767-01-25', '1767-02-11', true, '1767-05-25', 'Texel', 3925, 'The 5 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7720, '', 4, '', 'VELSEN', 'Hendrik Andries Tieding', 1100, NULL, '1756', NULL, NULL, 'A', 'A', '1766-11-07', 'Batavia', '1767-01-12', '1767-03-02', true, '1767-06-20', 'Texel', 3888, NULL);
INSERT INTO "voyages" VALUES (7721, '', 1, '', 'VREEBURG', 'Frans van Ewijk', 850, NULL, '1764', NULL, NULL, 'D', 'D', '1766-11-07', 'Batavia', '1767-01-23', '1767-02-11', true, '1767-05-24', 'Goeree', 3924, 'The 5 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7722, '', 4, '', 'WALCHEREN', 'Gerrit de Waal', 1150, NULL, '1754', NULL, NULL, 'Z', 'Z', '1766-11-07', 'Batavia', '1767-01-14', '1767-02-11', true, '1767-05-24', 'Rammekens', 3893, NULL);
INSERT INTO "voyages" VALUES (7723, '', 2, '', 'HUIS OM', 'Michiel Wargijn', 1150, NULL, '1761', NULL, NULL, 'Z', 'A', '1766-11-16', 'Ceylon', '1767-02-15', '1767-03-02', true, '1767-06-20', 'Texel', 3948, NULL);
INSERT INTO "voyages" VALUES (7724, '', 4, '', 'ORANJEZAAL', 'Frederik Kelger', 880, NULL, '1750', NULL, NULL, 'E', 'A', '1766-11-16', 'Bengal', '1767-01-27', '1767-03-02', true, '1767-06-20', 'Texel', 3944, NULL);
INSERT INTO "voyages" VALUES (7725, '', 2, '', 'RENSWOUDE', 'Abraham van der Weiden', 1150, NULL, '1756', NULL, NULL, 'A', 'A', '1766-11-16', 'Ceylon', '1767-01-22', '1767-02-11', true, '1767-05-24', 'Texel', 3782, NULL);
INSERT INTO "voyages" VALUES (7726, '', 1, '', 'JONGE SAMUEL', 'Johannes van Boom', 880, NULL, '1761', NULL, NULL, 'Z', 'Z', '1766-11-16', 'Bengal', '1767-02-01', '1767-03-02', true, '1767-06-20', 'Rammekens', 3905, NULL);
INSERT INTO "voyages" VALUES (7727, '', 1, '', 'NIEUW RHOON', 'Abraham in ''t Anker', 1150, NULL, '1764', NULL, NULL, 'Z', 'Z', '1766-12-03', 'China', '1767-03-24', '1767-04-01', true, '1767-07-02', 'Rammekens', 3940, NULL);
INSERT INTO "voyages" VALUES (7728, '', 1, '', 'JONGE THOMAS', 'Jakob Wiebe', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1766-12-03', 'China', NULL, NULL, false, '1767-06-29', 'Texel', 3935, NULL);
INSERT INTO "voyages" VALUES (7729, '', 1, '', 'BARTHA PETRONELLA', 'Leendert van Koopstad', 880, NULL, '1764', NULL, NULL, 'H', 'H', '1767-01-02', 'China', NULL, NULL, false, '1767-07-27', 'Texel', 3933, NULL);
INSERT INTO "voyages" VALUES (7730, '', 3, '', 'JONGE LIEVE', 'Hendrik de Haard', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1767-01-02', 'China', '1767-04-02', '1767-04-09', true, '1767-07-10', 'Texel', 3939, NULL);
INSERT INTO "voyages" VALUES (7731, '', 2, '', '''S LANDS WELVAREN', NULL, 880, NULL, '1762', NULL, NULL, 'A', 'A', '1767-01-15', 'Batavia', NULL, NULL, false, '1767-07-28', 'Texel', 3956, 'One passenger was a condemned person.');
INSERT INTO "voyages" VALUES (7732, '', 1, '', 'JONKVROUWE KORNELIA JAKOBA', 'Pieter de Leur', 880, NULL, '1763', NULL, NULL, 'H', 'E', '1767-01-20', 'Bengal', NULL, NULL, false, '1767-07-01', 'Texel', 3931, NULL);
INSERT INTO "voyages" VALUES (7733, '', 5, '', 'VREDESTEIN', 'Jochem Hendrik Dodendorp', 880, NULL, '1750', NULL, NULL, 'R', 'R', '1767-01-20', 'Bengal', NULL, NULL, false, '1767-07-03', 'Goeree', 3943, NULL);
INSERT INTO "voyages" VALUES (7734, '', 6, '', 'GOUVERNEUR-GENERAAL', NULL, 850, NULL, '1749', NULL, NULL, 'D', 'Z', '1767-02-04', 'Ceylon', NULL, NULL, false, '1767-07-11', 'Rammekens', 3947, NULL);
INSERT INTO "voyages" VALUES (7735, '', 5, '', 'SNOEK', 'Johan Hendriksz.', 880, NULL, '1750', NULL, NULL, 'Z', 'Z', '1767-02-04', 'Ceylon', NULL, NULL, false, '1767-07-28', 'Rammekens', 3941, 'The passenger was a condemned person.');
INSERT INTO "voyages" VALUES (7736, '', 4, '', 'VLIETLUST', 'Laurens Houtepen', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1767-02-05', 'Ceylon', '1767-04-08', '1767-04-19', true, '1767-07-22', 'Texel', 3923, NULL);
INSERT INTO "voyages" VALUES (7737, '', 2, '', 'WESTERVELD', 'Lieve van Rentergem', 1100, NULL, '1761', NULL, NULL, 'A', 'A', '1767-02-05', 'Ceylon', NULL, NULL, false, '1767-07-24', 'Texel', 3918, NULL);
INSERT INTO "voyages" VALUES (7738, '', 2, '', 'VROUWE ELISABETH DOROTHEA', 'Willem Groeve', 600, NULL, '1757', NULL, NULL, 'A', 'A', '1767-05-16', 'Batavia', NULL, NULL, false, NULL, NULL, 3936, '(departure on 09-09). During the voyage 12 members of the crew died. In the night of 27/18-11-1767 the VROUWE ELISABETH DOROTHEA ran ashore between Petten and Callantsoog and was wrecked; only 6 persons were rescued. (see P. Dekker). See also the VREEBURG (4030).');
INSERT INTO "voyages" VALUES (7739, '', 2, '', 'WESTFRIESLAND', 'Kornelis Pietersen', 880, NULL, '1761', NULL, NULL, 'H', 'H', '1767-10-22', 'Batavia', '1767-12-21', '1768-01-12', true, '1768-04-15', 'Texel', 3973, 'The 6 passengers included 2 condemned persons.');
INSERT INTO "voyages" VALUES (7740, '', 2, '', 'HUIS TE BIJWEG', 'Arie Fransz.', 1100, NULL, '1760', NULL, NULL, 'A', 'A', '1767-11-06', 'Batavia', '1768-01-02', '1768-02-02', true, '1768-05-20', 'Texel', 3926, 'The 11 passengers included 2 slaves. Commandeer of the return fleet was Jan van Eysden, master of the DUINENBURG f 77/41).');
INSERT INTO "voyages" VALUES (7741, '', 4, '', 'DUINENBURG', 'Jan van Eysden', 1100, NULL, '1757', NULL, NULL, 'Z', 'Z', '1767-11-06', 'Batavia', '1768-01-06', '1768-02-02', true, '1768-05-19', 'Rammekens', 3950, 'van Eysden, was commandeer of the return fleet.');
INSERT INTO "voyages" VALUES (7742, '', 3, '', 'LEKKERLUST', 'Bernard Hulleman', 880, NULL, '1755', NULL, NULL, 'H', 'R', '1767-11-06', 'Batavia', '1768-01-02', '1768-02-02', true, '1768-05-18', 'Goeree', 3964, NULL);
INSERT INTO "voyages" VALUES (7743, '', 6, '', 'LYCOCHTON', 'Jan Balthus Meyer', 880, NULL, '1749', NULL, NULL, 'E', 'A', '1767-11-06', 'Batavia', '1768-01-02', '1768-02-02', true, '1768-05-19', 'Texel', 3977, 'The 10 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7744, '', 1, '', 'RITTHEM', 'Jacob de Frein', 880, NULL, '1764', NULL, NULL, 'Z', 'D', '1767-11-06', 'Batavia', '1768-01-24', '1768-03-05', true, '1768-06-10', 'Goeree', 3967, NULL);
INSERT INTO "voyages" VALUES (7745, '', 4, '', 'WELGELEGEN', 'Josua Hartman', 880, NULL, '1753', NULL, NULL, 'E', 'E', '1767-11-06', 'Batavia', '1768-01-19', '1768-03-05', true, '1768-06-11', 'Texel', 3914, NULL);
INSERT INTO "voyages" VALUES (7746, '', 1, '', 'COMPAGNIES WELVAREN', 'Arend Willemse', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1767-11-06', 'Batavia', '1768-01-03', '1768-02-02', true, '1768-05-30', 'Texel', 3915, NULL);
INSERT INTO "voyages" VALUES (7747, '', 1, '', 'OUDERAMSTEL', 'Marten Pietersz. Mooy', 1100, NULL, '1765', NULL, NULL, 'Z', 'A', '1767-11-11', 'Batavia', '1768-01-09', '1768-03-05', true, '1768-06-11', 'Texel', 3981, 'of this ship, which during the outward voyage was called AZIE');
INSERT INTO "voyages" VALUES (7748, '', 2, '', 'VROUWE KORNELIA HILLEGONDA', 'Kornelis van der Stam', 850, NULL, '1760', NULL, NULL, 'D', 'A', '1767-11-18', 'Bengal', '1768-01-30', '1768-03-05', true, '1768-06-11', 'Texel', 3954, NULL);
INSERT INTO "voyages" VALUES (7749, '', 3, '', 'VROUWE GEERTRUIDA', 'Michiel Hendrik Kerke', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1767-11-19', 'Ceylon', '1768-01-19', '1768-03-05', true, '1768-06-11', 'Texel', 3911, NULL);
INSERT INTO "voyages" VALUES (7750, '', 5, '', 'RUITEVELD', 'Frans Overzee', 1150, NULL, '1752', NULL, NULL, 'A', 'A', '1767-11-19', 'Ceylon', '1768-01-10', '1768-02-02', true, '1768-05-17', 'Texel', 3963, NULL);
INSERT INTO "voyages" VALUES (7751, '', 1, '', 'GANZENHOEF', 'Thijs Fierman', 880, NULL, '1765', NULL, NULL, 'A', 'A', '1767-11-23', 'China', '1768-02-16', '1768-03-05', true, '1768-06-16', 'Texel', 3969, NULL);
INSERT INTO "voyages" VALUES (7752, '', 2, '', 'PALLAS', 'Jakob Boekhout', 1150, NULL, '1762', NULL, NULL, 'Z', 'A', '1767-11-23', 'China', '1768-02-19', '1768-03-10', true, '1768-06-18', 'Texel', 3975, NULL);
INSERT INTO "voyages" VALUES (7753, '', 1, '', 'GEINWENS', 'Kornelis Kuiper', 1100, NULL, '1765', NULL, NULL, 'A', 'Z', '1768-01-03', 'China', NULL, NULL, false, '1768-07-02', 'Rammekens', 3966, NULL);
INSERT INTO "voyages" VALUES (7754, '', 1, '', 'VROUWE MARGARETHA MARIA', 'Arie Arkebout', 880, NULL, '1765', NULL, NULL, 'E', 'E', '1768-01-03', 'China', NULL, NULL, false, '1768-07-04', 'Texel', 3974, NULL);
INSERT INTO "voyages" VALUES (7755, '', 1, '', 'VROUWE ANTHOINETTA KOENRARDINA', 'Abraham van Leeuwen', 880, NULL, '1765', NULL, NULL, 'D', 'E', '1768-01-19', 'Bengal', NULL, NULL, false, '1768-07-07', 'Texel', 3968, NULL);
INSERT INTO "voyages" VALUES (7756, '', 3, '', 'AZIE', 'Michiel Godfried Lehman', 1100, NULL, '1758', NULL, NULL, 'A', 'A', '1768-01-19', 'Batavia', NULL, NULL, true, NULL, NULL, 3912, 'of irreparability. 3912/7756 was the third and last voyage of this ship, which during its first two voyages and the third outward voyage was called OUDERAMSTEL.');
INSERT INTO "voyages" VALUES (7757, '', 4, '', 'VROUWE ELISABETH', NULL, 850, NULL, '1755', NULL, NULL, 'R', 'D', '1768-01-19', 'Bengal', NULL, NULL, false, '1768-07-02', 'Goeree', 3971, NULL);
INSERT INTO "voyages" VALUES (7758, '', 2, '', 'BURCH', 'Barend Rust', 1150, NULL, '1760', NULL, NULL, 'Z', 'Z', '1768-01-25', 'Batavia', NULL, NULL, false, '1768-08-25', 'Rammekens', 3906, 'The 5 passengers included 2 condemned persons.');
INSERT INTO "voyages" VALUES (7759, '', 4, '', 'NOORD-BEVELAND', 'Michiel Hendrik Wunder', 1100, NULL, '1756', NULL, NULL, 'Z', 'Z', '1768-02-02', 'Ceylon', '1768-04-16', '1768-05-03', true, '1768-08-27', 'Rammekens', 3978, NULL);
INSERT INTO "voyages" VALUES (7760, '', 4, '', 'VROUWE PETRONELLA MARIA', 'Laurens Helmstrom', 1100, NULL, '1755', NULL, NULL, 'A', 'A', '1768-02-02', 'Ceylon', NULL, NULL, false, '1768-07-27', 'Texel', 3900, NULL);
INSERT INTO "voyages" VALUES (7761, '', 3, '', 'SCHOONZICHT', 'Albert Kikkert', 880, NULL, '1758', NULL, NULL, 'R', 'R', '1768-02-16', 'Ceylon', NULL, NULL, false, '1768-08-27', 'Goeree', 3980, NULL);
INSERT INTO "voyages" VALUES (7762, '', 4, '', 'BLEISWIJK', 'Hendrik Willemse', 880, NULL, '1756', NULL, NULL, 'D', 'A', '1768-05-16', 'Batavia', NULL, NULL, false, '1768-11-04', 'Texel', 3991, 'The 4 passengers were condemned persons.');
INSERT INTO "voyages" VALUES (7763, '', 5, '', 'JERUSALEM', 'Jan Karel Schacht', 880, NULL, '1753', NULL, NULL, 'R', 'R', '1768-10-22', 'Batavia', '1769-02-02', '1769-02-23', true, '1769-06-03', 'Goeree', 3962, 'laid up at Rotterdam on 08-10-1770.');
INSERT INTO "voyages" VALUES (7764, '', 2, '', 'BARTHA PETRONELLA', 'Kornelis Brouwer', 880, NULL, '1764', NULL, NULL, 'H', 'H', '1768-11-06', 'Batavia', '1769-02-07', '1769-03-01', true, '1769-06-02', 'Texel', 4010, 'The 3 passengers included one condemned person. Commandeur of the return fleet was Dirk Wagtels, master of the BORSSELE (7766).');
INSERT INTO "voyages" VALUES (7765, '', 5, '', 'BLIJDORP', 'Lodewijk Thomassen', 880, NULL, '1754', NULL, NULL, 'R', 'Z', '1768-11-06', 'Batavia', '1769-02-02', '1769-04-03', true, '1769-07-18', 'Rammekens', 3986, 'The 7 passengers included 3 slaves.');
INSERT INTO "voyages" VALUES (7766, '', 2, '', 'BORSSELE', 'Dirk Wagtels', 1150, NULL, '1758', NULL, NULL, 'Z', 'Z', '1768-11-06', 'Batavia', '1769-01-09', '1769-02-07', true, '1769-05-10', 'Rammekens', 3946, 'The master of the BORSSELE, Dirk Wagtels. was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7767, '', 1, '', 'BOVENKERKER POLDER', 'Frederik Kelger', 850, NULL, '1765', NULL, NULL, 'A', 'A', '1768-11-06', 'Batavia', '1769-01-17', '1769-02-07', true, '1769-05-11', 'Texel', 4005, NULL);
INSERT INTO "voyages" VALUES (7768, '', 1, '', 'DUIVENBRUG', 'Jakob de Vries', 850, NULL, '1766', NULL, NULL, 'E', 'E', '1768-11-06', 'Batavia', '1769-01-14', '1769-02-07', true, '1769-05-12', 'Texel', 4006, 'The 4 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7769, '', 4, '', 'ERFPRINS', 'Abel Barber', 880, NULL, '1754', NULL, NULL, 'D', 'D', '1768-11-06', 'Batavia', '1769-01-09', '1769-02-07', true, '1769-05-10', 'Goeree', 3985, 'The 6 passengers included one female slave and one condemned person. 3985/7769 was the fourth voyage of this ship, which during the preceding three voyages was called ''s-GRAVENZANDE (3869/7695).');
INSERT INTO "voyages" VALUES (7770, '', 1, '', 'LANDSKROON', 'Antonie Leertouwer', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1768-11-06', 'Batavia', '1769-02-02', '1769-04-03', true, '1769-07-17', 'Texel', 3921, 'The 9 passengers included 6 condemned persons.');
INSERT INTO "voyages" VALUES (7771, '', 1, '', 'RIDDERKERK', 'Marten Hakker', 850, NULL, '1766', NULL, NULL, 'R', 'A', '1768-11-06', 'Batavia', '1769-01-17', '1769-02-07', true, '1769-05-12', 'Texel', 4004, 'The 10 passengers included 6 condemned persons.');
INSERT INTO "voyages" VALUES (7772, '', 2, '', 'JONGE SAMUEL', 'Jakob ''t Hart', 880, NULL, '1761', NULL, NULL, 'Z', 'A', '1768-11-06', 'Batavia', '1769-01-18', '1769-02-07', true, '1769-05-11', 'Texel', 4015, 'The 7 passengers included 6 condemned persons.');
INSERT INTO "voyages" VALUES (7773, '', 1, '', 'VELDHOEN', 'Pieter Fruit', 1150, NULL, '1765', NULL, NULL, 'A', 'A', '1768-11-06', 'Batavia', '1769-01-31', '1769-03-01', true, '1769-06-02', 'Texel', 3957, 'The 11 passengers included 6 condemned persons.');
INSERT INTO "voyages" VALUES (7774, '', 2, '', 'WALENBURG', 'Steven Booms', 880, NULL, '1764', NULL, NULL, 'R', 'A', '1768-11-06', 'Batavia', '1769-02-02', '1769-04-03', true, '1769-07-18', 'Texel', 3990, 'The 7 passengers included 6 condemned persons.');
INSERT INTO "voyages" VALUES (7775, '', 4, '', 'KRONENBURG', 'Pieter Andriesz.', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1768-11-16', 'Ceylon', '1769-02-02', '1769-03-01', true, '1769-06-02', 'Texel', 4007, NULL);
INSERT INTO "voyages" VALUES (7776, '', 2, '', 'NIEUW RHOON', 'Jan Hendriksz.', 1150, NULL, '1764', NULL, NULL, 'Z', 'Z', '1768-11-22', 'Ceylon', '1769-02-07', '1769-03-01', true, '1769-06-02', 'Rammekens', 4013, NULL);
INSERT INTO "voyages" VALUES (7777, '', 5, '', 'SCHOLTENBURG', 'Pieter Clement', 880, NULL, '1753', NULL, NULL, 'A', 'A', '1768-11-25', 'Bengal', '1769-02-07', '1769-03-01', true, '1769-06-02', 'Texel', 3979, NULL);
INSERT INTO "voyages" VALUES (7778, '', 4, '', 'VLISSINGEN', 'Kornelis van Brattem', 880, NULL, '1753', NULL, NULL, 'Z', 'Z', '1768-11-25', 'Bengal', '1769-02-07', '1769-03-01', true, '1769-06-02', 'Rammekens', 3951, NULL);
INSERT INTO "voyages" VALUES (7779, '', 2, '', 'JONGE THOMAS', 'Wopke Popta', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1768-11-30', 'China', '1769-03-08', '1769-04-03', true, '1769-07-18', 'Texel', 3999, NULL);
INSERT INTO "voyages" VALUES (7780, '', 1, '', 'WOESTDUIN', 'Jan Och', 1150, NULL, '1767', NULL, NULL, 'A', 'Z', '1768-11-30', 'China', '1769-03-08', '1769-04-03', true, '1769-07-18', 'Rammekens', 4000, NULL);
INSERT INTO "voyages" VALUES (7781, '', 1, '', 'PAUW', 'Gerrit Harmeyer', 850, NULL, '1767', NULL, NULL, 'D', 'D', '1768-12-25', 'China', '1769-03-21', '1769-04-03', true, '1769-07-16', 'Goeree', 4003, NULL);
INSERT INTO "voyages" VALUES (7782, '', 1, '', 'WILLEM DE VIJFDE', 'Jan Canvas', 1150, NULL, '1765', NULL, NULL, 'Z', 'A', '1768-12-26', 'China', '1769-04-03', '1769-05-15', true, '1769-07-22', 'Texel', 3997, NULL);
INSERT INTO "voyages" VALUES (7783, '', 2, '', 'ZILVEREN LEEUW', 'Willem Koelbier', 880, NULL, '1765', NULL, NULL, 'D', 'D', '1769-01-13', 'Batavia', NULL, NULL, false, '1769-07-15', 'Goeree', 4016, NULL);
INSERT INTO "voyages" VALUES (7784, '', 3, '', 'NIJENBORG', NULL, 880, NULL, '1757', NULL, NULL, 'H', 'E', '1769-01-13', 'Batavia', NULL, NULL, true, NULL, NULL, 3993, 'The NIJENBORG was wrecked between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7785, '', 3, '', 'RENSWOUDE', 'Klaas Roem', 1150, NULL, '1756', NULL, NULL, 'A', 'A', '1769-01-13', 'Batavia', '1769-04-20', '1769-05-02', true, '1769-08-02', 'Texel', 4018, NULL);
INSERT INTO "voyages" VALUES (7786, '', 1, '', 'BLEIJENBURG', 'Andries Lint', 880, NULL, '1765', NULL, NULL, 'R', 'H', '1769-01-23', 'Bengal', '1769-04-16', '1769-05-02', true, '1769-08-02', 'Texel', 3955, NULL);
INSERT INTO "voyages" VALUES (7787, '', 1, '', 'IJSSELMONDE', 'Arend van der Deuren', 880, NULL, '1762', NULL, NULL, 'R', 'R', '1769-01-23', 'Bengal', '1769-04-16', '1769-05-02', true, '1769-07-31', 'Goeree', 3897, NULL);
INSERT INTO "voyages" VALUES (7788, '', 3, '', 'DAMZICHT', 'Hendrik Jakob Beeld', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1769-02-03', 'Ceylon', '1769-04-07', '1769-05-18', true, '1769-07-18', 'Texel', 3987, NULL);
INSERT INTO "voyages" VALUES (7789, '', 3, '', 'LEIMUIDEN', 'Thomas Brunel', 1150, NULL, '1755', NULL, NULL, 'A', 'A', '1769-02-03', 'Ceylon', '1769-04-20', '1769-05-08', true, '1769-08-18', 'Texel', 3992, NULL);
INSERT INTO "voyages" VALUES (7790, '', 1, '', 'RIJNSBURG', 'H. Huurman', 850, NULL, '1765', NULL, NULL, 'Z', 'A', '1769-05-21', 'Batavia', NULL, NULL, false, '1770-02-13', 'Texel', 4023, NULL);
INSERT INTO "voyages" VALUES (7791, '', 2, '', 'VREEBURG', 'Michiel Hamelo', 850, NULL, '1764', NULL, NULL, 'D', 'D', '1769-10-21', 'Batavia', '1770-01-13', '1770-01-27', true, '1770-05-07', 'Goeree', 4030, NULL);
INSERT INTO "voyages" VALUES (7792, '', 3, '', 'ASCHAT', 'Willem Silvester', 1150, NULL, '1760', NULL, NULL, 'A', 'A', '1769-10-23', 'Batavia', '1770-01-07', '1770-03-01', true, '1770-06-14', 'Texel', 3953, 'fleet was Jan van Dalen. master of the HUIS OM (7793).');
INSERT INTO "voyages" VALUES (7793, '', 3, '', 'HUIS OM', 'Jan van Dalen', 1150, NULL, '1761', NULL, NULL, 'Z', 'A', '1769-10-23', 'Batavia', '1770-01-13', '1770-02-04', true, '1770-05-08', 'Texel', 4001, 'The master of the HUIS OM, Jan van Dalen, was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7794, '', 1, '', 'POPKENSBURG', 'Jan Abel', 880, NULL, '1763', NULL, NULL, 'Z', 'Z', '1769-10-23', 'Batavia', '1770-02-03', '1770-03-01', true, '1770-06-13', 'Rammekens', 3934, NULL);
INSERT INTO "voyages" VALUES (7795, '', 2, '', 'COMPAGNIES WELVAREN', 'Jan Berghuis', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1769-10-23', 'Batavia', '1770-01-03', '1770-02-04', true, '1770-05-08', 'Texel', 4036, NULL);
INSERT INTO "voyages" VALUES (7796, '', 3, '', 'PALLAS', 'Willem van Braam', 1150, NULL, '1762', NULL, NULL, 'Z', 'A', '1769-10-25', 'Batavia', '1769-12-26', '1770-02-04', true, '1770-05-08', 'Texel', 4035, NULL);
INSERT INTO "voyages" VALUES (7797, '', 3, '', 'HUTS TE BIJWEG', 'Abraham in ''t Anker', 1100, NULL, '1760', NULL, NULL, 'A', 'A', '1769-10-28', 'Batavia', '1769-12-27', '1770-02-04', true, '1770-05-08', 'Texel', 4034, 'The 9 passengers included 3 slaves.');
INSERT INTO "voyages" VALUES (7798, '', 5, '', 'BARBARA THEODORA', 'Pieter ten Droge', 1150, NULL, '1750', NULL, NULL, 'Z', 'Z', '1769-11-01', 'Batavia', '1770-01-07', '1770-02-04', true, '1770-05-08', 'Rammekens', 4041, '4041/7798 was the fifth voyage of this ship, which during its first three voyages was called TORENVLIET (3783/7616).');
INSERT INTO "voyages" VALUES (7799, '', 5, '', 'SCHAGEN', 'Frederik Wielard', 880, NULL, '1753', NULL, NULL, 'H', 'H', '1769-11-02', 'Batavia', '1770-01-15', '1770-02-04', true, '1770-05-09', 'Texel', 3998, 'The 114 persons aboard the SCHAGEN included one passenger.');
INSERT INTO "voyages" VALUES (7800, '', 6, '', 'VREDESTEIN', 'Leendert van Koopstad', 880, NULL, '1750', NULL, NULL, 'R', 'R', '1769-11-03', 'Batavia', '1770-02-03', '1770-03-01', true, '1770-06-13', 'Goeree', 4019, NULL);
INSERT INTO "voyages" VALUES (7801, '', 4, '', 'VROUWE GEERTRUIDA', 'Jakob de Frein', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1769-11-17', 'Ceylon', '1770-02-06', '1770-03-01', true, '1770-06-14', 'Texel', 4038, NULL);
INSERT INTO "voyages" VALUES (7802, '', 1, '', 'OUD HAARLEM', 'Pieter Sijbrandsz. Flout', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1769-12-13', 'China', '1770-03-15', '1770-04-03', true, '1770-06-27', 'Texel', 4027, NULL);
INSERT INTO "voyages" VALUES (7803, '', 1, '', '''T LOO', 'Kornelis Pietersen', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1769-12-13', 'China', '1770-03-15', '1770-04-03', true, '1770-06-28', 'Texel', 4028, NULL);
INSERT INTO "voyages" VALUES (7804, '', 1, '', 'OOSTKAPELLE', 'Frederik Papegaai', 1150, NULL, '1767', NULL, NULL, 'Z', 'Z', '1769-12-13', 'China', '1770-03-18', '1770-04-03', true, '1770-06-27', 'Rammekens', 4025, NULL);
INSERT INTO "voyages" VALUES (7805, '', 1, '', 'TEMPEL', 'Wouter Macquelin', 850, NULL, '1767', NULL, NULL, 'R', 'R', '1769-12-13', 'China', '1770-03-15', '1770-04-03', true, '1770-06-27', 'Goeree', 4026, NULL);
INSERT INTO "voyages" VALUES (7806, '', 2, '', 'VROUWE MARGARETHA MARIA', 'Jakob de Bruin', 880, NULL, '1765', NULL, NULL, 'E', 'E', '1770-01-17', 'Batavia', '1770-05-06', '1770-05-13', true, '1770-08-21', 'Texel', 4043, NULL);
INSERT INTO "voyages" VALUES (7807, '', 1, '', 'VROUWE MARIA JAKOBA', 'Klaas Ariensz.', 880, NULL, '1765', NULL, NULL, 'H', 'H', '1770-01-17', 'Batavia', NULL, NULL, false, '1770-08-23', 'Texel', 3996, 'One of the 2 passengers was a condemned person.');
INSERT INTO "voyages" VALUES (7808, '', 5, '', 'VROUWE PETRONELLA MARIA', 'Thijs Fierman', 1150, NULL, '1755', NULL, NULL, 'A', 'A', '1770-01-17', 'Batavia', NULL, NULL, true, NULL, NULL, 4048, 'The VROUWE PETRONELLA MARIA was wrecked between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (7809, '', 1, '', 'VREDELUST', 'Jurriaan Verburg', 1150, NULL, '1765', NULL, NULL, 'A', 'A', '1770-01-17', 'Batavia', '1770-05-08', '1770-05-28', true, '1770-10-13', 'Texel', 3942, 'The 3 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7810, '', 2, '', 'ENKHUIZEN', 'Hoeve', 880, NULL, '1760', NULL, NULL, 'E', 'E', '1770-01-29', 'Bengal', NULL, NULL, true, NULL, NULL, 4020, 'The ENKHUIZEN was wrecked between Bengal and the Cape.');
INSERT INTO "voyages" VALUES (7811, '', 1, '', 'VAILLANT', 'Thomas van Wagtendonk', 880, NULL, '1764', NULL, NULL, 'E', 'H', '1770-01-29', 'Bengal', NULL, NULL, true, NULL, NULL, 3961, 'The VAILLANT was wrecked between Bengal and the Cape.');
INSERT INTO "voyages" VALUES (7812, '', 3, '', '''S LANDS WELVAREN', 'Simon Bot', 880, NULL, '1762', NULL, NULL, 'A', 'A', '1770-01-29', 'Bengal', '1770-05-05', '1770-05-13', true, '1770-08-21', 'Texel', 4009, NULL);
INSERT INTO "voyages" VALUES (7813, '', 5, '', 'VELSEN', 'Kornelis Bos', 1100, NULL, '1756', NULL, NULL, 'A', 'A', '1770-02-13', 'Ceylon', '1770-04-05', '1770-04-24', true, '1770-08-02', 'Texel', 4011, NULL);
INSERT INTO "voyages" VALUES (7814, '', 3, '', 'ZUID-BEVELAND', 'Anthonie de Jong', 1100, NULL, '1755', NULL, NULL, 'Z', 'Z', '1770-02-13', 'Ceylon', '1770-04-10', '1770-04-24', true, '1770-08-09', 'Rammekens', 4014, NULL);
INSERT INTO "voyages" VALUES (7815, '', 3, '', 'WESTFRIESLAND', 'Marten Pietersz. Mooy', 880, NULL, '1761', NULL, NULL, 'H', 'A', '1770-05-23', 'Batavia', NULL, NULL, false, '1771-04-21', 'Texel', 4050, NULL);
INSERT INTO "voyages" VALUES (7816, '', 3, '', 'VROUWE KORNELIA HILLEGONDA', 'Marten Laban', 850, NULL, '1760', NULL, NULL, 'D', 'E', '1770-10-22', 'Batavia', '1770-12-23', '1771-01-10', true, '1771-04-27', 'Texel', 4039, NULL);
INSERT INTO "voyages" VALUES (7817, '', 5, '', 'KRONENBURG', 'Frederik Kelger', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1770-10-24', 'Batavia', '1770-12-23', '1771-02-09', true, '1771-05-24', 'Texel', 4068, 'The master of the KRONENBURG, Frederik Kelger, was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7818, '', 3, '', 'NIEUW RHOON', 'Johan Hendriksz.', 1150, NULL, '1764', NULL, NULL, 'Z', 'A', '1770-10-24', 'Batavia', '1770-12-26', '1771-03-02', true, '1771-06-03', 'Texel', 3066, NULL);
INSERT INTO "voyages" VALUES (7819, '', 2, '', 'VROUWE ANTHOINETTA KOENRARDINA', 'Hendrik Hilverduin', 880, NULL, '1765', NULL, NULL, 'D', 'D', '1770-11-06', 'Batavia', '1770-12-22', '1771-02-09', true, '1771-05-24', 'Goeree', 4054, NULL);
INSERT INTO "voyages" VALUES (7820, '', 4, '', 'JONGE LIEVE', 'Hendrik de Haard', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1770-11-06', 'Batavia', '1771-01-01', '1771-03-02', true, '1771-06-20', 'Texel', 4008, NULL);
INSERT INTO "voyages" VALUES (7821, '', 1, '', 'HUIS TER MEYEN', 'Johan Splinter Stavorinus', 1150, NULL, '1767', NULL, NULL, 'A', 'A', '1770-11-06', 'Batavia', '1771-01-01', '1771-02-09', true, '1771-05-24', 'Texel', 4002, NULL);
INSERT INTO "voyages" VALUES (7822, '', 3, '', 'JONGE SAMUEL', 'Pieter Angelvorst', 880, NULL, '1761', NULL, NULL, 'Z', 'Z', '1770-11-06', 'Batavia', '1770-12-26', '1771-02-09', true, '1771-05-24', 'Rammekens', 4061, NULL);
INSERT INTO "voyages" VALUES (7823, '', 4, '', 'DUINENBURG', 'Jan Verheke', 1100, NULL, '1757', NULL, NULL, 'Z', 'Z', '1770-11-10', 'Batavia', '1771-01-31', '1771-03-02', true, '1771-06-21', 'Rammekens', 4045, NULL);
INSERT INTO "voyages" VALUES (7824, '', 4, '', 'RIDDERKERK', 'Pieter van Prooien', 850, NULL, '1766', NULL, NULL, 'R', 'H', '1770-11-10', 'Batavia', '1771-01-03', '1771-02-09', true, '1771-05-24', 'Texel', 4060, 'The 5 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7825, '', 5, '', 'VLISSINGEN', 'Jakob ''t Hart', 880, NULL, '1753', NULL, NULL, 'Z', 'R', '1770-11-10', 'Batavia', '1771-01-13', '1771-02-09', true, '1771-05-24', 'Goeree', 4073, NULL);
INSERT INTO "voyages" VALUES (7826, '', 2, '', 'WOESTDUIN', 'Michiel Godfried Lehman', 1150, NULL, '1767', NULL, NULL, 'A', 'A', '1770-11-10', 'Batavia', '1771-01-07', '1771-03-02', true, '1771-06-20', 'Texel', 4074, NULL);
INSERT INTO "voyages" VALUES (7827, '', 2, '', 'GEINWENS', 'Johan Nikolaas Herault', 1100, NULL, '1765', NULL, NULL, 'A', 'A', '1770-11-16', 'Ceylon', '1771-02-22', '1771-03-02', true, '1771-06-20', 'Texel', 4042, NULL);
INSERT INTO "voyages" VALUES (7828, '', 2, '', 'BOVENKERKER POLDER', 'Pieter Andriesz.', 850, NULL, '1765', NULL, NULL, 'A', 'A', '1770-12-05', 'Bengal', '1771-02-15', '1771-03-02', true, '1771-06-17', 'Texel', 4067, NULL);
INSERT INTO "voyages" VALUES (7829, '', 1, '', 'BOT', 'Jan Rondekrans', 1150, NULL, '1768', NULL, NULL, 'Z', 'A', '1770-12-17', 'China', '1771-03-10', '1771-03-27', true, '1771-07-07', 'Texel', 4055, NULL);
INSERT INTO "voyages" VALUES (7830, '', 1, '', 'JONGE HELLINGMAN', 'Jan Balthus Meyer', 850, NULL, '1767', NULL, NULL, 'H', 'H', '1770-12-17', 'China', '1771-03-11', '1771-03-27', true, '1771-07-07', 'Texel', 4063, NULL);
INSERT INTO "voyages" VALUES (7831, '', 1, '', 'PRINSES VAN ORANJE', 'Kornelis Kuiper', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1770-12-17', 'China', '1771-03-11', '1771-03-27', true, '1771-07-07', 'Texel', 4059, NULL);
INSERT INTO "voyages" VALUES (7832, '', 2, '', 'WILLEM DE VIJFDE', 'Frederik Visser', 1150, NULL, '1765', NULL, NULL, 'Z', 'Z', '1770-12-17', 'China', '1771-03-11', '1771-03-27', true, '1771-07-02', 'Rammekens', 4062, NULL);
INSERT INTO "voyages" VALUES (7833, '', 3, '', 'ZILVEREN LEEUW', 'Christiaan Andries Spin', 880, NULL, '1765', NULL, NULL, 'D', 'R', '1771-01-19', 'Batavia', '1771-04-02', '1771-04-30', true, '1771-08-09', 'Goeree', 4075, NULL);
INSERT INTO "voyages" VALUES (7834, '', 4, '', 'SCHOONZICHT', 'Marten Hakker', 880, NULL, '1758', NULL, NULL, 'R', 'A', '1771-01-19', 'Batavia', '1771-04-02', '1771-04-30', true, '1771-08-10', 'Texel', 4076, NULL);
INSERT INTO "voyages" VALUES (7835, '', 4, '', 'DAMZICHT', 'Arend Willemse', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1771-01-20', 'Batavia', '1771-04-02', '1771-04-30', true, NULL, NULL, 4079, 'One of the 2 passengers was a condemned person. At the Cape the DAMZICHT was declared unseaworthy; its cargo was transported to Amsterdam by the ZON (see 7841). The DAMZICHT was laid up at the Cape on 10-02-1772.');
INSERT INTO "voyages" VALUES (7836, '', 5, '', 'BLEISWIJK', 'Jan Moorland', 880, NULL, '1756', NULL, NULL, 'D', 'D', '1771-01-29', 'Bengal', '1771-04-09', '1771-04-30', true, '1771-08-09', 'Goeree', 4051, NULL);
INSERT INTO "voyages" VALUES (7837, '', 2, '', 'RITTHEM', 'Abraham van der Weide', 880, NULL, '1764', NULL, NULL, 'Z', 'Z', '1771-01-29', 'Bengal', '1771-04-08', '1771-04-30', true, '1771-08-10', 'Rammekens', 4033, NULL);
INSERT INTO "voyages" VALUES (7838, '', 4, '', 'RENSWOUDE', 'Hendrik Willemse', 1150, NULL, '1756', NULL, NULL, 'A', 'A', '1771-02-03', 'Ceylon', '1771-04-03', '1771-04-30', true, '1771-09-10', 'Rammekens', 4070, 'The men aboard the RENSWOUDE included one passenger');
INSERT INTO "voyages" VALUES (7839, '', 3, '', 'WESTERVELD', 'Michiel Hendrik Kerke', 1100, NULL, '1761', NULL, NULL, 'A', 'A', '1771-02-03', 'Ceylon', '1771-03-03', '1771-04-30', true, '1771-08-13', 'Texel', 4021, NULL);
INSERT INTO "voyages" VALUES (7840, '', 2, '', 'DUIVENBRUG', 'Steven Booms', 850, NULL, '1766', NULL, NULL, 'E', 'A', '1771-05-20', 'Batavia', '1771-08-20', '1771-09-19', true, '1772-06-07', 'Texel', 4081, 'illness. Koenraad Louwe succeeded him as master of the DUIVENBRUG.');
INSERT INTO "voyages" VALUES (7841, '', 1, '', 'ZON', 'Andries Hansen', 450, 'hoeker', '1768', NULL, NULL, 'A', 'A', '1771-06-12', 'The Cape', '1771-06-12', NULL, true, '1771-09-29', 'Texel', 4037, 'The ZON transported the cargo of the DAMZICHT, taken off the service at the Cape, April 1771 (see 7835); invoice value: f 189,914, destined for the chamber Amsterdam.');
INSERT INTO "voyages" VALUES (7842, '', 2, '', 'RIJNSBURG', 'Roelof Schot', 850, NULL, '1765', NULL, NULL, 'Z', 'A', '1771-07-02', 'Batavia', NULL, NULL, true, NULL, NULL, 4086, 'was bound for the Republic via China and Bengal; sailing to China, however, it was wrecked in 1772. See also the HERSTELDER (7877).');
INSERT INTO "voyages" VALUES (7843, '', 3, '', 'BARTHA PETRONELLA', 'Kornelis Brouwer', 880, NULL, '1764', NULL, NULL, 'H', 'A', '1771-10-09', 'Coromandel', '1772-01-27', '1772-03-14', true, '1772-06-09', 'Texel', 4078, NULL);
INSERT INTO "voyages" VALUES (7844, '', 4, '', 'PALLAS', 'Klaas Roem', 1150, NULL, '1762', NULL, NULL, 'Z', 'A', '1771-10-11', 'Ceylon', '1772-01-31', '1772-02-20', true, '1772-05-30', 'Texel', 4085, NULL);
INSERT INTO "voyages" VALUES (7845, '', 1, '', 'HOOLWERF', 'Gerrit van der Gracht', 850, NULL, '1769', NULL, NULL, 'H', 'D', '1771-10-22', 'Batavia', '1772-01-18', '1772-01-30', true, '1772-04-24', 'Goeree', 4093, 'slaves.');
INSERT INTO "voyages" VALUES (7846, '', 4, '', 'ASCHAT', 'Jan Abel', 1150, NULL, '1760', NULL, NULL, 'A', 'A', '1771-11-06', 'Batavia', '1772-01-28', '1772-03-14', true, '1772-06-09', 'Texel', 4096, 'sailing aboard the JONGE THOMAS (7854); Pieter Kornelisz. Hasselaar, aboard the AZIE (7847), was commandeer.');
INSERT INTO "voyages" VALUES (7847, '', 2, '', 'AZIE', 'Christiaan Blom', 1100, NULL, '1765', NULL, NULL, 'Z', 'A', '1771-11-06', 'Batavia', '1772-01-18', '1772-02-20', true, '1772-05-30', 'Texel', 4032, 'Kornelisz. Hasselaar, commandeer of the return fleet. 4032/7847 was the second voyage of this ship, which during its first outward voyage (3981) was called AZIE, and during the first return voyage (7747) and the second outward voyage (4032) OUDERAMSTEL; after June, 1769, the ship was renamed AZIE.');
INSERT INTO "voyages" VALUES (7848, '', 4, '', 'HUTS TE BIJWEG', 'Asmus Hendrik Sterrenberg', 1100, NULL, '1760', NULL, NULL, 'A', 'A', '1771-11-06', 'Batavia', '1772-01-28', '1772-02-20', true, '1772-05-30', 'Texel', 4097, 'The 6 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7849, '', 5, '', 'VROUWE ELISABETH', 'Pieter van der Weert', 850, NULL, '1755', NULL, NULL, 'R', 'R', '1771-11-06', 'Batavia', '1772-01-29', '1772-03-14', true, '1772-06-26', 'Goeree', 4057, 'The 5 passengers included 2 slaves (one male and one female).');
INSERT INTO "voyages" VALUES (7850, '', 5, '', 'VROUWE GEERTRUIDA', 'Overstraten', 1100, NULL, '1757', NULL, NULL, 'A', 'A', '1771-11-06', 'Batavia', '1772-01-18', '1772-02-20', true, '1772-05-30', 'Texel', 4090, 'The 12 passengers included 4 condemned persons and 2 female slaves.');
INSERT INTO "voyages" VALUES (7851, '', 2, '', 'LANDSKROON', 'Andries Lint', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1771-11-06', 'Batavia', '1772-02-09', '1772-04-06', true, '1772-07-19', 'Texel', 4080, NULL);
INSERT INTO "voyages" VALUES (7852, '', 4, '', 'HUIS OM', 'Michiel Hamelo', 1150, NULL, '1761', NULL, NULL, 'Z', 'Z', '1771-11-06', 'Batavia', '1772-01-29', '1772-03-14', true, '1772-06-10', 'Rammekens', 4084, 'The 8 passengers included 2 slaves (one male and one female).');
INSERT INTO "voyages" VALUES (7853, '', 1, '', 'OUWERKERK', 'Jakob de Frein', 1150, NULL, '1768', NULL, NULL, 'Z', 'Z', '1771-11-06', 'Batavia', '1772-01-28', '1772-02-20', true, '1772-06-03', 'Rammekens', 4095, NULL);
INSERT INTO "voyages" VALUES (7854, '', 3, '', 'JONGE THOMAS', 'Kornelis Pietersen', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1771-11-06', 'Batavia', '1772-01-18', '1772-03-14', true, '1772-06-09', 'Texel', 4071, 'Aboard the JONGE THOMAS was Johan Vos, admiraal of the return fleet.');
INSERT INTO "voyages" VALUES (7855, '', 3, '', 'VREEBURG', 'Jan Kaatman', 850, NULL, '1764', NULL, NULL, 'D', 'E', '1771-11-17', 'Batavia', '1772-02-01', '1772-03-14', true, '1772-06-09', 'Texel', 4102, 'The crew included 6 soldiers.');
INSERT INTO "voyages" VALUES (7856, '', 4, '', 'LANDS WELVAREN', 'Pieter Andriesz.', 880, NULL, '1762', NULL, NULL, 'A', 'A', '1771-11-21', 'Bengal', '1772-01-28', '1772-02-20', true, '1772-05-30', 'Texel', 4099, NULL);
INSERT INTO "voyages" VALUES (7857, '', 1, '', 'LAM', 'Harmeyer', 850, NULL, '1769', NULL, NULL, 'D', 'E', '1771-12-17', 'China', '1772-03-19', '1772-04-06', true, '1772-07-12', 'Texel', 4087, NULL);
INSERT INTO "voyages" VALUES (7858, '', 2, '', '''T LOO', 'Wopke Popta', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1771-12-17', 'China', '1772-03-19', '1772-04-06', true, '1772-07-12', 'Texel', 4094, NULL);
INSERT INTO "voyages" VALUES (7859, '', 2, '', 'OUD HAARLEM', 'Jan Och', 1150, NULL, '1768', NULL, NULL, 'A', 'Z', '1771-12-24', 'China', '1772-03-21', '1772-04-06', true, '1772-07-12', 'Rammekens', 4092, NULL);
INSERT INTO "voyages" VALUES (7860, '', 2, '', 'OOSTKAPELLE', 'Frederik Papegaai', 1150, NULL, '1767', NULL, NULL, 'Z', 'A', '1771-12-24', 'China', '1772-03-19', '1772-04-06', true, '1772-07-13', 'Texel', 4089, NULL);
INSERT INTO "voyages" VALUES (7861, '', 2, '', 'USSELMONDE', 'Frederik Donckquart', 880, NULL, '1762', NULL, NULL, 'R', 'H', '1772-01-22', 'Bengal', '1772-03-31', '1772-04-12', true, '1772-07-19', 'Texel', 4088, NULL);
INSERT INTO "voyages" VALUES (7862, '', 4, '', 'BORSSELE', 'Jan Siereveld', 1150, NULL, '1758', NULL, NULL, 'Z', 'Z', '1772-02-03', 'Ceylon', '1772-04-15', '1772-05-01', true, '1772-08-05', 'Rammekens', 4101, NULL);
INSERT INTO "voyages" VALUES (7863, '', 5, '', 'WELGELEGEN', 'Gerrit ten Sunder', 880, NULL, '1753', NULL, NULL, 'E', 'H', '1772-02-24', 'Batavia', '1772-12-24', '1773-01-16', true, '1773-04-22', 'Texel', 4049, 'The 7 passengers included 2 condemned persons. Serious damage forced the WELGELEGEN to call at Rio Delagoa. The ship was laid up at Hoorn on 09-10-1773.');
INSERT INTO "voyages" VALUES (7864, '', 2, '', 'BLEIJENBURG', 'Kornelis Bos', 880, NULL, '1765', NULL, NULL, 'R', 'A', '1772-04-16', 'Batavia', NULL, NULL, false, '1772-10-14', 'Texel', 4105, 'One of the 2 passengers was a condemned person.');
INSERT INTO "voyages" VALUES (7865, '', 2, '', 'ZON', 'Andries Hansen', 450, 'hoeker', '1768', NULL, NULL, 'A', 'A', '1772-06-25', 'The Cape', '1772-06-25', NULL, true, '1772-09-28', 'Texel', 4123, NULL);
INSERT INTO "voyages" VALUES (7866, '', 1, '', 'ALKEMADE', 'Jan van Eysden', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1772-10-04', 'Coromandel', '1773-01-26', '1773-02-04', true, '1773-06-07', 'Texel', 4056, NULL);
INSERT INTO "voyages" VALUES (7867, '', 3, '', 'RITTHEM', 'Jurriaan Verburg', 880, NULL, '1764', NULL, NULL, 'Z', 'E', '1772-10-24', 'Batavia', '1772-12-22', '1773-01-16', true, '1773-05-01', 'Texel', 4130, NULL);
INSERT INTO "voyages" VALUES (7868, '', 1, '', 'GROENENDAAL', 'Karsten Eggers', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1772-10-27', 'Batavia', '1772-12-30', '1773-02-04', true, '1773-05-25', 'Texel', 4124, 'The 11 passengers included 3 condemned Commandeur persons. of the return fleet was Arend van der Deuren, master of the NOORD-BEVELAND (7874).');
INSERT INTO "voyages" VALUES (7869, '', 2, '', 'PAUW', 'Abraham van der Weide', 850, NULL, '1767', NULL, NULL, 'D', 'D', '1772-10-27', 'Batavia', '1772-12-30', '1773-02-04', true, '1773-05-23', 'Goeree', 4128, 'The 6 passengers included one female slave.');
INSERT INTO "voyages" VALUES (7870, '', 2, '', 'HONKOOP', 'Karel Philip Kassel', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1772-10-30', 'Batavia', '1772-12-23', '1773-02-04', true, '1773-05-24', 'Texel', 4125, NULL);
INSERT INTO "voyages" VALUES (7871, '', 3, '', 'WILLEM DE VIJFDE', 'Thomas de Beukelaar', 1150, NULL, '1765', NULL, NULL, 'Z', 'Z', '1772-10-31', 'Batavia', '1772-12-30', '1773-02-04', true, '1773-05-24', 'Rammekens', 4132, NULL);
INSERT INTO "voyages" VALUES (7872, '', 1, '', 'BOTLAND', 'Johan van Voorst', 1150, NULL, '1769', NULL, NULL, 'Z', 'A', '1772-11-04', 'Batavia', '1773-01-06', '1773-02-04', true, '1773-06-07', 'Texel', 4111, 'The 7 passengers included 2 condemned persons.');
INSERT INTO "voyages" VALUES (7873, '', 2, '', 'VROUWE MARIA JAKOBA', 'Marten Pietersz. Mooy', 880, NULL, '1765', NULL, NULL, 'H', 'H', '1772-11-08', 'Batavia', '1773-01-07', '1773-02-04', true, '1773-05-25', 'Texel', 4129, NULL);
INSERT INTO "voyages" VALUES (7874, '', 5, '', 'NOORD-BEVELAND', 'Arend van der Deuren', 1150, NULL, '1756', NULL, NULL, 'Z', 'A', '1772-11-08', 'Batavia', '1773-01-07', '1773-02-04', true, '1773-05-26', 'Texel', 4053, 'NOORD-BEVELAND, Arend van der Deuren, was commandeur of the return fleet. After its return the NOORD-BEVELAND served as a hospitalship; on 09-10-1773 it was laid up.');
INSERT INTO "voyages" VALUES (7875, '', 4, '', 'ZUID-BEVELAND', 'Lambert Arnout Hallman', 1100, NULL, '1755', NULL, NULL, 'Z', 'A', '1772-11-16', 'Ceylon', '1773-01-15', '1773-02-04', true, '1773-06-07', 'Texel', 4107, NULL);
INSERT INTO "voyages" VALUES (7876, '', 2, '', 'BOT', 'Damiaan Hugo Staring', 1150, NULL, '1768', NULL, NULL, 'Z', 'Z', '1772-12-03', 'China', '1773-03-02', '1773-04-09', true, '1773-07-04', 'Rammekens', 4115, NULL);
INSERT INTO "voyages" VALUES (7877, '', 1, '', 'HERSTELDER', 'Justus Hendrik Pfeil', 600, 'fregat', NULL, '1772', NULL, 'C', 'D', '1772-12-03', 'China', '1773-03-01', '1773-04-09', true, '1773-06-29', 'Goeree', NULL, 'The HERSTELDER, bought in China, replaced the RIJNSBURG, which had been wrecked during a voyage from Batavia to China in 1771/2 (see 7842).');
INSERT INTO "voyages" VALUES (7878, '', 4, '', 'NIEUW RHOON', 'Pieter van Prooien', 1150, NULL, '1764', NULL, NULL, 'Z', 'Z', '1772-12-03', 'Batavia', '1773-03-01', '1773-04-09', true, '1773-07-04', 'Rammekens', 4120, NULL);
INSERT INTO "voyages" VALUES (7879, '', 4, '', 'JONGE SAMUEL', 'Evertsz. Popta', 880, NULL, '1761', NULL, NULL, 'Z', 'R', '1772-12-03', 'Batavia', '1773-03-04', '1773-04-09', true, '1773-06-29', 'Goeree', 4131, NULL);
INSERT INTO "voyages" VALUES (7880, '', 2, '', 'PRINSES VAN ORANJE', 'Kornelis Pietersen', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1772-12-24', 'China', '1773-03-18', '1773-04-09', true, '1773-07-01', 'Texel', 4113, NULL);
INSERT INTO "voyages" VALUES (7881, '', 2, '', 'VELDHOEN', 'Pieter Sijbrandsz. Flout', 1150, NULL, '1765', NULL, NULL, 'A', 'A', '1772-12-24', 'China', '1773-03-21', '1773-04-09', true, '1773-07-01', 'Texel', 4065, NULL);
INSERT INTO "voyages" VALUES (7882, '', 2, '', 'BOVENKERKER POLDER', 'Jan Moorland', 850, NULL, '1765', NULL, NULL, 'A', 'A', '1773-01-24', 'Bengal', '1773-03-28', '1773-04-21', true, '1773-07-05', 'Texel', 4117, NULL);
INSERT INTO "voyages" VALUES (7883, '', 5, '', 'DUINENBURG', 'Pieter Thomasz.', 1100, NULL, '1757', NULL, NULL, 'Z', 'A', '1773-01-30', 'Batavia', '1773-05-03', '1773-05-26', true, NULL, NULL, 4135, 'The DUINENBURG was wrecked between the Cape and patria.');
INSERT INTO "voyages" VALUES (7884, '', 1, '', 'MERCUUR', 'Christiaan Andries Spin', 850, NULL, '1770', NULL, NULL, 'D', 'R', '1773-01-30', 'Batavia', NULL, NULL, false, '1773-08-15', 'Goeree', 4134, 'One of the 2 passengers was a condemned person.');
INSERT INTO "voyages" VALUES (7885, '', 4, '', 'WESTFRIESLAND', 'Gerrit Springer', 880, NULL, '1761', NULL, NULL, 'H', 'Z', '1773-02-01', 'Ceylon', '1773-04-13', '1773-05-09', true, '1773-09-03', 'Rammekens', 4114, NULL);
INSERT INTO "voyages" VALUES (7886, '', 3, '', 'WOESTDUIN', 'Pieter Angelvorst', 1150, NULL, '1767', NULL, NULL, 'A', 'A', '1773-02-01', 'Ceylon', '1773-04-19', '1773-05-09', true, '1773-09-02', 'Texel', 4122, NULL);
INSERT INTO "voyages" VALUES (7887, '', 2, '', 'OUWERKERK', 'Josua de Wolf van leperen', 1150, NULL, '1768', NULL, NULL, 'Z', 'Z', '1773-04-21', 'Cape', '1773-04-21', NULL, true, '1773-07-22', 'Rammekens', 4143, NULL);
INSERT INTO "voyages" VALUES (7888, '', 3, '', 'RIDDERKERK', 'Michiel Hendrik Wunder', 850, NULL, '1766', NULL, NULL, 'R', 'A', '1773-04-30', 'Batavia', '1773-07-18', NULL, true, '1773-11-17', 'Texel', 4137, NULL);
INSERT INTO "voyages" VALUES (7889, '', 3, '', 'VROUWE MARGARETHA MARIA', 'George Steendekker', 880, NULL, '1765', NULL, NULL, 'E', NULL, '1773-07-15', 'Batavia', NULL, NULL, true, NULL, NULL, 4108, 'The VROUWE MARGARETHA MARIA was bound for patria via Bengal, but on its way to Bengal it was wrecked in 1773.');
INSERT INTO "voyages" VALUES (7890, '', 4, '', 'BARTHA PETRONELLA', 'Jakob Hendrik Johansen', 880, NULL, '1764', NULL, NULL, 'H', 'A', '1773-07-18', 'The Cape', '1773-07-18', NULL, true, '1773-10-08', 'Texel', 4149, NULL);
INSERT INTO "voyages" VALUES (7891, '', 5, '', 'JONGE LIEVE', 'Jan Frederik Raatjes', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1773-09-27', 'Coromandel', '1773-12-18', '1774-02-02', true, '1774-06-02', 'Texel', 4136, NULL);
INSERT INTO "voyages" VALUES (7892, '', 1, '', 'JUNO', 'Pieter Verkerk', 850, NULL, '1771', NULL, NULL, 'R', 'D', '1773-10-27', 'Batavia', '1773-12-23', '1774-02-02', true, '1774-06-01', 'Goeree', 4146, 'Commandeur of the return fleet was Leendert van Koopstad, master of the ''T LOO (7898).');
INSERT INTO "voyages" VALUES (7893, '', 4, '', 'VROUWE KORNELIA HILLEGONDA', 'Gerrit Bruin', 850, NULL, '1760', NULL, NULL, 'D', 'H', '1773-10-27', 'Batavia', '1774-01-04', '1774-01-21', true, '1774-06-01', 'Texel', 4116, NULL);
INSERT INTO "voyages" VALUES (7894, '', 1, '', 'HUIS TE KROOSWIJK', 'Frederik Wielard', 850, NULL, '1770', NULL, NULL, 'R', 'R', '1773-10-27', 'Batavia', '1773-12-17', '1774-02-02', true, '1774-06-02', 'Goeree', 4133, NULL);
INSERT INTO "voyages" VALUES (7895, '', 4, '', 'VREEBURG', 'Hendrik Hilverduin', 850, NULL, '1764', NULL, NULL, 'D', 'E', '1773-10-27', 'Batavia', '1773-12-17', '1774-02-02', true, '1774-06-02', 'Texel', 4163, NULL);
INSERT INTO "voyages" VALUES (7896, '', 3, '', 'AZIE', 'Christiaan Blom', 1100, NULL, '1765', NULL, NULL, 'Z', 'Z', '1773-11-01', 'Batavia', '1774-01-10', '1774-02-02', true, '1774-06-01', 'Rammekens', 4148, 'return voyage (7747) and the second outward voyage (4032) OUDERAMSTEL; subsequently it was renamed AZIE again (see 7847, etc.).');
INSERT INTO "voyages" VALUES (7897, '', 1, '', 'FOREEST', 'Klaas Roem', 850, NULL, '1770', NULL, NULL, 'H', 'A', '1773-11-01', 'Batavia', '1774-01-06', '1774-03-02', true, '1774-06-08', 'Texel', 4150, 'The 4 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7898, '', 3, '', '''T LOO', 'Leendert van Koopstad', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1773-11-06', 'Batavia', '1774-01-09', '1774-02-02', true, '1774-06-02', 'Texel', 4161, 'The master of the ''T LOO. Leendert van Koopstad, was commandeer of the return fleet.');
INSERT INTO "voyages" VALUES (7899, '', 2, '', 'HUIS TER MEYEN', 'Jan Paardekoper', 1150, NULL, '1767', NULL, NULL, 'A', 'A', '1773-11-16', 'Ceylon', '1774-02-04', '1774-03-02', true, '1774-07-08', 'Texel', 4127, NULL);
INSERT INTO "voyages" VALUES (7900, '', 5, '', 'HUIS TE BIJWEG', NULL, 1100, NULL, '1760', NULL, NULL, 'A', 'A', '1773-11-18', 'Batavia', '1774-02-20', NULL, true, NULL, NULL, 4159, 'ashore on 20-02-1774. On 31-12-1780 the ship was laid up.');
INSERT INTO "voyages" VALUES (7901, '', 1, '', 'OVERHOUT', 'Hendrik Willemse', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1773-11-25', 'Batavia', '1774-03-12', '1774-04-05', true, '1774-07-05', 'Texel', 4151, 'The 5 passengers included 2 female slaves.');
INSERT INTO "voyages" VALUES (7902, '', 5, '', 'ASCHAT', 'Reindert den Uil', 1150, NULL, '1760', NULL, NULL, 'A', 'A', '1773-12-04', 'Batavia', '1774-03-12', '1774-04-05', true, '1774-07-05', 'Texel', 4147, NULL);
INSERT INTO "voyages" VALUES (7903, '', 2, '', 'POPKENSBURG', 'Pieter ten Droge', 880, NULL, '1763', NULL, NULL, 'Z', 'Z', '1773-12-04', 'Batavia', '1774-03-10', '1774-04-05', true, '1774-07-05', 'Rammekens', 4110, NULL);
INSERT INTO "voyages" VALUES (7904, '', 2, '', 'JONGE HELLINGMAN', 'Jan Balthus Meyer', 850, NULL, '1767', NULL, NULL, 'H', 'R', '1773-12-25', 'China', '1774-04-26', '1774-05-16', true, '1774-09-30', 'Texel', 4139, NULL);
INSERT INTO "voyages" VALUES (7905, '', 1, '', 'HOLLAND', 'Hans Hansen', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1773-12-25', 'China', '1774-04-22', '1774-05-06', true, '1774-08-25', 'Texel', 4157, NULL);
INSERT INTO "voyages" VALUES (7906, '', 1, '', 'EUROPA', 'Jakob de Frein', 1200, NULL, '1770', NULL, NULL, 'Z', 'Z', '1773-12-29', 'China', '1774-04-21', '1774-05-06', true, '1774-08-25', 'Rammekens', 4155, NULL);
INSERT INTO "voyages" VALUES (7907, '', 1, '', 'VOORBERG', 'Frederik Visser', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1773-12-29', 'China', '1774-04-21', '1774-05-06', true, '1774-08-26', 'Texel', 4153, NULL);
INSERT INTO "voyages" VALUES (7908, '', 1, '', 'BEEKVLIET', 'Andries Hansen', 850, NULL, '1770', NULL, NULL, 'A', 'A', '1774-01-21', 'Batavia', '1774-04-28', '1774-05-16', true, '1774-09-02', 'Texel', 4104, NULL);
INSERT INTO "voyages" VALUES (7909, '', 2, '', 'HOOLWERF', 'Willem Dona', 850, NULL, '1769', NULL, NULL, 'H', 'E', '1774-01-21', 'Batavia', '1774-04-18', '1774-05-04', true, '1774-08-25', 'Texel', 4167, 'condemned person.');
INSERT INTO "voyages" VALUES (7910, '', 4, '', 'ZILVEREN LEEUW', 'Marten Hakker', 880, NULL, '1765', NULL, NULL, 'D', 'A', '1774-01-23', 'Bengal', '1774-04-22', '1774-05-06', true, '1774-09-23', 'Texel', 4140, NULL);
INSERT INTO "voyages" VALUES (7911, '', 1, '', 'HOOP', 'Michiel Kooplijn', 800, 'fluit', NULL, NULL, NULL, 'A', 'A', '1774-02-01', 'The Cape', '1774-02-01', NULL, true, '1774-06-08', 'Texel', 4176, NULL);
INSERT INTO "voyages" VALUES (7912, '', 3, '', 'OUD HAARLEM', 'Jan Siereveld', 1150, NULL, '1768', NULL, NULL, 'A', 'Z', '1774-02-03', 'Ceylon', '1774-04-22', '1774-05-06', true, '1774-08-25', 'Rammekens', 4165, NULL);
INSERT INTO "voyages" VALUES (7913, '', 3, '', 'LANDSKROON', 'Michiel Hamelo', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1774-02-03', 'Ceylon', '1774-04-28', '1774-05-16', true, '1774-09-23', 'Texel', 4160, NULL);
INSERT INTO "voyages" VALUES (7914, '', 2, '', 'TEMPEL', 'Willem Koelbier', 850, NULL, '1767', NULL, NULL, 'R', 'A', '1774-05-14', 'Batavia', NULL, NULL, false, '1775-02-16', 'Texel', 4103, 'The 2 passengers were condemned persons.');
INSERT INTO "voyages" VALUES (7915, '', 1, '', 'NOORDBEEK', 'J. Wellegaart', 850, 'fluit', NULL, '1773', NULL, 'Z', 'Z', '1774-06-24', 'The Cape', '1774-06-24', NULL, true, '1774-11-15', 'Rammekens', 4183, NULL);
INSERT INTO "voyages" VALUES (7916, '', 5, '', 'PALLAS', 'Asmus Hendrik Sterrenberg', 1150, NULL, '1762', NULL, NULL, 'Z', 'A', '1774-10-20', 'Coromandel', '1775-01-16', '1775-03-02', true, '1775-06-23', 'Texel', 4170, NULL);
INSERT INTO "voyages" VALUES (7917, '', 4, '', 'WESTERVELD', 'Andries Bruin', 1100, NULL, '1761', NULL, NULL, 'A', 'A', '1774-10-20', 'Ceylon', '1775-02-07', '1775-03-02', true, '1775-06-23', 'Texel', 4138, NULL);
INSERT INTO "voyages" VALUES (7918, '', 3, '', 'VROUWE ANTHOINETTA KOENRARDINA', 'Jan Kaatman', 880, NULL, '1765', NULL, NULL, 'D', 'D', '1774-10-27', 'Batavia', '1775-01-15', '1775-02-02', true, '1775-05-14', 'Goeree', 4145, 'Commandeur of the return fleet was Stoffel Kok, master of the COMPAGNIES WELVAREN (7924).');
INSERT INTO "voyages" VALUES (7919, '', 5, '', 'BORSSELE', 'Johan Frederik Schuts', 1150, NULL, '1758', NULL, NULL, 'Z', 'Z', '1774-10-27', 'Batavia', '1775-02-06', '1775-03-02', true, '1775-06-22', 'Rammekens', 4175, NULL);
INSERT INTO "voyages" VALUES (7920, '', 1, '', 'BREDENHOF', 'Marten Pietersz. Mooy', 850, NULL, '1771', NULL, NULL, 'H', 'H', '1774-10-27', 'Batavia', '1775-01-10', '1775-01-24', true, '1775-04-24', 'Texel', 4178, NULL);
INSERT INTO "voyages" VALUES (7921, '', 1, '', 'DANKBAARHEID', 'Joachim Ernst Wend', 850, NULL, '1772', NULL, NULL, 'R', 'R', '1774-10-27', 'Batavia', '1775-01-08', '1775-02-02', true, '1775-05-14', 'Goeree', 4188, NULL);
INSERT INTO "voyages" VALUES (7922, '', 2, '', 'GROENENDAAL', 'Jan Stil', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1774-10-27', 'Batavia', '1775-01-12', '1775-02-02', true, '1775-05-15', 'Texel', 4186, 'The 9 passengers included 4 condemned persons.');
INSERT INTO "voyages" VALUES (7923, '', 1, '', 'MARS', 'Jan Abel', 1150, NULL, '1771', NULL, NULL, 'Z', 'Z', '1774-10-27', 'Batavia', '1775-01-08', '1775-02-02', true, '1775-05-12', 'Rammekens', 4189, NULL);
INSERT INTO "voyages" VALUES (7924, '', 3, '', 'COMPAGNIES WELVAREN', 'Stoffel Kok', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1774-10-27', 'Batavia', '1775-01-15', '1775-02-02', true, '1775-05-15', 'Texel', 4091, 'The 7 passengers included one condemned person and a slave. The master of the COMPAGNIES WELVAREN, Stoffel Kok, was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7925, '', 2, '', 'BOTLAND', 'Joost Koen', 1150, NULL, '1769', NULL, NULL, 'Z', 'A', '1774-11-01', 'Batavia', '1775-01-08', '1775-02-02', true, '1775-05-15', 'Texel', 4191, NULL);
INSERT INTO "voyages" VALUES (7926, '', 2, '', 'ALKEMADE', 'Daniel Deune', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1774-11-07', 'Batavia', '1775-01-08', '1775-03-02', true, '1775-06-23', 'Texel', 4180, 'The 12 passengers included 3 condemned persons, destined for the Cape.');
INSERT INTO "voyages" VALUES (7927, '', 1, '', 'HOOGKARSPEL', 'Pieter Helmers', 850, NULL, '1771', NULL, NULL, 'E', 'E', '1774-11-07', 'Batavia', '1775-03-26', '1775-04-18', true, '1775-07-17', 'Texel', 4179, NULL);
INSERT INTO "voyages" VALUES (7928, '', 1, '', 'BEEMSTER WELVAREN', 'Marten Schoning', 850, NULL, '1770', NULL, NULL, 'E', 'H', '1775-01-01', 'China', '1775-03-21', '1775-04-18', true, '1775-07-17', 'Texel', 4144, NULL);
INSERT INTO "voyages" VALUES (7929, '', 1, '', 'CERES', 'Wopke Popta', 1150, NULL, '1771', NULL, NULL, 'A', 'Z', '1775-01-01', 'China', '1775-03-21', '1775-04-04', true, '1775-07-02', 'Rammekens', 4181, NULL);
INSERT INTO "voyages" VALUES (7930, '', 3, '', 'OOSTKAPELLE', 'Johan van Voorst', 1150, NULL, '1767', NULL, NULL, 'Z', 'A', '1775-01-01', 'China', '1775-04-05', '1775-04-20', true, '1775-07-25', 'Texel', 4162, NULL);
INSERT INTO "voyages" VALUES (7931, '', 1, '', 'VRIJHEID', 'Jan Och', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1775-01-07', 'China', '1775-03-29', '1775-04-18', true, '1775-07-17', 'Texel', 4187, NULL);
INSERT INTO "voyages" VALUES (7932, '', 2, '', 'BOVENKERKER POLDER', 'Kornelis Bos', 850, NULL, '1765', NULL, NULL, 'A', 'A', '1775-01-20', 'Bengal', '1775-03-24', '1775-04-04', true, '1775-07-03', 'Texel', 4192, NULL);
INSERT INTO "voyages" VALUES (7933, '', 2, '', 'LAM', 'Olke Hendrik Andringa', 850, NULL, '1769', NULL, NULL, 'D', 'E', '1775-01-20', 'Bengal', '1775-03-25', '1775-04-04', true, '1775-07-03', 'Texel', 4174, NULL);
INSERT INTO "voyages" VALUES (7934, '', 2, '', 'HONKOOP', 'Pieter Haverkamp', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1775-01-21', 'Batavia', '1775-03-26', '1775-04-18', true, '1775-07-17', 'Texel', 4182, 'The 5 passengers included 2 condemned persons.');
INSERT INTO "voyages" VALUES (7935, '', 4, '', 'WILLEM DE VIJFDE', 'Josua de Wolf van Ieperen', 1150, NULL, '1766', NULL, NULL, 'Z', 'Z', '1775-01-21', 'Batavia', '1775-03-29', '1775-04-20', true, '1775-07-25', 'Rammekens', 4190, 'One of the 2 passengers was a condemned');
INSERT INTO "voyages" VALUES (7936, '', 3, '', 'VELDHOEN', 'Justus Hendrik Pfeil', 1150, NULL, '1765', NULL, NULL, 'A', 'A', '1775-02-02', 'Ceylon', '1775-04-05', '1775-05-02', true, '1775-08-01', 'Texel', 4195, NULL);
INSERT INTO "voyages" VALUES (7937, '', 5, '', 'ZUID-BEVELAND', 'Hendrik Nieuwboer', 1100, NULL, '1755', NULL, NULL, 'Z', 'Z', '1775-02-02', 'Ceylon', '1775-04-06', '1775-04-20', true, '1775-07-25', 'Rammekens', 4194, NULL);
INSERT INTO "voyages" VALUES (7938, '', 2, '', 'HOOP', 'Swerus Vrolijk', 800, 'fluit', NULL, NULL, NULL, 'A', 'A', '1775-02-08', 'The Cape', '1775-02-08', NULL, true, '1775-06-23', 'Texel', 4209, NULL);
INSERT INTO "voyages" VALUES (7939, '', 2, '', 'MERCUUR', 'Hendrik Mulder', 850, NULL, '1770', NULL, NULL, 'D', 'A', '1775-05-12', 'Batavia', NULL, NULL, false, '1775-12-13', 'Texel', 4198, 'The 2 passengers were condemned persons.');
INSERT INTO "voyages" VALUES (7940, '', 1, '', 'KATWIJK AAN DEN RIJN', 'Isaak Louis de Bellon', 750, 'hoeker', NULL, '1774', NULL, 'A', 'A', '1775-06-05', 'The Cape', '1775-06-05', NULL, true, '1775-09-12', 'Texel', 4224, NULL);
INSERT INTO "voyages" VALUES (7941, '', 3, '', 'BOT', 'Lambert Arnout Halfman', 1150, NULL, '1768', NULL, NULL, 'Z', 'A', '1775-10-05', 'Coromandel', '1776-02-10', '1776-03-03', true, '1776-06-13', 'Texel', 4197, NULL);
INSERT INTO "voyages" VALUES (7942, '', 1, '', 'JONGE HUGO', 'Hendrik Hilverduin', 850, NULL, '1772', NULL, NULL, 'E', 'E', '1775-10-18', 'China', '1776-03-19', '1776-04-06', true, '1776-07-03', 'Texel', 4217, NULL);
INSERT INTO "voyages" VALUES (7943, '', 1, '', 'INDIAAN', 'Jan Frederik Raatjes', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1775-10-18', 'China', '1776-03-19', '1776-04-06', true, '1776-07-03', 'Texel', 4210, NULL);
INSERT INTO "voyages" VALUES (7944, '', 5, '', 'BARTHA PETRONELLA', 'Justinus van Gennep', 880, NULL, '1764', NULL, NULL, 'H', 'E', '1775-10-19', 'Batavia', '1775-12-27', '1776-01-17', true, '1776-05-05', 'Texel', 4206, 'The 7 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7945, '', 4, '', '''T LOO', 'Gerrit Berg', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1775-10-19', 'Batavia', '1775-12-27', '1776-02-07', true, '1776-06-09', 'Texel', 4214, 'passengers included 2 female slaves. Commandeur of the return fleet was Christiaan Rebel, master of the HUIS OM (see 7946).');
INSERT INTO "voyages" VALUES (7946, '', 5, '', 'HUIS OM', 'Christiaan Rebel', 1150, NULL, '1761', NULL, NULL, 'Z', 'Z', '1775-10-19', 'Batavia', '1775-12-30', '1776-02-07', true, '1776-06-09', 'Rammekens', 4173, 'The master of the HUIS OM, Christiaan Rebel, was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7947, '', 4, '', 'WOESTDUIN', 'Pieter Thijssen jr.', 1150, NULL, '1767', NULL, NULL, 'A', 'A', '1775-10-19', 'Batavia', '1775-12-31', '1776-03-03', true, '1776-06-13', 'Texel', 4199, NULL);
INSERT INTO "voyages" VALUES (7948, '', 1, '', 'PATRIOT', 'Volkers', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1775-10-20', 'Batavia', '1776-01-08', '1776-04-06', true, '1776-07-03', 'Texel', 4219, 'The PATRIOT transported the cargo of the NIEUW RHOON, laid up at the Cape (see 7955); invoice value: f 293,773, destined for the chamber Amsterdam.');
INSERT INTO "voyages" VALUES (7949, '', 5, '', 'JONGE SAMUEL', 'Jurriaan Raasel', 880, NULL, '1761', NULL, NULL, 'Z', 'R', '1775-10-22', 'Batavia', '1776-01-04', '1776-02-07', true, '1776-06-09', 'Goeree', 4205, 'The 4 passengers included one slave.');
INSERT INTO "voyages" VALUES (7950, '', 1, '', 'ABBEKERK', 'Gerrit Bruin', 850, NULL, '1772', NULL, NULL, 'H', 'H', '1775-10-25', 'Batavia', '1776-01-04', '1776-02-07', true, '1776-06-09', 'Texel', 4222, 'The 5 passengers included one female slave.');
INSERT INTO "voyages" VALUES (7951, '', 4, '', 'RIDDERKERK', 'Christiaan van Veerden', 850, NULL, '1766', NULL, NULL, 'R', 'D', '1775-10-30', 'Batavia', '1776-01-01', '1776-02-20', true, '1776-06-09', 'Goeree', 4212, NULL);
INSERT INTO "voyages" VALUES (7952, '', 1, '', 'HOF TER LINDEN', 'Jan Kornelis Roos', 1150, NULL, '1772', NULL, NULL, 'Z', 'Z', '1775-11-02', 'Batavia', '1776-01-08', '1776-03-03', true, '1776-06-14', 'Rammekens', 4223, NULL);
INSERT INTO "voyages" VALUES (7953, '', 4, '', 'RITTHEM', 'Jan Everwijk Drillinger', 880, NULL, '1764', NULL, NULL, 'Z', 'A', '1775-11-02', 'Batavia', '1776-01-04', '1776-03-03', true, '1776-06-09', 'Texel', 4204, NULL);
INSERT INTO "voyages" VALUES (7954, '', 6, '', 'JONGE LIEVE', 'Willem Ferret', 1150, NULL, '1759', NULL, NULL, 'A', 'A', '1775-11-06', 'Batavia', '1776-01-08', '1776-02-07', true, '1776-06-09', 'Texel', 4211, NULL);
INSERT INTO "voyages" VALUES (7955, '', 5, '', 'NIEUW RHOON', 'Jakob Koelders', 1150, NULL, '1764', NULL, NULL, 'Z', 'A', '1775-11-22', 'Ceylon', '1776-02-05', NULL, true, NULL, NULL, 4213, 'After arrival at the Cape the NIEUW RHOON was taken off the service because of unseaworthiness; its cargo was transported to Amsterdam by the PATRIOT (see 7948). The NIEUW RHOON was laid up at the Cape on 01-03-1776.');
INSERT INTO "voyages" VALUES (7956, '', 2, '', 'EUROPA', 'Frans van Ewijk', 1200, NULL, '1770', NULL, NULL, 'Z', 'Z', '1776-01-10', 'China', '1776-04-29', '1776-05-12', true, '1776-09-01', 'Rammekens', 4221, NULL);
INSERT INTO "voyages" VALUES (7957, '', 1, '', 'MORGENSTER', 'Gerrit Springer', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1776-01-10', 'China', '1776-04-28', '1776-05-12', true, '1776-08-31', 'Texel', 4200, NULL);
INSERT INTO "voyages" VALUES (7958, '', 2, '', 'FOREEST', 'Andries Matthijssen', 850, NULL, '1770', NULL, NULL, 'H', 'A', '1776-01-20', 'Bengal', '1776-04-05', '1776-05-12', true, '1776-08-30', 'Texel', 4229, NULL);
INSERT INTO "voyages" VALUES (7959, '', 3, '', 'PAUW', 'Johan Snijders', 850, NULL, '1767', NULL, NULL, 'D', 'Z', '1776-01-20', 'Bengal', '1776-04-24', '1776-05-12', true, '1776-09-01', 'Rammekens', 4201, NULL);
INSERT INTO "voyages" VALUES (7960, '', 1, '', 'HUIS TE SPIJK', 'Michiel Kooplijn', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1776-01-25', 'Batavia', NULL, NULL, false, '1776-08-31', 'Texel', 4225, 'The 4 passengers included one condemned person. According to K.A. 4261 J. Etlofs was master.');
INSERT INTO "voyages" VALUES (7961, '', 2, '', 'VOORBERG', 'Reindert den Uil', 1150, NULL, '1770', NULL, NULL, 'A', 'Z', '1776-01-25', 'Batavia', '1776-05-10', '1776-06-04', true, '1776-09-11', 'Rammekens', 4226, NULL);
INSERT INTO "voyages" VALUES (7962, '', 4, '', 'OUD HAARLEM', 'Jan Siereveld', 1150, NULL, '1768', NULL, NULL, 'A', 'Z', '1776-02-12', 'Ceylon', '1776-05-02', '1776-06-04', true, '1776-09-01', 'Rammekens', 4230, NULL);
INSERT INTO "voyages" VALUES (7963, '', 3, '', 'HUIS TER MEYEN', 'Klaas Roem', 1150, NULL, '1767', NULL, NULL, 'A', 'A', '1776-02-12', 'Ceylon', '1776-05-02', '1776-05-16', true, '1776-08-11', 'Texel', 4227, NULL);
INSERT INTO "voyages" VALUES (7964, '', 2, '', 'HUIS TE KROOSWIJK', 'Hendrik Schreuder', 850, NULL, '1770', NULL, NULL, 'R', 'R', '1776-03-03', 'The Cape', '1776-03-03', NULL, true, '1776-06-13', 'Goeree', 4239, NULL);
INSERT INTO "voyages" VALUES (7965, '', 2, '', 'HERSTELDER', 'Albert Kikkert', 600, 'fregat', NULL, '1772', NULL, 'C', 'A', '1776-04-01', 'Batavia', NULL, NULL, false, '1776-10-22', 'Texel', 4207, NULL);
INSERT INTO "voyages" VALUES (7966, '', 2, '', 'NOORDBEEK', 'Jan Karel Wetterijk', 850, 'fluit', NULL, '1773', NULL, 'Z', 'Z', '1776-05-03', 'The Cape', '1776-05-03', NULL, true, '1776-08-20', 'Rammekens', 4240, NULL);
INSERT INTO "voyages" VALUES (7967, '', 3, '', 'PRINSES VAN ORANJE', 'Karsten Eggers', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1776-10-20', 'Coromandel', '1777-01-10', '1777-03-07', true, '1777-06-19', 'Texel', 4193, '4261 Gerard Oosthuis was master of the PRINSES VAN ORANJE.');
INSERT INTO "voyages" VALUES (7968, '', 3, '', 'BLEIJENBURG', 'Jan Tromp', 880, NULL, '1765', NULL, NULL, 'R', 'R', '1776-10-25', 'Batavia', '1776-12-31', '1777-02-03', true, '1777-05-20', 'Goeree', 4168, 'master of the BOTLAND (see 7969).');
INSERT INTO "voyages" VALUES (7969, '', 3, '', 'BOTLAND', 'Kornelis Pietersen', 1150, NULL, '1769', NULL, NULL, 'Z', 'Z', '1776-10-25', 'Batavia', '1776-12-31', '1777-02-03', true, '1777-05-20', 'Rammekens', 4242, 'The master of the BOTLAND, Kornelis Pietersen, was Cmmandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7970, '', 4, '', 'BOVENKERKER POLDER', 'Hendrik Elders', 850, NULL, '1765', NULL, NULL, 'A', 'A', '1776-10-25', 'Batavia', '1776-12-29', '1777-01-18', true, '1777-05-05', 'Texel', 4257, 'The 10 passengers included 7 condemned persons and a female slave.');
INSERT INTO "voyages" VALUES (7971, '', 5, '', 'VROUWE KORNELIA HILLEGONDA', 'Charles Smits', 850, NULL, '1760', NULL, NULL, 'D', 'H', '1776-10-25', 'Batavia', '1776-12-31', '1777-02-03', true, '1777-05-20', 'Texel', 4235, '');
INSERT INTO "voyages" VALUES (7972, '', 1, '', 'MENTOR', 'Hans Hansen', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1776-10-25', 'Batavia', '1776-12-31', '1777-02-03', true, '1777-05-20', 'Texel', 4252, 'The 6 passengers included one female slave.');
INSERT INTO "voyages" VALUES (7973, '', 3, '', 'POPKENSBURG', 'Jakob de Meyer', 880, NULL, '1763', NULL, NULL, 'Z', 'Z', '1776-10-25', 'Batavia', '1776-12-31', '1777-03-07', true, '1777-06-18', 'Rammekens', 4238, NULL);
INSERT INTO "voyages" VALUES (7974, '', 1, '', 'HELD WOLTEMADE', 'Jan Stil', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1776-10-25', 'Batavia', '1777-01-14', '1777-03-07', true, '1777-05-20', 'Texel', 4247, NULL);
INSERT INTO "voyages" VALUES (7975, '', 5, '', 'VREEBURG', 'Willem Bax', 850, NULL, '1764', NULL, NULL, 'D', 'D', '1776-10-28', 'Batavia', '1777-01-13', '1777-03-07', true, '1777-06-18', 'Goeree', 4246, 'The 4 passengers included one slave.');
INSERT INTO "voyages" VALUES (7976, '', 1, '', 'AMSTERDAM', 'Jurriaan Verburg', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1776-11-02', 'Batavia', '1777-01-14', '1777-03-07', true, '1777-06-19', 'Texel', 4185, 'The 6 passengers included 2 female slaves.');
INSERT INTO "voyages" VALUES (7977, '', 3, '', 'DUIVENBRUG', 'Gerrit Evertsz. Popta', 1150, NULL, '1766', NULL, NULL, 'E', 'E', '1760-11-08', 'Batavia', '1777-01-08', '1777-02-03', true, NULL, NULL, 4154, 'Between 14 and 16-05-1777 the DUIVENBRUG was wrecked off the Canary Islands.');
INSERT INTO "voyages" VALUES (7978, '', 5, '', 'WESTERVELD', 'Swerus Vrolijk', 1100, NULL, '1761', NULL, NULL, 'A', 'A', '1776-11-21', 'Ceylon', '1777-02-12', '1777-03-07', true, '1777-06-19', 'Texel', 4256, 'On 11-10-1777 the WESTERVELD was laid up.');
INSERT INTO "voyages" VALUES (7979, '', 1, '', 'DELFSHAVEN', 'Christiaan Andries Spin', 850, NULL, '1772', NULL, NULL, 'D', 'A', '1776-11-22', 'Bengal', '1777-02-13', '1777-03-07', true, '1777-06-19', 'Texel', 4215, NULL);
INSERT INTO "voyages" VALUES (7980, '', 1, '', 'BUTTENLEVEN', 'Jan Kaatman', 850, NULL, '1773', NULL, NULL, 'D', 'D', '1776-12-22', 'China', '1777-05-06', '1777-05-19', true, '1777-09-01', 'Goeree', 4248, NULL);
INSERT INTO "voyages" VALUES (7981, '', 1, '', 'TRITON', 'Pieter van Prooien', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1776-12-23', 'China', '1777-03-25', '1777-04-08', true, '1777-07-04', 'Texel', 4237, NULL);
INSERT INTO "voyages" VALUES (7982, '', 2, '', 'CERES', 'Johan van Voorst', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1777-01-06', 'China', '1777-04-07', '1777-05-04', true, '1777-08-02', 'Texel', 4249, NULL);
INSERT INTO "voyages" VALUES (7983, '', 1, '', 'BLOK', 'Jakob de Lange', 1150, NULL, '1774', NULL, NULL, 'A', 'Z', '1777-01-14', 'China', '1777-04-24', '1777-05-04', true, '1777-08-02', 'Rammekens', 4254, NULL);
INSERT INTO "voyages" VALUES (7984, '', 2, '', 'BEEKVLIET', 'Benjamin van der Spek', 850, NULL, '1770', NULL, NULL, 'A', 'H', '1777-01-20', 'Bengal', '1777-03-23', '1777-04-08', true, '1777-07-03', 'Texel', 4232, NULL);
INSERT INTO "voyages" VALUES (7985, '', 4, '', 'TEMPEL', 'Jan Frederik Volmer', 850, NULL, '1767', NULL, NULL, 'R', 'R', '1777-01-20', 'Bengal', '1777-03-23', '1777-04-08', true, '1777-07-02', 'Goeree', 4259, NULL);
INSERT INTO "voyages" VALUES (7986, '', 1, '', 'BATAVIA', 'Pieter Helmers', 850, NULL, '1773', NULL, NULL, 'E', 'Z', '1777-01-27', 'Batavia', '1777-05-19', '1777-06-12', true, '1777-10-01', 'Rammekens', 4260, 'The 4 passengers included one condemned person');
INSERT INTO "voyages" VALUES (7987, '', 2, '', 'HOLLAND', 'Hendrik Willemse', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1777-01-27', 'Batavia', NULL, NULL, false, '1777-10-02', 'Texel', 4231, NULL);
INSERT INTO "voyages" VALUES (7988, '', 1, '', 'MERENBERG', 'Jan Balthus Meyer', 850, NULL, '1773', NULL, NULL, 'H', 'H', '1777-01-27', 'Batavia', '1777-05-06', '1777-05-19', true, '1777-09-02', 'Texel', 4258, 'The 3 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (7989, '', 2, '', 'OVERHOUT', 'Pieter Angelvorst+', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1777-02-05', 'Ceylon', '1777-04-25', '1777-05-19', true, NULL, NULL, 4218, 'On 31-08-1777 the OVERHOUT ran ashore near Egmond aan Zee and was wrecked.');
INSERT INTO "voyages" VALUES (7990, '', 3, '', 'HONKOOP', 'Daniel Deune', 1150, NULL, '1770', NULL, NULL, 'A', 'Z', '1777-02-11', 'Ceylon', '1777-04-24', '1777-05-04', true, '1777-08-02', 'Rammekens', 4255, NULL);
INSERT INTO "voyages" VALUES (7991, '', 2, '', 'KATWUK AAN DEN RIJN', 'Kasper Meyer', 750, 'hoeker', NULL, '1774', NULL, 'A', 'A', '1777-03-07', 'The Cape', '1777-03-07', NULL, true, '1777-06-19', 'Texel', 4272, NULL);
INSERT INTO "voyages" VALUES (7992, '', 1, '', 'WAKKERHEID', 'Jakob Hendrik Johansen', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1777-10-23', 'Coromandel', '1778-01-07', '1778-02-13', true, '1778-05-22', 'Texel', 4202, 'After the arrival of the ship at Texel its name was altered into COMPAGNIES WELVAREN (see the second voyage: 4345/-).');
INSERT INTO "voyages" VALUES (7993, '', 2, '', 'VROUWE ANTHOINETTA KOENRARDINA', 'Gerrit Harmeyer', 880, NULL, '1765', NULL, NULL, 'D', 'D', '1777-10-30', 'Batavia', '1778-01-15', '1778-02-13', true, '1778-05-20', 'Goeree', 4268, 'The master of the VROUWE ANTHOINETTA KOEN-RARDINA, Gerrit Harmeyer, was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (7994, '', 4, '', 'BOT', 'Christiaan van Veerden', 1150, NULL, '1768', NULL, NULL, 'Z', 'Z', '1777-10-30', 'Batavia', '1778-01-12', '1778-02-13', true, '1778-05-23', 'Rammekens', 4279, NULL);
INSERT INTO "voyages" VALUES (7995, '', 1, '', 'DIANA', 'Willemsz. Greveling', 850, NULL, '1774', NULL, NULL, 'R', 'R', '1777-10-30', 'Batavia', '1778-01-15', '1778-02-13', true, '1778-05-22', 'Goeree', 4250, '');
INSERT INTO "voyages" VALUES (7996, '', 3, '', 'JONGE HELLINGMAN', 'Michiel Hamelo', 850, NULL, '1767', NULL, NULL, 'H', 'A', '1777-10-30', 'Batavia', '1778-01-15', '1778-01-31', true, '1778-05-11', 'Texel', 4228, NULL);
INSERT INTO "voyages" VALUES (7997, '', 2, '', 'VRIJHEID', 'Jan Abel', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1777-10-30', 'Batavia', '1778-01-15', '1778-02-13', true, '1778-05-22', 'Texel', 4253, '4 of the 5 passengers were condemned persons. According to K.A. 4390a Cristiaan Frederik Winterheim was master of the VRIJHEID.');
INSERT INTO "voyages" VALUES (7998, '', 4, '', 'COMPAGNIES WELVAREN', 'Dirk Schoon', 1150, NULL, '1764', NULL, NULL, 'A', 'A', '1777-10-30', 'Batavia', '1778-01-11', '1778-02-13', true, '1778-05-21', 'Texel', 4267, NULL);
INSERT INTO "voyages" VALUES (7999, '', 1, '', 'WILLEM FREDERIK', 'Willem Silvester', 1150, NULL, '1773', NULL, NULL, 'Z', 'Z', '1777-10-30', 'Batavia', '1778-01-16', '1778-03-04', true, '1778-06-05', 'Rammekens', 4261, 'passengers included one female slave.');
INSERT INTO "voyages" VALUES (8000, '', 2, '', 'BREDENHOF', 'Leendert van Koopstad', 850, NULL, '1771', NULL, NULL, 'H', 'H', '1777-11-06', 'Batavia', '1778-01-13', '1778-04-03', true, '1778-07-13', 'Texel', 4270, 'The 5 passengers included one condemned person and 2 slaves (one male and one female).');
INSERT INTO "voyages" VALUES (8001, '', 3, '', 'HOOLWERF', 'Isaak Louis de Bellon', 850, NULL, '1769', NULL, NULL, 'H', 'E', '1777-11-10', 'Batavia', '1778-02-07', '1778-03-04', true, '1778-06-05', 'Texel', 4241, NULL);
INSERT INTO "voyages" VALUES (8002, '', 3, '', 'OUWERKERK', 'Johan Splinter Stavorinus', 1150, NULL, '1768', NULL, NULL, 'Z', 'Z', '1777-11-18', 'Batavia', '1778-03-05', '1778-04-03', true, '1778-07-22', 'Rammekens', 4196, 'The 5 passengers included one condemned person and a slave.');
INSERT INTO "voyages" VALUES (8003, '', 2, '', 'JUNO', 'Willem Dona', 850, NULL, '1771', NULL, NULL, 'R', 'Z', '1777-11-21', 'Bengal', '1778-01-29', '1778-03-04', true, '1778-06-05', 'Rammekens', 4234, NULL);
INSERT INTO "voyages" VALUES (8004, '', 2, '', 'MARS', 'Pieter Bezaan', 1150, NULL, '1771', NULL, NULL, 'Z', 'A', '1777-11-21', 'Ceylon', '1778-01-29', '1778-03-04', true, '1778-06-05', 'Texel', 4264, NULL);
INSERT INTO "voyages" VALUES (8005, '', 3, '', 'MERCUUR', 'Kornelis Bos', 850, NULL, '1770', NULL, NULL, 'D', 'A', '1777-11-21', 'Bengal', '1778-01-24', '1778-03-04', true, '1778-06-05', 'Texel', 4287, NULL);
INSERT INTO "voyages" VALUES (8006, '', 1, '', 'VROUWE JOHANNA MARGARETHA', 'Jan Meindertsz. Swaal', 850, NULL, '1774', NULL, NULL, 'E', 'A', '1777-11-26', 'Batavia', '1778-02-01', '1778-03-04', true, '1778-06-05', 'Texel', 4284, 'The 6 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (8007, '', 1, '', 'GANGES', 'Wopke Popta', 1150, NULL, '1775', NULL, NULL, 'A', 'Z', '1777-12-20', 'China', '1778-03-13', '1778-04-03', true, '1778-07-22', 'Rammekens', 4282, NULL);
INSERT INTO "voyages" VALUES (8008, '', 1, '', 'ZEEPAARD', 'Jan Och', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1777-12-20', 'China', '1778-03-14', '1778-04-03', true, '1778-07-13', 'Texel', 4273, NULL);
INSERT INTO "voyages" VALUES (8009, '', 2, '', 'HOOGKARSPEL', 'Olke Hendrik Andringa', 850, NULL, '1771', NULL, NULL, 'E', 'E', '1778-01-24', 'Bengal', '1778-03-25', '1778-04-03', true, '1778-07-13', 'Texel', 4271, NULL);
INSERT INTO "voyages" VALUES (8010, '', 1, '', 'KANAAN', 'Willem Koelbier', 850, NULL, '1775', NULL, NULL, 'R', 'R', '1778-02-06', 'China', '1778-04-29', '1778-05-15', true, '1778-09-24', 'Goeree', 4278, NULL);
INSERT INTO "voyages" VALUES (8011, '', 5, '', '''T LOO', 'Stoffel Kok', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1778-02-06', 'Ceylon', '1778-04-26', '1778-05-15', true, '1778-10-01', 'Texel', 4288, NULL);
INSERT INTO "voyages" VALUES (8012, '', 1, '', 'OVERDUIN', 'Jan Kornelis Roos', 1150, NULL, '1774', NULL, NULL, 'Z', 'A', '1778-02-06', 'China', '1778-04-29', '1778-05-15', true, '1778-10-01', 'Texel', 4281, NULL);
INSERT INTO "voyages" VALUES (8013, '', 5, '', 'WILLEM DE VIJFDE', 'Justus van Gennep', 1150, NULL, '1766', NULL, NULL, 'Z', 'Z', '1778-02-06', 'Ceylon', '1778-04-28', '1778-05-15', true, '1778-10-01', 'Rammekens', 4289, NULL);
INSERT INTO "voyages" VALUES (8014, '', 1, '', 'VENUS', 'Gerrit ten Sunder', 850, NULL, '1771', NULL, NULL, 'A', 'A', '1778-02-08', 'Batavia', '1780-01-12', '1780-03-12', true, '1780-06-30', 'Texel', 4184, 'Rio Delagoa; not earlier than 27-11-1779 it was able to continue the return voyage via the Cape to Texel. After the return in patria the VENUS was sold to Prussia, and its name was altered into OOSTEREEM, and subsequently the ship was hired by the VOC (see 4406/-).');
INSERT INTO "voyages" VALUES (8015, '', 1, '', 'EENDRACHT', 'Thomas de Beukelaar', 850, NULL, '1771', NULL, NULL, 'D', 'D', '1778-02-18', 'Batavia', NULL, NULL, true, NULL, NULL, 4177, 'The EENDRACHT was wrecked between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (8016, '', 3, '', 'HOOP', 'Theunis Hans Borch', 800, 'fluit', NULL, NULL, NULL, 'A', 'A', '1778-10-12', 'Batavia', '1778-12-27', '1779-04-16', true, '1779-08-01', 'Texel', 4244, NULL);
INSERT INTO "voyages" VALUES (8017, '', 2, '', 'PATRIOT', 'Hendrik Mulder', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1778-10-18', 'Coromandel', '1779-01-23', '1779-03-03', true, '1779-07-03', 'Texel', 4286, 'According to K.A. 4390a Herman Volkers was master of the PATRIOT.');
INSERT INTO "voyages" VALUES (8018, '', 1, '', 'BEHEMOTH', 'Hendrik Nieuwboer', 1150, NULL, '1775', NULL, NULL, 'A', 'A', '1778-10-25', 'Batavia', '1778-12-27', '1779-02-04', true, '1779-06-09', 'Texel', 4275, 'The master of the BEHEMOTH, Hendrik Nieuwboer, was commandeur of the return fleet.');
INSERT INTO "voyages" VALUES (8019, '', 2, '', 'JONGE HUGO', 'Andries Klein Jurriaansz.', 850, NULL, '1772', NULL, NULL, 'E', 'E', '1778-10-25', 'Batavia', '1778-12-27', '1779-02-04', true, '1779-06-09', 'Texel', 4308, 'The 3 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (8020, '', 2, '', 'INDIAAN', 'Christoffel Beem', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1778-10-25', 'Batavia', '1778-12-30', '1779-01-19', true, '1779-04-27', 'Texel', 4280, 'The 5 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (8021, '', 5, '', 'ZILVEREN LEEUW', 'Adriaan Frederik van de Graaf', 880, NULL, '1765', NULL, NULL, 'D', 'D', '1778-10-25', 'Batavia', '1778-12-27', '1779-02-04', true, '1779-06-12', 'Goeree', 4245, 'Two of the 3 passengers were slaves.');
INSERT INTO "voyages" VALUES (8022, '', 5, '', 'RITTHEM', 'Kornelis Kornelissen', 880, NULL, '1764', NULL, NULL, 'Z', 'R', '1778-10-25', 'Batavia', '1779-01-03', '1779-02-04', true, '1779-06-09', 'Goeree', 4300, NULL);
INSERT INTO "voyages" VALUES (8023, '', 1, '', 'ZEEDUIN', 'Hendrik Schreuder', 850, NULL, '1771', NULL, NULL, 'Z', 'Z', '1778-10-25', 'Batavia', '1779-01-03', '1779-02-04', true, '1779-06-09', 'Rammekens', 4166, 'According to K.A. 4390a Benjamin der Kinderen was master of the ZEEDUIN.');
INSERT INTO "voyages" VALUES (8024, '', 1, '', 'VRIENDSCHAP', 'Jakob van den Berg', 850, NULL, '1774', NULL, NULL, 'D', 'H', '1778-10-29', 'Batavia', '1779-01-03', '1779-02-04', true, '1779-06-09', 'Texel', 4277, NULL);
INSERT INTO "voyages" VALUES (8025, '', 3, '', 'GROENENDAAL', 'Hendrik Elders jr.', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1778-11-06', 'Batavia', '1779-03-03', '1779-04-16', true, '1779-07-27', 'Texel', 4243, NULL);
INSERT INTO "voyages" VALUES (8026, '', 5, '', 'WOESTDUIN', 'Gerrit Berg', 1150, NULL, '1767', NULL, NULL, 'A', 'Z', '1778-11-10', 'Batavia', NULL, NULL, false, NULL, NULL, 4293, 'between ''de Noorderrassen en Deurloo''.');
INSERT INTO "voyages" VALUES (8027, '', 2, '', 'AMSTERDAM', 'Swerus Vrolijk', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1778-11-19', 'Ceylon', '1779-01-30', '1779-03-03', true, '1779-07-03', 'Texel', 4312, NULL);
INSERT INTO "voyages" VALUES (8028, '', 5, '', 'BOVENKERKER POLDER', 'Klaas Roem', 850, NULL, '1765', NULL, NULL, 'A', 'A', '1778-11-25', 'Bengal', '1779-02-08', '1779-03-03', true, '1779-07-03', 'Texel', 4309, NULL);
INSERT INTO "voyages" VALUES (8029, '', 3, '', 'HUIS TE KROOSWIJK', 'Thijssen', 850, NULL, '1770', NULL, NULL, 'R', 'R', '1778-11-25', 'Bengal', '1779-02-07', '1779-03-03', true, '1779-06-10', 'Goeree', 4294, NULL);
INSERT INTO "voyages" VALUES (8030, '', 1, '', 'DOLFIJN', 'Jan Frederik Raatjes', 1150, NULL, '1776', NULL, NULL, 'A', 'A', '1778-12-28', 'China', '1779-04-14', '1779-04-27', true, '1779-08-01', 'Texel', 4298, NULL);
INSERT INTO "voyages" VALUES (8031, '', 1, '', 'ZEEUW', 'Jan Siereveld', 1150, NULL, '1774', NULL, NULL, 'Z', 'Z', '1778-12-29', 'China', '1779-04-10', '1779-04-27', true, '1779-07-31', 'Rammekens', 4304, NULL);
INSERT INTO "voyages" VALUES (8032, '', 5, '', 'RIDDERKERK', 'Johan Snijders', 850, NULL, '1766', NULL, NULL, 'D', 'E', '1779-01-23', 'Bengal', '1779-04-10', '1779-04-27', true, '1779-08-01', 'Texel', 4297, 'After the return in patria the RIDDERKERK was sold to Prussia. Its name was altered into AURICH, and subsequently the ship was hired by the VOC (see 4407/8095).');
INSERT INTO "voyages" VALUES (8033, '', 2, '', 'ABBEKERK', 'Kasper Burger', 850, NULL, '1772', NULL, NULL, 'H', 'H', '1779-01-29', 'China', '1779-05-26', '1779-06-24', true, NULL, NULL, 4305, 'The ABBERKERK was wrecked between the Cape and patria.');
INSERT INTO "voyages" VALUES (8034, '', 1, '', 'VREDENHOF', 'Reindert den Uil', 1150, NULL, '1776', NULL, NULL, 'A', 'A', '1779-01-29', 'China', '1779-05-24', '1779-06-24', true, NULL, NULL, 4307, 'The VREDENHOF was wrecked between the Cape and patria.');
INSERT INTO "voyages" VALUES (8035, '', 3, '', 'HERSTELDER', 'Axel Land', 600, 'fregat', NULL, '1772', NULL, 'C', 'A', '1779-02-04', 'The Cape', '1779-02-04', NULL, true, '1779-06-09', 'Texel', 4323, NULL);
INSERT INTO "voyages" VALUES (8036, '', 3, '', 'KATWIJK AAN DEN RIJN', 'Laurens de Sille', 750, 'hoeker', NULL, '1774', NULL, 'A', 'A', '1779-02-04', 'The Cape', '1779-02-04', NULL, true, '1779-06-09', 'Texel', 4314, NULL);
INSERT INTO "voyages" VALUES (8037, '', 3, '', 'ALKEMADE', 'Isaak de Vries', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1779-02-06', 'Batavia', '1779-07-02', '1780-02-17', true, '1780-06-19', 'Texel', 4251, 'Cape for the first time, five days later, however, it had to return; 17-02-1780 was its final date of departure from the Cape.');
INSERT INTO "voyages" VALUES (8038, '', 2, '', 'HOF TER LINDEN', 'Kornelis Brouwer', 1150, NULL, '1772', NULL, NULL, 'Z', 'Z', '1779-02-06', 'Batavia', '1779-05-26', '1779-06-24', true, '1779-09-27', 'Rammekens', 4315, 'According to K.A. 4390a Lambert Arnout Halfman was master of the HOF TER LINDEN.');
INSERT INTO "voyages" VALUES (8039, '', 3, '', 'CERES', 'Johan Alexander van Schkoppf', 1150, NULL, '1771', NULL, NULL, 'A', 'Z', '1779-02-19', 'Ceylon', '1779-05-15', '1779-05-17', true, '1779-07-14', 'Rammekens', 4310, 'According to K.A. 4390a Hendrik van Baggen was master of the CERES.');
INSERT INTO "voyages" VALUES (8040, '', 2, '', 'MORGENSTER', 'Gerrit Springer', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1779-02-19', 'Ceylon', '1779-04-12', '1779-05-26', true, '1779-09-10', 'Texel', 4291, NULL);
INSERT INTO "voyages" VALUES (8041, '', 2, '', 'HELD WOLTEMADE', 'Arend van der Deuren+', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1779-10-17', 'Coromandel', '1780-01-26', '1780-03-12', true, '1780-06-30', 'Texel', 4301, 'The master died on 01-12-1779.');
INSERT INTO "voyages" VALUES (8042, '', 1, '', 'HINDELOOPEN', 'Jan Tromp', 850, NULL, '1776', NULL, NULL, 'H', 'D', '1779-10-27', 'Batavia', '1779-12-31', '1780-02-17', true, '1780-06-09', 'Goeree', 4324, 'The 8 passengers included one female slave.');
INSERT INTO "voyages" VALUES (8043, '', 3, '', 'HOLLAND', 'Benjamin van der Spek', 1150, NULL, '1771', NULL, NULL, 'A', 'A', '1779-10-27', 'Batavia', '1780-01-12', '1780-02-17', true, '1780-06-09', 'Texel', 4316, 'The 7 passengers included one female slave.');
INSERT INTO "voyages" VALUES (8044, '', 2, '', 'MERENBERG', 'Herman Jakob Hulleman', 850, NULL, '1773', NULL, NULL, 'H', 'E', '1779-10-27', 'Batavia', '1780-01-12', '1780-01-25', true, '1780-04-17', 'Texel', 4339, 'The 6 passengers included one female slave.');
INSERT INTO "voyages" VALUES (8045, '', 2, '', 'MENTOR', 'Johan de Korte', 1150, NULL, '1774', NULL, NULL, 'A', NULL, '1779-10-27', 'Batavia', NULL, NULL, true, NULL, NULL, 4303, 'On 05-01-1780 the MENTOR ran on the reef off Cape Agulhas in a heavy storm and was wrecked.');
INSERT INTO "voyages" VALUES (8046, '', 1, '', 'STAVENISSE', 'Pieter Kardon', 1150, NULL, '1772', NULL, NULL, 'Z', 'Z', '1779-10-27', 'Batavia', '1780-01-12', '1780-02-17', true, '1780-06-06', 'Rammekens', 4208, NULL);
INSERT INTO "voyages" VALUES (8047, '', 4, '', 'BLEIJENBURG', 'Pieter van Prooien', 880, NULL, '1765', NULL, NULL, 'R', 'R', '1779-12-02', 'Bengal', '1780-02-03', '1780-02-17', true, '1780-05-24', 'Goeree', 4326, NULL);
INSERT INTO "voyages" VALUES (8048, '', 4, '', 'MERCUUR', 'Daniel Deune', 850, NULL, '1770', NULL, NULL, 'D', 'A', '1779-12-02', 'Bengal', '1780-02-03', '1780-02-17', true, '1780-06-09', 'Texel', 4335, NULL);
INSERT INTO "voyages" VALUES (8049, '', 2, '', 'BLOK', 'Jakob de Lange', 1150, NULL, '1774', NULL, NULL, 'A', 'Z', '1779-12-17', 'China', '1780-03-20', '1170-04-08', true, '1780-07-25', 'Rammekens', 4327, 'the VOC (see 4408/8101).');
INSERT INTO "voyages" VALUES (8050, '', 1, '', 'ZEEPLOEG', 'Jan Stil', 1150, NULL, '1777', NULL, NULL, 'A', 'A', '1779-12-17', 'China', NULL, NULL, true, NULL, NULL, 4338, 'Sailing between China and the Cape the ZEEPLOEG was wrecked.');
INSERT INTO "voyages" VALUES (8051, '', 4, '', 'PRINSES VAN ORANJE', 'Jan Frederik Volmer', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1780-01-13', 'Ceylon', '1780-03-13', '1780-04-08', true, '1780-07-26', 'Texel', 4317, NULL);
INSERT INTO "voyages" VALUES (8052, '', 1, '', 'JAVA', 'Jan Meindertsz. Swaal', 850, NULL, '1775', NULL, NULL, 'E', 'E', '1780-01-18', 'China', '1780-03-23', '1780-04-08', true, '1780-07-24', 'Texel', 4332, NULL);
INSERT INTO "voyages" VALUES (8053, '', 3, '', 'VOORBERG', 'Johan van Voorst', 1150, NULL, '1770', NULL, NULL, 'A', 'A', '1780-01-18', 'China', '1780-03-24', '1780-04-08', true, '1780-07-25', 'Texel', 4336, NULL);
INSERT INTO "voyages" VALUES (8054, '', 3, '', 'LAM', 'Jan Everwijk Drillinger', 850, NULL, '1769', NULL, NULL, 'D', 'Z', '1780-01-21', 'Bengal', '1780-04-08', '1780-04-30', true, '1780-09-02', 'Rammekens', 4325, NULL);
INSERT INTO "voyages" VALUES (8055, '', 1, '', 'VROUWE EVERHARDINA', 'Segon', 850, NULL, '1776', NULL, NULL, 'D', 'Z', '1780-01-26', 'Batavia', '1780-04-21', '1780-06-09', true, '1780-10-02', 'Rammekens', 4313, '09-06-1780 was the second and final date of departure from the Cape; an earlier attempt to set out had failed.');
INSERT INTO "voyages" VALUES (8056, '', 2, '', 'ZEEPAARD', 'Jan Willem Nieder', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1780-01-26', 'Batavia', '1780-04-09', '1780-04-30', true, '1780-08-31', 'Texel', 4337, NULL);
INSERT INTO "voyages" VALUES (8057, '', 6, '', 'HUIS OM', 'Willem Udemans jr.', 1150, NULL, '1761', NULL, NULL, 'Z', 'Z', '1780-02-09', 'Ceylon', '1780-04-05', '1780-04-30', true, '1780-09-11', 'Rammekens', 4342, NULL);
INSERT INTO "voyages" VALUES (8058, '', 2, '', 'GANGES', 'Hillert Volkers', 1150, NULL, '1775', NULL, NULL, 'A', 'A', '1780-02-23', 'Ceylon', '1780-05-19', '1780-06-09', true, '1780-10-06', 'Texel', 4341, NULL);
INSERT INTO "voyages" VALUES (8059, '', 3, '', 'HERSTELDER', 'Frederik Godert Wever', 600, 'fregat', NULL, '1772', NULL, 'C', 'A', '1780-03-12', 'The Cape', '1780-03-12', NULL, true, '1780-06-29', 'Texel', 4354, 'According to K.A. 4390a Abraham Tim was master of the HERSTELDER.');
INSERT INTO "voyages" VALUES (8060, '', 4, '', 'KATWIJK AAN DEN RIJN', 'Jan Jansz. Laurits', 750, 'hoeker', NULL, '1774', NULL, 'A', 'A', '1780-04-08', 'The Cape', '1780-04-08', NULL, true, '1780-07-24', 'Texel', 4355, NULL);
INSERT INTO "voyages" VALUES (8061, '', 2, '', 'TRITON', 'Gottlieb Mulder', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1780-10-09', 'Coromandel', '1781-01-08', '1781-02-22', true, '1782-11-11', 'Texel', 4311, 'The TRITON called at Trondheim; arrival on 04-07-1781.');
INSERT INTO "voyages" VALUES (8062, '', 5, '', 'ANTHOINETTA KOENRARDINA', 'Kornelis Philippus Hoek', 880, NULL, '1765', NULL, NULL, 'D', 'H', '1780-11-01', 'Batavia', '1781-01-17', '1781-01-31', true, '1781-04-27', 'Cadiz', 4348, 'In April, 1781 the VROUWE ANTHOINETTA KOEN-RARDINA was sold to S. Berard at Marseille. Commandeur of the return fleet was Kornelis Kornelissen, master of the BEHEMOTH (8063).');
INSERT INTO "voyages" VALUES (8063, '', 2, '', 'BEHEMOTH', 'Kornelis Kornelissen', 1150, NULL, '1775', NULL, NULL, 'A', 'A', '1780-11-01', 'Batavia', '1781-02-17', '1781-03-03', true, '1781-06-08', 'Cadiz', 4357, 'The master of the BEHEMOTH, Kornelis Kornelissen, was Commandeur of the return fleet. At Marseille the ship was sold to S. Berard.');
INSERT INTO "voyages" VALUES (8064, '', 1, '', 'CONCORDIA', 'Evert Wesseling', 1150, NULL, '1773', NULL, NULL, 'Z', 'A', '1780-11-01', 'Batavia', '1781-02-10', '1781-03-03', true, NULL, NULL, 4269, 'The 13 passengers included 4 slaves. On 24-05-1781 the CONCORDIA was sunk by an English privateer off the Azores.');
INSERT INTO "voyages" VALUES (8065, '', 5, '', 'OUD HAARLEM', 'Arie Kikkert', 1150, NULL, '1768', NULL, NULL, 'A', 'Z', '1780-11-01', 'Batavia', '1781-01-17', '1781-02-22', true, '1782-11-14', 'Rammekens', 4351, 'passengers included one slave. The OUD HAARLEM called at Trondheim; arrival on 04-07-1781.');
INSERT INTO "voyages" VALUES (8066, '', 6, '', 'VREEBURG', 'Adriaan van Katersveld', 850, NULL, '1764', NULL, NULL, 'D', 'D', '1780-11-01', 'Batavia', '1781-02-19', '1781-03-03', true, '1781-06-08', 'Cadiz', 4319, 'was sold to S. Berard.');
INSERT INTO "voyages" VALUES (8067, '', 3, '', 'BEEKVLIET', 'N.Ketel Jakobsz.', 850, NULL, '1770', NULL, NULL, 'A', 'Z', '1780-11-12', 'Batavia', '1781-02-06', '1781-03-03', true, '1781-06-08', 'Cadiz', 4362, 'The 9 passengers included one slave. At Marseille the BEEKVLIET was sold to S. Berard.');
INSERT INTO "voyages" VALUES (8068, '', 6, '', '''T LOO', 'Jan van der Sloot', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1780-11-20', 'Ceylon', '1781-01-17', '1781-02-22', true, '1782-11-14', 'Texel', 4353, 'The ''T LOO called at Trondheim; arrival on 04-07-1781. At the arrival at Texel, Jan Frederik Zegert probably was master.');
INSERT INTO "voyages" VALUES (8069, '', 2, '', 'DIANA', 'Pierre Frederik Riebe', 850, NULL, '1774', NULL, NULL, 'R', 'A', '1780-12-01', 'Bengal', '1781-02-14', '1781-03-03', true, '1781-06-08', 'Cadiz', 4343, 'At Marseille the DIANA was sold to S. Berard.');
INSERT INTO "voyages" VALUES (8070, '', 4, '', 'POPKENSBURG', 'Jochem Bank', 880, NULL, '1763', NULL, NULL, 'Z', 'H', '1780-12-01', 'Bengal', '1781-02-10', '1781-03-03', true, '1781-06-08', 'Cadiz', 4361, 'At Marseille the POPKENSBURG was sold to S. Berard.');
INSERT INTO "voyages" VALUES (8071, '', 4, '', 'HONKOOP', NULL, 1150, NULL, '1770', NULL, NULL, 'A', 'Z', '1781-01-15', 'China', '1781-03-31', '1781-06-13', true, NULL, NULL, 4321, 'the HONKOOP was taken by the English in Saldanha Bay. See also the SENHOR DE BONFIM E SANCTA MARIA (8083).');
INSERT INTO "voyages" VALUES (8072, '', 3, '', 'HOOGKARSPEL', NULL, 850, NULL, '1771', NULL, NULL, 'E', 'D', '1781-01-15', 'China', '1781-03-31', '1781-05-13', true, NULL, NULL, 4352, 'On 21-07-1781 the HOOGKARSPEL was captured by the English in Saldanha Bay. See also the SENHOR DE BONFIM E SANCTA MARIA (8083).');
INSERT INTO "voyages" VALUES (8073, '', 1, '', 'MIDDELBURG', 'Justus van Gennep', 1150, NULL, '1775', NULL, NULL, 'Z', 'A', '1781-01-15', 'China', '1781-03-31', '1781-05-13', true, NULL, NULL, 4360, 'On 21-07-1781 the MIDDELBURG was burnt down in Saldanha Bay. See also the SENHOR DE BONFIM E SANCTA MARIA (8083).');
INSERT INTO "voyages" VALUES (8074, '', 1, '', 'PAREL', NULL, 1150, NULL, '1778', NULL, NULL, 'A', 'A', '1781-01-15', 'China', '1781-04-01', '1781-05-13', true, NULL, NULL, 4359, 'by the English in Saldanha Bay. See also the SENHOR DE BONFIM E SANCTA MARIA (8083).');
INSERT INTO "voyages" VALUES (8075, '', 2, '', 'DANKBAARHEID', 'Hendrik Steedsel', 850, NULL, '1772', NULL, NULL, 'R', 'R', '1781-01-20', 'Bengal', '1781-04-25', '1781-05-13', true, NULL, NULL, 4265, 'On 21-07-1781 the DANKBAARHEID was taken by the English in Saldanha Bay.');
INSERT INTO "voyages" VALUES (8076, '', 3, '', 'AMSTERDAM', 'Jan Willem Mekau', 1150, NULL, '1772', NULL, NULL, 'A', 'Z', '1781-02-13', 'Ceylon', '1781-05-03', '1781-05-17', true, NULL, NULL, 4366, 'On 17-05-1781 the Company''s authorities at the Cape sent the AMSTERDAM to Mauritius to assist the French; three and a half weeks later the ship returned to the Cape, 10-08-1781. Early in 1784 the AMSTERDAM was laid up at the Cape.');
INSERT INTO "voyages" VALUES (8077, '', 2, '', 'BATAVIA', 'Bartholomeus Veau', 850, NULL, '1773', NULL, NULL, 'E', 'R', '1781-02-15', 'Batavia', '1781-05-04', '1781-05-17', true, NULL, NULL, 4368, 'On 17-05-1781 the BATAVIA departed from the Cape to sail to Mauritius. The ship was severely damaged during a storm, and had to return to the Cape, 10-08-1781. Early in 1783 the BATAVIA was sold to the French.');
INSERT INTO "voyages" VALUES (8078, '', 3, '', 'INDIAAN', 'Gerrit Opdal', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1781-02-15', 'Batavia', '1781-05-28', '1781-06-01', true, NULL, NULL, 4358, 'In June, 1781, the INDIAAN sailed to the Hout Bay. Later on the ship departed from the Cape to sail to Mauritius, but it was missing since.');
INSERT INTO "voyages" VALUES (8079, '', 3, '', 'NOORDBEEK', NULL, 850, 'fluit', NULL, '1773', NULL, 'Z', 'Z', '1781-02-22', 'The Cape', '1781-02-22', NULL, true, NULL, NULL, 4322, 'On 26-06-1781 the NOORDBEEK was captured by the English and taken to Plymouth.');
INSERT INTO "voyages" VALUES (8080, '', 4, '', 'GROENENDAAL', NULL, 1150, NULL, '1770', NULL, NULL, 'A', NULL, '1781-05-01', 'Batavia', NULL, NULL, true, NULL, NULL, 4372, 'Sailing to patria the GROENENDAAL was seized by the English, probably in 1782.');
INSERT INTO "voyages" VALUES (8081, '', 2, '', 'HUTS TE SPIJK', 'Christiaan van Veerden', 1150, NULL, '1773', NULL, NULL, 'A', 'A', '1782-03-14', 'Ceylon', '1782-07-14', NULL, true, NULL, NULL, 4292, '03-09-1782; arrival at the Cape on 06-09-1782. The ship never returned to patria. In 1784 it made at least one voyage to Mauritius and back to the Cape. Eventually the HUIS TE SPIJK was laid up there, in 1786.');
INSERT INTO "voyages" VALUES (8082, '', 1, '', 'ZWALUW', 'Jan Jansz. Laurits', NULL, 'logger', NULL, NULL, NULL, NULL, NULL, '1782-04-20', 'The Cape', '1782-04-20', NULL, true, '1782-06-01', 'Lorient', 4391, NULL);
INSERT INTO "voyages" VALUES (8083, '', 1, '', 'SENHOR DE BONFIM E SANCTA MARIA', 'Philippo Nery da Silva', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1782-05-28', 'The Cape', '1782-05-28', NULL, true, NULL, NULL, NULL, 'flew the Portuguese flag. The ship had arrived at the Cape on 12-04-1782. There it was contracted by the V.O.C. According to K.A. 4276, fol. 373 the ship had to sail to Lisbon or to Amsterdam. Its cargo consisted of China tea, carried to the Cape by the HONKOOP (8071), the HOOGKARSPEL (8072), the MIDDELBURG (8073), and the PAREL (8074); in July, 1781, these ships had been captured or burnt down by the English in Saldanha Bay.');
INSERT INTO "voyages" VALUES (8084, '', 1, '', 'L''ACTIVE', NULL, 250, NULL, NULL, NULL, NULL, NULL, 'A', '1783-01-01', 'The Cape', '1783-01-01', NULL, true, '1783-08-03', 'Texel', NULL, NULL);
INSERT INTO "voyages" VALUES (8085, '', 1, '', 'L''ANGELIQUE BENECH', 'De Strale', 250, NULL, NULL, NULL, NULL, NULL, 'A', '1783-03-30', 'The Cape', '1783-03-30', NULL, true, '1783-08-03', 'Texel', 4401, 'The ANGELIQUE BENECH flew the Imperial (i.e. Austrian) flag. According to K.A. 4287 the ship was bound for Lorient.');
INSERT INTO "voyages" VALUES (8086, '', 1, '', 'KROONPRINS VAN PRUISEN', 'Dirk Huizing', 760, NULL, NULL, NULL, NULL, NULL, 'A', '1783-04-12', 'The Cape', '1783-04-12', NULL, true, '1783-08-03', 'Texel', 4404, 'The KROONPRINS VAN PRUISEN flew the Prussian flag.');
INSERT INTO "voyages" VALUES (8087, '', 1, '', 'BERLIN', 'Arie van der Giessen', 898, 'fluit', NULL, NULL, NULL, 'D', 'A', '1783-08-27', 'Batavia', '1783-11-11', '1783-12-23', true, '1784-04-11', 'Texel', 4400, 'The BERLIN flew the Prussian flag. After the return of the ship to patria its name was altered into DORDRECHT (4458/8148).');
INSERT INTO "voyages" VALUES (8088, '', 1, '', 'FRIEDRICH DER GROSSE', 'Simon Koter', 678, NULL, NULL, NULL, NULL, NULL, 'A', '1783-08-27', 'Batavia', '1783-10-29', '1783-12-23', true, '1784-04-08', 'Texel', 4403, 'The FRIEDRICH DER GROSSE flew the Prussian flag.');
INSERT INTO "voyages" VALUES (8089, '', 1, '', 'MAGDEBURG', 'Jan Nieuwenhuis', NULL, NULL, NULL, NULL, NULL, NULL, 'A', '1783-10-16', 'Batavia', '1783-12-17', '1783-12-28', true, '1784-04-25', 'Texel', 4412, 'The MAGDEBURG flew the Prussian flag.');
INSERT INTO "voyages" VALUES (8090, '', 1, '', 'FACTOR', 'Jan Jochem Milfaart', 320, NULL, NULL, NULL, NULL, NULL, 'Z', '1783-10-28', 'The Cape', '1783-10-28', NULL, true, '1784-01-18', 'Rammekens', 4416, NULL);
INSERT INTO "voyages" VALUES (8091, '', 1, '', 'SLOT TER HOGE', 'Lambert Arnout Hallman', 1150, NULL, '1776', NULL, NULL, 'Z', 'Z', '1783-11-06', 'Batavia', '1784-02-02', '1784-03-20', true, '1784-06-16', 'Rammekens', 4381, 'The 144 men, who departed from Batavia, included one passenger. A mutiny was suppressed between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (8092, '', 1, '', 'SCHOONDERLOO', 'Jakob van den Berg', 880, NULL, '1779', NULL, NULL, 'D', 'D', '1783-11-06', 'Batavia', '1784-01-30', '1784-02-20', true, '1784-06-17', 'Goeree', 4396, NULL);
INSERT INTO "voyages" VALUES (8093, '', 3, '', 'ZEEPAARD', 'Pieter Thijssen jr.', 1150, NULL, '1774', NULL, NULL, 'A', 'A', '1783-11-06', 'Batavia', '1784-02-03', '1784-03-20', true, '1784-06-16', 'Texel', 4398, NULL);
INSERT INTO "voyages" VALUES (8094, '', 1, '', 'DOLFIJN', 'Honore Roux', 397, NULL, NULL, NULL, NULL, NULL, 'A', '1783-11-11', 'Ceylon', '1784-02-04', '1784-03-09', true, '1784-05-31', 'Texel', 4405, 'The DOLFIJN flew the Imperial (i.e. Austrian) flag.');
INSERT INTO "voyages" VALUES (8095, '', 6, '', 'AURICH', 'Pieter Modderman', 850, NULL, NULL, NULL, '1766', 'R', 'E', '1783-11-17', 'Batavia', '1784-02-02', '1784-03-20', true, '1784-06-16', 'Texel', 4407, 'The AURICH flew the Prussian flag. 4407/8095 was the sixth voyage of this ship, which during its preceding voyages was called RIDDERKERK (4297/8032). After the return to patria the ship was renamed RIDDERKERK (4493/-).');
INSERT INTO "voyages" VALUES (8096, '', 2, '', 'JAVA', 'Jan Tromp', 850, NULL, '1775', NULL, NULL, 'E', 'A', '1783-11-17', 'Batavia', '1784-02-17', '1784-03-20', true, '1784-06-16', 'Texel', 4395, 'A mutiny was suppressed between Batavia and the Cape.');
INSERT INTO "voyages" VALUES (8097, '', 4, '', 'HOOP', 'Sijbrand Sax', 800, 'fluit', NULL, NULL, NULL, 'A', 'A', '1783-12-15', 'Batavia', '1784-06-01', NULL, true, NULL, NULL, 4379, 'On 30-06-1784 the HOOP went to pieces off the Cape.');
INSERT INTO "voyages" VALUES (8098, '', 1, '', 'LES DEUX SOEURS', 'Oyer', 582, NULL, NULL, '1781', NULL, 'B', 'Z', '1784-01-15', 'Mauritius', '1784-02-17', '1784-03-20', true, '1784-05-20', 'Rammekens', 4409, 'After the return of the ship to patria its name was altered into TWEE GEZUSTERS (4502/8175).');
INSERT INTO "voyages" VALUES (8099, '', 1, '', 'POTSDAM', 'Bernard Christiaan Muller', 1150, NULL, NULL, NULL, '1780', 'A', 'A', '1784-01-20', 'China', '1784-04-07', '1784-04-26', true, '1784-07-18', 'Texel', 4410, 'The POTSDAM flew the Prussian flag. After the return of the ship to patria its name was altered into SPARENRIJK (4474/8262).');
INSERT INTO "voyages" VALUES (8100, '', 1, '', 'UHARMONIE', NULL, 650, NULL, NULL, NULL, NULL, NULL, 'D', '1784-01-31', 'The Cape', '1784-01-31', NULL, true, '1784-05-06', 'Goeree', 4418, 'L''HARMONIE flew the French flag.');
INSERT INTO "voyages" VALUES (8101, '', 3, '', 'BRESLAU', 'Jan Kornelis Roos', 1150, NULL, NULL, NULL, '1774', 'A', 'Z', '1784-02-02', 'China', '1784-06-02', '1784-07-14', true, NULL, NULL, 4408, '(4327/8049). See also the GANGES (8106).');
INSERT INTO "voyages" VALUES (8102, '', 6, '', 'WILLEM DE VIJFDE', 'Pieter Kardon', 1150, NULL, '1765', NULL, NULL, 'Z', 'Z', '1784-02-08', 'Ceylon', '1784-04-08', '1784-04-26', true, '1784-08-16', 'Rammekens', 4413, NULL);
INSERT INTO "voyages" VALUES (8103, '', 1, '', 'GERECHTIGHEID', 'Johan Frederik Schuts', 1150, NULL, '1779', NULL, NULL, 'A', 'A', '1784-02-09', 'Batavia', '1784-04-15', NULL, true, '1784-08-16', 'Texel', 4411, 'The date of departure from the Cape is unknown.');
INSERT INTO "voyages" VALUES (8104, '', 4, '', 'VOORBERG', 'Abraham Tim', 1150, NULL, '1770', NULL, NULL, 'A', 'E', '1784-02-17', 'Batavia', '1784-05-28', '1784-07-14', true, '1784-11-17', 'Texel', 4397, 'The 119 man, who departed from Batavia, included one passenger. See also the GANGES (8106).');
INSERT INTO "voyages" VALUES (8105, '', 4, '', 'HOLLAND', 'Isaak de Vries', 1150, NULL, '1771', NULL, NULL, 'A', 'H', '1784-02-22', 'Batavia', '1784-05-27', '1784-07-14', true, '1784-11-16', 'Texel', 4394, 'See also the GANGES (8106).');
INSERT INTO "voyages" VALUES (8106, '', 3, '', 'GANGES', 'Jan Paardekoper', 1150, NULL, '1775', NULL, NULL, 'A', 'Z', '1784-02-26', 'Batavia', '1784-06-02', '1784-07-14', true, '1784-11-18', 'Rammekens', 4393, 'The 105 men, who departed from Batavia, included three passengers. Jan Paardekoper, the master of the GANGES, was commandeur of the ships. which sailed from the Cape on 14-07-1784.');
INSERT INTO "voyages" VALUES (8107, '', 1, '', 'PRINZ HEINRICH', 'Laurens Smit', 846, 'fluit', NULL, NULL, NULL, NULL, 'A', '1784-03-07', 'Batavia', '1784-06-09', '1784-08-01', true, '1784-11-27', 'Texel', 4414, 'call at the Cape, but at False Bay. From there it originally departed on 25-07-1784, the next day it returned, however.');
INSERT INTO "voyages" VALUES (8108, '', 3, '', 'MORGENSTER', 'Gerrit Berg', 1150, NULL, '1772', NULL, NULL, 'A', 'A', '1784-03-10', 'Ceylon', '1784-06-02', '1784-07-14', true, '1784-11-17', 'Texel', 4371, 'See also the GANGES (8106). On 29-10-1785 the Heren XV11 decided to lay the MORGENSTER up.');
INSERT INTO "voyages" VALUES (8109, '', 1, '', 'L''ESPERANCE DE LA PAIX', 'Joseph le Naux', 600, NULL, NULL, NULL, NULL, NULL, 'A', '1784-03-23', 'The Cape', '1784-03-23', NULL, true, '1784-06-22', 'Texel', 4421, 'L''ESPERANCE DE LA PAIX flew the French flag.');
INSERT INTO "voyages" VALUES (8110, '', 1, '', 'ROTTERDAMS WELVAREN', 'Kornelis de Wit', 880, NULL, '1780', NULL, NULL, 'R', 'R', '1784-03-30', 'Batavia', '1784-06-02', '1784-07-14', true, '1784-11-15', 'Goeree', 4415, 'See also the GANGES (8106).');
INSERT INTO "voyages" VALUES (8111, '', 1, '', 'LA DAME JEANNE', 'Karel Alm', 400, NULL, NULL, NULL, NULL, NULL, 'Z', '1784-07-23', 'Batavia', '1784-10-30', '1784-12-22', true, '1785-05-05', 'Rammekens', NULL, 'LA DAME JEANNE flew the Swedish flag. In accordance with the conditions of the contract, signed in patria in March, 1783, by the owners of the ship and representatives of the V.O.C., the DAME JEANNE had sailed on its own account from Lorient in France (departure: 18-05-1783) via the Cape (08-10 till 02-11-1783) to Mauritius. There it had officially entered the Company''s service. On 19-05-1784 the ship arrived at Batavia.');
INSERT INTO "voyages" VALUES (8112, '', 1, '', 'LE CONCORDE', 'Klaas Breitholz', 400, NULL, NULL, NULL, NULL, NULL, 'A', '1784-07-25', 'Batavia', '1784-10-23', '1784-12-22', true, '1785-05-04', 'Texel', NULL, 'The CONCORDE flew the Swedish flag, see LA DAME JEANNE (8111). The CONCORDE had sailed on its own account from Lorient in France (departure: 13-04-1783) via the Cape (28-10 till 16-12-1783) to Mauritius. There it had officially entered the Company''s service. On 27-04-1784 the ship arrived at Batavia.');
INSERT INTO "voyages" VALUES (8113, '', 1, '', 'NOIR', 'Gottfried Dahl', 650, NULL, NULL, NULL, NULL, NULL, 'H', '1784-08-12', 'Batavia', '1784-10-23', '1784-12-22', true, '1785-05-02', 'Texel', NULL, 'L''AIGLE NOIR flew the Swedish flag, see LA DAME JEANNE (8111). The AIGLE NOIR had sailed on its own account from Lorient in France (departure: 19-05-1783) via the Cape (31-08 till 03-10-1783) to Mauritius. There it had officially entered the Company''s service. On 10-05-1784 the ship arrived at Batavia.');
INSERT INTO "voyages" VALUES (8114, '', 1, '', 'LA SAINTE THERESE', 'La Fayde de Branchere', NULL, NULL, NULL, NULL, NULL, NULL, 'E', '1784-09-03', 'Batavia', NULL, NULL, true, '1785-04-01', 'Texel', NULL, 'The SAINTE THERESE flew the French flag. The ship probably did not call at the Cape. See LA DAME JEANNE (8111). The SAINTE THERESE had sailed on its own account from Lorient in France (departure: 04-11-1783) via the Cape (arrival: 01-03-1784) to Mauritius. There it had officially entered the Company''s service. On 01-07-1784 the ship arrived at Batavia.');
INSERT INTO "voyages" VALUES (8115, '', 1, '', 'L''EMPEREUR ET ROI', 'Franc Odievre', 760, NULL, NULL, NULL, NULL, NULL, 'R', '1784-09-04', 'Batavia', '1784-10-29', '1784-12-22', true, '1785-04-19', 'Goeree', NULL, '(departure: 17-07-1783), probably without calling at the Cape, to Mauritius. There it had officially entered the Company''s service. On 29-06-1784 the ship arrived at Batavia.');
INSERT INTO "voyages" VALUES (8116, '', 1, '', 'L''ORION', 'Johan George Kinborg', 500, NULL, NULL, NULL, NULL, NULL, 'H', '1784-09-05', 'Batavia', '1785-01-13', '1785-02-09', true, '1785-06-07', 'Texel', NULL, 'till 02-11-1783) to Mauritius. There it had officially entered the Company''s service. On 30-06-1784 the ship arrived at Batavia.');
INSERT INTO "voyages" VALUES (8117, '', 1, '', 'LA COMPTESSE DU NORD', 'Le Vasnier', 840, NULL, NULL, NULL, NULL, NULL, 'D', '1784-09-16', 'Batavia', '1784-11-20', '1785-01-20', true, '1785-05-19', 'Goeree', NULL, 'it had officially entered the Company''s service. On 11-7-1784 the ship arrived at Batavia.');
INSERT INTO "voyages" VALUES (8118, '', 1, '', 'LE JEUNE STANISLAUS', 'Pieter Menard', 550, NULL, NULL, NULL, NULL, NULL, 'R', '1784-10-06', 'Batavia', '1785-02-22', '1785-04-12', true, '1785-07-11', 'Goeree', NULL, 'entered the Company''s service. On 02-07-1784 the ship arrived at Batavia.');
INSERT INTO "voyages" VALUES (8119, '', 1, '', 'DAPPERHEID', 'Kornelis de Boer', 472, 'hoeker', NULL, NULL, NULL, NULL, 'E', '1784-10-19', 'Batavia', '1785-01-13', '1785-02-13', true, '1785-05-25', 'Texel', 4434, NULL);
INSERT INTO "voyages" VALUES (8120, '', 3, '', 'MERENBERG', 'Jan Montagne', 850, NULL, '1773', NULL, NULL, 'H', 'E', '1784-10-28', 'Batavia', '1785-01-30', '1785-04-10', true, '1785-07-17', 'Texel', 4384, 'MERENBERG, the L00 (8121), the ROZENBURG (8122), the ONZEKERE (8130), the GOUVERNEUR-GENERAAL DE CLERCK (8133), the DRAAK (8134), and the JACHTRUST (8142) were escorted by a Dutch man of war.');
INSERT INTO "voyages" VALUES (8121, '', 7, '', 'LOO', 'Dirk Hulsebos', 1150, NULL, '1768', NULL, NULL, 'A', 'A', '1784-10-30', 'Batavia', '1785-01-10', '1785-04-10', true, '1785-07-17', 'Texel', 4437, 'See also the MERENBERG (8120).');
INSERT INTO "voyages" VALUES (8122, '', 1, '', 'ROZENBURG', 'Gerrit Bruin', 880, NULL, NULL, NULL, '1780', 'D', 'D', '1784-10-30', 'Batavia', '1785-01-22', '1785-04-10', true, '1785-07-22', 'Goeree', 4425, 'See also the MERENBERG (8120).');
INSERT INTO "voyages" VALUES (8123, '', 1, '', 'LE FABIUS', 'Pieter Kolom', NULL, NULL, NULL, NULL, NULL, NULL, 'D', '1784-11-04', 'Batavia', '1785-01-20', '1785-02-09', true, '1785-05-21', 'Goeree', NULL, 'Mauritius. There it had officially entered the Company''s service. On 05-08-1784 the ship arrived at Batavia.');
INSERT INTO "voyages" VALUES (8124, '', 1, '', 'HARMONIE', 'Kornelis Philippus Hoek', 1150, NULL, '1778', NULL, NULL, 'Z', 'A', '1784-11-06', 'Batavia', NULL, NULL, true, NULL, NULL, 4432, 'Sailing to the Cape the HARMONIE was wrecked. See also the MEEUWTJE (4477).');
INSERT INTO "voyages" VALUES (8125, '', 1, '', 'LA CONJUNCTURE', 'Pieter Arwidson', NULL, NULL, NULL, NULL, NULL, NULL, 'Z', '1784-11-10', 'Batavia', '1785-02-17', '1785-03-09', true, '1785-06-01', 'Rammekens', NULL, 'Swedish flag. See LA DAME JEANNE (8111). The CONJUNCTURE had sailed on its own account from Martinique (departure: 10-10-1783) via the Cape (arrival: 18-03-1784) to Mauritius. There it had officially entered the Company''s service. On 04-10-1784 the ship arrived at Batavia.');
INSERT INTO "voyages" VALUES (8126, '', 1, '', 'JONGE FRANK', 'Jakob Veer', 592, NULL, NULL, NULL, NULL, NULL, 'A', '1784-11-13', 'Batavia', '1785-01-11', '1785-02-14', true, '1785-05-21', 'Texel', 4436, NULL);
INSERT INTO "voyages" VALUES (8127, '', 2, '', 'OVERDUIN', 'Jan Jurgen Christiaan Meyer', 1150, NULL, '1774', NULL, NULL, 'Z', 'Z', '1784-11-18', 'Batavia', NULL, NULL, true, NULL, NULL, 4344, 'Sailing from Batavia to the Cape the OVERDUIN was wrecked. See also the MEEUWTJE (4477).');
INSERT INTO "voyages" VALUES (8128, '', 2, '', 'VREDE EN VRIJHEID', 'Dirk Huizing', 760, NULL, NULL, NULL, NULL, NULL, 'H', '1784-11-24', 'Batavia', '1785-01-29', '1785-02-12', true, '1785-06-03', 'Texel', 4441, NULL);
INSERT INTO "voyages" VALUES (8129, '', 1, '', 'LES SIX FRERES', 'Saulnier', NULL, NULL, NULL, NULL, NULL, NULL, 'A', '1784-11-29', 'Batavia', '1785-01-20', '1785-01-29', true, '1785-04-26', 'Texel', NULL, 'LES SIX FRERES new the French flag. See LA DAME JEANNE (8111). The SIX FRERES had sailed on its own account from Bordeaux (departure: 07-09-1783) via the Cape (arrival: 02-03-1784) to Mauritius. There the ship had officially entered the Company''s service. On 04-10-1784 the SIX FRERES arrived at Batavia.');
INSERT INTO "voyages" VALUES (8130, '', 1, '', 'ONZEKERE', 'Johan Staalkop', 348, NULL, NULL, NULL, NULL, NULL, 'Z', '1784-12-03', 'Batavia', '1785-03-12', '1785-04-10', true, '1785-07-22', 'Rammekens', 4430, 'See also the MERENBERG (8120).');
INSERT INTO "voyages" VALUES (8131, '', 1, '', 'HOORN', 'Isaak Thierens', 850, NULL, '1774', NULL, NULL, 'H', 'H', '1784-12-04', 'Batavia', '1785-04-04', '1785-05-16', true, '1785-09-23', 'Texel', 4283, 'Soon after the departure from Batavia the HOORN sprang a leak. The ship possibly had to return. According to K.A. 4289, fol. 464 the master was called Jan Thierens.');
INSERT INTO "voyages" VALUES (8132, '', 3, '', 'BREDENHOF', 'Pieter van der Weert', 850, NULL, '1771', NULL, NULL, 'H', 'R', '1784-12-08', 'Batavia', NULL, NULL, true, NULL, NULL, 4363, 'Sailing from Batavia to the Cape the BREDENHOF was wrecked.');
INSERT INTO "voyages" VALUES (8133, '', 1, '', 'GOUVERNEUR-GENERAAL DE CLERCK', 'Jochem Bank', 1150, NULL, '1779', NULL, NULL, 'Z', 'Z', '1784-12-28', 'China', '1785-03-23', '1785-04-10', true, '1785-07-24', 'Rammekens', 4430, 'See also the MERENBERG (8120).');
INSERT INTO "voyages" VALUES (8134, '', 1, '', 'DRAAK', 'Arie Kikkert', 1150, NULL, '1780', NULL, NULL, 'A', 'A', '1785-01-02', 'China', '1785-03-23', '1785-04-10', true, '1785-07-17', 'Texel', 4430, 'See also the MERENBERG (8120).');
INSERT INTO "voyages" VALUES (8135, '', 1, '', 'STRALEN', 'Willem de Wijn', 880, NULL, '1778', NULL, NULL, 'E', 'A', '1785-01-23', 'Bengal', '1785-04-17', '1785-05-16', true, '1785-09-23', 'Texel', 4427, 'On 13-04-1785 the STRALEN arrived at False Bay; four days later the ship sailed to the Cape.');
INSERT INTO "voyages" VALUES (8136, '', 1, '', 'BREDERODE', 'Gottlieb Mulder', 1150, NULL, '1780', NULL, NULL, 'A', 'A', '1785-01-27', 'China', NULL, NULL, true, NULL, NULL, 4424, 'On 04-05-1785 the BREDERODE sank off Cape Agulhas; 80 men were saved.');
INSERT INTO "voyages" VALUES (8137, '', 1, '', 'VROUWE WIJNANDA LUBERTA', 'Sijbrand Berk', 508, 'fregat', NULL, NULL, NULL, NULL, 'E', '1785-02-11', 'Batavia', '1785-05-10', '1785-06-07', true, '1785-09-03', 'Texel', 4445, NULL);
INSERT INTO "voyages" VALUES (8138, '', 1, '', 'BERKHOUT', 'Herman Jakob Hulleman', 1150, NULL, '1779', NULL, NULL, 'H', 'H', '1785-02-21', 'China', '1785-05-05', '1785-05-16', true, '1785-09-23', 'Texel', 4433, NULL);
INSERT INTO "voyages" VALUES (8139, '', 1, '', 'DOGGERSBANK', 'Swerus Vrolijk', 1150, NULL, '1782', NULL, NULL, 'A', 'A', '1785-02-21', 'Ceylon', '1785-05-05', '1785-05-16', true, '1785-09-23', 'Texel', 4435, NULL);
INSERT INTO "voyages" VALUES (8140, '', 3, '', 'TRITON', 'Hendrik Steedsel', 1150, NULL, '1773', NULL, NULL, 'A', 'Z', '1785-02-21', 'Ceylon', '1785-05-02', '1785-05-16', true, '1785-09-24', 'Rammekens', 4431, NULL);
INSERT INTO "voyages" VALUES (8141, '', 1, '', 'LE CASTRIES', 'Mareches', NULL, NULL, NULL, NULL, NULL, NULL, 'R', '1785-04-06', 'Batavia', '1786-02-03', '1786-03-07', true, '1786-06-26', 'Goeree', NULL, 'The CASTRIES flew the French flag. From 27-05- till 22-12-1785 the ship called at Mauritius. See LA DAME JEANNE (8111). The CASTRIES had sailed on its own account from Bordeaux (departure: 17-05-1783) via the Cape (30-12-1783 till 15-01-1784) to Mauritius. There it had officially entered the Company''s service. On 09-11-1784 the ship arrived at Batavia.');
INSERT INTO "voyages" VALUES (8142, '', 1, '', 'JACHTRUST', 'Pieter Andriessen', 450, 'fregat', NULL, '1775', NULL, 'A', 'A', '1785-04-10', 'The Cape', '1785-04-10', NULL, true, '1785-07-17', 'Texel', 4276, 'See also the MERENBERG (8120).');
INSERT INTO "voyages" VALUES (8143, '', 1, '', 'VREDE', 'Thijs Ketel', 854, 'fluit', NULL, NULL, NULL, NULL, 'A', '1785-04-29', 'The Cape', '1785-04-29', NULL, true, '1785-08-07', 'Texel', 4449, NULL);
INSERT INTO "voyages" VALUES (8144, '', 1, '', 'VRIJHEID', 'Jan Isaac', 790, 'fluit', NULL, NULL, NULL, NULL, 'R', '1785-05-17', 'Batavia', '1785-08-18', '1785-09-10', true, '1786-03-25', 'Goeree', 4446, NULL);
INSERT INTO "voyages" VALUES (8145, '', 1, '', 'LES QUATRES FRERES', 'Samuel Nusker', 620, 'fregat', NULL, NULL, NULL, NULL, 'A', '1785-05-22', 'Batavia', '1785-08-02', '1785-09-01', true, '1786-05-04', 'Texel', 4440, 'LES QUATRES FRERES flew the Prussian flag. The 51 men, who departed from Batavia, included two passengers.');
INSERT INTO "voyages" VALUES (8146, '', 1, '', 'LA RESOLUTION', '(BONNE) Andries Lundgren', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1785-08-04', 'Batavia', '1785-10-22', '1786-01-17', true, NULL, NULL, NULL, 'LA (BONNE) RESOLUTION flew the Swedish flag. The port of destination in patria and the date of arrival there are unknown. See LA DAME JEANNE (8111). The (BONNE) RES-OLUTION had sailed on its own account from a French Atlantic port via the Cape to Mauritius. There it had officially entered the Company''s service. From Mauritius the ship sailed on to Batavia.');
INSERT INTO "voyages" VALUES (8147, '', 1, '', 'EENSGEZINDHEID', 'Peter Jansen', 884, 'fluit', NULL, NULL, NULL, NULL, 'H', '1785-08-07', 'Batavia', '1785-10-17', '1785-11-27', true, '1786-05-04', 'Texel', 4450, NULL);
INSERT INTO "voyages" VALUES (8148, '', 2, '', 'DORDRECHT', 'Arie van der Giessen', 898, 'fluit', NULL, NULL, NULL, 'D', 'H', '1785-08-17', 'Batavia', '1785-10-10', '1785-12-27', true, '1786-04-14', 'Texel', 4458, '4458/8148 was the second voyage of this ship, which during the preceding voyage (4400/8087) was called BERLIN.');
INSERT INTO "voyages" VALUES (8149, '', 1, '', 'EIK EN LINDE', 'Dirk Carlberg', 574, 'hoeker', NULL, NULL, NULL, NULL, 'H', '1785-09-06', 'Batavia', '1785-11-20', '1785-12-27', true, '1786-04-30', 'Texel', 4451, 'According to K.A. 4293 Hendrik Holder was master of the EIK EN LINDE.');
INSERT INTO "voyages" VALUES (8150, '', 1, '', 'MENTOR', 'Jan Jochem Milfaart', 560, NULL, NULL, NULL, NULL, NULL, 'Z', '1785-10-13', 'Batavia', '1785-12-06', '1786-01-04', true, '1786-03-24', 'Rammekens', 4455, NULL);
INSERT INTO "voyages" VALUES (8151, '', 1, '', 'HOOP', 'Harme Karel Visser', 175, NULL, NULL, '1782', NULL, 'A', 'A', '1785-10-23', 'Batavia', '1786-01-21', '1786-02-23', true, '1786-06-27', 'Texel', 4467, 'At the departure from the Cape the HOOP was accompanied by a Dutch man-of-war.');
INSERT INTO "voyages" VALUES (8152, '', 1, '', 'ELISABETH ET SOPHIE', 'Massaut', 525, NULL, NULL, NULL, NULL, 'R', 'D', '1785-11-05', 'Batavia', '1786-01-06', '1786-02-10', true, '1786-05-24', 'Goeree', NULL, 'The ELISABETH ET SOPHIE flew the French flag. See LA DAME JEANNE (8111). The ELISABETH ET SOPHIE had sailed on its own account from Lorient in France (departure: 04-11-1783) via the Cape (05 till 26-04-1784) to Mauritius. There it had officially entered the Company''s service. From Mauritius the ship had sailed on to Batavia.');
INSERT INTO "voyages" VALUES (8153, '', 1, '', 'LE NEPTHUNE', 'Jacques Lourde Martignac', NULL, NULL, NULL, NULL, NULL, NULL, 'R', '1785-11-05', 'Batavia', '1786-01-07', '1786-03-11', true, '1786-06-02', 'Goeree', NULL, 'The NEPTHUNE flew the French flag. See LA DAME JEANNE (8111). The NEPTHUNE had sailed on its own account from a French Atlantic port via the Cape to Mauritius, where it had officially entered the Company''s service. From Mauritius the ship had sailed on to Batavia.');
INSERT INTO "voyages" VALUES (8154, '', 1, '', 'WILLEM EN JAN', 'Tijmen de Zweed', 356, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1785-11-16', 'Batavia', '1786-03-02', '1786-03-25', true, '1786-07-20', 'Texel', 4461, NULL);
INSERT INTO "voyages" VALUES (8155, '', 1, '', 'JONGE JAKOB', 'Asmus Pieter Asmus', 648, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1785-11-22', 'Batavia', '1786-02-06', '1786-02-23', true, '1786-05-27', 'Texel', 4462, 'The 31 people, who departed from Batavia, included two passengers.');
INSERT INTO "voyages" VALUES (8156, '', 1, '', 'VROUWE JOHANNA JAKOBA', 'Jan Hendrik van der Linden', 444, 'hoeker', NULL, NULL, NULL, NULL, 'H', '1785-11-25', 'Batavia', '1786-02-25', '1786-03-25', true, '1786-07-25', 'Texel', 4459, NULL);
INSERT INTO "voyages" VALUES (8157, '', 1, '', 'HUISDUINEN', 'Laurens Kornelissen', 723, NULL, NULL, '1784', NULL, 'A', 'A', '1785-11-26', 'Ceylon', '1786-01-30', '1786-02-23', true, '1786-06-23', 'Texel', 4471, NULL);
INSERT INTO "voyages" VALUES (8158, '', 1, '', 'VOORSCHOTEN', 'Kornelis Kornelissen', 1150, NULL, '1783', NULL, NULL, 'A', 'A', '1785-12-11', 'China', '1786-03-23', NULL, true, '1786-08-21', 'Texel', 4465, NULL);
INSERT INTO "voyages" VALUES (8159, '', 1, '', 'EIKENWOUD', 'Klaas Ent', 892, 'fluit', NULL, NULL, NULL, NULL, 'A', '1785-12-13', 'Batavia', '1786-04-02', NULL, true, '1786-07-21', 'Texel', 4452, 'After the return to Texel the ship was renamed MERENBERG (4556/8223).');
INSERT INTO "voyages" VALUES (8160, '', 1, '', 'VLUGGE TREKVOGEL', 'Barend Jansz. Uffen', 484, 'hoeker', NULL, NULL, NULL, NULL, 'E', '1785-12-21', 'Batavia', '1786-03-29', NULL, true, '1786-08-01', 'Texel', 4460, NULL);
INSERT INTO "voyages" VALUES (8161, '', 1, '', 'BARBESTEIN', 'Dirk Kornelis Plokker', 1150, NULL, '1783', NULL, NULL, 'A', 'Z', '1786-01-12', 'China', '1786-04-21', '1786-05-11', true, '1786-08-20', 'Rammekens', 4470, NULL);
INSERT INTO "voyages" VALUES (8162, '', 1, '', 'POLLUX', 'Lodewijk Kappelhof', 490, NULL, NULL, '1784', NULL, 'Z', 'A', '1786-01-19', 'China', '1786-04-26', '1786-05-11', true, '1786-08-21', 'Texel', 4469, NULL);
INSERT INTO "voyages" VALUES (8163, '', 1, '', 'CONSTANTIA', 'Adriaan van Katersveld', 880, NULL, '1782', NULL, NULL, 'D', 'D', '1786-01-22', 'Bengal', '1786-04-03', '1786-05-11', true, '1786-07-20', 'Goeree', 4457, NULL);
INSERT INTO "voyages" VALUES (8164, '', 2, '', 'HINDELOOPEN', 'Kornelis Lorein', 850, NULL, '1776', NULL, NULL, 'H', 'A', '1786-01-27', 'Bengal', '1786-04-07', '1786-05-11', true, '1786-08-21', 'Texel', 4420, NULL);
INSERT INTO "voyages" VALUES (8165, '', 1, '', 'AFRIKAAN', 'Pieter Moddetman', 880, NULL, '1780', NULL, NULL, 'E', 'E', '1786-01-28', 'China', '1786-05-26', '1786-07-08', true, '1787-08-27', 'Texel', 4478, 'From 25-11-1786 till 18-08-1787 the AFRIKAAN was at Crookhaven in Ireland.');
INSERT INTO "voyages" VALUES (8166, '', 2, '', 'STAVENISSE', 'Kornelis van Vlaanderen', 1150, NULL, '1772', NULL, NULL, 'Z', 'A', '1786-02-13', 'Ceylon', '1786-04-23', '1786-05-11', true, '1786-08-21', 'Texel', 4444, NULL);
INSERT INTO "voyages" VALUES (8167, '', 2, '', 'SLOT TER HOGE', 'Lodewijk Elgenhuizen', 1150, NULL, '1776', NULL, NULL, 'Z', 'Z', '1786-02-26', 'Ceylon', '1786-05-19', '1786-07-08', true, '1786-12-10', 'Rammekens', 4480, NULL);
INSERT INTO "voyages" VALUES (8168, '', 2, '', 'FACTOR', 'Jan Jochem Milfaart', 320, NULL, NULL, NULL, NULL, NULL, 'Z', '1786-03-24', 'Ceylon', NULL, NULL, false, '1786-09-01', 'Rammekens', 4487, NULL);
INSERT INTO "voyages" VALUES (8169, '', 1, '', 'JAN EN KORNELIS', 'Klaas Duif', 560, 'fluit', NULL, NULL, NULL, NULL, 'A', '1786-05-10', 'Batavia', '1786-08-20', '1786-09-16', true, '1787-01-04', 'Rammekens', 4484, 'Although the JAN EN CORNELIS sailed for the Chamber Amsterdam, it cast anchor at Rammekens.');
INSERT INTO "voyages" VALUES (8170, '', 1, '', 'GEERTRUIDA', 'Daniel Kunneman', 660, 'fluit', NULL, NULL, NULL, NULL, 'A', '1786-05-11', 'Batavia', '1786-08-27', '1786-09-25', true, '1787-03-11', 'Texel', 4488, NULL);
INSERT INTO "voyages" VALUES (8171, '', 1, '', 'JOSEPHUS DE TWEEDE', 'Christiaan Zummack', 460, NULL, NULL, NULL, NULL, NULL, 'Z', '1786-05-12', 'Batavia', '1786-08-04', '1786-09-09', true, '1786-12-04', 'Rammekens', 4489, NULL);
INSERT INTO "voyages" VALUES (8172, '', 1, '', 'OUDENAARDE', 'Hans Klaassen', 380, NULL, NULL, NULL, NULL, NULL, 'Z', '1786-06-21', 'Batavia', '1786-09-07', '1786-10-07', true, '1787-02-05', 'Rammekens', 4468, NULL);
INSERT INTO "voyages" VALUES (8173, '', 1, '', 'VROUWE JAKOBA MARIA LUCIA THERESIA', 'Dirk Peek', 429, 'hoeker', NULL, NULL, NULL, NULL, 'H', '1786-07-17', 'Batavia', '1786-10-01', '1786-11-21', true, '1787-02-20', 'Texel', 4492, NULL);
INSERT INTO "voyages" VALUES (8174, '', 1, '', 'RUNOORD', 'Laurens Smit', 846, 'fluit', NULL, NULL, NULL, NULL, 'H', '1786-09-14', 'Batavia', '1786-12-25', '1787-02-02', true, '1787-05-25', 'Texel', 4485, NULL);
INSERT INTO "voyages" VALUES (8175, '', 2, '', 'TWEE GEZUSTERS', 'Wouter Jakobsen', 582, NULL, NULL, '1781', NULL, 'Z', NULL, '1786-10-26', 'Batavia', '1787-01-24', '1787-02-16', true, '1787-05-24', 'Rammekens', 4502, '4502/8175 was the second voyage of this ship, which during the preceding voyage (4409/8098) was called LES DEUX SOEURS.');
INSERT INTO "voyages" VALUES (8188, '', 2, '', 'GOUVERNEUR-GENERAAL DE CLERCK', 'Jan Arendsz.', 1150, NULL, '1779', NULL, NULL, 'Z', 'Z', '1787-02-03', 'China', '1787-05-23', '1787-06-22', true, '1787-09-26', 'Rammekens', 4506, NULL);
INSERT INTO "voyages" VALUES (8189, '', 1, '', 'VREDENBURG', 'Herman Kikkert', 1150, NULL, '1784', NULL, NULL, 'A', 'A', '1787-02-03', 'China', '1787-06-06', '1787-07-01', true, '1787-10-16', 'Texel', 4511, NULL);
INSERT INTO "voyages" VALUES (8190, '', 1, '', 'DUIFJE', 'Gerrit Jan van de Kerkhof', 400, NULL, '1784', NULL, NULL, 'A', 'A', '1787-02-08', 'Batavia', '1787-05-16', '1787-06-22', true, '1787-09-25', 'Texel', 4508, NULL);
INSERT INTO "voyages" VALUES (8191, '', 3, '', 'HOF TER LINDEN', 'Arie Pijlhart', 1150, NULL, '1772', NULL, NULL, 'Z', 'Z', '1787-02-13', 'Ceylon', '1787-04-23', NULL, true, '1787-08-22', 'Rammekens', 4382, NULL);
INSERT INTO "voyages" VALUES (8192, '', 2, '', 'DRAAK', 'Pierre Frederik Riebe', 1150, NULL, '1780', NULL, NULL, 'A', 'A', '1787-02-21', 'Ceylon', '1787-12-03', '1788-03-04', true, '1788-06-29', 'Texel', 4507, 'On 26-03-1787 the DRAAK lost its masts and pan of the rigging. For that reason the ship called at Mauritius, 12-04 till 22-10-1787.');
INSERT INTO "voyages" VALUES (8193, '', 2, '', 'PAREL', 'Gerrit Gerritsen', 1150, NULL, '1778', NULL, NULL, 'A', 'R', '1787-02-01', 'Ceylon', NULL, NULL, true, NULL, NULL, 4473, 'The date of the PAREL''s arrival at the Cape is unknown. There the ship was broken up in 1788. See also the VREDE (8214).');
INSERT INTO "voyages" VALUES (8194, '', 2, '', 'JONGE FRANK', 'Jakob Veer', 592, NULL, NULL, NULL, NULL, NULL, 'Z', '1787-05-02', 'Batavia', '1787-08-14', '1787-09-21', true, '1787-12-14', 'Rammekens', 4521, NULL);
INSERT INTO "voyages" VALUES (8195, '', 1, '', 'BERKSHOVEN', 'Pieter Bentse', 651, 'pink', NULL, NULL, NULL, NULL, 'A', '1787-05-08', 'Batavia', '1787-08-13', '1787-08-29', true, '1787-12-10', 'Texel', 4529, NULL);
INSERT INTO "voyages" VALUES (8196, '', 2, '', 'DAPPERHEID', 'Evert Wittenberg', 472, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1787-06-07', 'Batavia', '1787-08-30', '1787-10-04', true, '1787-12-10', 'Texel', 4526, NULL);
INSERT INTO "voyages" VALUES (8197, '', 2, '', 'VROUWE WIJNANDA LUBERTA', 'Jakob Smit', 508, 'fregat', NULL, NULL, NULL, NULL, 'A', '1787-06-07', 'Batavia', '1787-08-25', '1787-10-04', true, '1788-07-08', 'Texel', 4528, 'According to K.A. 4304 Sijbrand Berk was master of the VROUWE WIJNANDA LUBERTA.');
INSERT INTO "voyages" VALUES (8198, '', 2, '', 'ONZEKERE', 'Francois Aemonet', 348, NULL, NULL, NULL, NULL, NULL, 'Z', '1787-06-30', 'Batavia', '1787-09-19', '1787-11-10', true, '1788-02-22', 'Rammekens', 4520, NULL);
INSERT INTO "voyages" VALUES (8199, '', 2, '', 'JONGE JAKOB', 'Asmus Pieter Asmus', 648, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1787-10-06', 'Batavia', '1787-12-04', '1788-01-07', true, '1788-04-18', 'Texel', 4538, NULL);
INSERT INTO "voyages" VALUES (8200, '', 2, '', 'JUFFROUW JOHANNA', 'Simon Koter', 678, NULL, NULL, NULL, NULL, NULL, 'Z', '1787-10-31', 'Batavia', '1788-01-22', '1788-02-11', true, '1788-06-07', 'Rammekens', 4540, NULL);
INSERT INTO "voyages" VALUES (8201, '', 1, '', 'AVENHORN', 'A. Arend Thobiasz.', 880, NULL, '1780', NULL, NULL, 'H', NULL, '1787-11-04', 'Batavia', '1788-01-22', NULL, true, NULL, NULL, 4479, 'At the Cape the AVENHORN was wrecked.');
INSERT INTO "voyages" VALUES (8202, '', 2, '', 'EENSGEZINDHEID', 'Peter Jansen', 884, 'fluit', NULL, NULL, NULL, NULL, 'H', '1787-11-04', 'Batavia', '1788-01-22', '1788-02-10', true, '1788-06-18', 'Texel', 4537, NULL);
INSERT INTO "voyages" VALUES (8203, '', 2, '', 'MENTOR', 'Jochem Hendrik Milfaart', 560, NULL, NULL, NULL, NULL, NULL, 'Z', '1787-11-07', 'Batavia', '1788-01-09', '1788-01-31', true, '1788-04-18', 'Rammekens', 4545, NULL);
INSERT INTO "voyages" VALUES (8204, '', 1, '', 'OOSTZAANDAM', 'Jakob de Vries', 650, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1787-11-09', 'Batavia', '1788-01-22', '1788-02-14', true, '1788-06-13', 'Texel', 4530, NULL);
INSERT INTO "voyages" VALUES (8205, '', 2, '', 'DOGGERSBANK', 'Abraham Tim', 1150, NULL, '1782', NULL, NULL, 'A', 'A', '1787-11-15', 'Ceylon', '1788-01-23', '1788-03-04', true, '1788-06-29', 'Texel', 4522, NULL);
INSERT INTO "voyages" VALUES (8206, '', 1, '', 'VLISSINGEN', 'Willem Frederiks', 380, NULL, NULL, NULL, NULL, NULL, 'A', '1787-11-18', 'Batavia', '1788-01-25', '1788-02-17', true, '1788-06-12', 'Texel', 4550, NULL);
INSERT INTO "voyages" VALUES (8207, '', 1, '', 'MARIA', NULL, 908, 'fluit', NULL, NULL, NULL, NULL, 'A', '1787-12-08', 'Ceylon', '1788-08-01', NULL, true, NULL, NULL, 4524, 'outward-bound JONGE FRANK (4621) and the homeward-bound DUIFJE (8312).');
INSERT INTO "voyages" VALUES (8208, '', 1, '', 'BROEDERSLUST', 'Simon Vaartjes', 686, 'hoeker', NULL, NULL, NULL, NULL, 'R', '1787-12-13', 'Batavia', '1788-03-12', '1788-04-10', true, '1788-07-26', 'Goeree', 4551, NULL);
INSERT INTO "voyages" VALUES (8209, '', 3, '', 'DORDRECHT', 'Pleun van der Giessen', 898, 'fluit', NULL, NULL, NULL, 'D', 'A', '1788-01-17', 'Ceylon', '1788-03-21', '1788-04-10', true, '1788-07-16', 'Texel', 4533, 'third voyage of this ship, which during its first voyage (4400/8087) was called BERLIN.');
INSERT INTO "voyages" VALUES (8210, '', 1, '', 'GOEDE INTENTIE', 'Pieter Kornelissen', 500, 'hoeker', NULL, NULL, NULL, NULL, 'D', '1788-01-21', 'Batavia', '1788-04-19', NULL, true, '1788-10-28', 'Goeree', 4552, NULL);
INSERT INTO "voyages" VALUES (8211, '', 1, '', 'CANTON', 'Kornelis de Wit', 1150, NULL, '1785', NULL, NULL, 'R', 'R', '1788-01-24', 'China', '1788-04-13', NULL, true, '1788-08-18', 'Goeree', 4542, NULL);
INSERT INTO "voyages" VALUES (8212, '', 1, '', 'NEDERLANDS WELVAREN', 'Arie Kikkert', 1150, NULL, '1785', NULL, NULL, 'A', 'A', '1788-01-26', 'China', '1788-04-12', NULL, true, '1788-08-18', 'Texel', 4536, NULL);
INSERT INTO "voyages" VALUES (8213, '', 1, '', 'SPAARNE', 'Willem Udemans jr.', 656, 'hoeker', NULL, '1784', NULL, 'A', 'A', '1788-01-27', 'Bengal', '1788-04-14', NULL, true, '1788-09-30', 'Texel', 4453, NULL);
INSERT INTO "voyages" VALUES (8214, '', 2, '', 'VREDE', 'Thijs Ketel', 854, 'fluit', NULL, NULL, NULL, NULL, 'A', '1788-02-09', 'The Cape', '1788-02-09', NULL, true, '1788-06-26', 'Texel', 4541, 'The VREDE carried the cargo of the homeward-bound PAREL, laid up at the Cape (see 8193).');
INSERT INTO "voyages" VALUES (8215, '', NULL, '', NULL, 'Not used', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '1788-02-09', NULL, NULL, NULL, true, NULL, NULL, NULL, NULL);
INSERT INTO "voyages" VALUES (8216, '', 3, '', 'JAVA', 'Jan Kraai', 850, NULL, '1775', NULL, NULL, 'E', 'Z', '1788-02-25', 'Ceylon', '1788-06-01', NULL, true, '1789-06-01', 'Rammekens', 4472, 'On 01-06-1788 the JAVA arrived at Simon''s Bay. Three and a half months later the ship sailed to the Cape to be repaired.');
INSERT INTO "voyages" VALUES (8217, '', 2, '', 'BARBESTEIN', 'Kornelis van Vlaanderen', 1150, NULL, '1783', NULL, NULL, 'A', 'Z', '1788-03-01', 'China', '1788-08-14', '1788-09-09', true, '1789-05-31', 'Rammekens', 4544, NULL);
INSERT INTO "voyages" VALUES (8218, '', 1, '', 'ADMIRAAL DE SUFFREN', NULL, 1300, NULL, '1785', NULL, NULL, 'A', 'A', '1788-03-01', 'China', NULL, NULL, true, NULL, NULL, 4543, 'Sailing from China to the Cape the ADMIRAAL DE SUFFREN was wrecked, in the South China Sea.');
INSERT INTO "voyages" VALUES (8219, '', 2, '', 'VOORSCHOTEN', 'Willem van Groningen', 1150, NULL, '1783', NULL, NULL, 'A', 'A', '1788-03-01', 'China', '1788-08-15', '1789-02-09', true, '1789-06-01', 'Texel', 4547, NULL);
INSERT INTO "voyages" VALUES (8220, '', 1, '', 'HENDRINA', 'Hillebrand van Uijen', 656, 'fluit', NULL, NULL, NULL, NULL, 'A', '1788-04-14', 'Batavia', '1788-07-29', '1788-08-26', true, '1789-02-14', 'Texel', 4561, NULL);
INSERT INTO "voyages" VALUES (8221, '', 1, '', 'VROUWE AGATHA', NULL, 900, NULL, NULL, NULL, NULL, NULL, NULL, '1788-07-01', 'The Cape', '1788-07-01', NULL, true, '1788-09-14', 'Texel', 4591, NULL);
INSERT INTO "voyages" VALUES (8222, '', 1, '', 'GOEDE VERWACHTING', 'Tijmen de Zweed', 560, 'fluit', NULL, NULL, NULL, NULL, 'A', '1788-09-11', 'Batavia', '1788-12-02', '1789-01-09', true, '1789-04-13', 'Texel', 4558, 'passengers.');
INSERT INTO "voyages" VALUES (8223, '', 2, '', 'MERENBERG', 'Klaas Ent', 892, 'fluit', NULL, NULL, NULL, NULL, 'E', '1788-10-11', 'Batavia', '1789-01-01', '1789-02-05', true, '1789-06-01', 'Texel', 4556, '4556/8223 was the second voyage of this ship, which during the preceding voyage (4452/8159) was called EIKENWOUD.');
INSERT INTO "voyages" VALUES (8224, '', 1, '', 'FORTUIN (VAN', 'DORDRECHT) Jan Dale', NULL, 'fluit', NULL, NULL, NULL, NULL, 'A', '1788-10-18', 'Ceylon', '1788-12-26', '1789-04-11', true, '1789-08-25', 'Texel', 4566, 'The FORTUIN (VAN DORDRECHT) carried many Luxemburg soldiers. During the voyage it called at Lorient. Sailing from Ceylon to Texel the FORTUIN (VAN DORDRECHT) was escorted by a Dutch man-of-war. As far as the Cape the DRIE GEBROEDERS (8225), the JUFFROUW JOHANNA (8226), and the SUZANNA (8227) also formed part of the convoy; between the Cape and patria these three ships were accompanied by another Dutch man-of-war.');
INSERT INTO "voyages" VALUES (8225, '', 1, '', 'DRIE GEBROEDERS', 'Jan Roelofsz. de Groot', 828, 'fluit', NULL, NULL, NULL, NULL, 'A', '1788-10-18', 'Ceylon', '1788-12-26', '1789-03-03', true, '1789-08-25', 'Texel', 4567, 'The DRIE GEBROEDERS carried many Luxemburg soldiers. During the voyage the ship called at Lorient in France. See also the FORTUIN (8224).');
INSERT INTO "voyages" VALUES (8226, '', 3, '', 'JUFFROUW JOHANNA', 'Michiel Poest', NULL, NULL, NULL, NULL, NULL, NULL, 'Z', '1788-10-18', 'Ceylon', '1788-12-26', '1789-03-03', true, '1789-06-07', 'Rammekens', 4572, 'Luxemburg soldiers, and sailed via Lorient in France. See also the FOR-TUIN (8224).');
INSERT INTO "voyages" VALUES (8227, '', 1, '', 'SUZANNA', 'Klaas Zwart', NULL, NULL, NULL, NULL, NULL, NULL, 'A', '1788-10-18', 'Ceylon', '1788-12-26', '1789-03-03', true, '1789-08-25', 'Texel', 4579, 'The SUZANNA carried many Luxemburg soldiers. The ship sailed via Lorient in France. See also the FORTUIN (8224).');
INSERT INTO "voyages" VALUES (8228, '', 1, '', 'ZEEVAART', '(HOLLAND) Simon Jakob Forster', 846, NULL, NULL, NULL, NULL, NULL, 'A', '1788-10-18', 'Batavia', '1789-01-02', '1789-02-07', true, '1789-06-04', 'Texel', 4562, 'The 41 people, who departed from Batavia, included 5 passengers and 2 slaves.');
INSERT INTO "voyages" VALUES (8229, '', 2, '', 'VLUGGE TREKVOGEL', 'Barend Jansz. Uffen', 484, 'hoeker', NULL, NULL, NULL, NULL, 'H', '1788-10-23', 'Batavia', '1788-12-27', '1789-02-01', true, '1789-04-28', 'Texel', 4554, NULL);
INSERT INTO "voyages" VALUES (8230, '', 1, '', 'ALBLASSERDAM', 'Aris van Valkenburg', 1150, NULL, '1782', NULL, NULL, 'Z', 'Z', '1788-10-28', 'Batavia', '1789-01-02', '1789-02-09', true, '1789-05-31', 'Rammekens', 4483, 'The 12 passengers, who departed from Batavia, included 4 male and 2 female slaves.');
INSERT INTO "voyages" VALUES (8231, '', 2, '', 'GERECHTIGHEID', 'Hans Christiaan Christiaanse', 1150, NULL, '1779', NULL, NULL, 'A', 'R', '1788-10-28', 'Batavia', '1789-01-01', '1789-02-09', true, '1789-05-30', 'Goeree', 4482, 'The 11 passengers, indicated in the first column, included one male and two female slaves and a condemned person.');
INSERT INTO "voyages" VALUES (8232, '', 2, '', 'VROUWE JAKOBA MARIA LUCIA THERESIA', 'Dirk Peek', 429, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1788-11-08', 'Batavia', NULL, NULL, false, '1789-05-17', 'Texel', 4585, NULL);
INSERT INTO "voyages" VALUES (8233, '', 2, '', 'JOSEPHUS DE TWEEDE', 'Johan de Wolf', 460, NULL, NULL, NULL, NULL, NULL, 'Z', '1788-11-11', 'Ceylon', '1789-01-10', '1789-02-15', true, '1789-06-03', 'Rammekens', 4568, NULL);
INSERT INTO "voyages" VALUES (8234, '', 2, '', 'GEERTRUIDA', 'Daniel Kunneman', 660, 'fluit', NULL, NULL, NULL, NULL, 'A', '1788-11-12', 'Batavia', '1789-01-14', '1789-02-19', true, '1789-05-29', 'Texel', 4574, 'The 71 people, who departed from Batavia, included 6 passengers.');
INSERT INTO "voyages" VALUES (8235, '', 1, '', 'STANDVASTIGHEID', 'Herman Volkers', 780, 'hoeker', NULL, '1785', NULL, 'R', 'D', '1788-11-14', 'Batavia', '1789-01-19', '1789-02-19', true, '1789-06-06', 'Goeree', 4504, NULL);
INSERT INTO "voyages" VALUES (8236, '', 1, '', 'USTROOM', 'Dirk Roem', 898, NULL, NULL, '1785', NULL, 'A', 'Z', '1788-11-19', 'Batavia', NULL, NULL, false, '1789-06-05', 'Rammekens', 4486, 'included one female slave. At the departure from Batavia the IJSTROOM was escorted by a Dutch man-of-war.');
INSERT INTO "voyages" VALUES (8237, '', 1, '', 'WIRTZLUST', 'Karel Volkman', 590, NULL, NULL, NULL, NULL, NULL, 'A', '1788-11-29', 'Batavia', NULL, NULL, false, '1789-06-04', 'Texel', 4590, NULL);
INSERT INTO "voyages" VALUES (8238, '', 1, '', 'HANDELLUST', 'Eldert Evertsz.', 458, NULL, NULL, NULL, NULL, NULL, 'R', '1788-12-01', 'Batavia', '1789-02-25', '1789-03-22', true, '1789-06-24', 'Goeree', 4596, NULL);
INSERT INTO "voyages" VALUES (8239, '', 1, '', 'GOEDE HOOP', 'Laurens Jansen', 400, 'hoeker', NULL, NULL, NULL, NULL, 'E', '1788-12-01', 'Batavia', '1789-03-09', '1789-04-06', true, '1789-07-18', 'Texel', 4580, NULL);
INSERT INTO "voyages" VALUES (8240, '', 1, '', 'BATAVIER', 'Jan Jansz. Laurits', 1150, NULL, '1782', NULL, NULL, 'A', 'A', '1789-01-03', 'Ceylon', '1789-04-25', '1789-05-13', true, '1789-09-02', 'Texel', 4447, NULL);
INSERT INTO "voyages" VALUES (8241, '', 1, '', 'LEIDEN', 'Johan Hendrik Gevels', 1150, NULL, '1786', NULL, NULL, 'A', 'A', '1789-01-04', 'China', '1789-04-11', '1789-05-01', true, '1789-08-25', 'Texel', 4575, NULL);
INSERT INTO "voyages" VALUES (8242, '', 1, '', 'GOEDE TROUW', 'Jan Arendsz.', 1150, NULL, '1786', NULL, NULL, 'Z', 'Z', '1789-01-17', 'China', NULL, NULL, true, '1789-07-18', 'Rammekens', 4599, 'call at the Cape.');
INSERT INTO "voyages" VALUES (8243, '', 1, '', 'GOUVERNEUR FALCK', 'Paulus Kroon', 1150, NULL, '1786', NULL, NULL, 'A', 'A', '1789-01-19', 'Ceylon', '1789-04-01', '1789-05-01', true, '1789-08-25', 'Texel', 4595, NULL);
INSERT INTO "voyages" VALUES (8244, '', 1, '', 'GOUVERNEUR-GENERAAL MAATSUIJKER', 'Gerrit Esman', 1150, NULL, '1786', NULL, NULL, 'A', 'A', '1789-01-24', 'China', '1789-04-10', '1789-05-01', true, '1789-08-25', 'Texel', 4589, NULL);
INSERT INTO "voyages" VALUES (8245, '', 1, '', 'BLITTERSWUK', 'Lodewijk Elgenhuizen', 1150, NULL, '1785', NULL, NULL, 'Z', 'H', '1789-01-26', 'China', '1789-04-25', '1789-05-06', true, '1789-08-25', 'Texel', 4592, NULL);
INSERT INTO "voyages" VALUES (8246, '', 1, '', 'DRIETAL HANDELAARS', 'Kornelis de Vries', 502, NULL, NULL, NULL, NULL, NULL, 'A', '1789-02-27', 'Batavia', NULL, NULL, true, NULL, NULL, 4569, 'The DRIETAL HANDELAARS was wrecked off the Cape.');
INSERT INTO "voyages" VALUES (8247, '', 1, '', 'MARIA LOUISA', 'Anthonie Franciscus Steffers', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1789-03-05', 'Batavia', '1789-05-03', '1789-05-14', true, '1789-09-07', 'Texel', 4615, 'The 24 people on board the MARIA LOUISA included one passenger. At the departure from the Cape the ship was escorted by a Dutch man-of-war.');
INSERT INTO "voyages" VALUES (8248, '', 1, '', 'GATENISSE', 'Hans Klaassen', 660, NULL, NULL, NULL, NULL, NULL, 'Z', '1789-03-11', 'Batavia', '1789-06-05', '1789-07-07', true, '1789-10-16', 'Rammekens', 4593, NULL);
INSERT INTO "voyages" VALUES (8249, '', 1, '', 'GEERTRUIDA PETRONELLA', 'Jan Gerrit Scholten', 1090, 'hoeker', NULL, NULL, NULL, NULL, 'Z', '1789-03-19', 'Batavia', '1789-06-08', '1789-07-07', true, '1789-10-29', 'Rammekens', 4584, NULL);
INSERT INTO "voyages" VALUES (8250, '', 2, '', 'JAN EN KORNELIS', 'Klaas Duif', 560, 'fluit', NULL, NULL, NULL, NULL, 'A', '1789-04-02', 'Batavia', '1789-07-20', '1789-08-14', true, '1789-12-07', 'Texel', 4583, 'On 20-04-1789, when sailing through Sunda Strait, the JAN EN CORNELIS and the VROUWE JOHANNA JAKOBA (8251) were escorted by a Dutch man-of-war.');
INSERT INTO "voyages" VALUES (8251, '', 2, '', 'VROUWE JOHANNA JAKOBA', 'Simon Krijgsman', 444, 'hoeker', NULL, NULL, NULL, NULL, 'E', '1789-04-05', 'Batavia', '1789-06-15', '1789-07-07', true, '1789-10-04', 'Texel', 4581, 'See also the JAN EN KORNELIS (8250).');
INSERT INTO "voyages" VALUES (8252, '', 1, '', 'MEERMIN', NULL, 500, 'fregat', '1782', NULL, NULL, 'A', 'A', '1789-04-06', 'The Cape', '1789-04-06', NULL, true, '1789-07-26', 'Texel', 4438, NULL);
INSERT INTO "voyages" VALUES (8253, '', 1, '', 'JONGE JAKOB EN ALBERTUS', 'Hendrik Joosten', 516, 'fregat', NULL, NULL, NULL, NULL, 'A', '1789-04-23', 'Batavia', '1789-07-02', '1789-08-07', true, '1789-11-05', 'Vlie', 4610, NULL);
INSERT INTO "voyages" VALUES (8254, '', 3, '', 'DAPPERHEID', 'Evert Wittenberg', 472, 'hoeker', NULL, NULL, NULL, NULL, 'E', '1789-05-04', 'Batavia', '1789-07-20', '1789-08-07', true, '1789-11-04', 'Texel', 4603, NULL);
INSERT INTO "voyages" VALUES (8255, '', 2, '', 'BERKSHOVEN', 'Harmen Ruurdsz.', 651, 'pink', NULL, NULL, NULL, NULL, 'D', '1789-05-13', 'Batavia', '1789-08-19', '1789-09-14', true, '1789-12-15', 'Goeree', 4608, NULL);
INSERT INTO "voyages" VALUES (8256, '', 2, '', 'RIJNOORD', 'Kornelis Reindertsz. Tromp', 846, 'fluit', NULL, NULL, NULL, NULL, 'Z', '1789-05-31', 'Batavia', '1789-10-07', '1789-12-01', true, '1790-04-30', 'Rammekens', 4582, 'According to K.A. 4317 Karsten Hansen Blijk was master.');
INSERT INTO "voyages" VALUES (8257, '', 1, '', 'FARM', 'Luur Runken', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1789-06-21', 'Batavia', '1789-08-18', '1789-09-03', true, '1789-11-09', 'Texel', 4627, NULL);
INSERT INTO "voyages" VALUES (8258, '', 1, '', 'VLIJT', 'Couvret', 136, NULL, '1788', NULL, NULL, 'Z', 'Z', '1789-10-13', 'Batavia', '1789-12-06', '1790-01-02', true, '1790-03-27', 'Rammekens', 4636, 'Lieutenant William Bligh, former commanding officer of the English man-of-war BOUNTY. In April, 1789, the larger part of his crew had risen in mutiny; Bligh and 18 others had been turned adrift in a small open boat off Tofua, one of the Tonga Islands. All but one had survived the desperate voyage from Tofua all the way to Timor, where they arrived on 12-06-1789. See also the HOUTLUST (8260), the ROZENBURG (8261), the SPARENDIJK (8262), the CASTOR(8263), and the VREDENBURG (8329).');
INSERT INTO "voyages" VALUES (8259, '', 1, '', 'VALK', 'Matthijs Laurens Koster', 600, NULL, NULL, '1785', NULL, 'A', 'A', '1789-10-20', 'Batavia', '1789-12-28', '1790-01-18', true, '1790-05-01', 'Texel', 4525, 'One of the passengers was a condemned person.');
INSERT INTO "voyages" VALUES (8260, '', 1, '', 'HOUTLUST', 'Pieter Hol', 880, NULL, '1785', NULL, NULL, 'D', 'R', '1789-10-26', 'Batavia', '1790-01-11', '1790-02-17', true, '1790-05-24', 'Goeree', 4539, 'The 101 seafarers included 26 Chinese. Among the 11 passengers were one female and 4 male slaves, and a survivor of the English man-of war BOUNTY (see the VLIJT, 8258); during the voyage he died.');
INSERT INTO "voyages" VALUES (8261, '', 2, '', 'ROZENBURG', 'Dirk Dirksz. Varkevisser', 880, NULL, '1780', NULL, NULL, 'D', 'D', '1789-10-26', 'Batavia', '1790-01-08', '1790-02-26', true, '1790-06-23', 'Goeree', 4519, 'The 101 seaferers included 26 Chinese. Among the 12 passengers were 5 female slaves, and 2 survivors of the English man-of-war BOUNTY (see the VLIJT, 8258); both died very soon after having embarked on the ROZENBURG. On 29-12-1789, during a haevy storm, the crew threw 7 of the 9 guns overboard; part of the cargo, consisting of sugar, was affected by salt water. salt water.');
INSERT INTO "voyages" VALUES (8262, '', 2, '', 'SPARENRUK', 'Dirk Sem', 1150, NULL, '1780', NULL, NULL, 'A', 'A', '1789-10-26', 'Batavia', '1790-01-07', '1790-02-17', true, '1790-05-23', 'Texel', 4474, 'the SPARENDIJK was severely damaged off Cape Aghulhas. 4474/8262 was the second voyage of this ship, which during the preceding voyage (4410/8099) was called POTSDAM.');
INSERT INTO "voyages" VALUES (8263, '', 1, '', 'CASTOR', 'Michiel Jurgens', 650, NULL, NULL, '1784', NULL, 'Z', 'A', '1789-11-12', 'Batavia', '1790-02-02', '1790-02-26', true, '1790-06-22', 'Texel', 4464, 'passengers were 2 survivors of the English man-of-war BOUNTY (see the VLIJT, 8258).');
INSERT INTO "voyages" VALUES (8264, '', 1, '', 'NEGOTIE', 'Johan Pleen', 440, NULL, NULL, '1785', NULL, 'A', 'A', '1789-11-12', 'Batavia', '1790-02-13', '1790-03-07', true, '1790-06-26', 'Texel', 4497, 'The 7 passengers included a male and a temale slave.');
INSERT INTO "voyages" VALUES (8265, '', 1, '', 'VEERE', 'Hendrik Holder', 758, NULL, NULL, '1786', NULL, 'Z', 'Z', '1789-11-12', 'Batavia', '1790-02-13', '1790-03-07', true, '1790-06-26', 'Rammekens', 4518, NULL);
INSERT INTO "voyages" VALUES (8266, '', 1, '', 'AREND', 'Nikolaas Klopper', 690, NULL, NULL, '1786', NULL, 'A', 'A', '1789-11-17', 'Ceylon', '1790-02-13', '1790-03-21', true, '1790-07-19', 'Texel', 4527, NULL);
INSERT INTO "voyages" VALUES (8267, '', 1, '', 'ZAANSTROOM', 'Roelof Pietersz. Hoberg', 564, NULL, NULL, '1785', NULL, 'A', 'A', '1789-11-17', 'Ceylon', '1790-02-17', '1790-03-21', true, '1790-07-19', 'Texel', 4499, NULL);
INSERT INTO "voyages" VALUES (8268, '', 1, '', 'RESOLUTIE', 'Justinus Philippus Man', 530, NULL, NULL, '1784', NULL, 'E', 'H', '1789-11-18', 'Batavia', '1790-02-02', '1790-02-26', true, '1790-06-22', 'Texel', 4463, NULL);
INSERT INTO "voyages" VALUES (8269, '', 2, '', 'ROTTERDAMS WELVAREN', 'Willem Jakob Kudde', 880, NULL, '1780', NULL, NULL, 'R', 'E', '1789-11-18', 'Batavia', NULL, NULL, true, NULL, NULL, 4490, 'The 101 seafarers included 26 Chinese. Sailing to the Cape the ROTTERDAMS WELVAREN was wrecked.');
INSERT INTO "voyages" VALUES (8270, '', 1, '', 'ZEELAND', 'Jochem Bank', 1150, NULL, '1783', NULL, NULL, 'Z', 'Z', '1789-11-24', 'Batavia', '1790-02-13', '1790-03-07', true, '1790-06-26', 'Rammekens', 4515, 'The 111 seafarers included 26 Chinese; among the 12 passengers were a male and a female slave.');
INSERT INTO "voyages" VALUES (8271, '', 2, '', 'EIK EN LINDE', 'Jan Bringman', 574, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1789-12-01', 'Batavia', '1790-03-25', '1790-04-29', true, '1790-07-31', 'Texel', 4573, NULL);
INSERT INTO "voyages" VALUES (8272, '', 1, '', 'LUCHTBOL', 'Nils Lundstrom', 136, 'paketboot', '1788', NULL, NULL, 'R', 'R', '1789-12-01', 'Batavia', '1790-02-08', '1790-02-23', true, '1790-04-29', 'Goeree', 4638, NULL);
INSERT INTO "voyages" VALUES (8273, '', 1, '', 'CHRISTOFFEL COLUMBUS', 'Jurriaan Pietersen', 1150, NULL, '1787', NULL, NULL, 'A', 'A', '1790-01-01', 'China', '1790-04-21', '1790-05-04', true, '1790-08-03', 'Texel', 4623, NULL);
INSERT INTO "voyages" VALUES (8274, '', 1, '', 'DELFT', 'Jakob Swetman', 880, NULL, '1786', NULL, NULL, 'D', 'D', '1790-01-01', 'China', '1790-05-09', NULL, true, '1790-09-23', 'Goeree', 4622, NULL);
INSERT INTO "voyages" VALUES (8275, '', 1, '', 'MEERWIJK', 'Bernard Christiaan Muller', 1150, NULL, '1787', NULL, NULL, 'A', 'A', '1790-01-01', 'China', '1790-04-19', '1790-05-04', true, '1790-08-03', 'Texel', 4620, NULL);
INSERT INTO "voyages" VALUES (8276, '', 2, '', 'VROUWE SARA HENDRINA', 'Hillebrand van Uijen', 656, 'fluit', NULL, NULL, NULL, NULL, 'A', '1790-01-12', 'The Cape', '1790-01-12', NULL, true, '1790-05-23', 'Texel', 4641, NULL);
INSERT INTO "voyages" VALUES (8277, '', 1, '', 'VROUWE MARIA KORNELIA', 'Pieter Modderman', 1150, NULL, '1785', NULL, NULL, 'E', 'Z', '1790-01-17', 'China', NULL, NULL, true, '1790-08-24', 'Rammekens', 4631, 'The VROUWE MARIA KORNELIA probably did not call at the Cape.');
INSERT INTO "voyages" VALUES (8278, '', 1, '', 'SCHAGEN', 'Pieter Stokbroo', 880, NULL, '1785', NULL, NULL, 'H', 'E', '1790-01-17', 'China', '1790-04-21', '1790-05-04', true, '1790-08-03', 'Texel', 4634, NULL);
INSERT INTO "voyages" VALUES (8279, '', 1, '', 'DORDWIJK', 'Kornelis van Deventer', 800, 'hoeker', NULL, '1787', NULL, 'R', 'D', '1790-02-01', 'Batavia', '1790-05-09', NULL, true, '1790-09-25', 'Goeree', 4576, NULL);
INSERT INTO "voyages" VALUES (8280, '', 2, '', 'HUISDUINEN', 'Arie Simonsz. Koek', 723, NULL, NULL, '1784', NULL, 'A', 'Z', '1790-02-01', 'Ceylon', '1790-04-21', '1790-05-13', true, '1790-09-02', 'Rammekens', 4534, NULL);
INSERT INTO "voyages" VALUES (8281, '', 1, '', 'POLLUX', 'Johan van Stralen', 490, NULL, NULL, '1784', NULL, 'Z', 'Z', '1790-02-01', 'Batavia', '1790-07-16', NULL, true, '1790-11-12', 'Rammekens', 4546, 'Sailing to the Cape the POLLUX was overtaken by a heavy storm. Masts, rigging, and rudder were damaged, the hull got leaky. Part of the gunpowder was affected by water.');
INSERT INTO "voyages" VALUES (8282, '', 1, '', 'VERWACHTING', 'August Willem Hass+', 600, 'hoeker', NULL, '1787', NULL, 'H', 'Z', '1790-02-01', 'Batavia', '1790-05-21', NULL, true, '1790-10-15', 'Rammekens', 4570, 'Between Batavia and the Cape August Willem Hass died; Pieter van Lirtson succeeded him as master of the VERWACHTING. The passenger was a condemned person.');
INSERT INTO "voyages" VALUES (8283, '', 1, '', 'TRINCONOMALE', 'Herman Driesman', 1150, NULL, '1787', NULL, NULL, 'A', 'A', '1790-02-02', 'Ceylon', '1790-03-26', '1790-04-20', true, '1790-07-21', 'Texel', 4632, NULL);
INSERT INTO "voyages" VALUES (8284, '', 1, '', 'CAPELLE', 'Wietse de Boer', 880, NULL, '1786', NULL, NULL, 'R', 'R', '1790-02-27', 'Batavia', '1790-05-27', NULL, true, '1790-10-18', 'Texel', 4559, 'The 4 passengers included one slave. The SLOT CAPELLE sailed for the Chamber Rotterdam; because of a storm, however, the ship did not return to Goeree, but to Texel.');
INSERT INTO "voyages" VALUES (8285, '', 1, '', 'MEEUWTJE', 'Hendrik Blok', 400, NULL, '1783', NULL, NULL, 'A', 'A', '1790-02-27', 'Batavia', NULL, NULL, true, '1790-11-05', 'Texel', 4477, 'The MEEUWTJE probably did not call at the Cape.');
INSERT INTO "voyages" VALUES (8286, '', 1, '', 'ZEENIMF', 'Theodorus Toussaint', 450, NULL, '1782', NULL, NULL, 'Z', 'A', '1790-02-27', 'Batavia', '1790-06-01', NULL, true, NULL, NULL, 4500, 'The passenger was a condemned person. On 06-07-1790 the ZEENIMF ran aground at the Cape and was severely damaged; one month later it got afloat again (07-08-1790). Then the ship was presumably repaired; the ZEENIMF never returned to patria, however.');
INSERT INTO "voyages" VALUES (8287, '', 3, '', 'SLOT TER HOGE', 'David Hartig', 1150, NULL, '1776', NULL, NULL, 'Z', 'Z', '1790-03-06', 'Batavia', NULL, NULL, true, NULL, NULL, 4601, 'Sailing from Batavia to the Cape the SLOT TER HOGE was wrecked.');
INSERT INTO "voyages" VALUES (8288, '', 1, '', 'HAASJE', 'Jan Andries Rugee+', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1790-05-18', 'Batavia', '1790-07-28', '1790-08-23', true, '1790-12-01', 'Texel', 4654, 'killed. The rest of the crew managed to suppress the insurrection by shooting the main instigators. Jan Wilting took Rugee''s place as master. At the Cape Francois Johan van den Broek was appointed master of the HAASJE.');
INSERT INTO "voyages" VALUES (8289, '', 1, '', 'SNELHEID', 'Jan Koenraad Haverkamp+', 136, 'paketboot', '1788', NULL, NULL, 'H', 'H', '1790-08-04', 'Batavia', '1790-10-09', '1790-10-20', true, '1790-12-21', 'Texel', 4657, 'From 29-08 till 15-09-1790 the SNELHEID was at Mauritius. There the master died; Roelof Jurgen Erdrop succeeded him.');
INSERT INTO "voyages" VALUES (8290, '', 1, '', 'NOORD-HOLLAND', 'Simon Vaartjes', 894, 'fluit', NULL, NULL, NULL, NULL, 'A', '1790-09-16', 'Batavia', '1791-01-08', '1791-02-25', true, '1791-06-22', 'Texel', 4613, NULL);
INSERT INTO "voyages" VALUES (8291, '', 3, '', 'JONGE JAKOB', 'Asmus Pieter Asmus', 648, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1790-09-25', 'Batavia', '1790-12-18', '1791-01-22', true, '1791-05-13', 'Texel', 4619, NULL);
INSERT INTO "voyages" VALUES (8292, '', 1, '', 'GOUDA', 'Klaas Voet', 400, NULL, '1784', NULL, NULL, 'A', 'A', '1790-10-23', 'Batavia', '1791-01-22', '1791-02-11', true, '1791-05-11', 'Texel', 4532, NULL);
INSERT INTO "voyages" VALUES (8293, '', 2, '', 'CONSTANTIA', 'Johan Gallo', 880, NULL, '1782', NULL, NULL, 'D', 'D', '1790-10-28', 'Batavia', '1791-01-25', '1791-02-20', true, '1791-05-20', 'Goeree', 4560, NULL);
INSERT INTO "voyages" VALUES (8294, '', 1, '', 'RECHT DOOR ZEE', 'Matthijs van der Balk', 880, NULL, '1786', NULL, NULL, 'D', 'H', '1790-11-05', 'Batavia', '1791-02-10', '1791-03-17', true, '1791-06-24', 'Texel', 4586, 'The 11 passengers included a male and a female slave.');
INSERT INTO "voyages" VALUES (8295, '', 2, '', 'SCHELDE', 'Christiaan Martens', 1150, NULL, '1780', NULL, NULL, 'Z', 'Z', '1790-11-05', 'Batavia', '1791-01-23', '1791-02-20', true, '1791-05-20', 'Rammekens', 4578, 'Among the 7 passengers was a female slave.');
INSERT INTO "voyages" VALUES (8296, '', 3, '', 'GOUVERNEUR-GENERAAL DE CLERCK', 'Jakob Frederiks', 1150, NULL, '1779', NULL, NULL, 'Z', 'Z', '1790-11-10', 'Batavia', '1791-02-05', '1791-03-17', true, '1791-06-24', 'Rammekens', 4600, 'The 8 passengers included 3 slaves.');
INSERT INTO "voyages" VALUES (8297, '', 1, '', 'UNIE', 'Simon Laurentius', 1150, NULL, '1787', NULL, NULL, 'Z', 'A', '1790-11-16', 'Ceylon', '1791-01-21', '1791-02-20', true, '1791-05-20', 'Texel', 4664, 'The 164 people included 14 passengers.');
INSERT INTO "voyages" VALUES (8298, '', 1, '', 'SINT LAURENS', 'Johan Bakker', 1150, NULL, '1784', NULL, NULL, 'Z', 'Z', '1790-11-18', 'Batavia', '1791-04-02', '1791-07-17', true, '1791-11-15', 'Rammekens', 4553, 'Originally the ST. LAURENS departed from the Cape on 02-05-1791. Because of leakage and heavy damage to masts and rigging, however, the ship had to return.');
INSERT INTO "voyages" VALUES (8299, '', 1, '', 'EXPEDITIE', 'Jakob Zoeteman', 136, 'paketboot', '1788', NULL, NULL, 'D', 'A', '1790-11-19', 'Ceylon', '1791-01-08', '1791-02-01', true, '1791-04-23', 'Texel', 4648, NULL);
INSERT INTO "voyages" VALUES (8300, '', 2, '', 'FAAM', 'Luur Runken', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1790-11-20', 'Batavia', '1791-02-02', '1791-02-20', true, '1791-05-11', 'Texel', 4666, NULL);
INSERT INTO "voyages" VALUES (8301, '', 1, '', 'TEILINGEN', 'Karel Frederik Schaak', 1150, NULL, '1786', NULL, NULL, 'R', 'R', '1790-11-20', 'Batavia', '1791-03-01', '1791-04-08', true, '1791-07-02', 'Goeree', 4618, 'Among the 11 passengers were 4 female slaves.');
INSERT INTO "voyages" VALUES (8302, '', 1, '', 'VASCO DA GAMA', 'Hans Barendse', 1150, NULL, '1788', NULL, NULL, 'A', 'A', '1790-12-01', 'China', '1791-03-16', '1791-04-08', true, '1791-07-03', 'Texel', 4651, NULL);
INSERT INTO "voyages" VALUES (8303, '', 2, '', 'AFRIKAAN', 'Jan Olhof', 880, NULL, '1780', NULL, NULL, 'E', 'E', '1790-12-06', 'Batavia', '1791-03-17', '1791-05-05', true, '1791-08-17', 'Texel', 4587, 'The 6 passengers included one condemned person.');
INSERT INTO "voyages" VALUES (8304, '', 3, '', 'EENSGEZINDHEID', 'Simon Koter', 884, 'fluit', NULL, NULL, NULL, NULL, 'A', '1790-12-10', 'Batavia', '1791-03-15', '1791-04-16', true, '1791-07-30', 'Texel', 4626, NULL);
INSERT INTO "voyages" VALUES (8305, '', 2, '', 'MARIA LOUISA', 'Anthonie Franciscus Steffers', 136, 'paketboot', '1788', NULL, NULL, 'A', 'D', '1790-12-20', 'Ceylon', '1791-02-19', '1791-04-01', true, '1791-07-10', 'Goeree', 4649, 'On 23-01-1791 the MARIA LOUISA lost its main mast.');
INSERT INTO "voyages" VALUES (8306, '', 2, '', 'BROEDERSLUST', 'Gottlieb Jager', 686, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1790-12-21', 'Batavia', '1791-03-15', '1791-04-16', true, '1791-08-26', 'Texel', 4630, NULL);
INSERT INTO "voyages" VALUES (8307, '', 2, '', 'BEVERWIJK', 'Dirk Muller', 1150, NULL, '1784', NULL, NULL, 'A', 'A', '1791-01-17', 'Batavia', '1791-04-21', '1791-06-28', true, '1791-10-10', 'Texel', 4594, 'After the return of the ship to Texel, its name was altered into BERKHOUT (see the third voyage: 4738/--).');
INSERT INTO "voyages" VALUES (8308, '', 2, '', 'BERKHOUT', 'Gijsbert Matthias Weitzel', 1150, NULL, '1779', NULL, NULL, 'H', 'A', '1791-02-02', 'Ceylon', '1791-04-13', '1791-05-05', true, '1791-08-12', 'Texel', 4531, 'The 157 people included 6 passengers.');
INSERT INTO "voyages" VALUES (8309, '', 1, '', 'LEVIATHAN', 'Johan van der Plas', 1150, NULL, '1785', NULL, NULL, 'A', 'Z', '1791-02-02', 'Ceylon', '1791-04-12', '1791-06-05', true, '1791-08-05', 'Rammekens', 4548, 'The 165 people included 10 passengers.');
INSERT INTO "voyages" VALUES (8310, '', 2, '', 'VLIJT', 'Francois Moser', 136, 'paketboot', '1788', NULL, NULL, 'Z', 'Z', '1791-02-14', 'Batavia', '1791-06-04', '1791-07-09', true, '1791-10-25', 'Rammekens', 4671, NULL);
INSERT INTO "voyages" VALUES (8311, '', 1, '', 'HELENA LOUISA', 'Kornelis Koman', 180, NULL, NULL, '1787', NULL, 'B', 'A', '1791-02-17', 'The Cape', '1791-02-17', NULL, true, '1791-05-20', 'Texel', NULL, 'during a heavy storm; the Company''s authorities decided to have the ship repaired.');
INSERT INTO "voyages" VALUES (8312, '', 2, '', 'DUIFJE', 'Lodewijk Willem van Rossum', 400, NULL, '1784', NULL, NULL, 'A', 'A', '1791-03-26', 'The Cape', '1791-03-26', NULL, true, '1791-07-06', 'Texel', 4604, 'The DUIFJE carried part of the cargo of the homeward-bound MARIA, wrecked at the Cape in August, 1788 (see 8207).');
INSERT INTO "voyages" VALUES (8313, '', 1, '', 'SURSEANCE', 'Andries Maankop', 768, NULL, NULL, '1786', NULL, 'Z', 'Z', '1791-03-28', 'Batavia', '1791-06-27', '1791-08-07', true, '1791-12-02', 'Goeree', 4557, 'On 11-4-1792 the SURSEANCE arrived at Rammekens.');
INSERT INTO "voyages" VALUES (8314, '', 1, '', 'PHOENICWR', 'Jan Jochem Milfaart', 1150, NULL, '1786', NULL, NULL, 'A', 'A', '1791-04-05', 'Batavia', '1791-06-12', '1791-07-15', true, '1791-10-18', 'Texel', 4564, 'The 112 people included 3 passengers.');
INSERT INTO "voyages" VALUES (8315, '', 3, '', 'SCHOONDERLOO', 'Hendrik Anthonie Stoete', 880, NULL, '1779', NULL, NULL, 'D', 'A', '1791-04-06', 'Batavia', '1791-07-24', '1791-09-20', true, '1791-12-27', 'Portsmouth', 4624, 'the 101 seafarers were 26 Chinese; the 4 passengers included a condemned person. The SCHOONDERLOO was sold at Portsmouth.');
INSERT INTO "voyages" VALUES (8316, '', 2, '', 'LUCHTBOL', 'Jakob Soetemans', 136, 'paketboot', '1788', NULL, NULL, 'R', 'R', '1791-06-01', 'Batavia', '1791-09-14', '1791-09-28', true, '1791-12-07', 'Goeree', 4676, NULL);
INSERT INTO "voyages" VALUES (8317, '', 2, '', 'OOSTZAANDAM', 'Jakob de Vries', 650, 'hoeker', NULL, NULL, NULL, NULL, 'A', '1791-07-06', 'Batavia', '1791-09-16', '1792-01-01', true, '1792-04-24', 'Texel', 4637, 'Originally the OOSTZAANDAM departed from the Cape on 27-10-1791. The ship was overtaken by a heavy storm, however, and was severely damaged. On 09-11-1791 it returned to the Cape.');
INSERT INTO "voyages" VALUES (8318, '', 1, '', 'ZEEMEEUW', 'Pieter Teteris', 136, 'paketboot', '1788', NULL, NULL, 'E', 'E', '1791-07-29', 'Tuticorin', '1791-09-09', '1791-10-08', true, '1791-12-06', 'Texel', 4667, 'According to K.A. 4390a Pierre Muntz was master of the ZEEMEEUW.');
INSERT INTO "voyages" VALUES (8319, '', 2, '', 'TEXELSTROOM', 'Barend Sterk', 780, 'hoeker', NULL, '1785', NULL, 'R', 'A', '1791-10-07', 'Batavia', '1791-12-12', '1792-02-21', true, '1792-05-29', 'Texel', 4675, 'The 3 passengers included a slave. 4675/8318 was the second voyage of this ship, which during the preceding voyage (4504/8235) and the outward-bound part of this voyage, was called STANDVASTIGHEID.');
INSERT INTO "voyages" VALUES (8320, '', 2, '', 'EENPARIGHEID', 'Ulke Barendsz.', 600, NULL, NULL, '1784', NULL, 'H', 'A', '1791-10-29', 'Batavia', '1792-01-01', '1792-01-29', true, '1792-04-26', 'Texel', 4642, 'Among the 2 passengers was a condemned person.');
INSERT INTO "voyages" VALUES (8321, '', 1, '', 'ZWAAN', 'Marinus van Vlaanderen', 1150, NULL, '1787', NULL, NULL, 'Z', 'Z', '1791-11-11', 'Batavia', '1792-01-25', '1792-02-21', true, '1792-05-21', 'Rammekens', 4678, 'The 9 passengers included 3 slaves and a condemned person.');
INSERT INTO "voyages" VALUES (8322, '', 4, '', 'DORDRECHT', 'Kornelis Willemsen', 898, 'fluit', NULL, NULL, NULL, 'D', 'A', '1791-11-16', 'Batavia', '1792-02-03', '1792-02-29', true, '1792-06-08', 'Texel', 4640, 'Among the 36 people were 4 passengers including a male and a female slave. 4640/8322 was the fourth voyage of this ship, which during the first voyage (4400/8087) was called BERLIN.');
INSERT INTO "voyages" VALUES (8323, '', 3, '', 'DRAAK', 'Hendrik Spijkerman', 1150, NULL, '1780', NULL, NULL, 'A', 'A', '1791-11-16', 'Ceylon', '1792-02-02', '1792-02-21', true, '1792-05-27', 'Texel', 4639, 'According to K.A. 4329 H. Munts was master of the DRAAK, 
acc. to K.A. 4390a Wietse de Boer. (See also 4700).');
INSERT INTO "voyages" VALUES (8324, '', 1, '', 'KRAAI', 'Swerus Magnus Cederborg', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1791-11-25', 'Batavia', '1792-02-07', '1792-02-21', true, '1792-05-14', 'Texel', 4690, NULL);
INSERT INTO "voyages" VALUES (8325, '', 3, '', 'MENTOR', 'Anthonie van Rijn', 560, NULL, NULL, '1789', NULL, 'Z', 'Z', '1791-12-01', 'Batavia', '1792-03-10', '1792-04-11', true, '1792-07-10', 'Rammekens', 4643, NULL);
INSERT INTO "voyages" VALUES (8326, '', 1, '', 'HOORNWEG', 'Dinant Visser', 880, NULL, '1787', NULL, NULL, 'D', 'R', '1791-12-21', 'Batavia', '1792-03-31', NULL, true, '1792-08-14', 'Goeree', 4659, NULL);
INSERT INTO "voyages" VALUES (8327, '', 2, '', 'HORSSEN', 'George Philip Gas', 880, NULL, '1784', NULL, NULL, 'D', 'D', '1791-12-21', 'Batavia', '1792-03-19', '1792-04-11', true, '1792-07-12', 'Goeree', 4609, 'The 12 passengers included one female and two male slaves.');
INSERT INTO "voyages" VALUES (8328, '', 2, '', 'STANDVASTIGHEID', 'Joost Masson', 708, NULL, NULL, '1785', NULL, 'A', 'R', '1791-12-21', 'Batavia', '1792-03-30', NULL, true, '1792-08-16', 'Goeree', 4602, 'voyage of this ship, which during the preceding voyage (4498/8182) and the outward-bound part of this voyage was called TEXELSTROOM. On 26-04-1791 the ship, then still called TEXELSTROOM, started its second homeward-bound voyage. Because of leakage, however, it had to return to Batavia 08-06-1791. Before sailing out for the second time, in December, 1791, the ship''s name was altered into STANDVASTIGHEID.');
INSERT INTO "voyages" VALUES (8329, '', 2, '', 'VREDENBURG', 'Hans Christiaan Christiaanse', 1150, NULL, '1784', NULL, NULL, 'A', 'A', '1791-12-21', 'Batavia', '1792-03-18', '1792-04-11', true, '1792-07-10', 'Texel', 4606, 'many BOUNTY-mutineers as possible (see the VLIJT, 8258). Edwards had succeeded in taking prisoner 14 of them. On 29-08-1791, however, the ship ran on a rock and was wrecked at Barrier Reef off New Holland; 31 men and 4 of the mutineers were drowned. In four small boats most of the survivors had managed to reach Timor. At Batavia Edwards, 30 other men, and the 10 remaining prisoners went aboard the VREDENBURG; at the Cape he and the prisoners boarded an English ship.');
INSERT INTO "voyages" VALUES (8330, '', 2, '', 'ALBLASSERDAM', 'Pieter Mallet jr.', 1150, NULL, '1782', NULL, NULL, 'Z', 'A', '1791-12-25', 'China', '1792-03-29', '1792-04-16', true, '1792-07-10', 'Texel', 4653, NULL);
INSERT INTO "voyages" VALUES (8331, '', 2, '', 'BLITTERSWIJK', 'Gerrit Esman', 1150, NULL, '1785', NULL, NULL, 'Z', 'Z', '1792-01-02', 'China', '1792-03-29', '1792-04-16', true, '1792-07-10', 'Rammekens', 4680, NULL);
INSERT INTO "voyages" VALUES (8332, '', 2, '', 'VROUWE AGATHA', 'Herman Petrus', 900, 'fluit', NULL, NULL, NULL, NULL, 'A', '1792-01-28', 'Batavia', '1792-04-16', NULL, true, '1792-08-31', 'Texel', 4646, 'According to K.A. 4329 Herman Pieter Murk was master.');
INSERT INTO "voyages" VALUES (8333, '', 2, '', 'HAASJE', 'Ditmar Smit', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1792-01-28', 'Batavia', '1792-03-29', '1792-04-11', true, '1792-06-28', 'Texel', 4702, 'According to K.A. 4390a Jakob Zoeteman was master.');
INSERT INTO "voyages" VALUES (8334, '', 3, '', 'STRALEN', 'Anton Christian von Fleischer', 880, NULL, '1778', NULL, NULL, 'E', 'R', '1792-01-31', 'Batavia', '1792-04-17', NULL, true, '1792-08-26', 'Goeree', 4597, NULL);
INSERT INTO "voyages" VALUES (8335, '', 2, '', 'CHRISTOFFEL COLUMBUS', 'Jan Jansz. Laurits', 1150, NULL, '1787', NULL, NULL, 'A', 'A', '1792-02-03', 'Ceylon', '1792-03-30', '1792-04-16', true, '1792-07-10', 'Texel', 4688, NULL);
INSERT INTO "voyages" VALUES (8336, '', 2, '', 'SNELHEID', 'Roelof Jurgen Erdrop', 136, 'paketboot', '1788', NULL, NULL, 'H', 'H', '1792-02-18', 'Bengal', '1792-05-05', '1792-05-15', true, '1792-07-30', 'Texel', 4696, NULL);
INSERT INTO "voyages" VALUES (8337, '', 2, '', 'GOUVERNEUR FALCK', 'Jan Anthonie Lubben', 1150, NULL, '1786', NULL, NULL, 'A', 'A', '1792-02-21', 'Batavia', NULL, NULL, true, NULL, NULL, 4670, 'Sailing from Batavia to the Cape the GOUVERNEUR FALCK was wrecked.');
INSERT INTO "voyages" VALUES (8338, '', 2, '', 'DRIE GEBROEDERS', 'Jan Roelofsz. de Groot', 828, 'fluit', NULL, NULL, NULL, NULL, 'A', '1792-02-22', 'Batavia', '1792-06-02', NULL, true, NULL, NULL, 4695, 'At the Cape the DRIE GEBROEDERS sprang a leak and was beached. The greater part of the cargo was saved.');
INSERT INTO "voyages" VALUES (8339, '', 3, '', 'BARBESTEIN', 'Johan Koenraad Knot', 1150, NULL, '1783', NULL, NULL, 'A', 'Z', '1792-02-28', 'Batavia', NULL, NULL, true, NULL, NULL, 4669, 'BARBESTEIN was wrecked.');
INSERT INTO "voyages" VALUES (8340, '', 1, '', 'STAR', 'Christiaan Zummack', 136, 'paketboot', '1788', NULL, NULL, '1', 'Z', '1792-03-21', 'Ceylon', '1792-05-04', '1792-05-15', true, '1792-07-23', 'Rammekens', 4665, NULL);
INSERT INTO "voyages" VALUES (8341, '', 2, '', 'VROUWE KATHARINA JOHANNA', 'Jakob Meyer', 900, NULL, NULL, '1785', NULL, 'H', 'H', '1792-03-23', 'Batavia', '1792-06-11', '1792-07-13', true, NULL, NULL, 4611, 'According to K.A. 4336 Andries Eksteen was master. On 13-07-1792 the VROUWE KATHARINA JOHANNA departed from the Cape; because of leakage, however, the ship had to return (09-08-1792). See also the CASTOR (8360) and the GOUDA (8362).');
INSERT INTO "voyages" VALUES (8342, '', 1, '', 'MAKASSAR', 'Klaas Keuken', 1150, NULL, '1787', NULL, NULL, 'E', 'E', '1792-04-10', 'Batavia', '1792-08-23', '1793-02-05', true, '1793-06-21', 'Texel', 4660, 'the voyage the ship fell astern.');
INSERT INTO "voyages" VALUES (8343, '', 1, '', 'CONSTITUTIE', 'Christiaan de Cerf', 880, NULL, '1788', NULL, NULL, 'H', 'A', '1792-05-26', 'Batavia', '1792-08-31', '1793-02-05', true, '1793-06-21', 'Texel', 4689, 'See also the MAKASSAR (8342).');
INSERT INTO "voyages" VALUES (8344, '', 1, '', 'GEERTRUIDA EN PETRONELLA', 'Lodewijk Willem van Rossum', 964, 'pink', NULL, NULL, NULL, NULL, 'A', '1792-05-26', 'Batavia', '1792-08-28', '1793-03-05', true, '1793-06-20', 'Texel', 4709, 'included 4 passengers; one of them was a female slave. See also the MAKASSAR (8342).');
INSERT INTO "voyages" VALUES (8345, '', 1, '', 'NIEUWSTAD', 'Kornelis van Deventer', 880, NULL, '1787', NULL, NULL, 'H', 'H', '1792-10-22', 'Batavia', '1792-12-28', '1793-02-05', true, '1793-06-21', 'Texel', 4662, 'See also the MAKASSAR (8342).');
INSERT INTO "voyages" VALUES (8346, '', 1, '', 'GOUVERNEUR-GENERAAL MOSSEL', 'Albert Coblijn', 1150, NULL, '1788', NULL, NULL, 'A', 'A', '1792-11-01', 'Batavia', '1793-01-07', '1793-02-05', true, '1793-06-22', 'Texel', 4661, 'See also the MAKASSAR (8342).');
INSERT INTO "voyages" VALUES (8347, '', 1, '', 'RUSTHOF', 'Petrus Stephanus Buissine', 880, NULL, '1788', NULL, NULL, 'D', 'D', '1792-11-01', 'Batavia', '1793-01-09', '1793-02-05', true, '1793-06-21', 'Texel', 4685, 'The 112 people included 10 passengers; 3 of them were slaves. See also the MAKASSAR (8342).');
INSERT INTO "voyages" VALUES (8348, '', 2, '', 'UNIE', 'Philip Hendrik de Haard', 1150, NULL, '1787', NULL, NULL, 'Z', 'A', '1792-11-01', 'Batavia', '1793-01-06', '1793-02-05', true, '1793-06-21', 'Texel', 4715, 'The master was commandeur of the homeward-bound fleet (see the MAKASSAR, 8342).');
INSERT INTO "voyages" VALUES (8349, '', 1, '', 'WESTKAPELLE', 'Simon Laurentius', 1150, NULL, '1788', NULL, NULL, 'Z', 'Z', '1792-11-01', 'Batavia', '1793-01-06', '1793-02-05', true, '1793-06-21', 'Texel', 4717, 'The 159 people included 5 passengers; among them were 3 slaves and Jan Greve, admiraal of the homeward-bound fleet (see the MAKASSAR, 8342). On 08-07-1793 the WESTKAPELLE sailed out from Texel; four days later the ship arrived at the Rammekens.');
INSERT INTO "voyages" VALUES (8350, '', 1, '', 'BUITENVERWACHTING', 'Arie Simonsz. Koek', 1150, NULL, '1789', NULL, NULL, 'A', 'A', '1792-11-15', 'Batavia', '1793-01-28', '1793-02-05', true, '1793-06-21', 'Texel', 4712, 'According to K.A. 4390a Gerard Adriaan van Velsen was master of the BUITENVERW ACHTING. The passenger was a condemned person. See also the MAKASSAR (8342).');
INSERT INTO "voyages" VALUES (8351, '', 2, '', 'VROUWE MARIA KORNELIA', 'Jan Arendsz.', 1150, NULL, '1785', NULL, NULL, 'E', 'E', '1792-11-27', 'Batavia', '1793-02-27', '1793-04-01', true, '1793-07-27', 'Texel', 4698, NULL);
INSERT INTO "voyages" VALUES (8352, '', 1, '', 'OOSTHUIZEN', 'Gerrit Scheler', 880, NULL, '1789', NULL, NULL, 'H', 'H', '1792-12-03', 'China', '1793-03-14', '1793-04-01', true, '1793-07-27', 'Texel', 4714, NULL);
INSERT INTO "voyages" VALUES (8353, '', 2, '', 'ZEELAND', 'Albert Tjerksz.', 1156, NULL, '1783', NULL, NULL, 'Z', 'Z', '1792-12-03', 'China', '1793-04-08', NULL, true, NULL, NULL, 4694, 'According to K.A. 4336 Jakob Arkebout was master. On 20-05-1793 the ZEELAND ran aground at the Cape. Later on the ship was sold.');
INSERT INTO "voyages" VALUES (8354, '', 2, '', 'LEIDEN', 'Theunis Groen', 1150, NULL, '1786', NULL, NULL, 'A', 'Z', '1792-12-20', 'Batavia', '1793-02-20', '1793-05-03', true, '1794-08-02', 'Texel', 4655, 'When the LEIDEN arrived at the Cape, it was in bad condition and needed repairs. Goods from the homeward-bound DRECHTERLAND (8359) were put on board. On 03-05-1793 the LEIDEN departed from the Cape. It got into a bad condition again, however, and had to return (08-05-1793). Part of the cargo was taken over by the RESOLUTIE (8366). The date of the LEIDEN''s second departure from the Cape is unknown.');
INSERT INTO "voyages" VALUES (8355, '', 3, '', 'ROZENBURG', 'Roelof Bengtson', 880, NULL, '1780', NULL, NULL, 'D', 'A', '1792-12-20', 'China', '1793-03-31', '1793-05-31', true, '1794-02-19', 'Texel', 4708, 'During the voyage the ROZENBURG called at Cork in Ireland. Commandeur of the homeward-bound fleet (8355-8358, 8364 and 8368), which on 31-05-1793 departed from the Cape, was J.C. Clemens on board the VERWACHTING (8357); Wiggert Molenaar, aboard the GERECHTIGHEID (8364), was schout-bij-nacht.');
INSERT INTO "voyages" VALUES (8356, '', 1, '', 'JONKVROUWE SIBILLA ANTHOINETTA', 'A. H. Christiaansz.', 1150, NULL, '1789', NULL, NULL, 'A', 'A', '1793-01-12', 'Ceylon', '1793-04-07', '1793-05-31', true, '1794-02-10', 'Texel', 4705, 'According to K.A. 4336 Nikolaas Klopper was master. During the voyage the JONKVROUWE SIBILLA ANTHOINETTA called at Cork in Ireland. See also the ROZENBURG (8355).');
INSERT INTO "voyages" VALUES (8357, '', 2, '', 'VERWACHTING', 'Pieter van Aarson', 600, 'hoeker', NULL, '1787', NULL, 'H', 'A', '1793-01-16', 'Batavia', '1793-04-05', '1793-05-31', true, '1794-02-10', 'Texel', 4707, 'On board the VERWACHTING was J. C. Clemens, commandeur of the fleet, which on 31-05-1793 departed from the Cape (see the ROZENBURG, 8355). During the voyage the VERWACHTING called at Cork in Ireland.');
INSERT INTO "voyages" VALUES (8358, '', 1, '', 'VOORLAND', 'Daniel Correch', 1150, NULL, '1788', NULL, NULL, 'A', 'Z', '1793-01-30', 'Batavia', '1793-05-06', '1793-05-31', true, '1794-02-09', 'Goeree', 4668, 'and at Duins, from where it departed on 30-01-1794. Because of bad weather the ship had to sail to Goeree; later on it went to Rammekens. See also the ROZENBURG (8355).');
INSERT INTO "voyages" VALUES (8359, '', 1, '', 'DRECHTERLAND', 'Eps', 1150, NULL, '1784', NULL, NULL, 'H', 'A', '1793-02-03', 'Ceylon', '1793-04-15', NULL, true, '1794-08-02', 'Texel', 4588, 'According to K.A. 3805 Jochem Westvaal was master of the DRECHTERLAND. See also the LEIDEN (8354).');
INSERT INTO "voyages" VALUES (8360, '', 2, '', 'CASTOR', 'Arie Smitskamp', 650, NULL, NULL, '1784', NULL, 'Z', 'A', '1793-02-05', 'The Cape', '1793-02-05', NULL, true, '1793-07-21', 'Texel', 4706, 'The CASTOR carried part of the cargo of the VROUWE KATHARINA JOHANNA (see 8341). See also the MAKASSAR (8342).');
INSERT INTO "voyages" VALUES (8361, '', 3, '', 'DUIFJE', 'Jan Olhof', 400, NULL, '1784', NULL, NULL, 'A', 'A', '1793-02-05', 'The Cape', '1793-02-05', NULL, true, '1793-06-20', 'Texel', 4727, 'See also the MAKASSAR (8342).');
INSERT INTO "voyages" VALUES (8362, '', 2, '', 'GOUDA', 'Anthonie Franciscus Steffers', 400, NULL, '1784', NULL, NULL, 'A', 'A', '1793-02-05', 'The Cape', '1793-02-05', NULL, true, '1793-06-20', 'Texel', 4718, 'Originally the GOUDA departed from the Cape on 16-08-1792; four days later the ship returned. The GOUDA carried part of the cargo of the VROUWE KATHARINA JOHANNA (see 8341). See also the MAKASSAR (8342).');
INSERT INTO "voyages" VALUES (8363, '', 1, '', 'DEMERARY', 'Erland Nicolaus Abo', 1150, NULL, '1787', NULL, NULL, 'A', 'R', '1793-02-07', 'Batavia', NULL, NULL, true, NULL, NULL, 4616, 'Between Batavia and the Cape the DEMERARY was wrecked. At the Cape the master of an American ship informed the Company''s authorities. that during the voyage he had spoken the DEMERARY and had found it in a very bad condition. See also the STAR (4748).');
INSERT INTO "voyages" VALUES (8364, '', 3, '', 'GERECHTIGHEID', 'Jan Jobst Droop', 1150, NULL, '1779', NULL, NULL, 'A', 'A', '1793-02-23', 'Ceylon', '1793-04-11', '1793-05-31', true, '1794-02-10', 'Texel', 4673, 'GERECHTIGHEID called at Cork in Ireland. On board the ship was Wiggert Molenaar, schout-bij-nacht of the homeward-bound fleet, which departed from the Cape on 31-05-1793 (see the ROZENBURG, 8355).');
INSERT INTO "voyages" VALUES (8365, '', 3, '', 'FAAM', 'Hidde Bok', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1793-02-27', 'Bengal', '1793-05-14', '1793-08-01', true, '1793-12-21', 'Texel', 4711, NULL);
INSERT INTO "voyages" VALUES (8366, '', 2, '', 'RESOLUTIE', 'Daniel Hendriks', 530, NULL, NULL, '1784', NULL, 'H', 'R', '1793-04-01', 'The Cape', '1793-04-01', NULL, true, '1793-07-27', 'Texel', 4730, 'cargo from the LEIDEN (see 8354).');
INSERT INTO "voyages" VALUES (8367, '', 3, '', 'MARIA LOUISA', 'Jakob Zoeteman', 136, 'paketboot', '1788', NULL, NULL, 'A', 'D', '1793-04-20', 'Batavia', '1793-07-30', NULL, true, '1793-12-08', 'Goeree', 4725, 'According to K.A. 4390a Pieter Mosterd was master of the MARIA LOUISA.');
INSERT INTO "voyages" VALUES (8368, '', 3, '', 'TEXELSTROOM', 'Jurriaan Kornelis Koertse', 780, 'hoeker', NULL, '1785', NULL, 'R', 'A', '1793-05-31', 'The Cape', '1793-05-31', NULL, true, '1794-01-01', 'Gluckstadt', 4735, 'Ireland. At Gluckstadt the ship was sold. See also the ROZENBURG (8355). 4735/8368 was the third voyage of this ship, which during its first voyage and the outward-bound part of the second voyage (4675/8318) was called STANDVASTIGHEID.');
INSERT INTO "voyages" VALUES (8369, '', 2, '', 'KRAAI', 'Jakob Sem', 136, 'paketboot', '1788', NULL, NULL, 'A', 'A', '1793-08-01', 'Batavia', '1793-09-29', '1793-10-17', true, '1794-04-17', 'Texel', 4731, 'In January, 1794, the KRAAI called at Plymouth, early in February at a Norwegian port.');
INSERT INTO "voyages" VALUES (8370, '', 2, '', 'EXPEDITIE', NULL, 136, 'paketboot', '1788', NULL, NULL, 'D', 'A', '1793-12-15', 'Batavia', NULL, NULL, true, NULL, NULL, 4741, 'On 04-01-1794 the EXPEDITIE was captured by a French privateer and taken to Mauritius.');
INSERT INTO "voyages" VALUES (8371, '', 3, '', 'AFRIKAAN', 'Wiggert Molenaar', 880, NULL, '1780', NULL, NULL, 'E', 'H', '1794-02-27', 'Batavia', NULL, NULL, true, '1794-10-22', 'Plymouth', 4732, 'AFRIKAAN was confiscated by the English at Plymouth.');
INSERT INTO "voyages" VALUES (8383, '', 1, '', 'HOUGLY', 'Arnold Rogge', 1150, NULL, '1788', NULL, NULL, 'A', 'A', '1794-11-22', 'Batavia', '1795-03-11', '1795-05-21', true, NULL, NULL, 4650, 'On 18-05-1795 the HOUGLY originally departed from the Cape, two days later the ship had to return because of adverse wind. In June, 1795, the HOUGLY was captured by the English off St. Helena; while sailing to Cork in Ireland they set the ship on fire and sank it (01-09-1795).');
INSERT INTO "voyages" VALUES (8384, '', 1, '', 'KROMHOUT', 'Gottlieb Havenstein', 880, NULL, '1790', NULL, NULL, 'H', 'H', '1794-11-22', 'Batavia', '1795-03-11', '1795-05-18', true, NULL, NULL, 4751, 'In August, 1795, the KROMHOUT was taken by the English off the Shetlands.');
INSERT INTO "voyages" VALUES (8385, '', 4, '', 'MENTOR', 'Ulke Barendsz.', 560, NULL, NULL, '1789', NULL, 'Z', 'Z', '1794-11-22', 'Batavia', '1795-03-11', '1795-05-21', true, NULL, NULL, 4746, 'two days later the ship had to return because of adverse wind. In June, 1795, the MENTOR was seized by the English off St. Helena and taken to Shannon in Ireland.');
INSERT INTO "voyages" VALUES (8386, '', 2, '', 'SURSEANCE', 'Diedrich Wiese', 768, NULL, NULL, '1786', NULL, 'Z', 'Z', '1794-11-22', 'Batavia', '1795-03-11', '1795-05-21', true, NULL, NULL, 4747, 'Helena. On 05-09-1795 the ship was wrecked.');
INSERT INTO "voyages" VALUES (8387, '', 1, '', 'CEYLON', 'Willem Kol', 900, 'pink', '1791', NULL, NULL, 'A', 'A', '1795-01-23', 'Batavia', '1795-05-16', '1795-06-07', true, '1795-10-31', 'Setubal', 4742, 'Date of departure from the Cape unknown (see also the PHOENICIER, 8376). On board the CEYLON was J.C. Oldenburg, commandeur of the homeward-bound ships in 1795.');
INSERT INTO "voyages" VALUES (8388, '', 2, '', 'MAKASSAR', 'Frederik Markt', 1150, NULL, '1787', NULL, NULL, 'E', 'E', '1795-01-23', 'Batavia', '1795-05-16', NULL, true, NULL, NULL, 4766, 'Date of departure from the Cape unknown (see also the PHOENICIER, 8376). The MAKASSAR was taken by the English off St. Helena and brought to the Thames.');
INSERT INTO "voyages" VALUES (8389, '', 2, '', 'NOORD-HOLLAND', 'Wijs', 894, 'fluit', NULL, NULL, NULL, NULL, 'A', '1795-01-23', 'Batavia', '1795-05-16', NULL, true, '1795-10-03', 'Setubal', 4758, 'unknown (see also the PHOENICIER, (8376).');
INSERT INTO "voyages" VALUES (8390, '', 3, '', 'STANDVASTIGHEID', 'Karel Jakob Brugman', 708, NULL, NULL, '1785', NULL, 'A', 'Z', '1795-01-23', 'Batavia', '1795-05-16', '1795-06-07', true, '1795-10-03', 'Setubal', 4761, 'The passenger was a condemned person. The date of departure from the Cape is unknown. see also the PHOENICIER (8376). 4761/8390 was the third voyage and the outward-bound part of the second voyage (4602/8328) was called TEXELSTROOM.');
INSERT INTO "voyages" VALUES (8391, '', 3, '', 'VLIJT', 'Francois Moser', 136, 'paketboot', '1788', NULL, NULL, 'Z', 'Z', '1795-01-23', 'Batavia', '1795-05-06', '1795-05-18', true, '1795-09-18', 'Bergen', 4722, NULL);
INSERT INTO "voyages" VALUES (8392, '', 1, '', 'SIAM', 'George Philip Gas', 880, NULL, '1789', NULL, NULL, 'D', 'D', '1795-01-24', 'China', '1795-05-03', '1795-05-18', true, '1795-09-01', 'Trondheim', 4760, NULL);
INSERT INTO "voyages" VALUES (8393, '', 1, '', 'WASHINGTON', 'Gerard Adriaan van Velsen', 1150, NULL, '1791', NULL, NULL, 'A', 'A', '1795-01-24', 'China', '1795-05-02', '1795-05-18', true, '1795-09-01', 'Bergen', 4759, NULL);
INSERT INTO "voyages" VALUES (8394, '', 1, '', 'ZEELELIE', 'Kornelis Adriaansz', 1150, NULL, '1789', NULL, NULL, 'Z', 'Z', '1795-01-24', 'China', '1795-05-03', '1795-05-21', true, NULL, NULL, 4762, 'off St. Helena and taken to Shannon in Ireland. The ship was wrecked off the Scilly Islands later that year.');
INSERT INTO "voyages" VALUES (8395, '', 2, '', 'ZWAAN', 'Jan Olhof', 1150, NULL, '1787', NULL, NULL, 'Z', 'A', '1795-01-24', 'China', '1795-05-03', '1795-05-18', true, '1795-09-18', 'Trondheim', 4737, NULL);
INSERT INTO "voyages" VALUES (8396, '', 3, '', 'ALBLASSERDAM', 'Klaas Keuken', 1150, NULL, '1782', NULL, NULL, 'Z', 'A', '1795-01-01', 'Ceylon', '1795-05-06', '1795-05-21', true, NULL, NULL, 4764, 'was a condemned person.');
INSERT INTO "voyages" VALUES (8397, '', 1, '', 'ZUIDPOOL', 'J. A. van der Putten', 900, 'pink', '1791', NULL, NULL, 'Z', 'Z', '1795-01-01', 'Ceylon', '1795-04-25', '1795-05-18', true, '1795-09-18', 'Trondheim', 4772, NULL);
INSERT INTO "voyages" VALUES (8398, '', 2, '', 'MEERMIN', 'Gerard Ewoud Overbeek', 500, 'fregat', '1782', NULL, NULL, 'A', 'A', '1795-01-01', 'Batavia', '1795-05-21', NULL, true, NULL, NULL, 4674, 'to return because of adverse wind. In June, 1795, the MEERMIN was captured by the English off St. Helena and taken to Shannon in Ireland.');
INSERT INTO "voyages" VALUES (8399, '', 1, '', 'JONGE BONIFACIUS', 'Jan Nikolaas Kroese', 488, NULL, NULL, NULL, NULL, 'Z', 'Z', '1795-01-01', NULL, '1795-06-24', NULL, true, NULL, NULL, 4774, 'Almost all data concerning this homeward-bound voyage are missing. In August, 1795, the JONGE BONIFACIUS was captured by the English at the Cape.');
INSERT INTO "voyages" VALUES (8400, '', 1, '', 'LOUISA ANTHONY', 'Kersje Hillebrandsz.', 640, 'fluit', NULL, NULL, NULL, 'A', 'A', '1795-01-01', NULL, '1795-08-15', NULL, true, NULL, NULL, 4777, 'Almost all data concerning this homeward-bound voyage are missing. In August, 1795, the LOUISA ANTHONY was taken by the English at the Cape.');
INSERT INTO "voyages" VALUES (8401, '', 1, '', 'VERTROUWEN', 'Hillebrand van Uijen', 890, 'fluit', NULL, NULL, NULL, 'A', 'A', '1795-01-01', NULL, '1795-08-14', NULL, true, NULL, NULL, 4778, 'the English at the Cape.');

CREATE TABLE "craftsmen" (
	"number"               integer	NOT NULL,
	"number_sup"           char(1)	NOT NULL,
	"trip"                 integer,
	"trip_sup"             char(1),
	"onboard_at_departure" integer,
	"death_at_cape"        integer,
	"left_at_cape"         integer,
	"onboard_at_cape"      integer,
	"death_during_voyage"  integer,
	"onboard_at_arrival"   integer
);

INSERT INTO "craftsmen" VALUES (1376, '', 3, '', 19, NULL, NULL, NULL, NULL, 19);
INSERT INTO "craftsmen" VALUES (1378, '', 5, '', 22, NULL, NULL, NULL, NULL, 22);
INSERT INTO "craftsmen" VALUES (1379, '', 5, '', 18, NULL, NULL, NULL, 2, 16);
INSERT INTO "craftsmen" VALUES (1380, '', 3, '', 11, NULL, NULL, NULL, 1, 10);
INSERT INTO "craftsmen" VALUES (1381, '', 5, '', 11, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (1383, '', 5, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (1397, '', 3, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (1401, '', 1, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (1403, '', 3, '', 13, NULL, NULL, 1, 4, 10);
INSERT INTO "craftsmen" VALUES (1482, '', 2, '', 3, NULL, 3, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (1507, '', 2, '', 3, NULL, 3, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (1516, '', 1, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "craftsmen" VALUES (1521, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (1523, '', 4, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (1608, '', 3, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "craftsmen" VALUES (1621, '', 3, '', 4, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (1974, '', 3, '', 6, NULL, 2, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2311, '', 1, '', 2, 1, 1, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (2325, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2326, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2336, '', 4, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2338, '', 3, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (2339, '', 5, '', 3, NULL, NULL, 1, NULL, 4);
INSERT INTO "craftsmen" VALUES (2340, '', 3, '', 8, NULL, 1, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (2343, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2344, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2346, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2347, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2351, '', 5, '', 10, NULL, 7, 1, NULL, 4);
INSERT INTO "craftsmen" VALUES (2352, '', 2, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "craftsmen" VALUES (2353, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2355, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (2358, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2359, '', 2, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2361, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2362, '', 2, '', 5, NULL, 3, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2363, '', 3, '', 4, NULL, 1, 1, NULL, 4);
INSERT INTO "craftsmen" VALUES (2365, '', 6, '', 5, NULL, 3, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (2367, '', 2, '', 4, NULL, 1, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (2368, '', 4, '', 5, 1, NULL, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (2375, '', 5, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2376, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (2377, '', 4, '', 4, NULL, NULL, NULL, 2, 2);
INSERT INTO "craftsmen" VALUES (2381, '', 1, '', 2, NULL, NULL, 1, NULL, 3);
INSERT INTO "craftsmen" VALUES (2385, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (2394, '', 2, '', 3, NULL, 1, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2396, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2397, '', 1, '', 6, NULL, 1, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (2398, '', 4, '', 6, NULL, 6, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (2399, '', 3, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (2400, '', 6, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2401, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2402, '', 2, '', 2, NULL, 1, 3, NULL, 4);
INSERT INTO "craftsmen" VALUES (2404, '', 5, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2406, '', 3, '', 4, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2407, '', 4, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (2408, '', 2, '', 7, NULL, 1, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (2412, '', 5, '', 7, NULL, NULL, NULL, 3, 4);
INSERT INTO "craftsmen" VALUES (2415, '', 4, '', 4, NULL, NULL, NULL, 2, 2);
INSERT INTO "craftsmen" VALUES (2416, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2417, '', 5, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2418, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2420, '', 3, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2421, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2422, '', 1, '', 2, NULL, 1, NULL, 1, NULL);
INSERT INTO "craftsmen" VALUES (2423, '', 4, '', 3, NULL, 2, NULL, 1, NULL);
INSERT INTO "craftsmen" VALUES (2424, '', 4, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2426, '', 6, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (2427, '', 4, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (2428, '', 4, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2429, '', 1, '', 2, NULL, NULL, 2, 1, 3);
INSERT INTO "craftsmen" VALUES (2436, '', 2, '', 6, 1, 1, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (2437, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2438, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2439, '', 1, '', 5, NULL, 2, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (2440, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2443, '', 2, '', 2, NULL, 1, NULL, 1, NULL);
INSERT INTO "craftsmen" VALUES (2445, '', 2, '', 4, NULL, NULL, 1, 1, 4);
INSERT INTO "craftsmen" VALUES (2447, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2452, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2453, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2454, '', 1, '', 2, NULL, NULL, NULL, 2, NULL);
INSERT INTO "craftsmen" VALUES (2456, '', 3, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (2458, '', 2, '', 2, NULL, NULL, 1, NULL, 3);
INSERT INTO "craftsmen" VALUES (2459, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2460, '', 7, '', 2, NULL, 1, NULL, 1, NULL);
INSERT INTO "craftsmen" VALUES (2463, '', 5, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "craftsmen" VALUES (2486, '', 2, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2491, '', 3, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2496, '', 1, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2497, '', 5, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2500, '', 1, '', 3, NULL, 1, 1, 2, 1);
INSERT INTO "craftsmen" VALUES (2502, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2503, '', 1, '', 4, NULL, 2, 1, 2, 1);
INSERT INTO "craftsmen" VALUES (2504, '', 4, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "craftsmen" VALUES (2505, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2508, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2509, '', 4, '', 3, NULL, 1, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (2511, '', 6, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (2515, '', 7, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2518, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2519, '', 2, '', 5, 1, NULL, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (2523, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2525, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2529, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2530, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2531, '', 6, '', 3, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2532, '', 1, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2533, '', 7, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2535, '', 2, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (2536, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2537, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2541, '', 1, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "craftsmen" VALUES (2542, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2546, '', 3, '', 2, NULL, 1, 1, NULL, 2);
INSERT INTO "craftsmen" VALUES (2559, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2560, '', 3, '', 3, 1, NULL, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (2561, '', 2, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2562, '', 4, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2565, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2567, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2568, '', 2, '', 6, NULL, 1, 1, 3, 3);
INSERT INTO "craftsmen" VALUES (2570, '', 4, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2571, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2572, '', 4, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (2573, '', 1, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "craftsmen" VALUES (2574, '', 3, '', 91, 1, 2, NULL, 2, 87);
INSERT INTO "craftsmen" VALUES (2578, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2580, '', 2, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2581, '', 1, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (2582, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2585, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2586, '', 5, '', 3, NULL, NULL, 1, NULL, 4);
INSERT INTO "craftsmen" VALUES (2587, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2589, '', 1, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "craftsmen" VALUES (2590, '', 1, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "craftsmen" VALUES (2591, '', 1, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "craftsmen" VALUES (2592, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2595, '', 7, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2596, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2601, '', 5, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (2602, '', 4, '', 4, NULL, 2, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2603, '', 3, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2604, '', 5, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2610, '', 1, '', 4, NULL, 1, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (2611, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2613, '', 1, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (2614, '', 2, '', 7, NULL, 1, 1, 1, 6);
INSERT INTO "craftsmen" VALUES (2615, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2617, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (2618, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2625, '', 3, '', 6, NULL, 1, NULL, 3, 2);
INSERT INTO "craftsmen" VALUES (2627, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2629, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (2631, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2632, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2633, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2634, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2635, '', 6, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2636, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2638, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2639, '', 4, '', 8, NULL, NULL, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (2640, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2641, '', 5, '', 1, NULL, 1, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (2642, '', 3, '', 4, NULL, 1, 2, NULL, 5);
INSERT INTO "craftsmen" VALUES (2643, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2644, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2646, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2648, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2649, '', 4, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2650, '', 4, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (2651, '', 3, '', 3, NULL, NULL, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (2652, '', 3, '', 9, NULL, 1, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (2653, '', 5, '', 5, NULL, NULL, 1, NULL, 6);
INSERT INTO "craftsmen" VALUES (2654, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2655, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2656, '', 2, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2657, '', 3, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (2658, '', 2, '', 3, NULL, 1, 1, NULL, 3);
INSERT INTO "craftsmen" VALUES (2659, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2660, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2661, '', 7, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2662, '', 3, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2663, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2664, '', 1, '', 1, 1, NULL, NULL, 1, NULL);
INSERT INTO "craftsmen" VALUES (2666, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2667, '', 5, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2668, '', 3, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2669, '', 4, '', 3, NULL, NULL, 1, NULL, 4);
INSERT INTO "craftsmen" VALUES (2670, '', 5, '', 4, NULL, NULL, 1, NULL, 5);
INSERT INTO "craftsmen" VALUES (2673, '', 3, '', 7, NULL, NULL, NULL, 3, 4);
INSERT INTO "craftsmen" VALUES (2674, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2675, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (2677, '', 2, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (2678, '', 1, '', 4, NULL, 1, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2679, '', 5, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2681, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2682, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2684, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2685, '', 3, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2687, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2688, '', 8, '', 4, NULL, 1, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (2689, '', 7, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2690, '', 3, '', 4, NULL, NULL, 1, NULL, 5);
INSERT INTO "craftsmen" VALUES (2691, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2692, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2694, '', 1, '', 1, NULL, 1, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (2695, '', 1, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2698, '', 2, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (2699, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2700, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2701, '', 6, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (2702, '', 6, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2703, '', 7, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (2704, '', 4, '', 8, NULL, NULL, NULL, 3, 5);
INSERT INTO "craftsmen" VALUES (2705, '', 6, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2706, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2707, '', 1, '', 6, NULL, NULL, 1, 3, 4);
INSERT INTO "craftsmen" VALUES (2708, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2710, '', 3, '', 8, NULL, 5, 1, NULL, 4);
INSERT INTO "craftsmen" VALUES (2712, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (2713, '', 7, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2714, '', 3, '', 5, NULL, NULL, NULL, 2, 2);
INSERT INTO "craftsmen" VALUES (2715, '', 4, '', 6, NULL, 1, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (2716, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2717, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2718, '', 3, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2719, '', 4, '', 5, 1, NULL, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (2721, '', 3, '', 4, 1, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (2723, '', 6, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (2725, '', 4, '', 7, 1, 2, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (2730, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2732, '', 6, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2733, '', 5, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (2734, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2735, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2736, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2737, '', 5, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "craftsmen" VALUES (2738, '', 4, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2739, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2740, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2741, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2742, '', 1, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (2744, '', 5, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2745, '', 4, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2746, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2747, '', 5, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2748, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2749, '', 3, '', 10, NULL, 1, NULL, 3, 6);
INSERT INTO "craftsmen" VALUES (2750, '', 3, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (2751, '', 6, '', 7, NULL, 1, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (2752, '', 2, '', 3, NULL, NULL, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (2753, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2754, '', 4, '', 12, NULL, 1, NULL, 1, 10);
INSERT INTO "craftsmen" VALUES (2756, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2757, '', 9, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2758, '', 4, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (2761, '', 4, '', 7, NULL, 1, 1, NULL, 7);
INSERT INTO "craftsmen" VALUES (2762, '', 4, '', 8, NULL, 2, NULL, 3, 3);
INSERT INTO "craftsmen" VALUES (2763, '', 6, '', 9, NULL, 2, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (2764, '', 5, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2766, '', 4, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2767, '', 4, '', 15, NULL, 1, 2, NULL, 16);
INSERT INTO "craftsmen" VALUES (2768, '', 4, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (2769, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2770, '', 5, '', 5, NULL, NULL, 4, 1, 8);
INSERT INTO "craftsmen" VALUES (2771, '', 2, '', 4, NULL, NULL, 1, 3, 2);
INSERT INTO "craftsmen" VALUES (2772, '', 5, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2774, '', 2, '', 5, NULL, NULL, 1, 2, 4);
INSERT INTO "craftsmen" VALUES (2775, '', 6, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (2776, '', 3, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (2777, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2778, '', 1, '', 12, NULL, 6, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (2779, '', 4, '', 12, NULL, 2, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (2780, '', 4, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (2781, '', 3, '', 13, NULL, NULL, NULL, 2, 11);
INSERT INTO "craftsmen" VALUES (2784, '', 3, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (2785, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2786, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2787, '', 3, '', 1, NULL, NULL, 3, NULL, 4);
INSERT INTO "craftsmen" VALUES (2788, '', 8, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2789, '', 4, '', 14, NULL, 2, NULL, 5, 7);
INSERT INTO "craftsmen" VALUES (2790, '', 7, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (2792, '', 4, '', 7, NULL, 1, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (2793, '', 1, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2794, '', 7, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2795, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2798, '', 2, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (2799, '', 4, '', 5, NULL, 1, 2, 2, 4);
INSERT INTO "craftsmen" VALUES (2800, '', 4, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2802, '', 3, '', 3, NULL, NULL, 4, 1, 6);
INSERT INTO "craftsmen" VALUES (2803, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2804, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2806, '', 1, '', 2, NULL, 1, 1, 1, 1);
INSERT INTO "craftsmen" VALUES (2807, '', 6, '', 5, NULL, NULL, NULL, 4, 1);
INSERT INTO "craftsmen" VALUES (2808, '', 3, '', 6, NULL, NULL, 2, 1, 6);
INSERT INTO "craftsmen" VALUES (2810, '', 4, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "craftsmen" VALUES (2811, '', 4, '', 5, NULL, NULL, 1, 3, 3);
INSERT INTO "craftsmen" VALUES (2812, '', 1, '', 20, 1, 2, NULL, 1, 17);
INSERT INTO "craftsmen" VALUES (2813, '', 4, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (2814, '', 5, '', 13, NULL, 1, NULL, 6, 6);
INSERT INTO "craftsmen" VALUES (2815, '', 5, '', 7, NULL, 2, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2816, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2817, '', 1, '', 3, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2819, '', 1, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2820, '', 1, '', 12, NULL, 1, NULL, 2, 9);
INSERT INTO "craftsmen" VALUES (2821, '', 6, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2824, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2825, '', 3, '', 15, NULL, 1, 1, NULL, 15);
INSERT INTO "craftsmen" VALUES (2826, '', 5, '', 13, NULL, 3, 1, 1, 10);
INSERT INTO "craftsmen" VALUES (2827, '', 4, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (2828, '', 7, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2829, '', 6, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (2831, '', 7, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (2832, '', 5, '', 13, NULL, 2, 1, 2, 10);
INSERT INTO "craftsmen" VALUES (2833, '', 5, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (2835, '', 3, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2836, '', 6, '', 8, NULL, 1, 1, NULL, 8);
INSERT INTO "craftsmen" VALUES (2839, '', 3, '', 2, NULL, NULL, 2, 1, 3);
INSERT INTO "craftsmen" VALUES (2841, '', 5, '', 7, NULL, 2, 2, 3, 4);
INSERT INTO "craftsmen" VALUES (2842, '', 6, '', 7, NULL, NULL, NULL, 7, NULL);
INSERT INTO "craftsmen" VALUES (2843, '', 7, '', 3, NULL, NULL, 1, 3, 1);
INSERT INTO "craftsmen" VALUES (2844, '', 6, '', 11, NULL, 2, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (2845, '', 5, '', 13, NULL, 3, NULL, 3, 7);
INSERT INTO "craftsmen" VALUES (2846, '', 3, '', 3, NULL, NULL, 1, NULL, 3);
INSERT INTO "craftsmen" VALUES (2847, '', 1, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (2848, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2849, '', 1, '', 8, NULL, 2, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (2850, '', 5, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2851, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2852, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2853, '', 3, '', 7, NULL, 1, 2, NULL, 8);
INSERT INTO "craftsmen" VALUES (2854, '', 5, '', 16, NULL, 6, NULL, 1, 9);
INSERT INTO "craftsmen" VALUES (2855, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (2856, '', 1, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2857, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2858, '', 4, '', 3, NULL, 1, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (2859, '', 4, '', 18, NULL, 1, NULL, NULL, 17);
INSERT INTO "craftsmen" VALUES (2860, '', 5, '', 12, NULL, 5, NULL, 1, 6);
INSERT INTO "craftsmen" VALUES (2861, '', 1, '', 11, NULL, 2, NULL, 1, 8);
INSERT INTO "craftsmen" VALUES (2864, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2866, '', 2, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (2867, '', 4, '', 10, NULL, 1, 1, 1, 9);
INSERT INTO "craftsmen" VALUES (2868, '', 9, '', 5, NULL, 1, 1, 1, 4);
INSERT INTO "craftsmen" VALUES (2869, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2870, '', 6, '', 6, NULL, 2, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2871, '', 8, '', 4, NULL, 1, 2, 2, 3);
INSERT INTO "craftsmen" VALUES (2872, '', 3, '', 13, NULL, 5, 3, 4, 7);
INSERT INTO "craftsmen" VALUES (2873, '', 5, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (2874, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (2875, '', 6, '', 6, NULL, 1, NULL, 3, 2);
INSERT INTO "craftsmen" VALUES (2876, '', 1, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (2879, '', 8, '', 5, NULL, NULL, NULL, 2, 3);
INSERT INTO "craftsmen" VALUES (2880, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2883, '', 3, '', 10, NULL, 4, NULL, 4, 2);
INSERT INTO "craftsmen" VALUES (2884, '', 1, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "craftsmen" VALUES (2885, '', 1, '', 6, NULL, NULL, 1, 1, 6);
INSERT INTO "craftsmen" VALUES (2886, '', 4, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2887, '', 5, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2888, '', 3, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "craftsmen" VALUES (2890, '', 2, '', 8, NULL, NULL, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (2891, '', 5, '', 15, NULL, NULL, NULL, 1, 14);
INSERT INTO "craftsmen" VALUES (2892, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2893, '', 8, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2894, '', 1, '', 9, NULL, NULL, NULL, 1, 8);
INSERT INTO "craftsmen" VALUES (2899, '', 1, '', 7, NULL, NULL, 1, NULL, 8);
INSERT INTO "craftsmen" VALUES (2900, '', 6, '', 19, NULL, 7, 1, 1, 12);
INSERT INTO "craftsmen" VALUES (2901, '', 6, '', 11, NULL, NULL, 2, 1, 12);
INSERT INTO "craftsmen" VALUES (2902, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (2905, '', 4, '', 3, NULL, 1, 1, NULL, 3);
INSERT INTO "craftsmen" VALUES (2906, '', 7, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (2907, '', 5, '', 19, NULL, 10, 1, 4, 6);
INSERT INTO "craftsmen" VALUES (2909, '', 7, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2910, '', 1, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (2911, '', 6, '', 8, NULL, NULL, NULL, 2, 6);
INSERT INTO "craftsmen" VALUES (2912, '', 7, '', 21, NULL, 5, 5, 10, 11);
INSERT INTO "craftsmen" VALUES (2913, '', 4, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (2914, '', 5, '', 7, NULL, NULL, NULL, 1, 6);
INSERT INTO "craftsmen" VALUES (2915, '', 2, '', 19, NULL, 3, 3, 3, 16);
INSERT INTO "craftsmen" VALUES (2916, '', 5, '', 2, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2919, '', 1, '', 2, NULL, 1, 5, 1, 5);
INSERT INTO "craftsmen" VALUES (2921, '', 1, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "craftsmen" VALUES (2923, '', 5, '', 7, NULL, 1, 1, NULL, 7);
INSERT INTO "craftsmen" VALUES (2924, '', 6, '', 3, NULL, NULL, 1, 1, 3);
INSERT INTO "craftsmen" VALUES (2925, '', 1, '', 9, NULL, 1, NULL, 3, 5);
INSERT INTO "craftsmen" VALUES (2926, '', 3, '', 12, NULL, 2, NULL, 4, 6);
INSERT INTO "craftsmen" VALUES (2927, '', 3, '', 7, NULL, NULL, NULL, 1, 6);
INSERT INTO "craftsmen" VALUES (2928, '', 2, '', 22, NULL, 3, NULL, 1, 18);
INSERT INTO "craftsmen" VALUES (2929, '', 3, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (2930, '', 1, '', 9, NULL, NULL, 1, 2, 8);
INSERT INTO "craftsmen" VALUES (2931, '', 2, '', 7, NULL, NULL, NULL, 1, 6);
INSERT INTO "craftsmen" VALUES (2932, '', 1, '', 3, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2933, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2934, '', 1, '', 15, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (2936, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2938, '', 9, '', 6, NULL, NULL, 2, NULL, 8);
INSERT INTO "craftsmen" VALUES (2939, '', 5, '', 9, NULL, NULL, 1, NULL, 10);
INSERT INTO "craftsmen" VALUES (2941, '', 1, '', 7, NULL, NULL, NULL, 2, 5);
INSERT INTO "craftsmen" VALUES (2942, '', 2, '', 7, NULL, NULL, 1, 2, 6);
INSERT INTO "craftsmen" VALUES (2944, '', 4, '', 13, NULL, 2, NULL, 2, 9);
INSERT INTO "craftsmen" VALUES (2945, '', 5, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2946, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2948, '', 4, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2949, '', 5, '', 2, NULL, NULL, 2, 1, 3);
INSERT INTO "craftsmen" VALUES (2950, '', 1, '', 11, NULL, 3, 1, 2, 7);
INSERT INTO "craftsmen" VALUES (2951, '', 3, '', 6, NULL, NULL, NULL, 2, 4);
INSERT INTO "craftsmen" VALUES (2952, '', 7, '', 9, NULL, NULL, NULL, 2, 7);
INSERT INTO "craftsmen" VALUES (2953, '', 2, '', 4, NULL, 1, 1, 2, 2);
INSERT INTO "craftsmen" VALUES (2954, '', 3, '', 14, NULL, 1, NULL, 5, 8);
INSERT INTO "craftsmen" VALUES (2955, '', 3, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (2956, '', 5, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2957, '', 5, '', 13, NULL, 1, NULL, 2, 10);
INSERT INTO "craftsmen" VALUES (2958, '', 1, '', 5, NULL, NULL, 1, 1, 5);
INSERT INTO "craftsmen" VALUES (2959, '', 4, '', 11, NULL, 4, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (2960, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2961, '', 6, '', 10, NULL, 5, 2, 2, 5);
INSERT INTO "craftsmen" VALUES (2962, '', 6, '', 4, NULL, NULL, NULL, 2, 2);
INSERT INTO "craftsmen" VALUES (2963, '', 4, '', 14, NULL, NULL, NULL, NULL, 14);
INSERT INTO "craftsmen" VALUES (2964, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2965, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (2966, '', 1, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2967, '', 1, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (2968, '', 1, '', 9, NULL, NULL, NULL, 1, 8);
INSERT INTO "craftsmen" VALUES (2969, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (2970, '', 8, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (2971, '', 2, '', 19, NULL, 1, NULL, NULL, 18);
INSERT INTO "craftsmen" VALUES (2972, '', 2, '', 21, NULL, 3, NULL, 4, 14);
INSERT INTO "craftsmen" VALUES (2973, '', 7, '', 20, NULL, NULL, NULL, 3, 17);
INSERT INTO "craftsmen" VALUES (2976, '', 3, '', 8, NULL, 1, 5, 2, 10);
INSERT INTO "craftsmen" VALUES (2979, '', 6, '', 9, NULL, 1, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (2980, '', 2, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (2981, '', 4, '', 13, NULL, 4, NULL, 2, 7);
INSERT INTO "craftsmen" VALUES (2982, '', 2, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (2984, '', 3, '', 13, NULL, NULL, 1, NULL, 14);
INSERT INTO "craftsmen" VALUES (2985, '', 2, '', 11, NULL, NULL, NULL, 2, 9);
INSERT INTO "craftsmen" VALUES (2986, '', 5, '', 16, NULL, NULL, 1, 3, 14);
INSERT INTO "craftsmen" VALUES (2987, '', 7, '', 6, NULL, NULL, NULL, 3, 3);
INSERT INTO "craftsmen" VALUES (2988, '', 6, '', 14, NULL, 2, 4, 3, 15);
INSERT INTO "craftsmen" VALUES (2991, '', 5, '', 11, NULL, 1, NULL, 1, 10);
INSERT INTO "craftsmen" VALUES (2992, '', 1, '', 11, NULL, NULL, NULL, 1, 10);
INSERT INTO "craftsmen" VALUES (2993, '', 1, '', 6, NULL, 1, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (2994, '', 1, '', 9, NULL, 1, NULL, 3, 5);
INSERT INTO "craftsmen" VALUES (2995, '', 5, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (2996, '', 3, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (2997, '', 1, '', 8, NULL, NULL, NULL, 2, 6);
INSERT INTO "craftsmen" VALUES (2998, '', 1, '', 20, NULL, 7, 4, 8, 9);
INSERT INTO "craftsmen" VALUES (2999, '', 6, '', 8, NULL, 2, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3000, '', 3, '', 12, NULL, 3, 3, NULL, 12);
INSERT INTO "craftsmen" VALUES (3001, '', 1, '', 14, NULL, 2, 2, 2, 12);
INSERT INTO "craftsmen" VALUES (3002, '', 2, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3003, '', 3, '', 18, NULL, 3, NULL, 3, 12);
INSERT INTO "craftsmen" VALUES (3004, '', 1, '', 12, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (3005, '', 2, '', 16, NULL, 2, NULL, NULL, 14);
INSERT INTO "craftsmen" VALUES (3006, '', 5, '', 11, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (3007, '', 4, '', 20, NULL, NULL, NULL, NULL, 20);
INSERT INTO "craftsmen" VALUES (3009, '', 2, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3010, '', 10, '', 30, NULL, 1, NULL, 3, 26);
INSERT INTO "craftsmen" VALUES (3011, '', 2, '', 15, NULL, 2, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (3013, '', 3, '', 14, NULL, NULL, 3, 1, 7);
INSERT INTO "craftsmen" VALUES (3014, '', 7, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3015, '', 2, '', 21, NULL, NULL, NULL, NULL, 21);
INSERT INTO "craftsmen" VALUES (3017, '', 2, '', 19, NULL, NULL, NULL, 1, 18);
INSERT INTO "craftsmen" VALUES (3018, '', 1, '', 11, NULL, 2, 1, 4, 6);
INSERT INTO "craftsmen" VALUES (3022, '', 6, '', 2, NULL, NULL, 3, NULL, 5);
INSERT INTO "craftsmen" VALUES (3023, '', 2, '', 13, NULL, 1, NULL, 3, 9);
INSERT INTO "craftsmen" VALUES (3024, '', 1, '', 14, NULL, 2, 1, 3, 10);
INSERT INTO "craftsmen" VALUES (3025, '', 4, '', 22, NULL, 2, NULL, NULL, 20);
INSERT INTO "craftsmen" VALUES (3026, '', 4, '', 8, NULL, 1, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (3028, '', 5, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (3029, '', 6, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (3030, '', 4, '', 8, NULL, 1, NULL, 2, 5);
INSERT INTO "craftsmen" VALUES (3031, '', 3, '', 14, NULL, 1, NULL, 2, 7);
INSERT INTO "craftsmen" VALUES (3032, '', 1, '', 11, NULL, 2, 5, 5, 9);
INSERT INTO "craftsmen" VALUES (3033, '', 3, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3034, '', 1, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3035, '', 5, '', 13, NULL, 1, 1, 2, 11);
INSERT INTO "craftsmen" VALUES (3036, '', 4, '', 18, NULL, NULL, NULL, 1, 17);
INSERT INTO "craftsmen" VALUES (3037, '', 4, '', 11, NULL, 1, 1, 2, 9);
INSERT INTO "craftsmen" VALUES (3038, '', 1, '', 23, NULL, NULL, NULL, 2, 21);
INSERT INTO "craftsmen" VALUES (3039, '', 1, '', 4, NULL, 1, NULL, 2, 1);
INSERT INTO "craftsmen" VALUES (3040, '', 1, '', 10, NULL, NULL, 2, NULL, 12);
INSERT INTO "craftsmen" VALUES (3041, '', 1, '', 14, NULL, NULL, NULL, NULL, 14);
INSERT INTO "craftsmen" VALUES (3042, '', 2, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3043, '', 7, '', 20, 7, NULL, 3, 7, 16);
INSERT INTO "craftsmen" VALUES (3044, '', 1, '', 9, NULL, 1, 2, 1, 9);
INSERT INTO "craftsmen" VALUES (3045, '', 6, '', 14, NULL, 4, 1, 1, 10);
INSERT INTO "craftsmen" VALUES (3046, '', 2, '', 14, NULL, 4, 3, 5, 8);
INSERT INTO "craftsmen" VALUES (3047, '', 1, '', 13, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (3048, '', 2, '', 16, NULL, 1, NULL, 3, 12);
INSERT INTO "craftsmen" VALUES (3050, '', 4, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3051, '', 2, '', 10, 1, NULL, NULL, 1, 9);
INSERT INTO "craftsmen" VALUES (3052, '', 7, '', 8, NULL, 1, 1, 2, 6);
INSERT INTO "craftsmen" VALUES (3053, '', 4, '', 4, 2, 1, NULL, 2, 1);
INSERT INTO "craftsmen" VALUES (3055, '', 4, '', 5, NULL, 1, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (3056, '', 1, '', 13, NULL, 3, 2, 4, 7);
INSERT INTO "craftsmen" VALUES (3057, '', 2, '', 6, NULL, NULL, NULL, 4, 2);
INSERT INTO "craftsmen" VALUES (3058, '', 1, '', 6, NULL, NULL, NULL, 2, 4);
INSERT INTO "craftsmen" VALUES (3059, '', 3, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3060, '', 5, '', 9, NULL, 2, NULL, 1, 6);
INSERT INTO "craftsmen" VALUES (3061, '', 2, '', 13, 2, 2, NULL, 2, 9);
INSERT INTO "craftsmen" VALUES (3062, '', 1, '', 8, NULL, 3, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3063, '', 3, '', 21, NULL, 2, NULL, NULL, 19);
INSERT INTO "craftsmen" VALUES (3064, '', 8, '', 12, NULL, 2, NULL, 1, 9);
INSERT INTO "craftsmen" VALUES (3065, '', 6, '', 5, NULL, NULL, 2, 3, 4);
INSERT INTO "craftsmen" VALUES (3066, '', 1, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3067, '', 2, '', 8, NULL, 1, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (3068, '', 2, '', 9, NULL, 1, 8, 4, 12);
INSERT INTO "craftsmen" VALUES (3069, '', 1, '', 17, 9, 4, 4, 10, 7);
INSERT INTO "craftsmen" VALUES (3070, '', 2, '', 11, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (3072, '', 1, '', 10, NULL, NULL, 2, 5, 7);
INSERT INTO "craftsmen" VALUES (3073, '', 3, '', 13, NULL, 2, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (3074, '', 3, '', 6, NULL, NULL, 4, 2, 8);
INSERT INTO "craftsmen" VALUES (3075, '', 1, '', 14, NULL, 1, 2, 1, 14);
INSERT INTO "craftsmen" VALUES (3076, '', 2, '', 14, NULL, 2, NULL, 2, 10);
INSERT INTO "craftsmen" VALUES (3077, '', 1, '', 10, NULL, NULL, NULL, 2, 8);
INSERT INTO "craftsmen" VALUES (3078, '', 6, '', 11, NULL, 1, NULL, 1, 9);
INSERT INTO "craftsmen" VALUES (3079, '', 5, '', 10, NULL, NULL, NULL, 3, 7);
INSERT INTO "craftsmen" VALUES (3080, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3081, '', 6, '', 10, NULL, 1, NULL, 3, 6);
INSERT INTO "craftsmen" VALUES (3083, '', 7, '', 15, NULL, NULL, NULL, 3, 12);
INSERT INTO "craftsmen" VALUES (3084, '', 3, '', 14, 1, 1, NULL, 1, 12);
INSERT INTO "craftsmen" VALUES (3085, '', 3, '', 10, NULL, NULL, NULL, 1, 9);
INSERT INTO "craftsmen" VALUES (3086, '', 1, '', 10, NULL, 1, NULL, 2, 6);
INSERT INTO "craftsmen" VALUES (3087, '', 1, '', 11, NULL, NULL, 2, 2, 11);
INSERT INTO "craftsmen" VALUES (3088, '', 2, '', 7, NULL, NULL, 3, 3, 7);
INSERT INTO "craftsmen" VALUES (3089, '', 1, '', 12, NULL, NULL, NULL, 2, 10);
INSERT INTO "craftsmen" VALUES (3090, '', 1, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "craftsmen" VALUES (3091, '', 7, '', 8, NULL, NULL, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (3092, '', 3, '', 8, NULL, 1, 6, 11, 2);
INSERT INTO "craftsmen" VALUES (3094, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3096, '', 2, '', 6, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3097, '', 3, '', 10, NULL, 1, NULL, 4, 5);
INSERT INTO "craftsmen" VALUES (3098, '', 2, '', 4, NULL, NULL, NULL, NULL, 12);
INSERT INTO "craftsmen" VALUES (3099, '', 2, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3100, '', 1, '', 4, NULL, 1, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (3101, '', 11, '', 8, NULL, 2, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (3102, '', 7, '', 11, NULL, 1, NULL, 6, 4);
INSERT INTO "craftsmen" VALUES (3103, '', 2, '', 7, NULL, NULL, NULL, 2, 5);
INSERT INTO "craftsmen" VALUES (3104, '', 4, '', 8, NULL, 1, 1, 2, 6);
INSERT INTO "craftsmen" VALUES (3105, '', 1, '', 9, 1, NULL, NULL, 1, 8);
INSERT INTO "craftsmen" VALUES (3106, '', 2, '', 2, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3107, '', 3, '', 9, NULL, 2, NULL, 4, 3);
INSERT INTO "craftsmen" VALUES (3108, '', 3, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (3109, '', 4, '', 61, NULL, 11, 13, 11, 52);
INSERT INTO "craftsmen" VALUES (3110, '', 3, '', 11, NULL, 2, 1, 2, 8);
INSERT INTO "craftsmen" VALUES (3111, '', 3, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (3113, '', 5, '', 5, NULL, NULL, 2, 3, 4);
INSERT INTO "craftsmen" VALUES (3114, '', 6, '', 7, NULL, NULL, NULL, 1, 6);
INSERT INTO "craftsmen" VALUES (3115, '', 4, '', 7, NULL, NULL, 3, 3, 7);
INSERT INTO "craftsmen" VALUES (3116, '', 2, '', 4, NULL, NULL, 1, NULL, 5);
INSERT INTO "craftsmen" VALUES (3117, '', 4, '', 4, NULL, 1, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (3119, '', 5, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3122, '', 2, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (3123, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3124, '', 3, '', 16, NULL, NULL, NULL, NULL, 16);
INSERT INTO "craftsmen" VALUES (3125, '', 2, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3126, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3127, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3128, '', 1, '', 2, 1, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (3129, '', 3, '', 10, NULL, 1, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3130, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3131, '', 1, '', 6, NULL, 1, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (3132, '', 2, '', 7, NULL, NULL, NULL, 4, 3);
INSERT INTO "craftsmen" VALUES (3133, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3135, '', 2, '', 7, NULL, 1, 3, 1, 7);
INSERT INTO "craftsmen" VALUES (3137, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (3139, '', 3, '', 12, NULL, 2, NULL, 1, 9);
INSERT INTO "craftsmen" VALUES (3143, '', 3, '', 61, NULL, 4, NULL, 2, 55);
INSERT INTO "craftsmen" VALUES (3144, '', 4, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3145, '', 6, '', 13, NULL, 4, NULL, 2, 7);
INSERT INTO "craftsmen" VALUES (3146, '', 1, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3147, '', 2, '', 1, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (3148, '', 7, '', 13, NULL, 6, 1, 3, 5);
INSERT INTO "craftsmen" VALUES (3149, '', 4, '', 10, NULL, 1, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3150, '', 6, '', 13, NULL, NULL, NULL, 2, 11);
INSERT INTO "craftsmen" VALUES (3151, '', 2, '', 10, NULL, 6, 4, 1, 7);
INSERT INTO "craftsmen" VALUES (3152, '', 3, '', 12, NULL, NULL, NULL, 3, 9);
INSERT INTO "craftsmen" VALUES (3153, '', 5, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3154, '', 3, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (3155, '', 3, '', 5, NULL, 1, 7, 1, 10);
INSERT INTO "craftsmen" VALUES (3157, '', 5, '', 8, NULL, 5, 1, 2, 2);
INSERT INTO "craftsmen" VALUES (3158, '', 1, '', 4, NULL, NULL, 2, NULL, 6);
INSERT INTO "craftsmen" VALUES (3159, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3160, '', 4, '', 7, NULL, 1, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (3161, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3162, '', 1, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (3164, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3165, '', 1, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (3166, '', 11, '', 4, NULL, 1, 3, 1, 5);
INSERT INTO "craftsmen" VALUES (3167, '', 3, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "craftsmen" VALUES (3169, '', 7, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3170, '', 4, '', 11, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (3172, '', 3, '', 6, NULL, 1, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (3175, '', 4, '', 10, 2, NULL, NULL, 2, 8);
INSERT INTO "craftsmen" VALUES (3177, '', 1, '', 17, NULL, 6, NULL, 3, 8);
INSERT INTO "craftsmen" VALUES (3178, '', 2, '', 3, NULL, NULL, NULL, 3, NULL);
INSERT INTO "craftsmen" VALUES (3179, '', 7, '', 3, NULL, NULL, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (3180, '', 2, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (3181, '', 5, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (3182, '', 4, '', 13, 7, NULL, NULL, 7, 6);
INSERT INTO "craftsmen" VALUES (3183, '', 8, '', 15, NULL, 5, NULL, 8, 2);
INSERT INTO "craftsmen" VALUES (3184, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3185, '', 6, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3187, '', 3, '', 3, NULL, NULL, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (3188, '', 2, '', 3, NULL, NULL, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (3189, '', 1, '', 9, 5, 1, 1, 5, 4);
INSERT INTO "craftsmen" VALUES (3196, '', 7, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "craftsmen" VALUES (3201, '', 4, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (3205, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3210, '', 7, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (3230, '', 5, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3231, '', 5, '', 4, NULL, NULL, NULL, 2, 2);
INSERT INTO "craftsmen" VALUES (3232, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3238, '', 3, '', 4, NULL, 1, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (3239, '', 1, '', 6, NULL, NULL, NULL, 2, 4);
INSERT INTO "craftsmen" VALUES (3242, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3244, '', 4, '', 1, NULL, NULL, 1, 1, 1);
INSERT INTO "craftsmen" VALUES (3249, '', 2, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3254, '', 1, '', 1, NULL, 1, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (3256, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (3258, '', 3, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (3259, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (3260, '', 6, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3261, '', 5, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "craftsmen" VALUES (3269, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3270, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3277, '', 2, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3279, '', 1, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (3280, '', 1, '', 3, NULL, NULL, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (3289, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3298, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3299, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3301, '', 4, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3302, '', 4, '', 6, NULL, 1, NULL, 2, 3);
INSERT INTO "craftsmen" VALUES (3305, '', 1, '', 13, NULL, 1, NULL, 7, 6);
INSERT INTO "craftsmen" VALUES (3306, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3307, '', 3, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3309, '', 2, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3310, '', 2, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3313, '', 1, '', 8, NULL, NULL, NULL, 4, 4);
INSERT INTO "craftsmen" VALUES (3314, '', 2, '', 18, NULL, 1, NULL, 5, 12);
INSERT INTO "craftsmen" VALUES (3315, '', 2, '', 17, NULL, 3, NULL, 7, 7);
INSERT INTO "craftsmen" VALUES (3316, '', 1, '', 16, NULL, 2, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (3317, '', 5, '', 9, NULL, 3, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3318, '', 4, '', 12, 4, 2, NULL, 4, 6);
INSERT INTO "craftsmen" VALUES (3319, '', 5, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (3320, '', 4, '', 9, NULL, 1, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (3321, '', 1, '', 15, NULL, NULL, NULL, 3, 12);
INSERT INTO "craftsmen" VALUES (3323, '', 3, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (3324, '', 4, '', 8, NULL, 1, 1, 2, 6);
INSERT INTO "craftsmen" VALUES (3325, '', 2, '', 12, NULL, 1, NULL, 9, 2);
INSERT INTO "craftsmen" VALUES (3326, '', 4, '', 15, NULL, NULL, NULL, 1, 14);
INSERT INTO "craftsmen" VALUES (3327, '', 3, '', 12, NULL, NULL, 4, 2, 14);
INSERT INTO "craftsmen" VALUES (3328, '', 5, '', 21, NULL, 3, 2, 15, 5);
INSERT INTO "craftsmen" VALUES (3329, '', 4, '', 4, NULL, NULL, NULL, 3, 1);
INSERT INTO "craftsmen" VALUES (3331, '', 2, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (3332, '', 2, '', 21, NULL, NULL, NULL, 4, 17);
INSERT INTO "craftsmen" VALUES (3334, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3335, '', 1, '', 6, NULL, 2, 1, 2, 3);
INSERT INTO "craftsmen" VALUES (3336, '', 4, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (3337, '', 4, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3338, '', 4, '', 19, NULL, NULL, NULL, 4, 15);
INSERT INTO "craftsmen" VALUES (3339, '', 1, '', 16, NULL, 2, NULL, 2, 12);
INSERT INTO "craftsmen" VALUES (3340, '', 2, '', NULL, NULL, NULL, 1, 1, NULL);
INSERT INTO "craftsmen" VALUES (3341, '', 1, '', 30, NULL, 1, NULL, 8, 21);
INSERT INTO "craftsmen" VALUES (3342, '', 5, '', 23, NULL, 6, 1, 3, 15);
INSERT INTO "craftsmen" VALUES (3345, '', 1, '', 13, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (3347, '', 1, '', 6, NULL, NULL, NULL, 2, 4);
INSERT INTO "craftsmen" VALUES (3348, '', 1, '', 7, NULL, NULL, NULL, 1, 6);
INSERT INTO "craftsmen" VALUES (3349, '', 9, '', 9, NULL, NULL, 1, 2, 8);
INSERT INTO "craftsmen" VALUES (3351, '', 3, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (3352, '', 7, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3353, '', 4, '', 24, NULL, NULL, NULL, 1, 23);
INSERT INTO "craftsmen" VALUES (3354, '', 6, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3355, '', 2, '', 17, NULL, NULL, NULL, 4, 13);
INSERT INTO "craftsmen" VALUES (3356, '', 3, '', 21, NULL, NULL, NULL, 2, 19);
INSERT INTO "craftsmen" VALUES (3357, '', 1, '', 19, NULL, NULL, NULL, 3, 16);
INSERT INTO "craftsmen" VALUES (3358, '', 2, '', 10, NULL, NULL, 1, 2, 9);
INSERT INTO "craftsmen" VALUES (3360, '', 3, '', 12, NULL, 1, NULL, 4, 7);
INSERT INTO "craftsmen" VALUES (3361, '', 6, '', 15, NULL, 5, 1, 1, 11);
INSERT INTO "craftsmen" VALUES (3362, '', 3, '', 4, NULL, NULL, NULL, 3, 2);
INSERT INTO "craftsmen" VALUES (3363, '', 4, '', 3, 3, NULL, NULL, 3, NULL);
INSERT INTO "craftsmen" VALUES (3364, '', 1, '', 7, NULL, 1, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3365, '', 2, '', 11, NULL, 1, 2, 5, 8);
INSERT INTO "craftsmen" VALUES (3366, '', 6, '', 18, NULL, 1, NULL, 5, 12);
INSERT INTO "craftsmen" VALUES (3367, '', 3, '', 20, NULL, 4, NULL, 3, 13);
INSERT INTO "craftsmen" VALUES (3369, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3370, '', 1, '', 17, NULL, NULL, NULL, 4, 15);
INSERT INTO "craftsmen" VALUES (3371, '', 5, '', 13, NULL, 1, 1, 6, 7);
INSERT INTO "craftsmen" VALUES (3372, '', 1, '', 15, NULL, 1, NULL, 5, 9);
INSERT INTO "craftsmen" VALUES (3374, '', 1, '', 10, NULL, 1, NULL, 1, 8);
INSERT INTO "craftsmen" VALUES (3375, '', 1, '', 7, NULL, 1, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3376, '', 6, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3377, '', 2, '', 7, NULL, 1, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3378, '', 1, '', 12, NULL, 2, 1, 2, 9);
INSERT INTO "craftsmen" VALUES (3379, '', 1, '', 20, NULL, 2, NULL, 5, 13);
INSERT INTO "craftsmen" VALUES (3380, '', 1, '', 11, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (3381, '', 2, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (3382, '', 2, '', 8, NULL, NULL, 1, 5, 4);
INSERT INTO "craftsmen" VALUES (3383, '', 2, '', 8, NULL, 1, 1, 1, 7);
INSERT INTO "craftsmen" VALUES (3384, '', 2, '', 7, NULL, NULL, 1, NULL, 8);
INSERT INTO "craftsmen" VALUES (3385, '', 1, '', 7, NULL, 4, 1, 2, 2);
INSERT INTO "craftsmen" VALUES (3387, '', 2, '', 12, NULL, 1, 5, 2, 14);
INSERT INTO "craftsmen" VALUES (3388, '', 4, '', 6, NULL, NULL, 1, 2, 5);
INSERT INTO "craftsmen" VALUES (3390, '', 3, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3391, '', 2, '', 5, NULL, NULL, NULL, 2, 3);
INSERT INTO "craftsmen" VALUES (3393, '', 1, '', 113, 11, 5, 2, 19, 93);
INSERT INTO "craftsmen" VALUES (3394, '', 4, '', 5, NULL, NULL, NULL, 3, 2);
INSERT INTO "craftsmen" VALUES (3395, '', 1, '', 4, NULL, NULL, NULL, 2, 2);
INSERT INTO "craftsmen" VALUES (3396, '', 1, '', 2, NULL, NULL, 1, NULL, 3);
INSERT INTO "craftsmen" VALUES (3397, '', 2, '', 7, NULL, NULL, NULL, 4, 3);
INSERT INTO "craftsmen" VALUES (3398, '', 1, '', 5, NULL, 1, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (3400, '', 2, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (3401, '', 2, '', 17, NULL, NULL, NULL, 7, 10);
INSERT INTO "craftsmen" VALUES (3402, '', 3, '', 8, NULL, 4, 1, 3, 2);
INSERT INTO "craftsmen" VALUES (3403, '', 1, '', 7, NULL, NULL, NULL, 1, 6);
INSERT INTO "craftsmen" VALUES (3405, '', 5, '', 17, NULL, NULL, NULL, NULL, 17);
INSERT INTO "craftsmen" VALUES (3406, '', 1, '', 19, NULL, NULL, NULL, 5, 14);
INSERT INTO "craftsmen" VALUES (3407, '', 2, '', 20, NULL, NULL, 3, 14, 8);
INSERT INTO "craftsmen" VALUES (3410, '', 1, '', 108, NULL, 23, 13, 22, 73);
INSERT INTO "craftsmen" VALUES (3411, '', 1, '', 6, NULL, NULL, NULL, 3, 3);
INSERT INTO "craftsmen" VALUES (3412, '', 1, '', 10, NULL, 1, NULL, 2, 7);
INSERT INTO "craftsmen" VALUES (3413, '', 1, '', 9, NULL, NULL, NULL, 1, 8);
INSERT INTO "craftsmen" VALUES (3414, '', 1, '', 12, NULL, NULL, NULL, 3, 9);
INSERT INTO "craftsmen" VALUES (3415, '', 4, '', 13, NULL, 1, NULL, 5, 7);
INSERT INTO "craftsmen" VALUES (3417, '', 2, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (3418, '', 2, '', 4, NULL, NULL, 1, NULL, 5);
INSERT INTO "craftsmen" VALUES (3419, '', 1, '', 7, NULL, 1, NULL, 4, 2);
INSERT INTO "craftsmen" VALUES (3422, '', 4, '', 9, NULL, 5, NULL, 4, NULL);
INSERT INTO "craftsmen" VALUES (3424, '', 6, '', NULL, NULL, NULL, 1, 1, NULL);
INSERT INTO "craftsmen" VALUES (3425, '', 1, '', 8, NULL, 1, 1, 3, 5);
INSERT INTO "craftsmen" VALUES (3426, '', 3, '', 7, NULL, 2, NULL, 2, 3);
INSERT INTO "craftsmen" VALUES (3427, '', 1, '', 16, NULL, 1, NULL, NULL, 15);
INSERT INTO "craftsmen" VALUES (3428, '', 5, '', 14, NULL, 1, 1, 6, 7);
INSERT INTO "craftsmen" VALUES (3429, '', 2, '', 6, NULL, NULL, 3, 3, 6);
INSERT INTO "craftsmen" VALUES (3431, '', 1, '', 9, NULL, NULL, NULL, 2, 7);
INSERT INTO "craftsmen" VALUES (3432, '', 3, '', 10, NULL, 1, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3434, '', 4, '', 8, NULL, 1, NULL, 3, 4);
INSERT INTO "craftsmen" VALUES (3435, '', 2, '', 14, NULL, NULL, 1, NULL, 6);
INSERT INTO "craftsmen" VALUES (3436, '', 2, '', 7, NULL, NULL, 1, NULL, 7);
INSERT INTO "craftsmen" VALUES (3438, '', 1, '', 16, NULL, 2, NULL, 6, 8);
INSERT INTO "craftsmen" VALUES (3441, '', 2, '', 65, NULL, 9, NULL, 16, 40);
INSERT INTO "craftsmen" VALUES (3442, '', 2, '', 4, NULL, NULL, NULL, 2, 2);
INSERT INTO "craftsmen" VALUES (3443, '', 2, '', 101, NULL, 41, 12, 23, 42);
INSERT INTO "craftsmen" VALUES (3444, '', 3, '', 5, NULL, NULL, NULL, 2, 3);
INSERT INTO "craftsmen" VALUES (3446, '', 5, '', 9, NULL, NULL, NULL, 2, 7);
INSERT INTO "craftsmen" VALUES (3447, '', 4, '', 12, NULL, NULL, NULL, NULL, 12);
INSERT INTO "craftsmen" VALUES (3448, '', 6, '', 10, NULL, 1, NULL, 1, 8);
INSERT INTO "craftsmen" VALUES (3449, '', 1, '', 10, NULL, NULL, 1, 1, 5);
INSERT INTO "craftsmen" VALUES (3450, '', 2, '', 11, NULL, 3, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (3451, '', 2, '', 13, NULL, NULL, NULL, 3, 9);
INSERT INTO "craftsmen" VALUES (3452, '', 3, '', 8, NULL, 2, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3453, '', 2, '', 10, NULL, 2, 2, 3, 7);
INSERT INTO "craftsmen" VALUES (3454, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3455, '', 3, '', 6, NULL, NULL, NULL, 4, 2);
INSERT INTO "craftsmen" VALUES (3456, '', 4, '', 11, NULL, 1, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3457, '', 1, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (3458, '', 1, '', 16, NULL, NULL, NULL, 6, 10);
INSERT INTO "craftsmen" VALUES (3459, '', 5, '', 7, NULL, 2, NULL, 2, 3);
INSERT INTO "craftsmen" VALUES (3460, '', 4, '', 22, NULL, NULL, NULL, NULL, 22);
INSERT INTO "craftsmen" VALUES (3461, '', 3, '', 10, NULL, 2, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (3462, '', 5, '', 165, 7, 9, 5, 5, 150);
INSERT INTO "craftsmen" VALUES (3463, '', 3, '', 8, NULL, NULL, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (3464, '', 3, '', 10, NULL, 1, NULL, 5, 4);
INSERT INTO "craftsmen" VALUES (3465, '', 3, '', 4, NULL, 2, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3468, '', 2, '', 7, NULL, 4, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3469, '', 1, '', 10, NULL, NULL, NULL, 1, 9);
INSERT INTO "craftsmen" VALUES (3470, '', 1, '', 9, NULL, NULL, NULL, 2, 7);
INSERT INTO "craftsmen" VALUES (3471, '', 7, '', 10, NULL, 1, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3472, '', 2, '', 9, NULL, 1, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (3474, '', 5, '', 13, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (3476, '', 1, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3477, '', 2, '', 10, NULL, 1, 2, 1, 10);
INSERT INTO "craftsmen" VALUES (3478, '', 2, '', 15, NULL, 1, 2, 1, 15);
INSERT INTO "craftsmen" VALUES (3481, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3482, '', 1, '', 11, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (3484, '', 1, '', 16, NULL, 1, 1, 2, 14);
INSERT INTO "craftsmen" VALUES (3486, '', 2, '', 14, NULL, NULL, NULL, 1, 13);
INSERT INTO "craftsmen" VALUES (3487, '', 1, '', 17, NULL, NULL, NULL, 4, 13);
INSERT INTO "craftsmen" VALUES (3488, '', 2, '', 10, NULL, NULL, 1, 1, 10);
INSERT INTO "craftsmen" VALUES (3489, '', 3, '', 12, NULL, NULL, NULL, 2, 10);
INSERT INTO "craftsmen" VALUES (3490, '', 3, '', 4, NULL, NULL, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (3491, '', 2, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3492, '', 3, '', 7, NULL, 2, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (3495, '', 4, '', 5, NULL, 2, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3496, '', 2, '', 8, NULL, 3, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (3497, '', 1, '', 13, NULL, 3, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3498, '', 1, '', 16, NULL, 2, NULL, 4, 8);
INSERT INTO "craftsmen" VALUES (3499, '', 4, '', 13, NULL, NULL, NULL, 1, 12);
INSERT INTO "craftsmen" VALUES (3500, '', 3, '', 19, NULL, 1, NULL, 4, 13);
INSERT INTO "craftsmen" VALUES (3501, '', 2, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3502, '', 2, '', 14, NULL, 1, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (3503, '', 2, '', 25, NULL, 4, NULL, 2, 16);
INSERT INTO "craftsmen" VALUES (3504, '', 2, '', 16, NULL, 3, NULL, 2, 11);
INSERT INTO "craftsmen" VALUES (3505, '', 3, '', 8, NULL, NULL, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (3506, '', 3, '', 16, NULL, 1, NULL, 1, 14);
INSERT INTO "craftsmen" VALUES (3507, '', 1, '', 13, NULL, 7, NULL, 1, 12);
INSERT INTO "craftsmen" VALUES (3508, '', 1, '', 13, NULL, NULL, NULL, 5, 7);
INSERT INTO "craftsmen" VALUES (3509, '', 1, '', 12, NULL, NULL, 1, 1, 12);
INSERT INTO "craftsmen" VALUES (3510, '', 3, '', 16, NULL, 1, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (3511, '', 3, '', 15, 1, NULL, NULL, 1, 14);
INSERT INTO "craftsmen" VALUES (3512, '', 1, '', 15, NULL, NULL, NULL, 1, 15);
INSERT INTO "craftsmen" VALUES (3514, '', 1, '', 2, NULL, 1, 2, NULL, 3);
INSERT INTO "craftsmen" VALUES (3516, '', 1, '', 78, NULL, 8, 2, 13, NULL);
INSERT INTO "craftsmen" VALUES (3517, '', 5, '', 11, 2, NULL, 4, 2, 12);
INSERT INTO "craftsmen" VALUES (3520, '', 3, '', 11, NULL, 1, NULL, 2, 8);
INSERT INTO "craftsmen" VALUES (3521, '', 2, '', 10, NULL, NULL, NULL, 1, 9);
INSERT INTO "craftsmen" VALUES (3523, '', 4, '', 8, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (3524, '', 1, '', 14, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (3525, '', 1, '', 8, NULL, 2, NULL, 5, 1);
INSERT INTO "craftsmen" VALUES (3526, '', 1, '', 8, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (3527, '', 3, '', 11, NULL, 1, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3528, '', 1, '', 24, NULL, 3, NULL, 1, 20);
INSERT INTO "craftsmen" VALUES (3529, '', 2, '', 4, NULL, 1, 1, NULL, 4);
INSERT INTO "craftsmen" VALUES (3531, '', 3, '', 15, NULL, NULL, NULL, 1, 14);
INSERT INTO "craftsmen" VALUES (3532, '', 3, '', 11, NULL, NULL, NULL, 1, 10);
INSERT INTO "craftsmen" VALUES (3534, '', 2, '', 12, NULL, 1, NULL, 1, 10);
INSERT INTO "craftsmen" VALUES (3535, '', 4, '', 12, NULL, 2, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3536, '', 3, '', 20, NULL, NULL, NULL, NULL, 20);
INSERT INTO "craftsmen" VALUES (3537, '', 1, '', 13, NULL, NULL, NULL, 1, 12);
INSERT INTO "craftsmen" VALUES (3538, '', 2, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3539, '', 1, '', 21, NULL, 1, NULL, 2, 18);
INSERT INTO "craftsmen" VALUES (3540, '', 1, '', 12, NULL, NULL, NULL, 1, 11);
INSERT INTO "craftsmen" VALUES (3541, '', 1, '', 12, NULL, NULL, NULL, 1, 11);
INSERT INTO "craftsmen" VALUES (3542, '', 2, '', 12, NULL, NULL, 1, NULL, 13);
INSERT INTO "craftsmen" VALUES (3543, '', 4, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (3546, '', 3, '', 18, NULL, 1, 3, 7, 13);
INSERT INTO "craftsmen" VALUES (3547, '', 6, '', 3, NULL, NULL, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (3548, '', 4, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3550, '', 2, '', 10, NULL, 1, 2, NULL, 11);
INSERT INTO "craftsmen" VALUES (3551, '', 2, '', 18, NULL, NULL, NULL, NULL, 18);
INSERT INTO "craftsmen" VALUES (3553, '', 4, '', 141, NULL, 15, 8, 5, 118);
INSERT INTO "craftsmen" VALUES (3554, '', 4, '', 14, NULL, 1, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (3555, '', 3, '', 15, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (3556, '', 3, '', 17, NULL, 1, NULL, NULL, 16);
INSERT INTO "craftsmen" VALUES (3558, '', 2, '', 12, NULL, NULL, NULL, 1, 11);
INSERT INTO "craftsmen" VALUES (3559, '', 1, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3560, '', 5, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3561, '', 1, '', 14, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3562, '', 2, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (3563, '', 1, '', 17, NULL, NULL, NULL, 3, 12);
INSERT INTO "craftsmen" VALUES (3564, '', 2, '', 19, NULL, NULL, NULL, NULL, 19);
INSERT INTO "craftsmen" VALUES (3568, '', 5, '', 21, NULL, 4, NULL, 1, 16);
INSERT INTO "craftsmen" VALUES (3569, '', 1, '', 13, NULL, NULL, NULL, 1, 12);
INSERT INTO "craftsmen" VALUES (3570, '', 1, '', 14, NULL, NULL, NULL, 1, 13);
INSERT INTO "craftsmen" VALUES (3571, '', 1, '', 10, NULL, 1, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3572, '', 1, '', 20, NULL, 4, 4, NULL, 20);
INSERT INTO "craftsmen" VALUES (3573, '', 1, '', 11, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (3574, '', 1, '', 95, NULL, 14, 4, 26, 58);
INSERT INTO "craftsmen" VALUES (3575, '', 2, '', 12, NULL, NULL, NULL, NULL, 12);
INSERT INTO "craftsmen" VALUES (3576, '', 2, '', 23, NULL, NULL, NULL, 1, 22);
INSERT INTO "craftsmen" VALUES (3577, '', 3, '', 10, NULL, 1, NULL, 3, 6);
INSERT INTO "craftsmen" VALUES (3578, '', 3, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (3579, '', 3, '', 13, NULL, NULL, NULL, 2, 11);
INSERT INTO "craftsmen" VALUES (3583, '', 2, '', 13, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (3584, '', 5, '', 20, NULL, NULL, NULL, NULL, 20);
INSERT INTO "craftsmen" VALUES (3585, '', 3, '', 11, NULL, 1, NULL, 3, 7);
INSERT INTO "craftsmen" VALUES (3586, '', 3, '', 10, 4, NULL, NULL, 4, 6);
INSERT INTO "craftsmen" VALUES (3587, '', 2, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3588, '', 1, '', 10, NULL, 1, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3589, '', 4, '', 15, NULL, 1, 1, NULL, 15);
INSERT INTO "craftsmen" VALUES (3590, '', 1, '', 13, NULL, 1, 1, NULL, 13);
INSERT INTO "craftsmen" VALUES (3591, '', 5, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (3592, '', 2, '', 6, NULL, NULL, 2, 2, 6);
INSERT INTO "craftsmen" VALUES (3593, '', 4, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (3594, '', 4, '', 11, NULL, 1, 1, NULL, 9);
INSERT INTO "craftsmen" VALUES (3595, '', 1, '', 16, NULL, NULL, 1, 2, 15);
INSERT INTO "craftsmen" VALUES (3596, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3597, '', 4, '', 14, NULL, 1, NULL, 1, 12);
INSERT INTO "craftsmen" VALUES (3598, '', 1, '', 16, NULL, 1, NULL, 2, 13);
INSERT INTO "craftsmen" VALUES (3599, '', 4, '', 11, NULL, 2, NULL, 2, 7);
INSERT INTO "craftsmen" VALUES (3600, '', 1, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (3602, '', 2, '', 9, NULL, 3, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3603, '', 1, '', 8, NULL, 1, NULL, 2, 5);
INSERT INTO "craftsmen" VALUES (3604, '', 2, '', 15, NULL, 5, 2, 1, 11);
INSERT INTO "craftsmen" VALUES (3605, '', 1, '', 10, NULL, NULL, NULL, 3, 7);
INSERT INTO "craftsmen" VALUES (3607, '', 1, '', 15, NULL, 1, NULL, 2, 12);
INSERT INTO "craftsmen" VALUES (3608, '', 2, '', 13, NULL, NULL, NULL, 1, 12);
INSERT INTO "craftsmen" VALUES (3610, '', 4, '', 12, NULL, NULL, 3, 4, 11);
INSERT INTO "craftsmen" VALUES (3612, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3613, '', 2, '', 9, NULL, 1, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (3615, '', 3, '', 6, NULL, NULL, NULL, 3, 3);
INSERT INTO "craftsmen" VALUES (3616, '', 3, '', 17, NULL, NULL, NULL, 1, 16);
INSERT INTO "craftsmen" VALUES (3617, '', 1, '', 2, NULL, 1, 1, NULL, 2);
INSERT INTO "craftsmen" VALUES (3618, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3619, '', 3, '', 15, NULL, NULL, NULL, 5, 10);
INSERT INTO "craftsmen" VALUES (3622, '', 3, '', 14, NULL, NULL, NULL, 1, 13);
INSERT INTO "craftsmen" VALUES (3623, '', 5, '', 11, NULL, NULL, NULL, 3, 8);
INSERT INTO "craftsmen" VALUES (3624, '', 4, '', 19, NULL, 2, 1, 2, 16);
INSERT INTO "craftsmen" VALUES (3625, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3626, '', 1, '', 14, NULL, NULL, NULL, NULL, 14);
INSERT INTO "craftsmen" VALUES (3628, '', 3, '', 15, NULL, NULL, NULL, NULL, 15);
INSERT INTO "craftsmen" VALUES (3629, '', 3, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (3630, '', 2, '', 16, NULL, NULL, NULL, NULL, 16);
INSERT INTO "craftsmen" VALUES (3631, '', 1, '', 13, NULL, 2, NULL, 3, 8);
INSERT INTO "craftsmen" VALUES (3632, '', 4, '', 12, NULL, 1, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (3633, '', 1, '', 9, NULL, 2, NULL, 2, 5);
INSERT INTO "craftsmen" VALUES (3634, '', 2, '', 91, NULL, 8, 1, 11, 73);
INSERT INTO "craftsmen" VALUES (3635, '', 2, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (3636, '', 1, '', 12, NULL, 2, 1, 1, 11);
INSERT INTO "craftsmen" VALUES (3637, '', 2, '', 10, NULL, NULL, 2, 5, 6);
INSERT INTO "craftsmen" VALUES (3638, '', 2, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3639, '', 1, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (3640, '', 4, '', 3, NULL, 1, 1, NULL, 3);
INSERT INTO "craftsmen" VALUES (3644, '', 5, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (3645, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3646, '', 5, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (3647, '', 1, '', 12, NULL, 5, NULL, 3, 4);
INSERT INTO "craftsmen" VALUES (3651, '', 3, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (3654, '', 1, '', 7, NULL, 1, NULL, 3, 2);
INSERT INTO "craftsmen" VALUES (3655, '', 4, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "craftsmen" VALUES (3656, '', 4, '', 3, NULL, NULL, NULL, 2, 1);
INSERT INTO "craftsmen" VALUES (3657, '', 5, '', 77, NULL, 8, NULL, 12, 5);
INSERT INTO "craftsmen" VALUES (3658, '', 2, '', 14, NULL, 3, NULL, 3, 8);
INSERT INTO "craftsmen" VALUES (3659, '', 2, '', 11, NULL, 1, NULL, 4, 6);
INSERT INTO "craftsmen" VALUES (3660, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3661, '', 5, '', 93, NULL, 6, 2, 2, 86);
INSERT INTO "craftsmen" VALUES (3662, '', 2, '', 7, NULL, 1, NULL, 2, 4);
INSERT INTO "craftsmen" VALUES (3663, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3664, '', 1, '', 11, NULL, 1, NULL, 1, 9);
INSERT INTO "craftsmen" VALUES (3667, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3668, '', 1, '', 11, NULL, 3, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (3672, '', 2, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3673, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3674, '', 5, '', 11, NULL, NULL, 3, 2, 12);
INSERT INTO "craftsmen" VALUES (3675, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3676, '', 4, '', 10, NULL, NULL, NULL, 2, 8);
INSERT INTO "craftsmen" VALUES (3680, '', 5, '', 6, NULL, NULL, 1, NULL, 7);
INSERT INTO "craftsmen" VALUES (3681, '', 4, '', 14, NULL, NULL, NULL, NULL, 14);
INSERT INTO "craftsmen" VALUES (3682, '', 3, '', 15, NULL, NULL, NULL, 1, 14);
INSERT INTO "craftsmen" VALUES (3683, '', 4, '', 10, NULL, 2, 1, NULL, 9);
INSERT INTO "craftsmen" VALUES (3684, '', 3, '', 7, NULL, NULL, NULL, 1, 6);
INSERT INTO "craftsmen" VALUES (3685, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3686, '', 2, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3688, '', 1, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (3689, '', 1, '', 5, NULL, 1, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (3690, '', 1, '', 8, NULL, 2, 1, 1, 6);
INSERT INTO "craftsmen" VALUES (3692, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3694, '', 4, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3696, '', 2, '', 7, NULL, NULL, NULL, 1, 6);
INSERT INTO "craftsmen" VALUES (3697, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3698, '', 4, '', 8, 1, 1, NULL, 1, 6);
INSERT INTO "craftsmen" VALUES (3700, '', 3, '', 14, 4, 2, NULL, 4, 8);
INSERT INTO "craftsmen" VALUES (3701, '', 1, '', 75, 13, 18, 6, 13, 48);
INSERT INTO "craftsmen" VALUES (3703, '', 2, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "craftsmen" VALUES (3704, '', 4, '', 9, NULL, 1, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (3705, '', 4, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (3706, '', 6, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (3707, '', 5, '', 5, 1, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (3708, '', 3, '', 9, NULL, 1, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (3709, '', 3, '', 15, NULL, NULL, NULL, 1, 13);
INSERT INTO "craftsmen" VALUES (3710, '', 2, '', 17, NULL, NULL, NULL, NULL, 17);
INSERT INTO "craftsmen" VALUES (3711, '', 5, '', 5, NULL, NULL, NULL, 2, 3);
INSERT INTO "craftsmen" VALUES (3712, '', 1, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (3715, '', 3, '', 17, NULL, NULL, NULL, 5, 12);
INSERT INTO "craftsmen" VALUES (3716, '', 1, '', 13, NULL, NULL, NULL, 8, 5);
INSERT INTO "craftsmen" VALUES (3718, '', 3, '', 11, NULL, NULL, NULL, 3, 7);
INSERT INTO "craftsmen" VALUES (3720, '', 3, '', 3, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (3722, '', 1, '', 12, NULL, 2, NULL, 2, 8);
INSERT INTO "craftsmen" VALUES (3723, '', 1, '', 6, NULL, 2, 1, NULL, 5);
INSERT INTO "craftsmen" VALUES (3724, '', 5, '', 13, NULL, 3, NULL, 4, 6);
INSERT INTO "craftsmen" VALUES (3725, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3726, '', 1, '', 5, NULL, 1, 1, NULL, 5);
INSERT INTO "craftsmen" VALUES (3727, '', 6, '', 8, NULL, NULL, 1, 5, 5);
INSERT INTO "craftsmen" VALUES (3728, '', 5, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (3729, '', 2, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "craftsmen" VALUES (3730, '', 5, '', 5, NULL, NULL, NULL, 2, 3);
INSERT INTO "craftsmen" VALUES (3731, '', 3, '', 3, NULL, 1, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (3733, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3734, '', 6, '', 9, NULL, 1, NULL, 2, 6);
INSERT INTO "craftsmen" VALUES (3736, '', 2, '', 3, 1, NULL, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (3737, '', 3, '', 8, NULL, NULL, NULL, 3, 5);
INSERT INTO "craftsmen" VALUES (3738, '', 4, '', 19, NULL, NULL, NULL, 1, 18);
INSERT INTO "craftsmen" VALUES (3740, '', 3, '', 6, NULL, 1, NULL, 5, NULL);
INSERT INTO "craftsmen" VALUES (3741, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3742, '', 2, '', 11, NULL, 1, NULL, 3, 7);
INSERT INTO "craftsmen" VALUES (3745, '', 2, '', 5, NULL, 1, 2, 1, 5);
INSERT INTO "craftsmen" VALUES (3746, '', 4, '', 4, NULL, 1, 3, 1, 5);
INSERT INTO "craftsmen" VALUES (3748, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3749, '', 1, '', 10, NULL, 1, NULL, 1, 8);
INSERT INTO "craftsmen" VALUES (3750, '', 2, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (3751, '', 6, '', 10, NULL, NULL, NULL, 5, 5);
INSERT INTO "craftsmen" VALUES (3752, '', 3, '', 12, NULL, 1, NULL, 2, 9);
INSERT INTO "craftsmen" VALUES (3755, '', 2, '', 4, NULL, NULL, NULL, 3, 1);
INSERT INTO "craftsmen" VALUES (3756, '', 2, '', 4, NULL, 1, NULL, 1, 2);
INSERT INTO "craftsmen" VALUES (3757, '', 3, '', 12, NULL, NULL, NULL, 2, 10);
INSERT INTO "craftsmen" VALUES (3758, '', 3, '', 8, NULL, 3, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (3759, '', 1, '', 11, NULL, NULL, NULL, 1, 10);
INSERT INTO "craftsmen" VALUES (3760, '', 5, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "craftsmen" VALUES (3763, '', 5, '', 8, NULL, NULL, NULL, 2, 6);
INSERT INTO "craftsmen" VALUES (3764, '', 6, '', 8, NULL, NULL, 1, NULL, 4);
INSERT INTO "craftsmen" VALUES (3765, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3766, '', 3, '', 12, NULL, 9, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3767, '', 1, '', 2, NULL, NULL, 3, NULL, 5);
INSERT INTO "craftsmen" VALUES (3768, '', 4, '', 9, NULL, 3, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3769, '', 5, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (3770, '', 1, '', 8, NULL, 2, NULL, 1, NULL);
INSERT INTO "craftsmen" VALUES (3771, '', 3, '', 13, NULL, NULL, NULL, 2, 11);
INSERT INTO "craftsmen" VALUES (3772, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3773, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3774, '', 2, '', 7, NULL, NULL, NULL, 2, 5);
INSERT INTO "craftsmen" VALUES (3775, '', 5, '', 9, NULL, 1, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (3777, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3778, '', 5, '', 1, NULL, NULL, 2, NULL, 3);
INSERT INTO "craftsmen" VALUES (3779, '', 2, '', 5, NULL, NULL, 1, NULL, 6);
INSERT INTO "craftsmen" VALUES (3780, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3783, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3784, '', 4, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3785, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3786, '', 3, '', 8, NULL, 1, NULL, 1, 6);
INSERT INTO "craftsmen" VALUES (3787, '', 3, '', 7, 1, 1, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (3788, '', 4, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (3789, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3791, '', 3, '', 9, NULL, 2, NULL, 1, 6);
INSERT INTO "craftsmen" VALUES (3792, '', 5, '', 5, NULL, 2, 1, 1, 3);
INSERT INTO "craftsmen" VALUES (3793, '', 1, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3794, '', 2, '', 10, NULL, NULL, NULL, 2, 8);
INSERT INTO "craftsmen" VALUES (3795, '', 4, '', 13, NULL, 1, NULL, NULL, 12);
INSERT INTO "craftsmen" VALUES (3797, '', 1, '', 12, NULL, 3, NULL, 1, 8);
INSERT INTO "craftsmen" VALUES (3798, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3799, '', 5, '', 9, NULL, 1, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (3800, '', 4, '', 11, NULL, 1, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3801, '', 1, '', 10, NULL, NULL, NULL, 1, 9);
INSERT INTO "craftsmen" VALUES (3804, '', 4, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "craftsmen" VALUES (3805, '', 7, '', 11, NULL, 1, NULL, 4, 6);
INSERT INTO "craftsmen" VALUES (3807, '', 5, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (3808, '', 3, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3809, '', 3, '', 12, NULL, NULL, NULL, 3, 9);
INSERT INTO "craftsmen" VALUES (3810, '', 2, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3812, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3813, '', 5, '', 2, NULL, NULL, 1, NULL, 3);
INSERT INTO "craftsmen" VALUES (3814, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (3815, '', 4, '', 4, NULL, NULL, 2, NULL, 6);
INSERT INTO "craftsmen" VALUES (3816, '', 3, '', 12, NULL, 5, 1, NULL, 8);
INSERT INTO "craftsmen" VALUES (3817, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3818, '', 1, '', 13, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (3819, '', 7, '', 20, NULL, 1, NULL, 2, 16);
INSERT INTO "craftsmen" VALUES (3820, '', 1, '', 12, NULL, 5, 2, 3, 6);
INSERT INTO "craftsmen" VALUES (3821, '', 2, '', 14, NULL, NULL, NULL, 2, 12);
INSERT INTO "craftsmen" VALUES (3823, '', 4, '', 16, NULL, NULL, NULL, 3, 13);
INSERT INTO "craftsmen" VALUES (3825, '', 1, '', 73, NULL, NULL, NULL, 25, 44);
INSERT INTO "craftsmen" VALUES (3826, '', 3, '', 237, 8, 151, 2, 5, 81);
INSERT INTO "craftsmen" VALUES (3827, '', 6, '', 6, NULL, 2, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3828, '', 2, '', 14, NULL, 3, NULL, 1, 10);
INSERT INTO "craftsmen" VALUES (3829, '', 4, '', 5, NULL, NULL, NULL, 3, 2);
INSERT INTO "craftsmen" VALUES (3830, '', 4, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3832, '', 3, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (3833, '', 4, '', 16, NULL, 4, NULL, 4, 7);
INSERT INTO "craftsmen" VALUES (3834, '', 3, '', 11, NULL, 1, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3835, '', 2, '', 10, NULL, NULL, 1, NULL, 11);
INSERT INTO "craftsmen" VALUES (3836, '', 3, '', 13, NULL, 9, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3837, '', 3, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3838, '', 5, '', 8, NULL, NULL, 5, NULL, 13);
INSERT INTO "craftsmen" VALUES (3839, '', 2, '', 18, NULL, 1, 1, 2, 15);
INSERT INTO "craftsmen" VALUES (3840, '', 5, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3843, '', 3, '', 8, NULL, 1, 1, NULL, 8);
INSERT INTO "craftsmen" VALUES (3846, '', 5, '', 13, NULL, 1, NULL, NULL, 12);
INSERT INTO "craftsmen" VALUES (3847, '', 6, '', 178, 3, 9, 4, 3, 170);
INSERT INTO "craftsmen" VALUES (3848, '', 3, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (3849, '', 4, '', 10, NULL, 1, NULL, 1, 8);
INSERT INTO "craftsmen" VALUES (3850, '', 1, '', 12, NULL, 1, NULL, 1, 10);
INSERT INTO "craftsmen" VALUES (3851, '', 5, '', 7, NULL, 1, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (3853, '', 2, '', 7, NULL, 1, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3854, '', 3, '', 20, NULL, 2, NULL, 4, 14);
INSERT INTO "craftsmen" VALUES (3855, '', 4, '', 18, NULL, 1, 1, 2, 16);
INSERT INTO "craftsmen" VALUES (3856, '', 3, '', 4, NULL, 2, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (3859, '', 4, '', 17, NULL, 2, NULL, NULL, 15);
INSERT INTO "craftsmen" VALUES (3860, '', 5, '', 11, NULL, 1, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3861, '', 5, '', 10, NULL, 1, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (3862, '', 3, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3863, '', 4, '', 15, NULL, 1, 2, 1, 15);
INSERT INTO "craftsmen" VALUES (3864, '', 2, '', 6, NULL, 2, NULL, 3, 1);
INSERT INTO "craftsmen" VALUES (3865, '', 3, '', 8, NULL, 2, 1, 5, 3);
INSERT INTO "craftsmen" VALUES (3869, '', 3, '', 4, NULL, 1, 2, 1, 4);
INSERT INTO "craftsmen" VALUES (3870, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3873, '', 2, '', 3, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3876, '', 2, '', 9, NULL, NULL, NULL, 2, 7);
INSERT INTO "craftsmen" VALUES (3877, '', 3, '', 14, NULL, 3, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (3878, '', 1, '', 6, NULL, 2, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (3879, '', 1, '', 9, NULL, NULL, 1, 1, 9);
INSERT INTO "craftsmen" VALUES (3880, '', 8, '', 8, NULL, NULL, 2, 2, 8);
INSERT INTO "craftsmen" VALUES (3881, '', 4, '', 10, NULL, 3, NULL, 2, 5);
INSERT INTO "craftsmen" VALUES (3882, '', 4, '', 12, NULL, NULL, NULL, 2, 10);
INSERT INTO "craftsmen" VALUES (3883, '', 6, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3884, '', 7, '', 7, NULL, 2, NULL, 1, 4);
INSERT INTO "craftsmen" VALUES (3885, '', 5, '', 12, NULL, 2, NULL, 1, 9);
INSERT INTO "craftsmen" VALUES (3886, '', 5, '', 6, NULL, NULL, NULL, 2, 4);
INSERT INTO "craftsmen" VALUES (3888, '', 4, '', 8, NULL, NULL, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (3889, '', 1, '', 11, NULL, NULL, NULL, 3, 8);
INSERT INTO "craftsmen" VALUES (3891, '', 4, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3892, '', 3, '', 9, NULL, 3, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3893, '', 4, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3896, '', 4, '', 12, NULL, 4, 2, 5, 5);
INSERT INTO "craftsmen" VALUES (3897, '', 1, '', 15, NULL, 3, 2, 6, 8);
INSERT INTO "craftsmen" VALUES (3898, '', 5, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (3899, '', 3, '', 1, NULL, 1, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (3900, '', 4, '', 9, NULL, 1, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (3901, '', 5, '', 5, NULL, 1, 1, NULL, 5);
INSERT INTO "craftsmen" VALUES (3902, '', 4, '', 8, NULL, 2, 2, 2, 6);
INSERT INTO "craftsmen" VALUES (3903, '', 5, '', 10, NULL, 5, 2, 2, 5);
INSERT INTO "craftsmen" VALUES (3905, '', 1, '', 1, NULL, 1, 4, NULL, 4);
INSERT INTO "craftsmen" VALUES (3906, '', 2, '', 8, NULL, 2, 2, 1, 7);
INSERT INTO "craftsmen" VALUES (3908, '', 3, '', 14, NULL, 2, NULL, 1, 11);
INSERT INTO "craftsmen" VALUES (3909, '', 3, '', 12, NULL, 4, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (3910, '', 6, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3911, '', 3, '', 12, NULL, 1, 3, 2, 12);
INSERT INTO "craftsmen" VALUES (3912, '', 3, '', 16, NULL, NULL, NULL, 1, 15);
INSERT INTO "craftsmen" VALUES (3913, '', 1, '', 10, NULL, NULL, 1, 2, 9);
INSERT INTO "craftsmen" VALUES (3915, '', 1, '', 9, NULL, 1, NULL, 1, 7);
INSERT INTO "craftsmen" VALUES (3916, '', 1, '', 18, NULL, NULL, NULL, 1, 17);
INSERT INTO "craftsmen" VALUES (3917, '', 1, '', 9, NULL, 3, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (3919, '', 5, '', 11, NULL, NULL, NULL, 4, 7);
INSERT INTO "craftsmen" VALUES (3921, '', 1, '', 17, NULL, NULL, NULL, 6, 11);
INSERT INTO "craftsmen" VALUES (3924, '', 1, '', 11, NULL, 2, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3925, '', 6, '', 11, NULL, 1, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (3926, '', 2, '', 10, NULL, 1, 2, 2, 9);
INSERT INTO "craftsmen" VALUES (3927, '', 7, '', 9, NULL, 1, 1, 2, 7);
INSERT INTO "craftsmen" VALUES (3928, '', 5, '', 14, NULL, 1, NULL, 1, 12);
INSERT INTO "craftsmen" VALUES (3929, '', 1, '', 6, NULL, 1, 1, 1, 5);
INSERT INTO "craftsmen" VALUES (3930, '', 5, '', 11, NULL, NULL, 2, 2, 11);
INSERT INTO "craftsmen" VALUES (3931, '', 1, '', 11, NULL, NULL, NULL, 2, 9);
INSERT INTO "craftsmen" VALUES (3932, '', 5, '', 13, NULL, 4, 1, 3, 7);
INSERT INTO "craftsmen" VALUES (3933, '', 1, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "craftsmen" VALUES (3934, '', 1, '', 7, NULL, 1, NULL, 2, 4);
INSERT INTO "craftsmen" VALUES (3935, '', 1, '', 13, NULL, 1, NULL, NULL, 12);
INSERT INTO "craftsmen" VALUES (3937, '', 6, '', 12, NULL, 1, NULL, 1, 9);
INSERT INTO "craftsmen" VALUES (3938, '', 1, '', 12, NULL, 1, NULL, 2, 9);
INSERT INTO "craftsmen" VALUES (3939, '', 3, '', 13, NULL, 1, NULL, 1, 11);
INSERT INTO "craftsmen" VALUES (3940, '', 1, '', 3, NULL, 1, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3941, '', 5, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (3942, '', 1, '', 10, NULL, 5, NULL, 2, 3);
INSERT INTO "craftsmen" VALUES (3943, '', 5, '', 18, NULL, 1, NULL, 2, 15);
INSERT INTO "craftsmen" VALUES (3945, '', 4, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (3946, '', 2, '', 16, NULL, 2, 1, 2, 13);
INSERT INTO "craftsmen" VALUES (3949, '', 1, '', 17, NULL, 2, 2, NULL, 17);
INSERT INTO "craftsmen" VALUES (3950, '', 3, '', 4, NULL, 1, 1, NULL, 4);
INSERT INTO "craftsmen" VALUES (3951, '', 4, '', 3, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (3954, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "craftsmen" VALUES (3955, '', 1, '', 12, NULL, NULL, NULL, 1, 11);
INSERT INTO "craftsmen" VALUES (3956, '', 2, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (3957, '', 1, '', 15, NULL, 3, NULL, 1, 11);
INSERT INTO "craftsmen" VALUES (3958, '', 7, '', 3, 1, 1, NULL, 1, 1);
INSERT INTO "craftsmen" VALUES (3961, '', 1, '', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (3968, '', 1, '', NULL, NULL, NULL, NULL, NULL, 15);
INSERT INTO "craftsmen" VALUES (3971, '', 3, '', NULL, NULL, NULL, NULL, NULL, 15);
INSERT INTO "craftsmen" VALUES (3990, '', 2, '', NULL, NULL, NULL, NULL, NULL, 12);
INSERT INTO "craftsmen" VALUES (3991, '', 4, '', NULL, NULL, NULL, NULL, NULL, 12);
INSERT INTO "craftsmen" VALUES (3992, '', 3, '', 7, 1, 2, 1, 3, 3);
INSERT INTO "craftsmen" VALUES (3995, '', 5, '', 8, NULL, 1, 2, 3, 6);
INSERT INTO "craftsmen" VALUES (4004, '', 1, '', NULL, NULL, NULL, NULL, NULL, 18);
INSERT INTO "craftsmen" VALUES (4006, '', 1, '', NULL, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (4016, '', 2, '', NULL, NULL, NULL, NULL, NULL, 17);
INSERT INTO "craftsmen" VALUES (4021, '', 3, '', NULL, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (4024, '', 2, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (4026, '', 1, '', NULL, NULL, NULL, NULL, NULL, 17);
INSERT INTO "craftsmen" VALUES (4029, '', 7, '', NULL, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (4033, '', 2, '', NULL, NULL, NULL, NULL, NULL, 18);
INSERT INTO "craftsmen" VALUES (4043, '', 2, '', NULL, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (4045, '', 4, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (4046, '', 4, '', NULL, NULL, NULL, NULL, NULL, 16);
INSERT INTO "craftsmen" VALUES (4048, '', 5, '', NULL, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (4050, '', 3, '', NULL, NULL, NULL, NULL, NULL, 16);
INSERT INTO "craftsmen" VALUES (4057, '', 4, '', NULL, NULL, NULL, NULL, NULL, 16);
INSERT INTO "craftsmen" VALUES (4063, '', 1, '', NULL, NULL, NULL, NULL, NULL, 19);
INSERT INTO "craftsmen" VALUES (4076, '', 5, '', NULL, NULL, NULL, NULL, NULL, 17);
INSERT INTO "craftsmen" VALUES (4077, '', 5, '', NULL, NULL, NULL, NULL, NULL, 12);
INSERT INTO "craftsmen" VALUES (4078, '', 3, '', 13, NULL, NULL, NULL, NULL, 12);
INSERT INTO "craftsmen" VALUES (4080, '', 2, '', 11, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4081, '', 2, '', 13, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (4082, '', 7, '', NULL, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (4083, '', 6, '', 15, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (4084, '', 4, '', 15, NULL, NULL, NULL, NULL, 12);
INSERT INTO "craftsmen" VALUES (4085, '', 4, '', 16, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (4086, '', 2, '', 15, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (4087, '', 1, '', 22, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (4088, '', 2, '', 19, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4089, '', 2, '', 17, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (4090, '', 5, '', 16, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (4091, '', 3, '', 15, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4092, '', 2, '', 16, NULL, NULL, NULL, NULL, 12);
INSERT INTO "craftsmen" VALUES (4093, '', 1, '', 26, NULL, NULL, NULL, NULL, 19);
INSERT INTO "craftsmen" VALUES (4094, '', 2, '', 16, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (4095, '', 1, '', 13, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (4096, '', 4, '', 18, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4097, '', 4, '', 16, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (4102, '', 3, '', 20, 2, 4, 1, 2, 15);
INSERT INTO "craftsmen" VALUES (4103, '', 2, '', 19, 9, 2, 3, 9, 11);
INSERT INTO "craftsmen" VALUES (4105, '', 2, '', 8, NULL, 5, 6, NULL, 9);
INSERT INTO "craftsmen" VALUES (4115, '', 2, '', 17, 4, 2, 1, 4, 12);
INSERT INTO "craftsmen" VALUES (4116, '', 4, '', NULL, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (4133, '', 1, '', NULL, NULL, NULL, NULL, NULL, 32);
INSERT INTO "craftsmen" VALUES (4145, '', 3, '', NULL, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (4146, '', 1, '', NULL, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (4150, '', 1, '', NULL, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (4156, '', 6, '', 17, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4168, '', 3, '', 11, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (4170, '', 5, '', 12, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (4172, '', 3, '', 18, NULL, NULL, NULL, NULL, 15);
INSERT INTO "craftsmen" VALUES (4173, '', 5, '', 21, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (4174, '', 2, '', 4, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (4175, '', 4, '', 18, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (4177, '', 1, '', NULL, NULL, NULL, NULL, NULL, 16);
INSERT INTO "craftsmen" VALUES (4178, '', 1, '', NULL, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4180, '', 2, '', 11, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4181, '', 1, '', 12, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (4182, '', 2, '', 13, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (4184, '', 1, '', 12, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (4185, '', 1, '', 7, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (4186, '', 2, '', 16, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (4187, '', 1, '', 12, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (4188, '', 1, '', NULL, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4189, '', 1, '', 11, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (4190, '', 4, '', 10, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (4193, '', 3, '', 14, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (4203, '', 3, '', 14, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4204, '', 4, '', 5, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4205, '', 5, '', 7, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4206, '', 5, '', 9, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (4208, '', 1, '', 17, NULL, NULL, NULL, NULL, 20);
INSERT INTO "craftsmen" VALUES (4210, '', 1, '', 14, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (4211, '', 6, '', 14, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (4212, '', 4, '', 10, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (4213, '', 5, '', 15, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (4214, '', 4, '', 14, NULL, NULL, NULL, NULL, 14);
INSERT INTO "craftsmen" VALUES (4215, '', 1, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4216, '', 6, '', 12, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4218, '', 2, '', 12, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (4219, '', 1, '', 12, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4220, '', 1, '', 13, 1, 1, NULL, 1, 10);
INSERT INTO "craftsmen" VALUES (4221, '', 2, '', 11, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (4222, '', 1, '', 10, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (4223, '', 1, '', 12, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (4225, '', 1, '', NULL, NULL, 2, NULL, 3, 12);
INSERT INTO "craftsmen" VALUES (4226, '', 2, '', 15, NULL, NULL, NULL, 6, 9);
INSERT INTO "craftsmen" VALUES (4228, '', 3, '', 15, 4, 4, NULL, 4, 7);
INSERT INTO "craftsmen" VALUES (4231, '', 2, '', 14, 1, 6, 5, 1, 12);
INSERT INTO "craftsmen" VALUES (4248, '', 1, '', NULL, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4250, '', 1, '', NULL, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (4258, '', 1, '', NULL, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (4260, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (4262, '', 4, '', 15, NULL, NULL, NULL, NULL, 15);
INSERT INTO "craftsmen" VALUES (4263, '', 4, '', 12, 5, 2, 4, 5, 9);
INSERT INTO "craftsmen" VALUES (4264, '', 2, '', 24, 1, 4, 1, 2, 19);
INSERT INTO "craftsmen" VALUES (4265, '', 2, '', 8, 1, NULL, 2, 1, 9);
INSERT INTO "craftsmen" VALUES (4290, '', 4, '', 3, NULL, 2, 5, NULL, 6);
INSERT INTO "craftsmen" VALUES (4315, '', 2, '', 19, NULL, 4, 3, NULL, 18);
INSERT INTO "craftsmen" VALUES (4369, '', 6, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (4372, '', 4, '', 5, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (4374, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (4375, '', 4, '', 2, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (4376, '', 6, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (4377, '', 6, '', 2, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (4378, '', 4, '', 3, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (4380, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (4381, '', 1, '', NULL, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (4382, '', 3, '', 4, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (4384, '', 3, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (4385, '', 1, '', 8, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (4388, '', 2, '', 2, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (4392, '', 5, '', 13, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (4395, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (4396, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (4398, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (4411, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (4417, '', 4, '', 3, NULL, 2, 2, NULL, 3);
INSERT INTO "craftsmen" VALUES (4427, '', 1, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (4429, '', 5, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (4432, '', 1, '', NULL, NULL, NULL, 22, 2, 20);
INSERT INTO "craftsmen" VALUES (4433, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (4436, '', 1, '', 8, NULL, 1, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4447, '', 1, '', 6, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4493, '', 7, '', 2, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (4519, '', 2, '', NULL, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (4524, '', 1, '', 30, NULL, NULL, NULL, NULL, 21);
INSERT INTO "craftsmen" VALUES (4529, '', 1, '', 18, NULL, NULL, NULL, NULL, 18);
INSERT INTO "craftsmen" VALUES (4539, '', 1, '', NULL, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4542, '', 1, '', 14, NULL, NULL, NULL, NULL, 14);
INSERT INTO "craftsmen" VALUES (4550, '', 1, '', 37, NULL, NULL, NULL, NULL, 31);
INSERT INTO "craftsmen" VALUES (4559, '', 1, '', 9, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4560, '', 2, '', 7, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (4562, '', 1, '', 42, NULL, NULL, NULL, NULL, 27);
INSERT INTO "craftsmen" VALUES (4574, '', 2, '', 33, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4575, '', 1, '', 11, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4576, '', 1, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4586, '', 1, '', 14, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4587, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (4606, '', 2, '', 21, NULL, NULL, NULL, NULL, 17);
INSERT INTO "craftsmen" VALUES (4607, '', 5, '', 24, NULL, NULL, NULL, NULL, 20);
INSERT INTO "craftsmen" VALUES (4611, '', 2, '', 3, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (4612, '', 2, '', 9, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4613, '', 1, '', 24, NULL, NULL, NULL, NULL, 23);
INSERT INTO "craftsmen" VALUES (4616, '', 1, '', 22, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4617, '', 2, '', 5, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (4618, '', 1, '', 16, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (4620, '', 1, '', 14, NULL, NULL, NULL, NULL, 12);
INSERT INTO "craftsmen" VALUES (4622, '', 1, '', 14, NULL, NULL, NULL, NULL, 12);
INSERT INTO "craftsmen" VALUES (4623, '', 1, '', 13, NULL, NULL, NULL, NULL, 13);
INSERT INTO "craftsmen" VALUES (4624, '', 3, '', 11, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4625, '', 2, '', 21, NULL, NULL, NULL, NULL, 15);
INSERT INTO "craftsmen" VALUES (4628, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (4629, '', 3, '', 33, NULL, NULL, NULL, NULL, 23);
INSERT INTO "craftsmen" VALUES (4631, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (4633, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (4634, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (4639, '', 3, '', 32, NULL, NULL, NULL, NULL, 27);
INSERT INTO "craftsmen" VALUES (4640, '', 4, '', 14, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (4642, '', 2, '', 7, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (4643, '', 3, '', 4, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (4645, '', 1, '', 6, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (4646, '', 2, '', 12, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4650, '', 1, '', 23, NULL, NULL, NULL, NULL, 17);
INSERT INTO "craftsmen" VALUES (4651, '', 1, '', 15, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (4652, '', 3, '', 20, NULL, NULL, NULL, NULL, 18);
INSERT INTO "craftsmen" VALUES (4653, '', 2, '', 10, NULL, NULL, NULL, NULL, 9);
INSERT INTO "craftsmen" VALUES (4655, '', 2, '', 26, NULL, NULL, NULL, NULL, 19);
INSERT INTO "craftsmen" VALUES (4656, '', 2, '', 15, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4658, '', 2, '', 18, NULL, NULL, NULL, NULL, 16);
INSERT INTO "craftsmen" VALUES (4659, '', 1, '', 13, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (4660, '', 1, '', 8, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (4662, '', 1, '', 8, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4663, '', 2, '', 10, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (4668, '', 1, '', 22, NULL, NULL, NULL, NULL, 16);
INSERT INTO "craftsmen" VALUES (4669, '', 3, '', 5, NULL, NULL, NULL, NULL, 11);
INSERT INTO "craftsmen" VALUES (4670, '', 2, '', 8, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (4672, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "craftsmen" VALUES (4673, '', 3, '', 10, NULL, NULL, NULL, NULL, 7);
INSERT INTO "craftsmen" VALUES (4693, '', 1, '', 18, NULL, NULL, NULL, NULL, 10);
INSERT INTO "craftsmen" VALUES (4695, '', 2, '', NULL, NULL, NULL, 4, NULL, 4);
INSERT INTO "craftsmen" VALUES (4697, '', 4, '', 15, NULL, NULL, NULL, NULL, 6);
INSERT INTO "craftsmen" VALUES (4699, '', 2, '', NULL, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (4701, '', 2, '', 12, NULL, NULL, NULL, NULL, 16);
INSERT INTO "craftsmen" VALUES (4703, '', 3, '', 3, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (4708, '', 3, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "craftsmen" VALUES (4709, '', 1, '', 7, NULL, NULL, NULL, NULL, 4);
INSERT INTO "craftsmen" VALUES (4714, '', 1, '', 20, NULL, NULL, NULL, NULL, 20);
INSERT INTO "craftsmen" VALUES (4715, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "craftsmen" VALUES (4726, '', 2, '', NULL, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (4750, '', 3, '', 8, NULL, NULL, NULL, NULL, 5);
INSERT INTO "craftsmen" VALUES (4756, '', 5, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (4759, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (4760, '', 1, '', 4, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (4762, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "craftsmen" VALUES (5754, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5792, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5793, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5794, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5795, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5796, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5801, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5802, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5803, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5806, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5807, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5808, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5809, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5810, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5811, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5813, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5819, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5821, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5822, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5823, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5824, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5825, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5826, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5827, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5828, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5830, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5831, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5832, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5833, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5834, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5835, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5836, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5837, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5838, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5839, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5840, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5841, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5842, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5843, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5844, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5845, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5846, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5847, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5849, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5850, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5851, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5852, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5853, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5854, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5855, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5856, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5857, '', 2, '', 2, 2, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5859, '', 2, '', 5, 1, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5860, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5879, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5880, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5882, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5884, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5886, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5887, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5890, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5891, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5894, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5895, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5896, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5897, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5898, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5899, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5905, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5912, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5913, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5914, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5915, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5916, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5921, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5922, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5923, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5924, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5925, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5926, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5927, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5930, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5931, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5932, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5933, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5934, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5935, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5936, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5937, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5938, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5939, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5940, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5941, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5942, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5947, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5948, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5949, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5950, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5951, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5952, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5953, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5954, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5955, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5956, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5957, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5958, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5959, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5960, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5962, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5963, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5964, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5965, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5966, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5967, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5968, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5969, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5970, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5971, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5972, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5973, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5976, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5979, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5980, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5981, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5982, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5983, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5984, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5985, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5986, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5987, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5987, 'A', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5988, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5989, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5993, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5994, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5997, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (5999, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6000, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6001, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6002, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6003, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6004, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6005, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6006, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6010, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6018, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6019, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6020, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6021, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6022, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6023, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6024, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6025, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6026, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6033, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6037, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6038, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6039, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6040, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6041, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6042, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6043, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6044, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6045, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6046, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6047, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6048, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6053, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6058, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6059, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6060, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6062, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6063, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6064, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6065, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6066, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6067, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6070, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6073, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6074, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6075, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6076, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6077, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6079, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6080, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6081, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6082, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6083, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6084, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6085, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6086, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6087, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6088, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6089, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6096, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6097, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6098, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6112, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6113, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6114, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6115, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6116, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6118, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6119, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6120, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6121, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6122, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6123, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6124, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6125, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6126, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6130, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6131, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6132, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6133, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6136, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6137, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6138, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6139, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6140, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6141, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6142, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6143, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6144, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6149, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6150, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6151, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6153, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6154, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6155, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6156, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6157, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6158, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6165, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6166, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6167, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6169, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6170, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6171, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6172, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6173, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6174, '', 5, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6175, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6176, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6177, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6185, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6187, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6188, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6189, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6190, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6191, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6192, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6193, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6194, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6195, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6201, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6202, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6203, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6204, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6209, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6210, '', 6, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6211, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6212, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6217, '', 6, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6218, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6219, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6231, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6233, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6234, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6235, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6236, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6237, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6238, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6240, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6241, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6248, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6249, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6252, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6253, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6254, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6256, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6257, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6258, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6259, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6260, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6261, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6269, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6270, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6273, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6274, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6275, '', 7, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6276, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6277, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6279, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6281, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6286, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6287, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6290, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6291, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6292, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6293, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6294, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6295, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6296, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6297, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6298, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6299, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6300, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6307, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6308, '', 6, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6310, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6311, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6312, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6313, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6314, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6315, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6316, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6317, '', 8, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6318, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6319, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6320, '', 6, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6321, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6322, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6323, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6325, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6326, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6334, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6335, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6340, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6341, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6344, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6345, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6346, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6347, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6348, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6349, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6350, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6351, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6352, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6353, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6354, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6355, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6356, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6367, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6368, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6369, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6370, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6371, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6372, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6373, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6375, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6376, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6377, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6378, '', 6, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6379, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6381, '', 7, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6382, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6383, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6396, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6397, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6398, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6399, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6400, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6401, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6402, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6403, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6404, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6406, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6407, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6408, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6418, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6419, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6420, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6421, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6422, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6423, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6424, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6425, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6426, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6427, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6430, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6431, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6432, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6433, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6434, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6445, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6454, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6455, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6456, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6457, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6458, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6459, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6460, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6461, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6463, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6464, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6465, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6466, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6487, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6488, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6489, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6490, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6491, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6493, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6494, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6495, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6496, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6497, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6498, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6499, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6500, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6508, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6510, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6512, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6513, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6521, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6522, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6523, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6524, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6525, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6526, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6527, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6528, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6530, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6531, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6532, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6533, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6551, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6574, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6575, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6576, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6577, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6578, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6579, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6580, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6581, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6582, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6583, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6589, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6590, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6591, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6592, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6593, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6594, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6665, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6666, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6667, '', 5, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6668, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6669, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6671, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6672, '', 3, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6673, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6674, '', 5, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6675, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6676, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6677, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6678, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6679, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6680, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6681, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6682, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6683, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6684, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6708, '', 4, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6709, '', 3, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6711, '', 4, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6712, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6713, '', 5, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6714, '', 2, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6715, '', 8, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6716, '', 3, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6717, '', 5, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6718, '', 5, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6719, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6730, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6731, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6732, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6733, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6735, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6736, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6737, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6738, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6739, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6740, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6741, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6742, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6743, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6744, '', 7, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6745, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6750, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6752, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6753, '', 6, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6759, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6760, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6761, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6762, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6763, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6764, '', 6, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6765, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6766, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6767, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6768, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6769, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6770, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6771, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6772, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6773, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6774, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6775, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6776, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6778, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6792, '', 5, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6793, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6794, '', 5, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6796, '', 4, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6797, '', 7, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6798, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6799, '', 3, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6800, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6801, '', 8, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6802, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6803, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6804, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6805, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6807, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6813, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6814, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6816, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6817, '', 5, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6818, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6819, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6820, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6821, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6822, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6823, '', 7, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6824, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6825, '', 5, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6826, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6827, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6828, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6836, '', 7, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6837, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6838, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6839, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6846, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6847, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6848, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6849, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6850, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6852, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6853, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6854, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6856, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6857, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6858, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6859, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6860, '', 8, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6861, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6862, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6863, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6874, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6876, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6877, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6878, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6879, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6881, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6882, '', 7, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6883, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6884, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6885, '', 6, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6886, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6888, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6891, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6892, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6895, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6910, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6911, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6912, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6913, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6914, '', 9, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6915, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6916, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6917, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6918, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6919, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6920, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6921, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6923, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6924, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6932, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6933, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6937, '', 6, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6938, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6939, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6941, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6942, '', 6, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6943, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6944, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6945, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6946, '', 7, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6947, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6952, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6953, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6954, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6955, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6956, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6957, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6958, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6959, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6960, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6961, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6962, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6963, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6967, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6968, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6969, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6970, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6971, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6972, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6973, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6975, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6976, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6977, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6978, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6979, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6983, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6984, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6985, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6986, '', 10, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6988, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6989, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6990, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6991, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6992, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6993, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (6998, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7000, '', 6, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7001, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7003, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7005, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7006, '', 6, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7007, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7008, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7009, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7010, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7011, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7012, '', 6, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7013, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7014, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7015, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7017, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7023, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7027, '', 7, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7028, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7030, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7041, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7042, '', 7, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7043, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7044, '', 7, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7045, '', 7, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7046, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7047, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7048, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7049, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7050, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7051, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7057, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7058, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7059, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7060, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7061, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7062, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7068, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7069, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7070, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7071, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7072, '', 6, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7075, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7076, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7077, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7078, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7079, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7080, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7085, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7086, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7087, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7088, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7089, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7091, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7103, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7104, '', 7, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7105, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7106, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7107, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7108, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7109, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7110, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7115, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7116, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7130, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7151, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7152, '', 6, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7153, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7169, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7170, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7171, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7172, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7177, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7178, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7179, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7180, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7181, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7182, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7183, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7184, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7185, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7186, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7187, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7188, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7189, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7190, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7194, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7199, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7204, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7205, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7206, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7207, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7208, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7209, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7210, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7211, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7212, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7213, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7214, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7220, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7228, '', 6, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7229, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7230, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7231, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7232, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7233, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7234, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7235, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7238, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7245, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7246, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7247, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7248, '', 6, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7249, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7250, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7252, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7253, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7254, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7255, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7256, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7260, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7268, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7270, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7271, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7272, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7273, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7274, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7275, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7278, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7296, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7297, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7298, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7299, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7300, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7302, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7316, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7317, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7319, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7320, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7324, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7338, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7339, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7340, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7341, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7342, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7344, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7345, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7346, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7353, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7354, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7355, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7363, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7373, '', 2, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7375, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7384, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7385, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7386, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7387, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7389, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7392, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7393, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7399, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7528, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7529, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7530, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7531, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7533, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7534, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7535, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7536, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7537, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7538, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7539, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7549, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7554, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7555, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7556, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7559, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7560, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7561, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7562, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7563, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7565, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7567, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7572, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7573, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7583, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7584, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7585, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7586, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7587, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7588, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7589, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7593, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7605, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7606, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7607, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7609, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7610, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7611, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7612, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7613, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7614, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7615, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7616, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7617, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7630, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7631, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7633, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7634, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7635, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7636, '', 5, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7637, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7650, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7651, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7652, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7653, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7654, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7668, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7669, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7671, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7672, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7673, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7674, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7675, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7676, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7692, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7693, '', 6, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7694, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7695, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7696, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7697, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7698, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7699, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7700, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7716, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7717, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7718, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7719, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7720, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7721, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7722, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7731, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7739, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7740, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7741, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7742, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7743, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7744, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7745, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7746, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7747, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7765, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7766, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7767, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7770, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7771, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7772, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7773, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7774, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7791, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7792, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7793, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7794, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7795, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7796, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7797, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7808, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7816, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7819, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7820, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7821, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7822, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7823, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7824, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7825, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7826, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7833, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7834, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7845, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7846, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7847, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7848, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7849, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7850, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7851, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7852, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7853, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7854, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7867, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7868, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7869, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7870, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7871, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7872, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7878, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7895, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7897, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7901, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7902, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7908, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7918, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7919, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7920, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7921, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7922, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7923, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7924, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7925, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7926, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7944, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7945, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7946, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7947, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7949, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7950, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7951, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7952, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7953, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7954, '', 6, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7960, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7968, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7970, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7971, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7972, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7973, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7974, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7976, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7987, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7993, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7994, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7995, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7996, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7997, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7998, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (7999, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8000, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8002, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8006, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8014, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8018, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8019, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8020, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8021, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8022, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8023, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8024, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8025, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8026, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8042, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8043, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8046, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8062, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8063, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8064, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8066, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8096, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8230, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8231, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8236, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8260, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8262, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8263, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8264, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8279, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8292, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8293, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8294, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8320, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8326, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8329, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "craftsmen" VALUES (8341, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);

CREATE TABLE "impotenten" (
	"number"               integer	NOT NULL,
	"number_sup"           char(1)	NOT NULL,
	"trip"                 integer,
	"trip_sup"             char(1),
	"onboard_at_departure" integer,
	"death_at_cape"        integer,
	"left_at_cape"         integer,
	"onboard_at_cape"      integer,
	"death_during_voyage"  integer,
	"onboard_at_arrival"   integer
);

INSERT INTO "impotenten" VALUES (5733, '', 3, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5734, '', 2, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5735, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5736, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5737, '', 4, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5751, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5752, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5755, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5758, '', 5, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5759, '', 5, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5764, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5792, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5793, '', 3, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5794, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5795, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5796, '', 6, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5798, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5799, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5800, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5802, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5806, '', 1, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5807, '', 3, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5808, '', 5, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5809, '', 2, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5810, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5811, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5813, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5818, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5819, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5821, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5822, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5823, '', 1, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5824, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5825, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5826, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5827, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5828, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5830, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5831, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5832, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5833, '', 1, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5834, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5835, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5836, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5837, '', 3, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5838, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5839, '', 1, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5840, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5841, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5842, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5843, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5844, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5845, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5846, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5847, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5848, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5849, '', 4, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5850, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5851, '', 2, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5852, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5853, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5854, '', 2, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5855, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5856, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5859, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5860, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5862, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5879, '', 1, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5880, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5882, '', 3, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5886, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5887, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5890, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5891, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5894, '', 3, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5895, '', 4, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5896, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5897, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5898, '', 2, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5899, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5900, '', 1, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5901, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5902, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5903, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5905, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5906, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5907, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5908, '', 4, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5909, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5910, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5912, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5913, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5914, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5915, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5916, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5917, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5918, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5919, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5920, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5922, '', 4, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5923, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5924, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5925, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5926, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5927, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5928, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5929, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5930, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5931, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5932, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5933, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5934, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5935, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5936, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5937, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5938, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5939, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5940, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5941, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5942, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5947, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5948, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5950, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5951, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5952, '', 4, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5953, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5954, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5955, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5956, '', 2, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5957, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5958, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5959, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5962, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5963, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5964, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5965, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5966, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5967, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5968, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5969, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5970, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5971, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5972, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5973, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5976, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5979, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5981, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5982, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5983, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5984, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5985, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5986, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5987, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5987, 'A', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5988, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5989, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5993, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5994, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5997, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (5999, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6000, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6001, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6002, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6003, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6004, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6005, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6006, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6009, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6010, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6018, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6019, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6020, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6021, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6022, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6023, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6024, '', 5, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6025, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6026, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6032, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6037, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6038, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6039, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6040, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6041, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6042, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6043, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6044, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6045, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6046, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6047, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6048, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6053, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6054, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6058, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6059, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6060, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6061, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6062, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6063, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6064, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6065, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6066, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6067, '', 5, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6070, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6073, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6074, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6075, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6079, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6080, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6081, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6082, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6083, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6084, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6085, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6086, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6087, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6088, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6089, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6094, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6095, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6096, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6097, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6098, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6099, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6100, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6101, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6102, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6103, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6104, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6105, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6106, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6112, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6113, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6114, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6115, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6116, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6118, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6119, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6120, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6121, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6122, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6123, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6124, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6125, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6126, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6130, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6131, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6132, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6133, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6136, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6137, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6138, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6139, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6140, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6141, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6142, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6143, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6144, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6149, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6150, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6151, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6153, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6154, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6155, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6156, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6157, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6158, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6166, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6167, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6169, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6170, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6171, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6172, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6173, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6174, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6175, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6176, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6177, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6185, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6187, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6188, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6189, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6190, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6191, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6192, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6193, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6194, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6195, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6201, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6202, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6203, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6204, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6209, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6210, '', 6, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6211, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6212, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6216, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6217, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6218, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6219, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6227, '', 3, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6228, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6229, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6231, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6233, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6235, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6236, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6237, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6239, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6240, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6241, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6248, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6249, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6252, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6253, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6254, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6255, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6256, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6257, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6258, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6259, '', 6, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6260, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6261, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6269, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6270, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6273, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6274, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6275, '', 7, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6276, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6277, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6279, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6281, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6286, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6287, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6290, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6291, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6292, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6293, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6294, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6295, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6296, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6297, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6298, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6299, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6300, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6307, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6308, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6310, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6311, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6312, '', 6, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6313, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6314, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6315, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6316, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6317, '', 8, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6318, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6319, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6320, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6321, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6322, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6323, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6325, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6326, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6334, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6335, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6340, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6341, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6344, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6345, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6346, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6347, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6348, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6349, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6350, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6351, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6352, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6353, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6354, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6355, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6356, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6367, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6369, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6370, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6371, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6372, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6373, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6375, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6376, '', 5, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6377, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6378, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6379, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6381, '', 7, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6382, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6383, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6385, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6387, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6389, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6396, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6397, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6398, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6399, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6400, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6401, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6402, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6403, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6404, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6406, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6407, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6408, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6454, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6455, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6456, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6457, '', 6, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6458, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6459, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6460, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6461, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6463, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6464, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6465, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6466, '', 5, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6487, '', 6, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6488, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6489, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6490, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6491, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6493, '', 5, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6494, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6495, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6496, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6497, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6498, '', 5, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6499, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6500, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6508, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6510, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6512, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6513, '', 5, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6521, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6522, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6523, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6524, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6525, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6526, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6527, '', 6, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6528, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6530, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6531, '', 5, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6532, '', 6, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6533, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6551, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6574, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6575, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6576, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6577, '', 4, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6578, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6579, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6580, '', 6, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6581, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6582, '', 4, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6583, '', 5, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6589, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6590, '', 4, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6591, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6592, '', 1, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6593, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6594, '', 1, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6666, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6667, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6668, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6669, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6671, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6674, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6675, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6676, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6677, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6678, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6679, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6680, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6681, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6682, '', 6, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6683, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6684, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6701, '', 2, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6702, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6703, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6704, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6705, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6708, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6709, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6711, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6712, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6713, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6714, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6715, '', 8, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6716, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6717, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6718, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6719, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6730, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6731, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6732, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6733, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6735, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6736, '', 3, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6737, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6738, '', 2, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6739, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6740, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6741, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6742, '', 5, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6743, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6744, '', 7, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6745, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6750, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6752, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6753, '', 6, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6773, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6774, '', 6, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6776, '', 4, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6778, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6792, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6793, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6794, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6796, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6797, '', 7, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6798, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6799, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6800, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6801, '', 8, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6802, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6803, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6804, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6805, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6807, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6813, '', 5, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6814, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6816, '', 4, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6817, '', 5, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6818, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6819, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6820, '', 3, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6821, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6822, '', 4, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6823, '', 7, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6824, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6825, '', 5, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6826, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6827, '', 6, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6828, '', 6, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6829, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6830, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6831, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6836, '', 7, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6837, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6838, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6839, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6840, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6841, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6842, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6843, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6844, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6846, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6847, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6848, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6849, '', 4, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6850, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6851, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6852, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6853, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6854, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6856, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6857, '', 5, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6858, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6859, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6860, '', 8, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6861, '', 5, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6862, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6863, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6864, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6865, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6870, '', 6, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6871, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6873, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6874, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6876, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6877, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6878, '', 6, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6879, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6880, '', 4, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6881, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6882, '', 7, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6883, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6884, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6885, '', 6, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6886, '', 4, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6887, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6888, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6891, '', 6, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6892, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6893, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6894, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6895, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6901, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6904, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6907, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6908, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6910, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6911, '', 5, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6912, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6913, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6914, '', 9, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6915, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6916, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6917, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6918, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6919, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6920, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6921, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6923, '', 4, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6928, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6929, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6931, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6932, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6933, '', 6, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6937, '', 6, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6938, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6939, '', 5, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6941, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6942, '', 6, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6943, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6944, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6945, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6946, '', 7, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6947, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6952, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6953, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6954, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6955, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6956, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6957, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6958, '', 5, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6959, '', 3, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6960, '', 5, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6961, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6962, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6963, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6968, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6969, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6970, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6971, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6972, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6973, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6974, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6975, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6976, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6977, '', 6, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6978, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6979, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6984, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6985, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6986, '', 10, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6990, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6991, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6992, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6993, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (6998, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7000, '', 6, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7001, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7002, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7003, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7005, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7006, '', 6, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7007, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7008, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7009, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7010, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7011, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7012, '', 6, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7013, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7014, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7015, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7017, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7023, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7025, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7027, '', 7, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7028, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7029, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7030, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7031, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7035, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7036, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7037, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7038, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7041, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7042, '', 7, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7043, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7044, '', 7, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7045, '', 7, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7046, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7047, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7048, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7049, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7050, '', 6, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7051, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7057, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7058, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7059, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7060, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7061, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7062, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7068, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7069, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7070, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7071, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7072, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7075, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7076, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7077, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7078, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7079, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7080, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7085, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7086, '', 6, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7087, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7088, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7089, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7091, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7092, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7093, '', 7, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7094, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7095, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7096, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7097, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7098, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7099, '', 7, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7100, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7103, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7104, '', 7, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7105, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7106, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7107, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7108, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7109, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7110, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7115, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7116, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7121, '', 5, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7122, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7123, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7124, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7125, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7126, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7127, '', 7, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7151, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7152, '', 6, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7153, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7154, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7168, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7169, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7170, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7171, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7172, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7177, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7178, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7179, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7180, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7181, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7182, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7183, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7184, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7185, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7186, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7187, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7188, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7189, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7190, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7191, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7194, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7199, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7204, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7205, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7206, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7207, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7208, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7209, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7210, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7211, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7212, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7213, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7214, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7215, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7220, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7228, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7229, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7230, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7231, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7232, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7233, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7234, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7235, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7238, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7241, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7242, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7243, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7245, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7246, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7247, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7248, '', 6, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7249, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7250, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7251, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7252, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7253, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7254, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7255, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7256, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7258, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7259, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7260, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7268, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7270, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7271, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7272, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7273, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7274, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7275, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7278, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7296, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7297, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7298, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7299, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7300, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7302, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7316, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7326, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7327, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7328, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7333, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7350, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7351, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7356, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7357, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7368, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7374, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7375, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7378, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7380, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7386, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7394, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7404, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7531, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7561, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7585, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7586, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7602, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7603, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7624, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7651, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7653, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7656, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7674, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7675, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7688, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7693, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7694, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7695, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7696, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7697, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7698, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7699, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7700, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7717, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7718, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7720, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7721, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7722, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7739, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7742, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7744, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7745, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7747, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7764, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7767, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7771, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7774, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7806, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7826, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7835, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7846, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7852, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7853, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7871, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7872, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7878, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7897, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7901, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7902, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7914, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7918, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7919, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7924, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7953, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7965, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7968, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7970, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7975, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7976, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7988, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7993, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7995, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7998, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (7999, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8001, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8002, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8006, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8014, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8018, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8019, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8020, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8022, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8023, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8025, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8026, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8037, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8042, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8043, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8064, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8065, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8077, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8096, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8230, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8231, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8235, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8236, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8265, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8371, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "impotenten" VALUES (8396, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);

CREATE TABLE "invoices" (
	"number"     integer,
	"number_sup" char(1),
	"trip"       integer,
	"trip_sup"   char(1),
	"invoice"    integer,
	"chamber"    char(1)
);

INSERT INTO "invoices" VALUES (5102, '', 2, '', 268964, 'A');
INSERT INTO "invoices" VALUES (5103, '', 2, '', 164562, 'Z');
INSERT INTO "invoices" VALUES (5105, '', 2, '', 110370, 'A');
INSERT INTO "invoices" VALUES (5106, '', 2, '', 127181, 'D');
INSERT INTO "invoices" VALUES (5107, '', 2, '', 101522, 'A');
INSERT INTO "invoices" VALUES (5108, '', 3, '', 110370, 'A');
INSERT INTO "invoices" VALUES (5110, '', 1, '', 21160, 'A');
INSERT INTO "invoices" VALUES (5112, '', 3, '', 192449, 'R');
INSERT INTO "invoices" VALUES (5113, '', 1, '', 231099, 'A');
INSERT INTO "invoices" VALUES (5114, '', 1, '', 32449, 'Z');
INSERT INTO "invoices" VALUES (5115, '', 1, '', 88907, 'A');
INSERT INTO "invoices" VALUES (5116, '', 2, '', 39787, 'D');
INSERT INTO "invoices" VALUES (5117, '', 1, '', 207498, 'A');
INSERT INTO "invoices" VALUES (5118, '', 1, '', 189448, 'Z');
INSERT INTO "invoices" VALUES (5119, '', 1, '', 136414, 'H');
INSERT INTO "invoices" VALUES (5120, '', 2, '', 56526, 'H');
INSERT INTO "invoices" VALUES (5121, '', 1, '', 48766, 'E');
INSERT INTO "invoices" VALUES (5122, '', 1, '', 235346, 'A');
INSERT INTO "invoices" VALUES (5123, '', 1, '', 140348, 'E');
INSERT INTO "invoices" VALUES (5124, '', 1, '', 137398, 'Z');
INSERT INTO "invoices" VALUES (5125, '', 1, '', 145787, 'A');
INSERT INTO "invoices" VALUES (5127, '', 1, '', 300010, 'A');
INSERT INTO "invoices" VALUES (5128, '', 2, '', 60491, 'A');
INSERT INTO "invoices" VALUES (5129, '', 1, '', 143970, 'Z');
INSERT INTO "invoices" VALUES (5130, '', 1, '', 157705, 'Z');
INSERT INTO "invoices" VALUES (5131, '', 2, '', 249883, 'A');
INSERT INTO "invoices" VALUES (5132, '', 3, '', 461998, 'D');
INSERT INTO "invoices" VALUES (5133, '', 2, '', 87711, 'A');
INSERT INTO "invoices" VALUES (5134, '', 1, '', 195913, 'R');
INSERT INTO "invoices" VALUES (5135, '', 2, '', 123667, 'A');
INSERT INTO "invoices" VALUES (5136, '', 1, '', 218086, 'A');
INSERT INTO "invoices" VALUES (5137, '', 3, '', 37096, 'R');
INSERT INTO "invoices" VALUES (5138, '', 2, '', 214263, 'Z');
INSERT INTO "invoices" VALUES (5139, '', 3, '', 83309, NULL);
INSERT INTO "invoices" VALUES (5140, '', 1, '', 95238, 'A');
INSERT INTO "invoices" VALUES (5141, '', 2, '', 118121, 'Z');
INSERT INTO "invoices" VALUES (5142, '', 1, '', 203256, 'H');
INSERT INTO "invoices" VALUES (5143, '', 3, '', 278968, 'A');
INSERT INTO "invoices" VALUES (5144, '', 1, '', 315137, 'A');
INSERT INTO "invoices" VALUES (5145, '', 1, '', 130191, 'H');
INSERT INTO "invoices" VALUES (5146, '', 1, '', 228100, 'E');
INSERT INTO "invoices" VALUES (5147, '', 1, '', 316067, 'A');
INSERT INTO "invoices" VALUES (5148, '', 1, '', 268324, 'Z');
INSERT INTO "invoices" VALUES (5149, '', 1, '', 62754, 'A');
INSERT INTO "invoices" VALUES (5150, '', 1, '', 275888, 'A');
INSERT INTO "invoices" VALUES (5151, '', 3, '', 283047, 'Z');
INSERT INTO "invoices" VALUES (5152, '', 4, '', 123943, 'Z');
INSERT INTO "invoices" VALUES (5153, '', 1, '', 151234, 'A');
INSERT INTO "invoices" VALUES (5154, '', 1, '', 106659, 'A');
INSERT INTO "invoices" VALUES (5155, '', 2, '', 211770, 'A');
INSERT INTO "invoices" VALUES (5156, '', 1, '', 245984, 'E');
INSERT INTO "invoices" VALUES (5157, '', 1, '', 129607, 'D');
INSERT INTO "invoices" VALUES (5158, '', 4, '', 263842, 'A');
INSERT INTO "invoices" VALUES (5159, '', 3, '', 130360, 'Z');
INSERT INTO "invoices" VALUES (5160, '', 2, '', 150933, 'R');
INSERT INTO "invoices" VALUES (5161, '', 1, '', 135859, 'D');
INSERT INTO "invoices" VALUES (5162, '', 1, '', 23499, 'A');
INSERT INTO "invoices" VALUES (5164, '', 1, '', 222852, 'D');
INSERT INTO "invoices" VALUES (5165, '', 2, '', 243588, 'A');
INSERT INTO "invoices" VALUES (5166, '', 2, '', 109311, 'Z');
INSERT INTO "invoices" VALUES (5167, '', 2, '', 199065, 'A');
INSERT INTO "invoices" VALUES (5168, '', 2, '', 253027, 'A');
INSERT INTO "invoices" VALUES (5169, '', 2, '', 264605, 'A');
INSERT INTO "invoices" VALUES (5170, '', 2, '', 266764, 'Z');
INSERT INTO "invoices" VALUES (5171, '', 3, '', 461545, 'A');
INSERT INTO "invoices" VALUES (5172, '', 1, '', 203729, 'A');
INSERT INTO "invoices" VALUES (5173, '', 2, '', 159502, 'A');
INSERT INTO "invoices" VALUES (5174, '', 1, '', 89443, 'E');
INSERT INTO "invoices" VALUES (5175, '', 2, '', 135043, 'H');
INSERT INTO "invoices" VALUES (5176, '', 1, '', 128150, 'H');
INSERT INTO "invoices" VALUES (5177, '', 1, '', 186076, 'A');
INSERT INTO "invoices" VALUES (5178, '', 1, '', 156885, 'A');
INSERT INTO "invoices" VALUES (5179, '', 2, '', 112225, 'D');
INSERT INTO "invoices" VALUES (5180, '', 1, '', 293422, 'R');
INSERT INTO "invoices" VALUES (5181, '', 2, '', 233323, 'E');
INSERT INTO "invoices" VALUES (5182, '', 3, '', 294093, 'A');
INSERT INTO "invoices" VALUES (5183, '', 3, '', 150737, 'Z');
INSERT INTO "invoices" VALUES (5184, '', 3, '', 433039, 'A');
INSERT INTO "invoices" VALUES (5185, '', 1, '', 288699, 'Z');
INSERT INTO "invoices" VALUES (5186, '', 4, '', 171174, 'Z');
INSERT INTO "invoices" VALUES (5187, '', 2, '', 177035, 'A');
INSERT INTO "invoices" VALUES (5188, '', 2, '', 337771, 'D');
INSERT INTO "invoices" VALUES (5189, '', 1, '', 431033, 'Z');
INSERT INTO "invoices" VALUES (5190, '', 1, '', 65350, 'H');
INSERT INTO "invoices" VALUES (5191, '', 1, '', 88622, 'R');
INSERT INTO "invoices" VALUES (5192, '', 3, '', 418677, 'A');
INSERT INTO "invoices" VALUES (5193, '', 4, '', 380953, 'A');
INSERT INTO "invoices" VALUES (5194, '', 1, '', 327961, 'A');
INSERT INTO "invoices" VALUES (5195, '', 3, '', 121607, 'R');
INSERT INTO "invoices" VALUES (5196, '', 1, '', 232676, 'A');
INSERT INTO "invoices" VALUES (5197, '', 1, '', 146753, 'Z');
INSERT INTO "invoices" VALUES (5198, '', 1, '', 147978, 'Z');
INSERT INTO "invoices" VALUES (5199, '', 1, '', 259802, 'A');
INSERT INTO "invoices" VALUES (5200, '', 3, '', 171387, 'A');
INSERT INTO "invoices" VALUES (5201, '', 1, '', 52060, 'E');
INSERT INTO "invoices" VALUES (5202, '', 3, '', 373482, 'D');
INSERT INTO "invoices" VALUES (5203, '', 5, '', 271031, 'A');
INSERT INTO "invoices" VALUES (5204, '', 2, '', 91111, 'H');
INSERT INTO "invoices" VALUES (5205, '', 2, '', 467899, 'Z');
INSERT INTO "invoices" VALUES (5206, '', 4, '', 299933, 'A');
INSERT INTO "invoices" VALUES (5207, '', 4, '', 277796, 'A');
INSERT INTO "invoices" VALUES (5208, '', 2, '', 298410, 'R');
INSERT INTO "invoices" VALUES (5209, '', 1, '', 348027, 'A');
INSERT INTO "invoices" VALUES (5210, '', 1, '', 113526, 'Z');
INSERT INTO "invoices" VALUES (5211, '', 4, '', 111047, 'A');
INSERT INTO "invoices" VALUES (5212, '', 1, '', 205971, 'A');
INSERT INTO "invoices" VALUES (5213, '', 1, '', 279041, 'A');
INSERT INTO "invoices" VALUES (5214, '', 1, '', 269212, 'E');
INSERT INTO "invoices" VALUES (5215, '', 4, '', 92296, 'A');
INSERT INTO "invoices" VALUES (5216, '', 1, '', 289881, 'Z');
INSERT INTO "invoices" VALUES (5217, '', 1, '', 259222, 'A');
INSERT INTO "invoices" VALUES (5218, '', 3, '', 252739, 'Z');
INSERT INTO "invoices" VALUES (5219, '', 3, '', 70239, 'H');
INSERT INTO "invoices" VALUES (5220, '', 2, '', 196848, 'A');
INSERT INTO "invoices" VALUES (5221, '', 1, '', 223057, 'A');
INSERT INTO "invoices" VALUES (5222, '', 1, '', 247537, 'A');
INSERT INTO "invoices" VALUES (5223, '', 1, '', 561391, 'A');
INSERT INTO "invoices" VALUES (5224, '', 2, '', 547961, 'Z');
INSERT INTO "invoices" VALUES (5225, '', 1, '', 347906, 'Z');
INSERT INTO "invoices" VALUES (5226, '', 5, '', 198880, 'A');
INSERT INTO "invoices" VALUES (5227, '', 1, '', 165011, 'H');
INSERT INTO "invoices" VALUES (5228, '', 3, '', 166064, 'R');
INSERT INTO "invoices" VALUES (5229, '', 2, '', 295406, 'A');
INSERT INTO "invoices" VALUES (5230, '', 1, '', 210352, 'A');
INSERT INTO "invoices" VALUES (5231, '', 1, '', 477791, 'A');
INSERT INTO "invoices" VALUES (5232, '', 1, '', 194400, 'D');
INSERT INTO "invoices" VALUES (5233, '', 2, '', 232855, 'E');
INSERT INTO "invoices" VALUES (5234, '', 3, '', 267379, 'A');
INSERT INTO "invoices" VALUES (5235, '', 2, '', 378578, 'A');
INSERT INTO "invoices" VALUES (5236, '', 2, '', 395947, 'Z');
INSERT INTO "invoices" VALUES (5237, '', 1, '', 310569, 'A');
INSERT INTO "invoices" VALUES (5238, '', 2, '', 167543, 'Z');
INSERT INTO "invoices" VALUES (5239, '', 2, '', 190098, 'A');
INSERT INTO "invoices" VALUES (5240, '', 2, '', 272894, 'A');
INSERT INTO "invoices" VALUES (5241, '', 3, '', 292758, 'A');
INSERT INTO "invoices" VALUES (5242, '', 1, '', 401775, 'Z');
INSERT INTO "invoices" VALUES (5243, '', 1, '', 688078, 'A');
INSERT INTO "invoices" VALUES (5244, '', 1, '', 204434, 'D');
INSERT INTO "invoices" VALUES (5245, '', 2, '', 159826, 'A');
INSERT INTO "invoices" VALUES (5247, '', 2, '', 140193, 'H');
INSERT INTO "invoices" VALUES (5248, '', 1, '', 136414, 'R');
INSERT INTO "invoices" VALUES (5249, '', 4, '', 154234, 'A');
INSERT INTO "invoices" VALUES (5250, '', 3, '', 210975, 'A');
INSERT INTO "invoices" VALUES (5251, '', 4, '', 524355, 'Z');
INSERT INTO "invoices" VALUES (5252, '', 2, '', 385414, 'A');
INSERT INTO "invoices" VALUES (5253, '', 2, '', 345335, 'A');
INSERT INTO "invoices" VALUES (5254, '', 3, '', 269738, 'E');
INSERT INTO "invoices" VALUES (5255, '', 4, '', 313514, 'A');
INSERT INTO "invoices" VALUES (5256, '', 2, '', 155035, 'Z');
INSERT INTO "invoices" VALUES (5257, '', 3, '', 422127, 'A');
INSERT INTO "invoices" VALUES (5258, '', 1, '', 123756, 'E');
INSERT INTO "invoices" VALUES (5259, '', 2, '', 566833, 'Z');
INSERT INTO "invoices" VALUES (5260, '', 1, '', 476862, 'A');
INSERT INTO "invoices" VALUES (5261, '', 1, '', 25445, 'A');
INSERT INTO "invoices" VALUES (5262, '', 2, '', 168441, 'D');
INSERT INTO "invoices" VALUES (5263, '', 7, '', 178926, 'H');
INSERT INTO "invoices" VALUES (5264, '', 5, '', 206237, 'A');
INSERT INTO "invoices" VALUES (5265, '', 4, '', 323019, 'A');
INSERT INTO "invoices" VALUES (5266, '', 3, '', 270731, 'Z');
INSERT INTO "invoices" VALUES (5267, '', 3, '', 268266, 'A');
INSERT INTO "invoices" VALUES (5268, '', 5, '', 655127, 'Z');
INSERT INTO "invoices" VALUES (5269, '', 1, '', 208783, 'Z');
INSERT INTO "invoices" VALUES (5270, '', 4, '', 637484, 'A');
INSERT INTO "invoices" VALUES (5271, '', 3, '', 493332, 'A');
INSERT INTO "invoices" VALUES (5272, '', 2, '', 416131, 'R');
INSERT INTO "invoices" VALUES (5273, '', 1, '', 117930, 'A');
INSERT INTO "invoices" VALUES (5274, '', 3, '', 285640, 'Z');
INSERT INTO "invoices" VALUES (5275, '', 2, '', 264987, 'A');
INSERT INTO "invoices" VALUES (5276, '', 4, '', 346599, 'A');
INSERT INTO "invoices" VALUES (5277, '', 2, '', 325340, 'E');
INSERT INTO "invoices" VALUES (5278, '', 1, '', 206247, 'A');
INSERT INTO "invoices" VALUES (5279, '', 1, '', 394217, 'Z');
INSERT INTO "invoices" VALUES (5280, '', 1, '', 227600, 'H');
INSERT INTO "invoices" VALUES (5281, '', 1, '', 347977, 'A');
INSERT INTO "invoices" VALUES (5282, '', 5, '', 302174, 'A');
INSERT INTO "invoices" VALUES (5283, '', 2, '', 436685, 'D');
INSERT INTO "invoices" VALUES (5284, '', 6, '', 174528, 'Z');
INSERT INTO "invoices" VALUES (5285, '', 1, '', 81038, 'A');
INSERT INTO "invoices" VALUES (5286, '', 3, '', 401184, 'A');
INSERT INTO "invoices" VALUES (5287, '', 6, '', 364572, 'Z');
INSERT INTO "invoices" VALUES (5288, '', 4, '', 296193, 'E');
INSERT INTO "invoices" VALUES (5289, '', 4, '', 388516, 'Z');
INSERT INTO "invoices" VALUES (5290, '', 1, '', 360084, 'A');
INSERT INTO "invoices" VALUES (5292, '', 1, '', 98572, 'H');
INSERT INTO "invoices" VALUES (5293, '', 2, '', 357101, 'A');
INSERT INTO "invoices" VALUES (5294, '', 3, '', 152701, 'R');
INSERT INTO "invoices" VALUES (5295, '', 1, '', 69679, 'A');
INSERT INTO "invoices" VALUES (5296, '', 2, '', 409371, 'H');
INSERT INTO "invoices" VALUES (5297, '', 1, '', 620646, 'A');
INSERT INTO "invoices" VALUES (5298, '', 1, '', 352470, 'Z');
INSERT INTO "invoices" VALUES (5299, '', 1, '', 625158, 'A');
INSERT INTO "invoices" VALUES (5300, '', 4, '', 513061, 'Z');
INSERT INTO "invoices" VALUES (5301, '', 1, '', 115265, 'A');
INSERT INTO "invoices" VALUES (5302, '', 1, '', 358775, 'A');
INSERT INTO "invoices" VALUES (5303, '', 5, '', 247803, 'A');
INSERT INTO "invoices" VALUES (5304, '', 6, '', 242615, 'A');
INSERT INTO "invoices" VALUES (5305, '', 3, '', 241073, 'E');
INSERT INTO "invoices" VALUES (5306, '', 2, '', 403372, 'Z');
INSERT INTO "invoices" VALUES (5307, '', 3, '', 259072, 'D');
INSERT INTO "invoices" VALUES (5308, '', 5, '', 255005, 'Z');
INSERT INTO "invoices" VALUES (5309, '', 1, '', 338489, 'A');
INSERT INTO "invoices" VALUES (5310, '', 1, '', 493015, 'A');
INSERT INTO "invoices" VALUES (5311, '', 1, '', 474010, 'H');
INSERT INTO "invoices" VALUES (5312, '', 7, '', 218872, 'A');
INSERT INTO "invoices" VALUES (5313, '', 6, '', 295388, 'A');
INSERT INTO "invoices" VALUES (5314, '', 1, '', 249587, 'R');
INSERT INTO "invoices" VALUES (5315, '', 3, '', 330928, 'H');
INSERT INTO "invoices" VALUES (5316, '', 2, '', 356484, 'Z');
INSERT INTO "invoices" VALUES (5317, '', 2, '', 314046, 'A');
INSERT INTO "invoices" VALUES (5318, '', 2, '', 253657, 'A');
INSERT INTO "invoices" VALUES (5319, '', 1, '', 410458, 'Z');
INSERT INTO "invoices" VALUES (5320, '', 2, '', 147346, 'A');
INSERT INTO "invoices" VALUES (5321, '', 5, '', 257747, 'E');
INSERT INTO "invoices" VALUES (5322, '', 1, '', 372058, 'D');
INSERT INTO "invoices" VALUES (5323, '', 1, '', 361724, 'A');
INSERT INTO "invoices" VALUES (5324, '', 2, '', 337387, 'A');
INSERT INTO "invoices" VALUES (5325, '', 1, '', 575982, 'Z');
INSERT INTO "invoices" VALUES (5326, '', 5, '', 301657, 'Z');
INSERT INTO "invoices" VALUES (5327, '', 4, '', 298915, 'A');
INSERT INTO "invoices" VALUES (5328, '', 3, '', 633403, 'A');
INSERT INTO "invoices" VALUES (5329, '', 1, '', 40680, 'A');
INSERT INTO "invoices" VALUES (5330, '', 4, '', 226630, 'E');
INSERT INTO "invoices" VALUES (5331, '', 3, '', 133820, 'Z');
INSERT INTO "invoices" VALUES (5332, '', 2, '', 307570, 'R');
INSERT INTO "invoices" VALUES (5333, '', 2, '', 348219, 'A');
INSERT INTO "invoices" VALUES (5334, '', 2, '', 242850, 'A');
INSERT INTO "invoices" VALUES (5335, '', 3, '', 343126, 'A');
INSERT INTO "invoices" VALUES (5336, '', 2, '', 289926, 'H');
INSERT INTO "invoices" VALUES (5337, '', 2, '', 468996, 'Z');
INSERT INTO "invoices" VALUES (5338, '', 7, '', 168474, 'A');
INSERT INTO "invoices" VALUES (5339, '', 4, '', 173705, 'H');
INSERT INTO "invoices" VALUES (5340, '', 6, '', 146325, 'E');
INSERT INTO "invoices" VALUES (5341, '', 2, '', 242090, 'A');
INSERT INTO "invoices" VALUES (5342, '', 3, '', 306554, 'Z');
INSERT INTO "invoices" VALUES (5343, '', 3, '', 211434, 'A');
INSERT INTO "invoices" VALUES (5344, '', 3, '', 274375, 'A');
INSERT INTO "invoices" VALUES (5345, '', 6, '', 218335, 'Z');
INSERT INTO "invoices" VALUES (5346, '', 4, '', 183018, 'A');
INSERT INTO "invoices" VALUES (5347, '', 3, '', 209497, 'A');
INSERT INTO "invoices" VALUES (5348, '', 1, '', 185700, 'D');
INSERT INTO "invoices" VALUES (5349, '', 2, '', 239630, 'D');
INSERT INTO "invoices" VALUES (5350, '', 5, '', 146919, 'E');
INSERT INTO "invoices" VALUES (5351, '', 4, '', 137472, 'Z');
INSERT INTO "invoices" VALUES (5352, '', 1, '', 108812, 'Z');
INSERT INTO "invoices" VALUES (5353, '', 2, '', 266955, 'Z');
INSERT INTO "invoices" VALUES (5382, '', 5, '', 266954, 'Z');
INSERT INTO "invoices" VALUES (5383, '', 5, '', 258982, 'A');
INSERT INTO "invoices" VALUES (5384, '', 4, '', 252440, 'Z');
INSERT INTO "invoices" VALUES (5385, '', 8, '', 257232, 'R');
INSERT INTO "invoices" VALUES (5386, '', 3, '', 233505, 'D');
INSERT INTO "invoices" VALUES (5387, '', 6, '', 189903, 'E');
INSERT INTO "invoices" VALUES (5388, '', 4, '', 246008, 'H');
INSERT INTO "invoices" VALUES (5390, '', 6, '', 158429, 'Z');
INSERT INTO "invoices" VALUES (5391, '', 1, '', 203443, 'A');
INSERT INTO "invoices" VALUES (5392, '', 5, '', 267613, 'R');
INSERT INTO "invoices" VALUES (5393, '', 5, '', 287629, 'A');
INSERT INTO "invoices" VALUES (5394, '', 4, '', 237254, 'A');
INSERT INTO "invoices" VALUES (5395, '', 1, '', 305780, 'Z');
INSERT INTO "invoices" VALUES (5396, '', 6, '', 225960, 'H');
INSERT INTO "invoices" VALUES (5397, '', 1, '', 156747, 'A');
INSERT INTO "invoices" VALUES (5398, '', 2, '', 200622, 'A');
INSERT INTO "invoices" VALUES (5399, '', 4, '', 327499, 'Z');
INSERT INTO "invoices" VALUES (5400, '', 5, '', 291160, 'A');
INSERT INTO "invoices" VALUES (5401, '', 5, '', 373529, 'A');
INSERT INTO "invoices" VALUES (5402, '', 1, '', 426930, 'A');
INSERT INTO "invoices" VALUES (5403, '', 3, '', 371599, 'A');
INSERT INTO "invoices" VALUES (5404, '', 6, '', 275709, 'A');
INSERT INTO "invoices" VALUES (5405, '', 5, '', 334602, 'Z');
INSERT INTO "invoices" VALUES (5406, '', 7, '', 344879, 'E');
INSERT INTO "invoices" VALUES (5407, '', 6, '', 403099, 'A');
INSERT INTO "invoices" VALUES (5408, '', 6, '', 444704, 'A');
INSERT INTO "invoices" VALUES (5409, '', 1, '', 117081, 'H');
INSERT INTO "invoices" VALUES (5410, '', 2, '', 141843, 'A');
INSERT INTO "invoices" VALUES (5411, '', 1, '', 133278, 'D');
INSERT INTO "invoices" VALUES (5412, '', 5, '', 259932, 'Z');
INSERT INTO "invoices" VALUES (5413, '', 1, '', 282549, 'A');
INSERT INTO "invoices" VALUES (5414, '', 6, '', 299590, 'A');
INSERT INTO "invoices" VALUES (5415, '', 6, '', 231029, 'R');
INSERT INTO "invoices" VALUES (5416, '', 2, '', 305127, 'Z');
INSERT INTO "invoices" VALUES (5417, '', 1, '', 100588, 'E');
INSERT INTO "invoices" VALUES (5418, '', 1, '', 85798, 'A');
INSERT INTO "invoices" VALUES (5421, '', 7, '', 305601, 'H');
INSERT INTO "invoices" VALUES (5422, '', 1, '', 241497, 'A');
INSERT INTO "invoices" VALUES (5423, '', 1, '', 288282, 'D');
INSERT INTO "invoices" VALUES (5424, '', 1, '', 274114, 'A');
INSERT INTO "invoices" VALUES (5425, '', 7, '', 274586, 'Z');
INSERT INTO "invoices" VALUES (5426, '', 2, '', 421417, 'A');
INSERT INTO "invoices" VALUES (5427, '', 2, '', 240626, 'Z');
INSERT INTO "invoices" VALUES (5428, '', 4, '', 182545, 'A');
INSERT INTO "invoices" VALUES (5429, '', 1, '', 149477, 'Z');
INSERT INTO "invoices" VALUES (5430, '', 1, '', 86266, 'A');
INSERT INTO "invoices" VALUES (5431, '', 1, '', 238715, 'E');
INSERT INTO "invoices" VALUES (5432, '', 6, '', 254955, 'A');
INSERT INTO "invoices" VALUES (5433, '', 2, '', 151042, 'D');
INSERT INTO "invoices" VALUES (5434, '', 7, '', 263983, 'Z');
INSERT INTO "invoices" VALUES (5435, '', 7, '', 222836, 'A');
INSERT INTO "invoices" VALUES (5436, '', 6, '', 217000, 'Z');
INSERT INTO "invoices" VALUES (5437, '', 8, '', 235881, 'A');
INSERT INTO "invoices" VALUES (5438, '', 7, '', 317939, 'A');
INSERT INTO "invoices" VALUES (5439, '', 6, '', 493579, 'A');
INSERT INTO "invoices" VALUES (5440, '', 7, '', 315986, 'R');
INSERT INTO "invoices" VALUES (5441, '', 1, '', 229230, 'A');
INSERT INTO "invoices" VALUES (5442, '', 1, '', 274061, 'A');
INSERT INTO "invoices" VALUES (5443, '', 2, '', 166722, 'D');
INSERT INTO "invoices" VALUES (5444, '', 1, '', 240722, 'A');
INSERT INTO "invoices" VALUES (5445, '', 6, '', 190414, 'H');
INSERT INTO "invoices" VALUES (5446, '', 3, '', 301721, 'Z');
INSERT INTO "invoices" VALUES (5447, '', 1, '', 767178, 'A');
INSERT INTO "invoices" VALUES (5448, '', 2, '', 222980, 'Z');
INSERT INTO "invoices" VALUES (5449, '', 8, '', 306980, 'Z');
INSERT INTO "invoices" VALUES (5450, '', 1, '', 323848, 'R');
INSERT INTO "invoices" VALUES (5451, '', 1, '', 191940, 'R');
INSERT INTO "invoices" VALUES (5452, '', 1, '', 146872, 'D');
INSERT INTO "invoices" VALUES (5453, '', 2, '', 466158, 'E');
INSERT INTO "invoices" VALUES (5454, '', 7, '', 258198, 'A');
INSERT INTO "invoices" VALUES (5455, '', 7, '', 348790, 'Z');
INSERT INTO "invoices" VALUES (5456, '', 3, '', 407049, 'A');
INSERT INTO "invoices" VALUES (5457, '', 9, '', 361517, 'H');
INSERT INTO "invoices" VALUES (5458, '', 5, '', 302194, 'A');
INSERT INTO "invoices" VALUES (5459, '', 1, '', 175078, 'A');
INSERT INTO "invoices" VALUES (5460, '', 7, '', 345477, 'Z');
INSERT INTO "invoices" VALUES (5461, '', 2, '', 283462, 'A');
INSERT INTO "invoices" VALUES (5462, '', 2, '', 233025, 'A');
INSERT INTO "invoices" VALUES (5463, '', 8, '', 221572, 'E');
INSERT INTO "invoices" VALUES (5464, '', 3, '', 202700, 'D');
INSERT INTO "invoices" VALUES (5465, '', 8, '', 232134, 'Z');
INSERT INTO "invoices" VALUES (5466, '', 1, '', 117854, 'Z');
INSERT INTO "invoices" VALUES (5467, '', 8, '', 213762, 'H');
INSERT INTO "invoices" VALUES (5468, '', 1, '', 142837, 'R');
INSERT INTO "invoices" VALUES (5469, '', 1, '', 54670, 'A');
INSERT INTO "invoices" VALUES (5471, '', 2, '', 276427, 'E');
INSERT INTO "invoices" VALUES (5472, '', 3, '', 221080, 'D');
INSERT INTO "invoices" VALUES (5473, '', 2, '', 696375, 'A');
INSERT INTO "invoices" VALUES (5474, '', 2, '', 247720, 'R');
INSERT INTO "invoices" VALUES (5475, '', 4, '', 308208, 'A');
INSERT INTO "invoices" VALUES (5476, '', 6, '', 370317, 'A');
INSERT INTO "invoices" VALUES (5477, '', 7, '', 264336, 'H');
INSERT INTO "invoices" VALUES (5478, '', 4, '', 493167, 'Z');
INSERT INTO "invoices" VALUES (5479, '', 1, '', 198502, 'Z');
INSERT INTO "invoices" VALUES (5480, '', 1, '', 27719, 'A');
INSERT INTO "invoices" VALUES (5481, '', 1, '', 91409, 'A');
INSERT INTO "invoices" VALUES (5482, '', 3, '', 325980, 'A');
INSERT INTO "invoices" VALUES (5483, '', 3, '', 353729, 'A');
INSERT INTO "invoices" VALUES (5484, '', 8, '', 291879, 'A');
INSERT INTO "invoices" VALUES (5485, '', 1, '', 169188, 'R');
INSERT INTO "invoices" VALUES (5486, '', 1, '', 213007, 'H');
INSERT INTO "invoices" VALUES (5487, '', 8, '', 283223, 'Z');
INSERT INTO "invoices" VALUES (5488, '', 8, '', 278431, 'Z');
INSERT INTO "invoices" VALUES (5489, '', 1, '', 68536, 'A');
INSERT INTO "invoices" VALUES (5490, '', 1, '', 149818, 'A');
INSERT INTO "invoices" VALUES (5491, '', 3, '', 475060, 'A');
INSERT INTO "invoices" VALUES (5492, '', 3, '', 520566, 'A');
INSERT INTO "invoices" VALUES (5493, '', 3, '', 439431, 'E');
INSERT INTO "invoices" VALUES (5494, '', 1, '', 501844, 'A');
INSERT INTO "invoices" VALUES (5495, '', 4, '', 371968, 'D');
INSERT INTO "invoices" VALUES (5496, '', 7, '', 406556, 'Z');
INSERT INTO "invoices" VALUES (5497, '', 5, '', 412482, 'Z');
INSERT INTO "invoices" VALUES (5498, '', 1, '', 83319, 'A');
INSERT INTO "invoices" VALUES (5499, '', 1, '', 143203, 'A');
INSERT INTO "invoices" VALUES (5500, '', 1, '', 62881, 'A');
INSERT INTO "invoices" VALUES (5501, '', 4, '', 448518, 'A');
INSERT INTO "invoices" VALUES (5502, '', 4, '', 486708, 'A');
INSERT INTO "invoices" VALUES (5503, '', 3, '', 333980, 'R');
INSERT INTO "invoices" VALUES (5504, '', 1, '', 221880, 'A');
INSERT INTO "invoices" VALUES (5505, '', 5, '', 429012, 'A');
INSERT INTO "invoices" VALUES (5506, '', 1, '', 400719, 'H');
INSERT INTO "invoices" VALUES (5507, '', 1, '', 442481, 'Z');
INSERT INTO "invoices" VALUES (5508, '', 9, '', 387072, 'Z');
INSERT INTO "invoices" VALUES (5509, '', 1, '', 2300, 'A');
INSERT INTO "invoices" VALUES (5510, '', 1, '', 81761, 'A');
INSERT INTO "invoices" VALUES (5511, '', 1, '', 92769, 'A');
INSERT INTO "invoices" VALUES (5512, '', 2, '', 182731, 'Z');
INSERT INTO "invoices" VALUES (5513, '', 4, '', 255106, 'D');
INSERT INTO "invoices" VALUES (5514, '', 1, '', 256151, 'A');
INSERT INTO "invoices" VALUES (5515, '', 2, '', 371244, 'A');
INSERT INTO "invoices" VALUES (5516, '', 2, '', 222838, 'E');
INSERT INTO "invoices" VALUES (5517, '', 9, '', 340496, 'Z');
INSERT INTO "invoices" VALUES (5518, '', 1, '', 248214, 'A');
INSERT INTO "invoices" VALUES (5519, '', 2, '', 156240, 'Z');
INSERT INTO "invoices" VALUES (5520, '', 1, '', 254559, 'A');
INSERT INTO "invoices" VALUES (5521, '', 1, '', 64899, 'A');
INSERT INTO "invoices" VALUES (5522, '', 1, '', 74045, 'A');
INSERT INTO "invoices" VALUES (5523, '', 1, '', 282780, 'A');
INSERT INTO "invoices" VALUES (5524, '', 1, '', 296773, 'A');
INSERT INTO "invoices" VALUES (5525, '', 1, '', 272087, 'Z');
INSERT INTO "invoices" VALUES (5526, '', 4, '', 386123, 'R');
INSERT INTO "invoices" VALUES (5527, '', 1, '', 300465, 'A');
INSERT INTO "invoices" VALUES (5528, '', 1, '', 293688, 'A');
INSERT INTO "invoices" VALUES (5529, '', 2, '', 300246, 'Z');
INSERT INTO "invoices" VALUES (5530, '', 5, '', 297326, 'A');
INSERT INTO "invoices" VALUES (5531, '', 2, '', 438408, 'H');
INSERT INTO "invoices" VALUES (5532, '', 2, '', 346965, 'Z');
INSERT INTO "invoices" VALUES (5533, '', 1, '', 288401, 'A');
INSERT INTO "invoices" VALUES (5534, '', 1, '', 67973, 'A');
INSERT INTO "invoices" VALUES (5535, '', 1, '', 77252, 'A');
INSERT INTO "invoices" VALUES (5536, '', 2, '', 206354, 'Z');
INSERT INTO "invoices" VALUES (5537, '', 2, '', 388946, 'A');
INSERT INTO "invoices" VALUES (5538, '', 1, '', 110760, 'Z');
INSERT INTO "invoices" VALUES (5539, '', 1, '', 72499, 'E');
INSERT INTO "invoices" VALUES (5540, '', 2, '', 138867, 'A');
INSERT INTO "invoices" VALUES (5541, '', 1, '', 88721, 'D');
INSERT INTO "invoices" VALUES (5542, '', 2, '', 118033, 'A');
INSERT INTO "invoices" VALUES (5543, '', 1, '', 123270, 'H');
INSERT INTO "invoices" VALUES (5544, '', 1, '', 126912, 'Z');
INSERT INTO "invoices" VALUES (5545, '', 1, '', 212664, 'A');
INSERT INTO "invoices" VALUES (5546, '', 5, '', 381120, 'A');
INSERT INTO "invoices" VALUES (5547, '', 5, '', 367680, 'A');
INSERT INTO "invoices" VALUES (5548, '', 1, '', 266546, 'R');
INSERT INTO "invoices" VALUES (5549, '', 1, '', 116032, 'A');
INSERT INTO "invoices" VALUES (5550, '', 1, '', 195538, 'D');
INSERT INTO "invoices" VALUES (5551, '', 1, '', 262570, 'E');
INSERT INTO "invoices" VALUES (5552, '', 1, '', 327501, 'Z');
INSERT INTO "invoices" VALUES (5553, '', 3, '', 363373, 'Z');
INSERT INTO "invoices" VALUES (5554, '', 1, '', 375847, 'A');
INSERT INTO "invoices" VALUES (5555, '', 1, '', 133015, 'A');
INSERT INTO "invoices" VALUES (5556, '', 2, '', 156287, 'A');
INSERT INTO "invoices" VALUES (5557, '', 1, '', 127026, 'E');
INSERT INTO "invoices" VALUES (5558, '', 5, '', 209944, 'D');
INSERT INTO "invoices" VALUES (5559, '', 1, '', 292165, 'A');
INSERT INTO "invoices" VALUES (5560, '', 1, '', 207691, 'Z');
INSERT INTO "invoices" VALUES (5561, '', 1, '', 174176, 'Z');
INSERT INTO "invoices" VALUES (5562, '', 1, '', 403209, 'A');
INSERT INTO "invoices" VALUES (5563, '', 1, '', 196998, 'Z');
INSERT INTO "invoices" VALUES (5564, '', 1, '', 155960, 'A');
INSERT INTO "invoices" VALUES (5565, '', 3, '', 268129, 'H');
INSERT INTO "invoices" VALUES (5566, '', 1, '', 428344, 'A');
INSERT INTO "invoices" VALUES (5567, '', 2, '', 170219, 'R');
INSERT INTO "invoices" VALUES (5568, '', 2, '', 48336, 'A');
INSERT INTO "invoices" VALUES (5569, '', 3, '', 131792, 'A');
INSERT INTO "invoices" VALUES (5570, '', 1, '', 52391, 'A');
INSERT INTO "invoices" VALUES (5571, '', 1, '', 143354, 'E');
INSERT INTO "invoices" VALUES (5572, '', 1, '', 165037, 'A');
INSERT INTO "invoices" VALUES (5573, '', 1, '', 205520, 'R');
INSERT INTO "invoices" VALUES (5574, '', 1, '', 150632, 'Z');
INSERT INTO "invoices" VALUES (5575, '', 1, '', 211398, 'A');
INSERT INTO "invoices" VALUES (5576, '', 1, '', 218139, 'D');
INSERT INTO "invoices" VALUES (5577, '', 2, '', 154162, 'Z');
INSERT INTO "invoices" VALUES (5578, '', 2, '', 351202, 'A');
INSERT INTO "invoices" VALUES (5579, '', 1, '', 209842, 'A');
INSERT INTO "invoices" VALUES (5580, '', 1, '', 362274, 'A');
INSERT INTO "invoices" VALUES (5581, '', 2, '', 373452, 'Z');
INSERT INTO "invoices" VALUES (5582, '', 1, '', 301135, 'A');
INSERT INTO "invoices" VALUES (5583, '', 1, '', 143354, 'H');
INSERT INTO "invoices" VALUES (5584, '', 2, '', 179196, 'A');
INSERT INTO "invoices" VALUES (5585, '', 2, '', 203208, 'A');
INSERT INTO "invoices" VALUES (5586, '', 2, '', 242397, 'A');
INSERT INTO "invoices" VALUES (5587, '', 1, '', 157523, 'A');
INSERT INTO "invoices" VALUES (5588, '', 2, '', 13924, 'Z');
INSERT INTO "invoices" VALUES (5589, '', 1, '', 97796, 'A');
INSERT INTO "invoices" VALUES (5590, '', 6, '', 265612, 'A');
INSERT INTO "invoices" VALUES (5591, '', 1, '', 213638, 'D');
INSERT INTO "invoices" VALUES (5592, '', 1, '', 179370, 'Z');
INSERT INTO "invoices" VALUES (5593, '', 1, '', 277686, 'A');
INSERT INTO "invoices" VALUES (5594, '', 2, '', 228865, 'E');
INSERT INTO "invoices" VALUES (5595, '', 2, '', 191261, 'Z');
INSERT INTO "invoices" VALUES (5596, '', 4, '', 281732, 'H');
INSERT INTO "invoices" VALUES (5597, '', 1, '', 284697, 'A');
INSERT INTO "invoices" VALUES (5598, '', 2, '', 388958, 'A');
INSERT INTO "invoices" VALUES (5599, '', 1, '', 242014, 'Z');
INSERT INTO "invoices" VALUES (5600, '', 1, '', 471912, 'A');
INSERT INTO "invoices" VALUES (5601, '', 2, '', 312625, 'R');
INSERT INTO "invoices" VALUES (5602, '', 1, '', 408196, 'A');
INSERT INTO "invoices" VALUES (5603, '', 1, '', 393098, 'Z');
INSERT INTO "invoices" VALUES (5604, '', 1, '', 207395, 'E');
INSERT INTO "invoices" VALUES (5605, '', 1, '', 249916, 'A');
INSERT INTO "invoices" VALUES (5606, '', 2, '', 228155, 'Z');
INSERT INTO "invoices" VALUES (5607, '', 1, '', 92349, 'A');
INSERT INTO "invoices" VALUES (5608, '', 1, '', 106671, 'A');
INSERT INTO "invoices" VALUES (5609, '', 6, '', 374169, 'R');
INSERT INTO "invoices" VALUES (5610, '', 1, '', 207625, 'E');
INSERT INTO "invoices" VALUES (5611, '', 2, '', 281920, 'A');
INSERT INTO "invoices" VALUES (5612, '', 3, '', 248481, 'H');
INSERT INTO "invoices" VALUES (5613, '', 3, '', 369097, 'Z');
INSERT INTO "invoices" VALUES (5614, '', 2, '', 377812, 'A');
INSERT INTO "invoices" VALUES (5615, '', 1, '', 372660, 'Z');
INSERT INTO "invoices" VALUES (5616, '', 2, '', 298489, 'D');
INSERT INTO "invoices" VALUES (5617, '', 2, '', 425129, 'A');
INSERT INTO "invoices" VALUES (5618, '', 1, '', 190246, 'E');
INSERT INTO "invoices" VALUES (5619, '', 2, '', 274151, 'Z');
INSERT INTO "invoices" VALUES (5620, '', 2, '', 405686, 'A');
INSERT INTO "invoices" VALUES (5621, '', 3, '', 374652, 'A');
INSERT INTO "invoices" VALUES (5622, '', 2, '', 407153, 'Z');
INSERT INTO "invoices" VALUES (5623, '', 1, '', 188139, 'A');
INSERT INTO "invoices" VALUES (5624, '', 1, '', 104406, 'A');
INSERT INTO "invoices" VALUES (5625, '', 1, '', 138285, 'A');
INSERT INTO "invoices" VALUES (5626, '', 1, '', 148315, 'A');
INSERT INTO "invoices" VALUES (5627, '', 2, '', 308393, 'D');
INSERT INTO "invoices" VALUES (5628, '', 2, '', 244587, 'Z');
INSERT INTO "invoices" VALUES (5629, '', 3, '', 395577, 'E');
INSERT INTO "invoices" VALUES (5630, '', 2, '', 366601, 'A');
INSERT INTO "invoices" VALUES (5631, '', 2, '', 373661, 'R');
INSERT INTO "invoices" VALUES (5632, '', 2, '', 392921, 'A');
INSERT INTO "invoices" VALUES (5633, '', 1, '', 365615, 'Z');
INSERT INTO "invoices" VALUES (5634, '', 2, '', 330506, 'A');
INSERT INTO "invoices" VALUES (5635, '', 2, '', 253778, 'H');
INSERT INTO "invoices" VALUES (5636, '', 2, '', 325845, 'Z');
INSERT INTO "invoices" VALUES (5637, '', 1, '', 27143, 'Z');
INSERT INTO "invoices" VALUES (5638, '', 3, '', 217055, 'A');
INSERT INTO "invoices" VALUES (5639, '', 1, '', 170848, 'Z');
INSERT INTO "invoices" VALUES (5640, '', 1, '', 118007, 'A');
INSERT INTO "invoices" VALUES (5641, '', 1, '', 133460, 'A');
INSERT INTO "invoices" VALUES (5642, '', 2, '', 374475, 'A');
INSERT INTO "invoices" VALUES (5643, '', 1, '', 213744, 'H');
INSERT INTO "invoices" VALUES (5644, '', 2, '', 263014, 'E');
INSERT INTO "invoices" VALUES (5645, '', 1, '', 256424, 'D');
INSERT INTO "invoices" VALUES (5646, '', 1, '', 268643, 'R');
INSERT INTO "invoices" VALUES (5647, '', 3, '', 302855, 'Z');
INSERT INTO "invoices" VALUES (5648, '', 1, '', 9162, 'A');
INSERT INTO "invoices" VALUES (5651, '', 2, '', 126099, 'R');
INSERT INTO "invoices" VALUES (5652, '', 2, '', 183534, 'E');
INSERT INTO "invoices" VALUES (5653, '', 1, '', 135168, 'D');
INSERT INTO "invoices" VALUES (5654, '', 2, '', 332918, 'A');
INSERT INTO "invoices" VALUES (5655, '', 4, '', 252345, 'Z');
INSERT INTO "invoices" VALUES (5656, '', 2, '', 127951, 'H');
INSERT INTO "invoices" VALUES (5657, '', 3, '', 273945, 'A');
INSERT INTO "invoices" VALUES (5658, '', 2, '', 283226, 'Z');
INSERT INTO "invoices" VALUES (5659, '', 1, '', 20829, 'A');
INSERT INTO "invoices" VALUES (5660, '', 3, '', 216087, 'R');
INSERT INTO "invoices" VALUES (5661, '', 1, '', 353214, 'A');
INSERT INTO "invoices" VALUES (5662, '', 5, '', 235974, 'H');
INSERT INTO "invoices" VALUES (5663, '', 2, '', 295332, 'Z');
INSERT INTO "invoices" VALUES (5664, '', 3, '', 293529, 'A');
INSERT INTO "invoices" VALUES (5665, '', 3, '', 258232, 'E');
INSERT INTO "invoices" VALUES (5666, '', 3, '', 210177, 'D');
INSERT INTO "invoices" VALUES (5667, '', 1, '', 14365, 'A');
INSERT INTO "invoices" VALUES (5668, '', 3, '', 159664, 'Z');
INSERT INTO "invoices" VALUES (5669, '', 1, '', 162973, 'A');
INSERT INTO "invoices" VALUES (5670, '', 1, '', 345644, 'A');
INSERT INTO "invoices" VALUES (5671, '', 1, '', 366032, 'A');
INSERT INTO "invoices" VALUES (5672, '', 1, '', 300599, 'E');
INSERT INTO "invoices" VALUES (5673, '', 3, '', 337695, 'Z');
INSERT INTO "invoices" VALUES (5675, '', 1, '', 94656, 'Z');
INSERT INTO "invoices" VALUES (5676, '', 1, '', 327262, 'R');
INSERT INTO "invoices" VALUES (5677, '', 1, '', 307598, 'H');
INSERT INTO "invoices" VALUES (5678, '', 1, '', 437248, 'Z');
INSERT INTO "invoices" VALUES (5679, '', 1, '', 125499, 'A');
INSERT INTO "invoices" VALUES (5680, '', 1, '', 225831, 'E');
INSERT INTO "invoices" VALUES (5681, '', 1, '', 319972, 'Z');
INSERT INTO "invoices" VALUES (5682, '', 1, '', 280655, 'D');
INSERT INTO "invoices" VALUES (5683, '', 3, '', 399280, 'A');
INSERT INTO "invoices" VALUES (5685, '', 1, '', 425982, 'A');
INSERT INTO "invoices" VALUES (5686, '', 3, '', 550326, 'A');
INSERT INTO "invoices" VALUES (5687, '', 3, '', 97915, 'A');
INSERT INTO "invoices" VALUES (5688, '', 3, '', 103407, 'Z');
INSERT INTO "invoices" VALUES (5689, '', 1, '', 169836, 'Z');
INSERT INTO "invoices" VALUES (5690, '', 1, '', 193085, 'A');
INSERT INTO "invoices" VALUES (5691, '', 3, '', 167360, 'A');
INSERT INTO "invoices" VALUES (5692, '', 2, '', 211170, 'H');
INSERT INTO "invoices" VALUES (5693, '', 3, '', 206847, 'D');
INSERT INTO "invoices" VALUES (5694, '', 1, '', 377739, 'A');
INSERT INTO "invoices" VALUES (5695, '', 1, '', 222754, 'R');
INSERT INTO "invoices" VALUES (5696, '', 3, '', 417081, 'A');
INSERT INTO "invoices" VALUES (5697, '', 3, '', 351955, 'Z');
INSERT INTO "invoices" VALUES (5698, '', 4, '', 477332, 'A');
INSERT INTO "invoices" VALUES (5699, '', 3, '', 191788, 'E');
INSERT INTO "invoices" VALUES (5700, '', 3, '', 344024, 'Z');
INSERT INTO "invoices" VALUES (5701, '', 4, '', 112025, 'Z');
INSERT INTO "invoices" VALUES (5702, '', 1, '', 85736, 'A');
INSERT INTO "invoices" VALUES (5703, '', 2, '', 302228, 'A');
INSERT INTO "invoices" VALUES (5704, '', 1, '', 66660, 'A');
INSERT INTO "invoices" VALUES (5705, '', 1, '', 94568, 'E');
INSERT INTO "invoices" VALUES (5706, '', 1, '', 113528, 'H');
INSERT INTO "invoices" VALUES (5707, '', 2, '', 301339, 'A');
INSERT INTO "invoices" VALUES (5708, '', 1, '', 342864, 'Z');
INSERT INTO "invoices" VALUES (5709, '', 1, '', 257494, 'A');
INSERT INTO "invoices" VALUES (5710, '', 4, '', 331457, 'A');
INSERT INTO "invoices" VALUES (5711, '', 4, '', 272708, 'A');
INSERT INTO "invoices" VALUES (5712, '', 4, '', 355182, 'Z');
INSERT INTO "invoices" VALUES (5713, '', 2, '', 137377, 'Z');
INSERT INTO "invoices" VALUES (5714, '', 4, '', 184178, 'A');
INSERT INTO "invoices" VALUES (5715, '', 1, '', 104987, 'E');
INSERT INTO "invoices" VALUES (5716, '', 1, '', 70019, 'D');
INSERT INTO "invoices" VALUES (5717, '', 1, '', 102134, 'Z');
INSERT INTO "invoices" VALUES (5718, '', 2, '', 4076, 'A');
INSERT INTO "invoices" VALUES (5719, '', 3, '', 196095, 'Z');
INSERT INTO "invoices" VALUES (5720, '', 2, '', 286367, 'A');
INSERT INTO "invoices" VALUES (5721, '', 2, '', 587485, 'A');
INSERT INTO "invoices" VALUES (5722, '', 2, '', 542864, 'A');
INSERT INTO "invoices" VALUES (5723, '', 2, '', 337619, 'R');
INSERT INTO "invoices" VALUES (5724, '', 2, '', 455873, 'Z');
INSERT INTO "invoices" VALUES (5725, '', 1, '', 318962, 'A');
INSERT INTO "invoices" VALUES (5726, '', 2, '', 422228, 'D');
INSERT INTO "invoices" VALUES (5727, '', 2, '', 251738, 'H');
INSERT INTO "invoices" VALUES (5728, '', 2, '', 12043, 'A');
INSERT INTO "invoices" VALUES (5729, '', 1, '', 238739, 'D');
INSERT INTO "invoices" VALUES (5729, '', 1, '', 235436, 'E');
INSERT INTO "invoices" VALUES (5730, '', 1, '', 50133, 'A');
INSERT INTO "invoices" VALUES (5732, '', 1, '', 379979, 'A');
INSERT INTO "invoices" VALUES (5733, '', 3, '', 169540, 'E');
INSERT INTO "invoices" VALUES (5733, '', 3, '', 203831, 'H');
INSERT INTO "invoices" VALUES (5734, '', 2, '', 638350, 'A');
INSERT INTO "invoices" VALUES (5735, '', 1, '', 210368, 'D');
INSERT INTO "invoices" VALUES (5735, '', 1, '', 163118, 'R');
INSERT INTO "invoices" VALUES (5736, '', 1, '', 317891, 'Z');
INSERT INTO "invoices" VALUES (5737, '', 4, '', 335877, 'Z');
INSERT INTO "invoices" VALUES (5738, '', 2, '', 191426, 'A');
INSERT INTO "invoices" VALUES (5739, '', 1, '', 170754, 'Z');
INSERT INTO "invoices" VALUES (5740, '', 1, '', 15286, 'D');
INSERT INTO "invoices" VALUES (5740, '', 1, '', 15824, 'R');
INSERT INTO "invoices" VALUES (5740, '', 1, '', 207268, 'Z');
INSERT INTO "invoices" VALUES (5741, '', 4, '', 316932, 'A');
INSERT INTO "invoices" VALUES (5742, '', 3, '', 472276, 'A');
INSERT INTO "invoices" VALUES (5743, '', 1, '', 487580, 'A');
INSERT INTO "invoices" VALUES (5744, '', 4, '', 425315, 'Z');
INSERT INTO "invoices" VALUES (5745, '', 4, '', 424629, 'Z');
INSERT INTO "invoices" VALUES (5746, '', 2, '', 245825, 'H');
INSERT INTO "invoices" VALUES (5746, '', 2, '', 242970, 'E');
INSERT INTO "invoices" VALUES (5747, '', 2, '', 280454, 'R');
INSERT INTO "invoices" VALUES (5747, '', 2, '', 279375, 'D');
INSERT INTO "invoices" VALUES (5747, '', 2, '', 41289, 'Z');
INSERT INTO "invoices" VALUES (5748, '', 2, '', 514745, 'A');
INSERT INTO "invoices" VALUES (5749, '', 3, '', 187501, 'Z');
INSERT INTO "invoices" VALUES (5750, '', 4, '', 260850, 'A');
INSERT INTO "invoices" VALUES (5751, '', 1, '', 118219, 'H');
INSERT INTO "invoices" VALUES (5751, '', 1, '', 118622, 'E');
INSERT INTO "invoices" VALUES (5751, '', 1, '', 166960, 'A');
INSERT INTO "invoices" VALUES (5752, '', 5, '', 438745, 'A');
INSERT INTO "invoices" VALUES (5753, '', 2, '', 26780, 'R');
INSERT INTO "invoices" VALUES (5753, '', 2, '', 26710, 'D');
INSERT INTO "invoices" VALUES (5753, '', 2, '', 152254, 'Z');
INSERT INTO "invoices" VALUES (5754, '', 1, '', 199792, 'A');
INSERT INTO "invoices" VALUES (5755, '', 3, '', 6575, 'H');
INSERT INTO "invoices" VALUES (5755, '', 3, '', 62181, 'E');
INSERT INTO "invoices" VALUES (5755, '', 3, '', 458871, 'A');
INSERT INTO "invoices" VALUES (5756, '', 3, '', 9354, 'A');
INSERT INTO "invoices" VALUES (5757, '', 2, '', 53611, 'H');
INSERT INTO "invoices" VALUES (5757, '', 2, '', 371726, 'A');
INSERT INTO "invoices" VALUES (5758, '', 5, '', 21261, 'R');
INSERT INTO "invoices" VALUES (5758, '', 5, '', 1304, 'A');
INSERT INTO "invoices" VALUES (5758, '', 5, '', 452929, 'Z');
INSERT INTO "invoices" VALUES (5758, '', 5, '', 81367, 'D');
INSERT INTO "invoices" VALUES (5759, '', 5, '', 717, 'A');
INSERT INTO "invoices" VALUES (5759, '', 5, '', 71052, 'D');
INSERT INTO "invoices" VALUES (5759, '', 5, '', 131696, 'R');
INSERT INTO "invoices" VALUES (5759, '', 5, '', 280449, 'Z');
INSERT INTO "invoices" VALUES (5760, '', 1, '', 397164, 'A');
INSERT INTO "invoices" VALUES (5761, '', 2, '', 469730, 'A');
INSERT INTO "invoices" VALUES (5762, '', 1, '', 117920, 'A');
INSERT INTO "invoices" VALUES (5764, '', 2, '', 580984, 'A');
INSERT INTO "invoices" VALUES (5765, '', 4, '', 550297, 'Z');
INSERT INTO "invoices" VALUES (5766, '', 1, '', 109129, 'A');
INSERT INTO "invoices" VALUES (5766, '', 1, '', 114384, 'Z');
INSERT INTO "invoices" VALUES (5767, '', 1, '', 123088, 'H');
INSERT INTO "invoices" VALUES (5767, '', 1, '', 57799, 'E');
INSERT INTO "invoices" VALUES (5768, '', 4, '', 621000, 'A');
INSERT INTO "invoices" VALUES (5769, '', 3, '', 570286, 'A');
INSERT INTO "invoices" VALUES (5770, '', 1, '', 594590, 'A');
INSERT INTO "invoices" VALUES (5771, '', 2, '', 178405, 'E');
INSERT INTO "invoices" VALUES (5771, '', 2, '', 233308, 'H');
INSERT INTO "invoices" VALUES (5772, '', 1, '', 92885, 'Z');
INSERT INTO "invoices" VALUES (5773, '', 2, '', 186817, 'R');
INSERT INTO "invoices" VALUES (5773, '', 2, '', 243603, 'D');
INSERT INTO "invoices" VALUES (5774, '', 5, '', 7461, 'H');
INSERT INTO "invoices" VALUES (5774, '', 5, '', 645273, 'Z');
INSERT INTO "invoices" VALUES (5776, '', 1, '', 190760, 'A');
INSERT INTO "invoices" VALUES (5777, '', 1, '', 63472, 'E');
INSERT INTO "invoices" VALUES (5777, '', 1, '', 138634, 'A');
INSERT INTO "invoices" VALUES (5778, '', 1, '', 186452, 'Z');
INSERT INTO "invoices" VALUES (5779, '', 1, '', 89718, 'R');
INSERT INTO "invoices" VALUES (5780, '', 3, '', 346247, 'A');
INSERT INTO "invoices" VALUES (5781, '', 5, '', 20748, 'E');
INSERT INTO "invoices" VALUES (5781, '', 5, '', 122015, 'Z');
INSERT INTO "invoices" VALUES (5781, '', 5, '', 20749, 'R');
INSERT INTO "invoices" VALUES (5781, '', 5, '', 20749, 'D');
INSERT INTO "invoices" VALUES (5781, '', 5, '', 20748, 'H');
INSERT INTO "invoices" VALUES (5781, '', 5, '', 127232, 'A');
INSERT INTO "invoices" VALUES (5782, '', 4, '', 540999, 'Z');
INSERT INTO "invoices" VALUES (5783, '', 4, '', 479282, 'A');
INSERT INTO "invoices" VALUES (5784, '', 6, '', 422870, 'Z');
INSERT INTO "invoices" VALUES (5785, '', 3, '', 167057, 'D');
INSERT INTO "invoices" VALUES (5785, '', 3, '', 227551, 'R');
INSERT INTO "invoices" VALUES (5786, '', 5, '', 230989, 'E');
INSERT INTO "invoices" VALUES (5786, '', 5, '', 163367, 'H');
INSERT INTO "invoices" VALUES (5787, '', 1, '', 579259, 'A');
INSERT INTO "invoices" VALUES (5788, '', 6, '', 458912, 'A');
INSERT INTO "invoices" VALUES (5789, '', 1, '', 295918, 'A');
INSERT INTO "invoices" VALUES (5791, '', 1, '', 297075, 'A');
INSERT INTO "invoices" VALUES (5792, '', 1, '', 10236, 'A');
INSERT INTO "invoices" VALUES (5792, '', 1, '', 353917, 'H');
INSERT INTO "invoices" VALUES (5793, '', 3, '', 383463, 'E');
INSERT INTO "invoices" VALUES (5793, '', 3, '', 51489, 'A');
INSERT INTO "invoices" VALUES (5794, '', 1, '', 670576, 'A');
INSERT INTO "invoices" VALUES (5795, '', 1, '', 323155, 'D');
INSERT INTO "invoices" VALUES (5795, '', 1, '', 15250, 'R');
INSERT INTO "invoices" VALUES (5795, '', 1, '', 35, 'A');
INSERT INTO "invoices" VALUES (5796, '', 6, '', 609540, 'Z');
INSERT INTO "invoices" VALUES (5797, '', 2, '', 420050, 'A');
INSERT INTO "invoices" VALUES (5798, '', 2, '', 202883, 'Z');
INSERT INTO "invoices" VALUES (5799, '', 3, '', 322404, 'A');
INSERT INTO "invoices" VALUES (5800, '', 1, '', 110981, 'A');
INSERT INTO "invoices" VALUES (5801, '', 1, '', 192501, 'R');
INSERT INTO "invoices" VALUES (5802, '', 1, '', 98807, 'A');
INSERT INTO "invoices" VALUES (5803, '', 1, '', 115117, 'Z');
INSERT INTO "invoices" VALUES (5804, '', 1, '', 16251, 'A');
INSERT INTO "invoices" VALUES (5805, '', 3, '', 482041, 'A');
INSERT INTO "invoices" VALUES (5806, '', 1, '', 633149, 'A');
INSERT INTO "invoices" VALUES (5807, '', 3, '', 386281, 'R');
INSERT INTO "invoices" VALUES (5808, '', 5, '', 610377, 'Z');
INSERT INTO "invoices" VALUES (5809, '', 2, '', 673996, 'A');
INSERT INTO "invoices" VALUES (5810, '', 3, '', 349337, 'D');
INSERT INTO "invoices" VALUES (5811, '', 2, '', 372570, 'H');
INSERT INTO "invoices" VALUES (5812, '', 2, '', 454402, 'A');
INSERT INTO "invoices" VALUES (5813, '', 1, '', 382737, 'E');
INSERT INTO "invoices" VALUES (5814, '', 1, '', 255036, 'Z');
INSERT INTO "invoices" VALUES (5815, '', 2, '', 45893, 'A');
INSERT INTO "invoices" VALUES (5816, '', 1, '', 415830, 'A');
INSERT INTO "invoices" VALUES (5817, '', 1, '', 220792, 'Z');
INSERT INTO "invoices" VALUES (5818, '', 2, '', 142795, 'Z');
INSERT INTO "invoices" VALUES (5819, '', 1, '', 143409, 'A');
INSERT INTO "invoices" VALUES (5820, '', 5, '', 564679, 'A');
INSERT INTO "invoices" VALUES (5821, '', 2, '', 350272, 'R');
INSERT INTO "invoices" VALUES (5822, '', 2, '', 256809, 'H');
INSERT INTO "invoices" VALUES (5823, '', 1, '', 418084, 'A');
INSERT INTO "invoices" VALUES (5824, '', 1, '', 515385, 'Z');
INSERT INTO "invoices" VALUES (5825, '', 1, '', 312706, 'Z');
INSERT INTO "invoices" VALUES (5826, '', 1, '', 329497, 'A');
INSERT INTO "invoices" VALUES (5827, '', 1, '', 133397, 'E');
INSERT INTO "invoices" VALUES (5828, '', 1, '', 662950, 'A');
INSERT INTO "invoices" VALUES (5829, '', 2, '', 285671, 'A');
INSERT INTO "invoices" VALUES (5830, '', 2, '', 393392, 'A');
INSERT INTO "invoices" VALUES (5831, '', 4, '', 538699, 'Z');
INSERT INTO "invoices" VALUES (5832, '', 1, '', 354706, 'D');
INSERT INTO "invoices" VALUES (5832, '', 1, '', 102127, 'Z');
INSERT INTO "invoices" VALUES (5833, '', 1, '', 190659, 'A');
INSERT INTO "invoices" VALUES (5834, '', 1, '', 168527, 'A');
INSERT INTO "invoices" VALUES (5835, '', 1, '', 243016, 'Z');
INSERT INTO "invoices" VALUES (5836, '', 1, '', 238136, 'D');
INSERT INTO "invoices" VALUES (5837, '', 3, '', 408201, 'A');
INSERT INTO "invoices" VALUES (5838, '', 1, '', 413922, 'A');
INSERT INTO "invoices" VALUES (5839, '', 1, '', 308074, 'Z');
INSERT INTO "invoices" VALUES (5840, '', 2, '', 235925, 'R');
INSERT INTO "invoices" VALUES (5841, '', 2, '', 364441, 'A');
INSERT INTO "invoices" VALUES (5842, '', 1, '', 315634, 'E');
INSERT INTO "invoices" VALUES (5843, '', 4, '', 339926, 'Z');
INSERT INTO "invoices" VALUES (5844, '', 3, '', 225200, 'A');
INSERT INTO "invoices" VALUES (5844, '', 3, '', 95806, 'Z');
INSERT INTO "invoices" VALUES (5845, '', 4, '', 9738, 'R');
INSERT INTO "invoices" VALUES (5845, '', 4, '', 266649, 'H');
INSERT INTO "invoices" VALUES (5845, '', 4, '', 9738, 'D');
INSERT INTO "invoices" VALUES (5846, '', 1, '', 428485, 'A');
INSERT INTO "invoices" VALUES (5847, '', 1, '', 215192, 'A');
INSERT INTO "invoices" VALUES (5848, '', 1, '', 184994, 'A');
INSERT INTO "invoices" VALUES (5849, '', 4, '', 165842, 'A');
INSERT INTO "invoices" VALUES (5850, '', 3, '', 108139, 'H');
INSERT INTO "invoices" VALUES (5851, '', 2, '', 158049, 'Z');
INSERT INTO "invoices" VALUES (5852, '', 1, '', 116112, 'E');
INSERT INTO "invoices" VALUES (5853, '', 2, '', 108528, 'R');
INSERT INTO "invoices" VALUES (5854, '', 2, '', 105178, 'D');
INSERT INTO "invoices" VALUES (5855, '', 3, '', 329494, 'Z');
INSERT INTO "invoices" VALUES (5856, '', 1, '', 328550, 'A');
INSERT INTO "invoices" VALUES (5857, '', 2, '', 376120, 'A');
INSERT INTO "invoices" VALUES (5858, '', 1, '', 275812, 'A');
INSERT INTO "invoices" VALUES (5859, '', 2, '', 270810, 'A');
INSERT INTO "invoices" VALUES (5860, '', 1, '', 258040, 'Z');
INSERT INTO "invoices" VALUES (5861, '', 1, '', 175386, 'Z');
INSERT INTO "invoices" VALUES (5862, '', 2, '', 164445, 'A');
INSERT INTO "invoices" VALUES (5863, '', 2, '', 102391, 'E');
INSERT INTO "invoices" VALUES (5865, '', 1, '', 131368, 'R');
INSERT INTO "invoices" VALUES (5866, '', 1, '', 317734, 'A');
INSERT INTO "invoices" VALUES (5867, '', 1, '', 112502, 'H');
INSERT INTO "invoices" VALUES (5868, '', 2, '', 105948, 'A');
INSERT INTO "invoices" VALUES (5869, '', 4, '', 135152, 'E');
INSERT INTO "invoices" VALUES (5870, '', 5, '', 201270, 'Z');
INSERT INTO "invoices" VALUES (5871, '', 2, '', 141744, 'D');
INSERT INTO "invoices" VALUES (5872, '', 3, '', 10650, 'A');
INSERT INTO "invoices" VALUES (5873, '', 6, '', 484112, 'Z');
INSERT INTO "invoices" VALUES (5874, '', 4, '', 495689, 'A');
INSERT INTO "invoices" VALUES (5875, '', 1, '', 481477, 'A');
INSERT INTO "invoices" VALUES (5877, '', 1, '', 184201, 'Z');
INSERT INTO "invoices" VALUES (5878, '', 1, '', 332276, 'A');
INSERT INTO "invoices" VALUES (5879, '', 1, '', 154124, 'R');
INSERT INTO "invoices" VALUES (5880, '', 1, '', 79134, 'A');
INSERT INTO "invoices" VALUES (5880, '', 1, '', 210945, 'H');
INSERT INTO "invoices" VALUES (5881, '', 2, '', 180345, 'E');
INSERT INTO "invoices" VALUES (5882, '', 3, '', 156909, 'D');
INSERT INTO "invoices" VALUES (5884, '', 1, '', 21752, 'A');
INSERT INTO "invoices" VALUES (5885, '', 1, '', 506579, 'A');
INSERT INTO "invoices" VALUES (5886, '', 1, '', 765054, 'A');
INSERT INTO "invoices" VALUES (5887, '', 3, '', 441187, 'A');
INSERT INTO "invoices" VALUES (5888, '', 1, '', 203396, 'A');
INSERT INTO "invoices" VALUES (5889, '', 4, '', 277917, 'Z');
INSERT INTO "invoices" VALUES (5890, '', 4, '', 95953, 'D');
INSERT INTO "invoices" VALUES (5891, '', 2, '', 93759, 'R');
INSERT INTO "invoices" VALUES (5894, '', 3, '', 163907, 'Z');
INSERT INTO "invoices" VALUES (5895, '', 4, '', 201057, 'E');
INSERT INTO "invoices" VALUES (5896, '', 1, '', 172992, 'D');
INSERT INTO "invoices" VALUES (5897, '', 1, '', 145077, 'R');
INSERT INTO "invoices" VALUES (5898, '', 2, '', 201787, 'H');
INSERT INTO "invoices" VALUES (5899, '', 3, '', 243773, 'A');
INSERT INTO "invoices" VALUES (5900, '', 1, '', 858260, 'A');
INSERT INTO "invoices" VALUES (5901, '', 1, '', 608895, 'A');
INSERT INTO "invoices" VALUES (5902, '', 3, '', 548442, 'A');
INSERT INTO "invoices" VALUES (5903, '', 2, '', 875460, 'Z');
INSERT INTO "invoices" VALUES (5905, '', 2, '', 137743, 'R');
INSERT INTO "invoices" VALUES (5906, '', 1, '', 168128, 'E');
INSERT INTO "invoices" VALUES (5907, '', 2, '', 265672, 'A');
INSERT INTO "invoices" VALUES (5908, '', 4, '', 156532, 'R');
INSERT INTO "invoices" VALUES (5909, '', 1, '', 227894, 'Z');
INSERT INTO "invoices" VALUES (5910, '', 3, '', 137363, 'D');
INSERT INTO "invoices" VALUES (5911, '', 3, '', 562488, 'A');
INSERT INTO "invoices" VALUES (5912, '', 2, '', 3268, 'A');
INSERT INTO "invoices" VALUES (5912, '', 2, '', 157236, 'H');
INSERT INTO "invoices" VALUES (5913, '', 1, '', 190311, 'D');
INSERT INTO "invoices" VALUES (5914, '', 2, '', 154693, 'E');
INSERT INTO "invoices" VALUES (5915, '', 2, '', 143098, 'R');
INSERT INTO "invoices" VALUES (5916, '', 1, '', 174323, 'H');
INSERT INTO "invoices" VALUES (5917, '', 1, '', 419145, 'A');
INSERT INTO "invoices" VALUES (5918, '', 3, '', 492822, 'Z');
INSERT INTO "invoices" VALUES (5919, '', 3, '', 315560, 'A');
INSERT INTO "invoices" VALUES (5920, '', 3, '', 276077, 'A');
INSERT INTO "invoices" VALUES (5921, '', 3, '', 52014, 'A');
INSERT INTO "invoices" VALUES (5922, '', 4, '', 380814, 'A');
INSERT INTO "invoices" VALUES (5923, '', 1, '', 240279, 'R');
INSERT INTO "invoices" VALUES (5924, '', 1, '', 230773, 'H');
INSERT INTO "invoices" VALUES (5925, '', 1, '', 303309, 'Z');
INSERT INTO "invoices" VALUES (5926, '', 2, '', 242049, 'D');
INSERT INTO "invoices" VALUES (5927, '', 1, '', 193654, 'E');
INSERT INTO "invoices" VALUES (5928, '', 2, '', 168700, 'Z');
INSERT INTO "invoices" VALUES (5929, '', 2, '', 299113, 'A');
INSERT INTO "invoices" VALUES (5930, '', 1, '', 155757, 'A');
INSERT INTO "invoices" VALUES (5931, '', 1, '', 177977, 'H');
INSERT INTO "invoices" VALUES (5932, '', 1, '', 243002, 'A');
INSERT INTO "invoices" VALUES (5933, '', 3, '', 159318, 'Z');
INSERT INTO "invoices" VALUES (5934, '', 2, '', 3229, 'A');
INSERT INTO "invoices" VALUES (5934, '', 2, '', 337508, 'H');
INSERT INTO "invoices" VALUES (5935, '', 1, '', 549047, 'A');
INSERT INTO "invoices" VALUES (5936, '', 1, '', 3226, 'A');
INSERT INTO "invoices" VALUES (5936, '', 1, '', 384864, 'D');
INSERT INTO "invoices" VALUES (5937, '', 1, '', 3226, 'A');
INSERT INTO "invoices" VALUES (5937, '', 1, '', 377457, 'E');
INSERT INTO "invoices" VALUES (5938, '', 1, '', 375435, 'Z');
INSERT INTO "invoices" VALUES (5939, '', 1, '', 363799, 'R');
INSERT INTO "invoices" VALUES (5939, '', 1, '', 3226, 'A');
INSERT INTO "invoices" VALUES (5940, '', 3, '', 548580, 'Z');
INSERT INTO "invoices" VALUES (5941, '', 1, '', 548102, 'A');
INSERT INTO "invoices" VALUES (5942, '', 2, '', 5301, 'E');
INSERT INTO "invoices" VALUES (5942, '', 2, '', 269317, 'A');
INSERT INTO "invoices" VALUES (5943, '', 2, '', 2217, 'D');
INSERT INTO "invoices" VALUES (5943, '', 2, '', 2217, 'R');
INSERT INTO "invoices" VALUES (5943, '', 2, '', 249027, 'Z');
INSERT INTO "invoices" VALUES (5944, '', 2, '', 259871, 'A');
INSERT INTO "invoices" VALUES (5945, '', 3, '', 229509, 'Z');
INSERT INTO "invoices" VALUES (5945, '', 3, '', 2217, 'H');
INSERT INTO "invoices" VALUES (5945, '', 3, '', 2217, 'E');
INSERT INTO "invoices" VALUES (5946, '', 1, '', 259871, 'A');
INSERT INTO "invoices" VALUES (5947, '', 1, '', 205086, 'Z');
INSERT INTO "invoices" VALUES (5948, '', 1, '', 201671, 'A');
INSERT INTO "invoices" VALUES (5949, '', 1, '', 76009, 'A');
INSERT INTO "invoices" VALUES (5950, '', 2, '', 222581, 'D');
INSERT INTO "invoices" VALUES (5951, '', 1, '', 243038, 'R');
INSERT INTO "invoices" VALUES (5952, '', 4, '', 353072, 'Z');
INSERT INTO "invoices" VALUES (5953, '', 1, '', 500152, 'A');
INSERT INTO "invoices" VALUES (5954, '', 3, '', 230459, 'H');
INSERT INTO "invoices" VALUES (5955, '', 1, '', 269436, 'A');
INSERT INTO "invoices" VALUES (5956, '', 2, '', 501660, 'Z');
INSERT INTO "invoices" VALUES (5957, '', 2, '', 436072, 'A');
INSERT INTO "invoices" VALUES (5958, '', 1, '', 230443, 'E');
INSERT INTO "invoices" VALUES (5959, '', 2, '', 438592, 'A');
INSERT INTO "invoices" VALUES (5960, '', 1, '', 30718, 'Z');
INSERT INTO "invoices" VALUES (5962, '', 5, '', 383564, 'Z');
INSERT INTO "invoices" VALUES (5963, '', 1, '', 206524, 'H');
INSERT INTO "invoices" VALUES (5964, '', 2, '', 209662, 'D');
INSERT INTO "invoices" VALUES (5965, '', 1, '', 218010, 'R');
INSERT INTO "invoices" VALUES (5966, '', 1, '', 332299, 'Z');
INSERT INTO "invoices" VALUES (5967, '', 1, '', 482372, 'A');
INSERT INTO "invoices" VALUES (5968, '', 2, '', 460014, 'A');
INSERT INTO "invoices" VALUES (5969, '', 2, '', 303502, 'A');
INSERT INTO "invoices" VALUES (5970, '', 3, '', 331830, 'A');
INSERT INTO "invoices" VALUES (5971, '', 1, '', 315194, 'Z');
INSERT INTO "invoices" VALUES (5972, '', 2, '', 354119, 'A');
INSERT INTO "invoices" VALUES (5973, '', 2, '', 229601, 'E');
INSERT INTO "invoices" VALUES (5974, '', 1, '', 385591, 'A');
INSERT INTO "invoices" VALUES (5975, '', 4, '', 372692, 'A');
INSERT INTO "invoices" VALUES (5976, '', 1, '', 215917, 'Z');
INSERT INTO "invoices" VALUES (5977, '', 4, '', 280205, 'Z');
INSERT INTO "invoices" VALUES (5978, '', 2, '', 190552, 'A');
INSERT INTO "invoices" VALUES (5979, '', 3, '', 119443, 'Z');
INSERT INTO "invoices" VALUES (5980, '', 1, '', 31429, 'A');
INSERT INTO "invoices" VALUES (5981, '', 1, '', 273623, 'D');
INSERT INTO "invoices" VALUES (5982, '', 1, '', 369301, 'Z');
INSERT INTO "invoices" VALUES (5983, '', 1, '', 399848, 'Z');
INSERT INTO "invoices" VALUES (5984, '', 1, '', 492095, 'A');
INSERT INTO "invoices" VALUES (5985, '', 2, '', 280528, 'R');
INSERT INTO "invoices" VALUES (5986, '', 2, '', 458616, 'A');
INSERT INTO "invoices" VALUES (5987, '', 1, '', 243578, 'H');
INSERT INTO "invoices" VALUES (5987, 'A', 2, '', 238106, 'E');
INSERT INTO "invoices" VALUES (5988, '', 4, '', 541235, 'A');
INSERT INTO "invoices" VALUES (5989, '', 2, '', 191002, 'E');
INSERT INTO "invoices" VALUES (5991, '', 3, '', 204227, 'A');
INSERT INTO "invoices" VALUES (5992, '', 2, '', 272746, 'Z');
INSERT INTO "invoices" VALUES (5993, '', 2, '', 349733, 'A');
INSERT INTO "invoices" VALUES (5994, '', 2, '', 303309, 'Z');
INSERT INTO "invoices" VALUES (5995, '', 1, '', 103993, 'Z');
INSERT INTO "invoices" VALUES (5996, '', 3, '', 197903, 'A');
INSERT INTO "invoices" VALUES (5997, '', 1, '', 102479, 'A');
INSERT INTO "invoices" VALUES (5998, '', 3, '', 246416, 'A');
INSERT INTO "invoices" VALUES (5999, '', 1, '', 99024, 'Z');
INSERT INTO "invoices" VALUES (6000, '', 2, '', 296996, 'A');
INSERT INTO "invoices" VALUES (6001, '', 2, '', 244762, 'E');
INSERT INTO "invoices" VALUES (6001, '', 2, '', 18360, 'A');
INSERT INTO "invoices" VALUES (6002, '', 2, '', 232112, 'H');
INSERT INTO "invoices" VALUES (6002, '', 2, '', 18360, 'A');
INSERT INTO "invoices" VALUES (6003, '', 2, '', 420963, 'A');
INSERT INTO "invoices" VALUES (6004, '', 2, '', 8160, 'Z');
INSERT INTO "invoices" VALUES (6004, '', 2, '', 9180, 'A');
INSERT INTO "invoices" VALUES (6004, '', 2, '', 269894, 'D');
INSERT INTO "invoices" VALUES (6005, '', 1, '', 395157, 'A');
INSERT INTO "invoices" VALUES (6006, '', 2, '', 290168, 'Z');
INSERT INTO "invoices" VALUES (6007, '', 3, '', 283712, 'R');
INSERT INTO "invoices" VALUES (6007, '', 3, '', 9180, 'A');
INSERT INTO "invoices" VALUES (6007, '', 3, '', 8160, 'Z');
INSERT INTO "invoices" VALUES (6008, '', 3, '', 316514, 'Z');
INSERT INTO "invoices" VALUES (6009, '', 2, '', 152844, 'E');
INSERT INTO "invoices" VALUES (6010, '', 1, '', 197570, 'A');
INSERT INTO "invoices" VALUES (6011, '', 1, '', 494440, 'A');
INSERT INTO "invoices" VALUES (6012, '', 4, '', 244682, 'Z');
INSERT INTO "invoices" VALUES (6013, '', 3, '', 399298, 'Z');
INSERT INTO "invoices" VALUES (6014, '', 4, '', 308921, 'A');
INSERT INTO "invoices" VALUES (6015, '', 4, '', 517253, 'A');
INSERT INTO "invoices" VALUES (6016, '', 1, '', 118435, 'A');
INSERT INTO "invoices" VALUES (6018, '', 1, '', 297691, 'Z');
INSERT INTO "invoices" VALUES (6019, '', 3, '', 275683, 'Z');
INSERT INTO "invoices" VALUES (6020, '', 2, '', 230599, 'A');
INSERT INTO "invoices" VALUES (6021, '', 3, '', 158162, 'R');
INSERT INTO "invoices" VALUES (6021, '', 3, '', 14688, 'A');
INSERT INTO "invoices" VALUES (6022, '', 3, '', 302626, 'A');
INSERT INTO "invoices" VALUES (6023, '', 4, '', 177499, 'D');
INSERT INTO "invoices" VALUES (6023, '', 4, '', 14688, 'A');
INSERT INTO "invoices" VALUES (6024, '', 5, '', 444059, 'A');
INSERT INTO "invoices" VALUES (6025, '', 4, '', 14688, 'A');
INSERT INTO "invoices" VALUES (6025, '', 4, '', 172194, 'H');
INSERT INTO "invoices" VALUES (6026, '', 3, '', 439825, 'A');
INSERT INTO "invoices" VALUES (6027, '', 2, '', 208331, 'E');
INSERT INTO "invoices" VALUES (6027, '', 2, '', 14688, 'A');
INSERT INTO "invoices" VALUES (6028, '', 2, '', 510028, 'Z');
INSERT INTO "invoices" VALUES (6029, '', 3, '', 454720, 'A');
INSERT INTO "invoices" VALUES (6030, '', 2, '', 346652, 'A');
INSERT INTO "invoices" VALUES (6031, '', 2, '', 337913, 'A');
INSERT INTO "invoices" VALUES (6032, '', 1, '', 198329, 'A');
INSERT INTO "invoices" VALUES (6032, '', 1, '', 5686, 'E');
INSERT INTO "invoices" VALUES (6032, '', 1, '', 3641, 'H');
INSERT INTO "invoices" VALUES (6033, '', 2, '', 121384, 'R');
INSERT INTO "invoices" VALUES (6033, '', 2, '', 155424, 'D');
INSERT INTO "invoices" VALUES (6034, '', 3, '', 233251, 'H');
INSERT INTO "invoices" VALUES (6035, '', 2, '', 2483, 'A');
INSERT INTO "invoices" VALUES (6035, '', 2, '', 2686, 'D');
INSERT INTO "invoices" VALUES (6035, '', 2, '', 5823, 'R');
INSERT INTO "invoices" VALUES (6035, '', 2, '', 155297, 'Z');
INSERT INTO "invoices" VALUES (6037, '', 3, '', 528396, 'A');
INSERT INTO "invoices" VALUES (6038, '', 3, '', 545998, 'Z');
INSERT INTO "invoices" VALUES (6039, '', 1, '', 320669, 'E');
INSERT INTO "invoices" VALUES (6040, '', 1, '', 158721, 'A');
INSERT INTO "invoices" VALUES (6041, '', 2, '', 319666, 'Z');
INSERT INTO "invoices" VALUES (6042, '', 2, '', 305820, 'R');
INSERT INTO "invoices" VALUES (6043, '', 1, '', 153126, 'Z');
INSERT INTO "invoices" VALUES (6044, '', 1, '', 439974, 'A');
INSERT INTO "invoices" VALUES (6045, '', 3, '', 310440, 'H');
INSERT INTO "invoices" VALUES (6046, '', 2, '', 444110, 'A');
INSERT INTO "invoices" VALUES (6047, '', 1, '', 290520, 'D');
INSERT INTO "invoices" VALUES (6048, '', 3, '', 350103, 'A');
INSERT INTO "invoices" VALUES (6050, '', 2, '', 324569, 'Z');
INSERT INTO "invoices" VALUES (6051, '', 1, '', 339206, 'A');
INSERT INTO "invoices" VALUES (6052, '', 3, '', 333965, 'A');
INSERT INTO "invoices" VALUES (6053, '', 3, '', 405021, 'A');
INSERT INTO "invoices" VALUES (6054, '', 2, '', 736, 'Z');
INSERT INTO "invoices" VALUES (6054, '', 2, '', 104924, 'R');
INSERT INTO "invoices" VALUES (6054, '', 2, '', 123636, 'D');
INSERT INTO "invoices" VALUES (6055, '', 1, '', 1491, 'A');
INSERT INTO "invoices" VALUES (6055, '', 1, '', 87049, 'H');
INSERT INTO "invoices" VALUES (6055, '', 1, '', 93679, 'E');
INSERT INTO "invoices" VALUES (6056, '', 1, '', 4271, 'D');
INSERT INTO "invoices" VALUES (6056, '', 1, '', 4922, 'R');
INSERT INTO "invoices" VALUES (6056, '', 1, '', 8531, 'H');
INSERT INTO "invoices" VALUES (6056, '', 1, '', 8800, 'E');
INSERT INTO "invoices" VALUES (6056, '', 1, '', 197120, 'A');
INSERT INTO "invoices" VALUES (6057, '', 1, '', 88250, 'Z');
INSERT INTO "invoices" VALUES (6058, '', 4, '', 322882, 'R');
INSERT INTO "invoices" VALUES (6059, '', 3, '', 420081, 'E');
INSERT INTO "invoices" VALUES (6060, '', 4, '', 332869, 'A');
INSERT INTO "invoices" VALUES (6061, '', 3, '', 4906, 'R');
INSERT INTO "invoices" VALUES (6061, '', 3, '', 366223, 'Z');
INSERT INTO "invoices" VALUES (6062, '', 3, '', 386850, 'Z');
INSERT INTO "invoices" VALUES (6063, '', 1, '', 307620, 'H');
INSERT INTO "invoices" VALUES (6064, '', 4, '', 360107, 'A');
INSERT INTO "invoices" VALUES (6065, '', 3, '', 328335, 'A');
INSERT INTO "invoices" VALUES (6066, '', 1, '', 532466, 'A');
INSERT INTO "invoices" VALUES (6067, '', 5, '', 419407, 'D');
INSERT INTO "invoices" VALUES (6067, '', 5, '', 2307, 'R');
INSERT INTO "invoices" VALUES (6068, '', 2, '', 295213, 'Z');
INSERT INTO "invoices" VALUES (6069, '', 5, '', 174190, 'A');
INSERT INTO "invoices" VALUES (6070, '', 2, '', 135084, 'Z');
INSERT INTO "invoices" VALUES (6071, '', 5, '', 259581, 'A');
INSERT INTO "invoices" VALUES (6072, '', 2, '', 394801, 'A');
INSERT INTO "invoices" VALUES (6073, '', 3, '', 363445, 'A');
INSERT INTO "invoices" VALUES (6074, '', 1, '', 248789, 'H');
INSERT INTO "invoices" VALUES (6075, '', 2, '', 1989, 'R');
INSERT INTO "invoices" VALUES (6075, '', 2, '', 375463, 'Z');
INSERT INTO "invoices" VALUES (6076, '', 1, '', 293664, 'A');
INSERT INTO "invoices" VALUES (6077, '', 1, '', 215727, 'Z');
INSERT INTO "invoices" VALUES (6078, '', 2, '', 1653, 'H');
INSERT INTO "invoices" VALUES (6078, '', 2, '', 4983, 'E');
INSERT INTO "invoices" VALUES (6078, '', 2, '', 5203, 'R');
INSERT INTO "invoices" VALUES (6078, '', 2, '', 5363, 'D');
INSERT INTO "invoices" VALUES (6078, '', 2, '', 175767, 'A');
INSERT INTO "invoices" VALUES (6079, '', 3, '', 380207, 'Z');
INSERT INTO "invoices" VALUES (6080, '', 4, '', 344345, 'E');
INSERT INTO "invoices" VALUES (6081, '', 3, '', 404954, 'R');
INSERT INTO "invoices" VALUES (6082, '', 2, '', 597438, 'A');
INSERT INTO "invoices" VALUES (6083, '', 4, '', 402625, 'A');
INSERT INTO "invoices" VALUES (6084, '', 2, '', 292170, 'H');
INSERT INTO "invoices" VALUES (6085, '', 4, '', 607176, 'Z');
INSERT INTO "invoices" VALUES (6086, '', 4, '', 355093, 'D');
INSERT INTO "invoices" VALUES (6087, '', 4, '', 412996, 'A');
INSERT INTO "invoices" VALUES (6088, '', 4, '', 353907, 'A');
INSERT INTO "invoices" VALUES (6089, '', 6, '', 577716, 'A');
INSERT INTO "invoices" VALUES (6090, '', 2, '', 162642, 'Z');
INSERT INTO "invoices" VALUES (6091, '', 2, '', 359144, 'A');
INSERT INTO "invoices" VALUES (6092, '', 3, '', 242348, 'Z');
INSERT INTO "invoices" VALUES (6093, '', 2, '', 192670, 'A');
INSERT INTO "invoices" VALUES (6094, '', 1, '', 23553, 'A');
INSERT INTO "invoices" VALUES (6094, '', 1, '', 127193, 'H');
INSERT INTO "invoices" VALUES (6095, '', 3, '', 129397, 'E');
INSERT INTO "invoices" VALUES (6095, '', 3, '', 42503, 'A');
INSERT INTO "invoices" VALUES (6096, '', 1, '', 137176, 'R');
INSERT INTO "invoices" VALUES (6096, '', 1, '', 22048, 'Z');
INSERT INTO "invoices" VALUES (6096, '', 1, '', 10217, 'D');
INSERT INTO "invoices" VALUES (6097, '', 1, '', 199840, 'Z');
INSERT INTO "invoices" VALUES (6098, '', 3, '', 280841, 'D');
INSERT INTO "invoices" VALUES (6099, '', 2, '', 205670, 'A');
INSERT INTO "invoices" VALUES (6100, '', 2, '', 198787, 'E');
INSERT INTO "invoices" VALUES (6101, '', 3, '', 309623, 'A');
INSERT INTO "invoices" VALUES (6102, '', 4, '', 294885, 'Z');
INSERT INTO "invoices" VALUES (6103, '', 3, '', 395389, 'A');
INSERT INTO "invoices" VALUES (6104, '', 1, '', 302131, 'Z');
INSERT INTO "invoices" VALUES (6105, '', 2, '', 411469, 'A');
INSERT INTO "invoices" VALUES (6106, '', 4, '', 314187, 'R');
INSERT INTO "invoices" VALUES (6107, '', 2, '', 242131, 'Z');
INSERT INTO "invoices" VALUES (6108, '', 5, '', 208029, 'A');
INSERT INTO "invoices" VALUES (6109, '', 1, '', 181051, 'Z');
INSERT INTO "invoices" VALUES (6110, '', 1, '', 196017, 'A');
INSERT INTO "invoices" VALUES (6111, '', 3, '', 327086, 'A');
INSERT INTO "invoices" VALUES (6112, '', 2, '', 231219, 'H');
INSERT INTO "invoices" VALUES (6113, '', 5, '', 174745, 'Z');
INSERT INTO "invoices" VALUES (6114, '', 4, '', 802, 'R');
INSERT INTO "invoices" VALUES (6114, '', 4, '', 805, 'D');
INSERT INTO "invoices" VALUES (6114, '', 4, '', 237135, 'A');
INSERT INTO "invoices" VALUES (6115, '', 3, '', 94089, 'E');
INSERT INTO "invoices" VALUES (6115, '', 3, '', 202534, 'H');
INSERT INTO "invoices" VALUES (6116, '', 2, '', 240785, 'A');
INSERT INTO "invoices" VALUES (6117, '', 2, '', 72540, 'Z');
INSERT INTO "invoices" VALUES (6117, '', 2, '', 60374, 'A');
INSERT INTO "invoices" VALUES (6118, '', 3, '', 230083, 'Z');
INSERT INTO "invoices" VALUES (6119, '', 4, '', 237620, 'Z');
INSERT INTO "invoices" VALUES (6120, '', 3, '', 178091, 'Z');
INSERT INTO "invoices" VALUES (6121, '', 3, '', 250786, 'A');
INSERT INTO "invoices" VALUES (6122, '', 2, '', 170889, 'H');
INSERT INTO "invoices" VALUES (6123, '', 1, '', 349050, 'A');
INSERT INTO "invoices" VALUES (6123, '', 1, '', 48396, 'H');
INSERT INTO "invoices" VALUES (6124, '', 1, '', 32033, 'E');
INSERT INTO "invoices" VALUES (6124, '', 1, '', 361453, 'A');
INSERT INTO "invoices" VALUES (6125, '', 4, '', 35625, 'Z');
INSERT INTO "invoices" VALUES (6125, '', 4, '', 261073, 'D');
INSERT INTO "invoices" VALUES (6126, '', 1, '', 229310, 'R');
INSERT INTO "invoices" VALUES (6126, '', 1, '', 119681, 'Z');
INSERT INTO "invoices" VALUES (6127, '', 4, '', 288745, 'A');
INSERT INTO "invoices" VALUES (6128, '', 3, '', 252296, 'Z');
INSERT INTO "invoices" VALUES (6129, '', 1, '', 273216, 'A');
INSERT INTO "invoices" VALUES (6130, '', 4, '', 265711, 'Z');
INSERT INTO "invoices" VALUES (6131, '', 2, '', 270101, 'A');
INSERT INTO "invoices" VALUES (6132, '', 1, '', 256747, 'A');
INSERT INTO "invoices" VALUES (6133, '', 5, '', 352551, 'A');
INSERT INTO "invoices" VALUES (6134, '', 1, '', 72612, 'A');
INSERT INTO "invoices" VALUES (6134, '', 1, '', 15716, 'Z');
INSERT INTO "invoices" VALUES (6134, '', 1, '', 6985, 'H');
INSERT INTO "invoices" VALUES (6134, '', 1, '', 6789, 'R');
INSERT INTO "invoices" VALUES (6134, '', 1, '', 6666, 'D');
INSERT INTO "invoices" VALUES (6134, '', 1, '', 7287, 'E');
INSERT INTO "invoices" VALUES (6135, '', 1, '', 7984, 'Z');
INSERT INTO "invoices" VALUES (6135, '', 1, '', 15896, 'A');
INSERT INTO "invoices" VALUES (6136, '', 4, '', 230825, 'R');
INSERT INTO "invoices" VALUES (6137, '', 2, '', 194845, 'H');
INSERT INTO "invoices" VALUES (6138, '', 3, '', 203517, 'D');
INSERT INTO "invoices" VALUES (6139, '', 2, '', 305952, 'Z');
INSERT INTO "invoices" VALUES (6140, '', 1, '', 382204, 'Z');
INSERT INTO "invoices" VALUES (6141, '', 1, '', 307539, 'A');
INSERT INTO "invoices" VALUES (6142, '', 5, '', 307859, 'A');
INSERT INTO "invoices" VALUES (6143, '', 4, '', 407957, 'A');
INSERT INTO "invoices" VALUES (6144, '', 3, '', 421000, 'A');
INSERT INTO "invoices" VALUES (6145, '', 1, '', 424128, 'A');
INSERT INTO "invoices" VALUES (6146, '', 1, '', 391336, 'A');
INSERT INTO "invoices" VALUES (6147, '', 4, '', 348456, 'Z');
INSERT INTO "invoices" VALUES (6148, '', 2, '', 202121, 'E');
INSERT INTO "invoices" VALUES (6149, '', 2, '', 689, 'E');
INSERT INTO "invoices" VALUES (6149, '', 2, '', 193684, 'H');
INSERT INTO "invoices" VALUES (6150, '', 4, '', 886, 'Z');
INSERT INTO "invoices" VALUES (6150, '', 4, '', 230712, 'D');
INSERT INTO "invoices" VALUES (6150, '', 4, '', 677, 'R');
INSERT INTO "invoices" VALUES (6151, '', 3, '', 23877, 'Z');
INSERT INTO "invoices" VALUES (6151, '', 3, '', 5784, 'R');
INSERT INTO "invoices" VALUES (6151, '', 3, '', 5763, 'E');
INSERT INTO "invoices" VALUES (6151, '', 3, '', 120432, 'A');
INSERT INTO "invoices" VALUES (6152, '', 1, '', 6671, 'A');
INSERT INTO "invoices" VALUES (6153, '', 2, '', 255260, 'H');
INSERT INTO "invoices" VALUES (6154, '', 1, '', 354061, 'Z');
INSERT INTO "invoices" VALUES (6155, '', 5, '', 269994, 'R');
INSERT INTO "invoices" VALUES (6156, '', 4, '', 281752, 'E');
INSERT INTO "invoices" VALUES (6157, '', 3, '', 501162, 'A');
INSERT INTO "invoices" VALUES (6158, '', 1, '', 222792, 'D');
INSERT INTO "invoices" VALUES (6159, '', 2, '', 355282, 'A');
INSERT INTO "invoices" VALUES (6160, '', 1, '', 221789, 'A');
INSERT INTO "invoices" VALUES (6161, '', 1, '', 422831, 'A');
INSERT INTO "invoices" VALUES (6162, '', 1, '', 419931, 'A');
INSERT INTO "invoices" VALUES (6163, '', 1, '', 372686, 'Z');
INSERT INTO "invoices" VALUES (6164, '', 2, '', 197567, 'Z');
INSERT INTO "invoices" VALUES (6165, '', 1, '', 601, 'H');
INSERT INTO "invoices" VALUES (6165, '', 1, '', 755, 'A');
INSERT INTO "invoices" VALUES (6165, '', 1, '', 102311, 'E');
INSERT INTO "invoices" VALUES (6166, '', 1, '', 601, 'D');
INSERT INTO "invoices" VALUES (6166, '', 1, '', 601, 'Z');
INSERT INTO "invoices" VALUES (6166, '', 1, '', 108245, 'R');
INSERT INTO "invoices" VALUES (6167, '', 1, '', 5588, 'D');
INSERT INTO "invoices" VALUES (6167, '', 1, '', 5648, 'H');
INSERT INTO "invoices" VALUES (6167, '', 1, '', 41835, 'A');
INSERT INTO "invoices" VALUES (6167, '', 1, '', 108929, 'Z');
INSERT INTO "invoices" VALUES (6168, '', 5, '', 274790, 'D');
INSERT INTO "invoices" VALUES (6169, '', 2, '', 219527, 'A');
INSERT INTO "invoices" VALUES (6170, '', 3, '', 234829, 'H');
INSERT INTO "invoices" VALUES (6171, '', 1, '', 477485, 'A');
INSERT INTO "invoices" VALUES (6172, '', 2, '', 251690, 'Z');
INSERT INTO "invoices" VALUES (6173, '', 1, '', 370670, 'A');
INSERT INTO "invoices" VALUES (6174, '', 5, '', 422648, 'Z');
INSERT INTO "invoices" VALUES (6175, '', 5, '', 273316, 'R');
INSERT INTO "invoices" VALUES (6176, '', 1, '', 200304, 'E');
INSERT INTO "invoices" VALUES (6177, '', 4, '', 189866, 'A');
INSERT INTO "invoices" VALUES (6178, '', 1, '', 4872, 'A');
INSERT INTO "invoices" VALUES (6178, '', 1, '', 230997, 'Z');
INSERT INTO "invoices" VALUES (6179, '', 2, '', 372754, 'Z');
INSERT INTO "invoices" VALUES (6179, '', 2, '', 4872, 'A');
INSERT INTO "invoices" VALUES (6180, '', 6, '', 422021, 'A');
INSERT INTO "invoices" VALUES (6181, '', 3, '', 273729, 'A');
INSERT INTO "invoices" VALUES (6182, '', 2, '', 275173, 'A');
INSERT INTO "invoices" VALUES (6183, '', 3, '', 594, 'D');
INSERT INTO "invoices" VALUES (6183, '', 3, '', 594, 'Z');
INSERT INTO "invoices" VALUES (6183, '', 3, '', 300302, 'A');
INSERT INTO "invoices" VALUES (6183, '', 3, '', 594, 'R');
INSERT INTO "invoices" VALUES (6184, '', 1, '', 594, 'H');
INSERT INTO "invoices" VALUES (6184, '', 1, '', 205107, 'E');
INSERT INTO "invoices" VALUES (6185, '', 1, '', 43313, 'A');
INSERT INTO "invoices" VALUES (6185, '', 1, '', 9158, 'D');
INSERT INTO "invoices" VALUES (6185, '', 1, '', 10063, 'H');
INSERT INTO "invoices" VALUES (6185, '', 1, '', 29333, 'Z');
INSERT INTO "invoices" VALUES (6185, '', 1, '', 120534, 'R');
INSERT INTO "invoices" VALUES (6187, '', 1, '', 242042, 'H');
INSERT INTO "invoices" VALUES (6188, '', 1, '', 341983, 'A');
INSERT INTO "invoices" VALUES (6189, '', 1, '', 431605, 'Z');
INSERT INTO "invoices" VALUES (6190, '', 1, '', 361092, 'A');
INSERT INTO "invoices" VALUES (6191, '', 4, '', 284954, 'A');
INSERT INTO "invoices" VALUES (6192, '', 2, '', 229486, 'R');
INSERT INTO "invoices" VALUES (6193, '', 1, '', 297282, 'D');
INSERT INTO "invoices" VALUES (6194, '', 3, '', 228491, 'E');
INSERT INTO "invoices" VALUES (6195, '', 3, '', 311008, 'Z');
INSERT INTO "invoices" VALUES (6196, '', 1, '', 78069, 'Z');
INSERT INTO "invoices" VALUES (6196, '', 1, '', 278620, 'A');
INSERT INTO "invoices" VALUES (6197, '', 1, '', 5530, 'A');
INSERT INTO "invoices" VALUES (6197, '', 1, '', 185516, 'Z');
INSERT INTO "invoices" VALUES (6198, '', 1, '', 269748, 'A');
INSERT INTO "invoices" VALUES (6199, '', 5, '', 17296, 'A');
INSERT INTO "invoices" VALUES (6199, '', 5, '', 381860, 'Z');
INSERT INTO "invoices" VALUES (6200, '', 4, '', 550962, 'A');
INSERT INTO "invoices" VALUES (6201, '', 2, '', 339782, 'A');
INSERT INTO "invoices" VALUES (6202, '', 1, '', 595, 'R');
INSERT INTO "invoices" VALUES (6202, '', 1, '', 595, 'D');
INSERT INTO "invoices" VALUES (6202, '', 1, '', 233051, 'Z');
INSERT INTO "invoices" VALUES (6203, '', 1, '', 595, 'E');
INSERT INTO "invoices" VALUES (6203, '', 1, '', 748, 'A');
INSERT INTO "invoices" VALUES (6203, '', 1, '', 165517, 'H');
INSERT INTO "invoices" VALUES (6204, '', 2, '', 6731, 'E');
INSERT INTO "invoices" VALUES (6204, '', 2, '', 7085, 'H');
INSERT INTO "invoices" VALUES (6204, '', 2, '', 7246, 'R');
INSERT INTO "invoices" VALUES (6204, '', 2, '', 7646, 'D');
INSERT INTO "invoices" VALUES (6204, '', 2, '', 29811, 'Z');
INSERT INTO "invoices" VALUES (6204, '', 2, '', 182530, 'A');
INSERT INTO "invoices" VALUES (6209, '', 1, '', 190757, 'E');
INSERT INTO "invoices" VALUES (6210, '', 6, '', 232554, 'R');
INSERT INTO "invoices" VALUES (6211, '', 3, '', 219146, 'D');
INSERT INTO "invoices" VALUES (6212, '', 4, '', 378745, 'A');
INSERT INTO "invoices" VALUES (6213, '', 2, '', 26763, 'A');
INSERT INTO "invoices" VALUES (6214, '', 1, '', 304826, 'Z');
INSERT INTO "invoices" VALUES (6215, '', 1, '', 400499, 'A');
INSERT INTO "invoices" VALUES (6216, '', 2, '', 335299, 'Z');
INSERT INTO "invoices" VALUES (6217, '', 6, '', 265177, 'A');
INSERT INTO "invoices" VALUES (6218, '', 1, '', 325230, 'A');
INSERT INTO "invoices" VALUES (6219, '', 5, '', 295685, 'H');
INSERT INTO "invoices" VALUES (6220, '', 2, '', 271876, 'Z');
INSERT INTO "invoices" VALUES (6221, '', 3, '', 285296, 'A');
INSERT INTO "invoices" VALUES (6222, '', 1, '', 248984, 'A');
INSERT INTO "invoices" VALUES (6223, '', 5, '', 336505, 'A');
INSERT INTO "invoices" VALUES (6224, '', 2, '', 215959, 'A');
INSERT INTO "invoices" VALUES (6224, '', 2, '', 107955, 'Z');
INSERT INTO "invoices" VALUES (6225, '', 2, '', 334937, 'Z');
INSERT INTO "invoices" VALUES (6226, '', 2, '', 328852, 'A');
INSERT INTO "invoices" VALUES (6227, '', 3, '', 375, 'R');
INSERT INTO "invoices" VALUES (6227, '', 3, '', 375, 'D');
INSERT INTO "invoices" VALUES (6227, '', 3, '', 375, 'Z');
INSERT INTO "invoices" VALUES (6227, '', 3, '', 236787, 'A');
INSERT INTO "invoices" VALUES (6228, '', 1, '', 375, 'H');
INSERT INTO "invoices" VALUES (6228, '', 1, '', 197945, 'E');
INSERT INTO "invoices" VALUES (6229, '', 1, '', 5688, 'E');
INSERT INTO "invoices" VALUES (6229, '', 1, '', 5550, 'H');
INSERT INTO "invoices" VALUES (6229, '', 1, '', 5610, 'R');
INSERT INTO "invoices" VALUES (6229, '', 1, '', 5561, 'D');
INSERT INTO "invoices" VALUES (6229, '', 1, '', 24196, 'Z');
INSERT INTO "invoices" VALUES (6229, '', 1, '', 145114, 'A');
INSERT INTO "invoices" VALUES (6230, '', 1, '', 6552, 'E');
INSERT INTO "invoices" VALUES (6230, '', 1, '', 6551, 'H');
INSERT INTO "invoices" VALUES (6230, '', 1, '', 6720, 'R');
INSERT INTO "invoices" VALUES (6230, '', 1, '', 6754, 'D');
INSERT INTO "invoices" VALUES (6230, '', 1, '', 24692, 'Z');
INSERT INTO "invoices" VALUES (6230, '', 1, '', 174015, 'A');
INSERT INTO "invoices" VALUES (6231, '', 1, '', 187302, 'A');
INSERT INTO "invoices" VALUES (6232, '', 1, '', 40256, 'E');
INSERT INTO "invoices" VALUES (6233, '', 2, '', 441847, 'A');
INSERT INTO "invoices" VALUES (6234, '', 4, '', 207320, 'E');
INSERT INTO "invoices" VALUES (6235, '', 2, '', 360840, 'Z');
INSERT INTO "invoices" VALUES (6236, '', 2, '', 253023, 'H');
INSERT INTO "invoices" VALUES (6237, '', 1, '', 417112, 'A');
INSERT INTO "invoices" VALUES (6238, '', 1, '', 340347, 'A');
INSERT INTO "invoices" VALUES (6239, '', 6, '', 320238, 'Z');
INSERT INTO "invoices" VALUES (6240, '', 1, '', 266107, 'R');
INSERT INTO "invoices" VALUES (6241, '', 2, '', 246273, 'D');
INSERT INTO "invoices" VALUES (6242, '', 1, '', 316205, 'A');
INSERT INTO "invoices" VALUES (6243, '', 1, '', 277675, 'A');
INSERT INTO "invoices" VALUES (6243, '', 1, '', 8575, 'H');
INSERT INTO "invoices" VALUES (6244, '', 3, '', 4531, 'Z');
INSERT INTO "invoices" VALUES (6244, '', 3, '', 296846, 'A');
INSERT INTO "invoices" VALUES (6245, '', 2, '', 217082, 'A');
INSERT INTO "invoices" VALUES (6246, '', 1, '', 313212, 'Z');
INSERT INTO "invoices" VALUES (6247, '', 3, '', 198581, 'Z');
INSERT INTO "invoices" VALUES (6248, '', 1, '', 681, 'H');
INSERT INTO "invoices" VALUES (6248, '', 1, '', 184974, 'E');
INSERT INTO "invoices" VALUES (6249, '', 2, '', 375, 'R');
INSERT INTO "invoices" VALUES (6249, '', 2, '', 431, 'Z');
INSERT INTO "invoices" VALUES (6249, '', 2, '', 258185, 'D');
INSERT INTO "invoices" VALUES (6251, '', 1, '', 495687, 'Z');
INSERT INTO "invoices" VALUES (6252, '', 4, '', 272972, 'A');
INSERT INTO "invoices" VALUES (6253, '', 1, '', 234292, 'E');
INSERT INTO "invoices" VALUES (6254, '', 3, '', 274561, 'D');
INSERT INTO "invoices" VALUES (6255, '', 3, '', 46513, 'E');
INSERT INTO "invoices" VALUES (6256, '', 2, '', 323695, 'R');
INSERT INTO "invoices" VALUES (6257, '', 1, '', 244937, 'H');
INSERT INTO "invoices" VALUES (6258, '', 2, '', 235595, 'Z');
INSERT INTO "invoices" VALUES (6259, '', 6, '', 532042, 'A');
INSERT INTO "invoices" VALUES (6260, '', 5, '', 539454, 'A');
INSERT INTO "invoices" VALUES (6261, '', 1, '', 280204, 'A');
INSERT INTO "invoices" VALUES (6262, '', 4, '', 410618, 'A');
INSERT INTO "invoices" VALUES (6263, '', 2, '', 224241, 'Z');
INSERT INTO "invoices" VALUES (6264, '', 2, '', 401574, 'A');
INSERT INTO "invoices" VALUES (6265, '', 3, '', 234477, 'Z');
INSERT INTO "invoices" VALUES (6266, '', 1, '', 240981, 'A');
INSERT INTO "invoices" VALUES (6267, '', 2, '', 242209, 'A');
INSERT INTO "invoices" VALUES (6268, '', 3, '', 235737, 'Z');
INSERT INTO "invoices" VALUES (6269, '', 3, '', 376, 'H');
INSERT INTO "invoices" VALUES (6269, '', 3, '', 376, 'E');
INSERT INTO "invoices" VALUES (6269, '', 3, '', 376, 'A');
INSERT INTO "invoices" VALUES (6269, '', 3, '', 222067, 'R');
INSERT INTO "invoices" VALUES (6269, '', 3, '', 376, 'D');
INSERT INTO "invoices" VALUES (6270, '', 3, '', 227623, 'Z');
INSERT INTO "invoices" VALUES (6271, '', 1, '', 136518, 'A');
INSERT INTO "invoices" VALUES (6271, '', 1, '', 6948, 'D');
INSERT INTO "invoices" VALUES (6271, '', 1, '', 6797, 'R');
INSERT INTO "invoices" VALUES (6271, '', 1, '', 6871, 'H');
INSERT INTO "invoices" VALUES (6271, '', 1, '', 6903, 'E');
INSERT INTO "invoices" VALUES (6271, '', 1, '', 27176, 'Z');
INSERT INTO "invoices" VALUES (6273, '', 3, '', 501588, 'A');
INSERT INTO "invoices" VALUES (6274, '', 2, '', 304552, 'D');
INSERT INTO "invoices" VALUES (6275, '', 7, '', 371885, 'A');
INSERT INTO "invoices" VALUES (6276, '', 1, '', 266827, 'A');
INSERT INTO "invoices" VALUES (6277, '', 2, '', 261824, 'E');
INSERT INTO "invoices" VALUES (6278, '', 1, '', 64750, 'E');
INSERT INTO "invoices" VALUES (6279, '', 2, '', 316634, 'R');
INSERT INTO "invoices" VALUES (6280, '', 2, '', 444827, 'Z');
INSERT INTO "invoices" VALUES (6281, '', 1, '', 277240, 'H');
INSERT INTO "invoices" VALUES (6282, '', 2, '', 290373, 'A');
INSERT INTO "invoices" VALUES (6282, '', 2, '', 8550, 'E');
INSERT INTO "invoices" VALUES (6283, '', 1, '', 175281, 'A');
INSERT INTO "invoices" VALUES (6284, '', 1, '', 153862, 'Z');
INSERT INTO "invoices" VALUES (6284, '', 1, '', 8550, 'R');
INSERT INTO "invoices" VALUES (6285, '', 2, '', 8652, 'D');
INSERT INTO "invoices" VALUES (6285, '', 2, '', 254141, 'Z');
INSERT INTO "invoices" VALUES (6286, '', 1, '', 691, 'A');
INSERT INTO "invoices" VALUES (6286, '', 1, '', 241382, 'H');
INSERT INTO "invoices" VALUES (6286, '', 1, '', 377, 'E');
INSERT INTO "invoices" VALUES (6287, '', 4, '', 243248, 'Z');
INSERT INTO "invoices" VALUES (6287, '', 4, '', 377, 'D');
INSERT INTO "invoices" VALUES (6287, '', 4, '', 377, 'R');
INSERT INTO "invoices" VALUES (6288, '', 1, '', 7479, 'E');
INSERT INTO "invoices" VALUES (6288, '', 1, '', 7158, 'H');
INSERT INTO "invoices" VALUES (6288, '', 1, '', 7382, 'R');
INSERT INTO "invoices" VALUES (6288, '', 1, '', 7331, 'D');
INSERT INTO "invoices" VALUES (6288, '', 1, '', 28472, 'Z');
INSERT INTO "invoices" VALUES (6288, '', 1, '', 147619, 'A');
INSERT INTO "invoices" VALUES (6289, '', 2, '', 203195, 'Z');
INSERT INTO "invoices" VALUES (6290, '', 4, '', 181566, 'H');
INSERT INTO "invoices" VALUES (6291, '', 2, '', 243277, 'A');
INSERT INTO "invoices" VALUES (6292, '', 2, '', 177287, 'E');
INSERT INTO "invoices" VALUES (6293, '', 3, '', 182628, 'R');
INSERT INTO "invoices" VALUES (6294, '', 3, '', 242090, 'D');
INSERT INTO "invoices" VALUES (6295, '', 4, '', 243272, 'Z');
INSERT INTO "invoices" VALUES (6296, '', 2, '', 174877, 'E');
INSERT INTO "invoices" VALUES (6297, '', 2, '', 226055, 'A');
INSERT INTO "invoices" VALUES (6298, '', 2, '', 204159, 'A');
INSERT INTO "invoices" VALUES (6299, '', 1, '', 324454, 'Z');
INSERT INTO "invoices" VALUES (6300, '', 2, '', 385123, 'A');
INSERT INTO "invoices" VALUES (6301, '', 5, '', 308204, 'A');
INSERT INTO "invoices" VALUES (6302, '', 3, '', 402294, 'A');
INSERT INTO "invoices" VALUES (6303, '', 2, '', 212492, 'A');
INSERT INTO "invoices" VALUES (6304, '', 2, '', 196942, 'Z');
INSERT INTO "invoices" VALUES (6305, '', 2, '', 272890, 'Z');
INSERT INTO "invoices" VALUES (6306, '', 2, '', 385392, 'A');
INSERT INTO "invoices" VALUES (6307, '', 1, '', 377, 'Z');
INSERT INTO "invoices" VALUES (6307, '', 1, '', 158018, 'D');
INSERT INTO "invoices" VALUES (6307, '', 1, '', 377, 'R');
INSERT INTO "invoices" VALUES (6308, '', 6, '', 377, 'H');
INSERT INTO "invoices" VALUES (6308, '', 6, '', 377, 'E');
INSERT INTO "invoices" VALUES (6308, '', 6, '', 220143, 'A');
INSERT INTO "invoices" VALUES (6309, '', 2, '', 10140, 'E');
INSERT INTO "invoices" VALUES (6309, '', 2, '', 10367, 'H');
INSERT INTO "invoices" VALUES (6309, '', 2, '', 10534, 'R');
INSERT INTO "invoices" VALUES (6309, '', 2, '', 10518, 'D');
INSERT INTO "invoices" VALUES (6309, '', 2, '', 30844, 'Z');
INSERT INTO "invoices" VALUES (6309, '', 2, '', 170525, 'A');
INSERT INTO "invoices" VALUES (6310, '', 4, '', 430394, 'A');
INSERT INTO "invoices" VALUES (6311, '', 3, '', 224369, 'E');
INSERT INTO "invoices" VALUES (6312, '', 6, '', 409760, 'A');
INSERT INTO "invoices" VALUES (6313, '', 2, '', 409993, 'A');
INSERT INTO "invoices" VALUES (6314, '', 4, '', 310441, 'H');
INSERT INTO "invoices" VALUES (6315, '', 1, '', 372113, 'A');
INSERT INTO "invoices" VALUES (6316, '', 2, '', 235114, 'E');
INSERT INTO "invoices" VALUES (6317, '', 8, '', 366581, 'A');
INSERT INTO "invoices" VALUES (6318, '', 5, '', 223228, 'H');
INSERT INTO "invoices" VALUES (6319, '', 1, '', 272850, 'R');
INSERT INTO "invoices" VALUES (6320, '', 2, '', 297773, 'A');
INSERT INTO "invoices" VALUES (6320, '', 6, '', 303184, 'D');
INSERT INTO "invoices" VALUES (6321, '', 2, '', 405016, 'Z');
INSERT INTO "invoices" VALUES (6322, '', 3, '', 372114, 'A');
INSERT INTO "invoices" VALUES (6323, '', 2, '', 272850, 'R');
INSERT INTO "invoices" VALUES (6324, '', 1, '', 119485, 'D');
INSERT INTO "invoices" VALUES (6325, '', 5, '', 280108, 'R');
INSERT INTO "invoices" VALUES (6326, '', 3, '', 401340, 'Z');
INSERT INTO "invoices" VALUES (6327, '', 3, '', 307825, 'A');
INSERT INTO "invoices" VALUES (6328, '', 3, '', 297331, 'Z');
INSERT INTO "invoices" VALUES (6329, '', 2, '', 194057, 'Z');
INSERT INTO "invoices" VALUES (6331, '', 4, '', 190453, 'Z');
INSERT INTO "invoices" VALUES (6332, '', 3, '', 304834, 'A');
INSERT INTO "invoices" VALUES (6333, '', 1, '', 357406, 'A');
INSERT INTO "invoices" VALUES (6334, '', 2, '', 189423, 'E');
INSERT INTO "invoices" VALUES (6335, '', 3, '', 204653, 'A');
INSERT INTO "invoices" VALUES (6336, '', 3, '', 6430, 'D');
INSERT INTO "invoices" VALUES (6336, '', 3, '', 6506, 'R');
INSERT INTO "invoices" VALUES (6336, '', 3, '', 6772, 'H');
INSERT INTO "invoices" VALUES (6336, '', 3, '', 6777, 'E');
INSERT INTO "invoices" VALUES (6336, '', 3, '', 25441, 'Z');
INSERT INTO "invoices" VALUES (6336, '', 3, '', 129151, 'A');
INSERT INTO "invoices" VALUES (6337, '', 4, '', 68681, 'A');
INSERT INTO "invoices" VALUES (6338, '', 2, '', 53094, 'Z');
INSERT INTO "invoices" VALUES (6339, '', 3, '', 143236, 'Z');
INSERT INTO "invoices" VALUES (6340, '', 3, '', 165601, 'E');
INSERT INTO "invoices" VALUES (6341, '', 1, '', 164176, 'R');
INSERT INTO "invoices" VALUES (6342, '', 2, '', 37127, 'A');
INSERT INTO "invoices" VALUES (6343, '', 1, '', 532853, 'A');
INSERT INTO "invoices" VALUES (6344, '', 1, '', 433905, 'Z');
INSERT INTO "invoices" VALUES (6345, '', 3, '', 386048, 'A');
INSERT INTO "invoices" VALUES (6346, '', 3, '', 172173, 'H');
INSERT INTO "invoices" VALUES (6347, '', 2, '', 308696, 'Z');
INSERT INTO "invoices" VALUES (6348, '', 3, '', 196005, 'D');
INSERT INTO "invoices" VALUES (6349, '', 1, '', 439334, 'A');
INSERT INTO "invoices" VALUES (6350, '', 4, '', 193702, 'H');
INSERT INTO "invoices" VALUES (6351, '', 3, '', 235350, 'A');
INSERT INTO "invoices" VALUES (6352, '', 3, '', 273600, 'R');
INSERT INTO "invoices" VALUES (6353, '', 3, '', 156931, 'E');
INSERT INTO "invoices" VALUES (6354, '', 3, '', 282715, 'D');
INSERT INTO "invoices" VALUES (6355, '', 3, '', 291334, 'A');
INSERT INTO "invoices" VALUES (6356, '', 3, '', 285591, 'Z');
INSERT INTO "invoices" VALUES (6357, '', 1, '', 174245, 'A');
INSERT INTO "invoices" VALUES (6358, '', 1, '', 257234, 'A');
INSERT INTO "invoices" VALUES (6359, '', 2, '', 86723, 'A');
INSERT INTO "invoices" VALUES (6360, '', 2, '', 279492, 'A');
INSERT INTO "invoices" VALUES (6361, '', 4, '', 241727, 'A');
INSERT INTO "invoices" VALUES (6361, '', 4, '', 108708, 'Z');
INSERT INTO "invoices" VALUES (6362, '', 5, '', 234351, 'Z');
INSERT INTO "invoices" VALUES (6362, '', 5, '', 376, 'R');
INSERT INTO "invoices" VALUES (6362, '', 5, '', 376, 'D');
INSERT INTO "invoices" VALUES (6363, '', 1, '', 376, 'E');
INSERT INTO "invoices" VALUES (6363, '', 1, '', 376, 'H');
INSERT INTO "invoices" VALUES (6363, '', 1, '', 242853, 'A');
INSERT INTO "invoices" VALUES (6364, '', 2, '', 5470, 'R');
INSERT INTO "invoices" VALUES (6364, '', 2, '', 5594, 'D');
INSERT INTO "invoices" VALUES (6364, '', 2, '', 20012, 'Z');
INSERT INTO "invoices" VALUES (6364, '', 2, '', 162773, 'A');
INSERT INTO "invoices" VALUES (6364, '', 2, '', 5569, 'E');
INSERT INTO "invoices" VALUES (6364, '', 2, '', 5532, 'H');
INSERT INTO "invoices" VALUES (6365, '', 1, '', 72184, 'R');
INSERT INTO "invoices" VALUES (6366, '', 5, '', 176611, 'H');
INSERT INTO "invoices" VALUES (6367, '', 3, '', 183688, 'D');
INSERT INTO "invoices" VALUES (6368, '', 1, '', 482453, 'A');
INSERT INTO "invoices" VALUES (6369, '', 4, '', 351539, 'A');
INSERT INTO "invoices" VALUES (6370, '', 4, '', 267794, 'R');
INSERT INTO "invoices" VALUES (6371, '', 3, '', 147147, 'E');
INSERT INTO "invoices" VALUES (6372, '', 1, '', 321417, 'A');
INSERT INTO "invoices" VALUES (6373, '', 1, '', 167404, 'R');
INSERT INTO "invoices" VALUES (6374, '', 1, '', 54277, 'A');
INSERT INTO "invoices" VALUES (6375, '', 2, '', 314274, 'Z');
INSERT INTO "invoices" VALUES (6377, '', 3, '', 415753, 'Z');
INSERT INTO "invoices" VALUES (6378, '', 6, '', 259158, 'H');
INSERT INTO "invoices" VALUES (6379, '', 3, '', 165247, 'E');
INSERT INTO "invoices" VALUES (6380, '', 1, '', 66836, 'Z');
INSERT INTO "invoices" VALUES (6381, '', 7, '', 453250, 'A');
INSERT INTO "invoices" VALUES (6382, '', 6, '', 237125, 'D');
INSERT INTO "invoices" VALUES (6383, '', 4, '', 407223, 'Z');
INSERT INTO "invoices" VALUES (6384, '', 1, '', 132677, 'Z');
INSERT INTO "invoices" VALUES (6384, '', 1, '', 259057, 'A');
INSERT INTO "invoices" VALUES (6385, '', 3, '', 280814, 'A');
INSERT INTO "invoices" VALUES (6386, '', 2, '', 14129, 'A');
INSERT INTO "invoices" VALUES (6386, '', 2, '', 226211, 'Z');
INSERT INTO "invoices" VALUES (6387, '', 1, '', 302289, 'A');
INSERT INTO "invoices" VALUES (6388, '', 1, '', 151427, 'Z');
INSERT INTO "invoices" VALUES (6389, '', 2, '', 176652, 'A');
INSERT INTO "invoices" VALUES (6390, '', 1, '', 376, 'Z');
INSERT INTO "invoices" VALUES (6390, '', 1, '', 376, 'A');
INSERT INTO "invoices" VALUES (6390, '', 1, '', 221285, 'E');
INSERT INTO "invoices" VALUES (6391, '', 1, '', 376, 'R');
INSERT INTO "invoices" VALUES (6391, '', 1, '', 376, 'D');
INSERT INTO "invoices" VALUES (6391, '', 1, '', 176154, 'H');
INSERT INTO "invoices" VALUES (6392, '', 1, '', 77121, 'A');
INSERT INTO "invoices" VALUES (6393, '', 1, '', 6751, 'E');
INSERT INTO "invoices" VALUES (6393, '', 1, '', 6628, 'H');
INSERT INTO "invoices" VALUES (6393, '', 1, '', 6582, 'R');
INSERT INTO "invoices" VALUES (6393, '', 1, '', 6678, 'D');
INSERT INTO "invoices" VALUES (6393, '', 1, '', 26751, 'Z');
INSERT INTO "invoices" VALUES (6393, '', 1, '', 101659, 'A');
INSERT INTO "invoices" VALUES (6394, '', 4, '', 462000, 'A');
INSERT INTO "invoices" VALUES (6395, '', 1, '', 567703, 'A');
INSERT INTO "invoices" VALUES (6396, '', 1, '', 228737, 'Z');
INSERT INTO "invoices" VALUES (6397, '', 3, '', 387003, 'Z');
INSERT INTO "invoices" VALUES (6398, '', 2, '', 389327, 'Z');
INSERT INTO "invoices" VALUES (6399, '', 2, '', 207043, 'R');
INSERT INTO "invoices" VALUES (6400, '', 1, '', 259285, 'H');
INSERT INTO "invoices" VALUES (6401, '', 3, '', 256652, 'E');
INSERT INTO "invoices" VALUES (6402, '', 1, '', 265889, 'D');
INSERT INTO "invoices" VALUES (6403, '', 2, '', 242740, 'A');
INSERT INTO "invoices" VALUES (6404, '', 1, '', 237831, 'A');
INSERT INTO "invoices" VALUES (6405, '', 2, '', 53170, 'A');
INSERT INTO "invoices" VALUES (6406, '', 4, '', 455352, 'A');
INSERT INTO "invoices" VALUES (6407, '', 4, '', 270812, 'A');
INSERT INTO "invoices" VALUES (6408, '', 2, '', 505635, 'A');
INSERT INTO "invoices" VALUES (6409, '', 1, '', 186027, 'Z');
INSERT INTO "invoices" VALUES (6410, '', 3, '', 158811, 'A');
INSERT INTO "invoices" VALUES (6411, '', 3, '', 222991, 'A');
INSERT INTO "invoices" VALUES (6412, '', 5, '', 163914, 'A');
INSERT INTO "invoices" VALUES (6413, '', 2, '', 280489, 'A');
INSERT INTO "invoices" VALUES (6414, '', 4, '', 229869, 'Z');
INSERT INTO "invoices" VALUES (6415, '', 1, '', 377, 'D');
INSERT INTO "invoices" VALUES (6415, '', 1, '', 377, 'Z');
INSERT INTO "invoices" VALUES (6415, '', 1, '', 257708, 'R');
INSERT INTO "invoices" VALUES (6416, '', 3, '', 377, 'E');
INSERT INTO "invoices" VALUES (6416, '', 3, '', 377, 'H');
INSERT INTO "invoices" VALUES (6416, '', 3, '', 254332, 'A');
INSERT INTO "invoices" VALUES (6417, '', 3, '', 6937, 'E');
INSERT INTO "invoices" VALUES (6417, '', 3, '', 6875, 'H');
INSERT INTO "invoices" VALUES (6417, '', 3, '', 6956, 'R');
INSERT INTO "invoices" VALUES (6417, '', 3, '', 7021, 'D');
INSERT INTO "invoices" VALUES (6417, '', 3, '', 27440, 'Z');
INSERT INTO "invoices" VALUES (6417, '', 3, '', 151265, 'A');
INSERT INTO "invoices" VALUES (6418, '', 4, '', 209941, 'D');
INSERT INTO "invoices" VALUES (6419, '', 4, '', 393453, 'A');
INSERT INTO "invoices" VALUES (6420, '', 3, '', 157599, 'H');
INSERT INTO "invoices" VALUES (6421, '', 2, '', 353733, 'A');
INSERT INTO "invoices" VALUES (6422, '', 2, '', 474072, 'A');
INSERT INTO "invoices" VALUES (6423, '', 3, '', 153633, 'E');
INSERT INTO "invoices" VALUES (6424, '', 3, '', 273786, 'Z');
INSERT INTO "invoices" VALUES (6425, '', 1, '', 590644, 'A');
INSERT INTO "invoices" VALUES (6426, '', 5, '', 202155, 'A');
INSERT INTO "invoices" VALUES (6427, '', 4, '', 289947, 'A');
INSERT INTO "invoices" VALUES (6428, '', 1, '', 708122, 'A');
INSERT INTO "invoices" VALUES (6429, '', 2, '', 208208, 'A');
INSERT INTO "invoices" VALUES (6430, '', 2, '', 173497, 'D');
INSERT INTO "invoices" VALUES (6431, '', 3, '', 350128, 'A');
INSERT INTO "invoices" VALUES (6432, '', 3, '', 302023, 'R');
INSERT INTO "invoices" VALUES (6433, '', 1, '', 511879, 'Z');
INSERT INTO "invoices" VALUES (6434, '', 2, '', 175766, 'E');
INSERT INTO "invoices" VALUES (6435, '', 2, '', 9135, 'E');
INSERT INTO "invoices" VALUES (6435, '', 2, '', 251800, 'A');
INSERT INTO "invoices" VALUES (6436, '', 5, '', 3654, 'A');
INSERT INTO "invoices" VALUES (6436, '', 5, '', 9135, 'R');
INSERT INTO "invoices" VALUES (6436, '', 5, '', 199518, 'Z');
INSERT INTO "invoices" VALUES (6437, '', 2, '', 9135, 'H');
INSERT INTO "invoices" VALUES (6437, '', 2, '', 283313, 'A');
INSERT INTO "invoices" VALUES (6438, '', 4, '', 179436, 'A');
INSERT INTO "invoices" VALUES (6439, '', 3, '', 9140, 'D');
INSERT INTO "invoices" VALUES (6439, '', 3, '', 155678, 'Z');
INSERT INTO "invoices" VALUES (6440, '', 2, '', 65899, 'R');
INSERT INTO "invoices" VALUES (6441, '', 1, '', 64379, 'A');
INSERT INTO "invoices" VALUES (6442, '', 5, '', 377, 'D');
INSERT INTO "invoices" VALUES (6442, '', 5, '', 377, 'Z');
INSERT INTO "invoices" VALUES (6442, '', 5, '', 248740, 'R');
INSERT INTO "invoices" VALUES (6443, '', 2, '', 76919, 'A');
INSERT INTO "invoices" VALUES (6444, '', 1, '', 377, 'E');
INSERT INTO "invoices" VALUES (6444, '', 1, '', 377, 'H');
INSERT INTO "invoices" VALUES (6444, '', 1, '', 259139, 'A');
INSERT INTO "invoices" VALUES (6445, '', 4, '', 175555, 'H');
INSERT INTO "invoices" VALUES (6446, '', 2, '', 61974, 'A');
INSERT INTO "invoices" VALUES (6447, '', 3, '', 8216, 'E');
INSERT INTO "invoices" VALUES (6447, '', 3, '', 8310, 'H');
INSERT INTO "invoices" VALUES (6447, '', 3, '', 8323, 'R');
INSERT INTO "invoices" VALUES (6447, '', 3, '', 155489, 'A');
INSERT INTO "invoices" VALUES (6448, '', 1, '', 659875, 'A');
INSERT INTO "invoices" VALUES (6449, '', 2, '', 88921, 'A');
INSERT INTO "invoices" VALUES (6450, '', 1, '', 97484, 'A');
INSERT INTO "invoices" VALUES (6451, '', 4, '', 126484, 'Z');
INSERT INTO "invoices" VALUES (6451, '', 4, '', 392, 'A');
INSERT INTO "invoices" VALUES (6452, '', 2, '', 84434, 'A');
INSERT INTO "invoices" VALUES (6453, '', 1, '', 199507, 'A');
INSERT INTO "invoices" VALUES (6453, '', 1, '', 415501, 'Z');
INSERT INTO "invoices" VALUES (6454, '', 1, '', 592574, 'A');
INSERT INTO "invoices" VALUES (6455, '', 4, '', 150942, 'E');
INSERT INTO "invoices" VALUES (6456, '', 1, '', 308156, 'D');
INSERT INTO "invoices" VALUES (6457, '', 6, '', 144536, 'H');
INSERT INTO "invoices" VALUES (6458, '', 1, '', 264524, 'A');
INSERT INTO "invoices" VALUES (6459, '', 5, '', 338191, 'A');
INSERT INTO "invoices" VALUES (6460, '', 3, '', 438049, 'Z');
INSERT INTO "invoices" VALUES (6461, '', 4, '', 258847, 'R');
INSERT INTO "invoices" VALUES (6462, '', 2, '', 57329, 'Z');
INSERT INTO "invoices" VALUES (6463, '', 5, '', 173819, 'H');
INSERT INTO "invoices" VALUES (6464, '', 1, '', 152903, 'E');
INSERT INTO "invoices" VALUES (6465, '', 3, '', 542933, 'A');
INSERT INTO "invoices" VALUES (6466, '', 5, '', 474675, 'Z');
INSERT INTO "invoices" VALUES (6467, '', 1, '', 251153, 'E');
INSERT INTO "invoices" VALUES (6468, '', 1, '', 341904, 'A');
INSERT INTO "invoices" VALUES (6469, '', 4, '', 341406, 'A');
INSERT INTO "invoices" VALUES (6470, '', 1, '', 252295, 'H');
INSERT INTO "invoices" VALUES (6471, '', 2, '', 338396, 'D');
INSERT INTO "invoices" VALUES (6472, '', 2, '', 73985, 'Z');
INSERT INTO "invoices" VALUES (6473, '', 1, '', 12877, 'E');
INSERT INTO "invoices" VALUES (6473, '', 1, '', 12944, 'H');
INSERT INTO "invoices" VALUES (6473, '', 1, '', 12991, 'R');
INSERT INTO "invoices" VALUES (6473, '', 1, '', 13069, 'D');
INSERT INTO "invoices" VALUES (6473, '', 1, '', 52029, 'Z');
INSERT INTO "invoices" VALUES (6473, '', 1, '', 140049, 'A');
INSERT INTO "invoices" VALUES (6474, '', 3, '', 80322, 'R');
INSERT INTO "invoices" VALUES (6475, '', 2, '', 103241, 'A');
INSERT INTO "invoices" VALUES (6476, '', 1, '', 11356, 'H');
INSERT INTO "invoices" VALUES (6476, '', 1, '', 77880, 'E');
INSERT INTO "invoices" VALUES (6477, '', 1, '', 106247, 'A');
INSERT INTO "invoices" VALUES (6478, '', 1, '', 104367, 'Z');
INSERT INTO "invoices" VALUES (6479, '', 1, '', 82773, 'D');
INSERT INTO "invoices" VALUES (6480, '', 3, '', 155347, 'A');
INSERT INTO "invoices" VALUES (6481, '', 4, '', 10718, 'A');
INSERT INTO "invoices" VALUES (6481, '', 4, '', 262677, 'Z');
INSERT INTO "invoices" VALUES (6482, '', 2, '', 698751, 'A');
INSERT INTO "invoices" VALUES (6483, '', 4, '', 255853, 'A');
INSERT INTO "invoices" VALUES (6484, '', 2, '', 439765, 'Z');
INSERT INTO "invoices" VALUES (6484, '', 2, '', 223183, 'A');
INSERT INTO "invoices" VALUES (6485, '', 1, '', 261211, 'A');
INSERT INTO "invoices" VALUES (6486, '', 2, '', 151512, 'Z');
INSERT INTO "invoices" VALUES (6487, '', 6, '', 509730, 'A');
INSERT INTO "invoices" VALUES (6488, '', 3, '', 508237, 'A');
INSERT INTO "invoices" VALUES (6489, '', 4, '', 276316, 'E');
INSERT INTO "invoices" VALUES (6490, '', 3, '', 208492, 'R');
INSERT INTO "invoices" VALUES (6491, '', 1, '', 518295, 'A');
INSERT INTO "invoices" VALUES (6492, '', 1, '', 74015, 'Z');
INSERT INTO "invoices" VALUES (6493, '', 5, '', 517267, 'A');
INSERT INTO "invoices" VALUES (6494, '', 2, '', 347039, 'D');
INSERT INTO "invoices" VALUES (6495, '', 2, '', 521852, 'A');
INSERT INTO "invoices" VALUES (6496, '', 2, '', 321741, 'H');
INSERT INTO "invoices" VALUES (6497, '', 2, '', 187337, 'R');
INSERT INTO "invoices" VALUES (6498, '', 5, '', 368007, 'Z');
INSERT INTO "invoices" VALUES (6499, '', 1, '', 341415, 'Z');
INSERT INTO "invoices" VALUES (6500, '', 2, '', 519052, 'Z');
INSERT INTO "invoices" VALUES (6501, '', 1, '', 272870, 'H');
INSERT INTO "invoices" VALUES (6502, '', 3, '', 75961, 'A');
INSERT INTO "invoices" VALUES (6503, '', 3, '', 261956, 'E');
INSERT INTO "invoices" VALUES (6504, '', 1, '', 345445, 'A');
INSERT INTO "invoices" VALUES (6505, '', 3, '', 342889, 'Z');
INSERT INTO "invoices" VALUES (6506, '', 1, '', 377, 'D');
INSERT INTO "invoices" VALUES (6506, '', 1, '', 289675, 'R');
INSERT INTO "invoices" VALUES (6507, '', 1, '', 20534, 'E');
INSERT INTO "invoices" VALUES (6507, '', 1, '', 20940, 'H');
INSERT INTO "invoices" VALUES (6507, '', 1, '', 20826, 'R');
INSERT INTO "invoices" VALUES (6507, '', 1, '', 83049, 'Z');
INSERT INTO "invoices" VALUES (6507, '', 1, '', 21012, 'D');
INSERT INTO "invoices" VALUES (6507, '', 1, '', 236320, 'A');
INSERT INTO "invoices" VALUES (6508, '', 1, '', 449504, 'A');
INSERT INTO "invoices" VALUES (6509, '', 1, '', 32800, 'E');
INSERT INTO "invoices" VALUES (6509, '', 1, '', 32895, 'H');
INSERT INTO "invoices" VALUES (6509, '', 1, '', 33121, 'R');
INSERT INTO "invoices" VALUES (6509, '', 1, '', 32769, 'D');
INSERT INTO "invoices" VALUES (6509, '', 1, '', 159377, 'Z');
INSERT INTO "invoices" VALUES (6510, '', 4, '', 317691, 'Z');
INSERT INTO "invoices" VALUES (6511, '', 1, '', 288328, 'A');
INSERT INTO "invoices" VALUES (6512, '', 4, '', 242314, 'A');
INSERT INTO "invoices" VALUES (6513, '', 5, '', 368388, 'Z');
INSERT INTO "invoices" VALUES (6514, '', 1, '', 658516, 'A');
INSERT INTO "invoices" VALUES (6515, '', 5, '', 250062, 'A');
INSERT INTO "invoices" VALUES (6516, '', 2, '', 435371, 'Z');
INSERT INTO "invoices" VALUES (6517, '', 6, '', 163813, 'Z');
INSERT INTO "invoices" VALUES (6518, '', 3, '', 116190, 'Z');
INSERT INTO "invoices" VALUES (6519, '', 5, '', 131714, 'A');
INSERT INTO "invoices" VALUES (6520, '', 2, '', 12090, 'Z');
INSERT INTO "invoices" VALUES (6520, '', 2, '', 142290, 'A');
INSERT INTO "invoices" VALUES (6521, '', 2, '', 453293, 'A');
INSERT INTO "invoices" VALUES (6522, '', 1, '', 273029, 'H');
INSERT INTO "invoices" VALUES (6523, '', 2, '', 331341, 'A');
INSERT INTO "invoices" VALUES (6524, '', 2, '', 279450, 'D');
INSERT INTO "invoices" VALUES (6525, '', 1, '', 279558, 'D');
INSERT INTO "invoices" VALUES (6526, '', 1, '', 266651, 'E');
INSERT INTO "invoices" VALUES (6527, '', 6, '', 346618, 'A');
INSERT INTO "invoices" VALUES (6528, '', 5, '', 265095, 'H');
INSERT INTO "invoices" VALUES (6529, '', 3, '', 69541, 'A');
INSERT INTO "invoices" VALUES (6530, '', 3, '', 263208, 'E');
INSERT INTO "invoices" VALUES (6531, '', 5, '', 361728, 'Z');
INSERT INTO "invoices" VALUES (6532, '', 6, '', 309330, 'R');
INSERT INTO "invoices" VALUES (6533, '', 4, '', 429510, 'A');
INSERT INTO "invoices" VALUES (6534, '', 1, '', 380, 'R');
INSERT INTO "invoices" VALUES (6534, '', 1, '', 271129, 'D');
INSERT INTO "invoices" VALUES (6535, '', 1, '', 279774, 'Z');
INSERT INTO "invoices" VALUES (6536, '', 2, '', 98367, 'H');
INSERT INTO "invoices" VALUES (6536, '', 2, '', 179099, 'E');
INSERT INTO "invoices" VALUES (6537, '', 5, '', 277245, 'A');
INSERT INTO "invoices" VALUES (6538, '', 3, '', 98926, 'Z');
INSERT INTO "invoices" VALUES (6539, '', 2, '', 8218, 'D');
INSERT INTO "invoices" VALUES (6539, '', 2, '', 181978, 'A');
INSERT INTO "invoices" VALUES (6539, '', 2, '', 32962, 'Z');
INSERT INTO "invoices" VALUES (6539, '', 2, '', 8390, 'E');
INSERT INTO "invoices" VALUES (6539, '', 2, '', 8326, 'H');
INSERT INTO "invoices" VALUES (6539, '', 2, '', 8360, 'R');
INSERT INTO "invoices" VALUES (6540, '', 1, '', 28552, 'R');
INSERT INTO "invoices" VALUES (6540, '', 1, '', 28527, 'D');
INSERT INTO "invoices" VALUES (6540, '', 1, '', 137166, 'Z');
INSERT INTO "invoices" VALUES (6541, '', 2, '', 28494, 'E');
INSERT INTO "invoices" VALUES (6541, '', 2, '', 28438, 'H');
INSERT INTO "invoices" VALUES (6541, '', 2, '', 237436, 'A');
INSERT INTO "invoices" VALUES (6542, '', 3, '', 457880, 'Z');
INSERT INTO "invoices" VALUES (6542, '', 3, '', 195837, 'A');
INSERT INTO "invoices" VALUES (6543, '', 2, '', 707660, 'A');
INSERT INTO "invoices" VALUES (6544, '', 3, '', 215243, 'A');
INSERT INTO "invoices" VALUES (6545, '', 1, '', 320770, 'Z');
INSERT INTO "invoices" VALUES (6546, '', 4, '', 9296, 'Z');
INSERT INTO "invoices" VALUES (6546, '', 4, '', 172916, 'A');
INSERT INTO "invoices" VALUES (6547, '', 1, '', 6238, 'Z');
INSERT INTO "invoices" VALUES (6547, '', 1, '', 306158, 'A');
INSERT INTO "invoices" VALUES (6548, '', 2, '', 499645, 'Z');
INSERT INTO "invoices" VALUES (6549, '', 7, '', 509658, 'A');
INSERT INTO "invoices" VALUES (6550, '', 5, '', 352045, 'A');
INSERT INTO "invoices" VALUES (6551, '', 2, '', 209982, 'R');
INSERT INTO "invoices" VALUES (6552, '', 2, '', 216693, 'R');
INSERT INTO "invoices" VALUES (6553, '', 4, '', 536546, 'A');
INSERT INTO "invoices" VALUES (6554, '', 1, '', 205377, 'E');
INSERT INTO "invoices" VALUES (6555, '', 3, '', 205537, 'E');
INSERT INTO "invoices" VALUES (6556, '', 2, '', 365876, 'A');
INSERT INTO "invoices" VALUES (6557, '', 2, '', 534053, 'A');
INSERT INTO "invoices" VALUES (6558, '', 2, '', 202495, 'H');
INSERT INTO "invoices" VALUES (6559, '', 3, '', 248408, 'H');
INSERT INTO "invoices" VALUES (6560, '', 4, '', 493413, 'Z');
INSERT INTO "invoices" VALUES (6561, '', 5, '', 342281, 'D');
INSERT INTO "invoices" VALUES (6562, '', 3, '', 522706, 'A');
INSERT INTO "invoices" VALUES (6563, '', 3, '', 55103, 'A');
INSERT INTO "invoices" VALUES (6564, '', 3, '', 495165, 'Z');
INSERT INTO "invoices" VALUES (6565, '', 1, '', 335692, 'H');
INSERT INTO "invoices" VALUES (6565, '', 1, '', 380, 'E');
INSERT INTO "invoices" VALUES (6566, '', 1, '', 367380, 'A');
INSERT INTO "invoices" VALUES (6567, '', 2, '', 380, 'D');
INSERT INTO "invoices" VALUES (6567, '', 2, '', 294748, 'Z');
INSERT INTO "invoices" VALUES (6567, '', 2, '', 380, 'R');
INSERT INTO "invoices" VALUES (6568, '', 1, '', 262676, 'A');
INSERT INTO "invoices" VALUES (6569, '', 1, '', 9895, 'E');
INSERT INTO "invoices" VALUES (6569, '', 1, '', 9827, 'R');
INSERT INTO "invoices" VALUES (6569, '', 1, '', 9966, 'D');
INSERT INTO "invoices" VALUES (6569, '', 1, '', 39757, 'Z');
INSERT INTO "invoices" VALUES (6569, '', 1, '', 105423, 'A');
INSERT INTO "invoices" VALUES (6569, '', 1, '', 9949, 'H');
INSERT INTO "invoices" VALUES (6570, '', 3, '', 29743, 'D');
INSERT INTO "invoices" VALUES (6570, '', 3, '', 29743, 'R');
INSERT INTO "invoices" VALUES (6570, '', 3, '', 156759, 'Z');
INSERT INTO "invoices" VALUES (6571, '', 2, '', 226903, 'A');
INSERT INTO "invoices" VALUES (6572, '', 3, '', 256561, 'A');
INSERT INTO "invoices" VALUES (6572, '', 3, '', 29743, 'H');
INSERT INTO "invoices" VALUES (6572, '', 3, '', 29743, 'E');
INSERT INTO "invoices" VALUES (6573, '', 3, '', 96805, 'A');
INSERT INTO "invoices" VALUES (6573, '', 3, '', 10279, 'D');
INSERT INTO "invoices" VALUES (6573, '', 3, '', 10255, 'R');
INSERT INTO "invoices" VALUES (6573, '', 3, '', 10189, 'H');
INSERT INTO "invoices" VALUES (6573, '', 3, '', 10188, 'E');
INSERT INTO "invoices" VALUES (6574, '', 2, '', 136189, 'E');
INSERT INTO "invoices" VALUES (6575, '', 1, '', 406164, 'A');
INSERT INTO "invoices" VALUES (6576, '', 2, '', 133751, 'D');
INSERT INTO "invoices" VALUES (6577, '', 4, '', 151855, 'R');
INSERT INTO "invoices" VALUES (6578, '', 2, '', 180857, 'H');
INSERT INTO "invoices" VALUES (6579, '', 4, '', 267419, 'Z');
INSERT INTO "invoices" VALUES (6580, '', 6, '', 362312, 'A');
INSERT INTO "invoices" VALUES (6581, '', 3, '', 246999, 'Z');
INSERT INTO "invoices" VALUES (6582, '', 4, '', 130701, 'H');
INSERT INTO "invoices" VALUES (6583, '', 5, '', 387793, 'A');
INSERT INTO "invoices" VALUES (6584, '', 1, '', 41945, 'A');
INSERT INTO "invoices" VALUES (6585, '', 4, '', 223229, 'A');
INSERT INTO "invoices" VALUES (6586, '', 1, '', 252358, 'A');
INSERT INTO "invoices" VALUES (6586, '', 1, '', 13840, 'Z');
INSERT INTO "invoices" VALUES (6587, '', 1, '', 143633, 'Z');
INSERT INTO "invoices" VALUES (6588, '', 1, '', 125534, 'Z');
INSERT INTO "invoices" VALUES (6588, '', 1, '', 92172, 'A');
INSERT INTO "invoices" VALUES (6589, '', 3, '', 324371, 'A');
INSERT INTO "invoices" VALUES (6590, '', 4, '', 179790, 'R');
INSERT INTO "invoices" VALUES (6591, '', 2, '', 194526, 'E');
INSERT INTO "invoices" VALUES (6592, '', 1, '', 435310, 'Z');
INSERT INTO "invoices" VALUES (6593, '', 3, '', 265865, 'D');
INSERT INTO "invoices" VALUES (6594, '', 1, '', 576708, 'A');
INSERT INTO "invoices" VALUES (6595, '', 2, '', 398221, 'Z');
INSERT INTO "invoices" VALUES (6596, '', 1, '', 414, 'D');
INSERT INTO "invoices" VALUES (6596, '', 1, '', 368884, 'R');
INSERT INTO "invoices" VALUES (6597, '', 1, '', 422442, 'A');
INSERT INTO "invoices" VALUES (6598, '', 2, '', 623530, 'A');
INSERT INTO "invoices" VALUES (6599, '', 4, '', 414, 'H');
INSERT INTO "invoices" VALUES (6599, '', 4, '', 289667, 'E');
INSERT INTO "invoices" VALUES (6600, '', 1, '', 7644, 'R');
INSERT INTO "invoices" VALUES (6600, '', 1, '', 7627, 'E');
INSERT INTO "invoices" VALUES (6600, '', 1, '', 108653, 'A');
INSERT INTO "invoices" VALUES (6600, '', 1, '', 30242, 'Z');
INSERT INTO "invoices" VALUES (6600, '', 1, '', 7727, 'D');
INSERT INTO "invoices" VALUES (6600, '', 1, '', 7709, 'H');
INSERT INTO "invoices" VALUES (6601, '', 2, '', 261525, 'Z');
INSERT INTO "invoices" VALUES (6601, '', 2, '', 523050, 'A');
INSERT INTO "invoices" VALUES (6602, '', 1, '', 373657, 'A');
INSERT INTO "invoices" VALUES (6603, '', 3, '', 371854, 'Z');
INSERT INTO "invoices" VALUES (6604, '', 2, '', 123129, 'D');
INSERT INTO "invoices" VALUES (6605, '', 1, '', 381338, 'A');
INSERT INTO "invoices" VALUES (6606, '', 3, '', 96463, 'E');
INSERT INTO "invoices" VALUES (6606, '', 3, '', 126147, 'H');
INSERT INTO "invoices" VALUES (6607, '', 1, '', 76575, 'A');
INSERT INTO "invoices" VALUES (6607, '', 1, '', 18260, 'Z');
INSERT INTO "invoices" VALUES (6607, '', 1, '', 4599, 'D');
INSERT INTO "invoices" VALUES (6607, '', 1, '', 4595, 'R');
INSERT INTO "invoices" VALUES (6607, '', 1, '', 4576, 'H');
INSERT INTO "invoices" VALUES (6607, '', 1, '', 4471, 'E');
INSERT INTO "invoices" VALUES (6608, '', 1, '', 185732, 'Z');
INSERT INTO "invoices" VALUES (6609, '', 4, '', 175226, 'A');
INSERT INTO "invoices" VALUES (6610, '', 2, '', 207470, 'A');
INSERT INTO "invoices" VALUES (6611, '', 2, '', 241111, 'A');
INSERT INTO "invoices" VALUES (6612, '', 3, '', 450632, 'Z');
INSERT INTO "invoices" VALUES (6613, '', 6, '', 381071, 'A');
INSERT INTO "invoices" VALUES (6614, '', 1, '', 143373, 'Z');
INSERT INTO "invoices" VALUES (6614, '', 1, '', 26486, 'A');
INSERT INTO "invoices" VALUES (6615, '', 1, '', 327524, 'A');
INSERT INTO "invoices" VALUES (6616, '', 2, '', 450539, 'Z');
INSERT INTO "invoices" VALUES (6617, '', 2, '', 238031, 'H');
INSERT INTO "invoices" VALUES (6618, '', 3, '', 313563, 'Z');
INSERT INTO "invoices" VALUES (6619, '', 2, '', 166647, 'H');
INSERT INTO "invoices" VALUES (6620, '', 4, '', 169791, 'D');
INSERT INTO "invoices" VALUES (6621, '', 4, '', 177254, 'E');
INSERT INTO "invoices" VALUES (6622, '', 3, '', 314144, 'A');
INSERT INTO "invoices" VALUES (6623, '', 1, '', 155105, 'R');
INSERT INTO "invoices" VALUES (6624, '', 1, '', 233893, 'D');
INSERT INTO "invoices" VALUES (6625, '', 3, '', 438174, 'A');
INSERT INTO "invoices" VALUES (6626, '', 3, '', 170228, 'E');
INSERT INTO "invoices" VALUES (6627, '', 2, '', 209441, 'R');
INSERT INTO "invoices" VALUES (6628, '', 4, '', 441807, 'A');
INSERT INTO "invoices" VALUES (6629, '', 1, '', 491512, 'A');
INSERT INTO "invoices" VALUES (6630, '', 1, '', 107461, 'A');
INSERT INTO "invoices" VALUES (6631, '', 1, '', 590, 'R');
INSERT INTO "invoices" VALUES (6631, '', 1, '', 247052, 'D');
INSERT INTO "invoices" VALUES (6632, '', 1, '', 419559, 'A');
INSERT INTO "invoices" VALUES (6633, '', 4, '', 223229, 'A');
INSERT INTO "invoices" VALUES (6634, '', 2, '', 281301, 'H');
INSERT INTO "invoices" VALUES (6634, '', 2, '', 609, 'E');
INSERT INTO "invoices" VALUES (6635, '', 1, '', 449395, 'Z');
INSERT INTO "invoices" VALUES (6636, '', 1, '', 60728, 'Z');
INSERT INTO "invoices" VALUES (6636, '', 1, '', 14486, 'H');
INSERT INTO "invoices" VALUES (6636, '', 1, '', 14440, 'R');
INSERT INTO "invoices" VALUES (6636, '', 1, '', 14669, 'D');
INSERT INTO "invoices" VALUES (6636, '', 1, '', 14408, 'E');
INSERT INTO "invoices" VALUES (6636, '', 1, '', 99251, 'A');
INSERT INTO "invoices" VALUES (6637, '', 6, '', 172857, 'H');
INSERT INTO "invoices" VALUES (6637, '', 6, '', 345714, 'A');
INSERT INTO "invoices" VALUES (6638, '', 4, '', 387632, 'A');
INSERT INTO "invoices" VALUES (6639, '', 3, '', 84927, 'R');
INSERT INTO "invoices" VALUES (6639, '', 3, '', 113318, 'D');
INSERT INTO "invoices" VALUES (6640, '', 2, '', 92094, 'H');
INSERT INTO "invoices" VALUES (6640, '', 2, '', 116508, 'E');
INSERT INTO "invoices" VALUES (6641, '', 4, '', 365852, 'A');
INSERT INTO "invoices" VALUES (6642, '', 6, '', 340105, 'Z');
INSERT INTO "invoices" VALUES (6643, '', 1, '', 5446, 'R');
INSERT INTO "invoices" VALUES (6643, '', 1, '', 4820, 'E');
INSERT INTO "invoices" VALUES (6643, '', 1, '', 78093, 'A');
INSERT INTO "invoices" VALUES (6643, '', 1, '', 20717, 'Z');
INSERT INTO "invoices" VALUES (6643, '', 1, '', 5402, 'D');
INSERT INTO "invoices" VALUES (6643, '', 1, '', 4917, 'H');
INSERT INTO "invoices" VALUES (6644, '', 1, '', 188108, 'E');
INSERT INTO "invoices" VALUES (6645, '', 4, '', 361352, 'A');
INSERT INTO "invoices" VALUES (6646, '', 1, '', 224871, 'R');
INSERT INTO "invoices" VALUES (6647, '', 7, '', 462138, 'A');
INSERT INTO "invoices" VALUES (6648, '', 2, '', 478918, 'A');
INSERT INTO "invoices" VALUES (6649, '', 1, '', 227257, 'H');
INSERT INTO "invoices" VALUES (6649, 'A', 2, '', 255534, 'A');
INSERT INTO "invoices" VALUES (6650, '', 4, '', 79562, 'A');
INSERT INTO "invoices" VALUES (6651, '', 4, '', 472421, 'Z');
INSERT INTO "invoices" VALUES (6652, '', 6, '', 192640, 'D');
INSERT INTO "invoices" VALUES (6653, '', 2, '', 477984, 'Z');
INSERT INTO "invoices" VALUES (6654, '', 2, '', 165490, 'E');
INSERT INTO "invoices" VALUES (6655, '', 3, '', 183717, 'D');
INSERT INTO "invoices" VALUES (6656, '', 5, '', 147619, 'R');
INSERT INTO "invoices" VALUES (6657, '', 2, '', 152720, 'H');
INSERT INTO "invoices" VALUES (6658, '', 2, '', 241333, 'A');
INSERT INTO "invoices" VALUES (6659, '', 1, '', 187656, 'A');
INSERT INTO "invoices" VALUES (6660, '', 5, '', 145400, 'Z');
INSERT INTO "invoices" VALUES (6660, '', 5, '', 55553, 'A');
INSERT INTO "invoices" VALUES (6661, '', 3, '', 102920, 'Z');
INSERT INTO "invoices" VALUES (6661, '', 3, '', 12531, 'A');
INSERT INTO "invoices" VALUES (6662, '', 5, '', 481845, 'A');
INSERT INTO "invoices" VALUES (6663, '', 1, '', 397835, 'Z');
INSERT INTO "invoices" VALUES (6664, '', 1, '', 492776, 'A');
INSERT INTO "invoices" VALUES (6665, '', 3, '', 361942, 'E');
INSERT INTO "invoices" VALUES (6665, '', 3, '', 1469, 'A');
INSERT INTO "invoices" VALUES (6666, '', 2, '', 332573, 'A');
INSERT INTO "invoices" VALUES (6667, '', 5, '', 148638, 'A');
INSERT INTO "invoices" VALUES (6668, '', 2, '', 365987, 'R');
INSERT INTO "invoices" VALUES (6668, '', 2, '', 1318, 'D');
INSERT INTO "invoices" VALUES (6669, '', 1, '', 432394, 'Z');
INSERT INTO "invoices" VALUES (6670, '', 1, '', 90318, 'A');
INSERT INTO "invoices" VALUES (6670, '', 1, '', 9365, 'D');
INSERT INTO "invoices" VALUES (6670, '', 1, '', 9248, 'R');
INSERT INTO "invoices" VALUES (6670, '', 1, '', 10339, 'H');
INSERT INTO "invoices" VALUES (6670, '', 1, '', 10211, 'E');
INSERT INTO "invoices" VALUES (6670, '', 1, '', 36498, 'Z');
INSERT INTO "invoices" VALUES (6671, '', 2, '', 219932, 'E');
INSERT INTO "invoices" VALUES (6672, '', 3, '', 220162, 'D');
INSERT INTO "invoices" VALUES (6673, '', 4, '', 26859, 'R');
INSERT INTO "invoices" VALUES (6673, '', 4, '', 53012, 'D');
INSERT INTO "invoices" VALUES (6674, '', 5, '', 228042, 'R');
INSERT INTO "invoices" VALUES (6675, '', 1, '', 358394, 'A');
INSERT INTO "invoices" VALUES (6676, '', 3, '', 224199, 'H');
INSERT INTO "invoices" VALUES (6677, '', 4, '', 154729, 'A');
INSERT INTO "invoices" VALUES (6678, '', 3, '', 504522, 'A');
INSERT INTO "invoices" VALUES (6679, '', 3, '', 436417, 'Z');
INSERT INTO "invoices" VALUES (6680, '', 3, '', 25449, 'E');
INSERT INTO "invoices" VALUES (6680, '', 3, '', 55135, 'H');
INSERT INTO "invoices" VALUES (6681, '', 1, '', 256430, 'A');
INSERT INTO "invoices" VALUES (6682, '', 6, '', 455751, 'A');
INSERT INTO "invoices" VALUES (6683, '', 1, '', 296314, 'Z');
INSERT INTO "invoices" VALUES (6684, '', 3, '', 104484, 'Z');
INSERT INTO "invoices" VALUES (6685, '', 4, '', 282715, 'A');
INSERT INTO "invoices" VALUES (6685, '', 4, '', 141358, 'Z');
INSERT INTO "invoices" VALUES (6686, '', 4, '', 162129, 'Z');
INSERT INTO "invoices" VALUES (6686, '', 4, '', 39540, 'A');
INSERT INTO "invoices" VALUES (6687, '', 2, '', 7809, 'Z');
INSERT INTO "invoices" VALUES (6687, '', 2, '', 209160, 'A');
INSERT INTO "invoices" VALUES (6688, '', 2, '', 296314, 'A');
INSERT INTO "invoices" VALUES (6689, '', 4, '', 197756, 'A');
INSERT INTO "invoices" VALUES (6690, '', 2, '', 33158, 'A');
INSERT INTO "invoices" VALUES (6690, '', 2, '', 168607, 'Z');
INSERT INTO "invoices" VALUES (6691, '', 2, '', 354480, 'A');
INSERT INTO "invoices" VALUES (6692, '', 1, '', 44138, 'A');
INSERT INTO "invoices" VALUES (6693, '', 1, '', 289663, 'A');
INSERT INTO "invoices" VALUES (6694, '', 4, '', 116221, 'A');
INSERT INTO "invoices" VALUES (6694, '', 4, '', 8956, 'H');
INSERT INTO "invoices" VALUES (6694, '', 4, '', 8956, 'E');
INSERT INTO "invoices" VALUES (6695, '', 2, '', 8258, 'H');
INSERT INTO "invoices" VALUES (6695, '', 2, '', 78801, 'A');
INSERT INTO "invoices" VALUES (6695, '', 2, '', 8258, 'E');
INSERT INTO "invoices" VALUES (6696, '', 3, '', 7650, 'D');
INSERT INTO "invoices" VALUES (6696, '', 3, '', 121400, 'Z');
INSERT INTO "invoices" VALUES (6696, '', 3, '', 7650, 'R');
INSERT INTO "invoices" VALUES (6697, '', 2, '', 104019, 'R');
INSERT INTO "invoices" VALUES (6698, '', 3, '', 180469, 'H');
INSERT INTO "invoices" VALUES (6699, '', 4, '', 178751, 'D');
INSERT INTO "invoices" VALUES (6700, '', 2, '', 289974, 'Z');
INSERT INTO "invoices" VALUES (6701, '', 2, '', 75847, 'Z');
INSERT INTO "invoices" VALUES (6701, '', 2, '', 8058, 'D');
INSERT INTO "invoices" VALUES (6701, '', 2, '', 8058, 'R');
INSERT INTO "invoices" VALUES (6702, '', 1, '', 460404, 'A');
INSERT INTO "invoices" VALUES (6703, '', 2, '', 324836, 'D');
INSERT INTO "invoices" VALUES (6703, '', 2, '', 1245, 'R');
INSERT INTO "invoices" VALUES (6704, '', 1, '', 344709, 'H');
INSERT INTO "invoices" VALUES (6705, '', 5, '', 293397, 'A');
INSERT INTO "invoices" VALUES (6706, '', 1, '', 123317, 'A');
INSERT INTO "invoices" VALUES (6706, '', 1, '', 48286, 'Z');
INSERT INTO "invoices" VALUES (6706, '', 1, '', 12074, 'D');
INSERT INTO "invoices" VALUES (6706, '', 1, '', 12027, 'R');
INSERT INTO "invoices" VALUES (6706, '', 1, '', 12126, 'H');
INSERT INTO "invoices" VALUES (6706, '', 1, '', 11949, 'E');
INSERT INTO "invoices" VALUES (6707, '', 2, '', 188774, 'A');
INSERT INTO "invoices" VALUES (6707, '', 2, '', 94387, 'Z');
INSERT INTO "invoices" VALUES (6708, '', 4, '', 567225, 'Z');
INSERT INTO "invoices" VALUES (6709, '', 3, '', 561738, 'A');
INSERT INTO "invoices" VALUES (6710, '', 3, '', 75639, 'Z');
INSERT INTO "invoices" VALUES (6711, '', 4, '', 134260, 'Z');
INSERT INTO "invoices" VALUES (6712, '', 3, '', 196820, 'E');
INSERT INTO "invoices" VALUES (6713, '', 5, '', 178784, 'D');
INSERT INTO "invoices" VALUES (6714, '', 2, '', 48408, 'D');
INSERT INTO "invoices" VALUES (6714, '', 2, '', 66467, 'R');
INSERT INTO "invoices" VALUES (6715, '', 8, '', 191864, 'A');
INSERT INTO "invoices" VALUES (6716, '', 3, '', 227856, 'R');
INSERT INTO "invoices" VALUES (6717, '', 5, '', 538775, 'A');
INSERT INTO "invoices" VALUES (6718, '', 5, '', 177525, 'H');
INSERT INTO "invoices" VALUES (6719, '', 3, '', 48685, 'E');
INSERT INTO "invoices" VALUES (6719, '', 3, '', 35431, 'H');
INSERT INTO "invoices" VALUES (6720, '', 4, '', 360031, 'A');
INSERT INTO "invoices" VALUES (6721, '', 3, '', 139759, 'A');
INSERT INTO "invoices" VALUES (6722, '', 3, '', 301418, 'Z');
INSERT INTO "invoices" VALUES (6723, '', 3, '', 180909, 'A');
INSERT INTO "invoices" VALUES (6724, '', 5, '', 134016, 'A');
INSERT INTO "invoices" VALUES (6725, '', 5, '', 22739, 'A');
INSERT INTO "invoices" VALUES (6725, '', 5, '', 155435, 'Z');
INSERT INTO "invoices" VALUES (6726, '', 2, '', 185455, 'A');
INSERT INTO "invoices" VALUES (6727, '', 3, '', 106645, 'Z');
INSERT INTO "invoices" VALUES (6728, '', 2, '', 88906, 'A');
INSERT INTO "invoices" VALUES (6729, '', 2, '', 20399, 'Z');
INSERT INTO "invoices" VALUES (6730, '', 1, '', 325886, 'E');
INSERT INTO "invoices" VALUES (6731, '', 3, '', 1100, 'E');
INSERT INTO "invoices" VALUES (6731, '', 3, '', 10270, 'H');
INSERT INTO "invoices" VALUES (6731, '', 3, '', 385890, 'A');
INSERT INTO "invoices" VALUES (6732, '', 3, '', 906, 'R');
INSERT INTO "invoices" VALUES (6732, '', 3, '', 230099, 'D');
INSERT INTO "invoices" VALUES (6733, '', 1, '', 247534, 'Z');
INSERT INTO "invoices" VALUES (6734, '', 1, '', 2005, 'E');
INSERT INTO "invoices" VALUES (6734, '', 1, '', 1982, 'H');
INSERT INTO "invoices" VALUES (6734, '', 1, '', 1978, 'R');
INSERT INTO "invoices" VALUES (6734, '', 1, '', 1997, 'D');
INSERT INTO "invoices" VALUES (6734, '', 1, '', 7560, 'Z');
INSERT INTO "invoices" VALUES (6734, '', 1, '', 155055, 'A');
INSERT INTO "invoices" VALUES (6735, '', 2, '', 3047, 'A');
INSERT INTO "invoices" VALUES (6735, '', 2, '', 59821, 'D');
INSERT INTO "invoices" VALUES (6735, '', 2, '', 70952, 'R');
INSERT INTO "invoices" VALUES (6736, '', 3, '', 287085, 'H');
INSERT INTO "invoices" VALUES (6737, '', 4, '', 201788, 'D');
INSERT INTO "invoices" VALUES (6738, '', 2, '', 575887, 'A');
INSERT INTO "invoices" VALUES (6739, '', 3, '', 220914, 'R');
INSERT INTO "invoices" VALUES (6740, '', 3, '', 5342, 'A');
INSERT INTO "invoices" VALUES (6740, '', 3, '', 57933, 'H');
INSERT INTO "invoices" VALUES (6740, '', 3, '', 68062, 'E');
INSERT INTO "invoices" VALUES (6741, '', 1, '', 234422, 'E');
INSERT INTO "invoices" VALUES (6742, '', 5, '', 211351, 'Z');
INSERT INTO "invoices" VALUES (6743, '', 2, '', 316907, 'A');
INSERT INTO "invoices" VALUES (6744, '', 7, '', 286919, 'A');
INSERT INTO "invoices" VALUES (6745, '', 3, '', 399517, 'Z');
INSERT INTO "invoices" VALUES (6746, '', 1, '', 183473, 'A');
INSERT INTO "invoices" VALUES (6747, '', 6, '', 239150, 'A');
INSERT INTO "invoices" VALUES (6748, '', 2, '', 7165, 'A');
INSERT INTO "invoices" VALUES (6748, '', 2, '', 177851, 'Z');
INSERT INTO "invoices" VALUES (6749, '', 1, '', 192443, 'A');
INSERT INTO "invoices" VALUES (6750, '', 2, '', 94576, 'A');
INSERT INTO "invoices" VALUES (6751, '', 2, '', 131275, 'Z');
INSERT INTO "invoices" VALUES (6752, '', 2, '', 303282, 'A');
INSERT INTO "invoices" VALUES (6753, '', 6, '', 278137, 'Z');
INSERT INTO "invoices" VALUES (6754, '', 2, '', 34376, 'Z');
INSERT INTO "invoices" VALUES (6755, '', 2, '', 361882, 'A');
INSERT INTO "invoices" VALUES (6756, '', 3, '', 300894, 'E');
INSERT INTO "invoices" VALUES (6757, '', 2, '', 286772, 'R');
INSERT INTO "invoices" VALUES (6758, '', 4, '', 220488, 'Z');
INSERT INTO "invoices" VALUES (6759, '', 3, '', 4415, 'E');
INSERT INTO "invoices" VALUES (6759, '', 3, '', 4436, 'H');
INSERT INTO "invoices" VALUES (6759, '', 3, '', 4372, 'R');
INSERT INTO "invoices" VALUES (6759, '', 3, '', 4406, 'D');
INSERT INTO "invoices" VALUES (6759, '', 3, '', 13661, 'Z');
INSERT INTO "invoices" VALUES (6759, '', 3, '', 92207, 'A');
INSERT INTO "invoices" VALUES (6760, '', 1, '', 249236, 'A');
INSERT INTO "invoices" VALUES (6761, '', 1, '', 136598, 'A');
INSERT INTO "invoices" VALUES (6762, '', 4, '', 211079, 'A');
INSERT INTO "invoices" VALUES (6763, '', 4, '', 217100, 'E');
INSERT INTO "invoices" VALUES (6764, '', 6, '', 210367, 'R');
INSERT INTO "invoices" VALUES (6765, '', 4, '', 33210, 'A');
INSERT INTO "invoices" VALUES (6765, '', 4, '', 47351, 'E');
INSERT INTO "invoices" VALUES (6765, '', 4, '', 57208, 'H');
INSERT INTO "invoices" VALUES (6766, '', 3, '', 273272, 'D');
INSERT INTO "invoices" VALUES (6767, '', 5, '', 625985, 'A');
INSERT INTO "invoices" VALUES (6768, '', 4, '', 253438, 'H');
INSERT INTO "invoices" VALUES (6769, '', 5, '', 38575, 'Z');
INSERT INTO "invoices" VALUES (6769, '', 5, '', 47122, 'R');
INSERT INTO "invoices" VALUES (6769, '', 5, '', 57311, 'D');
INSERT INTO "invoices" VALUES (6770, '', 4, '', 375702, 'Z');
INSERT INTO "invoices" VALUES (6771, '', 2, '', 164546, 'Z');
INSERT INTO "invoices" VALUES (6772, '', 4, '', 123107, 'A');
INSERT INTO "invoices" VALUES (6773, '', 1, '', 328031, 'A');
INSERT INTO "invoices" VALUES (6774, '', 6, '', 329701, 'A');
INSERT INTO "invoices" VALUES (6775, '', 1, '', 36418, 'A');
INSERT INTO "invoices" VALUES (6776, '', 4, '', 193190, 'Z');
INSERT INTO "invoices" VALUES (6777, '', 5, '', 182320, 'A');
INSERT INTO "invoices" VALUES (6778, '', 1, '', 105621, 'Z');
INSERT INTO "invoices" VALUES (6779, '', 3, '', 12180, 'H');
INSERT INTO "invoices" VALUES (6779, '', 3, '', 253491, 'A');
INSERT INTO "invoices" VALUES (6780, '', 6, '', 12180, 'E');
INSERT INTO "invoices" VALUES (6780, '', 6, '', 111111, 'A');
INSERT INTO "invoices" VALUES (6781, '', 4, '', 12215, 'D');
INSERT INTO "invoices" VALUES (6781, '', 4, '', 46017, 'A');
INSERT INTO "invoices" VALUES (6781, '', 4, '', 175890, 'Z');
INSERT INTO "invoices" VALUES (6782, '', 3, '', 12180, 'R');
INSERT INTO "invoices" VALUES (6782, '', 3, '', 117595, 'Z');
INSERT INTO "invoices" VALUES (6783, '', 1, '', 273961, 'A');
INSERT INTO "invoices" VALUES (6784, '', 5, '', 134808, 'Z');
INSERT INTO "invoices" VALUES (6785, '', 2, '', 69884, 'E');
INSERT INTO "invoices" VALUES (6785, '', 2, '', 210786, 'H');
INSERT INTO "invoices" VALUES (6786, '', 4, '', 322868, 'A');
INSERT INTO "invoices" VALUES (6787, '', 6, '', 213589, 'A');
INSERT INTO "invoices" VALUES (6788, '', 2, '', 12225, 'R');
INSERT INTO "invoices" VALUES (6788, '', 2, '', 209001, 'D');
INSERT INTO "invoices" VALUES (6789, '', 2, '', 307690, 'A');
INSERT INTO "invoices" VALUES (6790, '', 2, '', 66845, 'R');
INSERT INTO "invoices" VALUES (6790, '', 2, '', 67327, 'D');
INSERT INTO "invoices" VALUES (6790, '', 2, '', 153053, 'Z');
INSERT INTO "invoices" VALUES (6791, '', 3, '', 58771, 'E');
INSERT INTO "invoices" VALUES (6791, '', 3, '', 59017, 'H');
INSERT INTO "invoices" VALUES (6791, '', 3, '', 143902, 'A');
INSERT INTO "invoices" VALUES (6792, '', 5, '', 192972, 'A');
INSERT INTO "invoices" VALUES (6793, '', 1, '', 323178, 'Z');
INSERT INTO "invoices" VALUES (6794, '', 5, '', 322525, 'Z');
INSERT INTO "invoices" VALUES (6795, '', 2, '', 96748, 'A');
INSERT INTO "invoices" VALUES (6796, '', 4, '', 137120, 'E');
INSERT INTO "invoices" VALUES (6796, '', 4, '', 206410, 'H');
INSERT INTO "invoices" VALUES (6797, '', 7, '', 336556, 'A');
INSERT INTO "invoices" VALUES (6798, '', 4, '', 77106, 'R');
INSERT INTO "invoices" VALUES (6798, '', 4, '', 87177, 'D');
INSERT INTO "invoices" VALUES (6799, '', 3, '', 139407, 'D');
INSERT INTO "invoices" VALUES (6799, '', 3, '', 201532, 'R');
INSERT INTO "invoices" VALUES (6800, '', 2, '', 80485, 'H');
INSERT INTO "invoices" VALUES (6800, '', 2, '', 90319, 'E');
INSERT INTO "invoices" VALUES (6801, '', 8, '', 545250, 'A');
INSERT INTO "invoices" VALUES (6802, '', 1, '', 334008, 'A');
INSERT INTO "invoices" VALUES (6803, '', 1, '', 224956, 'Z');
INSERT INTO "invoices" VALUES (6804, '', 1, '', 331742, 'A');
INSERT INTO "invoices" VALUES (6805, '', 3, '', 109301, 'Z');
INSERT INTO "invoices" VALUES (6806, '', 3, '', 36799, 'Z');
INSERT INTO "invoices" VALUES (6806, '', 3, '', 198643, 'A');
INSERT INTO "invoices" VALUES (6807, '', 3, '', 122487, 'A');
INSERT INTO "invoices" VALUES (6808, '', 3, '', 147130, 'A');
INSERT INTO "invoices" VALUES (6809, '', 1, '', 133175, 'Z');
INSERT INTO "invoices" VALUES (6810, '', 5, '', 123697, 'A');
INSERT INTO "invoices" VALUES (6811, '', 7, '', 79471, 'A');
INSERT INTO "invoices" VALUES (6811, '', 7, '', 103053, 'Z');
INSERT INTO "invoices" VALUES (6812, '', 1, '', 249084, 'A');
INSERT INTO "invoices" VALUES (6813, '', 5, '', 263952, 'Z');
INSERT INTO "invoices" VALUES (6814, '', 4, '', 263475, 'A');
INSERT INTO "invoices" VALUES (6815, '', 2, '', 6890, 'E');
INSERT INTO "invoices" VALUES (6815, '', 2, '', 6970, 'H');
INSERT INTO "invoices" VALUES (6815, '', 2, '', 6887, 'R');
INSERT INTO "invoices" VALUES (6815, '', 2, '', 7012, 'D');
INSERT INTO "invoices" VALUES (6815, '', 2, '', 26196, 'Z');
INSERT INTO "invoices" VALUES (6815, '', 2, '', 82540, 'A');
INSERT INTO "invoices" VALUES (6816, '', 4, '', 5923, 'H');
INSERT INTO "invoices" VALUES (6816, '', 4, '', 502440, 'A');
INSERT INTO "invoices" VALUES (6817, '', 5, '', 204992, 'A');
INSERT INTO "invoices" VALUES (6818, '', 1, '', 3749, 'H');
INSERT INTO "invoices" VALUES (6818, '', 1, '', 35293, 'A');
INSERT INTO "invoices" VALUES (6819, '', 4, '', 48990, 'D');
INSERT INTO "invoices" VALUES (6819, '', 4, '', 63459, 'R');
INSERT INTO "invoices" VALUES (6820, '', 3, '', 141820, 'Z');
INSERT INTO "invoices" VALUES (6821, '', 5, '', 94219, 'R');
INSERT INTO "invoices" VALUES (6821, '', 5, '', 147240, 'D');
INSERT INTO "invoices" VALUES (6822, '', 4, '', 52788, 'E');
INSERT INTO "invoices" VALUES (6822, '', 4, '', 66577, 'H');
INSERT INTO "invoices" VALUES (6823, '', 7, '', 206632, 'A');
INSERT INTO "invoices" VALUES (6824, '', 4, '', 81695, 'H');
INSERT INTO "invoices" VALUES (6824, '', 4, '', 159191, 'E');
INSERT INTO "invoices" VALUES (6825, '', 5, '', 445907, 'Z');
INSERT INTO "invoices" VALUES (6826, '', 5, '', 134964, 'Z');
INSERT INTO "invoices" VALUES (6827, '', 6, '', 193538, 'A');
INSERT INTO "invoices" VALUES (6828, '', 6, '', 125357, 'D');
INSERT INTO "invoices" VALUES (6829, '', 1, '', 12330, 'Z');
INSERT INTO "invoices" VALUES (6829, '', 1, '', 117813, 'A');
INSERT INTO "invoices" VALUES (6830, '', 3, '', 123582, 'A');
INSERT INTO "invoices" VALUES (6831, '', 1, '', 134081, 'A');
INSERT INTO "invoices" VALUES (6832, '', 6, '', 174166, 'Z');
INSERT INTO "invoices" VALUES (6833, '', 4, '', 296380, 'Z');
INSERT INTO "invoices" VALUES (6834, '', 2, '', 254723, 'A');
INSERT INTO "invoices" VALUES (6835, '', 1, '', 312834, 'A');
INSERT INTO "invoices" VALUES (6836, '', 7, '', 2499, 'D');
INSERT INTO "invoices" VALUES (6836, '', 7, '', 149337, 'Z');
INSERT INTO "invoices" VALUES (6837, '', 3, '', 2499, 'E');
INSERT INTO "invoices" VALUES (6837, '', 3, '', 2499, 'H');
INSERT INTO "invoices" VALUES (6837, '', 3, '', 276105, 'A');
INSERT INTO "invoices" VALUES (6838, '', 4, '', 120367, 'R');
INSERT INTO "invoices" VALUES (6839, '', 2, '', 94321, 'E');
INSERT INTO "invoices" VALUES (6839, '', 2, '', 32556, 'H');
INSERT INTO "invoices" VALUES (6840, '', 3, '', 348647, 'A');
INSERT INTO "invoices" VALUES (6841, '', 1, '', 119002, 'H');
INSERT INTO "invoices" VALUES (6841, '', 1, '', 63191, 'E');
INSERT INTO "invoices" VALUES (6842, '', 4, '', 239965, 'A');
INSERT INTO "invoices" VALUES (6843, '', 3, '', 35750, 'R');
INSERT INTO "invoices" VALUES (6843, '', 3, '', 147267, 'D');
INSERT INTO "invoices" VALUES (6844, '', 1, '', 176391, 'Z');
INSERT INTO "invoices" VALUES (6845, '', 4, '', 2392, 'H');
INSERT INTO "invoices" VALUES (6845, '', 4, '', 2534, 'R');
INSERT INTO "invoices" VALUES (6845, '', 4, '', 2416, 'D');
INSERT INTO "invoices" VALUES (6845, '', 4, '', 9845, 'Z');
INSERT INTO "invoices" VALUES (6845, '', 4, '', 60463, 'A');
INSERT INTO "invoices" VALUES (6846, '', 2, '', 158964, 'D');
INSERT INTO "invoices" VALUES (6847, '', 2, '', 141918, 'A');
INSERT INTO "invoices" VALUES (6848, '', 4, '', 137472, 'Z');
INSERT INTO "invoices" VALUES (6849, '', 4, '', 188025, 'A');
INSERT INTO "invoices" VALUES (6850, '', 4, '', 166671, 'R');
INSERT INTO "invoices" VALUES (6851, '', 1, '', 405106, 'A');
INSERT INTO "invoices" VALUES (6852, '', 2, '', 140265, 'H');
INSERT INTO "invoices" VALUES (6853, '', 4, '', 225974, 'A');
INSERT INTO "invoices" VALUES (6854, '', 5, '', 338823, 'Z');
INSERT INTO "invoices" VALUES (6855, '', 3, '', 35910, 'A');
INSERT INTO "invoices" VALUES (6856, '', 3, '', 170566, 'E');
INSERT INTO "invoices" VALUES (6857, '', 5, '', 80316, 'E');
INSERT INTO "invoices" VALUES (6857, '', 5, '', 81436, 'H');
INSERT INTO "invoices" VALUES (6858, '', 5, '', 4830, 'E');
INSERT INTO "invoices" VALUES (6858, '', 5, '', 4780, 'H');
INSERT INTO "invoices" VALUES (6858, '', 5, '', 4831, 'R');
INSERT INTO "invoices" VALUES (6858, '', 5, '', 4821, 'D');
INSERT INTO "invoices" VALUES (6858, '', 5, '', 19088, 'Z');
INSERT INTO "invoices" VALUES (6858, '', 5, '', 58169, 'A');
INSERT INTO "invoices" VALUES (6859, '', 1, '', 51151, 'D');
INSERT INTO "invoices" VALUES (6859, '', 1, '', 80628, 'R');
INSERT INTO "invoices" VALUES (6860, '', 8, '', 10788, 'R');
INSERT INTO "invoices" VALUES (6860, '', 8, '', 10897, 'D');
INSERT INTO "invoices" VALUES (6860, '', 8, '', 117763, 'Z');
INSERT INTO "invoices" VALUES (6861, '', 5, '', 4520, 'E');
INSERT INTO "invoices" VALUES (6861, '', 5, '', 4520, 'H');
INSERT INTO "invoices" VALUES (6861, '', 5, '', 139898, 'A');
INSERT INTO "invoices" VALUES (6862, '', 1, '', 169816, 'Z');
INSERT INTO "invoices" VALUES (6863, '', 2, '', 219995, 'A');
INSERT INTO "invoices" VALUES (6864, '', 1, '', 183022, 'A');
INSERT INTO "invoices" VALUES (6865, '', 5, '', 243010, 'A');
INSERT INTO "invoices" VALUES (6866, '', 3, '', 126, 'A');
INSERT INTO "invoices" VALUES (6866, '', 3, '', 119144, 'Z');
INSERT INTO "invoices" VALUES (6867, '', 4, '', 41812, 'A');
INSERT INTO "invoices" VALUES (6867, '', 4, '', 116578, 'Z');
INSERT INTO "invoices" VALUES (6868, '', 1, '', 305185, 'A');
INSERT INTO "invoices" VALUES (6869, '', 1, '', 304677, 'A');
INSERT INTO "invoices" VALUES (6870, '', 6, '', 100506, 'R');
INSERT INTO "invoices" VALUES (6870, '', 6, '', 130187, 'D');
INSERT INTO "invoices" VALUES (6871, '', 3, '', 366956, 'A');
INSERT INTO "invoices" VALUES (6872, '', 3, '', 73759, 'H');
INSERT INTO "invoices" VALUES (6872, '', 3, '', 137440, 'E');
INSERT INTO "invoices" VALUES (6873, '', 1, '', 271267, 'A');
INSERT INTO "invoices" VALUES (6874, '', 4, '', 303950, 'Z');
INSERT INTO "invoices" VALUES (6875, '', 2, '', 11690, 'E');
INSERT INTO "invoices" VALUES (6875, '', 2, '', 14954, 'H');
INSERT INTO "invoices" VALUES (6875, '', 2, '', 15305, 'R');
INSERT INTO "invoices" VALUES (6875, '', 2, '', 11277, 'D');
INSERT INTO "invoices" VALUES (6875, '', 2, '', 36919, 'Z');
INSERT INTO "invoices" VALUES (6875, '', 2, '', 97135, 'A');
INSERT INTO "invoices" VALUES (6876, '', 2, '', 164315, 'E');
INSERT INTO "invoices" VALUES (6877, '', 1, '', 165711, 'D');
INSERT INTO "invoices" VALUES (6878, '', 6, '', 140188, 'A');
INSERT INTO "invoices" VALUES (6879, '', 1, '', 201168, 'R');
INSERT INTO "invoices" VALUES (6880, '', 4, '', 4424, 'E');
INSERT INTO "invoices" VALUES (6880, '', 4, '', 4465, 'H');
INSERT INTO "invoices" VALUES (6880, '', 4, '', 4465, 'R');
INSERT INTO "invoices" VALUES (6880, '', 4, '', 4463, 'D');
INSERT INTO "invoices" VALUES (6880, '', 4, '', 120031, 'A');
INSERT INTO "invoices" VALUES (6881, '', 3, '', 188555, 'H');
INSERT INTO "invoices" VALUES (6882, '', 7, '', 494820, 'A');
INSERT INTO "invoices" VALUES (6883, '', 1, '', 339445, 'A');
INSERT INTO "invoices" VALUES (6884, '', 1, '', 438206, 'Z');
INSERT INTO "invoices" VALUES (6885, '', 6, '', 159096, 'Z');
INSERT INTO "invoices" VALUES (6886, '', 4, '', 128081, 'A');
INSERT INTO "invoices" VALUES (6887, '', 5, '', 245878, 'A');
INSERT INTO "invoices" VALUES (6888, '', 1, '', 300417, 'A');
INSERT INTO "invoices" VALUES (6889, '', 2, '', 190636, 'Z');
INSERT INTO "invoices" VALUES (6890, '', 1, '', 34444, 'Z');
INSERT INTO "invoices" VALUES (6890, '', 1, '', 56518, 'A');
INSERT INTO "invoices" VALUES (6891, '', 6, '', 72736, 'E');
INSERT INTO "invoices" VALUES (6891, '', 6, '', 78004, 'H');
INSERT INTO "invoices" VALUES (6892, '', 5, '', 189955, 'Z');
INSERT INTO "invoices" VALUES (6893, '', 1, '', 199521, 'A');
INSERT INTO "invoices" VALUES (6894, '', 1, '', 147933, 'A');
INSERT INTO "invoices" VALUES (6895, '', 1, '', 3153, 'E');
INSERT INTO "invoices" VALUES (6895, '', 1, '', 136816, 'A');
INSERT INTO "invoices" VALUES (6896, '', 4, '', 85139, 'R');
INSERT INTO "invoices" VALUES (6896, '', 4, '', 71435, 'D');
INSERT INTO "invoices" VALUES (6897, '', 2, '', 300510, 'Z');
INSERT INTO "invoices" VALUES (6898, '', 2, '', 237447, 'A');
INSERT INTO "invoices" VALUES (6899, '', 5, '', 240299, 'Z');
INSERT INTO "invoices" VALUES (6900, '', 2, '', 239866, 'A');
INSERT INTO "invoices" VALUES (6901, '', 1, '', 325332, 'A');
INSERT INTO "invoices" VALUES (6902, '', 1, '', 104009, 'Z');
INSERT INTO "invoices" VALUES (6903, '', 2, '', 104584, 'A');
INSERT INTO "invoices" VALUES (6903, '', 2, '', 4213, 'D');
INSERT INTO "invoices" VALUES (6903, '', 2, '', 4034, 'R');
INSERT INTO "invoices" VALUES (6903, '', 2, '', 4077, 'H');
INSERT INTO "invoices" VALUES (6903, '', 2, '', 3995, 'E');
INSERT INTO "invoices" VALUES (6903, '', 2, '', 16413, 'Z');
INSERT INTO "invoices" VALUES (6904, '', 2, '', 122697, 'H');
INSERT INTO "invoices" VALUES (6904, '', 2, '', 143465, 'E');
INSERT INTO "invoices" VALUES (6905, '', 1, '', 320795, 'A');
INSERT INTO "invoices" VALUES (6906, '', 2, '', 193771, 'R');
INSERT INTO "invoices" VALUES (6907, '', 4, '', 138788, 'D');
INSERT INTO "invoices" VALUES (6907, '', 4, '', 106626, 'R');
INSERT INTO "invoices" VALUES (6908, '', 3, '', 254061, 'Z');
INSERT INTO "invoices" VALUES (6909, '', 4, '', 198815, 'D');
INSERT INTO "invoices" VALUES (6910, '', 3, '', 128668, 'A');
INSERT INTO "invoices" VALUES (6911, '', 5, '', 148747, 'A');
INSERT INTO "invoices" VALUES (6912, '', 1, '', 621260, 'A');
INSERT INTO "invoices" VALUES (6913, '', 2, '', 424831, 'A');
INSERT INTO "invoices" VALUES (6914, '', 9, '', 152017, 'Z');
INSERT INTO "invoices" VALUES (6915, '', 1, '', 194408, 'H');
INSERT INTO "invoices" VALUES (6916, '', 3, '', 92466, 'A');
INSERT INTO "invoices" VALUES (6917, '', 3, '', 182651, 'E');
INSERT INTO "invoices" VALUES (6918, '', 1, '', 111574, 'Z');
INSERT INTO "invoices" VALUES (6919, '', 2, '', 476408, 'Z');
INSERT INTO "invoices" VALUES (6920, '', 2, '', 106573, 'A');
INSERT INTO "invoices" VALUES (6921, '', 1, '', 219749, 'H');
INSERT INTO "invoices" VALUES (6922, '', 2, '', 223052, 'R');
INSERT INTO "invoices" VALUES (6923, '', 4, '', 189066, 'E');
INSERT INTO "invoices" VALUES (6924, '', 3, '', 162040, 'D');
INSERT INTO "invoices" VALUES (6924, '', 3, '', 11685, 'R');
INSERT INTO "invoices" VALUES (6925, '', 1, '', 337036, 'A');
INSERT INTO "invoices" VALUES (6926, '', 1, '', 251784, 'Z');
INSERT INTO "invoices" VALUES (6927, '', 3, '', 172427, 'Z');
INSERT INTO "invoices" VALUES (6928, '', 2, '', 202526, 'A');
INSERT INTO "invoices" VALUES (6929, '', 5, '', 176186, 'R');
INSERT INTO "invoices" VALUES (6930, '', 1, '', 26880, 'A');
INSERT INTO "invoices" VALUES (6930, '', 1, '', 99525, 'Z');
INSERT INTO "invoices" VALUES (6931, '', 1, '', 137916, 'A');
INSERT INTO "invoices" VALUES (6932, '', 1, '', 142179, 'Z');
INSERT INTO "invoices" VALUES (6933, '', 6, '', 339497, 'A');
INSERT INTO "invoices" VALUES (6934, '', 1, '', 304450, 'A');
INSERT INTO "invoices" VALUES (6935, '', 3, '', 13867, 'R');
INSERT INTO "invoices" VALUES (6935, '', 3, '', 144669, 'Z');
INSERT INTO "invoices" VALUES (6935, '', 3, '', 13823, 'D');
INSERT INTO "invoices" VALUES (6936, '', 5, '', 13151, 'E');
INSERT INTO "invoices" VALUES (6936, '', 5, '', 12571, 'H');
INSERT INTO "invoices" VALUES (6936, '', 5, '', 187766, 'A');
INSERT INTO "invoices" VALUES (6937, '', 6, '', 272896, 'H');
INSERT INTO "invoices" VALUES (6938, '', 2, '', 75102, 'A');
INSERT INTO "invoices" VALUES (6939, '', 5, '', 258556, 'Z');
INSERT INTO "invoices" VALUES (6940, '', 1, '', 347080, 'A');
INSERT INTO "invoices" VALUES (6941, '', 3, '', 208017, 'R');
INSERT INTO "invoices" VALUES (6942, '', 6, '', 155996, 'A');
INSERT INTO "invoices" VALUES (6943, '', 4, '', 210538, 'E');
INSERT INTO "invoices" VALUES (6944, '', 1, '', 226547, 'D');
INSERT INTO "invoices" VALUES (6945, '', 1, '', 233639, 'A');
INSERT INTO "invoices" VALUES (6946, '', 7, '', 378975, 'Z');
INSERT INTO "invoices" VALUES (6947, '', 2, '', 232242, 'Z');
INSERT INTO "invoices" VALUES (6948, '', 6, '', 69893, 'E');
INSERT INTO "invoices" VALUES (6948, '', 6, '', 320674, 'A');
INSERT INTO "invoices" VALUES (6948, '', 6, '', 17562, 'H');
INSERT INTO "invoices" VALUES (6949, '', 4, '', 87305, 'Z');
INSERT INTO "invoices" VALUES (6950, '', 1, '', 288693, 'Z');
INSERT INTO "invoices" VALUES (6951, '', 1, '', 353806, 'A');
INSERT INTO "invoices" VALUES (6952, '', 1, '', 45711, 'E');
INSERT INTO "invoices" VALUES (6952, '', 1, '', 80645, 'H');
INSERT INTO "invoices" VALUES (6953, '', 1, '', 159266, 'R');
INSERT INTO "invoices" VALUES (6954, '', 4, '', 121192, 'A');
INSERT INTO "invoices" VALUES (6955, '', 1, '', 433070, 'A');
INSERT INTO "invoices" VALUES (6956, '', 5, '', 60425, 'D');
INSERT INTO "invoices" VALUES (6956, '', 5, '', 51232, 'R');
INSERT INTO "invoices" VALUES (6957, '', 1, '', 127392, 'Z');
INSERT INTO "invoices" VALUES (6958, '', 5, '', 213322, 'A');
INSERT INTO "invoices" VALUES (6959, '', 3, '', 155994, 'A');
INSERT INTO "invoices" VALUES (6960, '', 5, '', 13195, 'A');
INSERT INTO "invoices" VALUES (6960, '', 5, '', 189496, 'Z');
INSERT INTO "invoices" VALUES (6961, '', 5, '', 202211, 'A');
INSERT INTO "invoices" VALUES (6962, '', 1, '', 82814, 'E');
INSERT INTO "invoices" VALUES (6962, '', 1, '', 65819, 'H');
INSERT INTO "invoices" VALUES (6963, '', 5, '', 11507, 'D');
INSERT INTO "invoices" VALUES (6963, '', 5, '', 11307, 'R');
INSERT INTO "invoices" VALUES (6963, '', 5, '', 280142, 'Z');
INSERT INTO "invoices" VALUES (6964, '', 3, '', 15787, 'E');
INSERT INTO "invoices" VALUES (6964, '', 3, '', 64183, 'A');
INSERT INTO "invoices" VALUES (6964, '', 3, '', 15632, 'H');
INSERT INTO "invoices" VALUES (6965, '', 2, '', 194248, 'A');
INSERT INTO "invoices" VALUES (6966, '', 1, '', 21609, 'R');
INSERT INTO "invoices" VALUES (6966, '', 1, '', 125203, 'Z');
INSERT INTO "invoices" VALUES (6966, '', 1, '', 21749, 'D');
INSERT INTO "invoices" VALUES (6967, '', 1, '', 222637, 'A');
INSERT INTO "invoices" VALUES (6968, '', 2, '', 236699, 'D');
INSERT INTO "invoices" VALUES (6969, '', 1, '', 373432, 'A');
INSERT INTO "invoices" VALUES (6970, '', 2, '', 214767, 'R');
INSERT INTO "invoices" VALUES (6971, '', 5, '', 144277, 'A');
INSERT INTO "invoices" VALUES (6972, '', 2, '', 140221, 'A');
INSERT INTO "invoices" VALUES (6973, '', 3, '', 250483, 'E');
INSERT INTO "invoices" VALUES (6974, '', 2, '', 222758, 'H');
INSERT INTO "invoices" VALUES (6975, '', 6, '', 148143, 'Z');
INSERT INTO "invoices" VALUES (6976, '', 1, '', 372085, 'A');
INSERT INTO "invoices" VALUES (6977, '', 6, '', 135916, 'Z');
INSERT INTO "invoices" VALUES (6978, '', 3, '', 263112, 'A');
INSERT INTO "invoices" VALUES (6979, '', 2, '', 310356, 'Z');
INSERT INTO "invoices" VALUES (6980, '', 1, '', 339771, 'A');
INSERT INTO "invoices" VALUES (6981, '', 1, '', 258345, 'Z');
INSERT INTO "invoices" VALUES (6982, '', 2, '', 220162, 'A');
INSERT INTO "invoices" VALUES (6982, '', 2, '', 110081, 'Z');
INSERT INTO "invoices" VALUES (6983, '', 4, '', 148442, 'Z');
INSERT INTO "invoices" VALUES (6984, '', 3, '', 106036, 'H');
INSERT INTO "invoices" VALUES (6984, '', 3, '', 35990, 'E');
INSERT INTO "invoices" VALUES (6985, '', 1, '', 111594, 'A');
INSERT INTO "invoices" VALUES (6986, '', 10, '', 167628, 'Z');
INSERT INTO "invoices" VALUES (6987, '', 2, '', 233639, 'A');
INSERT INTO "invoices" VALUES (6988, '', 2, '', 251084, 'E');
INSERT INTO "invoices" VALUES (6989, '', 1, '', 275175, 'A');
INSERT INTO "invoices" VALUES (6990, '', 5, '', 76419, 'D');
INSERT INTO "invoices" VALUES (6990, '', 5, '', 70346, 'R');
INSERT INTO "invoices" VALUES (6991, '', 2, '', 126954, 'A');
INSERT INTO "invoices" VALUES (6992, '', 3, '', 134915, 'A');
INSERT INTO "invoices" VALUES (6993, '', 2, '', 143531, 'A');
INSERT INTO "invoices" VALUES (6994, '', 2, '', 30266, 'Z');
INSERT INTO "invoices" VALUES (6994, '', 2, '', 97937, 'A');
INSERT INTO "invoices" VALUES (6995, '', 1, '', 175845, 'A');
INSERT INTO "invoices" VALUES (6996, '', 1, '', 175354, 'A');
INSERT INTO "invoices" VALUES (6997, '', 3, '', 194592, 'Z');
INSERT INTO "invoices" VALUES (6998, '', 3, '', 248156, 'H');
INSERT INTO "invoices" VALUES (6999, '', 3, '', 368732, 'Z');
INSERT INTO "invoices" VALUES (7000, '', 6, '', 239992, 'D');
INSERT INTO "invoices" VALUES (7001, '', 3, '', 366861, 'A');
INSERT INTO "invoices" VALUES (7002, '', 1, '', 244810, 'R');
INSERT INTO "invoices" VALUES (7003, '', 1, '', 414442, 'A');
INSERT INTO "invoices" VALUES (7004, '', 4, '', 24036, 'Z');
INSERT INTO "invoices" VALUES (7004, '', 4, '', 6089, 'H');
INSERT INTO "invoices" VALUES (7004, '', 4, '', 6062, 'D');
INSERT INTO "invoices" VALUES (7004, '', 4, '', 5999, 'R');
INSERT INTO "invoices" VALUES (7004, '', 4, '', 105562, 'A');
INSERT INTO "invoices" VALUES (7004, '', 4, '', 14166, 'E');
INSERT INTO "invoices" VALUES (7005, '', 1, '', 432221, 'A');
INSERT INTO "invoices" VALUES (7006, '', 6, '', 411822, 'A');
INSERT INTO "invoices" VALUES (7007, '', 4, '', 308075, 'Z');
INSERT INTO "invoices" VALUES (7008, '', 1, '', 329590, 'Z');
INSERT INTO "invoices" VALUES (7009, '', 5, '', 124888, 'D');
INSERT INTO "invoices" VALUES (7010, '', 4, '', 63209, 'E');
INSERT INTO "invoices" VALUES (7010, '', 4, '', 58106, 'H');
INSERT INTO "invoices" VALUES (7011, '', 2, '', 435408, 'A');
INSERT INTO "invoices" VALUES (7012, '', 6, '', 218451, 'A');
INSERT INTO "invoices" VALUES (7013, '', 2, '', 153214, 'Z');
INSERT INTO "invoices" VALUES (7014, '', 3, '', 161925, 'D');
INSERT INTO "invoices" VALUES (7015, '', 2, '', 194683, 'H');
INSERT INTO "invoices" VALUES (7015, '', 2, '', 116283, 'E');
INSERT INTO "invoices" VALUES (7016, '', 1, '', 248883, 'A');
INSERT INTO "invoices" VALUES (7016, '', 1, '', 122218, 'Z');
INSERT INTO "invoices" VALUES (7017, '', 1, '', 436549, 'A');
INSERT INTO "invoices" VALUES (7018, '', 1, '', 377834, 'A');
INSERT INTO "invoices" VALUES (7019, '', 4, '', 130345, 'Z');
INSERT INTO "invoices" VALUES (7020, '', 2, '', 200704, 'A');
INSERT INTO "invoices" VALUES (7021, '', 4, '', 346856, 'A');
INSERT INTO "invoices" VALUES (7022, '', 3, '', 250426, 'Z');
INSERT INTO "invoices" VALUES (7023, '', 2, '', 122804, 'A');
INSERT INTO "invoices" VALUES (7024, '', 2, '', 383945, 'A');
INSERT INTO "invoices" VALUES (7025, '', 2, '', 114364, 'A');
INSERT INTO "invoices" VALUES (7026, '', 1, '', 62203, 'A');
INSERT INTO "invoices" VALUES (7027, '', 7, '', 156464, 'A');
INSERT INTO "invoices" VALUES (7028, '', 5, '', 330678, 'Z');
INSERT INTO "invoices" VALUES (7029, '', 2, '', 161925, 'D');
INSERT INTO "invoices" VALUES (7030, '', 1, '', 254617, 'R');
INSERT INTO "invoices" VALUES (7031, '', 1, '', 243822, 'A');
INSERT INTO "invoices" VALUES (7032, '', 4, '', 189771, 'A');
INSERT INTO "invoices" VALUES (7033, '', 1, '', 200163, 'Z');
INSERT INTO "invoices" VALUES (7034, '', 1, '', 199384, 'A');
INSERT INTO "invoices" VALUES (7035, '', 1, '', 118187, 'Z');
INSERT INTO "invoices" VALUES (7036, '', 3, '', 83450, 'Z');
INSERT INTO "invoices" VALUES (7037, '', 2, '', 231354, 'H');
INSERT INTO "invoices" VALUES (7038, '', 1, '', 53135, 'A');
INSERT INTO "invoices" VALUES (7039, '', 2, '', 187807, 'Z');
INSERT INTO "invoices" VALUES (7040, '', 2, '', 33638, 'E');
INSERT INTO "invoices" VALUES (7040, '', 2, '', 33853, 'H');
INSERT INTO "invoices" VALUES (7040, '', 2, '', 137984, 'A');
INSERT INTO "invoices" VALUES (7041, '', 2, '', 324496, 'A');
INSERT INTO "invoices" VALUES (7042, '', 7, '', 258344, 'E');
INSERT INTO "invoices" VALUES (7043, '', 2, '', 163407, 'A');
INSERT INTO "invoices" VALUES (7044, '', 7, '', 233890, 'H');
INSERT INTO "invoices" VALUES (7045, '', 7, '', 176006, 'D');
INSERT INTO "invoices" VALUES (7046, '', 2, '', 164166, 'A');
INSERT INTO "invoices" VALUES (7047, '', 3, '', 54985, 'A');
INSERT INTO "invoices" VALUES (7048, '', 2, '', 223379, 'A');
INSERT INTO "invoices" VALUES (7049, '', 3, '', 257855, 'Z');
INSERT INTO "invoices" VALUES (7050, '', 6, '', 168170, 'Z');
INSERT INTO "invoices" VALUES (7051, '', 3, '', 164326, 'R');
INSERT INTO "invoices" VALUES (7052, '', 2, '', 309640, 'A');
INSERT INTO "invoices" VALUES (7053, '', 3, '', 384962, 'A');
INSERT INTO "invoices" VALUES (7054, '', 5, '', 191679, 'D');
INSERT INTO "invoices" VALUES (7054, '', 5, '', 191679, 'R');
INSERT INTO "invoices" VALUES (7055, '', 3, '', 379078, 'Z');
INSERT INTO "invoices" VALUES (7056, '', 6, '', 393732, 'A');
INSERT INTO "invoices" VALUES (7057, '', 1, '', 365244, 'A');
INSERT INTO "invoices" VALUES (7057, '', 1, '', 4130, 'E');
INSERT INTO "invoices" VALUES (7058, '', 1, '', 120966, 'Z');
INSERT INTO "invoices" VALUES (7059, '', 1, '', 329886, 'A');
INSERT INTO "invoices" VALUES (7060, '', 3, '', 125515, 'R');
INSERT INTO "invoices" VALUES (7060, '', 3, '', 87523, 'D');
INSERT INTO "invoices" VALUES (7061, '', 5, '', 124833, 'H');
INSERT INTO "invoices" VALUES (7061, '', 5, '', 127894, 'E');
INSERT INTO "invoices" VALUES (7062, '', 4, '', 348416, 'Z');
INSERT INTO "invoices" VALUES (7063, '', 3, '', 118927, 'A');
INSERT INTO "invoices" VALUES (7063, '', 3, '', 6090, 'E');
INSERT INTO "invoices" VALUES (7064, '', 6, '', 215867, 'A');
INSERT INTO "invoices" VALUES (7065, '', 6, '', 135884, 'Z');
INSERT INTO "invoices" VALUES (7065, '', 6, '', 15345, 'A');
INSERT INTO "invoices" VALUES (7065, '', 6, '', 6090, 'D');
INSERT INTO "invoices" VALUES (7066, '', 5, '', 158237, 'A');
INSERT INTO "invoices" VALUES (7067, '', 4, '', 114611, 'Z');
INSERT INTO "invoices" VALUES (7067, '', 4, '', 6090, 'R');
INSERT INTO "invoices" VALUES (7068, '', 1, '', 118809, 'A');
INSERT INTO "invoices" VALUES (7069, '', 1, '', 151244, 'A');
INSERT INTO "invoices" VALUES (7069, '', 1, '', 70, 'E');
INSERT INTO "invoices" VALUES (7069, '', 1, '', 70, 'H');
INSERT INTO "invoices" VALUES (7070, '', 4, '', 151670, 'A');
INSERT INTO "invoices" VALUES (7071, '', 1, '', 70, 'R');
INSERT INTO "invoices" VALUES (7071, '', 1, '', 70, 'D');
INSERT INTO "invoices" VALUES (7071, '', 1, '', 167990, 'Z');
INSERT INTO "invoices" VALUES (7072, '', 6, '', 142443, 'A');
INSERT INTO "invoices" VALUES (7073, '', 1, '', 12677, 'H');
INSERT INTO "invoices" VALUES (7073, '', 1, '', 84632, 'A');
INSERT INTO "invoices" VALUES (7073, '', 1, '', 13467, 'E');
INSERT INTO "invoices" VALUES (7074, '', 2, '', 150155, 'Z');
INSERT INTO "invoices" VALUES (7074, '', 2, '', 12961, 'D');
INSERT INTO "invoices" VALUES (7074, '', 2, '', 12738, 'R');
INSERT INTO "invoices" VALUES (7075, '', 2, '', 267574, 'A');
INSERT INTO "invoices" VALUES (7076, '', 4, '', 112605, 'E');
INSERT INTO "invoices" VALUES (7077, '', 4, '', 219366, 'H');
INSERT INTO "invoices" VALUES (7077, '', 4, '', 178933, 'E');
INSERT INTO "invoices" VALUES (7078, '', 2, '', 129948, 'A');
INSERT INTO "invoices" VALUES (7079, '', 3, '', 170859, 'R');
INSERT INTO "invoices" VALUES (7079, '', 3, '', 217483, 'D');
INSERT INTO "invoices" VALUES (7080, '', 2, '', 149222, 'Z');
INSERT INTO "invoices" VALUES (7081, '', 5, '', 349971, 'A');
INSERT INTO "invoices" VALUES (7082, '', 3, '', 205453, 'E');
INSERT INTO "invoices" VALUES (7082, '', 3, '', 205453, 'H');
INSERT INTO "invoices" VALUES (7083, '', 1, '', 439912, 'A');
INSERT INTO "invoices" VALUES (7084, '', 3, '', 417182, 'Z');
INSERT INTO "invoices" VALUES (7085, '', 2, '', 116483, 'D');
INSERT INTO "invoices" VALUES (7086, '', 6, '', 114086, 'R');
INSERT INTO "invoices" VALUES (7087, '', 2, '', 257883, 'Z');
INSERT INTO "invoices" VALUES (7088, '', 1, '', 165841, 'A');
INSERT INTO "invoices" VALUES (7089, '', 2, '', 115899, 'H');
INSERT INTO "invoices" VALUES (7090, '', 2, '', 525983, 'A');
INSERT INTO "invoices" VALUES (7091, '', 3, '', 152736, 'A');
INSERT INTO "invoices" VALUES (7092, '', 1, '', 2460, 'H');
INSERT INTO "invoices" VALUES (7092, '', 1, '', 162339, 'A');
INSERT INTO "invoices" VALUES (7093, '', 7, '', 2436, 'R');
INSERT INTO "invoices" VALUES (7093, '', 7, '', 94518, 'Z');
INSERT INTO "invoices" VALUES (7094, '', 2, '', 2436, 'H');
INSERT INTO "invoices" VALUES (7094, '', 2, '', 63446, 'A');
INSERT INTO "invoices" VALUES (7094, '', 2, '', 91940, 'Z');
INSERT INTO "invoices" VALUES (7095, '', 4, '', 2436, 'E');
INSERT INTO "invoices" VALUES (7095, '', 4, '', 146550, 'A');
INSERT INTO "invoices" VALUES (7096, '', 3, '', 71860, 'R');
INSERT INTO "invoices" VALUES (7096, '', 3, '', 72039, 'D');
INSERT INTO "invoices" VALUES (7096, '', 3, '', 82125, 'Z');
INSERT INTO "invoices" VALUES (7097, '', 6, '', 216321, 'Z');
INSERT INTO "invoices" VALUES (7098, '', 4, '', 59319, 'H');
INSERT INTO "invoices" VALUES (7098, '', 4, '', 61666, 'E');
INSERT INTO "invoices" VALUES (7098, '', 4, '', 74152, 'A');
INSERT INTO "invoices" VALUES (7099, '', 7, '', 329599, 'A');
INSERT INTO "invoices" VALUES (7100, '', 2, '', 319232, 'A');
INSERT INTO "invoices" VALUES (7101, '', 2, '', 166414, 'Z');
INSERT INTO "invoices" VALUES (7102, '', 2, '', 26627, 'R');
INSERT INTO "invoices" VALUES (7102, '', 2, '', 27235, 'D');
INSERT INTO "invoices" VALUES (7102, '', 2, '', 27241, 'E');
INSERT INTO "invoices" VALUES (7102, '', 2, '', 50103, 'A');
INSERT INTO "invoices" VALUES (7102, '', 2, '', 26678, 'H');
INSERT INTO "invoices" VALUES (7103, '', 3, '', 392299, 'A');
INSERT INTO "invoices" VALUES (7104, '', 7, '', 166985, 'Z');
INSERT INTO "invoices" VALUES (7105, '', 3, '', 391787, 'A');
INSERT INTO "invoices" VALUES (7106, '', 3, '', 118966, 'R');
INSERT INTO "invoices" VALUES (7107, '', 1, '', 357873, 'E');
INSERT INTO "invoices" VALUES (7108, '', 2, '', 173502, 'H');
INSERT INTO "invoices" VALUES (7109, '', 1, '', 473329, 'Z');
INSERT INTO "invoices" VALUES (7110, '', 3, '', 274849, 'D');
INSERT INTO "invoices" VALUES (7111, '', 1, '', 439274, 'Z');
INSERT INTO "invoices" VALUES (7112, '', 1, '', 440459, 'A');
INSERT INTO "invoices" VALUES (7113, '', 4, '', 445907, 'D');
INSERT INTO "invoices" VALUES (7114, '', 3, '', 431903, 'A');
INSERT INTO "invoices" VALUES (7115, '', 2, '', 131765, 'A');
INSERT INTO "invoices" VALUES (7116, '', 4, '', 130537, 'A');
INSERT INTO "invoices" VALUES (7117, '', 3, '', 534565, 'A');
INSERT INTO "invoices" VALUES (7118, '', 2, '', 107213, 'Z');
INSERT INTO "invoices" VALUES (7119, '', 3, '', 126370, 'A');
INSERT INTO "invoices" VALUES (7120, '', 3, '', 540436, 'Z');
INSERT INTO "invoices" VALUES (7121, '', 5, '', 324291, 'A');
INSERT INTO "invoices" VALUES (7122, '', 1, '', 309819, 'R');
INSERT INTO "invoices" VALUES (7123, '', 2, '', 340240, 'A');
INSERT INTO "invoices" VALUES (7124, '', 2, '', 417514, 'Z');
INSERT INTO "invoices" VALUES (7125, '', 2, '', 245663, 'H');
INSERT INTO "invoices" VALUES (7126, '', 4, '', 102934, 'Z');
INSERT INTO "invoices" VALUES (7126, '', 4, '', 207594, 'A');
INSERT INTO "invoices" VALUES (7127, '', 7, '', 48139, 'Z');
INSERT INTO "invoices" VALUES (7127, '', 7, '', 157339, 'A');
INSERT INTO "invoices" VALUES (7128, '', 2, '', 115153, 'A');
INSERT INTO "invoices" VALUES (7129, '', 1, '', 115602, 'A');
INSERT INTO "invoices" VALUES (7130, '', 1, '', 264363, 'A');
INSERT INTO "invoices" VALUES (7131, '', 3, '', 525755, 'A');
INSERT INTO "invoices" VALUES (7132, '', 4, '', 499637, 'E');
INSERT INTO "invoices" VALUES (7133, '', 4, '', 497035, 'Z');
INSERT INTO "invoices" VALUES (7134, '', 1, '', 246115, 'A');
INSERT INTO "invoices" VALUES (7135, '', 1, '', 217731, 'Z');
INSERT INTO "invoices" VALUES (7136, '', 1, '', 223131, 'E');
INSERT INTO "invoices" VALUES (7137, '', 2, '', 333255, 'D');
INSERT INTO "invoices" VALUES (7138, '', 2, '', 427213, 'A');
INSERT INTO "invoices" VALUES (7139, '', 2, '', 89289, 'H');
INSERT INTO "invoices" VALUES (7140, '', 1, '', 358841, 'A');
INSERT INTO "invoices" VALUES (7141, '', 2, '', 353395, 'R');
INSERT INTO "invoices" VALUES (7142, '', 1, '', 313545, 'A');
INSERT INTO "invoices" VALUES (7143, '', 5, '', 133707, 'Z');
INSERT INTO "invoices" VALUES (7144, '', 1, '', 156695, 'A');
INSERT INTO "invoices" VALUES (7145, '', 6, '', 98838, 'Z');
INSERT INTO "invoices" VALUES (7146, '', 2, '', 143003, 'A');
INSERT INTO "invoices" VALUES (7147, '', 1, '', 123436, 'A');
INSERT INTO "invoices" VALUES (7149, '', 4, '', 132613, 'A');
INSERT INTO "invoices" VALUES (7150, '', 3, '', NULL, 'R');
INSERT INTO "invoices" VALUES (7150, '', 3, '', 125782, 'Z');
INSERT INTO "invoices" VALUES (7150, '', 3, '', NULL, 'D');
INSERT INTO "invoices" VALUES (7151, '', 3, '', 339899, 'A');
INSERT INTO "invoices" VALUES (7152, '', 6, '', 150684, 'R');
INSERT INTO "invoices" VALUES (7153, '', 4, '', 339517, 'A');
INSERT INTO "invoices" VALUES (7154, '', 2, '', 234173, 'Z');
INSERT INTO "invoices" VALUES (7155, '', 3, '', 490835, 'A');
INSERT INTO "invoices" VALUES (7156, '', 3, '', 351978, 'H');
INSERT INTO "invoices" VALUES (7157, '', 1, '', 232177, 'D');
INSERT INTO "invoices" VALUES (7158, '', 1, '', 491458, 'A');
INSERT INTO "invoices" VALUES (7160, '', 2, '', 468875, 'A');
INSERT INTO "invoices" VALUES (7161, '', 3, '', 497100, 'Z');
INSERT INTO "invoices" VALUES (7163, '', 1, '', NULL, 'D');
INSERT INTO "invoices" VALUES (7163, '', 1, '', 492786, 'R');
INSERT INTO "invoices" VALUES (7164, '', 1, '', 552499, 'Z');
INSERT INTO "invoices" VALUES (7165, '', 5, '', 121022, 'A');
INSERT INTO "invoices" VALUES (7166, '', 1, '', 166771, 'Z');
INSERT INTO "invoices" VALUES (7167, '', 4, '', 120731, 'A');
INSERT INTO "invoices" VALUES (7168, '', 1, '', 162842, 'A');
INSERT INTO "invoices" VALUES (7169, '', 5, '', 184357, 'A');
INSERT INTO "invoices" VALUES (7170, '', 4, '', 141243, 'Z');
INSERT INTO "invoices" VALUES (7171, '', 3, '', NULL, 'D');
INSERT INTO "invoices" VALUES (7171, '', 3, '', 110351, 'R');
INSERT INTO "invoices" VALUES (7172, '', 4, '', NULL, 'E');
INSERT INTO "invoices" VALUES (7172, '', 4, '', 142276, 'H');
INSERT INTO "invoices" VALUES (7174, '', 2, '', 147067, 'A');
INSERT INTO "invoices" VALUES (7175, '', 1, '', 204488, 'A');
INSERT INTO "invoices" VALUES (7176, '', 1, '', 120355, 'A');
INSERT INTO "invoices" VALUES (7177, '', 1, '', 179326, 'A');
INSERT INTO "invoices" VALUES (7178, '', 2, '', 94405, 'H');
INSERT INTO "invoices" VALUES (7179, '', 1, '', 13370, 'H');
INSERT INTO "invoices" VALUES (7179, '', 1, '', 137157, 'E');
INSERT INTO "invoices" VALUES (7180, '', 1, '', 295981, 'A');
INSERT INTO "invoices" VALUES (7181, '', 1, '', 183740, 'Z');
INSERT INTO "invoices" VALUES (7182, '', 5, '', 156190, 'R');
INSERT INTO "invoices" VALUES (7183, '', 1, '', 127556, 'D');
INSERT INTO "invoices" VALUES (7184, '', 3, '', 207175, 'Z');
INSERT INTO "invoices" VALUES (7185, '', 3, '', 198399, 'A');
INSERT INTO "invoices" VALUES (7186, '', 1, '', 247825, 'A');
INSERT INTO "invoices" VALUES (7187, '', 3, '', 139005, 'A');
INSERT INTO "invoices" VALUES (7188, '', 3, '', 101722, 'D');
INSERT INTO "invoices" VALUES (7189, '', 2, '', 1322, 'H');
INSERT INTO "invoices" VALUES (7189, '', 2, '', 98977, 'E');
INSERT INTO "invoices" VALUES (7190, '', 3, '', 689, 'H');
INSERT INTO "invoices" VALUES (7190, '', 3, '', 689, 'D');
INSERT INTO "invoices" VALUES (7190, '', 3, '', 689, 'R');
INSERT INTO "invoices" VALUES (7190, '', 3, '', 90325, 'A');
INSERT INTO "invoices" VALUES (7190, '', 3, '', 689, 'E');
INSERT INTO "invoices" VALUES (7191, '', 5, '', 135263, 'Z');
INSERT INTO "invoices" VALUES (7192, '', 3, '', 734147, 'A');
INSERT INTO "invoices" VALUES (7193, '', 3, '', 732555, 'Z');
INSERT INTO "invoices" VALUES (7194, '', 2, '', 96230, 'R');
INSERT INTO "invoices" VALUES (7195, '', 4, '', 135584, 'A');
INSERT INTO "invoices" VALUES (7196, '', 2, '', 139975, 'Z');
INSERT INTO "invoices" VALUES (7197, '', 4, '', 143151, 'A');
INSERT INTO "invoices" VALUES (7198, '', 3, '', 461822, 'A');
INSERT INTO "invoices" VALUES (7199, '', 2, '', 124279, 'A');
INSERT INTO "invoices" VALUES (7200, '', 8, '', 444313, 'Z');
INSERT INTO "invoices" VALUES (7202, '', 1, '', 444313, 'H');
INSERT INTO "invoices" VALUES (7204, '', 2, '', 119138, 'R');
INSERT INTO "invoices" VALUES (7204, '', 2, '', 1470, 'D');
INSERT INTO "invoices" VALUES (7205, '', 2, '', 197723, 'A');
INSERT INTO "invoices" VALUES (7206, '', 2, '', 249278, 'A');
INSERT INTO "invoices" VALUES (7207, '', 3, '', 126245, 'A');
INSERT INTO "invoices" VALUES (7207, '', 3, '', 49298, 'Z');
INSERT INTO "invoices" VALUES (7208, '', 2, '', 204512, 'A');
INSERT INTO "invoices" VALUES (7209, '', 5, '', 18006, 'R');
INSERT INTO "invoices" VALUES (7209, '', 5, '', 83145, 'D');
INSERT INTO "invoices" VALUES (7210, '', 5, '', 1455, 'E');
INSERT INTO "invoices" VALUES (7210, '', 5, '', 90203, 'H');
INSERT INTO "invoices" VALUES (7211, '', 2, '', 148010, 'Z');
INSERT INTO "invoices" VALUES (7212, '', 1, '', 116303, 'E');
INSERT INTO "invoices" VALUES (7213, '', 1, '', 230612, 'A');
INSERT INTO "invoices" VALUES (7214, '', 3, '', 116028, 'A');
INSERT INTO "invoices" VALUES (7215, '', 3, '', 131361, 'A');
INSERT INTO "invoices" VALUES (7216, '', 4, '', 39633, 'Z');
INSERT INTO "invoices" VALUES (7216, '', 4, '', 248194, 'A');
INSERT INTO "invoices" VALUES (7217, '', 6, '', 4879, 'D');
INSERT INTO "invoices" VALUES (7217, '', 6, '', 118684, 'A');
INSERT INTO "invoices" VALUES (7217, '', 6, '', 4872, 'H');
INSERT INTO "invoices" VALUES (7217, '', 6, '', 4872, 'E');
INSERT INTO "invoices" VALUES (7217, '', 6, '', 4872, 'R');
INSERT INTO "invoices" VALUES (7218, '', 5, '', 208821, 'Z');
INSERT INTO "invoices" VALUES (7219, '', 3, '', 33050, 'A');
INSERT INTO "invoices" VALUES (7219, '', 3, '', 100979, 'E');
INSERT INTO "invoices" VALUES (7219, '', 3, '', 382, 'H');
INSERT INTO "invoices" VALUES (7220, '', 1, '', 308220, 'A');
INSERT INTO "invoices" VALUES (7221, '', 1, '', 746530, 'A');
INSERT INTO "invoices" VALUES (7222, '', 4, '', 642945, 'Z');
INSERT INTO "invoices" VALUES (7223, '', 2, '', 194569, 'R');
INSERT INTO "invoices" VALUES (7223, '', 2, '', 207650, 'D');
INSERT INTO "invoices" VALUES (7224, '', 1, '', 593069, 'A');
INSERT INTO "invoices" VALUES (7225, '', 2, '', 151405, 'Z');
INSERT INTO "invoices" VALUES (7226, '', 1, '', 395914, 'A');
INSERT INTO "invoices" VALUES (7227, '', 1, '', 401058, 'A');
INSERT INTO "invoices" VALUES (7228, '', 6, '', 242303, 'A');
INSERT INTO "invoices" VALUES (7229, '', 1, '', 307552, 'A');
INSERT INTO "invoices" VALUES (7230, '', 2, '', 281539, 'A');
INSERT INTO "invoices" VALUES (7231, '', 1, '', 185694, 'Z');
INSERT INTO "invoices" VALUES (7232, '', 1, '', 6142, 'D');
INSERT INTO "invoices" VALUES (7232, '', 1, '', 31887, 'A');
INSERT INTO "invoices" VALUES (7232, '', 1, '', 122594, 'H');
INSERT INTO "invoices" VALUES (7233, '', 1, '', 232944, 'A');
INSERT INTO "invoices" VALUES (7234, '', 1, '', 6142, 'R');
INSERT INTO "invoices" VALUES (7234, '', 1, '', 24432, 'A');
INSERT INTO "invoices" VALUES (7234, '', 1, '', 161304, 'E');
INSERT INTO "invoices" VALUES (7235, '', 1, '', 63472, 'A');
INSERT INTO "invoices" VALUES (7235, '', 1, '', 292918, 'D');
INSERT INTO "invoices" VALUES (7236, '', 2, '', 563312, 'Z');
INSERT INTO "invoices" VALUES (7237, '', 1, '', 602523, 'A');
INSERT INTO "invoices" VALUES (7238, '', 4, '', 234812, 'Z');
INSERT INTO "invoices" VALUES (7238, '', 4, '', 73015, 'A');
INSERT INTO "invoices" VALUES (7239, '', 1, '', 882989, 'A');
INSERT INTO "invoices" VALUES (7240, '', 3, '', 768254, 'R');
INSERT INTO "invoices" VALUES (7241, '', 2, '', 160246, 'A');
INSERT INTO "invoices" VALUES (7241, '', 2, '', 1889, 'Z');
INSERT INTO "invoices" VALUES (7242, '', 4, '', 161188, 'Z');
INSERT INTO "invoices" VALUES (7243, '', 3, '', 166139, 'A');
INSERT INTO "invoices" VALUES (7244, '', 1, '', 143088, 'A');
INSERT INTO "invoices" VALUES (7244, '', 1, '', 442, 'R');
INSERT INTO "invoices" VALUES (7244, '', 1, '', 442, 'E');
INSERT INTO "invoices" VALUES (7244, '', 1, '', 442, 'H');
INSERT INTO "invoices" VALUES (7244, '', 1, '', 382, 'D');
INSERT INTO "invoices" VALUES (7244, '', 1, '', 834, 'Z');
INSERT INTO "invoices" VALUES (7245, '', 2, '', 81703, 'A');
INSERT INTO "invoices" VALUES (7246, '', 1, '', 219841, 'A');
INSERT INTO "invoices" VALUES (7247, '', 1, '', 228140, 'A');
INSERT INTO "invoices" VALUES (7248, '', 6, '', 180555, 'D');
INSERT INTO "invoices" VALUES (7249, '', 1, '', 437077, 'A');
INSERT INTO "invoices" VALUES (7250, '', 3, '', 255551, 'A');
INSERT INTO "invoices" VALUES (7251, '', 2, '', 239891, 'A');
INSERT INTO "invoices" VALUES (7251, '', 2, '', 101465, 'Z');
INSERT INTO "invoices" VALUES (7252, '', 1, '', 301396, 'Z');
INSERT INTO "invoices" VALUES (7253, '', 3, '', 30579, 'H');
INSERT INTO "invoices" VALUES (7253, '', 3, '', 80021, 'E');
INSERT INTO "invoices" VALUES (7254, '', 1, '', 347952, 'Z');
INSERT INTO "invoices" VALUES (7255, '', 4, '', 453685, 'A');
INSERT INTO "invoices" VALUES (7256, '', 2, '', 151556, 'R');
INSERT INTO "invoices" VALUES (7256, '', 2, '', 79588, 'D');
INSERT INTO "invoices" VALUES (7258, '', 2, '', 131890, 'A');
INSERT INTO "invoices" VALUES (7259, '', 5, '', 1331, 'A');
INSERT INTO "invoices" VALUES (7259, '', 5, '', 171587, 'Z');
INSERT INTO "invoices" VALUES (7260, '', 4, '', 84384, 'H');
INSERT INTO "invoices" VALUES (7260, '', 4, '', 123679, 'E');
INSERT INTO "invoices" VALUES (7261, '', 1, '', 610498, 'A');
INSERT INTO "invoices" VALUES (7262, '', 1, '', 222885, 'H');
INSERT INTO "invoices" VALUES (7262, '', 1, '', 394749, 'E');
INSERT INTO "invoices" VALUES (7263, '', 2, '', 4872, 'H');
INSERT INTO "invoices" VALUES (7263, '', 2, '', 4872, 'E');
INSERT INTO "invoices" VALUES (7263, '', 2, '', 4872, 'D');
INSERT INTO "invoices" VALUES (7263, '', 2, '', 4872, 'R');
INSERT INTO "invoices" VALUES (7263, '', 2, '', 25640, 'Z');
INSERT INTO "invoices" VALUES (7263, '', 2, '', 50004, 'A');
INSERT INTO "invoices" VALUES (7264, '', 1, '', 46265, 'E');
INSERT INTO "invoices" VALUES (7264, '', 1, '', 729843, 'A');
INSERT INTO "invoices" VALUES (7265, '', 4, '', 149900, 'A');
INSERT INTO "invoices" VALUES (7265, '', 4, '', 649717, 'E');
INSERT INTO "invoices" VALUES (7266, '', 3, '', 166459, 'A');
INSERT INTO "invoices" VALUES (7267, '', 3, '', 172904, 'Z');
INSERT INTO "invoices" VALUES (7268, '', 2, '', 204181, 'A');
INSERT INTO "invoices" VALUES (7269, '', 2, '', 317330, 'H');
INSERT INTO "invoices" VALUES (7269, '', 2, '', 15300, 'A');
INSERT INTO "invoices" VALUES (7269, '', 2, '', 2887, 'E');
INSERT INTO "invoices" VALUES (7270, '', 1, '', 206994, 'A');
INSERT INTO "invoices" VALUES (7271, '', 2, '', 212938, 'H');
INSERT INTO "invoices" VALUES (7272, '', 1, '', 172519, 'D');
INSERT INTO "invoices" VALUES (7273, '', 2, '', 151573, 'R');
INSERT INTO "invoices" VALUES (7274, '', 3, '', 212281, 'Z');
INSERT INTO "invoices" VALUES (7275, '', 2, '', 124010, 'E');
INSERT INTO "invoices" VALUES (7276, '', 4, '', 206623, 'A');
INSERT INTO "invoices" VALUES (7277, '', 1, '', 417198, 'A');
INSERT INTO "invoices" VALUES (7278, '', 1, '', 394592, 'Z');
INSERT INTO "invoices" VALUES (7279, '', 2, '', 543207, 'A');
INSERT INTO "invoices" VALUES (7280, '', 1, '', 579392, 'Z');
INSERT INTO "invoices" VALUES (7281, '', 1, '', 394049, 'R');
INSERT INTO "invoices" VALUES (7281, '', 1, '', NULL, 'D');
INSERT INTO "invoices" VALUES (7282, '', 3, '', 207608, 'A');
INSERT INTO "invoices" VALUES (7283, '', 5, '', 218961, 'A');
INSERT INTO "invoices" VALUES (7284, '', 1, '', 172517, 'A');
INSERT INTO "invoices" VALUES (7285, '', 3, '', 241232, 'Z');
INSERT INTO "invoices" VALUES (7286, '', 2, '', 828613, 'Z');
INSERT INTO "invoices" VALUES (7287, '', 1, '', 858153, 'A');
INSERT INTO "invoices" VALUES (7288, '', 2, '', 774309, 'A');
INSERT INTO "invoices" VALUES (7289, '', 2, '', 528497, 'A');
INSERT INTO "invoices" VALUES (7290, '', 4, '', 409517, 'Z');
INSERT INTO "invoices" VALUES (7291, '', 2, '', 534637, 'A');
INSERT INTO "invoices" VALUES (7292, '', 1, '', 831257, 'D');
INSERT INTO "invoices" VALUES (7292, '', 1, '', 61266, 'A');
INSERT INTO "invoices" VALUES (7292, '', 1, '', 25910, 'Z');
INSERT INTO "invoices" VALUES (7293, '', 5, '', 157785, 'A');
INSERT INTO "invoices" VALUES (7294, '', 2, '', 81749, 'Z');
INSERT INTO "invoices" VALUES (7295, '', 1, '', 339086, 'H');
INSERT INTO "invoices" VALUES (7296, '', 4, '', 313491, 'A');
INSERT INTO "invoices" VALUES (7297, '', 1, '', 141215, 'D');
INSERT INTO "invoices" VALUES (7297, '', 1, '', 36180, 'R');
INSERT INTO "invoices" VALUES (7298, '', 1, '', 326942, 'A');
INSERT INTO "invoices" VALUES (7299, '', 1, '', 227134, 'Z');
INSERT INTO "invoices" VALUES (7300, '', 1, '', 68698, 'H');
INSERT INTO "invoices" VALUES (7300, '', 1, '', 170000, 'E');
INSERT INTO "invoices" VALUES (7300, '', 1, '', 7860, 'A');
INSERT INTO "invoices" VALUES (7301, '', 2, '', 706654, 'A');
INSERT INTO "invoices" VALUES (7302, '', 1, '', 569112, 'A');
INSERT INTO "invoices" VALUES (7303, '', 3, '', 197457, 'A');
INSERT INTO "invoices" VALUES (7304, '', 1, '', 252718, 'A');
INSERT INTO "invoices" VALUES (7304, '', 1, '', 3003, 'Z');
INSERT INTO "invoices" VALUES (7305, '', 1, '', 17256, 'A');
INSERT INTO "invoices" VALUES (7305, '', 1, '', 229560, 'Z');
INSERT INTO "invoices" VALUES (7306, '', 3, '', 621167, 'Z');
INSERT INTO "invoices" VALUES (7307, '', 2, '', 794686, 'H');
INSERT INTO "invoices" VALUES (7307, '', 2, '', 254113, 'E');
INSERT INTO "invoices" VALUES (7308, '', 2, '', 1079964, 'A');
INSERT INTO "invoices" VALUES (7309, '', 1, '', 189847, 'A');
INSERT INTO "invoices" VALUES (7309, '', 1, '', 94743, 'Z');
INSERT INTO "invoices" VALUES (7310, '', 1, '', 360705, 'Z');
INSERT INTO "invoices" VALUES (7310, '', 1, '', 448682, 'R');
INSERT INTO "invoices" VALUES (7311, '', 2, '', 506797, 'A');
INSERT INTO "invoices" VALUES (7312, '', 2, '', 4359, 'R');
INSERT INTO "invoices" VALUES (7312, '', 2, '', 4381, 'D');
INSERT INTO "invoices" VALUES (7312, '', 2, '', 491572, 'Z');
INSERT INTO "invoices" VALUES (7313, '', 1, '', 1129, 'A');
INSERT INTO "invoices" VALUES (7313, '', 1, '', 39272, 'H');
INSERT INTO "invoices" VALUES (7313, '', 1, '', 152693, 'E');
INSERT INTO "invoices" VALUES (7314, '', 3, '', 152122, 'R');
INSERT INTO "invoices" VALUES (7315, '', 1, '', 12444, 'A');
INSERT INTO "invoices" VALUES (7316, '', 2, '', 154379, 'A');
INSERT INTO "invoices" VALUES (7317, '', 1, '', 428961, 'A');
INSERT INTO "invoices" VALUES (7317, '', 1, '', 3672, 'D');
INSERT INTO "invoices" VALUES (7318, '', 1, '', 130736, 'H');
INSERT INTO "invoices" VALUES (7319, '', 2, '', 218537, 'D');
INSERT INTO "invoices" VALUES (7319, '', 2, '', 204, 'R');
INSERT INTO "invoices" VALUES (7320, '', 2, '', 328011, 'A');
INSERT INTO "invoices" VALUES (7321, '', 5, '', 171786, 'Z');
INSERT INTO "invoices" VALUES (7322, '', 4, '', 8568, 'D');
INSERT INTO "invoices" VALUES (7322, '', 4, '', 132652, 'H');
INSERT INTO "invoices" VALUES (7322, '', 4, '', 438, 'E');
INSERT INTO "invoices" VALUES (7322, '', 4, '', 77630, 'A');
INSERT INTO "invoices" VALUES (7323, '', 2, '', 515, 'D');
INSERT INTO "invoices" VALUES (7323, '', 2, '', 515, 'R');
INSERT INTO "invoices" VALUES (7323, '', 2, '', 45, 'H');
INSERT INTO "invoices" VALUES (7323, '', 2, '', 4139, 'A');
INSERT INTO "invoices" VALUES (7323, '', 2, '', 194178, 'E');
INSERT INTO "invoices" VALUES (7323, '', 2, '', 607, 'Z');
INSERT INTO "invoices" VALUES (7324, '', 1, '', 256247, 'R');
INSERT INTO "invoices" VALUES (7326, '', 3, '', 170211, 'A');
INSERT INTO "invoices" VALUES (7327, '', 2, '', 168780, 'Z');
INSERT INTO "invoices" VALUES (7327, '', 2, '', 18327, 'A');
INSERT INTO "invoices" VALUES (7328, '', 3, '', 2579, 'Z');
INSERT INTO "invoices" VALUES (7328, '', 3, '', 169632, 'A');
INSERT INTO "invoices" VALUES (7329, '', 1, '', 775154, 'A');
INSERT INTO "invoices" VALUES (7330, '', 3, '', 436510, 'A');
INSERT INTO "invoices" VALUES (7331, '', 2, '', 559606, 'Z');
INSERT INTO "invoices" VALUES (7331, '', 2, '', 12240, 'R');
INSERT INTO "invoices" VALUES (7332, '', 1, '', 313402, 'E');
INSERT INTO "invoices" VALUES (7332, '', 1, '', 17944, 'D');
INSERT INTO "invoices" VALUES (7332, '', 1, '', 17944, 'R');
INSERT INTO "invoices" VALUES (7333, '', 1, '', 276761, 'A');
INSERT INTO "invoices" VALUES (7333, '', 1, '', 138652, 'Z');
INSERT INTO "invoices" VALUES (7334, '', 2, '', 749010, 'A');
INSERT INTO "invoices" VALUES (7335, '', 4, '', 687511, 'Z');
INSERT INTO "invoices" VALUES (7336, '', 3, '', 111718, 'Z');
INSERT INTO "invoices" VALUES (7336, '', 3, '', 209314, 'A');
INSERT INTO "invoices" VALUES (7337, '', 3, '', 341386, 'H');
INSERT INTO "invoices" VALUES (7337, '', 3, '', 895, 'A');
INSERT INTO "invoices" VALUES (7337, '', 3, '', 57104, 'E');
INSERT INTO "invoices" VALUES (7338, '', 2, '', 184953, 'D');
INSERT INTO "invoices" VALUES (7339, '', 2, '', 204578, 'R');
INSERT INTO "invoices" VALUES (7340, '', 2, '', 213160, 'E');
INSERT INTO "invoices" VALUES (7341, '', 1, '', 348987, 'A');
INSERT INTO "invoices" VALUES (7342, '', 3, '', 267954, 'A');
INSERT INTO "invoices" VALUES (7343, '', 1, '', 5100, 'E');
INSERT INTO "invoices" VALUES (7343, '', 1, '', 232845, 'H');
INSERT INTO "invoices" VALUES (7344, '', 1, '', 273029, 'A');
INSERT INTO "invoices" VALUES (7345, '', 2, '', 287653, 'Z');
INSERT INTO "invoices" VALUES (7346, '', 2, '', 213566, 'A');
INSERT INTO "invoices" VALUES (7347, '', 5, '', 713811, 'A');
INSERT INTO "invoices" VALUES (7348, '', 3, '', 629675, 'A');
INSERT INTO "invoices" VALUES (7349, '', 1, '', 723277, 'Z');
INSERT INTO "invoices" VALUES (7350, '', 1, '', 84070, 'A');
INSERT INTO "invoices" VALUES (7350, '', 1, '', 197387, 'Z');
INSERT INTO "invoices" VALUES (7351, '', 4, '', 309697, 'A');
INSERT INTO "invoices" VALUES (7352, '', 2, '', 732297, 'D');
INSERT INTO "invoices" VALUES (7353, '', 3, '', 311038, 'E');
INSERT INTO "invoices" VALUES (7354, '', 1, '', 295163, 'D');
INSERT INTO "invoices" VALUES (7354, '', 1, '', 17269, 'R');
INSERT INTO "invoices" VALUES (7355, '', 1, '', 337618, 'A');
INSERT INTO "invoices" VALUES (7356, '', 3, '', 113414, 'A');
INSERT INTO "invoices" VALUES (7356, '', 3, '', 193349, 'Z');
INSERT INTO "invoices" VALUES (7357, '', 4, '', 286850, 'A');
INSERT INTO "invoices" VALUES (7357, '', 4, '', 6623, 'Z');
INSERT INTO "invoices" VALUES (7358, '', 2, '', 405722, 'Z');
INSERT INTO "invoices" VALUES (7359, '', 1, '', 890031, 'H');
INSERT INTO "invoices" VALUES (7361, '', 1, '', 945305, 'R');
INSERT INTO "invoices" VALUES (7362, '', 6, '', 516, 'H');
INSERT INTO "invoices" VALUES (7362, '', 6, '', 516, 'E');
INSERT INTO "invoices" VALUES (7362, '', 6, '', 516, 'D');
INSERT INTO "invoices" VALUES (7362, '', 6, '', 516, 'R');
INSERT INTO "invoices" VALUES (7362, '', 6, '', 916, 'A');
INSERT INTO "invoices" VALUES (7362, '', 6, '', 189474, 'Z');
INSERT INTO "invoices" VALUES (7363, '', 2, '', 46092, 'A');
INSERT INTO "invoices" VALUES (7364, '', 2, '', 45794, 'Z');
INSERT INTO "invoices" VALUES (7365, '', 1, '', 43387, 'E');
INSERT INTO "invoices" VALUES (7366, '', 2, '', 632129, 'A');
INSERT INTO "invoices" VALUES (7367, '', 2, '', 223316, 'H');
INSERT INTO "invoices" VALUES (7368, '', 3, '', 287494, 'A');
INSERT INTO "invoices" VALUES (7369, '', 4, '', 933170, 'A');
INSERT INTO "invoices" VALUES (7370, '', 2, '', 655, 'A');
INSERT INTO "invoices" VALUES (7371, '', 1, '', 714936, 'Z');
INSERT INTO "invoices" VALUES (7372, '', 3, '', 713137, 'E');
INSERT INTO "invoices" VALUES (7373, '', 2, '', 477967, 'A');
INSERT INTO "invoices" VALUES (7374, '', 1, '', 262428, 'A');
INSERT INTO "invoices" VALUES (7375, '', 4, '', 240711, 'Z');
INSERT INTO "invoices" VALUES (7376, '', 1, '', 71029, 'H');
INSERT INTO "invoices" VALUES (7377, '', 1, '', 158368, 'R');
INSERT INTO "invoices" VALUES (7378, '', 4, '', 355542, 'D');
INSERT INTO "invoices" VALUES (7379, '', 3, '', 201159, 'D');
INSERT INTO "invoices" VALUES (7380, '', 3, '', 435482, 'Z');
INSERT INTO "invoices" VALUES (7381, '', 1, '', 1046583, 'A');
INSERT INTO "invoices" VALUES (7382, '', 3, '', 172240, 'Z');
INSERT INTO "invoices" VALUES (7383, '', 1, '', 104543, 'A');
INSERT INTO "invoices" VALUES (7384, '', 3, '', 153223, 'Z');
INSERT INTO "invoices" VALUES (7385, '', 3, '', 174612, 'H');
INSERT INTO "invoices" VALUES (7386, '', 2, '', 226201, 'A');
INSERT INTO "invoices" VALUES (7387, '', 2, '', 193699, 'D');
INSERT INTO "invoices" VALUES (7388, '', 2, '', 310125, 'E');
INSERT INTO "invoices" VALUES (7389, '', 2, '', 837333, 'Z');
INSERT INTO "invoices" VALUES (7390, '', 1, '', 556101, 'A');
INSERT INTO "invoices" VALUES (7391, '', 1, '', 580141, 'Z');
INSERT INTO "invoices" VALUES (7392, '', 1, '', 496450, 'A');
INSERT INTO "invoices" VALUES (7393, '', 2, '', 110295, 'R');
INSERT INTO "invoices" VALUES (7394, '', 1, '', 306938, 'A');
INSERT INTO "invoices" VALUES (7395, '', 2, '', 907502, 'Z');
INSERT INTO "invoices" VALUES (7396, '', 3, '', 817246, 'A');
INSERT INTO "invoices" VALUES (7397, '', 4, '', 544122, 'A');
INSERT INTO "invoices" VALUES (7398, '', 2, '', 675055, 'A');
INSERT INTO "invoices" VALUES (7399, '', 2, '', 192561, 'E');
INSERT INTO "invoices" VALUES (7400, '', 1, '', 416, 'E');
INSERT INTO "invoices" VALUES (7400, '', 1, '', 311652, 'H');
INSERT INTO "invoices" VALUES (7401, '', 4, '', 21471, 'D');
INSERT INTO "invoices" VALUES (7401, '', 4, '', 343396, 'R');
INSERT INTO "invoices" VALUES (7402, '', 3, '', 792371, 'Z');
INSERT INTO "invoices" VALUES (7403, '', 1, '', 840235, 'D');
INSERT INTO "invoices" VALUES (7404, '', 3, '', 141266, 'A');
INSERT INTO "invoices" VALUES (7404, '', 3, '', 69077, 'Z');
INSERT INTO "invoices" VALUES (7525, '', 4, '', NULL, 'Z');
INSERT INTO "invoices" VALUES (7525, '', 4, '', 383484, 'A');
INSERT INTO "invoices" VALUES (7526, '', 5, '', 366717, 'A');
INSERT INTO "invoices" VALUES (7527, '', 4, '', 133011, 'A');
INSERT INTO "invoices" VALUES (7528, '', 2, '', 162198, 'H');
INSERT INTO "invoices" VALUES (7529, '', 1, '', 228318, 'Z');
INSERT INTO "invoices" VALUES (7530, '', 5, '', 240961, 'R');
INSERT INTO "invoices" VALUES (7531, '', 3, '', 315319, 'A');
INSERT INTO "invoices" VALUES (7532, '', 4, '', 125926, 'H');
INSERT INTO "invoices" VALUES (7533, '', 3, '', 220737, 'D');
INSERT INTO "invoices" VALUES (7534, '', 3, '', 266252, 'A');
INSERT INTO "invoices" VALUES (7535, '', 4, '', 223641, 'D');
INSERT INTO "invoices" VALUES (7536, '', 4, '', 267353, 'A');
INSERT INTO "invoices" VALUES (7537, '', 3, '', 129833, 'E');
INSERT INTO "invoices" VALUES (7538, '', 4, '', 111670, 'Z');
INSERT INTO "invoices" VALUES (7539, '', 3, '', 243538, 'R');
INSERT INTO "invoices" VALUES (7540, '', 2, '', 169978, 'Z');
INSERT INTO "invoices" VALUES (7541, '', 1, '', 442040, 'E');
INSERT INTO "invoices" VALUES (7542, '', 4, '', 444254, 'A');
INSERT INTO "invoices" VALUES (7543, '', 1, '', 12191, 'E');
INSERT INTO "invoices" VALUES (7543, '', 1, '', 12191, 'H');
INSERT INTO "invoices" VALUES (7543, '', 1, '', 12191, 'R');
INSERT INTO "invoices" VALUES (7543, '', 1, '', 12195, 'D');
INSERT INTO "invoices" VALUES (7543, '', 1, '', 158242, 'A');
INSERT INTO "invoices" VALUES (7544, '', 3, '', 207276, 'A');
INSERT INTO "invoices" VALUES (7545, '', 1, '', 472757, 'A');
INSERT INTO "invoices" VALUES (7546, '', 2, '', 521438, 'A');
INSERT INTO "invoices" VALUES (7547, '', 2, '', 578255, 'Z');
INSERT INTO "invoices" VALUES (7548, '', 3, '', 439654, 'A');
INSERT INTO "invoices" VALUES (7548, '', 3, '', 424, 'R');
INSERT INTO "invoices" VALUES (7548, '', 3, '', 424, 'D');
INSERT INTO "invoices" VALUES (7548, '', 3, '', 424, 'H');
INSERT INTO "invoices" VALUES (7548, '', 3, '', 424, 'E');
INSERT INTO "invoices" VALUES (7549, '', 2, '', 320429, 'Z');
INSERT INTO "invoices" VALUES (7550, '', 1, '', 738961, 'A');
INSERT INTO "invoices" VALUES (7551, '', 4, '', 292170, 'Z');
INSERT INTO "invoices" VALUES (7552, '', 2, '', 339674, 'A');
INSERT INTO "invoices" VALUES (7553, '', 2, '', 138919, 'A');
INSERT INTO "invoices" VALUES (7554, '', 6, '', 134640, 'R');
INSERT INTO "invoices" VALUES (7555, '', 1, '', 237887, 'A');
INSERT INTO "invoices" VALUES (7556, '', 1, '', 225550, 'R');
INSERT INTO "invoices" VALUES (7557, '', 4, '', 130476, 'E');
INSERT INTO "invoices" VALUES (7558, '', 3, '', 155778, 'H');
INSERT INTO "invoices" VALUES (7559, '', 3, '', 204367, 'Z');
INSERT INTO "invoices" VALUES (7560, '', 1, '', 267823, 'Z');
INSERT INTO "invoices" VALUES (7561, '', 3, '', 210617, 'A');
INSERT INTO "invoices" VALUES (7562, '', 2, '', 194674, 'Z');
INSERT INTO "invoices" VALUES (7563, '', 3, '', 193344, 'A');
INSERT INTO "invoices" VALUES (7564, '', 2, '', 150513, 'H');
INSERT INTO "invoices" VALUES (7565, '', 4, '', 196593, 'A');
INSERT INTO "invoices" VALUES (7566, '', 4, '', 151811, 'E');
INSERT INTO "invoices" VALUES (7567, '', 6, '', 120961, 'A');
INSERT INTO "invoices" VALUES (7568, '', 1, '', 2, 'D');
INSERT INTO "invoices" VALUES (7568, '', 1, '', 243817, 'A');
INSERT INTO "invoices" VALUES (7569, '', 2, '', 242707, 'Z');
INSERT INTO "invoices" VALUES (7570, '', 4, '', 728035, 'A');
INSERT INTO "invoices" VALUES (7571, '', 2, '', 795519, 'Z');
INSERT INTO "invoices" VALUES (7572, '', 2, '', 426, 'D');
INSERT INTO "invoices" VALUES (7572, '', 2, '', 426, 'R');
INSERT INTO "invoices" VALUES (7572, '', 2, '', 323438, 'A');
INSERT INTO "invoices" VALUES (7573, '', 2, '', 249607, 'Z');
INSERT INTO "invoices" VALUES (7574, '', 5, '', 220450, 'E');
INSERT INTO "invoices" VALUES (7574, '', 5, '', 426, 'H');
INSERT INTO "invoices" VALUES (7575, '', 3, '', 9143, 'E');
INSERT INTO "invoices" VALUES (7575, '', 3, '', 9143, 'H');
INSERT INTO "invoices" VALUES (7575, '', 3, '', 9143, 'R');
INSERT INTO "invoices" VALUES (7575, '', 3, '', 277818, 'A');
INSERT INTO "invoices" VALUES (7575, '', 3, '', 9143, 'D');
INSERT INTO "invoices" VALUES (7576, '', 3, '', 300433, 'A');
INSERT INTO "invoices" VALUES (7577, '', 1, '', 641542, 'A');
INSERT INTO "invoices" VALUES (7578, '', 1, '', 637033, 'Z');
INSERT INTO "invoices" VALUES (7579, '', 2, '', 632338, 'A');
INSERT INTO "invoices" VALUES (7580, '', 2, '', 651375, 'A');
INSERT INTO "invoices" VALUES (7582, '', 2, '', 366523, 'A');
INSERT INTO "invoices" VALUES (7583, '', 4, '', 175328, 'R');
INSERT INTO "invoices" VALUES (7584, '', 2, '', 190319, 'Z');
INSERT INTO "invoices" VALUES (7585, '', 5, '', 108097, 'D');
INSERT INTO "invoices" VALUES (7586, '', 2, '', 144314, 'E');
INSERT INTO "invoices" VALUES (7587, '', 2, '', 184261, 'Z');
INSERT INTO "invoices" VALUES (7588, '', 5, '', 261595, 'A');
INSERT INTO "invoices" VALUES (7589, '', 1, '', 160116, 'H');
INSERT INTO "invoices" VALUES (7590, '', 3, '', 249424, 'A');
INSERT INTO "invoices" VALUES (7591, '', 2, '', 296123, 'Z');
INSERT INTO "invoices" VALUES (7592, '', 2, '', 498086, 'Z');
INSERT INTO "invoices" VALUES (7593, '', 4, '', 254752, 'A');
INSERT INTO "invoices" VALUES (7594, '', 1, '', 590960, 'A');
INSERT INTO "invoices" VALUES (7595, '', 1, '', 608862, 'A');
INSERT INTO "invoices" VALUES (7596, '', 2, '', 603453, 'A');
INSERT INTO "invoices" VALUES (7597, '', 1, '', 578796, 'D');
INSERT INTO "invoices" VALUES (7598, '', 2, '', 649808, 'A');
INSERT INTO "invoices" VALUES (7599, '', 3, '', 352311, 'A');
INSERT INTO "invoices" VALUES (7600, '', 3, '', 254305, 'H');
INSERT INTO "invoices" VALUES (7601, '', 3, '', 238460, 'E');
INSERT INTO "invoices" VALUES (7602, '', 1, '', 368422, 'A');
INSERT INTO "invoices" VALUES (7603, '', 2, '', 361190, 'A');
INSERT INTO "invoices" VALUES (7604, '', 3, '', 150000, 'R');
INSERT INTO "invoices" VALUES (7605, '', 4, '', 184419, 'R');
INSERT INTO "invoices" VALUES (7606, '', 5, '', 226319, 'R');
INSERT INTO "invoices" VALUES (7607, '', 3, '', 194697, 'D');
INSERT INTO "invoices" VALUES (7608, '', 4, '', 171962, 'D');
INSERT INTO "invoices" VALUES (7608, '', 4, '', 5809, 'R');
INSERT INTO "invoices" VALUES (7609, '', 4, '', 380954, 'A');
INSERT INTO "invoices" VALUES (7610, '', 2, '', 372511, 'A');
INSERT INTO "invoices" VALUES (7611, '', 2, '', 386249, 'A');
INSERT INTO "invoices" VALUES (7612, '', 1, '', 179500, 'H');
INSERT INTO "invoices" VALUES (7613, '', 3, '', 114493, 'H');
INSERT INTO "invoices" VALUES (7613, '', 3, '', 19238, 'A');
INSERT INTO "invoices" VALUES (7614, '', 3, '', 239039, 'Z');
INSERT INTO "invoices" VALUES (7615, '', 4, '', 140593, 'E');
INSERT INTO "invoices" VALUES (7616, '', 3, '', 282060, 'Z');
INSERT INTO "invoices" VALUES (7617, '', 1, '', 277424, 'Z');
INSERT INTO "invoices" VALUES (7618, '', 3, '', 486652, 'A');
INSERT INTO "invoices" VALUES (7619, '', 1, '', 757525, 'Z');
INSERT INTO "invoices" VALUES (7620, '', 1, '', 767411, 'A');
INSERT INTO "invoices" VALUES (7621, '', 2, '', 470448, 'A');
INSERT INTO "invoices" VALUES (7622, '', 3, '', 444358, 'Z');
INSERT INTO "invoices" VALUES (7623, '', 5, '', 475617, 'A');
INSERT INTO "invoices" VALUES (7624, '', 4, '', 437276, 'A');
INSERT INTO "invoices" VALUES (7624, '', 4, '', 409, 'R');
INSERT INTO "invoices" VALUES (7624, '', 4, '', 409, 'D');
INSERT INTO "invoices" VALUES (7624, '', 4, '', 409, 'E');
INSERT INTO "invoices" VALUES (7624, '', 4, '', 409, 'H');
INSERT INTO "invoices" VALUES (7625, '', 4, '', 311644, 'A');
INSERT INTO "invoices" VALUES (7626, '', 3, '', 384516, 'A');
INSERT INTO "invoices" VALUES (7627, '', 3, '', 461309, 'Z');
INSERT INTO "invoices" VALUES (7628, '', 1, '', 319912, 'Z');
INSERT INTO "invoices" VALUES (7629, '', 1, '', 104300, 'A');
INSERT INTO "invoices" VALUES (7630, '', 6, '', 26319, 'H');
INSERT INTO "invoices" VALUES (7630, '', 6, '', 109540, 'E');
INSERT INTO "invoices" VALUES (7631, '', 2, '', 122445, 'R');
INSERT INTO "invoices" VALUES (7632, '', 7, '', 104094, 'D');
INSERT INTO "invoices" VALUES (7633, '', 4, '', 186574, 'A');
INSERT INTO "invoices" VALUES (7634, '', 4, '', 115962, 'H');
INSERT INTO "invoices" VALUES (7635, '', 4, '', 227301, 'A');
INSERT INTO "invoices" VALUES (7636, '', 5, '', 215612, 'Z');
INSERT INTO "invoices" VALUES (7637, '', 3, '', 195885, 'Z');
INSERT INTO "invoices" VALUES (7638, '', 4, '', 341559, 'A');
INSERT INTO "invoices" VALUES (7639, '', 1, '', 829253, 'A');
INSERT INTO "invoices" VALUES (7640, '', 3, '', 826146, 'A');
INSERT INTO "invoices" VALUES (7641, '', 3, '', 813388, 'Z');
INSERT INTO "invoices" VALUES (7642, '', 3, '', 5693, 'A');
INSERT INTO "invoices" VALUES (7643, '', 3, '', 824318, 'Z');
INSERT INTO "invoices" VALUES (7644, '', 4, '', 418201, 'Z');
INSERT INTO "invoices" VALUES (7645, '', 3, '', 489211, 'A');
INSERT INTO "invoices" VALUES (7645, '', 3, '', 239, 'E');
INSERT INTO "invoices" VALUES (7645, '', 3, '', 239, 'H');
INSERT INTO "invoices" VALUES (7645, '', 3, '', 239, 'D');
INSERT INTO "invoices" VALUES (7645, '', 3, '', 239, 'R');
INSERT INTO "invoices" VALUES (7646, '', 3, '', 398204, 'A');
INSERT INTO "invoices" VALUES (7647, '', 2, '', 528368, 'Z');
INSERT INTO "invoices" VALUES (7647, '', 2, '', 88731, 'A');
INSERT INTO "invoices" VALUES (7648, '', 1, '', 37, 'R');
INSERT INTO "invoices" VALUES (7648, '', 1, '', 73, 'Z');
INSERT INTO "invoices" VALUES (7648, '', 1, '', 317, 'D');
INSERT INTO "invoices" VALUES (7648, '', 1, '', 4819, 'A');
INSERT INTO "invoices" VALUES (7648, '', 1, '', 59295, 'E');
INSERT INTO "invoices" VALUES (7648, '', 1, '', 37, 'H');
INSERT INTO "invoices" VALUES (7649, '', 5, '', 196204, 'E');
INSERT INTO "invoices" VALUES (7650, '', 2, '', 199654, 'D');
INSERT INTO "invoices" VALUES (7651, '', 2, '', 297273, 'A');
INSERT INTO "invoices" VALUES (7652, '', 5, '', 201906, 'Z');
INSERT INTO "invoices" VALUES (7653, '', 2, '', 313556, 'A');
INSERT INTO "invoices" VALUES (7654, '', 1, '', 287423, 'Z');
INSERT INTO "invoices" VALUES (7655, '', 3, '', 269585, 'R');
INSERT INTO "invoices" VALUES (7656, '', 4, '', 253836, 'H');
INSERT INTO "invoices" VALUES (7657, '', 3, '', 513267, 'A');
INSERT INTO "invoices" VALUES (7657, '', 3, '', 421844, 'E');
INSERT INTO "invoices" VALUES (7658, '', 2, '', 348686, 'A');
INSERT INTO "invoices" VALUES (7659, '', 1, '', 798445, 'A');
INSERT INTO "invoices" VALUES (7660, '', 6, '', 794571, 'A');
INSERT INTO "invoices" VALUES (7661, '', 1, '', 812068, 'Z');
INSERT INTO "invoices" VALUES (7662, '', 3, '', 499431, 'Z');
INSERT INTO "invoices" VALUES (7662, '', 3, '', 445892, 'D');
INSERT INTO "invoices" VALUES (7663, '', 3, '', 277363, 'Z');
INSERT INTO "invoices" VALUES (7664, '', 2, '', 240, 'R');
INSERT INTO "invoices" VALUES (7664, '', 2, '', 240, 'E');
INSERT INTO "invoices" VALUES (7664, '', 2, '', 240, 'H');
INSERT INTO "invoices" VALUES (7664, '', 2, '', 380765, 'A');
INSERT INTO "invoices" VALUES (7664, '', 2, '', 240, 'D');
INSERT INTO "invoices" VALUES (7665, '', 3, '', 333025, 'A');
INSERT INTO "invoices" VALUES (7666, '', 4, '', 342563, 'Z');
INSERT INTO "invoices" VALUES (7666, '', 4, '', 20316, 'A');
INSERT INTO "invoices" VALUES (7667, '', 1, '', 1443, 'Z');
INSERT INTO "invoices" VALUES (7667, '', 1, '', 53049, 'H');
INSERT INTO "invoices" VALUES (7667, '', 1, '', 61, 'E');
INSERT INTO "invoices" VALUES (7668, '', 3, '', 225753, 'E');
INSERT INTO "invoices" VALUES (7669, '', 1, '', 330262, 'A');
INSERT INTO "invoices" VALUES (7670, '', 6, '', 136896, 'D');
INSERT INTO "invoices" VALUES (7671, '', 2, '', 281442, 'Z');
INSERT INTO "invoices" VALUES (7672, '', 5, '', 270479, 'A');
INSERT INTO "invoices" VALUES (7673, '', 2, '', 336726, 'A');
INSERT INTO "invoices" VALUES (7674, '', 4, '', 234235, 'Z');
INSERT INTO "invoices" VALUES (7675, '', 4, '', 178414, 'D');
INSERT INTO "invoices" VALUES (7676, '', 4, '', 216611, 'R');
INSERT INTO "invoices" VALUES (7677, '', 2, '', 223805, 'H');
INSERT INTO "invoices" VALUES (7678, '', 3, '', 914642, 'Z');
INSERT INTO "invoices" VALUES (7679, '', 3, '', 810374, 'A');
INSERT INTO "invoices" VALUES (7680, '', 5, '', 350405, 'A');
INSERT INTO "invoices" VALUES (7681, '', 2, '', 869433, 'A');
INSERT INTO "invoices" VALUES (7682, '', 1, '', 901924, 'A');
INSERT INTO "invoices" VALUES (7683, '', 4, '', 88531, 'Z');
INSERT INTO "invoices" VALUES (7684, '', 1, '', 707978, 'D');
INSERT INTO "invoices" VALUES (7685, '', 1, '', 558407, 'R');
INSERT INTO "invoices" VALUES (7686, '', 5, '', 253983, 'E');
INSERT INTO "invoices" VALUES (7686, '', 5, '', 1055, 'A');
INSERT INTO "invoices" VALUES (7686, '', 5, '', 553873, 'H');
INSERT INTO "invoices" VALUES (7687, '', 6, '', 296593, 'Z');
INSERT INTO "invoices" VALUES (7688, '', 4, '', 302944, 'A');
INSERT INTO "invoices" VALUES (7688, '', 4, '', 355, 'R');
INSERT INTO "invoices" VALUES (7688, '', 4, '', 355, 'D');
INSERT INTO "invoices" VALUES (7688, '', 4, '', 355, 'H');
INSERT INTO "invoices" VALUES (7688, '', 4, '', 355, 'E');
INSERT INTO "invoices" VALUES (7689, '', 5, '', 365662, 'Z');
INSERT INTO "invoices" VALUES (7690, '', 5, '', 379491, 'A');
INSERT INTO "invoices" VALUES (7691, '', 1, '', 93779, 'R');
INSERT INTO "invoices" VALUES (7692, '', 5, '', 174553, 'H');
INSERT INTO "invoices" VALUES (7693, '', 6, '', 165154, 'E');
INSERT INTO "invoices" VALUES (7694, '', 3, '', 179793, 'R');
INSERT INTO "invoices" VALUES (7695, '', 3, '', 169622, 'D');
INSERT INTO "invoices" VALUES (7696, '', 4, '', 312027, 'A');
INSERT INTO "invoices" VALUES (7697, '', 3, '', 348717, 'A');
INSERT INTO "invoices" VALUES (7698, '', 4, '', 263356, 'Z');
INSERT INTO "invoices" VALUES (7699, '', 3, '', 323010, 'A');
INSERT INTO "invoices" VALUES (7700, '', 2, '', 276725, 'Z');
INSERT INTO "invoices" VALUES (7701, '', 4, '', 903750, 'Z');
INSERT INTO "invoices" VALUES (7702, '', 4, '', 905320, 'A');
INSERT INTO "invoices" VALUES (7703, '', 3, '', 334326, 'A');
INSERT INTO "invoices" VALUES (7704, '', 4, '', 349686, 'Z');
INSERT INTO "invoices" VALUES (7705, '', 4, '', 242492, 'Z');
INSERT INTO "invoices" VALUES (7706, '', 2, '', 250289, 'A');
INSERT INTO "invoices" VALUES (7706, '', 2, '', 365, 'R');
INSERT INTO "invoices" VALUES (7706, '', 2, '', 365, 'D');
INSERT INTO "invoices" VALUES (7706, '', 2, '', 365, 'H');
INSERT INTO "invoices" VALUES (7706, '', 2, '', 365, 'E');
INSERT INTO "invoices" VALUES (7707, '', 3, '', 895319, 'A');
INSERT INTO "invoices" VALUES (7708, '', 1, '', 896349, 'A');
INSERT INTO "invoices" VALUES (7709, '', 1, '', 928301, 'Z');
INSERT INTO "invoices" VALUES (7710, '', 1, '', 721078, 'R');
INSERT INTO "invoices" VALUES (7711, '', 3, '', 384714, 'R');
INSERT INTO "invoices" VALUES (7711, '', 3, '', 420265, 'D');
INSERT INTO "invoices" VALUES (7712, '', 4, '', 421582, 'H');
INSERT INTO "invoices" VALUES (7712, '', 4, '', 383866, 'E');
INSERT INTO "invoices" VALUES (7713, '', 2, '', 417025, 'A');
INSERT INTO "invoices" VALUES (7713, '', 2, '', 111980, 'Z');
INSERT INTO "invoices" VALUES (7714, '', 2, '', 477566, 'A');
INSERT INTO "invoices" VALUES (7715, '', 2, '', 108420, 'A');
INSERT INTO "invoices" VALUES (7716, '', 1, '', 462489, 'E');
INSERT INTO "invoices" VALUES (7717, '', 2, '', 271051, 'A');
INSERT INTO "invoices" VALUES (7718, '', 1, '', 125928, 'R');
INSERT INTO "invoices" VALUES (7719, '', 6, '', 128057, 'H');
INSERT INTO "invoices" VALUES (7720, '', 4, '', 245448, 'A');
INSERT INTO "invoices" VALUES (7721, '', 1, '', 148285, 'D');
INSERT INTO "invoices" VALUES (7722, '', 4, '', 256202, 'Z');
INSERT INTO "invoices" VALUES (7723, '', 2, '', 347688, 'A');
INSERT INTO "invoices" VALUES (7724, '', 4, '', 836616, 'A');
INSERT INTO "invoices" VALUES (7725, '', 2, '', 333283, 'A');
INSERT INTO "invoices" VALUES (7726, '', 1, '', 788179, 'Z');
INSERT INTO "invoices" VALUES (7727, '', 1, '', 846092, 'Z');
INSERT INTO "invoices" VALUES (7728, '', 1, '', 845046, 'A');
INSERT INTO "invoices" VALUES (7729, '', 1, '', 333656, 'H');
INSERT INTO "invoices" VALUES (7729, '', 1, '', 333656, 'E');
INSERT INTO "invoices" VALUES (7730, '', 3, '', 872051, 'A');
INSERT INTO "invoices" VALUES (7731, '', 2, '', 381393, 'A');
INSERT INTO "invoices" VALUES (7731, '', 2, '', 360, 'D');
INSERT INTO "invoices" VALUES (7731, '', 2, '', 360, 'H');
INSERT INTO "invoices" VALUES (7731, '', 2, '', 360, 'E');
INSERT INTO "invoices" VALUES (7731, '', 2, '', 360, 'R');
INSERT INTO "invoices" VALUES (7732, '', 1, '', 312500, 'E');
INSERT INTO "invoices" VALUES (7733, '', 5, '', 208400, 'D');
INSERT INTO "invoices" VALUES (7733, '', 5, '', 416600, 'R');
INSERT INTO "invoices" VALUES (7734, '', 6, '', 279590, 'Z');
INSERT INTO "invoices" VALUES (7734, '', 6, '', 12191, 'D');
INSERT INTO "invoices" VALUES (7735, '', 5, '', 380057, 'Z');
INSERT INTO "invoices" VALUES (7736, '', 4, '', 380201, 'A');
INSERT INTO "invoices" VALUES (7736, '', 4, '', 12191, 'H');
INSERT INTO "invoices" VALUES (7736, '', 4, '', 12191, 'E');
INSERT INTO "invoices" VALUES (7737, '', 2, '', 346899, 'A');
INSERT INTO "invoices" VALUES (7738, '', 2, '', 60489, 'A');
INSERT INTO "invoices" VALUES (7739, '', 2, '', 241704, 'H');
INSERT INTO "invoices" VALUES (7740, '', 2, '', 379686, 'A');
INSERT INTO "invoices" VALUES (7741, '', 4, '', 535737, 'Z');
INSERT INTO "invoices" VALUES (7742, '', 3, '', 232321, 'R');
INSERT INTO "invoices" VALUES (7743, '', 6, '', 289418, 'A');
INSERT INTO "invoices" VALUES (7744, '', 1, '', 236890, 'D');
INSERT INTO "invoices" VALUES (7745, '', 4, '', 316630, 'E');
INSERT INTO "invoices" VALUES (7746, '', 1, '', 367771, 'A');
INSERT INTO "invoices" VALUES (7747, '', 1, '', 35527, 'H');
INSERT INTO "invoices" VALUES (7747, '', 1, '', 355279, 'A');
INSERT INTO "invoices" VALUES (7748, '', 2, '', 797456, 'A');
INSERT INTO "invoices" VALUES (7749, '', 3, '', 335020, 'A');
INSERT INTO "invoices" VALUES (7750, '', 5, '', 337525, 'A');
INSERT INTO "invoices" VALUES (7751, '', 1, '', 778953, 'A');
INSERT INTO "invoices" VALUES (7752, '', 2, '', 819671, 'A');
INSERT INTO "invoices" VALUES (7754, '', 1, '', 331871, 'H');
INSERT INTO "invoices" VALUES (7754, '', 1, '', 332321, 'E');
INSERT INTO "invoices" VALUES (7755, '', 1, '', 274029, 'H');
INSERT INTO "invoices" VALUES (7755, '', 1, '', 609426, 'E');
INSERT INTO "invoices" VALUES (7756, '', 3, '', 147262, 'A');
INSERT INTO "invoices" VALUES (7756, '', 3, '', 360, 'R');
INSERT INTO "invoices" VALUES (7756, '', 3, '', 360, 'D');
INSERT INTO "invoices" VALUES (7756, '', 3, '', 360, 'E');
INSERT INTO "invoices" VALUES (7756, '', 3, '', 360, 'H');
INSERT INTO "invoices" VALUES (7757, '', 4, '', 601975, 'R');
INSERT INTO "invoices" VALUES (7757, '', 4, '', 286322, 'D');
INSERT INTO "invoices" VALUES (7758, '', 2, '', 131763, 'Z');
INSERT INTO "invoices" VALUES (7759, '', 4, '', 378115, 'Z');
INSERT INTO "invoices" VALUES (7759, '', 4, '', 61573, 'A');
INSERT INTO "invoices" VALUES (7760, '', 4, '', 446849, 'A');
INSERT INTO "invoices" VALUES (7760, '', 4, '', 12191, 'H');
INSERT INTO "invoices" VALUES (7760, '', 4, '', 12191, 'E');
INSERT INTO "invoices" VALUES (7761, '', 3, '', 398186, 'R');
INSERT INTO "invoices" VALUES (7761, '', 3, '', 12191, 'D');
INSERT INTO "invoices" VALUES (7762, '', 4, '', 88752, 'A');
INSERT INTO "invoices" VALUES (7763, '', 5, '', 158972, 'R');
INSERT INTO "invoices" VALUES (7764, '', 2, '', 163201, 'H');
INSERT INTO "invoices" VALUES (7765, '', 5, '', 161368, 'Z');
INSERT INTO "invoices" VALUES (7766, '', 2, '', 304692, 'Z');
INSERT INTO "invoices" VALUES (7767, '', 1, '', 132776, 'A');
INSERT INTO "invoices" VALUES (7768, '', 1, '', 186092, 'E');
INSERT INTO "invoices" VALUES (7769, '', 4, '', 157163, 'D');
INSERT INTO "invoices" VALUES (7770, '', 1, '', 238038, 'A');
INSERT INTO "invoices" VALUES (7771, '', 1, '', 202038, 'A');
INSERT INTO "invoices" VALUES (7772, '', 2, '', 216496, 'A');
INSERT INTO "invoices" VALUES (7773, '', 1, '', 246336, 'A');
INSERT INTO "invoices" VALUES (7774, '', 2, '', 142890, 'A');
INSERT INTO "invoices" VALUES (7775, '', 4, '', 337984, 'A');
INSERT INTO "invoices" VALUES (7776, '', 2, '', 287698, 'Z');
INSERT INTO "invoices" VALUES (7777, '', 5, '', 814041, 'A');
INSERT INTO "invoices" VALUES (7778, '', 4, '', 497140, 'Z');
INSERT INTO "invoices" VALUES (7779, '', 2, '', 677504, 'A');
INSERT INTO "invoices" VALUES (7780, '', 1, '', 686177, 'Z');
INSERT INTO "invoices" VALUES (7781, '', 1, '', 567136, 'D');
INSERT INTO "invoices" VALUES (7782, '', 1, '', 778861, 'A');
INSERT INTO "invoices" VALUES (7783, '', 2, '', 92900, 'D');
INSERT INTO "invoices" VALUES (7783, '', 2, '', 68976, 'R');
INSERT INTO "invoices" VALUES (7783, '', 2, '', 298, 'Z');
INSERT INTO "invoices" VALUES (7784, '', 3, '', 95318, 'E');
INSERT INTO "invoices" VALUES (7784, '', 3, '', 69874, 'H');
INSERT INTO "invoices" VALUES (7785, '', 3, '', 275826, 'A');
INSERT INTO "invoices" VALUES (7786, '', 1, '', 367017, 'H');
INSERT INTO "invoices" VALUES (7787, '', 1, '', 297652, 'E');
INSERT INTO "invoices" VALUES (7787, '', 1, '', 306629, 'D');
INSERT INTO "invoices" VALUES (7787, '', 1, '', 367033, 'R');
INSERT INTO "invoices" VALUES (7788, '', 3, '', 289366, 'A');
INSERT INTO "invoices" VALUES (7788, '', 3, '', 48537, 'Z');
INSERT INTO "invoices" VALUES (7789, '', 3, '', 48185, 'Z');
INSERT INTO "invoices" VALUES (7789, '', 3, '', 286828, 'A');
INSERT INTO "invoices" VALUES (7790, '', 1, '', 83872, 'A');
INSERT INTO "invoices" VALUES (7791, '', 2, '', 154461, 'D');
INSERT INTO "invoices" VALUES (7792, '', 3, '', 202264, 'A');
INSERT INTO "invoices" VALUES (7793, '', 3, '', 216414, 'A');
INSERT INTO "invoices" VALUES (7794, '', 1, '', 201251, 'Z');
INSERT INTO "invoices" VALUES (7795, '', 2, '', 198582, 'A');
INSERT INTO "invoices" VALUES (7796, '', 3, '', 171640, 'A');
INSERT INTO "invoices" VALUES (7797, '', 3, '', 174590, 'A');
INSERT INTO "invoices" VALUES (7798, '', 5, '', 218614, 'Z');
INSERT INTO "invoices" VALUES (7799, '', 5, '', 130763, 'H');
INSERT INTO "invoices" VALUES (7800, '', 6, '', 149186, 'R');
INSERT INTO "invoices" VALUES (7801, '', 4, '', 346074, 'A');
INSERT INTO "invoices" VALUES (7802, '', 1, '', 638006, 'A');
INSERT INTO "invoices" VALUES (7803, '', 1, '', 660065, 'A');
INSERT INTO "invoices" VALUES (7804, '', 1, '', 666327, 'Z');
INSERT INTO "invoices" VALUES (7805, '', 1, '', 471327, 'R');
INSERT INTO "invoices" VALUES (7806, '', 2, '', 134795, 'E');
INSERT INTO "invoices" VALUES (7807, '', 1, '', 123088, 'H');
INSERT INTO "invoices" VALUES (7807, '', 1, '', 86211, 'E');
INSERT INTO "invoices" VALUES (7808, '', 5, '', 227852, 'A');
INSERT INTO "invoices" VALUES (7808, '', 5, '', 300, 'R');
INSERT INTO "invoices" VALUES (7808, '', 5, '', 300, 'D');
INSERT INTO "invoices" VALUES (7808, '', 5, '', 300, 'Z');
INSERT INTO "invoices" VALUES (7809, '', 1, '', 217172, 'A');
INSERT INTO "invoices" VALUES (7810, '', 2, '', 616458, 'E');
INSERT INTO "invoices" VALUES (7811, '', 1, '', 607075, 'H');
INSERT INTO "invoices" VALUES (7812, '', 3, '', 765006, 'A');
INSERT INTO "invoices" VALUES (7813, '', 5, '', 260643, 'A');
INSERT INTO "invoices" VALUES (7814, '', 3, '', 235929, 'Z');
INSERT INTO "invoices" VALUES (7814, '', 3, '', 33856, 'A');
INSERT INTO "invoices" VALUES (7815, '', 3, '', 74510, 'A');
INSERT INTO "invoices" VALUES (7816, '', 3, '', 157075, 'E');
INSERT INTO "invoices" VALUES (7817, '', 5, '', 163627, 'A');
INSERT INTO "invoices" VALUES (7818, '', 3, '', 164164, 'A');
INSERT INTO "invoices" VALUES (7819, '', 2, '', 156727, 'D');
INSERT INTO "invoices" VALUES (7820, '', 4, '', 220767, 'A');
INSERT INTO "invoices" VALUES (7821, '', 1, '', 231742, 'A');
INSERT INTO "invoices" VALUES (7822, '', 3, '', 192440, 'Z');
INSERT INTO "invoices" VALUES (7823, '', 4, '', 186092, 'Z');
INSERT INTO "invoices" VALUES (7824, '', 4, '', 154317, 'H');
INSERT INTO "invoices" VALUES (7825, '', 5, '', 159059, 'R');
INSERT INTO "invoices" VALUES (7826, '', 2, '', 210874, 'A');
INSERT INTO "invoices" VALUES (7827, '', 2, '', 154549, 'A');
INSERT INTO "invoices" VALUES (7828, '', 2, '', 687198, 'A');
INSERT INTO "invoices" VALUES (7829, '', 1, '', 636118, 'Z');
INSERT INTO "invoices" VALUES (7830, '', 1, '', 478377, 'H');
INSERT INTO "invoices" VALUES (7831, '', 1, '', 638646, 'A');
INSERT INTO "invoices" VALUES (7832, '', 2, '', 649086, 'A');
INSERT INTO "invoices" VALUES (7833, '', 3, '', 161267, 'R');
INSERT INTO "invoices" VALUES (7834, '', 4, '', 170867, 'A');
INSERT INTO "invoices" VALUES (7835, '', 4, '', 189914, 'A');
INSERT INTO "invoices" VALUES (7836, '', 5, '', 625655, 'D');
INSERT INTO "invoices" VALUES (7837, '', 2, '', 625554, 'Z');
INSERT INTO "invoices" VALUES (7838, '', 4, '', 182274, 'Z');
INSERT INTO "invoices" VALUES (7838, '', 4, '', 29639, 'A');
INSERT INTO "invoices" VALUES (7839, '', 3, '', 214422, 'A');
INSERT INTO "invoices" VALUES (7840, '', 2, '', 84072, 'A');
INSERT INTO "invoices" VALUES (7843, '', 3, '', 551297, 'A');
INSERT INTO "invoices" VALUES (7843, '', 3, '', 253060, 'Z');
INSERT INTO "invoices" VALUES (7844, '', 4, '', 248271, 'A');
INSERT INTO "invoices" VALUES (7845, '', 1, '', 134124, 'D');
INSERT INTO "invoices" VALUES (7845, '', 1, '', 123195, 'E');
INSERT INTO "invoices" VALUES (7846, '', 4, '', 124491, 'A');
INSERT INTO "invoices" VALUES (7847, '', 2, '', 138875, 'A');
INSERT INTO "invoices" VALUES (7848, '', 4, '', 106674, 'A');
INSERT INTO "invoices" VALUES (7849, '', 5, '', 99841, 'R');
INSERT INTO "invoices" VALUES (7850, '', 5, '', 118484, 'A');
INSERT INTO "invoices" VALUES (7851, '', 2, '', 109456, 'A');
INSERT INTO "invoices" VALUES (7852, '', 4, '', 158922, 'Z');
INSERT INTO "invoices" VALUES (7853, '', 1, '', 144108, 'Z');
INSERT INTO "invoices" VALUES (7854, '', 3, '', 142096, 'A');
INSERT INTO "invoices" VALUES (7855, '', 3, '', 102239, 'E');
INSERT INTO "invoices" VALUES (7856, '', 4, '', 688233, 'A');
INSERT INTO "invoices" VALUES (7857, '', 1, '', 491010, 'E');
INSERT INTO "invoices" VALUES (7858, '', 2, '', 633709, 'A');
INSERT INTO "invoices" VALUES (7859, '', 2, '', 622905, 'Z');
INSERT INTO "invoices" VALUES (7860, '', 2, '', 674509, 'A');
INSERT INTO "invoices" VALUES (7861, '', 2, '', 311572, 'E');
INSERT INTO "invoices" VALUES (7861, '', 2, '', 353794, 'H');
INSERT INTO "invoices" VALUES (7862, '', 4, '', 240577, 'Z');
INSERT INTO "invoices" VALUES (7862, '', 4, '', 169639, 'A');
INSERT INTO "invoices" VALUES (7863, '', 5, '', 100653, 'H');
INSERT INTO "invoices" VALUES (7864, '', 2, '', 104035, 'A');
INSERT INTO "invoices" VALUES (7866, '', 1, '', 240640, 'Z');
INSERT INTO "invoices" VALUES (7866, '', 1, '', 538559, 'A');
INSERT INTO "invoices" VALUES (7867, '', 3, '', 179396, 'E');
INSERT INTO "invoices" VALUES (7868, '', 1, '', 223550, 'A');
INSERT INTO "invoices" VALUES (7869, '', 2, '', 165804, 'D');
INSERT INTO "invoices" VALUES (7870, '', 2, '', 221420, 'A');
INSERT INTO "invoices" VALUES (7871, '', 3, '', 174884, 'Z');
INSERT INTO "invoices" VALUES (7872, '', 1, '', 175177, 'A');
INSERT INTO "invoices" VALUES (7873, '', 2, '', 176576, 'H');
INSERT INTO "invoices" VALUES (7874, '', 5, '', 182854, 'A');
INSERT INTO "invoices" VALUES (7875, '', 4, '', 228857, 'A');
INSERT INTO "invoices" VALUES (7876, '', 2, '', 22236, 'A');
INSERT INTO "invoices" VALUES (7876, '', 2, '', 626769, 'Z');
INSERT INTO "invoices" VALUES (7877, '', 1, '', 24808, 'A');
INSERT INTO "invoices" VALUES (7877, '', 1, '', 313232, 'D');
INSERT INTO "invoices" VALUES (7878, '', 4, '', 181116, 'Z');
INSERT INTO "invoices" VALUES (7879, '', 4, '', 121183, 'R');
INSERT INTO "invoices" VALUES (7880, '', 2, '', 15294, 'D');
INSERT INTO "invoices" VALUES (7880, '', 2, '', 608316, 'A');
INSERT INTO "invoices" VALUES (7881, '', 2, '', 22974, 'Z');
INSERT INTO "invoices" VALUES (7881, '', 2, '', 631065, 'A');
INSERT INTO "invoices" VALUES (7882, '', 2, '', 808798, 'A');
INSERT INTO "invoices" VALUES (7883, '', 5, '', 113745, 'A');
INSERT INTO "invoices" VALUES (7884, '', 1, '', 73394, 'R');
INSERT INTO "invoices" VALUES (7885, '', 4, '', 211357, 'Z');
INSERT INTO "invoices" VALUES (7885, '', 4, '', 2260, 'A');
INSERT INTO "invoices" VALUES (7886, '', 3, '', 276737, 'A');
INSERT INTO "invoices" VALUES (7887, '', 2, '', 144108, 'Z');
INSERT INTO "invoices" VALUES (7888, '', 3, '', 70099, 'A');
INSERT INTO "invoices" VALUES (7890, '', 4, '', 551297, 'A');
INSERT INTO "invoices" VALUES (7890, '', 4, '', 253060, 'Z');
INSERT INTO "invoices" VALUES (7891, '', 5, '', 495756, 'A');
INSERT INTO "invoices" VALUES (7891, '', 5, '', 218448, 'Z');
INSERT INTO "invoices" VALUES (7892, '', 1, '', 114446, 'D');
INSERT INTO "invoices" VALUES (7893, '', 4, '', 132528, 'H');
INSERT INTO "invoices" VALUES (7894, '', 1, '', 138091, 'R');
INSERT INTO "invoices" VALUES (7895, '', 4, '', 136951, 'E');
INSERT INTO "invoices" VALUES (7896, '', 3, '', 142826, 'Z');
INSERT INTO "invoices" VALUES (7897, '', 1, '', 119279, 'A');
INSERT INTO "invoices" VALUES (7898, '', 3, '', 153199, 'A');
INSERT INTO "invoices" VALUES (7899, '', 2, '', 272105, 'A');
INSERT INTO "invoices" VALUES (7900, '', 5, '', 274114, 'A');
INSERT INTO "invoices" VALUES (7901, '', 1, '', 155416, 'A');
INSERT INTO "invoices" VALUES (7902, '', 5, '', 148747, 'A');
INSERT INTO "invoices" VALUES (7903, '', 2, '', 121629, 'Z');
INSERT INTO "invoices" VALUES (7904, '', 2, '', 448920, 'R');
INSERT INTO "invoices" VALUES (7905, '', 1, '', 618841, 'A');
INSERT INTO "invoices" VALUES (7906, '', 1, '', 634080, 'Z');
INSERT INTO "invoices" VALUES (7907, '', 1, '', 587347, 'A');
INSERT INTO "invoices" VALUES (7908, '', 1, '', 88712, 'A');
INSERT INTO "invoices" VALUES (7909, '', 2, '', 41015, 'H');
INSERT INTO "invoices" VALUES (7909, '', 2, '', 45120, 'E');
INSERT INTO "invoices" VALUES (7910, '', 4, '', 825385, 'A');
INSERT INTO "invoices" VALUES (7912, '', 3, '', 41630, 'A');
INSERT INTO "invoices" VALUES (7912, '', 3, '', 240136, 'Z');
INSERT INTO "invoices" VALUES (7913, '', 3, '', 258862, 'A');
INSERT INTO "invoices" VALUES (7914, '', 2, '', 83334, 'A');
INSERT INTO "invoices" VALUES (7916, '', 5, '', 260207, 'Z');
INSERT INTO "invoices" VALUES (7916, '', 5, '', 581890, 'A');
INSERT INTO "invoices" VALUES (7917, '', 4, '', 266820, 'A');
INSERT INTO "invoices" VALUES (7918, '', 3, '', 156732, 'D');
INSERT INTO "invoices" VALUES (7919, '', 5, '', 151551, 'Z');
INSERT INTO "invoices" VALUES (7920, '', 1, '', 168946, 'H');
INSERT INTO "invoices" VALUES (7921, '', 1, '', 167144, 'R');
INSERT INTO "invoices" VALUES (7922, '', 2, '', 161177, 'A');
INSERT INTO "invoices" VALUES (7923, '', 1, '', 160803, 'Z');
INSERT INTO "invoices" VALUES (7924, '', 3, '', 166605, 'A');
INSERT INTO "invoices" VALUES (7925, '', 2, '', 162607, 'A');
INSERT INTO "invoices" VALUES (7926, '', 2, '', 175448, 'A');
INSERT INTO "invoices" VALUES (7927, '', 1, '', 163470, 'E');
INSERT INTO "invoices" VALUES (7928, '', 1, '', 481500, 'H');
INSERT INTO "invoices" VALUES (7929, '', 1, '', 581994, 'Z');
INSERT INTO "invoices" VALUES (7930, '', 3, '', 622947, 'A');
INSERT INTO "invoices" VALUES (7931, '', 1, '', 571295, 'A');
INSERT INTO "invoices" VALUES (7932, '', 2, '', 809328, 'A');
INSERT INTO "invoices" VALUES (7933, '', 2, '', 4874, 'A');
INSERT INTO "invoices" VALUES (7933, '', 2, '', 429647, 'E');
INSERT INTO "invoices" VALUES (7933, '', 2, '', 375953, 'H');
INSERT INTO "invoices" VALUES (7934, '', 2, '', 99731, 'A');
INSERT INTO "invoices" VALUES (7935, '', 4, '', 101754, 'Z');
INSERT INTO "invoices" VALUES (7936, '', 3, '', 320755, 'A');
INSERT INTO "invoices" VALUES (7937, '', 5, '', 304118, 'A');
INSERT INTO "invoices" VALUES (7937, '', 5, '', 304118, 'Z');
INSERT INTO "invoices" VALUES (7939, '', 2, '', 81538, 'A');
INSERT INTO "invoices" VALUES (7941, '', 3, '', 529593, 'A');
INSERT INTO "invoices" VALUES (7941, '', 3, '', 237318, 'Z');
INSERT INTO "invoices" VALUES (7942, '', 1, '', 444196, 'E');
INSERT INTO "invoices" VALUES (7943, '', 1, '', 577632, 'A');
INSERT INTO "invoices" VALUES (7944, '', 5, '', 113629, 'E');
INSERT INTO "invoices" VALUES (7945, '', 4, '', 149671, 'A');
INSERT INTO "invoices" VALUES (7946, '', 5, '', 159702, 'Z');
INSERT INTO "invoices" VALUES (7947, '', 4, '', 181226, 'A');
INSERT INTO "invoices" VALUES (7949, '', 5, '', 117612, 'R');
INSERT INTO "invoices" VALUES (7950, '', 1, '', 116333, 'H');
INSERT INTO "invoices" VALUES (7951, '', 4, '', 118479, 'D');
INSERT INTO "invoices" VALUES (7952, '', 1, '', 186150, 'Z');
INSERT INTO "invoices" VALUES (7953, '', 4, '', 151559, 'A');
INSERT INTO "invoices" VALUES (7954, '', 6, '', 171508, 'A');
INSERT INTO "invoices" VALUES (7955, '', 5, '', 293773, 'A');
INSERT INTO "invoices" VALUES (7956, '', 2, '', 644352, 'Z');
INSERT INTO "invoices" VALUES (7957, '', 1, '', 597349, 'A');
INSERT INTO "invoices" VALUES (7958, '', 2, '', 964416, 'A');
INSERT INTO "invoices" VALUES (7959, '', 3, '', 966193, 'Z');
INSERT INTO "invoices" VALUES (7960, '', 1, '', 102140, 'A');
INSERT INTO "invoices" VALUES (7961, '', 2, '', 107413, 'Z');
INSERT INTO "invoices" VALUES (7962, '', 4, '', 295665, 'Z');
INSERT INTO "invoices" VALUES (7965, '', 2, '', 50610, 'A');
INSERT INTO "invoices" VALUES (7967, '', 3, '', 254394, 'Z');
INSERT INTO "invoices" VALUES (7967, '', 3, '', 563417, 'A');
INSERT INTO "invoices" VALUES (7968, '', 3, '', 119377, 'R');
INSERT INTO "invoices" VALUES (7969, '', 3, '', 118038, 'Z');
INSERT INTO "invoices" VALUES (7970, '', 4, '', 141934, 'A');
INSERT INTO "invoices" VALUES (7971, '', 5, '', 124291, 'H');
INSERT INTO "invoices" VALUES (7972, '', 1, '', 168906, 'A');
INSERT INTO "invoices" VALUES (7973, '', 3, '', 141517, 'Z');
INSERT INTO "invoices" VALUES (7974, '', 1, '', 194701, 'A');
INSERT INTO "invoices" VALUES (7975, '', 5, '', 114856, 'D');
INSERT INTO "invoices" VALUES (7976, '', 1, '', 131223, 'A');
INSERT INTO "invoices" VALUES (7977, '', 3, '', 99919, 'E');
INSERT INTO "invoices" VALUES (7978, '', 5, '', 216992, 'A');
INSERT INTO "invoices" VALUES (7979, '', 1, '', 945403, 'A');
INSERT INTO "invoices" VALUES (7980, '', 1, '', 496133, 'D');
INSERT INTO "invoices" VALUES (7981, '', 1, '', 646005, 'A');
INSERT INTO "invoices" VALUES (7982, '', 2, '', 664618, 'A');
INSERT INTO "invoices" VALUES (7983, '', 1, '', 634098, 'Z');
INSERT INTO "invoices" VALUES (7984, '', 2, '', 25650, 'A');
INSERT INTO "invoices" VALUES (7984, '', 2, '', 425233, 'E');
INSERT INTO "invoices" VALUES (7984, '', 2, '', 494044, 'H');
INSERT INTO "invoices" VALUES (7985, '', 4, '', 878191, 'R');
INSERT INTO "invoices" VALUES (7986, '', 1, '', 143628, 'Z');
INSERT INTO "invoices" VALUES (7987, '', 2, '', 199902, 'A');
INSERT INTO "invoices" VALUES (7988, '', 1, '', 95728, 'H');
INSERT INTO "invoices" VALUES (7989, '', 2, '', 25006, 'Z');
INSERT INTO "invoices" VALUES (7989, '', 2, '', 273689, 'A');
INSERT INTO "invoices" VALUES (7990, '', 3, '', 4962, 'A');
INSERT INTO "invoices" VALUES (7990, '', 3, '', 278029, 'Z');
INSERT INTO "invoices" VALUES (7992, '', 1, '', 292955, 'Z');
INSERT INTO "invoices" VALUES (7992, '', 1, '', 577293, 'A');
INSERT INTO "invoices" VALUES (7993, '', 2, '', 105024, 'D');
INSERT INTO "invoices" VALUES (7994, '', 4, '', 161970, 'Z');
INSERT INTO "invoices" VALUES (7995, '', 1, '', 107258, 'R');
INSERT INTO "invoices" VALUES (7996, '', 3, '', 125182, 'A');
INSERT INTO "invoices" VALUES (7997, '', 2, '', 171482, 'A');
INSERT INTO "invoices" VALUES (7998, '', 4, '', 160125, 'A');
INSERT INTO "invoices" VALUES (7999, '', 1, '', 144698, 'Z');
INSERT INTO "invoices" VALUES (8000, '', 2, '', 106471, 'H');
INSERT INTO "invoices" VALUES (8001, '', 3, '', 123195, 'E');
INSERT INTO "invoices" VALUES (8002, '', 3, '', 134652, 'Z');
INSERT INTO "invoices" VALUES (8003, '', 2, '', 910811, 'Z');
INSERT INTO "invoices" VALUES (8003, '', 2, '', 34006, 'A');
INSERT INTO "invoices" VALUES (8004, '', 2, '', 310827, 'A');
INSERT INTO "invoices" VALUES (8005, '', 3, '', 953063, 'A');
INSERT INTO "invoices" VALUES (8006, '', 1, '', 105664, 'A');
INSERT INTO "invoices" VALUES (8007, '', 1, '', 729019, 'A');
INSERT INTO "invoices" VALUES (8008, '', 1, '', 733638, 'A');
INSERT INTO "invoices" VALUES (8009, '', 2, '', 480091, 'E');
INSERT INTO "invoices" VALUES (8009, '', 2, '', 426810, 'H');
INSERT INTO "invoices" VALUES (8009, '', 2, '', 48023, 'A');
INSERT INTO "invoices" VALUES (8010, '', 1, '', 523827, 'R');
INSERT INTO "invoices" VALUES (8011, '', 5, '', 54105, 'Z');
INSERT INTO "invoices" VALUES (8011, '', 5, '', 267484, 'A');
INSERT INTO "invoices" VALUES (8012, '', 1, '', 717079, 'Z');
INSERT INTO "invoices" VALUES (8013, '', 5, '', 309415, 'Z');
INSERT INTO "invoices" VALUES (8014, '', 1, '', 1567, 'Z');
INSERT INTO "invoices" VALUES (8014, '', 1, '', 725, 'E');
INSERT INTO "invoices" VALUES (8014, '', 1, '', 190539, 'A');
INSERT INTO "invoices" VALUES (8015, '', 1, '', 119894, 'D');
INSERT INTO "invoices" VALUES (8017, '', 2, '', 514364, 'A');
INSERT INTO "invoices" VALUES (8017, '', 2, '', 254509, 'Z');
INSERT INTO "invoices" VALUES (8018, '', 1, '', 155993, 'A');
INSERT INTO "invoices" VALUES (8019, '', 2, '', 109089, 'E');
INSERT INTO "invoices" VALUES (8020, '', 2, '', 173798, 'A');
INSERT INTO "invoices" VALUES (8021, '', 5, '', 107658, 'D');
INSERT INTO "invoices" VALUES (8022, '', 5, '', 110556, 'R');
INSERT INTO "invoices" VALUES (8023, '', 1, '', 155085, 'Z');
INSERT INTO "invoices" VALUES (8024, '', 1, '', 97262, 'H');
INSERT INTO "invoices" VALUES (8025, '', 3, '', 153525, 'A');
INSERT INTO "invoices" VALUES (8026, '', 5, '', 137983, 'Z');
INSERT INTO "invoices" VALUES (8027, '', 2, '', 307250, 'A');
INSERT INTO "invoices" VALUES (8028, '', 5, '', 1002938, 'A');
INSERT INTO "invoices" VALUES (8029, '', 3, '', 445433, 'D');
INSERT INTO "invoices" VALUES (8029, '', 3, '', 15664, 'A');
INSERT INTO "invoices" VALUES (8029, '', 3, '', 501952, 'R');
INSERT INTO "invoices" VALUES (8030, '', 1, '', 763868, 'A');
INSERT INTO "invoices" VALUES (8031, '', 1, '', 754314, 'Z');
INSERT INTO "invoices" VALUES (8032, '', 5, '', 1500, 'A');
INSERT INTO "invoices" VALUES (8032, '', 5, '', 476945, 'H');
INSERT INTO "invoices" VALUES (8032, '', 5, '', 547113, 'E');
INSERT INTO "invoices" VALUES (8033, '', 2, '', 571242, 'H');
INSERT INTO "invoices" VALUES (8034, '', 1, '', 745266, 'A');
INSERT INTO "invoices" VALUES (8037, '', 3, '', 137531, 'A');
INSERT INTO "invoices" VALUES (8038, '', 2, '', 141217, 'Z');
INSERT INTO "invoices" VALUES (8039, '', 3, '', 350000, 'Z');
INSERT INTO "invoices" VALUES (8040, '', 2, '', 438164, 'A');
INSERT INTO "invoices" VALUES (8041, '', 2, '', 514396, 'A');
INSERT INTO "invoices" VALUES (8041, '', 2, '', 239884, 'Z');
INSERT INTO "invoices" VALUES (8042, '', 1, '', 82621, 'D');
INSERT INTO "invoices" VALUES (8042, '', 1, '', 46193, 'R');
INSERT INTO "invoices" VALUES (8043, '', 3, '', 151111, 'A');
INSERT INTO "invoices" VALUES (8044, '', 2, '', 61378, 'E');
INSERT INTO "invoices" VALUES (8044, '', 2, '', 46167, 'H');
INSERT INTO "invoices" VALUES (8045, '', 2, '', 150971, 'A');
INSERT INTO "invoices" VALUES (8046, '', 1, '', 159315, 'Z');
INSERT INTO "invoices" VALUES (8047, '', 4, '', 505223, 'R');
INSERT INTO "invoices" VALUES (8047, '', 4, '', 430528, 'Z');
INSERT INTO "invoices" VALUES (8048, '', 4, '', 950417, 'A');
INSERT INTO "invoices" VALUES (8049, '', 2, '', 652164, 'Z');
INSERT INTO "invoices" VALUES (8050, '', 1, '', 692863, 'A');
INSERT INTO "invoices" VALUES (8051, '', 4, '', 344476, 'A');
INSERT INTO "invoices" VALUES (8052, '', 1, '', 508582, 'E');
INSERT INTO "invoices" VALUES (8053, '', 3, '', 687992, 'A');
INSERT INTO "invoices" VALUES (8054, '', 3, '', 935970, 'Z');
INSERT INTO "invoices" VALUES (8055, '', 1, '', 98706, 'Z');
INSERT INTO "invoices" VALUES (8056, '', 2, '', 160397, 'A');
INSERT INTO "invoices" VALUES (8057, '', 6, '', 313946, 'Z');
INSERT INTO "invoices" VALUES (8058, '', 2, '', 329334, 'A');
INSERT INTO "invoices" VALUES (8061, '', 2, '', 266985, 'Z');
INSERT INTO "invoices" VALUES (8061, '', 2, '', 560537, 'A');
INSERT INTO "invoices" VALUES (8062, '', 5, '', 70237, 'E');
INSERT INTO "invoices" VALUES (8062, '', 5, '', 41558, 'H');
INSERT INTO "invoices" VALUES (8063, '', 2, '', 153524, 'A');
INSERT INTO "invoices" VALUES (8064, '', 1, '', 169465, 'A');
INSERT INTO "invoices" VALUES (8065, '', 5, '', 167291, 'Z');
INSERT INTO "invoices" VALUES (8066, '', 6, '', 85179, 'D');
INSERT INTO "invoices" VALUES (8066, '', 6, '', 40755, 'R');
INSERT INTO "invoices" VALUES (8067, '', 3, '', 141019, 'Z');
INSERT INTO "invoices" VALUES (8068, '', 6, '', 299917, 'A');
INSERT INTO "invoices" VALUES (8069, '', 2, '', 861935, 'A');
INSERT INTO "invoices" VALUES (8070, '', 4, '', 392637, 'E');
INSERT INTO "invoices" VALUES (8070, '', 4, '', 452346, 'H');
INSERT INTO "invoices" VALUES (8071, '', 4, '', 657355, 'Z');
INSERT INTO "invoices" VALUES (8072, '', 3, '', 516911, 'D');
INSERT INTO "invoices" VALUES (8073, '', 1, '', 643543, 'A');
INSERT INTO "invoices" VALUES (8074, '', 1, '', 658673, 'A');
INSERT INTO "invoices" VALUES (8075, '', 2, '', 130, 'A');
INSERT INTO "invoices" VALUES (8075, '', 2, '', 353265, 'D');
INSERT INTO "invoices" VALUES (8075, '', 2, '', 427490, 'R');
INSERT INTO "invoices" VALUES (8076, '', 3, '', 352115, 'Z');
INSERT INTO "invoices" VALUES (8077, '', 2, '', 44139, 'D');
INSERT INTO "invoices" VALUES (8077, '', 2, '', 51985, 'R');
INSERT INTO "invoices" VALUES (8078, '', 3, '', 133785, 'A');
INSERT INTO "invoices" VALUES (8081, '', 2, '', 391951, 'A');
INSERT INTO "invoices" VALUES (8087, '', 1, '', 165783, 'A');
INSERT INTO "invoices" VALUES (8088, '', 1, '', 259981, 'A');
INSERT INTO "invoices" VALUES (8089, '', 1, '', 20994, 'A');
INSERT INTO "invoices" VALUES (8091, '', 1, '', 196750, 'Z');
INSERT INTO "invoices" VALUES (8092, '', 1, '', 66309, 'D');
INSERT INTO "invoices" VALUES (8092, '', 1, '', 45351, 'R');
INSERT INTO "invoices" VALUES (8093, '', 3, '', 163875, 'A');
INSERT INTO "invoices" VALUES (8094, '', 1, '', 87787, 'A');
INSERT INTO "invoices" VALUES (8095, '', 6, '', 70459, 'E');
INSERT INTO "invoices" VALUES (8095, '', 6, '', 48225, 'H');
INSERT INTO "invoices" VALUES (8096, '', 2, '', 121227, 'A');
INSERT INTO "invoices" VALUES (8099, '', 1, '', 657354, 'A');
INSERT INTO "invoices" VALUES (8101, '', 3, '', 658673, 'Z');
INSERT INTO "invoices" VALUES (8102, '', 6, '', 209388, 'Z');
INSERT INTO "invoices" VALUES (8103, '', 1, '', 124714, 'A');
INSERT INTO "invoices" VALUES (8104, '', 4, '', 105911, 'E');
INSERT INTO "invoices" VALUES (8105, '', 4, '', 107093, 'H');
INSERT INTO "invoices" VALUES (8106, '', 3, '', 115622, 'Z');
INSERT INTO "invoices" VALUES (8107, '', 1, '', 145218, 'A');
INSERT INTO "invoices" VALUES (8108, '', 3, '', 305136, 'A');
INSERT INTO "invoices" VALUES (8110, '', 1, '', 47463, 'D');
INSERT INTO "invoices" VALUES (8110, '', 1, '', 49845, 'R');
INSERT INTO "invoices" VALUES (8111, '', 1, '', 61284, 'Z');
INSERT INTO "invoices" VALUES (8112, '', 1, '', 65019, 'A');
INSERT INTO "invoices" VALUES (8113, '', 1, '', 97071, 'H');
INSERT INTO "invoices" VALUES (8114, '', 1, '', 35834, 'E');
INSERT INTO "invoices" VALUES (8115, '', 1, '', 96030, 'R');
INSERT INTO "invoices" VALUES (8116, '', 1, '', 81152, 'H');
INSERT INTO "invoices" VALUES (8117, '', 1, '', 89220, 'D');
INSERT INTO "invoices" VALUES (8118, '', 1, '', 85901, 'R');
INSERT INTO "invoices" VALUES (8119, '', 1, '', 70048, 'E');
INSERT INTO "invoices" VALUES (8120, '', 3, '', 112067, 'E');
INSERT INTO "invoices" VALUES (8121, '', 7, '', 139370, 'A');
INSERT INTO "invoices" VALUES (8122, '', 1, '', 116034, 'D');
INSERT INTO "invoices" VALUES (8123, '', 1, '', 48062, 'D');
INSERT INTO "invoices" VALUES (8124, '', 1, '', 129245, 'A');
INSERT INTO "invoices" VALUES (8126, '', 1, '', 87846, 'A');
INSERT INTO "invoices" VALUES (8127, '', 2, '', 122320, 'Z');
INSERT INTO "invoices" VALUES (8128, '', 2, '', 115142, 'H');
INSERT INTO "invoices" VALUES (8130, '', 1, '', 777036, 'Z');
INSERT INTO "invoices" VALUES (8131, '', 1, '', 2218, 'A');
INSERT INTO "invoices" VALUES (8131, '', 1, '', 103178, 'H');
INSERT INTO "invoices" VALUES (8132, '', 3, '', 97427, 'R');
INSERT INTO "invoices" VALUES (8132, '', 3, '', 632, 'A');
INSERT INTO "invoices" VALUES (8132, '', 3, '', 1221, 'Z');
INSERT INTO "invoices" VALUES (8133, '', 1, '', 777036, 'Z');
INSERT INTO "invoices" VALUES (8134, '', 1, '', 777036, 'Z');
INSERT INTO "invoices" VALUES (8135, '', 1, '', 602551, 'A');
INSERT INTO "invoices" VALUES (8135, '', 1, '', 291443, 'E');
INSERT INTO "invoices" VALUES (8136, '', 1, '', 802928, 'A');
INSERT INTO "invoices" VALUES (8137, '', 1, '', 68208, 'E');
INSERT INTO "invoices" VALUES (8138, '', 1, '', 793801, 'H');
INSERT INTO "invoices" VALUES (8139, '', 1, '', 277883, 'A');
INSERT INTO "invoices" VALUES (8140, '', 3, '', 276614, 'Z');
INSERT INTO "invoices" VALUES (8141, '', 1, '', 108790, 'R');
INSERT INTO "invoices" VALUES (8144, '', 1, '', 114305, 'R');
INSERT INTO "invoices" VALUES (8145, '', 1, '', 119644, 'A');
INSERT INTO "invoices" VALUES (8146, '', 1, '', 93914, 'R');
INSERT INTO "invoices" VALUES (8147, '', 1, '', 116922, 'H');
INSERT INTO "invoices" VALUES (8148, '', 2, '', 119799, 'H');
INSERT INTO "invoices" VALUES (8149, '', 1, '', 87847, 'H');
INSERT INTO "invoices" VALUES (8150, '', 1, '', 69482, 'Z');
INSERT INTO "invoices" VALUES (8151, '', 1, '', 20672, 'A');
INSERT INTO "invoices" VALUES (8152, '', 1, '', 28024, 'R');
INSERT INTO "invoices" VALUES (8152, '', 1, '', 41058, 'D');
INSERT INTO "invoices" VALUES (8153, '', 1, '', 61158, 'D');
INSERT INTO "invoices" VALUES (8153, '', 1, '', 81506, 'R');
INSERT INTO "invoices" VALUES (8154, '', 1, '', 47169, 'A');
INSERT INTO "invoices" VALUES (8155, '', 1, '', 120302, 'A');
INSERT INTO "invoices" VALUES (8157, '', 1, '', 186186, 'A');
INSERT INTO "invoices" VALUES (8158, '', 1, '', 680504, 'A');
INSERT INTO "invoices" VALUES (8159, '', 1, '', 120466, 'A');
INSERT INTO "invoices" VALUES (8160, '', 1, '', 330, 'H');
INSERT INTO "invoices" VALUES (8160, '', 1, '', 72550, 'E');
INSERT INTO "invoices" VALUES (8161, '', 1, '', 826236, 'Z');
INSERT INTO "invoices" VALUES (8162, '', 1, '', 400644, 'A');
INSERT INTO "invoices" VALUES (8163, '', 1, '', 386187, 'R');
INSERT INTO "invoices" VALUES (8163, '', 1, '', 455079, 'D');
INSERT INTO "invoices" VALUES (8164, '', 2, '', 858939, 'A');
INSERT INTO "invoices" VALUES (8165, '', 1, '', 711291, 'E');
INSERT INTO "invoices" VALUES (8166, '', 2, '', 275734, 'A');
INSERT INTO "invoices" VALUES (8167, '', 2, '', 25342, 'Z');
INSERT INTO "invoices" VALUES (8168, '', 2, '', 79841, 'Z');
INSERT INTO "invoices" VALUES (8169, '', 1, '', 89974, 'A');
INSERT INTO "invoices" VALUES (8170, '', 1, '', 94580, 'A');
INSERT INTO "invoices" VALUES (8171, '', 1, '', 59231, 'Z');
INSERT INTO "invoices" VALUES (8172, '', 1, '', 64818, 'Z');
INSERT INTO "invoices" VALUES (8173, '', 1, '', 66234, 'H');
INSERT INTO "invoices" VALUES (8174, '', 1, '', 123771, 'H');
INSERT INTO "invoices" VALUES (8175, '', 2, '', 134783, 'Z');
INSERT INTO "invoices" VALUES (8188, '', 2, '', 886861, 'Z');
INSERT INTO "invoices" VALUES (8189, '', 1, '', 897725, 'A');
INSERT INTO "invoices" VALUES (8190, '', 1, '', 62169, 'A');
INSERT INTO "invoices" VALUES (8191, '', 3, '', 304380, 'Z');
INSERT INTO "invoices" VALUES (8192, '', 2, '', 317609, 'A');
INSERT INTO "invoices" VALUES (8194, '', 2, '', 94391, 'Z');
INSERT INTO "invoices" VALUES (8195, '', 1, '', 107276, 'A');
INSERT INTO "invoices" VALUES (8196, '', 2, '', 63189, 'A');
INSERT INTO "invoices" VALUES (8197, '', 2, '', 76851, 'A');
INSERT INTO "invoices" VALUES (8198, '', 2, '', 48266, 'Z');
INSERT INTO "invoices" VALUES (8199, '', 2, '', 133229, 'A');
INSERT INTO "invoices" VALUES (8200, '', 2, '', 123829, 'Z');
INSERT INTO "invoices" VALUES (8202, '', 2, '', 1748, 'A');
INSERT INTO "invoices" VALUES (8202, '', 2, '', 76773, 'H');
INSERT INTO "invoices" VALUES (8203, '', 2, '', 88955, 'Z');
INSERT INTO "invoices" VALUES (8204, '', 1, '', 133332, 'A');
INSERT INTO "invoices" VALUES (8205, '', 2, '', 346758, 'A');
INSERT INTO "invoices" VALUES (8206, '', 1, '', 65616, 'Z');
INSERT INTO "invoices" VALUES (8206, '', 1, '', 65616, 'A');
INSERT INTO "invoices" VALUES (8207, '', 1, '', 254877, 'A');
INSERT INTO "invoices" VALUES (8208, '', 1, '', 108435, 'R');
INSERT INTO "invoices" VALUES (8208, '', 1, '', 311, 'A');
INSERT INTO "invoices" VALUES (8209, '', 3, '', 254877, 'A');
INSERT INTO "invoices" VALUES (8210, '', 1, '', 69951, 'D');
INSERT INTO "invoices" VALUES (8211, '', 1, '', 1008278, 'R');
INSERT INTO "invoices" VALUES (8212, '', 1, '', 1067519, 'A');
INSERT INTO "invoices" VALUES (8213, '', 1, '', 405297, 'A');
INSERT INTO "invoices" VALUES (8216, '', 3, '', 266032, 'Z');
INSERT INTO "invoices" VALUES (8217, '', 2, '', 884506, 'Z');
INSERT INTO "invoices" VALUES (8218, '', 1, '', 1008000, 'A');
INSERT INTO "invoices" VALUES (8219, '', 2, '', 830809, 'A');
INSERT INTO "invoices" VALUES (8220, '', 1, '', 93142, 'A');
INSERT INTO "invoices" VALUES (8222, '', 1, '', 128701, 'A');
INSERT INTO "invoices" VALUES (8223, '', 2, '', 173692, 'E');
INSERT INTO "invoices" VALUES (8224, '', 1, '', 254876, 'A');
INSERT INTO "invoices" VALUES (8228, '', 1, '', 191943, 'A');
INSERT INTO "invoices" VALUES (8229, '', 2, '', 83880, 'H');
INSERT INTO "invoices" VALUES (8230, '', 1, '', 162745, 'Z');
INSERT INTO "invoices" VALUES (8231, '', 2, '', 58060, 'D');
INSERT INTO "invoices" VALUES (8231, '', 2, '', 88680, 'R');
INSERT INTO "invoices" VALUES (8232, '', 2, '', 92989, 'A');
INSERT INTO "invoices" VALUES (8234, '', 2, '', 139004, 'A');
INSERT INTO "invoices" VALUES (8235, '', 1, '', 110978, 'D');
INSERT INTO "invoices" VALUES (8236, '', 1, '', 138148, 'Z');
INSERT INTO "invoices" VALUES (8237, '', 1, '', 125897, 'A');
INSERT INTO "invoices" VALUES (8238, '', 1, '', 222, 'D');
INSERT INTO "invoices" VALUES (8238, '', 1, '', 103800, 'R');
INSERT INTO "invoices" VALUES (8239, '', 1, '', 85897, 'E');
INSERT INTO "invoices" VALUES (8239, '', 1, '', 1873, 'H');
INSERT INTO "invoices" VALUES (8240, '', 1, '', 155952, 'A');
INSERT INTO "invoices" VALUES (8241, '', 1, '', 990961, 'A');
INSERT INTO "invoices" VALUES (8242, '', 1, '', 1045376, 'Z');
INSERT INTO "invoices" VALUES (8243, '', 1, '', 280885, 'A');
INSERT INTO "invoices" VALUES (8244, '', 1, '', 1000461, 'A');
INSERT INTO "invoices" VALUES (8245, '', 1, '', 997218, 'H');
INSERT INTO "invoices" VALUES (8246, '', 1, '', 148819, 'A');
INSERT INTO "invoices" VALUES (8246, '', 1, '', 108567, 'D');
INSERT INTO "invoices" VALUES (8247, '', 1, '', 9640, 'A');
INSERT INTO "invoices" VALUES (8248, '', 1, '', 166128, 'Z');
INSERT INTO "invoices" VALUES (8249, '', 1, '', 200976, 'Z');
INSERT INTO "invoices" VALUES (8250, '', 2, '', 120593, 'A');
INSERT INTO "invoices" VALUES (8251, '', 2, '', 87103, 'E');
INSERT INTO "invoices" VALUES (8253, '', 1, '', 119694, 'A');
INSERT INTO "invoices" VALUES (8254, '', 3, '', 108538, 'E');
INSERT INTO "invoices" VALUES (8255, '', 2, '', 118029, 'D');
INSERT INTO "invoices" VALUES (8256, '', 2, '', 2303, 'A');
INSERT INTO "invoices" VALUES (8256, '', 2, '', 161522, 'Z');
INSERT INTO "invoices" VALUES (8257, '', 1, '', 1370, 'A');
INSERT INTO "invoices" VALUES (8258, '', 1, '', 2511, 'Z');
INSERT INTO "invoices" VALUES (8259, '', 1, '', 75459, 'A');
INSERT INTO "invoices" VALUES (8260, '', 1, '', 75162, 'R');
INSERT INTO "invoices" VALUES (8261, '', 2, '', 72226, 'D');
INSERT INTO "invoices" VALUES (8262, '', 2, '', 114862, 'A');
INSERT INTO "invoices" VALUES (8263, '', 1, '', 68402, 'A');
INSERT INTO "invoices" VALUES (8264, '', 1, '', 45639, 'A');
INSERT INTO "invoices" VALUES (8265, '', 1, '', 76391, 'Z');
INSERT INTO "invoices" VALUES (8268, '', 1, '', 58465, 'H');
INSERT INTO "invoices" VALUES (8269, '', 2, '', 76750, 'E');
INSERT INTO "invoices" VALUES (8270, '', 1, '', 114626, 'Z');
INSERT INTO "invoices" VALUES (8271, '', 2, '', 2124, 'D');
INSERT INTO "invoices" VALUES (8271, '', 2, '', 2124, 'E');
INSERT INTO "invoices" VALUES (8271, '', 2, '', 2266, 'H');
INSERT INTO "invoices" VALUES (8271, '', 2, '', 2267, 'R');
INSERT INTO "invoices" VALUES (8271, '', 2, '', 7079, 'Z');
INSERT INTO "invoices" VALUES (8271, '', 2, '', 83663, 'A');
INSERT INTO "invoices" VALUES (8272, '', 1, '', 2390, 'R');
INSERT INTO "invoices" VALUES (8287, '', 3, '', 236077, 'Z');
INSERT INTO "invoices" VALUES (8289, '', 1, '', 1248, 'H');
INSERT INTO "invoices" VALUES (8290, '', 1, '', 1248, 'H');
INSERT INTO "invoices" VALUES (8290, '', 1, '', 140227, 'A');
INSERT INTO "invoices" VALUES (8291, '', 3, '', 100954, 'A');
INSERT INTO "invoices" VALUES (8292, '', 1, '', 56724, 'A');
INSERT INTO "invoices" VALUES (8293, '', 2, '', 113493, 'D');
INSERT INTO "invoices" VALUES (8294, '', 1, '', 105968, 'H');
INSERT INTO "invoices" VALUES (8295, '', 2, '', 141703, 'Z');
INSERT INTO "invoices" VALUES (8296, '', 3, '', 146133, 'Z');
INSERT INTO "invoices" VALUES (8297, '', 1, '', 228423, 'A');
INSERT INTO "invoices" VALUES (8298, '', 1, '', 142195, 'Z');
INSERT INTO "invoices" VALUES (8300, '', 2, '', 9189, 'A');
INSERT INTO "invoices" VALUES (8301, '', 1, '', 628, 'Z');
INSERT INTO "invoices" VALUES (8301, '', 1, '', 134267, 'R');
INSERT INTO "invoices" VALUES (8302, '', 1, '', 164435, 'A');
INSERT INTO "invoices" VALUES (8303, '', 2, '', 112641, 'E');
INSERT INTO "invoices" VALUES (8303, '', 2, '', 1087, 'H');
INSERT INTO "invoices" VALUES (8304, '', 3, '', 88076, 'A');
INSERT INTO "invoices" VALUES (8306, '', 2, '', 515, 'R');
INSERT INTO "invoices" VALUES (8306, '', 2, '', 144452, 'A');
INSERT INTO "invoices" VALUES (8307, '', 2, '', 428, 'D');
INSERT INTO "invoices" VALUES (8307, '', 2, '', 308892, 'A');
INSERT INTO "invoices" VALUES (8308, '', 2, '', 241684, 'A');
INSERT INTO "invoices" VALUES (8309, '', 1, '', 240504, 'Z');
INSERT INTO "invoices" VALUES (8310, '', 2, '', 7121, 'Z');
INSERT INTO "invoices" VALUES (8313, '', 1, '', 95528, 'Z');
INSERT INTO "invoices" VALUES (8314, '', 1, '', 120743, 'A');
INSERT INTO "invoices" VALUES (8315, '', 3, '', 109783, 'A');
INSERT INTO "invoices" VALUES (8316, '', 2, '', 7890, 'R');
INSERT INTO "invoices" VALUES (8317, '', 2, '', 107331, 'A');
INSERT INTO "invoices" VALUES (8319, '', 2, '', 96548, 'A');
INSERT INTO "invoices" VALUES (8320, '', 2, '', 79382, 'A');
INSERT INTO "invoices" VALUES (8321, '', 1, '', 134499, 'Z');
INSERT INTO "invoices" VALUES (8322, '', 4, '', 129221, 'A');
INSERT INTO "invoices" VALUES (8323, '', 3, '', 153204, 'A');
INSERT INTO "invoices" VALUES (8324, '', 1, '', 8849, 'A');
INSERT INTO "invoices" VALUES (8325, '', 3, '', 74441, 'Z');
INSERT INTO "invoices" VALUES (8326, '', 1, '', 81217, 'R');
INSERT INTO "invoices" VALUES (8327, '', 2, '', 81582, 'D');
INSERT INTO "invoices" VALUES (8328, '', 2, '', 69494, 'R');
INSERT INTO "invoices" VALUES (8329, '', 2, '', 112921, 'A');
INSERT INTO "invoices" VALUES (8330, '', 2, '', 739545, 'A');
INSERT INTO "invoices" VALUES (8331, '', 2, '', 789590, 'Z');
INSERT INTO "invoices" VALUES (8332, '', 2, '', 111728, 'A');
INSERT INTO "invoices" VALUES (8333, '', 2, '', 6222, 'A');
INSERT INTO "invoices" VALUES (8334, '', 3, '', 85864, 'R');
INSERT INTO "invoices" VALUES (8335, '', 2, '', 189317, 'A');
INSERT INTO "invoices" VALUES (8337, '', 2, '', 228507, 'A');
INSERT INTO "invoices" VALUES (8338, '', 2, '', 107625, 'A');
INSERT INTO "invoices" VALUES (8339, '', 3, '', 248209, 'Z');
INSERT INTO "invoices" VALUES (8341, '', 2, '', 152856, 'H');
INSERT INTO "invoices" VALUES (8342, '', 1, '', 181647, 'E');
INSERT INTO "invoices" VALUES (8343, '', 1, '', 84541, 'A');
INSERT INTO "invoices" VALUES (8344, '', 1, '', 152421, 'A');
INSERT INTO "invoices" VALUES (8345, '', 1, '', 113163, 'H');
INSERT INTO "invoices" VALUES (8346, '', 1, '', 133393, 'A');
INSERT INTO "invoices" VALUES (8347, '', 1, '', 115076, 'D');
INSERT INTO "invoices" VALUES (8348, '', 2, '', 187030, 'A');
INSERT INTO "invoices" VALUES (8349, '', 1, '', 138049, 'Z');
INSERT INTO "invoices" VALUES (8350, '', 1, '', 156338, 'A');
INSERT INTO "invoices" VALUES (8351, '', 2, '', 133731, 'E');
INSERT INTO "invoices" VALUES (8352, '', 1, '', 686906, 'H');
INSERT INTO "invoices" VALUES (8353, '', 2, '', 880794, 'Z');
INSERT INTO "invoices" VALUES (8354, '', 2, '', 80993, 'R');
INSERT INTO "invoices" VALUES (8354, '', 2, '', 55288, 'D');
INSERT INTO "invoices" VALUES (8355, '', 3, '', 677410, 'Z');
INSERT INTO "invoices" VALUES (8356, '', 1, '', 330617, 'A');
INSERT INTO "invoices" VALUES (8357, '', 2, '', 203086, 'A');
INSERT INTO "invoices" VALUES (8358, '', 1, '', 195785, 'Z');
INSERT INTO "invoices" VALUES (8359, '', 1, '', 112132, 'Z');
INSERT INTO "invoices" VALUES (8363, '', 1, '', 135474, 'R');
INSERT INTO "invoices" VALUES (8364, '', 3, '', 94894, 'A');
INSERT INTO "invoices" VALUES (8367, '', 3, '', 10379, 'D');
INSERT INTO "invoices" VALUES (8371, '', 3, '', 39482, 'E');
INSERT INTO "invoices" VALUES (8371, '', 3, '', 30122, 'H');
INSERT INTO "invoices" VALUES (8383, '', 1, '', 139517, 'A');
INSERT INTO "invoices" VALUES (8384, '', 1, '', NULL, 'E');
INSERT INTO "invoices" VALUES (8384, '', 1, '', 110574, 'H');
INSERT INTO "invoices" VALUES (8385, '', 4, '', 61361, 'Z');
INSERT INTO "invoices" VALUES (8386, '', 2, '', 81527, 'Z');
INSERT INTO "invoices" VALUES (8387, '', 1, '', 105616, 'A');
INSERT INTO "invoices" VALUES (8388, '', 2, '', 124126, 'E');
INSERT INTO "invoices" VALUES (8389, '', 2, '', 108272, 'A');
INSERT INTO "invoices" VALUES (8390, '', 3, '', 91988, 'Z');
INSERT INTO "invoices" VALUES (8391, '', 3, '', 7226, 'Z');
INSERT INTO "invoices" VALUES (8392, '', 1, '', 550442, 'D');
INSERT INTO "invoices" VALUES (8393, '', 1, '', 698006, 'A');
INSERT INTO "invoices" VALUES (8394, '', 1, '', 716139, 'Z');
INSERT INTO "invoices" VALUES (8395, '', 2, '', 714079, 'A');
INSERT INTO "invoices" VALUES (8396, '', 3, '', 457491, 'A');
INSERT INTO "invoices" VALUES (8397, '', 1, '', 365373, 'Z');
INSERT INTO "invoices" VALUES (8399, '', 1, '', 50232, 'Z');
INSERT INTO "invoices" VALUES (8400, '', 1, '', 85711, 'A');
INSERT INTO "invoices" VALUES (8401, '', 1, '', 106435, 'A');

CREATE TABLE "passengers" (
	"number"               integer	NOT NULL,
	"number_sup"           char(1)	NOT NULL,
	"trip"                 integer,
	"trip_sup"             char(1),
	"onboard_at_departure" integer,
	"death_at_cape"        integer,
	"left_at_cape"         integer,
	"onboard_at_cape"      integer,
	"death_during_voyage"  integer,
	"onboard_at_arrival"   integer
);

INSERT INTO "passengers" VALUES (310, '', 2, '', 66, NULL, NULL, NULL, 2, 64);
INSERT INTO "passengers" VALUES (311, '', 2, '', 55, NULL, NULL, NULL, 5, 55);
INSERT INTO "passengers" VALUES (318, '', 5, '', 17, NULL, NULL, NULL, 4, 13);
INSERT INTO "passengers" VALUES (320, '', 3, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (321, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (335, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (340, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (469, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (557, '', 1, '', NULL, NULL, NULL, NULL, NULL, 13);
INSERT INTO "passengers" VALUES (559, '', 1, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (560, '', 5, '', NULL, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (561, '', 2, '', NULL, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (564, '', 2, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (567, '', 1, '', NULL, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (569, '', 1, '', NULL, NULL, NULL, NULL, NULL, 19);
INSERT INTO "passengers" VALUES (659, '', 3, '', NULL, NULL, NULL, NULL, 2, NULL);
INSERT INTO "passengers" VALUES (685, '', 4, '', NULL, NULL, NULL, NULL, NULL, 18);
INSERT INTO "passengers" VALUES (687, '', 2, '', NULL, NULL, NULL, NULL, NULL, 11);
INSERT INTO "passengers" VALUES (691, '', 1, '', NULL, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (693, '', 1, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (694, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (695, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (706, '', 2, '', NULL, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (707, '', 9, '', NULL, NULL, NULL, NULL, NULL, 10);
INSERT INTO "passengers" VALUES (723, '', 1, '', NULL, NULL, NULL, NULL, NULL, 11);
INSERT INTO "passengers" VALUES (724, '', 5, '', NULL, NULL, NULL, NULL, NULL, 18);
INSERT INTO "passengers" VALUES (726, '', 3, '', NULL, NULL, NULL, NULL, NULL, 16);
INSERT INTO "passengers" VALUES (727, '', 6, '', NULL, NULL, NULL, NULL, NULL, 18);
INSERT INTO "passengers" VALUES (728, '', 4, '', NULL, NULL, NULL, NULL, NULL, 25);
INSERT INTO "passengers" VALUES (730, '', 2, '', NULL, NULL, NULL, NULL, NULL, 17);
INSERT INTO "passengers" VALUES (731, '', 2, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (732, '', 8, '', NULL, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (733, '', 5, '', NULL, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (734, '', 5, '', NULL, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (735, '', 1, '', NULL, NULL, NULL, NULL, NULL, 33);
INSERT INTO "passengers" VALUES (737, '', 1, '', NULL, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (738, '', 2, '', NULL, NULL, NULL, NULL, NULL, 26);
INSERT INTO "passengers" VALUES (741, '', 4, '', NULL, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (742, '', 6, '', NULL, NULL, NULL, NULL, NULL, 16);
INSERT INTO "passengers" VALUES (743, '', 6, '', NULL, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (744, '', 6, '', NULL, NULL, NULL, NULL, NULL, 16);
INSERT INTO "passengers" VALUES (745, '', 5, '', NULL, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (746, '', 1, '', NULL, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (747, '', 1, '', NULL, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (749, '', 5, '', NULL, NULL, NULL, NULL, NULL, 14);
INSERT INTO "passengers" VALUES (750, '', 3, '', NULL, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (751, '', 1, '', NULL, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (752, '', 9, '', NULL, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (753, '', 7, '', NULL, NULL, NULL, NULL, NULL, 14);
INSERT INTO "passengers" VALUES (761, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (762, '', 1, '', NULL, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (763, '', 1, '', NULL, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (766, '', 1, '', NULL, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (767, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (769, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (770, '', 2, '', NULL, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (776, '', 5, '', NULL, NULL, NULL, NULL, NULL, 14);
INSERT INTO "passengers" VALUES (782, '', 1, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (803, '', 7, '', NULL, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (805, '', 8, '', NULL, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (826, '', 1, '', NULL, NULL, NULL, NULL, NULL, 11);
INSERT INTO "passengers" VALUES (827, '', 1, '', NULL, NULL, NULL, NULL, NULL, 10);
INSERT INTO "passengers" VALUES (830, '', 6, '', NULL, NULL, NULL, NULL, NULL, 11);
INSERT INTO "passengers" VALUES (831, '', 1, '', NULL, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (835, '', 2, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (836, '', 2, '', NULL, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (837, '', 2, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (840, '', 1, '', NULL, NULL, NULL, NULL, NULL, 10);
INSERT INTO "passengers" VALUES (841, '', 1, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (842, '', 1, '', NULL, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (843, '', 1, '', NULL, NULL, NULL, NULL, NULL, 10);
INSERT INTO "passengers" VALUES (845, '', 2, '', NULL, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (850, '', 3, '', NULL, NULL, NULL, NULL, NULL, 11);
INSERT INTO "passengers" VALUES (851, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (855, '', 5, '', NULL, NULL, NULL, NULL, NULL, 19);
INSERT INTO "passengers" VALUES (858, '', 8, '', NULL, NULL, 3, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (859, '', 1, '', NULL, NULL, NULL, 4, NULL, 5);
INSERT INTO "passengers" VALUES (862, '', 7, '', 14, NULL, NULL, NULL, NULL, 14);
INSERT INTO "passengers" VALUES (863, '', 7, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (864, '', 2, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (865, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (866, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (873, '', 8, '', NULL, NULL, NULL, NULL, NULL, 15);
INSERT INTO "passengers" VALUES (874, '', 8, '', 8, NULL, NULL, 1, 1, 8);
INSERT INTO "passengers" VALUES (875, '', 9, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (876, '', 8, '', NULL, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (877, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (878, '', 1, '', NULL, NULL, NULL, 7, NULL, 13);
INSERT INTO "passengers" VALUES (879, '', 2, '', NULL, NULL, NULL, 16, NULL, 21);
INSERT INTO "passengers" VALUES (880, '', 2, '', NULL, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (881, '', 2, '', NULL, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (882, '', 1, '', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (883, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (884, '', 3, '', NULL, NULL, NULL, 30, NULL, 32);
INSERT INTO "passengers" VALUES (885, '', 4, '', NULL, NULL, NULL, NULL, NULL, 14);
INSERT INTO "passengers" VALUES (886, '', 1, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (888, '', 9, '', NULL, NULL, NULL, NULL, NULL, 15);
INSERT INTO "passengers" VALUES (889, '', 7, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (892, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (894, '', 2, '', 8, NULL, 8, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (897, '', 4, '', 14, NULL, NULL, NULL, NULL, 14);
INSERT INTO "passengers" VALUES (898, '', 6, '', 7, NULL, 2, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (900, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (903, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (905, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (906, '', 8, '', 7, NULL, 2, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (907, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (908, '', 8, '', 8, NULL, 1, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (909, '', 8, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (910, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (913, '', 3, '', NULL, NULL, NULL, 2, NULL, 12);
INSERT INTO "passengers" VALUES (917, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (919, '', 9, '', 21, NULL, NULL, 2, 2, 21);
INSERT INTO "passengers" VALUES (920, '', 1, '', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (922, '', 1, '', NULL, NULL, NULL, 58, NULL, 59);
INSERT INTO "passengers" VALUES (923, '', 4, '', 3, NULL, NULL, 58, NULL, 61);
INSERT INTO "passengers" VALUES (924, '', 9, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (925, '', 1, '', NULL, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (927, '', 1, '', 2, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (928, '', 9, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (931, '', 1, '', 12, NULL, NULL, NULL, 1, 11);
INSERT INTO "passengers" VALUES (932, '', 2, '', 3, NULL, NULL, 2, NULL, 5);
INSERT INTO "passengers" VALUES (933, '', 4, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (937, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (938, '', 5, '', 13, NULL, NULL, 1, 1, 14);
INSERT INTO "passengers" VALUES (939, '', 3, '', 15, NULL, 1, NULL, 2, 12);
INSERT INTO "passengers" VALUES (940, '', 3, '', 17, NULL, 4, NULL, NULL, 13);
INSERT INTO "passengers" VALUES (941, '', 1, '', 4, NULL, NULL, NULL, 1, 4);
INSERT INTO "passengers" VALUES (948, '', 1, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (950, '', 5, '', 15, NULL, NULL, NULL, 5, 11);
INSERT INTO "passengers" VALUES (951, '', 7, '', 5, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (952, '', 1, '', 5, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (953, '', 8, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (954, '', 4, '', 10, NULL, 4, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (955, '', 9, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (956, '', 4, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (957, '', 1, '', 9, NULL, NULL, NULL, 1, 8);
INSERT INTO "passengers" VALUES (959, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (962, '', 2, '', 8, NULL, NULL, NULL, 1, 7);
INSERT INTO "passengers" VALUES (963, '', 2, '', NULL, NULL, NULL, 11, NULL, 11);
INSERT INTO "passengers" VALUES (965, '', 1, '', 7, NULL, 1, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (966, '', 9, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "passengers" VALUES (967, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (968, '', 1, '', 8, NULL, 5, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (969, '', 1, '', 6, NULL, 3, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (971, '', 1, '', 7, NULL, 2, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (972, '', 9, '', 10, NULL, 1, 6, 2, 13);
INSERT INTO "passengers" VALUES (973, '', 1, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "passengers" VALUES (977, '', 2, '', 14, NULL, NULL, NULL, 1, 13);
INSERT INTO "passengers" VALUES (979, '', 1, '', 2, NULL, NULL, 5, NULL, 7);
INSERT INTO "passengers" VALUES (980, '', 1, '', 5, NULL, NULL, 1, NULL, 6);
INSERT INTO "passengers" VALUES (981, '', 1, '', 6, NULL, NULL, 7, NULL, 13);
INSERT INTO "passengers" VALUES (982, '', 1, '', NULL, NULL, NULL, 4, NULL, 4);
INSERT INTO "passengers" VALUES (983, '', 1, '', NULL, NULL, NULL, 7, NULL, 7);
INSERT INTO "passengers" VALUES (984, '', 2, '', 4, NULL, NULL, 9, NULL, 13);
INSERT INTO "passengers" VALUES (986, '', 8, '', 9, NULL, NULL, NULL, NULL, 10);
INSERT INTO "passengers" VALUES (988, '', 5, '', 5, NULL, NULL, 1, 1, 5);
INSERT INTO "passengers" VALUES (989, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (990, '', 1, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (991, '', 1, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (992, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (996, '', 1, '', 10, NULL, NULL, NULL, NULL, 11);
INSERT INTO "passengers" VALUES (997, '', 1, '', 3, NULL, 3, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1000, '', 1, '', 5, NULL, 1, NULL, 1, 3);
INSERT INTO "passengers" VALUES (1001, '', 1, '', 2, NULL, NULL, 1, NULL, 3);
INSERT INTO "passengers" VALUES (1002, '', 1, '', 5, NULL, 2, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1004, '', 6, '', 18, NULL, NULL, NULL, NULL, 18);
INSERT INTO "passengers" VALUES (1005, '', 10, '', 10, NULL, 1, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (1006, '', 2, '', 11, NULL, 1, NULL, NULL, 10);
INSERT INTO "passengers" VALUES (1009, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1010, '', 1, '', 15, NULL, NULL, NULL, NULL, 15);
INSERT INTO "passengers" VALUES (1011, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1012, '', 2, '', 14, NULL, 1, NULL, NULL, 13);
INSERT INTO "passengers" VALUES (1013, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1014, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1015, '', 5, '', 7, NULL, 4, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1021, '', 5, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "passengers" VALUES (1022, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1024, '', 1, '', 7, NULL, 3, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1026, '', 2, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "passengers" VALUES (1028, '', 3, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "passengers" VALUES (1029, '', 1, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1033, '', 2, '', 1, NULL, NULL, 11, NULL, 12);
INSERT INTO "passengers" VALUES (1034, '', 1, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (1035, '', 1, '', 10, NULL, NULL, NULL, 3, 7);
INSERT INTO "passengers" VALUES (1036, '', 1, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1038, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1039, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1043, '', 2, '', 5, NULL, 3, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1044, '', 1, '', 2, NULL, 2, 2, NULL, 2);
INSERT INTO "passengers" VALUES (1045, '', 5, '', 11, NULL, 6, 1, 1, 5);
INSERT INTO "passengers" VALUES (1046, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1047, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1048, '', 1, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1051, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1052, '', 2, '', 6, NULL, 4, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1053, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1054, '', 2, '', 5, NULL, 1, NULL, 2, 2);
INSERT INTO "passengers" VALUES (1056, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1057, '', 1, '', 12, NULL, NULL, 2, NULL, 14);
INSERT INTO "passengers" VALUES (1058, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1062, '', 1, '', 4, NULL, 2, NULL, 2, NULL);
INSERT INTO "passengers" VALUES (1063, '', 3, '', 4, NULL, NULL, 2, NULL, 6);
INSERT INTO "passengers" VALUES (1064, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1068, '', 2, '', 5, NULL, NULL, 6, NULL, 11);
INSERT INTO "passengers" VALUES (1069, '', 2, '', 4, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1070, '', 1, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1071, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1073, '', 1, '', 9, NULL, NULL, NULL, 2, 7);
INSERT INTO "passengers" VALUES (1075, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1077, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1081, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1083, '', 1, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1084, '', 1, '', 1, NULL, NULL, 2, NULL, 3);
INSERT INTO "passengers" VALUES (1087, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1088, '', 1, '', 9, NULL, NULL, NULL, 1, 8);
INSERT INTO "passengers" VALUES (1093, '', 1, '', 10, NULL, NULL, NULL, 1, 9);
INSERT INTO "passengers" VALUES (1094, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1096, '', 2, '', 9, NULL, NULL, 6, NULL, 15);
INSERT INTO "passengers" VALUES (1097, '', 2, '', 12, NULL, NULL, NULL, NULL, 12);
INSERT INTO "passengers" VALUES (1098, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1100, '', 2, '', 12, NULL, NULL, NULL, 1, 11);
INSERT INTO "passengers" VALUES (1101, '', 6, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1104, '', 2, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1105, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1107, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1111, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1112, '', 1, '', 12, NULL, 1, NULL, NULL, 11);
INSERT INTO "passengers" VALUES (1113, '', 2, '', 8, NULL, 5, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1122, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1124, '', 1, '', 9, NULL, 1, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1125, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1126, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1128, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1131, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1133, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1135, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1141, '', 1, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "passengers" VALUES (1142, '', 1, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1143, '', 1, '', 12, NULL, NULL, NULL, NULL, 12);
INSERT INTO "passengers" VALUES (1151, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1152, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1153, '', 2, '', 11, NULL, 5, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1159, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1160, '', 2, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "passengers" VALUES (1161, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1163, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1165, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1166, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1167, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1169, '', 1, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1170, '', 2, '', 21, NULL, NULL, NULL, NULL, 21);
INSERT INTO "passengers" VALUES (1171, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1173, '', 2, '', 14, NULL, 1, NULL, NULL, 13);
INSERT INTO "passengers" VALUES (1174, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1176, '', 2, '', 12, NULL, NULL, NULL, 1, 12);
INSERT INTO "passengers" VALUES (1178, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1179, '', 1, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1181, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1183, '', 2, '', 5, NULL, 5, 4, NULL, 4);
INSERT INTO "passengers" VALUES (1184, '', 2, '', 23, NULL, 10, NULL, NULL, 13);
INSERT INTO "passengers" VALUES (1185, '', 2, '', 7, NULL, 1, NULL, 4, 2);
INSERT INTO "passengers" VALUES (1186, '', 1, '', 25, NULL, 2, NULL, 1, 24);
INSERT INTO "passengers" VALUES (1187, '', 2, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1189, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1190, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1193, '', 2, '', 22, NULL, NULL, NULL, 2, 20);
INSERT INTO "passengers" VALUES (1194, '', 2, '', 6, NULL, 1, 1, NULL, 6);
INSERT INTO "passengers" VALUES (1195, '', 3, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "passengers" VALUES (1197, '', 2, '', 10, NULL, NULL, NULL, 1, 9);
INSERT INTO "passengers" VALUES (1200, '', 3, '', 4, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1201, '', 3, '', 3, NULL, 2, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1205, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1206, '', 7, '', 7, NULL, NULL, NULL, 1, 6);
INSERT INTO "passengers" VALUES (1207, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1208, '', 1, '', 12, NULL, NULL, NULL, NULL, 12);
INSERT INTO "passengers" VALUES (1209, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1210, '', 1, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "passengers" VALUES (1214, '', 5, '', 7, NULL, 1, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1215, '', 3, '', 8, NULL, 4, NULL, 4, NULL);
INSERT INTO "passengers" VALUES (1219, '', 1, '', 8, NULL, 7, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (1220, '', 4, '', 15, NULL, NULL, NULL, 2, 13);
INSERT INTO "passengers" VALUES (1221, '', 2, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1225, '', 2, '', 3, NULL, NULL, 17, NULL, 20);
INSERT INTO "passengers" VALUES (1226, '', 4, '', 13, NULL, 12, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1227, '', 3, '', 2, NULL, NULL, 4, NULL, 6);
INSERT INTO "passengers" VALUES (1229, '', 3, '', 24, NULL, 19, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1231, '', 1, '', 11, NULL, NULL, NULL, 3, 10);
INSERT INTO "passengers" VALUES (1233, '', 1, '', 11, NULL, 1, NULL, 1, 10);
INSERT INTO "passengers" VALUES (1236, '', 1, '', 24, NULL, 5, 4, 6, 17);
INSERT INTO "passengers" VALUES (1239, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1244, '', 3, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1247, '', 3, '', 15, NULL, NULL, 1, 3, 13);
INSERT INTO "passengers" VALUES (1249, '', 3, '', 8, NULL, 3, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1250, '', 1, '', 4, NULL, 1, 9, NULL, 12);
INSERT INTO "passengers" VALUES (1253, '', 3, '', 4, NULL, NULL, 1, NULL, 5);
INSERT INTO "passengers" VALUES (1254, '', 2, '', 27, NULL, NULL, NULL, 7, 20);
INSERT INTO "passengers" VALUES (1255, '', 1, '', 9, NULL, NULL, NULL, NULL, 10);
INSERT INTO "passengers" VALUES (1260, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1261, '', 1, '', 15, NULL, 1, NULL, 1, 13);
INSERT INTO "passengers" VALUES (1267, '', 1, '', 17, NULL, 10, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1270, '', 1, '', 7, NULL, 1, 1, 1, 7);
INSERT INTO "passengers" VALUES (1271, '', 1, '', 7, NULL, NULL, NULL, 3, 4);
INSERT INTO "passengers" VALUES (1274, '', 1, '', 14, NULL, NULL, NULL, 5, 11);
INSERT INTO "passengers" VALUES (1277, '', 1, '', 3, NULL, NULL, 2, NULL, 5);
INSERT INTO "passengers" VALUES (1279, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1284, '', 1, '', 13, NULL, NULL, NULL, 2, 11);
INSERT INTO "passengers" VALUES (1285, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1286, '', 1, '', 11, NULL, NULL, NULL, NULL, 11);
INSERT INTO "passengers" VALUES (1287, '', 3, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (1288, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1289, '', 1, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (1290, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1291, '', 3, '', 7, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1292, '', 3, '', 4, NULL, NULL, 2, NULL, 6);
INSERT INTO "passengers" VALUES (1293, '', 1, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1294, '', 1, '', 14, NULL, NULL, NULL, 1, 13);
INSERT INTO "passengers" VALUES (1295, '', 4, '', 17, NULL, NULL, NULL, NULL, 17);
INSERT INTO "passengers" VALUES (1297, '', 1, '', 6, NULL, NULL, 5, NULL, 11);
INSERT INTO "passengers" VALUES (1314, '', 2, '', 18, NULL, NULL, 2, 2, 18);
INSERT INTO "passengers" VALUES (1315, '', 4, '', 20, NULL, NULL, NULL, 2, 17);
INSERT INTO "passengers" VALUES (1317, '', 4, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1318, '', 4, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (1319, '', 4, '', 2, NULL, NULL, 11, NULL, 13);
INSERT INTO "passengers" VALUES (1320, '', 2, '', 21, NULL, NULL, NULL, NULL, 24);
INSERT INTO "passengers" VALUES (1325, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1326, '', 4, '', 4, NULL, NULL, 3, NULL, 7);
INSERT INTO "passengers" VALUES (1327, '', 2, '', NULL, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1329, '', 4, '', NULL, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1331, '', 2, '', 14, NULL, 6, 3, NULL, 11);
INSERT INTO "passengers" VALUES (1332, '', 2, '', 12, NULL, NULL, NULL, 2, 10);
INSERT INTO "passengers" VALUES (1339, '', 1, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (1340, '', 2, '', NULL, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1341, '', 2, '', 12, NULL, NULL, NULL, NULL, 13);
INSERT INTO "passengers" VALUES (1343, '', 2, '', 4, NULL, 3, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1345, '', 2, '', 3, NULL, NULL, 1, NULL, 4);
INSERT INTO "passengers" VALUES (1346, '', 2, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (1352, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1354, '', 1, '', 6, NULL, 3, 1, NULL, 4);
INSERT INTO "passengers" VALUES (1355, '', 1, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (1366, '', 4, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1368, '', 3, '', 7, NULL, 6, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1385, '', 5, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1394, '', 3, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1395, '', 1, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1397, '', 3, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1401, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1403, '', 3, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "passengers" VALUES (1404, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1412, '', 5, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1414, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1415, '', 3, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (1416, '', 5, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1417, '', 1, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1420, '', 4, '', 9, NULL, 1, NULL, 2, 8);
INSERT INTO "passengers" VALUES (1426, '', 3, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1427, '', 2, '', 3, NULL, 3, 25, NULL, 25);
INSERT INTO "passengers" VALUES (1429, '', 1, '', NULL, NULL, NULL, 10, NULL, 10);
INSERT INTO "passengers" VALUES (1431, '', 4, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "passengers" VALUES (1432, '', 1, '', 6, NULL, NULL, 15, NULL, 21);
INSERT INTO "passengers" VALUES (1433, '', 3, '', 12, NULL, 12, 2, NULL, 2);
INSERT INTO "passengers" VALUES (1434, '', 4, '', 11, NULL, NULL, 2, NULL, 13);
INSERT INTO "passengers" VALUES (1437, '', 6, '', 3, NULL, 3, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1438, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1439, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1440, '', 1, '', 9, NULL, NULL, NULL, 2, 7);
INSERT INTO "passengers" VALUES (1443, '', 5, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1444, '', 6, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1445, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1447, '', 3, '', 16, NULL, NULL, NULL, NULL, 16);
INSERT INTO "passengers" VALUES (1450, '', 4, '', 5, NULL, 2, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1454, '', 2, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (1455, '', 3, '', 5, NULL, 3, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1456, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1462, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1463, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1464, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1466, '', 1, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1469, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1474, '', 1, '', 18, NULL, 17, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1476, '', 3, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "passengers" VALUES (1478, '', 5, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1479, '', 3, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (1480, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1481, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1482, '', 2, '', 10, NULL, NULL, 1, NULL, 11);
INSERT INTO "passengers" VALUES (1483, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1485, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1487, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1488, '', 2, '', 7, NULL, NULL, 5, NULL, 15);
INSERT INTO "passengers" VALUES (1492, '', 1, '', 7, NULL, 6, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1495, '', 2, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1496, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1498, '', 1, '', 6, NULL, NULL, 1, NULL, 7);
INSERT INTO "passengers" VALUES (1499, '', 4, '', 11, NULL, NULL, NULL, NULL, 11);
INSERT INTO "passengers" VALUES (1500, '', 1, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1502, '', 6, '', 5, NULL, 5, 5, NULL, 5);
INSERT INTO "passengers" VALUES (1504, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1505, '', 5, '', 4, NULL, 3, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1507, '', 2, '', 11, NULL, 11, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1509, '', 1, '', 14, NULL, NULL, NULL, NULL, 14);
INSERT INTO "passengers" VALUES (1511, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1512, '', 1, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (1514, '', 1, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (1515, '', 2, '', 3, NULL, 3, 6, NULL, 6);
INSERT INTO "passengers" VALUES (1516, '', 1, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1517, '', 2, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1519, '', 7, '', 13, NULL, 2, NULL, NULL, 11);
INSERT INTO "passengers" VALUES (1521, '', 2, '', NULL, NULL, NULL, 30, NULL, 30);
INSERT INTO "passengers" VALUES (1522, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1523, '', 4, '', 9, NULL, 8, 2, NULL, 3);
INSERT INTO "passengers" VALUES (1525, '', 1, '', 3, NULL, 2, 7, NULL, 8);
INSERT INTO "passengers" VALUES (1529, '', 1, '', 9, NULL, 4, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1530, '', 2, '', 11, NULL, NULL, NULL, NULL, 11);
INSERT INTO "passengers" VALUES (1533, '', 3, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (1535, '', 3, '', 4, NULL, NULL, 2, 1, 5);
INSERT INTO "passengers" VALUES (1536, '', 1, '', 9, NULL, 2, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1537, '', 1, '', 16, NULL, 4, NULL, NULL, 12);
INSERT INTO "passengers" VALUES (1538, '', 6, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1539, '', 1, '', 5, NULL, 1, 5, 1, 8);
INSERT INTO "passengers" VALUES (1540, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1542, '', 2, '', 1, NULL, NULL, 2, NULL, 3);
INSERT INTO "passengers" VALUES (1543, '', 2, '', 10, NULL, 4, NULL, 2, 4);
INSERT INTO "passengers" VALUES (1544, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1545, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1546, '', 1, '', 8, NULL, 1, 3, NULL, 10);
INSERT INTO "passengers" VALUES (1547, '', 4, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (1551, '', 2, '', 10, NULL, 8, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1552, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1553, '', 2, '', 32, NULL, 22, NULL, NULL, 10);
INSERT INTO "passengers" VALUES (1554, '', 1, '', 6, NULL, 5, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (1555, '', 1, '', 2, NULL, NULL, 2, NULL, 4);
INSERT INTO "passengers" VALUES (1556, '', 3, '', 22, NULL, 11, 14, 3, 18);
INSERT INTO "passengers" VALUES (1557, '', 2, '', 33, NULL, 29, 16, 1, 19);
INSERT INTO "passengers" VALUES (1558, '', 2, '', 29, NULL, 27, 3, 1, 4);
INSERT INTO "passengers" VALUES (1560, '', 4, '', 38, NULL, 29, NULL, 8, 1);
INSERT INTO "passengers" VALUES (1561, '', 2, '', 35, NULL, 33, NULL, 1, 1);
INSERT INTO "passengers" VALUES (1562, '', 2, '', 13, NULL, 4, NULL, 2, 6);
INSERT INTO "passengers" VALUES (1563, '', 3, '', 7, NULL, 7, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1564, '', 6, '', 43, NULL, 27, 1, 12, 5);
INSERT INTO "passengers" VALUES (1573, '', 1, '', 4, NULL, NULL, 24, 1, 27);
INSERT INTO "passengers" VALUES (1574, '', 4, '', 4, NULL, 3, 21, 2, 20);
INSERT INTO "passengers" VALUES (1576, '', 2, '', NULL, NULL, NULL, 20, NULL, 20);
INSERT INTO "passengers" VALUES (1579, '', 5, '', 12, NULL, 7, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1580, '', 3, '', 14, NULL, 2, NULL, NULL, 12);
INSERT INTO "passengers" VALUES (1581, '', 2, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1582, '', 2, '', 10, NULL, NULL, 1, 2, 9);
INSERT INTO "passengers" VALUES (1583, '', 3, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1584, '', 1, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (1585, '', 1, '', 9, NULL, 1, NULL, 3, 5);
INSERT INTO "passengers" VALUES (1589, '', 1, '', NULL, NULL, NULL, 6, NULL, 6);
INSERT INTO "passengers" VALUES (1590, '', 2, '', 1, NULL, NULL, 10, 1, 10);
INSERT INTO "passengers" VALUES (1591, '', 1, '', 6, NULL, 6, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1592, '', 4, '', 6, NULL, 2, 1, 2, 3);
INSERT INTO "passengers" VALUES (1595, '', 1, '', 3, NULL, NULL, 9, NULL, 12);
INSERT INTO "passengers" VALUES (1596, '', 3, '', 2, NULL, 2, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1597, '', 5, '', 10, NULL, NULL, NULL, 1, 9);
INSERT INTO "passengers" VALUES (1598, '', 2, '', 6, NULL, 1, NULL, 1, 4);
INSERT INTO "passengers" VALUES (1599, '', 2, '', 9, NULL, 5, 2, 1, 4);
INSERT INTO "passengers" VALUES (1601, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1606, '', 3, '', 8, NULL, 7, 1, NULL, 2);
INSERT INTO "passengers" VALUES (1609, '', 2, '', 4, NULL, 4, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1611, '', 5, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1612, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1613, '', 3, '', 8, NULL, 1, NULL, 1, 6);
INSERT INTO "passengers" VALUES (1614, '', 1, '', 4, NULL, 2, 6, NULL, 8);
INSERT INTO "passengers" VALUES (1615, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1616, '', 3, '', 6, NULL, 3, 3, NULL, 6);
INSERT INTO "passengers" VALUES (1617, '', 2, '', 4, NULL, NULL, NULL, 3, 1);
INSERT INTO "passengers" VALUES (1618, '', 2, '', 10, NULL, 2, 1, 1, 8);
INSERT INTO "passengers" VALUES (1619, '', 2, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "passengers" VALUES (1620, '', 3, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1621, '', 3, '', 9, NULL, NULL, NULL, 5, 5);
INSERT INTO "passengers" VALUES (1622, '', 5, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1623, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1624, '', 2, '', 16, NULL, NULL, NULL, 5, 11);
INSERT INTO "passengers" VALUES (1625, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1627, '', 4, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1630, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1631, '', 1, '', 6, NULL, NULL, 3, 1, 8);
INSERT INTO "passengers" VALUES (1635, '', 1, '', 6, NULL, 1, 3, NULL, 8);
INSERT INTO "passengers" VALUES (1637, '', 1, '', 7, NULL, 2, NULL, 1, 4);
INSERT INTO "passengers" VALUES (1642, '', 2, '', 8, NULL, NULL, 1, 1, 8);
INSERT INTO "passengers" VALUES (1643, '', 4, '', 12, NULL, 3, 3, 2, 11);
INSERT INTO "passengers" VALUES (1644, '', 1, '', 12, NULL, 1, NULL, NULL, 11);
INSERT INTO "passengers" VALUES (1645, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1648, '', 1, '', 5, NULL, 1, 1, 1, 5);
INSERT INTO "passengers" VALUES (1649, '', 5, '', 16, NULL, 2, NULL, NULL, 13);
INSERT INTO "passengers" VALUES (1650, '', 1, '', 2, NULL, NULL, 5, 1, 6);
INSERT INTO "passengers" VALUES (1652, '', 5, '', 3, NULL, 3, 3, NULL, 3);
INSERT INTO "passengers" VALUES (1655, '', 1, '', 7, NULL, 7, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1657, '', 1, '', 5, NULL, 3, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1659, '', 2, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (1662, '', 1, '', 2, NULL, NULL, 6, NULL, 8);
INSERT INTO "passengers" VALUES (1664, '', 1, '', 7, NULL, 1, NULL, 2, 4);
INSERT INTO "passengers" VALUES (1667, '', 1, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1668, '', 1, '', 9, NULL, 1, 5, 2, 12);
INSERT INTO "passengers" VALUES (1670, '', 2, '', 3, NULL, 3, 10, NULL, 10);
INSERT INTO "passengers" VALUES (1672, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1673, '', 4, '', 5, NULL, 1, 3, NULL, 7);
INSERT INTO "passengers" VALUES (1674, '', 3, '', 7, NULL, 7, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1676, '', 3, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (1677, '', 1, '', 3, NULL, 1, 1, NULL, 3);
INSERT INTO "passengers" VALUES (1678, '', 1, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (1681, '', 1, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (1682, '', 2, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (1683, '', 1, '', 1, NULL, NULL, 2, NULL, 3);
INSERT INTO "passengers" VALUES (1684, '', 2, '', 3, NULL, NULL, 2, 2, 3);
INSERT INTO "passengers" VALUES (1685, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1686, '', 4, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1688, '', 3, '', 3, NULL, 1, NULL, 1, 1);
INSERT INTO "passengers" VALUES (1689, '', 3, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "passengers" VALUES (1691, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1692, '', 3, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (1693, '', 4, '', 4, NULL, 4, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1695, '', 2, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "passengers" VALUES (1697, '', 1, '', 3, NULL, NULL, 2, NULL, 5);
INSERT INTO "passengers" VALUES (1702, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1705, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1712, '', 2, '', 7, NULL, 2, 1, NULL, 6);
INSERT INTO "passengers" VALUES (1713, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1715, '', 2, '', 5, NULL, 3, 1, NULL, 3);
INSERT INTO "passengers" VALUES (1718, '', 2, '', 9, NULL, 4, 2, 3, 5);
INSERT INTO "passengers" VALUES (1723, '', 3, '', NULL, NULL, NULL, 6, NULL, 6);
INSERT INTO "passengers" VALUES (1725, '', 5, '', 4, NULL, 1, 1, NULL, 4);
INSERT INTO "passengers" VALUES (1726, '', 1, '', 5, NULL, 2, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1729, '', 2, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "passengers" VALUES (1731, '', 2, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1732, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1735, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1738, '', 2, '', 10, NULL, 5, 2, 5, 2);
INSERT INTO "passengers" VALUES (1740, '', 1, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (1743, '', 3, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1744, '', 2, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1746, '', 2, '', 13, NULL, 8, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1749, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1750, '', 3, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "passengers" VALUES (1751, '', 1, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "passengers" VALUES (1754, '', 2, '', 6, NULL, 3, NULL, 1, 3);
INSERT INTO "passengers" VALUES (1757, '', 3, '', 13, NULL, 7, 1, 1, 6);
INSERT INTO "passengers" VALUES (1758, '', 4, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1759, '', 4, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1760, '', 2, '', NULL, NULL, NULL, 7, NULL, 7);
INSERT INTO "passengers" VALUES (1761, '', 4, '', 12, NULL, 7, NULL, 1, 4);
INSERT INTO "passengers" VALUES (1762, '', 2, '', 21, NULL, 6, 1, NULL, 16);
INSERT INTO "passengers" VALUES (1765, '', 1, '', 2, NULL, NULL, 5, NULL, 7);
INSERT INTO "passengers" VALUES (1770, '', 1, '', 7, NULL, NULL, 7, 1, 13);
INSERT INTO "passengers" VALUES (1774, '', 3, '', 5, NULL, 1, 5, NULL, 9);
INSERT INTO "passengers" VALUES (1775, '', 1, '', 8, NULL, 8, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1776, '', 5, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1777, '', 3, '', 5, NULL, 5, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1778, '', 2, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (1779, '', 2, '', 19, NULL, NULL, NULL, 1, 18);
INSERT INTO "passengers" VALUES (1780, '', 2, '', 3, NULL, 1, 12, NULL, 14);
INSERT INTO "passengers" VALUES (1781, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1782, '', 2, '', 21, NULL, 20, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (1783, '', 3, '', 27, NULL, 17, 2, 2, 10);
INSERT INTO "passengers" VALUES (1784, '', 2, '', 5, NULL, 2, 4, NULL, 7);
INSERT INTO "passengers" VALUES (1785, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1789, '', 1, '', 3, NULL, NULL, 2, NULL, 5);
INSERT INTO "passengers" VALUES (1791, '', 3, '', 5, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1794, '', 3, '', 13, NULL, NULL, NULL, NULL, 13);
INSERT INTO "passengers" VALUES (1797, '', 3, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1798, '', 5, '', 13, NULL, 2, 2, NULL, 13);
INSERT INTO "passengers" VALUES (1799, '', 2, '', 10, NULL, 3, 1, NULL, 8);
INSERT INTO "passengers" VALUES (1800, '', 2, '', 11, NULL, 9, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1802, '', 1, '', 14, NULL, 9, 2, 1, 6);
INSERT INTO "passengers" VALUES (1803, '', 3, '', 5, NULL, 2, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1804, '', 4, '', 4, NULL, 4, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1805, '', 1, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1806, '', 4, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1807, '', 1, '', 4, NULL, 3, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1808, '', 3, '', 11, NULL, 5, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1810, '', 1, '', 14, NULL, 3, 1, NULL, 12);
INSERT INTO "passengers" VALUES (1811, '', 2, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1813, '', 1, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1814, '', 2, '', 2, NULL, NULL, 1, NULL, 3);
INSERT INTO "passengers" VALUES (1816, '', 1, '', NULL, NULL, NULL, 7, NULL, 7);
INSERT INTO "passengers" VALUES (1818, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1819, '', 3, '', 14, NULL, 7, 2, NULL, 10);
INSERT INTO "passengers" VALUES (1820, '', 1, '', 2, NULL, 2, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1835, '', 4, '', 13, NULL, 14, 1, NULL, NULL);
INSERT INTO "passengers" VALUES (1836, '', 3, '', 12, NULL, 12, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1838, '', 3, '', 13, NULL, 8, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1839, '', 1, '', 4, NULL, 3, 1, NULL, 2);
INSERT INTO "passengers" VALUES (1840, '', 4, '', 13, NULL, 8, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1842, '', 1, '', 7, NULL, 3, 4, NULL, 8);
INSERT INTO "passengers" VALUES (1843, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1844, '', 1, '', 15, NULL, 9, 1, NULL, 7);
INSERT INTO "passengers" VALUES (1845, '', 3, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1846, '', 3, '', 13, NULL, 1, NULL, 1, 11);
INSERT INTO "passengers" VALUES (1848, '', 1, '', 2, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1849, '', 3, '', 5, NULL, NULL, 1, NULL, 6);
INSERT INTO "passengers" VALUES (1850, '', 5, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1851, '', 4, '', 6, NULL, 1, 3, NULL, 9);
INSERT INTO "passengers" VALUES (1852, '', 4, '', 1, NULL, NULL, 3, NULL, 4);
INSERT INTO "passengers" VALUES (1854, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1855, '', 1, '', 10, NULL, 1, 1, NULL, 10);
INSERT INTO "passengers" VALUES (1856, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1857, '', 4, '', 7, NULL, 5, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1858, '', 5, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1859, '', 3, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1860, '', 5, '', 7, NULL, 1, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (1861, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1862, '', 4, '', 7, NULL, NULL, NULL, 1, 6);
INSERT INTO "passengers" VALUES (1863, '', 6, '', 8, NULL, 3, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1864, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1865, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1866, '', 1, '', 7, NULL, 7, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1867, '', 1, '', 3, NULL, NULL, 5, NULL, 8);
INSERT INTO "passengers" VALUES (1868, '', 2, '', 9, NULL, 4, 3, NULL, 8);
INSERT INTO "passengers" VALUES (1870, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1871, '', 4, '', NULL, NULL, NULL, 4, NULL, 4);
INSERT INTO "passengers" VALUES (1873, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1874, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1875, '', 2, '', 4, NULL, 1, 1, NULL, 4);
INSERT INTO "passengers" VALUES (1878, '', 1, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (1879, '', 4, '', 6, NULL, 2, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1880, '', 2, '', 3, NULL, 1, 2, NULL, 5);
INSERT INTO "passengers" VALUES (1881, '', 4, '', 8, NULL, NULL, 1, NULL, 9);
INSERT INTO "passengers" VALUES (1882, '', 3, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (1883, '', 4, '', 10, NULL, 1, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (1884, '', 1, '', 6, NULL, NULL, 1, NULL, 7);
INSERT INTO "passengers" VALUES (1886, '', 1, '', 10, NULL, 8, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1887, '', 4, '', 6, NULL, 6, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1888, '', 3, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (1889, '', 3, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1891, '', 4, '', NULL, NULL, NULL, 8, NULL, 8);
INSERT INTO "passengers" VALUES (1894, '', 1, '', NULL, NULL, NULL, 6, NULL, 6);
INSERT INTO "passengers" VALUES (1896, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1899, '', 4, '', 17, NULL, 6, 4, NULL, 15);
INSERT INTO "passengers" VALUES (1900, '', 1, '', 8, NULL, 8, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1901, '', 1, '', 3, NULL, 1, 3, NULL, 5);
INSERT INTO "passengers" VALUES (1902, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1904, '', 5, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1906, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1907, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1908, '', 1, '', 3, NULL, 1, 5, NULL, 7);
INSERT INTO "passengers" VALUES (1910, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1911, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1916, '', 5, '', 6, 1, 1, NULL, 1, 5);
INSERT INTO "passengers" VALUES (1917, '', 2, '', 4, NULL, NULL, 1, NULL, 5);
INSERT INTO "passengers" VALUES (1918, '', 6, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1919, '', 4, '', 14, NULL, 7, 1, NULL, 8);
INSERT INTO "passengers" VALUES (1921, '', 5, '', 16, NULL, 2, NULL, NULL, 14);
INSERT INTO "passengers" VALUES (1923, '', 6, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1924, '', 1, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "passengers" VALUES (1925, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1928, '', 1, '', 9, NULL, 7, NULL, 2, NULL);
INSERT INTO "passengers" VALUES (1929, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1930, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1932, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1934, '', 3, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1935, '', 4, '', 3, NULL, NULL, 1, NULL, 4);
INSERT INTO "passengers" VALUES (1939, '', 3, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (1942, '', 4, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "passengers" VALUES (1943, '', 3, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1945, '', 1, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (1946, '', 3, '', 16, NULL, 16, 42, NULL, 42);
INSERT INTO "passengers" VALUES (1948, '', 3, '', 2, NULL, NULL, 2, NULL, 4);
INSERT INTO "passengers" VALUES (1949, '', 5, '', 5, NULL, NULL, 18, NULL, 24);
INSERT INTO "passengers" VALUES (1952, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1953, '', 5, '', 6, NULL, 4, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1954, '', 1, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (1955, '', 1, '', 12, NULL, 2, 4, NULL, 14);
INSERT INTO "passengers" VALUES (1959, '', 1, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1963, '', 1, '', NULL, NULL, NULL, 6, NULL, 6);
INSERT INTO "passengers" VALUES (1964, '', 2, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (1965, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1966, '', 4, '', 13, NULL, 6, NULL, NULL, 11);
INSERT INTO "passengers" VALUES (1967, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1970, '', 2, '', 4, NULL, 2, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1971, '', 5, '', 10, 1, 4, NULL, 1, 3);
INSERT INTO "passengers" VALUES (1972, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1973, '', 3, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "passengers" VALUES (1974, '', 1, '', 1, NULL, NULL, 5, NULL, 6);
INSERT INTO "passengers" VALUES (1976, '', 6, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (1977, '', 4, '', 19, NULL, 2, NULL, NULL, 17);
INSERT INTO "passengers" VALUES (1979, '', 4, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (1980, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1983, '', 1, '', 3, NULL, 2, 1, NULL, 2);
INSERT INTO "passengers" VALUES (1984, '', 1, '', 5, NULL, 3, 1, NULL, 3);
INSERT INTO "passengers" VALUES (1986, '', 1, '', 6, NULL, 4, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (1988, '', 5, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (1989, '', 2, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (1991, '', 2, '', 1, NULL, NULL, 2, NULL, 3);
INSERT INTO "passengers" VALUES (1993, '', 4, '', 9, NULL, 1, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (1994, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (1995, '', 1, '', 3, NULL, NULL, 1, 1, 3);
INSERT INTO "passengers" VALUES (1997, '', 4, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (1998, '', 2, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "passengers" VALUES (1999, '', 1, '', 1, NULL, NULL, 6, NULL, 7);
INSERT INTO "passengers" VALUES (2000, '', 1, '', 3, NULL, 1, 3, NULL, 5);
INSERT INTO "passengers" VALUES (2001, '', 6, '', 10, NULL, NULL, 1, 2, 5);
INSERT INTO "passengers" VALUES (2002, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2004, '', 4, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2005, '', 2, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (2008, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2010, '', 4, '', 2, NULL, NULL, 1, NULL, 3);
INSERT INTO "passengers" VALUES (2011, '', 1, '', 5, NULL, 5, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2012, '', 5, '', 4, NULL, 2, 2, NULL, 4);
INSERT INTO "passengers" VALUES (2014, '', 5, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2015, '', 2, '', 2, NULL, NULL, 3, NULL, 5);
INSERT INTO "passengers" VALUES (2016, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2017, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2018, '', 1, '', 8, NULL, 4, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2019, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2020, '', 2, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2022, '', 2, '', 9, NULL, NULL, NULL, 1, 8);
INSERT INTO "passengers" VALUES (2026, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (2028, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2030, '', 5, '', 5, NULL, NULL, 5, NULL, 9);
INSERT INTO "passengers" VALUES (2031, '', 4, '', 4, NULL, 3, 2, NULL, 3);
INSERT INTO "passengers" VALUES (2034, '', 5, '', NULL, NULL, NULL, 14, NULL, 14);
INSERT INTO "passengers" VALUES (2038, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2040, '', 5, '', NULL, NULL, NULL, 82, NULL, 82);
INSERT INTO "passengers" VALUES (2041, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2044, '', 1, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2046, '', 3, '', NULL, NULL, NULL, 67, NULL, 67);
INSERT INTO "passengers" VALUES (2052, '', 6, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2053, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2055, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2058, '', 5, '', 1, NULL, NULL, 3, NULL, 4);
INSERT INTO "passengers" VALUES (2059, '', 4, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (2060, '', 2, '', 2, NULL, NULL, 3, NULL, 5);
INSERT INTO "passengers" VALUES (2066, '', 1, '', NULL, NULL, NULL, 6, NULL, 6);
INSERT INTO "passengers" VALUES (2069, '', 3, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "passengers" VALUES (2071, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2072, '', 6, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2074, '', 6, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2075, '', 1, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (2076, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2078, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (2079, '', 3, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2083, '', 4, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2084, '', 7, '', 7, NULL, 2, 2, 2, 5);
INSERT INTO "passengers" VALUES (2085, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2086, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2087, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2089, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (2090, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2091, '', 3, '', 17, NULL, 3, 9, NULL, 23);
INSERT INTO "passengers" VALUES (2092, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2093, '', 1, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (2094, '', 5, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2096, '', 2, '', 7, NULL, NULL, 2, NULL, 9);
INSERT INTO "passengers" VALUES (2097, '', 2, '', 157, 5, 2, 4, 6, 153);
INSERT INTO "passengers" VALUES (2098, '', 2, '', 6, NULL, 2, 1, NULL, 5);
INSERT INTO "passengers" VALUES (2099, '', 5, '', 4, NULL, NULL, 6, NULL, 10);
INSERT INTO "passengers" VALUES (2101, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2102, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2103, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (2104, '', 1, '', 3, NULL, NULL, 3, NULL, 6);
INSERT INTO "passengers" VALUES (2106, '', 6, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2107, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2108, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2109, '', 3, '', 5, 1, 2, 3, 1, 5);
INSERT INTO "passengers" VALUES (2110, '', 1, '', 8, NULL, 7, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2112, '', 1, '', 2, NULL, NULL, 5, NULL, 7);
INSERT INTO "passengers" VALUES (2114, '', 2, '', 13, NULL, 2, NULL, NULL, 12);
INSERT INTO "passengers" VALUES (2115, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (2116, '', 5, '', 9, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (2117, '', 3, '', 14, NULL, 1, NULL, NULL, 13);
INSERT INTO "passengers" VALUES (2118, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (2119, '', 1, '', 2, NULL, 1, 6, 1, 6);
INSERT INTO "passengers" VALUES (2120, '', 4, '', NULL, NULL, NULL, 3, 1, 2);
INSERT INTO "passengers" VALUES (2125, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2126, '', 3, '', 3, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (2127, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (2128, '', 4, '', NULL, NULL, NULL, 6, NULL, 6);
INSERT INTO "passengers" VALUES (2130, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2131, '', 4, '', 6, NULL, NULL, 3, NULL, 9);
INSERT INTO "passengers" VALUES (2132, '', 7, '', 9, 1, NULL, 4, 1, 12);
INSERT INTO "passengers" VALUES (2134, '', 3, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (2136, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2137, '', 1, '', 3, NULL, NULL, 1, NULL, 4);
INSERT INTO "passengers" VALUES (2139, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2140, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2141, '', 7, '', 1, NULL, NULL, 4, NULL, 5);
INSERT INTO "passengers" VALUES (2142, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2143, '', 6, '', 16, NULL, 5, 6, NULL, 17);
INSERT INTO "passengers" VALUES (2144, '', 6, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (2145, '', 2, '', 22, NULL, NULL, 2, 1, 25);
INSERT INTO "passengers" VALUES (2152, '', 2, '', 11, NULL, NULL, 2, NULL, 13);
INSERT INTO "passengers" VALUES (2154, '', 2, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (2155, '', 2, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (2157, '', 3, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (2159, '', 2, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (2160, '', 2, '', 14, NULL, 1, NULL, NULL, 13);
INSERT INTO "passengers" VALUES (2161, '', 1, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (2162, '', 7, '', NULL, NULL, NULL, 8, NULL, 9);
INSERT INTO "passengers" VALUES (2165, '', 2, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "passengers" VALUES (2166, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2167, '', 5, '', 4, NULL, NULL, 1, NULL, 5);
INSERT INTO "passengers" VALUES (2168, '', 2, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2169, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2170, '', 2, '', 2, NULL, 1, 2, NULL, 3);
INSERT INTO "passengers" VALUES (2171, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2172, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2173, '', 4, '', 6, NULL, NULL, 2, NULL, 8);
INSERT INTO "passengers" VALUES (2174, '', 2, '', 5, NULL, 5, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2175, '', 1, '', 10, NULL, NULL, 1, NULL, 11);
INSERT INTO "passengers" VALUES (2176, '', 2, '', 11, NULL, 11, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2177, '', 2, '', 13, NULL, 13, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2178, '', 7, '', 7, NULL, 7, 12, NULL, 12);
INSERT INTO "passengers" VALUES (2180, '', 3, '', 27, NULL, 27, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2181, '', 2, '', 10, NULL, 8, 2, NULL, 4);
INSERT INTO "passengers" VALUES (2182, '', 2, '', 2, NULL, 2, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2187, '', 4, '', 10, NULL, 4, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (2189, '', 2, '', 3, NULL, 3, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2190, '', 3, '', 16, NULL, 11, 1, NULL, 6);
INSERT INTO "passengers" VALUES (2191, '', 2, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (2193, '', 1, '', 15, NULL, 15, 3, NULL, 3);
INSERT INTO "passengers" VALUES (2194, '', 2, '', 10, NULL, 9, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2195, '', 6, '', 25, NULL, 22, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2196, '', 3, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2198, '', 1, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2202, '', 4, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2203, '', 2, '', 16, NULL, 16, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2206, '', 4, '', 3, NULL, 1, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2213, '', 4, '', 7, NULL, 5, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2214, '', 8, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2216, '', 2, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "passengers" VALUES (2218, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2219, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2220, '', 3, '', 7, NULL, 1, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (2222, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2223, '', 1, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (2224, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2225, '', 1, '', 12, NULL, 4, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (2226, '', 3, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2231, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2234, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2235, '', 3, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2236, '', 3, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (2237, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2238, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2241, '', 3, '', 1, NULL, 1, 3, NULL, 3);
INSERT INTO "passengers" VALUES (2243, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2244, '', 7, '', 4, NULL, 4, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2245, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2248, '', 3, '', 4, NULL, 5, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (2251, '', 5, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2253, '', 1, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2254, '', 4, '', 3, NULL, 2, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2257, '', 1, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2260, '', 3, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (2262, '', 3, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2263, '', 2, '', 2, NULL, 2, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2270, '', 7, '', 1, NULL, 1, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2272, '', 3, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "passengers" VALUES (2273, '', 3, '', 5, NULL, 5, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2274, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2275, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2278, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2280, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2281, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2286, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2287, '', 4, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2288, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2289, '', 1, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2290, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2293, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2296, '', 4, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2297, '', 2, '', 9, NULL, 2, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (2300, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2301, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2304, '', 4, '', 1, NULL, NULL, 4, NULL, 5);
INSERT INTO "passengers" VALUES (2307, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2310, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2312, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2313, '', 4, '', 5, NULL, NULL, 1, NULL, 5);
INSERT INTO "passengers" VALUES (2314, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2315, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2316, '', 3, '', 10, NULL, 4, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (2317, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2319, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2320, '', 1, '', 6, NULL, 1, NULL, 1, 4);
INSERT INTO "passengers" VALUES (2321, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (2322, '', 1, '', 4, NULL, 1, NULL, 2, 2);
INSERT INTO "passengers" VALUES (2323, '', 2, '', 7, NULL, 1, NULL, 1, 5);
INSERT INTO "passengers" VALUES (2325, '', 1, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "passengers" VALUES (2326, '', 2, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "passengers" VALUES (2329, '', 7, '', 7, NULL, NULL, NULL, 1, 6);
INSERT INTO "passengers" VALUES (2330, '', 6, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2331, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2335, '', 8, '', 11, NULL, 6, 1, NULL, 6);
INSERT INTO "passengers" VALUES (2336, '', 4, '', 3, NULL, NULL, NULL, 1, 2);
INSERT INTO "passengers" VALUES (2337, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2338, '', 3, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (2340, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2342, '', 2, '', 11, NULL, NULL, 2, 2, 11);
INSERT INTO "passengers" VALUES (2343, '', 4, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2345, '', 1, '', 3, NULL, NULL, NULL, 1, 2);
INSERT INTO "passengers" VALUES (2348, '', 2, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2350, '', 1, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2351, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2353, '', 5, '', 12, NULL, NULL, 1, 2, 11);
INSERT INTO "passengers" VALUES (2355, '', 1, '', 7, NULL, 2, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (2356, '', 6, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2357, '', 2, '', 3, NULL, NULL, NULL, 2, 2);
INSERT INTO "passengers" VALUES (2361, '', 1, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2365, '', 6, '', 6, NULL, 1, 1, 2, 4);
INSERT INTO "passengers" VALUES (2369, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2370, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2373, '', 4, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2375, '', 5, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (2376, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2378, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2384, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2385, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2387, '', 5, '', 6, NULL, 5, 2, NULL, 3);
INSERT INTO "passengers" VALUES (2389, '', 1, '', 3, NULL, 3, 5, 4, 1);
INSERT INTO "passengers" VALUES (2390, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (2392, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (2393, '', 5, '', 5, NULL, 2, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2394, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2395, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2397, '', 1, '', 3, NULL, NULL, NULL, 1, 2);
INSERT INTO "passengers" VALUES (2400, '', 6, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2402, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2405, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2406, '', 3, '', 9, NULL, 1, NULL, 1, 7);
INSERT INTO "passengers" VALUES (2407, '', 4, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (2408, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (2410, '', 3, '', 4, NULL, 4, 1, NULL, 1);
INSERT INTO "passengers" VALUES (2415, '', 4, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2416, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2421, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2422, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2426, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2428, '', 4, '', 5, NULL, 2, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2429, '', 1, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "passengers" VALUES (2431, '', 5, '', 4, NULL, 4, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2432, '', 3, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2434, '', 2, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2436, '', 2, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2437, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2438, '', 1, '', 5, NULL, 4, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2439, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2452, '', 5, '', 1, 1, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (2453, '', 5, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (2454, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2461, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2463, '', 5, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2466, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2470, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2474, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (2478, '', 2, '', 2, NULL, NULL, 1, NULL, 5);
INSERT INTO "passengers" VALUES (2482, '', 3, '', NULL, NULL, NULL, 11, NULL, 11);
INSERT INTO "passengers" VALUES (2491, '', 3, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2493, '', 2, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (2496, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2497, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2499, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2501, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2502, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2503, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2514, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2516, '', 3, '', 5, NULL, 2, 1, NULL, 4);
INSERT INTO "passengers" VALUES (2517, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2518, '', 1, '', 2, NULL, NULL, 2, NULL, 4);
INSERT INTO "passengers" VALUES (2521, '', 6, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2526, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2530, '', 4, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2537, '', 1, '', 5, NULL, NULL, 1, NULL, 6);
INSERT INTO "passengers" VALUES (2539, '', 3, '', 3, NULL, 1, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2542, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2546, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2550, '', 1, '', 3, NULL, NULL, 1, NULL, 5);
INSERT INTO "passengers" VALUES (2562, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2567, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (2568, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2570, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2571, '', 3, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (2580, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2581, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (2582, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2583, '', 5, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (2586, '', 5, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2587, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2588, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2589, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2592, '', 2, '', 3, NULL, 2, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2596, '', 2, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2604, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2614, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2625, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2627, '', 1, '', 4, NULL, 4, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2628, '', 2, '', 2, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2629, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2632, '', 4, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (2635, '', 6, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (2640, '', 3, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2646, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2648, '', 1, '', 2, 9, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2651, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2652, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2653, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2655, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (2656, '', 2, '', 1, NULL, 1, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2661, '', 7, '', 9, NULL, 7, NULL, 2, NULL);
INSERT INTO "passengers" VALUES (2666, '', 2, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2667, '', 5, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2668, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2670, '', 5, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2679, '', 5, '', 2, NULL, NULL, 1, NULL, 3);
INSERT INTO "passengers" VALUES (2690, '', 3, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (2693, '', 3, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (2694, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2698, '', 2, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2699, '', 3, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (2700, '', 5, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2701, '', 6, '', 3, NULL, NULL, 4, NULL, 7);
INSERT INTO "passengers" VALUES (2706, '', 3, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2713, '', 7, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2714, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2716, '', 3, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (2717, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2718, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2737, '', 5, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2740, '', 3, '', NULL, NULL, NULL, 7, NULL, 7);
INSERT INTO "passengers" VALUES (2744, '', 5, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2745, '', 4, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (2749, '', 3, '', NULL, NULL, NULL, NULL, NULL, 20);
INSERT INTO "passengers" VALUES (2752, '', 2, '', 3, NULL, 2, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2753, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2754, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2756, '', 3, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2757, '', 9, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "passengers" VALUES (2762, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2763, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2766, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2767, '', 4, '', 2, NULL, NULL, 1, NULL, 3);
INSERT INTO "passengers" VALUES (2769, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2770, '', 5, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2771, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2772, '', 5, '', 6, NULL, 3, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2776, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2780, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2784, '', 3, '', 6, NULL, 2, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2792, '', 4, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2794, '', 7, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2795, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2802, '', 3, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2807, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2815, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2819, '', 1, '', 5, NULL, 4, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2821, '', 6, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2824, '', 4, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2826, '', 5, '', 2, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2827, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2829, '', 6, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2831, '', 7, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2835, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2836, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2841, '', 5, '', 2, NULL, 1, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (2845, '', 5, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2854, '', 5, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "passengers" VALUES (2855, '', 4, '', 4, NULL, 4, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2856, '', 1, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (2857, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2858, '', 4, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (2860, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2867, '', 4, '', 1, NULL, 1, 3, NULL, 3);
INSERT INTO "passengers" VALUES (2868, '', 9, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2870, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2875, '', 6, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2879, '', 8, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (2884, '', 1, '', 3, NULL, 3, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2885, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (2886, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2887, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2888, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2890, '', 2, '', 4, NULL, 1, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2892, '', 1, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2899, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2900, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2906, '', 7, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2912, '', 7, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (2913, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2916, '', 5, '', 4, NULL, 4, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2917, '', 1, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (2919, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2921, '', 1, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2924, '', 6, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (2929, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2930, '', 1, '', 9, NULL, 1, NULL, 2, 6);
INSERT INTO "passengers" VALUES (2931, '', 2, '', 4, NULL, 3, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (2932, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2933, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2936, '', 5, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2939, '', 5, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2942, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2945, '', 5, '', 19, NULL, 7, NULL, 1, 11);
INSERT INTO "passengers" VALUES (2947, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (2952, '', 7, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2953, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2954, '', 3, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (2956, '', 5, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "passengers" VALUES (2958, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2959, '', 4, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (2962, '', 6, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2963, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (2964, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2966, '', 1, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "passengers" VALUES (2967, '', 1, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "passengers" VALUES (2970, '', 8, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2979, '', 6, '', 7, NULL, NULL, NULL, 2, 5);
INSERT INTO "passengers" VALUES (2982, '', 2, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (2985, '', 2, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "passengers" VALUES (2986, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2988, '', 6, '', 2, NULL, 2, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2990, '', 7, '', 5, NULL, 4, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2991, '', 5, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (2993, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (2994, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (2995, '', 5, '', 3, NULL, NULL, NULL, 1, 2);
INSERT INTO "passengers" VALUES (2997, '', 1, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (2998, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3000, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3001, '', 1, '', 2, NULL, 1, 3, NULL, 4);
INSERT INTO "passengers" VALUES (3002, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3004, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3009, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3010, '', 10, '', 3, NULL, 3, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3011, '', 2, '', NULL, NULL, NULL, 4, NULL, 4);
INSERT INTO "passengers" VALUES (3013, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3014, '', 7, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3015, '', 2, '', 1, NULL, 1, 3, NULL, 3);
INSERT INTO "passengers" VALUES (3017, '', 2, '', 3, NULL, NULL, 2, NULL, 5);
INSERT INTO "passengers" VALUES (3018, '', 1, '', 6, NULL, 2, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3022, '', 6, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3025, '', 4, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3028, '', 5, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3029, '', 6, '', 5, NULL, 3, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3032, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3033, '', 3, '', 9, NULL, 3, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3034, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3037, '', 4, '', 12, NULL, NULL, NULL, NULL, 12);
INSERT INTO "passengers" VALUES (3038, '', 1, '', NULL, NULL, NULL, 4, NULL, 4);
INSERT INTO "passengers" VALUES (3039, '', 1, '', NULL, NULL, NULL, 1, 1, NULL);
INSERT INTO "passengers" VALUES (3040, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3041, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3043, '', 7, '', 2, 1, NULL, NULL, 1, 1);
INSERT INTO "passengers" VALUES (3044, '', 1, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (3045, '', 6, '', 6, NULL, NULL, NULL, 2, 4);
INSERT INTO "passengers" VALUES (3052, '', 7, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3060, '', 5, '', NULL, NULL, NULL, 17, NULL, 17);
INSERT INTO "passengers" VALUES (3061, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3062, '', 1, '', 1, NULL, NULL, 13, NULL, 14);
INSERT INTO "passengers" VALUES (3064, '', 8, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3066, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3070, '', 2, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (3074, '', 3, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (3076, '', 2, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3077, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3078, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3079, '', 5, '', 8, NULL, NULL, NULL, 2, 6);
INSERT INTO "passengers" VALUES (3083, '', 7, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3084, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3085, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3087, '', 1, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "passengers" VALUES (3088, '', 2, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "passengers" VALUES (3089, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3090, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3094, '', 2, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "passengers" VALUES (3096, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3097, '', 3, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3099, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3102, '', 7, '', 7, NULL, 5, NULL, 1, 1);
INSERT INTO "passengers" VALUES (3109, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3113, '', 5, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "passengers" VALUES (3116, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3117, '', 4, '', 7, NULL, 5, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3121, '', 1, '', 77, NULL, 4, 1, 10, 59);
INSERT INTO "passengers" VALUES (3126, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3127, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3129, '', 3, '', 3, NULL, NULL, NULL, 2, 1);
INSERT INTO "passengers" VALUES (3131, '', 1, '', 6, NULL, 2, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3140, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3143, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3149, '', 4, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3153, '', 5, '', 9, NULL, NULL, 2, NULL, 11);
INSERT INTO "passengers" VALUES (3154, '', 3, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3155, '', 3, '', 3, NULL, NULL, 2, NULL, 5);
INSERT INTO "passengers" VALUES (3161, '', 2, '', NULL, NULL, NULL, 4, NULL, 4);
INSERT INTO "passengers" VALUES (3167, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3169, '', 7, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3172, '', 3, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3175, '', 4, '', 3, NULL, 2, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3177, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3178, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3179, '', 7, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3180, '', 2, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3182, '', 4, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3183, '', 8, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3188, '', 2, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "passengers" VALUES (3189, '', 1, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (3190, '', 8, '', 5, 2, NULL, NULL, 2, 3);
INSERT INTO "passengers" VALUES (3191, '', 4, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3192, '', 5, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3193, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3196, '', 7, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3198, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3204, '', 3, '', 6, NULL, 2, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3205, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3208, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3211, '', 1, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (3212, '', 5, '', 6, NULL, 6, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3213, '', 1, '', 2, NULL, NULL, NULL, 2, NULL);
INSERT INTO "passengers" VALUES (3214, '', 3, '', 7, NULL, NULL, NULL, 1, 6);
INSERT INTO "passengers" VALUES (3223, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3226, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3231, '', 5, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3239, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3240, '', 8, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3241, '', 2, '', 2, NULL, NULL, 6, 2, 6);
INSERT INTO "passengers" VALUES (3242, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3244, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3245, '', 4, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3246, '', 3, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3247, '', 5, '', 10, NULL, NULL, NULL, NULL, 10);
INSERT INTO "passengers" VALUES (3249, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3251, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3253, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3254, '', 1, '', 12, NULL, 2, 1, 1, 10);
INSERT INTO "passengers" VALUES (3255, '', 1, '', NULL, NULL, NULL, 14, 2, 14);
INSERT INTO "passengers" VALUES (3256, '', 1, '', 9, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (3258, '', 3, '', 8, NULL, NULL, NULL, 2, 6);
INSERT INTO "passengers" VALUES (3259, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3260, '', 6, '', 10, NULL, 5, 16, 2, 19);
INSERT INTO "passengers" VALUES (3261, '', 5, '', NULL, NULL, NULL, 10, NULL, 10);
INSERT INTO "passengers" VALUES (3262, '', 1, '', 1, NULL, NULL, 14, 4, 10);
INSERT INTO "passengers" VALUES (3268, '', 3, '', 3, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3269, '', 3, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3270, '', 2, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "passengers" VALUES (3273, '', 3, '', NULL, NULL, NULL, 1, NULL, NULL);
INSERT INTO "passengers" VALUES (3274, '', 2, '', 11, NULL, NULL, NULL, 2, 10);
INSERT INTO "passengers" VALUES (3276, '', 1, '', 6, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (3277, '', 2, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "passengers" VALUES (3279, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3281, '', 1, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3283, '', 5, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3284, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3288, '', 1, '', 1, NULL, NULL, 6, NULL, 7);
INSERT INTO "passengers" VALUES (3289, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3290, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3293, '', 3, '', 4, NULL, NULL, 7, 2, 14);
INSERT INTO "passengers" VALUES (3294, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3295, '', 5, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3296, '', 3, '', 1, NULL, NULL, 7, NULL, 8);
INSERT INTO "passengers" VALUES (3299, '', 1, '', NULL, NULL, NULL, 7, NULL, 7);
INSERT INTO "passengers" VALUES (3301, '', 4, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3302, '', 4, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3304, '', 7, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3307, '', 3, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (3308, '', 1, '', 128, 41, 12, 7, 22, 102);
INSERT INTO "passengers" VALUES (3309, '', 2, '', 5, NULL, 1, 1, NULL, 5);
INSERT INTO "passengers" VALUES (3311, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3312, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3314, '', 2, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3316, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3317, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3318, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3319, '', 5, '', 2, NULL, 1, 2, NULL, 3);
INSERT INTO "passengers" VALUES (3320, '', 4, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "passengers" VALUES (3321, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3323, '', 3, '', 6, NULL, 5, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3324, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3325, '', 2, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3326, '', 4, '', 4, NULL, 1, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3327, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3328, '', 5, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3331, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3332, '', 2, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (3334, '', 1, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (3336, '', 4, '', 4, NULL, NULL, 1, NULL, 5);
INSERT INTO "passengers" VALUES (3337, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3338, '', 4, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3340, '', 2, '', 3, NULL, NULL, NULL, 1, 2);
INSERT INTO "passengers" VALUES (3341, '', 1, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3347, '', 1, '', 3, NULL, 3, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3348, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3349, '', 9, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3351, '', 3, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3353, '', 4, '', 8, NULL, 5, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3354, '', 6, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3356, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3357, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3358, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3359, '', 5, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3360, '', 3, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "passengers" VALUES (3362, '', 3, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (3363, '', 4, '', NULL, NULL, NULL, 19, NULL, 19);
INSERT INTO "passengers" VALUES (3365, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3369, '', 2, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (3371, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3375, '', 1, '', NULL, NULL, NULL, 4, NULL, 4);
INSERT INTO "passengers" VALUES (3376, '', 6, '', 4, NULL, NULL, NULL, 2, 2);
INSERT INTO "passengers" VALUES (3379, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3380, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3381, '', 2, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3382, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3383, '', 2, '', 5, NULL, 4, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (3388, '', 4, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3391, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3393, '', 1, '', 116, NULL, 12, 7, 19, 90);
INSERT INTO "passengers" VALUES (3396, '', 1, '', 8, NULL, 5, 2, NULL, 4);
INSERT INTO "passengers" VALUES (3397, '', 2, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3400, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3405, '', 5, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3406, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3407, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3408, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3410, '', 1, '', 13, NULL, 3, 1, 3, 15);
INSERT INTO "passengers" VALUES (3411, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3412, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3414, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3415, '', 4, '', 3, NULL, 3, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3417, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3418, '', 2, '', NULL, NULL, NULL, 1, 1, NULL);
INSERT INTO "passengers" VALUES (3419, '', 1, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3422, '', 4, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3426, '', 3, '', 2, NULL, NULL, 2, 1, 2);
INSERT INTO "passengers" VALUES (3428, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3429, '', 2, '', 3, NULL, NULL, NULL, 1, 2);
INSERT INTO "passengers" VALUES (3432, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3434, '', 4, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3435, '', 2, '', 4, NULL, 3, NULL, 1, 2);
INSERT INTO "passengers" VALUES (3436, '', 2, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "passengers" VALUES (3437, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3438, '', 1, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "passengers" VALUES (3443, '', 2, '', 3, NULL, 1, 1, 1, 2);
INSERT INTO "passengers" VALUES (3444, '', 3, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "passengers" VALUES (3449, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3450, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3451, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3452, '', 3, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3453, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3455, '', 3, '', 5, NULL, 2, 1, 2, 2);
INSERT INTO "passengers" VALUES (3457, '', 1, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (3458, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3459, '', 5, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3460, '', 4, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3461, '', 3, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3462, '', 5, '', 98, NULL, 20, NULL, 6, 71);
INSERT INTO "passengers" VALUES (3463, '', 3, '', 3, NULL, 3, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3464, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3470, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3471, '', 7, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3472, '', 2, '', 3, NULL, NULL, 1, NULL, 4);
INSERT INTO "passengers" VALUES (3474, '', 5, '', 2, NULL, NULL, 1, NULL, 3);
INSERT INTO "passengers" VALUES (3476, '', 1, '', 6, NULL, NULL, 4, NULL, 10);
INSERT INTO "passengers" VALUES (3480, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3481, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3482, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3484, '', 1, '', 5, NULL, NULL, 2, NULL, 7);
INSERT INTO "passengers" VALUES (3487, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3488, '', 2, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3489, '', 3, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (3490, '', 3, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3491, '', 2, '', 9, NULL, 6, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3492, '', 3, '', 5, NULL, 3, 4, NULL, 6);
INSERT INTO "passengers" VALUES (3493, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3495, '', 4, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3496, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3497, '', 1, '', NULL, NULL, NULL, 11, 2, 9);
INSERT INTO "passengers" VALUES (3498, '', 1, '', 1, NULL, NULL, 2, 1, 2);
INSERT INTO "passengers" VALUES (3499, '', 4, '', 2, NULL, NULL, 6, NULL, 8);
INSERT INTO "passengers" VALUES (3500, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3501, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3503, '', 2, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3504, '', 2, '', 4, NULL, 2, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3505, '', 3, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "passengers" VALUES (3506, '', 3, '', 4, NULL, NULL, NULL, 1, 3);
INSERT INTO "passengers" VALUES (3509, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3510, '', 3, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3514, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3517, '', 5, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3520, '', 3, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3521, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3523, '', 4, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3525, '', 1, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3527, '', 3, '', NULL, NULL, NULL, 6, NULL, 6);
INSERT INTO "passengers" VALUES (3528, '', 1, '', 2, NULL, NULL, 6, NULL, 8);
INSERT INTO "passengers" VALUES (3529, '', 2, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "passengers" VALUES (3531, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3534, '', 2, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3536, '', 3, '', 5, NULL, 8, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3537, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3539, '', 1, '', 5, NULL, NULL, 1, 1, 5);
INSERT INTO "passengers" VALUES (3540, '', 1, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3541, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3542, '', 2, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3543, '', 4, '', 4, NULL, NULL, 1, NULL, 5);
INSERT INTO "passengers" VALUES (3544, '', 4, '', NULL, NULL, 2, 10, NULL, 10);
INSERT INTO "passengers" VALUES (3547, '', 6, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3548, '', 4, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3550, '', 2, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (3551, '', 2, '', 5, NULL, NULL, NULL, 1, 4);
INSERT INTO "passengers" VALUES (3553, '', 4, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (3554, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3559, '', 1, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (3560, '', 5, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3563, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3565, '', 7, '', 118, NULL, 1, 2, NULL, 114);
INSERT INTO "passengers" VALUES (3566, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3568, '', 5, '', 7, NULL, 1, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (3569, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3570, '', 1, '', 1, NULL, 1, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3571, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3574, '', 1, '', 7, NULL, NULL, 4, 3, 8);
INSERT INTO "passengers" VALUES (3576, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3578, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3583, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3585, '', 3, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3586, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3587, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3588, '', 1, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (3589, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3597, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3599, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3605, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3608, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3610, '', 4, '', 4, NULL, NULL, NULL, 2, 2);
INSERT INTO "passengers" VALUES (3612, '', 3, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3615, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3616, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3618, '', 3, '', 8, NULL, 1, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (3619, '', 3, '', 9, NULL, 1, NULL, 1, 7);
INSERT INTO "passengers" VALUES (3622, '', 3, '', 9, NULL, 3, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3623, '', 5, '', 4, NULL, NULL, 4, NULL, 8);
INSERT INTO "passengers" VALUES (3625, '', 3, '', 3, NULL, 1, 4, 1, 5);
INSERT INTO "passengers" VALUES (3626, '', 1, '', 1, NULL, 1, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3628, '', 3, '', 5, NULL, 4, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3630, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3631, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3632, '', 4, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3634, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3636, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3637, '', 2, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (3638, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3639, '', 1, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (3644, '', 5, '', 5, NULL, 1, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3645, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3646, '', 5, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3647, '', 1, '', 1, NULL, NULL, 3, 1, 3);
INSERT INTO "passengers" VALUES (3649, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3650, '', 4, '', 7, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3652, '', 4, '', 1, NULL, 1, 2, NULL, 3);
INSERT INTO "passengers" VALUES (3654, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3655, '', 4, '', 3, NULL, NULL, 2, 1, 4);
INSERT INTO "passengers" VALUES (3661, '', 5, '', 14, NULL, 1, NULL, NULL, 13);
INSERT INTO "passengers" VALUES (3662, '', 2, '', 2, NULL, NULL, 1, 1, 2);
INSERT INTO "passengers" VALUES (3663, '', 1, '', NULL, NULL, 1, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3664, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3666, '', 4, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3668, '', 1, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (3669, '', 2, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3672, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3674, '', 5, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (3675, '', 3, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3676, '', 4, '', 5, NULL, NULL, 1, NULL, 6);
INSERT INTO "passengers" VALUES (3677, '', 2, '', 1, NULL, NULL, 2, NULL, 3);
INSERT INTO "passengers" VALUES (3678, '', 6, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3680, '', 5, '', 3, NULL, 1, 2, NULL, 4);
INSERT INTO "passengers" VALUES (3681, '', 4, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "passengers" VALUES (3682, '', 3, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3684, '', 3, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3686, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3689, '', 1, '', 6, NULL, 4, NULL, 1, 1);
INSERT INTO "passengers" VALUES (3690, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3691, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3692, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3696, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3697, '', 1, '', 2, NULL, 3, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3699, '', 4, '', 1, NULL, 3, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (3700, '', 3, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (3701, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3703, '', 2, '', 1, NULL, NULL, 4, NULL, 5);
INSERT INTO "passengers" VALUES (3704, '', 4, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3705, '', 4, '', 2, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3706, '', 6, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3707, '', 5, '', 2, NULL, 2, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3709, '', 3, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3710, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3711, '', 5, '', NULL, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3713, '', 7, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (3716, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3718, '', 3, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "passengers" VALUES (3720, '', 3, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3722, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3724, '', 5, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3725, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3728, '', 5, '', NULL, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3729, '', 2, '', 6, NULL, 1, NULL, 2, 3);
INSERT INTO "passengers" VALUES (3730, '', 5, '', 3, NULL, 1, NULL, 1, 1);
INSERT INTO "passengers" VALUES (3731, '', 3, '', 1, NULL, NULL, 2, NULL, 3);
INSERT INTO "passengers" VALUES (3732, '', 2, '', 4, NULL, NULL, 1, 1, 3);
INSERT INTO "passengers" VALUES (3733, '', 2, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3735, '', 4, '', 2, NULL, 2, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3736, '', 2, '', 6, 1, 1, 2, 1, 4);
INSERT INTO "passengers" VALUES (3737, '', 3, '', NULL, NULL, NULL, 2, NULL, 3);
INSERT INTO "passengers" VALUES (3740, '', 3, '', 6, NULL, 1, NULL, 1, 4);
INSERT INTO "passengers" VALUES (3741, '', 1, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (3745, '', 2, '', NULL, NULL, NULL, 4, NULL, 4);
INSERT INTO "passengers" VALUES (3746, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3748, '', 1, '', 7, NULL, 3, NULL, 1, 3);
INSERT INTO "passengers" VALUES (3749, '', 1, '', 4, NULL, NULL, NULL, 1, 4);
INSERT INTO "passengers" VALUES (3750, '', 2, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "passengers" VALUES (3755, '', 2, '', 5, NULL, NULL, NULL, 2, 3);
INSERT INTO "passengers" VALUES (3757, '', 3, '', 1, NULL, NULL, 2, NULL, 3);
INSERT INTO "passengers" VALUES (3759, '', 1, '', 3, NULL, NULL, 1, NULL, 4);
INSERT INTO "passengers" VALUES (3762, '', 6, '', NULL, NULL, NULL, 4, 2, 2);
INSERT INTO "passengers" VALUES (3763, '', 5, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3764, '', 6, '', NULL, NULL, NULL, 9, NULL, 9);
INSERT INTO "passengers" VALUES (3765, '', 2, '', NULL, NULL, NULL, 3, 1, 2);
INSERT INTO "passengers" VALUES (3766, '', 3, '', 1, NULL, NULL, 2, NULL, 3);
INSERT INTO "passengers" VALUES (3767, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3769, '', 5, '', 3, NULL, NULL, 2, NULL, 5);
INSERT INTO "passengers" VALUES (3771, '', 3, '', NULL, NULL, NULL, 7, NULL, 7);
INSERT INTO "passengers" VALUES (3772, '', 1, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (3773, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3774, '', 2, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3775, '', 5, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3778, '', 5, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3779, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3783, '', 3, '', 1, NULL, 1, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3787, '', 3, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3788, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3789, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3791, '', 3, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3792, '', 5, '', 3, NULL, NULL, 2, NULL, 5);
INSERT INTO "passengers" VALUES (3793, '', 1, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3794, '', 2, '', 4, NULL, 1, 1, NULL, 4);
INSERT INTO "passengers" VALUES (3798, '', 5, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (3799, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3800, '', 4, '', 6, NULL, 4, NULL, 2, NULL);
INSERT INTO "passengers" VALUES (3804, '', 4, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (3810, '', 2, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (3811, '', 2, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (3812, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3813, '', 5, '', 2, NULL, NULL, 5, NULL, 7);
INSERT INTO "passengers" VALUES (3814, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3815, '', 4, '', NULL, NULL, NULL, 10, NULL, 10);
INSERT INTO "passengers" VALUES (3818, '', 1, '', 1, NULL, NULL, 5, NULL, 6);
INSERT INTO "passengers" VALUES (3820, '', 1, '', 9, NULL, NULL, 2, NULL, 11);
INSERT INTO "passengers" VALUES (3821, '', 2, '', 6, NULL, 1, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3823, '', 4, '', 6, NULL, 1, 3, 2, 6);
INSERT INTO "passengers" VALUES (3825, '', 1, '', 6, NULL, NULL, NULL, 3, 3);
INSERT INTO "passengers" VALUES (3826, '', 3, '', 21, NULL, 2, 172, 7, NULL);
INSERT INTO "passengers" VALUES (3828, '', 2, '', 2, NULL, NULL, 2, NULL, 4);
INSERT INTO "passengers" VALUES (3829, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3830, '', 4, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "passengers" VALUES (3832, '', 3, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3833, '', 4, '', 6, NULL, 1, NULL, 1, 4);
INSERT INTO "passengers" VALUES (3834, '', 3, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3835, '', 2, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (3837, '', 3, '', 1, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3838, '', 5, '', 10, NULL, NULL, 1, 1, 10);
INSERT INTO "passengers" VALUES (3839, '', 2, '', 6, NULL, 5, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3840, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3846, '', 5, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (3847, '', 6, '', 89, 3, 16, 4, 3, 74);
INSERT INTO "passengers" VALUES (3848, '', 3, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3850, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3851, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3853, '', 2, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3854, '', 3, '', 4, NULL, NULL, 5, NULL, 9);
INSERT INTO "passengers" VALUES (3855, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3859, '', 4, '', 3, NULL, 3, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3860, '', 5, '', NULL, NULL, 8, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3861, '', 5, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3864, '', 2, '', 1, NULL, NULL, 2, 1, 2);
INSERT INTO "passengers" VALUES (3870, '', 3, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3872, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3873, '', 2, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "passengers" VALUES (3877, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3878, '', 1, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3879, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3880, '', 8, '', 6, NULL, NULL, NULL, 1, 5);
INSERT INTO "passengers" VALUES (3881, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3883, '', 6, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3885, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3886, '', 5, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3888, '', 4, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3889, '', 1, '', 2, NULL, NULL, 2, NULL, 4);
INSERT INTO "passengers" VALUES (3891, '', 4, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3892, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3893, '', 4, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3895, '', 6, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3896, '', 4, '', 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO "passengers" VALUES (3897, '', 1, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3898, '', 5, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3899, '', 3, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "passengers" VALUES (3900, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3901, '', 5, '', 2, NULL, NULL, 2, 1, 3);
INSERT INTO "passengers" VALUES (3902, '', 4, '', NULL, NULL, NULL, 8, NULL, 8);
INSERT INTO "passengers" VALUES (3905, '', 1, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3906, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3908, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3910, '', 6, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3912, '', 3, '', 3, NULL, 3, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3913, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3915, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3921, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3924, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3926, '', 2, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (3928, '', 5, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (3929, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3930, '', 5, '', 1, NULL, NULL, 1, NULL, 2);
INSERT INTO "passengers" VALUES (3931, '', 1, '', 1, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3932, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3933, '', 1, '', 1, NULL, 1, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3934, '', 1, '', 10, NULL, 2, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (3937, '', 6, '', 4, NULL, NULL, 1, NULL, 5);
INSERT INTO "passengers" VALUES (3938, '', 1, '', 2, NULL, 1, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3939, '', 3, '', 3, NULL, 1, NULL, 2, 1);
INSERT INTO "passengers" VALUES (3940, '', 1, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3941, '', 5, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3942, '', 1, '', 2, NULL, 2, 2, NULL, 2);
INSERT INTO "passengers" VALUES (3943, '', 5, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3945, '', 4, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3946, '', 2, '', 7, NULL, NULL, 2, NULL, 9);
INSERT INTO "passengers" VALUES (3949, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (3950, '', 3, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (3951, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3955, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (3957, '', 1, '', 2, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (3958, '', 7, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (3991, '', 4, '', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (4004, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4006, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4011, '', 5, '', 3, NULL, 1, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (4012, '', 5, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "passengers" VALUES (4016, '', 2, '', NULL, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (4021, '', 3, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (4033, '', 2, '', NULL, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (4045, '', 4, '', 6, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (4046, '', 4, '', NULL, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (4050, '', 3, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4057, '', 4, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (4063, '', 1, '', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (4077, '', 5, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (4078, '', 3, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4080, '', 2, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4084, '', 4, '', 2, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4086, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4087, '', 1, '', 7, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (4088, '', 2, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (4091, '', 3, '', 2, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4092, '', 2, '', 17, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (4094, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4095, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4096, '', 4, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (4097, '', 4, '', 2, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4105, '', 2, '', 5, 2, 1, NULL, 2, 2);
INSERT INTO "passengers" VALUES (4108, '', 3, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4133, '', 1, '', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (4145, '', 3, '', NULL, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (4146, '', 1, '', NULL, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (4156, '', 6, '', 1, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (4170, '', 5, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (4175, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4177, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4180, '', 2, '', 6, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (4182, '', 2, '', 5, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (4184, '', 1, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (4185, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4190, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (4204, '', 4, '', 2, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4205, '', 5, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (4212, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4215, '', 1, '', 1, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (4216, '', 6, '', 1, NULL, NULL, NULL, NULL, 12);
INSERT INTO "passengers" VALUES (4220, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4223, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4225, '', 1, '', NULL, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (4226, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4228, '', 3, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (4231, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4258, '', 1, '', NULL, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (4262, '', 4, '', 8, NULL, 3, 1, NULL, 6);
INSERT INTO "passengers" VALUES (4263, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4264, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4290, '', 4, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (4315, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4372, '', 4, '', 8, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (4374, '', 6, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4375, '', 4, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (4377, '', 6, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (4378, '', 4, '', 5, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4379, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4380, '', 1, '', 9, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4381, '', 1, '', NULL, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (4382, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4385, '', 1, '', 2, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (4392, '', 5, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (4396, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4411, '', 1, '', 6, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (4417, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4427, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4432, '', 1, '', 1, NULL, 1, 20, NULL, 20);
INSERT INTO "passengers" VALUES (4445, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4447, '', 1, '', 2, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (4493, '', 7, '', 21, NULL, NULL, NULL, NULL, 25);
INSERT INTO "passengers" VALUES (4519, '', 2, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4542, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4550, '', 1, '', 6, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (4559, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4560, '', 2, '', 3, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (4574, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (4575, '', 1, '', 8, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (4576, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4586, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (4587, '', 2, '', 1, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (4606, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4607, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4611, '', 2, '', NULL, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (4612, '', 2, '', NULL, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (4613, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4616, '', 1, '', 3, NULL, NULL, NULL, NULL, 16);
INSERT INTO "passengers" VALUES (4617, '', 2, '', 13, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (4618, '', 1, '', 7, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (4625, '', 2, '', 7, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (4628, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4629, '', 3, '', 11, NULL, NULL, NULL, NULL, 11);
INSERT INTO "passengers" VALUES (4634, '', 1, '', 1, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (4639, '', 3, '', 12, NULL, NULL, NULL, NULL, 12);
INSERT INTO "passengers" VALUES (4640, '', 4, '', 4, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (4642, '', 2, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4643, '', 3, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4645, '', 1, '', 2, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4646, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4650, '', 1, '', 4, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (4652, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4653, '', 2, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (4655, '', 2, '', 1, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (4656, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4658, '', 2, '', 8, NULL, NULL, NULL, NULL, 8);
INSERT INTO "passengers" VALUES (4660, '', 1, '', 4, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4663, '', 2, '', 5, NULL, NULL, NULL, NULL, 5);
INSERT INTO "passengers" VALUES (4668, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4669, '', 3, '', NULL, NULL, NULL, NULL, NULL, 6);
INSERT INTO "passengers" VALUES (4672, '', 2, '', 2, NULL, NULL, NULL, NULL, 1);
INSERT INTO "passengers" VALUES (4673, '', 3, '', 27, NULL, NULL, NULL, NULL, 13);
INSERT INTO "passengers" VALUES (4693, '', 1, '', 6, NULL, NULL, NULL, NULL, 2);
INSERT INTO "passengers" VALUES (4697, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4699, '', 2, '', 7, NULL, NULL, NULL, NULL, 4);
INSERT INTO "passengers" VALUES (4701, '', 2, '', 21, NULL, NULL, NULL, NULL, 17);
INSERT INTO "passengers" VALUES (4703, '', 3, '', 22, NULL, NULL, NULL, NULL, 22);
INSERT INTO "passengers" VALUES (4704, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4705, '', 1, '', 34, NULL, NULL, NULL, NULL, 32);
INSERT INTO "passengers" VALUES (4708, '', 3, '', 20, NULL, NULL, NULL, NULL, 24);
INSERT INTO "passengers" VALUES (4709, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (4714, '', 1, '', 5, NULL, NULL, NULL, NULL, 9);
INSERT INTO "passengers" VALUES (4715, '', 2, '', 25, NULL, NULL, NULL, NULL, 32);
INSERT INTO "passengers" VALUES (4726, '', 2, '', 8, NULL, NULL, NULL, NULL, 7);
INSERT INTO "passengers" VALUES (4750, '', 3, '', 24, NULL, NULL, NULL, NULL, 28);
INSERT INTO "passengers" VALUES (4751, '', 1, '', 23, NULL, NULL, NULL, NULL, 24);
INSERT INTO "passengers" VALUES (4755, '', 1, '', 44, NULL, NULL, NULL, NULL, 39);
INSERT INTO "passengers" VALUES (4759, '', 1, '', 28, NULL, NULL, NULL, NULL, 29);
INSERT INTO "passengers" VALUES (4760, '', 1, '', 2, NULL, NULL, NULL, NULL, 3);
INSERT INTO "passengers" VALUES (4762, '', 1, '', 26, NULL, NULL, NULL, NULL, 25);
INSERT INTO "passengers" VALUES (5382, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5383, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5384, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5385, '', 8, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5402, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5403, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5405, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5446, '', 3, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5660, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5661, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5662, '', 5, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5663, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5664, '', 3, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5665, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5666, '', 3, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5676, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5677, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5678, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5680, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5681, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5682, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5683, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5685, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5686, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5690, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5693, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5694, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5695, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5696, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5698, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5703, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5707, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5708, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5709, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5710, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5711, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5712, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5721, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5722, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5723, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5724, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5725, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5726, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5729, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5733, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5734, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5735, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5736, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5737, '', 4, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5740, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5741, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5742, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5743, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5744, '', 4, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5745, '', 4, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5746, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5747, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5748, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5751, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5753, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5754, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5755, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5757, '', 2, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5758, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5759, '', 5, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5764, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5792, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5793, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5794, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5795, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5796, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5806, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5807, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5809, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5810, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5811, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5818, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5819, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5847, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5848, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5849, '', 4, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5850, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5851, '', 2, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5852, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5853, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5854, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5862, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5879, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5880, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5882, '', 3, '', 5, NULL, 2, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5891, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5906, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5907, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5909, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5910, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5913, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5914, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5915, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5921, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5922, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5923, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5924, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5925, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5926, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5927, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5931, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5932, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5933, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5934, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5935, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5936, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5937, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5938, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5939, '', 1, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5940, '', 3, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5941, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5950, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5951, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5952, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5953, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5955, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5956, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5957, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5958, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5959, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5962, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5963, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5964, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5965, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5967, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5968, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5969, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5970, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5971, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5972, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5973, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5989, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5993, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (5994, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6000, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6001, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6002, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6003, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6004, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6005, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6006, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6010, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6018, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6019, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6020, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6021, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6022, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6023, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6024, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6025, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6026, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6034, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6037, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6038, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6039, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6041, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6042, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6043, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6044, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6045, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6046, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6047, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6061, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6065, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6067, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6070, '', 2, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6075, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6079, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6080, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6081, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6082, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6086, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6087, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6088, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6089, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6095, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6097, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6098, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6099, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6100, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6101, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6102, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6103, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6104, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6105, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6106, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6112, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6113, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6114, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6115, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6116, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6123, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6124, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6125, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6126, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6130, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6131, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6132, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6133, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6134, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6136, '', 4, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6137, '', 2, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6138, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6139, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6140, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6141, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6142, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6143, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6144, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6148, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6149, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6150, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6153, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6154, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6155, '', 5, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6156, '', 4, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6157, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6158, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6165, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6166, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6167, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6169, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6170, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6171, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6172, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6173, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6174, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6175, '', 5, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6176, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6177, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6185, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6187, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6188, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6189, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6190, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6191, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6192, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6193, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6194, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6201, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6204, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6213, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6215, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6216, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6217, '', 6, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6218, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6219, '', 5, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6228, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6231, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6232, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6233, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6235, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6236, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6237, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6238, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6239, '', 6, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6240, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6241, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6248, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6249, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6251, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6252, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6253, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6254, '', 3, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6256, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6257, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6258, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6259, '', 6, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6260, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6261, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6269, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6270, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6271, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6273, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6274, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6277, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6279, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6280, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6281, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6287, '', 4, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6288, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6290, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6291, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6292, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6293, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6294, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6296, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6297, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6298, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6299, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6300, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6307, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6308, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6310, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6312, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6313, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6314, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6317, '', 8, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6318, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6319, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6322, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6324, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6326, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6334, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6335, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6336, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6341, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6343, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6344, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6345, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6346, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6347, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6348, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6349, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6350, '', 4, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6351, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6352, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6353, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6354, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6355, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6362, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6363, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6367, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6368, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6369, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6370, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6371, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6372, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6373, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6374, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6375, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6376, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6377, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6379, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6381, '', 7, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6382, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6383, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6387, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6390, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6391, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6392, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6393, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6396, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6397, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6398, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6399, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6400, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6401, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6402, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6403, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6404, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6406, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6407, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6408, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6415, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6416, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6418, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6419, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6420, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6421, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6422, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6426, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6427, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6430, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6431, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6432, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6433, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6434, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6442, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6444, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6445, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6454, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6455, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6456, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6458, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6459, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6460, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6461, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6463, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6464, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6465, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6468, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6469, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6471, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6472, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6473, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6487, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6488, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6489, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6490, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6491, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6493, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6494, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6495, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6496, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6497, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6499, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6500, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6501, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6502, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6504, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6505, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6508, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6512, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6513, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6521, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6524, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6526, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6527, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6530, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6531, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6532, '', 6, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6536, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6537, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6551, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6565, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6566, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6568, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6569, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6570, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6572, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6574, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6576, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6578, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6579, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6580, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6581, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6582, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6583, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6584, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6589, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6590, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6591, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6592, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6597, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6600, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6636, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6675, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6676, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6678, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6679, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6680, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6681, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6683, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6701, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6702, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6703, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6704, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6705, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6706, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6730, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6731, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6732, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6733, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6735, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6736, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6738, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6740, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6741, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6742, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6743, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6744, '', 7, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6745, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6752, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6753, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6755, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6756, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6758, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6759, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6760, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6772, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6774, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6776, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6778, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6790, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6791, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6813, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6814, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6815, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6816, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6817, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6818, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6819, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6820, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6821, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6822, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6823, '', 7, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6824, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6825, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6826, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6827, '', 6, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6828, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6830, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6836, '', 7, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6837, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6838, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6840, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6841, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6842, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6843, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6844, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6846, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6847, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6848, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6849, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6850, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6851, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6852, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6853, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6854, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6855, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6856, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6857, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6858, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6860, '', 8, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6861, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6862, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6863, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6867, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6870, '', 6, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6871, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6872, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6873, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6874, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6875, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6876, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6877, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6878, '', 6, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6879, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6880, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6881, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6882, '', 7, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6883, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6885, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6888, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6891, '', 6, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6892, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6895, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6903, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6905, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6907, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6909, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6910, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6913, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6914, '', 9, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6915, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6916, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6917, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6918, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6919, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6920, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6921, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6923, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6924, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6932, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6933, '', 6, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6935, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6936, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6937, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6939, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6941, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6942, '', 6, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6944, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6945, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6946, '', 7, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6947, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6952, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6954, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6955, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6956, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6957, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6961, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6962, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6963, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6964, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6965, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6966, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6967, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6968, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6969, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6970, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6971, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6972, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6975, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6976, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6977, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6978, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6979, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6983, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6984, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6985, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6986, '', 10, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6991, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6992, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6993, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (6999, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7001, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7003, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7004, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7005, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7006, '', 6, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7007, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7008, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7009, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7010, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7011, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7012, '', 6, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7013, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7014, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7015, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7017, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7035, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7036, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7038, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7039, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7040, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7041, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7042, '', 7, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7043, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7044, '', 7, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7046, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7048, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7049, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7050, '', 6, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7051, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7057, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7058, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7059, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7060, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7061, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7062, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7069, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7074, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7075, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7076, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7077, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7078, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7079, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7080, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7086, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7087, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7088, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7089, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7091, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7092, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7094, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7096, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7102, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7103, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7104, '', 7, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7105, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7107, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7109, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7115, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7116, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7117, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7119, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7121, '', 5, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7122, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7123, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7124, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7125, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7126, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7127, '', 7, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7130, '', 1, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7135, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7150, '', 3, '', 2, 14, 13, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7151, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7152, '', 6, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7153, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7154, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7166, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7170, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7171, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7174, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7175, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7177, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7178, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7179, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7180, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7181, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7182, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7184, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7185, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7187, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7188, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7189, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7190, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7194, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7199, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7204, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7205, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7206, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7207, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7208, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7209, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7210, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7211, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7212, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7213, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7214, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7220, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7228, '', 6, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7229, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7230, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7231, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7232, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7233, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7234, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7235, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7241, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7242, '', 4, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7243, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7245, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7246, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7247, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7248, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7249, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7250, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7251, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7253, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7256, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7258, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7259, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7264, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7268, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7269, '', 2, '', 2, 5, 3, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7270, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7271, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7272, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7273, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7274, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7275, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7277, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7296, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7297, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7298, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7299, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7300, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7302, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7313, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7316, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7317, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7318, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7319, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7320, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7321, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7322, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7324, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7326, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7327, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7328, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7330, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7331, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7332, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7333, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7338, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7342, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7343, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7344, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7345, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7346, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7350, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7351, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7353, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7354, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7355, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7357, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7358, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7368, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7374, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7378, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7386, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7392, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7393, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7394, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7398, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7528, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7529, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7530, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7531, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7533, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7534, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7535, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7536, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7537, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7538, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7539, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7540, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7548, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7549, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7553, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7555, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7556, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7558, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7559, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7560, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7561, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7562, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7563, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7564, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7565, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7566, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7567, '', 6, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7572, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7573, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7574, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7583, '', 4, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7584, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7585, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7586, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7587, '', 2, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7588, '', 5, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7589, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7593, '', 4, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7599, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7601, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7602, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7603, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7604, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7624, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7625, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7630, '', 6, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7631, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7633, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7634, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7635, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7636, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7637, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7650, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7651, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7652, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7653, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7654, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7656, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7667, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7668, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7669, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7671, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7672, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7673, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7674, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7675, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7676, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7688, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7691, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7693, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7694, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7695, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7696, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7697, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7698, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7699, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7700, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7705, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7706, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7716, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7717, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7718, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7719, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7720, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7721, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7722, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7731, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7735, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7738, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7739, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7740, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7741, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7742, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7743, '', 6, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7744, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7745, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7746, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7747, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7756, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7758, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7762, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7764, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7765, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7766, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7767, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7768, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7769, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7770, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7771, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7772, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7773, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7774, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7783, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7790, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7791, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7792, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7793, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7794, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7795, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7796, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7797, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7807, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7808, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7809, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7816, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7820, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7821, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7822, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7824, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7825, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7826, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7833, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7834, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7835, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7845, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7846, '', 4, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7847, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7848, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7849, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7850, '', 5, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7851, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7852, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7853, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7854, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7863, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7864, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7867, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7868, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7869, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7870, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7871, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7872, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7878, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7879, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7884, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7897, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7901, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7902, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7909, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7914, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7918, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7919, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7920, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7921, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7922, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7923, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7924, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7925, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7926, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7934, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7935, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7939, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7944, '', 5, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7945, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7947, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7949, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7950, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7952, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7953, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7954, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7960, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7968, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7969, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7970, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7971, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7972, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7973, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7974, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7975, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7976, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7986, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7987, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7988, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7993, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7994, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7995, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7996, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7997, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7998, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (7999, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8000, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8001, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8002, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8014, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8018, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8019, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8020, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8021, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8022, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8023, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8024, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8025, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8026, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8037, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8042, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8043, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8044, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8046, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8059, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8063, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8064, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8065, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8066, '', 6, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8067, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8096, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8105, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8151, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8175, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8190, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8230, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8231, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8259, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8260, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8261, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8262, '', 2, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8263, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8264, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8265, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8270, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8281, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8282, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8284, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8286, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8292, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8293, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8295, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8296, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8298, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8301, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8315, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8319, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8320, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8321, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8325, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8327, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8328, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8329, '', 2, '', 45, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8339, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8341, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8342, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8350, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8354, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8371, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8384, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8390, '', 3, '', 1, 1, 7, NULL, NULL, NULL);
INSERT INTO "passengers" VALUES (8396, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);

CREATE TABLE "seafarers" (
	"number"               integer	NOT NULL,
	"number_sup"           char(1)	NOT NULL,
	"trip"                 integer,
	"trip_sup"             char(1),
	"onboard_at_departure" integer,
	"death_at_cape"        integer,
	"left_at_cape"         integer,
	"onboard_at_cape"      integer,
	"death_during_voyage"  integer,
	"onboard_at_arrival"   integer
);

INSERT INTO "seafarers" VALUES (196, '', 1, '', 65, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (197, '', 1, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (296, '', 1, '', 126, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (298, '', 1, '', 147, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (299, '', 1, '', 89, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (301, '', 1, '', 152, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (302, '', 1, '', 105, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (303, '', 1, '', 54, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (304, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (305, '', 1, '', 109, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (306, '', 1, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (307, '', 1, '', 103, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (308, '', 1, '', 25, NULL, NULL, NULL, 3, NULL);
INSERT INTO "seafarers" VALUES (310, '', 2, '', 181, NULL, NULL, NULL, 13, 168);
INSERT INTO "seafarers" VALUES (311, '', 2, '', 183, NULL, NULL, NULL, 28, 155);
INSERT INTO "seafarers" VALUES (318, '', 5, '', 160, NULL, NULL, NULL, 31, 129);
INSERT INTO "seafarers" VALUES (320, '', 3, '', 162, NULL, NULL, NULL, 20, 255);
INSERT INTO "seafarers" VALUES (321, '', 2, '', 116, NULL, NULL, NULL, 30, 141);
INSERT INTO "seafarers" VALUES (335, '', 1, '', 158, NULL, NULL, NULL, 28, 192);
INSERT INTO "seafarers" VALUES (340, '', 1, '', 230, NULL, NULL, NULL, 62, 270);
INSERT INTO "seafarers" VALUES (362, '', 4, '', NULL, NULL, NULL, NULL, NULL, 180);
INSERT INTO "seafarers" VALUES (446, '', 4, '', 120, NULL, NULL, NULL, 4, 120);
INSERT INTO "seafarers" VALUES (448, '', 2, '', NULL, NULL, NULL, NULL, 1, 165);
INSERT INTO "seafarers" VALUES (464, '', 2, '', NULL, NULL, NULL, NULL, 1, 154);
INSERT INTO "seafarers" VALUES (465, '', 3, '', NULL, NULL, NULL, NULL, 6, 138);
INSERT INTO "seafarers" VALUES (466, '', 1, '', NULL, NULL, NULL, NULL, 13, 117);
INSERT INTO "seafarers" VALUES (467, '', 1, '', NULL, NULL, NULL, NULL, 1, 66);
INSERT INTO "seafarers" VALUES (468, '', 1, '', NULL, NULL, NULL, NULL, 3, 60);
INSERT INTO "seafarers" VALUES (469, '', 1, '', NULL, NULL, NULL, NULL, NULL, 107);
INSERT INTO "seafarers" VALUES (470, '', 1, '', NULL, NULL, NULL, NULL, 3, 41);
INSERT INTO "seafarers" VALUES (471, '', 3, '', NULL, NULL, NULL, NULL, 11, 232);
INSERT INTO "seafarers" VALUES (472, '', 1, '', NULL, NULL, NULL, NULL, 7, 78);
INSERT INTO "seafarers" VALUES (473, '', 1, '', NULL, NULL, NULL, NULL, 3, 51);
INSERT INTO "seafarers" VALUES (474, '', 1, '', NULL, NULL, NULL, NULL, 19, 143);
INSERT INTO "seafarers" VALUES (475, '', 4, '', NULL, NULL, NULL, NULL, 21, 152);
INSERT INTO "seafarers" VALUES (476, '', 3, '', NULL, NULL, NULL, NULL, 26, 190);
INSERT INTO "seafarers" VALUES (477, '', 1, '', NULL, NULL, NULL, NULL, NULL, 26);
INSERT INTO "seafarers" VALUES (478, '', 1, '', NULL, NULL, NULL, NULL, 1, 54);
INSERT INTO "seafarers" VALUES (479, '', 2, '', NULL, NULL, NULL, NULL, 2, 134);
INSERT INTO "seafarers" VALUES (480, '', 1, '', NULL, NULL, NULL, NULL, 8, 193);
INSERT INTO "seafarers" VALUES (481, '', 7, '', NULL, NULL, NULL, NULL, 3, 209);
INSERT INTO "seafarers" VALUES (482, '', 5, '', NULL, NULL, NULL, NULL, 46, 144);
INSERT INTO "seafarers" VALUES (483, '', 4, '', NULL, NULL, NULL, NULL, 39, 184);
INSERT INTO "seafarers" VALUES (484, '', 1, '', NULL, NULL, NULL, NULL, NULL, 42);
INSERT INTO "seafarers" VALUES (485, '', 3, '', 120, NULL, NULL, NULL, NULL, 120);
INSERT INTO "seafarers" VALUES (486, '', 3, '', 249, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (487, '', 2, '', NULL, NULL, NULL, NULL, 2, 256);
INSERT INTO "seafarers" VALUES (488, '', 2, '', NULL, NULL, NULL, NULL, 1, 150);
INSERT INTO "seafarers" VALUES (489, '', 1, '', NULL, NULL, NULL, NULL, 1, 59);
INSERT INTO "seafarers" VALUES (490, '', 1, '', NULL, NULL, NULL, NULL, NULL, 56);
INSERT INTO "seafarers" VALUES (491, '', 1, '', NULL, NULL, NULL, NULL, NULL, 63);
INSERT INTO "seafarers" VALUES (492, '', 5, '', NULL, NULL, NULL, NULL, 38, 244);
INSERT INTO "seafarers" VALUES (493, '', 1, '', NULL, NULL, NULL, NULL, 20, 154);
INSERT INTO "seafarers" VALUES (494, '', 1, '', NULL, NULL, NULL, NULL, 5, 82);
INSERT INTO "seafarers" VALUES (495, '', 1, '', NULL, NULL, NULL, NULL, 1, 83);
INSERT INTO "seafarers" VALUES (496, '', 1, '', NULL, NULL, NULL, NULL, 1, 43);
INSERT INTO "seafarers" VALUES (497, '', 1, '', NULL, NULL, NULL, NULL, 18, 46);
INSERT INTO "seafarers" VALUES (498, '', 2, '', NULL, NULL, NULL, NULL, 6, 129);
INSERT INTO "seafarers" VALUES (499, '', 1, '', NULL, NULL, NULL, NULL, NULL, 74);
INSERT INTO "seafarers" VALUES (500, '', 1, '', 80, NULL, NULL, NULL, 3, 94);
INSERT INTO "seafarers" VALUES (501, '', 1, '', 80, NULL, NULL, NULL, 5, 71);
INSERT INTO "seafarers" VALUES (502, '', 3, '', NULL, NULL, NULL, NULL, 10, 196);
INSERT INTO "seafarers" VALUES (503, '', 3, '', NULL, NULL, NULL, NULL, 13, 222);
INSERT INTO "seafarers" VALUES (504, '', 1, '', NULL, NULL, NULL, NULL, 2, 72);
INSERT INTO "seafarers" VALUES (505, '', 1, '', 40, NULL, NULL, NULL, NULL, 40);
INSERT INTO "seafarers" VALUES (506, '', 3, '', NULL, NULL, NULL, NULL, 185, 93);
INSERT INTO "seafarers" VALUES (507, '', 1, '', NULL, NULL, NULL, NULL, 1, 47);
INSERT INTO "seafarers" VALUES (509, '', 4, '', NULL, NULL, NULL, NULL, 12, 209);
INSERT INTO "seafarers" VALUES (512, '', 3, '', 250, 56, NULL, NULL, 9, 151);
INSERT INTO "seafarers" VALUES (513, '', 4, '', NULL, NULL, NULL, NULL, 7, 168);
INSERT INTO "seafarers" VALUES (514, '', 1, '', NULL, NULL, NULL, NULL, NULL, 53);
INSERT INTO "seafarers" VALUES (515, '', 1, '', NULL, NULL, NULL, NULL, 3, 81);
INSERT INTO "seafarers" VALUES (516, '', 2, '', NULL, NULL, NULL, NULL, 3, 203);
INSERT INTO "seafarers" VALUES (517, '', 1, '', NULL, NULL, NULL, NULL, 6, 73);
INSERT INTO "seafarers" VALUES (518, '', 4, '', NULL, NULL, NULL, NULL, 15, 168);
INSERT INTO "seafarers" VALUES (519, '', 1, '', NULL, NULL, NULL, NULL, 2, 46);
INSERT INTO "seafarers" VALUES (520, '', 1, '', NULL, NULL, NULL, NULL, 5, 48);
INSERT INTO "seafarers" VALUES (521, '', 4, '', NULL, NULL, NULL, NULL, 20, 213);
INSERT INTO "seafarers" VALUES (522, '', 1, '', NULL, NULL, NULL, NULL, 3, 129);
INSERT INTO "seafarers" VALUES (523, '', 1, '', NULL, NULL, NULL, NULL, 4, 68);
INSERT INTO "seafarers" VALUES (525, '', 1, '', NULL, NULL, NULL, NULL, 29, 55);
INSERT INTO "seafarers" VALUES (527, '', 1, '', NULL, NULL, NULL, NULL, 2, 75);
INSERT INTO "seafarers" VALUES (528, '', 8, '', NULL, NULL, NULL, NULL, 14, 201);
INSERT INTO "seafarers" VALUES (529, '', 1, '', NULL, NULL, NULL, NULL, 39, 176);
INSERT INTO "seafarers" VALUES (531, '', 5, '', NULL, NULL, NULL, NULL, 39, 159);
INSERT INTO "seafarers" VALUES (548, '', 3, '', NULL, NULL, NULL, NULL, 42, 129);
INSERT INTO "seafarers" VALUES (549, '', 1, '', NULL, NULL, NULL, NULL, 10, 123);
INSERT INTO "seafarers" VALUES (550, '', 1, '', NULL, NULL, NULL, NULL, 8, 44);
INSERT INTO "seafarers" VALUES (552, '', 1, '', NULL, NULL, NULL, NULL, 2, 54);
INSERT INTO "seafarers" VALUES (553, '', 1, '', NULL, NULL, NULL, NULL, 8, 163);
INSERT INTO "seafarers" VALUES (554, '', 1, '', NULL, NULL, NULL, NULL, 29, 156);
INSERT INTO "seafarers" VALUES (555, '', 1, '', NULL, NULL, NULL, NULL, NULL, 53);
INSERT INTO "seafarers" VALUES (557, '', 1, '', NULL, NULL, NULL, NULL, 40, 50);
INSERT INTO "seafarers" VALUES (558, '', 2, '', NULL, NULL, NULL, NULL, 6, 194);
INSERT INTO "seafarers" VALUES (559, '', 1, '', NULL, NULL, NULL, NULL, 5, 83);
INSERT INTO "seafarers" VALUES (560, '', 5, '', NULL, NULL, NULL, NULL, 16, 140);
INSERT INTO "seafarers" VALUES (561, '', 2, '', NULL, NULL, NULL, NULL, 7, 159);
INSERT INTO "seafarers" VALUES (563, '', 1, '', NULL, NULL, NULL, NULL, 14, 68);
INSERT INTO "seafarers" VALUES (564, '', 2, '', NULL, NULL, NULL, NULL, 9, 149);
INSERT INTO "seafarers" VALUES (565, '', 3, '', NULL, NULL, NULL, NULL, NULL, 144);
INSERT INTO "seafarers" VALUES (566, '', 3, '', NULL, NULL, NULL, NULL, 2, 216);
INSERT INTO "seafarers" VALUES (567, '', 1, '', NULL, NULL, NULL, NULL, 10, 89);
INSERT INTO "seafarers" VALUES (568, '', 2, '', NULL, NULL, NULL, NULL, 10, 149);
INSERT INTO "seafarers" VALUES (569, '', 1, '', NULL, NULL, NULL, NULL, 28, 158);
INSERT INTO "seafarers" VALUES (570, '', 1, '', NULL, NULL, NULL, NULL, 15, 197);
INSERT INTO "seafarers" VALUES (577, '', 4, '', NULL, NULL, NULL, NULL, 1, 159);
INSERT INTO "seafarers" VALUES (579, '', 2, '', NULL, NULL, NULL, NULL, 5, 54);
INSERT INTO "seafarers" VALUES (580, '', 1, '', NULL, NULL, NULL, NULL, 1, 73);
INSERT INTO "seafarers" VALUES (582, '', 1, '', NULL, NULL, NULL, NULL, 1, 154);
INSERT INTO "seafarers" VALUES (584, '', 1, '', NULL, NULL, NULL, NULL, 6, 208);
INSERT INTO "seafarers" VALUES (585, '', 1, '', NULL, NULL, NULL, NULL, NULL, 18);
INSERT INTO "seafarers" VALUES (586, '', 5, '', NULL, NULL, NULL, NULL, 3, 181);
INSERT INTO "seafarers" VALUES (587, '', 5, '', NULL, NULL, NULL, NULL, 26, 183);
INSERT INTO "seafarers" VALUES (588, '', 1, '', NULL, NULL, NULL, NULL, NULL, 44);
INSERT INTO "seafarers" VALUES (589, '', 7, '', NULL, NULL, NULL, NULL, 38, 164);
INSERT INTO "seafarers" VALUES (590, '', 1, '', NULL, NULL, NULL, NULL, NULL, 73);
INSERT INTO "seafarers" VALUES (591, '', 1, '', NULL, NULL, NULL, NULL, 2, 61);
INSERT INTO "seafarers" VALUES (592, '', 1, '', NULL, NULL, NULL, NULL, NULL, 51);
INSERT INTO "seafarers" VALUES (593, '', 2, '', NULL, NULL, NULL, NULL, 18, 174);
INSERT INTO "seafarers" VALUES (594, '', 1, '', NULL, NULL, NULL, NULL, NULL, 17);
INSERT INTO "seafarers" VALUES (595, '', 6, '', NULL, NULL, NULL, NULL, 12, 169);
INSERT INTO "seafarers" VALUES (596, '', 2, '', NULL, NULL, NULL, NULL, 32, 202);
INSERT INTO "seafarers" VALUES (597, '', 2, '', NULL, NULL, NULL, NULL, 4, 223);
INSERT INTO "seafarers" VALUES (598, '', 6, '', NULL, NULL, NULL, NULL, 3, 120);
INSERT INTO "seafarers" VALUES (599, '', 2, '', 114, NULL, NULL, NULL, 6, 108);
INSERT INTO "seafarers" VALUES (600, '', 3, '', NULL, NULL, NULL, NULL, 2, 243);
INSERT INTO "seafarers" VALUES (601, '', 2, '', NULL, NULL, NULL, NULL, 4, 167);
INSERT INTO "seafarers" VALUES (602, '', 2, '', 82, NULL, NULL, NULL, NULL, 82);
INSERT INTO "seafarers" VALUES (603, '', 7, '', 172, NULL, NULL, NULL, NULL, 172);
INSERT INTO "seafarers" VALUES (604, '', 2, '', NULL, NULL, NULL, NULL, 10, 202);
INSERT INTO "seafarers" VALUES (605, '', 1, '', NULL, NULL, NULL, NULL, 5, 218);
INSERT INTO "seafarers" VALUES (606, '', 3, '', NULL, NULL, NULL, NULL, 1, 170);
INSERT INTO "seafarers" VALUES (607, '', 1, '', NULL, NULL, NULL, NULL, 2, 167);
INSERT INTO "seafarers" VALUES (608, '', 2, '', NULL, NULL, NULL, NULL, 5, 159);
INSERT INTO "seafarers" VALUES (609, '', 5, '', NULL, NULL, NULL, NULL, 26, 159);
INSERT INTO "seafarers" VALUES (610, '', 1, '', 37, NULL, NULL, NULL, NULL, 37);
INSERT INTO "seafarers" VALUES (611, '', 1, '', 41, NULL, NULL, NULL, 11, 33);
INSERT INTO "seafarers" VALUES (613, '', 2, '', 133, NULL, NULL, 25, 31, 220);
INSERT INTO "seafarers" VALUES (614, '', 2, '', 225, 3, NULL, 69, 70, 196);
INSERT INTO "seafarers" VALUES (615, '', 1, '', 79, NULL, NULL, NULL, NULL, 79);
INSERT INTO "seafarers" VALUES (616, '', 4, '', NULL, NULL, NULL, NULL, 62, 266);
INSERT INTO "seafarers" VALUES (617, '', 8, '', NULL, NULL, NULL, NULL, 2, 193);
INSERT INTO "seafarers" VALUES (618, '', 2, '', NULL, NULL, NULL, NULL, 2, 239);
INSERT INTO "seafarers" VALUES (619, '', 1, '', NULL, NULL, NULL, NULL, 3, 86);
INSERT INTO "seafarers" VALUES (620, '', 1, '', 81, NULL, NULL, NULL, NULL, 81);
INSERT INTO "seafarers" VALUES (621, '', 2, '', NULL, NULL, NULL, NULL, 6, 255);
INSERT INTO "seafarers" VALUES (624, '', 1, '', NULL, NULL, NULL, NULL, 5, 40);
INSERT INTO "seafarers" VALUES (625, '', 1, '', NULL, NULL, NULL, NULL, 1, 48);
INSERT INTO "seafarers" VALUES (626, '', 1, '', NULL, NULL, NULL, NULL, 16, 169);
INSERT INTO "seafarers" VALUES (627, '', 7, '', NULL, NULL, NULL, NULL, 7, 252);
INSERT INTO "seafarers" VALUES (628, '', 1, '', NULL, NULL, NULL, NULL, 2, 59);
INSERT INTO "seafarers" VALUES (629, '', 1, '', NULL, NULL, NULL, NULL, 2, 63);
INSERT INTO "seafarers" VALUES (630, '', 1, '', NULL, NULL, NULL, NULL, 2, 42);
INSERT INTO "seafarers" VALUES (636, '', 1, '', NULL, NULL, NULL, NULL, 1, 119);
INSERT INTO "seafarers" VALUES (641, '', 1, '', NULL, NULL, NULL, NULL, 2, 60);
INSERT INTO "seafarers" VALUES (642, '', 1, '', NULL, NULL, NULL, NULL, 16, 95);
INSERT INTO "seafarers" VALUES (643, '', 3, '', NULL, NULL, NULL, NULL, 61, 197);
INSERT INTO "seafarers" VALUES (644, '', 1, '', NULL, NULL, NULL, NULL, 3, 38);
INSERT INTO "seafarers" VALUES (645, '', 6, '', NULL, NULL, NULL, NULL, 4, 213);
INSERT INTO "seafarers" VALUES (646, '', 4, '', NULL, NULL, NULL, NULL, 16, 230);
INSERT INTO "seafarers" VALUES (648, '', 1, '', NULL, NULL, NULL, NULL, 5, 58);
INSERT INTO "seafarers" VALUES (649, '', 1, '', NULL, NULL, NULL, NULL, 20, 38);
INSERT INTO "seafarers" VALUES (659, '', 3, '', NULL, NULL, NULL, NULL, NULL, 300);
INSERT INTO "seafarers" VALUES (681, '', 8, '', NULL, NULL, NULL, NULL, 19, 233);
INSERT INTO "seafarers" VALUES (683, '', 1, '', 368, 26, NULL, NULL, 132, 161);
INSERT INTO "seafarers" VALUES (685, '', 4, '', NULL, NULL, NULL, NULL, NULL, 207);
INSERT INTO "seafarers" VALUES (687, '', 2, '', 216, NULL, NULL, NULL, 5, 164);
INSERT INTO "seafarers" VALUES (691, '', 1, '', NULL, NULL, NULL, NULL, 7, 61);
INSERT INTO "seafarers" VALUES (693, '', 1, '', NULL, NULL, NULL, NULL, 4, 64);
INSERT INTO "seafarers" VALUES (694, '', 1, '', 36, NULL, NULL, NULL, 3, NULL);
INSERT INTO "seafarers" VALUES (695, '', 1, '', NULL, NULL, NULL, NULL, 51, 179);
INSERT INTO "seafarers" VALUES (696, '', 4, '', NULL, NULL, NULL, NULL, 75, 199);
INSERT INTO "seafarers" VALUES (700, '', 1, '', NULL, NULL, NULL, NULL, 1, 93);
INSERT INTO "seafarers" VALUES (701, '', 1, '', NULL, NULL, NULL, NULL, 7, 93);
INSERT INTO "seafarers" VALUES (706, '', 2, '', NULL, NULL, NULL, NULL, 11, 77);
INSERT INTO "seafarers" VALUES (707, '', 9, '', NULL, NULL, NULL, NULL, 5, 196);
INSERT INTO "seafarers" VALUES (723, '', 1, '', NULL, NULL, NULL, NULL, NULL, 86);
INSERT INTO "seafarers" VALUES (724, '', 5, '', NULL, NULL, NULL, NULL, 23, 189);
INSERT INTO "seafarers" VALUES (725, '', 1, '', NULL, NULL, NULL, NULL, 4, 66);
INSERT INTO "seafarers" VALUES (726, '', 3, '', NULL, NULL, NULL, NULL, 23, 109);
INSERT INTO "seafarers" VALUES (727, '', 6, '', NULL, NULL, NULL, NULL, 8, 103);
INSERT INTO "seafarers" VALUES (728, '', 4, '', NULL, NULL, NULL, NULL, 13, 163);
INSERT INTO "seafarers" VALUES (729, '', 6, '', 300, NULL, NULL, NULL, 50, 169);
INSERT INTO "seafarers" VALUES (730, '', 2, '', NULL, NULL, NULL, NULL, 20, 165);
INSERT INTO "seafarers" VALUES (731, '', 2, '', NULL, NULL, NULL, NULL, NULL, 83);
INSERT INTO "seafarers" VALUES (732, '', 8, '', NULL, NULL, NULL, NULL, 2, 174);
INSERT INTO "seafarers" VALUES (733, '', 5, '', NULL, NULL, NULL, NULL, 49, 172);
INSERT INTO "seafarers" VALUES (734, '', 5, '', NULL, NULL, NULL, NULL, 18, 175);
INSERT INTO "seafarers" VALUES (735, '', 1, '', NULL, NULL, NULL, NULL, 31, 119);
INSERT INTO "seafarers" VALUES (737, '', 1, '', NULL, NULL, NULL, NULL, 5, 225);
INSERT INTO "seafarers" VALUES (738, '', 2, '', NULL, NULL, 49, NULL, 1, 50);
INSERT INTO "seafarers" VALUES (740, '', 2, '', NULL, NULL, 28, NULL, 4, 58);
INSERT INTO "seafarers" VALUES (741, '', 4, '', NULL, NULL, NULL, NULL, 5, 166);
INSERT INTO "seafarers" VALUES (742, '', 6, '', NULL, 85, 20, NULL, 93, 197);
INSERT INTO "seafarers" VALUES (743, '', 6, '', NULL, 45, 30, NULL, 56, 212);
INSERT INTO "seafarers" VALUES (744, '', 6, '', NULL, NULL, NULL, NULL, 53, 179);
INSERT INTO "seafarers" VALUES (745, '', 5, '', NULL, 39, NULL, NULL, 68, 165);
INSERT INTO "seafarers" VALUES (746, '', 1, '', NULL, NULL, NULL, NULL, 14, 88);
INSERT INTO "seafarers" VALUES (747, '', 1, '', NULL, NULL, NULL, NULL, 5, 90);
INSERT INTO "seafarers" VALUES (748, '', 1, '', NULL, NULL, NULL, NULL, NULL, 20);
INSERT INTO "seafarers" VALUES (749, '', 5, '', NULL, NULL, NULL, NULL, 75, 196);
INSERT INTO "seafarers" VALUES (750, '', 3, '', NULL, NULL, NULL, NULL, 56, 197);
INSERT INTO "seafarers" VALUES (751, '', 1, '', NULL, NULL, NULL, NULL, 1, 56);
INSERT INTO "seafarers" VALUES (752, '', 9, '', NULL, NULL, NULL, NULL, 87, 192);
INSERT INTO "seafarers" VALUES (753, '', 7, '', NULL, NULL, NULL, NULL, 87, 163);
INSERT INTO "seafarers" VALUES (754, '', 1, '', NULL, NULL, NULL, NULL, 1, 30);
INSERT INTO "seafarers" VALUES (761, '', 1, '', NULL, NULL, NULL, NULL, 1, 74);
INSERT INTO "seafarers" VALUES (762, '', 1, '', NULL, 6, 25, NULL, 9, 92);
INSERT INTO "seafarers" VALUES (763, '', 1, '', 170, NULL, NULL, NULL, 19, 94);
INSERT INTO "seafarers" VALUES (766, '', 1, '', NULL, NULL, NULL, NULL, 18, 142);
INSERT INTO "seafarers" VALUES (767, '', 1, '', 79, NULL, NULL, NULL, 11, 138);
INSERT INTO "seafarers" VALUES (769, '', 1, '', 89, NULL, NULL, NULL, 13, 10);
INSERT INTO "seafarers" VALUES (770, '', 2, '', NULL, NULL, NULL, NULL, 5, 92);
INSERT INTO "seafarers" VALUES (771, '', 1, '', NULL, NULL, NULL, NULL, 15, 163);
INSERT INTO "seafarers" VALUES (774, '', 1, '', NULL, NULL, NULL, NULL, 2, 115);
INSERT INTO "seafarers" VALUES (775, '', 6, '', NULL, NULL, NULL, NULL, 6, 246);
INSERT INTO "seafarers" VALUES (776, '', 5, '', NULL, NULL, NULL, NULL, 57, 102);
INSERT INTO "seafarers" VALUES (777, '', 2, '', NULL, NULL, NULL, NULL, 11, 171);
INSERT INTO "seafarers" VALUES (782, '', 1, '', NULL, NULL, NULL, NULL, 4, 90);
INSERT INTO "seafarers" VALUES (803, '', 7, '', NULL, NULL, NULL, NULL, 35, 200);
INSERT INTO "seafarers" VALUES (805, '', 8, '', NULL, NULL, NULL, NULL, 14, 228);
INSERT INTO "seafarers" VALUES (807, '', 7, '', NULL, 16, NULL, NULL, 10, 192);
INSERT INTO "seafarers" VALUES (826, '', 1, '', NULL, 6, NULL, NULL, 10, 204);
INSERT INTO "seafarers" VALUES (827, '', 1, '', NULL, 6, NULL, NULL, 7, 189);
INSERT INTO "seafarers" VALUES (829, '', 7, '', NULL, 11, NULL, NULL, 17, 163);
INSERT INTO "seafarers" VALUES (830, '', 6, '', 290, 5, NULL, NULL, 7, 185);
INSERT INTO "seafarers" VALUES (831, '', 1, '', NULL, 1, NULL, NULL, 3, 215);
INSERT INTO "seafarers" VALUES (834, '', 1, '', 75, NULL, NULL, NULL, NULL, 58);
INSERT INTO "seafarers" VALUES (835, '', 2, '', 165, 2, NULL, NULL, 2, 141);
INSERT INTO "seafarers" VALUES (836, '', 2, '', NULL, 2, NULL, NULL, 2, 120);
INSERT INTO "seafarers" VALUES (837, '', 2, '', 214, 1, NULL, NULL, 2, 151);
INSERT INTO "seafarers" VALUES (839, '', 1, '', 105, NULL, NULL, NULL, NULL, 74);
INSERT INTO "seafarers" VALUES (840, '', 1, '', 187, 2, NULL, NULL, 2, 117);
INSERT INTO "seafarers" VALUES (841, '', 1, '', 242, 3, NULL, NULL, 8, 175);
INSERT INTO "seafarers" VALUES (842, '', 1, '', 223, 1, NULL, NULL, 2, 170);
INSERT INTO "seafarers" VALUES (843, '', 1, '', 241, 5, NULL, NULL, 6, 168);
INSERT INTO "seafarers" VALUES (844, '', 2, '', 200, 2, NULL, NULL, 5, 123);
INSERT INTO "seafarers" VALUES (845, '', 2, '', 170, 1, NULL, NULL, 3, 92);
INSERT INTO "seafarers" VALUES (846, '', 2, '', 260, NULL, NULL, NULL, 6, 150);
INSERT INTO "seafarers" VALUES (847, '', 3, '', NULL, NULL, NULL, NULL, 2, 71);
INSERT INTO "seafarers" VALUES (849, '', 1, '', 38, NULL, NULL, NULL, 1, 33);
INSERT INTO "seafarers" VALUES (850, '', 3, '', 347, 3, 9, NULL, 7, 225);
INSERT INTO "seafarers" VALUES (851, '', 1, '', 40, NULL, NULL, NULL, NULL, 39);
INSERT INTO "seafarers" VALUES (854, '', 1, '', 64, NULL, 1, NULL, 1, 40);
INSERT INTO "seafarers" VALUES (855, '', 5, '', 356, NULL, 13, NULL, 4, 150);
INSERT INTO "seafarers" VALUES (858, '', 8, '', 250, NULL, 7, 2, 29, 122);
INSERT INTO "seafarers" VALUES (859, '', 1, '', 36, 1, 1, NULL, NULL, 35);
INSERT INTO "seafarers" VALUES (860, '', 1, '', 208, 8, 14, 4, NULL, 110);
INSERT INTO "seafarers" VALUES (861, '', 1, '', 54, NULL, 1, 4, NULL, 5);
INSERT INTO "seafarers" VALUES (862, '', 7, '', 240, 3, 1, NULL, 3, 236);
INSERT INTO "seafarers" VALUES (863, '', 7, '', 254, 5, 6, 10, 6, 252);
INSERT INTO "seafarers" VALUES (864, '', 2, '', 379, 22, 10, NULL, 25, 232);
INSERT INTO "seafarers" VALUES (865, '', 1, '', 230, 11, NULL, NULL, 10, 130);
INSERT INTO "seafarers" VALUES (866, '', 1, '', 172, 2, 9, 8, 5, 166);
INSERT INTO "seafarers" VALUES (867, '', 1, '', 57, 6, NULL, 1, 6, 52);
INSERT INTO "seafarers" VALUES (868, '', 3, '', 199, 3, NULL, 18, 20, 313);
INSERT INTO "seafarers" VALUES (869, '', 7, '', NULL, NULL, NULL, NULL, 23, 282);
INSERT INTO "seafarers" VALUES (870, '', 1, '', 152, 1, 49, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (871, '', 1, '', 38, NULL, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (872, '', 8, '', NULL, 1, NULL, NULL, 13, 200);
INSERT INTO "seafarers" VALUES (873, '', 8, '', 276, 7, 12, 50, 7, 200);
INSERT INTO "seafarers" VALUES (874, '', 8, '', 210, 3, 33, NULL, 4, 173);
INSERT INTO "seafarers" VALUES (875, '', 9, '', 244, 5, NULL, 35, 6, 222);
INSERT INTO "seafarers" VALUES (876, '', 8, '', 340, 5, 8, 3, 8, 188);
INSERT INTO "seafarers" VALUES (877, '', 1, '', 63, 7, 6, 11, 7, 40);
INSERT INTO "seafarers" VALUES (878, '', 1, '', 154, 10, NULL, 3, 12, 87);
INSERT INTO "seafarers" VALUES (879, '', 2, '', 317, 11, 7, 7, 33, 202);
INSERT INTO "seafarers" VALUES (880, '', 2, '', 313, 9, 17, NULL, 10, 78);
INSERT INTO "seafarers" VALUES (881, '', 2, '', 323, 29, 14, 4, 38, 193);
INSERT INTO "seafarers" VALUES (882, '', 1, '', 150, NULL, 6, NULL, 2, 93);
INSERT INTO "seafarers" VALUES (883, '', 1, '', 79, 1, NULL, NULL, 1, 45);
INSERT INTO "seafarers" VALUES (884, '', 3, '', 368, 14, 8, NULL, 36, 200);
INSERT INTO "seafarers" VALUES (885, '', 4, '', NULL, 16, 20, NULL, 19, 306);
INSERT INTO "seafarers" VALUES (886, '', 1, '', 172, 3, NULL, NULL, 12, 119);
INSERT INTO "seafarers" VALUES (887, '', 1, '', 175, NULL, 4, 4, 27, 42);
INSERT INTO "seafarers" VALUES (888, '', 9, '', 252, 3, 11, 7, 5, 126);
INSERT INTO "seafarers" VALUES (889, '', 7, '', 282, 82, 8, 3, 67, 210);
INSERT INTO "seafarers" VALUES (890, '', 1, '', 160, 2, 5, NULL, 2, 98);
INSERT INTO "seafarers" VALUES (891, '', 1, '', 134, 1, 1, 8, 6, 100);
INSERT INTO "seafarers" VALUES (892, '', 1, '', 79, 5, 7, 9, 5, 76);
INSERT INTO "seafarers" VALUES (893, '', 1, '', 34, NULL, NULL, 4, 2, 36);
INSERT INTO "seafarers" VALUES (894, '', 2, '', 240, 11, 12, NULL, 7, 221);
INSERT INTO "seafarers" VALUES (895, '', 1, '', 49, 1, NULL, NULL, 1, 48);
INSERT INTO "seafarers" VALUES (896, '', 1, '', 50, 1, NULL, NULL, 1, 49);
INSERT INTO "seafarers" VALUES (897, '', 4, '', 266, 13, 3, NULL, 9, 254);
INSERT INTO "seafarers" VALUES (898, '', 6, '', 271, 8, 25, NULL, 11, 235);
INSERT INTO "seafarers" VALUES (899, '', 1, '', 28, NULL, NULL, NULL, 1, 27);
INSERT INTO "seafarers" VALUES (900, '', 1, '', 99, 23, NULL, 4, 18, 85);
INSERT INTO "seafarers" VALUES (901, '', 1, '', 81, NULL, NULL, NULL, 7, 74);
INSERT INTO "seafarers" VALUES (902, '', 2, '', 75, 1, 1, NULL, 2, 72);
INSERT INTO "seafarers" VALUES (903, '', 2, '', 110, 1, NULL, NULL, 2, 108);
INSERT INTO "seafarers" VALUES (904, '', 1, '', 58, 1, NULL, 3, 1, 55);
INSERT INTO "seafarers" VALUES (905, '', 2, '', 220, 12, 5, NULL, 8, 207);
INSERT INTO "seafarers" VALUES (906, '', 8, '', 272, 15, NULL, 10, 12, 270);
INSERT INTO "seafarers" VALUES (907, '', 2, '', 121, 1, NULL, 3, 1, 123);
INSERT INTO "seafarers" VALUES (908, '', 8, '', 240, 9, NULL, 1, 9, 232);
INSERT INTO "seafarers" VALUES (909, '', 8, '', 234, 40, NULL, NULL, 26, 208);
INSERT INTO "seafarers" VALUES (910, '', 3, '', 236, 32, 1, 5, 35, 205);
INSERT INTO "seafarers" VALUES (911, '', 10, '', 192, 18, 3, NULL, 20, 169);
INSERT INTO "seafarers" VALUES (912, '', 1, '', 132, 7, 7, NULL, 7, 118);
INSERT INTO "seafarers" VALUES (913, '', 3, '', 356, 31, NULL, 2, 39, 202);
INSERT INTO "seafarers" VALUES (915, '', 2, '', 128, 3, NULL, NULL, 3, 125);
INSERT INTO "seafarers" VALUES (916, '', 1, '', 99, 1, 1, NULL, 1, 97);
INSERT INTO "seafarers" VALUES (917, '', 2, '', 131, 11, 1, NULL, 10, 120);
INSERT INTO "seafarers" VALUES (918, '', 2, '', 110, 1, 1, NULL, 3, 106);
INSERT INTO "seafarers" VALUES (919, '', 9, '', 272, 20, 3, NULL, 29, 240);
INSERT INTO "seafarers" VALUES (920, '', 1, '', 299, 16, NULL, NULL, 23, 176);
INSERT INTO "seafarers" VALUES (921, '', 1, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (922, '', 1, '', 302, 3, 11, NULL, 21, 202);
INSERT INTO "seafarers" VALUES (923, '', 4, '', 189, 3, 4, NULL, 2, 183);
INSERT INTO "seafarers" VALUES (924, '', 9, '', 206, NULL, NULL, NULL, 7, 199);
INSERT INTO "seafarers" VALUES (925, '', 1, '', 139, NULL, NULL, NULL, 2, 82);
INSERT INTO "seafarers" VALUES (926, '', 1, '', 55, 1, NULL, 1, 1, 53);
INSERT INTO "seafarers" VALUES (927, '', 1, '', 88, 4, 12, 7, 4, 78);
INSERT INTO "seafarers" VALUES (928, '', 9, '', 212, 6, 16, 7, 6, 349);
INSERT INTO "seafarers" VALUES (931, '', 1, '', 222, 73, 11, 18, 38, 191);
INSERT INTO "seafarers" VALUES (932, '', 2, '', 150, NULL, 4, NULL, 1, 145);
INSERT INTO "seafarers" VALUES (933, '', 4, '', 195, 5, 6, 1, 4, 189);
INSERT INTO "seafarers" VALUES (934, '', 2, '', 100, 1, NULL, NULL, 1, 97);
INSERT INTO "seafarers" VALUES (935, '', 1, '', 60, 1, NULL, NULL, 1, 59);
INSERT INTO "seafarers" VALUES (936, '', 3, '', 213, 4, 1, NULL, 5, 207);
INSERT INTO "seafarers" VALUES (937, '', 1, '', 92, 4, NULL, NULL, 4, 88);
INSERT INTO "seafarers" VALUES (938, '', 5, '', 242, 15, 1, 12, 17, 236);
INSERT INTO "seafarers" VALUES (939, '', 3, '', 236, 31, 2, NULL, 22, 212);
INSERT INTO "seafarers" VALUES (940, '', 3, '', 228, 26, 6, 3, 20, 211);
INSERT INTO "seafarers" VALUES (941, '', 1, '', 113, NULL, 2, 2, 4, 109);
INSERT INTO "seafarers" VALUES (942, '', 2, '', 131, 3, 1, 1, 3, 128);
INSERT INTO "seafarers" VALUES (944, '', 1, '', 258, 23, NULL, NULL, 14, 107);
INSERT INTO "seafarers" VALUES (946, '', 1, '', 253, 14, NULL, 1, NULL, NULL);
INSERT INTO "seafarers" VALUES (947, '', 1, '', 326, 48, 31, 35, NULL, NULL);
INSERT INTO "seafarers" VALUES (948, '', 1, '', 232, 2, 5, 1, 3, 225);
INSERT INTO "seafarers" VALUES (949, '', 1, '', 20, 4, NULL, NULL, NULL, 24);
INSERT INTO "seafarers" VALUES (950, '', 5, '', 200, 21, 6, 3, 27, 170);
INSERT INTO "seafarers" VALUES (951, '', 7, '', 235, 36, 4, 3, 20, 214);
INSERT INTO "seafarers" VALUES (952, '', 1, '', 57, NULL, 2, 2, 2, 54);
INSERT INTO "seafarers" VALUES (953, '', 8, '', 238, 34, 19, 5, 23, 201);
INSERT INTO "seafarers" VALUES (954, '', 4, '', 212, 5, NULL, 1, 4, 209);
INSERT INTO "seafarers" VALUES (955, '', 9, '', 226, 12, 5, NULL, 9, 212);
INSERT INTO "seafarers" VALUES (956, '', 4, '', 211, 14, 4, 3, 7, 203);
INSERT INTO "seafarers" VALUES (957, '', 1, '', 98, 8, NULL, NULL, 4, 94);
INSERT INTO "seafarers" VALUES (958, '', 1, '', 51, NULL, 2, NULL, 1, 48);
INSERT INTO "seafarers" VALUES (959, '', 2, '', 97, 1, 2, NULL, 1, 94);
INSERT INTO "seafarers" VALUES (960, '', 2, '', 177, 27, 1, 2, 24, 154);
INSERT INTO "seafarers" VALUES (962, '', 2, '', 98, 5, 2, NULL, 8, 88);
INSERT INTO "seafarers" VALUES (963, '', 2, '', 124, 1, 2, NULL, 1, 121);
INSERT INTO "seafarers" VALUES (964, '', 1, '', 110, NULL, 3, NULL, NULL, 107);
INSERT INTO "seafarers" VALUES (965, '', 1, '', 206, 27, 4, NULL, 21, 181);
INSERT INTO "seafarers" VALUES (966, '', 9, '', 236, 20, 13, 3, 24, 202);
INSERT INTO "seafarers" VALUES (967, '', 1, '', 97, NULL, 6, 1, 14, 78);
INSERT INTO "seafarers" VALUES (968, '', 1, '', 120, 18, 6, 7, 31, 90);
INSERT INTO "seafarers" VALUES (969, '', 1, '', 118, NULL, 10, 8, 15, 101);
INSERT INTO "seafarers" VALUES (970, '', 1, '', NULL, NULL, NULL, NULL, 11, NULL);
INSERT INTO "seafarers" VALUES (971, '', 1, '', 115, 10, 5, 4, 24, 90);
INSERT INTO "seafarers" VALUES (972, '', 9, '', 212, 39, 18, 9, 51, 152);
INSERT INTO "seafarers" VALUES (973, '', 1, '', 111, NULL, 3, 13, 47, 74);
INSERT INTO "seafarers" VALUES (975, '', 1, '', 86, 1, 5, NULL, 1, 80);
INSERT INTO "seafarers" VALUES (976, '', 1, '', 53, NULL, 2, 2, NULL, 53);
INSERT INTO "seafarers" VALUES (977, '', 2, '', 164, 4, 17, 2, 2, 147);
INSERT INTO "seafarers" VALUES (978, '', 1, '', 21, NULL, NULL, 1, NULL, 22);
INSERT INTO "seafarers" VALUES (979, '', 1, '', 57, NULL, NULL, NULL, 1, 56);
INSERT INTO "seafarers" VALUES (980, '', 1, '', 80, NULL, 6, NULL, NULL, 74);
INSERT INTO "seafarers" VALUES (981, '', 1, '', 86, 8, 1, NULL, 3, 82);
INSERT INTO "seafarers" VALUES (982, '', 1, '', 43, NULL, NULL, NULL, NULL, 43);
INSERT INTO "seafarers" VALUES (983, '', 1, '', 41, NULL, 12, 2, 1, 30);
INSERT INTO "seafarers" VALUES (984, '', 2, '', 99, 1, 3, NULL, 2, 94);
INSERT INTO "seafarers" VALUES (985, '', 1, '', 40, NULL, NULL, NULL, 2, 38);
INSERT INTO "seafarers" VALUES (986, '', 8, '', 158, 10, 3, 4, 12, 144);
INSERT INTO "seafarers" VALUES (987, '', 1, '', 79, NULL, NULL, NULL, NULL, 79);
INSERT INTO "seafarers" VALUES (988, '', 5, '', 120, 19, NULL, NULL, 11, 109);
INSERT INTO "seafarers" VALUES (989, '', 2, '', 63, 1, NULL, NULL, 1, 62);
INSERT INTO "seafarers" VALUES (990, '', 1, '', 99, 8, 15, 1, 6, 79);
INSERT INTO "seafarers" VALUES (991, '', 1, '', 87, 2, 2, 1, 3, 83);
INSERT INTO "seafarers" VALUES (992, '', 1, '', 96, 1, 12, NULL, 2, 82);
INSERT INTO "seafarers" VALUES (993, '', 1, '', 51, NULL, NULL, 2, 3, 50);
INSERT INTO "seafarers" VALUES (994, '', 1, '', 54, NULL, NULL, NULL, NULL, 54);
INSERT INTO "seafarers" VALUES (995, '', 1, '', 51, NULL, NULL, NULL, NULL, 51);
INSERT INTO "seafarers" VALUES (996, '', 1, '', 82, 3, 2, 2, 4, 78);
INSERT INTO "seafarers" VALUES (997, '', 1, '', 79, 15, 2, 1, 7, 70);
INSERT INTO "seafarers" VALUES (998, '', 1, '', 47, 1, 1, 1, 2, 45);
INSERT INTO "seafarers" VALUES (999, '', 1, '', 52, 4, NULL, 2, 5, 49);
INSERT INTO "seafarers" VALUES (1000, '', 1, '', 134, NULL, 15, 2, 8, 113);
INSERT INTO "seafarers" VALUES (1001, '', 1, '', 90, 8, 1, 3, 5, 87);
INSERT INTO "seafarers" VALUES (1002, '', 1, '', 125, 3, 17, 3, 3, 108);
INSERT INTO "seafarers" VALUES (1003, '', 1, '', 131, NULL, 2, NULL, 2, 127);
INSERT INTO "seafarers" VALUES (1004, '', 6, '', 180, NULL, NULL, NULL, 5, 175);
INSERT INTO "seafarers" VALUES (1005, '', 10, '', 190, NULL, 6, NULL, 9, 175);
INSERT INTO "seafarers" VALUES (1006, '', 2, '', 110, NULL, 1, 1, NULL, 110);
INSERT INTO "seafarers" VALUES (1007, '', 2, '', 55, 1, 4, 3, 2, 52);
INSERT INTO "seafarers" VALUES (1008, '', 2, '', 87, NULL, 5, NULL, NULL, 82);
INSERT INTO "seafarers" VALUES (1009, '', 2, '', 217, 3, 7, NULL, 3, 207);
INSERT INTO "seafarers" VALUES (1010, '', 1, '', 114, NULL, NULL, NULL, 1, 113);
INSERT INTO "seafarers" VALUES (1011, '', 4, '', 149, 2, NULL, 7, 3, 153);
INSERT INTO "seafarers" VALUES (1012, '', 2, '', 155, 1, 1, 4, 3, 155);
INSERT INTO "seafarers" VALUES (1013, '', 1, '', 136, 1, NULL, NULL, 3, 133);
INSERT INTO "seafarers" VALUES (1014, '', 2, '', 67, NULL, 3, 1, NULL, 65);
INSERT INTO "seafarers" VALUES (1015, '', 5, '', 155, 3, 9, 3, 2, 147);
INSERT INTO "seafarers" VALUES (1016, '', 1, '', 23, NULL, NULL, NULL, 1, 22);
INSERT INTO "seafarers" VALUES (1018, '', 1, '', 13, NULL, NULL, NULL, NULL, 13);
INSERT INTO "seafarers" VALUES (1020, '', 1, '', 13, NULL, NULL, NULL, 1, 12);
INSERT INTO "seafarers" VALUES (1021, '', 5, '', 162, 39, NULL, 4, 33, 133);
INSERT INTO "seafarers" VALUES (1022, '', 1, '', 132, 10, 13, NULL, 6, 113);
INSERT INTO "seafarers" VALUES (1024, '', 1, '', 175, 25, 17, NULL, 17, 141);
INSERT INTO "seafarers" VALUES (1026, '', 2, '', 94, 33, 13, 10, 7, 84);
INSERT INTO "seafarers" VALUES (1028, '', 3, '', 133, 16, NULL, NULL, 13, 113);
INSERT INTO "seafarers" VALUES (1029, '', 1, '', 145, 30, 31, NULL, 11, 103);
INSERT INTO "seafarers" VALUES (1032, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (1033, '', 2, '', 78, NULL, 1, 4, NULL, 81);
INSERT INTO "seafarers" VALUES (1034, '', 1, '', 132, 43, 5, NULL, 27, 100);
INSERT INTO "seafarers" VALUES (1035, '', 1, '', 85, 17, NULL, 2, 17, 70);
INSERT INTO "seafarers" VALUES (1036, '', 1, '', 74, 6, 5, 6, 15, 60);
INSERT INTO "seafarers" VALUES (1037, '', 1, '', 95, 9, 8, 2, 9, 80);
INSERT INTO "seafarers" VALUES (1038, '', 1, '', 120, 34, NULL, 1, 38, 83);
INSERT INTO "seafarers" VALUES (1039, '', 1, '', 44, 1, 5, 2, 3, 38);
INSERT INTO "seafarers" VALUES (1040, '', 1, '', 47, 5, 3, NULL, 4, 40);
INSERT INTO "seafarers" VALUES (1041, '', 1, '', 39, NULL, 1, 1, NULL, 39);
INSERT INTO "seafarers" VALUES (1043, '', 2, '', 128, 4, 4, 2, 4, 122);
INSERT INTO "seafarers" VALUES (1044, '', 1, '', 115, 2, 10, 1, 2, 104);
INSERT INTO "seafarers" VALUES (1045, '', 5, '', 187, 112, 23, 4, 77, 101);
INSERT INTO "seafarers" VALUES (1046, '', 2, '', 83, 2, NULL, 2, 2, 83);
INSERT INTO "seafarers" VALUES (1047, '', 2, '', 95, 5, 7, 4, 4, 88);
INSERT INTO "seafarers" VALUES (1048, '', 1, '', 159, 20, 6, NULL, 14, 139);
INSERT INTO "seafarers" VALUES (1049, '', 1, '', 23, NULL, NULL, NULL, NULL, 23);
INSERT INTO "seafarers" VALUES (1050, '', 3, '', 97, 48, 16, 14, 34, 61);
INSERT INTO "seafarers" VALUES (1051, '', 3, '', 190, 62, 24, 8, 58, 116);
INSERT INTO "seafarers" VALUES (1052, '', 2, '', 77, 21, 13, 3, 12, 55);
INSERT INTO "seafarers" VALUES (1053, '', 1, '', 113, 3, 17, 20, 5, 111);
INSERT INTO "seafarers" VALUES (1054, '', 2, '', 88, 11, 4, 7, 9, 80);
INSERT INTO "seafarers" VALUES (1055, '', 1, '', 84, NULL, 13, 10, 2, 79);
INSERT INTO "seafarers" VALUES (1056, '', 2, '', 98, NULL, 11, 2, 3, 86);
INSERT INTO "seafarers" VALUES (1057, '', 1, '', 141, 7, 7, 11, 4, 141);
INSERT INTO "seafarers" VALUES (1058, '', 2, '', 101, 12, 15, 1, 12, 75);
INSERT INTO "seafarers" VALUES (1059, '', 1, '', 106, 10, 1, 3, 10, 98);
INSERT INTO "seafarers" VALUES (1060, '', 1, '', 88, 21, 2, 2, 25, 66);
INSERT INTO "seafarers" VALUES (1061, '', 1, '', 49, 13, 5, 5, 11, 38);
INSERT INTO "seafarers" VALUES (1062, '', 1, '', 87, 7, 4, 3, 15, 71);
INSERT INTO "seafarers" VALUES (1063, '', 3, '', 222, 90, 4, 15, 65, 168);
INSERT INTO "seafarers" VALUES (1064, '', 1, '', 133, NULL, 9, 17, 7, 126);
INSERT INTO "seafarers" VALUES (1065, '', 3, '', 102, 6, 3, 10, 2, 107);
INSERT INTO "seafarers" VALUES (1066, '', 1, '', 102, 1, 8, 13, 1, 105);
INSERT INTO "seafarers" VALUES (1068, '', 2, '', 84, 12, NULL, 7, 4, 88);
INSERT INTO "seafarers" VALUES (1069, '', 2, '', 107, 6, 12, 1, 8, 87);
INSERT INTO "seafarers" VALUES (1070, '', 1, '', 130, 3, 18, 2, 11, 98);
INSERT INTO "seafarers" VALUES (1071, '', 1, '', 106, 9, 6, 11, 15, 96);
INSERT INTO "seafarers" VALUES (1073, '', 1, '', 135, 13, 4, 1, 6, 126);
INSERT INTO "seafarers" VALUES (1074, '', 1, '', 165, 6, 21, 4, 4, 144);
INSERT INTO "seafarers" VALUES (1075, '', 1, '', 140, 5, 15, NULL, 5, 120);
INSERT INTO "seafarers" VALUES (1077, '', 1, '', 23, NULL, NULL, 1, 1, 23);
INSERT INTO "seafarers" VALUES (1078, '', 1, '', 34, NULL, NULL, 3, NULL, 37);
INSERT INTO "seafarers" VALUES (1081, '', 1, '', 156, 15, 5, NULL, 21, 130);
INSERT INTO "seafarers" VALUES (1082, '', 1, '', 28, NULL, 2, 2, 1, 27);
INSERT INTO "seafarers" VALUES (1083, '', 1, '', 128, 1, 3, NULL, 4, 121);
INSERT INTO "seafarers" VALUES (1084, '', 1, '', 145, NULL, 2, 3, 2, 144);
INSERT INTO "seafarers" VALUES (1085, '', 1, '', 34, NULL, NULL, NULL, NULL, 34);
INSERT INTO "seafarers" VALUES (1087, '', 1, '', 130, NULL, 7, 1, 3, 121);
INSERT INTO "seafarers" VALUES (1088, '', 1, '', 152, 25, 3, 21, 8, 155);
INSERT INTO "seafarers" VALUES (1090, '', 1, '', 29, NULL, NULL, NULL, NULL, 29);
INSERT INTO "seafarers" VALUES (1091, '', 1, '', 29, NULL, NULL, NULL, NULL, 29);
INSERT INTO "seafarers" VALUES (1092, '', 1, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (1093, '', 1, '', 102, 4, NULL, 7, 4, 105);
INSERT INTO "seafarers" VALUES (1094, '', 1, '', 179, 6, 4, NULL, 17, 158);
INSERT INTO "seafarers" VALUES (1096, '', 2, '', 173, 5, NULL, 10, 2, 181);
INSERT INTO "seafarers" VALUES (1097, '', 2, '', 197, 35, 5, 3, 24, 171);
INSERT INTO "seafarers" VALUES (1098, '', 1, '', 166, 3, 6, 1, 3, 158);
INSERT INTO "seafarers" VALUES (1100, '', 2, '', 153, 18, 3, 5, 15, 140);
INSERT INTO "seafarers" VALUES (1101, '', 6, '', 173, 32, 11, 10, 20, 152);
INSERT INTO "seafarers" VALUES (1102, '', 2, 'b', 63, 1, 1, NULL, 1, 61);
INSERT INTO "seafarers" VALUES (1103, '', 1, '', 20, 1, NULL, 1, 1, 20);
INSERT INTO "seafarers" VALUES (1104, '', 2, '', 179, 17, 4, NULL, 14, 164);
INSERT INTO "seafarers" VALUES (1105, '', 1, '', 165, 4, 6, 2, 5, 156);
INSERT INTO "seafarers" VALUES (1106, '', 2, '', 221, 16, 15, 4, 43, 167);
INSERT INTO "seafarers" VALUES (1107, '', 1, '', 73, 8, 5, 5, NULL, 73);
INSERT INTO "seafarers" VALUES (1108, '', 1, '', 21, 2, NULL, 7, 2, 26);
INSERT INTO "seafarers" VALUES (1109, '', 1, '', 160, NULL, NULL, 1, 1, 160);
INSERT INTO "seafarers" VALUES (1110, '', 1, '', 34, 1, 1, 2, 1, 34);
INSERT INTO "seafarers" VALUES (1111, '', 2, '', 154, 2, 2, 3, 2, 153);
INSERT INTO "seafarers" VALUES (1112, '', 1, '', 201, 8, 4, 4, 12, 189);
INSERT INTO "seafarers" VALUES (1113, '', 2, '', 110, 10, 4, NULL, 3, 103);
INSERT INTO "seafarers" VALUES (1114, '', 2, '', 170, 2, 3, 1, 3, 165);
INSERT INTO "seafarers" VALUES (1115, '', 3, '', 224, 4, NULL, NULL, NULL, 118);
INSERT INTO "seafarers" VALUES (1117, '', 1, '', 100, 16, NULL, 1, 7, 94);
INSERT INTO "seafarers" VALUES (1118, '', 1, '', 20, NULL, 2, NULL, NULL, 18);
INSERT INTO "seafarers" VALUES (1120, '', 1, '', 16, NULL, NULL, 1, 1, 16);
INSERT INTO "seafarers" VALUES (1121, '', 1, '', 17, NULL, 1, NULL, NULL, 16);
INSERT INTO "seafarers" VALUES (1122, '', 2, '', 100, 11, 9, NULL, 11, 80);
INSERT INTO "seafarers" VALUES (1123, '', 3, '', 58, 7, 3, 14, 4, 65);
INSERT INTO "seafarers" VALUES (1124, '', 1, '', 174, 33, 7, 3, 19, 151);
INSERT INTO "seafarers" VALUES (1125, '', 2, '', 97, 5, 2, 2, 4, 93);
INSERT INTO "seafarers" VALUES (1126, '', 3, '', 68, 9, 3, 2, 4, 63);
INSERT INTO "seafarers" VALUES (1127, '', 4, '', 149, 25, 2, NULL, 14, 133);
INSERT INTO "seafarers" VALUES (1128, '', 2, '', 103, 14, 1, NULL, 8, 94);
INSERT INTO "seafarers" VALUES (1129, '', 1, '', 17, NULL, NULL, NULL, NULL, 17);
INSERT INTO "seafarers" VALUES (1130, '', 1, '', 16, NULL, 2, 1, NULL, 15);
INSERT INTO "seafarers" VALUES (1131, '', 1, '', 132, 9, 6, 8, 2, 132);
INSERT INTO "seafarers" VALUES (1133, '', 1, '', 82, 19, 6, 2, 12, 66);
INSERT INTO "seafarers" VALUES (1134, '', 1, '', 77, 5, 2, NULL, 5, 70);
INSERT INTO "seafarers" VALUES (1135, '', 2, '', 190, 47, 13, 3, 15, 165);
INSERT INTO "seafarers" VALUES (1136, '', 6, '', 162, 12, 7, 17, 13, 159);
INSERT INTO "seafarers" VALUES (1137, '', 1, '', 16, NULL, NULL, NULL, 1, 15);
INSERT INTO "seafarers" VALUES (1138, '', 1, '', 31, 1, NULL, NULL, 2, 29);
INSERT INTO "seafarers" VALUES (1140, '', 1, '', 111, 7, 8, 9, 11, 101);
INSERT INTO "seafarers" VALUES (1141, '', 1, '', 189, 25, 17, 3, 26, 149);
INSERT INTO "seafarers" VALUES (1142, '', 1, '', 128, 5, 4, 10, 5, 129);
INSERT INTO "seafarers" VALUES (1143, '', 1, '', 142, 23, 14, 7, 20, 115);
INSERT INTO "seafarers" VALUES (1144, '', 1, '', 14, 1, NULL, 5, 1, 18);
INSERT INTO "seafarers" VALUES (1145, '', 1, '', 19, NULL, NULL, NULL, NULL, 19);
INSERT INTO "seafarers" VALUES (1146, '', 2, '', 104, 20, 13, 16, 19, 88);
INSERT INTO "seafarers" VALUES (1148, '', 1, '', 74, 1, NULL, 3, 1, 76);
INSERT INTO "seafarers" VALUES (1149, '', 1, '', 15, NULL, NULL, 4, 2, 17);
INSERT INTO "seafarers" VALUES (1150, '', 2, '', 112, 5, NULL, 1, 3, 110);
INSERT INTO "seafarers" VALUES (1151, '', 2, '', 120, 8, 6, NULL, 8, 106);
INSERT INTO "seafarers" VALUES (1152, '', 3, '', 101, 1, 2, 4, 2, 101);
INSERT INTO "seafarers" VALUES (1153, '', 2, '', 145, 5, 10, 2, 10, 127);
INSERT INTO "seafarers" VALUES (1155, '', 1, '', 16, NULL, NULL, NULL, NULL, 16);
INSERT INTO "seafarers" VALUES (1157, '', 3, '', 184, 28, 3, NULL, 19, 162);
INSERT INTO "seafarers" VALUES (1159, '', 2, '', 151, 32, 2, 3, 21, 131);
INSERT INTO "seafarers" VALUES (1160, '', 2, '', 122, 2, NULL, 1, 3, 120);
INSERT INTO "seafarers" VALUES (1161, '', 2, '', 130, 27, 3, 6, 12, 121);
INSERT INTO "seafarers" VALUES (1162, '', 1, '', 67, NULL, 9, 3, NULL, 61);
INSERT INTO "seafarers" VALUES (1163, '', 3, '', 125, NULL, NULL, NULL, 36, 89);
INSERT INTO "seafarers" VALUES (1164, '', 2, '', 140, 3, 4, NULL, NULL, 136);
INSERT INTO "seafarers" VALUES (1165, '', 3, '', 111, 10, 2, NULL, 6, 105);
INSERT INTO "seafarers" VALUES (1166, '', 3, '', 101, 4, 5, 1, 3, 94);
INSERT INTO "seafarers" VALUES (1167, '', 2, '', 66, NULL, 2, 1, NULL, 65);
INSERT INTO "seafarers" VALUES (1169, '', 1, '', 66, NULL, 2, NULL, 2, 62);
INSERT INTO "seafarers" VALUES (1170, '', 2, '', 105, 4, 7, 3, 4, 97);
INSERT INTO "seafarers" VALUES (1171, '', 2, '', 80, 2, 5, 3, 3, 75);
INSERT INTO "seafarers" VALUES (1173, '', 2, '', 110, 1, 3, 2, 1, 108);
INSERT INTO "seafarers" VALUES (1174, '', 1, '', 88, 2, NULL, NULL, 2, 86);
INSERT INTO "seafarers" VALUES (1176, '', 2, '', 122, 6, 13, NULL, 7, 102);
INSERT INTO "seafarers" VALUES (1178, '', 2, '', 93, 3, 3, NULL, 3, 87);
INSERT INTO "seafarers" VALUES (1179, '', 1, '', 74, NULL, 2, 1, NULL, 73);
INSERT INTO "seafarers" VALUES (1180, '', 1, '', 61, 2, 2, NULL, 2, 54);
INSERT INTO "seafarers" VALUES (1181, '', 1, '', 74, NULL, NULL, NULL, 2, 68);
INSERT INTO "seafarers" VALUES (1182, '', 3, '', 159, 4, 6, NULL, 3, 150);
INSERT INTO "seafarers" VALUES (1183, '', 2, '', 83, 3, NULL, 2, 2, 83);
INSERT INTO "seafarers" VALUES (1184, '', 2, '', 170, 3, 5, 9, 8, 166);
INSERT INTO "seafarers" VALUES (1185, '', 2, '', 84, NULL, NULL, NULL, 3, 81);
INSERT INTO "seafarers" VALUES (1186, '', 1, '', 146, 3, NULL, NULL, 3, 143);
INSERT INTO "seafarers" VALUES (1187, '', 2, '', 157, NULL, 2, NULL, 11, 144);
INSERT INTO "seafarers" VALUES (1188, '', 1, '', 20, NULL, 1, NULL, NULL, 18);
INSERT INTO "seafarers" VALUES (1189, '', 3, '', 149, 6, 7, 7, 4, 145);
INSERT INTO "seafarers" VALUES (1190, '', 3, '', 145, NULL, NULL, NULL, 7, 138);
INSERT INTO "seafarers" VALUES (1191, '', 1, '', 17, NULL, NULL, NULL, 1, 11);
INSERT INTO "seafarers" VALUES (1192, '', 1, '', 96, NULL, NULL, 5, 1, 100);
INSERT INTO "seafarers" VALUES (1193, '', 2, '', 106, 10, 1, 4, 6, 103);
INSERT INTO "seafarers" VALUES (1194, '', 2, '', 164, 30, 3, 2, 17, 146);
INSERT INTO "seafarers" VALUES (1195, '', 3, '', 109, 11, 2, 1, 20, 88);
INSERT INTO "seafarers" VALUES (1196, '', 1, '', 17, NULL, 1, NULL, NULL, 16);
INSERT INTO "seafarers" VALUES (1197, '', 2, '', 110, 14, 11, 9, 13, 94);
INSERT INTO "seafarers" VALUES (1200, '', 3, '', 212, 7, 8, NULL, NULL, 204);
INSERT INTO "seafarers" VALUES (1201, '', 3, '', 141, 7, 19, NULL, 5, 117);
INSERT INTO "seafarers" VALUES (1202, '', 1, '', 46, NULL, 3, 7, NULL, 50);
INSERT INTO "seafarers" VALUES (1203, '', 2, '', 73, 3, NULL, 1, 1, 73);
INSERT INTO "seafarers" VALUES (1205, '', 3, '', 169, 6, 11, 1, 9, 150);
INSERT INTO "seafarers" VALUES (1206, '', 7, '', 164, 7, 1, NULL, 13, 147);
INSERT INTO "seafarers" VALUES (1207, '', 2, '', 164, 38, 18, 17, 42, 121);
INSERT INTO "seafarers" VALUES (1208, '', 1, '', 141, 2, NULL, NULL, 2, 139);
INSERT INTO "seafarers" VALUES (1209, '', 1, '', 55, 2, NULL, NULL, 1, 54);
INSERT INTO "seafarers" VALUES (1210, '', 1, '', 198, 3, 8, 1, 3, 188);
INSERT INTO "seafarers" VALUES (1211, '', 2, '', 160, 12, 6, 3, 14, 143);
INSERT INTO "seafarers" VALUES (1214, '', 5, '', 201, 16, 16, 2, 21, 166);
INSERT INTO "seafarers" VALUES (1215, '', 3, '', 144, 59, 6, 13, 21, 130);
INSERT INTO "seafarers" VALUES (1216, '', 2, '', 76, 1, 6, 1, 2, 69);
INSERT INTO "seafarers" VALUES (1217, '', 1, '', 60, 2, 2, 7, 3, 62);
INSERT INTO "seafarers" VALUES (1219, '', 1, '', 61, 2, 30, 26, 7, 48);
INSERT INTO "seafarers" VALUES (1220, '', 4, '', 217, 26, 12, 1, 26, 180);
INSERT INTO "seafarers" VALUES (1221, '', 2, '', 192, 21, 15, 2, 21, 158);
INSERT INTO "seafarers" VALUES (1225, '', 2, '', 82, 1, 31, 11, 4, 58);
INSERT INTO "seafarers" VALUES (1226, '', 4, '', 174, 23, 24, 10, 21, 139);
INSERT INTO "seafarers" VALUES (1227, '', 3, '', 133, 16, 16, 3, 8, 112);
INSERT INTO "seafarers" VALUES (1229, '', 3, '', 177, 1, 34, 2, 3, 142);
INSERT INTO "seafarers" VALUES (1230, '', 1, '', 143, 18, 21, 6, 11, 117);
INSERT INTO "seafarers" VALUES (1231, '', 1, '', 168, 60, 2, 3, 37, 134);
INSERT INTO "seafarers" VALUES (1232, '', 1, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (1233, '', 1, '', 197, 13, 11, 4, 8, 182);
INSERT INTO "seafarers" VALUES (1234, '', 1, '', 200, 38, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (1235, '', 2, '', 91, 3, 3, 3, 4, 87);
INSERT INTO "seafarers" VALUES (1236, '', 1, '', 205, 80, 3, 7, 59, 150);
INSERT INTO "seafarers" VALUES (1239, '', 2, '', 86, 8, 3, 3, 7, 79);
INSERT INTO "seafarers" VALUES (1242, '', 2, '', 101, 28, 9, 7, 29, 70);
INSERT INTO "seafarers" VALUES (1243, '', 1, '', 78, 1, 3, 3, 2, 76);
INSERT INTO "seafarers" VALUES (1244, '', 3, '', 165, 41, 10, 9, 26, 138);
INSERT INTO "seafarers" VALUES (1245, '', 4, '', 133, 37, 8, 10, 30, 105);
INSERT INTO "seafarers" VALUES (1246, '', 2, '', 104, 1, NULL, NULL, 7, 97);
INSERT INTO "seafarers" VALUES (1247, '', 3, '', 152, 80, 2, 38, 51, 137);
INSERT INTO "seafarers" VALUES (1249, '', 3, '', 174, 12, 9, 5, 10, 156);
INSERT INTO "seafarers" VALUES (1250, '', 1, '', 145, 46, 1, 1, 34, 111);
INSERT INTO "seafarers" VALUES (1253, '', 3, '', 157, NULL, 6, 2, 51, 102);
INSERT INTO "seafarers" VALUES (1254, '', 2, '', 169, 49, 6, 1, 27, 135);
INSERT INTO "seafarers" VALUES (1255, '', 1, '', 142, 8, 5, NULL, 7, 130);
INSERT INTO "seafarers" VALUES (1256, '', 3, '', 192, 46, 1, NULL, 32, 155);
INSERT INTO "seafarers" VALUES (1260, '', 1, '', 177, 10, 1, 1, 22, 155);
INSERT INTO "seafarers" VALUES (1261, '', 1, '', 150, 18, 4, 7, 13, 140);
INSERT INTO "seafarers" VALUES (1267, '', 1, '', 149, 16, 3, 3, 15, 134);
INSERT INTO "seafarers" VALUES (1268, '', 1, '', 146, 34, NULL, NULL, 14, 132);
INSERT INTO "seafarers" VALUES (1269, '', 1, '', 221, 7, 6, 2, 9, 208);
INSERT INTO "seafarers" VALUES (1270, '', 1, '', 177, NULL, 33, 2, 12, 134);
INSERT INTO "seafarers" VALUES (1271, '', 1, '', 205, NULL, 21, 40, 81, 143);
INSERT INTO "seafarers" VALUES (1273, '', 1, '', 28, NULL, NULL, NULL, NULL, 28);
INSERT INTO "seafarers" VALUES (1274, '', 1, '', 156, 17, 5, NULL, 6, 145);
INSERT INTO "seafarers" VALUES (1275, '', 1, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "seafarers" VALUES (1277, '', 1, '', 160, 20, 18, 5, 12, 135);
INSERT INTO "seafarers" VALUES (1279, '', 2, '', 69, NULL, NULL, NULL, 4, 65);
INSERT INTO "seafarers" VALUES (1284, '', 1, '', 177, NULL, 5, 2, 13, 155);
INSERT INTO "seafarers" VALUES (1285, '', 1, '', 167, NULL, NULL, 4, 14, 157);
INSERT INTO "seafarers" VALUES (1286, '', 1, '', 120, NULL, 7, 3, 5, 101);
INSERT INTO "seafarers" VALUES (1287, '', 3, '', 90, NULL, 2, 2, 10, 80);
INSERT INTO "seafarers" VALUES (1288, '', 1, '', 112, NULL, NULL, 4, 3, 106);
INSERT INTO "seafarers" VALUES (1289, '', 1, '', 162, NULL, 5, 1, 8, 149);
INSERT INTO "seafarers" VALUES (1290, '', 1, '', 145, NULL, 2, 7, 2, 148);
INSERT INTO "seafarers" VALUES (1291, '', 3, '', 250, NULL, 8, NULL, 14, 209);
INSERT INTO "seafarers" VALUES (1292, '', 3, '', 208, NULL, 18, 3, 4, 189);
INSERT INTO "seafarers" VALUES (1293, '', 1, '', 209, NULL, 4, NULL, 4, 201);
INSERT INTO "seafarers" VALUES (1294, '', 1, '', 199, NULL, 5, 3, 8, 188);
INSERT INTO "seafarers" VALUES (1295, '', 4, '', 181, NULL, 6, 3, 6, 173);
INSERT INTO "seafarers" VALUES (1296, '', 2, '', 25, NULL, 1, NULL, 1, 23);
INSERT INTO "seafarers" VALUES (1297, '', 1, '', 77, NULL, NULL, NULL, 3, 74);
INSERT INTO "seafarers" VALUES (1312, '', 2, '', 27, NULL, NULL, NULL, NULL, 27);
INSERT INTO "seafarers" VALUES (1314, '', 2, '', 178, NULL, 1, 1, 15, 163);
INSERT INTO "seafarers" VALUES (1315, '', 4, '', 158, NULL, 11, 6, 4, 146);
INSERT INTO "seafarers" VALUES (1317, '', 4, '', 194, 5, 2, 3, 10, 185);
INSERT INTO "seafarers" VALUES (1318, '', 4, '', 176, 3, 3, 10, 3, 180);
INSERT INTO "seafarers" VALUES (1319, '', 4, '', 167, 3, 18, 14, 1, 162);
INSERT INTO "seafarers" VALUES (1320, '', 2, '', 178, 7, 1, 1, 7, 171);
INSERT INTO "seafarers" VALUES (1321, '', 1, '', 59, NULL, 1, 1, NULL, 59);
INSERT INTO "seafarers" VALUES (1322, '', 1, '', 55, NULL, NULL, NULL, 1, 54);
INSERT INTO "seafarers" VALUES (1324, '', 1, '', 50, 1, 1, 1, 1, 49);
INSERT INTO "seafarers" VALUES (1325, '', 1, '', 197, 18, 13, 13, 22, 175);
INSERT INTO "seafarers" VALUES (1326, '', 4, '', 190, 19, 5, 12, 20, 177);
INSERT INTO "seafarers" VALUES (1327, '', 2, '', 120, NULL, NULL, NULL, NULL, 95);
INSERT INTO "seafarers" VALUES (1328, '', 1, '', 65, NULL, 3, NULL, 1, 61);
INSERT INTO "seafarers" VALUES (1329, '', 4, '', NULL, NULL, NULL, NULL, NULL, 120);
INSERT INTO "seafarers" VALUES (1330, '', 1, '', 64, NULL, 6, 3, 3, 58);
INSERT INTO "seafarers" VALUES (1331, '', 2, '', 139, 3, 9, 11, 3, 138);
INSERT INTO "seafarers" VALUES (1332, '', 2, '', 212, 21, 20, 4, 28, 167);
INSERT INTO "seafarers" VALUES (1333, '', 4, '', 104, 1, 11, NULL, 1, 92);
INSERT INTO "seafarers" VALUES (1334, '', 1, '', 73, 10, NULL, NULL, 2, 71);
INSERT INTO "seafarers" VALUES (1335, '', 2, '', NULL, NULL, NULL, NULL, NULL, 139);
INSERT INTO "seafarers" VALUES (1336, '', 2, '', 143, NULL, 16, NULL, 12, 115);
INSERT INTO "seafarers" VALUES (1337, '', 1, '', 65, NULL, 5, 1, NULL, 61);
INSERT INTO "seafarers" VALUES (1339, '', 1, '', 64, NULL, 2, 3, NULL, 64);
INSERT INTO "seafarers" VALUES (1340, '', 2, '', NULL, NULL, NULL, NULL, NULL, 137);
INSERT INTO "seafarers" VALUES (1341, '', 2, '', 193, NULL, NULL, NULL, 15, 160);
INSERT INTO "seafarers" VALUES (1342, '', 4, '', 89, NULL, NULL, NULL, 7, 75);
INSERT INTO "seafarers" VALUES (1343, '', 2, '', 144, 20, 9, 1, 13, 123);
INSERT INTO "seafarers" VALUES (1345, '', 2, '', 180, NULL, 11, 3, 8, 164);
INSERT INTO "seafarers" VALUES (1346, '', 2, '', 157, NULL, 9, 3, 17, 134);
INSERT INTO "seafarers" VALUES (1347, '', 1, '', 90, 1, 6, 2, 1, 85);
INSERT INTO "seafarers" VALUES (1348, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "seafarers" VALUES (1349, '', 1, '', 2, NULL, NULL, NULL, 1, 1);
INSERT INTO "seafarers" VALUES (1350, '', 1, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "seafarers" VALUES (1352, '', 4, '', 182, 11, 1, 2, 5, 178);
INSERT INTO "seafarers" VALUES (1353, '', 4, '', 115, NULL, 2, 1, NULL, 186);
INSERT INTO "seafarers" VALUES (1354, '', 1, '', 197, 4, 11, 9, 9, 186);
INSERT INTO "seafarers" VALUES (1355, '', 1, '', 218, 37, 14, 9, 37, 176);
INSERT INTO "seafarers" VALUES (1356, '', 2, '', 11, NULL, NULL, NULL, NULL, 11);
INSERT INTO "seafarers" VALUES (1357, '', 2, '', 195, NULL, 12, 2, 7, 172);
INSERT INTO "seafarers" VALUES (1358, '', 1, '', 53, NULL, 2, NULL, 1, 50);
INSERT INTO "seafarers" VALUES (1359, '', 2, '', 108, 3, 1, 7, 2, 112);
INSERT INTO "seafarers" VALUES (1360, '', 2, '', 71, 1, NULL, NULL, 1, 36);
INSERT INTO "seafarers" VALUES (1361, '', 3, '', 145, 3, 8, 3, 12, 128);
INSERT INTO "seafarers" VALUES (1362, '', 1, '', 42, 2, NULL, NULL, 3, 39);
INSERT INTO "seafarers" VALUES (1363, '', 2, '', 1, NULL, NULL, 2, NULL, 3);
INSERT INTO "seafarers" VALUES (1364, '', 4, '', 208, 17, 21, NULL, 35, 152);
INSERT INTO "seafarers" VALUES (1365, '', 4, '', 200, 38, 8, 7, 37, 191);
INSERT INTO "seafarers" VALUES (1366, '', 4, '', 115, NULL, NULL, NULL, 3, 112);
INSERT INTO "seafarers" VALUES (1367, '', 2, '', 141, NULL, NULL, 6, 1, 146);
INSERT INTO "seafarers" VALUES (1368, '', 3, '', 212, 2, 16, 12, 2, 206);
INSERT INTO "seafarers" VALUES (1369, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (1370, '', 4, '', 199, 25, 23, 11, 25, 158);
INSERT INTO "seafarers" VALUES (1372, '', 4, '', 138, 19, 14, 18, 17, 125);
INSERT INTO "seafarers" VALUES (1375, '', 2, '', 178, 12, 7, 5, 15, 160);
INSERT INTO "seafarers" VALUES (1376, '', 3, '', 177, 6, 2, NULL, 5, 170);
INSERT INTO "seafarers" VALUES (1378, '', 5, '', 194, 14, 9, 9, 6, 185);
INSERT INTO "seafarers" VALUES (1379, '', 5, '', 145, 2, 3, 1, NULL, 143);
INSERT INTO "seafarers" VALUES (1380, '', 3, '', 156, 1, 8, 11, 1, 158);
INSERT INTO "seafarers" VALUES (1381, '', 5, '', 173, 11, 25, 11, 7, 152);
INSERT INTO "seafarers" VALUES (1382, '', 2, '', 118, 16, 9, 4, 9, 104);
INSERT INTO "seafarers" VALUES (1383, '', 5, '', 181, 4, NULL, 1, 8, 173);
INSERT INTO "seafarers" VALUES (1384, '', 5, '', 184, 12, 4, NULL, 7, 169);
INSERT INTO "seafarers" VALUES (1385, '', 5, '', 183, 1, 8, 13, 1, 190);
INSERT INTO "seafarers" VALUES (1386, '', 3, '', 202, NULL, NULL, NULL, 6, 196);
INSERT INTO "seafarers" VALUES (1387, '', 4, '', 153, 2, 7, 5, 6, 145);
INSERT INTO "seafarers" VALUES (1388, '', 3, '', 19, NULL, 7, 12, 1, 23);
INSERT INTO "seafarers" VALUES (1390, '', 1, '', 67, NULL, NULL, NULL, NULL, 62);
INSERT INTO "seafarers" VALUES (1391, '', 1, '', 70, NULL, 3, 8, 1, 73);
INSERT INTO "seafarers" VALUES (1393, '', 2, '', 178, 22, 4, 4, 10, 170);
INSERT INTO "seafarers" VALUES (1394, '', 3, '', 169, 1, 5, 8, 3, 169);
INSERT INTO "seafarers" VALUES (1395, '', 1, '', 180, 10, 2, NULL, 3, 174);
INSERT INTO "seafarers" VALUES (1396, '', 1, '', 179, 3, 2, NULL, 6, 171);
INSERT INTO "seafarers" VALUES (1397, '', 3, '', 204, 4, 6, 6, 4, 200);
INSERT INTO "seafarers" VALUES (1398, '', 3, '', 236, 34, 25, NULL, 30, 181);
INSERT INTO "seafarers" VALUES (1399, '', 1, '', 42, 14, 8, 5, 5, 34);
INSERT INTO "seafarers" VALUES (1400, '', 1, '', 42, 14, 4, 12, 16, 34);
INSERT INTO "seafarers" VALUES (1401, '', 1, '', 81, 6, 3, 2, 2, 78);
INSERT INTO "seafarers" VALUES (1402, '', 1, '', 56, 2, 1, 11, 1, 55);
INSERT INTO "seafarers" VALUES (1403, '', 3, '', 149, 24, 6, 11, 16, 137);
INSERT INTO "seafarers" VALUES (1404, '', 2, '', 171, 36, 18, 6, 22, 137);
INSERT INTO "seafarers" VALUES (1407, '', 1, '', 87, NULL, 32, 9, 5, 59);
INSERT INTO "seafarers" VALUES (1409, '', 2, '', 149, NULL, 5, 1, 9, 136);
INSERT INTO "seafarers" VALUES (1410, '', 1, '', 24, 1, NULL, 5, 2, 27);
INSERT INTO "seafarers" VALUES (1411, '', 1, '', 36, 2, 7, NULL, 2, 27);
INSERT INTO "seafarers" VALUES (1412, '', 5, '', 211, 5, 15, 23, 7, 212);
INSERT INTO "seafarers" VALUES (1413, '', 2, '', 153, 13, 12, 7, 15, 133);
INSERT INTO "seafarers" VALUES (1414, '', 2, '', 161, 14, 7, 14, 14, 154);
INSERT INTO "seafarers" VALUES (1415, '', 3, '', 190, 15, 10, 3, 12, 171);
INSERT INTO "seafarers" VALUES (1416, '', 5, '', 193, 18, 12, 4, 14, 171);
INSERT INTO "seafarers" VALUES (1417, '', 1, '', 111, 3, 2, 7, 3, 109);
INSERT INTO "seafarers" VALUES (1418, '', 1, '', 138, NULL, 1, 3, 9, 131);
INSERT INTO "seafarers" VALUES (1419, '', 1, '', 93, 1, 2, 1, 1, 91);
INSERT INTO "seafarers" VALUES (1420, '', 4, '', 224, 12, 14, 5, 19, 190);
INSERT INTO "seafarers" VALUES (1422, '', 1, '', 96, 3, NULL, 1, 5, 92);
INSERT INTO "seafarers" VALUES (1423, '', 2, '', 175, 24, 5, 5, 24, 151);
INSERT INTO "seafarers" VALUES (1424, '', 1, '', 52, NULL, 4, NULL, NULL, 48);
INSERT INTO "seafarers" VALUES (1425, '', 1, '', 99, 11, 7, NULL, 1, 51);
INSERT INTO "seafarers" VALUES (1426, '', 3, '', 154, 18, 6, 9, 23, 134);
INSERT INTO "seafarers" VALUES (1427, '', 2, '', 157, 4, 3, 2, 9, 147);
INSERT INTO "seafarers" VALUES (1429, '', 1, '', 52, NULL, 1, 7, 3, 56);
INSERT INTO "seafarers" VALUES (1430, '', 3, '', 160, 3, 8, 3, 8, 145);
INSERT INTO "seafarers" VALUES (1431, '', 4, '', 181, NULL, NULL, NULL, 12, 169);
INSERT INTO "seafarers" VALUES (1432, '', 1, '', 54, 1, NULL, 1, 1, 54);
INSERT INTO "seafarers" VALUES (1433, '', 3, '', 59, 2, 4, 10, 7, 52);
INSERT INTO "seafarers" VALUES (1434, '', 4, '', 181, 31, 9, 13, 22, 163);
INSERT INTO "seafarers" VALUES (1435, '', 2, '', 79, 3, 1, 20, 1, 97);
INSERT INTO "seafarers" VALUES (1436, '', 5, '', 150, 13, 16, 3, 14, 123);
INSERT INTO "seafarers" VALUES (1437, '', 6, '', 193, 36, 6, NULL, 26, 161);
INSERT INTO "seafarers" VALUES (1438, '', 1, '', 128, 7, 6, NULL, 13, 109);
INSERT INTO "seafarers" VALUES (1439, '', 1, '', 76, 3, 4, 6, 3, 72);
INSERT INTO "seafarers" VALUES (1440, '', 1, '', 88, 4, 3, NULL, 7, 78);
INSERT INTO "seafarers" VALUES (1441, '', 3, '', 153, 10, 24, 2, 11, 120);
INSERT INTO "seafarers" VALUES (1442, '', 1, '', 150, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (1443, '', 5, '', 170, 4, 4, 5, 5, 163);
INSERT INTO "seafarers" VALUES (1444, '', 6, '', 201, NULL, 5, 5, 16, 178);
INSERT INTO "seafarers" VALUES (1445, '', 1, '', 74, 2, 2, 1, 1, 72);
INSERT INTO "seafarers" VALUES (1447, '', 3, '', 165, 2, 6, 4, 5, 158);
INSERT INTO "seafarers" VALUES (1449, '', 6, '', 145, NULL, NULL, NULL, 12, 106);
INSERT INTO "seafarers" VALUES (1450, '', 4, '', 176, NULL, 1, 6, 8, 165);
INSERT INTO "seafarers" VALUES (1451, '', 1, '', 206, 6, 10, 3, 6, 193);
INSERT INTO "seafarers" VALUES (1452, '', 1, '', 86, 78, 4, 45, 52, 75);
INSERT INTO "seafarers" VALUES (1453, '', 1, '', 138, 3, 2, 8, 4, 140);
INSERT INTO "seafarers" VALUES (1454, '', 2, '', 121, 4, 4, 3, 4, 116);
INSERT INTO "seafarers" VALUES (1455, '', 3, '', 165, 2, 4, 1, 2, 160);
INSERT INTO "seafarers" VALUES (1456, '', 1, '', 170, 3, 4, 7, 5, 168);
INSERT INTO "seafarers" VALUES (1457, '', 1, '', 160, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (1458, '', 6, '', 192, NULL, 8, 6, 3, 187);
INSERT INTO "seafarers" VALUES (1459, '', 1, '', 88, 8, 4, 1, 7, 78);
INSERT INTO "seafarers" VALUES (1460, '', 1, '', 33, 1, 1, 4, 1, 26);
INSERT INTO "seafarers" VALUES (1461, '', 1, '', 102, 15, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (1462, '', 1, '', 113, 2, 1, NULL, 2, 110);
INSERT INTO "seafarers" VALUES (1463, '', 1, '', 97, 5, 4, 2, 3, 92);
INSERT INTO "seafarers" VALUES (1464, '', 1, '', 120, 10, 13, 4, 7, 104);
INSERT INTO "seafarers" VALUES (1465, '', 2, '', 123, 8, 2, 1, 4, 118);
INSERT INTO "seafarers" VALUES (1466, '', 1, '', 117, 2, NULL, 1, 2, 116);
INSERT INTO "seafarers" VALUES (1467, '', 1, '', 112, 3, 1, 2, 2, 109);
INSERT INTO "seafarers" VALUES (1468, '', 2, '', 101, 4, 9, 10, 5, 97);
INSERT INTO "seafarers" VALUES (1469, '', 1, '', 144, 5, 19, 10, 6, 129);
INSERT INTO "seafarers" VALUES (1470, '', 1, '', 31, NULL, NULL, 7, NULL, 38);
INSERT INTO "seafarers" VALUES (1474, '', 1, '', 166, 9, 15, 16, 8, 156);
INSERT INTO "seafarers" VALUES (1476, '', 3, '', 117, 8, 8, 7, 8, 108);
INSERT INTO "seafarers" VALUES (1477, '', 1, '', 123, 9, 8, 3, 9, 109);
INSERT INTO "seafarers" VALUES (1478, '', 5, '', 183, 5, 10, 1, 6, 165);
INSERT INTO "seafarers" VALUES (1479, '', 3, '', 145, 17, 3, 2, 11, 133);
INSERT INTO "seafarers" VALUES (1480, '', 2, '', 121, 18, 13, 3, 14, 97);
INSERT INTO "seafarers" VALUES (1481, '', 1, '', 176, 4, 6, 4, 7, 167);
INSERT INTO "seafarers" VALUES (1482, '', 2, '', 90, 1, 5, 4, 2, 87);
INSERT INTO "seafarers" VALUES (1483, '', 1, '', 41, NULL, NULL, NULL, 1, 40);
INSERT INTO "seafarers" VALUES (1484, '', 2, '', 86, NULL, 3, 2, 2, 83);
INSERT INTO "seafarers" VALUES (1485, '', 3, '', 138, NULL, NULL, NULL, 3, 135);
INSERT INTO "seafarers" VALUES (1486, '', 1, '', 59, NULL, 1, NULL, 1, 57);
INSERT INTO "seafarers" VALUES (1487, '', 1, '', 131, 2, 1, 1, 17, 111);
INSERT INTO "seafarers" VALUES (1488, '', 2, '', 149, 7, 9, 1, 10, 136);
INSERT INTO "seafarers" VALUES (1489, '', 1, '', 129, 8, 24, 3, 7, 101);
INSERT INTO "seafarers" VALUES (1490, '', 2, '', 68, NULL, NULL, NULL, 10, 58);
INSERT INTO "seafarers" VALUES (1492, '', 1, '', 155, 8, 14, 29, 5, 164);
INSERT INTO "seafarers" VALUES (1493, '', 2, '', 74, 1, 2, 4, 1, 75);
INSERT INTO "seafarers" VALUES (1495, '', 2, '', 91, NULL, 2, NULL, 8, 81);
INSERT INTO "seafarers" VALUES (1496, '', 1, '', 64, NULL, 5, 5, 4, 60);
INSERT INTO "seafarers" VALUES (1497, '', 1, '', 77, NULL, 3, 15, 8, 80);
INSERT INTO "seafarers" VALUES (1498, '', 1, '', 106, NULL, 6, 11, NULL, 111);
INSERT INTO "seafarers" VALUES (1499, '', 4, '', 146, NULL, 6, 1, 2, 139);
INSERT INTO "seafarers" VALUES (1500, '', 1, '', 129, NULL, 7, 9, 7, 125);
INSERT INTO "seafarers" VALUES (1502, '', 6, '', 190, 1, 4, NULL, 5, 181);
INSERT INTO "seafarers" VALUES (1503, '', 1, '', 93, NULL, 18, 2, 4, 71);
INSERT INTO "seafarers" VALUES (1504, '', 1, '', 117, NULL, 6, 4, 7, 110);
INSERT INTO "seafarers" VALUES (1505, '', 5, '', 147, 3, 7, 10, 6, 144);
INSERT INTO "seafarers" VALUES (1507, '', 2, '', 112, NULL, 5, 4, 2, 109);
INSERT INTO "seafarers" VALUES (1508, '', 2, '', 103, NULL, NULL, NULL, 1, 102);
INSERT INTO "seafarers" VALUES (1509, '', 1, '', 164, NULL, 4, 2, 1, 154);
INSERT INTO "seafarers" VALUES (1511, '', 2, '', 148, NULL, 9, 1, 2, 132);
INSERT INTO "seafarers" VALUES (1512, '', 1, '', 29, NULL, NULL, NULL, 1, 28);
INSERT INTO "seafarers" VALUES (1514, '', 1, '', 79, 9, 5, 4, NULL, 78);
INSERT INTO "seafarers" VALUES (1515, '', 2, '', 86, 8, 4, 5, 4, 83);
INSERT INTO "seafarers" VALUES (1516, '', 1, '', 37, 4, 1, NULL, 2, 34);
INSERT INTO "seafarers" VALUES (1517, '', 2, '', 63, NULL, 1, 3, 2, 49);
INSERT INTO "seafarers" VALUES (1518, '', 3, '', 150, 18, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (1519, '', 7, '', 158, NULL, 1, NULL, 2, 156);
INSERT INTO "seafarers" VALUES (1520, '', 2, '', 21, 1, 4, 3, 1, 19);
INSERT INTO "seafarers" VALUES (1521, '', 2, '', 44, NULL, 1, 3, NULL, 46);
INSERT INTO "seafarers" VALUES (1522, '', 1, '', 54, NULL, NULL, NULL, NULL, 56);
INSERT INTO "seafarers" VALUES (1523, '', 4, '', 142, 15, 4, NULL, 10, 128);
INSERT INTO "seafarers" VALUES (1525, '', 1, '', 152, 17, 8, NULL, 18, 126);
INSERT INTO "seafarers" VALUES (1526, '', 4, '', 138, 17, 14, NULL, 8, 116);
INSERT INTO "seafarers" VALUES (1527, '', 1, '', 72, NULL, NULL, NULL, 37, 35);
INSERT INTO "seafarers" VALUES (1528, '', 1, '', 48, 1, 3, 1, 1, 45);
INSERT INTO "seafarers" VALUES (1529, '', 1, '', 140, 5, 15, 10, 5, 130);
INSERT INTO "seafarers" VALUES (1530, '', 2, '', 169, NULL, 16, 3, 9, 147);
INSERT INTO "seafarers" VALUES (1533, '', 3, '', 166, 2, 6, NULL, 2, 158);
INSERT INTO "seafarers" VALUES (1535, '', 3, '', 142, NULL, NULL, NULL, 14, 128);
INSERT INTO "seafarers" VALUES (1536, '', 1, '', 112, 1, 4, NULL, 4, 104);
INSERT INTO "seafarers" VALUES (1537, '', 1, '', 130, 3, 3, NULL, 7, 120);
INSERT INTO "seafarers" VALUES (1538, '', 6, '', 152, 15, 5, 7, 14, 140);
INSERT INTO "seafarers" VALUES (1539, '', 1, '', 152, 10, 13, 10, 4, 145);
INSERT INTO "seafarers" VALUES (1540, '', 1, '', 134, 4, 8, 9, 8, 127);
INSERT INTO "seafarers" VALUES (1542, '', 2, '', 123, 10, 10, 14, 22, 105);
INSERT INTO "seafarers" VALUES (1543, '', 2, '', 165, 10, 14, 9, 10, 150);
INSERT INTO "seafarers" VALUES (1544, '', 1, '', 64, 14, 9, 5, 2, 58);
INSERT INTO "seafarers" VALUES (1545, '', 2, '', 67, 6, 9, 7, 4, 61);
INSERT INTO "seafarers" VALUES (1546, '', 1, '', 92, 2, 4, 6, 5, 89);
INSERT INTO "seafarers" VALUES (1547, '', 4, '', 109, 3, 2, 8, 1, 114);
INSERT INTO "seafarers" VALUES (1548, '', 3, '', 55, NULL, 1, 1, 7, 52);
INSERT INTO "seafarers" VALUES (1550, '', 2, '', 64, NULL, 1, 1, 1, 63);
INSERT INTO "seafarers" VALUES (1551, '', 2, '', 85, NULL, 5, NULL, 10, 70);
INSERT INTO "seafarers" VALUES (1552, '', 1, '', 50, NULL, 1, NULL, 2, 47);
INSERT INTO "seafarers" VALUES (1553, '', 2, '', 98, NULL, NULL, NULL, 1, 97);
INSERT INTO "seafarers" VALUES (1554, '', 1, '', 48, NULL, NULL, 2, 3, 47);
INSERT INTO "seafarers" VALUES (1555, '', 1, '', 76, 13, 1, 3, 10, 68);
INSERT INTO "seafarers" VALUES (1556, '', 3, '', 146, 17, 5, 6, 11, 136);
INSERT INTO "seafarers" VALUES (1557, '', 2, '', 148, NULL, 3, 5, 1, 149);
INSERT INTO "seafarers" VALUES (1558, '', 2, '', 107, NULL, 5, 3, 8, 97);
INSERT INTO "seafarers" VALUES (1560, '', 4, '', 156, 19, 10, 6, 9, 143);
INSERT INTO "seafarers" VALUES (1561, '', 2, '', 98, NULL, 8, 14, 9, 95);
INSERT INTO "seafarers" VALUES (1562, '', 2, '', 85, 9, 9, 8, 13, 71);
INSERT INTO "seafarers" VALUES (1563, '', 3, '', 105, 4, 3, NULL, 3, 97);
INSERT INTO "seafarers" VALUES (1564, '', 6, '', 121, 37, 13, 9, 19, 97);
INSERT INTO "seafarers" VALUES (1568, '', 3, '', 14, NULL, NULL, 1, NULL, 15);
INSERT INTO "seafarers" VALUES (1569, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (1571, '', 1, '', 15, NULL, NULL, NULL, NULL, 15);
INSERT INTO "seafarers" VALUES (1573, '', 1, '', 171, NULL, 29, 10, 1, 150);
INSERT INTO "seafarers" VALUES (1574, '', 4, '', 157, 17, 20, 2, 7, 131);
INSERT INTO "seafarers" VALUES (1576, '', 2, '', 155, 1, 25, 4, 3, 130);
INSERT INTO "seafarers" VALUES (1577, '', 1, '', 151, 68, 13, 15, 45, 107);
INSERT INTO "seafarers" VALUES (1579, '', 5, '', 184, 34, 15, NULL, 19, 150);
INSERT INTO "seafarers" VALUES (1580, '', 3, '', 182, 30, 19, 10, 22, 151);
INSERT INTO "seafarers" VALUES (1581, '', 2, '', 99, 6, NULL, NULL, 6, 93);
INSERT INTO "seafarers" VALUES (1582, '', 2, '', 156, 28, 15, 5, 23, 123);
INSERT INTO "seafarers" VALUES (1583, '', 3, '', 133, 12, 6, 9, 11, 123);
INSERT INTO "seafarers" VALUES (1584, '', 1, '', 106, 57, 11, 26, 40, 79);
INSERT INTO "seafarers" VALUES (1585, '', 1, '', 145, 36, 17, 15, 15, 128);
INSERT INTO "seafarers" VALUES (1586, '', 2, '', 126, 5, 3, 8, 5, 126);
INSERT INTO "seafarers" VALUES (1587, '', 4, '', 171, 3, 29, 10, 6, 145);
INSERT INTO "seafarers" VALUES (1589, '', 1, '', 28, NULL, 11, 10, 2, 25);
INSERT INTO "seafarers" VALUES (1590, '', 2, '', 97, 5, 4, 5, 2, 96);
INSERT INTO "seafarers" VALUES (1591, '', 1, '', 182, 10, 34, 5, 11, 128);
INSERT INTO "seafarers" VALUES (1592, '', 4, '', 98, 66, 2, 18, 47, 60);
INSERT INTO "seafarers" VALUES (1593, '', 1, '', 83, 30, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (1594, '', 4, '', 116, 39, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (1595, '', 1, '', 97, 5, 6, 7, 5, 93);
INSERT INTO "seafarers" VALUES (1596, '', 3, '', 142, 60, 7, 3, 40, 90);
INSERT INTO "seafarers" VALUES (1597, '', 5, '', 215, 170, 21, 14, 103, 105);
INSERT INTO "seafarers" VALUES (1598, '', 2, '', 198, 213, 25, 52, 174, 51);
INSERT INTO "seafarers" VALUES (1599, '', 2, '', 117, 5, 10, NULL, 2, 105);
INSERT INTO "seafarers" VALUES (1600, '', 2, '', 77, 2, 4, 1, 2, 72);
INSERT INTO "seafarers" VALUES (1601, '', 3, '', 165, 4, 25, 1, 7, 133);
INSERT INTO "seafarers" VALUES (1603, '', 4, '', 161, 42, 15, 5, 46, 105);
INSERT INTO "seafarers" VALUES (1606, '', 3, '', 95, 18, 2, 19, 11, 99);
INSERT INTO "seafarers" VALUES (1608, '', 3, '', 58, 30, 4, 6, 20, 40);
INSERT INTO "seafarers" VALUES (1609, '', 2, '', 82, 3, 2, 6, 4, 79);
INSERT INTO "seafarers" VALUES (1611, '', 5, '', 137, 48, 7, 3, 33, 101);
INSERT INTO "seafarers" VALUES (1612, '', 3, '', 177, 35, 22, 3, 27, 131);
INSERT INTO "seafarers" VALUES (1613, '', 3, '', 137, 36, 16, 7, 27, 101);
INSERT INTO "seafarers" VALUES (1614, '', 1, '', 85, 6, 11, 1, 11, 64);
INSERT INTO "seafarers" VALUES (1615, '', 2, '', 88, 6, 7, 5, 6, 80);
INSERT INTO "seafarers" VALUES (1616, '', 3, '', 90, 2, 10, 3, 8, 75);
INSERT INTO "seafarers" VALUES (1617, '', 2, '', 151, 11, 17, 7, 41, 100);
INSERT INTO "seafarers" VALUES (1618, '', 2, '', 176, 15, 13, 4, 29, 138);
INSERT INTO "seafarers" VALUES (1619, '', 2, '', 71, 8, 9, 1, 9, 54);
INSERT INTO "seafarers" VALUES (1620, '', 3, '', 89, 2, 14, 5, 9, 71);
INSERT INTO "seafarers" VALUES (1621, '', 3, '', 148, 54, 30, 43, 104, 57);
INSERT INTO "seafarers" VALUES (1622, '', 5, '', 175, NULL, 17, NULL, 17, 141);
INSERT INTO "seafarers" VALUES (1623, '', 1, '', 143, 70, 26, 19, 27, 109);
INSERT INTO "seafarers" VALUES (1624, '', 2, '', 152, 16, 14, 9, 33, 114);
INSERT INTO "seafarers" VALUES (1625, '', 2, '', 104, 27, 17, 3, 26, 64);
INSERT INTO "seafarers" VALUES (1626, '', 2, '', 61, 2, 3, 9, 2, 65);
INSERT INTO "seafarers" VALUES (1627, '', 4, '', 144, 24, 4, 9, 13, 136);
INSERT INTO "seafarers" VALUES (1630, '', 1, '', 131, 31, 3, 6, 13, 118);
INSERT INTO "seafarers" VALUES (1631, '', 1, '', 168, 27, 12, 16, 29, 140);
INSERT INTO "seafarers" VALUES (1635, '', 1, '', 191, 35, 22, 5, 24, 149);
INSERT INTO "seafarers" VALUES (1637, '', 1, '', 131, 101, 17, 31, 58, 87);
INSERT INTO "seafarers" VALUES (1642, '', 2, '', 105, 28, 10, 8, 25, 78);
INSERT INTO "seafarers" VALUES (1643, '', 4, '', 175, 221, 12, 107, 128, 143);
INSERT INTO "seafarers" VALUES (1644, '', 1, '', 119, 3, 4, 4, 2, 117);
INSERT INTO "seafarers" VALUES (1645, '', 1, '', 150, 4, 2, 4, 6, 146);
INSERT INTO "seafarers" VALUES (1646, '', 3, '', 138, 2, 3, 8, 8, 135);
INSERT INTO "seafarers" VALUES (1648, '', 1, '', 169, 16, 29, 7, 24, 123);
INSERT INTO "seafarers" VALUES (1649, '', 5, '', 173, 51, 39, 2, 33, 99);
INSERT INTO "seafarers" VALUES (1650, '', 1, '', 142, 60, 8, 8, 34, 108);
INSERT INTO "seafarers" VALUES (1652, '', 5, '', 96, 2, 12, NULL, 2, 76);
INSERT INTO "seafarers" VALUES (1653, '', 2, '', 30, 1, 5, 2, 1, 26);
INSERT INTO "seafarers" VALUES (1654, '', 1, '', 143, 1, 4, 1, 15, 124);
INSERT INTO "seafarers" VALUES (1655, '', 1, '', 98, 12, 16, 4, 8, 77);
INSERT INTO "seafarers" VALUES (1657, '', 1, '', 145, 11, 16, 13, 10, 122);
INSERT INTO "seafarers" VALUES (1659, '', 2, '', 119, 2, 3, 2, 2, 110);
INSERT INTO "seafarers" VALUES (1660, '', 1, '', 95, 3, 14, 9, 2, 86);
INSERT INTO "seafarers" VALUES (1662, '', 1, '', 165, 8, 18, 7, 6, 148);
INSERT INTO "seafarers" VALUES (1664, '', 1, '', 128, 39, 18, 13, 60, 63);
INSERT INTO "seafarers" VALUES (1667, '', 1, '', 174, 37, 22, 17, 27, 142);
INSERT INTO "seafarers" VALUES (1668, '', 1, '', 140, 23, 33, 1, 10, 98);
INSERT INTO "seafarers" VALUES (1670, '', 2, '', 143, 134, 7, 49, 87, 98);
INSERT INTO "seafarers" VALUES (1672, '', 3, '', 180, 17, 9, 5, 18, 158);
INSERT INTO "seafarers" VALUES (1673, '', 4, '', 126, 2, 39, 2, 2, 87);
INSERT INTO "seafarers" VALUES (1674, '', 3, '', 119, 38, 17, 25, 25, 102);
INSERT INTO "seafarers" VALUES (1675, '', 1, '', 154, 41, 19, 15, 33, 117);
INSERT INTO "seafarers" VALUES (1676, '', 3, '', 157, 39, 53, 43, 75, 72);
INSERT INTO "seafarers" VALUES (1677, '', 1, '', 167, 23, 7, 8, 14, 155);
INSERT INTO "seafarers" VALUES (1678, '', 1, '', 133, 30, 3, 3, 10, 123);
INSERT INTO "seafarers" VALUES (1681, '', 1, '', 120, 11, 16, 8, 20, 84);
INSERT INTO "seafarers" VALUES (1682, '', 2, '', 98, 13, 6, 4, 11, 81);
INSERT INTO "seafarers" VALUES (1683, '', 1, '', 110, 43, 7, 10, 26, 87);
INSERT INTO "seafarers" VALUES (1684, '', 2, '', 155, 88, 37, 42, 59, 101);
INSERT INTO "seafarers" VALUES (1685, '', 4, '', 152, 15, 13, NULL, 5, 134);
INSERT INTO "seafarers" VALUES (1686, '', 4, '', 57, 16, 13, 29, 20, 53);
INSERT INTO "seafarers" VALUES (1688, '', 3, '', 162, 13, 36, 25, 13, 138);
INSERT INTO "seafarers" VALUES (1689, '', 3, '', 80, 51, 9, 38, 40, 69);
INSERT INTO "seafarers" VALUES (1690, '', 5, '', 108, 16, 11, 7, 18, 86);
INSERT INTO "seafarers" VALUES (1691, '', 1, '', 136, 6, 25, 2, 7, 106);
INSERT INTO "seafarers" VALUES (1692, '', 3, '', 93, 60, 13, 32, 42, 70);
INSERT INTO "seafarers" VALUES (1693, '', 4, '', 194, 74, 36, 3, 55, 106);
INSERT INTO "seafarers" VALUES (1694, '', 4, '', 103, 68, 8, 7, 32, 70);
INSERT INTO "seafarers" VALUES (1695, '', 2, '', 147, 30, 6, 5, 18, 128);
INSERT INTO "seafarers" VALUES (1696, '', 1, '', 74, 1, 1, NULL, 1, 72);
INSERT INTO "seafarers" VALUES (1697, '', 1, '', 176, 17, 16, 1, 12, 149);
INSERT INTO "seafarers" VALUES (1698, '', 4, '', 90, 1, 5, NULL, 9, 76);
INSERT INTO "seafarers" VALUES (1699, '', 3, '', 155, 59, 11, 9, 41, 112);
INSERT INTO "seafarers" VALUES (1701, '', 1, '', 165, 1, 4, 2, 3, 160);
INSERT INTO "seafarers" VALUES (1702, '', 1, '', 104, 1, 5, 2, 1, 99);
INSERT INTO "seafarers" VALUES (1703, '', 3, '', 97, 13, 3, 1, 8, 87);
INSERT INTO "seafarers" VALUES (1704, '', 1, '', 26, NULL, NULL, 2, 1, 27);
INSERT INTO "seafarers" VALUES (1705, '', 1, '', 58, NULL, 3, 3, 2, 56);
INSERT INTO "seafarers" VALUES (1706, '', 1, '', 174, 11, 4, 2, 5, 167);
INSERT INTO "seafarers" VALUES (1707, '', 1, '', 60, 1, 6, 2, 1, 55);
INSERT INTO "seafarers" VALUES (1710, '', 1, '', 104, 23, 5, 3, 15, 87);
INSERT INTO "seafarers" VALUES (1711, '', 1, '', 108, 32, 7, 5, 15, 91);
INSERT INTO "seafarers" VALUES (1712, '', 2, '', 137, 16, 17, 10, 12, 118);
INSERT INTO "seafarers" VALUES (1713, '', 2, '', 77, 12, 7, 5, 12, 63);
INSERT INTO "seafarers" VALUES (1714, '', 3, '', 128, 25, 16, 3, 17, 98);
INSERT INTO "seafarers" VALUES (1715, '', 2, '', 130, 19, 20, 8, 15, 103);
INSERT INTO "seafarers" VALUES (1716, '', 1, '', 120, 17, 3, 6, 23, 100);
INSERT INTO "seafarers" VALUES (1717, '', 2, '', 121, 18, 14, 9, 12, 104);
INSERT INTO "seafarers" VALUES (1718, '', 2, '', 159, 38, 11, 8, 23, 133);
INSERT INTO "seafarers" VALUES (1721, '', 1, '', 39, NULL, 4, NULL, 1, 34);
INSERT INTO "seafarers" VALUES (1722, '', 2, '', 31, NULL, 5, 7, NULL, 33);
INSERT INTO "seafarers" VALUES (1723, '', 3, '', 87, 6, 6, 5, 5, 81);
INSERT INTO "seafarers" VALUES (1725, '', 5, '', 169, 35, 12, 4, 18, 138);
INSERT INTO "seafarers" VALUES (1726, '', 1, '', 79, 14, 4, 10, 3, 82);
INSERT INTO "seafarers" VALUES (1727, '', 1, '', 48, 2, 4, 2, 2, 44);
INSERT INTO "seafarers" VALUES (1728, '', 2, '', 115, 25, 20, 17, 19, 84);
INSERT INTO "seafarers" VALUES (1729, '', 2, '', 159, 13, 6, 4, 10, 143);
INSERT INTO "seafarers" VALUES (1731, '', 2, '', 129, 22, 22, 16, 10, 125);
INSERT INTO "seafarers" VALUES (1732, '', 2, '', 141, 23, 7, 2, 12, 120);
INSERT INTO "seafarers" VALUES (1733, '', 2, '', 118, 16, 4, 16, 9, 118);
INSERT INTO "seafarers" VALUES (1734, '', 1, '', 160, 3, 2, 2, 5, 148);
INSERT INTO "seafarers" VALUES (1735, '', 1, '', 153, 12, 4, 3, 9, 143);
INSERT INTO "seafarers" VALUES (1736, '', 2, '', 91, 47, 11, 23, 32, 71);
INSERT INTO "seafarers" VALUES (1738, '', 2, '', 135, 104, 3, 29, 67, 94);
INSERT INTO "seafarers" VALUES (1740, '', 1, '', 101, 7, 6, 5, 11, 89);
INSERT INTO "seafarers" VALUES (1741, '', 1, '', 50, 1, 3, 5, 2, 50);
INSERT INTO "seafarers" VALUES (1742, '', 1, '', 14, NULL, NULL, 2, 2, 14);
INSERT INTO "seafarers" VALUES (1743, '', 3, '', 114, 15, 10, 15, 20, 92);
INSERT INTO "seafarers" VALUES (1744, '', 2, '', 128, 28, 11, 20, 38, 90);
INSERT INTO "seafarers" VALUES (1746, '', 2, '', 146, 49, 28, 19, 22, 115);
INSERT INTO "seafarers" VALUES (1747, '', 1, '', 152, 4, 19, 9, 4, 138);
INSERT INTO "seafarers" VALUES (1749, '', 1, '', 143, 1, NULL, NULL, 1, 142);
INSERT INTO "seafarers" VALUES (1750, '', 3, '', 101, 3, 3, 9, 5, 102);
INSERT INTO "seafarers" VALUES (1751, '', 1, '', 81, 5, 1, 1, 7, 75);
INSERT INTO "seafarers" VALUES (1752, '', 4, '', 187, 18, 7, 3, 8, 175);
INSERT INTO "seafarers" VALUES (1754, '', 2, '', 135, 18, 4, 3, 10, 124);
INSERT INTO "seafarers" VALUES (1755, '', 1, '', 47, 4, 1, 1, 3, 44);
INSERT INTO "seafarers" VALUES (1756, '', 2, '', 83, 3, 3, 2, 4, 78);
INSERT INTO "seafarers" VALUES (1757, '', 3, '', 129, 9, 3, NULL, 8, 119);
INSERT INTO "seafarers" VALUES (1758, '', 4, '', 136, 5, 8, 5, 8, 125);
INSERT INTO "seafarers" VALUES (1759, '', 4, '', 123, 2, 3, 2, 3, 119);
INSERT INTO "seafarers" VALUES (1760, '', 2, '', 109, 9, 11, 12, 60, 50);
INSERT INTO "seafarers" VALUES (1761, '', 4, '', 111, 3, 17, 19, 3, 110);
INSERT INTO "seafarers" VALUES (1762, '', 2, '', 157, 13, 27, 29, 11, 148);
INSERT INTO "seafarers" VALUES (1765, '', 1, '', 148, 11, 18, 14, 11, 135);
INSERT INTO "seafarers" VALUES (1766, '', 2, '', 105, 12, 7, 9, 6, 101);
INSERT INTO "seafarers" VALUES (1767, '', 1, '', 13, NULL, NULL, NULL, NULL, 13);
INSERT INTO "seafarers" VALUES (1769, '', 1, '', 142, 2, 17, 13, 2, 136);
INSERT INTO "seafarers" VALUES (1770, '', 1, '', 171, 29, 16, 6, 13, 148);
INSERT INTO "seafarers" VALUES (1774, '', 3, '', 114, 6, 1, 22, 4, 131);
INSERT INTO "seafarers" VALUES (1775, '', 1, '', 83, 3, 4, 11, 3, 87);
INSERT INTO "seafarers" VALUES (1776, '', 5, '', 109, 1, 7, 15, 1, 122);
INSERT INTO "seafarers" VALUES (1777, '', 3, '', 102, NULL, NULL, 8, 1, 109);
INSERT INTO "seafarers" VALUES (1778, '', 2, '', 98, NULL, 2, 10, NULL, 106);
INSERT INTO "seafarers" VALUES (1779, '', 2, '', 126, 4, 2, 30, 5, 149);
INSERT INTO "seafarers" VALUES (1780, '', 2, '', 134, 1, 6, 6, 1, 133);
INSERT INTO "seafarers" VALUES (1781, '', 2, '', 83, 1, 5, NULL, 1, 77);
INSERT INTO "seafarers" VALUES (1782, '', 2, '', 164, 27, 16, 13, 17, 144);
INSERT INTO "seafarers" VALUES (1783, '', 3, '', 170, 33, 7, 11, 16, 158);
INSERT INTO "seafarers" VALUES (1784, '', 2, '', 99, 5, 22, 5, 4, 78);
INSERT INTO "seafarers" VALUES (1785, '', 1, '', 113, 13, 12, 13, 12, 102);
INSERT INTO "seafarers" VALUES (1788, '', 2, '', 123, 2, 21, 13, NULL, 115);
INSERT INTO "seafarers" VALUES (1789, '', 1, '', 126, 9, 8, 3, 10, 111);
INSERT INTO "seafarers" VALUES (1791, '', 3, '', 126, NULL, 7, 9, NULL, 124);
INSERT INTO "seafarers" VALUES (1794, '', 3, '', 118, 2, NULL, NULL, 2, 116);
INSERT INTO "seafarers" VALUES (1795, '', 2, '', 87, 7, NULL, 2, 7, 82);
INSERT INTO "seafarers" VALUES (1797, '', 3, '', 113, 2, 2, NULL, 8, 103);
INSERT INTO "seafarers" VALUES (1798, '', 5, '', 164, 4, 16, 7, 3, 152);
INSERT INTO "seafarers" VALUES (1799, '', 2, '', 135, NULL, 7, 8, NULL, 135);
INSERT INTO "seafarers" VALUES (1800, '', 2, '', 135, 5, 4, 11, 2, 140);
INSERT INTO "seafarers" VALUES (1802, '', 1, '', 142, 6, 9, 12, 4, 141);
INSERT INTO "seafarers" VALUES (1803, '', 3, '', 123, 1, 1, 10, 2, 130);
INSERT INTO "seafarers" VALUES (1804, '', 4, '', 95, 2, 13, 4, 2, 84);
INSERT INTO "seafarers" VALUES (1805, '', 1, '', 45, 3, 1, 3, 3, 53);
INSERT INTO "seafarers" VALUES (1806, '', 4, '', 145, 46, 24, 24, 18, 130);
INSERT INTO "seafarers" VALUES (1807, '', 1, '', 79, 14, 8, 7, 15, 63);
INSERT INTO "seafarers" VALUES (1808, '', 3, '', 132, 7, 8, 4, 7, 119);
INSERT INTO "seafarers" VALUES (1810, '', 1, '', 157, 3, 11, 10, 4, 152);
INSERT INTO "seafarers" VALUES (1811, '', 2, '', 53, NULL, 3, 12, 2, 60);
INSERT INTO "seafarers" VALUES (1813, '', 1, '', 87, 1, 5, 40, 2, 120);
INSERT INTO "seafarers" VALUES (1814, '', 2, '', 54, NULL, NULL, 1, NULL, 53);
INSERT INTO "seafarers" VALUES (1815, '', 1, '', 40, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (1816, '', 1, '', 83, NULL, 13, 4, NULL, 74);
INSERT INTO "seafarers" VALUES (1818, '', 2, '', 109, NULL, 5, 1, NULL, 105);
INSERT INTO "seafarers" VALUES (1819, '', 3, '', 192, 3, 5, 2, 5, 184);
INSERT INTO "seafarers" VALUES (1820, '', 1, '', 86, NULL, 5, 8, 1, 88);
INSERT INTO "seafarers" VALUES (1835, '', 4, '', 160, 5, 5, 7, 4, 158);
INSERT INTO "seafarers" VALUES (1836, '', 3, '', 156, 8, 13, 12, 13, 142);
INSERT INTO "seafarers" VALUES (1838, '', 3, '', 135, 1, 8, 3, 2, 128);
INSERT INTO "seafarers" VALUES (1839, '', 1, '', 103, NULL, 5, 4, 3, 100);
INSERT INTO "seafarers" VALUES (1840, '', 4, '', 133, NULL, 19, 12, 2, 124);
INSERT INTO "seafarers" VALUES (1842, '', 1, '', 145, 5, 14, 3, 5, 126);
INSERT INTO "seafarers" VALUES (1843, '', 2, '', 79, NULL, 2, NULL, NULL, 77);
INSERT INTO "seafarers" VALUES (1844, '', 1, '', 143, 5, 6, 6, 6, 138);
INSERT INTO "seafarers" VALUES (1845, '', 3, '', 134, 1, 4, NULL, 5, 125);
INSERT INTO "seafarers" VALUES (1846, '', 3, '', 156, 10, 3, NULL, 8, 146);
INSERT INTO "seafarers" VALUES (1848, '', 1, '', 101, 6, 2, NULL, 7, 92);
INSERT INTO "seafarers" VALUES (1849, '', 3, '', 114, NULL, 6, 1, 3, 106);
INSERT INTO "seafarers" VALUES (1850, '', 5, '', 113, 4, 6, 6, 1, 112);
INSERT INTO "seafarers" VALUES (1851, '', 4, '', 118, 2, 6, 6, 2, 119);
INSERT INTO "seafarers" VALUES (1852, '', 4, '', 157, 6, 7, 9, 6, 153);
INSERT INTO "seafarers" VALUES (1854, '', 3, '', 64, NULL, NULL, NULL, NULL, 64);
INSERT INTO "seafarers" VALUES (1855, '', 1, '', 163, 3, 2, 2, 3, 162);
INSERT INTO "seafarers" VALUES (1856, '', 2, '', 152, NULL, 12, 6, 1, 144);
INSERT INTO "seafarers" VALUES (1857, '', 4, '', 114, NULL, 5, 1, 2, 108);
INSERT INTO "seafarers" VALUES (1858, '', 5, '', 118, 2, 8, NULL, 2, 108);
INSERT INTO "seafarers" VALUES (1859, '', 3, '', 82, NULL, 4, 8, 1, 85);
INSERT INTO "seafarers" VALUES (1860, '', 5, '', 119, 1, 8, 1, 1, 111);
INSERT INTO "seafarers" VALUES (1861, '', 3, '', 120, 10, 2, 2, 10, 110);
INSERT INTO "seafarers" VALUES (1862, '', 4, '', 146, 7, 3, 6, 4, 135);
INSERT INTO "seafarers" VALUES (1863, '', 6, '', 191, 10, 5, 5, 10, 181);
INSERT INTO "seafarers" VALUES (1864, '', 3, '', 136, 6, 8, 3, 6, 125);
INSERT INTO "seafarers" VALUES (1865, '', 2, '', 77, 1, 1, 1, 2, 73);
INSERT INTO "seafarers" VALUES (1866, '', 1, '', 142, 10, 9, 9, 6, 136);
INSERT INTO "seafarers" VALUES (1867, '', 1, '', 145, 8, 17, 6, 7, 123);
INSERT INTO "seafarers" VALUES (1868, '', 2, '', 183, 5, 7, 2, 3, 175);
INSERT INTO "seafarers" VALUES (1870, '', 2, '', 75, 3, 5, 6, 3, 73);
INSERT INTO "seafarers" VALUES (1871, '', 4, '', 155, 12, 6, 1, 8, 132);
INSERT INTO "seafarers" VALUES (1873, '', 2, '', 74, NULL, 2, 1, 1, 72);
INSERT INTO "seafarers" VALUES (1874, '', 3, '', 171, 3, 8, 6, 3, 166);
INSERT INTO "seafarers" VALUES (1875, '', 2, '', 96, 11, 9, 11, 11, 87);
INSERT INTO "seafarers" VALUES (1876, '', 1, '', 93, 3, 6, 23, 2, 108);
INSERT INTO "seafarers" VALUES (1878, '', 1, '', 171, 1, 5, 14, 1, 179);
INSERT INTO "seafarers" VALUES (1879, '', 4, '', 178, 5, 4, 16, 6, 178);
INSERT INTO "seafarers" VALUES (1880, '', 2, '', 114, 8, 4, NULL, 8, 102);
INSERT INTO "seafarers" VALUES (1881, '', 4, '', 172, 2, 9, 9, 2, 153);
INSERT INTO "seafarers" VALUES (1882, '', 3, '', 163, 3, 14, 4, 3, 150);
INSERT INTO "seafarers" VALUES (1883, '', 4, '', 216, 7, 11, 11, 12, 204);
INSERT INTO "seafarers" VALUES (1884, '', 1, '', 221, 6, 13, 12, 8, 205);
INSERT INTO "seafarers" VALUES (1885, '', 2, '', 95, NULL, 3, 3, NULL, 95);
INSERT INTO "seafarers" VALUES (1886, '', 1, '', 140, 1, 2, 1, 1, 102);
INSERT INTO "seafarers" VALUES (1887, '', 4, '', 152, 1, 12, 2, 3, 139);
INSERT INTO "seafarers" VALUES (1888, '', 3, '', 118, 4, 4, 5, 8, 111);
INSERT INTO "seafarers" VALUES (1889, '', 3, '', 164, 11, 5, 4, 6, 157);
INSERT INTO "seafarers" VALUES (1890, '', 1, '', 18, NULL, NULL, 3, NULL, 20);
INSERT INTO "seafarers" VALUES (1891, '', 4, '', 173, 32, 15, 11, 25, 144);
INSERT INTO "seafarers" VALUES (1894, '', 1, '', 97, 4, 10, 10, 6, 91);
INSERT INTO "seafarers" VALUES (1896, '', 1, '', 95, 7, 8, 6, 5, 87);
INSERT INTO "seafarers" VALUES (1898, '', 1, '', 19, 3, 2, 5, 3, 19);
INSERT INTO "seafarers" VALUES (1899, '', 4, '', 155, 4, 10, 10, 5, 150);
INSERT INTO "seafarers" VALUES (1900, '', 1, '', 158, 7, 8, 10, 13, 156);
INSERT INTO "seafarers" VALUES (1901, '', 1, '', 109, 1, 2, 3, 2, 108);
INSERT INTO "seafarers" VALUES (1902, '', 3, '', 117, 1, 4, 2, 1, 114);
INSERT INTO "seafarers" VALUES (1903, '', 4, '', 145, 15, 17, 8, 14, 122);
INSERT INTO "seafarers" VALUES (1904, '', 5, '', 90, 4, 9, 14, 4, 91);
INSERT INTO "seafarers" VALUES (1906, '', 2, '', 94, NULL, 3, 5, 5, 91);
INSERT INTO "seafarers" VALUES (1907, '', 4, '', 101, 1, 3, NULL, 1, 97);
INSERT INTO "seafarers" VALUES (1908, '', 1, '', 105, 6, 4, 5, 4, 102);
INSERT INTO "seafarers" VALUES (1910, '', 3, '', 165, 10, 6, 2, 7, 157);
INSERT INTO "seafarers" VALUES (1911, '', 2, '', 195, 5, 17, 4, 6, 176);
INSERT INTO "seafarers" VALUES (1912, '', 2, '', 111, 9, 3, 1, 8, 101);
INSERT INTO "seafarers" VALUES (1913, '', 4, '', 162, NULL, 11, 9, NULL, 160);
INSERT INTO "seafarers" VALUES (1915, '', 1, '', 158, 5, 12, 2, 4, 144);
INSERT INTO "seafarers" VALUES (1916, '', 5, '', 120, 4, 13, 8, 4, 111);
INSERT INTO "seafarers" VALUES (1917, '', 2, '', 104, 1, 6, 12, 1, 109);
INSERT INTO "seafarers" VALUES (1918, '', 6, '', 110, 3, 10, 3, 4, 99);
INSERT INTO "seafarers" VALUES (1919, '', 4, '', 205, 9, 6, 7, 12, 194);
INSERT INTO "seafarers" VALUES (1920, '', 1, '', 104, 17, 9, 7, 15, 87);
INSERT INTO "seafarers" VALUES (1921, '', 5, '', 147, 5, 5, 3, 5, 139);
INSERT INTO "seafarers" VALUES (1922, '', 2, '', 138, 26, 17, 2, 19, 104);
INSERT INTO "seafarers" VALUES (1923, '', 6, '', 144, 5, 9, 4, 9, 130);
INSERT INTO "seafarers" VALUES (1924, '', 1, '', 123, 11, 16, 14, 26, 95);
INSERT INTO "seafarers" VALUES (1925, '', 4, '', 155, 12, 19, 21, 20, 137);
INSERT INTO "seafarers" VALUES (1927, '', 1, '', 12, 1, NULL, 1, 1, 12);
INSERT INTO "seafarers" VALUES (1928, '', 1, '', 148, 13, 18, 7, 11, 126);
INSERT INTO "seafarers" VALUES (1929, '', 1, '', 79, NULL, 5, 5, NULL, 79);
INSERT INTO "seafarers" VALUES (1930, '', 3, '', 151, NULL, NULL, NULL, 33, 115);
INSERT INTO "seafarers" VALUES (1932, '', 3, '', 104, NULL, 7, 7, NULL, 104);
INSERT INTO "seafarers" VALUES (1933, '', 1, '', 60, NULL, NULL, NULL, 1, 55);
INSERT INTO "seafarers" VALUES (1934, '', 3, '', 94, 2, 3, 7, 2, 96);
INSERT INTO "seafarers" VALUES (1935, '', 4, '', 144, 21, 1, 6, 21, 126);
INSERT INTO "seafarers" VALUES (1936, '', 5, '', 137, 16, 8, NULL, 16, 115);
INSERT INTO "seafarers" VALUES (1937, '', 1, '', 102, 1, 7, 8, 1, 102);
INSERT INTO "seafarers" VALUES (1938, '', 1, '', 14, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (1939, '', 3, '', 91, 6, 9, 9, 6, 85);
INSERT INTO "seafarers" VALUES (1941, '', 3, '', 133, 16, 17, 7, 10, 113);
INSERT INTO "seafarers" VALUES (1942, '', 4, '', 136, 19, 9, 5, 9, 123);
INSERT INTO "seafarers" VALUES (1943, '', 3, '', 74, 13, 1, 2, 8, 69);
INSERT INTO "seafarers" VALUES (1944, '', 4, '', 100, 5, 5, 1, 4, 92);
INSERT INTO "seafarers" VALUES (1945, '', 1, '', 102, 35, 6, 29, 38, 87);
INSERT INTO "seafarers" VALUES (1946, '', 3, '', 138, 26, 12, 17, 18, 125);
INSERT INTO "seafarers" VALUES (1948, '', 3, '', 103, 22, 21, 13, 18, 77);
INSERT INTO "seafarers" VALUES (1949, '', 5, '', 118, 9, 13, 1, 7, 99);
INSERT INTO "seafarers" VALUES (1950, '', 1, '', 100, 4, 4, NULL, 4, 82);
INSERT INTO "seafarers" VALUES (1951, '', 5, '', 123, 34, 23, 38, 37, 101);
INSERT INTO "seafarers" VALUES (1952, '', 1, '', 119, 3, 12, 2, 2, 107);
INSERT INTO "seafarers" VALUES (1953, '', 5, '', 122, 5, 11, 4, 3, 112);
INSERT INTO "seafarers" VALUES (1954, '', 1, '', 127, 15, 27, 3, 15, 88);
INSERT INTO "seafarers" VALUES (1955, '', 1, '', 122, 5, 14, 7, 7, 108);
INSERT INTO "seafarers" VALUES (1956, '', 5, '', 152, 16, 15, 6, 18, 126);
INSERT INTO "seafarers" VALUES (1957, '', 1, '', 80, 1, 2, 1, 1, 78);
INSERT INTO "seafarers" VALUES (1958, '', 4, '', 122, 2, 5, 7, 2, 122);
INSERT INTO "seafarers" VALUES (1959, '', 1, '', 107, 2, 4, 8, 2, 109);
INSERT INTO "seafarers" VALUES (1963, '', 1, '', 116, 1, 9, 1, 1, 107);
INSERT INTO "seafarers" VALUES (1964, '', 2, '', 96, NULL, 10, 7, NULL, 93);
INSERT INTO "seafarers" VALUES (1965, '', 3, '', 97, NULL, 4, 1, NULL, 94);
INSERT INTO "seafarers" VALUES (1966, '', 4, '', 149, 1, 1, 1, 2, 147);
INSERT INTO "seafarers" VALUES (1967, '', 3, '', 161, 1, 4, 1, 1, 167);
INSERT INTO "seafarers" VALUES (1968, '', 2, '', 82, 2, 2, 2, 2, 79);
INSERT INTO "seafarers" VALUES (1969, '', 2, '', 92, 2, 2, 6, 2, 94);
INSERT INTO "seafarers" VALUES (1970, '', 2, '', 82, 2, 4, 1, 2, 77);
INSERT INTO "seafarers" VALUES (1971, '', 5, '', 131, 4, 4, 1, 5, 123);
INSERT INTO "seafarers" VALUES (1972, '', 2, '', 118, 5, 4, 9, 5, 118);
INSERT INTO "seafarers" VALUES (1973, '', 3, '', 112, 11, 3, 3, 11, 100);
INSERT INTO "seafarers" VALUES (1974, '', 1, '', 93, 15, 14, 15, 15, 79);
INSERT INTO "seafarers" VALUES (1976, '', 6, '', 88, 22, 9, 15, 22, 74);
INSERT INTO "seafarers" VALUES (1977, '', 4, '', 117, 13, 11, 14, 13, 107);
INSERT INTO "seafarers" VALUES (1978, '', 1, '', 93, 9, 4, NULL, 10, 79);
INSERT INTO "seafarers" VALUES (1979, '', 4, '', 120, 8, 8, 2, 9, 104);
INSERT INTO "seafarers" VALUES (1980, '', 5, '', 116, 4, 7, 6, 7, 111);
INSERT INTO "seafarers" VALUES (1981, '', 1, '', 116, 4, 11, 5, 4, 105);
INSERT INTO "seafarers" VALUES (1983, '', 1, '', 169, 3, 27, 11, 3, 150);
INSERT INTO "seafarers" VALUES (1984, '', 1, '', 130, 7, 7, 11, 8, 126);
INSERT INTO "seafarers" VALUES (1985, '', 2, '', 127, 8, 9, 7, 7, 118);
INSERT INTO "seafarers" VALUES (1986, '', 1, '', 135, 2, 10, 6, 4, 124);
INSERT INTO "seafarers" VALUES (1987, '', 1, '', 81, 2, 1, 1, 2, 79);
INSERT INTO "seafarers" VALUES (1988, '', 5, '', 121, 1, 3, 3, 1, 119);
INSERT INTO "seafarers" VALUES (1989, '', 2, '', 84, NULL, 3, NULL, 1, 80);
INSERT INTO "seafarers" VALUES (1991, '', 2, '', 120, 12, 6, 6, 13, 107);
INSERT INTO "seafarers" VALUES (1993, '', 4, '', 124, 6, 9, 1, 9, 107);
INSERT INTO "seafarers" VALUES (1994, '', 4, '', 115, 8, 12, 3, 9, 97);
INSERT INTO "seafarers" VALUES (1995, '', 1, '', 100, 1, 11, 3, 1, 91);
INSERT INTO "seafarers" VALUES (1996, '', 1, '', 136, 4, 23, 8, 5, 116);
INSERT INTO "seafarers" VALUES (1997, '', 4, '', 77, 77, 5, 60, 57, 75);
INSERT INTO "seafarers" VALUES (1998, '', 2, '', 126, 6, 8, 10, 17, 122);
INSERT INTO "seafarers" VALUES (1999, '', 1, '', 53, NULL, 2, NULL, NULL, 52);
INSERT INTO "seafarers" VALUES (2000, '', 1, '', 89, 19, 14, 9, 13, 71);
INSERT INTO "seafarers" VALUES (2001, '', 6, '', 125, 17, 10, 8, 13, 108);
INSERT INTO "seafarers" VALUES (2002, '', 3, '', 92, 16, 6, 7, 12, 81);
INSERT INTO "seafarers" VALUES (2003, '', 2, '', 91, 67, 12, 45, 45, 79);
INSERT INTO "seafarers" VALUES (2004, '', 4, '', 108, 15, 11, 7, 14, 90);
INSERT INTO "seafarers" VALUES (2005, '', 2, '', 85, 7, 11, 12, 6, 80);
INSERT INTO "seafarers" VALUES (2007, '', 3, '', 128, 9, 36, 8, 5, 95);
INSERT INTO "seafarers" VALUES (2008, '', 2, '', 51, 2, 3, NULL, 3, 45);
INSERT INTO "seafarers" VALUES (2010, '', 4, '', 88, 2, 5, NULL, 3, 82);
INSERT INTO "seafarers" VALUES (2011, '', 1, '', 179, 4, 16, 6, 2, 167);
INSERT INTO "seafarers" VALUES (2012, '', 5, '', 130, 2, 12, 2, 2, 118);
INSERT INTO "seafarers" VALUES (2013, '', 1, '', 130, 3, 6, 5, 4, 125);
INSERT INTO "seafarers" VALUES (2014, '', 5, '', 83, 2, 10, 5, 2, 76);
INSERT INTO "seafarers" VALUES (2015, '', 2, '', 52, 2, 4, 2, 2, 48);
INSERT INTO "seafarers" VALUES (2016, '', 4, '', 104, 6, 6, 6, 2, 102);
INSERT INTO "seafarers" VALUES (2017, '', 1, '', 125, 4, 9, 5, 3, 118);
INSERT INTO "seafarers" VALUES (2018, '', 1, '', 92, 2, 8, 4, 2, 86);
INSERT INTO "seafarers" VALUES (2019, '', 1, '', 143, 5, 5, 1, 3, 136);
INSERT INTO "seafarers" VALUES (2020, '', 2, '', 119, 2, 10, 3, 1, 111);
INSERT INTO "seafarers" VALUES (2021, '', 3, '', 108, 14, 5, NULL, 16, 87);
INSERT INTO "seafarers" VALUES (2022, '', 2, '', 124, 4, 11, 6, 7, 112);
INSERT INTO "seafarers" VALUES (2024, '', 1, '', 168, 2, 7, 1, 2, 160);
INSERT INTO "seafarers" VALUES (2026, '', 2, '', 115, 14, 6, 4, 8, 103);
INSERT INTO "seafarers" VALUES (2027, '', 3, '', 122, 5, 2, NULL, 5, 104);
INSERT INTO "seafarers" VALUES (2028, '', 3, '', 70, 1, NULL, 2, 1, 69);
INSERT INTO "seafarers" VALUES (2029, '', 3, '', 88, 2, 3, 1, 2, 81);
INSERT INTO "seafarers" VALUES (2030, '', 5, '', 138, 9, 3, NULL, 5, 128);
INSERT INTO "seafarers" VALUES (2031, '', 4, '', 147, 5, 12, 10, 5, 138);
INSERT INTO "seafarers" VALUES (2033, '', 2, '', 150, 32, 13, 3, 16, 124);
INSERT INTO "seafarers" VALUES (2034, '', 5, '', 123, 16, 5, 6, 13, 110);
INSERT INTO "seafarers" VALUES (2038, '', 1, '', 112, 5, 14, 4, 3, 99);
INSERT INTO "seafarers" VALUES (2039, '', 2, '', 96, 3, 2, NULL, 1, 93);
INSERT INTO "seafarers" VALUES (2040, '', 5, '', 139, 9, 4, 8, 10, 102);
INSERT INTO "seafarers" VALUES (2041, '', 1, '', 120, 3, 5, 9, 16, 106);
INSERT INTO "seafarers" VALUES (2042, '', 1, '', 95, 2, 1, 1, 1, 94);
INSERT INTO "seafarers" VALUES (2044, '', 1, '', 114, 17, 6, 15, 13, 93);
INSERT INTO "seafarers" VALUES (2046, '', 3, '', 160, 19, 9, 9, 27, 202);
INSERT INTO "seafarers" VALUES (2047, '', 2, '', 97, 3, 1, 1, 6, 91);
INSERT INTO "seafarers" VALUES (2049, '', 2, '', 146, 5, 5, 4, 5, 140);
INSERT INTO "seafarers" VALUES (2050, '', 1, '', 90, 7, 5, 2, 5, 82);
INSERT INTO "seafarers" VALUES (2051, '', 4, '', 73, 3, 5, 3, 3, 68);
INSERT INTO "seafarers" VALUES (2052, '', 6, '', 129, 7, 6, NULL, 2, 119);
INSERT INTO "seafarers" VALUES (2053, '', 2, '', 94, 9, 3, 9, 6, 95);
INSERT INTO "seafarers" VALUES (2054, '', 2, '', 138, 20, 3, 8, 26, 116);
INSERT INTO "seafarers" VALUES (2055, '', 3, '', 82, 11, 1, 2, 12, 76);
INSERT INTO "seafarers" VALUES (2056, '', 2, '', 96, 20, 5, 9, 25, 83);
INSERT INTO "seafarers" VALUES (2057, '', 1, '', 108, 47, 6, 10, 52, 76);
INSERT INTO "seafarers" VALUES (2058, '', 5, '', 105, 7, 10, 3, 20, 90);
INSERT INTO "seafarers" VALUES (2059, '', 4, '', 163, 72, 8, 3, NULL, 114);
INSERT INTO "seafarers" VALUES (2060, '', 2, '', 132, 19, 8, 4, 22, 114);
INSERT INTO "seafarers" VALUES (2061, '', 1, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (2062, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (2063, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (2064, '', 2, '', 50, 4, 5, 5, 5, 45);
INSERT INTO "seafarers" VALUES (2065, '', 1, '', 94, 22, 6, 6, 37, 60);
INSERT INTO "seafarers" VALUES (2066, '', 1, '', 132, 2, 16, 9, 2, 129);
INSERT INTO "seafarers" VALUES (2067, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (2068, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (2069, '', 3, '', 133, 4, 4, 7, 6, 134);
INSERT INTO "seafarers" VALUES (2070, '', 1, '', 148, 18, 15, 4, 23, 123);
INSERT INTO "seafarers" VALUES (2071, '', 1, '', 97, 1, 6, 2, 5, 91);
INSERT INTO "seafarers" VALUES (2072, '', 6, '', 140, 7, 8, 2, 8, 129);
INSERT INTO "seafarers" VALUES (2073, '', 1, '', 91, 4, 5, 3, 13, 76);
INSERT INTO "seafarers" VALUES (2074, '', 6, '', 123, 4, 15, 23, 5, 126);
INSERT INTO "seafarers" VALUES (2075, '', 1, '', 90, 8, 5, 10, 18, 77);
INSERT INTO "seafarers" VALUES (2076, '', 2, '', 164, 13, 14, NULL, 22, 131);
INSERT INTO "seafarers" VALUES (2078, '', 1, '', 131, 7, 17, 11, 9, 116);
INSERT INTO "seafarers" VALUES (2079, '', 3, '', 90, 12, 5, 1, 12, 74);
INSERT INTO "seafarers" VALUES (2081, '', 2, '', 131, 7, 13, 16, 20, 120);
INSERT INTO "seafarers" VALUES (2082, '', 3, '', 144, 6, 34, 20, 16, 114);
INSERT INTO "seafarers" VALUES (2083, '', 4, '', 118, 15, 11, 2, 16, 93);
INSERT INTO "seafarers" VALUES (2084, '', 7, '', 136, 28, 9, 19, 40, 105);
INSERT INTO "seafarers" VALUES (2085, '', 2, '', 124, 4, 16, 3, 5, 106);
INSERT INTO "seafarers" VALUES (2086, '', 4, '', 78, 38, 14, 31, 39, 56);
INSERT INTO "seafarers" VALUES (2087, '', 2, '', 98, 1, 4, 1, 3, 90);
INSERT INTO "seafarers" VALUES (2088, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (2089, '', 1, '', 56, 4, 7, 1, 4, 47);
INSERT INTO "seafarers" VALUES (2090, '', 1, '', 61, 3, 5, NULL, 3, 53);
INSERT INTO "seafarers" VALUES (2091, '', 3, '', 131, 15, 13, 30, 31, 117);
INSERT INTO "seafarers" VALUES (2092, '', 1, '', 167, 6, 31, 5, 13, 128);
INSERT INTO "seafarers" VALUES (2093, '', 1, '', 138, 10, 17, 2, 10, 113);
INSERT INTO "seafarers" VALUES (2094, '', 5, '', 90, 2, 8, 4, 4, 82);
INSERT INTO "seafarers" VALUES (2096, '', 2, '', 158, 4, 8, 6, 4, 152);
INSERT INTO "seafarers" VALUES (2097, '', 2, '', 78, 1, 7, 7, 2, 76);
INSERT INTO "seafarers" VALUES (2098, '', 2, '', 166, 4, 2, 2, 5, 161);
INSERT INTO "seafarers" VALUES (2099, '', 5, '', 97, 1, 7, 2, 1, 91);
INSERT INTO "seafarers" VALUES (2101, '', 2, '', 108, 2, 3, NULL, 4, 101);
INSERT INTO "seafarers" VALUES (2102, '', 4, '', 104, 1, 5, 1, 3, 97);
INSERT INTO "seafarers" VALUES (2103, '', 2, '', 175, 9, 10, 6, 10, 161);
INSERT INTO "seafarers" VALUES (2104, '', 1, '', 197, 3, 61, 4, 3, 137);
INSERT INTO "seafarers" VALUES (2105, '', 1, '', 118, 1, 8, NULL, 12, 97);
INSERT INTO "seafarers" VALUES (2106, '', 6, '', 172, 6, 15, 2, 9, 150);
INSERT INTO "seafarers" VALUES (2107, '', 2, '', 152, 1, 5, 1, 2, 96);
INSERT INTO "seafarers" VALUES (2108, '', 2, '', 148, 2, 1, 6, 2, 152);
INSERT INTO "seafarers" VALUES (2109, '', 3, '', 108, 4, 27, 45, 4, 122);
INSERT INTO "seafarers" VALUES (2110, '', 1, '', 97, NULL, 11, 8, NULL, 94);
INSERT INTO "seafarers" VALUES (2111, '', 2, '', 125, 9, 4, NULL, 12, 109);
INSERT INTO "seafarers" VALUES (2112, '', 1, '', 103, 2, 6, 2, 4, 95);
INSERT INTO "seafarers" VALUES (2114, '', 2, '', 100, 1, 4, 2, 1, 96);
INSERT INTO "seafarers" VALUES (2115, '', 1, '', 100, 1, NULL, NULL, 2, 98);
INSERT INTO "seafarers" VALUES (2116, '', 5, '', 185, 4, 24, 2, 4, 159);
INSERT INTO "seafarers" VALUES (2117, '', 3, '', 104, 4, 4, 3, 4, 99);
INSERT INTO "seafarers" VALUES (2118, '', 2, '', 151, 28, 18, 18, 28, 123);
INSERT INTO "seafarers" VALUES (2119, '', 1, '', 146, 14, 23, 13, 14, 122);
INSERT INTO "seafarers" VALUES (2120, '', 4, '', 158, 14, 18, 14, 15, 139);
INSERT INTO "seafarers" VALUES (2125, '', 1, '', 60, 2, 3, 1, 2, 59);
INSERT INTO "seafarers" VALUES (2126, '', 3, '', 59, 1, 9, 2, 2, 53);
INSERT INTO "seafarers" VALUES (2127, '', 1, '', 111, 1, NULL, 2, 1, 112);
INSERT INTO "seafarers" VALUES (2128, '', 4, '', 162, 4, NULL, 20, 4, 174);
INSERT INTO "seafarers" VALUES (2130, '', 2, '', 105, 2, 1, 1, 3, 101);
INSERT INTO "seafarers" VALUES (2131, '', 4, '', 83, NULL, 3, 1, 1, 80);
INSERT INTO "seafarers" VALUES (2132, '', 7, '', 148, 2, 11, 5, 3, 139);
INSERT INTO "seafarers" VALUES (2134, '', 3, '', 157, 3, 8, 3, 5, 141);
INSERT INTO "seafarers" VALUES (2136, '', 3, '', 157, 6, 8, 2, 6, 145);
INSERT INTO "seafarers" VALUES (2137, '', 1, '', 172, 2, 18, 6, 4, 155);
INSERT INTO "seafarers" VALUES (2138, '', 6, '', 176, 12, 15, 3, 12, 152);
INSERT INTO "seafarers" VALUES (2139, '', 2, '', 139, 2, 1, NULL, 2, 136);
INSERT INTO "seafarers" VALUES (2140, '', 2, '', 101, 4, 3, 21, 5, 109);
INSERT INTO "seafarers" VALUES (2141, '', 7, '', 154, 13, 16, 10, 13, 135);
INSERT INTO "seafarers" VALUES (2142, '', 1, '', 95, 3, 12, 22, 3, 102);
INSERT INTO "seafarers" VALUES (2143, '', 6, '', 145, 16, 16, 10, 21, 116);
INSERT INTO "seafarers" VALUES (2144, '', 6, '', 172, 21, 37, 22, 31, 126);
INSERT INTO "seafarers" VALUES (2145, '', 2, '', 195, 33, 21, 13, 33, 152);
INSERT INTO "seafarers" VALUES (2146, '', 3, '', 104, 29, 16, 37, 30, 95);
INSERT INTO "seafarers" VALUES (2150, '', 1, '', 150, 2, 8, 4, 3, 143);
INSERT INTO "seafarers" VALUES (2152, '', 2, '', 92, 1, 1, 7, 1, 97);
INSERT INTO "seafarers" VALUES (2154, '', 2, '', 156, NULL, 5, 14, 1, 164);
INSERT INTO "seafarers" VALUES (2155, '', 2, '', 100, NULL, 5, 9, NULL, 104);
INSERT INTO "seafarers" VALUES (2156, '', 1, '', 128, 3, 4, 3, 4, 123);
INSERT INTO "seafarers" VALUES (2157, '', 3, '', 188, 5, 11, 20, 5, 192);
INSERT INTO "seafarers" VALUES (2159, '', 2, '', 187, 5, 5, 3, 7, 178);
INSERT INTO "seafarers" VALUES (2160, '', 2, '', 151, 2, 3, 18, 2, 164);
INSERT INTO "seafarers" VALUES (2161, '', 1, '', 107, 2, 5, 8, 2, 108);
INSERT INTO "seafarers" VALUES (2162, '', 7, '', 179, NULL, 14, 1, 1, 162);
INSERT INTO "seafarers" VALUES (2163, '', 3, '', 153, 4, 20, 1, 4, 130);
INSERT INTO "seafarers" VALUES (2164, '', 1, '', 163, NULL, 17, 3, 1, 148);
INSERT INTO "seafarers" VALUES (2165, '', 2, '', 101, 1, 6, 5, 3, 97);
INSERT INTO "seafarers" VALUES (2166, '', 2, '', 101, 3, 3, 7, 3, 105);
INSERT INTO "seafarers" VALUES (2167, '', 5, '', 100, 3, 4, NULL, 2, 97);
INSERT INTO "seafarers" VALUES (2168, '', 2, '', 82, 2, 1, NULL, 2, 79);
INSERT INTO "seafarers" VALUES (2169, '', 3, '', 153, 5, 7, 5, 6, 145);
INSERT INTO "seafarers" VALUES (2170, '', 2, '', 148, 5, 8, 13, 13, 137);
INSERT INTO "seafarers" VALUES (2171, '', 1, '', 109, 4, 3, 3, 4, 99);
INSERT INTO "seafarers" VALUES (2172, '', 3, '', 148, 14, 4, 12, 7, 149);
INSERT INTO "seafarers" VALUES (2173, '', 4, '', 147, 11, 12, 13, 13, 135);
INSERT INTO "seafarers" VALUES (2174, '', 2, '', 64, NULL, 2, 2, NULL, 64);
INSERT INTO "seafarers" VALUES (2175, '', 1, '', 80, NULL, 2, 2, 1, 79);
INSERT INTO "seafarers" VALUES (2176, '', 2, '', 90, 4, 7, NULL, 4, 79);
INSERT INTO "seafarers" VALUES (2177, '', 2, '', 101, 11, 7, 3, 14, 83);
INSERT INTO "seafarers" VALUES (2178, '', 7, '', 185, 10, 19, 6, 10, 162);
INSERT INTO "seafarers" VALUES (2180, '', 3, '', 142, 3, 4, 3, 1, 140);
INSERT INTO "seafarers" VALUES (2181, '', 2, '', 158, 5, 3, 7, 5, 157);
INSERT INTO "seafarers" VALUES (2182, '', 2, '', 169, 3, 12, 8, 3, 162);
INSERT INTO "seafarers" VALUES (2183, '', 3, '', 108, 2, 7, 2, 2, 101);
INSERT INTO "seafarers" VALUES (2184, '', 2, '', 174, 3, 15, 11, 6, 164);
INSERT INTO "seafarers" VALUES (2185, '', 4, '', 104, 3, 12, 4, 3, 93);
INSERT INTO "seafarers" VALUES (2187, '', 4, '', 137, NULL, 4, 10, 2, 141);
INSERT INTO "seafarers" VALUES (2188, '', 3, '', 144, 6, 14, 4, 4, 127);
INSERT INTO "seafarers" VALUES (2189, '', 2, '', 103, 9, 16, 15, 10, 92);
INSERT INTO "seafarers" VALUES (2190, '', 3, '', 124, 2, 7, 7, 3, 122);
INSERT INTO "seafarers" VALUES (2191, '', 2, '', 59, NULL, NULL, NULL, 4, 55);
INSERT INTO "seafarers" VALUES (2193, '', 1, '', 134, 1, 12, 16, 5, 133);
INSERT INTO "seafarers" VALUES (2194, '', 2, '', 99, 8, 24, 22, 9, 88);
INSERT INTO "seafarers" VALUES (2195, '', 6, '', 182, 9, 32, 21, 10, 161);
INSERT INTO "seafarers" VALUES (2196, '', 3, '', 103, 2, 4, NULL, 2, 97);
INSERT INTO "seafarers" VALUES (2198, '', 1, '', 102, NULL, 2, NULL, NULL, 100);
INSERT INTO "seafarers" VALUES (2200, '', 1, '', 123, 2, 8, 2, 2, 116);
INSERT INTO "seafarers" VALUES (2201, '', 1, '', 54, NULL, 4, 3, NULL, 53);
INSERT INTO "seafarers" VALUES (2202, '', 4, '', 85, 1, 4, NULL, 1, 80);
INSERT INTO "seafarers" VALUES (2203, '', 2, '', 132, 3, 6, NULL, 6, 120);
INSERT INTO "seafarers" VALUES (2204, '', 2, '', 93, 3, 3, 3, 3, 90);
INSERT INTO "seafarers" VALUES (2205, '', 1, '', 94, NULL, 2, 1, NULL, 93);
INSERT INTO "seafarers" VALUES (2206, '', 4, '', 140, 1, 6, 1, 2, 134);
INSERT INTO "seafarers" VALUES (2207, '', 3, '', 95, 1, 6, 3, 2, 96);
INSERT INTO "seafarers" VALUES (2209, '', 1, '', 132, NULL, 8, 7, 1, 130);
INSERT INTO "seafarers" VALUES (2210, '', 2, '', 94, NULL, 5, 2, NULL, 91);
INSERT INTO "seafarers" VALUES (2211, '', 3, '', 147, NULL, 6, 3, NULL, 144);
INSERT INTO "seafarers" VALUES (2212, '', 2, '', 106, 3, 2, 1, 4, 101);
INSERT INTO "seafarers" VALUES (2213, '', 4, '', 162, 1, 7, 5, 1, 159);
INSERT INTO "seafarers" VALUES (2214, '', 8, '', 131, NULL, 4, 4, 2, 129);
INSERT INTO "seafarers" VALUES (2215, '', 5, '', 130, 1, 13, 4, 1, 120);
INSERT INTO "seafarers" VALUES (2216, '', 2, '', 95, 1, 3, 5, 1, 96);
INSERT INTO "seafarers" VALUES (2217, '', 1, '', 80, 4, 5, 5, 5, 75);
INSERT INTO "seafarers" VALUES (2218, '', 3, '', 139, 1, 15, 2, 1, 129);
INSERT INTO "seafarers" VALUES (2219, '', 3, '', 129, 7, 8, 7, 4, 124);
INSERT INTO "seafarers" VALUES (2220, '', 3, '', 136, 7, 9, 3, 8, 122);
INSERT INTO "seafarers" VALUES (2221, '', 1, '', 92, 4, 5, 4, 3, 88);
INSERT INTO "seafarers" VALUES (2222, '', 2, '', 151, 9, 8, 3, 9, 137);
INSERT INTO "seafarers" VALUES (2223, '', 1, '', 94, NULL, 3, 2, 4, 89);
INSERT INTO "seafarers" VALUES (2224, '', 1, '', 133, NULL, 11, 3, NULL, 125);
INSERT INTO "seafarers" VALUES (2225, '', 1, '', 149, NULL, 9, 6, NULL, 146);
INSERT INTO "seafarers" VALUES (2226, '', 3, '', 75, 1, 3, NULL, 1, 71);
INSERT INTO "seafarers" VALUES (2227, '', 1, '', 151, NULL, 14, 5, NULL, 137);
INSERT INTO "seafarers" VALUES (2228, '', 4, '', 96, 3, 7, 2, 3, 88);
INSERT INTO "seafarers" VALUES (2229, '', 2, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (2230, '', 2, '', 103, 1, 8, 1, 1, 95);
INSERT INTO "seafarers" VALUES (2231, '', 3, '', 95, 5, 4, 2, 2, 91);
INSERT INTO "seafarers" VALUES (2232, '', 3, '', 96, 3, 3, NULL, 3, 91);
INSERT INTO "seafarers" VALUES (2234, '', 3, '', 152, 5, 8, 7, 3, 148);
INSERT INTO "seafarers" VALUES (2235, '', 3, '', 93, 7, 4, 1, 7, 83);
INSERT INTO "seafarers" VALUES (2236, '', 3, '', 96, NULL, 6, 12, NULL, 102);
INSERT INTO "seafarers" VALUES (2237, '', 3, '', 131, NULL, 1, 1, NULL, 131);
INSERT INTO "seafarers" VALUES (2238, '', 3, '', 92, 2, 6, 2, 2, 86);
INSERT INTO "seafarers" VALUES (2239, '', 1, '', 90, 4, 1, 1, 4, 86);
INSERT INTO "seafarers" VALUES (2240, '', 2, '', 132, 2, 6, 5, 3, 128);
INSERT INTO "seafarers" VALUES (2241, '', 3, '', 94, 2, 11, 10, 2, 94);
INSERT INTO "seafarers" VALUES (2243, '', 6, '', 131, 4, 8, 7, 4, 126);
INSERT INTO "seafarers" VALUES (2244, '', 7, '', 132, 2, 5, 3, 3, 119);
INSERT INTO "seafarers" VALUES (2245, '', 4, '', 130, 3, 1, 1, 3, 127);
INSERT INTO "seafarers" VALUES (2246, '', 1, '', 95, 7, 5, 5, 4, 91);
INSERT INTO "seafarers" VALUES (2247, '', 4, '', 128, 1, 8, 2, 1, 121);
INSERT INTO "seafarers" VALUES (2248, '', 3, '', 99, 12, 9, 3, 9, 82);
INSERT INTO "seafarers" VALUES (2249, '', 3, '', 99, 7, 6, 2, 5, 89);
INSERT INTO "seafarers" VALUES (2250, '', 5, '', 134, 18, 12, 11, 22, 111);
INSERT INTO "seafarers" VALUES (2251, '', 5, '', 105, 13, 8, 3, 11, 94);
INSERT INTO "seafarers" VALUES (2252, '', 1, '', 131, 2, 12, 8, 2, 125);
INSERT INTO "seafarers" VALUES (2253, '', 1, '', 133, 5, 4, 5, 5, 127);
INSERT INTO "seafarers" VALUES (2254, '', 4, '', 146, 4, 4, 3, 4, 141);
INSERT INTO "seafarers" VALUES (2255, '', 1, '', 83, NULL, NULL, NULL, NULL, 83);
INSERT INTO "seafarers" VALUES (2256, '', 2, '', 151, 1, 5, 6, 1, 154);
INSERT INTO "seafarers" VALUES (2257, '', 1, '', 168, 4, 19, 16, 4, 161);
INSERT INTO "seafarers" VALUES (2258, '', 5, '', 112, 2, 3, 4, 1, 112);
INSERT INTO "seafarers" VALUES (2259, '', 2, '', 50, NULL, NULL, 5, NULL, 53);
INSERT INTO "seafarers" VALUES (2260, '', 3, '', 167, 5, 2, 3, 7, 161);
INSERT INTO "seafarers" VALUES (2261, '', 5, '', 157, 3, 9, 5, 3, 150);
INSERT INTO "seafarers" VALUES (2262, '', 3, '', 117, 6, 2, 1, 5, 111);
INSERT INTO "seafarers" VALUES (2263, '', 2, '', 119, 2, 4, NULL, 2, 113);
INSERT INTO "seafarers" VALUES (2264, '', 1, '', 101, 2, 5, 6, 3, 99);
INSERT INTO "seafarers" VALUES (2265, '', 6, '', 150, NULL, NULL, NULL, 3, 147);
INSERT INTO "seafarers" VALUES (2266, '', 4, '', 165, 2, 8, 4, 3, 158);
INSERT INTO "seafarers" VALUES (2267, '', 5, '', 174, 1, 6, NULL, 4, 165);
INSERT INTO "seafarers" VALUES (2269, '', 2, '', 149, 4, 11, 6, 1, 143);
INSERT INTO "seafarers" VALUES (2270, '', 7, '', 176, 5, 12, 6, 5, 165);
INSERT INTO "seafarers" VALUES (2271, '', 7, '', 146, 3, 5, 9, 3, 147);
INSERT INTO "seafarers" VALUES (2272, '', 3, '', 115, 3, 8, 12, 3, 116);
INSERT INTO "seafarers" VALUES (2273, '', 3, '', 175, 2, 9, 10, 2, 174);
INSERT INTO "seafarers" VALUES (2274, '', 1, '', 91, NULL, 3, 1, NULL, 89);
INSERT INTO "seafarers" VALUES (2275, '', 1, '', 155, 2, 3, 2, 6, 148);
INSERT INTO "seafarers" VALUES (2276, '', 1, '', 113, 3, 4, 3, 3, 109);
INSERT INTO "seafarers" VALUES (2277, '', 1, '', 79, NULL, 3, 3, NULL, 79);
INSERT INTO "seafarers" VALUES (2278, '', 4, '', 150, 2, 8, 3, 11, 134);
INSERT INTO "seafarers" VALUES (2279, '', 4, '', 113, 10, 8, 11, 9, 107);
INSERT INTO "seafarers" VALUES (2280, '', 3, '', 148, 1, 9, 4, 1, 142);
INSERT INTO "seafarers" VALUES (2281, '', 3, '', 118, 2, 11, NULL, 2, 105);
INSERT INTO "seafarers" VALUES (2283, '', 1, '', 154, 7, 13, NULL, 7, 131);
INSERT INTO "seafarers" VALUES (2284, '', 3, '', 110, 1, 1, NULL, 2, 105);
INSERT INTO "seafarers" VALUES (2286, '', 2, '', 166, 3, 36, 2, 3, 129);
INSERT INTO "seafarers" VALUES (2287, '', 4, '', 162, NULL, 3, 1, NULL, 160);
INSERT INTO "seafarers" VALUES (2288, '', 1, '', 94, 2, 4, 5, 4, 91);
INSERT INTO "seafarers" VALUES (2289, '', 1, '', 92, 3, 3, 4, 3, 90);
INSERT INTO "seafarers" VALUES (2290, '', 4, '', 118, NULL, 4, 1, NULL, 115);
INSERT INTO "seafarers" VALUES (2291, '', 5, '', 125, 6, 4, 1, 4, 118);
INSERT INTO "seafarers" VALUES (2292, '', 1, '', 154, 1, 2, NULL, 1, 151);
INSERT INTO "seafarers" VALUES (2293, '', 4, '', 114, 5, 2, 3, 5, 110);
INSERT INTO "seafarers" VALUES (2294, '', 2, '', 110, 1, 3, 4, 1, 110);
INSERT INTO "seafarers" VALUES (2296, '', 4, '', 188, 3, 4, NULL, 2, 182);
INSERT INTO "seafarers" VALUES (2297, '', 2, '', 182, 5, 4, 1, 5, 174);
INSERT INTO "seafarers" VALUES (2298, '', 4, '', 116, 14, 7, 4, 8, 105);
INSERT INTO "seafarers" VALUES (2299, '', 2, '', 184, 4, 11, 6, 4, 125);
INSERT INTO "seafarers" VALUES (2300, '', 3, '', 149, 6, 14, 4, 4, 135);
INSERT INTO "seafarers" VALUES (2301, '', 1, '', 117, 4, 1, 5, 4, 117);
INSERT INTO "seafarers" VALUES (2302, '', 3, '', 155, 2, 3, 4, 2, 154);
INSERT INTO "seafarers" VALUES (2303, '', 2, '', 113, 7, 13, 17, 9, 108);
INSERT INTO "seafarers" VALUES (2304, '', 4, '', 152, 1, 8, 2, 4, 142);
INSERT INTO "seafarers" VALUES (2306, '', 1, '', 81, 22, 12, 24, 22, 72);
INSERT INTO "seafarers" VALUES (2307, '', 1, '', 157, 45, 9, 3, 34, 116);
INSERT INTO "seafarers" VALUES (2308, '', 4, '', 118, 11, 8, 8, 9, 109);
INSERT INTO "seafarers" VALUES (2309, '', 4, '', 113, 12, 7, 7, 12, 101);
INSERT INTO "seafarers" VALUES (2310, '', 1, '', 171, 9, 28, 18, 7, 154);
INSERT INTO "seafarers" VALUES (2311, '', 1, '', 116, 6, 9, NULL, 6, 114);
INSERT INTO "seafarers" VALUES (2312, '', 1, '', 155, 5, 10, 1, 14, 132);
INSERT INTO "seafarers" VALUES (2313, '', 4, '', 149, 3, 4, 5, 4, 146);
INSERT INTO "seafarers" VALUES (2314, '', 4, '', 155, 15, 17, 3, 16, 125);
INSERT INTO "seafarers" VALUES (2315, '', 2, '', 89, 8, 5, 4, 6, 82);
INSERT INTO "seafarers" VALUES (2316, '', 3, '', 151, 10, 38, 32, 10, 135);
INSERT INTO "seafarers" VALUES (2317, '', 3, '', 119, 7, 10, NULL, 7, 102);
INSERT INTO "seafarers" VALUES (2318, '', 1, '', 151, 5, 19, 5, 3, 134);
INSERT INTO "seafarers" VALUES (2319, '', 3, '', 52, NULL, 1, 1, NULL, 52);
INSERT INTO "seafarers" VALUES (2320, '', 1, '', 114, 7, 3, 1, 6, 106);
INSERT INTO "seafarers" VALUES (2321, '', 2, '', 169, 8, 3, 2, 4, 164);
INSERT INTO "seafarers" VALUES (2322, '', 1, '', 120, 2, 3, 2, 1, 118);
INSERT INTO "seafarers" VALUES (2323, '', 2, '', 162, 12, 10, 10, 10, 152);
INSERT INTO "seafarers" VALUES (2324, '', 4, '', 151, 3, 9, 3, 4, 143);
INSERT INTO "seafarers" VALUES (2325, '', 1, '', 177, 24, 10, 4, 19, 152);
INSERT INTO "seafarers" VALUES (2326, '', 2, '', 120, 5, 7, 2, 4, 111);
INSERT INTO "seafarers" VALUES (2327, '', 2, '', 124, 2, 1, 1, 3, 121);
INSERT INTO "seafarers" VALUES (2328, '', 2, '', 127, 10, 9, 11, 19, 110);
INSERT INTO "seafarers" VALUES (2329, '', 7, '', 169, 22, 4, 3, 15, 153);
INSERT INTO "seafarers" VALUES (2330, '', 6, '', 83, 1, 1, 14, 1, 95);
INSERT INTO "seafarers" VALUES (2331, '', 2, '', 194, 5, 11, 4, 5, 182);
INSERT INTO "seafarers" VALUES (2332, '', 2, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (2333, '', 4, '', 120, 2, 4, 8, 3, 121);
INSERT INTO "seafarers" VALUES (2334, '', 2, '', 130, 8, 9, 13, 8, 126);
INSERT INTO "seafarers" VALUES (2335, '', 8, '', 197, 12, 11, 5, 5, 186);
INSERT INTO "seafarers" VALUES (2336, '', 4, '', 196, 9, 14, 1, 9, 174);
INSERT INTO "seafarers" VALUES (2337, '', 1, '', 168, 3, 12, 1, 4, 153);
INSERT INTO "seafarers" VALUES (2338, '', 3, '', 167, 2, 8, NULL, 10, 149);
INSERT INTO "seafarers" VALUES (2339, '', 5, '', 165, 1, 1, 6, 1, 169);
INSERT INTO "seafarers" VALUES (2340, '', 3, '', 150, 4, 14, 6, 4, 138);
INSERT INTO "seafarers" VALUES (2341, '', 1, '', 109, 4, 4, 7, 3, 109);
INSERT INTO "seafarers" VALUES (2342, '', 2, '', 117, 10, 33, 13, 28, 139);
INSERT INTO "seafarers" VALUES (2343, '', 4, '', 120, 2, 9, 7, 2, 116);
INSERT INTO "seafarers" VALUES (2344, '', 1, '', 114, 27, 9, 4, 15, 94);
INSERT INTO "seafarers" VALUES (2345, '', 1, '', 130, 6, 5, 8, 5, 128);
INSERT INTO "seafarers" VALUES (2346, '', 1, '', 135, 1, 2, 1, 1, 134);
INSERT INTO "seafarers" VALUES (2347, '', 2, '', 117, 2, 25, 3, 3, 92);
INSERT INTO "seafarers" VALUES (2348, '', 2, '', 84, 2, 5, NULL, 2, 77);
INSERT INTO "seafarers" VALUES (2350, '', 1, '', 118, 4, 2, 4, 4, 116);
INSERT INTO "seafarers" VALUES (2351, '', 5, '', 160, 3, 10, 1, 3, 148);
INSERT INTO "seafarers" VALUES (2352, '', 2, '', 48, 2, 1, 24, 20, 51);
INSERT INTO "seafarers" VALUES (2353, '', 5, '', 187, 53, 33, 13, 28, 139);
INSERT INTO "seafarers" VALUES (2354, '', 1, '', 124, 1, 2, 3, 1, 124);
INSERT INTO "seafarers" VALUES (2355, '', 1, '', 171, 10, 17, NULL, 12, 142);
INSERT INTO "seafarers" VALUES (2356, '', 6, '', 79, 1, 6, 2, 1, 74);
INSERT INTO "seafarers" VALUES (2357, '', 2, '', 124, 7, 11, NULL, 5, 108);
INSERT INTO "seafarers" VALUES (2358, '', 2, '', 155, 8, 5, NULL, 8, 141);
INSERT INTO "seafarers" VALUES (2359, '', 2, '', 157, 4, 4, 3, 4, 152);
INSERT INTO "seafarers" VALUES (2360, '', 2, '', 110, 24, 18, 3, 8, 87);
INSERT INTO "seafarers" VALUES (2361, '', 1, '', 181, 24, 19, 11, 20, 150);
INSERT INTO "seafarers" VALUES (2362, '', 2, '', 108, 17, 8, 1, 14, 86);
INSERT INTO "seafarers" VALUES (2363, '', 3, '', 183, 24, 28, 10, 14, 149);
INSERT INTO "seafarers" VALUES (2365, '', 6, '', 193, 56, 4, 6, 30, 158);
INSERT INTO "seafarers" VALUES (2366, '', 2, '', 73, 6, NULL, NULL, 6, 66);
INSERT INTO "seafarers" VALUES (2367, '', 2, '', 162, 32, 14, 6, 109, 47);
INSERT INTO "seafarers" VALUES (2368, '', 4, '', 151, 42, 2, 2, 42, 91);
INSERT INTO "seafarers" VALUES (2369, '', 2, '', 146, 8, 8, 6, 8, 135);
INSERT INTO "seafarers" VALUES (2370, '', 3, '', 176, 7, 11, 1, 7, 159);
INSERT INTO "seafarers" VALUES (2371, '', 3, '', 107, 6, 5, 2, 6, 99);
INSERT INTO "seafarers" VALUES (2373, '', 4, '', 157, 29, 11, 3, 19, 125);
INSERT INTO "seafarers" VALUES (2375, '', 5, '', 143, 3, 14, NULL, 16, 110);
INSERT INTO "seafarers" VALUES (2376, '', 1, '', 114, 5, 4, NULL, 6, 104);
INSERT INTO "seafarers" VALUES (2377, '', 4, '', 178, 11, 17, 7, 67, 131);
INSERT INTO "seafarers" VALUES (2378, '', 3, '', 114, 20, 16, 24, 34, 88);
INSERT INTO "seafarers" VALUES (2379, '', 1, '', 156, 16, 4, 1, 35, 118);
INSERT INTO "seafarers" VALUES (2381, '', 1, '', 110, 10, 12, 4, 9, 93);
INSERT INTO "seafarers" VALUES (2382, '', 3, '', 61, 2, 3, 7, 2, 63);
INSERT INTO "seafarers" VALUES (2383, '', 1, '', 128, 7, 5, 8, 8, 123);
INSERT INTO "seafarers" VALUES (2384, '', 5, '', 106, 3, 5, 1, 14, 88);
INSERT INTO "seafarers" VALUES (2385, '', 1, '', 142, 2, 11, 5, 5, 131);
INSERT INTO "seafarers" VALUES (2386, '', 1, '', 78, 9, 8, 15, 33, 52);
INSERT INTO "seafarers" VALUES (2387, '', 5, '', 171, 12, 22, 19, 19, 149);
INSERT INTO "seafarers" VALUES (2388, '', 1, '', 76, 13, 16, 25, 16, 69);
INSERT INTO "seafarers" VALUES (2389, '', 1, '', 183, 6, 28, 4, 8, 151);
INSERT INTO "seafarers" VALUES (2390, '', 1, '', 110, 4, 2, NULL, 2, 106);
INSERT INTO "seafarers" VALUES (2391, '', 4, '', 75, NULL, 3, NULL, NULL, 72);
INSERT INTO "seafarers" VALUES (2392, '', 1, '', 148, 9, 2, NULL, 6, 140);
INSERT INTO "seafarers" VALUES (2393, '', 5, '', 148, 6, 4, 3, 6, 141);
INSERT INTO "seafarers" VALUES (2394, '', 2, '', 187, 9, 7, 1, 9, 163);
INSERT INTO "seafarers" VALUES (2395, '', 1, '', 108, NULL, 1, NULL, 1, 107);
INSERT INTO "seafarers" VALUES (2396, '', 1, '', 104, 9, 9, NULL, 10, 85);
INSERT INTO "seafarers" VALUES (2397, '', 1, '', 148, 34, 34, 5, 17, 102);
INSERT INTO "seafarers" VALUES (2398, '', 4, '', 103, 11, 8, 12, 8, 99);
INSERT INTO "seafarers" VALUES (2399, '', 3, '', 114, 7, 4, NULL, 5, 105);
INSERT INTO "seafarers" VALUES (2400, '', 6, '', 162, 4, 1, NULL, 2, 159);
INSERT INTO "seafarers" VALUES (2401, '', 2, '', 152, 7, 19, 4, 7, 130);
INSERT INTO "seafarers" VALUES (2402, '', 2, '', 114, 4, 1, 2, 5, 110);
INSERT INTO "seafarers" VALUES (2404, '', 5, '', 148, 13, 5, 4, 7, 140);
INSERT INTO "seafarers" VALUES (2405, '', 3, '', 108, 19, 12, 4, 13, 92);
INSERT INTO "seafarers" VALUES (2406, '', 3, '', 108, 2, 2, 3, NULL, 109);
INSERT INTO "seafarers" VALUES (2407, '', 4, '', 104, 12, 12, 2, 10, 84);
INSERT INTO "seafarers" VALUES (2408, '', 2, '', 186, 18, 20, 6, 14, 158);
INSERT INTO "seafarers" VALUES (2410, '', 3, '', 184, 21, 15, 10, 22, 157);
INSERT INTO "seafarers" VALUES (2412, '', 5, '', 123, 37, 10, NULL, 32, 81);
INSERT INTO "seafarers" VALUES (2415, '', 4, '', 109, 10, 12, NULL, 6, 91);
INSERT INTO "seafarers" VALUES (2416, '', 1, '', 119, 8, 21, 9, 9, 100);
INSERT INTO "seafarers" VALUES (2417, '', 5, '', 180, 54, 49, 18, 28, 113);
INSERT INTO "seafarers" VALUES (2418, '', 4, '', 145, 14, 21, 10, 31, 103);
INSERT INTO "seafarers" VALUES (2419, '', 1, '', 108, 6, 15, NULL, 13, 80);
INSERT INTO "seafarers" VALUES (2420, '', 3, '', 147, 11, 24, NULL, 10, 105);
INSERT INTO "seafarers" VALUES (2421, '', 3, '', 144, 5, 9, NULL, 10, 126);
INSERT INTO "seafarers" VALUES (2422, '', 1, '', 148, 12, 12, 2, 30, 108);
INSERT INTO "seafarers" VALUES (2423, '', 4, '', 119, 60, 18, 24, 39, 87);
INSERT INTO "seafarers" VALUES (2424, '', 4, '', 109, 14, 16, 1, 10, 84);
INSERT INTO "seafarers" VALUES (2425, '', 3, '', 79, 6, 4, NULL, 7, 68);
INSERT INTO "seafarers" VALUES (2426, '', 6, '', 154, 33, 51, 10, 23, 90);
INSERT INTO "seafarers" VALUES (2427, '', 4, '', 155, 29, 39, 19, 32, 119);
INSERT INTO "seafarers" VALUES (2428, '', 4, '', 147, 12, 26, NULL, 19, 102);
INSERT INTO "seafarers" VALUES (2429, '', 1, '', 175, 32, 42, 45, 48, 130);
INSERT INTO "seafarers" VALUES (2431, '', 5, '', 76, 4, 10, 7, 4, 69);
INSERT INTO "seafarers" VALUES (2432, '', 3, '', 148, 22, 19, 12, 19, 122);
INSERT INTO "seafarers" VALUES (2433, '', 2, '', 81, 9, 1, 1, 10, 73);
INSERT INTO "seafarers" VALUES (2434, '', 2, '', 97, 15, 4, NULL, 10, 83);
INSERT INTO "seafarers" VALUES (2435, '', 1, '', 150, 34, 8, 12, 28, 126);
INSERT INTO "seafarers" VALUES (2436, '', 2, '', 111, 7, 14, NULL, 7, 90);
INSERT INTO "seafarers" VALUES (2437, '', 4, '', 183, 93, 13, 35, 48, 145);
INSERT INTO "seafarers" VALUES (2438, '', 1, '', 111, 2, 6, NULL, 4, 101);
INSERT INTO "seafarers" VALUES (2439, '', 1, '', 150, 19, 6, 9, 12, 141);
INSERT INTO "seafarers" VALUES (2440, '', 5, '', 119, 12, 11, NULL, 8, 100);
INSERT INTO "seafarers" VALUES (2441, '', 3, '', 60, 4, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (2443, '', 2, '', 193, 40, 14, 16, 19, 160);
INSERT INTO "seafarers" VALUES (2444, '', 2, '', 156, 26, 21, 3, 18, 120);
INSERT INTO "seafarers" VALUES (2445, '', 2, '', 157, 40, 9, 9, 20, 137);
INSERT INTO "seafarers" VALUES (2446, '', 6, '', 145, 14, 6, 2, 22, 119);
INSERT INTO "seafarers" VALUES (2447, '', 3, '', 106, 12, 11, 2, 9, 88);
INSERT INTO "seafarers" VALUES (2449, '', 6, '', 149, 12, 14, NULL, 17, 118);
INSERT INTO "seafarers" VALUES (2450, '', 2, '', 78, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (2451, '', 4, '', 190, 49, 19, 10, 19, 162);
INSERT INTO "seafarers" VALUES (2452, '', 5, '', 153, 3, 15, 6, 6, 138);
INSERT INTO "seafarers" VALUES (2453, '', 5, '', 138, 1, 6, NULL, 1, 131);
INSERT INTO "seafarers" VALUES (2454, '', 1, '', 97, 8, 7, NULL, 18, 72);
INSERT INTO "seafarers" VALUES (2456, '', 3, '', 110, 24, 5, 9, 12, 102);
INSERT INTO "seafarers" VALUES (2457, '', 1, '', 115, 26, 18, 13, 20, 89);
INSERT INTO "seafarers" VALUES (2458, '', 2, '', 113, 9, 9, 1, 15, 91);
INSERT INTO "seafarers" VALUES (2459, '', 2, '', 171, 11, 5, 2, 9, 159);
INSERT INTO "seafarers" VALUES (2460, '', 7, '', 111, 15, 15, 10, 18, 88);
INSERT INTO "seafarers" VALUES (2461, '', 1, '', 147, 26, 25, 17, 26, 113);
INSERT INTO "seafarers" VALUES (2463, '', 5, '', 108, 21, 30, 31, 21, 89);
INSERT INTO "seafarers" VALUES (2465, '', 1, '', 150, 8, 16, NULL, 8, 126);
INSERT INTO "seafarers" VALUES (2466, '', 1, '', 156, 4, 15, 1, 6, 136);
INSERT INTO "seafarers" VALUES (2470, '', 2, '', 77, 4, 5, 8, 6, 73);
INSERT INTO "seafarers" VALUES (2471, '', 5, '', 150, 26, 12, 5, 16, 127);
INSERT INTO "seafarers" VALUES (2473, '', 4, '', 98, 2, 1, NULL, 2, 97);
INSERT INTO "seafarers" VALUES (2474, '', 2, '', 158, 5, 18, NULL, 4, 136);
INSERT INTO "seafarers" VALUES (2478, '', 2, '', 94, 3, 11, 9, 19, 65);
INSERT INTO "seafarers" VALUES (2480, '', 7, '', 163, 23, 20, 4, 15, 132);
INSERT INTO "seafarers" VALUES (2481, '', 1, '', 126, 10, 22, 39, 10, 133);
INSERT INTO "seafarers" VALUES (2482, '', 3, '', 157, 30, 7, NULL, 14, 136);
INSERT INTO "seafarers" VALUES (2486, '', 2, '', 93, 1, 7, 5, 3, 88);
INSERT INTO "seafarers" VALUES (2491, '', 3, '', 158, 11, 9, 1, 8, 142);
INSERT INTO "seafarers" VALUES (2493, '', 2, '', 140, 5, 11, 41, 17, 156);
INSERT INTO "seafarers" VALUES (2496, '', 1, '', 83, 1, NULL, 46, 7, 127);
INSERT INTO "seafarers" VALUES (2497, '', 5, '', 170, 55, 39, 23, 46, 105);
INSERT INTO "seafarers" VALUES (2498, '', 4, '', 122, 72, 15, 39, 32, 123);
INSERT INTO "seafarers" VALUES (2499, '', 1, '', 147, 21, 19, 34, 30, 132);
INSERT INTO "seafarers" VALUES (2500, '', 1, '', 131, 17, 18, 13, 29, 97);
INSERT INTO "seafarers" VALUES (2501, '', 2, '', 84, 4, 8, 15, 5, 86);
INSERT INTO "seafarers" VALUES (2502, '', 1, '', 160, 12, 30, 33, 13, 150);
INSERT INTO "seafarers" VALUES (2503, '', 1, '', 130, 32, 25, 46, 17, 134);
INSERT INTO "seafarers" VALUES (2504, '', 4, '', 92, 14, 15, 12, 15, 74);
INSERT INTO "seafarers" VALUES (2505, '', 3, '', 82, 12, 2, 22, 9, 93);
INSERT INTO "seafarers" VALUES (2506, '', 3, '', 98, 17, 25, 24, 10, 87);
INSERT INTO "seafarers" VALUES (2507, '', 1, '', 97, 16, 17, 20, 14, 86);
INSERT INTO "seafarers" VALUES (2508, '', 1, '', 92, 5, 13, 21, 14, 86);
INSERT INTO "seafarers" VALUES (2509, '', 4, '', 90, 14, 13, 5, 12, 70);
INSERT INTO "seafarers" VALUES (2510, '', 4, '', 89, 3, 2, 5, 3, 89);
INSERT INTO "seafarers" VALUES (2511, '', 6, '', 159, 12, 21, 16, 8, 146);
INSERT INTO "seafarers" VALUES (2512, '', 2, '', 79, NULL, 2, NULL, NULL, 77);
INSERT INTO "seafarers" VALUES (2513, '', 3, '', 136, 22, 15, 21, 35, 107);
INSERT INTO "seafarers" VALUES (2514, '', 2, '', 107, 1, 1, NULL, 1, 105);
INSERT INTO "seafarers" VALUES (2515, '', 7, '', 153, 1, 3, 2, 2, 151);
INSERT INTO "seafarers" VALUES (2516, '', 3, '', 134, 1, 12, 2, 1, 123);
INSERT INTO "seafarers" VALUES (2517, '', 2, '', 142, NULL, 4, NULL, 2, 136);
INSERT INTO "seafarers" VALUES (2518, '', 1, '', 162, 1, 1, 1, 1, 161);
INSERT INTO "seafarers" VALUES (2519, '', 2, '', 94, NULL, 2, NULL, NULL, 93);
INSERT INTO "seafarers" VALUES (2521, '', 6, '', 92, 1, 4, NULL, 1, 87);
INSERT INTO "seafarers" VALUES (2522, '', 4, '', 69, 1, 2, 19, 1, 76);
INSERT INTO "seafarers" VALUES (2523, '', 1, '', 120, 7, 5, NULL, 7, 108);
INSERT INTO "seafarers" VALUES (2524, '', 3, '', 87, NULL, 1, NULL, NULL, 86);
INSERT INTO "seafarers" VALUES (2525, '', 1, '', 96, 2, 2, NULL, 2, 92);
INSERT INTO "seafarers" VALUES (2526, '', 5, '', 163, NULL, NULL, NULL, 3, 160);
INSERT INTO "seafarers" VALUES (2527, '', 1, '', 73, 1, 1, NULL, 2, 70);
INSERT INTO "seafarers" VALUES (2528, '', 1, '', 68, 1, 3, 2, 1, 66);
INSERT INTO "seafarers" VALUES (2529, '', 2, '', 98, 1, 2, 4, 1, 99);
INSERT INTO "seafarers" VALUES (2530, '', 4, '', 100, 1, 3, 6, 4, 99);
INSERT INTO "seafarers" VALUES (2531, '', 6, '', 141, 5, 7, 9, 6, 138);
INSERT INTO "seafarers" VALUES (2532, '', 1, '', 173, 6, 6, 7, 4, 171);
INSERT INTO "seafarers" VALUES (2533, '', 7, '', 142, 3, 4, 1, 5, 134);
INSERT INTO "seafarers" VALUES (2535, '', 2, '', 102, 3, 2, NULL, NULL, 100);
INSERT INTO "seafarers" VALUES (2536, '', 1, '', 130, NULL, 1, 1, NULL, 130);
INSERT INTO "seafarers" VALUES (2537, '', 1, '', 148, 2, 2, NULL, 3, 143);
INSERT INTO "seafarers" VALUES (2538, '', 3, '', 91, 4, 6, 7, 4, 90);
INSERT INTO "seafarers" VALUES (2539, '', 3, '', 91, 10, 7, 9, 9, 81);
INSERT INTO "seafarers" VALUES (2540, '', 4, '', 95, 12, 12, 8, 10, 90);
INSERT INTO "seafarers" VALUES (2541, '', 1, '', 88, 5, 7, 6, 3, 84);
INSERT INTO "seafarers" VALUES (2542, '', 4, '', 86, NULL, 4, 5, 2, 86);
INSERT INTO "seafarers" VALUES (2544, '', 2, '', 91, NULL, NULL, 1, NULL, 92);
INSERT INTO "seafarers" VALUES (2546, '', 3, '', 104, 3, 8, 1, 4, 93);
INSERT INTO "seafarers" VALUES (2548, '', 1, '', 59, 1, 4, 6, 1, 61);
INSERT INTO "seafarers" VALUES (2549, '', 6, '', 91, 16, 7, 11, 16, 81);
INSERT INTO "seafarers" VALUES (2550, '', 1, '', 132, 2, 2, NULL, 2, 125);
INSERT INTO "seafarers" VALUES (2559, '', 6, '', 152, 5, 9, 3, 6, 139);
INSERT INTO "seafarers" VALUES (2560, '', 3, '', 158, 1, 14, 5, 1, 144);
INSERT INTO "seafarers" VALUES (2561, '', 2, '', 186, 12, 18, 18, 7, 179);
INSERT INTO "seafarers" VALUES (2562, '', 4, '', 194, 25, 23, 15, 15, 171);
INSERT INTO "seafarers" VALUES (2565, '', 3, '', 198, 10, 17, NULL, 7, 174);
INSERT INTO "seafarers" VALUES (2567, '', 1, '', 174, 6, 7, 1, 6, 162);
INSERT INTO "seafarers" VALUES (2568, '', 2, '', 138, 45, 21, 30, 17, 130);
INSERT INTO "seafarers" VALUES (2570, '', 4, '', 92, NULL, 6, NULL, NULL, 86);
INSERT INTO "seafarers" VALUES (2571, '', 3, '', 177, 4, 8, 4, 4, 167);
INSERT INTO "seafarers" VALUES (2572, '', 4, '', 178, 9, 6, 7, 7, 172);
INSERT INTO "seafarers" VALUES (2573, '', 1, '', 98, 3, 3, NULL, 2, 93);
INSERT INTO "seafarers" VALUES (2576, '', 1, '', 164, 6, 5, NULL, 5, 154);
INSERT INTO "seafarers" VALUES (2577, '', 6, '', 151, 5, 11, NULL, 7, 133);
INSERT INTO "seafarers" VALUES (2578, '', 3, '', 104, 5, 1, NULL, 4, 99);
INSERT INTO "seafarers" VALUES (2579, '', 3, '', 97, 10, 1, 3, 10, 89);
INSERT INTO "seafarers" VALUES (2580, '', 2, '', 98, 17, 12, 6, 13, 79);
INSERT INTO "seafarers" VALUES (2581, '', 1, '', 149, 5, 7, 2, 5, 135);
INSERT INTO "seafarers" VALUES (2582, '', 4, '', 145, 28, 31, 28, 22, 120);
INSERT INTO "seafarers" VALUES (2583, '', 5, '', 104, 2, 3, 5, 3, 103);
INSERT INTO "seafarers" VALUES (2584, '', 4, '', 61, NULL, NULL, 5, NULL, 66);
INSERT INTO "seafarers" VALUES (2585, '', 2, '', 96, 8, 5, NULL, 8, 92);
INSERT INTO "seafarers" VALUES (2586, '', 5, '', 190, 23, 23, 16, 15, 162);
INSERT INTO "seafarers" VALUES (2587, '', 1, '', 106, 18, 12, 27, 16, 106);
INSERT INTO "seafarers" VALUES (2588, '', 4, '', 147, 16, 6, 1, 10, 133);
INSERT INTO "seafarers" VALUES (2589, '', 1, '', 156, 8, 13, 1, 4, 140);
INSERT INTO "seafarers" VALUES (2590, '', 1, '', 131, 7, 16, 6, 4, 117);
INSERT INTO "seafarers" VALUES (2591, '', 1, '', 101, 2, 5, NULL, 1, 96);
INSERT INTO "seafarers" VALUES (2592, '', 2, '', 190, 3, 15, NULL, 3, 172);
INSERT INTO "seafarers" VALUES (2593, '', 3, '', 104, NULL, 4, NULL, NULL, 100);
INSERT INTO "seafarers" VALUES (2594, '', 3, '', 100, 8, 12, 13, 5, 96);
INSERT INTO "seafarers" VALUES (2595, '', 7, '', 196, 6, 20, NULL, 4, 172);
INSERT INTO "seafarers" VALUES (2596, '', 2, '', 178, 10, 25, 11, 10, 154);
INSERT INTO "seafarers" VALUES (2598, '', 4, '', 92, 13, 8, 18, 13, 89);
INSERT INTO "seafarers" VALUES (2599, '', 4, '', 105, 38, 6, 26, 27, 98);
INSERT INTO "seafarers" VALUES (2601, '', 5, '', 102, 5, 3, NULL, 3, 96);
INSERT INTO "seafarers" VALUES (2602, '', 4, '', 140, 2, 14, NULL, 2, 124);
INSERT INTO "seafarers" VALUES (2603, '', 3, '', 88, 4, 5, NULL, 4, 86);
INSERT INTO "seafarers" VALUES (2604, '', 5, '', 174, 1, 8, 2, 2, 155);
INSERT INTO "seafarers" VALUES (2610, '', 1, '', 167, 16, 8, NULL, 11, 145);
INSERT INTO "seafarers" VALUES (2611, '', 5, '', 136, 5, 12, NULL, 5, 118);
INSERT INTO "seafarers" VALUES (2613, '', 1, '', 133, 4, 7, 1, 4, 123);
INSERT INTO "seafarers" VALUES (2614, '', 2, '', 168, 10, 5, 1, 11, 153);
INSERT INTO "seafarers" VALUES (2615, '', 2, '', 73, 3, 5, 10, 4, 74);
INSERT INTO "seafarers" VALUES (2616, '', 4, '', 118, 3, 7, 2, 1, 112);
INSERT INTO "seafarers" VALUES (2617, '', 2, '', 135, 3, 5, 2, 3, 129);
INSERT INTO "seafarers" VALUES (2618, '', 4, '', 131, 1, 6, NULL, 1, 124);
INSERT INTO "seafarers" VALUES (2625, '', 3, '', 134, 135, 4, 60, 89, 101);
INSERT INTO "seafarers" VALUES (2626, '', 1, '', 90, 18, 13, 18, 18, 77);
INSERT INTO "seafarers" VALUES (2627, '', 1, '', 128, 79, 15, 22, 48, 94);
INSERT INTO "seafarers" VALUES (2628, '', 2, '', 87, 19, 4, 10, 19, 74);
INSERT INTO "seafarers" VALUES (2629, '', 2, '', 51, 6, 11, 17, 11, 46);
INSERT INTO "seafarers" VALUES (2631, '', 2, '', 147, 1, 19, NULL, 1, 128);
INSERT INTO "seafarers" VALUES (2632, '', 4, '', 142, 2, 21, NULL, 4, 115);
INSERT INTO "seafarers" VALUES (2633, '', 2, '', 88, NULL, 5, NULL, NULL, 85);
INSERT INTO "seafarers" VALUES (2634, '', 1, '', 84, 1, 2, NULL, 1, 81);
INSERT INTO "seafarers" VALUES (2635, '', 6, '', 162, 2, 13, 1, 2, 148);
INSERT INTO "seafarers" VALUES (2636, '', 2, '', 137, 2, 16, NULL, 2, 118);
INSERT INTO "seafarers" VALUES (2637, '', 1, '', 88, 5, 1, NULL, 5, 82);
INSERT INTO "seafarers" VALUES (2638, '', 4, '', 136, 2, 9, NULL, 2, 125);
INSERT INTO "seafarers" VALUES (2639, '', 4, '', 86, 2, 2, NULL, 1, 85);
INSERT INTO "seafarers" VALUES (2640, '', 3, '', 88, 1, 4, NULL, 1, 83);
INSERT INTO "seafarers" VALUES (2641, '', 5, '', 107, 1, 10, 3, 1, 99);
INSERT INTO "seafarers" VALUES (2642, '', 3, '', 88, 4, 9, 5, 3, 81);
INSERT INTO "seafarers" VALUES (2643, '', 2, '', 92, 1, 2, NULL, 1, 89);
INSERT INTO "seafarers" VALUES (2644, '', 2, '', 160, 3, 6, NULL, 3, 151);
INSERT INTO "seafarers" VALUES (2646, '', 2, '', 103, NULL, 1, 2, NULL, 104);
INSERT INTO "seafarers" VALUES (2648, '', 1, '', 132, NULL, 6, 1, 2, 125);
INSERT INTO "seafarers" VALUES (2649, '', 4, '', 162, 2, NULL, 1, 4, 159);
INSERT INTO "seafarers" VALUES (2650, '', 4, '', 87, 1, 2, 1, 3, 83);
INSERT INTO "seafarers" VALUES (2651, '', 3, '', 165, 4, 3, NULL, 1, 162);
INSERT INTO "seafarers" VALUES (2652, '', 3, '', 164, 2, 3, NULL, 2, 159);
INSERT INTO "seafarers" VALUES (2653, '', 5, '', 136, 4, 6, 1, 5, 125);
INSERT INTO "seafarers" VALUES (2654, '', 3, '', 92, 5, 4, 3, 5, 86);
INSERT INTO "seafarers" VALUES (2655, '', 2, '', 138, 4, 6, 5, 5, 132);
INSERT INTO "seafarers" VALUES (2656, '', 2, '', 134, 3, 2, 4, 3, 133);
INSERT INTO "seafarers" VALUES (2657, '', 3, '', 136, 3, 15, 11, 4, 128);
INSERT INTO "seafarers" VALUES (2658, '', 2, '', 89, 5, 3, 1, 4, 83);
INSERT INTO "seafarers" VALUES (2659, '', 3, '', 134, 2, 19, 5, 2, 118);
INSERT INTO "seafarers" VALUES (2660, '', 5, '', 90, 4, 8, 7, 2, 87);
INSERT INTO "seafarers" VALUES (2661, '', 7, '', 158, 14, 7, 3, 7, 147);
INSERT INTO "seafarers" VALUES (2662, '', 3, '', 130, 11, 11, 7, 6, 119);
INSERT INTO "seafarers" VALUES (2664, '', 1, '', 89, 10, 4, 10, 10, 85);
INSERT INTO "seafarers" VALUES (2665, '', 2, '', 60, 2, 2, 5, 2, 61);
INSERT INTO "seafarers" VALUES (2666, '', 2, '', 136, 5, 1, NULL, 5, 130);
INSERT INTO "seafarers" VALUES (2667, '', 5, '', 92, 3, 7, NULL, 3, 82);
INSERT INTO "seafarers" VALUES (2668, '', 3, '', 145, 3, 16, 4, 3, 130);
INSERT INTO "seafarers" VALUES (2669, '', 4, '', 164, 24, 15, 8, 27, 130);
INSERT INTO "seafarers" VALUES (2670, '', 5, '', 142, 7, 7, 6, 7, 126);
INSERT INTO "seafarers" VALUES (2671, '', 2, '', 137, 7, 8, NULL, 4, 124);
INSERT INTO "seafarers" VALUES (2672, '', 4, '', 136, 8, 2, NULL, 5, 129);
INSERT INTO "seafarers" VALUES (2673, '', 3, '', 88, 17, 8, 11, 15, 77);
INSERT INTO "seafarers" VALUES (2674, '', 2, '', 136, 4, 15, 1, 3, 119);
INSERT INTO "seafarers" VALUES (2675, '', 2, '', 142, 7, 5, NULL, 7, 127);
INSERT INTO "seafarers" VALUES (2676, '', 5, '', 133, 16, 18, 6, 9, 112);
INSERT INTO "seafarers" VALUES (2677, '', 2, '', 85, 8, 8, 7, 8, 76);
INSERT INTO "seafarers" VALUES (2678, '', 1, '', 93, 6, 4, NULL, 6, 86);
INSERT INTO "seafarers" VALUES (2679, '', 5, '', 165, 7, 16, NULL, 4, 146);
INSERT INTO "seafarers" VALUES (2681, '', 3, '', 90, 1, 5, NULL, 1, 84);
INSERT INTO "seafarers" VALUES (2682, '', 3, '', 135, 2, 5, NULL, 3, 127);
INSERT INTO "seafarers" VALUES (2683, '', 5, '', 61, 1, 2, NULL, 1, 58);
INSERT INTO "seafarers" VALUES (2684, '', 1, '', 139, 5, 4, NULL, 28, 107);
INSERT INTO "seafarers" VALUES (2685, '', 3, '', 163, 20, 11, NULL, 12, 140);
INSERT INTO "seafarers" VALUES (2687, '', 2, '', 97, 3, 1, 2, 4, 94);
INSERT INTO "seafarers" VALUES (2688, '', 8, '', 154, 16, 13, 2, 12, 131);
INSERT INTO "seafarers" VALUES (2689, '', 7, '', 135, 1, 5, NULL, 1, 129);
INSERT INTO "seafarers" VALUES (2690, '', 3, '', 153, 20, 3, 5, 11, 144);
INSERT INTO "seafarers" VALUES (2691, '', 1, '', 89, 3, 7, NULL, 3, 79);
INSERT INTO "seafarers" VALUES (2692, '', 4, '', 86, NULL, 5, 4, NULL, 85);
INSERT INTO "seafarers" VALUES (2693, '', 3, '', 160, 1, 7, 2, 6, 149);
INSERT INTO "seafarers" VALUES (2694, '', 1, '', 94, 1, 1, 5, 1, 97);
INSERT INTO "seafarers" VALUES (2695, '', 1, '', 92, NULL, 3, 8, NULL, 97);
INSERT INTO "seafarers" VALUES (2696, '', 1, '', 83, 5, 11, 17, 5, 84);
INSERT INTO "seafarers" VALUES (2698, '', 2, '', 137, 9, 9, NULL, 14, 114);
INSERT INTO "seafarers" VALUES (2699, '', 3, '', 92, 18, 17, NULL, 13, 84);
INSERT INTO "seafarers" VALUES (2700, '', 5, '', 133, 10, 7, 4, 7, 125);
INSERT INTO "seafarers" VALUES (2701, '', 6, '', 160, 4, 12, NULL, 6, 143);
INSERT INTO "seafarers" VALUES (2702, '', 6, '', 142, 1, 11, 1, 6, 126);
INSERT INTO "seafarers" VALUES (2703, '', 7, '', 82, 19, 16, 24, 14, 76);
INSERT INTO "seafarers" VALUES (2704, '', 4, '', 85, 13, 4, 7, 10, 68);
INSERT INTO "seafarers" VALUES (2705, '', 6, '', 93, 5, 6, NULL, 5, 84);
INSERT INTO "seafarers" VALUES (2706, '', 3, '', 74, 9, 3, NULL, 7, 64);
INSERT INTO "seafarers" VALUES (2707, '', 1, '', 118, 64, 16, 26, 29, 99);
INSERT INTO "seafarers" VALUES (2708, '', 2, '', 116, 8, 10, NULL, 8, 96);
INSERT INTO "seafarers" VALUES (2710, '', 3, '', 92, 22, 12, 12, 17, 75);
INSERT INTO "seafarers" VALUES (2711, '', 2, '', 77, 11, 9, 8, 11, 65);
INSERT INTO "seafarers" VALUES (2712, '', 2, '', 75, 11, 12, 8, 9, 64);
INSERT INTO "seafarers" VALUES (2713, '', 7, '', 141, 8, 13, 1, 8, 123);
INSERT INTO "seafarers" VALUES (2714, '', 3, '', 121, 42, 27, 34, 31, 97);
INSERT INTO "seafarers" VALUES (2715, '', 4, '', 90, 10, 4, 3, 13, 78);
INSERT INTO "seafarers" VALUES (2716, '', 3, '', 100, 6, 3, 4, 6, 95);
INSERT INTO "seafarers" VALUES (2717, '', 3, '', 151, 10, 20, 21, 5, 148);
INSERT INTO "seafarers" VALUES (2718, '', 3, '', 129, 6, 36, NULL, 6, 87);
INSERT INTO "seafarers" VALUES (2719, '', 4, '', 129, 22, 19, 14, 22, 102);
INSERT INTO "seafarers" VALUES (2720, '', 2, '', 61, 1, 5, 5, 1, 60);
INSERT INTO "seafarers" VALUES (2721, '', 3, '', 140, 4, 39, 2, 4, 99);
INSERT INTO "seafarers" VALUES (2723, '', 6, '', 148, 14, 16, 2, 10, 124);
INSERT INTO "seafarers" VALUES (2725, '', 4, '', 123, 27, NULL, NULL, 27, 91);
INSERT INTO "seafarers" VALUES (2730, '', 4, '', 84, 15, 17, 32, 15, 84);
INSERT INTO "seafarers" VALUES (2731, '', 4, '', 83, 3, NULL, 7, 3, 87);
INSERT INTO "seafarers" VALUES (2732, '', 6, '', 92, 13, 1, 3, 16, 79);
INSERT INTO "seafarers" VALUES (2733, '', 5, '', 120, 4, 8, 2, 3, 111);
INSERT INTO "seafarers" VALUES (2734, '', 2, '', 80, 11, 7, 14, 8, 79);
INSERT INTO "seafarers" VALUES (2735, '', 3, '', 114, 5, 1, NULL, 4, 109);
INSERT INTO "seafarers" VALUES (2736, '', 2, '', 119, 5, 15, 8, 5, 107);
INSERT INTO "seafarers" VALUES (2737, '', 5, '', 118, 36, 22, 34, 26, 104);
INSERT INTO "seafarers" VALUES (2738, '', 4, '', 137, 11, 14, NULL, 11, 112);
INSERT INTO "seafarers" VALUES (2739, '', 4, '', 89, 9, 11, 9, 7, 81);
INSERT INTO "seafarers" VALUES (2740, '', 3, '', 82, 23, 8, 14, 23, 66);
INSERT INTO "seafarers" VALUES (2741, '', 4, '', 146, 5, 11, 3, 5, 133);
INSERT INTO "seafarers" VALUES (2742, '', 1, '', 83, 9, 9, 11, 4, 81);
INSERT INTO "seafarers" VALUES (2743, '', 5, '', 87, 11, 5, 11, 9, 84);
INSERT INTO "seafarers" VALUES (2744, '', 5, '', 113, 6, 2, 1, 6, 106);
INSERT INTO "seafarers" VALUES (2745, '', 4, '', 147, 10, 3, NULL, 7, 137);
INSERT INTO "seafarers" VALUES (2746, '', 6, '', 90, 6, 7, 8, 4, 91);
INSERT INTO "seafarers" VALUES (2747, '', 5, '', 120, 13, 5, NULL, 14, 101);
INSERT INTO "seafarers" VALUES (2748, '', 1, '', 122, 12, 8, NULL, 5, 109);
INSERT INTO "seafarers" VALUES (2749, '', 3, '', 98, 9, 3, 3, 16, 82);
INSERT INTO "seafarers" VALUES (2750, '', 3, '', 90, 3, NULL, NULL, 3, 87);
INSERT INTO "seafarers" VALUES (2751, '', 6, '', 120, 17, 11, 10, 12, 107);
INSERT INTO "seafarers" VALUES (2752, '', 2, '', 92, 11, 3, 5, 10, 84);
INSERT INTO "seafarers" VALUES (2753, '', 3, '', 93, 4, 4, 1, 4, 86);
INSERT INTO "seafarers" VALUES (2754, '', 4, '', 93, 10, 6, 2, 7, 82);
INSERT INTO "seafarers" VALUES (2756, '', 3, '', 117, 5, 1, 1, 7, 113);
INSERT INTO "seafarers" VALUES (2757, '', 9, '', 141, 5, 3, 1, 13, 126);
INSERT INTO "seafarers" VALUES (2758, '', 4, '', 86, 3, 2, 2, 4, 83);
INSERT INTO "seafarers" VALUES (2759, '', 2, '', 96, 7, 1, 4, 6, 93);
INSERT INTO "seafarers" VALUES (2761, '', 4, '', 123, 6, 11, NULL, 11, 101);
INSERT INTO "seafarers" VALUES (2762, '', 4, '', 158, 11, 12, 1, 10, 137);
INSERT INTO "seafarers" VALUES (2763, '', 6, '', 156, 5, 12, 1, 5, 140);
INSERT INTO "seafarers" VALUES (2764, '', 5, '', 122, 2, 3, NULL, 2, 117);
INSERT INTO "seafarers" VALUES (2766, '', 4, '', 132, 9, 6, NULL, 7, 119);
INSERT INTO "seafarers" VALUES (2767, '', 4, '', 153, 6, 9, 2, 6, 140);
INSERT INTO "seafarers" VALUES (2768, '', 4, '', 97, 9, NULL, NULL, 8, 89);
INSERT INTO "seafarers" VALUES (2769, '', 6, '', 92, 14, 14, 23, 17, 86);
INSERT INTO "seafarers" VALUES (2770, '', 5, '', 122, 19, 20, 15, 21, 95);
INSERT INTO "seafarers" VALUES (2771, '', 2, '', 102, 8, 13, 7, 7, 89);
INSERT INTO "seafarers" VALUES (2772, '', 5, '', 156, 13, 4, NULL, 7, 143);
INSERT INTO "seafarers" VALUES (2773, '', 3, '', 64, 1, 1, NULL, 2, 61);
INSERT INTO "seafarers" VALUES (2774, '', 2, '', 99, 34, 2, 12, 28, 84);
INSERT INTO "seafarers" VALUES (2775, '', 6, '', 100, 29, 12, 16, 33, 71);
INSERT INTO "seafarers" VALUES (2776, '', 3, '', 135, 16, 14, 5, 40, 86);
INSERT INTO "seafarers" VALUES (2777, '', 4, '', 99, 11, 9, 2, 5, 87);
INSERT INTO "seafarers" VALUES (2778, '', 1, '', 90, 27, 8, 15, 17, 80);
INSERT INTO "seafarers" VALUES (2779, '', 4, '', 102, 15, 11, 3, 9, 85);
INSERT INTO "seafarers" VALUES (2780, '', 4, '', 105, NULL, 1, 1, 1, 105);
INSERT INTO "seafarers" VALUES (2781, '', 3, '', 133, 15, 2, NULL, 10, 121);
INSERT INTO "seafarers" VALUES (2784, '', 3, '', 163, 12, 10, NULL, 4, 149);
INSERT INTO "seafarers" VALUES (2785, '', 1, '', 136, 10, 3, 1, 7, 122);
INSERT INTO "seafarers" VALUES (2786, '', 1, '', 106, 5, 1, 3, 6, 97);
INSERT INTO "seafarers" VALUES (2787, '', 3, '', 117, 28, 5, 12, 18, 106);
INSERT INTO "seafarers" VALUES (2788, '', 8, '', 159, 8, 8, NULL, 5, 147);
INSERT INTO "seafarers" VALUES (2789, '', 4, '', 132, 46, 14, 11, 28, 101);
INSERT INTO "seafarers" VALUES (2790, '', 7, '', 170, 7, 6, NULL, 4, 160);
INSERT INTO "seafarers" VALUES (2791, '', 1, '', 40, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (2792, '', 4, '', 135, 6, 8, 2, 3, 126);
INSERT INTO "seafarers" VALUES (2793, '', 1, '', 146, 8, 4, 1, 11, 132);
INSERT INTO "seafarers" VALUES (2794, '', 7, '', 171, 6, 6, 1, 6, 160);
INSERT INTO "seafarers" VALUES (2795, '', 3, '', 141, 1, 12, 2, 1, 131);
INSERT INTO "seafarers" VALUES (2798, '', 2, '', 87, 8, 3, NULL, 8, 76);
INSERT INTO "seafarers" VALUES (2799, '', 4, '', 122, 9, 10, 9, 21, 101);
INSERT INTO "seafarers" VALUES (2800, '', 4, '', 120, 9, 4, NULL, 9, 107);
INSERT INTO "seafarers" VALUES (2801, '', 5, '', 116, 1, 2, NULL, 1, 113);
INSERT INTO "seafarers" VALUES (2802, '', 3, '', 149, 20, 26, 12, 17, 119);
INSERT INTO "seafarers" VALUES (2803, '', 3, '', 161, 12, 11, 3, 22, 131);
INSERT INTO "seafarers" VALUES (2804, '', 2, '', 127, 8, 8, 2, 21, 100);
INSERT INTO "seafarers" VALUES (2805, '', 2, '', 91, 3, 3, 1, 3, 86);
INSERT INTO "seafarers" VALUES (2806, '', 1, '', 118, 17, 16, 16, 43, 75);
INSERT INTO "seafarers" VALUES (2807, '', 6, '', 181, 15, 24, 11, 51, 117);
INSERT INTO "seafarers" VALUES (2808, '', 3, '', 121, 10, 18, 18, 20, 99);
INSERT INTO "seafarers" VALUES (2809, '', 3, '', 78, 3, 2, 3, 6, 73);
INSERT INTO "seafarers" VALUES (2810, '', 4, '', 117, 86, 18, 46, 73, 72);
INSERT INTO "seafarers" VALUES (2811, '', 4, '', 158, 29, 2, 3, 41, 118);
INSERT INTO "seafarers" VALUES (2812, '', 1, '', 120, 3, 14, NULL, 3, 103);
INSERT INTO "seafarers" VALUES (2813, '', 4, '', 117, 8, 1, NULL, 6, 111);
INSERT INTO "seafarers" VALUES (2814, '', 5, '', 119, 26, 16, 7, 22, 89);
INSERT INTO "seafarers" VALUES (2815, '', 5, '', 178, 19, 15, NULL, 5, 157);
INSERT INTO "seafarers" VALUES (2816, '', 2, '', 83, 4, NULL, NULL, 4, 79);
INSERT INTO "seafarers" VALUES (2817, '', 1, '', 126, 4, 5, NULL, 3, 116);
INSERT INTO "seafarers" VALUES (2819, '', 1, '', 136, NULL, 10, NULL, NULL, 126);
INSERT INTO "seafarers" VALUES (2820, '', 1, '', 152, 6, 6, 2, 8, 140);
INSERT INTO "seafarers" VALUES (2821, '', 6, '', 115, 9, 11, NULL, 7, 97);
INSERT INTO "seafarers" VALUES (2824, '', 4, '', 119, 15, 12, 5, 8, 104);
INSERT INTO "seafarers" VALUES (2825, '', 3, '', 116, 6, 10, 10, 6, 110);
INSERT INTO "seafarers" VALUES (2826, '', 5, '', 194, 29, 39, 10, 21, 144);
INSERT INTO "seafarers" VALUES (2827, '', 4, '', 188, 8, 21, NULL, 15, 153);
INSERT INTO "seafarers" VALUES (2828, '', 7, '', 122, 11, 7, 8, 12, 111);
INSERT INTO "seafarers" VALUES (2829, '', 6, '', 203, 1, 6, 1, 2, 196);
INSERT INTO "seafarers" VALUES (2831, '', 7, '', 181, 2, 9, NULL, 4, 168);
INSERT INTO "seafarers" VALUES (2832, '', 5, '', 159, 31, 20, 16, 20, 135);
INSERT INTO "seafarers" VALUES (2833, '', 5, '', 117, 2, 8, NULL, 2, 107);
INSERT INTO "seafarers" VALUES (2834, '', 7, '', 120, 3, 2, 2, 3, 117);
INSERT INTO "seafarers" VALUES (2835, '', 3, '', 118, 3, 5, 8, 3, 118);
INSERT INTO "seafarers" VALUES (2836, '', 6, '', 155, 9, 6, 2, 6, 144);
INSERT INTO "seafarers" VALUES (2839, '', 3, '', 156, 89, 30, 42, 97, 72);
INSERT INTO "seafarers" VALUES (2841, '', 5, '', 185, 45, 34, 16, 38, 129);
INSERT INTO "seafarers" VALUES (2842, '', 6, '', 164, 184, 4, 80, 130, 110);
INSERT INTO "seafarers" VALUES (2843, '', 7, '', 125, 157, NULL, 71, 108, 88);
INSERT INTO "seafarers" VALUES (2844, '', 6, '', 113, 9, 4, 1, 8, 99);
INSERT INTO "seafarers" VALUES (2845, '', 5, '', 183, 21, 68, NULL, 12, 104);
INSERT INTO "seafarers" VALUES (2846, '', 3, '', 106, 10, 35, 12, 10, 73);
INSERT INTO "seafarers" VALUES (2847, '', 1, '', 145, 46, 44, 23, 35, 88);
INSERT INTO "seafarers" VALUES (2848, '', 3, '', 138, 11, 25, 4, 10, 107);
INSERT INTO "seafarers" VALUES (2849, '', 1, '', 119, 3, 27, NULL, 2, 90);
INSERT INTO "seafarers" VALUES (2850, '', 5, '', 177, 25, 34, 3, 19, 127);
INSERT INTO "seafarers" VALUES (2851, '', 2, '', 85, NULL, NULL, NULL, 31, 54);
INSERT INTO "seafarers" VALUES (2852, '', 1, '', 121, 2, 22, NULL, 2, 97);
INSERT INTO "seafarers" VALUES (2853, '', 3, '', 153, 43, 39, 42, 44, 112);
INSERT INTO "seafarers" VALUES (2854, '', 5, '', 150, 25, 23, NULL, 16, 111);
INSERT INTO "seafarers" VALUES (2855, '', 4, '', 106, 4, 8, 2, NULL, NULL);
INSERT INTO "seafarers" VALUES (2856, '', 1, '', 133, 8, 10, NULL, 8, 115);
INSERT INTO "seafarers" VALUES (2857, '', 3, '', 76, NULL, 1, 1, 1, 75);
INSERT INTO "seafarers" VALUES (2858, '', 4, '', 151, 13, 19, NULL, 9, 123);
INSERT INTO "seafarers" VALUES (2859, '', 4, '', 144, 6, 6, NULL, 5, 131);
INSERT INTO "seafarers" VALUES (2860, '', 5, '', 148, 20, 14, 1, 13, 122);
INSERT INTO "seafarers" VALUES (2861, '', 1, '', 149, 40, 16, NULL, 27, 106);
INSERT INTO "seafarers" VALUES (2864, '', 2, '', 140, 11, 4, NULL, 13, 122);
INSERT INTO "seafarers" VALUES (2866, '', 2, '', 150, 14, 2, 1, 13, 136);
INSERT INTO "seafarers" VALUES (2867, '', 4, '', 109, 9, 8, 2, 10, 182);
INSERT INTO "seafarers" VALUES (2868, '', 9, '', 177, 12, 3, 3, 19, 159);
INSERT INTO "seafarers" VALUES (2869, '', 6, '', 92, 5, 3, NULL, 5, 84);
INSERT INTO "seafarers" VALUES (2870, '', 6, '', 157, 9, 12, 10, 30, 125);
INSERT INTO "seafarers" VALUES (2871, '', 8, '', 179, 7, 16, 5, 31, 137);
INSERT INTO "seafarers" VALUES (2872, '', 3, '', 102, 30, 18, 35, 18, 101);
INSERT INTO "seafarers" VALUES (2873, '', 5, '', 98, 5, NULL, NULL, 5, 93);
INSERT INTO "seafarers" VALUES (2874, '', 2, '', 93, 2, 2, NULL, 3, 94);
INSERT INTO "seafarers" VALUES (2875, '', 6, '', 187, 38, 46, NULL, 19, 145);
INSERT INTO "seafarers" VALUES (2876, '', 1, '', 104, 4, 10, 2, 1, 95);
INSERT INTO "seafarers" VALUES (2879, '', 8, '', 180, 23, 18, NULL, 17, 145);
INSERT INTO "seafarers" VALUES (2880, '', 1, '', 149, 15, 24, 14, 22, 121);
INSERT INTO "seafarers" VALUES (2883, '', 3, '', 100, 64, 29, 32, 35, 94);
INSERT INTO "seafarers" VALUES (2884, '', 1, '', 100, 23, 15, 22, 19, 88);
INSERT INTO "seafarers" VALUES (2885, '', 1, '', 143, 13, 10, 2, 14, 121);
INSERT INTO "seafarers" VALUES (2886, '', 4, '', 100, 6, 8, 1, 6, 87);
INSERT INTO "seafarers" VALUES (2887, '', 5, '', 215, 5, 3, 3, 5, 209);
INSERT INTO "seafarers" VALUES (2888, '', 3, '', 92, 4, 4, 5, 4, 89);
INSERT INTO "seafarers" VALUES (2889, '', 1, '', 86, NULL, 7, 1, 1, 79);
INSERT INTO "seafarers" VALUES (2890, '', 2, '', 120, 10, 8, 3, 6, 109);
INSERT INTO "seafarers" VALUES (2891, '', 5, '', 101, 6, 1, 2, 5, 97);
INSERT INTO "seafarers" VALUES (2892, '', 1, '', 149, 2, 4, 1, 5, 141);
INSERT INTO "seafarers" VALUES (2893, '', 8, '', 179, 2, 15, 5, 2, 167);
INSERT INTO "seafarers" VALUES (2894, '', 1, '', 100, 5, 1, 3, 3, 99);
INSERT INTO "seafarers" VALUES (2899, '', 1, '', 152, 9, 10, 7, 16, 130);
INSERT INTO "seafarers" VALUES (2900, '', 6, '', 184, 58, 25, 39, 44, 154);
INSERT INTO "seafarers" VALUES (2901, '', 6, '', 152, 6, 8, 11, 17, 138);
INSERT INTO "seafarers" VALUES (2902, '', 1, '', 84, 4, 11, 10, 5, 68);
INSERT INTO "seafarers" VALUES (2905, '', 4, '', 151, 11, 14, 7, 7, 137);
INSERT INTO "seafarers" VALUES (2906, '', 7, '', 192, 16, 11, 3, 24, 160);
INSERT INTO "seafarers" VALUES (2907, '', 5, '', 103, 18, 21, 38, 17, 102);
INSERT INTO "seafarers" VALUES (2909, '', 7, '', 153, 7, 6, 1, 8, 140);
INSERT INTO "seafarers" VALUES (2910, '', 1, '', 139, 17, 16, 1, 14, 114);
INSERT INTO "seafarers" VALUES (2911, '', 6, '', 96, 8, 6, 13, 13, 91);
INSERT INTO "seafarers" VALUES (2912, '', 7, '', 178, 115, 39, 46, 65, 119);
INSERT INTO "seafarers" VALUES (2913, '', 4, '', 104, 6, 11, 1, 7, 87);
INSERT INTO "seafarers" VALUES (2914, '', 5, '', 137, 8, 13, NULL, 23, 101);
INSERT INTO "seafarers" VALUES (2915, '', 2, '', 98, 18, 15, 15, 15, 83);
INSERT INTO "seafarers" VALUES (2916, '', 5, '', 106, 15, 5, NULL, 8, 82);
INSERT INTO "seafarers" VALUES (2917, '', 1, '', 86, 50, 12, 37, 56, 55);
INSERT INTO "seafarers" VALUES (2919, '', 1, '', 150, 33, 44, 30, 25, 111);
INSERT INTO "seafarers" VALUES (2921, '', 1, '', 113, 29, 37, 21, 30, 67);
INSERT INTO "seafarers" VALUES (2923, '', 5, '', 109, 17, 27, 8, 15, 75);
INSERT INTO "seafarers" VALUES (2924, '', 6, '', 161, 8, 33, NULL, 3, 125);
INSERT INTO "seafarers" VALUES (2925, '', 1, '', 105, 10, 4, 1, 14, 87);
INSERT INTO "seafarers" VALUES (2926, '', 3, '', 103, 26, 16, 7, 18, 72);
INSERT INTO "seafarers" VALUES (2927, '', 3, '', 168, 15, 12, NULL, 13, 143);
INSERT INTO "seafarers" VALUES (2928, '', 2, '', 128, 7, 13, 5, 7, 113);
INSERT INTO "seafarers" VALUES (2929, '', 3, '', 162, 8, 12, NULL, 5, 145);
INSERT INTO "seafarers" VALUES (2930, '', 1, '', 201, 16, 11, 6, 14, 181);
INSERT INTO "seafarers" VALUES (2931, '', 2, '', 123, 11, 3, NULL, 11, 109);
INSERT INTO "seafarers" VALUES (2932, '', 1, '', 158, 16, 9, 8, 12, 146);
INSERT INTO "seafarers" VALUES (2933, '', 2, '', 126, 4, 11, 1, 7, 109);
INSERT INTO "seafarers" VALUES (2934, '', 1, '', 122, 7, 13, 1, 21, 90);
INSERT INTO "seafarers" VALUES (2936, '', 5, '', 171, 11, 18, 2, 11, 145);
INSERT INTO "seafarers" VALUES (2938, '', 9, '', 207, 10, 25, 2, 10, 171);
INSERT INTO "seafarers" VALUES (2939, '', 5, '', 121, 3, 17, 12, 2, 114);
INSERT INTO "seafarers" VALUES (2941, '', 1, '', 123, 6, 13, 3, 7, 107);
INSERT INTO "seafarers" VALUES (2942, '', 2, '', 175, 35, 18, 4, 28, 137);
INSERT INTO "seafarers" VALUES (2944, '', 4, '', 145, 9, 22, 9, 26, 106);
INSERT INTO "seafarers" VALUES (2945, '', 5, '', 212, 14, 28, NULL, 16, 168);
INSERT INTO "seafarers" VALUES (2946, '', 2, '', 135, 6, 8, 3, 7, 124);
INSERT INTO "seafarers" VALUES (2947, '', 1, '', 108, 1, 4, NULL, 1, 103);
INSERT INTO "seafarers" VALUES (2948, '', 4, '', 123, 6, 11, NULL, 6, 106);
INSERT INTO "seafarers" VALUES (2949, '', 5, '', 175, 15, 26, 12, 19, 143);
INSERT INTO "seafarers" VALUES (2950, '', 1, '', 124, 9, 16, 4, 10, 102);
INSERT INTO "seafarers" VALUES (2951, '', 3, '', 103, 5, 17, 7, 4, 89);
INSERT INTO "seafarers" VALUES (2952, '', 7, '', 101, 8, 10, 4, 3, 92);
INSERT INTO "seafarers" VALUES (2953, '', 2, '', 107, 10, 13, 13, 24, 84);
INSERT INTO "seafarers" VALUES (2954, '', 3, '', 98, 39, 5, 20, 31, 83);
INSERT INTO "seafarers" VALUES (2955, '', 3, '', 99, 14, 8, 12, 9, 94);
INSERT INTO "seafarers" VALUES (2956, '', 5, '', 146, 5, 9, 2, 6, 132);
INSERT INTO "seafarers" VALUES (2957, '', 5, '', 100, 4, 4, 5, 8, 93);
INSERT INTO "seafarers" VALUES (2958, '', 1, '', 141, 1, 14, 14, 4, 137);
INSERT INTO "seafarers" VALUES (2959, '', 4, '', 147, 29, 24, 1, 25, 109);
INSERT INTO "seafarers" VALUES (2960, '', 1, '', 152, 2, 4, 1, 6, 143);
INSERT INTO "seafarers" VALUES (2961, '', 6, '', 157, 49, 23, 12, 24, 119);
INSERT INTO "seafarers" VALUES (2962, '', 6, '', 148, 13, 1, 1, 22, 126);
INSERT INTO "seafarers" VALUES (2963, '', 4, '', 99, 7, 6, 1, 7, 93);
INSERT INTO "seafarers" VALUES (2964, '', 1, '', 121, 2, 3, 3, 4, 117);
INSERT INTO "seafarers" VALUES (2965, '', 2, '', 119, 2, 11, NULL, 2, 106);
INSERT INTO "seafarers" VALUES (2966, '', 1, '', 111, 4, 10, NULL, 6, 95);
INSERT INTO "seafarers" VALUES (2967, '', 1, '', 118, 3, 6, 1, 3, 110);
INSERT INTO "seafarers" VALUES (2968, '', 1, '', 120, 1, 10, NULL, 4, 106);
INSERT INTO "seafarers" VALUES (2969, '', 1, '', 97, NULL, 11, 4, 1, 89);
INSERT INTO "seafarers" VALUES (2970, '', 8, '', 165, 8, 12, 1, 6, 148);
INSERT INTO "seafarers" VALUES (2971, '', 2, '', 136, 1, 7, 3, 4, 128);
INSERT INTO "seafarers" VALUES (2972, '', 2, '', 165, 7, 13, NULL, 22, 130);
INSERT INTO "seafarers" VALUES (2973, '', 7, '', 196, 7, 20, 2, 23, 155);
INSERT INTO "seafarers" VALUES (2974, '', 3, '', 113, 1, 5, NULL, 2, 106);
INSERT INTO "seafarers" VALUES (2976, '', 3, '', 119, 7, 5, 6, 8, 112);
INSERT INTO "seafarers" VALUES (2979, '', 6, '', 194, 6, 13, 3, 20, 164);
INSERT INTO "seafarers" VALUES (2980, '', 2, '', 156, 4, 9, 3, 15, 135);
INSERT INTO "seafarers" VALUES (2981, '', 4, '', 127, 7, 1, NULL, 14, 108);
INSERT INTO "seafarers" VALUES (2982, '', 2, '', 114, 1, 1, NULL, 1, 112);
INSERT INTO "seafarers" VALUES (2983, '', 2, '', 98, 2, 1, 2, 3, 96);
INSERT INTO "seafarers" VALUES (2984, '', 3, '', 119, 6, 2, 10, 6, 121);
INSERT INTO "seafarers" VALUES (2985, '', 2, '', 117, 8, 2, NULL, 15, 100);
INSERT INTO "seafarers" VALUES (2986, '', 5, '', 153, 11, 2, 13, 7, 157);
INSERT INTO "seafarers" VALUES (2987, '', 7, '', 131, 13, 7, 4, 42, 87);
INSERT INTO "seafarers" VALUES (2988, '', 6, '', 111, 9, 9, 14, 10, 106);
INSERT INTO "seafarers" VALUES (2990, '', 7, '', 163, 11, NULL, 4, 12, 156);
INSERT INTO "seafarers" VALUES (2991, '', 5, '', 161, 3, 8, 1, 12, 150);
INSERT INTO "seafarers" VALUES (2992, '', 1, '', 112, 7, 1, 1, 4, 109);
INSERT INTO "seafarers" VALUES (2993, '', 1, '', 158, 27, 46, 18, 29, 101);
INSERT INTO "seafarers" VALUES (2994, '', 1, '', 169, 20, 24, 7, 26, 127);
INSERT INTO "seafarers" VALUES (2995, '', 5, '', 128, 5, 24, 21, 10, 116);
INSERT INTO "seafarers" VALUES (2996, '', 3, '', 108, 4, 6, NULL, 7, 95);
INSERT INTO "seafarers" VALUES (2997, '', 1, '', 123, 4, 22, 1, 4, 94);
INSERT INTO "seafarers" VALUES (2998, '', 1, '', 172, 55, 58, 47, 36, 125);
INSERT INTO "seafarers" VALUES (2999, '', 6, '', 111, 14, 10, 17, 9, 109);
INSERT INTO "seafarers" VALUES (3000, '', 3, '', 166, 14, 14, 21, 16, 157);
INSERT INTO "seafarers" VALUES (3001, '', 1, '', 141, 11, 13, 8, 4, 132);
INSERT INTO "seafarers" VALUES (3002, '', 2, '', 96, 2, 6, 2, 3, 90);
INSERT INTO "seafarers" VALUES (3003, '', 3, '', 123, 7, 15, 1, 2, 109);
INSERT INTO "seafarers" VALUES (3004, '', 1, '', 150, 6, 10, 3, 7, 137);
INSERT INTO "seafarers" VALUES (3005, '', 2, '', 127, 5, 8, 2, 5, 116);
INSERT INTO "seafarers" VALUES (3006, '', 5, '', 117, 4, 5, NULL, 2, 110);
INSERT INTO "seafarers" VALUES (3007, '', 4, '', 115, NULL, 3, 1, 1, 112);
INSERT INTO "seafarers" VALUES (3009, '', 2, '', 102, 1, 5, NULL, 4, 92);
INSERT INTO "seafarers" VALUES (3010, '', 10, '', 200, 11, 14, 12, 23, 174);
INSERT INTO "seafarers" VALUES (3011, '', 2, '', 116, 10, 15, 9, 2, 109);
INSERT INTO "seafarers" VALUES (3013, '', 3, '', 117, 2, 1, 5, 13, 117);
INSERT INTO "seafarers" VALUES (3014, '', 7, '', 187, 9, 4, 1, 5, 179);
INSERT INTO "seafarers" VALUES (3015, '', 2, '', 157, 5, 1, 3, 8, 151);
INSERT INTO "seafarers" VALUES (3017, '', 2, '', 172, 8, 3, NULL, 11, 159);
INSERT INTO "seafarers" VALUES (3018, '', 1, '', 121, 9, 5, 5, 13, 108);
INSERT INTO "seafarers" VALUES (3022, '', 6, '', 163, 9, 6, NULL, 8, 150);
INSERT INTO "seafarers" VALUES (3023, '', 2, '', 128, 12, 17, 12, 9, 114);
INSERT INTO "seafarers" VALUES (3024, '', 1, '', 115, 17, 13, 11, 17, 89);
INSERT INTO "seafarers" VALUES (3025, '', 4, '', 151, 9, 4, 2, 8, 141);
INSERT INTO "seafarers" VALUES (3026, '', 4, '', 114, 4, 2, 3, 5, 110);
INSERT INTO "seafarers" VALUES (3028, '', 5, '', 135, 3, 4, 3, 3, 131);
INSERT INTO "seafarers" VALUES (3029, '', 6, '', 98, 9, 9, 6, 4, 91);
INSERT INTO "seafarers" VALUES (3030, '', 4, '', 99, 9, 9, 19, 13, 96);
INSERT INTO "seafarers" VALUES (3031, '', 3, '', 177, 2, 1, NULL, 6, 137);
INSERT INTO "seafarers" VALUES (3032, '', 1, '', 98, 12, 6, 14, 7, 99);
INSERT INTO "seafarers" VALUES (3033, '', 3, '', 153, 5, 15, 1, 9, 130);
INSERT INTO "seafarers" VALUES (3034, '', 1, '', 160, 3, 7, 1, 10, 146);
INSERT INTO "seafarers" VALUES (3035, '', 5, '', 109, 1, 3, 3, 6, 103);
INSERT INTO "seafarers" VALUES (3036, '', 4, '', 102, 1, 5, 7, 14, 90);
INSERT INTO "seafarers" VALUES (3037, '', 4, '', 157, 21, 21, 17, 21, 132);
INSERT INTO "seafarers" VALUES (3038, '', 1, '', 148, 6, 6, 9, 16, 135);
INSERT INTO "seafarers" VALUES (3039, '', 1, '', 102, 31, 12, 9, 26, 73);
INSERT INTO "seafarers" VALUES (3040, '', 1, '', 153, 5, 4, 9, 7, 145);
INSERT INTO "seafarers" VALUES (3041, '', 1, '', 112, 3, 3, 2, 3, 108);
INSERT INTO "seafarers" VALUES (3042, '', 2, '', 100, 6, 5, 5, 6, 94);
INSERT INTO "seafarers" VALUES (3043, '', 7, '', 168, 42, 8, 25, 42, 138);
INSERT INTO "seafarers" VALUES (3044, '', 1, '', 161, 22, 18, 15, 24, 134);
INSERT INTO "seafarers" VALUES (3045, '', 6, '', 103, 29, 23, 15, 23, 72);
INSERT INTO "seafarers" VALUES (3046, '', 2, '', 108, 11, 18, 26, 11, 105);
INSERT INTO "seafarers" VALUES (3047, '', 1, '', 139, 5, 4, NULL, 4, 130);
INSERT INTO "seafarers" VALUES (3048, '', 2, '', 96, 10, 6, 10, 11, 89);
INSERT INTO "seafarers" VALUES (3050, '', 4, '', 118, 6, 6, 4, 6, 110);
INSERT INTO "seafarers" VALUES (3051, '', 2, '', 156, 13, 14, 15, 13, 145);
INSERT INTO "seafarers" VALUES (3052, '', 7, '', 199, 36, 39, 27, 25, 162);
INSERT INTO "seafarers" VALUES (3053, '', 4, '', 96, 19, 3, 2, 25, 70);
INSERT INTO "seafarers" VALUES (3055, '', 4, '', 108, 2, 4, 10, 4, 110);
INSERT INTO "seafarers" VALUES (3056, '', 1, '', 115, 37, 18, 51, 20, 129);
INSERT INTO "seafarers" VALUES (3057, '', 2, '', 114, 31, 12, 16, 26, 92);
INSERT INTO "seafarers" VALUES (3058, '', 1, '', 116, 16, 8, 8, 14, 104);
INSERT INTO "seafarers" VALUES (3059, '', 3, '', 118, 15, 8, 14, 23, 101);
INSERT INTO "seafarers" VALUES (3060, '', 5, '', 115, 11, 16, 18, 7, 111);
INSERT INTO "seafarers" VALUES (3061, '', 2, '', 119, 9, 11, 12, 9, 111);
INSERT INTO "seafarers" VALUES (3062, '', 1, '', 122, 2, 16, 9, 2, 114);
INSERT INTO "seafarers" VALUES (3063, '', 3, '', 121, NULL, 2, 7, 3, 123);
INSERT INTO "seafarers" VALUES (3064, '', 8, '', 203, 9, 19, 12, 7, 189);
INSERT INTO "seafarers" VALUES (3065, '', 6, '', 147, 22, 14, 3, 26, 110);
INSERT INTO "seafarers" VALUES (3066, '', 1, '', 123, 6, 8, 6, 7, 114);
INSERT INTO "seafarers" VALUES (3067, '', 2, '', 101, 2, 1, NULL, 4, 96);
INSERT INTO "seafarers" VALUES (3068, '', 2, '', 111, 16, 19, 25, 34, 83);
INSERT INTO "seafarers" VALUES (3069, '', 1, '', 102, 30, 18, 31, 41, 75);
INSERT INTO "seafarers" VALUES (3070, '', 2, '', 105, 4, 2, 7, 5, 106);
INSERT INTO "seafarers" VALUES (3072, '', 1, '', 110, 13, 12, 1, 23, 78);
INSERT INTO "seafarers" VALUES (3073, '', 3, '', 115, NULL, 4, 8, 9, 111);
INSERT INTO "seafarers" VALUES (3074, '', 3, '', 103, 25, 5, 14, 22, 90);
INSERT INTO "seafarers" VALUES (3075, '', 1, '', 154, 3, 17, 2, 5, 133);
INSERT INTO "seafarers" VALUES (3076, '', 2, '', 152, 15, 22, NULL, 10, 121);
INSERT INTO "seafarers" VALUES (3077, '', 1, '', 136, 15, 4, 2, 13, 122);
INSERT INTO "seafarers" VALUES (3078, '', 6, '', 136, 23, 11, 4, 15, 114);
INSERT INTO "seafarers" VALUES (3079, '', 5, '', 116, 17, 6, 3, 13, 100);
INSERT INTO "seafarers" VALUES (3080, '', 6, '', 161, 21, 8, 1, 16, 139);
INSERT INTO "seafarers" VALUES (3081, '', 6, '', 115, 10, 17, NULL, 21, 75);
INSERT INTO "seafarers" VALUES (3082, '', 2, '', 127, 2, 3, NULL, 4, 120);
INSERT INTO "seafarers" VALUES (3083, '', 7, '', 204, 27, 17, 3, 23, 167);
INSERT INTO "seafarers" VALUES (3084, '', 3, '', 121, 3, 9, NULL, 3, 108);
INSERT INTO "seafarers" VALUES (3085, '', 3, '', 122, 4, 4, 2, 5, 117);
INSERT INTO "seafarers" VALUES (3086, '', 1, '', 122, 11, 9, NULL, 14, 102);
INSERT INTO "seafarers" VALUES (3087, '', 1, '', 163, 48, 18, 18, 35, 131);
INSERT INTO "seafarers" VALUES (3088, '', 2, '', 131, 31, 22, 19, 31, 98);
INSERT INTO "seafarers" VALUES (3089, '', 1, '', 174, 76, 4, 9, 48, 130);
INSERT INTO "seafarers" VALUES (3090, '', 1, '', 60, 2, 2, 10, 2, 65);
INSERT INTO "seafarers" VALUES (3091, '', 7, '', 113, 16, 9, 2, 13, 93);
INSERT INTO "seafarers" VALUES (3092, '', 3, '', 167, 49, 29, 16, 35, 120);
INSERT INTO "seafarers" VALUES (3094, '', 2, '', 160, 55, 12, 4, 34, 117);
INSERT INTO "seafarers" VALUES (3096, '', 2, '', 156, 38, 1, NULL, 23, 134);
INSERT INTO "seafarers" VALUES (3097, '', 3, '', 121, 23, 3, 2, 33, 86);
INSERT INTO "seafarers" VALUES (3098, '', 2, '', 108, 27, 9, 6, 14, 91);
INSERT INTO "seafarers" VALUES (3099, '', 2, '', 121, 5, 5, 1, 9, 108);
INSERT INTO "seafarers" VALUES (3100, '', 1, '', 111, 22, 16, 2, 13, 86);
INSERT INTO "seafarers" VALUES (3101, '', 11, '', 206, 61, 18, 4, 45, 148);
INSERT INTO "seafarers" VALUES (3102, '', 7, '', 165, 80, 12, 9, 53, 109);
INSERT INTO "seafarers" VALUES (3103, '', 2, '', 169, 47, 4, 5, 32, 141);
INSERT INTO "seafarers" VALUES (3104, '', 4, '', 169, 31, 28, 6, 25, 122);
INSERT INTO "seafarers" VALUES (3105, '', 1, '', 117, 2, 3, 3, 2, 113);
INSERT INTO "seafarers" VALUES (3106, '', 2, '', 101, NULL, 3, 2, 4, 95);
INSERT INTO "seafarers" VALUES (3107, '', 3, '', 114, 21, 4, NULL, 8, 104);
INSERT INTO "seafarers" VALUES (3108, '', 3, '', 107, 3, 3, 2, 3, 103);
INSERT INTO "seafarers" VALUES (3110, '', 3, '', 125, 9, 4, 10, 19, 123);
INSERT INTO "seafarers" VALUES (3111, '', 3, '', 98, 8, 2, NULL, 8, 88);
INSERT INTO "seafarers" VALUES (3112, '', 4, '', 101, 26, 9, 11, 20, 84);
INSERT INTO "seafarers" VALUES (3113, '', 5, '', 92, 14, 15, 26, 19, 84);
INSERT INTO "seafarers" VALUES (3114, '', 6, '', 149, 14, 8, NULL, 16, 126);
INSERT INTO "seafarers" VALUES (3115, '', 4, '', 111, 5, 14, 1, 22, 78);
INSERT INTO "seafarers" VALUES (3116, '', 2, '', 150, 8, 7, 6, 25, 123);
INSERT INTO "seafarers" VALUES (3117, '', 4, '', 153, 60, 36, 47, 38, 126);
INSERT INTO "seafarers" VALUES (3119, '', 5, '', 121, NULL, 4, NULL, 4, 113);
INSERT INTO "seafarers" VALUES (3122, '', 2, '', 116, 8, 10, 3, 7, 103);
INSERT INTO "seafarers" VALUES (3123, '', 3, '', 115, 3, 5, 2, 6, 106);
INSERT INTO "seafarers" VALUES (3124, '', 3, '', 122, NULL, 2, NULL, NULL, 120);
INSERT INTO "seafarers" VALUES (3125, '', 2, '', 124, 2, 2, NULL, 3, 119);
INSERT INTO "seafarers" VALUES (3126, '', 1, '', 125, 12, 6, 1, 11, 109);
INSERT INTO "seafarers" VALUES (3127, '', 2, '', 126, 3, 9, NULL, 8, 109);
INSERT INTO "seafarers" VALUES (3128, '', 1, '', 100, 7, 14, 14, 7, 93);
INSERT INTO "seafarers" VALUES (3129, '', 3, '', 177, 22, 4, 2, 19, 158);
INSERT INTO "seafarers" VALUES (3130, '', 1, '', 101, 8, 14, 9, 9, 87);
INSERT INTO "seafarers" VALUES (3131, '', 1, '', 177, 1, 15, 1, 8, 155);
INSERT INTO "seafarers" VALUES (3132, '', 2, '', 125, 23, 10, 4, 11, 108);
INSERT INTO "seafarers" VALUES (3133, '', 3, '', 101, NULL, 11, 2, 3, 89);
INSERT INTO "seafarers" VALUES (3135, '', 2, '', 173, 35, 14, 6, 28, 135);
INSERT INTO "seafarers" VALUES (3136, '', 3, '', 107, 8, 5, 2, 11, 93);
INSERT INTO "seafarers" VALUES (3137, '', 2, '', 122, 17, 6, NULL, 15, 103);
INSERT INTO "seafarers" VALUES (3139, '', 3, '', 126, 5, 3, NULL, 2, 121);
INSERT INTO "seafarers" VALUES (3140, '', 2, '', 160, 17, 8, 3, 13, 140);
INSERT INTO "seafarers" VALUES (3142, '', 2, '', 125, 10, 10, NULL, 8, 108);
INSERT INTO "seafarers" VALUES (3144, '', 4, '', 127, 6, 19, NULL, 19, 89);
INSERT INTO "seafarers" VALUES (3145, '', 6, '', 122, 13, 21, 2, 10, 93);
INSERT INTO "seafarers" VALUES (3146, '', 1, '', 167, 8, 17, 4, 16, 139);
INSERT INTO "seafarers" VALUES (3147, '', 2, '', 148, 29, 30, 22, 21, 120);
INSERT INTO "seafarers" VALUES (3148, '', 7, '', 175, 21, 54, 23, 20, 124);
INSERT INTO "seafarers" VALUES (3149, '', 4, '', 101, NULL, 1, NULL, NULL, 100);
INSERT INTO "seafarers" VALUES (3150, '', 6, '', 108, 9, 3, 7, 5, 107);
INSERT INTO "seafarers" VALUES (3151, '', 2, '', 101, 8, 15, 21, 15, 91);
INSERT INTO "seafarers" VALUES (3152, '', 3, '', 111, 7, 7, 1, 8, 98);
INSERT INTO "seafarers" VALUES (3153, '', 5, '', 145, 6, 13, 4, 6, 128);
INSERT INTO "seafarers" VALUES (3154, '', 3, '', 143, 7, 4, NULL, 13, 127);
INSERT INTO "seafarers" VALUES (3155, '', 3, '', 149, 45, 44, 47, 39, 114);
INSERT INTO "seafarers" VALUES (3157, '', 5, '', 96, 39, 20, 54, 32, 98);
INSERT INTO "seafarers" VALUES (3158, '', 1, '', 167, 4, 18, 14, 13, 151);
INSERT INTO "seafarers" VALUES (3159, '', 1, '', 169, 3, 3, 4, 9, 161);
INSERT INTO "seafarers" VALUES (3160, '', 4, '', 122, 6, 5, NULL, 6, 111);
INSERT INTO "seafarers" VALUES (3161, '', 2, '', 123, 6, 10, 1, 7, 107);
INSERT INTO "seafarers" VALUES (3162, '', 1, '', 114, 8, 6, NULL, 7, 101);
INSERT INTO "seafarers" VALUES (3164, '', 3, '', 162, 6, 4, 14, 6, 166);
INSERT INTO "seafarers" VALUES (3165, '', 1, '', 116, 5, 3, NULL, 4, 109);
INSERT INTO "seafarers" VALUES (3166, '', 11, '', 112, 5, 4, 8, 5, 111);
INSERT INTO "seafarers" VALUES (3167, '', 3, '', 129, 3, 1, 9, 2, 135);
INSERT INTO "seafarers" VALUES (3168, '', 8, '', 116, 1, 3, 1, 3, 111);
INSERT INTO "seafarers" VALUES (3169, '', 7, '', 172, 2, 17, 2, 2, 153);
INSERT INTO "seafarers" VALUES (3170, '', 4, '', 121, 2, 4, 1, 1, 117);
INSERT INTO "seafarers" VALUES (3172, '', 3, '', 162, 7, 4, 5, 10, 153);
INSERT INTO "seafarers" VALUES (3175, '', 4, '', 145, 4, 20, 13, 4, 134);
INSERT INTO "seafarers" VALUES (3177, '', 1, '', 100, 11, 8, 8, 4, 96);
INSERT INTO "seafarers" VALUES (3178, '', 2, '', 172, 13, 57, 42, 11, 147);
INSERT INTO "seafarers" VALUES (3179, '', 7, '', 148, 19, 9, 1, 30, 105);
INSERT INTO "seafarers" VALUES (3180, '', 2, '', 142, 13, 7, 4, 10, 129);
INSERT INTO "seafarers" VALUES (3181, '', 5, '', 157, NULL, 43, 18, 59, 74);
INSERT INTO "seafarers" VALUES (3182, '', 4, '', 103, 27, 1, 5, 31, 76);
INSERT INTO "seafarers" VALUES (3183, '', 8, '', 168, 23, 43, 12, 72, 64);
INSERT INTO "seafarers" VALUES (3184, '', 4, '', 108, 4, 4, 1, 5, 100);
INSERT INTO "seafarers" VALUES (3185, '', 6, '', 99, 4, 17, NULL, 10, 72);
INSERT INTO "seafarers" VALUES (3186, '', 3, '', 111, 33, 9, 13, 43, 72);
INSERT INTO "seafarers" VALUES (3187, '', 3, '', 153, 17, 13, 1, 34, 109);
INSERT INTO "seafarers" VALUES (3188, '', 2, '', 155, 9, 26, NULL, 22, 107);
INSERT INTO "seafarers" VALUES (3189, '', 1, '', 108, 45, 9, 42, 62, 81);
INSERT INTO "seafarers" VALUES (3190, '', 8, '', 158, 53, 28, 29, 56, 104);
INSERT INTO "seafarers" VALUES (3191, '', 4, '', 123, NULL, 5, 4, 12, 111);
INSERT INTO "seafarers" VALUES (3192, '', 5, '', 164, 44, 27, 17, 29, 126);
INSERT INTO "seafarers" VALUES (3193, '', 1, '', 161, 10, 19, NULL, 21, 128);
INSERT INTO "seafarers" VALUES (3194, '', 1, '', 166, 43, 20, 8, 24, 131);
INSERT INTO "seafarers" VALUES (3195, '', 4, '', 126, 24, 11, 8, 22, 101);
INSERT INTO "seafarers" VALUES (3196, '', 7, '', 144, 15, 44, 18, 5, 113);
INSERT INTO "seafarers" VALUES (3197, '', 2, '', 124, 63, 24, 16, 30, 86);
INSERT INTO "seafarers" VALUES (3198, '', 1, '', 105, 4, 14, 3, 5, 89);
INSERT INTO "seafarers" VALUES (3199, '', 1, '', 172, 13, 4, NULL, 9, 159);
INSERT INTO "seafarers" VALUES (3200, '', 3, '', 109, 24, 9, 3, 9, 95);
INSERT INTO "seafarers" VALUES (3201, '', 4, '', 122, 35, 20, 29, 35, 98);
INSERT INTO "seafarers" VALUES (3202, '', 1, '', 118, 10, 23, NULL, 5, 91);
INSERT INTO "seafarers" VALUES (3203, '', 3, '', 121, 2, 25, 1, 2, 95);
INSERT INTO "seafarers" VALUES (3204, '', 3, '', 161, 62, 13, 2, 35, 115);
INSERT INTO "seafarers" VALUES (3205, '', 1, '', 112, 66, 12, 7, 38, 69);
INSERT INTO "seafarers" VALUES (3206, '', 5, '', 121, 44, 7, 4, 34, 87);
INSERT INTO "seafarers" VALUES (3208, '', 5, '', 121, 24, 1, 2, 24, 98);
INSERT INTO "seafarers" VALUES (3209, '', 2, '', 113, 5, 21, 37, 46, 85);
INSERT INTO "seafarers" VALUES (3210, '', 7, '', 119, 11, 23, 8, 8, 96);
INSERT INTO "seafarers" VALUES (3211, '', 1, '', 107, 17, 19, 11, 17, 83);
INSERT INTO "seafarers" VALUES (3212, '', 5, '', 103, 9, 20, 8, 11, 80);
INSERT INTO "seafarers" VALUES (3213, '', 1, '', 100, 22, NULL, 15, 24, 91);
INSERT INTO "seafarers" VALUES (3214, '', 3, '', 154, 74, 19, 23, 41, 119);
INSERT INTO "seafarers" VALUES (3216, '', 4, '', 102, 4, 13, 16, 6, 99);
INSERT INTO "seafarers" VALUES (3217, '', 3, '', 103, 17, 14, 4, 18, 88);
INSERT INTO "seafarers" VALUES (3218, '', 5, '', 111, 52, 7, 19, 36, 88);
INSERT INTO "seafarers" VALUES (3219, '', 1, '', 105, 66, 21, 52, 47, 89);
INSERT INTO "seafarers" VALUES (3220, '', 1, '', 24, 1, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (3221, '', 1, '', 125, 1, 1, NULL, 1, 125);
INSERT INTO "seafarers" VALUES (3222, '', 2, '', 128, 21, 6, 2, 14, 110);
INSERT INTO "seafarers" VALUES (3223, '', 4, '', 121, 3, 13, NULL, 3, 105);
INSERT INTO "seafarers" VALUES (3224, '', 3, '', 123, 5, 27, 9, 5, 99);
INSERT INTO "seafarers" VALUES (3225, '', 3, '', 172, 21, 12, 3, 21, 142);
INSERT INTO "seafarers" VALUES (3226, '', 1, '', 174, 42, 19, 6, 25, 136);
INSERT INTO "seafarers" VALUES (3227, '', 4, '', 117, 20, 16, 11, 11, 102);
INSERT INTO "seafarers" VALUES (3228, '', 4, '', 104, 16, 12, 4, 13, 83);
INSERT INTO "seafarers" VALUES (3229, '', 1, '', 168, 53, 25, 14, 38, 121);
INSERT INTO "seafarers" VALUES (3230, '', 5, '', 116, 18, 8, NULL, 9, 100);
INSERT INTO "seafarers" VALUES (3231, '', 5, '', 127, 31, 14, 5, 27, 91);
INSERT INTO "seafarers" VALUES (3232, '', 4, '', 126, 41, 9, 5, 22, 103);
INSERT INTO "seafarers" VALUES (3235, '', 1, '', 127, 6, 16, 1, 5, 107);
INSERT INTO "seafarers" VALUES (3236, '', 4, '', 173, 36, 10, 1, 15, 149);
INSERT INTO "seafarers" VALUES (3237, '', 2, '', 116, 16, 7, 1, 14, 96);
INSERT INTO "seafarers" VALUES (3238, '', 3, '', 125, 18, 16, 6, 27, 88);
INSERT INTO "seafarers" VALUES (3239, '', 1, '', 117, 16, 4, NULL, 10, 103);
INSERT INTO "seafarers" VALUES (3240, '', 8, '', 117, 34, 36, 48, 29, 101);
INSERT INTO "seafarers" VALUES (3241, '', 2, '', 170, 33, 7, 4, 21, 146);
INSERT INTO "seafarers" VALUES (3242, '', 2, '', 111, 7, 6, NULL, 4, 101);
INSERT INTO "seafarers" VALUES (3243, '', 4, '', 103, 2, NULL, NULL, 2, 101);
INSERT INTO "seafarers" VALUES (3244, '', 4, '', 150, 30, 13, 17, 22, 132);
INSERT INTO "seafarers" VALUES (3245, '', 4, '', 137, 35, 24, 20, 26, 108);
INSERT INTO "seafarers" VALUES (3246, '', 3, '', 125, NULL, 18, 20, 19, 111);
INSERT INTO "seafarers" VALUES (3247, '', 5, '', 154, 17, 23, NULL, 13, 131);
INSERT INTO "seafarers" VALUES (3249, '', 2, '', 112, 23, 35, 31, 13, 98);
INSERT INTO "seafarers" VALUES (3250, '', 8, '', 150, 9, 7, 1, 18, 127);
INSERT INTO "seafarers" VALUES (3251, '', 4, '', 147, 19, 9, NULL, 12, 126);
INSERT INTO "seafarers" VALUES (3253, '', 1, '', 106, NULL, 1, 2, 1, 110);
INSERT INTO "seafarers" VALUES (3254, '', 1, '', 173, 12, 21, 3, 11, 142);
INSERT INTO "seafarers" VALUES (3255, '', 1, '', 91, 1, 3, NULL, 2, 88);
INSERT INTO "seafarers" VALUES (3256, '', 1, '', 209, 2, 7, 5, 2, 202);
INSERT INTO "seafarers" VALUES (3258, '', 3, '', 199, 10, 20, 11, 6, 184);
INSERT INTO "seafarers" VALUES (3259, '', 1, '', 199, 18, 16, 20, 4, 199);
INSERT INTO "seafarers" VALUES (3260, '', 6, '', 195, 43, 24, 6, 32, 145);
INSERT INTO "seafarers" VALUES (3261, '', 5, '', 108, 20, 4, 3, 20, 86);
INSERT INTO "seafarers" VALUES (3262, '', 1, '', 146, 22, 26, 24, 20, 124);
INSERT INTO "seafarers" VALUES (3263, '', 3, '', 121, 37, 6, 1, 22, 95);
INSERT INTO "seafarers" VALUES (3264, '', 4, '', 97, NULL, 7, NULL, NULL, 90);
INSERT INTO "seafarers" VALUES (3265, '', 1, '', 83, 3, 10, 12, 3, 81);
INSERT INTO "seafarers" VALUES (3268, '', 3, '', 105, 7, 3, 1, 8, 95);
INSERT INTO "seafarers" VALUES (3269, '', 3, '', 140, 14, 9, NULL, 14, 110);
INSERT INTO "seafarers" VALUES (3270, '', 2, '', 143, 5, 16, 1, 5, 123);
INSERT INTO "seafarers" VALUES (3273, '', 3, '', 108, 15, 10, 4, 18, 132);
INSERT INTO "seafarers" VALUES (3274, '', 2, '', 90, 14, 14, 13, 8, 87);
INSERT INTO "seafarers" VALUES (3276, '', 1, '', 118, 23, 13, 9, 9, 109);
INSERT INTO "seafarers" VALUES (3277, '', 2, '', 114, 33, 25, 38, 27, 100);
INSERT INTO "seafarers" VALUES (3279, '', 1, '', 124, 15, 13, 2, 16, 97);
INSERT INTO "seafarers" VALUES (3280, '', 1, '', 132, 8, 33, 4, 18, 85);
INSERT INTO "seafarers" VALUES (3281, '', 1, '', 143, 9, 13, NULL, 3, 127);
INSERT INTO "seafarers" VALUES (3282, '', 1, '', 102, 6, 6, 1, 6, 91);
INSERT INTO "seafarers" VALUES (3283, '', 5, '', 121, 1, 12, 2, 1, 110);
INSERT INTO "seafarers" VALUES (3284, '', 2, '', 121, 2, 16, NULL, 2, 97);
INSERT INTO "seafarers" VALUES (3285, '', 1, '', 114, 7, 8, NULL, 5, 107);
INSERT INTO "seafarers" VALUES (3286, '', 2, '', 29, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (3287, '', 5, '', 138, 12, 11, 3, 6, 124);
INSERT INTO "seafarers" VALUES (3288, '', 1, '', 115, 13, 11, 2, 8, 97);
INSERT INTO "seafarers" VALUES (3289, '', 2, '', 144, 5, 17, 2, 5, 114);
INSERT INTO "seafarers" VALUES (3290, '', 2, '', 136, 15, 9, NULL, 15, 119);
INSERT INTO "seafarers" VALUES (3291, '', 2, '', 144, 20, 11, 4, 28, 110);
INSERT INTO "seafarers" VALUES (3292, '', 2, '', 117, 41, 53, 29, 23, 89);
INSERT INTO "seafarers" VALUES (3293, '', 3, '', 106, 5, 9, 12, 4, 105);
INSERT INTO "seafarers" VALUES (3294, '', 4, '', 124, 12, 9, 10, 9, 114);
INSERT INTO "seafarers" VALUES (3295, '', 5, '', 117, 3, 14, 1, 12, 92);
INSERT INTO "seafarers" VALUES (3296, '', 3, '', 122, 15, 10, 9, 13, 107);
INSERT INTO "seafarers" VALUES (3298, '', 2, '', 117, NULL, 28, 39, 24, 104);
INSERT INTO "seafarers" VALUES (3299, '', 1, '', 116, 6, 6, 36, 1, 149);
INSERT INTO "seafarers" VALUES (3301, '', 4, '', 140, 12, 5, 2, 12, 134);
INSERT INTO "seafarers" VALUES (3302, '', 4, '', 115, 25, 31, 22, 39, 68);
INSERT INTO "seafarers" VALUES (3304, '', 7, '', 135, 54, 19, 16, 32, 103);
INSERT INTO "seafarers" VALUES (3305, '', 1, '', 163, 58, 14, 1, 32, 129);
INSERT INTO "seafarers" VALUES (3306, '', 1, '', 153, 8, 2, 1, 16, 113);
INSERT INTO "seafarers" VALUES (3307, '', 3, '', 156, 3, 10, NULL, 16, 130);
INSERT INTO "seafarers" VALUES (3308, '', 1, '', 105, NULL, 24, 5, 21, 64);
INSERT INTO "seafarers" VALUES (3309, '', 2, '', 211, 21, 12, 14, 15, 198);
INSERT INTO "seafarers" VALUES (3310, '', 2, '', 168, 1, 10, NULL, 3, 156);
INSERT INTO "seafarers" VALUES (3311, '', 1, '', 176, 12, 29, 9, 22, 135);
INSERT INTO "seafarers" VALUES (3312, '', 2, '', 82, 6, 3, 1, 6, 74);
INSERT INTO "seafarers" VALUES (3313, '', 1, '', 169, 7, 11, 8, 23, 144);
INSERT INTO "seafarers" VALUES (3314, '', 2, '', 262, 108, 12, NULL, 72, 178);
INSERT INTO "seafarers" VALUES (3315, '', 2, '', 145, 77, 18, 15, 34, 108);
INSERT INTO "seafarers" VALUES (3316, '', 1, '', 155, 8, 6, 2, 8, 143);
INSERT INTO "seafarers" VALUES (3317, '', 5, '', 118, 11, 12, 3, 7, 103);
INSERT INTO "seafarers" VALUES (3318, '', 4, '', 116, 8, 8, 18, 8, 135);
INSERT INTO "seafarers" VALUES (3319, '', 5, '', 116, 11, 5, 4, 17, 98);
INSERT INTO "seafarers" VALUES (3320, '', 4, '', 117, 3, 1, NULL, 14, 87);
INSERT INTO "seafarers" VALUES (3321, '', 1, '', 169, 23, 2, NULL, 17, 151);
INSERT INTO "seafarers" VALUES (3323, '', 3, '', 109, 7, 7, 3, 8, 97);
INSERT INTO "seafarers" VALUES (3324, '', 4, '', 144, 31, 3, NULL, 23, 118);
INSERT INTO "seafarers" VALUES (3325, '', 2, '', 98, 137, 9, 42, 72, 80);
INSERT INTO "seafarers" VALUES (3326, '', 4, '', 123, 2, 9, 1, 3, 108);
INSERT INTO "seafarers" VALUES (3327, '', 3, '', 91, 2, 8, 7, 1, 90);
INSERT INTO "seafarers" VALUES (3328, '', 5, '', 125, 145, 25, 36, 42, 96);
INSERT INTO "seafarers" VALUES (3329, '', 4, '', 123, 12, 15, 15, 50, 73);
INSERT INTO "seafarers" VALUES (3330, '', 1, '', 18, NULL, 1, 1, NULL, 18);
INSERT INTO "seafarers" VALUES (3331, '', 2, '', 117, 1, 8, 1, 7, 83);
INSERT INTO "seafarers" VALUES (3332, '', 2, '', 154, 22, 14, 5, 10, 135);
INSERT INTO "seafarers" VALUES (3333, '', 2, '', 91, 8, 2, 3, 6, 82);
INSERT INTO "seafarers" VALUES (3334, '', 1, '', 146, 6, 18, 1, 5, 118);
INSERT INTO "seafarers" VALUES (3335, '', 1, '', 112, 24, 16, 29, 29, 95);
INSERT INTO "seafarers" VALUES (3336, '', 4, '', 117, 2, 5, 4, 11, 99);
INSERT INTO "seafarers" VALUES (3337, '', 4, '', 140, NULL, 16, 6, 25, 98);
INSERT INTO "seafarers" VALUES (3338, '', 4, '', 116, 12, 2, NULL, 7, 109);
INSERT INTO "seafarers" VALUES (3339, '', 1, '', 133, 14, 11, NULL, 13, 109);
INSERT INTO "seafarers" VALUES (3340, '', 2, '', 87, 7, 8, NULL, 1, 78);
INSERT INTO "seafarers" VALUES (3341, '', 1, '', 162, 1, 7, 2, 15, 142);
INSERT INTO "seafarers" VALUES (3342, '', 5, '', 151, 9, 30, 11, 20, 113);
INSERT INTO "seafarers" VALUES (3345, '', 1, '', 128, 10, 5, NULL, 5, 119);
INSERT INTO "seafarers" VALUES (3346, '', 1, '', 53, 1, 5, 8, 5, 83);
INSERT INTO "seafarers" VALUES (3347, '', 1, '', 158, 24, 9, 3, 15, 138);
INSERT INTO "seafarers" VALUES (3348, '', 1, '', 132, 16, 2, 2, 13, 119);
INSERT INTO "seafarers" VALUES (3349, '', 9, '', 140, 39, NULL, 8, 16, 132);
INSERT INTO "seafarers" VALUES (3351, '', 3, '', 104, 3, 2, NULL, 3, 99);
INSERT INTO "seafarers" VALUES (3352, '', 7, '', 114, 5, NULL, NULL, 4, 110);
INSERT INTO "seafarers" VALUES (3353, '', 4, '', 131, 6, 1, NULL, 8, 122);
INSERT INTO "seafarers" VALUES (3354, '', 6, '', 101, 3, NULL, NULL, NULL, 101);
INSERT INTO "seafarers" VALUES (3355, '', 2, '', 135, NULL, 4, 3, 22, 117);
INSERT INTO "seafarers" VALUES (3356, '', 3, '', 148, 5, NULL, NULL, 11, 137);
INSERT INTO "seafarers" VALUES (3357, '', 1, '', 157, 6, 1, 1, 8, 149);
INSERT INTO "seafarers" VALUES (3358, '', 2, '', 151, 10, 3, 2, 7, 144);
INSERT INTO "seafarers" VALUES (3359, '', 5, '', 106, 22, 21, 14, 22, 77);
INSERT INTO "seafarers" VALUES (3360, '', 3, '', 129, 48, 8, 5, 12, 121);
INSERT INTO "seafarers" VALUES (3361, '', 6, '', 143, 21, 22, 15, 10, 126);
INSERT INTO "seafarers" VALUES (3362, '', 3, '', 110, 2, 4, 1, 13, 97);
INSERT INTO "seafarers" VALUES (3363, '', 4, '', 121, 22, 19, 32, 22, 112);
INSERT INTO "seafarers" VALUES (3364, '', 1, '', 114, NULL, 6, NULL, NULL, 114);
INSERT INTO "seafarers" VALUES (3365, '', 2, '', 123, 35, 24, 22, 12, 109);
INSERT INTO "seafarers" VALUES (3366, '', 6, '', 132, 2, 8, 3, 9, 121);
INSERT INTO "seafarers" VALUES (3367, '', 3, '', 117, 28, 12, 6, 13, 98);
INSERT INTO "seafarers" VALUES (3369, '', 2, '', 157, 20, 6, 1, 8, 147);
INSERT INTO "seafarers" VALUES (3370, '', 1, '', 146, 46, 5, NULL, 18, 124);
INSERT INTO "seafarers" VALUES (3371, '', 5, '', 155, 21, 11, 8, 15, 138);
INSERT INTO "seafarers" VALUES (3372, '', 1, '', 163, 14, 12, 3, 11, 145);
INSERT INTO "seafarers" VALUES (3374, '', 1, '', 127, 10, 17, 4, 7, 107);
INSERT INTO "seafarers" VALUES (3375, '', 1, '', 118, 40, 9, 3, 13, 99);
INSERT INTO "seafarers" VALUES (3376, '', 6, '', 143, 54, 17, 4, 25, 106);
INSERT INTO "seafarers" VALUES (3377, '', 2, '', 160, 11, 7, 3, 15, 142);
INSERT INTO "seafarers" VALUES (3378, '', 1, '', 172, 61, 21, 11, 47, 117);
INSERT INTO "seafarers" VALUES (3379, '', 1, '', 123, 37, 8, NULL, 14, 101);
INSERT INTO "seafarers" VALUES (3380, '', 1, '', 146, 3, 6, NULL, 4, 136);
INSERT INTO "seafarers" VALUES (3381, '', 2, '', 131, 11, 5, 1, 11, 116);
INSERT INTO "seafarers" VALUES (3382, '', 2, '', 176, 54, 6, 1, 18, 154);
INSERT INTO "seafarers" VALUES (3383, '', 2, '', 168, 81, 6, 15, 41, 141);
INSERT INTO "seafarers" VALUES (3384, '', 2, '', 117, 15, 13, 3, 8, 102);
INSERT INTO "seafarers" VALUES (3385, '', 1, '', 162, 70, 19, NULL, 39, 104);
INSERT INTO "seafarers" VALUES (3387, '', 2, '', 134, 57, 6, 15, 31, 111);
INSERT INTO "seafarers" VALUES (3388, '', 4, '', 218, 95, 23, 13, 41, 130);
INSERT INTO "seafarers" VALUES (3390, '', 3, '', 201, 14, 9, NULL, 26, 167);
INSERT INTO "seafarers" VALUES (3391, '', 2, '', 164, 38, NULL, NULL, 29, 141);
INSERT INTO "seafarers" VALUES (3392, '', 1, '', 106, NULL, 3, NULL, 6, 98);
INSERT INTO "seafarers" VALUES (3394, '', 4, '', 117, 4, NULL, NULL, 22, 93);
INSERT INTO "seafarers" VALUES (3395, '', 1, '', 130, 18, 9, NULL, 14, 97);
INSERT INTO "seafarers" VALUES (3396, '', 1, '', 129, 20, 26, 9, 9, 107);
INSERT INTO "seafarers" VALUES (3397, '', 2, '', 121, 102, 16, 47, 38, 114);
INSERT INTO "seafarers" VALUES (3398, '', 1, '', 111, 5, 5, NULL, NULL, 96);
INSERT INTO "seafarers" VALUES (3400, '', 2, '', 132, 14, 10, 5, 11, 115);
INSERT INTO "seafarers" VALUES (3401, '', 2, '', 122, 89, 4, 7, 24, 101);
INSERT INTO "seafarers" VALUES (3402, '', 3, '', 145, 50, 49, 38, 29, 104);
INSERT INTO "seafarers" VALUES (3403, '', 1, '', 127, 2, 5, NULL, 5, 117);
INSERT INTO "seafarers" VALUES (3404, '', 1, '', 131, 28, 21, NULL, 13, 99);
INSERT INTO "seafarers" VALUES (3405, '', 5, '', 137, NULL, 20, 2, 3, 114);
INSERT INTO "seafarers" VALUES (3406, '', 1, '', 158, 67, 16, 5, 23, 121);
INSERT INTO "seafarers" VALUES (3407, '', 2, '', 164, NULL, 15, 27, 44, 126);
INSERT INTO "seafarers" VALUES (3408, '', 2, '', 107, NULL, 4, 1, 4, 99);
INSERT INTO "seafarers" VALUES (3409, '', 3, '', 96, 1, 1, NULL, 1, 95);
INSERT INTO "seafarers" VALUES (3411, '', 1, '', 114, 29, 9, NULL, 32, 72);
INSERT INTO "seafarers" VALUES (3412, '', 1, '', 142, 54, 4, 1, 25, 101);
INSERT INTO "seafarers" VALUES (3413, '', 1, '', 197, 11, 3, NULL, 18, 176);
INSERT INTO "seafarers" VALUES (3414, '', 1, '', 175, 12, 6, 1, 17, 154);
INSERT INTO "seafarers" VALUES (3415, '', 4, '', 179, 41, 34, 3, 25, 124);
INSERT INTO "seafarers" VALUES (3417, '', 2, '', 120, 3, 15, 8, 15, 97);
INSERT INTO "seafarers" VALUES (3418, '', 2, '', 185, 72, 15, 5, 25, 146);
INSERT INTO "seafarers" VALUES (3419, '', 1, '', 141, 4, 17, 3, 10, 115);
INSERT INTO "seafarers" VALUES (3420, '', 3, '', 115, 23, 38, 15, 15, 77);
INSERT INTO "seafarers" VALUES (3422, '', 4, '', 121, 33, 49, 24, 20, 81);
INSERT INTO "seafarers" VALUES (3424, '', 6, '', 148, 76, 39, 41, 40, 97);
INSERT INTO "seafarers" VALUES (3425, '', 1, '', 112, 29, 22, 20, 26, 84);
INSERT INTO "seafarers" VALUES (3426, '', 3, '', 129, 40, 24, 3, 16, 93);
INSERT INTO "seafarers" VALUES (3427, '', 1, '', 154, 9, 24, 1, 7, 121);
INSERT INTO "seafarers" VALUES (3428, '', 5, '', 107, 46, 12, 10, 12, 94);
INSERT INTO "seafarers" VALUES (3429, '', 2, '', 108, 50, 16, 26, 16, 99);
INSERT INTO "seafarers" VALUES (3430, '', 1, '', 52, NULL, NULL, 1, NULL, 53);
INSERT INTO "seafarers" VALUES (3431, '', 1, '', 184, 26, 5, NULL, 12, 167);
INSERT INTO "seafarers" VALUES (3432, '', 3, '', 120, 3, 5, NULL, 3, 112);
INSERT INTO "seafarers" VALUES (3433, '', 1, '', 57, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (3434, '', 4, '', 130, 24, 8, 1, 13, 111);
INSERT INTO "seafarers" VALUES (3435, '', 2, '', 158, 17, 8, 4, 10, 125);
INSERT INTO "seafarers" VALUES (3436, '', 2, '', 162, 51, NULL, 3, 27, 139);
INSERT INTO "seafarers" VALUES (3437, '', 1, '', 203, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (3438, '', 1, '', 186, 56, 11, 1, 23, 155);
INSERT INTO "seafarers" VALUES (3440, '', 1, '', 124, 3, 8, 2, 9, 109);
INSERT INTO "seafarers" VALUES (3441, '', 2, '', 182, 53, 11, 2, 45, 128);
INSERT INTO "seafarers" VALUES (3442, '', 2, '', 170, 25, 8, 1, 12, 151);
INSERT INTO "seafarers" VALUES (3443, '', 2, '', 202, NULL, 48, 5, 13, 143);
INSERT INTO "seafarers" VALUES (3444, '', 3, '', 182, 46, 9, 2, 36, 139);
INSERT INTO "seafarers" VALUES (3445, '', 3, '', 149, 29, 10, 4, 23, 121);
INSERT INTO "seafarers" VALUES (3446, '', 5, '', 139, NULL, 4, NULL, 11, 125);
INSERT INTO "seafarers" VALUES (3447, '', 4, '', 121, 5, NULL, NULL, 2, 118);
INSERT INTO "seafarers" VALUES (3448, '', 6, '', 137, 7, 9, 3, 14, 117);
INSERT INTO "seafarers" VALUES (3449, '', 1, '', 111, 20, 2, 3, 11, 99);
INSERT INTO "seafarers" VALUES (3450, '', 2, '', 186, 24, 12, 2, 18, 156);
INSERT INTO "seafarers" VALUES (3451, '', 2, '', 160, 53, 2, 8, 24, 141);
INSERT INTO "seafarers" VALUES (3452, '', 3, '', 146, 12, 10, 2, 3, 134);
INSERT INTO "seafarers" VALUES (3453, '', 2, '', 149, 26, 21, 12, 18, 120);
INSERT INTO "seafarers" VALUES (3454, '', 1, '', 84, NULL, 6, 7, 1, 84);
INSERT INTO "seafarers" VALUES (3455, '', 3, '', 152, 31, 18, 13, 27, 121);
INSERT INTO "seafarers" VALUES (3456, '', 4, '', 181, 5, 14, 1, 4, 160);
INSERT INTO "seafarers" VALUES (3457, '', 1, '', 163, 11, 19, 1, 25, 121);
INSERT INTO "seafarers" VALUES (3458, '', 1, '', 166, 8, 12, NULL, 8, 146);
INSERT INTO "seafarers" VALUES (3459, '', 5, '', 119, 1, 15, NULL, 2, 102);
INSERT INTO "seafarers" VALUES (3460, '', 4, '', 122, NULL, 9, 4, NULL, 116);
INSERT INTO "seafarers" VALUES (3461, '', 3, '', 182, 52, 19, 2, 21, 141);
INSERT INTO "seafarers" VALUES (3463, '', 3, '', 176, 8, 10, 1, 5, 162);
INSERT INTO "seafarers" VALUES (3464, '', 3, '', 177, 10, 11, 2, 31, 138);
INSERT INTO "seafarers" VALUES (3465, '', 3, '', 119, 3, 7, 2, 3, 111);
INSERT INTO "seafarers" VALUES (3467, '', 6, '', 105, 2, 6, 2, 2, 101);
INSERT INTO "seafarers" VALUES (3468, '', 2, '', 146, 11, 14, 1, 5, 127);
INSERT INTO "seafarers" VALUES (3469, '', 1, '', 204, 5, 18, 1, 11, 177);
INSERT INTO "seafarers" VALUES (3470, '', 1, '', 195, 22, 9, NULL, 12, 173);
INSERT INTO "seafarers" VALUES (3471, '', 7, '', 128, 2, 5, 2, 2, 123);
INSERT INTO "seafarers" VALUES (3472, '', 2, '', 202, 9, 19, 1, 7, 178);
INSERT INTO "seafarers" VALUES (3473, '', 1, '', 22, 1, 3, 4, 2, 21);
INSERT INTO "seafarers" VALUES (3474, '', 5, '', 186, 6, 14, 1, 4, 169);
INSERT INTO "seafarers" VALUES (3476, '', 1, '', 172, 4, 7, 3, 3, 167);
INSERT INTO "seafarers" VALUES (3477, '', 2, '', 163, 7, 10, 7, 11, 152);
INSERT INTO "seafarers" VALUES (3478, '', 2, '', 148, 29, 12, 11, 14, 133);
INSERT INTO "seafarers" VALUES (3480, '', 4, '', 105, 2, 1, 12, 5, 111);
INSERT INTO "seafarers" VALUES (3481, '', 2, '', 159, 1, 5, NULL, 1, 153);
INSERT INTO "seafarers" VALUES (3482, '', 1, '', 204, 3, 4, 3, 2, 201);
INSERT INTO "seafarers" VALUES (3484, '', 1, '', 153, 32, 11, 13, 18, 138);
INSERT INTO "seafarers" VALUES (3486, '', 2, '', 151, 3, 6, 1, 2, 136);
INSERT INTO "seafarers" VALUES (3487, '', 1, '', 143, 7, 7, NULL, 7, 130);
INSERT INTO "seafarers" VALUES (3488, '', 2, '', 142, 18, 17, 11, 11, 126);
INSERT INTO "seafarers" VALUES (3489, '', 3, '', 164, NULL, NULL, NULL, 13, 151);
INSERT INTO "seafarers" VALUES (3490, '', 3, '', 151, 14, 13, NULL, 13, 128);
INSERT INTO "seafarers" VALUES (3491, '', 2, '', 152, 7, 25, NULL, 16, 111);
INSERT INTO "seafarers" VALUES (3492, '', 3, '', 208, 5, 22, 1, 5, 183);
INSERT INTO "seafarers" VALUES (3493, '', 1, '', 90, NULL, 6, 22, 3, 102);
INSERT INTO "seafarers" VALUES (3494, '', 1, '', 38, NULL, NULL, NULL, 1, 37);
INSERT INTO "seafarers" VALUES (3495, '', 4, '', 146, NULL, 13, 2, 10, 117);
INSERT INTO "seafarers" VALUES (3496, '', 2, '', 149, 29, 20, 17, 26, 103);
INSERT INTO "seafarers" VALUES (3497, '', 1, '', 196, 18, 26, 9, 12, 167);
INSERT INTO "seafarers" VALUES (3498, '', 1, '', 158, NULL, 4, 19, 29, 98);
INSERT INTO "seafarers" VALUES (3499, '', 4, '', 161, 3, 4, 1, 4, 152);
INSERT INTO "seafarers" VALUES (3500, '', 3, '', 199, 3, 24, 1, 16, 161);
INSERT INTO "seafarers" VALUES (3501, '', 2, '', 118, 1, 6, 2, 1, 114);
INSERT INTO "seafarers" VALUES (3502, '', 2, '', 146, 9, 7, NULL, 19, 121);
INSERT INTO "seafarers" VALUES (3503, '', 2, '', 181, 3, 14, 1, 4, 166);
INSERT INTO "seafarers" VALUES (3504, '', 2, '', 190, 11, 15, NULL, 6, 169);
INSERT INTO "seafarers" VALUES (3505, '', 3, '', 143, 9, 13, NULL, 6, 122);
INSERT INTO "seafarers" VALUES (3506, '', 3, '', 189, 9, 18, NULL, 8, 164);
INSERT INTO "seafarers" VALUES (3507, '', 1, '', 199, 49, 19, 1, 31, 150);
INSERT INTO "seafarers" VALUES (3508, '', 1, '', 190, 12, 9, NULL, 27, 146);
INSERT INTO "seafarers" VALUES (3509, '', 1, '', 199, 1, 5, 8, 2, 200);
INSERT INTO "seafarers" VALUES (3510, '', 3, '', 193, 2, 3, 3, 2, 70);
INSERT INTO "seafarers" VALUES (3511, '', 3, '', 151, 4, 14, NULL, 4, 133);
INSERT INTO "seafarers" VALUES (3512, '', 1, '', 155, 1, 5, NULL, 1, 150);
INSERT INTO "seafarers" VALUES (3514, '', 1, '', 127, 7, 14, 5, 3, 115);
INSERT INTO "seafarers" VALUES (3515, '', 1, '', 219, 4, NULL, NULL, 9, 219);
INSERT INTO "seafarers" VALUES (3516, '', 1, '', 169, 21, 11, 5, 11, 151);
INSERT INTO "seafarers" VALUES (3517, '', 5, '', 134, 4, 22, 6, 4, 116);
INSERT INTO "seafarers" VALUES (3518, '', 4, '', 128, 1, NULL, NULL, 3, 128);
INSERT INTO "seafarers" VALUES (3519, '', 6, '', 112, 1, NULL, NULL, 1, 111);
INSERT INTO "seafarers" VALUES (3520, '', 3, '', 152, 3, 27, NULL, 8, 115);
INSERT INTO "seafarers" VALUES (3521, '', 2, '', 133, 3, 2, NULL, NULL, 132);
INSERT INTO "seafarers" VALUES (3522, '', 3, '', 145, 3, 8, 4, 3, 138);
INSERT INTO "seafarers" VALUES (3523, '', 4, '', 197, 5, 9, 1, 5, 183);
INSERT INTO "seafarers" VALUES (3524, '', 1, '', 144, 6, 11, 8, 4, 140);
INSERT INTO "seafarers" VALUES (3525, '', 1, '', 162, 9, 30, 6, 66, 69);
INSERT INTO "seafarers" VALUES (3526, '', 1, '', 199, 2, 27, 4, 2, 173);
INSERT INTO "seafarers" VALUES (3527, '', 3, '', 158, 6, 15, NULL, 8, 135);
INSERT INTO "seafarers" VALUES (3528, '', 1, '', 199, 6, 17, NULL, 3, 179);
INSERT INTO "seafarers" VALUES (3529, '', 2, '', 154, 5, 18, 4, 3, 137);
INSERT INTO "seafarers" VALUES (3531, '', 3, '', 170, 6, 5, NULL, 4, 161);
INSERT INTO "seafarers" VALUES (3532, '', 3, '', 122, 2, 9, 2, 6, 109);
INSERT INTO "seafarers" VALUES (3534, '', 2, '', 203, 10, 14, 1, 7, 184);
INSERT INTO "seafarers" VALUES (3535, '', 4, '', 111, 3, 7, NULL, 2, 103);
INSERT INTO "seafarers" VALUES (3536, '', 3, '', 186, 3, 9, NULL, 5, 172);
INSERT INTO "seafarers" VALUES (3537, '', 1, '', 200, 4, 10, NULL, 3, 187);
INSERT INTO "seafarers" VALUES (3538, '', 2, '', 171, 7, 12, 2, 4, 157);
INSERT INTO "seafarers" VALUES (3539, '', 1, '', 151, 17, 25, 2, 7, 122);
INSERT INTO "seafarers" VALUES (3540, '', 1, '', 204, 3, 17, 1, 2, 186);
INSERT INTO "seafarers" VALUES (3541, '', 1, '', 195, 6, 24, 1, 3, 186);
INSERT INTO "seafarers" VALUES (3542, '', 2, '', 173, 12, 12, NULL, 23, 145);
INSERT INTO "seafarers" VALUES (3543, '', 4, '', 210, 11, 15, 4, 26, 173);
INSERT INTO "seafarers" VALUES (3544, '', 4, '', 160, 5, 6, NULL, 9, 147);
INSERT INTO "seafarers" VALUES (3546, '', 3, '', 200, 11, 22, 11, 13, 176);
INSERT INTO "seafarers" VALUES (3547, '', 6, '', 132, 1, 7, 13, 1, 137);
INSERT INTO "seafarers" VALUES (3548, '', 4, '', 179, 3, 3, 2, 3, 175);
INSERT INTO "seafarers" VALUES (3550, '', 2, '', 210, 3, 2, 2, 7, 215);
INSERT INTO "seafarers" VALUES (3551, '', 2, '', 173, 3, 2, 3, 7, 167);
INSERT INTO "seafarers" VALUES (3553, '', 4, '', 208, NULL, 13, 2, 6, 200);
INSERT INTO "seafarers" VALUES (3554, '', 4, '', 135, 8, 3, 18, 4, 146);
INSERT INTO "seafarers" VALUES (3555, '', 3, '', 149, 2, 2, NULL, 5, 144);
INSERT INTO "seafarers" VALUES (3556, '', 3, '', 187, 6, 6, NULL, 5, 176);
INSERT INTO "seafarers" VALUES (3558, '', 2, '', 134, 2, 3, 5, 2, 130);
INSERT INTO "seafarers" VALUES (3559, '', 1, '', 150, 3, 6, 8, 3, 149);
INSERT INTO "seafarers" VALUES (3560, '', 5, '', 176, 7, 16, 7, 9, 158);
INSERT INTO "seafarers" VALUES (3561, '', 1, '', 136, 11, 30, 27, 14, 120);
INSERT INTO "seafarers" VALUES (3562, '', 2, '', 145, NULL, 2, 3, NULL, 146);
INSERT INTO "seafarers" VALUES (3563, '', 1, '', 197, 9, 2, 5, 19, 171);
INSERT INTO "seafarers" VALUES (3564, '', 2, '', 155, 3, 9, 3, 9, 138);
INSERT INTO "seafarers" VALUES (3566, '', 1, '', 143, 4, 14, 17, 10, 136);
INSERT INTO "seafarers" VALUES (3568, '', 5, '', 132, 18, 11, 4, 12, 107);
INSERT INTO "seafarers" VALUES (3569, '', 1, '', 195, 15, 5, 1, 3, 188);
INSERT INTO "seafarers" VALUES (3570, '', 1, '', 197, 9, 9, 1, 6, 182);
INSERT INTO "seafarers" VALUES (3571, '', 1, '', 194, 3, 3, 1, 5, 187);
INSERT INTO "seafarers" VALUES (3572, '', 1, '', 183, 3, 13, NULL, 2, 166);
INSERT INTO "seafarers" VALUES (3573, '', 1, '', 182, 2, 10, 1, 8, 165);
INSERT INTO "seafarers" VALUES (3575, '', 2, '', 150, 1, 11, 2, 10, 132);
INSERT INTO "seafarers" VALUES (3577, '', 3, '', 159, 17, 21, 16, 12, 142);
INSERT INTO "seafarers" VALUES (3578, '', 3, '', 125, NULL, 5, 6, NULL, 126);
INSERT INTO "seafarers" VALUES (3579, '', 3, '', 160, 3, 20, 9, 14, 135);
INSERT INTO "seafarers" VALUES (3583, '', 2, '', 179, NULL, 10, 4, NULL, 173);
INSERT INTO "seafarers" VALUES (3584, '', 5, '', 193, 3, 6, NULL, 3, 172);
INSERT INTO "seafarers" VALUES (3585, '', 3, '', 199, 3, 6, NULL, 21, 172);
INSERT INTO "seafarers" VALUES (3586, '', 3, '', 195, 18, 12, NULL, 18, 165);
INSERT INTO "seafarers" VALUES (3587, '', 2, '', 175, NULL, 6, NULL, 2, 168);
INSERT INTO "seafarers" VALUES (3588, '', 1, '', 169, 2, 6, NULL, 2, 161);
INSERT INTO "seafarers" VALUES (3589, '', 4, '', 180, 10, 9, 12, 8, 175);
INSERT INTO "seafarers" VALUES (3590, '', 1, '', 150, 7, 18, 17, 8, 144);
INSERT INTO "seafarers" VALUES (3591, '', 5, '', 164, 6, 14, 3, 5, 148);
INSERT INTO "seafarers" VALUES (3592, '', 2, '', 145, NULL, 6, 7, 20, 108);
INSERT INTO "seafarers" VALUES (3593, '', 4, '', 152, 3, 4, 4, 3, 149);
INSERT INTO "seafarers" VALUES (3594, '', 4, '', 193, 2, 33, 6, 11, 164);
INSERT INTO "seafarers" VALUES (3595, '', 1, '', 152, 3, 7, 4, 1, 148);
INSERT INTO "seafarers" VALUES (3596, '', 1, '', 152, NULL, 8, NULL, 1, 135);
INSERT INTO "seafarers" VALUES (3597, '', 4, '', 151, 10, 8, 1, 11, 133);
INSERT INTO "seafarers" VALUES (3598, '', 1, '', 185, 6, 5, NULL, 8, 172);
INSERT INTO "seafarers" VALUES (3599, '', 4, '', 172, 12, 23, 3, 14, 138);
INSERT INTO "seafarers" VALUES (3600, '', 1, '', 176, 5, 7, 2, 8, 163);
INSERT INTO "seafarers" VALUES (3602, '', 2, '', 197, 18, 11, NULL, 13, 173);
INSERT INTO "seafarers" VALUES (3603, '', 1, '', 198, 4, 12, 7, 5, 188);
INSERT INTO "seafarers" VALUES (3604, '', 2, '', 195, 14, 33, 40, 24, 178);
INSERT INTO "seafarers" VALUES (3605, '', 1, '', 201, 10, 15, 3, 6, 183);
INSERT INTO "seafarers" VALUES (3606, '', 2, '', 56, NULL, 2, 1, NULL, 55);
INSERT INTO "seafarers" VALUES (3607, '', 1, '', 199, 7, 22, 4, 11, 170);
INSERT INTO "seafarers" VALUES (3608, '', 2, '', 186, 3, 12, 1, 2, 173);
INSERT INTO "seafarers" VALUES (3610, '', 4, '', 178, 58, 18, 14, 34, 139);
INSERT INTO "seafarers" VALUES (3612, '', 3, '', 170, 15, 15, NULL, 6, 149);
INSERT INTO "seafarers" VALUES (3613, '', 2, '', 178, 5, 19, 4, 4, 160);
INSERT INTO "seafarers" VALUES (3615, '', 3, '', 160, NULL, 25, 2, 16, 121);
INSERT INTO "seafarers" VALUES (3616, '', 3, '', 177, NULL, NULL, NULL, 8, 168);
INSERT INTO "seafarers" VALUES (3617, '', 1, '', 179, 2, 36, 11, 12, 142);
INSERT INTO "seafarers" VALUES (3618, '', 3, '', 170, 3, 28, 4, 1, 145);
INSERT INTO "seafarers" VALUES (3619, '', 3, '', 189, 5, 7, NULL, 63, 119);
INSERT INTO "seafarers" VALUES (3622, '', 3, '', 189, 14, 30, 5, 10, 154);
INSERT INTO "seafarers" VALUES (3623, '', 5, '', 146, 9, 18, 2, 12, 118);
INSERT INTO "seafarers" VALUES (3624, '', 4, '', 155, 5, 11, 13, 8, 148);
INSERT INTO "seafarers" VALUES (3625, '', 3, '', 154, 45, 45, 56, 31, 134);
INSERT INTO "seafarers" VALUES (3626, '', 1, '', 159, NULL, 31, 2, NULL, 130);
INSERT INTO "seafarers" VALUES (3628, '', 3, '', 165, NULL, 22, 2, 1, 145);
INSERT INTO "seafarers" VALUES (3629, '', 3, '', 150, NULL, 6, NULL, 3, 138);
INSERT INTO "seafarers" VALUES (3630, '', 2, '', 173, 6, 12, 2, 10, 154);
INSERT INTO "seafarers" VALUES (3631, '', 1, '', 194, 39, 13, 3, 20, 162);
INSERT INTO "seafarers" VALUES (3632, '', 4, '', 194, 13, 17, 10, 15, 170);
INSERT INTO "seafarers" VALUES (3633, '', 1, '', 198, 7, 24, 11, 15, 176);
INSERT INTO "seafarers" VALUES (3635, '', 2, '', 181, 1, 11, 5, 19, 156);
INSERT INTO "seafarers" VALUES (3636, '', 1, '', 194, 7, 20, 4, 20, 156);
INSERT INTO "seafarers" VALUES (3637, '', 2, '', 199, 10, 15, 15, 18, 178);
INSERT INTO "seafarers" VALUES (3638, '', 2, '', 175, 4, 19, 9, 5, 154);
INSERT INTO "seafarers" VALUES (3639, '', 1, '', 176, 8, 14, 13, 3, 172);
INSERT INTO "seafarers" VALUES (3640, '', 4, '', 173, 4, 9, 7, 30, 141);
INSERT INTO "seafarers" VALUES (3641, '', 2, '', 172, 3, 7, 7, 3, 170);
INSERT INTO "seafarers" VALUES (3644, '', 5, '', 194, 3, 3, 5, 18, 184);
INSERT INTO "seafarers" VALUES (3645, '', 2, '', 188, 12, 13, 12, 15, 179);
INSERT INTO "seafarers" VALUES (3646, '', 5, '', 200, 8, 6, 2, 8, 188);
INSERT INTO "seafarers" VALUES (3647, '', 1, '', 156, 22, 53, 30, 16, 117);
INSERT INTO "seafarers" VALUES (3649, '', 2, '', 199, 3, 24, NULL, 1, 170);
INSERT INTO "seafarers" VALUES (3650, '', 4, '', 195, 6, 33, NULL, 22, 141);
INSERT INTO "seafarers" VALUES (3651, '', 3, '', 161, 3, 33, 4, 15, 117);
INSERT INTO "seafarers" VALUES (3652, '', 4, '', 112, 2, 12, 2, 4, 98);
INSERT INTO "seafarers" VALUES (3653, '', 1, '', 141, 14, 36, 1, 19, 89);
INSERT INTO "seafarers" VALUES (3654, '', 1, '', 199, NULL, 49, 27, 22, 146);
INSERT INTO "seafarers" VALUES (3655, '', 4, '', 190, 29, 45, 36, 46, 135);
INSERT INTO "seafarers" VALUES (3656, '', 4, '', 145, 13, 11, 4, 20, 118);
INSERT INTO "seafarers" VALUES (3658, '', 2, '', 188, 10, 38, 23, 18, 155);
INSERT INTO "seafarers" VALUES (3659, '', 2, '', 194, 6, 13, NULL, 23, 158);
INSERT INTO "seafarers" VALUES (3662, '', 2, '', 174, 30, 32, 3, 15, 128);
INSERT INTO "seafarers" VALUES (3664, '', 1, '', 184, 3, 15, 1, 1, 180);
INSERT INTO "seafarers" VALUES (3666, '', 4, '', 163, 3, 8, NULL, 3, 147);
INSERT INTO "seafarers" VALUES (3667, '', 2, '', 181, 4, 14, NULL, 5, 162);
INSERT INTO "seafarers" VALUES (3668, '', 1, '', 198, 3, 17, 2, 1, 176);
INSERT INTO "seafarers" VALUES (3669, '', 2, '', 179, 3, 23, 3, 2, 156);
INSERT INTO "seafarers" VALUES (3672, '', 2, '', 171, 3, 12, 4, 5, 147);
INSERT INTO "seafarers" VALUES (3673, '', 3, '', 158, 14, 9, 11, 7, 152);
INSERT INTO "seafarers" VALUES (3674, '', 5, '', 157, NULL, 8, 2, 12, 140);
INSERT INTO "seafarers" VALUES (3675, '', 3, '', 144, 8, 11, NULL, 6, 128);
INSERT INTO "seafarers" VALUES (3676, '', 4, '', 193, 6, 20, 9, 6, 177);
INSERT INTO "seafarers" VALUES (3677, '', 2, '', 143, 9, 14, 6, 9, 126);
INSERT INTO "seafarers" VALUES (3678, '', 6, '', 112, 9, 5, 1, 9, 99);
INSERT INTO "seafarers" VALUES (3680, '', 5, '', 199, 9, 16, 4, 9, 178);
INSERT INTO "seafarers" VALUES (3681, '', 4, '', 173, NULL, 7, NULL, NULL, 167);
INSERT INTO "seafarers" VALUES (3682, '', 3, '', 180, 6, 5, 3, 4, 174);
INSERT INTO "seafarers" VALUES (3683, '', 4, '', 201, 3, 11, 3, 2, 194);
INSERT INTO "seafarers" VALUES (3684, '', 3, '', 199, 16, 31, 12, 7, 173);
INSERT INTO "seafarers" VALUES (3685, '', 1, '', 204, 11, 28, 1, 11, 166);
INSERT INTO "seafarers" VALUES (3686, '', 2, '', 193, 3, 30, 8, 1, 168);
INSERT INTO "seafarers" VALUES (3688, '', 1, '', 181, 5, 18, 5, 5, 163);
INSERT INTO "seafarers" VALUES (3689, '', 1, '', 194, 71, 38, 10, 41, 123);
INSERT INTO "seafarers" VALUES (3690, '', 1, '', 195, 24, 40, 6, 13, 148);
INSERT INTO "seafarers" VALUES (3691, '', 2, '', 140, 3, 10, 1, 5, 126);
INSERT INTO "seafarers" VALUES (3692, '', 2, '', 182, NULL, 33, 5, 7, 151);
INSERT INTO "seafarers" VALUES (3694, '', 4, '', 153, NULL, 25, 18, 8, 135);
INSERT INTO "seafarers" VALUES (3696, '', 2, '', 150, 24, 7, NULL, 9, 136);
INSERT INTO "seafarers" VALUES (3697, '', 1, '', 154, 12, 4, NULL, 12, 138);
INSERT INTO "seafarers" VALUES (3698, '', 4, '', 150, 23, 9, 3, 23, 122);
INSERT INTO "seafarers" VALUES (3699, '', 4, '', 114, 14, 21, 10, 16, 186);
INSERT INTO "seafarers" VALUES (3700, '', 3, '', 179, 49, 27, 20, 49, 119);
INSERT INTO "seafarers" VALUES (3703, '', 2, '', 168, NULL, 11, 19, 31, 142);
INSERT INTO "seafarers" VALUES (3704, '', 4, '', 160, NULL, 34, 6, 11, 116);
INSERT INTO "seafarers" VALUES (3705, '', 4, '', 187, 114, 45, 51, 71, 122);
INSERT INTO "seafarers" VALUES (3706, '', 6, '', 140, 62, 30, 41, 33, 118);
INSERT INTO "seafarers" VALUES (3707, '', 5, '', 150, 16, 13, 6, 16, 126);
INSERT INTO "seafarers" VALUES (3708, '', 3, '', 180, 6, 43, 2, 9, 130);
INSERT INTO "seafarers" VALUES (3709, '', 3, '', 169, 6, 6, NULL, 6, 159);
INSERT INTO "seafarers" VALUES (3710, '', 2, '', 179, 7, 9, NULL, 4, 166);
INSERT INTO "seafarers" VALUES (3711, '', 5, '', 176, 8, 12, 3, 13, 154);
INSERT INTO "seafarers" VALUES (3712, '', 1, '', 202, 34, 18, 4, 18, 169);
INSERT INTO "seafarers" VALUES (3713, '', 7, '', 110, 3, 52, 25, 2, 83);
INSERT INTO "seafarers" VALUES (3714, '', 4, '', 186, 21, 28, NULL, 21, 133);
INSERT INTO "seafarers" VALUES (3715, '', 3, '', 186, 48, 1, NULL, 30, 156);
INSERT INTO "seafarers" VALUES (3716, '', 1, '', 189, NULL, NULL, NULL, 38, 147);
INSERT INTO "seafarers" VALUES (3718, '', 3, '', 206, NULL, 4, 30, 29, 192);
INSERT INTO "seafarers" VALUES (3720, '', 3, '', 190, 71, 34, 17, 32, 144);
INSERT INTO "seafarers" VALUES (3722, '', 1, '', 205, NULL, 17, NULL, 23, 166);
INSERT INTO "seafarers" VALUES (3723, '', 1, '', 141, 4, 19, 10, 12, 120);
INSERT INTO "seafarers" VALUES (3724, '', 5, '', 185, NULL, 21, 24, 17, 174);
INSERT INTO "seafarers" VALUES (3725, '', 2, '', 152, 34, 13, 1, 24, 117);
INSERT INTO "seafarers" VALUES (3726, '', 1, '', 190, 14, 23, 13, 12, 168);
INSERT INTO "seafarers" VALUES (3727, '', 6, '', 151, 24, 26, 27, 20, 132);
INSERT INTO "seafarers" VALUES (3728, '', 5, '', 180, 41, 38, 21, 25, 137);
INSERT INTO "seafarers" VALUES (3729, '', 2, '', 117, 30, 21, 27, 24, 99);
INSERT INTO "seafarers" VALUES (3730, '', 5, '', 202, 59, 43, 2, 39, 122);
INSERT INTO "seafarers" VALUES (3731, '', 3, '', 198, 22, 31, 2, 24, 145);
INSERT INTO "seafarers" VALUES (3732, '', 2, '', 150, 53, 27, 30, 41, 115);
INSERT INTO "seafarers" VALUES (3733, '', 2, '', 135, 8, 25, 17, 14, 112);
INSERT INTO "seafarers" VALUES (3734, '', 6, '', 167, 12, 17, 3, 18, 135);
INSERT INTO "seafarers" VALUES (3735, '', 4, '', 194, 81, 36, 29, 52, 135);
INSERT INTO "seafarers" VALUES (3736, '', 2, '', 187, 24, 27, 1, 24, 129);
INSERT INTO "seafarers" VALUES (3737, '', 3, '', 204, 63, 23, 28, 64, 145);
INSERT INTO "seafarers" VALUES (3738, '', 4, '', 194, 9, 9, NULL, 16, 170);
INSERT INTO "seafarers" VALUES (3740, '', 3, '', 196, 101, 16, 26, 67, 139);
INSERT INTO "seafarers" VALUES (3741, '', 1, '', 197, 42, 26, NULL, 19, 154);
INSERT INTO "seafarers" VALUES (3742, '', 2, '', 185, 50, 10, 6, 32, 149);
INSERT INTO "seafarers" VALUES (3745, '', 2, '', 178, 40, 29, 28, 26, 152);
INSERT INTO "seafarers" VALUES (3746, '', 4, '', 173, 62, 15, 16, 42, 132);
INSERT INTO "seafarers" VALUES (3748, '', 1, '', 196, 48, 18, 1, 13, 165);
INSERT INTO "seafarers" VALUES (3749, '', 1, '', 195, 38, 11, 2, 20, 167);
INSERT INTO "seafarers" VALUES (3750, '', 2, '', 193, NULL, 17, 1, 32, 147);
INSERT INTO "seafarers" VALUES (3751, '', 6, '', 171, 55, 7, NULL, 31, 135);
INSERT INTO "seafarers" VALUES (3752, '', 3, '', 180, NULL, 13, 2, 20, 149);
INSERT INTO "seafarers" VALUES (3755, '', 2, '', 202, NULL, 14, 7, 35, 165);
INSERT INTO "seafarers" VALUES (3756, '', 2, '', 202, 19, 47, 13, 19, 147);
INSERT INTO "seafarers" VALUES (3757, '', 3, '', 185, 40, 16, NULL, 26, 143);
INSERT INTO "seafarers" VALUES (3758, '', 3, '', 143, 10, 28, 3, 16, 102);
INSERT INTO "seafarers" VALUES (3759, '', 1, '', 158, 1, 13, NULL, 10, 135);
INSERT INTO "seafarers" VALUES (3760, '', 5, '', 154, 13, 24, 20, 10, 140);
INSERT INTO "seafarers" VALUES (3761, '', 2, '', 140, 3, 10, 2, 5, 127);
INSERT INTO "seafarers" VALUES (3762, '', 6, '', 117, 8, 11, 9, 12, 106);
INSERT INTO "seafarers" VALUES (3763, '', 5, '', 185, 7, 10, 1, 20, 156);
INSERT INTO "seafarers" VALUES (3764, '', 6, '', 195, NULL, 38, 91, 57, 190);
INSERT INTO "seafarers" VALUES (3765, '', 2, '', 144, 4, 14, 1, 13, 119);
INSERT INTO "seafarers" VALUES (3766, '', 3, '', 200, 13, 45, 43, 13, 185);
INSERT INTO "seafarers" VALUES (3767, '', 1, '', 186, 24, 28, 19, 5, 174);
INSERT INTO "seafarers" VALUES (3768, '', 4, '', 164, 5, 5, 1, 4, 164);
INSERT INTO "seafarers" VALUES (3769, '', 5, '', 183, 3, 20, 12, 7, 163);
INSERT INTO "seafarers" VALUES (3770, '', 1, '', 200, 11, 24, 1, 11, 166);
INSERT INTO "seafarers" VALUES (3771, '', 3, '', 152, 18, 4, 4, 14, 128);
INSERT INTO "seafarers" VALUES (3772, '', 1, '', 189, 10, 9, NULL, 6, 173);
INSERT INTO "seafarers" VALUES (3773, '', 2, '', 146, 6, 10, 10, 7, 139);
INSERT INTO "seafarers" VALUES (3774, '', 2, '', 186, 19, 8, 11, 15, 174);
INSERT INTO "seafarers" VALUES (3775, '', 5, '', 157, 4, 9, 7, 2, 153);
INSERT INTO "seafarers" VALUES (3777, '', 2, '', 203, 6, 4, 1, 11, 189);
INSERT INTO "seafarers" VALUES (3778, '', 5, '', 168, NULL, 13, 2, NULL, 157);
INSERT INTO "seafarers" VALUES (3779, '', 2, '', 184, 10, 14, 3, 11, 162);
INSERT INTO "seafarers" VALUES (3780, '', 3, '', 111, NULL, 7, 2, 1, 106);
INSERT INTO "seafarers" VALUES (3783, '', 3, '', 165, 5, 7, 5, 5, 158);
INSERT INTO "seafarers" VALUES (3784, '', 4, '', 173, 26, 21, 11, 20, 139);
INSERT INTO "seafarers" VALUES (3785, '', 3, '', 140, 5, 5, NULL, 9, 126);
INSERT INTO "seafarers" VALUES (3786, '', 3, '', 150, 6, 6, NULL, 10, 135);
INSERT INTO "seafarers" VALUES (3787, '', 3, '', 149, 11, 9, 2, 11, 127);
INSERT INTO "seafarers" VALUES (3788, '', 4, '', 194, 8, 24, NULL, 9, 161);
INSERT INTO "seafarers" VALUES (3789, '', 1, '', 122, 12, 17, 6, 8, 104);
INSERT INTO "seafarers" VALUES (3790, '', 5, '', 113, 5, 4, 3, 4, 109);
INSERT INTO "seafarers" VALUES (3791, '', 3, '', 199, 21, 36, 25, 12, 176);
INSERT INTO "seafarers" VALUES (3792, '', 5, '', 195, 53, 33, 7, 25, 144);
INSERT INTO "seafarers" VALUES (3793, '', 1, '', 138, 12, 17, 29, 9, 141);
INSERT INTO "seafarers" VALUES (3794, '', 2, '', 174, 10, 12, 2, 9, 155);
INSERT INTO "seafarers" VALUES (3795, '', 4, '', 156, 2, 8, 4, 2, 145);
INSERT INTO "seafarers" VALUES (3797, '', 1, '', 198, NULL, 22, 3, 33, 144);
INSERT INTO "seafarers" VALUES (3798, '', 5, '', 160, NULL, 5, 3, 15, 141);
INSERT INTO "seafarers" VALUES (3799, '', 5, '', 187, 1, 13, 4, NULL, 177);
INSERT INTO "seafarers" VALUES (3800, '', 4, '', 179, NULL, 18, NULL, 6, 156);
INSERT INTO "seafarers" VALUES (3801, '', 1, '', 195, 11, 15, NULL, 9, 171);
INSERT INTO "seafarers" VALUES (3804, '', 4, '', 164, 14, 3, 2, 8, 155);
INSERT INTO "seafarers" VALUES (3805, '', 7, '', 171, 9, 18, 16, 29, 139);
INSERT INTO "seafarers" VALUES (3807, '', 5, '', 158, 36, 26, 2, 31, 102);
INSERT INTO "seafarers" VALUES (3808, '', 3, '', 155, 13, 7, 1, 13, 138);
INSERT INTO "seafarers" VALUES (3809, '', 3, '', 164, NULL, NULL, NULL, 6, 158);
INSERT INTO "seafarers" VALUES (3810, '', 2, '', 192, 7, 5, 9, 7, 184);
INSERT INTO "seafarers" VALUES (3811, '', 2, '', 197, 11, 6, 3, 11, 175);
INSERT INTO "seafarers" VALUES (3812, '', 2, '', 121, 1, 5, 3, 4, 110);
INSERT INTO "seafarers" VALUES (3813, '', 5, '', 154, 3, 9, 5, 4, 146);
INSERT INTO "seafarers" VALUES (3814, '', 3, '', 204, 6, 3, 4, 3, 180);
INSERT INTO "seafarers" VALUES (3815, '', 4, '', 196, 6, 14, 9, 11, 177);
INSERT INTO "seafarers" VALUES (3816, '', 3, '', 149, 5, 26, 11, 4, 126);
INSERT INTO "seafarers" VALUES (3817, '', 3, '', 159, 6, 28, 17, 7, 141);
INSERT INTO "seafarers" VALUES (3818, '', 1, '', 191, 3, 7, 4, 3, 185);
INSERT INTO "seafarers" VALUES (3819, '', 7, '', 173, 4, 9, NULL, 1, 159);
INSERT INTO "seafarers" VALUES (3820, '', 1, '', 197, 29, 28, 5, 12, 161);
INSERT INTO "seafarers" VALUES (3821, '', 2, '', 222, 11, 18, 1, 15, 182);
INSERT INTO "seafarers" VALUES (3823, '', 4, '', 282, 11, 37, 43, 23, 265);
INSERT INTO "seafarers" VALUES (3825, '', 1, '', 260, NULL, NULL, NULL, 30, 231);
INSERT INTO "seafarers" VALUES (3827, '', 6, '', 228, 6, 20, 9, 6, 179);
INSERT INTO "seafarers" VALUES (3828, '', 2, '', 189, 14, 22, 9, 20, 153);
INSERT INTO "seafarers" VALUES (3829, '', 4, '', 253, 70, 22, 12, 45, 197);
INSERT INTO "seafarers" VALUES (3830, '', 4, '', 205, 8, 26, 25, 8, 169);
INSERT INTO "seafarers" VALUES (3832, '', 3, '', 288, 13, 43, 24, 24, 242);
INSERT INTO "seafarers" VALUES (3833, '', 4, '', 283, 51, 51, 2, 45, 179);
INSERT INTO "seafarers" VALUES (3834, '', 3, '', 211, 3, 21, 2, 3, 189);
INSERT INTO "seafarers" VALUES (3835, '', 2, '', 179, 2, 7, 2, 2, 172);
INSERT INTO "seafarers" VALUES (3836, '', 3, '', 186, 24, 57, 53, 18, 155);
INSERT INTO "seafarers" VALUES (3837, '', 3, '', 151, 7, 17, NULL, 7, 124);
INSERT INTO "seafarers" VALUES (3838, '', 5, '', 157, 2, 11, 4, 2, 147);
INSERT INTO "seafarers" VALUES (3839, '', 2, '', 217, 7, 8, 10, 5, 213);
INSERT INTO "seafarers" VALUES (3840, '', 5, '', 156, 4, 16, 1, 4, 137);
INSERT INTO "seafarers" VALUES (3843, '', 3, '', 155, NULL, 24, 22, 5, 145);
INSERT INTO "seafarers" VALUES (3846, '', 5, '', 222, 1, 31, 12, 1, 202);
INSERT INTO "seafarers" VALUES (3848, '', 3, '', 187, 13, 24, 4, 20, 147);
INSERT INTO "seafarers" VALUES (3849, '', 4, '', 233, 43, 35, 7, 37, 168);
INSERT INTO "seafarers" VALUES (3850, '', 1, '', 290, 15, 37, 13, 15, 251);
INSERT INTO "seafarers" VALUES (3851, '', 5, '', 220, 12, 3, 2, NULL, NULL);
INSERT INTO "seafarers" VALUES (3853, '', 2, '', 207, 3, 4, 1, 5, 196);
INSERT INTO "seafarers" VALUES (3854, '', 3, '', 243, 73, 22, 2, 55, 163);
INSERT INTO "seafarers" VALUES (3855, '', 4, '', 185, 2, 8, 6, 13, 170);
INSERT INTO "seafarers" VALUES (3856, '', 3, '', 157, 41, 22, 8, 33, 110);
INSERT INTO "seafarers" VALUES (3859, '', 4, '', 204, 4, 19, NULL, 4, 181);
INSERT INTO "seafarers" VALUES (3860, '', 5, '', 156, 5, 16, 12, 1, 151);
INSERT INTO "seafarers" VALUES (3861, '', 5, '', 165, 77, 24, 18, 47, 111);
INSERT INTO "seafarers" VALUES (3862, '', 3, '', 114, 3, 16, 15, 4, 109);
INSERT INTO "seafarers" VALUES (3863, '', 4, '', 192, 9, 18, 9, 9, 174);
INSERT INTO "seafarers" VALUES (3864, '', 2, '', 162, NULL, 12, 31, 47, 132);
INSERT INTO "seafarers" VALUES (3865, '', 3, '', 146, 11, 32, 6, 19, 101);
INSERT INTO "seafarers" VALUES (3868, '', 6, '', 111, 3, 2, 1, 4, 107);
INSERT INTO "seafarers" VALUES (3869, '', 3, '', 186, 18, 51, 37, 35, 138);
INSERT INTO "seafarers" VALUES (3870, '', 3, '', 249, 10, 102, 5, 10, 141);
INSERT INTO "seafarers" VALUES (3872, '', 5, '', 111, 17, 9, 15, 11, 81);
INSERT INTO "seafarers" VALUES (3873, '', 2, '', 193, 7, 31, 8, 8, 153);
INSERT INTO "seafarers" VALUES (3874, '', 4, '', 113, 14, 14, 18, 23, 79);
INSERT INTO "seafarers" VALUES (3875, '', 5, '', 164, 14, 19, 11, 11, 145);
INSERT INTO "seafarers" VALUES (3876, '', 2, '', 280, 3, 20, NULL, 21, 241);
INSERT INTO "seafarers" VALUES (3877, '', 3, '', 180, 7, 20, 2, 6, 157);
INSERT INTO "seafarers" VALUES (3878, '', 1, '', 198, 16, 30, 5, 22, 151);
INSERT INTO "seafarers" VALUES (3879, '', 1, '', 233, 1, 10, 7, 1, 230);
INSERT INTO "seafarers" VALUES (3880, '', 8, '', 217, 10, 19, 5, 37, 168);
INSERT INTO "seafarers" VALUES (3881, '', 4, '', 245, 25, 56, 11, 15, 185);
INSERT INTO "seafarers" VALUES (3882, '', 4, '', 293, 8, 24, 7, 8, 268);
INSERT INTO "seafarers" VALUES (3883, '', 6, '', 162, NULL, 33, 13, 2, 140);
INSERT INTO "seafarers" VALUES (3884, '', 7, '', 193, 9, 22, 4, 13, 162);
INSERT INTO "seafarers" VALUES (3885, '', 5, '', 180, 5, 39, 4, 3, 142);
INSERT INTO "seafarers" VALUES (3886, '', 5, '', 298, 30, 47, 28, 33, 245);
INSERT INTO "seafarers" VALUES (3888, '', 4, '', 246, NULL, 33, 3, 23, 172);
INSERT INTO "seafarers" VALUES (3889, '', 1, '', 178, 26, 17, 1, 12, 148);
INSERT INTO "seafarers" VALUES (3891, '', 4, '', 170, 18, 27, NULL, 8, 135);
INSERT INTO "seafarers" VALUES (3892, '', 3, '', 196, NULL, 30, NULL, 4, 162);
INSERT INTO "seafarers" VALUES (3893, '', 4, '', 196, 7, 11, 2, 21, 166);
INSERT INTO "seafarers" VALUES (3895, '', 6, '', 159, 3, 3, 3, 6, 153);
INSERT INTO "seafarers" VALUES (3896, '', 4, '', 191, 49, 33, 15, 25, 148);
INSERT INTO "seafarers" VALUES (3897, '', 1, '', 166, 47, 29, 22, 16, 143);
INSERT INTO "seafarers" VALUES (3898, '', 5, '', 209, 15, 54, 27, 33, 150);
INSERT INTO "seafarers" VALUES (3899, '', 3, '', 134, 51, 24, 53, 55, 108);
INSERT INTO "seafarers" VALUES (3900, '', 4, '', 211, 12, 57, 2, 21, 136);
INSERT INTO "seafarers" VALUES (3901, '', 5, '', 182, 43, 35, 29, 26, 150);
INSERT INTO "seafarers" VALUES (3902, '', 4, '', 200, 77, 32, 45, 77, 136);
INSERT INTO "seafarers" VALUES (3903, '', 5, '', 164, 20, 51, 47, 15, 146);
INSERT INTO "seafarers" VALUES (3905, '', 1, '', 153, 8, 43, 34, 16, 128);
INSERT INTO "seafarers" VALUES (3906, '', 2, '', 210, 16, 60, 47, 24, 172);
INSERT INTO "seafarers" VALUES (3908, '', 3, '', 195, 2, 34, NULL, 7, 154);
INSERT INTO "seafarers" VALUES (3909, '', 3, '', 199, 22, 47, 7, 19, 140);
INSERT INTO "seafarers" VALUES (3910, '', 6, '', 181, 5, 36, 10, 12, 143);
INSERT INTO "seafarers" VALUES (3911, '', 3, '', 192, 27, 59, 6, 22, 117);
INSERT INTO "seafarers" VALUES (3912, '', 3, '', 215, 5, 57, 2, 16, 150);
INSERT INTO "seafarers" VALUES (3913, '', 1, '', 195, 33, 26, 1, 19, 151);
INSERT INTO "seafarers" VALUES (3915, '', 1, '', 241, 12, 72, 2, 11, 160);
INSERT INTO "seafarers" VALUES (3916, '', 1, '', 199, 5, 4, NULL, 3, 192);
INSERT INTO "seafarers" VALUES (3917, '', 1, '', 237, 8, 26, 3, 10, 203);
INSERT INTO "seafarers" VALUES (3919, '', 5, '', 211, 48, 22, 3, 29, 160);
INSERT INTO "seafarers" VALUES (3921, '', 1, '', 219, 54, 73, 2, 34, 113);
INSERT INTO "seafarers" VALUES (3923, '', 4, '', 176, 3, 14, 4, 10, 329);
INSERT INTO "seafarers" VALUES (3924, '', 1, '', 179, 13, 20, 23, 8, 174);
INSERT INTO "seafarers" VALUES (3925, '', 6, '', 149, 4, 14, 1, 5, 131);
INSERT INTO "seafarers" VALUES (3926, '', 2, '', 181, 22, 19, 21, 16, 159);
INSERT INTO "seafarers" VALUES (3927, '', 7, '', 167, 39, 30, 17, 25, 129);
INSERT INTO "seafarers" VALUES (3928, '', 5, '', 129, 8, 7, NULL, 3, 125);
INSERT INTO "seafarers" VALUES (3929, '', 1, '', 168, 27, 36, 27, 27, 132);
INSERT INTO "seafarers" VALUES (3930, '', 5, '', 162, 12, 22, 31, 19, 153);
INSERT INTO "seafarers" VALUES (3931, '', 1, '', 153, 2, 11, 10, 13, 136);
INSERT INTO "seafarers" VALUES (3932, '', 5, '', 195, 12, 30, 8, 19, 154);
INSERT INTO "seafarers" VALUES (3933, '', 1, '', 158, 3, 8, 7, 9, 154);
INSERT INTO "seafarers" VALUES (3934, '', 1, '', 167, 32, 29, 10, 24, 124);
INSERT INTO "seafarers" VALUES (3935, '', 1, '', 195, 11, 7, 1, 6, 183);
INSERT INTO "seafarers" VALUES (3936, '', 3, '', 110, NULL, 36, 28, NULL, 102);
INSERT INTO "seafarers" VALUES (3937, '', 6, '', 219, 33, 75, 12, 20, 135);
INSERT INTO "seafarers" VALUES (3938, '', 1, '', 185, 3, 48, 1, 8, 136);
INSERT INTO "seafarers" VALUES (3939, '', 3, '', 262, 20, 49, 11, 12, 209);
INSERT INTO "seafarers" VALUES (3940, '', 1, '', 196, 54, 38, 40, 28, 171);
INSERT INTO "seafarers" VALUES (3941, '', 5, '', 170, 7, 11, 1, 5, 155);
INSERT INTO "seafarers" VALUES (3942, '', 1, '', 262, 63, 48, 17, 39, 187);
INSERT INTO "seafarers" VALUES (3943, '', 5, '', 183, 35, 26, NULL, 18, 139);
INSERT INTO "seafarers" VALUES (3945, '', 4, '', 211, 10, 46, 6, 13, 161);
INSERT INTO "seafarers" VALUES (3946, '', 2, '', 271, 5, 27, 12, 11, 245);
INSERT INTO "seafarers" VALUES (3949, '', 1, '', 238, 5, 31, 1, 6, 208);
INSERT INTO "seafarers" VALUES (3950, '', 3, '', 174, 13, 30, 39, 20, 163);
INSERT INTO "seafarers" VALUES (3951, '', 4, '', 158, 2, 12, 12, 2, 156);
INSERT INTO "seafarers" VALUES (3954, '', 2, '', 82, 10, 4, 66, 4, 140);
INSERT INTO "seafarers" VALUES (3955, '', 1, '', 143, 5, 8, 8, 8, 135);
INSERT INTO "seafarers" VALUES (3956, '', 2, '', 139, 5, 12, NULL, 6, 132);
INSERT INTO "seafarers" VALUES (3957, '', 1, '', 191, 9, 13, 1, 7, 173);
INSERT INTO "seafarers" VALUES (3958, '', 7, '', 149, 5, 3, 1, 7, 140);
INSERT INTO "seafarers" VALUES (3961, '', 1, '', 252, 2, 11, 8, NULL, 153);
INSERT INTO "seafarers" VALUES (3968, '', 1, '', 299, 3, 6, 2, NULL, 189);
INSERT INTO "seafarers" VALUES (3971, '', 3, '', 293, 3, 12, 9, NULL, 180);
INSERT INTO "seafarers" VALUES (3990, '', 2, '', 197, 11, NULL, 18, NULL, 111);
INSERT INTO "seafarers" VALUES (3991, '', 4, '', 270, 8, NULL, NULL, NULL, 146);
INSERT INTO "seafarers" VALUES (3992, '', 3, '', 177, 12, 45, 26, 37, 121);
INSERT INTO "seafarers" VALUES (3995, '', 5, '', 159, 11, 25, 22, 35, 121);
INSERT INTO "seafarers" VALUES (4004, '', 1, '', 285, 37, NULL, NULL, 52, 163);
INSERT INTO "seafarers" VALUES (4006, '', 1, '', 262, 22, NULL, NULL, 46, 189);
INSERT INTO "seafarers" VALUES (4011, '', 5, '', 243, 3, 27, 3, 48, 171);
INSERT INTO "seafarers" VALUES (4012, '', 5, '', 220, 12, 63, 30, 24, 163);
INSERT INTO "seafarers" VALUES (4016, '', 2, '', 259, 6, NULL, NULL, NULL, 133);
INSERT INTO "seafarers" VALUES (4021, '', 3, '', 316, 14, NULL, NULL, NULL, 171);
INSERT INTO "seafarers" VALUES (4024, '', 2, '', 290, 33, NULL, NULL, NULL, 156);
INSERT INTO "seafarers" VALUES (4026, '', 1, '', 297, 20, NULL, 2, NULL, 154);
INSERT INTO "seafarers" VALUES (4029, '', 7, '', 262, 67, NULL, 16, NULL, 157);
INSERT INTO "seafarers" VALUES (4033, '', 2, '', 292, 12, NULL, NULL, NULL, 150);
INSERT INTO "seafarers" VALUES (4038, '', 4, '', 235, 9, 9, NULL, 12, 141);
INSERT INTO "seafarers" VALUES (4040, '', 6, '', 367, 44, 32, NULL, 57, NULL);
INSERT INTO "seafarers" VALUES (4042, '', 2, '', 285, 19, 50, NULL, 24, 142);
INSERT INTO "seafarers" VALUES (4043, '', 2, '', 277, 57, NULL, NULL, NULL, 172);
INSERT INTO "seafarers" VALUES (4045, '', 4, '', 216, 1, 13, 3, 1, 201);
INSERT INTO "seafarers" VALUES (4046, '', 4, '', 259, 27, NULL, NULL, NULL, 154);
INSERT INTO "seafarers" VALUES (4048, '', 5, '', 304, 2, NULL, 1, NULL, 181);
INSERT INTO "seafarers" VALUES (4050, '', 3, '', 254, 12, NULL, NULL, NULL, 146);
INSERT INTO "seafarers" VALUES (4054, '', 2, '', 281, 15, NULL, 10, NULL, 164);
INSERT INTO "seafarers" VALUES (4057, '', 4, '', 290, 29, NULL, NULL, NULL, 138);
INSERT INTO "seafarers" VALUES (4063, '', 1, '', 306, 7, NULL, NULL, NULL, 193);
INSERT INTO "seafarers" VALUES (4070, '', 4, '', 371, 43, 22, 67, 48, 253);
INSERT INTO "seafarers" VALUES (4076, '', 5, '', 252, 13, 20, NULL, 33, 140);
INSERT INTO "seafarers" VALUES (4077, '', 5, '', 349, 6, 20, NULL, NULL, 224);
INSERT INTO "seafarers" VALUES (4078, '', 3, '', 207, 31, 87, 79, 36, 185);
INSERT INTO "seafarers" VALUES (4080, '', 2, '', 194, 46, 96, 47, 51, 158);
INSERT INTO "seafarers" VALUES (4081, '', 2, '', 187, 7, 18, NULL, NULL, 164);
INSERT INTO "seafarers" VALUES (4082, '', 7, '', 306, 9, 49, 69, 14, 210);
INSERT INTO "seafarers" VALUES (4083, '', 6, '', 165, 45, 64, 23, 49, 136);
INSERT INTO "seafarers" VALUES (4084, '', 4, '', 198, 140, 27, 56, 141, 154);
INSERT INTO "seafarers" VALUES (4085, '', 4, '', 206, 146, 67, 56, 148, 134);
INSERT INTO "seafarers" VALUES (4086, '', 2, '', 177, 11, 59, 22, 24, 148);
INSERT INTO "seafarers" VALUES (4087, '', 1, '', 176, 51, 29, 2, 54, 138);
INSERT INTO "seafarers" VALUES (4088, '', 2, '', 185, 52, 38, 5, 54, 153);
INSERT INTO "seafarers" VALUES (4089, '', 2, '', 252, 57, 49, 19, 66, 206);
INSERT INTO "seafarers" VALUES (4090, '', 5, '', 160, 41, 20, 9, NULL, 130);
INSERT INTO "seafarers" VALUES (4091, '', 3, '', 226, 80, 72, 4, 82, 146);
INSERT INTO "seafarers" VALUES (4092, '', 2, '', 224, 80, 39, 14, 83, 181);
INSERT INTO "seafarers" VALUES (4093, '', 1, '', 196, 51, 28, 1, 59, 131);
INSERT INTO "seafarers" VALUES (4094, '', 2, '', 240, 54, 34, 2, 60, 199);
INSERT INTO "seafarers" VALUES (4095, '', 1, '', 264, 168, 73, 62, 170, 138);
INSERT INTO "seafarers" VALUES (4096, '', 4, '', 206, 93, 30, 11, 112, 152);
INSERT INTO "seafarers" VALUES (4097, '', 4, '', 196, 98, 36, NULL, 98, 135);
INSERT INTO "seafarers" VALUES (4102, '', 3, '', 140, 10, 20, 22, 13, 129);
INSERT INTO "seafarers" VALUES (4103, '', 2, '', 125, 48, 21, 74, 48, 130);
INSERT INTO "seafarers" VALUES (4105, '', 2, '', 167, 45, 52, 47, 45, 117);
INSERT INTO "seafarers" VALUES (4108, '', 3, '', 252, 116, 46, NULL, 119, 85);
INSERT INTO "seafarers" VALUES (4115, '', 2, '', 195, 28, 51, 3, 28, 119);
INSERT INTO "seafarers" VALUES (4116, '', 4, '', 266, 141, NULL, 19, 145, 133);
INSERT INTO "seafarers" VALUES (4133, '', 1, '', 239, 20, 30, NULL, 25, 66);
INSERT INTO "seafarers" VALUES (4138, '', 4, '', 211, 52, 40, NULL, 51, 117);
INSERT INTO "seafarers" VALUES (4139, '', 2, '', 272, 59, 50, NULL, 61, 141);
INSERT INTO "seafarers" VALUES (4140, '', 4, '', 225, 36, 49, NULL, 50, 138);
INSERT INTO "seafarers" VALUES (4145, '', 3, '', 259, 44, 24, NULL, NULL, 147);
INSERT INTO "seafarers" VALUES (4146, '', 1, '', 244, 55, 39, NULL, NULL, 135);
INSERT INTO "seafarers" VALUES (4150, '', 1, '', 264, 39, 39, NULL, NULL, 130);
INSERT INTO "seafarers" VALUES (4156, '', 6, '', 167, 139, 20, 144, 152, 137);
INSERT INTO "seafarers" VALUES (4168, '', 3, '', 131, 40, 38, 59, 48, 107);
INSERT INTO "seafarers" VALUES (4170, '', 5, '', 163, 48, 37, 19, 51, 110);
INSERT INTO "seafarers" VALUES (4172, '', 3, '', 174, 31, 34, 14, 32, 145);
INSERT INTO "seafarers" VALUES (4173, '', 5, '', 163, 79, 43, 73, 82, 122);
INSERT INTO "seafarers" VALUES (4174, '', 2, '', 149, 11, 39, 28, 43, 130);
INSERT INTO "seafarers" VALUES (4175, '', 4, '', 173, 29, 76, 37, 29, 134);
INSERT INTO "seafarers" VALUES (4177, '', 1, '', 249, 55, 24, 25, 57, 140);
INSERT INTO "seafarers" VALUES (4178, '', 1, '', 280, 32, 46, 1, 34, 174);
INSERT INTO "seafarers" VALUES (4179, '', 1, '', 212, 9, 14, 32, 25, 170);
INSERT INTO "seafarers" VALUES (4180, '', 2, '', 172, 28, 18, 41, 29, 172);
INSERT INTO "seafarers" VALUES (4181, '', 1, '', 203, 14, 46, NULL, 17, 189);
INSERT INTO "seafarers" VALUES (4182, '', 2, '', 247, 47, 18, 29, 60, 202);
INSERT INTO "seafarers" VALUES (4184, '', 1, '', 183, 100, 69, 34, 119, 138);
INSERT INTO "seafarers" VALUES (4185, '', 1, '', 170, 20, 35, 42, 25, 156);
INSERT INTO "seafarers" VALUES (4186, '', 2, '', 265, 17, 85, 1, 19, 183);
INSERT INTO "seafarers" VALUES (4187, '', 1, '', 241, 42, 33, 3, 46, 187);
INSERT INTO "seafarers" VALUES (4188, '', 1, '', 150, 5, 20, 1, 6, 158);
INSERT INTO "seafarers" VALUES (4189, '', 1, '', 270, 163, 19, 36, 166, 162);
INSERT INTO "seafarers" VALUES (4190, '', 4, '', 218, 129, 65, 52, 132, 160);
INSERT INTO "seafarers" VALUES (4191, '', 2, '', 225, 1, 56, 1, 3, 184);
INSERT INTO "seafarers" VALUES (4193, '', 3, '', 237, 44, 50, 52, 48, 207);
INSERT INTO "seafarers" VALUES (4203, '', 3, '', 174, 15, 50, 19, 29, 133);
INSERT INTO "seafarers" VALUES (4204, '', 4, '', 198, 38, 94, 101, 65, 143);
INSERT INTO "seafarers" VALUES (4205, '', 5, '', 178, 8, 23, 36, 12, 175);
INSERT INTO "seafarers" VALUES (4206, '', 5, '', 117, 2, 11, 23, 4, 121);
INSERT INTO "seafarers" VALUES (4208, '', 1, '', 199, 8, 65, 78, 10, 195);
INSERT INTO "seafarers" VALUES (4210, '', 1, '', 230, 1, 8, 14, 17, 220);
INSERT INTO "seafarers" VALUES (4211, '', 6, '', 168, 9, 17, 4, 10, 155);
INSERT INTO "seafarers" VALUES (4212, '', 4, '', 139, 22, 12, 2, 28, 238);
INSERT INTO "seafarers" VALUES (4213, '', 5, '', 200, 9, 31, 28, 54, 174);
INSERT INTO "seafarers" VALUES (4214, '', 4, '', 268, 20, 58, 33, 37, 224);
INSERT INTO "seafarers" VALUES (4215, '', 1, '', 185, 4, 24, 27, 23, 170);
INSERT INTO "seafarers" VALUES (4216, '', 6, '', 256, 11, 41, 13, 20, 201);
INSERT INTO "seafarers" VALUES (4217, '', 1, '', 211, 2, 10, 1, NULL, 202);
INSERT INTO "seafarers" VALUES (4218, '', 2, '', 259, 22, 17, 7, 28, 238);
INSERT INTO "seafarers" VALUES (4219, '', 1, '', 273, 4, 41, 1, 44, 208);
INSERT INTO "seafarers" VALUES (4220, '', 1, '', 189, 6, 10, 25, 6, 196);
INSERT INTO "seafarers" VALUES (4221, '', 2, '', 195, 5, 25, 19, 15, 185);
INSERT INTO "seafarers" VALUES (4222, '', 1, '', 202, 8, 80, 9, 26, 142);
INSERT INTO "seafarers" VALUES (4223, '', 1, '', 261, 7, 26, 41, 50, 220);
INSERT INTO "seafarers" VALUES (4225, '', 1, '', 317, 2, 39, NULL, 28, 235);
INSERT INTO "seafarers" VALUES (4226, '', 2, '', 223, NULL, NULL, NULL, 29, 194);
INSERT INTO "seafarers" VALUES (4228, '', 3, '', 131, 12, 18, 56, 15, 154);
INSERT INTO "seafarers" VALUES (4231, '', 2, '', 195, 7, 62, 87, 8, 212);
INSERT INTO "seafarers" VALUES (4248, '', 1, '', 271, 15, NULL, 13, NULL, 188);
INSERT INTO "seafarers" VALUES (4250, '', 1, '', 262, 3, NULL, 17, NULL, 170);
INSERT INTO "seafarers" VALUES (4258, '', 1, '', 222, 10, NULL, NULL, NULL, 153);
INSERT INTO "seafarers" VALUES (4260, '', 1, '', 126, NULL, NULL, 19, NULL, 127);
INSERT INTO "seafarers" VALUES (4262, '', 4, '', 185, 6, 2, 28, 7, 204);
INSERT INTO "seafarers" VALUES (4263, '', 4, '', 169, 19, 31, 41, 23, 156);
INSERT INTO "seafarers" VALUES (4264, '', 2, '', 159, 5, 27, 32, 13, 151);
INSERT INTO "seafarers" VALUES (4265, '', 2, '', 118, 3, 8, 20, 4, 126);
INSERT INTO "seafarers" VALUES (4290, '', 4, '', 157, 1, 17, 21, 2, 159);
INSERT INTO "seafarers" VALUES (4315, '', 2, '', 169, 4, 2, 17, 5, 179);
INSERT INTO "seafarers" VALUES (4369, '', 6, '', 158, 22, NULL, NULL, 34, 106);
INSERT INTO "seafarers" VALUES (4372, '', 4, '', 222, 66, 77, 60, 83, 129);
INSERT INTO "seafarers" VALUES (4374, '', 6, '', 168, 24, 54, 46, 63, 111);
INSERT INTO "seafarers" VALUES (4375, '', 4, '', 274, 9, 90, 15, 87, 133);
INSERT INTO "seafarers" VALUES (4376, '', 6, '', 196, 19, 56, 8, 73, 115);
INSERT INTO "seafarers" VALUES (4377, '', 6, '', 146, 3, 40, 43, 84, 101);
INSERT INTO "seafarers" VALUES (4378, '', 4, '', 153, 5, 33, 11, 13, 139);
INSERT INTO "seafarers" VALUES (4379, '', 3, '', 64, 1, NULL, 8, 9, 57);
INSERT INTO "seafarers" VALUES (4380, '', 1, '', 225, 4, 75, 4, 5, 178);
INSERT INTO "seafarers" VALUES (4381, '', 1, '', 280, 18, 71, 55, 72, 159);
INSERT INTO "seafarers" VALUES (4382, '', 3, '', 260, 4, 74, NULL, 8, 192);
INSERT INTO "seafarers" VALUES (4384, '', 3, '', 190, 7, 24, 26, 11, 178);
INSERT INTO "seafarers" VALUES (4385, '', 1, '', 200, 2, 58, 32, 44, 155);
INSERT INTO "seafarers" VALUES (4387, '', 5, '', 182, 3, 44, 1, 5, 136);
INSERT INTO "seafarers" VALUES (4388, '', 2, '', 169, 4, 38, 2, 22, 128);
INSERT INTO "seafarers" VALUES (4392, '', 5, '', 125, 108, 80, 165, 126, 107);
INSERT INTO "seafarers" VALUES (4395, '', 2, '', 272, 142, 84, 74, 185, 90);
INSERT INTO "seafarers" VALUES (4396, '', 1, '', 132, 51, 80, 47, 67, 117);
INSERT INTO "seafarers" VALUES (4398, '', 3, '', 178, 73, 102, 69, 88, 119);
INSERT INTO "seafarers" VALUES (4411, '', 1, '', 149, 3, 3, NULL, NULL, 155);
INSERT INTO "seafarers" VALUES (4415, '', 1, '', 189, 5, 20, NULL, NULL, 170);
INSERT INTO "seafarers" VALUES (4417, '', 4, '', 228, 7, 77, 8, 13, 146);
INSERT INTO "seafarers" VALUES (4427, '', 1, '', 179, 3, 11, NULL, NULL, 202);
INSERT INTO "seafarers" VALUES (4429, '', 5, '', 183, 3, 6, NULL, NULL, 113);
INSERT INTO "seafarers" VALUES (4432, '', 1, '', 254, 22, 126, 40, 27, 141);
INSERT INTO "seafarers" VALUES (4433, '', 1, '', 308, 9, 10, NULL, NULL, 270);
INSERT INTO "seafarers" VALUES (4436, '', 1, '', 220, 5, 22, NULL, 7, 191);
INSERT INTO "seafarers" VALUES (4443, '', 1, '', 110, 1, 3, NULL, NULL, 91);
INSERT INTO "seafarers" VALUES (4445, '', 1, '', 167, 3, 15, NULL, NULL, 160);
INSERT INTO "seafarers" VALUES (4447, '', 1, '', 201, 4, 30, NULL, NULL, 200);
INSERT INTO "seafarers" VALUES (4493, '', 7, '', 204, 5, 33, NULL, NULL, 148);
INSERT INTO "seafarers" VALUES (4519, '', 2, '', 273, 36, 61, NULL, NULL, 122);
INSERT INTO "seafarers" VALUES (4524, '', 1, '', 128, 9, 25, NULL, NULL, 89);
INSERT INTO "seafarers" VALUES (4529, '', 1, '', 199, 4, 20, NULL, NULL, 187);
INSERT INTO "seafarers" VALUES (4539, '', 1, '', 269, 6, 14, NULL, NULL, 162);
INSERT INTO "seafarers" VALUES (4542, '', 1, '', 220, 4, 34, NULL, NULL, 189);
INSERT INTO "seafarers" VALUES (4550, '', 1, '', 275, NULL, NULL, NULL, NULL, 181);
INSERT INTO "seafarers" VALUES (4559, '', 1, '', 166, 3, 12, NULL, NULL, 159);
INSERT INTO "seafarers" VALUES (4560, '', 2, '', 164, 4, 10, NULL, NULL, 164);
INSERT INTO "seafarers" VALUES (4562, '', 1, '', 193, 32, 60, NULL, NULL, 136);
INSERT INTO "seafarers" VALUES (4574, '', 2, '', 114, 76, 54, NULL, NULL, 88);
INSERT INTO "seafarers" VALUES (4575, '', 1, '', 280, 11, 75, NULL, NULL, 184);
INSERT INTO "seafarers" VALUES (4576, '', 1, '', 120, 3, 20, NULL, NULL, 98);
INSERT INTO "seafarers" VALUES (4586, '', 1, '', 176, 3, 28, NULL, NULL, 151);
INSERT INTO "seafarers" VALUES (4587, '', 2, '', 190, 11, 18, NULL, NULL, 167);
INSERT INTO "seafarers" VALUES (4606, '', 2, '', 230, 53, 7, NULL, NULL, 194);
INSERT INTO "seafarers" VALUES (4607, '', 5, '', 207, 24, 50, NULL, NULL, 169);
INSERT INTO "seafarers" VALUES (4611, '', 2, '', 132, 19, 100, NULL, NULL, 100);
INSERT INTO "seafarers" VALUES (4612, '', 2, '', 80, 1, 6, NULL, NULL, 102);
INSERT INTO "seafarers" VALUES (4613, '', 1, '', 175, 1, 24, NULL, NULL, 156);
INSERT INTO "seafarers" VALUES (4616, '', 1, '', 254, 21, 49, NULL, NULL, 178);
INSERT INTO "seafarers" VALUES (4617, '', 2, '', 143, 15, 36, NULL, NULL, 122);
INSERT INTO "seafarers" VALUES (4618, '', 1, '', 205, 11, 32, NULL, NULL, 181);
INSERT INTO "seafarers" VALUES (4620, '', 1, '', 208, 2, NULL, NULL, NULL, 174);
INSERT INTO "seafarers" VALUES (4621, '', 3, '', 119, 17, 7, NULL, NULL, 57);
INSERT INTO "seafarers" VALUES (4622, '', 1, '', 194, 5, 15, NULL, NULL, 168);
INSERT INTO "seafarers" VALUES (4623, '', 1, '', 215, 7, 17, NULL, NULL, 207);
INSERT INTO "seafarers" VALUES (4624, '', 3, '', 199, 4, 15, NULL, NULL, 174);
INSERT INTO "seafarers" VALUES (4625, '', 2, '', 213, 3, 9, NULL, NULL, 204);
INSERT INTO "seafarers" VALUES (4628, '', 1, '', 162, 30, 30, NULL, NULL, 114);
INSERT INTO "seafarers" VALUES (4629, '', 3, '', 229, 4, 12, NULL, NULL, 138);
INSERT INTO "seafarers" VALUES (4631, '', 1, '', 229, 3, 16, NULL, NULL, 211);
INSERT INTO "seafarers" VALUES (4633, '', 4, '', 93, 13, NULL, NULL, NULL, 161);
INSERT INTO "seafarers" VALUES (4634, '', 1, '', 192, 5, 15, NULL, NULL, 177);
INSERT INTO "seafarers" VALUES (4639, '', 3, '', 168, 9, 38, NULL, NULL, 151);
INSERT INTO "seafarers" VALUES (4640, '', 4, '', 205, 22, 35, NULL, NULL, 127);
INSERT INTO "seafarers" VALUES (4642, '', 2, '', 130, 1, 30, NULL, NULL, 103);
INSERT INTO "seafarers" VALUES (4643, '', 3, '', 72, 5, 50, NULL, NULL, 79);
INSERT INTO "seafarers" VALUES (4645, '', 1, '', 181, 3, 15, NULL, NULL, 165);
INSERT INTO "seafarers" VALUES (4646, '', 2, '', 195, 12, 50, NULL, NULL, 158);
INSERT INTO "seafarers" VALUES (4650, '', 1, '', 228, 4, 6, NULL, NULL, 205);
INSERT INTO "seafarers" VALUES (4651, '', 1, '', 214, 7, 24, NULL, NULL, 198);
INSERT INTO "seafarers" VALUES (4652, '', 3, '', 231, 2, 9, NULL, NULL, 215);
INSERT INTO "seafarers" VALUES (4653, '', 2, '', 214, 21, 42, NULL, NULL, 185);
INSERT INTO "seafarers" VALUES (4655, '', 2, '', 288, 2, 24, NULL, NULL, 243);
INSERT INTO "seafarers" VALUES (4656, '', 2, '', 278, 3, 70, NULL, NULL, 202);
INSERT INTO "seafarers" VALUES (4658, '', 2, '', 215, 13, 54, NULL, NULL, 190);
INSERT INTO "seafarers" VALUES (4659, '', 1, '', 179, 3, 16, NULL, NULL, 157);
INSERT INTO "seafarers" VALUES (4660, '', 1, '', 243, 53, 34, NULL, NULL, 165);
INSERT INTO "seafarers" VALUES (4662, '', 1, '', 178, 36, 19, NULL, NULL, 149);
INSERT INTO "seafarers" VALUES (4663, '', 2, '', 213, 13, 55, NULL, NULL, 191);
INSERT INTO "seafarers" VALUES (4668, '', 1, '', 204, 7, 14, NULL, NULL, 185);
INSERT INTO "seafarers" VALUES (4669, '', 3, '', 178, 2, 20, NULL, NULL, 185);
INSERT INTO "seafarers" VALUES (4670, '', 2, '', 221, 52, 130, NULL, NULL, 124);
INSERT INTO "seafarers" VALUES (4672, '', 2, '', 125, 5, 14, NULL, NULL, 116);
INSERT INTO "seafarers" VALUES (4673, '', 3, '', 172, 8, 19, NULL, NULL, 144);
INSERT INTO "seafarers" VALUES (4693, '', 1, '', 182, 36, 50, NULL, NULL, 124);
INSERT INTO "seafarers" VALUES (4695, '', 2, '', 338, 4, 45, 31, 92, 186);
INSERT INTO "seafarers" VALUES (4697, '', 4, '', 119, 10, 47, NULL, NULL, 99);
INSERT INTO "seafarers" VALUES (4699, '', 2, '', 77, 2, 17, NULL, NULL, 86);
INSERT INTO "seafarers" VALUES (4701, '', 2, '', 165, 8, 12, NULL, NULL, 209);
INSERT INTO "seafarers" VALUES (4703, '', 3, '', 162, 3, NULL, NULL, NULL, 147);
INSERT INTO "seafarers" VALUES (4704, '', 2, '', 212, 4, NULL, NULL, NULL, 149);
INSERT INTO "seafarers" VALUES (4705, '', 1, '', 202, 1, NULL, NULL, NULL, 185);
INSERT INTO "seafarers" VALUES (4708, '', 3, '', 179, 6, NULL, NULL, NULL, 240);
INSERT INTO "seafarers" VALUES (4709, '', 1, '', 331, 1, NULL, NULL, NULL, 98);
INSERT INTO "seafarers" VALUES (4712, '', 1, '', 211, 17, 80, NULL, NULL, 146);
INSERT INTO "seafarers" VALUES (4714, '', 1, '', 275, 5, NULL, NULL, NULL, 247);
INSERT INTO "seafarers" VALUES (4715, '', 2, '', 214, 16, 40, NULL, NULL, 171);
INSERT INTO "seafarers" VALUES (4726, '', 2, '', 215, 6, 24, NULL, NULL, 264);
INSERT INTO "seafarers" VALUES (4750, '', 3, '', 124, 16, 55, 6, NULL, 125);
INSERT INTO "seafarers" VALUES (4751, '', 1, '', 195, 18, NULL, NULL, NULL, 172);
INSERT INTO "seafarers" VALUES (4755, '', 1, '', 196, 13, 21, NULL, NULL, 188);
INSERT INTO "seafarers" VALUES (4756, '', 5, '', 307, NULL, NULL, NULL, NULL, 276);
INSERT INTO "seafarers" VALUES (4759, '', 1, '', 176, 3, NULL, NULL, NULL, 172);
INSERT INTO "seafarers" VALUES (4760, '', 1, '', 188, 6, 9, NULL, NULL, 174);
INSERT INTO "seafarers" VALUES (4762, '', 1, '', 212, 1, 12, 17, NULL, 199);
INSERT INTO "seafarers" VALUES (4769, '', 2, '', 204, 6, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (4775, '', 3, '', 47, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (4781, '', 3, '', 62, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (4782, '', 1, '', 227, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (4784, '', 2, '', 181, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (4785, '', 2, '', 195, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (4788, '', 1, '', 99, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (4789, '', 1, '', 173, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5382, '', 5, '', 130, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5383, '', 5, '', 99, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5384, '', 4, '', 127, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5385, '', 8, '', 107, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5401, '', 5, '', 126, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5402, '', 1, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5403, '', 3, '', 121, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5404, '', 6, '', 103, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5405, '', 5, '', 148, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5446, '', 3, '', 109, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5655, '', 4, '', 100, 64, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5660, '', 3, '', 94, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5662, '', 5, '', 114, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5663, '', 2, '', 104, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5664, '', 3, '', 98, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5665, '', 3, '', 108, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5666, '', 3, '', 102, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5670, '', 1, '', 113, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5671, '', 1, '', 127, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5673, '', 3, '', 118, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5675, '', 1, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5676, '', 1, '', 112, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5677, '', 1, '', 111, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5678, '', 1, '', 126, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5679, '', 1, '', 48, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5680, '', 1, '', 101, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5681, '', 1, '', 86, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5682, '', 1, '', 95, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5683, '', 3, '', 102, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5684, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5685, '', 1, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5686, '', 3, '', 135, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5687, '', 3, '', 57, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5690, '', 1, '', 95, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5692, '', 2, '', 85, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5693, '', 3, '', 87, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5694, '', 1, '', 118, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5695, '', 1, '', 76, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5696, '', 3, '', 130, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5697, '', 3, '', 107, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5698, '', 4, '', 115, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5699, '', 3, '', 79, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5702, '', 1, '', 83, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5703, '', 2, '', 135, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5704, '', 1, '', 53, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5705, '', 1, '', 64, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5706, '', 1, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5707, '', 2, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5708, '', 1, '', 114, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5709, '', 1, '', 108, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5710, '', 4, '', 107, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5711, '', 4, '', 98, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5712, '', 4, '', 105, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5714, '', 4, '', 85, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5715, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5716, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5717, '', 1, '', 116, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5720, '', 2, '', 87, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5721, '', 2, '', 129, 6, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5722, '', 2, '', 129, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5723, '', 2, '', 102, 7, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5724, '', 2, '', 105, 12, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5725, '', 1, '', 56, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5726, '', 2, '', 114, 5, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5727, '', 2, '', 48, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5728, '', 2, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5729, '', 1, '', 122, 3, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5732, '', 1, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5733, '', 3, '', 118, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5734, '', 2, '', 112, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5735, '', 1, '', 102, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5736, '', 1, '', 1109, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5737, '', 4, '', 106, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5738, '', 2, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5740, '', 1, '', 126, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5741, '', 4, '', 122, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5742, '', 3, '', 110, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5743, '', 1, '', 118, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5744, '', 4, '', 106, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5745, '', 4, '', 115, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5746, '', 2, '', 94, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5747, '', 2, '', 112, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5748, '', 2, '', 102, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5750, '', 4, '', 92, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5751, '', 1, '', 89, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5752, '', 5, '', 96, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5753, '', 2, '', 64, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5754, '', 1, '', 62, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5755, '', 3, '', 118, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5756, '', 3, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5757, '', 2, '', 112, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5758, '', 5, '', 115, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5759, '', 5, '', 109, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5760, '', 1, '', 81, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5761, '', 2, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5762, '', 1, '', 58, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5764, '', 2, '', 96, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5765, '', 4, '', 99, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5766, '', 1, '', 72, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5767, '', 1, '', 96, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5768, '', 4, '', 115, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5769, '', 3, '', 121, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5770, '', 1, '', 108, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5771, '', 2, '', 119, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5772, '', 1, '', 37, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5773, '', 2, '', 117, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5774, '', 5, '', 137, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5776, '', 1, '', 59, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5777, '', 1, '', 85, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5778, '', 1, '', 66, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5779, '', 1, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5780, '', 3, '', 118, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5781, '', 5, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5782, '', 4, '', 116, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5783, '', 4, '', 121, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5784, '', 6, '', 119, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5785, '', 3, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5786, '', 5, '', 116, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5787, '', 1, '', 131, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5788, '', 6, '', 111, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5789, '', 1, '', 57, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5815, '', 2, '', 42, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5829, '', 2, '', 64, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5830, '', 2, '', 78, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5831, '', 4, '', 111, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5832, '', 1, '', 62, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5833, '', 1, '', 87, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5873, '', 6, '', 95, 2, 21, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5879, '', 1, '', 60, 1, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5880, '', 1, '', 67, 5, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5882, '', 3, '', 72, 3, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5884, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5886, '', 1, '', 81, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5887, '', 3, '', 95, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5888, '', 1, '', 55, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5889, '', 4, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5894, '', 3, '', 80, 3, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5895, '', 4, '', 85, 3, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5896, '', 1, '', 80, 2, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5897, '', 1, '', 65, 3, 21, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5898, '', 2, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5899, '', 3, '', 85, 1, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5900, '', 1, '', 94, 1, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5901, '', 1, '', 83, 3, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5902, '', 3, '', 74, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5903, '', 2, '', 98, 2, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5905, '', 2, '', 87, 3, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5906, '', 1, '', 85, 4, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5907, '', 2, '', 100, 3, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5908, '', 4, '', 90, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5909, '', 1, '', 95, 10, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5910, '', 3, '', 95, 2, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5912, '', 2, '', 65, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5913, '', 1, '', 70, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5914, '', 2, '', 60, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5915, '', 2, '', 70, NULL, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5916, '', 1, '', 85, 3, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5917, '', 1, '', 92, 3, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5918, '', 3, '', 110, 16, 80, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5919, '', 3, '', 68, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5920, '', 3, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5921, '', 3, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5922, '', 4, '', 100, 2, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5923, '', 1, '', 85, 2, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5924, '', 1, '', 70, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5925, '', 1, '', 85, 7, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5926, '', 2, '', 80, 2, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5927, '', 1, '', 70, 2, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5928, '', 2, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5929, '', 2, '', 90, 2, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5930, '', 1, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5931, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5932, '', 1, '', 85, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5933, '', 3, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5934, '', 2, '', 70, 5, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5935, '', 1, '', 100, 5, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5936, '', 1, '', 85, NULL, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5937, '', 1, '', 85, 8, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5938, '', 1, '', 85, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5939, '', 1, '', 85, 5, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5940, '', 3, '', 100, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5941, '', 1, '', 100, NULL, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5942, '', 2, '', 70, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5947, '', 1, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5948, '', 1, '', 85, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5950, '', 2, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5951, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5952, '', 4, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5953, '', 1, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5954, '', 3, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5955, '', 1, '', 78, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5956, '', 2, '', 105, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5957, '', 2, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5958, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5959, '', 2, '', 95, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5960, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5962, '', 5, '', 105, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5963, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5964, '', 2, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5965, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5966, '', 1, '', 105, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5967, '', 1, '', 105, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5968, '', 2, '', 105, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5969, '', 2, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5970, '', 3, '', 105, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5971, '', 1, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5972, '', 2, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5973, '', 2, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5976, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5979, '', 3, '', 40, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5980, '', 1, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5981, '', 1, '', 87, NULL, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5983, '', 1, '', 95, 4, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5984, '', 1, '', 83, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5985, '', 2, '', 89, 5, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5986, '', 2, '', 86, 6, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5987, '', 1, '', 68, 1, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5987, 'A', 2, '', 94, 5, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5988, '', 4, '', 112, 3, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5989, '', 2, '', 78, 8, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5993, '', 2, '', 90, NULL, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5994, '', 2, '', 90, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5997, '', 1, '', 33, NULL, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (5999, '', 1, '', 33, NULL, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6000, '', 2, '', 90, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6001, '', 2, '', 90, 2, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6002, '', 2, '', 90, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6003, '', 2, '', 107, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6004, '', 2, '', 90, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6005, '', 1, '', 105, 2, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6006, '', 2, '', 90, NULL, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6009, '', 2, '', 73, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6010, '', 1, '', 70, 4, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6016, '', 1, '', 35, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6018, '', 1, '', 90, 4, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6019, '', 3, '', 90, 4, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6020, '', 2, '', 103, 5, 40, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6021, '', 3, '', 70, 3, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6022, '', 3, '', 90, 3, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6023, '', 4, '', 70, 1, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6024, '', 5, '', 105, 7, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6025, '', 4, '', 70, NULL, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6026, '', 3, '', 99, 5, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6032, '', 1, '', 71, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6033, '', 2, '', 70, 4, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6034, '', 3, '', 77, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6035, '', 2, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6037, '', 3, '', 105, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6038, '', 3, '', 105, 3, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6039, '', 1, '', 75, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6040, '', 1, '', 50, NULL, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6041, '', 2, '', 90, 4, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6042, '', 2, '', 70, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6043, '', 1, '', 55, NULL, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6044, '', 1, '', 105, 2, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6045, '', 3, '', 90, 5, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6046, '', 2, '', 105, 3, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6047, '', 1, '', 70, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6048, '', 3, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6053, '', 3, '', 90, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6054, '', 2, '', 90, NULL, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6055, '', 1, '', 60, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6056, '', 1, '', 60, 2, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6057, '', 1, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6058, '', 4, '', 70, 3, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6059, '', 3, '', 90, 4, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6060, '', 4, '', 70, 1, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6061, '', 3, '', 90, 4, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6062, '', 3, '', 90, 3, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6063, '', 1, '', 60, 2, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6064, '', 4, '', 90, 2, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6065, '', 3, '', 70, 1, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6066, '', 1, '', 105, 3, 17, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6067, '', 5, '', 90, NULL, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6070, '', 2, '', 70, NULL, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6073, '', 3, '', 90, NULL, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6074, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6075, '', 2, '', 90, 4, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6076, '', 1, '', 60, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6077, '', 1, '', 70, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6078, '', 2, '', 50, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6079, '', 3, '', 90, 2, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6080, '', 4, '', 90, 4, 23, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6081, '', 3, '', 90, 2, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6082, '', 2, '', 105, 4, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6083, '', 4, '', 90, 8, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6084, '', 2, '', 70, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6085, '', 4, '', 105, 4, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6086, '', 4, '', 90, 4, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6087, '', 4, '', 90, 2, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6088, '', 4, '', 90, 6, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6089, '', 6, '', 105, 4, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6094, '', 1, '', 46, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6095, '', 3, '', 56, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6096, '', 1, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6097, '', 1, '', 70, 6, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6098, '', 3, '', 90, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6099, '', 2, '', 60, 2, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6100, '', 2, '', 60, 1, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6101, '', 3, '', 90, 1, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6102, '', 4, '', 90, 3, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6103, '', 3, '', 105, 6, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6104, '', 1, '', 90, 4, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6105, '', 2, '', 105, 5, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6106, '', 4, '', 90, 6, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6112, '', 2, '', 70, 4, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6113, '', 5, '', 70, 3, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6114, '', 4, '', 90, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6115, '', 3, '', 70, 2, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6116, '', 2, '', 70, 10, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6118, '', 3, '', 90, 3, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6119, '', 4, '', 90, 5, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6120, '', 3, '', 70, 1, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6121, '', 3, '', 90, 6, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6122, '', 2, '', 65, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6123, '', 1, '', 90, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6124, '', 1, '', 90, 3, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6125, '', 4, '', 90, 5, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6126, '', 1, '', 90, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6130, '', 4, '', 91, 7, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6131, '', 2, '', 70, 4, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6132, '', 1, '', 70, 2, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6133, '', 5, '', 91, 8, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6134, '', 1, '', 50, NULL, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6136, '', 4, '', 90, 3, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6137, '', 2, '', 65, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6138, '', 3, '', 65, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6139, '', 2, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6140, '', 1, '', 105, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6141, '', 1, '', 90, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6142, '', 5, '', 90, 2, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6143, '', 4, '', 105, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6144, '', 3, '', 105, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6148, '', 2, '', 65, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6149, '', 2, '', 65, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6150, '', 4, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6151, '', 3, '', 65, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6153, '', 2, '', 90, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6154, '', 1, '', 90, 5, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6155, '', 5, '', 90, 5, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6156, '', 4, '', 90, 5, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6157, '', 3, '', 105, 4, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6158, '', 1, '', 70, 1, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6165, '', 1, '', 65, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6166, '', 1, '', 65, 2, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6167, '', 1, '', 70, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6169, '', 2, '', 90, 5, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6170, '', 3, '', 65, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6171, '', 1, '', 105, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6172, '', 2, '', 90, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6173, '', 1, '', 90, 1, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6174, '', 5, '', 105, 4, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6175, '', 5, '', 90, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6176, '', 1, '', 65, 1, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6177, '', 4, '', 60, 3, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6185, '', 1, '', 64, 4, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6187, '', 1, '', 65, 2, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6188, '', 1, '', 90, 1, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6189, '', 1, '', 105, 3, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6190, '', 1, '', 90, 2, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6191, '', 4, '', 65, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6192, '', 2, '', 65, 4, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6193, '', 1, '', 90, 3, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6194, '', 3, '', 65, 1, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6195, '', 3, '', 90, 6, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6201, '', 2, '', 90, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6202, '', 1, '', 90, 3, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6203, '', 1, '', 65, 4, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6209, '', 1, '', 65, 2, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6210, '', 6, '', 90, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6211, '', 3, '', 90, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6212, '', 4, '', 90, 1, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6213, '', 2, '', 50, 1, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6215, '', 1, '', 145, 2, 17, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6216, '', 2, '', 105, 3, 22, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6217, '', 6, '', 90, NULL, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6218, '', 1, '', 90, NULL, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6219, '', 5, '', 90, 3, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6228, '', 1, '', 65, 1, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6229, '', 1, '', 70, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6230, '', 1, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6232, '', 1, '', 50, NULL, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6233, '', 2, '', 105, 3, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6234, '', 4, '', 65, 2, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6235, '', 2, '', 105, 3, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6236, '', 2, '', 90, 4, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6237, '', 1, '', 105, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6238, '', 1, '', 107, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6239, '', 6, '', 105, 8, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6240, '', 1, '', 90, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6241, '', 2, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6248, '', 1, '', 65, 1, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6249, '', 2, '', 90, 4, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6251, '', 1, '', 145, 3, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6252, '', 4, '', 65, 1, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6253, '', 1, '', 65, NULL, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6254, '', 3, '', 90, 1, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6255, '', 3, '', 50, NULL, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6256, '', 2, '', 90, 3, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6257, '', 1, '', 90, 2, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6258, '', 2, '', 70, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6259, '', 6, '', 105, 7, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6260, '', 5, '', 105, 1, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6261, '', 1, '', 65, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6269, '', 3, '', 100, NULL, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6270, '', 3, '', 100, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6271, '', 1, '', 80, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6273, '', 3, '', 105, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6274, '', 2, '', 90, 5, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6275, '', 7, '', 90, 4, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6276, '', 1, '', 90, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6277, '', 2, '', 65, 2, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6279, '', 2, '', 65, 5, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6280, '', 2, '', 145, 2, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6281, '', 1, '', 65, NULL, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6287, '', 4, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6288, '', 1, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6290, '', 4, '', 65, 5, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6291, '', 2, '', 65, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6292, '', 2, '', 65, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6293, '', 3, '', 65, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6294, '', 3, '', 90, 3, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6295, '', 4, '', 90, 3, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6296, '', 2, '', 65, 3, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6297, '', 2, '', 65, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6298, '', 2, '', 65, 2, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6299, '', 1, '', 90, 4, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6300, '', 2, '', 90, 4, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6307, '', 1, '', 75, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6308, '', 6, '', 100, 2, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6309, '', 2, '', 70, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6310, '', 4, '', 105, 4, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6311, '', 3, '', 65, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6312, '', 6, '', 105, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6313, '', 2, '', 115, 7, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6314, '', 4, '', 90, 2, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6315, '', 1, '', 90, 2, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6316, '', 2, '', 65, 2, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6317, '', 8, '', 90, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6318, '', 5, '', 65, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6319, '', 1, '', 65, 4, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6320, '', 6, '', 90, 2, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6321, '', 2, '', 105, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6322, '', 3, '', 90, 3, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6323, '', 2, '', 65, 5, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6324, '', 1, '', 45, NULL, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6325, '', 5, '', 90, 4, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6326, '', 3, '', 105, 3, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6334, '', 2, '', 70, 3, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6335, '', 3, '', 75, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6336, '', 3, '', 75, 2, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6340, '', 3, '', 60, 1, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6341, '', 1, '', 60, NULL, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6342, '', 2, '', 45, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6343, '', 1, '', 105, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6344, '', 1, '', 95, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6345, '', 3, '', 95, 1, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6346, '', 3, '', 60, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6347, '', 2, '', 80, 1, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6348, '', 3, '', 60, 1, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6349, '', 1, '', 95, 2, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6350, '', 4, '', 60, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6351, '', 3, '', 80, 5, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6352, '', 3, '', 80, 2, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6353, '', 3, '', 60, 3, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6354, '', 3, '', 80, 6, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6355, '', 3, '', 80, 2, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6356, '', 3, '', 80, 6, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6362, '', 5, '', 65, 1, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6363, '', 1, '', 65, 3, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6364, '', 2, '', 65, 2, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6365, '', 1, '', 60, NULL, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6366, '', 5, '', 60, 2, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6367, '', 3, '', 60, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6368, '', 1, '', 95, 6, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6369, '', 4, '', 80, 4, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6370, '', 4, '', 80, 6, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6371, '', 3, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6372, '', 1, '', 80, 6, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6373, '', 1, '', 60, 4, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6374, '', 1, '', 45, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6375, '', 2, '', 80, 8, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6376, '', 5, '', 95, 2, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6377, '', 3, '', 95, 1, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6378, '', 6, '', 80, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6379, '', 3, '', 60, 3, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6381, '', 7, '', 95, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6382, '', 6, '', 80, 2, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6383, '', 4, '', 95, 1, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6384, '', 1, '', 105, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6385, '', 3, '', 94, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6386, '', 2, '', 95, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6387, '', 1, '', 95, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6388, '', 1, '', 77, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6389, '', 2, '', 77, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6390, '', 1, '', 65, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6391, '', 1, '', 65, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6392, '', 1, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6393, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6396, '', 1, '', 60, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6397, '', 3, '', 95, 4, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6398, '', 2, '', 95, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6399, '', 2, '', 80, NULL, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6400, '', 1, '', 80, 1, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6401, '', 3, '', 80, 3, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6402, '', 1, '', 80, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6403, '', 2, '', 60, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6404, '', 1, '', 60, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6405, '', 2, '', 45, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6406, '', 4, '', 95, 4, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6407, '', 4, '', 60, NULL, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6408, '', 2, '', 95, 4, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6415, '', 1, '', 90, NULL, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6416, '', 3, '', 90, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6417, '', 3, '', 70, 1, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6418, '', 4, '', 85, NULL, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6419, '', 4, '', 100, 3, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6420, '', 3, '', 60, 3, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6421, '', 2, '', 85, 1, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6422, '', 2, '', 100, 7, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6423, '', 3, '', 60, 1, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6424, '', 3, '', 85, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6425, '', 1, '', 100, 2, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6426, '', 5, '', 60, NULL, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6427, '', 4, '', 85, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6430, '', 2, '', 60, NULL, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6431, '', 3, '', 85, 1, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6432, '', 3, '', 85, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6433, '', 1, '', 100, 5, 17, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6434, '', 2, '', 60, 3, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6440, '', 2, '', 70, NULL, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6441, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6442, '', 5, '', 110, NULL, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6443, '', 2, '', 70, NULL, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6444, '', 1, '', 110, 2, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6445, '', 4, '', 60, NULL, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6446, '', 2, '', 45, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6447, '', 3, '', 80, NULL, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6454, '', 1, '', 95, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6455, '', 4, '', 60, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6456, '', 1, '', 95, 3, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6457, '', 6, '', 60, 1, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6458, '', 1, '', 60, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6459, '', 5, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6460, '', 3, '', 95, 4, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6461, '', 4, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6462, '', 2, '', 45, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6463, '', 5, '', 80, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6464, '', 1, '', 60, 3, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6465, '', 3, '', 95, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6466, '', 5, '', 95, 4, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6467, '', 1, '', 75, 1, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6468, '', 1, '', 95, 4, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6469, '', 4, '', 95, 4, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6470, '', 1, '', 75, 3, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6471, '', 2, '', 95, 3, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6472, '', 2, '', 66, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6473, '', 1, '', 80, 1, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6474, '', 3, '', 66, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6475, '', 2, '', 66, 1, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6476, '', 1, '', 66, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6477, '', 1, '', 66, NULL, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6487, '', 6, '', 100, 2, 19, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6488, '', 3, '', 100, 2, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6489, '', 4, '', 65, 2, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6490, '', 3, '', 65, 1, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6491, '', 1, '', 100, 3, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6492, '', 1, '', 50, NULL, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6493, '', 5, '', 100, 4, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6494, '', 2, '', 85, NULL, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6495, '', 2, '', 100, 2, 23, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6496, '', 2, '', 85, 2, 19, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6497, '', 2, '', 65, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6498, '', 5, '', 85, 3, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6499, '', 1, '', 85, 6, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6500, '', 2, '', 100, 5, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6501, '', 1, '', 85, NULL, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6502, '', 3, '', 66, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6503, '', 3, '', 85, 5, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6504, '', 1, '', 90, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6505, '', 3, '', 90, NULL, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6506, '', 1, '', 90, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6507, '', 1, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6508, '', 1, '', 105, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6509, '', 1, '', 80, NULL, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6510, '', 4, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6511, '', 1, '', 80, NULL, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6512, '', 4, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6513, '', 5, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6521, '', 2, '', 105, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6522, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6523, '', 2, '', 90, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6524, '', 2, '', 70, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6525, '', 1, '', 70, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6526, '', 1, '', 70, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6527, '', 6, '', 90, 2, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6528, '', 5, '', 70, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6529, '', 3, '', 50, NULL, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6530, '', 3, '', 70, 3, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6531, '', 5, '', 90, 3, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6532, '', 6, '', 90, 1, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6533, '', 4, '', 105, 16, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6534, '', 1, '', 75, NULL, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6535, '', 1, '', 75, 3, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6536, '', 2, '', 75, 2, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6537, '', 5, '', 75, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6538, '', 3, '', 66, NULL, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6539, '', 2, '', 80, 1, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6551, '', 2, '', 94, NULL, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6565, '', 1, '', 99, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6566, '', 1, '', 98, 1, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6568, '', 1, '', 85, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6570, '', 3, '', 80, NULL, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6572, '', 3, '', 110, NULL, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6574, '', 2, '', 102, 5, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6575, '', 1, '', 150, 3, 28, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6576, '', 2, '', 96, NULL, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6577, '', 4, '', 96, 2, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6578, '', 2, '', 96, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6579, '', 4, '', 125, 4, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6580, '', 6, '', 150, 7, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6581, '', 3, '', 125, 7, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6582, '', 4, '', 96, 3, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6583, '', 5, '', 150, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6584, '', 1, '', 50, 2, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6589, '', 3, '', 125, 3, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6590, '', 4, '', 96, 1, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6591, '', 2, '', 96, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6592, '', 1, '', 150, 1, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6593, '', 3, '', 125, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6594, '', 1, '', 150, 5, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6595, '', 2, '', 90, 4, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6596, '', 1, '', 110, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6597, '', 1, '', 110, NULL, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6599, '', 4, '', 90, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6600, '', 1, '', 80, 1, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6631, '', 1, '', 15, 3, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6632, '', 1, '', 20, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6633, '', 4, '', 20, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6634, '', 2, '', 20, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6635, '', 1, '', 20, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6636, '', 1, '', 80, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6665, '', 3, '', 15, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6666, '', 2, '', 15, 3, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6667, '', 5, '', 20, 6, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6668, '', 2, '', 15, 3, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6669, '', 1, '', 20, 4, 21, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6670, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6671, '', 2, '', 15, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6672, '', 3, '', 15, NULL, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6673, '', 4, '', 15, 5, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6674, '', 5, '', 15, 1, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6675, '', 1, '', 81, 5, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6676, '', 3, '', 60, 1, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6677, '', 4, '', 85, 3, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6678, '', 3, '', 98, 3, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6679, '', 3, '', 80, 6, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6680, '', 3, '', 55, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6681, '', 1, '', 64, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6682, '', 6, '', 100, 1, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6683, '', 1, '', 63, 1, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6684, '', 3, '', 14, NULL, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6695, '', 2, '', 85, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6701, '', 2, '', 78, NULL, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6702, '', 1, '', 78, 3, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6703, '', 2, '', 67, NULL, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6704, '', 1, '', 68, 3, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6705, '', 5, '', 70, 4, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6706, '', 1, '', 78, 1, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6708, '', 4, '', 20, 2, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6709, '', 3, '', 20, 4, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6710, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6711, '', 4, '', 15, 3, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6712, '', 3, '', 12, 5, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6713, '', 5, '', 12, NULL, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6714, '', 2, '', 15, 8, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6715, '', 8, '', 20, 6, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6716, '', 3, '', 15, 5, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6717, '', 5, '', 21, 2, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6718, '', 5, '', 12, 4, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6719, '', 3, '', 12, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6730, '', 1, '', 105, 5, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6731, '', 3, '', 78, 2, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6732, '', 3, '', 105, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6733, '', 1, '', 102, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6735, '', 2, '', 84, 1, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6736, '', 3, '', 81, 3, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6737, '', 4, '', 65, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6738, '', 2, '', 58, NULL, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6739, '', 3, '', 65, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6740, '', 3, '', 84, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6741, '', 1, '', 64, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6742, '', 5, '', 37, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6743, '', 2, '', 64, 1, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6744, '', 7, '', 99, 2, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6745, '', 3, '', 81, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6750, '', 2, '', 85, 3, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6752, '', 2, '', 84, 1, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6753, '', 6, '', 101, 5, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6755, '', 2, '', 95, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6756, '', 3, '', 92, 5, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6758, '', 4, '', 93, 4, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6759, '', 3, '', 90, 4, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6760, '', 1, '', 70, 3, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6761, '', 1, '', 58, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6762, '', 4, '', 7, 2, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6763, '', 4, '', 4, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6764, '', 6, '', 4, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6765, '', 4, '', 6, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6766, '', 3, '', 4, 3, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6767, '', 5, '', 7, 3, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6768, '', 4, '', 4, 2, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6769, '', 5, '', 6, 1, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6770, '', 4, '', 6, 4, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6771, '', 2, '', 4, 2, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6772, '', 4, '', 125, 2, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6773, '', 1, '', 91, 15, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6774, '', 6, '', 93, 4, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6775, '', 1, '', 56, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6776, '', 4, '', 94, 5, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6778, '', 1, '', 58, 5, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6790, '', 2, '', 79, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6791, '', 3, '', 77, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6792, '', 5, '', 20, 5, 17, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6793, '', 1, '', 16, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6794, '', 5, '', 24, 3, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6795, '', 2, '', 2, NULL, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6796, '', 4, '', 20, 6, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6797, '', 7, '', 24, 4, 28, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6798, '', 4, '', 17, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6799, '', 3, '', 20, 5, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6800, '', 2, '', 16, 4, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6801, '', 8, '', 24, 2, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6802, '', 1, '', 20, 1, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6803, '', 1, '', 16, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6804, '', 1, '', 21, NULL, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6805, '', 3, '', 19, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6807, '', 3, '', 16, 3, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6808, '', 3, '', 6, 11, 30, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6813, '', 5, '', 49, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6814, '', 4, '', 49, 4, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6815, '', 2, '', 78, 3, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6816, '', 4, '', 113, 3, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6817, '', 5, '', 110, 5, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6818, '', 1, '', 92, 1, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6819, '', 4, '', 66, 2, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6820, '', 3, '', 80, 3, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6821, '', 5, '', 96, 3, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6822, '', 4, '', 71, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6823, '', 7, '', 113, 4, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6824, '', 4, '', 73, 4, 22, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6825, '', 5, '', 112, 9, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6826, '', 5, '', 87, NULL, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6827, '', 6, '', 108, 4, 17, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6828, '', 6, '', 92, 2, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6829, '', 1, '', 116, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6830, '', 3, '', 110, 1, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6831, '', 1, '', 112, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6836, '', 7, '', 71, 3, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6837, '', 3, '', 86, 6, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6838, '', 4, '', 87, 6, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6839, '', 2, '', 70, 7, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6840, '', 3, '', 97, 5, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6841, '', 1, '', 72, 1, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6842, '', 4, '', 71, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6843, '', 3, '', 69, 1, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6844, '', 1, '', 76, 9, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6845, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6846, '', 2, '', 93, 5, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6847, '', 2, '', 83, 1, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6848, '', 4, '', 85, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6849, '', 4, '', 106, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6850, '', 4, '', 84, 3, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6851, '', 1, '', 95, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6852, '', 2, '', 95, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6853, '', 4, '', 67, NULL, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6854, '', 5, '', 95, 4, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6855, '', 3, '', 57, 1, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6856, '', 3, '', 95, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6857, '', 5, '', 106, 5, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6858, '', 5, '', 63, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6859, '', 1, '', 69, 6, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6860, '', 8, '', 107, 4, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6861, '', 5, '', 106, 1, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6862, '', 1, '', 86, 3, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6863, '', 2, '', 72, 3, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6864, '', 1, '', 116, 2, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6865, '', 5, '', 141, 1, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6867, '', 4, '', 112, NULL, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6870, '', 6, '', 75, 7, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6871, '', 3, '', 88, 8, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6872, '', 3, '', 75, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6873, '', 1, '', 75, 9, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6874, '', 4, '', 67, 2, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6875, '', 2, '', 77, 4, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6876, '', 2, '', 71, 2, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6877, '', 1, '', 66, 6, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6878, '', 6, '', 83, 3, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6879, '', 1, '', 70, 2, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6880, '', 4, '', 88, 4, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6881, '', 3, '', 66, 3, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6882, '', 7, '', 80, 4, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6883, '', 1, '', 65, 4, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6884, '', 1, '', 94, 6, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6885, '', 6, '', 88, 2, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6886, '', 4, '', 90, 11, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6887, '', 5, '', 135, 5, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6888, '', 1, '', 90, 12, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6891, '', 6, '', 71, NULL, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6892, '', 5, '', 67, 9, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6893, '', 1, '', 110, NULL, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6894, '', 1, '', 89, NULL, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6895, '', 1, '', 94, 57, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6904, '', 2, '', 72, 2, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6905, '', 1, '', 97, 4, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6907, '', 4, '', 69, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6908, '', 3, '', 72, 4, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6909, '', 4, '', 124, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6910, '', 3, '', 93, 5, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6911, '', 5, '', 105, 15, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6912, '', 1, '', 120, 3, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6913, '', 2, '', 87, 3, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6914, '', 9, '', 105, 6, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6915, '', 1, '', 68, 6, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6916, '', 3, '', 69, 4, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6917, '', 3, '', 66, 3, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6918, '', 1, '', 67, 4, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6919, '', 2, '', 87, 3, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6920, '', 2, '', 102, 4, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6921, '', 1, '', 95, 10, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6923, '', 4, '', 74, 4, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6924, '', 3, '', 74, 3, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6925, '', 1, '', 74, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6928, '', 2, '', 114, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6929, '', 5, '', 113, 1, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6931, '', 1, '', 91, 1, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6932, '', 1, '', 62, 3, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6933, '', 6, '', 105, 8, 25, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6935, '', 3, '', 70, 5, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6936, '', 5, '', 78, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6937, '', 6, '', 85, 3, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6938, '', 2, '', 60, 3, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6939, '', 5, '', 97, 5, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6941, '', 3, '', 66, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6942, '', 6, '', 108, 7, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6943, '', 4, '', 68, 3, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6944, '', 1, '', 73, 3, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6945, '', 1, '', 75, 3, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6946, '', 7, '', 104, 5, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6947, '', 2, '', 72, 2, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6952, '', 1, '', 62, 5, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6953, '', 1, '', 60, 4, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6954, '', 4, '', 78, 3, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6955, '', 1, '', 90, 2, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6956, '', 5, '', 91, 3, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6957, '', 1, '', 91, 6, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6958, '', 5, '', 100, 3, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6959, '', 3, '', 89, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6960, '', 5, '', 105, 5, 19, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6961, '', 5, '', 118, 12, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6962, '', 1, '', 118, 11, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6963, '', 5, '', 92, 4, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6964, '', 3, '', 70, 3, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6965, '', 2, '', 80, 3, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6966, '', 1, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6967, '', 1, '', 60, 4, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6968, '', 2, '', 70, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6969, '', 1, '', 90, 7, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6970, '', 2, '', 70, 7, 17, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6971, '', 5, '', 90, 3, 23, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6972, '', 2, '', 90, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6973, '', 3, '', 70, 7, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6974, '', 2, '', 70, 6, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6975, '', 6, '', 70, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6976, '', 1, '', 90, 4, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6977, '', 6, '', 90, 8, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6978, '', 3, '', 70, 4, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6979, '', 2, '', 90, 5, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6983, '', 4, '', 72, 3, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6984, '', 3, '', 115, 5, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6985, '', 1, '', 88, 5, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6986, '', 10, '', 143, 6, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6988, '', 2, '', 70, 7, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6989, '', 1, '', 67, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6990, '', 5, '', 115, 4, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6991, '', 2, '', 88, 6, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6992, '', 3, '', 115, 4, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6993, '', 2, '', 115, 11, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6998, '', 3, '', 81, 14, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (6999, '', 3, '', 106, 5, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7000, '', 6, '', 81, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7001, '', 3, '', 106, 3, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7002, '', 1, '', 80, 2, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7003, '', 1, '', 106, 12, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7004, '', 4, '', 80, 5, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7005, '', 1, '', 85, 5, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7006, '', 6, '', 105, 4, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7007, '', 4, '', 65, 3, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7008, '', 1, '', 65, 2, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7009, '', 5, '', 65, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7010, '', 4, '', 65, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7011, '', 2, '', 85, 2, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7012, '', 6, '', 85, 4, 19, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7013, '', 2, '', 65, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7014, '', 3, '', 65, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7015, '', 2, '', 65, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7017, '', 1, '', 85, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7023, '', 2, '', 85, 9, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7024, '', 2, '', 85, 2, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7025, '', 2, '', 60, 6, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7026, '', 1, '', 60, 5, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7027, '', 7, '', 105, 22, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7028, '', 5, '', 85, 13, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7029, '', 2, '', 65, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7030, '', 1, '', 65, 7, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7031, '', 1, '', 65, 10, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7035, '', 1, '', 85, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7036, '', 3, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7037, '', 2, '', 65, 15, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7038, '', 1, '', 65, 15, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7039, '', 2, '', 80, 7, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7040, '', 2, '', 80, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7041, '', 2, '', 85, 3, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7042, '', 7, '', 85, 3, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7043, '', 2, '', 85, 4, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7044, '', 7, '', 85, 6, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7045, '', 7, '', 65, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7046, '', 2, '', 85, 6, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7047, '', 3, '', 65, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7048, '', 2, '', 65, NULL, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7049, '', 3, '', 85, 3, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7050, '', 6, '', 85, 4, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7051, '', 3, '', 65, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7052, '', 2, '', 74, 5, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7054, '', 5, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7056, '', 6, '', 100, 3, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7057, '', 1, '', 85, 1, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7058, '', 1, '', 65, 3, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7059, '', 1, '', 85, 8, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7060, '', 3, '', 65, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7061, '', 5, '', 65, 3, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7062, '', 4, '', 85, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7066, '', 5, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7068, '', 1, '', 65, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7069, '', 1, '', 85, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7070, '', 4, '', 85, 3, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7071, '', 1, '', 85, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7072, '', 6, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7073, '', 1, '', 80, 2, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7074, '', 2, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7075, '', 2, '', 88, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7076, '', 4, '', 73, 1, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7077, '', 4, '', 66, 1, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7078, '', 2, '', 77, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7079, '', 3, '', 71, 3, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7080, '', 2, '', 74, NULL, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7081, '', 5, '', 70, NULL, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7082, '', 3, '', 75, 5, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7091, '', 3, '', 82, 8, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7092, '', 1, '', 89, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7093, '', 7, '', 75, 4, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7094, '', 2, '', 92, NULL, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7095, '', 4, '', 72, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7096, '', 3, '', 70, 15, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7097, '', 6, '', 80, 15, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7098, '', 4, '', 60, 9, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7099, '', 7, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7100, '', 2, '', 90, 11, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7102, '', 2, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7103, '', 3, '', 90, 2, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7104, '', 7, '', 90, 3, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7105, '', 3, '', 90, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7106, '', 3, '', 70, 5, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7107, '', 1, '', 70, 2, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7108, '', 2, '', 70, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7109, '', 1, '', 90, 1, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7110, '', 3, '', 70, 1, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7111, '', 1, '', 75, 4, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7112, '', 1, '', 75, 6, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7113, '', 4, '', 75, 5, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7114, '', 3, '', 75, 7, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7115, '', 2, '', 90, 3, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7116, '', 4, '', 90, NULL, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7117, '', 3, '', 100, 3, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7118, '', 2, '', 75, NULL, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7119, '', 3, '', 95, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7120, '', 3, '', 100, 6, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7121, '', 5, '', 90, 3, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7122, '', 1, '', 70, 2, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7123, '', 2, '', 90, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7124, '', 2, '', 90, 7, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7125, '', 2, '', 70, 5, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7126, '', 4, '', 111, NULL, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7127, '', 7, '', 114, 4, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7130, '', 1, '', 98, 5, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7135, '', 1, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7151, '', 3, '', 90, 2, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7152, '', 6, '', 90, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7153, '', 4, '', 90, 5, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7154, '', 2, '', 75, 4, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7159, '', 4, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7162, '', 1, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7166, '', 1, '', 95, NULL, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7168, '', 1, '', 95, 2, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7169, '', 5, '', 78, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7170, '', 4, '', 77, 12, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7171, '', 3, '', 78, 13, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7172, '', 4, '', 77, 13, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7174, '', 2, '', 80, 7, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7175, '', 1, '', 80, 4, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7177, '', 1, '', 73, 4, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7178, '', 2, '', 73, 3, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7179, '', 1, '', 81, 8, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7180, '', 1, '', 100, 4, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7181, '', 1, '', 100, 10, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7182, '', 5, '', 75, 2, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7183, '', 1, '', 76, 4, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7184, '', 3, '', 89, 7, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7185, '', 3, '', 95, 1, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7186, '', 1, '', 118, 3, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7187, '', 3, '', 87, 8, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7188, '', 3, '', 79, 8, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7189, '', 2, '', 76, 5, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7191, '', 5, '', 102, 3, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7194, '', 2, '', 77, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7199, '', 2, '', 86, 5, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7204, '', 2, '', 73, 4, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7205, '', 2, '', 95, 6, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7206, '', 2, '', 64, 3, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7207, '', 3, '', 99, 3, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7208, '', 2, '', 90, 4, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7209, '', 5, '', 77, 1, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7210, '', 5, '', 76, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7211, '', 2, '', 108, 4, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7212, '', 1, '', 78, 4, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7213, '', 1, '', 104, 4, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7214, '', 3, '', 76, 3, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7215, '', 3, '', 90, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7220, '', 1, '', 83, 18, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7228, '', 6, '', 65, 7, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7229, '', 1, '', 104, 4, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7230, '', 2, '', 87, 4, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7231, '', 1, '', 81, 3, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7232, '', 1, '', 82, 6, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7233, '', 1, '', 94, 7, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7234, '', 1, '', 74, 1, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7235, '', 1, '', 64, 7, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7241, '', 2, '', 95, 4, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7242, '', 4, '', 89, 3, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7243, '', 3, '', 89, 4, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7245, '', 2, '', 70, 5, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7246, '', 1, '', 59, 3, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7248, '', 6, '', 79, 4, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7249, '', 1, '', 85, 4, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7250, '', 3, '', 90, 3, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7251, '', 2, '', 99, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7252, '', 1, '', 100, 3, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7253, '', 3, '', 78, 11, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7254, '', 1, '', 69, 9, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7255, '', 4, '', 98, 7, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7256, '', 2, '', 68, 5, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7258, '', 2, '', 70, 1, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7259, '', 5, '', 93, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7260, '', 4, '', 84, 15, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7264, '', 1, '', 85, 4, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7268, '', 2, '', 92, 2, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7270, '', 1, '', 105, 4, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7271, '', 2, '', 84, 11, 22, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7272, '', 1, '', 84, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7273, '', 2, '', 80, 5, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7278, '', 1, '', 88, 7, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7298, '', 1, '', 99, 9, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7299, '', 1, '', 85, 13, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7316, '', 2, '', 91, 2, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7317, '', 1, '', 105, 6, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7318, '', 1, '', 76, 2, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7319, '', 2, '', 93, 5, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7320, '', 2, '', 120, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7321, '', 5, '', 78, 3, 1, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7322, '', 4, '', 80, 5, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7324, '', 1, '', 93, 4, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7326, '', 3, '', 89, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7327, '', 2, '', 91, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7328, '', 3, '', 87, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7330, '', 3, '', 98, 8, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7331, '', 2, '', 109, 5, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7333, '', 1, '', 81, 2, 19, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7338, '', 2, '', 98, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7339, '', 2, '', 94, 7, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7340, '', 2, '', 92, 6, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7341, '', 1, '', 110, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7342, '', 3, '', 110, 2, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7343, '', 1, '', 91, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7344, '', 1, '', 104, 6, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7345, '', 2, '', 108, 1, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7346, '', 2, '', 99, NULL, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7350, '', 1, '', 83, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7351, '', 4, '', 93, 1, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7353, '', 3, '', 92, 13, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7354, '', 1, '', 83, 40, 26, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7355, '', 1, '', 92, 25, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7356, '', 3, '', 83, NULL, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7357, '', 4, '', 102, 2, 26, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7358, '', 2, '', 87, 20, 50, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7363, '', 2, '', 10, 4, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7368, '', 3, '', 104, NULL, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7373, '', 2, '', 16, 10, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7374, '', 1, '', 101, 1, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7375, '', 4, '', 91, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7376, '', 1, '', 5, 8, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7377, '', 1, '', 6, 5, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7378, '', 4, '', 98, 1, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7379, '', 3, '', 3, 12, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7380, '', 3, '', 10, 10, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7382, '', 3, '', 3, 4, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7383, '', 1, '', 8, 1, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7384, '', 3, '', 10, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7385, '', 3, '', 15, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7386, '', 2, '', 103, 5, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7387, '', 2, '', 17, 4, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7389, '', 2, '', 15, 1, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7392, '', 1, '', 103, 9, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7393, '', 2, '', 97, 4, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7394, '', 1, '', 109, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7398, '', 2, '', 107, 7, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7399, '', 2, '', 12, 8, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7400, '', 1, '', 3, 9, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7401, '', 4, '', 5, 7, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7402, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7404, '', 3, '', 100, NULL, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7526, '', 5, '', 18, NULL, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7528, '', 2, '', 92, 7, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7529, '', 1, '', 104, 3, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7530, '', 5, '', 91, 1, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7531, '', 3, '', 106, 6, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7533, '', 3, '', 93, 5, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7534, '', 3, '', 109, 9, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7535, '', 4, '', 92, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7536, '', 4, '', 107, 6, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7537, '', 3, '', 90, 5, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7538, '', 4, '', 96, 3, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7539, '', 3, '', 98, 3, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7540, '', 2, '', 92, 7, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7548, '', 3, '', 108, 5, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7549, '', 2, '', 113, 5, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7553, '', 2, '', 95, 9, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7554, '', 6, '', 83, 1, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7555, '', 1, '', 100, 2, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7556, '', 1, '', 90, 5, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7557, '', 4, '', 89, 3, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7558, '', 3, '', 85, 4, 17, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7559, '', 3, '', 99, 2, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7560, '', 1, '', 112, 5, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7561, '', 3, '', 94, 4, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7562, '', 2, '', 91, 4, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7563, '', 3, '', 93, 12, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7564, '', 2, '', 85, 3, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7565, '', 4, '', 94, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7566, '', 4, '', 80, 3, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7567, '', 6, '', 84, 5, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7572, '', 2, '', 94, 3, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7573, '', 2, '', 96, 4, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7574, '', 5, '', 89, 4, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7583, '', 4, '', 94, 3, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7584, '', 2, '', 101, 4, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7585, '', 5, '', 89, NULL, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7586, '', 2, '', 92, 7, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7587, '', 2, '', 103, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7588, '', 5, '', 100, 4, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7589, '', 1, '', 99, NULL, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7593, '', 4, '', 100, NULL, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7599, '', 3, '', 77, 6, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7600, '', 3, '', 100, 5, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7601, '', 3, '', 101, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7602, '', 1, '', 109, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7603, '', 2, '', 103, 3, 30, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7605, '', 4, '', 96, 3, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7606, '', 5, '', 95, 6, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7607, '', 3, '', 90, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7609, '', 4, '', 100, 3, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7611, '', 2, '', 114, 7, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7612, '', 1, '', 92, 5, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7613, '', 3, '', 95, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7614, '', 3, '', 94, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7615, '', 4, '', 91, 3, 27, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7616, '', 3, '', 101, 5, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7617, '', 1, '', 101, 4, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7624, '', 4, '', 108, 8, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7625, '', 4, '', 109, 4, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7630, '', 6, '', 98, 11, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7631, '', 2, '', 87, 6, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7633, '', 4, '', 105, 9, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7634, '', 4, '', 95, 4, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7635, '', 4, '', 101, 4, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7636, '', 5, '', 89, 8, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7637, '', 3, '', 96, 6, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7649, '', 5, '', 2, 5, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7650, '', 2, '', 91, 4, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7651, '', 2, '', 100, 6, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7652, '', 5, '', 84, 8, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7653, '', 2, '', 105, 8, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7654, '', 1, '', 104, 7, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7655, '', 3, '', 8, 8, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7656, '', 4, '', 95, 7, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7668, '', 3, '', 98, NULL, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7669, '', 1, '', 117, 2, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7670, '', 6, '', 8, 7, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7671, '', 2, '', 107, 6, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7672, '', 5, '', 93, 10, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7673, '', 2, '', 105, 10, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7674, '', 4, '', 91, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7675, '', 4, '', 95, 8, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7676, '', 4, '', 71, 6, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7687, '', 6, '', 6, 13, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7688, '', 4, '', 82, 12, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7692, '', 5, '', 12, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7693, '', 6, '', 98, 7, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7694, '', 3, '', 97, 8, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7695, '', 3, '', 95, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7696, '', 4, '', 104, 4, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7697, '', 3, '', 110, 4, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7698, '', 4, '', 104, 8, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7699, '', 3, '', 109, 6, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7700, '', 2, '', 97, 5, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7705, '', 4, '', 105, 7, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7706, '', 2, '', 106, 9, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7716, '', 1, '', 89, 5, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7717, '', 2, '', 113, 5, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7718, '', 1, '', 90, 2, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7719, '', 6, '', 93, 7, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7720, '', 4, '', 103, 10, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7721, '', 1, '', 97, 6, 17, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7722, '', 4, '', 104, 10, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7739, '', 2, '', 100, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7740, '', 2, '', 111, 5, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7741, '', 4, '', 114, 5, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7742, '', 3, '', 95, 4, 17, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7743, '', 6, '', 102, 11, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7744, '', 1, '', 100, 4, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7745, '', 4, '', 104, 5, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7746, '', 1, '', 104, 3, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7747, '', 1, '', 122, 3, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7756, '', 3, '', 107, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7764, '', 2, '', 99, 12, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7765, '', 5, '', 101, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7766, '', 2, '', 107, 1, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7767, '', 1, '', 95, 7, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7768, '', 1, '', 91, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7769, '', 4, '', 97, 11, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7770, '', 1, '', 104, 9, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7771, '', 1, '', 92, 4, 23, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7772, '', 2, '', 91, 10, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7773, '', 1, '', 102, 7, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7774, '', 2, '', 88, 5, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7791, '', 2, '', 85, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7792, '', 3, '', 114, 2, 19, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7793, '', 3, '', 111, 16, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7794, '', 1, '', 94, 6, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7795, '', 2, '', 108, 7, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7796, '', 3, '', 108, 4, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7797, '', 3, '', 105, 2, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7809, '', 1, '', 111, 8, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7816, '', 3, '', 102, 8, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7819, '', 2, '', 104, 1, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7820, '', 4, '', 102, 7, 19, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7821, '', 1, '', 108, 7, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7822, '', 3, '', 102, 6, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7823, '', 4, '', 113, 6, 19, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7824, '', 4, '', 101, 8, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7825, '', 5, '', 99, 7, 22, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7826, '', 2, '', 99, 9, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7833, '', 3, '', 98, 11, 17, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7834, '', 4, '', 97, 9, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7835, '', 4, '', 106, 12, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7845, '', 1, '', 86, 3, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7846, '', 4, '', 108, 12, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7847, '', 2, '', 113, 4, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7848, '', 4, '', 110, 8, 26, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7849, '', 5, '', 102, 6, 22, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7850, '', 5, '', 110, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7851, '', 2, '', 112, 14, 22, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7852, '', 4, '', 100, 16, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7853, '', 1, '', 115, 17, 37, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7854, '', 3, '', 111, 7, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7863, '', 5, '', 104, 16, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7867, '', 3, '', 88, 11, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7868, '', 1, '', 114, 4, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7869, '', 2, '', 98, 10, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7870, '', 2, '', 111, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7871, '', 3, '', 111, 7, 21, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7872, '', 1, '', 109, 7, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7878, '', 4, '', 114, 2, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7879, '', 4, '', 99, 10, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7895, '', 4, '', 95, 1, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7897, '', 1, '', 105, 8, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7901, '', 1, '', 111, 13, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7902, '', 5, '', 116, 17, 30, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7908, '', 1, '', 107, 16, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7909, '', 2, '', 104, 4, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7918, '', 3, '', 105, 11, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7919, '', 5, '', 108, 11, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7920, '', 1, '', 97, 7, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7921, '', 1, '', 97, 10, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7922, '', 2, '', 110, 11, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7923, '', 1, '', 114, 6, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7924, '', 3, '', 107, 8, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7925, '', 2, '', 119, 9, 22, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7926, '', 2, '', 111, 3, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7934, '', 2, '', 113, 7, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7935, '', 4, '', 111, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7939, '', 2, '', 106, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7944, '', 5, '', 97, 4, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7945, '', 4, '', 110, 8, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7946, '', 5, '', 113, 4, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7947, '', 4, '', 111, 3, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7949, '', 5, '', 104, 7, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7950, '', 1, '', 105, 5, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7951, '', 4, '', 98, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7952, '', 1, '', 114, 4, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7953, '', 4, '', 103, 2, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7954, '', 6, '', 107, 6, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7960, '', 1, '', 111, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7965, '', 2, '', 79, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7968, '', 3, '', 102, 8, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7969, '', 3, '', 116, 4, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7970, '', 4, '', 113, 10, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7971, '', 5, '', 105, 6, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7972, '', 1, '', 113, 6, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7973, '', 3, '', 101, 3, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7974, '', 1, '', 124, 8, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7975, '', 5, '', 113, 9, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7976, '', 1, '', 108, 8, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7986, '', 1, '', 104, 19, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7987, '', 2, '', 112, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7988, '', 1, '', 101, 15, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7993, '', 2, '', 100, 9, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7994, '', 4, '', 109, 17, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7995, '', 1, '', 102, 14, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7996, '', 3, '', 96, 12, 29, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7997, '', 2, '', 111, 19, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7998, '', 4, '', 113, 8, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (7999, '', 1, '', 105, 13, 6, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8000, '', 2, '', 100, 7, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8001, '', 3, '', 99, 9, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8002, '', 3, '', 107, 6, 24, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8006, '', 1, '', 99, 9, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8014, '', 1, '', 114, 15, 46, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8018, '', 1, '', 108, 3, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8019, '', 2, '', 99, 5, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8020, '', 2, '', 111, 10, 26, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8021, '', 5, '', 98, 7, 24, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8022, '', 5, '', 99, 8, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8023, '', 1, '', 112, 3, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8024, '', 1, '', 100, 10, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8025, '', 3, '', 110, 14, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8026, '', 5, '', 122, 17, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8037, '', 3, '', 110, 19, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8038, '', 2, '', 115, 12, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8042, '', 1, '', 106, 9, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8043, '', 3, '', 111, 8, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8044, '', 2, '', 104, 14, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8046, '', 1, '', 119, 10, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8062, '', 5, '', 104, 8, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8063, '', 2, '', 108, 11, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8064, '', 1, '', 112, 3, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8065, '', 5, '', 122, 5, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8066, '', 6, '', 105, 7, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8067, '', 3, '', 101, 4, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8077, '', 2, '', 109, 1, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8096, '', 2, '', 115, 54, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8105, '', 4, '', 120, 15, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8151, '', 1, '', 31, 3, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8175, '', 2, '', 43, 4, 13, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8190, '', 1, '', 46, 3, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8230, '', 1, '', 108, 6, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8231, '', 2, '', 120, 4, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8235, '', 1, '', 10, 6, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8236, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8259, '', 1, '', 51, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8260, '', 1, '', 101, 3, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8261, '', 2, '', 101, 2, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8262, '', 2, '', 111, 2, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8263, '', 1, '', 52, 1, 2, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8264, '', 1, '', 50, 1, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8265, '', 1, '', 50, 1, 3, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8269, '', 2, '', 101, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8270, '', 1, '', 111, 1, 17, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8279, '', 1, '', 48, 8, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8282, '', 1, '', 24, 13, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8284, '', 1, '', 102, 12, 9, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8286, '', 1, '', 49, 4, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8292, '', 1, '', 50, 7, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8293, '', 2, '', 91, 10, 4, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8294, '', 1, '', 3, 13, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8295, '', 2, '', 93, 18, 21, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8296, '', 3, '', 98, 13, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8298, '', 1, '', 105, 18, 14, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8301, '', 1, '', 84, 18, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8303, '', 2, '', 13, 14, 8, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8313, '', 1, '', 49, 6, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8315, '', 3, '', 101, 18, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8319, '', 2, '', 50, 2, 5, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8320, '', 2, '', 49, 2, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8321, '', 1, '', 118, 5, 18, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8325, '', 3, '', 40, 10, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8326, '', 1, '', 91, 26, 16, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8327, '', 2, '', 105, 8, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8328, '', 2, '', 29, 10, 21, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8329, '', 2, '', 83, 13, 11, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8341, '', 2, '', 48, 9, 15, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8342, '', 1, '', 153, NULL, 10, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8348, '', 2, '', 112, 11, 7, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8350, '', 1, '', 111, 12, 12, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8351, '', 2, '', 89, 22, 20, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8354, '', 2, '', 94, 13, 19, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8371, '', 3, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8384, '', 1, '', 118, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "seafarers" VALUES (8396, '', 3, '', 105, 1, 11, NULL, NULL, NULL);

CREATE TABLE "soldiers" (
	"number"               integer	NOT NULL,
	"number_sup"           char(1)	NOT NULL,
	"trip"                 integer,
	"trip_sup"             char(1),
	"onboard_at_departure" integer,
	"death_at_cape"        integer,
	"left_at_cape"         integer,
	"onboard_at_cape"      integer,
	"death_during_voyage"  integer,
	"onboard_at_arrival"   integer
);

INSERT INTO "soldiers" VALUES (296, '', 1, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (298, '', 1, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (299, '', 1, '', 55, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (300, '', 1, '', 53, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (301, '', 1, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (302, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (303, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (305, '', 1, '', 73, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (306, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (307, '', 1, '', 66, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (310, '', 2, '', 101, NULL, NULL, NULL, 4, 97);
INSERT INTO "soldiers" VALUES (311, '', 2, '', 92, NULL, NULL, NULL, 17, 75);
INSERT INTO "soldiers" VALUES (318, '', 5, '', 69, NULL, NULL, NULL, 32, 37);
INSERT INTO "soldiers" VALUES (320, '', 3, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (321, '', 2, '', 45, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (335, '', 1, '', 56, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (340, '', 1, '', 82, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (446, '', 4, '', 80, NULL, NULL, NULL, NULL, 76);
INSERT INTO "soldiers" VALUES (448, '', 2, '', NULL, NULL, NULL, NULL, NULL, 50);
INSERT INTO "soldiers" VALUES (464, '', 2, '', NULL, NULL, NULL, NULL, NULL, 71);
INSERT INTO "soldiers" VALUES (466, '', 1, '', NULL, NULL, NULL, NULL, NULL, 76);
INSERT INTO "soldiers" VALUES (467, '', 1, '', NULL, NULL, NULL, NULL, NULL, 24);
INSERT INTO "soldiers" VALUES (468, '', 1, '', NULL, NULL, NULL, NULL, NULL, 24);
INSERT INTO "soldiers" VALUES (469, '', 1, '', NULL, NULL, NULL, NULL, NULL, 54);
INSERT INTO "soldiers" VALUES (470, '', 1, '', NULL, NULL, NULL, NULL, NULL, 13);
INSERT INTO "soldiers" VALUES (471, '', 3, '', NULL, NULL, NULL, NULL, NULL, 90);
INSERT INTO "soldiers" VALUES (474, '', 1, '', NULL, NULL, NULL, NULL, NULL, 60);
INSERT INTO "soldiers" VALUES (475, '', 4, '', NULL, NULL, NULL, NULL, 6, 69);
INSERT INTO "soldiers" VALUES (476, '', 3, '', NULL, NULL, NULL, NULL, NULL, 89);
INSERT INTO "soldiers" VALUES (479, '', 2, '', NULL, NULL, NULL, NULL, NULL, 77);
INSERT INTO "soldiers" VALUES (480, '', 1, '', NULL, NULL, NULL, NULL, NULL, 103);
INSERT INTO "soldiers" VALUES (481, '', 7, '', NULL, NULL, NULL, NULL, NULL, 86);
INSERT INTO "soldiers" VALUES (482, '', 5, '', NULL, NULL, NULL, NULL, NULL, 59);
INSERT INTO "soldiers" VALUES (483, '', 4, '', NULL, NULL, NULL, NULL, NULL, 75);
INSERT INTO "soldiers" VALUES (484, '', 1, '', NULL, NULL, NULL, NULL, NULL, 20);
INSERT INTO "soldiers" VALUES (485, '', 3, '', 40, NULL, NULL, NULL, NULL, 40);
INSERT INTO "soldiers" VALUES (486, '', 3, '', 51, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (487, '', 2, '', NULL, NULL, NULL, NULL, NULL, 26);
INSERT INTO "soldiers" VALUES (488, '', 2, '', NULL, NULL, NULL, NULL, NULL, 58);
INSERT INTO "soldiers" VALUES (489, '', 1, '', NULL, NULL, NULL, NULL, NULL, 21);
INSERT INTO "soldiers" VALUES (490, '', 1, '', NULL, NULL, NULL, NULL, NULL, 20);
INSERT INTO "soldiers" VALUES (492, '', 5, '', NULL, NULL, NULL, NULL, NULL, 86);
INSERT INTO "soldiers" VALUES (493, '', 1, '', NULL, NULL, NULL, NULL, NULL, 43);
INSERT INTO "soldiers" VALUES (494, '', 1, '', NULL, NULL, NULL, NULL, NULL, 32);
INSERT INTO "soldiers" VALUES (495, '', 1, '', NULL, NULL, NULL, NULL, NULL, 33);
INSERT INTO "soldiers" VALUES (496, '', 1, '', NULL, NULL, NULL, NULL, NULL, 7);
INSERT INTO "soldiers" VALUES (497, '', 1, '', NULL, NULL, NULL, NULL, NULL, 15);
INSERT INTO "soldiers" VALUES (498, '', 2, '', NULL, NULL, NULL, NULL, NULL, 55);
INSERT INTO "soldiers" VALUES (500, '', 1, '', NULL, NULL, NULL, NULL, NULL, 35);
INSERT INTO "soldiers" VALUES (501, '', 1, '', NULL, NULL, NULL, NULL, NULL, 18);
INSERT INTO "soldiers" VALUES (502, '', 3, '', NULL, NULL, NULL, NULL, NULL, 66);
INSERT INTO "soldiers" VALUES (503, '', 3, '', NULL, NULL, NULL, NULL, NULL, 121);
INSERT INTO "soldiers" VALUES (504, '', 1, '', NULL, NULL, NULL, NULL, NULL, 36);
INSERT INTO "soldiers" VALUES (506, '', 3, '', NULL, NULL, NULL, NULL, NULL, 19);
INSERT INTO "soldiers" VALUES (507, '', 1, '', NULL, NULL, NULL, NULL, NULL, 22);
INSERT INTO "soldiers" VALUES (509, '', 4, '', NULL, NULL, NULL, NULL, NULL, 83);
INSERT INTO "soldiers" VALUES (512, '', 3, '', NULL, NULL, NULL, NULL, NULL, 83);
INSERT INTO "soldiers" VALUES (513, '', 4, '', NULL, NULL, NULL, NULL, NULL, 70);
INSERT INTO "soldiers" VALUES (514, '', 1, '', NULL, NULL, NULL, NULL, NULL, 25);
INSERT INTO "soldiers" VALUES (516, '', 2, '', NULL, NULL, NULL, NULL, NULL, 91);
INSERT INTO "soldiers" VALUES (518, '', 4, '', NULL, NULL, NULL, NULL, NULL, 76);
INSERT INTO "soldiers" VALUES (519, '', 1, '', NULL, NULL, NULL, NULL, NULL, 22);
INSERT INTO "soldiers" VALUES (520, '', 1, '', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "soldiers" VALUES (521, '', 4, '', NULL, NULL, NULL, NULL, NULL, 80);
INSERT INTO "soldiers" VALUES (522, '', 1, '', NULL, NULL, NULL, NULL, NULL, 58);
INSERT INTO "soldiers" VALUES (527, '', 1, '', NULL, NULL, NULL, NULL, NULL, 23);
INSERT INTO "soldiers" VALUES (528, '', 8, '', NULL, NULL, NULL, NULL, 9, 83);
INSERT INTO "soldiers" VALUES (529, '', 1, '', NULL, NULL, NULL, NULL, 18, 79);
INSERT INTO "soldiers" VALUES (531, '', 5, '', NULL, NULL, NULL, NULL, 17, 75);
INSERT INTO "soldiers" VALUES (548, '', 3, '', NULL, NULL, NULL, NULL, NULL, 59);
INSERT INTO "soldiers" VALUES (549, '', 1, '', NULL, NULL, NULL, NULL, NULL, 39);
INSERT INTO "soldiers" VALUES (550, '', 1, '', NULL, NULL, NULL, NULL, NULL, 15);
INSERT INTO "soldiers" VALUES (552, '', 1, '', NULL, NULL, NULL, NULL, NULL, 10);
INSERT INTO "soldiers" VALUES (553, '', 1, '', NULL, NULL, NULL, NULL, NULL, 85);
INSERT INTO "soldiers" VALUES (554, '', 1, '', NULL, NULL, NULL, NULL, NULL, 77);
INSERT INTO "soldiers" VALUES (555, '', 1, '', NULL, NULL, NULL, NULL, NULL, 34);
INSERT INTO "soldiers" VALUES (557, '', 1, '', NULL, NULL, NULL, NULL, NULL, 24);
INSERT INTO "soldiers" VALUES (558, '', 2, '', NULL, NULL, NULL, NULL, 11, 102);
INSERT INTO "soldiers" VALUES (559, '', 1, '', NULL, NULL, NULL, NULL, NULL, 28);
INSERT INTO "soldiers" VALUES (560, '', 5, '', NULL, NULL, NULL, NULL, NULL, 77);
INSERT INTO "soldiers" VALUES (561, '', 2, '', NULL, NULL, NULL, NULL, NULL, 80);
INSERT INTO "soldiers" VALUES (563, '', 1, '', NULL, NULL, NULL, NULL, NULL, 40);
INSERT INTO "soldiers" VALUES (564, '', 2, '', NULL, NULL, NULL, NULL, NULL, 51);
INSERT INTO "soldiers" VALUES (565, '', 3, '', NULL, NULL, NULL, NULL, NULL, 49);
INSERT INTO "soldiers" VALUES (566, '', 3, '', NULL, NULL, NULL, NULL, NULL, 67);
INSERT INTO "soldiers" VALUES (567, '', 1, '', NULL, NULL, NULL, NULL, NULL, 34);
INSERT INTO "soldiers" VALUES (568, '', 2, '', NULL, NULL, NULL, NULL, NULL, 43);
INSERT INTO "soldiers" VALUES (569, '', 1, '', NULL, NULL, NULL, NULL, NULL, 112);
INSERT INTO "soldiers" VALUES (570, '', 1, '', NULL, NULL, NULL, NULL, NULL, 91);
INSERT INTO "soldiers" VALUES (577, '', 4, '', NULL, NULL, NULL, NULL, NULL, 75);
INSERT INTO "soldiers" VALUES (579, '', 2, '', NULL, NULL, NULL, NULL, NULL, 29);
INSERT INTO "soldiers" VALUES (580, '', 1, '', NULL, NULL, NULL, NULL, NULL, 22);
INSERT INTO "soldiers" VALUES (582, '', 1, '', NULL, NULL, NULL, NULL, NULL, 97);
INSERT INTO "soldiers" VALUES (584, '', 1, '', NULL, NULL, NULL, NULL, NULL, 125);
INSERT INTO "soldiers" VALUES (586, '', 5, '', NULL, NULL, NULL, NULL, NULL, 105);
INSERT INTO "soldiers" VALUES (587, '', 5, '', NULL, NULL, NULL, NULL, NULL, 117);
INSERT INTO "soldiers" VALUES (588, '', 1, '', NULL, NULL, NULL, NULL, NULL, 15);
INSERT INTO "soldiers" VALUES (589, '', 7, '', NULL, NULL, NULL, NULL, NULL, 124);
INSERT INTO "soldiers" VALUES (590, '', 1, '', NULL, NULL, NULL, NULL, NULL, 17);
INSERT INTO "soldiers" VALUES (591, '', 1, '', NULL, NULL, NULL, NULL, NULL, 41);
INSERT INTO "soldiers" VALUES (593, '', 2, '', NULL, NULL, NULL, NULL, NULL, 116);
INSERT INTO "soldiers" VALUES (595, '', 6, '', NULL, NULL, NULL, NULL, NULL, 101);
INSERT INTO "soldiers" VALUES (596, '', 2, '', NULL, NULL, NULL, NULL, NULL, 80);
INSERT INTO "soldiers" VALUES (597, '', 2, '', NULL, NULL, NULL, NULL, NULL, 101);
INSERT INTO "soldiers" VALUES (598, '', 6, '', NULL, NULL, NULL, NULL, NULL, 66);
INSERT INTO "soldiers" VALUES (600, '', 3, '', NULL, NULL, NULL, NULL, NULL, 70);
INSERT INTO "soldiers" VALUES (601, '', 2, '', NULL, NULL, NULL, NULL, NULL, 123);
INSERT INTO "soldiers" VALUES (602, '', 2, '', 47, NULL, NULL, NULL, NULL, 47);
INSERT INTO "soldiers" VALUES (603, '', 7, '', 112, NULL, NULL, NULL, NULL, 112);
INSERT INTO "soldiers" VALUES (604, '', 2, '', NULL, NULL, NULL, NULL, NULL, 184);
INSERT INTO "soldiers" VALUES (605, '', 1, '', NULL, NULL, NULL, NULL, NULL, 180);
INSERT INTO "soldiers" VALUES (606, '', 3, '', NULL, NULL, NULL, NULL, NULL, 100);
INSERT INTO "soldiers" VALUES (607, '', 1, '', NULL, NULL, NULL, NULL, NULL, 105);
INSERT INTO "soldiers" VALUES (608, '', 2, '', NULL, NULL, NULL, NULL, NULL, 107);
INSERT INTO "soldiers" VALUES (609, '', 5, '', NULL, NULL, NULL, NULL, NULL, 167);
INSERT INTO "soldiers" VALUES (610, '', 1, '', 15, NULL, NULL, NULL, NULL, 15);
INSERT INTO "soldiers" VALUES (613, '', 2, '', 108, NULL, NULL, 70, NULL, 108);
INSERT INTO "soldiers" VALUES (614, '', 2, '', 105, NULL, NULL, NULL, NULL, 111);
INSERT INTO "soldiers" VALUES (615, '', 1, '', 24, NULL, NULL, NULL, NULL, 24);
INSERT INTO "soldiers" VALUES (616, '', 4, '', NULL, NULL, NULL, NULL, NULL, 83);
INSERT INTO "soldiers" VALUES (617, '', 8, '', NULL, NULL, NULL, NULL, NULL, 92);
INSERT INTO "soldiers" VALUES (618, '', 2, '', NULL, NULL, NULL, NULL, NULL, 80);
INSERT INTO "soldiers" VALUES (619, '', 1, '', NULL, NULL, NULL, NULL, NULL, 15);
INSERT INTO "soldiers" VALUES (620, '', 1, '', 23, NULL, NULL, NULL, NULL, 23);
INSERT INTO "soldiers" VALUES (621, '', 2, '', NULL, NULL, NULL, NULL, NULL, 69);
INSERT INTO "soldiers" VALUES (626, '', 1, '', NULL, NULL, NULL, NULL, NULL, 70);
INSERT INTO "soldiers" VALUES (627, '', 7, '', NULL, NULL, NULL, NULL, NULL, 105);
INSERT INTO "soldiers" VALUES (628, '', 1, '', NULL, NULL, NULL, NULL, NULL, 35);
INSERT INTO "soldiers" VALUES (629, '', 1, '', NULL, NULL, NULL, NULL, NULL, 32);
INSERT INTO "soldiers" VALUES (636, '', 1, '', NULL, NULL, NULL, NULL, NULL, 37);
INSERT INTO "soldiers" VALUES (641, '', 1, '', NULL, NULL, NULL, NULL, NULL, 20);
INSERT INTO "soldiers" VALUES (642, '', 1, '', NULL, NULL, NULL, NULL, NULL, 42);
INSERT INTO "soldiers" VALUES (643, '', 3, '', NULL, NULL, NULL, NULL, NULL, 92);
INSERT INTO "soldiers" VALUES (645, '', 6, '', NULL, NULL, NULL, NULL, NULL, 78);
INSERT INTO "soldiers" VALUES (646, '', 4, '', NULL, NULL, NULL, NULL, NULL, 54);
INSERT INTO "soldiers" VALUES (648, '', 1, '', NULL, NULL, NULL, NULL, NULL, 50);
INSERT INTO "soldiers" VALUES (649, '', 1, '', NULL, NULL, NULL, NULL, NULL, 53);
INSERT INTO "soldiers" VALUES (659, '', 3, '', NULL, NULL, NULL, NULL, 5, NULL);
INSERT INTO "soldiers" VALUES (681, '', 8, '', NULL, NULL, NULL, NULL, NULL, 114);
INSERT INTO "soldiers" VALUES (683, '', 1, '', NULL, NULL, NULL, NULL, NULL, 75);
INSERT INTO "soldiers" VALUES (685, '', 4, '', NULL, NULL, NULL, NULL, 3, 90);
INSERT INTO "soldiers" VALUES (687, '', 2, '', NULL, NULL, NULL, NULL, NULL, 36);
INSERT INTO "soldiers" VALUES (691, '', 1, '', NULL, NULL, NULL, NULL, NULL, 22);
INSERT INTO "soldiers" VALUES (693, '', 1, '', NULL, NULL, NULL, NULL, NULL, 23);
INSERT INTO "soldiers" VALUES (694, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (695, '', 1, '', NULL, NULL, NULL, NULL, NULL, 88);
INSERT INTO "soldiers" VALUES (696, '', 4, '', NULL, NULL, NULL, NULL, NULL, 110);
INSERT INTO "soldiers" VALUES (700, '', 1, '', NULL, NULL, NULL, NULL, NULL, 43);
INSERT INTO "soldiers" VALUES (701, '', 1, '', NULL, NULL, NULL, NULL, NULL, 40);
INSERT INTO "soldiers" VALUES (706, '', 2, '', NULL, NULL, NULL, NULL, NULL, 22);
INSERT INTO "soldiers" VALUES (707, '', 9, '', NULL, NULL, NULL, NULL, NULL, 110);
INSERT INTO "soldiers" VALUES (724, '', 5, '', NULL, NULL, NULL, NULL, NULL, 94);
INSERT INTO "soldiers" VALUES (726, '', 3, '', NULL, NULL, NULL, NULL, NULL, 77);
INSERT INTO "soldiers" VALUES (727, '', 6, '', NULL, NULL, NULL, NULL, NULL, 65);
INSERT INTO "soldiers" VALUES (728, '', 4, '', NULL, NULL, NULL, NULL, NULL, 104);
INSERT INTO "soldiers" VALUES (729, '', 6, '', NULL, NULL, NULL, NULL, NULL, 85);
INSERT INTO "soldiers" VALUES (730, '', 2, '', NULL, NULL, NULL, NULL, NULL, 73);
INSERT INTO "soldiers" VALUES (732, '', 8, '', NULL, NULL, NULL, NULL, NULL, 71);
INSERT INTO "soldiers" VALUES (733, '', 5, '', NULL, NULL, NULL, NULL, NULL, 88);
INSERT INTO "soldiers" VALUES (734, '', 5, '', NULL, NULL, NULL, NULL, NULL, 66);
INSERT INTO "soldiers" VALUES (735, '', 1, '', NULL, NULL, NULL, NULL, NULL, 93);
INSERT INTO "soldiers" VALUES (737, '', 1, '', NULL, NULL, NULL, NULL, NULL, 106);
INSERT INTO "soldiers" VALUES (741, '', 4, '', NULL, NULL, NULL, NULL, NULL, 97);
INSERT INTO "soldiers" VALUES (742, '', 6, '', NULL, NULL, NULL, NULL, NULL, 123);
INSERT INTO "soldiers" VALUES (743, '', 6, '', NULL, NULL, NULL, NULL, NULL, 127);
INSERT INTO "soldiers" VALUES (744, '', 6, '', NULL, NULL, NULL, NULL, NULL, 163);
INSERT INTO "soldiers" VALUES (745, '', 5, '', NULL, NULL, NULL, NULL, NULL, 149);
INSERT INTO "soldiers" VALUES (746, '', 1, '', NULL, NULL, NULL, NULL, NULL, 54);
INSERT INTO "soldiers" VALUES (747, '', 1, '', NULL, NULL, NULL, NULL, NULL, 42);
INSERT INTO "soldiers" VALUES (749, '', 5, '', NULL, NULL, NULL, NULL, NULL, 124);
INSERT INTO "soldiers" VALUES (750, '', 3, '', NULL, NULL, NULL, NULL, NULL, 115);
INSERT INTO "soldiers" VALUES (751, '', 1, '', NULL, NULL, NULL, NULL, NULL, 21);
INSERT INTO "soldiers" VALUES (752, '', 9, '', NULL, NULL, NULL, NULL, NULL, 111);
INSERT INTO "soldiers" VALUES (753, '', 7, '', NULL, NULL, NULL, NULL, NULL, 79);
INSERT INTO "soldiers" VALUES (761, '', 1, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "soldiers" VALUES (762, '', 1, '', NULL, NULL, NULL, NULL, NULL, 49);
INSERT INTO "soldiers" VALUES (763, '', 1, '', NULL, NULL, NULL, NULL, NULL, 51);
INSERT INTO "soldiers" VALUES (766, '', 1, '', NULL, NULL, NULL, NULL, NULL, 107);
INSERT INTO "soldiers" VALUES (767, '', 1, '', 54, NULL, NULL, NULL, NULL, 114);
INSERT INTO "soldiers" VALUES (769, '', 1, '', 66, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (770, '', 2, '', NULL, NULL, NULL, NULL, NULL, 23);
INSERT INTO "soldiers" VALUES (771, '', 1, '', NULL, NULL, NULL, NULL, NULL, 78);
INSERT INTO "soldiers" VALUES (774, '', 1, '', NULL, NULL, NULL, NULL, NULL, 53);
INSERT INTO "soldiers" VALUES (775, '', 6, '', NULL, NULL, NULL, NULL, NULL, 183);
INSERT INTO "soldiers" VALUES (776, '', 5, '', NULL, NULL, NULL, NULL, NULL, 87);
INSERT INTO "soldiers" VALUES (777, '', 2, '', NULL, NULL, NULL, NULL, NULL, 92);
INSERT INTO "soldiers" VALUES (782, '', 1, '', NULL, NULL, NULL, NULL, NULL, 48);
INSERT INTO "soldiers" VALUES (803, '', 7, '', NULL, NULL, NULL, NULL, NULL, 95);
INSERT INTO "soldiers" VALUES (807, '', 7, '', NULL, NULL, NULL, NULL, NULL, 114);
INSERT INTO "soldiers" VALUES (826, '', 1, '', NULL, NULL, NULL, NULL, NULL, 105);
INSERT INTO "soldiers" VALUES (827, '', 1, '', NULL, NULL, NULL, NULL, NULL, 75);
INSERT INTO "soldiers" VALUES (829, '', 7, '', NULL, NULL, NULL, NULL, NULL, 104);
INSERT INTO "soldiers" VALUES (830, '', 6, '', NULL, NULL, NULL, NULL, NULL, 88);
INSERT INTO "soldiers" VALUES (831, '', 1, '', NULL, NULL, NULL, NULL, NULL, 68);
INSERT INTO "soldiers" VALUES (834, '', 1, '', NULL, NULL, NULL, NULL, NULL, 17);
INSERT INTO "soldiers" VALUES (835, '', 2, '', NULL, NULL, NULL, NULL, NULL, 44);
INSERT INTO "soldiers" VALUES (836, '', 2, '', NULL, NULL, NULL, NULL, NULL, 41);
INSERT INTO "soldiers" VALUES (837, '', 2, '', NULL, NULL, NULL, NULL, NULL, 57);
INSERT INTO "soldiers" VALUES (839, '', 1, '', NULL, NULL, NULL, NULL, NULL, 23);
INSERT INTO "soldiers" VALUES (840, '', 1, '', NULL, NULL, NULL, NULL, NULL, 73);
INSERT INTO "soldiers" VALUES (841, '', 1, '', NULL, NULL, NULL, NULL, NULL, 72);
INSERT INTO "soldiers" VALUES (842, '', 1, '', NULL, NULL, NULL, NULL, NULL, 52);
INSERT INTO "soldiers" VALUES (843, '', 1, '', NULL, NULL, NULL, NULL, NULL, 56);
INSERT INTO "soldiers" VALUES (844, '', 2, '', NULL, NULL, NULL, NULL, NULL, 55);
INSERT INTO "soldiers" VALUES (845, '', 2, '', NULL, NULL, NULL, NULL, NULL, 83);
INSERT INTO "soldiers" VALUES (846, '', 2, '', NULL, NULL, NULL, NULL, NULL, 94);
INSERT INTO "soldiers" VALUES (847, '', 3, '', NULL, NULL, NULL, NULL, NULL, 66);
INSERT INTO "soldiers" VALUES (849, '', 1, '', NULL, NULL, NULL, NULL, NULL, 8);
INSERT INTO "soldiers" VALUES (850, '', 3, '', NULL, NULL, NULL, NULL, NULL, 95);
INSERT INTO "soldiers" VALUES (851, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "soldiers" VALUES (854, '', 1, '', NULL, NULL, NULL, NULL, NULL, 22);
INSERT INTO "soldiers" VALUES (855, '', 5, '', NULL, NULL, NULL, NULL, NULL, 144);
INSERT INTO "soldiers" VALUES (858, '', 8, '', NULL, NULL, 4, 5, NULL, 118);
INSERT INTO "soldiers" VALUES (859, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "soldiers" VALUES (860, '', 1, '', NULL, NULL, NULL, NULL, NULL, 76);
INSERT INTO "soldiers" VALUES (861, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "soldiers" VALUES (862, '', 7, '', 102, 1, 3, 27, 1, 125);
INSERT INTO "soldiers" VALUES (863, '', 7, '', 136, NULL, 27, 2, NULL, 111);
INSERT INTO "soldiers" VALUES (864, '', 2, '', NULL, NULL, NULL, NULL, NULL, 112);
INSERT INTO "soldiers" VALUES (865, '', 1, '', NULL, NULL, NULL, NULL, NULL, 86);
INSERT INTO "soldiers" VALUES (866, '', 1, '', 72, NULL, 6, 3, 1, 68);
INSERT INTO "soldiers" VALUES (867, '', 1, '', 18, NULL, NULL, NULL, NULL, 18);
INSERT INTO "soldiers" VALUES (868, '', 3, '', 112, NULL, NULL, 4, NULL, NULL);
INSERT INTO "soldiers" VALUES (869, '', 7, '', NULL, NULL, NULL, NULL, NULL, 116);
INSERT INTO "soldiers" VALUES (870, '', 1, '', NULL, NULL, 32, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (872, '', 8, '', NULL, NULL, NULL, NULL, NULL, 118);
INSERT INTO "soldiers" VALUES (873, '', 8, '', NULL, NULL, NULL, 32, NULL, 124);
INSERT INTO "soldiers" VALUES (874, '', 8, '', 100, NULL, 48, NULL, 1, 51);
INSERT INTO "soldiers" VALUES (875, '', 9, '', NULL, NULL, NULL, 45, NULL, 94);
INSERT INTO "soldiers" VALUES (876, '', 8, '', NULL, NULL, 12, 5, NULL, 131);
INSERT INTO "soldiers" VALUES (877, '', 1, '', NULL, NULL, 6, 1, NULL, 14);
INSERT INTO "soldiers" VALUES (878, '', 1, '', NULL, NULL, NULL, NULL, NULL, 46);
INSERT INTO "soldiers" VALUES (879, '', 2, '', NULL, NULL, 6, 2, NULL, 79);
INSERT INTO "soldiers" VALUES (880, '', 2, '', NULL, NULL, 9, NULL, NULL, 93);
INSERT INTO "soldiers" VALUES (881, '', 2, '', NULL, NULL, 7, 4, NULL, 78);
INSERT INTO "soldiers" VALUES (882, '', 1, '', NULL, NULL, 2, NULL, NULL, 41);
INSERT INTO "soldiers" VALUES (883, '', 1, '', NULL, NULL, NULL, NULL, NULL, 33);
INSERT INTO "soldiers" VALUES (884, '', 3, '', NULL, NULL, 6, NULL, NULL, 110);
INSERT INTO "soldiers" VALUES (885, '', 4, '', NULL, NULL, NULL, 20, NULL, 116);
INSERT INTO "soldiers" VALUES (886, '', 1, '', NULL, NULL, NULL, NULL, NULL, 34);
INSERT INTO "soldiers" VALUES (887, '', 1, '', NULL, NULL, 3, 11, NULL, 114);
INSERT INTO "soldiers" VALUES (888, '', 9, '', NULL, NULL, 4, 1, NULL, 96);
INSERT INTO "soldiers" VALUES (889, '', 7, '', 69, NULL, 3, 2, 18, 50);
INSERT INTO "soldiers" VALUES (890, '', 1, '', NULL, NULL, 1, NULL, NULL, 53);
INSERT INTO "soldiers" VALUES (891, '', 1, '', NULL, NULL, NULL, 1, NULL, 36);
INSERT INTO "soldiers" VALUES (892, '', 1, '', 49, NULL, 12, 2, NULL, 39);
INSERT INTO "soldiers" VALUES (894, '', 2, '', 107, NULL, 6, NULL, 6, 95);
INSERT INTO "soldiers" VALUES (895, '', 1, '', 18, NULL, NULL, NULL, NULL, 18);
INSERT INTO "soldiers" VALUES (896, '', 1, '', 21, NULL, NULL, NULL, NULL, 21);
INSERT INTO "soldiers" VALUES (897, '', 4, '', 116, NULL, 1, NULL, 5, 110);
INSERT INTO "soldiers" VALUES (898, '', 6, '', 116, NULL, 1, NULL, 8, 107);
INSERT INTO "soldiers" VALUES (900, '', 1, '', 58, NULL, NULL, NULL, 7, 51);
INSERT INTO "soldiers" VALUES (901, '', 1, '', 48, NULL, NULL, NULL, 6, 42);
INSERT INTO "soldiers" VALUES (902, '', 2, '', 20, NULL, 1, NULL, NULL, 19);
INSERT INTO "soldiers" VALUES (903, '', 2, '', 63, NULL, 2, NULL, NULL, 61);
INSERT INTO "soldiers" VALUES (904, '', 1, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "soldiers" VALUES (905, '', 2, '', 122, NULL, 5, NULL, 5, 112);
INSERT INTO "soldiers" VALUES (906, '', 8, '', 147, NULL, 43, NULL, 4, 100);
INSERT INTO "soldiers" VALUES (907, '', 2, '', 71, NULL, NULL, 2, 1, 72);
INSERT INTO "soldiers" VALUES (908, '', 8, '', 114, NULL, NULL, 1, 5, 110);
INSERT INTO "soldiers" VALUES (909, '', 8, '', 118, NULL, 2, NULL, 21, 95);
INSERT INTO "soldiers" VALUES (910, '', 3, '', 150, NULL, 21, 16, 25, 120);
INSERT INTO "soldiers" VALUES (911, '', 10, '', 91, NULL, 5, NULL, 13, 73);
INSERT INTO "soldiers" VALUES (912, '', 1, '', 75, 2, NULL, 2, 2, 75);
INSERT INTO "soldiers" VALUES (913, '', 3, '', NULL, NULL, NULL, NULL, NULL, 107);
INSERT INTO "soldiers" VALUES (915, '', 2, '', 64, NULL, 2, NULL, 2, 60);
INSERT INTO "soldiers" VALUES (916, '', 1, '', 56, NULL, NULL, 2, 1, 57);
INSERT INTO "soldiers" VALUES (917, '', 2, '', 88, NULL, 2, NULL, 3, 83);
INSERT INTO "soldiers" VALUES (918, '', 2, '', 11, NULL, 2, NULL, NULL, 9);
INSERT INTO "soldiers" VALUES (919, '', 9, '', 106, NULL, NULL, NULL, 24, 82);
INSERT INTO "soldiers" VALUES (920, '', 1, '', NULL, NULL, NULL, NULL, NULL, 80);
INSERT INTO "soldiers" VALUES (922, '', 1, '', NULL, NULL, NULL, NULL, NULL, 68);
INSERT INTO "soldiers" VALUES (923, '', 4, '', 84, NULL, 7, NULL, 3, 74);
INSERT INTO "soldiers" VALUES (924, '', 9, '', 153, NULL, NULL, NULL, 7, 146);
INSERT INTO "soldiers" VALUES (925, '', 1, '', NULL, NULL, NULL, NULL, NULL, 49);
INSERT INTO "soldiers" VALUES (927, '', 1, '', 38, NULL, 6, 11, 1, 42);
INSERT INTO "soldiers" VALUES (928, '', 9, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (931, '', 1, '', 120, NULL, 8, 12, 37, 87);
INSERT INTO "soldiers" VALUES (932, '', 2, '', 49, NULL, 1, NULL, 4, 44);
INSERT INTO "soldiers" VALUES (933, '', 4, '', 96, NULL, 13, 1, 3, 81);
INSERT INTO "soldiers" VALUES (934, '', 2, '', 62, 1, 1, NULL, 1, 61);
INSERT INTO "soldiers" VALUES (935, '', 1, '', 31, NULL, 29, 4, NULL, 6);
INSERT INTO "soldiers" VALUES (936, '', 3, '', 112, NULL, 1, NULL, 3, 108);
INSERT INTO "soldiers" VALUES (937, '', 1, '', 44, 2, 1, NULL, 2, 41);
INSERT INTO "soldiers" VALUES (938, '', 5, '', 154, NULL, 60, 5, 15, 84);
INSERT INTO "soldiers" VALUES (939, '', 3, '', 122, NULL, 3, 1, 11, 109);
INSERT INTO "soldiers" VALUES (940, '', 3, '', 116, NULL, 4, 5, 14, 103);
INSERT INTO "soldiers" VALUES (941, '', 1, '', 55, NULL, 2, 2, 3, 52);
INSERT INTO "soldiers" VALUES (942, '', 2, '', 110, 1, 1, NULL, 1, 108);
INSERT INTO "soldiers" VALUES (944, '', 1, '', NULL, NULL, NULL, 23, 24, 139);
INSERT INTO "soldiers" VALUES (946, '', 1, '', NULL, NULL, NULL, 4, NULL, NULL);
INSERT INTO "soldiers" VALUES (947, '', 1, '', NULL, NULL, NULL, 48, NULL, NULL);
INSERT INTO "soldiers" VALUES (948, '', 1, '', 81, NULL, 76, 3, NULL, 8);
INSERT INTO "soldiers" VALUES (949, '', 1, '', NULL, NULL, NULL, NULL, NULL, 25);
INSERT INTO "soldiers" VALUES (950, '', 5, '', 120, NULL, 3, 4, 17, 103);
INSERT INTO "soldiers" VALUES (951, '', 7, '', 103, NULL, 4, 2, 18, 83);
INSERT INTO "soldiers" VALUES (952, '', 1, '', 37, NULL, 1, 2, 3, 35);
INSERT INTO "soldiers" VALUES (953, '', 8, '', 138, NULL, 33, 7, 18, 94);
INSERT INTO "soldiers" VALUES (954, '', 4, '', 128, NULL, NULL, NULL, 2, 126);
INSERT INTO "soldiers" VALUES (955, '', 9, '', 119, NULL, 4, NULL, 6, 109);
INSERT INTO "soldiers" VALUES (956, '', 4, '', 129, NULL, 4, 5, 8, 122);
INSERT INTO "soldiers" VALUES (957, '', 1, '', 56, NULL, 20, NULL, 4, 32);
INSERT INTO "soldiers" VALUES (960, '', 2, '', 72, NULL, 20, NULL, 13, 39);
INSERT INTO "soldiers" VALUES (962, '', 2, '', 59, NULL, 31, NULL, 6, 22);
INSERT INTO "soldiers" VALUES (963, '', 2, '', 65, NULL, 31, 5, 1, 38);
INSERT INTO "soldiers" VALUES (964, '', 1, '', 65, NULL, 21, NULL, 3, 41);
INSERT INTO "soldiers" VALUES (965, '', 1, '', 119, NULL, 14, 2, 14, 93);
INSERT INTO "soldiers" VALUES (966, '', 9, '', 117, NULL, 8, 4, 17, 96);
INSERT INTO "soldiers" VALUES (967, '', 1, '', 109, NULL, 1, 10, 19, 99);
INSERT INTO "soldiers" VALUES (968, '', 1, '', 126, NULL, 1, 4, 35, 94);
INSERT INTO "soldiers" VALUES (969, '', 1, '', 121, NULL, NULL, 7, 19, 109);
INSERT INTO "soldiers" VALUES (971, '', 1, '', 113, NULL, 4, 1, 23, 87);
INSERT INTO "soldiers" VALUES (972, '', 9, '', 122, NULL, 15, 23, 34, 96);
INSERT INTO "soldiers" VALUES (973, '', 1, '', 120, NULL, 3, 33, 50, 100);
INSERT INTO "soldiers" VALUES (977, '', 2, '', 150, NULL, 23, 2, 2, 117);
INSERT INTO "soldiers" VALUES (979, '', 1, '', 49, NULL, NULL, NULL, 1, 48);
INSERT INTO "soldiers" VALUES (980, '', 1, '', 68, NULL, 4, NULL, NULL, 64);
INSERT INTO "soldiers" VALUES (981, '', 1, '', 74, NULL, 4, NULL, 7, 63);
INSERT INTO "soldiers" VALUES (982, '', 1, '', 14, NULL, NULL, NULL, NULL, 14);
INSERT INTO "soldiers" VALUES (983, '', 1, '', 13, NULL, 1, NULL, NULL, 12);
INSERT INTO "soldiers" VALUES (984, '', 2, '', 82, NULL, 1, NULL, 1, 80);
INSERT INTO "soldiers" VALUES (985, '', 1, '', 18, NULL, NULL, 17, 1, 34);
INSERT INTO "soldiers" VALUES (986, '', 8, '', 132, NULL, 6, 4, 17, 113);
INSERT INTO "soldiers" VALUES (987, '', 1, '', 38, NULL, NULL, NULL, NULL, 38);
INSERT INTO "soldiers" VALUES (988, '', 5, '', 117, NULL, NULL, 2, 13, 106);
INSERT INTO "soldiers" VALUES (989, '', 2, '', 45, NULL, 2, NULL, NULL, 43);
INSERT INTO "soldiers" VALUES (990, '', 1, '', 99, NULL, 11, 3, 7, 84);
INSERT INTO "soldiers" VALUES (991, '', 1, '', 72, NULL, 6, NULL, 5, 61);
INSERT INTO "soldiers" VALUES (992, '', 1, '', 83, NULL, NULL, NULL, 1, 82);
INSERT INTO "soldiers" VALUES (994, '', 1, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "soldiers" VALUES (995, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "soldiers" VALUES (996, '', 1, '', 40, NULL, 2, 6, 1, 43);
INSERT INTO "soldiers" VALUES (997, '', 1, '', 76, NULL, 2, 2, 11, 65);
INSERT INTO "soldiers" VALUES (998, '', 1, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "soldiers" VALUES (999, '', 1, '', 9, NULL, NULL, NULL, NULL, 9);
INSERT INTO "soldiers" VALUES (1000, '', 1, '', 77, NULL, 8, 2, 6, 65);
INSERT INTO "soldiers" VALUES (1001, '', 1, '', 63, NULL, 2, 4, 5, 60);
INSERT INTO "soldiers" VALUES (1002, '', 1, '', 32, NULL, 4, 3, NULL, 31);
INSERT INTO "soldiers" VALUES (1003, '', 1, '', 28, NULL, NULL, NULL, NULL, 28);
INSERT INTO "soldiers" VALUES (1004, '', 6, '', 68, NULL, NULL, 1, 2, 67);
INSERT INTO "soldiers" VALUES (1005, '', 10, '', 81, NULL, 2, NULL, 3, 76);
INSERT INTO "soldiers" VALUES (1006, '', 2, '', 40, NULL, NULL, NULL, NULL, 40);
INSERT INTO "soldiers" VALUES (1008, '', 2, '', 38, NULL, 1, 1, NULL, 38);
INSERT INTO "soldiers" VALUES (1009, '', 2, '', 67, NULL, NULL, NULL, NULL, 67);
INSERT INTO "soldiers" VALUES (1010, '', 1, '', 40, NULL, 2, 1, NULL, 39);
INSERT INTO "soldiers" VALUES (1011, '', 4, '', 67, NULL, NULL, 2, NULL, 69);
INSERT INTO "soldiers" VALUES (1012, '', 2, '', 71, NULL, 1, 2, NULL, 72);
INSERT INTO "soldiers" VALUES (1013, '', 1, '', 67, NULL, 8, NULL, 7, 52);
INSERT INTO "soldiers" VALUES (1014, '', 2, '', 21, NULL, 1, NULL, NULL, 20);
INSERT INTO "soldiers" VALUES (1015, '', 5, '', 77, NULL, 11, 1, 2, 65);
INSERT INTO "soldiers" VALUES (1021, '', 5, '', 89, NULL, 53, NULL, 14, 22);
INSERT INTO "soldiers" VALUES (1022, '', 1, '', 65, NULL, 60, NULL, 5, NULL);
INSERT INTO "soldiers" VALUES (1024, '', 1, '', 82, NULL, 70, NULL, 9, 3);
INSERT INTO "soldiers" VALUES (1026, '', 2, '', 114, NULL, 48, 36, 34, 68);
INSERT INTO "soldiers" VALUES (1028, '', 3, '', 38, NULL, 24, 24, 6, 23);
INSERT INTO "soldiers" VALUES (1029, '', 1, '', 124, NULL, 29, NULL, 24, 71);
INSERT INTO "soldiers" VALUES (1033, '', 2, '', 30, NULL, 17, 12, 1, 24);
INSERT INTO "soldiers" VALUES (1034, '', 1, '', 68, NULL, 19, 18, 18, 49);
INSERT INTO "soldiers" VALUES (1035, '', 1, '', 28, NULL, NULL, 3, 1, 30);
INSERT INTO "soldiers" VALUES (1036, '', 1, '', 4, NULL, NULL, NULL, 2, 2);
INSERT INTO "soldiers" VALUES (1037, '', 1, '', 54, 7, 11, NULL, 7, 36);
INSERT INTO "soldiers" VALUES (1038, '', 1, '', 51, NULL, 19, 18, NULL, 50);
INSERT INTO "soldiers" VALUES (1039, '', 1, '', 24, NULL, NULL, NULL, NULL, 24);
INSERT INTO "soldiers" VALUES (1040, '', 1, '', 16, NULL, 3, NULL, 2, 11);
INSERT INTO "soldiers" VALUES (1041, '', 1, '', 17, 1, 1, NULL, 1, 15);
INSERT INTO "soldiers" VALUES (1043, '', 2, '', 45, 1, 10, 9, 1, 43);
INSERT INTO "soldiers" VALUES (1044, '', 1, '', 36, NULL, 2, 3, NULL, 37);
INSERT INTO "soldiers" VALUES (1045, '', 5, '', 88, NULL, 12, 3, 37, 42);
INSERT INTO "soldiers" VALUES (1046, '', 2, '', 35, NULL, 3, 1, 1, 32);
INSERT INTO "soldiers" VALUES (1047, '', 2, '', 48, NULL, 4, 1, 2, 43);
INSERT INTO "soldiers" VALUES (1048, '', 1, '', 78, NULL, 3, 3, 10, 68);
INSERT INTO "soldiers" VALUES (1050, '', 3, '', 60, NULL, 12, 9, 19, 38);
INSERT INTO "soldiers" VALUES (1051, '', 3, '', 95, NULL, 14, 8, 24, 65);
INSERT INTO "soldiers" VALUES (1052, '', 2, '', 70, NULL, 13, 4, 17, 44);
INSERT INTO "soldiers" VALUES (1053, '', 1, '', 38, NULL, 15, 5, 3, 25);
INSERT INTO "soldiers" VALUES (1054, '', 2, '', 48, NULL, 26, 13, 6, 29);
INSERT INTO "soldiers" VALUES (1055, '', 1, '', 34, NULL, 22, 6, NULL, 18);
INSERT INTO "soldiers" VALUES (1056, '', 2, '', 47, NULL, 10, 10, 2, 45);
INSERT INTO "soldiers" VALUES (1057, '', 1, '', 102, NULL, 55, 13, 8, 52);
INSERT INTO "soldiers" VALUES (1058, '', 2, '', 53, NULL, 14, 9, 8, 40);
INSERT INTO "soldiers" VALUES (1059, '', 1, '', 50, NULL, 25, 1, 1, 25);
INSERT INTO "soldiers" VALUES (1060, '', 1, '', 39, NULL, 9, 6, 4, 29);
INSERT INTO "soldiers" VALUES (1061, '', 1, '', 16, NULL, 8, 3, 5, 6);
INSERT INTO "soldiers" VALUES (1062, '', 1, '', 43, NULL, 1, 45, 14, 83);
INSERT INTO "soldiers" VALUES (1063, '', 3, '', 73, NULL, 4, 1, 20, 50);
INSERT INTO "soldiers" VALUES (1064, '', 1, '', 50, NULL, 2, 36, 9, 74);
INSERT INTO "soldiers" VALUES (1065, '', 3, '', 68, NULL, 4, 10, 3, 71);
INSERT INTO "soldiers" VALUES (1066, '', 1, '', 64, 3, 2, 14, 3, 73);
INSERT INTO "soldiers" VALUES (1068, '', 2, '', 64, NULL, 3, 5, 10, 61);
INSERT INTO "soldiers" VALUES (1069, '', 2, '', 59, NULL, 10, 9, 7, 46);
INSERT INTO "soldiers" VALUES (1070, '', 1, '', 72, NULL, 26, NULL, 3, 43);
INSERT INTO "soldiers" VALUES (1071, '', 1, '', 54, NULL, 1, 56, 5, 104);
INSERT INTO "soldiers" VALUES (1073, '', 1, '', 79, NULL, 3, NULL, 15, 61);
INSERT INTO "soldiers" VALUES (1074, '', 1, '', 91, NULL, 28, NULL, 6, 56);
INSERT INTO "soldiers" VALUES (1075, '', 1, '', 73, 3, 4, NULL, 3, 66);
INSERT INTO "soldiers" VALUES (1077, '', 1, '', NULL, NULL, NULL, 6, NULL, 6);
INSERT INTO "soldiers" VALUES (1078, '', 1, '', NULL, NULL, NULL, 8, NULL, 8);
INSERT INTO "soldiers" VALUES (1081, '', 1, '', 86, NULL, 3, NULL, 9, 74);
INSERT INTO "soldiers" VALUES (1082, '', 1, '', NULL, NULL, NULL, 8, NULL, 8);
INSERT INTO "soldiers" VALUES (1083, '', 1, '', 45, NULL, 1, NULL, NULL, 44);
INSERT INTO "soldiers" VALUES (1084, '', 1, '', 62, NULL, NULL, 1, 2, 61);
INSERT INTO "soldiers" VALUES (1085, '', 1, '', NULL, NULL, NULL, 8, NULL, 8);
INSERT INTO "soldiers" VALUES (1087, '', 1, '', 91, NULL, 1, 1, NULL, 91);
INSERT INTO "soldiers" VALUES (1088, '', 1, '', 108, NULL, 5, NULL, 18, 84);
INSERT INTO "soldiers" VALUES (1093, '', 1, '', 65, NULL, NULL, 1, 2, 64);
INSERT INTO "soldiers" VALUES (1094, '', 1, '', 110, NULL, NULL, 1, 13, 98);
INSERT INTO "soldiers" VALUES (1096, '', 2, '', 96, NULL, NULL, NULL, 8, 88);
INSERT INTO "soldiers" VALUES (1097, '', 2, '', 117, NULL, 9, 1, 14, 95);
INSERT INTO "soldiers" VALUES (1098, '', 1, '', 42, NULL, 1, 3, NULL, 44);
INSERT INTO "soldiers" VALUES (1100, '', 2, '', 46, NULL, 3, 8, 5, 46);
INSERT INTO "soldiers" VALUES (1101, '', 6, '', 114, NULL, 3, NULL, 18, 93);
INSERT INTO "soldiers" VALUES (1102, '', 2, 'b', 44, NULL, 2, NULL, 1, 41);
INSERT INTO "soldiers" VALUES (1104, '', 2, '', 127, NULL, 1, NULL, 5, 118);
INSERT INTO "soldiers" VALUES (1105, '', 1, '', 145, NULL, 6, 6, 2, 143);
INSERT INTO "soldiers" VALUES (1106, '', 2, '', 81, NULL, 5, 2, 10, 68);
INSERT INTO "soldiers" VALUES (1107, '', 1, '', 63, NULL, 2, 4, 1, 64);
INSERT INTO "soldiers" VALUES (1108, '', 1, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "soldiers" VALUES (1109, '', 1, '', 110, NULL, NULL, 3, NULL, 113);
INSERT INTO "soldiers" VALUES (1111, '', 2, '', 103, NULL, 1, 4, 1, 105);
INSERT INTO "soldiers" VALUES (1112, '', 1, '', 118, NULL, 1, 5, 9, 113);
INSERT INTO "soldiers" VALUES (1113, '', 2, '', 74, NULL, 15, NULL, 10, 49);
INSERT INTO "soldiers" VALUES (1114, '', 2, '', 143, NULL, 2, 2, NULL, 143);
INSERT INTO "soldiers" VALUES (1115, '', 3, '', NULL, NULL, NULL, NULL, NULL, 79);
INSERT INTO "soldiers" VALUES (1117, '', 1, '', 56, NULL, 1, NULL, 12, 43);
INSERT INTO "soldiers" VALUES (1122, '', 2, '', 64, 3, 4, NULL, 3, 57);
INSERT INTO "soldiers" VALUES (1123, '', 3, '', 49, NULL, 5, 2, 5, 41);
INSERT INTO "soldiers" VALUES (1124, '', 1, '', 138, NULL, 18, 2, 22, 100);
INSERT INTO "soldiers" VALUES (1125, '', 2, '', 76, NULL, 4, 1, 3, 70);
INSERT INTO "soldiers" VALUES (1126, '', 3, '', 72, NULL, 5, 5, 8, 64);
INSERT INTO "soldiers" VALUES (1127, '', 4, '', 175, NULL, 11, NULL, 18, 146);
INSERT INTO "soldiers" VALUES (1128, '', 2, '', 86, NULL, NULL, NULL, 8, 79);
INSERT INTO "soldiers" VALUES (1131, '', 1, '', 110, NULL, 2, 4, 10, 102);
INSERT INTO "soldiers" VALUES (1133, '', 1, '', 45, NULL, 1, 2, 12, 34);
INSERT INTO "soldiers" VALUES (1134, '', 1, '', 48, 2, 4, 2, 2, 44);
INSERT INTO "soldiers" VALUES (1135, '', 2, '', 132, NULL, 12, 4, 39, 85);
INSERT INTO "soldiers" VALUES (1136, '', 6, '', 162, NULL, 14, 16, 21, 143);
INSERT INTO "soldiers" VALUES (1140, '', 1, '', 61, NULL, 2, 6, 4, 61);
INSERT INTO "soldiers" VALUES (1141, '', 1, '', 120, NULL, 10, 7, 21, 96);
INSERT INTO "soldiers" VALUES (1142, '', 1, '', 97, NULL, NULL, 7, 4, 100);
INSERT INTO "soldiers" VALUES (1143, '', 1, '', 119, NULL, 17, NULL, 26, 76);
INSERT INTO "soldiers" VALUES (1146, '', 2, '', 71, NULL, 4, 11, 22, 56);
INSERT INTO "soldiers" VALUES (1148, '', 1, '', 32, 2, 1, NULL, 2, 29);
INSERT INTO "soldiers" VALUES (1150, '', 2, '', 64, NULL, NULL, NULL, 4, 60);
INSERT INTO "soldiers" VALUES (1151, '', 2, '', 77, 9, 1, NULL, 9, 67);
INSERT INTO "soldiers" VALUES (1152, '', 3, '', 47, NULL, NULL, NULL, NULL, 47);
INSERT INTO "soldiers" VALUES (1153, '', 2, '', 96, NULL, 25, NULL, 3, 68);
INSERT INTO "soldiers" VALUES (1157, '', 3, '', 126, NULL, 5, 5, 12, 114);
INSERT INTO "soldiers" VALUES (1159, '', 2, '', 83, NULL, 4, 5, 18, 66);
INSERT INTO "soldiers" VALUES (1160, '', 2, '', 85, NULL, NULL, 12, 5, 92);
INSERT INTO "soldiers" VALUES (1161, '', 2, '', 101, NULL, 14, 9, 16, 80);
INSERT INTO "soldiers" VALUES (1162, '', 1, '', 44, NULL, 9, 2, NULL, 37);
INSERT INTO "soldiers" VALUES (1163, '', 3, '', 108, NULL, NULL, NULL, 27, 81);
INSERT INTO "soldiers" VALUES (1164, '', 2, '', 85, NULL, 10, NULL, 1, 74);
INSERT INTO "soldiers" VALUES (1165, '', 3, '', 81, NULL, 1, NULL, 5, 75);
INSERT INTO "soldiers" VALUES (1166, '', 3, '', 70, NULL, 5, 14, 2, 77);
INSERT INTO "soldiers" VALUES (1167, '', 2, '', 63, NULL, 4, 7, NULL, 66);
INSERT INTO "soldiers" VALUES (1169, '', 1, '', 30, NULL, 9, 4, NULL, 25);
INSERT INTO "soldiers" VALUES (1170, '', 2, '', 65, 1, 31, 1, 1, 34);
INSERT INTO "soldiers" VALUES (1171, '', 2, '', 40, NULL, 17, 4, NULL, 27);
INSERT INTO "soldiers" VALUES (1173, '', 2, '', 70, 1, 17, 2, 1, 54);
INSERT INTO "soldiers" VALUES (1174, '', 1, '', 36, 1, 15, NULL, 1, 20);
INSERT INTO "soldiers" VALUES (1176, '', 2, '', 65, NULL, 30, NULL, 4, 31);
INSERT INTO "soldiers" VALUES (1178, '', 2, '', 61, NULL, 24, NULL, 1, 36);
INSERT INTO "soldiers" VALUES (1179, '', 1, '', 30, NULL, 13, NULL, NULL, 17);
INSERT INTO "soldiers" VALUES (1180, '', 1, '', 18, 1, NULL, 3, 1, 18);
INSERT INTO "soldiers" VALUES (1181, '', 1, '', 36, NULL, NULL, NULL, NULL, 34);
INSERT INTO "soldiers" VALUES (1182, '', 3, '', 45, NULL, 32, NULL, 2, 11);
INSERT INTO "soldiers" VALUES (1183, '', 2, '', 59, NULL, 15, 1, 3, 22);
INSERT INTO "soldiers" VALUES (1184, '', 2, '', 95, NULL, 36, 3, 2, 60);
INSERT INTO "soldiers" VALUES (1185, '', 2, '', 36, NULL, 11, NULL, 4, 21);
INSERT INTO "soldiers" VALUES (1186, '', 1, '', 89, NULL, 25, NULL, 1, 63);
INSERT INTO "soldiers" VALUES (1187, '', 2, '', 84, NULL, 35, NULL, 2, 47);
INSERT INTO "soldiers" VALUES (1189, '', 3, '', 63, NULL, NULL, 1, 3, 61);
INSERT INTO "soldiers" VALUES (1190, '', 3, '', 83, NULL, NULL, NULL, 7, 76);
INSERT INTO "soldiers" VALUES (1192, '', 1, '', 42, NULL, 1, 1, 1, 42);
INSERT INTO "soldiers" VALUES (1193, '', 2, '', 44, NULL, 6, 6, 3, 41);
INSERT INTO "soldiers" VALUES (1194, '', 2, '', 137, NULL, 1, 1, 17, 120);
INSERT INTO "soldiers" VALUES (1195, '', 3, '', 53, NULL, NULL, NULL, 13, 40);
INSERT INTO "soldiers" VALUES (1197, '', 2, '', 58, NULL, 7, 8, 6, 53);
INSERT INTO "soldiers" VALUES (1200, '', 3, '', 87, NULL, 7, 3, 2, 81);
INSERT INTO "soldiers" VALUES (1201, '', 3, '', 65, NULL, 7, 8, 3, 63);
INSERT INTO "soldiers" VALUES (1202, '', 1, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "soldiers" VALUES (1203, '', 2, '', 30, NULL, NULL, NULL, 4, 26);
INSERT INTO "soldiers" VALUES (1205, '', 3, '', 77, NULL, 8, 7, 3, 73);
INSERT INTO "soldiers" VALUES (1206, '', 7, '', 87, NULL, 7, 6, 11, 75);
INSERT INTO "soldiers" VALUES (1207, '', 2, '', 59, NULL, 17, 11, 6, 47);
INSERT INTO "soldiers" VALUES (1208, '', 1, '', 83, NULL, 1, NULL, 1, 81);
INSERT INTO "soldiers" VALUES (1209, '', 1, '', 23, NULL, NULL, NULL, 2, 21);
INSERT INTO "soldiers" VALUES (1210, '', 1, '', 83, NULL, 44, 6, NULL, 45);
INSERT INTO "soldiers" VALUES (1211, '', 2, '', 38, NULL, 3, 1, 2, 34);
INSERT INTO "soldiers" VALUES (1214, '', 5, '', 110, NULL, 8, 1, 6, 97);
INSERT INTO "soldiers" VALUES (1215, '', 3, '', 109, NULL, 3, 15, 34, 87);
INSERT INTO "soldiers" VALUES (1216, '', 2, '', 31, NULL, 3, NULL, 3, 25);
INSERT INTO "soldiers" VALUES (1217, '', 1, '', NULL, NULL, NULL, 7, NULL, 7);
INSERT INTO "soldiers" VALUES (1219, '', 1, '', NULL, NULL, 44, 54, 4, 6);
INSERT INTO "soldiers" VALUES (1220, '', 4, '', 86, NULL, 17, NULL, 15, 54);
INSERT INTO "soldiers" VALUES (1221, '', 2, '', 69, NULL, 3, 1, 10, 57);
INSERT INTO "soldiers" VALUES (1225, '', 2, '', 29, NULL, 26, 14, NULL, 17);
INSERT INTO "soldiers" VALUES (1226, '', 4, '', 120, NULL, 85, 17, 20, 33);
INSERT INTO "soldiers" VALUES (1227, '', 3, '', 87, NULL, 48, 11, 11, 39);
INSERT INTO "soldiers" VALUES (1229, '', 3, '', 101, NULL, 68, 7, 9, 31);
INSERT INTO "soldiers" VALUES (1230, '', 1, '', 87, NULL, 40, 4, 10, 41);
INSERT INTO "soldiers" VALUES (1231, '', 1, '', 87, NULL, 16, 17, 21, 60);
INSERT INTO "soldiers" VALUES (1233, '', 1, '', 95, NULL, 31, 28, 9, 83);
INSERT INTO "soldiers" VALUES (1235, '', 2, '', 28, NULL, 12, 12, 1, 27);
INSERT INTO "soldiers" VALUES (1236, '', 1, '', 97, NULL, 34, 35, 31, 67);
INSERT INTO "soldiers" VALUES (1239, '', 2, '', 32, NULL, 10, 10, 3, 29);
INSERT INTO "soldiers" VALUES (1242, '', 2, '', 25, NULL, NULL, NULL, 5, 20);
INSERT INTO "soldiers" VALUES (1244, '', 3, '', 80, NULL, 18, 17, 24, 55);
INSERT INTO "soldiers" VALUES (1245, '', 4, '', 53, NULL, 10, 3, 12, 34);
INSERT INTO "soldiers" VALUES (1246, '', 2, '', 3, NULL, NULL, NULL, NULL, 3);
INSERT INTO "soldiers" VALUES (1247, '', 3, '', 106, NULL, 18, 10, 47, 51);
INSERT INTO "soldiers" VALUES (1249, '', 3, '', 93, NULL, 23, 23, 4, 88);
INSERT INTO "soldiers" VALUES (1250, '', 1, '', 61, NULL, 17, 14, 16, 42);
INSERT INTO "soldiers" VALUES (1253, '', 3, '', 81, NULL, 2, NULL, 37, 42);
INSERT INTO "soldiers" VALUES (1254, '', 2, '', 115, NULL, 13, 6, 19, 89);
INSERT INTO "soldiers" VALUES (1255, '', 1, '', 97, NULL, 1, 4, 6, 93);
INSERT INTO "soldiers" VALUES (1256, '', 3, '', 117, NULL, 23, 8, 13, 89);
INSERT INTO "soldiers" VALUES (1260, '', 1, '', 109, NULL, 13, 4, 9, 90);
INSERT INTO "soldiers" VALUES (1261, '', 1, '', 94, NULL, 14, 9, 10, 79);
INSERT INTO "soldiers" VALUES (1267, '', 1, '', 111, NULL, 3, 2, 16, 94);
INSERT INTO "soldiers" VALUES (1270, '', 1, '', 120, NULL, 43, NULL, 7, 70);
INSERT INTO "soldiers" VALUES (1271, '', 1, '', 102, NULL, 9, 53, 75, 71);
INSERT INTO "soldiers" VALUES (1274, '', 1, '', 119, NULL, 1, NULL, 13, 104);
INSERT INTO "soldiers" VALUES (1275, '', 1, '', 46, NULL, NULL, NULL, NULL, 46);
INSERT INTO "soldiers" VALUES (1277, '', 1, '', 113, NULL, 15, 12, 13, 97);
INSERT INTO "soldiers" VALUES (1279, '', 2, '', 35, NULL, 4, 3, 1, 33);
INSERT INTO "soldiers" VALUES (1284, '', 1, '', 110, NULL, 9, 7, 14, 94);
INSERT INTO "soldiers" VALUES (1285, '', 1, '', 95, NULL, 9, 5, 16, 75);
INSERT INTO "soldiers" VALUES (1286, '', 1, '', 66, NULL, 4, 4, NULL, 61);
INSERT INTO "soldiers" VALUES (1287, '', 3, '', 40, NULL, 2, 2, 4, 36);
INSERT INTO "soldiers" VALUES (1288, '', 1, '', 40, NULL, 2, NULL, 1, 37);
INSERT INTO "soldiers" VALUES (1289, '', 1, '', 81, NULL, 3, 6, 5, 79);
INSERT INTO "soldiers" VALUES (1290, '', 1, '', 78, NULL, 7, NULL, NULL, 71);
INSERT INTO "soldiers" VALUES (1291, '', 3, '', 123, NULL, 6, 13, 3, 75);
INSERT INTO "soldiers" VALUES (1292, '', 3, '', 74, NULL, 2, 22, 3, 91);
INSERT INTO "soldiers" VALUES (1293, '', 1, '', 62, NULL, 2, 8, 1, 67);
INSERT INTO "soldiers" VALUES (1294, '', 1, '', 92, NULL, 2, 2, 7, 85);
INSERT INTO "soldiers" VALUES (1295, '', 4, '', 121, NULL, 12, 8, 1, 116);
INSERT INTO "soldiers" VALUES (1297, '', 1, '', 51, NULL, 2, 2, 2, 49);
INSERT INTO "soldiers" VALUES (1314, '', 2, '', 98, NULL, 6, 4, 18, 78);
INSERT INTO "soldiers" VALUES (1315, '', 4, '', 103, NULL, 3, 2, 4, 97);
INSERT INTO "soldiers" VALUES (1317, '', 4, '', 91, NULL, 5, NULL, 4, 82);
INSERT INTO "soldiers" VALUES (1318, '', 4, '', 101, NULL, 2, 7, NULL, 106);
INSERT INTO "soldiers" VALUES (1319, '', 4, '', 90, NULL, 13, 11, 9, 79);
INSERT INTO "soldiers" VALUES (1320, '', 2, '', 112, NULL, 2, 1, 8, 103);
INSERT INTO "soldiers" VALUES (1322, '', 1, '', 8, NULL, NULL, 2, NULL, 10);
INSERT INTO "soldiers" VALUES (1324, '', 1, '', NULL, 1, NULL, NULL, 1, NULL);
INSERT INTO "soldiers" VALUES (1325, '', 1, '', 98, NULL, 10, 23, 10, 101);
INSERT INTO "soldiers" VALUES (1326, '', 4, '', 102, NULL, 9, 19, 12, 100);
INSERT INTO "soldiers" VALUES (1327, '', 2, '', NULL, NULL, NULL, NULL, NULL, 39);
INSERT INTO "soldiers" VALUES (1329, '', 4, '', NULL, NULL, NULL, NULL, NULL, 80);
INSERT INTO "soldiers" VALUES (1330, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "soldiers" VALUES (1331, '', 2, '', 102, NULL, 4, 4, 5, 97);
INSERT INTO "soldiers" VALUES (1332, '', 2, '', 93, NULL, 25, NULL, 7, 61);
INSERT INTO "soldiers" VALUES (1333, '', 4, '', 34, NULL, 6, NULL, NULL, 28);
INSERT INTO "soldiers" VALUES (1334, '', 1, '', 31, NULL, 2, 1, 1, 29);
INSERT INTO "soldiers" VALUES (1335, '', 2, '', NULL, NULL, NULL, NULL, NULL, 85);
INSERT INTO "soldiers" VALUES (1336, '', 2, '', 46, NULL, 1, 8, 3, 50);
INSERT INTO "soldiers" VALUES (1340, '', 2, '', NULL, NULL, NULL, NULL, NULL, 112);
INSERT INTO "soldiers" VALUES (1341, '', 2, '', 114, NULL, NULL, NULL, 34, 77);
INSERT INTO "soldiers" VALUES (1342, '', 4, '', 40, NULL, NULL, NULL, 8, 28);
INSERT INTO "soldiers" VALUES (1343, '', 2, '', 69, NULL, 13, 1, 16, 41);
INSERT INTO "soldiers" VALUES (1345, '', 2, '', 97, NULL, 15, 4, NULL, 86);
INSERT INTO "soldiers" VALUES (1346, '', 2, '', 67, NULL, 11, NULL, 4, 52);
INSERT INTO "soldiers" VALUES (1347, '', 1, '', 22, NULL, 1, 1, 1, 20);
INSERT INTO "soldiers" VALUES (1348, '', 1, '', 56, NULL, NULL, NULL, 2, 53);
INSERT INTO "soldiers" VALUES (1349, '', 1, '', 59, NULL, NULL, NULL, NULL, 59);
INSERT INTO "soldiers" VALUES (1350, '', 1, '', 43, NULL, 2, 2, NULL, 43);
INSERT INTO "soldiers" VALUES (1352, '', 4, '', 124, NULL, 1, 1, 11, 113);
INSERT INTO "soldiers" VALUES (1353, '', 4, '', 45, NULL, 1, 2, 1, 45);
INSERT INTO "soldiers" VALUES (1354, '', 1, '', 110, NULL, 7, 24, 5, 122);
INSERT INTO "soldiers" VALUES (1355, '', 1, '', 106, 16, 3, 5, 16, 92);
INSERT INTO "soldiers" VALUES (1357, '', 2, '', 65, NULL, 15, 1, 5, 42);
INSERT INTO "soldiers" VALUES (1358, '', 1, '', 24, NULL, NULL, NULL, NULL, 23);
INSERT INTO "soldiers" VALUES (1359, '', 2, '', 32, NULL, NULL, 9, 5, 36);
INSERT INTO "soldiers" VALUES (1360, '', 2, '', NULL, NULL, NULL, 1, 5, 28);
INSERT INTO "soldiers" VALUES (1361, '', 3, '', 77, NULL, 7, NULL, 8, 62);
INSERT INTO "soldiers" VALUES (1363, '', 2, '', 38, 1, 8, 4, 2, 32);
INSERT INTO "soldiers" VALUES (1364, '', 4, '', 109, NULL, 18, NULL, 25, 66);
INSERT INTO "soldiers" VALUES (1365, '', 4, '', 97, NULL, 7, 1, 28, 11);
INSERT INTO "soldiers" VALUES (1366, '', 4, '', 52, NULL, NULL, NULL, 1, 51);
INSERT INTO "soldiers" VALUES (1367, '', 2, '', 61, NULL, NULL, 4, NULL, 65);
INSERT INTO "soldiers" VALUES (1368, '', 3, '', 64, 2, 14, 9, 2, 57);
INSERT INTO "soldiers" VALUES (1370, '', 4, '', 63, NULL, 15, 9, 9, 48);
INSERT INTO "soldiers" VALUES (1372, '', 4, '', 75, NULL, 16, 19, 4, 74);
INSERT INTO "soldiers" VALUES (1375, '', 2, '', 86, NULL, 2, 1, 5, 81);
INSERT INTO "soldiers" VALUES (1376, '', 3, '', 91, NULL, 3, 2, 2, 88);
INSERT INTO "soldiers" VALUES (1378, '', 5, '', 92, NULL, 5, 16, 7, 96);
INSERT INTO "soldiers" VALUES (1379, '', 5, '', 74, NULL, NULL, 1, 1, 74);
INSERT INTO "soldiers" VALUES (1380, '', 3, '', 56, NULL, 1, 5, 1, 59);
INSERT INTO "soldiers" VALUES (1381, '', 5, '', 72, NULL, 19, 17, 5, 65);
INSERT INTO "soldiers" VALUES (1382, '', 2, '', 91, NULL, 5, 4, 9, 81);
INSERT INTO "soldiers" VALUES (1383, '', 5, '', 87, NULL, 5, NULL, 1, 81);
INSERT INTO "soldiers" VALUES (1384, '', 5, '', 91, NULL, 7, NULL, 2, 82);
INSERT INTO "soldiers" VALUES (1385, '', 5, '', 128, 7, 13, 6, 7, 115);
INSERT INTO "soldiers" VALUES (1386, '', 3, '', 133, NULL, NULL, NULL, 6, 125);
INSERT INTO "soldiers" VALUES (1387, '', 4, '', 103, NULL, 2, 8, 12, 94);
INSERT INTO "soldiers" VALUES (1390, '', 1, '', 26, NULL, 1, NULL, NULL, 26);
INSERT INTO "soldiers" VALUES (1391, '', 1, '', 34, NULL, 1, 2, 1, 34);
INSERT INTO "soldiers" VALUES (1393, '', 2, '', 139, NULL, 13, 13, 16, 126);
INSERT INTO "soldiers" VALUES (1394, '', 3, '', 96, NULL, 8, 3, NULL, 91);
INSERT INTO "soldiers" VALUES (1395, '', 1, '', 100, NULL, 5, NULL, 5, 90);
INSERT INTO "soldiers" VALUES (1396, '', 1, '', 105, NULL, 5, NULL, 2, 98);
INSERT INTO "soldiers" VALUES (1397, '', 3, '', 141, 4, 9, 17, 4, 129);
INSERT INTO "soldiers" VALUES (1398, '', 3, '', 122, NULL, 10, 10, 8, 114);
INSERT INTO "soldiers" VALUES (1399, '', 1, '', 25, NULL, 1, NULL, 7, 17);
INSERT INTO "soldiers" VALUES (1401, '', 1, '', 62, NULL, 14, 11, 5, 54);
INSERT INTO "soldiers" VALUES (1402, '', 1, '', 45, NULL, 1, NULL, 2, 42);
INSERT INTO "soldiers" VALUES (1403, '', 3, '', 97, NULL, 17, NULL, 6, 75);
INSERT INTO "soldiers" VALUES (1404, '', 2, '', 147, NULL, 18, 3, 22, 110);
INSERT INTO "soldiers" VALUES (1407, '', 1, '', 29, NULL, 28, 1, 1, 1);
INSERT INTO "soldiers" VALUES (1409, '', 2, '', 121, NULL, 5, NULL, 23, 93);
INSERT INTO "soldiers" VALUES (1411, '', 1, '', 17, 1, 5, NULL, 1, 11);
INSERT INTO "soldiers" VALUES (1412, '', 5, '', 144, NULL, 11, 19, 11, 141);
INSERT INTO "soldiers" VALUES (1413, '', 2, '', 102, NULL, 4, 7, 14, 91);
INSERT INTO "soldiers" VALUES (1414, '', 2, '', 104, NULL, 3, 27, 8, 120);
INSERT INTO "soldiers" VALUES (1415, '', 3, '', 140, NULL, 16, 5, 20, 109);
INSERT INTO "soldiers" VALUES (1416, '', 5, '', 139, NULL, 16, 2, 14, 111);
INSERT INTO "soldiers" VALUES (1417, '', 1, '', 79, NULL, 4, 10, 3, 80);
INSERT INTO "soldiers" VALUES (1418, '', 1, '', 103, NULL, 3, 5, 8, 97);
INSERT INTO "soldiers" VALUES (1419, '', 1, '', 73, NULL, NULL, NULL, 2, 71);
INSERT INTO "soldiers" VALUES (1420, '', 4, '', 121, NULL, 9, 3, 11, 106);
INSERT INTO "soldiers" VALUES (1422, '', 1, '', 66, NULL, 7, 7, 1, 65);
INSERT INTO "soldiers" VALUES (1423, '', 2, '', 134, NULL, 14, 16, 25, 111);
INSERT INTO "soldiers" VALUES (1425, '', 1, '', 55, NULL, 20, NULL, 3, 1);
INSERT INTO "soldiers" VALUES (1426, '', 3, '', 111, NULL, 9, 11, 15, 98);
INSERT INTO "soldiers" VALUES (1427, '', 2, '', 124, NULL, 7, 19, 16, 119);
INSERT INTO "soldiers" VALUES (1429, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "soldiers" VALUES (1430, '', 3, '', 108, NULL, 9, 19, 14, 104);
INSERT INTO "soldiers" VALUES (1431, '', 4, '', 122, NULL, NULL, NULL, 4, 118);
INSERT INTO "soldiers" VALUES (1432, '', 1, '', NULL, NULL, NULL, 5, NULL, 5);
INSERT INTO "soldiers" VALUES (1433, '', 3, '', 38, NULL, 10, 10, 10, 34);
INSERT INTO "soldiers" VALUES (1434, '', 4, '', 113, NULL, 7, 3, 15, 101);
INSERT INTO "soldiers" VALUES (1435, '', 2, '', NULL, NULL, NULL, 22, 3, 19);
INSERT INTO "soldiers" VALUES (1436, '', 5, '', 109, NULL, 6, 9, 11, 101);
INSERT INTO "soldiers" VALUES (1437, '', 6, '', 129, NULL, 4, 2, 24, 103);
INSERT INTO "soldiers" VALUES (1438, '', 1, '', 70, NULL, 8, 11, 11, 62);
INSERT INTO "soldiers" VALUES (1439, '', 1, '', 55, 3, 4, 7, 3, 55);
INSERT INTO "soldiers" VALUES (1440, '', 1, '', 69, NULL, 3, 5, 5, 64);
INSERT INTO "soldiers" VALUES (1441, '', 3, '', 116, NULL, 13, 40, 11, 132);
INSERT INTO "soldiers" VALUES (1442, '', 1, '', NULL, NULL, NULL, NULL, NULL, 73);
INSERT INTO "soldiers" VALUES (1443, '', 5, '', 91, NULL, 1, 4, 5, 91);
INSERT INTO "soldiers" VALUES (1444, '', 6, '', 102, NULL, 5, NULL, 4, 108);
INSERT INTO "soldiers" VALUES (1445, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "soldiers" VALUES (1447, '', 3, '', 116, NULL, 5, 4, 5, 110);
INSERT INTO "soldiers" VALUES (1449, '', 6, '', 96, NULL, NULL, NULL, 3, 93);
INSERT INTO "soldiers" VALUES (1450, '', 4, '', 116, NULL, 5, NULL, 6, 123);
INSERT INTO "soldiers" VALUES (1451, '', 1, '', 114, NULL, 3, 7, 1, 117);
INSERT INTO "soldiers" VALUES (1452, '', 1, '', 41, NULL, 1, 1, 27, 14);
INSERT INTO "soldiers" VALUES (1453, '', 1, '', 77, NULL, 4, 3, 1, 75);
INSERT INTO "soldiers" VALUES (1454, '', 2, '', 79, 1, NULL, NULL, 1, 78);
INSERT INTO "soldiers" VALUES (1455, '', 3, '', 100, 1, 10, 9, 1, 98);
INSERT INTO "soldiers" VALUES (1456, '', 1, '', 106, NULL, 4, 2, 1, 103);
INSERT INTO "soldiers" VALUES (1458, '', 6, '', 106, NULL, 4, 3, NULL, 105);
INSERT INTO "soldiers" VALUES (1459, '', 1, '', 37, NULL, 37, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (1460, '', 1, '', NULL, NULL, NULL, 3, NULL, 3);
INSERT INTO "soldiers" VALUES (1462, '', 1, '', 61, 1, 15, NULL, 1, 45);
INSERT INTO "soldiers" VALUES (1463, '', 1, '', 71, NULL, 5, NULL, 3, 63);
INSERT INTO "soldiers" VALUES (1464, '', 1, '', 81, NULL, 1, 8, 6, 82);
INSERT INTO "soldiers" VALUES (1465, '', 2, '', 82, NULL, 13, 11, 9, 71);
INSERT INTO "soldiers" VALUES (1466, '', 1, '', 76, 1, NULL, 15, 1, 90);
INSERT INTO "soldiers" VALUES (1467, '', 1, '', 83, NULL, 5, NULL, 2, 78);
INSERT INTO "soldiers" VALUES (1468, '', 2, '', 57, NULL, 3, 11, 2, 63);
INSERT INTO "soldiers" VALUES (1469, '', 1, '', 108, NULL, 8, NULL, NULL, 100);
INSERT INTO "soldiers" VALUES (1474, '', 1, '', 115, NULL, 13, 4, 4, 102);
INSERT INTO "soldiers" VALUES (1476, '', 3, '', 88, NULL, 3, 2, 14, 73);
INSERT INTO "soldiers" VALUES (1477, '', 1, '', 74, 2, 2, 7, 2, 77);
INSERT INTO "soldiers" VALUES (1478, '', 5, '', 116, NULL, 5, 2, NULL, 13);
INSERT INTO "soldiers" VALUES (1479, '', 3, '', 102, NULL, 12, 13, 7, 96);
INSERT INTO "soldiers" VALUES (1480, '', 2, '', 86, NULL, 9, 3, 5, 75);
INSERT INTO "soldiers" VALUES (1481, '', 1, '', 78, NULL, 4, NULL, NULL, 64);
INSERT INTO "soldiers" VALUES (1482, '', 2, '', 34, NULL, 4, 5, NULL, 35);
INSERT INTO "soldiers" VALUES (1484, '', 2, '', 32, NULL, 1, 1, 2, 30);
INSERT INTO "soldiers" VALUES (1485, '', 3, '', 103, NULL, NULL, NULL, 3, 98);
INSERT INTO "soldiers" VALUES (1487, '', 1, '', 87, NULL, NULL, NULL, 13, 71);
INSERT INTO "soldiers" VALUES (1488, '', 2, '', 107, NULL, 3, 17, 8, 107);
INSERT INTO "soldiers" VALUES (1489, '', 1, '', 42, NULL, 3, 18, 2, 55);
INSERT INTO "soldiers" VALUES (1492, '', 1, '', 120, NULL, 32, 12, 5, 94);
INSERT INTO "soldiers" VALUES (1495, '', 2, '', 61, NULL, 5, 1, 3, 59);
INSERT INTO "soldiers" VALUES (1496, '', 1, '', 44, NULL, 3, 2, 8, 35);
INSERT INTO "soldiers" VALUES (1497, '', 1, '', 24, NULL, 1, 4, 1, 26);
INSERT INTO "soldiers" VALUES (1498, '', 1, '', 63, NULL, 5, 6, NULL, 64);
INSERT INTO "soldiers" VALUES (1499, '', 4, '', 109, NULL, 15, 1, 2, 93);
INSERT INTO "soldiers" VALUES (1500, '', 1, '', 99, NULL, 2, 9, 5, 101);
INSERT INTO "soldiers" VALUES (1502, '', 6, '', 128, NULL, 6, 22, 5, 119);
INSERT INTO "soldiers" VALUES (1503, '', 1, '', 57, NULL, 6, NULL, 2, 47);
INSERT INTO "soldiers" VALUES (1504, '', 1, '', 65, NULL, 6, 5, 3, 59);
INSERT INTO "soldiers" VALUES (1505, '', 5, '', 53, NULL, 2, 3, 2, 52);
INSERT INTO "soldiers" VALUES (1507, '', 2, '', 76, NULL, 18, 3, 1, 60);
INSERT INTO "soldiers" VALUES (1508, '', 2, '', 48, NULL, NULL, NULL, 1, 47);
INSERT INTO "soldiers" VALUES (1509, '', 1, '', 98, NULL, 8, 3, 1, 94);
INSERT INTO "soldiers" VALUES (1511, '', 2, '', 59, NULL, 7, NULL, NULL, 52);
INSERT INTO "soldiers" VALUES (1514, '', 1, '', 55, NULL, 5, 9, 1, 58);
INSERT INTO "soldiers" VALUES (1515, '', 2, '', 51, NULL, 1, 4, 7, 47);
INSERT INTO "soldiers" VALUES (1516, '', 1, '', 18, NULL, 2, 4, NULL, 18);
INSERT INTO "soldiers" VALUES (1517, '', 2, '', 25, NULL, 25, NULL, 2, 4);
INSERT INTO "soldiers" VALUES (1519, '', 7, '', 107, NULL, 1, 7, 2, 111);
INSERT INTO "soldiers" VALUES (1520, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "soldiers" VALUES (1521, '', 2, '', 31, 1, NULL, 3, 3, 31);
INSERT INTO "soldiers" VALUES (1522, '', 1, '', 34, NULL, NULL, NULL, NULL, 34);
INSERT INTO "soldiers" VALUES (1523, '', 4, '', 104, NULL, 15, 2, 13, 78);
INSERT INTO "soldiers" VALUES (1525, '', 1, '', 100, NULL, 4, 2, 26, 70);
INSERT INTO "soldiers" VALUES (1526, '', 4, '', 96, NULL, 10, NULL, 17, 69);
INSERT INTO "soldiers" VALUES (1527, '', 1, '', 49, NULL, NULL, NULL, 30, 19);
INSERT INTO "soldiers" VALUES (1529, '', 1, '', 96, NULL, 23, 2, 3, 72);
INSERT INTO "soldiers" VALUES (1530, '', 2, '', 110, NULL, 12, NULL, 15, 83);
INSERT INTO "soldiers" VALUES (1533, '', 3, '', 112, NULL, 6, 1, 1, 106);
INSERT INTO "soldiers" VALUES (1535, '', 3, '', 75, NULL, 1, NULL, 6, 68);
INSERT INTO "soldiers" VALUES (1536, '', 1, '', 77, NULL, 4, 2, 6, 69);
INSERT INTO "soldiers" VALUES (1537, '', 1, '', 74, NULL, NULL, NULL, 2, 72);
INSERT INTO "soldiers" VALUES (1538, '', 6, '', 103, NULL, 13, 3, 4, 89);
INSERT INTO "soldiers" VALUES (1539, '', 1, '', 104, NULL, 14, 13, 8, 95);
INSERT INTO "soldiers" VALUES (1540, '', 1, '', 92, NULL, 17, 21, 10, 86);
INSERT INTO "soldiers" VALUES (1542, '', 2, '', 79, NULL, 9, 7, 7, 68);
INSERT INTO "soldiers" VALUES (1543, '', 2, '', 112, NULL, 6, 3, 13, 96);
INSERT INTO "soldiers" VALUES (1544, '', 1, '', 47, NULL, 4, 2, NULL, 45);
INSERT INTO "soldiers" VALUES (1545, '', 2, '', 34, NULL, 7, 4, 3, 28);
INSERT INTO "soldiers" VALUES (1546, '', 1, '', 67, NULL, 2, NULL, NULL, 65);
INSERT INTO "soldiers" VALUES (1547, '', 4, '', 98, NULL, 8, 5, 3, 98);
INSERT INTO "soldiers" VALUES (1548, '', 3, '', 54, NULL, 4, 2, 4, 48);
INSERT INTO "soldiers" VALUES (1550, '', 2, '', 50, NULL, 1, 3, 1, 51);
INSERT INTO "soldiers" VALUES (1551, '', 2, '', 78, NULL, 5, NULL, 11, 62);
INSERT INTO "soldiers" VALUES (1552, '', 1, '', 45, NULL, 14, 13, 4, 40);
INSERT INTO "soldiers" VALUES (1553, '', 2, '', 62, NULL, NULL, NULL, NULL, 62);
INSERT INTO "soldiers" VALUES (1554, '', 1, '', 47, NULL, 12, 13, NULL, 48);
INSERT INTO "soldiers" VALUES (1555, '', 1, '', 72, NULL, 3, 2, 5, 66);
INSERT INTO "soldiers" VALUES (1556, '', 3, '', 84, NULL, 8, 9, 10, 75);
INSERT INTO "soldiers" VALUES (1557, '', 2, '', 144, NULL, 4, 3, 2, 141);
INSERT INTO "soldiers" VALUES (1558, '', 2, '', 105, NULL, 4, 4, 2, 103);
INSERT INTO "soldiers" VALUES (1560, '', 4, '', 111, NULL, 4, 1, 3, 105);
INSERT INTO "soldiers" VALUES (1561, '', 2, '', 80, NULL, 20, 13, 4, 69);
INSERT INTO "soldiers" VALUES (1562, '', 2, '', 67, NULL, 12, NULL, 11, 43);
INSERT INTO "soldiers" VALUES (1563, '', 3, '', 103, NULL, 2, NULL, 2, 98);
INSERT INTO "soldiers" VALUES (1564, '', 6, '', 86, NULL, 44, 6, 12, 36);
INSERT INTO "soldiers" VALUES (1573, '', 1, '', 121, NULL, 55, NULL, NULL, 65);
INSERT INTO "soldiers" VALUES (1574, '', 4, '', 110, NULL, 6, 8, 9, 103);
INSERT INTO "soldiers" VALUES (1576, '', 2, '', 86, NULL, 53, 1, NULL, 34);
INSERT INTO "soldiers" VALUES (1577, '', 1, '', 80, NULL, 7, 13, 33, 52);
INSERT INTO "soldiers" VALUES (1579, '', 5, '', 133, NULL, 23, 12, 23, 99);
INSERT INTO "soldiers" VALUES (1580, '', 3, '', 132, NULL, 38, 6, 35, 65);
INSERT INTO "soldiers" VALUES (1582, '', 2, '', 112, NULL, 20, 7, 24, 75);
INSERT INTO "soldiers" VALUES (1583, '', 3, '', 83, NULL, 20, 19, 8, 74);
INSERT INTO "soldiers" VALUES (1584, '', 1, '', 48, NULL, 4, 2, 20, 25);
INSERT INTO "soldiers" VALUES (1585, '', 1, '', 101, NULL, 13, 24, 30, 82);
INSERT INTO "soldiers" VALUES (1586, '', 2, '', 84, NULL, 12, 5, 3, 74);
INSERT INTO "soldiers" VALUES (1587, '', 4, '', 128, NULL, 15, 13, 1, 125);
INSERT INTO "soldiers" VALUES (1590, '', 2, '', 64, NULL, 3, 5, 3, 63);
INSERT INTO "soldiers" VALUES (1591, '', 1, '', 134, NULL, 44, 12, 5, 95);
INSERT INTO "soldiers" VALUES (1592, '', 4, '', 66, NULL, 5, NULL, 27, 18);
INSERT INTO "soldiers" VALUES (1593, '', 1, '', 57, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (1594, '', 4, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (1595, '', 1, '', 51, NULL, 14, 1, 2, 36);
INSERT INTO "soldiers" VALUES (1596, '', 3, '', 94, NULL, 10, 3, 35, 44);
INSERT INTO "soldiers" VALUES (1597, '', 5, '', 129, NULL, 15, 20, 85, 49);
INSERT INTO "soldiers" VALUES (1598, '', 2, '', 129, NULL, 11, 39, 147, 10);
INSERT INTO "soldiers" VALUES (1599, '', 2, '', 89, NULL, 5, 1, 3, 82);
INSERT INTO "soldiers" VALUES (1601, '', 3, '', 123, NULL, 30, NULL, 6, 86);
INSERT INTO "soldiers" VALUES (1603, '', 4, '', 101, NULL, 27, 12, 29, 57);
INSERT INTO "soldiers" VALUES (1606, '', 3, '', 62, NULL, 10, 2, 8, 51);
INSERT INTO "soldiers" VALUES (1608, '', 3, '', 37, NULL, 10, 1, 12, 16);
INSERT INTO "soldiers" VALUES (1609, '', 2, '', 59, NULL, 10, 8, 4, 53);
INSERT INTO "soldiers" VALUES (1611, '', 5, '', 105, NULL, 12, 2, 22, 73);
INSERT INTO "soldiers" VALUES (1612, '', 3, '', 122, NULL, 8, 4, 27, 91);
INSERT INTO "soldiers" VALUES (1613, '', 3, '', 95, NULL, 17, 5, 21, 62);
INSERT INTO "soldiers" VALUES (1614, '', 1, '', 46, NULL, 1, 2, 12, 35);
INSERT INTO "soldiers" VALUES (1615, '', 2, '', 49, NULL, 1, 1, 4, 44);
INSERT INTO "soldiers" VALUES (1616, '', 3, '', 57, NULL, 15, 4, 8, 38);
INSERT INTO "soldiers" VALUES (1617, '', 2, '', 92, NULL, 15, 4, 41, 40);
INSERT INTO "soldiers" VALUES (1618, '', 2, '', 111, NULL, 11, 8, 26, 82);
INSERT INTO "soldiers" VALUES (1619, '', 2, '', 47, NULL, 6, 3, 11, 33);
INSERT INTO "soldiers" VALUES (1620, '', 3, '', 20, NULL, 11, NULL, NULL, 9);
INSERT INTO "soldiers" VALUES (1621, '', 3, '', 90, NULL, 17, 24, 63, 34);
INSERT INTO "soldiers" VALUES (1622, '', 5, '', 84, NULL, 11, NULL, 14, 59);
INSERT INTO "soldiers" VALUES (1623, '', 1, '', 116, NULL, 20, 9, 61, 44);
INSERT INTO "soldiers" VALUES (1624, '', 2, '', 107, NULL, 9, 7, 37, 68);
INSERT INTO "soldiers" VALUES (1625, '', 2, '', 66, NULL, 12, 4, 25, 33);
INSERT INTO "soldiers" VALUES (1626, '', 2, '', 41, 2, 10, 12, 2, 41);
INSERT INTO "soldiers" VALUES (1627, '', 4, '', 92, NULL, 2, 3, 19, 74);
INSERT INTO "soldiers" VALUES (1630, '', 1, '', 97, NULL, 6, 4, 27, 68);
INSERT INTO "soldiers" VALUES (1631, '', 1, '', 129, NULL, 10, 3, 25, 97);
INSERT INTO "soldiers" VALUES (1635, '', 1, '', 119, NULL, 16, 18, 23, 98);
INSERT INTO "soldiers" VALUES (1637, '', 1, '', 86, NULL, 8, 20, 50, 48);
INSERT INTO "soldiers" VALUES (1642, '', 2, '', 73, NULL, 13, 1, 23, 38);
INSERT INTO "soldiers" VALUES (1643, '', 4, '', 124, NULL, 11, 46, 101, 58);
INSERT INTO "soldiers" VALUES (1644, '', 1, '', 70, NULL, 6, 9, 2, 71);
INSERT INTO "soldiers" VALUES (1645, '', 1, '', 91, NULL, 7, 12, 2, 95);
INSERT INTO "soldiers" VALUES (1646, '', 3, '', 56, NULL, 2, 4, 7, 51);
INSERT INTO "soldiers" VALUES (1648, '', 1, '', 122, NULL, 18, 6, 16, 94);
INSERT INTO "soldiers" VALUES (1649, '', 5, '', 110, NULL, 32, 1, 23, 55);
INSERT INTO "soldiers" VALUES (1650, '', 1, '', 111, NULL, 10, 5, 29, 77);
INSERT INTO "soldiers" VALUES (1652, '', 5, '', 45, 1, 11, 3, 1, 38);
INSERT INTO "soldiers" VALUES (1654, '', 1, '', 90, NULL, 12, 11, 15, 73);
INSERT INTO "soldiers" VALUES (1655, '', 1, '', 79, NULL, 72, NULL, 7, NULL);
INSERT INTO "soldiers" VALUES (1657, '', 1, '', 104, NULL, 22, 11, 4, 89);
INSERT INTO "soldiers" VALUES (1659, '', 2, '', 73, 5, 16, 9, 5, 60);
INSERT INTO "soldiers" VALUES (1660, '', 1, '', 45, NULL, 2, 2, 4, 41);
INSERT INTO "soldiers" VALUES (1662, '', 1, '', 99, NULL, 14, 6, 12, 79);
INSERT INTO "soldiers" VALUES (1664, '', 1, '', 76, NULL, 10, 6, 18, 54);
INSERT INTO "soldiers" VALUES (1667, '', 1, '', 133, NULL, 26, 19, 18, 108);
INSERT INTO "soldiers" VALUES (1668, '', 1, '', 103, NULL, 15, 7, 16, 79);
INSERT INTO "soldiers" VALUES (1670, '', 2, '', 111, NULL, 4, 27, 69, 65);
INSERT INTO "soldiers" VALUES (1672, '', 3, '', 138, NULL, 8, 3, 17, 116);
INSERT INTO "soldiers" VALUES (1673, '', 4, '', 87, NULL, 29, 1, NULL, 59);
INSERT INTO "soldiers" VALUES (1674, '', 3, '', 89, NULL, 20, 10, 19, 60);
INSERT INTO "soldiers" VALUES (1675, '', 1, '', 98, NULL, 27, 20, 28, 62);
INSERT INTO "soldiers" VALUES (1676, '', 3, '', 84, NULL, 27, 7, 28, 36);
INSERT INTO "soldiers" VALUES (1677, '', 1, '', 121, NULL, 8, 7, 14, 106);
INSERT INTO "soldiers" VALUES (1678, '', 1, '', 103, NULL, 5, 3, 21, 80);
INSERT INTO "soldiers" VALUES (1681, '', 1, '', 83, NULL, 16, 8, 22, 50);
INSERT INTO "soldiers" VALUES (1682, '', 2, '', 77, NULL, 6, 7, 7, 71);
INSERT INTO "soldiers" VALUES (1683, '', 1, '', 76, NULL, 12, 9, 34, 39);
INSERT INTO "soldiers" VALUES (1684, '', 2, '', 101, NULL, 24, 39, 58, 58);
INSERT INTO "soldiers" VALUES (1685, '', 4, '', 107, NULL, 15, 3, 12, 83);
INSERT INTO "soldiers" VALUES (1686, '', 4, '', 20, NULL, 4, 2, 7, 11);
INSERT INTO "soldiers" VALUES (1688, '', 3, '', 131, NULL, 36, 5, 11, 89);
INSERT INTO "soldiers" VALUES (1689, '', 3, '', 43, NULL, 4, 11, 23, 27);
INSERT INTO "soldiers" VALUES (1690, '', 5, '', 77, NULL, 13, 2, 17, 49);
INSERT INTO "soldiers" VALUES (1691, '', 1, '', 100, NULL, 20, 3, 4, 79);
INSERT INTO "soldiers" VALUES (1692, '', 3, '', 66, NULL, 8, 23, 49, 32);
INSERT INTO "soldiers" VALUES (1693, '', 4, '', 144, NULL, 16, 3, 56, 75);
INSERT INTO "soldiers" VALUES (1694, '', 4, '', 66, NULL, 10, 4, 33, 27);
INSERT INTO "soldiers" VALUES (1695, '', 2, '', 107, NULL, 25, 6, 13, 75);
INSERT INTO "soldiers" VALUES (1697, '', 1, '', 82, NULL, 4, 2, 9, 64);
INSERT INTO "soldiers" VALUES (1698, '', 4, '', 67, NULL, 22, 5, 7, 43);
INSERT INTO "soldiers" VALUES (1699, '', 3, '', 124, NULL, 47, 9, 27, 59);
INSERT INTO "soldiers" VALUES (1701, '', 1, '', 127, NULL, 48, 3, NULL, 82);
INSERT INTO "soldiers" VALUES (1702, '', 1, '', 71, NULL, 9, 13, 6, 70);
INSERT INTO "soldiers" VALUES (1703, '', 3, '', 82, NULL, 5, 5, 10, 72);
INSERT INTO "soldiers" VALUES (1705, '', 1, '', 45, NULL, NULL, 1, NULL, 44);
INSERT INTO "soldiers" VALUES (1706, '', 1, '', 127, NULL, 22, 2, 10, 97);
INSERT INTO "soldiers" VALUES (1707, '', 1, '', 35, 1, 34, NULL, 1, NULL);
INSERT INTO "soldiers" VALUES (1710, '', 1, '', 70, NULL, 8, 6, 10, 58);
INSERT INTO "soldiers" VALUES (1711, '', 1, '', 70, NULL, 11, 4, 19, 44);
INSERT INTO "soldiers" VALUES (1712, '', 2, '', 94, NULL, 15, 9, 12, 76);
INSERT INTO "soldiers" VALUES (1713, '', 2, '', 47, NULL, 5, 4, 5, 41);
INSERT INTO "soldiers" VALUES (1714, '', 3, '', 86, NULL, 15, 6, 17, 60);
INSERT INTO "soldiers" VALUES (1715, '', 2, '', 103, NULL, 14, 3, 15, 77);
INSERT INTO "soldiers" VALUES (1716, '', 1, '', 50, NULL, 7, 2, 7, 38);
INSERT INTO "soldiers" VALUES (1717, '', 2, '', 54, NULL, 7, 5, 12, 40);
INSERT INTO "soldiers" VALUES (1718, '', 2, '', 104, NULL, 18, 3, 24, 65);
INSERT INTO "soldiers" VALUES (1723, '', 3, '', 68, NULL, 5, 10, 3, 70);
INSERT INTO "soldiers" VALUES (1725, '', 5, '', 114, NULL, 14, 4, 18, 82);
INSERT INTO "soldiers" VALUES (1726, '', 1, '', 51, NULL, 7, 2, 12, 28);
INSERT INTO "soldiers" VALUES (1728, '', 2, '', 56, NULL, 8, 4, 13, 38);
INSERT INTO "soldiers" VALUES (1729, '', 2, '', 113, NULL, 13, 2, 15, 87);
INSERT INTO "soldiers" VALUES (1731, '', 2, '', 89, NULL, 11, 10, 15, 73);
INSERT INTO "soldiers" VALUES (1732, '', 2, '', 97, NULL, 8, 3, 14, 78);
INSERT INTO "soldiers" VALUES (1733, '', 2, '', 90, NULL, 12, 4, 14, 67);
INSERT INTO "soldiers" VALUES (1734, '', 1, '', 109, NULL, 2, 2, 4, 105);
INSERT INTO "soldiers" VALUES (1735, '', 1, '', 90, NULL, 7, 5, 5, 81);
INSERT INTO "soldiers" VALUES (1736, '', 2, '', 68, NULL, 17, 11, 27, 35);
INSERT INTO "soldiers" VALUES (1738, '', 2, '', 91, NULL, 2, 10, 47, 52);
INSERT INTO "soldiers" VALUES (1740, '', 1, '', 33, NULL, 1, 1, NULL, 33);
INSERT INTO "soldiers" VALUES (1743, '', 3, '', 40, NULL, 5, 19, 20, 34);
INSERT INTO "soldiers" VALUES (1744, '', 2, '', 90, NULL, 8, 2, 35, 49);
INSERT INTO "soldiers" VALUES (1746, '', 2, '', 106, NULL, 20, 11, 41, 56);
INSERT INTO "soldiers" VALUES (1747, '', 1, '', 97, 2, 22, 14, 2, 87);
INSERT INTO "soldiers" VALUES (1749, '', 1, '', 99, 1, 4, 1, 1, 95);
INSERT INTO "soldiers" VALUES (1750, '', 3, '', 80, NULL, 5, 7, 3, 79);
INSERT INTO "soldiers" VALUES (1751, '', 1, '', 59, NULL, NULL, 1, 3, 56);
INSERT INTO "soldiers" VALUES (1752, '', 4, '', 128, NULL, 10, 10, 12, 116);
INSERT INTO "soldiers" VALUES (1754, '', 2, '', 93, NULL, 6, 9, 8, 88);
INSERT INTO "soldiers" VALUES (1756, '', 2, '', 25, NULL, NULL, 4, NULL, 29);
INSERT INTO "soldiers" VALUES (1757, '', 3, '', 97, NULL, 5, 11, 2, 99);
INSERT INTO "soldiers" VALUES (1758, '', 4, '', 102, NULL, 1, 3, 5, 99);
INSERT INTO "soldiers" VALUES (1759, '', 4, '', 64, NULL, 1, 1, 2, 62);
INSERT INTO "soldiers" VALUES (1760, '', 2, '', 77, NULL, 32, 35, 56, 24);
INSERT INTO "soldiers" VALUES (1761, '', 4, '', 82, NULL, 16, 6, 4, 68);
INSERT INTO "soldiers" VALUES (1762, '', 2, '', 128, NULL, 16, 16, 6, 122);
INSERT INTO "soldiers" VALUES (1765, '', 1, '', 79, 11, 13, 12, 11, 67);
INSERT INTO "soldiers" VALUES (1766, '', 2, '', 73, NULL, 10, 8, 12, 59);
INSERT INTO "soldiers" VALUES (1769, '', 1, '', 103, NULL, 9, 9, 2, 101);
INSERT INTO "soldiers" VALUES (1770, '', 1, '', 109, NULL, 5, 7, 16, 95);
INSERT INTO "soldiers" VALUES (1774, '', 3, '', 81, NULL, 4, 23, 4, 96);
INSERT INTO "soldiers" VALUES (1775, '', 1, '', 30, 4, 2, 20, 4, 44);
INSERT INTO "soldiers" VALUES (1776, '', 5, '', 89, 1, 6, 21, 1, 103);
INSERT INTO "soldiers" VALUES (1777, '', 3, '', 48, NULL, 1, 19, NULL, 66);
INSERT INTO "soldiers" VALUES (1778, '', 2, '', 55, 1, 4, 21, 1, 71);
INSERT INTO "soldiers" VALUES (1779, '', 2, '', 85, NULL, 6, 4, 2, 81);
INSERT INTO "soldiers" VALUES (1780, '', 2, '', 44, 2, 4, 4, 2, 42);
INSERT INTO "soldiers" VALUES (1781, '', 2, '', NULL, NULL, NULL, 4, NULL, 4);
INSERT INTO "soldiers" VALUES (1782, '', 2, '', 122, NULL, 33, 34, 12, 111);
INSERT INTO "soldiers" VALUES (1783, '', 3, '', 116, NULL, 10, 8, 17, 97);
INSERT INTO "soldiers" VALUES (1784, '', 2, '', 69, NULL, 24, 21, 4, 62);
INSERT INTO "soldiers" VALUES (1785, '', 1, '', 64, NULL, 9, 11, 7, 59);
INSERT INTO "soldiers" VALUES (1788, '', 2, '', 82, NULL, 15, 10, 2, 75);
INSERT INTO "soldiers" VALUES (1789, '', 1, '', 53, NULL, 1, 2, 1, 53);
INSERT INTO "soldiers" VALUES (1791, '', 3, '', 104, 1, 4, 5, 1, 102);
INSERT INTO "soldiers" VALUES (1794, '', 3, '', 91, 1, NULL, NULL, 1, 90);
INSERT INTO "soldiers" VALUES (1795, '', 2, '', 51, NULL, 2, 1, NULL, 50);
INSERT INTO "soldiers" VALUES (1797, '', 3, '', 67, NULL, 4, 2, 1, 64);
INSERT INTO "soldiers" VALUES (1798, '', 5, '', 115, NULL, 14, 8, 3, 106);
INSERT INTO "soldiers" VALUES (1799, '', 2, '', 77, 1, 6, 6, 1, 76);
INSERT INTO "soldiers" VALUES (1800, '', 2, '', 84, NULL, 6, 13, 5, 86);
INSERT INTO "soldiers" VALUES (1802, '', 1, '', 84, NULL, 7, 1, 3, 75);
INSERT INTO "soldiers" VALUES (1803, '', 3, '', 83, NULL, 3, 19, 4, 95);
INSERT INTO "soldiers" VALUES (1804, '', 4, '', NULL, NULL, NULL, 4, NULL, 4);
INSERT INTO "soldiers" VALUES (1806, '', 4, '', 107, NULL, 14, 18, 29, 82);
INSERT INTO "soldiers" VALUES (1808, '', 3, '', 83, NULL, 8, 2, 6, 68);
INSERT INTO "soldiers" VALUES (1810, '', 1, '', 116, NULL, 4, 5, 4, 113);
INSERT INTO "soldiers" VALUES (1813, '', 1, '', 48, NULL, 4, 29, NULL, 73);
INSERT INTO "soldiers" VALUES (1814, '', 2, '', NULL, NULL, NULL, 12, NULL, 12);
INSERT INTO "soldiers" VALUES (1819, '', 3, '', 90, NULL, 8, 10, 2, 90);
INSERT INTO "soldiers" VALUES (1820, '', 1, '', 1, NULL, 1, 1, NULL, 1);
INSERT INTO "soldiers" VALUES (1835, '', 4, '', 79, NULL, 7, 3, 2, 73);
INSERT INTO "soldiers" VALUES (1836, '', 3, '', 77, NULL, 12, 10, 5, 72);
INSERT INTO "soldiers" VALUES (1838, '', 3, '', 72, NULL, 4, 6, NULL, 74);
INSERT INTO "soldiers" VALUES (1839, '', 1, '', 29, NULL, 4, 5, 2, 27);
INSERT INTO "soldiers" VALUES (1840, '', 4, '', 72, NULL, 10, 3, 1, 64);
INSERT INTO "soldiers" VALUES (1842, '', 1, '', 65, 1, 10, 2, 1, 56);
INSERT INTO "soldiers" VALUES (1844, '', 1, '', 54, NULL, 7, 3, 1, 48);
INSERT INTO "soldiers" VALUES (1845, '', 3, '', 43, NULL, NULL, NULL, NULL, 43);
INSERT INTO "soldiers" VALUES (1846, '', 3, '', 57, NULL, 1, NULL, 2, 53);
INSERT INTO "soldiers" VALUES (1848, '', 1, '', 33, NULL, 2, NULL, 4, 27);
INSERT INTO "soldiers" VALUES (1849, '', 3, '', 41, NULL, 3, 5, NULL, 43);
INSERT INTO "soldiers" VALUES (1850, '', 5, '', 40, NULL, 5, 3, 4, 34);
INSERT INTO "soldiers" VALUES (1851, '', 4, '', 41, 1, 3, 2, 1, 36);
INSERT INTO "soldiers" VALUES (1852, '', 4, '', 67, 3, 6, 1, 3, 59);
INSERT INTO "soldiers" VALUES (1854, '', 3, '', 23, 1, NULL, NULL, 1, 22);
INSERT INTO "soldiers" VALUES (1855, '', 1, '', 71, NULL, 5, 2, 1, 65);
INSERT INTO "soldiers" VALUES (1856, '', 2, '', 53, NULL, 4, 3, NULL, 52);
INSERT INTO "soldiers" VALUES (1857, '', 4, '', 40, NULL, 1, 1, NULL, 40);
INSERT INTO "soldiers" VALUES (1858, '', 5, '', 36, 1, 4, NULL, 1, 31);
INSERT INTO "soldiers" VALUES (1859, '', 3, '', 29, NULL, 7, 3, NULL, 25);
INSERT INTO "soldiers" VALUES (1860, '', 5, '', 60, 2, 9, 4, 2, 53);
INSERT INTO "soldiers" VALUES (1861, '', 3, '', 30, NULL, 4, 4, 4, 26);
INSERT INTO "soldiers" VALUES (1862, '', 4, '', 57, NULL, 4, 1, 4, 50);
INSERT INTO "soldiers" VALUES (1863, '', 6, '', 80, NULL, 11, 4, 2, 71);
INSERT INTO "soldiers" VALUES (1864, '', 3, '', 65, NULL, 5, NULL, 4, 56);
INSERT INTO "soldiers" VALUES (1865, '', 2, '', 29, NULL, 3, 1, NULL, 28);
INSERT INTO "soldiers" VALUES (1866, '', 1, '', 54, NULL, 5, 5, 5, 49);
INSERT INTO "soldiers" VALUES (1867, '', 1, '', 54, NULL, 14, 11, 4, 53);
INSERT INTO "soldiers" VALUES (1868, '', 2, '', 67, NULL, 7, 1, 4, 57);
INSERT INTO "soldiers" VALUES (1871, '', 4, '', 61, NULL, 8, NULL, 6, 47);
INSERT INTO "soldiers" VALUES (1873, '', 2, '', 29, NULL, 3, 1, NULL, 27);
INSERT INTO "soldiers" VALUES (1874, '', 3, '', 54, NULL, 11, 1, NULL, 44);
INSERT INTO "soldiers" VALUES (1875, '', 2, '', 26, NULL, 1, 5, NULL, 30);
INSERT INTO "soldiers" VALUES (1876, '', 1, '', 42, NULL, 2, 4, 2, 42);
INSERT INTO "soldiers" VALUES (1878, '', 1, '', 62, NULL, 5, NULL, 1, 56);
INSERT INTO "soldiers" VALUES (1879, '', 4, '', 78, NULL, 5, 19, 4, 88);
INSERT INTO "soldiers" VALUES (1880, '', 2, '', 36, 2, 3, NULL, 2, 31);
INSERT INTO "soldiers" VALUES (1881, '', 4, '', 78, 1, 7, 6, 1, 74);
INSERT INTO "soldiers" VALUES (1882, '', 3, '', 61, 2, 6, 2, 2, 55);
INSERT INTO "soldiers" VALUES (1883, '', 4, '', 94, NULL, 11, 3, 2, 84);
INSERT INTO "soldiers" VALUES (1884, '', 1, '', 89, NULL, 10, 2, 6, 74);
INSERT INTO "soldiers" VALUES (1885, '', 2, '', 35, 1, 2, 4, 2, 35);
INSERT INTO "soldiers" VALUES (1886, '', 1, '', 37, NULL, 3, 2, NULL, 36);
INSERT INTO "soldiers" VALUES (1887, '', 4, '', 16, NULL, NULL, NULL, NULL, 16);
INSERT INTO "soldiers" VALUES (1888, '', 3, '', 45, NULL, 2, 4, 1, 46);
INSERT INTO "soldiers" VALUES (1889, '', 3, '', 84, NULL, 12, 12, 8, 76);
INSERT INTO "soldiers" VALUES (1891, '', 4, '', 79, NULL, 6, 6, 17, 62);
INSERT INTO "soldiers" VALUES (1892, '', 3, '', 70, NULL, 14, 7, 3, 60);
INSERT INTO "soldiers" VALUES (1894, '', 1, '', 36, NULL, 4, 3, NULL, 35);
INSERT INTO "soldiers" VALUES (1896, '', 1, '', 34, NULL, 5, 1, 3, 28);
INSERT INTO "soldiers" VALUES (1899, '', 4, '', 61, NULL, 2, 3, 1, 61);
INSERT INTO "soldiers" VALUES (1900, '', 1, '', 60, NULL, 12, 7, 11, 51);
INSERT INTO "soldiers" VALUES (1901, '', 1, '', 42, NULL, 5, 5, 1, 41);
INSERT INTO "soldiers" VALUES (1902, '', 3, '', 38, NULL, 1, 1, NULL, 38);
INSERT INTO "soldiers" VALUES (1903, '', 4, '', 57, NULL, 13, 3, 7, 40);
INSERT INTO "soldiers" VALUES (1906, '', 2, '', 45, NULL, 8, NULL, 2, 35);
INSERT INTO "soldiers" VALUES (1907, '', 4, '', 28, NULL, 3, NULL, NULL, 25);
INSERT INTO "soldiers" VALUES (1908, '', 1, '', 43, NULL, 3, 2, 3, 39);
INSERT INTO "soldiers" VALUES (1910, '', 3, '', 71, NULL, 2, 6, 6, 69);
INSERT INTO "soldiers" VALUES (1911, '', 2, '', 73, NULL, 8, 4, 9, 60);
INSERT INTO "soldiers" VALUES (1912, '', 2, '', 42, NULL, 2, NULL, 2, 38);
INSERT INTO "soldiers" VALUES (1913, '', 4, '', 58, NULL, 7, NULL, NULL, 51);
INSERT INTO "soldiers" VALUES (1915, '', 1, '', 52, NULL, 13, 5, NULL, 44);
INSERT INTO "soldiers" VALUES (1916, '', 5, '', 38, NULL, 4, 3, NULL, 37);
INSERT INTO "soldiers" VALUES (1917, '', 2, '', 40, NULL, 6, 2, 2, 34);
INSERT INTO "soldiers" VALUES (1918, '', 6, '', 40, NULL, 2, 4, 3, 39);
INSERT INTO "soldiers" VALUES (1919, '', 4, '', 82, NULL, 3, 2, 6, 75);
INSERT INTO "soldiers" VALUES (1920, '', 1, '', 37, NULL, 5, 6, 7, 31);
INSERT INTO "soldiers" VALUES (1921, '', 5, '', 53, NULL, 4, 2, 2, 47);
INSERT INTO "soldiers" VALUES (1922, '', 2, '', 44, NULL, 2, 6, 10, 38);
INSERT INTO "soldiers" VALUES (1923, '', 6, '', 1, NULL, NULL, 3, NULL, 4);
INSERT INTO "soldiers" VALUES (1924, '', 1, '', 46, NULL, 5, 10, 13, 38);
INSERT INTO "soldiers" VALUES (1925, '', 4, '', 55, NULL, 9, 5, 15, 36);
INSERT INTO "soldiers" VALUES (1928, '', 1, '', 60, NULL, 7, 10, 7, 56);
INSERT INTO "soldiers" VALUES (1930, '', 3, '', 55, NULL, NULL, NULL, 10, 45);
INSERT INTO "soldiers" VALUES (1934, '', 3, '', 60, NULL, 8, 7, 2, 57);
INSERT INTO "soldiers" VALUES (1935, '', 4, '', 91, 13, 4, 9, 13, 83);
INSERT INTO "soldiers" VALUES (1936, '', 5, '', 86, 9, 15, 1, 9, 63);
INSERT INTO "soldiers" VALUES (1937, '', 1, '', 61, NULL, 4, 22, 1, 71);
INSERT INTO "soldiers" VALUES (1939, '', 3, '', 30, 4, 2, NULL, 4, 24);
INSERT INTO "soldiers" VALUES (1941, '', 3, '', 108, NULL, 16, 5, 10, 87);
INSERT INTO "soldiers" VALUES (1942, '', 4, '', 108, NULL, 7, 7, 12, 96);
INSERT INTO "soldiers" VALUES (1943, '', 3, '', 49, NULL, 1, NULL, 9, 37);
INSERT INTO "soldiers" VALUES (1944, '', 4, '', 54, NULL, 8, 3, 2, 47);
INSERT INTO "soldiers" VALUES (1945, '', 1, '', 50, 13, 2, 2, 14, 36);
INSERT INTO "soldiers" VALUES (1946, '', 3, '', 126, NULL, 12, 1, 10, 105);
INSERT INTO "soldiers" VALUES (1948, '', 3, '', 43, NULL, 6, 6, 10, 33);
INSERT INTO "soldiers" VALUES (1949, '', 5, '', 83, NULL, 5, 4, 3, 79);
INSERT INTO "soldiers" VALUES (1950, '', 1, '', 53, NULL, 7, 3, 1, 58);
INSERT INTO "soldiers" VALUES (1951, '', 5, '', 101, 38, 16, 29, 39, 75);
INSERT INTO "soldiers" VALUES (1952, '', 1, '', 98, NULL, 17, 7, 2, 86);
INSERT INTO "soldiers" VALUES (1953, '', 5, '', 96, NULL, 18, 5, 3, 80);
INSERT INTO "soldiers" VALUES (1954, '', 1, '', 113, 17, 20, 2, 17, 78);
INSERT INTO "soldiers" VALUES (1955, '', 1, '', 108, 5, 10, 9, 6, 101);
INSERT INTO "soldiers" VALUES (1956, '', 5, '', 145, 39, 23, 9, 39, 92);
INSERT INTO "soldiers" VALUES (1957, '', 1, '', 50, 1, 6, 4, 1, 47);
INSERT INTO "soldiers" VALUES (1958, '', 4, '', 78, 1, 7, 8, 1, 78);
INSERT INTO "soldiers" VALUES (1959, '', 1, '', 54, 4, 4, 2, 4, 48);
INSERT INTO "soldiers" VALUES (1963, '', 1, '', 44, NULL, 3, 5, NULL, 46);
INSERT INTO "soldiers" VALUES (1964, '', 2, '', 61, 3, 3, 3, 3, 58);
INSERT INTO "soldiers" VALUES (1965, '', 3, '', 61, NULL, 3, 1, NULL, 59);
INSERT INTO "soldiers" VALUES (1966, '', 4, '', 106, 3, 9, 5, 5, 97);
INSERT INTO "soldiers" VALUES (1967, '', 3, '', 98, 2, 4, 7, 2, 99);
INSERT INTO "soldiers" VALUES (1968, '', 2, '', 51, NULL, 1, 1, NULL, 49);
INSERT INTO "soldiers" VALUES (1969, '', 2, '', 60, 3, 2, 6, 3, 61);
INSERT INTO "soldiers" VALUES (1970, '', 2, '', 63, NULL, NULL, 2, 1, 64);
INSERT INTO "soldiers" VALUES (1971, '', 5, '', 86, 1, 5, 4, 1, 84);
INSERT INTO "soldiers" VALUES (1972, '', 2, '', 82, 5, 4, 6, 5, 79);
INSERT INTO "soldiers" VALUES (1973, '', 3, '', 40, 2, 6, 3, 2, 35);
INSERT INTO "soldiers" VALUES (1974, '', 1, '', 60, 11, 10, 26, 11, 48);
INSERT INTO "soldiers" VALUES (1976, '', 6, '', 33, 5, 10, 26, 5, 44);
INSERT INTO "soldiers" VALUES (1977, '', 4, '', 86, 4, 10, 4, 4, 76);
INSERT INTO "soldiers" VALUES (1978, '', 1, '', 62, 4, 4, 5, 5, 58);
INSERT INTO "soldiers" VALUES (1979, '', 4, '', 95, 4, 1, 8, 4, 78);
INSERT INTO "soldiers" VALUES (1980, '', 5, '', 82, 8, 9, 2, 9, 67);
INSERT INTO "soldiers" VALUES (1981, '', 1, '', 83, 7, 10, 9, 7, 75);
INSERT INTO "soldiers" VALUES (1983, '', 1, '', 121, 4, 35, 9, 4, 91);
INSERT INTO "soldiers" VALUES (1984, '', 1, '', 99, 1, 16, 8, 4, 81);
INSERT INTO "soldiers" VALUES (1985, '', 2, '', 97, NULL, 7, 3, 10, 83);
INSERT INTO "soldiers" VALUES (1986, '', 1, '', 97, NULL, 6, 4, 1, 93);
INSERT INTO "soldiers" VALUES (1987, '', 1, '', 48, NULL, 3, 3, NULL, 48);
INSERT INTO "soldiers" VALUES (1988, '', 5, '', 75, 1, 4, 1, 1, 71);
INSERT INTO "soldiers" VALUES (1989, '', 2, '', 44, 1, 2, 8, 1, 49);
INSERT INTO "soldiers" VALUES (1991, '', 2, '', 81, 13, 3, 5, 13, 70);
INSERT INTO "soldiers" VALUES (1993, '', 4, '', 80, 6, 8, 4, 7, 69);
INSERT INTO "soldiers" VALUES (1994, '', 4, '', 39, 4, 11, 13, 4, 37);
INSERT INTO "soldiers" VALUES (1995, '', 1, '', 61, NULL, 10, 4, NULL, 55);
INSERT INTO "soldiers" VALUES (1996, '', 1, '', 99, 5, 19, 16, 6, 95);
INSERT INTO "soldiers" VALUES (1997, '', 4, '', 50, NULL, NULL, 7, 48, 9);
INSERT INTO "soldiers" VALUES (1998, '', 2, '', 77, 11, 16, 14, NULL, 64);
INSERT INTO "soldiers" VALUES (1999, '', 1, '', 13, NULL, 1, 1, 1, 13);
INSERT INTO "soldiers" VALUES (2000, '', 1, '', 61, NULL, 4, 11, 9, 52);
INSERT INTO "soldiers" VALUES (2001, '', 6, '', 81, NULL, 1, 8, 8, 81);
INSERT INTO "soldiers" VALUES (2002, '', 3, '', 60, NULL, 2, 3, 10, 51);
INSERT INTO "soldiers" VALUES (2003, '', 2, '', 64, NULL, 12, 30, 35, 47);
INSERT INTO "soldiers" VALUES (2004, '', 4, '', 47, NULL, 3, 9, 6, 47);
INSERT INTO "soldiers" VALUES (2005, '', 2, '', 65, NULL, 9, 1, 5, 52);
INSERT INTO "soldiers" VALUES (2007, '', 3, '', 86, NULL, 21, 4, 8, 61);
INSERT INTO "soldiers" VALUES (2008, '', 2, '', 46, NULL, 2, 1, 2, 43);
INSERT INTO "soldiers" VALUES (2010, '', 4, '', 59, NULL, 2, 2, 1, 56);
INSERT INTO "soldiers" VALUES (2011, '', 1, '', 136, NULL, 16, 4, 3, 128);
INSERT INTO "soldiers" VALUES (2012, '', 5, '', 99, NULL, 13, 5, NULL, 91);
INSERT INTO "soldiers" VALUES (2013, '', 1, '', 48, NULL, 7, 4, 3, 42);
INSERT INTO "soldiers" VALUES (2014, '', 5, '', 52, NULL, 3, 1, 2, 48);
INSERT INTO "soldiers" VALUES (2016, '', 4, '', 63, NULL, 10, 3, 6, 50);
INSERT INTO "soldiers" VALUES (2017, '', 1, '', 84, NULL, 14, 3, 2, 71);
INSERT INTO "soldiers" VALUES (2018, '', 1, '', 66, 1, 4, 2, 1, 63);
INSERT INTO "soldiers" VALUES (2019, '', 1, '', 105, NULL, 4, 5, 4, 102);
INSERT INTO "soldiers" VALUES (2020, '', 2, '', 94, NULL, 6, 2, 1, 89);
INSERT INTO "soldiers" VALUES (2021, '', 3, '', 66, NULL, 6, 1, 3, 58);
INSERT INTO "soldiers" VALUES (2022, '', 2, '', 88, NULL, 11, 9, 2, 84);
INSERT INTO "soldiers" VALUES (2024, '', 1, '', 124, 1, 2, NULL, 1, 121);
INSERT INTO "soldiers" VALUES (2026, '', 2, '', 87, NULL, 15, 3, 8, 67);
INSERT INTO "soldiers" VALUES (2027, '', 3, '', 38, NULL, 1, NULL, 1, 25);
INSERT INTO "soldiers" VALUES (2028, '', 3, '', 58, 2, 9, 3, 2, 49);
INSERT INTO "soldiers" VALUES (2029, '', 3, '', 60, 4, 5, 1, 4, 41);
INSERT INTO "soldiers" VALUES (2030, '', 5, '', 120, NULL, 13, 7, 5, 108);
INSERT INTO "soldiers" VALUES (2031, '', 4, '', 113, NULL, 33, 10, 3, 87);
INSERT INTO "soldiers" VALUES (2033, '', 2, '', 107, NULL, 14, NULL, 23, 70);
INSERT INTO "soldiers" VALUES (2034, '', 5, '', 94, NULL, 4, NULL, 5, 83);
INSERT INTO "soldiers" VALUES (2038, '', 1, '', 58, NULL, 11, 5, 3, 49);
INSERT INTO "soldiers" VALUES (2039, '', 2, '', 57, NULL, 4, 1, 4, 50);
INSERT INTO "soldiers" VALUES (2040, '', 5, '', 82, NULL, 48, NULL, 1, 29);
INSERT INTO "soldiers" VALUES (2041, '', 1, '', 87, NULL, 9, 37, 20, 94);
INSERT INTO "soldiers" VALUES (2042, '', 1, '', 54, NULL, 7, 3, 3, 47);
INSERT INTO "soldiers" VALUES (2044, '', 1, '', 89, NULL, 8, 24, 10, 92);
INSERT INTO "soldiers" VALUES (2046, '', 3, '', 71, 12, 39, NULL, 16, 37);
INSERT INTO "soldiers" VALUES (2047, '', 2, '', 59, 2, 1, NULL, 3, 55);
INSERT INTO "soldiers" VALUES (2049, '', 2, '', 89, NULL, 28, 25, 1, 85);
INSERT INTO "soldiers" VALUES (2050, '', 1, '', 68, NULL, 9, 3, 4, 58);
INSERT INTO "soldiers" VALUES (2051, '', 4, '', 52, NULL, 10, 2, NULL, 44);
INSERT INTO "soldiers" VALUES (2052, '', 6, '', 90, NULL, 4, NULL, 8, 78);
INSERT INTO "soldiers" VALUES (2053, '', 2, '', 60, NULL, 9, NULL, 4, 55);
INSERT INTO "soldiers" VALUES (2054, '', 2, '', 94, NULL, 4, 7, NULL, 90);
INSERT INTO "soldiers" VALUES (2055, '', 3, '', 59, NULL, 4, 3, NULL, 54);
INSERT INTO "soldiers" VALUES (2056, '', 2, '', 64, NULL, 10, 6, NULL, 43);
INSERT INTO "soldiers" VALUES (2057, '', 1, '', 45, NULL, 7, 8, NULL, 32);
INSERT INTO "soldiers" VALUES (2058, '', 5, '', 110, NULL, 12, 4, NULL, 90);
INSERT INTO "soldiers" VALUES (2059, '', 4, '', 133, NULL, 14, 4, NULL, 92);
INSERT INTO "soldiers" VALUES (2060, '', 2, '', 101, NULL, 6, 3, NULL, 90);
INSERT INTO "soldiers" VALUES (2064, '', 2, '', 47, NULL, 12, 9, NULL, 44);
INSERT INTO "soldiers" VALUES (2065, '', 1, '', 65, NULL, 6, 2, 13, 48);
INSERT INTO "soldiers" VALUES (2066, '', 1, '', 101, NULL, 7, 4, NULL, 95);
INSERT INTO "soldiers" VALUES (2069, '', 3, '', 93, NULL, 9, 2, NULL, 86);
INSERT INTO "soldiers" VALUES (2070, '', 1, '', 92, NULL, 10, 6, NULL, 79);
INSERT INTO "soldiers" VALUES (2071, '', 1, '', 55, NULL, 3, 2, NULL, 51);
INSERT INTO "soldiers" VALUES (2072, '', 6, '', 91, NULL, 9, 3, NULL, 81);
INSERT INTO "soldiers" VALUES (2073, '', 1, '', 57, 1, 3, 8, 6, 56);
INSERT INTO "soldiers" VALUES (2074, '', 6, '', 98, 1, 14, 13, 3, 94);
INSERT INTO "soldiers" VALUES (2075, '', 1, '', 63, 10, 3, 7, 19, 48);
INSERT INTO "soldiers" VALUES (2076, '', 2, '', 117, 7, 7, NULL, 21, 110);
INSERT INTO "soldiers" VALUES (2078, '', 1, '', 96, 3, 3, 12, 3, 102);
INSERT INTO "soldiers" VALUES (2079, '', 3, '', 67, 6, 5, NULL, 12, 65);
INSERT INTO "soldiers" VALUES (2081, '', 2, '', 99, 20, 24, 11, 28, 62);
INSERT INTO "soldiers" VALUES (2082, '', 3, '', 98, 8, 31, 13, 16, 64);
INSERT INTO "soldiers" VALUES (2083, '', 4, '', 38, 7, 2, 2, 7, 31);
INSERT INTO "soldiers" VALUES (2084, '', 7, '', 92, 18, 23, 22, 29, 63);
INSERT INTO "soldiers" VALUES (2085, '', 2, '', 100, 10, 18, 4, 14, 72);
INSERT INTO "soldiers" VALUES (2086, '', 4, '', 52, 32, 4, 3, 32, 12);
INSERT INTO "soldiers" VALUES (2087, '', 2, '', 60, 1, 1, NULL, 9, 54);
INSERT INTO "soldiers" VALUES (2089, '', 1, '', 35, 3, 3, NULL, 3, 28);
INSERT INTO "soldiers" VALUES (2090, '', 1, '', 43, NULL, 1, NULL, 2, 40);
INSERT INTO "soldiers" VALUES (2091, '', 3, '', 96, 25, 12, 11, 34, 61);
INSERT INTO "soldiers" VALUES (2092, '', 1, '', 118, 12, 9, 8, 25, 92);
INSERT INTO "soldiers" VALUES (2093, '', 1, '', 91, 14, 14, 8, 14, 71);
INSERT INTO "soldiers" VALUES (2094, '', 5, '', 56, NULL, 6, 3, NULL, 52);
INSERT INTO "soldiers" VALUES (2096, '', 2, '', 80, 1, 9, NULL, 1, 70);
INSERT INTO "soldiers" VALUES (2097, '', 2, '', 11, NULL, 1, 2, NULL, 12);
INSERT INTO "soldiers" VALUES (2098, '', 2, '', 74, 4, 5, 1, 4, 66);
INSERT INTO "soldiers" VALUES (2099, '', 5, '', 40, 2, NULL, NULL, 3, 36);
INSERT INTO "soldiers" VALUES (2101, '', 2, '', 55, NULL, 3, NULL, NULL, 52);
INSERT INTO "soldiers" VALUES (2102, '', 4, '', 49, NULL, 2, NULL, NULL, 47);
INSERT INTO "soldiers" VALUES (2103, '', 2, '', 96, 6, 13, 4, 6, 81);
INSERT INTO "soldiers" VALUES (2104, '', 1, '', 93, 2, 5, 1, 2, 87);
INSERT INTO "soldiers" VALUES (2105, '', 1, '', 44, 4, 8, 8, 8, 32);
INSERT INTO "soldiers" VALUES (2106, '', 6, '', 111, 2, 16, 5, 2, 98);
INSERT INTO "soldiers" VALUES (2107, '', 2, '', 52, 1, 4, NULL, 1, 47);
INSERT INTO "soldiers" VALUES (2108, '', 2, '', 82, 1, 4, 7, 3, 82);
INSERT INTO "soldiers" VALUES (2109, '', 3, '', 54, 6, 19, NULL, 6, 29);
INSERT INTO "soldiers" VALUES (2110, '', 1, '', 51, NULL, 11, 9, NULL, 49);
INSERT INTO "soldiers" VALUES (2111, '', 2, '', 39, 5, 3, 4, 5, 35);
INSERT INTO "soldiers" VALUES (2112, '', 1, '', 47, 1, 2, NULL, 1, 44);
INSERT INTO "soldiers" VALUES (2114, '', 2, '', 53, 2, 2, NULL, 2, 49);
INSERT INTO "soldiers" VALUES (2115, '', 1, '', 53, NULL, NULL, NULL, NULL, 53);
INSERT INTO "soldiers" VALUES (2116, '', 5, '', 97, 1, 15, NULL, 2, 80);
INSERT INTO "soldiers" VALUES (2117, '', 3, '', 53, 1, 4, 2, 3, 48);
INSERT INTO "soldiers" VALUES (2118, '', 2, '', 83, 30, 8, 20, 30, 65);
INSERT INTO "soldiers" VALUES (2119, '', 1, '', 83, 15, 18, 9, 16, 58);
INSERT INTO "soldiers" VALUES (2120, '', 4, '', 91, 8, 22, 8, 8, 69);
INSERT INTO "soldiers" VALUES (2125, '', 1, '', 39, NULL, 4, 3, NULL, 38);
INSERT INTO "soldiers" VALUES (2126, '', 3, '', 38, NULL, 6, 6, NULL, 38);
INSERT INTO "soldiers" VALUES (2127, '', 1, '', 54, 1, NULL, 2, 2, 54);
INSERT INTO "soldiers" VALUES (2128, '', 4, '', 75, 3, 4, 3, 3, 69);
INSERT INTO "soldiers" VALUES (2130, '', 2, '', 49, NULL, 4, 2, 2, 45);
INSERT INTO "soldiers" VALUES (2131, '', 4, '', 42, NULL, 1, 2, NULL, 43);
INSERT INTO "soldiers" VALUES (2132, '', 7, '', 74, 1, 7, 5, 1, 71);
INSERT INTO "soldiers" VALUES (2134, '', 3, '', 69, NULL, 1, 3, NULL, 71);
INSERT INTO "soldiers" VALUES (2136, '', 3, '', 76, 4, 7, 6, 8, 67);
INSERT INTO "soldiers" VALUES (2137, '', 1, '', 99, NULL, 2, 5, 1, 101);
INSERT INTO "soldiers" VALUES (2138, '', 6, '', 100, 4, 15, 11, 5, 91);
INSERT INTO "soldiers" VALUES (2139, '', 2, '', 82, 3, NULL, NULL, 3, 78);
INSERT INTO "soldiers" VALUES (2140, '', 2, '', 52, 4, 8, 16, 4, 54);
INSERT INTO "soldiers" VALUES (2141, '', 7, '', 74, 3, 6, 12, 3, 77);
INSERT INTO "soldiers" VALUES (2142, '', 1, '', 56, 2, 11, 7, 2, 50);
INSERT INTO "soldiers" VALUES (2143, '', 6, '', 93, 4, 17, 10, 5, 81);
INSERT INTO "soldiers" VALUES (2144, '', 6, '', 67, 10, 16, 12, 22, 41);
INSERT INTO "soldiers" VALUES (2145, '', 2, '', 101, 12, 11, 10, 12, 88);
INSERT INTO "soldiers" VALUES (2146, '', 3, '', 58, 31, 15, 25, 30, 39);
INSERT INTO "soldiers" VALUES (2150, '', 1, '', 79, 2, 5, 3, 2, 75);
INSERT INTO "soldiers" VALUES (2152, '', 2, '', 39, NULL, 1, NULL, NULL, 38);
INSERT INTO "soldiers" VALUES (2154, '', 2, '', 76, 1, 8, 9, 1, 76);
INSERT INTO "soldiers" VALUES (2155, '', 2, '', 50, 1, 2, 8, 3, 53);
INSERT INTO "soldiers" VALUES (2156, '', 1, '', 43, NULL, 2, 10, 1, 50);
INSERT INTO "soldiers" VALUES (2157, '', 3, '', 95, 2, 5, 16, 2, 104);
INSERT INTO "soldiers" VALUES (2159, '', 2, '', 94, 4, 4, 5, 4, 91);
INSERT INTO "soldiers" VALUES (2160, '', 2, '', 82, 2, 7, 9, 2, 82);
INSERT INTO "soldiers" VALUES (2161, '', 1, '', 52, NULL, 4, 1, 1, 48);
INSERT INTO "soldiers" VALUES (2162, '', 7, '', 107, 5, 17, 10, 6, 97);
INSERT INTO "soldiers" VALUES (2163, '', 3, '', 90, 1, 12, 7, 1, 85);
INSERT INTO "soldiers" VALUES (2164, '', 1, '', 89, NULL, 13, 8, NULL, 84);
INSERT INTO "soldiers" VALUES (2165, '', 2, '', 55, NULL, 5, 2, NULL, 52);
INSERT INTO "soldiers" VALUES (2166, '', 2, '', 50, 2, 3, 5, 2, 50);
INSERT INTO "soldiers" VALUES (2167, '', 5, '', 50, NULL, 5, 4, 2, 44);
INSERT INTO "soldiers" VALUES (2168, '', 2, '', 27, NULL, 3, NULL, NULL, 24);
INSERT INTO "soldiers" VALUES (2169, '', 3, '', 72, 2, 8, NULL, 2, 62);
INSERT INTO "soldiers" VALUES (2170, '', 2, '', 77, NULL, 6, 24, 16, 80);
INSERT INTO "soldiers" VALUES (2171, '', 1, '', 50, NULL, 6, 1, 3, 42);
INSERT INTO "soldiers" VALUES (2172, '', 3, '', 18, NULL, 2, 1, 8, 69);
INSERT INTO "soldiers" VALUES (2173, '', 4, '', 81, NULL, 15, 7, 4, 69);
INSERT INTO "soldiers" VALUES (2174, '', 2, '', 38, NULL, 7, 1, NULL, 32);
INSERT INTO "soldiers" VALUES (2175, '', 1, '', 41, NULL, 1, NULL, NULL, 40);
INSERT INTO "soldiers" VALUES (2176, '', 2, '', 42, 1, 5, 1, 1, 37);
INSERT INTO "soldiers" VALUES (2177, '', 2, '', 52, NULL, 4, 2, 9, 41);
INSERT INTO "soldiers" VALUES (2178, '', 7, '', 94, 11, 11, 7, 11, 79);
INSERT INTO "soldiers" VALUES (2180, '', 3, '', 65, NULL, 8, 5, 3, 59);
INSERT INTO "soldiers" VALUES (2181, '', 2, '', 57, 2, 6, 7, 2, 56);
INSERT INTO "soldiers" VALUES (2182, '', 2, '', 89, NULL, 12, 12, 2, 87);
INSERT INTO "soldiers" VALUES (2183, '', 3, '', 59, NULL, 8, 3, 2, 52);
INSERT INTO "soldiers" VALUES (2184, '', 2, '', 89, NULL, 7, 8, 3, 87);
INSERT INTO "soldiers" VALUES (2185, '', 4, '', 53, NULL, 10, 7, 2, 48);
INSERT INTO "soldiers" VALUES (2187, '', 4, '', 65, 2, 3, 7, 2, 67);
INSERT INTO "soldiers" VALUES (2188, '', 3, '', 70, NULL, 9, 1, 4, 54);
INSERT INTO "soldiers" VALUES (2189, '', 2, '', 49, 5, 10, 4, 5, 38);
INSERT INTO "soldiers" VALUES (2190, '', 3, '', 75, 1, 4, 3, 1, 72);
INSERT INTO "soldiers" VALUES (2191, '', 2, '', 20, NULL, NULL, NULL, 2, 18);
INSERT INTO "soldiers" VALUES (2193, '', 1, '', 70, NULL, 6, 5, 1, 68);
INSERT INTO "soldiers" VALUES (2194, '', 2, '', 52, 2, 7, 4, 2, 47);
INSERT INTO "soldiers" VALUES (2195, '', 6, '', 93, NULL, 13, 9, 5, 84);
INSERT INTO "soldiers" VALUES (2196, '', 3, '', 54, 7, 6, 2, 7, 43);
INSERT INTO "soldiers" VALUES (2198, '', 1, '', 50, NULL, 2, NULL, NULL, 48);
INSERT INTO "soldiers" VALUES (2200, '', 1, '', 43, 2, 6, 5, 2, 40);
INSERT INTO "soldiers" VALUES (2202, '', 4, '', 44, NULL, 5, NULL, NULL, 39);
INSERT INTO "soldiers" VALUES (2203, '', 2, '', 39, NULL, 6, 1, 2, 32);
INSERT INTO "soldiers" VALUES (2204, '', 2, '', 35, NULL, NULL, NULL, 1, 34);
INSERT INTO "soldiers" VALUES (2205, '', 1, '', 33, 1, 7, 2, 1, 27);
INSERT INTO "soldiers" VALUES (2206, '', 4, '', 41, NULL, 5, 1, NULL, 36);
INSERT INTO "soldiers" VALUES (2207, '', 3, '', 28, NULL, NULL, 1, NULL, 23);
INSERT INTO "soldiers" VALUES (2209, '', 1, '', 47, NULL, 10, 5, NULL, 42);
INSERT INTO "soldiers" VALUES (2210, '', 2, '', 35, 1, 4, NULL, 1, 30);
INSERT INTO "soldiers" VALUES (2211, '', 3, '', 63, NULL, 8, 2, NULL, 57);
INSERT INTO "soldiers" VALUES (2212, '', 2, '', 26, NULL, 1, 1, NULL, 26);
INSERT INTO "soldiers" VALUES (2213, '', 4, '', 62, NULL, 9, 4, 1, 56);
INSERT INTO "soldiers" VALUES (2214, '', 8, '', 45, NULL, 3, 1, 3, 40);
INSERT INTO "soldiers" VALUES (2215, '', 5, '', 48, NULL, 8, 1, NULL, 41);
INSERT INTO "soldiers" VALUES (2216, '', 2, '', 36, NULL, 4, 3, NULL, 35);
INSERT INTO "soldiers" VALUES (2217, '', 1, '', 27, NULL, 7, 2, NULL, 22);
INSERT INTO "soldiers" VALUES (2218, '', 3, '', 49, NULL, 4, 3, NULL, 48);
INSERT INTO "soldiers" VALUES (2219, '', 3, '', 47, NULL, 3, 1, 5, 40);
INSERT INTO "soldiers" VALUES (2220, '', 3, '', 45, NULL, 10, NULL, 1, 34);
INSERT INTO "soldiers" VALUES (2221, '', 1, '', 34, NULL, 9, 2, 2, 25);
INSERT INTO "soldiers" VALUES (2222, '', 2, '', 33, 7, 13, 11, 7, 24);
INSERT INTO "soldiers" VALUES (2223, '', 1, '', 31, NULL, 11, 5, NULL, 25);
INSERT INTO "soldiers" VALUES (2224, '', 1, '', 46, NULL, 10, 5, NULL, 41);
INSERT INTO "soldiers" VALUES (2225, '', 1, '', 54, 1, 18, 10, 1, 45);
INSERT INTO "soldiers" VALUES (2226, '', 3, '', 25, NULL, 3, 1, 1, 22);
INSERT INTO "soldiers" VALUES (2227, '', 1, '', 60, 1, 20, 3, 2, 41);
INSERT INTO "soldiers" VALUES (2228, '', 4, '', 35, NULL, 5, 2, NULL, 32);
INSERT INTO "soldiers" VALUES (2230, '', 2, '', 32, NULL, 10, 2, NULL, 24);
INSERT INTO "soldiers" VALUES (2231, '', 3, '', 34, NULL, 8, 3, 4, 25);
INSERT INTO "soldiers" VALUES (2232, '', 3, '', 30, NULL, 4, 2, NULL, 28);
INSERT INTO "soldiers" VALUES (2234, '', 3, '', 54, NULL, 6, 3, 3, 48);
INSERT INTO "soldiers" VALUES (2235, '', 3, '', 32, 1, 5, 4, 1, 30);
INSERT INTO "soldiers" VALUES (2236, '', 3, '', 30, NULL, 2, 8, NULL, 36);
INSERT INTO "soldiers" VALUES (2237, '', 3, '', 44, NULL, 5, 3, NULL, 42);
INSERT INTO "soldiers" VALUES (2238, '', 3, '', 33, NULL, 4, 2, NULL, 31);
INSERT INTO "soldiers" VALUES (2239, '', 1, '', 34, 1, 1, NULL, 1, 32);
INSERT INTO "soldiers" VALUES (2240, '', 2, '', 49, NULL, 11, 3, NULL, 41);
INSERT INTO "soldiers" VALUES (2241, '', 3, '', 32, 2, 6, 11, 2, 34);
INSERT INTO "soldiers" VALUES (2243, '', 6, '', 48, 5, 6, 6, 6, 42);
INSERT INTO "soldiers" VALUES (2244, '', 7, '', 47, NULL, 7, 5, NULL, 41);
INSERT INTO "soldiers" VALUES (2245, '', 4, '', 44, 9, NULL, NULL, 9, 35);
INSERT INTO "soldiers" VALUES (2246, '', 1, '', 35, NULL, 8, 1, 4, 24);
INSERT INTO "soldiers" VALUES (2247, '', 4, '', 46, NULL, 9, 4, NULL, 41);
INSERT INTO "soldiers" VALUES (2248, '', 3, '', 34, NULL, 7, 1, 3, 23);
INSERT INTO "soldiers" VALUES (2249, '', 3, '', 31, NULL, 5, 1, 2, 25);
INSERT INTO "soldiers" VALUES (2250, '', 5, '', 49, NULL, 7, 6, 8, 40);
INSERT INTO "soldiers" VALUES (2251, '', 5, '', 28, NULL, 7, 4, 3, 22);
INSERT INTO "soldiers" VALUES (2252, '', 1, '', 44, 1, 8, 7, 1, 42);
INSERT INTO "soldiers" VALUES (2253, '', 1, '', 48, 1, 3, 3, 1, 47);
INSERT INTO "soldiers" VALUES (2254, '', 4, '', 53, NULL, 2, 3, 3, 51);
INSERT INTO "soldiers" VALUES (2256, '', 2, '', 49, NULL, 1, 3, NULL, 51);
INSERT INTO "soldiers" VALUES (2257, '', 1, '', 59, NULL, 9, 6, NULL, 56);
INSERT INTO "soldiers" VALUES (2258, '', 5, '', 47, NULL, 3, 3, 2, 45);
INSERT INTO "soldiers" VALUES (2260, '', 3, '', 58, NULL, 4, 4, NULL, 58);
INSERT INTO "soldiers" VALUES (2261, '', 5, '', 45, NULL, 2, 1, NULL, 44);
INSERT INTO "soldiers" VALUES (2262, '', 3, '', 34, NULL, 3, 1, 2, 30);
INSERT INTO "soldiers" VALUES (2263, '', 2, '', 43, NULL, 6, 6, 1, 42);
INSERT INTO "soldiers" VALUES (2264, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "soldiers" VALUES (2265, '', 6, '', 58, NULL, NULL, NULL, 6, 52);
INSERT INTO "soldiers" VALUES (2266, '', 4, '', 67, NULL, 2, 2, NULL, 67);
INSERT INTO "soldiers" VALUES (2267, '', 5, '', 60, NULL, 8, 4, NULL, 56);
INSERT INTO "soldiers" VALUES (2269, '', 2, '', 52, NULL, 3, 2, 3, 48);
INSERT INTO "soldiers" VALUES (2270, '', 7, '', 56, NULL, 7, 5, 2, 52);
INSERT INTO "soldiers" VALUES (2271, '', 7, '', 55, 1, 5, 7, 1, 56);
INSERT INTO "soldiers" VALUES (2272, '', 3, '', 41, NULL, 5, 6, NULL, 42);
INSERT INTO "soldiers" VALUES (2273, '', 3, '', 58, 2, 6, 10, 2, 60);
INSERT INTO "soldiers" VALUES (2274, '', 1, '', 34, NULL, 1, NULL, NULL, 33);
INSERT INTO "soldiers" VALUES (2275, '', 1, '', 48, NULL, 7, 4, 2, 43);
INSERT INTO "soldiers" VALUES (2276, '', 1, '', 27, 1, 4, 3, 1, 35);
INSERT INTO "soldiers" VALUES (2278, '', 4, '', 56, NULL, 5, 3, 6, 48);
INSERT INTO "soldiers" VALUES (2279, '', 4, '', 39, NULL, 11, 3, 3, 29);
INSERT INTO "soldiers" VALUES (2280, '', 3, '', 52, 3, 5, 1, 3, 45);
INSERT INTO "soldiers" VALUES (2281, '', 3, '', 36, 1, 6, NULL, 1, 29);
INSERT INTO "soldiers" VALUES (2283, '', 1, '', 53, 2, 5, 1, 2, 46);
INSERT INTO "soldiers" VALUES (2284, '', 3, '', 48, NULL, 1, 1, NULL, 48);
INSERT INTO "soldiers" VALUES (2286, '', 2, '', 60, NULL, 12, NULL, NULL, 48);
INSERT INTO "soldiers" VALUES (2287, '', 4, '', 57, NULL, 6, 2, NULL, 53);
INSERT INTO "soldiers" VALUES (2288, '', 1, '', 29, NULL, 4, 5, 2, 24);
INSERT INTO "soldiers" VALUES (2289, '', 1, '', 31, NULL, 2, 2, 1, 30);
INSERT INTO "soldiers" VALUES (2290, '', 4, '', 39, NULL, 2, 1, NULL, 38);
INSERT INTO "soldiers" VALUES (2291, '', 5, '', 38, NULL, 2, 1, 4, 33);
INSERT INTO "soldiers" VALUES (2292, '', 1, '', 47, NULL, 5, 1, NULL, 43);
INSERT INTO "soldiers" VALUES (2293, '', 4, '', 36, 2, 2, 3, 2, 35);
INSERT INTO "soldiers" VALUES (2294, '', 2, '', 41, NULL, 3, NULL, NULL, 38);
INSERT INTO "soldiers" VALUES (2296, '', 4, '', 60, NULL, 2, NULL, 2, 56);
INSERT INTO "soldiers" VALUES (2297, '', 2, '', 65, NULL, 4, 1, 2, 60);
INSERT INTO "soldiers" VALUES (2298, '', 4, '', 48, NULL, 1, NULL, 7, 40);
INSERT INTO "soldiers" VALUES (2299, '', 2, '', 62, NULL, 4, 2, 1, 59);
INSERT INTO "soldiers" VALUES (2300, '', 3, '', 52, NULL, 1, 1, 3, 49);
INSERT INTO "soldiers" VALUES (2301, '', 1, '', 41, NULL, 7, 1, 3, 32);
INSERT INTO "soldiers" VALUES (2302, '', 3, '', 58, NULL, 4, 3, 2, 53);
INSERT INTO "soldiers" VALUES (2303, '', 2, '', 42, NULL, 9, 2, 1, 34);
INSERT INTO "soldiers" VALUES (2304, '', 4, '', 54, 2, 4, 6, 2, 54);
INSERT INTO "soldiers" VALUES (2306, '', 1, '', NULL, NULL, NULL, 7, NULL, 7);
INSERT INTO "soldiers" VALUES (2307, '', 1, '', 52, NULL, 4, 5, 14, 39);
INSERT INTO "soldiers" VALUES (2308, '', 4, '', 40, NULL, 3, 4, 3, 38);
INSERT INTO "soldiers" VALUES (2309, '', 4, '', 38, 4, 7, 4, 4, 31);
INSERT INTO "soldiers" VALUES (2310, '', 1, '', 132, NULL, 21, 4, 7, 108);
INSERT INTO "soldiers" VALUES (2311, '', 1, '', 37, 2, 3, 6, 2, 38);
INSERT INTO "soldiers" VALUES (2312, '', 1, '', 62, NULL, 7, 5, 6, 60);
INSERT INTO "soldiers" VALUES (2313, '', 4, '', 106, NULL, 4, 3, 2, 103);
INSERT INTO "soldiers" VALUES (2314, '', 4, '', 100, 12, 7, 1, 12, 82);
INSERT INTO "soldiers" VALUES (2315, '', 2, '', 33, NULL, 4, 1, 3, 27);
INSERT INTO "soldiers" VALUES (2316, '', 3, '', 100, 3, 36, 30, 3, 91);
INSERT INTO "soldiers" VALUES (2317, '', 3, '', 64, 1, 8, 3, 1, 58);
INSERT INTO "soldiers" VALUES (2318, '', 1, '', 103, NULL, 7, 12, 6, 99);
INSERT INTO "soldiers" VALUES (2320, '', 1, '', 59, NULL, 2, 9, 2, 64);
INSERT INTO "soldiers" VALUES (2321, '', 2, '', 80, NULL, 3, NULL, 5, 72);
INSERT INTO "soldiers" VALUES (2322, '', 1, '', 61, NULL, 7, NULL, 2, 52);
INSERT INTO "soldiers" VALUES (2323, '', 2, '', 82, NULL, 15, 3, 6, 64);
INSERT INTO "soldiers" VALUES (2324, '', 4, '', 104, NULL, 13, 5, 1, 93);
INSERT INTO "soldiers" VALUES (2325, '', 1, '', 131, NULL, 7, 2, 11, 115);
INSERT INTO "soldiers" VALUES (2326, '', 2, '', 66, NULL, 8, 1, 3, 56);
INSERT INTO "soldiers" VALUES (2327, '', 2, '', 62, NULL, 3, 3, NULL, 62);
INSERT INTO "soldiers" VALUES (2328, '', 2, '', 53, NULL, 4, 10, 11, 48);
INSERT INTO "soldiers" VALUES (2329, '', 7, '', 82, NULL, 5, NULL, 8, 69);
INSERT INTO "soldiers" VALUES (2330, '', 6, '', 45, NULL, 5, 2, NULL, 42);
INSERT INTO "soldiers" VALUES (2331, '', 2, '', 100, NULL, 5, 1, 2, 94);
INSERT INTO "soldiers" VALUES (2333, '', 4, '', 60, NULL, 3, 5, NULL, 62);
INSERT INTO "soldiers" VALUES (2334, '', 2, '', 52, 3, 11, 10, 3, 48);
INSERT INTO "soldiers" VALUES (2335, '', 8, '', 102, NULL, 13, 4, 7, 86);
INSERT INTO "soldiers" VALUES (2336, '', 4, '', 117, NULL, 3, NULL, 2, 112);
INSERT INTO "soldiers" VALUES (2337, '', 1, '', 89, NULL, 9, 1, 2, 79);
INSERT INTO "soldiers" VALUES (2338, '', 3, '', 91, NULL, NULL, NULL, 4, 87);
INSERT INTO "soldiers" VALUES (2339, '', 5, '', 71, NULL, 2, 5, NULL, 74);
INSERT INTO "soldiers" VALUES (2340, '', 3, '', 101, 1, 13, 1, 1, 88);
INSERT INTO "soldiers" VALUES (2341, '', 1, '', 74, NULL, 8, 11, 2, 75);
INSERT INTO "soldiers" VALUES (2342, '', 2, '', 57, NULL, 18, 6, 24, 85);
INSERT INTO "soldiers" VALUES (2343, '', 4, '', 59, NULL, 6, 8, 1, 60);
INSERT INTO "soldiers" VALUES (2344, '', 1, '', 61, NULL, 7, 8, 14, 48);
INSERT INTO "soldiers" VALUES (2345, '', 1, '', 56, NULL, 2, 2, 2, 54);
INSERT INTO "soldiers" VALUES (2346, '', 1, '', 56, 2, 5, NULL, 2, 48);
INSERT INTO "soldiers" VALUES (2347, '', 2, '', 68, NULL, 1, 1, 1, 67);
INSERT INTO "soldiers" VALUES (2348, '', 2, '', 42, 1, 2, NULL, 1, 39);
INSERT INTO "soldiers" VALUES (2350, '', 1, '', 66, 3, 2, 3, 3, 64);
INSERT INTO "soldiers" VALUES (2351, '', 5, '', 82, 1, 8, 1, 1, 74);
INSERT INTO "soldiers" VALUES (2352, '', 2, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "soldiers" VALUES (2353, '', 5, '', 121, NULL, 18, 6, 24, 85);
INSERT INTO "soldiers" VALUES (2354, '', 1, '', 56, 1, 3, 3, 1, 55);
INSERT INTO "soldiers" VALUES (2355, '', 1, '', 120, NULL, 5, 2, 2, 105);
INSERT INTO "soldiers" VALUES (2356, '', 6, '', 52, 3, 7, 2, 3, 44);
INSERT INTO "soldiers" VALUES (2357, '', 2, '', 62, NULL, 10, 3, 3, 52);
INSERT INTO "soldiers" VALUES (2358, '', 2, '', 92, 4, 3, 3, 4, 88);
INSERT INTO "soldiers" VALUES (2359, '', 2, '', 91, 1, 6, 3, 1, 87);
INSERT INTO "soldiers" VALUES (2360, '', 2, '', 71, NULL, 8, NULL, 18, 45);
INSERT INTO "soldiers" VALUES (2361, '', 1, '', 130, NULL, 20, 5, 20, 95);
INSERT INTO "soldiers" VALUES (2362, '', 2, '', 80, NULL, 13, NULL, 11, 57);
INSERT INTO "soldiers" VALUES (2363, '', 3, '', 118, NULL, 14, 2, 14, 92);
INSERT INTO "soldiers" VALUES (2365, '', 6, '', 100, NULL, 10, 6, 25, 60);
INSERT INTO "soldiers" VALUES (2366, '', 2, '', 47, 5, NULL, NULL, 5, 42);
INSERT INTO "soldiers" VALUES (2367, '', 2, '', 88, NULL, 14, 7, 72, 9);
INSERT INTO "soldiers" VALUES (2368, '', 4, '', 100, 41, NULL, 20, 41, 54);
INSERT INTO "soldiers" VALUES (2369, '', 2, '', 100, NULL, 9, 6, 4, 94);
INSERT INTO "soldiers" VALUES (2370, '', 3, '', 119, 5, 10, 1, 5, 105);
INSERT INTO "soldiers" VALUES (2371, '', 3, '', 74, NULL, 7, NULL, 1, 65);
INSERT INTO "soldiers" VALUES (2373, '', 4, '', 99, NULL, 6, NULL, 12, 81);
INSERT INTO "soldiers" VALUES (2375, '', 5, '', 111, NULL, 14, NULL, 7, 89);
INSERT INTO "soldiers" VALUES (2376, '', 1, '', 64, NULL, 6, NULL, 5, 53);
INSERT INTO "soldiers" VALUES (2377, '', 4, '', 128, NULL, 13, 2, 70, 72);
INSERT INTO "soldiers" VALUES (2378, '', 3, '', 65, NULL, 19, 5, 16, 35);
INSERT INTO "soldiers" VALUES (2379, '', 1, '', 90, NULL, 12, NULL, 26, 52);
INSERT INTO "soldiers" VALUES (2381, '', 1, '', 76, NULL, 12, 9, 10, 63);
INSERT INTO "soldiers" VALUES (2383, '', 1, '', 58, NULL, 3, 9, 5, 59);
INSERT INTO "soldiers" VALUES (2384, '', 5, '', 75, NULL, 3, 1, 17, 56);
INSERT INTO "soldiers" VALUES (2385, '', 1, '', 102, NULL, 8, 3, 3, 94);
INSERT INTO "soldiers" VALUES (2386, '', 1, '', 55, NULL, 22, 15, 13, 35);
INSERT INTO "soldiers" VALUES (2387, '', 5, '', 121, NULL, 27, 7, 37, 64);
INSERT INTO "soldiers" VALUES (2389, '', 1, '', 113, NULL, 24, 12, 26, 75);
INSERT INTO "soldiers" VALUES (2390, '', 1, '', 68, NULL, 7, 4, 4, 61);
INSERT INTO "soldiers" VALUES (2391, '', 4, '', 51, NULL, 6, 1, NULL, 46);
INSERT INTO "soldiers" VALUES (2392, '', 1, '', 105, NULL, 8, 1, 6, 92);
INSERT INTO "soldiers" VALUES (2393, '', 5, '', 105, NULL, 18, 13, 3, 97);
INSERT INTO "soldiers" VALUES (2394, '', 2, '', 121, NULL, 12, 2, 5, 106);
INSERT INTO "soldiers" VALUES (2395, '', 1, '', 69, NULL, 2, 1, NULL, 67);
INSERT INTO "soldiers" VALUES (2396, '', 1, '', 79, NULL, 10, NULL, 4, 65);
INSERT INTO "soldiers" VALUES (2397, '', 1, '', 107, NULL, 44, 8, 19, 49);
INSERT INTO "soldiers" VALUES (2398, '', 4, '', 68, NULL, 10, 4, 4, 58);
INSERT INTO "soldiers" VALUES (2399, '', 3, '', 66, NULL, 6, NULL, 3, 57);
INSERT INTO "soldiers" VALUES (2400, '', 6, '', 98, NULL, 10, 1, 3, 86);
INSERT INTO "soldiers" VALUES (2401, '', 2, '', 100, NULL, 19, 2, 6, 77);
INSERT INTO "soldiers" VALUES (2402, '', 2, '', 65, NULL, 4, 2, 6, 57);
INSERT INTO "soldiers" VALUES (2404, '', 5, '', 103, NULL, 17, 3, 9, 80);
INSERT INTO "soldiers" VALUES (2405, '', 3, '', 71, NULL, 6, NULL, 8, 52);
INSERT INTO "soldiers" VALUES (2406, '', 3, '', 69, NULL, 6, 7, 5, 65);
INSERT INTO "soldiers" VALUES (2407, '', 4, '', 74, NULL, 18, 6, 9, 53);
INSERT INTO "soldiers" VALUES (2408, '', 2, '', 121, NULL, 21, 4, 11, 93);
INSERT INTO "soldiers" VALUES (2410, '', 3, '', 122, NULL, 17, 17, 12, 110);
INSERT INTO "soldiers" VALUES (2412, '', 5, '', 56, NULL, 10, NULL, 12, 34);
INSERT INTO "soldiers" VALUES (2415, '', 4, '', 71, NULL, 15, NULL, 6, 50);
INSERT INTO "soldiers" VALUES (2416, '', 1, '', 59, NULL, 13, NULL, 6, 38);
INSERT INTO "soldiers" VALUES (2417, '', 5, '', 127, NULL, 51, 16, 25, 67);
INSERT INTO "soldiers" VALUES (2418, '', 4, '', 101, NULL, 29, 8, 18, 62);
INSERT INTO "soldiers" VALUES (2419, '', 1, '', 71, NULL, 21, 3, 8, 45);
INSERT INTO "soldiers" VALUES (2420, '', 3, '', 109, NULL, 23, 5, 4, 87);
INSERT INTO "soldiers" VALUES (2421, '', 3, '', 106, NULL, 9, 3, 12, 87);
INSERT INTO "soldiers" VALUES (2422, '', 1, '', 100, NULL, 14, 2, 26, 62);
INSERT INTO "soldiers" VALUES (2423, '', 4, '', 61, NULL, 19, 13, 21, 34);
INSERT INTO "soldiers" VALUES (2424, '', 4, '', 71, NULL, 32, 1, 8, 32);
INSERT INTO "soldiers" VALUES (2426, '', 6, '', 101, NULL, 39, 14, 19, 57);
INSERT INTO "soldiers" VALUES (2427, '', 4, '', 101, NULL, 18, 6, 27, 62);
INSERT INTO "soldiers" VALUES (2428, '', 4, '', 116, NULL, 40, 5, 11, 70);
INSERT INTO "soldiers" VALUES (2429, '', 1, '', 149, NULL, 68, 58, 66, 73);
INSERT INTO "soldiers" VALUES (2431, '', 5, '', 58, NULL, 18, 7, 6, 41);
INSERT INTO "soldiers" VALUES (2432, '', 3, '', 95, NULL, 22, 29, 12, 90);
INSERT INTO "soldiers" VALUES (2433, '', 2, '', 53, NULL, 7, 3, 5, 42);
INSERT INTO "soldiers" VALUES (2434, '', 2, '', 79, NULL, 9, 1, 14, 57);
INSERT INTO "soldiers" VALUES (2435, '', 1, '', 99, NULL, 9, 3, 13, 80);
INSERT INTO "soldiers" VALUES (2436, '', 2, '', 71, 2, 5, NULL, 2, 64);
INSERT INTO "soldiers" VALUES (2437, '', 4, '', 124, NULL, 15, 35, 47, 80);
INSERT INTO "soldiers" VALUES (2438, '', 1, '', 73, NULL, 2, NULL, 1, 70);
INSERT INTO "soldiers" VALUES (2439, '', 1, '', 101, NULL, 12, 2, 22, 69);
INSERT INTO "soldiers" VALUES (2440, '', 5, '', 97, NULL, 8, 1, 11, 79);
INSERT INTO "soldiers" VALUES (2441, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (2443, '', 2, '', 131, NULL, 22, 13, 9, 112);
INSERT INTO "soldiers" VALUES (2444, '', 2, '', 101, NULL, 25, 4, 16, 64);
INSERT INTO "soldiers" VALUES (2445, '', 2, '', 93, NULL, 6, 15, 20, 82);
INSERT INTO "soldiers" VALUES (2446, '', 6, '', 102, NULL, 12, 2, 16, 76);
INSERT INTO "soldiers" VALUES (2447, '', 3, '', 79, NULL, 9, NULL, 8, 62);
INSERT INTO "soldiers" VALUES (2449, '', 6, '', 100, NULL, 8, NULL, 17, 75);
INSERT INTO "soldiers" VALUES (2450, '', 2, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (2451, '', 4, '', 123, NULL, 19, 9, 26, 87);
INSERT INTO "soldiers" VALUES (2452, '', 5, '', 92, NULL, 12, 6, 6, 82);
INSERT INTO "soldiers" VALUES (2453, '', 5, '', 72, 3, 3, 2, 3, 68);
INSERT INTO "soldiers" VALUES (2454, '', 1, '', 76, NULL, 13, NULL, 29, 34);
INSERT INTO "soldiers" VALUES (2456, '', 3, '', 74, NULL, 12, 5, 15, 50);
INSERT INTO "soldiers" VALUES (2457, '', 1, '', 69, NULL, 13, 21, 16, 61);
INSERT INTO "soldiers" VALUES (2458, '', 2, '', 67, NULL, 7, 11, 5, 66);
INSERT INTO "soldiers" VALUES (2459, '', 2, '', 115, NULL, 3, 1, 6, 107);
INSERT INTO "soldiers" VALUES (2460, '', 7, '', 70, NULL, 5, 6, 22, 49);
INSERT INTO "soldiers" VALUES (2461, '', 1, '', 100, NULL, 30, 2, 14, 58);
INSERT INTO "soldiers" VALUES (2463, '', 5, '', 73, NULL, 23, 15, 12, 52);
INSERT INTO "soldiers" VALUES (2465, '', 1, '', 105, NULL, 18, 1, 9, 79);
INSERT INTO "soldiers" VALUES (2466, '', 1, '', 108, NULL, 10, 5, 5, 98);
INSERT INTO "soldiers" VALUES (2470, '', 2, '', 45, NULL, 5, 6, 1, 45);
INSERT INTO "soldiers" VALUES (2471, '', 5, '', 95, NULL, 16, 6, 12, 73);
INSERT INTO "soldiers" VALUES (2473, '', 4, '', 55, NULL, NULL, NULL, NULL, 53);
INSERT INTO "soldiers" VALUES (2474, '', 2, '', 99, NULL, 7, NULL, 3, 89);
INSERT INTO "soldiers" VALUES (2478, '', 2, '', 61, NULL, 8, 5, 24, 34);
INSERT INTO "soldiers" VALUES (2480, '', 7, '', 112, NULL, 13, 3, 10, 91);
INSERT INTO "soldiers" VALUES (2481, '', 1, '', 86, 3, 19, 7, 3, 71);
INSERT INTO "soldiers" VALUES (2482, '', 3, '', 109, NULL, 13, NULL, 21, 75);
INSERT INTO "soldiers" VALUES (2486, '', 2, '', 63, NULL, 3, 2, 3, 59);
INSERT INTO "soldiers" VALUES (2491, '', 3, '', 107, NULL, 10, 6, 6, 97);
INSERT INTO "soldiers" VALUES (2493, '', 2, '', 80, NULL, 8, 37, 15, 84);
INSERT INTO "soldiers" VALUES (2496, '', 1, '', 58, NULL, 5, 12, 1, 59);
INSERT INTO "soldiers" VALUES (2497, '', 5, '', 114, NULL, 22, 2, 19, 74);
INSERT INTO "soldiers" VALUES (2498, '', 4, '', 94, NULL, 14, 3, 43, 39);
INSERT INTO "soldiers" VALUES (2499, '', 1, '', 98, NULL, 21, 13, 19, 71);
INSERT INTO "soldiers" VALUES (2500, '', 1, '', 95, NULL, 15, 11, 32, 59);
INSERT INTO "soldiers" VALUES (2501, '', 2, '', 46, NULL, 16, 9, 1, 38);
INSERT INTO "soldiers" VALUES (2502, '', 1, '', 158, NULL, 17, 6, 8, 99);
INSERT INTO "soldiers" VALUES (2503, '', 1, '', 90, NULL, 32, 20, 15, 63);
INSERT INTO "soldiers" VALUES (2504, '', 4, '', 62, NULL, 11, 10, 19, 42);
INSERT INTO "soldiers" VALUES (2505, '', 3, '', 70, NULL, 8, 8, 11, 59);
INSERT INTO "soldiers" VALUES (2506, '', 3, '', 62, NULL, 14, 6, 16, 38);
INSERT INTO "soldiers" VALUES (2507, '', 1, '', 63, NULL, 15, 5, 9, 44);
INSERT INTO "soldiers" VALUES (2508, '', 1, '', 58, NULL, 2, 3, 5, 54);
INSERT INTO "soldiers" VALUES (2509, '', 4, '', 57, NULL, 11, 7, 7, 46);
INSERT INTO "soldiers" VALUES (2510, '', 4, '', 55, NULL, 4, 6, 1, 56);
INSERT INTO "soldiers" VALUES (2511, '', 6, '', 110, NULL, 10, 14, 6, 108);
INSERT INTO "soldiers" VALUES (2512, '', 2, '', 44, NULL, 2, 1, 1, 42);
INSERT INTO "soldiers" VALUES (2513, '', 3, '', 93, NULL, 16, 12, 27, 62);
INSERT INTO "soldiers" VALUES (2514, '', 2, '', 46, 1, 3, NULL, 1, 42);
INSERT INTO "soldiers" VALUES (2515, '', 7, '', 81, 1, 2, 3, 5, 76);
INSERT INTO "soldiers" VALUES (2516, '', 3, '', 92, 10, 3, 1, 10, 80);
INSERT INTO "soldiers" VALUES (2517, '', 2, '', 89, NULL, 3, NULL, NULL, 86);
INSERT INTO "soldiers" VALUES (2518, '', 1, '', 124, 3, 2, NULL, 3, 119);
INSERT INTO "soldiers" VALUES (2519, '', 2, '', 57, NULL, 3, NULL, NULL, 53);
INSERT INTO "soldiers" VALUES (2521, '', 6, '', 58, NULL, 2, NULL, 3, 53);
INSERT INTO "soldiers" VALUES (2522, '', 4, '', 21, NULL, 1, 8, NULL, 7);
INSERT INTO "soldiers" VALUES (2523, '', 1, '', 76, 3, 3, NULL, 3, 70);
INSERT INTO "soldiers" VALUES (2524, '', 3, '', 63, NULL, 1, NULL, 1, 61);
INSERT INTO "soldiers" VALUES (2525, '', 1, '', 57, NULL, 2, NULL, 1, 54);
INSERT INTO "soldiers" VALUES (2526, '', 5, '', 123, NULL, 6, NULL, 6, 111);
INSERT INTO "soldiers" VALUES (2528, '', 1, '', 21, NULL, NULL, NULL, NULL, 21);
INSERT INTO "soldiers" VALUES (2529, '', 2, '', 65, 3, 4, 3, 4, 60);
INSERT INTO "soldiers" VALUES (2530, '', 4, '', 64, NULL, 3, 3, 2, 62);
INSERT INTO "soldiers" VALUES (2531, '', 6, '', 91, NULL, 9, 7, 8, 81);
INSERT INTO "soldiers" VALUES (2532, '', 1, '', 106, NULL, 4, 4, 3, 102);
INSERT INTO "soldiers" VALUES (2533, '', 7, '', 90, NULL, 4, 5, 2, 89);
INSERT INTO "soldiers" VALUES (2535, '', 2, '', 57, NULL, 2, 2, 4, 53);
INSERT INTO "soldiers" VALUES (2536, '', 1, '', 92, 2, 1, 1, 3, 89);
INSERT INTO "soldiers" VALUES (2537, '', 1, '', 98, NULL, 3, 2, NULL, 97);
INSERT INTO "soldiers" VALUES (2538, '', 3, '', 57, NULL, 7, 3, NULL, 51);
INSERT INTO "soldiers" VALUES (2539, '', 3, '', 57, NULL, 4, 6, 2, 55);
INSERT INTO "soldiers" VALUES (2540, '', 4, '', 65, NULL, 3, 2, 16, 47);
INSERT INTO "soldiers" VALUES (2541, '', 1, '', 60, NULL, 11, 3, 3, 49);
INSERT INTO "soldiers" VALUES (2542, '', 4, '', 60, NULL, 3, 2, NULL, 59);
INSERT INTO "soldiers" VALUES (2544, '', 2, '', 53, NULL, 3, 1, 1, 50);
INSERT INTO "soldiers" VALUES (2546, '', 3, '', 47, NULL, 3, NULL, 1, 43);
INSERT INTO "soldiers" VALUES (2548, '', 1, '', 25, NULL, 1, 1, NULL, 25);
INSERT INTO "soldiers" VALUES (2549, '', 6, '', 57, NULL, 11, 7, 7, 44);
INSERT INTO "soldiers" VALUES (2550, '', 1, '', 90, NULL, 6, 2, 1, 86);
INSERT INTO "soldiers" VALUES (2559, '', 6, '', 75, NULL, 8, 6, 1, 71);
INSERT INTO "soldiers" VALUES (2560, '', 3, '', 81, 5, 19, NULL, 5, 57);
INSERT INTO "soldiers" VALUES (2561, '', 2, '', 90, NULL, 22, 13, 7, 74);
INSERT INTO "soldiers" VALUES (2562, '', 4, '', 98, NULL, 19, 10, 16, 73);
INSERT INTO "soldiers" VALUES (2565, '', 3, '', 104, NULL, 13, NULL, 5, 86);
INSERT INTO "soldiers" VALUES (2567, '', 1, '', 96, NULL, 7, 2, 3, 88);
INSERT INTO "soldiers" VALUES (2568, '', 2, '', 89, NULL, 24, 33, 27, 71);
INSERT INTO "soldiers" VALUES (2570, '', 4, '', 47, 1, 3, NULL, 1, 43);
INSERT INTO "soldiers" VALUES (2571, '', 3, '', 95, 2, 7, 1, 2, 87);
INSERT INTO "soldiers" VALUES (2572, '', 4, '', 91, NULL, 7, 2, 3, 83);
INSERT INTO "soldiers" VALUES (2573, '', 1, '', 52, NULL, 7, NULL, 1, 44);
INSERT INTO "soldiers" VALUES (2576, '', 1, '', 92, NULL, 9, 1, 2, 82);
INSERT INTO "soldiers" VALUES (2577, '', 6, '', 71, NULL, 5, 1, 1, 66);
INSERT INTO "soldiers" VALUES (2578, '', 3, '', 60, NULL, 12, NULL, 3, 55);
INSERT INTO "soldiers" VALUES (2579, '', 3, '', 52, 9, 2, NULL, 9, 41);
INSERT INTO "soldiers" VALUES (2580, '', 2, '', 51, NULL, 8, 9, 6, 46);
INSERT INTO "soldiers" VALUES (2581, '', 1, '', 80, NULL, 18, NULL, 2, 55);
INSERT INTO "soldiers" VALUES (2582, '', 4, '', 78, NULL, 19, 15, 10, 64);
INSERT INTO "soldiers" VALUES (2583, '', 5, '', 52, NULL, 2, 7, 6, 51);
INSERT INTO "soldiers" VALUES (2585, '', 2, '', 50, NULL, 4, NULL, 1, 46);
INSERT INTO "soldiers" VALUES (2586, '', 5, '', 109, NULL, 11, 13, 10, 101);
INSERT INTO "soldiers" VALUES (2587, '', 1, '', 63, NULL, 20, 18, 7, 54);
INSERT INTO "soldiers" VALUES (2588, '', 4, '', 91, NULL, 24, 1, 9, 59);
INSERT INTO "soldiers" VALUES (2589, '', 1, '', 88, NULL, 17, 1, 6, 66);
INSERT INTO "soldiers" VALUES (2590, '', 1, '', 74, NULL, 19, 8, 4, 59);
INSERT INTO "soldiers" VALUES (2591, '', 1, '', 52, NULL, 7, 1, 2, 43);
INSERT INTO "soldiers" VALUES (2592, '', 2, '', 104, NULL, 13, 4, 1, 94);
INSERT INTO "soldiers" VALUES (2593, '', 3, '', 49, 1, 5, 4, 1, 47);
INSERT INTO "soldiers" VALUES (2594, '', 3, '', 50, NULL, 7, 3, 5, 41);
INSERT INTO "soldiers" VALUES (2595, '', 7, '', 59, NULL, 10, NULL, 3, 49);
INSERT INTO "soldiers" VALUES (2596, '', 2, '', 80, NULL, 11, 5, NULL, 74);
INSERT INTO "soldiers" VALUES (2598, '', 4, '', 33, NULL, 8, 8, 7, 26);
INSERT INTO "soldiers" VALUES (2599, '', 4, '', 53, NULL, 20, 10, 15, 28);
INSERT INTO "soldiers" VALUES (2601, '', 5, '', 38, NULL, 4, 1, 1, 34);
INSERT INTO "soldiers" VALUES (2602, '', 4, '', 61, NULL, 14, NULL, NULL, 47);
INSERT INTO "soldiers" VALUES (2603, '', 3, '', 45, 10, 4, NULL, 10, 29);
INSERT INTO "soldiers" VALUES (2604, '', 5, '', 81, NULL, 3, NULL, NULL, 76);
INSERT INTO "soldiers" VALUES (2610, '', 1, '', 87, NULL, 5, NULL, 5, 76);
INSERT INTO "soldiers" VALUES (2611, '', 5, '', 73, 4, 5, NULL, 4, 63);
INSERT INTO "soldiers" VALUES (2613, '', 1, '', 66, 2, 8, 1, 2, 57);
INSERT INTO "soldiers" VALUES (2614, '', 2, '', 86, NULL, 4, 1, 5, 78);
INSERT INTO "soldiers" VALUES (2615, '', 2, '', 49, NULL, 3, 10, 5, 51);
INSERT INTO "soldiers" VALUES (2616, '', 4, '', 67, NULL, 3, 2, 6, 60);
INSERT INTO "soldiers" VALUES (2617, '', 2, '', 70, NULL, 7, NULL, NULL, 63);
INSERT INTO "soldiers" VALUES (2618, '', 4, '', 63, 2, 3, NULL, 2, 58);
INSERT INTO "soldiers" VALUES (2625, '', 3, '', 65, NULL, 3, 25, 48, 39);
INSERT INTO "soldiers" VALUES (2626, '', 1, '', 42, 6, 13, 4, 6, 27);
INSERT INTO "soldiers" VALUES (2627, '', 1, '', 81, NULL, 9, 3, 35, 36);
INSERT INTO "soldiers" VALUES (2628, '', 2, '', 49, 14, 2, 2, 14, 35);
INSERT INTO "soldiers" VALUES (2631, '', 2, '', 58, NULL, 8, NULL, 1, 48);
INSERT INTO "soldiers" VALUES (2632, '', 4, '', 66, NULL, 19, NULL, NULL, 47);
INSERT INTO "soldiers" VALUES (2633, '', 2, '', 43, 2, 5, NULL, 2, 36);
INSERT INTO "soldiers" VALUES (2634, '', 1, '', 39, 2, 2, NULL, 2, 35);
INSERT INTO "soldiers" VALUES (2635, '', 6, '', 89, NULL, 17, NULL, 1, 71);
INSERT INTO "soldiers" VALUES (2636, '', 2, '', 70, 1, 10, NULL, 1, 59);
INSERT INTO "soldiers" VALUES (2637, '', 1, '', 44, NULL, 6, NULL, 1, 37);
INSERT INTO "soldiers" VALUES (2638, '', 4, '', 70, 2, 7, NULL, 2, 61);
INSERT INTO "soldiers" VALUES (2639, '', 4, '', 45, NULL, 2, NULL, 2, 39);
INSERT INTO "soldiers" VALUES (2640, '', 3, '', 38, NULL, 6, NULL, 1, 31);
INSERT INTO "soldiers" VALUES (2641, '', 5, '', 42, 1, 4, NULL, 1, 37);
INSERT INTO "soldiers" VALUES (2642, '', 3, '', 44, NULL, 7, 4, 4, 37);
INSERT INTO "soldiers" VALUES (2643, '', 2, '', 42, 1, 3, 1, 1, 39);
INSERT INTO "soldiers" VALUES (2644, '', 2, '', 96, 2, 7, NULL, 2, 87);
INSERT INTO "soldiers" VALUES (2646, '', 2, '', 32, NULL, 1, 3, 2, 29);
INSERT INTO "soldiers" VALUES (2648, '', 1, '', 79, NULL, 5, NULL, 1, 73);
INSERT INTO "soldiers" VALUES (2649, '', 4, '', 93, NULL, 2, NULL, 1, 90);
INSERT INTO "soldiers" VALUES (2650, '', 4, '', 41, NULL, 2, 1, 1, 39);
INSERT INTO "soldiers" VALUES (2651, '', 3, '', 102, NULL, 12, NULL, 3, 88);
INSERT INTO "soldiers" VALUES (2652, '', 3, '', 86, NULL, 2, NULL, 1, 83);
INSERT INTO "soldiers" VALUES (2653, '', 5, '', 68, NULL, 4, 3, NULL, 67);
INSERT INTO "soldiers" VALUES (2654, '', 3, '', 49, 1, 3, 1, 1, 46);
INSERT INTO "soldiers" VALUES (2655, '', 2, '', 68, NULL, 3, 1, NULL, 66);
INSERT INTO "soldiers" VALUES (2656, '', 2, '', 74, 1, NULL, NULL, 1, 73);
INSERT INTO "soldiers" VALUES (2657, '', 3, '', 68, NULL, 9, 5, NULL, 64);
INSERT INTO "soldiers" VALUES (2658, '', 2, '', 43, NULL, 5, 3, 2, 39);
INSERT INTO "soldiers" VALUES (2659, '', 3, '', 67, 3, 10, 4, 3, 58);
INSERT INTO "soldiers" VALUES (2660, '', 5, '', 42, NULL, 7, 1, 1, 35);
INSERT INTO "soldiers" VALUES (2661, '', 7, '', 98, NULL, 22, 3, 8, 71);
INSERT INTO "soldiers" VALUES (2662, '', 3, '', 75, NULL, 10, 4, 7, 61);
INSERT INTO "soldiers" VALUES (2663, '', 4, '', 70, 1, 7, 4, 1, 65);
INSERT INTO "soldiers" VALUES (2664, '', 1, '', 44, 1, 6, 6, 1, 43);
INSERT INTO "soldiers" VALUES (2666, '', 2, '', 63, NULL, 8, NULL, 1, 54);
INSERT INTO "soldiers" VALUES (2667, '', 5, '', 43, NULL, 8, 1, 2, 34);
INSERT INTO "soldiers" VALUES (2668, '', 3, '', 58, 3, 20, NULL, 3, 35);
INSERT INTO "soldiers" VALUES (2669, '', 4, '', 84, NULL, 24, 1, 5, 56);
INSERT INTO "soldiers" VALUES (2670, '', 5, '', 66, 5, 2, 4, 5, 63);
INSERT INTO "soldiers" VALUES (2671, '', 2, '', 64, NULL, 7, NULL, 5, 52);
INSERT INTO "soldiers" VALUES (2672, '', 4, '', 69, NULL, 11, NULL, 4, 54);
INSERT INTO "soldiers" VALUES (2673, '', 3, '', 42, NULL, 9, NULL, 6, 26);
INSERT INTO "soldiers" VALUES (2674, '', 2, '', 66, NULL, 14, NULL, 2, 50);
INSERT INTO "soldiers" VALUES (2675, '', 2, '', 65, 4, 13, NULL, 4, 47);
INSERT INTO "soldiers" VALUES (2676, '', 5, '', 58, NULL, 13, 1, 8, 38);
INSERT INTO "soldiers" VALUES (2677, '', 2, '', 47, NULL, 10, 6, 4, 39);
INSERT INTO "soldiers" VALUES (2678, '', 1, '', 41, 1, 2, NULL, 1, 33);
INSERT INTO "soldiers" VALUES (2679, '', 5, '', 84, NULL, 19, NULL, 4, 60);
INSERT INTO "soldiers" VALUES (2681, '', 3, '', 37, 2, 5, NULL, 2, 30);
INSERT INTO "soldiers" VALUES (2682, '', 3, '', 65, NULL, 6, NULL, NULL, 59);
INSERT INTO "soldiers" VALUES (2684, '', 1, '', 66, NULL, 7, NULL, 20, 39);
INSERT INTO "soldiers" VALUES (2685, '', 3, '', 94, NULL, 18, 1, 12, 65);
INSERT INTO "soldiers" VALUES (2687, '', 2, '', 42, NULL, 2, 1, NULL, 41);
INSERT INTO "soldiers" VALUES (2688, '', 8, '', 99, NULL, 18, 1, 5, 77);
INSERT INTO "soldiers" VALUES (2689, '', 7, '', 63, 1, 10, NULL, 1, 52);
INSERT INTO "soldiers" VALUES (2690, '', 3, '', 99, NULL, 7, 12, 16, 88);
INSERT INTO "soldiers" VALUES (2691, '', 1, '', 46, NULL, 7, NULL, NULL, 39);
INSERT INTO "soldiers" VALUES (2692, '', 4, '', 43, NULL, 4, 2, NULL, 41);
INSERT INTO "soldiers" VALUES (2693, '', 3, '', 96, NULL, 6, 1, 4, 84);
INSERT INTO "soldiers" VALUES (2694, '', 1, '', 39, 2, 3, 2, 2, 36);
INSERT INTO "soldiers" VALUES (2698, '', 2, '', 74, NULL, 12, NULL, 14, 48);
INSERT INTO "soldiers" VALUES (2699, '', 3, '', 42, NULL, 16, NULL, 6, 36);
INSERT INTO "soldiers" VALUES (2700, '', 5, '', 75, NULL, 4, 5, 10, 64);
INSERT INTO "soldiers" VALUES (2701, '', 6, '', 95, NULL, 5, NULL, 6, 83);
INSERT INTO "soldiers" VALUES (2702, '', 6, '', 61, NULL, 10, 4, 4, 51);
INSERT INTO "soldiers" VALUES (2703, '', 7, '', 50, NULL, 16, 11, 6, 39);
INSERT INTO "soldiers" VALUES (2704, '', 4, '', 34, NULL, 5, 1, 2, 28);
INSERT INTO "soldiers" VALUES (2705, '', 6, '', 37, 2, 5, NULL, 2, 28);
INSERT INTO "soldiers" VALUES (2706, '', 3, '', 39, NULL, 5, NULL, 3, 31);
INSERT INTO "soldiers" VALUES (2707, '', 1, '', 65, NULL, 15, 8, 34, 24);
INSERT INTO "soldiers" VALUES (2708, '', 2, '', 65, 5, 7, NULL, 5, 53);
INSERT INTO "soldiers" VALUES (2710, '', 3, '', 28, NULL, 6, 4, 8, 18);
INSERT INTO "soldiers" VALUES (2711, '', 2, '', 41, 6, 12, 6, 6, 29);
INSERT INTO "soldiers" VALUES (2712, '', 2, '', 43, NULL, 6, NULL, 3, 32);
INSERT INTO "soldiers" VALUES (2713, '', 7, '', 82, 7, 15, NULL, 7, 60);
INSERT INTO "soldiers" VALUES (2714, '', 3, '', 62, NULL, 27, NULL, 11, 25);
INSERT INTO "soldiers" VALUES (2715, '', 4, '', 37, NULL, 3, 1, 2, 31);
INSERT INTO "soldiers" VALUES (2716, '', 3, '', 40, 8, 4, 21, 8, 49);
INSERT INTO "soldiers" VALUES (2717, '', 3, '', 65, NULL, 3, 5, 8, 48);
INSERT INTO "soldiers" VALUES (2718, '', 3, '', 52, 1, 6, 4, 1, 49);
INSERT INTO "soldiers" VALUES (2719, '', 4, '', 49, 8, 9, NULL, 8, 32);
INSERT INTO "soldiers" VALUES (2721, '', 3, '', 79, 6, 11, 6, 6, 68);
INSERT INTO "soldiers" VALUES (2723, '', 6, '', 72, NULL, 20, NULL, 5, 47);
INSERT INTO "soldiers" VALUES (2725, '', 4, '', 60, 16, 1, NULL, 16, 38);
INSERT INTO "soldiers" VALUES (2730, '', 4, '', 43, 3, 17, 11, 3, 34);
INSERT INTO "soldiers" VALUES (2731, '', 4, '', 34, 1, 7, 2, 1, 28);
INSERT INTO "soldiers" VALUES (2732, '', 6, '', 39, NULL, 8, 5, 11, 25);
INSERT INTO "soldiers" VALUES (2733, '', 5, '', 58, NULL, 7, 1, 2, 50);
INSERT INTO "soldiers" VALUES (2734, '', 2, '', 39, NULL, 3, 11, 4, 43);
INSERT INTO "soldiers" VALUES (2735, '', 3, '', 65, NULL, 1, 2, 3, 63);
INSERT INTO "soldiers" VALUES (2736, '', 2, '', 55, 2, 4, 10, 2, 59);
INSERT INTO "soldiers" VALUES (2737, '', 5, '', 63, NULL, 11, 24, 14, 62);
INSERT INTO "soldiers" VALUES (2738, '', 4, '', 77, 2, 5, 1, 2, 71);
INSERT INTO "soldiers" VALUES (2739, '', 4, '', 32, NULL, 3, 5, 3, 30);
INSERT INTO "soldiers" VALUES (2740, '', 3, '', 39, NULL, 6, 12, 8, 37);
INSERT INTO "soldiers" VALUES (2741, '', 4, '', 75, 1, 12, 5, 1, 67);
INSERT INTO "soldiers" VALUES (2742, '', 1, '', 39, NULL, 7, 2, 5, 29);
INSERT INTO "soldiers" VALUES (2743, '', 5, '', 34, NULL, 7, 6, 4, 29);
INSERT INTO "soldiers" VALUES (2744, '', 5, '', 89, NULL, 3, 2, 3, 85);
INSERT INTO "soldiers" VALUES (2745, '', 4, '', 74, NULL, 8, 1, 3, 64);
INSERT INTO "soldiers" VALUES (2746, '', 6, '', 38, NULL, 8, 1, 7, 23);
INSERT INTO "soldiers" VALUES (2747, '', 5, '', 57, NULL, 11, NULL, 3, 43);
INSERT INTO "soldiers" VALUES (2748, '', 1, '', 62, NULL, 11, NULL, 8, 43);
INSERT INTO "soldiers" VALUES (2749, '', 3, '', 42, NULL, 3, 1, 9, 31);
INSERT INTO "soldiers" VALUES (2750, '', 3, '', 45, 1, 6, NULL, 1, 38);
INSERT INTO "soldiers" VALUES (2751, '', 6, '', 61, NULL, 15, 3, 8, 41);
INSERT INTO "soldiers" VALUES (2752, '', 2, '', 45, NULL, 11, 2, 2, 34);
INSERT INTO "soldiers" VALUES (2753, '', 3, '', 36, 3, 10, 1, 3, 24);
INSERT INTO "soldiers" VALUES (2754, '', 4, '', 38, NULL, 2, 2, 7, 31);
INSERT INTO "soldiers" VALUES (2756, '', 3, '', 61, NULL, 6, 4, 4, 55);
INSERT INTO "soldiers" VALUES (2757, '', 9, '', 74, NULL, 12, 4, 6, 60);
INSERT INTO "soldiers" VALUES (2758, '', 4, '', 45, NULL, 1, 1, 5, 39);
INSERT INTO "soldiers" VALUES (2759, '', 2, '', 40, NULL, 3, 1, 2, 36);
INSERT INTO "soldiers" VALUES (2761, '', 4, '', 88, NULL, 12, NULL, 2, 74);
INSERT INTO "soldiers" VALUES (2762, '', 4, '', 109, NULL, 13, 2, 8, 90);
INSERT INTO "soldiers" VALUES (2763, '', 6, '', 104, 3, 15, 2, 3, 88);
INSERT INTO "soldiers" VALUES (2764, '', 5, '', 41, NULL, NULL, 1, 2, 40);
INSERT INTO "soldiers" VALUES (2766, '', 4, '', 78, NULL, 14, 11, 4, 71);
INSERT INTO "soldiers" VALUES (2767, '', 4, '', 143, NULL, 23, NULL, 6, 114);
INSERT INTO "soldiers" VALUES (2768, '', 4, '', 51, NULL, 4, NULL, 11, 36);
INSERT INTO "soldiers" VALUES (2769, '', 6, '', 58, NULL, 17, 6, 9, 36);
INSERT INTO "soldiers" VALUES (2770, '', 5, '', 86, NULL, 32, 8, 13, 50);
INSERT INTO "soldiers" VALUES (2771, '', 2, '', 50, NULL, 10, 3, 4, 39);
INSERT INTO "soldiers" VALUES (2772, '', 5, '', 100, NULL, 6, NULL, 8, 85);
INSERT INTO "soldiers" VALUES (2774, '', 2, '', 49, NULL, 1, 16, 20, 41);
INSERT INTO "soldiers" VALUES (2775, '', 6, '', 52, NULL, 12, 15, 22, 33);
INSERT INTO "soldiers" VALUES (2776, '', 3, '', 79, NULL, 17, 4, 24, 42);
INSERT INTO "soldiers" VALUES (2777, '', 4, '', 47, NULL, 16, 4, 9, 26);
INSERT INTO "soldiers" VALUES (2778, '', 1, '', 48, NULL, 10, 2, 10, 30);
INSERT INTO "soldiers" VALUES (2779, '', 4, '', 51, NULL, 7, 1, 8, 37);
INSERT INTO "soldiers" VALUES (2780, '', 4, '', 48, NULL, 10, 2, NULL, 39);
INSERT INTO "soldiers" VALUES (2781, '', 3, '', 67, NULL, 4, 3, 5, 61);
INSERT INTO "soldiers" VALUES (2784, '', 3, '', 86, NULL, 13, NULL, 8, 64);
INSERT INTO "soldiers" VALUES (2785, '', 1, '', 72, NULL, 4, NULL, 4, 48);
INSERT INTO "soldiers" VALUES (2786, '', 1, '', 48, NULL, 4, 5, 3, 46);
INSERT INTO "soldiers" VALUES (2787, '', 3, '', 44, NULL, 1, 13, 13, 43);
INSERT INTO "soldiers" VALUES (2788, '', 8, '', 93, NULL, 10, NULL, 10, 88);
INSERT INTO "soldiers" VALUES (2789, '', 4, '', 67, NULL, 10, 9, 24, 42);
INSERT INTO "soldiers" VALUES (2790, '', 7, '', 86, NULL, 9, NULL, 3, 74);
INSERT INTO "soldiers" VALUES (2792, '', 4, '', 73, NULL, 11, 8, 4, 66);
INSERT INTO "soldiers" VALUES (2793, '', 1, '', 61, NULL, 6, NULL, 6, 49);
INSERT INTO "soldiers" VALUES (2794, '', 7, '', 86, NULL, 5, NULL, 3, 78);
INSERT INTO "soldiers" VALUES (2795, '', 3, '', 65, 4, 10, NULL, 4, 50);
INSERT INTO "soldiers" VALUES (2798, '', 2, '', 58, 4, 3, 1, 4, 52);
INSERT INTO "soldiers" VALUES (2799, '', 4, '', 62, NULL, 11, 6, 13, 43);
INSERT INTO "soldiers" VALUES (2800, '', 4, '', 58, NULL, 1, NULL, 3, 54);
INSERT INTO "soldiers" VALUES (2801, '', 5, '', 63, 2, 9, 3, 2, 55);
INSERT INTO "soldiers" VALUES (2802, '', 3, '', 98, NULL, 14, 6, 21, 68);
INSERT INTO "soldiers" VALUES (2803, '', 3, '', 85, NULL, 6, 2, 10, 71);
INSERT INTO "soldiers" VALUES (2804, '', 2, '', 60, NULL, 2, 2, 14, 46);
INSERT INTO "soldiers" VALUES (2806, '', 1, '', 60, NULL, 11, 16, 22, 43);
INSERT INTO "soldiers" VALUES (2807, '', 6, '', 101, NULL, 10, 13, 45, 59);
INSERT INTO "soldiers" VALUES (2808, '', 3, '', 66, NULL, 25, 7, 14, 34);
INSERT INTO "soldiers" VALUES (2810, '', 4, '', 59, NULL, 16, 27, 36, 34);
INSERT INTO "soldiers" VALUES (2811, '', 4, '', 78, NULL, 8, 7, 29, 48);
INSERT INTO "soldiers" VALUES (2812, '', 1, '', 59, 4, 8, NULL, 4, 47);
INSERT INTO "soldiers" VALUES (2813, '', 4, '', 64, NULL, NULL, NULL, 4, 55);
INSERT INTO "soldiers" VALUES (2814, '', 5, '', 61, NULL, 7, 12, 21, 45);
INSERT INTO "soldiers" VALUES (2815, '', 5, '', 127, NULL, 21, NULL, 13, 93);
INSERT INTO "soldiers" VALUES (2817, '', 1, '', 61, NULL, 8, 3, 2, 54);
INSERT INTO "soldiers" VALUES (2819, '', 1, '', 47, NULL, 7, NULL, NULL, 40);
INSERT INTO "soldiers" VALUES (2820, '', 1, '', 79, NULL, 8, 2, 7, 66);
INSERT INTO "soldiers" VALUES (2821, '', 6, '', 62, NULL, 7, 3, 1, 57);
INSERT INTO "soldiers" VALUES (2824, '', 4, '', 62, NULL, 16, NULL, 9, 37);
INSERT INTO "soldiers" VALUES (2825, '', 3, '', 62, NULL, 7, 2, 1, 56);
INSERT INTO "soldiers" VALUES (2826, '', 5, '', 102, NULL, 29, 11, 16, 68);
INSERT INTO "soldiers" VALUES (2827, '', 4, '', 103, NULL, 14, NULL, 6, 82);
INSERT INTO "soldiers" VALUES (2828, '', 7, '', 68, NULL, 9, 15, 7, 67);
INSERT INTO "soldiers" VALUES (2829, '', 6, '', 95, NULL, 5, NULL, 3, 87);
INSERT INTO "soldiers" VALUES (2831, '', 7, '', 119, NULL, 1, NULL, 1, 117);
INSERT INTO "soldiers" VALUES (2832, '', 5, '', 82, NULL, 18, 15, 15, 64);
INSERT INTO "soldiers" VALUES (2833, '', 5, '', 58, 2, 5, NULL, 2, 51);
INSERT INTO "soldiers" VALUES (2835, '', 3, '', 59, NULL, 9, 1, 2, 49);
INSERT INTO "soldiers" VALUES (2836, '', 6, '', 78, NULL, 5, 10, 4, 81);
INSERT INTO "soldiers" VALUES (2839, '', 3, '', 79, NULL, 21, 21, 59, 19);
INSERT INTO "soldiers" VALUES (2841, '', 5, '', 120, NULL, 34, 16, 45, 57);
INSERT INTO "soldiers" VALUES (2842, '', 6, '', 81, NULL, 4, 41, 74, 42);
INSERT INTO "soldiers" VALUES (2843, '', 7, '', 60, NULL, 11, 37, 54, 32);
INSERT INTO "soldiers" VALUES (2844, '', 6, '', 61, NULL, 6, 1, 4, 48);
INSERT INTO "soldiers" VALUES (2845, '', 5, '', 103, NULL, 45, NULL, 9, 47);
INSERT INTO "soldiers" VALUES (2846, '', 3, '', 61, NULL, 26, 7, 9, 33);
INSERT INTO "soldiers" VALUES (2847, '', 1, '', 100, NULL, 40, 12, 31, 41);
INSERT INTO "soldiers" VALUES (2848, '', 3, '', 56, NULL, 22, 4, 2, 36);
INSERT INTO "soldiers" VALUES (2849, '', 1, '', 60, NULL, 12, NULL, 2, 46);
INSERT INTO "soldiers" VALUES (2850, '', 5, '', 135, NULL, 33, NULL, 23, 79);
INSERT INTO "soldiers" VALUES (2852, '', 1, '', 60, NULL, 13, NULL, NULL, 47);
INSERT INTO "soldiers" VALUES (2853, '', 3, '', 79, NULL, 28, 19, 14, 56);
INSERT INTO "soldiers" VALUES (2854, '', 5, '', 75, NULL, 16, NULL, 13, 46);
INSERT INTO "soldiers" VALUES (2855, '', 4, '', 51, NULL, 11, 5, NULL, NULL);
INSERT INTO "soldiers" VALUES (2856, '', 1, '', 53, 3, 10, 2, 3, 42);
INSERT INTO "soldiers" VALUES (2858, '', 4, '', 76, NULL, 10, NULL, 4, 62);
INSERT INTO "soldiers" VALUES (2859, '', 4, '', 79, NULL, 16, NULL, 2, 58);
INSERT INTO "soldiers" VALUES (2860, '', 5, '', 76, NULL, 24, NULL, 16, 36);
INSERT INTO "soldiers" VALUES (2861, '', 1, '', 79, NULL, 20, 3, 15, 47);
INSERT INTO "soldiers" VALUES (2864, '', 2, '', 104, NULL, 8, 2, 14, 84);
INSERT INTO "soldiers" VALUES (2866, '', 2, '', 88, NULL, 6, 4, 5, 81);
INSERT INTO "soldiers" VALUES (2867, '', 4, '', 76, NULL, 7, 12, 2, 80);
INSERT INTO "soldiers" VALUES (2868, '', 9, '', 98, NULL, 7, 4, 16, 79);
INSERT INTO "soldiers" VALUES (2869, '', 6, '', 55, NULL, 7, NULL, 2, 46);
INSERT INTO "soldiers" VALUES (2870, '', 6, '', 90, NULL, 6, 15, 15, 84);
INSERT INTO "soldiers" VALUES (2871, '', 8, '', 90, NULL, 4, 9, 16, 78);
INSERT INTO "soldiers" VALUES (2872, '', 3, '', 50, NULL, 13, 10, 13, 34);
INSERT INTO "soldiers" VALUES (2873, '', 5, '', 51, NULL, 1, NULL, 1, 49);
INSERT INTO "soldiers" VALUES (2874, '', 2, '', 52, NULL, 2, 1, 1, 50);
INSERT INTO "soldiers" VALUES (2875, '', 6, '', 93, NULL, 29, NULL, 18, 64);
INSERT INTO "soldiers" VALUES (2876, '', 1, '', 50, NULL, 1, 2, 5, 45);
INSERT INTO "soldiers" VALUES (2879, '', 8, '', 92, NULL, 7, NULL, 8, 83);
INSERT INTO "soldiers" VALUES (2880, '', 1, '', 75, NULL, 21, 12, 9, 59);
INSERT INTO "soldiers" VALUES (2883, '', 3, '', 50, NULL, 28, 16, 27, 35);
INSERT INTO "soldiers" VALUES (2884, '', 1, '', 52, NULL, 12, 17, 17, 40);
INSERT INTO "soldiers" VALUES (2885, '', 1, '', 87, NULL, 12, 3, 13, 65);
INSERT INTO "soldiers" VALUES (2886, '', 4, '', 53, NULL, 6, NULL, 2, 45);
INSERT INTO "soldiers" VALUES (2887, '', 5, '', 78, 2, 13, 8, 2, 71);
INSERT INTO "soldiers" VALUES (2890, '', 2, '', 65, NULL, 11, 9, 9, 54);
INSERT INTO "soldiers" VALUES (2891, '', 5, '', 55, NULL, 8, 4, 1, 50);
INSERT INTO "soldiers" VALUES (2892, '', 1, '', 83, NULL, 7, 2, NULL, 78);
INSERT INTO "soldiers" VALUES (2893, '', 8, '', 115, NULL, 10, 4, 2, 107);
INSERT INTO "soldiers" VALUES (2894, '', 1, '', 49, NULL, 1, 1, 2, 47);
INSERT INTO "soldiers" VALUES (2899, '', 1, '', 83, NULL, 10, 7, 10, 69);
INSERT INTO "soldiers" VALUES (2900, '', 6, '', 96, NULL, 25, 17, 25, 63);
INSERT INTO "soldiers" VALUES (2901, '', 6, '', 76, NULL, 7, 5, 4, 70);
INSERT INTO "soldiers" VALUES (2902, '', 1, '', NULL, NULL, NULL, 4, 1, 3);
INSERT INTO "soldiers" VALUES (2905, '', 4, '', 77, NULL, 15, 5, 6, 61);
INSERT INTO "soldiers" VALUES (2906, '', 7, '', 88, NULL, 15, 5, 14, 64);
INSERT INTO "soldiers" VALUES (2907, '', 5, '', 50, NULL, 20, 3, 15, 18);
INSERT INTO "soldiers" VALUES (2909, '', 7, '', 81, NULL, 15, 3, 2, 67);
INSERT INTO "soldiers" VALUES (2910, '', 1, '', 86, NULL, 5, 2, 6, 75);
INSERT INTO "soldiers" VALUES (2911, '', 6, '', 49, NULL, 15, 1, 9, 28);
INSERT INTO "soldiers" VALUES (2912, '', 7, '', 91, NULL, 12, 28, 54, 53);
INSERT INTO "soldiers" VALUES (2913, '', 4, '', 52, NULL, 10, NULL, 3, 39);
INSERT INTO "soldiers" VALUES (2914, '', 5, '', 76, NULL, 8, 1, 20, 49);
INSERT INTO "soldiers" VALUES (2915, '', 2, '', 52, NULL, 12, 4, 8, 36);
INSERT INTO "soldiers" VALUES (2916, '', 5, '', 41, NULL, 7, 1, 3, 29);
INSERT INTO "soldiers" VALUES (2917, '', 1, '', 1, NULL, NULL, 6, 2, 5);
INSERT INTO "soldiers" VALUES (2919, '', 1, '', 74, NULL, 34, 11, 18, 33);
INSERT INTO "soldiers" VALUES (2921, '', 1, '', 52, NULL, 21, 9, 13, 27);
INSERT INTO "soldiers" VALUES (2923, '', 5, '', 47, NULL, 20, 7, 4, 30);
INSERT INTO "soldiers" VALUES (2924, '', 6, '', 128, NULL, 27, 1, 7, 95);
INSERT INTO "soldiers" VALUES (2925, '', 1, '', 39, NULL, 2, 1, 12, 26);
INSERT INTO "soldiers" VALUES (2926, '', 3, '', 49, NULL, 11, 13, 15, 36);
INSERT INTO "soldiers" VALUES (2927, '', 3, '', 77, NULL, 8, 2, 4, 67);
INSERT INTO "soldiers" VALUES (2928, '', 2, '', 50, NULL, 17, 1, 2, 32);
INSERT INTO "soldiers" VALUES (2929, '', 3, '', 86, NULL, 11, 4, 4, 75);
INSERT INTO "soldiers" VALUES (2930, '', 1, '', 115, NULL, 21, 3, 13, 84);
INSERT INTO "soldiers" VALUES (2931, '', 2, '', 46, NULL, 2, NULL, 2, 42);
INSERT INTO "soldiers" VALUES (2932, '', 1, '', 98, NULL, 10, 1, 10, 79);
INSERT INTO "soldiers" VALUES (2933, '', 2, '', 55, NULL, 2, NULL, 3, 50);
INSERT INTO "soldiers" VALUES (2934, '', 1, '', 50, NULL, 7, 4, 13, 33);
INSERT INTO "soldiers" VALUES (2936, '', 5, '', 77, NULL, 8, 1, 2, 67);
INSERT INTO "soldiers" VALUES (2938, '', 9, '', 93, NULL, 9, 2, 2, 84);
INSERT INTO "soldiers" VALUES (2939, '', 5, '', 60, NULL, 8, NULL, 2, 50);
INSERT INTO "soldiers" VALUES (2941, '', 1, '', 51, NULL, 3, 2, 2, 46);
INSERT INTO "soldiers" VALUES (2942, '', 2, '', 76, NULL, 23, 2, 13, 42);
INSERT INTO "soldiers" VALUES (2944, '', 4, '', 74, NULL, 15, 5, 7, 57);
INSERT INTO "soldiers" VALUES (2945, '', 5, '', 111, NULL, 10, NULL, 14, 87);
INSERT INTO "soldiers" VALUES (2946, '', 2, '', 47, NULL, 2, 2, 9, 37);
INSERT INTO "soldiers" VALUES (2948, '', 4, '', 51, NULL, 4, NULL, NULL, 47);
INSERT INTO "soldiers" VALUES (2949, '', 5, '', 77, NULL, 25, 13, 10, 54);
INSERT INTO "soldiers" VALUES (2950, '', 1, '', 51, NULL, 9, 3, 17, 27);
INSERT INTO "soldiers" VALUES (2951, '', 3, '', 52, NULL, 7, 4, 1, 48);
INSERT INTO "soldiers" VALUES (2952, '', 7, '', 51, NULL, 7, 3, 4, 42);
INSERT INTO "soldiers" VALUES (2953, '', 2, '', 50, NULL, 4, 4, 22, 27);
INSERT INTO "soldiers" VALUES (2954, '', 3, '', 49, NULL, 3, 5, 16, 32);
INSERT INTO "soldiers" VALUES (2955, '', 3, '', 53, NULL, 12, 5, 7, 39);
INSERT INTO "soldiers" VALUES (2956, '', 5, '', 76, NULL, 22, NULL, 2, 52);
INSERT INTO "soldiers" VALUES (2957, '', 5, '', 49, NULL, 7, 6, 7, 41);
INSERT INTO "soldiers" VALUES (2958, '', 1, '', 77, NULL, 20, 12, 2, 69);
INSERT INTO "soldiers" VALUES (2959, '', 4, '', 59, NULL, 17, 2, 16, 48);
INSERT INTO "soldiers" VALUES (2960, '', 1, '', 75, NULL, 13, 3, 3, 62);
INSERT INTO "soldiers" VALUES (2961, '', 6, '', 114, NULL, 35, 16, 37, 51);
INSERT INTO "soldiers" VALUES (2962, '', 6, '', 73, NULL, 7, NULL, 11, 55);
INSERT INTO "soldiers" VALUES (2963, '', 4, '', 47, NULL, NULL, 2, 4, 39);
INSERT INTO "soldiers" VALUES (2964, '', 1, '', 62, NULL, 6, 4, NULL, 60);
INSERT INTO "soldiers" VALUES (2965, '', 2, '', 57, NULL, 12, 4, 1, 48);
INSERT INTO "soldiers" VALUES (2966, '', 1, '', 57, NULL, 7, NULL, 3, 47);
INSERT INTO "soldiers" VALUES (2967, '', 1, '', 51, NULL, 4, NULL, NULL, 47);
INSERT INTO "soldiers" VALUES (2968, '', 1, '', 61, NULL, 1, NULL, NULL, 60);
INSERT INTO "soldiers" VALUES (2969, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "soldiers" VALUES (2970, '', 8, '', 93, NULL, 8, 3, 6, 82);
INSERT INTO "soldiers" VALUES (2971, '', 2, '', 51, NULL, 4, NULL, 2, 45);
INSERT INTO "soldiers" VALUES (2972, '', 2, '', 85, NULL, 10, 10, 17, 68);
INSERT INTO "soldiers" VALUES (2973, '', 7, '', 101, NULL, 12, 3, 22, 70);
INSERT INTO "soldiers" VALUES (2974, '', 3, '', 64, NULL, 8, 2, 3, 55);
INSERT INTO "soldiers" VALUES (2976, '', 3, '', 62, NULL, 12, 4, 7, 47);
INSERT INTO "soldiers" VALUES (2979, '', 6, '', 107, NULL, 15, 7, 21, 78);
INSERT INTO "soldiers" VALUES (2980, '', 2, '', 90, NULL, 9, 2, 8, 75);
INSERT INTO "soldiers" VALUES (2981, '', 4, '', 47, NULL, 4, NULL, 8, 35);
INSERT INTO "soldiers" VALUES (2982, '', 2, '', 63, NULL, 4, NULL, 2, 57);
INSERT INTO "soldiers" VALUES (2984, '', 3, '', 57, NULL, NULL, 2, 1, 58);
INSERT INTO "soldiers" VALUES (2985, '', 2, '', 59, NULL, 4, NULL, 3, 52);
INSERT INTO "soldiers" VALUES (2986, '', 5, '', 87, NULL, 7, 8, 6, 82);
INSERT INTO "soldiers" VALUES (2987, '', 7, '', 49, NULL, 7, 2, 15, 28);
INSERT INTO "soldiers" VALUES (2988, '', 6, '', 62, NULL, 10, NULL, 8, 44);
INSERT INTO "soldiers" VALUES (2990, '', 7, '', 85, NULL, 9, NULL, 6, 70);
INSERT INTO "soldiers" VALUES (2991, '', 5, '', 99, NULL, 9, 2, 10, 91);
INSERT INTO "soldiers" VALUES (2992, '', 1, '', 57, NULL, NULL, NULL, 6, 50);
INSERT INTO "soldiers" VALUES (2993, '', 1, '', 101, NULL, 37, 21, 21, 64);
INSERT INTO "soldiers" VALUES (2994, '', 1, '', 90, NULL, 20, 3, 14, 58);
INSERT INTO "soldiers" VALUES (2995, '', 5, '', 53, NULL, 16, 5, 5, 36);
INSERT INTO "soldiers" VALUES (2996, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "soldiers" VALUES (2997, '', 1, '', 63, NULL, 8, NULL, 1, 53);
INSERT INTO "soldiers" VALUES (2998, '', 1, '', 86, NULL, 40, 27, 31, 42);
INSERT INTO "soldiers" VALUES (2999, '', 6, '', 58, NULL, 9, 4, 8, 45);
INSERT INTO "soldiers" VALUES (3000, '', 3, '', 85, NULL, 19, 19, 5, 70);
INSERT INTO "soldiers" VALUES (3001, '', 1, '', 93, NULL, 22, 8, 7, 72);
INSERT INTO "soldiers" VALUES (3002, '', 2, '', 33, NULL, 3, 2, NULL, 31);
INSERT INTO "soldiers" VALUES (3003, '', 3, '', 54, NULL, 9, 1, 3, 41);
INSERT INTO "soldiers" VALUES (3004, '', 1, '', 83, NULL, 9, 7, NULL, 81);
INSERT INTO "soldiers" VALUES (3005, '', 2, '', 50, NULL, 10, 3, 1, 42);
INSERT INTO "soldiers" VALUES (3006, '', 5, '', 60, NULL, 2, NULL, 3, 55);
INSERT INTO "soldiers" VALUES (3007, '', 4, '', 58, NULL, 5, 1, NULL, 54);
INSERT INTO "soldiers" VALUES (3009, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "soldiers" VALUES (3010, '', 10, '', 103, NULL, 11, 8, 17, 83);
INSERT INTO "soldiers" VALUES (3011, '', 2, '', 63, NULL, 16, 5, 5, 45);
INSERT INTO "soldiers" VALUES (3013, '', 3, '', 57, NULL, 2, 5, 2, 42);
INSERT INTO "soldiers" VALUES (3014, '', 7, '', 105, NULL, 9, 4, 6, 94);
INSERT INTO "soldiers" VALUES (3015, '', 2, '', 72, NULL, 11, 3, NULL, 64);
INSERT INTO "soldiers" VALUES (3017, '', 2, '', 72, NULL, 1, NULL, 1, 70);
INSERT INTO "soldiers" VALUES (3018, '', 1, '', 46, NULL, 10, 4, 6, 34);
INSERT INTO "soldiers" VALUES (3022, '', 6, '', 92, NULL, 15, 6, 4, 78);
INSERT INTO "soldiers" VALUES (3023, '', 2, '', 40, NULL, 12, 9, 7, 30);
INSERT INTO "soldiers" VALUES (3024, '', 1, '', 47, NULL, 7, 13, 6, 42);
INSERT INTO "soldiers" VALUES (3025, '', 4, '', 78, NULL, 8, 6, 3, 73);
INSERT INTO "soldiers" VALUES (3026, '', 4, '', NULL, NULL, NULL, 2, NULL, 2);
INSERT INTO "soldiers" VALUES (3028, '', 5, '', 76, NULL, 4, 3, 5, 70);
INSERT INTO "soldiers" VALUES (3029, '', 6, '', 64, NULL, 18, 4, 5, 45);
INSERT INTO "soldiers" VALUES (3030, '', 4, '', 55, NULL, 14, 10, 3, 48);
INSERT INTO "soldiers" VALUES (3031, '', 3, '', 87, NULL, 6, NULL, 8, 69);
INSERT INTO "soldiers" VALUES (3032, '', 1, '', 49, NULL, 4, 4, 8, 41);
INSERT INTO "soldiers" VALUES (3033, '', 3, '', 88, NULL, 10, NULL, 1, 77);
INSERT INTO "soldiers" VALUES (3034, '', 1, '', 73, NULL, 5, NULL, 4, 64);
INSERT INTO "soldiers" VALUES (3035, '', 5, '', 42, NULL, NULL, 2, 1, 43);
INSERT INTO "soldiers" VALUES (3036, '', 4, '', 51, NULL, 7, 8, 10, 40);
INSERT INTO "soldiers" VALUES (3037, '', 4, '', 74, NULL, 12, 12, 11, 63);
INSERT INTO "soldiers" VALUES (3038, '', 1, '', 76, NULL, 6, 1, 2, 69);
INSERT INTO "soldiers" VALUES (3039, '', 1, '', 52, NULL, 8, 7, 9, 42);
INSERT INTO "soldiers" VALUES (3040, '', 1, '', 77, NULL, 5, 2, 6, 66);
INSERT INTO "soldiers" VALUES (3041, '', 1, '', 59, 2, 2, 7, 2, 62);
INSERT INTO "soldiers" VALUES (3043, '', 7, '', 69, 30, 4, 13, 30, 44);
INSERT INTO "soldiers" VALUES (3044, '', 1, '', 76, NULL, 9, 10, 7, 70);
INSERT INTO "soldiers" VALUES (3045, '', 6, '', 84, NULL, 15, 2, 6, 65);
INSERT INTO "soldiers" VALUES (3046, '', 2, '', 45, NULL, 9, 7, 5, 38);
INSERT INTO "soldiers" VALUES (3047, '', 1, '', 94, NULL, NULL, NULL, 2, 92);
INSERT INTO "soldiers" VALUES (3048, '', 2, '', 48, NULL, 12, 7, 13, 30);
INSERT INTO "soldiers" VALUES (3050, '', 4, '', 53, 5, 3, NULL, 5, 45);
INSERT INTO "soldiers" VALUES (3051, '', 2, '', 86, 12, 13, NULL, 12, 60);
INSERT INTO "soldiers" VALUES (3052, '', 7, '', 100, NULL, 32, 12, 10, 70);
INSERT INTO "soldiers" VALUES (3053, '', 4, '', 34, 6, 1, 2, 10, 25);
INSERT INTO "soldiers" VALUES (3055, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "soldiers" VALUES (3056, '', 1, '', 45, NULL, 13, 14, 18, 28);
INSERT INTO "soldiers" VALUES (3057, '', 2, '', 56, NULL, 5, NULL, 9, 42);
INSERT INTO "soldiers" VALUES (3058, '', 1, '', 54, NULL, 8, 3, 5, 42);
INSERT INTO "soldiers" VALUES (3059, '', 3, '', 51, NULL, 7, 2, 4, 42);
INSERT INTO "soldiers" VALUES (3060, '', 5, '', 58, NULL, 12, 9, 4, 50);
INSERT INTO "soldiers" VALUES (3061, '', 2, '', 59, 12, 1, NULL, 12, 46);
INSERT INTO "soldiers" VALUES (3062, '', 1, '', 63, 2, 12, NULL, 2, 48);
INSERT INTO "soldiers" VALUES (3063, '', 3, '', 56, NULL, 10, NULL, 1, 45);
INSERT INTO "soldiers" VALUES (3064, '', 8, '', 106, NULL, 7, NULL, 9, 90);
INSERT INTO "soldiers" VALUES (3065, '', 6, '', 78, NULL, 28, 12, 10, 52);
INSERT INTO "soldiers" VALUES (3066, '', 1, '', 57, NULL, 5, 3, 5, 50);
INSERT INTO "soldiers" VALUES (3067, '', 2, '', 52, NULL, 5, NULL, 1, 46);
INSERT INTO "soldiers" VALUES (3068, '', 2, '', 56, NULL, 13, 3, 21, 25);
INSERT INTO "soldiers" VALUES (3069, '', 1, '', 49, 15, 14, 16, 19, 31);
INSERT INTO "soldiers" VALUES (3070, '', 2, '', 53, NULL, 4, NULL, 3, 46);
INSERT INTO "soldiers" VALUES (3072, '', 1, '', 40, NULL, 2, NULL, 11, 27);
INSERT INTO "soldiers" VALUES (3074, '', 3, '', 55, NULL, 4, 2, 7, 45);
INSERT INTO "soldiers" VALUES (3075, '', 1, '', 80, NULL, 9, NULL, 3, 67);
INSERT INTO "soldiers" VALUES (3076, '', 2, '', 71, NULL, 11, NULL, 8, 51);
INSERT INTO "soldiers" VALUES (3077, '', 1, '', 95, NULL, 7, NULL, 10, 77);
INSERT INTO "soldiers" VALUES (3078, '', 6, '', 94, NULL, 7, 3, 23, 67);
INSERT INTO "soldiers" VALUES (3079, '', 5, '', 60, NULL, 3, 1, 5, 53);
INSERT INTO "soldiers" VALUES (3080, '', 6, '', 85, NULL, 15, 2, 7, 64);
INSERT INTO "soldiers" VALUES (3081, '', 6, '', 60, NULL, 13, 2, 13, 35);
INSERT INTO "soldiers" VALUES (3082, '', 2, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "soldiers" VALUES (3083, '', 7, '', 98, NULL, 12, 2, 24, 63);
INSERT INTO "soldiers" VALUES (3084, '', 3, '', 59, NULL, 10, NULL, NULL, 49);
INSERT INTO "soldiers" VALUES (3085, '', 3, '', 55, NULL, NULL, NULL, 9, 44);
INSERT INTO "soldiers" VALUES (3086, '', 1, '', 62, NULL, 10, NULL, 4, 46);
INSERT INTO "soldiers" VALUES (3087, '', 1, '', 85, NULL, 5, NULL, 19, 58);
INSERT INTO "soldiers" VALUES (3088, '', 2, '', 42, NULL, 10, 13, 13, 31);
INSERT INTO "soldiers" VALUES (3089, '', 1, '', 72, NULL, 2, NULL, 35, 45);
INSERT INTO "soldiers" VALUES (3090, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "soldiers" VALUES (3091, '', 7, '', 59, NULL, 7, 3, 12, 42);
INSERT INTO "soldiers" VALUES (3092, '', 3, '', 85, NULL, 15, 11, 32, 48);
INSERT INTO "soldiers" VALUES (3094, '', 2, '', 88, NULL, 18, NULL, 29, 41);
INSERT INTO "soldiers" VALUES (3096, '', 2, '', 80, NULL, 4, NULL, 18, 57);
INSERT INTO "soldiers" VALUES (3097, '', 3, '', 58, NULL, 10, 3, 10, 41);
INSERT INTO "soldiers" VALUES (3098, '', 2, '', 59, NULL, 6, 2, 14, 41);
INSERT INTO "soldiers" VALUES (3099, '', 2, '', 55, NULL, 1, NULL, 6, 48);
INSERT INTO "soldiers" VALUES (3100, '', 1, '', 56, NULL, 14, 2, 12, 30);
INSERT INTO "soldiers" VALUES (3101, '', 11, '', 102, NULL, 13, 1, 27, 62);
INSERT INTO "soldiers" VALUES (3102, '', 7, '', 84, NULL, 11, 5, 29, 49);
INSERT INTO "soldiers" VALUES (3103, '', 2, '', 79, NULL, 6, 3, 22, 52);
INSERT INTO "soldiers" VALUES (3104, '', 4, '', 86, NULL, 14, 2, 16, 58);
INSERT INTO "soldiers" VALUES (3105, '', 1, '', 64, 2, 5, NULL, 2, 56);
INSERT INTO "soldiers" VALUES (3107, '', 3, '', 62, NULL, 7, NULL, 15, 39);
INSERT INTO "soldiers" VALUES (3108, '', 3, '', 52, 3, 1, NULL, 3, 48);
INSERT INTO "soldiers" VALUES (3109, '', 4, '', 154, 17, 31, 20, 11, 132);
INSERT INTO "soldiers" VALUES (3110, '', 3, '', 47, NULL, 9, 4, 12, 29);
INSERT INTO "soldiers" VALUES (3111, '', 3, '', 48, NULL, NULL, NULL, 4, 44);
INSERT INTO "soldiers" VALUES (3112, '', 4, '', 50, NULL, 6, 6, 17, 32);
INSERT INTO "soldiers" VALUES (3113, '', 5, '', 50, NULL, 13, 12, 9, 40);
INSERT INTO "soldiers" VALUES (3114, '', 6, '', 78, NULL, 7, NULL, 14, 56);
INSERT INTO "soldiers" VALUES (3115, '', 4, '', 49, NULL, 6, NULL, 4, 37);
INSERT INTO "soldiers" VALUES (3116, '', 2, '', 76, NULL, 7, 5, 22, 53);
INSERT INTO "soldiers" VALUES (3117, '', 4, '', 81, NULL, 20, 28, 29, 60);
INSERT INTO "soldiers" VALUES (3121, '', 1, '', 150, 6, 8, 15, 10, 147);
INSERT INTO "soldiers" VALUES (3122, '', 2, '', 62, NULL, 9, 3, 2, 53);
INSERT INTO "soldiers" VALUES (3123, '', 3, '', 60, NULL, 6, 4, NULL, 58);
INSERT INTO "soldiers" VALUES (3124, '', 3, '', 56, 1, 5, NULL, 1, 50);
INSERT INTO "soldiers" VALUES (3125, '', 2, '', 54, NULL, 4, 1, NULL, 51);
INSERT INTO "soldiers" VALUES (3126, '', 1, '', 65, NULL, 4, NULL, 4, 57);
INSERT INTO "soldiers" VALUES (3127, '', 2, '', 63, NULL, 14, 1, 11, 39);
INSERT INTO "soldiers" VALUES (3128, '', 1, '', NULL, NULL, NULL, 1, NULL, 1);
INSERT INTO "soldiers" VALUES (3129, '', 3, '', 86, NULL, 10, NULL, 10, 64);
INSERT INTO "soldiers" VALUES (3130, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "soldiers" VALUES (3131, '', 1, '', 84, NULL, 9, 1, 4, 72);
INSERT INTO "soldiers" VALUES (3132, '', 2, '', 61, NULL, 12, 5, 12, 42);
INSERT INTO "soldiers" VALUES (3135, '', 2, '', 88, NULL, 16, 5, 7, 58);
INSERT INTO "soldiers" VALUES (3136, '', 3, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "soldiers" VALUES (3137, '', 2, '', 68, NULL, 5, 2, 6, 58);
INSERT INTO "soldiers" VALUES (3139, '', 3, '', 49, NULL, 8, NULL, 3, 37);
INSERT INTO "soldiers" VALUES (3140, '', 2, '', 93, NULL, 13, NULL, 6, 74);
INSERT INTO "soldiers" VALUES (3142, '', 2, '', 67, NULL, 12, 2, 5, 51);
INSERT INTO "soldiers" VALUES (3143, '', 3, '', 122, 1, 12, 1, 1, 110);
INSERT INTO "soldiers" VALUES (3145, '', 6, '', 63, NULL, 15, NULL, 9, 39);
INSERT INTO "soldiers" VALUES (3146, '', 1, '', 90, NULL, 18, NULL, 8, 63);
INSERT INTO "soldiers" VALUES (3147, '', 2, '', 75, NULL, 13, 10, 16, 55);
INSERT INTO "soldiers" VALUES (3148, '', 7, '', 88, NULL, 32, 21, 22, 55);
INSERT INTO "soldiers" VALUES (3149, '', 4, '', 51, NULL, 8, 1, 7, 44);
INSERT INTO "soldiers" VALUES (3150, '', 6, '', 54, NULL, 10, 4, 5, 43);
INSERT INTO "soldiers" VALUES (3151, '', 2, '', 48, NULL, NULL, 13, 7, 51);
INSERT INTO "soldiers" VALUES (3152, '', 3, '', 41, NULL, 8, 4, 2, 34);
INSERT INTO "soldiers" VALUES (3153, '', 5, '', 83, NULL, 9, 7, 1, 81);
INSERT INTO "soldiers" VALUES (3154, '', 3, '', 80, NULL, 8, 1, 14, 58);
INSERT INTO "soldiers" VALUES (3155, '', 3, '', 80, NULL, 26, 69, 26, 96);
INSERT INTO "soldiers" VALUES (3157, '', 5, '', 50, NULL, 13, 19, 16, 40);
INSERT INTO "soldiers" VALUES (3158, '', 1, '', 84, NULL, 22, 5, 7, 62);
INSERT INTO "soldiers" VALUES (3159, '', 1, '', 90, NULL, 9, 3, 4, 80);
INSERT INTO "soldiers" VALUES (3160, '', 4, '', 64, NULL, 5, NULL, 4, 55);
INSERT INTO "soldiers" VALUES (3161, '', 2, '', 63, NULL, 8, 1, 2, 54);
INSERT INTO "soldiers" VALUES (3162, '', 1, '', 63, NULL, 8, NULL, 2, 53);
INSERT INTO "soldiers" VALUES (3164, '', 3, '', 87, 1, 12, 6, 1, 80);
INSERT INTO "soldiers" VALUES (3165, '', 1, '', 67, NULL, 9, 4, 3, 59);
INSERT INTO "soldiers" VALUES (3166, '', 11, '', 70, NULL, 6, 6, 9, 61);
INSERT INTO "soldiers" VALUES (3167, '', 3, '', 63, NULL, 8, 8, 2, 61);
INSERT INTO "soldiers" VALUES (3168, '', 8, '', 61, NULL, 5, 2, 2, 56);
INSERT INTO "soldiers" VALUES (3169, '', 7, '', 89, NULL, 8, 7, 2, 86);
INSERT INTO "soldiers" VALUES (3170, '', 4, '', 58, NULL, 4, 2, 2, 54);
INSERT INTO "soldiers" VALUES (3172, '', 3, '', 86, NULL, 13, 2, 10, 65);
INSERT INTO "soldiers" VALUES (3175, '', 4, '', 76, 8, 20, 9, 8, 57);
INSERT INTO "soldiers" VALUES (3177, '', 1, '', 53, NULL, 4, 1, 8, 42);
INSERT INTO "soldiers" VALUES (3178, '', 2, '', 90, NULL, 31, 14, 9, 63);
INSERT INTO "soldiers" VALUES (3179, '', 7, '', 89, NULL, 19, 2, 42, 29);
INSERT INTO "soldiers" VALUES (3180, '', 2, '', 85, NULL, 15, 5, 18, 57);
INSERT INTO "soldiers" VALUES (3181, '', 5, '', 88, NULL, 26, 8, 49, 19);
INSERT INTO "soldiers" VALUES (3182, '', 4, '', 52, 32, NULL, 12, 36, 28);
INSERT INTO "soldiers" VALUES (3183, '', 8, '', 74, NULL, 23, 4, 33, 22);
INSERT INTO "soldiers" VALUES (3184, '', 4, '', 54, NULL, 2, NULL, 2, 50);
INSERT INTO "soldiers" VALUES (3185, '', 6, '', 51, NULL, 6, NULL, 6, 39);
INSERT INTO "soldiers" VALUES (3187, '', 3, '', 87, NULL, 8, NULL, 13, 64);
INSERT INTO "soldiers" VALUES (3188, '', 2, '', 87, NULL, 26, 7, 16, 52);
INSERT INTO "soldiers" VALUES (3189, '', 1, '', 38, 17, 6, 21, 29, 22);
INSERT INTO "soldiers" VALUES (3190, '', 8, '', 80, 14, 20, 7, 14, 52);
INSERT INTO "soldiers" VALUES (3191, '', 4, '', 60, NULL, 4, 4, 7, 48);
INSERT INTO "soldiers" VALUES (3192, '', 5, '', 85, NULL, 13, 14, 19, 66);
INSERT INTO "soldiers" VALUES (3193, '', 1, '', 83, NULL, 16, NULL, 13, 53);
INSERT INTO "soldiers" VALUES (3194, '', 1, '', 96, NULL, 27, 15, 24, 59);
INSERT INTO "soldiers" VALUES (3195, '', 4, '', 66, NULL, 9, 6, 14, 49);
INSERT INTO "soldiers" VALUES (3196, '', 7, '', 94, NULL, 25, 9, 14, 64);
INSERT INTO "soldiers" VALUES (3198, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "soldiers" VALUES (3199, '', 1, '', 90, NULL, 9, NULL, 5, 76);
INSERT INTO "soldiers" VALUES (3200, '', 3, '', 69, NULL, 10, 1, 11, 48);
INSERT INTO "soldiers" VALUES (3201, '', 4, '', 49, 20, 6, 3, 20, 24);
INSERT INTO "soldiers" VALUES (3202, '', 1, '', 60, NULL, 3, NULL, 7, 49);
INSERT INTO "soldiers" VALUES (3203, '', 3, '', 60, 1, 10, 1, 1, 50);
INSERT INTO "soldiers" VALUES (3204, '', 3, '', 89, NULL, 12, 5, 30, 52);
INSERT INTO "soldiers" VALUES (3205, '', 1, '', 61, NULL, 7, 7, 29, 31);
INSERT INTO "soldiers" VALUES (3206, '', 5, '', 58, NULL, 2, NULL, 13, 40);
INSERT INTO "soldiers" VALUES (3208, '', 5, '', 62, 14, 5, NULL, 14, 43);
INSERT INTO "soldiers" VALUES (3209, '', 2, '', 63, NULL, 5, NULL, 25, 31);
INSERT INTO "soldiers" VALUES (3210, '', 7, '', 60, NULL, 16, 10, 8, 46);
INSERT INTO "soldiers" VALUES (3211, '', 1, '', 52, 13, 19, 6, 13, 25);
INSERT INTO "soldiers" VALUES (3213, '', 1, '', 1, NULL, NULL, 11, 1, 11);
INSERT INTO "soldiers" VALUES (3214, '', 3, '', 82, NULL, 14, 23, 36, 53);
INSERT INTO "soldiers" VALUES (3216, '', 4, '', 55, NULL, 15, 10, 9, 41);
INSERT INTO "soldiers" VALUES (3217, '', 3, '', 55, NULL, 4, 1, NULL, 39);
INSERT INTO "soldiers" VALUES (3218, '', 5, '', 40, NULL, 1, 10, 17, 31);
INSERT INTO "soldiers" VALUES (3219, '', 1, '', 49, NULL, 12, 6, 23, 20);
INSERT INTO "soldiers" VALUES (3221, '', 1, '', 61, 1, 4, 5, 1, 59);
INSERT INTO "soldiers" VALUES (3222, '', 2, '', 65, NULL, 14, 4, 8, 46);
INSERT INTO "soldiers" VALUES (3223, '', 4, '', 61, NULL, 7, 1, 3, 52);
INSERT INTO "soldiers" VALUES (3224, '', 3, '', 67, NULL, 16, 1, 1, 52);
INSERT INTO "soldiers" VALUES (3225, '', 3, '', 85, 16, 12, 6, 16, 63);
INSERT INTO "soldiers" VALUES (3226, '', 1, '', 88, NULL, 5, NULL, 20, 63);
INSERT INTO "soldiers" VALUES (3227, '', 4, '', 66, NULL, 13, 2, 11, 43);
INSERT INTO "soldiers" VALUES (3228, '', 4, '', 49, NULL, 6, 11, 5, 49);
INSERT INTO "soldiers" VALUES (3229, '', 1, '', 91, NULL, 25, 7, 23, 48);
INSERT INTO "soldiers" VALUES (3230, '', 5, '', 61, NULL, 4, 4, 10, 50);
INSERT INTO "soldiers" VALUES (3231, '', 5, '', 50, NULL, 7, 3, 23, 23);
INSERT INTO "soldiers" VALUES (3232, '', 4, '', 62, NULL, 14, 15, 20, 40);
INSERT INTO "soldiers" VALUES (3235, '', 1, '', 56, NULL, 3, NULL, 2, 51);
INSERT INTO "soldiers" VALUES (3236, '', 4, '', 84, NULL, 9, NULL, 26, 49);
INSERT INTO "soldiers" VALUES (3237, '', 2, '', 58, NULL, 6, NULL, 5, 47);
INSERT INTO "soldiers" VALUES (3238, '', 3, '', 49, NULL, 8, 4, 11, 34);
INSERT INTO "soldiers" VALUES (3239, '', 1, '', 63, NULL, 5, 1, 17, 42);
INSERT INTO "soldiers" VALUES (3240, '', 8, '', 70, NULL, 34, 14, 12, 37);
INSERT INTO "soldiers" VALUES (3241, '', 2, '', 92, NULL, 8, 17, 11, 90);
INSERT INTO "soldiers" VALUES (3242, '', 2, '', 74, NULL, 7, NULL, 5, 62);
INSERT INTO "soldiers" VALUES (3243, '', 4, '', 67, 8, NULL, NULL, 8, 59);
INSERT INTO "soldiers" VALUES (3244, '', 4, '', 88, NULL, 12, 17, 21, 72);
INSERT INTO "soldiers" VALUES (3245, '', 4, '', 97, NULL, 22, 8, 22, 59);
INSERT INTO "soldiers" VALUES (3246, '', 3, '', 94, NULL, 26, 2, 22, 45);
INSERT INTO "soldiers" VALUES (3247, '', 5, '', 84, NULL, 12, NULL, 11, 80);
INSERT INTO "soldiers" VALUES (3249, '', 2, '', 65, NULL, 18, 23, 14, 53);
INSERT INTO "soldiers" VALUES (3250, '', 8, '', 102, NULL, 20, 3, 11, 73);
INSERT INTO "soldiers" VALUES (3251, '', 4, '', 96, NULL, 11, 2, 11, 76);
INSERT INTO "soldiers" VALUES (3253, '', 1, '', 50, NULL, NULL, 4, 1, 48);
INSERT INTO "soldiers" VALUES (3254, '', 1, '', 188, NULL, 49, 28, 13, 154);
INSERT INTO "soldiers" VALUES (3256, '', 1, '', 94, NULL, 1, 26, 1, 122);
INSERT INTO "soldiers" VALUES (3258, '', 3, '', 202, NULL, 43, 20, 27, 152);
INSERT INTO "soldiers" VALUES (3259, '', 1, '', 202, NULL, 42, 21, 17, 150);
INSERT INTO "soldiers" VALUES (3260, '', 6, '', 184, NULL, 26, 13, 40, 131);
INSERT INTO "soldiers" VALUES (3261, '', 5, '', 77, NULL, 13, 14, 5, 74);
INSERT INTO "soldiers" VALUES (3262, '', 1, '', 122, NULL, 21, 16, 19, 128);
INSERT INTO "soldiers" VALUES (3263, '', 3, '', 65, NULL, 12, 1, 18, 35);
INSERT INTO "soldiers" VALUES (3264, '', 4, '', 58, 2, 3, 1, 2, 54);
INSERT INTO "soldiers" VALUES (3268, '', 3, '', 60, NULL, 11, NULL, NULL, 49);
INSERT INTO "soldiers" VALUES (3269, '', 3, '', 72, 7, 8, 13, 7, 67);
INSERT INTO "soldiers" VALUES (3270, '', 2, '', 73, 5, 9, 6, 5, 65);
INSERT INTO "soldiers" VALUES (3273, '', 3, '', 60, NULL, 25, 12, NULL, NULL);
INSERT INTO "soldiers" VALUES (3274, '', 2, '', 58, NULL, NULL, 1, 7, 44);
INSERT INTO "soldiers" VALUES (3276, '', 1, '', 149, NULL, 36, 6, 24, 93);
INSERT INTO "soldiers" VALUES (3277, '', 2, '', 68, NULL, 31, 32, 17, 52);
INSERT INTO "soldiers" VALUES (3279, '', 1, '', 133, NULL, 30, NULL, 24, 79);
INSERT INTO "soldiers" VALUES (3280, '', 1, '', 88, NULL, 7, NULL, 6, 75);
INSERT INTO "soldiers" VALUES (3281, '', 1, '', 161, NULL, 26, 1, 8, 127);
INSERT INTO "soldiers" VALUES (3282, '', 1, '', 72, 7, 2, NULL, 7, 63);
INSERT INTO "soldiers" VALUES (3283, '', 5, '', 68, 2, 4, 2, 2, 64);
INSERT INTO "soldiers" VALUES (3284, '', 2, '', 60, 2, 3, NULL, 2, 54);
INSERT INTO "soldiers" VALUES (3285, '', 1, '', 111, NULL, NULL, 1, 22, 84);
INSERT INTO "soldiers" VALUES (3287, '', 5, '', 126, NULL, 12, 2, 15, 101);
INSERT INTO "soldiers" VALUES (3288, '', 1, '', 105, NULL, 10, 1, 7, 88);
INSERT INTO "soldiers" VALUES (3289, '', 2, '', 129, 6, 4, 1, 6, 115);
INSERT INTO "soldiers" VALUES (3290, '', 2, '', 135, NULL, 21, 2, NULL, 111);
INSERT INTO "soldiers" VALUES (3291, '', 2, '', 131, NULL, 9, 6, 23, 104);
INSERT INTO "soldiers" VALUES (3292, '', 2, '', 64, NULL, NULL, 12, 27, 34);
INSERT INTO "soldiers" VALUES (3293, '', 3, '', 56, NULL, 12, 5, 4, 44);
INSERT INTO "soldiers" VALUES (3294, '', 4, '', 63, NULL, 7, 4, 11, 43);
INSERT INTO "soldiers" VALUES (3295, '', 5, '', 56, NULL, 4, 5, 5, 52);
INSERT INTO "soldiers" VALUES (3296, '', 3, '', 54, NULL, NULL, 1, 5, 46);
INSERT INTO "soldiers" VALUES (3298, '', 2, '', 75, NULL, 27, 4, 34, 18);
INSERT INTO "soldiers" VALUES (3299, '', 1, '', 136, NULL, 17, 5, 7, 116);
INSERT INTO "soldiers" VALUES (3301, '', 4, '', 180, NULL, 32, NULL, NULL, 149);
INSERT INTO "soldiers" VALUES (3302, '', 4, '', 106, NULL, 32, 24, 32, 65);
INSERT INTO "soldiers" VALUES (3304, '', 7, '', 135, NULL, 27, 1, 36, 60);
INSERT INTO "soldiers" VALUES (3305, '', 1, '', 105, NULL, 17, 23, 50, 70);
INSERT INTO "soldiers" VALUES (3306, '', 1, '', 81, NULL, 7, NULL, 10, 41);
INSERT INTO "soldiers" VALUES (3307, '', 3, '', 59, NULL, 6, NULL, 3, 50);
INSERT INTO "soldiers" VALUES (3309, '', 2, '', 107, NULL, 11, 3, 9, 90);
INSERT INTO "soldiers" VALUES (3310, '', 2, '', 102, NULL, 3, 2, 1, 99);
INSERT INTO "soldiers" VALUES (3311, '', 1, '', 133, NULL, 35, 6, 25, 78);
INSERT INTO "soldiers" VALUES (3312, '', 2, '', 33, NULL, 1, NULL, NULL, 32);
INSERT INTO "soldiers" VALUES (3313, '', 1, '', 40, NULL, 18, 8, 5, 25);
INSERT INTO "soldiers" VALUES (3314, '', 2, '', 125, NULL, 15, NULL, 42, 67);
INSERT INTO "soldiers" VALUES (3315, '', 2, '', 168, NULL, 60, 11, 44, 75);
INSERT INTO "soldiers" VALUES (3316, '', 1, '', 79, 7, 11, 3, 7, 63);
INSERT INTO "soldiers" VALUES (3317, '', 5, '', 68, NULL, 11, 3, 14, 45);
INSERT INTO "soldiers" VALUES (3318, '', 4, '', 59, 12, 25, 4, 12, 52);
INSERT INTO "soldiers" VALUES (3319, '', 5, '', 61, NULL, 11, 3, 14, 38);
INSERT INTO "soldiers" VALUES (3320, '', 4, '', 84, NULL, 8, 1, 8, 38);
INSERT INTO "soldiers" VALUES (3321, '', 1, '', 85, NULL, 7, 1, 7, 71);
INSERT INTO "soldiers" VALUES (3323, '', 3, '', 51, NULL, 7, NULL, 1, 43);
INSERT INTO "soldiers" VALUES (3324, '', 4, '', 52, NULL, 8, NULL, 12, 32);
INSERT INTO "soldiers" VALUES (3325, '', 2, '', 72, NULL, 2, 32, 79, 33);
INSERT INTO "soldiers" VALUES (3326, '', 4, '', 71, NULL, 14, 1, 1, 56);
INSERT INTO "soldiers" VALUES (3327, '', 3, '', 67, NULL, 14, 12, 2, 62);
INSERT INTO "soldiers" VALUES (3328, '', 5, '', 170, NULL, 32, 31, 104, 63);
INSERT INTO "soldiers" VALUES (3329, '', 4, '', 63, NULL, 25, 20, 27, 31);
INSERT INTO "soldiers" VALUES (3331, '', 2, '', 67, NULL, 2, NULL, 2, 52);
INSERT INTO "soldiers" VALUES (3332, '', 2, '', 181, NULL, 19, 5, 30, 137);
INSERT INTO "soldiers" VALUES (3333, '', 2, '', 38, NULL, 6, NULL, 3, 26);
INSERT INTO "soldiers" VALUES (3334, '', 1, '', 158, NULL, 21, NULL, 3, 124);
INSERT INTO "soldiers" VALUES (3335, '', 1, '', 131, NULL, 36, 45, 47, 89);
INSERT INTO "soldiers" VALUES (3336, '', 4, '', 79, NULL, 10, 1, 6, 60);
INSERT INTO "soldiers" VALUES (3337, '', 4, '', 148, NULL, 20, NULL, 36, 91);
INSERT INTO "soldiers" VALUES (3338, '', 4, '', 69, NULL, 7, NULL, 6, 54);
INSERT INTO "soldiers" VALUES (3339, '', 1, '', 92, NULL, 17, NULL, 12, 63);
INSERT INTO "soldiers" VALUES (3340, '', 2, '', 43, NULL, 10, 1, 5, 29);
INSERT INTO "soldiers" VALUES (3341, '', 1, '', 123, NULL, 11, 1, 15, 98);
INSERT INTO "soldiers" VALUES (3342, '', 5, '', 130, NULL, 64, 7, 16, 100);
INSERT INTO "soldiers" VALUES (3345, '', 1, '', 93, NULL, 8, 1, 7, 79);
INSERT INTO "soldiers" VALUES (3346, '', 1, '', 41, NULL, 21, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (3347, '', 1, '', 164, NULL, 12, 5, 13, 142);
INSERT INTO "soldiers" VALUES (3348, '', 1, '', 93, NULL, 7, NULL, 6, 82);
INSERT INTO "soldiers" VALUES (3349, '', 9, '', 159, NULL, 14, 1, 27, 113);
INSERT INTO "soldiers" VALUES (3351, '', 3, '', 71, 3, 7, NULL, 3, 62);
INSERT INTO "soldiers" VALUES (3352, '', 7, '', 68, NULL, 7, NULL, 3, 59);
INSERT INTO "soldiers" VALUES (3353, '', 4, '', 152, NULL, 12, 3, 23, 118);
INSERT INTO "soldiers" VALUES (3354, '', 6, '', 67, NULL, 7, NULL, 4, 56);
INSERT INTO "soldiers" VALUES (3355, '', 2, '', 86, NULL, 7, 1, 19, 55);
INSERT INTO "soldiers" VALUES (3356, '', 3, '', 112, NULL, 11, NULL, 10, 91);
INSERT INTO "soldiers" VALUES (3357, '', 1, '', 111, NULL, 9, NULL, 9, 93);
INSERT INTO "soldiers" VALUES (3358, '', 2, '', 143, NULL, 10, 3, 6, 129);
INSERT INTO "soldiers" VALUES (3359, '', 5, '', 63, NULL, 26, 8, 6, 39);
INSERT INTO "soldiers" VALUES (3360, '', 3, '', 132, NULL, 31, 7, 35, 74);
INSERT INTO "soldiers" VALUES (3361, '', 6, '', 160, NULL, 33, 12, 13, 125);
INSERT INTO "soldiers" VALUES (3362, '', 3, '', 69, NULL, 5, 1, 10, 51);
INSERT INTO "soldiers" VALUES (3363, '', 4, '', 67, 19, 26, 18, 19, 40);
INSERT INTO "soldiers" VALUES (3364, '', 1, '', 114, NULL, 10, 3, 1, 99);
INSERT INTO "soldiers" VALUES (3365, '', 2, '', 110, NULL, 41, 27, 23, 72);
INSERT INTO "soldiers" VALUES (3366, '', 6, '', 57, NULL, 7, NULL, 3, 47);
INSERT INTO "soldiers" VALUES (3369, '', 2, '', 143, NULL, 16, 6, 20, 110);
INSERT INTO "soldiers" VALUES (3370, '', 1, '', 172, NULL, 4, 1, 29, 124);
INSERT INTO "soldiers" VALUES (3371, '', 5, '', 151, NULL, 40, 18, 33, 95);
INSERT INTO "soldiers" VALUES (3372, '', 1, '', 166, NULL, 27, 2, 14, 125);
INSERT INTO "soldiers" VALUES (3374, '', 1, '', 126, NULL, 24, NULL, 13, 89);
INSERT INTO "soldiers" VALUES (3375, '', 1, '', 134, NULL, 22, NULL, 28, 84);
INSERT INTO "soldiers" VALUES (3376, '', 6, '', 150, NULL, 25, 1, 37, 88);
INSERT INTO "soldiers" VALUES (3377, '', 2, '', 64, NULL, 8, NULL, 9, 46);
INSERT INTO "soldiers" VALUES (3378, '', 1, '', 166, NULL, 23, 14, 80, 75);
INSERT INTO "soldiers" VALUES (3379, '', 1, '', 122, NULL, 13, 1, 21, 88);
INSERT INTO "soldiers" VALUES (3380, '', 1, '', 86, NULL, 9, NULL, 1, 76);
INSERT INTO "soldiers" VALUES (3381, '', 2, '', 83, NULL, 14, NULL, 9, 60);
INSERT INTO "soldiers" VALUES (3382, '', 2, '', 171, NULL, 21, 4, 44, 105);
INSERT INTO "soldiers" VALUES (3383, '', 2, '', 173, NULL, 18, 27, 60, 117);
INSERT INTO "soldiers" VALUES (3384, '', 2, '', 132, NULL, 13, NULL, 8, 108);
INSERT INTO "soldiers" VALUES (3385, '', 1, '', 126, NULL, 24, NULL, 42, 60);
INSERT INTO "soldiers" VALUES (3387, '', 2, '', 100, NULL, 22, 22, 27, 74);
INSERT INTO "soldiers" VALUES (3388, '', 4, '', 129, NULL, 28, 4, 56, 47);
INSERT INTO "soldiers" VALUES (3390, '', 3, '', 112, NULL, 6, 1, 21, 85);
INSERT INTO "soldiers" VALUES (3391, '', 2, '', 99, NULL, 3, 1, 27, 62);
INSERT INTO "soldiers" VALUES (3392, '', 1, '', 20, NULL, NULL, NULL, 4, 15);
INSERT INTO "soldiers" VALUES (3394, '', 4, '', 86, NULL, 4, NULL, 16, 68);
INSERT INTO "soldiers" VALUES (3395, '', 1, '', 106, NULL, 20, NULL, 7, 69);
INSERT INTO "soldiers" VALUES (3396, '', 1, '', 115, NULL, 35, 30, 17, 91);
INSERT INTO "soldiers" VALUES (3397, '', 2, '', 110, NULL, 29, 29, 63, 67);
INSERT INTO "soldiers" VALUES (3398, '', 1, '', 126, NULL, 28, 2, 19, 80);
INSERT INTO "soldiers" VALUES (3400, '', 2, '', 117, NULL, 23, 2, 8, 87);
INSERT INTO "soldiers" VALUES (3401, '', 2, '', 101, NULL, 2, 12, 56, 55);
INSERT INTO "soldiers" VALUES (3402, '', 3, '', 160, NULL, 72, 55, 54, 89);
INSERT INTO "soldiers" VALUES (3403, '', 1, '', 161, NULL, 21, 3, 12, 131);
INSERT INTO "soldiers" VALUES (3404, '', 1, '', 117, NULL, 20, NULL, 35, 57);
INSERT INTO "soldiers" VALUES (3405, '', 5, '', 148, NULL, 32, NULL, 1, 99);
INSERT INTO "soldiers" VALUES (3406, '', 1, '', 161, NULL, 26, 2, 53, 83);
INSERT INTO "soldiers" VALUES (3407, '', 2, '', 162, NULL, 16, 23, 74, 76);
INSERT INTO "soldiers" VALUES (3408, '', 2, '', 77, NULL, 12, 22, 13, 72);
INSERT INTO "soldiers" VALUES (3409, '', 3, '', 53, NULL, 49, NULL, 1, NULL);
INSERT INTO "soldiers" VALUES (3410, '', 1, '', 133, 43, 8, 11, 20, 120);
INSERT INTO "soldiers" VALUES (3411, '', 1, '', 78, NULL, 27, 40, 30, 63);
INSERT INTO "soldiers" VALUES (3412, '', 1, '', 101, NULL, 21, 40, 27, 86);
INSERT INTO "soldiers" VALUES (3413, '', 1, '', 122, NULL, 23, 50, 18, 131);
INSERT INTO "soldiers" VALUES (3414, '', 1, '', 148, NULL, 39, 31, 29, 110);
INSERT INTO "soldiers" VALUES (3415, '', 4, '', 108, NULL, 42, 40, 22, 83);
INSERT INTO "soldiers" VALUES (3417, '', 2, '', 57, NULL, 21, 15, 14, 37);
INSERT INTO "soldiers" VALUES (3418, '', 2, '', 155, NULL, 23, 7, 50, 89);
INSERT INTO "soldiers" VALUES (3419, '', 1, '', 82, NULL, 17, 1, 9, 57);
INSERT INTO "soldiers" VALUES (3420, '', 3, '', 50, NULL, 23, 3, 12, 18);
INSERT INTO "soldiers" VALUES (3422, '', 4, '', 71, NULL, 28, 6, 17, 27);
INSERT INTO "soldiers" VALUES (3424, '', 6, '', 100, NULL, 50, 21, 53, 40);
INSERT INTO "soldiers" VALUES (3425, '', 1, '', 102, NULL, 28, 12, 31, 55);
INSERT INTO "soldiers" VALUES (3426, '', 3, '', 109, NULL, 32, 9, 28, 57);
INSERT INTO "soldiers" VALUES (3427, '', 1, '', 165, NULL, 5, NULL, 5, 134);
INSERT INTO "soldiers" VALUES (3428, '', 5, '', 92, NULL, 13, 12, 41, 50);
INSERT INTO "soldiers" VALUES (3429, '', 2, '', 100, NULL, 27, 39, 31, 61);
INSERT INTO "soldiers" VALUES (3431, '', 1, '', 132, NULL, 16, 2, 36, 102);
INSERT INTO "soldiers" VALUES (3432, '', 3, '', 78, 7, 9, 3, 7, 65);
INSERT INTO "soldiers" VALUES (3434, '', 4, '', 84, NULL, 22, 4, 21, 45);
INSERT INTO "soldiers" VALUES (3435, '', 2, '', 99, NULL, 24, 9, 7, 62);
INSERT INTO "soldiers" VALUES (3436, '', 2, '', 80, NULL, 6, 3, 26, 46);
INSERT INTO "soldiers" VALUES (3437, '', 1, '', 127, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (3438, '', 1, '', 118, NULL, 23, 3, 37, 59);
INSERT INTO "soldiers" VALUES (3442, '', 2, '', 76, NULL, 18, NULL, 17, 41);
INSERT INTO "soldiers" VALUES (3444, '', 3, '', 57, NULL, 14, NULL, 14, 29);
INSERT INTO "soldiers" VALUES (3446, '', 5, '', 66, NULL, 8, NULL, 9, 48);
INSERT INTO "soldiers" VALUES (3447, '', 4, '', 70, NULL, 4, NULL, 5, 59);
INSERT INTO "soldiers" VALUES (3448, '', 6, '', 123, NULL, 12, 3, 5, 100);
INSERT INTO "soldiers" VALUES (3449, '', 1, '', 123, NULL, 8, 4, 19, 93);
INSERT INTO "soldiers" VALUES (3450, '', 2, '', 112, NULL, 35, 9, 12, 72);
INSERT INTO "soldiers" VALUES (3451, '', 2, '', 104, NULL, 16, 4, 26, 63);
INSERT INTO "soldiers" VALUES (3452, '', 3, '', 83, NULL, 15, 4, 10, 60);
INSERT INTO "soldiers" VALUES (3453, '', 2, '', 85, NULL, 21, 15, 16, 63);
INSERT INTO "soldiers" VALUES (3455, '', 3, '', 75, NULL, 22, 12, 23, 42);
INSERT INTO "soldiers" VALUES (3456, '', 4, '', 95, NULL, 13, 1, 3, 80);
INSERT INTO "soldiers" VALUES (3457, '', 1, '', 76, NULL, 19, 1, 10, 46);
INSERT INTO "soldiers" VALUES (3458, '', 1, '', 95, NULL, 21, 1, 8, 62);
INSERT INTO "soldiers" VALUES (3459, '', 5, '', 68, NULL, 20, 2, 2, 48);
INSERT INTO "soldiers" VALUES (3460, '', 4, '', 69, NULL, 8, 1, 8, 50);
INSERT INTO "soldiers" VALUES (3461, '', 3, '', 164, NULL, 16, 1, 89, 63);
INSERT INTO "soldiers" VALUES (3463, '', 3, '', 111, NULL, 12, 2, 9, 92);
INSERT INTO "soldiers" VALUES (3464, '', 3, '', 107, NULL, 13, NULL, 40, 52);
INSERT INTO "soldiers" VALUES (3465, '', 3, '', 20, 1, 19, NULL, 1, NULL);
INSERT INTO "soldiers" VALUES (3467, '', 6, '', 56, NULL, 9, 2, NULL, 46);
INSERT INTO "soldiers" VALUES (3468, '', 2, '', 82, NULL, 19, 10, 9, 65);
INSERT INTO "soldiers" VALUES (3469, '', 1, '', 104, NULL, 8, NULL, 26, 69);
INSERT INTO "soldiers" VALUES (3470, '', 1, '', 105, NULL, 14, 3, 10, 84);
INSERT INTO "soldiers" VALUES (3471, '', 7, '', 60, NULL, 7, NULL, 3, 50);
INSERT INTO "soldiers" VALUES (3472, '', 2, '', 105, NULL, 24, 10, 15, 75);
INSERT INTO "soldiers" VALUES (3474, '', 5, '', 81, NULL, 21, 1, 10, 51);
INSERT INTO "soldiers" VALUES (3476, '', 1, '', 86, NULL, NULL, 8, 4, 82);
INSERT INTO "soldiers" VALUES (3477, '', 2, '', 86, NULL, 9, 10, 14, 70);
INSERT INTO "soldiers" VALUES (3478, '', 2, '', 83, NULL, 10, 19, 17, 75);
INSERT INTO "soldiers" VALUES (3480, '', 4, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "soldiers" VALUES (3481, '', 2, '', 65, NULL, 4, 8, NULL, 69);
INSERT INTO "soldiers" VALUES (3482, '', 1, '', 106, NULL, 7, 3, 3, 99);
INSERT INTO "soldiers" VALUES (3484, '', 1, '', 81, NULL, 10, 21, 21, 70);
INSERT INTO "soldiers" VALUES (3486, '', 2, '', 84, NULL, 13, 3, 1, 70);
INSERT INTO "soldiers" VALUES (3487, '', 1, '', 92, NULL, 1, NULL, 21, 70);
INSERT INTO "soldiers" VALUES (3488, '', 2, '', 84, NULL, 13, 18, 13, 75);
INSERT INTO "soldiers" VALUES (3489, '', 3, '', 69, NULL, NULL, NULL, 1, 68);
INSERT INTO "soldiers" VALUES (3490, '', 3, '', 84, NULL, 6, NULL, 15, 4);
INSERT INTO "soldiers" VALUES (3491, '', 2, '', 81, NULL, 18, 1, 10, 52);
INSERT INTO "soldiers" VALUES (3492, '', 3, '', 103, NULL, 22, 1, 1, 80);
INSERT INTO "soldiers" VALUES (3495, '', 4, '', 92, NULL, 13, 3, 6, 10);
INSERT INTO "soldiers" VALUES (3496, '', 2, '', 80, NULL, 23, 12, 13, 1);
INSERT INTO "soldiers" VALUES (3497, '', 1, '', 119, NULL, 13, 19, 20, 105);
INSERT INTO "soldiers" VALUES (3498, '', 1, '', 72, NULL, 8, 21, 22, 41);
INSERT INTO "soldiers" VALUES (3499, '', 4, '', 80, NULL, 14, 2, 6, NULL);
INSERT INTO "soldiers" VALUES (3500, '', 3, '', 108, NULL, 17, 2, 17, NULL);
INSERT INTO "soldiers" VALUES (3501, '', 2, '', NULL, NULL, NULL, NULL, NULL, 2);
INSERT INTO "soldiers" VALUES (3502, '', 2, '', 84, NULL, 15, NULL, 22, 46);
INSERT INTO "soldiers" VALUES (3503, '', 2, '', 113, NULL, 20, 8, 3, 2);
INSERT INTO "soldiers" VALUES (3504, '', 2, '', 109, NULL, 9, NULL, 6, 1);
INSERT INTO "soldiers" VALUES (3505, '', 3, '', 86, NULL, 11, 2, 6, 72);
INSERT INTO "soldiers" VALUES (3506, '', 3, '', 103, NULL, 17, 6, 18, 74);
INSERT INTO "soldiers" VALUES (3507, '', 1, '', 109, NULL, 1, 9, 25, 74);
INSERT INTO "soldiers" VALUES (3508, '', 1, '', 106, NULL, 13, 5, 27, 68);
INSERT INTO "soldiers" VALUES (3509, '', 1, '', 104, NULL, 13, 10, 1, 99);
INSERT INTO "soldiers" VALUES (3510, '', 3, '', 98, 2, 11, 1, 2, 15);
INSERT INTO "soldiers" VALUES (3511, '', 3, '', 85, NULL, 14, 4, NULL, NULL);
INSERT INTO "soldiers" VALUES (3512, '', 1, '', 76, NULL, 11, 1, 3, 62);
INSERT INTO "soldiers" VALUES (3514, '', 1, '', 68, NULL, 5, 2, 7, 58);
INSERT INTO "soldiers" VALUES (3515, '', 1, '', 105, NULL, NULL, NULL, NULL, 105);
INSERT INTO "soldiers" VALUES (3517, '', 5, '', 54, 1, 8, 3, 1, 46);
INSERT INTO "soldiers" VALUES (3518, '', 4, '', 65, NULL, NULL, NULL, NULL, 65);
INSERT INTO "soldiers" VALUES (3519, '', 6, '', 68, NULL, NULL, NULL, NULL, 68);
INSERT INTO "soldiers" VALUES (3520, '', 3, '', 113, NULL, 13, 2, 7, 91);
INSERT INTO "soldiers" VALUES (3521, '', 2, '', 87, NULL, 13, 1, 3, 71);
INSERT INTO "soldiers" VALUES (3522, '', 3, '', 85, 2, 13, 15, 2, 84);
INSERT INTO "soldiers" VALUES (3523, '', 4, '', 113, 3, 20, 7, 3, 97);
INSERT INTO "soldiers" VALUES (3524, '', 1, '', 87, NULL, 14, 13, 3, 81);
INSERT INTO "soldiers" VALUES (3525, '', 1, '', 71, NULL, 27, 13, 39, 17);
INSERT INTO "soldiers" VALUES (3526, '', 1, '', 111, 4, 28, 12, 4, 91);
INSERT INTO "soldiers" VALUES (3527, '', 3, '', 86, NULL, 12, 3, 18, 61);
INSERT INTO "soldiers" VALUES (3529, '', 2, '', 77, NULL, 8, 2, 6, 65);
INSERT INTO "soldiers" VALUES (3531, '', 3, '', 72, NULL, 1, NULL, 2, 3);
INSERT INTO "soldiers" VALUES (3532, '', 3, '', 63, NULL, 8, 2, 12, 44);
INSERT INTO "soldiers" VALUES (3534, '', 2, '', 104, NULL, 23, 2, 6, 76);
INSERT INTO "soldiers" VALUES (3535, '', 4, '', 63, NULL, 6, NULL, 2, NULL);
INSERT INTO "soldiers" VALUES (3536, '', 3, '', 92, NULL, 14, NULL, 7, 71);
INSERT INTO "soldiers" VALUES (3537, '', 1, '', 100, NULL, 14, 1, 3, 3);
INSERT INTO "soldiers" VALUES (3538, '', 2, '', 74, NULL, 16, NULL, 7, 51);
INSERT INTO "soldiers" VALUES (3539, '', 1, '', 92, NULL, 21, 3, 12, 61);
INSERT INTO "soldiers" VALUES (3540, '', 1, '', 103, NULL, 28, 4, 4, NULL);
INSERT INTO "soldiers" VALUES (3541, '', 1, '', 148, NULL, 51, 3, 5, 78);
INSERT INTO "soldiers" VALUES (3542, '', 2, '', 131, NULL, 14, 4, 12, 106);
INSERT INTO "soldiers" VALUES (3543, '', 4, '', 153, NULL, 15, NULL, 21, 116);
INSERT INTO "soldiers" VALUES (3544, '', 4, '', 81, NULL, 7, 4, 2, 70);
INSERT INTO "soldiers" VALUES (3546, '', 3, '', 162, NULL, 26, 5, 16, 125);
INSERT INTO "soldiers" VALUES (3547, '', 6, '', 70, NULL, 8, 3, 2, 63);
INSERT INTO "soldiers" VALUES (3548, '', 4, '', 64, NULL, 7, NULL, 3, 54);
INSERT INTO "soldiers" VALUES (3550, '', 2, '', 141, NULL, 15, NULL, 4, 100);
INSERT INTO "soldiers" VALUES (3551, '', 2, '', 83, NULL, 1, 1, 4, 79);
INSERT INTO "soldiers" VALUES (3554, '', 4, '', 84, NULL, 14, 7, 4, 73);
INSERT INTO "soldiers" VALUES (3555, '', 3, '', 84, NULL, 4, 1, 2, 79);
INSERT INTO "soldiers" VALUES (3556, '', 3, '', 96, NULL, 4, NULL, 5, 87);
INSERT INTO "soldiers" VALUES (3558, '', 2, '', 71, NULL, 9, 9, 2, 69);
INSERT INTO "soldiers" VALUES (3559, '', 1, '', 94, NULL, 9, 7, 6, 86);
INSERT INTO "soldiers" VALUES (3560, '', 5, '', 95, NULL, 16, 5, 3, 81);
INSERT INTO "soldiers" VALUES (3561, '', 1, '', 94, NULL, 23, 15, 6, 79);
INSERT INTO "soldiers" VALUES (3562, '', 2, '', 71, NULL, 5, 14, NULL, 80);
INSERT INTO "soldiers" VALUES (3563, '', 1, '', 113, NULL, 7, 14, 33, 78);
INSERT INTO "soldiers" VALUES (3564, '', 2, '', 88, NULL, 12, 11, 6, 81);
INSERT INTO "soldiers" VALUES (3566, '', 1, '', NULL, NULL, NULL, 4, NULL, 4);
INSERT INTO "soldiers" VALUES (3568, '', 5, '', 80, NULL, 17, 1, 14, 54);
INSERT INTO "soldiers" VALUES (3569, '', 1, '', 153, NULL, 14, 8, 14, 132);
INSERT INTO "soldiers" VALUES (3570, '', 1, '', 152, NULL, 26, 3, 7, 122);
INSERT INTO "soldiers" VALUES (3571, '', 1, '', 160, NULL, 10, 4, 17, 134);
INSERT INTO "soldiers" VALUES (3572, '', 1, '', 105, NULL, 20, 1, 4, 81);
INSERT INTO "soldiers" VALUES (3573, '', 1, '', 76, NULL, 8, 5, 6, 66);
INSERT INTO "soldiers" VALUES (3574, '', 1, '', 146, 16, 15, 3, 20, 115);
INSERT INTO "soldiers" VALUES (3575, '', 2, '', 83, NULL, 10, NULL, 5, 67);
INSERT INTO "soldiers" VALUES (3576, '', 2, '', 153, NULL, 10, 3, 10, 134);
INSERT INTO "soldiers" VALUES (3577, '', 3, '', 108, NULL, 18, 10, 5, 94);
INSERT INTO "soldiers" VALUES (3578, '', 3, '', 62, NULL, 3, NULL, NULL, 59);
INSERT INTO "soldiers" VALUES (3579, '', 3, '', 71, NULL, 6, NULL, 20, 45);
INSERT INTO "soldiers" VALUES (3583, '', 2, '', 88, 1, 1, 1, 1, 87);
INSERT INTO "soldiers" VALUES (3584, '', 5, '', 112, 1, 2, NULL, 1, 95);
INSERT INTO "soldiers" VALUES (3585, '', 3, '', 138, NULL, 6, NULL, 24, 108);
INSERT INTO "soldiers" VALUES (3586, '', 3, '', 145, 17, 5, NULL, 17, 70);
INSERT INTO "soldiers" VALUES (3587, '', 2, '', 80, NULL, 4, NULL, 1, 74);
INSERT INTO "soldiers" VALUES (3588, '', 1, '', 109, 2, 10, 1, 2, 97);
INSERT INTO "soldiers" VALUES (3589, '', 4, '', 102, NULL, 8, 3, 4, 93);
INSERT INTO "soldiers" VALUES (3590, '', 1, '', 82, NULL, 24, 18, 3, 73);
INSERT INTO "soldiers" VALUES (3591, '', 5, '', 68, NULL, 10, 1, 4, 55);
INSERT INTO "soldiers" VALUES (3592, '', 2, '', NULL, NULL, NULL, 6, NULL, 5);
INSERT INTO "soldiers" VALUES (3593, '', 4, '', 88, NULL, 12, 4, NULL, 80);
INSERT INTO "soldiers" VALUES (3594, '', 4, '', 119, NULL, 28, 20, NULL, 98);
INSERT INTO "soldiers" VALUES (3595, '', 1, '', 83, NULL, 8, 5, 4, 76);
INSERT INTO "soldiers" VALUES (3596, '', 1, '', 84, NULL, 5, 2, 1, 79);
INSERT INTO "soldiers" VALUES (3597, '', 4, '', 79, NULL, 9, 4, 9, 26);
INSERT INTO "soldiers" VALUES (3598, '', 1, '', 99, NULL, 16, 3, 11, 75);
INSERT INTO "soldiers" VALUES (3599, '', 4, '', 91, NULL, 13, 1, 12, 67);
INSERT INTO "soldiers" VALUES (3600, '', 1, '', 85, NULL, 6, NULL, 9, 50);
INSERT INTO "soldiers" VALUES (3602, '', 2, '', 153, NULL, 24, NULL, 20, 109);
INSERT INTO "soldiers" VALUES (3603, '', 1, '', 154, NULL, 18, 3, 17, 122);
INSERT INTO "soldiers" VALUES (3604, '', 2, '', 149, NULL, 57, 31, 39, 87);
INSERT INTO "soldiers" VALUES (3605, '', 1, '', 151, NULL, 19, 3, 14, 121);
INSERT INTO "soldiers" VALUES (3607, '', 1, '', 154, NULL, 21, NULL, 34, 99);
INSERT INTO "soldiers" VALUES (3608, '', 2, '', 99, NULL, 15, 2, 2, 84);
INSERT INTO "soldiers" VALUES (3610, '', 4, '', 78, NULL, 12, 9, 23, 52);
INSERT INTO "soldiers" VALUES (3612, '', 3, '', 88, NULL, 9, 1, 13, 65);
INSERT INTO "soldiers" VALUES (3613, '', 2, '', 126, NULL, 12, NULL, 5, 108);
INSERT INTO "soldiers" VALUES (3615, '', 3, '', 143, NULL, 37, NULL, 22, 84);
INSERT INTO "soldiers" VALUES (3616, '', 3, '', 77, NULL, NULL, NULL, 6, 71);
INSERT INTO "soldiers" VALUES (3617, '', 1, '', 112, NULL, 5, 9, 6, 110);
INSERT INTO "soldiers" VALUES (3618, '', 3, '', 104, NULL, 3, 9, 9, 100);
INSERT INTO "soldiers" VALUES (3619, '', 3, '', 85, NULL, 10, NULL, 36, 39);
INSERT INTO "soldiers" VALUES (3622, '', 3, '', 95, NULL, 17, 3, 7, 74);
INSERT INTO "soldiers" VALUES (3623, '', 5, '', 75, NULL, 9, NULL, 18, 48);
INSERT INTO "soldiers" VALUES (3624, '', 4, '', 84, NULL, 7, 5, 7, 71);
INSERT INTO "soldiers" VALUES (3625, '', 3, '', 80, NULL, 34, 20, 17, 49);
INSERT INTO "soldiers" VALUES (3626, '', 1, '', 64, 1, 23, 5, 1, 45);
INSERT INTO "soldiers" VALUES (3627, '', 6, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "soldiers" VALUES (3628, '', 3, '', 87, NULL, 4, NULL, NULL, 81);
INSERT INTO "soldiers" VALUES (3629, '', 3, '', 76, NULL, 3, NULL, NULL, 59);
INSERT INTO "soldiers" VALUES (3630, '', 2, '', 86, NULL, 10, 1, 9, 67);
INSERT INTO "soldiers" VALUES (3631, '', 1, '', 143, NULL, 16, 6, 36, 97);
INSERT INTO "soldiers" VALUES (3632, '', 4, '', 147, NULL, 12, 4, 7, 132);
INSERT INTO "soldiers" VALUES (3633, '', 1, '', 142, NULL, 19, 3, 24, NULL);
INSERT INTO "soldiers" VALUES (3634, '', 2, '', 172, 4, 9, 4, 7, 160);
INSERT INTO "soldiers" VALUES (3635, '', 2, '', 79, NULL, 4, 4, 12, 67);
INSERT INTO "soldiers" VALUES (3636, '', 1, '', 150, NULL, 13, 2, 34, NULL);
INSERT INTO "soldiers" VALUES (3637, '', 2, '', 144, NULL, 12, 5, 19, 116);
INSERT INTO "soldiers" VALUES (3638, '', 2, '', 87, NULL, 4, NULL, 1, 79);
INSERT INTO "soldiers" VALUES (3639, '', 1, '', 89, NULL, 6, 1, 12, 72);
INSERT INTO "soldiers" VALUES (3640, '', 4, '', 88, NULL, 8, 12, 26, 66);
INSERT INTO "soldiers" VALUES (3641, '', 2, '', 76, NULL, 9, 1, NULL, 67);
INSERT INTO "soldiers" VALUES (3644, '', 5, '', 146, NULL, 5, 1, 21, 114);
INSERT INTO "soldiers" VALUES (3645, '', 2, '', 148, NULL, 11, 5, 18, 117);
INSERT INTO "soldiers" VALUES (3646, '', 5, '', 141, NULL, 7, NULL, 4, 130);
INSERT INTO "soldiers" VALUES (3647, '', 1, '', 94, NULL, 38, 16, 8, 64);
INSERT INTO "soldiers" VALUES (3649, '', 2, '', 125, NULL, 9, 4, 4, 115);
INSERT INTO "soldiers" VALUES (3650, '', 4, '', 119, NULL, 22, 4, 11, 82);
INSERT INTO "soldiers" VALUES (3651, '', 3, '', 68, NULL, 13, 4, 28, 31);
INSERT INTO "soldiers" VALUES (3652, '', 4, '', 68, NULL, 7, 1, 1, 61);
INSERT INTO "soldiers" VALUES (3653, '', 1, '', 74, NULL, 12, NULL, 9, 51);
INSERT INTO "soldiers" VALUES (3654, '', 1, '', 101, NULL, 39, 21, 23, NULL);
INSERT INTO "soldiers" VALUES (3655, '', 4, '', 117, NULL, 31, 23, 27, NULL);
INSERT INTO "soldiers" VALUES (3656, '', 4, '', 81, NULL, 25, 1, 11, 46);
INSERT INTO "soldiers" VALUES (3657, '', 5, '', 187, 16, 13, NULL, 15, 159);
INSERT INTO "soldiers" VALUES (3658, '', 2, '', 152, NULL, 44, 9, 22, 95);
INSERT INTO "soldiers" VALUES (3659, '', 2, '', 147, NULL, 22, 1, 43, 83);
INSERT INTO "soldiers" VALUES (3660, '', 1, '', 15, NULL, NULL, NULL, NULL, 15);
INSERT INTO "soldiers" VALUES (3661, '', 5, '', 170, 1, 29, 1, 3, 139);
INSERT INTO "soldiers" VALUES (3662, '', 2, '', 88, NULL, 20, 1, 21, 45);
INSERT INTO "soldiers" VALUES (3663, '', 1, '', 88, NULL, 11, 1, 1, 77);
INSERT INTO "soldiers" VALUES (3664, '', 1, '', 132, NULL, 7, NULL, 5, 106);
INSERT INTO "soldiers" VALUES (3666, '', 4, '', 81, 2, 5, NULL, 2, 74);
INSERT INTO "soldiers" VALUES (3667, '', 2, '', 78, NULL, 8, NULL, 1, 68);
INSERT INTO "soldiers" VALUES (3668, '', 1, '', 145, NULL, 21, 2, 5, 119);
INSERT INTO "soldiers" VALUES (3669, '', 2, '', 95, NULL, 4, NULL, 5, 86);
INSERT INTO "soldiers" VALUES (3672, '', 2, '', 91, NULL, 4, NULL, NULL, 78);
INSERT INTO "soldiers" VALUES (3673, '', 3, '', 74, NULL, 8, 8, 8, 65);
INSERT INTO "soldiers" VALUES (3674, '', 5, '', 90, NULL, 16, 20, 11, 82);
INSERT INTO "soldiers" VALUES (3675, '', 3, '', 93, NULL, 11, 13, 3, 91);
INSERT INTO "soldiers" VALUES (3676, '', 4, '', 94, NULL, 15, 18, 3, 94);
INSERT INTO "soldiers" VALUES (3677, '', 2, '', 87, NULL, 86, 5, 1, 5);
INSERT INTO "soldiers" VALUES (3678, '', 6, '', 71, 2, 9, 15, 2, 75);
INSERT INTO "soldiers" VALUES (3680, '', 5, '', 97, NULL, 20, 19, NULL, 96);
INSERT INTO "soldiers" VALUES (3681, '', 4, '', 88, NULL, 11, NULL, 2, 74);
INSERT INTO "soldiers" VALUES (3682, '', 3, '', 91, NULL, 9, 2, 3, 81);
INSERT INTO "soldiers" VALUES (3683, '', 4, '', 100, NULL, 18, 5, 2, 82);
INSERT INTO "soldiers" VALUES (3684, '', 3, '', 102, NULL, 30, 6, 12, 66);
INSERT INTO "soldiers" VALUES (3685, '', 1, '', 151, NULL, 41, 2, 11, 101);
INSERT INTO "soldiers" VALUES (3686, '', 2, '', 142, NULL, 30, 9, 5, 116);
INSERT INTO "soldiers" VALUES (3688, '', 1, '', 76, NULL, 30, 1, 1, 46);
INSERT INTO "soldiers" VALUES (3689, '', 1, '', 146, NULL, 44, 9, 30, 80);
INSERT INTO "soldiers" VALUES (3690, '', 1, '', 144, NULL, 31, 9, 18, 104);
INSERT INTO "soldiers" VALUES (3691, '', 2, '', 63, NULL, 9, 1, 2, 53);
INSERT INTO "soldiers" VALUES (3692, '', 2, '', 158, NULL, 40, 11, 17, 102);
INSERT INTO "soldiers" VALUES (3694, '', 4, '', 75, NULL, 8, 5, 1, 68);
INSERT INTO "soldiers" VALUES (3696, '', 2, '', 93, NULL, 5, 1, 17, 70);
INSERT INTO "soldiers" VALUES (3697, '', 1, '', 77, NULL, 5, NULL, 7, 64);
INSERT INTO "soldiers" VALUES (3698, '', 4, '', 66, 13, 5, 1, 13, 48);
INSERT INTO "soldiers" VALUES (3699, '', 4, '', 72, NULL, 15, 13, 17, 48);
INSERT INTO "soldiers" VALUES (3700, '', 3, '', 99, 40, 13, 11, 40, 54);
INSERT INTO "soldiers" VALUES (3701, '', 1, '', 151, 28, 30, 21, 28, 116);
INSERT INTO "soldiers" VALUES (3703, '', 2, '', 153, NULL, 28, 13, 49, 73);
INSERT INTO "soldiers" VALUES (3704, '', 4, '', 68, NULL, 24, 4, 9, 37);
INSERT INTO "soldiers" VALUES (3705, '', 4, '', 109, NULL, 30, 35, 49, 65);
INSERT INTO "soldiers" VALUES (3706, '', 6, '', 80, NULL, 23, 27, 32, 52);
INSERT INTO "soldiers" VALUES (3707, '', 5, '', 75, 5, 9, 8, 5, 68);
INSERT INTO "soldiers" VALUES (3708, '', 3, '', 93, NULL, 40, NULL, 1, 49);
INSERT INTO "soldiers" VALUES (3709, '', 3, '', 99, NULL, 10, 2, 6, 84);
INSERT INTO "soldiers" VALUES (3710, '', 2, '', 91, NULL, 12, 5, 11, 73);
INSERT INTO "soldiers" VALUES (3711, '', 5, '', 82, NULL, 21, 7, 6, 60);
INSERT INTO "soldiers" VALUES (3712, '', 1, '', 150, NULL, 30, 1, 27, 95);
INSERT INTO "soldiers" VALUES (3713, '', 7, '', 43, NULL, 38, 35, 2, 35);
INSERT INTO "soldiers" VALUES (3714, '', 4, '', 76, 11, 22, 2, 11, 3);
INSERT INTO "soldiers" VALUES (3715, '', 3, '', 76, NULL, 4, 5, 19, 2);
INSERT INTO "soldiers" VALUES (3716, '', 1, '', 142, NULL, NULL, NULL, 67, 67);
INSERT INTO "soldiers" VALUES (3718, '', 3, '', 141, NULL, 9, 31, 34, 107);
INSERT INTO "soldiers" VALUES (3720, '', 3, '', 152, NULL, 43, 9, 43, 73);
INSERT INTO "soldiers" VALUES (3722, '', 1, '', 129, NULL, 38, 2, 22, 70);
INSERT INTO "soldiers" VALUES (3723, '', 1, '', NULL, NULL, NULL, 11, 1, 10);
INSERT INTO "soldiers" VALUES (3724, '', 5, '', 142, NULL, 24, 23, 22, 98);
INSERT INTO "soldiers" VALUES (3725, '', 2, '', 77, NULL, 16, 1, 11, 50);
INSERT INTO "soldiers" VALUES (3726, '', 1, '', 105, NULL, 23, 3, 11, 74);
INSERT INTO "soldiers" VALUES (3727, '', 6, '', 83, NULL, 20, 7, 16, 54);
INSERT INTO "soldiers" VALUES (3728, '', 5, '', 97, NULL, 25, 13, 18, 67);
INSERT INTO "soldiers" VALUES (3729, '', 2, '', 66, NULL, 20, 24, 11, 59);
INSERT INTO "soldiers" VALUES (3730, '', 5, '', 102, NULL, 18, 2, 22, 64);
INSERT INTO "soldiers" VALUES (3731, '', 3, '', 104, NULL, 9, 4, 16, 83);
INSERT INTO "soldiers" VALUES (3732, '', 2, '', 76, NULL, 18, 17, 33, 39);
INSERT INTO "soldiers" VALUES (3733, '', 2, '', 71, NULL, 11, 10, 9, 61);
INSERT INTO "soldiers" VALUES (3734, '', 6, '', 65, NULL, 12, NULL, 7, 45);
INSERT INTO "soldiers" VALUES (3735, '', 4, '', 110, NULL, 24, 20, 49, 58);
INSERT INTO "soldiers" VALUES (3736, '', 2, '', 115, 17, 27, NULL, 17, 67);
INSERT INTO "soldiers" VALUES (3737, '', 3, '', 102, NULL, 19, 14, 45, 54);
INSERT INTO "soldiers" VALUES (3738, '', 4, '', 91, NULL, 11, 4, 9, 74);
INSERT INTO "soldiers" VALUES (3740, '', 3, '', 151, NULL, 19, 12, 51, 38);
INSERT INTO "soldiers" VALUES (3741, '', 1, '', 152, NULL, 41, 3, 28, 62);
INSERT INTO "soldiers" VALUES (3742, '', 2, '', 77, NULL, 9, 5, 22, 51);
INSERT INTO "soldiers" VALUES (3745, '', 2, '', 86, NULL, 16, 35, 14, 88);
INSERT INTO "soldiers" VALUES (3746, '', 4, '', 93, NULL, 22, 45, 24, 10);
INSERT INTO "soldiers" VALUES (3748, '', 1, '', 154, NULL, 11, NULL, 36, 106);
INSERT INTO "soldiers" VALUES (3749, '', 1, '', 143, NULL, 23, 2, 19, 103);
INSERT INTO "soldiers" VALUES (3750, '', 2, '', 145, NULL, 48, 6, 33, 68);
INSERT INTO "soldiers" VALUES (3751, '', 6, '', 87, NULL, 9, NULL, 21, 53);
INSERT INTO "soldiers" VALUES (3752, '', 3, '', 89, NULL, 16, NULL, 4, 69);
INSERT INTO "soldiers" VALUES (3755, '', 2, '', 142, NULL, 14, 9, 48, 73);
INSERT INTO "soldiers" VALUES (3756, '', 2, '', 97, NULL, 27, 13, 10, 73);
INSERT INTO "soldiers" VALUES (3757, '', 3, '', 101, NULL, 2, NULL, 21, 78);
INSERT INTO "soldiers" VALUES (3758, '', 3, '', 84, NULL, 20, 13, 10, 67);
INSERT INTO "soldiers" VALUES (3759, '', 1, '', 65, NULL, 8, NULL, 4, 53);
INSERT INTO "soldiers" VALUES (3760, '', 5, '', 74, NULL, 21, 14, 8, 59);
INSERT INTO "soldiers" VALUES (3761, '', 2, '', 80, NULL, 10, NULL, 4, 64);
INSERT INTO "soldiers" VALUES (3762, '', 6, '', 61, NULL, 10, 8, 11, 41);
INSERT INTO "soldiers" VALUES (3763, '', 5, '', 100, NULL, 4, 7, 12, 81);
INSERT INTO "soldiers" VALUES (3764, '', 6, '', 100, NULL, 26, 15, 40, 43);
INSERT INTO "soldiers" VALUES (3765, '', 2, '', 91, NULL, 17, 6, 13, 66);
INSERT INTO "soldiers" VALUES (3766, '', 3, '', 100, NULL, 36, 5, 5, 64);
INSERT INTO "soldiers" VALUES (3767, '', 1, '', 103, NULL, 34, 18, 27, 60);
INSERT INTO "soldiers" VALUES (3768, '', 4, '', 79, NULL, 12, 1, 2, 55);
INSERT INTO "soldiers" VALUES (3769, '', 5, '', 107, NULL, 12, 1, 3, 86);
INSERT INTO "soldiers" VALUES (3770, '', 1, '', 109, NULL, 32, 2, 10, 15);
INSERT INTO "soldiers" VALUES (3771, '', 3, '', 65, NULL, 5, NULL, 6, 52);
INSERT INTO "soldiers" VALUES (3772, '', 1, '', 110, NULL, 24, NULL, 7, 78);
INSERT INTO "soldiers" VALUES (3773, '', 2, '', 75, NULL, 11, 8, NULL, 72);
INSERT INTO "soldiers" VALUES (3774, '', 2, '', 132, NULL, 26, 13, 24, 94);
INSERT INTO "soldiers" VALUES (3775, '', 5, '', 82, NULL, 12, 6, 3, 73);
INSERT INTO "soldiers" VALUES (3777, '', 2, '', 2, NULL, NULL, NULL, NULL, 2);
INSERT INTO "soldiers" VALUES (3779, '', 2, '', 93, NULL, 17, NULL, 7, 69);
INSERT INTO "soldiers" VALUES (3780, '', 3, '', 88, NULL, 12, 4, 3, 76);
INSERT INTO "soldiers" VALUES (3783, '', 3, '', 101, NULL, 3, NULL, 2, 1);
INSERT INTO "soldiers" VALUES (3784, '', 4, '', 93, NULL, 16, NULL, 16, 72);
INSERT INTO "soldiers" VALUES (3785, '', 3, '', 75, NULL, 6, NULL, 12, 57);
INSERT INTO "soldiers" VALUES (3786, '', 3, '', 52, NULL, 2, NULL, 4, 45);
INSERT INTO "soldiers" VALUES (3787, '', 3, '', 76, 11, 13, 4, 11, 57);
INSERT INTO "soldiers" VALUES (3788, '', 4, '', 109, NULL, 18, 8, 5, 94);
INSERT INTO "soldiers" VALUES (3789, '', 1, '', 83, NULL, 15, 5, 7, 60);
INSERT INTO "soldiers" VALUES (3790, '', 5, '', 67, NULL, 12, 2, 2, 55);
INSERT INTO "soldiers" VALUES (3791, '', 3, '', 102, NULL, 44, 20, 12, 66);
INSERT INTO "soldiers" VALUES (3792, '', 5, '', 101, NULL, 12, 4, 44, 45);
INSERT INTO "soldiers" VALUES (3793, '', 1, '', 63, NULL, 29, 12, 5, 41);
INSERT INTO "soldiers" VALUES (3794, '', 2, '', 83, NULL, 10, 2, 5, 70);
INSERT INTO "soldiers" VALUES (3795, '', 4, '', 104, 4, 7, NULL, 4, 92);
INSERT INTO "soldiers" VALUES (3797, '', 1, '', 142, NULL, 12, NULL, 33, 96);
INSERT INTO "soldiers" VALUES (3798, '', 5, '', 90, NULL, NULL, NULL, 18, 60);
INSERT INTO "soldiers" VALUES (3799, '', 5, '', 62, NULL, 10, 4, 1, 55);
INSERT INTO "soldiers" VALUES (3800, '', 4, '', 135, NULL, 9, 1, 3, 122);
INSERT INTO "soldiers" VALUES (3801, '', 1, '', 131, NULL, 23, NULL, 2, 106);
INSERT INTO "soldiers" VALUES (3804, '', 4, '', 79, NULL, 6, NULL, 6, 56);
INSERT INTO "soldiers" VALUES (3805, '', 7, '', 89, NULL, 25, 10, 23, 42);
INSERT INTO "soldiers" VALUES (3807, '', 5, '', 79, NULL, 9, NULL, 20, 50);
INSERT INTO "soldiers" VALUES (3808, '', 3, '', 87, NULL, 2, NULL, 12, 70);
INSERT INTO "soldiers" VALUES (3809, '', 3, '', 56, NULL, NULL, NULL, NULL, 56);
INSERT INTO "soldiers" VALUES (3810, '', 2, '', 141, NULL, 20, 4, 14, 98);
INSERT INTO "soldiers" VALUES (3811, '', 2, '', 141, NULL, 14, 1, 8, 112);
INSERT INTO "soldiers" VALUES (3812, '', 2, '', 76, NULL, 8, 6, 1, 1);
INSERT INTO "soldiers" VALUES (3813, '', 5, '', 75, NULL, 16, 5, 2, 62);
INSERT INTO "soldiers" VALUES (3814, '', 3, '', 142, NULL, 7, 2, 8, 123);
INSERT INTO "soldiers" VALUES (3815, '', 4, '', 101, NULL, 25, 5, 4, 70);
INSERT INTO "soldiers" VALUES (3816, '', 3, '', 63, NULL, 23, 18, 5, 51);
INSERT INTO "soldiers" VALUES (3817, '', 3, '', 78, NULL, 28, 8, 24, 34);
INSERT INTO "soldiers" VALUES (3818, '', 1, '', 96, NULL, 10, 4, 1, 89);
INSERT INTO "soldiers" VALUES (3819, '', 7, '', 74, NULL, 10, 4, 4, 58);
INSERT INTO "soldiers" VALUES (3820, '', 1, '', 106, NULL, 15, 3, 25, 68);
INSERT INTO "soldiers" VALUES (3821, '', 2, '', 103, NULL, 15, NULL, 14, 62);
INSERT INTO "soldiers" VALUES (3823, '', 4, '', 55, NULL, 48, 1, 5, 3);
INSERT INTO "soldiers" VALUES (3827, '', 6, '', 35, NULL, 10, 1, 6, 16);
INSERT INTO "soldiers" VALUES (3828, '', 2, '', 104, NULL, 72, 1, 11, 19);
INSERT INTO "soldiers" VALUES (3829, '', 4, '', 81, NULL, 31, 4, 24, 27);
INSERT INTO "soldiers" VALUES (3830, '', 4, '', 71, NULL, 51, NULL, 6, 14);
INSERT INTO "soldiers" VALUES (3832, '', 3, '', 51, NULL, 28, NULL, 6, 15);
INSERT INTO "soldiers" VALUES (3833, '', 4, '', 40, NULL, 4, NULL, 11, 24);
INSERT INTO "soldiers" VALUES (3834, '', 3, '', 141, 2, 111, 2, 2, 30);
INSERT INTO "soldiers" VALUES (3835, '', 2, '', 78, 3, 20, 5, 3, 60);
INSERT INTO "soldiers" VALUES (3836, '', 3, '', 151, NULL, 77, 2, 14, 60);
INSERT INTO "soldiers" VALUES (3837, '', 3, '', 80, NULL, 29, NULL, 3, 46);
INSERT INTO "soldiers" VALUES (3838, '', 5, '', 32, NULL, 11, 9, NULL, 30);
INSERT INTO "soldiers" VALUES (3840, '', 5, '', 89, NULL, 23, NULL, 5, 61);
INSERT INTO "soldiers" VALUES (3843, '', 3, '', 87, NULL, 29, 24, 9, 66);
INSERT INTO "soldiers" VALUES (3846, '', 5, '', 102, 4, 12, 19, 4, 100);
INSERT INTO "soldiers" VALUES (3848, '', 3, '', 75, NULL, 12, 3, 5, 61);
INSERT INTO "soldiers" VALUES (3849, '', 4, '', 108, NULL, 70, 1, 11, 27);
INSERT INTO "soldiers" VALUES (3850, '', 1, '', 50, NULL, 11, 10, 4, 45);
INSERT INTO "soldiers" VALUES (3851, '', 5, '', 51, NULL, 2, 1, NULL, NULL);
INSERT INTO "soldiers" VALUES (3853, '', 2, '', 57, NULL, 17, 3, NULL, 42);
INSERT INTO "soldiers" VALUES (3854, '', 3, '', 84, NULL, 36, NULL, 23, 23);
INSERT INTO "soldiers" VALUES (3855, '', 4, '', 89, NULL, 50, 5, 8, 36);
INSERT INTO "soldiers" VALUES (3856, '', 3, '', 112, NULL, 20, 1, 34, 59);
INSERT INTO "soldiers" VALUES (3859, '', 4, '', 83, 2, 31, NULL, 2, 50);
INSERT INTO "soldiers" VALUES (3860, '', 5, '', 123, NULL, 46, 2, 6, 71);
INSERT INTO "soldiers" VALUES (3861, '', 5, '', 120, NULL, 32, 4, 39, 54);
INSERT INTO "soldiers" VALUES (3862, '', 3, '', 65, NULL, 48, 10, 3, 23);
INSERT INTO "soldiers" VALUES (3863, '', 4, '', 111, NULL, 81, 3, 1, 32);
INSERT INTO "soldiers" VALUES (3864, '', 2, '', 29, NULL, 3, 16, 6, 30);
INSERT INTO "soldiers" VALUES (3865, '', 3, '', 93, NULL, 76, 10, 5, 22);
INSERT INTO "soldiers" VALUES (3868, '', 6, '', 185, NULL, 119, 1, 6, 60);
INSERT INTO "soldiers" VALUES (3869, '', 3, '', 37, NULL, 7, 29, 3, 55);
INSERT INTO "soldiers" VALUES (3870, '', 3, '', 48, 3, 43, 1, 3, 2);
INSERT INTO "soldiers" VALUES (3872, '', 5, '', 188, NULL, 14, 27, 51, NULL);
INSERT INTO "soldiers" VALUES (3873, '', 2, '', 104, NULL, 33, 9, 7, 65);
INSERT INTO "soldiers" VALUES (3874, '', 4, '', 184, NULL, 37, 51, 96, NULL);
INSERT INTO "soldiers" VALUES (3875, '', 5, '', 136, NULL, 41, 6, 15, 61);
INSERT INTO "soldiers" VALUES (3876, '', 2, '', 62, NULL, 17, NULL, 11, 36);
INSERT INTO "soldiers" VALUES (3877, '', 3, '', 98, NULL, 13, 1, 4, 82);
INSERT INTO "soldiers" VALUES (3878, '', 1, '', 98, NULL, 32, 14, 5, 65);
INSERT INTO "soldiers" VALUES (3879, '', 1, '', 23, NULL, 3, 1, NULL, 21);
INSERT INTO "soldiers" VALUES (3880, '', 8, '', 81, NULL, 26, 6, 18, 43);
INSERT INTO "soldiers" VALUES (3881, '', 4, '', 100, NULL, 30, 10, 15, 65);
INSERT INTO "soldiers" VALUES (3882, '', 4, '', 49, NULL, 9, 1, 2, 39);
INSERT INTO "soldiers" VALUES (3883, '', 6, '', 24, NULL, 2, 12, 3, 31);
INSERT INTO "soldiers" VALUES (3884, '', 7, '', 60, NULL, 6, 3, 10, 47);
INSERT INTO "soldiers" VALUES (3885, '', 5, '', 143, NULL, 22, 3, 3, 119);
INSERT INTO "soldiers" VALUES (3886, '', 5, '', 44, NULL, 11, 9, 7, 35);
INSERT INTO "soldiers" VALUES (3888, '', 4, '', 91, NULL, 20, 2, 12, 50);
INSERT INTO "soldiers" VALUES (3889, '', 1, '', 82, NULL, 14, NULL, 14, 48);
INSERT INTO "soldiers" VALUES (3891, '', 4, '', 84, NULL, 12, 1, 24, 14);
INSERT INTO "soldiers" VALUES (3892, '', 3, '', 89, NULL, 29, 2, 6, 56);
INSERT INTO "soldiers" VALUES (3893, '', 4, '', 153, NULL, 19, NULL, 27, 107);
INSERT INTO "soldiers" VALUES (3895, '', 6, '', 62, NULL, 11, 13, 3, 61);
INSERT INTO "soldiers" VALUES (3896, '', 4, '', 97, NULL, 28, 10, 30, 48);
INSERT INTO "soldiers" VALUES (3897, '', 1, '', 111, NULL, 29, 18, 26, 74);
INSERT INTO "soldiers" VALUES (3898, '', 5, '', 94, NULL, 31, 24, 17, 66);
INSERT INTO "soldiers" VALUES (3899, '', 3, '', 54, NULL, 20, 41, 24, 51);
INSERT INTO "soldiers" VALUES (3900, '', 4, '', 105, NULL, 30, 1, 9, 65);
INSERT INTO "soldiers" VALUES (3901, '', 5, '', 129, NULL, 35, 31, 31, 94);
INSERT INTO "soldiers" VALUES (3902, '', 4, '', 112, NULL, 28, 41, 46, 79);
INSERT INTO "soldiers" VALUES (3903, '', 5, '', 60, NULL, 40, 5, 6, 19);
INSERT INTO "soldiers" VALUES (3905, '', 1, '', 82, NULL, 26, 29, 16, 69);
INSERT INTO "soldiers" VALUES (3906, '', 2, '', 102, NULL, 47, 16, 14, 57);
INSERT INTO "soldiers" VALUES (3908, '', 3, '', 94, NULL, 13, 1, 7, 75);
INSERT INTO "soldiers" VALUES (3909, '', 3, '', 145, NULL, 39, 2, 16, 92);
INSERT INTO "soldiers" VALUES (3910, '', 6, '', 76, NULL, 9, 12, 8, 71);
INSERT INTO "soldiers" VALUES (3911, '', 3, '', 136, NULL, 99, 3, 19, 20);
INSERT INTO "soldiers" VALUES (3912, '', 3, '', 114, NULL, 38, 1, 3, 74);
INSERT INTO "soldiers" VALUES (3913, '', 1, '', 144, NULL, 33, 2, 22, 91);
INSERT INTO "soldiers" VALUES (3915, '', 1, '', 100, NULL, 27, 1, 12, 62);
INSERT INTO "soldiers" VALUES (3916, '', 1, '', 77, NULL, 18, NULL, 5, 54);
INSERT INTO "soldiers" VALUES (3917, '', 1, '', 120, NULL, 28, NULL, 10, 71);
INSERT INTO "soldiers" VALUES (3919, '', 5, '', 66, NULL, 21, NULL, 19, 26);
INSERT INTO "soldiers" VALUES (3921, '', 1, '', 103, NULL, 44, 1, 25, 4);
INSERT INTO "soldiers" VALUES (3923, '', 4, '', 173, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (3924, '', 1, '', 86, NULL, 21, 15, 9, 71);
INSERT INTO "soldiers" VALUES (3925, '', 6, '', 76, NULL, 7, 4, NULL, 73);
INSERT INTO "soldiers" VALUES (3926, '', 2, '', 128, NULL, 29, 9, 10, 95);
INSERT INTO "soldiers" VALUES (3927, '', 7, '', 150, NULL, 23, 11, 29, 98);
INSERT INTO "soldiers" VALUES (3928, '', 5, '', 98, NULL, 6, NULL, 5, 57);
INSERT INTO "soldiers" VALUES (3929, '', 1, '', 156, NULL, 61, 20, 21, 94);
INSERT INTO "soldiers" VALUES (3930, '', 5, '', 152, NULL, 37, 23, 25, 113);
INSERT INTO "soldiers" VALUES (3931, '', 1, '', 82, NULL, 23, 22, 12, 65);
INSERT INTO "soldiers" VALUES (3932, '', 5, '', 101, NULL, 30, 23, 26, 68);
INSERT INTO "soldiers" VALUES (3933, '', 1, '', 72, NULL, 10, 8, 8, 62);
INSERT INTO "soldiers" VALUES (3934, '', 1, '', 75, NULL, 21, 7, 28, 34);
INSERT INTO "soldiers" VALUES (3935, '', 1, '', 148, NULL, 17, 1, 15, 117);
INSERT INTO "soldiers" VALUES (3936, '', 3, '', 41, NULL, 37, 4, 1, 7);
INSERT INTO "soldiers" VALUES (3937, '', 6, '', 115, NULL, 21, 14, 19, 88);
INSERT INTO "soldiers" VALUES (3938, '', 1, '', 98, NULL, 8, 2, 2, 86);
INSERT INTO "soldiers" VALUES (3939, '', 3, '', 87, NULL, 40, 5, 9, 41);
INSERT INTO "soldiers" VALUES (3940, '', 1, '', 149, NULL, 60, 1, 37, 53);
INSERT INTO "soldiers" VALUES (3941, '', 5, '', 69, NULL, 5, NULL, 4, 60);
INSERT INTO "soldiers" VALUES (3942, '', 1, '', 83, NULL, 16, 19, 33, 51);
INSERT INTO "soldiers" VALUES (3943, '', 5, '', 95, NULL, 17, 1, 21, 58);
INSERT INTO "soldiers" VALUES (3945, '', 4, '', 24, NULL, 4, 3, 1, 22);
INSERT INTO "soldiers" VALUES (3946, '', 2, '', 37, NULL, 2, 1, 3, 31);
INSERT INTO "soldiers" VALUES (3949, '', 1, '', 12, NULL, 5, 4, 1, 10);
INSERT INTO "soldiers" VALUES (3950, '', 3, '', 124, NULL, 43, 12, 7, 86);
INSERT INTO "soldiers" VALUES (3951, '', 4, '', 76, NULL, 5, 7, 1, 77);
INSERT INTO "soldiers" VALUES (3954, '', 2, '', 208, NULL, 201, 42, 8, 41);
INSERT INTO "soldiers" VALUES (3955, '', 1, '', 82, NULL, 14, 17, 9, 76);
INSERT INTO "soldiers" VALUES (3956, '', 2, '', 79, NULL, 19, NULL, 1, 90);
INSERT INTO "soldiers" VALUES (3957, '', 1, '', 100, NULL, 15, 5, 2, 87);
INSERT INTO "soldiers" VALUES (3958, '', 7, '', 58, 2, 5, NULL, 2, 51);
INSERT INTO "soldiers" VALUES (3961, '', 1, '', NULL, NULL, NULL, NULL, NULL, 51);
INSERT INTO "soldiers" VALUES (3968, '', 1, '', NULL, NULL, NULL, NULL, NULL, 79);
INSERT INTO "soldiers" VALUES (3971, '', 3, '', NULL, NULL, NULL, NULL, NULL, 81);
INSERT INTO "soldiers" VALUES (3990, '', 2, '', NULL, NULL, NULL, NULL, NULL, 46);
INSERT INTO "soldiers" VALUES (3991, '', 4, '', NULL, NULL, NULL, NULL, NULL, 54);
INSERT INTO "soldiers" VALUES (3992, '', 3, '', 120, 14, 44, 8, 28, 56);
INSERT INTO "soldiers" VALUES (3995, '', 5, '', 70, 1, 12, 13, 11, 60);
INSERT INTO "soldiers" VALUES (4004, '', 1, '', NULL, NULL, NULL, NULL, NULL, 49);
INSERT INTO "soldiers" VALUES (4006, '', 1, '', NULL, NULL, NULL, NULL, NULL, 13);
INSERT INTO "soldiers" VALUES (4011, '', 5, '', 95, 3, 9, NULL, 21, 65);
INSERT INTO "soldiers" VALUES (4012, '', 5, '', 134, 16, 41, 26, 27, 92);
INSERT INTO "soldiers" VALUES (4016, '', 2, '', NULL, NULL, NULL, NULL, NULL, 82);
INSERT INTO "soldiers" VALUES (4021, '', 3, '', NULL, NULL, NULL, NULL, NULL, 99);
INSERT INTO "soldiers" VALUES (4024, '', 2, '', NULL, NULL, NULL, NULL, NULL, 29);
INSERT INTO "soldiers" VALUES (4026, '', 1, '', NULL, NULL, NULL, NULL, NULL, 74);
INSERT INTO "soldiers" VALUES (4029, '', 7, '', NULL, NULL, NULL, NULL, NULL, 32);
INSERT INTO "soldiers" VALUES (4033, '', 2, '', NULL, NULL, NULL, NULL, NULL, 30);
INSERT INTO "soldiers" VALUES (4038, '', 4, '', NULL, NULL, NULL, NULL, NULL, 49);
INSERT INTO "soldiers" VALUES (4040, '', 6, '', NULL, NULL, NULL, NULL, NULL, 53);
INSERT INTO "soldiers" VALUES (4042, '', 2, '', NULL, NULL, NULL, NULL, NULL, 70);
INSERT INTO "soldiers" VALUES (4043, '', 2, '', NULL, NULL, NULL, NULL, NULL, 39);
INSERT INTO "soldiers" VALUES (4045, '', 4, '', 79, NULL, 2, NULL, NULL, 76);
INSERT INTO "soldiers" VALUES (4046, '', 4, '', NULL, NULL, NULL, NULL, NULL, 66);
INSERT INTO "soldiers" VALUES (4048, '', 5, '', NULL, NULL, NULL, NULL, NULL, 90);
INSERT INTO "soldiers" VALUES (4050, '', 3, '', NULL, NULL, NULL, NULL, NULL, 54);
INSERT INTO "soldiers" VALUES (4054, '', 2, '', NULL, NULL, NULL, NULL, NULL, 55);
INSERT INTO "soldiers" VALUES (4057, '', 4, '', NULL, NULL, NULL, NULL, NULL, 56);
INSERT INTO "soldiers" VALUES (4063, '', 1, '', NULL, NULL, NULL, NULL, NULL, 68);
INSERT INTO "soldiers" VALUES (4070, '', 4, '', NULL, NULL, NULL, NULL, NULL, 115);
INSERT INTO "soldiers" VALUES (4076, '', 5, '', NULL, NULL, NULL, NULL, NULL, 72);
INSERT INTO "soldiers" VALUES (4077, '', 5, '', NULL, NULL, NULL, NULL, NULL, 60);
INSERT INTO "soldiers" VALUES (4078, '', 3, '', 85, NULL, NULL, NULL, NULL, 64);
INSERT INTO "soldiers" VALUES (4080, '', 2, '', 105, NULL, NULL, NULL, NULL, 61);
INSERT INTO "soldiers" VALUES (4081, '', 2, '', 86, NULL, NULL, NULL, NULL, 68);
INSERT INTO "soldiers" VALUES (4082, '', 7, '', NULL, NULL, NULL, NULL, NULL, 91);
INSERT INTO "soldiers" VALUES (4083, '', 6, '', 89, NULL, NULL, NULL, NULL, 30);
INSERT INTO "soldiers" VALUES (4084, '', 4, '', 146, NULL, NULL, NULL, NULL, 76);
INSERT INTO "soldiers" VALUES (4085, '', 4, '', 138, NULL, NULL, NULL, NULL, 53);
INSERT INTO "soldiers" VALUES (4086, '', 2, '', 86, NULL, NULL, NULL, NULL, 58);
INSERT INTO "soldiers" VALUES (4087, '', 1, '', 85, NULL, NULL, NULL, NULL, 49);
INSERT INTO "soldiers" VALUES (4088, '', 2, '', 88, NULL, NULL, NULL, NULL, 34);
INSERT INTO "soldiers" VALUES (4089, '', 2, '', 88, NULL, NULL, NULL, NULL, 38);
INSERT INTO "soldiers" VALUES (4090, '', 5, '', 64, NULL, NULL, NULL, NULL, 42);
INSERT INTO "soldiers" VALUES (4091, '', 3, '', 121, NULL, NULL, NULL, NULL, 55);
INSERT INTO "soldiers" VALUES (4092, '', 2, '', 121, NULL, NULL, NULL, NULL, 59);
INSERT INTO "soldiers" VALUES (4093, '', 1, '', 67, NULL, NULL, NULL, NULL, 35);
INSERT INTO "soldiers" VALUES (4094, '', 2, '', 113, NULL, NULL, NULL, NULL, 67);
INSERT INTO "soldiers" VALUES (4095, '', 1, '', 83, NULL, NULL, NULL, NULL, 32);
INSERT INTO "soldiers" VALUES (4096, '', 4, '', 127, NULL, NULL, NULL, NULL, 58);
INSERT INTO "soldiers" VALUES (4097, '', 4, '', 143, NULL, NULL, NULL, NULL, 74);
INSERT INTO "soldiers" VALUES (4102, '', 3, '', 98, 6, 15, 22, 7, 98);
INSERT INTO "soldiers" VALUES (4103, '', 2, '', 113, 52, 21, 10, 52, 50);
INSERT INTO "soldiers" VALUES (4105, '', 2, '', 64, 18, 31, 34, 18, 49);
INSERT INTO "soldiers" VALUES (4108, '', 3, '', NULL, NULL, NULL, NULL, NULL, 54);
INSERT INTO "soldiers" VALUES (4115, '', 2, '', 153, 47, 25, 1, 52, 77);
INSERT INTO "soldiers" VALUES (4116, '', 4, '', NULL, NULL, NULL, NULL, NULL, 55);
INSERT INTO "soldiers" VALUES (4133, '', 1, '', NULL, NULL, NULL, NULL, NULL, 48);
INSERT INTO "soldiers" VALUES (4138, '', 4, '', NULL, NULL, NULL, NULL, NULL, 65);
INSERT INTO "soldiers" VALUES (4139, '', 2, '', NULL, NULL, NULL, NULL, NULL, 48);
INSERT INTO "soldiers" VALUES (4140, '', 4, '', NULL, NULL, NULL, NULL, NULL, 53);
INSERT INTO "soldiers" VALUES (4145, '', 3, '', NULL, NULL, NULL, NULL, NULL, 33);
INSERT INTO "soldiers" VALUES (4146, '', 1, '', NULL, NULL, NULL, NULL, NULL, 35);
INSERT INTO "soldiers" VALUES (4150, '', 1, '', NULL, NULL, NULL, NULL, NULL, 21);
INSERT INTO "soldiers" VALUES (4156, '', 6, '', 87, NULL, NULL, NULL, NULL, 52);
INSERT INTO "soldiers" VALUES (4168, '', 3, '', 63, NULL, NULL, NULL, NULL, 57);
INSERT INTO "soldiers" VALUES (4170, '', 5, '', 85, NULL, NULL, NULL, NULL, 71);
INSERT INTO "soldiers" VALUES (4172, '', 3, '', 74, NULL, NULL, NULL, NULL, 54);
INSERT INTO "soldiers" VALUES (4173, '', 5, '', 78, NULL, NULL, NULL, NULL, 70);
INSERT INTO "soldiers" VALUES (4174, '', 2, '', 77, NULL, NULL, NULL, NULL, 44);
INSERT INTO "soldiers" VALUES (4175, '', 4, '', 85, NULL, NULL, NULL, NULL, 57);
INSERT INTO "soldiers" VALUES (4177, '', 1, '', NULL, NULL, NULL, NULL, NULL, 37);
INSERT INTO "soldiers" VALUES (4178, '', 1, '', NULL, NULL, NULL, NULL, NULL, 19);
INSERT INTO "soldiers" VALUES (4179, '', 1, '', NULL, NULL, NULL, NULL, NULL, 22);
INSERT INTO "soldiers" VALUES (4180, '', 2, '', 22, NULL, NULL, NULL, NULL, 18);
INSERT INTO "soldiers" VALUES (4181, '', 1, '', 82, NULL, NULL, NULL, NULL, 36);
INSERT INTO "soldiers" VALUES (4182, '', 2, '', 43, NULL, NULL, NULL, NULL, 34);
INSERT INTO "soldiers" VALUES (4184, '', 1, '', 120, NULL, NULL, NULL, NULL, 22);
INSERT INTO "soldiers" VALUES (4185, '', 1, '', 60, NULL, NULL, NULL, NULL, 54);
INSERT INTO "soldiers" VALUES (4186, '', 2, '', 50, NULL, NULL, NULL, NULL, 29);
INSERT INTO "soldiers" VALUES (4187, '', 1, '', 32, NULL, NULL, NULL, NULL, 13);
INSERT INTO "soldiers" VALUES (4188, '', 1, '', NULL, NULL, NULL, NULL, NULL, 57);
INSERT INTO "soldiers" VALUES (4189, '', 1, '', 62, NULL, NULL, NULL, NULL, 22);
INSERT INTO "soldiers" VALUES (4190, '', 4, '', 98, NULL, NULL, NULL, NULL, 16);
INSERT INTO "soldiers" VALUES (4191, '', 2, '', 61, NULL, NULL, NULL, NULL, 46);
INSERT INTO "soldiers" VALUES (4193, '', 3, '', 96, NULL, NULL, NULL, NULL, 76);
INSERT INTO "soldiers" VALUES (4203, '', 3, '', 74, NULL, NULL, NULL, NULL, 52);
INSERT INTO "soldiers" VALUES (4204, '', 4, '', 32, NULL, NULL, NULL, NULL, 28);
INSERT INTO "soldiers" VALUES (4205, '', 5, '', 56, NULL, NULL, NULL, NULL, 55);
INSERT INTO "soldiers" VALUES (4206, '', 5, '', 62, NULL, NULL, NULL, NULL, 67);
INSERT INTO "soldiers" VALUES (4208, '', 1, '', 90, NULL, NULL, NULL, NULL, 87);
INSERT INTO "soldiers" VALUES (4210, '', 1, '', 55, NULL, NULL, NULL, NULL, 52);
INSERT INTO "soldiers" VALUES (4211, '', 6, '', 49, NULL, NULL, NULL, NULL, 42);
INSERT INTO "soldiers" VALUES (4212, '', 4, '', 37, NULL, NULL, NULL, NULL, 47);
INSERT INTO "soldiers" VALUES (4214, '', 4, '', 71, NULL, NULL, NULL, NULL, 51);
INSERT INTO "soldiers" VALUES (4215, '', 1, '', 56, NULL, NULL, NULL, NULL, 50);
INSERT INTO "soldiers" VALUES (4216, '', 6, '', 29, NULL, NULL, NULL, NULL, 24);
INSERT INTO "soldiers" VALUES (4217, '', 1, '', 19, NULL, NULL, NULL, NULL, 17);
INSERT INTO "soldiers" VALUES (4218, '', 2, '', 66, NULL, NULL, NULL, NULL, 47);
INSERT INTO "soldiers" VALUES (4219, '', 1, '', 53, NULL, NULL, NULL, NULL, 36);
INSERT INTO "soldiers" VALUES (4220, '', 1, '', 59, 6, 4, 21, 7, 67);
INSERT INTO "soldiers" VALUES (4221, '', 2, '', 53, NULL, NULL, NULL, NULL, 41);
INSERT INTO "soldiers" VALUES (4222, '', 1, '', 47, NULL, NULL, NULL, NULL, 13);
INSERT INTO "soldiers" VALUES (4223, '', 1, '', 29, NULL, NULL, NULL, NULL, 38);
INSERT INTO "soldiers" VALUES (4225, '', 1, '', NULL, NULL, 4, NULL, 8, 31);
INSERT INTO "soldiers" VALUES (4226, '', 2, '', 57, NULL, NULL, NULL, 14, 43);
INSERT INTO "soldiers" VALUES (4228, '', 3, '', 102, 26, 32, 1, 26, 45);
INSERT INTO "soldiers" VALUES (4231, '', 2, '', 106, 7, 46, 38, 7, 91);
INSERT INTO "soldiers" VALUES (4248, '', 1, '', NULL, NULL, NULL, NULL, NULL, 63);
INSERT INTO "soldiers" VALUES (4250, '', 1, '', NULL, NULL, NULL, NULL, NULL, 44);
INSERT INTO "soldiers" VALUES (4258, '', 1, '', NULL, NULL, NULL, NULL, NULL, 33);
INSERT INTO "soldiers" VALUES (4260, '', 1, '', NULL, NULL, NULL, NULL, NULL, 9);
INSERT INTO "soldiers" VALUES (4262, '', 4, '', 85, NULL, 6, 3, NULL, 82);
INSERT INTO "soldiers" VALUES (4263, '', 4, '', 63, 10, 7, 16, 10, 60);
INSERT INTO "soldiers" VALUES (4264, '', 2, '', 120, 3, 34, 15, 12, 89);
INSERT INTO "soldiers" VALUES (4265, '', 2, '', 91, 6, 13, 5, 6, 77);
INSERT INTO "soldiers" VALUES (4290, '', 4, '', 52, NULL, 13, 9, NULL, 48);
INSERT INTO "soldiers" VALUES (4315, '', 2, '', 115, 3, 21, 7, 3, 98);
INSERT INTO "soldiers" VALUES (4369, '', 6, '', NULL, NULL, NULL, NULL, NULL, 40);
INSERT INTO "soldiers" VALUES (4372, '', 4, '', 56, NULL, NULL, NULL, NULL, 49);
INSERT INTO "soldiers" VALUES (4374, '', 6, '', 25, NULL, NULL, NULL, NULL, 9);
INSERT INTO "soldiers" VALUES (4375, '', 4, '', 32, NULL, NULL, NULL, NULL, 12);
INSERT INTO "soldiers" VALUES (4376, '', 6, '', 51, NULL, NULL, NULL, NULL, 12);
INSERT INTO "soldiers" VALUES (4377, '', 6, '', 53, NULL, NULL, NULL, NULL, 15);
INSERT INTO "soldiers" VALUES (4378, '', 4, '', 39, NULL, NULL, NULL, NULL, 24);
INSERT INTO "soldiers" VALUES (4380, '', 1, '', 83, NULL, NULL, NULL, NULL, 58);
INSERT INTO "soldiers" VALUES (4382, '', 3, '', 50, NULL, NULL, NULL, NULL, 40);
INSERT INTO "soldiers" VALUES (4384, '', 3, '', 21, NULL, NULL, NULL, NULL, 21);
INSERT INTO "soldiers" VALUES (4385, '', 1, '', 60, NULL, NULL, NULL, NULL, 38);
INSERT INTO "soldiers" VALUES (4387, '', 5, '', 5, NULL, NULL, NULL, NULL, 4);
INSERT INTO "soldiers" VALUES (4388, '', 2, '', 39, NULL, NULL, NULL, NULL, 22);
INSERT INTO "soldiers" VALUES (4392, '', 5, '', 111, NULL, NULL, NULL, NULL, 113);
INSERT INTO "soldiers" VALUES (4395, '', 2, '', 16, NULL, NULL, 79, NULL, 113);
INSERT INTO "soldiers" VALUES (4396, '', 1, '', 143, NULL, NULL, 96, NULL, 160);
INSERT INTO "soldiers" VALUES (4398, '', 3, '', 74, NULL, NULL, 100, NULL, 138);
INSERT INTO "soldiers" VALUES (4411, '', 1, '', 135, NULL, NULL, NULL, NULL, 118);
INSERT INTO "soldiers" VALUES (4415, '', 1, '', 98, NULL, NULL, NULL, NULL, 57);
INSERT INTO "soldiers" VALUES (4417, '', 4, '', 50, 12, 18, 60, 13, 79);
INSERT INTO "soldiers" VALUES (4427, '', 1, '', 36, NULL, NULL, NULL, NULL, 87);
INSERT INTO "soldiers" VALUES (4429, '', 5, '', 59, NULL, NULL, NULL, NULL, 1);
INSERT INTO "soldiers" VALUES (4432, '', 1, '', 64, 6, 31, 73, 6, 100);
INSERT INTO "soldiers" VALUES (4433, '', 1, '', 27, NULL, NULL, NULL, NULL, 21);
INSERT INTO "soldiers" VALUES (4436, '', 1, '', 24, NULL, 3, NULL, 1, 20);
INSERT INTO "soldiers" VALUES (4443, '', 1, '', 1, NULL, NULL, NULL, NULL, 1);
INSERT INTO "soldiers" VALUES (4445, '', 1, '', 71, NULL, NULL, NULL, NULL, 62);
INSERT INTO "soldiers" VALUES (4447, '', 1, '', 136, NULL, NULL, NULL, NULL, 126);
INSERT INTO "soldiers" VALUES (4493, '', 7, '', 17, NULL, NULL, NULL, NULL, 12);
INSERT INTO "soldiers" VALUES (4519, '', 2, '', NULL, NULL, NULL, NULL, NULL, 53);
INSERT INTO "soldiers" VALUES (4524, '', 1, '', 193, NULL, NULL, NULL, NULL, 97);
INSERT INTO "soldiers" VALUES (4529, '', 1, '', 81, NULL, NULL, NULL, NULL, 67);
INSERT INTO "soldiers" VALUES (4539, '', 1, '', NULL, NULL, NULL, NULL, NULL, 53);
INSERT INTO "soldiers" VALUES (4542, '', 1, '', 115, NULL, NULL, NULL, NULL, 55);
INSERT INTO "soldiers" VALUES (4559, '', 1, '', 51, NULL, NULL, NULL, NULL, 55);
INSERT INTO "soldiers" VALUES (4560, '', 2, '', 49, NULL, NULL, NULL, NULL, 47);
INSERT INTO "soldiers" VALUES (4562, '', 1, '', 117, NULL, NULL, NULL, NULL, 71);
INSERT INTO "soldiers" VALUES (4574, '', 2, '', 97, NULL, NULL, NULL, NULL, 66);
INSERT INTO "soldiers" VALUES (4575, '', 1, '', 33, NULL, NULL, NULL, NULL, 14);
INSERT INTO "soldiers" VALUES (4576, '', 1, '', 51, NULL, NULL, NULL, NULL, 33);
INSERT INTO "soldiers" VALUES (4586, '', 1, '', 77, NULL, NULL, NULL, NULL, 41);
INSERT INTO "soldiers" VALUES (4587, '', 2, '', 82, NULL, NULL, NULL, NULL, 57);
INSERT INTO "soldiers" VALUES (4606, '', 2, '', 101, NULL, NULL, NULL, NULL, 77);
INSERT INTO "soldiers" VALUES (4607, '', 5, '', 113, NULL, NULL, NULL, NULL, 90);
INSERT INTO "soldiers" VALUES (4611, '', 2, '', 72, NULL, NULL, NULL, NULL, 43);
INSERT INTO "soldiers" VALUES (4612, '', 2, '', 39, NULL, NULL, NULL, NULL, 38);
INSERT INTO "soldiers" VALUES (4613, '', 1, '', 116, NULL, NULL, NULL, NULL, 81);
INSERT INTO "soldiers" VALUES (4616, '', 1, '', 77, NULL, NULL, NULL, NULL, 42);
INSERT INTO "soldiers" VALUES (4617, '', 2, '', 31, NULL, NULL, NULL, NULL, 32);
INSERT INTO "soldiers" VALUES (4618, '', 1, '', 116, NULL, NULL, NULL, NULL, 89);
INSERT INTO "soldiers" VALUES (4620, '', 1, '', 67, NULL, NULL, NULL, NULL, 53);
INSERT INTO "soldiers" VALUES (4621, '', 3, '', 73, NULL, NULL, NULL, NULL, 70);
INSERT INTO "soldiers" VALUES (4622, '', 1, '', 61, NULL, NULL, NULL, NULL, 36);
INSERT INTO "soldiers" VALUES (4623, '', 1, '', 89, NULL, NULL, NULL, NULL, 67);
INSERT INTO "soldiers" VALUES (4624, '', 3, '', 78, NULL, NULL, NULL, NULL, 53);
INSERT INTO "soldiers" VALUES (4625, '', 2, '', 78, NULL, NULL, NULL, NULL, 84);
INSERT INTO "soldiers" VALUES (4628, '', 1, '', 123, NULL, NULL, NULL, NULL, 58);
INSERT INTO "soldiers" VALUES (4629, '', 3, '', 10, NULL, NULL, NULL, NULL, 23);
INSERT INTO "soldiers" VALUES (4631, '', 1, '', 101, NULL, NULL, NULL, NULL, 74);
INSERT INTO "soldiers" VALUES (4633, '', 4, '', 42, NULL, NULL, NULL, NULL, 24);
INSERT INTO "soldiers" VALUES (4634, '', 1, '', 81, NULL, NULL, NULL, NULL, 75);
INSERT INTO "soldiers" VALUES (4639, '', 3, '', 103, NULL, NULL, NULL, NULL, 57);
INSERT INTO "soldiers" VALUES (4640, '', 4, '', 106, NULL, NULL, NULL, NULL, 40);
INSERT INTO "soldiers" VALUES (4642, '', 2, '', 44, NULL, NULL, NULL, NULL, 34);
INSERT INTO "soldiers" VALUES (4643, '', 3, '', 41, NULL, NULL, NULL, NULL, 31);
INSERT INTO "soldiers" VALUES (4645, '', 1, '', 69, NULL, NULL, NULL, NULL, 53);
INSERT INTO "soldiers" VALUES (4646, '', 2, '', 96, NULL, NULL, NULL, NULL, 67);
INSERT INTO "soldiers" VALUES (4650, '', 1, '', 92, NULL, NULL, NULL, NULL, 68);
INSERT INTO "soldiers" VALUES (4651, '', 1, '', 82, NULL, NULL, NULL, NULL, 60);
INSERT INTO "soldiers" VALUES (4652, '', 3, '', 79, NULL, NULL, NULL, NULL, 66);
INSERT INTO "soldiers" VALUES (4653, '', 2, '', 55, NULL, NULL, NULL, NULL, 21);
INSERT INTO "soldiers" VALUES (4655, '', 2, '', 9, NULL, NULL, NULL, NULL, 21);
INSERT INTO "soldiers" VALUES (4656, '', 2, '', 5, NULL, NULL, NULL, NULL, 12);
INSERT INTO "soldiers" VALUES (4658, '', 2, '', 107, NULL, NULL, NULL, NULL, 55);
INSERT INTO "soldiers" VALUES (4659, '', 1, '', 65, NULL, NULL, NULL, NULL, 41);
INSERT INTO "soldiers" VALUES (4660, '', 1, '', 103, NULL, NULL, NULL, NULL, 50);
INSERT INTO "soldiers" VALUES (4662, '', 1, '', 67, NULL, NULL, NULL, NULL, 36);
INSERT INTO "soldiers" VALUES (4663, '', 2, '', 77, NULL, NULL, NULL, NULL, 38);
INSERT INTO "soldiers" VALUES (4668, '', 1, '', 88, NULL, NULL, NULL, NULL, 88);
INSERT INTO "soldiers" VALUES (4669, '', 3, '', 101, NULL, NULL, NULL, NULL, 59);
INSERT INTO "soldiers" VALUES (4670, '', 2, '', 75, NULL, NULL, NULL, NULL, 51);
INSERT INTO "soldiers" VALUES (4672, '', 2, '', 63, NULL, NULL, NULL, NULL, 56);
INSERT INTO "soldiers" VALUES (4673, '', 3, '', 113, NULL, NULL, NULL, NULL, 95);
INSERT INTO "soldiers" VALUES (4693, '', 1, '', 60, NULL, NULL, NULL, NULL, 187);
INSERT INTO "soldiers" VALUES (4695, '', 2, '', NULL, NULL, NULL, 32, NULL, 32);
INSERT INTO "soldiers" VALUES (4697, '', 4, '', 1, NULL, NULL, NULL, NULL, 97);
INSERT INTO "soldiers" VALUES (4699, '', 2, '', NULL, NULL, NULL, NULL, NULL, 12);
INSERT INTO "soldiers" VALUES (4701, '', 2, '', NULL, NULL, NULL, NULL, NULL, 13);
INSERT INTO "soldiers" VALUES (4703, '', 3, '', 1, NULL, NULL, NULL, NULL, 41);
INSERT INTO "soldiers" VALUES (4704, '', 2, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "soldiers" VALUES (4705, '', 1, '', NULL, NULL, NULL, NULL, NULL, 90);
INSERT INTO "soldiers" VALUES (4708, '', 3, '', NULL, NULL, NULL, NULL, NULL, 22);
INSERT INTO "soldiers" VALUES (4709, '', 1, '', NULL, NULL, NULL, NULL, NULL, 3);
INSERT INTO "soldiers" VALUES (4712, '', 1, '', 29, NULL, NULL, NULL, NULL, 25);
INSERT INTO "soldiers" VALUES (4714, '', 1, '', NULL, NULL, NULL, NULL, NULL, 1);
INSERT INTO "soldiers" VALUES (4726, '', 2, '', 85, NULL, NULL, NULL, NULL, 75);
INSERT INTO "soldiers" VALUES (4750, '', 3, '', 75, NULL, NULL, NULL, NULL, 49);
INSERT INTO "soldiers" VALUES (4751, '', 1, '', 61, NULL, NULL, NULL, NULL, 52);
INSERT INTO "soldiers" VALUES (4755, '', 1, '', 14, NULL, NULL, NULL, NULL, 10);
INSERT INTO "soldiers" VALUES (4756, '', 5, '', NULL, NULL, NULL, NULL, NULL, 5);
INSERT INTO "soldiers" VALUES (4759, '', 1, '', 9, NULL, NULL, NULL, NULL, 8);
INSERT INTO "soldiers" VALUES (4760, '', 1, '', 16, NULL, NULL, NULL, NULL, 25);
INSERT INTO "soldiers" VALUES (4762, '', 1, '', 43, NULL, NULL, NULL, NULL, 41);
INSERT INTO "soldiers" VALUES (4769, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (4775, '', 3, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (4781, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (4782, '', 1, '', 39, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (4785, '', 2, '', 42, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (4788, '', 1, '', 52, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (4789, '', 1, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5382, '', 5, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5383, '', 5, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5384, '', 4, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5385, '', 8, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5401, '', 5, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5402, '', 1, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5403, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5404, '', 6, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5405, '', 5, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5446, '', 3, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5655, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5660, '', 3, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5661, '', 1, '', 134, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5662, '', 5, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5663, '', 2, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5664, '', 3, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5665, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5666, '', 3, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5670, '', 1, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5671, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5673, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5676, '', 1, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5677, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5678, '', 1, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5679, '', 1, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5680, '', 1, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5681, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5682, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5683, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5685, '', 1, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5686, '', 3, '', 45, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5687, '', 3, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5690, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5692, '', 2, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5693, '', 3, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5694, '', 1, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5695, '', 1, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5696, '', 3, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5697, '', 3, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5698, '', 4, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5699, '', 3, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5702, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5703, '', 2, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5704, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5705, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5706, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5707, '', 2, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5708, '', 1, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5709, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5710, '', 4, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5711, '', 4, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5712, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5714, '', 4, '', 37, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5715, '', 1, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5716, '', 1, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5717, '', 1, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5720, '', 2, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5721, '', 2, '', 46, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5722, '', 2, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5723, '', 2, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5724, '', 2, '', 40, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5725, '', 1, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5726, '', 2, '', 37, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5727, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5729, '', 1, '', 36, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5732, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5733, '', 3, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5734, '', 2, '', 39, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5735, '', 1, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5736, '', 1, '', 36, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5737, '', 4, '', 36, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5738, '', 2, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5740, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5741, '', 4, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5742, '', 3, '', 37, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5743, '', 1, '', 37, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5744, '', 4, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5745, '', 4, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5746, '', 2, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5747, '', 2, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5748, '', 2, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5750, '', 4, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5751, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5752, '', 5, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5755, '', 3, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5757, '', 2, '', 35, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5758, '', 5, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5759, '', 5, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5760, '', 1, '', 35, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5761, '', 2, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5762, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5764, '', 2, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5765, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5766, '', 1, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5767, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5768, '', 4, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5769, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5770, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5771, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5772, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5773, '', 2, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5774, '', 5, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5776, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5777, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5778, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5779, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5780, '', 3, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5781, '', 5, '', 34, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5782, '', 4, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5783, '', 4, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5784, '', 6, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5785, '', 3, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5786, '', 5, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5787, '', 1, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5788, '', 6, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5792, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5793, '', 3, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5794, '', 1, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5795, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5796, '', 6, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5802, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5806, '', 1, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5807, '', 3, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5808, '', 5, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5809, '', 2, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5810, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5811, '', 2, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5813, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5815, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5818, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5819, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5822, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5823, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5824, '', 1, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5825, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5826, '', 1, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5827, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5829, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5830, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5831, '', 4, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5832, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5833, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5834, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5835, '', 1, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5836, '', 1, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5837, '', 3, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5838, '', 1, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5839, '', 1, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5840, '', 2, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5847, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5848, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5849, '', 4, '', 30, 3, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5850, '', 3, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5851, '', 2, '', 40, 9, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5852, '', 1, '', 25, 1, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5853, '', 2, '', 31, 2, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5854, '', 2, '', 33, 4, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5856, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5862, '', 2, '', 26, 1, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5873, '', 6, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5879, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5880, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5882, '', 3, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5887, '', 3, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5888, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5889, '', 4, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5890, '', 4, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5891, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5894, '', 3, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5895, '', 4, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5896, '', 1, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5897, '', 1, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5898, '', 2, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5899, '', 3, '', 54, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5900, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5901, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5902, '', 3, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5903, '', 2, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5905, '', 2, '', 35, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5906, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5907, '', 2, '', 38, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5908, '', 4, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5909, '', 1, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5910, '', 3, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5912, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5913, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5914, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5915, '', 2, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5916, '', 1, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5917, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5918, '', 3, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5919, '', 3, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5920, '', 3, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5921, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5922, '', 4, '', 39, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5923, '', 1, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5924, '', 1, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5925, '', 1, '', 34, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5926, '', 2, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5927, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5930, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5931, '', 1, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5932, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5933, '', 3, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5934, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5935, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5936, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5937, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5938, '', 1, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5939, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5940, '', 3, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5941, '', 1, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5942, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5947, '', 1, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5948, '', 1, '', 38, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5950, '', 2, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5951, '', 1, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5952, '', 4, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5953, '', 1, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5954, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5955, '', 1, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5956, '', 2, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5957, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5958, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5959, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5960, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5962, '', 5, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5963, '', 1, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5964, '', 2, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5965, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5966, '', 1, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5967, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5968, '', 2, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5969, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5970, '', 3, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5971, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5972, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5973, '', 2, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5976, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5981, '', 1, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5982, '', 1, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5983, '', 1, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5984, '', 1, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5985, '', 2, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5986, '', 2, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5987, '', 1, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5987, 'A', 2, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5988, '', 4, '', 38, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5989, '', 2, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5993, '', 2, '', 34, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5994, '', 2, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5997, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (5999, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6000, '', 2, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6001, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6002, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6003, '', 2, '', 38, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6004, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6005, '', 1, '', 34, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6006, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6009, '', 2, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6010, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6016, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6018, '', 1, '', 41, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6019, '', 3, '', 40, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6020, '', 2, '', 40, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6021, '', 3, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6022, '', 3, '', 41, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6023, '', 4, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6024, '', 5, '', 51, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6025, '', 4, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6026, '', 3, '', 39, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6032, '', 1, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6033, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6034, '', 3, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6035, '', 2, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6037, '', 3, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6038, '', 3, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6039, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6040, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6041, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6042, '', 2, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6043, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6044, '', 1, '', 35, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6045, '', 3, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6046, '', 2, '', 35, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6047, '', 1, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6048, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6053, '', 3, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6054, '', 2, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6055, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6056, '', 1, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6057, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6058, '', 4, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6059, '', 3, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6060, '', 4, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6061, '', 3, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6062, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6063, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6064, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6065, '', 3, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6066, '', 1, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6067, '', 5, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6070, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6073, '', 3, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6074, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6075, '', 2, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6076, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6077, '', 1, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6078, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6079, '', 3, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6080, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6081, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6082, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6083, '', 4, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6084, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6085, '', 4, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6086, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6087, '', 4, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6088, '', 4, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6089, '', 6, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6094, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6095, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6096, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6097, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6098, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6099, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6100, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6101, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6102, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6103, '', 3, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6104, '', 1, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6105, '', 2, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6106, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6112, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6113, '', 5, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6114, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6115, '', 3, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6116, '', 2, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6118, '', 3, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6119, '', 4, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6120, '', 3, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6121, '', 3, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6122, '', 2, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6123, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6124, '', 1, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6125, '', 4, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6126, '', 1, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6130, '', 4, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6131, '', 2, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6132, '', 1, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6133, '', 5, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6136, '', 4, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6137, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6138, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6139, '', 2, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6140, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6141, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6142, '', 5, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6143, '', 4, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6144, '', 3, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6149, '', 2, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6150, '', 4, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6151, '', 3, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6153, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6154, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6155, '', 5, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6156, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6157, '', 3, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6158, '', 1, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6165, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6166, '', 1, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6167, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6169, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6170, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6171, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6172, '', 2, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6173, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6174, '', 5, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6175, '', 5, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6176, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6177, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6185, '', 1, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6187, '', 1, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6188, '', 1, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6189, '', 1, '', 34, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6190, '', 1, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6191, '', 4, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6192, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6193, '', 1, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6194, '', 3, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6195, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6201, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6202, '', 1, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6203, '', 1, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6204, '', 2, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6209, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6210, '', 6, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6211, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6212, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6215, '', 1, '', 35, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6216, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6217, '', 6, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6218, '', 1, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6219, '', 5, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6227, '', 3, '', 90, 5, 3, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6228, '', 1, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6229, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6230, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6231, '', 1, '', 65, 4, 7, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6233, '', 2, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6234, '', 4, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6235, '', 2, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6236, '', 2, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6237, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6238, '', 1, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6239, '', 6, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6240, '', 1, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6241, '', 2, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6248, '', 1, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6249, '', 2, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6251, '', 1, '', 35, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6252, '', 4, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6253, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6254, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6256, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6257, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6258, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6259, '', 6, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6260, '', 5, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6261, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6269, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6270, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6271, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6273, '', 3, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6274, '', 2, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6275, '', 7, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6276, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6277, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6279, '', 2, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6280, '', 2, '', 35, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6281, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6286, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6287, '', 4, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6288, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6290, '', 4, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6291, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6292, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6293, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6294, '', 3, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6295, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6296, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6297, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6298, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6299, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6300, '', 2, '', 27, NULL, 17, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6307, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6308, '', 6, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6309, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6310, '', 4, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6311, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6312, '', 6, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6313, '', 2, '', 34, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6314, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6315, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6316, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6317, '', 8, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6318, '', 5, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6319, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6320, '', 6, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6321, '', 2, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6322, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6323, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6325, '', 5, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6334, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6335, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6336, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6340, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6341, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6343, '', 1, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6344, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6345, '', 3, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6346, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6347, '', 2, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6349, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6350, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6351, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6352, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6353, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6354, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6355, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6356, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6362, '', 5, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6363, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6364, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6367, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6368, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6369, '', 4, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6370, '', 4, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6371, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6372, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6373, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6375, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6376, '', 5, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6377, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6378, '', 6, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6379, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6381, '', 7, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6382, '', 6, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6383, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6384, '', 1, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6385, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6386, '', 2, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6387, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6388, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6389, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6390, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6391, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6396, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6397, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6398, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6399, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6400, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6401, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6402, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6403, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6404, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6406, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6407, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6408, '', 2, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6415, '', 1, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6416, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6418, '', 4, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6419, '', 4, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6420, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6421, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6422, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6423, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6424, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6425, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6426, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6427, '', 4, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6430, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6431, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6432, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6433, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6434, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6445, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6454, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6455, '', 4, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6456, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6457, '', 6, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6458, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6459, '', 5, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6460, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6461, '', 4, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6463, '', 5, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6464, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6465, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6466, '', 5, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6467, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6468, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6469, '', 4, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6470, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6471, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6487, '', 6, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6488, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6489, '', 4, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6490, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6491, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6493, '', 5, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6494, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6495, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6496, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6497, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6498, '', 5, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6499, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6500, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6501, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6503, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6504, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6505, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6506, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6508, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6510, '', 4, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6512, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6513, '', 5, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6521, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6522, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6523, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6524, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6525, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6526, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6527, '', 6, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6528, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6530, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6531, '', 5, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6532, '', 6, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6533, '', 4, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6534, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6535, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6536, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6537, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6551, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6574, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6575, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6576, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6577, '', 4, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6578, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6579, '', 4, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6580, '', 6, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6581, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6582, '', 4, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6583, '', 5, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6589, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6590, '', 4, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6591, '', 2, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6592, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6593, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6594, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6595, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6596, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6597, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6599, '', 4, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6631, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6632, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6635, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6665, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6666, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6667, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6668, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6669, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6671, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6672, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6673, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6674, '', 5, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6675, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6676, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6677, '', 4, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6678, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6679, '', 3, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6680, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6681, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6682, '', 6, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6683, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6684, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6695, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6701, '', 2, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6702, '', 1, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6703, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6704, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6705, '', 5, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6708, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6709, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6710, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6711, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6712, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6713, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6714, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6715, '', 8, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6716, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6717, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6718, '', 5, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6719, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6730, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6731, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6732, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6733, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6735, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6736, '', 3, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6737, '', 4, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6738, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6739, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6740, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6741, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6742, '', 5, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6743, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6744, '', 7, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6745, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6750, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6752, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6753, '', 6, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6761, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6773, '', 1, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6774, '', 6, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6776, '', 4, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6778, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6792, '', 5, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6793, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6794, '', 5, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6796, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6797, '', 7, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6798, '', 4, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6799, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6800, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6801, '', 8, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6802, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6803, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6804, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6805, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6807, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6813, '', 5, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6814, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6816, '', 4, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6817, '', 5, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6818, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6819, '', 4, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6820, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6821, '', 5, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6822, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6823, '', 7, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6824, '', 4, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6825, '', 5, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6826, '', 5, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6827, '', 6, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6828, '', 6, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6836, '', 7, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6837, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6838, '', 4, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6839, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6840, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6841, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6842, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6843, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6844, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6846, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6847, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6848, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6849, '', 4, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6850, '', 4, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6851, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6852, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6853, '', 4, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6854, '', 5, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6856, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6857, '', 5, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6858, '', 5, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6859, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6860, '', 8, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6861, '', 5, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6862, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6863, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6870, '', 6, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6871, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6872, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6873, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6874, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6876, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6877, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6878, '', 6, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6879, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6880, '', 4, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6881, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6882, '', 7, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6883, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6884, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6885, '', 6, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6886, '', 4, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6888, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6891, '', 6, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6892, '', 5, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6895, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6904, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6905, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6907, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6908, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6910, '', 3, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6911, '', 5, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6912, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6913, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6914, '', 9, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6915, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6916, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6917, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6918, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6919, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6920, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6921, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6923, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6924, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6925, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6932, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6933, '', 6, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6937, '', 6, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6938, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6939, '', 5, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6941, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6942, '', 6, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6943, '', 4, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6944, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6945, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6946, '', 7, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6947, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6952, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6953, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6954, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6955, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6956, '', 5, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6957, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6958, '', 5, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6959, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6960, '', 5, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6961, '', 5, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6962, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6963, '', 5, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6967, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6968, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6969, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6970, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6971, '', 5, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6972, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6973, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6974, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6975, '', 6, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6976, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6977, '', 6, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6978, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6979, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6983, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6984, '', 3, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6985, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6986, '', 10, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6988, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6989, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6990, '', 5, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6991, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6992, '', 3, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6993, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (6998, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7000, '', 6, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7002, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7005, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7006, '', 6, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7007, '', 4, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7008, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7009, '', 5, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7010, '', 4, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7011, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7012, '', 6, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7013, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7014, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7015, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7017, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7023, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7024, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7025, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7026, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7027, '', 7, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7028, '', 5, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7029, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7030, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7031, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7035, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7036, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7037, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7038, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7041, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7042, '', 7, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7043, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7044, '', 7, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7045, '', 7, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7046, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7047, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7048, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7049, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7050, '', 6, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7051, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7057, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7058, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7059, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7060, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7061, '', 5, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7062, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7068, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7069, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7070, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7071, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7072, '', 6, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7075, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7076, '', 4, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7077, '', 4, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7078, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7079, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7080, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7085, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7086, '', 6, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7087, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7088, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7089, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7091, '', 3, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7092, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7093, '', 7, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7094, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7095, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7096, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7097, '', 6, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7098, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7099, '', 7, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7103, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7104, '', 7, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7105, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7106, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7107, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7108, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7109, '', 1, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7110, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7115, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7116, '', 4, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7119, '', 3, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7121, '', 5, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7123, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7125, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7130, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7151, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7152, '', 6, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7153, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7154, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7177, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7178, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7179, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7180, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7181, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7182, '', 5, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7183, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7184, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7185, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7186, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7187, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7188, '', 3, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7189, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7190, '', 3, '', 5, 5, 11, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7191, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7194, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7199, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7204, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7205, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7206, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7207, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7208, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7209, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7210, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7211, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7212, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7213, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7214, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7215, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7220, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7228, '', 6, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7229, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7230, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7231, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7232, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7233, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7234, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7235, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7238, '', 4, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7241, '', 2, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7242, '', 4, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7243, '', 3, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7245, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7246, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7247, '', 1, '', 9, 3, 4, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7248, '', 6, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7249, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7250, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7251, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7252, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7253, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7254, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7255, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7256, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7258, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7259, '', 5, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7260, '', 4, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7268, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7270, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7271, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7272, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7273, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7274, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7275, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7278, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7296, '', 4, '', 14, 1, 3, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7297, '', 1, '', 12, 7, 6, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7298, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7299, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7300, '', 1, '', 18, 12, 15, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7302, '', 1, '', 29, 12, 13, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7316, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7317, '', 1, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7318, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7319, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7320, '', 2, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7321, '', 5, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7322, '', 4, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7324, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7326, '', 3, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7327, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7328, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7330, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7331, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7332, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7333, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7338, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7339, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7340, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7341, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7342, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7343, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7344, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7345, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7346, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7350, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7353, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7354, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7355, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7356, '', 3, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7357, '', 4, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7358, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7363, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7368, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7373, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7374, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7378, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7380, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7384, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7385, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7386, '', 2, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7387, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7389, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7392, '', 1, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7393, '', 2, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7394, '', 1, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7398, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7399, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7401, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7402, '', 3, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7404, '', 3, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7528, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7529, '', 1, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7530, '', 5, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7531, '', 3, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7533, '', 3, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7534, '', 3, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7535, '', 4, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7536, '', 4, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7537, '', 3, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7538, '', 4, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7539, '', 3, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7540, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7548, '', 3, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7549, '', 2, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7554, '', 6, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7555, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7556, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7557, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7558, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7559, '', 3, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7560, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7561, '', 3, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7562, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7563, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7564, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7565, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7566, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7567, '', 6, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7572, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7573, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7574, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7583, '', 4, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7584, '', 2, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7585, '', 5, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7586, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7587, '', 2, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7588, '', 5, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7589, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7593, '', 4, '', 19, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7599, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7600, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7601, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7602, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7605, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7606, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7607, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7609, '', 4, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7610, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7611, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7612, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7613, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7614, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7615, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7616, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7617, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7625, '', 4, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7630, '', 6, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7631, '', 2, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7633, '', 4, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7634, '', 4, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7635, '', 4, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7636, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7637, '', 3, '', 17, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7650, '', 2, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7651, '', 2, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7652, '', 5, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7653, '', 2, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7654, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7656, '', 4, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7668, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7669, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7670, '', 6, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7671, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7672, '', 5, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7673, '', 2, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7674, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7675, '', 4, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7676, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7687, '', 6, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7688, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7692, '', 5, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7693, '', 6, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7694, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7695, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7696, '', 4, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7697, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7698, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7699, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7700, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7705, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7706, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7716, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7717, '', 2, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7718, '', 1, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7719, '', 6, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7720, '', 4, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7721, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7722, '', 4, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7731, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7739, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7740, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7741, '', 4, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7742, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7743, '', 6, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7744, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7745, '', 4, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7746, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7747, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7756, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7758, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7764, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7765, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7766, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7767, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7768, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7769, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7770, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7771, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7772, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7773, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7774, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7791, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7792, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7793, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7794, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7795, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7796, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7797, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7806, '', 2, '', 4, 8, 16, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7807, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7808, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7809, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7816, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7819, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7820, '', 4, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7821, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7822, '', 3, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7823, '', 4, '', 12, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7824, '', 4, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7825, '', 5, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7826, '', 2, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7833, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7834, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7835, '', 4, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7845, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7846, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7847, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7848, '', 4, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7849, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7850, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7851, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7852, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7853, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7854, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7863, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7864, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7867, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7868, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7869, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7870, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7871, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7872, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7878, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7879, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7895, '', 4, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7897, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7901, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7902, '', 5, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7908, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7909, '', 2, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7918, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7919, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7920, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7921, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7922, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7923, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7924, '', 3, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7925, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7926, '', 2, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7934, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7935, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7944, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7945, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7946, '', 5, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7947, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7949, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7950, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7951, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7952, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7953, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7954, '', 6, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7960, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7965, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7968, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7969, '', 3, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7970, '', 4, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7971, '', 5, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7972, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7973, '', 3, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7974, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7976, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7986, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7987, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7988, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7993, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7994, '', 4, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7995, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7996, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7997, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7998, '', 4, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (7999, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8000, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8001, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8002, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8006, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8014, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8018, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8019, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8020, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8021, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8022, '', 5, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8023, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8024, '', 1, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8025, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8026, '', 5, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8037, '', 3, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8038, '', 2, '', 3, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8042, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8043, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8044, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8046, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8062, '', 5, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8063, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8064, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8066, '', 6, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8067, '', 3, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8077, '', 2, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8096, '', 2, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8105, '', 4, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8175, '', 2, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8190, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8230, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8231, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8235, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8236, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8259, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8260, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8261, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8262, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8263, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8264, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8265, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8270, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8279, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8281, '', 1, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8284, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8286, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8292, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8293, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8294, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8295, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8296, '', 3, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8298, '', 1, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8301, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8303, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8313, '', 1, '', 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8315, '', 3, '', 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8320, '', 2, '', 5, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8321, '', 1, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8325, '', 3, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8326, '', 1, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8327, '', 2, '', 7, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8328, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8329, '', 2, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8341, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8342, '', 1, '', 8, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8348, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8350, '', 1, '', 9, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8351, '', 2, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8354, '', 2, '', 4, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "soldiers" VALUES (8396, '', 3, '', 44, NULL, NULL, NULL, NULL, NULL);

CREATE TABLE "total" (
	"number"               integer	NOT NULL,
	"number_sup"           char(1)	NOT NULL,
	"trip"                 integer,
	"trip_sup"             char(1),
	"onboard_at_departure" integer,
	"death_at_cape"        integer,
	"left_at_cape"         integer,
	"onboard_at_cape"      integer,
	"death_during_voyage"  integer,
	"onboard_at_arrival"   integer
);

INSERT INTO "total" VALUES (1, '', 1, '', 59, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3, '', 1, '', 85, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4, '', 1, '', 85, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5, '', 1, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8, '', 1, '', 123, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (9, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (31, '', 2, '', 46, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (32, '', 3, '', 95, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (33, '', 3, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (34, '', 3, '', 101, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (41, '', 1, '', 175, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (42, '', 1, '', 84, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (43, '', 1, '', 166, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (44, '', 1, '', 6, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (45, '', 1, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (46, '', 1, '', 77, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (82, '', 1, '', 130, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (83, '', 2, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (84, '', 1, '', 160, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (85, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (86, '', 1, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (87, '', 1, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (88, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (89, '', 1, '', 130, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (90, '', 1, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (91, '', 1, '', 130, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (92, '', 1, '', 130, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (93, '', 1, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (96, '', 2, '', 104, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (98, '', 2, '', 144, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (99, '', 1, '', 124, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (100, '', 2, '', 85, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (101, '', 1, '', 148, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (102, '', 1, '', 156, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (103, '', 1, '', 179, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (104, '', 1, '', 76, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (105, '', 2, '', 143, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (106, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (116, '', 2, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (117, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (118, '', 1, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (119, '', 1, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (120, '', 2, '', 140, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (121, '', 2, '', 140, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (122, '', 1, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (123, '', 1, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (124, '', 1, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (125, '', 2, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (126, '', 2, '', 160, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (127, '', 1, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (128, '', 1, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (129, '', 2, '', 160, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (130, '', 2, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (131, '', 2, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (132, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (133, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (134, '', 1, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (135, '', 1, '', 110, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (136, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (137, '', 2, '', 55, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (138, '', 2, '', 55, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (139, '', 3, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (140, '', 2, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (141, '', 2, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (142, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (143, '', 3, '', 99, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (144, '', 2, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (145, '', 2, '', 95, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (146, '', 2, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (147, '', 2, '', 110, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (148, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (164, '', 1, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (165, '', 1, '', 230, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (166, '', 1, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (168, '', 1, '', 90, NULL, NULL, NULL, 36, NULL);
INSERT INTO "total" VALUES (169, '', 2, '', 250, NULL, NULL, NULL, 20, NULL);
INSERT INTO "total" VALUES (170, '', 1, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (171, '', 2, '', 230, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (172, '', 1, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (173, '', 3, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (174, '', 1, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (175, '', 1, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (177, '', 2, '', 250, NULL, NULL, NULL, 163, NULL);
INSERT INTO "total" VALUES (178, '', 1, '', 220, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (180, '', 2, '', 208, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (181, '', 1, '', 180, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (200, '', 1, '', 213, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (206, '', 1, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (207, '', 1, '', 200, NULL, NULL, NULL, 113, NULL);
INSERT INTO "total" VALUES (208, '', 2, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (209, '', 1, '', 130, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (210, '', 1, '', 225, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (214, '', 2, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (215, '', 2, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (216, '', 1, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (217, '', 1, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (218, '', 2, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (219, '', 3, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (220, '', 1, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (221, '', 3, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (222, '', 2, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (223, '', 1, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (224, '', 2, '', 125, NULL, NULL, NULL, 3, NULL);
INSERT INTO "total" VALUES (225, '', 2, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (226, '', 1, '', 206, NULL, NULL, NULL, 157, NULL);
INSERT INTO "total" VALUES (227, '', 1, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (228, '', 2, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (229, '', 2, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (230, '', 3, '', 125, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (231, '', 1, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (232, '', 2, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (233, '', 3, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (234, '', 2, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (235, '', 2, '', 250, 50, NULL, NULL, 101, NULL);
INSERT INTO "total" VALUES (236, '', 2, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (237, '', 2, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (262, '', 3, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (263, '', 1, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (264, '', 1, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (270, '', 3, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (272, '', 4, '', 130, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (275, '', 1, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (277, '', 2, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (278, '', 1, '', 325, NULL, NULL, NULL, 277, NULL);
INSERT INTO "total" VALUES (279, '', 1, '', 175, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (280, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (281, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (282, '', 4, '', 325, NULL, NULL, NULL, 242, NULL);
INSERT INTO "total" VALUES (283, '', 3, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (284, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (285, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (286, '', 2, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (287, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (288, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (289, '', 1, '', 70, NULL, NULL, NULL, 9, NULL);
INSERT INTO "total" VALUES (290, '', 2, '', NULL, NULL, NULL, NULL, 109, NULL);
INSERT INTO "total" VALUES (291, '', 2, '', NULL, NULL, NULL, NULL, 70, NULL);
INSERT INTO "total" VALUES (292, '', 2, '', NULL, NULL, NULL, NULL, 57, NULL);
INSERT INTO "total" VALUES (314, '', 2, '', 175, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (315, '', 2, '', 125, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (316, '', 1, '', 180, NULL, NULL, NULL, 10, 170);
INSERT INTO "total" VALUES (317, '', 3, '', 225, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (319, '', 4, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (322, '', 3, '', 184, NULL, NULL, NULL, 38, 146);
INSERT INTO "total" VALUES (323, '', 2, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (325, '', 1, '', 150, NULL, NULL, NULL, 7, 144);
INSERT INTO "total" VALUES (326, '', 2, '', 261, NULL, NULL, NULL, 78, 183);
INSERT INTO "total" VALUES (327, '', 1, '', 120, NULL, NULL, NULL, 32, 88);
INSERT INTO "total" VALUES (328, '', 1, '', 170, NULL, NULL, NULL, 33, 137);
INSERT INTO "total" VALUES (329, '', 1, '', 72, NULL, NULL, NULL, 21, 51);
INSERT INTO "total" VALUES (330, '', 1, '', 76, NULL, NULL, NULL, 48, 28);
INSERT INTO "total" VALUES (331, '', 1, '', 75, NULL, NULL, NULL, 11, 64);
INSERT INTO "total" VALUES (332, '', 1, '', 100, NULL, NULL, NULL, 1, NULL);
INSERT INTO "total" VALUES (334, '', 3, '', 344, NULL, NULL, NULL, 25, 319);
INSERT INTO "total" VALUES (336, '', 4, '', 191, NULL, NULL, NULL, 7, 184);
INSERT INTO "total" VALUES (337, '', 2, '', 120, NULL, NULL, NULL, 2, 118);
INSERT INTO "total" VALUES (338, '', 1, '', 145, NULL, NULL, NULL, NULL, 145);
INSERT INTO "total" VALUES (339, '', 1, '', 144, NULL, NULL, NULL, 13, 131);
INSERT INTO "total" VALUES (341, '', 1, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (342, '', 3, '', 271, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (343, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (344, '', 3, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (345, '', 1, '', 175, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (346, '', 1, '', 250, NULL, NULL, NULL, 13, NULL);
INSERT INTO "total" VALUES (347, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (350, '', 1, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (351, '', 1, '', 160, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (352, '', 1, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (353, '', 1, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (354, '', 1, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (355, '', 1, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (356, '', 1, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (357, '', 3, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (358, '', 1, '', 200, NULL, NULL, NULL, 50, NULL);
INSERT INTO "total" VALUES (359, '', 1, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (360, '', 1, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (364, '', 4, '', NULL, NULL, NULL, NULL, 175, 203);
INSERT INTO "total" VALUES (365, '', 2, '', NULL, NULL, NULL, NULL, 31, 259);
INSERT INTO "total" VALUES (366, '', 1, '', 75, NULL, NULL, NULL, NULL, 72);
INSERT INTO "total" VALUES (367, '', 1, '', 150, NULL, NULL, NULL, NULL, 149);
INSERT INTO "total" VALUES (368, '', 1, '', 40, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (369, '', 5, '', 275, NULL, NULL, NULL, 32, 288);
INSERT INTO "total" VALUES (370, '', 1, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (371, '', 1, '', 75, NULL, NULL, NULL, NULL, 83);
INSERT INTO "total" VALUES (372, '', 1, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (373, '', 2, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (374, '', 3, '', 350, NULL, NULL, NULL, NULL, 389);
INSERT INTO "total" VALUES (375, '', 1, '', 35, NULL, NULL, NULL, NULL, 48);
INSERT INTO "total" VALUES (376, '', 2, '', 400, NULL, NULL, NULL, NULL, 480);
INSERT INTO "total" VALUES (377, '', 1, '', 75, NULL, NULL, NULL, NULL, 131);
INSERT INTO "total" VALUES (378, '', 1, '', 40, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (379, '', 1, '', 75, NULL, NULL, NULL, NULL, 147);
INSERT INTO "total" VALUES (380, '', 1, '', 35, NULL, NULL, NULL, NULL, 49);
INSERT INTO "total" VALUES (381, '', 4, '', 300, NULL, NULL, NULL, NULL, 362);
INSERT INTO "total" VALUES (382, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (383, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (384, '', 5, '', NULL, NULL, NULL, NULL, NULL, 162);
INSERT INTO "total" VALUES (387, '', 1, '', NULL, NULL, NULL, NULL, NULL, 206);
INSERT INTO "total" VALUES (388, '', 1, '', NULL, NULL, NULL, NULL, NULL, 65);
INSERT INTO "total" VALUES (389, '', 1, '', NULL, NULL, NULL, NULL, NULL, 270);
INSERT INTO "total" VALUES (390, '', 1, '', NULL, NULL, NULL, NULL, NULL, 226);
INSERT INTO "total" VALUES (391, '', 1, '', 225, NULL, NULL, NULL, 22, 203);
INSERT INTO "total" VALUES (392, '', 4, '', NULL, NULL, NULL, NULL, NULL, 191);
INSERT INTO "total" VALUES (393, '', 1, '', NULL, NULL, NULL, NULL, NULL, 120);
INSERT INTO "total" VALUES (394, '', 1, '', NULL, NULL, NULL, NULL, NULL, 210);
INSERT INTO "total" VALUES (395, '', 1, '', NULL, NULL, NULL, NULL, NULL, 70);
INSERT INTO "total" VALUES (396, '', 1, '', NULL, NULL, NULL, NULL, NULL, 254);
INSERT INTO "total" VALUES (397, '', 1, '', NULL, NULL, NULL, NULL, NULL, 207);
INSERT INTO "total" VALUES (399, '', 4, '', NULL, NULL, NULL, NULL, NULL, 120);
INSERT INTO "total" VALUES (400, '', 1, '', NULL, NULL, NULL, NULL, NULL, 120);
INSERT INTO "total" VALUES (401, '', 2, '', NULL, NULL, NULL, NULL, 5, 172);
INSERT INTO "total" VALUES (402, '', 2, '', NULL, NULL, NULL, NULL, 5, 180);
INSERT INTO "total" VALUES (403, '', 1, '', NULL, NULL, NULL, NULL, 3, 67);
INSERT INTO "total" VALUES (404, '', 2, '', NULL, NULL, NULL, NULL, 3, 53);
INSERT INTO "total" VALUES (405, '', 2, '', NULL, NULL, NULL, NULL, 31, 276);
INSERT INTO "total" VALUES (406, '', 2, '', 250, NULL, NULL, NULL, 28, 222);
INSERT INTO "total" VALUES (407, '', 1, '', 249, NULL, NULL, NULL, 26, 223);
INSERT INTO "total" VALUES (408, '', 3, '', 135, NULL, NULL, NULL, 5, 130);
INSERT INTO "total" VALUES (409, '', 4, '', 203, NULL, NULL, NULL, 5, 198);
INSERT INTO "total" VALUES (410, '', 1, '', NULL, NULL, NULL, NULL, NULL, 188);
INSERT INTO "total" VALUES (412, '', 3, '', NULL, NULL, NULL, NULL, NULL, 120);
INSERT INTO "total" VALUES (416, '', 1, '', 90, NULL, NULL, NULL, 13, 86);
INSERT INTO "total" VALUES (417, '', 5, '', 278, NULL, NULL, NULL, 23, 255);
INSERT INTO "total" VALUES (418, '', 1, '', 114, NULL, NULL, NULL, 1, 213);
INSERT INTO "total" VALUES (419, '', 1, '', NULL, NULL, NULL, NULL, NULL, 62);
INSERT INTO "total" VALUES (420, '', 1, '', NULL, NULL, NULL, NULL, 6, 220);
INSERT INTO "total" VALUES (421, '', 1, '', 278, NULL, NULL, NULL, 4, 274);
INSERT INTO "total" VALUES (422, '', 1, '', NULL, NULL, NULL, NULL, 23, 282);
INSERT INTO "total" VALUES (423, '', 5, '', NULL, NULL, NULL, NULL, 4, 138);
INSERT INTO "total" VALUES (424, '', 5, '', NULL, NULL, NULL, NULL, 1, 147);
INSERT INTO "total" VALUES (425, '', 1, '', NULL, NULL, NULL, NULL, 7, 271);
INSERT INTO "total" VALUES (426, '', 1, '', NULL, NULL, NULL, NULL, 5, 284);
INSERT INTO "total" VALUES (427, '', 2, '', NULL, NULL, NULL, NULL, 1, 246);
INSERT INTO "total" VALUES (428, '', 1, '', NULL, NULL, NULL, NULL, NULL, 97);
INSERT INTO "total" VALUES (429, '', 1, '', NULL, NULL, NULL, NULL, NULL, 49);
INSERT INTO "total" VALUES (431, '', 1, '', NULL, NULL, NULL, NULL, NULL, 231);
INSERT INTO "total" VALUES (432, '', 1, '', NULL, NULL, NULL, NULL, NULL, 78);
INSERT INTO "total" VALUES (433, '', 2, '', 240, NULL, NULL, NULL, 3, 237);
INSERT INTO "total" VALUES (434, '', 1, '', NULL, NULL, NULL, NULL, NULL, 57);
INSERT INTO "total" VALUES (437, '', 2, '', NULL, NULL, NULL, NULL, 1, 260);
INSERT INTO "total" VALUES (440, '', 2, '', 189, NULL, NULL, NULL, 5, 184);
INSERT INTO "total" VALUES (441, '', 2, '', 148, NULL, NULL, NULL, 7, 131);
INSERT INTO "total" VALUES (442, '', 4, '', 348, NULL, NULL, NULL, 23, 325);
INSERT INTO "total" VALUES (443, '', 1, '', 56, NULL, NULL, NULL, 1, 55);
INSERT INTO "total" VALUES (444, '', 3, '', 159, NULL, NULL, NULL, 2, 157);
INSERT INTO "total" VALUES (447, '', 1, '', NULL, NULL, NULL, NULL, NULL, 60);
INSERT INTO "total" VALUES (449, '', 3, '', NULL, NULL, NULL, NULL, 6, 50);
INSERT INTO "total" VALUES (450, '', 2, '', NULL, NULL, NULL, NULL, 8, 198);
INSERT INTO "total" VALUES (451, '', 2, '', NULL, NULL, NULL, NULL, 1, 203);
INSERT INTO "total" VALUES (452, '', 4, '', NULL, NULL, NULL, NULL, 1, 145);
INSERT INTO "total" VALUES (453, '', 2, '', NULL, NULL, NULL, NULL, 3, 156);
INSERT INTO "total" VALUES (454, '', 3, '', NULL, NULL, NULL, NULL, 4, 247);
INSERT INTO "total" VALUES (455, '', 1, '', NULL, NULL, NULL, NULL, 11, 197);
INSERT INTO "total" VALUES (456, '', 1, '', NULL, NULL, NULL, NULL, 1, 68);
INSERT INTO "total" VALUES (457, '', 2, '', NULL, NULL, NULL, NULL, 12, 297);
INSERT INTO "total" VALUES (458, '', 2, '', NULL, NULL, NULL, NULL, 2, 277);
INSERT INTO "total" VALUES (459, '', 1, '', NULL, NULL, NULL, NULL, 1, 59);
INSERT INTO "total" VALUES (460, '', 3, '', NULL, NULL, NULL, NULL, 5, 155);
INSERT INTO "total" VALUES (461, '', 6, '', NULL, NULL, NULL, NULL, 3, 312);
INSERT INTO "total" VALUES (462, '', 4, '', NULL, NULL, NULL, NULL, 2, 248);
INSERT INTO "total" VALUES (463, '', 3, '', NULL, NULL, NULL, NULL, 3, 263);
INSERT INTO "total" VALUES (510, '', 1, '', 300, NULL, NULL, NULL, 57, 199);
INSERT INTO "total" VALUES (511, '', 2, '', NULL, NULL, NULL, NULL, 155, 88);
INSERT INTO "total" VALUES (551, '', 1, '', NULL, NULL, NULL, NULL, 1, 63);
INSERT INTO "total" VALUES (562, '', 2, '', 92, NULL, NULL, NULL, NULL, 81);
INSERT INTO "total" VALUES (572, '', 1, '', NULL, NULL, NULL, NULL, 41, 220);
INSERT INTO "total" VALUES (574, '', 1, '', NULL, NULL, NULL, NULL, NULL, 142);
INSERT INTO "total" VALUES (578, '', 1, '', NULL, NULL, NULL, NULL, 3, 114);
INSERT INTO "total" VALUES (632, '', 1, '', NULL, NULL, NULL, NULL, 3, 84);
INSERT INTO "total" VALUES (634, '', 1, '', 110, NULL, NULL, NULL, NULL, 110);
INSERT INTO "total" VALUES (635, '', 3, '', 350, NULL, NULL, NULL, 6, 349);
INSERT INTO "total" VALUES (637, '', 1, '', NULL, NULL, NULL, NULL, NULL, 129);
INSERT INTO "total" VALUES (638, '', 3, '', 350, NULL, NULL, NULL, 18, 332);
INSERT INTO "total" VALUES (651, '', 2, '', NULL, NULL, NULL, NULL, 17, NULL);
INSERT INTO "total" VALUES (652, '', 5, '', NULL, NULL, NULL, NULL, 35, NULL);
INSERT INTO "total" VALUES (655, '', 1, '', NULL, NULL, NULL, NULL, 13, NULL);
INSERT INTO "total" VALUES (658, '', 2, '', 321, NULL, NULL, NULL, 165, 156);
INSERT INTO "total" VALUES (660, '', 6, '', NULL, NULL, NULL, NULL, 52, NULL);
INSERT INTO "total" VALUES (661, '', 4, '', NULL, NULL, NULL, NULL, 14, NULL);
INSERT INTO "total" VALUES (672, '', 5, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (673, '', 3, '', 350, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (676, '', 4, '', 200, NULL, NULL, NULL, 30, NULL);
INSERT INTO "total" VALUES (677, '', 1, '', 125, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (682, '', 1, '', 49, NULL, NULL, NULL, NULL, 49);
INSERT INTO "total" VALUES (684, '', 4, '', NULL, NULL, NULL, NULL, 14, 329);
INSERT INTO "total" VALUES (686, '', 3, '', NULL, NULL, NULL, NULL, 34, 301);
INSERT INTO "total" VALUES (688, '', 1, '', 102, NULL, NULL, NULL, 6, 92);
INSERT INTO "total" VALUES (689, '', 4, '', NULL, NULL, NULL, NULL, 75, 223);
INSERT INTO "total" VALUES (690, '', 7, '', NULL, NULL, NULL, NULL, 56, 202);
INSERT INTO "total" VALUES (692, '', 3, '', NULL, NULL, NULL, NULL, 16, 236);
INSERT INTO "total" VALUES (709, '', 4, '', NULL, NULL, NULL, NULL, 49, NULL);
INSERT INTO "total" VALUES (710, '', 4, '', NULL, NULL, NULL, NULL, 46, NULL);
INSERT INTO "total" VALUES (711, '', 5, '', NULL, NULL, NULL, NULL, 55, NULL);
INSERT INTO "total" VALUES (712, '', 3, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (713, '', 6, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (714, '', 4, '', NULL, NULL, NULL, NULL, 50, NULL);
INSERT INTO "total" VALUES (715, '', 2, '', NULL, NULL, NULL, NULL, 45, NULL);
INSERT INTO "total" VALUES (718, '', 8, '', 325, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (719, '', 5, '', NULL, NULL, NULL, NULL, 106, NULL);
INSERT INTO "total" VALUES (720, '', 1, '', NULL, NULL, NULL, NULL, 1, NULL);
INSERT INTO "total" VALUES (739, '', 1, '', NULL, NULL, NULL, NULL, NULL, 15);
INSERT INTO "total" VALUES (758, '', 1, '', 58, NULL, NULL, NULL, NULL, 55);
INSERT INTO "total" VALUES (760, '', 3, '', 206, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (765, '', 1, '', 93, NULL, NULL, NULL, 1, 92);
INSERT INTO "total" VALUES (768, '', 1, '', 137, NULL, NULL, NULL, 12, 125);
INSERT INTO "total" VALUES (773, '', 1, '', NULL, NULL, NULL, NULL, 11, 256);
INSERT INTO "total" VALUES (778, '', 7, '', NULL, 25, NULL, NULL, 32, 215);
INSERT INTO "total" VALUES (779, '', 1, '', NULL, 26, NULL, 2, 22, 162);
INSERT INTO "total" VALUES (780, '', 1, '', NULL, 8, 1, 2, 12, 104);
INSERT INTO "total" VALUES (781, '', 1, '', NULL, NULL, NULL, NULL, 1, 111);
INSERT INTO "total" VALUES (783, '', 5, '', NULL, 4, NULL, NULL, 6, 241);
INSERT INTO "total" VALUES (784, '', 7, '', NULL, NULL, NULL, NULL, 17, 283);
INSERT INTO "total" VALUES (788, '', 1, '', NULL, 30, NULL, NULL, 28, 155);
INSERT INTO "total" VALUES (789, '', 1, '', NULL, NULL, NULL, NULL, NULL, 12);
INSERT INTO "total" VALUES (790, '', 1, '', NULL, NULL, NULL, NULL, 29, 142);
INSERT INTO "total" VALUES (791, '', 1, '', NULL, NULL, NULL, NULL, 19, 143);
INSERT INTO "total" VALUES (792, '', 1, '', NULL, NULL, NULL, NULL, 25, 192);
INSERT INTO "total" VALUES (793, '', 1, '', NULL, NULL, NULL, NULL, 15, 227);
INSERT INTO "total" VALUES (794, '', 1, '', NULL, NULL, NULL, NULL, 5, 54);
INSERT INTO "total" VALUES (795, '', 1, '', NULL, NULL, NULL, NULL, 6, 164);
INSERT INTO "total" VALUES (796, '', 2, '', 350, NULL, NULL, NULL, 10, 313);
INSERT INTO "total" VALUES (797, '', 4, '', NULL, NULL, NULL, NULL, 46, 190);
INSERT INTO "total" VALUES (798, '', 1, '', NULL, NULL, NULL, NULL, 9, 181);
INSERT INTO "total" VALUES (799, '', 1, '', NULL, NULL, NULL, NULL, 5, 180);
INSERT INTO "total" VALUES (800, '', 1, '', NULL, NULL, NULL, 30, 9, 196);
INSERT INTO "total" VALUES (801, '', 1, '', NULL, 16, 12, 13, 25, 146);
INSERT INTO "total" VALUES (802, '', 1, '', NULL, NULL, NULL, NULL, 10, 160);
INSERT INTO "total" VALUES (806, '', 1, '', NULL, NULL, NULL, NULL, 50, NULL);
INSERT INTO "total" VALUES (808, '', 6, '', NULL, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (809, '', 1, '', NULL, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (810, '', 1, '', NULL, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (811, '', 6, '', NULL, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (812, '', 7, '', 430, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (813, '', 1, '', NULL, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (814, '', 1, '', NULL, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (816, '', 1, '', 133, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (817, '', 2, '', NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (818, '', 2, '', NULL, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (819, '', 1, '', NULL, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (820, '', 3, '', NULL, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (822, '', 1, '', 14, NULL, NULL, NULL, 8, 6);
INSERT INTO "total" VALUES (823, '', 1, '', 137, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (825, '', 7, '', 307, 2, NULL, 4, NULL, NULL);
INSERT INTO "total" VALUES (832, '', 1, '', NULL, NULL, NULL, NULL, NULL, 36);
INSERT INTO "total" VALUES (833, '', 2, '', 193, 2, NULL, NULL, 20, NULL);
INSERT INTO "total" VALUES (838, '', 1, 'B', 197, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (848, '', 8, '', 273, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (852, '', 1, '', 19, NULL, NULL, 3, NULL, 22);
INSERT INTO "total" VALUES (853, '', 1, '', 19, NULL, NULL, NULL, 1, 17);
INSERT INTO "total" VALUES (856, '', 1, '', 30, 1, NULL, NULL, 1, 29);
INSERT INTO "total" VALUES (857, '', 1, '', 21, NULL, NULL, NULL, NULL, 21);
INSERT INTO "total" VALUES (929, '', 2, '', 66, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (930, '', 1, '', 78, 2, NULL, 16, 3, 91);
INSERT INTO "total" VALUES (943, '', 1, '', 247, 12, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (945, '', 1, '', 241, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1017, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1019, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1023, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1025, '', 1, '', 15, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1027, '', 2, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1030, '', 1, '', 16, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1031, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1042, '', 3, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1095, '', 2, '', 176, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1099, '', 1, '', 140, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1119, '', 2, '', 173, 17, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1132, '', 1, '', 217, 29, NULL, NULL, NULL, 172);
INSERT INTO "total" VALUES (1147, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1154, '', 2, '', 200, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1158, '', 1, '', 118, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1168, '', 3, '', 168, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1172, '', 3, '', 170, 12, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1175, '', 2, '', 130, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1177, '', 1, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1198, '', 7, '', 296, 72, 12, NULL, 77, NULL);
INSERT INTO "total" VALUES (1199, '', 3, '', 220, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1204, '', 3, '', 113, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1212, '', 1, '', 53, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1213, '', 1, '', 49, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1218, '', 1, '', 40, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1222, '', 1, '', 17, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1224, '', 1, '', 19, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1228, '', 1, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1237, '', 1, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1238, '', 3, '', 230, 51, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1240, '', 1, '', 270, 52, NULL, NULL, NULL, 290);
INSERT INTO "total" VALUES (1248, '', 1, '', 21, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1251, '', 1, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1252, '', 1, '', 20, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1257, '', 3, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1258, '', 3, '', 192, 15, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1259, '', 2, '', 160, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1262, '', 2, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1263, '', 1, '', 11, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1264, '', 2, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1265, '', 1, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1266, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1272, '', 1, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1278, '', 1, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1280, '', 2, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1281, '', 3, '', 180, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1315, '', 4, '', 238, 10, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1323, '', 2, '', 27, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1338, '', 3, '', 20, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1351, '', 4, '', 252, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1371, '', 1, '', 36, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1374, '', 1, '', 38, NULL, NULL, NULL, NULL, 38);
INSERT INTO "total" VALUES (1377, '', 2, '', 275, 10, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1389, '', 3, '', 260, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1392, '', 1, '', 36, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1405, '', 1, '', 45, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1406, '', 1, '', 82, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1421, '', 5, '', 317, 26, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1428, '', 1, '', 15, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1446, '', 1, '', 111, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1448, '', 2, '', 100, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1469, '', 1, '', 166, 4, 24, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1471, '', 2, '', 75, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1472, '', 1, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1475, '', 3, '', 99, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1485, '', 1, '', 36, NULL, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1491, '', 2, '', 150, 3, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1494, '', 2, '', 166, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1501, '', 1, '', 80, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1506, '', 2, '', 150, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1510, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1513, '', 2, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1524, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1531, '', 2, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1532, '', 1, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1534, '', 3, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1541, '', 1, '', 13, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1549, '', 1, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1559, '', 2, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1565, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1566, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1567, '', 3, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1572, '', 1, '', 150, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1575, '', 1, '', 150, 12, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1578, '', 2, '', 250, 24, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1588, '', 1, '', NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1602, '', 1, '', 130, 14, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1605, '', 1, '', 40, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1607, '', 1, '', 250, 41, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1610, '', 2, '', 150, 13, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1628, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1629, '', 1, '', 300, 19, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1632, '', 1, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1633, '', 1, '', 50, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1634, '', 1, '', 75, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1636, '', 1, '', 80, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1638, '', 2, '', 200, 40, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1639, '', 3, '', 225, 33, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1640, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1641, '', 1, '', 50, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1647, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1651, '', 1, '', 10, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1656, '', 2, '', 175, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1658, '', 1, '', 75, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1661, '', 4, '', 250, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1663, '', 2, '', 200, 15, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1665, '', 1, '', 190, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1666, '', 1, '', 10, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1669, '', 1, '', 21, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1671, '', 5, '', 325, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1679, '', 1, '', 24, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1680, '', 1, '', 100, 15, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1687, '', 2, '', 250, 32, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1700, '', 2, '', 225, 7, NULL, NULL, 7, NULL);
INSERT INTO "total" VALUES (1708, '', 1, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1709, '', 4, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1719, '', 4, '', 175, 20, 68, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1720, '', 1, '', 75, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1724, '', 1, '', 225, 29, 96, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1730, '', 1, '', 80, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1737, '', 1, '', 40, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1739, '', 3, '', 150, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1745, '', 2, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1753, '', 3, '', 150, 8, 26, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1763, '', 1, '', 150, 1, 1, NULL, 1, NULL);
INSERT INTO "total" VALUES (1764, '', 2, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1768, '', 1, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1771, '', 1, '', 275, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1772, '', 1, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1773, '', 2, '', 175, 15, 23, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1786, '', 3, '', 175, 5, 29, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1787, '', 1, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1790, '', 4, '', 157, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1792, '', 2, '', 200, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1793, '', 3, '', 125, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1796, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1801, '', 3, '', 50, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1809, '', 5, '', 200, 21, 34, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1812, '', 4, '', 174, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1817, '', 1, '', 200, 6, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1837, '', 1, '', 14, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1841, '', 2, '', 75, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1847, '', 5, '', 175, 4, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1853, '', 5, '', 125, 5, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1869, '', 4, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1872, '', 1, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1877, '', 2, '', 200, 5, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1893, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1895, '', 1, '', 100, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1897, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1905, '', 2, '', 102, NULL, 9, 2, NULL, 95);
INSERT INTO "total" VALUES (1909, '', 6, '', 200, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1914, '', 3, '', 200, 4, 43, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1926, '', 1, '', 14, NULL, 1, 1, NULL, 14);
INSERT INTO "total" VALUES (1931, '', 1, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1940, '', 1, '', 16, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1947, '', 5, '', 200, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1960, '', 1, '', 105, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1962, '', 3, '', 125, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1975, '', 5, '', 200, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1982, '', 6, '', NULL, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1990, '', 4, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (1992, '', 1, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2006, '', 5, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2009, '', 1, '', 175, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2025, '', 5, '', 200, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2032, '', 3, '', 200, 22, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2035, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2036, '', 1, '', 25, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2037, '', 1, '', 15, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2043, '', 1, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2045, '', 3, '', 225, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2048, '', 2, '', 150, 20, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2077, '', 1, '', 225, 22, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2080, '', 2, '', 150, 43, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2095, '', 3, '', 250, 16, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2100, '', 2, '', 163, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2113, '', 1, '', 55, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2121, '', 1, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2122, '', 2, '', 225, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2123, '', 1, '', 225, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2124, '', 2, '', 125, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2129, '', 4, '', 225, 14, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2133, '', 1, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2135, '', 1, '', 225, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2147, '', 3, '', 286, 112, 22, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2148, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2149, '', 1, '', 100, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2151, '', 5, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2153, '', 1, '', 115, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2158, '', 2, '', 225, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2179, '', 5, '', 200, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2186, '', 3, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2192, '', 4, '', 80, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2197, '', 4, '', 200, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2199, '', 5, '', 150, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2208, '', 3, '', 175, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2233, '', 1, '', 175, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2242, '', 3, '', 175, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2268, '', 1, '', 175, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2285, '', 5, '', 150, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2295, '', 2, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2305, '', 4, '', 200, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2349, '', 1, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2372, '', 3, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2374, '', 1, '', 250, 34, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2380, '', 1, '', 180, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2403, '', 3, '', 180, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2409, '', 3, '', 250, 18, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2411, '', 2, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2413, '', 1, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2414, '', 1, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2430, '', 1, '', 27, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2442, '', 6, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2448, '', 2, '', 250, 17, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2455, '', 3, '', 250, 43, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2461, '', 1, '', 300, 55, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2464, '', 2, '', 180, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2467, '', 1, '', 300, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2468, '', 1, '', 71, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2469, '', 3, '', 150, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2472, '', 1, '', 250, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2475, '', 2, '', 150, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2476, '', 2, '', 250, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2477, '', 1, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2479, '', 2, '', 225, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2483, '', 1, '', 150, 12, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2484, '', 5, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2485, '', 2, '', 150, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2487, '', 4, '', 275, 34, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2488, '', 2, '', 275, 35, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2489, '', 3, '', 225, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2490, '', 4, '', 150, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2492, '', 1, '', 50, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2494, '', 3, '', 225, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2495, '', 6, '', 225, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2520, '', 7, '', 225, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2534, '', 1, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2543, '', 6, '', 150, 19, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2545, '', 1, '', 150, 50, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2547, '', 2, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2551, '', 3, '', 225, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2552, '', 6, '', 275, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2553, '', 2, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2554, '', 4, '', 225, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2555, '', 1, '', 225, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2556, '', 1, '', 150, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2557, '', 3, '', 225, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2558, '', 2, '', 275, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2563, '', 1, '', 225, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2564, '', 1, '', 150, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2566, '', 8, '', 275, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2569, '', 2, '', 225, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2575, '', 2, '', 150, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2597, '', 1, '', 130, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2600, '', 1, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2605, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2606, '', 3, '', 130, 17, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2607, '', 2, '', 200, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2608, '', 1, '', 30, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2609, '', 1, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2612, '', 3, '', 130, 23, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2619, '', 1, '', 60, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2620, '', 5, '', 130, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2621, '', 5, '', 130, 12, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2622, '', 1, '', 200, 16, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2623, '', 2, '', 200, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2624, '', 2, '', 200, 28, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2630, '', 2, '', 200, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2645, '', 5, '', 200, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2647, '', 2, '', 200, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2680, '', 1, '', 208, 28, 24, 22, 126, 82);
INSERT INTO "total" VALUES (2686, '', 2, '', 200, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2697, '', 5, '', 250, 16, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2709, '', 5, '', 180, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2722, '', 5, '', 180, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2724, '', 3, '', 180, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2726, '', 3, '', 180, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2727, '', 1, '', 180, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2728, '', 1, '', 120, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2729, '', 3, '', 220, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2755, '', 1, '', 85, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2760, '', 4, '', 180, 14, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2765, '', 2, '', 130, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2782, '', 1, '', 85, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2783, '', 1, '', 90, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2796, '', 2, '', 200, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2797, '', 3, '', 200, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2818, '', 2, '', 85, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2822, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2823, '', 4, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2830, '', 1, '', 240, 13, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2837, '', 2, '', 180, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2838, '', 1, '', 180, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2840, '', 5, '', 240, 47, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2862, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2863, '', 1, '', 100, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2865, '', 2, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2877, '', 3, '', 225, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2878, '', 1, '', 225, 67, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2881, '', 4, '', 190, 24, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2882, '', 5, '', 150, 59, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2895, '', 2, '', 100, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2896, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2897, '', 5, '', 100, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2898, '', 5, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2903, '', 2, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2904, '', 2, '', 225, 18, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2908, '', 2, '', 225, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2918, '', 8, '', 150, 32, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2920, '', 2, '', 150, 53, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2922, '', 4, '', 225, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2935, '', 1, '', 100, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2937, '', 2, '', 250, 16, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2940, '', 6, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2943, '', 6, '', 300, 40, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2975, '', 2, '', 250, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2977, '', 3, '', 175, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2978, '', 2, '', 256, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (2989, '', 3, '', 256, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3008, '', 2, '', 175, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3012, '', 2, '', 175, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3016, '', 2, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3019, '', 3, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3020, '', 2, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3021, '', 3, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3027, '', 2, '', 175, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3049, '', 6, '', 256, 175, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3054, '', 5, '', 175, 44, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3071, '', 6, '', 225, 26, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3093, '', 3, '', 175, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3095, '', 6, '', 250, 26, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3118, '', 1, '', NULL, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3134, '', 3, '', NULL, 3, NULL, NULL, 8, 178);
INSERT INTO "total" VALUES (3138, '', 7, '', NULL, NULL, 26, NULL, 82, NULL);
INSERT INTO "total" VALUES (3141, '', 8, '', NULL, 31, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3156, '', 2, '', 264, 14, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3163, '', 5, '', NULL, 3, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3171, '', 8, '', NULL, 48, 22, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3176, '', 7, '', 250, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3207, '', 8, '', 250, 51, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3215, '', 3, '', 253, 4, 37, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3233, '', 4, '', 250, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3234, '', 2, '', 175, 25, 18, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3248, '', 3, '', 175, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3252, '', 5, '', 250, 40, 63, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3257, '', 8, '', 393, 36, 46, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3266, '', 2, '', 274, 64, 23, NULL, 67, 187);
INSERT INTO "total" VALUES (3267, '', 3, '', 275, 31, 60, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3271, '', 3, '', 180, 8, 40, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3272, '', 1, '', 300, 25, 19, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3275, '', 1, '', 276, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3278, '', 6, '', 284, 18, 95, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3297, '', 6, '', 177, 14, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3300, '', 2, '', 221, 10, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3303, '', 4, '', 203, 5, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3322, '', 3, '', 278, 24, 36, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3343, '', 1, '', 232, 11, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3344, '', 3, '', 272, 7, 38, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3350, '', 1, '', 272, 48, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3368, '', 3, '', 284, 87, 70, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3373, '', 5, '', 201, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3386, '', 7, '', 285, 82, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3389, '', 5, '', 214, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3399, '', 3, '', 297, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3416, '', 3, '', 342, 70, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3421, '', 2, '', 296, 130, 94, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3423, '', 2, '', 207, 72, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3439, '', 2, '', 319, 87, 30, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3475, '', 3, '', 248, 24, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3479, '', 2, '', 317, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3483, '', 1, '', 318, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3513, '', 4, '', 249, 9, 2, NULL, 9, 240);
INSERT INTO "total" VALUES (3530, '', 1, '', 89, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3533, '', 2, '', 408, 20, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3545, '', 3, '', 266, 3, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3549, '', 5, '', 331, 3, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3552, '', 3, '', 343, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3557, '', 3, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3567, '', 1, '', NULL, 15, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3580, '', 5, '', 272, 9, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3581, '', 4, '', 353, 37, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3582, '', 3, '', 250, 9, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3601, '', 2, '', 109, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3611, '', 4, '', 274, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3614, '', 2, '', 356, 60, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3621, '', 3, '', 352, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3642, '', 2, '', 351, 2, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3643, '', 1, '', 271, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3648, '', 2, '', 305, 23, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3665, '', 5, '', 263, 21, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3670, '', 3, '', 351, 24, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3671, '', 4, '', 228, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3679, '', 2, '', 290, 19, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3687, '', 1, '', 142, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3695, '', 2, '', 309, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3702, '', 6, '', 292, 35, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3717, '', 2, '', 376, 89, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3719, '', 3, '', 353, 89, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3743, '', 2, '', 260, 24, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3744, '', 1, '', 145, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3747, '', 2, '', NULL, 100, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3754, '', 3, '', 345, 118, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3776, '', 5, '', 238, 15, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3781, '', 4, '', 301, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3796, '', 4, '', 337, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3802, '', 1, '', 97, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3803, '', 5, '', 363, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3806, '', 3, '', 286, 41, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3822, '', 2, '', 350, 48, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3824, '', 3, '', 338, 20, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3831, '', 2, '', 318, 113, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3841, '', 4, '', 234, 18, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3842, '', 1, '', 227, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3844, '', 1, '', 348, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3845, '', 6, '', 348, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3852, '', 4, '', 253, 18, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3857, '', 2, '', 327, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3858, '', 2, '', 303, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3866, '', 4, '', 390, 56, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3867, '', 3, '', 399, 70, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3871, '', 2, '', 399, 39, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3887, '', 3, '', 259, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3890, '', 5, '', 338, 18, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3894, '', 5, '', 350, 17, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3904, '', 4, '', 276, 45, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3907, '', 1, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3914, '', 4, '', 269, 13, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3918, '', 2, '', 354, 44, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3920, '', 4, '', 357, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3922, '', 3, '', 341, 58, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3944, '', 4, '', 263, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3947, '', 6, '', 254, 13, 19, NULL, 40, NULL);
INSERT INTO "total" VALUES (3948, '', 2, '', 353, 3, 7, NULL, 22, NULL);
INSERT INTO "total" VALUES (3952, '', 5, '', 248, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3953, '', 3, '', 300, 24, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3959, '', 6, '', 304, 28, 82, NULL, 187, NULL);
INSERT INTO "total" VALUES (3960, '', 6, '', 256, 16, 24, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3962, '', 5, '', 193, 19, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3963, '', 5, '', 320, 3, 45, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3964, '', 3, '', 242, 6, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3965, '', 7, '', 262, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3966, '', 1, '', 357, 24, 54, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3967, '', 1, '', 246, 6, 31, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3969, '', 1, '', 351, 1, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3970, '', 2, '', 354, 4, 44, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3972, '', 1, '', 354, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3973, '', 2, '', 266, 5, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3974, '', 1, '', 269, 25, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3975, '', 2, '', 363, 63, 51, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3976, '', 5, '', 343, 18, 67, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3977, '', 6, '', 244, 2, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3978, '', 4, '', 366, 27, 54, NULL, 62, NULL);
INSERT INTO "total" VALUES (3979, '', 4, '', 268, 2, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3980, '', 4, '', 187, 1, 1, NULL, 2, NULL);
INSERT INTO "total" VALUES (3981, '', 1, '', 345, 7, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3982, '', 7, '', 173, 6, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3983, '', 4, '', 383, 73, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3985, '', 4, '', 286, 14, 110, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3986, '', 6, '', 251, 1, 23, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3987, '', 3, '', 311, 67, NULL, NULL, 110, NULL);
INSERT INTO "total" VALUES (3988, '', 4, '', 309, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3989, '', 4, '', 299, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (3993, '', 3, '', 184, 5, NULL, NULL, 14, NULL);
INSERT INTO "total" VALUES (3994, '', 4, '', 198, 18, NULL, NULL, 69, NULL);
INSERT INTO "total" VALUES (3996, '', 1, '', 259, 26, NULL, NULL, 64, NULL);
INSERT INTO "total" VALUES (3997, '', 1, '', 368, 26, 58, NULL, 28, NULL);
INSERT INTO "total" VALUES (3998, '', 5, '', 278, 6, 10, NULL, 7, NULL);
INSERT INTO "total" VALUES (3999, '', 2, '', 358, 11, 49, NULL, 38, NULL);
INSERT INTO "total" VALUES (4000, '', 1, '', 370, 18, 37, NULL, 36, NULL);
INSERT INTO "total" VALUES (4001, '', 3, '', 364, 10, NULL, NULL, 40, NULL);
INSERT INTO "total" VALUES (4002, '', 1, '', 364, 9, NULL, NULL, 11, NULL);
INSERT INTO "total" VALUES (4003, '', 1, '', 277, 4, 15, 3, 6, NULL);
INSERT INTO "total" VALUES (4005, '', 1, '', 280, 8, NULL, NULL, 52, NULL);
INSERT INTO "total" VALUES (4007, '', 3, '', 349, 3, NULL, NULL, 121, NULL);
INSERT INTO "total" VALUES (4008, '', 4, '', 361, 32, NULL, NULL, 42, NULL);
INSERT INTO "total" VALUES (4009, '', 3, '', 263, 20, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4010, '', 2, '', 262, 15, NULL, NULL, 30, NULL);
INSERT INTO "total" VALUES (4013, '', 2, '', 348, 18, NULL, NULL, 24, NULL);
INSERT INTO "total" VALUES (4014, '', 3, '', 255, 14, NULL, NULL, 34, NULL);
INSERT INTO "total" VALUES (4015, '', 2, '', 246, 2, NULL, NULL, 2, NULL);
INSERT INTO "total" VALUES (4017, '', 5, '', 233, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4018, '', 3, '', 306, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4019, '', 6, '', 191, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4020, '', 2, '', 202, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4022, '', 6, '', 226, 31, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4023, '', 1, '', 226, 14, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4025, '', 1, '', 379, 51, 74, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4027, '', 1, '', 359, 34, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4028, '', 1, '', 360, 27, 49, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4030, '', 2, '', 266, 27, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4031, '', 2, '', 360, 16, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4032, '', 2, '', 354, 22, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4034, '', 3, '', 352, 56, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4035, '', 3, '', 352, 77, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4036, '', 2, '', 354, 34, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4037, '', 1, '', 158, 14, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4039, '', 3, '', 283, 34, 19, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4041, '', 5, '', 265, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4044, '', 7, '', 227, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4047, '', 7, '', 190, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4049, '', 5, '', 233, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4051, '', 5, '', 203, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4052, '', 3, '', 274, 17, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4053, '', 5, '', 264, 25, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4055, '', 1, '', 355, 40, 60, NULL, 84, NULL);
INSERT INTO "total" VALUES (4056, '', 1, '', 356, 35, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4058, '', 5, '', 273, 10, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4059, '', 1, '', 351, 32, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4060, '', 2, '', 265, 13, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4061, '', 3, '', 273, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4062, '', 2, '', 355, 19, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4064, '', 5, '', 192, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4065, '', 2, '', 355, 15, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4066, '', 3, '', 308, 48, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4067, '', 2, '', 281, 24, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4068, '', 4, '', 356, 38, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4069, '', 4, '', 347, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4071, '', 3, '', 360, 27, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4072, '', 3, '', 196, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4073, '', 5, '', 313, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4074, '', 2, '', 346, 14, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4075, '', 3, '', 237, 33, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4079, '', 4, '', 323, 7, 22, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4098, '', 6, '', 366, 121, 18, NULL, 131, NULL);
INSERT INTO "total" VALUES (4099, '', 4, '', 280, 71, 47, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4100, '', 1, '', 221, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4101, '', 3, '', 321, 76, 58, NULL, 78, NULL);
INSERT INTO "total" VALUES (4104, '', 1, '', 238, 3, 19, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4106, '', 2, '', 304, 120, 81, NULL, 129, NULL);
INSERT INTO "total" VALUES (4107, '', 4, '', 369, 217, 80, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4109, '', 6, '', 291, 184, 60, NULL, 193, NULL);
INSERT INTO "total" VALUES (4110, '', 2, '', 268, 90, 70, NULL, 91, NULL);
INSERT INTO "total" VALUES (4111, '', 1, '', 337, 99, 108, NULL, 103, 167);
INSERT INTO "total" VALUES (4112, '', 7, '', 282, 101, 72, NULL, 113, NULL);
INSERT INTO "total" VALUES (4113, '', 2, '', 363, 59, 14, NULL, 62, NULL);
INSERT INTO "total" VALUES (4114, '', 4, '', 193, 7, 6, NULL, 11, NULL);
INSERT INTO "total" VALUES (4117, '', 3, '', 223, 19, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4118, '', 3, '', 319, 106, 19, NULL, 114, 203);
INSERT INTO "total" VALUES (4119, '', 1, '', 173, 17, 11, NULL, 30, NULL);
INSERT INTO "total" VALUES (4120, '', 4, '', 363, 131, 20, NULL, 134, NULL);
INSERT INTO "total" VALUES (4121, '', 6, '', 343, 105, 35, NULL, 115, NULL);
INSERT INTO "total" VALUES (4122, '', 3, '', 323, 80, 40, NULL, 88, 174);
INSERT INTO "total" VALUES (4123, '', 2, '', 185, 55, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4124, '', 1, '', 337, 40, 12, NULL, 40, NULL);
INSERT INTO "total" VALUES (4125, '', 1, '', 313, 29, 41, NULL, 32, NULL);
INSERT INTO "total" VALUES (4126, '', 5, '', 328, 48, 25, NULL, 60, NULL);
INSERT INTO "total" VALUES (4127, '', 2, '', 315, 25, 49, NULL, 31, NULL);
INSERT INTO "total" VALUES (4128, '', 2, '', 276, 90, 40, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4129, '', 2, '', 283, 19, 19, NULL, 22, NULL);
INSERT INTO "total" VALUES (4130, '', 3, '', 224, 42, NULL, NULL, 50, NULL);
INSERT INTO "total" VALUES (4131, '', 4, '', 189, 42, 6, NULL, 46, NULL);
INSERT INTO "total" VALUES (4132, '', 3, '', 325, 72, 40, NULL, 76, NULL);
INSERT INTO "total" VALUES (4134, '', 1, '', 260, 36, 60, NULL, 42, NULL);
INSERT INTO "total" VALUES (4135, '', 5, '', 339, 83, 123, NULL, 86, 222);
INSERT INTO "total" VALUES (4136, '', 5, '', 303, 60, NULL, NULL, 62, 213);
INSERT INTO "total" VALUES (4137, '', 3, '', 226, 28, NULL, NULL, 30, 182);
INSERT INTO "total" VALUES (4141, '', 6, '', 266, 41, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4142, '', 5, '', 315, 116, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4143, '', 2, '', 515, 190, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4144, '', 1, '', 235, 17, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4147, '', 5, '', 288, 47, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4148, '', 3, '', 305, 62, 30, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4149, '', 4, '', 368, 103, 30, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4151, '', 1, '', 297, 100, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4152, '', 4, '', 300, 70, 41, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4153, '', 1, '', 298, 86, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4154, '', 3, '', 185, 36, 33, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4155, '', 1, '', 353, 150, 67, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4157, '', 1, '', 299, 65, 50, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4158, '', 3, '', 196, 41, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4159, '', 5, '', 243, 72, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4160, '', 3, '', 323, 101, 36, 12, 105, 194);
INSERT INTO "total" VALUES (4161, '', 3, '', 307, 58, 40, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4162, '', 3, '', 355, 107, 36, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4163, '', 4, '', 224, 33, 36, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4164, '', 5, '', 242, 54, 26, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4165, '', 3, '', 301, 42, 75, 10, 50, 186);
INSERT INTO "total" VALUES (4166, '', 1, '', 307, 63, 40, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4167, '', 2, '', 247, 33, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4169, '', 6, '', 300, 52, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4171, '', 5, '', 224, 30, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4176, '', 1, '', 258, 3, 25, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4183, '', 1, '', 239, 25, 30, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4192, '', 4, '', 262, 3, 25, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4194, '', 5, '', 322, 79, 13, 34, 89, 254);
INSERT INTO "total" VALUES (4195, '', 3, '', 372, 104, 38, NULL, 108, 221);
INSERT INTO "total" VALUES (4196, '', 3, '', 366, 10, 25, NULL, 79, NULL);
INSERT INTO "total" VALUES (4197, '', 3, '', 294, 22, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4198, '', 2, '', 218, 12, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4199, '', 4, '', 239, 21, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4200, '', 1, '', 301, 16, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4201, '', 3, '', 211, 28, 82, NULL, 41, NULL);
INSERT INTO "total" VALUES (4202, '', 1, '', 249, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4207, '', 2, '', 202, 10, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4209, '', 2, '', 245, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4224, '', 1, '', 223, NULL, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4227, '', 3, '', 303, 6, 15, 80, 54, 314);
INSERT INTO "total" VALUES (4229, '', 2, '', 247, 5, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4230, '', 4, '', 303, 1, 16, 67, 60, 294);
INSERT INTO "total" VALUES (4232, '', 2, '', 198, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4233, '', 5, '', 258, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4234, '', 2, '', 249, 12, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4235, '', 5, '', 278, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4236, '', 4, '', 272, 12, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4237, '', 1, '', NULL, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4238, '', 3, '', 180, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4239, '', 2, '', 314, 14, 37, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4240, '', 2, '', 245, 92, 118, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4241, '', 3, '', 230, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4242, '', 3, '', 342, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4243, '', 3, '', 234, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4244, '', 3, '', 248, 20, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4245, '', 5, '', 232, 10, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4246, '', 5, '', 230, 12, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4247, '', 1, '', 301, 17, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4249, '', 2, '', 286, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4251, '', 3, '', 342, 13, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4252, '', 1, '', 290, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4253, '', 2, '', 326, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4254, '', 1, '', 309, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4255, '', 3, '', 274, 30, 28, 80, 40, 286);
INSERT INTO "total" VALUES (4256, '', 5, '', 309, 47, 27, 113, 60, 335);
INSERT INTO "total" VALUES (4257, '', 5, '', 219, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4259, '', 3, '', 224, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4261, '', 1, '', 293, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4266, '', 2, '', 186, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4267, '', 4, '', 307, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4268, '', 4, '', 168, 40, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4269, '', 1, '', 310, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4270, '', 2, '', 153, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4271, '', 2, '', 217, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4272, '', 2, '', 222, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4273, '', 1, '', 300, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4274, '', 4, '', 131, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4275, '', 1, '', 286, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4276, '', 1, '', 101, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4277, '', 1, '', 214, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4278, '', 1, '', 246, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4279, '', 4, '', 348, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4280, '', 2, '', 331, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4281, '', 1, '', 300, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4282, '', 1, '', 275, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4283, '', 1, '', 195, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4284, '', 1, '', 155, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4285, '', 7, '', 209, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4286, '', 2, '', 219, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4287, '', 3, '', 182, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4288, '', 5, '', 270, NULL, NULL, 45, 9, 299);
INSERT INTO "total" VALUES (4289, '', 5, '', 296, 6, 20, 26, 10, 292);
INSERT INTO "total" VALUES (4291, '', 2, '', 291, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4292, '', 2, '', 287, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4293, '', 5, '', 301, 12, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4294, '', 3, '', 241, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4295, '', 5, '', 263, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4296, '', 6, '', 127, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4297, '', 5, '', 257, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4298, '', 1, '', 301, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4299, '', 3, '', 236, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4300, '', 5, '', 188, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4301, '', 2, '', 294, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4302, '', 2, '', 233, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4303, '', 2, '', 192, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4304, '', 1, '', 173, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4305, '', 2, '', 174, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4306, '', 6, '', 200, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4307, '', 1, '', 287, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4308, '', 2, '', 205, 25, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4309, '', 6, '', 154, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4310, '', 3, '', 192, 2, 12, 15, 3, 192);
INSERT INTO "total" VALUES (4311, '', 2, '', 206, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4312, '', 2, '', 191, 2, 5, NULL, 2, 179);
INSERT INTO "total" VALUES (4313, '', 1, '', 203, 15, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4314, '', 3, '', 46, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4316, '', 3, '', 237, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4317, '', 4, '', 289, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4318, '', 6, '', 310, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4319, '', NULL, '', 217, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4320, '', 3, '', 297, 15, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4321, '', 4, '', 299, 12, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4322, '', 3, '', 93, 2, 24, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4323, '', 3, '', 59, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4324, '', 1, '', 195, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4325, '', 3, '', 185, 16, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4326, '', 4, '', 212, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4327, '', 2, '', 304, 3, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4328, '', 4, '', 177, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4329, '', 2, '', 210, 43, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4330, '', 3, '', 270, 12, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4332, '', 1, '', 199, 21, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4333, '', 2, '', 207, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4334, '', 3, '', 206, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4335, '', 4, '', 131, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4336, '', 3, '', 230, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4337, '', 2, '', 167, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4338, '', 1, '', 197, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4339, '', 2, '', 182, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4340, '', 4, '', 208, 21, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4341, '', 2, '', 183, 4, 3, 25, 7, 198);
INSERT INTO "total" VALUES (4342, '', 6, '', 205, 1, 6, 4, 4, 199);
INSERT INTO "total" VALUES (4343, '', 2, '', 230, 19, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4344, '', 2, '', 294, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4345, '', 2, '', 203, 18, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4346, '', 2, '', 314, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4347, '', 4, '', 224, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4348, '', 5, '', 216, 23, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4349, '', 2, '', 216, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4350, '', 4, '', 255, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4351, '', 5, '', 209, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4352, '', 3, '', 201, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4353, '', 6, '', 300, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4354, '', 4, '', 59, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4355, '', 4, '', 51, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4356, '', 6, '', 233, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4357, '', 2, '', 279, 13, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4358, '', 3, '', 279, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4359, '', 1, '', 268, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4360, '', 1, '', 259, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4361, '', 4, '', 179, 3, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4362, '', 3, '', 152, 18, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4363, '', 3, '', 225, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4364, '', 3, '', 141, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4365, '', 2, '', 135, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4366, '', 3, '', 154, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4367, '', 3, '', 128, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4368, '', 2, '', 191, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4370, '', 7, '', 182, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4371, '', 3, '', 298, 48, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4373, '', 3, '', 186, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4383, '', 5, '', 60, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4386, '', 5, '', 45, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4389, '', 3, '', 284, 1, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4390, '', 1, '', 165, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4391, '', 1, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4393, '', 3, '', 301, 172, 72, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4394, '', 4, '', 291, 138, 97, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4397, '', 4, '', 302, 110, 129, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4399, '', 2, '', 317, 127, 112, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4400, '', 1, '', 36, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4401, '', 1, '', 230, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4403, '', 1, '', 42, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4404, '', 1, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4405, '', 1, '', 39, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4407, '', 6, '', 114, 7, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4408, '', 3, '', 124, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4409, '', 1, '', 46, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4410, '', 1, '', 129, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4412, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4413, '', 6, '', 197, 11, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4414, '', 1, '', 42, NULL, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4416, '', 1, '', 41, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4418, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4419, '', 4, '', 259, 5, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4420, '', 2, '', 279, 14, 85, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4421, '', 1, '', 40, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4422, '', 2, '', 266, 1, 25, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4423, '', 5, '', 313, 5, 70, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4424, '', 1, '', 335, 9, 30, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4425, '', 1, '', 285, 1, 19, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4426, '', 1, '', 326, 10, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4428, '', 2, '', 312, 1, 19, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4430, '', 1, '', 358, 6, 46, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4431, '', 3, '', 326, 7, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4434, '', 1, '', 226, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4435, '', 1, '', 361, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4437, '', 7, '', 255, 3, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4438, '', 1, '', 122, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4439, '', 2, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4440, '', 1, '', 55, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4441, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4442, '', 1, '', 158, 3, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4444, '', 2, '', 331, 13, 40, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4446, '', 1, '', 40, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4448, '', 1, '', 341, 29, 180, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4449, '', 1, '', 58, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4450, '', 1, '', 347, 32, 130, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4451, '', 1, '', 254, 20, 100, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4452, '', 1, '', 65, 4, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4453, '', 1, '', 255, 18, 60, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4454, '', 1, '', 156, 7, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4455, '', 1, '', 36, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4456, '', 4, '', 280, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4457, '', 1, '', 259, 1, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4458, '', 2, '', 377, 6, 27, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4459, '', 1, '', 37, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4460, '', 1, '', 28, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4461, '', 1, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4462, '', 1, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4463, '', 1, '', 73, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4464, '', 1, '', 130, 2, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4465, '', 1, '', 303, 9, 30, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4466, '', 1, '', 268, NULL, 22, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4467, '', 1, '', 33, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4468, '', 1, '', 34, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4470, '', 1, '', 343, 1, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4471, '', 1, '', 175, 2, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4472, '', 3, '', 201, 3, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4473, '', 2, '', 350, 5, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4474, '', 2, '', 333, 8, 40, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4475, '', 4, '', 350, 6, 26, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4477, '', 1, '', 128, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4478, '', 1, '', 228, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4479, '', 1, '', 27, 2, 24, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4480, '', 2, '', 309, 5, 25, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4481, '', 1, '', 109, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4482, '', 2, '', 355, 20, 74, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4483, '', 1, '', 298, 10, 50, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4484, '', 1, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4486, '', 1, '', 320, 9, 76, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4487, '', 2, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4488, '', 1, '', 36, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4489, '', 1, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4490, '', 2, '', 234, 1, 25, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4491, '', 1, '', 347, 28, 74, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4492, '', 1, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4494, '', 2, '', 270, 5, 42, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4495, '', 6, '', 260, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4496, '', 1, '', 166, 1, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4497, '', 1, '', 57, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4498, '', 1, '', 257, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4499, '', 1, '', 54, NULL, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4500, '', 1, '', 104, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4501, '', 1, '', 316, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4502, '', 2, '', 155, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4503, '', 1, '', 272, NULL, 31, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4504, '', 1, '', 190, 15, 39, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4505, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4506, '', 2, '', 390, 5, 22, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4507, '', 2, '', 355, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4508, '', 1, '', 110, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4509, '', 1, '', 311, 14, 40, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4510, '', 2, '', 248, 6, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4511, '', 1, '', 340, 5, 35, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4512, '', 5, '', 350, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4513, '', 4, '', 377, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4514, '', 5, '', 354, 34, 50, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4515, '', 1, '', 317, 4, 19, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4516, '', 2, '', 403, 2, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4517, '', 4, '', 178, 2, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4518, '', 1, '', 104, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4520, '', 2, '', 30, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4521, '', 2, '', 233, 21, 107, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4522, '', 2, '', 350, 3, 34, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4523, '', 8, '', 350, 5, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4525, '', 1, '', 78, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4526, '', 2, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4527, '', 1, '', 258, 7, 50, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4528, '', 2, '', 245, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4530, '', 1, '', 34, 6, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4531, '', 2, '', 345, 9, 59, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4532, '', 1, '', 77, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4533, '', 3, '', 40, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4534, '', 2, '', 252, 1, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4536, '', 1, '', 360, 15, 28, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4537, '', 2, '', 312, 25, 36, NULL, NULL, 212);
INSERT INTO "total" VALUES (4538, '', 2, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4540, '', 2, '', 171, 7, 50, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4541, '', 2, '', 38, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4543, '', 1, '', 384, 6, 40, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4544, '', 2, '', 361, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4545, '', 2, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4546, '', 2, '', 199, 5, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4547, '', 2, '', 361, 11, 47, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4548, '', 1, '', 331, 49, 38, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4549, '', 2, '', 288, 4, 21, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4551, '', 1, '', 188, 6, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4553, '', 1, '', 421, 23, 150, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4554, '', 2, '', 34, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4555, '', 3, '', 254, 4, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4556, '', 2, '', 104, 10, 24, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4557, '', 1, '', 238, 2, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4558, '', 1, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4561, '', 1, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4563, '', 1, '', 265, 37, 90, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4564, '', 1, '', 342, 22, 33, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4565, '', 3, '', 335, 38, 124, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4566, '', 1, '', 255, 7, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4567, '', 1, '', 196, 34, 114, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4568, '', 2, '', 161, 4, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4569, '', 1, '', 33, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4570, '', 1, '', 121, 4, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4571, '', 7, '', 272, 11, 88, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4572, '', 3, '', 221, 17, 90, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4573, '', 2, '', 199, 8, 21, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4577, '', 2, '', 32, NULL, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4578, '', 2, '', 369, 4, 57, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4579, '', 1, '', 129, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4580, '', 1, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4581, '', 2, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4582, '', 2, '', 40, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4583, '', 2, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4584, '', 1, '', 328, 17, 70, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4585, '', 2, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4588, '', 1, '', 345, 15, 34, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4589, '', 1, '', 359, 10, 70, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4590, '', 1, '', 205, 3, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4591, '', 1, '', 294, 11, 22, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4592, '', 1, '', 371, 14, 30, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4593, '', 1, '', 150, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4594, '', 2, '', 310, 17, 25, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4595, '', 1, '', 341, 4, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4596, '', 1, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4597, '', 3, '', 259, 6, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4598, '', 2, '', 350, 71, 140, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4599, '', 1, '', 344, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4600, '', 3, '', 260, 2, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4601, '', 3, '', 359, 1, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4602, '', 2, '', 187, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4603, '', 3, '', 36, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4604, '', 2, '', 97, 2, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4608, '', 2, '', 243, 4, 27, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4609, '', 2, '', 237, 2, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4610, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4614, '', 6, '', 337, 6, 30, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4615, '', 1, '', 25, NULL, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4619, '', 3, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4627, '', 1, '', 25, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4630, '', 2, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4632, '', 1, '', 328, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4635, '', 2, '', 85, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4636, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4637, '', 2, '', 31, 8, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4638, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4641, '', 2, '', 24, 4, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4644, '', 4, '', 275, 6, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4647, '', 1, '', 56, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4648, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4649, '', 2, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4654, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4657, '', 1, '', 24, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4661, '', 1, '', 363, 23, 41, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4664, '', 1, '', 259, 4, 25, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4665, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4666, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4667, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4671, '', 2, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4674, '', 2, '', 77, 1, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4675, '', 2, '', 165, 12, 39, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4676, '', 2, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4677, '', 1, '', 350, 4, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4678, '', 1, '', 310, 33, 103, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4679, '', 2, '', 121, 3, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4680, '', 2, '', 332, 16, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4681, '', 1, '', 359, 3, 28, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4682, '', 2, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4683, '', 1, '', 186, 3, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4684, '', 3, '', 243, 15, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4685, '', 1, '', 160, 5, 24, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4686, '', 2, '', 59, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4687, '', 2, '', 238, 1, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4688, '', 2, '', 357, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4689, '', 1, '', 204, NULL, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4690, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4691, '', 2, '', 175, NULL, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4692, '', 2, '', 52, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4694, '', 2, '', 300, 12, 36, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4696, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4698, '', 2, '', 305, 9, 48, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4700, '', 2, '', 63, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4702, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4706, '', 2, '', 58, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4707, '', 2, '', 159, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4710, '', 3, '', 217, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4711, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4713, '', 2, '', 231, NULL, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4716, '', 2, '', 348, 54, 78, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4717, '', 1, '', 371, 79, 55, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4718, '', 2, '', 67, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4719, '', 2, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4720, '', 2, '', 308, 5, 28, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4721, '', 3, '', 297, 7, 18, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4722, '', 3, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4723, '', 1, '', 402, 3, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4724, '', 3, '', 389, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4725, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4727, '', 3, '', 63, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4728, '', 2, '', 179, 4, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4729, '', 2, '', 360, 6, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4730, '', 2, '', 60, NULL, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4731, '', 2, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4732, '', 3, '', 267, 4, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4733, '', 2, '', 308, 4, 21, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4734, '', 2, '', 347, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4735, '', 3, '', 80, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4736, '', 1, '', 349, 7, 21, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4737, '', 2, '', 372, 7, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4738, '', 3, '', 380, 24, 23, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4739, '', 3, '', 371, 14, 23, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4740, '', 1, '', 387, 9, 25, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4741, '', 2, '', 25, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4742, '', 1, '', 226, 32, 48, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4743, '', 3, '', 301, 2, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4744, '', 4, '', 375, 3, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4745, '', 1, '', 363, 4, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4746, '', 4, '', 200, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4747, '', 2, '', 249, 3, 21, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4748, '', 2, '', 36, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4749, '', 3, '', 34, NULL, NULL, 26, NULL, NULL);
INSERT INTO "total" VALUES (4752, '', 3, '', 37, NULL, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4753, '', 3, '', 294, 16, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4754, '', 3, '', 50, NULL, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4761, '', 3, '', 92, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4763, '', 2, '', 37, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4764, '', 3, '', 1110, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4765, '', 1, '', 261, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4766, '', 2, '', 193, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4767, '', 2, '', 243, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4768, '', 4, '', 37, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4771, '', 1, '', 67, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4772, '', 1, '', 210, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4779, '', 4, '', 33, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (4780, '', 3, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5054, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5078, '', 1, '', 119, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5162, '', 1, '', 25, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5163, '', 1, '', 57, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5164, '', 1, '', 121, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5166, '', 2, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5174, '', 1, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5175, '', 2, '', 85, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5195, '', 3, '', 65, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5196, '', 1, '', 95, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5197, '', 1, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5198, '', 1, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5199, '', 1, '', 95, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5225, '', 1, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5226, '', 5, '', 110, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5227, '', 1, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5228, '', 3, '', 110, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5229, '', 2, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5230, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5231, '', 1, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5234, '', 3, '', 125, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5235, '', 2, '', 133, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5240, '', 2, '', 153, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5241, '', 3, '', 126, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5242, '', 1, '', 190, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5243, '', 1, '', 287, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5245, '', 2, '', 119, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5246, '', 6, '', 154, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5247, '', 2, '', 127, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5248, '', 1, '', 117, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5249, '', 4, '', 158, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5250, '', 3, '', 142, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5253, '', 2, '', 117, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5254, '', 3, '', 123, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5255, '', 4, '', 102, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5256, '', 2, '', 152, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5257, '', 3, '', 138, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5258, '', 1, '', 103, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5261, '', 1, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5262, '', 2, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5263, '', 7, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5264, '', 5, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5265, '', 4, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5267, '', 3, '', 122, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5268, '', 5, '', 162, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5269, '', 1, '', 47, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5270, '', 4, '', 139, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5271, '', 3, '', 133, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5272, '', 2, '', 131, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5286, '', 3, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5287, '', 6, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5288, '', 4, '', 110, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5289, '', 4, '', 130, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5290, '', 1, '', 110, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5291, '', 5, '', 110, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5292, '', 1, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5293, '', 2, '', 130, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5294, '', 3, '', 110, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5295, '', 1, '', 45, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5330, '', 4, '', 105, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5331, '', 3, '', 127, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5332, '', 2, '', 125, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5334, '', 2, '', 131, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5335, '', 3, '', 143, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5336, '', 2, '', 136, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5337, '', 2, '', 147, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5338, '', 7, '', 136, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5346, '', 4, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5347, '', 3, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5348, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5409, '', 1, '', 66, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5410, '', 2, '', 78, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5411, '', 1, '', 67, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5412, '', 5, '', 144, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5413, '', 1, '', 120, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5414, '', 6, '', 132, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5415, '', 6, '', 135, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5416, '', 2, '', 135, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5418, '', 1, '', 83, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5419, '', 1, '', 99, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5420, '', 1, '', 85, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5424, '', 1, '', 89, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5430, '', 1, '', 95, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5434, '', 7, '', 166, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5447, '', 1, '', 187, 37, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5449, '', 8, '', 150, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5450, '', 1, '', 160, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5451, '', 1, '', 94, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5459, '', 1, '', 44, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5460, '', 7, '', 150, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5461, '', 2, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5462, '', 2, '', 150, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5469, '', 1, '', 117, 31, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5470, '', 1, '', 131, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5471, '', 2, '', 148, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5472, '', 3, '', 135, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5473, '', 2, '', 147, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5474, '', 2, '', 195, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5475, '', 4, '', 166, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5476, '', 6, '', 184, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5477, '', 7, '', 149, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5478, '', 4, '', 165, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5479, '', 1, '', 119, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5480, '', 1, '', NULL, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5482, '', 3, '', 144, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5483, '', 3, '', 155, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5484, '', 8, '', 172, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5485, '', 1, '', 99, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5486, '', 1, '', 122, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5487, '', 8, '', 155, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5488, '', 8, '', 158, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5489, '', 1, '', 80, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5490, '', 1, '', 94, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5494, '', 1, '', 171, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5498, '', 1, '', 208, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5499, '', 1, '', 108, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5504, '', 1, '', 106, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5505, '', 5, '', 169, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5514, '', 1, '', 135, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5515, '', 2, '', 144, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5517, '', 9, '', 176, 13, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5518, '', 1, '', 170, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5520, '', 1, '', 114, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5522, '', 1, '', 74, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5524, '', 1, '', 104, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5534, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5535, '', 1, '', 77, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5536, '', 2, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5538, '', 1, '', 70, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5539, '', 1, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5540, '', 2, '', 90, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5541, '', 1, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5542, '', 2, '', 90, 10, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5543, '', 1, '', NULL, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5544, '', 1, '', NULL, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5545, '', 1, '', 87, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5546, '', 5, '', 146, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5547, '', 5, '', 140, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5554, '', 1, '', 146, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5564, '', 1, '', 76, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5568, '', 2, '', 51, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5571, '', 1, '', 76, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5572, '', 1, '', 92, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5573, '', 1, '', 121, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5574, '', 1, '', 73, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5575, '', 1, '', 96, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5576, '', 1, '', 110, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5577, '', 2, '', 91, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5578, '', 2, '', 111, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5579, '', 1, '', 82, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5580, '', 1, '', 111, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5581, '', 2, '', 113, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5582, '', 1, '', 111, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5583, '', 1, '', 84, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5584, '', 2, '', 91, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5585, '', 2, '', 88, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5589, '', 1, '', 79, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5590, '', 6, '', 115, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5593, '', 1, '', 129, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5594, '', 2, '', NULL, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5595, '', 2, '', NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5596, '', 4, '', NULL, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5597, '', 1, '', 125, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5598, '', 2, '', 157, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5599, '', 1, '', NULL, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5600, '', 1, '', 119, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5601, '', 2, '', NULL, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5602, '', 1, '', 99, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5603, '', 1, '', NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5604, '', 1, '', NULL, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5620, '', 2, '', 149, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5621, '', 3, '', 130, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5640, '', 1, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5641, '', 1, '', 60, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5652, '', 2, '', 113, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5653, '', 1, '', 74, 5, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5654, '', 2, '', 134, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5656, '', 2, '', 72, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5657, '', 3, '', 136, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5658, '', 2, '', 130, 15, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5689, '', 1, '', 103, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5691, '', 3, '', 109, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5700, '', 3, '', 134, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5718, '', 2, '', 12, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5719, '', 3, '', 50, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5730, '', 1, '', 39, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5731, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5749, '', 3, '', 132, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5814, '', 1, '', 124, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5816, '', 1, '', 125, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5820, '', 5, '', 109, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5858, '', 1, '', NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5863, '', 2, '', 62, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5865, '', 1, '', NULL, 2, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5866, '', 1, '', NULL, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5868, '', 2, '', NULL, 7, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5869, '', 4, '', NULL, NULL, 60, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5875, '', 1, '', NULL, 7, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5878, '', 1, '', NULL, 2, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5885, '', 1, '', 76, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5904, '', 2, '', 106, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5911, '', 3, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5943, '', 2, '', 117, 1, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5944, '', 2, '', 119, 7, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5945, '', 3, '', 114, 2, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5946, '', 1, '', 120, 2, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5961, '', 1, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5991, '', 3, '', 104, NULL, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5992, '', 2, '', 124, 3, 26, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5995, '', 1, '', 53, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5996, '', 3, '', 110, 1, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (5998, '', 3, '', 125, NULL, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6007, '', 3, '', 106, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6008, '', 3, '', 136, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6011, '', 1, '', 102, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6012, '', 4, '', 84, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6013, '', 3, '', 102, 8, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6014, '', 4, '', 93, 2, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6017, '', 4, '', 145, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6028, '', 2, '', 117, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6029, '', 3, '', 119, 1, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6030, '', 2, '', 93, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6031, '', 2, '', 95, 1, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6036, '', 4, '', 112, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6050, '', 2, '', 126, 2, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6051, '', 1, '', 122, 1, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6052, '', 3, '', 120, 1, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6068, '', 2, '', 113, 1, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6069, '', 5, '', 84, 2, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6071, '', 5, '', 112, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6072, '', 2, '', 135, 2, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6090, '', 2, '', 66, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6091, '', 2, '', 132, 8, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6092, '', 3, '', 107, 2, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6093, '', 2, '', 77, 2, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6107, '', 2, '', 130, 1, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6108, '', 5, '', 90, 1, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6109, '', 1, '', 99, NULL, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6110, '', 1, '', 99, 1, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6111, '', 3, '', 134, 1, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6117, '', 2, '', 65, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6127, '', 4, '', 90, NULL, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6128, '', 3, '', 86, 2, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6129, '', 1, '', 100, 1, 18, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6135, '', 1, '', 18, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6145, '', 1, '', 125, NULL, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6146, '', 1, '', 129, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6147, '', 4, '', 124, 2, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6159, '', 2, '', 144, 5, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6160, '', 1, '', 99, 4, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6161, '', 1, '', 128, 2, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6162, '', 1, '', 127, NULL, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6163, '', 1, '', 127, 2, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6164, '', 2, '', 70, 3, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6168, '', 5, '', 137, NULL, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6178, '', 1, '', 100, NULL, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6179, '', 2, '', 128, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6180, '', 6, '', 132, 4, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6181, '', 3, '', 100, 3, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6182, '', 2, '', 100, 4, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6186, '', 1, '', 140, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6196, '', 1, '', 134, 1, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6197, '', 1, '', 94, NULL, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6198, '', 1, '', 84, 2, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6199, '', 5, '', 155, NULL, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6200, '', 4, '', 162, NULL, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6206, '', 1, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6207, '', 1, '', 75, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6208, '', 1, '', 66, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6214, '', 1, '', 130, 1, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6220, '', 2, '', 98, 3, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6221, '', 3, '', 96, 2, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6222, '', 1, '', 101, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6223, '', 5, '', 135, NULL, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6224, '', 2, '', 130, 6, 23, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6225, '', 2, '', 134, 4, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6226, '', 2, '', 130, 3, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6244, '', 3, '', 130, 2, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6245, '', 2, '', 91, 5, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6246, '', 1, '', 137, NULL, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6262, '', 4, '', 130, 1, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6263, '', 2, '', 98, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6264, '', 2, '', 130, 1, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6265, '', 3, '', 97, 2, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6266, '', 1, '', 99, 1, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6267, '', 2, '', 98, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6268, '', 3, '', 136, 3, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6278, '', 1, '', 50, 2, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6282, '', 2, '', 121, 5, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6283, '', 1, '', 112, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6284, '', 1, '', NULL, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6285, '', 2, '', 125, 1, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6289, '', 2, '', 96, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6301, '', 5, '', 120, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6302, '', 3, '', 122, 3, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6303, '', 2, '', 96, NULL, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6304, '', 2, '', 91, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6305, '', 2, '', 123, NULL, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6320, '', 2, '', 114, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6327, '', 3, '', 115, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6328, '', 3, '', 110, 1, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6329, '', 2, '', 95, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6331, '', 4, '', 92, 2, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6332, '', 3, '', 110, 2, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6333, '', 1, '', 119, NULL, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6337, '', 4, '', 45, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6338, '', 2, '', 45, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6339, '', 3, '', 91, 1, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6357, '', 1, '', 91, 2, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6358, '', 1, '', 108, 5, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6359, '', 2, '', 113, 1, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6360, '', 2, '', 110, 3, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6361, '', 4, '', 114, 1, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6409, '', 1, '', NULL, 10, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6410, '', 3, '', NULL, 2, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6411, '', 3, '', NULL, NULL, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6412, '', 5, '', NULL, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6413, '', 2, '', NULL, 2, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6414, '', 4, '', NULL, NULL, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6428, '', 1, '', NULL, 1, 24, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6429, '', 2, '', NULL, 1, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6435, '', 2, '', NULL, 2, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6436, '', 5, '', NULL, 2, 21, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6437, '', 2, '', NULL, 3, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6438, '', 4, '', NULL, NULL, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6439, '', 3, '', NULL, 2, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6478, '', 1, '', NULL, NULL, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6479, '', 1, '', NULL, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6480, '', 3, '', NULL, 3, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6481, '', 4, '', NULL, 6, 30, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6483, '', 4, '', NULL, 4, 24, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6484, '', 2, '', NULL, 1, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6485, '', 1, '', NULL, NULL, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6486, '', 2, '', NULL, 3, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6514, '', 1, '', NULL, 19, 49, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6515, '', 5, '', NULL, 1, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6516, '', 2, '', NULL, 17, 32, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6517, '', 6, '', NULL, 14, 30, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6518, '', 3, '', NULL, 1, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6519, '', 5, '', NULL, 2, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6520, '', 2, '', NULL, 16, 18, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6540, '', 1, '', 80, 2, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6541, '', 2, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6543, '', 2, '', NULL, 2, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6544, '', 3, '', NULL, NULL, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6545, '', 1, '', NULL, 2, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6546, '', 4, '', NULL, 1, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6547, '', 1, '', NULL, NULL, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6548, '', 2, '', 100, 3, 18, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6549, '', 7, '', 100, 3, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6550, '', 5, '', 85, 3, 22, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6552, '', 2, '', 65, 1, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6553, '', 4, '', 100, 1, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6554, '', 1, '', 65, 2, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6555, '', 3, '', 60, 4, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6556, '', 2, '', 85, 4, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6557, '', 2, '', 100, NULL, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6558, '', 2, '', 65, 2, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6559, '', 3, '', 95, 1, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6560, '', 4, '', 100, 4, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6561, '', 5, '', 85, 4, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6562, '', 3, '', 100, 9, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6563, '', 3, '', 90, 2, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6564, '', 3, '', 100, 2, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6567, '', 2, '', 85, NULL, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6569, '', 1, '', 5, 2, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6571, '', 2, '', 80, NULL, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6573, '', 3, '', 80, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6585, '', 4, '', NULL, 1, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6586, '', 1, '', NULL, 4, 21, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6587, '', 1, '', NULL, 6, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6588, '', 1, '', NULL, 1, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6601, '', 2, '', NULL, 2, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6602, '', 1, '', NULL, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6603, '', 3, '', NULL, 2, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6604, '', 2, '', NULL, NULL, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6605, '', 1, '', NULL, NULL, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6606, '', 3, '', NULL, 1, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6607, '', 1, '', NULL, 2, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6608, '', 1, '', NULL, 3, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6609, '', 4, '', NULL, 3, 18, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6610, '', 2, '', NULL, 3, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6611, '', 2, '', NULL, 5, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6612, '', 3, '', NULL, 2, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6613, '', 6, '', NULL, 10, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6614, '', 1, '', NULL, NULL, 24, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6615, '', 1, '', NULL, 11, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6616, '', 2, '', NULL, 11, 21, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6617, '', 2, '', NULL, 4, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6618, '', 3, '', NULL, 13, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6619, '', 2, '', NULL, 8, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6620, '', 4, '', NULL, 6, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6621, '', 4, '', NULL, 1, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6622, '', 3, '', NULL, 8, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6623, '', 1, '', NULL, 4, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6624, '', 1, '', NULL, 6, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6625, '', 3, '', NULL, 4, 31, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6626, '', 3, '', NULL, 1, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6627, '', 2, '', NULL, 3, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6628, '', 4, '', NULL, 20, 24, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6629, '', 1, '', NULL, 2, 22, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6630, '', 1, '', NULL, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6637, '', 6, '', NULL, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6638, '', 4, '', NULL, 3, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6639, '', 3, '', NULL, 5, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6640, '', 2, '', NULL, 5, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6641, '', 4, '', NULL, 6, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6642, '', 6, '', NULL, 4, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6643, '', 1, '', NULL, 2, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6645, '', 4, '', NULL, 3, 21, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6646, '', 1, '', NULL, 2, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6647, '', 7, '', NULL, 3, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6648, '', 2, '', NULL, NULL, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6649, '', 1, '', NULL, NULL, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6651, '', 4, '', NULL, 3, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6653, '', 2, '', NULL, 1, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6654, '', 2, '', NULL, 2, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6655, '', 3, '', NULL, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6656, '', 5, '', NULL, 4, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6657, '', 2, '', NULL, 2, 18, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6658, '', 2, '', NULL, 3, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6659, '', 1, '', NULL, NULL, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6660, '', 5, '', NULL, 3, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6661, '', 3, '', NULL, 3, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6662, '', 5, '', NULL, 2, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6663, '', 1, '', NULL, 2, 21, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6664, '', 1, '', NULL, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6685, '', 4, '', NULL, 1, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6686, '', 4, '', NULL, 1, 19, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6687, '', 2, '', NULL, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6688, '', 2, '', NULL, NULL, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6689, '', 4, '', NULL, 1, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6690, '', 2, '', NULL, 1, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6691, '', 2, '', NULL, 1, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6692, '', 1, '', NULL, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6693, '', 1, '', NULL, 1, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6694, '', 4, '', NULL, 1, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6696, '', 3, '', NULL, 4, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6697, '', 2, '', NULL, 4, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6698, '', 3, '', NULL, 2, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6699, '', 4, '', NULL, 3, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6700, '', 2, '', NULL, 3, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6707, '', 2, '', NULL, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6720, '', 4, '', NULL, 6, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6721, '', 3, '', NULL, 4, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6722, '', 3, '', NULL, 6, 30, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6723, '', 3, '', NULL, 2, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6724, '', 5, '', NULL, 1, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6725, '', 5, '', NULL, 2, 22, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6726, '', 2, '', NULL, 6, 42, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6727, '', 3, '', NULL, 2, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6728, '', 2, '', NULL, 6, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6729, '', 2, '', NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6734, '', 1, '', 80, 36, 31, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6746, '', 1, '', NULL, 3, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6747, '', 6, '', NULL, NULL, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6748, '', 2, '', NULL, 4, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6749, '', 1, '', NULL, NULL, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6751, '', 2, '', NULL, 5, 19, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6754, '', 2, '', 60, NULL, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6757, '', 2, '', 97, 5, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6777, '', 5, '', NULL, 3, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6779, '', 3, '', NULL, 2, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6780, '', 6, '', NULL, 1, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6781, '', 4, '', NULL, 12, 26, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6782, '', 3, '', NULL, 2, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6783, '', 1, '', NULL, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6784, '', 5, '', NULL, 5, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6785, '', 2, '', NULL, 5, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6786, '', 4, '', NULL, 3, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6787, '', 6, '', NULL, 5, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6788, '', 2, '', NULL, 5, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6789, '', 2, '', NULL, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6806, '', 3, '', NULL, 2, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6809, '', 1, '', NULL, 2, 19, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6810, '', 5, '', NULL, 2, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6811, '', 7, '', NULL, 2, 19, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6812, '', 1, '', 88, 2, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6832, '', 6, '', 143, 1, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6833, '', 4, '', 95, 8, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6834, '', 2, '', 85, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6835, '', 1, '', 103, 9, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6866, '', 3, '', 96, 1, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6868, '', 1, '', 105, NULL, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6869, '', 1, '', 100, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6889, '', 2, '', 118, 2, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6890, '', 1, '', 125, 2, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6897, '', 2, '', 89, 13, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6898, '', 2, '', 105, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6899, '', 5, '', 100, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6900, '', 2, '', NULL, 2, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6902, '', 1, '', 50, NULL, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6906, '', 2, '', 97, 6, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6922, '', 2, '', 119, 8, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6926, '', 1, '', 76, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6927, '', 3, '', 117, 3, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6930, '', 1, '', 96, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6934, '', 1, '', 99, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6940, '', 1, '', 131, 3, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6948, '', 6, '', 158, 4, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6949, '', 4, '', 91, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6950, '', 1, '', 76, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6951, '', 1, '', 84, 1, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6980, '', 1, '', 91, 3, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6981, '', 1, '', 75, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6982, '', 2, '', 88, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6987, '', 2, '', 80, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6994, '', 2, '', 90, NULL, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6995, '', 1, '', 114, NULL, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6996, '', 1, '', 117, 6, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (6997, '', 3, '', 119, 1, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7016, '', 1, '', 92, 4, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7018, '', 1, '', 92, 6, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7019, '', 4, '', 91, 3, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7020, '', 2, '', 116, NULL, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7021, '', 4, '', 105, 6, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7022, '', 3, '', 85, 2, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7032, '', 4, '', 118, NULL, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7033, '', 1, '', 117, 5, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7034, '', 1, '', 108, 3, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7053, '', 3, '', 81, 3, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7055, '', 3, '', 81, 6, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7064, '', 6, '', 124, 3, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7065, '', 6, '', 109, 4, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7067, '', 4, '', 89, 2, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7083, '', 1, '', 83, 4, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7084, '', 3, '', 85, 4, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7090, '', 2, '', 99, 13, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7101, '', 2, '', 80, 8, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7128, '', 2, '', 83, 5, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7129, '', 1, '', NULL, 1, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7131, '', 3, '', 84, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7132, '', 4, '', 86, 3, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7133, '', 4, '', NULL, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7134, '', 1, '', NULL, 10, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7136, '', 1, '', 99, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7137, '', 2, '', 90, 2, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7138, '', 2, '', NULL, 9, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7139, '', 2, '', 116, 8, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7140, '', 1, '', 112, 6, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7141, '', 2, '', 93, 4, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7142, '', 1, '', 115, 1, 24, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7144, '', 1, '', 104, 2, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7145, '', 6, '', 94, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7146, '', 2, '', 109, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7147, '', 1, '', 82, 11, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7149, '', 4, '', 82, 8, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7155, '', 3, '', 110, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7156, '', 3, '', 108, 6, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7157, '', 1, '', 117, 8, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7158, '', 1, '', 83, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7160, '', 2, '', 83, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7161, '', 3, '', 86, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7163, '', 1, '', 87, 3, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7164, '', 1, '', 108, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7165, '', 5, '', 83, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7167, '', 4, '', 85, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7173, '', 1, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7176, '', 1, '', 70, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7192, '', 3, '', 75, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7193, '', 3, '', 75, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7195, '', 4, '', 111, 1, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7196, '', 2, '', 118, NULL, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7197, '', 4, '', 118, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7198, '', 3, '', 89, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7200, '', 8, '', 88, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7201, '', 1, '', 70, NULL, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7202, '', 1, '', 65, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7216, '', 4, '', 110, 3, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7217, '', 6, '', 86, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7218, '', 5, '', 116, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7219, '', 3, '', 58, 13, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7221, '', 1, '', 91, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7222, '', 4, '', 78, 1, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7224, '', 1, '', 83, 6, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7226, '', 1, '', 90, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7236, '', 2, '', 88, NULL, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7237, '', 1, '', 107, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7239, '', 1, '', 90, 3, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7240, '', 3, '', 91, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7244, '', 1, '', 111, 3, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7263, '', 2, '', 69, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7265, '', 4, '', 85, 7, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7266, '', 3, '', 84, 7, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7276, '', 4, '', NULL, 16, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7279, '', 2, '', 111, 2, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7280, '', 1, '', 101, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7281, '', 1, '', 82, 2, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7282, '', 3, '', 125, 2, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7283, '', 5, '', 125, 8, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7284, '', 1, '', 108, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7285, '', 3, '', 117, NULL, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7286, '', 2, '', 88, 2, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7287, '', 1, '', 81, NULL, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7288, '', 2, '', 74, 2, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7289, '', 2, '', NULL, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7290, '', 4, '', 80, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7291, '', 2, '', 97, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7292, '', 1, '', NULL, 2, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7293, '', 5, '', 80, 6, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7294, '', 2, '', 76, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7295, '', 1, '', 84, 9, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7301, '', 2, '', NULL, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7303, '', 3, '', 81, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7304, '', 1, '', NULL, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7305, '', 1, '', NULL, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7306, '', 3, '', 90, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7307, '', 2, '', NULL, NULL, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7309, '', 1, '', NULL, 13, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7310, '', 1, '', NULL, 3, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7311, '', 2, '', 104, 12, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7312, '', 2, '', 106, 6, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7314, '', 3, '', 79, 6, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7315, '', 1, '', 53, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7329, '', 1, '', 147, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7335, '', 4, '', 93, 18, 40, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7336, '', 3, '', 93, 30, 36, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7337, '', 3, '', 96, 9, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7348, '', 3, '', 102, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7349, '', 1, '', 94, 3, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7352, '', 2, '', 87, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7359, '', 1, '', 92, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7361, '', 1, '', 92, NULL, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7362, '', 6, '', 81, 11, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7364, '', 2, '', NULL, 4, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7365, '', 1, '', NULL, 4, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7366, '', 2, '', NULL, NULL, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7367, '', 2, '', NULL, 2, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7369, '', 4, '', NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7370, '', 2, '', NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7372, '', 3, '', NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7381, '', 1, '', NULL, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7388, '', 2, '', NULL, 1, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7390, '', 1, '', NULL, 2, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7391, '', 1, '', NULL, 1, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7395, '', 2, '', NULL, 3, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7397, '', 4, '', NULL, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7403, '', 1, '', NULL, 3, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7525, '', 4, '', NULL, 1, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7527, '', 4, '', NULL, 7, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7532, '', 4, '', NULL, 7, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7541, '', 1, '', NULL, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7542, '', 4, '', NULL, 4, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7543, '', 1, '', NULL, 1, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7544, '', 3, '', NULL, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7545, '', 1, '', NULL, 3, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7546, '', 2, '', NULL, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7550, '', 1, '', NULL, 4, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7551, '', 4, '', NULL, 1, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7552, '', 2, '', NULL, 2, 19, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7568, '', 1, '', NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7569, '', 2, '', NULL, 2, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7570, '', 4, '', NULL, 3, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7571, '', 2, '', NULL, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7575, '', 3, '', 135, NULL, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7576, '', 3, '', NULL, 1, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7577, '', 1, '', NULL, 14, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7578, '', 1, '', NULL, 2, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7579, '', 2, '', NULL, 3, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7580, '', 2, '', NULL, 3, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7582, '', 2, '', NULL, 3, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7590, '', 3, '', NULL, NULL, 18, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7591, '', 2, '', NULL, 2, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7594, '', 1, '', NULL, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7596, '', 2, '', NULL, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7598, '', 2, '', NULL, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7608, '', 4, '', NULL, 5, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7618, '', 3, '', NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7619, '', 1, '', NULL, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7620, '', 1, '', NULL, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7621, '', 2, '', NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7622, '', 3, '', NULL, 2, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7623, '', 5, '', NULL, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7626, '', 3, '', NULL, 4, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7627, '', 3, '', NULL, 3, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7628, '', 1, '', 110, 4, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7632, '', 7, '', NULL, 5, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7638, '', 4, '', NULL, 1, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7639, '', 1, '', NULL, NULL, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7640, '', 3, '', NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7641, '', 3, '', NULL, 1, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7642, '', 3, '', NULL, 1, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7644, '', 4, '', NULL, 14, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7645, '', 3, '', NULL, 11, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7646, '', 3, '', NULL, 3, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7647, '', 2, '', NULL, 3, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7657, '', 3, '', NULL, 3, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7658, '', 2, '', NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7660, '', 6, '', NULL, 4, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7661, '', 1, '', NULL, 4, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7662, '', 3, '', NULL, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7665, '', 3, '', NULL, 4, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7666, '', 4, '', NULL, 4, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7677, '', 2, '', NULL, 2, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7678, '', 3, '', NULL, 2, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7679, '', 3, '', NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7680, '', 5, '', NULL, 1, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7681, '', 2, '', NULL, 2, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7682, '', 1, '', NULL, 3, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7683, '', 4, '', NULL, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7684, '', 1, '', NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7685, '', 1, '', NULL, 3, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7686, '', 5, '', NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7690, '', 5, '', NULL, 6, 26, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7701, '', 4, '', NULL, 11, 23, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7702, '', 4, '', NULL, 3, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7703, '', 3, '', NULL, 3, 18, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7704, '', 4, '', NULL, 2, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7707, '', 3, '', 115, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7708, '', 1, '', 115, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7709, '', 1, '', 118, NULL, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7710, '', 1, '', 103, 3, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7711, '', 3, '', 107, 3, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7712, '', 4, '', 110, 4, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7713, '', 2, '', NULL, 6, 45, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7714, '', 2, '', 143, 10, 32, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7723, '', 2, '', 184, 11, 41, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7724, '', 4, '', 108, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7725, '', 2, '', 193, 1, 36, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7726, '', 1, '', 103, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7727, '', 1, '', 110, 6, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7730, '', 3, '', 116, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7736, '', 4, '', 148, 3, 29, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7748, '', 2, '', 106, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7749, '', 3, '', 150, 1, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7750, '', 5, '', 148, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7751, '', 1, '', 121, NULL, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7752, '', 2, '', 100, NULL, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7759, '', 4, '', 125, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7763, '', 5, '', 111, 5, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7775, '', 4, '', 137, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7776, '', 2, '', 136, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7777, '', 5, '', 108, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7778, '', 4, '', 105, 2, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7779, '', 2, '', 113, 3, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7780, '', 1, '', 112, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7781, '', 1, '', 105, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7782, '', 1, '', 109, 2, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7785, '', 3, '', 117, 12, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7786, '', 1, '', 106, 1, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7787, '', 1, '', 106, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7788, '', 3, '', 130, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7789, '', 3, '', 124, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7798, '', 5, '', 118, 3, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7799, '', 5, '', 114, 3, 18, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7800, '', 6, '', 112, 6, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7801, '', 4, '', 143, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7802, '', 1, '', 108, 2, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7803, '', 1, '', 113, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7804, '', 1, '', 113, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7805, '', 1, '', 111, 2, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7812, '', 3, '', 109, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7813, '', 5, '', 135, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7814, '', 3, '', 133, NULL, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7817, '', 5, '', 133, 6, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7818, '', 3, '', 125, 6, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7827, '', 2, '', 140, 4, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7828, '', 2, '', 102, 4, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7829, '', 1, '', 112, 3, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7830, '', 1, '', 101, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7831, '', 1, '', 118, 1, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7832, '', 2, '', 107, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7836, '', 5, '', 101, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7837, '', 2, '', 102, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7838, '', 4, '', 131, NULL, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7839, '', 3, '', 134, 3, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7840, '', 2, '', 101, 8, 28, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7843, '', 3, '', 103, 5, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7844, '', 4, '', 153, NULL, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7855, '', 3, '', 105, 8, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7856, '', 4, '', 110, 2, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7857, '', 1, '', 103, 3, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7858, '', 2, '', 103, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7859, '', 2, '', 108, 3, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7860, '', 2, '', 110, 5, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7861, '', 2, '', 104, NULL, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7862, '', 4, '', 161, 2, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7866, '', 1, '', 118, 15, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7873, '', 2, '', 112, 6, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7874, '', 5, '', 120, 7, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7875, '', 4, '', 138, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7876, '', 2, '', 107, 5, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7877, '', 1, '', 84, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7880, '', 2, '', 126, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7881, '', 2, '', 102, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7882, '', 2, '', 106, NULL, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7883, '', 5, '', 117, 12, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7885, '', 4, '', 117, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7886, '', 3, '', 129, 3, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7891, '', 5, '', 114, 4, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7892, '', 1, '', 118, 10, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7893, '', 4, '', 125, 8, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7894, '', 1, '', 110, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7896, '', 3, '', NULL, 3, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7898, '', 3, '', 129, 9, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7899, '', 2, '', 127, 4, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7903, '', 2, '', 114, 12, 22, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7904, '', 2, '', 97, 6, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7905, '', 1, '', 116, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7906, '', 1, '', 113, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7907, '', 1, '', 103, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7910, '', 4, '', 109, 3, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7912, '', 3, '', 123, 5, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7913, '', 3, '', 122, 4, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7916, '', 5, '', 122, 7, 26, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7917, '', 4, '', 137, 1, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7927, '', 1, '', 119, 25, 18, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7928, '', 1, '', 97, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7929, '', 1, '', 110, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7930, '', 3, '', 106, 3, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7931, '', 1, '', 114, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7932, '', 2, '', 110, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7933, '', 2, '', 115, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7936, '', 3, '', 121, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7937, '', 5, '', 125, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7941, '', 3, '', 120, 8, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7942, '', 1, '', 95, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7943, '', 1, '', 95, 2, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7948, '', 1, '', 93, 3, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7956, '', 2, '', 105, NULL, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7957, '', 1, '', 110, 5, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7958, '', 2, '', 95, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7959, '', 3, '', 98, 2, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7961, '', 2, '', 121, 20, 35, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7962, '', 4, '', 125, 2, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7963, '', 3, '', 125, 3, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7967, '', 3, '', 120, 3, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7977, '', 3, '', 116, 7, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7978, '', 5, '', 143, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7979, '', 1, '', 101, 5, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7980, '', 1, '', 92, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7981, '', 1, '', 98, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7982, '', 2, '', 100, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7983, '', 1, '', 103, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7984, '', 2, '', 102, NULL, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7985, '', 4, '', 101, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7989, '', 2, '', 122, 10, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7990, '', 3, '', 120, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (7992, '', 1, '', 120, NULL, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8003, '', 2, '', 105, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8004, '', 2, '', 137, 2, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8005, '', 3, '', 107, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8007, '', 1, '', 105, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8008, '', 1, '', 103, 2, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8009, '', 2, '', 112, NULL, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8010, '', 1, '', 97, 1, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8011, '', 5, '', 135, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8012, '', 1, '', 109, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8013, '', 5, '', 120, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8016, '', 3, '', 40, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8017, '', 2, '', 123, 5, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8027, '', 2, '', 126, 2, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8028, '', 5, '', 97, 4, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8029, '', 3, '', 103, 5, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8030, '', 1, '', 103, 6, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8031, '', 1, '', 99, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8032, '', 5, '', 98, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8033, '', 2, '', 101, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8034, '', 1, '', 118, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8039, '', 3, '', 119, 3, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8040, '', 2, '', 112, 2, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8041, '', 2, '', 117, 13, 36, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8047, '', 4, '', 106, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8048, '', 4, '', 102, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8049, '', 2, '', 109, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8051, '', 4, '', 122, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8052, '', 1, '', 96, 2, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8053, '', 3, '', 111, 2, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8054, '', 3, '', 121, 4, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8055, '', 1, '', 101, 10, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8056, '', 2, '', 117, 8, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8057, '', 6, '', 131, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8058, '', 2, '', 125, NULL, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8061, '', 2, '', 121, 3, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8068, '', 6, '', 126, NULL, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8069, '', 2, '', 122, 2, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8070, '', 4, '', 103, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8071, '', 4, '', 118, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8072, '', 3, '', 110, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8073, '', 1, '', NULL, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8074, '', 1, '', 105, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8075, '', 2, '', NULL, 8, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8076, '', 3, '', 130, 1, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8078, '', 3, '', 119, 8, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8081, '', 2, '', 110, 3, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8083, '', 1, '', 80, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8087, '', 1, '', 37, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8088, '', 1, '', 37, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8089, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8091, '', 1, '', 144, 10, 21, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8092, '', 1, '', NULL, 8, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8093, '', 3, '', 141, 9, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8094, '', 1, '', 38, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8095, '', 6, '', 101, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8097, '', 4, '', 40, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8098, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8099, '', 1, '', 121, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8101, '', 3, '', 122, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8102, '', 6, '', 123, NULL, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8103, '', 1, '', 95, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8104, '', 4, '', 119, 17, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8106, '', 3, '', 105, 9, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8107, '', 1, '', 42, 4, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8108, '', 3, '', 132, 2, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8109, '', 1, '', 40, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8110, '', 1, '', 110, 4, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8111, '', 1, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8112, '', 1, '', 23, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8113, '', 1, '', 41, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8115, '', 1, '', 47, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8116, '', 1, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8117, '', 1, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8118, '', 1, '', 39, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8119, '', 1, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8120, '', 3, '', 120, 9, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8121, '', 7, '', 160, 11, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8122, '', 1, '', 134, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8123, '', 1, '', 20, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8125, '', 1, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8126, '', 1, '', NULL, 5, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8128, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8129, '', 1, '', 42, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8130, '', 1, '', 106, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8131, '', 1, '', 113, 16, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8133, '', 1, '', 106, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8134, '', 1, '', 106, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8135, '', 1, '', 105, 3, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8137, '', 1, '', 45, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8138, '', 1, '', 107, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8139, '', 1, '', 140, 1, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8140, '', 3, '', 136, 1, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8141, '', 1, '', 66, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8144, '', 1, '', 39, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8145, '', 1, '', 51, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8146, '', 1, '', 45, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8147, '', 1, '', 37, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8148, '', 2, '', 38, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8149, '', 1, '', 38, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8150, '', 1, '', 28, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8152, '', 1, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8153, '', 1, '', 86, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8154, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8155, '', 1, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8156, '', 1, '', 35, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8157, '', 1, '', NULL, 2, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8158, '', 1, '', 107, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8159, '', 1, '', 39, 9, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8160, '', 1, '', 29, 6, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8161, '', 1, '', 109, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8162, '', 1, '', 58, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8163, '', 1, '', 91, 2, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8164, '', 2, '', 91, NULL, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8165, '', 1, '', 86, NULL, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8166, '', 2, '', 150, NULL, 11, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8167, '', 2, '', 159, 5, 23, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8169, '', 1, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8170, '', 1, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8171, '', 1, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8172, '', 1, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8173, '', 1, '', 29, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8174, '', 1, '', 36, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8188, '', 2, '', 109, 3, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8189, '', 1, '', 110, NULL, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8191, '', 3, '', 117, NULL, 22, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8192, '', 2, '', 100, 3, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8194, '', 2, '', 34, 5, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8195, '', 1, '', 37, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8196, '', 2, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8197, '', 2, '', 38, 2, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8198, '', 2, '', 28, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8199, '', 2, '', 30, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8200, '', 2, '', 32, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8201, '', 1, '', 100, 6, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8202, '', 2, '', 32, 6, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8203, '', 2, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8204, '', 1, '', 36, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8205, '', 2, '', 119, 2, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8206, '', 1, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8208, '', 1, '', 5, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8209, '', 3, '', 32, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8210, '', 1, '', 46, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8211, '', 1, '', 110, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8212, '', 1, '', 118, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8213, '', 1, '', 56, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8216, '', 3, '', 108, 4, 16, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8217, '', 2, '', 109, 6, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8219, '', 2, '', 104, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8220, '', 1, '', 33, 4, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8222, '', 1, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8223, '', 2, '', 38, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8224, '', 1, '', 373, 31, 114, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8225, '', 1, '', 288, 4, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8226, '', 3, '', 202, 3, 50, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8227, '', 1, '', 166, 10, 45, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8228, '', 1, '', 41, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8229, '', 2, '', 30, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8233, '', 2, '', 41, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8234, '', 2, '', 71, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8238, '', 1, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8239, '', 1, '', 28, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8240, '', 1, '', 160, 1, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8241, '', 1, '', 123, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8242, '', 1, '', 117, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8243, '', 1, '', 142, 5, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8244, '', 1, '', 122, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8245, '', 1, '', 122, 2, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8247, '', 1, '', 24, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8248, '', 1, '', 41, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8249, '', 1, '', 38, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8250, '', 2, '', 31, 3, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8251, '', 2, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8253, '', 1, '', 29, 6, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8254, '', 3, '', 31, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8255, '', 2, '', 30, 4, 6, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8256, '', 2, '', 39, 6, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8257, '', 1, '', NULL, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8258, '', 1, '', 14, 8, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8266, '', 1, '', 88, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8267, '', 1, '', 76, 2, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8268, '', 1, '', 57, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8271, '', 2, '', 33, 6, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8272, '', 1, '', 25, 1, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8273, '', 1, '', 113, 2, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8274, '', 1, '', 108, 5, 31, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8275, '', 1, '', 118, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8278, '', 1, '', 97, 4, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8280, '', 2, '', 101, 3, 25, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8283, '', 1, '', 124, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8285, '', 1, '', 51, 12, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8288, '', 1, '', 24, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8289, '', 1, '', 18, 7, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8290, '', 1, '', 44, 15, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8291, '', 3, '', 29, 1, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8297, '', 1, '', 164, NULL, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8300, '', 2, '', 21, 3, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8302, '', 1, '', 116, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8304, '', 3, '', 43, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8305, '', 2, '', 14, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8306, '', 2, '', 27, 1, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8307, '', 2, '', 110, 14, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8308, '', 2, '', 157, NULL, 12, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8309, '', 1, '', 165, 1, 15, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8310, '', 2, '', 24, 3, 14, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8311, '', 1, '', 27, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8314, '', 1, '', 112, 11, 40, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8316, '', 2, '', 23, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8317, '', 2, '', 33, 3, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8322, '', 4, '', 36, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8323, '', 3, '', 138, 1, 17, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8324, '', 1, '', 23, 2, 2, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8330, '', 2, '', 118, 5, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8331, '', 2, '', 122, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8332, '', 2, '', 38, 2, 5, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8333, '', 2, '', 25, 1, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8334, '', 3, '', 102, 8, 21, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8335, '', 2, '', 158, 5, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8336, '', 2, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8338, '', 2, '', NULL, 4, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8340, '', 1, '', 26, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8343, '', 1, '', 101, 6, 7, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8344, '', 1, '', 38, 3, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8345, '', 1, '', NULL, 3, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8346, '', 1, '', 134, 7, 20, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8347, '', 1, '', 112, 3, 9, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8349, '', 1, '', 159, 7, 18, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8352, '', 1, '', 104, 6, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8353, '', 2, '', 115, 5, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8355, '', 3, '', 119, 7, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8356, '', 1, '', 150, 7, 28, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8357, '', 2, '', 40, 9, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8358, '', 1, '', 115, 16, 22, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8359, '', 1, '', NULL, 1, 8, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8362, '', 2, '', 56, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8364, '', 3, '', 168, 2, 13, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8365, '', 3, '', 22, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8367, '', 3, '', 25, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8385, '', 4, '', 50, NULL, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8387, '', 1, '', NULL, 11, 10, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8388, '', 2, '', 45, 19, 24, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8389, '', 2, '', NULL, 3, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8391, '', 3, '', NULL, 3, 4, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8392, '', 1, '', 125, 1, NULL, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8393, '', 1, '', 103, 1, 1, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8394, '', 1, '', 100, 2, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8395, '', 2, '', 107, NULL, 3, NULL, NULL, NULL);
INSERT INTO "total" VALUES (8398, '', 2, '', 40, NULL, NULL, NULL, NULL, NULL);

ALTER TABLE "voyages" ADD PRIMARY KEY ("number", "number_sup");
ALTER TABLE "craftsmen" ADD PRIMARY KEY ("number", "number_sup");
ALTER TABLE "impotenten" ADD PRIMARY KEY ("number", "number_sup");
ALTER TABLE "passengers" ADD PRIMARY KEY ("number", "number_sup");
ALTER TABLE "seafarers" ADD PRIMARY KEY ("number", "number_sup");
ALTER TABLE "soldiers" ADD PRIMARY KEY ("number", "number_sup");
ALTER TABLE "total" ADD PRIMARY KEY ("number", "number_sup");

ALTER TABLE "craftsmen" ADD FOREIGN KEY ("number", "number_sup")
	REFERENCES "voyages" ("number", "number_sup");
ALTER TABLE "impotenten" ADD FOREIGN KEY ("number", "number_sup")
	REFERENCES "voyages" ("number", "number_sup");
ALTER TABLE "invoices" ADD FOREIGN KEY ("number", "number_sup")
	REFERENCES "voyages" ("number", "number_sup");
ALTER TABLE "passengers" ADD FOREIGN KEY ("number", "number_sup")
	REFERENCES "voyages" ("number", "number_sup");
ALTER TABLE "seafarers" ADD FOREIGN KEY ("number", "number_sup")
	REFERENCES "voyages" ("number", "number_sup");
ALTER TABLE "soldiers" ADD FOREIGN KEY ("number", "number_sup")
	REFERENCES "voyages" ("number", "number_sup");
ALTER TABLE "total" ADD FOREIGN KEY ("number", "number_sup")
	REFERENCES "voyages" ("number", "number_sup");

COMMIT;
